prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- Oracle APEX export file
--
-- You should run this script using a SQL client connected to the database as
-- the owner (parsing schema) of the application or as a database user with the
-- APEX_ADMINISTRATOR_ROLE role.
--
-- This export file has been automatically generated. Modifying this file is not
-- supported by Oracle and can lead to unexpected application and/or instance
-- behavior now or in the future.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_imp.import_begin (
 p_version_yyyy_mm_dd=>'2024.05.31'
,p_release=>'24.1.0'
,p_default_workspace_id=>10
,p_default_application_id=>4411
,p_default_id_offset=>0
,p_default_owner=>'APEX_240100'
);
end;
/
 
prompt APPLICATION 4411 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4411
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_240100
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             170
--       PWA:
--       Globalization:
--         Messages:          17,508
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--   Version:         24.1.0
--   Instance ID:     1000197243005302
--

prompt --application/delete_application
begin
wwv_flow_imp.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_imp_workspace.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_240100')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'MESSAGES-PLUGINS')
,p_application_group=>wwv_flow_imp.id(91050719712959059)
,p_application_group_name=>'APEX Product'
,p_application_group_comment=>'Applications shipped with the APEX product distribution'
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20240716121407'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_accessible_read_only=>'N'
,p_session_state_commits=>'IMMEDIATE'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_documentation_banner=>'Oracle APEX User interface messages used to support translation of strings that are not defined as part of the core APEX user interface.'
,p_authentication_id=>wwv_flow_imp.id(91645213681389498)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 24.1.0'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_pass_ecid=>'N'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_print_server_type=>'INSTANCE'
,p_file_storage=>'DB'
,p_is_pwa=>'N'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_imp_shared.create_user_interface(
 p_id=>wwv_flow_imp.id(4411)
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(562090986404402217)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
,p_version_scn=>72470870
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(48650898565635010)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Sign out'
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>'Sign out of Oracle APEX'
,p_list_text_09=>'Y'
,p_list_text_10=>'logout exit quit :q'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(281916990329150760)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Create an application on a spreadsheet'
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>'Import your excel or csv files and create an application'
,p_list_text_09=>'Y'
,p_list_text_10=>'excel csv xsl xslx spreadsheet data paste load import'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(282255839842182292)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Oracle APEX Home'
,p_list_item_link_target=>'f?p=4100:1:&APP_SESSION.'
,p_list_text_10=>'homepage start '
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(296033420364984683)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Browse Font APEX Icons'
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>'Browse Font APEX icons, add modifiers, and copy CSS or HTML you need.'
,p_list_text_09=>'Y'
,p_list_text_10=>'icons font apex library graphics'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(562091518091404815)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
,p_version_scn=>72470938
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(562091727563404815)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Export Application'
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>'Export Application {APP_ID} as SQL File'
,p_list_text_09=>'Y'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(562093357853428158)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Unused Lists'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(562092153904409717)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
,p_version_scn=>72470938
);
end;
/
prompt --application/shared_components/navigation/listentry
begin
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1730093136541659)
,p_plugin_type=>'PROCESS TYPE'
,p_plugin=>'PLUGIN_GEOCODING'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_version_scn=>84561042
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(2402129102885900)
,p_plugin_type=>'DYNAMIC ACTION'
,p_plugin=>'PLUGIN_OPEN_AI_ASSISTANT'
,p_version_scn=>17462055
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(3223689581446811)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_plugin=>'PLUGIN_ADFBC'
,p_version_scn=>660325217
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(4016600614278093)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SELECT_MANY'
,p_attribute_01=>'separated'
,p_version_scn=>231358686
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(14843831009863117)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(146861159122292557)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(183033629816949774)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(280965675228226639)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_APEX'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(460407779408652225)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(497671453666914719)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_version_scn=>29808778
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(631035363954639049)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1082458703597614427)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
,p_version_scn=>1088662543
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1831649180083980462)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'IG')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1832884277947217587)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
,p_version_scn=>28367502
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1840861033969283097)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'Y')).to_clob
,p_version_scn=>1088662545
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(91626406749381989)
,p_theme_id=>1
,p_name=>'One Level Tabs'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success" role="alert">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140001488931349566)
,p_page_template_id=>wwv_flow_imp.id(91626406749381989)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140001517815349566)
,p_page_template_id=>wwv_flow_imp.id(91626406749381989)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140001699115349566)
,p_page_template_id=>wwv_flow_imp.id(91626406749381989)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140001740672349566)
,p_page_template_id=>wwv_flow_imp.id(91626406749381989)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140001820430349566)
,p_page_template_id=>wwv_flow_imp.id(91626406749381989)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140001949447349565)
,p_page_template_id=>wwv_flow_imp.id(91626406749381989)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140002088971349565)
,p_page_template_id=>wwv_flow_imp.id(91626406749381989)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140002117005349565)
,p_page_template_id=>wwv_flow_imp.id(91626406749381989)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140002264345349565)
,p_page_template_id=>wwv_flow_imp.id(91626406749381989)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(91626529080381989)
,p_theme_id=>1
,p_name=>'Printer Friendly'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140002343913349565)
,p_page_template_id=>wwv_flow_imp.id(91626529080381989)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140002490586349565)
,p_page_template_id=>wwv_flow_imp.id(91626529080381989)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140002552177349565)
,p_page_template_id=>wwv_flow_imp.id(91626529080381989)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(91626823864381990)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(91632832228382001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140382691031344638)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140382773788344638)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140382895312344637)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140382923760344637)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140383001370344637)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140383101590344637)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140383260593344637)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140383343091344637)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140383417298344637)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140383590781344637)
,p_plug_template_id=>wwv_flow_imp.id(91632832228382001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(91636711305382010)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(91638400927382012)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(91641225667382016)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(91641730492382017)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(91641814330382017)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_imp_shared.create_popup_lov_template(
 p_id=>wwv_flow_imp.id(91642503902382024)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>'Search'
,p_close_button_text=>'Close'
,p_next_button_text=>'Next >'
,p_prev_button_text=>'< Previous'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(91641910982382018)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(91642102481382020)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(91642303533382020)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_imp_shared.create_theme(
 p_id=>wwv_flow_imp.id(91642708702382024)
,p_theme_id=>1
,p_theme_name=>'Red'
,p_theme_internal_name=>'RED'
,p_navigation_type=>'T'
,p_nav_bar_type=>'NAVBAR'
,p_is_locked=>false
,p_default_page_template=>wwv_flow_imp.id(91626406749381989)
,p_error_template=>wwv_flow_imp.id(91626406749381989)
,p_printer_friendly_template=>wwv_flow_imp.id(91626529080381989)
,p_breadcrumb_display_point=>'REGION_POSITION_01'
,p_sidebar_display_point=>'REGION_POSITION_02'
,p_login_template=>wwv_flow_imp.id(91625820476381987)
,p_default_button_template=>wwv_flow_imp.id(91626823864381990)
,p_default_region_template=>wwv_flow_imp.id(91632832228382001)
,p_default_chart_template=>wwv_flow_imp.id(91631622717381999)
,p_default_form_template=>wwv_flow_imp.id(91630725782381998)
,p_default_reportr_template=>wwv_flow_imp.id(91632832228382001)
,p_default_tabform_template=>wwv_flow_imp.id(91632832228382001)
,p_default_wizard_template=>wwv_flow_imp.id(91632204784382001)
,p_default_menur_template=>wwv_flow_imp.id(91633105066382001)
,p_default_listr_template=>wwv_flow_imp.id(91627727983381992)
,p_default_report_template=>wwv_flow_imp.id(91638400927382012)
,p_default_label_template=>wwv_flow_imp.id(91641225667382016)
,p_default_menu_template=>wwv_flow_imp.id(91641814330382017)
,p_default_calendar_template=>wwv_flow_imp.id(91642102481382020)
,p_default_list_template=>wwv_flow_imp.id(91636711305382010)
,p_default_option_label=>wwv_flow_imp.id(91641225667382016)
,p_default_required_label=>wwv_flow_imp.id(91641529261382017)
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(1),'')
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245617218976155)
,p_translation_flow_id=>4412
,p_translation_flow_language_cd=>'es'
,p_translation_comments=>'APEX Builder, Wizard Messages and Native Types - Spanish'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245702935976155)
,p_translation_flow_id=>4413
,p_translation_flow_language_cd=>'fr'
,p_translation_comments=>'APEX Builder, Wizard Messages and Native Types - French'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245830838976155)
,p_translation_flow_id=>4414
,p_translation_flow_language_cd=>'de'
,p_translation_comments=>'APEX Builder, Wizard Messages and Native Types - German'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72245929066976155)
,p_translation_flow_id=>4415
,p_translation_flow_language_cd=>'it'
,p_translation_comments=>'APEX Builder, Wizard Messages and Native Types - Italian'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246029698976155)
,p_translation_flow_id=>4416
,p_translation_flow_language_cd=>'pt-br'
,p_translation_comments=>'APEX Builder, Wizard Messages and Native Types - Brazilian Portuguese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246123317976155)
,p_translation_flow_id=>4417
,p_translation_flow_language_cd=>'zh-cn'
,p_translation_comments=>'APEX Builder, Wizard Messages and Native Types - Simplified Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246228444976155)
,p_translation_flow_id=>4418
,p_translation_flow_language_cd=>'zh-tw'
,p_translation_comments=>'APEX Builder, Wizard Messages and Native Types - Traditional Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246319589976155)
,p_translation_flow_id=>4419
,p_translation_flow_language_cd=>'ko'
,p_translation_comments=>'APEX Builder, Wizard Messages and Native Types - Korean'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246430201976155)
,p_translation_flow_id=>4420
,p_translation_flow_language_cd=>'ja'
,p_translation_comments=>'APEX Builder, Wizard Messages and Native Types - Japanese'
,p_direction_right_to_left=>'N'
);
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1814227314326251)
,p_name=>'2DCOLUMN'
,p_message_text=>'2D Column'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1816526316326253)
,p_name=>'2DCOLUMN_LINE'
,p_message_text=>'2D Column Line'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1814413427326252)
,p_name=>'2DDOUGHNUT'
,p_message_text=>'2D Doughnut'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1816323524326253)
,p_name=>'2DHSTACKED_PCT'
,p_message_text=>'Stacked Horizontal 2D Column (Percent)'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1814513062326252)
,p_name=>'2DLINE'
,p_message_text=>'2D Line'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1814632268326252)
,p_name=>'2DPIE'
,p_message_text=>'2D Pie'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1816109684326252)
,p_name=>'2DSTACKED_PCT'
,p_message_text=>'Stacked 2D Column (Percent)'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1814703346326252)
,p_name=>'3DCOLUMN'
,p_message_text=>'3D Column'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1816420921326253)
,p_name=>'3DHSTACKED_PCT'
,p_message_text=>'Stacked Horizontal 3D Column (Percent)'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1814811711326252)
,p_name=>'3DPIE'
,p_message_text=>'3D Pie'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1816210234326253)
,p_name=>'3DSTACKED_PCT'
,p_message_text=>'Stacked 3D Column (Percent)'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455039001641343152)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_text=>'0 Items for insert into the Attribute Dictionary'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455037830590266387)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_text=>'0 Items for update'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455053331966541163)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_text=>'0 Items for update of the Attribute Dictionary'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455058806180647209)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_text=>'0 Report Columns for insert into the Attribute Dictionary'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455059408735657438)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_text=>'0 Report Columns for update of the Attribute Dictionary'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455037519855263300)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_text=>'Review %0 Items for update'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455057508903619572)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_text=>'0 Report Columns for update'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455038728175341364)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_text=>'Review %0 Items for insert into the Attribute Dictionary'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455039712077374539)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_text=>'Review %0 Items for update of the Attribute Dictionary'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455058528559644236)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_text=>'Review %0 Report Columns for insert into the Attribute Dictionary'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455057100246617113)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_text=>'Review %0 Report Columns for update'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455059100424655013)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_text=>'Review %0 Report Columns for update of the Attribute Dictionary'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(237332502821717106)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_text=>'Value must be numeric.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218854722491089205)
,p_name=>'4000_639_SEQ_MESG'
,p_message_text=>'<span class="fielddata"> Cannot reorder because Region sequences are not unique.</span>'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218862500140319382)
,p_name=>'4000_641_SEQ_MESG'
,p_message_text=>'<span class="fielddata">Cannot reorder because Button sequences are not unique.</span>'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218862911568322684)
,p_name=>'4000_646_SEQ_MESG'
,p_message_text=>'<span class="fielddata">Cannot reorder because Navigation Bar sequences are not unique.</span>'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218863320572325259)
,p_name=>'4000_749_SEQ_MESG'
,p_message_text=>'<span class="fielddata">Cannot reorder because Region Item sequences are not unique.</span>'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(294714627951753160)
,p_name=>'4000_APPLICATION_ID'
,p_message_text=>'Application ID'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42641015751974682)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_text=>'Edit Application: %0 %1'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190191216789904908)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_text=>'The specified date format is invalid.  The calendar requires a date in YYYYMMDD format.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244160625121134779)
,p_name=>'4000_TREE'
,p_message_text=>'Tree'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(294716021025786683)
,p_name=>'4000_WORKSPACE_ID'
,p_message_text=>'Workspace ID'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145516618269340884)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_text=>'Enter the name of the new schema to be created. Choose a password for the schema, and choose the default tablespace and temporary tablespace.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145518524503342700)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_text=>'Enter the name of the existing schema.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145538114591349291)
,p_name=>'4050_106_WHEN_DONE'
,p_message_text=>'When done, click <strong>Next</strong>.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109980301694498629)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_text=>'Drop tablespaces and associated datafiles: %0'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109979522687495285)
,p_name=>'4050_110_DROP_USERS'
,p_message_text=>'Drop database users: %0'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(301177569873546148)
,p_name=>'4050_131_SSL_WALLET_PROPERTY'
,p_message_text=>'The current wallet path is defined by the SSL_WALLET database property'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(301177264212544976)
,p_name=>'4050_131_WALLET_ALTERNATIVE'
,p_message_text=>'You can specify an alternative wallet below.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(620830686957124301)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_text=>'Web Service Activity Log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1413965805969355)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_text=>'REST Synchronization Log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1589821405443861)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_text=>'Automation Log Entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145045413871421848)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_text=>'Developer activity log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15389030604151768)
,p_name=>'4050_31_LOG_COUNT'
,p_message_text=>'Login Access Log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145015920573357494)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_text=>'Change Requests'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145018106852362972)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_text=>'Runtime Requests'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145005228968340997)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_text=>'Workspace Requests'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145168805550693769)
,p_name=>'4050_46_AD_HOC'
,p_message_text=>'SQL Command Processor history entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145168027236690625)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_text=>'Control File execution log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145163630915682190)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_text=>'Script File execution log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145171026328699838)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_text=>'SQL Archives entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145297613131093383)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_text=>'Active Log Information'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145299932178098938)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_text=>'Current Log Number'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145301013262102934)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_text=>'Current Log Timestamp'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145352109200158478)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_text=>'Hours until next log switch'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145337722051114944)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_text=>'Interval in days (constant)'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145351432618155852)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_text=>'Next log switch scheduled for'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145357628378173480)
,p_name=>'4050_70_DEV_ACT'
,p_message_text=>'Developer activity log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145361831972183993)
,p_name=>'4050_71_CLICK'
,p_message_text=>'Click through log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145413101375241443)
,p_name=>'4050_75_AD_HOC'
,p_message_text=>'SQL Command Processor history entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145412628602239809)
,p_name=>'4050_75_CTRL_FILE'
,p_message_text=>'Control File execution log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145409911633234875)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_text=>'Script File execution log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145417806701252460)
,p_name=>'4050_75_SQL_ARCH'
,p_message_text=>'SQL Archives entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145477428995268293)
,p_name=>'4050_82_WORKSPACE'
,p_message_text=>'Workspace %1 has %2 applications and %3 user(s).'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145511106017327963)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_text=>'Click Counting log entries'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254832409736047670)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_text=>'Productivity and Sample Apps'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254079723483458269)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_text=>'Workspace Count'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(122913011490532448)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_text=>'Edit Application'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20429928742346966)
,p_name=>'4500 800 HD HTMLDB'
,p_message_text=>'Oracle APEX 2 Day Plus Developer Guide.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20434315976371693)
,p_name=>'4500 800 MSG DBA'
,p_message_text=>'Discusses common day-to-day administrative tasks.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20435308834379034)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_text=>'Offers a series to tutorials that describe how to build database-centric Web applications.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20437122471392467)
,p_name=>'4500 800 MSG NET'
,p_message_text=>'This document describes the key features of Oracle Data Provider for .NET and Oracle Developer Tools for Visual Studio .NET. It leads you through installation and configuration, shows how to build basic applications using Oracle Data Provider for .NE'
||'T and Oracle Developer Tools for Visual Studio .NET, and how to create and use both PL/SQL and .NET stored procedures.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9769223806175173)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_text=>'Alias'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9768218827164295)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_text=>'Column'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9770107314179814)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_text=>'Condition'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164969022563427041)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_text=>'Delete'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9772910562190200)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_text=>'Function'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9773819913192934)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_text=>'Group By'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9769730386177026)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_text=>'Object'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9771831902186993)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_text=>'Show'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9770515280182137)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_text=>'Sort Type'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9771224630184824)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_text=>'Sort Order'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10964410371662927)
,p_name=>'4500_1002_QB_JOIN'
,p_message_text=>'Join'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9296531469510943)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_text=>'Click here to select column for join'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11155203668127634)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_text=>'A maximum of 60 columns may be selected.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9295919348507481)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_text=>'Remove'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9295405496503444)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_text=>'Show/Hide Columns'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10964702537670191)
,p_name=>'4500_1002_QB_TO'
,p_message_text=>'to'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8942925019019788)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_text=>'Results of %0, run %1'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110293223052704114)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_text=>'Return to Original Query'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14084928671830801)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_text=>'First %0 columns displayed.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180129026087321856)
,p_name=>'4500_SESS_EVENT'
,p_message_text=>'Event'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180128316737319102)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_text=>'Kilobytes'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180127911196317514)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_text=>'Megabytes'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21299607759967144)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_text=>'UI Defaults allow AI interactions to understand the contents of your tables. They are also used to populate initial labels for forms and reports, providing consistency across multiple pages in an application or multiple applications.'
,p_version_scn=>117498961
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27776610928855106)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_text=>'This application requires cookies to be enabled.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27747406874537909)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_text=>'This application requires JavaScript to be enabled.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(188057516467537629)
,p_name=>'ABOUT'
,p_message_text=>'About'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(907030700283981973)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_text=>'Please confirm adding the following %0 user(s) to your workspace.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195669319386995168)
,p_name=>'ACCEPTED'
,p_message_text=>'Accepted'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184002513763630549)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_text=>'Accessibility Assignee'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183995707136600262)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_text=>'Accessibility Impact'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184004003505637013)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_text=>'Accessibility Status'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2040478723215461769)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_text=>'Accessibility Tested'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66768901771821180)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_text=>'Administration Rights'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13038822941882315)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_text=>'Access Control Administration Page'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155070400433342171)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_text=>'Administrator'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232263043267802089)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_text=>'Role assigned to application administrators.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13164129717423676)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_text=>'Application Administration'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13167830503480662)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_text=>'Application Mode'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13167215958476490)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_text=>'Identify how access to this application will be controlled.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13190231008067472)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_text=>'Unable to process set application mode request.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13190621789074218)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_text=>'Application Mode Set.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(67427815913071208)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_text=>'You may not delete yourself.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(67430621023091671)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_text=>'You may not remove administrator privilege from yourself.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13047625590949379)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_text=>'Create Table'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155069799286334366)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_text=>'Contribution Rights'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155070692180345306)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_text=>'Contributor'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232263370382804234)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_text=>'Role assigned to application contributors.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181826015286466071)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_text=>'The following Application Setting(s) will be created:'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155071206201353888)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_text=>'The following Application Access Role(s) will be created:'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19726902022653116)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_text=>'The following Authorization Scheme(s) will be created:'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39652705194868521)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_text=>'Unable to create access control page. %0'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39651309219860229)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_text=>'Unable to create access control tables. %0'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69251416022747608)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_text=>'You may not enter duplicate username.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66770728090828700)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_text=>'access control - edit'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13175605925549284)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_text=>'Enter case insensitive query criteria, then press the <strong>Go</strong> button.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13183519140007243)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_text=>'Unable to get application administration mode.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13174505447539669)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_text=>'Last Changed By'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13169100290490889)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_text=>'Access Control List'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13164713572428457)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_text=>'Full access to all, access control list not used.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13165400543434154)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_text=>'Restricted access. Only users defined in the access control list are allowed.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13166015088438389)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_text=>'Public read only. Edit and administrative privileges controlled by access control list.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13166623100469024)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_text=>'Administrative access only.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13188211353042819)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_text=>'No privilege for attempted action.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13170831374518767)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_text=>'Privilege'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181819236830426340)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_text=>'Reader Rights'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181819006172424408)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_text=>'Reader'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232263806108806288)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_text=>'Role assigned to application readers.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19873728462944627)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_text=>'Identify usernames which correspond to this application''s authentication scheme.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13168516436486095)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_text=>'Set Application Mode'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44642222810423676)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_text=>'The access control pages have been created successfully.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155071510027356455)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_text=>'Use Existing Access Control Role'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19825416155827552)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_text=>'Use Existing Authorization Scheme'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19726026001641114)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_text=>'Use Existing Table'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66771912075843074)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_text=>'access control - view'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20472403022632871)
,p_name=>'ACCOUNT_CREATED'
,p_message_text=>'Account created.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(389048005730370199)
,p_name=>'ACCOUNT_MENU'
,p_message_text=>'Account Menu'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173001212090777484)
,p_name=>'ACKNOWLEDGED'
,p_message_text=>'Acknowledged'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173007316901826204)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_text=>'Acknowledged, no action'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205915321720818630)
,p_name=>'ACL_ADD_USER'
,p_message_text=>'Add User'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623904200121647964)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_text=>'Access Dashboard'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623904728172656022)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_text=>'Access Monitor Activity'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623899814488614244)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_text=>'Add / Modify'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623903020768644500)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_text=>'Administration when Running Application'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623893122790541004)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_text=>'Administration from within App Builder'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623896920244606431)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_text=>'Annotations (files, tags, notes)'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623890708283489468)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_text=>'Oracle APEX Account Authentication without Access Control List'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623890406074479441)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_text=>'Authentication with Access Control List'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623896318120577480)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_text=>'Edit SQL Access and Suggested Objects'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(628482831215278735)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_text=>'Once authenticated to an application, access control specifies what users can do within the application. The table below identifies what capabilities different types of users will have based on the authentication being used within this application.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623904901768667361)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_text=>'Maintain Access Control List'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623896523445588443)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_text=>'Run and View'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623895629071571156)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_text=>'Update Application Properties'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(442738628681346793)
,p_name=>'ACTIONS'
,p_message_text=>'Actions'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(622852123755935803)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_text=>'Action Menu Settings'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23004506192614313)
,p_name=>'ACTIVE'
,p_message_text=>'Active'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160800423410678999)
,p_name=>'ACTIVITY'
,p_message_text=>'Activity'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184162618020814333)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Activity Summary',
''))
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(367642914624521833)
,p_name=>'ADDED_BY'
,p_message_text=>'Added By'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617128321947502667)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_text=>'Added to Purge List'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(435244708193906718)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_text=>'Additional information requested'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146309201279652859)
,p_name=>'ADD_ARGUEMENT'
,p_message_text=>'Add Argument'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145295524643077859)
,p_name=>'ADD_COLUMN'
,p_message_text=>'Add Column'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270356309633834871)
,p_name=>'ADD_COLUMN_NAME'
,p_message_text=>'Add Column %0'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(96747802282607912)
,p_name=>'ADD_CONSTRAINT'
,p_message_text=>'Add Constraint'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145158415069658752)
,p_name=>'ADD_MORE...'
,p_message_text=>'Add More...'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170150827202818987)
,p_name=>'ADD_ROW'
,p_message_text=>'Add Row'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290106114414522846)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_text=>'Adjust provisioned space by %0 megabytes'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145049818158432512)
,p_name=>'ADMIN'
,p_message_text=>'Admin'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1512430359936356)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_text=>'Banner Color'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1511947154901605)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_text=>'Enable Environment Banner'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1512202657934439)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_text=>'Banner Label'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145812130405722393)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_text=>'Banner Position'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17810000592953257)
,p_name=>'ADMINISTRATOR'
,p_message_text=>'Workspace Administrator'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184039402886242283)
,p_name=>'ADMINISTRATORS'
,p_message_text=>'Administrators'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21022444493203559)
,p_name=>'ADMIN_DIGEST_ADMIN_ACCOUNT'
,p_message_text=>'Maximum Administrator Accounts'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21022035390196788)
,p_name=>'ADMIN_DIGEST_CREATED_APPS'
,p_message_text=>'Created Applications'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21020880422172014)
,p_name=>'ADMIN_DIGEST_DBLINKS'
,p_message_text=>'Database Links'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21022683347205912)
,p_name=>'ADMIN_DIGEST_DEV_ACCOUNT'
,p_message_text=>'Maximum Developer Accounts'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21023667173219230)
,p_name=>'ADMIN_DIGEST_EMAIL_CREATED'
,p_message_text=>'Created'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21023466088217662)
,p_name=>'ADMIN_DIGEST_EMAIL_QUEUED'
,p_message_text=>'Still in queue'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21023817311220573)
,p_name=>'ADMIN_DIGEST_EMAIL_SENT'
,p_message_text=>'Sent'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21022855900209840)
,p_name=>'ADMIN_DIGEST_ENDUSER_ACCOUNT'
,p_message_text=>'Maximum End User Accounts'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21024041471222570)
,p_name=>'ADMIN_DIGEST_ERROR'
,p_message_text=>'Errors'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21027109230364944)
,p_name=>'ADMIN_DIGEST_FAILEDJOBS'
,p_message_text=>'Failed Jobs'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21021679061187891)
,p_name=>'ADMIN_DIGEST_FAILEDLOGINS'
,p_message_text=>'Failed Logins'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21020687601170293)
,p_name=>'ADMIN_DIGEST_INSTANCE_JOBS'
,p_message_text=>'Total Instance Jobs'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21023230662214775)
,p_name=>'ADMIN_DIGEST_IP_ADDRESS'
,p_message_text=>'Distinct IP Addresses'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21021074085179138)
,p_name=>'ADMIN_DIGEST_PAGE_EVENTS'
,p_message_text=>'Page Events'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21022223701198801)
,p_name=>'ADMIN_DIGEST_REMOVED_APPS'
,p_message_text=>'Removed Applications'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21023073669212640)
,p_name=>'ADMIN_DIGEST_SESSIONS'
,p_message_text=>'Distinct Sessions'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21021808288191171)
,p_name=>'ADMIN_DIGEST_SUCCESSJOBS'
,p_message_text=>'Successful Jobs'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21021432560186114)
,p_name=>'ADMIN_DIGEST_SUCCESSLOGIN'
,p_message_text=>'Successful Logins'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21019835805125132)
,p_name=>'ADMIN_DIGEST_TOTAL_APPLICATIONS'
,p_message_text=>'Total Applications'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21019648732123263)
,p_name=>'ADMIN_DIGEST_TOTAL_WORKSPACES'
,p_message_text=>'Total Workspaces'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21020094055158066)
,p_name=>'ADMIN_DIGEST_TOTAL_WORKSPACE_USERS'
,p_message_text=>'Total Workspace Users'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21020429504168407)
,p_name=>'ADMIN_DIGEST_USER_JOBS'
,p_message_text=>'Total User Jobs'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21021292192181152)
,p_name=>'ADMIN_DIGEST_WEBSRV_REQUESTS'
,p_message_text=>'Web Service Requests'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21020222275164428)
,p_name=>'ADMIN_DIGEST_WKSP_SCHEMAS'
,p_message_text=>'Total Workspace Schemas'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145601307809214859)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_text=>'Administrators email must be provided'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240625155773891491)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_text=>'Accessibility'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25296814352073057)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_text=>'Error'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25297430975077855)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_text=>'Performance'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25297709306582514)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_text=>'Quality Assurance'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25297021278075098)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_text=>'Security'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25297915540584280)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_text=>'Usability'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25297225434076270)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_text=>'Warning'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(356767707912315557)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_text=>'Item "%1" is protected and can not be set via an Ajax call.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(356770604517514650)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_text=>'Item "%1" is protected and can not be set via an Ajax call.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(362665601326910853)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_text=>'Item "%1" is protected and can not be set via an Ajax call.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37150127533471770)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_text=>'Missing SYS schema prefix'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(480431173835158437)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_text=>'Usage of WWV_FLOW APIs (use APEX APIs instead)'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(420868258611572443)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_text=>'Column %0 does not exist in Region Source SQL Statement!'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25318319241869637)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_text=>'Interactive Report column %0 does not exist.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316006670869634)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_text=>'%0 does not exist.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21580909857697783)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_text=>'Column %0 does not exist in Region Source SQL Statement!'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500053531887502655)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_text=>'Tabular Form column %0 does not exist.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316122214869634)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_text=>'%0 cannot be referenced as application or page item name.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(931576377428421039)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_text=>'Ajax Callback application process is not protected by an authorization scheme.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(931430218509929499)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_text=>'Page is not protected by an authorization scheme.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317007970869636)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_text=>'Target page %1 (within application %0) has no authorization scheme defined.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932274342204661069)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_text=>'Authorization of this page is different to authorization "%1" of parent page %0.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317132477869636)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_text=>'Authorization "%0" on target page is different to "%1".'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25315632635869633)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_text=>'%0 does not exist.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25315516938869633)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_text=>'Could not perform bind variable syntax check. Error: %0'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25315705427869634)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_text=>'%0 cannot be referenced with bind variable syntax.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317711275869636)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_text=>'Unconditional branch before other branches.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(931429660986921496)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_text=>'Autocomplete is set to "On" for a page that contains password items.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(931430051637925888)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_text=>'"Cache" allows the browser to cache sensitive data.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573558501444704314)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_text=>'"Embed in Frames" leaves the application vulnerable to clickjacking attacks.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573558744556709386)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_text=>'"HTML Escaping Mode" only escapes a limited set of characters.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2108067184704050)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_text=>'Items should escape special characters to avoid Cross-Site-Scripting attacks (XSS).'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576284706610466257)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The HTTP "Referer" request header can leak sensitive session information to third parties.',
'Applications should set "Referrer Policy" to "strict-origin".'))
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6723418373787727)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ID found in the Button Attributes, for a button referenced in a Dynamic Action (%0). ',
'',
'When an ID is defined in Button Attributes, this will cause Dynamic Actions referencing the button not to work. Please consider removing this ID, as the button will generate an ID by default.'))
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6725910839116736)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Button Template used by a button, that itself is referenced in a Dynamic Action (%0) does not contain the #BUTTON_ID# substitution string.',
'',
'Template:',
'%1',
'',
'Please consider either adding the #BUTTON_ID# substitution string to this template or changing the button template to one that includes the #BUTTON_ID# substitution string.'))
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8469915985140202)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_text=>'Button ''Action'' is not ''Defined by Dynamic Action'', for a button referenced in a Dynamic Action (%0).'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9969927715808840)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_text=>'Button (%0) has an ''Action'' of ''Defined by Dynamic Action'', but there is no corresponding Dynamic Action referencing this button.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316715973869635)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_text=>'Clear Cache Page %0 is not the current or target page %1.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25315402063869633)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_text=>'%0 does not exist.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(728339641269994550)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_text=>'This attribute value has been deprecated.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(746093378228936520)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_text=>'This component type has been deprecated.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(357364128938707207)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_text=>'Protected items in Ajax calls'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37149914027467871)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_text=>'Code Smell (APEX internal)'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25308004897688115)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_text=>'Declarative References of Application Items, Page Items, Columns or Interactive Report Filters'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(931429261300900875)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_text=>'Authorization'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25307421042683345)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_text=>'References with Bind Variable Syntax'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25310407929707996)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_text=>'Unconditional Branch before other Branches'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(931510289991221548)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_text=>'Browser Security Settings'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6723215257786814)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_text=>'Button is not compatible with Dynamic Actions'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9946705897802612)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_text=>'Inconsistent references between Dynamic Actions and Buttons'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25308620827692711)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_text=>'Clear Cache Page Number equals Target or Current Page'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25307213423681147)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_text=>'References with Column Syntax'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(728337360892970978)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_text=>'Deprecated attribute values'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25309409530699006)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_text=>'Fetch, DML, MR* Processes are Valid'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25310201349706076)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_text=>'Hardcoded Application ID'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172104812234201851)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_text=>'Page Item has Help Text'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240623156551821000)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_text=>'Page has page title'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(247063415322317717)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_text=>'Display Image item has image ALT text defined'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573557583616659864)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_text=>'Application attributes that can be locked down'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25307626583684954)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_text=>'Referenced Item is on Current Page'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25307832470686658)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_text=>'Referenced Item is Page Item of Target Page'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240679264181063844)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_text=>'Page item does not cause an unexpected context change'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(241922259823281882)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_text=>'Page item has label'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25310820396711546)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_text=>'Length of Item or Tabular Form Column Name'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37055831115179720)
,p_name=>'ADVISOR.CHECK.DESC_LEGACY_ORPHAN_COMPONENTS'
,p_message_text=>'Legacy Orphan Components'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25308210437689788)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_text=>'References of Page Item in a String'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25308415632691218)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_text=>'Referenced Page Number Exists'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240626832540486067)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_text=>'Region has Row Header'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25311216072748119)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_text=>'Report has Default Order'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(931536764055366995)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_text=>'Session State Protection'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25309614378700349)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_text=>'Inappropriate use of Substitution Syntax'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25307007536679465)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_text=>'References with Substitution Syntax'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25309205028697628)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_text=>'Target Page Authorization is also set for Current Component'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240672089207637382)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_text=>'Theme Style tested for accessibility'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(342223406255329137)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_text=>'User Interface includes compatibility JavaScript'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25310614163709730)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_text=>'Associated Item or Column of Validations'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25308826021694302)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_text=>'Is Valid SQL or PL/SQL Code'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25310028923704534)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_text=>'Verify Clob Property'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25309819572701829)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_text=>'V Function used in SQL Statements'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25311026976713451)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_text=>'Referenced Button in When Button Pressed exists'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317305682869636)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_text=>'Compilation error - %0 Statement: %1'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317630457869636)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_text=>'Link contains the current Application ID as hardcoded value.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172102828679168744)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_text=>'No help text defined.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240623793173854740)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_text=>'This page has no page title. Meaningful page titles are important for accessibility, to help users understand the content and purpose of the current page.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(247072235389367899)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_text=>'The item is missing the alternative text required for the image. Good text to use for this should adequately describe the contents of the image, and also should not duplicate any information that is visible on the page displayed in the context of the'
||' image (to avoid possible duplication). Note: If the image is provided by users, then so too should the image alternative text be, with appropriate guidance to help your users provide high quality text.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573558319384695449)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_text=>'"Runtime API Usage" allows application and workspace modification.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25315805182869634)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_text=>'%0 is not an item on page %1.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25315906592869634)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_text=>'%0 is not an item on target page %1.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240679667246079314)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_text=>'The setting ''Page Action on Selection'' for the page item could cause an unexpected change of context for the user. Consider switching to ''None'' so there is no change of context and replacing the functionality with Dynamic Actions or Cascading LOVs (i'
||'f you need to stay on the same page). Alternatively consider providing some information for the user so that they know what will happen, for example, adding ''Launches new page'' in the label. '
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(247038837204790392)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_text=>'A label for the item must be defined. If you prefer not to display a visible label, you should still define a label and then select the ''Hidden'' label template.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(241922654885316313)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_text=>'The item defines a ''Value Placeholder'' value, but no label. Placeholder text should not be used solely to label the item, as this causes accessibility issues. For better accessibility, an item label should be defined. If you prefer not to display a v'
||'isible label, you should still define a label and then select the ''Hidden'' label template.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25318029024869637)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_text=>'Name has a length of %0 characters, but should have a maximum of 30 characters.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4746294442484784)
,p_name=>'ADVISOR.CHECK.LEGACY_ORPHAN_COMPONENTS.MSG_BUTTON_ORPHAN_FOUND'
,p_message_text=>'Button is found in the "Legacy Orphan Components" slot. It should be moved to a supported slot.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4746079327482902)
,p_name=>'ADVISOR.CHECK.LEGACY_ORPHAN_COMPONENTS.MSG_ITEM_ORPHAN_FOUND'
,p_message_text=>'Item is found in the "Legacy Orphan Components" slot. It should be moved to a supported slot.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316221549869634)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_text=>'%0 might not exist.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316300225869634)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_text=>'%0 might not be a page or application item'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316611810869635)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_text=>'Clear Cache Page %1 (within application %0) does not exist.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316431363869635)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_text=>'Page %0 does not exist.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316509183869635)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_text=>'Target Page %1 (within application %0) does not exist.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181842959358531832)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_text=>'The Column Toggle region does not have a column with ''Value Identifies Row'' set to ''Yes''. This should be defined on the column, or columns that help to identify the row of data (for example customer name in a report of customer information), and is i'
||'mportant for accessibility.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2201281381019534)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_CR_NOT_DEFINED'
,p_message_text=>'The Classic Report region does not have a column with ''Value Identifies Row'' set to ''Yes''. This should be defined on the column, or columns that help to identify the row of data (for example customer name in a report of customer information), and is '
||'important for accessibility.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2801442691158342)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_IG_NOT_DEFINED'
,p_message_text=>'The Interactive Grid region does not have a column with ''Value Identifies Row'' set to ''Yes''. This should be defined on the column, or columns that help to identify the row of data (for example customer name in a report of customer information), and i'
||'s important for accessibility.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2201480498021836)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_IR_NOT_DEFINED'
,p_message_text=>'The Interactive Report region does not have a column with ''Value Identifies Row'' set to ''Yes''. This should be defined on the column, or columns that help to identify the row of data (for example customer name in a report of customer information), and'
||' is important for accessibility.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181867445444623902)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_text=>'The Reflow region does not have a column with ''Value Identifies Row'' set to ''Yes''. This should be defined on the column, or columns that help to identify the row of data (for example customer name in a report of customer information), and is importan'
||'t for accessibility.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240627431814514759)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_text=>'This Tabular Form region does not have a column with "Use as Row Header" set to Yes. The Row Header column should be the column that best identifies the current row (for example a customer name in a table of customer information). This information is'
||' then used when rendering the Tabular Form, to provide unique labels for each row''s form fields.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25318203115869637)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_text=>'Report does not have a default order.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573559261376727748)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_text=>'"Bookmark Hash Function" is set to a legacy algorithm.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573559477274733790)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_text=>'"Session State Protection" is disabled.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(931498729821018872)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_text=>'On a page with a fetch process, you should use Page Access Protection and enable protection for the items that you pass via the URL.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18961442298586347)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_text=>'Region contains "f?p" URL that is not passed through APEX_UTIL.PREPARE_URL.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317402787869636)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_text=>'Possible SQL Injection detected. %0 is used with substitution syntax in SQL, PL/SQL code or process table name.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25315216700869633)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_text=>'%0 does not exist.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25315312914869633)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_text=>'%0 cannot be referenced with substitution syntax.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317228758869636)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_text=>'Target page %1 (within application %0) has an authorization scheme defined, but current component does not.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240672444358656828)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_text=>'The current Theme Style for the application has not been tested for accessibility. Please either switch to a Theme Style that has Accessibility Tested set to Yes, or if your current Theme Style has been tested, set its Accessibility Tested attribute '
||'to Yes under your Theme settings.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(342370355471829199)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_text=>'User Interface includes jQuery Migrate. jQuery Migrate helps when migrating to a newer version of jQuery by restoring removed APIs and shows warnings in the browser console when removed or deprecated APIs are used. This includes an extra JavaScript f'
||'ile on every page in your app. To help remove this, please review the jQuery Migrate upgrade guide for details of APIs which should be changed, then once you are confident you no longer rely on any of these APIs, set Include jQuery Migrate to No.'
,p_version_scn=>37165770887488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(342223808924402055)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_text=>'User Interface includes Deprecated or Desupported JavaScript functions. This includes an extra JavaScript file on every page in your app. To help remove this, please review the ''Deprecated Features'' section of the Release Notes, where you will find i'
||'nstructions on how to check for dependencies to deprecated or desupported functions, and work towards no longer including this in your app.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317928647869637)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_text=>'Associated Item or Column is not defined, but "Error Message Display Location" would require it.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317812276869637)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_text=>'Associated Item or Column is not equal to "%0" specified in Validation Expression 1.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316800142869635)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_text=>'Compilation error - %0'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25316910802869636)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_text=>'No SQL or PL/SQL code defined.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25315110849869633)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_text=>'Is longer than 32767. Only the first 32767 are checked. Length: %0'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25317518541869636)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_text=>'Contains V/NV/DV function call in SQL statement (can be a performance problem).'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25318106109869637)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_text=>'Referenced button does not exist anymore.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166097224445033723)
,p_name=>'AFTER'
,p_message_text=>'After'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145542516335207895)
,p_name=>'AGREEMENT_MISSING'
,p_message_text=>'Agreement missing'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1407693115634864)
,p_name=>'AI.CONSENT_MESSAGE'
,p_message_text=>'<p>Please review the documentation regarding <a rel="noopener noreferrer" target="_blank" href="%0">terms</a> governing certain features of Oracle APEX that allow you to use third-party services, including generative AI services. Clicking <strong>Acc'
||'ept</strong> below and your use of such features constitutes your acknowledgement of the terms.</p>'
,p_version_scn=>1891933781
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1408457477569663)
,p_name=>'AI.NO_APP_SERVICE_SET'
,p_message_text=>'A default AI Service must be specified at application level'
,p_version_scn=>1052655207
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1408269988576468)
,p_name=>'AI.NO_BUILDER_SERVICE_SET'
,p_message_text=>'An AI Service marked as "Used by App Builder" must exist in this workspace'
,p_version_scn=>1057826508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6424552467881940)
,p_name=>'AI.NO_TABLES_FOUND'
,p_message_text=>'We could not find any tables that matched your request. If you have the tables needed for this type of application in the workspace default schema, please try to provide more details.'
,p_version_scn=>178456229
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86584014582220650)
,p_name=>'ALIAS'
,p_message_text=>'Alias'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484877215940188465)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_text=>'Allow application building'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1478581304946132)
,p_name=>'ALLOW_EXTENSIONS'
,p_message_text=>'Allow Hosting Extensions'
,p_version_scn=>24837499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(403370385927921636)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Allow installation of productivity and sample applications.',
''))
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(320716805963100795)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_text=>'Allow Use of RESTful Services'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484878120789189881)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_text=>'Allow SQL Workshop Use'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484878800488193470)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_text=>'Allow Use of Team Development'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484869812038130500)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_text=>'Allow workspace to be purged'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87983805377032963)
,p_name=>'ALL_APPLICATIONS'
,p_message_text=>'All Applications'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14632001252651677)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_text=>'- All - '
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14574000363462192)
,p_name=>'ALL_CATEGORIES'
,p_message_text=>'All Categories'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14632516489656103)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_text=>'- All Categories -'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485076117219856761)
,p_name=>'ALL_MILESTONES'
,p_message_text=>'All Milestones'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(251172702018475751)
,p_name=>'ALL_RELEASES'
,p_message_text=>'All Releases'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88269320723696242)
,p_name=>'ALL_STATIC_FILES'
,p_message_text=>'all static files'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88150006909944679)
,p_name=>'ALL_THEMES'
,p_message_text=>'all themes'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(495226290774101568)
,p_name=>'ALL_TYPES'
,p_message_text=>'All Types'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(495248866860596614)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_text=>'- All Types -'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88002619472254588)
,p_name=>'ALL_USERS'
,p_message_text=>'All Users'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(907031286000990559)
,p_name=>'ALREADY_IN_ACL'
,p_message_text=>'User is already has an APEX account'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(829735640879014301)
,p_name=>'ALREADY_IN_WS'
,p_message_text=>'User already exists in workspace'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(653851581838798040)
,p_name=>'ALWAYS'
,p_message_text=>'Always'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172941223450974103)
,p_name=>'ANALYSIS'
,p_message_text=>'%0 Analysis'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172950716749038434)
,p_name=>'ANALYZE'
,p_message_text=>'Analyze by %0'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270684517232453645)
,p_name=>'ANALYZE_TABLE'
,p_message_text=>'Analyze using %0 method'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88139419358796943)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_text=>'anonymous block'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26172702490478302)
,p_name=>'ANSWERS'
,p_message_text=>'Answers'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18929017490190454)
,p_name=>'ANY_DEVELOPER'
,p_message_text=>'(Any Developer)'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1412118393021287)
,p_name=>'APEX.ACL_NOT_ASSIGNED'
,p_message_text=>'The &PRODUCT_NAME. user has not been granted an ACL to access the target host. See section "Enabling Network Services in Oracle Database" in the &PRODUCT_NAME. Installation Guide.'
,p_version_scn=>129636705
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1813973379818556359)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_text=>'Application Changes:'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1813920029513387028)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_text=>'Hour:'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1834499481255569864)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_text=>'%0 K'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1813974106561558043)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_text=>'Page Views: '
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17616082422963647)
,p_name=>'APEX.ADMIN_DIGEST.APP_DELETED'
,p_message_text=>'Application %0 was removed.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23641335759567106)
,p_name=>'APEX.ADMIN_DIGEST.CONTAINER'
,p_message_text=>'Container'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23642828161608106)
,p_name=>'APEX.ADMIN_DIGEST.ERRINSTANCE'
,p_message_text=>'Error Instance ID'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23643096447630672)
,p_name=>'APEX.ADMIN_DIGEST.ERR_SEQ'
,p_message_text=>'Error Instance Sequence'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23641515081570667)
,p_name=>'APEX.ADMIN_DIGEST.HOST_ID'
,p_message_text=>'Host ID'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23642488011595351)
,p_name=>'APEX.ADMIN_DIGEST.MESSAGE_GROUP'
,p_message_text=>'Message Group'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23642646505598460)
,p_name=>'APEX.ADMIN_DIGEST.MESSAGE_ID'
,p_message_text=>'Message ID'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23641718765576282)
,p_name=>'APEX.ADMIN_DIGEST.MESSAGE_LEVEL'
,p_message_text=>'Message Level'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23643290109641256)
,p_name=>'APEX.ADMIN_DIGEST.PROBLEMKEY'
,p_message_text=>'Problem Key'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17615592708921820)
,p_name=>'APEX.ADMIN_DIGEST.SCHEMA_CREATED'
,p_message_text=>'New schema %1 added to the workspace %0.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17615787902937486)
,p_name=>'APEX.ADMIN_DIGEST.SCHEMA_DELETED'
,p_message_text=>'Schema %1 removed from the workspace %0.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17616202073978429)
,p_name=>'APEX.ADMIN_DIGEST.SCHEMA_EXCEPTION_CREATED'
,p_message_text=>'A schema exception was created. This allows assignment of restricted schema: %0 to workspace: %1.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17616467372987458)
,p_name=>'APEX.ADMIN_DIGEST.SCHEMA_EXCEPTION_DELETED'
,p_message_text=>'Exception removed for restricted schema: %0 to workspace: %1.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17616758261013958)
,p_name=>'APEX.ADMIN_DIGEST.SCHEMA_RESTRICT'
,p_message_text=>'Schema %0 has no privilege to be assigned to a workspace.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17616918469021013)
,p_name=>'APEX.ADMIN_DIGEST.SCHEMA_UNRESTRICT'
,p_message_text=>'Schema %0 recovered all privileges to be assigned to a workspace.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17613234252787969)
,p_name=>'APEX.ADMIN_DIGEST.WKSP_CREATED'
,p_message_text=>'Workspace %1 created. Source Identifier: %2. New schema: %3. Resource Manager Consumer Group: %4.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17615293941895697)
,p_name=>'APEX.ADMIN_DIGEST.WKSP_DELETED'
,p_message_text=>'Workspace %1 removed.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17614076592844376)
,p_name=>'APEX.ADMIN_DIGEST.WKSP_UPDATED'
,p_message_text=>'Workspace %1 updated. New schema %3 added. Resource Manager Consumer Group changed: %4.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(566012924313444410)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An API call has been prohibited.',
'Contact your administrator.',
'Details about this incident are available via debug id "%0".'))
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39872803540444214)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_text=>'The API call "%0" has been desupported in Oracle APEX version %1. Details about this incident are available via debug id "%2".'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192412832512555774)
,p_name=>'APEX.ASSERT.FUNCTION_BODY_START'
,p_message_text=>'Function Body must start with DECLARE,BEGIN, or RETURN'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192412534599555773)
,p_name=>'APEX.ASSERT.NO_DYNAMIC_SQL'
,p_message_text=>'Query must not contain dynamic SQL: %0'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192412959337555774)
,p_name=>'APEX.ASSERT.SQL_OR_FUNCTION_START'
,p_message_text=>'Expected DECLARE,BEGIN,RETURN,SELECT, or WITH'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192412686692555774)
,p_name=>'APEX.ASSERT.SQL_QUERY_START'
,p_message_text=>'Query must begin with SELECT or WITH'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192413035367555774)
,p_name=>'APEX.ASSERT.VERIFY_PARSING_SCHEMA'
,p_message_text=>'Invalid parsing schema for current workspace ID'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192412785576555774)
,p_name=>'APEX.ASSERT.WHERE_CLAUSE_START'
,p_message_text=>'WHERE clause must start with WHERE'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180071718656895367)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_text=>'#LABEL# does not exist in list.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(447793064593724800)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_text=>'Show Only branches are not supported if the page attribute "Reload on Submit" is set to "Only for Success".'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88359402284059953)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_text=>'Error processing branch.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6102403194325087)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_text=>'Error processing computation.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86839409490701736)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_text=>'Error processing condition.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106572910593837829)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_text=>'Unknown condition type "%0"'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4900993327931858)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_text=>'File browse item %0 must use APEX_APPLICATION_TEMP_FILES table.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1432776207207445)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_text=>'"Merge" loading type is not supported for loading into collections.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623765043314141060)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_text=>'"Merge" loading type requires at least one primary key column in the Data Profile.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623764585237131712)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_text=>'Loading Source SQL Query cannot be parsed: %0.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623764814985136441)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_text=>'Loading Source SQL Query must return VARCHAR2, CLOB or BLOB.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148432930458802696)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_text=>'Application %0 Dialog page %1 cannot be rendered successfully.  Ensure the page template in use on page %1 is of template type "Dialog page", with appropriate JavaScript dialog initialization, dialog closure and dialog cancel code defined.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502116932934915858)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_text=>'Copyright &copy; %0, All rights reserved.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502124066455975274)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_text=>'Create Workspace'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502114784898909741)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_text=>'This is a system generated message. Do not reply to this message.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613712881630550691)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_text=>'Environment'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1967442919973765677)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_text=>'Oracle APEX User'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502212088742654552)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_text=>'Get Started'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502117332712920703)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_text=>'Hello %0,'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502149330315258964)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_text=>'Password'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613713006899553480)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_text=>'Prevent Workspace Purge'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502204926674566759)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_text=>'You can prevent your workspace from being purged by clicking the button below and following the on-screen instructions. If you do not act in %0 day(s), your workspace will automatically be removed.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613712296050542306)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_text=>'No action is necessary if you no longer require your workspace.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613713484429562581)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_text=>'Your workspace is about to be purged!'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613657056143871428)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_text=>'Your workspace %0 has not shown any recent activity and is scheduled to be purged soon.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613656545025863893)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_text=>'Warning! Your workspace "%0" is about to be purged.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613712651034549844)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_text=>'Purge Date'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613742878448803925)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_text=>'Please complete your workspace request.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613742454843790049)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_text=>'Your workspace "%0" is ready!'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613743107291808807)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_text=>'Your workspace "%0" has been approved!'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613742623658795476)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_text=>'Your workspace request has been declined.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502121240784948033)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_text=>'Username'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613713229763560062)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_text=>'Warning!'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502121035475947160)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_text=>'Workspace'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502118841897926686)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_text=>'Workspace Request Approved'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502124299811978438)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_text=>'Click the button below to complete the approval process and set your password.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502119253893931555)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_text=>'Your workspace request has been approved!'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502148776991221459)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_text=>'Click the button below to get started.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502149978894274097)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_text=>'Your workspace is ready!'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502119014367928428)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_text=>'Workspace Request Declined'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502119682600937556)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_text=>'Sorry, your workspace request has been declined.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(230785551309946848)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_text=>'Queued'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(230785723092947749)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_text=>'Sent'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16215668814939242)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_text=>'Feedback Entries'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16215867669940917)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_text=>'Open Feedback Entries'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16216741984949755)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_text=>'Users'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135860124558880754)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_text=>'Group "%0" could not be found'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1007658038863784512)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_text=>'View Documentation'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6169169552872633)
,p_name=>'APEX.HTTP.DOWNLOAD_NOT_SUPPORTED'
,p_message_text=>'Downloads are not supported if the page attribute "Reload on Submit" is set to "Only for Success". Change the page attribute "Reload on Submit" to "Always" or use a before header process.'
,p_version_scn=>72849545
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42882491343010755)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The HTTP header %0 was sent twice, this could be an attack.',
'<ul>',
'<li>1st value: "%1"</li>',
'<li>2nd value: "%2"</li>',
'</ul>'))
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66173618008083723)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_text=>'Printing support must be STANDARD, ADVANCED, APEX_LISTENER, AOP or NONE.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(311469125967828275)
,p_name=>'APEX.INSTANCE_ADMIN.CANT_DEFER_FREE'
,p_message_text=>'You cannot defer the upgrade on a free instance'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66174023549085299)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_text=>'Cannot remove first schema provisioned'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24557818073907060)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_text=>'Invalid application ID.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(249468900103202117)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_text=>'Invalid Email address'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21961906187835010)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_text=>'Value must be zero or a positive integer.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66174529782087088)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_text=>'Invalid port number'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295567327400638221)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_text=>'Invalid subscription ID.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66174904979089370)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_text=>'Wallet path must be in the form file:<filesystempath>'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98891620098834899)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_text=>'The workspace was not found.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98882701388753837)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_text=>'Invalid workspace ID.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107047388434655289)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_text=>'Value must not be greater than %0.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1740472563251004)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_IS_NOT_FLAT_JSON'
,p_message_text=>'The value of instance parameter "%0" must be valid JSON with a flat structure.'
,p_version_scn=>1843716
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(79475304028561473)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_text=>'The value "%1" of instance parameter "%0" does not match regular expression "%2"'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(79475223911236089)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_text=>'The instance parameter "%0" must have a value'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66175510866091123)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_text=>'Instance parameter not found'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(288077407792782328)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_text=>'Password'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6115905511977304)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_text=>'Password (For authentication against workspace user account repository only)'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(480992070311969668)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_text=>'Password (For authentication against workspace user account repository only)'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(362586005740005181)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_text=>'Password (For authentication against workspace user account repository only)'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38550715718983061)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_text=>'Password (For authentication against workspace user account repository only)'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118624798306312512)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_text=>'Password (For authentication against workspace user account repository only)'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(288073403983781233)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_text=>'Password (For authentication against workspace user account repository only)'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66312611523315675)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_text=>'Print server protocol must be either http or https'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66313020874318381)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_text=>'Schema does not exist'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66313428492320660)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_text=>'Schema is restricted'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(311468748162820278)
,p_name=>'APEX.INSTANCE_ADMIN.UPGRADE_NOT_AVAILABLE'
,p_message_text=>'Upgrade is not available'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(311468922929825330)
,p_name=>'APEX.INSTANCE_ADMIN.UPGRADE_RUNNING'
,p_message_text=>'Upgrade is already running'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15755597969243546)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_text=>'Application'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15755119993235451)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_text=>'Application no longer exists'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(510501949159987765)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_text=>'Assign'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93814477731170564)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_text=>'Attachments'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(681640508284272117)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_text=>'Cards'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16222824335265439)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_text=>'Closed'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15763795466715114)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_text=>'Commented'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15762404351690795)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_text=>'comments'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16223080303266791)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_text=>'Complete'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150589340191932058)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_text=>'Created this issue %0'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6788125556287759)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_text=>'Delete'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6787551832283275)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_text=>'Are you sure you want to delete this comment?'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500030975775711386)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_text=>'Delete Issue'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10546849968035579)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_text=>'Are you sure you want to delete this issue?'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15769641748946864)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_text=>'Document'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15765460435759253)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_text=>'Documents'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6787823569286241)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_text=>'Edit'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563176259568667423)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_text=>'Edit Comment'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563176612274669818)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_text=>'Edit Issue'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15757514978409950)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_text=>'Application specified does not exist in this workspace.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15758386464439501)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_text=>'Error attempting to delete comment.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15758128174434701)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_text=>'Comment not found.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15758928743451732)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_text=>'Issue not found.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15759119813458689)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_text=>'Error attempting to mark issue for delete.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15757721148415641)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_text=>'Page specified does not exist in this workspace or in the provided application.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15758560186445720)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_text=>'User is not authorized to delete this comment.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15759330510464873)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_text=>'User not authorized to delete this issue.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15757977766430563)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_text=>'User is not authorized to change the visibility of this comment.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(598679943579795070)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_text=>'There was a problem checking file sizes. Please contact your system administrator.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(598679623924784998)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_text=>'One of these files is larger than the max file size of %0 bytes.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(598669656884776816)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_text=>'This file is larger than the maximum file size of %0 bytes.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6788392375288492)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_text=>'Hide'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15769212667944478)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_text=>'Image'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15765090237756188)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_text=>'Images'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15754321445205293)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_text=>'an issue that was not found in the system'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1659503297613032)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_text=>'Add Preference for User'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15763984156734988)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_text=>'Attach Files'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15761764932646517)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_text=>'Closed'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(698743093683144194)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_text=>'Heading'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15767952903890575)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_text=>'is empty.'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15767555285843328)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_text=>'One of these files is'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15761331822642524)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_text=>'Open'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15776591708128695)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_text=>'Permanently Delete Selected'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500417367361378905)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_text=>'Purge All'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15776301247123383)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_text=>'Reinstate Selected'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15764105164737383)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_text=>'Response Templates'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15767745366885392)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_text=>'too large to upload. <br>Files must be less than'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15768686319917121)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_text=>'Supported file types are: '
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586263564801423122)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_text=>'Select a Response Template'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15767379936829231)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_text=>'This file is'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15768144002899184)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_text=>'not a supported file type.'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459414268865169612)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_text=>'Bug'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459415474770182851)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_text=>'Documentation Issue'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459414410540173125)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_text=>'Enhancement Request'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459414695207174891)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_text=>'Feature Request'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459415270051180858)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_text=>'Installation Issue'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459415061051178881)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_text=>'Performance Issue'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459414826096176730)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_text=>'Security Issue'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459415630553184166)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_text=>'Training Issue'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459417047404196234)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_text=>'Administration'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459416482013191574)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_text=>'CSS / HTML'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459416658696194018)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_text=>'Dynamic Actions / JavaScript'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459416028114188787)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_text=>'Database'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459417246817198623)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_text=>'External System Integration'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459416251897190299)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_text=>'REST Integration'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459416861408194923)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_text=>'Security'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459415881988187616)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_text=>'UI / UX'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459414055537163639)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_text=>'Category assigned to the issue.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459412139945138517)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_text=>'Category'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459413873260160868)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_text=>'Functional area affected by the issue.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459412387728141273)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_text=>'Functional Area'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459413600296157679)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_text=>'Level of importance assigned to the issue.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459412515948143780)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_text=>'Importance'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459413402585154504)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_text=>'Level of effort to address the issue.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459412757477145573)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_text=>'Level of Effort'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459413219977151330)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_text=>'Progress against the issue.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459412999120146808)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_text=>'Progress'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459418006306205982)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_text=>'Backlog'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459417411926202503)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_text=>'Critical'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459417695263203303)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_text=>'Important'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459417800739204284)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_text=>'Normal'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459418285551207449)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_text=>'Will Not Address'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459418454661211243)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_text=>'Easy Fix'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459418874349214088)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_text=>'Large Development Effort'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459418678569212348)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_text=>'Moderate Effort'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459419670793223855)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_text=>'Can Not Fix'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459419855083225058)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_text=>'Complete'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459419224245220503)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_text=>'Requires More Info'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459419450587222758)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_text=>'Waiting on Third Party'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459419098647218464)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_text=>'Working On It'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461681272756449089)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_text=>'This Label Group may not be deleted because one or more of its members is assigned to an issue.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16222020043254273)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_text=>'Last updated'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15760115651579953)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_text=>'Marked duplicate of'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500032458659723624)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_text=>'Assignees'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500032225975723007)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_text=>'Labels'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500194278431059049)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_text=>'Milestones'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500032000488721930)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_text=>'Status'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15752717890152350)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_text=>'milestones'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(460427799520556560)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_text=>'Code Freeze'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(460428113883562989)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_text=>'Final Release'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(460427974831560195)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_text=>'UI Freeze'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15775324805078948)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_text=>'%0 added a comment to %1 %2'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1420753918636510)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_text=>'has changed.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471455708555167362)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_text=>'Issue number %0 in workspace %1 has changed.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(598636091558730275)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_text=>'No Labels have been defined.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16222626734263717)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_text=>'Open'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15765842514763884)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_text=>'Other'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15755764899244576)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15755321856237326)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_text=>'Page no longer exists'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(673260390160512570)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_text=>'Purge All'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(510502185254988762)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_text=>'Remove'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15754762488223719)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_text=>'Removed the Application and Page association from'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15756510522271058)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_text=>'Removed the attachment'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(625055880474785986)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_text=>'Do you want to replace your current comment with this template?'
,p_is_js_message=>true
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(627065760940319955)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hi there! ',
'',
'This is your very first issue! You can create issues to keep track of tasks, features, bugs, and feedback for all of your APEX projects!  You can add labels to issues, add assignees, set milestones, and even apply formatting using Markdown shorthand!'
||'  ',
'',
'Below is a quick sample of what you can do with Markdown:'))
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(627020434793279507)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_text=>'Welcome to Team Development in Oracle APEX!'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(514603986874946476)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_text=>'- Select -'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15756749342273960)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_text=>'Set status to'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6824529888322728)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_text=>'Show actions'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626969010413120433)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_text=>'Show More...'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15755933081249428)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_text=>'Subscribed'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(598752029318567239)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_text=>'%0 in workspace %1 has %2 new notifications.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459406070959977425)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_text=>'Template used to log a bug.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459405325950965248)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_text=>'Bug Template'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459404851388926104)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Expected Behavior**',
'- Tell us what you believe should happen.',
'',
'',
'**Current Behavior**',
'- Tell us what happens.',
'',
'',
'**Who is affected**',
'- Tell us who/what is affected. ',
'',
'**Possible Solution**',
'- If you can, suggest how you would fix this bug.',
'',
'**Steps to Reproduce**',
'- Provide an unambiguous set of steps to reproduce, including screen shots and code snippets if appropriate.',
'1.',
'2.',
'3.',
'',
'**Context**',
'- What were you trying to accomplish when the bug occurred. Does the bug only occur under certain conditions, or at certain times of day, and so forth.',
'',
'**Environment**',
'',
'- Version: ',
'- Platform: ',
'- Subsystem:',
'',
'______',
'',
'_**NOTE:** To associate an issue with an application and/or page, first log the issue, then use the **ACTIONS** drop down to associate the App and Page._'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459408795010070233)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_text=>'A bug has been raised.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459408570739066912)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_text=>'Bug Raised'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459408946397074008)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A **Bug** has been filed in the appropriate external system.',
'',
'- Bug Tracking System: ',
'- Bug ID: ',
'- URL to bug: ',
'',
'Comments:'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459406805249027008)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_text=>'Template used to log a feature request.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459406654637024303)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_text=>'Feature Request Template'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459407083603031574)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Feature Summary**',
' - Provide a one paragraph general overview of the feature request.',
'',
'',
'**Context**',
' - Does this request relate to a specific situation or process? For example, "I am always frustrated when [...]"',
'',
'',
' - Please provide any supporting information, including screenshots, use cases, and so forth.',
'',
'',
'**Preferred Solution**',
'- Provide a clear description of what you would like to see implemented.',
'',
'',
'**Alternative Solutions**',
'- Provide a description of alternative solutions or features considered, or workarounds used.',
'',
'',
'______',
'_**NOTE:** To associate an issue with an application and/or page, first log the issue, then use the **ACTIONS** drop down to associate the App and Page._'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459409339680081921)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_text=>'A feature request has been filed.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459409110641078448)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_text=>'Feature Request Filed'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459409590453084860)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A **Feature Request** has been filed in the appropriate external system.',
'',
'- Feature Tracking System: ',
'- Feature ID: ',
'- URL to Feature Definition: ',
'',
'Comments:'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459411166280106591)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_text=>'A followup action is required.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459410914872104152)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_text=>'Followup Action Required'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459411342342109166)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Please perform the following actions: ',
'',
'1.',
'2.',
'3.',
'4.',
'',
'Comments: '))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459407429811046820)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_text=>'Template used to ask a procedural question.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459407251548044622)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_text=>'How Do I ...'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459407693725049491)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Question**',
'- State your question or request as succinctly as possible.',
'',
'**General Context**',
'- What are you trying to do? ',
'',
'',
'- Where else have you looked or who else have you contacted to find an answer? ',
'',
'',
'**Environment** ',
'Is this question specific to an environment, programming language or other area?',
'',
'______',
'_**NOTE:** To associate an issue with an application and/or page, first log the issue, then use the **ACTIONS** drop down to associate the App and Page._'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459410582957099400)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_text=>'Reference a known issue.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459410349696095617)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_text=>'Known Issue'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459410743655101136)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'After review, it has been determined that this is a known issue, see details below.',
'',
'- Bug Tracking System: ',
'- Bug ID: ',
'- URL to bug: ',
'',
'Comments: '))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459409972722090704)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_text=>'Request for more information.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459409725735088140)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_text=>'Need More Information'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459410136474093077)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**More information is needed for this issue:**',
'',
'Please provide the information requested below. Without this information it will be difficult to triage and address the issue further.',
'',
'',
'Comments:'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459408193962060440)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_text=>'This issue will not be actioned'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459407948488057034)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_text=>'Won''t Action'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(459408349341062954)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'After careful consideration, **no further action will be taken on this issue**. ',
'',
'Comments:'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15769868452948224)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_text=>'Text File'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15765698960761153)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_text=>'Text Files'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15751914666135585)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_text=>'this issue'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471458196903192063)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_text=>'added the attachment %0 to %1 %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471456152071174289)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_text=>'added %0 to %1 %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471483680554268589)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_text=>'added %0 to %1 %2				'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471456581311177879)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_text=>'assigned %0 to %1 %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471457387041185245)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_text=>'associated %0 with %1 %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15774956500066416)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_text=>'edited a comment for %0	%1'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93754039405421844)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_text=>'edited issue %0 %1'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471474151956907146)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_text=>'This issue has been hidden.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471456914764181877)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_text=>'marked %0 as a duplicate of %1 %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471470290824653152)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_text=>'Opened %0 by'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471458397968193844)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_text=>'removed the attachment %0 from %1 %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471456382600176139)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_text=>'removed %0 from %1 %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471483888072272586)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_text=>'removed %0 from %1 %2 			'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471458569323195583)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_text=>'set status for %0 to %1 %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471457701231188763)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_text=>'subscribed to %0 %1'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471456715018179929)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_text=>'unassigned %0 from %1 %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471457507348186925)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_text=>'removed the Application and Page association from %0 %1'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471457138248183693)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_text=>'unmarked %0 as duplicate %1'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471457944217190420)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_text=>'unsubscribed from %0 %1'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471470035188651331)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_text=>'marked duplicate of %0 %1 by %2'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15753369414170235)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_text=>'Unassigned'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6788575618289773)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_text=>'Unhide'
,p_is_js_message=>true
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15756187320259859)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_text=>'Unsubscribed'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500031837979718118)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_text=>'Update...'
,p_is_js_message=>true
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15769451818945593)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_text=>'Zip File'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15765200525758181)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_text=>'Zip Files'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2212964321847020)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_text=>'%0 is not a Geocoded Address item.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(618179493321995456)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_text=>'Item %0 not found.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591719169453077645)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_text=>'The page checksum provides an easy way to determine whether the same page is deployed elsewhere. You can compare this checksum to determine whether there is a match.	Changes to Shared Components used on this page will not be reflected within this che'
||'cksum.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(727452646001026597)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_text=>'About this Application'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(727278751559955251)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_text=>'Configuration Options'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(727289478035981358)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_text=>'Theme Style Selection'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7402625739553451)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_text=>'Only Compact Font Format (CFF) fonts with one font are allowed.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7402866828566450)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_text=>'Only Compact Font Format (CFF) fonts with one top DICT are allowed.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7403012578568428)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_text=>'Only Compact Font Format (CFF) fonts with Type 2 CharString Format are allowed.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11401015227163974)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_text=>'The font was not found.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11400897978162374)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_text=>'Only format 4 and 12 cmap tables are supported.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11401686337180244)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_text=>'Invalid page orientation.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11401261170165884)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_text=>'The PDF is not initialized.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11400689408160974)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_text=>'No valid cmap sub-tables found in the font.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11401445079168584)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_text=>'The PDF has no pages.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(168402932951957365)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_text=>'An internal error has occurred while creating the PDF file.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13800526896179985)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_text=>'Process "%0" has invalid (non Multi-Row) Editable Region assigned.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9335300046801064)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_text=>'Unable to get next or previous primary key value.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(362308404356075090)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_text=>'The web service was not found.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88422025627501910)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_text=>'Error processing process.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3601179216152664)
,p_name=>'APEX.PROVISION_REQUEST.INVALID_EMAIL'
,p_message_text=>'The email address format provided in the workspace request is invalid.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19248021403301631)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Oracle APEX could not process the request because of database session resource limitations. Please try again later.',
'<p/>',
'Details about this incident are available via debug id "%0".'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9700490508606492)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_text=>'The following error occurred while deploying the application: %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10773029274266624)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_text=>'Application %0 successfully deployed to remote server.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11900354650958272)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_text=>'Application %0 successfully deployed as %1 to remote server.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358729193892838276)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_text=>'Authentication failed for REST Enabled SQL service.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19707705727680031)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_text=>'Authentication failure. List of Values uses a REST Enabled SQL data source that references invalid web credentials, which will prevent you from editing column information for this LOV. Please check authentication credentials. '
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(681124897300108628)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_text=>'Communication failure. There was a problem invoking the REST Enabled SQL data source referenced by the List of Values, which will prevent you from editing column information for the LOV. Please check the REST Enabled SQL data source is working correc'
||'tly, and also the corresponding authentication credentials are correct.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3301047227140977)
,p_name=>'APEX.REMOTESQL.DATABASE_NOT_SUPPORTED'
,p_message_text=>'REST Enabled SQL Database Type %0 is not supported.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359290872198939253)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_text=>'Error on Remote Server: %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(309252727957636603)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_text=>'Specified ORDS REST Enabled SQL instance not found.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100611171647129283)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_text=>'Server sent a redirection to: %0'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218215259070608118)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_text=>'SQL Statement is longer than 32.767 bytes.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(241923994125388733)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hello, Oracle APEX! You are connected as #USER#.',
'The local database timestamp is: #SYSDATE#.'))
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461678196397341941)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_text=>'You are editing the alias for the workspace''s default schema. Setting this alias will also change the Path Prefix at the workspace level.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(212724747305602464)
,p_name=>'APEX.SC.REFERENCES'
,p_message_text=>'%0 references'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1410035224780861)
,p_name=>'APEX.SEARCH.APP_PATH'
,p_message_text=>'App %0 (%1)'
,p_version_scn=>36697233
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461360095208526401)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_text=>'Utilities'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461360200313526418)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_text=>'Navigate to: Application Utilities \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49714562754352881)
,p_name=>'APEX.SEARCH.AU.APP_ALIAS'
,p_message_text=>'App %0 (%1)'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49714743747372945)
,p_name=>'APEX.SEARCH.AU.APP_PAGE_ALIAS'
,p_message_text=>'App %0'
,p_version_scn=>36720279
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1411453084791896)
,p_name=>'APEX.SEARCH.CATEGORY.ACTIONS'
,p_message_text=>'Actions'
,p_is_js_message=>true
,p_version_scn=>36715791
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1410686502786087)
,p_name=>'APEX.SEARCH.CATEGORY.APPLICATIONS'
,p_message_text=>'Applications'
,p_is_js_message=>true
,p_version_scn=>36714013
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1410432592785153)
,p_name=>'APEX.SEARCH.CATEGORY.GLOBAL'
,p_message_text=>'Global'
,p_is_js_message=>true
,p_version_scn=>36713979
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1411258991789813)
,p_name=>'APEX.SEARCH.CATEGORY.OTHERS'
,p_message_text=>'Others'
,p_is_js_message=>true
,p_version_scn=>36715717
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1411069214789061)
,p_name=>'APEX.SEARCH.CATEGORY.PAGES'
,p_message_text=>'Pages'
,p_is_js_message=>true
,p_version_scn=>36715643
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1412313989799657)
,p_name=>'APEX.SEARCH.CLEAR_ALL'
,p_message_text=>'Clear All'
,p_is_js_message=>true
,p_version_scn=>36716172
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461381863818527075)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_text=>'Go to page'
,p_is_js_message=>true
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461381592546527067)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_text=>'Go to Shared Components'
,p_is_js_message=>true
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1410415157231896)
,p_name=>'APEX.SEARCH.NO_RESULTS_FOUND'
,p_message_text=>'No results found'
,p_is_js_message=>true
,p_version_scn=>40889298
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461360571624526427)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_text=>'App Builder'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461360866509526435)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_text=>'App Builder Tasks > '
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1410246947781970)
,p_name=>'APEX.SEARCH.PAGE_PATH'
,p_message_text=>'App %0 / Page %1 (%2)'
,p_version_scn=>36697264
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461361163014526444)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_text=>'Application Items'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461361437528526452)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Application Items \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461361727720526461)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_text=>'Application Logic'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461362051439526469)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_text=>'Authentication Schemes'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461362310854526478)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Security Authentication Schemes \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461362578180526486)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_text=>'Authorization Schemes'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461362809891526495)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Security Authorization Schemes \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461363190129526503)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_text=>'Breadcrumbs'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461363459173526512)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Breadcrumbs \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461363785862526520)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_text=>'Build Options'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461364079937526529)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Build Options \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461364361400526537)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_text=>'Component Settings'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461364617319526546)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Component Settings \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461364987961526554)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_text=>'Computations'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461365210329526562)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Application Computations \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461365559294526571)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_text=>'Create Application Item'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461365842706526579)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_text=>'Create Authentication Scheme'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461366047952526587)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_text=>'Create Build Option'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461366350794526596)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_text=>'Create Application Computation'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461366629942526604)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_text=>'Create Email Template'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461366932786526613)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_text=>'Create Plug-in'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461367200861526621)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_text=>'Create Theme'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461367545659526630)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_text=>'Create Web Credentials'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461367871873526645)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_text=>'Data Load Definitions'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461368118423526660)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Data Load Definitions \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461368431050526671)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_text=>'Data Sources'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461368733741526679)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_text=>'Definition Attributes'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461368939897526690)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_text=>'Email Templates'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461369238599526699)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_text=>'Report Layouts'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461369549889526707)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Report Layouts \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461369821500526715)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_text=>'Legacy Web Services'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461370179061526724)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Legacy Web Services \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461370420527526732)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_text=>'Navigation Lists'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461370710464526741)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Classic Navigation Lists \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461371003867526751)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_text=>'List of Values'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461371368501526759)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ List of Values \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171970280041020767)
,p_name=>'APEX.SEARCH.SC.MANAGE_PREFERENCES'
,p_message_text=>'Manage Preferences'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171970571338047514)
,p_name=>'APEX.SEARCH.SC.MANAGE_SERVICE'
,p_message_text=>'Manage Service'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171970069103019026)
,p_name=>'APEX.SEARCH.SC.MANAGE_SESSION_STATE'
,p_message_text=>'Manage Session State'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171969706136015539)
,p_name=>'APEX.SEARCH.SC.MANAGE_WORKSPACE'
,p_message_text=>'Manage Workspace'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461371681971526768)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_text=>'Navigation'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461371942600526777)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_text=>'Other Components'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461372139782526785)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_text=>'Plug-ins'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461372413791526793)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Plug-ins \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461372749803526802)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_text=>'Processes'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461373012959526810)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Application Processes \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461373307855526828)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_text=>'Report Queries'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461373622189526836)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Report Queries \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461373988321526845)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_text=>'Reports'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461374204636526853)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461374524416526862)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ REST Enabled SQL \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461374895502526870)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_text=>'Security'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461375108211526878)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_text=>'Session State Protection'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461375366418526887)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_text=>'Set Application State Protection'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461375638234526895)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_text=>'Shared Components'
,p_is_js_message=>true
,p_version_scn=>36715482
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461375938330526904)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461376296119526912)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_text=>'Shortcuts'
,p_is_js_message=>true
,p_version_scn=>36716044
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461376550556526921)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Shortcuts \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461376850620526929)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_text=>'Tabs (Legacy)'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461377423883526949)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_text=>'Templates'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461377739997526957)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ UI Templates \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461378003791526966)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_text=>'Themes'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461378355217526974)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ UI Themes \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461378510250526982)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_text=>'User Interface'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461378880743526991)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_text=>'Web Credentials'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461379155251526999)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ Security Web Credentials \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461379440989527008)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_text=>'REST Data Source'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461379751305527016)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_text=>'Navigate to: Shared Components \ REST Data Sources \ %LIST_ITEM_NAME%'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461380073505527025)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_text=>'SQL Workshop'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461380350406527033)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_text=>'Create Object'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461380609146527042)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_text=>'Create %LIST_ITEM_NAME% in SQL Workshop'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461380957058527050)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_text=>'Script Editor'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461381245873527059)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_text=>'SQL Workshop Tasks'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44166157386204306)
,p_name=>'APEX.SEARCH.UTILITIES.OBJECT_REPORTS'
,p_message_text=>'Object Reports'
,p_is_js_message=>true
,p_version_scn=>36715832
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1582027430515961721)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_text=>'Page Item %0 is based on a Database Column but the attribute ''Source Used'' is set to ''Only when current value in session state is null''. This is very dangerous and can result in accidentally overwriting data when viewing and saving multiple records. '
||'Always set ''Source Used'' to ''Always, replacing any existing value in session state''.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(716454763684253965)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_text=>'Access to session state is disabled, attempt to read/write was blocked.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23680232504124313)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_text=>'Attempt to save item %0 in session state during show processing, item has Internal Only protection.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21006331518737908)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_text=>'Attempt to save item %0 in session state during accept processing, item has Internal Only protection or is not a form item that can be POSTed.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21005116019714586)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The checksum computed on the request, clear cache, argument names, and argument values (%0) did not match the checksum passed into the show procedure (%1).',
'',
'Note: End users get a different error message.'))
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20999902634644494)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Attempt to save item %0 in session state during show processing. Item protection level indicates:',
'  %1',
'',
'No checksum was passed in or the checksum passed in would be suitable for an item with protection level "%2".',
'',
'Note: End users get a different error message.'))
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88416518916490500)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_text=>'ERR-1022 Unable to save attributes.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2123374987810646)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_text=>'Cannot convert SDO_GEOMETRY value to GeoJSON.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1865271625862732)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_text=>'Cannot convert text to an SDO_GEOMETRY object.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018021290361364)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_text=>'%0 does not contain valid GeoJSON.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5994227411936586)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_text=>'Error computing default value for column #COMPONENT_NAME#.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6224418492659112)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_text=>'Error processing Multi Row Delete process.'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106583016405934090)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_text=>'Checksum column ("FCS") is required and was not supplied'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106584209264941524)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_text=>'No primary key values were supplied, at least one row must be supplied for updates to occur'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106613731493127723)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_text=>'No secondary values were supplied for the identified secondary key column'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143444531694195363)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_text=>'no data found in tabular form'
,p_version_scn=>37165770887489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106582623201926606)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_text=>'Primary key column was not specified'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106611710368121624)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_text=>'Secondary key column identified was not located in the select list of the query'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106581428957918814)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_text=>'Table Name was not specified'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106580518568915814)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_text=>'Table Owner was not specified'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112132616702429999)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_text=>'Error processing Multi Row Update process.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110951617009402863)
,p_name=>'APEX.TEMPLATE_DIRECTIVE.INFINITE_LOOP'
,p_message_text=>'Possible infinite loop detected while applying a Template Component.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15456502223871318)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_text=>'Can not copy theme "%0" in application "%1".'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1429533317665073149)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The imported theme is not compatible with the current theme.',
''))
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(968205231756292138)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_text=>'Theme number is invalid or theme is not a current UI theme.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715870652181741385)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_text=>'Primary Key and Parent Key Columns required to compute hierarchy.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715870894672745390)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_text=>'Node Level and Node Status Columns required when hierarchy is not computed.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(832771875757067316)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_text=>'Appearance'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(562168105051650372)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_text=>'Automatic'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72345618085017415)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_text=>'Dark Mode'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72346399126023116)
,p_name=>'APEX.UI.DISABLED'
,p_message_text=>'Disabled'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(562167987415648326)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_text=>'Light Mode'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48282408156372544)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_text=>'Unauthorized access (security group package variable not set).'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48286710328429891)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_text=>'Cannot fetch find user information. %0'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43150918940160201)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_text=>'User %0 requires ADMIN privilege to perform this operation.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48286117469422535)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_text=>'User %0 has not supplied an e-mail address.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38396719225016778)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_text=>'Unauthorized access.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48285131190417009)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_text=>'User %0 does not exist.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21500487218820275)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_text=>'Validation "%0" has invalid (non Multi-Row) Editable Region assigned.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88419200693494703)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_text=>'Error processing validation.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2257806996639685)
,p_name=>'APEX.WEBSRC.ARRAY_COLUMN_NOT_FOUND'
,p_message_text=>'Column %0 is not an array column in the data profile.'
,p_version_scn=>27116250
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(718365479485605501)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_text=>'Oracle APEX cannot compute a data profile from the response data of type: %0.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1469219931399671)
,p_name=>'APEX.WEBSRC.COLUMN_VALIDATION_REGEXP_VIOLATED'
,p_message_text=>'Invalid value for Data Profile column %0.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(328258143932001598)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_text=>'Table'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(328257912987000826)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_text=>'Row'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001336063737674)
,p_name=>'APEX.WEBSRC.DEFAULT_CATALOG_SERVICE_NAME'
,p_message_text=>'Service'
,p_version_scn=>26236570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(658173211885075774)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_text=>'Filter expression is not valid JSON.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644535835248888446)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_text=>'Filter is not supported by Oracle REST Data Services.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(212670799626464682)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_text=>'Pagination URL Parameter "%0" conflicts with a REST Source Parameter.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(310129990065948603)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_text=>'HTTP 200: Success'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(310130179567949413)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_text=>'HTTP 201: Created'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(310128919460940749)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_text=>'HTTP 400: Bad request'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(310128547530938849)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_text=>'HTTP 401: Unauthorized'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(310129108827942513)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_text=>'HTTP 403: Forbidden'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(310128736779939806)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_text=>'HTTP 404: Not found'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(310129360298943614)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_text=>'HTTP 405: Method not allowed'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2033978997579515)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_text=>'HTTP 407: Proxy Authentication required'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2035038201600950)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_text=>'HTTP 409: Conflict'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2034494541587302)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_text=>'HTTP 412: Precondition failed'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2034839697594944)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_text=>'HTTP 428: Precondition Required'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(310129593388944751)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_text=>'HTTP 500: Internal Server Error'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(310129705571947828)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_text=>'HTTP 502: Bad Gateway'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(719239318137040446)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_text=>'HTTP 503: Service Unavailable'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(719239519188043065)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_text=>'HTTP 504: Gateway Timeout'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580953514844599291)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_text=>'REST Data Source returned an HTTP error: %0'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(309252214290620546)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_text=>'REST Data Source not found.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86184817819805672)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_text=>'Row Selector "%0" did not select an array of objects to be treated as a Table.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86185855899815153)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_text=>'Row Selector "%0" did not select an object to be treated as a Single Row.'
,p_version_scn=>37165770887490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1469867057006028)
,p_name=>'APEX.WEBSRC.OPERATION_STATIC_ID_NOT_UNIQUE'
,p_message_text=>'Operation Static ID is not unique'
,p_version_scn=>37165770887493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1469023854403720)
,p_name=>'APEX.WEBSRC.PARAM_VALIDATION_REGEXP_VIOLATED'
,p_message_text=>'Invalid value for REST Source Parameter %0.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2500432815259450)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_text=>'The REST Data Source rate limit (%0 requests within %1 seconds) has been exceeded.'
,p_version_scn=>37165770887493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706842673865383)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_text=>'The REST Data Source rate limit (%0 requests within %1 seconds) has been exceeded and the required waiting time is too long.'
,p_version_scn=>37165770887493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580953317951585160)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_text=>'Required REST Source IN parameter "%0" of type "%1" must have a value.'
,p_version_scn=>37165770887493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538482188904946926)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_text=>'The response body is too large to display.'
,p_version_scn=>37165770887493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(280176385690444441)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_text=>'Legacy ORDS REST service uses a small Fixed Page Size.'
,p_version_scn=>37165770887493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9321724657569761)
,p_name=>'APEX.WEBSRC.SOURCE_DOES_NOT_USE_PAGINATION'
,p_message_text=>'This data source does not allow pagination'
,p_version_scn=>272092386
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3500258507404990)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- This API call dynamically synchronizes the table columns to the ',
'-- REST Data Source''s data profile by executing ALTER TABLE statements. ',
'-- If a column data type cannot be changed using ALTER TABLE, an error ',
'-- message will be raised.',
'--'))
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3002629821886787)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_text=>'Data Profile changes cannot be automatically applied, local table columns must be adjusted manually.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3500804276420203)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- As of %0 this will execute:',
''))
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001045503832068)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_text=>'The merge synchronization method requires a primary key to be defined in the Data Profile.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001659363843656)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_text=>'The local table and the data profile have no common columns.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706261919784177)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_text=>'Job terminated'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3002069500852015)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_text=>'Failure'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3002279220854625)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_text=>'Incomplete (Request limit exceeded)'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3002465944858667)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_text=>'Job already running'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1729255222008618)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_text=>'Running'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1729378473010739)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_text=>'Scheduled'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001809403851243)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_text=>'Success'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001288958834389)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_text=>'Synchronization Step %0'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001476237835497)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_text=>'%0 (New)'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183659823754519819)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_text=>'Test Operation'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242132451615743610)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_text=>'Timeout exceeded when fetching all REST Source data.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206935809388034186)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_text=>'The current local SQL filters require too many "Next Page" requests to the REST service.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108217961343965515)
,p_name=>'APEX.WEBSRC.TYPE_SWITCHED'
,p_message_text=>'Created REST Source as the "Simple HTTP" type, as it appears that the REST service does not support filtering or pagination.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2797152098598580)
,p_name=>'APEX.WEBSRC.UNFILTERABLE_ATTR_OR_BAD_OPER'
,p_message_text=>'Search filter includes a non-queryable column or unsupported operator'
,p_version_scn=>272322883
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(280176141272441818)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_text=>'Fixed Page Size for Legacy ORDS REST Service is unknown.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(97557422558470784)
,p_name=>'APEX.WORKSPACE_ADMIN.PARM_NOTFOUND'
,p_message_text=>'The workspace parameter was not found or the parameter cannot be changed using this functionality.'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113436236028212955)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_text=>'Branch to Admin Page'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410758871212964)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432377513212957)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_text=>'Commented Out'
,p_is_js_message=>true
,p_version_scn=>100563846
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416847511212962)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_text=>'Add Row'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417134109212962)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_text=>'Add %0'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417551213212962)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_text=>'Add Multiple Users'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417671635212962)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_text=>'Add User'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417777732212962)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_text=>'Add Users'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416514323212962)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_text=>'Apply Changes'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416667471212962)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_text=>'Cancel'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416758259212962)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_text=>'Close'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416462432212962)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_text=>'Create'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405759040212966)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_text=>'Delete'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416968277212962)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_text=>'Delete Checked'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417058209212962)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_text=>'Edit'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417296241212962)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_text=>'Finish'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405576148212966)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_text=>'Go'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406249107212965)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_text=>'Load Data'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417331639212962)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_text=>'Sign In'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405941339212966)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_text=>'Next'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405870519212966)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_text=>'Previous'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405633246212966)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_text=>'Reset'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406039205212965)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_text=>'Save'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406107803212965)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_text=>'Submit'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417822948212962)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_text=>'Submit Feedback'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417477405212962)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_text=>'View Details'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410634924212964)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_text=>'Label %0'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429857233212958)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_text=>'Series %0'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422226568212960)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_text=>'Roles'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410453999212964)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_text=>'Actions'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421272716212961)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_text=>'Activity by Hour'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420598140212961)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_text=>'Application Sessions'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410358898212964)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_text=>'Attachment'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409571105212964)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_text=>'Automation'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420108191212961)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_text=>'Avg Elapsed'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419523560212961)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_text=>'Component Name'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421180255212961)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_text=>'Context'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418417974212961)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_text=>'Current Status'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418103176212961)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420422699212961)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_text=>'Distinct Users'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409376835212964)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_text=>'Edit'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419212623212961)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_text=>'Elapsed'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422165649212960)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_text=>'Ended'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419884792212961)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_text=>'Error'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409429675212964)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_text=>'Errors'
,p_version_scn=>37165770887496
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422082029212960)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_text=>'Error Rows'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113417958587212962)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_text=>'Feature'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410098999212964)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409802326212964)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_text=>'Filed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422466407212960)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_text=>'Filed By'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420932528212961)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_text=>'Full Page Views'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419769573212961)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_text=>'IR Search'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418514956212961)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_text=>'Label'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418832741212961)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_text=>'Last Activity'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420033327212961)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_text=>'Max Elapsed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420255676212961)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_text=>'Median Elapsed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421664948212960)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_text=>'Message'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421768692212960)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_text=>'Message Type'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419962910212961)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_text=>'Min Elapsed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421588529212960)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_text=>'Most_Recent'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419672595212961)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_text=>'Num Rows'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421031580212961)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_text=>'Occurrence'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419398157212961)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421324569212960)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_text=>'Page Events'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419424921212961)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_text=>'Mode'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418909854212961)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_text=>'Page Name'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420637526212961)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_text=>'Page Views'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420840793212961)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_text=>'Partial Page Views'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421851403212960)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_text=>'Primary Key Value'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409992703212964)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_text=>'Rating'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422301049212960)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_text=>'Reason'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410198769212964)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_text=>'Response'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421443133212960)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_text=>'Rows Fetched'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409792687212964)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_text=>'Scheduled'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409673490212964)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_text=>'Started'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418067160212961)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_text=>'Status'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113421911298212960)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_text=>'Successful Rows'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419125079212961)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_text=>'Timestamp'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420741607212961)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_text=>'Total Rows'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418361367212961)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_text=>'Updated By'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418248080212961)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_text=>'Updated'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113419074268212961)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_text=>'User'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418785376212961)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_text=>'Username'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410284459212964)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_text=>'User Agent'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113418633728212961)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_text=>'Value'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113420354166212961)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_text=>'Weighted Performance'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113402910198212968)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_text=>'Dialog Closed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415872113212962)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_text=>'Cancel Dialog'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416326456212962)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_text=>'Change Filters'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415930640212962)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_text=>'Create Button - Dialog Closed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416074788212962)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_text=>'Edit Report - Dialog Closed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416114562212962)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_text=>'Perform Search'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113416227616212962)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_text=>'Refresh Report'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405407214212966)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_text=>'File Character Set'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405062585212966)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_text=>'Roles'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428617978212958)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When Access Control is enabled, Administrators have the ability to restrict access to certain application features for authenticated users. This application supports the following 3 roles: Reader, Contributor, and Administrator.<p>',
'<ul>',
'  <li><strong>Readers</strong> have read-only access to all information and can also view reports.</li>',
'  <li><strong>Contributors</strong> can create,edit and delete information and view reports.</li>',
'  <li><strong>Administrators</strong>,in addition to Contributors capability,can also perform configuration of the application.</li>',
'</ul>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428461084212958)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_text=>'Any authenticated user may access this application'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428588608212958)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_text=>'Choose <strong>No</strong> if all users are defined in the access control list. Choose <strong>Yes</strong> if authenticated users not in the access control list may also use this application.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426756128212959)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_text=>'Date / Number Formats to use'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426804945212959)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_text=>'Choose whether to provide custom or to use standard format masks'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429206780212958)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_text=>'Attachment'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428283922212958)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_text=>'Automation'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426941005212959)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_text=>'File Character Set'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425715209212959)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_text=>'Copy and Paste Delimited Data'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427021835212959)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_text=>'Currency Symbol'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427123451212959)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_text=>'If your data contains international currency symbol, enter it here. For example, if your data has "&euro;1,234.56" or "&yen;1,234.56", enter "&euro;" or "&yen;".  Otherwise the data will not load correctly.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425464176212959)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_text=>'Import From'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427430957212959)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_text=>'Decimal Character'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427594884212959)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The decimal character separates the integer and decimal parts of a number.</p>',
'<p> Any character can be the decimal character. The character specified must be single-byte, and the decimal character must be different from group separator. The character can be a space, but cannot be any numeric character or any of the following c'
||'haracters:</p>',
'<ul class="noIndent">',
'<li>plus (+)</li>',
'<li>hyphen (-)</li> ',
'<li>less than sign (<)</li>',
'<li>greater than sign (>)</li> ',
'</ul>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404655958212966)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_text=>'Display'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429320003212958)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_text=>'Enable Attachments'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426081768212959)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_text=>'Optionally Enclosed By'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404980117212966)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_text=>'Enter a delimiter character. You can use this character to delineate the starting and ending boundary of a data value. If you specify a delimiter character, Data Workshop ignores whitespace occurring before the starting and ending boundary of a data '
||'value. You can also use this option to enclose a data value with the specified delimiter character.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429192675212958)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_text=>'Experience'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426499731212959)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_text=>'Failed Row(s):'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405188338212966)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429406720212958)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_text=>'Filed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425537776212959)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_text=>'File Name'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425670006212959)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_text=>'Name of the file to upload'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426129899212959)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_text=>'Select this box if your data contains column names in the first row.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427266266212959)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_text=>'Group Separator'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427383218212959)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A group separator is a character that separates integer groups, for example to show thousands and millions.</p>',
'<p>Any character can be the group separator. The character specified must be single-byte, and the group separator must be different from any other decimal character. The character can be a space, but cannot be a numeric character or any of the follow'
||'ing:</p>',
'<ul class="noIndent">',
'<li>plus (+)</li>',
'<li>hyphen (-)</li> ',
'<li>less than sign (<)</li>',
'<li>greater than sign (>)</li> ',
'</ul>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426281686212959)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_text=>'Inserted Row(s):'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10200684396998904)
,p_name=>'APEXAPP.ITEM.ORDER_BY'
,p_message_text=>'Order By'
,p_is_js_message=>true
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405296743212966)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404849891212966)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_text=>'Password'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000648611280622)
,p_name=>'APEXAPP.ITEM.PERSISTENT_AUTHENTICATION'
,p_message_text=>'Remember me'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429599664212958)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_text=>'Rating'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425205195212959)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_text=>'Remember username'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425398031212959)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429626710212958)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_text=>'Response'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426542819212959)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_text=>'To be Reviewed Row(s):'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404444903212966)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_text=>'Search'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404592508212966)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_text=>'Search...'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425858288212959)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_text=>'Separator'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425905491212959)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_text=>'Identify a column separator character. Use <code>\t</code> for tab separators.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426687352212959)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_text=>'Display advanced settings for data loading: Currency Symbol, Decimal Characters, File Encoding or Date Formats'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428353305212958)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_text=>'Started'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113405317049212966)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_text=>'Status'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427943045212959)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_text=>'End User Theme Preference'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428003116212958)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_text=>'If checked, end users may choose their own Theme Style using the Customize link.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427730866212959)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_text=>'Desktop Theme Style'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427879513212959)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_text=>'The default Theme Style applies to all users.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113427672596212959)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_text=>'Timeframe'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113426320365212959)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_text=>'Updated Row(s):'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404703183212966)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_text=>'Username'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428717163212958)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_text=>'Usernames'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428902575212958)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_text=>'Enter usernames separated by commas, semicolons, or whitespace. Existing or duplicate usernames will automatically be ignored.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428859757212958)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_text=>'Enter usernames here'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429059714212958)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_text=>'Username Format'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429712638212958)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_text=>'User Agent'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113428135444212958)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_text=>'View As'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113407415602212965)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_text=>'Access Control'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113407358646212965)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_text=>'Activity Reports'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432089574212957)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_text=>'Application Administration'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113407236790212965)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_text=>'Application Configuration'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113407664160212965)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_text=>'Email Reporting'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113407518891212965)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431980005212957)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_text=>'Page Navigation'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113407786708212965)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_text=>'Job Reporting'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431891886212957)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_text=>'Navigation Bar'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432110330212957)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_text=>'Navigation Menu'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113407137906212965)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_text=>'User Interface'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432295909212957)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_text=>'Manage component'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113407998270212965)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_text=>'Home'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408074122212965)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_text=>'Log Out'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430053969212958)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_text=>'Report Row Per Page'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431539905212957)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_text=>'Acknowledged'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430957512212958)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_text=>'Add Chart Page'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431721460212957)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_text=>'Closed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430283982212958)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_text=>'Copy and Paste'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430577182212958)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_text=>'Use application standard format masks'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430609791212958)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_text=>'Provide custom formats for uploaded columns'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431044326212958)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_text=>'Email Addresses'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430796638212958)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_text=>'Allow End Users to choose Theme Style'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430302188212958)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_text=>'First Row has Column Names'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431320966212958)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_text=>'Negative'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431280229212958)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_text=>'Neutral'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431477538212957)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_text=>'No Action'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431658668212957)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_text=>'Open'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113431161241212958)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_text=>'Positive'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430870233212958)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_text=>'Add Report Page'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430468808212958)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_text=>'Use Advanced Settings'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113430153933212958)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_text=>'Upload file, comma separated (*.csv) or tab delimited'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434131142212956)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_text=>'Activity Dashboard'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408689696212964)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_text=>'Add Multiple Users - Step %0'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408849554212964)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_text=>'Add Multiple Users'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433762171212956)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_text=>'Administration'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433857009212956)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The administration page allows application owners (Administrators) to configure the application and maintain common data used across the application.',
'By selecting one of the available settings, administrators can potentially change how the application is displayed and/or features available to the end users.</p>',
'<p>Access to this page should be limited to Administrators only.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434355729212956)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_text=>'Automations Log'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434467413212956)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page provides an interactive report of the automations log.</p>',
'<p>Review logged information about previous automation executions. The log contains start and end timestamps as well as details about processed rows (successful and with errors). Drill down into Messages to see individual messages for processed rows.'
||'</p>',
''))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434097449212956)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Configuration settings allow you to make specific functionality either available (enabled) or unavailable (disabled) to end users.</p>',
'<p>If a specific function is not 100% ready, or needs to be temporarily removed, click <strong>Disabled</strong>. ',
'Once it should be made available, simply click <strong>Enabled</strong>.</p>',
'<p><em><strong>Note:</strong> Changes made here will not be reflected for individual end users currently running the application. Once the end user signs out and then signs back in the revised feature settings will be invoked.</em></p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435489936212956)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_text=>'Configure Access Control'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435574061212956)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the appropriate choice for any authenticated users.<br> ',
'Selecting <strong>No</strong> makes the application more secure as only specified users can access the application. ',
'However, if your application has a large user community then maintaining users may be onerous, and you may prefer to choose <strong>Yes</strong> and only enter application Administrators, and possibly Contributors.<br>',
'If you select <strong>Yes</strong> then you must also select how users not included in the users list are treated.</p>',
'<p>Select between requiring email addresses and any alphanumeric value for Usernames.<br>',
'Generally, you should set this setting to <strong>E-mail Address</strong> if your application uses (or will be configured to use) a centralized authentication scheme such as Oracle Access Manager, or SSO.</p>',
'<p><em><strong>Note:</strong> This application supports the following 3 access levels: Reader, Contributor, and Administrator.',
'<ul>',
'  <li><strong>Readers</strong> have read-only access to all information and can also view reports.</li>',
'  <li><strong>Contributors</strong> can create, edit and delete information and view reports.</li>',
'  <li><strong>Administrators</strong>, in addition to Contributors capability, can also perform configuration of the application by accessing the Administration section of the application.</li>',
'</ul>',
'</em></p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434967516212956)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_text=>'Application Error Log'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435034451212956)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page provides an interactive report of all unexpected errors logged by this application.</p>',
'<p>Click on the column headings to sort and filter data, or click on the <strong>Actions</strong> button to customize column display and many additional advanced features. Click the <strong>Reset</strong> button to reset the interactive report back t'
||'o the default settings.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435734527212956)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435852302212956)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_text=>'Feedback Settings'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435981701212956)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_text=>'<p><strong>Enable Attachments</strong> - If yes, users will be able to upload an attachment in support of their feedback.</p>'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408709650212964)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_text=>'Feedback Submitted'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408439038212964)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_text=>'Global Page'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408192761212965)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_text=>'Home'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432818985212957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_text=>'<p>Click the feedback icon ( <span class="fa fa-comment-o" aria-hidden="true"></span> ) in the navigation bar, from any page in the application, to leave feedback for the application administrators.</p>'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432617965212957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_text=>'<p>This is the home page of the application. Click on the cards to access different pages in the application, or use the navigation menu on the side of the page.</p>'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433228098212957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_text=>'<p>Click your name dropdown in the navigation bar to sign out of the application.</p>'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433103147212957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_text=>'<p>Click the user menu ( <span class="fa fa-user" aria-hidden="true"></span> ) in the navigation bar to update your time zone preference, and sign out of the application.</p>'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432574771212957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_text=>'Home Page'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432727420212957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_text=>'<p>This is the home page of the application. Click on the cards to access different pages in the application, or use the navigation menu at the top of the page.</p>'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433067539212957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Click the user menu ( <span class="fa fa-user" aria-hidden="true"></span> ) in the navigation bar (top right of the page) to access your user profile, and sign out of the application.<br>',
'If you click <strong>View My Profile</strong> you can then click <strong>Update Profile</strong> to enter your personal details and upload a photo or avatar.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432980286212957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Click the user menu ( <span class="fa fa-user" aria-hidden="true"></span> ) in the navigation bar to access your user profile, update your time zone preference, and sign out of the application.<br>',
'If you click <strong>View My Profile</strong> you can then click <strong>Update Profile</strong> to enter your personal details and upload a photo or avatar.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433413090212957)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can insert, update, and delete data directly within this interactive grid.<br>',
'  Insert a new row by clicking the Add Row button.<br>',
'  Double click into a cell, or click the <strong>Edit</strong> button to update data values, similar to editing data in a spreadsheet.</p>',
'',
'<p>Use the Row Actions menu ( <span class="fa fa-bars" aria-hidden="true"></span> ) at the top of the report to duplicate, delete, refresh or revert selected rows.<br> ',
'  Use the Row Actions menu on individual rows to also access the single row view or add a new row.</p>',
'',
'<p>To find data enter a search term into the search dialog, or click on the column headings to limit the records returned.</p>',
'',
'<p>You can perform numerous functions by clicking the <strong>Actions</strong> button. This includes selecting the columns that are displayed / hidden and their display sequence, plus numerous data and format functions.  You can also define an additi'
||'onal view of the data using the chart option.</p>',
'',
'<p>If you want to save your customizations select report, or click download to unload the data.<p>',
'',
'<p>For additional information click Help at the bottom of the Actions menu.</p> ',
'',
'<p>Click the <strong>Reset</strong> button to reset the interactive grid back to the default settings.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433589415212957)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To find data enter a search term into the search dialog, or click on the column headings to limit the records returned.</p>',
'',
'<p>You can perform numerous functions by clicking the <strong>Actions</strong> button. This includes selecting the columns that are displayed / hidden and their display sequence, plus numerous data and format functions.  You can also define an additi'
||'onal view of the data using the chart option.</p>',
'',
'<p>If you want to save your customizations select report, or click download to unload the data.<p>',
'<br>',
'<p>For additional information click Help at the bottom of the Actions menu.</p> ',
'',
'<p>Click the <strong>Reset</strong> button to reset the interactive report back to the default settings.</p>',
''))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433317012212957)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To find data enter a search term into the search dialog, or click on the column headings to limit the records returned.</p>',
'',
'<p>You can perform numerous functions by clicking the <strong>Actions</strong> button. This includes selecting the columns that are displayed / hidden and their display sequence, plus numerous data and format functions.  You can also define additiona'
||'l views of the data using the chart, group by, and pivot options.</p>',
'',
'<p>If you want to save your customizations select report, or click download to unload the data. Enter you email address and time frame under subscription to be sent the data on a regular basis.<p>',
'',
'<p>For additional information click Help at the bottom of the Actions menu.</p> ',
'',
'<p>Click the <strong>Reset</strong> button to reset the interactive report back to the default settings.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408208592212965)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_text=>'Login Page'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408327507212965)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_text=>'%0 - Log In'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435165931212956)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_text=>'Log Messages'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113436017312212955)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_text=>'Manage Feedback'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113436145079212955)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Feedback can be entered by end users from any normal page within the application.</p>',
'<p>This report shows the feedback entered, any response enter by administrators, and the status of the feedback.</p>',
'<p>Click the edit icon (yellow pencil) to enter a response or update the feedback status.</p>',
'<p><em><strong>Note:</strong> If feedback recipients have been defined then feedback submissions will also be emailed to the email addresses in the feedback recipients list.</em></p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435279279212956)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_text=>'Manage User Access'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435344754212956)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page shows a report of the application users and the access level granted.</p>',
'<p>Click on the column headings to sort and filter data, or click on the <strong>Actions</strong> button to customize column display and many additional advanced features.<br>',
'Click the <strong>Reset</strong> button to reset the interactive report back to the default settings.</p>',
'<p>Click the edit icon (yellow pencil) to edit the user details and access level, or to delete the user.</p>',
'<p>Click <strong>Add User</strong>, at the top of the report, to add a new user and their access level.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113435646307212956)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this form to enter users, their email address and set their access level. ',
'The settings defined under <em>Configure Access Control</em> will determine whether the username must be their email address or can be any alphanumeric entry.</p>',
'<p>This application supports the following 3 access levels: Reader, Contributor, and Administrator.</p>',
'<ul>',
'  <li><strong>Readers</strong> have read-only access to all information and can also view reports.</li>',
'  <li><strong>Contributors</strong> can create, edit and delete information and view reports.</li>',
'  <li><strong>Administrators</strong>, in addition to Contributors capability, can also perform configuration of the application by accessing the Administration section of the application.</li>',
'</ul>',
'<p>When editing an existing user you can lock their account which will prevent them from accessing the application.</p>',
'<p><em><strong>Note:</strong>   If using Oracle APEX accounts then users entered here must also be defined as end users by a Workspace Administrator, who can also set their password.</em></p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433610035212956)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This report page displays primary records in a selector on the side of the page. ',
'  Select a record to see the master record and any detail records defined.<br> ',
'  Click the edit icon ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ) to edit the master record.',
'  For detail records, click the pencil, at the beginning of each row, to edit that record.</p>',
'<p>To limit the data displayed in the selector enter a search term into the search dialog.</p>',
'',
'<p>To add a new master record click <strong>Create</strong> at the top of the page.',
'  For detail records, click the plus icon ( + ) at the top of the detail region to add a detail record.</p>',
'',
'<p>Click <strong>Reset</strong> at the top of the page to reset the page back to the default settings, removing any search term previously defined.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434715669212956)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_text=>'Page Performance'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434828283212956)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page provides an interactive report of the page performance and popularity. The report is ordered by <strong>Weighted Performance</strong> which is calculated by multiplying the Median Elapsed time and number of Page Views.</p>',
'<p>Select the reporting timeframe (Default = 1 day) at the top of the page as necessary.<br>',
'Click on the column headings to sort and filter data, or click on the <strong>Actions</strong> button to customize column display and many additional advanced features. Click the <strong>Reset</strong> button to reset the interactive report back to t'
||'he default settings.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434500105212956)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_text=>'Page Views'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434605339212956)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page provides an interactive report of the most recent page views.</p>',
'<p>Select the reporting timeframe (Default = 1 day) at the top of the page as necessary.<br>',
'Click on the column headings to sort and filter data, or click on the <strong>Actions</strong> button to customize column display and many additional advanced features. Click the <strong>Reset</strong> button to reset the interactive report back to t'
||'he default settings.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113433956921212956)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the default color scheme used to display the application.</p>',
'<p>If <strong>Allow End Users to choose Theme Style</strong> is checked, then each end user can select from the available theme styles by clicking the <em>Customize</em> link in the bottom left corner of the Home page.</p>'))
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408520658212964)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_text=>'Top Users'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113434247997212956)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this report and chart to see the users with the most page views for the specified timeframe.</p>',
'<p>Select the reporting timeframe (Default = 1 day) and choose between the report and chart icons at the top of the page.</p>',
'<p>For the interactive report, use the search field, or select the <strong>User</strong> column heading, to select a specific user. You can perform numerous functions by clicking the <strong>Actions</strong> button, such as columns displayed / hidden'
||', rows per page, filter, and so forth. Click the <strong>Reset</strong> button to reset the interactive report back to the default settings.</p>'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424649551212960)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_text=>'Add Users to Access Control List'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424747498212959)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_text=>'User(s) added.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422943634212960)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_text=>'Clear Page(s) Cache'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406553249212965)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_text=>'Close Dialog'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424550109212960)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_text=>'Create Collections'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406805968212965)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_text=>'Delete Feedback'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406951930212965)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_text=>'Feedback Deleted'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424475565212960)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_text=>'Process form %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425162533212959)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_text=>'Get File ID'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424143046212960)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_text=>'Get Log Detail'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423433637212960)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_text=>'Get Next or Previous Primary Key Value'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422896687212960)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_text=>'Get Username Cookie'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422541511212960)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_text=>'%0 - Save Interactive Grid Data'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424390172212960)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_text=>'Initialize form %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423320159212960)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_text=>'Action Processed.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406674529212965)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_text=>'Load Data'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423507698212960)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_text=>'Data Loading Failed'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406761429212965)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_text=>'Reply to Feedback'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406390795212965)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_text=>'Reset Pagination'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422605125212960)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_text=>'Reset report search'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113406453612212965)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_text=>'Set Access Control'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424280346212960)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_text=>'Access Control settings saved.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423928469212960)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_text=>'Update'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424090592212960)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_text=>'Configuration Options updated. '
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113425045780212959)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_text=>'Save Setting'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113422788837212960)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_text=>'Set Username Cookie'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424829963212959)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_text=>'Submit Feedback'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113424921857212959)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_text=>'Feedback Submitted'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423098037212960)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_text=>'#MRD_COUNT# row(s) deleted.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423197677212960)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_text=>'Update applied.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423240661212960)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_text=>'#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423868864212960)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_text=>'Save End User Style Preference'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113407026935212965)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_text=>'Application Appearance Settings Saved.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423629174212960)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_text=>'Save Theme Style'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113423759682212960)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_text=>'Application Appearance Settings Saved.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11400624042249723)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.CREDENTIALS_NAME'
,p_message_text=>'App %0 Push Notifications Credentials'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27407527852609193)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.DA.ENABLE_PUSH'
,p_message_text=>'Change %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27406121249506284)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.ITEM.ENABLE_PUSH'
,p_message_text=>'Enable push notifications on this device'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27406778068506284)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.LIST_ENTRY'
,p_message_text=>'Push Notifications'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1820761415876674)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.LIST_ENTRY.DESC'
,p_message_text=>'Configure whether you want to receive push notifications on this device.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601686553085957)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.NOT_SUPPORTED.REGION'
,p_message_text=>'Push Notifications Not Supported'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601879478088659)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.NOT_SUPPORTED.REGION.BODY'
,p_message_text=>'Push notifications are not currently supported in your browser.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27405358471506282)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.PAGE'
,p_message_text=>'Push Notifications'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27405562252506283)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.PAGE.HELP'
,p_message_text=>'This page contains the settings for controlling push notification subscription for the current user.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27405875618506283)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.REGION'
,p_message_text=>'Push Notifications'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1828334658928076)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.REGION.BODY'
,p_message_text=>'Push notifications have to be enabled for each device you want to receive the notifications on. The first time you enable push notifications, you will have to grant permission to your browser. This setting can be changed at any time.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8000520712745470)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.SUBSCRIBE'
,p_message_text=>'Subscribe to push notifications'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8000719340747710)
,p_name=>'APEXAPP.PUSH_NOTIFICATIONS.UNSUBSCRIBE'
,p_message_text=>'Unsubscribe from push notifications'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413316879212963)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_text=>'Access Control'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413226675212963)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_text=>'Access Control Actions'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415092067212962)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_text=>'Access Control Configuration'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413456772212963)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_text=>'ACL Information'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413034463212963)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_text=>'Activity Reports'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404032948212966)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_text=>'Application Administration'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412844202212963)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_text=>'Application Configuration'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414845151212962)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_text=>'Automation Execution'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403184214212967)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411934715212963)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_text=>'Buttons'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403967777212966)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_text=>'Column %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412739423212963)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_text=>'Configuration'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413133018212963)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_text=>'Configure Appearance'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403449366212966)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_text=>'Chart %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412374977212963)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_text=>'Failed Records'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412452710212963)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_text=>'Records Changed by Another User.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412232270212963)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_text=>'Data Load Wizard Progress'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403770336212966)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_text=>'The maximum row count for this report is %0 rows.  Please apply a filter to reduce the number of records in your query.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403677614212966)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_text=>'No data found.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413851964212963)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_text=>'Email Reporting'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415246159212962)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_text=>'Exceptions'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413549369212963)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404331607212966)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_text=>'Feedback Submitted'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414514723212963)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_text=>'Filters'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415772641212962)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_text=>'Form Items Region'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403586638212966)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_text=>'Form on %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415609571212962)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_text=>'Hidden Items'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414065134212963)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_text=>'Hourly Page Events'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412167781212963)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_text=>'Information'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413982678212963)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_text=>'Job Reporting'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413629753212963)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_text=>'Language Selector'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414390978212963)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_text=>'Latest Activity'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414407608212963)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_text=>'No activities found'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412506513212963)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_text=>'Master Records'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414937531212962)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_text=>'Messages'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414184713212963)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_text=>'Most Active Pages'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403887706212966)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_text=>'Page Navigation'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403369901212966)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_text=>'No Record Selected'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412677692212963)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_text=>'No Record Selected'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415405165212962)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_text=>'No Valid Users Exist - Page Info'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415520519212962)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_text=>'No valid new users found'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414212614212963)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_text=>'Recent Errors'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403228094212966)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_text=>'Region Display Selector'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404109187212966)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_text=>'Report'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113403034595212967)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_text=>'Search'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414655699212963)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_text=>'Top Users'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113414766351212963)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_text=>'Top Users Chart'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113404216896212966)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_text=>'%0 Users to Add'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113413714564212963)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_text=>'User Counts Report'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412984394212963)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_text=>'User Interface'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415300955212962)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_text=>'Valid Users Exist - Page Info'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113415103529212962)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_text=>'Wizard Container'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113412023489212963)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_text=>'Wizard Progress'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113432424888212957)
,p_name=>'APEXAPP.RELEASE'
,p_message_text=>'Release %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113429993673212958)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_text=>'Are you sure you want to leave this page without saving?'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410586118212964)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_text=>'%0 row(s) updated.'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292640238737582479)
,p_name=>'APEXAPP.TASK.ASSIGNED_TO_USER'
,p_message_text=>'Assigned to %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7204613406880255)
,p_name=>'APEXAPP.TASK.DETAILS_PAGE_DEVELOPER_INFORMATION'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page shows detailed information for the human task whose ID is passed',
'in to the <strong>Pnn_TASK_ID</strong> page item and is used as boilerplate for you to',
'start building your Task Detail page that your user will use to perform the',
'task. APEX has generated this page for you containing all of the task',
'services available for Human Tasks. These includes services like:</p>',
'',
'<ul>',
'    <li>task claiming, release and delegation</li>',
'    <li>task due dates, expiration, renewal</li>',
'    <li>requesting and providing more information from the originator</li>',
'    <li>task commenting</li>',
'    <li>task history</li>',
'    <li>saving task progress and submitting a complete task</li>',
'</ul>',
'',
'<p>You can delete this region and any task service regions or buttons that',
'are not required for your application. Then add one or more regions that',
'implement the task that the user needs to perform as part of your',
'application. You can do this by adding forms, reports, cards or other APEX',
'region types inside this page - just like you would on a normal page.</p>',
'',
'<p>You will need to make sure that the Page Processing includes processes to',
'update your data into the database. These should be executed on the',
'<strong>Save</strong> and <strong>Complete</strong> buttons. The',
'<strong>Automatic Row Processing</strong> process should occur',
'<strong>before Human Task - Manage</strong> process executes.</p>'))
,p_version_scn=>15475661
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292640348393582484)
,p_name=>'APEXAPP.TASK.DUE_SINCE'
,p_message_text=>'Due %0'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292640408632582485)
,p_name=>'APEXAPP.TASK.HIGH_PRIORITY'
,p_message_text=>'High priority'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292640545797582485)
,p_name=>'APEXAPP.TASK.INITIATED_BY_USER_SINCE'
,p_message_text=>'Initiated by %0 %1'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4202239021858536)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.ALERT.PROVIDE_NEW_PARAM_VALUE'
,p_message_text=>'Please provide a new parameter value'
,p_version_scn=>37165770887536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3511475674170501)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.ALERT.PROVIDE_POTENTIAL_OWNER'
,p_message_text=>'Please provide a new potential owner'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3513219500771817)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.BRANCH.RELOAD_DIALOG'
,p_message_text=>'Reload Dialog'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1628859363744696)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.CONFIRM.CANCEL_TASK'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Do you really want to cancel this task?</p>',
'<p>This will mark the task as no longer needed.</p>'))
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1981189064778542)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.ADD_COMMENT'
,p_message_text=>'Add Comment'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2367949396504124)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.APPLICATION'
,p_message_text=>'Application'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1981300446780994)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.APPROVE'
,p_message_text=>'Approve'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(311444607064787965)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CANCEL_DELEGATE'
,p_message_text=>'Cancel Delegate'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3511214555130416)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CANCEL_INVITE_PARTICIPANT'
,p_message_text=>'Cancel Invite Participant'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001914441616996)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CANCEL_REQUEST_INFORMATION'
,p_message_text=>'Cancel Request Information'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3500491786181014)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CANCEL_SET_DUE_DATE'
,p_message_text=>'Cancel Set Due Date'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1891295010650402)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CANCEL_SET_PRIORITY'
,p_message_text=>'Cancel Set Priority'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3002126852619688)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CANCEL_SUBMIT_INFORMATION'
,p_message_text=>'Cancel Submit Information'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1629136458748384)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CANCEL_TASK'
,p_message_text=>'Cancel Task'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10412716947646910)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CATEGORY'
,p_message_text=>'Category'
,p_version_scn=>15475662
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3500203026176064)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CHANGE_DUE_DATE'
,p_message_text=>'Change Due Date'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1891432895653575)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CHANGE_PRIORITY'
,p_message_text=>'Change Priority'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1891749966656741)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CLAIM'
,p_message_text=>'Claim'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1981577999785130)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CLAIM_TASK'
,p_message_text=>'Claim Task'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5000649139032407)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CLOSE_CANCEL_TASK_DIALOG'
,p_message_text=>'Close Cancel Task Dialog'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1982382248796006)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.COMMENT'
,p_message_text=>'Comment'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6400831322557139)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.COMMENTS_EXPIRED_TASKS'
,p_message_text=>'Include comments from expired tasks'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7400309168161312)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.COMPLETE'
,p_message_text=>'Complete'
,p_version_scn=>15475662
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1986707412841191)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.CREATED'
,p_message_text=>'Created'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1981736427789928)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.DELEGATE'
,p_message_text=>'Delegate'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(411787055578245571)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.DEVELOPER_INFORMATION'
,p_message_text=>'Developer Information'
,p_version_scn=>37166022046028
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(267547169316719121)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.DUE'
,p_message_text=>'Due'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4200941334639378)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.EDIT_PARAMETERS'
,p_message_text=>'Edit Parameters'
,p_version_scn=>37165770887536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(311444565510787965)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.EVENT'
,p_message_text=>'Event'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1903063851416422)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.FORWARD'
,p_message_text=>'Forward'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6400590580543353)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.HISTORY_EXPIRED_TASKS'
,p_message_text=>'Include history from expired tasks'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(267547834178740091)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.INITIATED'
,p_message_text=>'Initiated'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1905431875803582)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.INITIATOR'
,p_message_text=>'Initiator'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3505458898666495)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.INVITE_PARTICIPANT'
,p_message_text=>'Invite Participant'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1904103283617492)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.MATURITY'
,p_message_text=>'Maturity'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1986969768842559)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.MESSAGE'
,p_message_text=>'Message'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3500860301206760)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.NEW_DUE_DATE'
,p_message_text=>'New Due Date'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1982548139798470)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.NEW_OWNER'
,p_message_text=>'New Owner'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3505637234764350)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.NEW_POTENTIAL_OWNER'
,p_message_text=>'New Potential Owner'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1890851040644537)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.NEW_PRIORITY'
,p_message_text=>'New Priority'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4201764039795373)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.NEW_VALUE'
,p_message_text=>'New Value'
,p_version_scn=>37165770887536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292640930691582485)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.NO_TASKS'
,p_message_text=>'No Tasks'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5000488271027900)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.OPEN_CANCEL_TASK_DIALOG'
,p_message_text=>'Open Cancel Task Dialog'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305910060206854961)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.OUTCOME'
,p_message_text=>'Outcome'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292640608567582485)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.OWNER'
,p_message_text=>'Owner'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4201359648772393)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.PARAMETER'
,p_message_text=>'Parameter'
,p_version_scn=>37165770887536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3201310945173102)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.POTENTIAL_OWNER'
,p_message_text=>'Potential Owner'
,p_version_scn=>37165770887536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4200667284048265)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.PRIORITY'
,p_message_text=>'Priority'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1981945852791597)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.REJECT'
,p_message_text=>'Reject'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1982131927794390)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.RELEASE'
,p_message_text=>'Release'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2200293650310453)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.REMOVE_PARTICIPANT'
,p_message_text=>'Remove Participant'
,p_version_scn=>37165770887536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5200236826206240)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.RENEW_TASK'
,p_message_text=>'Renew Task'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001517507605187)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.REQUEST_INFORMATION'
,p_message_text=>'Request Information'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7400518149162678)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.SAVE'
,p_message_text=>'Save'
,p_version_scn=>16749560
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1906395123854468)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.SEARCH'
,p_message_text=>'Search'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2409462116945101)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.SHOW_EXPIRED_TASKS'
,p_message_text=>'Show expired tasks'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1908963761082145)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.SHOW_SUCCESS_MESSAGE'
,p_message_text=>'Show Success Message'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292640798465582485)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.SORT_BY'
,p_message_text=>'Sort by'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1905707086830021)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.STATE'
,p_message_text=>'State'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292640821642582485)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.SUBJECT'
,p_message_text=>'Subject'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001709204610084)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.SUBMIT_INFORMATION'
,p_message_text=>'Submit Information'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(311444446596787963)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.TIME'
,p_message_text=>'Time '
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1987157499843766)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.TYPE'
,p_message_text=>'Type'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4202584259028358)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.UPDATE_PARAMETER'
,p_message_text=>'Update Parameter'
,p_version_scn=>37165770887536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1987339495845158)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LABEL.USER'
,p_message_text=>'User'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1982790485800364)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.CREATED_HOURS.LAST_24_HOURS'
,p_message_text=>'Last 24 hours'
,p_version_scn=>37165770887497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1982906298801836)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.CREATED_HOURS.LAST_30_DAYS'
,p_message_text=>'Last 30 days'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1983179394803596)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.CREATED_HOURS.LAST_7_DAYS'
,p_message_text=>'Last 7 days'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1983349978805109)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.CREATED_HOURS.LAST_HOUR'
,p_message_text=>'Last hour'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1983576113807578)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.CREATED_HOURS.OLDER_THAN_30_DAYS'
,p_message_text=>'Older than 30 days'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1983723981808848)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.DUE_HOURS.MORE_THAN_30_DAYS'
,p_message_text=>'More than 30 days'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1983924651810229)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.DUE_HOURS.NEXT_24_HOURS'
,p_message_text=>'Next 24 hours'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1984128132812015)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.DUE_HOURS.NEXT_30_DAYS'
,p_message_text=>'Next 30 days'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1984374381813404)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.DUE_HOURS.NEXT_7_DAYS'
,p_message_text=>'Next 7 days'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1984545708814906)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.DUE_HOURS.NEXT_HOUR'
,p_message_text=>'Next hour'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1984720901816495)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.DUE_HOURS.OVERDUE'
,p_message_text=>'Overdue'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1904434351688450)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.DUE_HOURS.WITHOUT_DUE_DATE'
,p_message_text=>'No due date'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1984990420821229)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.META.CREATED'
,p_message_text=>'Created %0'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1985181855822922)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.LOV.META.INITIATED_BY'
,p_message_text=>'Initiated by %0'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1985350129825143)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PAGE.TASK_DETAILS'
,p_message_text=>'Task Details'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1985521016831213)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PAGE.UNIFIED_TASK_LIST'
,p_message_text=>'Unified Task List'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1889071057018823)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.APPROVE.SUCCESS_MESSAGE'
,p_message_text=>'Task approved'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1629302081750732)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.CANCEL_TASK.SUCCESS_MESSAGE'
,p_message_text=>'Task canceled'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1889923978048478)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.CLAIM.SUCCESS_MESSAGE'
,p_message_text=>'Task claimed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7401254142291345)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.COMPLETE.SUCCESS_MESSAGE'
,p_message_text=>'Task completed'
,p_version_scn=>15475662
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1889711087044021)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.DELEGATE.SUCCESS_MESSAGE'
,p_message_text=>'Task delegated to %0'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1903544500492459)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.FETCH_TASK_DATA'
,p_message_text=>'Fetch Task Data'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3512622989700974)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.INVITE_PARTICIPANT.SUCCESS_MESSAGE'
,p_message_text=>'Participant %0 added to task as potential owner'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1889471935032217)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.REJECT.SUCCESS_MESSAGE'
,p_message_text=>'Task rejected'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1890171777055128)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.RELEASE.SUCCESS_MESSAGE'
,p_message_text=>'Task released - can now be claimed by others'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3201657204286893)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.REMOVE_PARTICIPANT.SUCCESS_MESSAGE'
,p_message_text=>'Participant %0 removed from task.'
,p_version_scn=>37165770887564
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4801722663690298)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.RENEW_TASK.SUCCESS_MESSAGE'
,p_message_text=>'Task renewed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3002577351630336)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.REQUEST_INFORMATION.SUCCESS_MESSAGE'
,p_message_text=>'Information requested'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3500680163194093)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.SET_DUE_DATE.SUCCESS_MESSAGE'
,p_message_text=>'Task due date updated'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1891018403647255)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.SET_PRIORITY.SUCCESS_MESSAGE'
,p_message_text=>'Task priority changed'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1892291891750987)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.SET_SUCCESS_MESSAGE'
,p_message_text=>'Set Success Message'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3002376478628088)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.SUBMIT_INFORMATION.SUCCESS_MESSAGE'
,p_message_text=>'Information submitted'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4202872384035747)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.PROCESS.UPDATE_PARAMETER.SUCCESS_MESSAGE'
,p_message_text=>'Parameter updated'
,p_version_scn=>37165770887564
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232314808214833098)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.REFRESH_REPORT'
,p_message_text=>'Refresh - %0'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1985785969833120)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.REGION.COMMENTS'
,p_message_text=>'Comments'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1985944806834892)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.REGION.DETAILS'
,p_message_text=>'Details'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1986313195837932)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.REGION.EDIT_TASK'
,p_message_text=>'Edit Task'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1986185759836431)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.REGION.HISTORY'
,p_message_text=>'History'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1986508361839247)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.REGION.OVERVIEW'
,p_message_text=>'Overview'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292641066670582485)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.SORT_ORDER.CREATE_DATE'
,p_message_text=>'Create Date'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(292641169830582486)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.SORT_ORDER.DUE_DATE'
,p_message_text=>'Due Date'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1987500051846951)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.TAB.ADMIN_TASKS'
,p_message_text=>'Admin Tasks'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232314567796797461)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.TAB.ADMIN_TASKS_REGION_NAME'
,p_message_text=>'Admin Tasks - %0'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1987718975848869)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.TAB.INITIATED_BY_ME'
,p_message_text=>'Initiated by Me'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232314357296792572)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.TAB.INITIATED_BY_ME_REGION_NAME'
,p_message_text=>'Initiated by Me - %0'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1987942138850622)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.TAB.MY_TASKS'
,p_message_text=>'My Tasks'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232313849871743269)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.TAB.MY_TASKS_REGION_NAME'
,p_message_text=>'My Tasks - %0'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1988111610852754)
,p_name=>'APEXAPP.UNIFIED_TASK_LIST.TAB.TASK_LISTS'
,p_message_text=>'Task Lists'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27404984473480974)
,p_name=>'APEXAPP.USER_SETTINGS.LIST'
,p_message_text=>'User Settings'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27407142236564058)
,p_name=>'APEXAPP.USER_SETTINGS.LIST_ENTRY'
,p_message_text=>'Settings'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27404021901480973)
,p_name=>'APEXAPP.USER_SETTINGS.PAGE'
,p_message_text=>'Settings'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27404335227480973)
,p_name=>'APEXAPP.USER_SETTINGS.PAGE.HELP'
,p_message_text=>'This page contains a list of settings applicable to the current application user.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27403867154480973)
,p_name=>'APEXAPP.USER_SETTINGS.PAGE_GROUP'
,p_message_text=>'User Settings'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27404648393480974)
,p_name=>'APEXAPP.USER_SETTINGS.REGION'
,p_message_text=>'Settings'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411754308212963)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_text=>'At least One Feedback Required'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411821112212963)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_text=>'Please provide feedback or your experience.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411501684212963)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_text=>'Cannot remove yourself from administrator'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411629599212963)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_text=>'You cannot remove administrator role from yourself.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411082649212964)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_text=>'#COLUMN_HEADER# must be a valid date.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410870015212964)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_text=>'#COLUMN_HEADER# must have a value.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113410935786212964)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_text=>'#COLUMN_HEADER# must be numeric.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411168626212964)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_text=>'#COLUMN_HEADER# must be a valid timestamp value.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409135361212964)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_text=>'%0 must be a valid date'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411394170212964)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_text=>'#LABEL# must be a valid date.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411295228212964)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_text=>'#LABEL# must have some value.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113411471886212964)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_text=>'#LABEL# must be a valid timestamp.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113408936971212964)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_text=>'%0 not null'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409005657212964)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_text=>'%0 must be numeric'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113409237711212964)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_text=>'%0 must be a valid timestamp'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2806737954788203)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.ACTIVITIES'
,p_message_text=>'Activities'
,p_version_scn=>16569763
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2806952591791846)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.ACTIVITIES.NOT_FOUND'
,p_message_text=>'Please select a Workflow in the Overview region to see further details'
,p_version_scn=>16569774
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2805137566739864)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.AVG_COMPLETION_TIME'
,p_message_text=>'Average Completion Time'
,p_version_scn=>16569785
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2803135211662929)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.DETAILS'
,p_message_text=>'Details'
,p_version_scn=>16569796
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2803917880688012)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.INSTANCES'
,p_message_text=>'Instances'
,p_version_scn=>16569806
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2802745255654791)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.OVERVIEW'
,p_message_text=>'Overview'
,p_version_scn=>16569817
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2802954377660573)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.OVERVIEW.SERIES'
,p_message_text=>'Overview Series'
,p_version_scn=>16569827
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2804395452713426)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.PERFORMANCE'
,p_message_text=>'Performance'
,p_version_scn=>16569837
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2807191455798862)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.REFRESH.ACTIVITIES'
,p_message_text=>'Refresh Activities'
,p_version_scn=>16569847
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2805343788748799)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.REFRESH.PERFORMANCE'
,p_message_text=>'Refresh Performance Chart'
,p_version_scn=>16569881
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2804131065698468)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.REFRESH.WORKFLOW.INSTANCES'
,p_message_text=>'Refresh Workflow Per State Details Region'
,p_version_scn=>16569891
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2802491191646987)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.STATE.REGION'
,p_message_text=>'Workflows By State'
,p_version_scn=>16569910
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2804560910716733)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.TIME_UNIT'
,p_message_text=>'Time Unit'
,p_version_scn=>16569930
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600892899879139)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.TIME_UNIT.DAYS'
,p_message_text=>'Days'
,p_version_scn=>16728375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2804727883722296)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.TIME_UNIT.HELP_TEXT'
,p_message_text=>'Select the time unit to display within the Performance chart.'
,p_version_scn=>16569940
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3601056982881447)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.TIME_UNIT.HOURS'
,p_message_text=>'Hours'
,p_version_scn=>16728413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600460923876224)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.TIME_UNIT.MINS'
,p_message_text=>'Minutes'
,p_version_scn=>16728345
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600686130878160)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.TIME_UNIT.SEC'
,p_message_text=>'Seconds'
,p_version_scn=>16728362
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2803789250686008)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.WORKFLOWS'
,p_message_text=>'Workflows'
,p_version_scn=>16569964
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2806187779771245)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.WORKFLOWS.ACTIVE.NOT_FOUND'
,p_message_text=>'No Active Workflows found'
,p_version_scn=>16569975
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2804988203735908)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.WORKFLOWS.COMPLETED.NOT_FOUND'
,p_message_text=>'No Completed or Terminated Workflows found'
,p_version_scn=>16569985
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2806327954774036)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.WORKFLOWS.FAULTED.NOT_FOUND'
,p_message_text=>'No Faulted Workflows found'
,p_version_scn=>16569995
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2803379630667811)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.WORKFLOWS.NOT_FOUND'
,p_message_text=>'Please select a workflow state in the Overview chart to see further details'
,p_version_scn=>16570010
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2803550971681614)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.WORKFLOWS.STATE'
,p_message_text=>'Instances Per Workflow'
,p_version_scn=>16569715
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2806567782779243)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.WORKLOAD'
,p_message_text=>'Workflows'
,p_version_scn=>16570019
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2805734433762117)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.WORKLOAD.ACTIVE'
,p_message_text=>'Active Workflows'
,p_version_scn=>16570055
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2805904776765214)
,p_name=>'APEXAPP.WORKFLOW_CHARTS.WORKLOAD.FAULTED'
,p_message_text=>'Faulted Workflows'
,p_version_scn=>16570071
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2801935810630110)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.CONTEXT.ADMIN_WORKFLOWS'
,p_message_text=>'Admin Workflows'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2801537499627741)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.CONTEXT.ADMIN_WORKFLOWS_REGION_NAME'
,p_message_text=>'Admin Workflows - %0'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2803575589727860)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.CONTEXT.INITIATED_BY_ME'
,p_message_text=>'Initiated by Me'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2803326010726356)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.CONTEXT.INITIATED_BY_ME_REGION_NAME'
,p_message_text=>'Initiated by Me - %0'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2802908198690464)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.CONTEXT.MY_WORKFLOWS'
,p_message_text=>'My Workflows'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2802708471688813)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.CONTEXT.MY_WORKFLOWS_REGION_NAME'
,p_message_text=>'My Workflows - %0'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179934550727285810)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.DUE_SINCE'
,p_message_text=>'Due %0'
,p_version_scn=>37165931724634
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4218286590926689)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.INITIATED_BY_USER_SINCE'
,p_message_text=>'Initiated by %0 %1'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600523313648827)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.ACTIVITIES'
,p_message_text=>'Activities'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4400865539466560)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.ACTIVITY_AUDIT'
,p_message_text=>'Activity Audit'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3200869218014433)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.APPLICATION'
,p_message_text=>'Application'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4800272533485456)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.CANCEL_ACTIVITY_AUDIT'
,p_message_text=>'Cancel Activity Audit'
,p_version_scn=>38949913
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4601452028056396)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.CANCEL_DIALOG'
,p_message_text=>'Cancel Dialog'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4402715488548203)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.CANCEL_EDIT_VARIABLE'
,p_message_text=>'Cancel Edit Variable'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4800410522487829)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.DISABLE_ENABLE_UPDATE_BUTTON'
,p_message_text=>'Disable/Enable Update Button'
,p_version_scn=>39427470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4401233637481340)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.EDIT_VARIABLE'
,p_message_text=>'Edit Variable'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4401885983499155)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.HISTORY'
,p_message_text=>'History'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3201222032030845)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.INITIATED'
,p_message_text=>'Initiated'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3201012280022005)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.INITIATOR'
,p_message_text=>'Initiator'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4401484600486189)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.NEW_VALUE'
,p_message_text=>'New Value'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3201443703038979)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.NO_WORKFLOWS'
,p_message_text=>'No Workflows'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4401620625493556)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.PARAMETERS'
,p_message_text=>'Parameters'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3201863209068385)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.RESUME'
,p_message_text=>'Resume'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4402282281513365)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.RETRY'
,p_message_text=>'Retry'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3000292601966959)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.SEARCH'
,p_message_text=>'Search'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3400684186420703)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.SHOW_SUCCESS_MESSAGE'
,p_message_text=>'Show Success Message'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3202285360085800)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.SORT_BY'
,p_message_text=>'Sort By'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3000889262986148)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.STATE'
,p_message_text=>'State'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3401661172571949)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.STATUS'
,p_message_text=>'Status'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3401437010552294)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.SUBJECT'
,p_message_text=>'Subject'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4402078452504776)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.SUSPEND'
,p_message_text=>'Suspend'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3202082015075313)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.TERMINATE'
,p_message_text=>'Terminate'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3000668901976761)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.TYPE'
,p_message_text=>'Type'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4601634154069582)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.UPDATE_VARIABLE'
,p_message_text=>'Update Variable'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4401013780469774)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.VARIABLE'
,p_message_text=>'Variable'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4849780254887925)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.VARIABLES'
,p_message_text=>'Variables'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2599759572565449)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LABEL.WORKFLOW_DIAGRAM'
,p_message_text=>'Workflow Diagram'
,p_version_scn=>120639943
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4746203053824892)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LOV.CREATED_HOURS.LAST_24_HOURS'
,p_message_text=>'Last 24 hours'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4746619294829138)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LOV.CREATED_HOURS.LAST_30_DAYS'
,p_message_text=>'Last 30 days'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4746417810827109)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LOV.CREATED_HOURS.LAST_7_DAYS'
,p_message_text=>'Last 7 days'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4746013897819423)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LOV.CREATED_HOURS.LAST_HOUR'
,p_message_text=>'Last hour'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4747027770845041)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.LOV.CREATED_HOURS.OLDER_THAN_30_DAYS'
,p_message_text=>'Older than 30 days'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3201641702059778)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.PAGE.WORKFLOW_DETAILS'
,p_message_text=>'Workflow Details'
,p_version_scn=>38788293
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3400809349475282)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.PROCESS.RESUME.SUCCESS_MESSAGE'
,p_message_text=>'Workflow resumed'
,p_version_scn=>38788294
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4602266761186467)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.PROCESS.RETRY.SUCCESS_MESSAGE'
,p_message_text=>'Workflow retried'
,p_version_scn=>38788294
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4602090432160874)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.PROCESS.SUSPEND.SUCCESS_MESSAGE'
,p_message_text=>'Workflow suspended'
,p_version_scn=>38788294
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3401090461479147)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.PROCESS.TERMINATE.SUCCESS_MESSAGE'
,p_message_text=>'Workflow terminated'
,p_version_scn=>38788294
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4601852481147222)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.PROCESS.UPDATE_VARIABLE.SUCCESS_MESSAGE'
,p_message_text=>'Variable updated'
,p_version_scn=>38788294
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3401218819499727)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.REFRESH_REPORT'
,p_message_text=>'Refresh - %0'
,p_version_scn=>38788294
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7401573962586565)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.RETRY_COUNT.EQUALS_ONE'
,p_message_text=>'%0 retry'
,p_version_scn=>37165931724634
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7401758476594787)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.RETRY_COUNT.NOT_EQUALS_ONE'
,p_message_text=>'%0 retries'
,p_version_scn=>37165931724634
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3400210724401497)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.SORT_ORDER.CREATE_DATE'
,p_message_text=>'Create Date'
,p_version_scn=>38788294
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3400410238405537)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.SORT_ORDER.LAST_UPDATE'
,p_message_text=>'Last Update'
,p_version_scn=>38788294
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7401311218568069)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.STATE.COMPLETED'
,p_message_text=>'Completed'
,p_version_scn=>40822828
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7401100566565462)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.STATE.STARTED'
,p_message_text=>'Started'
,p_version_scn=>40822828
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224813209699307601)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.STATE_DISPLAY.COMPLETED_SINCE'
,p_message_text=>'Completed %0'
,p_version_scn=>37165963229390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224813154143307601)
,p_name=>'APEXAPP.WORKFLOW_CONSOLE.STATE_DISPLAY.STARTED_SINCE'
,p_message_text=>'Started %0'
,p_version_scn=>37165963229390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4043614693658048)
,p_name=>'APEXDEV.CREATE_APP_STATIC_FILE'
,p_message_text=>'Create Application Static File'
,p_version_scn=>475806000
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4043809597661899)
,p_name=>'APEXDEV.CREATE_WS_STATIC_FILE'
,p_message_text=>'Create Workspace Static File'
,p_version_scn=>475806263
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2088189729524976)
,p_name=>'APEXDEV.DBMS_CLOUD_INT.NO_DBMS_CLOUD'
,p_message_text=>'The DBMS_CLOUD package is not available on this system.'
,p_version_scn=>8581224
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2088305196526475)
,p_name=>'APEXDEV.DBMS_CLOUD_INT.NO_DBMS_CLOUD_ACCESS'
,p_message_text=>'Missing EXECUTE privilege on the DBMS_CLOUD package.'
,p_version_scn=>8581253
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3685697291162365)
,p_name=>'APEXDEV.DIFF.ADDED'
,p_message_text=>'%0 Added'
,p_version_scn=>48450708
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(413960891492883975)
,p_name=>'APEXDEV.DIFF.AUDIT_COMMENT'
,p_message_text=>'Components merged: %1, Working copy: %2, Elapsed time: %3 sec'
,p_version_scn=>37166027867738
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488343868872854461)
,p_name=>'APEXDEV.DIFF.AUDIT_COMMENT_REFRESH'
,p_message_text=>'Refreshed from Main. Components merged: %1, Elapsed time: %3 sec'
,p_version_scn=>37166027868205
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1794326996031927)
,p_name=>'APEXDEV.DIFF.BACKUP_APP'
,p_message_text=>'Automatic backup before merging changes from app ID: %0 into app ID: %1'
,p_version_scn=>42339255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3685433316161412)
,p_name=>'APEXDEV.DIFF.CHANGED'
,p_message_text=>'%0 Changed'
,p_version_scn=>48450730
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3771729412977828)
,p_name=>'APEXDEV.DIFF.EXPORTS_COMPLETED'
,p_message_text=>'Finishing up'
,p_version_scn=>42339255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3771361391947626)
,p_name=>'APEXDEV.DIFF.EXPORT_APP'
,p_message_text=>'Exporting: %0 application'
,p_version_scn=>45796352
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2705597105612308)
,p_name=>'APEXDEV.DIFF.INFO_LINK_TEXT'
,p_message_text=>'More information'
,p_version_scn=>48302664
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2705756668641183)
,p_name=>'APEXDEV.DIFF.INFO_MESSAGE'
,p_message_text=>'%0 changes detected. <strong>Note:</strong> there might be modifications to your application that cannot be merged.'
,p_version_scn=>51195396
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4571990994936512)
,p_name=>'APEXDEV.DIFF.MAIN'
,p_message_text=>'Main'
,p_version_scn=>42339255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3685821666164730)
,p_name=>'APEXDEV.DIFF.MISSING'
,p_message_text=>'%0 Missing'
,p_version_scn=>48450758
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014455144085190)
,p_name=>'APEXDEV.DIFF.PAGE_HEADER_COMPARE'
,p_message_text=>'Compare <span class="workingCopyName">%0</span> with %1'
,p_version_scn=>48302783
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783679057409828)
,p_name=>'APEXDEV.DIFF.PAGE_HEADER_MERGE'
,p_message_text=>'Merge <span class="workingCopyName">%0</span> into %1'
,p_version_scn=>48302807
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2704117323419116)
,p_name=>'APEXDEV.DIFF.PAGE_HEADER_REFRESH'
,p_message_text=>'Refresh <span class="workingCopyName">%1</span> from %0'
,p_version_scn=>53600843
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1796022725512810)
,p_name=>'APEXDEV.DIFF.PAGE_IS_LOCKED_ERROR'
,p_message_text=>'Page %0 is locked in %1 by %2'
,p_version_scn=>100515159
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4572139511938946)
,p_name=>'APEXDEV.DIFF.WORKING_COPY'
,p_message_text=>'Working Copy'
,p_version_scn=>42339255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3089644060501208)
,p_name=>'APEXDEV.DIFF.WORKING_COPY.COUNT'
,p_message_text=>'%0 Working Copy'
,p_version_scn=>57325803
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1440542402676692)
,p_name=>'APEXDEV.DIFF.WORKING_COPY.COUNT.PLURAL'
,p_message_text=>'%0 Working Copies'
,p_version_scn=>57325735
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1803166797376553)
,p_name=>'APEXDEV.DOWNLOAD.DATATYPE_NOT_SUPPORTED'
,p_message_text=>'Datatype not supported. Only BLOB, CLOB or VARCHAR2 columns are supported.'
,p_version_scn=>5717790
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1803332419377880)
,p_name=>'APEXDEV.DOWNLOAD.PROCESS_NOT_SUPPORTED'
,p_message_text=>'The Download process type is exclusively supported in the ''Before Header'' position during Page Rendering or in Page Processing when the page-level attribute ''Reload on Submit'' is configured as ''Always''. To achieve the desired functionality, consider '
||'utilizing the Download dynamic action as an alternative instead of relying on a page process.'
,p_version_scn=>5717801
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1408633006034984)
,p_name=>'APEXDEV.ICON_LABEL.IMAGE_FILE'
,p_message_text=>'Image file'
,p_version_scn=>472692045
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1408828712040153)
,p_name=>'APEXDEV.ICON_LABEL.OTHER_FILE'
,p_message_text=>'Other file'
,p_version_scn=>472692886
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(283307935221129307)
,p_name=>'APEXDEV.ICON_LABEL.SUCCESS'
,p_message_text=>'Success'
,p_is_js_message=>true
,p_version_scn=>453707698
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(283307419377127780)
,p_name=>'APEXDEV.ICON_LABEL.WARNING'
,p_message_text=>'Warning'
,p_is_js_message=>true
,p_version_scn=>37166015446655
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(873307975274722518)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_text=>'Interactive Grid Column ''%0'' specified for Dynamic Action ''#COMPONENT_NAME#'' does not exist.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(879103136883340544)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_text=>'Process ''%0'' raised ''%1'' while performing row locking. This error can occur when the process issues a SELECT FOR UPDATE on a complex view with an instead-of trigger, to lock the row. Set the process attribute ''Lock Row'' to No or PL/SQL Code.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(879102909220329261)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_text=>'Process ''%0'' raised ''%1'' while executing a DML command. This error can occur if a column is based on an aggregation or SQL expression. Set column attribute ''Query Only'' to Yes to exclude the column from the INSERT and UPDATE statement.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(497340504568985648)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_text=>'The master detail column ''%0'' does not contain a value. Please make sure that the process ''%1'' is executed after the corresponding process of the master region.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(727791972487724320)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_text=>'Interactive Grid ''%0'' doesn''t have a master column defined which is required for a master detail relationship.'
,p_version_scn=>37165770887498
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(268382530378995588)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_text=>'Interactive Grid ''%0'' doesn''t have a primary key column defined which is required for editing or in a master detail relationship.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(651045564097108671)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_text=>'For an Editable Interactive Grid, the Page attribute ''Reload on Submit'' must be set to ''Only for Success''.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7214182808225809)
,p_name=>'APEXDEV.INVOKE_API.FUNCTION_RESULT'
,p_message_text=>'Function Result'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30120850470397800)
,p_name=>'APEXDEV.OBJECT_DEPENDENCIES.UNSUPPORTED'
,p_message_text=>'Warning: analysis of code using %0 not yet supported.'
,p_version_scn=>29178514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12172284545201942)
,p_name=>'APEXDEV.OBJECT_DEPENDENCIES.UNSUPPORTED_EXPRESSION'
,p_message_text=>'Warning: analysis of code using Column SQL Expressions not yet supported.'
,p_version_scn=>38983444
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612409860626451489)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_text=>'Code Editor: %0'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612410174397451493)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_text=>'Collapse %0'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612410430905451493)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_text=>'Color Picker: %0'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612410719592451494)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_text=>'Edit Component'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612411000391451494)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_text=>' (Error)'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612411384203451494)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_text=>'Expand %0'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612409685614451487)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_text=>'Filter'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612411648032451494)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_text=>'No results found.'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612411956862451495)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_text=>'No results found. Try searching all properties by clicking the ''Show All'' button above.'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612412238896451495)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_text=>'Filter Properties'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612412578032451495)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_text=>'%0 (Invalid)'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4435411486753472)
,p_name=>'APEXDEV.PE.INVALID_GRAPH_NAME'
,p_message_text=>'The property graph %0 does not exist.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6601296965619661)
,p_name=>'APEXDEV.PE.INVALID_METHOD_NAME1'
,p_message_text=>'The function or procedure %0 in package %1 does not exist.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6601495027623201)
,p_name=>'APEXDEV.PE.INVALID_METHOD_NAME2'
,p_message_text=>'The stored function or procedure %0 does not exist.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6800390708839639)
,p_name=>'APEXDEV.PE.INVALID_PACKAGE_NAME'
,p_message_text=>'The package %0 does not exist.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612412877049451495)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_text=>'List of Values: %0'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612413190550451496)
,p_name=>'APEXDEV.PE.NO'
,p_message_text=>'No'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612413450988451496)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_text=>'The selected components have no properties in common.'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612417086929451499)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_text=>'No components currently selected'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612413717105451496)
,p_name=>'APEXDEV.PE.PICK'
,p_message_text=>'Pick %0'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612414096872451497)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_text=>'Pin Filter'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612414346715451497)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_text=>'Quick Pick: %0'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612414646064451497)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_text=>'Clear Selection'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612414910864451497)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_text=>'Required'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612415246651451498)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_text=>'Search'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612415566399451498)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_text=>'- Select -'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612415880557451498)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_text=>' (Value Varies)'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612416193276451498)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_text=>'Warning'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612416484511451499)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_text=>' (Warning)'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612416741449451499)
,p_name=>'APEXDEV.PE.YES'
,p_message_text=>'Yes'
,p_is_js_message=>true
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1404503700241713)
,p_name=>'APEXDEV.PRINT_REPORT.PROCESS_NOT_SUPPORTED'
,p_message_text=>'The Print Report process type is exclusively supported in the ''Before Header'' position during Page Rendering or in Page Processing when the page-level attribute ''Reload on Submit'' is configured as ''Always''. To achieve the desired functionality, consi'
||'der utilizing the Print Report dynamic action as an alternative instead of relying on a page process.'
,p_version_scn=>32255563
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4044020048680152)
,p_name=>'APEXDEV.STATIC_APP_FILE_ACTIONS'
,p_message_text=>'Static application file actions'
,p_version_scn=>475812799
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4044268184685965)
,p_name=>'APEXDEV.STATIC_WS_FILE_ACTIONS'
,p_message_text=>'Static workspace file actions'
,p_version_scn=>475813993
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(651047747543155674)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_text=>'For a Tabular Form, the Page attribute ''Reload on Submit'' must be set to ''Always''.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6801557010052339)
,p_name=>'APEXDEV.TEMPLATE_COMPONENT.PK_REQUIRED'
,p_message_text=>'A primary key is required for displaying media as part of the "%0" Template Component.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9600737088997323)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.INVALID_PLACEHOLDER_NAME'
,p_message_text=>'"%0" is an invalid placeholder name.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110951881565404586)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.MAX_SELF_APPLIED'
,p_message_text=>'The "%0" Template Component keeps applying itself.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800659889442686)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.MISSING_ARGUMENT'
,p_message_text=>'Missing "%0" argument in the template.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2102963056373576)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.MISSING_END_TOKEN'
,p_message_text=>'Missing "%0" in the template.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5201590669039291)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.PLACEHOLDER_NOT_DEFINED'
,p_message_text=>'Placeholder "%0" is not defined in the "%1" Template Component.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10005055326610040)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.REQUIRED_PLACEHOLDER_IS_MISSING'
,p_message_text=>'Placeholder "%0" is required in order to apply the "%1" Template Component.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5201126270989200)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.TEMPLATE_NOT_FOUND'
,p_message_text=>'Template Component "%0" not found.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2102346846355687)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.TOKEN_UNEXPECTED'
,p_message_text=>'Unexpected "%0" in the template.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2103832091503645)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.TOKEN_UNEXPECTED_AFTER'
,p_message_text=>'Unexpected "%0" after "%1" in the template.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5481791421095679)
,p_name=>'APEXDEV.TEMPLATE_DIRECTIVE.UNEXPECTED_ARGUMENT'
,p_message_text=>'Unexpected "%0" argument in the template.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3617614094693068)
,p_name=>'APEXDEV.TEMPLATE_WORKSPACE'
,p_message_text=>'Workspace'
,p_version_scn=>465446364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7223597401931205)
,p_name=>'APEXDEV.THEME.SWITCH.FAILED'
,p_message_text=>'Theme Switch failed.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7203680098369584)
,p_name=>'APEXDEV.THEME.SWITCH.TMPL_ATTR_ERROR'
,p_message_text=>'Cannot Switch Template Component "%0". Custom Attribute "%1" is not equal due to the Name, Sequence, or Type in Theme %2.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3456762454183373)
,p_name=>'APEXDEV.THEME.SWITCH.TMPL_ATTR_REQUIRED'
,p_message_text=>'Cannot Switch Template Component "%0". Custom Attribute "%1" is required in Theme %2.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601134037315465)
,p_name=>'APEXDEV.WORKING_ENVIRONMENT'
,p_message_text=>'Working Environment'
,p_version_scn=>7355608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(545782169043116383)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_text=>'Region Static ID must be specified as the page contains multiple Interactive Grids.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(67560903880357065)
,p_name=>'APEXIR_3D'
,p_message_text=>'3D'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112052218889463208)
,p_name=>'APEXIR_ADD'
,p_message_text=>'Add'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(444781311433192374)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_text=>'Add Subscription'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147600119386132087)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_text=>'Aggregates are displayed after each control break and at the end of the report.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121294162436905517)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_text=>'Count Distinct'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112079230934911338)
,p_name=>'APEXIR_AGG_MODE'
,p_message_text=>'Mode'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644585214705381401)
,p_name=>'APEXIR_AREA'
,p_message_text=>'Area'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(439756463016811486)
,p_name=>'APEXIR_BLACK'
,p_message_text=>'Black'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112498219214129041)
,p_name=>'APEXIR_CALENDAR'
,p_message_text=>'Calendar'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136484730494817722)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_text=>'Column Heading'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(791245704267305762)
,p_name=>'APEXIR_DAY'
,p_message_text=>'Day'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113562124088824615)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_text=>'Delete Checked'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147696903858581672)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_text=>'Would you like to perform this delete action?'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141701322705830797)
,p_name=>'APEXIR_DISABLE'
,p_message_text=>'Disable'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(67616512564286660)
,p_name=>'APEXIR_DISPLAY'
,p_message_text=>'Display'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(57099547077721312)
,p_name=>'APEXIR_DONUT'
,p_message_text=>'Donut'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6902576875804404)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_text=>'Data Only'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(67562512107378287)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_text=>'- Do not aggregate -'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623927411493897229)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_text=>'Edit Alternative Default'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141700107467826356)
,p_name=>'APEXIR_ENABLE'
,p_message_text=>'Enable'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147667208426412771)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_text=>'Unable to perform flashback request'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(411213431260597045)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_text=>'Function Column %0'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(439756626969811971)
,p_name=>'APEXIR_GRAY'
,p_message_text=>'Gray'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(55272404660857836)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_text=>'Highlight When'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(362416425067891251)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_text=>'Label Prefix'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(419523509375811302)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_text=>'Please click <a href=''%0''>here</a> to manage your subscription.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147809928997853860)
,p_name=>'APEXIR_MORE_DATA'
,p_message_text=>'More Data'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(63857427647172147)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_text=>'- New Category -'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113562810367830112)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_text=>'No aggregation defined.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92168806416507513)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_text=>'No column information available.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113563622141833542)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_text=>'No computation defined.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(791245424915302275)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_text=>'- No End Date -'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613435287230446315)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_text=>'Please select different row column.  The HTML expression or link in the row column contains column defined as pivot or aggregate column.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112052717597519521)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_text=>'Remove Aggregate'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(327439527633801368)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_text=>'The number of display columns in the report reached the limit.  Please click Select Columns under Actions menu to minimize the report display column list.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(103919323340917461)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_text=>'Row Order'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6748409827923181)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_text=>'The number of display columns in the report reached the limit.  Please click Select Columns under Actions menu to minimize the report display column list.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113540030003703334)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_text=>'Save as Default'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(56145302739843998)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_text=>'- Select Category -'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148092507292405773)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_text=>'Computed columns are prefixed with **.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(791243729239265742)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_text=>'- Select Sort Column -'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147809506488847342)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_text=>'Select Value'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(791241818157262484)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_text=>'Sort Column %0'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(408433823707074435)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_text=>'Ending Unit'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147668206479421636)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_text=>'Unauthorized'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139688810701818118)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_text=>'Column Heading must be unique.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(791246325392311859)
,p_name=>'APEXIR_WEEK'
,p_message_text=>'Week'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5726119032631729)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_text=>'Oracle APEX Administration Services'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(624801124779296459)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_text=>'There is no authentication configured for this application.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164806130198109254)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_text=>'The following database objects will be %0 into the selected schema:'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164812283120259655)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_text=>'The following database objects were successfully %0:'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(502640933259223682)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_text=>'Scroll down'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(502641259368224775)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_text=>'Scroll to top'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8485712413560636)
,p_name=>'APEX_WIZARD_FORM'
,p_message_text=>'Navigation Form'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623926632702884462)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_text=>'Edit Row'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295234610322901649)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_text=>'Invalid Objects'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(820480710316844869)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_text=>'No peer pages exist'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(628754359011688580)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_text=>'Objects to create'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(628832820607735495)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_text=>'Delete from Tables'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(628883040615235507)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_text=>'Drop Objects'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(456465923849355411)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_text=>'Object Name'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(456466728005356617)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_text=>'Object Type'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(456463701077329978)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_text=>'Schema'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(628753580952682996)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_text=>'Existing objects to be used'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25119900774841915)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_text=>'Application Computations'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25119502543795150)
,p_name=>'APPLICACTION_PROCESS'
,p_message_text=>'Application Processes'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(276935211336777527)
,p_name=>'APPLICATION'
,p_message_text=>'Application'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359248313170152671)
,p_name=>'APPLICATION BUILDER'
,p_message_text=>'App Builder'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192771330479976314)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_text=>'Application Computation Condition'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(193925322687230689)
,p_name=>'APPLICATION IMAGE'
,p_message_text=>'Application Image'
,p_version_scn=>37165770887500
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192771710178979905)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_text=>'Application Process Condition'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160743812928269079)
,p_name=>'APPLICATIONS'
,p_message_text=>'applications'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254103219723839878)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_text=>'Applications'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184171506479952922)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_text=>'Application Activity'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204326431260698780)
,p_name=>'APPLICATION_ALIAS'
,p_message_text=>'Application Alias'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201888924075925886)
,p_name=>'APPLICATION_DELETED'
,p_message_text=>'Application Deleted'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5715305985486099)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_text=>'Application Development'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203483230134875810)
,p_name=>'APPLICATION_HELP'
,p_message_text=>'Identifies Application.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183997123759605032)
,p_name=>'APPLICATION_ID'
,p_message_text=>'Application Number'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137890104814220249)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_text=>'Application ID is reserved.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137688617384138471)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_text=>'Application ID must be a positive, whole number.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(486385824784572064)
,p_name=>'APPLICATION_IMAGES'
,p_message_text=>'Application Images'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244155829077041830)
,p_name=>'APPLICATION_ITEM'
,p_message_text=>'Application Item'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34139202594701700)
,p_name=>'APPLICATION_ITEMS'
,p_message_text=>'Application Items'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23824317961115621)
,p_name=>'APPLICATION_LABEL'
,p_message_text=>'Application: %0'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204325926066697215)
,p_name=>'APPLICATION_NAME'
,p_message_text=>'Application Name'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(820473101406548964)
,p_name=>'APPLICATION_NAMES'
,p_message_text=>'Application Names'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(315871028643575093)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_text=>'Application Override ID'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201792407780421040)
,p_name=>'APPLICATION_OWNER'
,p_message_text=>'Application Owner'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(820472102875530500)
,p_name=>'APPLICATION_PAGES'
,p_message_text=>'Application Pages'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72038406986033206)
,p_name=>'APPLICATION_SETTINGS'
,p_message_text=>'Application Settings'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201793217823423985)
,p_name=>'APPLICATION_STATUS'
,p_message_text=>'Application Status'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(282817600879195063)
,p_name=>'APPLICATION_VERSION'
,p_message_text=>'Application Version'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11212531906149315)
,p_name=>'APPLICATION_X'
,p_message_text=>'Application %0'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176999305714750057)
,p_name=>'APPROVED'
,p_message_text=>'Approved'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(209403007313600972)
,p_name=>'APP_SUCCESS_MSG'
,p_message_text=>'The application has been successfully created.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(836388413761993110)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_text=>'Template Application'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22592528732319119)
,p_name=>'APP_TYPE_DATABASE'
,p_message_text=>'Application'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22593232542320275)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_text=>'Productivity or Sample Application'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176657314673029861)
,p_name=>'ARCHIVED'
,p_message_text=>'Archived'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23929717128314457)
,p_name=>'ARCHIVELOG'
,p_message_text=>'Log Archiving: On'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114403831934115900)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_text=>'Arguments Must Have Checksum'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145291012953055509)
,p_name=>'ARGUMENT_NAME'
,p_message_text=>'Argument Name'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145291931654060896)
,p_name=>'ARGUMENT_TYPE'
,p_message_text=>'Argument Type'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172768009090484269)
,p_name=>'ASAP'
,p_message_text=>'As soon as possible'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171872404945931328)
,p_name=>'ASSIGNED'
,p_message_text=>'Assigned'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(68117228795073143)
,p_name=>'ASSIGNEE'
,p_message_text=>'Assignee'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(969138433284014825)
,p_name=>'ASSIGN_LABEL'
,p_message_text=>'Assign  %0'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88270128342698420)
,p_name=>'ASSOCIATED'
,p_message_text=>'associated'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(70744921953402322)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_text=>'Associated Features'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184527917540507627)
,p_name=>'ATTACHMENT'
,p_message_text=>'Attachment'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1116469627795891689)
,p_name=>'AT_RISK_LABEL'
,p_message_text=>'At Risk'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84980113452412986)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_text=>'You are about to migrate this application''s custom authentication options to an authentication scheme.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84975628165379446)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_text=>'Current Authentication Method'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84979308473402072)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_text=>'Custom Authentication Function'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84977318253386052)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_text=>'Login Page'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84978925657397584)
,p_name=>'AUTH.LOGIN_URL'
,p_message_text=>'Login URL'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84978002454390895)
,p_name=>'AUTH.NONE'
,p_message_text=>'none'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86590502377236028)
,p_name=>'AUTHENTICATION'
,p_message_text=>'Authentication'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192776815943047895)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_text=>'Authentication Function'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192775618929039286)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_text=>'Authentication Scheme'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87208221048414695)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_text=>'You are about to delete an authentication scheme from application %0. If the application is not currently using SCHEME authentication or if the scheme is not the current authentication scheme, deleting the scheme has no effect on the operation of the'
||' application. If the application is using SCHEME authentication and this is the current authentication scheme, the application will continue to run using SCHEME authentication, but with a default authentication scheme. This will use a built-in login '
||'page with "open door" credentials verification (that is, anyone will be allowed to run the application). '
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87889804014093209)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_text=>'Click the Make Current button to have your application use this authentication scheme.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(363427413736982258)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_text=>'Oracle APEX Accounts'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4770420113873080)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_text=>'Oracle Cloud Identity Management'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(363435219276983864)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_text=>'Custom'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(363483002438988511)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_text=>'No Authentication'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(363443124471985374)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_text=>'Database Accounts'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1784899136475230)
,p_name=>'AUTHENTICATION_NAME.NATIVE_EXTENSION'
,p_message_text=>'Builder Extension Sign-In'
,p_version_scn=>19403533
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(556006715508818492)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_text=>'HTTP Header Variable'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(363511814559991981)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_text=>'Oracle Application Server Single Sign-On'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(363462329319986727)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_text=>'LDAP Directory'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(363499006940989801)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_text=>'Open Door Credentials'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1382586340020134)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_text=>'SAML Sign-In'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15243204618976010)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_text=>'Social Sign-In'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244213402938372976)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_text=>'Authentication Scheme'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192775001960034392)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4774527732875201)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_text=>'Oracle Cloud Identity Management'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11261109462457047)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_text=>'Exists SQL Query'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11261314310458385)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_text=>'PL/SQL Function Returning Boolean'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135867122178687109)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_text=>'Is In Role or Group'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135867319806688244)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_text=>'Is Not In Role or Group'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11261519158459818)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_text=>'Value of Item in Expression 1 Equals Expression 2'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11261724007461158)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_text=>'Item in Expression1 is NOT NULL'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11262006822465716)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_text=>'Item in Expression 1 is NULL'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11262210632466812)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_text=>'Value of Item in Expression 1 Does NOT Equal Expression 2'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11262414441467901)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_text=>'NOT Exists SQL Query'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11262618943469182)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_text=>'Value of Preference in Expression 1 Equals Expression 2'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11262823099470416)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_text=>'Value of Preference in Expression 1 Does NOT Equal Expression 2'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25598506881464331)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_text=>'Evaluate for every page view'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25598915885466909)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_text=>'Evaluate once per session'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12752907900044741)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_text=>'Account Expired'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12752503051043328)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_text=>'Account Locked'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12754102836052690)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_text=>'Maximum Login Attempts Exceeded'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12754509762054706)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_text=>'Unknown Internal Error'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12753725561049781)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_text=>'Password First Use'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12753318289047745)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_text=>'Incorrect Password'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12751723006039634)
,p_name=>'AUTH_SUCCESS'
,p_message_text=>'Normal, successful authentication'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12752130279041717)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_text=>'Unknown User Name'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42835024888575920)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_text=>'Unknown Workspace Name'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46712915547065819)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_text=>'Unknown Workspace Name: %0'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106601517552404527)
,p_name=>'AUTOCOMMIT'
,p_message_text=>'Commit statement not applicable.  All statements are automatically committed.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561323515570939404)
,p_name=>'AUTOMATIONS'
,p_message_text=>'Automation'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561324058485973047)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_text=>'Automation Action'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254984219822103682)
,p_name=>'AUTOPROVISION_MODE'
,p_message_text=>'Provisioning Mode'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3611510058039936)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_text=>'First Item'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290093313947238895)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_text=>'Availability'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14633025624668156)
,p_name=>'AVAILABLE'
,p_message_text=>'Available'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(402732328872676693)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_text=>'Available to Developers Only'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(402716131434667851)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_text=>'Available with Developer Toolbar'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184176217280135809)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_text=>'Average Rendering Time (Seconds)'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175289809867113949)
,p_name=>'BAR_CHART'
,p_message_text=>'Bar Chart'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471700515483089456)
,p_name=>'BASIC'
,p_message_text=>'Basic'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19748000349798134)
,p_name=>'BASIC_DEVELOPER'
,p_message_text=>'Basic Developer'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166096519250032238)
,p_name=>'BEFORE'
,p_message_text=>'Before'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(858434258584172426)
,p_name=>'BEFORE LIST ENTRY'
,p_message_text=>'Before List Entry'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(946323974268547532)
,p_name=>'BEFORE_FIRST'
,p_message_text=>'Before First'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194638714428741225)
,p_name=>'BIND_LABEL'
,p_message_text=>'Bind Label'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194225607253578559)
,p_name=>'BIND_VARIABLE'
,p_message_text=>'Bind Variable'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194226113964589955)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_text=>'Bind Variable Label'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(211008925787727306)
,p_name=>'BLACK_TEXT'
,p_message_text=>'Black Text'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5910016279942038)
,p_name=>'BLANK'
,p_message_text=>'Blank'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184523023896443249)
,p_name=>'BLOB_COLUMN'
,p_message_text=>'BLOB Column'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317487424096621745)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_text=>'Download'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22989702805390350)
,p_name=>'BLOB_FORMAT'
,p_message_text=>'Blob Format'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317510018014943651)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_text=>'Attachment'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317506415691883968)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_text=>'DOWNLOAD'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317506612887885269)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_text=>'IMAGE'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317509821249942086)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_text=>'Inline'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184536305681873179)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_text=>'BLOB Format'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184526705719475860)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_text=>'BLOB Last Updated Column'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184522708181429296)
,p_name=>'BLOB_TABLE'
,p_message_text=>'BLOB Table'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(211008521978726251)
,p_name=>'BLUE_TEXT'
,p_message_text=>'Blue Text'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190201810387940994)
,p_name=>'BRANCH CONDITION'
,p_message_text=>'Branch Condition'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26574026263306547)
,p_name=>'BRANCHES'
,p_message_text=>'Branches'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112649114174331879)
,p_name=>'BREADCRUMB'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166156511706285586)
,p_name=>'BREADCRUMB LABEL'
,p_message_text=>'Breadcrumb Label'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166157216208286830)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_text=>'Breadcrumb Long Name'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112652500584346879)
,p_name=>'BREADCRUMBS'
,p_message_text=>'Breadcrumbs'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(227313332167417545)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_text=>'Breadcrumb Entry'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244159817585123126)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_text=>'Breadcrumb Entry: %0'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138291118408684695)
,p_name=>'BREADCRUMB_PAGES'
,p_message_text=>'Breadcrumb Pages'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170067405116549071)
,p_name=>'BREADCRUMB_REGION'
,p_message_text=>'Breadcrumb Region'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47749016267868812)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_text=>'The breadcrumb has been created successfully.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166879626973629620)
,p_name=>'BROWSE_ICON'
,p_message_text=>'Browse Icon'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166350003385352802)
,p_name=>'BROWSE_PACKAGE'
,p_message_text=>'Browse Package'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145279924934973828)
,p_name=>'BROWSE_TABLE'
,p_message_text=>'Browse Table'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15119263075733254)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_text=>'An error occurred backing up the application'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15118664523711425)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_text=>'Application %0 restored from revision %1'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802407597908026)
,p_name=>'BU.APP_ACL'
,p_message_text=>'Application ACL'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1702144432186491)
,p_name=>'BU.APP_COMPUTATION'
,p_message_text=>'Application Computation'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1702368180188467)
,p_name=>'BU.APP_ITEM'
,p_message_text=>'Application Item'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1702863233206431)
,p_name=>'BU.APP_PROCESS'
,p_message_text=>'Application Process'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(482676484408478150)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_text=>'Application Properties: Modified'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1701377062165516)
,p_name=>'BU.APP_SETTING'
,p_message_text=>'Application Setting'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706991102383692)
,p_name=>'BU.APP_STATIC_FILE'
,p_message_text=>'Static Application File'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221348628070546856)
,p_name=>'BU.AUTHENTICATION'
,p_message_text=>'Authentication Scheme'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705784639370184)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_text=>'Authentication Schemes'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705942926372075)
,p_name=>'BU.AUTHORIZATION'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1411030306766457)
,p_name=>'BU.AUTOMATION'
,p_message_text=>'Automation'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1415809852150827)
,p_name=>'BU.BREADCRUMB'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800452149872935)
,p_name=>'BU.BREADCRUMB_ENTRY'
,p_message_text=>'Breadcrumb Entry'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800608675884821)
,p_name=>'BU.BREADCRUMB_TEMPLATE'
,p_message_text=>'Breadcrumb Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1702576502191183)
,p_name=>'BU.BUILD_OPTION'
,p_message_text=>'Build Option'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801086392888364)
,p_name=>'BU.BUTTON_TEMPLATE'
,p_message_text=>'Button Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800831101886798)
,p_name=>'BU.CALENDAR_TEMPLATE'
,p_message_text=>'Calendar Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221347968561525146)
,p_name=>'BU.COMPONENTS'
,p_message_text=>'Components'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555956116779069467)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_text=>'%0 Deleted'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555955935742068251)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_text=>'%0 Modified'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555955729562066674)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_text=>'%0 New'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706308531376863)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_text=>'Component Settings'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1904044312400017)
,p_name=>'BU.CREDENTIAL'
,p_message_text=>'Credential'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1803412028916452)
,p_name=>'BU.DATA_LOAD'
,p_message_text=>'Data Loading'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1407453146331896)
,p_name=>'BU.DATA_PROFILE'
,p_message_text=>'Data Profile'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2313139677522393)
,p_name=>'BU.DELETED'
,p_message_text=>'%0 Deleted'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2313328296524005)
,p_name=>'BU.DEVELOPERS'
,p_message_text=>'Developers'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706762033381926)
,p_name=>'BU.EMAIL_TEMPLATE'
,p_message_text=>'Email Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15119424933735656)
,p_name=>'BU.IN_PROGRESS'
,p_message_text=>'Application backup is in progress'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801697184896745)
,p_name=>'BU.LABEL_TEMPLATE'
,p_message_text=>'Label Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221383051921897436)
,p_name=>'BU.LAST_BACKUP'
,p_message_text=>'Last Backup: %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221347660858522604)
,p_name=>'BU.LAST_UPDATE'
,p_message_text=>'Last Update: %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1420532879213215)
,p_name=>'BU.LEGACY_DATA_LOAD'
,p_message_text=>'Legacy Data Load'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1703030376215662)
,p_name=>'BU.LIST'
,p_message_text=>'List'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801499221891834)
,p_name=>'BU.LIST_TEMPLATE'
,p_message_text=>'List Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15118804264729006)
,p_name=>'BU.LOCKED'
,p_message_text=>'Locked'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1704484605232781)
,p_name=>'BU.LOV'
,p_message_text=>'List of Values'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1707395869389595)
,p_name=>'BU.MESSAGE'
,p_message_text=>'Text Message'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1903474336341912)
,p_name=>'BU.MESSAGES'
,p_message_text=>'Messages'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2312941158520744)
,p_name=>'BU.MODIFIED'
,p_message_text=>'%0 Modified'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705310654362575)
,p_name=>'BU.NAVBAR'
,p_message_text=>'Navigation Menu'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221348437591531542)
,p_name=>'BU.NEW'
,p_message_text=>'%0 New'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602009007294268)
,p_name=>'BU.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800245353869748)
,p_name=>'BU.PAGES'
,p_message_text=>'Pages'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555955545407065478)
,p_name=>'BU.PAGES_DELETED'
,p_message_text=>'%0 Deleted'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555955369137063915)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_text=>'%0 Modified'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555955126547062456)
,p_name=>'BU.PAGES_NEW'
,p_message_text=>'%0 New'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1407664294338074)
,p_name=>'BU.PAGE_GROUP'
,p_message_text=>'Page Group'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1416435643150827)
,p_name=>'BU.PAGE_TEMPLATE'
,p_message_text=>'Page Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1416103393150827)
,p_name=>'BU.PARENT_TAB'
,p_message_text=>'Tab'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1704607495236865)
,p_name=>'BU.PLUGIN'
,p_message_text=>'Plug-in'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802227132904581)
,p_name=>'BU.POPUP_LOV_TEMPLATE'
,p_message_text=>'LOV Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1916404152112587)
,p_name=>'BU.PWA_SCREENSHOT'
,p_message_text=>'PWA Screenshots'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1916233322110252)
,p_name=>'BU.PWA_SHORTCUT'
,p_message_text=>'PWA Shortcuts'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801296798890058)
,p_name=>'BU.REGION_TEMPLATE'
,p_message_text=>'Region Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1707564312390578)
,p_name=>'BU.REMOTE_SERVER'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1904460144404383)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_text=>'Remove Servers'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1803067191913247)
,p_name=>'BU.REPORT_LAYOUT'
,p_message_text=>'Report Layout'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802894221911619)
,p_name=>'BU.REPORT_QUERY'
,p_message_text=>'Shared Query'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802098701901459)
,p_name=>'BU.REPORT_TEMPLATE'
,p_message_text=>'Report Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184304869410158113)
,p_name=>'BU.RESTORED'
,p_message_text=>'Restored Application'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11200636087663135)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_text=>'Application restored from backup revision %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1412035469105298)
,p_name=>'BU.SEARCH_CONFIG'
,p_message_text=>'Search Configuration'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001769583937170)
,p_name=>'BU.SEARCH_CONFIGURATIONS'
,p_message_text=>'Search Configurations.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706528083378618)
,p_name=>'BU.SHORTCUT'
,p_message_text=>'Shortcut'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13799188462677910)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_text=>'Change summary not available'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801835672899545)
,p_name=>'BU.TAB'
,p_message_text=>'Tab'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1415531338150827)
,p_name=>'BU.TASK_DEFINITION'
,p_message_text=>'Task Definition'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1407946128350589)
,p_name=>'BU.TEMPLATE_COMPONENT'
,p_message_text=>'Template Component'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1704286023226770)
,p_name=>'BU.THEME'
,p_message_text=>'Theme'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802629394909503)
,p_name=>'BU.TREE'
,p_message_text=>'Tree'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15119063214730172)
,p_name=>'BU.UNLOCKED'
,p_message_text=>'Unlocked'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1704048945223473)
,p_name=>'BU.USER_INTERFACES'
,p_message_text=>'User Interface Attributes'
,p_is_js_message=>true
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706160616374005)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_text=>'Web Credentials'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1803234202915007)
,p_name=>'BU.WEB_SERVICE'
,p_message_text=>'Web Service'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1904278876401643)
,p_name=>'BU.WEB_SOURCE'
,p_message_text=>'REST Data Source'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1707119428385575)
,p_name=>'BU.WS_STATIC_FILE'
,p_message_text=>'Static Workspace File'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7691925242338300)
,p_name=>'BUFFER CACHE'
,p_message_text=>'Buffer Cache'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172902200721777965)
,p_name=>'BUG'
,p_message_text=>'Bug'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184179708585180614)
,p_name=>'BUGS'
,p_message_text=>'Bugs'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191842801468313387)
,p_name=>'BUGS_ASSIGNED'
,p_message_text=>'bugs assigned'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236539728609554422)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_text=>'Bugs Assigned'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17736421345477258)
,p_name=>'BUGS_CLOSED'
,p_message_text=>'Bugs closed (%0 / %1):'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(496363927958523300)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_text=>'Bugs percent closed (%0/%1):'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236540021493557674)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_text=>'Bugs Unassigned'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236544023637571892)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_text=>'No Fix By Dates'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(496735400777253310)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_text=>'Bugs: %1 of %0 closed'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036814214998182732)
,p_name=>'BUG_LABEL'
,p_message_text=>'Bug: %0'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185507901218425453)
,p_name=>'BUILD QUERY'
,p_message_text=>'Build Query'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2301161452243484)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2300933861242412)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2300709255240747)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_text=>'PL/SQL'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2301309008244857)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2300584712239737)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_text=>'SQL'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(279427301631085873)
,p_name=>'BUILDER.PLUGINS'
,p_message_text=>'Plug-ins'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(275007606818926902)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_text=>'[Unsupported]'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484879007067195370)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_text=>'Workspace Message'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86867914216769358)
,p_name=>'BUILD_OPTION'
,p_message_text=>'Build Option'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337598917473396386)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_text=>'Build Option: %0'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1034832221991964130)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_text=>'Build Status: %0'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(342012314841257514)
,p_name=>'BUILD_VERSION'
,p_message_text=>'Build Version'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(231303217767143013)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_text=>'Built in Report Template'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165836317894003951)
,p_name=>'BUTTON'
,p_message_text=>'button'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(324872079304916555)
,p_name=>'BUTTON.ADD'
,p_message_text=>'Add'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10465811136933132)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_text=>'The selected Button''s Button Attributes must not contain an ID'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10465526804918707)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_text=>'The selected button must be a button with an Action set to ''Defined by Dynamic Action'''
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10517831315345828)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_text=>'The selected button uses a ''Button Template'' that does not contain the #BUTTON_ID# substitution string'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(324871665525913142)
,p_name=>'BUTTON.DELETE'
,p_message_text=>'Delete'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26585521658835522)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_text=>'Page must be specified.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23646206473246698)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_text=>'Report Query must be specified.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22557715752175614)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_text=>'Button Request must be specified for all the Button Request Source Types, unless Button Request Source Type is "Always Null".'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22641822294574881)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_text=>'Button Request Source Type must be specified.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26585724775836349)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_text=>'URL Target must be specified.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11131426025055486)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_text=>'When the Action is ''Defined by Dynamic Action'', the Button Attributes must not contain an ID'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27028915636625079)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_text=>'Image must be specified.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27029127757628555)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_text=>'Style must be specified.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27027908710623121)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_text=>'Template must be specified.'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11128929433952372)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_text=>'When the Button Style is ''Template Based Button'' and Action is ''Defined by Dynamic Action'', the selected Button Template must contain the #BUTTON_ID# substitution string'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6700327932133912)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_text=>'Button cannot be deleted because it is referenced in a Dynamic Action (Page: %0, Dynamic Action: ''%1'', Action: ''%2'', Attribute: ''Affected Element'').'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6699904678099115)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_text=>'Button cannot be deleted because it is referenced in a Dynamic Action (Page: %0, Dynamic Action: ''%1'', Attribute: ''When'').'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(324871850640915087)
,p_name=>'BUTTON.SUBMIT'
,p_message_text=>'Submit'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(313215230634932044)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_text=>'To be used in an "onclick" attribute'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(320371216069176796)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_text=>'To be used in an "href" attribute'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1909996074231882)
,p_name=>'BUTTON.TEMPLATE.ONCLICK'
,p_message_text=>'Indicates that the button has an onclick event with JavaScript code, which will be included in a script tag at the bottom of the page.'
,p_version_scn=>78664300
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26575631804308135)
,p_name=>'BUTTONS'
,p_message_text=>'Buttons'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195521424962048000)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_text=>'Button Attributes'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1034739606398883849)
,p_name=>'BUTTON_LABEL'
,p_message_text=>'Button: %0'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1722407472733113)
,p_name=>'BUTTON_NAME'
,p_message_text=>'Button Name'
,p_version_scn=>38408921
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200661619685415091)
,p_name=>'BUTTON_TEMPLATE'
,p_message_text=>'Button Template'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26057215633754454)
,p_name=>'BYTES'
,p_message_text=>'bytes'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172768215323486103)
,p_name=>'BY_NEXT_PATCH'
,p_message_text=>'By next patch'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172768419133487142)
,p_name=>'BY_NEXT_RELEASE'
,p_message_text=>'By next release'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922460531074056574)
,p_name=>'CA.ABOUT'
,p_message_text=>'About'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2645711118768334914)
,p_name=>'CA.ABOUT.PAGE'
,p_message_text=>'About Page'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2645703065337281803)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Include an about this application page which features a description of the application, the application version, and a page count.',
'</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84023937671947678)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_text=>'Content Container'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922460986216066186)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_text=>'About Page'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922461179966070662)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_text=>'Text about this application can be placed here.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922460399157049710)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_text=>'About this Page'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3108275218294181249)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_text=>'About this preview release'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(52067345260651933)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_text=>'Cannot remove yourself from administrator'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(52067196448634533)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_text=>'You cannot remove administrator role from yourself.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646689428037471242)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_text=>'Access Control'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2936352154493906864)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_text=>'Access Control Actions'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921862982160185411)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_text=>'Access Control Configuration'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621197543015395554)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_text=>'Enable role-based user authorization'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646691137910499236)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Incorporate role based user authentication within your application.',
'Users can be defined as Administrators, Contributors, or Readers.',
'You can then readily define different access to different roles for various components throughout your application, such as pages, menu entries, regions, columns, items, buttons and so forth.</p>',
'<p>Includes the following components:',
'<ul>',
'<li>Administrative page region with links to access control features</li>',
'<li>Users table to manage access control</li>',
'<li>Configuration page to set access level of authenticated users</li>',
'<li>Configuration page to specify if usernames are email addresses or not</li>',
'<li>Manage users access page to report and edit user access</li>',
'<li>Add user page with ability to add a single user</li>',
'<li>Add multiple users page with ability to add multiple users (email usernames only)</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921457360963067999)
,p_name=>'CA.ACCESS.ROLE'
,p_message_text=>'Role'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921458928124083758)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_text=>'Access Role ID'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40777121249534403)
,p_name=>'CA.ACCESS.ROLES'
,p_message_text=>'Roles'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921457568177069383)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_text=>'Account Locked'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(51097352111856095)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_text=>'Acknowledged'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2936348073694895278)
,p_name=>'CA.ACL.INFORMATION'
,p_message_text=>'ACL Information'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2939101723648525336)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_text=>'Insufficient privileges, user is not an Administrator'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2939101924183534294)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_text=>'You are not authorized to view this application, either because you have not been granted access, or your account has been locked. Please contact the application administrator.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2939102140061539543)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_text=>'Insufficient privileges, user is not a Contributor'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922000798241226929)
,p_name=>'CA.ACL.SAVED'
,p_message_text=>'Access Control settings saved.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922444182764816692)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_text=>'Action Button HTML'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922438254857756049)
,p_name=>'CA.ACTION.LABEL'
,p_message_text=>'Action Label'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922438458821758338)
,p_name=>'CA.ACTION.LINK'
,p_message_text=>'Action Link'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922457162389968680)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_text=>'Action Link HTML'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921391448582703368)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_text=>'Action Processed.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921454434670019772)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_text=>'Activity by Hour'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3431138782265996762)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_text=>'Activity Dashboard'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646811269044516004)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_text=>'Activity Reporting'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621235814173596267)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_text=>'Include user activity and error reports'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646812353061526776)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Include numerous reports on end user activity for your application. Determine the most active users, the most used pages, the performance of pages, and errors raised, to better understand how your application is being utilized and areas for improv'
||'ement.</p>',
'<p>Includes the following:',
'<ul>',
'<li>Top Users report</li>',
'<li>Application Error Log report</li>',
'<li>Page Performance, activity and performance by page</li>',
'<li>Application activity by page report</li>',
'<li>Page Views detail report</li>',
'',
'</ul>',
'</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184722752668855322)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_text=>'Actual Start Date'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2936347375766890525)
,p_name=>'CA.ADD'
,p_message_text=>'Add'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922445037810823657)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_text=>'Add Email Template'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3207348376277304563)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_text=>'Add Multiple Users - Step 2'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2928845970974696196)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_text=>'Add New %0'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921243212875092122)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_text=>'Add Notification'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(727736448010205713)
,p_name=>'CA.ADD.PAGE'
,p_message_text=>'Add Page'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921459160717086449)
,p_name=>'CA.ADD.USER'
,p_message_text=>'Add User'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3207350475634336341)
,p_name=>'CA.ADD.USERS'
,p_message_text=>'Add Users'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647110565840280585)
,p_name=>'CA.ADDING.PAGES'
,p_message_text=>'Adding Pages'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647115246828353695)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_text=>'<p>Click <strong>Add Page</strong> to add a page to your application. Then, select a page type (such as Blank, Chart, Form, Report, and so on) and define its attributes. You may also need to specify a valid table or view or use SQL Workshop to prepar'
||'e database objects in your workspace.</p>'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922455409080934735)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_text=>'Advanced'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184716749547844868)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_text=>'Additional Information'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921458512102079691)
,p_name=>'CA.ADDRESS'
,p_message_text=>'Address'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717719947844869664)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_text=>'Access Control'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717723416783887135)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_text=>'Change access control settings and disable access control'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717555357248833976)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_text=>'Activity Reports'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717720390087870685)
,p_name=>'CA.ADMIN.ADD'
,p_message_text=>'Add'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717729259651943829)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_text=>'Administration'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717721582582875378)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_text=>'Administrators'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218159415342551405)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_text=>'Application Configuration'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(306458550608649433)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_text=>'User Interface'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3019487861416921306)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_text=>'Application Administration'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3019490170988923820)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_text=>'Manage component'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717553734035817062)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_text=>'Theme Style Selection'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717554215113824357)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_text=>'Set the default application look and feel'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717552658117808643)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_text=>'Configuration Options'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717552297279805154)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_text=>'Enable or disable application features'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717556275937838498)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_text=>'Application Error Log'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717716478535842068)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_text=>'Report of errors logged by this application'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717554498319826140)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_text=>'Application Settings'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717554945167831899)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_text=>'Set application name and short description'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717553237079811577)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_text=>'Application Updates'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717553533218813726)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_text=>'Maintain the list of application updates'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717547491399784980)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_text=>'Configuration'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717721396161874155)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_text=>'Contributors'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3392601437263297482)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_text=>'Dashboard'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3392590633246194854)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_text=>'View application activity metrics'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722746696365755572)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_text=>'Default Time Zone'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722746819091756827)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_text=>'Set the default time zone for this application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717725912407903634)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_text=>'Email'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722747909848810687)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_text=>'Email Settings'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722748121389812242)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_text=>'Set if email should be sent and if so, who reply to should be'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717723695986888474)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717725181560895461)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_text=>'Feedback Settings'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717725523559899912)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_text=>'Manage if attachments should be allowed.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717723847939889886)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_text=>'User Feedback'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717724817879894153)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_text=>'Report of all feedback submitted by application users'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717726183260905316)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_text=>'Email Templates'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717726618186923296)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_text=>'Manage email template HTML and CSS used by this application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717548659596787143)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_text=>'Notifications'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717550305849793439)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_text=>'Display notifications on the home page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3035872367426225072)
,p_name=>'CA.ADMIN.PAGE'
,p_message_text=>'Administration Page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729541870126076153)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_text=>'Automations Log'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729545027816133501)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_text=>'Report of automation executions and messages logged by this application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717717207875843699)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_text=>'Page Performance'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717719105964859008)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_text=>'Report of activity and performance by application page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717719385461860347)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_text=>'Page Views'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717719758392867742)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_text=>'Report of each page view by user including date of access and elapsed time'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717721161023872634)
,p_name=>'CA.ADMIN.READERS'
,p_message_text=>'Readers'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3310571738092096812)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_text=>'Send Email'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3310572131363099669)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_text=>'Send template based email from this application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717555596528834943)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_text=>'Top Users'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717555811498837126)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_text=>'Report of page views aggregated by user'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717720726482871503)
,p_name=>'CA.ADMIN.USERS'
,p_message_text=>'Users'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717723231890882455)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_text=>'Set level of access for authenticated users of this application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717726827352924308)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_text=>'Email Log'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717727766757934617)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_text=>'View log of emails sent by this application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110372878183239212)
,p_name=>'CA.ADVANCED'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
' <li><strong>Advanced</strong> - Expand to see advanced options.',
'    <ul>',
'      <li><strong>Set as Home Page</strong> - Make this page the home page for the application.<br>',
'      &nbsp;&nbsp;&nbsp;Any page previously defined as the home page will be updated.</li>',
'      <li><strong>Set as Administration Page</strong> - Add this page under Administration, rather than as a normal page in the application. Access by clicking Administration in the main menu and then selecting it the Application Administration list.'
||'<br>',
'        <em><strong>Note:</strong> A page cannot be both a Home page and a page under Administration.</em></li>',
'      &nbsp;<br>',
'      <li><strong>Page Help</strong> - Enter text to be added to the Help Text for the page.</li>',
'    </ul>',
'  </li>',
'</ul>'))
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(64584832806113113)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
' <li><strong>Advanced</strong> - Expand to see advanced options.',
'    <ul>',
'      <li><strong>Page Help</strong> - Enter text to be added to the Help Text for the page.</li>',
'    </ul>',
'  </li>',
'</ul>'))
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3052392383106533190)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_text=>'Advanced Settings'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3052392567103548693)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_text=>'<p>Set additional definition, security and globalization settings.  These settings can be applied when creating the application, and can also be edited post application creation.</p>'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3092808948029652851)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_text=>'<p>Read the item help ( <span class="fa fa-question-circle" aria-hidden="true"></span> ) for each setting for more information.</p>'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3320760499135365754)
,p_name=>'CA.AFTER.ROWS'
,p_message_text=>'After Rows'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922443838328813787)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_text=>'After Rows HTML'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2928144744429905785)
,p_name=>'CA.ALL.COLS'
,p_message_text=>'All Columns'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922438636653760184)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_text=>'Allow Opt Out'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184691704616764705)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_text=>'Allow Runs in Restricted Mode'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921453849792975963)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_text=>'Application Error Log'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921400527629957834)
,p_name=>'CA.APP.NAME'
,p_message_text=>'Application Name'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233821681918498873)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_text=>'Whether access control is turned on or not'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233821822833504115)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_text=>'The default access level given to authenticated users who are not in the access control list'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921401775764976317)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_text=>'Application settings updated.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921400908323967781)
,p_name=>'CA.APP.SUBTITLE'
,p_message_text=>'Short Description'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921401599826971628)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_text=>'The text entered here is displayed under the application name on the home page of the application.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731729267645868096)
,p_name=>'CA.APPEARANCE'
,p_message_text=>'Appearance'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731729722265875812)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_text=>'<p>Define the default application color scheme (theme style), where the navigation is located, and the icon used for the application.</p>'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922385481311487392)
,p_name=>'CA.APPLICATION'
,p_message_text=>'Application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921186348271773302)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_text=>'Application Appearance'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731730776907899030)
,p_name=>'CA.APPLICATION.ICON'
,p_message_text=>'Application Icon'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731730993846908989)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_text=>'<p>Click <strong>Choose New Icon</strong> to select the icon color and one of the available icons. Your selection displays on the home page of the application.</p>'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731732224492951587)
,p_name=>'CA.APPLICATION.ID'
,p_message_text=>'Application ID'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731732489462955168)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_text=>'<p>Enter a unique, numeric identifier for your application. This field contains an automatically generated identifier by default.</p>'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922429791141503646)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_text=>'Application Page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921423639339335319)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_text=>'Application Sessions'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2645716370102357080)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_text=>'Application Settings'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621227754822543935)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_text=>'Set application name and short description'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2645718519823378422)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Allow application administrators to update various settings such as the application name and a description, default time zone and so forth.</p>',
'<p>Includes the following components:',
'<ul>',
'<li>Administrative page list entry and form</li>',
'<li>Ability to set application name</li>',
'<li>Ability to set home page hero region subtitle</li>',
'<li>Ability to set feedback recipients if using feedback</li>',
'<li>Ability to set application default time zone</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390027690448893810)
,p_name=>'CA.APPLICATIONITEM'
,p_message_text=>'Application Item'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3408615440855126793)
,p_name=>'CA.APPLY'
,p_message_text=>'Apply'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3624523424892738244)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_text=>'Applying application defaults'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2920367821485526287)
,p_name=>'CA.APPLY.CHANGES'
,p_message_text=>'Apply Changes'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3405575241848661420)
,p_name=>'CA.APPLY.FILTERS'
,p_message_text=>'Apply Filters'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(304994381923568234)
,p_name=>'CA.APP_BANNER'
,p_message_text=>'Application created from create application wizard %0.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305939287495202897)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_text=>'Save Setting'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3803963485747413355)
,p_name=>'CA.ATTACHMENT'
,p_message_text=>'Attachment'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129922908435085660)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_text=>'Attachment Count'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804208091347651202)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_text=>'Attachment Name'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129922795760084322)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_text=>'Attachment Size'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3414637955199571242)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_text=>'Attribute Defaults already defined for this %0.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921926912899196438)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_text=>'Any authenticated user may access this application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731733847212007055)
,p_name=>'CA.AUTHENTICATION'
,p_message_text=>'Authentication'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731734047687010010)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_text=>'<p>Select how you want users to authenticate into your application.</p>'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184700898371810810)
,p_name=>'CA.AUTO.DROP'
,p_message_text=>'Auto Drop'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729550481316258092)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_text=>'Automation Execution'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921449510700926462)
,p_name=>'CA.AVG.ELAPSED'
,p_message_text=>'Avg Elapsed'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(230792902824132322)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_text=>'Back to Jobs Report'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129924690458096670)
,p_name=>'CA.BCC'
,p_message_text=>'BCC'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3320760221853364271)
,p_name=>'CA.BEFORE.ROWS'
,p_message_text=>'Before Rows'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922443528620807726)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_text=>'Before Rows HTML'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922456491173956711)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_text=>'Before Rows Content'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2720804498703514355)
,p_name=>'CA.BLANK'
,p_message_text=>'Add Blank Page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2720808457568539034)
,p_name=>'CA.BLANK.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a blank page as a placeholder. Once you create the application, you can readily create regions on the page from Page Designer.</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'<!--  <li><strong>Include Page Navigation</strong> - Check this option to display a card list of all other pages defined in your application.<br>',
'      &nbsp;&nbsp;&nbsp;This option is typically used on your application home page.</li>',
'-->',
'</ul>'))
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3021697125256794594)
,p_name=>'CA.BLUEPRINT'
,p_message_text=>'Application Blueprint'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3021697330957833605)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The blueprint lists the application definition in JSON format.</p>',
'<p>When first entering this screen, the current application definition is transformed into a JSON document and displayed. You can edit the document to update application properties, and then click <strong>Apply Blueprint</strong> to change the curren'
||'t application details.</p>',
'<p>&nbsp;</p>',
'<p>If you need to create a large number of similar pages, copying the relevant JSON code for one page and pasting numerous times, and making small adjustments to the JSON, is significantly quicker than manually using the <strong>Add Page</strong> for'
||' each page.</p>',
'<p>Click <strong>Load a Previous Blueprint</strong> to replace the blueprint with the definition from a previously generated application. In this way you can very easily iterate an application design by adding additional pages, changing the features,'
||' or tweaking the settings, before generating the application again.</p>',
''))
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922437002669748757)
,p_name=>'CA.BODY1.TEXT'
,p_message_text=>'Body1 Text'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922438006633753421)
,p_name=>'CA.BODY2.TEXT'
,p_message_text=>'Body2 Text'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3350902159699397964)
,p_name=>'CA.BOTH'
,p_message_text=>'Both'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921193976387893274)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_text=>'Branch to Admin Page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109844703095809152)
,p_name=>'CA.BUTTON.BAR'
,p_message_text=>'Button Bar'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921187467439787711)
,p_name=>'CA.BUTTONS'
,p_message_text=>'Buttons'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722694106915896175)
,p_name=>'CA.CALENDAR'
,p_message_text=>'Add Calendar Page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722694311431897355)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a page which displays a calendar.</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'  <li><strong>Table or View</strong> (Mandatory) - Select the database object for the calendar.</li>',
'  <li><strong>Display Column</strong> (Mandatory) - Select the column from the table or view to display in the calendar events.</li>',
'  <li><strong>Start Date Column</strong> (Mandatory) - Select the date column from the table or view to use as the start date for calendar events.</li>',
'  <li><strong>End Date Column</strong> - Select the date column from the table or view to use as the end date for calendar events.<br>',
'      &nbsp;&nbsp;&nbsp;If End Date is specified then duration based events will be displayed. </li>',
'  <li><strong>Show Time</strong> - Select <strong>Yes</strong> to show the time portion for events and also enable the Weekly and Daily calendar views. Select <strong>No</strong> to only show the dates for events.</li>',
'  </ul>'))
,p_version_scn=>14498668
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2920367133497520875)
,p_name=>'CA.CANCEL'
,p_message_text=>'Cancel'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921195282534923399)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_text=>'Cancel Dialog'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106119627586788824)
,p_name=>'CA.CANCEL.MODAL'
,p_message_text=>'Cancel Modal'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922005558903296781)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_text=>'You cannot remove administration rights from your own record.'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3471170273687779427)
,p_name=>'CA.CARD'
,p_message_text=>'Add Card Page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3471170009562777626)
,p_name=>'CA.CARD.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a page which displays cards.</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'  <li><strong>Table or View</strong> (Mandatory) - Select the database object for the card.</li>',
'  <li><strong>Card Title</strong> (Mandatory) - Select the column from the table or view to use as the title for the card.</li>',
'  <li><strong>Description Column</strong> (Mandatory) - Select the column from the table or view to use as the description for the card.</li>',
'  <li><strong>Additional Text Column</strong> - Select the column from the table or view to use as the secondary description for the card.</li>',
'</ul>'))
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3404904849331246267)
,p_name=>'CA.CARDS'
,p_message_text=>'Cards'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3405070856175412381)
,p_name=>'CA.CARDS.VIEW'
,p_message_text=>'Cards View'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129924807358097534)
,p_name=>'CA.CC'
,p_message_text=>'CC'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305933134724073997)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_text=>'Change Filters'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2720772664103393591)
,p_name=>'CA.CHART'
,p_message_text=>'Add Chart Page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2720792603908461083)
,p_name=>'CA.CHART.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a page which displays either an area, bar, line, or pie chart.</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'  <li><strong>Chart Type</strong> - Select the type of chart to display [<strong>Area</strong>, <strong>Bar</strong>, <strong>Line</strong>, <strong>Pie</strong>].</li>',
'  <li><strong>Table or View</strong> (Mandatory) - Select the database object for the chart.</li>',
'  <li><strong>Label Column</strong> (Mandatory) - Select the column from the table or view to use as the label for the chart.</li>',
'  <li><strong>Value Aggregation</strong> - Select how the value column should be displayed or aggregated<br>',
'      &nbsp;&nbsp;&nbsp;[Column Value, Sum, Count].</li>',
'  <li><strong>Value Column</strong> (Mandatory) - Select a numeric column from the table or view which is used to calculate the chart values displayed.</li>',
'</ul>'))
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722683176199660378)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3>Examples</h3>',
'<p>Review the examples for how to utilize the different <strong>Summarization</strong> types:</p>',
'<p><strong>Example 1:</strong> Display a chart on Employees with the manager''s employee number for each employee.',
'<code><ul>',
'  <li>Table or View - Select EMP.</li>',
'  <li>Label Column - Select ENAME.</li>',
'  <li>Summarization - Select <u><strong>Column Value</strong></u>.</li>',
'  <li>Value Column - Select MGR.</li>',
'</ul></code>',
'</p>',
'<p><strong>Example 2:</strong> Display a chart on Employees with the total salary for each job.',
'<code><ul>',
'  <li>Table or View - Select EMP.</li>',
'  <li>Label Column - Select JOB.</li>',
'  <li>Summarization - Select <u><strong>Sum</strong></u>.</li>',
'  <li>Value Column - Select SAL.</li>',
'</ul></code>',
'</p>',
'<p><strong>Example 3:</strong> Display a chart on Employees with the number of employees in each department.',
'<code><ul>',
'  <li>Table or View - Select EMP.</li>',
'  <li>Label Column - Select DEPTNO.</li>',
'  <li>Summarization - Select <u><strong>Count</strong></u>.</li>',
'  <li>Value Column - Select EMPNO.</li>',
'</ul></code>',
'</p>'))
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184711409013830011)
,p_name=>'CA.CLIENT.ID'
,p_message_text=>'Client ID'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3931848816964656859)
,p_name=>'CA.CLOSE'
,p_message_text=>'Close'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(51097114481854864)
,p_name=>'CA.CLOSED'
,p_message_text=>'Closed'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3628834624970853082)
,p_name=>'CA.COLUMN'
,p_message_text=>'Column'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935898713692867147)
,p_name=>'CA.COLUMN.1'
,p_message_text=>'Column 1'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935898929609870618)
,p_name=>'CA.COLUMN.2'
,p_message_text=>'Column 2'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921451907304958627)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_text=>'Column Alias'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390026801759883432)
,p_name=>'CA.COMMENTS'
,p_message_text=>'Comments'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921418031609203832)
,p_name=>'CA.COMPONENT.NAME'
,p_message_text=>'Component Name'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921861447729181071)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_text=>'Configure Access Control'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921189270060793987)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_text=>'Configure Appearance'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921191411900800568)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_text=>'<p>The appearance of your application is defined by the Theme Style.</p>'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921397652305911899)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_text=>'Configuration Options updated. '
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646825012651935509)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_text=>'Configuration Options'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621234057644591678)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_text=>'Enable or disable application features'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646825268230950532)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enables application administrators to enable or disable specific functionality within the application. This feature is useful if you select features that need additional development effort before they can be used by end users.<br>',
'This feature can also be expanded to application-specific features. If developers define additional build options and associate them with specific functionality throughout the application, then they can be added to the configuration settings for admi'
||'nistrators. For example, within the Customer Tracker App administrators can turn on or off such features as Contacts, Data Loading, Geography, and more.',
'</p>',
'<p>Includes the following components:',
'<ul>',
'<li>Allows application functionality to be enabled and disabled</li>',
'<li>Use feature to allow selective functionality per deployment</li>',
'<li>Supports the grouping of related application settings</li>',
'<li>Enables application developers to control components using build options</li>',
'<li>Available from Administration page</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184690340593757039)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_text=>'Connect Credential Name'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184690646599758844)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_text=>'Connect Credential Owner'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(670893901978008019)
,p_name=>'CA.CONTEXT'
,p_message_text=>'Context'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921935063428206817)
,p_name=>'CA.CONTRIBUTOR'
,p_message_text=>'Contributor'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184718650637850656)
,p_name=>'CA.CPU.USED'
,p_message_text=>'CPU Used'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935878295891721656)
,p_name=>'CA.CREATE'
,p_message_text=>'Create'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975429714523414709)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_text=>'Creating administration page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974175639516293722)
,p_name=>'CA.CREATE.APP'
,p_message_text=>'Creating application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974911565411389030)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_text=>'Creating application computations'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974178012038343010)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_text=>'Creating application icon'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974911332271387043)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_text=>'Creating application items'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975289900755390741)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_text=>'Creating application processes'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(710418805308096201)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_text=>'Creating application settings'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3108274879338177214)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_text=>'Create an Application'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232262836269801979)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_text=>'Creating application roles'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974178433477347065)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_text=>'Creating authorization schemes'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975427059359396482)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_text=>'Creating blank page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974178217743344570)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_text=>'Creating build options'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975427949754402872)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_text=>'Creating calendar page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3363922963561060287)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_text=>'Creating cards page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975427510302400084)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_text=>'Creating chart page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975429183583407386)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_text=>'Creating classic report page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975427797806401473)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_text=>'Creating dashboard page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974175247369286615)
,p_name=>'CA.CREATE.END'
,p_message_text=>'Finishing up'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3624518963432702473)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_text=>'Creating faceted search page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2978204717848121381)
,p_name=>'CA.CREATE.FEATURES'
,p_message_text=>'Creating features'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3391781818698593736)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_text=>'Creating Filtered Content Page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975427233148397916)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_text=>'Creating form page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974175893097295268)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_text=>'Creating global page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975429577697413153)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_text=>'Creating home page navigation list'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975429335893410783)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_text=>'Creating interactive grid page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975428717007405619)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_text=>'Creating interactive report page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5002398058201500)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_text=>'Creating map page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3093502464147626788)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_text=>'Creating master detail pages'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974178899770352749)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_text=>'Creating navigation bars'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3034950084088983278)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_text=>'Creating page group'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2978068722766114663)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_text=>'Performing translation'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2978065590085061858)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_text=>'Performing translation for %0'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975428532600404337)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_text=>'Creating report and form page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3096937512007065559)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_text=>'Saving blueprint'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974179033665354309)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_text=>'Creating shortcut'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975290481439394542)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_text=>'Creating sign in page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4892141173869998)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_text=>'Creating Smart Filters page'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974174255912266882)
,p_name=>'CA.CREATE.START'
,p_message_text=>'Start'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974176094563300536)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_text=>'Creating supporting object scripts'
,p_version_scn=>37165770887499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974178651312351338)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_text=>'Creating text messages'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3385748405957524703)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_text=>'Creating timeline page'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3624523825618755124)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_text=>'Creating wizard page'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921392704693750112)
,p_name=>'CA.CREATED'
,p_message_text=>'Created'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921392990109752323)
,p_name=>'CA.CREATED.BY'
,p_message_text=>'Created By'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2717730367415961728)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_text=>'Creating Application ...'
,p_is_js_message=>true
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184692957177788983)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_text=>'Credential Name'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184717867125849687)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_text=>'Credential Owner'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921396834686900329)
,p_name=>'CA.CURRENT.STATUS'
,p_message_text=>'Current Status'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2984816748850813136)
,p_name=>'CA.CUSTOM.QRY'
,p_message_text=>'Custom Query'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(257378415276681194)
,p_name=>'CA.CUSTOM.THEME'
,p_message_text=>'Use Custom Theme'
,p_version_scn=>37165770887500
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(257672159768690707)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Switch the wizard to use a custom theme instead of the Universal Theme.</p>',
'',
'<p>Select a Workspace Theme for the application. If the theme supports Theme Styles, then the style can also be selected.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106076891433259654)
,p_name=>'CA.CUSTOM_THEME'
,p_message_text=>'Custom Theme'
,p_is_js_message=>true
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3021097598749298066)
,p_name=>'CA.DASHBOARD'
,p_message_text=>'Add Dashboard Page'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(657370579407842769)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_text=>'Chart %0'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3021097738613299739)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a dashboard page with multiple charts.</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'</ul>',
'&nbsp;<br>',
'<p>Each chart (Chart 1, Chart 2, Chart 3, and Chart 4) defaults to different chart types and is based on <em>Sample Data</em>. ',
'  As such you do not need to enter any further details to add this page.',
'  However, you can customize each chart be replacing the default values with your own selections.<br>',
'  To customize a chart enter the following attributes:</p>',
'<ul>',
'  <li><strong>Chart Name</strong> (Mandatory) - Enter the name for the chart.</li>',
'  <li><strong>Chart Type</strong> - Select the type of chart to display [<strong>Area</strong>, <strong>Bar</strong>, <strong>Line</strong>, <strong>Pie</strong>].</li>',
'  <li><strong>Table or View</strong> (Mandatory) - Select the database object for the chart.</li>',
'  <li><strong>Label Column</strong> (Mandatory) - Select the column from the table or view to use as the label for the chart.</li>',
'  <li><strong>Value Aggregation</strong> - Select how the value column should be displayed or aggregated<br>',
'      &nbsp;&nbsp;&nbsp;[Column Value, Sum, Count].</li>',
'  <li><strong>Value Column</strong> (Mandatory) - Select a numeric column from the table or view which is used to calculate the chart values displayed.</li>',
'</ul>'))
,p_version_scn=>14499014
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390018403696804042)
,p_name=>'CA.DATATYPE'
,p_message_text=>'Data Type'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390023045002834607)
,p_name=>'CA.DATEFORMATMASK'
,p_message_text=>'Date Format Mask'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921410575114006885)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_text=>'Default Time Zone'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921412991886040815)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_text=>'Default time zone updated.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3052392075133524538)
,p_name=>'CA.DEFAULTS'
,p_message_text=>'Application Attribute Defaults'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3052393369990606396)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_text=>'This JSON document allows for fine grain control over the generation of report and form columns names, format masks etc.  You can also define lists of values and other shared components. '
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3503659197691398606)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_text=>'List of Values Attributes'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3503659329568401157)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Add a list of values (LOV) attribute. LOVs can be used in table column definitions.</p>',
'<p>Enter the following attributes:',
'  <ul>',
'    <li><strong>Name</strong> (Mandatory) - Enter the name for the list of values.</li>',
'    <li><strong>Type</strong> - Select the list of values type [Structured, Dynamic, Static].<br>',
'      For Type of <u>Structured</u> - ',
'      <ul>',
'          <li><strong>Table</strong> (Mandatory) - Select the table or view to base the list of values on.</li>',
'          <li><strong>Display Column</strong> (Mandatory) - Select the column to display to end users.</li>',
'          <li><strong>Key Column</strong> (Mandatory) - Select the column value to return. This is generally the primary key for the table.</li>',
'      </ul>',
'      &nbsp;<br>',
'      For Type of <u>Dynamic</u> -',
'      <ul>',
'          <li><strong>SQL Query</strong> (Mandatory) - Enter a valid SQL select statement that returns two values (display value and return value).</li>',
'      </ul>',
'      &nbsp;<br>',
'      For Type of <u>Static</u> -',
'      <ul>',
'          <li><strong>Static List of Values</strong> (Mandatory) - Enter a valid static list of the form:',
'          <ul>',
'            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>List displayed in the order entered</li>',
'            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>List ordered alphabetically</li>',
'            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>Display value and return value the same</li>',
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3639060884968310767)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_text=>'Report Attributes'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3639061093818312202)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edit the attributes for all reports.</p>',
'<p>Enter the following attributes:',
'  <ul>',
'    <li><strong>Rows Per Page</strong> - Enter the number of report rows to display by default.</li>',
'    <li><strong>Pagination Method</strong> - Select how report pagination will be displayed.</li>',
'    <li><strong>Numeric Format Mask</strong> - Enter the format mask to apply to number columns and items.</li>',
'    <li><strong>Date Format Mask</strong> - Enter the format mask to apply to date columns and items.</li>',
'  </ul>',
'</p>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3636987998735639033)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_text=>'Table Attributes'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3635989190637543353)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_text=>'Table Column Attributes'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3635994429757612321)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edit the attributes for the selected table column.</p>',
'<p>Enter the following attributes:',
'  <ul>',
'    <li><strong>Table</strong> (Display Only) - The associated table.</li>',
'    <li><strong>Column</strong> (Display Only) - The column that the attributes are defined against.</li>',
'    <li><strong>Label</strong> - Enter the label to use in report headings and form labels.</li>',
'    <li><strong>Form Control</strong> - Select the item type to use on forms.</li>',
'    <li><strong>List of Values</strong> - Select an existing List of Values to use to display user friendly names as appropriate.</li>',
'    <li><strong>Format Mask</strong> - Enter an appropriate format mask based on the column type (text, number, date, and so forth).</li>',
'    <li><strong>Static Default Value</strong> - Enter a text default value for the column.</li>',
'    <li><strong>Include on Forms</strong> - Click Yes if the column should be included on forms.</li>',
'    <li><strong>Include on Reports</strong> - Click Yes if the column should be included on reports.</li>',
'    <li><strong>Required</strong> - Click Yes if data must be entered into this column on forms.</li>',
'    <li><strong>Help</strong> - Enter help text that is added to the item help attribute.</li>',
'  </ul>',
'</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3636988189411640116)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edit the attributes for the selected table.</p>',
'<p>Enter the following attributes:',
'  <ul>',
'    <li><strong>Table</strong> (Display Only) - The associated table.</li>',
'    <li><strong>Label, Singular</strong> (Mandatory) - Enter the label to use on form pages.</li>',
'    <li><strong>Label, Plural</strong> (Mandatory) - Enter the label to use in region headings and page names.</li>',
'    <li><strong>Primary Display Column</strong> - Select the first column to display, for example in card regions.</li>',
'    <li><strong>Secondary Display Column</strong> - Select the second column to display, for example in card regions.</li>',
'    <li><strong>Primary Key Column</strong> - Select the unique primary key column for the table.</li>',
'    <li><strong>Description</strong> - Enter a description for the table.</li>',
'  </ul>',
'</p>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184691961294765624)
,p_name=>'CA.DEFERRED.DROP'
,p_message_text=>'Deferred Drop'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390024443305853537)
,p_name=>'CA.DEFINITION'
,p_message_text=>'Definition'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2939102544288551506)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_text=>'Deinstallation complete.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921243510178096153)
,p_name=>'CA.DELETE'
,p_message_text=>'Delete'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2939100809220509997)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_text=>'Would you like to perform this delete action?'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647192229855853394)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_text=>'Are you sure you want to delete this page?'
,p_is_js_message=>true
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922145937187621898)
,p_name=>'CA.DELETE.PHOTO'
,p_message_text=>'Delete Photo'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921315510019364314)
,p_name=>'CA.DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935891867249795744)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_text=>'Navigation Bar'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935890832413787232)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_text=>'Navigation Menu'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921194181113900856)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_text=>'Desktop Theme Style'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921194344438905421)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_text=>'The default Theme Style applies to all users.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184693322210790821)
,p_name=>'CA.DESTINATION'
,p_message_text=>'Destination'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184693528489791916)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_text=>'Destination Owner'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106119013745756930)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_text=>'Dialog Buttons'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922446556500839801)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_text=>'Dispatch Emails'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3352231935537078117)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_text=>'Determines whether emails should be sent out from the Email Framework.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921269318491672617)
,p_name=>'CA.DISPLAY.FROM'
,p_message_text=>'Display From'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921269156969666950)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_text=>'Display Sequence'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921269572902675399)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_text=>'Display Until'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390018865083807380)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_text=>'Display Column'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921423432814333455)
,p_name=>'CA.DISTINCT .USERS'
,p_message_text=>'Distinct Users'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935881616764748047)
,p_name=>'CA.DOWNLOAD'
,p_message_text=>'Download'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3035873878412250184)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_text=>'Drag to reorder page'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110394392780365303)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
'  <li><strong>Drill Down Link</strong> - Expand to see attributes for defining a drill down link.',
'&nbsp;<br>',
'    <em><strong>Note:</strong> Drill Down Link only appears if the current page is based on a table or view and has a report type of Interactive Report, and you have defined a report (Interactive Report) or a master detail (Master Detail) page.</em>',
'  <ul>',
'    <li><strong>Link Column</strong> - Select the column to change to a link column in the report.</li>',
'    <li><strong>Link Key</strong> - Select the link key (foreign key) column used to identify the specific record in the page being linked to.</li>',
'    <li><strong>Link to Page</strong> - Select the report or form page that the link navigates to.</li>',
'    <li><strong>Target Key</strong> - Select the target key (primary key) column from the table that the report page, that the link navigates to and is based on.',
'  </ul>',
'</ul>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921417470815198164)
,p_name=>'CA.ELAPSED'
,p_message_text=>'Elapsed'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2671540709864246637)
,p_name=>'CA.EMAIL'
,p_message_text=>'Email Framework'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3350901500303395171)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_text=>'Email Addresses'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3739449055677845738)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_text=>'Default'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2671540444507243498)
,p_name=>'CA.EMAIL.DESC'
,p_message_text=>'Add ability to configure and send emails'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2671540976528256725)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Include the ability to send emails from your application. Using the example email template, send professional looking emails to users. The emails sent are logged so that administrators can keep track of email activity.</p>',
'<p>Includes the following components:',
'<ul>',
'<li>Extensible HTML Email template system</li>',
'<li>PL/SQL package for sending mail via APEX packages</li>',
'<li>Logging of email activity and status</li>',
'<li>Administrative UI to manage templates</li>',
'<li>Administrative UI to view email logs</li>',
'<li>Administrative UI to send emails</li>',
'</ul>',
'</p>',
'<p><em>Note: This feature will be enabled when Feedback is selected</em></p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390859682915675372)
,p_name=>'CA.EMAIL.FROM'
,p_message_text=>'Email From'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922439519597770694)
,p_name=>'CA.EMAIL.LOG'
,p_message_text=>'Email Log'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3767022200183606826)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_text=>'Email setting details required.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3760905119087160301)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_text=>'From Address is not a valid email.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3388520364122380768)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_text=>'From Address is not a valid email.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3353767397093620646)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_text=>'Email processed.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129926256783106143)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_text=>'Email Reporting'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234215567763914736)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_text=>'Report of all email queued to be sent and those already sent'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922446340050833283)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_text=>'Email Settings'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922454998629926366)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_text=>'Email settings updated.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3400496899899092919)
,p_name=>'CA.EMAIL.STATUS'
,p_message_text=>'Email Status'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922455213995930769)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_text=>'Email Template Details'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(481856201298619432)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_text=>'Scheduled Outage for #SERVICE_NAME#'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262724643767207906)
,p_name=>'CA.EMAIL2'
,p_message_text=>'Email'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922439326309766645)
,p_name=>'CA.EMAILS.SENT'
,p_message_text=>'Emails Sent'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3760906388661232426)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_text=>'Enable Attachments'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184713248642837561)
,p_name=>'CA.ENABLED'
,p_message_text=>'Enabled'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184701022555811514)
,p_name=>'CA.END.DATE'
,p_message_text=>'End Date'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922456858628964211)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_text=>'After Rows Content'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729547271811161451)
,p_name=>'CA.ENDED'
,p_message_text=>'Ended'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3207347751119292418)
,p_name=>'CA.ENTER.USERNAME'
,p_message_text=>'Enter usernames here'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921418733860210549)
,p_name=>'CA.ERROR'
,p_message_text=>'Error'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921453065781966085)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_text=>'Error Backtrace'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921452866471962209)
,p_name=>'CA.ERROR.CODE'
,p_message_text=>'Error Code'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921450342033943642)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_text=>'Error Message'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184723655639857031)
,p_name=>'CA.ERROR.NUMBER'
,p_message_text=>'Error Number'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184714990123843872)
,p_name=>'CA.ERRORS'
,p_message_text=>'Errors'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729548279136170455)
,p_name=>'CA.ERROR_ROWS'
,p_message_text=>'Error Rows'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184706076858815927)
,p_name=>'CA.EVENT.CONDITION'
,p_message_text=>'Event Condition'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184707255429817260)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_text=>'Event Queue Agent'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184707449591818273)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_text=>'Event Queue Name'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184707695219819290)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_text=>'Event Queue Owner'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184705747231815059)
,p_name=>'CA.EVENT.RULE'
,p_message_text=>'Event Rule'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3207348597027306223)
,p_name=>'CA.EXCEPTIONS'
,p_message_text=>'Exceptions'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3966760498355221622)
,p_name=>'CA.EXPERIENCE'
,p_message_text=>'Experience'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184712688908835181)
,p_name=>'CA.FAILURE.COUNT'
,p_message_text=>'Failure Count'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921395473639888511)
,p_name=>'CA.FEATURE'
,p_message_text=>'Feature'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561195827579186579)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_text=>'Application Version'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561196076362226278)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_text=>'Pages'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305936502942156065)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_text=>'Add Users to Access Control List'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305934807138124786)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_text=>'Go To Next Step'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305935959311136574)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_text=>'Create Collections'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305933494274094984)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_text=>'Cannot change the last administrator'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561194921446129497)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_text=>'Last Activity'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305932508063063298)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_text=>'No activities found'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561195648695158233)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_text=>'Reason'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305937462914177580)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_text=>'At least One Feedback Required'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(306083508867274967)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_text=>'Get File ID'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305007294530755768)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_text=>'Save Theme Style'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305007428270760100)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_text=>'Save End User Style Preference'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561195176647134446)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_text=>'Username'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2720709756240298547)
,p_name=>'CA.FEATURES'
,p_message_text=>'Features'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2720710407905304212)
,p_name=>'CA.FEATURES.DESC'
,p_message_text=>'Features provide application-level functionality and are typically added once per application. Choose features to include with your application.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646824705764929499)
,p_name=>'CA.FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621228749364562962)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_text=>'Allow users to provide feedback'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646821110719623802)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide a mechanism for end users to post general comments back to the application administrators and developers. The posts include useful session state information to help determine where the end user sent the feedback from. Providing such an eas'
||'y feedback loop enhances communication between the user community and the application owners, which leads to greatly improved end user satisfaction.</p>',
'<p>Includes the following components:',
'<ul>',
'<li>Ability for end users to leave feedback by clicking on a navigation bar icon</li>',
'<li>Administrative report for viewing and updating feedback</li>',
'<li>Feedback will capture the user, date and time, and user agent information</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3966762365367350420)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_text=>'Please provide feedback or your experience.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3761377816500363838)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_text=>'Send To'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3739423828750477590)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_text=>'Feedback Settings'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922385185869439518)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_text=>'Feedback settings updated.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3785661030236089620)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_text=>'Feedback Submitted'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184704061824812867)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_text=>'File Watcher Name'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184704728813814393)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_text=>'File Watcher Owner'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(63498757191799437)
,p_name=>'CA.FILED'
,p_message_text=>'Filed'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(63498989612801416)
,p_name=>'CA.FILED.BY'
,p_message_text=>'Filed By'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3404904320926232993)
,p_name=>'CA.FILTER.REPORT'
,p_message_text=>'Filter Report'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922457869659993430)
,p_name=>'CA.FILTERS'
,p_message_text=>'Filters'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3628792688080383632)
,p_name=>'CA.FINISH'
,p_message_text=>'Finish'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922146699005630764)
,p_name=>'CA.FIRST.NAME'
,p_message_text=>'First Name'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184691347946762229)
,p_name=>'CA.FLAGS'
,p_message_text=>'Flags'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722695911234992491)
,p_name=>'CA.FORM'
,p_message_text=>'Add Form Page'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722695767589991082)
,p_name=>'CA.FORM.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a page which displays a form page to enable end users to maintain data.</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'  <li><strong>Table</strong> (Mandatory) - Select the table for the form.</li>',
'<li><strong>Include Report</strong> (Mandatory) - Select this option to create a report and form. The first page is an interactive report. Each row provides a link to a form where users can update the record. </li>',
'  &nbsp;<br>',
'<li><strong>Advanced</strong> - Expand to see advanced options.',
'     <ul>',
'      <li><strong>Page Help</strong> - Enter text to be added to the Help Text for the page.</li>',
'      </ul>',
'</li>',
'</ul>'))
,p_version_scn=>14510670
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109862772238948209)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_text=>'Form Items Region'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935888332193771559)
,p_name=>'CA.FORM.ON'
,p_message_text=>'Form on %0'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3206409487718057694)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_text=>'The form type is not a valid type'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390025418889861472)
,p_name=>'CA.FORMATMASK'
,p_message_text=>'Format Mask'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390023206494838483)
,p_name=>'CA.FORMCONTROL'
,p_message_text=>'Form Control'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921392351593745165)
,p_name=>'CA.FROM'
,p_message_text=>'From'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922446820735842211)
,p_name=>'CA.FROM.ADDRESS'
,p_message_text=>'From Address'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390858037266661839)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_text=>'"From Address" Email Setting'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3387540893130642366)
,p_name=>'CA.FROM.EMAIL'
,p_message_text=>'From Email'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3387540699161641470)
,p_name=>'CA.FROM.WHO'
,p_message_text=>'From Who'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567275634790675126)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_text=>'%0 Search'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921449149049921504)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_text=>'Full Page Views'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922442837744801280)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_text=>'Full Template HTML'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390022169332822845)
,p_name=>'CA.FUNCTION'
,p_message_text=>'Function'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646825640139962257)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_text=>'Global Search'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621233646828586613)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_text=>'Provide application search capability'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646825422944960553)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Allow end users to search for text across key tables or views within the application. The advanced search page includes filters to make it simple for end users to narrow down the results.<br>',
'This very powerful feature does require some development effort to define the SQL (based on provided examples).</p>',
'<p>Includes the following components:',
'<ul>',
'<li>Displays a search icon in the header bar</li>',
'<li>Includes a detail search results page with side bar filter</li>',
'<li>Requires developer implement the SQL to define the App search</li>',
'<li>Includes sample data for illustration</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184711224596829124)
,p_name=>'CA.GLOBAL.UID'
,p_message_text=>'Global Unique ID'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(304941654983395022)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_text=>'Global Page - Desktop'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106119350254774772)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_text=>'Go To Admin Page'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722692398960864407)
,p_name=>'CA.GRID'
,p_message_text=>'Add Interactive Grid Page'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722692521388865538)
,p_name=>'CA.GRID.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a page which displays as an interactive grid which is similar to a spreadsheet. When editable, users can edit multiple rows directly on the page (that is, when Allow Editing is enabled).</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'  <li><strong>Query Type</strong> - Select the source for the report [<strong>Table or View</strong> or <strong>SQL Query</strong>].<br>',
'    <strong>Table or View</strong>:',
'    <ul>',
'      <li><strong>Table or View</strong> (Mandatory) - Select the database object for the grid.</li>',
'    </ul>',
'    <strong>SQL Query</strong>:',
'    <ul>',
'      <li><strong>SQL Query</strong> (Mandatory) - Enter a valid SQL statement which returns distinct columns.</li>',
'    </ul>',
'  </li>',
'  <li><strong>Grid Type</strong> - Select if users can edit the rows in the grid [<strong>Allow Editing</strong> or <strong>Read Only</strong>]. To enable editing, select <strong>Allow Editing</strong>.</li>',
'  &nbsp;<br>',
'  <em><strong>Warning:</strong> If you select a Query Type of <strong>SQL Query</strong> plus a Grid Type of <strong>Allow Editing</strong> and your query joins two or more tables, then the interactive grid generated will fail when users try and upda'
||'te records.',
'Also, if you select Grid Type of <strong>Allow Editing</strong> and the query (or selected Table or View) uses a view that is not updateable, then the Interactive Grid generated will fail when users try and update records.</em><br>',
'</ul>',
''))
,p_version_scn=>14510879
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922460172950046745)
,p_name=>'CA.HELP'
,p_message_text=>'Help'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729545221887138195)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page provides an interactive report of the automations log.</p>',
'<p>Review logged information about previous automation executions. The log contains start and end timestamps as well as details about processed rows (successful and with errors). Drill down into Messages to see individual messages for processed rows.'
||'</p>',
''))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921934660894202889)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_text=>'Choose <strong>No</strong> if all users are defined in the access control list. Choose <strong>Yes</strong> if authenticated users not in the access control list may also use this application.'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921400789661964062)
,p_name=>'CA.HELP.APP.NAME'
,p_message_text=>'The text entered here is used throughout the application, most notably, in the upper left-hand corner of every page. The change will take effect immediately for the administrator making the change, but other users will only see the change when they g'
||'et a new session (e.g. at next login).'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885894799020330828)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_text=>'<p>Click the feedback icon ( <span class="fa fa-comment-o" aria-hidden="true"></span> ) in the navigation bar, from any page in the application, to leave feedback for the application administrators.</p>'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885894141152310496)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_text=>'<p>This is the home page of the application. Click on the cards to access different pages in the application, or use the navigation menu on the side of the page.</p>'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885894503977315342)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_text=>'<p>This is the home page of the application. Click on the cards to access different pages in the application, or use the navigation menu at the top of the page.</p>'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885894911225351459)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_text=>'<p>Enter a search term in to the <strong>Search Application</strong> field on this page, or click the search icon ( <span class="fa fa-search" aria-hidden="true"></span> ) in the navigation bar from any page, to search for the term within your applic'
||'ation.</p>'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885895784447393918)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_text=>'<p>Click your name dropdown in the navigation bar to sign out of the application.</p>'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885895335593384290)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_text=>'<p>Click the user menu ( <span class="fa fa-user" aria-hidden="true"></span> ) in the navigation bar to update your time zone preference, and sign out of the application.</p>'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885894331206312070)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_text=>'Home Page'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885896091182396660)
,p_name=>'CA.HELP.HOME.USER'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Click the user menu ( <span class="fa fa-user" aria-hidden="true"></span> ) in the navigation bar (top right of the page) to access your user profile, and sign out of the application.<br>',
'If you click <strong>View My Profile</strong> you can then click <strong>Update Profile</strong> to enter your personal details and upload a photo or avatar.</p>'))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885895157473382298)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Click the user menu ( <span class="fa fa-user" aria-hidden="true"></span> ) in the navigation bar to access your user profile, update your time zone preference, and sign out of the application.<br>',
'If you click <strong>View My Profile</strong> you can then click <strong>Update Profile</strong> to enter your personal details and upload a photo or avatar.</p>'))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2986105093693789094)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To find data enter a search term into the search dialog, or click on the column headings to limit the records returned.</p>',
'',
'<p>You can perform numerous functions by clicking the <strong>Actions</strong> button. This includes selecting the columns that are displayed / hidden and their display sequence, plus numerous data and format functions.  You can also define an additi'
||'onal view of the data using the chart option.</p>',
'',
'<p>If you want to save your customizations select report, or click download to unload the data.<p>',
'<br>',
'<p>For additional information click Help at the bottom of the Actions menu.</p> ',
'',
'<p>Click the <strong>Reset</strong> button to reset the interactive report back to the default settings.</p>',
''))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2985284595924932808)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can insert, update, and delete data directly within this interactive grid.<br>',
'  Insert a new row by clicking the Add Row button.<br>',
'  Double click into a cell, or click the <strong>Edit</strong> button to update data values, similar to editing data in a spreadsheet.</p>',
'',
'<p>Use the Row Actions menu ( <span class="fa fa-bars" aria-hidden="true"></span> ) at the top of the report to duplicate, delete, refresh or revert selected rows.<br> ',
'  Use the Row Actions menu on individual rows to also access the single row view or add a new row.</p>',
'',
'<p>To find data enter a search term into the search dialog, or click on the column headings to limit the records returned.</p>',
'',
'<p>You can perform numerous functions by clicking the <strong>Actions</strong> button. This includes selecting the columns that are displayed / hidden and their display sequence, plus numerous data and format functions.  You can also define an additi'
||'onal view of the data using the chart option.</p>',
'',
'<p>If you want to save your customizations select report, or click download to unload the data.<p>',
'',
'<p>For additional information click Help at the bottom of the Actions menu.</p> ',
'',
'<p>Click the <strong>Reset</strong> button to reset the interactive grid back to the default settings.</p>'))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2885093087026229212)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To find data enter a search term into the search dialog, or click on the column headings to limit the records returned.</p>',
'',
'<p>You can perform numerous functions by clicking the <strong>Actions</strong> button. This includes selecting the columns that are displayed / hidden and their display sequence, plus numerous data and format functions.  You can also define additiona'
||'l views of the data using the chart, group by, and pivot options.</p>',
'',
'<p>If you want to save your customizations select report, or click download to unload the data. Enter you email address and time frame under subscription to be sent the data on a regular basis.<p>',
'',
'<p>For additional information click Help at the bottom of the Actions menu.</p> ',
'',
'<p>Click the <strong>Reset</strong> button to reset the interactive report back to the default settings.</p>'))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3209928781454624792)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This report page displays primary records in a selector on the side of the page. ',
'  Select a record to see the master record and any detail records defined.<br> ',
'  Click the edit icon ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ) to edit the master record.',
'  For detail records, click the pencil, at the beginning of each row, to edit that record.</p>',
'<p>To limit the data displayed in the selector enter a search term into the search dialog.</p>',
'',
'<p>To add a new master record click <strong>Create</strong> at the top of the page.',
'  For detail records, click the plus icon ( + ) at the top of the detail region to add a detail record.</p>',
'',
'<p>Click <strong>Reset</strong> at the top of the page to reset the page back to the default settings, removing any search term previously defined.</p>'))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2815566880196749620)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The administration page allows application owners (Administrators) to configure the application and maintain common data used across the application.',
'By selecting one of the available settings, administrators can potentially change how the application is displayed and/or features available to the end users.</p>',
'<p>Access to this page should be limited to Administrators only.</p>'))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826976181712610040)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the appropriate choice for any authenticated users.<br> ',
'Selecting <strong>No</strong> makes the application more secure as only specified users can access the application. ',
'However, if your application has a large user community then maintaining users may be onerous, and you may prefer to choose <strong>Yes</strong> and only enter application Administrators, and possibly Contributors.<br>',
'If you select <strong>Yes</strong> then you must also select how users not included in the users list are treated.</p>',
'<p>Select between requiring email addresses and any alphanumeric value for Usernames.<br>',
'Generally, you should set this setting to <strong>E-mail Address</strong> if your application uses (or will be configured to use) a centralized authentication scheme such as Oracle Access Manager, or SSO.</p>',
'<p><em><strong>Note:</strong> This application supports the following 3 access levels: Reader, Contributor, and Administrator.',
'<ul>',
'  <li><strong>Readers</strong> have read-only access to all information and can also view reports.</li>',
'  <li><strong>Contributors</strong> can create, edit and delete information and view reports.</li>',
'  <li><strong>Administrators</strong>, in addition to Contributors capability, can also perform configuration of the application by accessing the Administration section of the application.</li>',
'</ul>',
'</em></p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826976581162615244)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this form to enter users, their email address and set their access level. ',
'The settings defined under <em>Configure Access Control</em> will determine whether the username must be their email address or can be any alphanumeric entry.</p>',
'<p>This application supports the following 3 access levels: Reader, Contributor, and Administrator.</p>',
'<ul>',
'  <li><strong>Readers</strong> have read-only access to all information and can also view reports.</li>',
'  <li><strong>Contributors</strong> can create, edit and delete information and view reports.</li>',
'  <li><strong>Administrators</strong>, in addition to Contributors capability, can also perform configuration of the application by accessing the Administration section of the application.</li>',
'</ul>',
'<p>When editing an existing user you can lock their account which will prevent them from accessing the application.</p>',
'<p><em><strong>Note:</strong>   If using Oracle APEX accounts then users entered here must also be defined as end users by a Workspace Administrator, who can also set their password.</em></p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826976342638612479)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page shows a report of the application users and the access level granted.</p>',
'<p>Click on the column headings to sort and filter data, or click on the <strong>Actions</strong> button to customize column display and many additional advanced features.<br>',
'Click the <strong>Reset</strong> button to reset the interactive report back to the default settings.</p>',
'<p>Click the edit icon (yellow pencil) to edit the user details and access level, or to delete the user.</p>',
'<p>Click <strong>Add User</strong>, at the top of the report, to add a new user and their access level.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922004835723286611)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When Access Control is enabled, Administrators have the ability to restrict access to certain application features for authenticated users. This application supports the following 3 roles: Reader, Contributor, and Administrator.<p>',
'<ul>',
'  <li><strong>Readers</strong> have read-only access to all information and can also view reports.</li>',
'  <li><strong>Contributors</strong> can create,edit and delete information and view reports.</li>',
'  <li><strong>Administrators</strong>,in addition to Contributors capability,can also perform configuration of the application.</li>',
'</ul>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3207347434988285326)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_text=>'Enter usernames separated by commas, semicolons, or whitespace. Existing or duplicate usernames will automatically be ignored.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2825367579878446008)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Configuration settings allow you to make specific functionality either available (enabled) or unavailable (disabled) to end users.</p>',
'<p>If a specific function is not 100% ready, or needs to be temporarily removed, click <strong>Disabled</strong>. ',
'Once it should be made available, simply click <strong>Enabled</strong>.</p>',
'<p><em><strong>Note:</strong> Changes made here will not be reflected for individual end users currently running the application. Once the end user signs out and then signs back in the revised feature settings will be invoked.</em></p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826423433179501985)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the default color scheme used to display the application.</p>',
'<p>If <strong>Allow End Users to choose Theme Style</strong> is checked, then each end user can select from the available theme styles by clicking the <em>Customize</em> link in the bottom left corner of the Home page.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826830998694577812)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page provides an interactive report of all unexpected errors logged by this application.</p>',
'<p>Click on the column headings to sort and filter data, or click on the <strong>Actions</strong> button to customize column display and many additional advanced features. Click the <strong>Reset</strong> button to reset the interactive report back t'
||'o the default settings.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826830096634558140)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this report and chart to see the users with the most page views for the specified timeframe.</p>',
'<p>Select the reporting timeframe (Default = 1 day) and choose between the report and chart icons at the top of the page.</p>',
'<p>For the interactive report, use the search field, or select the <strong>User</strong> column heading, to select a specific user. You can perform numerous functions by clicking the <strong>Actions</strong> button, such as columns displayed / hidden'
||', rows per page, filter, and so forth. Click the <strong>Reset</strong> button to reset the interactive report back to the default settings.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826831104027582004)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page provides an interactive report of the page performance and popularity. The report is ordered by <strong>Weighted Performance</strong> which is calculated by multiplying the Median Elapsed time and number of Page Views.</p>',
'<p>Select the reporting timeframe (Default = 1 day) at the top of the page as necessary.<br>',
'Click on the column headings to sort and filter data, or click on the <strong>Actions</strong> button to customize column display and many additional advanced features. Click the <strong>Reset</strong> button to reset the interactive report back to t'
||'he default settings.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826831322945585747)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page provides an interactive report of the most recent page views.</p>',
'<p>Select the reporting timeframe (Default = 1 day) at the top of the page as necessary.<br>',
'Click on the column headings to sort and filter data, or click on the <strong>Actions</strong> button to customize column display and many additional advanced features. Click the <strong>Reset</strong> button to reset the interactive report back to t'
||'he default settings.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2825217243422439757)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Notifications are displayed on the home page when active.</p>',
'<p>This report shows the notifications defined and the time period when they are displayed.</p>',
'<p>Click the edit icon (yellow pencil) to edit an existing notification or click <strong>Add Notification</strong> to insert a new notification.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826423921463504398)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the application name and short description for the application.</p>',
'<p>The application name is displayed on home page. The short description is displayed below the application name.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826826501142523824)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Feedback can be entered by end users from any normal page within the application.</p>',
'<p>This report shows the feedback entered, any response enter by administrators, and the status of the feedback.</p>',
'<p>Click the edit icon (yellow pencil) to enter a response or update the feedback status.</p>',
'<p><em><strong>Note:</strong> If feedback recipients have been defined then feedback submissions will also be emailed to the email addresses in the feedback recipients list.</em></p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922384937268434693)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_text=>'Provide a comma-separated list of the email addresses.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826827842013539431)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_text=>'<p><strong>Enable Attachments</strong> - If yes, users will be able to upload an attachment in support of their feedback.</p>'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2827122248767651394)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page lists the email templates defined and how many times the template has been referenced in emails sent.</p>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2827121313728645843)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page lists the emails sent.</p>',
'<p>Click the Magnifying Glass icon to view more details on the emails sent.</p>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2827121708983648776)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the following fields to define an email template:</p>',
'<ul>',
'  <li><strong>Template Name</strong> (Mandatory) - Enter a meaningful name for the template.</li>',
'  <li><strong>HTML Template</strong> (Mandatory) - Enter the HTML code used to construct the email sent to recipients that allow the delivery of HTML-based emails.',
'    Substitution values include:',
'    <ul>',
'        <li><strong>#APP_NAME#</strong> - will be replaced by the name of the application</li>',
'        <li><strong>#BODY1#</strong> - will be replaced by the value passed in as p_body1_text</li> ',
'        <li><strong>#TABLE#</strong> - will be replaced by the value passed in as p_table_content, using the Table Open HTML, Table Row HTML and Table Close HTML</li> ',
'        <li><strong>#BODY2#</strong> - will be replaced by the value passed in as p_body2_text</li> ',
'        <li><strong>#ACTION#</strong> - will be replaced by the value passed in as p_action_label and p_action_link, using the Action Link template</li>',
'     </ul></li>',
'  <li><strong>Plain Text Template</strong> (Mandatory) - Enter the plain text used to construct the email sent to recipients that do not accept HTML-based emails.  This uses the same substitutions as the HTML Template except the #TABLE# and #ACTION# '
||'will be rendered as plain text.</li>',
'</ul>',
'<p>Additional HTML Templates allow for more advanced emails.  These items include:</p>',
'<ul>',
'  <li><strong>Before Rows</strong> - Enter HTML to replace #TABLE# in the HTML Template.  Only used if p_table_content is passed.</li>',
'  <li><strong>Row Template</strong> - Enter HTML to render each row of the table.  This includes the row open/close and data open/close using the #LABEL# and #VALUE# substitutions.    Only used if p_table_content is passed.</li>',
'  <li><strong>After Rows</strong> - Enter HTML to close the table or div.  Only used if p_table_content is passed.</li>',
'  <li><strong>Action Link HTML</strong> - Enter HTML to replace #ACTION# in the HTML Template.  It should contain #ACTION_LINK# and #ACTION_TEXT#.  Only used if p_action_label and p_action_link are passed.</li>',
'</ul>',
'<p><em><strong>Note:</strong> Use the entries within the <strong>default template</strong> as an example for developing your own template. The default template uses all of the substitution variables which you may or may not want to include within you'
||'r own email template.</em></p>'))
,p_version_scn=>14511008
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2827122660400653788)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enable or disable the sending of emails by selecting one of the <strong>Dispatch Emails</strong> options.</p>',
'<p>Enter the <strong>Emails Sent From</strong> using the email address of the primary contact for application issues.  This value can be used or overwritten when using the email feature.</p>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922447627444850849)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_text=>'This is the from address that will be used to send emails. It can be overwritten when using the email feature.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3310998165895557234)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Populate the following items and click [Send Email].  All emails sent are logged in the Email Log.',
'    <ul>',
'        <li><strong>From</strong> - If a "From Address" is set within Email Settings, that email address will be an option to send from.  If this application uses Email Addresses as username, you can select to send emails from your email.  Lastly, yo'
||'u can always have the Send From be the same as the Send To.</li>',
'        <li><strong>Send To</strong> - If this application uses Email Addresses as username, you can select to send emails to Email Addresses and/or Users.</li>',
'        <li><strong>Email Addresses</strong> - Comma separated list of email addresses to receive the email. Those found to be invalid, will not be included.</li>',
'        <li><strong>Role</strong> - Send email to all users of a selected role or to all defined users.  Select list includes a list of roles and the count of users within that role.</li>',
'        <li><strong>Template</strong> - Select the email template to use to create the body of the email.</li>',
'        <li><strong>Subject</strong> - The subject of the email.</li>',
'        <li><strong>Email Body</strong> - Text to be included as the body of the email.</li>',
'        <li><strong>Allow Opt Out</strong> - Some emails should be sent regardless of the user opting out of receiving emails. These include outage messages, etc. This flag identifies if this email should be allowed to be opted out of or if it should'
||' be sent regardless of the user''s preference.</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3362798694332746063)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Populate the following items and click [Send Email].  All emails sent are logged in the Email Log.',
'    <ul>',
'        <li><strong>From</strong> - If a "From Address" is set within Email Settings, that email address will be an option to send from.  Otherwise, you can always have the Send From be the same as the Send To.</li>',
'        <li><strong>Email Addresses</strong> - Comma separated list of email addresses to receive the email. Those found to be invalid, will not be included.</li>',
'        <li><strong>Template</strong> - Select the email template to use to create the body of the email.</li>',
'        <li><strong>Subject</strong> - The subject of the email.</li>',
'        <li><strong>Email Body</strong> - Text to be included as the body of the email.</li>',
'        <li><strong>Allow Opt Out</strong> - Some emails should be sent regardless of the user opting out of receiving emails. These include outage messages, etc. This flag identifies if this email should be allowed to be opted out of or if it should'
||' be sent regardless of the user''s preference.</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2826825625683510454)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the default time zone for all users of this application.</p>',
'<p>Individual users can override this setting by clicking their user name (top right) and selecting <strong>Preferences</strong>. Alternatively, they can click the time zone link displayed at the bottom of the home page.</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922151157122767119)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_text=>'This page is not accessible directly through the UI. It is used to facilitate profile photo downloading.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922148619304676217)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_text=>'The User Profile Page allows you to see relevant information about a user in one easy to use screen.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922147937487653460)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_text=>'Please upload a photo with a square aspect ratio otherwise it may be distorted. The preferred image size is 250x250 pixels.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2845154884735575084)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This form allows you to update your personal details and upload a photo or avatar.</p>',
'<p>To upload an image, click <strong>Browse</strong> or drag and drop the image over the button.<br>',
'Please upload a photo with a square aspect ratio otherwise it may be distorted. The preferred image size is 250x250 pixels.</p>',
'<p>Click <strong>Delete Photo</strong> to remove the image.</p>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922460710567062320)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_text=>'All application help text can be accessed from this page. The links in the "Documentation" region give a much more in-depth explanation of the application''s features and functionality.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2919482571627912253)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_text=>'You can set application preferences for your account from this page. The preferences can affect several aspects of the application such as time zone. Click the item-level help icons to learn what each preference does.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129926839055109215)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_text=>'<p>This report shows all email queued to be sent and those already sent.</p>'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184690119298754624)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_text=>'<p>This report includes all the jobs selected to be monitored by this application.  More details of each job can be viewed by clicking on the job name.</p>'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184714203018842404)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_text=>'<p>This report includes the run details about the jobs selected to be monitored by this application.</p>'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621228429576558138)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_text=>'Add about this application page'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2920780735107596548)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_text=>'Set this option to No if you do not want to receive emails from this application.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3214738171028737188)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a search term into the search dialog and click <strong>Search</strong>.<br>',
'Click on any of the result headings to navigate to that specific record.</p>',
'<p>To limit the search uncheck one or more Sources, which removes that report from the search results.</p>',
'<p>Click <strong>Reset</strong> to remove the current search term and check all Sources.</p> '))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2920779829770579930)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_text=>'Set your preferred time zone for use throughout the application.'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109929974733353866)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_text=>'Hidden Items'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935892872459804960)
,p_name=>'CA.HOME'
,p_message_text=>'Home'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3035873643356247183)
,p_name=>'CA.HOME.PAGE'
,p_message_text=>'Home Page'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3431138501538994244)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_text=>'Hourly Page Events'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129923857503088605)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_text=>'HTML Body Size'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922455608816950097)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_text=>'HTML Template'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922403438085948059)
,p_name=>'CA.IN.PROGRESS'
,p_message_text=>'In Progress'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390023617312842111)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_text=>'Include on Forms'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390023464598840999)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_text=>'Include on Reports'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2974177521902325138)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_text=>'Installing supporting object scripts'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184692122033767485)
,p_name=>'CA.INSTANCE.ID'
,p_message_text=>'Instance ID'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184695173855799041)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_text=>'Instance Stickiness'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2762518213840408889)
,p_name=>'CA.INTRO.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Welcome to this cloud-only preview of a new and improved way to create a more fully-featured application. The standard Create Application Wizard only allows you to select pages to generate, while this wizard also allows you to quickly pre-load a n'
||'umber of additional features into your application.</p>',
'<p>Applications generated using this wizard will be fully supported and may also include Supporting Objects for selected features, such as Access Control, Email Framework, Feedback, and more.</p>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2762781533965438228)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Start by entering an application name. Next add one or more pages to your application. Check the features you want included. Make choices about the application appearance and then review the settings.<br>',
'That is it - Click <strong>Create Application</strong> and you are away!</p>',
'<p>Click on <strong>View Blueprint</strong> to reuse the model from a previously generated application or to quickly replicate pages.</p>',
'<p><em><strong>Note:</strong> Each section and each ''Add Page'' includes detailed help to assist you further.</em></p>',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2762518563345411939)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_text=>'How To Use This Wizard'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3123825716879847807)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Significant issues at the time of release are listed below:',
'<ol>',
'  <li>The Create Application from Blueprint Wizard is not translated.</li>',
'  <li>Translated applications generated with this wizard are only partially translated.</li>',
'  <li>Report Drill Down only allows one drill down column.</li>',
'  <li>Filter report pages can not be generated.</li>',
'  <li>Email feature provides the low level API, but does not yet include higher level email features.</li>',
'  <li>Generating an application from a Blueprint that references missing tables will fail ungracefully.</li>',
'  <li>Advanced Settings - Date Formats are not applied to the generated application.</li>',
'</ol>',
'</p>'))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3123823976605830310)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_text=>'Known Issues'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2762782109910444519)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Released %0.</p>',
'',
''))
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2762781751817439821)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_text=>'Release Details'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2762108118828369911)
,p_name=>'CA.INTRO.TITLE'
,p_message_text=>'Create Application from a Blueprint Wizard {Cloud-Only Preview}'
,p_version_scn=>37165770887501
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921451320341951949)
,p_name=>'CA.IP.ADDRESS'
,p_message_text=>'IP Address'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921418434810209193)
,p_name=>'CA.IR.SEARCH'
,p_message_text=>'IR Search'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921455137119030743)
,p_name=>'CA.IR.SEARCHES'
,p_message_text=>'IR Searches'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390018003835801799)
,p_name=>'CA.ITEMNAME'
,p_message_text=>'Item Name'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184709829957825012)
,p_name=>'CA.JOB.ACTION'
,p_message_text=>'Job Action'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184713488151838482)
,p_name=>'CA.JOB.CLASS'
,p_message_text=>'Job Class'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184711641220830824)
,p_name=>'CA.JOB.CREATOR'
,p_message_text=>'Job Creator'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184713852932840370)
,p_name=>'CA.JOB.NAME'
,p_message_text=>'Job Name'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184699372032808033)
,p_name=>'CA.JOB.PRIORITY'
,p_message_text=>'Job Priority'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184689941217752204)
,p_name=>'CA.JOB.REPORTING'
,p_message_text=>'Job Reporting'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218155149841501964)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_text=>'View status and run details of jobs supporting this application'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184714091500841721)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_text=>'Job Run Details'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184711817021831828)
,p_name=>'CA.JOB.STYLE'
,p_message_text=>'Job Style'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184712090408832630)
,p_name=>'CA.JOB.SUBNAME'
,p_message_text=>'Job Subname'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184710133093825908)
,p_name=>'CA.JOB.TYPE'
,p_message_text=>'Job Type'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184694387399796291)
,p_name=>'CA.JOB.WEIGHT'
,p_message_text=>'Job Weight'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390020401533811054)
,p_name=>'CA.KEYCOLUMN'
,p_message_text=>'Key Column'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390025200674859796)
,p_name=>'CA.LABEL'
,p_message_text=>'Label'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390021044358816377)
,p_name=>'CA.LABELCOLUMN'
,p_message_text=>'Label Column'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390025684829862973)
,p_name=>'CA.LABELPLURAL'
,p_message_text=>'Label Plural'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390025024442858169)
,p_name=>'CA.LABELSINGULAR'
,p_message_text=>'Label Singular'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731732681309956661)
,p_name=>'CA.LANGUAGE'
,p_message_text=>'Language'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731732870762978363)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_text=>'Select the primary language for this application.'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3096535189070950803)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_text=>'<p>The primary language dictates the language used to display the pages and components generated in the App Builder. Selecting multiple translations will provide choices for your end users as to what language the runtime application is rendered using'
||'.</p>'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(304974196731546192)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_text=>'Language Selector'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922146882170633130)
,p_name=>'CA.LAST.NAME'
,p_message_text=>'Last Name'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184712213357833565)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_text=>'Last Run Duration'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184712494729834384)
,p_name=>'CA.LAST.START.DATE'
,p_message_text=>'Last Start Date'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3431139308858001384)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_text=>'Latest Activity'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390023818625843976)
,p_name=>'CA.LISTOFVALUES'
,p_message_text=>'List of Values'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3213478521559499976)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_text=>'Load Blueprint'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184724822262861368)
,p_name=>'CA.LOG.DATE'
,p_message_text=>'Log Date'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184725241717862425)
,p_name=>'CA.LOG.ID'
,p_message_text=>'Log ID'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184696288660801521)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_text=>'Logging Level'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(730217506078555409)
,p_name=>'CA.LOG_MESSAGES'
,p_message_text=>'Log Messages'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922445733354828314)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_text=>'Manage Email Templates'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922430379075523813)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_text=>'Manage Feedback'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921459552802091145)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_text=>'Manage User Access'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3471280999731244121)
,p_name=>'CA.MASTER'
,p_message_text=>'Add Master Detail Page'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3471288414436303902)
,p_name=>'CA.MASTER.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a page which displays a master-detail page to enable end users to view and maintain data.<br>',
'&nbsp;</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'  <li><strong>Page Type</strong> - Select the type of page [Side by Side, Stacked].<br></li>',
'    <strong>Side by Side</strong>: <br>',
'<em>A single page master-detail utilizing side by side layout and report regions with modal edit windows.</em>',
'    <ul>',
'      <li><strong>Table</strong> (Mandatory) - Select the master table for the page.</li>',
'      <li><strong>Primary Display Column</strong> (Mandatory) - Select the column to display in the list of master records.</li>',
'      <li><strong>Secondary Display Column</strong> (Mandatory) - Select the descriptive column to display in the list of master records, under the Primary Display Column.</li>',
'      <li><strong>Detail Table 1</strong> (Mandatory) - Select the first detail table for the page.</li>',
'      <li><strong>Detail Table 2</strong> - Select the second detail table for the page.</li>',
'      <li><strong>Detail Table 3</strong> - Select the third detail table for the page.</li>',
'      <li><strong>Detail Table 4</strong> - Select the forth detail table for the page.</li>',
'    </ul>',
'   <strong>Stacked</strong>: <br>',
'<em>A single page master-detail utilizing editable Interactive Grids.</em>',
'    <ul>',
'      <li><strong>Table</strong> (Mandatory) - Select the master table for the editable interactive grid.</li>',
'      <li><strong>Detail Table</strong> (Mandatory) - Select the detail table for the page.</li>',
'      <em><strong>Note:</strong> Only one detail table (editable interactive grid) can be added using the wizard. Additional detail tables can easily be added post-generation.</em>',
'    </ul>',
'</ul>'))
,p_version_scn=>14511157
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(304973226369525794)
,p_name=>'CA.MASTER_RECORDS'
,p_message_text=>'Master Records'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921424035363339579)
,p_name=>'CA.MAX.ELAPSED'
,p_message_text=>'Max Elapsed'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184698972208806077)
,p_name=>'CA.MAX.FAILURES'
,p_message_text=>'Maximum Failures'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184697284873802829)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_text=>'Maximum Run Duration'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184699122360806963)
,p_name=>'CA.MAX.RUNS'
,p_message_text=>'Maximum Runs'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390020826046814187)
,p_name=>'CA.MAXIMUMROWS'
,p_message_text=>'Maximum Rows'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390698185596533926)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_text=>'Maximum Width'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126181581180824016)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_text=>'Add Filter'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126183593259837085)
,p_name=>'CA.MD.ADD.ROW'
,p_message_text=>'Add %0'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126180843980820882)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_text=>'Apply Filters'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126412896618976531)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_text=>'Date Value'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126413378707980665)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_text=>'Date Value 2'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126181945758825467)
,p_name=>'CA.MD.EDIT'
,p_message_text=>'Edit'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126178240841813052)
,p_name=>'CA.MD.FILTER'
,p_message_text=>'Filter'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126178059153811617)
,p_name=>'CA.MD.FILTERS'
,p_message_text=>'Filters'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126183758217839342)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_text=>'No Filters'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126179509905818776)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_text=>'No Record Selected'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126178976405816668)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_text=>'No Records Found'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126183137366832711)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_text=>'%0 deleted'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126182568075829043)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_text=>'%0 updated'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126178493426813829)
,p_name=>'CA.MD.SEARCH'
,p_message_text=>'Search'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126183974645840770)
,p_name=>'CA.MD.VALUE'
,p_message_text=>'Value'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3126184169832841956)
,p_name=>'CA.MD.VALUE.2'
,p_message_text=>'Value 2'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921423074548329461)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_text=>'Median Elapsed'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922438936143762653)
,p_name=>'CA.MESSAGE'
,p_message_text=>'Message'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729554545077431629)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_text=>'Message Type'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390027217290886941)
,p_name=>'CA.METRIC'
,p_message_text=>'Metric'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921449350927924856)
,p_name=>'CA.MIN.ELAPSED'
,p_message_text=>'Min Elapsed'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921458107697077121)
,p_name=>'CA.MOBILE.PHONE'
,p_message_text=>'Mobile Phone'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921417804849202115)
,p_name=>'CA.MODE'
,p_message_text=>'Mode'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2928846548085702402)
,p_name=>'CA.MORE'
,p_message_text=>'More'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921455368325032970)
,p_name=>'CA.MOST RECENT'
,p_message_text=>'Most_Recent'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3431138963487998239)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_text=>'Most Active Pages'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110399486977448504)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_text=>'Multiple Reports'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110399647658472955)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Check one or more table or view names. Alternatively, click the check box in the header to select or deselect all the database objects listed.</p>',
'<p>A page with an interactive report will be added for each checked database object.</p>'))
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921386496226526275)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_text=>'#LABEL# must be a valid timestamp.'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390026603542880599)
,p_name=>'CA.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731730321516892380)
,p_name=>'CA.NAVIGATION'
,p_message_text=>'Navigation'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731730586046897188)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_text=>'<p>Select if the menu displays on the side of the application or across the top of the application.</p>'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3966761056345225423)
,p_name=>'CA.NEGATIVE'
,p_message_text=>'Negative'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3966760844908224457)
,p_name=>'CA.NEUTRAL'
,p_message_text=>'Neutral'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3197576405458479166)
,p_name=>'CA.NEXT'
,p_message_text=>'Next'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184697835825804376)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_text=>'Next Run Date'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184694197799795488)
,p_name=>'CA.NLS.ENV'
,p_message_text=>'NLS Environment'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(259441579847037601)
,p_name=>'CA.NO'
,p_message_text=>'No'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922403644428949108)
,p_name=>'CA.NO.ACTION'
,p_message_text=>'No Action'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2987455550476259206)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_text=>'No help is available for this page.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109933953007368985)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_text=>'No Valid Users Exist - Page Info'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3207348955022315319)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_text=>'No valid new users found'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3093033482716995036)
,p_name=>'CA.NONE'
,p_message_text=>'None'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921458734477080901)
,p_name=>'CA.NOTE'
,p_message_text=>'Note'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646817348406583711)
,p_name=>'CA.NOTIFICATION'
,p_message_text=>'Notifications'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621233833044589005)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_text=>'Display notifications on the home page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646818500323599480)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enables application administrators to specify either alerts (yellow) or errors (red) that display to all end users on the application home page. This feature is useful for relaying important information to your end user community.</p>',
'<p>Includes the following components:<ul>',
'<li>Ability to define notifications</li>',
'<li>Display of notification on application home page</li>',
'<li>Ability control the time window of notification display</li>',
'<li>Support for color coding of notifications by type</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921244095427102267)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921418279248207207)
,p_name=>'CA.NUM.ROWS'
,p_message_text=>'Num Rows'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184709632159824117)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_text=>'Number of Arguments'
,p_version_scn=>37165899652287
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184693717345792827)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_text=>'Number of Destinations'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390022812404832999)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_text=>'Number Format Mask'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921449947643933379)
,p_name=>'CA.OCCURRENCE'
,p_message_text=>'Occurrence'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4055153107580160784)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_text=>'You cannot perform this action unless there is another administrator.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922404223592955005)
,p_name=>'CA.OPEN'
,p_message_text=>'Open'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647111031373283020)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_text=>'Organizing Pages'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647114832697344347)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Arrange the pages in the order that you want them to appear in your application. <br>',
'To reorder pages in the list, click and hold the <em>Drag to reorder page</em> icon ( <span class="fa fa-bars" aria-hidden="true"></span> ) at the end of each page listing, and then drag and drop that page up or down.</p>',
'<p>The Home page always displays first and cannot be reordered.<br>',
'Administrative pages always display at the bottom of the list and the order dictates the order they appear in the Application Administration list on the Administration page.</p>'))
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184714613184843219)
,p_name=>'CA.OUTPUT'
,p_message_text=>'Output'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184724638770860473)
,p_name=>'CA.OWNER'
,p_message_text=>'Owner'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921417645579199082)
,p_name=>'CA.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921454613194022715)
,p_name=>'CA.PAGE.EVENTS'
,p_message_text=>'Page Events'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2938835944705259860)
,p_name=>'CA.PAGE.HELP'
,p_message_text=>'Page Help'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921451503098955061)
,p_name=>'CA.PAGE.ITEM'
,p_message_text=>'Page Item'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(306084580369305986)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_text=>'Edit Master Record'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(306085151364316004)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_text=>'Perform Search'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921416824294189829)
,p_name=>'CA.PAGE.NAME'
,p_message_text=>'Page Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935898000767860540)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_text=>'Page Navigation'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921449719036928183)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_text=>'Page Performance'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3206408857016053819)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_text=>'The page type "%0" is not a valid type'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921423836679337395)
,p_name=>'CA.PAGE.VIEWS'
,p_message_text=>'Page Views'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647122505941384402)
,p_name=>'CA.PAGES'
,p_message_text=>'Pages'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647124679145403885)
,p_name=>'CA.PAGES.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define page(s) to include in your initial application. You must define at least one page before you can create your application.</p>',
'<p>You can stub out your application by creating any number of pages using this wizard. After you create your application, use the Create Page Wizard to add more pages.</p>',
''))
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921448964769917006)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_text=>'Partial Page Views'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922148130990659903)
,p_name=>'CA.PHOTO'
,p_message_text=>'Photo'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922161316240161037)
,p_name=>'CA.PHOTO.DELETED'
,p_message_text=>'Photo deleted.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922148318819662307)
,p_name=>'CA.PHOTO.NAME'
,p_message_text=>'Photo Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922147703988645764)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_text=>'Photo Upload'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729555122900439590)
,p_name=>'CA.PK_VALUE'
,p_message_text=>'Primary Key Value'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922456249113954248)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_text=>'Plain Text Template'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3966760656261222915)
,p_name=>'CA.POSITIVE'
,p_message_text=>'Positive'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2920379632736563641)
,p_name=>'CA.PREFERENCES'
,p_message_text=>'Preferences'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3628792320592380959)
,p_name=>'CA.PREVIOUS'
,p_message_text=>'Previous'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390024006095846922)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_text=>'Primary Display Column'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390026050362867650)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_text=>'Primary Key Column'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390026294670870095)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_text=>'Primary Parent Table'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921450107191942687)
,p_name=>'CA.PROCEDURE'
,p_message_text=>'Procedure'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921186111635760269)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_text=>'Email preference updated.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(306081884568225546)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_text=>'Fetch Row'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(730884159655757356)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_text=>'Get Log Detail'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921196362084932673)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_text=>'Application Appearance Settings Saved.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921184726999736101)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_text=>'Time zone preference updated.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922150930242763343)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_text=>'Profile Photo Download'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184710544504827181)
,p_name=>'CA.PROGRAM.NAME'
,p_message_text=>'Program Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184711049660828195)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_text=>'Program Owner'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8400704891022574)
,p_name=>'CA.PUSH_NOTIFICATIONS'
,p_message_text=>'Push Notifications'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802204012551267)
,p_name=>'CA.PUSH_NOTIFICATIONS.DESC'
,p_message_text=>'Allow users to receive push notifications'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8400950437056990)
,p_name=>'CA.PUSH_NOTIFICATIONS.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Web push notifications are a way for web apps to send notifications to a user''s device even when the user is not currently on the website. These notifications can be sent to a user''s desktop or mobile device, and can be used to alert the user to n'
||'ew content or events on the website, or to re-engage the user with the website.</p>',
'<p>Enabling this option will:</p>',
'<ul>',
'<li>Add a new navigation bar entry: User Settings.</li>',
'<li>Allow users to subscribe and unsubscribe to push notifications.</li>',
'<li>When subscribed, allow users to receive push notifications from the APEX app.</li>',
'</ul>',
'<p><p/>'))
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8303470570504542)
,p_name=>'CA.PWA'
,p_message_text=>'Install Progressive Web App'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8303126569420677)
,p_name=>'CA.PWA.DESC'
,p_message_text=>'Give your app the ability to be installed'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8303569104504543)
,p_name=>'CA.PWA.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Progressive Web Apps are web applications designed to be capable, reliable, and installable. A Progressive Web App feels like a platform-specific application.</p>',
'<p>Enabling this option will:</p>',
'<ul>',
'<li>Add a new navigation bar entry: Install App</li>',
'<li>Allow users to install this APEX app on devices</li>',
'</ul>',
'<p><p/>',
'<p>If Persistent Authentication is enabled for this instance, the Login Page will display a "Remember me" checkbox, which when selected, allows end users to stay signed in to their Progressive Web App.</p>',
'<p><p/>'))
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390024824586855924)
,p_name=>'CA.QUERY'
,p_message_text=>'Query'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184694772184797913)
,p_name=>'CA.RAISE.EVENTS'
,p_message_text=>'Raise Events'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(51353868030904935)
,p_name=>'CA.RATING'
,p_message_text=>'Rating'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921934855677205460)
,p_name=>'CA.READERS'
,p_message_text=>'Readers'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2920780137439587848)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_text=>'Receive Emails'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3431139186824999439)
,p_name=>'CA.RECENT.ERRORS'
,p_message_text=>'Recent Errors'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561194524277112528)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_text=>'Label'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561194741717116834)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_text=>'Value'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921244536718109466)
,p_name=>'CA.RED'
,p_message_text=>'Red'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922444587124818185)
,p_name=>'CA.REFERENCED'
,p_message_text=>'Referenced'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305931329303042545)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_text=>'Refresh Admin Page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106496011282431005)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_text=>'Refresh on Dialog Close'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(306084859968311072)
,p_name=>'CA.REFRESH_REPORT'
,p_message_text=>'Refresh Report'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921242785371085147)
,p_name=>'CA.REGION.BUTTONS'
,p_message_text=>'Buttons Region'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921242506708082584)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_text=>'Form Items Region'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921451787738957119)
,p_name=>'CA.REGION.ID'
,p_message_text=>'Region ID'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935889526988777728)
,p_name=>'CA.RELEASE'
,p_message_text=>'Release %0'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647112026204284365)
,p_name=>'CA.REMOVING.PAGES'
,p_message_text=>'Removing Pages'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647113862303314729)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_text=>'<p>Click <strong>Edit</strong> to select the page, then click <strong>Delete Page</strong> to remove a page from your application.</p>'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184713690066839655)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_text=>'Repeat Interval'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129925254742099427)
,p_name=>'CA.REPLY.TO'
,p_message_text=>'Reply To'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722690195303784669)
,p_name=>'CA.REPORT'
,p_message_text=>'Add Report Page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2722689894579782954)
,p_name=>'CA.REPORT.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a page which displays either as an interactive report or a classic report.</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'  <li><strong>Query Type</strong> - Select the source for the report [<strong>Table or View</strong> or <strong>SQL Query</strong>]:<br>',
'    <strong>Table or View</strong>:',
'    <ul>',
'      <li>Table or View (Mandatory) - Select the database object for the report.</li>',
'      <li>Include Form - Select to include a linked form page to enable users to maintain the table values.</li>',
'    </ul>',
'    <strong>SQL Query</strong>:',
'    <ul>',
'      <li>SQL Query (Mandatory) - Enter a valid SQL statement which returns distinct columns.</li>',
'    </ul>',
'  </li>',
'  <li><strong>Report Type</strong> - Select the type of report (<strong>Interactive Report</strong> or <strong>Classic Report</strong>).</li>',
'</ul>'))
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2639505674780625869)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_text=>'%0 with Form'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626527526045993891)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_text=>'%0 Report'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3405071059508413435)
,p_name=>'CA.REPORT.VIEW'
,p_message_text=>'Report View'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390028597888900267)
,p_name=>'CA.REPORTS'
,p_message_text=>'Reports'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184723207341856267)
,p_name=>'CA.REQ.START.DATE'
,p_message_text=>'Requested Start Date'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390697972613532537)
,p_name=>'CA.REQUIRED'
,p_message_text=>'Required'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922458096978996863)
,p_name=>'CA.RESET'
,p_message_text=>'Reset'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922403834124950043)
,p_name=>'CA.RESOLVED'
,p_message_text=>'Resolved'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922403192123945882)
,p_name=>'CA.RESPONSE'
,p_message_text=>'Response'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184699991090809019)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_text=>'Restart on Failure'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184700217011810026)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_text=>'Restart on Recovery'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184691195850760870)
,p_name=>'CA.RESTARTABLE'
,p_message_text=>'Restartable'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184698734822805108)
,p_name=>'CA.RETRY.COUNT'
,p_message_text=>'Retry Count'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3351725351649654702)
,p_name=>'CA.ROLE'
,p_message_text=>'Role'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921452624642961195)
,p_name=>'CA.ROW.NUMBER'
,p_message_text=>'Row Number'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922456676511960168)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_text=>'Row Template'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3320295483017269069)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_text=>'Row Template HTML'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3358847878805966412)
,p_name=>'CA.ROWS.CONTENT'
,p_message_text=>'Rows Content'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921454937448029010)
,p_name=>'CA.ROWS.FETCHED'
,p_message_text=>'Rows Fetched'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390022382213828818)
,p_name=>'CA.ROWSPERPAGE'
,p_message_text=>'Rows Per Page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184712836848835869)
,p_name=>'CA.RUN.COUNT'
,p_message_text=>'Run Count'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184720942320854525)
,p_name=>'CA.RUN.DURATION'
,p_message_text=>'Run Duration'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184697604379803639)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_text=>'Schedule Limit'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184709079948822077)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_text=>'Schedule Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184709439332823002)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_text=>'Schedule Owner'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184708472719820986)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_text=>'Schedule Type'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731733063481980184)
,p_name=>'CA.SCHEMA'
,p_message_text=>'Schema'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731733228397992154)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_text=>'<p>Select the database schema which stores the database objects you want to use in this application.</p>'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390018252112802925)
,p_name=>'CA.SCOPE'
,p_message_text=>'Scope'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922458366526000876)
,p_name=>'CA.SEARCH'
,p_message_text=>'Search'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922458581105002968)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_text=>'Search Application'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922458795420013267)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_text=>'Search Dialog'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3407190128711818051)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_text=>'Search Filters'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2979318503405336246)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This page is driven off of the Shared Component list called Searched Tables.',
'',
'Any Interactive Report pages initially generated from the Create Application wizard will automatically be added to the list. ',
'To add your own tables to the list then navigate to Shared Components, select Lists, and then click on Searched Tables.',
'  Enter the following attributes:',
'    Entry: List Entry Label - enter the display name for the table.',
'    Target: Page - select the appropriate page to navigate to (preferably an Interactive Report)',
'    Target: Clear Cache - enter any pages that need to be cleared (generally the same number as entered under Page).',
'       If navigating to an Interactive Report page then add CIR,RIR to clear any existing filters, and so forth.',
'    Target: Set these items - select (or enter) the appropriate page item to be populated.',
'       If navigating to an Interactive Report page then enter IR_[COLUMN_NAME].',
'    Target: With these values - enter =PK=',
'    User Defined Attributes: 1 - enter the table name to search in upper case.',
'    User Defined Attributes: 2 - enter the primary column name in upper case.',
'    User Defined Attributes: 3 (Optional) -  comma separated list of columns to search.',
'       If no columns are specified then all text (varchar2) and character large object (clob) columns are searched.',
'',
'Note: A list of available tables to search will only be displayed to users if more than one table is listed.'))
,p_version_scn=>37165899671117
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922457606955990007)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_text=>'Search Results'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390025862465865497)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_text=>'Secondary Display Column'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922435318931719505)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_text=>'Selected Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129923640465087400)
,p_name=>'CA.SEND.BEGIN'
,p_message_text=>'Send Begin'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129924419500094269)
,p_name=>'CA.SEND.COUNT'
,p_message_text=>'Send Count'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129923113039086608)
,p_name=>'CA.SEND.END'
,p_message_text=>'Send End'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129924204648093248)
,p_name=>'CA.SEND.ERROR'
,p_message_text=>'Send Error'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3760906540923234721)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_text=>'Send Emails'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3761376521066295477)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_text=>'Determines whether emails should be sent out when new feedback is received.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3414689778981199651)
,p_name=>'CA.SEND.FROM'
,p_message_text=>'Send From'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3313145483929833340)
,p_name=>'CA.SEND.TO'
,p_message_text=>'Send To'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935882209558754856)
,p_name=>'CA.SERIES'
,p_message_text=>'Series %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184720323546852349)
,p_name=>'CA.SESSION.ID'
,p_message_text=>'Session ID'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390018621208805615)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_text=>'Session State Protection'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731731806713947526)
,p_name=>'CA.SETTINGS'
,p_message_text=>'Settings'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731732040025949725)
,p_name=>'CA.SETTINGS.DESC'
,p_message_text=>'<p>Specify the settings used in the generation of the application.</p>'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2928846372034701001)
,p_name=>'CA.SHOW.ALL'
,p_message_text=>'Show All'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106120380074794251)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_text=>'Show/Hide Scope'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935896827679836189)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_text=>'Show Timezone'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2935892113919800507)
,p_name=>'CA.SIGN.IN'
,p_message_text=>'Sign In'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2939100174148497967)
,p_name=>'CA.SIGN.OUT'
,p_message_text=>'Sign Out'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184719716051851508)
,p_name=>'CA.SLAVE.PID'
,p_message_text=>'Slave PID'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184693965233793882)
,p_name=>'CA.SOURCE'
,p_message_text=>'Source'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3206409269930056506)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_text=>'The source type is not a valid type'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2979319378053356626)
,p_name=>'CA.SOURCES'
,p_message_text=>'Sources'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184708229509820188)
,p_name=>'CA.START.DATE'
,p_message_text=>'Start Date'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729546580814157996)
,p_name=>'CA.STARTED'
,p_message_text=>'Started'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184713038749836550)
,p_name=>'CA.STATE'
,p_message_text=>'State'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390697770980531635)
,p_name=>'CA.STATICDEFAULT'
,p_message_text=>'Static Default'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921396060126891486)
,p_name=>'CA.STATUS'
,p_message_text=>'Status'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184695682815799995)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_text=>'Stop on Window Close'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184696057595800681)
,p_name=>'CA.STORE.OUTPUT'
,p_message_text=>'Store Output'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922436841225744965)
,p_name=>'CA.SUBJECT'
,p_message_text=>'Subject'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922162868348185141)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_text=>'Submit Feedback'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(729547977336167046)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_text=>'Successful Rows'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390020645932812421)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_text=>'Suggested Visualization'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3092809477868655287)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_text=>'Supporting Objects'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3092810345861672837)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_text=>'<p>Enter code into the installation script, generally to create or manipulate database objects, or perform inserts / updates / deletes on existing records. Enter code into deinstallation, generally to remove (drop) database objects. These scripts wil'
||'l be incorporated into the Supporting Objects so that when you export the application it will perform these same updates in your test and production environments.</p>'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3092815282060745232)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter valid SQL and/or PL/SQL statements into Installation Script which are run when the application is imported.</p>',
'<p>If you want these statements also run in the current environment, and not just when the application is imported into another environment, click <strong>Run when creating application</strong>.</p>',
'<p>Enter valid SQL and/or PL/SQL statements into Deinstallation Script which are run when the application is deleted from App Builder.</p>',
''))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184694588562797200)
,p_name=>'CA.SYSTEM'
,p_message_text=>'System'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390024649542854875)
,p_name=>'CA.TABLE'
,p_message_text=>'Table'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731733474202994238)
,p_name=>'CA.TABLE.PREFIX'
,p_message_text=>'Framework Object Prefix'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731733627770005594)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an object prefix for use by the application. Some features add this prefix to database objects that they create (including packages and tables).</p>',
'<p>Warning: Ensure you enter a unique prefix that is not used by other applications. If not unique, the application may raise errors when being created and not function correctly.</p>'))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390026492417877892)
,p_name=>'CA.TABLECOLUMN'
,p_message_text=>'Table Column'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3313145601333834668)
,p_name=>'CA.TEMPLATE'
,p_message_text=>'Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922457454361978717)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_text=>'This template name is already being used.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922436605700742409)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_text=>'Template Name'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921391954075741175)
,p_name=>'CA.TEXT'
,p_message_text=>'Text'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129924099151089768)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_text=>'Text Body Size'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922443385126804940)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_text=>'Text Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921194528874912239)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_text=>'End User Theme Preference'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921195095555919908)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_text=>'If checked, end users may choose their own Theme Style using the Customize link.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921194874305916813)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_text=>'Allow End Users to choose Theme Style'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646819143387604543)
,p_name=>'CA.THEME.SELECTOR'
,p_message_text=>'Theme Style Selection'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621229113321566682)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_text=>'Update default application look and feel'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646819960845612088)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enables administrators to select a default color scheme (theme style) for the application. Administrators can also choose to allow end users to choose their own theme style. End users can simply click on the <em>Customize</em> button at the bottom'
||' of the home page, and select from the available theme styles. For example, users with visual impairment may prefer to utilize the <em>Vista</em> theme style which has a much higher color contrast.</p>',
'<p>Includes the following components:',
'<ul>',
'<li>Allows administrators can define the default theme style</li>',
'<li>Enables end users to select various theme styles</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731729942366878282)
,p_name=>'CA.THEME.STYLE'
,p_message_text=>'Theme Style'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2731730121275890778)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the default theme style used to display the application.</p>',
'<p>The style can readily be changed to another pre-defined style, or modified post generation. To change the style run the application and then click <strong>Theme Roller</strong> in the Developer toolbar.</p>'))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921453283701967288)
,p_name=>'CA.TIME'
,p_message_text=>'Time'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2920380645020574978)
,p_name=>'CA.TIME.ZONE'
,p_message_text=>'Time Zone'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646826518738991527)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_text=>'Time Zone Support'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621227560179541334)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_text=>'Set default and user time zones'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646825849153970053)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Allow end users to set their local time zone. This is important if your application tables utilize time zone aware date types (such as Timestamp with Local Time Zone) so that the reports and data entry reflect where end users are located.</p>',
'<p>Includes the following components:',
'<ul>',
'<li>Allow administrators to set the default time zone</li>',
'<li>Allow end users to select their time zone preference</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3431140134673030776)
,p_name=>'CA.TIMEFRAME'
,p_message_text=>'Timeframe'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3471198075494170547)
,p_name=>'CA.TIMELINE'
,p_message_text=>'Add Timeline Page'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3471263289412222102)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a page which displays a timeline which is especially useful for displaying updates.</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Page Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'  <li><strong>Table or View</strong> (Mandatory) - Select the database object for the timeline.</li>',
'  <li><strong>User Name</strong> (Mandatory) - Select the column from the table or view to use as the user displayed for the timeline entries.</li>',
'  <li><strong>Date</strong> (Mandatory) - Select the column from the table or view to use as the date for the timeline entries.</li>',
'  <li><strong>Event Name</strong> (Mandatory) - Select the column from the table or view to use as the title for the timeline entries.</li>',
'  <li><strong>Description</strong> - Select the column from the table or view to use as the description for the timeline entries.</li>',
'</ul>'))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921417259937197070)
,p_name=>'CA.TIMESTAMP'
,p_message_text=>'Timestamp'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921458393197078619)
,p_name=>'CA.TITLE'
,p_message_text=>'Title'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(129925677711102175)
,p_name=>'CA.TO'
,p_message_text=>'To'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921455540828037265)
,p_name=>'CA.TOP.USERS'
,p_message_text=>'Top Users'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921455762663042343)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_text=>'Top Users Chart'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921448735460914737)
,p_name=>'CA.TOTAL.ROWS'
,p_message_text=>'Total Rows'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921935562871212226)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_text=>'Default role for users not in access control list:'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921392107428743788)
,p_name=>'CA.TYPE'
,p_message_text=>'Type'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(257374300535647357)
,p_name=>'CA.UI.DEFAULTS'
,p_message_text=>'UI Defaults'
,p_version_scn=>117498983
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(257375130198663952)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_text=>'Set defaults for user interface settings, such as rows per page, and add list of values definitions. These settings are used when generating components within the application. '
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921392548960746848)
,p_name=>'CA.UNTIL'
,p_message_text=>'Until'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305009607760777247)
,p_name=>'CA.UPDATE'
,p_message_text=>'Update'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922150790998731722)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_text=>'Update Profile'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921393275486754997)
,p_name=>'CA.UPDATED'
,p_message_text=>'Updated'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921393414512757711)
,p_name=>'CA.UPDATED.BY'
,p_message_text=>'Updated By'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921417094747195980)
,p_name=>'CA.USER'
,p_message_text=>'User'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3195379971078958197)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_text=>'Add Multiple Users - Step 1'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3195380265360959518)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_text=>'Add Multiple Users - Step 2'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3195380600243961060)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_text=>'Add Multiple Users'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921451161914950682)
,p_name=>'CA.USER.AGENT'
,p_message_text=>'User Agent'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2936351423782899523)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_text=>'User Counts Report'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921457046707065611)
,p_name=>'CA.USER.NAME'
,p_message_text=>'Username'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922144971884615710)
,p_name=>'CA.USER.PROFILE'
,p_message_text=>'User Profile'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646826254388983218)
,p_name=>'CA.USER.PROFILES'
,p_message_text=>'User Profiles'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2621225210234534185)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_text=>'Allow users to update their profile'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2646826025625981905)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Allow end users to enter in additional information about themselves, including a picture or avatar, to personalize their account.</p>',
'<p>Includes the following components:',
'<ul>',
'<li>Setting page for end users to set their profile</li>',
'<li>Ability to upload photo / avatar</li>',
'</ul>',
'</p>'))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922146356654627051)
,p_name=>'CA.USERNAME'
,p_message_text=>'Username'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921936309585217163)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_text=>'Username format'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3207348034031295734)
,p_name=>'CA.USERNAMES'
,p_message_text=>'Usernames'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262698262181125779)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_text=>'Username Format'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3207350632665341464)
,p_name=>'CA.USERS.ADDED'
,p_message_text=>'User(s) added.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3350901784067397175)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_text=>'Users by Role'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922439174861764791)
,p_name=>'CA.USERS.INCLUDED'
,p_message_text=>'Users Included'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3207348797143310587)
,p_name=>'CA.USERS.TO.ADD'
,p_message_text=>'Users to Add'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922003303237247880)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_text=>'Username format updated.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109886988000332582)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_text=>'Valid Users Exist - Page Info'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3056992948347852373)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_text=>'Application ID already exists, or is reserved for another application.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(225738885909472966)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_text=>'Application name must be specified.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3353766588815615887)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_text=>'Must provide email addresses to send your email to.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3353765604996603820)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_text=>'Must provide email addresses or select a set of users to send your email to.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3353766169610610955)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_text=>'Must select a set of users to send your email to.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3057526203131860182)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_text=>'Table prefix must not be greater than six characters, must start with a letter, and only contain letters, numbers, and underscores.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3057936114198871699)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_text=>'Please enter a different Table Prefix. The following Database Objects already exist: %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922005918770308922)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_text=>'Username is not in a valid email address format. Please note the application''''s username format below.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2922005735362304681)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_text=>'Verify Email Format'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921456602216051989)
,p_name=>'CA.VIEW.AS'
,p_message_text=>'View As'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3108275020233179174)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_text=>'View Blueprint'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2928846164943698203)
,p_name=>'CA.VIEW.DETAILS'
,p_message_text=>'View Details'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3354911907549227891)
,p_name=>'CA.VIEW.EMAIL'
,p_message_text=>'View Email'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2938962816876268130)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_text=>'View My Profile'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921423268594331404)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_text=>'Weighted Performance'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3390698320925534642)
,p_name=>'CA.WIDTH'
,p_message_text=>'Width'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3649990863111799259)
,p_name=>'CA.WIZARD'
,p_message_text=>'Create Wizard Pages'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109885017554270299)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_text=>'Wizard Container'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3649996196165836832)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a collection of pages to be used as a wizard. Generally wizards are used for entering data across multiple steps.</p>',
'<p>Enter the following attributes:</p>',
'<ul>',
'  <li><strong>Wizard Name</strong> (Mandatory) - Enter a name for this page.</li>',
'  <li><strong>Set Icon</strong> - Select an icon to display in the navigation menu for this page.</li>',
'  <li><strong>Page Mode</strong> (Mandatory) - Select whether the wizard steps display as normal page, modal dialog or drawer. Select <strong>Normal Page</strong>, <strong>Modal Dialog</strong> or <strong>Drawer</strong>.</li>',
'  <li><strong>Step 1 ... 8</strong> - Enter the page name for the steps of the wizard.<br><em><strong>Note:</strong> Steps 5 - 8 are displayed as a name is entered for each previous step.</em></li>',
'</ul>'))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921457975337075480)
,p_name=>'CA.WORK.PHONE'
,p_message_text=>'Work phone'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921244318988109066)
,p_name=>'CA.YELLOW'
,p_message_text=>'Yellow'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(259432601146036795)
,p_name=>'CA.YES'
,p_message_text=>'Yes'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(51319200328373190)
,p_name=>'CACHED'
,p_message_text=>'Cached'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18836621004672418)
,p_name=>'CACHE_CREATED'
,p_message_text=>'Cache Created'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13865615425766823)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_text=>'Delete Data functionality is disabled.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9010606424108252)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_text=>'Add data functionality is disabled.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9010817506111448)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_text=>'Update data functionality is disabled.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73699120857866662)
,p_name=>'CALENDAR.NEXT'
,p_message_text=>'Next'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73697304580861976)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_text=>'Previous'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21777513516626683)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_text=>'Easy Calendar'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599926506288337367)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_text=>'Edit Calendar Entry'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4305321288245834)
,p_name=>'CALENDAR_POPUP'
,p_message_text=>'Calendar pop-up for %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47221208998715794)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_text=>'The calendar has been created successfully.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200695312104715640)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_text=>'Legacy Calendar Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21776104512624097)
,p_name=>'CALENDAR_TYPE'
,p_message_text=>'Calendar'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138974622964506611)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_text=>'No calendar templates found when attempting to copy from application %0 and template ID %1'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(202296720265917598)
,p_name=>'CANCEL'
,p_message_text=>'Cancel'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6253014660797937)
,p_name=>'CARD_ACTIONS'
,p_message_text=>'Card Actions'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455022416486968962)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_text=>'Cascading Style Sheets'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(293195619978388103)
,p_name=>'CHANGES'
,p_message_text=>'Changes'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(740659070554031061)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_text=>'Change Authentication'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195800222275030115)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_text=>'Change Database Size'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195796420020991565)
,p_name=>'CHANGE_REQUEST'
,p_message_text=>'Change Request'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(389072450102661347)
,p_name=>'CHANGE_WORKSPACE'
,p_message_text=>'Change Workspace'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184527231000483165)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_text=>'Character Set Column'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88140824815817440)
,p_name=>'CHART'
,p_message_text=>'chart'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2958109427171268)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Invalid chart query: %0<br><br>',
'Use the following syntax:',
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
'<tr><td>LABEL</td><td>Text that goes with the bar</td></tr>',
'<tr><td>VALUE</td><td>Numeric column that defines bar size</td></tr>',
'</table>',
''))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69504705708239462)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Invalid chart query.<br /><br /> Use the following syntax: <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>',
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
'<td>Numeric column that defines dial value.</td>',
'</tr>',
'<tr>',
'<td>MAX</td>',
'<td>Numeric column that defines Maximum dial value.</td>',
'</tr>',
'<tr>',
'<td>LOW (optional)</td>',
'<td>Numeric column that defines Minimum previous dial value.</td>',
'</tr>',
'<tr>',
'<td>HIGH (optional)</td>',
'<td>Numeric column that defines Maximum previous dial value.</td>',
'</tr>',
'</table>'))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91347420304253520)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_text=>'Invalid chart type.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2953401799093358)
,p_name=>'CHART.INVALID_QUERY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Failed to parse SQL query!',
'<p>%0</p>',
'Certain queries can only be executed when running your application, if your query appears syntactically correct, you can save your query without validation (see options below query source).'))
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1142980177132061296)
,p_name=>'CHART_DEGREES'
,p_message_text=>'degrees'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175290602904159247)
,p_name=>'CHART_PAGE'
,p_message_text=>'%0 Chart'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14515306749524246)
,p_name=>'CHART_SERIES'
,p_message_text=>'Chart Series'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(193582863065333859)
,p_name=>'CHART_SERIES_ERROR'
,p_message_text=>'Chart series error %0 for %1.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44579130448227170)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_text=>'The chart has been created successfully.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179146631742550328)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_text=>'Checksum Required - Application Level'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114385932590813391)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_text=>'Checksum Required - Session Level'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114385521854810236)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_text=>'Checksum Required - User Level'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114385122416800939)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_text=>'Checksum Required - Application Level'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1198925881914331852)
,p_name=>'CHECK_ALL'
,p_message_text=>'Check All'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170067226467546740)
,p_name=>'CLASSIC_CALENDAR'
,p_message_text=>'Classic Calendar'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171347196809995472)
,p_name=>'CLASSIC_REPORT'
,p_message_text=>'Classic Report'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(68338261711239053)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_text=>'Classic Report Columns'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170214869730857302)
,p_name=>'CLASSIC_TREE'
,p_message_text=>'Classic Tree'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169454129488056891)
,p_name=>'CLEAN_UP'
,p_message_text=>'Clean Up Page'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12272112996747369)
,p_name=>'CLEAR_COMMAND'
,p_message_text=>'Clear Command'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173214002327361890)
,p_name=>'CLOSED'
,p_message_text=>'Closed'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192598428012185091)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_text=>'Closed Last 7 Days'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108366527719365876)
,p_name=>'CLOSE_WINDOW'
,p_message_text=>'Close Window'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569810570021911617)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_text=>'Accessibility Mode'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601539083859649)
,p_name=>'CODE_EDITOR.BRACKET_PAIR_COLORIZATION'
,p_message_text=>'Bracket Pair Colorization'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1942172821221687)
,p_name=>'CODE_EDITOR.CHAT.AI_DEBUG_MESSAGE'
,p_message_text=>'Let me find out if I can help you with this problem...'
,p_is_js_message=>true
,p_version_scn=>127322887
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2067065080673299)
,p_name=>'CODE_EDITOR.CHAT.APEX_ASSISTANT'
,p_message_text=>'APEX Assistant'
,p_is_js_message=>true
,p_version_scn=>128942990
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1615042601007557)
,p_name=>'CODE_EDITOR.CHAT.CLEAR_CHAT'
,p_message_text=>'Clear chat'
,p_is_js_message=>true
,p_version_scn=>126766172
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1944059314005008)
,p_name=>'CODE_EDITOR.CHAT.CONTENT_TOO_LONG'
,p_message_text=>'The content is too long, please select the relevant code snippet before proceeding.'
,p_is_js_message=>true
,p_version_scn=>126894751
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1615223326268556)
,p_name=>'CODE_EDITOR.CHAT.DEBUG_HELP_LABEL'
,p_message_text=>'Help me fix this'
,p_is_js_message=>true
,p_version_scn=>126926706
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1943882299992240)
,p_name=>'CODE_EDITOR.CHAT.DEBUG_MESSAGE'
,p_message_text=>'Given your latest suggested code, and based on your role''s expertise, analyze the code. Your objective is to find, give an explanation and a solution of any semantic and syntactic errors found in the code.'
,p_is_js_message=>true
,p_version_scn=>128400207
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614636815927683)
,p_name=>'CODE_EDITOR.CHAT.DISCLAIMER'
,p_message_text=>'Please note that AI-generated code may contain errors or security risks. Always review and validate all code before use.'
,p_is_js_message=>true
,p_version_scn=>127360209
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1944433659031093)
,p_name=>'CODE_EDITOR.CHAT.ERROR_CODE_MESSAGE'
,p_message_text=>'I have the following error: %0'
,p_is_js_message=>true
,p_version_scn=>128881709
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613188788786998)
,p_name=>'CODE_EDITOR.CHAT.EXPLAIN'
,p_message_text=>'Explain'
,p_is_js_message=>true
,p_version_scn=>126847928
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1612811905774561)
,p_name=>'CODE_EDITOR.CHAT.EXPLAIN_MSG'
,p_message_text=>'I''m having trouble understanding this code block. Can you please explain it to me?'
,p_is_js_message=>true
,p_version_scn=>128399987
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1612644059769040)
,p_name=>'CODE_EDITOR.CHAT.EXPLAIN_SELECTION'
,p_message_text=>'Explain selection'
,p_is_js_message=>true
,p_version_scn=>126847992
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614253069888170)
,p_name=>'CODE_EDITOR.CHAT.GENERAL_ASSISTANCE'
,p_message_text=>'General Assistance'
,p_is_js_message=>true
,p_version_scn=>126847848
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613366697820601)
,p_name=>'CODE_EDITOR.CHAT.GENERAL_WELCOME'
,p_message_text=>'How may I assist you?'
,p_is_js_message=>true
,p_version_scn=>126847801
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1612020351746619)
,p_name=>'CODE_EDITOR.CHAT.IMPROVE'
,p_message_text=>'Improve'
,p_is_js_message=>true
,p_version_scn=>126848012
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1612479003763071)
,p_name=>'CODE_EDITOR.CHAT.IMPROVE_MSG'
,p_message_text=>'Help me improve the quality, efficiency, and security of this code block.'
,p_is_js_message=>true
,p_version_scn=>128400022
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1612219867756283)
,p_name=>'CODE_EDITOR.CHAT.IMPROVE_SELECTION'
,p_message_text=>'Improve selection'
,p_is_js_message=>true
,p_version_scn=>126848083
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613819322856075)
,p_name=>'CODE_EDITOR.CHAT.INSERT'
,p_message_text=>'Insert'
,p_is_js_message=>true
,p_version_scn=>126761288
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614061807857011)
,p_name=>'CODE_EDITOR.CHAT.INSERTED'
,p_message_text=>'Inserted'
,p_is_js_message=>true
,p_version_scn=>126761331
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2031104478693631)
,p_name=>'CODE_EDITOR.CHAT.NEW_CONVERSATION'
,p_message_text=>'New conversation started'
,p_is_js_message=>true
,p_version_scn=>128664057
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614456618891715)
,p_name=>'CODE_EDITOR.CHAT.QUERY_BUILDER'
,p_message_text=>'Query Builder'
,p_is_js_message=>true
,p_version_scn=>126847871
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613554265825796)
,p_name=>'CODE_EDITOR.CHAT.QUERY_BUILDER_WELCOME'
,p_message_text=>'Hi there, I can help you author SQL based on tables and views in your current schema. What can I help you query?'
,p_is_js_message=>true
,p_version_scn=>126847825
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1943412843950167)
,p_name=>'CODE_EDITOR.CHAT.QUICK_ACTION_QUESTION'
,p_message_text=>'I see you have selected some code. How can I assist you with it?'
,p_is_js_message=>true
,p_version_scn=>126894118
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614801631959183)
,p_name=>'CODE_EDITOR.CHAT.USE_SELECTION'
,p_message_text=>'Use selection'
,p_is_js_message=>true
,p_version_scn=>126848107
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1943601007975573)
,p_name=>'CODE_EDITOR.CHAT.USE_THIS_WARNING'
,p_message_text=>'You need to select something in the editor first.'
,p_is_js_message=>true
,p_version_scn=>126894404
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1944641166035154)
,p_name=>'CODE_EDITOR.CHAT.WARNING_CODE_MESSAGE'
,p_message_text=>'I have the following warning: %0'
,p_is_js_message=>true
,p_version_scn=>128882367
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070519427711217189)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_text=>'Close Notification'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070522899432239079)
,p_name=>'CODE_EDITOR.FIND'
,p_message_text=>'Find'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070522074151233947)
,p_name=>'CODE_EDITOR.HINT'
,p_message_text=>'Auto Complete'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612168158276666759)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_text=>'Indentation'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070520692065225426)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_text=>'Indent Size'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070521006143228002)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_text=>'Tab Inserts Spaces'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569810790574912980)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_text=>'Item %0 does not exist'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569814199996924865)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_text=>'Minimap'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569813589575923845)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_text=>'Only when >100 lines'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5704521977081437)
,p_name=>'CODE_EDITOR.NEXT_CHANGE'
,p_message_text=>'Next Change'
,p_is_js_message=>true
,p_version_scn=>42339255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5705022020086340)
,p_name=>'CODE_EDITOR.PREVIOUS_CHANGE'
,p_message_text=>'Previous Change'
,p_is_js_message=>true
,p_version_scn=>42339255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3128836128978446134)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_text=>'Query Builder'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070523095943240568)
,p_name=>'CODE_EDITOR.REDO'
,p_message_text=>'Redo'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24283554067250207)
,p_name=>'CODE_EDITOR.ROLE_DESCRIPTION'
,p_message_text=>'editor'
,p_is_js_message=>true
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24283752625251254)
,p_name=>'CODE_EDITOR.ROLE_DESCRIPTION_READONLY'
,p_message_text=>'read only editor'
,p_is_js_message=>true
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070521611692231539)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_text=>'Settings'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070521269331229061)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_text=>'Show Line Numbers'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070520035602220881)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_text=>'Show Ruler'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569813320397922772)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_text=>'Show Suggestions'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070520878632226491)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_text=>'Tab Size'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070520470054223867)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_text=>'Theme'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569813196385921866)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_text=>'Automatic'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569812586543921002)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_text=>'Dark'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569812117518919233)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_text=>'High Contrast Dark'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569812322936920041)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_text=>'Light'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569811505815917246)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_text=>'Transform Code Case'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070523290278241609)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_text=>'Undo'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569811108660915040)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_text=>'Off'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569811353619915622)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_text=>'On'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070521842786232830)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_text=>'Validate'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3070523400641242424)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_text=>'Validation successful'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569810967931914225)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_text=>'Show Whitespace'
,p_is_js_message=>true
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146148925494206871)
,p_name=>'COLLAPSE'
,p_message_text=>'Collapse '
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15772413581087385)
,p_name=>'COLOR_PALETTE'
,p_message_text=>'Color Palette'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89774508950852044)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_text=>'Analogic'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89772822887837167)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_text=>'Complementary'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89780016578929941)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_text=>'Complementary Colors'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89774922456855939)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_text=>'Monotone'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89773231544839616)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_text=>'Split complementary'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89774118516845404)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_text=>'Tetrade'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89773606395841873)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_text=>'Triad'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1034586128171471312)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_text=>'Display Name: %0'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145364716519189011)
,p_name=>'COLUMN_NAME'
,p_message_text=>'Column Name'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261398804665946972)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_text=>'All authenticated users can access this application'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261399021093949653)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_text=>'Only users defined in the application access control list may access this application'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261400110339952687)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_text=>'Unexpected Access Control Setting Value: %0'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14634122985676876)
,p_name=>'COMING_SOON'
,p_message_text=>'Coming Soon'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145411825832238970)
,p_name=>'COMMENT'
,p_message_text=>'Comment'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108970405030089481)
,p_name=>'COMPILE_FAILURE'
,p_message_text=>'Compilation failed,line <a href="javascript:goToLine(''%0'')">%0</a> (%2)<br />%1'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(277637601187810539)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_text=>'Compilation failed, line %0 (%2) The line numbers associated with compilation errors are relative to the first BEGIN statement. This only affects the compilation of database triggers.<br />%1'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108963117188045685)
,p_name=>'COMPILE_SUCCESS'
,p_message_text=>'PL/SQL code successfully compiled (%0)'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172549003438857500)
,p_name=>'COMPLETE'
,p_message_text=>'Complete'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176657008786028133)
,p_name=>'COMPLETED'
,p_message_text=>'Completed'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180834903635975007)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_text=>'Complete / No issues'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192600716855276486)
,p_name=>'COMPONENT'
,p_message_text=>'Component'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(336418909105289891)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_text=>'Component Name: %0'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503109925131716571)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_text=>'Component not enabled'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(45312630174882950)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_text=>'The component has been successfully created.'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(973696800733323792)
,p_name=>'COMPONENT_SUMMARY'
,p_message_text=>'Component Summary'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3601001492839738)
,p_name=>'COMPONENT_TYPE.APP_ACL'
,p_message_text=>'Application Access Control Role'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3800214997860962)
,p_name=>'COMPONENT_TYPE.APP_COMPUTATION'
,p_message_text=>'Application Computation'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3800481017861988)
,p_name=>'COMPONENT_TYPE.APP_ITEM'
,p_message_text=>'Application Item'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3800694384862896)
,p_name=>'COMPONENT_TYPE.APP_PROCESS'
,p_message_text=>'Application Process'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3800871612863823)
,p_name=>'COMPONENT_TYPE.APP_SETTING'
,p_message_text=>'Application Setting'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3801083600865030)
,p_name=>'COMPONENT_TYPE.APP_STATIC_FILE'
,p_message_text=>'Application Static File'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3801274565865963)
,p_name=>'COMPONENT_TYPE.AUTHENTICATION'
,p_message_text=>'Authentication Scheme'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807498567899636)
,p_name=>'COMPONENT_TYPE.AUTHORIZATION'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3801420317866978)
,p_name=>'COMPONENT_TYPE.AUTOMATION'
,p_message_text=>'Automation'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3801642955868043)
,p_name=>'COMPONENT_TYPE.BREADCRUMB'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3802096797870070)
,p_name=>'COMPONENT_TYPE.BREADCRUMB_ENTRY'
,p_message_text=>'Breadcrumb Entry'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3801892605869095)
,p_name=>'COMPONENT_TYPE.BREADCRUMB_TEMPLATE'
,p_message_text=>'Breadcrumb Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3802426941872550)
,p_name=>'COMPONENT_TYPE.BUILD_OPTION'
,p_message_text=>'Build Option'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3802275313871380)
,p_name=>'COMPONENT_TYPE.BUILD_OPTION_STATUS'
,p_message_text=>'Build Option Status'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3802610033873691)
,p_name=>'COMPONENT_TYPE.BUTTON_TEMPLATE'
,p_message_text=>'Button Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3802887822874899)
,p_name=>'COMPONENT_TYPE.CALENDAR_TEMPLATE'
,p_message_text=>'Calendar Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5005762962232922)
,p_name=>'COMPONENT_TYPE.COMPONENT_GROUP'
,p_message_text=>'Component Group'
,p_version_scn=>15089495
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3803019024876030)
,p_name=>'COMPONENT_TYPE.CREDENTIAL'
,p_message_text=>'Credential'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3803406838878318)
,p_name=>'COMPONENT_TYPE.DATA_LOAD'
,p_message_text=>'Data Load'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3803621115879489)
,p_name=>'COMPONENT_TYPE.DATA_PROFILE'
,p_message_text=>'Data Profile'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2718621502374496)
,p_name=>'COMPONENT_TYPE.DYNAMIC_TRANSLATION'
,p_message_text=>'Dynamic Translation'
,p_version_scn=>9787507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3803853694880455)
,p_name=>'COMPONENT_TYPE.EMAIL_TEMPLATE'
,p_message_text=>'Email Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804098990881460)
,p_name=>'COMPONENT_TYPE.LABEL_TEMPLATE'
,p_message_text=>'Label Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3803228452877372)
,p_name=>'COMPONENT_TYPE.LEGACY_DATA_LOAD'
,p_message_text=>'Data Load ( Legacy )'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804432132883491)
,p_name=>'COMPONENT_TYPE.LIST'
,p_message_text=>'List'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2975027830389462)
,p_name=>'COMPONENT_TYPE.LIST_ENTRY'
,p_message_text=>'List Entry'
,p_version_scn=>51523235
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804236136882472)
,p_name=>'COMPONENT_TYPE.LIST_TEMPLATE'
,p_message_text=>'List Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804668478884754)
,p_name=>'COMPONENT_TYPE.LOV'
,p_message_text=>'List of Values'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1397990198384583)
,p_name=>'COMPONENT_TYPE.MAP_BACKGROUND'
,p_message_text=>'Map Background'
,p_version_scn=>37165881964536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804866310885930)
,p_name=>'COMPONENT_TYPE.MESSAGE'
,p_message_text=>'Text Message'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805031220886956)
,p_name=>'COMPONENT_TYPE.NAVBAR'
,p_message_text=>'Navigation Bar Entry'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805471348889102)
,p_name=>'COMPONENT_TYPE.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805620193890414)
,p_name=>'COMPONENT_TYPE.PAGE_GROUP'
,p_message_text=>'Page Group'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805232572888041)
,p_name=>'COMPONENT_TYPE.PAGE_TEMPLATE'
,p_message_text=>'Page Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805850809891477)
,p_name=>'COMPONENT_TYPE.PARENT_TAB'
,p_message_text=>'Parent Tab'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806030217892418)
,p_name=>'COMPONENT_TYPE.PLUGIN'
,p_message_text=>'Plug-in'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806236877893450)
,p_name=>'COMPONENT_TYPE.PLUGIN_SETTINGS'
,p_message_text=>'Plug-in Settings'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806417419894507)
,p_name=>'COMPONENT_TYPE.POPUP_LOV_TEMPLATE'
,p_message_text=>'Popup List of Values Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3809451544909666)
,p_name=>'COMPONENT_TYPE.PWA_SCREENSHOT'
,p_message_text=>'PWA Screenshot'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3809295250908628)
,p_name=>'COMPONENT_TYPE.PWA_SHORTCUT'
,p_message_text=>'PWA Shortcut'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806694299895496)
,p_name=>'COMPONENT_TYPE.REGION_TEMPLATE'
,p_message_text=>'Region Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806843909896576)
,p_name=>'COMPONENT_TYPE.REMOTE_SERVER'
,p_message_text=>'Remote Server'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807052100897550)
,p_name=>'COMPONENT_TYPE.REPORT_LAYOUT'
,p_message_text=>'Report Layout'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807652956900795)
,p_name=>'COMPONENT_TYPE.REPORT_QUERY'
,p_message_text=>'Report Query'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807208169898542)
,p_name=>'COMPONENT_TYPE.REPORT_TEMPLATE'
,p_message_text=>'Report Template'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808025892902570)
,p_name=>'COMPONENT_TYPE.SEARCH_CONFIG'
,p_message_text=>'Search Configuration'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807841333901628)
,p_name=>'COMPONENT_TYPE.SHORTCUT'
,p_message_text=>'Shortcut'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808252487903451)
,p_name=>'COMPONENT_TYPE.TAB'
,p_message_text=>'Tab'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808423226904405)
,p_name=>'COMPONENT_TYPE.TASK_DEFINITION'
,p_message_text=>'Task Definition'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3201066258335556)
,p_name=>'COMPONENT_TYPE.TEMPLATE_COMPONENT'
,p_message_text=>'Template Component'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808654210905348)
,p_name=>'COMPONENT_TYPE.TREE'
,p_message_text=>'Tree'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808819742906399)
,p_name=>'COMPONENT_TYPE.WEB_SERVICE'
,p_message_text=>'Web Service'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3809053947907500)
,p_name=>'COMPONENT_TYPE.WEB_SOURCE'
,p_message_text=>'REST Data Source'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(132491971547266883)
,p_name=>'COMPONENT_TYPE.WORKFLOW'
,p_message_text=>'Workflow'
,p_version_scn=>37165874167242
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3809698134910588)
,p_name=>'COMPONENT_TYPE.WS_STATIC_FILE'
,p_message_text=>'Workspace Static File'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26573222107305330)
,p_name=>'COMPUTATIONS'
,p_message_text=>'Computations'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(219338505351768650)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_text=>'Application components successfully installed.'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109160603009082215)
,p_name=>'CONDITIONAL'
,p_message_text=>'Conditional'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137153030635601954)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_text=>'popup list of values'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167846322494167848)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_text=>'always'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85091907321893783)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_text=>'exists'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85053030944806028)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_text=>'Expression'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85072900647835157)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_text=>'item / column=value'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85074028352843071)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_text=>'item / column not null'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(572077911133276296)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_text=>'item / column null'
,p_version_scn=>37165770887502
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85094624290898694)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_text=>'never'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85097002603901871)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_text=>'none'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85085927837880849)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_text=>'page in'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85090223120888950)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_text=>'page not in'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85075315669848918)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_text=>'request=e1'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86865826552763427)
,p_name=>'CONDITION_TYPE'
,p_message_text=>'Condition Type'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150820922375135385)
,p_name=>'CONFIRM'
,p_message_text=>'Confirm'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1819119104278786)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_text=>'Two page master detail'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1818612871276983)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_text=>'Three page master detail'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83741621054145676)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_text=>'Actual Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172150321712797363)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_text=>'Aggregate by Columns'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172153114009814070)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_text=>'Aggregate Functions to Use'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83629211143452101)
,p_name=>'CONFIRM.APPLICATION'
,p_message_text=>'Application'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84960224553217479)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_text=>'Alias'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84960619143225429)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_text=>'Default Language'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84959603774211504)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30326603162445855)
,p_name=>'CONFIRM.ARRAY'
,p_message_text=>'Result Tree to Report On'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30327010434447956)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_text=>'Result Parameters to Report On'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84962917542234410)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_text=>'Authentication'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(326398824931494617)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_text=>'Branch to Page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(140245428775019902)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_text=>'Break Columns'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83716430002044177)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_text=>'%0 Button Branch'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83715032641035557)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_text=>'%0 Button Display Text'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7012400231928635)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_text=>'Enable Adding Data'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7012215768904715)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_text=>'Enable Drag and Drop'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261944706055469953)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_text=>'Cancel Branch'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(326330706923489354)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_text=>'Cancel Button Label'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(297298419264914724)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_text=>'Case Sensitive'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108082004628024380)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_text=>'You have requested to change the Interactive Report query. If you removed any columns from the query, it will disable existing filters, highlight rules, and other report settings referencing those columns. Please confirm your request.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83890404206424749)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_text=>'Chart Axis'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203473409705410233)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_text=>'Dial'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203474817324412439)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_text=>'Dial (Sweep)'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83959621325590507)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_text=>'Horizontal Bar'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83961310028596692)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_text=>'Line'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83898511263436179)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_text=>'Number Mask'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83960431021593278)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_text=>'Pie'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83885909270416759)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_text=>'Chart Query'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83894412864427252)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_text=>'Scale'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83964025611601184)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_text=>'Scatter'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83947427380554416)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_text=>'Chart Size'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83946611104549672)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_text=>'Chart Title'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83945731059546010)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_text=>'Chart Type'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83952810327568385)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_text=>'Vertical Bar'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30342710322589858)
,p_name=>'CONFIRM.COLLECTION'
,p_message_text=>'Temporary Result Set Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83637803318535041)
,p_name=>'CONFIRM.COLUMNS'
,p_message_text=>'Columns'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(140179508287559813)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_text=>'Column Headings'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240029700019433381)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_text=>'Column Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261994626271485277)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_text=>'Column Name(s)'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84312222269584337)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_text=>'Use Column Heading Sorting'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115383228802117267)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_text=>'You have requested to copy an application with the following attributes. Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84220229111255163)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_text=>'You have requested to copy a page with the following attributes.  Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83681504750913953)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_text=>'A new tab set "%0" will be created and used by this page.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84958832256200806)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_text=>'You have requested to create an application with the following attributes.  Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84032115287777986)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_text=>'You have requested to create a calendar page with the following attributes.   Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84155707575069111)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_text=>'You have requested to create a drill down report page with the following attributes.   Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93460706616689925)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_text=>'You have requested to create an Interactive Report page with the following attributes. Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84279810401524144)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_text=>'You have requested to create a report page with the following attributes.   Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852521928585935732)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_text=>'You have requested to create an application using the same ID as an existing application in the current workspace. The existing application will be deleted and then replaced by the new application. Please confirm your selections. '
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236526520020512770)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_text=>'You have requested to create form and list view pages with the following attributes. Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172121326589675702)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_text=>'You have requested to create a form and a report page with analysis pages. Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84013706452737578)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_text=>'You have requested to create a form on SQL query with the following attributes.   Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84012121212732461)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_text=>'You have requested to create a form on stored procedure with the following attributes.   Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84009924198723832)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_text=>'You have requested to create a form on a table page with the following attributes.   Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22395309050346102)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_text=>'You have requested to create a form on a Web service reference page with the following attributes.   Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38956009470728152)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_text=>'You have requested to create a form and report on a Web service reference page with the following attributes.   Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184230915971057577)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_text=>'You have requested to create a Map page with the following attributes. Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1807521688165980)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_text=>'You have requested to create master detail pages with the following attributes. Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84064716513891867)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_text=>'You have requested to create a breadcrumb region and breadcrumb option with the following attributes.  Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175431427677330268)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_text=>'Create Mode'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83996527399705856)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_text=>'You have requested to create a page with the following attributes.  Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1728744384958605947)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_text=>'Create Page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1728745182668609740)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_text=>'Create Page Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84110608342974700)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_text=>'You have requested to create form and report pages with the following attributes.  Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(819414604293905684)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_text=>'You have requested to create a page with the following attributes. Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84229312367316547)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_text=>'You have requested to create a report page with the following attributes.  Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84015121343741885)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_text=>'You have requested to create an HTML Bar Chart Page with the following attributes.  Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84210505862220035)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_text=>'You have requested to create a summary page with the following attributes.  Press the "Add More" button to add additional items from other pages and/or regions. Press "Finish" to create the summary items.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84022417665750334)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_text=>'You have requested to create a SVG chart page with the following attributes.  Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83993721381694591)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_text=>'You have requested to create a tabular form page with the following attributes.   Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84043324815818579)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_text=>'You have requested to create a tree page with the following attributes. Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83997719911713164)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_text=>'You have requested to create a wizard with the following attributes.  Please confirm your selections.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138426605418559284)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_text=>'Link Label'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(615639618994709511)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_text=>'Data Load Definition Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(902243418172050374)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_text=>'This Data Load Definition will be recreated with the existing table lookups and transformation rules.'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(297302425498916480)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_text=>'Page Number'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84032629271791502)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_text=>'Date Column'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175991709779651307)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_text=>'Default Authentication Scheme'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83974520248637528)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_text=>'Delete'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84198211094174194)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_text=>'Detail %0 Display Columns'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1821022698289204)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_text=>'Detail Display Column(s)'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84206614257203482)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_text=>'Detail Breadcrumb Column'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84201925770187894)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_text=>'Detail Table %0 Order By'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84186212994136871)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_text=>'Detail Page %0'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1820614733286910)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_text=>'Detail Table'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84195110963164711)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_text=>'Detail Table Name %0'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84190831825151808)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_text=>'Detail Tab Label %0'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262006612550490724)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_text=>'Upload Column'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83806217048305430)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_text=>'Display Columns'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(239986813742259852)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_text=>'Upload Column 2'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(239987010938261114)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_text=>'Upload Column 3'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1859452456201370626)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_text=>'Edit Page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1859453093801372063)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_text=>'Edit Page Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135403411593346752)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_text=>'CSV Output'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135411721280973906)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_text=>'Print Output'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135417522066030987)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_text=>'Enable Column Heading Sorting'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150950888417606320)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_text=>'A region will be added to the existing Administration Page:'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261948711249471482)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_text=>'Finish Branch'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84127322588007244)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_text=>'Form Page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84127802979011040)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_text=>'Form Page Name'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84131125143017377)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_text=>'Form Page Tab Label'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84130613022013946)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_text=>'Form Page Tab Set'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176126223883648900)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_text=>'Import Shared Components From'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(497202016211813883)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_text=>'Include Custom Calendar'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1821807592294307)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_text=>'Include master report?'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84204814126194016)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_text=>'Include a Breadcrumb'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83712923160023286)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_text=>'Information Template'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83714207361028258)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_text=>'Information Default Text'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22397929884456194)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_text=>'Form Items'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30345527815632745)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_text=>'Form Region Template'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30344620542630727)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_text=>'Form Region Title'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83972424965629402)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_text=>'Insert'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83701300173007240)
,p_name=>'CONFIRM.ITEMS'
,p_message_text=>'Items'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262002604239488343)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_text=>'Return Column'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261859323014399107)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_text=>'Lookup Key Column 1'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261863529248400974)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_text=>'Key Column 2'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261867500636402127)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_text=>'Key Column 3'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84035014164796574)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_text=>'Label Column'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(239994016865395131)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_text=>'Lookup Owner'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261998631812486824)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_text=>'Lookup Table'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1822214518296327)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_text=>'Master Detail Layout'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1820208846285276)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_text=>'Master Display Column(s)'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1821400320292291)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_text=>'Navigate master record by'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1819830532282011)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_text=>'Master Table'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(140201620240601092)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_text=>'Maximum Number of Columns'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138409209802536157)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_text=>'Rows Per Page'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101146608951668706)
,p_name=>'CONFIRM.MENU'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84078523140922214)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_text=>'Breadcrumb Link'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84205224169196952)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_text=>'Breadcrumb Root'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84076825779913529)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_text=>'Breadcrumb Template'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84081702839925828)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_text=>'Breadcrumb Text'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23172706604083715)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_text=>'You have requested to upgrade the HTML chart to a new HTML5 chart. Please confirm your request.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945251552534553999)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_text=>'You have requested to upgrade the jsTree to a new Tree. Please confirm your request.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73484029469295415)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SVG chart will be upgraded with the following restrictions:  ',
'<ul>',
'<li>',
'Only number formats defined in axis format strings will be migrated.  Date and time formats will be ignored.',
'</li>',
'<li>',
'Number format elements containing the following will be migrated:',
'<br />',
'0,9,D,G,, (comma),. (period),$,C,L,FM',
'</li>',
'<li>',
'The label for each series in the Flash chart will be derived from each series'' column alias.  ',
'This differs from SVG charts, where the label for each series was derived from the Series Name attribute.',
'</li>',
'<li>',
'Flash Dial charts display actual values instead of percentages.',
'</li>',
'</ul>'))
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46897809780048121)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_text=>'You have requested to upgrade the SVG chart to a HTML5 chart.  Please confirm your request.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(818412717795920577)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_text=>'Navigation'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84964129232256696)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_text=>'Navigation Bar'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(486936856312805010)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_text=>'Navigation Menu List'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183300219613419824)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_text=>'A new Administration page will be added, Page:'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108086300603032691)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_text=>'New Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83743214259153187)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_text=>'New Template'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(326296424454484962)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_text=>'Next Button label'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83681105658904732)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_text=>'No tab set has been selected for this page.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83697102466998390)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_text=>'No Template'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22398303004457852)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_text=>'Output Items'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83830823459345159)
,p_name=>'CONFIRM.OWNER'
,p_message_text=>'Owner'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83630915907472398)
,p_name=>'CONFIRM.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84963301528248741)
,p_name=>'CONFIRM.PAGES'
,p_message_text=>'Pages'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83631600108477324)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_text=>'Page Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83680707604895771)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_text=>'Page Title'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84197231048170548)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_text=>'Parent Display Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84083520501930905)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_text=>'Parent Breadcrumb'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84205803176200356)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_text=>'Parent Breadcrumb Column'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84199705684182098)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_text=>'Parent Table Order By'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84185527408131648)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_text=>'Parent Page'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84194218450157460)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_text=>'Parent Table Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83683732501950333)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_text=>'Parent Tab Label'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83682916224945610)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_text=>'Parent Tab Set'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108037800020416014)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_text=>'Parsing Schema'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113109016577114145)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_text=>'Partial Page Refresh'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(326300431034486939)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_text=>'Previous Button label'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83639108990546076)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_text=>'Primary Key Column %0'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84134515924024248)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_text=>'Primary Key Column'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138427015115562017)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_text=>'Output Format'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(140263022260197709)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_text=>'Print Link Label'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138432405212644324)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_text=>'Report Printing'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83810010945313161)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_text=>'Process Options'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138411310541564744)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_text=>'Region Column'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83706502382017360)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_text=>'Region Template'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83634724050512649)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_text=>'Region Title'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84070419415902174)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_text=>'Region Type'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108084024021029996)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_text=>'Removed Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146155504163285903)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_text=>'Report Implementation'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84122401678991717)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_text=>'Report Page'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84123216223995906)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_text=>'Report Page Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84126911852004107)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_text=>'Report Page Tab Label'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84125830768000098)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_text=>'Report Page Tab Set'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30346630024642892)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_text=>'Report Region Template'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30346223790641127)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_text=>'Report Region Title'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84290214818544312)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_text=>'Report Template'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32197317394970783)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_text=>'Row Version Column'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84295815296553924)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_text=>'default: HTML (standard)'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84300617505563987)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_text=>'default: Look 1'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84303328240567119)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_text=>'default: Look 2'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107705726948742483)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_text=>'default: Look 3'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107707500760744404)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_text=>'default: Look 4'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31532527800826069)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_text=>'default: Look 5'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84297930533558343)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_text=>'default: vertical report'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84305108285570856)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_text=>'export: CSV'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84306817636573518)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_text=>'export: XML'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84299206769560958)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_text=>'default: vertical report, look 1 (include null columns)'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107696406385727073)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_text=>'default: vertical report, look 2 (exclude null columns)'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107703919330740339)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_text=>'default: vertical report, look 2 (include null columns)'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262104926880504309)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_text=>'Rule Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262128900345506131)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_text=>'Sequence'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262132904847507404)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_text=>'Rule Type'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14409918408338346)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_text=>'You have requested to run the following script.  Please confirm your request.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84077510673918613)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_text=>'Sequence'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84073108810908627)
,p_name=>'CONFIRM.SLOT'
,p_message_text=>'Slot'
,p_version_scn=>37165770887503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84293027285547888)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_text=>'Sort Option'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83866207707378452)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_text=>'SQL Query'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113107824411106963)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_text=>'Standard'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150744926557143983)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_text=>'Multiple pages will be created, starting with Page:'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83837400041347840)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_text=>'Stored Procedure Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108747129005840662)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_text=>'Stored Procedure Owner'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(326383316273492066)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_text=>'Finish Button Label'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(926588757347489760)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_text=>'Subscribe Theme'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83739605816141345)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_text=>'Suggested Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172146718334777420)
,p_name=>'CONFIRM.TABLE'
,p_message_text=>'Table / View'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172147430454780949)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_text=>'Summarize By Column'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355173116897830984)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_text=>'Table Lookups'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83636820502530530)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_text=>'Table Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83635906650526508)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_text=>'Table Owner'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(438030407548222259)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_text=>'Transformation Rule'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262136920431511936)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_text=>'Transformation Rules'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108113313936798447)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_text=>'Table / View Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108112908049796749)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_text=>'Table / View Owner'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84963718151253552)
,p_name=>'CONFIRM.TABS'
,p_message_text=>'Tabs'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83682414708935691)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_text=>'Warning, tabset information is incomplete.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83635525566522484)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_text=>'Tab Label'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84231926696330131)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_text=>'Tab Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83635112060518636)
,p_name=>'CONFIRM.TAB_SET'
,p_message_text=>'Tab Set'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84308130103577082)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_text=>'template:'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84056714735863028)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_text=>'Based on new item with popup list of values'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84054528672848151)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_text=>'Max Levels'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84048902221830992)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_text=>'Tree Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84055323954856200)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_text=>'Tree Query'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84057626856866535)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_text=>'Based on a SQL Query'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84054911141852527)
,p_name=>'CONFIRM.TREE_START'
,p_message_text=>'Start Tree'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84058207940870527)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_text=>'Static value'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84050018151835644)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_text=>'Tree Type'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84964508239260082)
,p_name=>'CONFIRM.UI_THEME'
,p_message_text=>'Theme'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84964904214268381)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_text=>'Blue and Tan'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84965424300274208)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_text=>'Red'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84965830880276110)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_text=>'Navy and Gray'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84966203306277655)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_text=>'Olive'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84966608501279118)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_text=>'Maroon'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84967013349280524)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_text=>'Simple Blue and Tan'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84967421660282932)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_text=>'Blue'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84967827894284732)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_text=>'None'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83638722019540369)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_text=>'Updateable Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83973806050633440)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_text=>'Update'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83681906612923875)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_text=>'This page will use the existing tab set "%0".'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22396020094396573)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_text=>'Web Service Reference, Operation'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84141114454042698)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_text=>'Where Clause'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166873618268598741)
,p_name=>'CONFIRMATION_ICON'
,p_message_text=>'Confirmation Icon'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172716023045270728)
,p_name=>'CONFIRMED'
,p_message_text=>'Confirmed'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172716804476274747)
,p_name=>'CONFIRMED_BY_QA'
,p_message_text=>'Confirmed by QA'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138433303265653176)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_text=>'Break Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138432816987647720)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_text=>'Print Format'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2404616616773834)
,p_name=>'CONSTRAINT.PLUGIN_ATTR_GROUP_UK'
,p_message_text=>'Title is already in use.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2404464983771917)
,p_name=>'CONSTRAINT.WWV_FLOW_PLUGIN_EVNT_UK'
,p_message_text=>'Internal event name is already in use.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184527530092492358)
,p_name=>'CONTENT_DISPOSITION'
,p_message_text=>'View File As'
,p_version_scn=>5717867
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203709630611302300)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_text=>'Content Served'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3302267252408311822)
,p_name=>'CONTRIBUTORS'
,p_message_text=>'Contributors'
,p_version_scn=>37165770887506
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066442187509685842)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_text=>'New Static ID'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107621953694815859)
,p_name=>'COPY_ACTION'
,p_message_text=>'Copy Action'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46517020668056138)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_text=>'Your application has been copied.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(102720203089575632)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_text=>'Error during execution of copy_button: %0 >> %1'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115671112908765514)
,p_name=>'COPY_DEPLOYMENT'
,p_message_text=>'Copy Object Definition Attributes'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40669212803910647)
,p_name=>'COPY_EXISTING_APP'
,p_message_text=>'Copy Application'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236701410487836285)
,p_name=>'COPY_FEATURE'
,p_message_text=>'Copy Feature: %0'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115665011607746282)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_text=>'Copy From Application'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(377458612114590405)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_text=>'Based on Template Application'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115665825460750295)
,p_name=>'COPY_FROM_NAME'
,p_message_text=>'Copy from Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47542815619438356)
,p_name=>'COPY_LIST_ENTRY'
,p_message_text=>'Copy List Entry'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(102751817942627200)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_text=>'Error during execution of copy_named_lov: %0'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(102747529932621210)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_text=>'List of Values ID "%0" not found.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(102741206383614374)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_text=>'List of Values ID "%0" is not numeric.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(210014620633797439)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_text=>'Copy From Page'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(210015401371801385)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_text=>'Copy To Page'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(208515000750011720)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_text=>'- Select Authorization-'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(208498619909875377)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_text=>'- Select List -'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(208331327285592030)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_text=>'- Select List of Values -'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270368600686936356)
,p_name=>'COPY_TABLE'
,p_message_text=>'Copy %0 to table %1'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115666500657752567)
,p_name=>'COPY_TO_APPLICATION'
,p_message_text=>'Copy To Application'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115669012777756014)
,p_name=>'COPY_TO_NAME'
,p_message_text=>'Copy to Name'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88198422380441257)
,p_name=>'CORE'
,p_message_text=>'core'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359347306899198143)
,p_name=>'CREATE APPLICATION'
,p_message_text=>'Create Application'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359353919067230028)
,p_name=>'CREATE OBJECT'
,p_message_text=>'Create Object'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236544221265573001)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_text=>'Created last 7 days'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40669423885913852)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_text=>'From an application template'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(618908211023219939)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_text=>'Candlestick Charts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(618907814355211391)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_text=>'2D and 3D Column, Bar and Stacked Charts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(618915511772324226)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_text=>'Dial and Dial (Percent) Charts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(618908025437214669)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_text=>'2D and 3D Pie and Doughnut Charts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(618910226738233977)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_text=>'Project Gantt Charts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(618915202422321555)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_text=>'2D and 3D Range Charts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(618910903320236649)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_text=>'Resource Gantt Charts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(618908802497226975)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_text=>'Scatter Marker Charts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87880010753981624)
,p_name=>'CREATE_CONDITION.AND'
,p_message_text=>'AND'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87879208544971469)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_text=>'Arrow Down'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87879626552976677)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_text=>'Arrow Right'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87878327197948501)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_text=>'Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87878820056955889)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_text=>'Conditions'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87880424951985732)
,p_name=>'CREATE_CONDITION.OR'
,p_message_text=>'OR'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87881504089998606)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_text=>'Preview Condition'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236985217260207312)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_text=>'Click on the Grant Privileges button below to grant these privileges now to %0.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236982701330202732)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_text=>'%0 does not have CREATE TABLE, CREATE VIEW, CREATE TRIGGER, CREATE SEQUENCE or CREATE PROCEDURE privilege and will not be able to install the demonstration application.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236984208948204945)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'%0 does not have execute privilege on CTX_DOC and CTX_DDL and will not be able to install the President''s Inaugural demonstration.  Perform the following grants as a privileged user: ',
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(481306458436268516)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_text=>'Create Button - Dialog Closed'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12822302047712450)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_text=>'Create Dynamic List'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108620632556503516)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_text=>'Create Dynamic List of Values'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5020515591120823)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_text=>'Oracle Cloud Identity Management'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19313909795983710)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_text=>'Database Account'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361689301600139463)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_text=>'Oracle APEX Authentication'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(238410706844459393)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_text=>'LDAP'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(818415061995974022)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_text=>'Navigation Menu List'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361689915106143338)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_text=>'No Authentication'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361686817259049333)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_text=>'No Tabs'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361687330765053241)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_text=>'One Level of Tabs'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(238413104204468005)
,p_name=>'CREATE_FLOW.SSO'
,p_message_text=>'Single Sign On (SSO)'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361687810810056919)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_text=>'Two Levels of Tabs'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40669031373906620)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_text=>'From a spreadsheet'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3267030017882614)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_text=>'Global page components are displayed on all pages if their region''s slot is contained within the selected page template.  Conditional Display attributes can be used to suppress display.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(96878610610811768)
,p_name=>'CREATE_INDEX'
,p_message_text=>'Create Index'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146974531694708406)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_text=>'no region associated'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88192610381371516)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_text=>'Create new login page.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87906532513233934)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_text=>'Back to Create Table Wizard'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87903006147197894)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_text=>'Browse Package'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87902231166186180)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_text=>'The package "%0" has been created in the "%1" schema.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87908128751261177)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_text=>'Creating table "%0" failed.'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87904608141217443)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_text=>'Home'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87903804547206903)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_text=>'Return to'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87904223940212505)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_text=>'SQL&nbsp;Workshop'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87903418614201542)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_text=>'SQL Workshop Home'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87126316003224021)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_text=>'No items found'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87120925438207806)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_text=>'Page Items'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87125001805219905)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_text=>'Prompt'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87122506522211862)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_text=>'Region'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87123920721215917)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_text=>'click to set region'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87075818708044990)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_text=>'Page Items'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87077500485049266)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_text=>'Region'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87899628002156915)
,p_name=>'CREATE_TABLE.HOME'
,p_message_text=>'Home'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87898129256147797)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_text=>'Return to'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87897407785141651)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_text=>'Run Script'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87894509255123107)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_text=>'The create table script for table %0 has been created in the SQL script repository.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87895703499130887)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_text=>'Go to Script Repository'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87899117959154028)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_text=>'SQL&nbsp;Workshop'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87896421853136195)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_text=>'SQL Workshop Home'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(328774415577711156)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_text=>'Tabular Form'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932215187057657001)
,p_name=>'CREATE_TO_DO'
,p_message_text=>'Create To Do'
,p_is_js_message=>true
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184693178038789934)
,p_name=>'CREDENTIAL.OWNER'
,p_message_text=>'Credential Owner'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170067083232545137)
,p_name=>'CSS_CALENDAR'
,p_message_text=>'Calendar'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136638301939904394)
,p_name=>'CURRENT'
,p_message_text=>'Current'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166135932213196828)
,p_name=>'CURRENT ENTRY'
,p_message_text=>'Current Entry'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166097702412036871)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_text=>'Current form element'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90151232732051153)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_text=>'Current Item Help Text'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166098106222037924)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_text=>'Current Item Identification Number'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166098819381041767)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_text=>'Current Item Label Name'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190185901636881615)
,p_name=>'CURRENT TAB'
,p_message_text=>'Current Tab'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86583305232217917)
,p_name=>'CURRENT_APPLICATION'
,p_message_text=>'Current Application'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86861115339750755)
,p_name=>'CURRENT_IMAGE'
,p_message_text=>'Current Image'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(390643202413553513)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_text=>'ID that can be used on a container element that wraps the current field, in the Before Label and Item attribute.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(955847408211879160)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_text=>'Current Item Help Label'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69205826774176619)
,p_name=>'CURRENT_MILESTONE'
,p_message_text=>'Current Milestone'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86841910313711400)
,p_name=>'CURRENT_PAGE'
,p_message_text=>'Current Page'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179939314231236701)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_text=>'Current Page Contains No Items.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(162226704929487232)
,p_name=>'CUSTOMIZE LINK'
,p_message_text=>'Customize Link'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573712549030153071)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_text=>'Custom Applications'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12749202396995794)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_text=>'Developer Defined'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100935527759955492)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_text=>'Error in %0'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69336821132118100)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_text=>'Enter any string to be used as your user identifier for this session.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69337502909122300)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_text=>'Enter your %0 username and password.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69338606157132723)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_text=>'Enter your username and password for verification by LDAP host: %0.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69354024782232780)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_text=>'Enter your database schema username and password.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(497765815001951590)
,p_name=>'CUSTOM_CALENDAR'
,p_message_text=>'Reload'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500101730575457743)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_text=>'End Date'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(500101522610455453)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_text=>'Start Date'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(272511924560338779)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When the True Action is Set Value with a Set Type of SQL Statement, you need to define the Affected Elements in the same order as the column order of your SQL statement. The SQL Statement you defined was:</p>',
'<pre>%0</pre>'))
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145056710932458773)
,p_name=>'DATA'
,p_message_text=>'Data'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359249325983156343)
,p_name=>'DATA WORKSHOP'
,p_message_text=>'Data Workshop'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105840611346370368)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_text=>'All %0 columns have been automatically mapped to the %1 table.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105991816286974911)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_text=>'Data in table <code>%0</code> appended with <b id="incompl_success_row_count"></b> new rows. <b class="u-danger-text" id="incompl_fail_row_count"></b> rows rejected.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105985239488554324)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_text=>'Data in table <code>%0</code> appended with <b id="success_row_count"></b> new rows!'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105987278022579060)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_text=>'Data in table <code>%0</code> appended with <b id="err_success_row_count"></b> new rows. <b class="u-danger-text" id="err_fail_row_count"></b> rows rejected.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3781904745619163)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_text=>'Choose File'
,p_is_js_message=>true
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2501027814382386)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_text=>'Column mapping must be specified.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17030734026113679)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_text=>'Configuration Saved!'
,p_is_js_message=>true
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3709908511167509)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_text=>'Data Profile'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3710175905169204)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_text=>'Data Profile Columns'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600538591907637)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_text=>'Data Source'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105842173837380473)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_text=>'Please define the column mapping in order to load this data into the %0 table.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3709762281165426)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_text=>'Data Load Definition'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3781631818614078)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_text=>'Drag and drop file here or'
,p_is_js_message=>true
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3781056923595660)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_text=>'Supported formats csv, xlsx, txt, xml, json'
,p_is_js_message=>true
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358297367813091201)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_text=>'Data Loading job execution stopped unexpectedly.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(284069980792277983)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_text=>'Data Loading Job in Workspace %0: Load into Table %1'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3601265764953688)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_text=>'Loaded File'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105842359685390468)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_text=>'%0 out of %1 columns have been automatically mapped to the %2 table. Please configure the remaining %3 columns.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(319504465141049485)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_text=>'Pasted Data'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105992381678977349)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_text=>'Data in table <code>%0</code> replaced with <b id="incompl_success_row_count"></b> new rows. <b class="u-danger-text" id="incompl_fail_row_count"></b> rows rejected.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105985431991555679)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_text=>'Data in table <code>%0</code> replaced with <b id="success_row_count"></b> new rows!'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105987494697581361)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_text=>'Data in table <code>%0</code> replaced with <b id="err_success_row_count"></b> new rows. <b class="u-danger-text" id="err_fail_row_count"></b> rows rejected.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(105842513595401913)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_text=>'Please select the columns to load.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1443541124456055)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_text=>'Supported formats %0'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600847441945692)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_text=>'Upload a File'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3601748233963090)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_text=>'XLSX Worksheet'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(910329911394909439)
,p_name=>'DATABASE'
,p_message_text=>'Database'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359354426685232224)
,p_name=>'DATABASE BROWSER'
,p_message_text=>'Database Browser'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(910662500275953503)
,p_name=>'DATABASE_APPLICATION'
,p_message_text=>'Application'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20146512622163987)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_text=>'Applications'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24283832499156801)
,p_name=>'DATABASE_APPS'
,p_message_text=>'Applications'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(219194119339534265)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_text=>'Application <strong>%0</strong> successfully installed.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(154784408351737294)
,p_name=>'DATABASE_LINK'
,p_message_text=>'Database Link'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184168709502897083)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_text=>'Database Object Counts by Object Type'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184183131665253510)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_text=>'Database Role Privileges'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23063210655713253)
,p_name=>'DATABASE_USERS'
,p_message_text=>'Database'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262591928380410954)
,p_name=>'DATA_GRID'
,p_message_text=>'Data Grid'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623896725654598603)
,p_name=>'DATA_GRIDS'
,p_message_text=>'Data Grids'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623902205054630439)
,p_name=>'DATA_GRID_DATA'
,p_message_text=>'Data Grid Data'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600627792229524564)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_text=>'Data Load Advanced Settings'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48760530208123501)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_text=>'Date / Number Formats to use'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48760808858133339)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_text=>'Choose whether to provide custom or to use standard format masks'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23680003820515412)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_text=>'File Character Set'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(352821406088222317)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_text=>'Column Names'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(217696968023180455)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_text=>'Column Names Aliases'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472561420018638399)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_text=>'The data has been successfully uploaded to your table.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(483373612463447211)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_text=>'Copy and Paste'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(467703824232343283)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_text=>'Copy and Paste Delimited Data'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(681885100754374518)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_text=>'Currency Symbol'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(681908532530402583)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_text=>'If your data contains international currency symbol, enter it here. For example, if your data has "&euro;1,234.56" or "&yen;1,234.56", enter "&euro;" or "&yen;".  Otherwise the data will not load correctly.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24810990922019773)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_text=>'Data Loading'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600628629324535918)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_text=>'Use application standard format masks'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600628881994537859)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_text=>'Provide custom formats for uploaded columns'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682792718612568932)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The decimal character separates the integer and decimal parts of a number.</p>',
'<p> Any character can be the decimal character. The character specified must be single-byte, and the decimal character must be different from group separator. The character can be a space, but cannot be any numeric character or any of the following c'
||'haracters:</p>',
'<ul class="noIndent">',
'<li>plus (+)</li>',
'<li>hyphen (-)</li> ',
'<li>less than sign (<)</li>',
'<li>greater than sign (>)</li> ',
'</ul>'))
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682080417648474055)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_text=>'Decimal Character'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72724786024377767)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_text=>'Decimal character is required if group separator is defined for the %0 table column.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(217697333751184030)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_text=>'Display'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(285743495507728472)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_text=>'Multiple source columns are mapped to the %0 table column.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(520162010741385667)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_text=>'Failed Row(s):'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(635274905916505129)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_text=>'Failed Records'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(681387730293165407)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_text=>'Name of the file to upload'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(477689322403086759)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_text=>'First Row has Column Names'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(681539003075242760)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_text=>'Select this box if your data contains column names in the first row.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(681726426203344026)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_text=>'Globalization'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682038212191453463)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A group separator is a character that separates integer groups, for example to show thousands and millions.</p>',
'<p>Any character can be the group separator. The character specified must be single-byte, and the group separator must be different from any other decimal character. The character can be a space, but cannot be a numeric character or any of the follow'
||'ing:</p>',
'<ul class="noIndent">',
'<li>plus (+)</li>',
'<li>hyphen (-)</li> ',
'<li>less than sign (<)</li>',
'<li>greater than sign (>)</li> ',
'</ul>'))
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(681957409374424333)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_text=>'Group Separator'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(520154029310381614)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_text=>'Inserted Row(s):'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(672741732280358756)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_text=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(212988505490822595)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_text=>'Records Changed by Another User.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61681511868525395)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_text=>'Case Sensitive'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61681162300520983)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_text=>'Unique Column'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(453900718524261345)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_text=>'Data Loading Failed'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(453969811729268858)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_text=>'Action Processed'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(462491823887292821)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_text=>'Import From'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261883123670446611)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_text=>'Step 2 - Page Name'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1013410410856554995)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_text=>'No file preview available'
,p_is_js_message=>true
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(679228403862599545)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_text=>'Optionally Enclosed By'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(609913253811028253)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_text=>'Data Load Wizard Progress'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261933530165467476)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_text=>'Step 4 - Page Name'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(217697116091181686)
,p_name=>'DATA_LOAD.RETURN'
,p_message_text=>'Return'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(212028923407671941)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_text=>'To be Reviewed Row(s):'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(338393819195613097)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate)',
'',
'my_func (',
'    p_1 => :SAL,',
'    p_2 => :COMM)',
'',
'where SAL and COMM are column names of the uploaded data',
'and my_func is the function that returns the value which will be the new value',
'for the column for which this transformation rule is defined.',
'</pre>'))
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(338404200420637003)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result number;',
'begin',
'    l_result := :SAL * :COMM;',
'    return l_result;',
'end;',
'',
'The returned result will be the new value of the column for which this transformation rule is defined.',
'',
':SAL and :COMM refer to the SAL and COMM column names of the uploaded data.',
'</pre>'))
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(338404005812634447)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select deptno',
' from dept',
'where dname = :DEPTNAME',
'  and loc   = :LOC',
'',
'where :DEPTNAME and :LOC refer to DEPTNAME and LOC columns names of the uploaded data.',
'</pre>'))
,p_version_scn=>70279024
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(81749122770461523)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_text=>'In the %0 table column, the same character cannot be defined as both the group separator and decimal character. Please enter different characters.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(678828814411489009)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_text=>'Identify a column separator character. Use <code>\t</code> for tab separators.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(678851330125503058)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_text=>'Separator'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(217697508301185501)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_text=>'Sequence'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600627395300521656)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_text=>'Use Advanced Settings'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600627505257523102)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_text=>'Display advanced settings for data loading: Currency Symbol, Decimal Characters, File Encoding or Date Formats'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485545329169133312)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_text=>'Data Load Source'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261879115358444253)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_text=>'Step 1 - Page Name'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(914275118591356269)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_text=>'(\t for tab)'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(676794115993978533)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_text=>'Unique Column %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(520158004854383976)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_text=>'Updated Row(s):'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1793617060337370917)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_text=>'Null value was uploaded.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(483293503328435147)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_text=>'Upload file, comma separated (*.csv) or tab delimited'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485583620774149853)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_text=>'Data Load Results'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485575713155147603)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_text=>'Data Validation'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261887130942448730)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_text=>'Step 3 - Page Name'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(264373716326245308)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_text=>'The data load wizard pages have been created successfully.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(454005026620273118)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_text=>'Data / Table Mapping Failed'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(454012800086274968)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_text=>'Action Processed'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171085145560947445)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_text=>'Data Upload Column Mapping'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84357624215581507)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_text=>'Column Type: Column %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20602250024359075)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_text=>'Decimal Character: Column %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20602658544361576)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_text=>'Format Mask: Column %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20602461103360372)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_text=>'Group Separator: Column %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20603035624363579)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_text=>'Map To: Column %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(94755079153779391)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_text=>'Maximum Length: Column %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20602863292362570)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_text=>'- Unmapped Column -'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256038129446617484)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_text=>'Entered Highlighted Date attribute value %0 for item %1 does not match %2 format.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261691912045958964)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_text=>'Entered Highlighted Date attribute value %0 for item %1 is not a relative date.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256038704082629114)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_text=>'Entered Maximum Date attribute value %0 for item %1 does not match %2 format.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261692512176968453)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_text=>'Entered Maximum Date attribute value %0 for item %1 is not a relative date.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3200814904890353)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_text=>'Entered Maximum Static attribute value %0 for item %1 does not match %2 format.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256038419188623995)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_text=>'Entered Minimum Date attribute value %0 for item %1 does not match %2 format.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261692201786965402)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_text=>'Entered Minimum Date attribute value %0 for item %1 is not a relative date.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3200659198888941)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_text=>'Entered Minimum Static attribute value %0 for item %1 does not match %2 format.'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(367650718087522898)
,p_name=>'DATE_ADDED'
,p_message_text=>'Date Added'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(620843423495516542)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_text=>'Oracle APEX database jobs with time of last run'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191632027649118825)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_text=>'to final milestone'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191632830550129092)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_text=>'to final milestone of release %0'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261342003959605902)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_text=>'Add Class'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626835418833839278)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_text=>'Alert'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626382321884216912)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_text=>'Cancel Event'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626835803380844283)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_text=>'Clear'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626835628876842210)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_text=>'Confirm'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3734450541724)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_text=>'Cancel Dialog'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3734453545253)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_text=>'Close Dialog'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46427217426725881)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_text=>'Disable'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46427011539724180)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_text=>'Enable'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(616985332312478260)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_text=>'Execute PL/SQL Code'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46426628377719504)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_text=>'Hide'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(187267306245892988)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_text=>'Execute JavaScript Code'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(457604812163620493)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_text=>'Refresh'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261353428565764316)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_text=>'Remove Class'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261353731682765225)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_text=>'Set Style'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(427397516319148902)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_text=>'Set Focus'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(187267031740890834)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_text=>'Set Value'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46426320758717324)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_text=>'Show'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(427397820475150050)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_text=>'Submit Page'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388636357727758698)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_text=>'Collapse Tree'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388636132255757718)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_text=>'Expand Tree'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13168625276730447)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_text=>'Database Account'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184824631064713110)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_text=>'Database table and column names are case sensitive'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290111727752564563)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_text=>'db object creation exception'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18826730502410402)
,p_name=>'DB_PRODUCT_NAME'
,p_message_text=>'Oracle Database'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(834494811225784137)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_text=>'Alias'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808752222882635106)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_text=>'All Mimes'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(833299123196626797)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_text=>'Create Handler'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808768400503638047)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_text=>'Create Method'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808760227038636224)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_text=>'Create Parameter'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808764329808637094)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_text=>'Create Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(860747615097133487)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_text=>'RESTful Service Module'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(833053106096612430)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_text=>'Handler'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(870162814936297257)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_text=>'Handler Bind Variable'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(696578318379108703)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_text=>'Handler Method'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(870718429228358187)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_text=>'Handler Source'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(696578605312111849)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_text=>'Handler Source Type'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808744016995633348)
,p_name=>'DB_SERVICES_METHOD'
,p_message_text=>'Method'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(860774119252134704)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_text=>'Module Name'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(870555215114335219)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_text=>'Module URI Prefix'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808772503274638831)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_text=>'No Source'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808739914225632553)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_text=>'Parameter'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(867090327207111610)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_text=>'RESTful Services'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808748119766634193)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_text=>'Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(870585832083340069)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_text=>'URI Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(696576048769091661)
,p_name=>'DB_SERVICES_URI'
,p_message_text=>'Uniform Resource Identifier (URI)'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(860641311503122959)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_text=>'URI Prefix'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(860686619814125421)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_text=>'URI Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(696578939566114715)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_text=>'Query One Row'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148729725448916262)
,p_name=>'DEBUG'
,p_message_text=>'Debug'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195676708098077056)
,p_name=>'DECLINED'
,p_message_text=>'Declined'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614996593681258700)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_text=>'Default Dialog Button Region Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614996349518256716)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_text=>'Default Dialog Content Region Template'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(454925418312976152)
,p_name=>'DEFAULT_PAGE'
,p_message_text=>'Default Page'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145392019551208775)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_text=>'default tablespace'
,p_version_scn=>37165770887504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145568814637377715)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_text=>'Default Tablespace'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345031628101716386)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_text=>'Default Template'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11582712872251962)
,p_name=>'DEFINED_BY_DA'
,p_message_text=>'Defined by Dynamic Action'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(492149208444795988)
,p_name=>'DEFINED_TABS'
,p_message_text=>'This application has %0 tabs organized into %1 tab sets, and has defined %2 parent tabs.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108559622945131752)
,p_name=>'DEFINE_LOV'
,p_message_text=>'Define List of Values'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(163582030440385864)
,p_name=>'DEFINITION'
,p_message_text=>'Definition'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(282818412512204797)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_text=>'Deinstallation Script'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42403117645694538)
,p_name=>'DELETED'
,p_message_text=>'Deleted'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623895004006554445)
,p_name=>'DELETE_APPLICATION'
,p_message_text=>'Delete Application'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(330209506788980954)
,p_name=>'DELETE_LABEL'
,p_message_text=>'Delete: %0'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(305245848343039293)
,p_name=>'DELETE_LINK_TEXT'
,p_message_text=>'Delete %0'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25831504818551543)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_text=>'Sample Application'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25831920055555978)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_text=>'Product Portal is a sample application that highlights common design concepts. It includes dedicated pages for customers, products, and orders as well as demonstrates the use of reports, charts, calendar, map, and tree.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174644812235660365)
,p_name=>'DEMONSTRABLE'
,p_message_text=>'Demonstrable'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86639518073448693)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_text=>'Examples of robust reports and pagination concepts.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86633502920425421)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_text=>'Example of on-line store built using %0.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86647610978484497)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_text=>'Learn about using Oracle Text with %0.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86653513318504148)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_text=>'Example of project status tracking application built with %0.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86642316257467134)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_text=>'Learn to use webservices with %0.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86623500533377424)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_text=>'Action'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86525609238058166)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_text=>'Application'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86521617764051253)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_text=>'BASIC_LEXER'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86638504913444896)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_text=>'Business Look'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86624401010387021)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_text=>'Collection Showcase'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86522827461054037)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_text=>'CONTEXT INDEX'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86510714124012310)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_text=>'You are about to create Basic Examples Demo Application.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86100731729913303)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_text=>'You are about to (re)create business look Demo Application.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86512630746017160)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_text=>'You are about to create the Collections Showcase Demo Application.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86515319927032940)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_text=>'create or recreate in schema %0'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86097707488906306)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_text=>'Create an example application to demonstrate web services.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86102321471919779)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_text=>'You are about to create WorldCup Mania Demo Application.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15092706680478500)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_text=>'Remove'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86622409060370419)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_text=>'Demo Application'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86535014910069267)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_text=>'You have about %0 MB free.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86628122743412220)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_text=>'Install'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86625514647400427)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_text=>'Installed'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(122982709993673959)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_text=>'You are about to install the Sample Application, which demonstrates the key features of %0.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86637510323437040)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_text=>'Install Now'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86624920403392658)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_text=>'Learn about %0 shopping cart concepts.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(313624608662862080)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_text=>'Locked'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86531228977063909)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_text=>'The Presidential Inaugural Address Demonstration requires about 7 MB of free disk space and may take up to two minutes to install in your schema.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(122831228619423792)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_text=>'There was not enough space to create this demonstration.  Request additional storage by going to the administration page, go to provisioning services and click the link to request additional storage. %0'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86627209584408409)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_text=>'Not Installed'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86484212645955102)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_text=>'Exist'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86096209088897267)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_text=>'exists'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86473730175950682)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86517915902041262)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_text=>'Object Name'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86096825711902091)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_text=>'not exists'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86467506711925047)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_text=>'The following database objects will be recreated if they exist'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86472916323946682)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_text=>'Object Type'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86507026806006531)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_text=>'Package'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86631413870419120)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_text=>'Pet store'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86646724353478911)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_text=>'Presidential Inaugural Addresses'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86652229463499345)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_text=>'Project Tracking'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145933418006022093)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_text=>'Re-install'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86626029192404645)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_text=>'Run'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86468720217928959)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_text=>'Schema'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86503729445997814)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_text=>'Sequence'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86622922219374241)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_text=>'Status'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86492611391964173)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_text=>'Table'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86620423127364980)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_text=>'Demonstration Application Install Status Report'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86505108452001239)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_text=>'Trigger'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(313676104908502024)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_text=>'Unlocked'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23242703577590357)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_text=>'Update Available'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86640725476460289)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_text=>'Web Services'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86537630971083428)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_text=>'You may experience an error if you are not recreating this demonstration.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(50836014165298463)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_text=>'There was not enough space to create this demonstration.  Request additional storage by going to the administration page, and clicking on the "Request Changes to Current Service" link.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(50835403776295415)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_text=>'The %0 demonstration application was created.'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(480758127693408050)
,p_name=>'DEPRECATED'
,p_message_text=>'Deprecated'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36720023900411452)
,p_name=>'DERIVED$'
,p_message_text=>'derived column'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174644425610654818)
,p_name=>'DESIRABLE'
,p_message_text=>'Desirable'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(228702619717448415)
,p_name=>'DETAIL'
,p_message_text=>'Detail'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(277486928313626173)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_text=>'Details'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(228739531108499058)
,p_name=>'DETAIL_2'
,p_message_text=>'Detail 2'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17810404748954428)
,p_name=>'DEVELOPER'
,p_message_text=>'Developer'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(293190322524322629)
,p_name=>'DEVELOPERS'
,p_message_text=>'Developers'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184172513415030584)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_text=>'Developer Activity Summary'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192133732493924765)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_text=>'Developer Summary'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2702015186464033)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_text=>'App %0'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(186261000404476007)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_text=>'App Customization'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360140386507888882)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_text=>'Clear'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360140125773885528)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_text=>'Copy'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575493681141328292)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_text=>'Customize'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366642448785309569)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_text=>'Debug (%0)'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366641626667300575)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_text=>'Default Debug Level'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366641861195302368)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_text=>'Info (default)'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366642012920304246)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_text=>'App Trace'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366642200394306469)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_text=>'Full Trace'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2800360693488448)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_text=>'Page %0'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353746132583436489)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_text=>'One or more errors have occurred since the page loaded. Open the Browser''s JavaScript console to see the errors.'
,p_is_js_message=>true
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355175192670438833)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_text=>'JavaScript Errors'
,p_is_js_message=>true
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575493935590328293)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_text=>'Edit Logo'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(386897861761240703)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_text=>'This functionality requires the Oracle APEX App Builder window to be open. Do you want to open the Builder in this window?'
,p_is_js_message=>true
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381273200466580477)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_text=>'Developer Toolbar Options'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(384555059549864274)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_text=>'Auto Hide'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(384555419711870333)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_text=>'Display Position'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(384555291942867299)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_text=>'Show Icons Only'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(384555814973874379)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_text=>'Bottom'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(384555656409872765)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_text=>'Left'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(384556064886876117)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_text=>'Right'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385761552293309631)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_text=>'Top'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355989664736465271)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_text=>'Info'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(356002468951508889)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_text=>'Page Performance Timing'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381358960615424454)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_text=>'Quick Edit'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900992399487999)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_ADDITIONAL_FILES'
,p_message_text=>'Additional Files'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901118067487999)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_ADDITIONAL_FILES_CSS'
,p_message_text=>'CSS URLs'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901028693487999)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_ADDITIONAL_FILES_JS'
,p_message_text=>'JavaScript URLs'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900140972409553)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_CURRENT_DEBUG_LEVEL'
,p_message_text=>'Current Debug Level'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900326253409570)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_CURRENT_DEBUG_LEVEL_TITLE'
,p_message_text=>'Current Debug Level: %0'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3800907511350892)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_DISABLED'
,p_message_text=>'Overrides Off'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3800838028350892)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_ENABLED'
,p_message_text=>'Overrides On'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900246900409569)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_ENABLE_DEBUG'
,p_message_text=>'Enable Debug'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900470346487997)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_FILE_PATH'
,p_message_text=>'File Paths'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900587883487997)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_FILE_PATH_APEX'
,p_message_text=>'APEX Files<p><small><em>#APEX_FILES#</em></small></p>'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900672405487998)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_FILE_PATH_APP'
,p_message_text=>'Application Files<p><small><em>#APP_FILES#</em></small></p>'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900895558487998)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_FILE_PATH_THEME'
,p_message_text=>'Theme Files<p><small><em>#THEME_FILES#</em></small></p>'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900709826487998)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_FILE_PATH_WORKSPACE'
,p_message_text=>'Workspace Files<p><small><em>#WORKSPACE_FILES#</em></small></p>'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901259815488000)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_GLOBALIZATION'
,p_message_text=>'Globalization'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901417908488001)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_GLOBALIZATION_DIRECTION'
,p_message_text=>'Document Direction'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901521354488001)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_GLOBALIZATION_DIRECTION_LTR'
,p_message_text=>'Left to Right'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901610660488001)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_GLOBALIZATION_DIRECTION_RTL'
,p_message_text=>'Right to Left'
,p_version_scn=>37165770887505
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901347854488000)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_GLOBALIZATION_LANGUAGE'
,p_message_text=>'Application Language'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901724237488002)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_GLOBALIZATION_TIMEZONE'
,p_message_text=>'Timezone'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3800759155350891)
,p_name=>'DEVELOPER_TOOLBAR_SESSION_OVERRIDES_TITLE'
,p_message_text=>'Session Overrides %0'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355999028492503322)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_text=>'Show Page Timing'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1204379270876804968)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_text=>'Theme Roller'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(382663032436820803)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_text=>'Developer Toolbar'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(267547537217734558)
,p_name=>'DEVELOPER_TOOLBAR_UL_LABEL'
,p_message_text=>'Developer'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3800545119314967)
,p_name=>'DEVELOPER_TOOLBAR_VIEW_SESSION'
,p_message_text=>'View Session State'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171867412470876722)
,p_name=>'DEVELOPMENT_TASK'
,p_message_text=>'Development Task'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(296084422964260258)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_text=>'Alert'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(296083516385258328)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_text=>'High'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(296083010497256643)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_text=>'Low Value'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1282446584658956)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_text=>'Page Item Groups'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25298122802560928)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_text=>'Applications'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25303424842608773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_text=>'Authentication Schemes'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25303600732611242)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_text=>'Authorization Schemes'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25301813283595956)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_text=>'Entries'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25301607742594383)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_text=>'Breadcrumbs'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1980048219402510376)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_text=>'Build Options'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25300910035585579)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_text=>'Application Computations'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25301403240593082)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_text=>'Application Items'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25302018824597563)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_text=>'Lists'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25302223672598958)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_text=>'Entries'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25302430252600892)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_text=>'List of Values'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9202606977180731)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_text=>'List of Value Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25302603025602424)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_text=>'Entries'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25302808566604098)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_text=>'Navigation Bars'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25298327650562264)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_text=>'Pages'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25300700685582832)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_text=>'Branches'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25299121201569922)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_text=>'Buttons'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153864276128707774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_text=>'Charts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153864632540710785)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_text=>'Axes'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153864490797709415)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_text=>'Series'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25300116830578077)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_text=>'Computations'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40262323537603241)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_text=>'Dynamic Actions'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40262510855609094)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_text=>'Dynamic Action - Actions'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25299705402574756)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_text=>'IR Regions'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25299911982576690)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_text=>'Report Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25298709080566394)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_text=>'Page Items'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25300528258581348)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_text=>'Processes'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25298500077563817)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_text=>'Regions'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573536325941511679)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_text=>'Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25298916007568367)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_text=>'Report Columns'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(803509317745097730)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_text=>'Trees'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25300322025579558)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_text=>'Validations'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25303014799605856)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_text=>'Parent Tabs'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25301122502589172)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_text=>'Application Processes'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(972898512937938103)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_text=>'Report Layouts'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(978742247507281708)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_text=>'Report Query SQL Statements'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(972898399932936898)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_text=>'Report Queries'
,p_version_scn=>37165770887506
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(659977078006490487)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_text=>'Application Settings'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25303806273612922)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_text=>'Shortcuts'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24585407027078375)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_text=>'Application Files'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25306831122638922)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_text=>'Substitutions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1980047693313506828)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_text=>'Supporting Objects'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1980047862409507939)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_text=>'Supporting Objects-Build Options'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25306420387635911)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_text=>'Supporting Objects-Validations'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25306626274637532)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_text=>'Supporting Objects-Scripts'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25303219301607190)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_text=>'Tabs'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25304629475619537)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_text=>'Breadcrumb Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25304801902621117)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_text=>'Button Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25305012291624108)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_text=>'Calendar Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46096213775712442)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_text=>'Grid Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25305217139625509)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_text=>'Label Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25305422334626928)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_text=>'List Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25305626836628302)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_text=>'Page Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25305832723630018)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_text=>'Popup LOV Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25306007573632140)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_text=>'Region Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25306213807633997)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_text=>'Report Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25304423588617828)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_text=>'Themes'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22471918393334546)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_text=>'Theme Files'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4404910736916502)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_text=>'Theme Styles'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184622614836817675)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_text=>'Text Messages'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20700923873719648)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_text=>'Dynamic Translations'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20701132184722136)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_text=>'Translatable Text'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25304218047616285)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_text=>'Trees'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25304012506614625)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_text=>'Web Services'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(726145854627236327)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_text=>'Access Control Roles'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(726167576938240101)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_text=>'Access Control Users'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(213698187815497496)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_text=>'Access Control User Role Assignment'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000571616049705)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_text=>'Automations'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000854631053745)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_text=>'Automation - Actions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3236853974485426)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_COMPONENT_GROUPS'
,p_message_text=>'Component Groups'
,p_version_scn=>16214233
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1018712666401555678)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_text=>'Concatenated Files'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10100419105481796)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_text=>'Data Loads'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160793077882317301)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_text=>'Data Parsing Profiles'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160793203513318786)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_text=>'Data Parsing Profile Columns'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1412618625300025145)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_text=>'Developer Comments'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(839979139605711982)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_text=>'Email Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4001340008302656)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_INVOKE_API_PARAMS'
,p_message_text=>'Component Invoke API Parameters'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(438005425079217783)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_text=>'Data Load Table'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(431147405285707613)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_text=>'Data Load Tables'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(431207111519709450)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_text=>'Data Load Table Lookups'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(431254819137711646)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_text=>'Data Load Table Transformation Rules'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176043454647666081)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_MAP_BACKGROUNDS'
,p_message_text=>'Map Backgrounds'
,p_version_scn=>37165925786973
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000112083714237)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_BG_PROC_STATUS'
,p_message_text=>'Page Process Background Executions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6355510169032202)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_text=>'Calendar Pages'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6001991272157846)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_text=>'Cards'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6002114482160226)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_text=>'Card Actions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2024122226676626)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_COMP_ACTIONS'
,p_message_text=>'Actions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(382292046190893480)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_text=>'Interactive Grid Regions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(382292212545898262)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_text=>'Report Columns'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(382292498099900066)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_text=>'Column Groups'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1700174255909188)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_text=>'Maps'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1700221275920742)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_text=>'Map Layers'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2024300948680400)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MENU_ENTRIES'
,p_message_text=>'Menu Entries'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2040222599089119)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_META_TAGS'
,p_message_text=>'Page Meta Tags'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001379581913805)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_SEARCH_SOURCES'
,p_message_text=>'Search Region Sources'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28180907816420685)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_text=>'Plug-ins'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2024710175687432)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ACT_POSITIONS'
,p_message_text=>'Action Positions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2024563832685262)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ACT_TEMPLATES'
,p_message_text=>'Action Templates'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28181119244423990)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_text=>'Attributes'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1712370435413546)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_GROUPS'
,p_message_text=>'Attribute Groups'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184246512825879782)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_text=>'Values'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48607312036937762)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_text=>'Events'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29914022361373053)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_text=>'Files'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(229787870621608090)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_text=>'Filter Operators'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1980048074915509101)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_text=>'Component Settings'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601730316803940)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SLOTS'
,p_message_text=>'Slots'
,p_version_scn=>98916146
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(835956048613350616)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_text=>'Plug-In Standard Attribute Meta Data'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2040041401087668)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PWA_SCREENSHOTS'
,p_message_text=>'PWA Screenshots'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2039590151080826)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PWA_SHORTCUTS'
,p_message_text=>'PWA Shortcuts'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160792862016313926)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_text=>'REST Enabled SQL Servers'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1812179768280218)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_SEARCH_CONFIGS'
,p_message_text=>'Search Configurations'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1645112173180942)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TASKDEFS'
,p_message_text=>'Human Task Definitions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1645373164184524)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TASKDEF_ACTIONS'
,p_message_text=>'Task Definition Actions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1646052567231242)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TASKDEF_COMP_PARAMS'
,p_message_text=>'Component Task Definition Parameters'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1645550886187404)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TASKDEF_PARAMS'
,p_message_text=>'Task Definition Parameters'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1645717435192457)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TASKDEF_PARTICIPANTS'
,p_message_text=>'Task Definition Participants'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573146723726150452)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_text=>'Template Options'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1980047452063505090)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_text=>'Template Option Groups'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(686997998172447583)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_text=>'Template Option Group'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1133443428743194825)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_text=>'Positions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1133443614551196137)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_text=>'Positions'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47715223352407140)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_text=>'Theme Display Points'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160794298871328000)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_text=>'Component REST Source Parameters'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160793662266322576)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_text=>'REST Data Sources'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160793812375324171)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_text=>'REST Source Operations'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160794059255325819)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_text=>'REST Source Parameters'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160793463285320890)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_text=>'REST Source Remote Servers'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001340608456881)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_text=>'REST Synchronization Steps'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601490683254545)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOWS'
,p_message_text=>'Workflow Definitions'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601861366264057)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOW_ACTIVITIES'
,p_message_text=>'Workflow Activity Definitions'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602650448290114)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOW_ACT_VARS'
,p_message_text=>'Workflow Activity Variable Definitions'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(162997916462965922)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOW_BRANCHES'
,p_message_text=>'Workflow Branch Definitions'
,p_version_scn=>64098310
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602895238294999)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOW_COMP_PARAMS'
,p_message_text=>'Workflow Component Parameters'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602453112286576)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOW_PARAMS'
,p_message_text=>'Workflow Parameter Definitions'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603070153297912)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOW_PARTICIPANT'
,p_message_text=>'Workflow Participant Definitions'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602005639281738)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOW_TRANSITIONS'
,p_message_text=>'Workflow Transition Definitions'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602209178284256)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOW_VARIABLES'
,p_message_text=>'Workflow Variable Definitions'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601633909259613)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WORKFLOW_VERSIONS'
,p_message_text=>'Workflow Definition Versions'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001263883077977)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_text=>'Automation Log'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001414699079870)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_text=>'Automation Message Log'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1644185701830774)
,p_name=>'DICTIONARY_VIEW.APEX_TASKS'
,p_message_text=>'Human Tasks'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1644519962838558)
,p_name=>'DICTIONARY_VIEW.APEX_TASK_COMMENTS'
,p_message_text=>'Human Task Comments'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1644361045835609)
,p_name=>'DICTIONARY_VIEW.APEX_TASK_HISTORY'
,p_message_text=>'Human Task History'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1644980816843295)
,p_name=>'DICTIONARY_VIEW.APEX_TASK_PARAMETERS'
,p_message_text=>'Human Task Parameters'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1644740126841766)
,p_name=>'DICTIONARY_VIEW.APEX_TASK_PARTICIPANTS'
,p_message_text=>'Human Task Participants'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2400960509828160)
,p_name=>'DICTIONARY_VIEW.APEX_WORKFLOWS'
,p_message_text=>'Workflows'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2401109353829793)
,p_name=>'DICTIONARY_VIEW.APEX_WORKFLOW_ACTIVITIES'
,p_message_text=>'Workflow Activities'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2401721186839085)
,p_name=>'DICTIONARY_VIEW.APEX_WORKFLOW_ACTIVITY_VARS'
,p_message_text=>'Workflow Activity Variables'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2402161095844054)
,p_name=>'DICTIONARY_VIEW.APEX_WORKFLOW_AUDIT'
,p_message_text=>'Workflow Audit'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2401575580832867)
,p_name=>'DICTIONARY_VIEW.APEX_WORKFLOW_PARAMETERS'
,p_message_text=>'Workflow Parameters'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2401975739842640)
,p_name=>'DICTIONARY_VIEW.APEX_WORKFLOW_PARTICIPANTS'
,p_message_text=>'Workflow Participants'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2401397492831523)
,p_name=>'DICTIONARY_VIEW.APEX_WORKFLOW_VARIABLES'
,p_message_text=>'Workflow Variables'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(856780615481386063)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_text=>'Disabled Next Button'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(856768711672384969)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_text=>'Disabled Previous Button'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86865117548760809)
,p_name=>'DISPLAY_CONDITION'
,p_message_text=>'Display Condition'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86866805212766707)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_text=>'Display Condition Text'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(330745710183192592)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_text=>'Display Order: %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32496506841842752)
,p_name=>'DISPLAY_TYPE'
,p_message_text=>'Display Type'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1959701514123060257)
,p_name=>'DISPLAY_VALUE.N'
,p_message_text=>'Display Value: %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(820473830149557306)
,p_name=>'DISTINCT_PAGES'
,p_message_text=>'Distinct Pages'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(820474114696562256)
,p_name=>'DISTINCT_USERS'
,p_message_text=>'Distinct Users'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9200522165667512)
,p_name=>'DML_FORM'
,p_message_text=>'DML Form'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114391602227012711)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183994729169597113)
,p_name=>'DOC_IMPACT'
,p_message_text=>'Documentation Impact'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183998807744619317)
,p_name=>'DOC_STATUS'
,p_message_text=>'Documentation Status'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183999415709621603)
,p_name=>'DOC_WRITER'
,p_message_text=>'Documentation Writer'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(131525828309214179)
,p_name=>'DOWN'
,p_message_text=>'Down'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184528229792520693)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_text=>'Download Link Text'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114388432440002543)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_text=>'Do not update application items'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114390109714005492)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_text=>'Do not update data entry items'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114391022528009163)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_text=>'Do not update display-only items'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114387304950985129)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_text=>'Do not update pages'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114499007559840034)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_text=>'Do not update page items'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77645421757592088)
,p_name=>'DRAG_AND_DROP'
,p_message_text=>'Drag and Drop'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26822732038167865)
,p_name=>'DRILLDOWN'
,p_message_text=>'Drill Down'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26822328574166869)
,p_name=>'DRILLUP'
,p_message_text=>'Drill Up'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88171105019057676)
,p_name=>'DRIVEN'
,p_message_text=>'driven'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270362200161898315)
,p_name=>'DROP_COLUMN'
,p_message_text=>'Drop Column %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418847524033673598)
,p_name=>'DS_ACCESS_METHOD'
,p_message_text=>'Access Method'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418819928057665325)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_text=>'Bind Variable Name'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418893519662681756)
,p_name=>'DS_HANDLER'
,p_message_text=>'Handler'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(419019521655701272)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_text=>'Items Per Page'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418976600877695258)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_text=>'MIME Types Allowed'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(419007813690698969)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_text=>'Origins Allowed'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418855400615676314)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_text=>'Parameter Type'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(419027432391704379)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_text=>'Security Constraint'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418839615375671058)
,p_name=>'DS_SOURCE'
,p_message_text=>'Source'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418926904555686898)
,p_name=>'DS_SOURCE_TYPE'
,p_message_text=>'Source Type'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(419039413821708472)
,p_name=>'DS_URI_PREFIX'
,p_message_text=>'URI Prefix'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418738202300648453)
,p_name=>'DS_URI_TEMPLATE'
,p_message_text=>'URI Template'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(980680785332625341)
,p_name=>'DUE'
,p_message_text=>'Due'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183998228738615949)
,p_name=>'DUE_DATE'
,p_message_text=>'Due Date'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172717500236292467)
,p_name=>'DUPLICATE'
,p_message_text=>'Duplicate'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(829735346009007045)
,p_name=>'DUPLICATE_USER'
,p_message_text=>'Duplicate user in list'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4521519772939447)
,p_name=>'DYNAMIC ACTION'
,p_message_text=>'Dynamic Action'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4521314577937997)
,p_name=>'DYNAMIC ACTIONS'
,p_message_text=>'Dynamic Actions'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8483313274523015)
,p_name=>'DYNAMIC_FORM'
,p_message_text=>'Dynamic Form'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42485347173711860)
,p_name=>'DYNAMIC_HTML'
,p_message_text=>'Dynamic HTML'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75583618448331157)
,p_name=>'DYNAMIC_QUERY'
,p_message_text=>'Interactive Report'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2482320333924478)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_text=>'Dynamic Reference'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107656122999656198)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_text=>'The condition you are adding has caused the query to be invalid.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5961703297676406)
,p_name=>'EDIT PAGE GROUP'
,p_message_text=>'Edit Page Group'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203707602014515361)
,p_name=>'EDITOR_EXIT'
,p_message_text=>'You will loose unsaved changes if you choose OK.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17524809329912576)
,p_name=>'EDIT_ALL'
,p_message_text=>'Edit All'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108520607008660982)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_text=>'Edit all page definition attributes'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(196571121853984806)
,p_name=>'EDIT_ALL_REGION'
,p_message_text=>'Edit all items in this region'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165849123481033944)
,p_name=>'EDIT_APPLICATION'
,p_message_text=>'Edit Application'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(227298415750327626)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_text=>'Edit Attribute'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623896109116574858)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_text=>'Edit Authentication'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(209279114711024779)
,p_name=>'EDIT_COMPONENT'
,p_message_text=>'Edit Component'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(227304624024377369)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_text=>'Edit Component Definition'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(304860839623544861)
,p_name=>'EDIT_LINK_TEXT'
,p_message_text=>'Edit %0'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(227290119035290700)
,p_name=>'EDIT_LIST_DEV'
,p_message_text=>'Edit List Definition'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(926816628335129335)
,p_name=>'EDIT_LOCK'
,p_message_text=>'Edit Lock'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148724424971906642)
,p_name=>'EDIT_PAGE'
,p_message_text=>'Edit Page'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109823904326721164)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_text=>'Edit page attributes'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485854150589995875)
,p_name=>'EDIT_PROFILE'
,p_message_text=>'Edit Profile'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(495340620321711192)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_text=>'User 0% has no privileges to update the information for another user.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(209252912352853733)
,p_name=>'EDIT_REGION'
,p_message_text=>'Edit Region'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295258003666132616)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_text=>'Edit Reporting Timeframe'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(209256117678864784)
,p_name=>'EDIT_REPORT_COLS'
,p_message_text=>'Edit Report Columns'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(481306729733270553)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_text=>'Edit Report - Dialog Closed'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195816020534303963)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_text=>'Edit System Message'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(454859202056072704)
,p_name=>'EDIT_TAB'
,p_message_text=>'Edit Tab'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(228986309599775173)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_text=>'Edit this attribute'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145151519309641028)
,p_name=>'ELAPSED_TIME'
,p_message_text=>'Elapsed Time'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177293525864118220)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_text=>'<a rel="noopener noreferrer" href="#MY_APPLICATION_LINK#">Visit My Application and manage your email preferences</a>.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(182816204436193767)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_text=>'<b style="font-size: 24px;">My Application</b>'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270605954832606075)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Hello #INVITEE#,</strong><br>',
'<br>',
'This is a reminder of an upcoming event you have been invited to.  Please see the event details below:<br>',
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Organizer</th>',
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Event Date</th>',
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Start Time</th>',
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Duration</th>',
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Location</th>',
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Notes</th>',
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177292894284112303)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Hello #CUSTOMER_NAME#</strong>,<br>',
'<br>',
'Thank you for placing your order!<br>',
'<br>',
'<strong>Order Details</strong><br>',
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Order Date</th>',
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Order Number</th>',
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Ship To</th>',
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Shipping Address</th>',
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Items Ordered</th>',
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Order Total</th>',
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
'Need to make a change to your order? <a href="#ORDER_URL#">Manage your order #ORDER_NUMBER# here.</a>'))
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(481899083519669572)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hello #SERVICE_USER#,<br>',
'<br>',
'Please be aware that your service #SERVICE_NAME# has an upcoming scheduled outage.<br>',
'The outage is scheduled to begin at #OUTAGE_START# and is planned to be unavailable for #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.<br>',
'<br>',
'The following will be performed during this scheduled outage:<br>',
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
'For any issues relating to this outage please contact #OUTAGE_CONTACT#.<br>',
'<br>',
'Thank you for your understanding,<br>',
'#SERVICE_TEAM#'))
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(481191972391345551)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_text=>'Event Reminder: #EVENT_NAME#'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(481192170701355144)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_text=>'Order (#ORDER_NUMBER#) Confirmed!'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270669368302907263)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hello #INVITEE#,',
'',
'This email is to remind you of an upcoming event you are associated with.',
'',
'Event Date: #EVENT_DATE#',
'Start Time: #START_TIME#',
'Duration:   #DURATION#',
'Organizer:  #ORGANIZER#',
'Location:   #LOCATION#',
'URL:        #URL_NAME# (#URL_LINK#)',
'Notes:      #NOTES#',
'',
'View additional event details here: #EVENT_LINK#'))
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270653521379861150)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hello #CUSTOMER_NAME#,',
'',
'Thank you for placing your order!',
'',
'Order Details',
'--------------------------------------------------------------------------------',
'  Order Date:       #ORDER_DATE#',
'  Order Number:     #ORDER_NUMBER#',
'  Ship To:          #SHIP_TO#',
'  Shipping Address: #SHIPPING_ADDRESS_LINE_1#',
'                    #SHIPPING_ADDRESS_LINE_2#',
'  Items Ordered:    #ITEMS_ORDERED#',
'  Order Total:      #ORDER_TOTAL#',
'--------------------------------------------------------------------------------',
'',
'Need to make a change to your order? Manage your order #ORDER_NUMBER# here: #ORDER_URL#'))
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(481898621288667766)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hello #SERVICE_USER#,',
'',
'Please be aware that your service #SERVICE_NAME# has an upcoming scheduled outage.',
'The outage is scheduled to begin at #OUTAGE_START# and is planned to be unavailable for #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.',
'',
'The following will be performed during this scheduled outage:',
'#OUTAGE_REASON#',
'',
'For any issues relating to this outage please contact #OUTAGE_CONTACT#.',
'',
'Thank you for your understanding,',
'#SERVICE_TEAM#',
''))
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201793625095426060)
,p_name=>'ENABLE_DEBUGGING'
,p_message_text=>'Enable Debugging Yes or No'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18886617136177889)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_text=>'Length of value to be encrypted may not exceed 4000 bytes.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17810808211955434)
,p_name=>'END_USER'
,p_message_text=>'End User'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171861228091833861)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_text=>'Enhancement Request'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(496735014367238388)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_text=>'Enhancement Requests: %1 of %0 closed'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172715819582269695)
,p_name=>'ENTERED'
,p_message_text=>'Entered'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166184219961533935)
,p_name=>'ENTRY LINK'
,p_message_text=>'Entry Link'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166183715459532695)
,p_name=>'ENTRY TEXT'
,p_message_text=>'Entry Text'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190189622892897230)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_text=>'Error Page Template'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123652919513837836)
,p_name=>'ERRORPAGE'
,p_message_text=>'On Error Page'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(198245516383523130)
,p_name=>'ERRORS'
,p_message_text=>'Errors'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166305326513104029)
,p_name=>'ERROR_ICON'
,p_message_text=>'Error Icon'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(955846819150853709)
,p_name=>'ERROR_MESSAGE'
,p_message_text=>'Error Message'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161111212984184120)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_text=>'<br><strong>Escaped Data exceeds allowed limit, results trimmed to 32k</strong>'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88141602698839382)
,p_name=>'ESCAPE_SC'
,p_message_text=>'escape special characters'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184003428654634768)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_text=>'Estimated Effort in Hours'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418761822732654339)
,p_name=>'ETAG_QUERY'
,p_message_text=>'ETAG Query'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(418753915459652239)
,p_name=>'ETAG_TYPE'
,p_message_text=>'ETAG Type'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171868306368884342)
,p_name=>'EVENT'
,p_message_text=>'Event'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484995317511352603)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_text=>'After Refresh'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485076930987879656)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_text=>'Before Page Submit'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484995113356351362)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_text=>'Before Refresh'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487346700888842532)
,p_name=>'EVENT.BROWSER'
,p_message_text=>'Browser Events'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107041629257271653)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_text=>'Double Tap'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107042007054274843)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_text=>'Pan'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107041864275273550)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_text=>'Press'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107042283230276155)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_text=>'Swipe'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107041495807269483)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_text=>'Tap'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484993411147341273)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_text=>'Change'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484992011362331854)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_text=>'Click'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484992216557333343)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_text=>'Double Click'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484991025083326382)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_text=>'Get Focus'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484990210538322163)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_text=>'Lose Focus'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601214705018515)
,p_name=>'EVENT.BROWSER.INPUT'
,p_message_text=>'Input'
,p_version_scn=>132225377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484994021882344390)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_text=>'Key Down'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484994702966348336)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_text=>'Key Press'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484994906083349294)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_text=>'Key Release'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484991228200327247)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_text=>'Resource Load'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484992422098334933)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_text=>'Mouse Button Press'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484993002489338794)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_text=>'Mouse Enter'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484993207684340316)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_text=>'Mouse Leave'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484992831448337683)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_text=>'Mouse Move'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484992626946336349)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_text=>'Mouse Button Release'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5281515968954667)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_text=>'Orientation Change'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488323623842199026)
,p_name=>'EVENT.BROWSER.READY'
,p_message_text=>'Page Load'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484991431317328187)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_text=>'Resize'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484991602012329168)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_text=>'Scroll'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5281720470956028)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_text=>'Scroll Start'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5281923240956833)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_text=>'Scroll Stop'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484993613917342070)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_text=>'Select'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5279908565943120)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_text=>'Swipe'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5280113067944340)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_text=>'Swipe Left'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5280316876945479)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_text=>'Swipe Right'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5279530251939881)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_text=>'Tap'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5279703024941527)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_text=>'Tap and Hold'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484991805821330322)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_text=>'Page Unload'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5281106618951950)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_text=>'Virtual Click'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5281311466953400)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_text=>'Touch Cancel'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5280525880948113)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_text=>'Touch Start'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5280730036949270)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_text=>'Touch Move'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5280901770950630)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_text=>'Touch End'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487347110238845223)
,p_name=>'EVENT.COMPONENT'
,p_message_text=>'Component Events'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1805896572298034)
,p_name=>'EVENT.COMPONENT.APEXSELECTIONCHANGE'
,p_message_text=>'Selection Change [Region]'
,p_version_scn=>8216292
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3782325278158105)
,p_name=>'EVENT.CUSTOM'
,p_message_text=>'Custom Event'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3782529434159334)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_text=>'Custom'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487346905390843830)
,p_name=>'EVENT.FRAMEWORK'
,p_message_text=>'Framework Events'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136499668765818784)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_text=>'Dialog Closed or Canceled'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(208944027692720500)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_text=>'Dialog Closed'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1083319309501404155)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_text=>'After Refresh'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1083323413657405386)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_text=>'Before Page Submit'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1083309305345403011)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_text=>'Before Refresh'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(163582301828387091)
,p_name=>'EVENTS'
,p_message_text=>'Events'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183998503589618131)
,p_name=>'EVENT_ID'
,p_message_text=>'Milestone Number'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204379610360758976)
,p_name=>'EXACT_SUBS'
,p_message_text=>'Exact Substitutions'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(327980106735075998)
,p_name=>'EXAMPLE_1'
,p_message_text=>'Example 1'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(327995209506076788)
,p_name=>'EXAMPLE_2'
,p_message_text=>'Example 2'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(628864827214314488)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_text=>'This is an example of the data contained within an XML database column.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(826875932566730545)
,p_name=>'EXAMPLE_URI'
,p_message_text=>'Example URI'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(272959522903959120)
,p_name=>'EXCLUDE'
,p_message_text=>'Exclude'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(246234331235507934)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_text=>'Existing Schema Name'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194470031998589246)
,p_name=>'EXISTS'
,p_message_text=>'Exists'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25594709605436753)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_text=>'EXISTS SQL Query'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471700213058088753)
,p_name=>'EXPANDED'
,p_message_text=>'Expanded'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(799702405779687700)
,p_name=>'EXPAND_ALL'
,p_message_text=>'Expand All'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(51596623304413900)
,p_name=>'EXPIRED'
,p_message_text=>'Expired'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165989729388391701)
,p_name=>'EXPLAIN PLAN'
,p_message_text=>'Explain Plan'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(163584313949390509)
,p_name=>'EXPORT'
,p_message_text=>'Export'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455023324582980796)
,p_name=>'EXPORT REPOSITORY'
,p_message_text=>'Export Repository'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(209771217779765237)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_text=>'Exported from another workspace or application.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(209771622628766627)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_text=>'Exported from current workspace.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(282817829765196826)
,p_name=>'EXPORT_APPLICATION'
,p_message_text=>'Export Application'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(294712132733705328)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use these links to download this application and its corresponding database supporting objects for deployment in a different Oracle APEX installation.  The downloaded files will be SQL Scripts that can be run from SQL*Plus, SQL Developer or SQL Scrip'
||'ts within Oracle APEX.',
''))
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(282818018119202181)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_text=>'Export Supporting Objects'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164662110029806941)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_text=>'Application Export  '
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164662929422812474)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_text=>'Cascading Style Sheets Export'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164663712238817049)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_text=>'Static File Export'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164663305658815160)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_text=>'Image Export'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164662516609808862)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_text=>'Page Export'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164664118818818925)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_text=>'Script File Export'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160761125861699548)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_text=>'UI Defaults'
,p_version_scn=>117499000
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135413608989368289)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_text=>'Application Computation'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134836429599062018)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_text=>'Application Item'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135411426173363818)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_text=>'Application Process'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86495111868973829)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_text=>'Application ID''s 3000 through 8999 are reserved.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25626813971569587)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_text=>'This application was exported from the current workspace.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25627206137576727)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_text=>'This application was exported from another workspace.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573900032205919046)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_text=>'Application %0 Remote Print Server Credentials'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573894419184828839)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_text=>'Application %0 Remote Print Server'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135410214053360310)
,p_name=>'F4000.BRANCH'
,p_message_text=>'Branch'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141818720379119145)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_text=>'Branch from page'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141820528475130880)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_text=>'Branch to page'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135404306649348711)
,p_name=>'F4000.BUTTON'
,p_message_text=>'Button'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(193801311939283265)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_text=>'Button Item'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(45554027073404674)
,p_name=>'F4000.CALENDAR'
,p_message_text=>'Calendar'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106621422382604572)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_text=>'Calendar column.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(142828325976224854)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_text=>'Column Attributes'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646544751779955187)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_text=>'The identified column name is an Oracle reserved word.  Please choose another name.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1453625237124072)
,p_name=>'F4000.COMPONENT_ACTION'
,p_message_text=>'Template Component Action'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194891218104921825)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_text=>'Copy list entry: %0'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145989127122232867)
,p_name=>'F4000.DYNAMIC'
,p_message_text=>'Dynamic'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34968010896570877)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_text=>'Dynamic Action'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25624919110466918)
,p_name=>'F4000.EXPORT'
,p_message_text=>'Export'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146312323752706572)
,p_name=>'F4000.FIX_ME'
,p_message_text=>'Fix Me'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145925525101986300)
,p_name=>'F4000.FOR_USER'
,p_message_text=>'For User'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145924317136984010)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_text=>'For User Session'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141821031938131926)
,p_name=>'F4000.FROM'
,p_message_text=>'from'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3791272266079910)
,p_name=>'F4000.GENERATIVE_AI_CREDENTIALS'
,p_message_text=>'Generative AI Service Credentials'
,p_version_scn=>1409118629
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86524303351056557)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_text=>'Header must contain <strong> &lt;head&gt;</strong> and <strong>&lt;/head&gt;</strong> tags.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86532909715067781)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_text=>'<strong>#HEAD#</strong> substitution string must appear between the <strong> &lt;head&gt;</strong> and <strong>&lt;/head&gt;</strong> tags.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170819532610079591)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_text=>'File "%0" is of invalid type.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24019747525798165)
,p_name=>'F4000.ITEM'
,p_message_text=>'Item'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135393920586333770)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_text=>'Item Display'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135398623141343968)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_text=>'Item Read-only'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10901814504383528)
,p_name=>'F4000.LEGACY_SQL'
,p_message_text=>'Legacy SQL'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232345120989008657)
,p_name=>'F4000.LINK_COLUMN'
,p_message_text=>'Link Column'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146365627176455163)
,p_name=>'F4000.LIST_INITCAP'
,p_message_text=>'List'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135417011675388059)
,p_name=>'F4000.LIST_ITEM'
,p_message_text=>'List Item'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10901630852381990)
,p_name=>'F4000.LOCAL'
,p_message_text=>'Local'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135420311937406967)
,p_name=>'F4000.LOV_ENTRY'
,p_message_text=>'List of Values Entry'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141823628952140566)
,p_name=>'F4000.MENU'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1453852652125363)
,p_name=>'F4000.MENU_ENTRY'
,p_message_text=>'Menu Entry'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135417523103391279)
,p_name=>'F4000.MENU_OPTION'
,p_message_text=>'Breadcrumb Entry'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150692517959064941)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_text=>'Must select at least one to copy or subscribe.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114115418066509874)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_text=>'Navigation&nbsp;Bar&nbsp;Icon'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134491109598687258)
,p_name=>'F4000.NO'
,p_message_text=>'No'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145989606128236359)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_text=>'Not Referenced'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139984404907972703)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_text=>'No data found.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1020631059651763715)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_text=>'Application %0 does not exist in the current workspace.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(493069300808102739)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_text=>'Update Check disabled'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149230005333451280)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_text=>'Parent Tab Name'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26435015781196447)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_text=>'Cancel Button Branch'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26432930710153401)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_text=>'Cancel Button Display Text'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26435510718204416)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_text=>'Finish Button Branch'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26433415388167940)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_text=>'Finish Button Display Text'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26434516343187176)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_text=>'Next Button Display Text'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26433829241171919)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_text=>'Previous Button Display Text'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149233800401468822)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_text=>'Tree Page'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149240430661487065)
,p_name=>'F4000.P119.GO'
,p_message_text=>'Go'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149249501271506953)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_text=>'Using the same templates as an existing application.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1040898274196574090)
,p_name=>'F4000.P135.COPY'
,p_message_text=>'Copy %0'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150848527560411361)
,p_name=>'F4000.P158.COPY_OF'
,p_message_text=>'Copy of %0'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1040435196889019226)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_text=>'Lookup Definition'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1029863567640079754)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_text=>'Region Name'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86515621658033438)
,p_name=>'F4000.P19.VALIDATION'
,p_message_text=>'Must specify at least one item to create not null validation.'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(609359051139062041)
,p_name=>'F4000.P1935.NAME'
,p_message_text=>'App %0 Print Server'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(508402824680318750)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_text=>'Update default export settings'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(561325578825071719)
,p_name=>'F4000.P203.ACTION='
,p_message_text=>'action='
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001194728708208)
,p_name=>'F4000.P203.ACTIVITY='
,p_message_text=>'activity='
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1454075680126956)
,p_name=>'F4000.P203.COLUMN='
,p_message_text=>'Column='
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167455724744518449)
,p_name=>'F4000.P203.COMMENT='
,p_message_text=>'comment='
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166938900897839755)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_text=>'Used to run computation'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1289127918514452972)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_text=>'Concatenated File'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001391861711152)
,p_name=>'F4000.P203.CONDITION='
,p_message_text=>'condition='
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167101902712171368)
,p_name=>'F4000.P203.DISPVAL='
,p_message_text=>'display value='
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1289127654267446487)
,p_name=>'F4000.P203.FILE='
,p_message_text=>'file='
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166956827618951511)
,p_name=>'F4000.P203.ICONBAR'
,p_message_text=>'Icon Bar'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167110015656184621)
,p_name=>'F4000.P203.LOV='
,p_message_text=>'List of Values='
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167098431193160737)
,p_name=>'F4000.P203.LOVDATA'
,p_message_text=>'List of Values Data'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167077602272114512)
,p_name=>'F4000.P203.NAME='
,p_message_text=>'name='
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166926719766807309)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_text=>'Used to display page'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167425213653439494)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_text=>'Page Branch'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167129103021218788)
,p_name=>'F4000.P203.PGTEMP'
,p_message_text=>'Page Template'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166947509648899048)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_text=>'Used to run process'
,p_version_scn=>37165770887509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166944719990873578)
,p_name=>'F4000.P203.PROCESSING'
,p_message_text=>'Processing'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167107825222177930)
,p_name=>'F4000.P203.RETVAL='
,p_message_text=>'return value='
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000980802706259)
,p_name=>'F4000.P203.VERSION='
,p_message_text=>'version='
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1080731868950026785)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_text=>'Reparent List Entry'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106605231530080434)
,p_name=>'F4000.P254.VALIDATION'
,p_message_text=>'Must specify at least one region to create.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134484504919647981)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_text=>'Workspace will not be created because it already exists.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134484919117652104)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_text=>'Workspace will be created.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1127352654100000526)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_text=>'View Lock'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106605707420082902)
,p_name=>'F4000.P295.VALIDATION'
,p_message_text=>'Must specify at least one page to create.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1127569218931270327)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_text=>'This page is currently unlocked.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468676428466077911)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_text=>'Popup LOV'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149505327392725640)
,p_name=>'F4000.P374.POS.1'
,p_message_text=>'Pos.1'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149506512979730884)
,p_name=>'F4000.P374.POS.2'
,p_message_text=>'Pos.2'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149507032372736471)
,p_name=>'F4000.P374.POS.3'
,p_message_text=>'Pos.3'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149508511378739875)
,p_name=>'F4000.P374.POS.4'
,p_message_text=>'Pos.4'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7839310130588292)
,p_name=>'F4000.P374.POS.5'
,p_message_text=>'Pos.5'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255932528799792494)
,p_name=>'F4000.P374.POS.6'
,p_message_text=>'Pos.6'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255972625348794093)
,p_name=>'F4000.P374.POS.7'
,p_message_text=>'Pos.7'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255972823408794978)
,p_name=>'F4000.P374.POS.8'
,p_message_text=>'Pos.8'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149510900212755588)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_text=>'DML and pagination buttons require specific button names, reference help text.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1041684749433736848)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_text=>'%0 (Class Matches)'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149518811902777873)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_text=>'manage'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1289357884789314569)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_text=>'Original Value'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149523324500791042)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_text=>'Substitution String'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149528111256806092)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_text=>'Substitution Value'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139954013622729248)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<font class="instructiontext">This region will display page and item help for the current page when called using following syntax:<br>',
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149536101653860162)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_text=>'Form on %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149541611958882055)
,p_name=>'F4000.P404.VALUES'
,p_message_text=>'Values'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146336912716081944)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_text=>'Icon Subtext='
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146336506136080033)
,p_name=>'F4000.P4045.IMAGE='
,p_message_text=>'Image='
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146346315505234156)
,p_name=>'F4000.P4045.ITEM='
,p_message_text=>'Item='
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146341400090191825)
,p_name=>'F4000.P4045.LIST='
,p_message_text=>'List='
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146344205678221776)
,p_name=>'F4000.P4045.PAGE='
,p_message_text=>'Page='
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14567428133299857)
,p_name=>'F4000.P4045.REGION='
,p_message_text=>'Region='
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146348915983243760)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_text=>'Tab Set='
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146341804246193034)
,p_name=>'F4000.P4045.TEXT='
,p_message_text=>'Text='
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149738521316010734)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_text=>'Download'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149742009720045217)
,p_name=>'F4000.P420.CVS'
,p_message_text=>'CSV'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149736631790994858)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_text=>'Default Look 1'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149737314259999238)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_text=>'Default Look 2'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149737728804003390)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_text=>'Default Look 3'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149738109196007207)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_text=>'Default Look 4'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149724227016898855)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_text=>'Use externally created pagination buttons'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149735608110978485)
,p_name=>'F4000.P420.HTML_STD'
,p_message_text=>'HTML standard look'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149740227812031526)
,p_name=>'F4000.P420.LOOK1'
,p_message_text=>'Look 1'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149740719285038548)
,p_name=>'F4000.P420.LOOK2'
,p_message_text=>'Look 2'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149741123441039740)
,p_name=>'F4000.P420.LOOK3'
,p_message_text=>'Look 3'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149741527597040876)
,p_name=>'F4000.P420.LOOK4'
,p_message_text=>'Look 4'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149728923254926132)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_text=>'Rows X to Y'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149727506500911832)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_text=>'Row Ranges 1-15 16-30 in select list'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149730606547940228)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_text=>'Search Engine'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149727919660915626)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_text=>'Search Engine 1,2,3,4 (set based pagination)'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149729512303932421)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_text=>'Select List'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149717203543797450)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_text=>'set defaults'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149723518920887018)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_text=>'turn off pagination'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149728508709921939)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_text=>'Use pagination buttons'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149742524611049547)
,p_name=>'F4000.P420.XML'
,p_message_text=>'XML'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149739006556015915)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_text=>'XML Export'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149936809432979586)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_text=>'Generate Link'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149726518490905829)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_text=>'Row Ranges X to Y (with next and previous links)'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1755110288040792178)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_text=>'Null'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(228670025726383922)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_text=>'DB Column'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(228676627720403406)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_text=>'PL/SQL expression'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(228688627289422265)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_text=>'PL/SQL function body'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(228673321009392089)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_text=>'SQL Query'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(228664318669372478)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_text=>'static text'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149952704864148621)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_text=>'DML buttons require specific button names, reference help text.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30529711806817998)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_text=>'New plug-in will be created in application %0.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30529302802815350)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_text=>'Existing plug-in in application %0 will be replaced.'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149965911809302066)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_text=>'HTML w/shortcuts'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149967128562316298)
,p_name=>'F4000.P4651.PLSQL'
,p_message_text=>'PLSQL'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146364809168449931)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_text=>'Default Button Template'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(45552716768382833)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_text=>'Default Calendar Template'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593341632279897777)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_text=>'Default Chart Region Template'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(45362930554309485)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_text=>'Default Dialog Page Template'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593341848341898777)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_text=>'Default Form Region Template'
,p_version_scn=>37165770887507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593342642256904297)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_text=>'Default Interactive Report Region Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146364431894446989)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_text=>'Default Label Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593342049589900227)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_text=>'Default List Region Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146364024621444875)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_text=>'Default List Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593343215016907111)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_text=>'Default Breadcrumb Region Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146365217133452230)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_text=>'Default Breadcrumb Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593245256645659962)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_text=>'Default Navigation Bar List Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593244678295655997)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_text=>'Default Navigation Menu List Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593108425581398352)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_text=>'Default Optional Label Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146362026914436109)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_text=>'Default Page Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146362432109437626)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_text=>'Default Region Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593342237419901266)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_text=>'Default Report Region Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146363616656442610)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_text=>'Default Report Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593108645137399815)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_text=>'Default Required Label Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593245086817658499)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_text=>'Default Side Navigation Menu List Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593342442356902776)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_text=>'Default Tabular Form Region Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593244806041657610)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_text=>'Default Top Navigation Menu List Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593342830241905787)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_text=>'Default Wizard Region Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146361621720434569)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_text=>'Default Error Page Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1593261710164753148)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_text=>'Default Login Page Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146361214101432431)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_text=>'Default Print Mode Page Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149544215552892476)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_text=>'Report on %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148347221649290645)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_text=>'alert information'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148362209453381735)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_text=>'new region'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148339400393274977)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_text=>'You must create at least one region before you can create a page item.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148348525243301165)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_text=>'Use a wizard to create a new region'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148772917932046521)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_text=>'will be sorted alphabetically'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148774425682058235)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_text=>'Example 4: List of values with bind variable'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148774009752053598)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_text=>'sorted in order of creation'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148769121480028654)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_text=>'Example 2: List of values with same display and return value'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185570731231446623)
,p_name=>'F4000.P4719.INLINE'
,p_message_text=>'Example 5: Query contains in-line query, must ensure first FROM clause in the SQL statement is not part of the in-line query'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148767928275021129)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_text=>'Example 1: List of values based on SQL query'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148771529229040279)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_text=>'Example 3: Static list examples'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148770411221035114)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_text=>'When selecting the same column for both the display and return values use a column alias.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29880115309879630)
,p_name=>'F4000.P4719.YN'
,p_message_text=>'show Yes / No, return Y and N'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149984926980476737)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_text=>'After Processing'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149981712304463018)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_text=>'Before Computations'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149984414513473075)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_text=>'Before Processing'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149983901354469348)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_text=>'Before Validations'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37390900837540334)
,p_name=>'F4000.P4731.ADD'
,p_message_text=>'Add Row'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149988123349513502)
,p_name=>'F4000.P4731.APPLY'
,p_message_text=>'Apply'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32126726517376064)
,p_name=>'F4000.P4731.DELETE'
,p_message_text=>'Delete'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149990018763531084)
,p_name=>'F4000.P4731.FINISH'
,p_message_text=>'Finish'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149989419324521804)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_text=>'Submit'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150001112145576532)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_text=>'Pagination will be reset for all pages in this application when this procedure runs.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(151070807826999856)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_text=>'WARNING: You have chosen a validation of type Regular Expression, however your version of the database does not support them.  This validation will always return true.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(694731901671470687)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_text=>'Translations for this application are currently not enabled. See <em>Application Language Derived From</em> setting in <a href="%0">Globalization Attributes</a>.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1447898339712914164)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_text=>'When Maximum Session Idle Time is not set, the workspace level or instance level value will be used (currently, %0 seconds).'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1448056361887120303)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_text=>'When Maximum Session Length is not set, the workspace level or instance level value will be used (currently, %0 seconds).'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1137633130163109359)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_text=>'New Branch'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(210925907127579087)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_text=>'These components were exported from a different application or from an application in a different workspace. The components cannot be installed in this application.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218892327152677275)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_text=>'These files were exported from a different workspace. The files cannot be installed in this workspace.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1137639903389218635)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_text=>'To Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1155933732255449972)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_text=>'Copy Option: %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1155933920906451468)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_text=>'Existing List of Values: %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176939516372005878)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_text=>'This page was exported from a different application or from an application in different workspace. Page cannot be installed in this application.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134002813305555778)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_text=>'This page was exported from an application in another workspace.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134002220793548534)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_text=>'This page was exported from an application in the current workspace.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(479778329505464176)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_text=>'This page is currently locked.  You cannot import over a locked page.  Please unlock the page and then install.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1080734751826151865)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_text=>'Clear Parent Entry'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1146536660443540035)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_text=>'Select Parameter %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86538323137090640)
,p_name=>'F4000.P818.VALIDATION'
,p_message_text=>'Must select at least one scheme to be copied.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3346979597882557)
,p_name=>'F4000.P818.VALIDATION.NO_DUPLICATE_NAMES'
,p_message_text=>'There exists an authentication scheme with the same name: %0.'
,p_version_scn=>76607614
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3346708718909220)
,p_name=>'F4000.P818.VALIDATION.NO_DUPLICATE_SUBSCRIPTION'
,p_message_text=>'There exists an authentication scheme which is subscribed to the same master authentication scheme: %0.'
,p_version_scn=>76603057
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1146562096651816614)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_text=>'Value for HTTP Header %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1146560263847762174)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_text=>'Value for Input Parameter %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1146738627667596028)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_text=>'Delete Header'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1146735277742558688)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_text=>'Delete Parameter: %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150805707213036461)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_text=>'Required Style Sheet'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141775604963076853)
,p_name=>'F4000.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146036105342529459)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_text=>'Page Button'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135406121887353083)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_text=>'Page Computation'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46902724637541315)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_text=>'Page Dynamic Action'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000732909495596)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_text=>'Page Dynamic Action - Action'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134837703065063771)
,p_name=>'F4000.PAGE_ITEM'
,p_message_text=>'Page Item'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2200685392212779)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_text=>'Page Item Group'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146366009299459372)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_text=>'page(s)'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13142322962515734)
,p_name=>'F4000.PAGE_META_TAG'
,p_message_text=>'Page Meta Tag'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141779320894081452)
,p_name=>'F4000.PAGE_NAME'
,p_message_text=>'Page Name'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135408332622356237)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_text=>'Page Process'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146035627028526237)
,p_name=>'F4000.PAGE_REGION'
,p_message_text=>'Page Region'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146037732485546724)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_text=>'Page Validation'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135416601632385149)
,p_name=>'F4000.PARENT_TAB'
,p_message_text=>'Parent Tab'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(142982813471268544)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_text=>'Popup List of Values template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573899837554916324)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_text=>'Remote Print Server Credentials'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143419401285016250)
,p_name=>'F4000.PUBLISH'
,p_message_text=>'Publish'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001315230582138)
,p_name=>'F4000.PWA_PUSH_CREDENTIALS'
,p_message_text=>'PWA Push Notifications Credentials'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13142169407514745)
,p_name=>'F4000.PWA_SCREENSHOT'
,p_message_text=>'PWA Screenshot'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13141961116511676)
,p_name=>'F4000.PWA_SHORTCUT'
,p_message_text=>'PWA Shortcut'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135391130497327247)
,p_name=>'F4000.REGION'
,p_message_text=>'Region'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573545839995573569)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_text=>'Region Column'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141780228166083471)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_text=>'Related Page(s) and Components'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573901516543940452)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185377920813253892)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_text=>'Report Column'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10902036710385063)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1431441923389870)
,p_name=>'F4000.SEC_SCHEME_NAME_ALREADY_EXISTS'
,p_message_text=>'Authorization Scheme Name(s) %0 already exists.  Enter a new name.'
,p_version_scn=>16116982
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1431242421386901)
,p_name=>'F4000.SEC_SCHEME_SUBSCRIPTION_ALREADY_EXISTS'
,p_message_text=>'Authorization scheme subscriptions(s) %0 already exists.  Choose a different authorization scheme.'
,p_version_scn=>16117032
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143418725049013645)
,p_name=>'F4000.SEED'
,p_message_text=>'Seed'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135416223319381907)
,p_name=>'F4000.STANDARD_TAB'
,p_message_text=>'Standard Tab'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145988612924228808)
,p_name=>'F4000.STATIC'
,p_message_text=>'Static'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141824409690144388)
,p_name=>'F4000.TAB'
,p_message_text=>'Tab'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143022808632342861)
,p_name=>'F4000.TEMPLATE'
,p_message_text=>'Template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5007329143011604)
,p_name=>'F4000.TEMPLATE_COMPONENT'
,p_message_text=>'Template Component'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93404031792355486)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_text=>'Template Name(s) %0 already exists.  Enter a new name.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86544517989117530)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_text=>'Template Name must be specified.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143385830084036014)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_text=>'New theme will be created in application %0.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143386508051039115)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_text=>'Existing theme in application %0 will be replaced.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(141819305965124455)
,p_name=>'F4000.TO'
,p_message_text=>'to'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135421219902409341)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_text=>'Unknown Application Element'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143422611290066454)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_text=>'Updateable Column'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(193724713542174017)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_text=>'Take actions or access reports across pages within the selected application.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135409204702357576)
,p_name=>'F4000.VALIDATION'
,p_message_text=>'Validation'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10902201050386055)
,p_name=>'F4000.WEB_SOURCE'
,p_message_text=>'REST Data Source'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573902319277950727)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_text=>'REST Data Source'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134489925744682388)
,p_name=>'F4000.YES'
,p_message_text=>'Yes'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165249714489706664)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_text=>'Date MMDDYYYY'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(293191102915326473)
,p_name=>'F4000_APPLICATIONS'
,p_message_text=>'Applications'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62016702554585619)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_text=>'As an application on a database table'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147088014969938712)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_text=>'As an application on database tables'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150808127645042322)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_text=>'This button position is not in your region template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(651618085775482117)
,p_name=>'F4000_CHART'
,p_message_text=>'Chart'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150822203721158394)
,p_name=>'F4000_CLOSE'
,p_message_text=>'Close'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153549405181508295)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_text=>'Copy and Subscribe'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150859819567532022)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_text=>'Date format not recognized.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37271124481000772)
,p_name=>'F4000_F1500_LOCKED'
,p_message_text=>'Locked'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(196125709113497656)
,p_name=>'F4000_HELP_TEXT'
,p_message_text=>'Help Text'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(291143926462938285)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_text=>'List of Values Name(s) %0 already exists. Enter a new name.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156325827764888435)
,p_name=>'F4000_NONE_SELECTED'
,p_message_text=>'None Selected'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145735912185499985)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_text=>'No Application Associated'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15607427552526611)
,p_name=>'F4000_OFF'
,p_message_text=>'Off'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15607022704525241)
,p_name=>'F4000_ON'
,p_message_text=>'On'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38660710153584840)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_text=>'Calendar templates referencing this, template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177585711524722102)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_text=>'view pages of this type'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86879717249789116)
,p_name=>'F4000_P173_NO_HELP'
,p_message_text=>'no help exists for this item'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86594326618242992)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_text=>'authentication home'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86593321078241432)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_text=>'Edit this template'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87403413025738167)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_text=>'Reset CSS'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(493109316682353244)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_text=>'Page already exists in this application.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37546123750494308)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_text=>'Page must be numeric.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37576114661510664)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_text=>'Page must be positive numbers.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37578007866518198)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_text=>'Page must be whole numbers.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(199283731134650209)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_text=>'Import Authorization Scheme(s)'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176127115356655918)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_text=>'Import Authentication Scheme(s)'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(199285221568656902)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_text=>'Import Navigation Bar(s)'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176128100596661105)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_text=>'Import Theme'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150024016787662983)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_text=>'Tabular Form'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165127624242113325)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_text=>'Authenticated!'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165129712599119454)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_text=>'Authentication failed!'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155993209664776110)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_text=>'No Column'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150902908689494047)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_text=>'This application is currently unavailable at this time.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78815025925985832)
,p_name=>'F4000_P430_DATE'
,p_message_text=>'Date: %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78815409087990462)
,p_name=>'F4000_P430_DATE2'
,p_message_text=>'Date, flexible: %0 with any separator'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78819131428034683)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_text=>'Date format not recognized'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78818708226028033)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_text=>'Date must be in the form %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78813004622941846)
,p_name=>'F4000_P430_IP'
,p_message_text=>'IP Address'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78816821685003558)
,p_name=>'F4000_P430_IP_ERR'
,p_message_text=>'Invalid IP Address'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78813422284946942)
,p_name=>'F4000_P430_PHONE'
,p_message_text=>'Phone Number, US: %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78813810425962453)
,p_name=>'F4000_P430_PHONE2'
,p_message_text=>'Phone Number, US flexible: 999.999.9999, (999)-999-9999, 999 999 9999, etc...'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78817929781015296)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_text=>'Phone number format not recognized'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78817210388009717)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_text=>'Phone number must be in the form %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78812622499937542)
,p_name=>'F4000_P430_URL'
,p_message_text=>'URL: http(s)://domain/path/doc.(pdf)(html)(etc...)'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78816106794999238)
,p_name=>'F4000_P430_URL_ERR'
,p_message_text=>'Invalid URL'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78814215405973269)
,p_name=>'F4000_P430_ZIP'
,p_message_text=>'ZIP Code: 99999'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78814602030978955)
,p_name=>'F4000_P430_ZIP2'
,p_message_text=>'ZIP + 4: 99999-9999'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78818323678023037)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_text=>'ZIP code must be in the form %0'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39886304819402862)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_text=>'Subscribed to Authentication'
,p_version_scn=>73092456
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39886714515405621)
,p_name=>'F4000_P4495.MASTER'
,p_message_text=>'This is the "master" copy of this authentication scheme.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39887530792410336)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_text=>'There are no subscribers to this authentication scheme.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39887124904408640)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_text=>'Applications subscribing to this Authentication Scheme'
,p_version_scn=>34185680
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(65386729108453214)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_text=>'- no scheme -'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149969411509330281)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_text=>'Report 1'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150905031246528923)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_text=>'Form on Stored Procedure'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149974304499347243)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_text=>'Chart 1'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150890108147954553)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_text=>'Display Only'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150889802953953043)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_text=>'Hidden'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150886413248899195)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_text=>'Clear Item(s) Cache'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150886001474895803)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_text=>'Clear Page(s) Cache'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(157352628773779755)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_text=>'Reset Pagination'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150887300912905126)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_text=>'Set Item using PL/SQL function body'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150886824330902446)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_text=>'Static Item Assignment'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149995323311560818)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_text=>'All page items that are not cached in the current application will be initialized to null.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150893117656193812)
,p_name=>'F4000_P4737_EXISTS'
,p_message_text=>'Exists'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150892218564184591)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_text=>'Item Not Null'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150892528261187430)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_text=>'Item Not Zero'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150892809345191433)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165258818906726794)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_text=>'Date DDMMYYYY'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165254621546718068)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_text=>'Phone Number'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(818285481791031268)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_text=>'Database Object'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150010202411621032)
,p_name=>'F4000_P4759_VIEW'
,p_message_text=>'In Browser'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150012031501629445)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_text=>'Calendar 1'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(65785219203598803)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_text=>'(containing Date or Timestamp column)'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317085609887212421)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_text=>'Syntax: select id, name, date from ...'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317086313972225763)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_text=>'Example using ROWID pseudo column'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317086506855229082)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_text=>'Example using the source table Primary Key'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317085801476216309)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_text=>'1. You must include at least two columns, one of which must be a DATE column.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(317086029500218505)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_text=>'2. The first column should identify the primary key column to be used for managing data manipulation language (DML) operation.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150018910769651786)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_text=>'Form 1'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(211657623650073328)
,p_name=>'F4000_P48_MANIFEST'
,p_message_text=>'Component Export Manifest    '
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177572209400693131)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_text=>'View page definition'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150029603544678159)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_text=>'Summary Page'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153666831463913325)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_text=>'click to set tab set'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379173801566229476)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_text=>'Page template supports two level tabs, however standard tab does not identify a parent tab set'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379173616878222387)
,p_name=>'F4000_P643_NO_TAB'
,p_message_text=>'No tabs, this page will not display tabs'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379173203760182882)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_text=>'This page will show one level of tabs'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379177301086290484)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_text=>'Pages with no tabs'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379178819189297290)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_text=>'A total of %0 pages have no tabs defined.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379172919503175595)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_text=>'Tab Display'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379173411499209702)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_text=>'This page will show two levels of tabs'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(627209892749353745)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Oracle APEX %0 is available!</strong> Your instance will be automatically upgraded on <strong>%1</strong>. Your Instance administrator can initiate the upgrade at any time prior to this date in Administration Services.</p>',
'<p><a rel="noopener noreferrer" href="%2" target="_blank" rel="noopener noreferrer">Read the announcement</a> to learn what''s new in this release.</p>'))
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(627209444774343781)
,p_name=>'F4000_P78_UPGRADING'
,p_message_text=>'<strong>Your %0 instance is being upgraded to a newer release.</strong> Changes to your applications will be disabled for a period of time during the upgrade process. Access to your applications and %0 development environment will be interrupted for '
||'up to %1 minutes.'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39873601724462645)
,p_name=>'F4000_P801_ACTION'
,p_message_text=>'Action'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39879230099059985)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_text=>'Make this scheme current'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39879605297062332)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_text=>'make current'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(64444629386160793)
,p_name=>'F4000_P801_CURRENT'
,p_message_text=>'current'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39878415424046270)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_text=>'Change status to inactive'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39871228211432447)
,p_name=>'F4000_P801_DETAILS'
,p_message_text=>'Details'
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39871607910435989)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Built-in session management logic, a built-in login page and user authentication against the internal "cookie user" account repository.',
''))
,p_version_scn=>37165770887508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39872426957441515)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_text=>'This method has been replaced with SCHEME authentication.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61409019186790889)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_text=>'Edit deprecated authentication attributes'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61409427628802834)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_text=>'deprecated attributes'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61409831700822962)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_text=>'or leave them in place until you are ready to change the authentication method to %0.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61412206737938755)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_text=>'Specifies one or more deprecated authentication attributes.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61413803583985128)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_text=>'or migrate them to an authentication scheme.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61406830577491461)
,p_name=>'F4000_P801_FLOW'
,p_message_text=>'Application'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39876016053476210)
,p_name=>'F4000_P801_MANAGE'
,p_message_text=>'Manage authentication schemes using the report above.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39870811589427647)
,p_name=>'F4000_P801_METHOD'
,p_message_text=>'Method'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(64444024838131113)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_text=>'(Not Editable)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39878821442057486)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_text=>'(current)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61407218634525803)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_text=>'(deprecated)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39875609127474192)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_text=>'(none)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39873231590452290)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_text=>'Public Pages'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39874012113465584)
,p_name=>'F4000_P801_REVIEW1'
,p_message_text=>'Review or edit'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39874420078467963)
,p_name=>'F4000_P801_REVIEW2'
,p_message_text=>'or edit'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39874828043470260)
,p_name=>'F4000_P801_REVIEW3'
,p_message_text=>'session management attributes'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39875201508472017)
,p_name=>'F4000_P801_REVIEW4'
,p_message_text=>'of this application on the application attributes page, or use the report above to create and manage authentication schemes that can be used when you change the authentication method to %0.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61410307851844396)
,p_name=>'F4000_P801_REVIEW5'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Review or edit session management attributes',
''))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61413104575957016)
,p_name=>'F4000_P801_REVIEW6'
,p_message_text=>'Review or edit these'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61407622275564684)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_text=>'%0 authentication is a deprecated method. We recommend that you click the "make current" link (shown above) on one of the authentication schemes in this application, or create a new authentication scheme and make it current. The INTERNAL-SETUP authen'
||'tication scheme is functionally equivalent to the %0 method.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61411327422887901)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_text=>'Uses authentication schemes to control user authentication and all other aspects of session management for your application.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150206009663872154)
,p_name=>'F4000_P805_X'
,p_message_text=>'You specified a page sentry function in the previous step. That function will be responsible for session verification on each page, so a session verification function may not be entered here. If this is not what you want, you may step backward throug'
||'h this wizard and make changes.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66222117896903331)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_text=>'Built-in Login Page'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66223700066935976)
,p_name=>'F4000_P806_NONE'
,p_message_text=>'None'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66222528070915744)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_text=>'Page in This Application'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66223311363929820)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_text=>'Oracle Application Server Single Sign-On'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66222921275923177)
,p_name=>'F4000_P806_URL'
,p_message_text=>'URL'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66225200675955094)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_text=>'Use %0 account username and password to authenticate.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19804220938385447)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_text=>'Use database account username and password to authenticate.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66225621930970736)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_text=>'Do not verify credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66226423793980669)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_text=>'Use my custom function to authenticate.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66226003361974800)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_text=>'Use an LDAP server to authenticate.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150906329646537882)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_text=>'- No page name -'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39893331774656582)
,p_name=>'F4000_P811_AUTH'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Authentication Function',
''))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39896502731676578)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_text=>'Cookie Domain'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39895724417673388)
,p_name=>'F4000_P811_C_NAME'
,p_message_text=>'Cookie Name'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39896130651675166)
,p_name=>'F4000_P811_C_PATH'
,p_message_text=>'Cookie Path'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18869930610961583)
,p_name=>'F4000_P811_C_SECURE'
,p_message_text=>'Secure'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39892514459651575)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_text=>'Invalid Session Target'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39894526364664499)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_text=>'LDAP Search Base'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39894908487668811)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_text=>'LDAP Username Edit'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39893709742659693)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_text=>'LDAP Host'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39894118053662100)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_text=>'LDAP Port'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39896908272678205)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_text=>'Logout URL'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39891318137643177)
,p_name=>'F4000_P811_NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39890910865641131)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_text=>'(Built-In)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39897316237680472)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_text=>'(Database Authentication)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39891724024644884)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_text=>'Page Sentry Function'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39895316106670984)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_text=>'Post-Authentication Process'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39892921731653672)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_text=>'Pre-Authentication Process'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39892106147649238)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_text=>'Session Verification Function'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66229313582015577)
,p_name=>'F4000_P815_COPY'
,p_message_text=>'As a copy of an existing authentication scheme'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66229703670022247)
,p_name=>'F4000_P815_GALLERY'
,p_message_text=>'Based on a pre-configured scheme from the gallery'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66228911719005572)
,p_name=>'F4000_P815_SCRATCH'
,p_message_text=>'Based on a pre-configured scheme from the gallery'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41469703149528409)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_text=>'Error in refreshing authentication schemes.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39900332654770449)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_text=>'Authentication Method'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78913212633022862)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_text=>'Warning: You are about to delete the current authentication scheme for this application!'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39901117547775466)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39899926767768765)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_text=>'Application ID'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39900709236773101)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_text=>'Scheme Name'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66234300562097054)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_text=>'Oracle Application Server Single Sign-On (My Application as Partner App)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66232732245068270)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_text=>'Show Login Page and Use %0 Account Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66233124757075644)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_text=>'Show Built-In Login Page and Use Open Door Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66233507919080219)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_text=>'Show Login Page and Use LDAP Directory Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66233902509088076)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_text=>'Oracle Application Server Single Sign-On (%0 Engine as Partner App)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40267217392815769)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_text=>'Current Authentication Method'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41470109728530360)
,p_name=>'F4000_P826_CREATE1'
,p_message_text=>'Single Sign-On (Oracle Use Only)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41470515616531998)
,p_name=>'F4000_P826_CREATE2'
,p_message_text=>'Oracle Application Server Single Sign-On (%0 as Partner Application)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41470923234534243)
,p_name=>'F4000_P826_CREATE3'
,p_message_text=>'Oracle Application Server Single Sign-On (My Application as Partner Application)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41471330160536239)
,p_name=>'F4000_P826_CREATE4'
,p_message_text=>'Built-in Login Page: Use %0 Account Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58961322020257300)
,p_name=>'F4000_P826_CREATE4A'
,p_message_text=>'Newly Created Login Page: Use %0 Account Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58961731717260145)
,p_name=>'F4000_P826_CREATE4B'
,p_message_text=>'Existing Login Page: Use %0 Account Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41471704319538227)
,p_name=>'F4000_P826_CREATE5'
,p_message_text=>'Built-in Login Page: Open Door Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41472110206539962)
,p_name=>'F4000_P826_CREATE6'
,p_message_text=>'Built-in Login Page: Use LDAP Directory Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58960510807244588)
,p_name=>'F4000_P826_CREATE6A'
,p_message_text=>'Newly Created Login Page: Use LDAP Directory Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58960929854250135)
,p_name=>'F4000_P826_CREATE6B'
,p_message_text=>'Existing Login Page: Use LDAP Directory Credentials'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41472515747541468)
,p_name=>'F4000_P826_CREATE7'
,p_message_text=>'Based on authentication scheme from gallery'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(66235709959128137)
,p_name=>'F4000_P826_NEW'
,p_message_text=>'New'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86652803275501185)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_text=>'The undo feature of %0 uses a built in database feature called "Flashback Query", allowing you to query data as of a certain time.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86651009724493635)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_text=>'Select a time you want to go back to, then click "Apply" to write the source back to the region edit page and close this dialog.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86654430980509247)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_text=>'Based on the database parameter "UNDO_RETENTION", you may only undo changes that occurred within the last %0 hour(s).'
,p_version_scn=>37165899742952
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86681816790580831)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_text=>'Confirm Create-Standard Tab in Application'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86691826187611948)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_text=>'A new tab set %0 will be created.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86690108872606883)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_text=>'Page %0 will use the existing tab set "%1".'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86685428696593735)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_text=>'Warning, tabset information in incomplete.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(324108200335061668)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_text=>'Value for %0'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150827706538187616)
,p_name=>'F4000_PREV'
,p_message_text=>'Prev.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147096621081006667)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_text=>'Click <strong>Finish</strong> to create or extend your application.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147092208221974630)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_text=>'Include breadcrumb navigation aids'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147092703157982623)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_text=>'Hide primary key in report page'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244166318158214050)
,p_name=>'F4000_SHORTCUT'
,p_message_text=>'Shortcut'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118129716703327549)
,p_name=>'F4000_SVG_CHART'
,p_message_text=>'SVG Chart'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150809716694048608)
,p_name=>'F4000_TOP'
,p_message_text=>'Top'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(196129728553531633)
,p_name=>'F4000_TREE'
,p_message_text=>'Tree'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(315847010134538103)
,p_name=>'F4000_WORKSPACE'
,p_message_text=>'Workspace'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25361907636262929)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_text=>'Entire Response Document'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22139822636023550)
,p_name=>'F4050.ACCEPTED'
,p_message_text=>'DELETE'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316820306488089637)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_text=>'Accepted'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(188645923081160381)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_text=>'Schema will be assigned to the workspace.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(188646512823166833)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_text=>'Schema will not be assigned to the workspace for the following reasons:'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(188027029567105422)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_text=>'Additional Schema'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145831423697834506)
,p_name=>'F4050.ADJUST'
,p_message_text=>'Adjust'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145812814038784444)
,p_name=>'F4050.ALL'
,p_message_text=>'All'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316795309915586679)
,p_name=>'F4050.APPROVED'
,p_message_text=>'Approved'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23911325230448901)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_text=>'Your request for a workspace has been approved and credentials sent to the email address you provided during registration.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179820507844497340)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_text=>'Your request for an account has been approved.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179819727321484036)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_text=>'Approved: account request for %0 '
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179825711288697031)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_text=>'Your request for an additional %0 megabytes of storage in workspace %1 has been approved.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316794322942474215)
,p_name=>'F4050.ASSIGNED'
,p_message_text=>'Assigned'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(639421725872867422)
,p_name=>'F4050.AUTOMATIC'
,p_message_text=>'Automatic'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316794127470472124)
,p_name=>'F4050.AVAILABLE'
,p_message_text=>'Available'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352007997049892192)
,p_name=>'F4050.BROKEN'
,p_message_text=>'Broken'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352009045827898915)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_text=>'Chain Stalled'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179828309565772240)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_text=>'Change request approved'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179828708658781461)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_text=>'Change request denied'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352007723440891074)
,p_name=>'F4050.COMPLETED'
,p_message_text=>'Completed'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(188044408228108792)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_text=>'Schema will be created.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316795505602588615)
,p_name=>'F4050.DECLINED'
,p_message_text=>'Declined'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179824828641654723)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_text=>'Declined: account request for %0'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179827921209766125)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_text=>'Your request for an additional %0 megabytes of storage in workspace %1 has been denied.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179826503716723282)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_text=>'Your request for database schema %0 in workspace %1 has been denied.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179826926010739155)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_text=>'Your request to terminate service for workspace %0 has been denied.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352006553209885915)
,p_name=>'F4050.DISABLED'
,p_message_text=>'Disabled'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22123827073845070)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Click the link below to complete the approval process. Once complete, you will receive your workspace credentials in a follow-up email.',
'',
'%0'))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179821613431527317)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Click the link below to get started.',
'',
'%0'))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352008107720893694)
,p_name=>'F4050.FAILED'
,p_message_text=>'Failed'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28982224117920311)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_text=>'Please click <a href=''%0''>here</a> to complete the approval process and receive your credentials.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143453901312243350)
,p_name=>'F4050.INFORMATION'
,p_message_text=>'Information'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145886730417921579)
,p_name=>'F4050.INSTALL'
,p_message_text=>'Install'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316795709663632342)
,p_name=>'F4050.IN_PROGRESS'
,p_message_text=>'In Progress'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145820428152807406)
,p_name=>'F4050.NO_ACTION'
,p_message_text=>'No Action'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150244918601045060)
,p_name=>'F4050.P23.USE'
,p_message_text=>'Use'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1494434304923541669)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_text=>'Update Check disabled for the entire instance'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150249223496074851)
,p_name=>'F4050.P39_OPEN'
,p_message_text=>'Open'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(187988215369101348)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_text=>'Primary Schema'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145830117810832777)
,p_name=>'F4050.PROVISION'
,p_message_text=>'Provision'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179766225640071194)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_text=>'Change request approved.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179765815251068180)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_text=>'Your request for database schema %0 in workspace %1 has been approved.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352008426242895159)
,p_name=>'F4050.REMOTE'
,p_message_text=>'Remote'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316795904487634686)
,p_name=>'F4050.REQUESTED'
,p_message_text=>'Requested'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145809818063776106)
,p_name=>'F4050.RESET'
,p_message_text=>'Reset'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179776000303659950)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_text=>'Warning: The requested schema is restricted because it is an Oracle default schema or because of site-specific policies. Restricted schemas cannot be assigned to workspaces.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352007116191888317)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_text=>'Retry Scheduled'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(188138128791124106)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_text=>'Existing schema will be reused.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352007562054889992)
,p_name=>'F4050.RUNNING'
,p_message_text=>'Running'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352003976178884132)
,p_name=>'F4050.SCHEDULED'
,p_message_text=>'Scheduled'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179625214726302594)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_text=>'Warning: The requested schema is already assigned to one or more workspaces. Please ensure that giving multiple workspaces access to the same schema is permitted by the security policies at your site before approving this request.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179624806930262446)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_text=>'Warning: The requested schema already exists.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(188647530485171964)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_text=>'The schema does not exist.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(188836903866192677)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_text=>'The schema is reserved and may not be assigned to workspaces.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179625623384305073)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_text=>'Warning: The requested schema is restricted because it is an Oracle default schema or because of site-specific policies. If you assign this schema to the workspace by proceeding, you will be giving developers in that workspace full access to the sche'
||'ma. Please ensure that this action is consistent with the security policies at your site before approving this request.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(188836024167189086)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_text=>'The schema is restricted by security policies. Restricted schemas cannot be assigned to workspaces.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179830107665809594)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_text=>'Service terminated'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179830505719818485)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_text=>'Your development service "%0" has been terminated.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1352008772171897383)
,p_name=>'F4050.SUCCEEDED'
,p_message_text=>'Succeeded'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316794518413476363)
,p_name=>'F4050.SUSPENDED'
,p_message_text=>'Suspended'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316794714099478341)
,p_name=>'F4050.TERMINATE'
,p_message_text=>'Terminate'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(316796132510636918)
,p_name=>'F4050.TERMINATED'
,p_message_text=>'Terminated'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1351978525323738372)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_text=>'Termination in Progress'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145836812316859611)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_text=>'View Request'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145882728208911522)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_text=>'Workspace Export'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75206101896338943)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_text=>'Workspace Home'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75206509861341219)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_text=>'Workspace Login'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176891429814779648)
,p_name=>'F4050.WSID_EXISTS'
,p_message_text=>'Workspace will not be created because a workspace with the same ID already exists.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176890818386776368)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_text=>'Workspace will not be created because a workspace with the same name already exists.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(102929930842706242)
,p_name=>'F4050.WS_CREATED'
,p_message_text=>'Workspace %0 was created at %1 and confirmation sent to the email address you provided during registration.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25628922114609795)
,p_name=>'F4050.WS_EXISTS'
,p_message_text=>'Workspace will not be created because it already exists.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25629303891613922)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_text=>'Workspace will be created.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114747300497047211)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_text=>'New Password'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114746927247035998)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_text=>'Account password changed for user %0.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114745431917999567)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_text=>'Your password has been changed.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(839147671570607040)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_text=>'Once a new %0 release becomes available, you will have <strong>%1 days</strong> to test your apps. If you don''t upgrade within this window, the upgrade will be automatically applied for you.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(331737606932283560)
,p_name=>'F4050_P158_PAID_ADB_INTRO_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page allows you to define the upgrade window for your %0 instance. Once an upgrade becomes available, you can apply it at any time within this window.</p>',
'',
'<p>Select the longer upgrade window if you need additional time to test your apps. If you don''t upgrade within this window, the upgrade will be automatically applied for you.</p>'))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(839148476471617548)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>%0 %1 is available! <a rel="noopener noreferrer" href="%2" target="_blank" rel="noopener noreferrer">Read the announcement</a> to learn what''s new in this release.</p>',
'<p>You can begin the upgrade by clicking Upgrade Now below. If you take no action, your instance will be automatically upgraded on <strong>%3</strong>.</p>'))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(331737981665287199)
,p_name=>'F4050_P158_UPGRADE_WINDOW_LOV'
,p_message_text=>'%0 days'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(331735868608254241)
,p_name=>'F4050_P158_UPGRADING'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>%0 is currently being upgraded to %1.</p>',
'<p>Changes to your applications will be disabled for a period of time during the upgrade process. Access to your applications and %0 development environment will be interrupted for up to %2 minutes.</p>'))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(837679378547437608)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_text=>'System is up-to-date.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(837679539688445519)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_text=>'%0 %1 is available. <a rel="noopener noreferrer" href="%2" target="_blank" rel="noopener noreferrer">Read the announcement</a>.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(833883074811534384)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Once a new %0 release becomes available, you will have <strong>%1 days</strong> to test your apps before this instance is automatically upgraded.</p>',
'',
'<p>If you need more time, click the gear icon to increase this upgrade window.</p>'))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(836350092292156051)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_text=>'If you take no action, your instance will be automatically upgraded on <strong>%0</strong>.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(833882636368532721)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_text=>'Once a new %0 release becomes available, you will have <strong>%1 days</strong> to test your apps before this instance is automatically upgraded.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(331736633377263898)
,p_name=>'F4050_P3_UPGRADE_NOW'
,p_message_text=>'Upgrade Now'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388974535508417280)
,p_name=>'F4050_P3_UPGRADING'
,p_message_text=>'%0 is currently being upgraded to %1.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24593407723308270)
,p_name=>'F4050_P74_PROVISION'
,p_message_text=>'Database user %0 created with default tablespace %1 using datafile %2'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26640504268629944)
,p_name=>'F4050_P74_PROVISION1'
,p_message_text=>'Workspace %0 provisioned with administrator %1.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87844101253467937)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_text=>'Show All Workspaces'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86870432570774655)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_text=>'Column length cannot be null.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86869726683772874)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_text=>'Column length cannot be zero.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86871506036776399)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_text=>'Column names cannot be longer than %0 characters.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86873212269778193)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_text=>'Column names cannot be null.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5396253719794266)
,p_name=>'F4300.DATA_UNLOAD_INITIATED'
,p_message_text=>'File with data to be unloaded is being prepared and downloaded.'
,p_is_js_message=>true
,p_version_scn=>133463484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86881724521791243)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_text=>'<strong>%0</strong> is already used by an existing object.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86935724306800603)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_text=>'<strong>%0</strong> is not a valid sequence name.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86867509368767945)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_text=>'Table name already exists.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86877900626784292)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_text=>'<strong>%0</strong> is not a valid primary key name.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150255008867089512)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_text=>'DOS'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143330408052431553)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_text=>'Spreadsheet Import'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86874519542780298)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_text=>'Table names must be less than %0 characters.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87938425952733481)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_text=>'First row contains column names.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224226903173180696)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_text=>'Text Import'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100134429029480686)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_text=>'Application Owner'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145757327432580123)
,p_name=>'F4350.AVAILABLE'
,p_message_text=>'(available)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145739715779510525)
,p_name=>'F4350.CHANGE'
,p_message_text=>'Change'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(246268318693598982)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_text=>'You are requesting that the existing schema %0 be assigned to your workspace.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(246303322896628524)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_text=>'You are requesting that the schema %0 be created and assigned to your workspace.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145735108722498983)
,p_name=>'F4350.CREATE'
,p_message_text=>'Create'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101842816264248805)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_text=>'Creating Workspace'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145756919813577935)
,p_name=>'F4350.CURRENT'
,p_message_text=>'(current)'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100139928252499393)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_text=>'Current Time (on server)'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100137907128493307)
,p_name=>'F4350.CURRENT_USER'
,p_message_text=>'Current User'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145738108160508338)
,p_name=>'F4350.DELETE'
,p_message_text=>'Delete'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(103022404831297823)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_text=>'Workspace creation has been disabled temporarily.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100132516562477137)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_text=>'Host Schema'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145721801880478113)
,p_name=>'F4350.INSERTED'
,p_message_text=>'Inserted'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100139015439495682)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_text=>'Language Preference'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100131603749473450)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_text=>'Last DDL Time'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381689586271773896)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_text=>'Last Patch Time'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(414809275530070944)
,p_name=>'F4350.MERGE'
,p_message_text=>'Merge'
,p_version_scn=>37166021078922
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20145930490083989)
,p_name=>'F4350.MORE'
,p_message_text=>'%0 more...'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381689213930763630)
,p_name=>'F4350.PATCH_VERSION'
,p_message_text=>'Patch Version'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100127609936446841)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_text=>'Product Build'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461033010354392251)
,p_name=>'F4350.RESET'
,p_message_text=>'Reset'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100128726212451531)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_text=>'Schema Compatibility'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20145609225992720)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_text=>'(+%0 translated applications)'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145732306513488953)
,p_name=>'F4350.UNKNOWN'
,p_message_text=>'Unknown'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145728020581483525)
,p_name=>'F4350.UPDATED'
,p_message_text=>'Updated'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100135610113484733)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_text=>'Workspace ID'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100136520849487821)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_text=>'Workspace Name'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554293371271697527)
,p_name=>'F4350_AJAX'
,p_message_text=>'AJAX'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554292715179690144)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_text=>'Authentication Callback'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145827801187828057)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_text=>'Click through log entries:'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145825206943820255)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_text=>'Developer activity log entries:'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145842000242884497)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_text=>'Distinct Users over all sessions = %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145884207561915021)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_text=>'no user selected'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145890525353929584)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_text=>'%0 Preferences exist for %1 users in workspace "%2"'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10376412599011993)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_text=>'%0 Preferences exist for %1 users'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145816323865796666)
,p_name=>'F4350_RESET_PREFS'
,p_message_text=>'Reset your preferences if you wish to run your application without any preset values.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26373928259575502)
,p_name=>'F4350_RESET_SESSION'
,p_message_text=>'Reset your session state if you wish to run your application without any preset values.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145897527216939654)
,p_name=>'F4350_SELECTED_USER'
,p_message_text=>'Selected User'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145843927600892400)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_text=>'Sessions older than %0 day(s) = %1'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145876518381899229)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_text=>'Sessions older than %0 minute(s) = %1'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145776530857628394)
,p_name=>'F4350_SESSION_STATE'
,p_message_text=>'Your session is identified by %0 and contains %1 entries.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145933821815023259)
,p_name=>'F4350_SQL'
,p_message_text=>'SQL'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145887300419922455)
,p_name=>'F4350_SUMMARY'
,p_message_text=>'Summary'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145832207205839257)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_text=>'Total Sessions for workspace "%0" is %1'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10370229736979001)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_text=>'Total Sessions: %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145901825269948512)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_text=>'User %0 has %1 preferences.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145814803780790907)
,p_name=>'F4350_USER_PREFS'
,p_message_text=>'The current user %0 has %1 preferences set.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145920226570967814)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_text=>'Workspace Schemas'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146267100756264668)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_text=>'Display Seq in Forms must be numeric.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146280202019331291)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_text=>'Display Seq in Reports must be numeric.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87301303321579921)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_text=>'The argument name <strong>%0</strong> is used more than once in this function.<br/>'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146551424274794926)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_text=>'Execution Order must be specified.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146546516478754859)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_text=>'Execution Order must be numeric.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143557202398271997)
,p_name=>'F4500.FIND'
,p_message_text=>'Find'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150265600818106080)
,p_name=>'F4500.HIDE_SQL'
,p_message_text=>'Hide SQL'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144539404728565975)
,p_name=>'F4500.MAGNIFY'
,p_message_text=>'Magnify'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584926995354787)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_text=>'Move Column Down'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584321454353171)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_text=>'Move Column Up'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86944204960823452)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_text=>'Enter unique execution order number.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4961911062856252)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_text=>'New Columns to Add'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86937925129810271)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_text=>'<strong>%0</strong> is not a valid object name.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86936905044804536)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_text=>'<strong>%0</strong> is not a valid table name.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577900498309295)
,p_name=>'F4500.NO_IMAGE'
,p_message_text=>'No Image'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144544805814594736)
,p_name=>'F4500.NULLABLE'
,p_message_text=>'nullable'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185608217403771413)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_text=>'Previous Runs'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87227127113454296)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_text=>'The column names <strong>%0</strong> are used more than once in this table.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87252419934509031)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_text=>'Must enter the name of at least one column.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87249017379498849)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_text=>'The column name <strong>%0</strong> is invalid.<br />'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87240403049485169)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_text=>'The precision for the column <strong>%0</strong> is invalid.<br/>'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87241207551486541)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_text=>'The scale for the column <strong>%0</strong> is invalid.<br/>'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24233212357857302)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_text=>'The scale for the column <strong>%0</strong> is required.<br/>'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150298824647283291)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_text=>'Create synonym on'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150264420773102430)
,p_name=>'F4500.SHOW_SQL'
,p_message_text=>'Show SQL'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86939707599814700)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_text=>'Table <strong>%0</strong> not found in schema <strong>%1</strong>.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6153518682252669)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_text=>'Warning Statements'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146099910602710759)
,p_name=>'F4500_BROKEN'
,p_message_text=>'Broken'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146136610695767564)
,p_name=>'F4500_BYTES'
,p_message_text=>'Bytes'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146134327879763063)
,p_name=>'F4500_CARD'
,p_message_text=>'Card'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146048107345624604)
,p_name=>'F4500_CHECK'
,p_message_text=>'Check'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145347023829143851)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_text=>'Click to populate query field'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146133714027759013)
,p_name=>'F4500_COST'
,p_message_text=>'Cost'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145297307936091921)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_text=>'The create operation was successful.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(719539727706485054)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_text=>'Objects without defaults'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(719539567651483175)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_text=>'Objects with defaults'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145286019917010171)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_text=>'The drop operation was successful.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20617205117621379)
,p_name=>'F4500_FOREIGN'
,p_message_text=>'Foreign'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115221323309093715)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_text=>'Foreign Key'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87772822417376371)
,p_name=>'F4500_NATIVE'
,p_message_text=>'Native file format.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145208513674932676)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_text=>'not available to edit'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146115004630727899)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_text=>'not available to search'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146064507869662636)
,p_name=>'F4500_OF'
,p_message_text=>'Of'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146133000175755050)
,p_name=>'F4500_OPTIMIZER'
,p_message_text=>'Optimizer'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145353215087160173)
,p_name=>'F4500_OP_SUCCESS'
,p_message_text=>'The operation was successful.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(222942624645486615)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_text=>'VARCHAR column types do not exist.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29685025840567465)
,p_name=>'F4500_P1023_PARSING'
,p_message_text=>'Parsing script - please wait.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14417206166401083)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_text=>'Number of Statements'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(111190222010213705)
,p_name=>'F4500_P10_ON_BY'
,p_message_text=>'on %0 by %1'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145039831617407999)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_text=>'If you have parameters in the script, please define them before running.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14415329106388731)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_text=>'Script Name'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(111187805256199440)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_text=>'Script Size in Bytes'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108648409693576820)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_text=>'Updated By'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145049516426432058)
,p_name=>'F4500_P10_VALUE'
,p_message_text=>'Value'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240424019155921125)
,p_name=>'F4500_P115.CONFIRM'
,p_message_text=>'You have requested to import the following script(s). Please confirm your request.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240441423104007467)
,p_name=>'F4500_P115.ERROR'
,p_message_text=>'The script(s) you have requested to import exceed the maximum storage allowed.  Please contact the %0 administrator.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240683129649023879)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_text=>'Script to Import'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145063421668461909)
,p_name=>'F4500_P11_NUM'
,p_message_text=>'Num'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(131409305258381399)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_text=>'View Output'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166297025988065990)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_text=>'Browse Sequences'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166304107119098442)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_text=>'The create sequence operation was not successful for the following reason:'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166295206118050807)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_text=>'The sequence "%0" has been created in the "%1" schema.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145088703622504043)
,p_name=>'F4500_P12_STATEMENT'
,p_message_text=>'Statement'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166319227645161114)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_text=>'Browse Database Synonyms'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166326200596200655)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_text=>'The create synonym operation was not successful for the following reason:'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166316432709153136)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_text=>'The synonym "%0" has been created in the "%1" schema.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166336503067229683)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_text=>'The create package operation was not successful for the following reason:'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166349504508334202)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_text=>'The package "%0" has been created in the "%1" schema.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98506619730365793)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_text=>'Save to Worksheet'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145129513459592038)
,p_name=>'F4500_P25_BY'
,p_message_text=>'By'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145124220254584530)
,p_name=>'F4500_P25_CREATED'
,p_message_text=>'Created'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145120031898578382)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_text=>'File Name'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21304229377805231)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_text=>'Expired'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21304600896815983)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_text=>'Expired and Locked'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21303718988802297)
,p_name=>'F4500_P2610_LOCKED'
,p_message_text=>'Locked'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21303313793800716)
,p_name=>'F4500_P2610_OPEN'
,p_message_text=>'Open'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166294905079050480)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_text=>'The operation was not successful for the following reason:'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(151500305009038413)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_text=>'not available to insert data'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166287900615001934)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_text=>'Browse Database View'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166277531689954160)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_text=>'The create view operation was not successful for the following reason:'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166281603207964850)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_text=>'SQL Workshop Home'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166286500830992559)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_text=>'The view "%0" has been created in the "%1" schema.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150901620754393463)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_text=>'Get Column Comment'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254185229264096515)
,p_name=>'F4500_P602_IDENTITY'
,p_message_text=>'Identity'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28545002787003941)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_text=>'No datatype specified for %0.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145279405887968360)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_text=>'The table operation was successful.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145019719665366670)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_text=>'This file has %0 statements.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145027231917379739)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_text=>'User has defined following %0 parameter(s):'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87775006880400316)
,p_name=>'F4500_PARSE'
,p_message_text=>'Parse this script.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146047030416621864)
,p_name=>'F4500_PRIMARY'
,p_message_text=>'Primary'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8662002623439149)
,p_name=>'F4500_REFERENTIAL'
,p_message_text=>'Referential'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87774310212391770)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_text=>'View document as text.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146047502150623094)
,p_name=>'F4500_UNIQUE'
,p_message_text=>'Unique'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2358690750438193077)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_text=>'There are issues with the configuration of the Static Files in your environment. Please consult the "Configuring Static File Support" section in the Oracle APEX Installation Guide.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(275883433348136277)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_text=>'Welcome to Oracle APEX! Please sign in using the administrator (ADMIN) password of your Autonomous Database.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1883643949316343761)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_text=>'You are receiving this email because you requested an Oracle APEX workspace.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1883643490032314793)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_text=>'Action required: account request for %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177810622932624330)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_text=>'(used to email your credentials)'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177842811092791262)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_text=>'Please enter a database schema that currently exists in your Oracle database.  For security reasons, a list of values is not provided.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177835513601773076)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_text=>'Please enter the name of the Oracle database schema you would like to have created for your workspace.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177452818985137617)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'In your description below, please explain why you are requesting a restricted schema.',
''))
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177453227296140032)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_text=>'In your description below, please explain why you are requesting a schema that is already in use by one or more other workspaces.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177723125292095133)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_text=>'Warning: The schema you are requesting is restricted for security reasons. The %0 administrator may deny your request to assign this schema to your workspace.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177722707630090001)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_text=>'Warning: The schema you are requesting is already used by other workspace(s). The %0 administrator may deny your request to assign this schema to your workspace. '
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175016213507057623)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_text=>'The new schema that you have requested for your workspace is an Oracle default schema or may be specifically restricted at your site for security reasons and may not eligible for assignment to a workspace. The site administrator may reject your provi'
||'sioning request if this violates a security policy at your site.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175015705280036394)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_text=>'The schema that you have requested for your workspace is already assigned to %0 workspace(s). The site administrator may reject your provisioning request if this violates a security policy at your site.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20376230637286985)
,p_name=>'F4700P1_A'
,p_message_text=>'Oracle APEX provides access to an Oracle database and browser based development tools.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20376522803294173)
,p_name=>'F4700P1_B'
,p_message_text=>'Declaratively build web applications'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20377100209306659)
,p_name=>'F4700P1_C'
,p_message_text=>'Create and manage database objects'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20377421680312781)
,p_name=>'F4700P1_D'
,p_message_text=>'Track milestones, bugs, features and todos'
,p_version_scn=>14511212
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(774107484047717728)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_text=>'The application installed successfully. However, in order to run the application with Oracle APEX account authentication, an APEX user account must be set up.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224947394665268612)
,p_name=>'F4750.VERSION'
,p_message_text=>'Version'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(940818159815905787)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_text=>'Unable to reset sample RESTful Services data: schema <code>%0</code> does not exist.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468710109484602182)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_text=>'This application uses %0 authentication scheme.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(497070198305366360)
,p_name=>'FACETED_SEARCH'
,p_message_text=>'Faceted Search'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(473482670721129506)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_text=>'The wizard cannot create a faceted search using the report source.  There are no columns to search.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290123702722891054)
,p_name=>'FAILURE'
,p_message_text=>'failure'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145140532337635325)
,p_name=>'FAILURES'
,p_message_text=>'Failures'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173614400185012397)
,p_name=>'FDASH1'
,p_message_text=>'%0 Features'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191517916887838475)
,p_name=>'FEATURE'
,p_message_text=>'Feature'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1397683851852755265)
,p_name=>'FEATURE OWNERS'
,p_message_text=>'Feature Owners'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84200705203356904)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_text=>'About Page'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84201952224370403)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_text=>'About this application page.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84200995203358854)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_text=>'Access Control'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84203680172383309)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_text=>'Incorporate role based user authentication within your application and manage username mappings to application roles.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84201123246360046)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_text=>'Activity Reporting'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84204130716386721)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_text=>'Include numerous reports and charts on end user activity.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84201381991361273)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_text=>'Configuration Options'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84219433920465509)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_text=>'Allow application administrators to enable or disable specific functionality, associated with an Oracle APEX build option, from within the application.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183301178307521710)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_text=>'The following Build Option(s) will be created:'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(231894282222679540)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_text=>'Email Reporting'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(231895170003687078)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_text=>'Includes a report on the APEX_SEND() email queue.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(282644396285664209)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_text=>'Includes a report displaying the mail to be sent joined with the log of emails already sent.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84201562179363041)
,p_name=>'FEATURE.FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84204379551407363)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_text=>'Provide a mechanism for end users to post general comments back to the application administrators and developers.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(231895348983688353)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_text=>'Job Reporting'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(231895511104694051)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_text=>'Includes a report on database jobs, with the ability to drill down on a specific job to see additional details.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4300462136985973)
,p_name=>'FEATURE.LOGIN_PAGE'
,p_message_text=>'Login Page'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27400736922393806)
,p_name=>'FEATURE.PUSH_NOTIFICATIONS'
,p_message_text=>'Push Notifications'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27400947885405016)
,p_name=>'FEATURE.PUSH_NOTIFICATIONS.DESCRIPTION'
,p_message_text=>'Allow users to subscribe to push notifications on their devices.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84201747465364726)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_text=>'Theme Style Selection'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84219048821446127)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_text=>'Allow administrators to select a default color scheme (theme style) for the application. Administrators can also choose to allow end users to choose their own theme style. '
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830875334230756)
,p_name=>'FEATURE.USER_SETTINGS'
,p_message_text=>'User Settings'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831055538245220)
,p_name=>'FEATURE.USER_SETTINGS.DESCRIPTION'
,p_message_text=>'The user settings page is a drawer that links to all user settings pages.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184180325554185504)
,p_name=>'FEATURES'
,p_message_text=>'Features'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485078731951974562)
,p_name=>'FEATURES_100_PCT'
,p_message_text=>'Features 100%'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234853120204102803)
,p_name=>'FEATURES_100_PERCENT'
,p_message_text=>'Features 100% (%0/%1)'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192145719707498175)
,p_name=>'FEATURES_80_PCT'
,p_message_text=>'Features 80%'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18577520238762949)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_text=>' %0 >= 80%'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17728012725427410)
,p_name=>'FEATURES_COMPLETE'
,p_message_text=>'Features Complete (%0 / %1):'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18575220800753718)
,p_name=>'FEATURES_COMPLETED'
,p_message_text=>'%0 Completed'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487513045802053287)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_text=>'Features for Release %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234854220992193558)
,p_name=>'FEATURES_PAST_DUE'
,p_message_text=>'Past Due (%0/%1)'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(496362715660481844)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_text=>'Percent of features functionally complete (%0/%1):'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234853610018168240)
,p_name=>'FEATURES_WITH_DATES'
,p_message_text=>'With dates (%0/%1)'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254149506154089255)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_text=>'Feature Configuration'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183999820904623129)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_text=>'Contributor'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234852831418097601)
,p_name=>'FEATURE_COUNT'
,p_message_text=>'Feature Count'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(483990512251943978)
,p_name=>'FEATURE_DASH_01'
,p_message_text=>'%0 features, %1 fully completed, in %2 release(s)'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(483991303780055107)
,p_name=>'FEATURE_DASH_02'
,p_message_text=>'%0 top level features'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(483991707028065508)
,p_name=>'FEATURE_DASH_03'
,p_message_text=>'%0 have no due date, %1 are past due and < 80% complete'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(483992006467074756)
,p_name=>'FEATURE_DASH_04'
,p_message_text=>'%0 features are functionally complete, %1 are not'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485023122808836612)
,p_name=>'FEATURE_DASH_05'
,p_message_text=>'%0% of features are 100% completed'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183993919818594387)
,p_name=>'FEATURE_DESC'
,p_message_text=>'Feature Description'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183997427914606213)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_text=>'Desirability'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036768914043163496)
,p_name=>'FEATURE_LABEL'
,p_message_text=>'Feature: %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183991802849589534)
,p_name=>'FEATURE_NAME'
,p_message_text=>'Feature Name'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183992407005590747)
,p_name=>'FEATURE_OWNER'
,p_message_text=>'Feature Owner'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183996316140602799)
,p_name=>'FEATURE_PRIORITY'
,p_message_text=>'Priority'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183996719603603851)
,p_name=>'FEATURE_STATUS'
,p_message_text=>'Status'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183996010599601201)
,p_name=>'FEATURE_TAGS'
,p_message_text=>'Tags'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1397687342451860888)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_text=>'Unassigned'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1498532887395479413)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_text=>'logged %0 and assigned to %1'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191517304074834773)
,p_name=>'FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203490604863944127)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_text=>'Please supply this information to be logged as feedback.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(273112208343519070)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_text=>'Feedback Dashboard'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184179103605169719)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_text=>'Feedback Entries'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17736721130486692)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_text=>'%2 Feedback Entries Open (%0 Closed)'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203483808364897872)
,p_name=>'FEEDBACK_HELP'
,p_message_text=>'Enter your feedback and press the submit feedback button.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(496402817419709480)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_text=>'Feedback percent closed (%0/%1):'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(196350621297426902)
,p_name=>'FEEDBACK_TYPE'
,p_message_text=>'Feedback Type'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203490319839929578)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_text=>'Please identify the type of feedback you are providing.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(367347618256485030)
,p_name=>'FILENAME'
,p_message_text=>'Filename'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184526415977469382)
,p_name=>'FILENAME_COLUMN'
,p_message_text=>'Filename Column'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(396342026929807355)
,p_name=>'FILENAME_LABEL'
,p_message_text=>'File Name: %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184184631581272338)
,p_name=>'FILES'
,p_message_text=>'Files'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(713111144147176087)
,p_name=>'FILES_WITH_COUNT'
,p_message_text=>'%0 files'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184182407162227502)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_text=>'%0 Files, consuming %1K'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036652000312093327)
,p_name=>'FILE_LABEL'
,p_message_text=>'File: %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9947229840693675)
,p_name=>'FILE_TOO_BIG'
,p_message_text=>'This text file is too large to edit. To change the content, you must edit the file on your local machine and upload it again.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21798905684183104)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_text=>'No valid session exists and one or more files were uploaded.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21798521829178273)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_text=>'More files were uploaded in this request than the number of file item types defined on the page.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(232261032177001109)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_text=>'Find My Workspace'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12272820961749624)
,p_name=>'FIND_TABLES'
,p_message_text=>'Find Tables'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1996935978571961857)
,p_name=>'FINISH'
,p_message_text=>'Finish'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145292201310061618)
,p_name=>'FIRST_ENTRY'
,p_message_text=>'First Entry'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236578201387627808)
,p_name=>'FIXBY_PAST_DUE'
,p_message_text=>'Fix by date past due'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172716600667273722)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_text=>'Fixed in development'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183992911507592070)
,p_name=>'FOCUS_AREA'
,p_message_text=>'Focus Area'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108524816844748937)
,p_name=>'FOOTER'
,p_message_text=>'Footer Text'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5373709776864896)
,p_name=>'FORM'
,p_message_text=>'Form'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1034598021160488225)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_text=>'Format Mask: %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236488210803182787)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_text=>'Form and List View'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236489817464210045)
,p_name=>'FORM_AND_REPORT'
,p_message_text=>'Report with Form'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137275415556534344)
,p_name=>'FORM_ON'
,p_message_text=>'Form in %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44321031109540358)
,p_name=>'FORM_ON_A_TABLE'
,p_message_text=>'Form on a Table'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204696925514770887)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_text=>'The form on a query has been created successfully.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204764429445240132)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_text=>'The form and report on a Web service reference has been created successfully.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(202521832506737634)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_text=>'The form has been created successfully.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204710515089866880)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_text=>'The summary page has been created successfully.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204671002711447234)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_text=>'The form on a table has been created successfully.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204738017313048171)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_text=>'The form on a Web service reference has been created successfully.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25709701357732201)
,p_name=>'FORWARD'
,p_message_text=>'Forward'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256977111726608594)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_text=>'from Attribute Dictionary'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88048600163580167)
,p_name=>'FUNCTION'
,p_message_text=>'function'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178053005824935732)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_text=>'Functionally complete'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171874408801960728)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_text=>'Functional Implementation'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109286116578316206)
,p_name=>'FUNCTION_BODY'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88138201088772751)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_text=>'PL/SQL function body returning SQL query'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(202011106817617558)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_text=>'PL/SQL function body returning Ref Cursor'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194246309705806257)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_text=>'PL/SQL Function body returning boolean'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25596327398451371)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_text=>'PL/SQL Function Returning Boolean'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191640729315289585)
,p_name=>'FUTURE_MILESTONES'
,p_message_text=>'Future milestones'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5677977796947494)
,p_name=>'GALLERY.APP_DETAILS'
,p_message_text=>'Application Details'
,p_is_js_message=>true
,p_version_scn=>136415949
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5022096193542214)
,p_name=>'GALLERY.APP_UPDATE_AVAILABLE'
,p_message_text=>'Update available'
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10620139532018105)
,p_name=>'GALLERY.EDIT_APP'
,p_message_text=>'Edit'
,p_is_js_message=>true
,p_version_scn=>136415949
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2002569725276855)
,p_name=>'GALLERY.FILE_DOWNLOAD_ERROR'
,p_message_text=>'Failed downloading required file.'
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5677787546940598)
,p_name=>'GALLERY.INSTALLING_APP'
,p_message_text=>'Installing'
,p_is_js_message=>true
,p_version_scn=>143817998
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001212179207685)
,p_name=>'GALLERY.INSTALL_APP'
,p_message_text=>'Install'
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2002159192271895)
,p_name=>'GALLERY.INSTALL_APP_ERROR'
,p_message_text=>'Error during installation of %0 app.'
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1506365517447463)
,p_name=>'GALLERY.MISSING_VALUES_ERROR'
,p_message_text=>'Missing required information to further process installation.'
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001959182269296)
,p_name=>'GALLERY.MORE_INFO'
,p_message_text=>'More Info'
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2227801476686371)
,p_name=>'GALLERY.OPEN_NEW_WINDOW'
,p_message_text=>'Opens in new window'
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001784944267730)
,p_name=>'GALLERY.REMOVE_APP'
,p_message_text=>'Remove'
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2002759561278982)
,p_name=>'GALLERY.REMOVE_APP_CONFIRM'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Are you sure you want to remove <strong>%0 (%1)</strong>?</p>',
'<p>This will uninstall the application and remove its supporting database objects.</p>'))
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2506634426694850)
,p_name=>'GALLERY.RUN_APP'
,p_message_text=>'Run'
,p_is_js_message=>true
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5677545397937037)
,p_name=>'GALLERY.UPDATE_APP'
,p_message_text=>'Update'
,p_is_js_message=>true
,p_version_scn=>136415949
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5677323502935436)
,p_name=>'GALLERY.UPDATE_APP_CONFIRM'
,p_message_text=>'<p>Are you sure you want to update <strong>%0 (%1)</strong>?</p> <p>This will uninstall the application and remove its supporting database objects before it''s installed again.</p>'
,p_is_js_message=>true
,p_version_scn=>136415949
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10637332038068644)
,p_name=>'GALLERY.UPDATING_APP'
,p_message_text=>'Updating'
,p_is_js_message=>true
,p_version_scn=>143818090
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677442406557096297)
,p_name=>'GANTT_BASELINEDATE'
,p_message_text=>'Baseline Date'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677442220803094736)
,p_name=>'GANTT_BASELINEEND'
,p_message_text=>'Baseline End'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677442031727093092)
,p_name=>'GANTT_BASELINESTART'
,p_message_text=>'Baseline Start'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194105111354775484)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_text=>'End Date'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194103009837765603)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_text=>'Start Date'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(439398906545969347)
,p_name=>'GANTT_CHART.TASK'
,p_message_text=>'Task'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677441487888089338)
,p_name=>'GANTT_DATE'
,p_message_text=>'Date'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677441275596086495)
,p_name=>'GANTT_END'
,p_message_text=>'End'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677441625319090139)
,p_name=>'GANTT_LABEL'
,p_message_text=>'Label'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677441824522091096)
,p_name=>'GANTT_PROGRESS'
,p_message_text=>'Progress'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677440741570084354)
,p_name=>'GANTT_ROW'
,p_message_text=>'Row'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677440941235085379)
,p_name=>'GANTT_START'
,p_message_text=>'Start'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(556062580523572273)
,p_name=>'GATHER_TABLE_STATS'
,p_message_text=>'Gather Table Statistics'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172901823792775202)
,p_name=>'GENERAL_COMMENT'
,p_message_text=>'General Comment'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(496734709818208693)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_text=>'General Comments: %1 of %0 closed'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26824806027207686)
,p_name=>'GENERATED_TABLE'
,p_message_text=>'This table was created using the table wizard.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(70815513451842900)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_text=>'Changes saved.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177245309457396800)
,p_name=>'GET_STATIC_LOV'
,p_message_text=>'Create or edit static List of Values'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184000930254625811)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_text=>'Globalization Assignee'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183994324667595831)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_text=>'Globalization Impact'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184004307314638146)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_text=>'Globalization Status'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5825203972474852)
,p_name=>'GLOBAL_PAGE'
,p_message_text=>'Global Page'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(211007614705724106)
,p_name=>'GRAY_TEXT'
,p_message_text=>'Gray Text'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(187805525089702071)
,p_name=>'GRID_DEBUG_OFF'
,p_message_text=>'Hide Layout Columns'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(187804521972701110)
,p_name=>'GRID_DEBUG_ON'
,p_message_text=>'Show Layout Columns'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40285632067856520)
,p_name=>'GRID_TEMPLATE'
,p_message_text=>'Grid Template'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(163584817412391536)
,p_name=>'GROUPS'
,p_message_text=>'Groups'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(333692300401908936)
,p_name=>'GROUP_LABEL'
,p_message_text=>'Group: %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108524009787737497)
,p_name=>'HEADER'
,p_message_text=>'Header Text'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(273998376966098798)
,p_name=>'HEADING_DEBUG_OFF'
,p_message_text=>'Show Headings'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(273998105058097934)
,p_name=>'HEADING_DEBUG_ON'
,p_message_text=>'Hide Headings'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(333300231260870499)
,p_name=>'HEADING_LABEL'
,p_message_text=>'Heading: %0'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(955848469602909019)
,p_name=>'HELP_TEMPLATE'
,p_message_text=>'Help Template'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88140020874806833)
,p_name=>'HELP_TEXT'
,p_message_text=>'help text'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114861606711916090)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_text=>'Hidden and Protected'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173505325783539251)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_text=>'Highly desirable'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(712641721359637072)
,p_name=>'HIGH_CONTRAST'
,p_message_text=>'High Contrast'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(533547531238289090)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_text=>'High Contrast Toggle'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(163583810139389489)
,p_name=>'HISTORY'
,p_message_text=>'History'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201797807031666802)
,p_name=>'HOME_LINK'
,p_message_text=>'Home Link'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4685131422496765)
,p_name=>'HOME_NAV'
,p_message_text=>'Oracle APEX Home'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22961825480170112)
,p_name=>'HOME_PAGE_USERS'
,p_message_text=>'Users:'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101039603448269690)
,p_name=>'HORIZONTAL'
,p_message_text=>'horizontal'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815014715326252)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_text=>'Horizontal 2D Column'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815100562326252)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_text=>'Horizontal 3D Column'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815232025326252)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_text=>'Horizontal Range 2D Column'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815317988326252)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_text=>'Horizontal Range 3D Column'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(946331723042693021)
,p_name=>'HOT_TEMPLATE'
,p_message_text=>'Hot Template'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20387325317948551)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_text=>'HR account unlocked.'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88170724842044532)
,p_name=>'HTML'
,p_message_text=>'HTML'
,p_version_scn=>37165770887510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93580118576507001)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_text=>'HTML with Shortcuts'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92482917543552046)
,p_name=>'HTML_BODY'
,p_message_text=>'HTML Body'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26503403314893043)
,p_name=>'HTML_BUTTON'
,p_message_text=>'HTML Button'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32272117814837371)
,p_name=>'HTML_CHART'
,p_message_text=>'HTML Chart'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108528620878816332)
,p_name=>'HTML_HEADER'
,p_message_text=>'HTML Header'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32273732144850984)
,p_name=>'HTML_SLASH_TEXT'
,p_message_text=>'HTML/Text'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88138621997788233)
,p_name=>'HTML_TEXT'
,p_message_text=>'HTML Text'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32281719031875559)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_text=>'HTML Text with shortcuts'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8402580457836209)
,p_name=>'ICON.EDITOR.CHANGE.ICON'
,p_message_text=>'Edit App Icon'
,p_is_js_message=>true
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(955812439808160524)
,p_name=>'ICON_CSS_CLASSES'
,p_message_text=>'Icon CSS Classes'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631587323575452741)
,p_name=>'IE6_COMPATIBLE'
,p_message_text=>'Indicates theme is IE 6 compatible'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242848040662032447)
,p_name=>'IG_ALLOW_EDITING'
,p_message_text=>'Allow Editing'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242849375082044723)
,p_name=>'IG_READ_ONLY'
,p_message_text=>'Read Only'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88171504111066905)
,p_name=>'IMAGE'
,p_message_text=>'image'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455022723065970877)
,p_name=>'IMAGES'
,p_message_text=>'Images'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86863605081757188)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_text=>'Image Attributes'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201791628427417589)
,p_name=>'IMAGE_PREFIX'
,p_message_text=>'Image Prefix'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171265523549112036)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_text=>'Import from application'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1289208578817461225)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_text=>'New Value for Substitution String %0'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379115324171942682)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_text=>'Your imported file is located in the <a href="%0">Export Repository</a>.  Unless you plan to install it again, you should remove it.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145339904866119459)
,p_name=>'IN/OUT'
,p_message_text=>'In/Out'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8804725089048621)
,p_name=>'INACTIVE'
,p_message_text=>'Inactive'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(272958517362957576)
,p_name=>'INCLUDE'
,p_message_text=>'Include'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036299821363843933)
,p_name=>'INCLUDE_LABEL'
,p_message_text=>'Include: %0'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88049007435582316)
,p_name=>'INDEX'
,p_message_text=>'index'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270308402287577214)
,p_name=>'INDEX_NOUN'
,p_message_text=>'Index'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(65392128733576156)
,p_name=>'INITCAP_REFRESH'
,p_message_text=>'Refresh'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123651810855835370)
,p_name=>'INLINE'
,p_message_text=>'Inline'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(659796271089373997)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_text=>'Inline Help Template'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123651306700834167)
,p_name=>'INLINE_NOTIFICATION'
,p_message_text=>'Inline and in Notification'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194225331710576145)
,p_name=>'INPUT_TYPE'
,p_message_text=>'Input Type'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88055813678659792)
,p_name=>'INSERT'
,p_message_text=>'insert'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290113018532571365)
,p_name=>'INSERT_EXCEPTION'
,p_message_text=>'insert into wwv_flow_companies exception:'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(213906322982468604)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_text=>'CSS (Application)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(213905506706463998)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_text=>'Image (Application)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(213907407529473623)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_text=>'Static File (Application)'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19138931693035629)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_text=>'Build Options'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39814211838750490)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_text=>'You can choose to include the following build options.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19138426498034185)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_text=>'Application Substitutions'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39809119326743151)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_text=>'You can configure the following attributes of your application.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19140908621038448)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_text=>'Install Confirmation'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39817825129763771)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_text=>'Please confirm that you would like to install this application''s supporting objects.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19145418103050626)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_text=>'Deinstall Confirmation'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9745431570194925)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_text=>'Deinstall Script'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19146124336052424)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_text=>'Deinstall Success'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39821608422777847)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_text=>'Deinstallation complete.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139327225008143048)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Error when performing install check "%0":',
'<pre>%1</pre>'))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139327418310161349)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Error when running install script "%0":',
'<pre>%1</pre>'))
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19137918533031875)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_text=>'Existence Check Failure'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19142219703041632)
,p_name=>'INSTALLER.FAILURE'
,p_message_text=>'Post Install Failure'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39820328723774297)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_text=>'Installation of database objects and seed data has failed.'
,p_version_scn=>37165770887511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164982584877642830)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_text=>'The application installer has detected that this application''s supporting objects were previously installed. The objects must be removed via SQL Workshop before this application can be installed.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19144411869048877)
,p_name=>'INSTALLER.LICENSE'
,p_message_text=>'License'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16173009195286580)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_text=>'Errors'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16172528111282569)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_text=>'Success'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19141413816039978)
,p_name=>'INSTALLER.SUCCESS'
,p_message_text=>'Post Install Success'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39818911062769191)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_text=>'Your application''s supporting objects have been installed.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2701299834575501)
,p_name=>'INSTALLER.SUPPORTING_OBJECTS.CHECK_EXISTING_OBJECTS'
,p_message_text=>'Object Exists: %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2701039904569454)
,p_name=>'INSTALLER.SUPPORTING_OBJECTS.CHECK_FREE_SPACE'
,p_message_text=>'Need Space in KB: %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2700802713565902)
,p_name=>'INSTALLER.SUPPORTING_OBJECTS.CHECK_MISSING_PREVS'
,p_message_text=>'Required Privileges: %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58033415386456711)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_text=>'Please confirm that you would like to upgrade this application''s supporting objects.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58031908460454743)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_text=>'The upgrade of this application''s supporting objects has failed.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(57756131411818027)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_text=>'The application installer has detected that this application''s supporting objects were previously installed.  This wizard will guide you through the process of upgrading these supporting objects.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58028724952450028)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_text=>'Your application''s supporting objects have been upgraded.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19139703081036834)
,p_name=>'INSTALLER.VALIDATION'
,p_message_text=>'Validation'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39814818765752412)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_text=>'The following validations will be performed to ensure your system is compatible with this application.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19137111953029949)
,p_name=>'INSTALLER.WELCOME'
,p_message_text=>'Welcome'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39804020234733947)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_text=>'This application installer will guide you through the process of creating your database objects and seed data.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(213905915017466398)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_text=>'CSS (Workspace)'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(213905100819462222)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_text=>'Image (Workspace)'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(213907031293471061)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_text=>'Static File (Workspace)'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14645020439742339)
,p_name=>'INSTALL_APPLICATION'
,p_message_text=>'Install App'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(214702416715662274)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_text=>'Install a sample application'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(517409447259276152)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_text=>'Oracle APEX Administration Services Home'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255460408553239761)
,p_name=>'INSTANCE_SETTINGS'
,p_message_text=>'Instance Settings'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183821928571603570)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_text=>'This instance is running in manual provisioning mode, so it will not be accepting service requests'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(246648812638251524)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_text=>'Insufficient space to install this application.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171878525208975010)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_text=>'Integration Complete'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174645923232682502)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_text=>'Integration Signoff'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170065679108527458)
,p_name=>'INTERACTIVE_GRID'
,p_message_text=>'Interactive Grid'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(95864124883978910)
,p_name=>'INTERACTIVE_REPORT'
,p_message_text=>'Interactive Report'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184176800227149784)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_text=>'Interactive Report Searches'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22442313245886060)
,p_name=>'INTERNAL'
,p_message_text=>'Internal'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5715510833487472)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_text=>'Internal Administration'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23062808231712501)
,p_name=>'INTERNAL_USERS'
,p_message_text=>'Internal'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136664131199788587)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_text=>'A valid name must be entered.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8772602535631584)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_text=>'The file is not a valid application archive.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137285508026717430)
,p_name=>'INVALID_GROUP_NAME'
,p_message_text=>'A valid group name must be entered.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26135121181016158)
,p_name=>'INVALID_OBJECT'
,p_message_text=>'Object %0 is Invalid.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(403448122464343933)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_text=>'A valid page group name must be entered.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290108829221546003)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_text=>'Invalid schema name'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2120755743098673126)
,p_name=>'INVALID_SLOT'
,p_message_text=>'Invalid Slot [Not Rendered]'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(193083218652976750)
,p_name=>'INVALID_SORT_ORDER'
,p_message_text=>'Invalid entry value must be a number.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(907030966733988139)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_text=>'Note that %0 string(s) were invalid usernames.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290107907058539650)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_text=>'invalid workspace name'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815413665326252)
,p_name=>'INVERSE2DLINE'
,p_message_text=>'Inverse 2D Line'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172716428933272416)
,p_name=>'IN_PROGRESS'
,p_message_text=>'In progress'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(68338458135241961)
,p_name=>'IR_COLUMNS'
,p_message_text=>'Interactive Report Columns'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147454217861346394)
,p_name=>'IR_DEVELOPER'
,p_message_text=>'Developer'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147453111628344599)
,p_name=>'IR_END_USER'
,p_message_text=>'End User'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147582707378986659)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_text=>'Interactive Report'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138819931519026565)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_text=>'One interactive report can be displayed on a page.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147465003148379988)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_text=>'This dialog is only displayed for developers.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147450022232338199)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_text=>'Save Report *'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147511132359672212)
,p_name=>'IR_SAVE_STAR'
,p_message_text=>'Save *'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1035130632230156262)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_text=>'Application: %0, Page: %1, Subscribed By: %2'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206229326366541623)
,p_name=>'IR_SUCCESS_MSG'
,p_message_text=>'The Interactive Report page has been created successfully.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147593730243069007)
,p_name=>'IR_UNITS'
,p_message_text=>'Units'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563161898318625279)
,p_name=>'ISSUES'
,p_message_text=>'Issues'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145360212925178500)
,p_name=>'IS_WRAPPED'
,p_message_text=>'is wrapped'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190200501037938215)
,p_name=>'ITEM CONDITION'
,p_message_text=>'Item Condition'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32495619869837009)
,p_name=>'ITEM NAME'
,p_message_text=>'Item Name'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22436711223597111)
,p_name=>'ITEM.BUTTONS'
,p_message_text=>'Item Buttons'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1570642694832186213)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_text=>'Current Item Column Span'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25597522680459407)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_text=>'Value of item in Expression 1 Equals Expression 2'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25598030645461738)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_text=>'Value of item in Expression 1 Does NOT Equal Expression 2'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25595917701448578)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_text=>'Item in Expression 1 is NOT NULL'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25595504888444851)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_text=>'Item in Expression 1 is NULL'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1034093705802849827)
,p_name=>'ITEM_LABEL'
,p_message_text=>'Item: %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47018929658539168)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_text=>'Date Picker'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47019704639550869)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_text=>'Hidden'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178466200151552045)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_text=>'Text Field with autocomplete'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(457042806909521760)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_text=>'Checkbox'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(615611829302459362)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_text=>'Color Picker'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1463288551467991)
,p_name=>'ITEM_NAME.NATIVE_COMBOBOX'
,p_message_text=>'Combobox'
,p_version_scn=>37165772372518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262393826595906174)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_text=>'Date Picker'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5803650985687850)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_APEX'
,p_message_text=>'Date Picker'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(441527621988959612)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_text=>'Date Picker (Classic)'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3266708803970728)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_text=>'Date Picker (HTML5)'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(483845904767501013)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_text=>'Display Image'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(445419014331086747)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_text=>'Display Only'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(480913413263646328)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_text=>'File Browse...'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(615611207139453011)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_text=>'Hidden'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(486688113475969701)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_text=>'List Manager'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494671947276545164)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_text=>'Markdown Editor'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(429343027345558379)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_text=>'Number Field'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(435144421948227586)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_text=>'Password'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(444339515286528545)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_text=>'Popup LOV'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1963659291350524)
,p_name=>'ITEM_NAME.NATIVE_QR_CODE'
,p_message_text=>'QR Code'
,p_version_scn=>119288763
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(457042503445520810)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_text=>'Radio Group'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(186408100362957020)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_text=>'Rich Text Editor'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(442271609320051007)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_text=>'Select List'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(451693926836698589)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_text=>'Shuttle'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10719525082453906)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_text=>'Slider'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47022710096571409)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_text=>'Stop and Start Grid Layout (Deprecated)'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(189610316585158458)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_text=>'Textarea'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(615611411987454383)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_text=>'Text Field'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10593511381210388)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_text=>'Yes/No'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29297525253797225)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_text=>'Plug-in'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47031906427655458)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_text=>'Popup List of Values'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(460404603553325944)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_text=>'Star Rating'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47044303787664128)
,p_name=>'ITEM_NAME.TEXT'
,p_message_text=>'Text'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(699369653293490656)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_text=>'Item Post Text Template'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(699369475931489543)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_text=>'Item Pre Text Template'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218110180478406210)
,p_name=>'ITEM_ROW_2'
,p_message_text=>'Row 2'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218110346951407531)
,p_name=>'ITEM_ROW_3'
,p_message_text=>'Row 3'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218110579436408259)
,p_name=>'ITEM_ROW_4'
,p_message_text=>'Row 4'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218110727843408979)
,p_name=>'ITEM_ROW_5'
,p_message_text=>'Row 5'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(429322711724251125)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_text=>'Entered Maximum Value %0 for item %1 is not numeric. If the value contains decimal places, please specify a period as the decimal separator.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(429322417481243369)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_text=>'Entered Minimum Value %0 for item %1 is not numeric. If the value contains decimal places, please specify a period as the decimal separator.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10712215676347066)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_text=>'Entered Step Value %0 for item %1 is not numeric. If the value contains decimal places, please specify a period as the decimal separator.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29517030204402712)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_text=>'Button'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29527328007405703)
,p_name=>'ITEM_TYPE.FILE'
,p_message_text=>'File Browse...'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29528009729405901)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_text=>'Hidden'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29528226038405967)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_text=>'Hidden and Protected'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29530514202406637)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_text=>'Popup Color Picker'
,p_is_js_message=>true
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29534518087407769)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_text=>'Text Field'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29534704348407836)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_text=>'Text Field (Disabled, does not save state)'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29535017571407902)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_text=>'Text Field (Disabled, saves state)'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29535225276407968)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_text=>'Text Field (always submits page when Enter pressed)'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170063642545504459)
,p_name=>'JET_CHART'
,p_message_text=>'JET Chart'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145184932187824523)
,p_name=>'JOB'
,p_message_text=>'Job'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170630603896911049)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_text=>'Column Toggle'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170629223468902643)
,p_name=>'JQM REFLOW'
,p_message_text=>'Reflow Report'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(219466618203400862)
,p_name=>'JQM_FOOTER'
,p_message_text=>'Footer'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(219466419497400281)
,p_name=>'JQM_HEADER'
,p_message_text=>'Header'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171344442301955759)
,p_name=>'JQM_LIST_VIEW'
,p_message_text=>'List View'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170066845631543229)
,p_name=>'JSTREE'
,p_message_text=>'Javascript Tree'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184000624713624219)
,p_name=>'JUSTIFICATION'
,p_message_text=>'Justification'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563162051335625813)
,p_name=>'LABELS'
,p_message_text=>'Labels'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1570642261024165006)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_text=>'Current Label Column Span'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1425457543373107675)
,p_name=>'LABEL_ID'
,p_message_text=>'Current Item Label ID'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200665409343440405)
,p_name=>'LABEL_TEMPLATE'
,p_message_text=>'Label Template'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84970116644319357)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_text=>'Copied from Application'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84970810195326889)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_text=>'This is the "master" copy of this template.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84971614828337676)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_text=>'No templates subscribe to this template.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84971225086331220)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_text=>'Applications subscribing to this Label Template'
,p_version_scn=>34185859
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(273997655157095839)
,p_name=>'LANDMARK_DEBUG_OFF'
,p_message_text=>'Show Landmarks'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(273997985067096860)
,p_name=>'LANDMARK_DEBUG_ON'
,p_message_text=>'Hide Landmarks'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14672425549762804)
,p_name=>'LANGUAGES'
,p_message_text=>'Languages'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184173508744067080)
,p_name=>'LAST_CHANGE'
,p_message_text=>'Last Change'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145293830746070076)
,p_name=>'LAST_ENTRY'
,p_message_text=>'Last Entry'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184184903577292648)
,p_name=>'LAST_LOGIN'
,p_message_text=>'Last login'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6165132766856070)
,p_name=>'LAYOUT'
,p_message_text=>'%0 - Layout'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20278126461591468)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_text=>'After Body'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137506712817520861)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_text=>'After error page header'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137498405760509277)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_text=>'After Footer'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165394409780140493)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_text=>'After Header'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485600899431113706)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_text=>'After Item'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(390658715673684077)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_text=>'After Label'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(390659505752688687)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_text=>'After Label and Item'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48421508218941440)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_text=>'After Authentication'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135387012705312642)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_text=>'After Processing'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137495519481503785)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_text=>'After Regions'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137500220305513479)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_text=>'After Submit'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20277501181584167)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_text=>'Before Body'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135382624564297148)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_text=>'Before Computation'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137508021821523466)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_text=>'Before error page footer'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137497601604508127)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_text=>'Before Footer'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135381713828294047)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_text=>'Before Header'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485600625705112676)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_text=>'Before Item'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(390658517829683117)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_text=>'Before Label'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(390659307909687713)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_text=>'Before Label and Item'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135385601969309481)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_text=>'Before Processing'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137492528700496989)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_text=>'Before Regions'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135383904955300894)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_text=>'Before Validation'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156989924682940804)
,p_name=>'LAYOUT.BRANCHES'
,p_message_text=>'branches'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44704526565339448)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_text=>'Above Box'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44704702905339448)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_text=>'Below Box'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44705029784339449)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_text=>'Bottom'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44705313948339450)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_text=>'Template Change'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44705631841339450)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_text=>'Template Close'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44705918949339451)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_text=>'Template Copy'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44706203815339451)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_text=>'Template Create'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44706514748339452)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_text=>'Template Delete'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44706832225339453)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_text=>'Template Edit'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44707100026339454)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_text=>'Template Expand'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44707405818339455)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_text=>'Template Next'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44707723003339455)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_text=>'Template Previous'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44708019235339456)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_text=>'Top'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123166401413657736)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_text=>'Change Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153868096349260935)
,p_name=>'LAYOUT.CHART'
,p_message_text=>'Chart'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261701130595153544)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_text=>'Series'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123161908508621916)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_text=>'Close Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123164928856646711)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_text=>'Copy Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123163218682634368)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_text=>'Create2 Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3400115673116959)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_text=>'Custom Position'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261699509817147542)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_text=>'False'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261700013280148558)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_text=>'True'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123164416735643223)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_text=>'Delete Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488113600558460959)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_text=>'Empty Label - #0'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(955846442737846335)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_text=>'Error Template'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123162705176630470)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_text=>'Expand Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114732005028575420)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_text=>'Function Returning SQL Query'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261701605100155577)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_text=>'Global Page: '
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123163703229639326)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_text=>'Help Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485601262118116815)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_text=>'Item Help Link'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488113815795465332)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_text=>'Hidden - #0'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114721917561408736)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_text=>'HTML Text Escape Special Characters'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(659795507897368595)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_text=>'Inline Help Text'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(699370146625493940)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_text=>'Item Post Text'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(699369943582492941)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_text=>'Item Pre Text'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123165409247650508)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_text=>'Next Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156984204681916143)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_text=>'No region at slot'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261702814234167722)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_text=>'Page Items and Buttons with no Region'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180092822165624858)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_text=>'Ajax Callbacks'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(390659111360686140)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_text=>'On Error After Label'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(390658913732685045)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_text=>'On Error Before Label'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135421726136411073)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_text=>'On New Instance'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135423414839417296)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_text=>'On Submit and Before Computation'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123165921368654064)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_text=>'Previous Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261705711033185694)
,p_name=>'LAYOUT.PROCESSING'
,p_message_text=>'Processing'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3695090403150)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_text=>'Body'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261708629191351774)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_text=>'Body (#0)'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261708901617353252)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_text=>'Position #0'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261700721937151033)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_text=>'Report Columns'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262591525610410118)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_text=>'Run %0'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114732415417578443)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_text=>'Simple Chart'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114735908538604839)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_text=>'Structured Query'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262590504832404117)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_text=>'Submit as "%0"'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171215708394053134)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_text=>'Sub Region'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114734706675594897)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_text=>'SVG Chart'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38964511711611749)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_text=>'Cascading Style Sheet files used by &PRODUCT_NAME.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38965311280630523)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_text=>'JavaScript files and code used by &PRODUCT_NAME.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1015126450060294491)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_text=>'Cascading Style Sheet files defined on user interface level'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38965708641639233)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_text=>'JavaScript files defined on user interface level'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226664318547749795)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_text=>'Dialog Attributes, to define dialog attributes not declaratively supported'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(673021802301543126)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_text=>'Dialog CSS Classes'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226663422884717389)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_text=>'Dialog Height'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226663816199720497)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_text=>'Dialog Maximum Width'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226663619650718931)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_text=>'Dialog Width'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1558825573842977332)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_text=>'Label for Expand / Collapse Navigation'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1558825750616983129)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_text=>'Label for Expand / Collapse Side Column'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(925478599144594293)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_text=>'Favicons HTML Code'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38965129157626300)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_text=>'Cascading Style Sheets created by components on the fly'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38965924917643913)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_text=>'JavaScript code created by components on the fly'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226664129773729374)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_text=>'Dialog Page Mode (for example ''true'' when modal, ''false'' when non-modal)'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38964915305622255)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_text=>'Cascading Style Sheet files and inline style defined on page level'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(33633960830189546)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_text=>'Page CSS Classes'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(424470927339805137)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_text=>'JavaScript files and code defined on page level'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5542515709630424)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_text=>'Page Static ID (for example ''P100'')'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4516613300957258)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_text=>'Transition used to navigate to a new page.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226663226551715702)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_text=>'Page URL'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4516808340959565)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_text=>'Transition used to open a popup.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(231627200841384180)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_text=>'Page URL which was requested by the browser'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1018626716583780788)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_text=>'Navigation Menu (Side)'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38964701106618116)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_text=>'Cascading Style Sheet files and inline style defined in the template'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38965531366636389)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_text=>'JavaScript files and code defined in the template'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39003524542467063)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_text=>'Cascading Style Sheet files defined on theme level'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1284879406424248175)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_text=>'JavaScript files defined on theme level'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1284931463957345739)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_text=>'Cascading Style Sheet files defined on theme style level'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1018626537303776577)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_text=>'Navigation Menu (Top)'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226664509704753919)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_text=>'Triggering Element (for example, the current DOM element)'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60952132655774337)
,p_name=>'LAYOUT.T_ACTION'
,p_message_text=>'action'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(424538414009239269)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_text=>'Affected Elements'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60690611735452334)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_text=>'Application Tabs'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60342825318961257)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_text=>'down'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60682621170436122)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_text=>'Body Title'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60048007021292033)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_text=>'create branch'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60343602939964259)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_text=>'create button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60545200327900229)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_text=>'Change'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60535611362874995)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_text=>'Close'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60693522817455506)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_text=>'Workspace Images'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60045216587285333)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_text=>'create computation'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60542502274891307)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_text=>'Copy'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60534024390869310)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_text=>'Create'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60535003397872748)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_text=>'Create'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60541526384888796)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_text=>'Delete'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60531407768864533)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_text=>'Edit'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60532916772867071)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_text=>'Expand'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60539809761884027)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_text=>'Form Close'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60537930062880430)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_text=>'Form Open'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60677801300420896)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_text=>'Global Notification'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60540718073886389)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_text=>'Help'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60344311943966813)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_text=>'create item'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60676502554411798)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_text=>'Nav Bar'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60543710239893614)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_text=>'Next'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60677116752415943)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_text=>'Notification'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60688732729448927)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_text=>'Parent Tabs'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60544622706897233)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_text=>'Previous'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60044806890282476)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_text=>'create process'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60043724075277999)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_text=>'create region'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60536620019877560)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_text=>'Region Body'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60684806756441376)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_text=>'Region Position'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60529224606859949)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_text=>'Region Title'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60687423033446084)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_text=>'Tabs'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60680301431430444)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_text=>'Success Message'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60679621385426747)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_text=>'Template Body'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60680711127433265)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_text=>'Title'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60046926976288329)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_text=>'create validation'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60043115071275402)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_text=>'warning'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262644532423904016)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(946321228106506920)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_text=>'Breadcrumb Label (escaping HTML characters)'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487519901522138930)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_text=>'When Event'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60697705071469290)
,p_name=>'LAYOUT.T_BODY'
,p_message_text=>'Body'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16141313183385957)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_text=>'Branch'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59843023823284373)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_text=>'Branching'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262651029231997769)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_text=>'Branch Action'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44711332705574892)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_text=>'Branch To Function Returning Page'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44711619621574893)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_text=>'Branch To Function Returning URL'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44710519133574890)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_text=>'Branch To Page Accept'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44710721646574891)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_text=>'Branch To Page Identified By Item'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60954819411789444)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_text=>'Go To Page'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44711918994574893)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_text=>'Branch To PL/SQL Procedure'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44711011339574891)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_text=>'Branch To URL Identified By Item'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262644815931908729)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_text=>'Build Option'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59806705423900598)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_text=>'Buttons'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60954308329786255)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_text=>'Button'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262648532039951216)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_text=>'Button Action'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(460929425621223502)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_text=>'Execute Validations'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60458420853612838)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_text=>'Buttons with no regions'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262650126545978026)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_text=>'Chart Query'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262649830224969665)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_text=>'Column Heading'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(946229617468955776)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_text=>'Component CSS Classes'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59807523084905749)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_text=>'Computations'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61010529275104511)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_text=>'Computation'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59807915943913099)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_text=>'Page 0 does not support computations.  Computations which should occur on every page should be handled by application level computations.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262646524851930208)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_text=>'Computation Type'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60952812354777932)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_text=>'condition'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262643631422856467)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_text=>'Expression 1'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262643901770857386)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_text=>'Expression 2'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262643311682850768)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_text=>'Condition Type'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59776605817228943)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_text=>'Copy'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59775824255215297)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_text=>'Create'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(941324092927790557)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_text=>'Text derived from the <em>APEX.CURRENT_PROGRESS</em> internal text message (defaults to <em>Current Progress</em>).'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60706709966499159)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60953900018783866)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_text=>'Display'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262648802388952185)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_text=>'Display as'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(628273414799488753)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_text=>'Dynamic Actions'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59776217806222962)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_text=>'Edit'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16133328271229449)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_text=>'Edit page in Builder'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44597112583383186)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_text=>'Edit Region Attributes'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44702102090190437)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_text=>'Error Page'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60953424474781389)
,p_name=>'LAYOUT.T_EXP'
,p_message_text=>'exp'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60040615286266028)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_text=>'No Branches'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60038709960255034)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_text=>'No computations'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60033713508237094)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_text=>'No page selected.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60039722427258589)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_text=>'No processes'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60035418487248023)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_text=>'No regions'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60040203858262737)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_text=>'No validations'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60698216153472468)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_text=>'Footer Template'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60719727375560882)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_text=>'HTML Form Close'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60712610706527720)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_text=>'HTML Form Open'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60705517800491894)
,p_name=>'LAYOUT.T_FROM'
,p_message_text=>'From'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59839218451245003)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_text=>'Global page does not support branches, computations, processes, or validations.  Computations and processes which should occur on every page should be handled by application level computations and processes.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487656110404557772)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_text=>'Grid Column'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200168002770089997)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_text=>'Grid Column Span'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60697329182466796)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_text=>'Header Template'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4500469893368119)
,p_name=>'LAYOUT.T_IMAGE_TEMPLATE'
,p_message_text=>'Image Template'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44701315118184739)
,p_name=>'LAYOUT.T_INLINE'
,p_message_text=>'Inline'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44700802474143274)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_text=>'Inline+Notification'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59795129908425096)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_text=>'Invalid template'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59807114427903172)
,p_name=>'LAYOUT.T_ITEM'
,p_message_text=>'Items'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178955911065523313)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_text=>'Item'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60463128949624664)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_text=>'Item count exceeds maximum of 200.'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262649106675962893)
,p_name=>'LAYOUT.T_LABEL'
,p_message_text=>'Label'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2800537121274723)
,p_name=>'LAYOUT.T_LANDMARK_ATTRIBUTES'
,p_message_text=>'Region Landmark Attributes'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7736904103801199)
,p_name=>'LAYOUT.T_LISTS'
,p_message_text=>'Lists'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(858472120633218841)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_text=>'Unique List Id'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44703608632239612)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_text=>'Location'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77206713920604210)
,p_name=>'LAYOUT.T_LOV'
,p_message_text=>'Lists of Values'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7736108821793101)
,p_name=>'LAYOUT.T_MENUS'
,p_message_text=>'Breadcrumbs'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488112829470431494)
,p_name=>'LAYOUT.T_NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60957530801840050)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_text=>'Navigates to page'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59878608267507005)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_text=>'Navigation&nbsp;Bar'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174689624166382852)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_text=>'Navigation Menu'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44717208744797959)
,p_name=>'LAYOUT.T_NEVER'
,p_message_text=>'never'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200167414416084499)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_text=>'Start New Grid'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200167806868088018)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_text=>'Start New Grid Column'
,p_version_scn=>37165770887514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200167612043085683)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_text=>'Start New Grid Row'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60696616368463162)
,p_name=>'LAYOUT.T_NO'
,p_message_text=>'No'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44712824393632174)
,p_name=>'LAYOUT.T_NONE'
,p_message_text=>'none'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44701726200187932)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_text=>'Notification'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60714130792533516)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_text=>'Notification Message'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59843405254288560)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_text=>'Page "%0" has no branches.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60459504015617458)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_text=>'Page "%0" has no buttons.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60461318213621556)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_text=>'Page "%0" has no items.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7760503336895556)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_text=>'No lists used.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77220009118981333)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_text=>'No shared lists of values used.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7761507491896772)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_text=>'No Breadcrumbs used.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59879123851511553)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_text=>'Application "%0" has no navBar.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59808811918921420)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_text=>'Page "%0" has no onLoad computations.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59809813781931382)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_text=>'Page "%0" has no onLoad processes.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59839701613249626)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_text=>'Page "%0" has no onSubmit computations.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59842532003277285)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_text=>'Page "%0" has no onSubmit processes.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59774515813203410)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_text=>'No page selected.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59873130384485037)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_text=>'No parent level tabs'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59806031555794600)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_text=>'Page "%0" has no regions.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59878128914503551)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_text=>'Page %0 has no tab set.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77223101247035776)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_text=>'No templates used.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59842028409266857)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_text=>'Page "%0" has no validations.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44604918897836127)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_text=>'%0 Items'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59775309710211150)
,p_name=>'LAYOUT.T_PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59794305536408585)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_text=>'Alias'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59796719566450507)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_text=>'Authentication'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59795911816438802)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_text=>'Authorization'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60716019841539852)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_text=>'Page Body'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60717130576542910)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_text=>'Page Body Title'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59796308138447206)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_text=>'Build Option'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60710710228518161)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_text=>'Page Head'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59792512415382241)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59791316440373896)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_text=>'Page not found.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60707820009502013)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_text=>'Page Onload'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59797130301453638)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_text=>'Public'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59804130254775289)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_text=>'Required'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59795527615433881)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_text=>'Std. TabSet'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59794715363420872)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_text=>'Template'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59793124882385840)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_text=>'Title'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60709727413513600)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_text=>'Page Title'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59869419255453405)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_text=>'Parent Tabs'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59809301660927899)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_text=>'Processes'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61009617847101231)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_text=>'Process'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59808328410916757)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_text=>'Page 0 does not support processes.  Processes which should occur on every page should be handled by application level processes.'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262650421135985934)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_text=>'Process Type'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60955229107792245)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_text=>'Go To Page'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60704106372488603)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_text=>'Referenced'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(946230589530060914)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_text=>'Referenced From'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59804516879780938)
,p_name=>'LAYOUT.T_REGION'
,p_message_text=>'Regions'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61019220954376530)
,p_name=>'LAYOUT.T_REGION2'
,p_message_text=>'Region'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171364013436994094)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_text=>'Region Attributes'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3917113662091476)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_text=>'Region CSS Classes'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171328630228610976)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_text=>'Unique Region Id'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4600405789395168)
,p_name=>'LAYOUT.T_REGION_IMAGE'
,p_message_text=>'Region Image'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11101304315824589)
,p_name=>'LAYOUT.T_REGION_IMAGE_ALT_TEXT'
,p_message_text=>'Region Image ALT Text'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11101580545826021)
,p_name=>'LAYOUT.T_REGION_IMAGE_ATTRIBUTES'
,p_message_text=>'Region Image Attributes'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4600623645397346)
,p_name=>'LAYOUT.T_REGION_IMAGE_URL'
,p_message_text=>'Region Image URL'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(197267919141755001)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_text=>'Region Position'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60722230969571454)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_text=>'Region Position1'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167377170603710008)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_text=>'Region Position 10'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167377307656710621)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_text=>'Region Position 11'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167378141187712992)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_text=>'Region Position 12'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167378509564714010)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_text=>'Region Position 13'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167379103988714632)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_text=>'Region Position 14'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167379309554715210)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_text=>'Region Position 15'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167379525350715876)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_text=>'Region Position 16'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60724917725586474)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_text=>'Region Position2'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60725427422589335)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_text=>'Region Position3'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60726103658591884)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_text=>'Region Position4'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60726513701594853)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_text=>'Region Position5'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60726926168598420)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_text=>'Region Position6'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60727404482601659)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_text=>'Region Position7'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60727913832604345)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_text=>'Region Position8'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167376923596709339)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_text=>'Region Position 9'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171330019062626693)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_text=>'Region Static Id'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487637709908396776)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_text=>'Region Type'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44715121501697537)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_text=>'standard condition'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59876101210495492)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_text=>'Standard&nbsp;Tabs'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60699127581475776)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_text=>'Substitution'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171337719380749826)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_text=>'Sub Regions - Header Entry Template'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171337928384752413)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_text=>'Sub Regions - Header Template'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171336902280735348)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_text=>'Sub Regions - Template'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171335301016668773)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_text=>'Sub Regions'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171335506557670359)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_text=>'Sub Region Headers'
,p_version_scn=>37165770887515
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171334732483649523)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_text=>'Sub Region Header Entries'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171332730621639535)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_text=>'Static Id of Sub Region'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171333504086641304)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_text=>'Title of Sub Region'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715008759536647)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_text=>'Success Message'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7714703276382370)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_text=>'Tabular Form'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59876712638498845)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_text=>'Tab Set'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60545913833904117)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_text=>'Template'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77188403194326734)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_text=>'Templates'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60054005206310407)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_text=>'create branch'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60345802031973448)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_text=>'create button'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60049801265299778)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_text=>'create computation'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60347821771979161)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_text=>'create item'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60051513732303448)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_text=>'create process'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60049119142295555)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_text=>'create region'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60052628623307730)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_text=>'create validation'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60346913460976743)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_text=>'edit button'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60348600085982345)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_text=>'edit button item'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60350015668986795)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_text=>'edit item'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60345020947969391)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_text=>'region title'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262648003989943169)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_text=>'When Condition'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262647725675939898)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_text=>'When Element'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44714303231673362)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_text=>'Unconditional'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59841511440261941)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_text=>'Validations'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61008606073097793)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_text=>'Validation'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(460928731377215692)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_text=>'Always Execute'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262645416409918389)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_text=>'Validation Expression 1'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262645720218919437)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_text=>'Validation Expression 2'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262645104981915056)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_text=>'Validation Type'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59782830844292891)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_text=>'View'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262643022287844375)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_text=>'When Button Pressed'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60695100785458587)
,p_name=>'LAYOUT.T_YES'
,p_message_text=>'Yes'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114732925460581385)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_text=>'Updatable SQL Query'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(111428205470898805)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_text=>'Application default'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261705405146184054)
,p_name=>'LAYOUT.VALIDATING'
,p_message_text=>'Validating'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109178318096275841)
,p_name=>'LAYOUT_NEVER'
,p_message_text=>'Never'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117341131050475075)
,p_name=>'LAYOUT_RUN'
,p_message_text=>'Run'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192777612265056237)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_text=>'LDAP Username Edit Function'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13169617011756491)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_text=>'LDAP'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20377901379316362)
,p_name=>'LEARN MORE'
,p_message_text=>'Learn More'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72197828481530785)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_text=>'Learn more about App Builder'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(81567675348360936)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_text=>'Learn more about Page Designer'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72198362599532592)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_text=>'Learn more about Productivity Apps'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72197656288529421)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_text=>'Learn more about SQL Workshop'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(251504500119529789)
,p_name=>'LEFT'
,p_message_text=>'Left'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1260377129614285145)
,p_name=>'LEGACY_CALENDAR'
,p_message_text=>'Legacy Calendar'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21688628097893180)
,p_name=>'LINES'
,p_message_text=>'Lines'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(497367620196253077)
,p_name=>'LINK'
,p_message_text=>'Link'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36719618013409814)
,p_name=>'LINK$'
,p_message_text=>'column link'
,p_version_scn=>37165770887516
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184178512478162794)
,p_name=>'LINKS'
,p_message_text=>'Links'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036609701436074658)
,p_name=>'LINK_LABEL'
,p_message_text=>'Link: %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270939722555565264)
,p_name=>'LINK_TO_THIS'
,p_message_text=>'Link to this %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147228815121172479)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_text=>'links to this page item %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88143601359867374)
,p_name=>'LIST'
,p_message_text=>'list'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192772118143982285)
,p_name=>'LIST ITEM CONDITION'
,p_message_text=>'List Item Condition'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191534928992357706)
,p_name=>'LIST OF VALUES'
,p_message_text=>'List of Values'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(30618417829831189)
,p_name=>'LISTVIEW'
,p_message_text=>'List'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236507128783341614)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_text=>'The Form and List View have been created successfully.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244157711811065056)
,p_name=>'LIST_ENTRY'
,p_message_text=>'List Entry'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2378284115551690114)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_text=>'List Entry Label'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(231029322138434626)
,p_name=>'LIST_INITCAP'
,p_message_text=>'List'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358903823823774280)
,p_name=>'LIST_ITEMS'
,p_message_text=>'List Items'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170062896027503563)
,p_name=>'LIST_REGION'
,p_message_text=>'List Region'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200668519217481169)
,p_name=>'LIST_TEMPLATE'
,p_message_text=>'List Template'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(95262601017911818)
,p_name=>'LIST_TEMPLATES'
,p_message_text=>'List Templates'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110413724014849383)
,p_name=>'LIST_UTILIZATION'
,p_message_text=>'List Utilization'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236523732590430937)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_text=>'List View Page Attributes'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236539026681540118)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_text=>'List View Page Name'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236522300925400102)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_text=>'List View Page'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(914962612629449085)
,p_name=>'LOAD_DATA'
,p_message_text=>'Load Data'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(276573503382100452)
,p_name=>'LOCK'
,p_message_text=>'Lock'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361820018717355579)
,p_name=>'LOCKED'
,p_message_text=>'locked'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137109409483368793)
,p_name=>'LOCKED BY'
,p_message_text=>'Locked by: %0'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(925751156638637305)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_text=>'Locked %0 by %1'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(926816349448126854)
,p_name=>'LOCK_SCRIPT'
,p_message_text=>'Lock Script'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145291427498059712)
,p_name=>'LOG'
,p_message_text=>'Log'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201792000854419008)
,p_name=>'LOGGING'
,p_message_text=>'Logging'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263598425179461354)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_text=>'Remember username'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263732570324544492)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201791215867357146)
,p_name=>'LOGIN_URL'
,p_message_text=>'Login URL'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201585531179266988)
,p_name=>'LOGO'
,p_message_text=>'Logo'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575493087035328292)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_text=>'No Image Set.'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575493336839328292)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_text=>'Application Logo Text'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575488610585328282)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_text=>'Application Logo'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575490088357328289)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_text=>'This file exceeds the allowed limit of %0'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575491529708328290)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_text=>'Custom logo markup can be set in the Application Builder.'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575491235298328290)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_text=>'Drag and drop files or click to select'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575490908891328290)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_text=>'Image'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575491894948328291)
,p_name=>'LOGO.LABEL.NONE'
,p_message_text=>'No Logo will be shown for this App.'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575490631009328289)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_text=>'Text'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575490304613328289)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_text=>'Type'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575492428599328291)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_text=>'A logo image is required for this logo type.'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575492700641328291)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_text=>'Logo Saved Successfully'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575492161353328291)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_text=>'A logo text is required for this logo type.'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575489761457328289)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_text=>'Only images are allowed'
,p_is_js_message=>true
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(823080828718883618)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_text=>'Thank you for your feedback, a bug has been created for this issue. '
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(835469798540994325)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_text=>'Thank you for your feedback, this request will be considered for a future release.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(493740797739783522)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_text=>'Thank you for your feedback, an issue has been logged in our system.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(836071698124261136)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_text=>'Thank you for your feedback, a task has been created to address this issue.'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1126853886916020485)
,p_name=>'LOG_IN'
,p_message_text=>'Log In'
,p_version_scn=>37165770887512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145335814086112597)
,p_name=>'LOG_INTERVAL'
,p_message_text=>'Log Interval'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191534522759355982)
,p_name=>'LOV ITEM CONDITION'
,p_message_text=>'List of Values Item Condition'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173530616198094636)
,p_name=>'LOW_PRIORITY'
,p_message_text=>'Low priority'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7749009626940369)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_text=>'Manage Page Groups'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359361311757275293)
,p_name=>'MANAGE SERVICE'
,p_message_text=>'Manage Service'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359355610194236932)
,p_name=>'MANAGE USERS'
,p_message_text=>'Manage Users'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359250201527158797)
,p_name=>'MANAGE WORKSPACE'
,p_message_text=>'Manage Workspace'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(294659024226767193)
,p_name=>'MANAGE_APPLICATION'
,p_message_text=>'Manage'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89492503020021602)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_text=>'Manage Unassigned'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19246514177089179)
,p_name=>'MANUAL'
,p_message_text=>'Manual'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2099171488542010)
,p_name=>'MAP_BACKGROUND.TYPES.OGCWMS'
,p_message_text=>'OGC WMS'
,p_version_scn=>37165881964536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2098687399536781)
,p_name=>'MAP_BACKGROUND.TYPES.RASTER'
,p_message_text=>'Raster XYZ Tile Layer'
,p_version_scn=>37165881964536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2098855793539451)
,p_name=>'MAP_BACKGROUND.TYPES.VECTOR'
,p_message_text=>'Vector Tile Layer'
,p_version_scn=>37165881964536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1700365256466959)
,p_name=>'MAP_LAYERS'
,p_message_text=>'Map Layers'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(45093631953561714)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_text=>'The map has been created successfully.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173505119896537517)
,p_name=>'MARQUEE_FEATURE'
,p_message_text=>'Marquee feature'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(228694730883432774)
,p_name=>'MASTER'
,p_message_text=>'Master'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204680931917585593)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_text=>'The master detail pages have been created successfully.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1271527567810900)
,p_name=>'MASTER_DETAIL'
,p_message_text=>'Master Detail'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1273802941851037)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_text=>'%0 Detail'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272629907830432)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_text=>'Edit %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270312332677604906)
,p_name=>'MATERIALIZED_VIEW'
,p_message_text=>'Materialized View'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184176530786139669)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_text=>'Maximum Rendering Time (Seconds)'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255028216715743318)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_text=>'Maximum Session Idle Time in Seconds'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255028407011747806)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_text=>'Maximum Session Length in Seconds'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(70827014465409662)
,p_name=>'MAY_NOT_DELETE'
,p_message_text=>'Deleting of milestones with associated features is not permitted.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22955624909103798)
,p_name=>'MEMORY'
,p_message_text=>'Memory:'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88111108558263925)
,p_name=>'MENU'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192772526454984643)
,p_name=>'MENU ITEM CONDITION'
,p_message_text=>'Breadcrumb Item Condition'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200686512357658911)
,p_name=>'MENU_TEMPLATE'
,p_message_text=>'Breadcrumb Template'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455018231283916555)
,p_name=>'MIGRATION FILES'
,p_message_text=>'Migration Files'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191518224506840662)
,p_name=>'MILESTONE'
,p_message_text=>'Milestone'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184180016204182794)
,p_name=>'MILESTONES'
,p_message_text=>'Milestones'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554294621241729642)
,p_name=>'MILLISECONDS_MS'
,p_message_text=>'ms'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184525822426461792)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_text=>'MIME Type Column'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172746306703436278)
,p_name=>'MINIMAL_IMPACT'
,p_message_text=>'Minimal Impact'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14671801654755910)
,p_name=>'MIN_VERSION'
,p_message_text=>'Minimum Version'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(829737488233033333)
,p_name=>'MISSING_AT_SIGN'
,p_message_text=>'Missing @ sign'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149489328196469481)
,p_name=>'MODEL_PAGE'
,p_message_text=>'Page %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173505508598543682)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_text=>'Moderately desirable'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172746102894435184)
,p_name=>'MODERATE_IMPACT'
,p_message_text=>'Moderate Impact'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60900401425236738)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_text=>'Denotes modified attribute.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270358825826858476)
,p_name=>'MODIFY_COLUMN'
,p_message_text=>'Modify Column %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145065912795468853)
,p_name=>'MONITOR'
,p_message_text=>'Monitor'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359360608294274252)
,p_name=>'MONITOR ACTIVITY'
,p_message_text=>'Monitor Activity'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195794808882884288)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_text=>'More...'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184172811945049105)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_text=>'%0 Most Active Applications'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183919229104067304)
,p_name=>'MOST_RECENT_ERROR'
,p_message_text=>'Most recent error'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468793720525103091)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_text=>'Most recent file is %0 uploaded by %1 %2'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106636411725245052)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_text=>'Error in MRU: row= %0, %1, %2'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106583632682938847)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_text=>'Primary key column identified was not located in the select list of the query'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106637514973255379)
,p_name=>'MRU.LOST_UPDATE'
,p_message_text=>'Current version of data in database has changed since user initiated update process. current checksum = "%0", item checksum = "%1".'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106580004715911851)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_text=>'There are no rows to process'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(74610218441708686)
,p_name=>'MUST_BE_XSL'
,p_message_text=>'Please ensure that the file type of the report layout file is XSL-FO, using ''.xsl'' as the file extension.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26566108620102788)
,p_name=>'MY_PAGE'
,p_message_text=>'My Page'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(820473514565552726)
,p_name=>'NAMES'
,p_message_text=>'Names'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(276320214015253322)
,p_name=>'NAVBAR'
,p_message_text=>'Navigation Bar'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191533707521351546)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_text=>'Navbar Item Condition'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855065613638177355)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_text=>'Go to Top'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190188614234894716)
,p_name=>'NAVIGATION BAR'
,p_message_text=>'Navigation Bar'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201376516054877137)
,p_name=>'NAVIGATION_LIST'
,p_message_text=>'Navigation'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7731807202589607)
,p_name=>'NAVIGATION_PAGE'
,p_message_text=>'Navigation Page'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4683114491444583)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_text=>'Navigate to the App Builder home page'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1425521768621667155)
,p_name=>'NAV_BAR_LIST'
,p_message_text=>'Implementation: List %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1425521326180665089)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_text=>'Implementation: Classic'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180834001773965043)
,p_name=>'NEEDS_REVIEW'
,p_message_text=>'Needs review'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176656130126024825)
,p_name=>'NEED_INFORMATION'
,p_message_text=>'Need information'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184178823560166007)
,p_name=>'NEWS_ENTRIES'
,p_message_text=>'News Entries'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1289410809468395700)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_text=>'New Value for Bind Variable %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91986109686181694)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Your new email address for your Oracle APEX account <strong>%0</strong> in workspace <strong>%1</strong>:<br>',
'%2<br><br>',
'%3'))
,p_version_scn=>29756017
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173001417631779047)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_text=>'New feature request'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145546021302360739)
,p_name=>'NEW_OR_EXISTING'
,p_message_text=>'New or Existing'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(246233220846504945)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_text=>'New Schema Name'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183826222815611404)
,p_name=>'NEW_SERVICE'
,p_message_text=>'New Service'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88103026987174618)
,p_name=>'NEW_TABSET'
,p_message_text=>'New Tabset'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936810445467028582)
,p_name=>'NEW_TOP_LEVEL'
,p_message_text=>'- No parent selected - '
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195799909331016896)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_text=>'New Workspace Request'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206030921197124527)
,p_name=>'NO CORRESPONDING REGION'
,p_message_text=>'No corresponding region'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171248017606006266)
,p_name=>'NO PRIMARY KEY'
,p_message_text=>'Table has no primary keys defined. A primary key is required when creating reports with forms. '
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23930121630315793)
,p_name=>'NOARCHIVELOG'
,p_message_text=>'Log Archiving: Off'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166136302908197868)
,p_name=>'NON CURRENT ENTRY'
,p_message_text=>'Non Current Entry'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190186611333884408)
,p_name=>'NON CURRENT TAB'
,p_message_text=>'Non Current Tab'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192141813811420822)
,p_name=>'NONE_SPECIFIED'
,p_message_text=>'None specified'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86862626768753970)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_text=>'Non Current Image'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(249542929342371497)
,p_name=>'NON_PACKAGE'
,p_message_text=>'-Non Productivity or Sample App-'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173530211696093348)
,p_name=>'NORMAL_PRIORITY'
,p_message_text=>'Normal priority'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(825615609184130380)
,p_name=>'NOT AVAILABLE'
,p_message_text=>'Not available'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036560702428046561)
,p_name=>'NOTE_LABEL'
,p_message_text=>'Note: %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123652313972836215)
,p_name=>'NOTIFICATION'
,p_message_text=>'Notification'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172713832199084126)
,p_name=>'NOT_A_BUG'
,p_message_text=>'Not a bug'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1252635610430289637)
,p_name=>'NOT_CURRENT'
,p_message_text=>'Not Current'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173506020027546963)
,p_name=>'NOT_DESIRABLE'
,p_message_text=>'Not desirable'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194470204425590678)
,p_name=>'NOT_EXISTS'
,p_message_text=>'Not Exists'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25595122418440396)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_text=>'NOT EXISTS SQL Query'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172715616466268802)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_text=>'Not feasible to fix'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(276139020530375202)
,p_name=>'NOT_FOUND'
,p_message_text=>'not found.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1397683472527752101)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_text=>'80% or less complete'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(209576722691307993)
,p_name=>'NOT_INSTALLED'
,p_message_text=>'Not Installed'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88090322335012391)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_text=>'Not in Data Dictionary'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174643804485648695)
,p_name=>'NOT_PRIORITIZED'
,p_message_text=>'Not prioritized'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172768624674488777)
,p_name=>'NOT_PRORITIZED'
,p_message_text=>'Not prioritized'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192153718902639812)
,p_name=>'NOT_PROVIDED'
,p_message_text=>'Not provided'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471877832570828583)
,p_name=>'NOT_REQUIRED'
,p_message_text=>'Not Required'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176655521122022274)
,p_name=>'NOT_STARTED'
,p_message_text=>'Not started'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(238269707256939080)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_text=>'<strong>%0</strong> is not a valid view name.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14634505108681169)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_text=>'No applications found.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(217443300966091317)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_text=>'No application selected'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114404521329122308)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_text=>'No Arguments Allowed'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171884714567028698)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_text=>'No assigned priority'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26362702473331569)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_text=>'no authorization scheme'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192447202528314675)
,p_name=>'NO_AVAIL_JOBS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'There are no available database job queue processes. Please contact your<br> administrator to have the JOB_QUEUE_PROCESSES initialization parameter <br>',
'increased or wait for other jobs to complete.'))
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139101032126745741)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_text=>'No breadcrumb templates found in theme. At least one breadcrumb template is required.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139102117366750968)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_text=>'No button templates found in theme. At least one button template is required.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139084626061706218)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_text=>'No calendar templates found in theme. At least one calendar template is required.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69673813099210540)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_text=>'No date specified'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148730329258917330)
,p_name=>'NO_DEBUG'
,p_message_text=>'No Debug'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12448003249747214)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_text=>'No Developer Privilege'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31675201711401266)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_text=>'- No Display -'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18745922829126238)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_text=>'No features targeted'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137502117221405325)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_text=>'No help available for this page item.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1846488465153797910)
,p_name=>'NO_ICON_FOUND'
,p_message_text=>'No icon found'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48095106818801006)
,p_name=>'NO_IMAGES_FOUND'
,p_message_text=>'No images found'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126705622790936308)
,p_name=>'NO_IMAGE_FOUND'
,p_message_text=>'No image found'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88178311786173189)
,p_name=>'NO_ITEM'
,p_message_text=>'no item'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(251179913919784023)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Database job queue processes is not enabled.  Please contact your<br>',
'administrator to set the JOB_QUEUE_PROCESSES initialization parameter.'))
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139089913856721620)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_text=>'No label templates found in theme. At least one label template is required.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41768324045254472)
,p_name=>'NO_LAYOUT'
,p_message_text=>'No Report Layout selected'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139098500613736633)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_text=>'No list templates found in theme. At least one list template is required.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173007811145834007)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_text=>'No longer an issue'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26361120781308414)
,p_name=>'NO_LOV'
,p_message_text=>'no List of Values'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191649702415489914)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_text=>'No milestones defined'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404655547200593610)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_text=>'Do not show navigation menu list'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41751910508872793)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_text=>'Developer does not have privilege to create a component on this page.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139106431134773821)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_text=>'Attempting to copy theme and found no page templates in application %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139081603205699540)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_text=>'No page templates found in theme.  At least one page template is required.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115414509296253586)
,p_name=>'NO_PARENT'
,p_message_text=>'No parent breadcrumb entry'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455064626237775943)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_text=>'No parent tabs have been defined'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195794208058874611)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_text=>'No pending requests'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139103914034759458)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_text=>'No popup list of values templates found in theme. One popup list of values template is required.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174558326211497881)
,p_name=>'NO_PRIORITY'
,p_message_text=>'No priority'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245432727613252897)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_text=>'This region position is not in your page template'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139083216365703369)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_text=>'No region templates found in theme. At least one region template is required.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139095413295730830)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_text=>'No report templates found in theme. At least one report template is required.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26362213424325207)
,p_name=>'NO_SHORTCUT'
,p_message_text=>'no shortcut'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176655217312021120)
,p_name=>'NO_STATUS'
,p_message_text=>'No status'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195815012092292093)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_text=>'No system message defined'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(492146426620763387)
,p_name=>'NO_TABS_DEFINED'
,p_message_text=>'No tabs have been defined for this application'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455348218805304300)
,p_name=>'NO_TABS_FOUND'
,p_message_text=>'No Tabs Found'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(454926705938029386)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_text=>'No tabs have been defined'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455283909652790821)
,p_name=>'NO_TABS_SELECTED'
,p_message_text=>'No Tabs Selected'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(820492924299208388)
,p_name=>'NO_TAGS_FOUND'
,p_message_text=>'No tags found'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88177025722158291)
,p_name=>'NO_TEMPLATE'
,p_message_text=>'No Template'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114405231026125191)
,p_name=>'NO_URL_ACCESS'
,p_message_text=>'No URL Access'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487137900747040482)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_text=>'Before you can use SQL tags you need to define a list of allowed tables.  This is for security reasons.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172741824234431872)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_text=>'No Workaround Available'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87938019026731545)
,p_name=>'NULL_IN_PAREN'
,p_message_text=>'(null)'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(275031104321611838)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_text=>'Entries'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(237102028496754781)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_text=>'Users'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18745600319119822)
,p_name=>'NUM_TOTAL'
,p_message_text=>'%0 Total'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(163583007369388600)
,p_name=>'OBJECTS'
,p_message_text=>'Objects'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(427729310896581580)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_text=>'Objects without Defaults'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(427729006047580158)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_text=>'Objects with Defaults'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036136524508721791)
,p_name=>'OBJECT_LABEL'
,p_message_text=>'Object: %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600245042350523)
,p_name=>'OBSTORE.AUTH_FAILED'
,p_message_text=>'Authentication failed.'
,p_version_scn=>11933214
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(291551406042184580)
,p_name=>'OBSTORE.BUCKET_NOT_VISIBLE'
,p_message_text=>'The bucket can be accessed, but is not visible.'
,p_version_scn=>37166014291033
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600791079364505)
,p_name=>'OBSTORE.BUCKET_VISIBLE'
,p_message_text=>'The bucket is visible, but allows listing contents.'
,p_version_scn=>11933504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2602084336460454)
,p_name=>'OBSTORE.ERR_CREATE_BUCKET'
,p_message_text=>'An error occurred while creating bucket %0. Response %1: %2'
,p_version_scn=>11933531
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601354040428131)
,p_name=>'OBSTORE.ERR_DELETE'
,p_message_text=>'An error occurred while deleting file %0. Response %1: %2 '
,p_version_scn=>11258708
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601561511434283)
,p_name=>'OBSTORE.ERR_GET'
,p_message_text=>'An error occurred retrieving file %0. Response %1: %2.'
,p_version_scn=>11260191
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2602233100476756)
,p_name=>'OBSTORE.ERR_LIST'
,p_message_text=>'An error occurred while listing contents at %0. Response %1: %2'
,p_version_scn=>11933594
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601877440453701)
,p_name=>'OBSTORE.ERR_PUT'
,p_message_text=>'An error occurred while creating file %0. Response %1: %2'
,p_version_scn=>11258823
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3026276146382141)
,p_name=>'OBSTORE.JOB_EXISTS'
,p_message_text=>'The job for syncing files in the background already exists.'
,p_version_scn=>12467436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600528904355200)
,p_name=>'OBSTORE.NOT_ACCESSIBLE'
,p_message_text=>'Bucket URL is not accessible.'
,p_version_scn=>11933399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3002623582427736)
,p_name=>'OBSTORE.SYNC_BACKGROUND'
,p_message_text=>'%0 files totaling %1 will be synced in the background. Note that files of the same name may be overwritten.'
,p_version_scn=>37166061256324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3002587055425790)
,p_name=>'OBSTORE.SYNC_IMMEDIATE'
,p_message_text=>'%0 files totaling %1 will be synced immediately. Note that files of the same name may be overwritten.'
,p_version_scn=>37166061256415
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600993840367887)
,p_name=>'OBSTORE.UNKOWN'
,p_message_text=>'An unknown error occurred while accessing the bucket.'
,p_version_scn=>11933635
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180236301190617432)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_text=>'Foreign Key Name must be specified.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(220824309442503326)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_text=>'Referenced Columns'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180239219676632281)
,p_name=>'OB_FK_REF_TAB'
,p_message_text=>'Foreign Key references table must be selected.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180238602707627311)
,p_name=>'OB_FK_SEL_COLS'
,p_message_text=>'Foreign Key columns must be selected.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(276745415661690615)
,p_name=>'OB_POSITION'
,p_message_text=>'Position'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(222608216198311144)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_text=>'- Select Datatype -'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555831921975745555)
,p_name=>'ODG.API.START'
,p_message_text=>'%0  START'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555831721294742515)
,p_name=>'ODG.API.UNHANDLED'
,p_message_text=>'%0 Unhandled Exception'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555833421079833122)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_text=>'Unhandled builtin data_source: %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1499684816938676)
,p_name=>'ODG.BLUEPRINT'
,p_message_text=>'Blueprint'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555835855285927327)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_text=>'Blueprint not found or not created'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1945021399399889)
,p_name=>'ODG.BLUEPRINT.COLUMN_NOT_FOUND'
,p_message_text=>'The column %0 does not exists in this table, with datatype: %1'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3410698042711235)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_text=>'Data Source Name must be 26 characters or fewer.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3410459530709481)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_text=>'Error importing: %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1945690893399889)
,p_name=>'ODG.BLUEPRINT.ERROR_PREVIEWING'
,p_message_text=>'Error when generating preview data: %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555835241861914652)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_text=>'Error building INSERT-SELECT SQL statement'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555834230751886107)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_text=>'%0 obtaining JSON data. URL: %1'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601885036215691)
,p_name=>'ODG.BLUEPRINT.EXPORT_FILE_LIMIT'
,p_message_text=>'The size of blueprint %0 is too large to display. Click on export blueprint to download the complete file.'
,p_version_scn=>13939233
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4125588393794848)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_ERROR'
,p_message_text=>'Errors found when inserting generated data into the database. Verify source column data type and value formats and target table constrains are all valid.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555836823129947944)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_text=>'INSERT INTO script:'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3411066065715959)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_text=>'Invalid builtin data source: %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1944424214399889)
,p_name=>'ODG.BLUEPRINT.INVALID_FORMAT'
,p_message_text=>'The format is not valid: %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1790211894451010)
,p_name=>'ODG.BLUEPRINT.INVALID_OFFSET'
,p_message_text=>'The offset must be greater than 0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1945381529399889)
,p_name=>'ODG.BLUEPRINT.INVALID_SCHEMA'
,p_message_text=>'The schema %0 is not a valid workspace schema'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555835041068910658)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_text=>'Error: JSON data is null.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1943840889399888)
,p_name=>'ODG.BLUEPRINT.MULTIPLE_TABLES'
,p_message_text=>'Unable to generate CLOB output for multiple tables - use the BLOB output procedure instead'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555834452897890722)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_text=>'Not a valid object'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555834609315893493)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_text=>'Error No rows requested'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1944106392399888)
,p_name=>'ODG.BLUEPRINT.NO_TABLES'
,p_message_text=>'No tables (containing columns) defined or found for this blueprint'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1948982217399892)
,p_name=>'ODG.BLUEPRINT.PROCESS_EXISTS'
,p_message_text=>'Data generation for blueprint %0, table %1 is already in progress and can not be started simultaneously.'
,p_version_scn=>37165899744191
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5100756822393282)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_0'
,p_message_text=>'Data generation started (status line)'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1945993606399889)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_1'
,p_message_text=>'%0:%1: Preparing SQL for generating data.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1947789279399891)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_10'
,p_message_text=>'%0:%1: Data generation complete.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1946254210399890)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_2'
,p_message_text=>'%0:%1: Generating and staging data.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1948084582399891)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_20'
,p_message_text=>'%0:%1: Data generation failed.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1946583692399890)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_3'
,p_message_text=>'%0:%1: Preparing SQL for downloading generated data.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1947182921399890)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_4_DOWNLOAD'
,p_message_text=>'%0:%1: Downloading generated data.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1946861008399890)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_4_INSERT'
,p_message_text=>'%0:%1: Inserting generated data.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1947495913399890)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_5'
,p_message_text=>'%0:%1: Creating output file.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1948314710399891)
,p_name=>'ODG.BLUEPRINT.PROCESS_MESSAGE_99'
,p_message_text=>'%0:%1: Data generation stopped.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1948671319399892)
,p_name=>'ODG.BLUEPRINT.PROCESS_STOPPED'
,p_message_text=>'Data generation for blueprint %0, table %1 has been stopped'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1943688253399887)
,p_name=>'ODG.BLUEPRINT.RESERVED_WORDS'
,p_message_text=>'Unable to generate data. The table/column names are using reserved words: %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4151244941807333)
,p_name=>'ODG.BLUEPRINT.SUCCESS_INSERTING_DATA'
,p_message_text=>'Successfully inserted data into the database from the blueprint.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1944766944399889)
,p_name=>'ODG.BLUEPRINT.TABLE_NOT_FOUND'
,p_message_text=>'The table does not exists in this database schema'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555834051293880571)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_text=>'Too many rows requested, maximum rows allowed is %0.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(555834819984898266)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_text=>'Unexpected Error loading %0.'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1790037249447590)
,p_name=>'ODG.BLUEPRINT.UNSUPPORTED_DATATYPE'
,p_message_text=>'Datatype is not supported: %0'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3410898655713717)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_text=>'%0 must be Y or N'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1501915601032927)
,p_name=>'ODG.BUILTIN'
,p_message_text=>'Built In'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1791238803574690)
,p_name=>'ODG.BUILTINS.2D_SHAPE'
,p_message_text=>'Two Dimensional Shape'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1733574984574643)
,p_name=>'ODG.BUILTINS.2D_SHAPE.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1733714801574663)
,p_name=>'ODG.BUILTINS.2D_SHAPE.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1734050637574664)
,p_name=>'ODG.BUILTINS.2D_SHAPE.SIDES'
,p_message_text=>'Sides'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1791530702574691)
,p_name=>'ODG.BUILTINS.3D_SHAPE'
,p_message_text=>'Three Dimensional Shape'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1734313284574664)
,p_name=>'ODG.BUILTINS.3D_SHAPE.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1734622473574664)
,p_name=>'ODG.BUILTINS.3D_SHAPE.EDGES'
,p_message_text=>'Edges'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1734962172574665)
,p_name=>'ODG.BUILTINS.3D_SHAPE.FACES'
,p_message_text=>'Faces'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1735209504574665)
,p_name=>'ODG.BUILTINS.3D_SHAPE.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1735537465574665)
,p_name=>'ODG.BUILTINS.3D_SHAPE.VERTICES'
,p_message_text=>'Vertices'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1791873896574691)
,p_name=>'ODG.BUILTINS.AIRPORT'
,p_message_text=>'Airport'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1735853194574665)
,p_name=>'ODG.BUILTINS.AIRPORT.AIRPORT_TYPE'
,p_message_text=>'Airport Type'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1736107096574665)
,p_name=>'ODG.BUILTINS.AIRPORT.ARP_LATITUDE'
,p_message_text=>'Latitude'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1736485353574665)
,p_name=>'ODG.BUILTINS.AIRPORT.ARP_LATITUDE_S'
,p_message_text=>'Latitude South'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1736794828574666)
,p_name=>'ODG.BUILTINS.AIRPORT.ARP_LONGITUDE'
,p_message_text=>'Longitude'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1737002680574666)
,p_name=>'ODG.BUILTINS.AIRPORT.ARP_LONGITUDE_S'
,p_message_text=>'Longitude South'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1737337157574666)
,p_name=>'ODG.BUILTINS.AIRPORT.CITY'
,p_message_text=>'City'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1737602097574666)
,p_name=>'ODG.BUILTINS.AIRPORT.COUNTY'
,p_message_text=>'County'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1737901840574666)
,p_name=>'ODG.BUILTINS.AIRPORT.FACILITY_NAME'
,p_message_text=>'Facility Name'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1738204123574666)
,p_name=>'ODG.BUILTINS.AIRPORT.IATA_CODE'
,p_message_text=>'Local Access and Transport Area Code'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1738527751574666)
,p_name=>'ODG.BUILTINS.AIRPORT.OWNER'
,p_message_text=>'Owner'
,p_version_scn=>37165770887513
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1738823443574666)
,p_name=>'ODG.BUILTINS.AIRPORT.OWNER_ADDRESS'
,p_message_text=>'Owner Address'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1739159165574667)
,p_name=>'ODG.BUILTINS.AIRPORT.SEEDED_DATA_YN'
,p_message_text=>'Data Seeded, Yes or No'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1739431813574667)
,p_name=>'ODG.BUILTINS.AIRPORT.SITE_NUMBER'
,p_message_text=>'Site Number'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1739780849574667)
,p_name=>'ODG.BUILTINS.AIRPORT.STATE_NAME'
,p_message_text=>'State Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1792163503574691)
,p_name=>'ODG.BUILTINS.ANIMAL'
,p_message_text=>'Animal'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1740015566574667)
,p_name=>'ODG.BUILTINS.ANIMAL.CLASS'
,p_message_text=>'Class'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1740301895574667)
,p_name=>'ODG.BUILTINS.ANIMAL.COMMON_NAME'
,p_message_text=>'Common Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1740613382574667)
,p_name=>'ODG.BUILTINS.ANIMAL.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1740970041574667)
,p_name=>'ODG.BUILTINS.ANIMAL.FAMILY'
,p_message_text=>'Family'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1741288822574667)
,p_name=>'ODG.BUILTINS.ANIMAL.GENUS'
,p_message_text=>'Genus'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1741570269574668)
,p_name=>'ODG.BUILTINS.ANIMAL.KINGDOM'
,p_message_text=>'Kingdom'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1741886171574668)
,p_name=>'ODG.BUILTINS.ANIMAL.PHYLUM'
,p_message_text=>'Phylum'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1742132818574668)
,p_name=>'ODG.BUILTINS.ANIMAL.SEEDED_DATA_YN'
,p_message_text=>'Data Seeded, Yes or No'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1742419248574668)
,p_name=>'ODG.BUILTINS.ANIMAL.SPECIES'
,p_message_text=>'Species'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1742797593574668)
,p_name=>'ODG.BUILTINS.ANIMAL.THE_ORDER'
,p_message_text=>'Order'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1792427059574691)
,p_name=>'ODG.BUILTINS.BOOLEAN'
,p_message_text=>'Boolean'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1743028374574668)
,p_name=>'ODG.BUILTINS.BOOLEAN.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1743366835574668)
,p_name=>'ODG.BUILTINS.BOOLEAN.ONE_ZERO'
,p_message_text=>'One or Zero'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1743698190574668)
,p_name=>'ODG.BUILTINS.BOOLEAN.TRUE_FALSE'
,p_message_text=>'True or False'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1743985478574669)
,p_name=>'ODG.BUILTINS.BOOLEAN.Y_N'
,p_message_text=>'Yes or No'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1792712949574691)
,p_name=>'ODG.BUILTINS.CAR'
,p_message_text=>'Car'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1744252370574669)
,p_name=>'ODG.BUILTINS.CAR.CITY_MPG'
,p_message_text=>'Miles Per Gallon (City)'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1744577752574669)
,p_name=>'ODG.BUILTINS.CAR.DRIVEN_WHEELS'
,p_message_text=>'Drivetrain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1744895014574669)
,p_name=>'ODG.BUILTINS.CAR.ENGINE_CYLINDERS'
,p_message_text=>'Engine Cylinders'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1745150384574669)
,p_name=>'ODG.BUILTINS.CAR.ENGINE_FUEL_TYPE'
,p_message_text=>'Engine Fuel Type'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1745412376574669)
,p_name=>'ODG.BUILTINS.CAR.ENGINE_HP'
,p_message_text=>'Engine Horsepower'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1745787786574669)
,p_name=>'ODG.BUILTINS.CAR.HIGHWAY_MPG'
,p_message_text=>'Miles Per Gallon (Highway)'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1746096285574669)
,p_name=>'ODG.BUILTINS.CAR.MAKE'
,p_message_text=>'Make'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1746344273574670)
,p_name=>'ODG.BUILTINS.CAR.MARKET_CATEGORY'
,p_message_text=>'Market Category'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1746611321574670)
,p_name=>'ODG.BUILTINS.CAR.MODEL'
,p_message_text=>'Model'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1746997907574670)
,p_name=>'ODG.BUILTINS.CAR.MSRP'
,p_message_text=>'Manufacturer Suggested Retail Price'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1747215616574670)
,p_name=>'ODG.BUILTINS.CAR.NUMBER_OF_DOORS'
,p_message_text=>'Number of Doors'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1747505970574670)
,p_name=>'ODG.BUILTINS.CAR.SEEDED_DATA_YN'
,p_message_text=>'Data Seeded, Yes or No'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1747818359574670)
,p_name=>'ODG.BUILTINS.CAR.TRANSMISSION_TYPE'
,p_message_text=>'Transmission Type'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1748144486574670)
,p_name=>'ODG.BUILTINS.CAR.VEHICLE_SIZE'
,p_message_text=>'Vehicle Size'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1748426608574670)
,p_name=>'ODG.BUILTINS.CAR.VEHICLE_STYLE'
,p_message_text=>'Vehicle Style'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1748766072574671)
,p_name=>'ODG.BUILTINS.CAR.YEAR'
,p_message_text=>'Year'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1793040727574691)
,p_name=>'ODG.BUILTINS.CHARACTER'
,p_message_text=>'Character'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1749060846574671)
,p_name=>'ODG.BUILTINS.CHARACTER.GUID'
,p_message_text=>'Globally Unique Identifier'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1793395062574691)
,p_name=>'ODG.BUILTINS.COLOR'
,p_message_text=>'Color'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1749329378574671)
,p_name=>'ODG.BUILTINS.COLOR.COLOR'
,p_message_text=>'Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1749630582574671)
,p_name=>'ODG.BUILTINS.COLOR.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1749979774574671)
,p_name=>'ODG.BUILTINS.COLOR.HEX_CODE'
,p_message_text=>'Hexadecimal Code'
,p_version_scn=>37165924917479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1750236907574671)
,p_name=>'ODG.BUILTINS.COLOR.RGB'
,p_message_text=>'Red, Green, and Blue'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1750533616574671)
,p_name=>'ODG.BUILTINS.COLOR.RN'
,p_message_text=>'Return Null'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1793682659574691)
,p_name=>'ODG.BUILTINS.COMPANY_NAME'
,p_message_text=>'Company Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1750882410574671)
,p_name=>'ODG.BUILTINS.COMPANY_NAME.COMPANY'
,p_message_text=>'Company'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1793907898574692)
,p_name=>'ODG.BUILTINS.COUNTRY'
,p_message_text=>'Country'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1751171182574672)
,p_name=>'ODG.BUILTINS.COUNTRY.AREA'
,p_message_text=>'Area'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1751409254574672)
,p_name=>'ODG.BUILTINS.COUNTRY.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1751716391574672)
,p_name=>'ODG.BUILTINS.COUNTRY.GDP_PER_CAPITA'
,p_message_text=>'Gross Domestic Product Per Capita'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1752072885574672)
,p_name=>'ODG.BUILTINS.COUNTRY.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1752356223574672)
,p_name=>'ODG.BUILTINS.COUNTRY.POPULATION'
,p_message_text=>'Population'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1752689708574672)
,p_name=>'ODG.BUILTINS.COUNTRY.POP_DENSITY'
,p_message_text=>'Population Density'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1752958927574672)
,p_name=>'ODG.BUILTINS.COUNTRY.REGION'
,p_message_text=>'Region'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1794235951574692)
,p_name=>'ODG.BUILTINS.CREDIT_CARD'
,p_message_text=>'Credit Card'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1753258530574672)
,p_name=>'ODG.BUILTINS.CREDIT_CARD.CARD_NUMBER'
,p_message_text=>'Card Number'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1794502061574692)
,p_name=>'ODG.BUILTINS.DATE'
,p_message_text=>'Date'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1753547228574673)
,p_name=>'ODG.BUILTINS.DATE.DATE_BETWEEN_MIN_AND_MAX'
,p_message_text=>'Date Between Minimum And Maximum'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1753818808574673)
,p_name=>'ODG.BUILTINS.DATE.NOW'
,p_message_text=>'Today''s Date'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1754166190574673)
,p_name=>'ODG.BUILTINS.DATE.RANDOM'
,p_message_text=>'Random Date'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1754415352574673)
,p_name=>'ODG.BUILTINS.DATE.RANDOM_FUTURE'
,p_message_text=>'Random Future Date'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1754756199574673)
,p_name=>'ODG.BUILTINS.DATE.RANDOM_PAST'
,p_message_text=>'Random Past Date'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1755022505574673)
,p_name=>'ODG.BUILTINS.DATE.TODAY'
,p_message_text=>'Today''s Date'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1794854393574692)
,p_name=>'ODG.BUILTINS.DEPT'
,p_message_text=>'Department'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1755378432574673)
,p_name=>'ODG.BUILTINS.DEPT.DNAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1755673572574673)
,p_name=>'ODG.BUILTINS.DEPT.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1795197503574692)
,p_name=>'ODG.BUILTINS.ELEMENT'
,p_message_text=>'Element'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1755945234574674)
,p_name=>'ODG.BUILTINS.ELEMENT.ATOMIC_NUMBER'
,p_message_text=>'Atomic Number'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1756235585574674)
,p_name=>'ODG.BUILTINS.ELEMENT.ATOMIC_WEIGHT'
,p_message_text=>'Atomic Weight'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1756583450574674)
,p_name=>'ODG.BUILTINS.ELEMENT.CAS_NUMBER'
,p_message_text=>'Chemical Abstracts Service Number'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1756899453574674)
,p_name=>'ODG.BUILTINS.ELEMENT.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1757197696574674)
,p_name=>'ODG.BUILTINS.ELEMENT.ELECTRON_CONFIGURATION'
,p_message_text=>'Electron Configuration'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1757492769574674)
,p_name=>'ODG.BUILTINS.ELEMENT.ELEMENT_CATEGORY'
,p_message_text=>'Category'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1757712230574674)
,p_name=>'ODG.BUILTINS.ELEMENT.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1758056393574674)
,p_name=>'ODG.BUILTINS.ELEMENT.PHASE'
,p_message_text=>'Phase'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1758311900574675)
,p_name=>'ODG.BUILTINS.ELEMENT.SYMBOL'
,p_message_text=>'Symbol'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4502402782710503)
,p_name=>'ODG.BUILTINS.FONT_APEX'
,p_message_text=>'Font APEX'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4502650198714224)
,p_name=>'ODG.BUILTINS.FONT_APEX.ICON_NAME'
,p_message_text=>'Icon Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1795484469574692)
,p_name=>'ODG.BUILTINS.FOOD'
,p_message_text=>'Food'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1758672154574675)
,p_name=>'ODG.BUILTINS.FOOD.CALORIES'
,p_message_text=>'Calories'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1758986782574675)
,p_name=>'ODG.BUILTINS.FOOD.CATEGORY'
,p_message_text=>'Category'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1759283669574675)
,p_name=>'ODG.BUILTINS.FOOD.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1759523393574675)
,p_name=>'ODG.BUILTINS.FOOD.FAT'
,p_message_text=>'Grams of Fat'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1759875261574675)
,p_name=>'ODG.BUILTINS.FOOD.FOOD'
,p_message_text=>'Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1760107454574676)
,p_name=>'ODG.BUILTINS.FOOD.GRAMS'
,p_message_text=>'Grams'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1760483172574676)
,p_name=>'ODG.BUILTINS.FOOD.MEASURE'
,p_message_text=>'Measurements'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1760706992574676)
,p_name=>'ODG.BUILTINS.FOOD.PROTEIN'
,p_message_text=>'Grams of Protein'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1795717195574692)
,p_name=>'ODG.BUILTINS.GENERIC'
,p_message_text=>'Generic'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1761028012574676)
,p_name=>'ODG.BUILTINS.GENERIC.CODE'
,p_message_text=>'Code'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1761308029574676)
,p_name=>'ODG.BUILTINS.GENERIC.OTHER'
,p_message_text=>'Other'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1761680662574676)
,p_name=>'ODG.BUILTINS.GENERIC.PERCENTAGE'
,p_message_text=>'Percentage'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1761902891574676)
,p_name=>'ODG.BUILTINS.GENERIC.VARCHAR2'
,p_message_text=>'Variable Character'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1762275258574677)
,p_name=>'ODG.BUILTINS.GENERIC.VARCHAR2.CHANNEL'
,p_message_text=>'Channel'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1762584871574677)
,p_name=>'ODG.BUILTINS.GENERIC.VARCHAR2.GENDER_LONG'
,p_message_text=>'Gender'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1762801256574677)
,p_name=>'ODG.BUILTINS.GENERIC.VARCHAR2.GENDER_SHORT'
,p_message_text=>'Gender Initial'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1763173373574677)
,p_name=>'ODG.BUILTINS.GENERIC.VARCHAR2.STATUS_LONG'
,p_message_text=>'Status Name Identifier'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1763489856574677)
,p_name=>'ODG.BUILTINS.GENERIC.VARCHAR2.STATUS_SHORT'
,p_message_text=>'Status Value Identifier'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1763758698574677)
,p_name=>'ODG.BUILTINS.GENERIC.VARCHAR2.YN'
,p_message_text=>'Yes or No'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1796008243574692)
,p_name=>'ODG.BUILTINS.GENERIC_PROD'
,p_message_text=>'Generic Product'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1764024550574677)
,p_name=>'ODG.BUILTINS.GENERIC_PROD.LIST_PRICE'
,p_message_text=>'List Price'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1764384286574677)
,p_name=>'ODG.BUILTINS.GENERIC_PROD.PRODUCT_NAME'
,p_message_text=>'Product Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1764640317574678)
,p_name=>'ODG.BUILTINS.GENERIC_PROD.VC2'
,p_message_text=>'Category Array'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1796307465574693)
,p_name=>'ODG.BUILTINS.ICD_DIAG'
,p_message_text=>'Interface Control Document Diagram'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1764970338574678)
,p_name=>'ODG.BUILTINS.ICD_DIAG.CODE'
,p_message_text=>'Code'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1765291995574678)
,p_name=>'ODG.BUILTINS.ICD_DIAG.LONG_DESC'
,p_message_text=>'Long Description'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1765561945574678)
,p_name=>'ODG.BUILTINS.ICD_DIAG.SEEDED_DATA_YN'
,p_message_text=>'Data Seeded, Yes or No'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1765898072574678)
,p_name=>'ODG.BUILTINS.ICD_DIAG.SHORT_DESC'
,p_message_text=>'Short Description'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1796623867574693)
,p_name=>'ODG.BUILTINS.ICD_PROC'
,p_message_text=>'Interface Control Document Process'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1766174896574678)
,p_name=>'ODG.BUILTINS.ICD_PROC.CODE'
,p_message_text=>'Code'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1766450731574678)
,p_name=>'ODG.BUILTINS.ICD_PROC.LONG_DESC'
,p_message_text=>'Long Description'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1766710393574678)
,p_name=>'ODG.BUILTINS.ICD_PROC.SEEDED_DATA_YN'
,p_message_text=>'Data Seeded, Yes or No'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1767017514574679)
,p_name=>'ODG.BUILTINS.ICD_PROC.SHORT_DESC'
,p_message_text=>'Short Description'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1796949437574693)
,p_name=>'ODG.BUILTINS.INDUSTRY'
,p_message_text=>'Industry'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1767378317574679)
,p_name=>'ODG.BUILTINS.INDUSTRY.DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1767679869574679)
,p_name=>'ODG.BUILTINS.INDUSTRY.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1767977811574679)
,p_name=>'ODG.BUILTINS.INDUSTRY.TITLE'
,p_message_text=>'Title'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4100386403195078)
,p_name=>'ODG.BUILTINS.INVALID_INPUT'
,p_message_text=>'Invalid input submitted'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1797227887574693)
,p_name=>'ODG.BUILTINS.IPV4'
,p_message_text=>'Internet Protocol Version 4'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1768222530574679)
,p_name=>'ODG.BUILTINS.IPV4.ANY_ADDRESS'
,p_message_text=>'Any Address'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1768541142574679)
,p_name=>'ODG.BUILTINS.IPV4.UNRESTRICTED_ADDRESS'
,p_message_text=>'Unrestricted Address'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1797596503574693)
,p_name=>'ODG.BUILTINS.IPV6'
,p_message_text=>'Internet Protocol Version 6'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1768785457574679)
,p_name=>'ODG.BUILTINS.IPV6.ANY_ADDRESS'
,p_message_text=>'Any Address'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1797864685574693)
,p_name=>'ODG.BUILTINS.ISLAND'
,p_message_text=>'Island'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1769085172574679)
,p_name=>'ODG.BUILTINS.ISLAND.COUNTRY'
,p_message_text=>'Country'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1769396671574680)
,p_name=>'ODG.BUILTINS.ISLAND.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1769616878574680)
,p_name=>'ODG.BUILTINS.ISLAND.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1798171311574693)
,p_name=>'ODG.BUILTINS.LANGUAGE'
,p_message_text=>'Language'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1769931763574680)
,p_name=>'ODG.BUILTINS.LANGUAGE.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1770210229574680)
,p_name=>'ODG.BUILTINS.LANGUAGE.LANGUAGE_ID'
,p_message_text=>'Language Identifier'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1770510448574680)
,p_name=>'ODG.BUILTINS.LANGUAGE.LANGUAGE_LABEL'
,p_message_text=>'Language Label'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1770876019574680)
,p_name=>'ODG.BUILTINS.LANGUAGE.NLS_LANGUAGE'
,p_message_text=>'National Language Support Language'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1771159349574680)
,p_name=>'ODG.BUILTINS.LANGUAGE.NLS_TERRITORY'
,p_message_text=>'National Language Support Territory'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1798471252574693)
,p_name=>'ODG.BUILTINS.LATIN_TEXT'
,p_message_text=>'Latin Text'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1771495016574680)
,p_name=>'ODG.BUILTINS.LATIN_TEXT.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1771754988574681)
,p_name=>'ODG.BUILTINS.LATIN_TEXT.TEXT1024'
,p_message_text=>'1,024 Characters of Text'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1772024150574681)
,p_name=>'ODG.BUILTINS.LATIN_TEXT.TEXT128'
,p_message_text=>'128 Characters of Text'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1772396122574681)
,p_name=>'ODG.BUILTINS.LATIN_TEXT.TEXT256'
,p_message_text=>'256 Characters of Text'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1772664746574681)
,p_name=>'ODG.BUILTINS.LATIN_TEXT.TEXT32'
,p_message_text=>'32 Characters of Text'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1772944213574681)
,p_name=>'ODG.BUILTINS.LATIN_TEXT.TEXT4000'
,p_message_text=>'4,000 Characters of Text'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1773216887574681)
,p_name=>'ODG.BUILTINS.LATIN_TEXT.TEXT64'
,p_message_text=>'64 Characters of Text'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1798726343574694)
,p_name=>'ODG.BUILTINS.LOCATION'
,p_message_text=>'Location'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1773564609574682)
,p_name=>'ODG.BUILTINS.LOCATION.CITY'
,p_message_text=>'City'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1773835868574682)
,p_name=>'ODG.BUILTINS.LOCATION.COUNTY_FIPS'
,p_message_text=>'County Federal Information Processing Standard Codes'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1774130146574682)
,p_name=>'ODG.BUILTINS.LOCATION.COUNTY_NAME'
,p_message_text=>'County Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1774415946574682)
,p_name=>'ODG.BUILTINS.LOCATION.LATITUDE'
,p_message_text=>'Latitude'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1774744649574682)
,p_name=>'ODG.BUILTINS.LOCATION.LONGITUDE'
,p_message_text=>'Longitude'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1775054448574682)
,p_name=>'ODG.BUILTINS.LOCATION.MILITARY'
,p_message_text=>'Military'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1775378223574683)
,p_name=>'ODG.BUILTINS.LOCATION.POPULATION'
,p_message_text=>'Population'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1775611824574683)
,p_name=>'ODG.BUILTINS.LOCATION.SEEDED_DATA_YN'
,p_message_text=>'Data Seeded, Yes or No'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1775952185574683)
,p_name=>'ODG.BUILTINS.LOCATION.STATE_ID'
,p_message_text=>'State Identifier'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1776249977574683)
,p_name=>'ODG.BUILTINS.LOCATION.STATE_NAME'
,p_message_text=>'State Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1776562174574683)
,p_name=>'ODG.BUILTINS.LOCATION.TIMEZONE'
,p_message_text=>'Timezone'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1776876834574683)
,p_name=>'ODG.BUILTINS.LOCATION.ZCTA'
,p_message_text=>'Zip Code Tabulation Areas'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1777150044574683)
,p_name=>'ODG.BUILTINS.LOCATION.ZIP_VC'
,p_message_text=>'Zip Code'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1799052651574694)
,p_name=>'ODG.BUILTINS.NUMBER'
,p_message_text=>'Number'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1777419433574683)
,p_name=>'ODG.BUILTINS.NUMBER.GUID'
,p_message_text=>'Globally Unique Identifier'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1777736232574684)
,p_name=>'ODG.BUILTINS.NUMBER.INTEGER'
,p_message_text=>'Integer'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1778014393574684)
,p_name=>'ODG.BUILTINS.NUMBER.RANDOM'
,p_message_text=>'Random Number'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1799384630574694)
,p_name=>'ODG.BUILTINS.OCCUPATION'
,p_message_text=>'Occupation'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1778319828574684)
,p_name=>'ODG.BUILTINS.OCCUPATION.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1778656009574684)
,p_name=>'ODG.BUILTINS.OCCUPATION.MEAN_WAGE'
,p_message_text=>'Mean Wage'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1778997560574684)
,p_name=>'ODG.BUILTINS.OCCUPATION.TITLE'
,p_message_text=>'Title'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1799650624574694)
,p_name=>'ODG.BUILTINS.PERSON'
,p_message_text=>'Person'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1779259867574684)
,p_name=>'ODG.BUILTINS.PERSON.BIOLOGICAL_SEX'
,p_message_text=>'Biological Sex'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1779574535574684)
,p_name=>'ODG.BUILTINS.PERSON.EMAIL'
,p_message_text=>'Email'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1779834307574684)
,p_name=>'ODG.BUILTINS.PERSON.FIRST_NAME'
,p_message_text=>'First Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1780100335574685)
,p_name=>'ODG.BUILTINS.PERSON.FORWARD_NAME'
,p_message_text=>'Forward Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1780482836574685)
,p_name=>'ODG.BUILTINS.PERSON.LAST_COMMA_FIRST'
,p_message_text=>'Last Name, First Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1780799125574685)
,p_name=>'ODG.BUILTINS.PERSON.LAST_NAME'
,p_message_text=>'Last Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1781012245574685)
,p_name=>'ODG.BUILTINS.PERSON.UPPER_FULL_NAME'
,p_message_text=>'Uppercased Full Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1799938170574694)
,p_name=>'ODG.BUILTINS.PET'
,p_message_text=>'Pet'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1781354004574685)
,p_name=>'ODG.BUILTINS.PET.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1781697627574685)
,p_name=>'ODG.BUILTINS.PET.PET_NAME'
,p_message_text=>'Pet Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1781978952574685)
,p_name=>'ODG.BUILTINS.PET.PET_SUB_TYPE'
,p_message_text=>'Pet Subtype'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782232300574685)
,p_name=>'ODG.BUILTINS.PET.PET_TYPE'
,p_message_text=>'Pet Type'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800255958574695)
,p_name=>'ODG.BUILTINS.PHONE'
,p_message_text=>'Phone'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782541456574686)
,p_name=>'ODG.BUILTINS.PHONE.US_PHONE_NUMBER'
,p_message_text=>'United States Phone Number'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800525099574695)
,p_name=>'ODG.BUILTINS.PLANT'
,p_message_text=>'Plant'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782806312574686)
,p_name=>'ODG.BUILTINS.PLANT.CATEGORY'
,p_message_text=>'Category'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783129617574686)
,p_name=>'ODG.BUILTINS.PLANT.CLASS'
,p_message_text=>'Class'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783409685574686)
,p_name=>'ODG.BUILTINS.PLANT.COMMON_NAME'
,p_message_text=>'Common Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783724641574686)
,p_name=>'ODG.BUILTINS.PLANT.DIVISION'
,p_message_text=>'Division'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1784060655574686)
,p_name=>'ODG.BUILTINS.PLANT.FAMILY'
,p_message_text=>'Family'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1784328215574686)
,p_name=>'ODG.BUILTINS.PLANT.FAMILY_COMMON_NAME'
,p_message_text=>'Family Common Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1784614664574687)
,p_name=>'ODG.BUILTINS.PLANT.GENERA_BINOMIAL_AUTHOR'
,p_message_text=>'Genera Binomial Author'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1784903029574687)
,p_name=>'ODG.BUILTINS.PLANT.GENUS'
,p_message_text=>'Genus'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1785276642574687)
,p_name=>'ODG.BUILTINS.PLANT.GROWTH_HABIT'
,p_message_text=>'Growth Habit'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1785598979574687)
,p_name=>'ODG.BUILTINS.PLANT.KINGDOM'
,p_message_text=>'Kingdom'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1785840125574687)
,p_name=>'ODG.BUILTINS.PLANT.SCIENTIFIC_NAME'
,p_message_text=>'Scientific Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1786128845574687)
,p_name=>'ODG.BUILTINS.PLANT.SEEDED_DATA_YN'
,p_message_text=>'Data Seeded, Yes or No'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1786468875574687)
,p_name=>'ODG.BUILTINS.PLANT.SPECIES'
,p_message_text=>'Species'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1786761930574688)
,p_name=>'ODG.BUILTINS.PLANT.SUBCLASS'
,p_message_text=>'Subclass'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1787073365574688)
,p_name=>'ODG.BUILTINS.PLANT.TAXONOMY_ORDER'
,p_message_text=>'Taxonomy Order'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1787356918574688)
,p_name=>'ODG.BUILTINS.PLANT.VARIETY'
,p_message_text=>'Variety'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800894947574695)
,p_name=>'ODG.BUILTINS.PRODUCT_REVIEW'
,p_message_text=>'Product Review'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1787636636574688)
,p_name=>'ODG.BUILTINS.PRODUCT_REVIEW.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1787902088574688)
,p_name=>'ODG.BUILTINS.PRODUCT_REVIEW.REVIEW'
,p_message_text=>'Review'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1788239173574688)
,p_name=>'ODG.BUILTINS.PRODUCT_REVIEW.STARS'
,p_message_text=>'Stars'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2862257683295088)
,p_name=>'ODG.BUILTINS.RETURNS'
,p_message_text=>'Returns %0'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801107571574695)
,p_name=>'ODG.BUILTINS.SCHOOL'
,p_message_text=>'School'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1788595744574689)
,p_name=>'ODG.BUILTINS.SCHOOL.ACCRED_AGENCY'
,p_message_text=>'Accredited Agency'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1788804394574689)
,p_name=>'ODG.BUILTINS.SCHOOL.CITY'
,p_message_text=>'City'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1789105875574689)
,p_name=>'ODG.BUILTINS.SCHOOL.DOMAIN'
,p_message_text=>'Domain'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1789441865574689)
,p_name=>'ODG.BUILTINS.SCHOOL.INSTITUTION_NAME'
,p_message_text=>'Institution Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1789714513574689)
,p_name=>'ODG.BUILTINS.SCHOOL.INSTURL'
,p_message_text=>'Institution Uniform Resource Locator'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1790000865574689)
,p_name=>'ODG.BUILTINS.SCHOOL.STATE'
,p_message_text=>'State'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801450513574695)
,p_name=>'ODG.BUILTINS.STATUS'
,p_message_text=>'Status'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1790376836574690)
,p_name=>'ODG.BUILTINS.STATUS.CODE'
,p_message_text=>'Code'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1790690582574690)
,p_name=>'ODG.BUILTINS.STATUS.DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1790988596574690)
,p_name=>'ODG.BUILTINS.STATUS.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1505331958189680)
,p_name=>'ODG.CUSTOM.BUILTIN_CATEGORY'
,p_message_text=>'Custom'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1500270644955042)
,p_name=>'ODG.DATA_SOURCE'
,p_message_text=>'Data Source'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1501163099008649)
,p_name=>'ODG.DATA_SOURCE.SUB_TEXT'
,p_message_text=>'Reference an existing data source'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2864528425368065)
,p_name=>'ODG.ERROR.MISSING_NUM_ROWS'
,p_message_text=>'Please specify number of rows for the following table(s): %0'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2866137055431896)
,p_name=>'ODG.ERROR.SELECT_A_TABLE'
,p_message_text=>'Please select at least one table to create a blueprint'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1499408526912140)
,p_name=>'ODG.FORMULA'
,p_message_text=>'Formula'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1504065044154238)
,p_name=>'ODG.FORMULA.DISPLAY_NAME'
,p_message_text=>'Custom Formula'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1500559702979282)
,p_name=>'ODG.FORMULA.SUB_TEXT'
,p_message_text=>'Apply a pl/sql formula'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1500091332952076)
,p_name=>'ODG.INLINE'
,p_message_text=>'Inline'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1504249014166608)
,p_name=>'ODG.INLINE.DISPLAY_NAME'
,p_message_text=>'Static Values'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1500907384986027)
,p_name=>'ODG.INLINE.SUB_TEXT'
,p_message_text=>'Define a list of static values'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15935090116484175)
,p_name=>'ODG.MESSAGE.INSERTED_DATA'
,p_message_text=>'Successfully inserted data into the database.'
,p_is_js_message=>true
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15636011728421299)
,p_name=>'ODG.MESSAGE.INVALID_ROWS'
,p_message_text=>'Please specify number of rows for the following tables: %0'
,p_is_js_message=>true
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4007316058645678)
,p_name=>'ODG.MESSAGE.MAX_RECORDS_TABLES'
,p_message_text=>'You can only choose %0 tables to generate a blueprint (additional tables can be added afterwards).'
,p_is_js_message=>true
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2705046750504313)
,p_name=>'ODG.MESSAGE.NO_TABLES'
,p_message_text=>'This blueprint has no tables'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2905800435939386)
,p_name=>'ODG.MESSAGE.NUM_OF_TABLES'
,p_message_text=>'%0 Tables'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15636342459423991)
,p_name=>'ODG.MESSAGE.SELECT_ONE_TABLE'
,p_message_text=>'Please select at least one table to create a blueprint'
,p_is_js_message=>true
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2700705025487560)
,p_name=>'ODG.MESSAGE.TABLE'
,p_message_text=>'%0 Table'
,p_version_scn=>37165770887517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1499828830945996)
,p_name=>'ODG.SEQUENCE'
,p_message_text=>'Sequence'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1500717065982591)
,p_name=>'ODG.SEQUENCE.SUB_TEXT'
,p_message_text=>'Apply an increasing sequence'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600457228435906)
,p_name=>'ODG.TABLE.INVALID'
,p_message_text=>'INVALID'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001151883486668)
,p_name=>'ODG.TABLE.INVALID.TOOLTIP'
,p_message_text=>'Table has no columns'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2500965629434840)
,p_name=>'ODG.TABLE.VALID'
,p_message_text=>'VALID'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3000960637485400)
,p_name=>'ODG.TABLE.VALID.TOOLTIP'
,p_message_text=>'Table is valid'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26543532244014911)
,p_name=>'ONE'
,p_message_text=>'One'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14631124885639585)
,p_name=>'ONLY_INSTALLED'
,p_message_text=>'Only Installed'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108525732213762806)
,p_name=>'ON_LOAD'
,p_message_text=>'On Load'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173213731632360942)
,p_name=>'OPEN'
,p_message_text=>'Open'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2802522333583038)
,p_name=>'OPENAPI.EMPTY_DOCUMENT'
,p_message_text=>'The OpenAPI file has no content.'
,p_version_scn=>37166027539575
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2802280705569579)
,p_name=>'OPENAPI.NOT_VALID_JSON'
,p_message_text=>'This is not a valid JSON file.'
,p_version_scn=>26077370
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2802876211585467)
,p_name=>'OPENAPI.NOT_VALID_OPENAPI'
,p_message_text=>'This is not a valid OpenAPI file.'
,p_version_scn=>26077370
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2803167279591228)
,p_name=>'OPENAPI.NO_SUPPORTED_VERSION'
,p_message_text=>'OpenAPI version "%0 %1" is not supported. Supported versions are OpenAPI 3.0.x and Swagger 2.0.'
,p_version_scn=>37166014166001
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192598123164183632)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_text=>'Opened Last 7 Days'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192129623256430108)
,p_name=>'OPEN_BUGS'
,p_message_text=>'Open Bugs'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192128509750426279)
,p_name=>'OPEN_FEATURES'
,p_message_text=>'Open Features'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(435245015812908931)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_text=>'Open, processing feedback'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192129218408428750)
,p_name=>'OPEN_TO_DOS'
,p_message_text=>'Open To Do''s'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166185026541535805)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_text=>'Optional Attribute'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1513250230627843206)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_text=>'Optional Icon CSS Classes'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166184622731534708)
,p_name=>'OPTIONAL IMAGE'
,p_message_text=>'Optional Image'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166185430004536893)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_text=>'Optional Image Attributes'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455019119293922509)
,p_name=>'ORACLE FORMS'
,p_message_text=>'Oracle Forms'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(666133781176529317)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_text=>'Oracle REST Data Services based printing has been deprecated in Oracle APEX 19.1 and is no longer supported.'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7692428705339319)
,p_name=>'OTHER'
,p_message_text=>'Other'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455023626659981446)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_text=>'Other Workspace Files'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(186776030704706563)
,p_name=>'OTN'
,p_message_text=>'Oracle Technology Network'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(186776317675712235)
,p_name=>'OTN_FORUM'
,p_message_text=>'Oracle Technology Network Discussion Forum'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(315870832094573501)
,p_name=>'OVERRIDE_ID'
,p_message_text=>'Override ID'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(973673712723317745)
,p_name=>'OVERVIEW'
,p_message_text=>'Overview'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86588116098230549)
,p_name=>'OWNER'
,p_message_text=>'Owner'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18541915334657499)
,p_name=>'OWNERS'
,p_message_text=>'Owners'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149966512286311617)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_text=>'SQL Query Function. Body'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244191924806256498)
,p_name=>'P4001_APPLICATION'
,p_message_text=>'Application %0'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73991322077001182)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_text=>'This LOV can not be deleted. It is used on page(s) %0.'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194637622608734038)
,p_name=>'P4316_BIND_ITEM'
,p_message_text=>'Bind Item (enter item name)'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(686165989832446094)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_text=>'May need refresh.'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(702771907851168518)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_text=>'Add Deployment Server'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156271715527433051)
,p_name=>'P58_BROWSE_SEQ'
,p_message_text=>'Browse Database Links'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155470212935120076)
,p_name=>'P58_NO_SUCCESS'
,p_message_text=>'The create database link operation was not successful for the following reason:'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155479504755127193)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_text=>'The database link "%0" has been created in the "%1" schema.'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88049412284583760)
,p_name=>'PACKAGE'
,p_message_text=>'package'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139562209188305123)
,p_name=>'PACKAGED_APPLICATION'
,p_message_text=>'Productivity or Sample Application'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21513829710621136)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_text=>'Productivity and Sample Apps'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(279567304759011227)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_text=>'Error during the Application installation.'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150997017215904948)
,p_name=>'PACKAGE_BODY'
,p_message_text=>'Package Body'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(249524124270303772)
,p_name=>'PACKAGE_GLOBALS'
,p_message_text=>'-Global-'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86628423436412442)
,p_name=>'PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192778403046063078)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_text=>'Page Computation Condition'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(272640503680865488)
,p_name=>'PAGE HEADER'
,p_message_text=>'Page Header'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190185117782876810)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_text=>'Page Header, Body, and Footer'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192779804908073061)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_text=>'Page Item Default'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192780621185077766)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_text=>'Page Item Display Condition'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192781405386082608)
,p_name=>'PAGE ITEM LOV'
,p_message_text=>'Page Item List of Values'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192780213220075447)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_text=>'Page Item Post Computation'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192781029150080083)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_text=>'Page Item Read-Only Display Condition'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192779225209069433)
,p_name=>'PAGE ITEM SOURCE'
,p_message_text=>'Page Item Source'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152089218374264621)
,p_name=>'PAGE ITEMS'
,p_message_text=>'Page Items'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190197017051923954)
,p_name=>'PAGE PROCESS'
,p_message_text=>'Page Process'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190199109564931278)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_text=>'Page Process Condition'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192778812396065725)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_text=>'Page Validation Condition'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160743431151264924)
,p_name=>'PAGES'
,p_message_text=>'pages'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358908113743818687)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_text=>'Page Attributes'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184178201050159487)
,p_name=>'PAGE_EVENTS'
,p_message_text=>'Page Events'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203661826644664498)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_text=>'Page events: %0'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1638412628606833633)
,p_name=>'PAGE_FINDER'
,p_message_text=>'Page Finder'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5148603366407413)
,p_name=>'PAGE_GROUP'
,p_message_text=>'Page Group'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203483505331878042)
,p_name=>'PAGE_HELP'
,p_message_text=>'Identifies page within application.'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(374309830874467510)
,p_name=>'PAGE_ID_LOCKED'
,p_message_text=>'Page %0 locked'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(374310028070468753)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_text=>'Page %0 unlocked'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(219201531915710776)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_text=>'Application page successfully installed.'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152469129024986832)
,p_name=>'PAGE_ITEM'
,p_message_text=>'page item'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(335825829313229545)
,p_name=>'PAGE_LABEL'
,p_message_text=>'Page: %0'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179920608803093260)
,p_name=>'PAGE_LOCKED'
,p_message_text=>'Page Locked'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137957215723996593)
,p_name=>'PAGE_LOCKED_BY'
,p_message_text=>'Page locked by %0'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185745220575226518)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_text=>'page name is required for all pages'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1720071725524131)
,p_name=>'PAGE_PATTERN'
,p_message_text=>'Page Pattern'
,p_version_scn=>148593687
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184177618581155083)
,p_name=>'PAGE_POSTS'
,p_message_text=>'Page Posts'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358909929242842018)
,p_name=>'PAGE_PROCESSES'
,p_message_text=>'Page Processes'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18836825159673575)
,p_name=>'PAGE_PROCESSING'
,p_message_text=>'Page Processing'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204381422135762354)
,p_name=>'PAGE_PROTECTION'
,p_message_text=>'Page Protection'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87115503012182392)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_text=>'Sequence'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87117322059187952)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_text=>'Target'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87116415479186021)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_text=>'Text'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87114003574173164)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87115117080177017)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_text=>'List Template'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87106324090160136)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_text=>'Hide Source'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87105109545155925)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_text=>'Show Source'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87101410322137176)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_text=>'Item'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87100518156129995)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_text=>'Tree Name'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87101824521141279)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_text=>'Tree Query'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87101032008134006)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_text=>'Type'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44734020311867636)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_text=>'Page %0 has been created successfully.'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190184223191868901)
,p_name=>'PAGE_TEMPLATE'
,p_message_text=>'Page Template'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(55641346905813552)
,p_name=>'PAGE_TYPE.UNKNOWN'
,p_message_text=>'Unknown'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179921932352100007)
,p_name=>'PAGE_UNLOCKED'
,p_message_text=>'Page Unlocked'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184177925853157210)
,p_name=>'PAGE_VIEWS'
,p_message_text=>'Page Views'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183997909691610457)
,p_name=>'PARENT_FEATURE_ID'
,p_message_text=>'Parent Feature Number'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270940232252568071)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_text=>'Parent report column'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455036706339183679)
,p_name=>'PARENT_TAB'
,p_message_text=>'Parent Tab'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(454858917508067627)
,p_name=>'PARENT_TABS'
,p_message_text=>'Parent Tabs'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86848603434737818)
,p_name=>'PARENT_TAB_SET'
,p_message_text=>'Parent Tab Set'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86850007936739163)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_text=>'Parent Tab Set New'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86852925251744090)
,p_name=>'PARENT_TAB_TEXT'
,p_message_text=>'Parent Tab Text'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455015619546865809)
,p_name=>'PARRENT_TAB_SET'
,p_message_text=>'Parent Tab Set'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19806830869044005)
,p_name=>'PARSING_SCHEMA'
,p_message_text=>'Parsing Schema'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18837005897677509)
,p_name=>'PARTIAL_PAGE'
,p_message_text=>'Partial Page'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12449711392787388)
,p_name=>'PASSWORD_EXPIRED'
,p_message_text=>'Password Expired'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8161512663886891)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_text=>'The password for this account must be changed.'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12449306890786107)
,p_name=>'PASSWORD_VALID'
,p_message_text=>'Password Valid'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15612005707643326)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_text=>'Password (submits when Enter pressed)'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236565419287619520)
,p_name=>'PAST_DUE'
,p_message_text=>'Past Due'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(324312510471121399)
,p_name=>'PATH'
,p_message_text=>'Path'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485079930697983669)
,p_name=>'PCT_CLOSED'
,p_message_text=>'% Closed'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484232425755064936)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_text=>'Graphical formatting for percentages, whole numbers between 0 and 100'
,p_version_scn=>37165770887518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645810060661030)
,p_name=>'PE.COMPONEN.TYPE.ACL_ROLE.PLURAL'
,p_message_text=>'Roles'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645985412661030)
,p_name=>'PE.COMPONEN.TYPE.ACL_ROLE.SINGULAR'
,p_message_text=>'Role'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380847448376067216)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_text=>'Applications'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380847587300067216)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_text=>'Application'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599366231624282032)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_text=>'Application Computations'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599366336991282034)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_text=>'Application Computation'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645466350661028)
,p_name=>'PE.COMPONEN.TYPE.APP_GROUP.PLURAL'
,p_message_text=>'Application Groups'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645557046661028)
,p_name=>'PE.COMPONEN.TYPE.APP_GROUP.SINGULAR'
,p_message_text=>'Application Group'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380849426619067219)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_text=>'Application Items'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380849529356067220)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_text=>'Application Item'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599366447122282035)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_text=>'Application Processes'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599366539824282035)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_text=>'Application Process'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647666689661032)
,p_name=>'PE.COMPONEN.TYPE.APP_SETTING.PLURAL'
,p_message_text=>'Application Settings'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647739988661033)
,p_name=>'PE.COMPONEN.TYPE.APP_SETTING.SINGULAR'
,p_message_text=>'Application Setting'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645651497661028)
,p_name=>'PE.COMPONEN.TYPE.APP_SUBSTITUTION.PLURAL'
,p_message_text=>'Substitutions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645792700661028)
,p_name=>'PE.COMPONEN.TYPE.APP_SUBSTITUTION.SINGULAR'
,p_message_text=>'Substitution'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850271886067221)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_text=>'Authentications'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850330705067221)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_text=>'Authentication'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242644680215661027)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION_SERVER.PLURAL'
,p_message_text=>'Authentication Servers'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242644717274661027)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION_SERVER.SINGULAR'
,p_message_text=>'Authentication Server'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850460126067221)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_text=>'Authorizations'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850593484067221)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_text=>'Authorization'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548442554495181150)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_text=>'Automations'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548442885930181158)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_text=>'Automation'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(766619366320245968)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_text=>'Actions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(766619459258245972)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_text=>'Action'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649258031661036)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_WS_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649383875661036)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_WS_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854461871067231)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_text=>'Branches'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854542220067231)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_text=>'Branch'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850639431067222)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_text=>'Breadcrumbs'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850792517067222)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599366634693282036)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_text=>'Entries'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599366726290282036)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_text=>'Entry'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848872546067219)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_text=>'Breadcrumb Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848995722067219)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_text=>'Breadcrumb Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563788173500486)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE_OPTION.PLURAL'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563885307500486)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE_OPTION.SINGULAR'
,p_message_text=>'Template Option'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850063803067221)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_text=>'Build Options'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850147968067221)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_text=>'Build Option'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380853207726067227)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_text=>'Buttons'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380853377348067229)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_text=>'Button'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848404125067218)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_text=>'Button Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848549123067218)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_text=>'Button Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563315572500486)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE_OPTION.PLURAL'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563435005500486)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE_OPTION.SINGULAR'
,p_message_text=>'Template Option'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380849085006067219)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_text=>'Legacy Calendar Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380849145219067219)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_text=>'Legacy Calendar Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596930282431296467)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596930372199296471)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596930406690296471)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_text=>'Actions'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596930552974296471)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_text=>'Action'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388944156512781282)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388944262139781284)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647884627661033)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_NAV_BAR.PLURAL'
,p_message_text=>'Classic Navigation Bar Entries'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647905103661033)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_NAV_BAR.SINGULAR'
,p_message_text=>'Classic Navigation Bar Entry'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380856431944067234)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380856589563067234)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380856696392067234)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380856733574067235)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033281681271629)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_text=>'Printing'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033351445271630)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_text=>'Printing'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10575349816340668)
,p_name=>'PE.COMPONEN.TYPE.COMPONENT_GROUP.PLURAL'
,p_message_text=>'Component Groups'
,p_version_scn=>49870222
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10575445674340673)
,p_name=>'PE.COMPONEN.TYPE.COMPONENT_GROUP.SINGULAR'
,p_message_text=>'Component Group'
,p_version_scn=>49870224
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143561706963500483)
,p_name=>'PE.COMPONEN.TYPE.COMPONENT_TYPE.PLURAL'
,p_message_text=>'Component Types'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143561805784500483)
,p_name=>'PE.COMPONEN.TYPE.COMPONENT_TYPE.SINGULAR'
,p_message_text=>'Component Type'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10575530093340673)
,p_name=>'PE.COMPONEN.TYPE.COMP_GRP_COMPONENT.PLURAL'
,p_message_text=>'Components'
,p_version_scn=>49870224
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10575688629340673)
,p_name=>'PE.COMPONEN.TYPE.COMP_GRP_COMPONENT.SINGULAR'
,p_message_text=>'Component'
,p_version_scn=>49870224
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649891052661036)
,p_name=>'PE.COMPONEN.TYPE.CONCATENATED_FILE.PLURAL'
,p_message_text=>'Concatenated Files'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649937489661037)
,p_name=>'PE.COMPONEN.TYPE.CONCATENATED_FILE.SINGULAR'
,p_message_text=>'Concatenated File'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242644448801661023)
,p_name=>'PE.COMPONEN.TYPE.CREDENTIAL.PLURAL'
,p_message_text=>'Web Credentials'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242644524377661026)
,p_name=>'PE.COMPONEN.TYPE.CREDENTIAL.SINGULAR'
,p_message_text=>'Web Credential'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(578420042366254816)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_text=>'Data Load Definitions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(578420171352254818)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_text=>'Data Load Definition'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648451256661035)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEF_DATA_PROFILE.PLURAL'
,p_message_text=>'Data Profiles'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648511918661035)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEF_DATA_PROFILE.SINGULAR'
,p_message_text=>'Data Profile'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648698616661035)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEF_DATA_PROFILE_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648767686661035)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEF_DATA_PROFILE_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380851855108067224)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_text=>'Legacy Data Load Definitions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380851957096067224)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_text=>'Legacy Data Load Definition'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380853627173067229)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_text=>'Actions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380853723593067229)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_text=>'Action'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380853429361067229)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_text=>'Dynamic Actions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380853536116067229)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_text=>'Dynamic Action'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649636398661036)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_TRANSLATION.PLURAL'
,p_message_text=>'Dynamic Translations'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649740756661036)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_TRANSLATION.SINGULAR'
,p_message_text=>'Dynamic Translation'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110205764918413219)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_text=>'Email Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110205816584413215)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_text=>'Email Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199017444213921)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_text=>'Facets'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199165264213924)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_text=>'Facet'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(583694215041746696)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_text=>'Facet Groups'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(583694538177746697)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_text=>'Facet Group'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(583694859890746698)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_text=>'Checkboxes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(583695156528746698)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_text=>'Checkbox'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848296539067217)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_text=>'Field Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848385205067218)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_text=>'Field Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563101794500486)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE_OPTION.PLURAL'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563291421500486)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE_OPTION.SINGULAR'
,p_message_text=>'Template Option'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221600157410260086)
,p_name=>'PE.COMPONEN.TYPE.FILE.PLURAL'
,p_message_text=>'File Servers'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221600242078260086)
,p_name=>'PE.COMPONEN.TYPE.FILE.SINGULAR'
,p_message_text=>'File Server'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1716615953312501)
,p_name=>'PE.COMPONEN.TYPE.GENERATIVE_AI.PLURAL'
,p_message_text=>'Generative AI Services'
,p_version_scn=>972216747
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1716706810312499)
,p_name=>'PE.COMPONEN.TYPE.GENERATIVE_AI.SINGULAR'
,p_message_text=>'Generative AI Service'
,p_version_scn=>972216748
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562349470500485)
,p_name=>'PE.COMPONEN.TYPE.GLOBAL_TEMPLATE_OPTION.PLURAL'
,p_message_text=>'Global Template Options'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562468179500485)
,p_name=>'PE.COMPONEN.TYPE.GLOBAL_TEMPLATE_OPTION.SINGULAR'
,p_message_text=>'Global Template Option'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245970246961480576)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245970308815480576)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245970680444480577)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245970784890480577)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245970451847480577)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_text=>'Column Groups'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245970577609480577)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_text=>'Column Group'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245970866783480578)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_text=>'Printing'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245970999047480578)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_text=>'Printing'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596143933205244652)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_text=>'Saved Reports'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596145674245264347)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_text=>'Saved Report'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854643270067231)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854757453067231)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855268965067232)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855322003067232)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969589323250158)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_ACTION.PLURAL'
,p_message_text=>'Actions'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969667719250158)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_ACTION.SINGULAR'
,p_message_text=>'Action'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969722948250158)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_ACTION_MENU_ENTRY.PLURAL'
,p_message_text=>'Menus'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969890818250158)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_ACTION_MENU_ENTRY.SINGULAR'
,p_message_text=>'Menu'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855053502067232)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_text=>'Column Groups'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855109509067232)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_text=>'Column Group'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033015118271627)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_text=>'Printing'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033151883271628)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_text=>'Printing'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854840630067231)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_text=>'Saved Reports'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854908075067231)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_text=>'Saved Report'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(291855191788771966)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(291855295101772755)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(291854970250767444)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_text=>'Axes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(291855043510769004)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_text=>'Axis'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(291855451563783357)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_text=>'Series'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(291855577151784093)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_text=>'Series'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(719156225296365060)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(719156360733365062)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649415841661036)
,p_name=>'PE.COMPONEN.TYPE.LANGUAGE_MAP.PLURAL'
,p_message_text=>'Language Mappings'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649544904661036)
,p_name=>'PE.COMPONEN.TYPE.LANGUAGE_MAP.SINGULAR'
,p_message_text=>'Language Mapping'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850857629067222)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_text=>'Lists'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380850965830067222)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_text=>'List'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599366890411282036)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_text=>'Entries'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599366943819282036)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_text=>'Entry'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848621703067218)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_text=>'List Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848722576067218)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_text=>'List Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563526740500486)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE_OPTION.PLURAL'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563673717500486)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE_OPTION.SINGULAR'
,p_message_text=>'Template Option'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380851002400067222)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_text=>'Lists of Values'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380851119199067223)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_text=>'List of Values'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648067956661033)
,p_name=>'PE.COMPONEN.TYPE.LOV_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648122824661034)
,p_name=>'PE.COMPONEN.TYPE.LOV_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367037128282037)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_text=>'Entries'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367172961282037)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_text=>'Entry'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648224571661034)
,p_name=>'PE.COMPONEN.TYPE.LOV_WS_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648393640661034)
,p_name=>'PE.COMPONEN.TYPE.LOV_WS_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139863800776148456)
,p_name=>'PE.COMPONEN.TYPE.MAP_BACKGROUND.PLURAL'
,p_message_text=>'Map Backgrounds'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139863920488148457)
,p_name=>'PE.COMPONEN.TYPE.MAP_BACKGROUND.SINGULAR'
,p_message_text=>'Map Background'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563413873945648480)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_text=>'Layers'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563413967449648480)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_text=>'Layer'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563414045129648480)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563414150662648480)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563413672809648474)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563413756081648480)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380852603159067226)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_text=>'Pages'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380852752961067227)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_text=>'Page'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854088927067230)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_text=>'Computations'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854105442067230)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_text=>'Computation'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380852425855067226)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_text=>'Page Groups'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380852529517067226)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_text=>'Page Group'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147761959503874632)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_text=>'Page Items'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147762000653874624)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_text=>'Page Item'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126954028481510952)
,p_name=>'PE.COMPONEN.TYPE.PAGE_META_TAG.PLURAL'
,p_message_text=>'Meta Tags'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126954194380510952)
,p_name=>'PE.COMPONEN.TYPE.PAGE_META_TAG.SINGULAR'
,p_message_text=>'Meta Tag'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2095020119401543)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PATTERN.PLURAL'
,p_message_text=>'Page Patterns'
,p_version_scn=>153063392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2095156427401542)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PATTERN.SINGULAR'
,p_message_text=>'Page Pattern'
,p_version_scn=>153063392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854229027067230)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_text=>'Processes'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380854310969067230)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_text=>'Process'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130191878492982608)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_INVOKE_API_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130191954016982608)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_INVOKE_API_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650824737661043)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_TASK_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650916067661043)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_TASK_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115816178068908804)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WF_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115816411464908804)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WF_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35133863041835473)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35133933061835474)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855898434067233)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_text=>'Basic Authentication Parameters'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855945556067233)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_text=>'Basic Authentication Parameter'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855462576067232)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_text=>'In Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855548053067233)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_text=>'In Parameter'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855684213067233)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_text=>'Out Parameters'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380855739460067233)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_text=>'Out Parameter'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380847833776067217)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_text=>'Page Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380847976586067217)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_text=>'Page Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565911579500495)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE_DISPLAY_POINT.PLURAL'
,p_message_text=>'Slots'
,p_version_scn=>92000930
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566037331500495)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE_DISPLAY_POINT.SINGULAR'
,p_message_text=>'Slot'
,p_version_scn=>92000930
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562762985500486)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE_OPTION.PLURAL'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562896092500486)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE_OPTION.SINGULAR'
,p_message_text=>'Template Option'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367602181282043)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_text=>'Plugins'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367702009282043)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_text=>'Plugin'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564900952500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_ACTION_POSITION.PLURAL'
,p_message_text=>'Action Positions'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565025070500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_ACTION_POSITION.SINGULAR'
,p_message_text=>'Action Position'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565155121500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_ACTION_TEMPLATE.PLURAL'
,p_message_text=>'Action Templates'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565261673500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_ACTION_TEMPLATE.SINGULAR'
,p_message_text=>'Action Template'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564363615500493)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_ATTRIBUTE_GROUP.PLURAL'
,p_message_text=>'Attribute Groups'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564489418500493)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_ATTRIBUTE_GROUP.SINGULAR'
,p_message_text=>'Attribute Group'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564757120500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_ATTRIBUTE_LOV_ENTRY.PLURAL'
,p_message_text=>'Entries'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564835760500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_ATTRIBUTE_LOV_ENTRY.SINGULAR'
,p_message_text=>'Entry'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564572094500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_CUSTOM_ATTRIBUTE.PLURAL'
,p_message_text=>'Custom Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564610953500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_CUSTOM_ATTRIBUTE.SINGULAR'
,p_message_text=>'Custom Attribute'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565360752500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_EVENT.PLURAL'
,p_message_text=>'Events'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565484441500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_EVENT.SINGULAR'
,p_message_text=>'Event'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565572434500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_FILE.PLURAL'
,p_message_text=>'Files'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565622217500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_FILE.SINGULAR'
,p_message_text=>'File'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565711528500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_SETTING.PLURAL'
,p_message_text=>'Component Settings'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143565868208500494)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_SETTING.SINGULAR'
,p_message_text=>'Component Setting'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613980604673398)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_SLOT.PLURAL'
,p_message_text=>'Slots'
,p_version_scn=>91991067
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614077985673398)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_SLOT.SINGULAR'
,p_message_text=>'Slot'
,p_version_scn=>91991067
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564171567500493)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_STD_ATTRIBUTE.PLURAL'
,p_message_text=>'Standard Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564293671500493)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN_STD_ATTRIBUTE.SINGULAR'
,p_message_text=>'Standard Attribute'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175598718459484179)
,p_name=>'PE.COMPONEN.TYPE.POPUP_LOV_TEMPLATE.PLURAL'
,p_message_text=>'Popup LOV Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175598817979484179)
,p_name=>'PE.COMPONEN.TYPE.POPUP_LOV_TEMPLATE.SINGULAR'
,p_message_text=>'Popup LOV Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242644866340661027)
,p_name=>'PE.COMPONEN.TYPE.PRINT_SERVER.PLURAL'
,p_message_text=>'Print Servers'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242644985447661027)
,p_name=>'PE.COMPONEN.TYPE.PRINT_SERVER.SINGULAR'
,p_message_text=>'Print Server'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126953863053510950)
,p_name=>'PE.COMPONEN.TYPE.PWA_SCREENSHOT.PLURAL'
,p_message_text=>'PWA Screenshots'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126953982803510950)
,p_name=>'PE.COMPONEN.TYPE.PWA_SCREENSHOT.SINGULAR'
,p_message_text=>'PWA Screenshot'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126953622216510950)
,p_name=>'PE.COMPONEN.TYPE.PWA_SHORTCUT.PLURAL'
,p_message_text=>'PWA Shortcuts'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126953730110510950)
,p_name=>'PE.COMPONEN.TYPE.PWA_SHORTCUT.SINGULAR'
,p_message_text=>'PWA Shortcut'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380852843971067227)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_text=>'Regions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380852946230067227)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_text=>'Region'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969161142250158)
,p_name=>'PE.COMPONEN.TYPE.REGION_ACTION.PLURAL'
,p_message_text=>'Actions'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969294428250158)
,p_name=>'PE.COMPONEN.TYPE.REGION_ACTION.SINGULAR'
,p_message_text=>'Action'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969340176250158)
,p_name=>'PE.COMPONEN.TYPE.REGION_ACTION_MENU_ENTRY.PLURAL'
,p_message_text=>'Menus'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969497216250158)
,p_name=>'PE.COMPONEN.TYPE.REGION_ACTION_MENU_ENTRY.SINGULAR'
,p_message_text=>'Menu'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573029772591576526)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573029885672576528)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547999201621318325)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547999323256318329)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848062832067217)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_text=>'Region Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380848105338067217)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_text=>'Region Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562975521500486)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE_OPTION.PLURAL'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563065024500486)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE_OPTION.SINGULAR'
,p_message_text=>'Template Option'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115968935196250154)
,p_name=>'PE.COMPONEN.TYPE.REGION_TMPL_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969004492250154)
,p_name=>'PE.COMPONEN.TYPE.REGION_TMPL_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355260066320719280)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355260135463719281)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152950164190840293)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_text=>'Remote Databases'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152950247623840294)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(168940271614469169)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_ORACLE_DATABASE.PLURAL'
,p_message_text=>'Remote Databases'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(168940335608469179)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_ORACLE_DATABASE.SINGULAR'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489466110875840028)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_text=>'Report Layouts'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489466255858840033)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_text=>'Report Layout'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648838688661035)
,p_name=>'PE.COMPONEN.TYPE.REPORT_QUERY.PLURAL'
,p_message_text=>'Report Queries'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242648968093661035)
,p_name=>'PE.COMPONEN.TYPE.REPORT_QUERY.SINGULAR'
,p_message_text=>'Report Query'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649004989661035)
,p_name=>'PE.COMPONEN.TYPE.REPORT_QUERY_STATEMENT.PLURAL'
,p_message_text=>'Source Queries'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242649156834661035)
,p_name=>'PE.COMPONEN.TYPE.REPORT_QUERY_STATEMENT.SINGULAR'
,p_message_text=>'Source Query'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380849233309067219)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_text=>'Classic Report Templates'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380849326604067219)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_text=>'Classic Report Template'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143563910332500487)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE_OPTION.PLURAL'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143564003345500487)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE_OPTION.SINGULAR'
,p_message_text=>'Template Option'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645036050661027)
,p_name=>'PE.COMPONEN.TYPE.REST_SERVER.PLURAL'
,p_message_text=>'REST Data Source Servers'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645175073661027)
,p_name=>'PE.COMPONEN.TYPE.REST_SERVER.SINGULAR'
,p_message_text=>'REST Data Source Server'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115304829247300259)
,p_name=>'PE.COMPONEN.TYPE.SEARCH_CONFIG.PLURAL'
,p_message_text=>'Search Configurations'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115304928853300260)
,p_name=>'PE.COMPONEN.TYPE.SEARCH_CONFIG.SINGULAR'
,p_message_text=>'Search Configuration'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78519182825696015)
,p_name=>'PE.COMPONEN.TYPE.SEARCH_CONFIG_WS_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78519212422696016)
,p_name=>'PE.COMPONEN.TYPE.SEARCH_CONFIG_WS_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115305071351300272)
,p_name=>'PE.COMPONEN.TYPE.SEARCH_REGION_SOURCES.PLURAL'
,p_message_text=>'Search Sources'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115305175531300272)
,p_name=>'PE.COMPONEN.TYPE.SEARCH_REGION_SOURCES.SINGULAR'
,p_message_text=>'Search Source'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136506399697670846)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_text=>'Filters'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136506491603670844)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_text=>'Filter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136506564046670843)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_text=>'Filter Groups'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136506601820670843)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_text=>'Filter Group'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136506783409670843)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_text=>'Checkboxes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136506855550670843)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_text=>'Checkbox'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367254150282043)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_text=>'Shortcuts'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367318697282043)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_text=>'Shortcut'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647287154661032)
,p_name=>'PE.COMPONEN.TYPE.STATIC_APPLICATION_FILE.PLURAL'
,p_message_text=>'Static Application Files'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647325675661032)
,p_name=>'PE.COMPONEN.TYPE.STATIC_APPLICATION_FILE.SINGULAR'
,p_message_text=>'Static Application File'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645212301661027)
,p_name=>'PE.COMPONEN.TYPE.STATIC_WORKSPACE_FILE.PLURAL'
,p_message_text=>'Static Workspace Files'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242645386048661027)
,p_name=>'PE.COMPONEN.TYPE.STATIC_WORKSPACE_FILE.SINGULAR'
,p_message_text=>'Static Workspace File'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651073055661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS.PLURAL'
,p_message_text=>'Supporting Object'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651120112661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS.SINGULAR'
,p_message_text=>'Supporting Object'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651487075661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_BUILD_OPTION.PLURAL'
,p_message_text=>'Build Options'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651522414661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_BUILD_OPTION.SINGULAR'
,p_message_text=>'Build Option'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651855349661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_INSTALL.PLURAL'
,p_message_text=>'Install Scripts'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651987436661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_INSTALL.SINGULAR'
,p_message_text=>'Install Script'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651204881661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_SUBSTITUTION.PLURAL'
,p_message_text=>'Substitutions'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651396878661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_SUBSTITUTION.SINGULAR'
,p_message_text=>'Substitution'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(288342375008248321)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_UPGRADE.PLURAL'
,p_message_text=>'Upgrade Scripts'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(288342451671248321)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_UPGRADE.SINGULAR'
,p_message_text=>'Upgrade Script'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651639367661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_VALIDATION.PLURAL'
,p_message_text=>'Validations'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242651780167661044)
,p_name=>'PE.COMPONEN.TYPE.SUPPORT_OBJECTS_VALIDATION.SINGULAR'
,p_message_text=>'Validation'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380852020608067224)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_text=>'Standard Tab Sets'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380852151546067224)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_text=>'Standard Tab Set'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380951986975062006)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380952041969062006)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380974278132206736)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380974333310206736)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033461977271630)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_text=>'Printing'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033592263271631)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_text=>'Printing'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650050932661037)
,p_name=>'PE.COMPONEN.TYPE.TASK_DEF.PLURAL'
,p_message_text=>'Task Definitions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650171009661037)
,p_name=>'PE.COMPONEN.TYPE.TASK_DEF.SINGULAR'
,p_message_text=>'Task Definition'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650469691661037)
,p_name=>'PE.COMPONEN.TYPE.TASK_DEF_ACTION.PLURAL'
,p_message_text=>'Actions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650593783661037)
,p_name=>'PE.COMPONEN.TYPE.TASK_DEF_ACTION.SINGULAR'
,p_message_text=>'Action'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650223490661037)
,p_name=>'PE.COMPONEN.TYPE.TASK_DEF_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650389300661037)
,p_name=>'PE.COMPONEN.TYPE.TASK_DEF_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650603617661037)
,p_name=>'PE.COMPONEN.TYPE.TASK_DEF_PARTICIPANT.PLURAL'
,p_message_text=>'Participants'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242650786859661037)
,p_name=>'PE.COMPONEN.TYPE.TASK_DEF_PARTICIPANT.SINGULAR'
,p_message_text=>'Participant'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562549509500485)
,p_name=>'PE.COMPONEN.TYPE.TEMPLATE_OPTION_GROUP.PLURAL'
,p_message_text=>'Template Option Groups'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562653094500485)
,p_name=>'PE.COMPONEN.TYPE.TEMPLATE_OPTION_GROUP.SINGULAR'
,p_message_text=>'Template Option Group'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647407084661032)
,p_name=>'PE.COMPONEN.TYPE.TEXT_MESSAGE.PLURAL'
,p_message_text=>'Text Messages'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647560116661032)
,p_name=>'PE.COMPONEN.TYPE.TEXT_MESSAGE.SINGULAR'
,p_message_text=>'Text Message'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380847664075067217)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_text=>'Themes'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380847739032067217)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_text=>'Theme'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143561965982500485)
,p_name=>'PE.COMPONEN.TYPE.THEME_FILE.PLURAL'
,p_message_text=>'Files'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562082578500485)
,p_name=>'PE.COMPONEN.TYPE.THEME_FILE.SINGULAR'
,p_message_text=>'File'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562173597500485)
,p_name=>'PE.COMPONEN.TYPE.THEME_STYLE.PLURAL'
,p_message_text=>'Styles'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143562278830500485)
,p_name=>'PE.COMPONEN.TYPE.THEME_STYLE.SINGULAR'
,p_message_text=>'Style'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367490430282043)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_text=>'Trees'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367582834282043)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_text=>'Tree'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380853815586067229)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_text=>'Validations'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380853946570067230)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_text=>'Validation'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380851279154067223)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_text=>'Web Service References'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380851377756067223)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_text=>'Web Service Reference'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380851443481067223)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_text=>'Operations'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380851502145067223)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_text=>'Operation'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(736663718377285606)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_text=>'Basic Authentication Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(736663859572285607)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_text=>'Basic Authentication Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(736663993219285607)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_text=>'HTTP Header Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(736664041752285607)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_text=>'HTTP Header Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(736663373107285605)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_text=>'In Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(736663417051285605)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_text=>'In Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(736663529781285605)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_text=>'Out Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(736663689585285606)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_text=>'Out Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705320862622677)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_ARRAY_COLUMN.PLURAL'
,p_message_text=>'Array Columns'
,p_version_scn=>25819052
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705427294622684)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_ARRAY_COLUMN.SINGULAR'
,p_message_text=>'Array Column'
,p_version_scn=>25819057
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234377928323129163)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_text=>'REST Data Sources'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378043750129164)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_text=>'REST Data Source'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646017605661031)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_DATA_PROFILE.PLURAL'
,p_message_text=>'Data Profiles'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646125482661031)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_DATA_PROFILE.SINGULAR'
,p_message_text=>'Data Profile'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646288304661031)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_DATA_PROFILE_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646389987661031)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_DATA_PROFILE_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355350565581790175)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355350628504790177)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355259633802719264)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_text=>'Operations'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355259710897719265)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_text=>'Operation'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646433550661031)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION_DATA_PROFILE.PLURAL'
,p_message_text=>'Data Profiles'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646597009661031)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION_DATA_PROFILE.SINGULAR'
,p_message_text=>'Data Profile'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646681802661031)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION_DATA_PROFILE_COLUMN.PLURAL'
,p_message_text=>'Columns'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646773790661032)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION_DATA_PROFILE_COLUMN.SINGULAR'
,p_message_text=>'Column'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355350743201790178)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355350895742790178)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355350906406790180)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355351003594790180)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378148444129165)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_text=>'REST Source Query'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378214677129165)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_text=>'REST Source Query'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646816845661032)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_SYNC_STEP.PLURAL'
,p_message_text=>'Synchronization Steps'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242646996715661032)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_SYNC_STEP.SINGULAR'
,p_message_text=>'Synchronization Step'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647086859661032)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_SYNC_STEP_WS_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242647156058661032)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_SYNC_STEP_WS_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115816752613908804)
,p_name=>'PE.COMPONEN.TYPE.WF_ACTIVITY_INVOKE_API_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115817041107908804)
,p_name=>'PE.COMPONEN.TYPE.WF_ACTIVITY_INVOKE_API_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115815504900908803)
,p_name=>'PE.COMPONEN.TYPE.WF_ACTIVITY_TASK_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115815825550908803)
,p_name=>'PE.COMPONEN.TYPE.WF_ACTIVITY_TASK_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115817318073908804)
,p_name=>'PE.COMPONEN.TYPE.WF_ACTIVITY_WS_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115817664361908805)
,p_name=>'PE.COMPONEN.TYPE.WF_ACTIVITY_WS_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115788573136908779)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW.PLURAL'
,p_message_text=>'Workflows'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115788867017908779)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW.SINGULAR'
,p_message_text=>'Workflow'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115790906409908781)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_ACTIVITY.PLURAL'
,p_message_text=>'Activities'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115791212832908781)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_ACTIVITY.SINGULAR'
,p_message_text=>'Activity'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115791593969908781)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_ACTIVITY_VARIABLE.PLURAL'
,p_message_text=>'Activity Variables'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115791894475908781)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_ACTIVITY_VARIABLE.SINGULAR'
,p_message_text=>'Activity Variable'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115792726514908782)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_BRANCH.PLURAL'
,p_message_text=>'Connections'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115793051782908782)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_BRANCH.SINGULAR'
,p_message_text=>'Connection'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115789173957908780)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_PARAM.PLURAL'
,p_message_text=>'Parameters'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115789444641908780)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_PARAM.SINGULAR'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115793321120908782)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_PARTICIPANT.PLURAL'
,p_message_text=>'Participants'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115793699313908783)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_PARTICIPANT.SINGULAR'
,p_message_text=>'Participant'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115792122548908782)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_TRANSITION.PLURAL'
,p_message_text=>'Connections'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115792477581908782)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_TRANSITION.SINGULAR'
,p_message_text=>'Connection'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115790326618908780)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_VARIABLE.PLURAL'
,p_message_text=>'Variables'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115790637558908781)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_VARIABLE.SINGULAR'
,p_message_text=>'Variable'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115789765591908780)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_VERSION.PLURAL'
,p_message_text=>'Versions'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115790062783908780)
,p_name=>'PE.COMPONEN.TYPE.WORKFLOW_VERSION.SINGULAR'
,p_message_text=>'Version'
,p_version_scn=>37166067046315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169240500883151172)
,p_name=>'PE.DISPLAY_GROUP.ACCESSIBILITY'
,p_message_text=>'Accessibility'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360864712507183800)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_text=>'Actions Menu'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653656822661054)
,p_name=>'PE.DISPLAY_GROUP.ACTION_EXECUTION'
,p_message_text=>'Action Execution'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115862556856908846)
,p_name=>'PE.DISPLAY_GROUP.ACTIVITY'
,p_message_text=>'Activity'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(766619501277245987)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_text=>'Additional Code Execution'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263422725418107591)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_DATA'
,p_message_text=>'Additional Data'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123084109448211759)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_text=>'Advanced'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123084415167211760)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_text=>'Affected Elements'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566657492500499)
,p_name=>'PE.DISPLAY_GROUP.AFTER_LIST_ENTRY'
,p_message_text=>'After List Entry'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1716970200312491)
,p_name=>'PE.DISPLAY_GROUP.AI'
,p_message_text=>'Generative AI'
,p_version_scn=>1168865141
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597417768064719)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_text=>'Animation'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085603068211761)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_text=>'Appearance'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655146747661056)
,p_name=>'PE.DISPLAY_GROUP.APP_FORMAT_MASKS'
,p_message_text=>'Application Format Masks'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123082220275211756)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566857736500499)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTE_DESCRIPTIONS'
,p_message_text=>'Attribute Descriptions'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3697288592474)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_text=>'Audit Information'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242652473984661053)
,p_name=>'PE.DISPLAY_GROUP.AUTHENTICATION'
,p_message_text=>'Authentication'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123084211007211759)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_text=>'Authorization'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367964048282054)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(386177255053883105)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_text=>'Automatic Refresh'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654711528661055)
,p_name=>'PE.DISPLAY_GROUP.AVAILABILITY'
,p_message_text=>'Availability'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085527600211761)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_text=>'Behavior'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380731050824495604)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_text=>'BLOB Attributes'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596930895526296482)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_text=>'Body'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380755925454409863)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_text=>'Break Formatting'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(393580156867704545)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_text=>'Calendar State Items'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569017914500500)
,p_name=>'PE.DISPLAY_GROUP.CALLBACKS'
,p_message_text=>'Callbacks'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596930640885296482)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_text=>'Card'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(378538008685881597)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_text=>'Cascading List of Values'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566755011500499)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_STYLE_SHEET'
,p_message_text=>'Cascading Style Sheet'
,p_version_scn=>37166067046327
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655256421661056)
,p_name=>'PE.DISPLAY_GROUP.CHARACTER_VALUE_COMPARISON'
,p_message_text=>'Character Value Comparison'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388640525600170170)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_text=>'Chart'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653392685661054)
,p_name=>'PE.DISPLAY_GROUP.CLICK_COUNTING'
,p_message_text=>'Click Counting'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880516065481481555)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_text=>'Client-side Condition'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175599215052484215)
,p_name=>'PE.DISPLAY_GROUP.CLOSE_BUTTON'
,p_message_text=>'Close Button'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388944789703781304)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_text=>'Colors'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033936009271643)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_text=>'Columns'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488468243851554395)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_text=>'Column Filter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360488709681274642)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_text=>'Column Formatting'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033839446271643)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_text=>'Column Headings'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295596755622064717)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_text=>'Column Mapping'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567298828500499)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_TEMPLATES'
,p_message_text=>'Column Templates'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567384713500500)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_TEMPLATE_1'
,p_message_text=>'Column Template 1'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567465765500500)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_TEMPLATE_2'
,p_message_text=>'Column Template 2'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567573610500500)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_TEMPLATE_3'
,p_message_text=>'Column Template 3'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567651097500500)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_TEMPLATE_4'
,p_message_text=>'Column Template 4'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123082316562211756)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_text=>'Comments'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10580250326400960)
,p_name=>'PE.DISPLAY_GROUP.COMPONENT'
,p_message_text=>'Component'
,p_version_scn=>49879423
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569945555500501)
,p_name=>'PE.DISPLAY_GROUP.COMPONENT_DEFAULTS'
,p_message_text=>'Component Defaults'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569839089500501)
,p_name=>'PE.DISPLAY_GROUP.COMPONENT_LIST_OF_VALUES'
,p_message_text=>'Component List of Values'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570813146500501)
,p_name=>'PE.DISPLAY_GROUP.COMPONENT_TYPE_SUPPORT'
,p_message_text=>'Component Type Support'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123084000969211759)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_text=>'Computation'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115862203554908846)
,p_name=>'PE.DISPLAY_GROUP.CONDITION'
,p_message_text=>'Condition'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123082531109211756)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_text=>'Configuration'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170048423473210)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_text=>'Confirmation'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(403569313608996616)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_text=>'Controls'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123082618224211757)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_text=>'CSS'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150986716901822647)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_text=>'Customization'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569368149500501)
,p_name=>'PE.DISPLAY_GROUP.CUSTOM_ATTRIBUTES'
,p_message_text=>'Custom Attributes'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388944574554781304)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_text=>'Daily & Weekly Calendar'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1408914324498240)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_CREDENTIAL'
,p_message_text=>'Database Credential'
,p_version_scn=>1112210295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599368015323282054)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_text=>'Database Session'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295596610906064716)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_text=>'Data Cursor'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653779557661054)
,p_name=>'PE.DISPLAY_GROUP.DATA_PROFILE'
,p_message_text=>'Data Profile'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114936128532758508)
,p_name=>'PE.DISPLAY_GROUP.DEADLINE'
,p_message_text=>'Deadline'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123084605987211760)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_text=>'Default'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603291600316862)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT_SLOTS'
,p_message_text=>'Default Slots'
,p_version_scn=>100990128
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566278000500499)
,p_name=>'PE.DISPLAY_GROUP.DEFINITION'
,p_message_text=>'Definition'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656010631661056)
,p_name=>'PE.DISPLAY_GROUP.DEINSTALL_MESSAGES'
,p_message_text=>'Deinstallation Messages'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(378537709527881595)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_text=>'Depending On'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360864829648183800)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360864930196183800)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_text=>'Detail View'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(396391920998658574)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_text=>'Dialog'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570154977500501)
,p_name=>'PE.DISPLAY_GROUP.DIALOG_DEFAULTS'
,p_message_text=>'Dialog Defaults'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360865014940183800)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_text=>'Download'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388944897097781304)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_text=>'Drag and Drop'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597327781064719)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_text=>'Dual Y Axes'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245971168171480604)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_text=>'Edit'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373630716604680654)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_text=>'Edit Authorization'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123084711424211760)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_text=>'Element'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245971015560480593)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_text=>'Enable Users To'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242652501971661053)
,p_name=>'PE.DISPLAY_GROUP.ENDPOINT_URL'
,p_message_text=>'Endpoint URL'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115969975011250170)
,p_name=>'PE.DISPLAY_GROUP.ENTITY_TITLE'
,p_message_text=>'Entity Title'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(393924499519510636)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_text=>'Entry'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123082409280211756)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_text=>'Error'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123083009173211758)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_text=>'Error Handling'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568941529500500)
,p_name=>'PE.DISPLAY_GROUP.ERROR_PAGE'
,p_message_text=>'Error Page'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570765127500501)
,p_name=>'PE.DISPLAY_GROUP.ERROR_TEMPLATES'
,p_message_text=>'Error Templates'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569723975500501)
,p_name=>'PE.DISPLAY_GROUP.EXAMPLES'
,p_message_text=>'Examples'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121386420157374991)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION'
,p_message_text=>'Execution'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380443583692583970)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_text=>'Export / Printing'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144040251740306376)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_FILTER_ORDER_BY'
,p_message_text=>'External Filter and Order By'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380756084046409863)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_text=>'External Processing'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571011891500502)
,p_name=>'PE.DISPLAY_GROUP.FEEDBACK'
,p_message_text=>'Feedback'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566348960500499)
,p_name=>'PE.DISPLAY_GROUP.FIELD_CONTAINER'
,p_message_text=>'Field Container'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569475951500501)
,p_name=>'PE.DISPLAY_GROUP.FILES'
,p_message_text=>'Files'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221600345611260098)
,p_name=>'PE.DISPLAY_GROUP.FILE_STORAGE'
,p_message_text=>'File Storage'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569515479500501)
,p_name=>'PE.DISPLAY_GROUP.FILE_URLS_TO_LOAD'
,p_message_text=>'File URLs to Load'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175599137001484215)
,p_name=>'PE.DISPLAY_GROUP.FIND_BUTTON'
,p_message_text=>'Find Button'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566443185500499)
,p_name=>'PE.DISPLAY_GROUP.FIRST_ENTRY'
,p_message_text=>'First Entry'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388640439143170170)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_text=>'Timeline'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644142972854412563)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_text=>'Viewport'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388639787600170169)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_text=>'Gauge'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1716841661312491)
,p_name=>'PE.DISPLAY_GROUP.GENERATIVE_AI_SERVICE'
,p_message_text=>'Generative AI Service'
,p_version_scn=>972216748
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653528152661054)
,p_name=>'PE.DISPLAY_GROUP.GLOBALIZATION'
,p_message_text=>'Globalization'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570921334500502)
,p_name=>'PE.DISPLAY_GROUP.GRID_LAYOUT_RENDERING'
,p_message_text=>'Grid Layout Rendering'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123083117114211758)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_text=>'Header and Footer'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380756267068409863)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_text=>'Heading'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123083227657211758)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_text=>'Help'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242652687211661053)
,p_name=>'PE.DISPLAY_GROUP.HTML_FORMAT'
,p_message_text=>'HTML Format'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123083313323211758)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_text=>'HTML Header'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653117403661054)
,p_name=>'PE.DISPLAY_GROUP.ICON'
,p_message_text=>'Icon'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570226703500501)
,p_name=>'PE.DISPLAY_GROUP.ICONS'
,p_message_text=>'Icons'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931067698296482)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_text=>'Icon and Badge'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360865110468183800)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_text=>'Icon View'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123082014885211756)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_text=>'Identification'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567037994500499)
,p_name=>'PE.DISPLAY_GROUP.IMAGE'
,p_message_text=>'Image'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568593621500500)
,p_name=>'PE.DISPLAY_GROUP.IMAGE_BASED_TAB'
,p_message_text=>'Image Based Tab'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569606554500501)
,p_name=>'PE.DISPLAY_GROUP.INFORMATION'
,p_message_text=>'Information'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655683833661056)
,p_name=>'PE.DISPLAY_GROUP.INSTALLATION'
,p_message_text=>'Installation'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655878002661056)
,p_name=>'PE.DISPLAY_GROUP.INSTALL_MESSAGES'
,p_message_text=>'Installation Messages'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653262686661054)
,p_name=>'PE.DISPLAY_GROUP.IS_CURRENT'
,p_message_text=>'Is Current'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570616679500501)
,p_name=>'PE.DISPLAY_GROUP.ITEM'
,p_message_text=>'Item'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123083417389211758)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_text=>'JavaScript'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085026437211761)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_text=>'Label'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085705529211762)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_text=>'Layout'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388639148854170168)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_text=>'Legend'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295596865295064717)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_text=>'Line'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360892504432343748)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_text=>'Link'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570453319500501)
,p_name=>'PE.DISPLAY_GROUP.LIST'
,p_message_text=>'List'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472571439053854860)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_text=>'List Entries'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085101986211761)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_text=>'List of Values'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388944682996781304)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_text=>'Agenda View Calendar'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656369126907244838)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_text=>'Local Post Processing'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150986105124822646)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_text=>'Login Processing'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655390104661056)
,p_name=>'PE.DISPLAY_GROUP.LOGO'
,p_message_text=>'Logo'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653916651661055)
,p_name=>'PE.DISPLAY_GROUP.LOOKUP'
,p_message_text=>'Lookup'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597058619064718)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_text=>'Major Ticks'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563414390509648493)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_text=>'Zoom Levels'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563414272277648492)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_text=>'Map'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563414935646648493)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_text=>'Info Window'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563414492937648493)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_text=>'Initial Position and Zoom'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563414780720648493)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_text=>'Point Clustering'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563414694613648493)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_text=>'Point Objects'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563414863498648493)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_text=>'Row Assignment'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295596911893064717)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_text=>'Marker'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436911244832567657)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_text=>'Master Detail'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931117919296482)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_text=>'Media'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242652833863661053)
,p_name=>'PE.DISPLAY_GROUP.MESSAGE'
,p_message_text=>'Message'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380756176724409863)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_text=>'Messages'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597179112064718)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_text=>'Minor Ticks'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388944383629781302)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_text=>'Monthly Calendar'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46404817553208393)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_text=>'Multiple Values'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170053166754478595)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_text=>'Multi-Series Chart Data'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599368193640282054)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_text=>'Name'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174740922473982379)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_text=>'Navigation'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655407255661056)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_BAR'
,p_message_text=>'Navigation Bar'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1524070148991039793)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_text=>'Navigation Menu'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175599350955484215)
,p_name=>'PE.DISPLAY_GROUP.NEXT_BUTTON'
,p_message_text=>'Next Button'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654511656661055)
,p_name=>'PE.DISPLAY_GROUP.OPERATION'
,p_message_text=>'Operation'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489470471208264146)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_text=>'Output'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295596571341064716)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_text=>'Overview'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033719398271642)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489034185313271643)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_text=>'Page Footer'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489034032269271643)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_text=>'Page Header'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2681627723981463)
,p_name=>'PE.DISPLAY_GROUP.PAGE_PATTERN'
,p_message_text=>'Page Pattern'
,p_version_scn=>127897720
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568401487500500)
,p_name=>'PE.DISPLAY_GROUP.PAGE_SUBTEMPLATE'
,p_message_text=>'Subtemplate'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360865201545183800)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_text=>'Pagination'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568230396500500)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION_SUBTEMPLATE'
,p_message_text=>'Pagination Subtemplates'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366641627742523367)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_text=>'Parameter'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568714734500500)
,p_name=>'PE.DISPLAY_GROUP.PARENT_TAB'
,p_message_text=>'Parent Tab'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653811498661055)
,p_name=>'PE.DISPLAY_GROUP.PARSING'
,p_message_text=>'Parsing'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245971378651480605)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_text=>'Performance'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242652750937661053)
,p_name=>'PE.DISPLAY_GROUP.PLAIN_TEXT_FORMAT'
,p_message_text=>'Plain Text Format'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175598967408484215)
,p_name=>'PE.DISPLAY_GROUP.POPUP_ICON'
,p_message_text=>'Popup Icon'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568879404500500)
,p_name=>'PE.DISPLAY_GROUP.POSITIONS'
,p_message_text=>'Positions'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150986231078822647)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_text=>'Post-Logout URL'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655733080661056)
,p_name=>'PE.DISPLAY_GROUP.PREREQUISITES'
,p_message_text=>'Prerequisites'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175599455691484215)
,p_name=>'PE.DISPLAY_GROUP.PREVIOUS_BUTTON'
,p_message_text=>'Previous Button'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381155439741155629)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_text=>'Primary Key Source'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489033624386271642)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_text=>'Printing'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655546701661056)
,p_name=>'PE.DISPLAY_GROUP.PWA'
,p_message_text=>'Progressive Web App'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599367893856282053)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_text=>'Query'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085216305211761)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_text=>'Quick Picks'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123083503151211758)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_text=>'Read Only'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150986306932822647)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_text=>'Real Application Security'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75491220253434474)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_text=>'Reference Lines'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570034741500501)
,p_name=>'PE.DISPLAY_GROUP.REGION_DEFAULTS'
,p_message_text=>'Region Defaults'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242652202192661047)
,p_name=>'PE.DISPLAY_GROUP.REGION_IMAGE'
,p_message_text=>'Image'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152950382004840335)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_text=>'Remote Cache'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654190914661055)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_REST'
,p_message_text=>'Remote REST Data Source Server'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654837953661055)
,p_name=>'PE.DISPLAY_GROUP.REPORT_PRINTING'
,p_message_text=>'Report Printing'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567138491500499)
,p_name=>'PE.DISPLAY_GROUP.REPORT_TEMPLATE'
,p_message_text=>'Report Template'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656165424661056)
,p_name=>'PE.DISPLAY_GROUP.REST_SOURCE_CATALOG'
,p_message_text=>'REST Source Catalog'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175599628917484215)
,p_name=>'PE.DISPLAY_GROUP.RESULT_SET'
,p_message_text=>'Result Set'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568305500500500)
,p_name=>'PE.DISPLAY_GROUP.ROW_HIGHLIGHTING'
,p_message_text=>'Row Highlighting'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654651847661055)
,p_name=>'PE.DISPLAY_GROUP.ROW_SEARCH'
,p_message_text=>'Row Search'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600143071001622)
,p_name=>'PE.DISPLAY_GROUP.ROW_SELECTION'
,p_message_text=>'Row Selection'
,p_version_scn=>6739864
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567765384500500)
,p_name=>'PE.DISPLAY_GROUP.ROW_TEMPLATES'
,p_message_text=>'Row Templates'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567800718500500)
,p_name=>'PE.DISPLAY_GROUP.ROW_TEMPLATE_1'
,p_message_text=>'Row Template 1'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143567961810500500)
,p_name=>'PE.DISPLAY_GROUP.ROW_TEMPLATE_2'
,p_message_text=>'Row Template 2'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568087296500500)
,p_name=>'PE.DISPLAY_GROUP.ROW_TEMPLATE_3'
,p_message_text=>'Row Template 3'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568177561500500)
,p_name=>'PE.DISPLAY_GROUP.ROW_TEMPLATE_4'
,p_message_text=>'Row Template 4'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(343854115293545262)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_text=>'Search Bar'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175599012011484215)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_FIELD'
,p_message_text=>'Search Field'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596930921224296482)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_text=>'Secondary Body'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123083613818211758)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_text=>'Security'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123083721632211758)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_text=>'Server Cache'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880515942791481554)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_text=>'Server-side Condition'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599368321187282054)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_text=>'Session'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654955416661055)
,p_name=>'PE.DISPLAY_GROUP.SESSION_MANAGEMENT'
,p_message_text=>'Session Management'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150986510113822647)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_text=>'Session Not Valid'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242652393335661047)
,p_name=>'PE.DISPLAY_GROUP.SESSION_SHARING'
,p_message_text=>'Session Sharing'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242652931271661054)
,p_name=>'PE.DISPLAY_GROUP.SESSION_STATE'
,p_message_text=>'Session State'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655098088661055)
,p_name=>'PE.DISPLAY_GROUP.SESSION_STATE_PROTECTION'
,p_message_text=>'Session State Protection'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123082129075211756)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_text=>'Settings'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360865415322183801)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_text=>'Single Row View'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360865304717183800)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_text=>'Sorting'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085305344211761)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_text=>'Source'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144040351767306390)
,p_name=>'PE.DISPLAY_GROUP.SOURCE_ORDER_BY'
,p_message_text=>'Order By'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569203117500501)
,p_name=>'PE.DISPLAY_GROUP.STANDARD_ATTRIBUTES'
,p_message_text=>'Standard Attributes'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143568600079500500)
,p_name=>'PE.DISPLAY_GROUP.STANDARD_TAB'
,p_message_text=>'Standard Tab'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653069122661054)
,p_name=>'PE.DISPLAY_GROUP.STATUS'
,p_message_text=>'Status'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69018304743027572)
,p_name=>'PE.DISPLAY_GROUP.SUBENTRIES'
,p_message_text=>'Subentries'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570598190500501)
,p_name=>'PE.DISPLAY_GROUP.SUBLIST'
,p_message_text=>'SubList'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566582134500499)
,p_name=>'PE.DISPLAY_GROUP.SUBLIST_ENTRY'
,p_message_text=>'Sublist Entry'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150986610603822647)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_text=>'Subscription'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566912473500499)
,p_name=>'PE.DISPLAY_GROUP.SUB_REGIONS'
,p_message_text=>'Sub Regions'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596930759236296482)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_text=>'Subtitle'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361253422635487056)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_text=>'Success Message'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136506993133670837)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_text=>'Suggestions'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143569168507500500)
,p_name=>'PE.DISPLAY_GROUP.SUPPORTED_FOR'
,p_message_text=>'Supported for'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654337032661055)
,p_name=>'PE.DISPLAY_GROUP.SYNCHRONIZATION'
,p_message_text=>'REST Synchronization'
,p_version_scn=>25876812
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654404879661055)
,p_name=>'PE.DISPLAY_GROUP.SYNCHRONIZATION_RATE_LIMIT'
,p_message_text=>'Synchronization Rate Limit'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1524070263927039795)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_text=>'Tabs'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654239339661055)
,p_name=>'PE.DISPLAY_GROUP.TARGET'
,p_message_text=>'Target'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571144949500502)
,p_name=>'PE.DISPLAY_GROUP.TEMPLATE'
,p_message_text=>'Template'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656219232661056)
,p_name=>'PE.DISPLAY_GROUP.TEMPLATES'
,p_message_text=>'Templates'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143566115991500499)
,p_name=>'PE.DISPLAY_GROUP.TEMPLATE_OPTIONS'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143570337453500501)
,p_name=>'PE.DISPLAY_GROUP.THEME_ROLLER_ATTRIBUTES'
,p_message_text=>'Theme Roller Attributes'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24876916607098898)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_text=>'Thresholds'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597217527064718)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_text=>'Tick Label'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547734718336400066)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_text=>'Time Scale'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388640055675170170)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_text=>'Title'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245971296842480605)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_text=>'Toolbar'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388639947314170169)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_text=>'Tooltip'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242654047079661055)
,p_name=>'PE.DISPLAY_GROUP.TRANSFORMATION'
,p_message_text=>'Transformation'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381133716357191075)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_text=>'UI Defaults Reference'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242655903559661056)
,p_name=>'PE.DISPLAY_GROUP.UPGRADE_MESSAGES'
,p_message_text=>'Upgrade Messages'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242653421276661054)
,p_name=>'PE.DISPLAY_GROUP.USER_DEFINED_ATTRIBUTES'
,p_message_text=>'User Defined Attributes'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085422766211761)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_text=>'Validation'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388639853399170169)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_text=>'Value'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115862886735908846)
,p_name=>'PE.DISPLAY_GROUP.VARIABLE'
,p_message_text=>'Variable'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388944484798781303)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_text=>'Weekly Calendar'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123084309458211759)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_text=>'When'
,p_version_scn=>37166067046321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175599584688484215)
,p_name=>'PE.DISPLAY_GROUP.WINDOW'
,p_message_text=>'Window'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178444755867165501)
,p_name=>'PE.DISPLAY_GROUP.WORKING_COPY'
,p_message_text=>'Working Copy'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355260259624719306)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_text=>'Zoom Scale'
,p_version_scn=>37166067046324
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656390040661057)
,p_name=>'PE.ERROR.APP_ID_EXISTS'
,p_message_text=>'Application with this ID already exists.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656455521661057)
,p_name=>'PE.ERROR.TRANS_APP_ID_NO_ZERO'
,p_message_text=>'Translation Application must not end in zero.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639295701500673)
,p_name=>'PE.PROPERTY.A01_DESCRIPTION.PROMPT'
,p_message_text=>'A01'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639389265500673)
,p_name=>'PE.PROPERTY.A02_DESCRIPTION.PROMPT'
,p_message_text=>'A02'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639488874500673)
,p_name=>'PE.PROPERTY.A03_DESCRIPTION.PROMPT'
,p_message_text=>'A03'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639587201500673)
,p_name=>'PE.PROPERTY.A04_DESCRIPTION.PROMPT'
,p_message_text=>'A04'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639657867500673)
,p_name=>'PE.PROPERTY.A05_DESCRIPTION.PROMPT'
,p_message_text=>'A05'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639704944500673)
,p_name=>'PE.PROPERTY.A06_DESCRIPTION.PROMPT'
,p_message_text=>'A06'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639834561500673)
,p_name=>'PE.PROPERTY.A07_DESCRIPTION.PROMPT'
,p_message_text=>'A07'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639976498500673)
,p_name=>'PE.PROPERTY.A08_DESCRIPTION.PROMPT'
,p_message_text=>'A08'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640007758500673)
,p_name=>'PE.PROPERTY.A09_DESCRIPTION.PROMPT'
,p_message_text=>'A09'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640135063500673)
,p_name=>'PE.PROPERTY.A10_DESCRIPTION.PROMPT'
,p_message_text=>'A10'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640232387500673)
,p_name=>'PE.PROPERTY.A11_DESCRIPTION.PROMPT'
,p_message_text=>'A11'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640376443500674)
,p_name=>'PE.PROPERTY.A12_DESCRIPTION.PROMPT'
,p_message_text=>'A12'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640457964500674)
,p_name=>'PE.PROPERTY.A13_DESCRIPTION.PROMPT'
,p_message_text=>'A13'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640513802500674)
,p_name=>'PE.PROPERTY.A14_DESCRIPTION.PROMPT'
,p_message_text=>'A14'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640695373500674)
,p_name=>'PE.PROPERTY.A15_DESCRIPTION.PROMPT'
,p_message_text=>'A15'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640752659500674)
,p_name=>'PE.PROPERTY.A16_DESCRIPTION.PROMPT'
,p_message_text=>'A16'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640820933500674)
,p_name=>'PE.PROPERTY.A17_DESCRIPTION.PROMPT'
,p_message_text=>'A17'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143640900226500674)
,p_name=>'PE.PROPERTY.A18_DESCRIPTION.PROMPT'
,p_message_text=>'A18'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143641090934500674)
,p_name=>'PE.PROPERTY.A19_DESCRIPTION.PROMPT'
,p_message_text=>'A19'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143641148238500674)
,p_name=>'PE.PROPERTY.A20_DESCRIPTION.PROMPT'
,p_message_text=>'A20'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635610686500670)
,p_name=>'PE.PROPERTY.ACCESSIBILITY_TESTED.PROMPT'
,p_message_text=>'Accessibility Tested'
,p_version_scn=>37166067046454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601240643780569)
,p_name=>'PE.PROPERTY.ACCESSIBLE_READ_ONLY_ITEMS.HELP'
,p_message_text=>'Determines whether &PRODUCT_NAME. renders the legacy SPAN-based elements for an item''s read-only mode, or the more accessible readonly input or textarea elements. The more accessible input and textarea elements will be focusable with the keyboard, an'
||'d easier to perceive for screen reader users.'
,p_version_scn=>21323117
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601131240780569)
,p_name=>'PE.PROPERTY.ACCESSIBLE_READ_ONLY_ITEMS.PROMPT'
,p_message_text=>'Accessible Read-Only Items'
,p_version_scn=>21323117
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494837997272153)
,p_name=>'PE.PROPERTY.ACL_ROLE_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this role on an existing role in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494778024272153)
,p_name=>'PE.PROPERTY.ACL_ROLE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717133905661329)
,p_name=>'PE.PROPERTY.ACTIONS_INITIATED_ON.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717070046661329)
,p_name=>'PE.PROPERTY.ACTIONS_INITIATED_ON.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_text=>'Function Body Returning Boolean'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716998106661329)
,p_name=>'PE.PROPERTY.ACTIONS_INITIATED_ON.LOV.NO_ROWS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716838231661329)
,p_name=>'PE.PROPERTY.ACTIONS_INITIATED_ON.LOV.ROWS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716724391661328)
,p_name=>'PE.PROPERTY.ACTIONS_INITIATED_ON.PROMPT'
,p_message_text=>'Actions Initiated On'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208968782982816)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208821961982815)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208731166982815)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209023796982816)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208624335982815)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208519444982815)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112601090276432)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112505504276432)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112470657276432)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112729994276432)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112341847276432)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763582676661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_ITEM1.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763975379661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_ITEM2.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242765085424661470)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242765964997661471)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615314320484678)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242764924725661470)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615530346484679)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242765802325661471)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763699315661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615295599484678)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242764823754661470)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615478045484679)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242765714457661471)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242765109955661471)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766049611661471)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615106076484678)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242764717881661470)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615003611484677)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully as one or more rows exist when checking if the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>To return successfully as no rows exist when checking if the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763389036661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763700988661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242764077008661470)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TEXT2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242760827716661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762779809661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_text=>'Text is contained in Item'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762836720661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_text=>'Text = Value'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763056105661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_text=>'Text is contained in Value'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763167116661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_text=>'Text is NOT contained in Value'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762931836661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_text=>'Text != Value'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242760952751661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761196566661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761230118661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762174305661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_text=>'Item contains no spaces'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762493155661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_text=>'Item is alphanumeric'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761692734661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_text=>'Item is NOT NULL'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762305522661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_text=>'Item is NOT numeric'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761839712661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_text=>'Item is NOT zero'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761542585661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_text=>'Item is NULL'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761987164661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_text=>'Item is NULL or zero'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762294034661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_text=>'Item is numeric'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761767503661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_text=>'Item is zero'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762001399661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_text=>'Item is NOT NULL and NOT zero'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763298721661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761099168661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762566270661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is in colon delimited list'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242762655058661468)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is NOT in colon delimited list'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761341649661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_text=>'Item = Value'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242761432439661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'Item != Value'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242760706908661467)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763425508661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_VALUE1.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242763881788661469)
,p_name=>'PE.PROPERTY.ACTION_CONDITION_VALUE2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046488
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717855972661329)
,p_name=>'PE.PROPERTY.ACTION_ERROR_HANDLING.LOV.ABORT.D'
,p_message_text=>'Terminate Automation'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717953592661330)
,p_name=>'PE.PROPERTY.ACTION_ERROR_HANDLING.LOV.DISABLE.D'
,p_message_text=>'Disable Automation'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717791406661329)
,p_name=>'PE.PROPERTY.ACTION_ERROR_HANDLING.LOV.IGNORE.D'
,p_message_text=>'Ignore'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717644379661329)
,p_name=>'PE.PROPERTY.ACTION_ERROR_HANDLING.PROMPT'
,p_message_text=>'Action Error Handling'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975188432250370)
,p_name=>'PE.PROPERTY.ACTION_LINK_TARGET_TYPE.HELP'
,p_message_text=>'Select the action to be performed when the specified action type is clicked.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975418445250371)
,p_name=>'PE.PROPERTY.ACTION_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_text=>'Redirect to Page in a different Application'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975506588250371)
,p_name=>'PE.PROPERTY.ACTION_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Redirect to a page in a different application, with optional additional attributes for resetting pagination, setting the request value, clearing cache and setting item values, on the target page.</p>',
'<p>Note: Redirecting to a page in different application relies on deep linking being enabled in the target application. To enable deep linking, go to the application''s <em>Security</em> attributes and enable <em>Deep Linking</em>.</p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975252078250370)
,p_name=>'PE.PROPERTY.ACTION_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_text=>'Redirect to Page in this Application'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975387217250370)
,p_name=>'PE.PROPERTY.ACTION_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_text=>'Redirect to a page in the current application, with optional additional attributes for resetting pagination, setting the request value, clearing cache and setting item values, on the target page.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975656849250371)
,p_name=>'PE.PROPERTY.ACTION_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_text=>'Redirect to URL'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975739846250371)
,p_name=>'PE.PROPERTY.ACTION_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_text=>'Redirect to the target URL you specify.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975089944250370)
,p_name=>'PE.PROPERTY.ACTION_LINK_TARGET_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971264385250227)
,p_name=>'PE.PROPERTY.ACTION_POSITION.HELP'
,p_message_text=>'Determines where the action is positioned on the Template Component.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971145798250227)
,p_name=>'PE.PROPERTY.ACTION_POSITION.PROMPT'
,p_message_text=>'Position'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143628969300500665)
,p_name=>'PE.PROPERTY.ACTION_POSITION_PREDEFINED_TEMPLATE.PROMPT'
,p_message_text=>'Predefined Template'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973024893250232)
,p_name=>'PE.PROPERTY.ACTION_TEMPLATE.HELP'
,p_message_text=>'Determines which template is used to render the action.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972960906250232)
,p_name=>'PE.PROPERTY.ACTION_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667217996661278)
,p_name=>'PE.PROPERTY.ADDITIONAL_CODE_PLSQL_CODE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL anonymous block of code that contains procedures to be called for Initialization or Cleanup of the automation, or before action processing for each row.</p>',
'<p>For performance reasons you can also store this code in a PL/SQL package in the database.</p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667103914661278)
,p_name=>'PE.PROPERTY.ADDITIONAL_CODE_PLSQL_CODE.PROMPT'
,p_message_text=>'PL/SQL Code'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(124358059020988768)
,p_name=>'PE.PROPERTY.ADDITIONAL_INFO.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'If specified, this additional column information is used by REST Source Plug-In implementations to influence how they',
'interact with the REST endpoint.'))
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(124357996090988768)
,p_name=>'PE.PROPERTY.ADDITIONAL_INFO.PROMPT'
,p_message_text=>'Additional Information'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973284743481113)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify an authorization scheme to restrict who can add rows.',
'In order for an end user to add rows, this authorization scheme must evaluate to TRUE for that user.',
'If no authorization scheme is provided then any user can add rows in this interactive grid.'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973136373481112)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_text=>'Add'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748141458661390)
,p_name=>'PE.PROPERTY.ADD_BUILT_WITH_LOVE.PROMPT'
,p_message_text=>'Add "Built with APEX" to Footer'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245976782896481124)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an alternative label for the Add button. The default label is <em>Add Row</em>.</p>',
'        <p>For example, enter <em>Add Employee</em> for an interactive grid where employees are maintained.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245976659704481124)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_text=>'Add Button Label'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974437774481117)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to add a new row if the interactive grid currently has no records returned.',
'        The <em>No Data Found</em> message will never be displayed as there will always be at least one record displayed.</p>',
'        <p>Note - If no updates are made to the record that was added it will not be inserted when the region is saved.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974375964481117)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_text=>'Add Row If Empty'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(597584695726962384)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_text=>'Enter classes to add to this facet. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584821707429747884)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_text=>'Enter classes to add to this facet group. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245992064388481470)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter classes to add to this component. You may add multiple classes by separating them with spaces.</p>',
'        <p>Note: This property can be used to make style modifications to the corresponding item when the Interactive Grid is editable.</p>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586672083272045663)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter classes to add to this component. You may add multiple classes by separating them with spaces.</p>',
'        <p>Note: These CSS classes will be applied to the HTML form element tag.</p>'))
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136510390660670635)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_text=>'Enter classes to add to this filter. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136511037526670633)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_text=>'Enter classes to add to this filter group. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586671401992045326)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Add the CSS classes <code>articlenumber</code> and <code>highlight</code> to the HTML tag of the component</dt>',
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586671363995045325)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_text=>'Enter additional space delimited CSS classes to be included in the component.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586671262443045325)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724787053661336)
,p_name=>'PE.PROPERTY.ADVANCED_IS_VISIBLE.PROMPT'
,p_message_text=>'Show on Task Details'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709360247661322)
,p_name=>'PE.PROPERTY.ADVANCED_SEQUENCE.PROMPT'
,p_message_text=>'Sequence'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123148927136211878)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_text=>'Select the button to be affected by this action.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123148829473211878)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_text=>'Button'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880517347826482140)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter one or more columns to be affected by this action.',
'For multiple columns, separate each column name with a comma.',
'<p>You can type in the name or pick from the list of available columns.',
'If you pick from the list and there is already text entered, then a comma is placed at the end of the existing text, followed by the column name returned from the list.'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880517208456482139)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_text=>'Column(s)'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123149314977211879)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter either a DOM object (<code>document</code>, <code>window</code>) or the <em>id</em> of a DOM object (<code>myElementID</code>) as the element to be affected by this action.</p>',
'<p>Note: <em>DOM Object</em> is deprecated and should be replaced by <em>JavaScript Expression</em> or <em>jQuery Selector</em>.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123149215160211879)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_text=>'DOM Object'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123149124060211878)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter one or more page items to be affected by this action.',
'For multiple items, separate each item name with a comma.',
'<p>You can type in the name or pick from the list of available items.',
'If you pick from the list and there is already text entered, then a comma is placed at the end of the existing text, followed by the item name returned from the list.'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123149014786211878)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_text=>'Item(s)'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855974624354605333)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Returns a reference to the browser''s <code>window</code> DOM object.</dt>',
'<dd><code>window</code></dd>',
'<dt>Returns a reference to the browser''s <code>document</code> DOM object.</dt>',
'<dd>document</dd>',
'<dt>jQuery selector selects all DIV elements that have a class of ''alert'', and then returns a jQuery object containing all their parents.</dt>',
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855974543971605333)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_text=>'Specify the JavaScript Expression to be evaluated to return a single DOM object, an array of DOM objects or a jQuery object as the element(s) to be affected by this action.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855974467213605333)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760788757751456)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>To select a page element with an DOM id of <code>my_id</code></dt>',
'<dd><pre>#my_id</pre></dd>',
'<dt>To select all the page elements with a class of <code>my_class</code></dt>',
'<dd><pre>.my_class</pre></dd>',
'<dt>To select all the page elements that are inputs</dt>',
'<dd><pre>input</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123149513177211879)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter jQuery Selector syntax to return one or more page elements to be affected by this action. The jQuery library offers a very powerful selector syntax which provides a way to easily access one or more elements from a page.</p>',
'<p>Please see the official documentation available from the <a rel="noopener noreferrer" target="_blank" href="http://docs.jquery.com">jQuery homepage</a> for further information about the selector syntax.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123149414108211879)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_text=>'jQuery Selector'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123148718878211878)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_text=>'Select the region to be affected by this action.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123148617829211878)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_text=>'Region'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123147818160211876)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_text=>'Select how to define the page components to be affected when this action is executed.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759535732751452)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_text=>'Button'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759662631751452)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_text=>'The action affects the button you select.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880516281803481624)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_text=>'Column(s)'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880516367625481625)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_text=>'The action affects the one or more columns you enter.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759952202751453)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_text=>'DOM Object'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760094839751453)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_text=>'The action affects the page element identified by the DOM Object or DOM ID you enter.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760565109751455)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_text=>'Event Source'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760694717751455)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The action affects the page element where the event originated, which could be different to the "Triggering Element" in some cases.</p>',
'<p>In this advanced configuration, the triggering element specified is generally a container element (such as a region) which handles events raised by all of it''s sub-elements (such as page items in that region).',
'This selection type can then be used to act upon the sub-element that triggered the event, rather than the container element.',
'For example, if you have a dynamic action that defines a <strong>''Change''</strong> event on a region on your page, the action affects the actual item in the region that has changed.</p>',
'<p>Utilizing <em>''Event Source''</em> can be a more efficient way of defining common behaviors that affect many page elements.',
'The ability of container elements to catch events raised by sub-elements is determined by the event type.',
'The following event types support this:</p>',
'<ul>',
'  <li><strong>After Refresh</strong> (apexafterrefresh)</li>',
'  <li><strong>Before Refresh</strong> (apexbeforerefresh)</li>',
'  <li><strong>Change</strong> (change)</li>',
'  <li><strong>Click</strong> (click)</li>',
'  <li><strong>Double Click</strong> (dblclick)</li>',
'  <li><strong>Get Focus</strong> (focus)</li>',
'  <li><strong>Key Down</strong> (keydown)</li>',
'  <li><strong>Key Press</strong> (keypress)</li>',
'  <li><strong>Key Release</strong> (keyup)</li>',
'  <li><strong>Lose Focus</strong> (blur)</li>',
'  <li><strong>Mouse Button Press</strong> (mousedown)</li>',
'  <li><strong>Mouse Button Release</strong> (mouseup)</li>',
'  <li><strong>Mouse Move</strong> (mousemove)</li>',
'</ul>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759365249751452)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_text=>'Item(s)'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759453411751452)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_text=>'The action affects the one or more page items you enter.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855974233209605091)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855974356285605091)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_text=>'The action affects the page element(s) returned using the JavaScript Expression you enter.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760178983751453)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_text=>'jQuery Selector'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760235791751454)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_text=>'The action affects the page element(s) returned using the jQuery selector syntax you enter.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759766357751452)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_text=>'Region'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759831212751453)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_text=>'The action affects the region you select.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760397060751454)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_text=>'Triggering Element'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760497378751454)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_text=>'The action affects the page element or component that triggered the dynamic action.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123147701917211876)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_text=>'Selection Type'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597055831500642)
,p_name=>'PE.PROPERTY.AFTER_COLUMN_HEADING.PROMPT'
,p_message_text=>'After Heading'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602058302500646)
,p_name=>'PE.PROPERTY.AFTER_EACH_ROW.PROMPT'
,p_message_text=>'After Each Row'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577455440500629)
,p_name=>'PE.PROPERTY.AFTER_ITEM_TEMPLATE.PROMPT'
,p_message_text=>'After'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578398513500629)
,p_name=>'PE.PROPERTY.AFTER_LABEL_AND_ITEM_TEMPLATE.PROMPT'
,p_message_text=>'After Label and Item'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577274114500628)
,p_name=>'PE.PROPERTY.AFTER_LABEL_TEMPLATE.PROMPT'
,p_message_text=>'After'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596645150500642)
,p_name=>'PE.PROPERTY.AFTER_LAST_ROW.PROMPT'
,p_message_text=>'Bottom'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177895461425512641)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_text=>'No Aggregation'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(177967856596546587)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_text=>'Returns the value column.'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608660284518801518)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_text=>'Select how to aggregate the associated chart values column.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608661766512801529)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_text=>'Approximate Count Distinct'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608661852884801529)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_text=>'Returns the approximate number of distinct values. This aggregation is significantly faster than <em>Count Distinct</em> when processing large amounts of data.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608660732340801522)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_text=>'Average'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608660848396801523)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_text=>'Returns the average of the value column.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608660306290801519)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_text=>'Count'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608660499549801520)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_text=>'Returns the number of records.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608661592023801528)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_text=>'Count Distinct'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608661698659801528)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_text=>'Returns the exact number of distinct values.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608661301590801527)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_text=>'Maximum'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608661442817801527)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_text=>'Returns the maximum value.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608660945420801523)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_text=>'Median'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608661077848801524)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_text=>'Returns the middle number, ignoring nulls. This aggregation is best suited to a continuous distribution model as it returns the number in the center.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608661141275801525)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_text=>'Minimum'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608661284139801526)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_text=>'Returns the minimum value.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608660580026801521)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_text=>'Sum'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608660620930801521)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_text=>'Returns the total of the value column.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(608660133169801517)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_text=>'Value Aggregation'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718314713312389)
,p_name=>'PE.PROPERTY.AI_ATTRIBUTES.HELP'
,p_message_text=>'Additional (JSON) attributes for the Generative AI Service'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718249886312389)
,p_name=>'PE.PROPERTY.AI_ATTRIBUTES.PROMPT'
,p_message_text=>'Generative AI Service additional attributes'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718552366312389)
,p_name=>'PE.PROPERTY.AI_ENABLED.HELP'
,p_message_text=>'<p>Enable the AI Assistant for this component.</p>'
,p_version_scn=>1178083120
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718455505312389)
,p_name=>'PE.PROPERTY.AI_ENABLED.PROMPT'
,p_message_text=>'Enabled'
,p_version_scn=>1168819199
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718155416312389)
,p_name=>'PE.PROPERTY.AI_HTTP_HEADERS.HELP'
,p_message_text=>'Additional HTTP headers for the Generative AI Service'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718060440312389)
,p_name=>'PE.PROPERTY.AI_HTTP_HEADERS.PROMPT'
,p_message_text=>'Generative AI Service additional HTTP Headers'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1404194478172947)
,p_name=>'PE.PROPERTY.AI_IS_BUILDER_SERVICE.HELP'
,p_message_text=>'Indicates whether this is the default Generative AI Service'
,p_version_scn=>1006615889
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1404056033172947)
,p_name=>'PE.PROPERTY.AI_IS_BUILDER_SERVICE.PROMPT'
,p_message_text=>'Default Generative AI Service'
,p_version_scn=>1006615887
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1717925016312389)
,p_name=>'PE.PROPERTY.AI_MODEL_NAME.HELP'
,p_message_text=>'The model to use for the Generative AI Service'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1717807670312389)
,p_name=>'PE.PROPERTY.AI_MODEL_NAME.PROMPT'
,p_message_text=>'Generative AI Service model to use'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1717153498312389)
,p_name=>'PE.PROPERTY.AI_PROVIDER_TYPE.HELP'
,p_message_text=>'The provider of the Generative AI Service'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1717334966312389)
,p_name=>'PE.PROPERTY.AI_PROVIDER_TYPE.LOV.COHERE.D'
,p_message_text=>'Cohere'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1717410937312389)
,p_name=>'PE.PROPERTY.AI_PROVIDER_TYPE.LOV.OCI_GENAI.D'
,p_message_text=>'OCI Generative AI'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1717208724312389)
,p_name=>'PE.PROPERTY.AI_PROVIDER_TYPE.LOV.OPENAI.D'
,p_message_text=>'Open AI'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1717582644312389)
,p_name=>'PE.PROPERTY.AI_PROVIDER_TYPE.LOV.REST.D'
,p_message_text=>'Generic REST'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1717003197312390)
,p_name=>'PE.PROPERTY.AI_PROVIDER_TYPE.PROMPT'
,p_message_text=>'Generative AI Service provider'
,p_version_scn=>972216769
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801389423132477)
,p_name=>'PE.PROPERTY.AI_REMOTE_SERVER_ID.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.NULL_TEXT'
,p_message_text=>'Application Default'
,p_version_scn=>122461709
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2673118823994224)
,p_name=>'PE.PROPERTY.AI_REMOTE_SERVER_ID.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_text=>'Application Default'
,p_version_scn=>1057828116
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2673269853994170)
,p_name=>'PE.PROPERTY.AI_REMOTE_SERVER_ID.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.NULL_TEXT'
,p_message_text=>'Application Default'
,p_version_scn=>1057828155
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718716217312389)
,p_name=>'PE.PROPERTY.AI_REMOTE_SERVER_ID.HELP'
,p_message_text=>'<p>Specify the Generative AI Service to be used by the AI Assistant.</p>'
,p_version_scn=>1181195732
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718682421312389)
,p_name=>'PE.PROPERTY.AI_REMOTE_SERVER_ID.PROMPT'
,p_message_text=>'Service'
,p_version_scn=>1168819213
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3518652976897834)
,p_name=>'PE.PROPERTY.AI_SYSTEM_PROMPT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You are an expert in marketing. You will be provided with a product description and seed words, and your task is to generate product names.</p>',
'<p>You are a professional translator. You will be provided with a sentence in English, and your task is to translate it into French.</p>'))
,p_version_scn=>16827073
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718966607312388)
,p_name=>'PE.PROPERTY.AI_SYSTEM_PROMPT.HELP'
,p_message_text=>'<p>Specify the system prompt to be used by the AI Assistant.</p>'
,p_version_scn=>1178083120
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718821798312388)
,p_name=>'PE.PROPERTY.AI_SYSTEM_PROMPT.PROMPT'
,p_message_text=>'System Prompt'
,p_version_scn=>972216771
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2416250228528240)
,p_name=>'PE.PROPERTY.AI_WELCOME_MESSAGE.EXAMPLES'
,p_message_text=>'<p>How may I help you today?</p>'
,p_version_scn=>17387265
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2416128821528240)
,p_name=>'PE.PROPERTY.AI_WELCOME_MESSAGE.HELP'
,p_message_text=>'<p>An optional welcome message shown by the AI Assistant.</p>'
,p_version_scn=>17387265
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2416080876528225)
,p_name=>'PE.PROPERTY.AI_WELCOME_MESSAGE.PROMPT'
,p_message_text=>'Welcome Message'
,p_version_scn=>17387264
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606801822500649)
,p_name=>'PE.PROPERTY.AJAX_PROCEDURE_FUNCTION_NAME.PROMPT'
,p_message_text=>'AJAX Procedure/Function Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656656175661059)
,p_name=>'PE.PROPERTY.ALIAS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter an alphanumeric alias for this page. You may use this alias to reference the page instead of the page number.',
'For example, if you were working on page 1 of application 100, you could create an alias called <code>home</code>.',
'You could then access this page from other pages using the following f?p syntax:',
'<pre>f?p=100:home</pre>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656528791661059)
,p_name=>'PE.PROPERTY.ALIAS.PROMPT'
,p_message_text=>'Alias'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123103829603211803)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select whether the end user may submit the same page more than once.',
'Use this feature to avoid duplicate inserts into the same table.',
'This can happen when an end user clicks the browser''s back button and then submits the page again, or if the end user clicks the browser''s reload button.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750582988751423)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_text=>'No - Prevent page from being re-posted'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750614060751423)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_text=>'Yes - Enable page to be re-posted'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123103724704211803)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_text=>'Enable duplicate page submissions'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590335172500638)
,p_name=>'PE.PROPERTY.ALLOW_EMBED_IN_FRAME.LOV.MODAL.D'
,p_message_text=>'Modal Dialog'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590442016500638)
,p_name=>'PE.PROPERTY.ALLOW_EMBED_IN_FRAME.LOV.NON_MODAL.D'
,p_message_text=>'Non-Modal Dialog'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590217642500637)
,p_name=>'PE.PROPERTY.ALLOW_EMBED_IN_FRAME.PROMPT'
,p_message_text=>'Allow Embed In Frame'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360871800302183856)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_text=>'Specify whether null columns are hidden on the Single Record View.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360871714793183856)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_text=>'Exclude Null Values'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718665508661330)
,p_name=>'PE.PROPERTY.ALLOW_FEEDBACK.PROMPT'
,p_message_text=>'Allow Feedback'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715538899661327)
,p_name=>'PE.PROPERTY.ALLOW_FETCHING_ALL_ROWS.PROMPT'
,p_message_text=>'Allow Fetching All Rows'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360872026127183857)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_text=>'Specify whether only those columns currently displayed are displayed in the Single Record View. If you specify <strong>Off</strong> then non displayed report columns may also be shown on the Single Record View.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360871903079183856)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_text=>'Only Displayed Columns'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493127103274742)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_text=>'Specify whether end users can aggregate this column.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493028473274742)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_text=>'Aggregate'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493512537274743)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_text=>'Specify whether end users can use this column within a chart.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493404177274742)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_text=>'Chart'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493311844274742)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_text=>'Specify whether end users can utilize this column in a computational column they define.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493204933274742)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_text=>'Compute'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492902492274742)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_text=>'Specify whether end users can utilize this column in a control break.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492831261274742)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_text=>'Control Break'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492513490274740)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_text=>'Specify whether end users can filter this column.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492430129274740)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_text=>'Filter'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493703430274743)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_text=>'Specify whether end users can group by this column.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493629942274743)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_text=>'Group By'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492125631274739)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_text=>'Specify whether end users can hide this column.'
,p_version_scn=>37166067046347
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492013667274739)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_text=>'Hide'
,p_version_scn=>37166067046347
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492700552274741)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_text=>'Specify whether end users can highlight this column.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492617288274741)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_text=>'Highlight'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3701298840680)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_text=>'Specify whether end user can define a pivot break-down within this report.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3701297840680)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_text=>'Pivot'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881132292183863)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can save their current report definition as a <em>Public</em> report.</p>',
'<p>Public reports are displayed in a select list of available reports in the Search Bar, and are displayed to everyone.',
'The option on the Actions menu is only available to authenticated users and is further restricted if you also populate the <strong>Save Public Report Authorization</strong>.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881027932183863)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_text=>'Save Public Report'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880917042183863)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can save their current report definition as a <em>Private</em> report.</p>',
'<p>Private reports are displayed in a select list of available reports in the Search Bar, and are only displayed to the user who saved the report, providing they are authenticated.',
'The option on the Actions menu is only available to authenticated users.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880815518183863)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_text=>'Save Report'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881327766183863)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_text=>'Specify whether end users can save report categories.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881200616183863)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_text=>'Save Report Categories'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492323211274739)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_text=>'Specify whether end users can sort this column.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360492227203274739)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_text=>'Sort'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600112384973220)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the alternative label to use in dialogs and in various column heading placements.',
'        Use an alternative label when the heading contains extra formatting, such as HTML tags, which do not display properly.'))
,p_version_scn=>16936867
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981087464481146)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the alternative label to use in dialogs and in the Single Row View.',
'        Use an alternative label when the heading contains extra formatting, such as HTML tags, which do not display properly.'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245980901915481146)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_text=>'Alternative Label'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156036204345350908)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether this validation is always executed.',
'If set to <strong>On</strong>, this validation is always evaluated, irrespective of the <em>Execute Validations</em> setting defined against the button that submitted the page.',
'If set to <strong>Off</strong>, this validation is only evaluated if the triggering button has an <em>Execute Validations</em> setting of <strong>On</strong>.</p>',
'<p>Note: This validation must also comply with the conditions specified before being evaluated.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156036117483350908)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_text=>'Always Execute'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295601319462065286)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether animation is shown when data is changed on the chart. A data change can occur if the chart gets automatically refreshed, if hide and show behavior is performed when clicking on a legend item, or when chart data is programmatically u'
||'pdated via some custom JavaScript code or a Dynamic Action.</p>',
'        <p>The options <strong>Slide to Left</strong> and <strong>Slide to Right</strong> do not apply to Dial charts</p>.  '))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295601430423065287)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762702923249741)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_text=>'Apply the Oracle JET defined default animation settings for the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295601720995065288)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869356867587481)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_text=>'No animation is applied to the chart when data is changed.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295601551160065287)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_text=>'Slide to Left'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869168999587479)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_text=>'The data elements slide to the left when data is changed. This setting does not apply to Gantt charts.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295601612396065288)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_text=>'Slide to Right'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869204460587480)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_text=>'The data elements slide to the right when data is changed. This setting does not apply to Gantt charts.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295601274722065286)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_text=>'On Data Change'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295600786814065284)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the type of animation used when initially displaying the chart.</p>',
'        <p>The options <strong>Alpha Fade</strong> and <strong>Zoom</strong> do not apply to Dial charts.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295600959425065284)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_text=>'Alpha Fade'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762458308249736)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_text=>'Fade in the chart when initially displayed. This setting does not apply to Gantt charts.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295600871317065284)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762349444249735)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_text=>'Apply the Oracle JET defined default animation settings for the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295601128905065285)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762699044249738)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_text=>'No animation applied to the chart when initially displayed.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295601049556065285)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_text=>'Zoom'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762531376249737)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_text=>'Zoom in to the chart when initially displayed. This setting does not apply to Gantt charts.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295600655110065283)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_text=>'On Display'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749384393661392)
,p_name=>'PE.PROPERTY.APEX_FILES_PATH.PROMPT'
,p_message_text=>'#APEX_FILES# Path'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194706340982626)
,p_name=>'PE.PROPERTY.API_CUSTOM_DATA_TYPE.HELP'
,p_message_text=>'Enter the name of the custom data type of the parameter.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194646019982626)
,p_name=>'PE.PROPERTY.API_CUSTOM_DATA_TYPE.PROMPT'
,p_message_text=>'Data Type Name'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192943989982624)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.HELP'
,p_message_text=>'Data type of the parameter as it''s defined in the selected procedure or function.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194195236982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.BLOB.D'
,p_message_text=>'BLOB'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193486291982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.BOOLEAN.D'
,p_message_text=>'BOOLEAN'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194258946982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.CHAR.D'
,p_message_text=>'CHAR'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193170427982624)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.CLOB.D'
,p_message_text=>'CLOB'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194475375982626)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.CUSTOM.D'
,p_message_text=>'Custom'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194525403982626)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.CUSTOM.HELP'
,p_message_text=>'Use Custom if it''s not a standard PL/SQL data type. Custom allows to specify the name of a PL/SQL record type or Database object type.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193512343982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.DATE.D'
,p_message_text=>'DATE'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194051392982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.INTERVAL DAY TO SECOND.D'
,p_message_text=>'INTERVAL DAY TO SECOND'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193940127982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.INTERVAL YEAR TO MONTH.D'
,p_message_text=>'INTERVAL YEAR TO MONTH'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193265140982624)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.NUMBER.D'
,p_message_text=>'NUMBER'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193334257982624)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.PLS_INTEGER.D'
,p_message_text=>'PL/SQL INTEGER'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194355663982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.ROWID.D'
,p_message_text=>'ROWID'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193715637982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.TIMESTAMP WITH LOCAL TIME ZONE.D'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193897052982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.TIMESTAMP WITH TIME ZONE.D'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193658050982625)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_text=>'TIMESTAMP'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130193001668982624)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.LOV.VARCHAR2.D'
,p_message_text=>'VARCHAR2'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192846795982624)
,p_name=>'PE.PROPERTY.API_DATA_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35135226420835726)
,p_name=>'PE.PROPERTY.API_DIRECTION.COMPONENT_PROPERTY.PAGE_PROCESS_WS_PARAM.HELP'
,p_message_text=>'The direction of the parameter as defined within the REST Data Source.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192245631982624)
,p_name=>'PE.PROPERTY.API_DIRECTION.HELP'
,p_message_text=>'Select the direction of the parameter as it''s defined in the selected procedure or function.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192362561982624)
,p_name=>'PE.PROPERTY.API_DIRECTION.LOV.IN.D'
,p_message_text=>'In'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192545709982624)
,p_name=>'PE.PROPERTY.API_DIRECTION.LOV.IN_OUT.D'
,p_message_text=>'In/Out'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192406118982624)
,p_name=>'PE.PROPERTY.API_DIRECTION.LOV.OUT.D'
,p_message_text=>'Out'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192126509982623)
,p_name=>'PE.PROPERTY.API_DIRECTION.PROMPT'
,p_message_text=>'Direction'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606177575500648)
,p_name=>'PE.PROPERTY.API_INTERFACE.LOV.1.D'
,p_message_text=>'Function'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606066485500648)
,p_name=>'PE.PROPERTY.API_INTERFACE.LOV.2.D'
,p_message_text=>'Procedure'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605988595500648)
,p_name=>'PE.PROPERTY.API_INTERFACE.PROMPT'
,p_message_text=>'API Interface'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195029662982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.HELP'
,p_message_text=>'Select how this parameter is populated.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196365556982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.API_DEFAULT.D'
,p_message_text=>'API Default'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196476856982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.API_DEFAULT.HELP'
,p_message_text=>'Use the value defined as default in the API parameter declaration.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195707508982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195857364982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>Expression</em> entered.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195988813982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196089568982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195375843982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195452935982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196501416982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196654317982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.NULL.HELP'
,p_message_text=>'Set to NULL as no value specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196188939982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.PREFERENCE.D'
,p_message_text=>'Preference'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196239341982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.PREFERENCE.HELP'
,p_message_text=>'Set to the value of the <em>Preference</em> entered.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195502371982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195679808982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.SQL_QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195121577982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130195257989982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.LOV.STATIC.HELP'
,p_message_text=>'Set to the value entered into <em>Static Value</em>.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194975937982631)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BASIC.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196896434982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.HELP'
,p_message_text=>'Select how this parameter is populated.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197512996982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.API_DEFAULT.D'
,p_message_text=>'API Default'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197660328982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.API_DEFAULT.HELP'
,p_message_text=>'Use the value defined as default in the API parameter declaration.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197160051982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197283981982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>Expression</em> entered.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197377435982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197472657982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197702962982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197849244982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.NULL.HELP'
,p_message_text=>'Set to NULL as no BLOB specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196937919982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197041966982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.LOV.SQL_QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130196786821982632)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_BLOB.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198089356982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.HELP'
,p_message_text=>'Select how this parameter is populated.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198510136982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.LOV.API_DEFAULT.D'
,p_message_text=>'API Default'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198663430982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.LOV.API_DEFAULT.HELP'
,p_message_text=>'Use the value defined as default in the API parameter declaration.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198107055982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.LOV.EXPRESSION.D'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198206419982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>PL/SQL Expression</em> entered.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198384880982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.LOV.FUNCTION_BODY.D'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198464058982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>PL/SQL Function Body</em> entered.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198798921982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.LOV.NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198821187982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.LOV.NULL.HELP'
,p_message_text=>'Set to an empty data type.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130197974296982633)
,p_name=>'PE.PROPERTY.API_VALUE_TYPE_CUSTOM.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586672100901045666)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596948660078296957)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589856006857239294)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_text=>'Enter additional space delimited CSS classes you want to add to your report. Your report template must include the <code>#COMPONENT_CSS_CLASSES#</code> substitution string.'
,p_version_scn=>37166067046536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245991899500481468)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter classes to add to this component. You may add multiple classes by separating them with spaces.</p>',
'',
'        <p>Note: These CSS classes will be applied to the cells in the Interactive Grid. To apply CSS classes to the corresponding item, please see the CSS Classes property under the Advanced group.</p>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976761093250630)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IR_COLUMN_ACTION.HELP'
,p_message_text=>'Enter classes to add to this action. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586671887020045654)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046492
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586671921675045662)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter classes to add to this item. You may add multiple classes by separating them with spaces.<p/>',
'        <p>This property can be used to make style modifications to the item, beyond template options, or to provide a simpler way of selecting this item via JavaScript.</p>',
'        <p>Note: To apply CSS classes to the HTML form element tag, please see the CSS Classes property under the Advanced group.</p>'))
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586672271284045668)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976161397250628)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_ACTION.HELP'
,p_message_text=>'Enter classes to add to this action. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589856221746239310)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589856181877239298)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_text=>'Enter additional space delimited CSS classes you want to add to your report. Your report template must include the <code>#COMPONENT_CSS_CLASSES#</code> substitution string.'
,p_version_scn=>37166067046537
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586671710055045543)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Add the CSS classes <code>articlenumber</code> and <code>highlight</code> to the component</dt>',
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586671682996045543)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_text=>'Enter CSS classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586671539921045543)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718466288661330)
,p_name=>'PE.PROPERTY.APPLICATION_GROUP.PROMPT'
,p_message_text=>'Application Group'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730047355661340)
,p_name=>'PE.PROPERTY.APP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720463232661332)
,p_name=>'PE.PROPERTY.APP_AVAILABILITY.LOV.AVAILABLE.D'
,p_message_text=>'Available'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720567706661332)
,p_name=>'PE.PROPERTY.APP_AVAILABILITY.LOV.AVAILABLE_W_EDIT_LINK.D'
,p_message_text=>'Available with Developer Toolbar'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720616939661332)
,p_name=>'PE.PROPERTY.APP_AVAILABILITY.LOV.DEVELOPERS_ONLY.D'
,p_message_text=>'Available to Developers Only'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720714938661332)
,p_name=>'PE.PROPERTY.APP_AVAILABILITY.LOV.RESTRICTED_ACCESS.D'
,p_message_text=>'Restricted Access'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720885980661332)
,p_name=>'PE.PROPERTY.APP_AVAILABILITY.LOV.UNAVAILABLE.D'
,p_message_text=>'Unavailable'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720953240661332)
,p_name=>'PE.PROPERTY.APP_AVAILABILITY.LOV.UNAVAILABLE_PLSQL.D'
,p_message_text=>'Unavailable (Status Shown with PL/SQL)'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721038264661332)
,p_name=>'PE.PROPERTY.APP_AVAILABILITY.LOV.UNAVAILABLE_URL.D'
,p_message_text=>'Unavailable (Redirect to URL)'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720339976661332)
,p_name=>'PE.PROPERTY.APP_AVAILABILITY.PROMPT'
,p_message_text=>'Status'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576525631340719)
,p_name=>'PE.PROPERTY.APP_COMPUTATION_ID.HELP'
,p_message_text=>'Identifies the application computation.'
,p_version_scn=>49870253
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576429292340719)
,p_name=>'PE.PROPERTY.APP_COMPUTATION_ID.PROMPT'
,p_message_text=>'Application Computation'
,p_version_scn=>49870253
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494283861272152)
,p_name=>'PE.PROPERTY.APP_COMPUTATION_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this application computation on an existing application computation in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494152264272152)
,p_name=>'PE.PROPERTY.APP_COMPUTATION_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745228318661354)
,p_name=>'PE.PROPERTY.APP_DATE_FORMAT.PROMPT'
,p_message_text=>'Date'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745383081661354)
,p_name=>'PE.PROPERTY.APP_DATE_TIME_FORMAT.PROMPT'
,p_message_text=>'Date Time'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749271388661391)
,p_name=>'PE.PROPERTY.APP_FILES_PATH.PROMPT'
,p_message_text=>'#APP_FILES# Path'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675338880661289)
,p_name=>'PE.PROPERTY.APP_ITEM_DATA_TYPE.LOV.NUMBER.D'
,p_message_text=>'NUMBER'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675421818661289)
,p_name=>'PE.PROPERTY.APP_ITEM_DATA_TYPE.LOV.VARCHAR.D'
,p_message_text=>'VARCHAR'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675214303661289)
,p_name=>'PE.PROPERTY.APP_ITEM_DATA_TYPE.PROMPT'
,p_message_text=>'Session State Data Type'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576189403340719)
,p_name=>'PE.PROPERTY.APP_ITEM_ID.HELP'
,p_message_text=>'Identifies the application item.'
,p_version_scn=>49870252
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576050165340719)
,p_name=>'PE.PROPERTY.APP_ITEM_ID.PROMPT'
,p_message_text=>'Application Item'
,p_version_scn=>49870251
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783455918903)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the scope of this application item. Select <strong>Global</strong> if the &PRODUCT_NAME. session is shared by more than one application and the item''s value should be the same for all applications.',
'Otherwise, select <strong>Application</strong>, which is the default scope.</p>',
'<p>Applications can share the same session, if their authentications have the same <em>Session Cookie Attributes</em>.',
'The scope attribute, of application items, has to be the same across these applications as well.</p>'))
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516785949183751567)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_text=>'Application'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786031121751567)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_text=>'Global'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783454918903)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_text=>'Scope'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80493871682272152)
,p_name=>'PE.PROPERTY.APP_ITEM_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this application item on an existing application item in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80493764406272152)
,p_name=>'PE.PROPERTY.APP_ITEM_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744618477661353)
,p_name=>'PE.PROPERTY.APP_LANGUAGE_DERIVED_FROM.LOV.0.D'
,p_message_text=>'No NLS (Application not translated)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744850277661354)
,p_name=>'PE.PROPERTY.APP_LANGUAGE_DERIVED_FROM.LOV.BROWSER.D'
,p_message_text=>'Browser (use browser language preference)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744935248661354)
,p_name=>'PE.PROPERTY.APP_LANGUAGE_DERIVED_FROM.LOV.FLOW_PREFERENCE.D'
,p_message_text=>'Application Preference (use FSP_LANGUAGE_PREFERENCE)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744781440661353)
,p_name=>'PE.PROPERTY.APP_LANGUAGE_DERIVED_FROM.LOV.FLOW_PRIMARY_LANGUAGE.D'
,p_message_text=>'Application Primary Language'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745009706661354)
,p_name=>'PE.PROPERTY.APP_LANGUAGE_DERIVED_FROM.LOV.ITEM_PREFERENCE.D'
,p_message_text=>'Item Preference (use item containing preference)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745185050661354)
,p_name=>'PE.PROPERTY.APP_LANGUAGE_DERIVED_FROM.LOV.SESSION.D'
,p_message_text=>'Session'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744527201661353)
,p_name=>'PE.PROPERTY.APP_LANGUAGE_DERIVED_FROM.PROMPT'
,p_message_text=>'Language Derived From'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730782072661341)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AF.D'
,p_message_text=>'Afrikaans (af)'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732372119661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-AE.D'
,p_message_text=>'Arabic (U.A.E.) (ar-ae)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731010209661341)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-BH.D'
,p_message_text=>'Arabic (Bahrain) (ar-bh)'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730931083661341)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-DZ.D'
,p_message_text=>'Arabic (Algeria) (ar-dz)'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731141543661341)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-EG.D'
,p_message_text=>'Arabic (Egypt) (ar-eg)'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731277411661341)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-IQ.D'
,p_message_text=>'Arabic (Iraq) (ar-iq)'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731395529661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-JO.D'
,p_message_text=>'Arabic (Jordan) (ar-jo)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731432794661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-KW.D'
,p_message_text=>'Arabic (Kuwait) (ar-kw)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731528235661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-LB.D'
,p_message_text=>'Arabic (Lebanon) (ar-lb)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731601349661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-LY.D'
,p_message_text=>'Arabic (Libya) (ar-ly)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731720918661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-MA.D'
,p_message_text=>'Arabic (Morocco) (ar-ma)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731898827661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-OM.D'
,p_message_text=>'Arabic (Oman) (ar-om)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242731912754661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-QA.D'
,p_message_text=>'Arabic (Qatar) (ar-qa)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732019756661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-SA.D'
,p_message_text=>'Arabic (Saudi Arabia) (ar-sa)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732195430661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-SY.D'
,p_message_text=>'Arabic (Syria) (ar-sy)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732252233661342)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-TN.D'
,p_message_text=>'Arabic (Tunisia) (ar-tn)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732456370661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR-YE.D'
,p_message_text=>'Arabic (Yemen) (ar-ye)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732501839661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AR.D'
,p_message_text=>'Arabic (ar)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732740999661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AS.D'
,p_message_text=>'Assamese (as)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732879622661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.AZ.D'
,p_message_text=>'Azerbaijani (az)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733046319661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.BE.D'
,p_message_text=>'Belarusian (be)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733257967661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.BG.D'
,p_message_text=>'Bulgarian (bg)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733143923661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.BN.D'
,p_message_text=>'Bengali (bn)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733302749661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.CA.D'
,p_message_text=>'Catalan (ca)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734152669661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.CS.D'
,p_message_text=>'Czech (cs)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744429854661353)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.CY.D'
,p_message_text=>'Welsh (cy)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734278565661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.DA.D'
,p_message_text=>'Danish (da)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737182672661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.DE-AT.D'
,p_message_text=>'German (Austria) (de-at)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737530130661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.DE-CH.D'
,p_message_text=>'German (Switzerland) (de-ch)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737383414661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.DE-LI.D'
,p_message_text=>'German (Liechtenstein) (de-li)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737455094661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.DE-LU.D'
,p_message_text=>'German (Luxemgourg) (de-lu)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737259901661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.DE.D'
,p_message_text=>'German (Germany) (de)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737665935661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EL.D'
,p_message_text=>'Greek (el)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734565613661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-AU.D'
,p_message_text=>'English (Australia) (en-au)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734638246661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-BZ.D'
,p_message_text=>'English (Belize) (en-bz)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734707263661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-CA.D'
,p_message_text=>'English (Canada) (en-ca)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735491183661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-GB.D'
,p_message_text=>'English (United Kingdom) (en-gb)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734890828661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-IE.D'
,p_message_text=>'English (Ireland) (en-ie)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734955590661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-JM.D'
,p_message_text=>'English (Jamaica) (en-jm)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735025563661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-NZ.D'
,p_message_text=>'English (New Zealand) (en-nz)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735114790661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-PH.D'
,p_message_text=>'English (Philippines) (en-ph)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735393470661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-TT.D'
,p_message_text=>'English (Trinidad) (en-tt)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735522026661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-US.D'
,p_message_text=>'English (United States) (en-us)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735211925661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-ZA.D'
,p_message_text=>'English (South Africa) (en-za)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735619945661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN-ZW.D'
,p_message_text=>'English (Zimbabwe) (en-zw)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735790736661345)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EN.D'
,p_message_text=>'English (en)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741311824661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-AR.D'
,p_message_text=>'Spanish (Argentina) (es-ar)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741438800661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-BO.D'
,p_message_text=>'Spanish (Bolivia) (es-bo)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741589730661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-CL.D'
,p_message_text=>'Spanish (Chile) (es-cl)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741684707661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-CO.D'
,p_message_text=>'Spanish (Colombia) (es-co)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741761868661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-CR.D'
,p_message_text=>'Spanish (Costa Rica) (es-cr)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741854499661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-DO.D'
,p_message_text=>'Spanish (Dominican Republic) (es-do)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741943429661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-EC.D'
,p_message_text=>'Spanish (Ecuador) (es-ec)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742172648661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-GT.D'
,p_message_text=>'Spanish (Guatemala) (es-gt)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742213916661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-HN.D'
,p_message_text=>'Spanish (Honduras) (es-hn)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742387339661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-MX.D'
,p_message_text=>'Spanish (Mexico) (es-mx)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742437143661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-NI.D'
,p_message_text=>'Spanish (Nicaragua) (es-ni)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742552630661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-PA.D'
,p_message_text=>'Spanish (Panama) (es-pa)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742704357661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-PE.D'
,p_message_text=>'Spanish (Peru) (es-pe)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742894569661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-PR.D'
,p_message_text=>'Spanish (Puerto Rico) (es-pr)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742690614661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-PY.D'
,p_message_text=>'Spanish (Paraguay) (es-py)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742081920661351)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-SV.D'
,p_message_text=>'Spanish (El Salvador) (es-sv)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743082429661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-US.D'
,p_message_text=>'Spanish (United States) (es-us)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743129826661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-UY.D'
,p_message_text=>'Spanish (Uruguay) (es-uy)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743200061661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES-VE.D'
,p_message_text=>'Spanish (Venezuela) (es-ve)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242742939697661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ES.D'
,p_message_text=>'Spanish (Traditional Sort) (es)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735839664661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ET.D'
,p_message_text=>'Estonian (et)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732904800661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.EU.D'
,p_message_text=>'Basque (eu)'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736161928661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.FA.D'
,p_message_text=>'Farsi (fa)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736221542661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.FI.D'
,p_message_text=>'Finnish (fi)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736012992661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.FO.D'
,p_message_text=>'Faeroese (fo)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736398224661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.FR-BE.D'
,p_message_text=>'French (Belgium) (fr-be)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736486919661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.FR-CA.D'
,p_message_text=>'French (Canada) (fr-ca)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736831829661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.FR-CH.D'
,p_message_text=>'French (Switzerland) (fr-ch)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736664878661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.FR-LU.D'
,p_message_text=>'French (Luxembourg) (fr-lu)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736716932661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.FR-MC.D'
,p_message_text=>'French (Monaco) (fr-mc)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736520554661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.FR.D'
,p_message_text=>'French (France) (fr)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738382735661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.GA.D'
,p_message_text=>'Irish (ga)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242736991397661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.GD.D'
,p_message_text=>'Gaelic (gd)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737042889661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.GL.D'
,p_message_text=>'Galician (gl)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737785480661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.GU.D'
,p_message_text=>'Gujarati (gu)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737801894661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.HE.D'
,p_message_text=>'Hebrew (he)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242737950208661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.HI.D'
,p_message_text=>'Hindi (hi)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734098196661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.HR.D'
,p_message_text=>'Croatian (hr)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738040754661347)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.HU.D'
,p_message_text=>'Hungarian (hu)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242732697351661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.HY.D'
,p_message_text=>'Armenian'
,p_version_scn=>37166067046420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738222070661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ID.D'
,p_message_text=>'Indonesian (id)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738134059661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.IS.D'
,p_message_text=>'Icelandic (is)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738505811661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.IT-CH.D'
,p_message_text=>'Italian (Switzerland) (it-ch)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738430007661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.IT.D'
,p_message_text=>'Italian (Italy) (it)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738672591661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.JA.D'
,p_message_text=>'Japanese (ja)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738861825661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.KK.D'
,p_message_text=>'Kazakh (kk)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738717941661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.KN.D'
,p_message_text=>'Kannada (kn)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739017750661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.KO.D'
,p_message_text=>'Korean (ko)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242738962543661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.KOK.D'
,p_message_text=>'Konkani (kok)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739135466661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.KZ.D'
,p_message_text=>'Kyrgyz (kz)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739341673661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.LT.D'
,p_message_text=>'Lithuanian (lt)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739299524661348)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.LV.D'
,p_message_text=>'Latvian (lv)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242735998539661346)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.MK.D'
,p_message_text=>'FYRO Macedonian (mk)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739546341661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ML.D'
,p_message_text=>'Malayalam (ml)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739780025661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.MR.D'
,p_message_text=>'Marathi (mr)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739476438661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.MS.D'
,p_message_text=>'Malay (Malaysia) (ms)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739617867661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.MT.D'
,p_message_text=>'Maltese (mt)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739903264661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.NB-NO.D'
,p_message_text=>'Norwegian (Bokmal) (nb-no)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242739822477661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.NE.D'
,p_message_text=>'Nepali (India) (ne)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734378664661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.NL-BE.D'
,p_message_text=>'Dutch (Belgium) (nl-be)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242734494694661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.NL.D'
,p_message_text=>'Dutch (Netherlands) (nl)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740183711661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.NN-NO.D'
,p_message_text=>'Norwegian (Nynorsk) (nn-no)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740044863661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.NO.D'
,p_message_text=>'Norwegian (Bokmal) (no)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740206893661349)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.OR.D'
,p_message_text=>'Oriya (or)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740614541661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.PA.D'
,p_message_text=>'Punjabi (pa)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740308751661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.PL.D'
,p_message_text=>'Polish (pl)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740448173661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.PT-BR.D'
,p_message_text=>'Portuguese (Brazil) (pt-br)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740517365661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.PT.D'
,p_message_text=>'Portuguese (Portugal) (pt)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740716257661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.RO.D'
,p_message_text=>'Romanian (ro)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740826080661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.RU-MD.D'
,p_message_text=>'Russian (Moldova) (ru-md)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242740928205661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.RU.D'
,p_message_text=>'Russian (ru)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741130362661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.SK.D'
,p_message_text=>'Slovak (sk)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741270925661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.SL.D'
,p_message_text=>'Slovenian (sl)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730847871661341)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.SQ.D'
,p_message_text=>'Albanian'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242741077332661350)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.SR.D'
,p_message_text=>'Serbian (sr)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743447509661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.SV-FI.D'
,p_message_text=>'Swedish (Finland) (sv-fi)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743506878661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.SV.D'
,p_message_text=>'Swedish (sv)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743352248661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.SW.D'
,p_message_text=>'Swahili (sw)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743651065661352)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.TA.D'
,p_message_text=>'Tamil (ta)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743785661661353)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.TE.D'
,p_message_text=>'Telugu (te)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743843976661353)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.TH.D'
,p_message_text=>'Thai (th)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242743996131661353)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.TR.D'
,p_message_text=>'Turkish (tr)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744086601661353)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.UK.D'
,p_message_text=>'Ukrainian (uk)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744177315661353)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.UR.D'
,p_message_text=>'Urdu (ur)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744235527661353)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.UZ.D'
,p_message_text=>'Uzbek (uz)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242744399091661353)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.VI.D'
,p_message_text=>'Vietnamese (vi)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733470165661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ZH-CN.D'
,p_message_text=>'Chinese (China) (zh-cn)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733598595661343)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ZH-HK.D'
,p_message_text=>'Chinese (Hong Kong SAR) (zh-hk)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733691931661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ZH-MO.D'
,p_message_text=>'Chinese (Macau SAR) (zh-mo)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733745180661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ZH-SG.D'
,p_message_text=>'Chinese (Singapore) (zh-sg)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733844394661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ZH-TW.D'
,p_message_text=>'Chinese (Taiwan) (zh-tw)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242733932255661344)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.LOV.ZH.D'
,p_message_text=>'Chinese (zh)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730611977661341)
,p_name=>'PE.PROPERTY.APP_PRIMARY_LANGUAGE.PROMPT'
,p_message_text=>'Primary Language'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576379769340719)
,p_name=>'PE.PROPERTY.APP_PROCESS_ID.HELP'
,p_message_text=>'Identifies the application process.'
,p_version_scn=>49870253
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576258910340719)
,p_name=>'PE.PROPERTY.APP_PROCESS_ID.PROMPT'
,p_message_text=>'Application Process'
,p_version_scn=>49870252
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674628442661289)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_text=>'After Regions'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674870037661289)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_text=>'After Footer'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674462214661289)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_text=>'After Header'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674100631661288)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.AFTER_LOGIN.D'
,p_message_text=>'After Authentication'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675086783661289)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_text=>'Processing'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674557250661289)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_text=>'Before Regions'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674747933661289)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_text=>'Before Footer'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674335072661288)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_text=>'Before Header'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675134409661289)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_text=>'Ajax Callback'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674212431661288)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_text=>'New Session'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674930293661289)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_text=>'After Submit'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242674001029661288)
,p_name=>'PE.PROPERTY.APP_PROCESS_POINT.PROMPT'
,p_message_text=>'Point'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494002389272152)
,p_name=>'PE.PROPERTY.APP_PROCESS_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this application process on an existing application process in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80493984805272152)
,p_name=>'PE.PROPERTY.APP_PROCESS_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728151739661339)
,p_name=>'PE.PROPERTY.APP_SESSION_STATE_PROTECTION.PROMPT'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576753187340720)
,p_name=>'PE.PROPERTY.APP_SETTING_ID.HELP'
,p_message_text=>'Identifies the application setting.'
,p_version_scn=>49870254
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576666405340720)
,p_name=>'PE.PROPERTY.APP_SETTING_ID.PROMPT'
,p_message_text=>'Application Setting'
,p_version_scn=>49870254
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179854017003688496)
,p_name=>'PE.PROPERTY.APP_SETTING_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this application setting on an existing application setting in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179853944385688496)
,p_name=>'PE.PROPERTY.APP_SETTING_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745480834661354)
,p_name=>'PE.PROPERTY.APP_TIMESTAMP_FORMAT.PROMPT'
,p_message_text=>'Timestamp'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745537067661354)
,p_name=>'PE.PROPERTY.APP_TIMESTAMP_TZ_FORMAT.PROMPT'
,p_message_text=>'Timestamp Time Zone'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623115961065364)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_text=>'Specify whether the current series is assigned to the Y2 axis rendered on the chart.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623039751065364)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_text=>'Assigned To Y2 Axis'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156037216363350912)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_text=>'Select the column associated with this page processing component.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156037125044350912)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_text=>'Associated Column'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156037000679350912)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the item where this validation error message displays.',
'If you select an item and the <em>Error message display location</em> includes "Inline with Field", the error message displays underneath the label of the specified item.',
'If the <em>Error message display location</em> does not include "Inline with Field", this attribute has no impact on the display of the error message.'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156036916150350912)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_text=>'Associated Item'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636924343500671)
,p_name=>'PE.PROPERTY.ATTRIBUTE_01.PROMPT'
,p_message_text=>'Attribute 1'
,p_version_scn=>37166067046456
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637089885500671)
,p_name=>'PE.PROPERTY.ATTRIBUTE_02.PROMPT'
,p_message_text=>'Attribute 2'
,p_version_scn=>37166067046456
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637132684500671)
,p_name=>'PE.PROPERTY.ATTRIBUTE_03.PROMPT'
,p_message_text=>'Attribute 3'
,p_version_scn=>37166067046456
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637214085500671)
,p_name=>'PE.PROPERTY.ATTRIBUTE_04.PROMPT'
,p_message_text=>'Attribute 4'
,p_version_scn=>37166067046456
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637307874500671)
,p_name=>'PE.PROPERTY.ATTRIBUTE_05.PROMPT'
,p_message_text=>'Attribute 5'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637472650500671)
,p_name=>'PE.PROPERTY.ATTRIBUTE_06.PROMPT'
,p_message_text=>'Attribute 6'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637566275500671)
,p_name=>'PE.PROPERTY.ATTRIBUTE_07.PROMPT'
,p_message_text=>'Attribute 7'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637652277500671)
,p_name=>'PE.PROPERTY.ATTRIBUTE_08.PROMPT'
,p_message_text=>'Attribute 8'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637710244500672)
,p_name=>'PE.PROPERTY.ATTRIBUTE_09.PROMPT'
,p_message_text=>'Attribute 9'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637807257500672)
,p_name=>'PE.PROPERTY.ATTRIBUTE_10.PROMPT'
,p_message_text=>'Attribute 10'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143637913040500672)
,p_name=>'PE.PROPERTY.ATTRIBUTE_11.PROMPT'
,p_message_text=>'Attribute 11'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638003816500672)
,p_name=>'PE.PROPERTY.ATTRIBUTE_12.PROMPT'
,p_message_text=>'Attribute 12'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638118370500672)
,p_name=>'PE.PROPERTY.ATTRIBUTE_13.PROMPT'
,p_message_text=>'Attribute 13'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638222387500672)
,p_name=>'PE.PROPERTY.ATTRIBUTE_14.PROMPT'
,p_message_text=>'Attribute 14'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638360750500672)
,p_name=>'PE.PROPERTY.ATTRIBUTE_15.PROMPT'
,p_message_text=>'Attribute 15'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606628061500649)
,p_name=>'PE.PROPERTY.AUTHENTICATION_FUNCTION_NAME.PROMPT'
,p_message_text=>'Authentication Function Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577947696340720)
,p_name=>'PE.PROPERTY.AUTHENTICATION_ID.HELP'
,p_message_text=>'Identifies the authentication scheme.'
,p_version_scn=>49870259
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577826164340720)
,p_name=>'PE.PROPERTY.AUTHENTICATION_ID.PROMPT'
,p_message_text=>'Authentication Scheme'
,p_version_scn=>49870259
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711818085661324)
,p_name=>'PE.PROPERTY.AUTHENTICATION_SERVER.PROMPT'
,p_message_text=>'Authentication Server'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661377760661099)
,p_name=>'PE.PROPERTY.AUTHENTICATION_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this authentication scheme on an existing authentication scheme in this application or another application in your workspace.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661284650661099)
,p_name=>'PE.PROPERTY.AUTHENTICATION_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661127874661099)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select which authentication scheme is applied. The following authentication types are supported:</p>',
'#NATIVE_PLUGINS#',
'<p>Depending on your application configuration, you may have additional authentication type plug-ins available here.',
'These are displayed as <em>&lt;My Plugin&gt; [Plug-in]</em>.',
'The following plug-ins are installed in this application''s shared components:</p>',
'#CUSTOM_PLUGINS#'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150987627084822705)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578187683340720)
,p_name=>'PE.PROPERTY.AUTHORIZATION_ID.HELP'
,p_message_text=>'Identifies the authorization scheme.'
,p_version_scn=>49870259
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578066528340720)
,p_name=>'PE.PROPERTY.AUTHORIZATION_ID.PROMPT'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>49870259
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123169907157211912)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an authorization scheme applied to the page. Authorization schemes are defined at the application-level and can be applied to many elements within the application.</p>',
'<p>An authorization scheme is evaluated either once for each application session (at session creation), or once for each page view. If the selected authorization scheme evaluates to <strong>TRUE</strong>, then the page displays and is subject to othe'
||'r defined conditions. If it evaluates to <strong>FALSE</strong>, then the page does not display and an error message displays.</p>'))
,p_version_scn=>37166067046493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123102214513211800)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_text=>'Select an authorization scheme to control this component. The authorization must evaluate to TRUE in order for this component to be rendered or executed.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123102100838211800)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691327368661305)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123087121257211764)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify how this authorization scheme will be applied. The following types are supported:</p>',
'#NATIVE_PLUGINS#',
'<p>Depending on your application configuration, you may also have additional authorization type plug-ins available here.',
'These display as <em>&lt;My Plug-in&gt; [Plug-in]</em>.',
'The following plug-ins install into this application''s shared components:</p>',
'#CUSTOM_PLUGINS#'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123087006133211764)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726880888661337)
,p_name=>'PE.PROPERTY.AUTHORIZE_BACKGROUND_JOBS.PROMPT'
,p_message_text=>'Run on Background Job'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726736397661337)
,p_name=>'PE.PROPERTY.AUTHORIZE_PUBLIC_PAGES.PROMPT'
,p_message_text=>'Run on Public Pages'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12172370648222388)
,p_name=>'PE.PROPERTY.AUTH_CONFIG_PROCEDURE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Enter the name of a procedure which configures authentication at runtime.'))
,p_version_scn=>38984022
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18581907051295464)
,p_name=>'PE.PROPERTY.AUTH_CONFIG_PROCEDURE.PROMPT'
,p_message_text=>'Configuration Procedure'
,p_version_scn=>38984017
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711991691661324)
,p_name=>'PE.PROPERTY.AUTH_URL_PATH_PREFIX.PROMPT'
,p_message_text=>'URL Path Prefix'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746239739661355)
,p_name=>'PE.PROPERTY.AUTOMATIC_CSV_ENCODING.PROMPT'
,p_message_text=>'Automatic CSV Encoding'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746187957661355)
,p_name=>'PE.PROPERTY.AUTOMATIC_TIME_ZONE.PROMPT'
,p_message_text=>'Automatic Time Zone'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(766619938041246222)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716094841661328)
,p_name=>'PE.PROPERTY.AUTOMATION_TRIGGER_TYPE.LOV.API.D'
,p_message_text=>'On Demand'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716195778661328)
,p_name=>'PE.PROPERTY.AUTOMATION_TRIGGER_TYPE.LOV.POLLING.D'
,p_message_text=>'Scheduled'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715984411661328)
,p_name=>'PE.PROPERTY.AUTOMATION_TRIGGER_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(766619871092246222)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_text=>'Specify the source of the data evaluated during the execution of the automation. Automations can be based on tables, SQL queries or PL/SQL functions returning a SQL query.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(766619789236246221)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_text=>'Source Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209568514982817)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209483314982817)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209334898982817)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209621867982817)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209223589982817)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209198372982817)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113179179276433)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113022127276433)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112934765276433)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113227171276434)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112850121276433)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242767946890661473)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242768850406661474)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615968609484680)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242767838449661473)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616147363484681)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242768705057661474)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766905248661472)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615889186484680)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242767719525661473)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616019166484681)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242768609631661474)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242768087272661473)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242768905857661474)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615789171484680)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242767666761661473)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175615647341484680)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully as one or more rows exist when checking if the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>To return successfully as no rows exist when checking if the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766860184661472)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766260017661472)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766389728661472)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766577237661472)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766604973661472)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766738962661472)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766493222661472)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242766157242661471)
,p_name=>'PE.PROPERTY.AUTOM_CONDITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110868957276428)
,p_name=>'PE.PROPERTY.AUTOM_FUNC_BODY_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111171307276429)
,p_name=>'PE.PROPERTY.AUTOM_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111038247276428)
,p_name=>'PE.PROPERTY.AUTOM_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110954710276428)
,p_name=>'PE.PROPERTY.AUTOM_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111255701276429)
,p_name=>'PE.PROPERTY.AUTOM_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110792485276428)
,p_name=>'PE.PROPERTY.AUTOM_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242757577066661464)
,p_name=>'PE.PROPERTY.AUTOM_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a Java function body returning boolean which executes when the automation runs.',
'If the function body returns <strong>true</strong>, the actions will be executed.'))
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242757462227661464)
,p_name=>'PE.PROPERTY.AUTOM_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614204296484672)
,p_name=>'PE.PROPERTY.AUTOM_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242757359942661464)
,p_name=>'PE.PROPERTY.AUTOM_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a JavaScript function body returning boolean which executes when the automation runs.',
'If the function body returns <strong>true</strong>, the actions will be executed.'))
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242757219339661463)
,p_name=>'PE.PROPERTY.AUTOM_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614170296484672)
,p_name=>'PE.PROPERTY.AUTOM_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242757182418661463)
,p_name=>'PE.PROPERTY.AUTOM_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a PL/SQL function body returning boolean which executes when the automation runs.',
'If the function body returns <strong>true</strong>, the actions will be executed.'))
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242757004061661463)
,p_name=>'PE.PROPERTY.AUTOM_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242757776949661464)
,p_name=>'PE.PROPERTY.AUTOM_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a Python function body returning boolean which executes when the automation runs.',
'If the function body returns <strong>true</strong>, the actions will be executed.'))
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242757693301661464)
,p_name=>'PE.PROPERTY.AUTOM_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1742128297820292)
,p_name=>'PE.PROPERTY.AUTO_DISMISS_SUCCESS_MSG.COMPONENT_PROPERTY.APPLICATION.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Before enabling automatic dismissal of success messages for an application, it is important to take into consideration the accessibility impact it could have on users who may use special technology to view their screen or need longer than the defa'
||'ult 5 seconds to perceive the message. Those users may not see or read a success message',
'        before it is dismissed from the page, and therefore they may potentially miss information in the success message. If important information is conveyed in success messages in this application, consider turning the auto-dismiss functionality of'
||'f, or provide users with a preference setting that allows them to opt-out of the auto-dismiss functionality. This can be done',
'        using the <a rel="noopener noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/apex/23.2/aexjs/apex.message.html#.setDismissPreferences">apex.message setDismissPreferences API</a> to influence the dismiss behavior.</p'
||'>'))
,p_version_scn=>131771082
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1742041869820276)
,p_name=>'PE.PROPERTY.AUTO_DISMISS_SUCCESS_MSG.HELP'
,p_message_text=>'When set to <strong>On</strong>, all success messages in this application will be dismissed automatically after 5 seconds unless a user interacts with the message.'
,p_version_scn=>131771073
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1741957716820276)
,p_name=>'PE.PROPERTY.AUTO_DISMISS_SUCCESS_MSG.PROMPT'
,p_message_text=>'Auto-Dismiss Success Messages'
,p_version_scn=>131771072
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295625172745065371)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_text=>'Enter the maximum value of the axis. Defaults to null for automatic calculation based on the data.'
,p_version_scn=>15114749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295625051366065371)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_text=>'Maximum'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624917649065370)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_text=>'Enter the minimum value of the axis. Defaults to null for automatic calculation based on the data.'
,p_version_scn=>15114749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624830811065370)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_text=>'Minimum'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626337185065375)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_text=>'Select the position of the label(s) to be rendered on the chart.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626478967065376)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626821313065377)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_text=>'Bottom'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626667705065376)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_text=>'End'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626563794065376)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_text=>'Start'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626774009065377)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_text=>'Top'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626294236065375)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_text=>'Position'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256713641739301)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_text=>'Select the axis scale. Only applies to numerical axes.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256838589739302)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_text=>'Linear'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256933581739302)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_text=>'Log'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256663395739301)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_text=>'Scale'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626105810065375)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_text=>'Enter the increment between major tick marks. Defaults to null for automatic calculation based on the data. Only applies to time and numerical axes.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626007538065374)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_text=>'Step'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601499397784524)
,p_name=>'PE.PROPERTY.BACKGROUND_COLOR_FOR_CHECKED_ROW.COMPONENT_PROPERTY.REPORT_TEMPLATE.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing report accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in report visualization.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 4.5:1 to ensure readability for individuals with varying level'
||'s of vision impairment.</li>',
'</ul>'))
,p_version_scn=>12189400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602171528500646)
,p_name=>'PE.PROPERTY.BACKGROUND_COLOR_FOR_CHECKED_ROW.PROMPT'
,p_message_text=>'Checked row'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601520092784524)
,p_name=>'PE.PROPERTY.BACKGROUND_COLOR_FOR_CURRENT_ROW.COMPONENT_PROPERTY.REPORT_TEMPLATE.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing report accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in report visualization.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 4.5:1 to ensure readability for individuals with varying level'
||'s of vision impairment.</li>',
'</ul>'))
,p_version_scn=>12189400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602208043500646)
,p_name=>'PE.PROPERTY.BACKGROUND_COLOR_FOR_CURRENT_ROW.PROMPT'
,p_message_text=>'Current row'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939694512296796)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_text=>'Select the column to be used as badge.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939507638296796)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_text=>'Badge Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939813601296797)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939723332296797)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_text=>'Badge CSS Classes'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940180006296797)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>To display movie ratings</dt>',
'    <dd>The Badge Column may be the RATING column, and the Badge Label can be "Stars"</dd>',
'</dl>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940046134296797)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_text=>'Enter the label for the badge to describe the badge value.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939984345296797)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_text=>'Badge Label'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596703405500642)
,p_name=>'PE.PROPERTY.BEFORE_COLUMN_HEADING.PROMPT'
,p_message_text=>'Before Heading'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597179509500642)
,p_name=>'PE.PROPERTY.BEFORE_EACH_ROW.PROMPT'
,p_message_text=>'Before Each Row'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114936507588758672)
,p_name=>'PE.PROPERTY.BEFORE_EXPIRE_INTERVAL.HELP'
,p_message_text=>'The interval in ISO or SQL format.'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114936440592758672)
,p_name=>'PE.PROPERTY.BEFORE_EXPIRE_INTERVAL.PROMPT'
,p_message_text=>'Before Expiration Interval'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596460827500641)
,p_name=>'PE.PROPERTY.BEFORE_FIRST_ROW.PROMPT'
,p_message_text=>'Top'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577397597500628)
,p_name=>'PE.PROPERTY.BEFORE_ITEM_TEMPLATE.PROMPT'
,p_message_text=>'Before'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578221600500629)
,p_name=>'PE.PROPERTY.BEFORE_LABEL_AND_ITEM_TEMPLATE.PROMPT'
,p_message_text=>'Before Label and Item'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577149817500628)
,p_name=>'PE.PROPERTY.BEFORE_LABEL_TEMPLATE.PROMPT'
,p_message_text=>'Before'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718140493661330)
,p_name=>'PE.PROPERTY.BEFORE_ROW_PROCESSING_PROCEDURE_NAME.PROMPT'
,p_message_text=>'Before Row Processing Procedure Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638476757500672)
,p_name=>'PE.PROPERTY.BEGINS_ON_NEW_LINE.PROMPT'
,p_message_text=>'Begins On New Line'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388947546799781569)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify when the calendar starts. Selecting this option creates a calendar that spans an entire interval such as a month.</p>',
'<ul>',
'  <li>If Begin at start of interval is <strong>On</strong>, the date is June 15th, and the display is monthly, the resulting calendar spans from June 1st to June 30th.</li>',
'  <li>If Begin at start of interval is <strong>Off</strong>, the date is June 15th, and the display is monthly, the resulting calendar spans from June 15th to June 30th.</li>',
'</ul>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388947493799781569)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_text=>'Begin at Start of Interval'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732950325495743)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_text=>'Select the character set column from the table which stores the BLOB content you want to display. The image is unlikely to display if you select a column with the wrong data type.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732869561495743)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_text=>'Character Set Column'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380731995484495741)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_text=>'Select the BLOB column from the table which stores the BLOB content you want to display. The image is unlikely to display if you select a column with the wrong data type.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380731803710495741)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_text=>'BLOB Column'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732795647495742)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_text=>'Enter the filename column from the table which stores the BLOB content you want to display. The image is unlikely to display if you select a column with the wrong data type.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732688276495742)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_text=>'Filename Column'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380733134961495743)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_text=>'Select the last updated column from the table which stores the BLOB content you want to display. If you already have an <code>UPDATED</code> column with an associated trigger to maintain the date, you could use this column instead of defining a new c'
||'olumn specifically for when the image was last updated. However, if columns other than the BLOB content are updated regularly, then image caching is adversely affected. The image is unlikely to display if you select a column with the wrong data type.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380733047895495743)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_text=>'Last Updated Column'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732522496495742)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_text=>'Select the mime type column from the table which stores the BLOB content you want to display. The image is unlikely to display if you select a column with the wrong data type.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732422614495742)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_text=>'Mime Type Column'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732185847495741)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_text=>'Select the first primary key column from the table which stores the BLOB content you want to display. If the primary key of this table has more than two columns, you must select the <code>ROWID</code> column. The image is unlikely to display if you s'
||'elect a column with the wrong data type.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732030431495741)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_text=>'Primary Key Column 1'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732382359495742)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_text=>'Only select the second primary key column if the primary key for your table has two columns. If you select <code>ROWID</code> for the first primary key column, you should not populate this column. The image is unlikely to display if you select a colu'
||'mn with the wrong data type.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380732241591495742)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_text=>'Primary Key Column 2'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380731792116495740)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the table name which stores the BLOB content you want to display.',
'You can type in the table name or pick from the list of available tables.'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380731605572495740)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_text=>'Table Name'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380731523481495740)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_text=>'Select the schema that owns the table which stores the BLOB content you want to display.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380731427062495740)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_text=>'Table Owner'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935249494296787)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_text=>'Specify whether this component displays using a column or advanced formatting using HTML expressions and supported substitution strings.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935189122296787)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_text=>'Advanced Formatting'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935411115296787)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_text=>'Select the column to be used as body.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935340917296787)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935910514296787)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935861763296787)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101801715211800)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter text or HTML you want to appear before regions that display on the running page.',
'Text you enter here appears before the page template <code>#BODY#</code> substitution string.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101731838211800)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_text=>'Body Header'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935717587296787)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Change the background and text colors</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Use Heading 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Use a dynamic class from the SQL query</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    The <code>&COLUMN_CLASS.</code> and <code>&EMPLOYEE_STATUS.</code> substitutions in this example are columns selected in the report SQL query.</dd>',
'  <dt>Show an image, and a tooltip on hover</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935665717296787)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_text=>'Enter HTML expressions to be shown in this column. Use <code>&COLUMN.</code> syntax to show column values in HTML.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935562949296787)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_text=>'HTML Expression'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381474639209264239)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_text=>'Enter the request to be included within the branch link.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381474505473264238)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_text=>'Request'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110205323276427)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG_VARCHAR2.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110599197276428)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110440099276427)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110371713276427)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110605736276428)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110174008276427)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380165120634832843)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page or application item containing a page number or URL to redirect to.',
'This item can be set by the calling page, or by a process when the page first loads.',
'Specifying an item provides an easy way to dynamically set the branch for pages that are called from many other pages.'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380165003312832841)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600306976703090677)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the Java function body that returns a page number or URL to redirect to.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600306812912090677)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613836799484670)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES" : "NO" );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600306688699090677)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the JavaScript function body that returns a page number or URL to redirect to.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600306515734090676)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155911523328354791)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_text=>'Enter the page to which this branch is redirected.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155911409526354791)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_text=>'Page Number'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155912110796354792)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_text=>'Enter the PL/SQL code executed by the branch. This PL/SQL procedure is responsible for invoking the necessary URL.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155912018511354792)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_text=>'PL/SQL Code'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613744843484670)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600306386050090676)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the PL/SQL function body that returns a page number or URL to redirect to.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600306236403090676)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155910627953354789)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_text=>'Select at what point in page rendering or processing this branch is executed.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773128578751510)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_text=>'After Processing'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374053403373796)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_text=>'Processing: Branches after processing performed.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772870635751510)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_text=>'After Submit'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373711539373794)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_text=>'Processing: Branches after submitting the page and before computation, validations and processes are executed.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773221843751510)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_text=>'Before Header'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374158549373797)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_text=>'Rendering: Branches before the page renders.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773058814751510)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_text=>'Processing'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373932833373795)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_text=>'Processing: Branches before processing performed.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772910792751510)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_text=>'Validating'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373851560373795)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_text=>'Processing: Branches before validations performed.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155910530412354789)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_text=>'Point'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307139339090677)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the Python function body that returns a page number or URL to redirect to.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307049381090677)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155909631777354787)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the type of page branch to perform.</p>',
'<dl>',
'<dt>Redirect branches</dt>',
'<dd>&PRODUCT_NAME. returns the new page or URL to the browser, which performs a new request before showing the resultant page.',
'The major advantage is that the end users can refresh the page without losing context, as the browser address contains the full page URL.',
'The disadvantage is that the browser performs an additional request to show the page.</dd>',
'<dt>Show Only branches</dt>',
'<dd>&PRODUCT_NAME. immediately renders the new page as part of the current page processing, without performing another request.',
'This has the advantage that the browser does not have to perform an additional request.',
'The major disadvantage is that the browser address will be <code>wwv_flow.accept</code>.',
'If the end users refreshes the page the browser will ask to resend the data, as the browser address is not a full page URL.</dd>',
'</dl>',
'<p>Oracle recommends that you select one of the redirect branch types to provide a better end user experience.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772246329751507)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_text=>'Function Returning a Page (Show only)'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772354438751508)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_text=>'Function Returning a URL (Redirect)'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772766984751509)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_text=>'Page Processing {not common}'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772523967751508)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_text=>'Page Identified by Item (Show only)'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772190056751507)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_text=>'Page (Show only)'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772619879751509)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_text=>'URL Identified by Item (Redirect)'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772495354751508)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_text=>'PL/SQL procedure [Legacy]'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516772005584751507)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_text=>'Page or URL (Redirect)'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155909512283354787)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575367629500627)
,p_name=>'PE.PROPERTY.BREADCRUMB_AFTER_LAST_TEMPLATE.PROMPT'
,p_message_text=>'After Last'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575016224500627)
,p_name=>'PE.PROPERTY.BREADCRUMB_BEFORE_FIRST_TEMPLATE.PROMPT'
,p_message_text=>'Before First'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575415106500627)
,p_name=>'PE.PROPERTY.BREADCRUMB_BETWEEN_LEVELS_TEMPLATE.PROMPT'
,p_message_text=>'Between Levels'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575128804500627)
,p_name=>'PE.PROPERTY.BREADCRUMB_CURRENT_PAGE_TEMPLATE.PROMPT'
,p_message_text=>'Current Page'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575511799500627)
,p_name=>'PE.PROPERTY.BREADCRUMB_MAXIMUM_LEVELS_TEMPLATE.PROMPT'
,p_message_text=>'Maximum Levels'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575251624500627)
,p_name=>'PE.PROPERTY.BREADCRUMB_NON_CURRENT_PAGE_TEMPLATE.PROMPT'
,p_message_text=>'Non Current Page'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691064559661305)
,p_name=>'PE.PROPERTY.BREADCRUMB_PAGE_NUMBER.PROMPT'
,p_message_text=>'Page Number'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590027555500637)
,p_name=>'PE.PROPERTY.BREADCRUMB_POSITION.PROMPT'
,p_message_text=>'Breadcrumb Position'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574540624500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_START_WITH.LOV.CHILD_MENU.D'
,p_message_text=>'Child Breadcrumb Entries'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574608928500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_START_WITH.LOV.CURRENT_MENU.D'
,p_message_text=>'Current Breadcrumb'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574793897500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_START_WITH.LOV.PARENT_MENU.D'
,p_message_text=>'Parent Breadcrumb Entries'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574873492500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_START_WITH.LOV.PARENT_TO_LEAF.D'
,p_message_text=>'Parent to Leaf (breadcrumb style)'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574415916500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_START_WITH.PROMPT'
,p_message_text=>'Start With'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783413305508)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_text=>'Select the breadcrumb template utilized with this breadcrumb.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783412305508)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_text=>'Breadcrumb Template'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573316051500625)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.1.D'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574298537500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.10.D'
,p_message_text=>'Custom 8'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573468243500625)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.2.D'
,p_message_text=>'Hierarchical'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573541888500625)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.3.D'
,p_message_text=>'Custom 1'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573667074500625)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.4.D'
,p_message_text=>'Custom 2'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573787120500625)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.5.D'
,p_message_text=>'Custom 3'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573813058500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.6.D'
,p_message_text=>'Custom 4'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573941990500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.7.D'
,p_message_text=>'Custom 5'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574050806500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.8.D'
,p_message_text=>'Custom 6'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574188247500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.LOV.9.D'
,p_message_text=>'Custom 7'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573230538500625)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_CLASS.PROMPT'
,p_message_text=>'Class'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574374739500626)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380764439865410012)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_text=>'Enter the text that displays after break columns when displaying a break row.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380764315410410012)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_text=>'After Row'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380764057499410011)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_text=>'Enter the text that displays before break columns when displaying a break row.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380763907181410011)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_text=>'Before Row'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380858234690128751)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_text=>'No Break'
,p_version_scn=>37166067046536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380976657353206968)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_text=>'No Break'
,p_version_scn=>37166067046537
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380762749356410009)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_text=>'Select how many report columns are incorporated into the break formatting. The columns must be consecutive columns, starting from the first column displayed in the report.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796426587751600)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_text=>'First Column'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796501975751600)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_text=>'First and Second Columns'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796677164751600)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_text=>'First, Second and Third Column'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380762617521410009)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_text=>'Break Columns'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380763228376410010)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_text=>'Select how breaks affect the display formatting of the report.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796997963751601)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_text=>'Default Break Formatting'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797090773751601)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_text=>'The breaks display in a single report without repeating the headings for each break.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796747220751601)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_text=>'Repeat Headings on Break'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796828440751601)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_text=>'The report displays as several subreports with repeating headings for each break.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380763110160410009)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_text=>'Style'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380763839233410011)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_text=>'Enter the text that displays on report breaks. Utilize <code>#SUM_COLUMN_HEADER#</code> substitutions.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380763783888410011)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_text=>'Report Break Format'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380764241468410011)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_text=>'Enter the text for the break column when displaying a report break. You can utilize <code>#COLUMN_VALUE#</code> substitutions.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380764161458410011)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_text=>'Column Break Format'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380763698108410011)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_text=>'Enter the text for the repeating headings displayed for report breaks. You can utilize <code>#COLUMN_VALUE#</code> substitutions.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380763533692410010)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_text=>'Repeat Heading Format'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380857467860128730)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_text=>'Application Default'
,p_version_scn=>37166067046493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656092355391958067)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_text=>'Uses the setting defined in the application security attributes.'
,p_version_scn=>37166067046493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123107115416211810)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If the cache is enabled, the browser can save the contents of your application''s pages in its cache, both in memory and on disk.',
'If a user clicks the browser back button, the page typically loads from the cache, not from the server.',
'If the cache is disabled, the browser is instructed to not save page content and requests it anew from the server.</p>',
'<p>Oracle recommends, from a security perspective, that the cache is disabled, so the browser does not store sensitive data and always requests pages if the URL changes.',
'Otherwise, it may even be possible to go back in the browser history after a log out and see cached content of the former session.',
'Disabling the browser cache prevents subtle back button issues with pages that use partial page refresh, such as interactive reports.</p>',
'<p>If this attribute is set to <strong>Disabled</strong>, &PRODUCT_NAME. sends the HTTP header <em>cache-control: no-store</em> which instructs the Browser to not cache the page contents on disk or in memory.',
'If it is set to <strong>Application Default</strong>, the value at runtime is taken from the application''s <em>Browser Cache</em> attribute.</p>',
'<p>Note: This feature requires modern browsers that support the HTTP header response variable <code>cache-control</code>.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752964047751428)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752844300751428)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123107024940211810)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_text=>'Browser Cache'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1781814286933792)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.HELP'
,p_message_text=>'<p>Please provide an icon css class to represent your page pattern in the create page wizard. You can choose a pre-existing icon from the list.</p>'
,p_version_scn=>152987682
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1781956650043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.ABOUT-US.D'
,p_message_text=>'about-us'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782061141043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.CARD-GALLERY.D'
,p_message_text=>'card-gallery'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782174032043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.CHECKOUT.D'
,p_message_text=>'checkout'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782203238043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.CONTACT-DETAILS.D'
,p_message_text=>'contact-details'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782488330043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.DASHBOARD-3-COL.D'
,p_message_text=>'dashboard-3-col'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782574840043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.DASHBOARD-3X2-GRID.D'
,p_message_text=>'dashboard-3x2-grid'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782622649043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.DASHBOARD-FEATURE-2-COL.D'
,p_message_text=>'dashboard-feature-2-col'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782350046043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.DASHBOARD.D'
,p_message_text=>'dashboard'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782720373043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.ERROR.D'
,p_message_text=>'error'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782858691043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.EVENT-CALENDAR.D'
,p_message_text=>'event-calendar'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1782980732043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.FAQ-PAGE.D'
,p_message_text=>'faq-page'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1781778630043236)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.GENERIC.D'
,p_message_text=>'generic'
,p_version_scn=>161709178
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783048006043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.HOMEPAGE.D'
,p_message_text=>'homepage'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783182665043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.LANDING-PAGE.D'
,p_message_text=>'landing-page'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783215038043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.POST-DETAILS.D'
,p_message_text=>'post-details'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783369278043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.PRIVACY-POLICY-DISCLAIMER.D'
,p_message_text=>'privacy-policy-disclaimer'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783430915043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.PRODUCT-DETAILS.D'
,p_message_text=>'product-details'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783583904043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.SEARCH-RESULTS.D'
,p_message_text=>'search-results'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783648241043232)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.SHOPPING-CART.D'
,p_message_text=>'shopping-cart'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783753443043232)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.SIGN-IN-FORM.D'
,p_message_text=>'sign-in-form'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783878772043232)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.SIGN-UP-FORM.D'
,p_message_text=>'sign-up-form'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1783945537043232)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.TESTIMONIALS.D'
,p_message_text=>'testimonials'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1781888605043233)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.LOV.USER-PROFILE-DETAILS.D'
,p_message_text=>'user-profile-details'
,p_version_scn=>161709180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1781730898933795)
,p_name=>'PE.PROPERTY.BUILDER_ICON_CSS_CLASS.PROMPT'
,p_message_text=>'Builder Icon Class'
,p_version_scn=>153049406
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1351947201507675381)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>1. You are developing an application that will have many installations.',
'                                        Additionally, each installation may choose to enable or disable certain application functionality.',
'                                        With Build Options, you can develop one application and when installed, build options can be configured to include or exclude associated application functionality.',
'                                        You may also use the API to expose this feature within the application.',
'                                        This allows privileged end-users to selectively enable or disable application functionality.</p>',
'                                      <p>2. You are developing functionality which is not yet complete, so you do not wish to expose to end-users.',
'                                        Using Build Options enables you to disable this functionality from the application when it is built into the test and production environments.',
'                                        The benefit of this approach is that the application can still be deployed without including incomplete functionality.</p>',
'                                      <p>3. You are removing functionality you think is not needed by the application, but are unsure this is a safe operation.',
'                                        In this case, you can use Build Options to essentially "comment out" specific functionality.',
'                                        If on deployment, the removed functionality was deemed to be necessary, it can be re-instated.',
'                                        If this functionality was deemed to be unnecessary, then it can be safely removed from the application.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123107713315211811)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this component.</p>',
'                                     <p>Build Options allow application components and functionality to be conditionally enabled or disabled when the application is installed, or at runtime via API (APEX_UTIL.SET_BUILD_OPTION_STATUS).<br>',
'                                       Build Options can set this component to be Included or Excluded in the runtime application:</p>',
'                                     <p><strong>Included</strong> - Enabled and are part of the application.</p>',
'                                     <p><strong>Excluded</strong> - Disabled and are not a part of the application.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123107606878211811)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_text=>'Build Option'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754069028661396)
,p_name=>'PE.PROPERTY.BUILD_OPTIONS_MESSAGE.PROMPT'
,p_message_text=>'Build Options'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576914049340720)
,p_name=>'PE.PROPERTY.BUILD_OPTION_ID.HELP'
,p_message_text=>'Identifies the build option.'
,p_version_scn=>49870255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10576879442340720)
,p_name=>'PE.PROPERTY.BUILD_OPTION_ID.PROMPT'
,p_message_text=>'Build Option'
,p_version_scn=>49870254
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123086104745211762)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_text=>'Select a build option status for this component.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516746888879751409)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_text=>'Exclude'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516746929157751410)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_text=>'Do not use any component flagged with this build option.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516746649806751408)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_text=>'Include'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516746737968751408)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_text=>'Use all components flagged with this build option.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123086006405211762)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_text=>'Status'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494489057272152)
,p_name=>'PE.PROPERTY.BUILD_OPTION_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this build option on an existing build option in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494397001272152)
,p_name=>'PE.PROPERTY.BUILD_OPTION_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721459960661333)
,p_name=>'PE.PROPERTY.BUILD_STATUS.LOV.RUN_AND_BUILD.D'
,p_message_text=>'Run and Build Application'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721383125661333)
,p_name=>'PE.PROPERTY.BUILD_STATUS.LOV.RUN_ONLY.D'
,p_message_text=>'Run Application Only'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721297927661333)
,p_name=>'PE.PROPERTY.BUILD_STATUS.PROMPT'
,p_message_text=>'Build Status'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156074607069627092)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_text=>'Select the action to be performed when this button is clicked.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774981304751517)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_text=>'Defined by Dynamic Action'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516775098290751518)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_text=>'Does not submit the page or redirect to another page. Instead the button''s behavior is defined by a Dynamic Action.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516775364489751518)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_text=>'Next Page'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516775484247751519)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_text=>'Redirect to the next page.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516775500529751519)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_text=>'Previous Page'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516775693288751519)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_text=>'Redirect to the previous page.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774503792751517)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_text=>'Redirect to Page in a different Application'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774675026751517)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Redirect to a page in a different application, with optional additional attributes for resetting pagination, setting the request value, clearing cache and setting item values, on the target page.</p>',
'<p>Note: Redirecting to a page in different application relies on deep linking being enabled in the target application. To enable deep linking, go to the application''s <em>Security</em> attributes and enable <em>Deep Linking</em>.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774332023751516)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_text=>'Redirect to Page in this Application'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774451633751517)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_text=>'Redirect to a page in the current application, with optional additional attributes for resetting pagination, setting the request value, clearing cache and setting item values, on the target page.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774758369751517)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_text=>'Redirect to URL'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774880220751517)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_text=>'Redirect to the target URL you specify.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516775160876751518)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_text=>'Reset Page'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516775202962751518)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_text=>'Reset the page by performing a complete page refresh, not a Partial Page Refresh (PPR).'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774188362751516)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_text=>'Submit Page'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774228276751516)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_text=>'Submit the current page with a REQUEST value equal to the Button Name.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156074506164627091)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_text=>'Action'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123115208065211823)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the type of SQL operation that clicking this button performs.',
'This selection is used to trigger the specified database action within built-in Automatic Row Processing (DML).',
'If you do not select a type, database processing executes based on the REQUEST value, which is set based on the <strong>Button Name</strong> defined for this button.'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516768530553751492)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_text=>'SQL DELETE action'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516768333603751490)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_text=>'SQL INSERT action'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516768435067751491)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_text=>'SQL UPDATE action'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123115123130211823)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_text=>'Database Action'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596947095555296806)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_text=>'Select a button display type to define the appearance of this button.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596947376173296806)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_text=>'Icon'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596947484605296806)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_text=>'Displays an icon only.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596947131390296806)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_text=>'Text'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596947211300296806)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_text=>'Displays the button label only.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596947521703296806)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_text=>'Text with Icon'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596947687094296806)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_text=>'Displays an icon next to the button label.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596946928125296806)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_text=>'Display Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629296874193683057)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter additional attributes displayed after the HTML table cell that displays each individual option in a radio group or set of check boxes.',
'You can include HTML, JavaScript, and shortcuts.</p>',
'<p>You can reference the following substitution strings:</p>',
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
'  <dd>Obtains the name of the HTML form element that this page item is associated with.</dd>',
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Obtains the name of the current page item.</dd>',
'</dl>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629296745236683057)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_text=>'Post Text '
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629296609121683056)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter additional attributes displayed before the HTML table cell that displays each individual option in a radio group or set of check boxes.',
'You can include HTML, JavaScript, and shortcuts.</p>',
'<p>You can reference the following substitution strings:</p>',
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
'  <dd>Obtains the name of the HTML form element that this page item is associated with.</dd>',
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Obtains the name of the current page item.</dd>',
'</dl>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629296552179683054)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_text=>'Pre Text'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123115028052211822)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If the page is submitted and this attribute is set to <strong>On</strong>, all validations defined for the page and also the built-in validations are executed (such as required, valid number or valid date) on the server-side.',
'In addition, if <em>Compatibility Mode</em> of the application is set to <strong>5.1</strong> or above, &PRODUCT_NAME. will also perform client-side validations, such as item required. Please see "Compatibility Mode" in the Release Notes for further '
||'details.',
'The page will not be submitted until all issues are fixed.</p>',
'<p>If set to <strong>Off</strong>, none of the defined validations nor the built-in validations are executed.',
'If you want a specific validation to execute independent of this setting, modify the validation and set the validation attribute <strong>Always Execute</strong> to <strong>On</strong>.</p>',
'<p>This attribute is particularly useful for buttons such as Delete or Cancel where the majority of validations should not be executed.',
'Users should generally not be stopped from performing such actions if an item is null or of the wrong type.',
'However, if actions, such as Delete, should only be performed by authorized users it is important to set the corresponding validation attribute <strong>Always Execute</strong> to <strong>On</strong>, or ensure there is an appropriate condition define'
||'d on the button itself so that the button is only displayed to authorized users.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123114920763211822)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_text=>'Execute Validations'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573199714500625)
,p_name=>'PE.PROPERTY.BUTTON_HOT_TEMPLATE.PROMPT'
,p_message_text=>'Hot'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596948599400296957)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_text=>'Specify whether to use the <strong>Normal</strong> or <strong>Hot</strong> button when rendering this button.'
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976628782250630)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.IR_COLUMN_ACTION.HELP'
,p_message_text=>'Specify whether to use the <strong>Normal</strong> or <strong>Hot</strong> button when rendering this button.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976088704250627)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.REGION_ACTION.HELP'
,p_message_text=>'Specify whether to use the <strong>Normal</strong> or <strong>Hot</strong> button when rendering this button.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123114228489211821)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_text=>'Specify whether to use the <strong>Normal</strong> or <strong>Hot</strong> button template when rendering this button.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123114116974211821)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_text=>'Hot'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600965697784514)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.BUTTON.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ensure buttons have clear and meaningful descriptions, aiding users in understanding and utilizing their functions.</p>',
'<strong>Best Practices:</strong>',
'<ul><li><strong>Label Text Verification:</strong>',
'Check if the label text accurately describes the button''s purpose.</li></ul>'))
,p_version_scn=>36587285
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1605086803784563)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ensure buttons have clear and meaningful descriptions, aiding users in understanding and utilizing their functions.</p>',
'<strong>Best Practices:</strong>',
'<ul><li><strong>Label Text Verification:</strong>',
'Check if the label text accurately describes the button''s purpose.</li></ul>'))
,p_version_scn=>36587347
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596948375777296956)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_text=>'Enter the text to be displayed on the button. If button display type is icon, this text becomes the ALT text for the icon image.'
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976871312250631)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.IR_COLUMN_ACTION_MENU_ENTRY.HELP'
,p_message_text=>'Enter the text to be displayed in the menu.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976207054250629)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.REGION_ACTION_MENU_ENTRY.HELP'
,p_message_text=>'Enter the text to be displayed in the menu.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123142109660211867)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_text=>'If the button is text, enter the text to be displayed on the button. If the button is an image, then this text becomes the ALT text for the image.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123142022442211867)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_text=>'Label'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123171132739211914)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_text=>'Enter the name used to reference the button being clicked. When this page is submitted, the value of REQUEST is set to this button name.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123141904992211867)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name used to identify this button within subsequent page processing.',
'When the page is submitted, by pressing this button, the REQUEST value is set to the name entered.</p>',
'<p>Button name does not have to be unique, for buttons on the same page or in the same region.',
'You can define multiple buttons with the same button name, which sets the same REQUEST value when pressed.',
'This is useful for defining buttons with different <strong>Button Labels</strong> or conditions, that need to execute the same page processing, by simply evaluating the common REQUEST value.</p>',
'<p>If you name the button <code>FLOW_RESET_BUTTON</code> then the button resets the current page without doing a page submit.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123141806617211867)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_text=>'Button Name'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143573064155500625)
,p_name=>'PE.PROPERTY.BUTTON_NORMAL_TEMPLATE.PROMPT'
,p_message_text=>'Normal'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629250080454045814)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_text=>'When this button is pressed the page will be submitted and the page request will be set to this value. If this value is null and the <em>Request Source Type</em> is <em>Static Value</em>, then the Button Name will be used as the request value.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249978097045813)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_text=>'Request Source'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248096756045806)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_text=>'This identifies the type of expression that is contained in the request source attribute. '
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249744018045812)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249808747045813)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_text=>'Set to null.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248392426045807)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_text=>'Database Column'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248409191045808)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_text=>'Set to the column value entered in <em>Database Column</em>, that is retrieved from a built-in fetch row process.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249101379045810)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249232660045811)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>PL/SQL Expression</em> entered.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249374347045811)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249422638045811)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>PL/SQL Function Body</em> entered.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248562796045808)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248645980045808)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249597993045812)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_text=>'Preference'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249693962045812)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_text=>'Set to the value of the <em>Preference</em> entered.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248758373045809)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248824640045809)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248910225045810)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_text=>'SQL Query (return colon separated value)'
,p_version_scn=>20460321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629249048921045810)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_text=>'Set to a single colon separated value, which concatenates each row value, returned from the <em>SQL Query</em> entered.'
,p_version_scn=>20460321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248192550045806)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629248202252045807)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Set to the text entered into <em>Static Value</em>.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629247932236045806)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_text=>'Request Source Type'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1752947412732009)
,p_name=>'PE.PROPERTY.BUTTON_SHOW_PROCESSING.HELP'
,p_message_text=>'Specify whether the current page is grayed-out and a ''processing'' style animation is displayed during page submission. This can be useful to prevent end user action during long running operations, such as the end user attempting to re-click on the se'
||'arch button when the report is slow to refresh.'
,p_version_scn=>11412107
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1709228531797460)
,p_name=>'PE.PROPERTY.BUTTON_SHOW_PROCESSING.PROMPT'
,p_message_text=>'Show Processing'
,p_version_scn=>10978777
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123114826644211822)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_text=>'Click the Target to invoke a modal dialog. You can enter the target to be called when this button is clicked. Only enter a target for buttons that should not invoke page processing when clicked (for example, a Cancel button).'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123114732430211822)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_text=>'Target'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123114002162211821)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_text=>'Select a button template to define the appearance of this button.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123113914777211821)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_text=>'Button Template'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571451322500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.1.D'
,p_message_text=>'Button'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572239294500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.10.D'
,p_message_text=>'Custom 5'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572334420500625)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.11.D'
,p_message_text=>'Custom 6'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572452580500625)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.12.D'
,p_message_text=>'Custom 7'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572539310500625)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.13.D'
,p_message_text=>'Custom 8'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571716594500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.2.D'
,p_message_text=>'Button, Alternative 3'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571598036500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.4.D'
,p_message_text=>'Button, Alternative 1'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571694715500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.5.D'
,p_message_text=>'Button, Alternative 2'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571818522500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.6.D'
,p_message_text=>'Custom 1'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571946318500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.7.D'
,p_message_text=>'Custom 2'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572060577500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.8.D'
,p_message_text=>'Custom 3'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572173860500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.LOV.9.D'
,p_message_text=>'Custom 4'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571302447500624)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_CLASS.PROMPT'
,p_message_text=>'Class'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572703158500625)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591311343519936582)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_text=>'Page Default'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(598580632101140811)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_text=>'Check for unsaved changes when the button is clicked, if the check is enabled at page level.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591063056342936260)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_text=>'Specify if the user is warned when they try to navigate away from the page by clicking the button, and where the page contains unsaved changes.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591063373835936260)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_text=>'Do Not Check'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596646348541061450)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_text=>'The unsaved changes check will not be performed when the button is clicked. This setting should be used for Cancel, Delete and Apply Changes buttons.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591062743953936259)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_text=>'Warn on Unsaved Changes'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201041418982783)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201473422982783)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201338622982783)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201273427982783)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201579057982783)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201128562982783)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200922272982783)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61101835975276401)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102146081276401)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102075719276401)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61101935657276401)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102247481276401)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61101756359276400)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123124717448211838)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123124621986211838)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123126120566211841)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046467
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123126030137211840)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046467
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600260748909090573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600260645285090572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600262384660090576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600262282475090576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606832905484613)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600260480213090572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600260335831090572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175607085494484614)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600262080789090576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600261939268090576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123124900132211839)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_text=>'Enter a colon(:) separated list of values for this condition.'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123124804829211838)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125309475211839)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_text=>'Enter the Page Number for this condition.'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125224059211839)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_text=>'Page'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125529876211840)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_text=>'Enter a comma separated list of Page Numbers for this condition.'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125418602211839)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_text=>'Pages'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606727173484612)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600260143181090572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600260088562090572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606961326484613)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600261782341090576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600261616170090575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125111421211839)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_text=>'Enter a User Preference that is compared against the specified value for this condition.'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125016177211839)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_text=>'Preference'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600260911800090573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600260839623090573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600262505474090577)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600262492192090576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606694637484612)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600259834230090572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a SQL Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600259742613090572)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606598015484610)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully as one or more rows exist when checking if the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>To return successfully as no rows exist when checking if the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123123727919211837)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_text=>'Enter a SQL query for this condition.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123123626935211837)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125701446211840)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_text=>'Enter the text value for this condition.'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125616385211840)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123126329459211841)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123126202238211841)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150995829257822759)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>'Select a condition type that must be met for the region to be cached.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123117303538211826)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_text=>'Specify a condition. If the condition returns <strong>TRUE</strong>, the page displays from cache. If the condition returns <strong>FALSE</strong>, the page renders dynamically and is not retrieved from cache.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516917308727751924)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599827198734464389)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_text=>'The component will always be rendered or executed.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915959845751920)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_text=>'Client Browser is Microsoft Internet Explorer 7.0 or higher'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916015545751920)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_text=>'Client Browser is XHTML / CSS capable browser'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915839842751920)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_text=>'Client Browser is Mozilla, Netscape 6.x/7x or higher'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916116690751920)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_text=>'Client Browser is Other browsers (or older version)'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914525827751918)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_text=>'Text is contained in Item'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916519629751922)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_text=>'Current Language = Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830936567464413)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_text=>'The end user is currently running the application in the language you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916218393751920)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_text=>'Current Language is contained in Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599831142783464415)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_text=>'The end user is currently running the application in one of the languages you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916401132751921)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_text=>'Current Language != Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599831094748464414)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_text=>'The end user is not currently running the application in the language you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916351451751921)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_text=>'Current Language is NOT contained in Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599831282451464415)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_text=>'The end user is not currently running the application in one of the languages you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913749322751916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_text=>'Current Page = Page'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829720045464403)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_text=>'The current page is equal to the value you enter into <em>Page</em>.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913914343751916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_text=>'Current Page is in comma delimited list'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829913267464404)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_text=>'The current page is in the comma separated list you enter into <em>Pages</em>.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913853147751916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_text=>'Current Page != Page'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829874651464403)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_text=>'The current page is not equal to the value you enter into <em>Page</em>.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914068339751916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_text=>'Current Page is NOT in comma delimited list'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830020467464405)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_text=>'The current page is not in the comma separated list you enter into <em>Pages</em>.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916682262751922)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: DAD_NAME = Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916772948751922)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: DAD_NAME != Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915426654751919)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_text=>'Inline Validation Errors displayed'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830720550464412)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_text=>'An inline validation error is displayed on the page, following a page submission.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914844624751918)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_text=>'Text = Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914619069751918)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_text=>'Text is contained in Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914732380751918)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_text=>'Text is NOT contained in Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914978171751918)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_text=>'Text != Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516911226275751910)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599827220238464390)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_text=>'The SQL query returns one or more rows.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258806266090564)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258915465090564)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'The expression evaluates to TRUE.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516911665596751912)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599827671685464392)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'The function body returns TRUE.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516917044892751923)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: HTTP_HOST = Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516917150103751923)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: HTTP_HOST != Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915143178751919)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_text=>'Page/Region is NOT Read Only'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830445466464410)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_text=>'The page and parent region, if appropriate, are displayed normally.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915044670751918)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_text=>'Page/Region is Read Only'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830373041464410)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_text=>'Either the page or parent region, if appropriate, ''Read Only'' condition evaluates to TRUE.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912905161751914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_text=>'Item contains no spaces'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828980774464399)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_text=>'The value of the selected <em>Item</em> has no spaces.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913223040751914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_text=>'Item is alphanumeric'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829270756464400)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is alphanumeric, containing only letters or numbers and no special characters.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912420616751913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_text=>'Item is NOT NULL'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828460703464396)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not empty.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913185860751914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_text=>'Item is NOT numeric'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829162975464399)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not numeric.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912661349751913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_text=>'Item is NOT zero'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828616000464397)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not the number zero.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912304906751913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_text=>'Item is NULL'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828383760464395)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is empty.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912791813751914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_text=>'Item is NULL or zero'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828711980464397)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is empty or the number zero.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913092940751914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_text=>'Item is numeric'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829065285464399)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is numeric.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912599741751913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_text=>'Item is zero'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828585533464397)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is the number zero.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912825695751914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_text=>'Item is NOT NULL and NOT zero'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828865556464398)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not empty and not the number zero.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915627770751920)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_text=>'SQL Reports (OK to show the forward button)'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915705008751920)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_text=>'SQL Reports (OK to show the back button)'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516917235714751923)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915522646751919)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_text=>'Inline Validation Errors NOT displayed'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830811949464413)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_text=>'An inline validation error is not displayed on the page.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516911358446751910)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599827333386464391)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_text=>'The SQL Query returns no rows'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914314313751917)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_text=>'Current Page is in Printer Friendly Mode'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830136894464405)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_text=>'The current page has been toggled to ''Printer Friendly Mode'' by the end user.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914422098751917)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_text=>'Current page is NOT in Printer Friendly Mode'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830242433464409)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_text=>'The current page has not been toggled to ''Printer Friendly Mode'' by the end user.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516911751695751912)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_text=>'Request = Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599827770686464393)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_text=>'The page request is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516911986952751912)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_text=>'Request is contained in Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599827900340464393)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_text=>'The page request is contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516911858832751912)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_text=>'Request != Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599827846235464393)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_text=>'The page request is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912029071751912)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_text=>'Request is NOT contained in Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828001730464394)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_text=>'The page request is not contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916891891751922)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: SERVER_NAME = Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516916919370751922)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: SERVER_NAME != Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915261156751919)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_text=>'User is Authenticated (not public)'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830554647464411)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_text=>'The end user is logged into the application.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516915313382751919)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_text=>'User is the Public User (user has not authenticated)'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599830601955464411)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_text=>'The end user is not logged into the application.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913571574751915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_text=>'User Preference = Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829541512464402)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_text=>'The value of the <em>Preference</em> entered is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913680206751916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'User Preference != Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829631841464403)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_text=>'The value of the <em>Preference</em> entered is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913309676751914)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is in colon delimited list'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829364632464401)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is completely contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516913459739751915)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is NOT in colon delimited list'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599829459498464401)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not completely contained in the text you entered into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912163869751912)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_text=>'Item = Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828102145464395)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516912248404751913)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'Item != Value'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599828291643464395)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914254438751916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_text=>'Current Page != Page Submitted (posted)'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516914189296751916)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_text=>'Current Page = Page Submitted (posted)'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123117205323211826)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123124524766211838)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_text=>'Enter the value to compare against the condition.'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123124400751211838)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125920776211840)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123125827816211840)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046464
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(687751685349317019)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_text=>'Enter a comma separated list of items that cached content depends on.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(687751531383317019)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_text=>'Depends On Item(s)'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671657305396909509)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_text=>'Select how the &PRODUCT_NAME. engine can cache HTML text on the server side. If caching can be used, it emits the cached result instead of computing it again. This cuts down on expensive computation time on the server. This feature is unrelated to th'
||'e browser''s caching capabilities.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671658281850909510)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671658511241909510)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_text=>'Content is cached and utilized by all users.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671657677342909510)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671657928779909510)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_text=>'Content is not cached and computed for each request.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671659428655909511)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_text=>'Cache By Session'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671659736345909511)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_text=>'Content is cached specifically for each session.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671658866868909510)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_text=>'Cache By User'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671659170710909511)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_text=>'Content is cached specifically for each user.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(671657053144909507)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_text=>'Caching'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123105022761211805)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_text=>'Select how long a cached page is valid. Subsequent page requests do not utilize the cached page if the timeout expires.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750987067751424)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_text=>'10 seconds'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751565258751426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_text=>'3 hours'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752450876751427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_text=>'2 weeks'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751697715751426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_text=>'4 hours'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752080810751427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_text=>'2 days'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751281260751425)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_text=>'30 minutes'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751787799751426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_text=>'6 hours'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752560624751428)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_text=>'4 Weeks'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752166246751427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_text=>'3 days'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752725625751428)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_text=>'1 Year'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752230335751427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_text=>'4 days'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751353338751426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_text=>'1 hour'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751860185751426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_text=>'12 hours'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751052941751424)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_text=>'1 minute'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751178618751424)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_text=>'10 minutes'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752371162751427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_text=>'1 week'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516752661897751428)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_text=>'10 Weeks'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751447918751426)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_text=>'2 hours'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516751963236751427)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_text=>'1 day'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123104904340211805)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_text=>'Cache Timeout'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516842977368751735)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display column values</dt>',
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
'<dt>Display an image in a calendar event.</dt>',
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(393575241990660486)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_text=>'Enter custom text to display in calendar cells. You can enter HTML expressions and use <code>#COLUMN_NAME#</code> syntax to show column values. This display type enables you to enter multiple columns in the display.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(393575100157660486)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_text=>'Custom Display Format'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388945859026781565)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the page or application item that holds the start date of the calendar which is currently displayed to the end user.',
'This item is used by the &PRODUCT_NAME. engine when the end user selects to navigate to the previous or next period.'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388945753812781565)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_text=>'Start Date'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388946490193781566)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_text=>'Select the values displayed on the calendar.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516842314099751734)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_text=>'Column'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516842441042751734)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_text=>'Uses the <strong>Display Column</strong> attribute to select the column to display in the calendar cell.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516842564145751734)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_text=>'Custom'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516842643428751734)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_text=>'Enables you to enter a custom column format using HTML expressions and supported substitution strings.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516842791570751734)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_text=>'No Display Value'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516842830916751735)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_text=>'No data is displayed in the calendar cells.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388946331822781566)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_text=>'Display Type'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388946091697781566)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the page or application item that holds the end date of the calendar which is currently displayed to the end user.',
'This item is used by the &PRODUCT_NAME. engine when the end user selects to navigate to the previous or next period.'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388945902777781565)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_text=>'End Date'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388945027277781564)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_text=>'Select a template to use when the calendar is rendered.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388944995923781560)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578519284500630)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.1.D'
,p_message_text=>'Calendar'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579424570500631)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.10.D'
,p_message_text=>'Custom 7'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579598554500631)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.11.D'
,p_message_text=>'Custom 8'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578675165500630)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.2.D'
,p_message_text=>'Calendar, Alternative 1'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578734009500630)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.3.D'
,p_message_text=>'Small Calendar'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578865709500630)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.4.D'
,p_message_text=>'Custom 1'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578918824500630)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.5.D'
,p_message_text=>'Custom 2'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579009109500630)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.6.D'
,p_message_text=>'Custom 3'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579175694500630)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.7.D'
,p_message_text=>'Custom 4'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579255563500630)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.8.D'
,p_message_text=>'Custom 5'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579383254500630)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.LOV.9.D'
,p_message_text=>'Custom 6'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578422397500629)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_CLASS.PROMPT'
,p_message_text=>'Class'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579657191500631)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388946261510781566)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_text=>'Select the page or application item that holds the calendar type which is currently displayed to the end user.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388946179634781566)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596946793122296805)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_text=>'Enter the number of cards to display per page.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596946626105296805)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_text=>'Cards per Page'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596945595080296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_text=>'Determines where the button is positioned on the card.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596945681826296805)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_text=>'Primary'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596945745918296805)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_text=>'Secondary'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596945437907296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_text=>'Position'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944397799296803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the type of action to add to the card component.</p>',
'<p>Note: You can define multiple actions of the same type.  However, only button actions are rendered multiple times.',
'For all other action types, the first TRUE display condition gets rendered, and the rest are ignored.</p>',
'<p>Display conditions can be defined based on the column values if execution condition is set to check for each row.</p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944474637296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_text=>'Button'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944570753296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_text=>'Adds button to the card.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944622547296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_text=>'Full Card'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944717850296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_text=>'Adds link to the full card. Usually, one of this action type should be defined.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596945264137296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_text=>'Media'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596945345494296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_text=>'Adds link to the card media. Usually, one of this action type should be defined.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596945049936296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_text=>'Subtitle'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596945116358296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_text=>'Adds link to the card subtitle. Usually, one of this action type should be defined.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944835273296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_text=>'Title'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944929720296804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_text=>'Adds link to the card title. Usually, one of this action type should be defined.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944267626296803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933284644296784)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_text=>'Enter CSS classes to apply to each individual card. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933178177296784)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311808852300804)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.COMPONENT_PROPERTY.SEARCH_REGION_SOURCES.HELP'
,p_message_text=>'The icon or media, which is displayed with a search result, is specified in the Search Configuration, within Shared Components. This attribute allows to specify Icon CSS classes which override the Search Configuration settings.'
,p_version_scn=>37166067046534
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938475900296789)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Show an arrow pointing right</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938334635296789)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to add to the component. You may add multiple classes by separating them with spaces.</p>',
'        <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938220167296789)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_text=>'Icon CSS Classes'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(621716610478791742)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Show an arrow pointing right</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(621716552336791742)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to add to the component. You may add multiple classes by separating them with spaces.</p>',
'        <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(621716455098791740)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_text=>'Icon CSS Classes'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931622869296778)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_text=>'This property determines how the cards are arranged on the page.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931939487296778)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_text=>'Float'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932028700296778)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_text=>'Cards will wrap when they no longer fit horizontally on the screen.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931775897296778)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_text=>'Grid'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931875681296778)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_text=>'Arranges the cards in a grid of columns.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932186511296778)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_text=>'Horizontal (Row)'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932209728296778)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_text=>'Cards will be positioned on top of each other.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931595425296778)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_text=>'Layout'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646459255724244900)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_text=>'Select the first primary key column from the region source. If the primary key of this table has more than two columns, you must select the <code>ROWID</code> column. If the region is set to display scroll pagination, the primary key is used to avoid'
||' displaying duplicate rows.  If the region displays an image from a BLOB column, the primary key is used to get the image.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646459197224244895)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_text=>'Primary Key Column 1'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646463648589307322)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_text=>'Select the first primary key column from the region source. If the primary key of this table has more than two columns, you must select the <code>ROWID</code> column. If the region is set to display scroll pagination, the primary key is used to avoid'
||' displaying duplicate rows.  If the region displays an image from a BLOB column, the primary key is used to get the image.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646463519504307322)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_text=>'Primary Key Column 1'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646459417879244900)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_text=>'Only select the second primary key column if the primary key for your region source has two columns. If you select <code>ROWID</code> for the first primary key column, you should not populate this column. If the region is set to display scroll pagina'
||'tion, the second primary key is used to avoid displaying duplicate rows.  If the region displays an image from a BLOB column, the second primary key is used to get the image.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646459399092244900)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_text=>'Primary Key Column 2'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646463841348307322)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_text=>'Only select the second primary key column if the primary key for your region source has two columns. If you select <code>ROWID</code> for the first primary key column, you should not populate this column. If the region is set to display scroll pagina'
||'tion, the second primary key is used to avoid displaying duplicate rows.  If the region displays an image from a BLOB column, the second primary key is used to get the image.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646463760449307322)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_text=>'Primary Key Column 2'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596946852026296806)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_text=>'Card uses BLOB column'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379347787217882209)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_text=>'Enter the case sensitive database column name of the List of Values, which is used to query it using the parent facet or filter value.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379347402665882209)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_text=>'LOV Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1496923414782680405)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter columns that trigger the refresh of this list of values.',
'For multiple columns, separate each column name with a comma.',
'You can type in the name or pick from the list of available columns.',
'If you pick from the list, and there is already text entered, then a comma is placed at the end of the existing text, followed by the column name returned from the list.</p>',
'<p>This list of values is refreshed whenever the value of any of the specified columns are changed on this page.</p>',
'<p>You should use the column(s) specified in this attribute within the <em>where clause</em> of this list of values SQL Query to restrict the values returned.</p>',
'<p>For example, if you have columns for Car Make and Model, you could specify Car Make as the Cascading LOV Parent Column within the List of Values definition for Model, and use Car Make within the where clause for that list of values.',
'Then whenever Car Make is changed, the LOV for Model is refreshed, and the list only displays values for the currently selected Car Make.</p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1496923336184680405)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_text=>'Parent Column(s)'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379348345562882209)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_text=>'Select a Facet that triggers the refresh of this list of values.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379348098218882209)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_text=>'Parent Facet'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509268788670736)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_text=>'Select a Filter that triggers the refresh of this list of values.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509130782670736)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_text=>'Parent Filter'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123112722079211819)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter page or application items that trigger the refresh of this list of values.',
'For multiple items, separate each item name with a comma.',
'You can type in the name or pick from the list of available items.',
'If you pick from the list, and there is already text entered, then a comma is placed at the end of the existing text, followed by the item name returned from the list.</p>',
'<p>This list of values is refreshed whenever the value of any of the specified items are changed on this page.</p>',
'<p>You should use the page item(s) specified in this attribute within the <em>where clause</em> of this list of values SQL Query to restrict the values returned.</p>',
'<p>For example, if you have page items for Car Make and Model, you could specify Car Make as the Cascading LOV Parent Item within the List of Values definition for Model, and use Car Make within the where clause for that list of values.',
'Then whenever Car Make is changed, the LOV for Model is refreshed, and the list only displays values for the currently selected Car Make.</p>'))
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123112624918211818)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_text=>'Parent Item(s)'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(378620698674881660)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify under what conditions this list of values is refreshed.</p>',
'<p>If set to <strong>On</strong> the refresh call to get new values performs only when all <em>Cascading LOV Parent Item(s)</em> are not null.',
'If one item is null, it is assumed that the LOV Query does not return any rows.',
'In such cases, the select list entries are simply cleared in the browser, without doing a refresh.</p>',
'<p>If set to <strong>Off</strong>, the refresh is always performed.',
'This option is only used if you specifically handle nullable <em>Cascading LOV Parent Item(s)</em> in the <em>where clause</em> of this list of values SQL Query.',
'If nullable page items are not properly handled, unnecessary refresh calls are executed that never return any rows.</p>'))
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(378620332880881659)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_text=>'Parent Required'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638577821500672)
,p_name=>'PE.PROPERTY.CELL_COLUMN_SPAN.PROMPT'
,p_message_text=>'Cell Column Span'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669587831661284)
,p_name=>'PE.PROPERTY.CERTIFICATE.PROMPT'
,p_message_text=>'Certificate'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669649759661284)
,p_name=>'PE.PROPERTY.CERTIFICATE_PRIVATE_KEY.PROMPT'
,p_message_text=>'Private Key'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3697290592633)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_text=>'Displays the user credentials of the developer who last updated this attribute.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3697289592633)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_text=>'Changed By'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3697292592633)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_text=>'Displays when this attribute was last updated.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3697291592633)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_text=>'Changed On'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745609356661354)
,p_name=>'PE.PROPERTY.CHARACTER_VALUE_COMPARISON.PROMPT'
,p_message_text=>'Mode'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745841669661354)
,p_name=>'PE.PROPERTY.CHARACTER_VALUE_COMPARISON_BEHAVIOR.LOV.0.D'
,p_message_text=>'Database session NLS setting (default)'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745908488661355)
,p_name=>'PE.PROPERTY.CHARACTER_VALUE_COMPARISON_BEHAVIOR.LOV.BINARY.D'
,p_message_text=>'Binary'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746082840661355)
,p_name=>'PE.PROPERTY.CHARACTER_VALUE_COMPARISON_BEHAVIOR.LOV.LINGUISTIC.D'
,p_message_text=>'Linguistic'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242745744870661354)
,p_name=>'PE.PROPERTY.CHARACTER_VALUE_COMPARISON_BEHAVIOR.PROMPT'
,p_message_text=>'Behavior'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388659361015170401)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the height of the chart in pixels. The height defines a fixed height for your chart region. Alternatively, to enable automatic resizing of the chart height, leave this item empty.',
'The height is then based upon the height of the browser.</p>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388659205575170401)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_text=>'Height'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388659459558170401)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436871559363587520)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum width of the chart in pixels. The maximum width defines a fixed width for your chart region.',
'Alternatively, to enable automatic resizing of the chart width, leave this item empty. The width is then automatically set to 100% of the region.</p>'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(430915143832461021)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_text=>'Maximum Width'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(430915596868465793)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603416808784547)
,p_name=>'PE.PROPERTY.CHART_TITLE.COMPONENT_PROPERTY.JET_CHART.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Clear titles, and labels are crucial for making visualizations accessible to all users.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li>Descriptive Title:',
'Use descriptive titles that clearly explain what the visualization depicts and guide readers on what to focus on.</li>',
'</ul>',
'<p>By adhering to these principles, you can enhance the accessibility of your visualizations for all users, including those with visual impairments or color blindness.</p>'))
,p_version_scn=>12189420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385519968584020683)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_text=>'Enter a title to display at the top of the chart.  For gantt charts, this value is only used to define the accessible chart title.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385519824432020683)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_text=>'Title'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415169345648784)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_text=>'Select the location of the data.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415271608648788)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_text=>'Local Database'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415312702648788)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_text=>'Data is sourced from the local database.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415884955648788)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_text=>'Region Source'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415912992648788)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_text=>'Data is sourced from the location specified in the region source definition.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415415062648788)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415515329648788)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_text=>'Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. '
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415603909648788)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_text=>'REST Source'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415736627648788)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_text=>'Data is sourced from a RESTful web service defined using REST Data Sources.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563415070721648784)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_text=>'Location'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380868243107719003)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_text=>'Select the basis for this report column.'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787038029751572)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_text=>'* Date Picker'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786968502751571)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_text=>'* Date Picker (Classic)'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786820879751571)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_text=>'* Display as Text (saves state)'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786593448751570)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_text=>'Download BLOB'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824742368464153)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_text=>'Displays the column as a link to download the file.'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786739659751571)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_text=>'Hidden'
,p_version_scn=>23756077
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824938192464154)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_text=>'Does not display the column, but it is referenceable.'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787562553751572)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_text=>'* Hidden Field'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786498956751570)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_text=>'Display Image'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824649182464153)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_text=>'Displays the column as an image.'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786383753751570)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_text=>'Link'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824558124464153)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_text=>'Displays the column as a link.'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786665421751571)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_text=>'Percent Graph'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824851225464154)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_text=>'Displays the column as a percentage graph. The value retrieved must be between 0 and 100.'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786197356751570)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_text=>'Plain Text'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824378928464151)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_text=>'Displays the column value.'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516786263548751570)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_text=>'Plain Text (based on List of Values)'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824477284464152)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_text=>'Displays the value returned from the list of values specified.'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787693261751573)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_text=>'* Popup LOV'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787794531751573)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_text=>'* Popup Key LOV'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787491999751572)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_text=>'* Radio Group'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(602224327211522907)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_text=>'Rich Text'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(602224644882522907)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_text=>'Renders the column using HTML or Markdown.'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787999811751573)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_text=>'* Row Selector'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787394840751572)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_text=>'* Select List'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787897770751573)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_text=>'* Simple Checkbox'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787169475751572)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_text=>'* Text Field'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516787225541751572)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_text=>'* Text Area'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380868168830719003)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380858138006128751)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_text=>'No Pagination (Show All Rows)'
,p_version_scn=>37166067046536
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380976556449206968)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_text=>'No Pagination (Show All Rows)'
,p_version_scn=>37166067046537
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380759333198410003)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the pagination type to utilize in this report.',
'Generally only a subset of the results are currently displayed in the report.',
'Pagination provides the user with information about the number of rows and the current position within the result set. Pagination also defines the style of links or buttons that are used to navigate to the next or previous page.</p>',
'<p>Pagination can be shown above or below the report (or both) and can be positioned on the left or right.</p>',
'<p>You can also use a simplified pagination style to improve performance, such as <strong>Row Ranges X to Y (with next and previous links)</strong>.',
'Using pagination types of the form "X to Y of Z", require the &PRODUCT_NAME. engine to perform two queries to return the results.',
'One query retrieves the current records to be displayed and another query gets the total record count to display in the pagination control.',
'For reports based on exceedingly large data sets or with very CPU intensive queries, such as numerous non-optimal table joins or expensive conditions, this additional query can add some processing time, which can lead to the report taking longer to r'
||'ender.</p>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795666807751596)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_text=>'Use Externally Created Pagination Buttons'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795772383751596)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_text=>'Row Ranges X to Y (with next and previous links)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795087358751595)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_text=>'Row Ranges X to Y (no pagination)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795166100751595)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_text=>'Row Ranges X to Y of Z (no pagination)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795312316751595)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_text=>'Row Ranges 1-15 16-30  (with set pagination)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795437999751595)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_text=>'Row Ranges 1-15 16-30 in select list (with pagination)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795284807751595)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_text=>'Row Ranges X to Y of Z (with pagination)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795500458751595)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_text=>'Search Engine 1,2,3,4 (set based pagination)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380759234787410002)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594990400500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.1.D'
,p_message_text=>'Borderless'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595855460500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.10.D'
,p_message_text=>'Custom 4'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595990983500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.11.D'
,p_message_text=>'Custom 5'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596050333500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.12.D'
,p_message_text=>'Custom 6'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596176463500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.13.D'
,p_message_text=>'Custom 7'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596220862500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.14.D'
,p_message_text=>'Custom 8'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595055290500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.2.D'
,p_message_text=>'Horizontal Border'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595122332500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.3.D'
,p_message_text=>'One Column Unordered List'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595267342500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.4.D'
,p_message_text=>'Standard'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595306058500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.5.D'
,p_message_text=>'Standard, Alternating Row Colors'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595455059500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.6.D'
,p_message_text=>'Value Attribute Pairs'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595555911500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.7.D'
,p_message_text=>'Custom 1'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595608321500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.8.D'
,p_message_text=>'Custom 2'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143595721560500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.LOV.9.D'
,p_message_text=>'Custom 3'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594891772500640)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_CLASS.PROMPT'
,p_message_text=>'Class'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596365251500641)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594612147500640)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_TYPE.LOV.GENERIC_COLUMNS.D'
,p_message_text=>'Generic Columns (column template)'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594764371500640)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_TYPE.LOV.NAMED_COLUMNS.D'
,p_message_text=>'Named Column (row template)'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594553289500640)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_TEMPLATE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718245884661330)
,p_name=>'PE.PROPERTY.CLEANUP_PROCEDURE_NAME.PROMPT'
,p_message_text=>'Cleanup Procedure Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693325126661307)
,p_name=>'PE.PROPERTY.CLICK_COUNT_CATEGORY.PROMPT'
,p_message_text=>'Category'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242659070670661088)
,p_name=>'PE.PROPERTY.CLIENT_ID_OR_USERNAME.HELP'
,p_message_text=>'Enter the Username for Basic Authentication and the Client ID for the OAuth2 Client Credentials flow. &PRODUCT_NAME. does not store this information encrypted.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658960685661087)
,p_name=>'PE.PROPERTY.CLIENT_ID_OR_USERNAME.PROMPT'
,p_message_text=>'Client ID or Username'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667684193661278)
,p_name=>'PE.PROPERTY.CLIENT_SECRET_OR_PASSWORD.HELP'
,p_message_text=>'Enter the Password for Basic Authentication and the Client Secret for the OAuth2 Client Credentials flow. &PRODUCT_NAME. stores this information encrypted, so it cannot be retrieved back in clear text.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667586020661278)
,p_name=>'PE.PROPERTY.CLIENT_SECRET_OR_PASSWORD.PROMPT'
,p_message_text=>'Client Secret or Password'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360874627946183859)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_text=>'Select the number of icons to display per row in Icon View. A value of 5 displays 5 icons per row of the report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782145990751547)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_text=>'1'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782205484751548)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_text=>'2'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782376824751548)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_text=>'3'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782486401751548)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_text=>'4'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782543546751548)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_text=>'5'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782614434751548)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_text=>'6'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782736727751548)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_text=>'7'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782840079751549)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_text=>'8'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782950993751549)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_text=>'9'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360874518922183859)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_text=>'Columns Per Row'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360491609174274738)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_text=>'Select the column display alignment. Note that your alignment selection must be supported by the selected report template.'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516777900596751529)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_text=>'center'
,p_version_scn=>37166067046347
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516777874661751529)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_text=>'start'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778090784751529)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_text=>'end'
,p_version_scn=>37166067046347
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360491522568274738)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_text=>'Column Alignment'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381153943040643967)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_text=>'Select a default column value type.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516799161698751608)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516799038619751608)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381153888896643965)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602863777784544)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Column headings play a crucial role in organizing and presenting tabular data in a clear and understandable format.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Descriptive and Meaningful:</strong> Use descriptive and meaningful column headings that accurately represent the content of each column. Column headings should succinctly convey the information contained within the respective columns.</l'
||'i>',
'<li><strong>Consistency:</strong> Maintain consistency in column headings throughout the table. Consistent column headings facilitate navigation and comprehension for users, especially when interacting with complex tables containing multiple columns.'
||'</li>',
'</ol>'))
,p_version_scn=>36587322
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602177842784528)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Column headings play a crucial role in organizing and presenting tabular data in a clear and understandable format.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Descriptive and Meaningful:</strong> Use descriptive and meaningful column headings that accurately represent the content of each column. Column headings should succinctly convey the information contained within the respective columns.</l'
||'i>',
'<li><strong>Consistency:</strong> Maintain consistency in column headings throughout the table. Consistent column headings facilitate navigation and comprehension for users, especially when interacting with complex tables containing multiple columns.'
||'</li>',
'</ol>'))
,p_version_scn=>36587306
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245991586681481467)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_text=>'Enter the group heading text.'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601756602784526)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IR_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Column headings play a crucial role in organizing and presenting tabular data in a clear and understandable format.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Descriptive and Meaningful:</strong> Use descriptive and meaningful column headings that accurately represent the content of each column. Column headings should succinctly convey the information contained within the respective columns.</l'
||'i>',
'<li><strong>Consistency:</strong> Maintain consistency in column headings throughout the table. Consistent column headings facilitate navigation and comprehension for users, especially when interacting with complex tables containing multiple columns.'
||'</li>',
'</ol>'))
,p_version_scn=>36587302
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603189203784546)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Column headings play a crucial role in organizing and presenting tabular data in a clear and understandable format.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Descriptive and Meaningful:</strong> Use descriptive and meaningful column headings that accurately represent the content of each column. Column headings should succinctly convey the information contained within the respective columns.</l'
||'i>',
'<li><strong>Consistency:</strong> Maintain consistency in column headings throughout the table. Consistent column headings facilitate navigation and comprehension for users, especially when interacting with complex tables containing multiple columns.'
||'</li>',
'</ol>'))
,p_version_scn=>36587323
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360490512109274736)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_text=>'Enter the report column heading text.'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360490427548274736)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_text=>'Heading'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596858978500642)
,p_name=>'PE.PROPERTY.COLUMN_HEADING_TEMPLATE.PROMPT'
,p_message_text=>'Heading'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764466661594730)
,p_name=>'PE.PROPERTY.COLUMN_INIT_JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764512433594730)
,p_name=>'PE.PROPERTY.COLUMN_INIT_JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>'Enter a JavaScript function that takes a configuration object for the column, modifies the object, and returns it. This allows advanced customization of the column appearance, features, and behavior.'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69763925134594545)
,p_name=>'PE.PROPERTY.COLUMN_INIT_JAVASCRIPT_CODE.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'  options.advancedOption = true;',
'  return options;',
'}',
'</pre>',
''))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69763826432594544)
,p_name=>'PE.PROPERTY.COLUMN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_text=>'<p>Enter a JavaScript function that takes a configuration object for the component, modifies the object, and returns it. This allows advanced customization of the appearance, features, and behavior of the component.</p>'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69763737930594543)
,p_name=>'PE.PROPERTY.COLUMN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_text=>'Column Initialization JavaScript Function'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38501571607611534)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_text=>'Is Sortable'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117338908246910317)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.COMPONENT_PROPERTY.WORKFLOW_VERSION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'The primary key column for the table which will serve as the system of records during execution of this workflow version.'))
,p_version_scn=>37166067046558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(568457223046739607)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_text=>'Choose the column containing the unique key to identify a row. Use this to provide the primary key value to custom JavaScript code or map event handlers.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(568457108727739607)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_text=>'Primary Key Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360489022764274733)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_text=>'Enter the column name for this report column.'
,p_version_scn=>37166067046343
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360488903960274733)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_text=>'Column Name'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970155564250215)
,p_name=>'PE.PROPERTY.COLUMN_NAME_UPPER.HELP'
,p_message_text=>'Enter the name of this region column. It must be a valid Oracle identifier.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970041252250215)
,p_name=>'PE.PROPERTY.COLUMN_NAME_UPPER.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380858341569128754)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_text=>'Ascending'
,p_version_scn=>37166067046536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380977013914206972)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_text=>'Ascending'
,p_version_scn=>37166067046537
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380452709537584106)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_text=>'Specify whether this column is sorted in Descending order. If not specified, the column is sorted in Ascending order (the default).'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792317025751584)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_text=>'Descending'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380452631577584106)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_text=>'Direction'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380451704331584105)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the sort sequence for this column.',
'Each column should have a unique sequence to correctly order the report output.'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791501915751582)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_text=>'1'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791665156751582)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_text=>'2'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791774052751583)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_text=>'3'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791841351751583)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_text=>'4'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791999126751583)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_text=>'5'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792031931751584)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_text=>'6'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792137464751584)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_text=>'7'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792277461751584)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_text=>'8'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380451680171584104)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_text=>'Default Sequence'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974388795250298)
,p_name=>'PE.PROPERTY.COLUMN_SOURCE_TYPE.HELP'
,p_message_text=>'Select the source type the value of this column is based on.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974418528250298)
,p_name=>'PE.PROPERTY.COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_text=>'Database Column'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974507315250298)
,p_name=>'PE.PROPERTY.COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_text=>'Set to the column value entered in <em>Database Column</em>, that is retrieved from the region source SQL Query.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974842198250299)
,p_name=>'PE.PROPERTY.COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974978460250299)
,p_name=>'PE.PROPERTY.COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_text=>'The column value is not retrieved from any source. For example, the APEX$ROW_SELECTOR and APEX$ROW_ACTION columns have no source.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974688417250299)
,p_name=>'PE.PROPERTY.COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974778593250299)
,p_name=>'PE.PROPERTY.COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_text=>'Set to the value returned from the <em>SQL Expression</em> entered.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974297004250298)
,p_name=>'PE.PROPERTY.COLUMN_SOURCE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597232849500642)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_1.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597547441500642)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_1_CONDITION.LOV.EVEN_ROW_NUMBERS.D'
,p_message_text=>'Use for Even Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597447347500642)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_1_CONDITION.LOV.NOT_CONDITIONAL.D'
,p_message_text=>'Use Based on PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597648612500642)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_1_CONDITION.LOV.ODD_ROW_NUMBERS.D'
,p_message_text=>'Use for Odd Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597328789500642)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_1_CONDITION.PROMPT'
,p_message_text=>'Condition'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597752447500642)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_1_EXPRESSION.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597836026500642)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_2.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598198766500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_2_CONDITION.LOV.EVEN_ROW_NUMBERS.D'
,p_message_text=>'Use for Even Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598031241500642)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_2_CONDITION.LOV.NOT_CONDITIONAL.D'
,p_message_text=>'Use Based on PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598278446500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_2_CONDITION.LOV.ODD_ROW_NUMBERS.D'
,p_message_text=>'Use for Odd Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143597915479500642)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_2_CONDITION.PROMPT'
,p_message_text=>'Condition'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598391708500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_2_EXPRESSION.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598474608500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_3.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598742840500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_3_CONDITION.LOV.EVEN_ROW_NUMBERS.D'
,p_message_text=>'Use for Even Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598650376500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_3_CONDITION.LOV.NOT_CONDITIONAL.D'
,p_message_text=>'Use Based on PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598849724500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_3_CONDITION.LOV.ODD_ROW_NUMBERS.D'
,p_message_text=>'Use for Odd Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598542611500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_3_CONDITION.PROMPT'
,p_message_text=>'Condition'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143598913512500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_3_EXPRESSION.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599034034500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_4.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599359700500644)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_4_CONDITION.LOV.EVEN_ROW_NUMBERS.D'
,p_message_text=>'Use for Even Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599216062500644)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_4_CONDITION.LOV.NOT_CONDITIONAL.D'
,p_message_text=>'Use Based on PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599453704500644)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_4_CONDITION.LOV.ODD_ROW_NUMBERS.D'
,p_message_text=>'Use for Odd Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599100148500643)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_4_CONDITION.PROMPT'
,p_message_text=>'Condition'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599563408500644)
,p_name=>'PE.PROPERTY.COLUMN_TEMPLATE_4_EXPRESSION.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360489219942274734)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_text=>'Enter the data type for the report column.'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360489126652274734)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380444191321584090)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the column width in pixels.',
'Use this attribute when displaying reports in a browser.',
'Note that setting the column width must be supported by the selected report template.'))
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380444072942584090)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_text=>'Cell Width'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388641088657170307)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123086911830211764)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123086804386211763)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_text=>'Comments'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717331434661329)
,p_name=>'PE.PROPERTY.COMMIT_EACH_ROW.LOV.N.D'
,p_message_text=>'Once'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717467663661329)
,p_name=>'PE.PROPERTY.COMMIT_EACH_ROW.LOV.Y.D'
,p_message_text=>'Each Row'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717278690661329)
,p_name=>'PE.PROPERTY.COMMIT_EACH_ROW.PROMPT'
,p_message_text=>'Commit'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711455407661324)
,p_name=>'PE.PROPERTY.COMMIT_INTERVAL.PROMPT'
,p_message_text=>'Commit Interval'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116958276852909846)
,p_name=>'PE.PROPERTY.COMPARE_VALUE.HELP'
,p_message_text=>'Specify the value to compare with.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116957983554909846)
,p_name=>'PE.PROPERTY.COMPARE_VALUE.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719323676661331)
,p_name=>'PE.PROPERTY.COMPATIBILITY_MODE.LOV.19.1.D'
,p_message_text=>'19.1'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719226098661331)
,p_name=>'PE.PROPERTY.COMPATIBILITY_MODE.LOV.19.2.D'
,p_message_text=>'19.2 / 20.1 / 20.2 / 21.1'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719120528661331)
,p_name=>'PE.PROPERTY.COMPATIBILITY_MODE.LOV.21.2.D'
,p_message_text=>'21.2 to 24.1'
,p_version_scn=>20717625
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719830665661331)
,p_name=>'PE.PROPERTY.COMPATIBILITY_MODE.LOV.4.0.D'
,p_message_text=>'Pre 4.1'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719782136661331)
,p_name=>'PE.PROPERTY.COMPATIBILITY_MODE.LOV.4.1.D'
,p_message_text=>'4.1'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719626252661331)
,p_name=>'PE.PROPERTY.COMPATIBILITY_MODE.LOV.4.2.D'
,p_message_text=>'4.2'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719579215661331)
,p_name=>'PE.PROPERTY.COMPATIBILITY_MODE.LOV.5.0.D'
,p_message_text=>'5.0'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719479869661331)
,p_name=>'PE.PROPERTY.COMPATIBILITY_MODE.LOV.5.1.D'
,p_message_text=>'5.1 / 18.1 / 18.2'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719024085661331)
,p_name=>'PE.PROPERTY.COMPATIBILITY_MODE.PROMPT'
,p_message_text=>'Compatibility Mode'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583946659500633)
,p_name=>'PE.PROPERTY.COMPLETION_FUNCTION_NAME.PROMPT'
,p_message_text=>'Completion Function Name'
,p_version_scn=>6572870
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933065737296784)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_text=>'Enter CSS classes to apply to this component. This class will apply to the cards container.  You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932931773296784)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(220462851849847738)
,p_name=>'PE.PROPERTY.COMPONENT_SETTING_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base these component settings on existing component settings in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(220462738409847737)
,p_name=>'PE.PROPERTY.COMPONENT_SETTING_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203897224982798)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG_VARCHAR2.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204236905982798)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204124748982798)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204039398982798)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204390629982798)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203943490982798)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG_VARCHAR2.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203740350982798)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104204506276415)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG_VARCHAR2.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104569692276415)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104473748276415)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104323024276415)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104670141276415)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104125987276415)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123093420740211779)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_text=>'Enter the page or application item populated by this computation. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123093328715211779)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_text=>'Item Name'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123095622151211787)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_text=>'Enter the item whose value is used to populate the computation item. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123095529682211787)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_text=>'Item Name'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600275785920090614)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a Java expression that produces a value used to populate the computation item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600275604178090614)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600277332787090622)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter a Java function body that returns a value used to populate the computation item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600277272635090622)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609336564484644)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600275428868090614)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a JavaScript expression that produces a value used to populate the computation item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600275321391090614)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609520982484645)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES" : "NO" );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600277080793090622)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter a JavaScript function body that returns a value used to populate the computation item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600276968764090622)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609234025484644)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600275182267090614)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a PL/SQL expression that produces a value used to populate the computation item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600275026700090614)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609414028484645)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600276767058090621)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter a PL/SQL function body that returns a value used to populate the computation item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600276605295090621)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123096206721211787)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select at what point in page rendering or processing this computation is executed.',
'The most typical computation point is <strong>After Submit</strong>.'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756452926751441)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_text=>'After Regions'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371204159373699)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_text=>'Rendering: Executes after regions render.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756603006751441)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_text=>'After Footer'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371430636373701)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_text=>'Rendering: Executes after footer renders.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756272085751441)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_text=>'After Header'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371006815373697)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_text=>'Rendering: Executes after the header renders.'
,p_version_scn=>37166067046331
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756735524751441)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_text=>'After Submit'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371565661373701)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_text=>'Processing: Executes after the page is submitted, but before page processing.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756362383751441)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_text=>'Before Regions'
,p_version_scn=>37166067046332
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371196303373698)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_text=>'Rendering: Executes before regions render.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756577909751441)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_text=>'Before Footer'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371337512373700)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_text=>'Rendering: Executes before footer renders.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756164322751440)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_text=>'Before Header'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644370978002373696)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_text=>'Rendering: Executes before the page renders.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756044398751440)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_text=>'New Session'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644370802136373695)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_text=>'Executes when a new session is generated.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123096124772211787)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_text=>'Point'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123095813540211787)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_text=>'Enter a User Preference that has a value used to populate the computation item.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123095711912211787)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_text=>'Preference'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600275932924090614)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a Python expression that produces a value used to populate the computation item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600275892998090614)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600277551771090622)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter a Python function body that returns a value used to populate the computation item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600277493471090622)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599827060301464311)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_text=>'Enter a SQL query that provides a value used to populate the computation item. If the result contains multiple rows then the value from each row is formed into a single colon delimited value.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826963806464310)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609146698484644)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600274846398090613)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a SQL expression that produces a value used to populate the computation item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600274774582090613)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123094810263211781)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_text=>'Enter a SQL query that provides a value used to populate the computation item. If the result contains multiple rows then only the value from the first row is returned.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123094702837211781)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123094631803211781)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_text=>'Enter the text that is used to populate the computation item.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123094531932211781)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123093615880211779)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_text=>'Select a computation type from the following list.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600257265962090243)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600257348399090244)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>Expression</em> entered.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516755379587751437)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599822022575464041)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516755838398751438)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599821599640464038)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516755436885751438)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599821663714464039)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516755578989751438)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_text=>'SQL Query (return multiple values)'
,p_version_scn=>19621403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599821722695464039)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_text=>'Set to multiple values returned from the <em>SQL Query</em>. The format of what is returned is determined by the current item''s Multiple Values setting. If Multiple Values is set to <em>Delimited Values</em>, the value will be a single concatenated l'
||'ist separated by the defined Separator. If Multiple Values is set to <em>JSON Array</em>, the value will be a JSON Array of the values. If Multiple Values is set to <em>No</em> or the item does not support multiple values, then the value is a single '
||'concatenated list separated by a colon.'
,p_version_scn=>20476609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516755972899751439)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_text=>'Preference'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599822145614464041)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_text=>'Set to the value of the <em>Preference</em> entered.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516755223321751436)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599821458752464032)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_text=>'Set to the text entered into <em>Static Value</em>.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123093509088211779)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380443969485584090)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'For this column, specify whether the sum is computed and displays at the end of the report.',
'When used with break columns, the total sum and the sum on each break displays.'))
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380443855250584089)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_text=>'Compute Sum'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10575944104340719)
,p_name=>'PE.PROPERTY.COMP_GRP_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this component group on an existing component group in another application in your workspace.'
,p_version_scn=>49870249
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10575834677340719)
,p_name=>'PE.PROPERTY.COMP_GRP_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>49870248
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749455020661392)
,p_name=>'PE.PROPERTY.CONCATENATED_FILE_URL.PROMPT'
,p_message_text=>'Concatenated File URL'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202492139982792)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202875398982792)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202781096982792)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202610858982792)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202934240982792)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202513419982792)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202348609982792)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103009317276410)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103348441276410)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103256053276410)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103118851276410)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103473770276410)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102941455276409)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123167714252211908)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123167608558211908)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123169117370211911)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123169005342211910)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600268335393090599)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Expression for this condition.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600268229890090599)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600269960180090601)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600269856931090601)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608251903484632)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600268086578090599)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Expression for this condition.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600267992393090598)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608462795484633)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600269647358090601)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600269556203090601)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123167908615211909)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_text=>'Enter a colon(:) separated list of values for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123167813607211909)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168312331211909)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_text=>'Enter the Page Number for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168202961211909)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_text=>'Page'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168510984211910)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_text=>'Enter a comma separated list of Page Numbers for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168424697211909)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_text=>'Pages'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608107591484632)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600267780089090598)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Expression for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600267689086090598)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608315593484633)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600269370974090600)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600269256284090600)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168115001211909)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_text=>'Enter a User Preference that is compared against the specified value for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168010522211909)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_text=>'Preference'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600268522809090599)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Expression for this condition.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600268434780090599)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600270150015090601)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600270062321090601)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608011423484632)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600267401226090598)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a SQL Expression for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600267337664090598)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175607977001484630)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully as one or more rows exist when checking if the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>To return successfully as no rows exist when checking if the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123166724043211907)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_text=>'Enter a SQL query for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123166600710211907)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168703353211910)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_text=>'Enter the text value for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168607739211910)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123169305495211911)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123169218672211911)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(420748770880532414)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_text=>'Select a condition type to be met in order for this action to be active.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123170507900211913)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_text=>'Select a condition type to be met in order for this dynamic action to be active.'
,p_version_scn=>37166067046504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123160319194211897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_text=>'Select a condition type that must be met in order for this component to be rendered or processed.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929712047751957)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835744138464447)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_text=>'The component will always be rendered or executed.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928354455751954)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_text=>'Client Browser is Microsoft Internet Explorer 7.0 or higher'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928475425751954)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_text=>'Client Browser is XHTML / CSS capable browser'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928261677751954)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_text=>'Client Browser is Mozilla, Netscape 6.x/7x or higher'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928500008751954)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_text=>'Client Browser is Other browsers (or older version)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926942387751951)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_text=>'Text is contained in Item'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928970189751955)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_text=>'Current Language = Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839529010464467)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_text=>'The end user is currently running the application in the language you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928686393751954)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_text=>'Current Language is contained in Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839778056464468)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_text=>'The end user is currently running the application in one of the languages you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928828380751955)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_text=>'Current Language != Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839602404464467)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_text=>'The end user is not currently running the application in the language you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928793505751955)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_text=>'Current Language is NOT contained in Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839892145464469)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_text=>'The end user is not currently running the application in one of the languages you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926113536751949)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_text=>'Current Page = Page'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838332969464461)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_text=>'The current page is equal to the value you enter into <em>Page</em>.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926349566751949)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_text=>'Current Page is in comma delimited list'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838531384464462)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_text=>'The current page is in the comma separated list you enter into <em>Pages</em>.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926203673751949)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_text=>'Current Page != Page'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838443496464461)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_text=>'The current page is not equal to the value you enter into <em>Page</em>.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926442009751950)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_text=>'Current Page is NOT in comma delimited list'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838675545464462)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_text=>'The current page is not in the comma separated list you enter into <em>Pages</em>.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929063664751955)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: DAD_NAME = Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929199812751956)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: DAD_NAME != Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927828640751953)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_text=>'Inline Validation Errors displayed'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839360269464466)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_text=>'An inline validation error is displayed on the page, following a page submission.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927218685751951)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_text=>'Text = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927019367751951)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_text=>'Text is contained in Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927151979751951)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_text=>'Text is NOT contained in Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927367144751952)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_text=>'Text != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516923608299751944)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835808839464448)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_text=>'The SQL query returns one or more rows.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600266451354090590)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600266555117090590)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'The expression evaluates to TRUE.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924027701751945)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599836225432464450)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'The function body returns TRUE.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929453707751957)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: HTTP_HOST = Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929565800751957)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: HTTP_HOST != Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927586188751952)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_text=>'Page/Region is NOT Read Only'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839063251464465)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_text=>'The page and parent region, if appropriate, are displayed normally.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927456450751952)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_text=>'Page/Region is Read Only'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838909234464464)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_text=>'Either the page or parent region, if appropriate, ''Read Only'' condition evaluates to TRUE.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925348571751948)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_text=>'Item contains no spaces'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837599474464456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_text=>'The value of the selected <em>Item</em> has no spaces.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925605457751948)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_text=>'Item is alphanumeric'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837814003464458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is alphanumeric, containing only letters or numbers and no special characters.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924835194751946)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_text=>'Item is NOT NULL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837098774464454)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not empty.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925513382751948)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_text=>'Item is NOT numeric'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837742715464457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not numeric.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925082711751947)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_text=>'Item is NOT zero'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837278749464455)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not the number zero.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924789297751946)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_text=>'Item is NULL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599836931028464453)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is empty.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925167199751947)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_text=>'Item is NULL or zero'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837363932464455)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is empty or the number zero.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925435346751948)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_text=>'Item is numeric'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837616261464457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is numeric.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924981517751946)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_text=>'Item is zero'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837106737464454)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is the number zero.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925223703751947)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_text=>'Item is NOT NULL and NOT zero'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837401119464456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not empty and not the number zero.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928080455751953)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_text=>'SQL Reports (OK to show the forward button)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516928196889751954)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_text=>'SQL Reports (OK to show the back button)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929638532751957)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839963225464470)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The component is never rendered or executed.</p>',
'<p>Note: Changing a condition to <strong>Never</strong> will remove any existing condition. For temporarily disabling a component, Oracle recommends using the <em>Build Option</em> attribute instead.</p>'))
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927969583751953)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_text=>'Inline Validation Errors NOT displayed'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839464734464466)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_text=>'An inline validation error is not displayed on the page.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516923751761751944)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835980060464448)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_text=>'The SQL Query returns no rows'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926701557751950)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_text=>'Current Page is in Printer Friendly Mode'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838767949464463)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_text=>'The current page has been toggled to ''Printer Friendly Mode'' by the end user.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926863886751951)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_text=>'Current page is NOT in Printer Friendly Mode'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838852856464463)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_text=>'The current page has not been toggled to ''Printer Friendly Mode'' by the end user.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924116850751945)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_text=>'Request = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599836337302464450)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_text=>'The page request is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924359904751945)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_text=>'Request is contained in Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599836529095464451)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_text=>'The page request is contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924233398751945)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_text=>'Request != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599836412968464451)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_text=>'The page request is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924413292751945)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_text=>'Request is NOT contained in Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599836682618464452)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_text=>'The page request is not contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929262452751957)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: SERVER_NAME = Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929305387751957)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: SERVER_NAME != Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927641512751952)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_text=>'User is Authenticated (not public)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839101234464465)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_text=>'The end user is logged into the application.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516927728861751952)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_text=>'User is the Public User (user has not authenticated)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599839217201464465)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_text=>'The end user is not logged into the application.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925983670751949)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_text=>'User Preference = Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838158697464460)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_text=>'The value of the <em>Preference</em> entered is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926044500751949)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'User Preference != Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838272812464460)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_text=>'The value of the <em>Preference</em> entered is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925728392751948)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is in colon delimited list'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599837967082464458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is completely contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516925847691751949)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is NOT in colon delimited list'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599838035434464459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not completely contained in the text you entered into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924531737751946)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_text=>'Item = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599836716849464452)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516924650946751946)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'Item != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599836830298464453)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926614057751950)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_text=>'Current Page != Page Submitted (posted)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516926597129751950)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_text=>'Current Page = Page Submitted (posted)'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123160220021211896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123167503429211908)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_text=>'Enter the value to compare against the condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123167421072211908)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168920425211910)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123168810330211910)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046471
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753999871661396)
,p_name=>'PE.PROPERTY.CONFIGURATION_MESSAGE.PROMPT'
,p_message_text=>'Application Substitutions'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170257298473078)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Protect the button''s behavior with a confirmation prompt. Shows a confirmation dialog after the button has been clicked, where the user must confirm before the button performs its action.</p>',
'<p>This functionality can be used to ensure the user does not perform a significant action by accident, such as deleting a record.</p>',
'<p>Note: The confirmation button in the dialog derives its label from the main button label.</p>'))
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170117209473080)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_text=>'Requires Confirmation'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601052244784514)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.COMPONENT_PROPERTY.BUTTON.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When designing message confirmation dialogs or prompts, it''s essential to consider accessibility to ensure all users can easily understand and interact with the confirmation message.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Clear and Informative Content:</strong>',
'Ensure that the confirmation message provides clear and concise information about the action being confirmed. Use straightforward language that is easy to understand for all users.</li>',
'<li><strong>Accessible Formatting:</strong>',
'Format the confirmation message in a way that is accessible to users with various assistive technologies, such as screen readers. Use semantic HTML elements and provide alternative text for any non-text elements like buttons.</li>',
'<li><strong>Consistent Design:</strong>',
'Maintain consistency in the design and placement of message confirmation dialogs across your application or website. Consistency helps users predict the location of the confirmation message and reduces confusion.</li>',
'<li><strong>User Control:</strong>',
'Provide users with the option to review their action before confirming, especially for critical or irreversible actions. This empowers users to make informed decisions and reduces the likelihood of unintentional actions.</li>',
'</ol>',
'<p>By following these accessibility considerations, you can ensure that message confirmation dialogs are inclusive and usable for all users, regardless of their abilities or assistive technology usage.</p>'))
,p_version_scn=>36587286
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170586514473076)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_text=>'<pre>&lt;strong&gt;Are you sure&lt;&#x2F;strong&gt; you wish to delete employee &amp;P1_ENAME.?</pre>'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170465583473076)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_text=>'Enter the message to be displayed in the confirmation dialog.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170393950473076)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_text=>'Message'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100171281931473034)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_text=>'Default'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170757805473076)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_text=>'Specify the style of the dialog.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100171082657473076)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_text=>'Danger'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170875439473076)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_text=>'Information'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100171107873473076)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_text=>'Success'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170959739473076)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_text=>'Warning'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100170639866473076)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_text=>'Style'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380739045756813986)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_text=>'Select the content-disposition for the downloaded file. Content-disposition is an extension to the MIME protocol that instructs the browser on how the document displays.'
,p_version_scn=>5717665
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792512381751588)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_text=>'Attachment'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802518278372837)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.HELP'
,p_message_text=>'Saves the file to disk.'
,p_version_scn=>5717665
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792685096751589)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_text=>'Inline'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802656360372837)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.HELP'
,p_message_text=>'Displays the file instead of the current page.'
,p_version_scn=>5717666
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380738934770813986)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_text=>'View File As'
,p_version_scn=>5717665
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150990619237822711)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the URL domain attribute for the session cookie.',
'If the tail comparison of the request URL does not match the domain specified, the cookie is not sent to the browser.',
'The default value is the host name of the request URL.</p>',
'<p>Use this attribute to specify a less restrictive domain, when you wish to share session cookies between applications that have common domains.',
'For example, <code>my.yahoo.com</code>, <code>sport.yahoo.com</code>, and <code>finance.yahoo.com</code> could all access the same cookie if a domain of <code>yahoo.com</code> is entered.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150990515490822711)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_text=>'Cookie Domain'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150990206085822711)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name for the session cookie, which is required to identify a &PRODUCT_NAME. session, together with the session id in the URL.',
'If you do not specify a session cookie name, &PRODUCT_NAME. utilizes a default value.</p>',
'<p>By entering the same cookie name in multiple applications, each of the applications can utilize the same session cookie.',
'Therefore, a URL call from a &PRODUCT_NAME. application to another &PRODUCT_NAME. application, with the same cookie name, does not require the user to re-authenticate, because the new application can utilize the existing session cookie.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150990124167822710)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_text=>'Cookie Name'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150990419773822711)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the URL path attribute for the session cookie.',
'If the start of the request URL does not match the path specified, the cookie is not sent to the browser.',
'The default value is the path of the request URL.</p>',
'<p>Use this attribute to specify a less restrictive path, when you wish to share session cookies between applications that have initially conforming URL paths.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150990332273822711)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_text=>'Cookie Path'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691693643661306)
,p_name=>'PE.PROPERTY.COOKIE_TYPE.LOV.A.D'
,p_message_text=>'Application (No Sharing)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691824807661306)
,p_name=>'PE.PROPERTY.COOKIE_TYPE.LOV.C.D'
,p_message_text=>'Custom'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691777283661306)
,p_name=>'PE.PROPERTY.COOKIE_TYPE.LOV.W.D'
,p_message_text=>'Workspace Sharing'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691566017661306)
,p_name=>'PE.PROPERTY.COOKIE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722770897661334)
,p_name=>'PE.PROPERTY.COPYRIGHT_BANNER.PROMPT'
,p_message_text=>'Copyright Banner'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693252551661307)
,p_name=>'PE.PROPERTY.COUNT_CLICKS.PROMPT'
,p_message_text=>'Count Clicks'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669959515661285)
,p_name=>'PE.PROPERTY.CREDENTIALS.PROMPT'
,p_message_text=>'Credentials'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657680361661070)
,p_name=>'PE.PROPERTY.CREDENTIAL_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the Authentication type here. &PRODUCT_NAME. supports the following authentication types:</p>',
'<ul>',
'    <li><strong>Basic Authentication</strong> - Sends username and password in Base64-encoded form as the <strong>Authorization</strong> request header.</li>',
'    <li><strong>OAuth2 Client Credentials</strong> - &PRODUCT_NAME. exchanges the client ID and client secret for an <strong>Access Token</strong> using a token server URL. The access token is t',
'hen used to perform the actual request. If the access token is expired, &PRODUCT_NAME. will transparently request a new one.</li>',
'    <li><strong>OCI Native Authentication</strong> - &PRODUCT_NAME. signs requests to the <em>Oracle Cloud Infrastructur',
'e (OCI)</em> REST API, as described in the <a rel="noopener noreferrer" href="https://docs.cloud.oracle.com/en-us/iaas/Content/API/Concepts/signingrequests.htm">OCI Documentation</a>.</li>',
'    <li><strong>HTTP Hea',
'der</strong> - The credential is added to the REST request as an HTTP Header. The name of the credential is used as the HTTP Header name, and the Secret of the credential is used as the HTTP Header value. &PRODUCT_NAME. does not add these secrets to',
'the Debug log or any other logs.</li>',
'    <li><strong>URL Query String</strong> -  The credential is added to the URL of the REST request as a <em>Query String</em> Parameter (for example: <strong>?name=value</strong>). This option can be useful with',
' API keys. &PRODUCT_NAME. does not add these secrets to the Debug log or any other logs. However, web proxy or other intermediate servers may record these credentials in their log files.</li>',
'    <li><strong>Key Pair</strong> - A key pair credential consists of a public key, openly shared for encrypting data, and a private key, securely kept secret for decrypting data, together ensuring a secure data exchange.</li>',
'</ul>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657749079661070)
,p_name=>'PE.PROPERTY.CREDENTIAL_TYPE.LOV.BASIC.D'
,p_message_text=>'Basic Authentication'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658006490661070)
,p_name=>'PE.PROPERTY.CREDENTIAL_TYPE.LOV.CERTIFICATE_PAIR.D'
,p_message_text=>'Certificate/Private Key Pair'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658198747661070)
,p_name=>'PE.PROPERTY.CREDENTIAL_TYPE.LOV.HTTP_HEADER.D'
,p_message_text=>'HTTP Header'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658273057661071)
,p_name=>'PE.PROPERTY.CREDENTIAL_TYPE.LOV.HTTP_QUERY_STRING.D'
,p_message_text=>'URL Query String'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657834536661070)
,p_name=>'PE.PROPERTY.CREDENTIAL_TYPE.LOV.OAUTH2_CLIENT_CREDENTIALS.D'
,p_message_text=>'OAuth2 Client Credentials Flow'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657973451661070)
,p_name=>'PE.PROPERTY.CREDENTIAL_TYPE.LOV.OCI.D'
,p_message_text=>'Oracle Cloud Infrastructure (OCI)'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657504690661070)
,p_name=>'PE.PROPERTY.CREDENTIAL_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516755097687751435)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Standard file reference</dt>',
'<dd><pre>/mycss/main.css</pre></dd>',
'<dt>Standard file reference which loads the minified file main.min.css from /mycss/minified/ for regular page views and main.css from /mycss/ in debug mode or when running the application from App Builder.</dt>',
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
'<dt>Conditional media query</dt>',
'<dd><pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
'<dt>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser is instructed to always load the new file and ignore any previously cache'
||'d files.</dt>',
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092228073211777)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet (CSS) file URLs loaded on this page. Each URL must be written on a new line.',
'If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <code>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty'
||' string if the page is viewed in debug mode or when running the application from App Builder.',
'You also have access to the substitution string <code>#APP_VERSION#</code> if you want to include the application''s version in the file URL.</p>',
'<p>File URLs you enter here replace the <code>#PAGE_CSS#</code> substitution string in the page template.</p>',
'<p>Each file URL can optionally be prefixed with <code>[media ...]</code> for conditional loading. See the examples for details.</p>',
'<p>Note: You do not need to include opening or closing <code>link</code> tags. Just include the file URL.</p>',
'<p>To comment out a File URL, prefix the line with two dashes: <code>--</code>. To comment out multiple lines, use the typical code block syntax: <code>/* */</code>.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092121157211777)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_text=>'File URLs'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791493441751582)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Setting this attribute to <code>color:#FF0000;</code> changes the text color of the column to red and generates the following HTML</dt>',
'<dd><pre>',
'&lt;span style="color:#FF0000"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380451345403584104)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_text=>'Enter CSS styles to apply to this column''s value. You can type in the CSS style or pick from the list of available items.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380451216117584103)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_text=>'CSS Style'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360870900155183856)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_text=>'Enter a delimiter character to delineate the starting and ending boundary of a data value. The default delimiter is double quotation marks.'
,p_version_scn=>14922478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360870824321183855)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_text=>'CSV Enclosed By'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380762161673410008)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_text=>'Specify whether end users can download the report contents to a CSV file. To enable <em>CSV Downloads</em>, you must use a report template with a <code>#CSV_LINK#</code> substitution string and set this option to <strong>On</strong>.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380762030074410007)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_text=>'CSV Export Enabled'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360870711254183855)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_text=>'Enter a column separator. If no value is entered, a comma or semicolon is used depending on your current NLS settings. Use <code>\t</code> to indicate the TAB character.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360870602517183855)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_text=>'CSV Separator'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726665742661337)
,p_name=>'PE.PROPERTY.CURRENT_AUTHENTICATION_SCHEME.PROMPT'
,p_message_text=>'Authentication Scheme'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588025303500636)
,p_name=>'PE.PROPERTY.CURRENT_IMAGE_TAB.PROMPT'
,p_message_text=>'Current'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600772989001656)
,p_name=>'PE.PROPERTY.CURRENT_SELECTION_PAGE_ITEM.HELP'
,p_message_text=>'Enter the page item used to store the selection state. It holds information about all selected records and their primary key values. Stores these values as a string separated by colons.'
,p_version_scn=>11004648
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600610023001656)
,p_name=>'PE.PROPERTY.CURRENT_SELECTION_PAGE_ITEM.PROMPT'
,p_message_text=>'Current Selection Page Item'
,p_version_scn=>6739878
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123100012625211793)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_text=>'Specify whether the cursor is focused when first entering the page.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748692045751416)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_text=>'First item on page'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748780590751416)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_text=>'The cursor focus is placed on the first field on the page using JavaScript, generated by the &PRODUCT_NAME. engine.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748882487751416)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_text=>'Do not focus cursor'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748993203751416)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The cursor is not focused and no JavaScript is generated.<br>',
'Select this option if the generated JavaScript conflicts with custom JavaScript.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123089325833211773)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_text=>'Cursor Focus'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150996400445842739)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_text=>'Select whether display attributes in this region can be customized by the user.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516771935950751506)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_text=>'Not Customizable By End Users'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516771841521751506)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_text=>'Customizable and Shown By Default'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516771727094751506)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_text=>'Customizable and Not Shown By Default'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150996318276842739)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_text=>'Customizable'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150994907650822720)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the label for the link that displays under this region, which provides access to the region customization page.',
'This label only displays for regions that are customizable.'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150994830018822719)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(394425890024693091)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML text to include for this button:',
'<ul>',
'  <li>For buttons of type <strong>HTML Button</strong>, this text is added to the HTML element definition.</li>',
'  <li>For buttons based on templates, your template must include the <code>#BUTTON_ATTRIBUTES#</code> substitution string.</li>',
'</ul>',
'<p>You can use this attribute to control tab stops</p>'))
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(394426028149693105)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_text=>'The report template substitution string <code>#REPORT_ATTRIBUTES#</code> is replaced with this value.  The <code>#REPORT_ATTRIBUTES#</code> substitution string is only replaced in the before rows attribute of the report template.'
,p_version_scn=>37166067046536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245992129959481471)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>'Enter additional attributes to be included in the form element HTML tag. The <code>size</code> and <code>id</code> HTML attributes are generated and therefore should not be supplied. For the <code>class</code> HTML attribute it is better to use the d'
||'edicated <em>CSS Classes</em> attribute instead.'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(394425725738693088)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_text=>'Enter additional attributes to be included in the form element HTML tag. The <code>size</code> and <code>id</code> HTML attributes are generated and therefore should not be supplied. For the <code>class</code> HTML attribute it is better to use the d'
||'edicated <em>CSS Classes</em> attribute instead.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(394425921378693093)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>'Enter the value substituted into region attributes. Region templates that contain the substitution string <code>#REGION_ATTRIBUTES#</code> are substituted with this value.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(394426114690693109)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_text=>'The report template substitution string <code>#REPORT_ATTRIBUTES#</code> is replaced with this value.  The <code>#REPORT_ATTRIBUTES#</code> substitution string is only replaced in the before rows attribute of the report template.'
,p_version_scn=>37166067046537
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(394425637481692917)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter additional space delimited attributes to be included in the item tag.',
'For the HTML CLASS attribute, Oracle recommends using the dedicated CSS Classes attribute.'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(394425544548692903)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_text=>'Custom Attributes'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337337426518204970)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_text=>'Specify the custom column name, which can be used for defining a custom tooltip, or database-based colors to be used for the chart elements. For a Box Plot chart, the column should not match the selected Value column mapping. Selection of a column th'
||'at matches the Value column mapping will result in no custom column being used for the chart.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337337375093204970)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_text=>'Custom Column'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123097409584211789)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_text=>'Specify a custom JavaScript event name if the declarative events provided are not sufficient.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123097301501211789)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_text=>'Custom Event'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633725553500669)
,p_name=>'PE.PROPERTY.CUSTOM_ICON_CLASSES.PROMPT'
,p_message_text=>'Custom Classes'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633804205500669)
,p_name=>'PE.PROPERTY.CUSTOM_ICON_PREFIX_CLASS.PROMPT'
,p_message_text=>'Custom Prefix Class'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633692376500669)
,p_name=>'PE.PROPERTY.CUSTOM_LIBRARY_FILE_URLS.PROMPT'
,p_message_text=>'Custom Library File URLs'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715589987035627)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.COMPONENT_PROPERTY.AUTOMATION_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715773358035653)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.COMPONENT_PROPERTY.JET_CHART_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715388844035617)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.COMPONENT_PROPERTY.LOV_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715933855035688)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.COMPONENT_PROPERTY.MAP_LAYER_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046554
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60714992028035600)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.COMPONENT_PROPERTY.REGION_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78521522445696243)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.COMPONENT_PROPERTY.SEARCH_CONFIG_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046534
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775255742661521)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.COMPONENT_PROPERTY.WEB_SRC_OPERATION.NULL_TEXT'
,p_message_text=>'Not Mapped'
,p_version_scn=>37166067046524
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715177542035608)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.COMPONENT_PROPERTY.WEB_SRC_SYNC_STEP_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046524
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117343484374910327)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.COMPONENT_PROPERTY.WF_ACTIVITY_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261571097719749)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Assign a <strong>Database Operation</strong> to this HTTP operation. The database operation is important for &PRODUCT_NAME. components to work with the REST Data Source. An &PRODUCT_NAME. component is assigned a REST Data Source (and not an opera'
||'tion), thus it looks up the HTTP operation based on the required database operation.',
'</p>',
'<ul>',
'    <li>Visualization components like report, charts, CSS calendar and others, will always use the HTTP operation assigned to the <strong>Fetch Rows</strong> database operation. <strong>APEX_EXEC.OPEN_WEB_SOURCE_QUERY</strong> will also use the Fetch'
||' Rows database operation.</li>',
'    <li>When a Form component inserts, updates or deletes rows, it will use the operations assigned to the <strong>Insert Row</strong>, <strong>Update Row</strong> or <strong>Delete Row</strong>, respectively. In PL/SQL, <strong>APEX_EXEC.OPEN_WEB_SO'
||'URCE_DML_CONTEXT</strong> is the equivalent to a form.</li>',
'    <li>The <strong>Fetch Single Row</strong> database operation is used by the Form component when lost update detection or the allowed operations check is performed. The form then uses this operation to re-fetch the row from the REST service before'
||' doing the actual DML operation.</li>',
'    <li>Operations which are not mapped to a database operation, will not be used by &PRODUCT_NAME. components. Use the <strong>APEX_EXEC.EXECUTE_WEB_SOURCE</strong> PL/SQL procedure to execute these from a PL/SQL context.</li>',
'</ul>',
'<p>',
'    <br>',
'    For instance, the report or chart components of &PRODUCT_NAME. require a collection of rows. When working with',
'    a REST Data Source, &PRODUCT_NAME. will look up the <strong>Fetch rows</strong> database operation and  execute',
'    the assigned HTTP operation at runtime. A Form will look for Insert Row, Update Row or Delete Row database operations.',
'</p>',
'<p>',
'    Each database operation can be assigned only once within a REST Data Source. This abstraction of the &PRODUCT_NAME. component from the actual HTTP operation allows to create a new operation with different behavior and assign that to the database '
||'operation. All components will then transparently use the new HTTP operation.',
'</p>',
'<p>',
'    There is no restriction on which HTTP operation (GET, POST, PUT, DELETE) can be mapped to which database operation. A POST HTTP operation can be mapped to the Fetch Rows database operation. However, for clarity and maintainability, it is recommen'
||'ded to design REST APIs to use GET for fetch operations and to use POST, PUT, DELETE to change data.',
'</p>'))
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262036884719754)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_text=>'Delete Row'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261678586719751)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_text=>'Fetch Rows'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261772888719752)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_text=>'Fetch Single Row'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261830383719752)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_text=>'Insert Row'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261991090719753)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_text=>'Update Row'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261444992719748)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_text=>'Database Operation'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845476773751742)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388951478294781578)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the background of the data displayed in this calendar.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388951375163781577)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_text=>'Data Background'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755150992661397)
,p_name=>'PE.PROPERTY.DATA_LOAD_DEF_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78519354172696106)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.BLOB.D'
,p_message_text=>'BLOB'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705418223661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.CLOB.D'
,p_message_text=>'CLOB'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705076708661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.DATE.D'
,p_message_text=>'DATE'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705643480661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.DOCUMENT_FRAGMENT.D'
,p_message_text=>'JSON Document'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704977997661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.NUMBER.D'
,p_message_text=>'NUMBER'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705568483661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_text=>'Geometry (SDO_GEOMETRY)'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705298252661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.TIMESTAMP WITH LOCAL TIME ZONE.D'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705371290661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.TIMESTAMP WITH TIME ZONE.D'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705193685661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_text=>'TIMESTAMP'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704848553661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.LOV.VARCHAR2.D'
,p_message_text=>'VARCHAR2'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704713382661318)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_DATA_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709186445661321)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_PATH.PROMPT'
,p_message_text=>'Path Expression'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704516008661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_SELECTOR.PROMPT'
,p_message_text=>'Selector'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704602304661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_SELECTOR_NO.PROMPT'
,p_message_text=>'Column Number'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703787738661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_TYPE.LOV.DATA.D'
,p_message_text=>'Data'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703865584661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_TYPE.LOV.LOOKUP.D'
,p_message_text=>'Lookup'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703951030661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704091588661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703636655661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_COLUMN_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703068015661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_CSV_ENCLOSED_BY.LOV.".D'
,p_message_text=>'"'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703116024661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_CSV_ENCLOSED_BY.LOV.''.D'
,p_message_text=>''''
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702967449661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_CSV_ENCLOSED_BY.PROMPT'
,p_message_text=>'CSV Enclosed By'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702873618661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_CSV_SEPARATOR.LOV.	.D'
,p_message_text=>'[tab]'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702757314661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_CSV_SEPARATOR.LOV.#.D'
,p_message_text=>'#'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702512589661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_CSV_SEPARATOR.LOV.,.D'
,p_message_text=>','
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702459399661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_CSV_SEPARATOR.LOV.;.D'
,p_message_text=>';'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702606443661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_CSV_SEPARATOR.LOV.|.D'
,p_message_text=>'|'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702368699661315)
,p_name=>'PE.PROPERTY.DATA_PROFILE_CSV_SEPARATOR.PROMPT'
,p_message_text=>'CSV Separator'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708732192661321)
,p_name=>'PE.PROPERTY.DATA_PROFILE_DECIMAL_CHARACTER.PROMPT'
,p_message_text=>'Decimal Character'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698350549661312)
,p_name=>'PE.PROPERTY.DATA_PROFILE_FORMAT.LOV.CSV.D'
,p_message_text=>'CSV'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698490802661312)
,p_name=>'PE.PROPERTY.DATA_PROFILE_FORMAT.LOV.JSON.D'
,p_message_text=>'JSON'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698572048661312)
,p_name=>'PE.PROPERTY.DATA_PROFILE_FORMAT.LOV.XLSX.D'
,p_message_text=>'XLSX'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698620895661312)
,p_name=>'PE.PROPERTY.DATA_PROFILE_FORMAT.LOV.XML.D'
,p_message_text=>'XML'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698205982661312)
,p_name=>'PE.PROPERTY.DATA_PROFILE_FORMAT.PROMPT'
,p_message_text=>'Format'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709232714661322)
,p_name=>'PE.PROPERTY.DATA_PROFILE_FORMAT_HIDDEN.PROMPT'
,p_message_text=>'Data Profile Format'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708800403661321)
,p_name=>'PE.PROPERTY.DATA_PROFILE_GROUP_CHARACTER.PROMPT'
,p_message_text=>'Group Character'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703494237661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_HAS_HEADER_ROW.PROMPT'
,p_message_text=>'First Line Contains Headers'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698840088661312)
,p_name=>'PE.PROPERTY.DATA_PROFILE_IS_SINGLE_ROW.PROMPT'
,p_message_text=>'Contains Single Row'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702165615661315)
,p_name=>'PE.PROPERTY.DATA_PROFILE_NUMERIC_CHARACTERS.PROMPT'
,p_message_text=>'Numeric Characters'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698774885661312)
,p_name=>'PE.PROPERTY.DATA_PROFILE_ROW_SELECTOR.PROMPT'
,p_message_text=>'Row Selector'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704295896661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_SELECTOR_TYPE.LOV.NAME.D'
,p_message_text=>'Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704452063661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_SELECTOR_TYPE.LOV.REGEXP.D'
,p_message_text=>'Regular Expression'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704317390661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_SELECTOR_TYPE.LOV.SEQ.D'
,p_message_text=>'Sequence'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242704126691661317)
,p_name=>'PE.PROPERTY.DATA_PROFILE_SELECTOR_TYPE.PROMPT'
,p_message_text=>'Selector Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698950067661312)
,p_name=>'PE.PROPERTY.DATA_PROFILE_SINGLE_ROW_SELECTOR.PROMPT'
,p_message_text=>'Single Row Selector'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703360553661316)
,p_name=>'PE.PROPERTY.DATA_PROFILE_SKIP_ROWS.PROMPT'
,p_message_text=>'Skip Rows'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(79115216376670151)
,p_name=>'PE.PROPERTY.DATA_PROFILE_USE_RAW_JSON_SELECTORS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    If enabled, &PRODUCT_NAME. will not sanitize row and column selectors when generating the SQL query for JSON parsing.',
'    All selectors will be used exactly as specified.',
'</p>'))
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(79115163356670151)
,p_name=>'PE.PROPERTY.DATA_PROFILE_USE_RAW_JSON_SELECTORS.PROMPT'
,p_message_text=>'Use Raw Selectors'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73134395754902341)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the case sensitive column name used as the source for this item value.</p>',
'<p>This column must exist in the data source specified within the Form region.',
'An error is raised at runtime, and the page is not loaded, if the column name does not exist in the referenced table.',
'Similarly, if there is no built-in fetch row process defined and there is an item with a source type of <strong>Database Column</strong>, then an error is raised, and the page is not loaded when trying to render the page.</p>'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73134227230902341)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73134117041902341)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_text=>'Select the associated Form region for this page item.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73134078364902341)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_text=>'Form Region'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516971530649068920)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388951659419781578)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the data in this calendar.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388951594769781578)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_text=>'Data Text'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245987437172481169)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_text=>'Select the data type of the underlying database column.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587733075324156354)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_text=>'BFILE'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732863992156352)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_text=>'BLOB'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732763086156352)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_text=>'CLOB'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732193350156348)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_text=>'DATE'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732682012156351)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_text=>'INTERVAL DAY TO SECOND'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732539697156350)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_text=>'INTERVAL YEAR TO MONTH'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732032991156347)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_text=>'NUMBER'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732980621156353)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_text=>'ROWID'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(99820682903889540)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_text=>'SDO_GEOMETRY'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732293684156349)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_text=>'TIMESTAMP'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732416673156350)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587732313241156349)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1587731930410156344)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_text=>'VARCHAR2'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245987377975481169)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388945255489781565)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_text=>'Select the column from the table or query that contains the dates to be placed on the calendar.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388945104106781564)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_text=>'Date Column'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388945442343781565)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_text=>'Specify if you want to show time or only date values on your calendar.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388945309507781565)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_text=>'Show Time'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380446808534584095)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_text=>'Select the format mask to apply to the date picker for this column.'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788526730751574)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_text=>'DD/MM/YYYY'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788340062751574)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_text=>'DD-MM-YYYY'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788481276751574)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_text=>'DD.MM.YYYY'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789188702751576)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_text=>'DD/MM/YYYY HH24:MI'
,p_version_scn=>37166067046352
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788938341751576)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_text=>'DD-MM-YYYY HH24:MI'
,p_version_scn=>37166067046352
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789052797751576)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_text=>'DD.MM.YYYY HH24:MI'
,p_version_scn=>37166067046352
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788845523751576)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_text=>'DD/MM/YYYY HH:MI'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788636994751574)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_text=>'DD-MM-YYYY HH:MI'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788748594751575)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_text=>'DD.MM.YYYY HH:MI'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789212917751576)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_text=>'DD-MON-RR'
,p_version_scn=>37166067046352
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789476100751577)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_text=>'DD-MON-RR HH24:MI'
,p_version_scn=>37166067046352
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789335061751576)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_text=>'DD-MON-RR HH:MI'
,p_version_scn=>37166067046352
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789502137751577)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_text=>'DD-MON-YYYY'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789739936751577)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_text=>'DD-MON-YYYY HH24:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789621611751577)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_text=>'DD-MON-YYYY HH:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789830623751577)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_text=>'MM/DD/YYYY'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790049852751578)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_text=>'MM/DD/YYYY HH24:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516789902825751578)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_text=>'MM/DD/YYYY HH:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790184820751578)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_text=>'RR-MON-DD'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790363955751579)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_text=>'RR-MON-DD HH24:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790259167751578)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_text=>'RR-MON-DD HH:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788081598751573)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_text=>'Use Application Date Format'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788147885751573)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_text=>'Use Application Format Mask'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516788206806751574)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_text=>'Use Item Format Mask'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790445150751579)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_text=>'YYYY.DD.MM'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790610885751579)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_text=>'YYYY.DD.MM HH24:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790569014751579)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_text=>'YYYY.DD.MM HH:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790766413751579)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_text=>'YYYY-MM-DD'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791126375751580)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_text=>'YYYY-MM-DD HH24:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791267013751580)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_text=>'YYYY/MM/DD HH24:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790961753751580)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_text=>'YYYY-MM-DD HH:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791074581751580)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_text=>'YYYY/MM/DD HH:MI'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516790880714751579)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_text=>'YYYY/MM/DD'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380446772591584095)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_text=>'Format Mask'
,p_version_scn=>37166067046351
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634088107500669)
,p_name=>'PE.PROPERTY.DATE_PICKER_ICON_ATTRIBUTES.PROMPT'
,p_message_text=>'Date Picker Icon Attributes'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633910446500669)
,p_name=>'PE.PROPERTY.DATE_PICKER_ICON_NAME.PROMPT'
,p_message_text=>'Date Picker Icon Name'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388953866567781584)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_text=>'Click Target to invoke a modal dialog. You can enter the target link the calendar calls when creating an event by clicking on a calendar cell outside of an existing event.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388953727269781584)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_text=>'Create Target'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123147009123211875)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify which action you want to perform. The following actions are supported:</p>',
'#NATIVE_PLUGINS#',
'<p>Depending on your application configuration, you may also have additional dynamic action plug-ins available here.',
'These are displayed as <em>&lt;My Plug-in&gt; [Plug-in]</em>.',
'The following plug-ins are installed within this application''s shared components:</p>',
'#CUSTOM_PLUGINS#'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123146902753211875)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_text=>'Action'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361612012463150265)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_text=>'Select the appropriate dynamic action event from the available list.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361611907270150265)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_text=>'Event'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121387734528375047)
,p_name=>'PE.PROPERTY.DA_EXECUTION_IMMEDIATE.HELP'
,p_message_text=>'Toggle when the selected execution type is invoked. Set to Yes for actions to be executed immediately before the timer starts. Set to No for actions to be executed after the value set in Time.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121387668888375047)
,p_name=>'PE.PROPERTY.DA_EXECUTION_IMMEDIATE.PROMPT'
,p_message_text=>'Immediate'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121387438517375047)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TIME.HELP'
,p_message_text=>'Specify the amount of time to delay the execution of actions based on the execution type. Measured in milliseconds where 1 second = 1000 milliseconds.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121387334749375047)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TIME.PROMPT'
,p_message_text=>'Time'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121387556407375047)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TIME.UNIT'
,p_message_text=>'milliseconds'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121386657368375045)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose the type of execution method for the Dynamic Action. This defines if the actions are fired immediately, debounced, or throttled.</p>',
'        <p>If a Client-side Condition is defined, it will be evaluated when the Dynamic Action and its Actions are executed, not when the event fires.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121386934853375046)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TYPE.LOV.DEBOUNCE.D'
,p_message_text=>'Debounce'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121387012132375046)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TYPE.LOV.DEBOUNCE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Actions are only executed once after a specified time at the end of a single or series of events.</p>',
'        <p>Example 1:</p>',
'        <p>Update a text field if the user has stopped typing for 2 seconds and use the values last entered.</p>',
'        <p>Example 2:</p>',
'        <p>Refresh a region once after a click and ignore all other clicks in the next 5 seconds.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121386751500375046)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TYPE.LOV.IMMEDIATE.D'
,p_message_text=>'Immediate'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121386806109375046)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TYPE.LOV.IMMEDIATE.HELP'
,p_message_text=>'Actions are executed immediately.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121387172402375046)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TYPE.LOV.THROTTLE.D'
,p_message_text=>'Throttle'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121387208045375047)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TYPE.LOV.THROTTLE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Actions are executed at timed intervals when the action is fired multiple times.</p>',
'        <p>Example 1:</p>',
'        <p>During scrolling, update the current screen position at least every 2 seconds. The action will continue to fire if the user keeps scrolling.</p>',
'        <p>Example 2:</p>',
'        <p>As a user types, update a text field with the values entered at least every 2 seconds. The action will continue to fire as the user keeps typing.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121386559810375045)
,p_name=>'PE.PROPERTY.DA_EXECUTION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1409472125498257)
,p_name=>'PE.PROPERTY.DB_CREDENTIAL_IS_INSTANCE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enable this switch to indicate that the chosen database credential is available at the instance level.</p>',
'<p>An instance level database credential must be accessible to the APEX Engine (<code>APEX_NNNNNN</code>) schema.</p>'))
,p_version_scn=>1112210310
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1409360699498257)
,p_name=>'PE.PROPERTY.DB_CREDENTIAL_IS_INSTANCE.PROMPT'
,p_message_text=>'Instance Credential'
,p_version_scn=>1112210310
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1409206758498257)
,p_name=>'PE.PROPERTY.DB_CREDENTIAL_NAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    To use the secrets stored within a database credential, enter its name here.',
'    Available credentials can be obtained from the <strong>ALL_CREDENTIALS</strong> d',
'    ictionary view. Use the <strong>DBMS_CREDENTIAL</strong> package',
'    to maintain database credentials.</p>',
'<p>',
'    <em>Using a database credential changes the behavior of HTTP requests being done and how Web Credentials work:</em></p>',
'<ul>',
'    <li>',
'        If a database credential is used, all HTTP requests will be done in the',
'        context of the application''s parsing schema, and not in the context of the',
'        APEX engine any more. That means, that PL/SQL network ACLs must be granted',
'        to the application''s parsing schema. See the documentation for the',
'        <strong>DBMS_NETWORK_ACL_ADMIN</strong> for more details.</li>',
'    <li>',
'        A database credentials is completely maintained by the database, &PRODUCT_NAME.',
'        does not have access to the stored secrets. As &PRODUCT_NAME. thus cannot enforce',
'        the <strong>Valid for URLs</strong> attribute, this attribute is disabled when a',
'        database credential is used.</li>',
'</ul>'))
,p_version_scn=>1112210310
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1409199296498257)
,p_name=>'PE.PROPERTY.DB_CREDENTIAL_NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>1112210309
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665666327661275)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Use this attribute to enter a PL/SQL block that runs at the end of page processing.',
'It can be used to free or clean up resources that were used, like VPD contexts or database links.',
'</p>',
'<p>Example 1:',
'<pre>',
'dbms_session.clear_context(''CTX_USER_QRY'');',
'</pre>',
'This call resets the application context named CTX_USER_QRY before the database session is given back to the session pool,',
'to ensure that no information will be leaked when it gets reused later on.',
'</p>',
'<p>Example 2:',
'<pre>',
'dbms_session.close_database_link(''SALES'');',
'</pre>',
'This call closes the database link SALES, which might have been opened in the "Initialization PL/SQL Code" or implicitly, just by querying data via the link.',
'Again, this frees resources and prevents resource leakage when the database session will be reused.',
'</p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599369661432282303)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_text=>'Cleanup PL/SQL Code'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665535017661275)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Use this attribute to enter a PL/SQL block that sets a context for the database session associated with the current "show page" or "accept page" request. The block you enter here is executed at a very early point during the page request, immediate'
||'ly after the <code>APP_USER</code> value is established. The value of <code>APP_USER</code> (using <code>:APP_USER</code> or <code>v(''APP_USER'')</code>) may be used within the block. Values of other items in session state may be referenced as well, b'
||'ut any such items must have been established in session state before the initiation of the current page request.',
'Consider the following example:',
'</p>',
'<pre>',
'dbms_session.set_context(''CTX_USER_QRY'',''USERPRIV'',my_package.my_function(:APP_USER));',
'</pre>',
'',
'<p>This example sets the value of <code>USERPRIV</code> in the context named <code>CTX_USER_QRY</code> to the value returned by the function <code>my_function</code> in package <code>my_package</code>. The function is passed the current value of <cod'
||'e>APP_USER</code> as an input argument. Presumably, the named context would be used in a VPD policy (created within the application''s parsing schema) to effect the generation of predicates appropriate to the authenticated user.</p>',
'',
'<p>Virtual Private Database, also know as Fine-Grained Access Control or FGAC, is an Oracle database feature that provides an application programming interface (API) that enables developers to assign security policies to database tables and views. Us'
||'ing PL/SQL, developers can create security policies with stored procedures and bind the procedures to a table or view by means of a call to an RDBMS package. Such policies are based on the content of application data stored within the database, or ba'
||'sed on context variables provided by Oracle database. In this way, VPD permits access security mechanisms to be removed from applications, and to be situated closer to particular schemas.</p>',
'',
'<p>The code entered here need not pertain to VPD/FGAC and may not be related to security at all. Any code that needs to be executed at the earliest point in a page request can be placed here. For example, the following code sets the database session '
||'time zone for every page request:</p>',
'',
'<pre>',
'BEGIN',
'   EXECUTE IMMEDIATE ''alter session set time_zone = ''''Australia/Sydney'''' '';',
'END;',
'</pre>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599369452705282303)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_text=>'Initialization PL/SQL Code'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718892316661330)
,p_name=>'PE.PROPERTY.DEBUGGING.PROMPT'
,p_message_text=>'Debugging'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116968277360909853)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.HELP'
,p_message_text=>'Specify the debug level of the Workflow Version.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116969728834909854)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.LOV.1.D'
,p_message_text=>'Error'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116970036298909854)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.LOV.1.HELP'
,p_message_text=>'Debug level for logging critical errors.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116969159227909854)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.LOV.2.D'
,p_message_text=>'Warning'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116969450506909854)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.LOV.2.HELP'
,p_message_text=>'Debug level for logging  less critical errors .'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116968570642909853)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.LOV.4.D'
,p_message_text=>'Info'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116968814753909853)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.LOV.4.HELP'
,p_message_text=>'The default debug level of the Workflow Version.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116970324340909854)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.LOV.6.D'
,p_message_text=>'Trace'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116970689147909855)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.LOV.6.HELP'
,p_message_text=>'Debug level for tracing messages with procedures and functions.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116967943700909853)
,p_name=>'PE.PROPERTY.DEBUG_LEVEL.PROMPT'
,p_message_text=>'Debug Level'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380857339984128730)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_text=>'Application Default'
,p_version_scn=>37166067046493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656092297685958067)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_text=>'Uses the setting defined in the application security attributes.'
,p_version_scn=>37166067046493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123102816607211801)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how external URL requests to a page are handled.',
'Page requests from within this application to this page, are not considered deep linking, and are not governed by this attribute''s setting.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749501435751421)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749637077751421)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_text=>'If the URL does not contain a valid session ID, &PRODUCT_NAME. starts a new session and redirects the user to the application home page, rather than to this page.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749375033751420)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749462949751420)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If this page is specified as the target page in a URL, it ultimately redirects to this page.<br>',
'If the user is not already authenticated and the page is not public, then the user is prompted to login.',
'After successfully logging into the application, the user is redirected to this page.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123102703427211801)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_text=>'Deep Linking'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632357911500668)
,p_name=>'PE.PROPERTY.DEFAULT_BREADCRUMBS_TMPL.PROMPT'
,p_message_text=>'Breadcrumbs'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631271385500667)
,p_name=>'PE.PROPERTY.DEFAULT_BREADCRUMB_TMPL.PROMPT'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631326067500667)
,p_name=>'PE.PROPERTY.DEFAULT_BUTTON_TMPL.PROMPT'
,p_message_text=>'Button'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632425804500668)
,p_name=>'PE.PROPERTY.DEFAULT_CHARTS_TMPL.PROMPT'
,p_message_text=>'Charts'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632089851500667)
,p_name=>'PE.PROPERTY.DEFAULT_CLASSIC_REPORT_TMPL.PROMPT'
,p_message_text=>'Classic Report'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631586935500667)
,p_name=>'PE.PROPERTY.DEFAULT_DEFAULT_LABEL_TMPL.PROMPT'
,p_message_text=>'Default Label'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633126560500668)
,p_name=>'PE.PROPERTY.DEFAULT_DIALOG_BUTTON_REGION_TMPL.PROMPT'
,p_message_text=>'Dialog Button Region'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633077555500668)
,p_name=>'PE.PROPERTY.DEFAULT_DIALOG_CONTENT_REGION_TMPL.PROMPT'
,p_message_text=>'Dialog Content Region'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633272344500668)
,p_name=>'PE.PROPERTY.DEFAULT_DIALOG_PAGE_TMPL.PROMPT'
,p_message_text=>'Dialog Page'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721976514661333)
,p_name=>'PE.PROPERTY.DEFAULT_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_text=>'Inline in Notification'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721851480661333)
,p_name=>'PE.PROPERTY.DEFAULT_ERROR_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_text=>'Inline with Field'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721708492661333)
,p_name=>'PE.PROPERTY.DEFAULT_ERROR_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_text=>'Inline with Field and in Notification'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721685164661333)
,p_name=>'PE.PROPERTY.DEFAULT_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_text=>'Default Display Location'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631085690500667)
,p_name=>'PE.PROPERTY.DEFAULT_ERROR_PAGE_TMPL.PROMPT'
,p_message_text=>'Error Page'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605533539500648)
,p_name=>'PE.PROPERTY.DEFAULT_ESCAPE_MODE.LOV.ATTR.D'
,p_message_text=>'HTML Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605466978500648)
,p_name=>'PE.PROPERTY.DEFAULT_ESCAPE_MODE.LOV.HTML.D'
,p_message_text=>'HTML'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605735505500648)
,p_name=>'PE.PROPERTY.DEFAULT_ESCAPE_MODE.LOV.RAW.D'
,p_message_text=>'Raw'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605685359500648)
,p_name=>'PE.PROPERTY.DEFAULT_ESCAPE_MODE.LOV.STRIPHTML.D'
,p_message_text=>'Strip HTML'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605305577500648)
,p_name=>'PE.PROPERTY.DEFAULT_ESCAPE_MODE.PROMPT'
,p_message_text=>'Default Escape Mode'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632289907500668)
,p_name=>'PE.PROPERTY.DEFAULT_FOOTER_TOOLBAR_TMPL.PROMPT'
,p_message_text=>'Footer Toolbar'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632558260500668)
,p_name=>'PE.PROPERTY.DEFAULT_FORMS_TMPL.PROMPT'
,p_message_text=>'Forms'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632106140500668)
,p_name=>'PE.PROPERTY.DEFAULT_HEADER_TOOLBAR_TMPL.PROMPT'
,p_message_text=>'Header Toolbar'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632910523500668)
,p_name=>'PE.PROPERTY.DEFAULT_INTERACTIVE_REPORTS_TMPL.PROMPT'
,p_message_text=>'Interactive Reports'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631475982500667)
,p_name=>'PE.PROPERTY.DEFAULT_LEGACY_CALENDAR_TMPL.PROMPT'
,p_message_text=>'Legacy Calendar'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632689349500668)
,p_name=>'PE.PROPERTY.DEFAULT_LISTS_TMPL.PROMPT'
,p_message_text=>'Lists'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631894424500667)
,p_name=>'PE.PROPERTY.DEFAULT_LIST_TMPL.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630962768500667)
,p_name=>'PE.PROPERTY.DEFAULT_LOGIN_PAGE_TMPL.PROMPT'
,p_message_text=>'Login Page'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630373438500666)
,p_name=>'PE.PROPERTY.DEFAULT_NAVIGATION_BAR_LIST_TMPL.PROMPT'
,p_message_text=>'Navigation Bar List'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630616934500666)
,p_name=>'PE.PROPERTY.DEFAULT_NAVIGATION_MENU_LIST_POSITION_TMPL.LOV.SIDE.D'
,p_message_text=>'Side'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630543019500666)
,p_name=>'PE.PROPERTY.DEFAULT_NAVIGATION_MENU_LIST_POSITION_TMPL.LOV.TOP.D'
,p_message_text=>'Top'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630432469500666)
,p_name=>'PE.PROPERTY.DEFAULT_NAVIGATION_MENU_LIST_POSITION_TMPL.PROMPT'
,p_message_text=>'Navigation Menu List Position'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630837035500667)
,p_name=>'PE.PROPERTY.DEFAULT_NAVIGATION_MENU_LIST_SIDE_TMPL.PROMPT'
,p_message_text=>'Navigation Menu List (Side)'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630761645500667)
,p_name=>'PE.PROPERTY.DEFAULT_NAVIGATION_MENU_LIST_TOP_TMPL.PROMPT'
,p_message_text=>'Navigation Menu List (Top)'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242774870979661482)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.COMPONENT_PROPERTY.BUILD_OPTION.NULL_TEXT'
,p_message_text=>'Same as Current Status'
,p_version_scn=>37166067046492
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123086526162211763)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_text=>'Select the default build option applied to this component when exporting. This option can be over ridden by export options.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747070807751410)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_text=>'Exclude'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644370651759373663)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_text=>'Disabled and not a part of the application.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747194054751410)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_text=>'Include'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644370715500373664)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_text=>'Enabled and part of the application.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123086416825211763)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_text=>'Default on Export'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631627606500667)
,p_name=>'PE.PROPERTY.DEFAULT_OPTION_LABEL_TMPL.PROMPT'
,p_message_text=>'Optional Label'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630253488500666)
,p_name=>'PE.PROPERTY.DEFAULT_PAGE_TMPL.PROMPT'
,p_message_text=>'Page'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631152823500667)
,p_name=>'PE.PROPERTY.DEFAULT_PRINTER_FRIENDLY_PAGE_TMPL.PROMPT'
,p_message_text=>'Printer Friendly Page'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631962298500667)
,p_name=>'PE.PROPERTY.DEFAULT_REGION_TMPL.PROMPT'
,p_message_text=>'Region'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632782288500668)
,p_name=>'PE.PROPERTY.DEFAULT_REPORTS_TMPL.PROMPT'
,p_message_text=>'Reports'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143631758272500667)
,p_name=>'PE.PROPERTY.DEFAULT_REQUIRED_LABEL_TMPL.PROMPT'
,p_message_text=>'Required Label'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1616434705673449)
,p_name=>'PE.PROPERTY.DEFAULT_SLOT_BUTTON.HELP'
,p_message_text=>'Specify the default slot in which buttons should be inserted'
,p_version_scn=>91991107
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1616309493673449)
,p_name=>'PE.PROPERTY.DEFAULT_SLOT_BUTTON.PROMPT'
,p_message_text=>'Buttons'
,p_version_scn=>100990161
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1616298789673449)
,p_name=>'PE.PROPERTY.DEFAULT_SLOT_ITEM.HELP'
,p_message_text=>'Specify the default slot in which items should be inserted'
,p_version_scn=>91991107
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1616146246673449)
,p_name=>'PE.PROPERTY.DEFAULT_SLOT_ITEM.PROMPT'
,p_message_text=>'Items'
,p_version_scn=>100990161
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1616044572673449)
,p_name=>'PE.PROPERTY.DEFAULT_SLOT_REGION.HELP'
,p_message_text=>'Specify the default slot in which regions should be inserted'
,p_version_scn=>91991107
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1615974195673449)
,p_name=>'PE.PROPERTY.DEFAULT_SLOT_REGION.PROMPT'
,p_message_text=>'Regions'
,p_version_scn=>100990155
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775695713661529)
,p_name=>'PE.PROPERTY.DEFAULT_SORT_COLUMN_NAME.COMPONENT_PROPERTY.LOV.NULL_TEXT'
,p_message_text=>'Use Order By from Query'
,p_version_scn=>37166067046529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696199822661310)
,p_name=>'PE.PROPERTY.DEFAULT_SORT_COLUMN_NAME.PROMPT'
,p_message_text=>'Default Sort'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572912328500625)
,p_name=>'PE.PROPERTY.DEFAULT_TEMPLATE_OPTIONS.PROMPT'
,p_message_text=>'Default'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245988452720481173)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_text=>'Select how the default value of this column is determined.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258248098090428)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258321324090428)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value returned from the <em>Expression</em> entered.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258473560090428)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258543528090428)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245988704978481174)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245988821050481174)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value returned from the session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245989734774481182)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_text=>'Sequence'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245989826830481182)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_text=>'<p>Set to the value returned from the <em>Sequence</em> entered. This is a "special" default type: It is executed as part of the Interactive Grid DML process and <em>not</em> during page load. Use this type for auto-generated primary key values, when'
||' <strong>Return Primary Key(s) after Insert</strong> cannot be used, for instance when working with views and INSTEAD OF triggers or with database links. The sequence name is case-insensitive; use double quotes to indicate a mixed case sequence name '
||'("mySequence").</p>'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245988945583481176)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>19621416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245989035536481176)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>19621416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245989181405481176)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_text=>'SQL Query (return multiple values)'
,p_version_scn=>19621416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245989233691481177)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_text=>'Set to multiple values returned from the <em>SQL Query</em>. The format of what is returned is determined by the current column''s Multiple Values setting. If Multiple Values is set to <em>Delimited Values</em>, the value will be a single concatenated'
||' list separated by the defined Separator. If Multiple Values is set to <em>JSON Array</em>, the value will be a JSON Array of the values. If Multiple Values is set to <em>No</em> or the column does not support multiple values, then the value is a sin'
||'gle concatenated list separated by a colon.'
,p_version_scn=>20476611
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245988552961481173)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_text=>'Static'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245988600867481173)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Set to the value entered in <em>Static</em> value.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245988381210481172)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205290829982800)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG_VARCHAR2.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205682022982801)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205570698982801)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205453805982800)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205782439982801)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205316300982800)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG_VARCHAR2.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205150027982800)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105498074276417)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG_VARCHAR2.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105758146276417)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105664707276417)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105563803276417)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105801324276417)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105380263276417)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381154394683643967)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_text=>'Enter the page or application item which holds the default value.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381154214274643967)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600282998133090635)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the Java expression that produces the value for this item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600282846386090635)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600284530394090636)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the Java function body which returns the value for this item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600284489032090636)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610393561484649)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600282687939090635)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the JavaScript expression that produces the value for this item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600282579480090635)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610595652484650)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES" : "NO" );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600284261464090636)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the JavaScript function body which returns the value for this item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600284108374090636)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610232584484648)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600282360824090634)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the PL/SQL expression that produces the value for this item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600282221418090634)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610430808484649)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600283945253090636)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the PL/SQL function body which returns the value for this item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600283856205090636)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600283136155090635)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the Python expression that produces the value for this item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600283002551090635)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600284792028090637)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the Python function body which returns the value for this item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600284650969090636)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990428397481184)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_text=>'Enter the name of the database sequence which returns the default value for this column.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990343244481184)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_text=>'Sequence'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610185465484648)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600282042552090634)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the SQL expression that produces the value for this item.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600281970746090634)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990039285481183)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>19621416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245989973473481182)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>19621416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990297852481183)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_text=>'Set to multiple values returned from the <em>SQL Query</em>. The format of what is returned is determined by the current item''s Multiple Values setting. If Multiple Values is set to <em>Delimited Values</em>, the value will be a single concatenated l'
||'ist separated by the defined Separator. If Multiple Values is set to <em>JSON Array</em>, the value will be a JSON Array of the values. If Multiple Values is set to <em>No</em> or the item does not support multiple values, then the value is a single '
||'concatenated list separated by a colon.'
,p_version_scn=>20476611
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990173734481183)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_text=>'SQL Query (return multiple values)'
,p_version_scn=>19621416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123134924063211855)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_text=>'Specify a default value for this item. The default value is used when the item''s value is not derived from session state and when the source value is null.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123134801947211855)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123134403359211854)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_text=>'Select a default value type for this item.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600257620068090272)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600257772353090272)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value returned from the <em>Expression</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600257862867090272)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600257936752090273)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73132744749902121)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73132841329902121)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value returned from the session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73133513315902122)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_text=>'Sequence'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73133686112902122)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_text=>'<p>Set to the value returned from the <em>Sequence</em> entered. This is a "special" default type: It is executed as part of the Form Region DML process and <em>not</em> during page load. Use this type for auto-generated primary key values, when <str'
||'ong>Return Primary Key(s) after Insert</strong> cannot be used, for instance, when working with views and INSTEAD OF triggers or with database links. The sequence name is case-sensitive.</p>'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73132959565902121)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>19621411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73133006080902121)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>19621411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73133130732902121)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_text=>'SQL Query (return multiple values)'
,p_version_scn=>19621411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73133225424902122)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_text=>'Set to multiple values returned from the <em>SQL Query</em>. The format of what is returned is determined by the current item''s Multiple Values setting. If Multiple Values is set to <em>Delimited Values</em>, the value will be a single concatenated l'
||'ist separated by the defined Separator. If Multiple Values is set to <em>JSON Array</em>, the value will be a JSON Array of the values. If Multiple Values is set to <em>No</em> or the item does not support multiple values, then the value is a single '
||'concatenated list separated by a colon.'
,p_version_scn=>20476609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516765041665751476)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_text=>'Static'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73132610340902120)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_text=>'Set to the value entered in <em>Static</em> value.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123134326145211854)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143632875727500668)
,p_name=>'PE.PROPERTY.DEFAULT_WIZARDS_TMPL.PROMPT'
,p_message_text=>'Wizards'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703235259661316)
,p_name=>'PE.PROPERTY.DEFAULT_XLSX_SHEET_NAME.PROMPT'
,p_message_text=>'Default XLSX Sheet Name'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957496298792522)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_text=>'<p>Specify whether end users can define a chart for this Interactive Grid.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957377978792522)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_text=>'Define Chart View'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754942847661397)
,p_name=>'PE.PROPERTY.DEINSTALL_CONFIRMATION_MESSAGE.PROMPT'
,p_message_text=>'Confirmation'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973605436481114)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select an authorization scheme to restrict who can delete rows.',
'        In order for an end user to delete rows, this authorization scheme must evaluate to TRUE for that user.',
'        If no authorization scheme is provided then any user can delete rows in this interactive grid.'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973507453481114)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_text=>'Delete'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143628514860500665)
,p_name=>'PE.PROPERTY.DEMO_VALUE.PROMPT'
,p_message_text=>'Demo Value'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616407854500657)
,p_name=>'PE.PROPERTY.DEPENDING_ON_ATTRIBUTE.PROMPT'
,p_message_text=>'Depending on Custom Attribute'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379342305101882204)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_text=>'Specify a condition which checks the value of another Facet or Filter to control whether the current Facet or Filter should be displayed.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379342697556882205)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_text=>'equal to'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379342946744882205)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_text=>'Checks if the value of the depending on <em>Facet or Filter</em> is equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379343806211882205)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_text=>'in list'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379344195436882205)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_text=>'Checks if the value of the depending on <em>Facet or Filter</em> is in the <em>List</em> specified.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379343219505882205)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_text=>'not equal to'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379343585380882205)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_text=>'Checks if the value of the depending on <em>Facet or Filter</em> is not equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379344489688882205)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_text=>'not in list'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379344762400882206)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_text=>'Checks if the value of the depending on <em>Facet or Filter</em> is not in the <em>List</em> specified.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379345667871882206)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_text=>'is not null'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379345910787882206)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_text=>'Checks if the value of the depending on <em>Facet or Filter</em> is not empty.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379345088296882206)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_text=>'is null'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379345323445882206)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_text=>'Checks if the value of the depending on <em>Facet or Filter</em> is empty.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379342025949882204)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616688518500658)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION_TYPE.LOV.EQUALS.D'
,p_message_text=>'equal to'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616870027500658)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION_TYPE.LOV.IN_LIST.D'
,p_message_text=>'in list'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617121144500658)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION_TYPE.LOV.IS_NOT_NULL.D'
,p_message_text=>'is not null'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617020472500658)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION_TYPE.LOV.IS_NULL.D'
,p_message_text=>'is null'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616725539500658)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION_TYPE.LOV.NOT_EQUALS.D'
,p_message_text=>'not equal to'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616989259500658)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION_TYPE.LOV.NOT_IN_LIST.D'
,p_message_text=>'not in list'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616566648500658)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION_TYPE.PROMPT'
,p_message_text=>'Depending on Condition Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379347162755882207)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_text=>'Enter the comma separated list of values for this condition.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379346826473882207)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379346546890882207)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_text=>'Enter the value for this condition.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379346224915882206)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617262199500658)
,p_name=>'PE.PROPERTY.DEPENDING_ON_EXPRESSION.PROMPT'
,p_message_text=>'Expression'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379341755504882204)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_text=>'Select the associated Facet which should be checked to decide if the current Facet should be displayed.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(379341472631882204)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_text=>'Facet'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584534625240747542)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_text=>'Select the associated checkbox which should be checked to decide if the current checkbox should be displayed.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584534373527747542)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_text=>'Checkbox'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617320918500658)
,p_name=>'PE.PROPERTY.DEPENDING_ON_HAS_TO_EXIST.PROMPT'
,p_message_text=>'Always Evaluate'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508611100670737)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_text=>'Select the associated Filter which should be checked to decide if the current Filter should be displayed.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508593275670737)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_text=>'Filter'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508863592670737)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_text=>'Select the associated checkbox which should be checked to decide if the current checkbox should be displayed.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508779447670737)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_text=>'Checkbox'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534296169186777862)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_text=>'$$$ DJP currently hidden'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385158973374476148)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_text=>'Derived Column'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1590875641451364499)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_text=>'Enter a description for this Interactive Report.'
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360641401493667940)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_text=>'Enter a description for the column group. This description never displays to end users.'
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123093202735211779)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_text=>'Enter a description.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123093110550211779)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_text=>'Description'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783660575751552)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/table&gt;',
'</pre>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877719493183861)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_text=>'Enter the HTML to be displayed after report rows.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877606746183861)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_text=>'After Rows'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783431446751552)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;table&gt;',
'</pre>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877331762183861)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_text=>'Enter the HTML to be displayed before report rows.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877225785183861)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_text=>'Before Rows'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245991324260481466)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_text=>'Specify whether the Detail View is enabled. Selecting <strong>On</strong> adds a View Details icon to the Search bar for interactive reports, or to the interactive grid View button, enabling users to access this view.'
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877102072183861)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_text=>'Specify whether the Detail View is enabled. Selecting <strong>On</strong> adds a View Details icon to the Search bar for interactive reports, or to the interactive grid View button, enabling users to access this view.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877007437183860)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1568686749932063585)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1568686871576063586)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the body for report rows in the Detail View.</p>',
'<p>The following substitution strings are available:',
'<ul>',
'<li><code>&&lt;COLUMN_NAME&gt;.</code> - substitution strings for column names.</li>',
'<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - substitution strings for column labels.</li>',
'<li><code>&APEX$ROW_ID.</code> - the record identifier for the row.</li>',
'<li><code>&APEX$ROW_INDEX.</code> - the record display sequence number.</li>',
'<li><code>&APEX$ROW_STATE_CLASSES.</code> - the record state such as <code>is-inserted</code> or <code>is-deleted</code>.</li>',
'</ul>',
'</p>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783520646751552)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877507498183861)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_text=>'Enter the body for report rows in the Detail View. Use <code>#COLUMN_NAME#</code> substitution strings for column names and column labels.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877424161183861)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_text=>'For Each Row'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116959410337909847)
,p_name=>'PE.PROPERTY.DIAGRAM.HELP'
,p_message_text=>'Specify the coordinates of the workflow activity or transition in the diagram builder.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116959198011909847)
,p_name=>'PE.PROPERTY.DIAGRAM.PROMPT'
,p_message_text=>'Diagram'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123093021700211778)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A subset of dialog attributes are declaratively supported: <em>height, width, and maximum width</em>.',
'To define any additional attributes for the dialog, enter the name/value pairings in a comma separated list.',
'<p>The substitution string <code>#DIALOG_ATTRIBUTES#</code> in the dialog initialization code defined at page template level, is replaced by any value(s) entered in this item.</p>',
'<p>The jQuery UI dialog widget is utilized.</p>',
'<p>For example, a dialog page could have the following attributes defined: <code>resizable:true, draggable:true</code></p>',
'<p>For further information on the attributes available, refer to the <a rel="noopener noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">jQuery UI dialog widget documentation</a>.</p>'))
,p_version_scn=>15114744
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092930198211778)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586742460500635)
,p_name=>'PE.PROPERTY.DIALOG_CANCEL_CODE.PROMPT'
,p_message_text=>'Dialog Cancel Code'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596510380819337493)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select <strong>On</strong> if this dialog is opened by another dialog, and should reuse the same dialog window.',
'For example, if this dialog is part of a multiple page dialog wizard, and you wish to reuse the dialog window for each step of the wizard.<p><p>',
'Select <strong>Off</strong> if this dialog is opened by another dialog, and should be opened in a new dialog window. For example, when this dialog is modal,',
'and you wish to open it within a parent modal dialog window.'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596510248080337488)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_text=>'Chained'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586699645500635)
,p_name=>'PE.PROPERTY.DIALOG_CLOSURE_CODE.PROMPT'
,p_message_text=>'Dialog Closure Code'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143571284820500542)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.EXAMPLES'
,p_message_text=>'<pre>ui-dialog--wizard</pre>'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(396409522783845271)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(396409422179845271)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150987522875822705)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the height of the dialog, in pixels, for example, <strong><em>500</em></strong>.',
'The substitution string <code>#DIALOG_HEIGHT#</code> in the dialog initialization code of the page template is replaced with the value entered.'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150987414139822705)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_text=>'Height'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586536228500635)
,p_name=>'PE.PROPERTY.DIALOG_INITIALIZATION_CODE.PROMPT'
,p_message_text=>'Dialog Initialization Code'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092809064211778)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum width of the dialog in pixels.',
'The substitution string <code>#DIALOG_MAX_WIDTH#</code> in the dialog initialization code of the page template is replaced with the value entered in this item.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092713683211778)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_text=>'Maximum Width'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380856989886128728)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_text=>'Theme Default'
,p_version_scn=>37166067046492
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174733119859045974)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a dialog template to define the appearance and layout of this page.</p>',
'        <p>Dialog templates are defined in the application theme.',
'        When a dialog page is created, the template is automatically set to <em>Theme Default</em> which will render the page using the default page template defined in the current theme.',
'        Making a selection here overrides the default dialog template.</p>',
'        <p>Universal Theme provides the following dialog templates:',
'          <dl>',
'            <dt>Modal Dialog</dt>',
'              <dd>Useful for most dialog use cases.</dd>',
'            <dt>Wizard Modal Dialog</dt>',
'              <dd>Provides a streamlined user interface and is well suited for modal dialog wizards, alerts, notifications, or small forms.</dd>',
'          </dl>',
'          See Also: <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a>',
'        </p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174733001820045974)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_text=>'Dialog Template'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092607619211778)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the width of the dialog, in pixels.',
'The substitution string <code>#DIALOG_WIDTH#</code> in the dialog initialization code of the page template is replaced with the value entered in this item.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092507393211778)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_text=>'Width'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380453052505584107)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_text=>'Specify whether this column can be used by the end user to sort the report.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380452913704584107)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_text=>'Sortable'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388946974986781568)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_text=>'Select the single column to display in the calendar cells.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388946886983781568)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_text=>'Display Column'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695913307661310)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN_NAME.PROMPT'
,p_message_text=>'Display'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111929345211817)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An item may have a session state value which does not occur in the given list of values definition.',
'Select whether this list of values displays this extra session state value.',
'If you choose to not display this extra session state value and there is no matching value in the list of values definition, the first value in the list of values is the selected and displayed value.'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111803782211817)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_text=>'Display Extra Values'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123112117344211818)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_text=>'Specify whether the list of values used for this item displays a NULL value at the top of the list.'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123112002732211818)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_text=>'Display Null Value'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596948438934296957)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the display sequence for this action.',
'This is used to evaluate the display condition and render in the order defined.'))
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245991771972481468)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the display sequence for this column. The sequence setting determines where this column is displayed in relation to other columns within the region.</p>',
'<p>Note: If two columns, within the same region, have the same sequence value then they may be displayed in a different order when the application is exported and imported into another environment, such as a test or production environment.',
'To ensure consistency, Oracle recommends you specify unique sequence numbers for every item, or at least for those within the same region.</p>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976511701250630)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_ACTION.HELP'
,p_message_text=>'Enter the display sequence for this action. This is used to evaluate the display condition and render in the order defined.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115977016823250632)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_ACTION_MENU_ENTRY.HELP'
,p_message_text=>'Enter the display sequence for this menu entry. This is used to evaluate the display condition and render in the order defined.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360641329435667940)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_text=>'Enter the display sequence for this column group. The sequence determines the order in which the column groups display in the detail view.'
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567457297584315683)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the display sequence for this layer. The sequence setting determines the order in which map layers are displayed on top of each other. Layers with higher numbers are displayed on top of layers with lower numbers.</p>',
'<p>Note: If two map layers have the same sequence value then they may be displayed in a different order when the application is exported and imported into another environment, such as a test or production environment.',
'To ensure consistency, Oracle recommends you specify unique sequence numbers for every layer, or at least for those within the same map region.</p>'))
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975908491250627)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.REGION_ACTION.HELP'
,p_message_text=>'Enter the display sequence for this action. This is used to evaluate the display condition and render in the order defined.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976475666250629)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.REGION_ACTION_MENU_ENTRY.HELP'
,p_message_text=>'Enter the display sequence for this menu entry. This is used to evaluate the display condition and render in the order defined.'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115977166459250665)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.REGION_TMPL_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the display sequence for this column. The sequence setting determines where this column is displayed in relation to other columns within the region.</p>',
'<p>Note: If two columns, within the same region, have the same sequence value then they may be displayed in a different order when the application is exported and imported into another environment, such as a test or production environment.',
'To ensure consistency, Oracle recommends you specify unique sequence numbers for every item, or at least for those within the same region.</p>'))
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311787918300803)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.SEARCH_REGION_SOURCES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the display sequence for this search configuration. The display sequence determines the order in which search configurations are searched and results are ordered.</p>',
'<p>Note: If two search configurations have the same sequence value then results might be displayed in a different order when the application is exported and imported into another environment, such as a test or production environment.',
'To ensure consistency, Oracle recommends you specify unique sequence numbers for every search configuration, or at least for those within the same search region.</p>'))
,p_version_scn=>37166067046534
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123150731678211881)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the display sequence for this item. The sequence and other layout settings determine where this item displays in relation to other items within the region.</p>',
'<p>Note: If two items, within the same region, have the same sequence value then they display in a different order when the application is exported and imported into another environment, such as a test or production environment. To ensure consistency'
||', Oracle recommends you specify unique sequence numbers for every item, or at least for those within the same region.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123150608930211881)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_text=>'Sequence'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697564413661311)
,p_name=>'PE.PROPERTY.DISPLAY_VALUE.PROMPT'
,p_message_text=>'Display'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690306333661304)
,p_name=>'PE.PROPERTY.DOCUMENT_DIRECTION.LOV.N.D'
,p_message_text=>'Left-To-Right'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690499425661305)
,p_name=>'PE.PROPERTY.DOCUMENT_DIRECTION.LOV.Y.D'
,p_message_text=>'Right-To-Left'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690226222661304)
,p_name=>'PE.PROPERTY.DOCUMENT_DIRECTION.PROMPT'
,p_message_text=>'Document Direction'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29633884935376703)
,p_name=>'PE.PROPERTY.DOM_STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the static ID for the button. If defined, the static ID is used as the ID for the button. The static ID can be useful when developing custom JavaScript behavior for the button. If the static ID is not defined, the button generates an internal I'
||'D.',
'<p>Note: The template must include the <code>#BUTTON_ID#</code> substitution string, in order for the button to utilize the static ID entered.</p>'))
,p_version_scn=>15114774
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29634131680376731)
,p_name=>'PE.PROPERTY.DOM_STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>'Enter the static ID for the column. The static ID can be useful when developing custom JavaScript behavior, or custom style for the column item. If the static ID is not defined, an internal ID is used for the column item ID.'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29634023960376724)
,p_name=>'PE.PROPERTY.DOM_STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_text=>'Enter the static ID for the column. If defined, the static ID is used as the ID for the corresponding table header (TH) cell, and as the HEADERS value for corresponding table data (TD) cells. The static ID can be useful when developing custom JavaScr'
||'ipt behavior, or custom style for the column. If the static ID is not defined, the table generates an internal ID for these attribute values.'
,p_version_scn=>15114778
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29633976851376707)
,p_name=>'PE.PROPERTY.DOM_STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the static ID for this region. If defined, this is used as the ID for the region, using the substitution string <code>#REGION_STATIC_ID#</code>, which can be useful if developing custom JavaScript behavior for the region. If this is not defi'
||'ned, the region generates an internal ID.</p>',
'<p>Note: The template must include the <code>#REGION_STATIC_ID#</code> substitution string, in order for the region to utilize the static ID entered.</p>'))
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29633765580376524)
,p_name=>'PE.PROPERTY.DOM_STATIC_ID.HELP'
,p_message_text=>'Enter a static ID to uniquely identify this component. This ID will be placed in the DOM and can be used for API calls or custom JavaScript or CSS.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29633666601376523)
,p_name=>'PE.PROPERTY.DOM_STATIC_ID.PROMPT'
,p_message_text=>'Static ID'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(783113655970666169)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an authorization scheme to restrict who can download.',
'        To enable an end user to download, this authorization scheme must evaluate to TRUE for that user.</p>',
'        <p>Note - If no authorization scheme is provided then any user may download.</p>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(783113542628666162)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_text=>'Authorization'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380765299434410090)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_text=>'Specify a name for the CSV download file. If no name is specified, the region name is used followed by the extension .csv.'
,p_version_scn=>37166067046536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380976889582206970)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_text=>'Specify a name for the CSV download file. If no name is specified, the region name is used followed by the extension .csv.'
,p_version_scn=>37166067046537
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380756437575409963)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_text=>'Enter the filename for the document when downloaded. Do not specify a file extension. The extension is added automatically. If you leave this attribute blank, the region name is used as the file name.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380756368539409963)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_text=>'Filename'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360869923288183855)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_text=>'<p>Check which download formats users can utilize to download the currently displayed columns.</p>'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516780665638751540)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_text=>'CSV'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516780742141751540)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_text=>'HTML'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516781054841751541)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_text=>'PDF'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548683744210181467)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_text=>'Excel'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360869809963183855)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_text=>'Formats'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380762336057410008)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_text=>'Enter the text for the link to invoke the CSV download.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380762213287410008)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_text=>'Link Text'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380733761241495748)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_text=>'Enter the text to use for the download link on the page. End users use this link to download the BLOB content.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380733697995495748)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_text=>'Download Text'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388954245859781587)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select an authorization scheme to limit who has rights to update existing calendar events using drag and drop.',
'If specified, this authorization scheme must evaluate to TRUE in order for the drag and drop to be processed.'))
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388954138966781584)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516846303637751745)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Custom process</dt>',
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388954056464781584)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_text=>'Define the process to be executed when a Calendar entry is dragged and dropped.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388953983919781584)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_text=>'Process'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130211070803982821)
,p_name=>'PE.PROPERTY.DUE_ON_EXPRESSION_LANG_CUSTOM.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130211495293982821)
,p_name=>'PE.PROPERTY.DUE_ON_EXPRESSION_LANG_CUSTOM.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130211378119982821)
,p_name=>'PE.PROPERTY.DUE_ON_EXPRESSION_LANG_CUSTOM.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130211255732982821)
,p_name=>'PE.PROPERTY.DUE_ON_EXPRESSION_LANG_CUSTOM.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130211598976982821)
,p_name=>'PE.PROPERTY.DUE_ON_EXPRESSION_LANG_CUSTOM.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130211159278982821)
,p_name=>'PE.PROPERTY.DUE_ON_EXPRESSION_LANG_CUSTOM.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210907611982821)
,p_name=>'PE.PROPERTY.DUE_ON_EXPRESSION_LANG_CUSTOM.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213035412982822)
,p_name=>'PE.PROPERTY.DUE_ON_FUNC_BODY_LANG_CUSTOM.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213363206982822)
,p_name=>'PE.PROPERTY.DUE_ON_FUNC_BODY_LANG_CUSTOM.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213231718982822)
,p_name=>'PE.PROPERTY.DUE_ON_FUNC_BODY_LANG_CUSTOM.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213154011982822)
,p_name=>'PE.PROPERTY.DUE_ON_FUNC_BODY_LANG_CUSTOM.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213445442982822)
,p_name=>'PE.PROPERTY.DUE_ON_FUNC_BODY_LANG_CUSTOM.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130212936216982822)
,p_name=>'PE.PROPERTY.DUE_ON_FUNC_BODY_LANG_CUSTOM.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918348877674990)
,p_name=>'PE.PROPERTY.DUE_ON_INTERVAL_VALUE.HELP'
,p_message_text=>'Enter the ISO or SQL interval used as the source for this due on value.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918250438674990)
,p_name=>'PE.PROPERTY.DUE_ON_INTERVAL_VALUE.PROMPT'
,p_message_text=>'Interval'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130212618743982822)
,p_name=>'PE.PROPERTY.DUE_ON_JAVA_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter a Java expression that produces a value used to populate the due on item.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130212510038982822)
,p_name=>'PE.PROPERTY.DUE_ON_JAVA_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214021435982823)
,p_name=>'PE.PROPERTY.DUE_ON_JAVA_FUNC_BODY_CUSTOM.HELP'
,p_message_text=>'Enter a Java function body that returns a value used to populate the due on item.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213979967982822)
,p_name=>'PE.PROPERTY.DUE_ON_JAVA_FUNC_BODY_CUSTOM.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617876799484688)
,p_name=>'PE.PROPERTY.DUE_ON_JS_EXPRESSION_CUSTOM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130212386167982821)
,p_name=>'PE.PROPERTY.DUE_ON_JS_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter a JavaScript expression that produces a value used to populate the due on item.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130212211963982821)
,p_name=>'PE.PROPERTY.DUE_ON_JS_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213836598982822)
,p_name=>'PE.PROPERTY.DUE_ON_JS_FUNC_BODY_CUSTOM.HELP'
,p_message_text=>'Enter a JavaScript function body that returns a value used to populate the due on item.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213780106982822)
,p_name=>'PE.PROPERTY.DUE_ON_JS_FUNC_BODY_CUSTOM.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617755112484688)
,p_name=>'PE.PROPERTY.DUE_ON_PLSQL_EXPRESSION_CUSTOM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130212004621982821)
,p_name=>'PE.PROPERTY.DUE_ON_PLSQL_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter a PL/SQL expression that produces a value used to populate the due on item.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130211951010982821)
,p_name=>'PE.PROPERTY.DUE_ON_PLSQL_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213612587982822)
,p_name=>'PE.PROPERTY.DUE_ON_PLSQL_FUNC_BODY_CUSTOM.HELP'
,p_message_text=>'Enter a PL/SQL function body that returns a value used to populate the due on item.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130213547508982822)
,p_name=>'PE.PROPERTY.DUE_ON_PLSQL_FUNC_BODY_CUSTOM.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130212840606982822)
,p_name=>'PE.PROPERTY.DUE_ON_PYTHON_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter a Python expression that produces a value used to populate the due on item.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130212739735982822)
,p_name=>'PE.PROPERTY.DUE_ON_PYTHON_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214214478982823)
,p_name=>'PE.PROPERTY.DUE_ON_PYTHON_FUNC_BODY_CUSTOM.HELP'
,p_message_text=>'Enter a Python function body that returns a value used to populate the due on item.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214162842982823)
,p_name=>'PE.PROPERTY.DUE_ON_PYTHON_FUNC_BODY_CUSTOM.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918762764674991)
,p_name=>'PE.PROPERTY.DUE_ON_QUERY_VALUE.HELP'
,p_message_text=>'Enter the SQL Query used as the source for this due on value. If more than one row is returned then the value of the first row is used.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918662374674991)
,p_name=>'PE.PROPERTY.DUE_ON_QUERY_VALUE.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918569080674990)
,p_name=>'PE.PROPERTY.DUE_ON_SCHEDULER_VALUE.HELP'
,p_message_text=>'Enter the Scheduler Calendar Expression used as the source for this due on value.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918407435674990)
,p_name=>'PE.PROPERTY.DUE_ON_SCHEDULER_VALUE.PROMPT'
,p_message_text=>'Scheduler Expression'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617687604484688)
,p_name=>'PE.PROPERTY.DUE_ON_SQL_EXPRESSION_CUSTOM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130211732837982821)
,p_name=>'PE.PROPERTY.DUE_ON_SQL_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter a SQL expression that produces a value used to populate the due on item.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130211627782982821)
,p_name=>'PE.PROPERTY.DUE_ON_SQL_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83922597925675113)
,p_name=>'PE.PROPERTY.DUE_ON_TYPE.COMPONENT_PROPERTY.TASK_DEF.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046534
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117340743222910319)
,p_name=>'PE.PROPERTY.DUE_ON_TYPE.COMPONENT_PROPERTY.WORKFLOW_ACTIVITY.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83917655894674990)
,p_name=>'PE.PROPERTY.DUE_ON_TYPE.HELP'
,p_message_text=>'Select how the Due On Type is populated.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83917973278674990)
,p_name=>'PE.PROPERTY.DUE_ON_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918003016674990)
,p_name=>'PE.PROPERTY.DUE_ON_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83917725356674990)
,p_name=>'PE.PROPERTY.DUE_ON_TYPE.LOV.INTERVAL.D'
,p_message_text=>'Interval'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918105844674990)
,p_name=>'PE.PROPERTY.DUE_ON_TYPE.LOV.SCHEDULER_EXPRESSION.D'
,p_message_text=>'Scheduler Expression'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83917871700674990)
,p_name=>'PE.PROPERTY.DUE_ON_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83917506297674990)
,p_name=>'PE.PROPERTY.DUE_ON_TYPE.PROMPT'
,p_message_text=>'Due On Type'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990618586481185)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_text=>'Specify whether the column should be defaulted to the existing column value when duplicating the record.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990543356481184)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_text=>'Duplicate Copies Existing Value'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123686304536072273)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Check which data manipulation language (DML) operations are supported. This process will perform DML operations based on the <strong>Database Action</strong> attribute of the button to submit the page. If that attribute is not set, the operation w'
||'ill be determined by the button Request value, which is set based on the Button Name, as follows:</p>',
'<ul>',
'<li><strong>Add Row</strong> is triggered by Request Values: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN</li>',
'<li><strong>Update Row</strong> is triggered by Request Values: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%</li>',
'<li><strong>Delete Row</strong> is triggered by Request Values: DELETE, REMOVE, DELETE ROW, DROP</li>',
'</ul>'))
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972540801481110)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_text=>'Check which data manipulation operations are allowed on this interactive grid.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972832360481111)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_text=>'Delete Row'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972627152481111)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_text=>'Add Row'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972704048481111)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_text=>'Update Row'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972498525481110)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_text=>'Allowed Operations'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973005257481112)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a column where the column value indicates if the row can be updated and/or deleted. The allowable values are:',
'        <dl>',
'          <dt>U</dt>',
'            <dd>Row can be updated</dd>',
'          <dt>D</dt>',
'            <dd>Row can be deleted</dd>',
'          <dt>UD</dt>',
'            <dd>Row can be updated or deleted</dd>',
'        </dl>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972949821481112)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_text=>'Allowed Row Operations Column'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123127501122211843)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_text=>'Select the alignment of the item within the HTML table cell that surrounds it.'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762373101751466)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_text=>'Center bottom'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762468423751466)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_text=>'Center center'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762568238751466)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_text=>'Center top'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762242342751466)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_text=>'Center'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762798394751466)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_text=>'Left bottom'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762861422751466)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_text=>'Left center'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762951791751467)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_text=>'Left top'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762623079751466)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_text=>'Left'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516763144106751468)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_text=>'Right bottom'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516763201521751468)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_text=>'Right center'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516763336522751468)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_text=>'Right top'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516763001991751468)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_text=>'Right'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123113402356211820)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_text=>'Alignment'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123129326394211846)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_text=>'Enter the height (approximate number of rows) for textareas, shuttles, multi select lists, and any plug-in Item types that support the Has Height Attribute attribute.'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123129203191211846)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_text=>'Height'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(399204133150537799)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_text=>'lines'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123129113678211845)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_text=>'Enter the maximum number of characters users can type into this item.'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123129006954211845)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_text=>'Maximum Length'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(399204234986543174)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_text=>'characters'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123130117714211847)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_text=>'Enter additional space-delimited attributes for the HTML table cell used to display each individual option in a radio group or set of check boxes.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123130011447211847)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_text=>'Option HTML Attributes'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123130517262211848)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter additional attributes displayed after the HTML table cell that displays each individual option in a radio group or set of check boxes.',
'You can include HTML, JavaScript, and shortcuts.</p>',
'<p>You can reference the following substitution strings:</p>',
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
'  <dd>Obtains the name of the HTML form element that this page item is associated with.</dd>',
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Obtains the name of the current page item.</dd>',
'</dl>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123130416403211848)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_text=>'Post Text '
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123130314830211847)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter additional attributes displayed before the HTML table cell that displays each individual option in a radio group or set of check boxes.',
'You can include HTML, JavaScript, and shortcuts.</p>',
'<p>You can reference the following substitution strings:</p>',
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
'  <dd>Obtains the name of the HTML form element that this page item is associated with.</dd>',
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
'  <dd>Obtains the name of the current page item.</dd>',
'</dl>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123130212162211847)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_text=>'Pre Text'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602380800784528)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.COMPONENT_PROPERTY.IG_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Placeholder text serves as a helpful guide within input fields. When implemented thoughtfully, it aids users in understanding the expected input without overshadowing accessibility or creating confusion.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Supplemental Information:</strong> Use placeholders to offer additional guidance, not as replacements for labels.</li>',
'<li><strong>Clear and Concise:</strong> Keep placeholder text brief yet informative.</li>',
'</ul>'))
,p_version_scn=>36587307
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600756833784512)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.COMPONENT_PROPERTY.PAGE_ITEM.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Placeholder text serves as a helpful guide within input fields. When implemented thoughtfully, it aids users in understanding the expected input without overshadowing accessibility or creating confusion.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Supplemental Information:</strong> Use placeholders to offer additional guidance, not as replacements for labels.</li>',
'<li><strong>Clear and Concise:</strong> Keep placeholder text brief yet informative.</li>',
'</ul>'))
,p_version_scn=>36587282
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123129523378211846)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter hint text displayed in this item when no value for that item is entered. Once any text is entered into the item, the hint is removed.</p>',
'<p>This placeholder attribute specifies a short hint that can be used to describe the expected value of a page item.',
'Such hints are useful for providing a sample value, or an example of the expected format, or instructions such as: Search on title, description, and tag.',
'For accessibility reasons, this attribute should not be used as an alternative to a well defined, meaningful label.</p>',
'<p><strong>Attention:</strong> This is a HTML5 feature and only works in modern browsers! Older browsers do not display the text entered into this attribute.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123129426225211846)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_text=>'Value Placeholder'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123128923184211845)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_text=>'Enter the width of the form element to be used to display this item.'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123128821484211845)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_text=>'Width'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(399204066390537796)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_text=>'characters'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516782072532751546)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360874012935183858)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a valid email address to use as the <em>From</em> address when sending email from this report. Emails are sent from this report for Downloads of type Email and for Subscriptions.</p>',
'<p>The value can be a literal string containing a valid email address or a static substitution reference defined in the application using substitution syntax.',
'Using a page or application item substitution is NOT recommended because it only works in email download and causes any subscription emails to fail since these items can not be accessed outside of a valid session.',
'Subscriptions are sent directly from the &PRODUCT_NAME. engine and not from a user session.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873929981183858)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_text=>'Email From Address'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673698054661288)
,p_name=>'PE.PROPERTY.EMAIL_HTML_BODY.PROMPT'
,p_message_text=>'Body'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673742387661288)
,p_name=>'PE.PROPERTY.EMAIL_HTML_FOOTER.PROMPT'
,p_message_text=>'Footer'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673582774661288)
,p_name=>'PE.PROPERTY.EMAIL_HTML_HEADER.PROMPT'
,p_message_text=>'Header'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673813378661288)
,p_name=>'PE.PROPERTY.EMAIL_HTML_TEMPLATE.PROMPT'
,p_message_text=>'HTML Template'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673981311661288)
,p_name=>'PE.PROPERTY.EMAIL_PLAIN_BODY.PROMPT'
,p_message_text=>'Content'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673400000661288)
,p_name=>'PE.PROPERTY.EMAIL_SUBJECT.PROMPT'
,p_message_text=>'Email Subject'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578525358340720)
,p_name=>'PE.PROPERTY.EMAIL_TEMPLATE_ID.HELP'
,p_message_text=>'Identifies the email template.'
,p_version_scn=>49870263
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578480508340720)
,p_name=>'PE.PROPERTY.EMAIL_TEMPLATE_ID.PROMPT'
,p_message_text=>'Email Template'
,p_version_scn=>49870262
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179853621302688495)
,p_name=>'PE.PROPERTY.EMAIL_TEMPLATE_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this email template on an existing email template in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179853530703688495)
,p_name=>'PE.PROPERTY.EMAIL_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728676681661339)
,p_name=>'PE.PROPERTY.EMBED_IN_FRAMES.LOV.A.D'
,p_message_text=>'Allow'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728446502661339)
,p_name=>'PE.PROPERTY.EMBED_IN_FRAMES.LOV.D.D'
,p_message_text=>'Deny'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728509293661339)
,p_name=>'PE.PROPERTY.EMBED_IN_FRAMES.LOV.S.D'
,p_message_text=>'Allow from same origin'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728307509661339)
,p_name=>'PE.PROPERTY.EMBED_IN_FRAMES.PROMPT'
,p_message_text=>'Embed in Frames'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256958008863792523)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can use this column in control breaks, and aggregates.</p>',
'        <p>Note - Allowing these operations can lead to performance issues, especially on large data sets or where appropriate column indexes are not available.</p>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957952974792523)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_text=>'Control Break/Aggregate'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977565148481127)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_text=>'Specify whether end users can download the report to one of the download formats specified.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977443604481127)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_text=>'Download'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245982217034481150)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_text=>'Specify whether end users can filter this column.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245982110586481150)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957227912792522)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can utilize flashback queries for this Interactive Grid.</p>',
'<p>Flashback queries utilize the Oracle Flashback Technology and Database Point-in-Time Recovery to view data as it existed at a previous point in time. Users can only query this data, but can not rewind any data changes. How far back in time they ca'
||'n successfully perform a flashback query is determined by when the redo log files were last switched within the Oracle database, as this technology utilizes the RMAN backup.'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957160624792522)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_text=>'Flashback'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957821424792523)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_text=>'Specify whether end users can hide this column.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957712414792523)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_text=>'Hide'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245978419505481130)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can send an email, with the report download included as an attachment.</p>',
'<p>Email is only available to authenticated users, and requires the SMTP to be configured within &PRODUCT_NAME. Administration Services application by an Instance Administrator.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245978372315481130)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_text=>'Send as Email'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126954379135510966)
,p_name=>'PE.PROPERTY.ENABLE_META_TAGS.HELP'
,p_message_text=>'Select if meta tags can be added on this public page.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126954238579510966)
,p_name=>'PE.PROPERTY.ENABLE_META_TAGS.PROMPT'
,p_message_text=>'Enable Meta Tags'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489466459508840283)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_text=>'Specify whether to enable report printing. Selecting <strong>On</strong> enables users to download a report in a variety of formats, including PDF, Microsoft Word, Microsoft Excel and HTML.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489466382965840283)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245976918069481125)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can save their current report definition as a <em>Public</em> report.</p>',
'        <p>Public reports are displayed in a select list of available reports in the Toolbar, and are displayed to everyone.<p>',
'        <p>Note - This option is only available to authenticated users, and is further restricted if you also populate the <strong>Save Public Report Authorization</strong>.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245976827015481125)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_text=>'Save Public Report'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245988247364481172)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can use this column in sorting.</p>',
'        <p>Note - Allowing a sort operation can lead to performance issues, especially on large data sets or where appropriate column indexes are not available.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245988100749481172)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_text=>'Sort'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977388646481126)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_text=>'Specify whether end users can define subscription settings for this report.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977232048481126)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_text=>'Subscription'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123140819579211866)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to encrypt this item when stored in session state.',
'If the contents of an item contain sensitive data, then you should encrypt the value when it is stored in the &PRODUCT_NAME. session state management tables.',
'Otherwise, anyone with rights to read the &PRODUCT_NAME. meta data tables could potentially write a query to extract this sensitive data.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123140704241211866)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_text=>'Store value encrypted in session state'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669298412661284)
,p_name=>'PE.PROPERTY.ENDPOINT_URL.PROMPT'
,p_message_text=>'URL'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388949582581781575)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the last day of the week displayed on the weekly calendar.',
'You can use this attribute in conjunction with <strong>Start Day</strong> to restrict the days of the week displayed, or select the day before the <strong>Start Day</strong> value to show all seven days.'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844589044751739)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_text=>'Sunday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844611601751739)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_text=>'Monday'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844715777751740)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_text=>'Tuesday'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844832213751740)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_text=>'Wednesday'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844939993751740)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_text=>'Thursday'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845036993751740)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_text=>'Friday'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845172690751740)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_text=>'Saturday'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388949472175781573)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_text=>'End Day'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388951120531781577)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_text=>'Enter the end hour to focus the display of the weekly and daily calendar.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388951036959781577)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_text=>'End Hour'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972431500250228)
,p_name=>'PE.PROPERTY.ENTITIES_PER_PAGE.HELP'
,p_message_text=>'Enter the number of entities to display per page.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972380585250228)
,p_name=>'PE.PROPERTY.ENTITIES_PER_PAGE.PROMPT'
,p_message_text=>'Entities per Page'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971619353250227)
,p_name=>'PE.PROPERTY.ENTITY_TITLE_PLURAL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Define a custom title for the entity displayed by the region. Note: If nothing is defined, the generic term "rows" will be used.</p>',
'<p>The singular and plural titles are used to show more descriptive messages to end users. Instead of a generic "No rows found" a more engaging "No customers found" message is displayed.</p>',
''))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971550083250227)
,p_name=>'PE.PROPERTY.ENTITY_TITLE_PLURAL.PROMPT'
,p_message_text=>'Plural'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971401804250227)
,p_name=>'PE.PROPERTY.ENTITY_TITLE_SINGULAR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Define a custom title for the entity displayed by the region. Note: If nothing is defined, the generic term "row" will be used.</p>',
'<p>The singular and plural titles are used to show more descriptive messages to end users. Instead of a generic "No rows found" a more engaging "No customers found" message is displayed.</p>',
''))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971313684250227)
,p_name=>'PE.PROPERTY.ENTITY_TITLE_SINGULAR.PROMPT'
,p_message_text=>'Singular'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388953219406781582)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_text=>'Click Target to invoke a modal dialog. You can enter the target link the calendar calls to view the details of an existing event.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388953137076781582)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_text=>'Event Target'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711207584661323)
,p_name=>'PE.PROPERTY.ERROR_COLLECTION.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123089413787211773)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL function called when an error occurs within the application.',
'You can use this function to act on various error codes including those emanating from the Oracle database, and log such errors in a custom table you define if necessary.',
'The function can include logic to modify the error message and display location, transforming Oracle database errors into user friendly messages.',
'For example, you can capture a unique key violation on <code>DEMO_CUSTOMERS</code> and replace the <code>ORA-00001</code> message with this text: Customer Name must be unique.',
'Installing the <strong>Poll</strong> Starter App, from the Gallery, creates the <code>EBA_QPOLL_FW</code> package, which includes the <code>apex_error_handling</code> function.',
'This error handling function includes extensive comments to make it easy for you to utilize as the basis for defining your own function.</p>',
'<p>The function name entered can reference a package function or stand alone function in the database. For example:',
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
'<p>When referencing a database PL/SQL package or stand alone function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
'<p>If an error handling function is specified on a page then it is utilized, instead of this application level setting, for that page.</p>',
'<p>Error Handling Functions must implement the following interface:',
'<pre>',
'function &lt;name of function> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
'<p>See the API Reference manual for a description of the package <code>apex_error</code>.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123108200898211812)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_text=>'Error Handling Function'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710974412661323)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_TYPE.LOV.ABORT.D'
,p_message_text=>'Stop'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711118405661323)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_TYPE.LOV.ERROR_LOG.D'
,p_message_text=>'Log into Error Log'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710838621661323)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_TYPE.LOV.IGNORE.D'
,p_message_text=>'Ignore'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711017625661323)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_TYPE.LOV.LOG_ROWS.D'
,p_message_text=>'Log Error into Collection'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710727160661323)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_TYPE.PROMPT'
,p_message_text=>'When on Error'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711396687661323)
,p_name=>'PE.PROPERTY.ERROR_LOGGING_TABLE.PROMPT'
,p_message_text=>'Table Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123170209740211912)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an error message that displays if this computation fails.',
'    Use <code>#SQLERRM#</code> as a substitution string for the SQL error message resulting from a failed computation.</p>',
'    <p>Computations are designed to always succeed, and only fail due to unanticipated errors.',
'    It is not advisable to implement a computation that regularly fails and acts as a pseudo-validation utilizing this error message.'))
,p_version_scn=>37166067046493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361254727335487254)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the error message for this process.',
'This message displays if an unhandled exception is raised. After any error processing stops, a rollback is issued and an error message displays.</p>',
'<p>Note: the SQL error message sqlerrm displays by default if <strong>On Error Page</strong> is defined as the error display location, there is no need to add <code>#SQLERRM#</code> to your error text.</p>',
'<p>Error messages can include the following substitution strings:</p>',
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
'  <dd>Text of error message without the error number.</dd>',
'  <dt><code>#SQLERRM#</code></dt>',
'  <dd>Complete error message.</dd>',
'</dl>'))
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601393356784520)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.VALIDATION.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Accessible error suggestions foster a more inclusive user experience, aiding users of varying abilities in rectifying input errors efficiently.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Clear and Descriptive:</strong> Error messages should clearly describe the problem or issue encountered by the user in a concise and understandable manner. Avoid using technical jargon or ambiguous language that may confuse users.</li>',
'<li><strong>Provide Solutions:</strong> Offer clear instructions or suggestions on how users can resolve the error.</li>',
'<li><strong>Error Identification:</strong> Clearly identify the field or input element that triggered the error. Provide sufficient context to help users understand which part of the form or application needs attention.</li>',
'<li><strong>Consistent:</strong> Maintain consistency in the format and style of error messages throughout the application or website. Consistent error messaging helps users understand and navigate the interface more effectively.</li>',
'</ol>',
'<strong>Examples:</strong>',
'<ul>',
'<li>Error: "Invalid email address. Please enter a valid email format (e.g., example@example.com)."</li>',
'<li>Error: "Insufficient funds. Please add funds to your account to complete the transaction."</li>',
'</ul>'))
,p_version_scn=>36587292
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1829519280056528647)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_text=>'#LABEL# must have some value.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123087310666211764)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text to be displayed in the event that the validation does not pass.</p>',
'<p>You can use <code>#LABEL#</code> as placeholder for the label of the associated page item or <code>#COLUMN_HEADER#</code> for the heading of the associated editable region column. The placeholders are not supported if error display location is set'
||' to On Error Page.</p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123087224832211764)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_text=>'Error Message'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156036428424350908)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select where the error message displays for this validation.',
'Validation error messages display on a separate error page, or inline with the existing page.',
'Inline error messages display underneath the <em>Associated Item</em> label and/or in a Notification area, defined as part of the page template.'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773572913751513)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_text=>'Inline in Notification'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773404922751512)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_text=>'Inline with Field'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773315946751512)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_text=>'Inline with Field and in Notification'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773609775751513)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_text=>'On Error Page'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156036314805350908)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_text=>'Display Location'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590523008500638)
,p_name=>'PE.PROPERTY.ERROR_PAGE_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667456812661278)
,p_name=>'PE.PROPERTY.ERROR_STOP_EXECUTION_ON_ERROR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether processing of all other pending actions is stopped when an error occurs while executing the current action.</p>',
'<p>Note: The order of execution of specific actions is determined by the sequence specified for each action. To ensure that actions are run in the same order, Oracle recommends that the sequence numbers be unique.</p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667367094661278)
,p_name=>'PE.PROPERTY.ERROR_STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_text=>'Stop Execution On Error'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578109659500629)
,p_name=>'PE.PROPERTY.ERROR_TEMPLATE.PROMPT'
,p_message_text=>'Error Template'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123141013245211866)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'To prevent Cross-Site Scripting (XSS) attacks, always set this attribute to <strong>On</strong>.',
'If you need to render HTML tags stored in the page item or in the entries of a list of values, you can set this flag to <strong>Off</strong>.',
'In such cases, you should take additional precautions to ensure any user input to such fields are properly escaped when entered and before saving.'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123140928108211866)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_text=>'Escape special characters'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123087524092211765)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Authorization schemes are evaluated on first use in a session.',
'Select the appropriate evaluation point to determine whether subsequent use of the given authorization obtains the result from memory or re-evaluates the authorization scheme.</p>',
'#LOV_VALUES#',
'<p>The default value <em>Once per session</em> is the most efficient.',
'You should choose another value if the authorization check depends on changing session state or other factors that are not consistent over an entire session.',
'The options <em>Once per component</em> and <em>Always (No Caching)</em> provide additional parameters that can be defined for use by the authorization scheme.',
'In authorization plugins, you can use the <em>component.type</em>, <em>component.id</em> and <em>component.name</em> attributes of the <em>t_authorization</em> parameter.',
'For the built-in <em>Exists SQL Query</em> and <em>PL/SQL Function Body Returning Boolean</em> types, equivalent bind variables <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> and <em>:APP_COMPONENT_NAME</em> are available.',
'</p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747629186751412)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_text=>'Once per Component'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747763889751412)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_text=>'Evaluates once for each component that references the authorization scheme, but saves the result in the session. Further requests to render or process the scheme use the result in memory.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747482806751412)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_text=>'Once per Page View'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747588484751412)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_text=>'Evaluates once for each request that is processed. Use the result in memory if the authorization scheme is referenced in more than one component on the page.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747287237751412)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_text=>'Once per Session'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747348528751412)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_text=>'Evaluates only once and then uses the result in memory.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747827356751413)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_text=>'Always (No Caching)'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516747986020751413)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_text=>'The authorization scheme is always evaluated.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123087409981211764)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_text=>'Evaluation Point'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123097209497211789)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the event that causes the dynamic action to fire.',
'For information about specific events, please see the <a rel="noopener noreferrer" href="#SYSTEM_HELP_URL#CSH:pd-event" target="_blank">relevant section</a> in the <em>App Builder User''s Guide</em>.</p>',
'Events are categorized into the following types:',
'<dl>',
'  <dt>Browser Events</dt>',
'    <dd>Standard browser events.</dd>',
'  <dt>Framework Events</dt>',
'    <dd>Framework events are triggered from within the Oracle APEX framework.</dd>',
'  <dt>Component Events</dt>',
'    <dd>Only available when there is a component available to your application that triggers a custom event. These events are triggered from either native components or plug-in components you have installed in your application.</dd>',
'  <dt>Custom Event</dt>',
'    <dd>Any custom event triggered from your application.</dd>',
'</dl>'))
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123097132224211788)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_text=>'Event'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123146300581211874)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_text=>'Select the scope of the event, which determines when the event is evaluated a second or successive time.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758580569751450)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_text=>'Static'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758638179751450)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_text=>'Binds the event handler to the triggering element(s) for the lifetime of the current page, but is no longer bound if a triggering element is updated via Partial Page Refresh (PPR).'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758705611751450)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_text=>'Dynamic'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758889500751450)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_text=>'Binds the event handler to the triggering element(s) for the lifetime of the current page, irrespective of any triggering elements being recreated via Partial Page Refresh (PPR).'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758909195751450)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_text=>'Once'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759063975751450)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_text=>'Binds the event handler to the triggering element(s) only once. The dynamic action is not triggered again until after the page has been fully refreshed.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123146205112211874)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_text=>'Event Scope'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718996323661330)
,p_name=>'PE.PROPERTY.EXACT_SUBSTITUTIONS.PROMPT'
,p_message_text=>'Exact Substitutions'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143628497651500665)
,p_name=>'PE.PROPERTY.EXAMPLES.PROMPT'
,p_message_text=>'Examples'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(696456469269748811)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_text=>'Specify whether you want to exclude this title from translation. This attribute has no effect, except when translating the application into another language.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(696456384740748806)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_text=>'Exclude Title from Translation'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567457763634315687)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how many times this layer condition is executed.',
'If you refer to <em>Columns</em> in your condition, you must specify <strong>For Each Row</strong> in order for the condition to be evaluated for each row of the layer query.',
'Otherwise, set to <strong>Once</strong> to evaluate the validations one time for the region.'))
,p_version_scn=>37166067046551
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156037819585350914)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how many times this editable region validation is executed.',
'If you refer to <em>Columns</em> in your condition, you must specify <strong>For Each Row</strong> in order for the condition to be evaluated for each row of the editable region.',
'Otherwise, set to <strong>Once</strong> to evaluate the validations one time for the region.'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516774002548751516)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_text=>'Once'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773919715751514)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_text=>'For Each Row'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156037708535350914)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_text=>'Execute Condition'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990874352481185)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select when this read only condition is executed.</p>',
'        <p>If you refer to <em>Columns</em> in your read only condition, you must specify <strong>For Each Row</strong> in order for the condition to be evaluated for each row of the Interactive Grid.',
'        Otherwise, set to <strong>Once</strong> to evaluate the condition only one time for the region.'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245991099775481186)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_text=>'Once'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373632267864681195)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_text=>'Evaluate the read only condition only once for the whole region.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990921579481186)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_text=>'For Each Row'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373632109510681194)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_text=>'Evaluate the read only condition independently for each row.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245990781383481185)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_text=>'Execute'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607044577500649)
,p_name=>'PE.PROPERTY.EXECUTION_FUNCTION_NAME.PROMPT'
,p_message_text=>'Execution Function Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714208042661326)
,p_name=>'PE.PROPERTY.EXECUTION_IS_ACTIVE.PROMPT'
,p_message_text=>'Active'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156037401037350913)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the execution scope for this editable region validation.',
'Select <strong>For Created and Modified Rows</strong>, if you want this validation to be evaluated for new and updated rows in your editable region.',
'If you want your validation to be evaluated for every submitted row, select <strong>All Submitted Rows</strong>.'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773809167751514)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_text=>'All Submitted Rows'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516773707410751514)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_text=>'For Created and Modified Rows'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156037313201350913)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_text=>'Execution Scope'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123096028119211787)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the sequence for this component. The sequence determines the order of execution.</p>',
'<p>Note: If two components have the same sequence value, then they may be executed in a different order when the application is exported and imported into another environment.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123095923074211787)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_text=>'Sequence'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658611756661078)
,p_name=>'PE.PROPERTY.EXEC_STOP_EXECUTION_ON_ERROR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether processing of all other pending actions is stopped when an error occurs while executing the current action.</p>',
'<p>Note: The order of execution of specific actions is determined by the sequence specified for each action. To ensure that actions are run in the same order, Oracle recommends that the sequence numbers be unique for all True Actions and all False Ac'
||'tions.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658589987661078)
,p_name=>'PE.PROPERTY.EXEC_STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_text=>'Stop Execution On Error'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114937310475758789)
,p_name=>'PE.PROPERTY.EXPIRATION_POLICY.COMPONENT_PROPERTY.TASK_DEF.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046534
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114936719073758672)
,p_name=>'PE.PROPERTY.EXPIRATION_POLICY.HELP'
,p_message_text=>'The action to perform when the Task is overdue.'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114936908435758672)
,p_name=>'PE.PROPERTY.EXPIRATION_POLICY.LOV.EXPIRE.D'
,p_message_text=>'Expire'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114936844322758672)
,p_name=>'PE.PROPERTY.EXPIRATION_POLICY.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114937067872758672)
,p_name=>'PE.PROPERTY.EXPIRATION_POLICY.LOV.RENEW.D'
,p_message_text=>'Renew'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114936638574758672)
,p_name=>'PE.PROPERTY.EXPIRATION_POLICY.PROMPT'
,p_message_text=>'Expiration Policy'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656375983980385911)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>For an ORDS REST Service, retrieve all records with the "sal" attribute less than 3000.</dt>',
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>',
'<dl><dt>For an Oracle Cloud Applications (Saas) REST Service, retrieve all records with the "sal" attribute less than 3000.</dt>',
'<dd><pre>sal &lt; 3000',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656375823793385911)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_text=>'Provide a filter expression to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For example, Oracle REST Data Services (ORDS) expects JSON syntax'
||' while Oracle Cloud Applications (SaaS) expects a SQL-like where clause predicate using filterable attribute names.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656375776757385910)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_text=>'Filter'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656376226788385913)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    <dl><dt>For an ORDS REST Service, order by the "job" attribute ascending, then by "ename", descending.</dt>',
'    <dd><pre>',
'    {"job": "asc", "ename": "desc"}',
'    </pre></dd>',
'    </dl>',
'    <dl><dt>For an Oracle Cloud Applications (SaaS) REST Service, order by the "job" attribute ascending, then by "ename", descending.</dt>',
'    <dd><pre>',
'    job:asc,ename:desc',
'    </pre></dd>',
'    </dl>'))
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656376103092385912)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_text=>'Provide an order by expression involving one or more columns to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For example, Oracle REST Data Se'
||'rvices (ORDS) expects JSON syntax while Oracle Cloud Applications (SaaS) expects a comma-separated list of attribute names with optional direction indicator.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656376077462385912)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_text=>'Order By'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043853690306653)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_ITEM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>For an ORDS REST Service, order by the "job" attribute ascending, then by "ename", descending.</dt>',
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>',
'<dl><dt>For an Oracle Cloud Applications (SaaS) REST Service, order by the "job" attribute ascending, then by "ename", descending.</dt>',
'<dd><pre>',
'job:asc,ename:desc',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043716389306653)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_ITEM.HELP'
,p_message_text=>'Provide an order by expression involving one or more columns to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For example, Oracle REST Data Se'
||'rvices (ORDS) expects JSON syntax while Oracle Cloud Applications (SaaS) expects a comma-separated list of attribute names with optional direction indicator.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043608485306653)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044945017306815)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_TYPE.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044678258306780)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_TYPE.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043132215306653)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_TYPE.HELP'
,p_message_text=>'Select how this component is sorted.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043469146306653)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043554716306653)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Based on the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043297830306653)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043354979306653)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Based on the REST service order by expression entered into <em>External Order By</em>.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043062339306652)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_TYPE.PROMPT'
,p_message_text=>'Order By Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380775604538196285)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_text=>'Specify whether external post processing is enabled for this report.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380775595300196285)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380764854843410013)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_text=>'Enter the text for the link which end users click to invoke the external processing engine.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380764732312410013)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_text=>'Link Text'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380764612760410012)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_text=>'Enter the URL to a server for post processing of this report.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380764571415410012)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_text=>'URL'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044479159306659)
,p_name=>'PE.PROPERTY.EXTERNAL_STATIC_ORDER_BY_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    <dl><dt>For an ORDS REST Service, order by the "job" attribute ascending, then by "ename", descending.</dt>',
'    <dd><pre>',
'    {"job": "asc", "ename": "desc"}',
'    </pre></dd>',
'    </dl>',
'    <dl><dt>For an Oracle Cloud Applications (SaaS) REST Service, order by the "job" attribute ascending, then by "ename", descending.</dt>',
'    <dd><pre>',
'    job:asc,ename:desc',
'    </pre></dd>',
'    </dl>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044355231306659)
,p_name=>'PE.PROPERTY.EXTERNAL_STATIC_ORDER_BY_EXPR.HELP'
,p_message_text=>'Provide an order by expression involving one or more columns to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For example, Oracle REST Data Se'
||'rvices (ORDS) expects JSON syntax while Oracle Cloud Applications (SaaS) expects a comma-separated list of attribute names with optional direction indicator.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044275265306654)
,p_name=>'PE.PROPERTY.EXTERNAL_STATIC_ORDER_BY_EXPR.PROMPT'
,p_message_text=>'Order By'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584531936161747540)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_text=>'Select the facet group to which this checkbox is associated.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584531685716747540)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_text=>'Facet Group'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199312624214252)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_text=>'Select the list of values type.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554200277478214254)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_text=>'Distinct Values'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554200330999214254)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_text=>'The list of values is based on an automatically generated query that selects the distinct column values.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258653979090494)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body returning SQL Query'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258751876090494)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'The Dynamic list of values is based on the SQL Query returned by the entered Function Body you enter.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199479790214252)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_text=>'Shared Component'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199550485214253)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_text=>'The list of values is based on a predefined list of values, defined in Shared Components.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199670459214253)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199726607214253)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'The Dynamic list of values is based on the SQL Query you enter.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199832946214253)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199911162214253)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_text=>'The Static list of values is based on the text value you enter.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(554199297692214252)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746348064661355)
,p_name=>'PE.PROPERTY.FAVICONS.PROMPT'
,p_message_text=>'Favicon HTML'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665435493661271)
,p_name=>'PE.PROPERTY.FC_ACTIONS_CHART.HELP'
,p_message_text=>'<p>Specify whether a button is shown next to the facet to allow the user to show a chart of the facet list entry counts. This property only applies when the Faceted Search region property Show Charts is not No.</p>'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665391039661271)
,p_name=>'PE.PROPERTY.FC_ACTIONS_CHART.PROMPT'
,p_message_text=>'Chart'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112454756155495728)
,p_name=>'PE.PROPERTY.FC_ACTIONS_FILTER.HELP'
,p_message_text=>'<p>Specify whether the action Filter is displayed on the facet context menu to allow the user to toggle the client-side filtering On and Off, the user setting will be saved in session storage. The action will be disabled if the number of facet values'
||' is less than the value of Maximum Displayed Entries.</p>'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712352606661324)
,p_name=>'PE.PROPERTY.FC_ACTIONS_FILTER.PROMPT'
,p_message_text=>'Filter'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472574461879855229)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_text=>'<p>Specify whether the facet is collapsible.  When set to <strong>On</strong>, a toggle displays to the left of the facet, to hide/show its list entries. When set to <strong>Off</strong>, the facet and its list entries are always visible.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472574385106855229)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_text=>'Collapsible'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945735478744064097)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_text=>'<p>Specify whether to compute the count of the list entries for the facet or filter. There is a performance impact associated with the use of this option.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945735373913064091)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_text=>'Compute Counts'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584532864679747541)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_text=>'Specify how to combine filters within this group.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584533739348747541)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_text=>'AND (Intersect)'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584534008195747541)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_text=>'Filters will be combined using "AND"; thus the result will be the intersection of all individual filters.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584533184731747541)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_text=>'OR (Union)'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584533429551747541)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_text=>'Filters will be combined using "OR"; thus the result will be the union set of individual filters.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584532548463747540)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_text=>'Combine Filters'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472573601181855229)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_text=>'Specify whether to allow client-side filtering of the list entries for the filter. When set to <strong>On</strong>, a search field will render above the list entries, to allow end users to filter the list.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472573542690855229)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_text=>'Client-Side Filtering'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(288251622399082298)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES_INITIALLY.HELP'
,p_message_text=>'<p>Specify whether the client-side filtering is displayed initially for the facet.  When set to <strong>On</strong>, a filter field is shown above the list entries. If the number of entries in the facet is less than the value on Maximum Displayed Ent'
||'ries, the filter field won''t be displayed.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(288251515612082295)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES_INITIALLY.PROMPT'
,p_message_text=>'Display Filter Initially'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584535821804747543)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_text=>'<p>Specify whether the chart is initially displayed. This property only applies when Faceted Search region property Show Charts is Selector. Changes to this property may not be seen right away because the set of charts the user has shown is persisted'
||' in the browser session. To see the effect of changes to this property reset the report using the link Reset Regions cache control option such as with the wizard generated Reset button.</p>'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584535501784747542)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_text=>'Show Chart Initially'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472574644279855230)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_text=>'<p>Specify whether the facet should be initially rendered in a collapsed state. Changes to this property may not be seen right away because the expansion state is persisted in the browser session. To see the effect of changes to this property reset t'
||'he report using the link Reset Regions cache control option such as with the wizard generated Reset button.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472574549047855230)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_text=>'Initially Collapsed'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(594424680415379437)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_text=>'<p>Determines whether the facet is displayed by default. Changes to this property may not be seen right away because the display state is persisted in the browser session. To see the effect of changes to this property reset the report using the link '
||'Reset Regions cache control option such as with the wizard generated Reset button.</p>'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(594424381815379437)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_text=>'Initially Displayed'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472574855398855230)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_text=>'Enter the maximum height for the facet in pixels.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472574741192855230)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_text=>'Maximum Height'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472574956831855230)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47098737943209052)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_text=>'Specify how to combine individual values when filtering.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47099629028209053)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_text=>'AND (Intersect)'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47099999885209053)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_text=>'Values will be combined using "AND"; thus the result will be the intersection of all individual values.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47099083997209053)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_text=>'OR (Union)'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47099333303209053)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_text=>'Values will be combined using "OR"; thus the result will be the union set of individual values.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47098410516209052)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_text=>'Filter Combination'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472573225280855228)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_text=>'<p>Specify whether to show the count of occurrences of the list entries for the facet or filter.  When set to <strong>On</strong>, the count will display in brackets next to the list entry. For example, KING (3).</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472573122778855227)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_text=>'Show Counts'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472574280798855229)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_text=>'<p>Specify the maximum number of list entries to display for the facet.  When a value is specified, and the list contains more than this number of entries, a <strong>Show More</strong> link will render at the bottom of the list. When no value is spec'
||'ified, all list entries will be displayed.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472574140469855229)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_text=>'Maximum Displayed Entries'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472573861884855229)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_text=>'<p>Specify whether any selected list entries are shown first in the list for the facet or filter. This attribute does not apply where the list of values associated with the facet defines groups.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472573766715855229)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_text=>'Show Selected First'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150102198212010394)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_text=>'Specify whether to sort the list entries for the facet or filter. When set to <strong>On</strong>, the list entries are sorted by count descending. When set to <strong>Off</strong>, the list entries are displayed in the order defined by the List of V'
||'alues.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150102085667010386)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_text=>'Sort By Top Counts'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(594424066845379437)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_text=>'<p>Specify whether end-users can show or hide the facet. When at least one facet has this option turned on, a "More Facets" button is added that is used to choose which facets to show or hide. There is no performance cost to calculate counts for face'
||'ts that are not displayed.</p>'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(594423784111379437)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_text=>'Display Toggling'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945735621004064098)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_text=>'<p>Specify how list entries with zero count are displayed for the facet or filter.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945735952143064098)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_text=>'Disable'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945736059709064098)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_text=>'<p>Show all entries but disable those that are not filterable.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945735719864064098)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_text=>'Hide'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945735880173064098)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_text=>'<p>Only show filterable list entries.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945736146486064098)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_text=>'Show Last'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945736257623064098)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_text=>'<p>Show all entries but disable those that are not filterable, and show them last in the list for the facet or filter. This option is ignored if the associated Shared List of Values makes use of the group feature.</p>'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945735551188064098)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_text=>'Zero Count Entries'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638905963500672)
,p_name=>'PE.PROPERTY.FEEDBACK_ENTRY.PROMPT'
,p_message_text=>'Feedback Entry'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715614548661327)
,p_name=>'PE.PROPERTY.FETCH_ALL_ROWS_TIMEOUT.PROMPT'
,p_message_text=>'Fetch All Rows Timeout '
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715774305661327)
,p_name=>'PE.PROPERTY.FETCH_ALL_ROWS_TIMEOUT.UNIT'
,p_message_text=>'seconds'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109324461211814)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_text=>'Enter any additional attributes used in the HTML table cell that contains this label.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109228065211813)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_text=>'Table Cell Attributes'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380453752161584179)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_text=>'Choose the field template to be used when rendering the tabular form field. When no template is selected, the field is rendered using the default accessibility compliant label.'
,p_version_scn=>37166067046536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380977163625206972)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_text=>'Choose the field template to be used when rendering the tabular form field. When no template is selected, the field is rendered using the default accessibility compliant label.'
,p_version_scn=>37166067046537
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109102138211813)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a label template to define the appearance and layout of this item label.</p>',
'        <p>Label templates are defined in the application theme.',
'        When an item is created, the template is automatically set to the default item template defined in the current theme.</p>',
'        <p>Many themes contain label templates for displaying required, optional, and hidden labels.<br>',
'        Universal Theme provides the following label templates:',
'          <dl>',
'            <dt>Hidden</dt>',
'              <dd>Use this when the label should not be displayed on screen. Note that Assistive Technology will still be able to read the label.',
'              Hidden is ignored for Checkbox items because a label must be shown after the checkbox.</dd>',
'            <dt>Optional</dt>',
'              <dd>Use this for form items that are optional. The label will be displayed to the side of the item.</dd>',
'            <dt>Optional - Above</dt>',
'              <dd>Use this for form items that are optional. The label will be displayed above the item.</dd>',
'            <dt>Optional - Floating</dt>',
'              <dd>Use this for form items that are optional. The label will be displayed inside of the input item, and will automatically shrink once the input field has a value.</dd>',
'            <dt>Required</dt>',
'              <dd>This label template displays a red asterisk next to the label, and is used for form items where user input is required.  The label will be displayed to the side of the item.</dd>',
'            <dt>Required - Above</dt>',
'              <dd>This label template displays a red asterisk next to the label, and is used for form items where user input is required.  The label will be displayed above the item. Item templates enable you to define the user interface attributes a'
||'s part of a theme and share that definition among many page items.</dd>',
'            <dt>Required - Floating</dt>',
'              <dd>This label template displays a red asterisk next to the label, and is used for form items where user input is required.  The label will be displayed inside of the input item, and will automatically shrink once the input field has a '
||'value. Item templates enable you to define the user interface attributes as part of a theme and share that definition among many page items.</dd>',
'          </dl>',
'          See Also: <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a>',
'        </p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109031761211813)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575955184500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.1.D'
,p_message_text=>'Optional Label with Help'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576756257500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.10.D'
,p_message_text=>'Custom 6'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576803525500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.11.D'
,p_message_text=>'Custom 7'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576932482500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.12.D'
,p_message_text=>'Custom 8'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575729870500627)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.13.D'
,p_message_text=>'No Label'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576199943500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.2.D'
,p_message_text=>'Required Label with Help'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575822835500627)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.3.D'
,p_message_text=>'Optional Label'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576015070500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.4.D'
,p_message_text=>'Required Label'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576214776500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.5.D'
,p_message_text=>'Custom 1'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576391861500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.6.D'
,p_message_text=>'Custom 2'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576472058500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.7.D'
,p_message_text=>'Custom 3'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576530439500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.8.D'
,p_message_text=>'Custom 4'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143576687778500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.LOV.9.D'
,p_message_text=>'Custom 5'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143575675210500627)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_CLASS.PROMPT'
,p_message_text=>'Class'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577009286500628)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670627704661285)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.BIG5.D'
,p_message_text=>'Chinese Big5'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671806361661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.EUC-JP.D'
,p_message_text=>'Japanese EUC'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672009900661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.EUC-KR.D'
,p_message_text=>'Korean EUC'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670745094661285)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.GBK.D'
,p_message_text=>'Chinese GBK'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673299076661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.ISO-8859-1.D'
,p_message_text=>'Western European ISO-8859-1'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671235216661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.ISO-8859-2.D'
,p_message_text=>'Eastern European ISO-8859-2'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672363430661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.ISO-8859-3.D'
,p_message_text=>'Southern European ISO-8859-3'
,p_version_scn=>37166067046402
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672183211661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.ISO-8859-4.D'
,p_message_text=>'Northern European ISO-8859-4'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670835601661285)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.ISO-8859-5.D'
,p_message_text=>'Cyrilic ISO-8859-5'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670496848661285)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.ISO-8859-6.D'
,p_message_text=>'Arabic ISO-8859-6'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671462985661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.ISO-8859-7.D'
,p_message_text=>'Greek ISO-8859-7'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671656451661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.ISO-8859-8-I.D'
,p_message_text=>'Hebrew ISO-8859-8-i'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672580375661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.ISO-8859-9.D'
,p_message_text=>'Turkish ISO-8859-9'
,p_version_scn=>37166067046402
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670965088661285)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.KOI8-R.D'
,p_message_text=>'Cyrilic KOI8-R'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671062038661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.KOI8-U.D'
,p_message_text=>'Cyrilic KOI8-U'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671912954661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.SHIFT_JIS.D'
,p_message_text=>'Japanese Shift JIS'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672469873661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.TIS-620.D'
,p_message_text=>'Thai TIS-620'
,p_version_scn=>37166067046402
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672728462661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.US-ASCII.D'
,p_message_text=>'US-ASCII'
,p_version_scn=>37166067046402
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672841669661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.UTF-16BE.D'
,p_message_text=>'Unicode UTF-16 Big Endian'
,p_version_scn=>37166067046402
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672939179661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.UTF-16LE.D'
,p_message_text=>'Unicode UTF-16 Little Endian'
,p_version_scn=>37166067046402
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673095647661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.UTF-8.D'
,p_message_text=>'Unicode UTF-8'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671373668661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.WINDOWS-1250.D'
,p_message_text=>'Eastern European Windows 1250'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671144340661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.WINDOWS-1251.D'
,p_message_text=>'Cyrilic Windows 1251'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673308388661288)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.WINDOWS-1252.D'
,p_message_text=>'Western European Windows 1252'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671529269661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.WINDOWS-1253.D'
,p_message_text=>'Greek Windows 1253'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672631178661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.WINDOWS-1254.D'
,p_message_text=>'Turkish Windows 1254'
,p_version_scn=>37166067046402
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242671784622661286)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.WINDOWS-1255.D'
,p_message_text=>'Hebrew Windows 1255'
,p_version_scn=>37166067046401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670549085661285)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.WINDOWS-1256.D'
,p_message_text=>'Arabic Windows 1256'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242672208181661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.WINDOWS-1257.D'
,p_message_text=>'Northern European Windows 1257'
,p_version_scn=>37166067046402
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242673181618661287)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.LOV.WINDOWS-1258.D'
,p_message_text=>'Vietnamese Windows 1258'
,p_version_scn=>37166067046403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670383249661285)
,p_name=>'PE.PROPERTY.FILE_CHARACTER_SET.PROMPT'
,p_message_text=>'File Character Set'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667037788661277)
,p_name=>'PE.PROPERTY.FILE_NAME.HELP'
,p_message_text=>'This is the name of the file in the workspace file repository. Use <strong><code>&#35;WORKSPACE_IMAGES#filename</code></strong> in your application to reference a file.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666978948661277)
,p_name=>'PE.PROPERTY.FILE_NAME.PROMPT'
,p_message_text=>'File Name'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634106819500669)
,p_name=>'PE.PROPERTY.FILE_PREFIX.PROMPT'
,p_message_text=>'File Prefix'
,p_version_scn=>37166067046452
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221600563324260197)
,p_name=>'PE.PROPERTY.FILE_STORAGE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Controls whether static files are sourced from APEX itself or from Oracle Cloud Object Store'))
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221600684752260197)
,p_name=>'PE.PROPERTY.FILE_STORAGE.LOV.DB.D'
,p_message_text=>'Database'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221600724293260197)
,p_name=>'PE.PROPERTY.FILE_STORAGE.LOV.DB.HELP'
,p_message_text=>' Store Static Application Files in APEX, in the local database.'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221600883061260197)
,p_name=>'PE.PROPERTY.FILE_STORAGE.LOV.OBJECT_STORE.D'
,p_message_text=>'Object Storage'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221600922391260197)
,p_name=>'PE.PROPERTY.FILE_STORAGE.LOV.OBJECT_STORE.HELP'
,p_message_text=>'Store Static Application Files in a bucket in Oracle Cloud Object Store.'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221600441046260197)
,p_name=>'PE.PROPERTY.FILE_STORAGE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649747652831901166)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_text=>'Filter Data Type'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985623461481162)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to perform an exact match search when the end user enters text into a column filter.',
'      If set to <strong>Off</strong>, the filter will perform a contains search, rather than an equals search.</p>',
'      <p>For example, for a column called TAGS, this is equivalent to TAGS = ''<<value>>''. If Exact Match is set to <strong>Off</strong>, this is equivalent to TAGS LIKE ''%<<value>>%''. '))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985578954481161)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_text=>'Exact Match'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984049872481156)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether a filter is always required for this column.</p>',
'        <p>Note - a filter will always be required for this specific column before any data is returned, irrespective of the <strong>Filter Required</strong> option in the interactive grid attributes.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245983910861481156)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_text=>'Required'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984220571481157)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_text=>'Select how to derive the list of values for the filter when a user clicks on the column header or in filter dialogs.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984596447481158)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_text=>'Distinct Column'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984645134481158)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_text=>'Distinct column values are displayed for VARCHAR2 and NUMBER columns. DATE and TIMESTAMP columns utilize the built-in predefined date ranges.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649746677221901081)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_text=>'Use List of Values'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649746755659901084)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_text=>'Values are derived from list of values.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984383514481157)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984469876481158)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Disable any values being displayed in the filter.',
'        This option is appropriate on large columns, generally with most values being over 50 characters, or when a list would not be very usable for selecting a specific record.',
'        Instead the end user can just type in a partial value and then view the results.'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985374130481161)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_text=>'PL/SQL Function Body returning SQL Query'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985443710481161)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_text=>'Values are derived from the PL/SQL function body that returns a SQL Query.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984905902481159)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_text=>'Shared Component'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985077766481160)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_text=>'Values are derived from an existing list of values.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984766746481159)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984866390481159)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'Values are derived from the SQL query definition.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985116277481160)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985230625481160)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Values are derived from a static list of values.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245984181766481157)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_text=>'LOV Type'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245982401444481151)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select which filter operators end users can utilize for this column.</p>',
'        <p>Depending on the size of the data set and column indexes, you may choose to disable certain filter operators to avoid performance issues for the end users.',
'        Certain operators may cause full table scans instead of using column indexes.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404761901081249706)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_text=>'Contains'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762010067249712)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Filter returns results of column values containing the filter value.',
'        &PRODUCT_NAME. will utilize a <code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code> in the where clause.</p>',
'        <p>Note - this operator will prevent any column indexes being used, which may result in a full table scan.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245982907283481153)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_text=>'Case Insensitive'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373631815256681177)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Filter returns results of column values irrespective of differences in the case of the column value and filter value.',
'        &PRODUCT_NAME. will utilize a <code>UPPER(column) <em>operator</em> UPPER(filtervalue)</code> in the where clause.</p>',
'        <p>Note - Generally performing UPPER on both the column and filter value will prevent the use of any column indexes, except for function based column indexes with UPPER(<em>column</em>).</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245982862334481152)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_text=>'Regular Expression'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373631978464681178)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Filter returns results based on the regular expression entered.</p>',
'        <p>Note - using REGEXP operators is complex and generally only used by advanced users. Such operators can result in very bad performance.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762187652249713)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_text=>'Starts With'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762256247249713)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Filter returns results of column values starting with the filter value.',
'        &PRODUCT_NAME. will utilize a <code>column LIKE filtervalue<strong>%</strong></code> in the where clause.</p>',
'        <p>Note - this operator can utilize available column indexes. {Please review <strong>Case Insensitive</strong> for exceptions}.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245982382662481151)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_text=>'Performance Impacting Operators'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245983242227481154)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select which case the text within the column value is stored.</p>',
'        <p>If the column can be specified as always upper case, for example <em>Username</em>, or always lower case, then the performance of retrieving filter results can be improved.',
'          If <strong>Upper</strong> or <strong>Lower</strong> is selected searches will always perform case sensitive searches.</p>',
'        <p>Note - If Mixed is selected, then end users can specify <strong>Case Sensitive</strong> in the Search and Filter dialogs.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245983569840481155)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_text=>'Lower'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245983617947481155)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'For when the column value is always stored in lower case.',
'        &PRODUCT_NAME. will utilize a <code>column <em>operator</em> LOWER(filtervalue)</code> in the where clause.'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245983706880481155)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_text=>'Mixed'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245983874192481156)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_text=>'For when the column value is stored in mixed case. The setting for the <strong>Case Insensitive</strong> operator will determine the where clause utilized.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245983340475481154)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_text=>'Upper'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245983436805481154)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'For when the column value is always stored in upper case.',
'        &PRODUCT_NAME. will utilize a <code>column <em>operator</em> UPPER(filtervalue)</code> in the where clause.'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245983178123481153)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_text=>'Text Case'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123147619576211876)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify if the action fires on initialization.</p>',
'                                    <p>Initialization has a slightly different meaning depending on how the Dynamic Action is defined. For Dynamic',
'                                    Actions defined to fire on Interactive Grid columns, this specifies if the action fires when the Interactive',
'                                    Grid row is activated for editing. For all other Dynamic Actions, this specifies if the action fires when the',
'                                    page loads.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123147506656211876)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_text=>'Fire on Initialization'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123147231104211875)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether this action fires when the triggering element condition is met by selecting <strong>True</strong> (True Action), or when it is not met by selecting <strong>False</strong> (False Action).</p>',
'<p>Note: if there is no condition specified, only <strong>True</strong> actions fire.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759287412751451)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_text=>'False'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516759136878751451)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_text=>'True'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123147108237211875)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_text=>'Fire When Event Result Is'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1567067136291011343)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_text=>'Specify whether you would like to fix the report''s column headers to the top of the <strong>Page</strong> or top of the <strong>Region</strong>, so that the column headers remain visible as the user vertically scrolls the report.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1581952670972432887)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1581952702232432889)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_text=>'Report header is not fixed.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1567067374012011344)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_text=>'Page'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1567068977005058387)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_text=>'Fixes the report header to the top of the page. As the user vertically scrolls the page, the report header will remain fixed at the top of the page. <strong>Page</strong> level fixed headings are useful for when the report is the main content on the '
||'page. This setting is not supported when the region is in a dialog.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1567067218596011344)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_text=>'Region'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1567068819965058387)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_text=>'Fixes the report header to the top of the current region. As the user vertically scrolls within the region, the report header will remain fixed at the top of the region. <strong>Region</strong> level fixed headings could be useful for a page containi'
||'ng multiple regions, for example a dashboard page.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1567067074708011341)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_text=>'Fixed To'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1583793385577513898)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_text=>'Enter the maximum height for the report in pixels.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1583793259567513896)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_text=>'Maximum Report Height'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1583793497757513898)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715437008661327)
,p_name=>'PE.PROPERTY.FIXED_PAGE_SIZE.PROMPT'
,p_message_text=>'Fixed Page Size'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(429904650700246123)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_text=>'Enter the fixed height for the report in pixels.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(429904581032246114)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_text=>'Fixed Report Height'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(429904701697246123)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245975296893481119)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to display the interactive grid with fixed row height.</p>',
'        <p>If set to <em>Yes</em>, ellipses (...) will be displayed at the end of data, for columns that are too narrow to display all of the data.',
'        If set to <em>No</em> data will wrap across multiple lines as necessary.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245975149879481119)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_text=>'Fixed Row Height'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150995603900822757)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a region footer that displays directly after the body content, after <code>#BODY#</code> in the region template.',
'You may use shortcuts, as well as the substitution string <code>#TIMING#</code>, to display the time consumed to render the region.</p>',
'<p>For report regions you can use the following pagination substitution strings:</p>',
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
'    <dd>Shows the number of rows fetched by the reporting engine (the page size). Use these substitution strings to display customized messages to the user.</dd>',
'  <dt><code>#TOTAL_ROWS#</code></dt>',
'    <dd>Displays the total number of rows that satisfy a SQL query used for a report. For example, Z in rows X - Y of Z</dd>',
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
'    <dd>The X in rows X - Y of Z</dd>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
'    <dd>The Y in rows X - Y of Z</dd>',
'</dl>'))
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123102002718211800)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_text=>'Enter text or HTML that appears before the page template footer.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101927515211800)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_text=>'Footer Text'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715813247661328)
,p_name=>'PE.PROPERTY.FORCE_RAISE_HTTP_404_ERROR.PROMPT'
,p_message_text=>'Force Raise HTTP-404 Error'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516791384020751581)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Setting this attribute to <code>fielddatabold</code> results in the following HTML being generated</dt>',
'<dd><pre>',
'&lt;span class="fielddatabold"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380451124449584103)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter CSS classes to apply to this column''s value. You can type in the CSS class or pick from the list of available items.</p>',
'<p>This class is included by default on all &PRODUCT_NAME. pages and has the definition of <code>''.fielddatabold{font-size: 10pt; font-weight: bold; color: #000000;}''</code>.</p>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380451069296584103)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380453688844584179)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the format mask to apply to this column.',
'    You can type in the format mask or pick from the predefined list, based on a sample representation of how that format mask is displayed.</p>',
'    <p>It is important that number format masks are only applied to columns that contain numbers and date format masks are only applied to columns that contain dates.',
'    Otherwise, a runtime error is raised when any record contains a value that can not be converted using the specified format mask.</p>'))
,p_version_scn=>37166067046536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380976998275206970)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the format mask to apply to this column.',
'    You can type in the format mask or pick from the predefined list, based on a sample representation of how that format mask is displayed.</p>',
'    <p>It is important that number format masks are only applied to columns that contain numbers and date format masks are only applied to columns that contain dates.',
'    Otherwise, a runtime error is raised when any record contains a value that can not be converted using the specified format mask.</p>'))
,p_version_scn=>37166067046537
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111122074211816)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a format mask to apply to this component.',
'   You can type in the format mask or pick from the list of predefined format masks, based on a sample representation of how that format mask is displayed.</p>',
'   <p>It is important that number format masks are only applied to components that contain numbers and date format masks are only applied to components that contain dates.',
'    Otherwise, a runtime error is raised when the component contains a value that can not be converted using the specified format mask.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111007725211816)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_text=>'Format Mask'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111311191211816)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a date format mask to apply to this component.',
'You can type in the format mask or pick from the list of predefined format masks, based on a sample representation of how that format mask displays.',
'You can also use substitution syntax to reference a dynamic format mask from an application or page item.'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111228377211816)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_text=>'Format Mask'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111502753211817)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a number format mask to apply to this component.',
'You can type in the format mask or pick from the list of predefined format masks, based on a sample representation of how that format mask displays.',
'You can also use substitution syntax to reference a format mask from an application or page item.'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111431988211817)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_text=>'Format Mask'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123104400564211804)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether auto-complete is disabled for this page. A value of <strong>On</strong> has no effect on this page. A value of <strong>Off</strong> generates the following HTML in the FORM tag:',
'<pre>',
'autocomplete="off"',
'</pre>',
'<p>Note: Different browsers may have different rules around when <code>autocomplete="off"</code> is respected or ignored. Therefore please bear this in mind specifically when setting this to <strong>Off</strong>, and test in your target browsers.</p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750881958751423)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_text=>'Off'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750758419751423)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_text=>'On'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123104323674211804)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_text=>'Form Auto Complete'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718561987661330)
,p_name=>'PE.PROPERTY.FRIENDLY_URLS.PROMPT'
,p_message_text=>'Friendly URLs'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116949946139909841)
,p_name=>'PE.PROPERTY.FROM_WORKFLOW_ACTIVITY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Specify the From activity for this connection.'))
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116949632064909840)
,p_name=>'PE.PROPERTY.FROM_WORKFLOW_ACTIVITY.PROMPT'
,p_message_text=>'From'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21663361672862471)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the label(s) of the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21662991569855002)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_text=>'Label'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380394545651680321)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum number of generic report columns.',
'Reports that use generic column names are parsed at runtime only, so the number of columns is not known when editing the report.</p>',
'<p>The maximum number of report columns should match the expected number of report columns.',
'If the actual number is smaller, the report renders with the actual number of columns.',
'However, if the actual number is higher than the maximum, then an error message shows at runtime.</p>'))
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380394404738680320)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_text=>'Generic Column Count'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722076074661333)
,p_name=>'PE.PROPERTY.GLOBAL_NOTIFICATION_MESSAGE.PROMPT'
,p_message_text=>'Global Notification Message'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183239816227033867)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_text=>'Select the global page, if one is not defined.'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183239727840033867)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_text=>'Global Page'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588919673500636)
,p_name=>'PE.PROPERTY.GRID_ALWAYS_RENDER_LAYOUT.PROMPT'
,p_message_text=>'Always Render Layout'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588723540500636)
,p_name=>'PE.PROPERTY.GRID_ALWAYS_USE_MAX_COLUMNS.PROMPT'
,p_message_text=>'Always use Max Columns'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629250135349045958)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380857562328128734)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380857815727128739)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110107473211815)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_text=>'Select a specific layout column. Use <strong>Automatic</strong> to automatically determine the next available layout column where the component displays.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110023143211815)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110924251211816)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_text=>'Enter additional attributes set for the layout column. This value replaces the <code>#ATTRIBUTES#</code> substitution placeholder in the layout column template.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110829109211816)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_text=>'Column Attributes'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596947963690296955)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_text=>'Auto'
,p_version_scn=>37166067046554
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932420537296778)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how many layout columns this component occupies. Use Automatic to balance the available layout columns across all components in the same row.</p>',
'<dl>',
'  <dt>Auto</dt>',
'    <dd>Cards will have an initial width and will automatically wrap to a new row when they can no longer fit comfortably.</dd>',
'  <dt>2, 3, 4, 5 Columns</dt>',
'    <dd>Cards will be arranged to fit the selected number of columns per line.  The layout may reduce the number of columns based on the viewport width.</dd>',
'  <dt>You can configure the width of the cards by setting a CSS variable.</dt>',
'    <dd>For example add the following snippet to set the card width to 320px: <pre>:root {',
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932512321296778)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_text=>'2 Columns'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932696949296778)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_text=>'3 Columns'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932740138296783)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_text=>'4 Columns'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932831092296784)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_text=>'5 Columns'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596932335726296778)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_text=>'Grid Columns'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1590875512609364322)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter CSS classes you want to apply to the layout column that contains this region. You may add multiple classes by separating them with spaces.</p>',
'        <p>This property can be used to provide fine grained control over the responsiveness and layout of the region''s layout column as the viewport size is changed.',
'        For Universal Theme applications, there are a number of CSS modifiers you may use to extend your page components. Review the Reference section of the Universal Theme Sample Application to learn more.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1590875420491364322)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_text=>'Column CSS Classes'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629250278856045958)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380857691672128734)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380857901433128739)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110530835211816)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_text=>'Select how many layout columns this component occupies. Use <strong>Automatic</strong> to balance the available layout columns across all components in the same row.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110403032211816)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_text=>'Column Span'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589841152500637)
,p_name=>'PE.PROPERTY.GRID_COLUMN_TEMPLATE.PROMPT'
,p_message_text=>'Column Template'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589615702500637)
,p_name=>'PE.PROPERTY.GRID_CONTAINER_TEMPLATE.PROMPT'
,p_message_text=>'Container Template'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589289145500637)
,p_name=>'PE.PROPERTY.GRID_DEFAULT_LABEL_COLUMN_SPAN.PROMPT'
,p_message_text=>'Default Label Column Span'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589074365500637)
,p_name=>'PE.PROPERTY.GRID_EMIT_EMPTY_LEADING_COLUMNS.PROMPT'
,p_message_text=>'Emit Empty Leading Columns'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589178054500637)
,p_name=>'PE.PROPERTY.GRID_EMIT_EMPTY_TRAILING_COLUMNS.PROMPT'
,p_message_text=>'Emit Empty Trailing Columns'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589317936500637)
,p_name=>'PE.PROPERTY.GRID_FIRST_COLUMN_ATTRIBUTES.PROMPT'
,p_message_text=>'First Column Attributes'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588836723500636)
,p_name=>'PE.PROPERTY.GRID_HAS_COLUMN_SPAN.PROMPT'
,p_message_text=>'Has Column Span'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589931488500637)
,p_name=>'PE.PROPERTY.GRID_JAVASCRIPT_DEBUG_CODE.PROMPT'
,p_message_text=>'JavaScript Debug Code'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1565702633782714285)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_text=>'Page Template Default'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1565702583770714121)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_text=>'Select how many layout columns the label occupies.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1565702451926714118)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_text=>'Label Column Span'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589425215500637)
,p_name=>'PE.PROPERTY.GRID_LAST_COLUMN_ATTRIBUTES.PROMPT'
,p_message_text=>'Last Column Attributes'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588602571500636)
,p_name=>'PE.PROPERTY.GRID_MAXIMUM_COLUMNS.PROMPT'
,p_message_text=>'Maximum Columns'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110309253211815)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_text=>'Specify whether this component displays in the next column or in the same column as the previous component.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110226186211815)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_text=>'New Column'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109716909211814)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_text=>'Specify whether this component displays in a new layout, or in the same layout as the previous component.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109625932211814)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_text=>'Start New Layout'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109901807211815)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_text=>'Specify whether this component displays on the next row after the previous component, or on the same row.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109832176211814)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_text=>'Start New Row'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589555227500637)
,p_name=>'PE.PROPERTY.GRID_REGION_TABLE_ATTRIBUTES.PROMPT'
,p_message_text=>'Region Table Attributes'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(568033875674572954)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter CSS classes you want to apply to the layout row that contains this region. You may add multiple classes by separating them with spaces.</p>',
'        <p>This property can be used to provide fine grained control over the responsiveness and layout of the region''s layout row as the viewport size is changed.',
'        For Universal Theme applications, there are a number of CSS modifiers you may use to extend your page components. Review the Reference section of the Universal Theme Sample Application to learn more.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(568033772305572939)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_text=>'Row CSS Classes'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110726973211816)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_text=>'Enter how many rows within the HTML table this component occupies. Components are laid out in HTML tables. This attribute determines the value to be used for the <em>ROWSPAN</em> attribute in the table cell for this component.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123110609664211816)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_text=>'Row Span'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143589776670500637)
,p_name=>'PE.PROPERTY.GRID_ROW_TEMPLATE.PROMPT'
,p_message_text=>'Row Template'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696732028661310)
,p_name=>'PE.PROPERTY.GROUP_COLUMN_NAME.PROMPT'
,p_message_text=>'Group'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578364469340720)
,p_name=>'PE.PROPERTY.GROUP_ID.HELP'
,p_message_text=>'Identifies the application access control role.'
,p_version_scn=>49870262
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578227557340720)
,p_name=>'PE.PROPERTY.GROUP_ID.PROMPT'
,p_message_text=>'Application Access Control Role'
,p_version_scn=>49870261
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618797188065348)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining a short descriptive custom tooltip on the series name(s) on the chart legend. For a Box Plot chart, the column should not match the selected Value column mapping. Selection of a column that matches the V'
||'alue column mapping will result in no legend tooltip being rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618617128065348)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_text=>'Legend Tooltip'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618976653065349)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining a short descriptive custom tooltip on the x axis label(s) of the chart. For a Box Plot chart, the column should not match the selected Value column mapping. Selection of a column that matches the Value c'
||'olumn mapping will result in no label tooltip being rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618822762065348)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_text=>'Label Tooltip'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696971010661311)
,p_name=>'PE.PROPERTY.GROUP_SORT_DIRECTION.LOV.ASC.D'
,p_message_text=>'Ascending (Nulls Last)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697094141661311)
,p_name=>'PE.PROPERTY.GROUP_SORT_DIRECTION.LOV.ASC_NULLS_FIRST.D'
,p_message_text=>'Ascending (Nulls First)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697142556661311)
,p_name=>'PE.PROPERTY.GROUP_SORT_DIRECTION.LOV.DESC.D'
,p_message_text=>'Descending (Nulls Last)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697256352661311)
,p_name=>'PE.PROPERTY.GROUP_SORT_DIRECTION.LOV.DESC_NULLS_FIRST.D'
,p_message_text=>'Descending (Nulls First)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696889726661310)
,p_name=>'PE.PROPERTY.GROUP_SORT_DIRECTION.PROMPT'
,p_message_text=>'Group Sort Direction'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199639004982646)
,p_name=>'PE.PROPERTY.HAS_DEFAULT.HELP'
,p_message_text=>'Specify whether the parameter has a default value and can be omitted.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199548767982646)
,p_name=>'PE.PROPERTY.HAS_DEFAULT.PROMPT'
,p_message_text=>'Has Default'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380393434510636701)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether column definitions are derived from the SQL query.',
'Doing this requires &PRODUCT_NAME. to parse the query.',
'If you do not want the query parsed at this time, use generic column names, which produces placeholder column definitions.'))
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380393346024636700)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_text=>'Use Generic Column Names'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705923862661319)
,p_name=>'PE.PROPERTY.HAS_TIME_ZONE.PROMPT'
,p_message_text=>'Has Time Zone'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150995523577822757)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>'Enter HTML text displayed at the top of the region, before the <code>#BODY#</code> content.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101622730211800)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_text=>'Enter text or HTML you want to appear immediately following the page header and before the body content.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101513020211800)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_text=>'Header Text'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380756641146409997)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_text=>'Select how headings are defined for your report.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793115032751590)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_text=>'Custom Headings'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793224384751590)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_text=>'Enables you to enter your own headings. The headings are initially defaulted, based on a query of column names.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793376441751590)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793473058751590)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'Creates headings based on a PL/SQL Function returning a colon delimited list of names.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793541472751590)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_text=>'None'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793655343751591)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_text=>'The report is displayed without report headings.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792752464751589)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_text=>'Column Names'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792839388751589)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_text=>'Generates headings based on a query of the column names.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792925684751589)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_text=>'Column Names (InitCap)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793024769751590)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_text=>'Generates headings, which are converted to initial capitalization, based on a query of the column names.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380756519234409997)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360491109553274737)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_text=>'Select the heading alignment. Note that your alignment selection must be supported by the selected report template.'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516777694535751528)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_text=>'center'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516777529202751528)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_text=>'start'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516777728111751528)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_text=>'end'
,p_version_scn=>37166067046346
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360491023976274737)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_text=>'Alignment'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793762043751591)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Provide the headings for a report based on the DEPT table</dt>',
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380757324802409999)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_text=>'Enter a PL/SQL function to return a string of column headings delimited by colons.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380757239845409999)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577789838500629)
,p_name=>'PE.PROPERTY.HELP_TEMPLATE.PROMPT'
,p_message_text=>'Invoke'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245991465649481466)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_text=>'<p>Use this attribute to enter help text for the interactive grid. The entered help text will display along with the default help content under Actions Menu help.</p>'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245992439660481474)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>'Enter help text for this column.'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380880293441012831)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_text=>'Enter help text for this item. The help text may be used to provide field level context sensitive help.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123108123776211812)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this attribute to enter help text for the current page. Page level help supports shortcuts using the following syntax:</p>',
'<pre>"SHORTCUT_NAME"</pre>',
'<p>Page help text is not displayed by default. However, you can readily develop a help system that exposes this text.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123108027866211812)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_text=>'Help Text'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600502386784508)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.COMPONENT_PROPERTY.PAGE.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Help text plays a crucial role in providing additional information and guidance to users, particularly those who may require assistance or clarification while interacting with an interface. By ensuring that help text is accessible and effectively '
||'communicates its purpose, you enhance the usability and inclusivity of your application.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Clear and Concise:</strong> Keep help text clear and concise to facilitate easy understanding for all users. Avoid using overly technical language or jargon that may be confusing to some users.</li>',
'<li><strong>Contextual Guidance:</strong> Provide help text that is contextually relevant to the task or element it is associated with. This helps users understand how to complete a specific action or navigate through the interface effectively.</li>',
'<li><strong>Sensory Characteristics:</strong> Ensure instructions provided through help do not rely solely on sensory characteristics of page elements (such as shape, color, size or visual location). For example, instead of saying ''click the button i'
||'n the top right of the page'', better help text would be ''click the button labelled "Next" in the top right of the page'' (so the instruction is not reliant on location alone).</li>',
'</ol>'))
,p_version_scn=>36587275
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(273855846058182173)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this attribute to enter help text for the current page. Page level help supports shortcuts using the following syntax:</p>',
'<pre>"SHORTCUT_NAME"</pre>',
'<p>Page help text is not displayed by default. However, you can readily develop a help system that exposes this text.</p>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(273855772089182173)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_text=>'Help Text'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143628391374500665)
,p_name=>'PE.PROPERTY.HELP_TEXT_NO_MARKUP.PROMPT'
,p_message_text=>'Help Text'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507053566670740)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_text=>'Region'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971049037250227)
,p_name=>'PE.PROPERTY.HIDDEN_PLUGIN_NAME.PROMPT'
,p_message_text=>'Plugin Name'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573029955602576803)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_text=>'Region Type'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192058737982622)
,p_name=>'PE.PROPERTY.HIDDEN_REQUIRED_VALUE_TYPE.PROMPT'
,p_message_text=>'Required Type'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1414908265559871)
,p_name=>'PE.PROPERTY.HIDDEN_SOURCE_LOCATION.PROMPT'
,p_message_text=>'Hidden Source Location'
,p_version_scn=>19132258
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1414604110559834)
,p_name=>'PE.PROPERTY.HIDDEN_TEMPLATE_COMPONENT_TYPE.PROMPT'
,p_message_text=>'Template Component Type'
,p_version_scn=>19132243
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973114584250232)
,p_name=>'PE.PROPERTY.HIDDEN_TEMPLATE_ID.PROMPT'
,p_message_text=>'Hidden Template Id'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130194854714982626)
,p_name=>'PE.PROPERTY.HIDDEN_VALUE_TYPE.PROMPT'
,p_message_text=>'Hidden Value Type'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611878099065324)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the hide and show behavior that is performed when clicking on a legend item.',
'        For example, deselecting a legend item will hide its associated data series on the chart.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611999631065324)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(405613662881209889)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_text=>' The chart will not enable the hide and show behavior.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295612146319065325)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_text=>'No Rescaling'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(405613808238209891)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_text=>' The chart axes will not rescale. This is useful to keep the user in context.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295612035814065325)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_text=>'Rescale'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(405613712408209890)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_text=>' The chart axes will rescale as the minimum and maximum values of the visible data increase or decrease. This is useful for series with largely varying values.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611744813065324)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_text=>'Hide and Show Behavior'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380451500123584104)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter text strings to be highlighted in a report column.',
'For multiple highlighted words, use a comma delimited list.',
'You can also reference page or application items using <code>&amp;ITEM.</code> syntax.',
'For example, you can highlight strings entered into a search field.'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380451438561584104)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_text=>'Highlight Words'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183239206065033865)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_text=>'Specify the application home page.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183239109260033865)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_text=>'Home URL'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123143300921211869)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_text=>'<p>Select the horizontal alignment for this button within the specified template position.</p>'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516768167195751489)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_text=>'Left'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516768288837751489)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_text=>'Right'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123143220881211869)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_text=>'Horizontal Alignment'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729734653661340)
,p_name=>'PE.PROPERTY.HTML_ESCAPING_MODE.LOV.B.D'
,p_message_text=>'Basic'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729861542661340)
,p_name=>'PE.PROPERTY.HTML_ESCAPING_MODE.LOV.E.D'
,p_message_text=>'Extended'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729633511661340)
,p_name=>'PE.PROPERTY.HTML_ESCAPING_MODE.PROMPT'
,p_message_text=>'HTML Escaping Mode'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779649110751535)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Change the background and text colors</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
'  <dt>Use Heading 2</dt>',
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
'  <dt>Use a dynamic class from the SQL query</dt>',
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
'    The <code>#COLUMN_CLASS#</code> and <code>#EMPLOYEE_STATUS#</code> substitutions in this example are columns selected in the report SQL query.</dd>',
'  <dt>Show an image, and a tooltip on hover</dt>',
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'  <dt>Loop over a comma separated list of values</dt>',
'    <dd><pre>&lt;ul>{loop "," TAGS/}&lt;li>&APEX$ITEM.&lt;/li>{endloop/}&lt;/ul></pre></dd>',
'  <dt>Use an "if" directive for a column with a quoted identifier</dt>',
'    <dd><pre>{if Mixed Case Name/}&lt;strong>#"Mixed Case Name"#&lt;/strong>{endif/}</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360495413051274748)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML expressions to be shown in this column. Use <code>#COLUMN#</code> syntax to show column values in HTML.</p>',
'  <p>If a column name is a quoted identifier, use #"COLUMN"# syntax.</p> '))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360495317881274748)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_text=>'HTML Expression'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101223040211799)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text to replace the <code>#HEAD#</code> substitution string in the page template header.',
'The values entered here are inserted after the HTML <code>&lt;head&gt;</code> tag. Use this page attribute to add page specific meta tags.',
'</p>',
'<p>Note: JavaScript code or Cascading Style Sheets should be added to the dedicated JavaScript and CSS attributes.</p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101124643211799)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_text=>'HTML Header'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594091796500640)
,p_name=>'PE.PROPERTY.HTML_TABLE_ATTRIBUTES.PROMPT'
,p_message_text=>'HTML Table Attributes'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670084219661285)
,p_name=>'PE.PROPERTY.HTTPS_HOST_NAME.PROMPT'
,p_message_text=>'HTTPS Host Name'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669707577661284)
,p_name=>'PE.PROPERTY.HTTP_CREDENTIAL_NAME.PROMPT'
,p_message_text=>'Credential Name'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669871752661285)
,p_name=>'PE.PROPERTY.HTTP_CREDENTIAL_SECRET.PROMPT'
,p_message_text=>'Credential Secret'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715439145035626)
,p_name=>'PE.PROPERTY.HTTP_METHOD.COMPONENT_PROPERTY.AUTOMATION_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715620210035653)
,p_name=>'PE.PROPERTY.HTTP_METHOD.COMPONENT_PROPERTY.JET_CHART_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715242887035617)
,p_name=>'PE.PROPERTY.HTTP_METHOD.COMPONENT_PROPERTY.LOV_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715825278035688)
,p_name=>'PE.PROPERTY.HTTP_METHOD.COMPONENT_PROPERTY.MAP_LAYER_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046554
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60714885692035599)
,p_name=>'PE.PROPERTY.HTTP_METHOD.COMPONENT_PROPERTY.REGION_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78521433225696243)
,p_name=>'PE.PROPERTY.HTTP_METHOD.COMPONENT_PROPERTY.SEARCH_CONFIG_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046534
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60715041400035607)
,p_name=>'PE.PROPERTY.HTTP_METHOD.COMPONENT_PROPERTY.WEB_SRC_SYNC_STEP_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046524
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117343168533910327)
,p_name=>'PE.PROPERTY.HTTP_METHOD.COMPONENT_PROPERTY.WF_ACTIVITY_WS_PARAM.NULL_TEXT'
,p_message_text=>'All'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664050042661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    HTTP Operation or <em>Method</em> (GET, POST, PUT, DELETE) to be executed on the REST Web Service. The combination of URL pattern and HTTP Operation identifies the operation within a REST Data Source. A REST Data Source may contain the same URL p'
||'attern for different HTTP operations and different URL patterns for the same HTTP operation.',
'</p>',
'<p>',
'    Following is a brief explanation of HTTP methods and their usage in REST services. Note this this is all convention - REST services should adhere to this, but real implementations can be different. Always check the documentation of the REST servi'
||'ce you plan to access on which methods can be called and how they work.',
'</p>'))
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664743408661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.DELETE.D'
,p_message_text=>'DELETE'
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664868639661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.DELETE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Typically used to remove a resource on the server. A request body is typically not required.'))
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664121037661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.GET.D'
,p_message_text=>'GET'
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664247483661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.GET.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Fetch data from the REST service. GET is supposed to be idempotent; it''s invocation does not change anything at the server side. For this reason,',
'GET requests can be typically be cached or called multiple times. GET requests do also <em>not</em> have a request body in normal cases.'))
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664900277661234)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.PATCH.D'
,p_message_text=>'PATCH'
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665001506661234)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.PATCH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Typically used to <em>change</em> a new resource on the server. Not all REST services provide PATCH endpoints. A request body, containing information on',
'which attribute to change to which value, is required. PATCH thus allows to do partial updates on a server resource. Note that there is no standard on how',
'the request body for a PATCH endpoint should look like - check the documentation of your REST service before invoking it.'))
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664359325661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.POST.D'
,p_message_text=>'POST'
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664448353661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.POST.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Typically used to create a new resource on the server. However, in practice, POST requests can do all sort of things. POST requests typically',
'require a request body to be sent.'))
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664553113661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.PUT.D'
,p_message_text=>'PUT'
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242664620037661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.LOV.PUT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Typically used to <em>replace</em> a new resource on the server. A request body is typically required. Note that you need to pass <em>all</em> attributes',
'to the server - missing attributes are likely to be written as null or empty values.'))
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663917603661233)
,p_name=>'PE.PROPERTY.HTTP_METHOD.PROMPT'
,p_message_text=>'HTTP Method'
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729936749661340)
,p_name=>'PE.PROPERTY.HTTP_RESPONSE_HEADERS.PROMPT'
,p_message_text=>'HTTP Response Headers'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712180357661324)
,p_name=>'PE.PROPERTY.HTTP_TRANSFER_TIMEOUT.PROMPT'
,p_message_text=>'HTTP Transfer Timeout'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712201673661324)
,p_name=>'PE.PROPERTY.HTTP_TRANSFER_TIMEOUT.UNIT'
,p_message_text=>'seconds'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775722942661532)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.COMPONENT_PROPERTY.DATA_LOAD_DEF_DATA_PROFILE.NULL_TEXT'
,p_message_text=>'Database Character Set'
,p_version_scn=>37166067046530
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775186568661520)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.COMPONENT_PROPERTY.WEB_SRC_MODULE_DATA_PROFILE.NULL_TEXT'
,p_message_text=>'Database Character Set'
,p_version_scn=>37166067046524
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775484360661522)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.COMPONENT_PROPERTY.WEB_SRC_OPERATION_DATA_PROFILE.NULL_TEXT'
,p_message_text=>'Database Character Set'
,p_version_scn=>37166067046524
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699355207661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.BIG5.D'
,p_message_text=>'Chinese Big5'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700565616661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.EUC-JP.D'
,p_message_text=>'Japanese EUC'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700735216661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.EUC-KR.D'
,p_message_text=>'Korean EUC'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699439753661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.GBK.D'
,p_message_text=>'Chinese GBK'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701995200661315)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.ISO-8859-1.D'
,p_message_text=>'Western European ISO-8859-1'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699970770661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.ISO-8859-2.D'
,p_message_text=>'Eastern European ISO-8859-2'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701069599661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.ISO-8859-3.D'
,p_message_text=>'Southern European ISO-8859-3'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700815140661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.ISO-8859-4.D'
,p_message_text=>'Northern European ISO-8859-4'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699597576661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.ISO-8859-5.D'
,p_message_text=>'Cyrilic ISO-8859-5'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699194509661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.ISO-8859-6.D'
,p_message_text=>'Arabic ISO-8859-6'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700130754661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.ISO-8859-7.D'
,p_message_text=>'Greek ISO-8859-7'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700338241661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.ISO-8859-8-I.D'
,p_message_text=>'Hebrew ISO-8859-8-i'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701230075661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.ISO-8859-9.D'
,p_message_text=>'Turkish ISO-8859-9'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699670500661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.KOI8-R.D'
,p_message_text=>'Cyrilic KOI8-R'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699769367661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.KOI8-U.D'
,p_message_text=>'Cyrilic KOI8-U'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700615611661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.SHIFT_JIS.D'
,p_message_text=>'Japanese Shift JIS'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701151386661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.TIS-620.D'
,p_message_text=>'Thai TIS-620'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701413656661315)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.US-ASCII.D'
,p_message_text=>'US-ASCII'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701554189661315)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.UTF-16BE.D'
,p_message_text=>'Unicode UTF-16 Big Endian'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701631366661315)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.UTF-16LE.D'
,p_message_text=>'Unicode UTF-16 Little Endian'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701775240661315)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.UTF-8.D'
,p_message_text=>'Unicode UTF-8'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700043169661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.WINDOWS-1250.D'
,p_message_text=>'Eastern European Windows 1250'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699847045661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.WINDOWS-1251.D'
,p_message_text=>'Cyrilic Windows 1251'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702054083661315)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.WINDOWS-1252.D'
,p_message_text=>'Western European Windows 1252'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700206322661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.WINDOWS-1253.D'
,p_message_text=>'Greek Windows 1253'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701317392661315)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.WINDOWS-1254.D'
,p_message_text=>'Turkish Windows 1254'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700430845661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.WINDOWS-1255.D'
,p_message_text=>'Hebrew Windows 1255'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699242823661313)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.WINDOWS-1256.D'
,p_message_text=>'Arabic Windows 1256'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242700986138661314)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.WINDOWS-1257.D'
,p_message_text=>'Northern European Windows 1257'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242701834425661315)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.LOV.WINDOWS-1258.D'
,p_message_text=>'Vietnamese Windows 1258'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242699027136661312)
,p_name=>'PE.PROPERTY.I18N_IANA_CHARSET_ENCODING.PROMPT'
,p_message_text=>'Encoding'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676057983661290)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AF.D'
,p_message_text=>'Afrikaans (af)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677681305661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-AE.D'
,p_message_text=>'Arabic (U.A.E.) (ar-ae)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676365779661290)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-BH.D'
,p_message_text=>'Arabic (Bahrain) (ar-bh)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676268376661290)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-DZ.D'
,p_message_text=>'Arabic (Algeria) (ar-dz)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676416124661290)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-EG.D'
,p_message_text=>'Arabic (Egypt) (ar-eg)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676529634661290)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-IQ.D'
,p_message_text=>'Arabic (Iraq) (ar-iq)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676609857661290)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-JO.D'
,p_message_text=>'Arabic (Jordan) (ar-jo)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676764745661290)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-KW.D'
,p_message_text=>'Arabic (Kuwait) (ar-kw)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676851780661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-LB.D'
,p_message_text=>'Arabic (Lebanon) (ar-lb)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676955860661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-LY.D'
,p_message_text=>'Arabic (Libya) (ar-ly)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677013365661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-MA.D'
,p_message_text=>'Arabic (Morocco) (ar-ma)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677170996661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-OM.D'
,p_message_text=>'Arabic (Oman) (ar-om)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677292933661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-QA.D'
,p_message_text=>'Arabic (Qatar) (ar-qa)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677352897661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-SA.D'
,p_message_text=>'Arabic (Saudi Arabia) (ar-sa)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677477962661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-SY.D'
,p_message_text=>'Arabic (Syria) (ar-sy)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677533431661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-TN.D'
,p_message_text=>'Arabic (Tunisia) (ar-tn)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677761757661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR-YE.D'
,p_message_text=>'Arabic (Yemen) (ar-ye)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677871360661291)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AR.D'
,p_message_text=>'Arabic (ar)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678079599661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AS.D'
,p_message_text=>'Assamese (as)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678162902661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.AZ.D'
,p_message_text=>'Azerbaijani (az)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678335495661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.BE.D'
,p_message_text=>'Belarusian (be)'
,p_version_scn=>37166067046410
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678538806661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.BG.D'
,p_message_text=>'Bulgarian (bg)'
,p_version_scn=>37166067046410
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678445381661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.BN.D'
,p_message_text=>'Bengali (bn)'
,p_version_scn=>37166067046410
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678668770661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.CA.D'
,p_message_text=>'Catalan (ca)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679498790661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.CS.D'
,p_message_text=>'Czech (cs)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689716144661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.CY.D'
,p_message_text=>'Welsh (cy)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679511006661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.DA.D'
,p_message_text=>'Danish (da)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682498838661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.DE-AT.D'
,p_message_text=>'German (Austria) (de-at)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682817614661297)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.DE-CH.D'
,p_message_text=>'German (Switzerland) (de-ch)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682602105661296)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.DE-LI.D'
,p_message_text=>'German (Liechtenstein) (de-li)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682729082661297)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.DE-LU.D'
,p_message_text=>'German (Luxemgourg) (de-lu)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682522849661296)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.DE.D'
,p_message_text=>'German (Germany) (de)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682944125661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EL.D'
,p_message_text=>'Greek (el)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679829039661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-AU.D'
,p_message_text=>'English (Australia) (en-au)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679916052661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-BZ.D'
,p_message_text=>'English (Belize) (en-bz)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680015329661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-CA.D'
,p_message_text=>'English (Canada) (en-ca)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680765179661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-GB.D'
,p_message_text=>'English (United Kingdom) (en-gb)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680119659661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-IE.D'
,p_message_text=>'English (Ireland) (en-ie)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680247523661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-JM.D'
,p_message_text=>'English (Jamaica) (en-jm)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680374834661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-NZ.D'
,p_message_text=>'English (New Zealand) (en-nz)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680421164661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-PH.D'
,p_message_text=>'English (Philippines) (en-ph)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680691763661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-TT.D'
,p_message_text=>'English (Trinidad) (en-tt)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680816108661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-US.D'
,p_message_text=>'English (United States) (en-us)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680559454661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-ZA.D'
,p_message_text=>'English (South Africa) (en-za)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242680984027661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN-ZW.D'
,p_message_text=>'English (Zimbabwe) (en-zw)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681080181661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EN.D'
,p_message_text=>'English (en)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686617663661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-AR.D'
,p_message_text=>'Spanish (Argentina) (es-ar)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686771520661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-BO.D'
,p_message_text=>'Spanish (Bolivia) (es-bo)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686897708661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-CL.D'
,p_message_text=>'Spanish (Chile) (es-cl)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686984563661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-CO.D'
,p_message_text=>'Spanish (Colombia) (es-co)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687058935661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-CR.D'
,p_message_text=>'Spanish (Costa Rica) (es-cr)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687184298661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-DO.D'
,p_message_text=>'Spanish (Dominican Republic) (es-do)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687273724661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-EC.D'
,p_message_text=>'Spanish (Ecuador) (es-ec)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687414789661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-GT.D'
,p_message_text=>'Spanish (Guatemala) (es-gt)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687596259661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-HN.D'
,p_message_text=>'Spanish (Honduras) (es-hn)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687606234661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-MX.D'
,p_message_text=>'Spanish (Mexico) (es-mx)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687735579661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-NI.D'
,p_message_text=>'Spanish (Nicaragua) (es-ni)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687898162661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-PA.D'
,p_message_text=>'Spanish (Panama) (es-pa)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688086937661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-PE.D'
,p_message_text=>'Spanish (Peru) (es-pe)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688144317661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-PR.D'
,p_message_text=>'Spanish (Puerto Rico) (es-pr)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687921376661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-PY.D'
,p_message_text=>'Spanish (Paraguay) (es-py)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242687306639661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-SV.D'
,p_message_text=>'Spanish (El Salvador) (es-sv)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688334458661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-US.D'
,p_message_text=>'Spanish (United States) (es-us)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688475925661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-UY.D'
,p_message_text=>'Spanish (Uruguay) (es-uy)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688568068661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES-VE.D'
,p_message_text=>'Spanish (Venezuela) (es-ve)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688237951661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ES.D'
,p_message_text=>'Spanish (Traditional Sort) (es)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681129417661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ET.D'
,p_message_text=>'Estonian (et)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678267053661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.EU.D'
,p_message_text=>'Basque (eu)'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681483048661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.FA.D'
,p_message_text=>'Farsi (fa)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681575935661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.FI.D'
,p_message_text=>'Finnish (fi)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681368790661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.FO.D'
,p_message_text=>'Faeroese (fo)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681631104661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.FR-BE.D'
,p_message_text=>'French (Belgium) (fr-be)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681706512661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.FR-CA.D'
,p_message_text=>'French (Canada) (fr-ca)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682192281661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.FR-CH.D'
,p_message_text=>'French (Switzerland) (fr-ch)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681975661661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.FR-LU.D'
,p_message_text=>'French (Luxembourg) (fr-lu)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682029739661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.FR-MC.D'
,p_message_text=>'French (Monaco) (fr-mc)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681830557661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.FR.D'
,p_message_text=>'French (France) (fr)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683695227661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.GA.D'
,p_message_text=>'Irish (ga)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682228435661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.GD.D'
,p_message_text=>'Gaelic (gd)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242682318381661295)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.GL.D'
,p_message_text=>'Galician (gl)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683089323661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.GU.D'
,p_message_text=>'Gujarati (gu)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683133372661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.HE.D'
,p_message_text=>'Hebrew (he)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683278958661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.HI.D'
,p_message_text=>'Hindi (hi)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679306226661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.HR.D'
,p_message_text=>'Croatian (hr)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683391353661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.HU.D'
,p_message_text=>'Hungarian (hu)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242677959826661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.HY.D'
,p_message_text=>'Armenian'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683545627661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ID.D'
,p_message_text=>'Indonesian (id)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683434186661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.IS.D'
,p_message_text=>'Icelandic (is)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683884059661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.IT-CH.D'
,p_message_text=>'Italian (Switzerland) (it-ch)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683723796661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.IT.D'
,p_message_text=>'Italian (Italy) (it)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242683958244661298)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.JA.D'
,p_message_text=>'Japanese (ja)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684134027661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.KK.D'
,p_message_text=>'Kazakh (kk)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684068887661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.KN.D'
,p_message_text=>'Kannada (kn)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684331450661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.KO.D'
,p_message_text=>'Korean (ko)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684256722661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.KOK.D'
,p_message_text=>'Konkani (kok)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684483843661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.KZ.D'
,p_message_text=>'Kyrgyz (kz)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684686628661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.LT.D'
,p_message_text=>'Lithuanian (lt)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684513184661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.LV.D'
,p_message_text=>'Latvian (lv)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242681248899661294)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.MK.D'
,p_message_text=>'FYRO Macedonian (mk)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684895797661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ML.D'
,p_message_text=>'Malayalam (ml)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685073215661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.MR.D'
,p_message_text=>'Marathi (mr)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684769894661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.MS.D'
,p_message_text=>'Malay (Malaysia) (ms)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242684939028661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.MT.D'
,p_message_text=>'Maltese (mt)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685239193661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.NB-NO.D'
,p_message_text=>'Norwegian (Bokmal) (nb-no)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685102790661299)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.NE.D'
,p_message_text=>'Nepali (India) (ne)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679678509661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.NL-BE.D'
,p_message_text=>'Dutch (Belgium) (nl-be)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679769617661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.NL.D'
,p_message_text=>'Dutch (Netherlands) (nl)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685483608661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.NN-NO.D'
,p_message_text=>'Norwegian (Nynorsk) (nn-no)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685362138661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.NO.D'
,p_message_text=>'Norwegian (Bokmal) (no)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685508403661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.OR.D'
,p_message_text=>'Oriya (or)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685926173661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.PA.D'
,p_message_text=>'Punjabi (pa)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685634462661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.PL.D'
,p_message_text=>'Polish (pl)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685745741661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.PT-BR.D'
,p_message_text=>'Portuguese (Brazil) (pt-br)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242685874276661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.PT.D'
,p_message_text=>'Portuguese (Portugal) (pt)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686097854661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.RO.D'
,p_message_text=>'Romanian (ro)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686180456661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.RU-MD.D'
,p_message_text=>'Russian (Moldova) (ru-md)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686229779661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.RU.D'
,p_message_text=>'Russian (ru)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686417349661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.SK.D'
,p_message_text=>'Slovak (sk)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686560712661301)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.SL.D'
,p_message_text=>'Slovenian (sl)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242676131660661290)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.SQ.D'
,p_message_text=>'Albanian'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242686336828661300)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.SR.D'
,p_message_text=>'Serbian (sr)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688790856661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.SV-FI.D'
,p_message_text=>'Swedish (Finland) (sv-fi)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688875610661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.SV.D'
,p_message_text=>'Swedish (sv)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688633194661302)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.SW.D'
,p_message_text=>'Swahili (sw)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242688923745661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.TA.D'
,p_message_text=>'Tamil (ta)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689099833661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.TE.D'
,p_message_text=>'Telugu (te)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689179261661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.TH.D'
,p_message_text=>'Thai (th)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689258258661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.TR.D'
,p_message_text=>'Turkish (tr)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689323239661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.UK.D'
,p_message_text=>'Ukrainian (uk)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689492917661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.UR.D'
,p_message_text=>'Urdu (ur)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689570435661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.UZ.D'
,p_message_text=>'Uzbek (uz)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689682951661303)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.VI.D'
,p_message_text=>'Vietnamese (vi)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678712132661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ZH-CN.D'
,p_message_text=>'Chinese (China) (zh-cn)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678845585661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ZH-HK.D'
,p_message_text=>'Chinese (Hong Kong SAR) (zh-hk)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242678950309661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ZH-MO.D'
,p_message_text=>'Chinese (Macau SAR) (zh-mo)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679060488661292)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ZH-SG.D'
,p_message_text=>'Chinese (Singapore) (zh-sg)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679144691661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ZH-TW.D'
,p_message_text=>'Chinese (Taiwan) (zh-tw)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242679273814661293)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.LOV.ZH.D'
,p_message_text=>'Chinese (zh)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675997666661290)
,p_name=>'PE.PROPERTY.I18N_LANGUAGE.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937988528296789)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_text=>'Select the column that returns the BLOB for the icon image source.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937878237296789)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_text=>'Image Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937716111296789)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_text=>'Select the column to be used as icon image source.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937671926296789)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_text=>'Icon Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697358722661311)
,p_name=>'PE.PROPERTY.ICON_COLUMN_NAME.PROMPT'
,p_message_text=>'Icon'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509573938670642)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to use to identify this facet. You may add multiple classes by separating them with spaces.</p>',
'            <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509649434670640)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to use to identify this facet. You may add multiple classes by separating them with spaces.</p>',
'            <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509783130670639)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to use to identify this facet. You may add multiple classes by separating them with spaces.</p>',
'            <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656819062397941424)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to add to the component. You may add multiple classes by separating them with spaces.</p>',
'        <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>',
'        <p>Note: This icon will be displayed inside of the item, not as part of the label.</p>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656818904378941390)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to add to the component. You may add multiple classes by separating them with spaces.</p>',
'        <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>',
'        <p>Note: This icon will be displayed inside of the item, not as part of the label.</p>'))
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509901781670637)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to use to identify this filter. You may add multiple classes by separating them with spaces.</p>',
'            <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136510801426670633)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to use to identify this filter. You may add multiple classes by separating them with spaces.</p>',
'            <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136511262214670632)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to use to identify this filter. You may add multiple classes by separating them with spaces.</p>',
'            <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586665819957925835)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Show an arrow pointing right</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586665759686925835)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to add to the component. You may add multiple classes by separating them with spaces.</p>',
'        <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(586665616958925835)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_text=>'Icon'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604810328784562)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.COMPONENT_PROPERTY.CARD.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The icon description serves as a vital accessibility feature by providing contextual information about an icon when it receives focus or is hovered over. This feature enhances user understanding and interaction with the interface.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Clear and Concise:</strong> Icon descriptions should be clear and succinct, providing users with a brief but informative understanding of the icon''s function or purpose.</li>',
'<li><strong>Descriptive Language:</strong> Use descriptive language that accurately conveys the meaning or action associated with the icon. Avoid ambiguous or vague descriptions that may confuse users.</li>',
'<li><strong>Determining Alt Text Need:</strong>',
'Evaluate whether the absence of the icon would impact page comprehension.',
'If the page would lose meaning without the icon, add alt text.</li>',
'</ol>'))
,p_version_scn=>36587345
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939449767296796)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_text=>'This text describes the icon and may used for tooltips and alterative text for images.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939348827296796)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_text=>'Icon Description'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638714774500672)
,p_name=>'PE.PROPERTY.ICON_HEIGHT.PROMPT'
,p_message_text=>'Height'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938188121296789)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_text=>'Enter the URL for the icon image source.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938038261296789)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_text=>'Image URL'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938671482296790)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_text=>'Determines the position of the icon in the card header.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939128144296796)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_text=>'End'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939240598296796)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_text=>'Aligns the icon to the end position (typically to the right side) of the header.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938992565296796)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_text=>'Start'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596939058718296796)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_text=>'Aligns the icon to the starting position (typically to the left side) of the header.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938703100296796)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_text=>'Top'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938842450296796)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_text=>'Displays the icon at the top of the header.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596938553644296790)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_text=>'Icon Position'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596948085864296956)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_text=>'No Icon'
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311556816300802)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.SEARCH_CONFIG.NULL_TEXT'
,p_message_text=>'No Icon'
,p_version_scn=>37166067046534
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937066005296788)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_text=>'Select the icon source for the icon that is displayed in the header of the card component.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937566686296789)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_text=>'Image BLOB Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937308633296788)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_text=>'Icon Class Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937121816296788)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_text=>'Initials'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937210471296788)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_text=>'Icon Class'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596937466463296789)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_text=>'Image URL'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936916482296788)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_text=>'Icon Source'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126956206590511164)
,p_name=>'PE.PROPERTY.ICON_URL.HELP'
,p_message_text=>'Identifies the icon URL.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126956126748511164)
,p_name=>'PE.PROPERTY.ICON_URL.PROMPT'
,p_message_text=>'Icon URL'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245978740345481131)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&ENAME.&lt;/a&gt;',
'</pre>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245978664385481131)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the custom column HTML for the Icon View.</p>',
'<p>The following substitution strings are available:',
'<ul>',
'<li><code>&&lt;COLUMN_NAME&gt;.</code> - substitution strings for column names.</li>',
'<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - substitution strings for column labels.</li>',
'<li><code>&APEX$ROW_ID.</code> - the record identifier for the row.</li>',
'<li><code>&APEX$ROW_INDEX.</code> - the record display sequence number.</li>',
'<li><code>&APEX$ROW_URL.</code> - reference the specified Link Target.</li>',
'<li><code>&APEX$ROW_STATE_CLASSES.</code> - the record state such as <code>is-inserted</code> or <code>is-deleted</code>.</li>',
'</ul>',
'</p>'))
,p_version_scn=>15114749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245978520404481130)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_text=>'Custom Icon'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783365851751551)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876932737183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_text=>'Enter the column link for the Icon View. Use <code>#COLUMN_NAME#</code> substitution strings for column names as required.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876800108183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_text=>'Custom Link'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245991288931481464)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_text=>'Specify whether the Icon View is enabled. Selecting <strong>On</strong> adds a View Icons icon to the Search bar for interactive reports, or to the interactive grid View button, enabling users to access this view.'
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360874214179183858)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_text=>'Specify whether the Icon View is enabled. Selecting <strong>On</strong> adds a View Icons icon to the Search bar for interactive reports, or to the interactive grid View button, enabling users to access this view.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360874119907183858)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601617861784525)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.COMPONENT_PROPERTY.IR_ATTRIBUTES.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Alt text communicates the information conveyed by icons to users of assistive technology, ensuring website accessibility.<p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Determining Alt Text Need:</strong>',
'Evaluate whether the absence of the icon would impact page comprehension.',
'If the page would lose meaning without the icon, add alt text.</li>',
'<li><strong>Considerations for Text:</strong>',
'Assess the presence of adjacent text and its relevance to the icon''s purpose.</li>',
'',
'<li><strong>Recommendations:</strong>',
'<ul>',
'<li>Including text with icons enhances the clickable/touchable area for links or buttons.</li>',
'<li>Adding alt text to stand-alone icons without visible adjacent text ensures accessibility for all users.</li>',
'<li>Utilize consistent, clear and understandable icons</li>',
'</ul>',
'</li>',
'</ol>'))
,p_version_scn=>36587301
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876530693183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_text=>'Enter the HTML ALT text for the image.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876419418183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_text=>'HTML ALT Text'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876729162183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_text=>'Enter the HTML TITLE tag for the image.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876602545183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_text=>'HTML TITLE Text'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602032330784527)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.COMPONENT_PROPERTY.IG_ATTRIBUTES.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To ensure accessibility, it''s crucial to define icon attributes correctly. These attributes, such as the ALT text, play a vital role in providing context and functionality for users who rely on screen readers or have visual impairments.</p>',
'<ul>',
'<li><strong>Recommendations:</strong>',
'<ul>',
'<li>Including text with icons enhances the clickable/touchable area for links or buttons.</li>',
'<li>We also recommend adding alt="" if the intention is for the image to be ignored by screen readers.</li>',
'<li>Include descriptive ALT text: Provide concise yet informative descriptions of icons to convey their meaning and purpose to users who cannot see them.</li>',
'</ul>',
'</li>',
'</ul>'))
,p_version_scn=>36587306
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245980043492481143)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_text=>'Enter the icon image attributes used for the HTML IMG tag.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245979979897481142)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_text=>'Icon Attributes'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245979477435481136)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_text=>'Select the interactive grid column that returns the BLOB for the icon image source.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245979357515481133)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_text=>'Image Column'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245979820107481141)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_text=>'Select the interactive grid column that returns the CSS classes for the icon image source.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245979731082481141)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_text=>'Icon'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245978954923481132)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_text=>'Select the column type that holds the icon image source.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245979270773481133)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_text=>'Icon CSS Classes'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245979168011481132)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_text=>'Image in URL'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245978810784481131)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_text=>'Icon Type'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245979604188481139)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_text=>'Select the interactive grid column that returns the URL for the icon image source.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245979576258481138)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_text=>'Icon URL'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876320289183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_text=>'Enter the image attributes used for the HTML IMG tag.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876210499183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_text=>'Image Attributes'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783100289751550)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examine the <code>IMAGE</code> column</dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360875930948183859)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_text=>'Select the report column that returns the image source.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360875816232183859)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_text=>'Image Source Column'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783274480751550)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examine the <code>ENAME</code> column</dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876121559183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_text=>'Select the report column that returns the image label.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360876027616183860)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_text=>'Label Column'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234379202540129747)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examine the <code>ENAME</code> column</dt>',
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234379153938129746)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_text=>'Select the report column that returns the image label.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234379034848129746)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_text=>'Label Column'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245980421121481144)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_text=>'Enter HTML attributes that are associated with the display of each <strong>Link Target</strong>.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245980369215481144)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_text=>'Link Attributes'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783080103751549)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examine the <code>LINK</code> column</dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360875722600183859)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_text=>'Select the report column that returns the link target of the icon.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360875617299183859)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_text=>'Link Column'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638803502500672)
,p_name=>'PE.PROPERTY.ICON_WIDTH.PROMPT'
,p_message_text=>'Width'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639092746500672)
,p_name=>'PE.PROPERTY.IDENTIFICATION_DISPLAY_SEQUENCE.PROMPT'
,p_message_text=>'Sequence'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714173144661326)
,p_name=>'PE.PROPERTY.IDENTIFICATION_STATIC_ID.PROMPT'
,p_message_text=>'Static ID'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629589972500666)
,p_name=>'PE.PROPERTY.IDENTIFIER.PROMPT'
,p_message_text=>'Identifier'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116960035494909848)
,p_name=>'PE.PROPERTY.IDENTITY_TYPE.HELP'
,p_message_text=>'Specify the identity type of the participant.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116959719092909847)
,p_name=>'PE.PROPERTY.IDENTITY_TYPE.PROMPT'
,p_message_text=>'Identity Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35135379704835727)
,p_name=>'PE.PROPERTY.IGNORE_OUTPUT.COMPONENT_PROPERTY.PAGE_PROCESS_WS_PARAM.HELP'
,p_message_text=>'Specify whether the returning value of an IN OUT or OUT parameter should be ignored.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192750341982624)
,p_name=>'PE.PROPERTY.IGNORE_OUTPUT.HELP'
,p_message_text=>'Specify whether the parameters IN OUT, OUT or function result should be ignored.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130192633435982624)
,p_name=>'PE.PROPERTY.IGNORE_OUTPUT.PROMPT'
,p_message_text=>'Ignore Output'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106687117276418)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG_SQL.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106947139276419)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG_SQL.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106863823276419)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG_SQL.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106726404276419)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG_SQL.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107049131276419)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG_SQL.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106526708276418)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG_SQL.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600287756407090644)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a Java function body that returns an SQL Query to populate this list of values.</p>',
'<p>The SQL Query only needs to return one column. If the query returns multiple columns, only the first column is used in the filter search.</p>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600287693699090644)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Java Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610957377484652)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display department name, set department number</dt>',
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600287435000090644)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a JavaScript function body that returns an SQL Query to populate this list of values.</p>',
'<p>The SQL Query only needs to return one column. If the query returns multiple columns, only the first column is used in the filter search.</p>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600287380017090644)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'JavaScript Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610899813484651)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>To return the department name:</dt>',
'<dd><pre>',
'begin',
'    return ''select dname as d from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600287118533090640)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL function body that returns an SQL Query to populate this list of values.</p>',
'<p>The SQL Query only needs to return one column. If the query returns multiple columns, only the first column is used in the filter search.</p>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600287084371090640)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'PL/SQL Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600287972162090644)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a Python function body that returns an SQL Query to populate this list of values.</p>',
'<p>The SQL Query only needs to return one column. If the query returns multiple columns, only the first column is used in the filter search.</p>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600287857208090644)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Python Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985963504481163)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_text=>'<pre>Cow,Dog,Cat,Lion</pre>'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985888670481162)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a comma delimited list of values for this static list.</p>',
'        <p>Note - the Static Values will always be displayed in the same order they are specified, not alphabetically.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245985706819481162)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981266189481147)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the group for this column. Groups are used to associate columns together in the grid and Single Row View.',
'        <p>Note - Groups are added by expanding the Attributes folder within the Rendering tree, and right-clicking on Column Groups to create a new group.</p>'))
,p_version_scn=>15114749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981106426481146)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_text=>'Group'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977760155481128)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_text=>'<p>Check which download formats users can utilize to download the currently displayed columns.</p>'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977877589481128)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_text=>'CSV'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977978077481128)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_text=>'HTML'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381448677833863434)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_text=>'PDF'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5680236833352966)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_text=>'Excel'
,p_is_js_message=>true
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977664545481127)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_text=>'Formats'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245980270249481144)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_text=>'Click the Link Target to invoke a modal dialog. You can enter a custom target to be called when the icon is clicked.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245980117688481143)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_text=>'Link Target'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1496923200542680397)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_text=>'Interactive Grid Region'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596146697843278259)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_text=>'Enter an alias for this saved report. Use this alias to define a more meaningful URL link to this specific saved report. This link can be used to link directly from elsewhere in the application.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596144306039250725)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_text=>'Alias'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596147069247299741)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_text=>'View the saved report category, which dictates where this report displays within the Reports select List. This attribute is view only and cannot be updated.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596144791469254589)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_text=>'Alternative'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596146012306270042)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_text=>'Subsequent report layouts saved by developers, that end users can select.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596144539502253022)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_text=>'Primary'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596145898931268735)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_text=>'Report saved by developers, that is displayed by default.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596145157780257112)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_text=>'Private'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596146457856272920)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_text=>'Report layouts saved by end users, that only the end user who saved it can select.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596144948808255757)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_text=>'Public'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596146295898271257)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_text=>'Report layouts saved by end users, that all other end users can select.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596144161896247063)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_text=>'Visibility'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981450660481147)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_text=>'Select where the group is used to display this column.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981509643481148)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_text=>'Both'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981674103481148)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_text=>'The group will display in both the report heading and in the Single Row view.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981921391481149)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_text=>'Heading'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245982097124481149)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_text=>'The group will only display in the report heading.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981758850481148)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_text=>'Single Row View'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981881737481149)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_text=>'The group will only display in the Single Row View.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245981373644481147)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_text=>'Use Group For'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602554331784533)
,p_name=>'PE.PROPERTY.IMAGE_ALT_ATTRIBUTE.COMPONENT_PROPERTY.CLASSIC_NAV_BAR.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Alternative Text, serves as a crucial element to enhance accessibility for users with visual impairments. It provides a textual description of images within documents or webpages, offering insights into their significance in relation to the conten'
||'t.</p>',
'<strong>Best practices:</strong>',
'<ol>',
'<li>Purposeful Description:',
'<ul>',
'<li>Alt Text should succinctly convey the significance of the image in relation to the surrounding content.</li>',
'<li>Focus on describing the "why" of the image rather than stating what the image is.</li>',
'<li>Keep Alt Text clear, concise, and descriptive.</li>',
'</ul>',
'</li>',
'<strong>Example:</strong>',
'<p>"Team celebrating with high-fives and smiles after successfully completing a challenging project."</p>',
'In this example, the alt text emphasizes the reason behind the image, which is the successful completion of a challenging project and the resulting celebration among team members. This description provides context and insight into the significance of'
||' the image for users who cannot see it directly.',
'<li>Informative Images:',
'Identify images that contribute to the comprehension or context of the webpage.',
'If removing the image would diminish the page''s meaning or significance, it requires Alt Text.</li>',
'<li>Avoid Redundancy:',
'Omit phrases like "image of" as screen readers automatically announce an image as such.</li>',
'</ol>'))
,p_version_scn=>12189408
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694769920661308)
,p_name=>'PE.PROPERTY.IMAGE_ALT_ATTRIBUTE.PROMPT'
,p_message_text=>'Alt Attribute'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602676333784534)
,p_name=>'PE.PROPERTY.IMAGE_ATTRIBUTES.COMPONENT_PROPERTY.LIST_ENTRY.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Alternative Text, serves as a crucial element to enhance accessibility for users with visual impairments. It provides a textual description of images within documents or webpages, offering insights into their significance in relation to the conten'
||'t.</p>',
'<strong>Best practices:</strong>',
'<ol>',
'<li>Purposeful Description:',
'<ul>',
'<li>Alt Text should succinctly convey the significance of the image in relation to the surrounding content.</li>',
'<li>Focus on describing the "why" of the image rather than stating what the image is.</li>',
'<li>Keep Alt Text clear, concise, and descriptive.</li>',
'</ul>',
'</li>',
'<strong>Example:</strong>',
'<p>"Team celebrating with high-fives and smiles after successfully completing a challenging project."</p>',
'In this example, the alt text emphasizes the reason behind the image, which is the successful completion of a challenging project and the resulting celebration among team members. This description provides context and insight into the significance of'
||' the image for users who cannot see it directly.',
'<li>Informative Images:',
'Identify images that contribute to the comprehension or context of the webpage.',
'If removing the image would diminish the page''s meaning or significance, it requires Alt Text.</li>',
'<li>Avoid Redundancy:',
'Omit phrases like "image of" as screen readers automatically announce an image as such.</li>',
'</ol>'))
,p_version_scn=>12189408
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694670232661308)
,p_name=>'PE.PROPERTY.IMAGE_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1742373852820324)
,p_name=>'PE.PROPERTY.IMAGE_DESCRIPTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Image Description property serves as a vital component in improving accessibility for users with visual impairments. It enables the provision of text or a reference to a column containing text to describe the image.  It is important to define '
||'descriptions for images that can be displayed as part of reports, such as in Classic or Interactive Reports, to improve usability for users of assistive technologies, such as screen readers.</p>',
'<strong>Best practices:</strong>',
'<ol>',
'<li>Informative Images:',
'Identify images that contribute to the comprehension or context of the webpage. If removing the image would diminish the page''s meaning or significance, it requires the image description. If removing the image would not diminish the page''s meaning (f'
||'or example if it was just decorative), then leave the image description blank and it will be ignored by screen readers.</li>',
'<li>Purposeful Description:',
'<ul>',
'<li>Alt Text should succinctly convey the significance of the image in relation to the surrounding content.</li>',
'<li>Focus on describing the "why" of the image rather than stating what the image is.</li>',
'<li>Keep Alt Text clear, concise, and descriptive.</li>',
'</ul>',
'</li>',
'<strong>Example:</strong>',
'<p>"Stylish pink tote bag with faux leather straps, perfect for adding a pop of color to your outfit".</p>',
'<li>Avoid Redundancy:',
'Omit phrases like "image of" as screen readers automatically announce an image as such.</li>',
'</ol>'))
,p_version_scn=>131857692
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1742202777820308)
,p_name=>'PE.PROPERTY.IMAGE_DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Image Description property serves as a vital component in improving accessibility for users with visual impairments. It enables the provision of text or a reference to a column containing text to describe the image.  It is important to define '
||'descriptions for images that can be displayed as part of reports, such as in Classic or Interactive Reports, to improve usability for users of assistive technologies, such as screen readers.</p>',
'<strong>Best practices:</strong>',
'<ol>',
'<li>Informative Images:',
'Identify images that contribute to the comprehension or context of the webpage. If removing the image would diminish the page''s meaning or significance, it requires the image description. If removing the image would not diminish the page''s meaning (f'
||'or example if it was just decorative), then leave the image description blank and it will be ignored by screen readers.</li>',
'<li>Purposeful Description:',
'<ul>',
'<li>Alt Text should succinctly convey the significance of the image in relation to the surrounding content.</li>',
'<li>Focus on describing the "why" of the image rather than stating what the image is.</li>',
'<li>Keep Alt Text clear, concise, and descriptive.</li>',
'</ul>',
'</li>',
'<strong>Example:</strong>',
'<p>"Stylish pink tote bag with faux leather straps, perfect for adding a pop of color to your outfit".</p>',
'<li>Avoid Redundancy:',
'Omit phrases like "image of" as screen readers automatically announce an image as such.</li>',
'</ol>'))
,p_version_scn=>131857685
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1742449580820325)
,p_name=>'PE.PROPERTY.IMAGE_DESCRIPTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Image Description property serves as a vital component in improving accessibility for users with visual impairments. It enables the provision of text or a reference to a column containing text to describe the image.  It is important to define '
||'descriptions for images that can be displayed as part of reports, such as in Classic or Interactive Reports, to improve usability for users of assistive technologies, such as screen readers.</p>',
'<strong>Best practices:</strong>',
'<ol>',
'<li>Informative Images:',
'Identify images that contribute to the comprehension or context of the webpage. If removing the image would diminish the page''s meaning or significance, it requires the image description. If removing the image would not diminish the page''s meaning (f'
||'or example if it was just decorative), then leave the image description blank and it will be ignored by screen readers.</li>',
'<li>Purposeful Description:',
'<ul>',
'<li>Alt Text should succinctly convey the significance of the image in relation to the surrounding content.</li>',
'<li>Focus on describing the "why" of the image rather than stating what the image is.</li>',
'<li>Keep Alt Text clear, concise, and descriptive.</li>',
'</ul>',
'</li>',
'<strong>Example:</strong>',
'<p>"Stylish pink tote bag with faux leather straps, perfect for adding a pop of color to your outfit".</p>',
'<li>Avoid Redundancy:',
'Omit phrases like "image of" as screen readers automatically announce an image as such.</li>',
'</ol>'))
,p_version_scn=>131857693
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2226894709217290)
,p_name=>'PE.PROPERTY.IMAGE_DESCRIPTION.HELP'
,p_message_text=>'Provide text, or a reference to a column containing the text to describe the image. This will be used as alternative text for the image and be rendered with the <alt> tag. If no Image Description is provided, then the <alt> tag with double quote will'
||' be rendered.'
,p_version_scn=>131783761
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2226713308217290)
,p_name=>'PE.PROPERTY.IMAGE_DESCRIPTION.PROMPT'
,p_message_text=>'Image Description'
,p_version_scn=>110692816
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690521582661305)
,p_name=>'PE.PROPERTY.IMAGE_DIRECTORY.PROMPT'
,p_message_text=>'Image Directory'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694507709661308)
,p_name=>'PE.PROPERTY.IMAGE_ICON_CSS_CLASSES.PROMPT'
,p_message_text=>'Image/Icon CSS Classes'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150993721537822717)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_text=>'<p>Enter custom region image attributes to be included in the image HTML. This can be used for attributes such as height or width.</p>'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150993631288822716)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_text=>'Image Tag Attributes'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625620682500663)
,p_name=>'PE.PROPERTY.INCLUDE_COLUMNS_IN_ITEMS_PICKER.PROMPT'
,p_message_text=>'Include Columns in Items Picker'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380453205717584107)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_text=>'Specify whether this column is included when the report is exported to CSV or printed.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380453126200584107)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_text=>'Include In Export / Print'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749199448661391)
,p_name=>'PE.PROPERTY.INCLUDE_JQUERY_MIGRATE.PROMPT'
,p_message_text=>'Include jQuery Migrate'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749065571661391)
,p_name=>'PE.PROPERTY.INCLUDE_LEGACY_JAVASCRIPT.LOV.18.D'
,p_message_text=>'18.x'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748992847661391)
,p_name=>'PE.PROPERTY.INCLUDE_LEGACY_JAVASCRIPT.LOV.PRE18.D'
,p_message_text=>'Pre 18.1'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748896236661391)
,p_name=>'PE.PROPERTY.INCLUDE_LEGACY_JAVASCRIPT.PROMPT'
,p_message_text=>'Include Deprecated or Desupported Javascript Functions'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945736409730064099)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_text=>'Specify whether the list of values includes a NULL option at the top of the list.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945736343903064099)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_text=>'Include Null Option'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(238492256204632551)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_text=>'Specify whether the pseudo column ROWID should be selected.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(238492171664632549)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_text=>'Include ROWID Column'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360865620889183848)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A search bar is displayed above the report.  If you include the search bar, you can also fully customize which functions to display.</p>',
'The search bar can include the following components:',
'<dl>',
'  <dt>Search Field</dt>',
'    <dd>Displays a text field in the search bar used to enter search criteria.</dd>',
'  <dt>Finder Drop Down</dt>',
'    <dd>Embedded within the <em>Search Field</em>, displays a drop down list of displayed columns. If a column is selected then the search is only performed against the values in the selected column.</dd>',
'  <dt>Reports Select List</dt>',
'    <dd>Displays a list of all available reports for the user, including primary, alternate, public and private reports. This list is only displayed if a report, other than the primary report, is accessible to the user.</dd>',
'  <dt>Rows Per Page Selector</dt>',
'    <dd>Displays a select list used to select the number of rows to display per page.</dd>',
'  <dt>Actions Menu</dt>',
'    <dd>Displays the Actions menu button, which generally includes a comprehensive set of options. These options enables the end user to customize the report based upon the functions you make available.</dd>',
'</dl>'))
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360865526508183848)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_text=>'Include Search Bar'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690800388661305)
,p_name=>'PE.PROPERTY.INCLUDE_SESSION_STATE.PROMPT'
,p_message_text=>'Include'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101011906211796)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>&PRODUCT_NAME. typically requires specific JavaScript and CSS files.',
'For some applications, such as mobile applications, you may want to suppress the inclusion of these files on the page.</p>',
'<p>To Include the standard &PRODUCT_NAME. and JavaScript files select <strong>On</strong>. Selecting <strong>Off</strong> suppresses the inclusion of these files in the HTML Header.</p>',
'<p>Suppressing inclusion of these files can have adverse effects on an application and may cause it to break.',
'Therefore, disabling this attribute is only recommended for advanced developers.</p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123100930371211796)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_text=>'Include Standard JavaScript and CSS'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972652972250231)
,p_name=>'PE.PROPERTY.INITIAL_ENTITIES_COUNT.HELP'
,p_message_text=>'Enter the number of entities to display initially. If not specified a default of 40 will be used.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972569860250231)
,p_name=>'PE.PROPERTY.INITIAL_ENTITIES_COUNT.PROMPT'
,p_message_text=>'Initial Entities Count'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601238951364208)
,p_name=>'PE.PROPERTY.INITIATOR_CAN_COMPLETE.HELP'
,p_message_text=>' Specify if the initiator can complete task.'
,p_version_scn=>38668414
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601432503366206)
,p_name=>'PE.PROPERTY.INITIATOR_CAN_COMPLETE.PROMPT'
,p_message_text=>'Initiator Can Complete'
,p_version_scn=>38668478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423494230648851)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_text=>'Pick the column containing the initial map position as a GeoJSON point object.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423342878648851)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_text=>'GeoJSON Column'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423234196648851)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_text=>'Pick the SDO_GEOMETRY column containing the initial map position as a point object.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423132716648851)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_text=>'Geometry Column'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422426287648850)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_text=>'Identifies the column type to use for the initial map position.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422735716648850)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_text=>'GeoJSON'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422849468648851)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_text=>'GeoJSON, as VARCHAR2 or CLOB column types.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422924408648851)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_text=>'Longitude/Latitude'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423093577648851)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_text=>'Longitude and Latitude, as two NUMBER columns.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422582486648850)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_text=>'SDO_GEOMETRY'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422611743648850)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_text=>'Oracle SDO_GEOMETRY type.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422378328648850)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_text=>'Geometry Column Data Type'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764870114594815)
,p_name=>'PE.PROPERTY.INIT_JAVASCRIPT_FUNCTION.COMPONENT_PROPERTY.CARD.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.pagination.showPageLinks = true;',
'    options.modelOptions.pageSize = 200;',
'    return options;',
'}</pre>'))
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764953469594815)
,p_name=>'PE.PROPERTY.INIT_JAVASCRIPT_FUNCTION.COMPONENT_PROPERTY.CARD.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a JavaScript function that takes an options object, modifies the object, and returns it. This allows advanced customization of the region during initialization. See the <code>tableModelView</code> widget JavaScript API documentation for the '
||'available options.</p>',
'<p>',
'Additional options defined by the cards region:',
'</p>',
'<ul>',
'<li>',
'<strong>modelOptions</strong> Options object passed to <code>apex.model.create</code>.</li>',
'</ul>'))
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764219143594726)
,p_name=>'PE.PROPERTY.INIT_JAVASCRIPT_FUNCTION.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.toolbar = false;',
'    return options;',
'}',
'</pre>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764324496594726)
,p_name=>'PE.PROPERTY.INIT_JAVASCRIPT_FUNCTION.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_text=>'Enter a JavaScript function that takes a configuration object for the Interactive Grid, modifies the object, and returns it. This allows advanced customization of the Interactive Grid appearance, features, and behavior including toolbar, menus, and a'
||'ctions.'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764633291594773)
,p_name=>'PE.PROPERTY.INIT_JAVASCRIPT_FUNCTION.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ){',
'    // Setup a callback function which gets called when data is retrieved, it allows to manipulate the series',
'    options.dataFilter = function( data ) {',
'        data.series[ 0 ].color = "#00FF00";',
'        return data;',
'    };',
'    // Set chart initialization options',
'    options.type = "line";',
'    return options;',
'}</pre>'))
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764705470594773)
,p_name=>'PE.PROPERTY.INIT_JAVASCRIPT_FUNCTION.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_text=>'<p>Enter a JavaScript function that takes a configuration object for the chart, modifies the object, and returns it. This allows advanced customization of the chart appearance, features, and behavior.</p>'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764118325594561)
,p_name=>'PE.PROPERTY.INIT_JAVASCRIPT_FUNCTION.HELP'
,p_message_text=>'<p>Enter JavaScript code that can be executed. Note: The exact nature of what this does will depend on the current plug-in.</p>'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69764029891594561)
,p_name=>'PE.PROPERTY.INIT_JAVASCRIPT_FUNCTION.PROMPT'
,p_message_text=>'Initialization JavaScript Function'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421306745648847)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_text=>'<p>Whether to center the map to the current location from the browser. If enabled, and the browser can access the current location, this takes precedence over the initial position determined by Static Values, SQL query or based on Spatial Results, as'
||' configured above.</p><p>This only applies for the first page load within an APEX session. When the map page is revisited in the APEX session, the map will be centered to its last position.</p>'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421292811648847)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_text=>'Get Position From Browser'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423851330648851)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_text=>'Pick the column containing the latitude of the initial map position. The returned value should be between -90 and 90.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423719456648851)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_text=>'Initial Latitude Column'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422029967648850)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_text=>'Specify the latitude of the initial map position. Use values between -90 (South) and 90 (North), and "." as the decimal character. Example: <strong>45.5</strong>.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421992488648850)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_text=>'Latitude'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423601335648851)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_text=>'Pick the column containing the longitude of the initial map position. The returned value should be between -180 and 180.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423502938648851)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_text=>'Initial Longitude Column'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421815963648847)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_text=>'Specify the longitude of the initial map position. Use values between -180 (West) and 180 (East), and "." as the decimal character. Example: <strong>100.5</strong>.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421714799648847)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_text=>'Longitude'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421603502648847)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Query Returning NUMBER columns to determine the initial map position and zoom level:</p>',
'<pre>',
'select -133.5 longitude,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
'<p>Query Returning an SDO_GEOMETRY column to determine the initial map position and a NUMBER column for the zoom level.</p>',
'<pre>',
'select sdo_geometry( 2001,                                 -- 2 dimensional point',
'                     4326,                                 -- longitude/latitude (WGS84)',
'                     sdo_point_type( -133.5, 35.2, null ), -- concrete coordinates',
'                     null,                                 -- not used for points',
'                     null                                  -- not used for points',
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421540019648847)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_text=>'Enter the SQL Query to determine the initial map position and zoom level.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421458492648847)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420504130648846)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_text=>'Specify how to determine the initial map position and zoom level for a new APEX session or after a map region <strong>Clear</strong> or <strong>Reset</strong> operation. Within an APEX session, the map region memorizes the current position and zoom l'
||'evel across page requests.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421028171648846)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_text=>'Based on Spatial Results'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563421182454648847)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_text=>'The map will be positioned so that layer query results are visible. <em>Note that this is not supported if GeoJSON is chosen as the layer geometry column type</em>.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420809051648846)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420981389648846)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_text=>'Provide a SQL query returning values for the initial map position.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420689276648846)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420733631648846)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Provide Static Values for the initial map position.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420412914648843)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718021258661330)
,p_name=>'PE.PROPERTY.INIT_PROCEDURE_NAME.PROMPT'
,p_message_text=>'Initialization Procedure Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424081415648852)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_text=>'Pick the column containing the initial zoom level. The returned value should be between 1 and 24.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563423988273648852)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_text=>'Initial Zoomlevel Column'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422211205648850)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_text=>'Specify the initial zoom level. Use integer values between 1 and 24.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563422138970648850)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_text=>'Zoom Level'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516755142061751435)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Sets the CSS class <code>display_only</code> to bold</dt>',
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092405152211777)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter CSS code for this page. Any CSS entered here will only be applied to this page and will not affect any other pages. The entered CSS code will replace the #PAGE_CSS# substitution string in the page template.</p>',
'<p>If the same CSS is required on several pages, it''s best to put the code into an external file. This will help to avoid duplication and take advantage of browser caching of static files. You can reference the external file at the application level,'
||' under Shared Components, User Interface Attributes, CSS, File URLs.</p>',
'<p>Note that you don''t need to include opening or closing <code>style</code> tags. Simply add your CSS code.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092324894211777)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_text=>'Inline'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123107932659211812)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_text=>'Enter the error message displayed when an error occurs on this page. The error message is substituted for <code>#NOTIFICATION_MESSAGE#</code> in the page template.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123107831739211812)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_text=>'In-line Error Notification Text'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577812908500629)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEMPLATE.PROMPT'
,p_message_text=>'Inline'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600835648784514)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Help text plays a crucial role in providing additional information and guidance to users, particularly those who may require assistance or clarification while interacting with an interface. By ensuring that help text is accessible and effectively '
||'communicates its purpose, you enhance the usability and inclusivity of your application.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Clear and Concise:</strong> Keep help text clear and concise to facilitate easy understanding for all users. Avoid using overly technical language or jargon that may be confusing to some users.</li>',
'<li><strong>Contextual Guidance:</strong> Provide help text that is contextually relevant to the task or element it is associated with. This helps users understand how to complete a specific action or navigate through the interface effectively.</li>',
'<li><strong>Sensory Characteristics:</strong> Ensure instructions provided through help do not rely solely on sensory characteristics of page elements (such as shape, color, size or visual location). For example, instead of saying ''click the button i'
||'n the top right of the page'', better help text would be ''click the button labelled "Next" in the top right of the page'' (so the instruction is not reliant on location alone).</li>',
'</ol>'))
,p_version_scn=>36587284
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656818883525941173)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_text=>'Enter inline help text for this item. The help text is being displayed immediately with the item and may be used to provide field level context sensitive help.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656818718184941170)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_text=>'Inline Help Text'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753651485661395)
,p_name=>'PE.PROPERTY.INSTALLED_OBJECT_NAMES.PROMPT'
,p_message_text=>'Object Names'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754275950661396)
,p_name=>'PE.PROPERTY.INSTALL_CONFIRM_MESSAGE.PROMPT'
,p_message_text=>'Confirmation'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754456521661396)
,p_name=>'PE.PROPERTY.INSTALL_FAILURE_MESSAGE.PROMPT'
,p_message_text=>'Install Failure'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754313472661396)
,p_name=>'PE.PROPERTY.INSTALL_SUCCESS_MESSAGE.PROMPT'
,p_message_text=>'Install Success'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754138084661396)
,p_name=>'PE.PROPERTY.INSTALL_WELCOME_MESSAGE.PROMPT'
,p_message_text=>'Welcome'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72496314745786843)
,p_name=>'PE.PROPERTY.INTERNAL_UID.HELP'
,p_message_text=>'Stores the internal ID of a component.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72496213345786843)
,p_name=>'PE.PROPERTY.INTERNAL_UID.PROMPT'
,p_message_text=>'Internal ID'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606546703500649)
,p_name=>'PE.PROPERTY.INVALID_SESSION_FUNCTION_NAME.PROMPT'
,p_message_text=>'Invalid Session Function Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150988530830822708)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select where &PRODUCT_NAME. redirects to if the session is not valid.',
'This happens if the <strong>Sentry Function</strong> or the <strong>Verify Function</strong> returns FALSE on normal page requests, but not on Ajax requests.</p>',
'<p>Note: If using the <strong>Custom</strong> Authentication Scheme Type, the <strong>Sentry Function</strong> attribute in the Authentication Scheme can also be utilized.',
'For plug-in Authentication Scheme Types this is defined by the plug-in developer in the <strong>Session Sentry Function Name</strong> callback.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769860694751496)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_text=>'Built-In Login Page'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769905809751496)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_text=>'Redirect to the URL defined in <code>wwv_flow_custom_auth_std.login_page</code>, provided by &PRODUCT_NAME..'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769635359751496)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_text=>'Login Page'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769764743751496)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_text=>'Redirect to the Login URL defined in the application attributes.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770040969751496)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_text=>'URL'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770105939751496)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_text=>'Redirect to the URL you enter, such as <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150988407565822707)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_text=>'Redirect to'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150989016895822709)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_text=>'Enter a URL that &PRODUCT_NAME. redirects to if the session sentry function returns FALSE. This would normally be a URL to a login page or single sign-on portal. For example, f?p=&amp;APP_ID.:101:&amp;SESSION'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150988906668822708)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_text=>'Invalid Session URL'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976934187250632)
,p_name=>'PE.PROPERTY.IR_COLUMN_ACTION_PARENT_MENU.COMPONENT_PROPERTY.IR_COLUMN_ACTION_MENU_ENTRY.NULL_TEXT'
,p_message_text=>'No Parent'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973556016250238)
,p_name=>'PE.PROPERTY.IR_COLUMN_ACTION_PARENT_MENU.HELP'
,p_message_text=>'Select the parent menu in which the menu entry will be displayed.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973409877250238)
,p_name=>'PE.PROPERTY.IR_COLUMN_ACTION_PARENT_MENU.PROMPT'
,p_message_text=>'Parent Menu'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360542528832591711)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the relevant column display type to define how column values are displayed. The following types are supported:</p>',
'#NATIVE_PLUGINS#',
'<p>Depending on your application configuration, you may also have additional plug-ins available here. The following plug-ins are installed within this application''s shared components:</p>',
'#CUSTOM_PLUGINS#'))
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360542419281591711)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436911339178567862)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>To return the department name:</dt>',
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361708902950363213)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL query which needs to return one column. If the query returns multiple columns, only the first column is used in the list of values.</p>',
'<p>Entering a SQL query can improve performance in some reports, or be used to limit the values displayed.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361708821660363213)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488469270551554660)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_text=>'Select a defined named list of values. The column filter only uses the first column of the dynamic list of values query or the display value of the static list of values to filter the report data.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488469192494554659)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_text=>'Named LOV'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493908410274744)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_text=>'Select how to derive the filters provided in the report column drop down list.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778985632751534)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_text=>'Use Named List of Values to Filter Exact Match'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779076742751534)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_text=>'Derive the list of values from the named list of values to create an equal filter.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779175268751534)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_text=>'Use Named List of Values to Filter Word Contains'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779209045751534)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_text=>'Derive the list of values from the named list of values to create a contains filter.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778785513751533)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_text=>'Use Defined List of Values to Filter Word Contains'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778817347751533)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_text=>'Derive the list of values from a defined list of values SQL query to create a contains filter.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778343314751532)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_text=>'Default Based on Column Type'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778447698751532)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_text=>'STRING and NUMBER columns derive the list of values from distinct column values. DATE columns derive the list of values from predefined date ranges.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778107870751531)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_text=>'None'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778233858751531)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_text=>'There is no column filter provided for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778542425751533)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_text=>'Use Defined List of Values to Filter Exact Match'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516778600504751533)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_text=>'Derive the list of values from a defined list of values SQL query to create an equal match filter.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360493819274274743)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360542305142591711)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_text=>'Select the group for this column. Groups are used to display columns in logical groups in the Single Row View.'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360542202396591710)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_text=>'Group'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360871305640183856)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the link column type for this report.',
'If you select the link column, it always displays as the first column in the report and cannot be hidden by the user.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516781497647751542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_text=>'Link to Custom Target'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516781557921751542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_text=>'The end user is directed to another page based on the target URL you enter.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516781691889751543)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_text=>'Exclude Link Column'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516781719133751543)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_text=>'The link column is not displayed.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516781217149751542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_text=>'Link to Single Row View'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516781312872751542)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_text=>'The end user is directed to a page which shows the column values for the specified row. What and how columns display is governed by various report and column attributes.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360871221789183856)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_text=>'Link Column'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380858017242128748)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360865826210183852)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the pagination type for this report. Often only a certain number of rows of a report display on a page.',
'In order to include additional rows, the application end user must to navigate to the next page of the report.</p>',
'<p>Pagination provides the end user with information about the number of rows and the current position within the result set.</p>',
'<p>Pagination can be shown above or below the report (or both) and can be positioned on the left or right.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779921876751536)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_text=>'Row Ranges X to Y'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779865169751536)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_text=>'Row Ranges X to Y of Z'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360865721697183852)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360946023515486681)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_text=>'Enter an alias for this saved report. Use this alias to define a more meaningful URL link to this specific saved report. This link can be used to link directly from elsewhere in the application.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360945924647486681)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_text=>'Alias'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360946415755511368)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_text=>'View the saved report category, which dictates where this report displays within the Reports select List. This attribute is view only and cannot be updated.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783852382751558)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_text=>'Alternative Default'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824024804464141)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_text=>'Subsequent report layouts saved by developers, that end users can select.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783718038751558)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_text=>'Primary Default'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599823945463464141)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_text=>'Report saved by developers, that is displayed by default.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516784035740751559)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_text=>'Private'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824263459464143)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_text=>'Report layouts saved by end users, that only the end user who saved it can select.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516783982395751558)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_text=>'Public'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599824100749464142)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_text=>'Report layouts saved by end users, that all other end users can select.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360946313149511368)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_text=>'Visibility'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635253574500670)
,p_name=>'PE.PROPERTY.IS_ADVANCED.PROMPT'
,p_message_text=>'Advanced'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635421818500670)
,p_name=>'PE.PROPERTY.IS_CURRENT.PROMPT'
,p_message_text=>'Is Current'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208320775982814)
,p_name=>'PE.PROPERTY.IS_CURRENT_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208256735982814)
,p_name=>'PE.PROPERTY.IS_CURRENT_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208184556982814)
,p_name=>'PE.PROPERTY.IS_CURRENT_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208479498982814)
,p_name=>'PE.PROPERTY.IS_CURRENT_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130208012916982814)
,p_name=>'PE.PROPERTY.IS_CURRENT_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207950848982813)
,p_name=>'PE.PROPERTY.IS_CURRENT_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242760527766661466)
,p_name=>'PE.PROPERTY.IS_CURRENT_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614976826484674)
,p_name=>'PE.PROPERTY.IS_CURRENT_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242760453013661466)
,p_name=>'PE.PROPERTY.IS_CURRENT_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693178114661307)
,p_name=>'PE.PROPERTY.IS_CURRENT_PAGES.PROMPT'
,p_message_text=>'Pages'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614802971484674)
,p_name=>'PE.PROPERTY.IS_CURRENT_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242760391739661466)
,p_name=>'PE.PROPERTY.IS_CURRENT_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242760675870661467)
,p_name=>'PE.PROPERTY.IS_CURRENT_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614760978484674)
,p_name=>'PE.PROPERTY.IS_CURRENT_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242760220905661466)
,p_name=>'PE.PROPERTY.IS_CURRENT_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693046430661307)
,p_name=>'PE.PROPERTY.IS_CURRENT_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692810961661307)
,p_name=>'PE.PROPERTY.IS_CURRENT_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692495277661306)
,p_name=>'PE.PROPERTY.IS_CURRENT_TYPE.LOV.COLON_DELIMITED_PAGE_LIST.D'
,p_message_text=>'Pages'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692537088661306)
,p_name=>'PE.PROPERTY.IS_CURRENT_TYPE.LOV.EXISTS.D'
,p_message_text=>'Exists SQL Query'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692777468661307)
,p_name=>'PE.PROPERTY.IS_CURRENT_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692948183661307)
,p_name=>'PE.PROPERTY.IS_CURRENT_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692604749661307)
,p_name=>'PE.PROPERTY.IS_CURRENT_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'Not Exists SQL Query'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692383329661306)
,p_name=>'PE.PROPERTY.IS_CURRENT_TYPE.LOV.TARGET_PAGE.D'
,p_message_text=>'Target Page'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692299092661306)
,p_name=>'PE.PROPERTY.IS_CURRENT_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604154351500647)
,p_name=>'PE.PROPERTY.IS_DEPRECATED.PROMPT'
,p_message_text=>'Deprecated'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(194050169735779450)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can edit this Form region.</p>',
'        <p>Note - When the Form region is made editable a process is automatically created to process the row.'))
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972358306481110)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can edit this Interactive Grid.</p>',
'        <p>Note - When the Interactive Grid is made editable a process is automatically created to process the rows.'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972218346481109)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649894192767542431)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_text=>'Is Global Page'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709097451661321)
,p_name=>'PE.PROPERTY.IS_HIDDEN.PROMPT'
,p_message_text=>'Hidden'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604256316500647)
,p_name=>'PE.PROPERTY.IS_LEGACY.PROMPT'
,p_message_text=>'Legacy'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2681842967981387)
,p_name=>'PE.PROPERTY.IS_PAGE_PATTERN.HELP'
,p_message_text=>'Specify if the page is to be used as a pattern. Page patterns are shown in the create page wizard allowing you to easily copy a pattern when creating a page. Page patterns can be run from the application builder but are not runnable by end users. '
,p_version_scn=>148588993
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2681758206981387)
,p_name=>'PE.PROPERTY.IS_PAGE_PATTERN.PROMPT'
,p_message_text=>'Page Pattern'
,p_version_scn=>148588991
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245987870354481171)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_text=>'Specify whether the column is one of the primary key values for the underlying table(s).'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245987760169481170)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_text=>'Primary Key'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635554175500670)
,p_name=>'PE.PROPERTY.IS_PUBLIC.PROMPT'
,p_message_text=>'Is Public'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749712630661392)
,p_name=>'PE.PROPERTY.IS_PWA.PROMPT'
,p_message_text=>'Enable'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245987697863481170)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to exclude the column from DML operations.</p>',
'        <p>If set to <strong>On</strong>, &PRODUCT_NAME. will not utilize the column when executing Interactive Grid - Automatic Row Processing (DML).',
'        For example, you should exclude columns whose definitions include concatenations, inner selects, function calls, or a column in an updateable view which is based on an expression.</p>',
'        <p>All columns which need to be included in any INSERT or UPDATE statements must have this option set to <strong>Off</strong>.</p>',
'        <p>Note: Columns of type <em>Display Only</em> are <u>also</u> included in the Automatic Row Processing unless this option is turned <strong>On</strong>.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245987580890481170)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_text=>'Query Only'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604098992500647)
,p_name=>'PE.PROPERTY.IS_QUICK_PICK_ADVANCED.PROMPT'
,p_message_text=>'Quick Pick'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697899884661311)
,p_name=>'PE.PROPERTY.IS_SEARCHABLE.PROMPT'
,p_message_text=>'Searchable'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355260983042719740)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_text=>'Specify whether the parameter can only be set once with a static value or be overridden on component level.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355260899350719739)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_text=>'Static'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573030102735576804)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_text=>'Specify whether this column is displayed or hidden. Even if hidden, columns can always be referenced using substitution syntax, <code>&amp;COLUMN_NAME.</code>.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573030037109576803)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233352415754601869)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the high value on this chart. . Where no column is selected, the highest value of the Box Plot chart will be based upon the data set.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233352098161594991)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_text=>'High'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233352296103599451)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the low value on this chart. Where no column is selected, the lowest value of the Box Plot chart will be based upon the data set. '
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233351824801590151)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_text=>'Low'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617588669065344)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the closing value on this chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617446267065344)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_text=>'Close'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617123212065343)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the high value on this chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617047592065342)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_text=>'High'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619142332065350)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the label(s) of the x-axis on the chart. For a Stock chart, the column should be of data type Date/Timestamp, to represent the stock information on a time axis.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619014415065349)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_text=>'Label'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165172163348500905)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
,p_version_scn=>37166067046545
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624535942065369)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_text=>'<p>Enter a CSS style string defining the style of the labels on this chart.</p>'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624410930065369)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Styling'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353257142854739626)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>For range series, if an array of two values are provided, the first and second value will apply to the low and high point respectively. The <strong>Outside Slice</strong> value only applies to pie charts.',
'        The <strong>Above Marker</strong>, <strong>Below Marker</strong>, <strong>Before Marker</strong>, and <strong>After Marker</strong> values only apply to line, area, scatter, and bubble series. The <strong>Inside Bar Edge</strong> and <strong>'
||'Outside Bar Edge</strong> values',
'        only apply to non-polar bar series. Stacked bars do not support <strong>Outside Bar Edge</strong>. The <strong>Start</strong> value only applies to horizontal and vertical Status Meter Gauge charts. The chart does not currently adjust layout '
||'to fit labels within the plot area or deal with any overlaps between labels.</p>'))
,p_version_scn=>37166067046545
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623582856065366)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_text=>'Select the position of the label(s) to be rendered on the chart.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623701241065366)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_text=>'Above Marker'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624076536065367)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_text=>'After Marker'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624369086065368)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623936322065367)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_text=>'Before Marker'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623809268065367)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_text=>'Below Marker'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623650782065366)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_text=>'Center'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624186180065368)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_text=>'Inside Bar Edge'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256564591739298)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624244961065368)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_text=>'Outside Bar Edge'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256439615739296)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_text=>'Outside Slice'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31564352881556490)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_text=>'Start'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623497857065365)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_text=>'Position'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604134591784550)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.COMPONENT_PROPERTY.JET_CHART_SERIES.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Labelling for Readability:</strong>',
'<ul>',
'<li>',
'Directly label elements on the chart to enhance readability.</li>',
'<li>Eliminate the need for users to reference a separate legend by labeling directly on the chart.</li>',
'<li>Ensure labels are short and simple to prevent clutter and confusion.</li>',
'</ul>',
'</li>',
'</ul>'))
,p_version_scn=>36587334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623362739065365)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_text=>'Specify whether the label(s) should be rendered on the chart. This setting applies to the visibility of the metric value on a Dial chart. '
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295623218129065364)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295616917615065342)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the low value on this chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295616874324065342)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_text=>'Low'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618590547065347)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_text=>'Select the column name to be used for defining the maximum value on this chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618477217065347)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_text=>'Maximum Value'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(382558518165124443)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_text=>'Select the column name to be used for defining the minimum value on this chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(382558343750120884)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_text=>'Minimum Value'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617320894065343)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the opening value on this chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617256188065343)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_text=>'Open'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619317153065350)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining a short descriptive custom tooltip on the data points of the chart. To render a tooltip on chart data points, ensure the chart tooltip attribute <strong>Show</strong> is set to <strong>On</strong>. For a'
||' Box Plot chart, the column should not match the selected Value column mapping. Selection of a column that matches the Value column mapping will result in no custom tooltip being rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619256158065350)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_text=>'Custom Tooltip'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618398850065347)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_text=>'Select the column name to be used for defining the target value on this chart. When set, the value attribute defines the filled area within the slice and this represents the value of the whole slice. '
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618284790065346)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_text=>'Target Value'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295616762156065341)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the value on this chart. For a Box Plot chart, this column will be used for defining the minimum, quartiles, median, and maximum values of the numerical data set.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295616687974065341)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617713692065345)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the volume value on this chart. When values are provided, the volume is displayed on the y2 axis.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617654018065344)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_text=>'Volume'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617981029065345)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the x value on this chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295617811981065345)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_text=>'X'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618176673065346)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the y value on this chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295618065219065346)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_text=>'Y'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295615396557065336)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the z value on this chart.  The z value defines the bubble radius for a bubble chart, the width of a box plot item, and the bar width for a bar or combination chart. '
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295615299371065336)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_text=>'Z'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992922770822715)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_text=>'Select if the region components (sub regions, items, buttons) display above or below the main region content.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770964887751502)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_text=>'Above Content'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516771091826751503)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_text=>'Below Content'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992832490822715)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_text=>'Render Components'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123150521512211881)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_text=>'Enter the name of this item. Item names must be valid Oracle identifiers. It is recommended that item names be no longer then 30 bytes so they can be used as bind variables in SQL Queries.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123150428847211881)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577693339500629)
,p_name=>'PE.PROPERTY.ITEM_POST_TEXT_TEMPLATE.PROMPT'
,p_message_text=>'Post Text'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577520701500629)
,p_name=>'PE.PROPERTY.ITEM_PRE_TEXT_TEMPLATE.PROMPT'
,p_message_text=>'Pre Text'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245991644725481467)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how this column is rendered. The following column types are supported:</p>',
'#NATIVE_PLUGINS#',
'<p>Depending on your application configuration, you may also have additional column type plug-ins available here.',
'These display as <em>&lt;My Plug-in&gt; [Plug-in]</em>.',
'The following plug-ins are installed in this application''s shared components:</p>',
'#CUSTOM_PLUGINS#'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123150122377211881)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify how this item is rendered. For more information on specific item types, see <a rel="noopener noreferrer" target="_blank" href="#SYSTEM_HELP_URL#CSH:pd-type-item">About Item Types</a>.</p>',
'<p>The following item types are supported:</p>',
'#NATIVE_PLUGINS#',
'<p>Depending on your application configuration, you may also have additional item type plug-ins available here.',
'These display as <em>&lt;My Plug-in&gt; [Plug-in]</em>.',
'The following plug-ins install into this application''s shared components:</p>',
'#CUSTOM_PLUGINS#'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123150005865211880)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607772805500649)
,p_name=>'PE.PROPERTY.ITEM_TYPE_COMPONENT_TYPES.LOV.APEX_APPLICATION_PAGE_ITEMS.D'
,p_message_text=>'Page Items'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607930610500649)
,p_name=>'PE.PROPERTY.ITEM_TYPE_COMPONENT_TYPES.LOV.APEX_APPL_PAGE_FACETS.D'
,p_message_text=>'Facets'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608000533500650)
,p_name=>'PE.PROPERTY.ITEM_TYPE_COMPONENT_TYPES.LOV.APEX_APPL_PAGE_FACET_GRP_ITEMS.D'
,p_message_text=>'Facet Group Items'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607879419500649)
,p_name=>'PE.PROPERTY.ITEM_TYPE_COMPONENT_TYPES.LOV.APEX_APPL_PAGE_IG_COLUMNS.D'
,p_message_text=>'Interactive Grid Columns'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608111377500650)
,p_name=>'PE.PROPERTY.ITEM_TYPE_COMPONENT_TYPES.LOV.APEX_APPL_PAGE_SFILTERS.D'
,p_message_text=>'Filters'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608248996500650)
,p_name=>'PE.PROPERTY.ITEM_TYPE_COMPONENT_TYPES.LOV.APEX_APPL_PAGE_SFILTER_GRP_ITEMS.D'
,p_message_text=>'Filter Group Items'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607619148500649)
,p_name=>'PE.PROPERTY.ITEM_TYPE_COMPONENT_TYPES.PROMPT'
,p_message_text=>'Component Type'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591309437161936576)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_text=>'Page Default'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(598578633220140804)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_text=>'Include item in the unsaved changes check, if the check is enabled at page level.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591062180005936259)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_text=>'Specify if the page item is included in the unsaved changes check, which warns the user when they try to navigate away from the page, and where the page contains unsaved changes. Some items may not need to be checked (for example they are not based o'
||'n a database column, like a search item), so can be set to be ignored.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591062496070936259)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_text=>'Ignore'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596646220872061449)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_text=>'Changes to the item are ignored by the unsaved changes check.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591061832964936258)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_text=>'Warn on Unsaved Changes'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547685675285362048)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_text=>'Specify the position of the major and minor axes on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547688203026462569)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_text=>'Bottom'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547688097837461705)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_text=>'Top'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547685037734319215)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_text=>'Axis Position'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547734487152390775)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_text=>'Specify the time scale to be used for the axis on the chart. This is required in order for the Gantt to properly render. The selected time scale will be used for zooming, when no Zoom Scale options have been selected.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547706401980079534)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_text=>'Days'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547706236882078849)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_text=>'Hours'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547705608792076175)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_text=>'Minutes'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547707203082082688)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_text=>'Months'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547707629885085127)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_text=>'Quarters'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547705454891074524)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_text=>'Seconds'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547706855439081036)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_text=>'Weeks'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547708090957086707)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_text=>'Years'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547734235382389537)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_text=>'Scale'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597618060065273)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_text=>'Select the chart type. The chart type determines the visualization used to render the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597712819065273)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_text=>'Area'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436867699270587459)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_text=>'Area charts are useful for comparing trends of cumulative values over time, such as breakdowns of sales trends.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597823846065273)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_text=>'Bar'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436867720663587460)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_text=>'Bar charts are useful for comparing values across categories, or over time.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205892653261668360)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_text=>'Box Plot'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205892893794672782)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_text=>'Box plot charts are useful for analyzing the distribution of data, displaying the minimum, quartiles, median, and maximum values of groups of numerical data. Box plots are also called Box and Whisker diagrams.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597909431065274)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_text=>'Bubble'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436867855480587461)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_text=>'Bubble charts define data items using x, y, and z values, making them useful for viewing relationships between 3 dimensions. The third dimension is represented by the size of the bubble.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598070045065274)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_text=>'Combination'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436867919451587462)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_text=>'Combination charts allow bar, line, and area series to be displayed on the same chart. The most common use case is lines with bars or lines with stacked bars.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598179150065275)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_text=>'Status Meter Gauge'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868006806587463)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_text=>'Status Meter gauges are used to display a metric value in relation to the minimum and maximum possible values for that metric.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(334520945052611243)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_text=>'Donut'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868105731587464)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_text=>'Donut charts are a pie chart with a hole in the middle. They are useful for visualizing parts of a whole.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598269689065275)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_text=>'Funnel'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868249534587465)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_text=>'Funnel charts are useful for viewing data for stages of a process, such as the stages of a sales process. The area of a funnel slice is proportional to the value for the corresponding stage.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547687369888396458)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_text=>'Gantt'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547687570071398700)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_text=>'Gantt charts are useful for displaying project schedules, displaying bars that indicate the start and end date of tasks.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598338822065275)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_text=>'Line'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868310774587467)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_text=>'Line charts are useful for visualizing trends in a set of values over time and comparing these values across series.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598454472065276)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_text=>'Line with Area'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868430287587468)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_text=>'Line with Area charts are the same as line charts, with the area below each line filled in.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598592786065276)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_text=>'Pie'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868554690587469)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_text=>'Pie charts are useful for visualizing parts of a whole.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(334515435437558665)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_text=>'Polar'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868685590587470)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_text=>'Polar charts have a radial y-axis and a tangential x-axis. Polar charts can be rendered as bar, line, area, combination, scatter, or bubble chart series types.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155492853373481910)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_text=>'Pyramid'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155493003843485414)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_text=>'Pyramid charts are useful for visualizing hierarchical, proportional and foundation-based relationships, process steps, organizational layers or topics interconnections. The area of a pyramid slice is proportional to its value for the corresponding s'
||'tage.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(334520501924608199)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_text=>'Radar'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868765951587471)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_text=>'Radar charts are polar charts with a polygonal grid shape, rather than a circle surround. They are supported for line and area chart series types.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(334520706013609140)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_text=>'Range'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868881006587472)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_text=>'Range charts display maximum and minimum (high / low) values for each entry, using either bars or area.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598680671065276)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_text=>'Scatter'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436868997496587473)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_text=>'Scatter charts define data items using x and y values, making them useful for viewing relationships between 2 dimensions.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598719750065277)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_text=>'Stock'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869086506587474)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_text=>'Stock charts are useful for displaying information about a stock on a time axis. Unique to stock charts is the candlestick <strong>Stock Render As</strong> property, which allows for displaying open, close, high, low information for the stock price.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295597544342065272)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233353073873675052)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether gaps in your multi-series chart data should be set to a value of zero, or null.</p>',
'        <p>When set to <strong>On</strong>, gaps in data are handled as zero.  For a Line chart, this will ensure the line is rendered as a continuous line. For a stacked Bar chart with Stack Label set to On, this will ensure the stack label is rende'
||'red for each stack.</p>',
'        <p>When set to <strong>Off</strong>, gaps in data are handled as null. For a Line chart, the line will be rendered as a broken line, with gaps representing null data points.<p>',
'        <p>This setting will be applied to multi-series chart types that support rendering as a bar, and line, such as Bar, Line, Line with Area, Combination, Area, Polar, Radar and Scatter.  The default is <strong>On</strong>.</p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233352842425669001)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_text=>'Render Gap as Zero'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295603670796065294)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether the data cursor is enabled on the chart.',
'        Data cursor is a useful alternative to tooltips when the data items are difficult to navigate to, especially on touch devices.<p/>',
'        <p>If set to <strong>Automatic</strong>, the data cursor is shown only for line or area charts on touch devices.<p/>',
'        <p>Note - The data cursor is not shown when the tooltip is null, and it is not supported on polar charts.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295603787830065295)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869465197587486)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_text=>'Apply the Oracle JET defined default data cursor display for the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295603902916065296)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_text=>'No'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869641909587487)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_text=>'The data cursor is not displayed.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295603894666065295)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_text=>'Yes'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869547314587487)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_text=>'The data cursor is always displayed.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295603594487065294)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_text=>'Cursor'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604194109065296)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_text=>'Select the behavior of the data cursor on the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604202314065296)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762805955249749)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_text=>'Apply the Oracle JET defined default data cursor behavior for the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604373684065297)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_text=>'Smooth'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869725700587489)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The data cursor follows the mouse/touch movement smoothly, displaying the tooltip whenever the data cursor is hovering over any part of a data element, and not just specific data points. An indicator identifies the currently selected data element.'
||'</p>',
'        <p>Note - Set <strong>Cursor</strong> to <strong>Yes</strong> for this visualization to work fully.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604458116065297)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_text=>'Snap'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869876458587490)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The data cursor snaps (jumps) to a data element when a mouse/touch movement occurs over the chart, displaying the tooltip whenever the data cursor is hovering over a data element. An indicator identifies the currently selected data element.</p>',
'        <p>Note - Set <strong>Cursor</strong> to <strong>Yes</strong> for this visualization to work fully.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604017961065296)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_text=>'Behavior'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170055779258485891)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_text=>'Specify whether gaps in your multi-series chart data should be automatically filled.  This setting does not apply to single series charts or the following chart types: Bubble, Donut, Funnel, Gantt, Pie, Pyramid, Scatter, and Stock.  When set to <stro'
||'ng>On</strong>, data densification logic introduced in Oracle APEX 5.1.3 will be applied to the chart data.  When set to <strong>Off</strong>, gaps in data will not be filled and may result in inaccurate chart rendering. The default is <strong>On</st'
||'rong>.  '
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170054415697482848)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_text=>'Fill Gaps in Chart Data'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715974477481412973)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_text=>'<p>Enter CSS classes to be applied to baseline bars on the Gantt chart. You may add multiple classes by separating them with spaces. You can utilize <code>&COLUMN_VALUE.</code> substitutions.</p>'
,p_version_scn=>37166067046380
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715974347987412973)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_text=>'Baseline CSS Classes'
,p_version_scn=>37166067046380
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548317294018508820)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_text=>'Select the column name to be used for defining the baseline end date on the Gantt chart. A baseline end date is the task''s original planned end date.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548317085652507277)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_text=>'Baseline End Date'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548316888818505515)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_text=>'Select the column name to be used for defining the baseline start date on the Gantt chart. A baseline start date is the task''s original planned start date.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548316658993503547)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_text=>'Baseline Start Date'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548301330415892408)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_text=>'Select the column name to be used for defining the end date of the Gantt chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548301189784891001)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_text=>'End Date Column'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548302388467912577)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_text=>'Select the page or application item to be used for defining the end date of the Gantt chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548302111666911120)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_text=>'End Date Item'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548170492961795121)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_text=>'Select the source to be used for defining the end date of the Gantt chart. An end date is required in order to render the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548171694941821455)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_text=>'Database Column'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548171814051826735)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_text=>'Set to the column value entered in <em>End Date Column</em>.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548300634414884904)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548300924696888555)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>End Date Item</em> selected.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548170985653803307)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_text=>'End Date Source Type'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548317605300596866)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_text=>'Select the column name to be used for defining the task progress on the Gantt chart. The value of the progress must be between 0 and 1.  If the value is invalid, no progress will be shown.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548317475365595002)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_text=>'Progress'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715974232120412961)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_text=>'<p>Enter CSS classes to be applied to progress bars on the Gantt chart. You may add multiple classes by separating them with spaces. You can utilize <code>&COLUMN_VALUE.</code> substitutions.</p>'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715974110254412961)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_text=>'Progress CSS Classes'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548308456997181612)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_text=>'Select the column name to be used for defining the row ID on the gantt chart. A row ID is required if you wish to render multiple tasks per row. When no row ID column mapping is defined, each task will be rendered as a single task per row.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548308279553180100)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_text=>'Row ID'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548308837851184293)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the row name on the gantt chart.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548308680712183096)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_text=>'Row Name'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548168770964878264)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_text=>'Select the column name to be used for defining the start date of the Gantt chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548168564281876677)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_text=>'Start Date Column'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(562509920009950529)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_text=>'Select the page or application item to be used for defining the start date of the Gantt chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548299944349876822)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_text=>'Start Date Item'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547688876223472016)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_text=>'Select the source to be used for defining the start date of the Gantt chart. A start date is required in order to render the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547736142179499323)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_text=>'Database Column'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547736372935501145)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_text=>'Set to the column value entered in <em>Start Date Column</em>.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547736515632502557)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547736704411504537)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Start Date Item</em> selected.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547688468344467079)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_text=>'Start Date Source Type'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715974091333412960)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_text=>'<p>Enter CSS classes to be applied to task bars on the Gantt chart. You may add multiple classes by separating them with spaces. You can utilize <code>&COLUMN_VALUE.</code> substitutions.</p>'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715973929768412960)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_text=>'Task CSS Classes'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548314199246280942)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_text=>'Select the column name to be used for defining the task end date on the Gantt chart.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548313999205279868)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_text=>'Task End Date'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548309224281186693)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_text=>'Select the column name to be used for defining the task ID on the gantt chart.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548309057672185384)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_text=>'Task ID'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548309685350189039)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining the task name on the gantt chart. When no row name column mapping is defined, the task name will be used as the row label on the row axis of the chart. '
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548309496763187759)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_text=>'Task Name'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548313732404278583)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_text=>'Select the column name to be used for defining the task start date on the Gantt chart.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548313524980277156)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_text=>'Task Start Date'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644375126308374191)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_text=>'Select the column name to be used for defining the viewport end date of the Gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644144220262428336)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_text=>'End Date Column'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644375209171374192)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_text=>'Select the page or application item to be used for defining the viewport end date of the Gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644143883305423990)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_text=>'End Date Item'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374874965374189)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_text=>'Select the source to be used for defining the end date of the Gantt chart''s viewport. A viewport is a date range, which when defined can control the initial zooming of a chart when rendered. The chart will be zoomed in to the specified date range.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644144601948445122)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_text=>'Database Column'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374967392374190)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_text=>'Set to the column value entered in <em>End Date Column</em>.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644145394002452000)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644375081307374191)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>End Date Item</em> selected.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644143620572422924)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_text=>'End Date Source Type'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374624343374170)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_text=>'Select the column name to be used for defining the viewport start date of the Gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644144087144426525)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_text=>'Start Date Column'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374712400374188)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_text=>'Select the page or application item to be used for defining the viewport start date of the Gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644143414193421500)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_text=>'Start Date Item'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374398230374168)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_text=>'Select the source to be used for defining the start date of the Gantt chart''s viewport. A viewport is a date range, which when defined can control the initial zooming of a chart when rendered. The chart will be zoomed in to the specified date range.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644144443901443883)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_text=>'Database Column'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374470289374169)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_text=>'Set to the column value entered in <em>Start Date Column</em>.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644145100940450958)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374568273374169)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Start Date Item</em> selected.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644143206938418635)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_text=>'Start Date Source Type'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21646030727691101)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_text=>'Enter the angle extent in degrees for the Status Meter Gauge chart with circular orientation. The Angle Extent is an actual angle of the circular orientation. Positive values indicate clockwise angle.  Negative values indicate counterclockwise angle.'
||' You may draw your circular gauge at any angle you want and change its shape according to the chosen angle. The shape of your gauge depends on 2 settings: <strong>Start Angle</strong> and <strong>Angle Extent</strong>.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21645527040620279)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_text=>'Angle Extent'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21644576770504780)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_text=>'Specify the ratio of relative thickness of the indicator to the plot area.  The default is 1.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21644311645502157)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_text=>'Indicator Size'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21644759758507631)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_text=>'Specify the inner radius of a Status Meter gauge chart with circular orientation, defined by the distance from the center of the gauge to the innermost edge of the indicator and plot area. Valid values are a percent or ratio from 0 to 1.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21645128427617382)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_text=>'Inner Radius'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21642147670869727)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_text=>'Select the type of Status Meter Gauge chart to render.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21641529726834170)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_text=>'Circular'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21641783119835023)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_text=>'Horizontal'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21641922063836154)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_text=>'Vertical'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21641391568833259)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_text=>'Orientation'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21642513722882555)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_text=>'Specify whether the plot area of a Status Meter Gauge chart is to be rendered.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21642337867871120)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_text=>'Show Plot Area'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603708905784550)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.COMPONENT_PROPERTY.JET_CHART_SERIES.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing chart accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Use Bold and Clear Colors:</strong> Opt for colors that are bold and clear to ensure both text and graphical elements within your charts are easily distinguishable. This enhances readability and comprehension for all users, including thos'
||'e with visual impairments.</li>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 4.5:1 to ensure readability for individuals with varying level'
||'s of vision impairment.</li>',
'</ol>'))
,p_version_scn=>12412759
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73133784175902337)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24877570009106052)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color to be displayed for the plot area of a Status Meter Gauge chart. You can utilize <code>&COLUMN_VALUE.</code> substitutions. This color only applies when threshold colors have not been defined for the chart.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24877333728101302)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_text=>'Plot Area Color'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21645712394668253)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_text=>'Enter the start angle in degrees for the Status Meter Gauge chart with circular orientation. Positive values indicate clockwise start angle. Negative values indicate counterclockwise start angle. You may draw your circular gauge at any angle you want'
||' and change its shape according to the chosen angle. The shape of your gauge depends on 2 settings: <strong>Start Angle</strong> and <strong>Angle Extent</strong>.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21645373662619483)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_text=>'Start Angle'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547686254345366648)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_text=>'Specify whether to display horizontal gridlines on the chart.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547684406468311387)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_text=>'Show Horizontal Grid'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604630673065298)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the behavior to be applied when hovering over data items on the chart.<p/>',
'        Select <strong>On</strong> to dim all data items when not currently hovered over, and highlight only the current data item hovered over.'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604566653065297)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_text=>'Dim On Hover'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881765644069802791)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_text=>'Select the initial zooming of the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881765769384802792)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_text=>'First'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881765872448802793)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_text=>'Initially zoom to the first data points that can fit in the chart plot area.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881765905427802793)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_text=>'Last'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881766056161802794)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_text=>'Initially zoom to the last data points that can fit in the chart plot area.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881766199636802795)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881766263767802796)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_text=>'To disable initial zooming.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881765581651802789)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_text=>'Initial Zooming'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957005197792521)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118723436154905567)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display the font for the specified attribute.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118717381823868568)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_text=>'Font Color'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118720528824882572)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_text=>'Select the font family.'
,p_version_scn=>37166067046392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118717758557870267)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_text=>'Arial Black'
,p_version_scn=>37166067046392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118717500414869266)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_text=>'Arial'
,p_version_scn=>37166067046392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118717953068871079)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_text=>'Bookman'
,p_version_scn=>37166067046392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118718122982872213)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_text=>'Comic Sans MS'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118718519837874288)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_text=>'Courier New'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118718327356873465)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_text=>'Courier'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118718756597875112)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_text=>'Garamond'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118718904562875830)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_text=>'Georgia'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118719189918876896)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_text=>'Helvetica'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118719340878877610)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_text=>'Impact'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118719533325878381)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_text=>'Palatino'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118719922984879821)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_text=>'Times New Roman'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118719775115879005)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_text=>'Times'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118720158871880695)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_text=>'Trebuchet MS'
,p_version_scn=>37166067046395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118720393840881633)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_text=>'Verdana'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118716718532865988)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_text=>'Font Family'
,p_version_scn=>37166067046392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118721571919887801)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_text=>'Select the font size.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118721963272888935)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_text=>'10'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118722117199889506)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_text=>'12'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118722305667890096)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_text=>'14'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118722601055899945)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_text=>'16'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118722868850900685)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_text=>'18'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118723006257901372)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_text=>'20'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118723235547902045)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_text=>'22'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118721739796888349)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_text=>'8'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118717192603867696)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_text=>'Font Size'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118720762602884038)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_text=>'Select the font style.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118721149455885431)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_text=>'Italic'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118720909350884804)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118721310193886084)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_text=>'Oblique'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118716942691866845)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_text=>'Font Style'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47126047579094143)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_text=>'Specify how the labels should be displayed on the slices of the pie chart. '
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725666314709375892)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_text=>'Label - Percentage ( Value )'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725954037761687464)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_text=>'<p>The labels will display the label, value and percentage information in the following format: label - percentage ( value ). For example, <strong>Bugs - 15% ( 18 )</strong>.</p>'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725666582514377355)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_text=>'Percentage ( Value )'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725954263504689423)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_text=>'<p>The labels will display as numeric values, based on the selected Value column mapping. For example, <strong>15% ( 18 )</strong>.</p>'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725665750910371484)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_text=>'Label'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725953317867682044)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_text=>'<p>The labels will display on the slices of the chart, based on the selected Label column mapping. For example, <strong>Bugs</strong>.</p>'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(56894047988122935)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_PCT.D'
,p_message_text=>'Label - Percentage'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(56894270350126592)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_PCT.HELP'
,p_message_text=>'<p>The labels will display the label and percentage information in the following format: label - percentage. For example, <strong>Bugs - 15%</strong>.</p>'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(198753872420334687)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_text=>'Label - Value'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(198754079893340002)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_text=>'<p>The labels will display the label and value information in the following format: label - value. For example, <strong>Bugs - 18</strong>.</p>'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725665949091372517)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_text=>'Percentage'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725953615603684094)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_text=>'<p>The labels will display as values between 0% and 100%, based on the selected Value column mapping. The value is a percentage of the total values represented on the chart. For example, <strong>15%</strong>.</p>'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725666103379373323)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_text=>'Value'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725953863766685776)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_text=>'<p>The labels will display as numeric values, based on the selected Value column mapping.</p>'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725665504199367215)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_text=>'Display As'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956938649792518)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118700313942218307)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display the font for the specified attribute.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118699323869208840)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_text=>'Font Color'
,p_version_scn=>37166067046392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118699745599214293)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_text=>'Select the font family.'
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118700741614221257)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_text=>'Arial Black'
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118700511258219306)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_text=>'Arial'
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118700941581222040)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_text=>'Bookman'
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118701346119222963)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_text=>'Comic Sans MS'
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118701721468224508)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_text=>'Courier New'
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118701549657223734)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_text=>'Courier'
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118701986591225370)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_text=>'Garamond'
,p_version_scn=>37166067046390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118702132051226163)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_text=>'Georgia'
,p_version_scn=>37166067046390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118702378707226954)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_text=>'Helvetica'
,p_version_scn=>37166067046390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118702579232227642)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_text=>'Impact'
,p_version_scn=>37166067046390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118702700207228444)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_text=>'Palatino'
,p_version_scn=>37166067046390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118703455062230064)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_text=>'Times New Roman'
,p_version_scn=>37166067046390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118703297773229091)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_text=>'Times'
,p_version_scn=>37166067046390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118703628374230909)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_text=>'Trebuchet MS'
,p_version_scn=>37166067046390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118703895138231638)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_text=>'Verdana'
,p_version_scn=>37166067046390
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118698704260206164)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_text=>'Font Family'
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118700126896217192)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_text=>'Select the font size.'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118704843624235909)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_text=>'10'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118705468096236462)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_text=>'12'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118705658336237197)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_text=>'14'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118705839357237819)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_text=>'16'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118706047630238521)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_text=>'18'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118706269661239376)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_text=>'20'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118706469830240019)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_text=>'22'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118704611489235278)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_text=>'8'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118699188587207879)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_text=>'Font Size'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118699980965215780)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_text=>'Select the font style.'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118704228113233187)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_text=>'Italic'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118704037182232484)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118704480987234401)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_text=>'Oblique'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118698941994206976)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_text=>'Font Style'
,p_version_scn=>37166067046391
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604035880784550)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.COMPONENT_PROPERTY.JET_CHART_SERIES.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing chart accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Use Bold and Clear Colors:</strong> Opt for colors that are bold and clear to ensure both text and graphical elements within your charts are easily distinguishable. This enhances readability and comprehension for all users, including thos'
||'e with visual impairments.</li>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 4.5:1 to ensure readability for individuals with varying level'
||'s of vision impairment.</li>',
'</ol>'))
,p_version_scn=>12412759
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75492463823453812)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>A comma delimited list of colors:</dt>',
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
'<dt>A comma delimited list of page or application items, returning colors, using:</dt>',
'<dd><pre>',
'<code>&amp;ITEM.</code> syntax. For example, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>A comma delimited list of columns, returning colors, using:</dt>',
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code> syntax. For example, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75492231404451825)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the color(s) to be used to identify the reference line(s) to be rendered on a Status Meter Gauge chart.',
'For multiple reference lines, use a comma delimited list.'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75491663003436125)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_text=>'Colors'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75492098747449868)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>A comma delimited list of static numeric values:</dt>',
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
'<dt>A comma delimited list of page or application items, returning numeric values, using:</dt>',
'<dd><pre>',
'<code>&amp;ITEM.</code> syntax. For example, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>A comma delimited list of columns, returning numeric values, using:</dt>',
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code> syntax. For example, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75491867312447881)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the number(s) to be used to identify the reference line(s) to be rendered on a Status Meter Gauge chart.',
'For multiple reference lines, use a comma delimited list.'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(75491418298435346)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_text=>'Values'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547685805365363494)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_text=>'Specify whether to render the row labels on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547684810612316773)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_text=>'Show Row Axis'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603647282784550)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.COMPONENT_PROPERTY.JET_CHART_SERIES.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing chart accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Use Bold and Clear Colors:</strong> Opt for colors that are bold and clear to ensure both text and graphical elements within your charts are easily distinguishable. This enhances readability and comprehension for all users, including thos'
||'e with visual impairments.</li>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 4.5:1 to ensure readability for individuals with varying level'
||'s of vision impairment.</li>',
'</ol>'))
,p_version_scn=>12412753
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619691965065351)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619586950065351)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color to be displayed for the data items associated with this chart series. You can utilize <code>&COLUMN_VALUE.</code> substitutions. For a Status Meter Gauge chart, this color will be applied to the indicator, with the exception of whe'
||'n thresholds have been defined, and the <strong>Threshold Display</strong> attribute is set to <strong>On Indicator</strong>.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619450862065351)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_text=>'Color'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603888182784550)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.COMPONENT_PROPERTY.JET_CHART_SERIES.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing chart accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Use Bold and Clear Colors:</strong> Opt for colors that are bold and clear to ensure both text and graphical elements within your charts are easily distinguishable. This enhances readability and comprehension for all users, including thos'
||'e with visual impairments.</li>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 4.5:1 to ensure readability for individuals with varying level'
||'s of vision impairment.</li>',
'</ol>'))
,p_version_scn=>12412759
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234664425370023479)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234636573339639612)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color to be displayed for the q2 segment of the Box Plot chart series. You can utilize <code>&COLUMN_VALUE.</code> substitutions.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234636117673634483)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_text=>'Q2 Color'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603978573784550)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.COMPONENT_PROPERTY.JET_CHART_SERIES.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing chart accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Use Bold and Clear Colors:</strong> Opt for colors that are bold and clear to ensure both text and graphical elements within your charts are easily distinguishable. This enhances readability and comprehension for all users, including thos'
||'e with visual impairments.</li>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 4.5:1 to ensure readability for individuals with varying level'
||'s of vision impairment.</li>',
'</ol>'))
,p_version_scn=>12412759
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234664547442023485)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234637184407642166)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color to be displayed for the q3 segment of the Box Plot chart series. You can utilize <code>&COLUMN_VALUE.</code> substitutions.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234636348529635659)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_text=>'Q3 Color'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(230523649976029576)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_text=>'Select the chart series type.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206372410142103430)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_text=>'Area'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206372637314104395)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_text=>'Bar'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206372213230102263)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_text=>'Box Plot'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206372808653105708)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_text=>'Line'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206373051712107364)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_text=>'Line with Area'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206373274809110020)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334447197204948)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_text=>'Series Type Column Mapping'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334630850204951)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_text=>'Select the chart series type. You can also create a chart combining different types of series on the same data plot.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334734831204951)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_text=>'Area'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335280608204953)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_text=>'Area Range'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334875843204952)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_text=>'Bar'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335114072204953)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_text=>'Bar Range'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334952799204952)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_text=>'Line'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335073281204952)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_text=>'Line with Area'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334521798204950)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335872885204955)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_text=>'Select the chart series type.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335965250204955)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_text=>'Area'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336526848204958)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_text=>'Area Range'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336076163204956)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_text=>'Bar'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336470797204957)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_text=>'Bar Range'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336319710204957)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_text=>'Bubble'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336123810204956)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_text=>'Line'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(536750131356446327)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_text=>'Line with Area'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336292143204957)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_text=>'Scatter'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335757725204955)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336769581204958)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_text=>'Select the chart series type.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336849705204959)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_text=>'Area'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336942169204959)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_text=>'Area Range'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337337040854204959)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_text=>'Line'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337336641414204958)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335466968204954)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_text=>'Select the chart series type.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335615713204954)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_text=>'Area Range'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335548206204954)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_text=>'Bar Range'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337335328010204953)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624715628065370)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_text=>'Specify whether the axis is rendered on the chart.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295624645793065369)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_text=>'Show Axis'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73915922870487004)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_text=>'Specify whether to display the baseline information in the tooltip on your chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73914704992444428)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_text=>'Show Baseline'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73915595021484307)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_text=>'Specify whether to display the end date in the tooltip on your chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73914300299442671)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_text=>'Show End Date'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73915742593485602)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_text=>'Specify whether to display the progress in the tooltip on your chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73914512845443530)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_text=>'Show Progress'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73914968879451290)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_text=>'Specify whether to display row information in the tooltip on your chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73913717510438275)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_text=>'Show Row'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73915353998482707)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_text=>'Specify whether to display the start date in the tooltip on your chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73914185099441790)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_text=>'Show Start Date'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21660577285755496)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_text=>'Specify whether the value should be rendered on the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21659378701496981)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73915103653480525)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_text=>'Specify whether to display the label in the tooltip on your chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73913927158440703)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_text=>'Show Label'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295609418498065315)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_text=>'Specify whether a tooltip should be rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295609327660065315)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295610332264065319)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_text=>'Specify whether to display values in the tooltip on your chart. Values are derived from your chart query and display next to your chart data.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295610211747065318)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_text=>'Show Value'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(562509863613950460)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_text=>'Select the chart sort order of the data on a multi-series chart, based on either the value or label of the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538517811873362690)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_text=>'Label - Ascending'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538518616382387471)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_text=>'Set to order the chart based on the x-axis labels in ascending order. This is the default sort order. '
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538518032309364159)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_text=>'Label - Descending'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538518819072388661)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_text=>'Set to order the chart based on the x-axis labels in descending order. '
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538517410748360045)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_text=>'Value - Ascending'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538518279534366769)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_text=>'Set to order the chart based on the values in ascending order (1, 2, 3, ...). This setting should only be used for pie charts, bar/line/area charts with one series, or stacked bar/area charts. Sorting will not apply when using a hierarchical group ax'
||'is.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538517665783361372)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_text=>'Value - Descending'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538518458488382415)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_text=>'Set to order the chart based on the values in descending order (10, 9, 8, ...). This setting should only be used for pie charts, bar/line/area charts with one series, or stacked bar/area charts. Sorting will not apply when using a hierarchical group '
||'axis.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538516896076345762)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_text=>'Sort Order'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464840449499269002)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464840283497262919)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display the font for the specified attribute.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464839465610246214)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_text=>'Font Color'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464839659905252552)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_text=>'Select the font family.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464845066156428337)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_text=>'Arial Black'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464844822524427399)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_text=>'Arial'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464845232763429396)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_text=>'Bookman'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464845484405431284)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_text=>'Comic Sans MS'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464845869057432779)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_text=>'Courier New'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464845643833432087)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_text=>'Courier'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464847196892433728)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_text=>'Garamond'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464847314743434468)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_text=>'Georgia'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464847559234435283)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_text=>'Helvetica'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464847772316436136)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_text=>'Impact'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464847948844437157)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_text=>'Palatino'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464848312592438571)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_text=>'Times New Roman'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464848153156437827)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_text=>'Times'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464848540078439832)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_text=>'Trebuchet MS'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464848921364440583)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_text=>'Verdana'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464838278902236088)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_text=>'Font Family'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464840040233257655)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_text=>'Select the font size.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464842800611414915)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_text=>'10'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464843082767415464)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_text=>'12'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464843294903416036)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_text=>'14'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464843461725416672)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_text=>'16'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464843611080417289)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_text=>'18'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464843818131417943)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_text=>'20'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464844005225418490)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_text=>'22'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464842611411414295)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_text=>'8'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464838632585243169)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_text=>'Font Size'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464839879269255188)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_text=>'Select the font style.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464844453326422295)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_text=>'Italic'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464844276084421636)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464844658718423316)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_text=>'Oblique'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(464838447279239144)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_text=>'Font Style'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548325432181797311)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_text=>'Select the position of the task labels on the Gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548326467388801918)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_text=>'End'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548327257106805583)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_text=>'The task label is rendered at the end of the task bar on the gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548326621773802668)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_text=>'Inner Center'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548327429223806807)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_text=>'The task label is rendered at the inner center of the task bar on the gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548327061247804251)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_text=>'Inner End'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548327859854809174)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_text=>'The task label is rendered at the inner end of the task bar on the gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548326862164803461)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_text=>'Inner Start'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548327649112808034)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_text=>'The task label is rendered at the inner start of the task bar on the gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548326072981799958)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_text=>'Start'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548326268860801139)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_text=>'The task label is rendered at the start of the task bar on the gantt chart.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(548325256677795878)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_text=>'Task Label Position'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28063729696387463)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>A comma delimited list of colors:</dt>',
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
'<dt>A comma delimited list of page or application items, returning colors, using:</dt>',
'<dd><pre>',
'<code>&amp;ITEM.</code> syntax. For example, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>A comma delimited list of columns, returning colors, using:</dt>',
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code> syntax. For example, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28063542016386104)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the color(s) to be used to identify the upper bound of the threshold(s) to be rendered on a Status Meter Gauge chart.',
'For multiple thresholds, use a comma delimited list.'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24878151870173057)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_text=>'Colors'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73133834801902339)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_text=>'Specify how thresholds are to be displayed on the Status Meter Gauge chart. '
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28062349470371741)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_text=>'All'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28062512358373590)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_text=>'All thresholds, defined using the <strong>Threshold Values</strong> attribute, are displayed in the plot area of the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28063196259378512)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_text=>'Current Threshold Only'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28063355803379895)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_text=>'The current threshold, defined using the <strong>Threshold Values</strong> attribute, is displayed in the plot area of the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28062735688374957)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_text=>'On Indicator'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73133922384902339)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_text=>'The current threshold, defined using the <strong>Threshold Values</strong> attribute, is displayed on the indicator of the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28062115918368711)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_text=>'Display'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(28061967649365875)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>A comma delimited list of static numeric values:</dt>',
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
'<dt>A comma delimited list of page or application items, returning numeric values, using:</dt>',
'<dd><pre>',
'<code>&amp;ITEM.</code> syntax. For example, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>A comma delimited list of columns, returning numeric values, using:</dt>',
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code> syntax. For example, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24877765358108671)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the number(s) to be used to identify the upper bound of the threshold(s) to be rendered on a Status Meter Gauge chart.',
'For multiple thresholds, use a comma delimited list.'))
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24877122666100101)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_text=>'Values'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956854749792516)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118635340321524094)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display the font for the specified attribute.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118629343290492128)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_text=>'Font Color'
,p_version_scn=>37166067046387
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118632585077509613)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_text=>'Select the font family.'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118629789618494174)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_text=>'Arial Black'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118629570558493332)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_text=>'Arial'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118629929393494838)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_text=>'Bookman'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118630112183495797)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_text=>'Comic Sans MS'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118630526263497415)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_text=>'Courier New'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118630348591496631)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_text=>'Courier'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118630776600498355)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_text=>'Garamond'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118630900160499161)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_text=>'Georgia'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118631168595500116)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_text=>'Helvetica'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118631388747500850)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_text=>'Impact'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118631567805501937)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_text=>'Palatino'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118631947428503615)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_text=>'Times New Roman'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118631720591502592)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_text=>'Times'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118632113346505030)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_text=>'Trebuchet MS'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118632396562505844)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_text=>'Verdana'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118628737502488795)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_text=>'Font Family'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118633514325515848)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_text=>'Select the font size.'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118633994387517516)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_text=>'10'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118634185621518100)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_text=>'12'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118634373590518918)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_text=>'14'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118634500681519618)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_text=>'16'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118634714783520362)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_text=>'18'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118634930896521039)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_text=>'20'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118635114767521972)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_text=>'22'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118633750523516590)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_text=>'8'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118629128088491161)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_text=>'Font Size'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118632713334511815)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_text=>'Select the font style.'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118633152984513601)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_text=>'Italic'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118632913703512852)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118633342507514523)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_text=>'Oblique'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118628996629490149)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_text=>'Font Style'
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604819459065298)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_text=>'Select the type of time axis to display on the chart. This setting will automatically render the chart data in chronological order, and should not be used if you require your data to be rendered in reverse chronological order.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604909945065299)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404762915657249751)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_text=>'Apply the Oracle JET defined default time axis setting for the chart, based on the data being rendered.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605051369065299)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404763040317249752)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_text=>'Apply no time axis type setting to the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605176245065300)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404763128889249753)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_text=>'Apply a time axis type setting to the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605257241065300)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_text=>'Mixed Frequency'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256019454739253)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_text=>'The time values displayed on the chart axis in mixed frequency. Since the time value of the data can vary, stacking is not supported.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256199097739254)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_text=>'Skip Gaps'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256236646739255)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_text=>'The time values displayed on the chart axis will be rendered at a regular interval regardless of any time gaps that may exist in the data.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295604773018065298)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_text=>'Time Axis Type'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956784352792514)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046384
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117825348907610588)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display the font for the specified attribute.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046382
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117825189794608731)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_text=>'Font Color'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117808700051565968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_text=>'Select the font family.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117801433552552372)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_text=>'Arial Black'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117801291580551537)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_text=>'Arial'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117801684765553044)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_text=>'Bookman'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117801852025554181)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_text=>'Comic Sans MS'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117802207417555623)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_text=>'Courier New'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117802010965554873)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_text=>'Courier'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117802448294556931)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_text=>'Garamond'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117802698991557855)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_text=>'Georgia'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117803098432558722)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_text=>'Helvetica'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117803212648559386)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_text=>'Impact'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117807786394560219)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_text=>'Palatino'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117808130446562031)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_text=>'Times New Roman'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117807906903560928)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_text=>'Times'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117808365217563130)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_text=>'Trebuchet MS'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117808553890564259)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_text=>'Verdana'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117796421992529299)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_text=>'Font Family'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117809132594569797)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_text=>'Select the font size.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117799473633541803)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_text=>'10'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117799623628545527)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_text=>'12'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117800071341546282)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_text=>'14'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117800329579546900)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_text=>'16'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117800597797547717)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_text=>'18'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117800849228548493)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_text=>'20'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117801033125549352)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_text=>'22'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117799294715541086)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_text=>'8'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117796841348531521)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_text=>'Font Size'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117808922042568219)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_text=>'Select the font style.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117797221893536148)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_text=>'Italic'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117797043586535290)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117797401507538571)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_text=>'Oblique'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117796673913530538)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_text=>'Font Style'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547686045017365115)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_text=>'Specify whether to display vertical gridlines on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547684675349315555)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_text=>'Show Vertical Grid'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353257029506739622)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the zoom and scroll behavior of the chart. <strong>Live</strong> behavior means that the chart will be updated continuously as it is being manipulated,',
'        while <strong>Delayed</strong> means that the update will wait until the zoom/scroll action is done. While <strong>Live</strong> zoom and scroll provides the best end user experience, no guarantees are made',
'        about the rendering performance or usability for large data sets or slow client environments. If performance is an issue, <strong>Delayed</strong> zoom and scroll should be used instead.</p>'))
,p_version_scn=>37166067046537
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605461552065301)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the zoom and scroll behavior of the chart.',
'        Zoom and scroll allows the end user to use gestures, such as dragging on the plot area, using the mouse wheel, or two-finger pinches, to resize the values displayed and navigate within the chart to display different chart values.'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605668772065302)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_text=>'Delayed'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373632423469681212)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_text=>'The change to the data display will wait until the zoom/scroll action is done.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605791595065302)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_text=>'Delayed Scroll Only'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373632585356681213)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_text=>'The change to the data display will wait until the scroll action is done.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605870102065302)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_text=>'Live'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373632678767681214)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Live behavior means that the chart will be updated continuously as it is being manipulated.',
'        For large data sets or slow client environments, it is recommended to select <strong>Delayed</strong>.'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605904766065303)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_text=>'Live Scroll Only'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373632734591681215)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Live Scroll Only behavior means that the chart will be updated continuously as it is being scrolled.',
'        For large data sets or slow client environments, consider selecting <strong>Delayed Scroll Only</strong>.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605599349065301)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_text=>'No'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373632309609681211)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_text=>'Zoom and scroll are disabled for the chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295605307800065301)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_text=>'Zoom and Scroll'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649746940134901128)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_text=>'Select the zoom direction of the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649747012428901128)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_text=>'Both Axes'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649747103215901129)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_text=>'Zooms in both x and y axes direction.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649747201349901130)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_text=>'X-Axis'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649747334983901133)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_text=>'Zooms only in the x-axis direction.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649747410602901134)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_text=>'Y-Axis'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649747574661901134)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_text=>'Zooms only in the y-axis direction.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649746867214901127)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_text=>'Zoom Direction'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547709258175100707)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_text=>'Specify whether to allow zooming to a scale of days on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547706628795080271)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_text=>'Days'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547709026926099155)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_text=>'Specify whether to allow zooming to a scale of hours on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547706066691078116)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_text=>'Hours'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547708856599097471)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_text=>'Specify whether to allow zooming to a scale of minutes on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547705813672077336)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_text=>'Minutes'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547709680157103540)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_text=>'Specify whether to allow zooming to a scale of months on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547707408463083740)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_text=>'Months'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547710075879105331)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_text=>'Specify whether to allow zooming to a scale of quarters on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547707839740085987)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_text=>'Quarters'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547708630136095913)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_text=>'Specify whether to allow zooming to a scale of seconds on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547705246529073497)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_text=>'Seconds'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547709453554102024)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_text=>'Specify whether to allow zooming to a scale of weeks on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547707093778081853)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_text=>'Weeks'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547710284472107822)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_text=>'Specify whether to allow zooming to a scale of years on the chart.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(547708213565087538)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_text=>'Years'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636120107500670)
,p_name=>'PE.PROPERTY.JSON_CONFIGURATION.PROMPT'
,p_message_text=>'JSON Configuration'
,p_version_scn=>37166067046454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(420748414701532413)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_text=>'Specify a client-side condition, to control whether the action fires.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123099318340211792)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a client-side condition to control whether True or False actions fire. If the condition',
'                                  evaluates to True, then True actions fire, if the condition evaluates to False, then False actions fire.',
'                                  If no condition is specified, only True actions fire.'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516757419042751445)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_text=>'Item = Value'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059036090977129)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> is equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516757697045751445)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_text=>'Item > Value'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059296777977131)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> is greater than the <em>Value</em> specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516757725777751446)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_text=>'Item >= Value'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059367372977133)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> is greater than or equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758258034751447)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_text=>'Item is in list'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059821584977139)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> is in the <em>List</em> specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758454295751447)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_text=>'JavaScript expression'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932060062871977141)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_text=>'Evaluates the JavaScript Expression specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516757841246751446)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_text=>'Item < Value'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059431067977135)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> is less than the <em>Value</em> specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516757976473751446)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_text=>'Item <= Value'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059587071977136)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> is less than or equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516757543266751445)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_text=>'Item != Value'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059166833977130)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> is not equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758365681751447)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_text=>'Item is not in list'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059983983977140)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> is not in the <em>List</em> specified.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758102085751447)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_text=>'Item is not null'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059752168977138)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_text=>'Checks if the selected <em>Item</em> is not empty.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516758083653751446)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_text=>'Item is null'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(932059672418977137)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_text=>'Checks if the selected <em>Item</em> is empty.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123099202464211792)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936009524374126448)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the column used in this condition.</p>',
'<p>Note: In the majority of cases this should be the column specified above, in the <em>When Column(s)</em>,',
'and is therefore defaulted to this. However you may want to base the condition on a different column,',
'for example with an Interactive Grid based on the EMP table, if you want to fire a dynamic action',
'whenever <code>SAL</code> changes but only if the <code>JOB</code> equals <em>SALESMAN</em>, then you would change this attribute to <code>JOB</code>.</p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915342504824041661)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936011823024343818)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_text=>'Select whether an <em>Item</em> or <em>Column</em> is used in this condition.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880516938958482137)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_text=>'Column'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880516813425482136)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880516751314482136)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_text=>'Component Type'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(420748566147532414)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_text=>'<p>Enter the page item used in this condition. You can type in the name or pick from the list of available items.</p>'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(420748332574532412)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_text=>'<p>Enter the page item used in this condition. You can type in the name or pick from the list of available items.</p>'
,p_version_scn=>37166067046503
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936009676739126450)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the page item used in this condition. You can type in the name or pick from the list of available items.</p>',
'<p>Note: In the majority of cases this should be the item specified above, in the <em>When Item(s)</em>,',
'and is therefore defaulted to this. However you may want to base the condition on a different page item,',
'for example with a form based on the EMP table, if you want to fire a dynamic action whenever <code>P2_SAL</code> changes but only if the',
'<code>P2_JOB</code> equals <em>SALESMAN</em>, then you would change this attribute to <code>P2_JOB</code>.</p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880517024079482138)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936009476974126446)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_text=>'Enter the page item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915342470399041660)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(420748674288532414)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_text=>'Specify a client-side condition, to control whether the action fires.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915342707462041664)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a client-side condition to control whether True or False actions fire. If the condition',
'                                  evaluates to True, then True actions fire, if the condition evaluates to False, then False actions fire.',
'                                  If no condition is specified, only True actions fire.'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915342855921041666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_text=>'Item / Column = Value'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936009773446126451)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> or <em>Column</em> is equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343098357041668)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_text=>'Item / Column > Value'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936009913796126453)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> or <em>Column</em> is greater than the <em>Value</em> specified.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343112787041669)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_text=>'Item / Column >= Value'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936010091265126454)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> or <em>Column</em> is greater than or equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343621763041674)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_text=>'Item / Column is in list'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936010568135126459)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> or <em>Column</em> is in the <em>List</em> specified.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343856852041675)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_text=>'JavaScript expression'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936010743163126462)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_text=>'Evaluates the JavaScript Expression specified.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343241156041670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_text=>'Item / Column < Value'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936010175377126455)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> or <em>Column</em> is less than the <em>Value</em> specified.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343350183041671)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_text=>'Item / Column <= Value'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936010236473126456)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> or <em>Column</em> is less than or equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915342927517041667)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_text=>'Item / Column != Value'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936009835761126452)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em> or <em>Column</em> is not equal to the <em>Value</em> specified.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343746608041675)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_text=>'Item / Column is not in list'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936010681769126460)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_text=>'Checks if the value of the selected <em>Item</em>  or <em>Column</em> is not in the <em>List</em> specified.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343584995041673)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_text=>'Item / Column is not null'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936010487787126458)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_text=>'Checks if the selected <em>Item</em> or <em>Column</em> is not empty.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343498025041672)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_text=>'Item / Column is null'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(936010335177126457)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_text=>'Checks if the selected <em>Item</em> or <em>Column</em> is empty.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915342673465041663)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(420748287849532186)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the JavaScript Expression to be evaluated for this condition.',
'The code has access to the following dynamic action related attributes:</p>',
'<dl>',
'  <dt>this.triggeringElement</dt>',
'    <dd>A reference to the DOM object of the element that triggered the dynamic action.</dd>',
'  <dt>this.browserEvent</dt>',
'    <dd>The event object that triggered the event. Note: On load this is equal to ''load''.</dd>',
'  <dt>this.data</dt>',
'    <dd>Optional additional data that can be passed from the event handler.</dd>',
'</dl>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(420748116771532185)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915344473682041680)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the JavaScript Expression to be evaluated for this condition.',
'The code has access to the following dynamic action related attributes:</p>',
'<dl>',
'  <dt>this.triggeringElement</dt>',
'    <dd>A reference to the DOM object of the element that triggered the dynamic action.</dd>',
'  <dt>this.browserEvent</dt>',
'    <dd>The event object that triggered the event. Note: On load this is equal to ''load''.</dd>',
'  <dt>this.data</dt>',
'    <dd>Optional additional data that can be passed from the event handler.</dd>',
'</dl>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915344332649041679)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915342347451041542)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_text=>'Enter the comma separated list of values for this condition.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915342258988041537)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915344203848041679)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_text=>'Enter the comma separated list of values for the condition to test.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915344135273041678)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1631774497053881133)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_text=>'Enter the value for this condition.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1631774344195881133)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915344050827041677)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_text=>'Enter the value for the condition to test.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(915343920916041676)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123100817888211796)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript code to execute when the page loads.',
'The code is executed after the JavaScript code generated by &PRODUCT_NAME..</p>',
'<p>Code you enter here replaces the <code>#GENERATED_JAVASCRIPT#</code> substitution string in the page template.</p>',
'<p>Note: You do not need to add any opening or closing <code>script</code> tags, just the JavaScript code.</p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123100719218211796)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_text=>'Execute when Page Loads'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749016351751416)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Standard file reference</dt>',
'<dd><pre>/myjs/main.js</pre></dd>',
'<dt>Standard file reference which loads the minified file <code>main.min.js</code> from <code>/myjs/minified/</code> for regular page views and <code>main.js</code> from <code>/myjs/</code> in debug mode or when running the application from App Build'
||'er.</dt>',
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
'<dt>Use this syntax if the library is also used from a RequireJS require call. The define name must match what is used in the requirejs.config paths and the value must be the global symbol exposed by the library. Only applies when using RequireJS. Th'
||'is avoids RequireJS  loading that library a second time.</dt>',
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
'<dt>Use this syntax if the file has a dependency on RequireJS. This will automatically load RequireJS before this file.</dt>',
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
'<dt>Use this syntax if the file has a dependency on Oracle JET. This will automatically load RequireJS and the Oracle JET RequireJS configuration before this file.</dt>',
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
'<dt>Use this syntax if the file is a JavaScript ES Module. It will add <code>type="module"</code> to the script tag.</dt>',
'<dd><pre>[module]/myjs/main.js</pre></dd>',
'<dt>Use this syntax if the file should be loaded asynchronously. It will add attribute <code>async</code> to the script tag.</dt>',
'<dd><pre>[async]/myjs/main.js</pre></dd>',
'<dt>Use this syntax if the file should only be executed after the document was been parsed. It will add attribute <code>defer</code> to the script tag. Note that modules are deferred by default.</dt>',
'<dd><pre>[defer]/myjs/main.js</pre></dd>',
'<dt>Multiple File URL directives can be provided but must be comma separated.</dt>',
'<dd><pre>[module, async]/myjs/main.js</pre></dd>',
'<dt>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser is instructed to always load the new file and ignore any previously cache'
||'d files.</dt>',
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123100427149211794)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript file URLs for code loaded on this page. Each URL must be written on a new line.',
'If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <code>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty'
||' string if the page is viewed in debug mode or when running the application from App Builder.',
'You also have access to the substitution string <code>#APP_VERSION#</code> if you want to include the application''s version in the file URL.</p>',
'<p>JavaScript file URLs you enter here replaces the <code>#PAGE_JAVASCRIPT#</code> substitution string in the page template.</p>',
'<p>Each file URL can be prefixed with a pair of brackets (<code>[...]</code>) containing one or more of the following directives. See the examples for details.</p>',
'<p><ul>',
'    <li>module</li>',
'    <li>defer</li>',
'    <li>async</li>',
'    <li>define</li>',
'    <li>require requirejs</li>',
'    <li>require jet</li>',
'</ul></p>',
'<p>Note: You do not need to include opening or closing <code>script</code> tags. Just specify the URL.</p>',
'<p>To comment out a File URL, prefix the line with two dashes: <code>--</code>. To comment out multiple lines, use the typical code block syntax: <code>/* */</code>.</p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123100318953211793)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_text=>'File URLs'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123100610743211795)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript code such as functions or global variable declarations referenced on this page.',
'To reference a shortcut, use <code>"SHORTCUTNAME"</code>.',
'If the same JavaScript is required on multiple pages, consider putting the code into an external JavaScript file to avoid duplication and to leverage browser caching of static files.</p>',
'<p>Code you enter here replaces the <code>#PAGE_JAVASCRIPT#</code> substitution string in the page template.</p>',
'<p>Note: You do not need to include opening or closing <code>script</code> tags. Just include the JavaScript code.</p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123100504217211794)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_text=>'Function and Global Variable Declaration'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(728449279756156906)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the label for the facet.',
'    The label displays on the page only if the facet displays. The label for type <strong>Search</strong> is visually hidden, but available to assistive technology.</p>'))
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584821432913747883)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_text=>'~Enter the label of the facet group.~'
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584822050456747884)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the label for the facet.',
'    The label displays on the page only if the facet displays. The label for type <strong>Search</strong> is visually hidden, but available to assistive technology.</p>'))
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311937028300864)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_text=>'Override Label to use for search result display. If not specified, the label of the search configuration will be used.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600642847784511)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.PAGE_ITEM.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ensure labels accurately describe the purpose of form controls, aiding users in form completion.</p>',
'<strong>Best Practices:</strong>',
'<ul><li><strong>Clear and Concise Text:</strong> Use descriptive yet brief labels for clarity.</li></ul>'))
,p_version_scn=>36587278
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509866489670637)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the label for the filter.',
'    The label displays on the page only if the filter displays. The label for type <strong>Search</strong> is visually hidden, but available to assistive technology.</p>'))
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136510784417670633)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_text=>'~Enter the label of the filter group.~'
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136511152467670632)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the label for the filter.',
'    The label displays on the page only if the filter displays. The label for type <strong>Search</strong> is visually hidden, but available to assistive technology.</p>'))
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117341306897910321)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.WORKFLOW_ACTIVITY.HELP'
,p_message_text=>'An optional, user friendly, translatable label for the activity.'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117341698277910321)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.WORKFLOW_ACTIVITY_VARIABLE.HELP'
,p_message_text=>'An end-user friendly name of the activity variable.'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117339222174910317)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.WORKFLOW_PARAM.HELP'
,p_message_text=>'An end-user friendly name of the workflow parameter.'
,p_version_scn=>37166067046558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117339893757910318)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.WORKFLOW_VARIABLE.HELP'
,p_message_text=>'An end-user friendly name of the workflow parameter.'
,p_version_scn=>37166067046558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123151122864211881)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the field label for the page item.',
'The label displays on the page only if the item displays.',
'Depending on the label alignment and the display, the label displays either in its own HTML table cell or in the same cell.</p>',
'<p>Item labels can include shortcuts using <code>"SHORTCUT_NAME"</code> syntax.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123151004762211881)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_text=>'Label'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123151322565211882)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the label alignment. Labels can display above, below, or to the left of the item.',
'When the label displays next to a form element, it occupies its own HTML table cell.',
'By changing this label alignment, you can control the label''s position within that table cell.'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760829463751458)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_text=>'Above '
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516760940694751458)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_text=>'Below'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761126712751459)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_text=>'Center bottom'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761216039751459)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_text=>'Center center'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761381135751459)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_text=>'Center top'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761014971751458)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_text=>'Center'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761537921751460)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_text=>'Left bottom'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761673963751460)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_text=>'Left center'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761728792751460)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_text=>'Left top'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761456357751459)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_text=>'Left'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761965272751460)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_text=>'Right bottom'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762010093751460)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_text=>'Right center'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516762154018751460)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_text=>'Right top'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516761809117751460)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_text=>'Right'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123151216068211882)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_text=>'Alignment'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601840461921178)
,p_name=>'PE.PROPERTY.LANDMARK_LABEL.COMPONENT_PROPERTY.REGION.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>It is important to provide good labels that truly improve user experience. Good labels are defined as follows:',
'<ul>',
'<li>Unique on a page, and not too long (preferably 3 words or less).</li>',
'<li>Accurately describe the purpose of the contents of the region, for example ''Edit Employee'', or ''Useful Links''.</li>',
'<li>Do not use the landmark role in the label, for example the label for a navigation landmark for an application should just be ''Application'', rather than ''Application Navigation'', to avoid screen readers announcing ''navigation'' twice.</li>',
'</ul>',
'</p>'))
,p_version_scn=>7533463
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121751180635479814)
,p_name=>'PE.PROPERTY.LANDMARK_LABEL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Define a custom label for the landmark. Note: If no label is defined, the region title will be used as the landmark label. For more information on landmarks, see <a rel="noopener noreferrer" href="#SYSTEM_HELP_URL#CSH:pd-landmark-label" target="_b'
||'lank">Page Structure - Landmarks</a>.</p>',
'<p>It is important to provide good labels that truly improve user experience. Good labels are defined as follows:',
'<ul>',
'<li>Unique on a page, and not too long (preferably 3 words or less).</li>',
'<li>Accurately describe the purpose of the contents of the region, for example ''Edit Employee'', or ''Useful Links''.</li>',
'<li>Do not use the landmark role in the label, for example the label for a navigation landmark for an application should just be ''Application'', rather than ''Application Navigation'', to avoid screen readers announcing ''navigation'' twice.</li>',
'</ul>',
'</p>',
''))
,p_version_scn=>1112210319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121751095746479814)
,p_name=>'PE.PROPERTY.LANDMARK_LABEL.PROMPT'
,p_message_text=>'Landmark Label'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000598324858872)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.COMPONENT_PROPERTY.REGION.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Why landmark types matter:',
'<ul>',
'<li>Clarity & Navigation: Each type signifies a specific section''s purpose, helping users understand and navigate the page efficiently.</li>',
'<li>Accessibility Tools: Screen readers and other assistive technologies depend on these landmarks to offer context and streamline user interaction.</li>',
'<li>Standardized Structure: Choosing the right landmark type promotes a consistent and intuitive browsing experience for all users.</li>',
'</ul>',
'</p>'))
,p_version_scn=>11393298
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121751249984479909)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'Template Default'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121751314638479909)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_text=>'Uses the default landmark type defined in the region template.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121749398895479812)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>There are 8 different landmark types available to use. 7 of the 8 have specific meanings and will be suitable under certain circumstances (eg "search" for a region containing search functionality, "navigation" for a region containing navigation fu'
||'nctionality). The final type is "region", which is suitable in the case where no specific landmark is appropriate, but where you still want to include the region as a landmark on the page.</p>',
'<p>For more information on landmarks, see <a rel="noopener noreferrer" href="#SYSTEM_HELP_URL#CSH:pd-landmark-type" target="_blank">Page Structure - Landmarks</a>.</p>',
''))
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6202180214797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.BANNER.D'
,p_message_text=>'Banner'
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6202216160797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.BANNER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>A <code>banner</code> landmark identifies application-oriented content at the beginning of each page within your APEX application.',
'Within APEX, this will usually be everything contained within the top bar, for example application logo, name and navigation bar controls,',
'(but this could vary depending on your application, the theme you are using, or the template).',
'<p>Pages will usually only have one <code>banner</code> landmark, and the most common pattern for APEX pages will be for this <code>banner</code>',
'landmark to come from the page template, meaning defining page regions as <code>banner</code> regions in APEX will likely be rare.</p>',
''))
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6202325683797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.COMPLEMENTARY.D'
,p_message_text=>'Complementary'
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6202436466797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.COMPLEMENTARY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>A <code>complementary</code> landmark is a supporting section of a page, designed to be <code>complementary</code> to the main',
'content at a similar level in the DOM hierarchy, but remains meaningful when separated from the main content.</p>',
''))
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6202523066797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.CONTENTINFO.D'
,p_message_text=>'Content Info'
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6202699758797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.CONTENTINFO.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>A <code>contentinfo</code> landmark is a way to identify common information at the bottom of each page of an application, typically',
'called the "footer" of the page.</p>',
'<p>Pages will usually only have one <code>contentinfo</code> landmark, and the most common pattern for APEX pages will be for this <code>contentinfo</code>',
'landmark to come from the page template, meaning defining page regions as <code>contentinfo</code> regions in APEX will likely be rare.</p>',
''))
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6202771166797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.FORM.D'
,p_message_text=>'Form'
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6202849745797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.FORM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>A <code>form</code> landmark identifies a region that contains a collection of elements (usually page items and buttons) that, as a whole, combine to create a form when no other named landmark is appropriate (e.g. main or search).</p>',
''))
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6202991807797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.MAIN.D'
,p_message_text=>'Main'
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203008102797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.MAIN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>A <code>main</code> landmark identifies the primary content of the page.</p>',
'<p>Each page should have one <code>main</code> landmark, and the most common pattern for APEX pages will be for this <code>main</code>',
'landmark to come from the page template, meaning usually there will be no need to define individual regions as <code>main</code>',
'landmarks.</p>',
''))
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203172102797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.NAVIGATION.D'
,p_message_text=>'Navigation'
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203234049797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.NAVIGATION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p><code>Navigation</code> landmarks provide a way to identify groups (e.g. lists) of links that are intended to be used for application',
'or page content navigation.</p>',
''))
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203376765797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.REGION.D'
,p_message_text=>'Region'
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203445953797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.REGION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>A <code>region</code> landmark is a perceivable section containing content that is relevant to a specific purpose and sufficiently',
'important that users will likely want to be able to navigate to the section easily and to have it listed in a summary of the page.',
'This is probably the most common landmark type for APEX regions.</p>',
'<p>The <code>region</code> landmark can be used to identify content that the other named landmarks do not appropriately describe.</p>',
''))
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203500559797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.SEARCH.D'
,p_message_text=>'Search'
,p_version_scn=>9556749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203640394797579)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.LOV.SEARCH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>A <code>search</code> landmark contains a collection of elements (usually page items and buttons) that, as a whole, combine to create',
'search functionality to content in the application.</p>',
''))
,p_version_scn=>9556750
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121749281945479812)
,p_name=>'PE.PROPERTY.LANDMARK_TYPE.PROMPT'
,p_message_text=>'Landmark Type'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(759826823387201321)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to load the region independently of the data for the region.</p>',
'        <p>When lazy loading is specified, the page is rendered immediately, showing an empty region, until the data is loaded.',
'        Generally, the page is not displayed until all of the page is loaded and ready to be rendered.',
'        Therefore, if it takes 5 seconds to load all of the data for a region, without lazy loading, the end user would have to wait 5 seconds before the page started to render.</p>',
'        <p>Note - Lazy Loading should only be utilized on data sets that take significant time to load, as this adds unnecessary processing overhead on the database for regions that load quickly.</p>'))
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974881523481118)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to load the region independently of the data for the region.</p>',
'        <p>When lazy loading is specified, the page is rendered immediately, showing an empty region, until the data is loaded.',
'        Generally, the page is not displayed until all of the page is loaded and ready to be rendered.',
'        Therefore, if it takes 5 seconds to load all of the data for a region, without lazy loading, the end user would have to wait 5 seconds before the page started to render.</p>',
'        <p>Note - Lazy Loading should only be utilized on data sets that take significant time to load, as this adds unnecessary processing overhead on the database for regions that load quickly.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974783201481118)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_text=>'Lazy Loading'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567456607883315482)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_text=>'Specify whether layer visibility can be toggled by clicking its name in the legend.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567456526149315482)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_text=>'Enable to Hide'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567456841626315504)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_text=>'Specify the Icon to display for this layer in the legend.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567456737496315504)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_text=>'Icon CSS Classes'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611174695065321)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_text=>'Select the position of a legend on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611288340065322)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611571136065323)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_text=>'Bottom'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611434225065323)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_text=>'End'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611324685065322)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_text=>'Start'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611681569065323)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_text=>'Top'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295611034582065321)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_text=>'Position'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603548256784548)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.COMPONENT_PROPERTY.JET_CHART.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When it comes to accessibility best practices for charts, it''s essential to consider how to make the information contained within the chart accessible to all users, including those with disabilities.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Text Equivalents:</strong> If the chart legend contains crucial information that is not otherwise available in the chart itself, then it should be included in the chart.',
'</li>',
'</ul>'))
,p_version_scn=>36587326
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295610908764065321)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_text=>'Specify whether a legend should be rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295610842276065320)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567457068399315682)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_text=>'Specify the title of the legend.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388657084397170394)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_text=>'Enter a title to display at the top of the chart legend.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388656923920170394)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_text=>'Title'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753838871661396)
,p_name=>'PE.PROPERTY.LICENSE_MESSAGE.PROMPT'
,p_message_text=>'License'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619811575065352)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_text=>'Specify the style of the line to be rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620040257065353)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_text=>'Dashed'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619924170065352)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_text=>'Dotted'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620129358065353)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_text=>'Solid'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295619733053065352)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_text=>'Style'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620695812065355)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_text=>'Specify the type of line to be rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620742303065355)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046368
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621099431065356)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_text=>'Centered Segmented'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620843705065356)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_text=>'Centered Stepped'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620996129065356)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_text=>'Curved'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621323772065358)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621255090065357)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_text=>'Segmented'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621195818065357)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_text=>'Stepped'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621402304065358)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_text=>'Straight'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620558136065355)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620376536065354)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_text=>'Specify the width of the line to be rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620244976065354)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_text=>'Width'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295620419013065354)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779782087751536)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Open the link in a new window</dt>',
'<dd><pre>target="_blank"</pre></dd>',
'<dt>Show a tooltip on hover</dt>',
'<dd><pre>title="Click to edit"</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360495808236274749)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_text=>'Enter additional column link attributes to be included in the <code>&lt;a href=...&gt;</code> tag, including link target, classes or styles.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360495716099274749)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_text=>'Link Attributes'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873400949183857)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_text=>'Select an authorization scheme to associate with the Link Column. This authorization scheme must evaluate to TRUE in order for the Link Column to be rendered in the report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873323608183857)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203105487982797)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203546749982797)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203498091982797)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203300669982797)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203630589982797)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203252351982797)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130203012037982797)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103602033276414)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103972953276414)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103800788276414)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103768400276414)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104005851276414)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61103587979276414)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360889903110183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360889828788183886)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360891329534183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360891219936183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600272119699090611)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Expression for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600272042370090611)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600273764842090612)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600273605818090612)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608826504484642)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600271801928090611)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Expression for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600271716974090611)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609047833484643)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600273404328090612)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600273339911090612)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890118358183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_text=>'Enter a colon(:) separated list of values for this condition.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890026530183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890513687183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_text=>'Enter the Page Number for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890432673183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_text=>'Page'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890725828183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_text=>'Enter a comma separated list of Page Numbers for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890613442183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_text=>'Pages'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608777096484641)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600271563614090611)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Expression for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600271403929090611)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608902970484643)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600273186473090612)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600273005316090612)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890326915183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_text=>'Enter a User Preference that is compared against the specified value for this condition.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890220058183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_text=>'Preference'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600272378545090611)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Expression for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600272233593090611)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600273960171090613)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600273842182090612)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608627825484641)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600271222922090610)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a SQL Expression for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600271199787090610)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175608531689484639)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully as one or more rows exist when checking if the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>To return successfully as no rows exist when checking if the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360888902224183886)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_text=>'Enter a SQL query for this condition.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360888821035183886)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890917752183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_text=>'Enter the text value for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360890803030183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360891519797183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360891418097183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360882519335183881)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_text=>'Select a condition type that must be met in order for this link to be rendered.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935971254751974)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599840098840464474)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_text=>'The component will always be rendered or executed.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934583783751970)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_text=>'Client Browser is Microsoft Internet Explorer 7.0 or higher'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934692813751971)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_text=>'Client Browser is XHTML / CSS capable browser'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934486032751970)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_text=>'Client Browser is Mozilla, Netscape 6.x/7x or higher'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934729861751971)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_text=>'Client Browser is Other browsers (or older version)'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933192499751968)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_text=>'Text is contained in Item'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935147978751972)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_text=>'Current Language = Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843840456464494)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_text=>'The end user is currently running the application in the language you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934844750751971)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_text=>'Current Language is contained in Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599844092194464495)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_text=>'The end user is currently running the application in one of the languages you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935030288751972)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_text=>'Current Language != Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843923127464494)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_text=>'The end user is not currently running the application in the language you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934944443751972)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_text=>'Current Language is NOT contained in Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599844196396464495)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_text=>'The end user is not currently running the application in one of the languages you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932395263751966)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_text=>'Current Page = Page'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842640940464487)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_text=>'The current page is equal to the value you enter into <em>Page</em>.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932523636751966)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_text=>'Current Page is in comma delimited list'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842898397464488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_text=>'The current page is in the comma separated list you enter into <em>Pages</em>.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932438963751966)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_text=>'Current Page != Page'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842765855464488)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_text=>'The current page is not equal to the value you enter into <em>Page</em>.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932687764751967)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_text=>'Current Page is NOT in comma delimited list'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842931845464489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_text=>'The current page is not in the comma separated list you enter into <em>Pages</em>.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935296126751972)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: DAD_NAME = Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935348597751972)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: DAD_NAME != Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934032731751969)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_text=>'Inline Validation Errors displayed'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843634935464493)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_text=>'An inline validation error is displayed on the page, following a page submission.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933492740751968)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_text=>'Text = Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933253093751968)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_text=>'Text is contained in Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933358379751968)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_text=>'Text is NOT contained in Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933549848751969)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_text=>'Text != Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929885359751961)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599840147741464474)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_text=>'The SQL query returns one or more rows.'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600270270948090602)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600270392446090602)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'The expression evaluates to TRUE.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516930215899751962)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599840509742464476)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'The function body returns TRUE.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935647934751973)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: HTTP_HOST = Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935736087751973)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: HTTP_HOST != Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933766892751969)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_text=>'Page/Region is NOT Read Only'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843385129464491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_text=>'The page and parent region, if appropriate, are displayed normally.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933636088751969)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_text=>'Page/Region is Read Only'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843296548464491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_text=>'Either the page or parent region, if appropriate, ''Read Only'' condition evaluates to TRUE.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931568778751964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_text=>'Item contains no spaces'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841827163464483)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_text=>'The value of the selected <em>Item</em> has no spaces.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931855012751965)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_text=>'Item is alphanumeric'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842117005464484)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is alphanumeric, containing only letters or numbers and no special characters.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931008742751963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_text=>'Item is NOT NULL'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841394308464480)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not empty.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931712438751965)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_text=>'Item is NOT numeric'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842055806464484)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not numeric.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931200680751964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_text=>'Item is NOT zero'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841500318464481)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not the number zero.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516930967267751963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_text=>'Item is NULL'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841230053464480)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is empty.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931396871751964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_text=>'Item is NULL or zero'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841632547464482)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is empty or the number zero.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931632817751964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_text=>'Item is numeric'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841944899464483)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is numeric.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931154926751964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_text=>'Item is zero'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841437840464481)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is the number zero.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931422325751964)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_text=>'Item is NOT NULL and NOT zero'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841727972464482)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not empty and not the number zero.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934271376751970)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_text=>'SQL Reports (OK to show the forward button)'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934387612751970)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_text=>'SQL Reports (OK to show the back button)'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935810625751974)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046478
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599844297126464497)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The component is never rendered or executed.</p>',
'<p>Note: Changing a condition to <strong>Never</strong> will remove any existing condition. For temporarily disabling a component, Oracle recommends using the <em>Build Option</em> attribute instead.</p>'))
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516934163022751970)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_text=>'Inline Validation Errors NOT displayed'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843785262464493)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_text=>'An inline validation error is not displayed on the page.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516929910791751961)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599840209910464475)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_text=>'The SQL Query returns no rows'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932909000751967)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_text=>'Current Page is in Printer Friendly Mode'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843008363464489)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_text=>'The current page has been toggled to ''Printer Friendly Mode'' by the end user.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933030556751968)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_text=>'Current page is NOT in Printer Friendly Mode'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843157645464490)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_text=>'The current page has not been toggled to ''Printer Friendly Mode'' by the end user.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516930352069751962)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_text=>'Request = Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599840688329464477)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_text=>'The page request is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516930582560751962)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_text=>'Request is contained in Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599840880795464477)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_text=>'The page request is contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516930402098751962)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_text=>'Request != Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599840724574464477)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_text=>'The page request is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516930653602751962)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_text=>'Request is NOT contained in Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599840941805464478)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_text=>'The page request is not contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935495505751973)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: SERVER_NAME = Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516935550404751973)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: SERVER_NAME != Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933807605751969)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_text=>'User is Authenticated (not public)'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843410457464491)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_text=>'The end user is logged into the application.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516933908174751969)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_text=>'User is the Public User (user has not authenticated)'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599843533447464492)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_text=>'The end user is not logged into the application.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932107517751966)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_text=>'User Preference = Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842432396464486)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_text=>'The value of the <em>Preference</em> entered is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932239122751966)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'User Preference != Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842533426464487)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_text=>'The value of the <em>Preference</em> entered is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516931976163751965)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is in colon delimited list'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842222496464485)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is completely contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932094252751966)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is NOT in colon delimited list'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599842392552464485)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not completely contained in the text you entered into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516930771566751962)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_text=>'Item = Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841097403464479)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516930871792751963)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'Item != Value'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599841189910464479)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932874512751967)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_text=>'Current Page != Page Submitted (posted)'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516932700613751967)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_text=>'Current Page = Page Submitted (posted)'
,p_version_scn=>37166067046475
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360882406086183881)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_text=>'Condition Type'
,p_version_scn=>37166067046474
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360889710988183886)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_text=>'Enter the value to compare against the condition.'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360889631334183886)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046478
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360891111687183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360891018513183887)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489470349344203315)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Report regions can be printed using the standard print link, shown below the report region, or using a button. If you want to use a button, remove the link label and create a button on your page, using the URL shown in Print URL as the button targ'
||'et.</p>',
'<p>Using buttons to print report regions enables you to set session state. This is useful if you are planning to support printing to several different output formats (Word, Excel, PDF, and so on) and want to display a button, link, or image for each '
||'option. For this implementation, use the output format derived from item option and include the item name and value in your Print URL.</p>'))
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596947823322296926)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>View the URL link for this saved report. This attribute is view only and cannot be updated.</p>',
'    <p>This attribute enables you to quickly copy the displayed URL. This URL can be used to link directly to this particular saved report from anywhere else in the application.</p>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489496883565590656)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Report regions can be printed using the standard print link, shown below the report region, or using a button. If you want to use a button, remove the link label and create a button on your page, using the URL shown in Print URL as the button targ'
||'et.</p>',
'<p>Using buttons to print report regions enables you to set session state. This is useful if you are planning to support printing to several different output formats (Word, Excel, PDF, and so on) and want to display a button, link, or image for each '
||'option. For this implementation, use the output format derived from item option and include the item name and value in your Print URL.</p>'))
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360946216296486683)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>View the URL link for this saved report. This attribute is view only and cannot be updated.</p>',
'<p>This attribute enables you to quickly copy the displayed URL. This URL can be used to link directly to this particular saved report from anywhere else in the application.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360946130575486681)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_text=>'Link Example'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873229266183857)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_text=>'Enter the HTML to be used for the link. Use an image tag to display images, or pick from the list of default images.  If not defined, <code>#APEX_FILES#ws/small_page.gif</code> is used.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873123718183857)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_text=>'Link Icon'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360893108175400252)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Click the Target to invoke a modal dialog. You can enter a custom target to be called when the Link Column is clicked.</p>',
'        <p>Select the appropriate type in Link Builder - Target based on your requirements:',
'        <dl>',
'        <dt>Page in this application</dt>',
'        <dd>Enter the following:',
'        <ul>',
'        <li>Page - enter the page number or page alias to navigate to. You can also select the page number from the select list.</li>',
'        <li>Set Items: Name - enter or select page items (<code>P3_ID</code>), application items (<code>LAST_PAGE</code>) or interactive report filters (<code>IR_EMPNO</code>) to be set into session state.</li>',
'        <li>Set Items: Value - enter or select a report column (<code>#ID#</code>), enter an application or page item (<code>&P2_EMPNO.</code>), or enter a static value (<code>2</code>).</li>',
'        <li>Clear Cache - enter a comma-delimited list of page numbers (<code>2,3</code>), items (<code>P3_EMPNO,LAST_PAGE</code>), and report settings to be cleared. To reset pagination for a report enter <code>RP</code>. To clear or reset interacti'
||'ve report settings enter <code>CIR</code> or <code>RIR</code>.</li>',
'        <li>Reset Pagination - select Yes to reset pagination, back to the first set of records, for reports on the target page. This has the same affect as passing <code>RP</code> in Clear Cache.</li>',
'        <li>Advanced: Request - enter the request to be used.</li>',
'        </ul>',
'        </dd>',
'        <dt>Page in a different application</dt>',
'        <dd>Enter the same attributes as listed for Page in this application, with the addition that you need to enter the application ID or application alias for Application.</dd>',
'        <dt>URL</dt>',
'        <dd>Enter the URL</dd>',
'        </dl></p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360893013895400252)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_text=>'Target'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567457490782315686)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_text=>'Select the action to be performed when an object on the map is clicked.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295615525848065337)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_text=>'Select the action to be performed when the chart is clicked.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(249209000656561628)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_text=>'Redirect to URL returned by First Column'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(249209177715561629)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_text=>'Redirect to the target URL returned by the first column of the SQL query.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295615885313065338)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_text=>'Redirect to Page in a different Application'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295615997019065338)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Redirect to a page in a different application, with optional additional attributes for resetting pagination, setting the request value, clearing cache and setting item values, on the target page.</p>',
'<p>Note: Redirecting to a page in different application relies on deep linking being enabled in the target application. To enable deep linking, go to the application''s <em>Security</em> attributes and enable <em>Deep Linking</em>.</p>'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295615659122065337)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_text=>'Redirect to Page in this Application'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295615737392065338)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_text=>'Redirect to a page in the current application, with optional additional attributes for resetting pagination, setting the request value, clearing cache and setting item values, on the target page.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295616062137065339)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_text=>'Redirect to URL'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295616113028065339)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_text=>'Redirect to the target URL you specify.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295615442383065337)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603032405784545)
,p_name=>'PE.PROPERTY.LINK_TEXT.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Accessible link text is essential for users of assistive technologies, such as screen readers, to navigate and understand content effectively.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Conciseness:</strong> Keep link text concise while ensuring it conveys the necessary information. Aim for a balance between brevity and descriptiveness.</li>',
'<li><strong>Accessibility Attributes:</strong> Ensure report column row headers are defined. Defining this attribute improves the navigation experience for screen reader users by providing clear orientation points within the tabular data.</li>',
'<li><strong>Repeated links:</strong> In a typical report, each row often features a repeating link, such as an edit option. In such cases, the most effective link text would be ''Edit'', and paired with a clear row header.</li>',
'</ol>',
'<p>By following these best practices for link text, you can create a more inclusive and accessible browsing experience for all users, including those with disabilities.</p>'))
,p_version_scn=>12189419
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602491913784529)
,p_name=>'PE.PROPERTY.LINK_TEXT.COMPONENT_PROPERTY.IG_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Accessible link text is essential for users of assistive technologies, such as screen readers, to navigate and understand content effectively.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Conciseness:</strong> Keep link text concise while ensuring it conveys the necessary information. Aim for a balance between brevity and descriptiveness.</li>',
'<li><strong>Accessibility Attributes:</strong> Ensure report column row headers are defined. Defining this attribute improves the navigation experience for screen reader users by providing clear orientation points within the tabular data.</li>',
'<li><strong>Repeated links:</strong> In a typical report, each row often features a repeating link, such as an edit option. In such cases, the most effective link text would be ''Edit'', and paired with a clear row header.</li>',
'</ol>',
'<p>By following these best practices for link text, you can create a more inclusive and accessible browsing experience for all users, including those with disabilities.</p>'))
,p_version_scn=>12189406
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601990457784526)
,p_name=>'PE.PROPERTY.LINK_TEXT.COMPONENT_PROPERTY.IR_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Accessible link text is essential for users of assistive technologies, such as screen readers, to navigate and understand content effectively.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Conciseness:</strong> Keep link text concise while ensuring it conveys the necessary information. Aim for a balance between brevity and descriptiveness.</li>',
'<li><strong>Accessibility Attributes:</strong> Ensure report column row headers are defined. Defining this attribute improves the navigation experience for screen reader users by providing clear orientation points within the tabular data.</li>',
'<li><strong>Repeated links:</strong> In a typical report, each row often features a repeating link, such as an edit option. In such cases, the most effective link text would be ''Edit'', and paired with a clear row header.</li>',
'</ol>',
'<p>By following these best practices for link text, you can create a more inclusive and accessible browsing experience for all users, including those with disabilities.</p>'))
,p_version_scn=>12189401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603391024784546)
,p_name=>'PE.PROPERTY.LINK_TEXT.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Accessible link text is essential for users of assistive technologies, such as screen readers, to navigate and understand content effectively.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Conciseness:</strong> Keep link text concise while ensuring it conveys the necessary information. Aim for a balance between brevity and descriptiveness.</li>',
'<li><strong>Accessibility Attributes:</strong> Ensure report column row headers are defined. Defining this attribute improves the navigation experience for screen reader users by providing clear orientation points within the tabular data.</li>',
'<li><strong>Repeated links:</strong> In a typical report, each row often features a repeating link, such as an edit option. In such cases, the most effective link text would be ''Edit'', and paired with a clear row header.</li>',
'</ol>',
'<p>By following these best practices for link text, you can create a more inclusive and accessible browsing experience for all users, including those with disabilities.</p>'))
,p_version_scn=>12189420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360495605071274749)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_text=>'Enter the HTML text to be shown as a link. Use an image tag to display images, or pick from the list of default images.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360495500482274749)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_text=>'Link Text'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112190027276430)
,p_name=>'PE.PROPERTY.LIST_FUNC_BODY_LANG_SQL.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112046427276430)
,p_name=>'PE.PROPERTY.LIST_FUNC_BODY_LANG_SQL.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111908750276430)
,p_name=>'PE.PROPERTY.LIST_FUNC_BODY_LANG_SQL.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61112265222276430)
,p_name=>'PE.PROPERTY.LIST_FUNC_BODY_LANG_SQL.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111866849276430)
,p_name=>'PE.PROPERTY.LIST_FUNC_BODY_LANG_SQL.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577154285340720)
,p_name=>'PE.PROPERTY.LIST_ID.HELP'
,p_message_text=>'Identifies the list.'
,p_version_scn=>49870256
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577087618340720)
,p_name=>'PE.PROPERTY.LIST_ID.PROMPT'
,p_message_text=>'List'
,p_version_scn=>49870255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242759457232661465)
,p_name=>'PE.PROPERTY.LIST_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Java Function Body returning SQL Query'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614603702484673)
,p_name=>'PE.PROPERTY.LIST_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display department name</dt>',
'<dd><pre>',
'return "select null as level, dname as label from dept order by dname";',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242759345259661465)
,p_name=>'PE.PROPERTY.LIST_JS_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'JavaScript Function Body returning SQL Query'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614544285484673)
,p_name=>'PE.PROPERTY.LIST_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display department names</dt>',
'<dd><pre>',
'begin',
'    return ''select null as level, dname as label from dept order by dname'';',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242759274214661465)
,p_name=>'PE.PROPERTY.LIST_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'PL/SQL Function Body returning SQL Query'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242759558756661466)
,p_name=>'PE.PROPERTY.LIST_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Python Function Body returning SQL Query'
,p_version_scn=>37166067046485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692022888661306)
,p_name=>'PE.PROPERTY.LIST_SQL_QUERY.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752223809661394)
,p_name=>'PE.PROPERTY.LIST_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783411305506)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a template to define the appearance and layout of this list.</p>',
'        <p>List templates are defined in the application theme.',
'        When a list region is created, the template is automatically set to the default list template defined in the current theme.</p>',
'        <p>Universal Theme provides the following list templates:',
'          <dl>',
'            <dt>Badge List</dt>',
'            <dt>Cards</dt>',
'            <dt>Links List</dt>',
'            <dt>Media List</dt>',
'            <dt>Menu Bar</dt>',
'            <dt>Menu Popup</dt>',
'            <dt>Navigation Bar</dt>',
'            <dt>Side Navigation Menu</dt>',
'            <dt>Tabs</dt>',
'            <dt>Top Navigation Menu</dt>',
'            <dt>Wizard Progress</dt>',
'          </dl>',
'          See Also: <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a>',
'        </p>'))
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783410305502)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_text=>'List Template'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583861206500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_AFTER_ROWS.PROMPT'
,p_message_text=>'After Rows'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582124211500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_BEFORE_ROWS.PROMPT'
,p_message_text=>'Before Rows'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582678829500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_BETWEEN_ENTRIES.PROMPT'
,p_message_text=>'Between Entries'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583603746500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_BETWEEN_SUBLIST_ENTRIES.PROMPT'
,p_message_text=>'Between Entries'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580728443500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.1.D'
,p_message_text=>'Vertical Unordered List with Bullets'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581130328500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.10.D'
,p_message_text=>'Custom 2'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581247880500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.11.D'
,p_message_text=>'Custom 3'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581377824500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.12.D'
,p_message_text=>'Custom 4'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581467437500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.13.D'
,p_message_text=>'Custom 5'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581526727500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.14.D'
,p_message_text=>'Custom 6'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581669792500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.15.D'
,p_message_text=>'Custom 7'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581705747500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.16.D'
,p_message_text=>'Custom 8'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580935522500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.17.D'
,p_message_text=>'Wizard Progress List'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580886297500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.18.D'
,p_message_text=>'Vertical Unordered List without Bullets'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580643101500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.19.D'
,p_message_text=>'Vertical Sidebar List'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580551645500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.2.D'
,p_message_text=>'Vertical Ordered List'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580105643500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.20.D'
,p_message_text=>'Pull Down Menu'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580234816500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.21.D'
,p_message_text=>'Pull Down Menu with Image'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581871026500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.22.D'
,p_message_text=>'Hierarchical Expanding'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581986883500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.23.D'
,p_message_text=>'Hierarchical Expanded'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580059152500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.3.D'
,p_message_text=>'Horizontal Links List'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579966875500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.4.D'
,p_message_text=>'Horizontal Images with Label List'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580463750500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.5.D'
,p_message_text=>'Vertical Images List'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579899628500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.6.D'
,p_message_text=>'Button List'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143580362778500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.7.D'
,p_message_text=>'Tabbed Navigation List'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143581077867500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.LOV.9.D'
,p_message_text=>'Custom 1'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143579767183500631)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CLASS.PROMPT'
,p_message_text=>'Class'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582756661500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CURRENT_1ST.PROMPT'
,p_message_text=>'Current'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582275427500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CURRENT_ENTRY.PROMPT'
,p_message_text=>'Current'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582366588500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CURRENT_ENTRY_WITH_SUBLIST.PROMPT'
,p_message_text=>'Current with Sublist'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582801815500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_CURRENT_ENTRY_WITH_SUBLIST_1ST.PROMPT'
,p_message_text=>'Current with Sublist'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582435621500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_NONCURRENT_ENTRY.PROMPT'
,p_message_text=>'Noncurrent'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582924984500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_NONCURRENT_ENTRY_1ST.PROMPT'
,p_message_text=>'Noncurrent'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582510593500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_NONCURRENT_ENTRY_WITH_SUBLIST.PROMPT'
,p_message_text=>'Noncurrent with Sublist'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583000692500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_NONCURR_WITH_SUBLIST_ITEMS_1ST.PROMPT'
,p_message_text=>'Noncurrent with Sublist'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583113112500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_SUBLIST_BEFORE_ROWS.PROMPT'
,p_message_text=>'Before Rows'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583297449500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_SUBLIST_CURRENT_ENTRY.PROMPT'
,p_message_text=>'Current'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583374760500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_SUBLIST_CURR_ENTRY_WITH_SUBLIST.PROMPT'
,p_message_text=>'Current with Sublist'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583454562500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_SUBLIST_NONCURRENT_ENTRY.PROMPT'
,p_message_text=>'Noncurrent'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583545958500633)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_SUBLIST_NONCURR_ENTRY_WITH_SUBL.PROMPT'
,p_message_text=>'Noncurrent with Sublist Items'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143582035317500632)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599368740593282302)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_text=>'Select the list type.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599369263924282303)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_text=>'Function Body returning SQL Query'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599369313373282303)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_text=>'The Dynamic list is based on the SQL Query returned by the entered Function Body you enter.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599369050281282303)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599369127265282303)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'The Dynamic list is based on the SQL Query you enter.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599368881149282303)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599368996722282303)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_text=>'The Static list is based on the text value you enter.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599368669176282302)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388952590333781581)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_text=>'Enter the total number of days to display in the Agenda View.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388952446172781581)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_text=>'Number of Days'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388952679039781581)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_text=>'days'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388952027836781580)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_text=>'Select the days to display for the List View.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845934040751744)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_text=>'Custom'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516846049839751744)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_text=>'Display the calendar entries based on the number of days you enter.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845512158751742)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_text=>'Current Month'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845682901751742)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_text=>'Display the calendar entries for the current month.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845748893751742)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_text=>'Current Year'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845860527751744)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_text=>'Display the calendar entries for the current year.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388951941620781579)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_text=>'Display'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710536378661323)
,p_name=>'PE.PROPERTY.LOADING_METHOD_COLLECTION.LOV.APPEND.D'
,p_message_text=>'Append'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710621785661323)
,p_name=>'PE.PROPERTY.LOADING_METHOD_COLLECTION.LOV.REPLACE.D'
,p_message_text=>'Replace'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710447213661323)
,p_name=>'PE.PROPERTY.LOADING_METHOD_COLLECTION.PROMPT'
,p_message_text=>'Loading Method'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710171600661322)
,p_name=>'PE.PROPERTY.LOADING_METHOD_TABLE.LOV.APPEND.D'
,p_message_text=>'Append'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710214881661322)
,p_name=>'PE.PROPERTY.LOADING_METHOD_TABLE.LOV.MERGE.D'
,p_message_text=>'Merge'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710378641661323)
,p_name=>'PE.PROPERTY.LOADING_METHOD_TABLE.LOV.REPLACE.D'
,p_message_text=>'Replace'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242710069737661322)
,p_name=>'PE.PROPERTY.LOADING_METHOD_TABLE.PROMPT'
,p_message_text=>'Loading Method'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577535100340720)
,p_name=>'PE.PROPERTY.LOAD_TABLE_ID.HELP'
,p_message_text=>'Identifies the data load definition.'
,p_version_scn=>49870258
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577430805340720)
,p_name=>'PE.PROPERTY.LOAD_TABLE_ID.PROMPT'
,p_message_text=>'Data Load Definition'
,p_version_scn=>49870257
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718718175661330)
,p_name=>'PE.PROPERTY.LOGGING.PROMPT'
,p_message_text=>'Logging'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183239427692033866)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_text=>'Specify the application login page.'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183239323381033866)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_text=>'Login URL'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150989609013822709)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_text=>'Enter where &PRODUCT_NAME. redirects to after logout.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770209077751498)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_text=>'Home Page'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770369940751498)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_text=>'Redirect to the Home Link value specified in the application attributes.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770414319751498)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_text=>'URL'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770519109751499)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_text=>'Redirect to the URL you enter, such as <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150989505789822709)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_text=>'Logout Type'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747994385661390)
,p_name=>'PE.PROPERTY.LOGO_CUSTOM.PROMPT'
,p_message_text=>'Custom HTML'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746926517661355)
,p_name=>'PE.PROPERTY.LOGO_IMAGE_URL.PROMPT'
,p_message_text=>'Image URL'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746815845661355)
,p_name=>'PE.PROPERTY.LOGO_TYPE.LOV.C.D'
,p_message_text=>'Custom'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746548905661355)
,p_name=>'PE.PROPERTY.LOGO_TYPE.LOV.I.D'
,p_message_text=>'Image'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746755203661355)
,p_name=>'PE.PROPERTY.LOGO_TYPE.LOV.IT.D'
,p_message_text=>'Image and Text'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746629051661355)
,p_name=>'PE.PROPERTY.LOGO_TYPE.LOV.T.D'
,p_message_text=>'Text'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242746483063661355)
,p_name=>'PE.PROPERTY.LOGO_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918959313674991)
,p_name=>'PE.PROPERTY.LOG_MESSAGE_TYPE.HELP'
,p_message_text=>'Select the type of action message that gets logged to the task history.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83919335319674991)
,p_name=>'PE.PROPERTY.LOG_MESSAGE_TYPE.LOV.ALL.D'
,p_message_text=>'All'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83919242083674991)
,p_name=>'PE.PROPERTY.LOG_MESSAGE_TYPE.LOV.FAILURE.D'
,p_message_text=>'Failure'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83919015383674991)
,p_name=>'PE.PROPERTY.LOG_MESSAGE_TYPE.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83919178228674991)
,p_name=>'PE.PROPERTY.LOG_MESSAGE_TYPE.LOV.SUCCESS.D'
,p_message_text=>'Success'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83918861219674991)
,p_name=>'PE.PROPERTY.LOG_MESSAGE_TYPE.PROMPT'
,p_message_text=>'Log Message Type'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691221618661305)
,p_name=>'PE.PROPERTY.LONG_NAME.PROMPT'
,p_message_text=>'Long Name'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706575470661319)
,p_name=>'PE.PROPERTY.LOOKUP_DATA_COLUMN1.PROMPT'
,p_message_text=>'Data Column 1'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706732614661319)
,p_name=>'PE.PROPERTY.LOOKUP_DATA_COLUMN2.PROMPT'
,p_message_text=>'Data Column 2'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706955938661320)
,p_name=>'PE.PROPERTY.LOOKUP_DATA_COLUMN3.PROMPT'
,p_message_text=>'Data Column 3'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706084753661319)
,p_name=>'PE.PROPERTY.LOOKUP_OWNER.PROMPT'
,p_message_text=>'Table Owner'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706220455661319)
,p_name=>'PE.PROPERTY.LOOKUP_RETURN_COLUMN.PROMPT'
,p_message_text=>'Return Column'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706136127661319)
,p_name=>'PE.PROPERTY.LOOKUP_TABLE.PROMPT'
,p_message_text=>'Table Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706451913661319)
,p_name=>'PE.PROPERTY.LOOKUP_TABLE_COLUMN1.PROMPT'
,p_message_text=>'Table Column 1'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706625731661319)
,p_name=>'PE.PROPERTY.LOOKUP_TABLE_COLUMN2.PROMPT'
,p_message_text=>'Table Column 2'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706870353661319)
,p_name=>'PE.PROPERTY.LOOKUP_TABLE_COLUMN3.PROMPT'
,p_message_text=>'Table Column 3'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242706386709661319)
,p_name=>'PE.PROPERTY.LOOKUP_WHERE_CLAUSE.PROMPT'
,p_message_text=>'Where Clause'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973813613481115)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how to protect data against lost updates.',
'        Lost updates occur when two or more people try to update the same data, and the last update overwrites updates made by the first user to save changes.',
'        To prevent this from happening, updates can check the existing column value(s) in the database with the value(s) retrieved when the record was originally queried.</p>',
'        <p>For example:',
'          <ol>',
'            <li>User A queries employee (EMP) records.</li>',
'            <li>User B queries the same employee records.</li>',
'            <li>User B updates employee details for EMPNO = 7839 and applies (commits) the changes to the database.</li>',
'            <li>User A updates employee details for EMPNO = 7839 and is attempting to apply the changes to the database.</li>',
'          </ol>',
'          If User A successfully updates the same record, changes made by User B will be lost.</p>',
'         <p>When User A is attempting to save the employee record, then the data in the database is different from what User A queried originally.',
'          In step 1 above, the column value(s) originally queried by User A can be captured.',
'          Then in step 4 above, the value(s) can be compared to the current values in the database.',
'          This comparison will raise an error for User A, as the database value(s) were updated by User B in step 3.',
'          This prevents a user from overwriting changes made by another user to the same row.</p>',
'          <p>Note - Lost Update Type will only be used if the corresponding process, Interactive Grid - Automatic Row Processing (DML), has <strong>Prevent Lost Updates</strong> enabled.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974099100481115)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_text=>'Row Version Column'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373630939708681155)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If your database table includes a column which is incremented every time a record is updated, preferably by a database trigger, then this column can be used instead of calculating checksums.',
'        This option should not be used if your interactive grid updates data in multiple tables.</p>',
'        <p>Note - The row version column must be included in the SQL Source for the region.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973912273481115)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_text=>'Row Values'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373630857207681154)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A checksum value will be calculated for each row, when initially querying the data.',
'        The checksum is calculated by concatenating all of the updateable columns into a string and then generating a unique value.',
'        When committing the updated record, this checksum will be compared to the checksum value of the current database record.',
'        If they are not the same, an error will be raised.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973741500481114)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_text=>'Lost Update Type'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747016304661356)
,p_name=>'PE.PROPERTY.LOTO_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697757713661311)
,p_name=>'PE.PROPERTY.LOV_ENTRY_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106057141276418)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG_SQL.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106325424276418)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG_SQL.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106221639276418)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG_SQL.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106114822276418)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG_SQL.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61106420856276418)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG_SQL.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105986847276418)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG_SQL.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578769052340721)
,p_name=>'PE.PROPERTY.LOV_ID.HELP'
,p_message_text=>'Identifies the list of values.'
,p_version_scn=>49870263
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578671986340721)
,p_name=>'PE.PROPERTY.LOV_ID.PROMPT'
,p_message_text=>'List of Values'
,p_version_scn=>49870263
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600286196296090639)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a Java function body that returns an SQL Query to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600286023927090639)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Java Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610775227484651)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display department name, set department number</dt>',
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600285803896090637)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a JavaScript function body that returns an SQL Query to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600285720807090637)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'JavaScript Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695881385661309)
,p_name=>'PE.PROPERTY.LOV_LEGACY_SQL_QUERY.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150986920068822684)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter column, page or application items to set into session state when the value of any of the specified Cascading LOV Parent Item(s) change on this page.',
'For multiple items, separate each item name with a comma.',
'You can type in the name or pick from the list of available items.',
'If you pick from the list and there is already text entered, then a comma is placed at the end of the existing text, followed by the item name returned from the list.</p>',
'<p>You should use the page item(s) specified in this attribute within the <em>where clause</em> of this list of values SQL Query to restrict the values returned.</p>',
'<p>Note: The page items defined in <em>Cascading LOV Parent Item(s)</em> are automatically transmitted and do not need to be entered into this attribute.</p>'))
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150986820234822683)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_text=>'Items to Submit'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610684137484650)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display department name, set department number</dt>',
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600285585666090637)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL function body that returns an SQL Query to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600285426210090637)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'PL/SQL Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600286327564090640)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a Python function body that returns an SQL Query to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600286229007090639)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Python Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695641478661309)
,p_name=>'PE.PROPERTY.LOV_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_text=>'Function Body returning SQL Query'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62038117569862367)
,p_name=>'PE.PROPERTY.LOV_QUERY_TYPE.LOV.GRAPH.D'
,p_message_text=>'Property Graph'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695748607661309)
,p_name=>'PE.PROPERTY.LOV_QUERY_TYPE.LOV.LEGACY_SQL.D'
,p_message_text=>'Legacy SQL Query'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695562986661309)
,p_name=>'PE.PROPERTY.LOV_QUERY_TYPE.LOV.SQL.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695404805661309)
,p_name=>'PE.PROPERTY.LOV_QUERY_TYPE.LOV.TABLE.D'
,p_message_text=>'Table / View'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695338830661309)
,p_name=>'PE.PROPERTY.LOV_QUERY_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697414027661311)
,p_name=>'PE.PROPERTY.LOV_SEQUENCE.PROMPT'
,p_message_text=>'Sequence'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107856411785408286)
,p_name=>'PE.PROPERTY.LOV_SORT_DIRECTION.HELP'
,p_message_text=>'Define the sort direction for the values. Due to performance reasons the sorting is done on the client side and the values are sorted alphanumerically. If a server-side sort is required, a different List of Values type should be used.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107856575857408286)
,p_name=>'PE.PROPERTY.LOV_SORT_DIRECTION.LOV.ASC.D'
,p_message_text=>'Ascending'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107856645997408287)
,p_name=>'PE.PROPERTY.LOV_SORT_DIRECTION.LOV.DESC.D'
,p_message_text=>'Descending'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107856372442408286)
,p_name=>'PE.PROPERTY.LOV_SORT_DIRECTION.PROMPT'
,p_message_text=>'Sort Direction'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695037590661309)
,p_name=>'PE.PROPERTY.LOV_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_text=>'Local Database'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695108691661309)
,p_name=>'PE.PROPERTY.LOV_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694937608661309)
,p_name=>'PE.PROPERTY.LOV_SOURCE_LOCATION.LOV.STATIC.D'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242695265570661309)
,p_name=>'PE.PROPERTY.LOV_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_text=>'REST Source'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694845123661309)
,p_name=>'PE.PROPERTY.LOV_SOURCE_LOCATION.PROMPT'
,p_message_text=>'Location'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677401688478475039)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL query definition to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>',
'<p>Note: When defining a Popup LOV item type, if you would like to display multiple columns in the popup, you must instead define your List of Values in Shared Components,',
'with the required additional metadata. Inline list of values can only be used to display single columns for Popup LOVs.</p>'))
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584822312591747885)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL query definition to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>',
'<p>Note: When defining a Popup LOV item type, if you would like to display multiple columns in the popup, you must instead define your List of Values in Shared Components,',
'with the required additional metadata. Inline list of values can only be used to display single columns for Popup LOVs.</p>'))
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(728414699313647112)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL query definition to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>',
'<p>Note: When defining a Popup LOV item type, if you would like to display multiple columns in the popup, you must instead define your List of Values in Shared Components,',
'with the required additional metadata. Inline list of values can only be used to display single columns for Popup LOVs.</p>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(677401558584474951)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL query definition to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>',
'<p>Note: When defining a Popup LOV item type, if you would like to display multiple columns in the popup, you must instead define your List of Values in Shared Components,',
'with the required additional metadata. Inline list of values can only be used to display single columns for Popup LOVs.</p>'))
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115977237165250665)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.REGION_TMPL_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL query definition to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>',
'<p>Note: When defining a Popup LOV item type, if you would like to display multiple columns in the popup, you must instead define your List of Values in Shared Components,',
'with the required additional metadata. Inline list of values can only be used to display single columns for Popup LOVs.</p>'))
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136510045477670637)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL query definition to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>',
'<p>Note: When defining a Popup LOV item type, if you would like to display multiple columns in the popup, you must instead define your List of Values in Shared Components,',
'with the required additional metadata. Inline list of values can only be used to display single columns for Popup LOVs.</p>'))
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136511342860670632)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL query definition to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>',
'<p>Note: When defining a Popup LOV item type, if you would like to display multiple columns in the popup, you must instead define your List of Values in Shared Components,',
'with the required additional metadata. Inline list of values can only be used to display single columns for Popup LOVs.</p>'))
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538346754980123252)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display department name, set department number</dt>',
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361709231131406393)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL query definition to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>'))
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361709125894406392)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361717908161613244)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_text=>'Enter the values for this static list of values.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361717820551613244)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662093720661132)
,p_name=>'PE.PROPERTY.LOV_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this list of values on an existing list of values in this application or another application in your workspace.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661999106661132)
,p_name=>'PE.PROPERTY.LOV_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361711029929680172)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_text=>'Select the list of values type.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258091409090319)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body returning SQL Query'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600258189026090319)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'The Dynamic list of values is based on the SQL Query returned by the entered Function Body you enter.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245971485489480814)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_text=>'Shared Component'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245971525890480814)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_text=>'The list of values is based on a predefined list of values, defined in Shared Components.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245971609984480815)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245971720624480815)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'The Dynamic list of values is based on the SQL Query you enter.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516785121510751562)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516785255976751562)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_text=>'The Static list of values is based on the text value you enter.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361710900679680171)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123134028600211853)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_text=>'Select how session state is maintained.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117680162983836721)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_text=>'Per Request (Memory Only)'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117680252880836735)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_text=>'Do not save state in the database. State is only available when processing the current request. When AJAX requests need to use an item, make sure to pass the item name via "Page Items To Submit".'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516764959817751476)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_text=>'Per User (Persistent)'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372354352373745)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_text=>'Maintain for a user by storing the value in the database, to access it across sessions.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516764877648751475)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_text=>'Per Session (Persistent)'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372216270373744)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_text=>'Maintain for each session by storing the value in the database, to access it across requests.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123133931501211853)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_text=>'Storage'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117680469711836934)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_text=>'Select how session state is maintained.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117680547588836934)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_text=>'Per Request (Memory Only)'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117680614242836934)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_text=>'Do not save state in the database. State is only available when processing the current request. When AJAX requests need to use an item, make sure to pass the item name via "Page Items To Submit".'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117680703737836934)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_text=>'Per Session (Persistent)'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117680886697836934)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_text=>'Maintain for each session by storing the value in the database, to access it across requests.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117680345922836934)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_text=>'Storage'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627008410065378)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_text=>'Select whether the major tick marks are rendered.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627180336065378)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627322432065379)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_text=>'No'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627224892065378)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_text=>'Yes'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295626975255065377)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579505366340721)
,p_name=>'PE.PROPERTY.MAP_BACKGROUND_ID.HELP'
,p_message_text=>'Identifies the map background.'
,p_version_scn=>49870266
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579468566340721)
,p_name=>'PE.PROPERTY.MAP_BACKGROUND_ID.PROMPT'
,p_message_text=>'Map Background'
,p_version_scn=>49870265
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139865628671148582)
,p_name=>'PE.PROPERTY.MAP_BKG_API_KEY.PROMPT'
,p_message_text=>'API Key'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139865491887148582)
,p_name=>'PE.PROPERTY.MAP_BKG_ATTRIBUTION.PROMPT'
,p_message_text=>'Attribution'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139865802329148582)
,p_name=>'PE.PROPERTY.MAP_BKG_HTTP_HEADERS.PROMPT'
,p_message_text=>'HTTP Headers'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139864214652148582)
,p_name=>'PE.PROPERTY.MAP_BKG_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139866813483148761)
,p_name=>'PE.PROPERTY.MAP_BKG_TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_text=>'Same as Standard'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139866911449148761)
,p_name=>'PE.PROPERTY.MAP_BKG_TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_text=>'Use the same background map for light and dark mode.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139866277217148583)
,p_name=>'PE.PROPERTY.MAP_BKG_TILELAYER_DARK.PROMPT'
,p_message_text=>'Dark Mode'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139866087066148583)
,p_name=>'PE.PROPERTY.MAP_BKG_TILELAYER_DEFAULT.PROMPT'
,p_message_text=>'Standard'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139865040833148582)
,p_name=>'PE.PROPERTY.MAP_BKG_TYPE.LOV.OGCWMS.D'
,p_message_text=>'OGC WMS'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139864677127148582)
,p_name=>'PE.PROPERTY.MAP_BKG_TYPE.LOV.RASTER.D'
,p_message_text=>'Raster XYZ Tile Layer'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139864867618148582)
,p_name=>'PE.PROPERTY.MAP_BKG_TYPE.LOV.VECTOR.D'
,p_message_text=>'Vector Tile Layer'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139864499902148582)
,p_name=>'PE.PROPERTY.MAP_BKG_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139865292966148582)
,p_name=>'PE.PROPERTY.MAP_BKG_URL.PROMPT'
,p_message_text=>'URL'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139866637325148583)
,p_name=>'PE.PROPERTY.MAP_BKG_ZOOM_MAX.PROMPT'
,p_message_text=>'Maximum Zoom Level'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139866419677148583)
,p_name=>'PE.PROPERTY.MAP_BKG_ZOOM_MIN.PROMPT'
,p_message_text=>'Minimum Zoom Level'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604709023784561)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.COMPONENT_PROPERTY.MAP_LAYER.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ensure that the color of a Point Clustering fill meets certain criteria to enhance visibility and usability for all users.</p>',
'<strong>Best Practices:</strong><ol>',
'<li><strong>Contrast Ratio:</strong> The Point Clustering fill must have a contrast ratio of at least (3:1) in comparison to its background. This ensures that users with visual impairments can discern the clustered points effectively.</li>',
'<li><strong>Differentiation from Standard Fill Color:</strong> The Point Clustering fill color should also be distinguishable from the standard fill color. This distinction is crucial for users to easily differentiate between clustered points and sta'
||'ndard data points, facilitating improved data comprehension and interaction.</li>',
'</ol>',
'<p>By adhering to these guidelines, we strive to create a more inclusive and accessible experience for all users, regardless of their visual abilities.</p>'))
,p_version_scn=>54871605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563437992880648891)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563437873232648891)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the fill color to display a point cluster.',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563437736855648891)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_text=>'Fill Color'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563436766845648890)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_text=>'Specify icon CSS classes to use to display a point cluster.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563436608138648890)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_text=>'Icon CSS Classes'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563436519470648890)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_text=>'Specify the URL to the image to use to display a point cluster.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563436424428648890)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_text=>'Icon URL'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563436951656648890)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_text=>'Specify the SVG shape to display a point cluster. Choose from the predefined shapes or enter the name of a <em>custom SVG shape</em>, specified in the <strong>Custom SVG Styles</strong> map region attribute. When the specified name is not in the list'
||' of default or custom SVG styles, then the <strong>Default Marker</strong> will be used.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704240078253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_text=>'Camera'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681144141263043)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576005068233505113)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_text=>'Check'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682447035263045)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704391731253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_text=>'Circle Alternative'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681358647263043)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563437113909648890)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_text=>'Circle'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681250270263043)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704152472253264)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_text=>'Default'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681016168263043)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704472450253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_text=>'Face Frown'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681468136263044)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704507889253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_text=>'Face Meh'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681525397263044)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704685310253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_text=>'Face Smile'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681696448263044)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576005597094505114)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_text=>'Flag Pennant'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682935200263046)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576005605757505114)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_text=>'Flag Swallowtail'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580683095894263046)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573705003732253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_text=>'Heart'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682181585263045)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576005150480505113)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_text=>'Home'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682520052263045)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573705136415253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_text=>'Pentagon'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682253472263045)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704846805253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_text=>'Pin Circle'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681902829263044)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704978433253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_text=>'Pin Square'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682056641263044)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576005347356505114)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_text=>'Shine'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682758681263046)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576005285949505113)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_text=>'Slash'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682654883263045)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704791423253265)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_text=>'Square Alternative'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681838948263044)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563437005265648890)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_text=>'Square'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580681739631263044)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576005441022505114)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_text=>'Street View'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682816967263046)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563437488306648891)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_text=>'Triangle'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580682329630263045)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563436889826648890)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_text=>'Shape'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573705343019253266)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_text=>'Specify the scaling factor for the SVG shape to display a point cluster. The maximum scale is <strong>10</strong>, and the map component wil round the value to the first decimal digit.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573705268902253266)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_text=>'Shape Scale'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441102950648897)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The cluster radius in pixels. If a value of <strong>80</strong> is specified, points within 80 pixels of each other will be',
'aggregated to a point cluster.'))
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441046156648896)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_text=>'Clustering Radius'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441245303648897)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462453319648943)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_text=>'Enter HTML expressions to be shown as tooltip when hovering over an cluster marker on the map. Use the <strong>&LAYER.</strong> and <strong>&COUNT.</strong> placeholders to reference the layer name and the amount of map objects in the cluster.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462356167648943)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_text=>'Tooltip'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563426081797648857)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_text=>'Provide the copyright notice to be placed at the footer of the map. If empty, a notice for the used background map will be generated.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425927642648854)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_text=>'Copyright Notice'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427952245648870)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427848775648870)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide definitions for custom SVG shapes, which can be used as map markers. Styles defined here can be used as the <strong>SVG Shape</strong> attribute within a Point layer.</p>',
'<p>The SVG shape must have a width and height of <strong>20</strong>. The marker will be positioned on the map, so that the center of the shape bottom (SVG coordinate <strong>10</strong>, <strong>20</strong>) is pointing to the map object.</p>',
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
'<title id="prop1526_SvgTitle">SVG markers have a width and height of 20 and point to the map location at position x=10 and y=20.</title>',
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427755363648870)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_text=>'Custom SVG Styles'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563460063128648939)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_text=>'Select the column returning a value to determine the height of the extruded polygon.'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459978764648939)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_text=>'Extrusion Value Column'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461884693648943)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_text=>'Select the unit to determine the height of the extruded polygon.'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462133303648943)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_text=>'Foot'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462015028648943)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_text=>'Kilometer'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461906538648943)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_text=>'Meter'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462267857648943)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_text=>'Mile'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461790613648942)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_text=>'Unit'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1832928318826319)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.COMPONENT_PROPERTY.MAP_LAYER.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Check Color Contrast Ratio:</strong> Ensure there is sufficient contrast between the background color and stroke color to facilitate clear differentiation of the highlighted area on the map. Aim for a ratio of at least 3:1 to ensure reada'
||'bility for individuals with varying levels of vision impairment as well as the borders or stroke color outlining various features. Adequate contrast is crucial for users to easily perceive and discern these visual elements, enhancing the overall legi'
||'bility and usability of the map interface.</li>',
'</ul>'))
,p_version_scn=>14796591
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563432967033648882)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563432893325648882)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the fill color.',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563432767976648882)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_text=>'Fill Color'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443079251648900)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_text=>'Specify whether to use a <em>Color Scheme</em> for this layer. A color scheme is a list of colors. Based on a value and the minimum and maximum values, the map widget will pick the actual display color for this object from the list.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563442949815648898)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_text=>'Use Color Scheme'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617257636013049509)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Color list ranging from red to white</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Color list ranging from blue to black</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443240336648900)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_text=>'Specify a custom <em>color scheme</em> for this layer. A color scheme is a list of colors. Based on a value and the minimum and maximum values, the map widget will pick the actual display color for this object from the list.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443128332648900)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_text=>'Custom Color List'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443456983648900)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_text=>'Select the column returning a value in order to determine the display color from the scheme.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443372298648900)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_text=>'Color Value Column'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433143498648882)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_text=>'Specify fill opacity. Ranges from zero (fully transparent) to 1.0 (opaque).'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433085519648882)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_text=>'Fill Opacity'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443672768648901)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_text=>'Select the column returning the value to determine the display color from the scheme. If no column is selected, the display color will be determined from point density only.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443564464648901)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_text=>'Value Column'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439031118648893)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_text=>'Specify whether the information window displays using columns or advanced formatting using HTML expressions and supported substitution strings. The information window will be displayed as a pop-up when clicking an object on the map.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438904805648892)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_text=>'Advanced Formatting'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439491206648893)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_text=>'Select the column to be used as body for the information window. The information window will be displayed as a pop-up when clicking an object on the map..'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439381512648893)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_text=>'Body Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439942620648895)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_text=>'Enter CSS classes to use when rendering the info window popup. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439824676648895)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439713911648895)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Change the background and text colors</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Use Heading 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Use a dynamic class from the SQL query</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    The <code>&COLUMN_CLASS.</code> and <code>&EMPLOYEE_STATUS.</code> substitutions in this example are columns selected in the report SQL query.</dd>',
'  <dt>Show an image, and a tooltip on hover</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439699958648895)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_text=>'Enter HTML expressions to be shown as the info popup when clicking a spatial object. Use <code>&COLUMN.</code> syntax to show column values in HTML.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439504146648893)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_text=>'HTML Expression'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439203465648893)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_text=>'Select the column to be used as the title for the information window. The information window will be displayed as a pop-up when clicking an object on the map.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563439136131648893)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_text=>'Title Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563463393991648945)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_text=>'Specify the label to use for this layer in the legend and within tooltips.'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563463214981648944)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_text=>'Label'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604552177784560)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.COMPONENT_PROPERTY.MAP_LAYER.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing map accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Use Bold and Clear Colors:</strong> Opt for colors that are bold and clear to ensure both text and graphical elements within your map are easily distinguishable. This enhances readability and comprehension for all users, including those w'
||'ith visual impairments.</li>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 4.5:1 to ensure readability for individuals with varying level'
||'s of vision impairment.</li>',
'</ol>'))
,p_version_scn=>12412766
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462958990648944)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462808646648944)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the marker fill color.',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462779822648944)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_text=>'Fill Color'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462624956648943)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_text=>'Specify fill opacity. Ranges from zero (fully transparent) to 1.0 (opaque).'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563462583339648943)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_text=>'Fill Opacity'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604685810784560)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.COMPONENT_PROPERTY.MAP_LAYER.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The stroke color of a map serves to ensure that individuals with moderately low vision can effectively distinguish boundaries between adjoining segments of colors in a map.<p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li>Color Selection Considerations:',
'<ul>',
'<li>When selecting colors for maps with multiple colors, it''s crucial to consider the contrast ratio between adjoining colors.</li>',
'<li>Ensure that the contrast ratio between adjoining colors is at least 3:1 to facilitate clear differentiation.</li></ul></li>',
'<li>Testing and Adjustment Procedures:',
'<ul>',
'<li>Utilize accessibility testing tools or manual checks to ensure compliance with the minimum contrast ratio requirement.</li>',
'<li>If the contrast ratio falls below 3:1 for any adjoining colors, implement corrective measures to enhance visibility.</li>',
'<li>Consider adding borders with contrasting colors to visually separate adjoining segments and improve clarity.</li></ul></li>',
'<li>Considerations for Color Blindness:',
'<ul>',
'<li>Take into account the prevalence of color blindness among users and design with consideration for their needs.</li>',
'<li>Avoid relying solely on color to convey information; incorporate other visual cues, such as patterns or textures, to supplement color distinctions.</li>',
'<li>Ensure that color choices accommodate common types of color blindness, such as red-green deficiency, by selecting colors that remain distinguishable in various color vision scenarios.</li></ul></li>',
'</ol>'))
,p_version_scn=>12412766
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563460330510648939)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563460211027648939)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the stroke color.',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563460178083648939)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_text=>'Stroke Color'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563460540317648941)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_text=>'Specify the stroke width.'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563460468663648941)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_text=>'Stroke Width'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440135208648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_text=>'Select the column to use to assign rows from the region source to this layer.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440043487648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440325258648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_text=>'Provide the <strong>Row Assignment Column</strong> <em>value</em> which assigns rows from the region source to this layer.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440240024648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_text=>'Value for this Layer'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604476284784560)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.COMPONENT_PROPERTY.MAP_LAYER.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The stroke color of a map serves to ensure that individuals with moderately low vision can effectively distinguish boundaries between adjoining segments of colors in a map.<p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li>Color Selection Considerations:',
'<ul>',
'<li>When selecting colors for maps with multiple colors, it''s crucial to consider the contrast ratio between adjoining colors.</li>',
'<li>Ensure that the contrast ratio between adjoining colors is at least 3:1 to facilitate clear differentiation.</li></ul></li>',
'<li>Testing and Adjustment Procedures:',
'<ul>',
'<li>Utilize accessibility testing tools or manual checks to ensure compliance with the minimum contrast ratio requirement.</li>',
'<li>If the contrast ratio falls below 3:1 for any adjoining colors, implement corrective measures to enhance visibility.</li>',
'<li>Consider adding borders with contrasting colors to visually separate adjoining segments and improve clarity.</li></ul></li>',
'<li>Considerations for Color Blindness:',
'<ul>',
'<li>Take into account the prevalence of color blindness among users and design with consideration for their needs.</li>',
'<li>Avoid relying solely on color to convey information; incorporate other visual cues, such as patterns or textures, to supplement color distinctions.</li>',
'<li>Ensure that color choices accommodate common types of color blindness, such as red-green deficiency, by selecting colors that remain distinguishable in various color vision scenarios.</li></ul></li>',
'</ol>'))
,p_version_scn=>12412766
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563432303502648880)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563432253133648880)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the stroke color.',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563432183339648879)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_text=>'Stroke Color'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440591858648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_text=>'Specify the stroke style.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440843168648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_text=>'Dashed'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440795672648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_text=>'Dotted'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440974305648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_text=>'Dot-Dashed'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440682177648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_text=>'Solid'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563440471203648896)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_text=>'Stroke Style'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563432586408648882)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_text=>'Specify the stroke width.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563432461652648882)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_text=>'Stroke Width'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438197894648891)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_text=>'Specify whether the tooltip displays using a column or advanced formatting using HTML expressions and supported substitution strings. The tooltip is displayed when hovering over an object on the map.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438062947648891)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_text=>'Advanced Formatting'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438365188648891)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_text=>'Select the column to be used as tooltip.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438273193648891)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438807071648892)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_text=>'Enter CSS classes to use when rendering the tooltip. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438759547648892)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438602929648892)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Change the background and text colors</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Use Heading 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Use a dynamic class from the SQL query</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    The <code>&COLUMN_CLASS.</code> and <code>&EMPLOYEE_STATUS.</code> substitutions in this example are columns selected in the report SQL query.</dd>',
'  <dt>Show an image, and a tooltip on hover</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438523931648892)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_text=>'Enter HTML expressions to be shown as tooltip when hovering over an object on the map. Use <code>&COLUMN.</code> syntax to show column values in HTML.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563438426302648892)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_text=>'HTML Expression'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431490942648879)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_text=>'Column returning GeoJSON objects to display on the map.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431300017648879)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_text=>'GeoJSON Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431666354648879)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_text=>'SDO_GEOMETRY column, returning geometry objects to display on the map.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431533385648879)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_text=>'Geometry Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430083955648877)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_text=>'Identify the data type of the geometry column.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430350187648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_text=>'GeoJSON'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430449544648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_text=>'GeoJSON, as VARCHAR2 or CLOB types.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430524430648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_text=>'Longitude/Latitude'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430651500648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_text=>'Longitude and Latitude, as two NUMBER columns. Only supported for the <strong>Points</strong> and <strong>Heat Map</strong> layer types.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430111346648877)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_text=>'SDO_GEOMETRY'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430208449648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_text=>'Oracle SDO_GEOMETRY type.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563429937015648877)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_text=>'Geometry Column Data Type'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430863891648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_text=>'Identify the data type of the geometry column.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430985404648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_text=>'GeoJSON'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431055945648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_text=>'GeoJSON, as VARCHAR2 or CLOB types.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431101416648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_text=>'Longitude/Latitude'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431250686648879)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_text=>'Longitude and Latitude, as two NUMBER columns.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563430717329648878)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_text=>'Geometry Column Data Type'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563429675343648872)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enable this switch, if the underlying table has a spatial index and the map widget should use it when fetching rows from the database. In this case, the widget will <em>only</em> fetch rows for the current map window from the database. This provid'
||'es a performance benefit when the data source contains a large amount of rows.</p><p>A spatial index can be created on an SDO_GEOMETRY column in SQL Workshop.</p>',
'<p>Note that a Spatial Index will <em>not</em> be used in the following situations:</p>',
'<ul>',
'<li>More than one layer references the <strong>Region Source</strong> as their data source.</li>',
'<li>The map window is too large; that is the case when it spans more than half of the world.</li>',
'</ul>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563429573524648872)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_text=>'Use Spatial Index'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563432095330648879)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_text=>'NUMBER column, containing the latitude of the spatial objects to be displayed on the map. Returned values should be between -90 and 90.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431990948648879)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_text=>'Latitude Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449016813648913)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_text=>'Choose one of the predefined diverging color schemes. These are suitable to visualize diverging values, going from one extreme to another. Color schemes from cartocolors (<a rel="noopener noreferrer" href="https://github.com/CartoDB/cartocolor" targe'
||'t="_blank">CARTOcolor on GitHub)</a>.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449157740648913)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_text=>'"Army" to Rose'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449225107648913)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450327605648918)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_text=>'Earth Colors'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450446077648918)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449380583648913)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_text=>'Fall Colors'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449431025648913)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449514565648913)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_text=>'Geyser'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449605752648914)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449961453648917)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_text=>'Teal to Rose'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450095693648917)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449739453648917)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_text=>'Temps'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563449823909648917)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450100747648917)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_text=>'Tropic Colors'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450207748648917)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448902601648913)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_text=>'Scheme Name'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450653157648918)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_text=>'Choose one of the predefined qualitative color schemes. These are suitable to visualize distinct values. Color schemes from cartocolors (<a rel="noopener noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor on GitHub)</'
||'a>.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450752121648918)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_text=>'Antique'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450828232648918)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450988152648918)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_text=>'Bold'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451028116648918)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451119249648918)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_text=>'Pastel'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451236055648919)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451383644648919)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_text=>'Prism'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451464203648919)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451537666648921)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_text=>'Safe'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451691198648921)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451775195648921)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_text=>'Vivid'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451811593648921)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563450560602648918)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_text=>'Scheme Name'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445026082648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_text=>'Choose one of the predefined sequential color schemes. These are suitable to visualize sequential values, going from a low to a high value. Color schemes from cartocolors (<a rel="noopener noreferrer" href="https://github.com/CartoDB/cartocolor" targ'
||'et="_blank">CARTOcolor on GitHub)</a>.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446558848648904)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_text=>'Blue to Green'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446621175648906)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447112112648906)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_text=>'Blue to Yellow'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447200720648906)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448764995648912)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_text=>'Brown to Yellow'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448899150648913)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445160293648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_text=>'Burgundy'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445296627648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445395247648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_text=>'Burgundy to Yellow'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445450533648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446792035648906)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_text=>'Dark Mint'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446898449648906)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446970651648906)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_text=>'Emerald'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447069072648906)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448315337648912)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_text=>'Magenta'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448455801648912)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446323604648904)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_text=>'Mint'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446499506648904)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445717769648903)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_text=>'Orange to Yellow'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445898354648903)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445906759648903)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_text=>'Peach'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446028690648904)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446111268648904)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_text=>'Pink to Yellow'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563446298528648904)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447790860648911)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_text=>'Purple'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447830953648911)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447962730648912)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_text=>'Purple to Orange'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448096349648912)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445568203648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_text=>'Red to Orange'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563445662475648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448170756648912)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_text=>'Sunset'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448237629648912)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448507208648912)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_text=>'Dark Sunset'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563448626221648912)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447390130648906)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_text=>'Teal'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447468436648906)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447541160648911)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_text=>'Teal to Green'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563447650621648911)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444901141648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_text=>'Scheme Name'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563463985807649162)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_text=>'Custom'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563464077480649162)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_text=>'Specify a list of HTML colors (#rrggbb), separated by comma.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444259562648901)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_text=>'Choose the color scheme type.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444547285648901)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_text=>'Diverging'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444666959648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_text=>'This color scheme is suitable to visualize diverging values, going from one extreme to another.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444759152648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_text=>'Qualitative'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444871082648902)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_text=>'This color scheme is suitable to visualize distinct values.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444344281648901)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_text=>'Sequential'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444482656648901)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_text=>'This color scheme is suitable to visualize sequential values, going from a low to a high value.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444131420648901)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_text=>'Color Scheme'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604300476784560)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.COMPONENT_PROPERTY.MAP_LAYER.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Contrast Between Colors:</strong>',
'Ensure a significant contrast exists between the first and last colors chosen for your layer heat map spectrum. This facilitates clear differentiation of intensity levels or data points represented.</li>',
'<li><strong>Avoid Problematic Color Combinations:</strong>',
'Steer clear of common problematic color combinations like red and green. These combinations can pose challenges for users with color vision deficiencies, potentially hindering accurate interpretation of the map.</li></ol>',
'<p>By selecting colors with sufficient contrast and avoiding problematic combinations, you can enhance the accessibility of your layer heat map and ensure that it remains inclusive and usable for all users.</p>'))
,p_version_scn=>14796591
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617258496732079441)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Color list ranging from red to white</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Color list ranging from blue to black</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459877022648938)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_text=>'Specify a custom <em>color scheme</em> for this heat map layer. A color scheme is a list of colors. Based on a value and the minimum and maximum values, the map widget will pick the actual display color for this object from the list.'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459708459648938)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_text=>'Custom Color List'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456871973648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_text=>'Choose one of the predefined diverging color schemes. These are suitable to visualize diverging values, going from one extreme to another. Color schemes from cartocolors (<a rel="noopener noreferrer" href="https://github.com/CartoDB/cartocolor" targe'
||'t="_blank">CARTOcolor on GitHub)</a>.'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456905836648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_text=>'"Army" to Rose'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457076731648930)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458180036648932)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_text=>'Earth Colors'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458223575648932)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457121871648930)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_text=>'Fall Colors'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457203164648930)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457373618648930)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_text=>'Geyser'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457429186648930)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457774710648931)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_text=>'Teal to Rose'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457848015648931)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457533584648930)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_text=>'Temps'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457608718648930)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563457948505648932)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_text=>'Tropic Colors'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458042476648932)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456746918648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_text=>'Scheme Name'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458441159648932)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_text=>'Choose one of the predefined qualitative color schemes. These are suitable to visualize distinct values. Color schemes from cartocolors (<a rel="noopener noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor on GitHub)</'
||'a>.'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458529202648935)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_text=>'Antique'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458653959648935)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458724053648935)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_text=>'Bold'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458898460648937)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458942758648937)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_text=>'Pastel'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459042028648937)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459181213648938)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_text=>'Prism'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459279145648938)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459351009648938)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_text=>'Safe'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459428928648938)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459537888648938)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_text=>'Vivid'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563459636034648938)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563458386505648932)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_text=>'Scheme Name'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452813731648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_text=>'Choose one of the predefined sequential color schemes. These are suitable to visualize sequential values, going from a low to a high value. Color schemes from cartocolors (<a rel="noopener noreferrer" href="https://github.com/CartoDB/cartocolor" targ'
||'et="_blank">CARTOcolor on GitHub)</a>.'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454323915648925)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_text=>'Blue to Green'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454406709648925)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454901406648925)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_text=>'Blue to Yellow'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455063758648926)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456510980648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_text=>'Brown to Yellow'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456678176648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452976101648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_text=>'Burgundy'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453094747648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453141902648923)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_text=>'Burgundy to Yellow'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453289898648923)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454574920648925)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_text=>'Dark Mint'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454660971648925)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454753627648925)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_text=>'Emerald'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454879602648925)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456191647648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_text=>'Magenta'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456271114648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454183874648924)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_text=>'Mint'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454249266648924)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453540002648923)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_text=>'Orange to Yellow'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453689563648923)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453708271648924)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_text=>'Peach'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453804023648924)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453941539648924)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_text=>'Pink to Yellow'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563454005397648924)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455508853648927)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_text=>'Purple'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455686569648927)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455779929648927)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_text=>'Purple to Orange'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455891138648927)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453332933648923)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_text=>'Red to Orange'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563453481522648923)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455978354648927)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_text=>'Sunset'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456092083648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456332973648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_text=>'Dark Sunset'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563456425834648928)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455188095648926)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_text=>'Teal'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455274889648926)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455304665648927)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_text=>'Teal to Green'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563455407190648927)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
,p_version_scn=>37166067046432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452777561648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_text=>'Scheme Name'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563464149872649162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_text=>'Custom'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563464209687649162)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_text=>'Specify a list of HTML colors (#rrggbb), separated by comma.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452006704648921)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_text=>'Choose the color scheme type.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452331752648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_text=>'Diverging'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452431073648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_text=>'This color scheme is suitable to visualize diverging values, going from one extreme to another.'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452564925648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_text=>'Qualitative'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452644778648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_text=>'This color scheme is suitable to visualize distinct values.'
,p_version_scn=>37166067046431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452103467648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_text=>'Sequential'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563452211248648922)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_text=>'This color scheme is suitable to visualize sequential values, going from a low to a high value.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563451918991648921)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_text=>'Color Scheme'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441472894648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_text=>'Identify the type of this layer.'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563442181943648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_text=>'Heat Map'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563442256391648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_text=>'Point Objects, displayed as a Heat Map. Heat maps are useful to visualize the density of point objects.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441748820648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_text=>'Lines'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441825819648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_text=>'Line Objects.'
,p_version_scn=>37166067046426
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441587818648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_text=>'Points'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441628343648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_text=>'Point Objects.'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441962126648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_text=>'Polygons'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563442013051648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_text=>'Polygon Objects.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563442343078648898)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_text=>'Extruded Polygons'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563442409096648898)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_text=>'"Extruded" Polygons as 3D objects. The height is based on a result column value.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563441342468648897)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_text=>'Layer Type'
,p_version_scn=>37166067046425
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563444008547648901)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_text=>'Specify the maximum zoom level for this layer to remain visible.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443903035648901)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_text=>'Maximum'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443832904648901)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_text=>'Specify the minimum zoom level for this layer to become visible.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563443739761648901)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_text=>'Minimum'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431873583648879)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_text=>'NUMBER column, containing the longitude of the spatial objects to be displayed on the map. Returned values should be between -180 and 180.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563431765679648879)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_text=>'Longitude Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563436397509648890)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_text=>'Whether to cluster co-located points on the map.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563436273680648890)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_text=>'Enable'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433396380648882)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_text=>'Identifies how to display point objects.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433638528648883)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_text=>'Icon'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433767570648883)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_text=>'Display as Icon.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433452423648883)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_text=>'SVG'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433538054648883)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_text=>'Display as SVG Shape.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433219614648882)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_text=>'Style'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563435394225648884)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_text=>'Specify the SVG shape to display point objects. Choose from the predefined shapes or enter the name of a <em>Custom SVG Shape</em>, specified in the <strong>Custom SVG Styles</strong> map region attribute. When no name is specified, or the specified '
||'name is not in the list of default or custom SVG shapes, then the <strong>Default</strong> shape will be used.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573702933462253262)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_text=>'Camera'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679004854263039)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576004356513505111)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_text=>'Check'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680362124263041)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703057672253262)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_text=>'Circle Alternative'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679299921263040)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563435563423648887)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_text=>'Circle'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679170805263040)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573702874494253262)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_text=>'Default'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580678911525263035)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703111889253262)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_text=>'Face Frown'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679304793263040)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703271618253263)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_text=>'Face Meh'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679433133263040)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703378022253263)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_text=>'Face Smile'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679529716263040)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576004823726505111)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_text=>'Flag Pennant'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680880146263042)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576004974730505111)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_text=>'Flag Swallowtail'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680995857263042)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703757182253263)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_text=>'Heart'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680085700263041)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576004432771505111)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_text=>'Home'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680494443263042)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703829119253263)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_text=>'Pentagon'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680168154263041)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703547584253263)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_text=>'Pin Circle'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679866027263041)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703663971253263)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_text=>'Pin Square'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679995389263041)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576004663522505111)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_text=>'Shine'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680657618263042)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576004548364505111)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_text=>'Slash'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680569205263042)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703488222253263)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_text=>'Square Alternative'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679795725263041)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563435448615648887)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_text=>'Square'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580679622309263040)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(576004760697505111)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_text=>'Street View'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680751686263042)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563435853959648887)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_text=>'Triangle'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(580680206742263041)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563435218843648884)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_text=>'Shape'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573704052003253264)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_text=>'Specify the scaling factor for the SVG shape. The maximum scale is <strong>10</strong>. If a column substitution is used and the value is greater than <strong>10</strong>, a message is written to the JavaScript console and the marker is displayed wit'
||'h a scale factor of <strong>10</strong>. The map component wil round the value to the first decimal digit.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(573703939034253264)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_text=>'Shape Scale'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434720951648884)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_text=>'Select the column containing icon CSS classes.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434657776648884)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_text=>'Icon Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563435157071648884)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_text=>'CSS classes to use as icon source.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563435062329648884)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_text=>'Icon CSS Classes'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434944714648884)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_text=>'Enter the URL for the image source.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434869147648884)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_text=>'Image URL'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433921091648883)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_text=>'Select the source for the icon to display the point on the map.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434209725648883)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_text=>'Icon Class Column'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434355634648883)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_text=>'Use individual CSS classes for each row.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434004708648883)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_text=>'Icon Class'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434189201648883)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_text=>'Use a Static CSS class for all rows.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434446610648883)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_text=>'Image URL'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563434562025648884)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_text=>'URL to an image to use for point display.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563433846887648883)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_text=>'Icon Source'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424231334648853)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_text=>'Enable or disable miscellaneous map widget features.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425360358648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_text=>'Get Browser Location'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425498910648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_text=>'Get the user''s current location from the browser.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425579014648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_text=>'Circle Tool'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425604501648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_text=>'The Circle Tool allows end users to draw a circle onto the map. When finished, an event is triggered, so that the circle can be processed by Dynamic Actions or JavaScript code.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425777910648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_text=>'Distance Tool'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425843050648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_text=>'Allows end users to measure distances between points on the map.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425113067648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_text=>'Infinite Map'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425268588648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_text=>'Infinite map scrolling.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424344405648853)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_text=>'Mousewheel Zoom'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424496657648853)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_text=>'Zoom in or out by using the mouse wheel.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424906806648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_text=>'Overview Map'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563425002829648854)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_text=>'Display an overview map in the lower right.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424510586648853)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_text=>'Rectangle Zoom'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424641990648853)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_text=>'Zoom the map to an area by drawing a rectangle onto the map.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424792582648853)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_text=>'Scale Bar'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424816007648853)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_text=>'Display a scale bar on the map.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563424109730648852)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_text=>'Options'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563429335941648872)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_text=>'Specify the height of the map region.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563429272530648872)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_text=>'Height'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563429468865648872)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427677699648870)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_text=>'Enter CSS classes to add to the legend. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427581790648869)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427443415648869)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_text=>'jQuery selector for the element to display the legend in.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427363429648869)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_text=>'Selector'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563426675430648867)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_text=>'Specify the position of the legend.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563426984553648867)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_text=>'End'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427053125648867)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_text=>'Show the legend on the ending position (typically below the map).'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427187387648867)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_text=>'Selector'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563427232064648868)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_text=>'Specify a jQuery selector for the element to show the legend in.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563426711368648867)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_text=>'Start'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563426837482648867)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_text=>'Show the legend on the starting position (typically above the map).'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563426514008648867)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_text=>'Position'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563463410575649159)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_text=>'Hide'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617257848560049667)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_text=>'Do not show layer messages.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428143324648870)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_text=>'Specify where to show map layer No Data Found and More Data Found messages.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428279340648870)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_text=>'Above'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428380412648870)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_text=>'Show messages above the map.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428479880648870)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_text=>'Below'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428524711648870)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_text=>'Show messages below the map.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428672717648871)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_text=>'Selector'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428714601648871)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_text=>'Specify a jQuery selector for the element to display the messages in.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428008763648870)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_text=>'Messages Position'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428964759648872)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_text=>'jQuery selector for the element to display the messages in.'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563428884378648872)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_text=>'Message Selector'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563426278589648857)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_text=>'Specify whether to show a legend.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563426113042648857)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563429179154648872)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If a page item is chosen, the map region will always maintain the current map bounding box, in GeoJSON format, as the value of this item. This is useful to connect the map to another APEX component (for instance, a classic or interactive report): '
||'the contents of the bounding box item can be used by the other component to perform a spatial query and to display only data visible on the map.</p>',
'<p>Example content of the Bounding Box Item after some map movement or zoom level change:</p>',
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
'Using a <strong>Refresh</strong> Dynamic Action, the map can be connected to a report region. The report region can apply a spatial filter to show only results which are also visible on the map.</p>',
'<p>Example report query:</p>',
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column],',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] )',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563429028084648872)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_text=>'Bounding Box Item'
,p_version_scn=>37166067046422
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563460833898648941)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_text=>'Select the unit system to use for the scale bar and distance tool.'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461116165648942)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_text=>'Imperial'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461232071648942)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_text=>'Use the imperial system.'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461332655648942)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_text=>'Derive from Item'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461490403648942)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_text=>'Derive the unit system from the value of a page or application item.'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563460999061648941)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_text=>'Metric'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461009582648941)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_text=>'Use the metric system.'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563460721003648941)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_text=>'Unit System'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461617962648942)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_text=>'Enter a page or application item containing the value to use as the map unit system: <strong>METRIC</strong> (<strong>M</strong>) or <strong>IMPERIAL</strong> (<strong>I</strong>).'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563461557649648942)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_text=>'Unit System Item'
,p_version_scn=>37166067046435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621605735065359)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_text=>'Specify whether a marker should be rendered on the data items of the chart.'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621794996065359)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621962068065360)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_text=>'No'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621842724065359)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_text=>'Yes'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295621517733065358)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622100891065360)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_text=>'Select the shape of the marker to be rendered on the data items of the chart. Only <strong>auto</strong> is supported for range series. '
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622296621065361)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622329125065361)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_text=>'Circle'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622440774065362)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_text=>'Diamond'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622582839065362)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_text=>'Human'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622694449065362)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_text=>'Plus'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622726899065363)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_text=>'Square'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353256303908739294)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_text=>'Star'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622821466065363)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_text=>'Triangle Down'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622947511065363)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_text=>'Triangle Up'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295622069729065360)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_text=>'Shape'
,p_version_scn=>37166067046371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(405613359337209849)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If this column is a foreign key column for the master interactive grid region, as specified by <strong>Master Region</strong> in the region settings, select the corresponding primary key column from the master table.</p>',
'        <p>For example, if the master region was DEPT and this interactive grid was EMP, then you would select the DEPTNO column within the EMP interactive grid and then select the DEPTNO column from the list of DEPT columns for Master Column.</p>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(405613285488209848)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_text=>'Master Column'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972160480481109)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the master region to which this detail region belongs.<br>',
'        This should be set when this region is the detail region in a master-detail relationship with another region on this page.</p>',
'        <p>For the master-detail relationship to work correctly, select the column(s) in this region which are foreign keys to the master region, and specify the <strong>Master Column</strong> accordingly.'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245972073309481109)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_text=>'Master Region'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360869721502183855)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_text=>'Enter the maximum number to display in the Rows Per Page selector.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360869625273183855)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_text=>'Maximum Rows Per Page'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242717516098661329)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_TO_PROCESS.PROMPT'
,p_message_text=>'Maximum Rows to Process'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567457660073315686)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_text=>'Enter the maximum number of rows which can be processed for this layer. This can be used as a measure against too many spatial objects being downloaded and displayed on the map.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360867324532183853)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum number of rows which can be processed by the query. If the maximum number of rows to be processed exceeds the limit, then an error message will be displayed instead of data.',
'A custom message can be defined by specifying a message in <strong>More Data Found</strong>.</p>',
'<p>This attribute is to safeguard against end users performing actions, such as sorts or aggregations, on all the records in very large tables or views, which might not be performant.',
'Instead, the number of records being processed must first be reduced by adding additional filters.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360867210421183853)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_text=>'Maximum Rows to Process'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727611465661338)
,p_name=>'PE.PROPERTY.MAXIMUM_SESSION_IDLE_TIME.PROMPT'
,p_message_text=>'Maximum Session Idle Time'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727752395661338)
,p_name=>'PE.PROPERTY.MAXIMUM_SESSION_IDLE_TIME.UNIT'
,p_message_text=>'seconds'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727308771661338)
,p_name=>'PE.PROPERTY.MAXIMUM_SESSION_LENGTH.PROMPT'
,p_message_text=>'Maximum Session Length'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727451869661338)
,p_name=>'PE.PROPERTY.MAXIMUM_SESSION_LENGTH.UNIT'
,p_message_text=>'seconds'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705761872661318)
,p_name=>'PE.PROPERTY.MAX_LENGTH.PROMPT'
,p_message_text=>'Maximum Length'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114937290242758672)
,p_name=>'PE.PROPERTY.MAX_RENEWAL_COUNT.HELP'
,p_message_text=>'Specify the maximum renewal count of a Task.'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114937104287758672)
,p_name=>'PE.PROPERTY.MAX_RENEWAL_COUNT.PROMPT'
,p_message_text=>'Maximum Renewal Count'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311480900300630)
,p_name=>'PE.PROPERTY.MAX_RESULTS.HELP'
,p_message_text=>'Specify the maximum of results to show from this Search Configuration.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311350005300630)
,p_name=>'PE.PROPERTY.MAX_RESULTS.PROMPT'
,p_message_text=>'Maximum Results'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72496516558786844)
,p_name=>'PE.PROPERTY.MAX_SCHEDULER_JOBS.HELP'
,p_message_text=>'<p>Provide the maximum number of scheduler jobs being available for background execution of page processes for this application. Only the configured number of jobs will run at the same time, to execute page processes for this application in the backg'
||'round. If the configured maximum amount of scheduler jobs is active, new submitted executions will wait until a job becomes available.</p><p>Setting the attribute to zero disables background executions; new submitted executions will stay in enqueued '
||'state.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72496443595786843)
,p_name=>'PE.PROPERTY.MAX_SCHEDULER_JOBS.PROMPT'
,p_message_text=>'Maximum Background Page Process Jobs'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940339647296797)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_text=>'Specify whether this component displays using a column or advanced formatting using HTML expressions and supported substitution strings.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940216816296797)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_text=>'Advanced Formatting'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596948216067296956)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_text=>'Auto'
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942798001296799)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines the aspect ratio for the media.',
'<strong>Auto</strong> Uses a best fit to preserve the original media size.'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942892841296799)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_text=>'Square'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942913786296801)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_text=>'Applies a square aspect ratio.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943037510296801)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_text=>'Widescreen'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943189627296801)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_text=>'Applies a widescreen aspect ratio.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942697998296799)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_text=>'Appearance'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941713496296798)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_text=>'Select the column that returns the BLOB for the media source.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941660236296798)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_text=>'BLOB Column'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943933550296803)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943886993296803)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604961796784563)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.COMPONENT_PROPERTY.CARD.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The media description serves as a vital accessibility feature by providing contextual information about a media when it receives focus or is hovered over. This feature enhances user understanding and interaction with the interface.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Clear and Concise:</strong> Media description should be clear and succinct, providing users with a brief but informative understanding of the media''s function or purpose.</li>',
'<li><strong>Descriptive Language:</strong> Use descriptive language that accurately conveys the meaning or action associated with the media. Avoid ambiguous or vague descriptions that may confuse users.</li>',
'<li><strong>Determining Alt Text Need:</strong>',
'Evaluate whether the absence of the media would impact page comprehension.',
'If the page would lose meaning without the media, add the media description.</li>',
'</ol>'))
,p_version_scn=>36587345
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944138633296803)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_text=>'This text describes the media and may used for tooltips and alterative text for images.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596944099725296803)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_text=>'Image Description'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941970146296798)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_text=>'Determines where the media component is positioned on the card.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942483282296799)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_text=>'As Background Image'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942548604296799)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_text=>'Displays the media as the card background.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942230821296799)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_text=>'Body'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942370850296799)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_text=>'Displays the media within the card body.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942022568296798)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_text=>'First'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596942106769296798)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_text=>'Displays the media before the card header.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941873767296798)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_text=>'Position'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940643962296797)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Change the background and text colors</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Use Heading 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Use a dynamic class from the SQL query</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    The <code>&COLUMN_CLASS.</code> and <code>&EMPLOYEE_STATUS.</code> substitutions in this example are columns selected in the report SQL query.</dd>',
'  <dt>Show an image, and a tooltip on hover</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940593000296797)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_text=>'Enter HTML expressions to be shown in this column. Use <code>&COLUMN.</code> syntax to show column values in HTML.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940434552296797)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_text=>'HTML Expression'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943346653296801)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_text=>'Determines how the media is sized within the media component.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943645126296803)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_text=>'Cover'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943725216296803)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_text=>'Adjusts the sizing so the media fills the media display area.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943485924296801)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_text=>'Fit'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943571379296803)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_text=>'Adjusts the sizing so the media is contained within the media display area.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596943203403296801)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_text=>'Sizing'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596948181677296956)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_text=>'No Media'
,p_version_scn=>37166067046555
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940807640296797)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_text=>'Select the media source type.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941193075296798)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_text=>'BLOB Column'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941059313296798)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_text=>'URL Column'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940920526296797)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_text=>'Image URL'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596940788708296797)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_text=>'Source'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123092019257211777)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Internet media type. An Internet media type is a two part identifier for file formats on the Internet.',
'A media type is composed of at least two parts: a type, a subtype, and one or more optional parameters.',
'This media type is used in the Content-Type HTTP header when rendering the page.</p>',
'<p>The page-level Media type overrides the application-level media type.',
'If both the page-level and application-level values for media type are <code>NULL</code>, the media type <code>text/html</code> is used.</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123091932284211777)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_text=>'Media Type'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941376248296798)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_text=>'Enter the URL for the media source.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941268563296798)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_text=>'URL'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941515240296798)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_text=>'Select the column to be used as media source.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596941443377296798)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_text=>'URL Column'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970367019250226)
,p_name=>'PE.PROPERTY.MENU_ENTRY_TYPE.HELP'
,p_message_text=>'Select how the menu entry should be rendered.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970426716250226)
,p_name=>'PE.PROPERTY.MENU_ENTRY_TYPE.LOV.ENTRY.D'
,p_message_text=>'Menu Entry'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970584756250226)
,p_name=>'PE.PROPERTY.MENU_ENTRY_TYPE.LOV.ENTRY.HELP'
,p_message_text=>'A menu entry that executes an action.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970825486250227)
,p_name=>'PE.PROPERTY.MENU_ENTRY_TYPE.LOV.SEPARATOR.D'
,p_message_text=>'Separator'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970901320250227)
,p_name=>'PE.PROPERTY.MENU_ENTRY_TYPE.LOV.SEPARATOR.HELP'
,p_message_text=>'To group menu entries, a separator can be used to divide menu entries. If there is no previous or next menu entry, the separator will not be shown.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970647961250227)
,p_name=>'PE.PROPERTY.MENU_ENTRY_TYPE.LOV.SUB_MENU.D'
,p_message_text=>'Sub-Menu'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970734578250227)
,p_name=>'PE.PROPERTY.MENU_ENTRY_TYPE.LOV.SUB_MENU.HELP'
,p_message_text=>'Groups multiple other menu entries in a sub-menu. A sub-menu entry can''t execute an action.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115970262178250226)
,p_name=>'PE.PROPERTY.MENU_ENTRY_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579973348340721)
,p_name=>'PE.PROPERTY.MESSAGE_ID.HELP'
,p_message_text=>'Identifies the text message.'
,p_version_scn=>49870268
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579818964340721)
,p_name=>'PE.PROPERTY.MESSAGE_ID.PROMPT'
,p_message_text=>'Text Message'
,p_version_scn=>49870267
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689912157661303)
,p_name=>'PE.PROPERTY.MESSAGE_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606328814500648)
,p_name=>'PE.PROPERTY.META_DATA_PROCEDURE_NAME.PROMPT'
,p_message_text=>'Meta Data Procedure Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126954614579511161)
,p_name=>'PE.PROPERTY.META_TAG_NAME.HELP'
,p_message_text=>'The name of the meta tag identifies the type of content this meta tag is representing.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126954767534511161)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.DESCRIPTION.D'
,p_message_text=>'description'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126954813215511161)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.DESCRIPTION.HELP'
,p_message_text=>'A brief description of the page.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955385411511162)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:DESCRIPTION.D'
,p_message_text=>'og:description'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955457924511162)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:DESCRIPTION.HELP'
,p_message_text=>'Open Graph Protocol: A brief description of the page.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955561446511162)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:IMAGE.D'
,p_message_text=>'og:image'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955651889511162)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:IMAGE.HELP'
,p_message_text=>'Open Graph Protocol: An image URL which should represent the page within the graph.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955104135511162)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:TITLE.D'
,p_message_text=>'og:title'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955246915511162)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:TITLE.HELP'
,p_message_text=>'Open Graph Protocol: The title of your page as it should appear within the graph.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126954961362511161)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:TYPE.D'
,p_message_text=>'og:type'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955045759511161)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:TYPE.HELP'
,p_message_text=>'Open Graph Protocol: The type of page you are sharing. (e.g., article, website, etc.).'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955784516511162)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:URL.D'
,p_message_text=>'og:url'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955886123511162)
,p_name=>'PE.PROPERTY.META_TAG_NAME.LOV.OG:URL.HELP'
,p_message_text=>'Open Graph Protocol: The canonical URL of the page that will be used as its permanent ID in the graph.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126954532721511161)
,p_name=>'PE.PROPERTY.META_TAG_NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126956051265511162)
,p_name=>'PE.PROPERTY.META_TAG_VALUE.HELP'
,p_message_text=>'The value of the meta tag.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126955981951511162)
,p_name=>'PE.PROPERTY.META_TAG_VALUE.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669194379661284)
,p_name=>'PE.PROPERTY.MIME_TYPE.PROMPT'
,p_message_text=>'Mime Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627940978065381)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_text=>'Enter the increment between minor tick marks. Defaults to null for automatic calculation based on the data. Only applies to numerical axes.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627883383065381)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_text=>'Step'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627776665065380)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_text=>'Specify whether the minor tick marks are rendered.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627614866065380)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627554476065380)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_text=>'Enter the minimum increment between major tick marks. This is typically used to prevent fractional axis values for discrete measures.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295627482208065379)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_text=>'Minimum Step'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037807301862320)
,p_name=>'PE.PROPERTY.MLE_ENVIRONMENT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the MLE Environment in which to execute all snippets of MLE code in the application.',
'If none is provided, the default environment will be used.'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037725524862320)
,p_name=>'PE.PROPERTY.MLE_ENVIRONMENT.PROMPT'
,p_message_text=>'MLE Environment'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715161250661327)
,p_name=>'PE.PROPERTY.MULTIPLE_VALUES.PROMPT'
,p_message_text=>'Multiple Values'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668577861661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Normal characters:</dt>',
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
'<dt>Control Characters:</dt>',
'<dd>Tab (<em>ASCII: 9</em>) <pre>\t</pre></dd>',
'<dd>Linefeed (<em>ASCII: 10</em>) <pre>\n</pre></dd>',
'<dt>Other Characters:</dt>',
'<dd>Use a Unicode encoding value of the form ''\xxxx'' where ''xxxx'' is the hexadecimal value of a character in UCS-2 encoding format.</dd>',
'<dd>Start of Heading (<em>ASCII: 1</em>) <pre>\0001</pre></dd>',
'<dd>"@"-Symbol (<em>ASCII: 64</em>) <pre>\0040</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668419440661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_SEPARATOR.HELP'
,p_message_text=>'<p>Identifies the character which separates values from each other. Note that the <strong>"</strong> (double-quote) and <strong>\</strong> (backslash) characters are not supported as a Value Separator, also not in the <strong>\xxxx</strong> format.</'
||'p>'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668389818661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_text=>'Separator'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1919066916412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_SEPARATOR_ALWAYS.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Normal characters:</dt>',
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
'<dt>Control Characters:</dt>',
'<dd>Tab (<em>ASCII: 9</em>) <pre>\t</pre></dd>',
'<dd>Linefeed (<em>ASCII: 10</em>) <pre>\n</pre></dd>',
'<dt>Other Characters:</dt>',
'<dd>Use a Unicode encoding value of the form ''\xxxx'' where ''xxxx'' is the hexadecimal value of a character in UCS-2 encoding format.</dd>',
'<dd>Start of Heading (<em>ASCII: 1</em>) <pre>\0001</pre></dd>',
'<dd>"@"-Symbol (<em>ASCII: 64</em>) <pre>\0040</pre></dd>',
'</dl>'))
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918975985412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_SEPARATOR_ALWAYS.HELP'
,p_message_text=>'<p>Identifies the character which separates values from each other. Note that the <strong>"</strong> (double-quote) and <strong>\</strong> (backslash) characters are not supported as a Value Separator, also not in the <strong>\xxxx</strong> format.</'
||'p>'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918842991412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_SEPARATOR_ALWAYS.PROMPT'
,p_message_text=>'Separator'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918752030412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_SEPARATOR_OPTIONAL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Normal characters:</dt>',
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
'<dt>Control Characters:</dt>',
'<dd>Tab (<em>ASCII: 9</em>) <pre>\t</pre></dd>',
'<dd>Linefeed (<em>ASCII: 10</em>) <pre>\n</pre></dd>',
'<dt>Other Characters:</dt>',
'<dd>Use a Unicode encoding value of the form ''\xxxx'' where ''xxxx'' is the hexadecimal value of a character in UCS-2 encoding format.</dd>',
'<dd>Start of Heading (<em>ASCII: 1</em>) <pre>\0001</pre></dd>',
'<dd>"@"-Symbol (<em>ASCII: 64</em>) <pre>\0040</pre></dd>',
'</dl>'))
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918612901412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_SEPARATOR_OPTIONAL.HELP'
,p_message_text=>'<p>Identifies the character which separates values from each other. Note that the <strong>"</strong> (double-quote) and <strong>\</strong> (backslash) characters are not supported as a Value Separator, also not in the <strong>\xxxx</strong> format.</'
||'p>'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918546460412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_SEPARATOR_OPTIONAL.PROMPT'
,p_message_text=>'Separator'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668747876661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Whether to trim leading and trailing whitespace from individual values after splitting.</p>',
'<pre>',
'APEX:SQL:Spatial :Oracle Text: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
'<dt>Trim Whitespace <em>disabled</em> leads to the following individual values counted:</dt>',
'<dd><pre>',
'"APEX":            1',
'"APEX ":           1',
'"SQL":             2',
'"Spatial":         1',
'"Oracle Text":     1',
'"Data Warehouse":  1',
'" Data Warehouse": 1',
'</pre></dd>',
'<dt>Trim Whitespace <em>enabled</em> leads to the following individual values counted:</dt>',
'<dd><pre>',
'"APEX":            2',
'"SQL":             2',
'"Spatial":         1',
'"Oracle Text":     1',
'"Data Warehouse":  2',
'</pre></dd>',
'</dl>',
'<p>Note that trimming whitespace can significantly impact query performance. For larger data sets, consider data cleansing instead.</p>'))
,p_version_scn=>15114751
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668668163661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_text=>'Trim Whitespace'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242776267856661559)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_text=>'No'
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242776356407661559)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_text=>'Column does not contain multiple values.'
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242776449551661564)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_text=>'No'
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242776585055661564)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_text=>'Column does not contain multiple values.'
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667865514661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.HELP'
,p_message_text=>'<p>Determines whether the Source Column contains multiple values, and how these are encoded.</p>'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668108232661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_text=>'JSON Array'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668282884661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Source column contains a JSON array of scalar values. &PRODUCT_NAME. will raise error messages if the column contains invalid JSON syntax.</p><pre>["APEX", "SQL", "PL/SQL"]</pre><p>Use the JSON_TABLE SQL function for processing, as in the foll'
||'owing example:</p><pre>select',
'    element',
'from',
'    json_table ( <em>:ITEM_NAME</em>, ''$[*]''',
'        columns',
'            element varchar2 path ''$''',
'    );',
'</pre>'))
,p_version_scn=>13362723
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667936204661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_text=>'Delimited List'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668032342661279)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_text=>'<p>Column contains values as a delimited list.</p><pre>APEX,SQL,PL/SQL</pre><p>Use the APEX_STRING.SPLIT function for processing, as in the following example:</p><pre>select column_value from apex_string.split ( <em>:ITEM_NAME</em>, '','' );</pre>'
,p_version_scn=>1057828100
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242667762124661278)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918073368412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_ALWAYS.HELP'
,p_message_text=>'<p>Determines how multiple values are encoded.</p>'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918336152412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_ALWAYS.LOV.JSON_ARRAY.D'
,p_message_text=>'JSON Array'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918427245412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_ALWAYS.LOV.JSON_ARRAY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Source column contains a JSON array of scalar values. &PRODUCT_NAME. will raise error messages if the column contains invalid JSON syntax.</p><pre>["APEX", "SQL", "PL/SQL"]</pre><p>Use the JSON_TABLE SQL function for processing, as in the foll'
||'owing example:</p><pre>select',
'    element',
'from',
'    json_table ( <em>:ITEM_NAME</em>, ''$[*]''',
'        columns',
'            element varchar2 path ''$''',
'    );',
'</pre>'))
,p_version_scn=>13362727
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918183019412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_ALWAYS.LOV.SEPARATED.D'
,p_message_text=>'Delimited List'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1918247875412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_ALWAYS.LOV.SEPARATED.HELP'
,p_message_text=>'<p>Column contains values as a delimited list.</p><pre>APEX,SQL,PL/SQL</pre><p>Use the APEX_STRING.SPLIT function for processing, as in the following example:</p><pre>select column_value from apex_string.split ( <em>:ITEM_NAME</em>, '','' );</pre>'
,p_version_scn=>1057828108
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1917914458412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_ALWAYS.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1919372268412877)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_text=>'No'
,p_version_scn=>2711520
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1919480033412877)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_text=>'Column does not contain multiple values.'
,p_version_scn=>2711520
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1919171874412865)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_text=>'No'
,p_version_scn=>2711512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1919239699412865)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_text=>'Column does not contain multiple values.'
,p_version_scn=>2711512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1917464161412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.HELP'
,p_message_text=>'<p>Determines whether the Source Column contains multiple values, and how these are encoded.</p>'
,p_version_scn=>2711485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1917745348412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.LOV.JSON_ARRAY.D'
,p_message_text=>'JSON Array'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1917893694412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.LOV.JSON_ARRAY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Source column contains a JSON array of scalar values. &PRODUCT_NAME. will raise error messages if the column contains invalid JSON syntax.</p><pre>["APEX", "SQL", "PL/SQL"]</pre><p>Use the JSON_TABLE SQL function for processing, as in the foll'
||'owing example:</p><pre>select',
'    element',
'from',
'    json_table ( <em>:ITEM_NAME</em>, ''$[*]''',
'        columns',
'            element varchar2 path ''$''',
'    );',
'</pre>'))
,p_version_scn=>13362727
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1917577178412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.LOV.SEPARATED.D'
,p_message_text=>'Delimited List'
,p_version_scn=>2711486
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1917673326412806)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.LOV.SEPARATED.HELP'
,p_message_text=>'<p>Column contains values as a delimited list.</p><pre>APEX,SQL,PL/SQL</pre><p>Use the APEX_STRING.SPLIT function for processing, as in the following example:</p><pre>select column_value from apex_string.split ( <em>:ITEM_NAME</em>, '','' );</pre>'
,p_version_scn=>1057828108
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1917335927412796)
,p_name=>'PE.PROPERTY.MULTI_VALUE_TYPE_OPTIONAL.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>2711485
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156052912809978826)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_text=>'Enter the name of the branch for easy identification by developers.'
,p_version_scn=>37166067046509
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84570119270362966)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_text=>'Enter the name of the action. This helps to identify what the action does in Page Designer.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123170422212211913)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_text=>'Enter the name of the dynamic action.'
,p_version_scn=>37166067046499
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(124353858896670049)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_text=>'Displays the name of the Saved Report.'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360641216276667940)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_text=>'Enter the name of the column group.  This name displays as a region header in the detailed view.'
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(124353789562670041)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_SAVED_REPORT.HELP'
,p_message_text=>'Displays the name of the Saved Report.'
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567457123425315683)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_text=>'Enter a descriptive name for this component. Use the <strong>Label</strong> attribute, if HTML or substitutions are required for label display on the map region.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123169730471211912)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_text=>'Enter the name of the current page. This name is used in numerous &PRODUCT_NAME. pages and reports, along with the page number and title.'
,p_version_scn=>37166067046492
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123171726318211915)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_text=>'Enter the name of the process for easy identification by developers.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130217781383982865)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS_INVOKE_API_PARAM.HELP'
,p_message_text=>'Enter the name of a parameter declared in the selected procedure or function.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601170927784515)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ensure clear, descriptive titles for each region to aid user navigation and content understanding without relying on page context.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Clear and Descriptive:</strong>',
'The title should provide a clear and concise description of the content or purpose of the region. Avoid vague or ambiguous titles.</li>',
'</ul> '))
,p_version_scn=>36587287
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1917157241273890)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>'Enter a region name. The region name is required, it is used by Page Designer to identify the region on the tree view and the grid layout view. The region name is used as the runtime region title, if the title attribute is empty.'
,p_version_scn=>76038959
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311659583300803)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.SEARCH_REGION_SOURCES.HELP'
,p_message_text=>'Enter a descriptive name for this search source.'
,p_version_scn=>37166067046534
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156038120831350962)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_text=>'Enter the name for the validation. This name should be descriptive so that developers can easily identify conditions being checked.'
,p_version_scn=>37166067046512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117342871208910326)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.WF_ACTIVITY_INVOKE_API_PARAM.HELP'
,p_message_text=>'Enter the name of a parameter declared in the selected procedure or function.'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117337779158910315)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.WORKFLOW.HELP'
,p_message_text=>'Name of this workflow.'
,p_version_scn=>37166067046558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117340147771910319)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.WORKFLOW_ACTIVITY.HELP'
,p_message_text=>'Enter a name for the workflow activity.'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117342295660910322)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.WORKFLOW_BRANCH.HELP'
,p_message_text=>'Name of this workflow switch activity branch.'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117342536910910324)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.WORKFLOW_PARTICIPANT.HELP'
,p_message_text=>'Name of this workflow participant.'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117341989877910322)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.WORKFLOW_TRANSITION.HELP'
,p_message_text=>'Name of this workflow activity transition.'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085927581211762)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_text=>'Enter a descriptive name for this component.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123085824308211762)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111716222211817)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_text=>'Select the name of an existing list of values.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123111606081211817)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_text=>'List of Values'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(84570077093362906)
,p_name=>'PE.PROPERTY.NAME_HIDDEN.PROMPT'
,p_message_text=>'Name Hidden'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690063605661304)
,p_name=>'PE.PROPERTY.NAME_UPPER.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630126753500666)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_IMPLEMENTATION.LOV.LIST.D'
,p_message_text=>'List'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143630000951500666)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_IMPLEMENTATION.LOV.NAVBAR.D'
,p_message_text=>'Classic'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629973422500666)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_IMPLEMENTATION.PROMPT'
,p_message_text=>'Navigation Bar Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419938477648843)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_text=>'Choose the position of the navigation bar on the map.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420264750648843)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_text=>'End'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420336334648843)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_text=>'Show the navigation bar on the ending position (typically to the right side) of the map.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420053068648843)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_text=>'Start'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563420138157648843)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_text=>'Show the navigation bar on the starting position (typically to the left side) of the map.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419816364648843)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_text=>'Navigation Bar Position'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143638627520500672)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046459
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419133623648842)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_text=>'The type of navigation bar to use.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419648371648843)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_text=>'Zoom and Compass'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419746124648843)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_text=>'Zoom controls and compass to control map orientation.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419231025648842)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419383268648842)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_text=>'No navigation bar.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419407739648842)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_text=>'Zoom Only'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419583899648843)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_text=>'Only zoom in and zoom out controls.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563419049905648837)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_text=>'Navigation Bar'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1009218098048651460)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_text=>'Do not show Navigation Menu List'
,p_version_scn=>37166067046492
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174741323280982459)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_text=>'Select the navigation menu list utilized for navigation on this page.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174741207176982459)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1009217539517651320)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_text=>'Select the position for the navigation menu list on this page.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1009217704069651320)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_text=>'Side'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1009217651437651320)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_text=>'Top'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1009217485520651320)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_text=>'List Position'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174741511203982459)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_text=>'Select the navigation menu list template utilized with the navigation menu list on this page.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174741413546982459)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_text=>'List Template'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629844996500666)
,p_name=>'PE.PROPERTY.NAVIGATION_TYPE.LOV.L.D'
,p_message_text=>'List'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629777783500666)
,p_name=>'PE.PROPERTY.NAVIGATION_TYPE.LOV.T.D'
,p_message_text=>'Tabs'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629645630500666)
,p_name=>'PE.PROPERTY.NAVIGATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748454797661391)
,p_name=>'PE.PROPERTY.NAV_BAR_IMPLEMENTATION.LOV.LIST.D'
,p_message_text=>'List'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748322568661391)
,p_name=>'PE.PROPERTY.NAV_BAR_IMPLEMENTATION.LOV.NAVBAR.D'
,p_message_text=>'Classic'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748228887661390)
,p_name=>'PE.PROPERTY.NAV_BAR_IMPLEMENTATION.PROMPT'
,p_message_text=>'Implementation'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748545670661391)
,p_name=>'PE.PROPERTY.NAV_BAR_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748619643661391)
,p_name=>'PE.PROPERTY.NAV_BAR_LIST_TEMPLATE.PROMPT'
,p_message_text=>'List Template'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748779952661391)
,p_name=>'PE.PROPERTY.NAV_BAR_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1009217931406651321)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_text=>'<p>Select template options to customize the user interface of this navigation list.</p>'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1009217861928651321)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602417324500646)
,p_name=>'PE.PROPERTY.NEXT_PAGE_TEMPLATE.PROMPT'
,p_message_text=>'Next Page'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602626335500646)
,p_name=>'PE.PROPERTY.NEXT_SET_TEMPLATE.PROMPT'
,p_message_text=>'Next Set'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588186115500636)
,p_name=>'PE.PROPERTY.NON_CURRENT_IMAGE_TAB.PROMPT'
,p_message_text=>'Non Current'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931498630296575)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Show an arrow pointing right</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931312689296575)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the classes for the icon you want to add to the component. You may add multiple classes by separating them with spaces.</p>',
'        <p>If your theme uses Font APEX then review the <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a> to view available icons and modifiers.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596931202452296575)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_text=>'No Data Found Icon'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720043783661331)
,p_name=>'PE.PROPERTY.NO_PROXY_DOMAINS.PROMPT'
,p_message_text=>'No Proxy Domains'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945736751333064292)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_text=>'Enter the text to be displayed within the list NULL option at the top of this list.'
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584822633164747885)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_text=>'Enter the text to be displayed within the list NULL option at the top of this list.'
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136510173432670637)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_text=>'Enter the text to be displayed within the list NULL option at the top of this list.'
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136511453777670632)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_text=>'Enter the text to be displayed within the list NULL option at the top of this list.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123112312446211818)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_text=>'Enter the text to be displayed within the list NULL option at the top of this list. This value also displays when rendering the item if the value is null. If you do not enter any text, it is displayed as a blank line in the list and a blank item when'
||' rendered.'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123112223253211818)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_text=>'Null Display Value'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123112528944211818)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_text=>'Enter the value to be returned if the NULL value is selected in this list of values. If you do not provide a value, the item value is left as null when the NULL option is selected from this list.'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123112405363211818)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_text=>'Null Return Value'
,p_version_scn=>37166067046337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635112089500670)
,p_name=>'PE.PROPERTY.NULL_TEXT.PROMPT'
,p_message_text=>'Null Text'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605809692500648)
,p_name=>'PE.PROPERTY.NUMBER_OF_LAZY_LOADING_SKELETONS.PROMPT'
,p_message_text=>'Number of Lazy Loading Skeletons'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380760900577410005)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_text=>'Enter the number of report rows to display per report page.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380760831883410005)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_text=>'Number of Rows'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380761129475410006)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_text=>'Select the item whose value specifies the number of report rows to display per report page.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380761060023410006)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380760551355410005)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_text=>'Select how the number of rows for this report are entered.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795984801751597)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_text=>'Based on Item Value'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516795806925751596)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380760496624410005)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_text=>'Number of Rows Type'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658427408661071)
,p_name=>'PE.PROPERTY.OAUTH_SCOPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>',
'Permissions represented by the Access Token in OAuth 2.0 terms are known as scopes. The scope parameter allows the application to express the desired scope of the access request.',
'</p>',
'<p>',
'If your authentication server requires a scope to be specified for the access token request, provide it here. The OAuth2 access token will then be requested with the following request body:',
'<pre>',
'grant_type=client_credentials&amp;scope=<strong>{scope}</strong>',
'</pre>',
'</p>'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658385414661071)
,p_name=>'PE.PROPERTY.OAUTH_SCOPE.PROMPT'
,p_message_text=>'OAuth Scope'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661028317661091)
,p_name=>'PE.PROPERTY.OCI_PRIVATE_KEY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the private key in PEM format for OCI authentication. &PRODUCT_NAME. stores this information encrypted and secure, so it cannot be retrieved back in clear text.</p><p><a rel="noopener noreferrer" target="_blank" href="https://docs.clo',
'ud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a></p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242660916998661091)
,p_name=>'PE.PROPERTY.OCI_PRIVATE_KEY.PROMPT'
,p_message_text=>'OCI Private Key'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669495154661284)
,p_name=>'PE.PROPERTY.OCI_PUBLIC_KEY_FINGERPRINT.PROMPT'
,p_message_text=>'OCI Public Key Fingerprint'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669324796661284)
,p_name=>'PE.PROPERTY.OCI_TENANCY_ID.PROMPT'
,p_message_text=>'OCI Tenancy ID'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242660827282661091)
,p_name=>'PE.PROPERTY.OCI_USER_ID.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Cloud Infrastructure <em>User OCID</em>. &PRODUCT_NAME. does not store this information encrypted.</p> <p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigning',
'key.htm">Oracle Cloud Infrastructure Documentation</a></p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242660768401661091)
,p_name=>'PE.PROPERTY.OCI_USER_ID.PROMPT'
,p_message_text=>'OCI User ID'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715086611661327)
,p_name=>'PE.PROPERTY.OMIT_WHEN_NULL.PROMPT'
,p_message_text=>'Omit when value is empty'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749633597661392)
,p_name=>'PE.PROPERTY.ONLY_FOR_PAGE.PROMPT'
,p_message_text=>'Only for Page'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123104211403211803)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_text=>'Enter a URL target for when an end user attempts to perform a second page submission. &PRODUCT_NAME. displays an error message and a link to this URL to enable the user to continue.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123104127644211803)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_text=>'On duplicate page submissions go to this URL'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143578050173500629)
,p_name=>'PE.PROPERTY.ON_ERROR_AFTER_LABEL_TEMPLATE.PROMPT'
,p_message_text=>'After Label'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143577923105500629)
,p_name=>'PE.PROPERTY.ON_ERROR_BEFORE_LABEL_TEMPLATE.PROMPT'
,p_message_text=>'Before Label'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114936272700758645)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.BEFORE_EXPIRE.D'
,p_message_text=>'Before Expire'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242723875609661335)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.CANCEL.D'
,p_message_text=>'Cancel'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722966719661334)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.CLAIM.D'
,p_message_text=>'Claim'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242723063505661334)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.COMPLETE.D'
,p_message_text=>'Complete'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242723936868661335)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.CREATE.D'
,p_message_text=>'Create'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242723123352661334)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.DELEGATE.D'
,p_message_text=>'Delegate'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114936391481758646)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.EXPIRE.D'
,p_message_text=>'Expire'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242723530039661335)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.FAIL.D'
,p_message_text=>'Fail'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242723785946661335)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.RELEASE.D'
,p_message_text=>'Release'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242723372559661334)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.UPDATE_COMMENT.D'
,p_message_text=>'Update Comment'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242723636759661335)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.UPDATE_DUE_ON.D'
,p_message_text=>'Update Due On'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242723491046661334)
,p_name=>'PE.PROPERTY.ON_EVENT.LOV.UPDATE_PRIORITY.D'
,p_message_text=>'Update Priority'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722856501661334)
,p_name=>'PE.PROPERTY.ON_EVENT.PROMPT'
,p_message_text=>'On Event'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691406203661306)
,p_name=>'PE.PROPERTY.ON_UPGRADE_KEEP_STATUS.PROMPT'
,p_message_text=>'On Upgrade Keep Status'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690783668661305)
,p_name=>'PE.PROPERTY.ON_UPGRADE_KEEP_VALUE.PROMPT'
,p_message_text=>'On Upgrade Keep Value'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134029972393337202)
,p_name=>'PE.PROPERTY.OPENAPI_URL.HELP'
,p_message_text=>'<p>Enter the URL where the OpenAPI information is available. This can be an absolute URL or an URL relative to the Base URL of the service.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134029811363337202)
,p_name=>'PE.PROPERTY.OPENAPI_URL.PROMPT'
,p_message_text=>'OpenAPI URL'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388952859452781582)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_text=>'Specify if the page or URL replaces the current page or opens in a dialog.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516846231411751745)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_text=>'Dialog'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516846136949751744)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_text=>'Same Window'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388952791924781581)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_text=>'Open Link in'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116955072516909844)
,p_name=>'PE.PROPERTY.OPERATOR.HELP'
,p_message_text=>'Select the branch condition expression.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116955315917909844)
,p_name=>'PE.PROPERTY.OPERATOR.LOV.EQUALS.D'
,p_message_text=>'Is Equal To'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116955967468909845)
,p_name=>'PE.PROPERTY.OPERATOR.LOV.GREATER_THAN.D'
,p_message_text=>'Is Greater Than'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116956428714909845)
,p_name=>'PE.PROPERTY.OPERATOR.LOV.GTE.D'
,p_message_text=>'Is Greater Than Or Equal To'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116957011974909845)
,p_name=>'PE.PROPERTY.OPERATOR.LOV.IS_NULL.D'
,p_message_text=>'Is Null'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116956127058909845)
,p_name=>'PE.PROPERTY.OPERATOR.LOV.LESS_THAN.D'
,p_message_text=>'Is Less Than'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116956739211909845)
,p_name=>'PE.PROPERTY.OPERATOR.LOV.LTE.D'
,p_message_text=>'Is Less Than Or Equal To'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116955665788909844)
,p_name=>'PE.PROPERTY.OPERATOR.LOV.NOT_EQUALS.D'
,p_message_text=>'Is Not Equal To'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116957348758909846)
,p_name=>'PE.PROPERTY.OPERATOR.LOV.NOT_NULL.D'
,p_message_text=>'Is Not Null'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116957690456909846)
,p_name=>'PE.PROPERTY.OPERATOR.LOV.OTHERWISE.D'
,p_message_text=>'Otherwise'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116954754672909844)
,p_name=>'PE.PROPERTY.OPERATOR.PROMPT'
,p_message_text=>'Operator'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233436283111103926)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt><pre>INDEX (employees emp_department_ix)</pre></dt>',
'<dd>When accessing the table <code>employee</code> try to use the index <code>emp_department_ix</code></dd>',
'<dt><pre>WITH_PLSQL</pre></dt>',
'<dd>Enable the use of the <code>WITH plsql_declarations</code> clause within the SQL query</dd>',
'</dl>',
'<h5>The following <em>APEX Pseudo Hints</em> are available:</h5>',
'<dl>',
'<dt><pre>APEX$USE_OFFSET_PAGINATION</pre></dt>',
'<dd>Use the <strong>OFFSET m ROWS FETCH n ROWS</strong> (SQL2008) syntax, instead of the <strong>ROW_NUMBER</strong> analytic function, when generating pagination SQL. The executed query will only return rows of interest for the current component pag'
||'e.</dd>',
'<dt><pre>APEX$USE_ROWNUM_PAGINATION</pre></dt>',
'<dd>Use the <strong>ROWNUM</strong> pseudo column, instead of the <strong>ROW_NUMBER</strong> analytic function, when generating pagination SQL. The executed query will only return rows of interest for the current component page.</dd>',
'<dt><pre>APEX$USE_NO_PAGINATION</pre></dt>',
'<dd>Do not build any pagination SQL. The component always starts fetching at the first row; the current page is shown by skipping rows and stopping after fetching the last row of interest.</dd>',
'<dt><pre>APEX$USE_NO_BULK_FETCH</pre></dt>',
'<dd>Do not use bulk fetching for this query.</dd>',
'<dt><pre>APEX$USE_NO_GROUPING_SETS</pre></dt>',
'<dd>Do not use the <strong>GROUPING SETS</strong> SQL clause for Faceted Search or Smart Filters. Instead, compute counts for each facet or filter using an individual query, and combine these with UNION ALL.</dd>',
'</dl>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233436151526103925)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Optimizer hint which is added to the top-level statement when executing the SQL query generated by &PRODUCT_NAME..',
'        A hint is an instruction to the Optimizer. When writing SQL, you may know information about the data unknown to the Optimizer. Hints enable you to make decisions normally made by the Optimizer,',
'        sometimes causing the Optimizer to select a plan that it sees as higher cost.</p>',
'        <p>For example, you might know that a certain index is more selective for certain queries. Based on this information, you might be able to choose a more efficient execution plan than the Optimizer.',
'        In such a case, use hints to force the Optimizer to use the optimal execution plan.</p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(233436018063103924)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_text=>'Optimizer Hint'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948507782925507)
,p_name=>'PE.PROPERTY.ORACLE_DBMS_SEARCH_INDEX_NAME.HELP'
,p_message_text=>'Choose an Oracle Ubiquitous Search index, this index must already exist in your parsing schema.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948480837925507)
,p_name=>'PE.PROPERTY.ORACLE_DBMS_SEARCH_INDEX_NAME.PROMPT'
,p_message_text=>'Search Index Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948306118925507)
,p_name=>'PE.PROPERTY.ORACLE_DBMS_SEARCH_INDEX_OWNER.HELP'
,p_message_text=>'Choose an owner that has an Oracle Ubiquitous Search index. Only schemas are listed for which you also have object privileges.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948229352925507)
,p_name=>'PE.PROPERTY.ORACLE_DBMS_SEARCH_INDEX_OWNER.PROMPT'
,p_message_text=>'Search Index Owner'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948911356925507)
,p_name=>'PE.PROPERTY.ORACLE_DBMS_SEARCH_SOURCE_NAME.HELP'
,p_message_text=>'Choose an Oracle Ubiquitous Search index source from your parsing schema which is part of your selected Oracle Ubiquitous Search index.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948817610925507)
,p_name=>'PE.PROPERTY.ORACLE_DBMS_SEARCH_SOURCE_NAME.PROMPT'
,p_message_text=>'Search Source Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948721459925507)
,p_name=>'PE.PROPERTY.ORACLE_DBMS_SEARCH_SOURCE_OWNER.HELP'
,p_message_text=>'Choose an owner. Only schemas are listed for which a data source exists for the selected Oracle Ubiquitous Search index.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948665290925507)
,p_name=>'PE.PROPERTY.ORACLE_DBMS_SEARCH_SOURCE_OWNER.PROMPT'
,p_message_text=>'Search Source Owner'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720183302661331)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_FUNCTION.PROMPT'
,p_message_text=>'Custom Function Name'
,p_version_scn=>42020677
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1062892661984721692)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a column where the column is indexed by an Oracle Text index.</p>',
'<p>Row Search returns results based on the Oracle Text operator entered, providing the corresponding Oracle Text index has been created for the column.',
'This option should only be enabled if the necessary index exist, and the end users have been trained in how to utilize the Oracle Text search operators.',
'To simplify Oracle Text syntax for end users, you can select a ready-to-use function or specify your own custom function for the "Text Query Function" in the Application Definition settings.<br>',
'See <a rel="noopener noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/23/ccapp/index.html">Oracle Text Application Developers Guide</a>.</p>',
'<p>Note - When end users correctly enter the Oracle Text operators, then the search should be far more performant.</p>',
''))
,p_version_scn=>20263338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1062892550511721691)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_text=>'Oracle Text Index Column'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306469314300625)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN_NAME.HELP'
,p_message_text=>'Identify the name of the Oracle Text index to use for search.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306370423300625)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN_NAME.PROMPT'
,p_message_text=>'Oracle Text Index Column'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306687328300625)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_NAME.HELP'
,p_message_text=>'Identify the name of the Oracle Text or Ubiquitous Search index to use for search.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306579011300625)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_NAME.PROMPT'
,p_message_text=>'Oracle Text Index Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599371029351282305)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_text=>'Cleanup Code'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598985903065277)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_text=>'Select the orientation of this chart.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295599109606065278)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_text=>'Horizontal'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404230182553407288)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_text=>'Displays the data items of the chart horizontally.  For example, the bars on a Bar chart will display horizontally.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404229775905404214)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_text=>'Vertical'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404229930862405899)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_text=>'Displays the data items of the chart vertically.  For example, the bars on a Bar chart will display vertically.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295598834587065277)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_text=>'Orientation'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724152749661335)
,p_name=>'PE.PROPERTY.OUTCOME.LOV.APPROVED.D'
,p_message_text=>'Approved'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724208960661335)
,p_name=>'PE.PROPERTY.OUTCOME.LOV.REJECTED.D'
,p_message_text=>'Rejected'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724096785661335)
,p_name=>'PE.PROPERTY.OUTCOME.PROMPT'
,p_message_text=>'Outcome'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2400662117879615)
,p_name=>'PE.PROPERTY.OUTPUT_FILE_NAME.HELP'
,p_message_text=>'Specify a name for a data loop if the report layout will be used by report region for printing. The data loop name is used as name for the rows array of the JSON data.'
,p_version_scn=>79184269
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2400524344879614)
,p_name=>'PE.PROPERTY.OUTPUT_FILE_NAME.PROMPT'
,p_message_text=>'File Name'
,p_version_scn=>79184268
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134293431835567)
,p_name=>'PE.PROPERTY.OUT_VALUE_TYPE.HELP'
,p_message_text=>'Select how this parameter is populated.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134581726835567)
,p_name=>'PE.PROPERTY.OUT_VALUE_TYPE.LOV.COLLECTION.D'
,p_message_text=>'Collection (CLOB)'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134637527835567)
,p_name=>'PE.PROPERTY.OUT_VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_text=>'Set to the CLOB column value of the first row from the <em>Collection</em> entered.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134327592835567)
,p_name=>'PE.PROPERTY.OUT_VALUE_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134434092835567)
,p_name=>'PE.PROPERTY.OUT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134765100835567)
,p_name=>'PE.PROPERTY.OUT_VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_text=>'Preference'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134810669835567)
,p_name=>'PE.PROPERTY.OUT_VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_text=>'Set to the value of the <em>Preference</em> entered.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134160228835567)
,p_name=>'PE.PROPERTY.OUT_VALUE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311210341300630)
,p_name=>'PE.PROPERTY.OVERRIDE_LABEL.HELP'
,p_message_text=>'Specify a Label to use instead of the label configured in the Search Configuration.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311197923300630)
,p_name=>'PE.PROPERTY.OVERRIDE_LABEL.PROMPT'
,p_message_text=>'Override Label'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295612528794065326)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_text=>'Enter the height of the overview scrollbar, in pixels (for example 50px) or percent (for example 15%), to be rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295612482156065326)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_text=>'Height'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295612307605065326)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether an overview scrollbar should be rendered on the chart.',
'        Currently this option is only supported for vertical bar, line, area, line with area, stock, and combination charts.</p>',
'        <p>Note - The <strong>Zoom and Scroll</strong> option must be enabled for the overview scrollbar to be displayed.</p>'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295612283835065325)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174741104820982459)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_text=>'Specify whether the default User Interface level navigation is overwritten. This can be used to either have no navigation for the current page, or choose alternative navigation for the current page (for example to provide different navigation around '
||'a sub-section of your app).'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174741018408982458)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_text=>'Override User Interface Level'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123103223898211802)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_text=>'Select what type of session state protection is implemented for this page.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749960769751421)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_text=>'Arguments Must Have Checksum'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750066396751422)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If Request, Clear Cache, or Name/Value Pair arguments appear in the URL, a checksum must also be provided.<br>',
'The checksum type must be compatible with the most stringent <em>Session State Protection</em> attribute of all the items passed as arguments.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750388171751422)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_text=>'No URL Access'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750479721751422)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The page may not be accessed using a URL.<br>',
'However, the page may be the target of a <em>Branch to Page</em> branch type, as this does not perform a URL redirect.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749799813751421)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_text=>'Unrestricted'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749865084751421)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_text=>'The page may be requested using a URL, with or without session state arguments, and without having to have a checksum.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750161054751422)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_text=>'No Arguments Supported'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516750227572751422)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_text=>'A URL may be used to request the page, but the URL can not contain Request, Clear Cache, or Name/Value Pair arguments.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123103120619211802)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_text=>'Page Access Protection'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123102414332211801)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether this page is public or requires authentication.',
'If a page is identified as public, the page can be viewed by any user who accesses the page.',
'The application''s page sentry function may access this page attribute to identify pages that do not require prior authentication to view.',
'The implementation of the authentication scheme''s page sentry function determines whether this attribute has any effect.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749152019751420)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_text=>'Page Requires Authentication'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516749292988751420)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_text=>'Page Is Public'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123102326441211801)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_text=>'Authentication'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588407870500636)
,p_name=>'PE.PROPERTY.PAGE_GRID_TYPE.LOV.FIXED.D'
,p_message_text=>'Fixed Number of Columns'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588304419500636)
,p_name=>'PE.PROPERTY.PAGE_GRID_TYPE.LOV.TABLE.D'
,p_message_text=>'HTML Table'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588537182500636)
,p_name=>'PE.PROPERTY.PAGE_GRID_TYPE.LOV.VARIABLE.D'
,p_message_text=>'Variable Number of Columns'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143588283884500636)
,p_name=>'PE.PROPERTY.PAGE_GRID_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123088123535211768)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the page group to associate with this page.',
'Page groups do not affect functionality, but help developers manage the pages within an application.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123088019224211768)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_text=>'Page Group'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101426744211799)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter text substituted in for your page template''s <code>#ONLOAD#</code> substitution string.',
'To use this feature, your page template must include the <code>#ONLOAD#</code> substitution string.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123101308381211799)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_text=>'Page HTML Body Attribute'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718636155541979)
,p_name=>'PE.PROPERTY.PAGE_ID.HELP'
,p_message_text=>'Identifies the page.'
,p_version_scn=>148588995
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1718571275541979)
,p_name=>'PE.PROPERTY.PAGE_ID.PROMPT'
,p_message_text=>'Page'
,p_version_scn=>148588994
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(127955165258951193)
,p_name=>'PE.PROPERTY.PAGE_ITEM_DATA_TYPE.HELP'
,p_message_text=>'Select the data type of the page item.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(127955311035951193)
,p_name=>'PE.PROPERTY.PAGE_ITEM_DATA_TYPE.LOV.CLOB.D'
,p_message_text=>'CLOB'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(127955498924951193)
,p_name=>'PE.PROPERTY.PAGE_ITEM_DATA_TYPE.LOV.NUMBER.D'
,p_message_text=>'NUMBER'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(127955286772951193)
,p_name=>'PE.PROPERTY.PAGE_ITEM_DATA_TYPE.LOV.VARCHAR2.D'
,p_message_text=>'VARCHAR2'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(127955063917951193)
,p_name=>'PE.PROPERTY.PAGE_ITEM_DATA_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123088312782211772)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the page mode for this page.</p>',
'#LOV_VALUES#',
'<p>Note that options <em>Modal</em> and <em>Non-Modal Dialog</em> will only be available for selection where the current application theme contains a default <em>Dialog Page Template</em>.</p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748278651751414)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_text=>'Modal Dialog'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748374357751414)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The page is presented as a modal dialog.<br>',
'A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it.',
'The underlying page is grayed out and the end user is prevented from interacting with the rest of the page until the dialog is closed.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748496628751415)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_text=>'Non-Modal Dialog'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748588911751415)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The page is presented as a non-modal dialog.<br>',
'A non-modal dialog is an overlay window positioned within the viewport, where the end user can interact with the dialog, and content on the page that launched the dialog.',
'A non-modal dialog can be used when the requested information is not essential to continue, work can continue elsewhere while the window is still open.'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748059237751414)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516748140689751414)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_text=>'The page is presented as a normal &PRODUCT_NAME. application page.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123088215331211768)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_text=>'Page Mode'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(754561338001620580)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_text=>'Navigation Type'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(679286612525732139)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_text=>'Enter a PL/SQL function body that returns a value used as the source for this parameter.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(679286538847732139)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(679286490025732135)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_text=>'Enter the page or application item used as the source for this parameter. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(679286394474732133)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(679287020009732141)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter one or more page or application item used as the destination for this parameter. For multiple items, separate each item name with a comma.</p>',
'<p>You can type in the name or pick from the list of available items.',
'If you pick from the list and there is already text entered, then a comma is placed at the end of the existing text, followed by the item name returned from the list.'))
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(679286978214732141)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_text=>'Item(s)'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682184824956227183)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_text=>'Select the source for the parameter from the available list.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682185395607227188)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682185438202227188)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_text=>'Set to the value returned from the <em>PL/SQL Function Body</em> entered.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682184978896227183)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682185027129227186)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682185198837227187)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682185277381227187)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_text=>'Set to the text entered into <em>Static Value</em>.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(682184766792227182)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_text=>'Source'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366642912450523499)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_text=>'Enter the value for this parameter.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366642808857523499)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2095373076401475)
,p_name=>'PE.PROPERTY.PAGE_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this page on an existing page in another application in your workspace.'
,p_version_scn=>153063403
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2095298652401475)
,p_name=>'PE.PROPERTY.PAGE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>153063402
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380856877508128728)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_text=>'Theme Default'
,p_version_scn=>37166067046492
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123088801597211772)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a page template to define the appearance and layout of this page.</p>',
'        <p>Page templates are defined in the application theme.',
'        When a page is created, the template is automatically set to <em>Theme Default</em> which will render the page using the default page template defined in the current theme.',
'        Making a selection here overrides the default page template.</p>',
'        <p>Many themes contain page templates with specific purposes, such as for displaying content with side columns, login page, dialog pages, and so forth.<br>',
'        Universal Theme provides the following page templates:',
'          <dl>',
'            <dt>Standard</dt>',
'              <dd>The default page template. Ideal for home pages, dashboards, large reports, and other layouts where maximum screen real-estate is desired.</dd>',
'            <dt>Left Side Column</dt>',
'              <dd>Provides a slot on the left side where search and filter regions can be placed.</dd>',
'            <dt>Right Side Column</dt>',
'              <dd>Provides a collapsible slot on the right side where action-oriented controls such as buttons or lists can be displayed.</dd>',
'            <dt>Left and Right Side Columns</dt>',
'              <dd>Provides both the left-side column and collapsible right-side column that is well suited for very complex pages.</dd>',
'            <dt>Login</dt>',
'              <dd>Used exclusively for the application login page.</dd>',
'            <dt>Marquee</dt>',
'              <dd>Provides a collapsible right side column and a title-bar area which contains primary information.',
'              This page template is well suited for displaying a single record which has several related reports or data.',
'              Marquee is commonly used for displaying Master-Detail relationships where a single master record is first selected from a report. </dd>',
'            <dt>Minimal (No Navigation)</dt>',
'              <dd>Useful for very simple pages, disclaimers, single page applications, or where navigation is not necessary.</dd>',
'          </dl>',
'          See Also: <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a>',
'        </p>'))
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123088705676211772)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_text=>'Page Template'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586389027500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_BODY.PROMPT'
,p_message_text=>'Body'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584400843500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.1.D'
,p_message_text=>'One Level Tabs'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585292808500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.10.D'
,p_message_text=>'Custom 3'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585338429500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.11.D'
,p_message_text=>'Custom 4'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585428783500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.12.D'
,p_message_text=>'Custom 5'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585539177500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.13.D'
,p_message_text=>'Custom 6'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585679324500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.14.D'
,p_message_text=>'Custom 7'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585711930500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.15.D'
,p_message_text=>'Custom 8'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584535167500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.16.D'
,p_message_text=>'One Level Tabs with Sidebar'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584353753500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.17.D'
,p_message_text=>'No Tabs with Sidebar'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584999555500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.18.D'
,p_message_text=>'Two Level Tabs with Sidebar'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584809927500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.2.D'
,p_message_text=>'Two Level Tabs'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584252227500633)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.3.D'
,p_message_text=>'No Tabs'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584664456500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.4.D'
,p_message_text=>'Popup'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584740892500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.5.D'
,p_message_text=>'Printer Friendly'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584168698500633)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.6.D'
,p_message_text=>'Login'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585080076500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.8.D'
,p_message_text=>'Custom 1'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585140005500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.LOV.9.D'
,p_message_text=>'Custom 2'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143584030220500633)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CLASS.PROMPT'
,p_message_text=>'Class'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587625671500636)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CURRENT_PARENT_TAB.PROMPT'
,p_message_text=>'Current'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587260709500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CURRENT_TAB.PROMPT'
,p_message_text=>'Current'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587342256500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_CURRENT_TAB_FONT_ATTRIBUTES.PROMPT'
,p_message_text=>'Current Font Attributes'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586461453500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_FOOTER.PROMPT'
,p_message_text=>'Footer'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586210828500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_HEADER.PROMPT'
,p_message_text=>'Header'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586922580500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_NAVIGATION_BAR.PROMPT'
,p_message_text=>'Navigation Bar'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587096106500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_NAVIGATION_BAR_ENTRY.PROMPT'
,p_message_text=>'Navigation Bar Entry'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587811752500636)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_NON_CURRENT_PARENT_TAB.PROMPT'
,p_message_text=>'Non Current'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587428240500636)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_NON_CURRENT_STANDARD_TAB.PROMPT'
,p_message_text=>'Non Current'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587596776500636)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_NON_CURRENT_TAB_FONT_ATTRIBUTES.PROMPT'
,p_message_text=>'Non Current Font Attributes'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587161489500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_NOTIFICATION.PROMPT'
,p_message_text=>'Notification'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587797860500636)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_PARENT_CURR_TAB_FONT_ATTRIBUTES.PROMPT'
,p_message_text=>'Current Font Attributes'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143587957554500636)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_PARENT_NON_CURR_TAB_FONT_ATTR.PROMPT'
,p_message_text=>'Non Current Font Attributes'
,p_version_scn=>37166067046442
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586180804500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586891599500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_SUCCESS_MESSAGE.PROMPT'
,p_message_text=>'Success Message'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143586012736500635)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_TYPE.LOV.N.D'
,p_message_text=>'Normal Page'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585975127500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_TYPE.LOV.Y.D'
,p_message_text=>'Dialog Page'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143585807429500634)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600394629784507)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When designing web pages, it''s essential to prioritize user experience by implementing features that prevent data loss. By enabling the page warn on unsaved changes functionality, users are notified when attempting to navigate away from a page con'
||'taining unsaved modifications.',
'This feature not only enhances usability but also ensures data integrity and user satisfaction.</p>'))
,p_version_scn=>36587273
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589359113531855953)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify if the user is warned when trying to navigate away from the page, where the page contains unsaved changes.',
'        Page Items and Buttons also offer more granular control over when this check is performed, and what is included in it.',
'        For Buttons, you can specify if clicking the button will perform the check.',
'        For Page Items, you can specify if changes to the item are included, or ignored by the check (see the <em>Warn on Unsaved Changes</em> attribute for both).</p>',
'        <p>Note: This does not apply to an end user closing a Modal dialog page.</p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589359002031855953)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_text=>'Warn on Unsaved Changes'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360866313973183852)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_text=>'Select where the report pagination displays.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516780066870751536)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_text=>'Bottom - Left'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516780112385751537)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_text=>'Bottom - Right'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516780435344751537)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_text=>'Top and Bottom - Left'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516780551319751537)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_text=>'Top and Bottom - Right'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516780246080751537)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_text=>'Top - Left'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516780351712751537)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_text=>'Top - Right'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360866217706183852)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_text=>'Display Position'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602393799500646)
,p_name=>'PE.PROPERTY.PAGINATION_TEMPLATE.PROMPT'
,p_message_text=>'Pagination'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973744351250291)
,p_name=>'PE.PROPERTY.PAGINATION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the pagination type for this report. Often not all report rows are displayed in the report.',
'        In order to display additional rows, the end user can use the pagination provided.</p>',
'        <p>Pagination provides the end user with information about the number of rows displayed, and the current position within the result set.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974039611250292)
,p_name=>'PE.PROPERTY.PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_text=>'Scroll'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115974164457250292)
,p_name=>'PE.PROPERTY.PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Initially enough rows to fill the height of the region are displayed.',
'        As the end user scrolls additional rows are displayed, getting more data from the server as needed.'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973826817250292)
,p_name=>'PE.PROPERTY.PAGINATION_TYPE.LOV.SET.D'
,p_message_text=>'Page'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973948267250292)
,p_name=>'PE.PROPERTY.PAGINATION_TYPE.LOV.SET.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The first rows will be displayed, based on the number specified in <em>Rows per Page</em>.',
'        If there are additional rows, controls will be added to the report footer, allowing end users to navigate forwards and backwards between row sets.'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973635853250291)
,p_name=>'PE.PROPERTY.PAGINATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616329920500657)
,p_name=>'PE.PROPERTY.PARAMETER_DEFAULT_VALUE.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(737729528751218129)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_text=>'Parameter Id'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261146661719742)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_text=>'Specify whether the parameter is required and must always be set.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261098870719741)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_text=>'Required'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(53528905337320029)
,p_name=>'PE.PROPERTY.PARAMETER_UPDATABLE.HELP'
,p_message_text=>'Specify whether this task parameter is updatable.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(53528846944320028)
,p_name=>'PE.PROPERTY.PARAMETER_UPDATABLE.PROMPT'
,p_message_text=>'Updatable'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261383661719746)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_text=>'Specify a default or static value for this parameter.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355261285052719745)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116962830436909849)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.HELP'
,p_message_text=>'Select how this parameter is populated.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116966101336909852)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.DEFAULT.D'
,p_message_text=>'Default'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116966419939909852)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_text=>'Use the value defined as default in the Workflow parameter declaration.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116964921448909851)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116965259217909851)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>Expression</em> entered.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116965581168909851)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116965833996909851)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116963739352909850)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116964059171909850)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116966716427909852)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116967083192909852)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.NULL.HELP'
,p_message_text=>'Set to null as no value specified.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116964360651909850)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116964655093909851)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116963157005909850)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116963481807909850)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Set to the text entered into <em>Static Value</em>.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116962586327909849)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663357221661228)
,p_name=>'PE.PROPERTY.PARAM_DIRECTION.HELP'
,p_message_text=>'Select the direction of the parameter.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663471269661229)
,p_name=>'PE.PROPERTY.PARAM_DIRECTION.LOV.IN.D'
,p_message_text=>'In'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663691894661229)
,p_name=>'PE.PROPERTY.PARAM_DIRECTION.LOV.IN_OUT.D'
,p_message_text=>'In/Out'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663517158661229)
,p_name=>'PE.PROPERTY.PARAM_DIRECTION.LOV.OUT.D'
,p_message_text=>'Out'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663281797661228)
,p_name=>'PE.PROPERTY.PARAM_DIRECTION.PROMPT'
,p_message_text=>'Direction'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199072863982633)
,p_name=>'PE.PROPERTY.PARAM_DISPLAY_SEQUENCE.HELP'
,p_message_text=>'Enter the display sequence for this parameter in Page Designer.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130198948255982633)
,p_name=>'PE.PROPERTY.PARAM_DISPLAY_SEQUENCE.PROMPT'
,p_message_text=>'Display Sequence'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691110703661305)
,p_name=>'PE.PROPERTY.PARENT_BREADCRUMB_ENTRY.PROMPT'
,p_message_text=>'Parent Entry'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242692163831661306)
,p_name=>'PE.PROPERTY.PARENT_LIST_ENTRY.PROMPT'
,p_message_text=>'Parent Entry'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72496698166786902)
,p_name=>'PE.PROPERTY.PARENT_PROCESS.COMPONENT_PROPERTY.PAGE_PROCESS.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72496172635786843)
,p_name=>'PE.PROPERTY.PARENT_PROCESS.HELP'
,p_message_text=>'Defines the execution chain this process is a part of.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72496025359786843)
,p_name=>'PE.PROPERTY.PARENT_PROCESS.PROMPT'
,p_message_text=>'Execution Chain'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139982744786374609)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'No Parent'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123115706776211824)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_text=>'Select the parent region in which the region will be displayed.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123115612423211823)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_text=>'Parent Region'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242705841352661319)
,p_name=>'PE.PROPERTY.PARSING_FORMAT_MASK.PROMPT'
,p_message_text=>'Format Mask'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730102096661340)
,p_name=>'PE.PROPERTY.PARSING_SCHEMA.PROMPT'
,p_message_text=>'Parsing Schema'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380760396454410004)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to use Partial Page Refresh (PPR) to update the report display.</p>',
'If the end user performs an action, such as a pagination request or selection of a new sort column, the current report rows must be refreshed. Setting this attribute to <strong>On</strong>, refreshes just the report region. Setting this attribute to '
||'<strong>Off</strong>, refreshes the entire page.'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380760248099410004)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_text=>'Partial Page Refresh'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604983987500647)
,p_name=>'PE.PROPERTY.PARTIAL_TEMPLATE.PROMPT'
,p_message_text=>'Partial'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242725997519661337)
,p_name=>'PE.PROPERTY.PARTICIPANT_TYPE.LOV.BUSINESS_ADMIN.D'
,p_message_text=>'Business Administrator'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242725875225661337)
,p_name=>'PE.PROPERTY.PARTICIPANT_TYPE.LOV.POTENTIAL_OWNER.D'
,p_message_text=>'Potential Owner'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242725750444661336)
,p_name=>'PE.PROPERTY.PARTICIPANT_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(124353690572669926)
,p_name=>'PE.PROPERTY.PARTICIPANT_VALUE_TYPE.HELP'
,p_message_text=>'Select how this participant is populated.'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726311006661337)
,p_name=>'PE.PROPERTY.PARTICIPANT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726463046661337)
,p_name=>'PE.PROPERTY.PARTICIPANT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726230379661337)
,p_name=>'PE.PROPERTY.PARTICIPANT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726165564661337)
,p_name=>'PE.PROPERTY.PARTICIPANT_VALUE_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726090311661337)
,p_name=>'PE.PROPERTY.PARTICIPANT_VALUE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(51006932869312870)
,p_name=>'PE.PROPERTY.PASS_ECID.COMPONENT_PROPERTY.WEB_SRC_MODULE.NULL_TEXT'
,p_message_text=>'Application Default'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(51006821580312624)
,p_name=>'PE.PROPERTY.PASS_ECID.LOV.N.D'
,p_message_text=>'No'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(51006754713312623)
,p_name=>'PE.PROPERTY.PASS_ECID.LOV.Y.D'
,p_message_text=>'Yes'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712067819661324)
,p_name=>'PE.PROPERTY.PASS_ECID.PROMPT'
,p_message_text=>'Pass ECID'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516792476910751585)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380729553679508664)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the background of this graph.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380729412970508663)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_text=>'Background Color'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380729992227508667)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_text=>'Enter the width in pixels for this bar chart.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380729805986508665)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_text=>'Bar Width'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388641188202170318)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_text=>'pixels'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516971320113068864)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380729753539508664)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the foreground of this graph.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380729630743508664)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_text=>'Foreground Color'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606148842065304)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the fraction of the whole pie chart, below which the slices are aggregated into an "Other" slice.  Valid values range from 0 (default) to 1</p>',
'        <p>For example, a value of 0.15 would cause all slices which are less than 15% of the pie to be aggregated into the "Other" slice.</p>'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606007221065303)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_text=>'Pie Chart Other Threshold'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333015501204931)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_text=>'Select the effect applied when a pie segment is selected.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333139484204931)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_text=>'Explode'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333397955204932)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_text=>'Highlight'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333232415204931)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_text=>'Highlight And Explode'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337332984009204929)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_text=>'Pie Selection Effect'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381156136324155779)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_text=>'Enter a PL/SQL expression that provides a value for the primary key.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381156039012155779)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381156319188155780)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_text=>'Enter a name for the primary key.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381156201299155780)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381155692494155779)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_text=>'Select the source type for the primary key.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516799356171751608)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516799459752751609)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_text=>'Existing sequence'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516799264218751608)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_text=>'Existing trigger'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381155583431155778)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488469436881554660)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_text=>'Enter a SQL query to be used in place of a automatically generated query that selects the distinct column values. The SQL query needs to return one column. Entering a SQL query can improve performance in some reports.  This list of values displays wh'
||'en a user clicks on a column header.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488469388757554660)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488468471083554658)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_text=>'Select how to derive the list of values for the filter on the report column drop down list.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516854075593751765)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_text=>'Use Named List of Values to Filter Exact Match'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516854170290751765)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_text=>'Derive the list of values from the named list of values to create an equal filter.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516854232197751765)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_text=>'Use Named List of Values to Filter Word Contains'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516854361882751765)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_text=>'Derive the list of values from the named list of values to create a contains filter.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516853836368751764)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_text=>'Use Defined List of Values to Filter Word Contains'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516853901847751765)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_text=>'Derive the list of values from a defined list of values SQL query to create a contains filter.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516853416777751764)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_text=>'Default Based on Column Type'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516853509628751764)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_text=>'STRING and NUMBER columns derive the list of values from distinct column values. DATE columns derive the list of values from predefined date ranges.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516853210004751763)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_text=>'None'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516853384545751764)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_text=>'Disable filter on list of values.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516853670569751764)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_text=>'Use Defined List of Values to Filter Exact Match'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516853700697751764)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_text=>'Derive the list of values from a defined list of values SQL query to create an equal filter.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(488468309750554658)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358409856961928038)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_text=>'Enter the PL/SQL code to be executed on the remote database.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358409733646928034)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>'Enter the PL/SQL code to generate the HTML output.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117340481930910319)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.WORKFLOW_ACTIVITY.HELP'
,p_message_text=>'Enter the PL/SQL code to be executed on the remote database.'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150988121549822706)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_text=>'Enter the PL/SQL source utilized within this authentication scheme.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150988032428822706)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_text=>'PL/SQL Code'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358409262598891096)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_text=>'Select where the process is executed.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358409385085891098)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_text=>'Local Database'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358409404502891098)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_text=>'PL/SQL code is executed in the local database.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358409592850891099)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358409614550891100)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_text=>'PL/SQL code is executed in a remote database, where the connection is defined using REST Enabled SQL. '
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358409157194891091)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_text=>'Location'
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616136339500655)
,p_name=>'PE.PROPERTY.PLUGIN_ABOUT_URL.PROMPT'
,p_message_text=>'About URL'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143628717174500665)
,p_name=>'PE.PROPERTY.PLUGIN_ACTION_POSITION_TYPE.LOV.LINK.D'
,p_message_text=>'Link'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143628806905500665)
,p_name=>'PE.PROPERTY.PLUGIN_ACTION_POSITION_TYPE.LOV.TEMPLATE.D'
,p_message_text=>'Template'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143628621563500665)
,p_name=>'PE.PROPERTY.PLUGIN_ACTION_POSITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629393287500666)
,p_name=>'PE.PROPERTY.PLUGIN_ACTION_TEMPLATE.PROMPT'
,p_message_text=>'Action Template'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629165653500666)
,p_name=>'PE.PROPERTY.PLUGIN_ACTION_TEMPLATE_TYPE.LOV.BUTTON.D'
,p_message_text=>'Button'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629212105500666)
,p_name=>'PE.PROPERTY.PLUGIN_ACTION_TEMPLATE_TYPE.LOV.MENU.D'
,p_message_text=>'Menu'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629010402500666)
,p_name=>'PE.PROPERTY.PLUGIN_ACTION_TEMPLATE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626459087500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_COMP_TYPE_SCOPE.LOV.PAGE.D'
,p_message_text=>'Current Page'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626517095500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_COMP_TYPE_SCOPE.LOV.PAGE_AND_GLOBAL.D'
,p_message_text=>'Current Page and Global Page'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626614624500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_COMP_TYPE_SCOPE.LOV.PARENT.D'
,p_message_text=>'Within Parent Component'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626705939500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_COMP_TYPE_SCOPE.LOV.THEME.D'
,p_message_text=>'Current Theme'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626395039500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_COMP_TYPE_SCOPE.PROMPT'
,p_message_text=>'Scope'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624945748500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.BFILE.D'
,p_message_text=>'Bfile'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624782774500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.BLOB.D'
,p_message_text=>'Blob'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624848885500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.CLOB.D'
,p_message_text=>'Clob'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624197612500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.DATE.D'
,p_message_text=>'Date'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624623769500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.INTERVAL_D2S.D'
,p_message_text=>'Interval Day to Second'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624566356500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.INTERVAL_Y2M.D'
,p_message_text=>'Interval Year to Month'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624062462500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.NUMBER.D'
,p_message_text=>'Number'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625041952500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.ROWID.D'
,p_message_text=>'Rowid'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624226068500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.TIMESTAMP.D'
,p_message_text=>'Timestamp'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624405629500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.TIMESTAMP_LTZ.D'
,p_message_text=>'Timestamp with Local Time Zone'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143624303614500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.TIMESTAMP_TZ.D'
,p_message_text=>'Timestamp with Time Zone'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623946645500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.LOV.VARCHAR2.D'
,p_message_text=>'Varchar2'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623869947500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DATA_TYPES.PROMPT'
,p_message_text=>'Data Types'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627193392500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DEFAULT_VALUE.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623334346500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_DISPLAY_WIDTH.PROMPT'
,p_message_text=>'Display Width'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625936814500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_ESCAPE_MODE.LOV.ATTR.D'
,p_message_text=>'HTML Attribute'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625844907500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_ESCAPE_MODE.LOV.HTML.D'
,p_message_text=>'HTML'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626129905500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_ESCAPE_MODE.LOV.RAW.D'
,p_message_text=>'Raw'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626063318500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_ESCAPE_MODE.LOV.STRIPHTML.D'
,p_message_text=>'Strip HTML'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625757462500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_ESCAPE_MODE.PROMPT'
,p_message_text=>'Escape Mode'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618034438500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_GROUP.PROMPT'
,p_message_text=>'Attribute Group'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622915126500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_IS_COMMON.PROMPT'
,p_message_text=>'Common'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623162438500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_IS_REQUIRED.PROMPT'
,p_message_text=>'Required'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623289125500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_IS_TRANSLATABLE.PROMPT'
,p_message_text=>'Translatable'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626299612500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_LOV_COMPONENT_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625539497500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_LOV_NULL_TEXT.PROMPT'
,p_message_text=>'LOV Null Text'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622838074500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_LOV_TYPE.LOV.COMPONENT.D'
,p_message_text=>'Component'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622763614500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_LOV_TYPE.LOV.STATIC.D'
,p_message_text=>'Static'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622674418500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_LOV_TYPE.PROMPT'
,p_message_text=>'Lov Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623663579500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_MAXIMUM_COLUMNS.PROMPT'
,p_message_text=>'Maximum Columns'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623476165500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_MAXIMUM_LENGTH.PROMPT'
,p_message_text=>'Maximum Length'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623596950500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_MINIMUM_COLUMNS.PROMPT'
,p_message_text=>'Minimum Columns'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626975367500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_ON_DELETE_BEHAVIOR.LOV.WEAK_CASCADE.D'
,p_message_text=>'Cascade'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627064136500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_ON_DELETE_BEHAVIOR.LOV.WEAK_NULL.D'
,p_message_text=>'Set to NULL'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143626875157500664)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_ON_DELETE_BEHAVIOR.PROMPT'
,p_message_text=>'On Delete Behavior'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617517163500658)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SCOPE.LOV.APPLICATION.D'
,p_message_text=>'Application'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617839907500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SCOPE.LOV.COLUMN.D'
,p_message_text=>'Region Column'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617618568500658)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SCOPE.LOV.COMPONENT.D'
,p_message_text=>'Component'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617713081500658)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SCOPE.LOV.REPORT.D'
,p_message_text=>'Report'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617409808500658)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SCOPE.PROMPT'
,p_message_text=>'Scope'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143617938087500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SEQUENCE.PROMPT'
,p_message_text=>'Attribute'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625396287500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SET_TEXT_CASE.LOV.LOWER.D'
,p_message_text=>'Lowercase'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625293761500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SET_TEXT_CASE.LOV.UPPER.D'
,p_message_text=>'Uppercase'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625190999500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SET_TEXT_CASE.PROMPT'
,p_message_text=>'Set Text Case'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623049391500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_SHOW_IN_WIZARD.PROMPT'
,p_message_text=>'Show in Wizard'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622323701500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.AUTHORIZATION GROUPS.D'
,p_message_text=>'Authorization Groups'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622259075500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.CHECKBOX.D'
,p_message_text=>'Yes/No'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618242668500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.CHECKBOXES.D'
,p_message_text=>'Checkboxes'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618387706500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.CODE LANGUAGE.D'
,p_message_text=>'Code Language'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618447857500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.COLOR.D'
,p_message_text=>'Color'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618504852500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.COLUMN.D'
,p_message_text=>'Column'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622461690500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.CREDENTIAL ID.D'
,p_message_text=>'Credentials'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618637060500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.DATA LOAD DEFINITION ID.D'
,p_message_text=>'Data Load Definition ID'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618735284500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.DATA LOAD TABLE ID.D'
,p_message_text=>'Data Load Table ID'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618836594500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.EMAIL TEMPLATE ID.D'
,p_message_text=>'Email Template'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618941851500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.HTML.D'
,p_message_text=>'HTML'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619081212500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.ICON.D'
,p_message_text=>'Icon'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619196670500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.INTEGER.D'
,p_message_text=>'Integer'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619749788500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript Code'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619861937500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.LINK.D'
,p_message_text=>'Link to Target Page/URL'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619975154500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.MEDIA.D'
,p_message_text=>'Media'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619375853500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.MLE JAVASCRIPT EXPRESSION BOOLEAN.D'
,p_message_text=>'JavaScript (MLE) Expression Returning BOOLEAN'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619490326500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.MLE JAVASCRIPT EXPRESSION VARCHAR2.D'
,p_message_text=>'JavaScript (MLE) Expression Returning VARCHAR2'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619531684500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.MLE JAVASCRIPT FUNCTION BODY BOOLEAN.D'
,p_message_text=>'JavaScript (MLE) Function Body Returning BOOLEAN'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619614993500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.MLE JAVASCRIPT FUNCTION BODY VARCHAR2.D'
,p_message_text=>'JavaScript (MLE) Function Body Returning VARCHAR2'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143619248919500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.MLE JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620073388500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.NUMBER.D'
,p_message_text=>'Number'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620186023500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.OWNER.D'
,p_message_text=>'Owner'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620918741500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PAGE ITEM.D'
,p_message_text=>'Page Item'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621000718500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PAGE ITEMS.D'
,p_message_text=>'Page Items'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621176706500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PAGE NUMBER.D'
,p_message_text=>'Page Number'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621206010500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PAGE NUMBERS.D'
,p_message_text=>'Page Numbers'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622574861500662)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PLACEHOLDER JSON.D'
,p_message_text=>'Template Placeholders'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620324757500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PLSQL EXPRESSION BOOLEAN.D'
,p_message_text=>'PL/SQL Expression Returning BOOLEAN'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620473298500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PLSQL EXPRESSION.D'
,p_message_text=>'PL/SQL Expression Returning VARCHAR2'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620588770500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PLSQL FUNCTION BODY BOOLEAN.D'
,p_message_text=>'PL/SQL Function Body Returning BOOLEAN'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620656617500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PLSQL FUNCTION BODY.D'
,p_message_text=>'PL/SQL Function Body Returning VARCHAR2'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620800754500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PLSQL METHOD.D'
,p_message_text=>'PL/SQL Procedure or Function'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620722838500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PLSQL PACKAGE.D'
,p_message_text=>'PL/SQL Package'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143620285628500660)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.PLSQL.D'
,p_message_text=>'PL/SQL Code'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621387793500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.REGION SOURCE COLUMN.D'
,p_message_text=>'Region SQL Statement Column'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1416701156354238)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.REPORT QUERY ID.D'
,p_message_text=>'Report Query'
,p_version_scn=>79184259
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621546830500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.SELECT LIST.D'
,p_message_text=>'Select List'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621653639500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.SESSION STATE VALUE.D'
,p_message_text=>'Session State Value'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621494359500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.SQL.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621791300500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.TABLE.D'
,p_message_text=>'Table'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621847670500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.TASK DEFINITION ID.D'
,p_message_text=>'Task Definition'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143621999849500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.TEXT.D'
,p_message_text=>'Text'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622029980500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.TEXTAREA.D'
,p_message_text=>'Textarea'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143622169516500661)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.LOV.XML.D'
,p_message_text=>'XML'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143618149611500659)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143625466405500663)
,p_name=>'PE.PROPERTY.PLUGIN_ATTRIBUTE_UNIT.PROMPT'
,p_message_text=>'Unit'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226306709146475459)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_text=>'Select under which category the plug-in is displayed in the user interface.'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(103918742871939455)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.APPLICATION.D'
,p_message_text=>'Application Components'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516775978111751522)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_text=>'Component'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516776014600751523)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_text=>'Effect'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516776137854751523)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_text=>'Execute'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516776211198751523)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_text=>'Initialize'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516776329523751523)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_text=>'Miscellaneous'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(103918666124939455)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NATIVE.D'
,p_message_text=>'Built-in Components'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516776473495751523)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_text=>'Navigation'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516776599075751524)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_text=>'Notification'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516776657457751524)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_text=>'Style'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(103918874928939455)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.THEME.D'
,p_message_text=>'Theme Components'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226306616496475459)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_text=>'Category'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616253330500657)
,p_name=>'PE.PROPERTY.PLUGIN_HELP_TEXT.PROMPT'
,p_message_text=>'Help Text'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578916379340721)
,p_name=>'PE.PROPERTY.PLUGIN_ID.HELP'
,p_message_text=>'Identifies the plug-in.'
,p_version_scn=>49870264
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10578857896340721)
,p_name=>'PE.PROPERTY.PLUGIN_ID.PROMPT'
,p_message_text=>'Plug-in'
,p_version_scn=>49870263
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602837082500646)
,p_name=>'PE.PROPERTY.PLUGIN_INTERNAL_NAME.PROMPT'
,p_message_text=>'Internal Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143623727839500662)
,p_name=>'PE.PROPERTY.PLUGIN_PARENT_ATTRIBUTE.PROMPT'
,p_message_text=>'Parent Attribute'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579147754340721)
,p_name=>'PE.PROPERTY.PLUGIN_SETTING_ID.HELP'
,p_message_text=>'Identifies the plug-in settings.'
,p_version_scn=>49870264
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579092797340721)
,p_name=>'PE.PROPERTY.PLUGIN_SETTING_ID.PROMPT'
,p_message_text=>'Plug-in Settings'
,p_version_scn=>49870264
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615200905500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_AUTHENTICATION_ATTRIBUTES.LOV.INVALID_SESSION.D'
,p_message_text=>'Has Session not Valid Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615396340500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_AUTHENTICATION_ATTRIBUTES.LOV.LOGIN_PAGE.D'
,p_message_text=>'Has Login Page In Application'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615186376500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_AUTHENTICATION_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes:'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614022016500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.BUTTON.D'
,p_message_text=>'For Button'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614595477500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.EVENT_SOURCE.D'
,p_message_text=>'For Event Source'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615042529500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.INIT_JAVASCRIPT_CODE.D'
,p_message_text=>'Has "Initialization JavaScript Code" Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613923568500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.ITEM.D'
,p_message_text=>'For Item(s)'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614399496500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_text=>'For JavaScript Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614252523500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.JQUERY_SELECTOR.D'
,p_message_text=>'For jQuery Selector'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614707025500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.ONLOAD.D'
,p_message_text=>'Check "Fire on Initialization"'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614187270500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.REGION.D'
,p_message_text=>'For Region'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614601498500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.REQUIRED.D'
,p_message_text=>'Affected Element Required'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614864180500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.STOP_EXECUTION_ON_ERROR.D'
,p_message_text=>'Has "Stop Execution on Error" Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614418761500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.TRIGGERING_ELEMENT.D'
,p_message_text=>'For Triggering Element'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143614971679500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.LOV.WAIT_FOR_RESULT.D'
,p_message_text=>'Has "Wait For Result" Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613804167500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_DYNAMIC_ACTION_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610608599500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.CASCADING_LOV.D'
,p_message_text=>'Has Cascading LOV Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609799794500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.ELEMENT.D'
,p_message_text=>'Has Element Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610041929500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.ELEMENT_OPTION.D'
,p_message_text=>'Has Element Option Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610369780500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.ENCRYPT.D'
,p_message_text=>'Has Encrypt Session State Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609259099500650)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.ESCAPE_OUTPUT.D'
,p_message_text=>'Has Escape Special Characters Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611551997500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.FC_FILTER_VALUES.D'
,p_message_text=>'Facet: Client-Side Filtering'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611290874500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.FC_HAS_FEEDBACK.D'
,p_message_text=>'Facet: Gather Occurrences'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611677041500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.FC_LOV_DISPLAY_NULL.D'
,p_message_text=>'Facet: LOV Display Null Value'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611478463500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.FC_SHOW_MORE_COUNT.D'
,p_message_text=>'Facet: Maximum Displayed Entries'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611304118500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.FC_SHOW_SELECTED_FIRST.D'
,p_message_text=>'Facet: Show Selected First'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610874159500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.FILTER.D'
,p_message_text=>'Has Filter'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609529357500650)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.FORMAT_MASK_DATE.D'
,p_message_text=>'Format Mask Date Only'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609689789500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.FORMAT_MASK_NUMBER.D'
,p_message_text=>'Format Mask Number Only'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608934373500650)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.FORM_ELEMENT.D'
,p_message_text=>'Standard Form Element'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609993408500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.HEIGHT.D'
,p_message_text=>'Has Height Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610266447500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.ICON.D'
,p_message_text=>'Has Icon Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611042077500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.INIT_JAVASCRIPT_CODE.D'
,p_message_text=>'Has "Initialization JavaScript Code" Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610782494500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.JOIN_LOV.D'
,p_message_text=>'Join LOV for Column Display'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610948006500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.LINK.D'
,p_message_text=>'Has Link'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610484820500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.LOV.D'
,p_message_text=>'Has List of Values'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610511153500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.LOV_DISPLAY_NULL.D'
,p_message_text=>'Has LOV Display Null Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143610125665500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.PLACEHOLDER.D'
,p_message_text=>'Has Placeholder Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609318112500650)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.QUICKPICK.D'
,p_message_text=>'Has Quick Pick Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609176919500650)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.READONLY.D'
,p_message_text=>'Has Read Only Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609007809500650)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.SESSION_STATE.D'
,p_message_text=>'Session State Changeable'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611177582500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.SESSION_STATE_CLOB.D'
,p_message_text=>'Session State Supports CLOB'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609437705500650)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.SOURCE.D'
,p_message_text=>'Has Source Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608869781500650)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.VISIBLE.D'
,p_message_text=>'Is Visible Widget'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143609859469500651)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.LOV.WIDTH.D'
,p_message_text=>'Has Width Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608798876500650)
,p_name=>'PE.PROPERTY.PLUGIN_STD_ITEM_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615706172500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_PROCESS_ATTRIBUTES.LOV.REGION.D'
,p_message_text=>'Region'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615877697500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_PROCESS_ATTRIBUTES.LOV.REGION_REQUIRED.D'
,p_message_text=>'Region Required'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(259065368882273300)
,p_name=>'PE.PROPERTY.PLUGIN_STD_PROCESS_ATTRIBUTES.LOV.WAIT_FOR_COMPLETION.D'
,p_message_text=>'Wait For Completion'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615625798500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_PROCESS_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612414708500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.AJAX_ITEMS_TO_SUBMIT.D'
,p_message_text=>'Has "Page Items to Submit" Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613025703500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.COLUMNS.D'
,p_message_text=>'Has "Region Columns"'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613109999500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.COLUMN_HEADING.D'
,p_message_text=>'Has "Heading" Column Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612837613500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.ESCAPE_OUTPUT.D'
,p_message_text=>'Has "Escape Special Characters" Region Attribute'
,p_version_scn=>37166067046447
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612660704500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.FETCHED_ROWS.D'
,p_message_text=>'Has "Number of Fetched Rows" Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613227394500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.HEADING_ALIGNMENT.D'
,p_message_text=>'Has "Heading Alignment" Column Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612998478500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.INIT_JAVASCRIPT_CODE.D'
,p_message_text=>'Has "Initialization JavaScript Code" Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612731048500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.NO_DATA_FOUND_MESSAGE.D'
,p_message_text=>'Has "No Data Found Message" Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612564642500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.ORDER_BY.D'
,p_message_text=>'Has "Order By" Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612266889500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.SOURCE_HTML.D'
,p_message_text=>'Region Source is HTML'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611839858500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.SOURCE_LOCATION.D'
,p_message_text=>'Region Source supports different Data Sources'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612329799500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.SOURCE_PLAIN.D'
,p_message_text=>'Region Source is Plain Text'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612016737500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.SOURCE_PLSQL.D'
,p_message_text=>'Region Source is PL/SQL Statement'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143612106377500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.SOURCE_PLSQL_FUNCTION.D'
,p_message_text=>'Region Source is PL/SQL Function Body [Deprecated]'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611992008500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.SOURCE_SQL.D'
,p_message_text=>'Region Source is SQL Statement [Deprecated]'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613733323500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.SUPPORTS_EXTERNAL_FILTERING.D'
,p_message_text=>'Supports Faceted Search / Smart Filters'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613311216500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.VALUE_ALIGNMENT.D'
,p_message_text=>'Has "Alignment" Column Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613576828500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.VALUE_ATTRIBUTE.D'
,p_message_text=>'Has "Custom Attributes" Column Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613420990500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.VALUE_CSS.D'
,p_message_text=>'Has "CSS Class" Column Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143613680711500653)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.LOV.VALUE_ESCAPE_OUTPUT.D'
,p_message_text=>'Has "Escape Special Characters" Column Attribute'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143611729966500652)
,p_name=>'PE.PROPERTY.PLUGIN_STD_REGION_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615577508500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_WEB_SOURCE_ATTRIBUTES.LOV.ENDPOINT_HINT.D'
,p_message_text=>'Default Endpoint'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615406863500654)
,p_name=>'PE.PROPERTY.PLUGIN_STD_WEB_SOURCE_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604390072500647)
,p_name=>'PE.PROPERTY.PLUGIN_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604534566500647)
,p_name=>'PE.PROPERTY.PLUGIN_THEME.PROMPT'
,p_message_text=>'Theme'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604721786500647)
,p_name=>'PE.PROPERTY.PLUGIN_TMPL_COMPONENT_TYPE.LOV.PARTIAL.D'
,p_message_text=>'Single (Partial)'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5400372171670735)
,p_name=>'PE.PROPERTY.PLUGIN_TMPL_COMPONENT_TYPE.LOV.REGION_ONLY.D'
,p_message_text=>'Region Only'
,p_version_scn=>109169362
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604872618500647)
,p_name=>'PE.PROPERTY.PLUGIN_TMPL_COMPONENT_TYPE.LOV.REPORT.D'
,p_message_text=>'Multiple (Report)'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604642768500647)
,p_name=>'PE.PROPERTY.PLUGIN_TMPL_COMPONENT_TYPE.PROMPT'
,p_message_text=>'Available as'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603018010500646)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.AUTHENTICATION TYPE.D'
,p_message_text=>'Authentication Scheme Type'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603177257500646)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.AUTHORIZATION TYPE.D'
,p_message_text=>'Authorization Scheme Type'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603217761500646)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.DYNAMIC ACTION.D'
,p_message_text=>'Dynamic Action'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603984729500647)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.IR COLUMN.D'
,p_message_text=>'Interactive Report Column'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603351677500646)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.ITEM TYPE.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603488755500646)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.PROCESS TYPE.D'
,p_message_text=>'Process'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603615963500647)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.REGION TYPE.D'
,p_message_text=>'Region'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603790119500647)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.REPORT COLUMN TYPE.D'
,p_message_text=>'Report Column'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603824205500647)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.TEMPLATE COMPONENT.D'
,p_message_text=>'Template Component'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143603583620500646)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.LOV.WEB SOURCE TYPE.D'
,p_message_text=>'REST Data Source'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602935973500646)
,p_name=>'PE.PROPERTY.PLUGIN_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143616086966500655)
,p_name=>'PE.PROPERTY.PLUGIN_VERSION.PROMPT'
,p_message_text=>'Version'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601613466484599)
,p_name=>'PE.PROPERTY.POPUP_LOV_AFTER_FIELD_TEXT.HELP'
,p_message_text=>'<p>Display this text after displaying the search field, the search button, and the close button.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601538613484599)
,p_name=>'PE.PROPERTY.POPUP_LOV_AFTER_FIELD_TEXT.PROMPT'
,p_message_text=>'After Field'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605537629484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_AFTER_RESULT_SET.HELP'
,p_message_text=>'<p>Display this text after displaying the result set. The result set is the result of the list of values query.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605468850484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_AFTER_RESULT_SET.PROMPT'
,p_message_text=>'After'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601461089484599)
,p_name=>'PE.PROPERTY.POPUP_LOV_BEFORE_FIELD_TEXT.EXAMPLES'
,p_message_text=>'<p><pre>Search&lt;br&gt;</pre></p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601372304484599)
,p_name=>'PE.PROPERTY.POPUP_LOV_BEFORE_FIELD_TEXT.HELP'
,p_message_text=>'<p>Defines text to display before the popup list of values search field displays.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601283162484599)
,p_name=>'PE.PROPERTY.POPUP_LOV_BEFORE_FIELD_TEXT.PROMPT'
,p_message_text=>'Before Field'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605369819484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_BEFORE_RESULT_SET.HELP'
,p_message_text=>'<p>Display this text before displaying the result set. The result set is the result of the list of values query.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605206805484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_BEFORE_RESULT_SET.PROMPT'
,p_message_text=>'Before'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603021114484601)
,p_name=>'PE.PROPERTY.POPUP_LOV_CLOSE_BUTTON_ATTRIBUTES.HELP'
,p_message_text=>'<p>Defines additional attributes of the Close button.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602919664484601)
,p_name=>'PE.PROPERTY.POPUP_LOV_CLOSE_BUTTON_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602863546484601)
,p_name=>'PE.PROPERTY.POPUP_LOV_CLOSE_BUTTON_TEXT.HELP'
,p_message_text=>'<p>Defines the name of the close button. The close button dismisses the popup list of values page.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602789774484601)
,p_name=>'PE.PROPERTY.POPUP_LOV_CLOSE_BUTTON_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600913265484599)
,p_name=>'PE.PROPERTY.POPUP_LOV_COLOR_PICKER_ICON.HELP'
,p_message_text=>'<p>Specify an icon to display to the right of a form field for items of type Popup Color Picker. By default, the &PRODUCT_NAME. engine shows a color palette icon.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600851600484598)
,p_name=>'PE.PROPERTY.POPUP_LOV_COLOR_PICKER_ICON.PROMPT'
,p_message_text=>'Color Picker Icon'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601125420484599)
,p_name=>'PE.PROPERTY.POPUP_LOV_COLOR_PICKER_ICON_ATTR.HELP'
,p_message_text=>'<p>Specify image attributes (such as height and width) used to display the Popup Color Picker Icon.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601028856484599)
,p_name=>'PE.PROPERTY.POPUP_LOV_COLOR_PICKER_ICON_ATTR.PROMPT'
,p_message_text=>'Color Picker Attributes'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602069601484600)
,p_name=>'PE.PROPERTY.POPUP_LOV_FILTER_MAX_WIDTH.HELP'
,p_message_text=>'<p>Display the HTML INPUT TYPE = TEXT widget using this maximum width.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601920135484600)
,p_name=>'PE.PROPERTY.POPUP_LOV_FILTER_MAX_WIDTH.PROMPT'
,p_message_text=>'Maximum Width'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602254518484600)
,p_name=>'PE.PROPERTY.POPUP_LOV_FILTER_TEXT_ATTRIBUTES.HELP'
,p_message_text=>'<p>Display the HTML INPUT TYPE = TEXT widget using these attributes.  This will be included within the HTML input tag.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602194220484600)
,p_name=>'PE.PROPERTY.POPUP_LOV_FILTER_TEXT_ATTRIBUTES.PROMPT'
,p_message_text=>'Filter Text Attributes'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601866461484600)
,p_name=>'PE.PROPERTY.POPUP_LOV_FILTER_WIDTH.HELP'
,p_message_text=>'<p>Display the HTML INPUT TYPE = TEXT widget using this width.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175601724713484599)
,p_name=>'PE.PROPERTY.POPUP_LOV_FILTER_WIDTH.PROMPT'
,p_message_text=>'Width'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602695909484600)
,p_name=>'PE.PROPERTY.POPUP_LOV_FIND_BUTTON_ATTRIBUTES.HELP'
,p_message_text=>'<p>Defines additional attributes for the Find button.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602547242484600)
,p_name=>'PE.PROPERTY.POPUP_LOV_FIND_BUTTON_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602400562484600)
,p_name=>'PE.PROPERTY.POPUP_LOV_FIND_BUTTON_TEXT.HELP'
,p_message_text=>'<p>Defines text that displays on the name of the button used to search on the popup page.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175602321271484600)
,p_name=>'PE.PROPERTY.POPUP_LOV_FIND_BUTTON_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604661596484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_HEIGHT.HELP'
,p_message_text=>'<p>Popup lists of values are executed using JavaScript. Use this attribute to control the values of <code>height=</code>. The default is 400.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604598161484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_HEIGHT.PROMPT'
,p_message_text=>'Height'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600581340484598)
,p_name=>'PE.PROPERTY.POPUP_LOV_ICON.HELP'
,p_message_text=>'Specify an icon to display to the right of a form field for items of type POPUP. By default, the &PRODUCT_NAME. engine uses a CSS-based default icon.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600494082484598)
,p_name=>'PE.PROPERTY.POPUP_LOV_ICON.PROMPT'
,p_message_text=>'Icon'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600718793484598)
,p_name=>'PE.PROPERTY.POPUP_LOV_ICON_ATTRIBUTES.HELP'
,p_message_text=>'Specify image attributes (such as height and width) used to display the Popup Icon.'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600688399484598)
,p_name=>'PE.PROPERTY.POPUP_LOV_ICON_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603461881484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_NEXT_BUTTON_ATTR.HELP'
,p_message_text=>'<p>Defines additional attributes for the Next button.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603383526484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_NEXT_BUTTON_ATTR.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603260652484601)
,p_name=>'PE.PROPERTY.POPUP_LOV_NEXT_BUTTON_TEXT.HELP'
,p_message_text=>'<p>Defines the name of the Next button used when paginating result sets.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603195183484601)
,p_name=>'PE.PROPERTY.POPUP_LOV_NEXT_BUTTON_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606061878484604)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGE_BODY_ATTRIBUTES.EXAMPLES'
,p_message_text=>'<p><pre>bgcolor="white" OnLoad="first_field()"</pre></p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605934243484604)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGE_BODY_ATTRIBUTES.HELP'
,p_message_text=>'<p>Defines text that is added into the popup list of values HTML BODY.  Note the page includes a JavaScript called <code>first_field</code>.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605813393484604)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGE_BODY_ATTRIBUTES.PROMPT'
,p_message_text=>'Body Attributes'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606493376484604)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGE_FOOTER_TEXT.HELP'
,p_message_text=>'<p>Defines text to display after displaying the popup page including the search list results.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606301626484604)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGE_FOOTER_TEXT.PROMPT'
,p_message_text=>'Footer'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606219964484604)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGE_HEADING_TEXT.HELP'
,p_message_text=>'<p>Defines text to display after opening the form, but before displaying any text. This text comes before the before field text.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175606179880484604)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGE_HEADING_TEXT.PROMPT'
,p_message_text=>'Heading'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605741584484604)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGE_HTML_HEAD.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines text to be included in the popup LOV page header. Use this area to include style sheets.  For example:',
'<pre>&lt;link rel="stylesheet" href="&#35;IMAGE_PREFIX&#35;platform2.css" type="text/css"&gt;',
'#THEME_CSS#',
'</pre>',
'</p>',
'<p>The following substitution strings are supported:',
'<ul>',
'<li>#THEME_CSS#</li>',
'</ul>',
'</p>'))
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605684069484604)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGE_HTML_HEAD.PROMPT'
,p_message_text=>'Head'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605176973484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGINATION_SIZE.HELP'
,p_message_text=>'<p>Defines the number of rows per page.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175605037088484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGINATION_SIZE.PROMPT'
,p_message_text=>'Rows per Page'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604939323484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGINATION_TEXT.EXAMPLES'
,p_message_text=>'<p><pre>#FIRST_ROW# - #LAST_ROW#</pre></p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604833343484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGINATION_TEXT.HELP'
,p_message_text=>'<p>Defines how row count results display. Use the substitution strings #FIRST_ROW# and #LAST_ROW#.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604734390484603)
,p_name=>'PE.PROPERTY.POPUP_LOV_PAGINATION_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603848662484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_PREV_BUTTON_ATTRIBUTES.HELP'
,p_message_text=>'<p>Defines additional attributes of the Previous button.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603723017484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_PREV_BUTTON_ATTRIBUTES.PROMPT'
,p_message_text=>'Attributes'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603658984484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_PREV_BUTTON_TEXT.HELP'
,p_message_text=>'<p>Defines the name of Previous page button. This button is used to paginate result sets.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603509074484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_PREV_BUTTON_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604230148484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_RESIZABLE.HELP'
,p_message_text=>'<p>Popup lists of values are executed using JavaScript. Use this attribute to control the value of <code>resizable=</code>.  The default value is 1. Other valid values include 1 and 0.  A value of zero indicates that the popup dialog window is not re'
||'sizable.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604197354484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_RESIZABLE.PROMPT'
,p_message_text=>'Resizable'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604005148484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_SCROLL_BARS.HELP'
,p_message_text=>'<p>Popup lists of values are executed using JavaScript. Use this attribute to control the values of <code>scrollbars=</code>. The default value is 1. Other valid values include 1 and 0.  A value of zero (0) indicates that the popup dialog window is n'
||'ot scrollable.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175603946056484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_SCROLL_BARS.PROMPT'
,p_message_text=>'Scroll Bars'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600073548484597)
,p_name=>'PE.PROPERTY.POPUP_LOV_TEMPLATE_CLASS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identifies a specific usage for this template.</p>',
'<p>When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.<br />',
'Use the <strong>Translatable</strong> check box to indicate if this template contains text strings that require translation.',
'</p>'))
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600111042484598)
,p_name=>'PE.PROPERTY.POPUP_LOV_TEMPLATE_CLASS.LOV.1.D'
,p_message_text=>'Standard'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175599932561484597)
,p_name=>'PE.PROPERTY.POPUP_LOV_TEMPLATE_CLASS.PROMPT'
,p_message_text=>'Template Class'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600309076484598)
,p_name=>'PE.PROPERTY.POPUP_LOV_TEMPLATE_SUBSCRIBED_FROM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You may select an existing template in this workspace or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</p>',
'<p>To load a new copy of any master template, click <span class="fielddatabold">Refresh Template</span>.</p>'))
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175600260811484598)
,p_name=>'PE.PROPERTY.POPUP_LOV_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604482864484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_WIDTH.HELP'
,p_message_text=>'<p>Popup lists of values are executed using JavaScript. Use this attribute to control the values of <code>width=</code>. The default value is 450.</p>'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175604379848484602)
,p_name=>'PE.PROPERTY.POPUP_LOV_WIDTH.PROMPT'
,p_message_text=>'Width'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661465486661100)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Remove the domain from the authenticated username, i.e. transforms <code>JOHNDOE@EXAMPLE.COM</code> to <code>JOHNDOE</code></dt>',
'<dd><pre>',
'apex_custom_auth.set_user (',
'    p_user => regexp_replace(:APP_USER, ''@.*'', null) );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150989430795822709)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the name of a procedure to be executed by the &PRODUCT_NAME. login procedure (login API) after the authentication step (login credentials verification).',
'The login procedure executes this code after performing normal login procedure duties, which include setting a cookie and registering the session, but before it redirects to the desired application page.',
'The procedure can be defined in the <strong>PL/SQL Code</strong> attribute or in the database.'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150989329901822709)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_text=>'Post-Authentication Procedure Name'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123133813896211853)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL expression to refine the value of the item.</p>',
'<p>For example, if this item is named <code>P1_X</code>, you could use post calculation expressions such as <code>UPPER(:P1_X)</code>, <code>INITCAP(:P2_Y)</code>, <code>MIN(:P1_X, :P2_Y - 200)</code>, <code>NVL(:P1_X, :P2_Y)</code>, or a function ca'
||'ll such as <code>my_func(:P1_X)</code> to set the final value of the item.',
'Note that these examples demonstrate that the expressions can reference the current item, or they may reference any other item in session state.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123133715198211853)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_text=>'Post Calculation Computation'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755065415661397)
,p_name=>'PE.PROPERTY.POST_DEINSTALL_MESSAGE.PROMPT'
,p_message_text=>'Post-Deinstall'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606764556500649)
,p_name=>'PE.PROPERTY.POST_LOGOUT_FUNCTION_NAME.PROMPT'
,p_message_text=>'Post Logout Function Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150990001241822710)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_text=>'Enter the URL where your application is redirected after &PRODUCT_NAME. has cleaned up the user session.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150989916714822710)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_text=>'Post-Logout URL'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107852939276420)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG_SQL.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108143454276420)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG_SQL.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108088533276420)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG_SQL.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107987739276420)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG_SQL.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108264550276420)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG_SQL.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107729929276420)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG_SQL.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600290984111090649)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_text=>'Enter a Java function body, where the SQL query returned transforms the data retrieved from the Web Source. The SQL query returned by the Java function body must select from the #APEX$SOURCE_DATA# pseudo-table and read columns available in the data p'
||'rofile. Subquery factoring using the SQL WITH clause is not supported here. '
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600290805894090649)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Java Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611367194484654)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Select the EMPNO, ENAME and SAL columns and filter out all rows with a SAL less then 3000.</dt>',
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000";',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600290632684090648)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_text=>'Enter a JavaScript function body, where the SQL query returned transforms the data retrieved from the Web Source. The SQL query returned by the JavaScript function body must select from the #APEX$SOURCE_DATA# pseudo-table and read columns available i'
||'n the data profile. Subquery factoring using the SQL WITH clause is not supported here. '
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600290581412090648)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'JavaScript Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656370515977245299)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656370406032245299)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter one or more comma separated column names, including directives, to define the order in which records are retrieved.</p>',
'        <p>Directives include:',
'          <ul>',
'            <li>ASC - Return column in ascending order</li>',
'            <li>DESC - Return column in descending order</li>',
'            <li>NULLS FIRST - Return column with no value before those with values</li>',
'            <li>NULLS LAST - Return column with values before those with no value</li>',
'          </ul>',
'        </p>'))
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656370305514245298)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_text=>'Order By Clause'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042629685306652)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_ITEM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042555341306652)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter multiple Order By Clauses that can be picked by end-users. Each can contain one or more comma-separated column names, including directives, to define the order in which records are retrieved.</p>',
'            <p>Directives include:',
'              <ul>',
'                <li>ASC - Return column in ascending order</li>',
'                <li>DESC - Return column in descending order</li>',
'                <li>NULLS FIRST - Return column with no value before those with values</li>',
'                <li>NULLS LAST - Return column with values before those with no value</li>',
'              </ul>',
'            </p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042468045306652)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042949376306652)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_ITEM2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042899948306652)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_ITEM2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter multiple Order By Clauses that can be picked by end-users. Each can contain one or more comma-separated column names, including directives, to define the order in which records are retrieved.</p>',
'            <p>Directives include:',
'              <ul>',
'                <li>ASC - Return column in ascending order</li>',
'                <li>DESC - Return column in descending order</li>',
'                <li>NULLS FIRST - Return column with no value before those with values</li>',
'                <li>NULLS LAST - Return column with values before those with no value</li>',
'              </ul>',
'            </p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042759132306652)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_ITEM2.PROMPT'
,p_message_text=>'Order By Item'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144045036709306815)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_TYPE.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044742912306780)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_TYPE.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041917403306651)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_TYPE.HELP'
,p_message_text=>'Select how this component is sorted.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042278415306651)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042369719306651)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Based on the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042097198306651)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144042137374306651)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Based on the ORDER BY clause entered into <em>Order By Clause</em>.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041885825306649)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY_TYPE.PROMPT'
,p_message_text=>'Order By Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611221620484653)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Select the EMPNO, ENAME and SAL columns and filter out all rows with a SAL less then 3000.</dt>',
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600290308186090648)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_text=>'Enter a PL/SQL function body, where the SQL query returned transforms the data retrieved from the Web Source. The SQL query returned by the PL/SQL function body must select from the #APEX$SOURCE_DATA# pseudo-table and read columns available in the da'
||'ta profile. Subquery factoring using the SQL WITH clause is not supported here. '
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600290258419090648)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'PL/SQL Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291108453090649)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_text=>'Enter a Python function body, where the SQL query returned transforms the data retrieved from the Web Source. The SQL query returned by the Python function body must select from the #APEX$SOURCE_DATA# pseudo-table and read columns available in the da'
||'ta profile. Subquery factoring using the SQL WITH clause is not supported here. '
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291021617090649)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Python Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(658804616017501868)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Select the EMPNO, ENAME and SAL columns and filter out all rows with a SAL less then 3000.</dt>',
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656370791089245301)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_text=>'Enter a SQL Query to transform the data retrieved from the REST Data Source. Select from the pseudo-table #APEX$SOURCE_DATA# and specify columns available in the data profile. Subquery factoring using the SQL WITH clause is not supported here.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656370693311245301)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656370252985245298)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Only include those employees which have a manager or have a job of salesman.</dt>',
'<dd><pre>',
'( MGR is not null or JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656370172232245297)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656370024313245297)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_text=>'Where Clause'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572891772500625)
,p_name=>'PE.PROPERTY.PRESET_TEMPLATE_OPTIONS.PROMPT'
,p_message_text=>'Preset'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602523092500646)
,p_name=>'PE.PROPERTY.PREVIOUS_PAGE_TEMPLATE.PROMPT'
,p_message_text=>'Previous Page'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143602701346500646)
,p_name=>'PE.PROPERTY.PREVIOUS_SET_TEMPLATE.PROMPT'
,p_message_text=>'Previous Set'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150989215811822709)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of a procedure to be executed after the login page is submitted and just before credentials verification is performed.',
'The procedure can be defined in the <strong>PL/SQL Code</strong> attribute or within the database.</p>',
'<p>Authentication schemes, where user credential checking is done outside of &PRODUCT_NAME., typically do not execute the Pre-Authentication procedure.',
'Examples include <em>HTTP Header Variable</em>, <em>Oracle Application Server Single Sign-On</em> and custom authentication schemes that use <code>apex_authentication.post_login</code> instead of <code>apex_authentication.login</code>.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150989124116822709)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_text=>'Pre-Authentication Procedure Name'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388947119489781568)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_text=>'Select the column which holds the primary key for the table.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388947024348781568)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_text=>'Primary Key Column'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856043361751772)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037742629271873)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display the border for the specified attribute.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037609879271873)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_text=>'Border Color'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037555573271873)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_text=>'Enter the width in pixels of the table borders.'
,p_version_scn=>37166067046358
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037493925271873)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_text=>'Border Width'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516971843630068933)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489042764558271890)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display the background for this component.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489042605254271890)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_text=>'Background Color'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858115355751779)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489042591356271890)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display this component.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489042496546271890)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_text=>'Font Color'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489041411542271888)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_text=>'Select a font face for this component.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857876668751777)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_text=>'Courier'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857693083751777)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_text=>'Helvetica'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857758355751777)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_text=>'Times'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489041368817271887)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_text=>'Font'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489042310002271889)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_text=>'Enter a font size for this component.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489042263541271889)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_text=>'Font Size'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489041966359271889)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_text=>'Select a font weight for this component.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858011809751778)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_text=>'Bold'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857906857751778)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489041802540271888)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_text=>'Font Weight'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516971740800068932)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489041237253271887)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display the background for this component.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489041123122271887)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_text=>'Background Color'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857576374751777)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489041098102271887)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display this component.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489040923140271887)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_text=>'Font Color'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489039915922271878)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_text=>'Select a font face for this component.'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857287900751775)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_text=>'Courier'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857013747751775)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_text=>'Helvetica'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857123304751775)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_text=>'Times'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489039815831271878)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_text=>'Font'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489040814490271886)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_text=>'Enter a font size for this component.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489040736016271886)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_text=>'Font Size'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489040464582271886)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_text=>'Select a font weight for this component.'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857462763751776)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_text=>'Bold'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516857367954751776)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489040348775271882)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_text=>'Font Weight'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380453446226584108)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_text=>'Enter the column width used to size this column when the report is printed. The unit is defined in the Columns group of the Printing Attributes.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380453381254584107)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_text=>'Print Width'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489468155496840289)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_text=>'Select the units used to define the column width values.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516859757506751785)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_text=>'Percent'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516859873619751786)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_text=>'Point'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489468063778840289)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_text=>'Width Units'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722688940661334)
,p_name=>'PE.PROPERTY.PRINT_CREDENTIALS.PROMPT'
,p_message_text=>'Credentials'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489466894948840284)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_text=>'Enter a name for the downloaded document. If you leave this blank, the region name is used as the file name.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489466790313840284)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_text=>'File Name'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037300287271872)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_text=>'Enter the height of this page.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037288822271872)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_text=>'Height'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489496552257590504)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text for the download link. To replace the link with a different navigational component, such as a button, leave this field blank. You can set up the other component to start the printing process by using a URL with the following syntax '
||'as the target:</p>',
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
'<p><strong>Note</strong>: Replace  <code>[REGION_ID]</code> in the string above with your region ID.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489496447521590503)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_text=>'Link Text'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489036111504271870)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_text=>'Select the orientation for the page.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855535818751769)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_text=>'Landscape'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855465507751769)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_text=>'Portrait'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489036044678271870)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_text=>'Orientation'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489470147086203314)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_text=>'Derive from Item'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775839462661534)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.REPORT_QUERY.NULL_TEXT'
,p_message_text=>'Derive from Item'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489496663105590656)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_text=>'Derive from Item'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489467024356840284)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_text=>'Select the report output format. You can also have the output format specified by an item.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516859476832751783)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_text=>'HTML'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516859102909751783)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_text=>'PDF'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516859246350751783)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_text=>'Word'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516859392807751783)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_text=>'Excel'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516859574502751784)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_text=>'XML'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489466912562840284)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_text=>'Format'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489467740794840286)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the page or application item that holds the format value. You can include a <em>Select List</em> page item for users to select the output format at runtime. Valid values are</p>',
'<dl>',
'<dt>PDF</dt>',
'<dd>Opens the document in a PDF Previewer</dd>',
'<dt>RTF</dt>',
'<dd>Opens the document in Microsoft Word</dd>',
'<dt>XLS</dt>',
'<dd>Opens the document in Microsoft Excel</dd>',
'<dt>HTM</dt>',
'<dd>Downloads the document as an HTML file</dd>',
'<dt>XML</dt>',
'<dd>Downloads the document as an XML file</dd>',
'</dl>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489467607929840286)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_text=>'Format Item'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489044258975271897)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_text=>'Select the alignment for the page footer.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858910306751782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_text=>'center'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858813003751781)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_text=>'start'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516859053677751782)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_text=>'end'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489044115462271897)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_text=>'Alignment'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858744982751781)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489044015783271897)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display this component.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489043920703271896)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_text=>'Font Color'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489042927626271891)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_text=>'Select a font face for this component.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858462512751780)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_text=>'Courier'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858246601751780)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_text=>'Helvetica'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858357814751780)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_text=>'Times'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489042807196271890)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_text=>'Font'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489043855660271896)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_text=>'Enter a font size for this component.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489043793013271892)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_text=>'Font Size'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489043416626271892)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_text=>'Select a font weight for this component.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858673490751781)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_text=>'Bold'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516858576316751780)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489043385018271891)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_text=>'Font Weight'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489044780302271898)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_text=>'Enter text to appear in the footer section of the document. To show values of page or application items, use <code>&amp;ITEM_NAME.</code> syntax.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489044628166271898)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_text=>'Page Footer Text'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489039292821271876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_text=>'Select an alignment for the page header.'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856851712751774)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_text=>'center'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856774190751774)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_text=>'start'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856958052751775)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_text=>'end'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489039154845271876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_text=>'Alignment'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856647920751774)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include -',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489039007384271876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used to display this component.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489038939492271876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_text=>'Font Color'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037944336271874)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_text=>'Select a font face for this component.'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856366669751773)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_text=>'Courier'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856193178751772)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_text=>'Helvetica'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856295382751772)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_text=>'Times'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037849297271873)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_text=>'Font'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489038860844271875)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_text=>'Enter a font size for this component.'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489038746426271875)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_text=>'Font Size'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489038439467271875)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_text=>'Select a font weight for this component.'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856511187751773)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_text=>'Bold'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516856431398751773)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489038389588271874)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_text=>'Font Weight'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489039781670271877)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_text=>'Enter text to appear in the header section of the document. To show values of page or application items, use <code>&amp;ITEM_NAME.</code> syntax.'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489039612152271877)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_text=>'Page Header Text'
,p_version_scn=>37166067046361
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489035322991271868)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_text=>'Select the report page size. To type in your own page width and height, select <strong>Custom</strong>.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855270390751769)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_text=>'A3'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855109182751769)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_text=>'A4'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855335533751769)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_text=>'Custom'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516854989665751768)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_text=>'Legal'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516854834070751768)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_text=>'Letter'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855090731751768)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_text=>'Tabloid'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489035213865271868)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_text=>'Size'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656861788661069)
,p_name=>'PE.PROPERTY.PRINT_SERVER_TYPE.HELP'
,p_message_text=>'Select the type of print server.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657399159661070)
,p_name=>'PE.PROPERTY.PRINT_SERVER_TYPE.LOV.AOP.D'
,p_message_text=>'APEX Office Print'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657431813661070)
,p_name=>'PE.PROPERTY.PRINT_SERVER_TYPE.LOV.AOP.HELP'
,p_message_text=>'Select this option if you are using APEX Office Print.'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656971190661069)
,p_name=>'PE.PROPERTY.PRINT_SERVER_TYPE.LOV.BIP.D'
,p_message_text=>'Oracle BI Publisher'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657081779661070)
,p_name=>'PE.PROPERTY.PRINT_SERVER_TYPE.LOV.BIP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select this option if you are using a licensed version of Oracle BI Publisher.',
'This option enables you to take report query results and convert them from XML to RTF format using Oracle BI Publisher.',
'Select this option if you want to upload your own customized RTF or XSL-FO templates for printing reports within &PRODUCT_NAME..'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657174797661070)
,p_name=>'PE.PROPERTY.PRINT_SERVER_TYPE.LOV.FOP.D'
,p_message_text=>'Apache FOP'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242657212345661070)
,p_name=>'PE.PROPERTY.PRINT_SERVER_TYPE.LOV.FOP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select this option if you are using Apache FOP on an external J2EE server.',
'This option enables you to use the basic printing functionality, which includes creating report queries and',
'printing report regions using the default templates provided in &PRODUCT_NAME. and using your own customized XSL-FO templates.'))
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242656747873661069)
,p_name=>'PE.PROPERTY.PRINT_SERVER_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722443987661334)
,p_name=>'PE.PROPERTY.PRINT_TYPE.LOV.INSTANCE.D'
,p_message_text=>'Use Instance Settings'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722200095661333)
,p_name=>'PE.PROPERTY.PRINT_TYPE.LOV.NATIVE.D'
,p_message_text=>'Native Printing'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722339142661333)
,p_name=>'PE.PROPERTY.PRINT_TYPE.LOV.REMOTE.D'
,p_message_text=>'Remote Print Server'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722154354661333)
,p_name=>'PE.PROPERTY.PRINT_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489036519390271871)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_text=>'Select the units used to specify page width and height.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855810497751770)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_text=>'Centimeters'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855620291751770)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_text=>'Inches'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855782869751770)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_text=>'Millimeters'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516855920270751770)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_text=>'Points'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489036474903271871)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_text=>'Units'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489034783620271867)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_text=>'Select the content-disposition for the print document. Content-disposition is an extension to the MIME protocol that instructs the browser on how the document displays.'
,p_version_scn=>5717666
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516854676249751767)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_text=>'Attachment'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802743220372841)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.HELP'
,p_message_text=>'Saves the file to disk.'
,p_version_scn=>5717666
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516854781065751768)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_text=>'Inline'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1802889326372841)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.HELP'
,p_message_text=>'Displays the file instead of the current page.'
,p_version_scn=>5717666
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489034697908271867)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_text=>'View File As'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037113626271872)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_text=>'Enter the width of this page.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489037044044271872)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_text=>'Width'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242725048022661336)
,p_name=>'PE.PROPERTY.PRIORITY.LOV.1.D'
,p_message_text=>'1-Urgent'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242725140262661336)
,p_name=>'PE.PROPERTY.PRIORITY.LOV.2.D'
,p_message_text=>'2-High'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242725282814661336)
,p_name=>'PE.PROPERTY.PRIORITY.LOV.3.D'
,p_message_text=>'3-Medium'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242725386627661336)
,p_name=>'PE.PROPERTY.PRIORITY.LOV.4.D'
,p_message_text=>'4-Low'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242725405884661336)
,p_name=>'PE.PROPERTY.PRIORITY.LOV.5.D'
,p_message_text=>'5-Lowest'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724936856661336)
,p_name=>'PE.PROPERTY.PRIORITY.PROMPT'
,p_message_text=>'Priority'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73134589018902343)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_text=>'Select the associated Form region for this page item.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73134406933902343)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_text=>'Form Region'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361254126257487182)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_text=>'Select where this process error message displays, when the process fails to complete successfully.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516784346168751560)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_text=>'Inline in Notification'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516784409037751560)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_text=>'The process error message is displayed in the "Notification" area (defined as part of the page template)'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516784526116751561)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_text=>'On Error Page'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516784648469751561)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_text=>'The Process error message is displayed on the error page.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361254009398487182)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_text=>'Display Location'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123116108619211824)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_text=>'Select at what point in page rendering or processing this process is executed.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769033190751493)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_text=>'After Regions'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372808861373767)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_text=>'Rendering: Executes after the regions render.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769216364751494)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_text=>'After Footer'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373022197373768)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_text=>'Rendering: Executes after the page renders.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516768878069751493)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_text=>'After Header'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372658277373764)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_text=>'Rendering: Executes after the header renders.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769472470751494)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_text=>'Processing'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373284446373770)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_text=>'Processing: Executes after validations and computations performed, when page processing performed.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516768958468751493)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_text=>'Before Regions'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372764694373764)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_text=>'Rendering: Executes before the regions render.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769195513751493)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_text=>'Before Footer'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372981324373768)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_text=>'Rendering: Executes before the footer renders.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516768760948751492)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_text=>'Before Header'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372566891373763)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_text=>'Rendering: Executes before the page renders.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769536486751494)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_text=>'Ajax Callback'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373312782373770)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_text=>'Executes when called by apex.server JavaScipt APIs.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516768692782751492)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_text=>'New Session'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372468384373762)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_text=>'Executes when a new session is generated.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516769303423751494)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_text=>'After Submit'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373112924373769)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_text=>'Processing: Executes after the page is submitted, but before computations, validations, and page processes performed.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123116012256211824)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_text=>'Point'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361254520977487183)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_text=>'Select the region to associate with this process.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361254412994487183)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_text=>'Editable Region'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658878331661079)
,p_name=>'PE.PROPERTY.PROCESS_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the process type to execute. The following process types are supported:</p>',
'#NATIVE_PLUGINS#',
'<p>Depending on your application configuration, you may also have additional process type plug-ins available here.',
'These display as <em>&lt;My Plug-in&gt; [Plug-in]</em>.',
'The following plug-ins are installed within this application''s shared components:</p>',
'#CUSTOM_PLUGINS#'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242658719460661079)
,p_name=>'PE.PROPERTY.PROCESS_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608478442500650)
,p_name=>'PE.PROPERTY.PROCESS_TYPE_COMPONENT_TYPES.LOV.APEX_APPLICATION_PAGE_PROC.D'
,p_message_text=>'Page Processes'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608513992500650)
,p_name=>'PE.PROPERTY.PROCESS_TYPE_COMPONENT_TYPES.LOV.APEX_APPL_AUTOMATION_ACTIONS.D'
,p_message_text=>'Automation Actions'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608654143500650)
,p_name=>'PE.PROPERTY.PROCESS_TYPE_COMPONENT_TYPES.LOV.APEX_APPL_TASKDEF_ACTIONS.D'
,p_message_text=>'Task Definition Actions'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(259065247477273295)
,p_name=>'PE.PROPERTY.PROCESS_TYPE_COMPONENT_TYPES.LOV.APEX_APPL_WORKFLOW_ACTIVITIES.D'
,p_message_text=>'Workflow Activities'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143608392335500650)
,p_name=>'PE.PROPERTY.PROCESS_TYPE_COMPONENT_TYPES.PROMPT'
,p_message_text=>'Component Type'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666892752661277)
,p_name=>'PE.PROPERTY.PROMPT_ON_INSTALL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose whether prompts for this credential should be displayed when the application is being imported on another &PRODUCT_NAME. instance. Since &PRODUCT_NAME. never exports Passwords or Client Secrets, installation pr',
'ompts are <em>always</em> generated when a Client ID or Username are provided.'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666730550661277)
,p_name=>'PE.PROPERTY.PROMPT_ON_INSTALL.PROMPT'
,p_message_text=>'Prompt On Install'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242703589128661317)
,p_name=>'PE.PROPERTY.PROMPT_SUBSTITUTION.PROMPT'
,p_message_text=>'Prompt Substitution'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242719935116661331)
,p_name=>'PE.PROPERTY.PROXY_SERVER.PROMPT'
,p_message_text=>'Proxy Server'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977103934481126)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an authorization scheme to restrict who can save public report definitions.',
'        To enable an end user to save a public report, this authorization scheme must evaluate to TRUE for that user.</p>',
'        <p>Note - If no authorization scheme is provided then public reports may be saved by any user.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245977028752481125)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_text=>'Save Public Report Authorization'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726590998661337)
,p_name=>'PE.PROPERTY.PUBLIC_USER.PROMPT'
,p_message_text=>'Public User'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751962236661394)
,p_name=>'PE.PROPERTY.PWA_APP_DESCRIPTION.PROMPT'
,p_message_text=>'App Description'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751493679661393)
,p_name=>'PE.PROPERTY.PWA_BACKGROUND_COLOR.PROMPT'
,p_message_text=>'Background Color'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752043364661394)
,p_name=>'PE.PROPERTY.PWA_CUSTOM_MANIFEST.PROMPT'
,p_message_text=>'Custom Manifest'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752134281661394)
,p_name=>'PE.PROPERTY.PWA_CUSTOM_SERVICE_WORKER.PROMPT'
,p_message_text=>'Custom Service Worker'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750370378661392)
,p_name=>'PE.PROPERTY.PWA_DISPLAY.LOV.BROWSER.D'
,p_message_text=>'Browser'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750073948661392)
,p_name=>'PE.PROPERTY.PWA_DISPLAY.LOV.FULLSCREEN.D'
,p_message_text=>'Fullscreen'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750292058661392)
,p_name=>'PE.PROPERTY.PWA_DISPLAY.LOV.MINIMAL-UI.D'
,p_message_text=>'Minimal UI'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750164710661392)
,p_name=>'PE.PROPERTY.PWA_DISPLAY.LOV.STANDALONE.D'
,p_message_text=>'Standalone'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749957499661392)
,p_name=>'PE.PROPERTY.PWA_DISPLAY.PROMPT'
,p_message_text=>'Display'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749848219661392)
,p_name=>'PE.PROPERTY.PWA_INSTALLABLE.PROMPT'
,p_message_text=>'Installable'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751867793661394)
,p_name=>'PE.PROPERTY.PWA_IOS_STATUS_BAR_STYLE.LOV.BLACK-TRANSLUCENT.D'
,p_message_text=>'Translucent'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751719329661394)
,p_name=>'PE.PROPERTY.PWA_IOS_STATUS_BAR_STYLE.LOV.BLACK.D'
,p_message_text=>'Black'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751671191661394)
,p_name=>'PE.PROPERTY.PWA_IOS_STATUS_BAR_STYLE.LOV.DEFAULT.D'
,p_message_text=>'Default'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751514047661394)
,p_name=>'PE.PROPERTY.PWA_IOS_STATUS_BAR_STYLE.PROMPT'
,p_message_text=>'iOS Status Bar Style'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93211742462826280)
,p_name=>'PE.PROPERTY.PWA_IS_PUSH_ENABLED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Web push notifications are a way for web apps to send notifications to a user''s device even when the user is not currently on the website. These notifications can be sent to a user''s desktop or mobile device, and can be used to alert the user to n'
||'ew content or events on the website, or to re-engage the user with the website.</p>',
'<p>Enabling this option will:</p>',
'<ul>',
'<li>Add a new navigation bar entry: User Settings</li>',
'<li>Allow users to subscribe and unsubscribe to push notifications.</li>',
'<li>When subscribed, users can receive push notifications from the APEX app.</li>',
'</ul>'))
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93211676951826280)
,p_name=>'PE.PROPERTY.PWA_IS_PUSH_ENABLED.PROMPT'
,p_message_text=>'Enable Push Notifications'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93211952411826280)
,p_name=>'PE.PROPERTY.PWA_PUSH_CREDENTIAL_ID.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Credentials are required to setup push notification securely. A public and private key pair are used respectively to allow users to subscribe to push notifications on the client side, and for the server to send the notifications to the subscribers'
||'.</p>',
'<p>Select the credential to authenticate against. To edit the credential, navigate to <strong>Web Credentials</strong> in <strong>Workspace Utilities</strong></p>.'))
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93211846988826280)
,p_name=>'PE.PROPERTY.PWA_PUSH_CREDENTIAL_ID.PROMPT'
,p_message_text=>'PWA Push Notifications Credentials'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750534213661393)
,p_name=>'PE.PROPERTY.PWA_SCREEN_ORIENTATION.LOV.ANY.D'
,p_message_text=>'Any'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750865485661393)
,p_name=>'PE.PROPERTY.PWA_SCREEN_ORIENTATION.LOV.LANDSCAPE-PRIMARY.D'
,p_message_text=>'Landscape Primary'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750971309661393)
,p_name=>'PE.PROPERTY.PWA_SCREEN_ORIENTATION.LOV.LANDSCAPE-SECONDARY.D'
,p_message_text=>'Landscape Secondary'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750715336661393)
,p_name=>'PE.PROPERTY.PWA_SCREEN_ORIENTATION.LOV.LANDSCAPE.D'
,p_message_text=>'Landscape'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750630683661393)
,p_name=>'PE.PROPERTY.PWA_SCREEN_ORIENTATION.LOV.NATURAL.D'
,p_message_text=>'Natural'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751131151661393)
,p_name=>'PE.PROPERTY.PWA_SCREEN_ORIENTATION.LOV.PORTRAIT-PRIMARY.D'
,p_message_text=>'Portrait Primary'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751284111661393)
,p_name=>'PE.PROPERTY.PWA_SCREEN_ORIENTATION.LOV.PORTRAIT-SECONDARY.D'
,p_message_text=>'Portrait Secondary'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751042111661393)
,p_name=>'PE.PROPERTY.PWA_SCREEN_ORIENTATION.LOV.PORTRAIT.D'
,p_message_text=>'Portrait'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242750437261661393)
,p_name=>'PE.PROPERTY.PWA_SCREEN_ORIENTATION.PROMPT'
,p_message_text=>'Screen Orientation'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242751328013661393)
,p_name=>'PE.PROPERTY.PWA_THEME_COLOR.PROMPT'
,p_message_text=>'Theme Color'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93212185865826280)
,p_name=>'PE.PROPERTY.PWA_VAPID_CONTACT_INFO.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Enter the email address to contact in case the push notification service provider (Google, Mozilla, Apple, etc.) wants to contact the owner of the application. We recommend using a group email so it''s not dependent on a single individual.</p>'))
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(93212086689826280)
,p_name=>'PE.PROPERTY.PWA_VAPID_CONTACT_INFO.PROMPT'
,p_message_text=>'Contact Email'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534296044435777862)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_text=>'$$$ DJP currently hidden'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(384947424232471508)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_text=>'Report Column Query Id'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123135923919211857)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_text=>'Enter the label for the first <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123135830820211857)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_text=>'Label 1'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136322907211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_text=>'Enter the label for the second <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136222831211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_text=>'Label 2'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136732744211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_text=>'Enter the label for the third <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136624095211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_text=>'Label 3'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137115818211859)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_text=>'Enter the label for the forth <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137012137211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_text=>'Label 4'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137507903211859)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_text=>'Enter the label for the fifth <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137431628211859)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_text=>'Label 5'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137918685211860)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_text=>'Enter the label for the sixth <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137825227211860)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_text=>'Label 6'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138317337211860)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_text=>'Enter the label for the seventh <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138201132211860)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_text=>'Label 7'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138722617211861)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_text=>'Enter the label for the eighth <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138620209211861)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_text=>'Label 8'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139105628211862)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_text=>'Enter the label for the ninth <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139026261211862)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_text=>'Label 9'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139517928211862)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_text=>'Enter the label for the tenth <strong>Quick Pick</strong>. This label is the text the end user of the application sees.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139418122211862)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_text=>'Label 10'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123135713188211856)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_text=>'Enter HTML attributes that are associated with the display of each <strong>Quick Pick</strong> link.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123135624418211856)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_text=>'Link Attributes'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136131634211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_text=>'Enter the value associated with the first <strong>Quick Pick</strong>.  This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136014670211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_text=>'Value 1'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136507931211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_text=>'Enter the value associated with the second <strong>Quick Pick</strong>. This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136423821211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_text=>'Value 2'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136908954211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_text=>'Enter the value associated with the third <strong>Quick Pick</strong>.  This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123136808905211858)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_text=>'Value 3'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137315383211859)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_text=>'Enter the value associated with the forth <strong>Quick Pick</strong>.  This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137229522211859)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_text=>'Value 4'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137709202211860)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_text=>'Enter the value associated with the fifth <strong>Quick Pick</strong>.  This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123137628724211859)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_text=>'Value 5'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138127982211860)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_text=>'Enter the value associated with the sixth <strong>Quick Pick</strong>. This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138026904211860)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_text=>'Value 6'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138500609211861)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_text=>'Enter the value associated with the seventh <strong>Quick Pick</strong>.  This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138406752211861)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_text=>'Value 7'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138914682211861)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_text=>'Enter the value associated with the eighth <strong>Quick Pick</strong>.  This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123138828926211861)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_text=>'Value 8'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139311060211862)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_text=>'Enter the value associated with the ninth <strong>Quick Pick</strong>.  This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139220373211862)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_text=>'Value 9'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139714522211864)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_text=>'Enter the value associated with the tenth <strong>Quick Pick</strong>.  This value replaces the existing item value when the user clicks this quick pick.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139604308211863)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_text=>'Value 10'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380450386543584102)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_text=>'Enter the number of columns to display for this radio group column.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380450299142584102)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_text=>'Number of Columns'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150991506150822713)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a colon separated list of Real Application Security Dynamic Roles, such as:',
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
'<p>&PRODUCT_NAME. enables these roles on login, by passing them via the <em>enable_dynamic_roles</em> parameter of <em>sys.dbms_xs_sessions.assign_user</em>.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150991428284822713)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_text=>'Dynamic Roles'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150991026998822712)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how Oracle Real Application Security (RAS) is used in this application.</p>',
'<p>If you enable RAS Mode, make sure that the users have privileges to access the application''s schema objects.',
'For example, with <strong>External Users</strong> you can grant database privileges to a <em>RAS Dynamic Application Role</em> and configure it in this authentication scheme as a <em>Dynamic Role</em>.',
'You can also enable roles via a call to <em>apex_authorization.enable_dynamic_groups</em>, such as within a Post-Authentication procedure.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770637464751500)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373416073373781)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_text=>'Real Application Security does not get used in the application'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770782140751500)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_text=>'External Users'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373520697373782)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_text=>'For light weight external users, &PRODUCT_NAME. passes <em>true</em> via the <em>is_external</em> parameter to <em>dbms_xs_sessions.assign_user</em>.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516770823907751500)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_text=>'Internal Users'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644373648498373786)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_text=>'&PRODUCT_NAME. assumes that all users are internal and passes <em>false</em> via the <em>is_external</em> parameter to <em>dbms_xs_sessions.assign_user</em>.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150990902975822712)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_text=>'RAS Mode'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150991705728822713)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a colon separated list of Real Application Security Namespace Templates, such as:',
'<pre>',
'NS1:NS2',
'</pre></p>',
'<p>&PRODUCT_NAME. enables these namespaces on login, by passing them via the <em>namespaces</em> parameter of <em>sys.dbms_xs_sessions.assign_user</em>.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150991600279822713)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_text=>'Namespaces'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201703492982787)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202106623982788)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202027793982788)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201987097982788)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130202224494982788)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201852590982788)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130201647014982787)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102466047276405)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102717364276406)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102643424276406)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102588042276405)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102885446276406)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61102393283276405)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123158531007211894)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123158432085211893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159923019211896)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159816372211896)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600264511412090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600264476715090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600266165439090589)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600266081775090589)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175607458774484622)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600264234470090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600264161361090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175607680296484623)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600265837329090587)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600265761543090587)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123158732282211894)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_text=>'Enter a colon(:) separated list of values for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123158615565211894)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159110530211895)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_text=>'Enter the Page Number for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159015271211894)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_text=>'Page'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159317664211895)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_text=>'Enter a comma separated list of Page Numbers for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159214154211895)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_text=>'Pages'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175607357461484622)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600263975690090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600263840791090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175607554038484623)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600265593140090587)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600265461235090587)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123158931245211894)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_text=>'Enter a User Preference that is compared against the specified value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123158811853211894)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_text=>'Preference'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600264788520090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600264632364090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600266315792090589)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600266287079090589)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175607216446484622)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600263600550090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a SQL Expression for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600263556907090586)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175607105584484620)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully as one or more rows exist when checking if the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>To return successfully as no rows exist when checking if the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123157525969211892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_text=>'Enter a SQL query for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123157424570211892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159508697211895)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_text=>'Enter the text value for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159420354211895)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123160114788211896)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123160017287211896)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245992260715481473)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a condition type that must be met in order for this component to render as read-only.',
'Not selecting a condition causes the item to render normally.',
'A read-only item is rendered with the same settings as a Display Only item.</p>',
'<p>Note: Set the condition type to <strong>Never</strong> to always render the item as an enterable field.',
'This setting overwrites any read-only condition setting on the region or page level.</p>'))
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783712657738)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a condition type that must be met in order for this component to render as read-only.',
'Not selecting a condition causes the item to render normally.',
'A read-only item is rendered with the same settings as a Display Only item.</p>',
'<p>Note: Set the condition type to <strong>Never</strong> to always render the item as an enterable field.',
'This setting overwrites any read-only condition setting on the region or page level.</p>'))
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150995731987822758)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a condition type that must be met in order for this region to render page items as read-only.',
'Not selecting a condition causes the page items to render normally.</p>',
'<p>Note: If you want a page item in this region (for example a search field) to always render as an enterable page item, independent of how this condition evaluates, then you should set the read only condition of that page item to "Never" to overwrit'
||'e the region setting.</p>'))
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123126530789211841)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a condition type that must be met in order for this page to render page items as read only. Not selecting a condition causes the page items to render normally.',
'The read only condition is evaluated after executing the processes with a processing point of <em>Before Header</em>.</p>',
'<p>Note: If you want some page items (for example a search field) or all page items of a specific region to always render as enterable page items independent of how this condition evaluates, then set the read only condition of those regions/page item'
||'s to <strong>Never</strong> to overwrite the parent setting.</p>'))
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516923516033751940)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599831469035464420)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_text=>'The component will always be rendered as read only.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922149616751937)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_text=>'Client Browser is Microsoft Internet Explorer 7.0 or higher'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922286163751937)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_text=>'Client Browser is XHTML / CSS capable browser'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922006730751937)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_text=>'Client Browser is Mozilla, Netscape 6.x/7x or higher'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922353156751938)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_text=>'Client Browser is Other browsers (or older version)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920701144751934)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_text=>'Text is contained in Item'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922753522751938)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_text=>'Current Language = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835296416464441)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_text=>'The end user is currently running the application in the language you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922470472751938)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_text=>'Current Language is contained in Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835407051464442)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_text=>'The end user is currently running the application in one of the languages you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922676158751938)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_text=>'Current Language != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835351108464441)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_text=>'The end user is not currently running the application in the language you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922599788751938)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_text=>'Current Language is NOT contained in Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835562393464442)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_text=>'The end user is not currently running the application in one of the languages you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919968255751932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_text=>'Current Page = Page'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834033987464433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_text=>'The current page is equal to the value you enter into <em>Page</em>.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920154401751933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_text=>'Current Page is in comma delimited list'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834228583464435)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_text=>'The current page is in the comma separated list you enter into <em>Pages</em>.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920084770751933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_text=>'Current Page != Page'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834154842464434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_text=>'The current page is not equal to the value you enter into <em>Page</em>.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920298177751933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_text=>'Current Page is NOT in comma delimited list'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834395051464435)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_text=>'The current page is not in the comma separated list you enter into <em>Pages</em>.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922848340751939)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: DAD_NAME = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516922917044751939)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: DAD_NAME != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921667414751936)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_text=>'Inline Validation Errors displayed'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835026175464439)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_text=>'An inline validation error is displayed on the page, following a page submission.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921059080751935)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_text=>'Text = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920873645751934)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_text=>'Text is contained in Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920921971751934)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_text=>'Text is NOT contained in Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921100336751935)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_text=>'Text != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516917474582751926)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599831565215464421)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_text=>'The SQL query returns one or more rows.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600262696305090577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600262740313090577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'The expression evaluates to TRUE.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516917835641751928)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599831930223464422)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'The function body returns TRUE.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516923294707751940)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: HTTP_HOST = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516923318353751940)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: HTTP_HOST != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921345341751936)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_text=>'Page/Region is NOT Read Only'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834735096464438)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_text=>'The page and parent region, if appropriate, are displayed normally.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921268873751936)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_text=>'Page/Region is Read Only'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834603466464437)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_text=>'Either the page or parent region, if appropriate, ''Read Only'' condition evaluates to TRUE.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919172777751931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_text=>'Item contains no spaces'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833215349464429)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_text=>'The value of the selected <em>Item</em> has no spaces.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919499454751931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_text=>'Item is alphanumeric'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833533062464431)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is alphanumeric, containing only letters or numbers and no special characters.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918661167751930)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_text=>'Item is NOT NULL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832787960464427)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not empty.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919325285751931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_text=>'Item is NOT numeric'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833422324464430)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not numeric.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918865801751930)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_text=>'Item is NOT zero'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832992312464427)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not the number zero.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918523406751930)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_text=>'Item is NULL'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832605946464426)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is empty.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918935416751930)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_text=>'Item is NULL or zero'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833087725464428)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is empty or the number zero.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919224906751931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_text=>'Item is numeric'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833306420464429)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is numeric.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918793111751930)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_text=>'Item is zero'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832853222464427)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is the number zero.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919036379751931)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_text=>'Item is NOT NULL and NOT zero'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833189133464429)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not empty and not the number zero.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921836728751937)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_text=>'SQL Reports (OK to show the forward button)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921994747751937)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_text=>'SQL Reports (OK to show the back button)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516923413561751940)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835679176464444)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_text=>'The component is rendered normally, irrespective of the read only condition for parent component(s).'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921724972751936)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_text=>'Inline Validation Errors NOT displayed'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599835173803464440)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_text=>'An inline validation error is not displayed on the page.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516917586210751927)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599831627685464421)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_text=>'The SQL Query returns no rows'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920535967751934)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_text=>'Current Page is in Printer Friendly Mode'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834401666464437)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_text=>'The current page has been toggled to ''Printer Friendly Mode'' by the end user.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920642941751934)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_text=>'Current page is NOT in Printer Friendly Mode'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834553277464437)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_text=>'The current page has not been toggled to ''Printer Friendly Mode'' by the end user.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516917990282751928)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_text=>'Request = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832099084464423)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_text=>'The page request is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918111221751929)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_text=>'Request is contained in Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832258020464424)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_text=>'The page request is contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918099615751928)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_text=>'Request != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832126862464423)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_text=>'The page request is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918218695751929)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_text=>'Request is NOT contained in Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832363049464424)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_text=>'The page request is not contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516923090593751939)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: SERVER_NAME = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516923132554751940)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_text=>'CGI_ENV: SERVER_NAME != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921419190751936)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_text=>'User is Authenticated (not public)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834894881464439)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_text=>'The end user is logged into the application.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516921575316751936)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_text=>'User is the Public User (user has not authenticated)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599834970927464439)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_text=>'The end user is not logged into the application.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919795997751932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_text=>'User Preference = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833856379464433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_text=>'The value of the <em>Preference</em> entered is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919896518751932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'User Preference != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833900679464433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_text=>'The value of the <em>Preference</em> entered is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919543275751932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is in colon delimited list'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833652937464431)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is completely contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516919630651751932)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Item is NOT in colon delimited list'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599833700478464431)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not completely contained in the text you entered into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918352602751929)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_text=>'Item = Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832403858464425)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516918459163751930)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'Item != Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599832566343464425)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Item</em> is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920436654751933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_text=>'Current Page != Page Submitted (posted)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516920310059751933)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_text=>'Current Page = Page Submitted (posted)'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123126431263211841)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123158324287211893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_text=>'Enter the value to compare against the condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123158229640211893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159707678211896)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123159606754211895)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046470
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516765345148751482)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139923765211864)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_text=>'Enter attributes included in the item HTML table cell tag, <code>&lt;td&gt;</code>, when displayed in read only mode.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123139830066211864)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_text=>'Read Only HTML Attributes'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143639175740500673)
,p_name=>'PE.PROPERTY.REFERENCE_ID.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046460
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728902002661339)
,p_name=>'PE.PROPERTY.REFERRER_POLICY.LOV.NO-REFERRER-WHEN-DOWNGRADE.D'
,p_message_text=>'no-referrer-when-downgrade'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728821681661339)
,p_name=>'PE.PROPERTY.REFERRER_POLICY.LOV.NO-REFERRER.D'
,p_message_text=>'no-referrer'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729177523661340)
,p_name=>'PE.PROPERTY.REFERRER_POLICY.LOV.ORIGIN-WHEN-CROSS-ORIGIN.D'
,p_message_text=>'origin-when-cross-origin'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729096420661339)
,p_name=>'PE.PROPERTY.REFERRER_POLICY.LOV.ORIGIN.D'
,p_message_text=>'origin'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729232565661340)
,p_name=>'PE.PROPERTY.REFERRER_POLICY.LOV.SAME-ORIGIN.D'
,p_message_text=>'same-origin'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729491313661340)
,p_name=>'PE.PROPERTY.REFERRER_POLICY.LOV.STRICT-ORIGIN-WHEN-CROSS-ORIGIN.D'
,p_message_text=>'strict-origin-when-cross-origin'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729321352661340)
,p_name=>'PE.PROPERTY.REFERRER_POLICY.LOV.STRICT-ORIGIN.D'
,p_message_text=>'strict-origin'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242729511911661340)
,p_name=>'PE.PROPERTY.REFERRER_POLICY.LOV.UNSAFE-URL.D'
,p_message_text=>'unsafe-url'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728747725661339)
,p_name=>'PE.PROPERTY.REFERRER_POLICY.PROMPT'
,p_message_text=>'Referrer Policy'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334280940204947)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_text=>'Enter the interval in seconds between chart updates. Very small updates intervals, such as 2 seconds, are discouraged since they may cause serious database performance issues.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334166670204947)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_text=>'Interval'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334320013204947)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_text=>'seconds'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123171315060211914)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_text=>'Select the region in which the button will be displayed.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139982645978374613)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_text=>'No Parent'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783707657734)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_text=>'Select the region in which the item will be displayed.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139982596105374618)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_text=>'No Parent'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123150904083211881)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_text=>'Select the region in which this component is associated. If the component is displayed then it is displayed within the specified region and relative to other components within this region.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123150809290211881)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_text=>'Region'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115976360092250629)
,p_name=>'PE.PROPERTY.REGION_ACTION_PARENT_MENU.COMPONENT_PROPERTY.REGION_ACTION_MENU_ENTRY.NULL_TEXT'
,p_message_text=>'No Parent'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972812656250232)
,p_name=>'PE.PROPERTY.REGION_ACTION_PARENT_MENU.HELP'
,p_message_text=>'Select the parent menu in which the menu entry will be displayed.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972792467250231)
,p_name=>'PE.PROPERTY.REGION_ACTION_PARENT_MENU.PROMPT'
,p_message_text=>'Parent Menu'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593897025500640)
,p_name=>'PE.PROPERTY.REGION_BODY_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(127955694457951194)
,p_name=>'PE.PROPERTY.REGION_COLUMN_SESSION_STATE_DATA_TYPE.HELP'
,p_message_text=>'Select the data type of the region column.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(127955875105951194)
,p_name=>'PE.PROPERTY.REGION_COLUMN_SESSION_STATE_DATA_TYPE.LOV.CLOB.D'
,p_message_text=>'CLOB'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(127955790410951194)
,p_name=>'PE.PROPERTY.REGION_COLUMN_SESSION_STATE_DATA_TYPE.LOV.VARCHAR2.D'
,p_message_text=>'VARCHAR2'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(127955594934951194)
,p_name=>'PE.PROPERTY.REGION_COLUMN_SESSION_STATE_DATA_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150993328333822716)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify <strong>On</strong> if you want this region included in the Region Display Selector.',
'This attribute is only utilized if a region type of <em>Region Display Selector</em> is defined and viewable on the page.</p>',
'<p>When a user clicks on a region name, included in the Region Display Selector, only the selected region shows and all other listed regions are hidden.',
'The first entry within the Region Display Selector is <em>Show All</em>, which enables the user to show all of the available regions rather than only the previously selected region.</p>',
'<p>If a region is not displayable, based on the region conditions, then it is not included in the lists of regions within the Region Display Selector.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150993228077822716)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_text=>'Region Display Selector'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150995124952822720)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_text=>'Enter a PL/SQL Function that returns a SQL query that is used as the basis for this region.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150995025410822720)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_text=>'PL/SQL Function Body returning SQL Query'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992118408822714)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_text=>'Enter the region source or content, depending on the <em>Region Type</em> selected.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992008417822714)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_text=>'HTML Code'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150993506932822716)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_text=>'Enter a reference to an image that displays in the upper left of the region. There is no control over the table tag used to display this image.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150993405141822716)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_text=>'Region Image'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601267110784516)
,p_name=>'PE.PROPERTY.REGION_IMAGE_ALT_TEXT.COMPONENT_PROPERTY.REGION.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Alternative Text, serves as a crucial element to enhance accessibility for users with visual impairments. It provides a textual description of images within documents or webpages, offering insights into their significance in relation to the conten'
||'t.</p>',
'<strong>Best practices:</strong>',
'<ol>',
'<li>Purposeful Description:',
'<ul>',
'<li>Alt Text should succinctly convey the significance of the image in relation to the surrounding content.</li>',
'<li>Focus on describing the "why" of the image rather than stating what the image is.</li>',
'<li>Keep Alt Text clear, concise, and descriptive.</li>',
'</ul>',
'</li>',
'<strong>Example:</strong>',
'<p>"Team celebrating with high-fives and smiles after successfully completing a challenging project."</p>',
'In this example, the alt text emphasizes the reason behind the image, which is the successful completion of a challenging project and the resulting celebration among team members. This description provides context and insight into the significance of'
||' the image for users who cannot see it directly.',
'<li>Informative Images:',
'Identify images that contribute to the comprehension or context of the webpage.',
'If removing the image would diminish the page''s meaning or significance, it requires Alt Text.</li>',
'<li>Avoid Redundancy:',
'Omit phrases like "image of" as screen readers automatically announce an image as such.</li>',
'</ol>'))
,p_version_scn=>12189394
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747637063661390)
,p_name=>'PE.PROPERTY.REGION_IMAGE_ALT_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text that describes the image, to be used in the image HTML ALT attribute.',
'        If the image is purely decorative, or the equivalent visible text is already included on the page, then this field should be left blank and an empty ALT attribute will be rendered.',
'        Leaving this blank will mean users of Assistive Technology like screen readers, will not perceive the image.',
'        If the image is non-decorative, the text provided should be short and descriptive.',
'        This text will then be used as the image ALT text, and screen readers users will hear this description.</p>',
'        <p>Note: A ''decorative'' image is one that does not present important content, or is used for layout or non-informative purposes.</p>'))
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747524640661390)
,p_name=>'PE.PROPERTY.REGION_IMAGE_ALT_TEXT.PROMPT'
,p_message_text=>'Accessible Description'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747803331661390)
,p_name=>'PE.PROPERTY.REGION_IMAGE_ATTRIBUTES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter custom image attributes to be included in the image HTML. This can be used for attributes such as height or width, and',
'        this value is substituted for the substitution string #REGION_IMAGE_ATTRIBUTES# in the selected region template.</p>'))
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747721032661390)
,p_name=>'PE.PROPERTY.REGION_IMAGE_ATTRIBUTES.PROMPT'
,p_message_text=>'Custom Attributes'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594424859500640)
,p_name=>'PE.PROPERTY.REGION_IMAGE_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747496235661390)
,p_name=>'PE.PROPERTY.REGION_IMAGE_URL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a reference to an image URL. Control over image placement within the region comes from region templates that contain the #REGION_IMAGE# or #REGION_IMAGE_URL# substitution strings.',
'        This property is required with the use of #REGION_IMAGE_URL# in the selected region template.'))
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747375377661390)
,p_name=>'PE.PROPERTY.REGION_IMAGE_URL.PROMPT'
,p_message_text=>'File URL'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385144294046696939)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_text=>'Enter the text source for this component.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385144101502696935)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150987111294822704)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_text=>'Enter the SQL source for this component.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150987011654822704)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115975807102250573)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992708480822715)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a region template to define the appearance and layout of this region.</p>',
'        <p>Region templates are defined in the application theme.',
'        When a region is created, the template is automatically set to the default region template defined in the current theme.</p>',
'        <p>Many themes contain region templates for displaying reports, forms, alerts, buttons, collapsible (hide / show) content, login forms, and so forth.<br>',
'        Universal Theme provides the following region templates:',
'          <dl>',
'            <dt>Alert</dt>',
'            <dt>Blank with Attributes</dt>',
'            <dt>Blank with Attributes (No Grid)</dt>',
'            <dt>Buttons Container</dt>',
'            <dt>Cards Container</dt>',
'            <dt>Carousel Container</dt>',
'            <dt>Collapsible</dt>',
'            <dt>Content Block</dt>',
'            <dt>Hero</dt>',
'            <dt>Image</dt>',
'            <dt>Inline Dialog</dt>',
'            <dt>Inline Drawer</dt>',
'            <dt>Inline Popup</dt>',
'            <dt>Interactive Report</dt>',
'            <dt>Login</dt>',
'            <dt>Standard</dt>',
'            <dt>Tabs Container</dt>',
'            <dt>Title Bar</dt>',
'            <dt>Wizard Container</dt>',
'          </dl>',
'          See Also: <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a>',
'        </p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992600708822715)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591459534500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.1.D'
,p_message_text=>'Hide and Show Region'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592494081500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.10.D'
,p_message_text=>'Reports Region, Alternative 1'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591912138500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.11.D'
,p_message_text=>'Region without Title'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592787385500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.12.D'
,p_message_text=>'Wizard Region'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592337939500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.13.D'
,p_message_text=>'Reports Region 100% Width'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591752245500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.16.D'
,p_message_text=>'Navigation Region, Alternative 1'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591106727500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.17.D'
,p_message_text=>'Button Region without Title'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590885528500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.18.D'
,p_message_text=>'Bracketed Region'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591807709500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.19.D'
,p_message_text=>'Region without Buttons and Title'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592523482500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.2.D'
,p_message_text=>'Sidebar Region'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592849756500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.20.D'
,p_message_text=>'Wizard Region with Icon'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592986996500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.21.D'
,p_message_text=>'Custom 1'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593040954500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.22.D'
,p_message_text=>'Custom 2'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593128780500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.23.D'
,p_message_text=>'Custom 3'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593246829500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.24.D'
,p_message_text=>'Custom 4'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593351825500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.25.D'
,p_message_text=>'Custom 5'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593431167500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.26.D'
,p_message_text=>'Custom 6'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593502270500640)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.27.D'
,p_message_text=>'Custom 7'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593680834500640)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.28.D'
,p_message_text=>'Custom 8'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591503843500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.29.D'
,p_message_text=>'List Region with Icon'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592635597500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.3.D'
,p_message_text=>'Sidebar Region, Alternative 1'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591216274500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.30.D'
,p_message_text=>'Chart Region'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592108626500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.31.D'
,p_message_text=>'Report Filter - Single Row'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592096619500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.32.D'
,p_message_text=>'Report Filter - Multi Row'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591075582500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.4.D'
,p_message_text=>'Button Region with Title'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591691643500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.5.D'
,p_message_text=>'Navigation Region'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590951201500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.6.D'
,p_message_text=>'Breadcrumb Region'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590776932500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.7.D'
,p_message_text=>'Borderless Region'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143591335540500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.8.D'
,p_message_text=>'Form Region'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143592260722500639)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.LOV.9.D'
,p_message_text=>'Reports Region'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590651618500638)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_CLASS.PROMPT'
,p_message_text=>'Class'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593771988500640)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143593955450500640)
,p_name=>'PE.PROPERTY.REGION_TITLE_HTML_ID.PROMPT'
,p_message_text=>'Region Title HTML ID'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226665602513268991)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify how this region is rendered. The following region types are supported:</p>',
'#NATIVE_PLUGINS#',
'<p>Depending on your application configuration, you may also have additional region type plug-ins available here.',
'The following plug-ins are installed within this application''s shared components:</p>',
'#CUSTOM_PLUGINS#'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123150215810211881)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487524135716106374)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the type of equality to be tested for this validation. Depending on your selection, one or more additional attributes are required to fully define this validation.</p>',
'<p>If the validation passes the equality test, or evaluates to TRUE, then the validation error message does not display.',
'Validation error messages display when the validation fails the equality test, or evaluates to FALSE, or a non-empty text string is returned.</p>',
'<p>A validation failure does not stop subsequent validations from being evaluated, therefore, each subsequent validation may raise an additional validation error message. If you want to stop subsequent validations from executing then you need to add '
||'additional logic into the first failed validation, such as setting a page item to a specific value, and then enhancing the conditional logic on subsequent validations as needed. Subsequent processes and branches are not executed if one or more valida'
||'tions fail evaluation.</p>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906612661751897)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906712258751897)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the SQL query returns one or more rows.<br>',
'Fails if the SQL query returns no rows.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600296685543090660)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600296779193090660)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the expression evaluates to TRUE.<br>',
'Fails if the expression evaluates to FALSE.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516907676382751900)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_text=>'Function Body (returning Boolean)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516907784865751900)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Function body returns TRUE.<br>',
'Fails if the Function body returns FALSE.<br>',
'Note: The result returned from the function must be a boolean.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516907834055751900)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_text=>'Function Body (returning Error Text)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516907931161751900)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Function body returns an empty string.<br>',
'Fails if the Function body returns a non-empty string. The returned string displays as the error message for the validation.<br>',
'Note: The result returned from the function must be a text string.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908657283751902)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_text=>'Column contains no spaces'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908765152751902)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value has no spaces.<br>',
'Fails if the Column value contains spaces.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910668411751907)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_text=>'Column contains at least one of the characters in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910738199751908)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value includes at least one character from the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Column value does not include any characters from the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910834942751908)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_text=>'Column does NOT contain any of the characters in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910907965751908)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value does not include any characters from the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Column value includes at least one character from the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910404887751906)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_text=>'Column contains only characters specified in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910534766751906)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value contains only characters found in the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Column value contains any characters that are not in the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909698685751903)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_text=>'Column = Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909716859751903)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is equal to the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Column value is not equal to the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910027749751904)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_text=>'Column is contained in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910136963751904)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is completely contained in the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Column value is not completely contained in the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909850307751904)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_text=>'Column != Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909912505751904)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is not equal to the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Column value is equal to the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910203477751904)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_text=>'Column is NOT contained in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516910366602751905)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is not completely contained in the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Column value is completely contained in the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908826351751902)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_text=>'Column is alphanumeric'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908938531751902)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is alphanumeric, containing only letters and numbers and no special characters.<br>',
'Fails if the Column value includes special characters.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909271030751903)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_text=>'Column is a valid date'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909309621751903)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is a valid date.<br>',
'Fails if the Column value is not a valid date.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909006493751902)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_text=>'Column is numeric'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909102738751902)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is numeric.<br>',
'Fails if the Column value contains non-numeric characters, including spaces, other than leading spaces.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909492216751903)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_text=>'Column is a valid timestamp'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516909560657751903)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is a valid timestamp.<br>',
'Fails if the Column value is not a valid timestamp.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908074013751901)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_text=>'Column is NOT NULL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908198712751901)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is not empty.<br>',
'Fails if the Column value is empty.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908220496751901)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_text=>'Column is NOT NULL or zero'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908376357751901)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is not empty and is not the number zero.<br>',
'Fails if the Column value is empty or is the number zero.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908468954751902)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_text=>'Column is NOT zero'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516908572473751902)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value is not the number zero.<br>',
'Fails if the Column value is the number zero.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906843189751897)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906967748751898)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the SQL query returns no rows.<br>',
'Fails if the SQL query returns one or more rows.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516907457615751900)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_text=>'PL/SQL Error'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516907528278751900)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the PL/SQL code executes without generating an error.<br>',
'Fails if the PL/SQL expression generates an error when it executes.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516911094837751908)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_text=>'Column matches Regular Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516911190241751908)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Column value matches the regular expression you enter into the <em>Value</em> attribute.',
'Fails if the Column value does not match the regular expression you enter into the <em>Value</em> attribute.<br>',
'Note: Regular expressions enable you to search for patterns in string data by using standardized syntax conventions, rather than just a straight character comparisons.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487524026254106374)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487527814344106382)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_text=>'Enter a case-sensitive column name for this validation. You can type in the name or pick from the list of available columns.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487527743894106381)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206651285982809)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207081874982810)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206943619982810)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206856338982810)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207125498982810)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206775607982809)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206565065982809)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109037856276425)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109317188276426)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109277699276426)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109111482276426)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109448268276426)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108928258276425)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600296954457090664)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600297226903090664)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600297125714090664)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600297057159090664)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600297331631090664)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600296859787090663)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600300128949090668)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Java expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600300022774090668)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600301767690090669)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Java function body that returns a BOOLEAN value as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600301686101090669)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600298129024090666)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_text=>'Enter a Java function body that returns the error message text as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600298043691090666)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_text=>'Java Function Body Returning Error Text'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612968254484666)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600299823227090668)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600299703196090668)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613111482484667)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600301448752090669)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript function body that returns a BOOLEAN value as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600301376414090669)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612583822484664)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise the specified error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600297871406090666)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_text=>'Enter a JavaScript function body that returns the error message text as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600297781243090664)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_text=>'JavaScript Function Body Returning Error Text'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612623164484665)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise the specified error, when the employee is in department 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487527652520106381)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_text=>'Enter a PL/SQL expression that raises an error as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487527534759106381)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_text=>'PL/SQL Code raising Error'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612890111484665)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600299579298090668)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600299427762090667)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613083995484666)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600301135683090669)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL function body that returns a BOOLEAN value as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600301007934090669)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612401462484664)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise the specified error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600297525636090664)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_text=>'Enter a PL/SQL function body that returns the error message text as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600297482349090664)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_text=>'PL/SQL Function Body Returning Error Text'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600300346126090668)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Python expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600300275342090668)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600301966146090670)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Python function body that returns a BOOLEAN value as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600301849006090670)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600298313099090666)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_text=>'Enter a Python function body that returns the error message text as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600298247468090666)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_text=>'Python Function Body Returning Error Text'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487528230147106382)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_text=>'Enter the regular expression used to match the column specified for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487528185681106382)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_text=>'Regular Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612733695484665)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is a manager or the department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600299274200090667)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a SQL expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600299110774090667)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612344678484663)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>For <strong>Rows Returned</strong>, to pass the validation, and not raise an error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>For <strong>No Rows Returned</strong>, to pass the validation, and not raise an error message, when the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>15114761
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487526686165106379)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_text=>'Enter a SQL query to define this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487526529150106379)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487528068095106382)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_text=>'Enter the value used to compare against the value of the column column specified for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487527901832106382)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(495248073359568623)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_text=>'Application Default'
,p_version_scn=>37166067046493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656092129701958066)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_text=>'Inherits the setting defined against the application.'
,p_version_scn=>37166067046493
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(495247686277568506)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this attribute to control if &PRODUCT_NAME. should support application URLs that do not contain session IDs.',
'When rejoin sessions is enabled, &PRODUCT_NAME. will attempt to use the session cookie to join an existing session, when a URL does not contain a session ID.',
'</p>',
'<p>A more restrictive instance level setting overrides this page level value.',
'</p>',
'<p><em><strong>Note:</strong></em> Enabling rejoin sessions exposes your application to possible security breaches,',
'as it can enable attackers to take over existing end user sessions.',
'To learn more, see the <a rel="noopener noreferrer" href="#SYSTEM_HELP_URL#CSH:pd-rejoin-existing-sessions" target="_blank">Rejoin Sessions</a> sections in "Managing Application Security" in the App Builder User''s Guide.',
'</p>'))
,p_version_scn=>15114749
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516859910903751786)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516860098616751786)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_text=>'If the URL does not contain a session ID &PRODUCT_NAME. creates a new session.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516860168917751786)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_text=>'Enabled for Public Sessions'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516860262364751786)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the URL goes to a public page and does not contain a session ID &PRODUCT_NAME. attempts to utilize the existing session cookie established for that application.',
'For applications with both public and authenticated pages, a session ID is defined after the end user authenticates.',
'&PRODUCT_NAME. only joins via the cookie when the session is not yet authenticated.'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516860315763751787)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_text=>'Enabled for All Sessions'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516860425510751787)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If the URL does not contain a session ID &PRODUCT_NAME. attempts to utilize the existing session cookie established for that application, providing the following conditions are met:</p>',
'<p><ul>',
'  <li>Session State Protection is enabled for the application and the URL includes a valid checksum.',
'    For public bookmarks, the most restrictive item level protection must be either <em>Unrestricted</em> or <em>Checksum Required - Application Level</em>.</li>',
'  <li>OR, the URL does not contain payload (a request parameter, clear cache or data value pairs).</li>',
'</ul></p>',
'<p>This setting also requires that <em>Embed In Frames</em> is set to <em>Allow from same origin</em> or to <em>Deny</em> for the application.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(495247500085568505)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_text=>'Rejoin Sessions'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600496900784508)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.COMPONENT_PROPERTY.PAGE.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>For improved accessibility, opt for the "Only for Success" option for several reasons:</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Dynamic Error Display:</strong>',
'Display errors dynamically without reloading the page.</li>',
'<li><strong>Contextual Reload:</strong>',
'Reload the page after successful processing to maintain user context.</li>',
'<li><strong>Avoiding Full Page Reloads:</strong>',
'Opting for this approach minimizes full page reloads and prevents unnecessary context changes for the user.</li>',
'</ol>'))
,p_version_scn=>36587274
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(430876530726386321)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_text=>'Select when the page should be reloaded following a page submission.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(430876682766386322)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(430876775915386322)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_text=>'Always reload the page to display errors and the success message.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(430876839448386323)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_text=>'Only for Success'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(430876941348386324)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_text=>'Show errors dynamically without reloading page, but reload it after a successful processing.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(430876461923386316)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_text=>'Reload on Submit'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708566070661321)
,p_name=>'PE.PROPERTY.REMOTE_ATTRIBUTE_NAME.PROMPT'
,p_message_text=>'Attribute Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242776044617661548)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242776134574661548)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_text=>'Result is not cached. Data is fetched from the remote database for each request.'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775511152661529)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.COMPONENT_PROPERTY.LOV.NULL_TEXT'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242776624240661571)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242776787020661571)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_text=>'Result is not cached. Data is fetched from the remote database for each request.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242774976158661499)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775089147661499)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_text=>'Result is not cached. Data is fetched from the remote database for each request.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775316564661521)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.COMPONENT_PROPERTY.WEB_SRC_OPERATION.NULL_TEXT'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046524
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662200294661222)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how the &PRODUCT_NAME. engine can cache data in the local database.',
'        If caching can be used, the component will be rendered based on cached results, instead of fetching from the remote database.',
'        Cached results will greatly improve performance, especially if there is latency between the local and remote database.'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662360700661222)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.LOV.ALL_USERS.D'
,p_message_text=>'For All Users'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662440158661222)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.LOV.ALL_USERS.HELP'
,p_message_text=>'Result is cached and utilized by all users.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662702918661223)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.LOV.SESSION.D'
,p_message_text=>'By Session'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662897643661223)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.LOV.SESSION.HELP'
,p_message_text=>'Result is cached specifically for each user session.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662551177661222)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.LOV.USER.D'
,p_message_text=>'By User'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662671940661223)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.LOV.USER.HELP'
,p_message_text=>'Result is cached specifically for each user, across sessions.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662103725661222)
,p_name=>'PE.PROPERTY.REMOTE_CACHING.PROMPT'
,p_message_text=>'Caching'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708626539661321)
,p_name=>'PE.PROPERTY.REMOTE_DATA_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221601128871260197)
,p_name=>'PE.PROPERTY.REMOTE_FILE_SERVER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Select a remote server defined in Workspace Utilities of the type "File Server".'))
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221601098756260197)
,p_name=>'PE.PROPERTY.REMOTE_FILE_SERVER.PROMPT'
,p_message_text=>'Remote File Server'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663183499661223)
,p_name=>'PE.PROPERTY.REMOTE_INVALIDATE_WHEN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Expire the data 15 minutes after it has been cached</dt>',
'  <dd><pre>15</pre></dd>',
'<dt>Expire the data at the top of the hour</dt>',
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
'<dt>Expire the data at midnight</dt>',
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663093056661223)
,p_name=>'PE.PROPERTY.REMOTE_INVALIDATE_WHEN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter when cached data is to be invalidated.',
'        Provide either the amount of minutes or a DBMS_SCHEDULER Calendar String.</p>',
'        <p>For DBMS_SCHEDULER Calendar String, you can define that cached data is invalidated at the top of the hour, at midnight, or another specific recurring point in time.',
'        See the documentation on DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING for more details.</p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242662999144661223)
,p_name=>'PE.PROPERTY.REMOTE_INVALIDATE_WHEN.PROMPT'
,p_message_text=>'Cache Timeout'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706068191622806)
,p_name=>'PE.PROPERTY.REMOTE_IS_COMMON.HELP'
,p_message_text=>'Determines whether this column is a common column of the REST Data Source. Create Page wizards will only consider common columns when creating a new component. Page Designer will always work with all visible columns.'
,p_version_scn=>1112210322
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705977324622806)
,p_name=>'PE.PROPERTY.REMOTE_IS_COMMON.PROMPT'
,p_message_text=>'Is Common'
,p_version_scn=>25819082
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708979189661321)
,p_name=>'PE.PROPERTY.REMOTE_IS_FILTERABLE.PROMPT'
,p_message_text=>'Filterable'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242722501783661334)
,p_name=>'PE.PROPERTY.REMOTE_PRINT_SERVER.PROMPT'
,p_message_text=>'Remote Print Server'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670232580661285)
,p_name=>'PE.PROPERTY.REMOTE_SERVER_TYPE.PROMPT'
,p_message_text=>'Remote Server Type'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698145843661312)
,p_name=>'PE.PROPERTY.REMOTE_SQL_DATABASE_TYPE.LOV.MYSQL.D'
,p_message_text=>'MySQL'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242698012654661312)
,p_name=>'PE.PROPERTY.REMOTE_SQL_DATABASE_TYPE.LOV.ORACLE.D'
,p_message_text=>'Oracle'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697939758661311)
,p_name=>'PE.PROPERTY.REMOTE_SQL_DATABASE_TYPE.PROMPT'
,p_message_text=>'Database Type'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606204049500648)
,p_name=>'PE.PROPERTY.RENDER_PROCEDURE_FUNCTION_NAME.PROMPT'
,p_message_text=>'Render Procedure/Function Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873612748183858)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter an alphanumeric alias for this interactive report region.',
'The alias must be unique within the application.',
'You can use an alias to reference an interactive report region in your custom API call.',
'For example, you can write a function to return the <code>INTERACTIVE_REPORT_ID</code> by querying the <code>ALIAS</code> column in the <code>APEX_APPLICATION_PAGE_IR</code> view.',
'Since the <code>INTERACTIVE_REPORT_ID</code> value can change when you export or import the application to different instances, referencing interactive report regions using an alias may be preferable.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873509158183858)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_text=>'Region Alias'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605056515500647)
,p_name=>'PE.PROPERTY.REPORT_BODY_TEMPLATE.PROMPT'
,p_message_text=>'Report Body'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1630084810184598)
,p_name=>'PE.PROPERTY.REPORT_CONTAINER_TEMPLATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><p>Enter the markup for the report container template. The Static IDs of the Custom Attributes of scope "Report" can be referenced with <code>#STATIC_ID#</code> syntax.',
'You can quickly synchronize all placeholders as Custom Attributes using the <strong>Synchronize Attributes</strong> button.',
'</p>',
'<p>',
'The following predefined template placeholders are supported:',
'<dl>',
'<dt>APEX$DOM_ID</dt>',
'<dd>Unique DOM ID generated when the template is invoked, useful for referencing other DOM elements in the provided HTML markup.</dd>',
'<dt>APEX$COMPONENT_CSS_CLASSES</dt>',
'<dd>CSS classes specified for the region.</dd>',
'<dt>APEX$REPORT_BODY</dt>',
'<dd>Output of the Report Body template.</dd>',
'</dl>',
'</p>',
'<p>You can also use slot placeholders to allow this report container to render page components (regions, items, buttons).<br /> Slots can be referenced with <code>#SLOT_STATIC_ID#</code> syntax.<br />',
'To render a slot conditionally to its usage use the <code>{if SLOT_STATIC_ID/}&lt;div class="inner-div"&gt;#SLOT_STATIC_ID#&lt;/div&gt;{endif/}</code> syntax to render additional markup only if the slot is being used.<br />',
'Slots in the report container template will only render if the associated region uses <strong>Display As: Multiple (Report)</strong></p>',
'<p>Supports Template Directives.</p></p>'))
,p_version_scn=>97316400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1629966076184598)
,p_name=>'PE.PROPERTY.REPORT_CONTAINER_TEMPLATE.PROMPT'
,p_message_text=>'Report Container'
,p_version_scn=>97316399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360494930375274748)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the list of values date restrictions.',
'For date columns, the list of values can display past time, future time, or both in the filter for the report column drop down list.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779335757751534)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_text=>'All'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779555850751535)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_text=>'Future'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516779459186751535)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_text=>'Past'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360494800086274748)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_text=>'Date Ranges'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873831061183858)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a page or application item whose value stores the saved report ID.',
'Interactive report uses this item value to link to a saved report.',
'For example, you can define list of saved reports with links with defined item name and saved report ID as its value to link to a saved default reports, public or private reports.',
'The saved report IDs can be retrieved from the <code>APEX_APPLICATION_PAGE_IR_RPT</code> view.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873715265183858)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_text=>'Report ID Item'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489470201269203315)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_text=>'Default Report Layout'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2647529041613384)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.IR_PRINT_ATTR.NULL_TEXT'
,p_message_text=>'Default Report Layout'
,p_version_scn=>88678808
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242775922145661535)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.REPORT_QUERY.NULL_TEXT'
,p_message_text=>'Use Generic Report Layout'
,p_version_scn=>37166067046535
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489496773572590656)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_text=>'Default Report Layout'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489467955277840289)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_text=>'Select the report layout to utilize when printing the report.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(489467809903840289)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_text=>'Layout'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242756229994661398)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_COLUMN_TEMPLATE.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242756324941661398)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_COLUMN_TEMPLATE_WIDTH.PROMPT'
,p_message_text=>'Column Width'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2400483430879614)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_DATA_LOOP_NAME.HELP'
,p_message_text=>'Specify a name for a data loop if the report layout will be used by report region for printing. The data loop name is used as name for the rows array of the JSON data.'
,p_version_scn=>79184268
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2400334269879614)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_DATA_LOOP_NAME.PROMPT'
,p_message_text=>'Data Loop Name'
,p_version_scn=>79184267
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579785369340721)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_ID.HELP'
,p_message_text=>'Identifies the report layout.'
,p_version_scn=>49870267
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579666925340721)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_ID.PROMPT'
,p_message_text=>'Report Layout'
,p_version_scn=>49870266
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242756044086661398)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_PAGE_TEMPLATE.PROMPT'
,p_message_text=>'Page'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602722005784542)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_REPORT_COLUMN_HEADING.COMPONENT_PROPERTY.REPORT LAYOUT.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Column headings play a crucial role in organizing and presenting tabular data in a clear and understandable format.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Descriptive and Meaningful:</strong> Use descriptive and meaningful column headings that accurately represent the content of each column. Column headings should succinctly convey the information contained within the respective columns.</l'
||'i>',
'<li><strong>Consistency:</strong> Maintain consistency in column headings throughout the table. Consistent column headings facilitate navigation and comprehension for users, especially when interacting with complex tables containing multiple columns.'
||'</li>',
'</ol>'))
,p_version_scn=>36587321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242756183535661398)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_REPORT_COLUMN_HEADING.PROMPT'
,p_message_text=>'Column Heading'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179853810194688496)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this report layout on an existing report layout in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179853746371688496)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2400234297879588)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_TYPE.LOV.DOCX_FILE.D'
,p_message_text=>'Named Columns (DOCX)'
,p_version_scn=>79184258
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755889808661397)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_TYPE.LOV.RTF_FILE.D'
,p_message_text=>'Named Columns (RTF)'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755945500661397)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_TYPE.LOV.XSL_FILE.D'
,p_message_text=>'Named Columns (XSL-FO)'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755760677661397)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_TYPE.LOV.XSL_GENERIC.D'
,p_message_text=>'Generic Columns (XSL-FO)'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755650204661397)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380757952788410000)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_text=>'Select a predefined report templates to control the display of this report.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794227287751592)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_text=>'HTML (standard)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794380677751592)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_text=>'Creates a standard HTML table.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794429300751593)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_text=>'Vertical Report'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794573687751594)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_text=>'Shows each column in a separate row.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794680258751594)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_text=>'CSV'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794742358751594)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_text=>'Exports the report as a CSV file.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794872967751594)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_text=>'XML'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794936492751594)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_text=>'Exports the report as an XML file.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380757893524410000)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605156013500648)
,p_name=>'PE.PROPERTY.REPORT_ROW_TEMPLATE.PROMPT'
,p_message_text=>'Report Row'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380762504082410009)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_text=>'Enter the text that displays adjacent to report sum values.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380762480590410008)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_text=>'Report Sum Label'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380472029259124383)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a report template to define the appearance and layout of this classic report.</p>',
'        <p>Report templates are defined in the application theme.',
'        When a classic report is created, the template is automatically set to the default report template defined in the current theme.</p>',
'        <p>Many themes contain classic report templates for displaying data in a table, key value pairs, search results, cards, and so forth.',
'        Note that some report templates, such as cards and search results, are "row based" and expect your SQL query to return a particular set of column aliases that are substituted in the template.<br>',
'        Universal Theme provides the following report templates:',
'          <dl>',
'            <dt>Alerts</dt>',
'              <dd>Displays any number of horizontal alerts or notifications on your page.</dd>',
'            <dt>Badge List</dt>',
'              <dd>Displays key value pairs in a dashboard-like user interface.</dd>',
'            <dt>Cards</dt>',
'              <dd>Displays report data in cards, or small blocks and is useful for presenting a variety of information. Cards can be heavily customized via Template Options.</dd>',
'            <dt>Comments</dt>',
'              <dd>Displays comments and other messages.</dd>',
'            <dt>Content Row</dt>',
'              <dd>Displays report data in a set of rows, with support for a selection column, icons, and actions. Suitable for most types of content.</dd>',
'            <dt>Contextual Info</dt>',
'              <dd>Displays simple key-value pairs one after the next. It uses the column headers as the labels and displays the associated column value next to each label.</dd>',
'            <dt>Media List</dt>',
'              <dd>Displays report content in a media list, with an icon, heading, description, and badge.</dd>',
'            <dt>Search Results</dt>',
'              <dd>Displays search-engine style search results.</dd>',
'            <dt>Standard</dt>',
'              <dd>This is the default report template for displaying data in a table and can be heavily customized via Template Options.</dd>',
'            <dt>Timeline</dt>',
'              <dd>Displays a timeline of actions. It is well suited for home pages, change logs, and other areas where an activity feed of recent actions is needed.</dd>',
'            <dt>Value Attribute Pairs - Column</dt>',
'              <dd>Displays key-value pairs for column-based queries. It uses the column header as the label for each item.</dd>',
'            <dt>Value Attribute Pairs - Row</dt>',
'              <dd>Displays key-value pairs for row-based queries. It uses the first column for labels, and second column for values.</dd>',
'          </dl>',
'          See Also: <a rel="noopener noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application</a>',
'        </p>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380471962206124383)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715302187661327)
,p_name=>'PE.PROPERTY.REQUEST_BODY_TEMPLATE.PROMPT'
,p_message_text=>'Request Body Template'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752402949661394)
,p_name=>'PE.PROPERTY.REQUIRED_FREE_SPACE.PROMPT'
,p_message_text=>'Free Space'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752536409661394)
,p_name=>'PE.PROPERTY.REQUIRED_FREE_SPACE.UNIT'
,p_message_text=>'KB'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752723217661395)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.LOV.CREATE DATABASE LINK.D'
,p_message_text=>'CREATE DATABASE LINK'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752831626661395)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.LOV.CREATE MATERIALIZED VIEW.D'
,p_message_text=>'CREATE MATERIALIZED VIEW'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752938320661395)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.LOV.CREATE PROCEDURE.D'
,p_message_text=>'CREATE PROCEDURE'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753085340661395)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.LOV.CREATE SEQUENCE.D'
,p_message_text=>'CREATE SEQUENCE'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753151200661395)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.LOV.CREATE SYNONYM.D'
,p_message_text=>'CREATE SYNONYM'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753274312661395)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.LOV.CREATE TABLE.D'
,p_message_text=>'CREATE TABLE'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753373989661395)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.LOV.CREATE TRIGGER.D'
,p_message_text=>'CREATE TRIGGER'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753466043661395)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.LOV.CREATE TYPE .D'
,p_message_text=>'CREATE TYPE '
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753545343661395)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.LOV.CREATE VIEW.D'
,p_message_text=>'CREATE VIEW'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752652068661394)
,p_name=>'PE.PROPERTY.REQUIRED_SYSTEM_PRIVILEGES.PROMPT'
,p_message_text=>'System Privileges'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245975096077481119)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to prevent the interactive grid from displaying data, unless at least one filter is defined on one of the report columns.',
'        This option is designed to limit the data loaded from a very large data set, by restricting the rows returned based on a filter.</p>',
'        <p>Individual columns can have <strong>Column Filter Required</strong> enabled, ensuring a filter is required for that column, whereas, this option only requires one filter across any of the columns.</p>',
'        <p>Note - When this option is set and no filters are currently defined, a message will be displayed requesting the users to input a filter.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974939264481119)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_text=>'Requires Filter'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380857754495128737)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_text=>'All characters can be saved.'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123141227799211866)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how to restrict the characters that can be saved in session state.',
'&PRODUCT_NAME. displays an error message if a user tries to save data that does not conform to the selected character restriction.</p>',
'<p>Restricting the characters hardens application security and is a possible counter measure to cross-site scripting (XSS) attacks.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766842097751486)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_text=>'Blocklist &<>"/;,*|=% and --'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766906733751486)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_text=>'The following characters: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % and "--" (PL/SQL comment) can NOT be saved.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516767032774751486)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_text=>'Blocklist &<>"/;,*|=% or -- and new line'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516767158421751486)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_text=>'The following characters: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, %, "--", and new line characters can NOT be saved.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766444948751484)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_text=>'Allowlist for a-Z, 0-9 and space'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766521300751485)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_text=>'Only characters a-z, A-Z, 0-9 and space can be saved.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766687844751486)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_text=>'Blocklist HTML command characters (<>")'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766763473751486)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_text=>'Reserved HTML characters can NOT be saved.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516767236170751487)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_text=>'Workspace Schema'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109114267304856448)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WRKSP_USER_SCHEMA.D'
,p_message_text=>'Workspace User Schema'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109114327114856448)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WRKSP_USER_SCHEMA_ID.D'
,p_message_text=>'Workspace User Schema ID'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123141124184211866)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_text=>'Restricted Characters'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721583674661333)
,p_name=>'PE.PROPERTY.RESTRICT_ACCESS.PROMPT'
,p_message_text=>'Restrict User List'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755342472661397)
,p_name=>'PE.PROPERTY.REST_CATALOG_NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755443096661397)
,p_name=>'PE.PROPERTY.REST_CATALOG_SERVICE_NAME.PROMPT'
,p_message_text=>'Service '
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755542278661397)
,p_name=>'PE.PROPERTY.REST_CATALOG_SERVICE_VERSION.PROMPT'
,p_message_text=>'Version'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711570146661324)
,p_name=>'PE.PROPERTY.REST_DATA_SOURCE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607100657500649)
,p_name=>'PE.PROPERTY.REST_SOURCE_CAPABILITIES_PROCEDURE.PROMPT'
,p_message_text=>'REST Source Capabilities Procedure'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607541118500649)
,p_name=>'PE.PROPERTY.REST_SOURCE_DISCOVER_PROCEDURE.PROMPT'
,p_message_text=>'REST Source Discover Procedure'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607389150500649)
,p_name=>'PE.PROPERTY.REST_SOURCE_DML_PROCEDURE.PROMPT'
,p_message_text=>'REST Source DML Procedure'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607481187500649)
,p_name=>'PE.PROPERTY.REST_SOURCE_EXECUTE_PROCEDURE.PROMPT'
,p_message_text=>'REST Source Execute Procedure'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143607274469500649)
,p_name=>'PE.PROPERTY.REST_SOURCE_FETCH_PROCEDURE.PROMPT'
,p_message_text=>'REST Source Fetch Procedure'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696095639661310)
,p_name=>'PE.PROPERTY.RETURN_COLUMN_NAME.PROMPT'
,p_message_text=>'Return'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242697637437661311)
,p_name=>'PE.PROPERTY.RETURN_VALUE.PROMPT'
,p_message_text=>'Return'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(602346650693523030)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_text=>'Select the input format for the content rendered.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(602346948235523030)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_text=>'HTML'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(602347265234523030)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_text=>'Content contains HTML tags and will be rendered without applying special characters escaping. Make sure that the data is safe and does not contain end-user entered data to avoid Cross-Side Scripting vulnerabilities (XSS).'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(602347517872523031)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_text=>'Markdown'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(602347811251523031)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_text=>'Content contains Markdown tags which will be translated into safe HTML tags before rendering. The translation of well known Markdown tags will <strong>prevent</strong> Cross-Side Scripting vulnerabilities (XSS).'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(602346345516523030)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_text=>'Format'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596561486500641)
,p_name=>'PE.PROPERTY.ROW_BEFORE_FIRST_ROW.PROMPT'
,p_message_text=>'Top'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143596975401500642)
,p_name=>'PE.PROPERTY.ROW_COLUMN_HEADING_TEMPLATE.PROMPT'
,p_message_text=>'Heading'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600987215686569)
,p_name=>'PE.PROPERTY.ROW_SELECTION_TYPE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>11004719
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600225474686389)
,p_name=>'PE.PROPERTY.ROW_SELECTION_TYPE.HELP'
,p_message_text=>'Select the type of row selection.'
,p_version_scn=>11004648
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600369592686389)
,p_name=>'PE.PROPERTY.ROW_SELECTION_TYPE.LOV.FOCUS.D'
,p_message_text=>'Focus only'
,p_version_scn=>11004648
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600407376686389)
,p_name=>'PE.PROPERTY.ROW_SELECTION_TYPE.LOV.FOCUS.HELP'
,p_message_text=>'Only enables setting the focus to a selected row. Useful to improve accessibility or being able to keyboard navigate through the result set.'
,p_version_scn=>11004648
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600732187686389)
,p_name=>'PE.PROPERTY.ROW_SELECTION_TYPE.LOV.MULTIPLE.D'
,p_message_text=>'Multiple Selection'
,p_version_scn=>11004648
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600853384686389)
,p_name=>'PE.PROPERTY.ROW_SELECTION_TYPE.LOV.MULTIPLE.HELP'
,p_message_text=>'Enables multiple row selection.'
,p_version_scn=>11004648
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600570934686389)
,p_name=>'PE.PROPERTY.ROW_SELECTION_TYPE.LOV.SINGLE.D'
,p_message_text=>'Single Selection'
,p_version_scn=>11004648
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600684007686389)
,p_name=>'PE.PROPERTY.ROW_SELECTION_TYPE.LOV.SINGLE.HELP'
,p_message_text=>'Enables single row selection.'
,p_version_scn=>11004648
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600130999686370)
,p_name=>'PE.PROPERTY.ROW_SELECTION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>11004645
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599643621500644)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_1.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599917624500644)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_1_CONDITION.LOV.EVEN_ROW_NUMBERS.D'
,p_message_text=>'Use for Even Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599801314500644)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_1_CONDITION.LOV.NOT_CONDITIONAL.D'
,p_message_text=>'Use Based on PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600076868500644)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_1_CONDITION.LOV.ODD_ROW_NUMBERS.D'
,p_message_text=>'Use for Odd Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143599748370500644)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_1_CONDITION.PROMPT'
,p_message_text=>'Condition'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600163067500644)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_1_EXPRESSION.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600223455500644)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_2.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600535711500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_2_CONDITION.LOV.EVEN_ROW_NUMBERS.D'
,p_message_text=>'Use for Even Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600414464500644)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_2_CONDITION.LOV.NOT_CONDITIONAL.D'
,p_message_text=>'Use Based on PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600686314500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_2_CONDITION.LOV.ODD_ROW_NUMBERS.D'
,p_message_text=>'Use for Odd Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600366431500644)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_2_CONDITION.PROMPT'
,p_message_text=>'Condition'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600776010500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_2_EXPRESSION.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600809645500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_3.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601186397500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_3_CONDITION.LOV.EVEN_ROW_NUMBERS.D'
,p_message_text=>'Use for Even Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601054659500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_3_CONDITION.LOV.NOT_CONDITIONAL.D'
,p_message_text=>'Use Based on PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601228995500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_3_CONDITION.LOV.ODD_ROW_NUMBERS.D'
,p_message_text=>'Use for Odd Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143600969012500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_3_CONDITION.PROMPT'
,p_message_text=>'Condition'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601376128500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_3_EXPRESSION.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601464286500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_4.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601772492500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_4_CONDITION.LOV.EVEN_ROW_NUMBERS.D'
,p_message_text=>'Use for Even Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601647610500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_4_CONDITION.LOV.NOT_CONDITIONAL.D'
,p_message_text=>'Use Based on PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601855483500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_4_CONDITION.LOV.ODD_ROW_NUMBERS.D'
,p_message_text=>'Use for Odd Numbered Rows'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601596145500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_4_CONDITION.PROMPT'
,p_message_text=>'Condition'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143601918005500645)
,p_name=>'PE.PROPERTY.ROW_TEMPLATE_4_EXPRESSION.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974295255481116)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_text=>'Select the column which stores the row version number for the table being updated. This column will be used in the lost update check.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974120835481116)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_text=>'Row Version Column'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730438566661341)
,p_name=>'PE.PROPERTY.RUNTIME_API_USAGE.LOV.O.D'
,p_message_text=>'Modify Other Applications'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730321902661341)
,p_name=>'PE.PROPERTY.RUNTIME_API_USAGE.LOV.T.D'
,p_message_text=>'Modify This Application'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730500100661341)
,p_name=>'PE.PROPERTY.RUNTIME_API_USAGE.LOV.W.D'
,p_message_text=>'Modify Workspace Repository'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242730216297661341)
,p_name=>'PE.PROPERTY.RUNTIME_API_USAGE.PROMPT'
,p_message_text=>'Runtime API Usage'
,p_version_scn=>37166067046416
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361253616127487181)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_text=>'Select the frequency that this process is executed.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516784294858751559)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_text=>'Once Per Page Visit (default)'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516784186695751559)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_text=>'Once Per Session or When Reset'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361253516996487181)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_text=>'Run Process'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360868731759183854)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select an authorization scheme to restrict who can save public report definitions.',
'To enable an end user to save a public report, this authorization scheme must evaluate to TRUE.',
'If no authorization scheme is provided then reports may be saved by any user.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360868610954183854)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_text=>'Save Public Report Authorization'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155912307425354792)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether values in session state are saved to the database before the branch executes.',
'It is important to set this attribute to <strong>On</strong> if you are navigating to a different application that needs to access the session state values from this application.'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155912217742354792)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_text=>'Save State before Branching'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716226906661328)
,p_name=>'PE.PROPERTY.SCHEDULE_EXPRESSION.PROMPT'
,p_message_text=>'Schedule Expression'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716461704661328)
,p_name=>'PE.PROPERTY.SCHEDULE_STATUS.LOV.ACTIVE.D'
,p_message_text=>'Active'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716517183661328)
,p_name=>'PE.PROPERTY.SCHEDULE_STATUS.LOV.DISABLED.D'
,p_message_text=>'Disabled'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716652154661328)
,p_name=>'PE.PROPERTY.SCHEDULE_STATUS.LOV.ERROR.D'
,p_message_text=>'Disabled (Error)'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242716335344661328)
,p_name=>'PE.PROPERTY.SCHEDULE_STATUS.PROMPT'
,p_message_text=>'Schedule Status'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992516788822715)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_text=>'Enter the page or application item to be used as the overriding parsing schema.  This is for internal applications only.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992406488822714)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_text=>'Schema Override Item'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599370752951282304)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599370614779282304)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599369908633282304)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_text=>'<p>Select how this authorization scheme will be applied.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599370048457282304)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_text=>'Exists SQL Query'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599370155594282304)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_text=>'Authorization passes when query returns a value'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599370401820282304)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_text=>'PL/SQL Function Returning Boolean'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599370582984282304)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_text=>'Enter a PL/SQL Function Body that returns a boolean value'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599370274508282304)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_text=>'NOT Exists SQL Query'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599370306216282304)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_text=>'Authorization passes when query does not return any values'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599369848929282304)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_text=>'Scheme Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126956423869511164)
,p_name=>'PE.PROPERTY.SCREENSHOT_URL.HELP'
,p_message_text=>'Identifies the screenshot URL.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126956330626511164)
,p_name=>'PE.PROPERTY.SCREENSHOT_URL.PROMPT'
,p_message_text=>'Screenshot URL'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306866046300625)
,p_name=>'PE.PROPERTY.SEARCHABLE_COLUMNS.HELP'
,p_message_text=>'Provide a list of columns to include when searching.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306767444300625)
,p_name=>'PE.PROPERTY.SEARCHABLE_COLUMNS.PROMPT'
,p_message_text=>'Searchable Columns'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308207703300627)
,p_name=>'PE.PROPERTY.SEARCH_BADGE_COLUMN_NAME.HELP'
,p_message_text=>'Identify the column which contains content to display as the search result badge.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308132438300627)
,p_name=>'PE.PROPERTY.SEARCH_BADGE_COLUMN_NAME.PROMPT'
,p_message_text=>'Badge Column Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360869513272183855)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_text=>'Enter the text for the search button label.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360869428553183855)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_text=>'Search Button Label'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310842290300629)
,p_name=>'PE.PROPERTY.SEARCH_CONFIGURATION.HELP'
,p_message_text=>'Select a Search Configuration (Shared Component) to search within.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310733885300629)
,p_name=>'PE.PROPERTY.SEARCH_CONFIGURATION.PROMPT'
,p_message_text=>'Search Configuration'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577335344340720)
,p_name=>'PE.PROPERTY.SEARCH_CONFIG_ID.HELP'
,p_message_text=>'Identifies the search configuration.'
,p_version_scn=>49870257
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577277635340720)
,p_name=>'PE.PROPERTY.SEARCH_CONFIG_ID.PROMPT'
,p_message_text=>'Search Configuration'
,p_version_scn=>49870256
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310654255300629)
,p_name=>'PE.PROPERTY.SEARCH_CONFIG_SUBSCRIBED_FROM.HELP'
,p_message_text=>'You may base the search config definition on an existing search config in this application or another in your workspaces schema.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310557349300629)
,p_name=>'PE.PROPERTY.SEARCH_CONFIG_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308667242300627)
,p_name=>'PE.PROPERTY.SEARCH_CUSTOM_01_COLUMN_NAME.HELP'
,p_message_text=>'Identify the column which contains content to display as the search result custom attribute "1".'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308553132300627)
,p_name=>'PE.PROPERTY.SEARCH_CUSTOM_01_COLUMN_NAME.PROMPT'
,p_message_text=>'Custom Column Name 1'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308844792300627)
,p_name=>'PE.PROPERTY.SEARCH_CUSTOM_02_COLUMN_NAME.HELP'
,p_message_text=>'Identify the column which contains content to display as the search result custom attribute "2".'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308709598300627)
,p_name=>'PE.PROPERTY.SEARCH_CUSTOM_02_COLUMN_NAME.PROMPT'
,p_message_text=>'Custom Column Name 2'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115309090620300628)
,p_name=>'PE.PROPERTY.SEARCH_CUSTOM_03_COLUMN_NAME.HELP'
,p_message_text=>'Identify the column which contains content to display as the search result custom attribute "3".'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308999355300628)
,p_name=>'PE.PROPERTY.SEARCH_CUSTOM_03_COLUMN_NAME.PROMPT'
,p_message_text=>'Custom Column Name 3'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308042371300627)
,p_name=>'PE.PROPERTY.SEARCH_DESCR_COLUMN_NAME.HELP'
,p_message_text=>'Identify the column which contains content to display as the search result description.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307972135300627)
,p_name=>'PE.PROPERTY.SEARCH_DESCR_COLUMN_NAME.PROMPT'
,p_message_text=>'Description Column Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308412902300627)
,p_name=>'PE.PROPERTY.SEARCH_LAST_MODIFIED_COLUMN_NAME.HELP'
,p_message_text=>'Identify the column which contains content to display as the search result last modfied timestamp.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115308395618300627)
,p_name=>'PE.PROPERTY.SEARCH_LAST_MODIFIED_COLUMN_NAME.PROMPT'
,p_message_text=>'Last Modified Column Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307226011300626)
,p_name=>'PE.PROPERTY.SEARCH_PK1_COLUMN_NAME.HELP'
,p_message_text=>'Select the first primary key column from the search data source. If the primary key of this table has more than two columns, the query must provide a <code>ROWID</code> column.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307197892300625)
,p_name=>'PE.PROPERTY.SEARCH_PK1_COLUMN_NAME.PROMPT'
,p_message_text=>'Primary Key 1 Column Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307419616300626)
,p_name=>'PE.PROPERTY.SEARCH_PK2_COLUMN_NAME.HELP'
,p_message_text=>'Select the second primary key column from the search data source. If the primary key of this table has more than two columns, the query must provide a <code>ROWID</code> column.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307363395300626)
,p_name=>'PE.PROPERTY.SEARCH_PK2_COLUMN_NAME.PROMPT'
,p_message_text=>'Primary Key 2 Column Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115305479999300623)
,p_name=>'PE.PROPERTY.SEARCH_PREFIX.HELP'
,p_message_text=>'Prefix a search term to only evaluate it for specific search configurations.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115305331840300623)
,p_name=>'PE.PROPERTY.SEARCH_PREFIX.PROMPT'
,p_message_text=>'Search Query Prefix'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115309205929300628)
,p_name=>'PE.PROPERTY.SEARCH_SCORE_COLUMN_NAME.HELP'
,p_message_text=>'Identify the column which contains the result score. This is useful to provide a result score also Search Configurations not based on Oracle Text.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115309104599300628)
,p_name=>'PE.PROPERTY.SEARCH_SCORE_COLUMN_NAME.PROMPT'
,p_message_text=>'Score Column Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307846222300626)
,p_name=>'PE.PROPERTY.SEARCH_SUBTITLE_COLUMN_NAME.HELP'
,p_message_text=>'Identify the column which contains content to display as the search result subtitle.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307756854300626)
,p_name=>'PE.PROPERTY.SEARCH_SUBTITLE_COLUMN_NAME.PROMPT'
,p_message_text=>'Subtitle Column Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310434786300629)
,p_name=>'PE.PROPERTY.SEARCH_TEXT_SQL_QUERY.HELP'
,p_message_text=>'Enter the SQL query for the search text.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310304164300629)
,p_name=>'PE.PROPERTY.SEARCH_TEXT_SQL_QUERY.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310274218300629)
,p_name=>'PE.PROPERTY.SEARCH_TEXT_TABLE_NAME.HELP'
,p_message_text=>'Enter the case-sensitive table or view name. You can type in the name or pick from the list.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310149656300629)
,p_name=>'PE.PROPERTY.SEARCH_TEXT_TABLE_NAME.PROMPT'
,p_message_text=>'Table Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310000338300628)
,p_name=>'PE.PROPERTY.SEARCH_TEXT_TABLE_OWNER.HELP'
,p_message_text=>'Select the schema that owns the table.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115309908733300628)
,p_name=>'PE.PROPERTY.SEARCH_TEXT_TABLE_OWNER.PROMPT'
,p_message_text=>'Table Owner'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307658047300626)
,p_name=>'PE.PROPERTY.SEARCH_TITLE_COLUMN_NAME.HELP'
,p_message_text=>'Identify the column which contains content to display as the search result title.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307587456300626)
,p_name=>'PE.PROPERTY.SEARCH_TITLE_COLUMN_NAME.PROMPT'
,p_message_text=>'Title Column Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115305686896300623)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.HELP'
,p_message_text=>'Select the type of search for this configuration.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115305943598300624)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.LOV.APEX_LIST.D'
,p_message_text=>'APEX List'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306027026300624)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.LOV.APEX_LIST.HELP'
,p_message_text=>'Search within an APEX List.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115305731961300623)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.LOV.SIMPLE.D'
,p_message_text=>'Simple (APEX Data Source)'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115305801811300624)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.LOV.SIMPLE.HELP'
,p_message_text=>'Use an APEX Data Source (local, REST Enabled SQL, or REST Data Source).'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948007256925506)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.LOV.TEXT_DBMS_SEARCH.D'
,p_message_text=>'Oracle Ubiquitous Search'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112948126361925506)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.LOV.TEXT_DBMS_SEARCH.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Search using an Oracle Ubiquitous Search index (requires Oracle Database 23ai or later).<br/>',
'<em>The index must be located in the parsing schema of the application.</em>'))
,p_version_scn=>22686180
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306182883300625)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.LOV.TEXT_MANUAL.D'
,p_message_text=>'Oracle Text (Manual)'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306276860300625)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.LOV.TEXT_MANUAL.HELP'
,p_message_text=>'Search using a manually maintained Oracle Text index.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115305554205300623)
,p_name=>'PE.PROPERTY.SEARCH_TYPE.PROMPT'
,p_message_text=>'Search Type'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936162962296787)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_text=>'Specify whether this component displays using a column or advanced formatting using HTML expressions and supported substitution strings.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936003922296787)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_text=>'Advanced Formatting'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936346166296788)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_text=>'Select the column to be used as secondary body.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936247755296788)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936828346296788)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936787886296788)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936643194296788)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Change the background and text colors</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Use Heading 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Use a dynamic class from the SQL query</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    The <code>&COLUMN_CLASS.</code> and <code>&EMPLOYEE_STATUS.</code> substitutions in this example are columns selected in the report SQL query.</dd>',
'  <dt>Show an image, and a tooltip on hover</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936580705296788)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_text=>'Enter HTML expressions to be shown in this column. Use <code>&COLUMN.</code> syntax to show column values in HTML.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596936451601296788)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_text=>'HTML Expression'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661657245661101)
,p_name=>'PE.PROPERTY.SECURE_COOKIE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify <strong>On</strong> to enable the session management cookie to be sent from the browser only when the protocol is HTTPS.',
'Select <strong>Off</strong> to enable the session management cookie to be sent from the browser when the protocol is HTTP or HTTPS.</p>',
'<p>If SSL is configured on your web server, you should select <strong>On</strong> to strengthen your application''s security by preventing unencrypted HTTP traffic.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661588599661101)
,p_name=>'PE.PROPERTY.SECURE_COOKIE.PROMPT'
,p_message_text=>'Secure'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600937075001656)
,p_name=>'PE.PROPERTY.SELECT_ALL_PAGE_ITEM.HELP'
,p_message_text=>'Enter the page item used as the source for selecting all records. This item must be of type checkbox.'
,p_version_scn=>6739880
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600861826001656)
,p_name=>'PE.PROPERTY.SELECT_ALL_PAGE_ITEM.PROMPT'
,p_message_text=>'Select All Page Item'
,p_version_scn=>11004654
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957692902792523)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_text=>'Specify whether the first row should automatically be selected.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256957517349792523)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_text=>'Select First Row'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385565982234693401)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_text=>'Series Chart Type'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295616509019065340)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_text=>'Select the column name to be used for defining your multi-series dynamic query.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295616412000065340)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_text=>'Series Name'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668915029661284)
,p_name=>'PE.PROPERTY.SERVER_TIMEOUT.HELP'
,p_message_text=>'Defines the transfer timeout for communicating with the server in seconds.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242668821561661284)
,p_name=>'PE.PROPERTY.SERVER_TIMEOUT.PROMPT'
,p_message_text=>'Server Timeout'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242669043798661284)
,p_name=>'PE.PROPERTY.SERVER_TIMEOUT.UNIT'
,p_message_text=>'seconds'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242670193520661285)
,p_name=>'PE.PROPERTY.SERVER_TIME_ZONE.PROMPT'
,p_message_text=>'Server Time Zone'
,p_version_scn=>37166067046400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116961092383909848)
,p_name=>'PE.PROPERTY.SESSION_FORMAT_MASK.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Format mask to be used to convert the workflow variable or parameter value into a NUMBER, DATE and TIMESTAMP and back into a VARCHAR2',
'                                when the variable or parameter is used in a bind variable or substitution string. '))
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116960772962909848)
,p_name=>'PE.PROPERTY.SESSION_FORMAT_MASK.PROMPT'
,p_message_text=>'Session State Format Mask'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727876860661338)
,p_name=>'PE.PROPERTY.SESSION_IDLE_TIMEOUT_URL.PROMPT'
,p_message_text=>'Session Idle Timeout URL'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606432488500648)
,p_name=>'PE.PROPERTY.SESSION_SENTRY_FUNCTION_NAME.PROMPT'
,p_message_text=>'Session Sentry Function Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690921681661305)
,p_name=>'PE.PROPERTY.SESSION_STATE_ITEMS.PROMPT'
,p_message_text=>'Items'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123140127099211864)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_text=>'Select a Session State Protection level.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516765662641751482)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_text=>'Checksum Required - Application Level'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516765745921751483)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_text=>'The item can be set by passing the item in a URL that includes a checksum specific to the workspace and application.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766245939751483)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_text=>'Restricted - May not be set from browser'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766359614751484)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The item can not be altered using the URL or POSTDATA.',
'Select this option to restrict what can set the item value to internal processes, computations, and so on.',
'This attribute only applies to items that are not used as data entry items and is always observed, even if Session State Protection is disabled.',
'Use this attribute for page or application items that have the following <strong>Display As</strong> types:',
'<ul>',
'  <li>Display Only (Save State=No)</li>',
'  <li>Text Field (Disabled, does not save state)</li>',
'</ul>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516765452415751482)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_text=>'Unrestricted'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516765521686751482)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_text=>'The item can be set by passing the item in a URL or in a form. No checksum is required in the URL.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516765882572751483)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_text=>'Checksum Required - User Level'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516765988287751483)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_text=>'The item can be set by passing the item in a URL that includes a checksum specific to the workspace, application and user.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766024168751483)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_text=>'Checksum Required - Session Level'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516766130843751483)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_text=>'The item can be set by passing the item in a URL that includes a checksum specific to the session.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123140017167211864)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_text=>'Session State Protection'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727576047661338)
,p_name=>'PE.PROPERTY.SESSION_TIMEOUT_URL.PROMPT'
,p_message_text=>'Session Timeout URL'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727958024661338)
,p_name=>'PE.PROPERTY.SESSION_TIMEOUT_WARNING.PROMPT'
,p_message_text=>'Session Timeout Warning'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728080163661339)
,p_name=>'PE.PROPERTY.SESSION_TIMEOUT_WARNING.UNIT'
,p_message_text=>'seconds'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509064805670736)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_text=>'Select the filter group to which this checkbox is associated.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508913672670736)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_text=>'Filter Group'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111607698276429)
,p_name=>'PE.PROPERTY.SHORTCUT_FUNC_BODY_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111531753276429)
,p_name=>'PE.PROPERTY.SHORTCUT_FUNC_BODY_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111470985276429)
,p_name=>'PE.PROPERTY.SHORTCUT_FUNC_BODY_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111742516276429)
,p_name=>'PE.PROPERTY.SHORTCUT_FUNC_BODY_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61111338689276429)
,p_name=>'PE.PROPERTY.SHORTCUT_FUNC_BODY_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675533269661289)
,p_name=>'PE.PROPERTY.SHORTCUT_HTML_CODE.PROMPT'
,p_message_text=>'HTML Code'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579389070340721)
,p_name=>'PE.PROPERTY.SHORTCUT_ID.HELP'
,p_message_text=>'Identifies the shortcut.'
,p_version_scn=>49870265
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10579216839340721)
,p_name=>'PE.PROPERTY.SHORTCUT_ID.PROMPT'
,p_message_text=>'Shortcut'
,p_version_scn=>49870264
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242758584902661465)
,p_name=>'PE.PROPERTY.SHORTCUT_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614461131484673)
,p_name=>'PE.PROPERTY.SHORTCUT_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES" : "NO" );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242758446722661465)
,p_name=>'PE.PROPERTY.SHORTCUT_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614360101484673)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242758336975661464)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242758678002661465)
,p_name=>'PE.PROPERTY.SHORTCUT_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046484
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666626814661277)
,p_name=>'PE.PROPERTY.SHORTCUT_SUBSCRIBED_FROM.HELP'
,p_message_text=>'You may base the shortcut definition on an existing shortcut in this application or another in your workspaces schema.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666559398661277)
,p_name=>'PE.PROPERTY.SHORTCUT_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675680679661290)
,p_name=>'PE.PROPERTY.SHORTCUT_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665713915661276)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.HELP'
,p_message_text=>'The shortcut type identifies what is in the shortcut text.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665869175661276)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body returning VARCHAR2'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665943940661276)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.LOV.HTML_TEXT.D'
,p_message_text=>'HTML Text'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666008991661276)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.LOV.HTML_TEXT_ESCAPE_SC.D'
,p_message_text=>'HTML Text with Escaped Special Chars'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666147900661276)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.LOV.IMAGE.D'
,p_message_text=>'Image'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666369073661277)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.LOV.MESSAGE.D'
,p_message_text=>'Message'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666463168661277)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.LOV.MESSAGE_ESCAPE_JS.D'
,p_message_text=>'Message with JavaScript Escaped Single Quotes'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242666241957661276)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.LOV.TEXT_ESCAPE_JS.D'
,p_message_text=>'Text with JavaScript Escaped Single Quotes'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(630575097249467586)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360882110299183864)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_text=>'Specify whether the <em>Actions</em> menu is included within the Search Bar.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360882027391183864)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_text=>'Include Actions Menu'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879308592183862)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_text=>'Specify whether end users can define aggregates for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879211839183862)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_text=>'Aggregate'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973381875250237)
,p_name=>'PE.PROPERTY.SHOW_AS_DISABLED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to render the button or menu entries as <strong>disabled</strong> instead of hiding them if the entered row-level condition evaluates to FALSE.</p>',
'<p>Setting this attribute to <strong>On></strong> improves layout stability and guides end-users on which actions are available.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115973287132250237)
,p_name=>'PE.PROPERTY.SHOW_AS_DISABLED.PROMPT'
,p_message_text=>'Show as Disabled'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360489612336274734)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_text=>'Specify whether or not this column displays in the report by default.'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360489525671274734)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_text=>'Show by Default'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879528642183862)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_text=>'Specify whether end users can define charts for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879429957183862)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_text=>'Chart'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879124030183862)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_text=>'Specify whether end users can define computational columns for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879029526183862)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_text=>'Compute'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878724580183862)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_text=>'Specify whether end users can define control breaks for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878610287183861)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_text=>'Control Break'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509462248670736)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_text=>'Specify whether to display the facet label next to its selected value(s) in the list of current facets. Hide the label if the selected value is self-explaining, for example, an order status.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136509351379670736)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_text=>'Show Label for Current Facet'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627268255500664)
,p_name=>'PE.PROPERTY.SHOW_DEPRECATED_ATTRIBUTE_FOR_VALUES.PROMPT'
,p_message_text=>'Show Deprecated Attribute for Values'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881721034183864)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether a separate drop down row selector is included within the search bar.',
'You should not select both this attribute and <strong>Rows Per Page</strong>.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881610239183864)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_text=>'Rows Per Page Selector'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880524800183863)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_text=>'Specify whether end users can download the report to one of the download formats specified.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880400144183863)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_text=>'Download'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877928248183861)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_text=>'Specify whether end users can define filters on this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360877813700183861)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_text=>'Filter'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881502203183864)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether the Finder drop down is included at the beginning of the Search field within the search bar.',
'The Finder drop down is a list of columns that enables users to limit their search to a specific column.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881430532183863)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_text=>'Finder Drop Down'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880111646183863)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can utilize flashback queries for this report.</p>',
'<p>Flashback queries utilize the Oracle Flashback Technology and Database Point-in-Time Recovery to view data as it existed at a previous point in time. Users can only query this data, but can not rewind any data changes. How far back in time they ca'
||'n successfully perform a flashback query is determined by when the redo log files were last switched within the Oracle database, as this technology utilizes the RMAN backup.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880016314183863)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_text=>'Flashback'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879910239183863)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_text=>'Specify whether end,users can define group by break-downs for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879829101183862)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_text=>'Group By'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295610179095065318)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_text=>'Specify whether the group name should be displayed in the tooltip rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295610091368065318)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_text=>'Show Group Name'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880718771183863)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can invoke the built-in help modal dialog for interactive reports.</p>',
'<p>The help dialog only outlines those options available to the current user.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880609358183863)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_text=>'Help'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878902284183862)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_text=>'Specify whether end users can define highlights for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878831736183862)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_text=>'Highlight'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567456487812315482)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_text=>'Specify whether this layer is being shown in the legend.'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567456328397315474)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046428
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879713660183862)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_text=>'Specify whether end users can define subscription settings for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360879632361183862)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_text=>'Subscription'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360867115600183853)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_text=>'Enter the text you want to display for null columns.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360867022239183853)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_text=>'Show Null Values as'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3701296840671)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_text=>'Specify whether end users can define pivot break-downs for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3701295840671)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_text=>'Pivot'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123135500559211856)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether quick picks display for this page item.',
'Quick picks enable users to select predefined values with just one click, rather than typing in text or selecting from a list of available options.</p>',
'<p>You should specify quick picks when there is a relatively small, discrete set of <em>common</em> input values.',
'There is a maximum of ten quick picks that can be defined for an item.',
'Such user aids are especially useful when defined for an item that has a lengthy select list of available values.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123135430166211856)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_text=>'Show Quick Picks'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360882324219183864)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether the Reports select list displays in the search bar.</p>',
'<p>The Reports select list only displays if a report, other than the primary report, is accessible to the user.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360882220367183864)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_text=>'Reports Select List'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880300766183863)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether end users can reset their reports from the Actions menu.</p>',
'<p>Resetting the report reverts all customizations made by the user, or specified by the calling URL, and displays the Primary Report.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360880215795183863)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_text=>'Reset'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878304277183861)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_text=>'Specify whether end users can change the number of rows displayed for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878222835183861)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_text=>'Rows Per Page'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881900873183864)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_text=>'Specify whether the search field is included within the search bar.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360881811986183864)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_text=>'Search Field'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878106202183861)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_text=>'Specify whether end users can use <strong>Select Columns</strong> in the Actions menu to change the columns displayed in this report. User can select (or show), deselect (or hide) and reorder multiple columns using this option.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878009433183861)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_text=>'Select Columns'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295609958757065317)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_text=>'Specify whether the series name should be displayed in the tooltip rendered on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295609848507065317)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_text=>'Show Series Name'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878504559183861)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_text=>'Specify whether end users can define sort columns for this report.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360878413422183861)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_text=>'Sort'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508475487670737)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_text=>'Specify whether to show the label of the filter or only the value in the Suggestion Chip. Hide the label if the suggested value is self-explaining, for example, an order status.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508390110670737)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_text=>'Show Label'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245976139455481122)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_text=>'Specify whether a toolbar is displayed above the report. The toolbar may include search, report type, saved reports, actions, change, and reset functionality.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245976063730481122)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245975952387481122)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to display the total row count in the report footer.<p/>',
'        <p>Note - An additional query is performed to obtain the total row count, which may hinder performance, especially on very large data sets.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245975883178481122)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_text=>'Show Total Count'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143590148880500637)
,p_name=>'PE.PROPERTY.SIDEBAR_POSITION.PROMPT'
,p_message_text=>'Sidebar Position'
,p_version_scn=>37166067046443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380450986942584103)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'For the Simple Checkbox display type, enter either one value or two comma separated values.',
'The first value is submitted if the checkbox is selected. The second value, if defined, is submitted if the checkbox is deselected.'',',
'        p_examples           => q''~<dl>',
'<dt>Submit Yes when selected and No when deselected</dt>',
'<dd><pre>',
'Yes,No',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380450883771584103)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_text=>'Checkbox Values'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116921092690909816)
,p_name=>'PE.PROPERTY.SIMPLE_SOURCE_QUERY_TYPE.HELP'
,p_message_text=>'Select how the data is queried.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116921976039909817)
,p_name=>'PE.PROPERTY.SIMPLE_SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116922285791909817)
,p_name=>'PE.PROPERTY.SIMPLE_SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_text=>'The data is retrieved based on a SQL Query.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116921368950909816)
,p_name=>'PE.PROPERTY.SIMPLE_SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_text=>'Table / View'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116921680766909817)
,p_name=>'PE.PROPERTY.SIMPLE_SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_text=>'The data is retrieved based on a table or view.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116920710911909816)
,p_name=>'PE.PROPERTY.SIMPLE_SOURCE_QUERY_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242749536522661392)
,p_name=>'PE.PROPERTY.SINGLE_FILE_URLS.PROMPT'
,p_message_text=>'Single File URLs'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360490920396274737)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_text=>'Enter the column label to use in the Single Row View.'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360490819983274737)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_text=>'Label'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636531599500671)
,p_name=>'PE.PROPERTY.SLOT_BUTTON_SUPPORT.PROMPT'
,p_message_text=>'Buttons'
,p_version_scn=>37166067046455
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636627121500671)
,p_name=>'PE.PROPERTY.SLOT_GRID_SUPPORT.PROMPT'
,p_message_text=>'Grid'
,p_version_scn=>37166067046455
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636446726500671)
,p_name=>'PE.PROPERTY.SLOT_ITEM_SUPPORT.PROMPT'
,p_message_text=>'Items'
,p_version_scn=>37166067046454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636714099500671)
,p_name=>'PE.PROPERTY.SLOT_MAX_FIXED_GRID_COLUMNS.PROMPT'
,p_message_text=>'Maximum Fixed Columns'
,p_version_scn=>37166067046455
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636820514500671)
,p_name=>'PE.PROPERTY.SLOT_NEW_ROW.PROMPT'
,p_message_text=>'New Row'
,p_version_scn=>37166067046455
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614494764673407)
,p_name=>'PE.PROPERTY.SLOT_PLACEHOLDER.HELP'
,p_message_text=>'Select the slot used to display this component. The slots are derived from the appropriate page template, region template or template component definition.'
,p_version_scn=>91991090
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1614380272673407)
,p_name=>'PE.PROPERTY.SLOT_PLACEHOLDER.PROMPT'
,p_message_text=>'Slot'
,p_version_scn=>91991090
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636301367500670)
,p_name=>'PE.PROPERTY.SLOT_REGION_SUPPORT.PROMPT'
,p_message_text=>'Regions'
,p_version_scn=>37166067046454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696397924661310)
,p_name=>'PE.PROPERTY.SORT_DIRECTION.LOV.ASC.D'
,p_message_text=>'Ascending (Nulls Last)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696474767661310)
,p_name=>'PE.PROPERTY.SORT_DIRECTION.LOV.ASC_NULLS_FIRST.D'
,p_message_text=>'Ascending (Nulls First)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696516505661310)
,p_name=>'PE.PROPERTY.SORT_DIRECTION.LOV.DESC.D'
,p_message_text=>'Descending (Nulls Last)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696612096661310)
,p_name=>'PE.PROPERTY.SORT_DIRECTION.LOV.DESC_NULLS_FIRST.D'
,p_message_text=>'Descending (Nulls First)'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242696291158661310)
,p_name=>'PE.PROPERTY.SORT_DIRECTION.PROMPT'
,p_message_text=>'Sort Direction'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380761569089410007)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_text=>'For report columns that enable column heading sorting, select how you want records with null values to be sorted in relation to records with not null values'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796036877751597)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_text=>'First'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796160162751598)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_text=>'Records with a null value are displayed before any columns with not-null values.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796293311751598)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_text=>'Last'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516796386647751598)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_text=>'Records with a not-null values are displayed before any columns with a null value.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380761493862410007)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_text=>'Sort Nulls'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3711703476464)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_text=>'Select the breadcrumb list associated with this page.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3711702476463)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945736840933064293)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_text=>'<p>Enter the case sensitive database column name used as the source for this facet.</p>'
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584822902804747885)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_text=>'<p>Enter the case sensitive database column name used as the source for this facet.</p>'
,p_version_scn=>37166067046548
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136510485003670635)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_text=>'<p>Enter the case sensitive database column name used as the source for this filter.</p>'
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136511588117670632)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_text=>'<p>Enter the case sensitive database column name used as the source for this filter.</p>'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123133409591211852)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the case sensitive database column name used as the source for this item value.</p>',
'<p>This column must exist in the table specified within the built-in fetch row process defined on this page.',
'An error is raised, and the page is not loaded, if the database column name does not exist in the referenced table.',
'Similarly, if there is no built-in fetch row process defined and there is an item with a source type of <strong>Database Column</strong>, then an error is raised, and the page is not loaded when trying to render the page.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123133309942211852)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_text=>'Database Column'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204519859982799)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG_VARCHAR2.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204984260982799)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204810763982799)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204708702982799)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205073874982799)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204600183982799)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG_VARCHAR2.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130204477404982799)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472571690079855224)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_text=>'Select the region associated with this Faceted Search or Smart Filter region.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472571580456855216)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_text=>'Filtered Region'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727183644661338)
,p_name=>'PE.PROPERTY.SOURCE_FOR_ROLE_OR_GROUP_SCHEMES.LOV.A.D'
,p_message_text=>'Authentication Scheme'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727239853661338)
,p_name=>'PE.PROPERTY.SOURCE_FOR_ROLE_OR_GROUP_SCHEMES.LOV.C.D'
,p_message_text=>'Custom Code'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242727040479661338)
,p_name=>'PE.PROPERTY.SOURCE_FOR_ROLE_OR_GROUP_SCHEMES.LOV.R.D'
,p_message_text=>'Access Control User Role Assignments'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242726931864661338)
,p_name=>'PE.PROPERTY.SOURCE_FOR_ROLE_OR_GROUP_SCHEMES.PROMPT'
,p_message_text=>'Source for Role or Group Schemes'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114485742276436)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_CLOB.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114767977276437)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_CLOB.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114685411276437)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_CLOB.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114513837276437)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_CLOB.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114898526276437)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_CLOB.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114397515276436)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_CLOB.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104805155276416)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_VARCHAR2.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105160921276416)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105011526276416)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104965498276416)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61105254573276416)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61104769319276416)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036792510862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_COLUMNS_CLAUSE.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    <dl>',
'    <dt>Return <strong>NAME</strong>, <strong>BRAND</strong> and <strong>TOTAL_COST</strong> columns, the latter is the <strong>COST</strong> column, multiplied by 100.</dt>',
'    <dd><pre>p.name, c.brand, t.cost * 100 as total_cost</pre></dd>',
'   </dl>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036655117862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_COLUMNS_CLAUSE.HELP'
,p_message_text=>'Define the query return columns. Those are properties of vertices or edges or expressions using them.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036508773862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_COLUMNS_CLAUSE.PROMPT'
,p_message_text=>'Columns Clause'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036147504862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_MATCH_CLAUSE.EXAMPLES'
,p_message_text=>'<dl><dt>Find all persons who bought cars.</dt><dd><pre>(p is person) - [t is buys] -> (c is car)</pre></dd><dt>Find all employees working in departments.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments)</pre></dd><dt>Find all emplo'
||'yees working in departments who bought cars.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments), (e is employees) - [t is buys] -> (c is car)</pre></dd></dl>'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036033389862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_MATCH_CLAUSE.HELP'
,p_message_text=>'Enter a path pattern to find on the property graph. In order to find all edges in your graph, use the following: <strong>(a) - [e] -> (b)</strong>. In addition to this, use <em>label constraints</em> to restrict the types of vertices or edges of inte'
||'rest.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62035907841862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_MATCH_CLAUSE.PROMPT'
,p_message_text=>'Match Clause'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62035895790862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_NAME.HELP'
,p_message_text=>'Enter the case-sensitive Property Graph name. You can type in the name or pick from the list.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62035781528862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_NAME.PROMPT'
,p_message_text=>'Graph Name'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037330955862320)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_ORDER_BY.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    <dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'    <dd><pre>',
'    HIREDATE DESC NULLS LAST, DEPTNO',
'    </pre></dd>',
'    </dl>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037224590862320)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_ORDER_BY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter one or more comma separated column names, including directives, to define the order in which records are retrieved.</p>',
'            <p>Directives include:',
'              <ul>',
'                <li>ASC - Return column in ascending order</li>',
'                <li>DESC - Return column in descending order</li>',
'                <li>NULLS FIRST - Return column with no value before those with values</li>',
'                <li>NULLS LAST - Return column with values before those with no value</li>',
'              </ul>',
'            </p>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037101627862320)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_ORDER_BY.PROMPT'
,p_message_text=>'Order By Clause'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037640705862320)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_ORDER_BY_ITEM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037556129862320)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_ORDER_BY_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter multiple Order By Clauses that can be picked by end-users. Each can contain one or more comma-separated column names, including directives, to define the order in which records are retrieved.</p>',
'            <p>Directives include:',
'              <ul>',
'                <li>ASC - Return column in ascending order</li>',
'                <li>DESC - Return column in descending order</li>',
'                <li>NULLS FIRST - Return column with no value before those with values</li>',
'                <li>NULLS LAST - Return column with values before those with no value</li>',
'              </ul>',
'            </p>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037459168862320)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_ORDER_BY_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62035678096862318)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_OWNER.HELP'
,p_message_text=>'Select the schema that owns the Property Graph.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62035534717862318)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_OWNER.PROMPT'
,p_message_text=>'Graph Owner'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037090572862320)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_STATIC_ORDER_BY.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    <dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'    <dd><pre>',
'    HIREDATE DESC NULLS LAST, DEPTNO',
'    </pre></dd>',
'    </dl>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036926616862320)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_STATIC_ORDER_BY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter one or more comma separated column names, including directives, to define the order in which records are retrieved.</p>',
'            <p>Directives include:',
'              <ul>',
'                <li>ASC - Return column in ascending order</li>',
'                <li>DESC - Return column in descending order</li>',
'                <li>NULLS FIRST - Return column with no value before those with values</li>',
'                <li>NULLS LAST - Return column with values before those with no value</li>',
'              </ul>',
'            </p>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036858613862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_STATIC_ORDER_BY.PROMPT'
,p_message_text=>'Order By Clause'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036427847862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_WHERE_CLAUSE.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    <dl>',
'    <dt>Only include those employees which have a manager or have a job of salesman.</dt>',
'    <dd><pre>( e.mgr is not null or e.job = ''SALESMAN'' )</pre></dd>',
'    </dl>'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036334532862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_WHERE_CLAUSE.HELP'
,p_message_text=>'Enter an optional WHERE clause to restrict the returned rows. Columns must use a vertex or edge alias.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62036273096862319)
,p_name=>'PE.PROPERTY.SOURCE_GRAPH_WHERE_CLAUSE.PROMPT'
,p_message_text=>'Where Clause'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675801067661290)
,p_name=>'PE.PROPERTY.SOURCE_IMAGE_URL.PROMPT'
,p_message_text=>'Image URL'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123132813597211851)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page or application item used as the source for this item value.',
'You can type in the name or pick from the list of available items.'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123132732681211851)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600308543786090678)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_text=>'Enter the Java code to be executed.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600308475588090678)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_text=>'Java Code'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600279348189090624)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a Java expression that produces a value used as the source for this item value.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600279219903090624)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61115677156276438)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_CLOB.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a Java function body that returns the HTML content of this region as a CLOB.</p>',
'<p>Note that it is the developer''s responsibility to ensure the generated HTML is accessible and secure. Untrusted content should be escaped appropriately to avoid Cross-site Scripting (XSS).</p>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61115544934276437)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_CLOB.PROMPT'
,p_message_text=>'Java Function Body returning a CLOB'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600280920489090628)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter a Java function body that returns a value used as the source for this item value.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600280818251090628)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175614040089484671)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Increases the salary by 3% for those employees which are qualified for a salary raise:</dt>',
'<dd><pre>',
'let rows;',
'',
'function needsSalaryRaise( empno ) {',
'    // placeholder for some complicated logic to calculate if employee needs a raise',
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( let row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600308213345090678)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_text=>'Enter the JavaScript code to be executed.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600308122811090678)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_text=>'JavaScript Code'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609897890484646)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600279056649090624)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a JavaScript expression that produces a value used as the source for this item value.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600278918996090623)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617510287484687)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_CLOB.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Print the list of all employee names and their jobs:</dt>',
'<dd><pre>',
'let result = "&lt;h4&gt;List of employees:&lt;/h4&gt;";',
'let rows = apex.conn.execute( `',
'    select ename,',
'           job',
'      from emp',
'     order by ename',
'` ).rows;',
'',
'result += "&lt;ul&gt;";',
'for ( let row of rows ) {',
'    result += `&lt;li&gt;&lt;strong&gt;${row.ENAME}&lt;/strong&gt; (${row.JOB})&lt;/li&gt;`;',
'}',
'result += "&lt;/ul&gt;";',
'',
'return result;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61115399480276437)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_CLOB.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a JavaScript function body that returns the HTML content of this region as a CLOB.</p>',
'<p>Note that it is the developer''s responsibility to ensure the generated HTML is accessible and secure. Untrusted content should be escaped appropriately to avoid Cross-site Scripting (XSS).</p>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61115254437276437)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_CLOB.PROMPT'
,p_message_text=>'JavaScript Function Body returning a String'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175610056857484647)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES" : "NO" );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600280689004090627)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter a JavaScript function body that returns a value used as the source for this item value.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600280538067090627)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3711701476463)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_text=>'Select the source for this list.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3711700476463)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5400495008670786)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>109169378
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5400534420670786)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_text=>'No data source.'
,p_version_scn=>109169379
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152960463387110251)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_text=>'Select the location of the data.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152960526091110252)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_text=>'Local Database'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152960648217110253)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_text=>'Data is sourced from the local database.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152960745460110254)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_text=>'REST Enabled SQL'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152960827558110255)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_text=>'Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. '
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378309493129736)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_text=>'REST Source'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644374215585374138)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_text=>'Data is sourced from a RESTful web service defined using REST Data Sources.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152960350353110250)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_text=>'Location'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242675741608661290)
,p_name=>'PE.PROPERTY.SOURCE_MESSAGE_NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046409
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295629615311065694)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_text=>'Enter a comma separated list of page items on the current page to be set into session state when the chart data gets read with a separate request.'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563463618437649161)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_text=>'Enter a comma separated list of page items on the current page to be set into session state when the map data is fetched with a separate request.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992302199822714)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter page or application items to be set into session state when the region is refreshed by a partial page refresh.',
'For multiple items, separate each item name with a comma.',
'You can type in the name or pick from the list of available items.',
'If you pick from the list and there is already text entered, then a comma is placed at the end of the existing text, followed by the item name returned from the list.</p>',
'<p>The region can be refreshed with partial page refresh either during pagination, if <em>Enable Partial Page Refresh</em> is set to <strong>On</strong>), or with the Refresh action within a Dynamic Action.</p>',
'These page items can then be used in the <em>where condition</em> of the Region Source SQL Query to restrict the query result.'))
,p_version_scn=>15114747
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150992219822822714)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_text=>'Page Items to Submit'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613960875484671)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Increases the salary by 3% for those employees which are qualified for a salary raise:</dt>',
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307921055090678)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_text=>'Enter the PL/SQL code to be executed.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307849699090678)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_text=>'PL/SQL Code'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609777297484646)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600278735860090623)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a PL/SQL expression that produces a value used as the source for this item value.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600278674378090623)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617415170484687)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_CLOB.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Print the list of all employee names and their jobs:</dt>',
'<dd><pre>',
'declare',
'    l_result clob := ''&lt;h4>List of employees:&lt;/h4&gt;'';',
'begin',
'    l_result := l_result || ''&lt;ul&gt;'';',
'    for l_emp in ( select ename,',
'                          job',
'                     from emp',
'                    order by ename )',
'    loop',
'        l_result := l_result ||',
'                    ''&lt;li&gt;&lt;strong&gt;'' || apex_escape.html( l_emp.ename ) || ''&lt;/strong&gt;'' ||',
'                    '' ('' || apex_escape.html( l_emp.job ) || '')&lt;/li&gt;'';',
'    end loop;',
'    l_result := l_result || ''&lt;/ul&gt;'';',
'',
'    return l_result;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61115023035276437)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_CLOB.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL function body that returns the HTML content of this region as a CLOB.</p>',
'<p>Note that it is the developer''s responsibility to ensure the generated HTML is accessible and secure. Untrusted content should be escaped appropriately to avoid Cross-site Scripting (XSS).</p>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114916696276437)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_CLOB.PROMPT'
,p_message_text=>'PL/SQL Function Body returning a CLOB'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609999601484647)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600280308968090625)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter a PL/SQL function body that returns a value used as the source for this item value.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600280258524090625)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656369330679245294)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_text=>'Select how to post process the retrieved REST Source data in the local database.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656369882401245296)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_text=>'PL/SQL Function Body returning SQL Query'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656369980451245297)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_text=>'Enter a PL/SQL function body, where the SQL query returned transforms the data retrieved.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656369690840245295)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656369731337245296)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_text=>'Enter a SQL Query to transform the data retrieved.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656369452125245294)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_text=>'Where/Order By Clause'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656369532922245295)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_text=>'Enter the where and/or order by clause to restrict and order the data retrieved.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656369230324245294)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123133630856211853)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_text=>'Enter the User Preference to be used as the source for this item value.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123133526553211853)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_text=>'Preference'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600308767674090678)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_text=>'Enter the Python code to be executed.'
,p_version_scn=>37166067046481
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600308699126090678)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_text=>'Python Code'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600279545389090624)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a Python expression that produces a value used as the source for this item value.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600279454202090624)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61115820348276438)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_CLOB.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a Python function body that returns the HTML content of this region as a CLOB.</p>',
'<p>Note that it is the developer''s responsibility to ensure the generated HTML is accessible and secure. Untrusted content should be escaped appropriately to avoid Cross-site Scripting (XSS).</p>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61115737814276438)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_CLOB.PROMPT'
,p_message_text=>'Python Function Body returning a CLOB'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600281120612090628)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter a Python function body that returns a value used as the source for this item value.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600281040409090628)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123132410781211851)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_text=>'Enter the SQL Query used as the source for this item value. If more than one row is returned then the value of the first row is used.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123132301065211851)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123132612288211851)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_text=>'Enter the SQL Query that returns one or more rows to be used as the source for this item value. If the result contains multiple rows, then the format of what is returned is determined by the current item''s Multiple Values setting. If Multiple Values '
||'is set to <em>Delimited Values</em>, the value will be a single concatenated list separated by the defined Separator. If Multiple Values is set to <em>JSON Array</em>, the value will be a JSON Array of the values. If Multiple Values is set to <em>No<'
||'/em> or the column does not support multiple values, then the value is a single concatenated list separated by a colon.'
,p_version_scn=>20482183
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123132501569211851)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107273910276419)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG_SQL.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107500975276419)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG_SQL.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107408133276419)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG_SQL.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107360041276419)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG_SQL.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107618187276419)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG_SQL.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61107105309276419)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG_SQL.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600289384564090646)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_text=>'Enter a Java function body that returns an SQL Query for this component.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600289210260090646)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Java Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611159704484653)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Select the EMPNO, ENAME and SAL columns and filter out all rows with a SAL less then 3000.</dt>',
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from EMP where SAL < 3000";',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600289022184090645)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_text=>'Enter a JavaScript function body that returns an SQL Query for this component.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600288937230090645)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'JavaScript Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152952542825840916)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    <dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'    <dd><pre>',
'    HIREDATE DESC NULLS LAST, DEPTNO',
'    </pre></dd>',
'    </dl>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152952427314840915)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter one or more comma separated column names, including directives, to define the order in which records are retrieved.</p>',
'            <p>Directives include:',
'              <ul>',
'                <li>ASC - Return column in ascending order</li>',
'                <li>DESC - Return column in descending order</li>',
'                <li>NULLS FIRST - Return column with no value before those with values</li>',
'                <li>NULLS LAST - Return column with values before those with no value</li>',
'              </ul>',
'            </p>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152952333727840914)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_text=>'Order By Clause'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041464576306649)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_ITEM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041370320306647)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter multiple Order By Clauses that can be picked by end-users. Each can contain one or more comma-separated column names, including directives, to define the order in which records are retrieved.</p>',
'            <p>Directives include:',
'              <ul>',
'                <li>ASC - Return column in ascending order</li>',
'                <li>DESC - Return column in descending order</li>',
'                <li>NULLS FIRST - Return column with no value before those with values</li>',
'                <li>NULLS LAST - Return column with values before those with no value</li>',
'              </ul>',
'            </p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041223593306647)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041795465306649)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_ITEM2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041644365306649)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_ITEM2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter multiple Order By Clauses that can be picked by end-users. Each can contain one or more comma-separated column names, including directives, to define the order in which records are retrieved.</p>',
'            <p>Directives include:',
'              <ul>',
'                <li>ASC - Return column in ascending order</li>',
'                <li>DESC - Return column in descending order</li>',
'                <li>NULLS FIRST - Return column with no value before those with values</li>',
'                <li>NULLS LAST - Return column with values before those with no value</li>',
'              </ul>',
'            </p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041580343306649)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_ITEM2.PROMPT'
,p_message_text=>'Order By Item'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044857831306815)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_TYPE.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044540303306779)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_TYPE.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046507
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144040707826306646)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_TYPE.HELP'
,p_message_text=>'Select how this component is sorted.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041013087306646)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144041167128306646)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Based on the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144040836809306646)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144040921755306646)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Based on the ORDER BY clause entered into <em>Order By Clause</em>.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144040602448306644)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951735984840910)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_text=>'Select the schema that owns the table.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951616932840909)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_text=>'Table Owner'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378937130129745)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_text=>'Enter a PL/SQL Function that returns a SQL query that is used as the basis for this region.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378851074129744)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_text=>'PL/SQL Function Body returning SQL Query'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611098773484652)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Select the EMPNO, ENAME and SAL columns and filter out all rows with a SAL less then 3000.</dt>',
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600288750858090645)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_text=>'Enter a PL/SQL function body that returns an SQL Query for this component.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600288646209090645)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'PL/SQL Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600289557083090646)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_text=>'Enter a Python function body that returns an SQL Query for this component.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600289489809090646)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_text=>'Python Function Body returning SQL Query'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044114522306654)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_STATIC_ORDER_BY.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    <dl><dt>To show the newest hires first and those which have not been hired yet last. If the date is equal, sort them by department number.</dt>',
'    <dd><pre>',
'    HIREDATE DESC NULLS LAST, DEPTNO',
'    </pre></dd>',
'    </dl>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144044069402306654)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_STATIC_ORDER_BY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter one or more comma separated column names, including directives, to define the order in which records are retrieved.</p>',
'            <p>Directives include:',
'              <ul>',
'                <li>ASC - Return column in ascending order</li>',
'                <li>DESC - Return column in descending order</li>',
'                <li>NULLS FIRST - Return column with no value before those with values</li>',
'                <li>NULLS LAST - Return column with values before those with no value</li>',
'              </ul>',
'            </p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144043938510306653)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_STATIC_ORDER_BY.PROMPT'
,p_message_text=>'Order By Clause'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951951509840911)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_text=>'Enter the case-sensitive table or view name. You can type in the name or pick from the list.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951853278840910)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_text=>'Table Name'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951377040840906)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_text=>'Select how the data is queried.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378474968129738)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_text=>'Function Body returning SQL Query'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378507437129739)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_text=>'The data is retrieved based on the SQL Query returned by executing a Function Body.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62037921132862341)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.GRAPH.D'
,p_message_text=>'Property Graph'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(62038017460862341)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.GRAPH.HELP'
,p_message_text=>'The data is retrieved based on a Property Graph.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152990131214619062)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152990229199619067)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_text=>'The data is retrieved based on a SQL Query.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951478504840907)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_text=>'Table / View'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951593779840908)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_text=>'The data is retrieved based on a table or view.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951233776840905)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152952266653840914)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Only include those employees which have a manager or have a job of salesman.</dt>',
'<dd><pre>',
'( MGR is not null or JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152952167398840913)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152952093954840912)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_text=>'Where Clause'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951103812840904)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_text=>'Select the remote database server.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152951048180840904)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_text=>'Remote Server'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(168940416672469282)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE_TYPE.PROMPT'
,p_message_text=>'Database Type'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(168940678737469303)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_ORACLE_DATABASE.HELP'
,p_message_text=>'Select the remote database server.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(168940549140469303)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_ORACLE_DATABASE.PROMPT'
,p_message_text=>'Remote Server'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711674999661324)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_REST_SERVER.PROMPT'
,p_message_text=>'Remote Server'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307326379090677)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_text=>'Select a language that is used to execute the entered code.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307615900090677)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307577191090677)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307474027090677)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307717687090678)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600307227352090677)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436867592890587450)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>To concatenate two columns together:</dt>',
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
'<dt>Include an inner select:</dt>',
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTID)',
'</pre></dd>',
'<pre>',
'The SQL Expression will be combined with the main query.',
'Make sure that there are no ambiguities, use column aliases.',
'</pre>',
'</dl>'))
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245987254443481169)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_text=>'Enter the SQL Expression.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245987183468481168)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175609631929484646)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600278433961090623)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter a SQL expression that produces a value used as the source for this item value.'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600278379628090623)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567457310442315683)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Query returning longitude and latitude values as NUMBER columns:</dt>',
'<dd><pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre></dd>',
'<dt>Query returning the customer location as SDO_GEOMETRY column:</dt>',
'<dd><pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85343284988736413)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152952785067840917)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_text=>'Enter the SQL source for this component.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152952606166840917)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123132214865211851)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_text=>'Enter the static value used as the source for this item value.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123132128482211850)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123131129438211849)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the source type the value of this item is based on.</p>',
'<p>Note: If <strong>Source: Used</strong> is set to <em>Only when current value in session state is null</em>, the source will not be utilized if a value has been set into session state for this item.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516763941332751472)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599823027612464071)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_text=>'Set to null as no value specified.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516764125202751472)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_text=>'Database Column'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599822393490464068)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_text=>'Set to the column value entered in <em>Database Column</em>, that is retrieved from a built-in fetch row process.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600257418868090270)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600257559364090270)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>Expression</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516764596768751472)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599822809027464070)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516764640958751473)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599822406067464068)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516764729022751474)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_text=>'Preference'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599822926392464071)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_text=>'Set to the value of the <em>Preference</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516764210685751472)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599822582138464069)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516764338087751472)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_text=>'SQL Query (return multiple values)'
,p_version_scn=>20471036
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599822630897464069)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_text=>'Set to multiple values returned from the <em>SQL Query</em>. The format of what is returned is determined by the current item''s Multiple Values setting. If Multiple Values is set to <em>Delimited Values</em>, the value will be a single concatenated l'
||'ist separated by the defined Separator. If Multiple Values is set to <em>JSON Array</em>, the value will be a JSON Array of the values. If Multiple Values is set to <em>No</em> or the item does not support multiple values, then the value is a single '
||'concatenated list separated by a colon.'
,p_version_scn=>20476609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516764014588751472)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599822265131464067)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Set to the text entered into <em>Static Value</em>.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123131030981211849)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123130720359211848)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select which value takes precedence, the value from session state or the item source value.</p>',
'<p>For items with the source type <strong>Database Column</strong>, select <strong>Always, replacing any existing value in session state</strong> unless you do not want the associated row fetch operation to populate the item if the page branches back'
||' to itself.',
'For other source types you must decide, based on how the page is used, whether the previously sourced value is displayed, or if the source type is applied anew for each page view.</p>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516763790421751471)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_text=>'Always, replacing any existing value in session state'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516763820445751472)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_text=>'Only when current value in session state is null'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123130604033211848)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_text=>'Used'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706712724622917)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_ARRAY_COL.COMPONENT_PROPERTY.AUTOMATION.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>25819114
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706809577622932)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_ARRAY_COL.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>25819118
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706529740622898)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_ARRAY_COL.COMPONENT_PROPERTY.LOV.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>25819111
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706985563622958)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_ARRAY_COL.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>25819139
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706487844622852)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_ARRAY_COL.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>25819098
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2400730668879687)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_ARRAY_COL.COMPONENT_PROPERTY.REPORT_QUERY_STATEMENT.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>79184354
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706621654622907)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_ARRAY_COL.COMPONENT_PROPERTY.SEARCH_CONFIG.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>25819113
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705604264622736)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_ARRAY_COL.HELP'
,p_message_text=>'<p>Select the <strong>Array Column</strong>, from the REST Source Data Profile, to use for this component. All <em>direct</em> child columns of the selected array column, and all its parent columns will become available to this component as a flat ta'
||'ble structure.</p><p>Note: &PRODUCT_NAME. uses the <code>JSON_TABLE</code> SQL function with <code>NESTED PATH</code> clauses to convert nested JSON to a flat result.</p>'
,p_version_scn=>39066510
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705516442622736)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_ARRAY_COL.PROMPT'
,p_message_text=>'Array Column'
,p_version_scn=>25819063
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378708424129744)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_text=>'Select the REST Data Source which supports fetching a collection.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234378663300129743)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_text=>'REST Source'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210787849982819)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210672609982819)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210572797982819)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210882890982819)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210495549982819)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210352900982819)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114121818276436)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114037174276436)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113960377276436)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61114200850276436)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113867131276436)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242773723919661478)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242774607582661479)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617126681484685)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242773642549661478)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617322295484686)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242774563487661479)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242772707054661477)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617084305484685)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242773565984661478)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617251250484686)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242774477194661479)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242773852903661478)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242774778290661479)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616977282484685)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242773404453661478)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616854149484685)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully as one or more rows exist when checking if the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>To return successfully as no rows exist when checking if the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242772681967661477)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242772067116661477)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242772100714661477)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242772369435661477)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242772440994661477)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242772562028661477)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242772231409661477)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242771947879661477)
,p_name=>'PE.PROPERTY.SO_COND_CONDITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210192639982818)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210085513982818)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209976900982818)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130210237961982818)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209823162982818)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130209753737982818)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113675621276435)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113516652276435)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113434149276435)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113746464276435)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61113358332276435)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242770829197661476)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242771763610661476)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616517803484683)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242770738462661476)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616723271484684)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242771643968661476)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242769875454661475)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616417470484683)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242770665396661475)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616682469484684)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242771505042661476)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242770931054661476)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242771870102661476)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616398395484683)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242770522639661475)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175616213194484682)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully as one or more rows exist when checking if the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>To return successfully as no rows exist when checking if the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242769754394661475)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242769138231661474)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242769222748661474)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242769419405661474)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242769536918661474)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242769695328661475)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242769334595661474)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242769041520661474)
,p_name=>'PE.PROPERTY.SO_VAL_CONDITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295629481651065387)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_text=>'In a split dual-Y chart, specify the fraction of the space that is given to the Y-axis subchart. Valid values are numbers from 0 to 1.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295629323790065386)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_text=>'Splitter Position'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628955031065385)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_text=>'Specify whether the plot area is split into two sections, so that sets of data assigned to the different Y-axes appear in different parts of the plot area. Stock charts do not support <strong>No</strong>.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295629079800065385)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295629269722065386)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_text=>'No'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295629141647065385)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_text=>'Yes'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628813631065384)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242728269790661339)
,p_name=>'PE.PROPERTY.SSP_ACCEPT_OLD_CHECKSUMS.PROMPT'
,p_message_text=>'Accept pre-20.2 URL Checksums'
,p_version_scn=>37166067046413
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295599955585065281)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_text=>'<p>Specify whether the data items are stacked.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295599890742065281)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_text=>'Stack'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91880425177759494)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_text=>'Specify the stack category name to assign this series to. By default, all series of a stacked chart are grouped together in the same stack. To group this series in a separate stack, set a stack category. You can utilize <code>&COLUMN_VALUE.</code> su'
||'bstitutions.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91880211187756189)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_text=>'Stack Category'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91856283427932981)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_text=>'<p>Specify whether the total values of stacked data items should be displayed. Only applies to bar charts.'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91856062531929353)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_text=>'Stack Label'
,p_version_scn=>37166067046364
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123089027722211772)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_text=>'Select a standard tab set used for this page. A standard tab set is associated with a specific page number. You can use standard tabs to link users to a specific page.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123088930576211772)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_text=>'Standard Tab Set'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388948611645781572)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the first day of the week displayed on the weekly calendar.',
'You can use this attribute in conjunction with <strong>End Day</strong> to restrict the days of the week displayed, or simply specify the first day of the week displayed.'))
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516843857122751738)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_text=>'Sunday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516843992926751738)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_text=>'Monday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844001759751738)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_text=>'Tuesday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844180180751738)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_text=>'Wednesday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844284111751739)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_text=>'Thursday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844307450751739)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_text=>'Friday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516844449341751739)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_text=>'Saturday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388948560927781572)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_text=>'Start Day'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388947759425781570)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_text=>'Determines the day of the week on which the monthly calendar starts.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516843186502751736)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_text=>'Sunday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516843218717751736)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_text=>'Monday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516843333198751736)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_text=>'Tuesday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516843491325751736)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_text=>'Wednesday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516843544249751736)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_text=>'Thursday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516843679414751737)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_text=>'Friday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516843774576751738)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_text=>'Saturday'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388947649388781570)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_text=>'Start Day'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388950889093781577)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_text=>'Enter the start hour to focus the display of the weekly and daily calendar.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388950747422781577)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_text=>'Start Hour'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116947260980909838)
,p_name=>'PE.PROPERTY.STATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The state of the workflow version.</p>',
'        <p>A workflow version when first created is always in the <strong>In Development</strong> state.</p>',
'        <p>Once the developer is satisfied with modelling a version, they can click on <strong>Activate</strong> to move the version to the <strong>Active</strong> state.</p>',
'        <p>Only one version of a workflow can be active at one time. Only one version of a workflow can be in development at one time.</p>',
'        <p>If the developer activates a version and a different version of the workflow is already active,',
'        then the currently active version will be silently <strong>deactivated</strong> before moving the version to <strong>Active</strong> state.</p>',
'        <p><strong>Inactive</strong> versions cannot be used to start new workflow instances. They can only be deleted or duplicated.</p>',
'        <p>When a Workflow Version is in <strong>Active</strong> state, only selected properties can be edited.',
'        <ul>',
'        <li><strong>Activities</strong> and <strong>connections</strong> cannot be created, duplicated, or deleted.</li>',
'        <li><strong>Variables</strong> cannot be created, duplicated, or deleted for the version.</li>',
'        <li><strong>Activity Variables</strong> can be added to and deleted from the activities in the version.</li>',
'        <li>The <strong>Type</strong> cannot be changed for activities. But the <strong>Source</strong> type and value can be changed for the version and its activities.</li>',
'        <li>The conditions for the connections of <strong>Switch</strong> activities can be changed.</li>',
'        <li>Workflow Participants can be added. But existing participants cannot be deleted.</li>',
'        </ul></p>',
'        <p>When a Workflow Version is in <strong>Inactive</strong> state, none of its properties, activities, and variables can be edited.</p> '))
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116947803647909839)
,p_name=>'PE.PROPERTY.STATE.LOV.ACTIVE.D'
,p_message_text=>'Active'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116947554666909839)
,p_name=>'PE.PROPERTY.STATE.LOV.DEVELOPMENT.D'
,p_message_text=>'In Development'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116948124399909839)
,p_name=>'PE.PROPERTY.STATE.LOV.INACTIVE.D'
,p_message_text=>'Inactive'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116946954026909838)
,p_name=>'PE.PROPERTY.STATE.PROMPT'
,p_message_text=>'State'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123146818994211874)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the jQuery Selector, of a static container, for use by this dynamic action.</p>',
'<p>You can improve the performance of dynamic actions that have an event scope of <strong>Dynamic</strong>.',
'This must be an element on the page that itself does not get recreated, but contains the triggering elements that are recreated using Partial Page Refresh (PPR).',
'This element reference needs to be defined as a jQuery selector.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123146704546211874)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_text=>'Static Container (jQuery Selector)'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295629898753065697)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_text=>'Enter the static ID for the chart axis. The static ID can be useful when developing custom JavaScript behavior for the chart axis.'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295629737716065695)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_text=>'Enter the static ID for the chart series. The static ID can be useful when developing custom JavaScript behavior for the chart series.'
,p_version_scn=>37166067046545
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117338069020910316)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.WORKFLOW.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Static ID for this workflow. The static ID is used when manually executing the workflow with',
'the <strong>APEX_WORKFLOW</strong> package (<strong>APEX_WORKFLOW.CREATE_WORKFLOW</strong>).'))
,p_version_scn=>37166067046558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123143729025211870)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_text=>'Enter a static ID to uniquely identify this component in API calls.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123143613271211870)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_text=>'Static ID'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333591274204933)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_text=>'Select the series type to be applied to the rendered stock chart.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333686329204933)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_text=>'Area'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333725447204933)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_text=>'Bar'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333862627204934)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_text=>'Candlestick'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333910489204934)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_text=>'Line'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337334066458204934)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_text=>'Line with Area'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(337333421650204932)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_text=>'Render As'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155336912192007959)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_text=>'Use Report Setting'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155337085405007960)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_text=>'The column will use the <strong>Stretch</strong> Report Setting set by the End User to define if the column should stretch or not.'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155336453269007762)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_text=>'Specify if the column should stretch if there is sufficient screen real estate. '
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155336795586007764)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155336837694007765)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_text=>'The column will always stretch, irrespective of the <strong>Stretch</strong> Report Setting set by the End User.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155336599486007763)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155336644667007763)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_text=>'The column will not stretch and always just use the width specified. This is useful for columns with short content like Yes/No or Numbers.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155336337170007761)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_text=>'Stretch'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380761374238410006)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether or not to remove HTML tags from the original column values.',
'This is particularly important for columns that utilize HTML expressions, are used in column links, or are exported to CSV files.</p>',
'<p>If you select values from the database that already contain HTML tags, then those tags can cause conflicts with the HTML generated for your HTML expressions or URL generated for column links.',
'When exporting such values, the existing HTML tags are included as plain text in the generated CSV file.',
'When this option is enabled, only the actual data portion of your column value is used.</p>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380761262022410006)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_text=>'Strip HTML'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69018525950027658)
,p_name=>'PE.PROPERTY.SUBENTRIES_LIST.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the list populating subentries for this list entry. Use this attribute if you are creating a hierarchical list.',
'<p>To create a hierarchical list, you must select a list template that supports hierarchical lists. To determine which list templates support hierarchical lists, look for templates having the naming convention "with Sublist." For more information on '
||'hierarchical list item display, see list template item help.'))
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69018405158027658)
,p_name=>'PE.PROPERTY.SUBENTRIES_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143583789629500633)
,p_name=>'PE.PROPERTY.SUBLIST_TEMPLATE_AFTER_ROWS.PROMPT'
,p_message_text=>'After Rows'
,p_version_scn=>37166067046439
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974695491481118)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to include checked rows in page processing, generally initiated by a custom button, such as <strong>Mark Completed</strong>.',
'        These checked rows can then be utilized in a custom process to perform the required action.</p>',
'        <p>Note - The selected rows will be processed even if nothing on the row has been updated. Generally, only rows which have been inserted, updated or deleted are processed.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245974513770481117)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_text=>'Submit Includes Selected Rows'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143604420705500647)
,p_name=>'PE.PROPERTY.SUBSCRIBE_COMPONENT_SETTINGS.PROMPT'
,p_message_text=>'Subscribe Component Settings'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143615960331500655)
,p_name=>'PE.PROPERTY.SUBSTITUTE_ATTRIBUTE_VALUES.PROMPT'
,p_message_text=>'Substitute Attribute Values'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242752398334661394)
,p_name=>'PE.PROPERTY.SUBSTITUTION_INSTALLATION_PROMPT.PROMPT'
,p_message_text=>'Installation prompt'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594370720500640)
,p_name=>'PE.PROPERTY.SUB_REGION_BODY_TEMPLATE.PROMPT'
,p_message_text=>'Template'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594251362500640)
,p_name=>'PE.PROPERTY.SUB_REGION_HEADER_ENTRY_TEMPLATE.PROMPT'
,p_message_text=>'Header Entry Template'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143594132827500640)
,p_name=>'PE.PROPERTY.SUB_REGION_HEADER_TEMPLATE.PROMPT'
,p_message_text=>'Header Template'
,p_version_scn=>37166067046446
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934389859296786)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_text=>'Specify whether this component displays using a column or advanced formatting using HTML expressions and supported substitution strings.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934284502296785)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_text=>'Advanced Formatting'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934562441296786)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_text=>'Select the column to be used as subtitle.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934483407296786)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596935060227296787)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934919390296787)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934891138296786)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Change the background and text colors</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Use Heading 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Use a dynamic class from the SQL query</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    The <code>&COLUMN_CLASS.</code> and <code>&EMPLOYEE_STATUS.</code> substitutions in this example are columns selected in the report SQL query.</dd>',
'  <dt>Show an image, and a tooltip on hover</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934736167296786)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_text=>'Enter HTML expressions to be shown in this column. Use <code>&COLUMN.</code> syntax to show column values in HTML.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934600696296786)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_text=>'HTML Expression'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361254616380487254)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the success message for this process.',
'If the process runs and does not generate an error, then this process success message displays in the notification section of the resulting page displayed.',
'If you are branching to another page via a URL redirect, you may need to check the <em>preserve success message</em> attribute.</p>',
'<p>For multi row processes, the following substitution string can be used to get the number of records processed:</p>',
'<ul>',
'  <li>Insert: <code>#MRI_COUNT#</code></li>',
'  <li>Update: <code>#MRU_COUNT#</code></li>',
'  <li>Delete: <code>#MRD_COUNT#</code></li>',
'</ul>',
'<p>For the Send E-Mail process type the substitution string <code>#TO#</code> can be used to get the addressees of the e-mail.</p>',
'<p>Plug-ins can have other substitution strings as well. See Plug-in documentation for details.</p>'))
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516258510425688210)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_text=>'Enter the text to be displayed in the "Notification" area (defined as part of the page template), when this process completes successfully.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361253902564487182)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_text=>'Success Message'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508286592670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL Query used as the source for the suggestions.</p>',
'<p>Note: The order in which the values are returned is used to determine the order they should get displayed.</p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508113602670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136508063573670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a comma delimited list of static values used as the source for the suggestions.</p>',
'<p>Note: The order in which the values are specified is used to determine the order they should get displayed.</p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507911892670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136510266635670635)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136510953692670633)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>37166067046549
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507248863670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how suggestions are determined for this filter.</p>',
'<p>Note: The values provided are still checked against the visible entries of the List of Values and will only be used if there is a match.',
'If a value is not found it will be skipped and the next one is checked.</p>'))
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507392789670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_text=>'Dynamic'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507469751670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_text=>'Picks the <strong>first</strong> visible entry from the List of Values.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507742247670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507800102670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'Values are returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507568925670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Values'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507663981670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Comma delimited list of values.'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136507179159670737)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(342545036297144820)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text that appears at the top of the download files. You can enter data classification, legal or warning messages about the data in the file.</p>',
'        <p> Note - The entered text will be included in all report download formats.  If CSV download is enabled, the defined text will invalidate the CSV file format.</p>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(342544712472144818)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_text=>'Supplemental Text'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627455632500665)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPLICATION_PAGE_ITEMS.D'
,p_message_text=>'Page Items'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143628019376500665)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPLICATION_PAGE_PROC.D'
,p_message_text=>'Page Processes'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143628147181500665)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPL_AUTOMATION_ACTIONS.D'
,p_message_text=>'Automation Actions'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627642523500665)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPL_PAGE_FACETS.D'
,p_message_text=>'Facets'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627769367500665)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPL_PAGE_FACET_GRP_ITEMS.D'
,p_message_text=>'Facet Group Items'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627507047500665)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPL_PAGE_IG_COLUMNS.D'
,p_message_text=>'Interactive Grid Columns'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627818354500665)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPL_PAGE_SFILTERS.D'
,p_message_text=>'Filters'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627909391500665)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPL_PAGE_SFILTER_GRP_ITEMS.D'
,p_message_text=>'Filter Group Items'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(259065411866273315)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPL_TASKDEF_ACTIONS.D'
,p_message_text=>'Task Definition Actions'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(259065588696273315)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.LOV.APEX_APPL_WORKFLOW_ACTIVITIES.D'
,p_message_text=>'Workflow Activities'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143627390814500664)
,p_name=>'PE.PROPERTY.SUPPORTED_FOR_COMPONENT_TYPE.PROMPT'
,p_message_text=>'Component Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1610332801496176)
,p_name=>'PE.PROPERTY.SUPPORTED_ITEM_TYPES.HELP'
,p_message_text=>'List of item types that are allowed in a given slot.'
,p_version_scn=>110249114
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1610282654496176)
,p_name=>'PE.PROPERTY.SUPPORTED_ITEM_TYPES.PROMPT'
,p_message_text=>'Item Types'
,p_version_scn=>110249114
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1610113556496176)
,p_name=>'PE.PROPERTY.SUPPORTED_REGION_TYPES.HELP'
,p_message_text=>'List of region types that are allowed in a given slot'
,p_version_scn=>110249113
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1610073529496176)
,p_name=>'PE.PROPERTY.SUPPORTED_REGION_TYPES.PROMPT'
,p_message_text=>'Region Types'
,p_version_scn=>110249113
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242691981116661306)
,p_name=>'PE.PROPERTY.SWITCH_AUTHENTICATION_IN_SESSION.PROMPT'
,p_message_text=>'Switch in Session'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116952969881909843)
,p_name=>'PE.PROPERTY.SWITCH_TYPE.PROMPT'
,p_message_text=>'Switch Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713220000661325)
,p_name=>'PE.PROPERTY.SYNCHRONIZATION_SCHEDULE.PROMPT'
,p_message_text=>'Schedule'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712826344661325)
,p_name=>'PE.PROPERTY.SYNCHRONIZATION_TYPE.LOV.APPEND.D'
,p_message_text=>'Append'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712998378661325)
,p_name=>'PE.PROPERTY.SYNCHRONIZATION_TYPE.LOV.MERGE.D'
,p_message_text=>'Merge'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713001786661325)
,p_name=>'PE.PROPERTY.SYNCHRONIZATION_TYPE.LOV.REPLACE.D'
,p_message_text=>'Full Refresh - Delete'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713196880661325)
,p_name=>'PE.PROPERTY.SYNCHRONIZATION_TYPE.LOV.TRUNCATE.D'
,p_message_text=>'Full Refresh - Truncate'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712782001661325)
,p_name=>'PE.PROPERTY.SYNCHRONIZATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713350524661325)
,p_name=>'PE.PROPERTY.SYNC_COMMIT_INTERVAL.PROMPT'
,p_message_text=>'Commit Interval'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360490714678274736)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_text=>'Specify this attribute if you want to use the column heading text as the label in the Detail View.'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360490617925274736)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_text=>'Use Column Heading'
,p_version_scn=>37166067046346
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713442710661325)
,p_name=>'PE.PROPERTY.SYNC_HTTP_REQUEST_LIMIT.PROMPT'
,p_message_text=>'HTTP Request Limit'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712480217661324)
,p_name=>'PE.PROPERTY.SYNC_JOB_IS_ACTIVE.PROMPT'
,p_message_text=>'Job is Active'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712646384661325)
,p_name=>'PE.PROPERTY.SYNC_LOCAL_TABLE_NAME.PROMPT'
,p_message_text=>'Local Table Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242712516836661325)
,p_name=>'PE.PROPERTY.SYNC_LOCAL_TABLE_OWNER.PROMPT'
,p_message_text=>'Local Table Owner'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713759636661326)
,p_name=>'PE.PROPERTY.SYNC_RATE_LIMIT_HTTP_REQUESTS.PROMPT'
,p_message_text=>'HTTP Requests'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713595255661325)
,p_name=>'PE.PROPERTY.SYNC_RATE_LIMIT_TIMEFRAME.PROMPT'
,p_message_text=>'Timeframe'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713602117661325)
,p_name=>'PE.PROPERTY.SYNC_RATE_LIMIT_TIMEFRAME.UNIT'
,p_message_text=>'seconds'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713930199661326)
,p_name=>'PE.PROPERTY.SYNC_WHEN_RATE_LIMIT_EXCEEDED.LOV.ERROR.D'
,p_message_text=>'Raise Error'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714052036661326)
,p_name=>'PE.PROPERTY.SYNC_WHEN_RATE_LIMIT_EXCEEDED.LOV.WAIT.D'
,p_message_text=>'Wait'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242713880474661326)
,p_name=>'PE.PROPERTY.SYNC_WHEN_RATE_LIMIT_EXCEEDED.PROMPT'
,p_message_text=>'When Exceeded'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380974574546206889)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the basis for this Tabular Form column.</p>',
'<p>The selection determines whether this column is updateable within the Tabular Form.',
'Updates can only be performed if a multiple row update is defined, or a PL/SQL process is implemented to process updated data.</p>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797322294751603)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_text=>'Date Picker'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826524748464187)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_text=>'Enter the date, or utilize the date picker to select the date.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797292757751603)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_text=>'Date Picker (Classic)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826601198464187)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_text=>'Enter the date, or utilize the date picker to select the date.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797168941751603)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_text=>'Plain Text (saves state)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825217162464179)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_text=>'Displays the column value, and saves in the value in session state. This column can be utilized in page processing.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798810397751607)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_text=>'Download BLOB'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825698839464181)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_text=>'Displays the column as a link to download the file.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798387302751606)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_text=>'Hidden'
,p_version_scn=>23756079
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826713163464188)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_text=>'Does not display the column, but it is referenceable.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797863269751604)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_text=>'Hidden (saves state)'
,p_version_scn=>23756079
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826817386464189)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_text=>'Does not display the column, but it is referenceable. This column can be utilized in page processing.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798768376751606)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_text=>'Display Image'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825551717464180)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_text=>'Displays the column as an image.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798612302751606)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_text=>'Link'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825479518464180)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_text=>'Displays the column as a link.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798920968751607)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_text=>'Percent Graph'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825776422464181)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_text=>'Displays the column as a percentage graph. The value retrieved must be between 0 and 100.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798482658751606)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_text=>'Plain Text'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825156042464178)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_text=>'Displays the column value.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798566095751606)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_text=>'Plain Text (based on List of Values)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825315697464179)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_text=>'Displays the value returned from the list of values specified.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797945019751604)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_text=>'Popup LOV (shows return value)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826256104464185)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_text=>'Select a value from the popup. The return value from the list of values is shown.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798078250751604)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_text=>'Popup LOV (shows displays value)'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826116865464183)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_text=>'Select a value from the popup. The display value from the list of values is shown.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797799106751604)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_text=>'Radio Group'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826361131464186)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_text=>'Select a single radio group from the list of values specified.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798238006751606)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_text=>'Row Selector'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825084400464178)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_text=>'Includes a checkbox at the beginning of each row.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797604484751604)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_text=>'Select List'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826095570464183)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_text=>'Select a value from the list of values specified.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516798196733751605)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_text=>'Simple Checkbox'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599826496279464187)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_text=>'Check or uncheck a single checkbox.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797407626751604)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_text=>'Text Field'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825899407464182)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_text=>'Enter a value into a text field.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516797545302751604)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_text=>'Text Area'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599825959741464182)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_text=>'Enter a value into a text area field.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380974476467206888)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155911321193354791)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_text=>'Click the Target to invoke a modal dialog. You can enter the target that is called when this branch is invoked.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155911231309354791)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_text=>'Target'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709902308661322)
,p_name=>'PE.PROPERTY.TARGET_COLLECTION.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709772949661322)
,p_name=>'PE.PROPERTY.TARGET_OWNER.PROMPT'
,p_message_text=>'Table Owner'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709842209661322)
,p_name=>'PE.PROPERTY.TARGET_TABLE.PROMPT'
,p_message_text=>'Table Name'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709604195661322)
,p_name=>'PE.PROPERTY.TARGET_TYPE.LOV.COLLECTION.D'
,p_message_text=>'Collection'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709510969661322)
,p_name=>'PE.PROPERTY.TARGET_TYPE.LOV.TABLE.D'
,p_message_text=>'Table'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242709455816661322)
,p_name=>'PE.PROPERTY.TARGET_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747245162661362)
,p_name=>'PE.PROPERTY.TASK_DEF_PARAM.HELP'
,p_message_text=>'Show the name of the parameter of a Task Definition.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242747184201661362)
,p_name=>'PE.PROPERTY.TASK_DEF_PARAM.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242725699895661336)
,p_name=>'PE.PROPERTY.TASK_DETAILS_PAGE.PROMPT'
,p_message_text=>'Details Page'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724633615661336)
,p_name=>'PE.PROPERTY.TASK_PARAM_DATA_TYPE.LOV.DATE.D'
,p_message_text=>'Date'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724558202661335)
,p_name=>'PE.PROPERTY.TASK_PARAM_DATA_TYPE.LOV.NUMBER.D'
,p_message_text=>'Number'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724431447661335)
,p_name=>'PE.PROPERTY.TASK_PARAM_DATA_TYPE.LOV.VARCHAR2.D'
,p_message_text=>'String'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724397417661335)
,p_name=>'PE.PROPERTY.TASK_PARAM_DATA_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242724887703661336)
,p_name=>'PE.PROPERTY.TASK_SUBJECT.PROMPT'
,p_message_text=>'Subject'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169933946116911832)
,p_name=>'PE.PROPERTY.TASK_TYPE.LOV.ACTION.D'
,p_message_text=>'Action Task'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169933836350911832)
,p_name=>'PE.PROPERTY.TASK_TYPE.LOV.APPROVAL.D'
,p_message_text=>'Approval Task'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169933719304911832)
,p_name=>'PE.PROPERTY.TASK_TYPE.PROMPT'
,p_message_text=>'Task Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1606315305537456)
,p_name=>'PE.PROPERTY.TASK_VACATION_RULE_PROCEDURE.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>',
'This example shows a vacation rule procedure implementation where SCOTT is added as an alternate participant as JANE',
'would be on maternity leave.</p>',
'<pre>',
'',
'    procedure alternate_job_approvers(',
'                p_param    in apex_approval.t_vacation_rule_input,',
'                p_result  out apex_approval.t_vacation_rule_result)',
'    is',
'        l_result            apex_approval.t_vacation_rule_result;',
'        l_changes           apex_approval.t_task_participant_changes;',
'        l_participants      apex_approval.t_task_participants;',
'        l_new_participant   apex_approval.t_task_participant;',
'        l_old_participant   apex_approval.t_task_participant;',
'        l_has_changed       boolean                             := false;',
'        l_index             pls_integer                         := 1;',
'    begin',
'        l_participants := p_param.original_participants;',
'        for i in 1..l_participants.count loop',
'            if l_participants(i).value = ''JANE'' then',
'                l_old_participant               :=  l_participants(i);',
'                l_new_participant.value         := ''SCOTT'';',
'                l_new_participant.type          := ''POTENTIAL_OWNER'';',
'                l_new_participant.identity      := ''USER'';',
'                l_has_changed                   := true;',
'            end if;',
'        end loop;',
'        if l_has_changed then',
'            l_changes(l_index).old_participant   := l_old_participant;',
'            l_changes(l_index).new_participant   := l_new_participant;',
'            l_changes(l_index).change_reason     := ''Jane is out on maternity leave'';',
'        end if;',
'        l_result.participant_changes            := l_changes;',
'        l_result.has_participant_changes        := l_has_changed;',
'        p_result                                := l_result;',
'    end;',
'</pre>'))
,p_version_scn=>1112210301
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600504756003435)
,p_name=>'PE.PROPERTY.TASK_VACATION_RULE_PROCEDURE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Specify the name of a PL/SQL procedure in the format <strong>schemaName.packageName.procedureName</strong>.',
'The procedure is expected to return alternate participants for this task definitions.',
'The vacation rule procedure should implement the following interface.</p>',
'<pre>',
'    procedure my_vacation_rule (',
'        p_param    in apex_approval.t_vacation_rule_input,',
'        p_result  out apex_approval.t_vacation_rule_output );',
'</pre>',
'<p>The procedure input is of type <strong>apex_approval.t_vacation_rule_input</strong> and the result output is of type <strong>apex_approval.t_vacation_rule_output</strong> </p>'))
,p_version_scn=>27652091
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600470135003434)
,p_name=>'PE.PROPERTY.TASK_VACATION_RULE_PROCEDURE.PROMPT'
,p_message_text=>'Task Vacation Rule Procedure Name'
,p_version_scn=>27609748
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242659276052661088)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.HELP'
,p_message_text=>'Select how this parameter is populated.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78371272056037995)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78371319189037996)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>Expression</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78371423061037996)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78371507457037996)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242659549339661088)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242659699628661088)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242660586512661089)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242660628623661089)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.NULL.HELP'
,p_message_text=>'Set to null as no value specified.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242660346063661089)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_text=>'Preference'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242660439049661089)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_text=>'Set to the value of the <em>Preference</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242659717113661088)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242659823719661088)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242659330765661088)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242659466450661088)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Set to the text entered into <em>Static Value</em>.'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242659153635661088)
,p_name=>'PE.PROPERTY.TASK_VALUE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971846804250228)
,p_name=>'PE.PROPERTY.TEMPLATE_COMPONENT_TYPE.HELP'
,p_message_text=>'Select how the data should be displayed.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972137717250228)
,p_name=>'PE.PROPERTY.TEMPLATE_COMPONENT_TYPE.LOV.PARTIAL.D'
,p_message_text=>'Single (Partial)'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972244945250228)
,p_name=>'PE.PROPERTY.TEMPLATE_COMPONENT_TYPE.LOV.PARTIAL.HELP'
,p_message_text=>'Only one partial is rendered based on the single row the region source returns.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5400136115670640)
,p_name=>'PE.PROPERTY.TEMPLATE_COMPONENT_TYPE.LOV.REGION_ONLY.D'
,p_message_text=>'Region Only'
,p_version_scn=>109169349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5400214231670656)
,p_name=>'PE.PROPERTY.TEMPLATE_COMPONENT_TYPE.LOV.REGION_ONLY.HELP'
,p_message_text=>'A single partial based on the values from the attributes.'
,p_version_scn=>109169352
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971937021250228)
,p_name=>'PE.PROPERTY.TEMPLATE_COMPONENT_TYPE.LOV.REPORT.D'
,p_message_text=>'Multiple (Report)'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115972022443250228)
,p_name=>'PE.PROPERTY.TEMPLATE_COMPONENT_TYPE.LOV.REPORT.HELP'
,p_message_text=>'A report with pagination controls is rendered based on the rows returned by the region source.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115971787153250228)
,p_name=>'PE.PROPERTY.TEMPLATE_COMPONENT_TYPE.PROMPT'
,p_message_text=>'Display'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143574979536500626)
,p_name=>'PE.PROPERTY.TEMPLATE_IDENTIFIER.PROMPT'
,p_message_text=>'Identifier'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589935513845301675)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select template options to customize the user interface of this component.</p>',
'<p>You can also modify the template options when running the application using <strong>Live Template Options</strong>.',
'Live Template Options enables you to customize your application in real time, allowing you to preview and apply various options.',
'To access Live Template Options, run the application from Application Builder and click <em>Quick Edit</em> in the developer toolbar.',
'Hover over a page component, such as a region, and click the wrench icon ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) displayed in the top left corner.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589935451128301675)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589935740682301676)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select template options to customize the user interface of this component.</p>',
'<p>You can also modify the template options when running the application using <strong>Live Template Options</strong>.',
'Live Template Options enables you to customize your application in real time, allowing you to preview and apply various options.',
'To access Live Template Options, run the application from Application Builder and click <em>Quick Edit</em> in the developer toolbar.',
'Hover over a page component, such as a region, and click the wrench icon ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) displayed in the top left corner.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589935674491301675)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_text=>'Template Options'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635376699500670)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_GROUP.PROMPT'
,p_message_text=>'Group'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634913427500669)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_TYPE.LOV.BREADCRUMB.D'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634350915500669)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_TYPE.LOV.BUTTON.D'
,p_message_text=>'Button'
,p_version_scn=>37166067046452
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634464155500669)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_TYPE.LOV.FIELD.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634786965500669)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_TYPE.LOV.LIST.D'
,p_message_text=>'List'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634887927500669)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_TYPE.LOV.PAGE.D'
,p_message_text=>'Page'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634573573500669)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_TYPE.LOV.REGION.D'
,p_message_text=>'Region'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634663223500669)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_TYPE.LOV.REPORT.D'
,p_message_text=>'Report'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143634271873500669)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_TYPE.PROMPT'
,p_message_text=>'Template Type'
,p_version_scn=>37166067046452
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635069642500669)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTION_TYPE_HIDDEN.PROMPT'
,p_message_text=>'Template Type'
,p_version_scn=>37166067046453
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636205821500670)
,p_name=>'PE.PROPERTY.TEMPLATE_SUBSTITUTION.PROMPT'
,p_message_text=>'Template Substitution'
,p_version_scn=>37166067046454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143572601660500625)
,p_name=>'PE.PROPERTY.TEMPLATE_TRANSLATABLE.PROMPT'
,p_message_text=>'Translatable'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380757548766409999)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_text=>'Select the template type for this report.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794049007751592)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_text=>'Predefined'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516794178548751592)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_text=>'Predefined report templates which are not associated directly with any themes. Because there is no correlation between these predefined templates and your current theme, your report layout remains the same even if you change the application theme.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793849006751591)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_text=>'Theme'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516793909232751591)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_text=>'Report templates available in the corresponding theme.'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380757450064409999)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_text=>'Template Type'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000197237831235)
,p_name=>'PE.PROPERTY.TERMINATION_FUNCTION_NAME.PROMPT'
,p_message_text=>'Termination Function Name'
,p_version_scn=>6572832
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494647487272153)
,p_name=>'PE.PROPERTY.TEXT_MESSAGE_SUBSCRIBED_FROM.HELP'
,p_message_text=>'Use this field to base this text message on an existing text message in another application in your workspace.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494536364272153)
,p_name=>'PE.PROPERTY.TEXT_MESSAGE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1429536945413068)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.COMPONENT_PROPERTY.APPLICATION.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>20194532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1429662953413143)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.COMPONENT_PROPERTY.SEARCH_CONFIG.NULL_TEXT'
,p_message_text=>'None'
,p_version_scn=>20194558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6576437507224674)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>The Oracle Text query syntax is very complex and powerful and provides a rich set of query operators to deal with wildcards, stemming, fuzzy searches and so forth. For end users, this syntax is often hard to understand. To simplify the search proc'
||'ess for users, you can select a function that automatically converts simple end user input into an Oracle Text query, with the advanced search features applied automatically. Select the Text Query Function type to use.'))
,p_version_scn=>20179872
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6576974905224685)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.LOV.CUSTOM.D'
,p_message_text=>'Custom'
,p_version_scn=>22278504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6577071069224685)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.LOV.CUSTOM.HELP'
,p_message_text=>'Provide a custom function.'
,p_version_scn=>22278504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6576530455224684)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.LOV.EXPERT_SEARCH.D'
,p_message_text=>'Expert Search'
,p_version_scn=>22278504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6576625853224685)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.LOV.EXPERT_SEARCH.HELP'
,p_message_text=>'This function supports more advanced search operators for precise queries. It allows exact matching, Boolean operators (AND, OR, NOT), precedence with parentheses and proximity search. Additional parameters allow customizing search behavior. This is '
||'best when requiring highly accurate results from very specific queries. Also see the <code>QUERY_EXPERT_SEARCH</code> function within the <code>APEX_SEARCH</code> package.'
,p_version_scn=>20179872
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6576749461224685)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_text=>'Search Engine'
,p_version_scn=>22278504
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6576852972224685)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.LOV.SEARCH_ENGINE.HELP'
,p_message_text=>'This function performs a query relaxation search to retrieve relevant results beyond just exact matches. The goal is to get as many related results as possible, allowing users to easily find related information without needing to input precise querie'
||'s. The search process begins with an exact match search and then progressively relaxes the query using techniques like stemming and fuzzy matching. While maximizing the number of results, the search engine function ensures that the most exact and rel'
||'evant matches are always ranked at the top of the search results.'
,p_version_scn=>42020677
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6576346537223643)
,p_name=>'PE.PROPERTY.TEXT_QUERY_FUNCTION_TYPE.PROMPT'
,p_message_text=>'Text Query Function'
,p_version_scn=>42020677
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945736635917064100)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Depending on the <strong>Search Type</strong> specified, enter one, or a list of database column names that are used for text search.</p>',
'<ul>',
'  <li><strong>Row Search</strong>: Enter a comma delimited list of case sensitive database column names of type VARCHAR2 used for text search. If no column is specified, all VARCHAR2 columns will automatically be used.</li>',
'  <li><strong>Oracle Text</strong>: Enter the case sensitive database column name which contains the Oracle Text index.</li>',
'</ul>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945736566699064100)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_text=>'Database Column(s)'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183239626317033866)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_text=>'Select the theme to associate with the current application.'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183239514105033866)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_text=>'Theme'
,p_version_scn=>37166067046340
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633446222500668)
,p_name=>'PE.PROPERTY.THEME_ICON_LIBRARY.LOV.FONTAPEX.D'
,p_message_text=>'Font APEX'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633538607500669)
,p_name=>'PE.PROPERTY.THEME_ICON_LIBRARY.LOV.FONTAPEX_LATEST.D'
,p_message_text=>'Font APEX - Latest'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143633323587500668)
,p_name=>'PE.PROPERTY.THEME_ICON_LIBRARY.PROMPT'
,p_message_text=>'Library'
,p_version_scn=>37166067046451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143629462131500666)
,p_name=>'PE.PROPERTY.THEME_NUMBER.PROMPT'
,p_message_text=>'Theme Number'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635925645500670)
,p_name=>'PE.PROPERTY.THEME_ROLLER_INPUT_FILE_URLS.PROMPT'
,p_message_text=>'Input Parameter File URLs'
,p_version_scn=>37166067046454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143636006944500670)
,p_name=>'PE.PROPERTY.THEME_ROLLER_OUTPUT_FILE_URL.PROMPT'
,p_message_text=>'Output CSS File URL'
,p_version_scn=>37166067046454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635856378500670)
,p_name=>'PE.PROPERTY.THEME_ROLLER_READ_ONLY.PROMPT'
,p_message_text=>'Read Only'
,p_version_scn=>37166067046454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242748056613661390)
,p_name=>'PE.PROPERTY.THEME_STYLE_BY_USER_PREF.PROMPT'
,p_message_text=>'Enable End Users to choose Theme Style'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143635713427500670)
,p_name=>'PE.PROPERTY.THEME_STYLE_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3131542917259355)
,p_name=>'PE.PROPERTY.THEME_VERSION.HELP'
,p_message_text=>'<p>String to identify the version of the theme.'
,p_version_scn=>29924187
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3131433044259353)
,p_name=>'PE.PROPERTY.THEME_VERSION.PROMPT'
,p_message_text=>'Version'
,p_version_scn=>29924186
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628522420065383)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_text=>'Select the position of the tick labels relative to the plot area.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628746880065384)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_text=>'Inside'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628625222065383)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_text=>'Outside'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628416282065383)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_text=>'Position'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604206892784551)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.COMPONENT_PROPERTY.JET_CHART_AXES.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Tick labels can be important for accessibility depending on the context and the users needs.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Contextual Understanding:</strong> In some cases, the presence of tick labels can provide valuable context or assist in understanding the data visualization, even for users who are not visually impaired. For example, they can help users i'
||'nterpret trends, identify specific data points, or understand the scale of the visualization.</li>',
'</ul>',
'<p>Tick labels can play an important role in accessibility, particularly for visually impaired users relying on screen readers.</p>'))
,p_version_scn=>36587335
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628150746065382)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_text=>'Specify whether the tick labels are rendered.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628070144065381)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_text=>'Show'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628369973065382)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether the chart will automatically rotate the labels by 90 degrees in order to fit more labels on the axis.',
'        The rotation will only be applied to categorical labels for a horizontal axis.'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295628204935065382)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_text=>'Rotation'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567456965968315682)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_text=>'Same as Standard'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617257749575049666)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_text=>'Use the same background map for light and dark mode.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417978364648833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_text=>'Choose the tile layer to use as the background map when dark mode is enabled.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418821215648836)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_text=>'Oracle BI World Map'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418919011648837)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Non-obtrusive base map based on HERE Map data. This base map style provides location context for your data and accentuates visualization of your data.</p>',
'<p>Style schema and definitions by Oracle, USA.</p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418471582648836)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_text=>'OpenStreetMap Bright'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418538646648836)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>General purpose basemap based on OpenStreetMap data. This basemap style provides detailed location context for your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">View on GitHub</a></p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418024234648833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_text=>'OpenStreetMap Dark'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418166095648833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>Non-obtrusive light basemap based on OpenStreetMap data. This basemap style accentuates visualizations of your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license. Cartography by Stamen Design is licensed under CC0.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">View on GitHub</a></p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418282565648833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_text=>'OpenStreetMap Positron'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418312246648834)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Non-obtrusive dark basemap based on OpenStreetMap data. This basemap style accentuates visualizations of your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license. Cartography by Stamen Design is licensed under CC0.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">View on GitHub</a></p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418625143648836)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_text=>'Oracle World Map'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563418732891648836)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>General purpose basemap based on HERE Map data. This base map style provides location context for your data and accentuates visualization of your data.</p>',
'<p>Style schema and definitions by Oracle, USA.</p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417835088648833)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_text=>'Dark Mode'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416755217648832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_text=>'Choose the tile layer to use as the background map.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417671023648833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_text=>'Oracle BI World Map'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417755454648833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Non-obtrusive base map based on HERE Map data. This base map style provides location context for your data and accentuates visualization of your data.</p>',
'<p>Style schema and definitions by Oracle, USA.</p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417242365648832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_text=>'OpenStreetMap Bright'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417340108648832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<p>General purpose basemap based on OpenStreetMap data. This basemap style provides detailed location context for your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">View on GitHub</a></p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417076462648832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_text=>'OpenStreetMap Dark'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417193680648832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Non-obtrusive dark basemap based on OpenStreetMap data. This basemap style accentuates visualizations of your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license. Cartography by Stamen Design is licensed under CC0.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">View on GitHub</a></p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416866455648832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_text=>'OpenStreetMap Positron'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416925579648832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Non-obtrusive light basemap based on OpenStreetMap data. This basemap style accentuates visualizations of your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license. Cartography by Stamen Design is licensed under CC0.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">View on GitHub</a></p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417492483648833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_text=>'Oracle World Map'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563417528279648833)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>General purpose basemap based on HERE Map data. This base map style provides location context for your data and accentuates visualization of your data.</p>',
'<p>Style schema and definitions by Oracle, USA.</p>'))
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416667729648832)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_text=>'Standard'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416129816648831)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_text=>'Select the background map to use.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416429361648831)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_text=>'Built-In'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416539215648832)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_text=>'Pick the map tile layers to use for the background map.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416266735648831)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_text=>'Default'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416357171648831)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_text=>'Use default background map settings.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139864052832148564)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.SHARED.D'
,p_message_text=>'Shared Component'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139864148268148564)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.SHARED.HELP'
,p_message_text=>'Select the custom map tile layers from the shared components to use as a background map.'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563416091846648829)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_text=>'Background'
,p_version_scn=>37166067046421
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388950409874781576)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_text=>'Select how to display the time format.'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845229846751741)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_text=>'12 Hour'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516845397990751741)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_text=>'24 Hour'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388950384495781576)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_text=>'Time Format'
,p_version_scn=>37166067046355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1093425604750839605)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_text=>'Enter a title for the axis. This title describes the information being represented on the axis of your chart.'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1600287699784504)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Page titles are crucial for helping all users understand the purpose of a page, especially those using assistive technology like screen readers. Since the page title is often the first thing heard by a screen reader user, it''s essential to make su'
||'re every page title is meaningful and unique.</p>',
'<p>Best Practices:</p>',
'<ol>',
'<li>Clear and Descriptive:',
'Use specific titles like "Understanding WCAG 2.1" or section titles for easy navigation.</li>',
'<li>Effective:',
'Consider the following example: For a Form page, include relevant information like the record being edited, such as "Create / Edit Customer: [customer name]." Follow these steps in Page Designer:',
'<ol>',
'<li>Select the page in the Rendering tree.</li>',
'<li>In the Property Editor, locate the Identification - Title field.</li>',
'<li>Replace P1_CUSTOMER_NAME with the appropriate page item containing the record identifier.</li>',
'<li>Enter the title format as Create / Edit Customer: &P1_CUSTOMER_NAME. (include the period).</li>',
'</ol>',
'</li>',
'</ol>',
'<p>Implementing descriptive page and regions titles significantly enhances accessibility, enabling seamless navigation and content understanding for users across diverse web environments.</p>'))
,p_version_scn=>12189379
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123169824414211912)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a title that will be displayed in the title bar of the browser window, and announced to screen reader users when they first open the page.',
'        The &PRODUCT_NAME. engine uses the title you specify here in place of the <code>#TITLE#</code> substitution string used in the page template. This title is inserted between the',
'        HTML tags <code>&lt;TITLE&gt;</code> and <code>&lt;/TITLE&gt;</code>.</p>',
'        <p>A good page title should provide a clear and concise description of the purpose of the page, can include the application name and sub-section of the application for additional',
'        context, and should always include the most important, and unique information first. For example, if you have a ''Products'' page in an ''Administration'' section of a ''Customer Portal''',
'        application, the page title could be defined as ''Products | Admin | Customer Portal''.</p>'))
,p_version_scn=>37166067046492
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123171611069211914)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_text=>'Enter a region title. The region title is optional, it only displays when it is defined in the region template.'
,p_version_scn=>76038960
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117338314560910316)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.WORKFLOW.HELP'
,p_message_text=>'User friendly title of this workflow.'
,p_version_scn=>37166067046558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123089200477211772)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_text=>'Enter the page title. The page title is displayed in the title bar of the browser window.'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123089105321211772)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_text=>'Title'
,p_version_scn=>37166067046327
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933449416296784)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_text=>'Specify whether this component displays using a column or advanced formatting using HTML expressions and supported substitution strings.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933317809296784)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_text=>'Advanced Formatting'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933654422296784)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_text=>'Select the column to be used as title.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933512411296784)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934152543296785)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_text=>'Enter classes to add to this component. You may add multiple classes by separating them with spaces.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596934002564296784)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_text=>'CSS Classes'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933944193296784)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Change the background and text colors</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Use Heading 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Use a dynamic class from the SQL query</dt>',
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    The <code>&COLUMN_CLASS.</code> and <code>&EMPLOYEE_STATUS.</code> substitutions in this example are columns selected in the report SQL query.</dd>',
'  <dt>Show an image, and a tooltip on hover</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933818460296784)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_text=>'Enter HTML expressions to be shown in this column. Use <code>&COLUMN.</code> syntax to show column values in HTML.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(596933719730296784)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_text=>'HTML Expression'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242720297369661332)
,p_name=>'PE.PROPERTY.TOKENIZE_ROW_SEARCH.PROMPT'
,p_message_text=>'Tokenize'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256955687507792442)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_text=>'Check which additional controls are to be displayed in the toolbar.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956139121792442)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_text=>'Actions Menu'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956264976792442)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_text=>'Displays the Actions menu button, which generally includes a comprehensive set of options. These options enables the end user to customize the report based upon the functions you make available.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956370149792442)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_text=>'Reset Button'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956401405792443)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_text=>'Displays the Reset button. When this button is pressed, any customizations, such as filters, column width, and ordering will be removed, and the report definition will be reloaded from the server.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956503955792443)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_text=>'Save Button'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956660152792446)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Displays the Save button. When this button is pressed, only changes made to this Interactive Grid will be saved, without needing to save the whole page.',
'        <p>The save button will only be displayed when the Interactive Grid is editable, and the end user has authorization to add, update or delete.</p>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256955795910792442)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_text=>'Search Column Selection'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256955894886792442)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_text=>'Displays a drop down list of displayed non-numeric columns. If a column is selected then the search is only performed against the values in the selected column.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256955982487792442)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_text=>'Search Field'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256956002569792442)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_text=>'Displays a text field in the search bar used to enter search criteria.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256955593474792442)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_text=>'Controls'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116950548048909841)
,p_name=>'PE.PROPERTY.TO_WORKFLOW_ACTIVITY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Specify the To activity for this connection.'))
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116950229146909841)
,p_name=>'PE.PROPERTY.TO_WORKFLOW_ACTIVITY.PROMPT'
,p_message_text=>'To'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708151005661321)
,p_name=>'PE.PROPERTY.TRANSFORMATION_FIND.PROMPT'
,p_message_text=>'Find'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708420586661321)
,p_name=>'PE.PROPERTY.TRANSFORMATION_NULLIF.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708247743661321)
,p_name=>'PE.PROPERTY.TRANSFORMATION_REGEXP.PROMPT'
,p_message_text=>'Regular Expression'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708342163661321)
,p_name=>'PE.PROPERTY.TRANSFORMATION_REPLACE_WITH.PROMPT'
,p_message_text=>'Replace With'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242708046119661321)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TRIM_CHARS.PROMPT'
,p_message_text=>'Trim Characters'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707584448661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.LOV.LOWER.D'
,p_message_text=>'To Lower Case'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707162736661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.LOV.LTRIM.D'
,p_message_text=>'Left Trim'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707712171661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.LOV.NULLIF.D'
,p_message_text=>'Null If'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707973330661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.LOV.REGEXP_NULLIF.D'
,p_message_text=>'Regular Expression Null If'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707851439661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.LOV.REGEXP_REPLACE.D'
,p_message_text=>'Regular Expression Replace'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707436670661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.LOV.REPLACE.D'
,p_message_text=>'Replace'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707221459661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.LOV.RTRIM.D'
,p_message_text=>'Right Trim'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707332168661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.LOV.TRIM.D'
,p_message_text=>'Trim'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707613733661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.LOV.UPPER.D'
,p_message_text=>'To Upper Case'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242707054638661320)
,p_name=>'PE.PROPERTY.TRANSFORMATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116951110920909841)
,p_name=>'PE.PROPERTY.TRANSITION_TYPE.HELP'
,p_message_text=>'<p>Select the type of connection.</p>'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116951781096909842)
,p_name=>'PE.PROPERTY.TRANSITION_TYPE.LOV.ERROR.D'
,p_message_text=>'Error'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(252759449322830290)
,p_name=>'PE.PROPERTY.TRANSITION_TYPE.LOV.ERROR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Every activity can have one or more error connections for handling of errors.</p>',
'        <p> Every error connection must include the following properties.',
'        <ul>',
'        <li>Condition Value    - This is the SQL Error Code with which the activity error is compared.</li>',
'        <li>Condition Operator - This is operator used for the comparison.</li>',
'        <li>Sequence           - For multiple error connections, this property defines the order of comparison.</li>',
'        </ul>',
'        </p> '))
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116951416317909842)
,p_name=>'PE.PROPERTY.TRANSITION_TYPE.LOV.NORMAL.D'
,p_message_text=>'Normal'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(252759337014830290)
,p_name=>'PE.PROPERTY.TRANSITION_TYPE.LOV.NORMAL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The default connection between two activities.</p>',
'        <p>Every workflow activity must have one incoming and one outgoing normal connection.</p>',
'        <p>The only exceptions are activities of type <strong>Workflow Start</strong>, <strong>Workflow Switch</strong> and <strong>Workflow End</strong>.',
'        <ul>',
'        <li>The Workflow Start activity cannot have any incoming connection.</li>',
'        <li>The Workflow End activity cannot have any outgoing connection.</li>',
'        <li>The Workflow Switch activity has conditional connections also known as <strong>branches</strong>.</li>',
'        <li>The connection type for a branch depends on the Type of the Switch activity. It cannot be selected from here.</li>',
'        </ul></p>'))
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116952007706909842)
,p_name=>'PE.PROPERTY.TRANSITION_TYPE.LOV.TIMEOUT.D'
,p_message_text=>'Timeout'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169934044360911872)
,p_name=>'PE.PROPERTY.TRANSITION_TYPE.LOV.TIMEOUT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available only if the <strong>From</strong> activity has the <em>Due On Type</em> attribute defined.</p>',
'        <p>Not available for the <strong>Wait</strong> Activity because it already has its own timeout property.</p>'))
,p_version_scn=>15114758
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116950828287909841)
,p_name=>'PE.PROPERTY.TRANSITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663839989661232)
,p_name=>'PE.PROPERTY.TRANSLATE_FROM_TEXT.HELP'
,p_message_text=>'Enter the text in the primary language to be translated.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242663790450661232)
,p_name=>'PE.PROPERTY.TRANSLATE_FROM_TEXT.PROMPT'
,p_message_text=>'Translate from Text'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143605265303500648)
,p_name=>'PE.PROPERTY.TRANSLATE_TEMPLATES.PROMPT'
,p_message_text=>'Translate Templates'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665243778661235)
,p_name=>'PE.PROPERTY.TRANSLATE_TO_TEXT.HELP'
,p_message_text=>'Enter the translated text in the target language.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242665188150661235)
,p_name=>'PE.PROPERTY.TRANSLATE_TO_TEXT.PROMPT'
,p_message_text=>'Translate to Text'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693465799661307)
,p_name=>'PE.PROPERTY.TRANSLATE_USER_DEFINED_ATTRIBUTES.PROMPT'
,p_message_text=>'Translatable'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690147265661304)
,p_name=>'PE.PROPERTY.TRANSLATION_APPLICATION_ID.PROMPT'
,p_message_text=>'Translation Application'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(630575902938467587)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(599371146585282305)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_text=>'Tree Query'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(630576248536467587)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361846902718139166)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_text=>'Indicates whether or not this column is timezone aware.'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361846832305139166)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_text=>'Timezone Aware'
,p_version_scn=>37166067046349
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381134335754191222)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the column name that this report column references.',
'This attribute is used to compare references to columns across applications using UI Defaults.',
'This reference is maintained manually, after being initialized by a wizard, whenever possible.'))
,p_version_scn=>19132244
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381134252177191222)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381134125485191222)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the table or view that this column references.',
'This attribute is used to compare references to columns across applications using UI Defaults.',
'This reference is maintained manually, after being initialized by a wizard, whenever possible.'))
,p_version_scn=>19132244
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381134045203191222)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_text=>'Table Name'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381133985727191222)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the schema that owns the reference table.',
'This attribute is used to compare references to columns across applications using UI Defaults.',
'This reference is maintained manually, after being initialized by a wizard, whenever possible.'))
,p_version_scn=>19132244
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381133823874191222)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_text=>'Table Owner'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242721198184661332)
,p_name=>'PE.PROPERTY.UNAVAILABLE_MESSAGE.PROMPT'
,p_message_text=>'Message'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360872201681183857)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the type of column used to identify the current row when utilizing the link column.',
'By default, <strong>ROWID</strong> is used to uniquely identify rows in a report. However, you can also utilize another column by selecting <strong>Unique Column</strong>.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516781927724751544)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_text=>'Unique Column'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516781831421751544)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_text=>'ROWID'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360872114872183857)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_text=>'Uniquely Identify Rows by'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360872616011183857)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the first column used to uniquely identify rows for this component.</p>',
'<p><strong>ROWID</strong> is also included in the list of available columns for backward compatibility.</p>',
'<p>Note: For an interactive report with the <em>Link Column</em> attribute set to <strong>Link to Single Row View</strong>, only a single unique column can be selected. Other components support the selection of up to three columns.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360872528407183857)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_text=>'Unique Column'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360872832048183857)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the second column to be used to uniquely identify rows for this component. Use this attribute when your table has a two-part primary key.</p>',
'<p><strong>ROWID</strong> is also included in the list of available columns for backward compatibility.</p>'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360872723317183857)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_text=>'Unique Column 2'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360873021218183857)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the third column to be used to uniquely identify rows for this component. Use this attribute when your table has a three-part primary key.</p>',
'<p><strong>ROWID</strong> is also included in the list of available columns for backward compatibility.</p>',
'<p>Note: If your table''s primary key has more than three columns, then you need to uniquely identify rows by <strong>ROWID</strong>.'))
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360872902979183857)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_text=>'Unique Column 3'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973408441481113)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select an authorization scheme to restrict who can update rows.',
'In order for an end user to update rows, this authorization scheme must evaluate to TRUE for that user.',
'If no authorization scheme is provided then any user can update rows in this interactive grid.'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245973342965481113)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_text=>'Update'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754616575661396)
,p_name=>'PE.PROPERTY.UPGRADE_CONFIRMATION_MESSAGE.PROMPT'
,p_message_text=>'Confirmation'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754856353661396)
,p_name=>'PE.PROPERTY.UPGRADE_FAILURE_MESSAGE.PROMPT'
,p_message_text=>'Failure'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754745892661396)
,p_name=>'PE.PROPERTY.UPGRADE_SUCCESS_MESSAGE.PROMPT'
,p_message_text=>'Success'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242754537374661396)
,p_name=>'PE.PROPERTY.UPGRADE_WELCOME_MESSAGE.PROMPT'
,p_message_text=>'Welcome'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242711707232661324)
,p_name=>'PE.PROPERTY.URL_PATH_PREFIX.PROMPT'
,p_message_text=>'URL Path Prefix'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242715284483661327)
,p_name=>'PE.PROPERTY.URL_PATTERN.PROMPT'
,p_message_text=>'URL Pattern'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242689867284661303)
,p_name=>'PE.PROPERTY.USED_IN_JAVASCRIPT.PROMPT'
,p_message_text=>'Used in JavaScript'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693524757661307)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE1.PROMPT'
,p_message_text=>'1.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694454712661308)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE10.PROMPT'
,p_message_text=>'10.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693601876661307)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE2.PROMPT'
,p_message_text=>'2.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693706721661308)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE3.PROMPT'
,p_message_text=>'3.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693894806661308)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE4.PROMPT'
,p_message_text=>'4.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242693944062661308)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE5.PROMPT'
,p_message_text=>'5.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694053416661308)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE6.PROMPT'
,p_message_text=>'6.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694104655661308)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE7.PROMPT'
,p_message_text=>'7.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694272234661308)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE8.PROMPT'
,p_message_text=>'8.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242694350186661308)
,p_name=>'PE.PROPERTY.USER_DEFINED_ATTRIBUTE9.PROMPT'
,p_message_text=>'9.'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115311016926300629)
,p_name=>'PE.PROPERTY.USE_AS_INITIAL_RESULT.HELP'
,p_message_text=>'If enabled, the results from this Search Configuration will be displayed as "initial" results, when no query was entered.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115310973945300629)
,p_name=>'PE.PROPERTY.USE_AS_INITIAL_RESULT.PROMPT'
,p_message_text=>'Use as Initial Result'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602983651784544)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>It''s crucial to define row headers for tabular report data, such as in Classic or Interactive Reports, to enhance usability for users of assistive technologies like screen readers.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Impact on Usability for Screen Reader Users:</strong>',
'<ul>',
'<li>When a screen reader user navigates through different rows of the report, the column or columns designated as identifying the row will be announced as the row header upon moving to the new row.</li>',
'<li>Failure to define a row header column makes it significantly more challenging for screen reader users to orient themselves while navigating the report.</li>',
'</ul>',
'</li>',
'<li><strong>Enhancing Orientation and Navigation:</strong>',
'<ul>',
'<li>Defining this attribute improves the navigation experience for screen reader users by providing clear orientation points within the tabular data.</li>',
'<li>This ensures smoother navigation and comprehension of the report''s content for users relying on assistive technologies.</li>',
'</ul>',
'</li>',
'<li><strong>Recommendations:</strong>',
'<ul>',
'<li>Define, one or more columns that identify the row, that will function as the row header for users of Assistive Technology.</li>',
'<li>This will be announced every time a user moves between rows, so the entire row header should not be too long to become overly verbose.</li>',
'</ul>',
'</li>',
'</ol>'))
,p_version_scn=>36587322
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602299344784528)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.COMPONENT_PROPERTY.IG_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>It''s crucial to define row headers for tabular report data, such as in Classic or Interactive Reports, to enhance usability for users of assistive technologies like screen readers.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Impact on Usability for Screen Reader Users:</strong>',
'<ul>',
'<li>When a screen reader user navigates through different rows of the report, the column or columns designated as identifying the row will be announced as the row header upon moving to the new row.</li>',
'<li>Failure to define a row header column makes it significantly more challenging for screen reader users to orient themselves while navigating the report.</li>',
'</ul>',
'</li>',
'<li><strong>Enhancing Orientation and Navigation:</strong>',
'<ul>',
'<li>Defining this attribute improves the navigation experience for screen reader users by providing clear orientation points within the tabular data.</li>',
'<li>This ensures smoother navigation and comprehension of the report''s content for users relying on assistive technologies.</li>',
'</ul>',
'</li>',
'<li><strong>Recommendations:</strong>',
'<ul>',
'<li>Define, one or more columns that identify the row, that will function as the row header for users of Assistive Technology.</li>',
'<li>This will be announced every time a user moves between rows, so the entire row header should not be too long to become overly verbose.</li>',
'</ul>',
'</li>',
'</ol>'))
,p_version_scn=>36587307
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601893400784526)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.COMPONENT_PROPERTY.IR_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>It''s crucial to define row headers for tabular report data, such as in Classic or Interactive Reports, to enhance usability for users of assistive technologies like screen readers.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Impact on Usability for Screen Reader Users:</strong>',
'<ul>',
'<li>When a screen reader user navigates through different rows of the report, the column or columns designated as identifying the row will be announced as the row header upon moving to the new row.</li>',
'<li>Failure to define a row header column makes it significantly more challenging for screen reader users to orient themselves while navigating the report.</li>',
'</ul>',
'</li>',
'<li><strong>Enhancing Orientation and Navigation:</strong>',
'<ul>',
'<li>Defining this attribute improves the navigation experience for screen reader users by providing clear orientation points within the tabular data.</li>',
'<li>This ensures smoother navigation and comprehension of the report''s content for users relying on assistive technologies.</li>',
'</ul>',
'</li>',
'<li><strong>Recommendations:</strong>',
'<ul>',
'<li>Define, one or more columns that identify the row, that will function as the row header for users of Assistive Technology.</li>',
'<li>This will be announced every time a user moves between rows, so the entire row header should not be too long to become overly verbose.</li>',
'</ul>',
'</li>',
'</ol>'))
,p_version_scn=>36587303
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603248824784546)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>It''s crucial to define row headers for tabular report data, such as in Classic or Interactive Reports, to enhance usability for users of assistive technologies like screen readers.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Impact on Usability for Screen Reader Users:</strong>',
'<ul>',
'<li>When a screen reader user navigates through different rows of the report, the column or columns designated as identifying the row will be announced as the row header upon moving to the new row.</li>',
'<li>Failure to define a row header column makes it significantly more challenging for screen reader users to orient themselves while navigating the report.</li>',
'</ul>',
'</li>',
'<li><strong>Enhancing Orientation and Navigation:</strong>',
'<ul>',
'<li>Defining this attribute improves the navigation experience for screen reader users by providing clear orientation points within the tabular data.</li>',
'<li>This ensures smoother navigation and comprehension of the report''s content for users relying on assistive technologies.</li>',
'</ul>',
'</li>',
'<li><strong>Recommendations:</strong>',
'<ul>',
'<li>Define, one or more columns that identify the row, that will function as the row header for users of Assistive Technology.</li>',
'<li>This will be announced every time a user moves between rows, so the entire row header should not be too long to become overly verbose.</li>',
'</ul>',
'</li>',
'</ol>'))
,p_version_scn=>36587323
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380444375027584091)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the column value, or combination of column values that help to identify the row of data. For example for person data this could be the first and last name, for customer data this could be the customer name, and so on.</p>',
'<p>For regions that render tabular report data (like Classic or Interactive Reports), defining this attribute is very important for the usability of the report for users of assistive technologies like screen readers. When a screen reader user navigat'
||'es to different rows of the report, the column, or columns defined as identifying the row will be announced as the row header, as soon as they move to the new row. If this is not defined, it is much harder for these users to orientate themselves when'
||' moving around the report.</p>'))
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380444262021584090)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_text=>'Value Identifies Row'
,p_version_scn=>37166067046350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(386061711557243699)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_text=>'Specify whether you wish to define a custom link for the Icon View. This option provides greater flexibility in defining the content of the Icon View, including the ability to utilize more than one column.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(386061629129243698)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_text=>'Custom'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144040506195306603)
,p_name=>'PE.PROPERTY.USE_EXTERNAL_EXPR.HELP'
,p_message_text=>'Whether to use external Filtering or Order By expressions, which are directly passed to the REST service.'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(144040441085306603)
,p_name=>'PE.PROPERTY.USE_EXTERNAL_EXPR.PROMPT'
,p_message_text=>'Enabled'
,p_version_scn=>37166067046377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714913463661327)
,p_name=>'PE.PROPERTY.USE_FOR_ROW_SEARCH.PROMPT'
,p_message_text=>'Use for Row Search'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000458154858866)
,p_name=>'PE.PROPERTY.USE_LANDMARK.COMPONENT_PROPERTY.REGION.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Landmarks provide a powerful way to identify the organization and structure of a web page. The structural information conveyed visually to users should be represented programmatically in the markup using landmark roles. The use of landmarks roles '
||'support keyboard navigation to the structure of a web page for screen reader users, and can be used as targets for browser extensions for enhanced keyboard navigation.</p>',
'    <p>When using landmarks, all perceivable content (eg all items, buttons, regions, menus, etc. of an APEX app) should be contained in a landmark, in order that content is not missed by the user. When labelling landmarks, you have the option to eit'
||'her use the region title (default), or define a custom Landmark Label on the region.</p>'))
,p_version_scn=>9235857
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121749115974479812)
,p_name=>'PE.PROPERTY.USE_LANDMARK.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'    <p>Determines if this region should be exposed as a landmark. For more information on landmarks, see <a rel="noopener noreferrer" href="#SYSTEM_HELP_URL#CSH:pd-use-landmark" target="_blank">Page Structure - Landmarks</a>.</p>'))
,p_version_scn=>1112210319
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121749060679479811)
,p_name=>'PE.PROPERTY.USE_LANDMARK.PROMPT'
,p_message_text=>'Use Landmark'
,p_version_scn=>37166067046437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242753728431661395)
,p_name=>'PE.PROPERTY.VALIDATION_MESSAGE.PROMPT'
,p_message_text=>'Validations'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143606946282500649)
,p_name=>'PE.PROPERTY.VALIDATION_PROCEDURE_NAME.PROMPT'
,p_message_text=>'Validation Procedure Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78519578690696135)
,p_name=>'PE.PROPERTY.VALIDATION_REGEXP.HELP'
,p_message_text=>'Specify a regular expression pattern to validate values with.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78519414614696135)
,p_name=>'PE.PROPERTY.VALIDATION_REGEXP.PROMPT'
,p_message_text=>'Regex Pattern'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156052805702978802)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_text=>'Select the associated region for this validation.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156052716592978802)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_text=>'Editable Region'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156031911692350896)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the type of equality to be tested for this validation. Depending on your selection, one or more additional attributes are required to fully define this validation.</p>',
'<p>If the validation passes the equality test, or evaluates to TRUE, then the validation error message does not display.',
'Validation error messages display when the validation fails the equality test, or evaluates to FALSE, or a non-empty text string is returned.</p>',
'<p>A validation failure does not stop subsequent validations from being evaluated, therefore, each subsequent validation may raise an additional validation error message. If you want to stop subsequent validations from executing then you need to add '
||'additional logic into the first failed validation, such as setting a page item to a specific value, and then enhancing the conditional logic on subsequent validations as needed. Subsequent processes and branches are not executed if one or more valida'
||'tions fail evaluation.</p>'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516902015071751886)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516902182802751887)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the SQL query returns one or more rows.<br>',
'Fails if the SQL query returns no rows.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291250887090649)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291363074090649)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the expression evaluates to TRUE.<br>',
'Fails if the expression evaluates to FALSE.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903087786751888)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_text=>'Function Body (returning Boolean)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903120276751889)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Function body returns TRUE.<br>',
'Fails if the Function body returns FALSE.<br>',
'Note: The result returned from the function must be a boolean.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903207036751889)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_text=>'Function Body (returning Error Text)'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903337004751889)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Function body returns an empty string.<br>',
'Fails if the Function body returns a non-empty string. The returned string displays as the error message for the validation.<br>',
'Note: The result returned from the function must be a text string.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904058234751890)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_text=>'Item contains no spaces'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904145048751890)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value has no spaces.<br>',
'Fails if the Item value contains spaces.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906019841751894)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_text=>'Item contains at least one of the characters in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906160730751895)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value includes at least one character from the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Item value does not include any characters from the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906284159751895)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_text=>'Item does NOT contain any of the characters in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906306612751895)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value does not include any characters from the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Item value includes at least one character from the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905819256751894)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_text=>'Item contains only characters specified in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905928054751894)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value contains only characters found in the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Item value contains any characters that are not in the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905098267751892)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_text=>'Item = Value'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905139469751892)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is equal to the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Item value is not equal to the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905457126751893)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_text=>'Item is contained in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905571885751894)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is completely contained in the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Item value is not completely contained in the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905260641751892)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_text=>'Item != Value'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905348864751892)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is not equal to the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Item value is equal to the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905613189751894)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_text=>'Item is NOT contained in Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516905766741751894)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is not completely contained in the text you enter into the <em>Value</em> attribute.<br>',
'Fails if the Item value is completely contained in the text you enter into the <em>Value</em> attribute.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904293830751890)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_text=>'Item is alphanumeric'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904305029751891)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is alphanumeric, containing only letters and numbers and no special characters.<br>',
'Fails if the Item value includes special characters.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904610682751891)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_text=>'Item is a valid date'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904760058751891)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is a valid date.<br>',
'Fails if the Item value is not a valid date.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904444127751891)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_text=>'Item is numeric'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904595010751891)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is numeric.<br>',
'Fails if the Item value contains non-numeric characters, including spaces, other than leading spaces.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904881428751891)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_text=>'Item is a valid timestamp'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516904949801751892)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is a valid timestamp.<br>',
'Fails if the Item value is not a valid timestamp.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903484667751889)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_text=>'Item is NOT NULL'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903575490751889)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is not empty.<br>',
'Fails if the Item value is empty.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903683067751889)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_text=>'Item is NOT NULL or zero'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903797617751890)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is not empty and is not the number zero.<br>',
'Fails if the Item value is empty or is the number zero.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903859489751890)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_text=>'Item is NOT zero'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516903975378751890)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value is not the number zero.<br>',
'Fails if the Item value is the number zero.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516902217959751887)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516902362615751887)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the SQL query returns no rows.<br>',
'Fails if the SQL query returns one or more rows.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516902862869751888)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_text=>'PL/SQL Error'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516902934732751888)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the PL/SQL code executes without generating an error.<br>',
'Fails if the PL/SQL expression generates an error when it executes.'))
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906400343751895)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_text=>'Item matches Regular Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516906504056751895)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Passes if the Item value matches the regular expression you enter into the <em>Value</em> attribute.',
'Fails if the Item value does not match the regular expression you enter into the <em>Value</em> attribute.<br>',
'Note: Regular expressions enable you to search for patterns in string data by using standardized syntax conventions, rather than just a straight character comparisons.'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156031811545350896)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661896036661106)
,p_name=>'PE.PROPERTY.VALID_FOR_URLS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>&PRODUCT_NAME. will check whether the URL, for which the credential is being used at run time, matches one of the URLs within this list. If the URL does not match, &PRODUCT_NAME. will raise an error.</p>',
'<p>Enter each URL on a new line. The URL endpoint being used must start with one of the URLs provided here.</p>',
'<p>Example:</p>',
'<pre>',
'https://www.example.com/restapis/my-protected-api',
'https://www.example.com/allowed-urls',
'</pre>',
'<p>If the credential is used to',
'invoke a REST service at <strong>https://www.example.com/restapis/my-protected-api/restendpoint</strong> or <strong>https://www.example.com/allowed-urls/page1</strong>, the credential can be used and the call will succeed.</p>',
'<p>If the credential is',
' used to invoke a REST service at <strong>https://localhost/myapis/test</strong> or <strong>https://dev.example.com/myapis/test</strong>, the credential <em>cannot</em> be used and &PRODUCT_NAME. will raise an error.</p>',
'<p>Note that changing this va',
'lue requires to re-enter the client secret.</p>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242661714043661106)
,p_name=>'PE.PROPERTY.VALID_FOR_URLS.PROMPT'
,p_message_text=>'Valid for URLs'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242690619538661305)
,p_name=>'PE.PROPERTY.VALID_VALUES.PROMPT'
,p_message_text=>'Valid Values'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295625744571065373)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_text=>'Select whether the axis baseline starts at the minimum value of the data or at zero. Only applies to numerical data axes.'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295625820524065374)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_text=>'Minimum'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295625928072065374)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_text=>'Zero'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295625603371065373)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_text=>'Baseline Scaling'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200092225982647)
,p_name=>'PE.PROPERTY.VALUE_BOOLEAN_FALSE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Value used to determine FALSE. It''s used to convert a VARCHAR2 value into a BOOLEAN and back into a VARCHAR2.',
'If no value has been specified, and &PRODUCT_NAME. can''t determine the value from an item of type Checkbox or Switch, the',
'values <code>N,n,FALSE,false,f,0</code> and NULL are considered FALSE.'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199961947982647)
,p_name=>'PE.PROPERTY.VALUE_BOOLEAN_FALSE.PROMPT'
,p_message_text=>'False Value'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199805646982647)
,p_name=>'PE.PROPERTY.VALUE_BOOLEAN_TRUE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Value used to determine TRUE. It''s used to convert a VARCHAR2 value into a BOOLEAN and back into a VARCHAR2.',
'If no value has been specified, and &PRODUCT_NAME. can''t determine the value from an item of type Checkbox or Switch, the',
'values <code>Y,y,TRUE,true,T,1</code> are considered TRUE.'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199738811982647)
,p_name=>'PE.PROPERTY.VALUE_BOOLEAN_TRUE.PROMPT'
,p_message_text=>'True Value'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358782138533589980)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_text=>'Enter the Collection name. The source for this parameter value will be based on the value of the CLOB column from the collection''s first row.'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358782075367589979)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046376
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608153745065311)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the currency that will be used when formatting the value on the chart.',
'        The value should be a ISO 4217 alphabetic currency code. If the format is set to currency, and no currency is defined in the <strong>Currency</strong> property, the currency will be automatically derived from the application language when the'
||' chart is rendered.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608091779065310)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_text=>'Currency'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404763312258250116)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_text=>'Specify the number of decimal places to be applied to the numeric value on the chart.'
,p_version_scn=>37166067046540
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388675157147170433)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_text=>'Enter the number of decimal places to use in value labels.'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(388675060328170433)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_text=>'Decimal Places'
,p_version_scn=>37166067046354
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214438559982823)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_CUSTOM.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214843673982823)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_CUSTOM.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214726727982823)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_CUSTOM.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214679688982823)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_CUSTOM.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214916512982823)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_CUSTOM.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214579542982823)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_CUSTOM.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130214369418982823)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_CUSTOM.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207384644982811)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_VARCHAR2.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207757203982811)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207687667982811)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207558505982811)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207846412982811)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207429178982811)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_VARCHAR2.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130207211864982810)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78521617621696274)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_MASK.COMPONENT_PROPERTY.JET_CHART_WS_PARAM.HELP'
,p_message_text=>'Format mask to convert the <strong>Static</strong>, <strong>Item</strong> or <strong>Preference</strong> value to the data type of the REST Source Parameter.'
,p_version_scn=>37166067046547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78521794002696302)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_MASK.COMPONENT_PROPERTY.MAP_LAYER_WS_PARAM.HELP'
,p_message_text=>'Format mask to convert the <strong>Static</strong>, <strong>Item</strong> or <strong>Preference</strong> value to the data type of the REST Source Parameter.'
,p_version_scn=>37166067046554
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78521261047696198)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_MASK.COMPONENT_PROPERTY.PAGE_PROCESS_WS_PARAM.HELP'
,p_message_text=>'Format mask to convert the <strong>Static</strong>, <strong>Item</strong> or <strong>Preference</strong> value to the data type of the REST Source Parameter.'
,p_version_scn=>37166067046508
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78521321121696217)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_MASK.COMPONENT_PROPERTY.REGION_WS_PARAM.HELP'
,p_message_text=>'Format mask to convert the <strong>Static</strong>, <strong>Item</strong> or <strong>Preference</strong> value to the data type of the REST Source Parameter.'
,p_version_scn=>37166067046523
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117343719172910329)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_MASK.COMPONENT_PROPERTY.WF_ACTIVITY_WS_PARAM.HELP'
,p_message_text=>'Format mask to convert the <strong>Static</strong>, <strong>Item</strong> or <strong>Preference</strong> value to the data type of the REST Source Parameter.'
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200283616982652)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_MASK.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Format mask to be used to convert the value into a NUMBER, DATE and TIMESTAMP and back into a VARCHAR2.',
'If no format mask has been specified, &PRODUCT_NAME. will automatically read the format mask of the specified item.'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200185590982652)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_MASK.PROMPT'
,p_message_text=>'Format Mask'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608520049065312)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_text=>'Select the scaling behavior of the value on the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608733627065313)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295609035533065314)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_text=>'Billion'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608949743065314)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_text=>'Million'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608686653065313)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_text=>'None'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295609269387065315)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_text=>'Quadrillion'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608834162065313)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_text=>'Thousand'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295609172157065314)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_text=>'Trillion'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608494566065312)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_text=>'Format Scaling'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404763268467250116)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the type of formatting to be applied to the value on the chart.',
'        The formats <strong>Decimal</strong>,<strong>Percent</strong> or <strong>Currency</strong> only apply to numeric values.',
'        The <strong>Date</strong>,<strong>Time</strong> and <strong>DateTime</strong> formats will only apply to values of that data type on the chart.'))
,p_version_scn=>37166067046540
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606582308065305)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_text=>'Select a numeric, date and/or time type of formatting to be applied to the value on the chart.  For date and/or time formatting, ensure the chart attribute <strong>Time Axis Type</strong> is set to one of the following values, depending on your chart'
||' data: <strong>Enabled</strong>, <strong>Mixed Frequency</strong>, or <strong>Skip Gaps</strong>.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607813299065310)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_text=>'Currency'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436871325648587510)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_text=>'When a number is formatted as currency, the Currency property is required to be set to specify the currency that will be used when formatting the number.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606945412065307)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_text=>'Date - Full'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870205467587500)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a date is formatted as full, the formatted date will contain long-weekday (EEEE), year (y), long-month (MMMM), day (d). For example, Wednesday, January 6, 2016.',
'        For some languages, long months are not used; for example, in Japanese the numeric month is used in patterns.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606884992065306)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_text=>'Date - Long'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870116316587499)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_text=>'When a date is formatted as long, the formatted date will contain year, long-month, day. For example, January 6, 2016.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606795662065306)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_text=>'Date - Medium'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870022906587498)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a date is formatted as medium, the formatted date will contain year, abbreviated-month (MMM), day. For example, Jan 6, 2016.',
'        For some languages, abbreviated months are not used; in that case, the medium format will contain the numeric month (MM/M).'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606618560065305)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_text=>'Date - Short'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436869986240587497)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_text=>'When a date is formatted as short, the formatted date will contain year, numeric-month (MM/M), day. For example, 1/6/16.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436871007236587507)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_text=>'DateTime - Full'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436871123344587508)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a date-time is formatted as full, the formatted date-time will contain long-weekday (EEEE), year (y), long-month (MMMM), day (d), hour (h/H), minute (mm), second (ss), and zone (zzzz). For example, Wednesday, January 6, 2016 7 h 30 min 21 s.',
'        The hour format depends on whether the application language uses 12-hour time or not.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607694243065309)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_text=>'DateTime - Long'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870927468587507)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a date-time is formatted as long, the formatted date-time will contain year, long-month, day, hour, minute, second, and zone (z). For example, Jan 6, 2016 7:30:21 AM.',
'        The hour format depends on whether the application language uses 12-hour time or not.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607508729065309)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_text=>'DateTime - Medium'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870881432587506)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a date-time is formatted as medium, the formatted date-time will contain year, abbreviated-month (MMM), day, hour, minute, second, and zone (z). For example, Jan 6, 2016 7:30:21 AM.',
'        The hour format depends on whether the application language uses 12-hour time or not.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607496992065308)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_text=>'DateTime - Short'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870726781587505)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a date-time is formatted as short, the formatted date-time will contain year, numeric-month (MM/M), day, hour, minute. For example, 1/6/16 7:30 AM.',
'        The hour format depends on whether the application language uses 12-hour time or not.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607700976065309)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_text=>'Decimal'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436871280275587509)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_text=>'When a number is formatted as a decimal, the decimal character is replaced with the most appropriate symbol for the locale. In English this is a decimal point ("."), while in many locales it is a decimal comma (",").'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607908413065310)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_text=>'Percent'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436871404873587511)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_text=>'When a number is formatted as a percent, the values on the chart are multiplied by 100 to format as a percent.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607352851065308)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_text=>'Time - Full'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870609377587504)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a time is formatted as full, the formatted time will contain hour (h/H), minute (mm), second (ss), and zone (zzzz). For example, 7 h 30 min 21 s.',
'        The hour format depends on whether the application language uses 12-hour time or not.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607217865065308)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_text=>'Time - Long'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870550783587503)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a time is formatted as long, the formatted time will contain hour, minute, second, and zone (z). For example, 7:30:21 AM.',
'        The hour format depends on whether the application language uses 12-hour time or not.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607187144065307)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_text=>'Time - Medium'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870417355587502)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a time is formatted as medium, the formatted time will contain hour, minute, second. For example, 7:30:21 AM.',
'        The hour format depends on whether the application language uses 12-hour time or not.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295607074283065307)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_text=>'Time - Short'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436870367951587501)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When a time is formatted as short, the formatted time will contain hour, minute. For example, 7:30 AM.',
'        The hour format depends on whether the application language uses 12-hour time or not.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606441456065305)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_text=>'Format'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216492995982824)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_CUSTOM.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216786033982825)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_CUSTOM.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216628373982824)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_CUSTOM.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216539738982824)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_CUSTOM.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216826615982825)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_CUSTOM.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216396401982824)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_CUSTOM.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109631356276427)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_VARCHAR2.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109966497276427)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_VARCHAR2.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109857737276427)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_VARCHAR2.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109703989276427)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_VARCHAR2.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61110094135276427)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_VARCHAR2.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61109535620276426)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG_VARCHAR2.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355264399211719780)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page or application item used as the source for this parameter value.',
'You can type in the name or pick from the list of available items.'))
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355264284319719779)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216044755982824)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter the Java expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130215942193982824)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600303742595090674)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the Java expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600303644360090674)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130217450586982825)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_CUSTOM.HELP'
,p_message_text=>'Enter the Java function body which returns a value used as the source for this parameter value.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130217393082982825)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_CUSTOM.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600305337503090675)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the Java function body which returns a value used as the source for this parameter value.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600305223144090675)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175618139210484691)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_CUSTOM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130215761265982824)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter the JavaScript expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130215619831982824)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613420646484668)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600303475768090674)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the JavaScript expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600303399469090673)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130217270211982825)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_CUSTOM.HELP'
,p_message_text=>'Enter the JavaScript function body which returns a value used as the source for this parameter value.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130217117715982825)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_CUSTOM.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613676864484669)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES" : "NO" );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600305012977090675)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the JavaScript function body which returns a value used as the source for this parameter value.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600304972915090675)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606381951065304)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_text=>'Specify a minimum value for the chart.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295606290877065304)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_text=>'Minimum'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404763452110250117)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_text=>'Specify the numeric pattern to be applied to the numeric value on the chart.'
,p_version_scn=>37166067046540
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1498051992355787751)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Numeric Pattern to represent temperatures in fahrenheit, for example 15&deg;F:</dt>',
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
'<dt>Numeric pattern to represent numbers in specific format, for example, 12,30,00:</dt>',
'<dd><pre>',
'##,##,##',
'</pre></dd>',
'<dt>Numeric pattern to represent numbers in millimeters:</dt>',
'<dd><pre>',
'# mm',
'</pre></dd>',
'<dt>Date pattern to represent date as Month Year, for example, Jul 2016:</dt>',
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
'<dt>Date pattern to represent date as Month, for example, July:</dt>',
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608338111065311)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter an optional localized numeric or date pattern, where the characters used in the pattern conform to Unicode CLDR for date time formats.',
'        When present, this will override the Format selected.'))
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(295608242442065311)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_text=>'Pattern'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706210492622806)
,p_name=>'PE.PROPERTY.VALUE_PARENT_COLUMN.HELP'
,p_message_text=>'<p>Select a <em>primary key column</em> from the master interactive grid region; the value of that column will be used as the source for this parameter value.</p>'
,p_version_scn=>25819084
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706103543622806)
,p_name=>'PE.PROPERTY.VALUE_PARENT_COLUMN.PROMPT'
,p_message_text=>'Column'
,p_version_scn=>25819083
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175618040295484690)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_CUSTOM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130215447324982823)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter the PL/SQL expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130215314357982823)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200576391982652)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_NO_LANG.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200487451982652)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_NO_LANG.HELP'
,p_message_text=>'Enter the PL/SQL expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200352413982652)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_NO_LANG.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613307994484668)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600303164914090673)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the PL/SQL expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600303052282090673)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130217091573982825)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_CUSTOM.HELP'
,p_message_text=>'Enter the PL/SQL function body which returns a value used as the source for this parameter value.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216978318982825)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_CUSTOM.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200849974982652)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_NO_LANG.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return some data from the EMP table as a stringified JSON:</dt>',
'<dd><pre>',
'declare',
'    l_result json;',
'begin',
'    select json_arrayagg (',
'               json_object (',
'                   ''empno'' value empno,',
'                   ''ename'' value ename',
'               )',
'           )',
'      into l_result',
'      from emp;',
'',
'    return l_result;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200790326982652)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_NO_LANG.HELP'
,p_message_text=>'Enter the PL/SQL function body which returns a value used as the source for this parameter value.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130200699725982652)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_NO_LANG.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613559591484669)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600304791756090675)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the PL/SQL function body which returns a value used as the source for this parameter value.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600304631762090675)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31551954831451213)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_text=>'Specify the position where the value should be displayed on the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31550771071442751)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_text=>'Automatic'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31552115483456114)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_text=>'<p>The value will be displayed in the default position for the chart, which is outside of the plot area.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31550970863443619)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_text=>'Center'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31552323468457460)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_text=>'<p>The value will be displayed in the center of the indicator on the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31551169895444867)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_text=>'Inside Indicator Edge'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31552529758458611)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_text=>'<p>The value will be displayed inside the edge of the indicator on the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31551321947445907)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_text=>'Outside Indicator Edge'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31552729022460290)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_text=>'<p>The value will be displayed outside the edge of the indicator on the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31551507465447249)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_text=>'Outside Plot Area'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31552969387461824)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_text=>'<p>The value will be displayed outside the plot area of the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31551704987448181)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_text=>'With Label'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31553151682463882)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_text=>'<p>If the label is rendered, the value will be displayed in the same position as the label. If the label is not rendered, the value will be displayed outside the plot area of the chart.'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31550591513440798)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_text=>'Position'
,p_version_scn=>37166067046381
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355264971762719784)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_text=>'Enter the User Preference to be used as the source for this parameter value.'
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355264822109719783)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_text=>'Preference'
,p_version_scn=>37166067046375
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216292087982824)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter the Python expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130216107947982824)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600303939047090674)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the Python expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600303819823090674)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130217687616982825)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_CUSTOM.HELP'
,p_message_text=>'Enter the Python function body which returns a value used as the source for this parameter value.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130217506915982825)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_CUSTOM.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600305531466090675)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_text=>'Enter the Python function body which returns a value used as the source for this parameter value.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600305448644090675)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355264131139719778)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_text=>'Enter the SQL Query used as the source for this parameter value. If more than one row is returned then the value of the first row is used.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355264074929719777)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109531780211814)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If set to <strong>On</strong> and the page item is visible, &PRODUCT_NAME. automatically performs a NOT NULL validation when the page is submitted.</p>',
'<p>By defining a message called <strong>APEX.PAGE_ITEM_IS_REQUIRED</strong> in Shared Components, Text Messages, the predefined error text can be replaced by an application specific error message.</p>',
'<p>The display location of the message is defined by the application level setting <strong>Default error display location</strong>.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123109411374211814)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_text=>'Value Required'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175617924974484690)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_CUSTOM.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130215113646982823)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_CUSTOM.HELP'
,p_message_text=>'Enter the SQL expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130215014342982823)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_CUSTOM.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175613251863484667)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return YES when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600302856868090673)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_text=>'Enter the SQL expression that produces a value used as the source for this parameter value.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600302726113090673)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355263995501719777)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_text=>'Enter the static value used as the source for this parameter value.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355263833858719776)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199257777982633)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE_BOOLEAN.HELP'
,p_message_text=>'Select the BOOLEAN value that is used as the source for this parameter value.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199473581982634)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE_BOOLEAN.LOV.FALSE.D'
,p_message_text=>'False'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199322891982634)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE_BOOLEAN.LOV.TRUE.D'
,p_message_text=>'True'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130199192182982633)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE_BOOLEAN.PROMPT'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404229378010394110)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_text=>'Specify how the value should be displayed on the chart, either as a number or a percentage of the total value.'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404228562545373161)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_text=>'Number'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(405613495621209877)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_text=>'<p>The value will be displayed as a number on the chart.</p> <p>Note: the <strong>Format</strong> attribute should only be used to apply custom decimal or currency formatting to the label and value displayed on the chart.</p>'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404228772121374282)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_text=>'Percent'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(405613578708209878)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_text=>'<p>The value will be displayed as a percent between 0% and 100%.</p> <p>Note: When <strong>Format</strong> is set to <strong>Percent</strong>, the values on the chart are multiplied by 100 to format as a percent. If you wish to use the Format attribu'
||'te, ensure that Label Type is set to number.</p>'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(404228348688372098)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_text=>'Value Type'
,p_version_scn=>37166067046365
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262344386719758)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_text=>'Select how this parameter is populated.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358781842210589975)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_text=>'Collection (CLOB)'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358781985369589976)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_text=>'Set to the CLOB column value of the first row from the <em>Collection</em> entered.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(546903661705815046)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_text=>'REST Source Default'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(546903786680815082)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_text=>'Use the value defined as default within the REST Data Source.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78371697491038149)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78371742337038149)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>Expression</em> entered.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78371813889038149)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78371913565038149)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262650047719763)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262784384719764)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355263655330719774)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355263780436719775)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_text=>'Set to null as no value specified.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705785916622738)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PARENT_COLUMN.D'
,p_message_text=>'Parent Column'
,p_version_scn=>25819064
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1705827904622738)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PARENT_COLUMN.HELP'
,p_message_text=>'Set to the value of the specified <em>Parent column</em>, if a <strong>Master Region</strong> is configured (currently only available for Interactive Grid).'
,p_version_scn=>25819065
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355263462753719773)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_text=>'Preference'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355263596200719774)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_text=>'Set to the value of the <em>Preference</em> entered.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262804009719765)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262937995719767)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262401143719760)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262553022719762)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Set to the text entered into <em>Static Value</em>.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262234219719757)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205906510982806)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206329602982806)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206228200982806)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206185868982806)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206417494982806)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130206072991982806)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(130205851060982806)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108466201276423)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108701823276423)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108671524276423)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108548031276423)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108843195276423)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61108363541276423)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291587713090653)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291883420090653)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291704063090653)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291682095090653)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291923561090653)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600291486305090652)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487523574026106373)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_text=>'Enter a page or application item used in this validation. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487523441224106373)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600294793299090657)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Java expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600294636356090656)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600296304839090660)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Java function body that returns a BOOLEAN value as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600296275265090659)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600292798907090654)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_text=>'Enter a Java function body that returns the error message text as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600292676325090654)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_text=>'Java Function Body Returning Error Text'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612006126484659)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600294433790090656)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600294321168090656)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612250533484660)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600296027818090659)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript function body that returns a BOOLEAN value as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600295925530090659)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611603523484658)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise the specified error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600292479693090653)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_text=>'Enter a JavaScript function body that returns the error message text as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600292305225090653)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_text=>'JavaScript Function Body Returning Error Text'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611740128484658)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise the specified error, when the employee is in department 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487523311831106373)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_text=>'Enter a PL/SQL expression that raises an error as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487523263617106373)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_text=>'PL/SQL Code raising Error'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611961542484659)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600294170670090656)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600294053560090656)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175612146054484660)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600295730692090657)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL function body that returns a BOOLEAN value as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600295602082090657)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611525592484657)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise the specified error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600292175188090653)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_text=>'Enter a PL/SQL function body that returns the error message text as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600292026083090653)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_text=>'PL/SQL Function Body Returning Error Text'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600294979133090657)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Python expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600294887678090657)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600296519272090660)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Python function body that returns a BOOLEAN value as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600296431684090660)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600292992887090654)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_text=>'Enter a Python function body that returns the error message text as the basis for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600292888717090654)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_text=>'Python Function Body Returning Error Text'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487523967158106374)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_text=>'Enter the regular expression used to match the item specified for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487523857744106374)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_text=>'Regular Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611860968484659)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To pass the validation, and not raise an error message, when the employee is a manager or the department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600293854135090656)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a SQL expression to define the validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(600293793614090656)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175611415098484657)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>For <strong>Rows Returned</strong>, to pass the validation, and not raise an error message, when the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>For <strong>No Rows Returned</strong>, to pass the validation, and not raise an error message, when the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>15114761
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487522394703106371)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_text=>'Enter a SQL query to define this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487522208519106371)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487523746977106373)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_text=>'Enter the value used to compare against the value of the item column specified for this validation.'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487523697015106373)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046480
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116962214096909849)
,p_name=>'PE.PROPERTY.VARIABLE_BOOLEAN_FALSE.HELP'
,p_message_text=>'<p>Variable or parameter value used to determine FALSE. It''s used to convert a VARCHAR2 value into a BOOLEAN and back into a VARCHAR2.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116961983225909849)
,p_name=>'PE.PROPERTY.VARIABLE_BOOLEAN_FALSE.PROMPT'
,p_message_text=>'False Value'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116961600503909849)
,p_name=>'PE.PROPERTY.VARIABLE_BOOLEAN_TRUE.HELP'
,p_message_text=>'<p>Variable or parameter value used to determine TRUE. It''s used to convert a VARCHAR2 value into a BOOLEAN and back into a VARCHAR2.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116961344024909848)
,p_name=>'PE.PROPERTY.VARIABLE_BOOLEAN_TRUE.PROMPT'
,p_message_text=>'True Value'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116967612634909853)
,p_name=>'PE.PROPERTY.VARIABLE_DEFAULT.HELP'
,p_message_text=>'<p>Default value of this parameter.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116967373097909852)
,p_name=>'PE.PROPERTY.VARIABLE_DEFAULT.PROMPT'
,p_message_text=>'Default Value'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117339578231910317)
,p_name=>'PE.PROPERTY.VARIABLE_DIRECTION.COMPONENT_PROPERTY.WORKFLOW_PARAM.HELP'
,p_message_text=>'The direction of the parameter as defined within the Workflow.'
,p_version_scn=>37166067046558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116958871539909847)
,p_name=>'PE.PROPERTY.VARIABLE_DIRECTION.HELP'
,p_message_text=>'Specify the direction of the workflow parameter or variable.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116958586866909846)
,p_name=>'PE.PROPERTY.VARIABLE_DIRECTION.PROMPT'
,p_message_text=>'Direction'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534296321020777944)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Restrict the use of an application to specific business hours</dt>',
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150988300877822706)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the name of a function that is called after the session sentry has returned successfully.',
'The function can either be defined in the <strong>PL/SQL code</strong> attribute or in the database.',
'The result must be boolean, with TRUE representing the user is verified, and FALSE representing the user has failed verification.'))
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(150988214144822706)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_text=>'Verify Function Name'
,p_version_scn=>37166067046338
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242718389067661330)
,p_name=>'PE.PROPERTY.VERSION.PROMPT'
,p_message_text=>'Version'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80495078861272153)
,p_name=>'PE.PROPERTY.VERSION_SCN.HELP'
,p_message_text=>'Use this field to identify the current version of the data.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(80494917486272153)
,p_name=>'PE.PROPERTY.VERSION_SCN.PROMPT'
,p_message_text=>'Version Number'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123149909680211880)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether all pending actions wait for the result of the current action.',
'Set this attribute to <strong>On</strong> if pending actions are dependent on the result of this action,',
'or to <strong>Off</strong> if there is no dependency and they can execute asynchronously, without waiting.</p>',
'<p>Note: The order of execution of specific actions is determined by the sequence specified for each action.',
'To ensure that actions are run in the same order, Oracle recommends that the sequence numbers be unique for all True Actions and all False Actions.</p>'))
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123149802895211879)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_text=>'Wait For Result'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115307064015300625)
,p_name=>'PE.PROPERTY.WEB_SRC_FUNCTION.HELP'
,p_message_text=>'Provide the name of a function to convert the end user query to syntax which the REST Source understands.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(115306929429300625)
,p_name=>'PE.PROPERTY.WEB_SRC_FUNCTION.PROMPT'
,p_message_text=>'REST Source Query Function'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1706364367622806)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_ARRAY_COLUMNS.PROMPT'
,p_message_text=>'REST Source Has Array Columns'
,p_version_scn=>25819084
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165482215725365238)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_text=>'Identifies whether the REST Data Source has a local synchronization table'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165482192972365221)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_text=>'REST Data Source has a Synchronization table'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577790776340720)
,p_name=>'PE.PROPERTY.WEB_SRC_MODULE_ID.HELP'
,p_message_text=>'Identifies the REST data source.'
,p_version_scn=>49870259
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10577668786340720)
,p_name=>'PE.PROPERTY.WEB_SRC_MODULE_ID.PROMPT'
,p_message_text=>'REST Data Source'
,p_version_scn=>49870258
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242755235885661397)
,p_name=>'PE.PROPERTY.WEB_SRC_MODULE_SUBSCRIBED_FROM.PROMPT'
,p_message_text=>'Master'
,p_version_scn=>37166067046436
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134091446835566)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.HELP'
,p_message_text=>'The name of the parameter, as configured in Shared Components, REST Data Sources.'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355262118988719755)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046374
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78519726962696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.HELP'
,p_message_text=>'<p>Data type of the REST Source Parameter.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78521080666696136)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.BLOB.D'
,p_message_text=>'Binary'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78521165101696136)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.BLOB.HELP'
,p_message_text=>'<p>Binary content contains non-text (image, raw bytes) data, and are represented as a String in <em>Base64</em> format.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520831928696136)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.BOOLEAN.D'
,p_message_text=>'Boolean'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520991867696136)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.BOOLEAN.HELP'
,p_message_text=>'<p>Boolean values contain <strong>true</strong> or <strong>false</strong>. Use the <strong>Format Mask</strong> to convert values like <code>''Y'',''N''</code>, or  <code>''1'',''0''</code> to boolean values.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520295108696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.DATE.D'
,p_message_text=>'Date'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520389018696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.DATE.HELP'
,p_message_text=>'<p>Date values contain date and time, but neither fractional seconds nor time zone information.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520069856696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.NUMBER.D'
,p_message_text=>'Numeric'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520145831696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.NUMBER.HELP'
,p_message_text=>'<p>Numeric values are decimal or integer values.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520634203696136)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.TIMESTAMP WITH TIME ZONE.D'
,p_message_text=>'Timestamp with Time Zone'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520790531696136)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.TIMESTAMP WITH TIME ZONE.HELP'
,p_message_text=>'<p>Timestamp with Time Zone values contain date and time (including fractional seconds), as well as time zone information.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520471978696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_text=>'Timestamp'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78520598584696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.TIMESTAMP.HELP'
,p_message_text=>'<p>Timestamp values contain date and time (including fractional seconds), but no time zone information.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78519809609696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.VARCHAR2.D'
,p_message_text=>'String'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78519994964696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.LOV.VARCHAR2.HELP'
,p_message_text=>'<p>String values contain alphanumeric data.</p>'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78519666435696135)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_DATA_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714826426661327)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_TYPE.LOV.BODY.D'
,p_message_text=>'Request or Response Body'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714504679661326)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_TYPE.LOV.COOKIE.D'
,p_message_text=>'HTTP Cookie'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35134912644835599)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_TYPE.LOV.DATA_PROFILE.D'
,p_message_text=>'Data Profile Column'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714456549661326)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_TYPE.LOV.HEADER.D'
,p_message_text=>'HTTP Header'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714748540661327)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_TYPE.LOV.QUERY_STRING.D'
,p_message_text=>'URL Query String'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35135154481835600)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_TYPE.LOV.REASON_PHRASE.D'
,p_message_text=>'HTTP Reason Phrase'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(35135052293835600)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_TYPE.LOV.STATUS_CODE.D'
,p_message_text=>'HTTP Status Code'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714612966661326)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_TYPE.LOV.URL_PATTERN.D'
,p_message_text=>'URL Pattern'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242714333553661326)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046412
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165482421222365239)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_text=>'<p>Enable this to use the local table, which is configured within the <strong>Synchronization</strong> section of the REST Data Source, instead of reaching out to the external REST service.'
,p_version_scn=>37166067046398
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165482380131365239)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_text=>'Use Local Table'
,p_version_scn=>25875457
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117273640137910122)
,p_name=>'PE.PROPERTY.WF_CONDITION_EXPRESSION_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to evaluate the entered expression.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117274842416910122)
,p_name=>'PE.PROPERTY.WF_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117274510565910122)
,p_name=>'PE.PROPERTY.WF_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117274248745910122)
,p_name=>'PE.PROPERTY.WF_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117275124539910123)
,p_name=>'PE.PROPERTY.WF_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117273948011910122)
,p_name=>'PE.PROPERTY.WF_CONDITION_EXPRESSION_LANG_BOOLEAN.LOV.SQL.D'
,p_message_text=>'SQL'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117273330514910121)
,p_name=>'PE.PROPERTY.WF_CONDITION_EXPRESSION_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117279681092910126)
,p_name=>'PE.PROPERTY.WF_CONDITION_FUNC_BODY_LANG_BOOLEAN.HELP'
,p_message_text=>'Select a language that is used to execute the entered function body.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117280562711910126)
,p_name=>'PE.PROPERTY.WF_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVA.D'
,p_message_text=>'Java (MLE)'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117280207676910126)
,p_name=>'PE.PROPERTY.WF_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.JAVASCRIPT.D'
,p_message_text=>'JavaScript (MLE)'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117279953094910126)
,p_name=>'PE.PROPERTY.WF_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PLSQL.D'
,p_message_text=>'PL/SQL'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117280897921910126)
,p_name=>'PE.PROPERTY.WF_CONDITION_FUNC_BODY_LANG_BOOLEAN.LOV.PYTHON.D'
,p_message_text=>'Python (MLE)'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117279343062910125)
,p_name=>'PE.PROPERTY.WF_CONDITION_FUNC_BODY_LANG_BOOLEAN.PROMPT'
,p_message_text=>'Language'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117270079529910119)
,p_name=>'PE.PROPERTY.WF_CONDITION_ITEM1.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117269770023910119)
,p_name=>'PE.PROPERTY.WF_CONDITION_ITEM1.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117272455717910121)
,p_name=>'PE.PROPERTY.WF_CONDITION_ITEM2.HELP'
,p_message_text=>'Enter the page or application item used in this condition. You can type in the name or pick from the list of available items.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117272184201910121)
,p_name=>'PE.PROPERTY.WF_CONDITION_ITEM2.PROMPT'
,p_message_text=>'Item'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117278448777910125)
,p_name=>'PE.PROPERTY.WF_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Expression for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117278133965910125)
,p_name=>'PE.PROPERTY.WF_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Java Expression'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117283236063910128)
,p_name=>'PE.PROPERTY.WF_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Java Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117282944065910128)
,p_name=>'PE.PROPERTY.WF_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Java Function Body'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175618590215484696)
,p_name=>'PE.PROPERTY.WF_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117277511034910124)
,p_name=>'PE.PROPERTY.WF_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Expression for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117277299569910124)
,p_name=>'PE.PROPERTY.WF_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175618774611484697)
,p_name=>'PE.PROPERTY.WF_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (let row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117282332312910127)
,p_name=>'PE.PROPERTY.WF_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a JavaScript Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117282041327910127)
,p_name=>'PE.PROPERTY.WF_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'JavaScript Function Body'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117270656831910120)
,p_name=>'PE.PROPERTY.WF_CONDITION_LIST.HELP'
,p_message_text=>'Enter a colon(:) separated list of values for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117270319807910119)
,p_name=>'PE.PROPERTY.WF_CONDITION_LIST.PROMPT'
,p_message_text=>'List'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175618410672484696)
,p_name=>'PE.PROPERTY.WF_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30 or is a manager:</dt>',
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117276642618910124)
,p_name=>'PE.PROPERTY.WF_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Expression for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117276343109910123)
,p_name=>'PE.PROPERTY.WF_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Expression'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175618667352484697)
,p_name=>'PE.PROPERTY.WF_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is in department 30:</dt>',
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117281451299910127)
,p_name=>'PE.PROPERTY.WF_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a PL/SQL Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117281139275910127)
,p_name=>'PE.PROPERTY.WF_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'PL/SQL Function Body'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117279010896910125)
,p_name=>'PE.PROPERTY.WF_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Expression for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117278713564910125)
,p_name=>'PE.PROPERTY.WF_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'Python Expression'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117283845706910128)
,p_name=>'PE.PROPERTY.WF_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_text=>'Enter a Python Function Body that returns a boolean value for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117283520505910128)
,p_name=>'PE.PROPERTY.WF_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_text=>'Python Function Body'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175618399794484696)
,p_name=>'PE.PROPERTY.WF_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully when the employee is a manager and their department is located in Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117275779333910123)
,p_name=>'PE.PROPERTY.WF_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_text=>'Enter a SQL Expression for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117275460934910123)
,p_name=>'PE.PROPERTY.WF_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_text=>'SQL Expression'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175618281823484694)
,p_name=>'PE.PROPERTY.WF_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>To return successfully as one or more rows exist when checking if the employee is in department 30:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
'<dt>To return successfully as no rows exist when checking if the employee is in department 40:</dt>',
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117268545336910118)
,p_name=>'PE.PROPERTY.WF_CONDITION_SQL_STATEMENT.HELP'
,p_message_text=>'Enter a SQL query for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117268288532910118)
,p_name=>'PE.PROPERTY.WF_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117271216447910120)
,p_name=>'PE.PROPERTY.WF_CONDITION_TEXT.HELP'
,p_message_text=>'Enter the text value for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117270987473910120)
,p_name=>'PE.PROPERTY.WF_CONDITION_TEXT.PROMPT'
,p_message_text=>'Text'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117273082275910121)
,p_name=>'PE.PROPERTY.WF_CONDITION_TEXT2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117272703007910121)
,p_name=>'PE.PROPERTY.WF_CONDITION_TEXT2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117254417858910109)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.HELP'
,p_message_text=>'Select a condition type that must be met in order for this branch to be executed.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117254759499910109)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_text=>'Always'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117255028509910109)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_text=>'The component will always be rendered or executed.'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117266184030910117)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_text=>'Text is contained in Variable'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117266461192910117)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_text=>'Text = Value'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117267039528910117)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_text=>'Text is contained in Value'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117267362022910117)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_text=>'Text is NOT contained in Value'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117266752965910117)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_text=>'Text != Value'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117255322636910109)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_text=>'Rows returned'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117255679123910110)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_text=>'The SQL query returns one or more rows.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117256587860910110)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117256802853910110)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'The expression evaluates to TRUE.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117257159832910111)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117257406657910111)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'The function body returns TRUE.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117262508043910114)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_text=>'Variable contains no spaces'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117262801316910114)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> has no spaces.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117264389166910116)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_text=>'Variable is alphanumeric'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117264608124910116)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is alphanumeric, containing only letters or numbers and no special characters.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117259558485910112)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_text=>'Variable is NOT NULL'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117259897009910112)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is not empty.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117263706265910115)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_text=>'Variable is NOT numeric'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117264001867910115)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is not numeric.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117260749275910113)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_text=>'Variable is NOT zero'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117261077147910113)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is not the number zero.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117258967852910112)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_text=>'Variable is NULL'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117259233858910112)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is empty.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117261388933910113)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_text=>'Variable is NULL or zero'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117261611118910114)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is empty or the number zero.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117263157726910114)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_text=>'Variable is numeric'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117263422837910115)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is numeric.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117260175474910113)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_text=>'Variable is zero'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117260476398910113)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is the number zero.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117261972106910114)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_text=>'Variable is NOT NULL and NOT zero'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117262218186910114)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is not empty and not the number zero.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117267644486910118)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.NEVER.D'
,p_message_text=>'Never'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117267970509910118)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The component is never rendered or executed.</p>',
'<p>Note: Changing a condition to <strong>Never</strong> will remove any existing condition. For temporarily disabling a component, Oracle recommends using the <em>Build Option</em> attribute instead.</p>'))
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117255920957910110)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_text=>'No Rows returned'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117256282103910110)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_text=>'The SQL Query returns no rows'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117264990574910116)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Variable is in colon delimited list'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117265230452910116)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is completely contained in the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117265535410910116)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_text=>'Variable is NOT in colon delimited list'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117265893490910116)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is not completely contained in the text you entered into the <em>Value</em> attribute.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117257745938910111)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_text=>'Variable = Value'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117258095888910111)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117258398625910111)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_text=>'Variable != Value'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117258640381910112)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_text=>'The value of the selected <em>Variable</em> is not equal to the text you enter into the <em>Value</em> attribute.'
,p_version_scn=>37166067046490
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117254110316910109)
,p_name=>'PE.PROPERTY.WF_CONDITION_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046489
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117269430203910119)
,p_name=>'PE.PROPERTY.WF_CONDITION_VALUE1.HELP'
,p_message_text=>'Enter the value to compare against the condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117269128758910119)
,p_name=>'PE.PROPERTY.WF_CONDITION_VALUE1.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117271865085910120)
,p_name=>'PE.PROPERTY.WF_CONDITION_VALUE2.HELP'
,p_message_text=>'Enter the value, including <code>&ITEM.</code> substitution strings, for this condition.'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117271516910910120)
,p_name=>'PE.PROPERTY.WF_CONDITION_VALUE2.PROMPT'
,p_message_text=>'Value'
,p_version_scn=>37166067046491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116939405484909833)
,p_name=>'PE.PROPERTY.WF_IDENTIFICATION_STATIC_ID.HELP'
,p_message_text=>'Enter a case-insensitive static ID to uniquely identify this component.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116939151338909833)
,p_name=>'PE.PROPERTY.WF_IDENTIFICATION_STATIC_ID.PROMPT'
,p_message_text=>'Static ID'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423529678107963)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_OWNER.HELP'
,p_message_text=>'Select the schema that owns the table.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423469120107963)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_OWNER.PROMPT'
,p_message_text=>'Table Owner'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423703818107964)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_TABLE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the case-sensitive table or view name. You can type in the name or pick from the list.',
'        The column names of the table can be used as bind variables and substitution strings to evaluate variables, participants and conditions during the execution of the activities.'))
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423676906107964)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_TABLE.PROMPT'
,p_message_text=>'Table Name'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263424178621108254)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_TYPE.COMPONENT_PROPERTY.WORKFLOW_VERSION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how additional data is queried that can be used to evaluate variables,',
'        participants and conditions during the execution of the activities of the workflow..'))
,p_version_scn=>37166067046558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263422955201107963)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_TYPE.HELP'
,p_message_text=>'Select how the workflow data is queried.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423246121107963)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423387578107963)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_text=>'The workflow data is retrieved based on a SQL Query.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423008357107963)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_text=>'Table / View'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423155892107963)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_text=>'The workflow data is retrieved based on a table or view.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263422803869107963)
,p_name=>'PE.PROPERTY.WF_SOURCE_QUERY_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263424438367108257)
,p_name=>'PE.PROPERTY.WF_SOURCE_SQL_QUERY.COMPONENT_PROPERTY.WORKFLOW_ACTIVITY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL query to read additional data.</p>',
'                <p>The column names of the query can be used as bind variables and substitution',
'                strings to evaluate conditions or activity variables during the execution of the activity.</p>',
'                <p>The result of the query should contain only one row.</p>',
'                <p> If the query returns no result or more than one row then the activity fails during execution.</p>'))
,p_version_scn=>37166067046559
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263424076875107964)
,p_name=>'PE.PROPERTY.WF_SOURCE_SQL_QUERY.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :DEPT_NUMBER',
'</pre>'))
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423939494107964)
,p_name=>'PE.PROPERTY.WF_SOURCE_SQL_QUERY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL query to read additional data.</p>',
'        <p>The column-names of the query can be used as bind variables and substitution strings to evaluate variables, participants and conditions during the execution of the activities.</p>',
'        <p>The result of the query should contain only one row.</p>',
'        <p> If the query returns no result or more than one row then the workflow fails during execution.</p>'))
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(263423894416107964)
,p_name=>'PE.PROPERTY.WF_SOURCE_SQL_QUERY.PROMPT'
,p_message_text=>'SQL Query'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116953512948909843)
,p_name=>'PE.PROPERTY.WHEN.HELP'
,p_message_text=>'Select the branch condition expression.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116954104652909843)
,p_name=>'PE.PROPERTY.WHEN.LOV.FALSE.D'
,p_message_text=>'False'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116954464816909844)
,p_name=>'PE.PROPERTY.WHEN.LOV.NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116953811044909843)
,p_name=>'PE.PROPERTY.WHEN.LOV.TRUE.D'
,p_message_text=>'True'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116953232858909843)
,p_name=>'PE.PROPERTY.WHEN.PROMPT'
,p_message_text=>'When'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123098522404211791)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_text=>'Select the button to trigger the dynamic action.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123098423112211790)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_text=>'Button'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155912532688354793)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_text=>'If you want this page processing component to execute only when the specified button is clicked, select a button from the list. You can incorporate this button condition with other conditions to further refine when this page processing component exec'
||'utes.'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155912414222354793)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_text=>'When Button Pressed'
,p_version_scn=>37166067046339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881766428691802833)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter one or more columns to trigger the dynamic action.',
'For multiple columns, separate each item name with a comma.',
'You can type in the name or pick from the list of available columns.',
'If you pick from the list and there is already text entered, a comma is placed at the end of the existing text, followed by the column name returned from the list.'))
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(881766371004802833)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_text=>'Column(s)'
,p_version_scn=>37166067046373
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123098920983211791)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter either a DOM object (<code>document</code>, <code>window</code>) or the <em>id</em> of a DOM object (<code>myElementID</code>) as the element to trigger the dynamic action.</p>',
'<p>Note: <em>DOM Object</em> is deprecated and should be replaced by <em>JavaScript Expression</em> or <em>jQuery Selector</em>.</p>'))
,p_version_scn=>37166067046335
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123098800968211791)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_text=>'DOM Object'
,p_version_scn=>37166067046335
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47974018531258315)
,p_name=>'PE.PROPERTY.WHEN_IG_REGION.HELP'
,p_message_text=>'<p>Select the name of the editable interactive grid region that triggers the dynamic action.'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47973931234258315)
,p_name=>'PE.PROPERTY.WHEN_IG_REGION.PROMPT'
,p_message_text=>'Interactive Grid'
,p_version_scn=>37166067046336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123098721439211791)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter page or application items to trigger the dynamic action.',
'For multiple items, separate each item name with a comma.',
'You can type in the name or pick from the list of available items.',
'If you pick from the list and there is already text entered, a comma is placed at the end of the existing text, followed by the item name returned from the list.'))
,p_version_scn=>37166067046335
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123098627238211791)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_text=>'Item(s)'
,p_version_scn=>37166067046335
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855974941117605334)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Returns a reference to the browser''s <code>window</code> DOM object.</dt>',
'<dd><code>window</code></dd>',
'<dt>Returns a reference to the browser''s <code>document</code> DOM object.</dt>',
'<dd><code>document</code></dd>',
'<dt>jQuery selector selects all DIV elements that have a class of ''alert'', and then returns a jQuery object containing all their parents.</dt>',
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855974829736605333)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_text=>'Enter the JavaScript Expression to be evaluated to return a single DOM object, an array of DOM objects or a jQuery object as the element(s) to trigger the dynamic action.'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855974775041605333)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046363
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516757351426751445)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>To select a page element with an DOM id of <code>my_id</code></dt>',
'<dd><pre>#my_id</pre></dd>',
'<dt>To select all the page elements with a class of <code>my_class</code></dt>',
'<dd><pre>.my_class</pre></dd>',
'<dt>To select all the page elements that are inputs</dt>',
'<dd><pre>input</pre></dd>',
'</dl>'))
,p_version_scn=>37166067046335
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123099121580211791)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter jQuery Selector syntax to return one or more page element to trigger the dynamic action. The jQuery library offers a very powerful selector syntax which provides a way to easily access one or more elements from a page.</p>',
'<p>Please see the official documentation available from the <a rel="noopener noreferrer" target="_blank" href="http://docs.jquery.com">jQuery homepage</a> for further information about the selector syntax.</p>'))
,p_version_scn=>37166067046335
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123099026678211791)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_text=>'jQuery Selector'
,p_version_scn=>37166067046335
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245991180136481464)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the text message that displays when the <strong>Maximum Rows to Process</strong> limit is exceeded.',
'The default message instructs end users to add additional filters to limit the number of records to be processed.'))
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381151147674270816)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_text=>'Enter the text message that displays when more rows are returned from the query than the maximum row count entered.'
,p_version_scn=>37166067046522
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567457514720315686)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_text=>'Enter the text message that displays in the <strong>Messages</strong> area, when the <strong>Maximum Rows to Process</strong> limit is exceeded for the layer. Use the <strong>#MAX_ROW_COUNT#</strong> substitution for the amount of rows actually fetch'
||'ed.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380761960387410007)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text message that displays when more report rows exist.',
'Use this approach as an alternative to pagination, especially if a report generally only has a discrete record set.',
'If the report query returns additional rows, this message can be used to alert the end user to the anomaly, rather than simply displaying slightly different pagination controls.',
'Your text message can readily incorporate a "Call to action" so end users are given guidance on how to respond to this unusual query result and can include page or URL links.</p>',
'<p>The following pagination substitution strings can be utilized in your message:</p>',
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
'    <dd>The number of rows displayed (page size)</dd>',
'  <dt><code>#TOTAL_ROWS#</code></dt>',
'    <dd>The "Z" in "rows X - Y of Z"</dd>',
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
'    <dd>The "X" in "rows X - Y of Z"</dd>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
'    <dd>The "Y" in "rows X - Y of Z"</dd>',
'  <dt><code>#ROW_RANGES"</code></dt>',
'    <dd>Shows: Row(s) 1-15 16-30 30-32</dd>',
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
'    <dd>Same as row ranges but in a select list<dd>',
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
'    <dd>Page Sets: 1 2 3 4 5 6</dd>',
'</dl>'))
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380761883288410007)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_text=>'When More Data Found'
,p_version_scn=>37166067046353
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(727917161242125534)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_text=>'Enter a text message to display if the chart query does not return any rows. When left empty, Oracle JET will automatically use the default message "No data to display".'
,p_version_scn=>37166067046541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617257949224049671)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_text=>'Enter the text message that displays in the <strong>Messages</strong> area, when the layer query does not return any rows.'
,p_version_scn=>37166067046550
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360867725409183853)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_text=>'Enter a text message to display if the query does not return any rows.'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(360867629489183853)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_text=>'When No Data Found'
,p_version_scn=>37166067046348
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123098313340211790)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the name of the region that triggers the dynamic action.',
'For example this could be an ''Interactive Report'' region, used in conjunction with an ''After Refresh'' event, to define a dynamic action that fire whenever the report refreshes.</p>',
'<p>Having region trigger a dynamic action can be useful when you want to define similar behavior for multiple page items in a region. However, this is only possible for certain events that are raised by items within that region.',
'For a list of events that support this type of definition and an example of how they could be utilized, see item Help for the <em>Affected Elements</em> &gt; <em>Selection Type</em> of Event Scope on the Action page.</p>'))
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123098215159211790)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_text=>'Region'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123097631797211789)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_text=>'Select the type of page element or construct to be used to trigger the event. For examples of using a specific selection type, see Help on the associated attribute.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756970862751443)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_text=>'Button'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371724184373703)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_text=>'Triggered by a button.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(880516195479481615)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_text=>'Column(s)'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371951709373704)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_text=>'Triggered by one or more columns.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47973702038258314)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.DOM_OBJECT.D'
,p_message_text=>'DOM Object'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47973837686258315)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Triggered by the DOM object (<code>document</code>, <code>window</code>) or the <em>id</em> of a DOM object (<code>myElementID</code>).</p>',
'        <p>Note: <em>DOM Object</em> is deprecated and should be replaced by <em>JavaScript Expression</em> or <em>jQuery Selector</em>.</p>'))
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516756805044751442)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_text=>'Item(s)'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371643316373703)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Triggered by one or more page items.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(855974171148605082)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_text=>'JavaScript Expression'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372116455373707)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_text=>'Triggered by the page elements returned by the JavaScript expression.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516757222317751444)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_text=>'jQuery Selector'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644372029778373706)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_text=>'Triggered by one or more page elements returned by the jQuery Selector.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(516757034246751443)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_text=>'Region'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(644371867926373704)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_text=>'Triggered by a region.'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123097511050211789)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_text=>'Selection Type'
,p_version_scn=>37166067046334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116944833887909837)
,p_name=>'PE.PROPERTY.WORKFLOW_DATA_TYPE.HELP'
,p_message_text=>'Select the data type of the workflow variable.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116946639468909838)
,p_name=>'PE.PROPERTY.WORKFLOW_DATA_TYPE.LOV.BOOLEAN.D'
,p_message_text=>'BOOLEAN'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116946326842909838)
,p_name=>'PE.PROPERTY.WORKFLOW_DATA_TYPE.LOV.NUMBER.D'
,p_message_text=>'NUMBER'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116945464621909837)
,p_name=>'PE.PROPERTY.WORKFLOW_DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_text=>'TIMESTAMP'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116945797277909837)
,p_name=>'PE.PROPERTY.WORKFLOW_DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116946020692909838)
,p_name=>'PE.PROPERTY.WORKFLOW_DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116945131658909837)
,p_name=>'PE.PROPERTY.WORKFLOW_DATA_TYPE.LOV.VARCHAR2.D'
,p_message_text=>'VARCHAR2'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116944505771909836)
,p_name=>'PE.PROPERTY.WORKFLOW_DATA_TYPE.PROMPT'
,p_message_text=>'Data Type'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116944210954909836)
,p_name=>'PE.PROPERTY.WORKFLOW_PARAM.HELP'
,p_message_text=>'Show the name of the parameter of a workflow.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116943964149909836)
,p_name=>'PE.PROPERTY.WORKFLOW_PARAM.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116948735643909840)
,p_name=>'PE.PROPERTY.WORKFLOW_PARTICIPANT_TYPE.HELP'
,p_message_text=>'Select the type of participant.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116949315205909840)
,p_name=>'PE.PROPERTY.WORKFLOW_PARTICIPANT_TYPE.LOV.ADMIN.D'
,p_message_text=>'Workflow Administrator'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116949083546909840)
,p_name=>'PE.PROPERTY.WORKFLOW_PARTICIPANT_TYPE.LOV.OWNER.D'
,p_message_text=>'Workflow Owner'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116948468089909839)
,p_name=>'PE.PROPERTY.WORKFLOW_PARTICIPANT_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116940097852909833)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.HELP'
,p_message_text=>'Select how this parameter is populated.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116942115549909835)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_text=>'Expression'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116942480881909835)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_text=>'Set to the value that results from executing the <em>Expression</em> entered.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116942736168909835)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_text=>'Function Body'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116943055080909835)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_text=>'Set to the value returned from the <em>Function Body</em> entered.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116940999229909834)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.ITEM.D'
,p_message_text=>'Item'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116941269290909834)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_text=>'Set to the value held in session state for the <em>Item</em> selected.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116943389946909836)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.NULL.D'
,p_message_text=>'Null'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116943613160909836)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.NULL.HELP'
,p_message_text=>'Set to null as no value specified.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116941500945909834)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_text=>'SQL Query (return single value)'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116941850929909835)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_text=>'Set to the first value returned from the <em>SQL Query</em> entered.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116940341980909834)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.STATIC.D'
,p_message_text=>'Static Value'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116940682250909834)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.LOV.STATIC.HELP'
,p_message_text=>'Set to the text entered into <em>Static Value</em>.'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116939713016909833)
,p_name=>'PE.PROPERTY.WORKFLOW_VALUE_TYPE.PROMPT'
,p_message_text=>'Type'
,p_version_scn=>37166067046447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117338662217910316)
,p_name=>'PE.PROPERTY.WORKFLOW_VERSION.COMPONENT_PROPERTY.WORKFLOW_VERSION.HELP'
,p_message_text=>'Version of this workflow.'
,p_version_scn=>37166067046558
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116952688055909842)
,p_name=>'PE.PROPERTY.WORKFLOW_VERSION.HELP'
,p_message_text=>'Identifies the version of this workflow.'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116952304766909842)
,p_name=>'PE.PROPERTY.WORKFLOW_VERSION.PROMPT'
,p_message_text=>'Workflow Version'
,p_version_scn=>37166067046448
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178445106128165622)
,p_name=>'PE.PROPERTY.WORKING_COPY_CREATED_BY.HELP'
,p_message_text=>'Displays the user who created the working copy.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178445085818165622)
,p_name=>'PE.PROPERTY.WORKING_COPY_CREATED_BY.PROMPT'
,p_message_text=>'Created By'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178444909151165622)
,p_name=>'PE.PROPERTY.WORKING_COPY_CREATED_ON.HELP'
,p_message_text=>'Displays the date the working copy was created on.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178444884774165622)
,p_name=>'PE.PROPERTY.WORKING_COPY_CREATED_ON.PROMPT'
,p_message_text=>'Created On'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178445575989165622)
,p_name=>'PE.PROPERTY.WORKING_COPY_DESCRIPTION.HELP'
,p_message_text=>'Use this field to provide more detailed information about the purpose of the working copy.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178445485333165622)
,p_name=>'PE.PROPERTY.WORKING_COPY_DESCRIPTION.PROMPT'
,p_message_text=>'Description'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178445382999165622)
,p_name=>'PE.PROPERTY.WORKING_COPY_NAME.HELP'
,p_message_text=>'Use this field to identify the working copy.'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178445268919165622)
,p_name=>'PE.PROPERTY.WORKING_COPY_NAME.PROMPT'
,p_message_text=>'Name'
,p_version_scn=>37166067046438
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242702251645661315)
,p_name=>'PE.PROPERTY.XML_NAMESPACES.PROMPT'
,p_message_text=>'XML Namespaces'
,p_version_scn=>37166067046411
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145008019057347651)
,p_name=>'PENDING'
,p_message_text=>'pending'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183818931557594964)
,p_name=>'PENDING_ENTRIES'
,p_message_text=>'Pending Entries'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184184319114268754)
,p_name=>'PENDING_REQUESTS'
,p_message_text=>'Pending Requests'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192599615330190891)
,p_name=>'PERCENT_CLOSED'
,p_message_text=>'Percent Closed'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191840221985300449)
,p_name=>'PERCENT_COMPLETE'
,p_message_text=>'Percent Complete'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192599919139191964)
,p_name=>'PERCENT_OPENED'
,p_message_text=>'Percent Opened'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(175290222512155447)
,p_name=>'PIE_CHART'
,p_message_text=>'Pie Chart'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184523421256451966)
,p_name=>'PKC1'
,p_message_text=>'Primary Key Column 1'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184523625758453247)
,p_name=>'PKC2'
,p_message_text=>'Primary Key Column 2'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(788943257722706279)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_text=>'Available to Install'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(788943590525714542)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_text=>'Available to Upgrade'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(788992479513877720)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_text=>'Productivity/Sample App events: %0'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(815827172437199727)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_text=>'%0 Users - %1 Views'
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1353042780494324001)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following prerequisite checks failed.  Installation of this application and its supporting objects cannot continue until these issues are resolved.</p>',
''))
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1353053656902349837)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Object Exists: <br />',
'%0'))
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1353043114951333829)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Required Privileges: <br />',
'%0'))
,p_version_scn=>37165770887532
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1018698262394077103)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this page to control access for Oracle APEX workspace administrators, application developers, and end users.</p>',
'',
'<p><strong>Workspace administrators</strong> can install, remove or upgrade applications as well as manage user accounts and development services.</p>',
'',
'<p><strong>Developers</strong> can install, remove or upgrade applications.</p>',
'',
'<p><strong>End users</strong> have no development privileges and can only access applications that do not use an external authentication scheme.</p>'))
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(788136030897253614)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_text=>'Please select a workspace from the list below'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166323500811191205)
,p_name=>'PLSQL'
,p_message_text=>'PL/SQL'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109287910476323973)
,p_name=>'PLSQL_EXPRESSION'
,p_message_text=>'PLSQL Expression'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(198743911515654775)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_text=>'List of values based on a PL/SQL function body returning a SQL statement contains errors.'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88139012086794834)
,p_name=>'PLSQL_PROCEDURE'
,p_message_text=>'PL/SQL'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170783502034938220)
,p_name=>'PLSQL_REGION'
,p_message_text=>'PL/SQL Region'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455007528625773786)
,p_name=>'PLUG-IN FILES'
,p_message_text=>'Plug-in Files'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(393558907067329921)
,p_name=>'PLUGIN'
,p_message_text=>'Plug-In'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626798916273252893)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_text=>'Component'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626797907700231443)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_text=>'Effect'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626798603329239713)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_text=>'Execute'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(820081712172678800)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_text=>'Initialize'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626797224753217524)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_text=>'Miscellaneous'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(614771189313215000)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_text=>'Navigation'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626798321898235635)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_text=>'Notification'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626797716226224457)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_text=>'Style'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366994317725621551)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_text=>' [Deprecated]'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179050708804838827)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_text=>' [Plug-in]'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589100821604942779)
,p_name=>'PLUGIN.LEGACY'
,p_message_text=>' [Legacy]'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(331836425429622805)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_text=>'Authentication Scheme Type'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10799806733191553)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_text=>'Authorization Scheme Type'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(34967402013502113)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_text=>'Dynamic Action'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(33454005832527831)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_text=>'Item'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471054223839010132)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_text=>'Process'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(33454214836530415)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_text=>'Region'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185353719531035856)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_text=>'Report Column'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1906248424207268768)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If you are entering a URL use the <code>&amp;APP_ID.</code>, <code>&amp;SESSION.</code> and <code>&amp;DEBUG.</code> substitution strings and <code>&amp;COLUMN_NAME.</code> syntax to set the row ID or primary key on the target page, or to set addi'
||'tional attribute values.</p>',
'<p><strong>Examples</strong></p>',
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
'<p>For more details on the <code>f?p</code> syntax review App Builder User''s Guide.</p>'))
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(187105405257939387)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_text=>'The plug-in has been created successfully.'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(506525228607363770)
,p_name=>'PNONUS'
,p_message_text=>'Percent of employees outside the United States'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88181523653233378)
,p_name=>'POPUP_LOV'
,p_message_text=>'popup List of Values'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244165204608174758)
,p_name=>'POPUP_TEMPLATE'
,p_message_text=>'Popup List of Values Template'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192777202222053375)
,p_name=>'POST AUTH PROCESS'
,p_message_text=>'Post-authentication Process'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192776406247045095)
,p_name=>'PRE AUTH PROCESS'
,p_message_text=>'Pre-authentication Process'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145408830895230969)
,p_name=>'PRECISION'
,p_message_text=>'Precision'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(394454169294198635)
,p_name=>'PREFERENCES'
,p_message_text=>'Preferences'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87136902890248573)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_text=>'apply permissions'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87149105015277636)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_text=>'no action required'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87140122976254366)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_text=>'revoke permissions'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25596704672454203)
,p_name=>'PREF_EQ_EXP'
,p_message_text=>'Value of Preference in Expression'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25597114023456931)
,p_name=>'PREF_NE_EXP'
,p_message_text=>'Value of Preference in Expression 1 Does NOT Equal Expression 2'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83768228070795736)
,p_name=>'PRESENTATION'
,p_message_text=>'Presentation'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(95157004818449967)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_text=>'Report printing is currently not available, there is no print server configured.'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183827030134641906)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_text=>'Advanced (requires Oracle BI Publisher)'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183835407194654185)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_text=>'Standard'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173530007194092003)
,p_name=>'PRIORITIZED'
,p_message_text=>'Prioritized'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180834618742969897)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_text=>'Problems corrected'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180834313201968299)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_text=>'Problems identified'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88049817478585185)
,p_name=>'PROCEDURE'
,p_message_text=>'procedure'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1605395316685945)
,p_name=>'PROCESS.NATIVE_CREATE_TASK'
,p_message_text=>'Human Task - Create'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612255792243942649)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_text=>'Data Loading'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2516479227865339)
,p_name=>'PROCESS.NATIVE_GEOCODING'
,p_message_text=>'Server Side Geocoding'
,p_version_scn=>86348263
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6433386161936567)
,p_name=>'PROCESS.NATIVE_INVOKE_API'
,p_message_text=>'Invoke API'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1605541799687867)
,p_name=>'PROCESS.NATIVE_MANAGE_TASK'
,p_message_text=>'Human Task - Manage'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1839492630841280)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_text=>'Execute Code'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1839660429842273)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_text=>'Send E-Mail'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4400551828429352)
,p_name=>'PROCESS.NATIVE_SEND_PUSH_NOTIFICATION'
,p_message_text=>'Send Push Notification'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26572819337304567)
,p_name=>'PROCESSES'
,p_message_text=>'Processes'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7646519991882620)
,p_name=>'PROCESSING'
,p_message_text=>'Processing your request, please wait'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487180627721795667)
,p_name=>'PRODUCTION_DOWN'
,p_message_text=>'Production Down'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(910235724161884705)
,p_name=>'PRODUCT_PORTAL'
,p_message_text=>'Product Portal'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036437413154973994)
,p_name=>'PROMPT_LABEL'
,p_message_text=>'Prompt: %0'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14645300484746131)
,p_name=>'PROVIDER'
,p_message_text=>'Provider'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14671121263752061)
,p_name=>'PROVIDER_EMAIL'
,p_message_text=>'Provider Email'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184039130113240685)
,p_name=>'PROVISIONED'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Provisioned',
''))
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290102928004507842)
,p_name=>'PROVISIONED_SPACE'
,p_message_text=>'Existing provisioned space'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183843609449692616)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_text=>'By User Request with Email verification'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183855321916696210)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_text=>'Manual'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183843917414694939)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_text=>'By User Request'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88379812739242757)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_text=>'Administrator Information'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88385421228283040)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_text=>'Tablespace will be created'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88386918589291696)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_text=>'Datafile for tablespace'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88379000618239214)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88380604559249851)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_text=>'E-mail'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88386203351287333)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_text=>'APEX_XXX'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88377720442226055)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88376714770214962)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_text=>'You have requested to provision a new %0.'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88384526638275154)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_text=>'No'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88383005167268956)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_text=>'Reuse Existing Schema'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88382225814265376)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_text=>'Schema Information'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88384905298278380)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_text=>'Schema Name'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88378101526230060)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_text=>'Workspace ID'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88378514339233719)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_text=>'System Assigned'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88381024991255715)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_text=>'Title'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88380225898246558)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_text=>'User Name'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88377307282222256)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_text=>'Workspace Information'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88383715902272057)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_text=>'Yes'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204380818325761273)
,p_name=>'PROXY_SERVER'
,p_message_text=>'Proxy Server'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87194106672372667)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_text=>'You have requested to refresh following item help'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87195629874379386)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_text=>'If this is correct, click Refresh All. Otherwise, click Cancel.'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503065216597247706)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_text=>'Administrators'
,p_version_scn=>37165770887529
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503040327998023921)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_text=>'Begin delete workspace %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503038814922001221)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Begin drop tablespace %0 for workspace %1',
''))
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503037309550961845)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_text=>'Begin drop user %0 for workspace %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503035710542933753)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_text=>'Begin purge of workspace %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503065031704242607)
,p_name=>'PURGE.BYTES'
,p_message_text=>'Bytes'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503041020510031261)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_text=>'Error deleting workspace %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503039732369015786)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_text=>'Error dropping tablespace %0 for workspace %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503038312367991115)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_text=>'Error dropping user %0 for workspace %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503032027895891442)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Dear Oracle APEX User,',
'',
'Workspace %0 on %1 has not shown any recent activity.  Your inactive workspace is currently scheduled to be purged on or after %2.',
'',
'To prevent your workspace from being removed, please click the URL below and choose that you do not wish to have your workspace purged.  You must do this within the next %3 day(s).  If you do not need this workspace any longer, no action is required.',
'',
'Confirmation link:  %4'))
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503034205647903998)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_text=>'Oracle APEX Workspace to be Purged:   Workspace %0 on %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503040603541026313)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_text=>'End delete workspace %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626884331018072649)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_text=>'End drop tablespace %0 for workspace %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503037732060968395)
,p_name=>'PURGE.END_DROP_USER'
,p_message_text=>'End drop user %0 for workspace %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503002822635360133)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_text=>'Adding workspace %0 to purge list, days inactive at least %1.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503003225191370343)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_text=>'Removing workspace %0 from purge list due to recent activity.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503004404328383224)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_text=>'Sent email to %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503006218227415670)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_text=>'Moved workspace %0 from retained list to purge list.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503063112264208623)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_text=>'Bytes'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503042701341091903)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_text=>'Count'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503062908108207396)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_text=>'Datafiles'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503062025985203141)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_text=>'Schemas'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503042419564087773)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_text=>'Status'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503043513247104859)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_text=>'Removed from Purge List (due to recent activity)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503059508099131791)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_text=>'Added Back to Purge list (previously retained but no activity in %0 days)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503044732078119779)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_text=>'Newly Added to Purge List (no activity in %0 days)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503060815680181269)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_text=>'Purged Today'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503043903335111407)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_text=>'Retained (administrator requested to not purge workspace)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503059920004144610)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_text=>'To Be Purged in %0 day(s)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503062231872204793)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_text=>'Tablespaces'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503061820790201650)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_text=>'Workspaces'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503061005422187770)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_text=>'Workspaces Remaining'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503005103420392421)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_text=>'Recorded response from email %0 value of: %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503064625685231424)
,p_name=>'PURGE.SCHEMA'
,p_message_text=>'Schema'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503036017253945135)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_text=>'Setting status of schema %0 to status %1 for workspace %2'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503036718423954942)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_text=>'Setting status of tablespace %0 to status %1 for workspace %2'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(504479805360418061)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_text=>'Oracle APEX Daily Workspace Purge Summary'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503064807116235547)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_text=>'Tablespace Name'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503066906348329951)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_text=>'Workspaces Added Back to Purge list (previously retained but no activity in %0 days)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503066710027321567)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_text=>'Workspaces Newly Added to Purge List (no activity in %0 days)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503063505469216097)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_text=>'Workspaces Purged Summary'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503064000405224120)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_text=>'Workspaces Purged Today'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503067123317334771)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_text=>'Workspaces Removed from the Purge List (due to recent activity)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503067816522342312)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_text=>'Workspaces Retained (administrator requested to not purge workspace)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503065528503260618)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_text=>'Workspaces to be Purged in %0 Day(s)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503064415296228475)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_text=>'Workspace Name'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503042215755086666)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_text=>'Purge of workspace %0 complete'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617127512110414692)
,p_name=>'PURGED'
,p_message_text=>'Purged'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1035205928130259194)
,p_name=>'PURGE_LABEL'
,p_message_text=>'Purge: %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6204834921698885)
,p_name=>'PWA.INSTALL'
,p_message_text=>'Install App'
,p_is_js_message=>true
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(267910431289557793)
,p_name=>'QB_ACTIONS'
,p_message_text=>'&nbsp;Actions'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110230728202918107)
,p_name=>'QB_CREATE_QUERY'
,p_message_text=>'Please enter a valid query to see results'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(266046512148332428)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Name already used by existing query in Query Builder or SQL Command Processor.<br> ',
'Please select a new name and save again.'))
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165759207818452233)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_text=>'Nothing to save.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152093709202299884)
,p_name=>'QB_SAVE_QUERY'
,p_message_text=>'Query Saved.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(276741830197619154)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_text=>'Table Actions'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(276742203316620888)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_text=>'View Actions'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(238805331740231559)
,p_name=>'QB_WARN_MESSAGE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Visual Query Builder is not able to open the current query.<br>',
'Click Create to replace your current query with a new one, or click Return to keep your current query.'))
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(238589721770166877)
,p_name=>'QUERY'
,p_message_text=>'Query'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26331015907250250)
,p_name=>'QUERY BUILDER'
,p_message_text=>'Query Builder'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101364420500305976)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_text=>'invalid query, no select statement found'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26172500066477535)
,p_name=>'QUESTIONS'
,p_message_text=>'Questions'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484316002177881236)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_text=>'Numeric format mask: 999G999G999G999G990'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(296683019528536683)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_text=>'Data Load Report'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112040512266258395)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_text=>'Analysis'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181703424645200607)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_text=>'Average %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61016502303524210)
,p_name=>'QUICK_APP_BY'
,p_message_text=>'By %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112072924518271323)
,p_name=>'QUICK_APP_CHARTS'
,p_message_text=>'Charts'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61013630438513480)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_text=>'Chart by %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60924217260358256)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_text=>'Detail View'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112071616206268967)
,p_name=>'QUICK_APP_REPORTS'
,p_message_text=>'Reports'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181703903221222858)
,p_name=>'QUICK_APP_SUM'
,p_message_text=>'Sum %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(340910764307305163)
,p_name=>'QUICK_SQL'
,p_message_text=>'Quick SQL'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815519331326252)
,p_name=>'RANGE2DCOLUMN'
,p_message_text=>'Range 2D Column'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815609336326252)
,p_name=>'RANGE3DCOLUMN'
,p_message_text=>'Range 3D Column'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3302267425221312565)
,p_name=>'READERS'
,p_message_text=>'Readers'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1137919885860539500)
,p_name=>'REASSIGN_ITEM'
,p_message_text=>'Reassign Item: %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7896209998918062)
,p_name=>'REASSIGN_PAGES'
,p_message_text=>'Reassign Pages'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145356213140169140)
,p_name=>'RECYCLE_BIN'
,p_message_text=>'Recycle Bin'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(289237004562832719)
,p_name=>'REDIRECT'
,p_message_text=>'Redirect'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(289479018274101668)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_text=>'This button will redirect to a URL and will most likely not cause the page to be submitted.  If you want your button to submit the page, do not identify a redirect page or URL.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109160129197080393)
,p_name=>'REDIRECT_TO'
,p_message_text=>'Redirect To %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(389132198696753083)
,p_name=>'REDIRECT_TO_APP'
,p_message_text=>'Redirect to application %0, page %1'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109159622271078326)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_text=>'Redirect to page %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26148620452104987)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_text=>'Redirect to Page in this Application'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26149329109107488)
,p_name=>'REDIRECT_TO_URL'
,p_message_text=>'Redirect to URL'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(163585421568392762)
,p_name=>'REFERENCED'
,p_message_text=>'Referenced'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26401423724143280)
,p_name=>'REGEN_VER'
,p_message_text=>'Regenerate verification code'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165836924820005872)
,p_name=>'REGION'
,p_message_text=>'region'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(272647017101888257)
,p_name=>'REGION BUTTON POSITONS'
,p_message_text=>'Region Button Positions'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192778024732059858)
,p_name=>'REGION CONDITION'
,p_message_text=>'Region Condition'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190190404669901415)
,p_name=>'REGION CONTENT'
,p_message_text=>'Region Content'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22436914686598075)
,p_name=>'REGION.BUTTONS'
,p_message_text=>'Region Buttons'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2002391693274760)
,p_name=>'REGION.CLIENTSIDETEMPLATOR.ERROR'
,p_message_text=>'Web Service Request failed.'
,p_is_js_message=>true
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26572412757302692)
,p_name=>'REGIONS'
,p_message_text=>'Regions'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(95263500801921209)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_text=>'Regions List Template Override'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170065088538521202)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_text=>'Region Display Selector'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3712502963424)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_text=>'Breadcrumb'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385676934015716732)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_text=>'Calendar'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601392065588394)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_text=>'Cards'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(156092423787297853)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_text=>'Calendar'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10799322975344307)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_text=>'Data Upload Column Mapping'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(168073913219897651)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_text=>'Region Display Selector'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2100794844649328)
,p_name=>'REGION_NAME.NATIVE_DYNAMIC_CONTENT'
,p_message_text=>'Dynamic Content'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472094460514706083)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_text=>'Faceted Search'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(251809545166097799)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_text=>'Form'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783624373361)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_text=>'Help Text'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(260844772422580714)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_text=>'Interactive Grid'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380525630203463196)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_text=>'Interactive Report'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153868354947294714)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_text=>'Chart'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(653850496644762574)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_text=>'Column Toggle Report'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10799126044316782)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_text=>'List View'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(653850666997764183)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_text=>'Reflow Report'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385677317649721510)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_text=>'Tree'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3711204144950)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_text=>'List'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(659652125394048064)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_text=>'Map'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485353945092630375)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_text=>'PL/SQL'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7206722514570037)
,p_name=>'REGION_NAME.NATIVE_SEARCH'
,p_message_text=>'Search'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385503419777084174)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_text=>'Chart (HTML - LEGACY)'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(55640736522783875)
,p_name=>'REGION_NAME.NATIVE_SMART_FILTERS'
,p_message_text=>'Smart Filters'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380039741334727348)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_text=>'Report'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(485354181157631565)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_text=>'Static Content'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385503248638082367)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_text=>'Chart (SVG - LEGACY)'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(380529094634639135)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_text=>'Tabular Form'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(385677163663718406)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_text=>'Classic Tree'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3782393874005)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_text=>'URL'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2687073145241212)
,p_name=>'REGION_NAME.TEMPLATE_REPORT'
,p_message_text=>'Template Report'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59935122259946294)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_text=>'No Template'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171867929785881675)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_text=>'Rejected or Duplicate'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183993615316593125)
,p_name=>'RELEASE'
,p_message_text=>'Release'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14672114121759502)
,p_name=>'RELEASED'
,p_message_text=>'Released'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192630026794846994)
,p_name=>'RELEASE_SUMMARY'
,p_message_text=>'Release Summary'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192628922676798471)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_text=>'Release summary for workspace: %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(819906230676778065)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_text=>'More Information'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1448928063715190229)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-MediaBlock-graphic">',
'    <span role="img" aria-label="Warning" class="a-Icon a-Icon--medium icon-warning u-warning-text"></span>',
'</div>',
'<div class="a-MediaBlock-content">PL/SQL Web Toolkit %0 required <a href="%1" target="_blank">[More Information]</a></div>'))
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1448927655673176659)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-MediaBlock-graphic">',
'    <span role="img" aria-label="Warning" class="a-Icon a-Icon--medium icon-warning u-warning-text"></span>',
'</div>',
'<div class="a-MediaBlock-content">Patch Set %0 is available <a href="%1" target="_blank">[More Information]</a></div>'))
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1448927818167183126)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-MediaBlock-graphic">',
'    <span role="img" aria-label="Warning" class="a-Icon a-Icon--medium icon-warning u-warning-text"></span>',
'</div>',
'<div class="a-MediaBlock-content">Oracle APEX %0 is available <a href="%1" target="_blank">[More Information]</a></div>'))
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(819905431930768973)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-MediaBlock-graphic">',
'    <span role="img" aria-label="Success" class="a-Icon a-Icon--medium icon-check-circle-s u-success-text"></span>',
'</div>',
'<div class="a-MediaBlock-content">System is up-to-date</div>'))
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617128029734467063)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_text=>'Removed due to Activity'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14644406933738436)
,p_name=>'REMOVE_APPLICATION'
,p_message_text=>'Remove'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(590338203935701441)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_text=>'The application definition will be removed as well as all the supporting objects that were created.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(207766609833703705)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_text=>'The workspace has been successfully removed.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270360524702877030)
,p_name=>'RENAME_COLUMN'
,p_message_text=>'Rename column %0 to %1'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270364528343915901)
,p_name=>'RENAME_TABLE'
,p_message_text=>'Rename table %0 to %1'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117420607704823960)
,p_name=>'REORDER_BUTTONS'
,p_message_text=>'Reorder Region Buttons'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118971307631595839)
,p_name=>'REORDER_NAVBAR'
,p_message_text=>'Reorder Navigation Bar Entries'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117421013937825702)
,p_name=>'REORDER_REGIONS'
,p_message_text=>'Reorder Regions'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117295712079024861)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_text=>'Reorder Region Items'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118889506564368399)
,p_name=>'REORDER_TABS'
,p_message_text=>'Reorder Tabs'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152089826339266916)
,p_name=>'REPORT COLUMNS'
,p_message_text=>'Report Columns'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1034408900878293120)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_text=>'Report Alias: %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152468725215985737)
,p_name=>'REPORT_COLUMN'
,p_message_text=>'report column'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236522103729398744)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_text=>'Report Columns'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200680923476614845)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_text=>'Report Column Template'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200443410763924741)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_text=>'The Form and Report have been created successfully.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184027314333046914)
,p_name=>'REPORT_GENERATED'
,p_message_text=>'Report Generated'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244184016408245217)
,p_name=>'REPORT_LAYOUT'
,p_message_text=>'Report Layout'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(137273529623528928)
,p_name=>'REPORT_ON'
,p_message_text=>'Report on %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236524122886435460)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_text=>'Report Page Attributes'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59709016412598666)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_text=>'Query is valid. Bind variables parsed.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244183103265236161)
,p_name=>'REPORT_QUERY'
,p_message_text=>'Report Query'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(140167123327275116)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_text=>'Step 1 - Download XML file'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(140167628175276574)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_text=>'Step 2 - Design report layout and save as RTF file'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(140171201210297122)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_text=>'Step 2 - Upload XSL-FO file'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(140168031638277539)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_text=>'Step 3 - Upload RTF file'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(198244927680516962)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_text=>'Report Rows Fetched'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262109718714591574)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_text=>'The report has been created successfully.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200682219451623180)
,p_name=>'REPORT_TEMPLATE'
,p_message_text=>'Report Template'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206214406383459700)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_text=>'The Report on Web Service page has been created successfully.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(158193321432286366)
,p_name=>'REQUEST'
,p_message_text=>'Request'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195670017785004163)
,p_name=>'REQUESTED'
,p_message_text=>'Requested'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(466780910201258971)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_text=>'%0 of workspace "%1" has requested change of database size of an additional %2'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(466780613879250600)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_text=>'%0 has requested a new schema for workspace "%1" with %2'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(466774329791103790)
,p_name=>'REQUEST_WORKSPACE'
,p_message_text=>'%0 requests new workspace "%1" with size of %2'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15645303797592553)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_text=>'%0 requests new workspace "%1"'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176655825277023453)
,p_name=>'RESEARCHING'
,p_message_text=>'Researching'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5845819303536058)
,p_name=>'RESET_4000'
,p_message_text=>'Reset'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22406808491591448)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_text=>'Reset to null value'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16905902533757713)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_text=>'Resource Manager Consumer Group'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(402732561673678607)
,p_name=>'RESTRICTED_ACCESS'
,p_message_text=>'Restricted Access'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114383832758775587)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_text=>'Restricted - May not be set from browser'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(202640513896354025)
,p_name=>'REST_SUCCESS_MSG'
,p_message_text=>'The Web Service Reference has been added to Application %0.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49771200900356795)
,p_name=>'REST_WS.ALIASED'
,p_message_text=>'Aliased'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(542897905216769512)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX RESTful Services is in read only mode.</p>',
'',
'<p>You may use the APEX based RESTful services as they are defined. However, Oracle encourages migration of these services to ORDS by clicking <strong>Migrate to ORDS RESTful Services</strong>.</p>',
''))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(521580885894150813)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_text=>'Cannot find the current running version of ORDS. '
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49770040426349162)
,p_name=>'REST_WS.DISABLED'
,p_message_text=>'Disabled'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(542891988583619117)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This action will de-register and remove all ORDS REST Service definitions for the selected schema. This action cannot be undone.</p>',
'',
'<p>Are you sure you wish to de-register this schema?</p>'))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(138295137632160300)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_text=>'An APEX Path Prefix with this value is already defined for another workspace.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161639618436179872)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_text=>'This schema alias is already in use by another schema.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49769878531347406)
,p_name=>'REST_WS.ENABLED'
,p_message_text=>'Enabled'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715162741218784647)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_text=>'Total Enabled Objects'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42669356497464991)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_text=>'The Glob (*) character may only appear in a Route Pattern as the last character and may only be preceded by a Named Parameter or a forward slash (/).'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468879649786732985)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_text=>'Handler Created'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468880053028735554)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_text=>'Handler Deleted'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(453345471456460680)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_text=>'Expecting a Handler ID and received NULL'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468879895439734206)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_text=>'Handler Updated'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42669199555460450)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_text=>'Invalid characters were found in the literal portions of the Route Pattern.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(64015307867021061)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_text=>'Authorization Required'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(929159189586099286)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div style="padding:20px; font-size: 12px;"><p>APEX has detected that your workspace contains 2 or more APEX Based REST modules with NULL URI Prefixes. ORDS does not allows more than one Module to have the same base URI Prefix. </p>',
'',
'<p>In order to migrate these services to ORDS, the following rules will be applied: </p>',
'',
'<ul>',
'<li>All affected modules will be collapsed into a single ORDS module named <em><strong>merged.apex.rest.services</strong></em>.</li>',
'<li>If <strong><em>any</em></strong> of the APEX based modules being merged are published, the new merged module <strong><em>will be published</em></strong>.</li>',
'<li>If <strong><em>none</em></strong> of the APEX based modules being merged are published, the new merged module <strong><em>will not be published</em></strong>.</li>',
'<li><strong><em>All roles</em></strong> associated with APEX based modules being merged <strong><em>will be assigned to the new merged module</em></strong>.</li>',
'<li>The <strong><em>pagination size</em></strong> of the merged module will be set to the <strong><em>largest pagination size</em></strong> from the modules being merged.</li>',
'<li>If there are APEX modules with NULL base URI''s that also have duplicate template URI''s the following will occur:',
'',
'<ul>',
'<li>The most recently updated template will maintain the duplicate URI</li>',
'<li>All other templates will be prefixed with dup001_*</li>',
'<li>The comment for the template will contain the original module name from which it was migrated and the original template URI</li>',
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715162100278778911)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_text=>'Total Modules'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468878323982700815)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_text=>'Module Created'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468878817255718025)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_text=>'Module Deleted'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(453345005575456578)
,p_name=>'REST_WS.MODULE_ID'
,p_message_text=>'Expecting a Module ID and received NULL'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468878602662711653)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_text=>'Module Updated'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42668740501446527)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_text=>'A named parameter within the Route Pattern contains invalid characters.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(569526976195665708)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_text=>'This schema has not been registered with ORDS RESTful Data Services. To register this schema click <strong>Register Schema with ORDS</strong>.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42669564063474921)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_text=>'The URI did not match either URI or ROUTE style pattern.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42669764833478307)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_text=>'It is not allowed to have more than 1 consecutive forward slash.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42668556939434654)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_text=>'You are not allowed to have a query string for a Route Pattern.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11666091259717329)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_text=>'<p>APEX is currently running in the CDB. You cannot define ORDS based REST Services in the CDB.</p><p>You may continue to use the APEX Based RESTful Services.</p>'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(542886380300533352)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The currently installed ORDS version (%0) does not support all functionality required to enable the ORDS Based RESTful Services in Oracle APEX. A minimum version of %1 must be installed.</p>',
'<p>You may continue to use the APEX Based RESTful Services.</p>'))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42668981590451975)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_text=>'The Optional (?) character may only appear in a Route Pattern as the last character and must be preceded by a Named Parameter.'
,p_version_scn=>37166027478155
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42263536094497870)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_text=>'<p>The system was unable to locate the ORDS_METADATA schema, which is required to enable the ORDS REST Workshop. Please refer to the Oracle REST Data Services Installation Guide for installation steps.</p> <p>You may continue to use the APEX Based RE'
||'STful Services.</p>'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49771017108355237)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_text=>'Partially Secured'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42092348727444112)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_text=>'<p>This system is currently using the Oracle Embedded PL/SQL Gateway. You must install  version %0 or above of Oracle REST Data Services in order to enable access to the ORDS REST Workshop.</p> <p>You may continue to use the APEX Based RESTful Servic'
||'es.</p>'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715162342645780761)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_text=>'Total Privileges'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468880871261766444)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_text=>'Privilege Created'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468881288057770198)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_text=>'Privilege Deleted'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468881007657767926)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_text=>'Privilege Updated'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49770201168350431)
,p_name=>'REST_WS.PUBLISHED'
,p_message_text=>'Published'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(50135430791675039)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This action will drop and recreate the <strong>oracle.example.hr</strong> module and related database objects in the currently selected schema. Any changes or additions that have been made will be lost and cannot be undone.</p>',
'<p>Are you sure you wish to reset the sample service?</p>'))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715162536186782248)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_text=>'Total Roles'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468880268970743744)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_text=>'Role Created'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468880635679754555)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_text=>'Role Deleted'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468880427178745272)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_text=>'Role Updated'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(64014793457018302)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_text=>'Access Status'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(64015729038022941)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_text=>'Schema Alias'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(533705856015668787)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_text=>'The uploaded script is too large. Oracle APEX has a limit of 32MB (32767 bytes).'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49770693963352505)
,p_name=>'REST_WS.SECURED'
,p_message_text=>'Secured'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(453345278784458090)
,p_name=>'REST_WS.SEQ_ID'
,p_message_text=>'Expecting a Sequence ID for Parameter and received NULL'
,p_version_scn=>37166027480330
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715178693094867317)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_text=>'Failure'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715178444472865802)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_text=>'Success'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715178861699868991)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_text=>'Warning'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468879030665721066)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_text=>'Template Created'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468879456895725442)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_text=>'Template Deleted'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(453345651335463922)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_text=>'Expecting a Template ID and received NULL'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22580233089094698)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_text=>'The URI Template may not be null.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468879282335723300)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_text=>'Template Updated'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49771630569361035)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_text=>'Enabled Objects'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49771822648362553)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_text=>'Modules'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49772048574367960)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_text=>'Privileges'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49772208709369481)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_text=>'Roles'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(658953290150256112)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_text=>'RESTful Data Services'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49771435557358410)
,p_name=>'REST_WS.UNALIASED'
,p_message_text=>'Unaliased'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49770459544351400)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_text=>'Unpublished'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49770847797353550)
,p_name=>'REST_WS.UNSECURED'
,p_message_text=>'Unsecured'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42668332242426468)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_text=>'One or more of the URI variables have a syntax error.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(395576498395061834)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_text=>'The script you are trying to load is an APEX based RESTful Service export. It cannot be loaded using the ORDS RESTful Services import page.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(565748740497781605)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_text=>'The script you are trying to load is an ORDS based RESTful Service export. It cannot be loaded using the APEX RESTful Services import page.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715182722880925973)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_text=>'Copy to clipboard'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715183076648930143)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_text=>'Copy Full URL to Clipboard'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617127801684459029)
,p_name=>'RETAINED'
,p_message_text=>'Retained'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(103007129381800449)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_text=>'Return to %0 Login Page'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1959701819333061620)
,p_name=>'RETURN_VALUE.N'
,p_message_text=>'Return Value: %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176656704976027027)
,p_name=>'REVIEWING'
,p_message_text=>'Reviewing'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(389072025008658774)
,p_name=>'ROLE'
,p_message_text=>'Role'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106602231058408408)
,p_name=>'ROLLBACK'
,p_message_text=>'Rollback statement not applicable.  All statements are automatically committed.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270740728276854233)
,p_name=>'ROWS_IN_SECONDS'
,p_message_text=>'%0 rows returned in %1 seconds'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26069125459601000)
,p_name=>'ROWS_RETURNED_IN'
,p_message_text=>'rows returned in'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361821302572360316)
,p_name=>'RUN'
,p_message_text=>'Run'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3554408236532257)
,p_name=>'RUN_AND_BUILD'
,p_message_text=>'Run and Develop'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165845926467025342)
,p_name=>'RUN_APPLICATION'
,p_message_text=>'Run Application'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(371962518542008561)
,p_name=>'RUN_APPLICATION_ID'
,p_message_text=>'Run Application: %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104599401770349222)
,p_name=>'RUN_ONLY'
,p_message_text=>'Run Only'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(374310508445477947)
,p_name=>'RUN_PAGE_ID'
,p_message_text=>'Run Page: %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22440808808672097)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_text=>'Sample Applications'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345254039514755456)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_text=>'Countries'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345254655183767067)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_text=>'Listing of countries, population, and capital.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98074327478492109)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_text=>'EMP / DEPT'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98074537760493946)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_text=>'The generic EMP and DEPT tables.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345254229501757722)
,p_name=>'SAMPLE_DS.F1'
,p_message_text=>'Formula 1'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345267116908775700)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_text=>'Formula 1 World Champions'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(616633601230939673)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_text=>'Health Updates'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(616633817556940975)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_text=>'Simplified patient-reported health status updates for health providers.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98074790433496136)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_text=>'HR Data'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98074948406502585)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_text=>'The generic HR tables commonly used by Oracle Education.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(372967357600650914)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_text=>'Customer Orders'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(372967515899659906)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_text=>'A collection of customers, stores, products, and orders. This dataset includes JSON data for the product description, and longitude / latitude for the stores.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98073376208481738)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_text=>'Project Data'
,p_version_scn=>37165770887606
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98073713092484466)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_text=>'A collection of projects, milestones, tasks, and more. This dataset includes master-detail-detail relationships and a useful view for charting.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98075749485505263)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_text=>'Tasks Spreadsheet'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(98081566754527646)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_text=>'A single table with unnormalized data containing tasks, dates, status, assigned to, cost, and budget.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345253802258754059)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_text=>'Tennis'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345255504460771958)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_text=>'Mens and Womens winners and runners-up for Grand Slam events'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345254448774760316)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_text=>'World Cup'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345267311635778526)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_text=>'Soccer World Cup results'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195757224288500821)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_text=>'Link Alias'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195757608835505852)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_text=>'Link Example'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195758032038512565)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_text=>'More Saved Reports...'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195747921359263458)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_text=>'Primary Report'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195136301985131895)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_text=>'Private'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195136623803138186)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_text=>'Private Subscription'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195744301629983402)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_text=>'Public'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195756520348490239)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_text=>'Report Name'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195756016061479568)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_text=>'Report Type'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(70816128451848470)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_text=>'Breadcrumb entry deleted.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(70816537137851220)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_text=>'Breadcrumb entry created.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(70816385958849833)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_text=>'Breadcrumb entry updated.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(70815967112846952)
,p_name=>'SC.BC.BC_DELETED'
,p_message_text=>'Breadcrumb deleted.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(70815766211845639)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_text=>'Breadcrumb updated.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48200711283690315)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_text=>'Interactive Grid Column'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48200507193688897)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_text=>'Page Item'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184184000414263384)
,p_name=>'SCHEMAS'
,p_message_text=>'Schemas'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290114226282583003)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_text=>'wwv_flow_companies schema insert exception'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290100500384480976)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_text=>'The schema "%0" is available.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290101520255496142)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_text=>'The schema "%0" is NOT available at this time and cannot be created because it conflicts with an existing user.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145564330783372942)
,p_name=>'SCHEMA_PASSWORD'
,p_message_text=>'Schema Password'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88183510110276832)
,p_name=>'SCHEMES'
,p_message_text=>'schemes'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(712297812327407378)
,p_name=>'SCREEN_READER'
,p_message_text=>'Screen Reader'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200273628354593096)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_text=>'Screen Reader Toggle'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(241288411883636761)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_text=>'This file was exported from another workspace (%0), possibly from another %1 database.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(857365715723181622)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_text=>'Script %0 locked'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(857365427292175602)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_text=>'Script %0 unlocked'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(925750575258630812)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_text=>'Script is not locked'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181934614458415765)
,p_name=>'SC_DESCRIBE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'To describe an object, type <br><br> ',
'',
'DESCRIBE &lt object name &gt in the command pane above and click Run.',
'</pre>'))
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190531806484781806)
,p_name=>'SC_NAME_NN'
,p_message_text=>'Query Name may not be null'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(198575311481875158)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
'Object to be described could not be found.',
'</pre>'))
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191887013145865437)
,p_name=>'SC_SC'
,p_message_text=>'Non-Visual Query'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(160852416487687134)
,p_name=>'SC_SQL_RUNNING'
,p_message_text=>'SQL Statement Running'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191885604141862825)
,p_name=>'SC_VQ'
,p_message_text=>'Visual Query'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(622851713712932872)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_text=>'Search Bar Settings'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1811456330274674)
,p_name=>'SEARCH_CONFIG'
,p_message_text=>'Search Configuration'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1811815284277177)
,p_name=>'SEARCH_CONFIGS'
,p_message_text=>'Search Configurations'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244113401646309990)
,p_name=>'SEARCH_FIELD'
,p_message_text=>'Search Field'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145656807237458052)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_text=>'There are no varchar columns in this query.  Search cannot be enabled.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(140356327960435938)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_text=>'There are no varchar columns to search on.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242888423456960370)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_text=>'Search Productivity and Sample Applications'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(559171036991269284)
,p_name=>'SEARCH_RESULTS'
,p_message_text=>'Search Results'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003137653993328)
,p_name=>'SEARCH_SOURCES'
,p_message_text=>'Search Region Sources'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623901810810622685)
,p_name=>'SECTIONS'
,p_message_text=>'Sections'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86629230708414559)
,p_name=>'SECURITY'
,p_message_text=>'Security'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184002009261629258)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_text=>'Security Assignee'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(504378531138186149)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_text=>'Security Group ID (your workspace identity) is invalid.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183995304019599294)
,p_name=>'SECURITY_IMPACT'
,p_message_text=>'Security Impact'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204380214516760122)
,p_name=>'SECURITY_SCHEME'
,p_message_text=>'Authorization Scheme'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192388428493677390)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_text=>'Must Not Be Public User'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184003732463635940)
,p_name=>'SECURITY_STATUS'
,p_message_text=>'Security Status'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192134723105969373)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_text=>'See attached report'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20602053554358091)
,p_name=>'SELECT_ALL'
,p_message_text=>'Select All'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145086727255491959)
,p_name=>'SELECT_APPLICATION'
,p_message_text=>'Select Application'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27001923708058831)
,p_name=>'SELECT_ATLEAST_ONE_ROW'
,p_message_text=>'Please select at least one row.'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4290112238864665)
,p_name=>'SELECT_DATE'
,p_message_text=>'Select a date from the table. Current Month = %0, Current Year = %1'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(588479303155716800)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_text=>'Select dynamic action'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87050526149009278)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_text=>'Theme'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87044415283996684)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_text=>'Theme'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87040805802984558)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_text=>'Theme'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87003402591926859)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_text=>'Theme'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87059325588018648)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_text=>'Theme'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1199060097431490802)
,p_name=>'SELECT_ROW_C'
,p_message_text=>'Select Row: %0'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(356224527314061099)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_text=>'Select a workspace from below to open the Oracle APEX development environment.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255029913228790514)
,p_name=>'SELF_SERVICE'
,p_message_text=>'Self Service'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255029715384789478)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_text=>'Self Service with Email Verification'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(856471610240356162)
,p_name=>'SEPARATOR'
,p_message_text=>'Separator'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88050221288586298)
,p_name=>'SEQUENCE'
,p_message_text=>'sequence'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(335346704763175110)
,p_name=>'SEQUENCE_LABEL'
,p_message_text=>'Sequence: %0'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26870432271659957)
,p_name=>'SERIES'
,p_message_text=>'Series %0'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183826505630615852)
,p_name=>'SERVICE_CHANGE'
,p_message_text=>'Service Change'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12757112327140649)
,p_name=>'SERVICE_LOGIN'
,p_message_text=>'Site Administration'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171866928616871926)
,p_name=>'SERVICE_REQUEST'
,p_message_text=>'Service Request'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88374010221185214)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_text=>'Enter case sensitive Verification Code and click <strong>Submit Request</strong>.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88368422033141292)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_text=>'Administrator Information'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88372809051175372)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_text=>'Database Size'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88368010259137953)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88369621471150584)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_text=>'E-mail'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88368832076144203)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_text=>'First Name'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88367330906134404)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_text=>'Justification'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88369211082147593)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_text=>'Last Name'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88366503548126467)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88371618270168577)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_text=>'No'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88370032207153677)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_text=>'Phone'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88370826451161542)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_text=>'Reuse Existing Schema'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88370414330157995)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_text=>'Schema Information'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88372030045171982)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_text=>'Schema Name'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88365720039121793)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_text=>'Workspace Information'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88371207189165451)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_text=>'Yes'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148727014020912891)
,p_name=>'SESSION'
,p_message_text=>'Session'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192776030357042570)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_text=>'Session Verification Function'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22969323730368374)
,p_name=>'SESSIONS'
,p_message_text=>'Sessions'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(253081329161432951)
,p_name=>'SESSION_MON_BUFFER'
,p_message_text=>'Buffer:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(253079316348429226)
,p_name=>'SESSION_MON_CPU'
,p_message_text=>'CPU:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(251877521114631256)
,p_name=>'SESSION_MON_CURRENT'
,p_message_text=>'Current'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(253080222928431191)
,p_name=>'SESSION_MON_DISK'
,p_message_text=>'Disk:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(253078410807427608)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_text=>'Elapsed:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(251878328387633345)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_text=>'Previous'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58564323882322968)
,p_name=>'SET_BINDS'
,p_message_text=>'Values for all bind variables must be set when testing a query.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18928432203156858)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_text=>'Set due date of the %0 incomplete features assigned to %1 for release %2 to date of milestone'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(68483408064095540)
,p_name=>'SET_MILESTONE'
,p_message_text=>'Set Milestone'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18937202720470053)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_text=>'Set features with missing milestones to milestone (%3) for the %0 incomplete features assigned to %1 for release %2.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18933416507294286)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_text=>'Change milestone of %0 incomplete features assigned to %1 for release %2 that correspond to a past due milestone to milestone (%3).'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(67991126586063027)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_text=>'%0 open feature(s) will be assigned to the selected milestone.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(68777227850129641)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_text=>'%0 open feature(s) due date will be set to the milestone date.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(890618829574776254)
,p_name=>'SET_PREFERENCES'
,p_message_text=>'Set Preferences'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(68976718893155433)
,p_name=>'SET_RELEASE'
,p_message_text=>'Set Release'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(250975707068465787)
,p_name=>'SHARED'
,p_message_text=>'Shared'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455022113369968126)
,p_name=>'SHARED COMPONENTS'
,p_message_text=>'Shared Components'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192773831480023944)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_text=>'Shared Dynamic List of Values'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7691321432337239)
,p_name=>'SHARED POOL'
,p_message_text=>'Shared Pool'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192773419013020347)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_text=>'Shared Static List of Values Condition'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32088113155199298)
,p_name=>'SHARED_COMPONENT'
,p_message_text=>'Shared Component'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(445860205875499593)
,p_name=>'SHARED_VALIDATION'
,p_message_text=>'Shared Validation'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88184507124285370)
,p_name=>'SHORTCUT'
,p_message_text=>'shortcut'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358905323524802585)
,p_name=>'SHORTCUTS'
,p_message_text=>'Shortcuts'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(172745930121433563)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_text=>'Significant Impact'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(174645023663663695)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_text=>'Significant Progress'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88141200835829449)
,p_name=>'SIMPLE'
,p_message_text=>'simple'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170628605230893154)
,p_name=>'SIMPLE_CHART'
,p_message_text=>'Simple Chart'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(222550714292471997)
,p_name=>'SINCE_DATE_MASK'
,p_message_text=>'16 hours ago'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(275508543726335983)
,p_name=>'SINCE_DAY_AGO'
,p_message_text=>'1 day ago'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(275508355561334273)
,p_name=>'SINCE_HOUR_AGO'
,p_message_text=>'1 hour ago'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1055111383922183363)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_text=>'in 16h'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(275508927405337550)
,p_name=>'SINCE_WEEK_AGO'
,p_message_text=>'1 week ago'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21687822556891571)
,p_name=>'SIZE'
,p_message_text=>'Size'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(716926574845319773)
,p_name=>'SL.APP'
,p_message_text=>'App'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(708178661932946176)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_text=>'Edit Page %0 in application %1'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(708184357140999808)
,p_name=>'SL.GO.TO.APP'
,p_message_text=>'Go to application %0'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(97082876892163477)
,p_name=>'SL.GOTO'
,p_message_text=>'Go to %0, %1, %2, %3'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(97082671518160406)
,p_name=>'SL.LABEL'
,p_message_text=>'Spotlight Search'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567252396076417182)
,p_name=>'SL.MATCH.FOUND'
,p_message_text=>'1 match found'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(567252559722418794)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_text=>'%0 matches found'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(584479579388865290)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_text=>'No match found'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(716926733643320773)
,p_name=>'SL.PAGE'
,p_message_text=>'Page'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(377013641535362670)
,p_name=>'SL.PLACEHOLDER'
,p_message_text=>'Search'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1412549101811679)
,p_name=>'SL.SEARCH.AI'
,p_message_text=>'Search using AI for %0'
,p_is_js_message=>true
,p_version_scn=>36719936
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(398827021383246571)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_text=>'Search all applications for %0'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(709140850001087651)
,p_name=>'SL.SEARCH.APP'
,p_message_text=>'Search this App for %0'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(517450231018157581)
,p_name=>'SL.SEARCH.HELP'
,p_message_text=>'Please enter at least two letters to search'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(709140401581082309)
,p_name=>'SL.SEARCH.PAGE'
,p_message_text=>'Search Page for %0'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(709141085886091786)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_text=>'Search Team Development for %0'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(709141280367098173)
,p_name=>'SL.SEARCH.USER'
,p_message_text=>'Search user %0'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(709141463626101750)
,p_name=>'SL.SEARCH.WP'
,p_message_text=>'Search Workspace for %0'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(708659288410164160)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_text=>'Shared Components of App %0'
,p_is_js_message=>true
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171866230216862851)
,p_name=>'SOFTWARE_DEFECT'
,p_message_text=>'Software Defect'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173505814486545420)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_text=>'Somewhat desirable'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484869605111128593)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_text=>'Source Identifier'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290104617054514123)
,p_name=>'SPACE_UTILIZATION'
,p_message_text=>'Existing space utilization'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61946809247791406)
,p_name=>'SPOTLIGHT'
,p_message_text=>'Spotlight'
,p_is_js_message=>true
,p_version_scn=>37165770887541
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165989324539390343)
,p_name=>'SQL NOT AVAILABLE'
,p_message_text=>'SQL not available'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359248819750154500)
,p_name=>'SQL WORKSHOP'
,p_message_text=>'SQL Workshop'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270731031365628070)
,p_name=>'SQL_COMMANDS'
,p_message_text=>'SQL Commands'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184180606638189457)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_text=>'SQL Command History'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109287429045319871)
,p_name=>'SQL_EXPRESSION'
,p_message_text=>'SQL Expression'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206218800611098777)
,p_name=>'SQL_INJECT_LINE'
,p_message_text=>'Line'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206217815717093644)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_text=>'Package'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206218121605095316)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_text=>'Procedure'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206217510869092259)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_text=>'Schema'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206218429570097635)
,p_name=>'SQL_INJECT_VAR'
,p_message_text=>'Variable'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(492114715249514192)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_text=>'SQL and PL/SQL access is not enabled for this application.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(492114923214516497)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_text=>'SQL and PL/SQL access is not enabled for this instance.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88137431039743484)
,p_name=>'SQL_QUERY'
,p_message_text=>'SQL Query'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10732429433808116)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_text=>'Invalid query, no select statement found'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118154403768390051)
,p_name=>'SQL_REPORT'
,p_message_text=>'SQL Report'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42556629786166028)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_text=>'Append'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87140931634256903)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_text=>'Default'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87165330127322693)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_text=>'Disable Sort Column'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87137303929248901)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_text=>'Display Value'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87147015620271186)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_text=>'Primary Sort Column'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42556425284164699)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_text=>'Replace'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87139718821253252)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_text=>'Return Value'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87163501730314472)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_text=>'Secondary Sort Column'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87164316621318856)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_text=>'Select Column'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184181231226196583)
,p_name=>'SQL_SCRIPTS'
,p_message_text=>'SQL Scripts'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184180921875193889)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_text=>'SQL Script Results'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487137713776034826)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_text=>'The following database objects need to be defined on the permissible table list: %0'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184181512310200544)
,p_name=>'SQL_WORKSHOP'
,p_message_text=>'SQL Workshop'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110400475719854328)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_text=>'The alias specified is already in use by another object.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110400277898857629)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_text=>'The Object alias you have provided is invalid. Valid aliases may only contain letters, numbers, underscores and dashes.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256971437702831822)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_text=>'This schema has not been registered with ORDS RESTful Data Services. To register this schema navigate to <strong> RESTful Services, ORDS Restful Services</strong> and click the <strong>Register Schema with ORDS</strong> button.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(278423646786289378)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_text=>'APEX is currently running in the CDB. You cannot define ORDS based REST Services in the CDB.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(278422839403276718)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_text=>'The currently installed ORDS version (%0) does not support all functionality required to REST enable database objects. A minimum version of %1 must be installed.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(278422415940272648)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_text=>'The system was unable to locate the ORDS_METADATA schema, which is required to enable  ORDS RESTful services. Please refer to the Oracle REST Data Services Installation Guide for installation steps.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(278423280025279333)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_text=>'ORDS Version <strong>%0</strong>'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(278422603650275085)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_text=>'This system is currently using the Oracle Embedded PL/SQL Gateway. You must install version %0 or above of Oracle REST Data Services in order to REST enable database objects.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815724904326252)
,p_name=>'STACKED2DCOLUMN'
,p_message_text=>'Stacked 2D Column'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815826503326252)
,p_name=>'STACKED3DCOLUMN'
,p_message_text=>'Stacked 3D Column'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1815913300326252)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_text=>'Stacked Horizontal 2D Column'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1816011966326252)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_text=>'Stacked Horizontal 3D Column'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(454858513006066422)
,p_name=>'STANDARD _TABS'
,p_message_text=>'Standard Tabs'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455032712255062413)
,p_name=>'STANDARD_TAB'
,p_message_text=>'Standard Tab'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86630911446418425)
,p_name=>'STANDARD_TAB_SET'
,p_message_text=>'Standard Tab Set'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29420622968214777)
,p_name=>'STATIC APPLICATION FILES'
,p_message_text=>'Static Application Files'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29420426418213211)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_text=>'Static Workspace Files'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109278403279227285)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_text=>'Static Assignment'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(287651401224247087)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_text=>'No Associated Application'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7907222474997295)
,p_name=>'STATIC_HTML'
,p_message_text=>'Static HTML'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2481916523923367)
,p_name=>'STATIC_REFERENCE'
,p_message_text=>'Static Reference'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170056793767488931)
,p_name=>'STATIC_REGION'
,p_message_text=>'Static Region'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(201792813667422749)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_text=>'Static Substitution Strings'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1034828115065962125)
,p_name=>'STATUS_LABEL'
,p_message_text=>'Status: %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145190606261845398)
,p_name=>'STATUS_MODIFIED'
,p_message_text=>'Status Modified'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191534114794353605)
,p_name=>'STD TAB CONDITION'
,p_message_text=>'Standard Tab Condition'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(925750739336632445)
,p_name=>'STEAL_LOCK'
,p_message_text=>'Steal Lock'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22954819368102115)
,p_name=>'STORAGE'
,p_message_text=>'Storage:'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88137819526759156)
,p_name=>'STRUCTURED_QUERY'
,p_message_text=>'structured query'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(118121419342318799)
,p_name=>'STRUCTURED_REPORT'
,p_message_text=>'Structured Report'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(289237410449834409)
,p_name=>'SUBMIT'
,p_message_text=>'Submit'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145185502667834901)
,p_name=>'SUBMITTED'
,p_message_text=>'Submitted'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(117341504516476841)
,p_name=>'SUBMIT_AS'
,p_message_text=>'Submit As'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(196398504524611342)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_text=>'Submit Feedback'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166182806455530055)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_text=>'Subordinate Current Entry'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166183209572530982)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_text=>'Subordinate Non Current Entry'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1439454545237905808)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_text=>'Nonexistent Master'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1446087526439281002)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_text=>'Theme'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1446087364293279466)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_text=>'Theme Repository'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4455631612683572)
,p_name=>'SUBSCRIBE_APP_COMPUTATION.COPIED_FROM'
,p_message_text=>'Subscribed to Application Computation'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4456249801696389)
,p_name=>'SUBSCRIBE_APP_COMPUTATION.MASTER'
,p_message_text=>'This is the "master" copy of this Computation.'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4456062308692851)
,p_name=>'SUBSCRIBE_APP_COMPUTATION.NO_SUBSCRIPTION'
,p_message_text=>'No Computations subscribed to this Computation.'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4455895445688497)
,p_name=>'SUBSCRIBE_APP_COMPUTATION.REFERENCE'
,p_message_text=>'Applications subscribing to this Computation'
,p_version_scn=>30143382
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7651337561063622)
,p_name=>'SUBSCRIBE_APP_ITEM.COPIED_FROM'
,p_message_text=>'Subscribed to Application Item'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7651903846075434)
,p_name=>'SUBSCRIBE_APP_ITEM.MASTER'
,p_message_text=>'This is the "master" copy of this application item.'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7651774657072041)
,p_name=>'SUBSCRIBE_APP_ITEM.NO_SUBSCRIPTION'
,p_message_text=>'No application items subscribed to this item.'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7651572554067114)
,p_name=>'SUBSCRIBE_APP_ITEM.REFERENCE'
,p_message_text=>'Applications subscribing to this Item'
,p_version_scn=>30143597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3569176440209231)
,p_name=>'SUBSCRIBE_APP_PROCESS.COPIED_FROM'
,p_message_text=>'Subscribed to Application Process'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3569738865219294)
,p_name=>'SUBSCRIBE_APP_PROCESS.MASTER'
,p_message_text=>'This is the "master" copy of this application process.'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3569591285215475)
,p_name=>'SUBSCRIBE_APP_PROCESS.NO_SUBSCRIPTION'
,p_message_text=>'No application process subscribed to this process.'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3569379945212582)
,p_name=>'SUBSCRIBE_APP_PROCESS.REFERENCE'
,p_message_text=>'Applications subscribing to this Process'
,p_version_scn=>33004944
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8408761695731600)
,p_name=>'SUBSCRIBE_APP_SETTING.COPIED_FROM'
,p_message_text=>'Subscribed to Application Setting'
,p_version_scn=>37165251514295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8408906026733283)
,p_name=>'SUBSCRIBE_APP_SETTING.MASTER'
,p_message_text=>'This is the "master" copy of this application setting.'
,p_version_scn=>37165251514308
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8409121667735470)
,p_name=>'SUBSCRIBE_APP_SETTING.NO_SUBSCRIPTION'
,p_message_text=>'No application settings subscribed to this application setting.'
,p_version_scn=>37165251514328
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8409317531737522)
,p_name=>'SUBSCRIBE_APP_SETTING.REFERENCE'
,p_message_text=>'Applications subscribing to this Application Setting'
,p_version_scn=>30064192
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86686308395597343)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_text=>'Subscribed to Authorization'
,p_version_scn=>73092052
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86696126665621536)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_text=>'This is the "master" copy of this authorization scheme.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86701232683632674)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_text=>'No authorization schemes subscribe to this authorization scheme.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86698817099628250)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_text=>'Applications subscribing to this Authorization Scheme'
,p_version_scn=>30064216
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7235065570139375)
,p_name=>'SUBSCRIBE_COMPONENT_GROUP.COPIED_FROM'
,p_message_text=>'Subscribed to Component Group'
,p_version_scn=>27328018
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7235275214141613)
,p_name=>'SUBSCRIBE_COMPONENT_GROUP.MASTER'
,p_message_text=>'This is the "master" copy of this component group.'
,p_version_scn=>27328042
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7235468020144292)
,p_name=>'SUBSCRIBE_COMPONENT_GROUP.NO_SUBSCRIPTION'
,p_message_text=>'No component group subscribed to this component group.'
,p_version_scn=>27328089
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7235654255146120)
,p_name=>'SUBSCRIBE_COMPONENT_GROUP.REFERENCE'
,p_message_text=>'Applications subscribing to this Component Group'
,p_version_scn=>30064236
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1407386804977600)
,p_name=>'SUBSCRIBE_COMPONENT_SETTING.COPIED_FROM'
,p_message_text=>'Subscribed to Component Settings'
,p_version_scn=>37165252934683
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1407559579979573)
,p_name=>'SUBSCRIBE_COMPONENT_SETTING.MASTER'
,p_message_text=>'This is the "master" copy of this component settings.'
,p_version_scn=>37165252934702
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1407716147981182)
,p_name=>'SUBSCRIBE_COMPONENT_SETTING.NO_SUBSCRIPTION'
,p_message_text=>'No components subscribed to this component settings.'
,p_version_scn=>37165252934734
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1407906589982722)
,p_name=>'SUBSCRIBE_COMPONENT_SETTING.REFERENCE'
,p_message_text=>'Applications subscribing to this Component Setting'
,p_version_scn=>30143694
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3513980011625257)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_text=>'Subscribed to Data Load'
,p_version_scn=>73087212
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3514575081637184)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_text=>'This is the "master" copy of this Data Load Definition.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3514302904633946)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_text=>'No Data Load Definitions subscribe to this definition.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3514161402630509)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_text=>'Applications subscribing to this Data Load Definition'
,p_version_scn=>30064292
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8401471939525164)
,p_name=>'SUBSCRIBE_EMAIL_TEMPLATE.COPIED_FROM'
,p_message_text=>'Subscribed to Email Template'
,p_version_scn=>37165251502958
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8401664366527378)
,p_name=>'SUBSCRIBE_EMAIL_TEMPLATE.MASTER'
,p_message_text=>'This is the "master" copy of this email template.'
,p_version_scn=>37165251507778
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8401816894529922)
,p_name=>'SUBSCRIBE_EMAIL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_text=>'No email template subscribed to this email template.'
,p_version_scn=>37165251507791
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8402031929532101)
,p_name=>'SUBSCRIBE_EMAIL_TEMPLATE.REFERENCE'
,p_message_text=>'Applications subscribing to this Email Template'
,p_version_scn=>30064316
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86661027910536765)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_text=>'Copied from Application'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86662408301540549)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_text=>'This is the "master" copy of this item help.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86665311895551015)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_text=>'No items subscribe to this item help text.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86663924578545184)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_text=>'Items subscribing to this item help text'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10600205010512813)
,p_name=>'SUBSCRIBE_LIST.COPIED_FROM'
,p_message_text=>'Subscribed to List'
,p_version_scn=>73087147
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10600445429514038)
,p_name=>'SUBSCRIBE_LIST.MASTER'
,p_message_text=>'This is the "master" copy of this List.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10600887351516148)
,p_name=>'SUBSCRIBE_LIST.NO_SUBSCRIPTION'
,p_message_text=>'No Lists subscribed to this List.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10600695597515049)
,p_name=>'SUBSCRIBE_LIST.REFERENCE'
,p_message_text=>'Applications subscribing to this List'
,p_version_scn=>30064394
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86843911830721349)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_text=>'Subscribed to List of Values'
,p_version_scn=>73092096
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86844826028725406)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_text=>'This is the "master" copy of this List of Values.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86846722696733877)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_text=>'No Lists of Values subscribe to this List of Values.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86845706766729341)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_text=>'Applications subscribing to this List of Values'
,p_version_scn=>30064414
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2075073719346981)
,p_name=>'SUBSCRIBE_MAP_BACKGROUND.COPIED_FROM'
,p_message_text=>'Subscribed to Map Background'
,p_version_scn=>37165257640030
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2076764733429422)
,p_name=>'SUBSCRIBE_MAP_BACKGROUND.MASTER'
,p_message_text=>'This is the "master" copy of this Map Background'
,p_version_scn=>37165881964536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2074449507324880)
,p_name=>'SUBSCRIBE_MAP_BACKGROUND.NO_SUBSCRIPTION'
,p_message_text=>'No Map Backgrounds subscribe to this custom map background.'
,p_version_scn=>37165881964536
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2080380356499921)
,p_name=>'SUBSCRIBE_MAP_BACKGROUND.REFERENCE'
,p_message_text=>'Applications subscribing to this Map Background'
,p_version_scn=>30064434
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2618940794555047)
,p_name=>'SUBSCRIBE_MESSAGE.COPIED_FROM'
,p_message_text=>'Subscribed to Text Message'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2619506085571117)
,p_name=>'SUBSCRIBE_MESSAGE.MASTER'
,p_message_text=>'This is the "master" copy of this Text Message.'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2619375440566369)
,p_name=>'SUBSCRIBE_MESSAGE.NO_SUBSCRIPTION'
,p_message_text=>'No Text Messages subscribed to this Text Message.'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2619182733561488)
,p_name=>'SUBSCRIBE_MESSAGE.REFERENCE'
,p_message_text=>'Applications subscribing to this Text Message'
,p_version_scn=>30064457
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(33437509679131595)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_text=>'Copied from Application'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86869325298772486)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_text=>'This is the "master" copy of this Navigation Bar.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86874118503779983)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_text=>'No Navigation Bars subscribe to this Navigation Bar.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86870903958775840)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_text=>'Applications subscribing to this Navigation Bar'
,p_version_scn=>30064494
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4826882535980598)
,p_name=>'SUBSCRIBE_PATCH.COPIED_FROM'
,p_message_text=>'Subscribed to Build Option'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4827708612191163)
,p_name=>'SUBSCRIBE_PATCH.MASTER'
,p_message_text=>'This is the "master" copy of this build option.'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4827509853186868)
,p_name=>'SUBSCRIBE_PATCH.NO_SUBSCRIPTION'
,p_message_text=>'No build options subscribed to this build option.'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4827300137139654)
,p_name=>'SUBSCRIBE_PATCH.REFERENCE'
,p_message_text=>'Applications subscribing to this Build Option'
,p_version_scn=>30064517
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32728430447674345)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_text=>'Subscribed to Plugin'
,p_version_scn=>73092151
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(122801802104022384)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM_THEME'
,p_message_text=>'Subscribed to Standard Theme'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32728602527675713)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_text=>'This is the "master" copy of this plug-in.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32729014648679217)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_text=>'No plug-ins subscribe to this plug-in.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32728808068677317)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_text=>'Applications subscribing to this Plug-in'
,p_version_scn=>30064547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8402950978554527)
,p_name=>'SUBSCRIBE_REPORT_LAYOUT.COPIED_FROM'
,p_message_text=>'Subscribed to Report Layout'
,p_version_scn=>37165251507587
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8403181069557399)
,p_name=>'SUBSCRIBE_REPORT_LAYOUT.MASTER'
,p_message_text=>'This is the "master" copy of this report layout.'
,p_version_scn=>37165251507878
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8403393780559624)
,p_name=>'SUBSCRIBE_REPORT_LAYOUT.NO_SUBSCRIPTION'
,p_message_text=>'No report layout subscribed to this report layout.'
,p_version_scn=>37165251507892
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8403505242562982)
,p_name=>'SUBSCRIBE_REPORT_LAYOUT.REFERENCE'
,p_message_text=>'Applications subscribing to this Report Layout'
,p_version_scn=>30064594
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2432831414768960)
,p_name=>'SUBSCRIBE_SEARCH_CONFIG.COPIED_FROM'
,p_message_text=>'Subscribed to Search Configuration'
,p_version_scn=>73092264
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2433176186775239)
,p_name=>'SUBSCRIBE_SEARCH_CONFIG.MASTER'
,p_message_text=>'This is the "master" copy of this Search Configuration.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2433541978786812)
,p_name=>'SUBSCRIBE_SEARCH_CONFIG.NO_SUBSCRIPTION'
,p_message_text=>'No Search Configurations subscribe to this configuration.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2433314080783026)
,p_name=>'SUBSCRIBE_SEARCH_CONFIG.REFERENCE'
,p_message_text=>'Applications subscribing to this Search Configuration'
,p_version_scn=>30064614
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86720306757653613)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_text=>'Subscribed to Shortcut'
,p_version_scn=>73092217
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86722222341658068)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_text=>'This is the "master" copy of this shortcut.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86725201132670893)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_text=>'No shortcuts subscribe to this shortcut.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86723302040661709)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_text=>'Applications subscribing to this Shortcut'
,p_version_scn=>30064637
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86580310726191108)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_text=>'Copied from Application'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86581705662199154)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_text=>'This is the "master" copy of this template.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86582618607212348)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_text=>'No templates subscribe to this template.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86581027695196053)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_text=>'Popup List of Values Template'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86981504491889566)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_text=>'Applications subscribing to this Template'
,p_version_scn=>30064658
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(697006400448082056)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_text=>'Subscribed to Application Theme'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(946631698054187282)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_text=>'Subscribed to Standard Theme'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(697007616576097044)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_text=>'This is the "master" copy of this theme'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(697007409353094379)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_text=>'No themes subscribe to this theme. '
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(697007037321085140)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_text=>'Popup List of Values Theme'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(697007232713092265)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_text=>'Applications subscribing to this Theme'
,p_version_scn=>30064688
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4786595435482339)
,p_name=>'SUBSCRIBE_USER_GROUP.COPIED_FROM'
,p_message_text=>'Subscribed to Role'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4787280483497977)
,p_name=>'SUBSCRIBE_USER_GROUP.MASTER'
,p_message_text=>'This is the "master" copy of this Role.'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4787027465494627)
,p_name=>'SUBSCRIBE_USER_GROUP.NO_SUBSCRIPTION'
,p_message_text=>'No Roles subscribed to this Role.'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4786824965488152)
,p_name=>'SUBSCRIBE_USER_GROUP.REFERENCE'
,p_message_text=>'Applications subscribing to this Role'
,p_version_scn=>30064712
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(247764984451838716)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_text=>'Subscribed to REST Data Source'
,p_version_scn=>73091945
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(247765132796840066)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_text=>'This is the "master" copy of this REST Data Source.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(247765540808842980)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_text=>'No REST Data Sources subscribe to this Source.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(247765398434841295)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_text=>'Applications subscribing to this REST Data Source'
,p_version_scn=>33008072
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86944606345823810)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_text=>'Copied from Application'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86978023754885573)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_text=>'This is the "master" copy of this button template.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86988520553903630)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_text=>'No templates subscribe to this button template.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86985423885895123)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_text=>'Applications subscribing to this Button Template'
,p_version_scn=>32836907
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15051110091225709)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_text=>'Substitution String Usage'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152846403136516096)
,p_name=>'SUCCESS'
,p_message_text=>'success'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190187119990886927)
,p_name=>'SUCCESS MESSAGE'
,p_message_text=>'Success Message'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145138313637629890)
,p_name=>'SUCCESSES'
,p_message_text=>'Successes'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106957922308187858)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_text=>'Cluster truncated.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106823308710426924)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_text=>'Command executed.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106933000650068016)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_text=>'Context dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106935100912086996)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_text=>'Database Link created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106934611171080552)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_text=>'Database Link dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106958912312213332)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_text=>'Function altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106797912248333364)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_text=>'Function created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106886021111600850)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_text=>'Function dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106949613389166339)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_text=>'Indextype altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106931824630056043)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_text=>'Indextype dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106802822422345735)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_text=>'Index created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106888607306625184)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_text=>'Index dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106819628534413737)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_text=>'Materialized View created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106889710553635620)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_text=>'Materialized view dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106958522917206873)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_text=>'Package altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106799603375340168)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_text=>'Package Body created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106801613764343233)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_text=>'Package created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106876711536531786)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_text=>'Package dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106959631705218905)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_text=>'Procedure altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106798425754337256)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_text=>'Procedure created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106886610853607333)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_text=>'Procedure dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106820106501416775)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_text=>'Role created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106890501681642493)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_text=>'Role dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106849420400449196)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_text=>'%0 row(s) deleted.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106847401699443786)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_text=>'%0 row(s) inserted.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106827309533436646)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_text=>'%0 row(s) updated.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106969721447225397)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_text=>'Sequence altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106821217583419980)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_text=>'Sequence created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106882123357563656)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_text=>'Sequence dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1685216866750470)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_text=>'Row created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1685075721749209)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_text=>'Row deleted.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1684843274748401)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_text=>'Row updated.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9525312362919889)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_text=>'Statement processed.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106822200052424385)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_text=>'Synonym created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106891027307649917)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_text=>'Synonym dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106884904573577121)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_text=>'Table altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106791111424323632)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_text=>'Table created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106875414868523321)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_text=>'Table dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106942106285126378)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_text=>'Table renamed.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106955431528181002)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_text=>'Table truncated.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106947623993159916)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_text=>'Trigger altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106794231510329380)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_text=>'Trigger created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106891518088656701)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_text=>'Trigger dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106946631481152574)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_text=>'Type altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106817906370407280)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_text=>'Type created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106891906098662727)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_text=>'Type dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106991624133245123)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_text=>'User altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106818715374409866)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_text=>'User created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106878301624538383)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_text=>'User dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106945106547145440)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_text=>'View altered.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106792521813326608)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_text=>'View created.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106879122403544397)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_text=>'View dropped.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(282818215963203258)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_text=>'Supporting Objects'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(624409274737946368)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_text=>'Object definition has changed.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(624409489626953458)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_text=>'The object no longer exists.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(170632926435922800)
,p_name=>'SVG CHART'
,p_message_text=>'SVG Chart'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(238454219778746961)
,p_name=>'SVG PLUGIN'
,p_message_text=>'Please install SVG Viewer to view the chart.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1312817603958878)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_text=>'You cannot edit an empty SQL script.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1313326953961572)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_text=>'You cannot edit script greater than 30,000 bytes.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88050624751587352)
,p_name=>'SYNONYM'
,p_message_text=>'synonym'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(492685206325359933)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_text=>'(synonym)'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270313124843612160)
,p_name=>'SYNONYM_NOUN'
,p_message_text=>'Synonym'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(387738242258512380)
,p_name=>'SYSTEM_MESSAGE'
,p_message_text=>'System Message'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145192121499849821)
,p_name=>'SYSTEM_STATUS'
,p_message_text=>'System Status'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145193406046854858)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_text=>'System Status Modified'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88051028214588345)
,p_name=>'TABLE'
,p_message_text=>'table'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171256418608053892)
,p_name=>'TABLE NOT FOUND'
,p_message_text=>'%0 is not a valid table or view name.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184183720022259561)
,p_name=>'TABLESPACES'
,p_message_text=>'Tablespaces'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87941216171749635)
,p_name=>'TABLE_IN_PAREN'
,p_message_text=>'(table)'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(189569219849119686)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_text=>'Table Name %0 exceeds allowed size.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(196130720372538780)
,p_name=>'TABULAR_FORM'
,p_message_text=>'Tabular Form'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204685429280647630)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_text=>'The tabular form has been created successfully.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87169717922338159)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_text=>'Warning: Parent tab target "%0" appears to reference a page that does not exist.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86853602180746890)
,p_name=>'TAB_SEQUENCE'
,p_message_text=>'Tab Sequence'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86840323342705705)
,p_name=>'TAB_SET'
,p_message_text=>'Tab Set'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(454858208504065116)
,p_name=>'TAB_SETS'
,p_message_text=>'Tab Sets'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86841401656708887)
,p_name=>'TAB_TEXT'
,p_message_text=>'Tab Text'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036686418451107995)
,p_name=>'TAG_LABEL'
,p_message_text=>'Tag: %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18541331825652728)
,p_name=>'TARGETED_FEATURES'
,p_message_text=>'Targeted Features'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2378282883543689290)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_text=>'Target Page ID or custom URL'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171878732135976983)
,p_name=>'TASK_COMPLETE'
,p_message_text=>'Task Complete'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1910470804348975)
,p_name=>'TASK_DEFINITION'
,p_message_text=>'Task Definition'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1909722910341436)
,p_name=>'TASK_DEFINITION_PARTICIPANTS'
,p_message_text=>'Task Definition Participants'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184171910682982548)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_text=>'Team Development'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86596019823250532)
,p_name=>'TEMPLATE'
,p_message_text=>'Template'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1822683395567472017)
,p_name=>'TEMPLATE.ACTION'
,p_message_text=>'Action: %0'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161994910550064834)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_text=>'After Header'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161995514705066031)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_text=>'Before Footer'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1822628761388233244)
,p_name=>'TEMPLATE.COPY'
,p_message_text=>'Copy Template: %0'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1822683117715469607)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_text=>'New Template: %0'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3695493443923)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_text=>'Page Template Body'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161938114050018541)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_text=>'Page Template Body (1)'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161939020630020448)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_text=>'Page Template Body (2)'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161970130327023247)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_text=>'Page Template Body (3)'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1822628995962235779)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_text=>'Preview Template: %0'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161845629775408021)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_text=>'Region Position 9'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161846006704410837)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_text=>'Region Position 10'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161846411898412282)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_text=>'Region Position 11'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161846816054413495)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_text=>'Region Position 12'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161876411505733966)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_text=>'Region Position 13'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161878413367743900)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_text=>'Region Position 14'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161878828951748374)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_text=>'Region Position 15'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(161879301031749799)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_text=>'Region Position 16'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(563162239958626438)
,p_name=>'TEMPLATES'
,p_message_text=>'Templates'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255036614108033255)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_text=>'Template Applications'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7058813985686712)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_text=>'Error during the creation of an application based on a Template Application.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(343348525221905554)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_text=>'Template Driven'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(253566303121596461)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_text=>'Advanced'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(253566125073594835)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_text=>'Common'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591759272596283842)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_text=>'Default'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(253550511669515644)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_text=>'General'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(628659752109774194)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_text=>'No matching template options defined.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(637454698270777864)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_text=>'- No Option Selected -'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(602944719272803661)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_text=>'Use Template Defaults'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1474343487284844088)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_text=>'Template Options Mismatch'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2104471085429192289)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_text=>'This template is subscribed to the corresponding template in the master theme. To modify this template, edit the master template and then refresh the theme. Alternatively you can create a local, unsubscribed copy of this template. Unsubscribed templa'
||'tes are editable and will not get overwritten by a theme refresh.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2104297930976773037)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This template is local to this application and is unsubscribed. ',
'Individual templates can not be subscribed when the associated theme is subscribed.',
'As an alternative to defining local templates, you could add new templates to the master theme, and then easily push or pull them into this application.'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87092429275085900)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_text=>'Referenced as application default template.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87094800794096624)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_text=>'Referenced as error template.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87096400233105935)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_text=>'This page template is NOT referenced.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87096816163110523)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_text=>'This page template is'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87095817070101302)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_text=>'Referenced in page(s)'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87094220749092949)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_text=>'Referenced as printer friendly template.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145581100570383076)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_text=>'Temporary Tablespace'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107008913948125109)
,p_name=>'TEST'
,p_message_text=>'Test'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184001506144628328)
,p_name=>'TESTING_ASSIGNEE'
,p_message_text=>'Testing Assignee'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183995000903598406)
,p_name=>'TESTING_IMPACT'
,p_message_text=>'Testing Impact'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184002818957632040)
,p_name=>'TESTING_STATUS'
,p_message_text=>'Testing Status'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240761815759417280)
,p_name=>'TEST_QUERY'
,p_message_text=>'Test Query'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455021809559966956)
,p_name=>'TEXT FILES'
,p_message_text=>'Text Files'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61181601208769995)
,p_name=>'THEME'
,p_message_text=>'Theme'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29420028384181936)
,p_name=>'THEME FILES'
,p_message_text=>'Theme Files'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(455008913435797798)
,p_name=>'THEME IMAGES'
,p_message_text=>'Theme Images'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1059954980069114481)
,p_name=>'THEME.COMPATIBLE'
,p_message_text=>'Compatible'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575488836719328287)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_text=>'Theme'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5060849337417374)
,p_name=>'THEME.THEME_ID_POSTFIX'
,p_message_text=>'(Theme %0)'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(60665129251652087)
,p_name=>'THEMES'
,p_message_text=>'Themes'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2106049263717827588)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_text=>'You cannot unsubscribe individual templates that are part of a theme, which is subscribed to another theme at the theme level.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2123606290064587354)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_text=>'This application cannot be converted to a theme using tab-based navigation, as it uses list-based navigation.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2123605233133585263)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_text=>'This application cannot be converted to a theme using list-based navigation, as it uses two levels of tabs. Please update the application and set current tabs settings to use only one level of tabs prior to switching the theme.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(173520746694218163)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_text=>'A Desktop theme cannot be switched to a Mobile theme.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90750999185281011)
,p_name=>'THEME_SWITCH.TEMPLATE_REQUIREMENTS'
,p_message_text=>'Switching to the selected theme requires that it has at least one template for every template type.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135120415019678141)
,p_name=>'THEME_TYPE'
,p_message_text=>'Theme Type'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1036234026510816956)
,p_name=>'TITLE_LABEL'
,p_message_text=>'Title: %0'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171868813640886464)
,p_name=>'TO DO'
,p_message_text=>'To Do'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191518528661841906)
,p_name=>'TODO'
,p_message_text=>'To Do'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184179432349177960)
,p_name=>'TODOS'
,p_message_text=>'Todo''s'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17736106454472993)
,p_name=>'TODO_COMPLETE'
,p_message_text=>'To Do complete (%0 / %1):'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484696111614908396)
,p_name=>'TODO_DASH_1'
,p_message_text=>'%0 entries, %1 open, %2 completed.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484696422481920913)
,p_name=>'TODO_DASH_2'
,p_message_text=>'%0 entries are partially complete'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484696609798926746)
,p_name=>'TODO_DASH_3'
,p_message_text=>'%0 entries are partially complete'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184175229700110985)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_text=>'%0 Top Tables by Row Count, Reported by Schema'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192599004248187620)
,p_name=>'TOTAL_CLOSED'
,p_message_text=>'Total Closed'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191631720592107253)
,p_name=>'TOTAL_MILESTONES'
,p_message_text=>'Total milestones'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192598700785186642)
,p_name=>'TOTAL_OPENED'
,p_message_text=>'Total Opened'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184175904120131987)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_text=>'Total Rendering Time (Seconds)'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617128509611508575)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_text=>'To be Purged (within next 7 days)'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192128914598427651)
,p_name=>'TO_DOS'
,p_message_text=>'To Do''s'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(496362921893483673)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_text=>'To Do percent complete (%0/%1):'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88143220968863612)
,p_name=>'TREE'
,p_message_text=>'tree'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(319071319557903713)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_text=>'Start Tree Based on Existing Item'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(319071515029905790)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_text=>'Start Tree Based on SQL Query'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(319072810906938072)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_text=>'Start Tree Value is NULL'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(319071708127908972)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_text=>'Start Tree Based on Static Value'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44717606711806982)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_text=>'The tree has been created successfully.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88051431677589329)
,p_name=>'TRIGGER'
,p_message_text=>'trigger'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38257706264920995)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_text=>'Button names must not be the same name as an existing tab'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(273371226012551789)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_text=>'Application ID and current security group ID are not consistent.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38255505094911228)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_text=>'Security group ID 20 is reserved for workspace ''ORACLE'''
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(83758913869334927)
,p_name=>'TWO_COL_TABLE.SUMMARY'
,p_message_text=>'Summary'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(324320601598128318)
,p_name=>'TYPE'
,p_message_text=>'Type'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(333565425073897116)
,p_name=>'TYPE_LABEL'
,p_message_text=>'Type: %0'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8601480849189697)
,p_name=>'UI.APP.ICON.BUILDER_ICON'
,p_message_text=>'Oracle APEX App Builder icon'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8600329050159009)
,p_name=>'UI.APP.ICON.FAVICON'
,p_message_text=>'Favicon'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8600523123159010)
,p_name=>'UI.APP.ICON.LARGE_ICON'
,p_message_text=>'Large icon'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3200645125145402)
,p_name=>'UI.APP.ICON.LARGE_ROUNDED_ICON'
,p_message_text=>'Large rounded icon'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8600271951150330)
,p_name=>'UI.APP.ICON.NOT_FOUND'
,p_message_text=>'Icon not found'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8601592691189697)
,p_name=>'UI.APP.ICON.PWA_ICON'
,p_message_text=>'PWA icon'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8600459643159010)
,p_name=>'UI.APP.ICON.SMALL_ICON'
,p_message_text=>'Small icon'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3200867925147566)
,p_name=>'UI.APP.ICON.SMALL_ROUNDED_ICON'
,p_message_text=>'Small rounded icon'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(262577325246558570)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_text=>'Custom Item Type'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(273138525710612889)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_text=>'View Database Column Definition'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183695918895873968)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_text=>'Skip to Main Content'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(68856128674139296)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_text=>'Unable to determine milestone date'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(213322512095153057)
,p_name=>'UNASSIGNED'
,p_message_text=>'Unassigned'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(245480207196489052)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_text=>'Unauthenticated User'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(402732927247688628)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_text=>'Unavailable (Redirect to URL)'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(402732746739684892)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_text=>'Unavailable (Status Shown with PL/SQL)'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176626116583368169)
,p_name=>'UNDER_CONSIDERATION'
,p_message_text=>'Under consideration'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32260020191809684)
,p_name=>'UNEXPIRED'
,p_message_text=>'Unexpired'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(276573907884101738)
,p_name=>'UNLOCK'
,p_message_text=>'Unlock'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361820829799358782)
,p_name=>'UNLOCKED'
,p_message_text=>'unlocked'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21520216690702517)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_text=>'Unlocked Applications'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20450314923281207)
,p_name=>'UNLOCK_APPLICATION'
,p_message_text=>'Unlock'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114384730596793885)
,p_name=>'UNRESTRICTED'
,p_message_text=>'Unrestricted'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107170227381540993)
,p_name=>'UP'
,p_message_text=>'Up'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88142427070855867)
,p_name=>'UPDATEABLE_REPORT'
,p_message_text=>'updateable report'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(484707125185092038)
,p_name=>'UPDATED_BY'
,p_message_text=>'Updated By'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(103918312127904710)
,p_name=>'UPDATED_ON'
,p_message_text=>'Updated On'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(344317528205524819)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_text=>'Update to Application Version'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(344317821951527756)
,p_name=>'UPDATE_VERSION'
,p_message_text=>'Update to Version'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(636392213171991608)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_text=>'not a supported date format'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(498205613512585738)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_text=>'Date format not supported.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(882016883304155443)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_text=>'After upgrading, ensure the series attribute Label Column is mapped to a Date / Timestamp column.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88142806423859428)
,p_name=>'URL'
,p_message_text=>'URL'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(166094703536018201)
,p_name=>'URL LINK'
,p_message_text=>'URL Link'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(179821129792513116)
,p_name=>'USERID'
,p_message_text=>'User ID'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184185206656340829)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_text=>'%0 Users, Most recent user created %1'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(274139308832038265)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_text=>'No Global Page Defined.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184001203027627369)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_text=>'User Interface Assignee'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(183999111554620415)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_text=>'User Interface Impact'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184004611123639236)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_text=>'User Interface Status'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40273724637283821)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this page to control access for Oracle APEX workspace administrators, application developers, and end users.</p>',
'',
'<p><strong>Workspace administrators</strong> can create and modify applications and  database objects as well as manage user accounts, groups, and development services.</p>',
'',
'<p><strong>Developers</strong> can create and modify applications and database objects.</p>',
'',
'<p><strong>End users</strong> have no development privileges and can only access applications that do not use an external authentication scheme.</p>',
'',
'<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">Learn More ...</a></p>',
''))
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(45542625250358437)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this page to control access for Oracle APEX end users.</p>',
'',
'<p><strong>End users</strong> have no development privileges and can only access applications that do not use an external authentication scheme.</p>',
'',
'<p><strong>Workspace administrators</strong> and <strong>developers</strong> are managed using the Identity Console. Whenever a workspace administrator or developer logs in to APEX, a "shadow" account is created. These "shadow" users can be removed i'
||'f desired.</p>'))
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88193031506377596)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_text=>'Use built-in login page.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88192207826361362)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_text=>'Use page %0 as login page.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254093610308753020)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use the <strong>clear cache</strong> attribute to remove session state for a comma separated list of pages.  The following clear cache syntax is also available:',
'<ul>',
'<li>RIR - Reset Interactive Report</li>',
'<li>CIR - Clear Interactive Report</li>',
'</ul>'))
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(290109816193551783)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_text=>'using existing schema'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(59545324172395574)
,p_name=>'UTR.ADDITIONAL_OPTIONS'
,p_message_text=>'Additional Options'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340234970487937169)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_text=>'Close'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340235591362941599)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_text=>'Code Editor'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340235387760940056)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_text=>'Maximize'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340235113330938906)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_text=>'Minimize'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340237847087960926)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_text=>'Changing the Theme Style will reset your unsaved changes. This operation cannot be undone. Do you want to proceed?'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2185508486130627991)
,p_name=>'UTR.CHANGE_THEME'
,p_message_text=>'Change Theme'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340234777248936352)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_text=>'Style'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340234268422933595)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_text=>'Cancel'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340232921574920231)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_text=>'Confirm'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2184338331283844075)
,p_name=>'UTR.COMMON.COPY'
,p_message_text=>'Copy'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340233861306930450)
,p_name=>'UTR.COMMON.NO'
,p_message_text=>'No'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340234004346932131)
,p_name=>'UTR.COMMON.OK'
,p_message_text=>'OK'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2184338197656842986)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_text=>' You have made changes to a read-only theme. If you make it the current theme, your changes will be erased. Are you sure you want to proceed? '
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340234411515934922)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_text=>'Style Name'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340233207935921477)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_text=>'Success'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2185507645066623132)
,p_name=>'UTR.COMMON.WARNING'
,p_message_text=>'Warning'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340233693443927808)
,p_name=>'UTR.COMMON.YES'
,p_message_text=>'Yes'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1843151994429417859)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_text=>'Paste the following line of code into the JS console to load your current configuration into Theme Roller:'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1843152123436421550)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_text=>'Theme Roller must be opened and the current style must be valid to output the configuration.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(625156486946012536)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_text=>'Contrast Ratio:'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1494167512286506825)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_text=>'Failed'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502399877275636194)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_text=>'For text above 18pt or bold above 14pt'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1494168418689518228)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_text=>'Validations are performed according to the Web Content Accessibility Guidelines (WCAG) 2.0 in Color Contrast for normal sized fonts'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1494167394150505060)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_text=>'Passed'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1494167083029502402)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_text=>'Color Contrast Information'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2141839123712410191)
,p_name=>'UTR.CURRENT'
,p_message_text=>'Current'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340237477862957315)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_text=>'Custom CSS'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340237629837959264)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_text=>'This code will be included at the end of the stylesheet'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1564401002297669031)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_text=>'This CSS code hides the Theme Roller dialog. It is not being applied to the page.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494559516967154406)
,p_name=>'UTR.DOWNLOAD'
,p_message_text=>'Download'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494561057127165269)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_text=>'Drag and drop files or click to select'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494562463351173630)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_text=>'Enable LESS Compilation'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340233483928924523)
,p_name=>'UTR.ERROR'
,p_message_text=>'Error'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340238918404970171)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_text=>'Could not create theme style.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1555011485211504998)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_text=>'Error loading one or more CSS File URLs.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340238521089965497)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_text=>'The LESS code for this theme style is invalid.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340239399348973008)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_text=>'Theme style could not be loaded. Please make sure the App Builder window is still open, and your session is valid.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2185507928468626189)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_text=>'The selected theme could not be used as the application''s current theme!'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4381783827151592)
,p_name=>'UTR.ERROR.THEME_STYLE_URL_ERROR'
,p_message_text=>'%0 could not be loaded due to a source file missing. Open your browser''s console for more information.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7101160520423152)
,p_name=>'UTR.ERROR.THEME_STYLE_WITH_ERRORS'
,p_message_text=>'%0 could not be loaded due to a parsing error. Open your browser''s console for more information.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340238269427963974)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_text=>'This theme style doesn''t support Theme Roller customization'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340238722007968818)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_text=>'This theme has no theme styles. Please select a theme with theme styles to use Theme Roller.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340239120777971540)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_text=>'Could not update theme style, Custom css cannot be larger than 1.5k lines.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49715368838475991)
,p_name=>'UTR.EXPORT'
,p_message_text=>'Export'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(610259559788506593)
,p_name=>'UTR.FILTER'
,p_message_text=>'Filter'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502749667108556786)
,p_name=>'UTR.HELP'
,p_message_text=>'Help'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502749946542559725)
,p_name=>'UTR.HELP.P1'
,p_message_text=>'Theme Roller enables easy customization of the user interface of your application by enabling you to pick colors and set styles for various application components. An application can have any number of theme styles defined, however, only the ''Current'
||''' theme style is used to display the application to end users.'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1502750118991561817)
,p_name=>'UTR.HELP.P2'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'After making changes, attributes can easily be restored, either for the complete theme style by pressing the Reset button, or pressing the reset icon for the group. ',
'',
'For attributes that allow the selection of foreground and background colors, the check-box preceding the two color selections indicates color contrast information based on Web Content Accessibility Guidelines (WCAG) 2.0. A higher calculated contrast '
||'score indicates that the color combination is more accessible.'))
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(49715739855480014)
,p_name=>'UTR.IMPORT'
,p_message_text=>'Import'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575494836398328295)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_text=>'Inline editor'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218752317624908721)
,p_name=>'UTR.LESS.ACCENT'
,p_message_text=>'Accent'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830987976274320258)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_text=>'Actions Column'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840796872221976890)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_text=>'Active'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840856065293137798)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_text=>'Active state'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840636648670636794)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_text=>'Background'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(218752600527951358)
,p_name=>'UTR.LESS.BADGE'
,p_message_text=>'Badge'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830987629603312630)
,p_name=>'UTR.LESS.BODY'
,p_message_text=>'Body'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830926038533276226)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_text=>'Body Accent'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1845687461892315428)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_text=>'Body Content Maximum Width'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831310444894332434)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_text=>'Border Radius'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1829937802987095640)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_text=>'Buttons'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840638637347662323)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_text=>'Color 1'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840639592035662370)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_text=>'Color 10'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1055049902306498732)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_text=>'Color 11'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1055050176648499387)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_text=>'Color 12'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1055050392805500211)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_text=>'Color 13'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1055050543444500894)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_text=>'Color 14'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1055050704816501576)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_text=>'Color 15'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840638759240662328)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_text=>'Color 2'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840640299112665197)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_text=>'Color 3'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840638919079662346)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_text=>'Color 4'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840639030560662350)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_text=>'Color 5'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840639152735662354)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_text=>'Color 6'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840639266156662358)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_text=>'Color 7'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840639378541662362)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_text=>'Color 8'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840639444562662366)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_text=>'Color 9'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830111327718404786)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_text=>'Containers'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840766574276840065)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_text=>'Container Border Radius'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831310884931332453)
,p_name=>'UTR.LESS.DANGER'
,p_message_text=>'Danger'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1832821330985347087)
,p_name=>'UTR.LESS.DISABLED'
,p_message_text=>'Disabled'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831190607738214317)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_text=>'Focus Outline'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840636434321636125)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_text=>'Foreground'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2268643001651527152)
,p_name=>'UTR.LESS.FORMS'
,p_message_text=>'Forms'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1829936363612020436)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_text=>'Global Colors'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840637479655645562)
,p_name=>'UTR.LESS.HEADER'
,p_message_text=>'Header'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830905737873268038)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_text=>'Header Accent'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221377275105710881)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_text=>'Header Height'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831310648764332443)
,p_name=>'UTR.LESS.HOT'
,p_message_text=>'Hot'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840798486388024326)
,p_name=>'UTR.LESS.HOVER'
,p_message_text=>'Hover'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840855818121137790)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_text=>'Hover state'
,p_is_js_message=>true
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840796799211976886)
,p_name=>'UTR.LESS.ICON'
,p_message_text=>'Icon'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1832826937260349070)
,p_name=>'UTR.LESS.INFO'
,p_message_text=>'Info'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830838250088173538)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_text=>'Interactive Reports'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2268901179343027799)
,p_name=>'UTR.LESS.ITEM'
,p_message_text=>'Item'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2268915582280057722)
,p_name=>'UTR.LESS.LABEL'
,p_message_text=>'Label'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830407099128456762)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_text=>'Layout'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831310090515332407)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_text=>'Left Side Column'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831190591325214307)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_text=>'Link Color'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840537179337432330)
,p_name=>'UTR.LESS.MENU'
,p_message_text=>'Menu'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1613711288655293883)
,p_name=>'UTR.LESS.MENUS'
,p_message_text=>'Menus'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(256953548093773170)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_text=>'Menu Item Hover state'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830407964799526095)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_text=>'Navigation'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840794257790906283)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_text=>'Navigation Tree'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831310557898332438)
,p_name=>'UTR.LESS.NORMAL'
,p_message_text=>'Normal'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840796958867976894)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_text=>'Not active'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830497014870695160)
,p_name=>'UTR.LESS.PALETTE'
,p_message_text=>'Palette'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831310722984332449)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_text=>'Primary'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147770210347710173)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_text=>'Primary Accent'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1829937783504095635)
,p_name=>'UTR.LESS.REGIONS'
,p_message_text=>'Regions'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831211417741282121)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_text=>'Header'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1355584799221607565)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_text=>'Reports and Grids'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631054444252682281)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_text=>'Body Background'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631054224478681477)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_text=>'Body Header'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631348119973772716)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_text=>'Display Mode'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631516560255779210)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_text=>'Compact'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631516078259776776)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_text=>'Standard (Default)'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(616638162694097778)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_text=>'Layout'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(621701839705618626)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_text=>'Contained'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(621701460536616727)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_text=>'Edge to Edge (Default)'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(621701663100617732)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_text=>'Floating'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(616637929532097282)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_text=>'Mode'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(621701070289612312)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_text=>'Dark'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(621701213489613974)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_text=>'Dark Body'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(634423625624537164)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_text=>'Dark (Default)'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(621700850147611396)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_text=>'Light'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(634423836684538307)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_text=>'Light (Default)'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(616637728820096024)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_text=>'Pillar'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631053869962679194)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_text=>'Beige'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631052849349676023)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_text=>'Lilac'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631050258757671249)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_text=>'Neutral (Default)'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631052602862675322)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_text=>'Ocean'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631050486645672157)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_text=>'Pebble'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631050836549673746)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_text=>'Pine'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631053604864678462)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_text=>'Plum'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631053027594676669)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_text=>'Rose'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631053236094677532)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_text=>'Sienna'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631050658169672968)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_text=>'Slate'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631052430597674477)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_text=>'Teal'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631054089316680408)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_text=>'Appearance'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631050096575668631)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_text=>'Redwood Options'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(121617042921647496)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_text=>'Scale'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(147770526960708563)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_text=>'Secondary Accent'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840797071807982493)
,p_name=>'UTR.LESS.SELECTED'
,p_message_text=>'Selected'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840855972411137794)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_text=>'Selected state'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831311148456332467)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_text=>'Simple'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830411854897551740)
,p_name=>'UTR.LESS.STATES'
,p_message_text=>'States'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831311000713332462)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_text=>'Success'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840636584471636435)
,p_name=>'UTR.LESS.TEXT'
,p_message_text=>'Text'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831066476549377987)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_text=>'Title Bar'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831310977015332457)
,p_name=>'UTR.LESS.WARNING'
,p_message_text=>'Warning'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(610260030824513671)
,p_name=>'UTR.LOADING'
,p_message_text=>'Loading...'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44900607719857925)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_text=>'Alternate Text'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461384953774527170)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_text=>'Custom'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461384670646527162)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_text=>'You can edit the logo markup in the Application Builder'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494624228717656220)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_text=>'Logo data could not be loaded. Please make sure the App Builder window is still open, and your session is valid.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461384344469527153)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_text=>'Image'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(498762888252291815)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_text=>'No Image Loaded.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461384065570527145)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_text=>'Image and Text'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494565664361191048)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_text=>'Please select a file smaller than %0KB'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461383744025527136)
,p_name=>'UTR.LOGO.NONE'
,p_message_text=>'None'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494582091336195735)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_text=>'Only image files are allowed'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494557852617121273)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_text=>'Save Logo'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494583557202209499)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_text=>'Logo could not be saved.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494605959751512124)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_text=>'Logo saved successfully.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461383464826527128)
,p_name=>'UTR.LOGO.TEXT'
,p_message_text=>'Text'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461383147236527119)
,p_name=>'UTR.LOGO.TYPE'
,p_message_text=>'Type'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461382825943527111)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_text=>'Drag and drop files or click to select'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575489166265328288)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_text=>'Edit Logo'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494561674589171269)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_text=>'Only JSON files are allowed'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1622070940268928024)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_text=>'Adjacent'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1622070564331925355)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_text=>'Base RGB'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2188427525612726313)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_text=>'Dual'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1622070796234926411)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_text=>'Monochromatic'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1622071789120934541)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_text=>'Separation'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1622071341950931650)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_text=>'Tetrad'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1622071113567929304)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_text=>'Triad'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1622071569949933457)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_text=>'With Complement'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221175397132427409)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_text=>'You haven''t saved your logo changes.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(221175533163428501)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_text=>'You haven''t saved your theme changes.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830592705217874510)
,p_name=>'UTR.REDO'
,p_message_text=>'Redo'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340237025411954271)
,p_name=>'UTR.RESET'
,p_message_text=>'Reset'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340237242757956075)
,p_name=>'UTR.RESET.PROMPT'
,p_message_text=>'Are you sure you want to reset the CSS? All your changes will be lost. This operation cannot be undone.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2185532764531630133)
,p_name=>'UTR.RESET.STYLE'
,p_message_text=>'Reset Style'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340236419385948710)
,p_name=>'UTR.SAVE'
,p_message_text=>'Save'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340236678822951523)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_text=>'Update the name to rename the current theme style.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340236899211952912)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_text=>'Theme style updated successfully!'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340235743792944240)
,p_name=>'UTR.SAVE_AS'
,p_message_text=>'Save As'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340235926284945427)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_text=>'Enter a name for the new theme style.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340236262363947647)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_text=>'Theme style created successfully!'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1622070146600921382)
,p_name=>'UTR.SEARCH'
,p_message_text=>'Search'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(575489418606328288)
,p_name=>'UTR.SELECT_THEME'
,p_message_text=>'Select Theme'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2141836842914389138)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_text=>'Set as Current'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2185542820789637484)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_text=>'Set as current theme style'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2185546471363640639)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_text=>'The selected theme is now the application''s current theme.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2185553692829647232)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_text=>'You have made changes to a read-only theme. If you set this theme as the application''s "current" theme, your changes will be erased. Are you sure you want to proceed?'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9100850384762540)
,p_name=>'UTR.STYLE_CHANGE.CONFIRM'
,p_message_text=>'Your current customizations will be lost if you switch theme styles. Continue?'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461382543553527103)
,p_name=>'UTR.TABS.LOGO'
,p_message_text=>'Logo'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461382298740527094)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_text=>'Theme Style'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1340232591706917958)
,p_name=>'UTR.THEME_ROLLER'
,p_message_text=>'Theme Roller'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1544724798661211284)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_text=>'Show All'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1544724408636209889)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_text=>'Show Common'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1895390126382487683)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_text=>'Color Wheel'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830592501699873523)
,p_name=>'UTR.UNDO'
,p_message_text=>'Undo'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494560314321159088)
,p_name=>'UTR.UPLOAD'
,p_message_text=>'Upload'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(494560709087160432)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_text=>'Upload Configuration File'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58120826777430073)
,p_name=>'UTR.UPLOAD_ERROR'
,p_message_text=>'This file is incompatible with Theme Roller.'
,p_is_js_message=>true
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88479108573866020)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_text=>'ERR-1812 Unexpected Error converting application alias (%0).'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1034039407140821812)
,p_name=>'VALIDATION_LABEL'
,p_message_text=>'Validation: %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1403762466470564)
,p_name=>'VALUES_ARE_EXCLUSIVE'
,p_message_text=>'Values are Exclusive'
,p_version_scn=>32944784
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5692917266320002)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_text=>'View All Page Groups'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5694020167330300)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_text=>'View All Page Types'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(61006900001457361)
,p_name=>'VIEWS2'
,p_message_text=>'Views'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(452386427982474493)
,p_name=>'VIEW_DEBUG'
,p_message_text=>'View Debug'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(14532632213920428)
,p_name=>'VIEW_DETAILS'
,p_message_text=>'View Details'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(277487500739627688)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_text=>'View'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12364907904841704)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_text=>'View for Printing'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(466847119699822780)
,p_name=>'VIEW_HISTORY'
,p_message_text=>'View history'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(716303491725447743)
,p_name=>'VIEW_IN_BUILDER'
,p_message_text=>'View'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87942426858764735)
,p_name=>'VIEW_IN_PAREN'
,p_message_text=>'(view)'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(925750940191633864)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_text=>'View Lock History'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623890201226478039)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_text=>'This SQL query is used to generate the XML displayed after the clicking the <strong>View XML</strong> button.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5752219264916088)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_text=>'View pages of this type'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461383210995864483)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_text=>'View "%0" page change history'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42641625242062541)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_text=>'View activity for: %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204382326637763681)
,p_name=>'VPD'
,p_message_text=>'Virtual Private Database (VPD)'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224980611401318832)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_text=>'Installing Application...'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1130512519933303602)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_text=>'Removing Application...'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1131220102235117070)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_text=>'Unlocking Application...'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1130514813010317596)
,p_name=>'WAITING.APP_UPDATE'
,p_message_text=>'Updating Application...'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224981808069327360)
,p_name=>'WAITING.GENERIC'
,p_message_text=>'Processing Request'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224982816726329824)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_text=>'Installing Supporting Objects'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345032403238803867)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_text=>'No matching class'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(345031931274790953)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_text=>'Multiple matches'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2200486525899233)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_text=>'Add Service: %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2300484225904550)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_text=>'To be added from Catalog'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2300278894902067)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_text=>'Remove Service: %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(196120422703482667)
,p_name=>'WEB_SERVICE'
,p_message_text=>'Web Service'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88140408538812764)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_text=>'Web Service result'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1215145007262023)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_text=>'Oracle Cloud Applications (SaaS) REST Service'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1214542030255069)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_text=>'Simple HTTP'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1215314590263192)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_text=>'Oracle Cloud Infrastructure (OCI)'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2800998401736620)
,p_name=>'WEB_SOURCE.NATIVE_ODATA'
,p_message_text=>'OData REST Service'
,p_version_scn=>37165793743213
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1214949453259463)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_text=>'Oracle REST Data Services'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2102229690613076)
,p_name=>'WEB_SOURCE.NATIVE_REST_ENABLED_SQL_QUERY'
,p_message_text=>'REST Enabled SQL Query'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7400881332165880)
,p_name=>'WEB_SOURCE.ODATA.DEFAULT_VALUE_NOT_FOUND'
,p_message_text=>'Default value for parameter %0 is not found.'
,p_version_scn=>37165793717650
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7401233270186715)
,p_name=>'WEB_SOURCE.ODATA.ILLEGAL_PARAMETER'
,p_message_text=>'At least 1 illegal ODATA Parameter was found in URL. Please don''t use any of these Parameters when adding an ODATA Source: %0'
,p_version_scn=>37165793717650
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7401405177281633)
,p_name=>'WEB_SOURCE.ODATA.NO_RESOURCE_PATH_FOUND'
,p_message_text=>'Resource Path is not found. Please check if the resource path is given or not.'
,p_version_scn=>37165793717650
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7401624233298678)
,p_name=>'WEB_SOURCE.ODATA.PARAMETER_ERROR'
,p_message_text=>'Something went wrong with parameters.'
,p_version_scn=>37165793717650
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7400624914132822)
,p_name=>'WEB_SOURCE.ODATA.RESOURCE_PATH_ERROR'
,p_message_text=>'%0 is not a valid resource path.'
,p_version_scn=>37165793717650
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18455914211326025)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_text=>'Complete this registration wizard to request an Oracle APEX workspace.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(211008018515725223)
,p_name=>'WHITE_TEXT'
,p_message_text=>'White Text'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25425730443722532)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_text=>'Within next 1 day'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(628538530409770408)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_text=>'Within next %0 days'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184185524449355472)
,p_name=>'WITH_ADMIN'
,p_message_text=>'with admin option'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88142001790848622)
,p_name=>'WITH_SHORTCUTS'
,p_message_text=>'with shortcuts'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(276203862919071135)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_text=>'Page Number already exists in this application.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(275500301976021864)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_text=>'Page Number is reserved.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104784600721973334)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_text=>'Delete Checked'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(44301477802556989)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_text=>'Commented Out'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1697118292216338)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_text=>'Reset Page'
,p_is_js_message=>true
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(588242030765745084)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_text=>'Card Columns'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47400533351126465)
,p_name=>'WIZARD.CREATE.PAGE.BLANK'
,p_message_text=>'Blank Page'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47402021931158765)
,p_name=>'WIZARD.CREATE.PAGE.CALENDAR'
,p_message_text=>'Calendar'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2507521972462270)
,p_name=>'WIZARD.CREATE.PAGE.CARD'
,p_message_text=>'Cards'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47401173133139476)
,p_name=>'WIZARD.CREATE.PAGE.CHART'
,p_message_text=>'Chart'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501776249501888254)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_text=>'Classic Report'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47401784954154448)
,p_name=>'WIZARD.CREATE.PAGE.DASHBOARD'
,p_message_text=>'Dashboard'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47500715265167655)
,p_name=>'WIZARD.CREATE.PAGE.DATALOAD'
,p_message_text=>'Data Loading'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472562804610840957)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_text=>'Faceted Search'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47201942429072960)
,p_name=>'WIZARD.CREATE.PAGE.FORM'
,p_message_text=>'Form'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501791015131946954)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_text=>'Create Form and List View'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501833677131200783)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROC'
,p_message_text=>'Form on a Local Procedure'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501831997162147772)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_text=>'Create Form on SQL Query'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501831445513135291)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_text=>'Create Form'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(887064206085140727)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_text=>'Create Form on Web Service'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15500352346346430)
,p_name=>'WIZARD.CREATE.PAGE.FORMWS'
,p_message_text=>'Form on Legacy Web Service'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4756153754177501)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_text=>'Facet'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501776051355884913)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_text=>'Interactive Grid'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501775823767882947)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_text=>'Interactive Report'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15500714566353023)
,p_name=>'WIZARD.CREATE.PAGE.LEGACY_DATA_LOAD'
,p_message_text=>'Legacy Data Loading'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2282830237311266)
,p_name=>'WIZARD.CREATE.PAGE.MAP'
,p_message_text=>'Map'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501776496986890827)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_text=>'Master Detail'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47400807013136495)
,p_name=>'WIZARD.CREATE.PAGE.PLUGIN'
,p_message_text=>'Plug-in Page'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501777100165919517)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_text=>'Create Report'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15500563800350624)
,p_name=>'WIZARD.CREATE.PAGE.REPORTANDFORMWS'
,p_message_text=>'Report and Form on Legacy Web Service'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501790272601940012)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_text=>'Create Report with Form'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600826570564864)
,p_name=>'WIZARD.CREATE.PAGE.SEARCH'
,p_message_text=>'Search Page'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807559528424190)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_text=>'Smart Filters'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4756337031178436)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_text=>'Filter'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15401008042331067)
,p_name=>'WIZARD.CREATE.PAGE.SUMMARY'
,p_message_text=>'Summary Page'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501791708859952095)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_text=>'Create Tabular Form'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3501091324445329)
,p_name=>'WIZARD.CREATE.PAGE.TASKLIST'
,p_message_text=>'Unified Task List'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1601126471135751)
,p_name=>'WIZARD.CREATE.PAGE.TEMPLATE_REPORT'
,p_message_text=>'Template Report'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47500496422162332)
,p_name=>'WIZARD.CREATE.PAGE.TREE'
,p_message_text=>'Tree'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(501776883228896974)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_text=>'Report on Legacy Web Service'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47501262068173181)
,p_name=>'WIZARD.CREATE.PAGE.WIZARD'
,p_message_text=>'Wizard'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2401224726874395)
,p_name=>'WIZARD.CREATE.PAGE.WORKFLOWCONSOLE'
,p_message_text=>'Workflow Console'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(74580439376179215)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_text=>'This wizard requires an Universal Theme based application.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29864930406798821)
,p_name=>'WIZARD.DEFAULT_PAGE_NAME'
,p_message_text=>'Step %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1656416143590668)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_text=>'Process form %0'
,p_is_js_message=>true
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1656182589586100)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_text=>'Initialize form %0'
,p_is_js_message=>true
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(253803183554891342)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_text=>'SQL Query'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(253802790101889590)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_text=>'Table'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(268252947408634353)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_text=>'%0 - Save Interactive Grid Data'
,p_is_js_message=>true
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261090938402869328)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_text=>'Classic Report'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261090653642868106)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_text=>'Interactive Grid'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261090475504866946)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_text=>'Interactive Report'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261091303661873593)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_text=>'Report'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(261091119169871690)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_text=>'Report on Web Service'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16400518812134583)
,p_name=>'WIZARD.TAB_NAVIGATION_MSG'
,p_message_text=>'Note: Your application is using legacy tab based navigation. If you want to associate this new page with any tabs, please use "Shared Components, Tabs" section, after the page creation.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(85003306900638167)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_text=>'#LABEL# must have some value.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190687831181344518)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_text=>'Validation error occurred.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(190687506940337543)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_text=>'#COLUMN_HEADER# must have a value.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(231724831116859265)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_text=>'The wizard pages have been created successfully.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1856720536839689391)
,p_name=>'WIZARD_PROGRESS'
,p_message_text=>'Wizard Progress'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(206210001485385998)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_text=>'The Wizard Report page has been created successfully.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2002005462733412)
,p_name=>'WORKFLOW_TRANSITIONS'
,p_message_text=>'Workflow Transitions'
,p_version_scn=>38788295
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88198018917440193)
,p_name=>'WORKSPACE'
,p_message_text=>'workspace'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(193924912298227598)
,p_name=>'WORKSPACE IMAGE'
,p_message_text=>'Workspace Image'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254079406026451177)
,p_name=>'WORKSPACES'
,p_message_text=>'Workspaces'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184170811412935387)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_text=>'Workspace Applications'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184172226265987017)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_text=>'Workspace Application Activity Summary'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617129505933516957)
,p_name=>'WORKSPACE_COUNT'
,p_message_text=>'Current Workspace Count'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184027630609051646)
,p_name=>'WORKSPACE_ID'
,p_message_text=>'Workspace ID'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(486385620974570962)
,p_name=>'WORKSPACE_IMAGES'
,p_message_text=>'Workspace Images'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254129605113044083)
,p_name=>'WORKSPACE_INITCAP'
,p_message_text=>'Workspace'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(145399824184219659)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_text=>'Workspace'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23824605279121414)
,p_name=>'WORKSPACE_LABEL'
,p_message_text=>'Workspace: %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12757517521142166)
,p_name=>'WORKSPACE_LOGIN'
,p_message_text=>'Workspace Login'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(387742682681584361)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_text=>'Workspace Message'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184027032425033222)
,p_name=>'WORKSPACE_NAME'
,p_message_text=>'Workspace Name'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(315871221311578483)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_text=>'Workspace Override ID'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(195796105475987409)
,p_name=>'WORKSPACE_REQUEST'
,p_message_text=>'Workspace Request'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184170026733920950)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_text=>'Workspace Schemas'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26400205323109546)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_text=>'You will receive an email to activate your workspace once this request has been approved.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254080529484500984)
,p_name=>'WORKSPACE_USERS'
,p_message_text=>'Workspace Users'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184068228606306470)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_text=>'%0 workspace summary'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171873903476949808)
,p_name=>'WORK_INITIATED'
,p_message_text=>'Work Initiated'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(171874111094951933)
,p_name=>'WORK_PROGRESSING'
,p_message_text=>'Work Progressing'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176656400821025846)
,p_name=>'WRITING'
,p_message_text=>'Writing'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623891606121507794)
,p_name=>'WS.CAPABILITY'
,p_message_text=>'Capability'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(623891218111501822)
,p_name=>'WS.READER'
,p_message_text=>'Reader'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(204776020793274465)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_text=>'The Web Service Reference has been added to Application %0.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9327617644280197)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_text=>'Access Control'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458518321268805695)
,p_name=>'WS_ADD_FILE'
,p_message_text=>'Add File'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(891438907504826628)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_text=>'There was not enough space to add the file. Request additional storage by going to the administration page, go to manage service and click request storage.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468745713685681944)
,p_name=>'WS_ADD_LINK'
,p_message_text=>'Add Link'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499073322755673349)
,p_name=>'WS_ADD_NEW'
,p_message_text=>'Add New'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468746127538685976)
,p_name=>'WS_ADD_NOTE'
,p_message_text=>'Add Note'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468716324057833488)
,p_name=>'WS_ADD_ROW'
,p_message_text=>'Add Row'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468745330870677486)
,p_name=>'WS_ADD_TAGS'
,p_message_text=>'Add Tags'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503040804580026682)
,p_name=>'WS_ADD_VALIDATION'
,p_message_text=>'Add Validation'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9327204700266974)
,p_name=>'WS_ADMINISTRATION'
,p_message_text=>'Administration'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(457386507474788760)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_text=>'The alias must be specified.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6629826488180436)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_text=>'Alias must be alphanumeric.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10742132550345534)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_text=>'Alias is too long. The limit is 255 characters.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503004931686391156)
,p_name=>'WS_ALL_ROWS'
,p_message_text=>'All Rows'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499110112122802755)
,p_name=>'WS_ANNOTATIONS'
,p_message_text=>'Annotations'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9327405523276700)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_text=>'Application Properties'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503249225769279490)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_text=>'The selected display type cannot use the List of Values.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503896228387569721)
,p_name=>'WS_CHANGED'
,p_message_text=>'Changed'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499738232412123677)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_text=>'Change Column Type'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503940620665785087)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_text=>'You have requested to change the report query. If you added columns to the query, they will not be displayed when the report is run. You will need to use the actions menu and either select the columns or click <strong>Reset</strong>. If you removed a'
||'ny columns from the query, it will disable existing filters, highlight rules, and other report settings referencing those columns. Please confirm your request.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9200958478013844)
,p_name=>'WS_CHOOSE_FILE'
,p_message_text=>'Choose File'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499821311802429921)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_text=>'Column Alignment'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468744909745671344)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_text=>'Column Groups'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(862743311343586607)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_text=>'Column name exists already. Please enter a different name.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468744402342659769)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_text=>'Column Properties'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499870717380734259)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_text=>'Confirm to perform this delete action'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503248624122260072)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_text=>'The column label must be specified.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503845115986395882)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_text=>'Column must be selected to change the value.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503855529323437491)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_text=>'Column must be selected to replace the value.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503257032527319240)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_text=>'The column name must be specified.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503248300920253318)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_text=>'The column must be selected to edit.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503286116531484897)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_text=>'The column(s) must be selected to remove.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499670519580968543)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_text=>'comma separated list'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499845614431695538)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_text=>'Enter comma separated list.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503245921127192915)
,p_name=>'WS_CONF_DELETE'
,p_message_text=>'Please confirm to delete.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(945619325205410352)
,p_name=>'WS_CONTROL_PANEL'
,p_message_text=>'Control Panel'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617862725456299066)
,p_name=>'WS_COPY'
,p_message_text=>'Copy'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436572032548159465)
,p_name=>'WS_COPY_PAGE'
,p_message_text=>'New Page as a Copy'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436560509318925664)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_text=>'Create Chart Section'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(202663428296408083)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_text=>'Create Data Grid'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436561908719982326)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_text=>'Create Data Section'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499674802312992001)
,p_name=>'WS_CREATE_DATE'
,p_message_text=>'Current Date'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436567932408074310)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_text=>'Create Navigation Section'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436571212678144279)
,p_name=>'WS_CREATE_PAGE'
,p_message_text=>'Create Page'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21378930819900485)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_text=>'Create PL/SQL Section'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436559701821857332)
,p_name=>'WS_CREATE_SECTION'
,p_message_text=>'Create Section'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436564227728035073)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_text=>'Create Text Section'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499677526553998988)
,p_name=>'WS_CURRENT_USER'
,p_message_text=>'Current User'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9326717897223485)
,p_name=>'WS_DASHBOARD'
,p_message_text=>'Dashboard'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2195410933380529)
,p_name=>'WS_DATA'
,p_message_text=>'Data'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(186913030164669148)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_text=>'The maximum number of columns available for the column type reached.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(867497026776130435)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_text=>'Duplicate column names are found.  Column name must be unique.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(660489432495863177)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_text=>'Data Grid name exists already. Please enter a different name.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499683807553021840)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_text=>'Default Text'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499674425383989128)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_text=>'Default Type'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1288060913137471009)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_text=>'Define Data Grid Columns'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499852813308714106)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_text=>'Delete Columns'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(454870903562356963)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_text=>'Delete Data Grid'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503011409288592861)
,p_name=>'WS_DELETE_ROWS'
,p_message_text=>'Delete Rows'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499855007898722074)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_text=>'Select column(s) to permanently remove along with the data:'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17234226319893876)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_text=>'The first column must be primary key of the Data Grid to display edit or add row link.  Please add "APXWS_DATA_GRID_PK" substitution as the first column in the select statement to include primary key.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15635207969738843)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_text=>'The query must reference Data Grid only once in order to display edit or add row link.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17251618372393106)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_text=>'The query contains more than one select statements.  Please add "APXWS_DATA_GRID_PK" substitution as the first column in the select statement to display edit or add row link.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(506161431345185348)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_text=>'SQLVALUE Tag Syntax:'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(258012623793330173)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_text=>'SQL Tag Syntax:'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499588308789861406)
,p_name=>'WS_DISPLAY_AS'
,p_message_text=>'Display As'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499208028379006056)
,p_name=>'WS_DOCUMENT'
,p_message_text=>'Document'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(457386006997779187)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_text=>'Cannot choose the same column for the primary key.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(498969210101206128)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_text=>'Edit Attachment'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617891312474333190)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_text=>'Edit Attributes'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9317929681602386)
,p_name=>'WS_EDIT_FILE'
,p_message_text=>'Edit File'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9309907415463494)
,p_name=>'WS_EDIT_NOTE'
,p_message_text=>'Edit Note'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(436569520942118279)
,p_name=>'WS_EDIT_PAGE'
,p_message_text=>'Edit Page'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617906321263345205)
,p_name=>'WS_EDIT_QUERY'
,p_message_text=>'Edit Query'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(444795232023434819)
,p_name=>'WS_EDIT_SECTION'
,p_message_text=>'Edit Section'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(495971800236663780)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_text=>'Edit Sections'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9321627772914099)
,p_name=>'WS_EDIT_TAG'
,p_message_text=>'Edit Tag'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27034525080684618)
,p_name=>'WS_EDIT_TAGS'
,p_message_text=>'Edit Tags'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22862126579986015)
,p_name=>'WS_EMAIL_PAGE'
,p_message_text=>'Email Page'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499886027432812873)
,p_name=>'WS_EMPTY_ROW'
,p_message_text=>'Empty Rows'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(450213012349820992)
,p_name=>'WS_ERROR'
,p_message_text=>'Error %0 %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503064202829224860)
,p_name=>'WS_ERR_MESSAGE'
,p_message_text=>'Error Message'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503891508769497799)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_text=>'Error message must be specified.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471105511829264919)
,p_name=>'WS_FILE'
,p_message_text=>'File'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458949229317489193)
,p_name=>'WS_FILES'
,p_message_text=>'Files'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1830416430764587651)
,p_name=>'WS_FILE_REQUIRED'
,p_message_text=>'File must have some value'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503007717796434427)
,p_name=>'WS_FILL'
,p_message_text=>'Fill'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503008915812490622)
,p_name=>'WS_FILL_HLP'
,p_message_text=>'Fill down null column values with column value from above cell.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503006423422417182)
,p_name=>'WS_FIND_WHAT'
,p_message_text=>'Find What'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499739423193130403)
,p_name=>'WS_GROUP'
,p_message_text=>'Group'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503027626416834312)
,p_name=>'WS_GROUP_NAME'
,p_message_text=>'Group Name'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503832713468338371)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_text=>'The group name must be specified.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499819528724406361)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_text=>'Heading Alignment'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499823009771457717)
,p_name=>'WS_HEIGHT'
,p_message_text=>'Height'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503838821957378616)
,p_name=>'WS_INVALID_COL'
,p_message_text=>'Invalid column'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503246918272211108)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_text=>'Invalid column name'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478311718013293688)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_text=>'Invalid Data Grid Name or Alias'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458950317673495295)
,p_name=>'WS_LINKS'
,p_message_text=>'Links'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503037025349956930)
,p_name=>'WS_LINK_NAME'
,p_message_text=>'Link Name'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(457497924797569575)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_text=>'Link to this page'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503011031751570892)
,p_name=>'WS_LOAD_ORDER'
,p_message_text=>'load order'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503250117374295900)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_text=>'The list of values name already exists.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499669315293957908)
,p_name=>'WS_LOV_DEF'
,p_message_text=>'List of Values Definition'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503251006423302222)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_text=>'The list of values definition must be specified.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499841312176657033)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_text=>'List of Values are used to restrict the column values a user can enter.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499842103995664210)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_text=>'You can associate the defined List of Values to a column at edit Column Properties.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503248902913272848)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_text=>'The List of Values must be defined for the selected display type.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503249523130288188)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_text=>'The List of Values name must be specified.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499668725898951421)
,p_name=>'WS_LOV_NAME'
,p_message_text=>'List of Values Name'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458948230225480077)
,p_name=>'WS_MAP'
,p_message_text=>'Map'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499822519336450948)
,p_name=>'WS_MAX_WIDTH'
,p_message_text=>'Maximum Width'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(270242109027513821)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_text=>'Maximum Width cannot be greater than 4000.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499069329194590053)
,p_name=>'WS_MINIMIZE'
,p_message_text=>'minimize'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468744020218655435)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_text=>'Move Columns'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631158119244296545)
,p_name=>'WS_MUST_BE_DATE'
,p_message_text=>'%0 does not match date format of %1.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503833823296350626)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_text=>'The new Data Grid name must be specified.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(457385720025773478)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_text=>'The name must be specified.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499879024614783683)
,p_name=>'WS_NEW_COL_VAL'
,p_message_text=>'New Column Value'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9325022652168129)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_text=>'New Data Grid'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503012730291665114)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_text=>'New Data Grid Name'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503022911609811118)
,p_name=>'WS_NEW_GROUP'
,p_message_text=>'New Group'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499665710052927921)
,p_name=>'WS_NEW_LOV'
,p_message_text=>'New List of Values'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499830610781580988)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_text=>'New List of Values Based on Current Values'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9324213386146463)
,p_name=>'WS_NEW_PAGE'
,p_message_text=>'New Page'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9325304775172399)
,p_name=>'WS_NEW_REPORT'
,p_message_text=>'New Report'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9323822258139638)
,p_name=>'WS_NEW_SECTION'
,p_message_text=>'New Section'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503041511899057109)
,p_name=>'WS_NEW_VALIDATION'
,p_message_text=>'New Validation'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503895204707553435)
,p_name=>'WS_NEW_VALUE'
,p_message_text=>'New Value'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381524045769406723)
,p_name=>'WS_NOTE'
,p_message_text=>'Note'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458949509016492786)
,p_name=>'WS_NOTES'
,p_message_text=>'Notes'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381524801564510878)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_text=>'Note must have some value. '
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9323526629131399)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_text=>'No columns found'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9316726387563606)
,p_name=>'WS_NO_FILES'
,p_message_text=>'No Files'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9201140664017154)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_text=>'No file chosen'
,p_is_js_message=>true
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9311326293506816)
,p_name=>'WS_NO_NOTES'
,p_message_text=>'No Notes'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9322104363992499)
,p_name=>'WS_NO_TAGS'
,p_message_text=>'No Tags'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499206113011992174)
,p_name=>'WS_NUMBER'
,p_message_text=>'Number'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503894809425545369)
,p_name=>'WS_OLD_VALUE'
,p_message_text=>'Old Value'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503009300837505242)
,p_name=>'WS_ORDER_BY'
,p_message_text=>'Order By'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471106113953293908)
,p_name=>'WS_PAGE_ALIAS'
,p_message_text=>'Page Alias'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22639610735562144)
,p_name=>'WS_PAGE_CREATED'
,p_message_text=>'Page created'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471106430229298549)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_text=>'Page Description'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9324707068163626)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_text=>'Page Directory'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9327025001263388)
,p_name=>'WS_PAGE_HISTORY'
,p_message_text=>'Page History'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(771904615091445156)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_text=>'Hierarchical Page List with Child Pages'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617731916387116739)
,p_name=>'WS_PROPERTIES'
,p_message_text=>'Properties'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503245502296178044)
,p_name=>'WS_QRY_MORE_10K'
,p_message_text=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(486499927673956978)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_text=>'Query on internal application objects not allowed.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499795929866189155)
,p_name=>'WS_READ_ONLY'
,p_message_text=>'Read Only'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503892400720514460)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_text=>'Recent changes listed below:'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617847411772257332)
,p_name=>'WS_REPLACE'
,p_message_text=>'Replace'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503007319051425388)
,p_name=>'WS_REPLACE_WITH'
,p_message_text=>'Replace With'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503894306523534980)
,p_name=>'WS_ROW'
,p_message_text=>'Row'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503012216261623210)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_text=>'Rows with Empty Columns'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629560200527704446)
,p_name=>'WS_ROW_CREATED'
,p_message_text=>'Row %0 created %1 by %2'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629385619435006486)
,p_name=>'WS_ROW_KEY'
,p_message_text=>'Row Key'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629560580468709460)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_text=>'Content last updated %0 by %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503851100103419665)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_text=>'A row must be selected to set the column value.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458948911309484044)
,p_name=>'WS_ROW_ORDER'
,p_message_text=>'Row Order'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503246612601199949)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_text=>'A row must be selected to delete.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461294302788594373)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_text=>'Sample home page will be created.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(468714532190797982)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_text=>'Save and Add Another'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(789640212328151347)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_text=>'Search Report %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471105803302271851)
,p_name=>'WS_SECTION_CONTENT'
,p_message_text=>'Section Content'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22639302770559806)
,p_name=>'WS_SECTION_CREATED'
,p_message_text=>'Section created'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(461295728761601879)
,p_name=>'WS_SECTION_TITLE'
,p_message_text=>'Section Title'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499883308039807273)
,p_name=>'WS_SELECTED'
,p_message_text=>'Selected'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503005424891398648)
,p_name=>'WS_SELECTED_ROWS'
,p_message_text=>'Selected Rows'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499740014320137292)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_text=>'Select Column Group'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(419241619142027810)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_text=>'Select the report name to view the columns.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503826614760281944)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_text=>'The sequence must be numeric.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503305306367548167)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_text=>'The sequence must be specified.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499874504828749551)
,p_name=>'WS_SET_COL_VAL'
,p_message_text=>'Set Column Values'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(838603569554567425)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_text=>'<a rel="noopener noreferrer" href="https://www.oracle.com/legal/privacy/index.html" target="_new">Oracle Privacy Policy</a>'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(783778259139144818)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'By clicking on the "Next" button below, you understand and agree that the use of Oracle''s web site is subject to the <a rel="noopener noreferrer" href="https://www.oracle.com/us/legal/terms/index.html" target="_new">Oracle.com Terms of Use</a>.',
'Additional details regarding Oracle''s collection and use of your personal information, including information about access, retention, rectification, deletion, security, cross-border transfers and other topics,',
'is available in the <a rel="noopener noreferrer" href="https://www.oracle.com/legal/privacy/index.html" target="_new">Oracle Privacy Policy.</a>'))
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499204914265983071)
,p_name=>'WS_STRING'
,p_message_text=>'String'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503856030839447466)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_text=>'String to find must be specified.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458950625985497748)
,p_name=>'WS_TAGS'
,p_message_text=>'Tags'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617732413401125338)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_text=>'Toggle Checkboxes'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503042032247081982)
,p_name=>'WS_TYPE'
,p_message_text=>'Type'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503030015035859378)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_text=>'Unassigned Columns'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499162310147934605)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_text=>'Unique Identifier'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503037514744963414)
,p_name=>'WS_URL_TARGET'
,p_message_text=>'URL Target'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503856907206459582)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_text=>'URL target must be specified.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503895900336561658)
,p_name=>'WS_USER'
,p_message_text=>'User'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(829736144960026542)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_text=>'Username too long'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(631156801236291387)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_text=>'%0 must be numeric.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381522837978257338)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_text=>'(Value Required)'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503063711356217801)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_text=>'Validation Expression'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503860902620477126)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_text=>'Validation name must be specified.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503044110261113444)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_text=>'Column specified does NOT equal string literal in Expression'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503877200673485987)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_text=>'Validation sequence must be specified.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503043200433101106)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_text=>'Column specified contains at least one of the characters in Expression'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503061427932194199)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_text=>'Column specified is alphanumeric'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503060130740147721)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_text=>'Column specified is contained in Expression'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503060315980152967)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_text=>'Column specified is NOT zero'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503059724375136484)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_text=>'Column specified is NOT contained in Expression'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503061209578188927)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_text=>'Column specified is NOT NULL or zero'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503060502605158537)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_text=>'Column specified contains no spaces'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503061615250200057)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_text=>'Column specified is numeric'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503062402221205704)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_text=>'Column specified is a valid date'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503059304982130833)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_text=>'Column specified equals string literal in Expression'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503045203466120954)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_text=>'Column specified does not contain any of the characters in Expression'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503042909306094269)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_text=>'Column specified is NOT NULL'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503043720865107032)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_text=>'Column specified contains only characters in Expression'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(503915617567585470)
,p_name=>'WS_VIEW'
,p_message_text=>'View'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(771722804393394809)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_text=>'View Data Grid'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(498944202735147241)
,p_name=>'WS_VIEW_FILES'
,p_message_text=>'View Files'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(498962727154192163)
,p_name=>'WS_VIEW_NOTES'
,p_message_text=>'View Notes'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(498947711309168605)
,p_name=>'WS_VIEW_TAGS'
,p_message_text=>'View Tags'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(499821624400443021)
,p_name=>'WS_WIDTH'
,p_message_text=>'Width'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458940815371428465)
,p_name=>'WS_WITHOUT_FILES'
,p_message_text=>'Without Files'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458944629701442079)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_text=>'Without Links'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458946724637450056)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_text=>'Without Location'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458943804420434764)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_text=>'Without Notes'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458939918010419735)
,p_name=>'WS_WITH_FILES'
,p_message_text=>'With Files'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458944317234438426)
,p_name=>'WS_WITH_LINKS'
,p_message_text=>'With Links'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458945308014445246)
,p_name=>'WS_WITH_LOCATION'
,p_message_text=>'With Location'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(458941724721431095)
,p_name=>'WS_WITH_NOTES'
,p_message_text=>'With Notes'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(192135231872515868)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_text=>'<p>Query must contain at least one date or timestamp column, please check your query. (%0) </p>'
,p_version_scn=>37166027476591
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104322314843477948)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_text=>'Key must be 8, 16, or 24 bytes.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9404184262282029)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_text=>'Application %0 does not exist in this workspace.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9404501818286629)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_text=>'Loading table %0 failed. Errors logged in table %1. This table must be dropped prior to re-running.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9403920162279287)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_text=>'no file generated'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9401201684241939)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_text=>'rows exported'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9404773239288589)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_text=>'Error table %0 already exists. This table must be dropped prior to re-running.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9404317793284350)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_text=>'All included columns are unsupported data types.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2231762375596005)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_text=>'The %0 schema needs READ and WRITE privileges on the DATA_PUMP_DIR directory.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3028197611430967)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_text=>'The chosen object store file is too large.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1774737063929018)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_text=>'An internal error has occurred while processing the DBMS_CLOUD request.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1774934746932543)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_text=>'Invalid credential type for an object store reference.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2231531577594606)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_text=>'The %0 schema needs access privileges for the DATA_PUMP_DIR directory.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2893586688311699)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_text=>'The DBMS_CLOUD package is not available on this system.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2231329579593444)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_text=>'The %0 schema needs the EXECUTE privilege on the DBMS_CLOUD package.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91476310681856338)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_text=>'parse error: Function body must not be null.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91477925703870136)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_text=>'parse error: %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88381300880258184)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_text=>'application=%0 current workspace=%1 requested workspace=%2'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88379304428240302)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_text=>'ERR-1014 Application not found.  Invalid workspace.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88407219346471762)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_text=>'application=%0 page=%1 request=%2'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88327003174899281)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_text=>'ERR-1082 Error in executing authorization scheme code.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88354902799022211)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_text=>'ERR-1007 Branch point can not be null: %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88356921500027628)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_text=>'ERR-1008 Error performing branch to page %0.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3783462999513)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_text=>'ERR-7746 Unable to process branch from a Dialog page to a page of a different page mode.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90635200725016256)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_text=>'Error fetching button template id=%0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88288311298788152)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_text=>'<p>Click <a href="%0">here</a> to login'
,p_version_scn=>14511294
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88339305130966102)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_text=>'ERR-1030 Error executing computation expression.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88344631926983354)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_text=>'ERR-1004 Unable to compute function. computation_point=%0 computation_type=%1'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88334227031953545)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_text=>'ERR-1003 Error executing computation query.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88333831402945337)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_text=>'ERR-1001 Unexpected error creating item: FSP_PROCESS_STATE_%0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88320705766862172)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_text=>'ERR-1001 Unexpected error in make_deeplinking_item session=%0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88364207788108795)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_text=>'Expecting p_company or wwv_flow_company cookie to contain security group id of application owner.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88394714143394514)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_text=>'ERR-7621 Could not determine workspace for application (%0) on application accept.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88395103538400931)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_text=>'Expecting p_company or wwv_flow_company cookie to contain security group id of application owner.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88360209688071529)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_text=>'ERR-1011 Invalid evaluation type: %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90629301848997585)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_text=>'Application error in fetch_value.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88324312608883071)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_text=>'ERR-1902 Item ID is null in find_item_name routine.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88353405092013382)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_text=>'ERR-1021 Unable to run "function body returning boolean" validation.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88352922277008912)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_text=>'ERR-1024 Unable to run "function body returning text" validation.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88361525056085421)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_text=>'ERR-1812 Unexpected error assigning G_FLOW_ID (%0).'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88396129296417854)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_text=>'ERR-9988 Insufficient information provided for this request:  It is likely that you did not wait for your previous page to fully load.  Press your browsers back and reload buttons, or navigate to your applications home page to continue.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88367632638134887)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_text=>'ERR-1555 Not logged into to Oracle Login Server.  No public user identified.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88388431533304905)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_text=>'Log Out'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88281125796763944)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_text=>'Not logged in.  Cookie required for authentication was missing or invalid.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88423912598507598)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_text=>'ERR-1777: Page %0 provided no page to branch to.  Please report this error to your application administrator.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88391014133318821)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_text=>'ERR-1013 No privilege for attempted operation by user %0. Requires role %1, please contact your application administrator.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21003510000703384)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_text=>'Page may be requested with arguments if a checksum is passed to the show procedure'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21004329740709008)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_text=>'Page may be accessed only using a "Branch to Page" type branch, from another page'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21003919697706131)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_text=>'Page may be accessed only without arguments'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21005526408717534)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_text=>'Arguments were passed to a page that does not accept arguments (request, clear cache, item values).'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(21003101689700943)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_text=>'Page has no protection'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88387707984298150)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_text=>'Required role not enabled.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88426830606512828)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_text=>'<a href="f?p=%0">Restart Application</a>'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88319712215854623)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_text=>'ERR-1001 Unexpected error in Save Routine.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88359825833066738)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_text=>'ERR-1910 Error evaluating SQL expression in heading text.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106478118325347989)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_text=>'Unable to direct you to the home page.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88394325093388260)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_text=>'ERR-1512 Unable to resolve page alias (%0).'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90671203374083205)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_text=>'Unable to set timed_statistics: %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90667108784075267)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_text=>'Unable to trace: %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88376318448206546)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_text=>'ERR-1444 Unsupported authentication scheme.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88351229072001374)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_text=>'ERR-1006 Error in validation routine.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91480001771910490)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_text=>'Deprecated'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106862507549492782)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_text=>'Error in delete developer role. %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106860014691485444)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_text=>'Cannot fetch find user information. %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167862731417927258)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_text=>'Warning:  User %0 does not have any developer privileges'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603976066557226)
,p_name=>'WWV_FLOW_API.CANNOT_REMOVE_APP_WITH_RUNNING_BACKGROUND_EXECS'
,p_message_text=>'Cannot remove application while background executions are running. Use APEX_APPLICATION_INSTALL.SUSPEND_BACKGROUND_EXECS or set "Keep Background Executions" to FALSE.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43346112185820732)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_text=>'COMPATIBLE (You should be able to run this import without issues.)'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(572813752932115210)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'WARNING for credential "%0" (Static ID):',
'',
'- Oracle APEX export files do not contain credential information.',
'- Use the APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL procedure to set the',
'- credentials after the application has been imported. The credential is being',
'- referenced with its static ID "%0"'))
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43148225164160194)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_text=>'Your Current Version:'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(269561094782992439)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_text=>'Can not delete application %0, it is installed in a different workspace!'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(69711819790615025)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_text=>'Error page=%0 item="%1" id="%2" has same name as existing application-level item.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43148018597160190)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_text=>'API Last Extended:'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43247607140629984)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_text=>'This export file is incompatible with the version of Oracle APEX you are attempting to import the file into.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43151508956160203)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_text=>'The procedure %0 was called without a value for p_id -- a application ID must be provided.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1310913285729482)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_text=>'Application ID "%0" is not in the allowed range (%1 - %2)'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(267889011676974627)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_text=>'Application ID "%0" cannot be used, the range (%1 - %2) is reserved'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43162621072160235)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_text=>'Application ID %0 is reserved is Oracle Corporation '
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1311024804729573)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_text=>'Application ID "%0" is reserved for another workspace and can not be used here'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43151804783160203)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_text=>'Application %0 was not deleted. Import will not be attempted.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43148518890160196)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_text=>'This import is compatible with version:'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(239236027976309173)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_text=>'Unable to import script. %0'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43150618340160200)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_text=>'Invalid username, password, or workspace combination'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43148802602160196)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_text=>'Your application import did not supply an export version.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(572789649333027939)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_text=>'No values have been provided for the remote server with static ID "%0". Use APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER before installing the application.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(239066220639777193)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_text=>'new'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43346309752820732)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_text=>'NOT COMPATIBLE (Your export may contain calls not supported by your %0 version.)'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(572833322173119772)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'WARNING for remote server "%0" (Static ID).',
'',
'- Attributes for this remote server have been set with APEX_APPLICATION_INSTALL.',
'- Note that other applications also use this remote server object.',
'',
'Thus, workspace remote server attributes have been updated.',
'- Base URL:      %1',
'- HTTPS Host:    %2',
'- ORDS Timezone: %3'))
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(572833192850118816)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'WARNING for remote server "%0" (Static ID).',
'',
'- The PROMPT_ON_INSTALL attribute is set to YES.',
'- No attributes have been provided with APEX_APPLICATION_INSTALL.',
'',
'Thus, workspace remote server settings remain unchanged.',
'- Base URL:      %1',
'- HTTPS Host:    %2',
'- ORDS Timezone: %3',
'',
'Use APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER to change attributes.'))
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(572813990441117488)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'WARNING for remote server "%0" (Static ID).',
'',
'- The PROMPT_ON_INSTALL attribute is set to NO.',
'- Settings from application import file are different to existing attributes.',
'- This remote server is also used by other applications in this workspace.',
'',
'Thus, workspace remote server settings remain unchanged.',
'- Base URL:      %1',
'- HTTPS Host:    %2',
'- ORDS Timezone: %3',
'',
'Use APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER to change attributes.'))
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(239063326395769367)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_text=>'replace'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472567624246567657)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_text=>'You can''t import feedback into the same system!'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(239241416464324784)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_text=>'Script size %0 bytes exceeds the maximum size allowed.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603599520523992)
,p_name=>'WWV_FLOW_API.SET_KEEP_BACKGROUND_EXECS_NOT_USED'
,p_message_text=>'Application %0 contains background page processes. APEX_APPLICATION_INSTALL.SET_KEEP_BACKGROUND_EXECS must be used to control deployment behavior of existing background executions.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1603749117535073)
,p_name=>'WWV_FLOW_API.SET_KEEP_SESSIONS_REQUIRED'
,p_message_text=>'To preserve background executions, the "On Upgrade Keep Sessions" attribute  (APEX_APPLICATION_INSTALL.SET_KEEP_SESSIONS) must be enabled.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43162319287160233)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_text=>'Package variable g_security_group_id must be set.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43151207920160202)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_text=>'Package variable g_security_group_id must be set to import an application.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43149424497160198)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_text=>'Your engine last API version could not be established.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43149121549160197)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_text=>'Your engine version could not be established.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43150314346160200)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_text=>'You will need to upgrade to import this application export.'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472567110394563659)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_text=>'Feedback hasn''t been exported for this deployment system!'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2120928858607027)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_text=>'Automations referencing REST Data Sources cannot be copied from another application.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001051926060899)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_text=>'New Action'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3944137768982819)
,p_name=>'WWV_FLOW_BARCODE_API.GENERATION_ERROR'
,p_message_text=>'Error generating %0 Barcode.'
,p_version_scn=>119288763
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18161609946068527)
,p_name=>'WWV_FLOW_BARCODE_API.INPUT_CASE_ERROR'
,p_message_text=>'The %0 parameter only expects uppercase letters.'
,p_version_scn=>119288763
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6951639391479542)
,p_name=>'WWV_FLOW_BARCODE_API.INPUT_TOO_LONG'
,p_message_text=>'%0 exceeds %1 characters.'
,p_version_scn=>120168028
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8151482024887087)
,p_name=>'WWV_FLOW_BARCODE_API.INVALID_ERROR_CORRECTION_LEVEL'
,p_message_text=>'The %0 error correction level is not valid.'
,p_version_scn=>119288763
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17961855833178872)
,p_name=>'WWV_FLOW_BARCODE_API.NUMERIC_INPUT_ERROR'
,p_message_text=>'%0 exceeds %1 digits.'
,p_version_scn=>119288763
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18161904326858412)
,p_name=>'WWV_FLOW_BARCODE_API.NUMERIC_INPUT_ERROR2'
,p_message_text=>'%0 is not a valid number.'
,p_version_scn=>119288763
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8144100707719446)
,p_name=>'WWV_FLOW_BARCODE_API.NUMERIC_INPUT_ERROR3'
,p_message_text=>'%0 is not in the correct range: %1.'
,p_version_scn=>119288763
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88523421302888619)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_text=>'Application:'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101037029374248786)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_text=>'No application selected.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88559708404903797)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_text=>'<span class="tiny">No pages found.</span>'
,p_version_scn=>14511342
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88552708966894541)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_text=>'Page:'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88561922949908002)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_text=>'%0 <span size=-2>Pages</span>'
,p_version_scn=>14511468
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148444708816835759)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_text=>'page count:'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(148445113318836972)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_text=>'page list'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88558126281899501)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_text=>'PL/SQL %0 %1 contains %2 lines of source code.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359571771191256354)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_text=>'Code completion is not supported for Remote SQL.'
,p_is_js_message=>true
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359292584454996382)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_text=>'Query Builder is not supported for Remote SQL.'
,p_is_js_message=>true
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106874705864520757)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_text=>'Updatable report parse error: %0'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(850949421871941892)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_text=>'Unable to redirect from a Dialog page to a Normal page.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91492119657981881)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_text=>'obsolete'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91489411430960644)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_text=>'Purged %0 duplicate sessions.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86720607449653855)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_text=>'You may change only your own password.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86722825457658992)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_text=>'Unexpected error processing your change password request: %0'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86714217577637814)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_text=>'Password and password confirmation must be supplied.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86718715976646812)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_text=>'Passwords not matched, try again.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86840624381705987)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_text=>'Oracle Error: %0'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86837423557696267)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_text=>'ERR-1025 Error processing PLSQL expression.  %0'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3800991704465989)
,p_name=>'WWV_FLOW_CODE_EXEC_DEV.RETURN_VALUE_MISSING'
,p_message_text=>'ORA-06503: PL/SQL: Function returned without value'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37733411822893511)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_text=>'Specified member attribute number %0 is invalid'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91537111224045759)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_text=>'Invalid exists/not exists condition: %0'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91514921351029671)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_text=>'Invalid function body condition: %0'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91508922951020670)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_text=>'Invalid PL/SQL expression condition: %0'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91523015248037417)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_text=>'Invalid SQL expression condition: %0'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(102681201479508895)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_text=>'Error during execution of wwv_flow_copy: %0 >> %1'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3788454762194)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_text=>'The translated Application ID is invalid.  The Application ID is in use by an existing application.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(102678522126505440)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_text=>'Security Group ID (your workspace identity) is not set.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(211254146879805901)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_text=>'Application "%0" compatibility mode must be at least 21.2 to 24.1 for a theme refresh. Compatibility mode can be changed from the Application Definition, under Properties.'
,p_version_scn=>20711435
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1387585516973262678)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_text=>'The current theme is not compatible with the selected master theme, the theme identifiers do not match.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27701443832421755)
,p_name=>'WWV_FLOW_COPY_METADATA.LIST_NOT_EXISTS'
,p_message_text=>'Invalid List. List does not exists.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(358233231565942249)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_text=>'Unable to refresh template, parent template not found.'
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39084922695030908)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to publish authentication scheme. %0',
''))
,p_version_scn=>37165770887605
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39077424941993691)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to publish button template. %0',
''))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106599010402336191)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to publish calendar template. %0',
''))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39074025849984558)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_text=>'Unable to publish field template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39086204472035108)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to publish item help. %0',
''))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39070631128967151)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_text=>'Unable to publish list template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39082114599019102)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to publish list of values. %0',
''))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39077905333997519)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to publish Breadcrumb template. %0',
''))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39081225550012786)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_text=>'Unable to publish navigation bar. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39068320608954614)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_text=>'Unable to publish page template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39076210743989577)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_text=>'Unable to publish popup List of Values template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39068811735961559)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_text=>'Unable to publish region template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39071519138973094)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_text=>'Unable to publish report template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39078524380003056)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_text=>'Unable to publish security scheme. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39079409966008344)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to publish shortcut. %0',
''))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39037818512802648)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_text=>'Unable to remove authentication scheme reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38798227413604893)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_text=>'Unable to remove button template reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106598121568320479)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to subscribe to calendar template. %0',
''))
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38783117408554701)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_text=>'Unable to remove field reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39038211370809972)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_text=>'Unable to remove item help reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38777706195542065)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_text=>'Unable to remove list reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38789127020576445)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_text=>'Unable to remove List of Values reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38796614469591734)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_text=>'Unable to remove Breadcrumb template reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38788110397571611)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_text=>'Unable to remove navigation bar reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38771732252530614)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_text=>'Unable to remove page reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38792022649584595)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_text=>'Unable to remove popup List of Values template reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38774323379537504)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_text=>'Unable to remove region reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38779329397548740)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_text=>'Unable to remove report reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38785102994560031)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_text=>'Unable to remove security scheme reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38786221348565295)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_text=>'Unable to remove shortcut reference id. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39055407617913034)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_text=>'Unable to subscribe to authentication scheme. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39045714234867604)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_text=>'Unable to subscribe to button template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(809912007407410419)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_text=>'Unable to subscribe to calendar template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39042528863852961)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_text=>'Unable to subscribe to field template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39062920346935568)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_text=>'Unable to subscribe to item help. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39040703106835997)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_text=>'Unable to subscribe to list template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39050827094899740)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_text=>'Unable to subscribe to List of Values. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39045231072863038)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_text=>'Unable to subscribe to breadcrumb template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39047817613887533)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_text=>'Unable to subscribe to navigation bar. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39039125700823582)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_text=>'Unable to subscribe to page template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39043414796858272)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_text=>'Unable to subscribe to Popup List of Values Template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39039608169827999)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_text=>'Unable to subscribe to region template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39042106007846299)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_text=>'Unable to subscribe to report template. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39046408478875371)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_text=>'Unable to subscribe to security scheme. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39047032373882304)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_text=>'Unable to subscribe to shortcut. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(690814909430253199)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_text=>'Unable to subscribe to theme options. %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106879422749544543)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_text=>'Error during execution of wwv_flow_copy_page: %0 >> %1'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(102730807506595849)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_text=>'Error during execution of wwv_flow_copy_page_item: %0 >> %1'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41475209223643748)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_text=>'Unable to find %0 (%1) to copy'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(159711803637919839)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_text=>'a shortcut with the name %0 already exists'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(102757726862648685)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_text=>'Unable to find shortcut (%0) to copy.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104296800926294126)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_text=>'Error in create application (create report templates): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104301726384339352)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_text=>'Error in create application (compute tab targets): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106302714393395579)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_text=>'Error in create application (copy authentication schemes): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106301915301386404)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_text=>'Error in create application (copy authorization schemes): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104310329164415821)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_text=>'Error in create application (copy button templates): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104304806691362045)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_text=>'Error in create application (copy field template): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104307302021398542)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_text=>'Error in create application (copy list templates): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104313414104449288)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_text=>'Error in create application (copy List of Values): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104308222106404354)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_text=>'Error in create application (copy breadcrumb templates): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104313027825443863)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_text=>'Error in create application (copy NavBar): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104304117296355577)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_text=>'Error in create application (copy page template): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104306812625392071)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_text=>'Error in create application (copy region templates): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104305707168371624)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_text=>'Error in create application (copy report templates): %0 '
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104313801422455099)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_text=>'Error in create application (copy security scheme): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104295411876287788)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_text=>'Error in create application (create field template): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104298917118317743)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_text=>'Error in create application (create list templates): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104299324737319899)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_text=>'Error in create application (create breadcrumb templates): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104291115639260550)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_text=>'Error in create application (create page): %0 '
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104302811970344626)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_text=>'Error in create application (create parent tabs): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104294418325280192)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_text=>'Error in create application (create page template): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104300213093325987)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_text=>'Error in create application (create Popup List of Values Template): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104298415948307867)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_text=>'Error in create application (create region templates): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104300604567333006)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_text=>'Error in create application (create standard tabs): %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104289218840242539)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_text=>'Verify %0 error: %1'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(347018527428940737)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_text=>'Navigation Menu'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(199568821259309738)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_text=>'Running Script:%0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2921177585296237)
,p_name=>'WWV_FLOW_CREDENTIAL.INSTANCE_DBMS_CREDENTIAL_NOT_ENABLED'
,p_message_text=>'Database Credentials on the Instance Level are not enabled.'
,p_version_scn=>2075466
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(155053083875977604)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_text=>'This procedure must be invoked from within an application session.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1773384009304644)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_KEY_PAIR_CREDENTIALS'
,p_message_text=>'Key pair credentials could not be regenerated.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600422000429486)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_text=>'Credential is not allowed to be used for this URL endpoint.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2200950816700636)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP_OR_LDAP'
,p_message_text=>'URLs in the list must start with http://, https://, ldap:// or ldaps://'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(225728247811712452)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_text=>'Credentials for %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104331413074524751)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_text=>'Unable to remove css: %0'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242592312299469924)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_text=>'Drag and drop is not supported for REST Data Sources.'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91418513349724661)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_text=>'Apply Changes'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41396607553373305)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_text=>'The page sentry function will return the boolean result of the built-in session verification check to the engine. If the result is true, the engine will continue to show or accept the page. If the result is false, the engine will redirect to the inva'
||'lid session page or URL specified in this authentication scheme (see below).'
,p_version_scn=>37165770887606
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41399211630373837)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_text=>'If the page sentry function returns TRUE, page rendering or processing continues. If the result is FALSE, the engine must quit because no invalid session target is specified in the authentication scheme. In this case, the user-provided page sentry fu'
||'nction is presumed to have redirected to a login page outside the %0 environment, possibly to an external authentication portal. The function should also have set the global variable g_unrecoverable_error := true to instruct the engine to quit withou'
||'t showing an error page.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41399432053373869)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_text=>'The engine will execute the following code that is specified as the pre-authentication process of this authentication scheme:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41399630371373901)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_text=>'This is executed as an anonymous block that returns no value.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41399812564373935)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_text=>'No custom pre-authentication code is specified in this scheme.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41400212863374000)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_text=>'Any username/password combination entered into the login form will be considered valid. The username entered will be used as the name of the logged-in user for the life of the session. This technique can be useful while you are developing your applic'
||'ation but before any actual user accounts are established.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41400432750374036)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_text=>'Check the username and password entered into the login form against the App Builder (cookie user) accounts. These are the same accounts used in your workspace to log into %0. This technique can be useful when the users of your application are develop'
||'ers who have %0 accounts in the same database and workspace.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20150808646887943)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_text=>'Check the username and password entered into the login form against Oracle database accounts. This technique is convenient when the users of your application have accounts in the database.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41400624357374068)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_text=>'Check the username and password entered into the login form using the LDAP directory specified in this authentication scheme.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41400812027374099)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_text=>'The LDAP parameters are set to:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41402222278374321)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_text=>'Execute the following custom code to verify credentials:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41402612307374385)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_text=>'Check the built-in sessions table for the session used by the built-in login page. If the session exists and is not owned by another user, mark it as now owned by the authenticated user (using the username from the login form).'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41396803767373391)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_text=>'The page sentry function will return the boolean result of the built-in session verification check ANDed with the result of the user-provided session verification check to the engine. If the result is true, the engine will continue to show or accept '
||'the page. If the result is false, the engine will redirect to the invalid session target specified in this authentication scheme (see below).'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41402811649374417)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_text=>'Set the cookie named %0 to a value that locates the row in the internal sessions table.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41403202921374481)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_text=>'Determine the URL to redirect to next. If a "deep link" was recorded in the session state by the rendering engine, use that as the URL to go to. Otherwise go the URL specified as the home link attribute of the application.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41403605577374545)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_text=>'After credentials verification, the engine will execute the following code that is specified as the post-authentication process of this authentication scheme:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41403805668374578)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_text=>'This is executed as an anonymous block that returns no value.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41404014932374609)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_text=>'No custom post-authentication code is specified in this scheme.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41404218818374641)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_text=>'Redirect to the URL determined above. This marks the end of login processing using the built-in login page and the APIs that it calls.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41397013838373478)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_text=>'Use custom logic to perform page sentry tasks. For each page request, the engine will execute the following code:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41397206771373510)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_text=>'The boolean result of the above block will be returned to the engine. If the result is true, the engine will continue to show or accept the page. If the result is false, the engine will redirect to the invalid session target specified in this authent'
||'ication scheme (see below).'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41397407375373543)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_text=>'The built-in method for session verification is available to the %0 developer using the API call:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41397630513373578)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_text=>'This boolean function result can be combined with other checks in the user-provided page sentry function specified in an authentication scheme. If this API is called, it will check the cookie named %0'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41397800456373610)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_text=>'If the cookie exists and its decoded value locates a row in the internal sessions table, then the session is considered valid and a TRUE value is returned to the page sentry function that called it.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41398205449373675)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_text=>'If the page sentry function returns TRUE, page rendering or processing continues. If the result is FALSE, the engine will show page %0, which is considered to be this application''s login page based on its designation in this authentication scheme as '
||'the invalid session page.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41399028933373802)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_text=>'The page sentry function returns a boolean result to the engine. If the result is TRUE, page rendering or processing continues. If the result is FALSE, the engine will redirect to %0.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41404428348374675)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_text=>'A typical approach is for the page to contain a login form to capture the user''s credentials. Then the page''s after-submit processes would call an authentication module to verify the credentials. After authentication, the page would perform any sessi'
||'on registration and cookie setting tasks. Finally it would redirect to the start page of the application.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41404624149374709)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_text=>'The %0 API: wwv_flow_custom_auth_std can be called by such after-submit processes to perform any of these steps just described. There are two entry points available:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41404827020374742)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_text=>'Call the login procedure to have the engine perform all of the steps for you. The engine will use the built-in sessions table and perform session registration and cookie setting for you. Any custom code you provide in this authentication scheme will '
||'be run at the pre-authentication, authentication, or post-authentication points.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41405026585374778)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_text=>'Call the post_login procedure if you are performing authentication yourself but you would like %0 to handle all post-authentication chores for you. With these two entry points you can use any of the built-in login processing steps in combination with'
||' your own login page and any processes that run on it. Remember, if you use the built-in post-authentication processing, you can take advantage of built-in page sentry and session verification processing as well.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41398420318373707)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_text=>'the built-in login page'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41405208647374810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_text=>'External Login Processing'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41407430774375234)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_text=>'The login URL %0 does not appear to specify an %1 application page as the invalid session target. Additionally, there are no login processing values in the authentication scheme. This page is responsible for performing the following steps:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41407619026375267)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_text=>'Please note that unless the services invoked at this URL use the %0 wwv_custom_auth_std API to assist with session registration tasks, your application will not be able to use built-in page sentry or session verification processing. You will have to '
||'do this work by whatever means you devise on your own.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41408407183375394)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_text=>'The login URL %0 does not appear to specify an %1 application page as the invalid session target. This page is responsible for performing the following steps:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41408604564375426)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_text=>'The values set for login processing in the authentication scheme are shown below:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41408805285375459)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_text=>'The login page specified in this scheme is page [%0] in this application. This page is responsible for performing the following steps:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41409023567375491)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_text=>'However, there are no login processing values in the authentication scheme.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41409231736375531)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Because this page is the designated login page for the application, it is not possible to perform certain actions on the page when the page is first shown, because user authentication has not yet occurred. Also, certain session state and session iden'
||'tification variables are not available to page computations or processes as they would be on ordinary pages that are processed after authentication. For these reasons, the specification of a login page by page number in an authentication scheme is on'
||'ly suitable for pages that have very little or no functionality other than login form processing. If you would prefer to have your login page be more active, please use the login URL designation in the authentication scheme wizard or edit page. So lo'
||'ng as you remember to set the public page attribute to ''Yes - This page is public'' using the page attributes form in the Builder the log',
'in page can use the full range of %0 features in addition to serving as the login page in your application.'))
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41405431005374845)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_text=>'This authentication scheme specifies neither a login page or a URL to be used for the invalid session target. This implies that the page sentry function handles this case. Perhaps it redirects to a single-signon portal or some other login server. Add'
||'itionally, there are no login processing values in the authentication scheme. If this is not what you intended, please edit this authentication scheme and provide an invalid session page or URL, then examine this chart view again.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41405621034374879)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_text=>'This authentication scheme specifies neither a login page or a URL to be used for the invalid session target. This implies that the page sentry function handles this case. Perhaps it redirects to a single-signon portal or some other login server. How'
||'ever, there are values set for login processing in the authentication scheme, as shown below:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41405817398374910)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_text=>'The login URL:%0 appears to specify an %1 application page as the invalid session target. However, there are no login processing values in the authentication scheme. This page is responsible for performing the following steps:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41406230828374980)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_text=>'In order for the %0 engine to be able to show or accept the login page in your application, you must select the page attribute ''Yes - This page is public'' on the Page Attributes page of the App Builder. If you do not do this, the engine will attempt '
||'to execute the page sentry function before showing the page. If you have not yet logged in, a redirect to the same URL will be attempted. This will cause a most unsatisfying loop. If you code your own page sentry function, you may need to recognize w'
||'hen the current page is this login page and handle it differently from other pages. If you can identify it by page number, fine. A more generic technique is to use the boolean function wwv_flow_custom_auth.current_page_is_public to recognize this pub'
||'lic attribute of the login page or any other page in your application.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41406411682375060)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_text=>'The login URL %0 appears to specify an %1 application page as the invalid session target. This page is responsible for performing the following steps:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41406632730375093)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_text=>'The values set for login processing in the authentication scheme are shown below:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41406821282375137)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_text=>'The Oracle Application Server Single Sign-On Server will redirect back to this application after user authentication. The entry point is the wwv_flow_custom_auth_sso.process_success procedure in the %0 schema. %0 is registered as an Oracle Applicatio'
||'n Server Single Sign-On partner application and can manage all interfaces to the login server for you. If, however, you would prefer to register your own application in your own schema, you can. You can write your own page sentry or simply create an '
||'authentication scheme based on the Portal-SSO scheme (my application as partner app) from the authentication scheme gallery. The resulting scheme will call the built-in SSO page sentry wwv_flow_custom_auth_std.portal_sso_sentry_v1. This function requ'
||'ires that the current authentication scheme knows the name of your partner application, as registered with Oracle Application Server Single Sign-On. The create authentication scheme wizard asks you for the partner application name, or it can be added'
||' or changed by editing the scheme after it is created. The name must be entered exactly as registered, observing case. You will also need to write your own URLC receiver procedure and call the wwv_flow_custom_auth_sso.process_success API from it, pas'
||'sing in the name of your application as you registered it with Oracle Application Server Single Sign-On. This will perform session registration with %0 after authentication. If you write your own page sentry, the wwv_flow_custom_auth_sso.portal_sso_r'
||'edirect API may be called by the page sentry to perform the redirect to the login server when it determines that authentication is required. You must pass in the registered name of your partner application to this procedure. Please consult the %0 doc'
||'umentation and the %1 documentation for details.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41408027049375330)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_text=>'Post-authentication processing'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41407829529375299)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_text=>'Pre-authentication processing'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41396000224373209)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_text=>'Using built-in logic, check the cookie named [%0]. If the cookie exists and its decoded value locates a row in the internal sessions table, then consider the session valid.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41396429487373272)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_text=>'Compute Return Value'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41400028685373967)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_text=>'Credentials Verification (Authentication)'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41403410071374513)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_text=>'Custom Post-Authentication Processing'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40692100766892713)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_text=>'Illegal entry point arg to wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.  '
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40691319545892639)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_text=>'Null p_session_id argument to wwv_flow_custom_auth_std.login--p_flow_page:%0'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40690702718892586)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_text=>'Unable to run authentication credential check function.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41398013612373642)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_text=>'Invalid Session Target'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41401430584374193)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_text=>'LDAP Search Base:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41401604336374226)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_text=>'The following block is used to call a function before the call to DBMS_LDAP.SIMPLE_BIND_S. The username captured in the login form is passed to the function, which returns a value that is used to replace %LDAP_USER% in the LDAP Search Base (see above'
||').'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41401820735374257)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_text=>'This code block must have this signature:'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41402031493374289)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_text=>'This feature allows you to transform the username entered in the login form into whatever format matches your LDAP directory entry.'
,p_version_scn=>37165770887607
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41401022116374131)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_text=>'LDAP Host:'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41401200512374162)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_text=>'LDAP Port:'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41394431501372942)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_text=>'This application (%0) uses page %1 as a login page.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41394630427372975)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_text=>'Whenever page %0 is requested, no further authentication checks are performed and the page is shown or accepted. This allows the login page to be shown before authentication has occurred.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41394203574372867)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_text=>'Login Page Handling'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41395412237373110)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_text=>'Page Sentry Function'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41395608791373143)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_text=>'Use built-in logic to perform page sentry tasks. For each page request, the page sentry function performs session verification and computes a return value.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41402400687374352)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_text=>'Post-Authentication Processing'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41396210343373241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_text=>'Use additional user-provided code to determine if the session if valid. After getting a TRUE result from the built-in session verification check, above, execute the following code and remember its boolean return value:'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41395832463373174)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_text=>'Session Verification Function'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41398601479373738)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_text=>'the Oracle Application Server Single Sign-On server'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41398810762373770)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_text=>'the URL'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106885600202585281)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_text=>'error'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2893776853314830)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_text=>'Data Loading job started.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(74478344834069607)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_text=>'%0 files larger than %1 MB are not supported for data loading.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(242204537510431474)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_text=>'Invalid SQL Expression: %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(33437617911346313)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_text=>'Analyze %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(33742809206665528)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_text=>'View By'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(104335016799544687)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_text=>'Invalid date format.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90983227445178357)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_text=>'Debug:'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91047208426399878)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_text=>'Feature not supported by this version.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88460325355757354)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_text=>'ERR-1101 Unable to process function body returning query.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91050926696424133)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_text=>'Error 4323- Request for help did not provide a numeric page ID to show help for.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88459428556739296)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_text=>'ERR-1025 Error processing PLSQL expression.  %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88459922800747137)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_text=>'Application=%0 Page=%1 SQLERRM=%2'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90977127530159463)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_text=>'Unable to print shortcut: %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88461230812777849)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_text=>'ERR-1108 Unable to process item current condition.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90980824890168114)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_text=>'Error in rendering chart: %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(136199432566073078)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_text=>'Unable to render component: %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11238517868816072)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_text=>'Error in rendering Dynamic List region: %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91049328989415357)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_text=>'Error 4322- Request for help did not use proper syntax.  Request was null when expecting a valid page number.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106747002318188466)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_text=>'Unable to bind "%0". Use double quotes for multi byte items or verify length of item is 30 bytes or less. Use v() syntax to reference items longer than 30 bytes.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478442307050468307)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_text=>'Expecting BLOB column name in report column format mask DOWNLOAD:TABLE_NAME:BLOB_COLUMN...'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(634992415650460607)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_text=>'Column %0 not found in table %1'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106485219804405213)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_text=>'Error in DML: p_rowid=%0, p_alt_rowid=%1, p_rowid2=%2, p_alt_rowid2=%3. %4'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(31187225836283229)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_text=>'Unable to perform insert operation.  %0  %1'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(146169004984043730)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_text=>'Invalid numeric value %0 for column %1'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38383000423297849)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_text=>'Invalid action %0 on this object. (%1)'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478438528512398829)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_text=>'Invalid table owner'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478438923795406936)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_text=>'Invalid URL'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478437927642360737)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_text=>'Last updated data column "%0" data type "%1" used to track updates to "%2" must be a date or timestamp data type.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478439206741420865)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_text=>'Error: Must call from form page that contains the item name of type FILE'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478440220163443734)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_text=>'No Format Mask Found'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478442625404473554)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_text=>'Expecting primary key 1 column name in report column format mask DOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME...'
,p_version_scn=>37166027486284
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(635025227771464120)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_text=>'Table or view %0 not found'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478441520771462775)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_text=>'Expecting table name in report column format mask DOWNLOAD:TABLE_NAME...'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478441122718453880)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_text=>'Format mask must include at least 4 arguments separated by colons'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478440804364448612)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_text=>'Format mask must begin with DOWNLOAD or IMAGE'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1480014685953528)
,p_name=>'WWV_FLOW_EXEC.ARRAY_ROW_DOES_NOT_EXIST_IN_COLUMN'
,p_message_text=>'Array Column %0 does not contain child row %1.'
,p_version_scn=>23676562
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1481142959116128)
,p_name=>'WWV_FLOW_EXEC.ARRAY_ROW_DOES_NOT_EXIST_IN_CURRENT_COLUMN'
,p_message_text=>'Current Array Column does not contain child row %0.'
,p_version_scn=>23676674
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1479711333930788)
,p_name=>'WWV_FLOW_EXEC.DATATYPE_NOT_SUPPORTED_IN_NESTED_COLUMNS'
,p_message_text=>'%0 data type is not supported within an array column'
,p_version_scn=>23620304
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2948748962668377)
,p_name=>'WWV_FLOW_EXEC.DERIVED_OR_TRANSFORMATED_COLUMNS_NOT_SUPPORTED_IN_ARRAY'
,p_message_text=>'Getting a derived or transformed value for column %0 is not supported.'
,p_version_scn=>29826544
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1944284758909413)
,p_name=>'WWV_FLOW_EXEC.DML_ON_GRAPH_NOT_SUPPORTED'
,p_message_text=>'DML is not supported on Property Graphs.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3211859190670248)
,p_name=>'WWV_FLOW_EXEC.FEATURE_NOT_AVAILABLE_ON_MYSQL'
,p_message_text=>'Feature not available on MySQL databases: %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153560761206509972)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_text=>'Column name "%0" is invalid for the SQL query. Make sure that you use unique alias names for your columns.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1480272713967858)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_REFERENCE'
,p_message_text=>'Invalid column reference used.'
,p_version_scn=>23638355
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29980542594453921)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_text=>'This operation is not allowed for REST Data Source.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1480528418000261)
,p_name=>'WWV_FLOW_EXEC.NOT_AN_ARRAY_COLUMN_IN_CURRENT_ROW'
,p_message_text=>'%0 is not an array column within the current row or child row.'
,p_version_scn=>23658451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1479505495925709)
,p_name=>'WWV_FLOW_EXEC.NOT_WITHIN_ARRAY_COLUMN'
,p_message_text=>'An Array Column must be selected within current DML context.'
,p_version_scn=>23658258
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2258070055651884)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_POSSIBLE_IN_PARENT'
,p_message_text=>'DML Operation "%0" is not possible for a child row, as the parent row''s DML operation is "%1".'
,p_version_scn=>27115104
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153560407631496862)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_text=>'Wrong number of columns selected in the SQL query. See Help of attribute for details.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2036445306628250)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_text=>'%0 has a wrong data type in SQL statement. Column# %1 is %2 but %3 expected.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224963057131303206)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_text=>'Column name "%0" is already used in the SQL query. Make sure that you use unique alias names for your columns.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224962847643300805)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_text=>'Column name "%0" is invalid for the LOV SQL query. Make sure that you use valid alias names for your columns.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224962443500294559)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_text=>'Parsing returned query results in "%0".'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224962648513298005)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_text=>'Wrong number of columns selected in the SQL query. See Help of attribute for details.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600887633608795)
,p_name=>'WWV_FLOW_EXEC_REMOTE.SERVER_IS_UNUSABLE'
,p_message_text=>'REST Enabled SQL Server cannot be used.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600651158607070)
,p_name=>'WWV_FLOW_EXEC_REMOTE.SERVER_IS_USABLE'
,p_message_text=>'REST Enabled SQL Server can be used.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1516161659211283)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.AT_LEAST_ONE_OPERATION_REQUIRED'
,p_message_text=>'Cannot delete the last operation of a REST Data Source.'
,p_version_scn=>14230676
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1516548680198658)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.DB_OPERATION_ARRAY_COL_MUST_BE_UNIQUE'
,p_message_text=>'The combination of <strong>Database Operation</strong> and <strong>Data Profile Array Column</strong> must be unique in a REST Data Source.'
,p_version_scn=>14231261
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2167453504063476)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.DML_NOT_SUPPORTED_FOR_RESTSQL'
,p_message_text=>'DML is not supported for REST Sources of the "REST Enabled SQL" Type.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1516723111187083)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.EACH_DB_OPERATION_MUST_EXIST_ONCE_WITHOUT_ARRAY_COL'
,p_message_text=>'For Operations mapped to a <strong>Database Operation</strong>, <strong>Data Profile Array Column</strong>=<strong>All</strong> must be used at least once for each Database Operation type.'
,p_version_scn=>14231519
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1516336054207755)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.HTTP_OPERATION_URL_PATTERN_MUST_BE_UNIQUE'
,p_message_text=>'The combination of <strong>HTTP Method</strong> and <strong>URL Pattern</strong> must be unique within a REST Data Source.'
,p_version_scn=>14230775
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2033306469566214)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_text=>'REST Data Source Type %0 is not supported.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1516994173182081)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.STATID_ID_MUST_BE_UNIQUE'
,p_message_text=>'The <strong>Static ID</strong> value must be unique within the REST Data Source.'
,p_version_scn=>14231790
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2300402783447448)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_text=>'Duplicate filename: %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808629171977772489)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_text=>'Application Item'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808628742080767973)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_text=>'Constant'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808628024257760819)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_text=>'Function'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808631075144796203)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_text=>'Keyword'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808630390855783743)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_text=>'Materialized View'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808629406935774595)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_text=>'Package'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808628958679770533)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_text=>'Page Item'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808627722104758705)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_text=>'Procedure'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808629604435776621)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_text=>'Sequence'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808629874766778198)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_text=>'Table'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808631325436797726)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_text=>'Template'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808628384963763135)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_text=>'Type'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808628519088765802)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_text=>'Variable'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808630096633779708)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_text=>'View'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4212529195223952)
,p_name=>'WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'
,p_message_text=>'Needs refresh'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4200811299520962)
,p_name=>'WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_STATUS'
,p_message_text=>'Status'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4212703097225143)
,p_name=>'WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'
,p_message_text=>'Could not determine, needs refresh'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4212385135222437)
,p_name=>'WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'
,p_message_text=>'Up to date'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(441433307801280987)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_text=>'Failed to parse LOV SQL query! %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(193502783958597052)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_text=>'Invalid query filter submitted.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(442303002150531453)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_text=>'Column name "%0" is already used in the LOV SQL query. Make sure that you use unique alias names for your columns.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(442302606521523279)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_text=>'Column name "%0" is invalid for the LOV SQL query. Make sure that you use valid alias names for your columns.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(441433022907275842)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_text=>'Wrong number of columns selected in the LOV SQL query. See examples for valid statements.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38259319386972127)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_text=>'The server encountered an error attempting to remove file "%0"'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38260911552979291)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_text=>'Unable to remove file %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38258504925949023)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_text=>'There was an error writing to the physical file directory "%0". (%1: %2)'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89517924321495634)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_text=>'Exceeded the maximum limit in size for non-internal workspace files.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38258925011954796)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_text=>'There is no file to write for id %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89517730359492815)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_text=>'Exceeded the maximum limit in size for all workspace files.'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106888230377622376)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_text=>'Error in delete developer role. %0'
,p_version_scn=>37165770887608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48284319631404256)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_text=>'User was not created for the following reason: %0'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(486440805698663943)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_text=>'%0 is an invalid email address'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106669701644639561)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_text=>'Item %0 of type select list w/js redirect has no query.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106669229087628549)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_text=>'Item %0 of type select list has no query.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106670508009650783)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_text=>'Item %0 of type select list w/URL redirect has no query.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106671132250657812)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_text=>'Item %0 of type select list w/URL redirect to page has no query.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90739820670286891)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_text=>'Edit item %0 - %1 , Sequence: %2'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88457831149702261)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_text=>'ERR-1904 Unable to compute item default: type = Function Body computation_type= %0.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88457323053690425)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_text=>'ERR-1020 Error in PLSQL item processing (function).'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88458832319712030)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_text=>'Spell Check'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(90713017806229268)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_text=>'Unable to cast value "%0" to date format mask %1.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2031458189488409)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_text=>'Items of the BLOB data type are not supported for REST Enabled SQL or REST Data Source.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2031935276516017)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_text=>'Cannot fetch meta data for region ID %s.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(176994660758191685)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_text=>'Form DML or Initialization process does not have a form region assigned.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180338459150127781)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_text=>'Migrate Legacy Form page to Form Region error: table referenced in DML process cannot be described.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(87505263796408129)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_text=>'No checksum found for lost update detection. Can only perform UPDATE or DELETE for existing rows.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(462212951924415591)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_text=>'Cannot execute form DML on a REST Source with Synchronization enabled.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2030627596361243)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_text=>'No Primary Key item has been defined for form region %0.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2031729795497400)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_text=>'Item %0 has wrong data type.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(67198011524964908)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_text=>'There is domain index in selected %0.  Generate DDL cannot generate DDL for domain index.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46196218202976259)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_text=>'No %0 found to generate DDL.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39372909393692461)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_text=>'Save_ddl error %0'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39368118481676070)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_text=>'Error parsing the DDL script. %0'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106677607896792738)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_text=>'Error, package name: %0 is invalid or already taken.'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(43940668607324336)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PKS_MISSING_MSG'
,p_message_text=>'Can not create PL/SQL package %0 because the following tables have no primary key constraint defined:'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92146217193778974)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_text=>'-- table API for application %0, generated %1'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92123205569586465)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Create PL/SQL package %0 with the following procedures:',
''))
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92138516323740943)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_text=>'use to insert data into %0, primary key needs to be supplied'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92141801694755656)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_text=>'use to update data in %0 identified by primary key(s)'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92142517624760255)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_text=>'use to delete data from %0 based on primary key(s)'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92144004941766063)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_text=>'use to retrieve data from %0 based on primary key(s)'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92136327311687332)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92131513281645443)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_text=>'Download Body'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92131116267636769)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_text=>'Download Specification'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92129513234617015)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_text=>'Hide Body'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92126928209602449)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_text=>'Hide Specification'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113662912982925859)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_text=>'-- package body'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113663632028931333)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_text=>'-- package specification'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92128519683609451)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_text=>'Show Body'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92126207085596347)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_text=>'Show Specification'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92133721162666613)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_text=>'Subprogram'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113626308041817301)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_text=>'-- create procedure for table "%0"'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113660927002892044)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_text=>'-- delete procedure for table "%0"'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113661500945903479)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_text=>'-- get procedure for table "%0"'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113662122547919180)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_text=>'-- build MD5 function for table "%0"'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113658810118868288)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_text=>'-- update procedure for table "%0"'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106696921767948087)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_text=>'error'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472777626278906718)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_text=>'Source Identifier of the workspace has to be defined!'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472777903207909525)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_text=>'Deployment system has to be specified!'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47015210259369950)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Component <strong>%0</strong> cannot be rendered in <strong>Column %1</strong> as another component already exists within this column.</p>',
'<p>Setting the Column to <strong>Automatic</strong> will typically fix this issue.</p>'))
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1569635187265482799)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_text=>'<p>Label of Page Item <strong>%0</strong> cannot be rendered as the label column span grid setting for this page item is invalid. It is set to be displayed with a <strong>Label Column Span of %1</strong>. This is not supported as the page item itself'
||' only has <strong>%2 Column(s)</strong> available.</p>'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47014821378325796)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Component <strong>%0</strong> cannot be rendered as the grid settings for this component are invalid. It is set to be displayed at <strong>Column %1</strong> with a <span>Column Span of %2</span>. This is not supported as the grid on this page onl'
||'y supports up to <strong>%3 Columns</strong>.</p>',
'<p>Setting the Column and Column Span to <strong>Automatic</strong> for all components will typically fix this issue.</p>'))
,p_version_scn=>14513371
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47015014929333408)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Component <strong>%0</strong> cannot be rendered as the grid settings for this component are invalid. It is set to be displayed at <strong>Column %1</strong> with a <strong>Column Span of %2</strong>. This is not supported as the grid on this page'
||' only supports <strong>%3 Columns</strong>.</p>',
'<p>Setting the Column and Column Span to <strong>Automatic</strong> for all components will typically fix this issue.</p>'))
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8549824552841148)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_text=>'2 Day DBA'
,p_version_scn=>37165770887609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8549314856838395)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_text=>'2 Day + Developer''s Guide'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1035310352563992)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_text=>'Application Administration Guide'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1035530784569884)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_text=>'API Reference'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244221730226716666)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_text=>'Contents'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(236972607548434619)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_text=>'About: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244222703345718305)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_text=>'Find'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8548528577832833)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_text=>'App Builder User''s Guide'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359855529042871460)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_text=>'initial index creation may take several seconds'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1035715331574927)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_text=>'Application Migration Guide'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244193201258642062)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_text=>'Documentation mapping file not found: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(244236429711754396)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_text=>'Score'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1035913038583745)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_text=>'SQL Workshop and Utilities Guide'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107323210450921064)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_text=>'Create normalize error: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(154898006946285628)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_text=>'You do not have access to the schema that you are importing.  Import failed.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107322625556915884)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_text=>'remove_table_hint was called without a p_table_id, a table must be provided.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(74251312155282122)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_text=>'Encountered second create_company call during workspace install.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46970011824107886)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_text=>'GET_BLOCK Error. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46969221735101308)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_text=>'GET_STMT error. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46971307106116025)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_text=>'Unable to find the file. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2800663771466319)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_text=>'Zip archive not valid, no installation manifest file found.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47875313297451598)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_text=>'You do not have privileges on the %0 schema.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(46967317318081153)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Execution  of the statement was unsuccessful. %0',
'<pre>%1</pre>'))
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(78523615428273587)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_text=>'API call to remove_page procedure detected within large block in export file.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152883709291063192)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_text=>'No label exists for this item.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20942861630810737)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_text=>'There is a problem with your environment because the Oracle APEX files are not up-to-date! The files for version #LOADED_VERSION# have been loaded, but %0 is expected. Please verify that you have copied the images directory to your application server'
||' as instructed in the Installation Guide.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20942182934783658)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_text=>'There is a problem with your environment because the Oracle APEX files have not been loaded. Please verify that you have copied the images directory to your application server as instructed in the Installation Guide. In addition, please verify that y'
||'our image prefix path is correct. Your current path is %0 (it should contain both starting and ending forward slashes, such as the default /i/). Use the SQL script reset_image_prefix.sql if you need to change it.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106662023752541784)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_text=>'Unauthorized attempt to run job %0 by schema: %1 in application: %2'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107333513454063842)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_text=>'Unable to create collection: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107326116384951156)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_text=>'error'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107330909813024913)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_text=>'Find data type error: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107333105920042757)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_text=>'Get data type error: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107332006828033556)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_text=>'Get max col length error1: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165394309130429106)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_text=>'Unable to insert a row with more than 32KB data.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107358010141223704)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_text=>'User %0 has no privileges on the %1 schema.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7400740207222956)
,p_name=>'WWV_FLOW_LOV.INVALID_SEARCH_OPERATOR'
,p_message_text=>'Search Operators "ends with" and "like" are not supported for legacy LOVs.'
,p_version_scn=>37165772372518
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106714026456063029)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_text=>'Unable to update page branching condition type. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106712800483055560)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_text=>'Unable to update page button condition type. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106711220307042281)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_text=>'Unable to update Application computation type. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106710628141035073)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_text=>'Unable to update Application process when condition type. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106725327542091699)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_text=>'Error during updating misspelled words. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106710220522032908)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_text=>'Unable to update NavBar display condition type. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106716319661070525)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_text=>'Unable to update page computation type. %0'
,p_version_scn=>37165770887599
);
end;
/
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106722602954084627)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_text=>'Unable to update page process type. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106711914204049966)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_text=>'Unable to update page sub title type. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106720714944078592)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_text=>'Unable to update page validation type. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(487378716087594335)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_text=>'%0: "Cascading LOV Parent Item(s)" can only be used if "Lazy Loading" is set to Yes.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478439923841435307)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_text=>'Error: At most one DML process may be declared per page'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(478439529251427437)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_text=>'Error: No corresponding DML process found for page %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(480899828763319665)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_text=>'%0 has to have a valid BLOB column as source.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(445494311662918478)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_text=>'A PL/SQL code which emits HTML must be specified for item %0.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2212412901006259)
,p_name=>'WWV_FLOW_NATIVE_ITEM.RESTRICTION_DISPLAY_COLUMN'
,p_message_text=>'%0: You need to specify a display and a return column in your LOV.'
,p_version_scn=>139271321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13200641276014857)
,p_name=>'WWV_FLOW_NATIVE_ITEM.RESTRICTION_FETCH_ON_SEARCH'
,p_message_text=>'%0: "Fetch on Search" can only be used if the provided LOV has no display value configured.'
,p_version_scn=>120103692
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13201895634092454)
,p_name=>'WWV_FLOW_NATIVE_ITEM.RESTRICTION_MANUAL_ENTRIES_ITEM'
,p_message_text=>'%0: "Manual Entries Item" needs to be set if the provided LOV has a display value configured.'
,p_version_scn=>120103907
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107407902428514824)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_text=>'Unable to bulk collect: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107391924928445579)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_text=>'Unable to check whether the code has be parsed or not: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107393206359449691)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_text=>'Unable to run the control file: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107415328232560134)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_text=>'Unable to check control file statistics: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107413624507540116)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_text=>'Unable to delete parsed information: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107413207885535352)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_text=>'Execution of the statement was unsuccessful: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107367429721342899)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_text=>'Unable to find the file. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107377214624423711)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_text=>'Unable to get statement: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91363029745292775)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_text=>'Line length %0 exceeds maximum %1 at line %2'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107412318835529021)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_text=>'Warning: Package Body created with compilation errors.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107396112031460795)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_text=>'Unable to run the code: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107410823206520832)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_text=>'Unable to run the statement: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107378502634429754)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_text=>'Unable to save the parameter to the database: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107368025003350980)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_text=>'Unable to get the block of code: %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107390732416438329)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_text=>'Unable to validate the file "%0". %1'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107416714857565750)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_text=>'Unable to parse the file. %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(339518415675566178)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_text=>'No authentication function has been defined for plug-in %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(339548422602568218)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_text=>'No post logout function has been defined for plug-in %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(339482108057563974)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_text=>'No session sentry function has been defined for plug-in %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893672329311107313)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_text=>'Action'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893521725932087434)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_text=>'Defined by Dynamic Action'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893395729264078916)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_text=>'Redirect to Page in this Application'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893462812426083512)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_text=>'Redirect to URL'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893423303769080979)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_text=>'Submit Page'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893596932643098799)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_text=>'Clear Cache'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(441433723862295066)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_text=>'LOV query is invalid, a display and a return value are needed, the column names need to be different. If your query contains an in-line query, the first FROM clause in the SQL statement must not belong to the in-line query.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(444753323460788986)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_text=>'Failed to parse region source query! %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47978119665021368)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_text=>'Failed to parse SQL query! %0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1289211309685714732)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_text=>'%0'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(441434005292299109)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_text=>'Static LOV is invalid, a display and a return value are needed.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(366522308782464608)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_text=>'Table, View or Synonym does not exist!'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(47477228821574136)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_text=>'- Select -'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(441434917198312088)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_text=>'A list of values (LOV) query or Named list of values must be specified for items with this display as type.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(441434631958306833)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_text=>'Using a named list of values (LOV) is only supported for item types which require at least two LOV columns.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48004703332262618)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_text=>'Value must be an integer.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48004325711259622)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_text=>'Value must be numeric.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893550404939090810)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_text=>'Page'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24267332229011745)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_text=>'Column is of wrong data type. This attribute requires that the column has one of the following data type(s): %0.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20803516045903154)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_text=>'Column does not exist or region source query is invalid.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24269932210210507)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_text=>'wrong data type'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(444748619548655436)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_text=>'A region source must be specified for regions with this region type.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(444748927859657813)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_text=>'Column name "%0" is already used in the region source query. Make sure that you use unique alias names for your columns.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(444749202017659778)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_text=>'Column name "%0" is invalid for the region source query. Make sure that you use unique alias names for your columns.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(444749508597661733)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_text=>'Wrong number of columns selected in the region source query. See examples for valid statements.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893581726063096907)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_text=>'Request'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893565814635093631)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_text=>'Reset pagination for this page'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893622507494100980)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_text=>'Set These Items'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(442303930809558685)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_text=>'Column name "%0" is already used in the SQL query. Make sure that you use unique alias names for your columns.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(442303622844556361)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_text=>'Column name "%0" is invalid for the SQL query. Make sure that you use unique alias names for your columns.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48404910267057258)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_text=>'Wrong number of columns selected in the SQL query. See Help of attribute for details.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(441434322261304008)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_text=>'Static list of values (LOV) are only supported for item types which require at least two LOV columns.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2200999102459702)
,p_name=>'WWV_FLOW_PLUGIN_DEV.TOO_MANY_ATTRIBUTES'
,p_message_text=>'The maximum number of attributes is %0.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893660624463105875)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_text=>'URL Target'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(893645515459103347)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_text=>'With These Values'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106758900286216270)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_text=>'ERR-1711 Cannot convert popup lov id in request.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106761314831220551)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_text=>'ERR-1721 Cannot find item for popup lov id in request.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13540912301658420)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_text=>'The printing engine could not be reached because either the URL specified is incorrect or a proxy URL needs to be specified.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1529265390861841)
,p_name=>'WWV_FLOW_PROCESS_BACKGROUND.CLOB_CONTEXT_VALUE_NOT_SUPPORTED'
,p_message_text=>'The CLOB data type is not supported for the Context Value item.'
,p_version_scn=>37165770887521
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537732093442035634)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_text=>'Above Region'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537732813183046513)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_text=>'Below Region'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537733009967048668)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_text=>'Bottom of Region'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537732216095038052)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_text=>'Left of Title'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537730869008018123)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_text=>'Right of Interactive Report Search Bar'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537732412158039531)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_text=>'Right of Title'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537732679199043709)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_text=>'Region Default'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537731414033030389)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_text=>'Top of Region'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537731608974032713)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_text=>'Top and Bottom of Region'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537734190946079823)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_text=>'After Header'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537734322549081800)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_text=>'Before Footer'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(651359099171540032)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_text=>'Component not found! It might have been deleted by another user. Please reload page.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(651358820186529347)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_text=>'Can not delete because component ''%0'' references this component!'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(651358434842521681)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_text=>'Can not delete because component ''%0'' on page %1 references this component!'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(651359210859547413)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_text=>'Attribute has already been changed by another user! Please reload page.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(651360932308568593)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_text=>'Attribute is not available in this context!'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(651359430261555616)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_text=>'Component has been changed by another user and this attribute no longer exists! Please reload page.'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353446974008993918)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_text=>'Parsing returned query results in "%0".'
,p_version_scn=>37165770887599
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1829545720810857156)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_text=>'Parsing returned query results in "%0". If you believe your query is syntactically correct, check the "Use Generic Column Names" checkbox below to proceed without parsing.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(857657730558585506)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_text=>'Must be unique!'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537734570792086725)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_text=>'No Template'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353440637719968632)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_text=>'No query has been returned by pl/sql block.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1829546007148878250)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_text=>'No query has been returned by pl/sql block. If you believe your code is syntactically correct, check the "Use Generic Column Names" checkbox below to proceed without parsing.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2777279193186292)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_IS_LOCKED_CANNOT_UNSUBSCRIBE'
,p_message_text=>'You cannot unsubscribe the page as it is locked by another user.'
,p_version_scn=>159469674
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2777020723192894)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_IS_PART_OF_SUBSCRIBED_COMP_GROUP'
,p_message_text=>'You cannot unsubscribe the page as it is part of a component group that is subscribed.'
,p_version_scn=>159470005
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537737220812110292)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_text=>'Page locked by another user!'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537736144664095556)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_text=>'Page is currently locked by %0! Unable to save any changes.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(227908921330764599)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_text=>'Could not extend tablespace because schemas no longer exist for this %0.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106766112669238825)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_text=>'Error in drop_tablespace p_name is null.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106768713624258040)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_text=>'Error in drop_user no l_username.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1944158721520237334)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_text=>'The encryption wallet is not open.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112498496434009213)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_text=>'Illegal password string passed to wwv_flow_provision.create_user.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106782313240305247)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_text=>'Error in remove_provisioned_company.  Workspace is null.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106778802374292650)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_text=>'Unable to create tablespace. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106776809515285171)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_text=>'Unable to create user. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106767414185248762)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_text=>'Unable to drop tablespace. Error: %0 \nsql:\n %1'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106770608907266105)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_text=>'Unable to drop user. Error: %0 \nsql:\n %1'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106780225230299229)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_text=>'Unable to grant initial privileges. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10629322413967513)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_text=>'Unable to create the tablespace at this time.  Please try again later.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106773204189274258)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_text=>'Error with: %0 %1'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39151626027372532)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_text=>'Automatic provisioning failed during the "MAKE_REQUEST" phase'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41503207935130163)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to determine security group ID for specified workspace ID = "%0"',
''))
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39164828975411219)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_text=>'Workspace %0 is a reserved name, request is denied'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39154627674391948)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_text=>'An error occurred adding user to workspace %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106793629086328694)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_text=>'error'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100126817077439459)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_text=>'Not implemented.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39145605810357255)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_text=>'No workspace found with workspace ID: %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39146215853360122)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_text=>'No schema assigned for workspace ID: %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41504003134157160)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_text=>'You cannot use this facility to remove the last schema of a workspace'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39189626429476681)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_text=>'Request %0 not found'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39176518632436651)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_text=>'Request %0 could not be processed.  %1'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39155504733404174)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_text=>'This request has been processed or is being processed.  Status must equal "%0"'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41507806082195833)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_text=>'User name %0 does not exist in workspace %1'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41506412184188135)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_text=>'Not permitted to reset password for a schema that is not associated with your workspace.  %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41505504088176339)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_text=>'Unable to reset password for schema %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39187527683467658)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_text=>'Request %0 could not be processed as the schema %1 exists in the %2 table.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39165418024417535)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_text=>'Schema name %0 is a reserved schema and cannot be provisioned.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39142227964287942)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'User %0 does not have privilege on the %1 schema.',
''))
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24117630971511091)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_text=>'%0 Analysis'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24371807833034300)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_text=>'Analyze'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19341201520634212)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_text=>'Use database account credentials.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25806518942300171)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_text=>'Use internal %0 account credentials and login page in this application.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(447122131817524125)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_text=>'Use Oracle Application Server Single Sign-On.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24122707469532693)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_text=>'%0 Chart'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24032206027428180)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_text=>'Choose a Column'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24255325130887840)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_text=>'Unable to clear cache.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626408319756988304)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_text=>'#COLUMN_HEADER# must have a value.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(33747832109700462)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_text=>'Unable to create analyze page. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40685116090846807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_text=>'Unable to create button template. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40689006010891205)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_text=>'Unable to create chart page.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40680122792782550)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_text=>'Unable to create application.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40694425056896765)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_text=>'Unable to create home page. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40687905879881714)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_text=>'Unable to create insert form. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40681013703798862)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_text=>'Unable to create label template. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40694912720902614)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_text=>'Unable to create list. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40695430728907851)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_text=>'Unable to create list item. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40679203960767649)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_text=>'Unable to create list template. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40687132628870546)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_text=>'Unable to create breadcrumb . %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40684629465841175)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_text=>'Unable to create breadcrumb template. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40697225234934631)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_text=>'Unable to create modules.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40686511157864334)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_text=>'Unable to create navbar. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24207031804596451)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_text=>'Create New %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24373206579043384)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_text=>'Create New'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40680618767790771)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_text=>'Unable to create page template. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40681825609811672)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_text=>'Unable to create region template. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40687520985876566)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_text=>'Unable to create report page. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40681403791805417)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_text=>'Unable to create report template. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40695815622912869)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_text=>'Unable to create success page. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40686122108857990)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_text=>'Unable to create standard tabs. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40688422501886474)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_text=>'Unable to create update form. %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24253920151876948)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_text=>'Spread Sheet'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626470811425534666)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_text=>'#COLUMN_HEADER# must be a valid date.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40696315753922395)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_text=>'Please define default templates to create the application.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25197630886947900)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_text=>'Unable to display page region.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24242505727806565)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_text=>'This page displays help for a page.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24246403350834252)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_text=>'Insert %0'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24204805138588835)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_text=>'Insert Form'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24218426618670698)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_text=>'Insert Another'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24258011324912269)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_text=>'Unable to insert a row to %0.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24216309649665793)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_text=>'The data has been inserted successfully.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(200155517918411593)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_text=>'#LABEL# must be a valid date.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24211700252634648)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_text=>'#LABEL# must be number.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(168185721999550914)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_text=>'#LABEL# must be a valid timestamp.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24244320403820324)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_text=>'%0 Breadcrumb'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24211211549628455)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_text=>'%0 must have some value.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626461604752475883)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_text=>'#COLUMN_HEADER# must be numeric.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40685703061852488)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_text=>'Unable to create Popup List of Values Template.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24372423071038731)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_text=>'Report and Edit'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24251816903866620)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_text=>'Unable to show report.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24256512794893740)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_text=>'Unable to reset pagination.'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24222707141683995)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_text=>'Return Home'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24243527545812868)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_text=>'Return to previous page'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24029500571407704)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_text=>'Search Report'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(719933371398781571)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_text=>'Search All Applications'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(718987030752118910)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_text=>'Search Application'
,p_version_scn=>37165770887600
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(716971742627971929)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_text=>'Search Team Development'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(719364989450620373)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_text=>'Search Users'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24031117671422080)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_text=>'Show Chart By'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25100127058795395)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_text=>'Unable to show breadcrumb.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24225028612690214)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_text=>'Success'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24215519561659194)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_text=>'Success Page'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(626471016273536039)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_text=>'#COLUMN_HEADER# must be a valid timestamp value.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24209428256614394)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_text=>'Update %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24207930896605734)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_text=>'Update Form'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40696802724928137)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_text=>'You can only build the application using one level tab.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24219718438677763)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_text=>'View Report'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37378917844686039)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_text=>'About'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(37387408803730748)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_text=>'Branching'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106705105584000209)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_text=>'Error'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(27046113746109641)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_text=>'A nested list only support "Client Side" as search type.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100996707398005871)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_text=>'Unexpected error %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(88464016576820971)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_text=>'Warning: Tree root ID "%0" not found.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153345578698908951)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_text=>'Error in PLSQL code raised during remote SQL processing.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2900716911874966)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_text=>'Unable to create cards page. %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254013818766191262)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_text=>'RESTful access is not enabled for this instance.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(251065532599816655)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_text=>'The region was not found or is not REST enabled.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(251087609761311472)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_text=>'No output method was specified.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2087733266163390)
,p_name=>'WWV_FLOW_SEARCH.DBMS_SEARCH_NOT_AVAILABLE'
,p_message_text=>'Oracle Ubiquitous Database Search is not available in this database.'
,p_version_scn=>32903904
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91161404448786667)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_text=>'Workspace required.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91336917749893254)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_text=>'Application required.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91337320304903384)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_text=>'Invalid username "%0" or password.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167806816086865980)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_text=>'%0 new attributes inserted and may require translation'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167810216217875472)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_text=>'%0 attributes purged and no longer require translation'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38247413873847538)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_text=>'Seed delete error: %0.%1 %2'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38243324347831576)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_text=>'Seed insert error: %0.%1 %2'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(164979508652595121)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_text=>'Seed error for Table: %0, Column: %1, Error Message: %2'
,p_version_scn=>64098337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167814119118885837)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_text=>'%0 total attributes that may require translation'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38242022138821476)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_text=>'Unable to find %0 translation of application %1'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(167794301756852446)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_text=>'%0 existing attributes updated and may require translation'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107430923393634397)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_text=>'error'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205940814843488725)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_text=>'No index on %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169606682963347369)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_text=>'Data in collection <code>%0</code> appended with <b id="incompl_success_row_count"></b> new documents. <b class="u-danger-text" id="incompl_fail_row_count"></b> documents rejected.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169605602195333224)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_text=>'Data in collection <code>%0</code> appended with <b id="success_row_count"></b> new documents!'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2605740339329401)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_text=>'Content'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169620518942636399)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_text=>'Size'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2606134289337726)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_text=>'Created'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2605466100277301)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_text=>'Key'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2606343644339848)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_text=>'Last Modified'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2605950654336001)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_text=>'Media Type'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804347314371771)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_text=>'Data Guide not available. Either the collection contains no data or no JSON search index has been created yet.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2452020298767622)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_text=>'Upload JSON, TXT or ZIP files.'
,p_is_js_message=>true
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804530190373560)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_text=>'Collection meta data not available. Please check the collection name.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169606902061350662)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_text=>'Data in collection <code>%0</code> replaced with <b id="incompl_success_row_count"></b> new documents. <b class="u-danger-text" id="incompl_fail_row_count"></b> documents rejected.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169605847177335844)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_text=>'Data in collection <code>%0</code> replaced with <b id="success_row_count"></b> new documents!'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101354615259276070)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: Axis interval must be greater than zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101350330927261676)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_text=>'Validation Failed: Axis max must be greater than axis min.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101359617252295603)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: Axis max must be greater than zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101358009849284018)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: Axis min must be greater than or equal to zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101352321707268501)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: Bar width must be greater than zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101346123392240632)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_text=>'error'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101419622035467319)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_text=>'Fetch error: %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101414116924446961)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_text=>'Function returning SQL query: Query cannot be parsed within the App Builder. %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101374129766327642)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: Gaps between bars must be greater than or equal to zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101349621923259115)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: Maximum rows to display must be greater than zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101491025123591251)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_text=>'More data found, but could not display more than 30 values.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101415530561460303)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_text=>'Parse error: %0 '
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101487929148582948)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_text=>'SVG Chart error: %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101452013686512183)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_text=>'Unable to calculate graph holder position: %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101413001902433070)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_text=>'Unable to get color: %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101378023794344805)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: X Axis interval must be greater than zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101405231507403827)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: X Axis max must be greater than zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101390321894382120)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: X Axis min must be greater than or equal to zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101383702024366930)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: Y Axis interval must be greater than zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101376400246338026)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_text=>'Validation Failed: Y Axis max must be greater than axis min.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101408925058411368)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: Y Axis max must be greater than zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101398525835392735)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_text=>'Validation Failed: Y Axis min must be greater than or equal to zero.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100220809570645402)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_text=>'Add Member Error.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19771124963890987)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_text=>'%0 command blocked.  Cannot run from SQL Workshop.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100062126437167690)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_text=>'User %0 has no privileges on the %1 schema.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23744021322864616)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_text=>'Schema %0 has no select privilege on table or view %1.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100222204638662869)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_text=>'Error creating the script.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100072124537204982)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_text=>'plan table created to facilitate explain plan statement'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100091911864286556)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_text=>'Create script file error.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100074821205213480)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_text=>'Error at line %0: %1'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100086731210263735)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_text=>'Error inserting script to files table.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(790998513797296213)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_text=>'Invalid Row ID:  %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100088806885275662)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_text=>'Error parsing the script.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100081816619231129)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_text=>'Schema "%0" does not exist in the database.  Please contact your workspace admin to set correct default schema for you.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15907709682021738)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_text=>'Error in run_sql_arr. %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100221231734651844)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_text=>'Update member error.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(23729007242618562)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_text=>'Script line exceeds 32767 bytes'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11692921729710163)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_text=>'Canceled'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(113173221816062127)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_text=>'Canceling'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12617010562857360)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_text=>'Completed'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12625022879050187)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_text=>'%0 seconds'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11883124508481828)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_text=>'Executing'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29715524034661564)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_text=>'You have requested to run a script containing unknown statement(s).  Please remove the following statement(s).'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12617824068861274)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_text=>'In Progress'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(29711514899649471)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_text=>'Line Number'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19758423964967007)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_text=>'ERR-1004 Scripts cannot be nested more than %0 levels.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20365028491013772)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_text=>'ERR-1005 The script output reached the maximum size limit.  Please change your script to generate less output or contact your administrator to increase the maximum script result size.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(133486729458954279)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_text=>'The script exceeds the maximum allowable size of %0 bytes.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(20367712393046913)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_text=>'ERR-1005 The script output reached the maximum workspace result size limit. Please delete existing results or contact your administrator to increase the maximum workspace result size.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(114601519289792147)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_text=>'No statement in buffer to run.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(17705323851566742)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_text=>'SELECT statement cannot be greater than 32KB.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12622714305028750)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_text=>'%0 row.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12623718938039553)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_text=>'%0 rows.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18521015940098072)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_text=>'%0 rows selected.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109105930633436572)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_text=>'You have requested to run a script that does not contain any runnable statements.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15871319229863606)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_text=>'Unable to run script. %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(15872307024879013)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_text=>'Error in run_statement. %0'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(109020908099762137)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_text=>'You have requested to run a script containing statement(s) SQL Workshop will ignore. Please confirm your request.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19756420239947016)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_text=>'ERR-1001 Script not found.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11691832071684719)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_text=>'Submitted'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112549021095817348)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_text=>'Unknown Statement'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112464600626158594)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_text=>'%0% used'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106848007587445550)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_text=>'Package creation failed due to invalid SQL syntax.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106826208841436408)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_text=>'Table creation failed due to invalid SQL syntax.'
,p_version_scn=>37165770887601
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38253908426902703)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_text=>'Sync error: %0.%1 %2'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149270822124768381)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_text=>'referenced by'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(149269805155763472)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_text=>'references'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(36587317699273087)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_text=>'Tried to access tabular form column which would be mapped to PL/SQL array apex_application.g_f%0, but only %1 columns which save state are supported. Please reduce the number of columns which save state.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355209414702107214)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_text=>'Add New Parent Tab'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153102311370731257)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_text=>'Add New Standard Tab'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153145328657209354)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_text=>'New Tabset (allows you to create a Standard Tab in a new tabset)'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107445725995673000)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_text=>'Cant find new tabset for parent tab id = %0.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107443912836669180)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_text=>'Cant find old tabset for tab id = %0.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107447311581678354)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_text=>'Page id: %0 is not a number.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153125209854071373)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_text=>'Parent Tab. Sequence'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153143810518194607)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_text=>'is not associated with a parent tab. It is being displayed as a Pseudo Parent Tab so that you may edit the Standard Tabs in this tab-set.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153150618183225187)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_text=>'Select Standard Tab'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153127103882088572)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_text=>'Selected Parent Tab'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153126513101081864)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_text=>'Selected Pseudo Parent Tab'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107441117207660999)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_text=>'Security group id must be set.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(107452921063690512)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_text=>'Must specify a new tabset for tab id = %0.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153100307860701785)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_text=>'Standard Tab. Sequence'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153099610846693201)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_text=>'Tab also Current For Pages'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153097325129678433)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_text=>'Tab Current for Page'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(153127812671100639)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_text=>'The tab-set'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38407310793499508)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_text=>'Unable to find button template (%0) in application "%1" workspace "%2" to copy'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38427811542603766)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_text=>'Unable to replace button template. %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106853503347463238)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_text=>'Error'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38385014191320724)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_text=>'Unable to find field template (%0) in application "%1" workspace "%2" to copy'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38425404700582946)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_text=>'Unable to replace field template. %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38424525694579499)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_text=>'Unable to replace list template. %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38406909623489707)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_text=>'Unable to find breadcrumb template (%0) in application "%1" workspace "%2" to copy'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38426022708588077)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_text=>'Unable to replace breadcrumb template. %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38423032142571909)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_text=>'Unable to replace page template. %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38426512796594744)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_text=>'Unable to replace Popup List of Values Template. %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(134994931371888186)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_text=>'Unable to find Popup template (%0) in application "%1" workspace "%2" to copy'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38423609071574712)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_text=>'Unable to replace region template. %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38424017729577229)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_text=>'Unable to replace report template. %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38384613021310928)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_text=>'Unable to find template (%0) to copy'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38419018374549001)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_text=>'Unable to replace %0 template. %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(927024734632621819)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_text=>'Theme Style does not exist.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1211907640106292047)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_text=>'Can''t update style, it''s read only!'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1211907447408255308)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_text=>'Name is already used by an existing style!'
,p_is_js_message=>true
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38248309156855596)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_text=>'Seed update error: %0.%1 %2'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(225652877535873964)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_text=>'Oracle APEX is being upgraded to a newer version. Changes to applications are disabled until the upgrade has finished.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86936300195803128)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_text=>'Add'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5980104696315032)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_text=>'Application %0 not found logged in as database user %1.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5980628722331352)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_text=>'Application %0 page %1 not found logged in as database user %2.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86949522621828533)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_text=>'Calendar'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91820318112795228)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_text=>'Error evaluating checkbox query: %0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86958204660851671)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_text=>'Close'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91744004241289737)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_text=>'Error: Display Only lists of values must select two columns.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86934817380798640)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_text=>'Unable to determine List of Values.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86965922799866397)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_text=>'Find%0'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106665920036597526)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_text=>'Error generating Popup List of Values.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91736022371228694)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_text=>'Error generating query.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91739615361245591)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_text=>'Error in initializing List of Values.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91817211054783730)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_text=>'Unable to initialize query.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(63684610778544812)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_text=>'Popup List of Values query is invalid, a display and a return value are needed, the column names need to be  different'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86977321676884980)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_text=>'JavaScript not supported'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86980902414888919)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_text=>'List'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86994309602909880)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_text=>'Error executing List of Values query.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86945812232825486)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_text=>'Next'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86940214179816619)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_text=>'No matches.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86958815395854793)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_text=>'Ok'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106663409254565988)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_text=>'Popup List of Values must begin with "select".'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91733125918210785)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_text=>'Unable generate Popup List of Values with filter.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106665108131584627)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_text=>'Error initializing PopUp List of Values with filter: %0 %1'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(106663913541576724)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_text=>'Error initializing PopUp List of Values.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91803510053736096)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_text=>'Popup List of Values authentication failed.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91809514686746943)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_text=>'Popup List of Values checksum verification failed.'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86943301496822375)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_text=>'Previous'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86937520974809106)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_text=>'Remove'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(86961900289859951)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_text=>'Search Dialog'
,p_version_scn=>37165770887602
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(492202110193297962)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_text=>'Error showing image. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91936518457145445)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_text=>'Bold'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91942131795187148)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_text=>'Bulleted List'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91955405176207766)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_text=>'Indent Left'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91962815219210684)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_text=>'Indent Right'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91939307422170567)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_text=>'Italics'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91945008854199462)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_text=>'Justify Center'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91942813918191436)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_text=>'Justify Left'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91947423399203617)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_text=>'Justify Right'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91941514133182065)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_text=>'Numbered List'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91940931664177663)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_text=>'Underline'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91743214237264260)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_text=>'Unable to bind "%0"'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800576687468256)
,p_name=>'WWV_FLOW_WEB_SERVICES.DBMS_CREDENTIAL_NOT_SUPPORTED'
,p_message_text=>'Using a Database Credential is not supported.'
,p_version_scn=>2051716
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1800754127477014)
,p_name=>'WWV_FLOW_WEB_SERVICES.DBMS_CREDENTIAL_NOT_VALID'
,p_message_text=>'Database Credential %0 does not exist or is not accessible by this workspace.'
,p_version_scn=>57170679
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(152434725166400337)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_text=>'The webservice was unreachable because either the URL you supplied was invalid, your environment requires a valid proxy server address for HTTP requests, the request timed out, or a wallet needs to be configured for HTTPS requests. SQLERRM: %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26736714862399592)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_text=>'The WSDL document was unretrievable because either the URL you supplied was invalid, your environment requires a valid proxy server address for HTTP requests and you have not defined one for this application, or a wallet needs to be configured for th'
||'is instance of &PRODUCT_NAME. for HTTPS requests.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26904423903903533)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_text=>'Action Processed.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359640325944604022)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_text=>'Unable to add rows.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25324405032005442)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_text=>'Unable to create button. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40704419965027728)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_text=>'Unable to create calendar page. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40701320957999597)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_text=>'Unable to create chart page. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(474705903854191932)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_text=>'Unable to complete the data load process. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40730007675062030)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_text=>'Unable to create excel chart. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40706208668033962)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_text=>'Unable to create form on equijoin. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40699605111976110)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_text=>'Unable to create form on sp. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40700105935985789)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_text=>'Unable to create form on table. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40700520479990021)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_text=>'Unable to create insert form. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(269140443991216656)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_text=>'Unable to create Oracle JET chart. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2401917549947375)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_text=>'Unable to create master detail page. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(180644717180881510)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_text=>'Unable to create dynamic action. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40700901910994145)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_text=>'Unable to create query and update page. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40703206112023732)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_text=>'Unable to create report page. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40731424991067032)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_text=>'Unable to create summary page. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40731808845071811)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_text=>'Unable to create SVG Chart page. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40717912608044502)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_text=>'Unable to create tree. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40699222642971734)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_text=>'Unable to create updateable report. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40711723905038298)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_text=>'Unable to create wizard creating wizard. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359625416117591729)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_text=>'Unable to process delete.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359642723220631691)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_text=>'#MRD_COUNT# row(s) deleted.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9293304754717218)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_text=>'Get Next or Previous Primary Key Value'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9279405222651106)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_text=>'This button is needed for Get Next or Previous Primary Key Value process.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9275804960632165)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_text=>'This item is needed for Get Next or Previous Primary Key Value process.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9312418653749676)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_text=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12313530078134639)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_text=>'Are you sure you want to leave this page without saving?'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(132002227332912101)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_text=>'Unable to get secondary key item value.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(132001320621900737)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_text=>'Unable to get primary key item value.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40701713123006845)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_text=>'Invalid report type.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139383927642245856)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_text=>'Interactive report already exists. You can only add one Interactive report per page.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(39483025801887283)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_text=>'Unable to create get next previous primary key value process. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359617118531516727)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_text=>'No help is available for this page.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40698809136967782)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_text=>'ParseErr: %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40698211429959036)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_text=>'parse error2 %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359643712663666415)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_text=>'Error sending request.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359917714477766131)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_text=>'Show Tree'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359651926955727334)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_text=>'Tree Root'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26903002647887974)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_text=>'Unable to fetch row.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(26904002086897222)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_text=>'Unable to process row of table %0.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(40732321443084954)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_text=>'Updatable SQL Query already exists. You can only add one updatable SQL query per page.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359641702657616262)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_text=>'Update applied.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(359642231401624512)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_text=>'#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(210228024254102806)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_text=>'Copy Authorization Scheme'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(210222010009070370)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_text=>'Copy List'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(210211820389997660)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_text=>'Copy List of Values'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(210222928709075712)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_text=>'Use Existing List'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(210213802989011585)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_text=>'Use Existing List of Values'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(92050406919216961)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_text=>'Error rendering report: %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(373254127062259739)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_text=>'%0 GB total | %1 GB used | %2 percent used'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5590417429371347)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_text=>'Error while setting new PGA aggregate target. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5517322027678913)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_text=>'Error while setting new SGA target. %0'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2199622936500295888)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_text=>'Error processing %0: %1'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1943535848885061)
,p_name=>'WWV_QUERY_VALIDATION_DEV.COLUMNS_CLAUSE_REQUIRED'
,p_message_text=>'PQL Columns Clause required.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1991845019513179)
,p_name=>'WWV_QUERY_VALIDATION_DEV.GRAPH_REQUIRED'
,p_message_text=>'Graph Name is required.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1943739025886318)
,p_name=>'WWV_QUERY_VALIDATION_DEV.MATCH_CLAUSE_REQUIRED'
,p_message_text=>'PQL Match Clause is required.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77193479172946463)
,p_name=>'WWV_QUERY_VALIDATION_DEV.PLSQL_REQUIRED'
,p_message_text=>'PL/SQL Function Body Returning a SQL Query is required.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77193181864942902)
,p_name=>'WWV_QUERY_VALIDATION_DEV.QUERY_REQUIRED'
,p_message_text=>'SQL Query is required.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77198031228994965)
,p_name=>'WWV_QUERY_VALIDATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_text=>'REST Enabled SQL Service is required.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77192945923940461)
,p_name=>'WWV_QUERY_VALIDATION_DEV.TABLE_REQUIRED'
,p_message_text=>'Table Name is required.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77198246885998790)
,p_name=>'WWV_QUERY_VALIDATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_text=>'REST Data Source is required.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(77199352682126333)
,p_name=>'WWV_QUERY_VALIDATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_text=>'WHERE or ORDER BY clause is required.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91343610345231701)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_text=>'Average'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91343225105226531)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_text=>'Axis'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91346229523246673)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_text=>'First'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91346805413249219)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_text=>'Go'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91345823982245118)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_text=>'Last'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91345012554241809)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_text=>'Maximum'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91345419480243777)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_text=>'Minimum'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91342818872224685)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_text=>'Rows'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91344600433238332)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_text=>'Sum'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72334222183488035)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_text=>'The query can not be parsed, the cursor is not yet open or a function returning a SQL query returned without a value.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(202074819273302989)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_text=>'Your query contains duplicate alias names, queries used for reports require unique alias names.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(63435513943523799)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'unable to process function body returning query:',
'%0'))
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(101350027810260835)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_text=>'invalid number of columns defined in query, there are %0 columns required for this region type'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72338308162521865)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Function returning SQL query: Query cannot be parsed within the Builder. If you believe your query is syntactically correct, check the <strong>generic columns</strong> checkbox below the region source to proceed without parsing.',
'<br/>',
'(%0)'))
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72345130157566013)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Query cannot be parsed within the Builder. If you believe your query is syntactically correct, check the ''''generic columns'''' checkbox below the region source to proceed without parsing.',
'%0</p>'))
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100948712453572099)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_text=>'Add Word'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100987012406893825)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_text=>'Add To Dictionary'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100986611928884194)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_text=>'Apply Changes'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100986114568875507)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_text=>'Cancel'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100985724480868948)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_text=>'Done'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(280309058310284054)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_text=>'Submit'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100977429964766405)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_text=>'%0 already in your dictionary.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100995213061941341)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_text=>'Enter new word.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100991212106922151)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_text=>'Pick A Word'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169736503521442394)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_text=>'Spell Checker'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(100976710787751452)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_text=>'Added %0 to your dictionary.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(32081613579269326)
,p_name=>'XML_LOAD_ERROR'
,p_message_text=>'XML load error.'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191582113723159197)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_text=>'An additional %0 tags exist'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(191843113851335978)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_text=>'%0 bugs have no fix by dates'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(361739120903159633)
,p_name=>'YEARLY'
,p_message_text=>'Year'
,p_version_scn=>37165770887603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(58422019512981075)
,p_name=>'YES_BY_USER'
,p_message_text=>'Yes, By User'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(74915818232893988)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_text=>'Your email address is registered with a user in the following workspaces:'
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(165055114808779463)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_text=>'You are now logged out.'
,p_version_scn=>37165770887604
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(91645213681389498)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_version_scn=>72472246
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3708767719669)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>'Breadcrumb'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472427
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display the breadcrumb trail for the current page.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3709973247475)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>'List'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472432
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays values based on either a static or dynamic list. Generally these are used for navigating to pages in the application.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3734497742532)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>'Cancel Dialog'
,p_category=>'NAVIGATION'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_version_scn=>72472432
,p_subscribe_plugin_settings=>true
,p_help_text=>'Cancels the current dialog page.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3734500756040)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>'Close Dialog'
,p_category=>'NAVIGATION'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_version_scn=>72472432
,p_subscribe_plugin_settings=>true
,p_help_text=>'Closes the current dialog page.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3788410042953)
,p_plugin_id=>wwv_flow_imp.id(3734500756040)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Items to Return'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of one or more page items to be returned by the dialog. For multiple items separate each item name with a comma.</p>',
'<p>You can access the returned item values by defining a Dynamic Action to fire on the <strong>Dialog Closed</strong> event on the element that opens the dialog, with an action of <strong>Set Value</strong> and a <em>Set Type</em> of <strong>Dialog R'
||'eturn Item</strong>.</p>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3782395890396)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>'Region Display Selector'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472484
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display region names in a horizontal list, enabling end users to select one region to display and hide other regions. Only page regions with <em>Region Display Selector</em> set to <strong>Yes</strong> will be displayed in this region.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1764737380560506621)
,p_plugin_id=>wwv_flow_imp.id(3782395890396)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'include_slider'
,p_prompt=>'Include Slider'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Dynamically add a slider to the region if the displayed region names exceed the width of the region.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1763653631955156043)
,p_plugin_id=>wwv_flow_imp.id(3782395890396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'rds_mode'
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how regions with <em>Region Display Selector</em> set to <strong>Yes</strong> will be displayed on the page.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1763654080157157624)
,p_plugin_attribute_id=>wwv_flow_imp.id(1763653631955156043)
,p_display_sequence=>10
,p_display_value=>'View Single Region'
,p_return_value=>'STANDARD'
,p_help_text=>'Show regions as tabs. Selecting a tab will make the corresponding region visible and hide the other selections.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1763654509981158498)
,p_plugin_attribute_id=>wwv_flow_imp.id(1763653631955156043)
,p_display_sequence=>20
,p_display_value=>'Scroll Window'
,p_return_value=>'JUMP'
,p_help_text=>'Always display all the regions on the page. Selecting a tab will scroll your window to the corresponding region.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1763973139934187732)
,p_plugin_id=>wwv_flow_imp.id(3782395890396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'include_show_all'
,p_prompt=>'Include ''Show All'''
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1763653631955156043)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>'Prepend a "Show All" tab which, when selected, displays all regions on the page .'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1763975939882192484)
,p_plugin_id=>wwv_flow_imp.id(3782395890396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'remember_selection'
,p_prompt=>'Remember Selection'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'USER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how the tab you last selected will be remembered on page load. Tabs are remembered using static IDs, so selection will be lost if the static IDs of regions change.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2002089282985931)
,p_plugin_attribute_id=>wwv_flow_imp.id(1763975939882192484)
,p_display_sequence=>10
,p_display_value=>'By User'
,p_return_value=>'USER'
,p_help_text=>'Remember tab selection by User, across sessions.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2002447797991694)
,p_plugin_attribute_id=>wwv_flow_imp.id(1763975939882192484)
,p_display_sequence=>20
,p_display_value=>'By Session'
,p_return_value=>'SESSION'
,p_help_text=>'Remember the tab selection for the current session only.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2002872648996043)
,p_plugin_attribute_id=>wwv_flow_imp.id(1763975939882192484)
,p_display_sequence=>30
,p_display_value=>'No'
,p_return_value=>'NO'
,p_help_text=>'Do not remember tab selections.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2004453926026568)
,p_plugin_id=>wwv_flow_imp.id(3782395890396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>15
,p_static_id=>'display_region_icons'
,p_prompt=>'Display Region Icons'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Display the Icon attribute value for each region in the Region Display Selector next to the titles in the Region Display Selector tabs.'
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3783484270249)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472506
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display remote content sourced from a URL.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3783486275401)
,p_plugin_id=>wwv_flow_imp.id(3783484270249)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'url'
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Enter an URL for the remote content.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3783489372727)
,p_plugin_id=>wwv_flow_imp.id(3783484270249)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'inclusion_mode'
,p_prompt=>'Inclusion Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how the remote content from the URL is included in the page.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3783492373852)
,p_plugin_attribute_id=>wwv_flow_imp.id(3783489372727)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>'Embed remote content as an iframe.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3783496377152)
,p_plugin_attribute_id=>wwv_flow_imp.id(3783489372727)
,p_display_sequence=>20
,p_display_value=>'Inline (escape special characters)'
,p_return_value=>'ESC_INLINE'
,p_help_text=>'Read remote content at page rendering time and embed it, but escape special HTML characters to prevent cross-site scripting.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3783504380866)
,p_plugin_attribute_id=>wwv_flow_imp.id(3783489372727)
,p_display_sequence=>30
,p_display_value=>'Inline (no escaping)'
,p_return_value=>'NOESC_INLINE'
,p_help_text=>'Read remote content at page rendering time and embed it. This option should only be selected if the remote content can be fully trusted, as no HTML escaping is done. This may make the region vulnerable to cross-site scripting.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3783511409602)
,p_plugin_id=>wwv_flow_imp.id(3783484270249)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'iframe_attributes'
,p_prompt=>'IFrame Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3783489372727)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'width="300" height="300"',
'</pre>'))
,p_help_text=>'Enter additional HTML element attributes for the iframe tag.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3783517424673)
,p_plugin_id=>wwv_flow_imp.id(3783484270249)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'discard_html_until'
,p_prompt=>'Discard HTML Until'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3783489372727)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>'Use this attribute when clipping a section of HTML out of a larger document. Enter a string which identifies the beginning of the targeted section, or the point until which HTML is discarded.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3783520428341)
,p_plugin_id=>wwv_flow_imp.id(3783484270249)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'discard_html_after'
,p_prompt=>'Discard HTML After'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3783489372727)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>'Use this attribute to clip a section of HTML out of a larger HTML document. Enter a string which identifies the end of the targeted section, or the point from which the remaining HTML is discarded. This string which identifies the end of the targeted'
||' section is not included in the returned text.'
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3783523603076)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>'Help Text'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472506
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a special Help region utilized on the dedicated Help page.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1370261776191667)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>'Faceted Search'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>false
,p_version_scn=>72472506
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'<p>A region based on the source of an associated Faceted Search, that provides end users with numerous facets that are used to narrow search results at run-time. </p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1370473361191712)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'batch_facet_search'
,p_prompt=>'Batch Facet Changes'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Select whether to batch apply selected facets, or individually, on the Faceted Search report.  When Yes, the filtering of the Report is executed when an Apply button is clicked.  When No, the filtering of the Report is executed as soon as any facet v'
||'alue changes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2517816294852101)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'show_current_facets'
,p_prompt=>'Show Current Facets'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify whether to display the current facets area. The current facets area lists the facets that are currently selected and provides an easy way to remove them individually or all at once.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2518140718854747)
,p_plugin_attribute_id=>wwv_flow_imp.id(2517816294852101)
,p_display_sequence=>10
,p_display_value=>'Yes'
,p_return_value=>'Y'
,p_help_text=>'The list of current facets is displayed at the top of the Faceted Search region.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2518542510858430)
,p_plugin_attribute_id=>wwv_flow_imp.id(2517816294852101)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'The list of current facets is not displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2518915492864304)
,p_plugin_attribute_id=>wwv_flow_imp.id(2517816294852101)
,p_display_sequence=>30
,p_display_value=>'Selector'
,p_return_value=>'E'
,p_help_text=>'The current facets area is displayed within the element specified by this selector. This allows you to place the current facets area just about anywhere on the page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(728482701453610313)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'current_facets_selector'
,p_prompt=>'Current Facets Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2517816294852101)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>'This is the selector of an element on the page where the faceted search region will display the current facets.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1501356115247921)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_static_id=>'show_total_row_count'
,p_prompt=>'Show Total Row Count'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify where to display the total row count.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1501661440256814)
,p_plugin_attribute_id=>wwv_flow_imp.id(1501356115247921)
,p_display_sequence=>10
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'The total row count is not displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1502011338258911)
,p_plugin_attribute_id=>wwv_flow_imp.id(1501356115247921)
,p_display_sequence=>20
,p_display_value=>'Yes'
,p_return_value=>'Y'
,p_help_text=>'The total row count is displayed at the top of the current facets area or, if Show Current Facets is No, at the top of the Faceted Search region.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1502458150261854)
,p_plugin_attribute_id=>wwv_flow_imp.id(1501356115247921)
,p_display_sequence=>30
,p_display_value=>'Selector'
,p_return_value=>'E'
,p_help_text=>'The total row count (without any label) is displayed within the element specified by this selector. This allows you to place the total row count just about anywhere on the page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1503042014268412)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_static_id=>'total_row_count_label'
,p_prompt=>'Total Row Count Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1501356115247921)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Label to use for the total row count. If no label is provided here, APEX will use the APEX.FS.TOTAL_ROW_COUNT_LABEL text message.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1503328055272516)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_static_id=>'total_row_count_selector'
,p_prompt=>'Total Row Count Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1501356115247921)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>'This is the selector of an element on the page where the faceted search region will display the total row count.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(556135859462274866)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_static_id=>'compact_numbers_threshold'
,p_prompt=>'Compact Numbers Threshold'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'Provide a threshold value, above which facet counts are displayed using a compact number format. With the compact number format, a value of <strong>1,234</strong> will be displayed as <strong>1K</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2600957382075036)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_static_id=>'show_charts'
,p_prompt=>'Show Charts'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify where facet value charts are shown.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2601268677075657)
,p_plugin_attribute_id=>wwv_flow_imp.id(2600957382075036)
,p_display_sequence=>10
,p_display_value=>'Dialog'
,p_return_value=>'Y'
,p_help_text=>'Facet value charts are shown in a non-modal dialog.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2601607534076237)
,p_plugin_attribute_id=>wwv_flow_imp.id(2600957382075036)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'There is no button for users to show facet value charts.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2602011048076805)
,p_plugin_attribute_id=>wwv_flow_imp.id(2600957382075036)
,p_display_sequence=>30
,p_display_value=>'Selector'
,p_return_value=>'E'
,p_help_text=>'Facet value charts are added to the element specified by this selector. This allows you to place the charts just about anywhere on the page creating a facet value charts dashboard.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2602471299081559)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_static_id=>'charts_selector'
,p_prompt=>'Charts Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2600957382075036)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>'This is the selector of an element on the page where the faceted search region will display facet charts.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3900223688176537)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_static_id=>'display_chart_for_top_n_values'
,p_prompt=>'Display Chart for Top N Values'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2600957382075036)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>'Provide the number of values to display in the chart for each facet. A value of <strong>10</strong> means that the facet charts will display the <em>first 10</em> items as ordered under the facet. When the facet property Sort By Top Counts is On this'
||' will be the <em>top 10</em> items based on occurrence counts. Changes to this property may not be seen right away in currently active browser sessions. This value as well as the user''s choice of pie or bar chart is saved in the browser session. To s'
||'ee the effect of changes to this property reset the report using the link Reset Regions cache control option such as with the wizard generated Reset button.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(152341438099378569)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.clearOnHide = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a JavaScript function that takes an options object, modifies the object, and returns it. This allows advanced customization of the region during initialization. See the <code>facetsRegion</code> interface JavaScript API documentation for the'
||' available options.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(603063046957961274)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_name=>'facetsafterremovechart'
,p_display_name=>'After Remove Chart'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(603062764743961271)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>'Before Add Chart'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(1372274287191736)
,p_plugin_id=>wwv_flow_imp.id(1370261776191667)
,p_name=>'facetschange'
,p_display_name=>'Facets Change'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1381216513007333)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>'SAML Sign-In'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_version_scn=>55530562
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Delegates authentication to the Security Assertion Markup Language (SAML) Sign In authentication scheme.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1381216513007334)
,p_plugin_id=>wwv_flow_imp.id(1381216513007333)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>'Credential Store for Signing Requests'
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1381216513007335)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the credential store which contains public certificate and private key used to sign messages to the identity provider.',
'You need to register the certificate at the identity provider.',
'&PRODUCT_NAME. uses the private key to sign requests.',
'While this attribute is optional, it is recommended to sign requests for security reasons.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1381216513007335)
,p_plugin_id=>wwv_flow_imp.id(1381216513007333)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Use SAML Attributes of'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>'Specify whether to use an instance-level or application specific SAML configuration.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1381216513007332)
,p_plugin_attribute_id=>wwv_flow_imp.id(1381216513007335)
,p_display_sequence=>10
,p_display_value=>'Instance'
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use the shared SAML configuration for the whole &PRODUCT_NAME. instance.',
'This requires that your instance administrator has configured instance-level SAML attributes.',
'If this is not the case, you will get runtime errors.'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1381216513007331)
,p_plugin_attribute_id=>wwv_flow_imp.id(1381216513007335)
,p_display_sequence=>20
,p_display_value=>'Application'
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>'Use an application specific SAML configuration.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1381216513007336)
,p_plugin_id=>wwv_flow_imp.id(1381216513007333)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Identity Provider Single Sign-On URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1381216513007335)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>'Select the identity provider''s Single Sign-On POST URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1381216513007337)
,p_plugin_id=>wwv_flow_imp.id(1381216513007333)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>'Identity Provider Single Sign-Out URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1381216513007335)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the identity provider''s Single Sign-Out POST URL.',
'If empty, the Single Sign-On URL will be used.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1381216513007338)
,p_plugin_id=>wwv_flow_imp.id(1381216513007333)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>'Identity Provider Issuer'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1381216513007335)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the identity provider''s "Issuer" value.',
'&PRODUCT_NAME. will verify this value in messages from the identity provider.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1381216513007339)
,p_plugin_id=>wwv_flow_imp.id(1381216513007333)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1381216513007335)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The SAML attribute which contains the username.',
'Defaults to the value of the "Assertion/Subject/NameID" node.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1381216513007340)
,p_plugin_id=>wwv_flow_imp.id(1381216513007333)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>'Identity Provider''s Signing Certificate'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1381216513007335)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the certificate that the identity provider uses to sign messages.',
'&PRODUCT_NAME. uses this certificate to verify response messages from the identity provider.',
'While this attribute is optional, it is recommended to verify responses for security reasons.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(549695930675668342)
,p_plugin_id=>wwv_flow_imp.id(1381216513007333)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Convert Username To Upper Case'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select "Yes" to automatically convert the username value to upper case. Select "No" to keep the original username value supplied by the authentication provider.</p>',
'<p>Oracle recommends setting this attribute to "Yes" if your application uses the native Application Access Control shared component.</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1401075215817352)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>'Input Field'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:FORMAT_MASK_DATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_version_scn=>72472620
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a text field that enables the user to filter by text input.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1401202979819499)
,p_plugin_id=>wwv_flow_imp.id(1401075215817352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Comparison Operator'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select which operator is utilized to compare the entered facet value. If <strong>User can Choose Operator</strong> is enabled, it will be used as default operator.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1401536563820127)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>10
,p_display_value=>'equals'
,p_return_value=>'EQUALS'
,p_help_text=>'Filter returns results of column values which equal the filter value. Comparison is always done case-sensitive.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3203673978637568)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>20
,p_display_value=>'not equals'
,p_return_value=>'NOT_EQUALS'
,p_help_text=>'Filter returns results of column values which do not equal the filter value. Comparison is always done case-sensitive.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1402360244821204)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>30
,p_display_value=>'less than'
,p_return_value=>'LT'
,p_help_text=>'Filter returns results of column values which are less than the filter value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1402711336822152)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>40
,p_display_value=>'less than or equal to'
,p_return_value=>'LTE'
,p_help_text=>'Filter returns results of column values which are less than or equal to the filter value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1403187913822669)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>50
,p_display_value=>'greater than'
,p_return_value=>'GT'
,p_help_text=>'Filter returns results of column values which are greater than the filter value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1403530010823859)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>60
,p_display_value=>'greater than or equal to'
,p_return_value=>'GTE'
,p_help_text=>'Filter returns results of column values which are greater than or equal to the filter value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1574661752077055)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>70
,p_display_value=>'starts with'
,p_return_value=>'STARTS_WITH'
,p_help_text=>'<p>Filter returns results of column values starting with the filter value. &PRODUCT_NAME. will utilize a <code>column LIKE filtervalue<strong>%</strong></code> in the where clause.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3803652188245066)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>80
,p_display_value=>'does not start with'
,p_return_value=>'NOT_STARTS_WITH'
,p_help_text=>'<p>Filter returns results of column values which do not start with the filter value. &PRODUCT_NAME. will utilize a <code>column NOT LIKE filtervalue<strong>%</strong></code> in the where clause.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1403924638824893)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>90
,p_display_value=>'contains'
,p_return_value=>'CONTAINS'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Filter returns results of column values containing the filter value. &PRODUCT_NAME. will utilize a <code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code> in the where clause.</p>',
'        <p>Note - this operator will prevent any column indexes being used, which may result in a full table scan.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3802656449241834)
,p_plugin_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_display_sequence=>100
,p_display_value=>'does not contain'
,p_return_value=>'NOT_CONTAINS'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Filter returns results of column values which do not contain the filter value. &PRODUCT_NAME. will utilize a <code>column NOT LIKE <strong>%</strong>filtervalue<strong>%</strong></code> in the where clause.</p>',
'        <p>Note - this operator will prevent any column indexes being used, which may result in a full table scan.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1404353085828349)
,p_plugin_id=>wwv_flow_imp.id(1401075215817352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Case Sensitive'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1401202979819499)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS,NOT_STARTS_WITH,NOT_CONTAINS'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether case sensitivity should be respected. &PRODUCT_NAME. will utilize a <code>UPPER(column) <em>operator</em> UPPER(filtervalue)</code> in the where clause.</p>',
'<p>Note - Generally performing UPPER on both the column and filter value will prevent the use of any column indexes, except for function based column indexes with UPPER(<em>column</em>).</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1581137453249138)
,p_plugin_id=>wwv_flow_imp.id(1401075215817352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Values Case'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1404353085828349)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select which case the text within the column value is stored.</p>',
'<p>If the column can be specified as always upper case, for example <em>Username</em>, or always lower case, then the performance of retrieving filter results can be improved. If <strong>Upper</strong> or <strong>Lower</strong> is selected searches w'
||'ill always perform case sensitive searches.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1581469548249721)
,p_plugin_attribute_id=>wwv_flow_imp.id(1581137453249138)
,p_display_sequence=>10
,p_display_value=>'Mixed Case'
,p_return_value=>'MIXED'
,p_help_text=>'For when the column value is stored in mixed case.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1581879901250301)
,p_plugin_attribute_id=>wwv_flow_imp.id(1581137453249138)
,p_display_sequence=>20
,p_display_value=>'Lower Case'
,p_return_value=>'LOWER'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'For when the column value is always stored in lower case.',
'&PRODUCT_NAME. will utilize a <code>column <em>operator</em> LOWER(filtervalue)</code> in the where clause.'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1582278689250872)
,p_plugin_attribute_id=>wwv_flow_imp.id(1581137453249138)
,p_display_sequence=>30
,p_display_value=>'Upper Case'
,p_return_value=>'UPPER'
,p_help_text=>'For when the column value is always stored in upper case. &PRODUCT_NAME. will utilize a <code>column <em>operator</em> UPPER(filtervalue)</code> in the where clause.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1573402545049808)
,p_plugin_id=>wwv_flow_imp.id(1401075215817352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Current Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1383077082463854)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'Filtering for %0'
,p_help_text=>'Provide the text to be displayed for this facet in the current facets area. The current value can be references with the <strong>%0</strong> placeholder.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1594998866512975)
,p_plugin_id=>wwv_flow_imp.id(1401075215817352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Prefix Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1383077082463854)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Provide text to be displayed before the input field.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1595229523514009)
,p_plugin_id=>wwv_flow_imp.id(1401075215817352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Suffix Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1383077082463854)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Provide text to be displayed after the input field.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1383077082463854)
,p_plugin_id=>wwv_flow_imp.id(1401075215817352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>20
,p_prompt=>'User can Choose Operator'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether the end user can choose a different comparison operator for this Facet at runtime.'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/extension
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1402013258504459)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'EXTENSION'
,p_display_name=>'Internal Application Extension'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','EXTENSION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>55030944
,p_subscribe_plugin_settings=>true
,p_help_text=>'Use this scheme for extensions to internal applications.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/print_report
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1405506977267831)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'PRINT_REPORT'
,p_display_name=>'Print Report'
,p_category=>'EXECUTE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','PRINT_REPORT'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_version_scn=>5632150
,p_subscribe_plugin_settings=>true
,p_help_text=>'Prints a Report Query.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1406167220267846)
,p_plugin_id=>wwv_flow_imp.id(1405506977267831)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Report Query'
,p_attribute_type=>'REPORT QUERY ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Select the <strong>Report Query</strong> from Shared Components. Among other attributes, the report query defines the data sources for the report, the report layout, and output format.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1406517121267847)
,p_plugin_id=>wwv_flow_imp.id(1405506977267831)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Filename'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>'my_files.zip'
,p_help_text=>'Enter a filename for the downloaded report.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1406922372267847)
,p_plugin_id=>wwv_flow_imp.id(1405506977267831)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'View File As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ATTACHMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select the content-disposition for the downloaded report. Content-disposition is an extension to the MIME protocol that instructs the browser on how the document displays.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1407381464267847)
,p_plugin_attribute_id=>wwv_flow_imp.id(1406922372267847)
,p_display_sequence=>10
,p_display_value=>'Attachment'
,p_return_value=>'ATTACHMENT'
,p_help_text=>'Saves the file to disk.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1407815858267847)
,p_plugin_attribute_id=>wwv_flow_imp.id(1406922372267847)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'Displays the file instead of the current page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1408334252267848)
,p_plugin_id=>wwv_flow_imp.id(1405506977267831)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Items to Submit'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the uppercase page items submitted to the server, and therefore, available for use within your <strong>Report Query</strong>.</p>',
'<p>You can type in the item name or pick from the list of available items. If you pick from the list and there is already text entered then a comma is placed at the end of the existing text, followed by the item name returned from the list.</p>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/print_report
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1410715931267865)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PRINT_REPORT'
,p_display_name=>'Print Report'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PRINT_REPORT'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_version_scn=>5619131
,p_subscribe_plugin_settings=>true
,p_help_text=>'Prints a Report Query. This process type works in Before Header position at Page Rendering or in Page Processing when submitting a page. The processing stops after this process is executed.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(3613183103496362)
,p_plugin_id=>wwv_flow_imp.id(1410715931267865)
,p_title=>'Source'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1411321964267865)
,p_plugin_id=>wwv_flow_imp.id(1410715931267865)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Report Query'
,p_attribute_type=>'REPORT QUERY ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Select the <strong>Report Query</strong> from Shared Components. Among other attributes, the report query defines the data sources for the report, the report layout, and output format.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1411709395267866)
,p_plugin_id=>wwv_flow_imp.id(1410715931267865)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Filename'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>'my_report.pdf'
,p_help_text=>'Enter a filename for the downloaded report.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1412138943267866)
,p_plugin_id=>wwv_flow_imp.id(1410715931267865)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'View File As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ATTACHMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select the content-disposition for the downloaded report. Content-disposition is an extension to the MIME protocol that instructs the browser on how the document displays.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1412541220267866)
,p_plugin_attribute_id=>wwv_flow_imp.id(1412138943267866)
,p_display_sequence=>10
,p_display_value=>'Attachment'
,p_return_value=>'ATTACHMENT'
,p_help_text=>'Saves the file to disk.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1413045559267866)
,p_plugin_attribute_id=>wwv_flow_imp.id(1412138943267866)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'Displays the file instead of the current page.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_ai_assistant
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1411874327001490)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_AI_ASSISTANT'
,p_display_name=>'Open AI Assistant'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_AI_ASSISTANT'),'')
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#da.ai#MIN#.js'
,p_api_version=>1
,p_standard_attributes=>'INIT_JAVASCRIPT_CODE:AI_ENABLED_ALWAYS:AI_SYSTEM_PROMPT:AI_WELCOME_MESSAGE'
,p_substitute_attributes=>false
,p_version_scn=>130225892
,p_subscribe_plugin_settings=>true
,p_help_text=>'Opens the AI Assistant, an AI-powered chat service, displayed either as a dialog or inline.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1413300248012844)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_title=>'Appearance'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1413600130012844)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_title=>'Initial Prompt'
,p_display_sequence=>20
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1414078813012844)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_title=>'Use Response'
,p_display_sequence=>30
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(2003303289447764)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_title=>'Quick Actions'
,p_display_sequence=>40
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2401866519885874)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>200
,p_prompt=>'AI Avatar Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Select the type of avatar for the AI assistant.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2402663869889534)
,p_plugin_attribute_id=>wwv_flow_imp.id(2401866519885874)
,p_display_sequence=>10
,p_display_value=>'Icon Classes'
,p_return_value=>'ICON_CLASS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2403011832892604)
,p_plugin_attribute_id=>wwv_flow_imp.id(2401866519885874)
,p_display_sequence=>20
,p_display_value=>'Image URL'
,p_return_value=>'IMAGE_URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2403459041896703)
,p_plugin_attribute_id=>wwv_flow_imp.id(2401866519885874)
,p_display_sequence=>30
,p_display_value=>'Initials'
,p_return_value=>'INITIALS'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2600307389908899)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>250
,p_prompt=>'User Avatar Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Select the type of avatar for the current application user.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2600812164910232)
,p_plugin_attribute_id=>wwv_flow_imp.id(2600307389908899)
,p_display_sequence=>10
,p_display_value=>'Icon Classes'
,p_return_value=>'ICON_CLASS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2601206275911387)
,p_plugin_attribute_id=>wwv_flow_imp.id(2600307389908899)
,p_display_sequence=>20
,p_display_value=>'Image URL'
,p_return_value=>'IMAGE_URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2601691135915120)
,p_plugin_attribute_id=>wwv_flow_imp.id(2600307389908899)
,p_display_sequence=>30
,p_display_value=>'Initials'
,p_return_value=>'INITIALS'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2602206340920357)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>210
,p_prompt=>'Icon Classes'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2401866519885874)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON_CLASS'
,p_help_text=>'Specify the CSS classes for the avatar icon.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2602794103923463)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>220
,p_prompt=>'Image URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2401866519885874)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE_URL'
,p_help_text=>'Enter the URL of an image to be used for the avatar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2603299336927010)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>230
,p_prompt=>'Initials'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2401866519885874)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'INITIALS'
,p_help_text=>'Enter the Initials used for the avatar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2603753852929480)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>260
,p_prompt=>'Icon Classes'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2600307389908899)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON_CLASS'
,p_help_text=>'Specify the CSS classes for the avatar icon.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2604261171931596)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>7
,p_display_sequence=>270
,p_prompt=>'Image URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2600307389908899)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE_URL'
,p_help_text=>'Enter the URL of an image to be used for the avatar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2604749881933780)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>8
,p_display_sequence=>280
,p_prompt=>'Initials'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2600307389908899)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'INITIALS'
,p_help_text=>'Enter the Initials used for the avatar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1415109541016584)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Display As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'DIALOG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1413300248012844)
,p_help_text=>'Select how the AI Assistant should appear on your page.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1415494567017447)
,p_plugin_attribute_id=>wwv_flow_imp.id(1415109541016584)
,p_display_sequence=>10
,p_display_value=>'Dialog'
,p_return_value=>'DIALOG'
,p_help_text=>'Will present the assistant in a modal dialog.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1415864640018177)
,p_plugin_attribute_id=>wwv_flow_imp.id(1415109541016584)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'Will integrate the assistant directly into the page layout.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1416359466024032)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1415109541016584)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG'
,p_attribute_group_id=>wwv_flow_imp.id(1413300248012844)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a title for the modal dialog.</p>',
'<p>The default title can be changed application-wide by creating a text message named <code>APEX.AI.DIALOG_TITLE</code>.</p>',
'<p>The attribute supports template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1416797069028849)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Container Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1415109541016584)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'INLINE'
,p_attribute_group_id=>wwv_flow_imp.id(1413300248012844)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>To select a page element with a DOM ID of <code>my_id</code></dt>',
'<dd><pre>#my_id</pre></dd>',
'<dt>To select a page element with a class of <code>my_class</code></dt>',
'<dd><pre>.my_class</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter jQuery Selector syntax to return a page element present on your current page. This Container Selector will be used to locate the element where the AI Assistant widget will be embedded.</p>',
'<p>If the selector returns multiple DOM elements only the first one is used.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1417159579033036)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1413600130012844)
,p_null_text=>'None'
,p_help_text=>'Select the type of initial prompt to be delivered to the AI Assistant. The initial prompt represents a message as if it were coming from the user. This can be either a specific item value or a value derived from a JavaScript expression. Select the ap'
||'propriate option based on the source of the initial input to the assistant.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1417418145033941)
,p_plugin_attribute_id=>wwv_flow_imp.id(1417159579033036)
,p_display_sequence=>10
,p_display_value=>'Item'
,p_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1417822358040167)
,p_plugin_attribute_id=>wwv_flow_imp.id(1417159579033036)
,p_display_sequence=>20
,p_display_value=>'JavaScript Expression'
,p_return_value=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1419294657050607)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1417159579033036)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_attribute_group_id=>wwv_flow_imp.id(1413600130012844)
,p_help_text=>'Enter a page item used to set the initial prompt. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1419532292059594)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Displayed Message'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1417159579033036)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_attribute_group_id=>wwv_flow_imp.id(1413600130012844)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text to be displayed as the initial prompt message. Note that this displayed text can be different from the complete content provided by the item. This allows for a more user-friendly or context-specific message to be showcased while sti'
||'ll leveraging the full item value for processing.</p>',
'<p>The attribute supports template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2401835632731461)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Immediate Action Prompt'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1417159579033036)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_attribute_group_id=>wwv_flow_imp.id(1413600130012844)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Summarize the provided text.</p>',
'<p>Translate this text into German.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a prompt that is used in conjunction with the ''Initial Prompt'' to display an immediate AI-generated response for the end user.</p>',
'<p>The attribute supports template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1419840706063544)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'JavaScript Expression'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1417159579033036)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_attribute_group_id=>wwv_flow_imp.id(1413600130012844)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Using a page item value</p>',
'<pre>',
'apex.items.P1_NAME.value + " " + apex.items.P1_DESCRIPTION.value',
'</pre>',
'',
'<p>Using the values from page items to construct an object that contains both the full and displayed content</p>',
'<pre>',
'{',
'    fullContent: "Product Name: " + apex.items.P1_NAME.value + "\n Product Description: " + apex.items.P1_DESCRIPTION.value, // Message sent to AI service',
'    content: "Product Information", // Optional message displayed if different from fullContent',
'    type: "text", // Optional type to render content as: text (default), markdown or html',
'    commit: false // Optional flag to immediately send the message to the AI service. Defaults to ''false''',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a JavaScript Expression that will evaluate to the initial prompt. The expression can return either a string or a JavaScript object.</p>',
'<p>The code has access to the following dynamic action related attributes:</p>',
'',
'<dl>',
'  <dt>this.triggeringElement</dt>',
'    <dd>A reference to the DOM object of the element that triggered the dynamic action.</dd>',
'  <dt>this.browserEvent</dt>',
'    <dd>The event object that triggered the event. Note: On load this is equal to ''load''.</dd>',
'  <dt>this.data</dt>',
'    <dd>Optional additional data that can be passed from the event handler.</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1420121450068327)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1414078813012844)
,p_null_text=>'None'
,p_help_text=>'Select how the AI Assistant should return responses. The term ''response'' refers to the message content of an individual chat message. You have the option to capture this response directly into a page item value or to process it based on more complex '
||'logic using JavaScript Code.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1420447096069087)
,p_plugin_attribute_id=>wwv_flow_imp.id(1420121450068327)
,p_display_sequence=>10
,p_display_value=>'Item'
,p_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1420876638070502)
,p_plugin_attribute_id=>wwv_flow_imp.id(1420121450068327)
,p_display_sequence=>20
,p_display_value=>'JavaScript Code'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1421325881074376)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1420121450068327)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_attribute_group_id=>wwv_flow_imp.id(1414078813012844)
,p_help_text=>'Select a page item as the destination for the response value that the AI Assistant returns.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1421616976079154)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'JavaScript Code'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1420121450068327)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_attribute_group_id=>wwv_flow_imp.id(1414078813012844)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Assign the response value to a page item</p>',
'<pre>',
'apex.items.P1_RESPONSE.value = this;',
'</pre>',
'',
'<p>Call the custom <code>myFunctionToProcessResponse</code> JavaScript function to process the response value in the application.</p>',
'<pre>',
'const response = this;',
'myFunctionToProcessResponse( response );',
'</pre>'))
,p_help_text=>'Enter the JavaScript Code to manage the processing of the response value returned by the AI Assistant. Use ''this'' to access the message content, which is provided as a string.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1421936707084348)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Button Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>80
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1420121450068327)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_attribute_group_id=>wwv_flow_imp.id(1414078813012844)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the label for the message action button, which is used to send the response to a designated target. The default label is ''Use this''. Customize this label to better suit the action''s purpose or context.</p>',
'<p>The attribute supports template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1422221010088282)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'JavaScript Detection Expression'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1420121450068327)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_attribute_group_id=>wwv_flow_imp.id(1414078813012844)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Only show the ''Use this'' quick action button on messages which contain the phrase ''recipe'' and return the whole message in such cases.</p>',
'<pre>',
'this.fullContent.toLowerCase().includes( "recipe" ) ? this.fullContent : ""',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a JavaScript Expression to search for certain criteria within the message, like finding a specific piece of text. This expression should return the text to be used in the response. Additionally, the result of this expression determines if a '
||'quick action button is displayed on the message. If the expression returns a value, the button will be made visible.</p>',
'<p>Use ''this'' to access the message content object.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2003999650451479)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Message 1'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>400
,p_is_translatable=>true
,p_attribute_group_id=>wwv_flow_imp.id(2003303289447764)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a message to serve as a chat-wide quick action. A quick action is a pre-defined phrase that, once clicked, will be sent as a user message.</p>',
'<p>The attribute supports template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2004268551454391)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Message 2'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(2003999650451479)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_attribute_group_id=>wwv_flow_imp.id(2003303289447764)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a message to serve as a chat-wide quick action. A quick action is a pre-defined phrase that, once clicked, will be sent as a user message.</p>',
'<p>The attribute supports template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(1412134716001530)
,p_plugin_id=>wwv_flow_imp.id(1411874327001490)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.displayAs = "DIALOG";',
'    options.initialPrompt.message = "My initial display message";',
'    options.response.buttonLabel = "Use this text";',
'',
'    options.useChatContext = ( chat, chatView ) => {',
'        console.log( "useChatContext", chat, chatView );',
'    };',
'',
'    options.view.title = "My dialog title";',
'    options.view.quickActions.push( {',
'        title: "My new Quick Action",',
'        message: "Description of new Quick Action"',
'    } );',
'',
'    return options;',
'}',
'</pre>'))
,p_help_text=>'Enter a JavaScript function that takes a configuration object for the AI Assistant, modifies the object, and returns it. This allows advanced customization of the assistant appearance, features, and behavior.'
);
end;
/
prompt --application/shared_components/plugins/region_type/search_region
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1490801048649253)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SEARCH_REGION'
,p_display_name=>'Search'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SEARCH_REGION'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.search#MIN#.js'
,p_api_version=>1
,p_standard_attributes=>'AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_version_scn=>1088654305
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display Search Results, based on Search Configurations, which are defined within Shared Components.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(6038497365653879)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_title=>'Appearance'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(6038850986653880)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_title=>'Sort'
,p_display_sequence=>20
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(6039225434653880)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_title=>'Pagination'
,p_display_sequence=>30
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(6039669849653881)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_title=>'Messages'
,p_display_sequence=>40
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(6040052739653881)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_title=>'Performance'
,p_display_sequence=>50
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1493694522672314)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>90
,p_static_id=>'custom_layout'
,p_prompt=>'Custom Layout'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(6038497365653879)
,p_help_text=>'Whether to use a custom template for search results, instead of the display templates specified within the Search Configuration.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1493909354677201)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>100
,p_static_id=>'result_row_template'
,p_prompt=>'Result Row Template'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1493694522672314)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6038497365653879)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Example: Template to render the default search result layout.</p>',
'<pre>',
'&lt;div class="a-ResultsItem &amp;RESULT_CSS_CLASSES!ATTR."&gt;',
'  {if ?ICON_VALUE/}',
'    {case ICON_TYPE/}',
'      {when INITIALS/}',
'        &lt;div class="a-ResultItem-initials u-color-var"&gt;&amp;ICON_VALUE.&lt;/div&gt;',
'      {when URL/}',
'        &lt;div class="a-ResultItem-image"&gt;&lt;img src="&amp;ICON_VALUE!ATTR." alt="&amp;TITLE!ATTR." role="presentation" /&gt;&lt;/div&gt;',
'      {when CLASS/}',
'        &lt;div class="a-ResultItem-icon u-color-var"&gt;&lt;span class="fa &amp;ICON_VALUE!ATTR." aria-hidden="true"&gt;&lt;/span&gt;&lt;/div&gt;',
'    {endcase/}',
'  {endif/}',
'  &lt;div class="a-ResultsItem-content"&gt;',
'    &lt;div class="a-ResultsItem-header"&gt;',
'      {if ?LINK/}',
'        &lt;span class="a-ResultsItem-title"&gt;&lt;a href="&amp;LINK!ATTR."&gt;&amp;TITLE.&lt;/a&gt;&lt;/span&gt;',
'      {else/}',
'        &lt;span class="a-ResultsItem-title"&gt;&amp;TITLE.&lt;/span&gt;',
'      {endif/}',
'      {if ?BADGE/}&lt;span class="a-ResultsItem-badge"&gt;&amp;BADGE.&lt;/span&gt;{endif/}',
'    &lt;/div&gt;',
'    {if ?SUBTITLE/}&lt;div class="a-ResultsItem-subTitle"&gt;&amp;SUBTITLE.&lt;/div&gt;{endif/}',
'    {if ?DESCRIPTION/}&lt;div class="a-ResultsItem-description"&gt;&amp;DESCRIPTION.&lt;/div&gt;{endif/}',
'    {if ?HAS_CUSTOM_ATTRS/}',
'      &lt;div class="a-ResultsItem-attributes"&gt;',
'        {if ?CUSTOM_01/}&lt;span class="a-ResultsItem-attribute"&gt;&amp;CUSTOM_01.&lt;/span&gt;{endif/}',
'        {if ?CUSTOM_02/}&lt;span class="a-ResultsItem-attribute"&gt;&amp;CUSTOM_02.&lt;/span&gt;{endif/}',
'        {if ?CUSTOM_03/}&lt;span class="a-ResultsItem-attribute"&gt;&amp;CUSTOM_03.&lt;/span&gt;{endif/}',
'      &lt;/div&gt;',
'    {endif/}',
'    {if ?LAST_MODIFIED/}&lt;div class="a-ResultsItem-misc"&gt;&amp;LAST_MODIFIED.&lt;/div&gt;{endif/}',
'  &lt;/div&gt;',
'&lt;/div&gt;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter HTML Expression to display a search result row. Use <code>&COLUMN.</code> syntax to show search result column values in HTML. Supports template directives. The following substitutions are available:',
'</p>',
'<dl>',
'<dt>TITLE</dt>',
'<dd><strong>Title</strong> column.</dd>',
'<dt>SUBTITLE</dt>',
'<dd><strong>Subtitle</strong> column.</dd>',
'<dt>PRIMARY_KEY_1</dt>',
'<dd><strong>Primary Key</strong> column.</dd>',
'<dt>PRIMARY_KEY_2</dt>',
'<dd>Second <strong>Primary Key</strong> column.</dd>',
'<dt>DESCRIPTION</dt>',
'<dd><strong>Description</strong> column.</dd>',
'<dt>BADGE</dt>',
'<dd><strong>Badge</strong> column.</dd>',
'<dt>LAST_MODIFIED</dt>',
'<dd><strong>Last Modified</strong> column. The <strong>Last Modified Format Mask</strong> will be applied to this column, if specified.</dd>',
'<dt>CUSTOM_01</dt>',
'<dd><strong>Custom #1</strong> column.</dd>',
'<dt>CUSTOM_02</dt>',
'<dd><strong>Custom #2</strong> column.</dd>',
'<dt>CUSTOM_03</dt>',
'<dd><strong>Custom #3</strong> column.</dd>',
'<dt>SCORE</dt>',
'<dd><strong>Score</strong> column. For Oracle TEXT Search Configurations, this will be the score returned by Oracle TEXT; other configurations allow to map a query column.</dd>',
'<dt>ICON_TYPE</dt>',
'<dd>Represents the icon type: Can be <strong>CLASS</strong>, <strong>URL</strong> or <strong>INITIALS</strong>.</dd>',
'<dt>ICON_VALUE</dt>',
'<dd>The actual icon value, depending on the value of <strong>ICON_TYPE</strong></dd>',
'<dt>RESULT_CSS_CLASSES</dt>',
'<dd>The CSS classes to be applied to each row, based on the <strong>Result CSS Classes</strong> Search Configuration attribute.</dd>',
'<dt>LINK</dt>',
'<dd>The <strong>link</strong> being specified in the search configuration.</dd>',
'<dt>CONFIG_ID</dt>',
'<dd>Internal ID of the search configuration.</dd>',
'<dt>CONFIG_LABEL</dt>',
'<dd>Label of the search configuration.</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2200830996346302)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_static_id=>'search_as_you_type'
,p_prompt=>'Search as You Type'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'When enabled, the search is executed as you type in the search field. Otherwise the search is not executed until the user presses Enter or a button.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1495375982688519)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_static_id=>'search_page_item'
,p_prompt=>'Search Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Reference the page item for end users to type their searches in.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1495648084691809)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_static_id=>'show_result_count'
,p_prompt=>'Show Result Count'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(6039225434653880)
,p_examples=>'#totalRowCountSpan'
,p_help_text=>'Specify where to display the search results row count.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1495930256693393)
,p_plugin_attribute_id=>wwv_flow_imp.id(1495648084691809)
,p_display_sequence=>10
,p_display_value=>'Yes'
,p_return_value=>'Y'
,p_help_text=>'The total row count is displayed at the top of the search region.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1496327088694270)
,p_plugin_attribute_id=>wwv_flow_imp.id(1495648084691809)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'The total row count is not displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1496736670696793)
,p_plugin_attribute_id=>wwv_flow_imp.id(1495648084691809)
,p_display_sequence=>30
,p_display_value=>'Selector'
,p_return_value=>'E'
,p_help_text=>'The search results row count (without any label) is displayed within the element specified by this selector. This allows you to place the total row count just about anywhere on the page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1497192080700085)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_static_id=>'result_count_selector'
,p_prompt=>'Result Count Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1495648084691809)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_attribute_group_id=>wwv_flow_imp.id(6039225434653880)
,p_examples=>'#totalRowCountSpan'
,p_help_text=>'This is the selector of an element on the page where the search region will display the total results count.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1497429151701470)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_static_id=>'overall_sort'
,p_prompt=>'Overall Sort'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(6038850986653880)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Search results are returned in the order they appear on the Search Configurations page. The order within each search configuration is defined on the Shared Components, Edit page. To override the default order, select a column from the list.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1497777172702846)
,p_plugin_attribute_id=>wwv_flow_imp.id(1497429151701470)
,p_display_sequence=>10
,p_display_value=>'Title'
,p_return_value=>'TITLE'
,p_help_text=>'Order results by Title.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1498138078704478)
,p_plugin_attribute_id=>wwv_flow_imp.id(1497429151701470)
,p_display_sequence=>20
,p_display_value=>'Subtitle'
,p_return_value=>'SUBTITLE'
,p_help_text=>'Order results by Subtitle.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1498503446706961)
,p_plugin_attribute_id=>wwv_flow_imp.id(1497429151701470)
,p_display_sequence=>30
,p_display_value=>'Last Modified'
,p_return_value=>'LAST_MODIFIED'
,p_help_text=>'Order results by the Last Modified date.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1498931451708226)
,p_plugin_attribute_id=>wwv_flow_imp.id(1497429151701470)
,p_display_sequence=>40
,p_display_value=>'Badge'
,p_return_value=>'BADGE'
,p_help_text=>'Order results by the Badge.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1499379182709511)
,p_plugin_attribute_id=>wwv_flow_imp.id(1497429151701470)
,p_display_sequence=>50
,p_display_value=>'Custom Column 1'
,p_return_value=>'CUSTOM_01'
,p_help_text=>'Order results by custom column #1.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1499779268710835)
,p_plugin_attribute_id=>wwv_flow_imp.id(1497429151701470)
,p_display_sequence=>60
,p_display_value=>'Custom Column 2'
,p_return_value=>'CUSTOM_02'
,p_help_text=>'Order results by custom column #2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1500157956711994)
,p_plugin_attribute_id=>wwv_flow_imp.id(1497429151701470)
,p_display_sequence=>70
,p_display_value=>'Custom Column 3'
,p_return_value=>'CUSTOM_03'
,p_help_text=>'Order results by custom column #3.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1501998091720876)
,p_plugin_attribute_id=>wwv_flow_imp.id(1497429151701470)
,p_display_sequence=>80
,p_display_value=>'Search Score / Rank'
,p_return_value=>'SCORE'
,p_help_text=>'Order by the "Score", which is returned by Oracle TEXT.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1500835682715923)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>130
,p_static_id=>'sort_direction'
,p_prompt=>'Sort Direction'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ASC'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1497429151701470)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(6038850986653880)
,p_help_text=>'Specify whether overall sorting should be done in ascending or descending order.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1501152309717127)
,p_plugin_attribute_id=>wwv_flow_imp.id(1500835682715923)
,p_display_sequence=>10
,p_display_value=>'Ascending'
,p_return_value=>'ASC'
,p_help_text=>'Sort in ascending order.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1501594257718257)
,p_plugin_attribute_id=>wwv_flow_imp.id(1500835682715923)
,p_display_sequence=>20
,p_display_value=>'Descending'
,p_return_value=>'DESC'
,p_help_text=>'Sort in descending order.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2001000326874972)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>110
,p_static_id=>'last_modified_format_mask'
,p_prompt=>'Last Modified Format Mask'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(6038497365653879)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Example format masks with results for the date of <strong>January 12th, 2022 14:30</strong>:</p>',
'<dl>',
'<dt>DD-MON-YY</dt>',
'<dd>12-JAN-22</dd>',
'<dt>DD-MON-YYYY</dt>',
'<dd>12-JAN-2022</dd>',
'<dt>YYYY-MM-DD</dt>',
'<dd>2022-01-12</dd>',
'<dt>DD-MON-YYYY HH24:MI</dt>',
'<dd>2022-01-12 14:30</dd>',
'<dt>DD-MON-YYYY HH:MIAM</dt>',
'<dd>2022-01-12 02:30PM</dd>',
'<dt>SINCE</dt>',
'<dd>6 months ago</dd>',
'</dl>'))
,p_help_text=>'Provide the format mask to use for displaying the <strong>Last Modified</strong> attribute of a search result. Values are returned as the <strong>TIMESTAMP WITH LOCAL TIME ZONE</strong> data type.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2600216996081210)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>62
,p_static_id=>'lazy_loading'
,p_prompt=>'Lazy Loading'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(6040052739653881)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to load the region independently of the data for the region.</p>',
'        <p> When lazy loading is enabled, the page renders immediately, showing an empty region until the data loads. Generally, the page does not display until the entire page loads and is ready to be rendered. For example, if it takes 5 seconds to '
||'load all of the data for a region, without lazy loading, the end user would have to wait 5 seconds before the page started to render.</p>',
'        <p>Note - Lazy Loading should only be utilized on data sets that take significant time to load, as this adds unnecessary processing overhead on the database for regions that load quickly.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2202955359391456)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>60
,p_static_id=>'minimum_characters'
,p_prompt=>'Minimum Characters'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2200830996346302)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>'Specify the minimum number of characters required in the search term before the search will be executed. This can be useful to reduce the amount of searching done when queries are expensive.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2203295596392516)
,p_plugin_attribute_id=>wwv_flow_imp.id(2202955359391456)
,p_display_sequence=>10
,p_display_value=>'No minimum (0)'
,p_return_value=>'0'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2203698679393998)
,p_plugin_attribute_id=>wwv_flow_imp.id(2202955359391456)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2204062323394411)
,p_plugin_attribute_id=>wwv_flow_imp.id(2202955359391456)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2204479602394864)
,p_plugin_attribute_id=>wwv_flow_imp.id(2202955359391456)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2204831359395291)
,p_plugin_attribute_id=>wwv_flow_imp.id(2202955359391456)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2205293153395812)
,p_plugin_attribute_id=>wwv_flow_imp.id(2202955359391456)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3800442090961681)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>310
,p_static_id=>'no_query_entered_message'
,p_prompt=>'No Query Entered Message'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_attribute_group_id=>wwv_flow_imp.id(6039669849653881)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Simple Message</dt>',
'<dd><pre>Please enter a query to search.</pre>',
'<dt>Message with icon</dt>',
'<dd><pre>&lt;span class="fa fa-search"&gt;&lt;/span&gt; Please enter a query to search.',
'</dl>'))
,p_help_text=>'<p>Enter a message to show when no query was entered, and no Search Source has the <strong>Use as Initial Result</strong> switch enabled.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(4429457074397525)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>67
,p_static_id=>'results_per_page'
,p_prompt=>'Results per Page'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(6044532678673702)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(6039225434653880)
,p_help_text=>'Denotes the amount of results being shown on each page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(5400253924694729)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>65
,p_static_id=>'use_pagination'
,p_prompt=>'Use Pagination'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(6039225434653880)
,p_help_text=>'Whether to use pagination for displaying search results.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(7205377779533047)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>320
,p_static_id=>'no_results_found_message'
,p_prompt=>'No Results Found Message'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_attribute_group_id=>wwv_flow_imp.id(6039669849653881)
,p_help_text=>'Enter a message to display when no results are found. If specified, messages defined in the <em>Search Configurations</em> are ignored.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(6044532678673702)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>66
,p_static_id=>'results_per_page_type'
,p_prompt=>'Results per Page Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(5400253924694729)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(6039225434653880)
,p_help_text=>'Select how the number of results per page is determined.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(6044953406674587)
,p_plugin_attribute_id=>wwv_flow_imp.id(6044532678673702)
,p_display_sequence=>10
,p_display_value=>'Static Value'
,p_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(6045396836675643)
,p_plugin_attribute_id=>wwv_flow_imp.id(6044532678673702)
,p_display_sequence=>20
,p_display_value=>'Based on Item Value'
,p_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(6047101110690759)
,p_plugin_id=>wwv_flow_imp.id(1490801048649253)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>69
,p_static_id=>'search_item'
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(6044532678673702)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_attribute_group_id=>wwv_flow_imp.id(6039225434653880)
,p_help_text=>'Select the item whose value specifies the number of results to display per page.'
);
end;
/
prompt --application/shared_components/plugins/process_type/create_task
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1548334208231855)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CREATE_TASK'
,p_display_name=>'Human Task - Create'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CREATE_TASK'),'')
,p_api_version=>2
,p_standard_attributes=>'REGION:WAIT_FOR_COMPLETION'
,p_substitute_attributes=>true
,p_version_scn=>102113216
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process creates a human task using an existing task definition from the application.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1548544126233880)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Definition'
,p_attribute_type=>'TASK DEFINITION ID'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_help_text=>'The Task Definition contains the settings of a human task. It includes the Task Subject, Priority, Due Date, Participants, Parameters and Actions defined for a Human Task. The Subject and Priority attributes can be overridden when creating an instanc'
||'e of human task based on the task definition.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1759133543712618)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Subject'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_help_text=>'The Task Subject which summarizes the purpose of the task. This field can be used to override the subject of the task specified at the task definition level.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2304381637210307)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Priority'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_help_text=>'The priority of the task. 1 - Urgent - 2 - High, 3 -Medium (also the default) and 4 -Low and 5 - Lowest Priority. This field, when provided, overrides the priority defined at the task definition level.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1789709843766139)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Task ID Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_show_in_wizard=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_help_text=>'The page item where the ID of the newly created task instance can be stored.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1500226523064919)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Details Primary Key  Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_show_in_wizard=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_help_text=>'The page item pointing to the Primary Key of the system of records for which this task is defined.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1651913286799933)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>35
,p_prompt=>'Initiator Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_TASKDEF_ACTIONS:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_help_text=>'The ID of the user initiating the task. When not specified, this value defaults to the current logged in user.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(46424725262312828)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Due Date Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_is_translatable=>false
,p_help_text=>'An optional Page Item representing the Due Date of the Task. When specified, this value overrides the Due Date provided in the Task Definition this Task is based on.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3600261672057830)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Outcome'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_help_text=>'An (optional) attribute to store the Workflow Variable item to which the outcome of this task will be saved when the task is Approved or Rejected. This is applicable only when the task is being used as a Workflow Activity.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3800234644059876)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Owner'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_help_text=>'An (optional) attribute to store the Workflow Variable item to which the actual owner of this task will be saved when the task is Completed. This is applicable only when the task is being used as a Workflow Activity.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1602077230888001)
,p_plugin_id=>wwv_flow_imp.id(1548334208231855)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>32
,p_prompt=>'Initiator Can Complete'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Specify if an initiator can approve or reject the task.</p><p>Choose <strong>on</strong> to allow task initiators to approve or reject the task.</p><p>Choose <strong>off</strong> to prohibit the initiator from completing the task.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1915425894753034)
,p_plugin_attribute_id=>wwv_flow_imp.id(1602077230888001)
,p_display_sequence=>10
,p_display_value=>'Yes'
,p_return_value=>'Y'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1916161723758502)
,p_plugin_attribute_id=>wwv_flow_imp.id(1602077230888001)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
);
end;
/
prompt --application/shared_components/plugins/process_type/workflow_switch
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1601183310005109)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WORKFLOW_SWITCH'
,p_display_name=>'Switch'
,p_supported_component_types=>'APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WORKFLOW_SWITCH'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472647
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process supports condition-based evaluation to arrive at a certain outcome. It can be used in a workflow activity to decide the next activity based on certain conditions.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1516565068428361)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_title=>'Switch'
,p_display_sequence=>5
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1516290582428360)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_title=>'Compare'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1516906516428362)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_title=>'Condition'
,p_display_sequence=>20
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1601623612045930)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TRUE_FALSE_CHECK'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1516565068428361)
,p_help_text=>'Select the type of switch.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1601961198053629)
,p_plugin_attribute_id=>wwv_flow_imp.id(1601623612045930)
,p_display_sequence=>10
,p_display_value=>'True False Check'
,p_return_value=>'TRUE_FALSE_CHECK'
,p_is_quick_pick=>true
,p_help_text=>'Based on the result of a single condition that returns a boolean (Workflow Variable = value, Row (not) Exists, Expression, Function Call result).'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1602322190060527)
,p_plugin_attribute_id=>wwv_flow_imp.id(1601623612045930)
,p_display_sequence=>20
,p_display_value=>'Check Workflow Variable'
,p_return_value=>'CHECK_WF_VARIABLE'
,p_help_text=>'Based on the value of a Workflow Variable, the different branches perform a comparison against that value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1602740596063332)
,p_plugin_attribute_id=>wwv_flow_imp.id(1601623612045930)
,p_display_sequence=>30
,p_display_value=>'Case'
,p_return_value=>'CASE'
,p_help_text=>'Based on the result of a computation (Workflow Variable, SQL query result, Function Call result), the different branches perform a comparison against that value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1603127738067636)
,p_plugin_attribute_id=>wwv_flow_imp.id(1601623612045930)
,p_display_sequence=>40
,p_display_value=>'If Elsif Else'
,p_return_value=>'IF_ELSE'
,p_help_text=>'If the conditions in the different branches are more complex, use If Elsif Else to perform AND/OR comparison between the conditions.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1603542889081910)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Data Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1601623612045930)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CASE'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1516290582428360)
,p_help_text=>'The data type of the result of the CASE expression. The result of the CASE expression from the code editor is always expected to be a varchar2, and the data type is applied only at runtime when the case statement is being executed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1603806900083006)
,p_plugin_attribute_id=>wwv_flow_imp.id(1603542889081910)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1604272004083857)
,p_plugin_attribute_id=>wwv_flow_imp.id(1603542889081910)
,p_display_sequence=>20
,p_display_value=>'NUMBER'
,p_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1604653969084783)
,p_plugin_attribute_id=>wwv_flow_imp.id(1603542889081910)
,p_display_sequence=>30
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
,p_help_text=>'The result of the case expression should be either ''Y'' or ''N'' or null.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1605016806088371)
,p_plugin_attribute_id=>wwv_flow_imp.id(1603542889081910)
,p_display_sequence=>40
,p_display_value=>'TIMESTAMP'
,p_return_value=>'TIMESTAMP'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4413952235457113)
,p_plugin_attribute_id=>wwv_flow_imp.id(1603542889081910)
,p_display_sequence=>50
,p_display_value=>'TIMESTAMP WITH TIME ZONE'
,p_return_value=>'TIMESTAMP_TZ'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4414307727458660)
,p_plugin_attribute_id=>wwv_flow_imp.id(1603542889081910)
,p_display_sequence=>60
,p_display_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_return_value=>'TIMESTAMP_LTZ'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1605831825467805)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Condition Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROWS_RETURNED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1601623612045930)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TRUE_FALSE_CHECK'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1516906516428362)
,p_help_text=>'The condition types in a True False Check Switch.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1606116509483507)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_display_sequence=>10
,p_display_value=>'Rows Returned'
,p_return_value=>'ROWS_RETURNED'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1606584525485091)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_display_sequence=>20
,p_display_value=>'Rows Not Returned'
,p_return_value=>'ROWS_NOT_RETURNED'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1606976277486967)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_display_sequence=>30
,p_display_value=>'Expression'
,p_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1607312032488952)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_display_sequence=>40
,p_display_value=>'Function Body'
,p_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1607742757491812)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_display_sequence=>50
,p_display_value=>'Workflow Variable = Value'
,p_return_value=>'WF_VARIABLE_EQ_VAL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1608152954493776)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_display_sequence=>60
,p_display_value=>'Workflow Variable != Value'
,p_return_value=>'WF_VARIABLE_NEQ_VAL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1608555619495718)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_display_sequence=>70
,p_display_value=>'Workflow Variable is NULL'
,p_return_value=>'WF_VARIABLE_NULL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1608904446497592)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_display_sequence=>80
,p_display_value=>'Workflow Variable is NOT NULL'
,p_return_value=>'WF_VARIABLE_NOT_NULL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1609534637529603)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ROWS_RETURNED,ROWS_NOT_RETURNED'
,p_attribute_group_id=>wwv_flow_imp.id(1516906516428362)
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1609893115536678)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Expression'
,p_attribute_type=>'PLSQL EXPRESSION BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EXPRESSION'
,p_attribute_group_id=>wwv_flow_imp.id(1516906516428362)
,p_help_text=>'SQL or PLSQL Expression that returns a Boolean Value in a True False Check switch.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1610149847546886)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Language'
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'EXPRESSION,FUNCTION_BODY'
,p_attribute_group_id=>wwv_flow_imp.id(1516906516428362)
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1610410196549376)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Function Body'
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_attribute_group_id=>wwv_flow_imp.id(1516906516428362)
,p_help_text=>'PLSQL Function Body that returns a Boolean Value in a True False Check switch.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1610710441556198)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Workflow Variable'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'WF_VARIABLE_NULL,WF_VARIABLE_NOT_NULL,WF_VARIABLE_EQ_VAL,WF_VARIABLE_NEQ_VAL'
,p_attribute_group_id=>wwv_flow_imp.id(1516906516428362)
,p_help_text=>'The Workflow Variable to be compared in Check Workflow Variable or True False Check switches.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1611021111718423)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Compare Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL_QUERY'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1601623612045930)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CASE'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1516290582428360)
,p_help_text=>'The type of the CASE condition.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1611301733719745)
,p_plugin_attribute_id=>wwv_flow_imp.id(1611021111718423)
,p_display_sequence=>10
,p_display_value=>'SQL Query'
,p_return_value=>'SQL_QUERY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1611732873720976)
,p_plugin_attribute_id=>wwv_flow_imp.id(1611021111718423)
,p_display_sequence=>20
,p_display_value=>'Expression'
,p_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1612181403722279)
,p_plugin_attribute_id=>wwv_flow_imp.id(1611021111718423)
,p_display_sequence=>30
,p_display_value=>'Function Body'
,p_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1612776795732007)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Compare Variable'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1601623612045930)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CHECK_WF_VARIABLE'
,p_attribute_group_id=>wwv_flow_imp.id(1516290582428360)
,p_help_text=>'The Workflow Variable used for the comparison.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1613088353755805)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Compare Query'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1611021111718423)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_attribute_group_id=>wwv_flow_imp.id(1516290582428360)
,p_help_text=>'SQL Query used to specify the condition in a Case Switch.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1613360118768421)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Compare Expression'
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1611021111718423)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EXPRESSION'
,p_attribute_group_id=>wwv_flow_imp.id(1516290582428360)
,p_help_text=>'Expression used in a Case Switch.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1613635808777161)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Compare Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1611021111718423)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_attribute_group_id=>wwv_flow_imp.id(1516290582428360)
,p_help_text=>'Function Body used to specify the condition in a Case switch.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1613978574853767)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1605831825467805)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'WF_VARIABLE_EQ_VAL,WF_VARIABLE_NEQ_VAL'
,p_attribute_group_id=>wwv_flow_imp.id(1516906516428362)
,p_help_text=>'The Value to be compared against a Workflow Variable in True False Check or Check Workflow Variable switches. If the Workflow Variable has a format mask specified, it is expected that the compare value is also formatted according to the same mask.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2002137418421276)
,p_plugin_id=>wwv_flow_imp.id(1601183310005109)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Compare Language'
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1611021111718423)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'EXPRESSION,FUNCTION_BODY'
,p_attribute_group_id=>wwv_flow_imp.id(1516290582428360)
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1602002675849340)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>'Cards'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ORDER_BY:SUPPORTS_EXTERNAL_FILTERING'
,p_substitute_attributes=>false
,p_version_scn=>72472647
,p_subscribe_plugin_settings=>true
,p_help_text=>'Report based on a SQL Query that displays data for each row in cards.  With cards, you can easily visualize the data in blocks of content.  You can customize Header, Media, Body or Actions declaratively.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(1602292184849355)
,p_plugin_id=>wwv_flow_imp.id(1602002675849340)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(633822552473663477)
,p_plugin_id=>wwv_flow_imp.id(1602002675849340)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>'Page Change'
);
end;
/
prompt --application/shared_components/plugins/process_type/execution_chain
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1603669291043434)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'EXECUTION_CHAIN'
,p_display_name=>'Execution Chain'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','EXECUTION_CHAIN'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472647
,p_subscribe_plugin_settings=>true
,p_help_text=>'Execute a sequence of page processes, either in the foreground or in the background.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1461486944563690)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_title=>'Serialization'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1604343648052038)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Run in Background'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether to execute this chain in the background.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1604635608063659)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>40
,p_prompt=>'Serialize'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1604343648052038)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(1461486944563690)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to serialize executions of this execution chain. When set to <strong>On</strong>, all executions (from all APEX sessions) with the same <strong>Context Value</strong> will be serialized, to avoid concurrent executions in the backgr'
||'ound. An execution with a NULL context value will block executions regardless of the context value, and a new execution with a NULL context value will only run, if <em>no other execution</em> of this process is running.</p>',
'<p> Use this setting when processes of this chain are likely to work on the same resources, for instance, performing DML on the same row in a table.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1604929538071687)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Return ID into Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1604343648052038)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Choose a page item to return the execution ID into. Based on the execution ID, the current status of the background execution can be fetched.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1605279278074176)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>60
,p_prompt=>'Temporary File Handling'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1604343648052038)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To execute this chain in the background, &PRODUCT_NAME. clones the current APEX session; and all background executions will work with the session clone.</p>',
'<p>Determine how to deal with temporary files, uploaded through a <strong>File Browse</strong> page item.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1605593771077410)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605279278074176)
,p_display_sequence=>10
,p_display_value=>'Ignore'
,p_return_value=>'IGNORE'
,p_help_text=>'Neither move nor copy temporary files to the <em>working session</em> for background execution. Choose this option if the background processes will not work with uploaded files.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1605949077078549)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605279278074176)
,p_display_sequence=>20
,p_display_value=>'Move'
,p_return_value=>'MOVE'
,p_help_text=>'Move temporary files to the <em>working session</em> for background execution. Choose this option if access to temporary files is only needed by <em>one</em> background execution chain.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1606398394079365)
,p_plugin_attribute_id=>wwv_flow_imp.id(1605279278074176)
,p_display_sequence=>30
,p_display_value=>'Copy'
,p_return_value=>'COPY'
,p_help_text=>'Copy temporary files to the <em>working session</em> for background execution. Choose this option  if you have multiple background execution chains, and all of them require access to the temporary files.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1607812256110222)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>'Temporary File Items'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1605279278074176)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'MOVE,COPY'
,p_help_text=>'Specify a list of page items to move or copy to the session clone for this background execution. If nothing is selected, all temporary files are affected.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1608115916120274)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>'Executions Limit'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1604343648052038)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'If an execution limit is specified, &PRODUCT_NAME. will raise an error message, if an application user requests more than the specified limit of background executions within the current session. For instance, if a value of <strong>3</strong> is speci'
||'fied, end users see an error message when attempting to submit the fourth background execution. This is useful to prevent users from submitting large amounts of background executions to the server.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1383441235481930)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>30
,p_prompt=>'Context Value Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1604343648052038)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Pick a page item containing a <em>Context Value</em> to be passed to the background execution. The context value is available in the <strong>APEX_APPL_PAGE_BG_PROC_STATUS</strong> view, as well as in the record returned from <strong>APEX_BACKGROUN'
||'D_PROCESS.GET_EXECUTION</strong>.</p>',
'<p>When the <strong>Serialize</strong> switch is enabled, the context value will be used as the <em>mutex</em> for serialization, which means that executions with the same context value have to wait for each other, while executions with different con'
||'text values can run in parallel.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1383788116475849)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>50
,p_prompt=>'When Already Running'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'WAIT'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1604635608063659)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1461486944563690)
,p_help_text=>'Specify the behavior when a background execution is added, while another execution with the same or a NULL <em>context value</em> is already running.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1384062064473544)
,p_plugin_attribute_id=>wwv_flow_imp.id(1383788116475849)
,p_display_sequence=>10
,p_display_value=>'Wait'
,p_return_value=>'WAIT'
,p_help_text=>'The execution will wait until previous executions have finished.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1384439479470970)
,p_plugin_attribute_id=>wwv_flow_imp.id(1383788116475849)
,p_display_sequence=>20
,p_display_value=>'Error'
,p_return_value=>'ERROR'
,p_help_text=>'If an execution with the same context value is already running, an error is raised.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1384915422456178)
,p_plugin_id=>wwv_flow_imp.id(1603669291043434)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Submit Immediately'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1604343648052038)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Enable this switch if the background process should be submitted for execution <em>immediately</em>, outside of the current transaction. If the current transaction is rolled back, the submitted execution remains in the queue. When disabled, the backg'
||'round process submission will be part of the current transaction.'
);
end;
/
prompt --application/shared_components/plugins/region_type/workflow_diagram
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1611646412474411)
,p_plugin_type=>'REGION TYPE'
,p_name=>'WORKFLOW_DIAGRAM'
,p_display_name=>'Workflow Diagram'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','WORKFLOW_DIAGRAM'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>54991876
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a read-only Workflow Diagram showing the progress and activities completed.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1613052446502570)
,p_plugin_id=>wwv_flow_imp.id(1611646412474411)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'workflow_id'
,p_prompt=>'Workflow ID'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'<p>Page Item that holds the ID value of the <i>Workflow Instance</i> to be displayed.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1613349357585968)
,p_plugin_id=>wwv_flow_imp.id(1611646412474411)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'enable_navigator'
,p_prompt=>'Enable Navigator'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Displays a button in the toolbar which controls the showing/hiding of the navigator.<br>',
'The navigator is a minimap which displays a small version of the whole diagram in the corner of the region.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1615535069704772)
,p_plugin_id=>wwv_flow_imp.id(1611646412474411)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'initial_zoom'
,p_prompt=>'Initial Zoom'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>The initial zoom level of the diagram.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3156106365285389)
,p_plugin_attribute_id=>wwv_flow_imp.id(1615535069704772)
,p_display_sequence=>10
,p_display_value=>'Zoom to Fit'
,p_return_value=>'0'
,p_help_text=>'Tries to fit the route into the visible viewport by zooming out if necessary. If there is no route, it tries to fit the whole diagram.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2880825766077845)
,p_plugin_attribute_id=>wwv_flow_imp.id(1615535069704772)
,p_display_sequence=>20
,p_display_value=>'50%'
,p_return_value=>'50'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2882854365072344)
,p_plugin_attribute_id=>wwv_flow_imp.id(1615535069704772)
,p_display_sequence=>30
,p_display_value=>'100%'
,p_return_value=>'100'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2884842200066935)
,p_plugin_attribute_id=>wwv_flow_imp.id(1615535069704772)
,p_display_sequence=>40
,p_display_value=>'150%'
,p_return_value=>'150'
);
end;
/
prompt --application/shared_components/plugins/process_type/workflow_wait
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1614625387223803)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WORKFLOW_WAIT'
,p_display_name=>'Wait'
,p_supported_component_types=>'APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WORKFLOW_WAIT'),'')
,p_api_version=>2
,p_standard_attributes=>'WAIT_FOR_COMPLETION'
,p_substitute_attributes=>true
,p_version_scn=>72472647
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process pauses the execution of the workflow in which this process has been added as an activity. The Workflow resumes execution when the timeout specified by the process attributes, elapses, or when <strong>APEX_WORKFLOW.CONTINUE_ACTIVITY()</strong>'
||' procedure is called.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1615291303268453)
,p_plugin_id=>wwv_flow_imp.id(1614625387223803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Timeout Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1615565365269995)
,p_plugin_attribute_id=>wwv_flow_imp.id(1615291303268453)
,p_display_sequence=>10
,p_display_value=>'Static'
,p_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1615906592270943)
,p_plugin_attribute_id=>wwv_flow_imp.id(1615291303268453)
,p_display_sequence=>20
,p_display_value=>'SQL Query'
,p_return_value=>'SQL_QUERY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1616356283271628)
,p_plugin_attribute_id=>wwv_flow_imp.id(1615291303268453)
,p_display_sequence=>30
,p_display_value=>'Expression'
,p_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1616715634272393)
,p_plugin_attribute_id=>wwv_flow_imp.id(1615291303268453)
,p_display_sequence=>40
,p_display_value=>'Function Body'
,p_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1617141988276474)
,p_plugin_id=>wwv_flow_imp.id(1614625387223803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1615291303268453)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1617484743280653)
,p_plugin_id=>wwv_flow_imp.id(1614625387223803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Expression'
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1615291303268453)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1617776056283525)
,p_plugin_id=>wwv_flow_imp.id(1614625387223803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Function Body'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1615291303268453)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1618030324286558)
,p_plugin_id=>wwv_flow_imp.id(1614625387223803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Static Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1615291303268453)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>'PT2M, PT4H, P2DT5H, P3W'
,p_help_text=>'Enter the timeout value in ISO or SQL Duration format. For example, PT2M implies that the Wait Activity will time out after 2 Minutes. P2W implies that the Wait Activity will time out after 2 Weeks.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1618391791289723)
,p_plugin_id=>wwv_flow_imp.id(1614625387223803)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Language'
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPL_WORKFLOW_ACTIVITIES'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1615291303268453)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'EXPRESSION,FUNCTION_BODY'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1677862467038200)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>55031458
,p_subscribe_plugin_settings=>true
,p_help_text=>'Use a REST service as a REST Data Source.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1901267720643867)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Pagination Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'No Pagination'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1901523910653468)
,p_plugin_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_display_sequence=>10
,p_display_value=>'Page Size and Fetch Offset'
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Flexible pagination where the REST API allows to request a specific set of rows, using <em>page size</em> and <em>offset</em> ("start at row") parameters. URL typically look like the following example, which skips <strong>20</strong> and fetches t'
||'he next <strong>100</strong> rows:</p>',
'<pre>',
'http://hostname.example.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1901988519660109)
,p_plugin_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_display_sequence=>20
,p_display_value=>'Page Size and Page Number'
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Pagination where the REST API allows to request a set of rows, using <em>page size</em> and <em>page number</em> parameters. URLs typically look like the following example which requests page number <strong>2</strong> with a page size of <strong>1'
||'00</strong>, which leads to rows 101 to 200 being returned.',
'</p>',
'<pre>',
'http://hostname.example.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1902974368668773)
,p_plugin_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_display_sequence=>30
,p_display_value=>'Page Number'
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Pagination where the REST API allows to request a set of rows, using a <em>page</em> parameter. The Page Size is fixed and determined by the REST API. URLs typically look like the following example which requests page number <strong>2</strong>. If'
||' the REST API uses a fixed page size of <strong>20</strong>, rows 21 to 40 will be returned.',
'<pre>',
'http://hostname.example.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1904445073685723)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Page Size URL Parameter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide the URL parameter to specify the <em>page size</em> to be requested from the REST API. Typical values are <strong>limit</strong>, <strong>page_size</strong> or </strong>per_page</strong>.</p>',
'<p><em>Do not add this parameter within REST Data Source <strong>Parameters</strong></em>. &PRODUCT_NAME. will add it automatically when executing the HTTP request.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1904796837692405)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Page Size Maximum'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>'rows'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide the maximum amount of rows per page, which the REST API allows to fetch. &PRODUCT_NAME. will not attempt to request more rows per page.</p>',
'<p>Make sure that the REST API <em>actually returns</em> that amount of rows, since &PRODUCT_NAME. assumes a requested page to be the last page, if the response contains less rows than requested.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1905045481696652)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Page Number URL Parameter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide the URL parameter to specify the <em>Page Number</em> to request from the REST API. A typical value is <strong>page</strong>.</p>',
'<p><em>Do not add this parameter within REST Data Source <strong>Parameters</strong></em>. &PRODUCT_NAME. will add it automatically when executing the HTTP request.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1905385707699679)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Index of First Page'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Specify whether the REST API starts counting pages at index <strong>"0"</strong> or <strong>"1"</strong>.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1905636932702605)
,p_plugin_attribute_id=>wwv_flow_imp.id(1905385707699679)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>'The REST API refers to the first page as page <strong>1</strong>.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1906025829704631)
,p_plugin_attribute_id=>wwv_flow_imp.id(1905385707699679)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>'The REST API refers to the first page as page <strong>0</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1906661765710861)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Fixed Page Size'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>'rows'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide the <em>page size</em> (number of rows per page), which is determined by the REST API.</p>',
'<p>Typically this information can be found in the documentation of the REST API. Make sure to specify the correct value here: if the value is not accurate, rows will be missing or duplicated when &PRODUCT_NAME. fetches data from the REST API.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1906984049714159)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Row Offset URL Parameter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>'rows'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide the URL parameter to specify the <em>offset</em>, which denotes the rows to skip before the first row is returned.</p>',
'<p><em>Do not add this parameter within REST Data Source <strong>Parameters</strong></em>. &PRODUCT_NAME. will add it automatically when executing the HTTP request.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1907222147716823)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Row Offset Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Choose whether the <strong>Offset</strong> parameter specifies the <em>Amount of Rows to Skip</em>, or the <em>First Row to Fetch</em>.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1907577038717722)
,p_plugin_attribute_id=>wwv_flow_imp.id(1907222147716823)
,p_display_sequence=>10
,p_display_value=>'Rows to Skip'
,p_return_value=>'OFFSET'
,p_help_text=>'The offset value indicates the rows to skip. For instance, if a value of 100 is provided, the REST API returns rows starting at index 101.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1907904681718986)
,p_plugin_attribute_id=>wwv_flow_imp.id(1907222147716823)
,p_display_sequence=>20
,p_display_value=>'First Row to Fetch'
,p_return_value=>'START'
,p_help_text=>'The offset value indicates the row to start fetching at. For instance, if a value of 100 is provided, the REST API returns will skip 99 rows and start fetching at index 100.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1908579263746808)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Has More Rows Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If a REST API returns the following JSON response:</p>',
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
'The <strong>Has More Rows Selector</strong> is <strong>metadata.pagination.moreRows</strong>.',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If the response REST API returns information about whether there are additional pages, provide the <em>selector</em> to extract this attribute here.</p>',
'<p>Specifying a <strong>Has More Rows Selector</strong> is not required, but it helps &PRODUCT_NAME. to save additional HTTP requests (which would return no data) when all data has already been fetched.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1908849697751769)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Has More Rows When Value'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1908579263746808)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Choose how to interpret the value of the response attribute referenced by the <strong>Has More Rows Selector</strong>.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1909141279756289)
,p_plugin_attribute_id=>wwv_flow_imp.id(1908849697751769)
,p_display_sequence=>10
,p_display_value=>'Equals'
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>'Assume more rows to be available when the response attribute referenced by the <strong>Has More Rows Selector</strong> equals a value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1909569602757607)
,p_plugin_attribute_id=>wwv_flow_imp.id(1908849697751769)
,p_display_sequence=>20
,p_display_value=>'Is Not Null'
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>'Assume more rows to be available when the response attribute referenced by the <strong>Has More Rows Selector</strong> exists and is not empty.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1911015518771444)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Has More Rows Attribute Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1908849697751769)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>'<p>&PRODUCT_NAME. assumes more rows being available, if the response attribute referenced by the <strong>Has More Rows Selector</strong> contains this value.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1911713410779146)
,p_plugin_id=>wwv_flow_imp.id(1677862467038200)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Total Rows Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1901267720643867)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If the REST API returns the following JSON response ...</p>',
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
'... the <strong>Has More Rows Selector</strong> is <strong>metadata.pagination.totalRows</strong>.',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If the REST API returns the <em>total amount of rows</em> (across all pages) as part of the response, provide the <em>selector</em> to extract this attribute here.</p>',
'<p>Specifying a <strong>Has More Rows Selector</strong> is not required; it allows to display the total amount of rows in &PRODUCT_NAME. components, <em>as long as data is not further filtered</em>.</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/qrcode
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1685656838167223)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'QRCODE'
,p_display_name=>'QR Code'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','QRCODE'),'')
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#item.QRcode#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:SESSION_STATE_CLOB'
,p_substitute_attributes=>true
,p_version_scn=>72472649
,p_subscribe_plugin_settings=>true
,p_help_text=>'This item encodes the selected source value into a QR code and displays it.'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(11973305431150969)
,p_plugin_id=>wwv_flow_imp.id(1685656838167223)
,p_title=>'QR Code'
,p_display_sequence=>1
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11969142270203478)
,p_plugin_id=>wwv_flow_imp.id(1685656838167223)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Data Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(11973305431150969)
,p_null_text=>'Plain Text'
,p_help_text=>'Select the type of the content that this QR code contains and a corresponding prefix value is inserted in front of the selected source value to affect how the user QR Code scanner will interact with the content.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11970194046178105)
,p_plugin_attribute_id=>wwv_flow_imp.id(11969142270203478)
,p_display_sequence=>10
,p_display_value=>'URL'
,p_return_value=>'URL'
,p_help_text=>'The URL will open in a browser.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11970510391175694)
,p_plugin_attribute_id=>wwv_flow_imp.id(11969142270203478)
,p_display_sequence=>20
,p_display_value=>'Phone'
,p_return_value=>'TEL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Open the phone app with the input number.',
'',
'The phone number can contain special characters ''('' , '')'', ''+'', ''-'', ''.'', and spaces. The exact format of the phone number delegates to the phone''s locale settings.'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11970999053173151)
,p_plugin_attribute_id=>wwv_flow_imp.id(11969142270203478)
,p_display_sequence=>30
,p_display_value=>'Email'
,p_return_value=>'MAIL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Compose a new email to an email address.',
'',
'The expected format of the email address is a valid email address without leading or trailing spaces.'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11971370068169722)
,p_plugin_attribute_id=>wwv_flow_imp.id(11969142270203478)
,p_display_sequence=>40
,p_display_value=>'SMS'
,p_return_value=>'SMS'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Compose a text message to a number.',
'',
'The phone number can contain special characters ''('' , '')'', ''+'', ''-'', ''.'', and spaces. The exact format of the phone number delegates to the phone''s locale settings.'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11971729900165839)
,p_plugin_attribute_id=>wwv_flow_imp.id(11969142270203478)
,p_display_sequence=>50
,p_display_value=>'Geo location'
,p_return_value=>'MAP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Open a map application to specific coordinates.',
'',
'The expected format of the input coordinates is: ',
'',
'lattitude,longitude',
'',
'with no leading or trailing spaces.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(4553974400597934)
,p_plugin_id=>wwv_flow_imp.id(1685656838167223)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(11973305431150969)
,p_null_text=>'Default'
,p_help_text=>'<p>Sets the size of the QR code page item.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4554621421580873)
,p_plugin_attribute_id=>wwv_flow_imp.id(4553974400597934)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'a-QRCode--sm'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4555066478579976)
,p_plugin_attribute_id=>wwv_flow_imp.id(4553974400597934)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'a-QRCode--md'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4555437379579146)
,p_plugin_attribute_id=>wwv_flow_imp.id(4553974400597934)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'a-QRCode--lg'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(163831281745828967)
,p_plugin_id=>wwv_flow_imp.id(1685656838167223)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Value Protected'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specifying whether the encoded value of the QR code item is protected, preventing the value from being manipulated when the page is posted.'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_apex
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1700270759409701)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_APEX'
,p_display_name=>'Date Picker'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_APEX'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_version_scn=>72472649
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>Allows users to enter a date. For this you can either use a text field that opens a date picker as a popup, or you can use an inline or native date picker.</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1700854665409714)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Appearance & Behavior'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER:TODAY-BUTTON'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Control the appearance and behavior of the calendar used to select dates.</p>',
'<p>Note: This is only used when ''Display As'' is either ''Popup'' or ''Inline''.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1701285040409714)
,p_plugin_attribute_id=>wwv_flow_imp.id(1700854665409714)
,p_display_sequence=>10
,p_display_value=>'Show Week'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>'Whether the week of the year will be shown.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1701717134409714)
,p_plugin_attribute_id=>wwv_flow_imp.id(1700854665409714)
,p_display_sequence=>20
,p_display_value=>'Month Picker'
,p_return_value=>'MONTH-PICKER'
,p_help_text=>'Whether the month should be rendered as a button, to allow selection instead of text.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702248165409714)
,p_plugin_attribute_id=>wwv_flow_imp.id(1700854665409714)
,p_display_sequence=>30
,p_display_value=>'Year Picker'
,p_return_value=>'YEAR-PICKER'
,p_help_text=>'Whether the year should be rendered as a button, to allow selection instead of text.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2620990137063019)
,p_plugin_attribute_id=>wwv_flow_imp.id(1700854665409714)
,p_display_sequence=>40
,p_display_value=>'Paginate by Multiple Months'
,p_return_value=>'NUMBER-OF-MONTH'
,p_help_text=>'Whether the pagination size when displaying several months is only one month or the number of months.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(280966245876229655)
,p_plugin_attribute_id=>wwv_flow_imp.id(1700854665409714)
,p_display_sequence=>50
,p_display_value=>'Show Today Button'
,p_return_value=>'TODAY-BUTTON'
,p_help_text=>'Whether the today button is shown, to select the current date. The Today button is not displayed if the current day is outside min or max.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702713068409714)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Days Outside Month'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Dictates the behavior of days outside the current viewing month.</p>',
'<p>Note: This is only used when ''Display As'' is either ''Popup'' or ''Inline''.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1703117607409714)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702713068409714)
,p_display_sequence=>10
,p_display_value=>'Hidden'
,p_return_value=>'HIDDEN'
,p_help_text=>'Days outside the current viewing month will be hidden.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1703692471409714)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702713068409714)
,p_display_sequence=>20
,p_display_value=>'Selectable'
,p_return_value=>'SELECTABLE'
,p_help_text=>'Days outside the current viewing month will be visible and selectable.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1704147862409715)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702713068409714)
,p_display_sequence=>30
,p_display_value=>'Visible'
,p_return_value=>'VISIBLE'
,p_help_text=>'Days outside the current viewing month will be visible.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1700498657409712)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Time Increment'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>'minutes'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Time increment in minutes used by the time selection control. Note: This just controls the control used for selecting the time, any time outside of these increments can still be manually entered and saved.</p>',
'<p>Note: This is only used when ''Display As'' is either ''Popup'' or ''Inline'', and in addition ''Show Time'' is on.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1704671595409715)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Show On'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Controls when the calendar popup is displayed. Note: This is only used when ''Display As'' is ''Popup''.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1705083967409715)
,p_plugin_attribute_id=>wwv_flow_imp.id(1704671595409715)
,p_display_sequence=>10
,p_display_value=>'Item Focus'
,p_return_value=>'FOCUS'
,p_help_text=>'When the item receives focus or when the calendar icon is clicked.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1705557485409715)
,p_plugin_attribute_id=>wwv_flow_imp.id(1704671595409715)
,p_display_sequence=>20
,p_display_value=>'Icon Click'
,p_return_value=>'IMAGE'
,p_help_text=>'Only when the calendar icon is clicked.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1706021979409715)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Show Time'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Whether to include time information.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1716493546409717)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Display As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select the display mode for the date picker.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1716833762409717)
,p_plugin_attribute_id=>wwv_flow_imp.id(1716493546409717)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>'Calendar displays in a popup when the item receives focus, or the calendar icon is clicked.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1717347761409718)
,p_plugin_attribute_id=>wwv_flow_imp.id(1716493546409717)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'The calendar always displays inline on the page. No text field is displayed and the current date selection is shown highlighted in the calendar.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1717826139409718)
,p_plugin_attribute_id=>wwv_flow_imp.id(1716493546409717)
,p_display_sequence=>30
,p_display_value=>'Native HTML'
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Render using the native HTML input date types, if supported by the browser. When ''Show Time'' is off, this renders a ''date'' type, when ''Show Time'' is on, this renders a ''datetime-local'' type. Note: The exact display of these date types is dependent'
||' on the browser. Native HTML may be the preferred option when the app is being used on a mobile device.</p>',
'<p>Please note, when using ''Native HTML'', because the native date types are very specific about the date format they require, the item''s ''Format Mask'' will be automatically set by &PRODUCT_NAME., and you will not be able to change it. However this wi'
||'ll not be the format displayed to the end user. The end user will see the date in the format appropriate to their current locale.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1706874077409715)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Minimum Date'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify if this item has a minimum date.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1707213927409715)
,p_plugin_attribute_id=>wwv_flow_imp.id(1706874077409715)
,p_display_sequence=>10
,p_display_value=>'None'
,p_return_value=>'NONE'
,p_help_text=>'No minimum date defined.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1707787229409715)
,p_plugin_attribute_id=>wwv_flow_imp.id(1706874077409715)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
,p_help_text=>'Minimum date is derived dynamically from another item''s value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1708209073409715)
,p_plugin_attribute_id=>wwv_flow_imp.id(1706874077409715)
,p_display_sequence=>30
,p_display_value=>'Static'
,p_return_value=>'STATIC'
,p_help_text=>'Minimum date is a static value, defined as either an absolute value, or relative value to today''s date.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1715612679409717)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Minimum Static'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1706874077409715)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the minimum date that can be input or selected.</p>',
'<p>The date value can be an absolute value in <code>''YYYY-MM-DDTHH24:MI:SS''</code> or <code>''YYYYMMDDHH24MI''</code> format or a relative value with respect to today''s date, such as <code>+7d</code>, or a dynamic value using substitution syntax, provi'
||'ding the substitution returns the correct date format or relative value.</p>',
'<p>Relative date values include:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - years from today''s date</dd>',
'  <dt>m</dt>',
'    <dd>+ / - months from today''s date</dd>',
'  <dt>w</dt>',
'    <dd>+ / - weeks from today''s date</dd>',
'  <dt>d</dt>',
'    <dd>+ / - days from today''s date</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1708725443409715)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Minimum Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1706874077409715)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>'<p>The item that determines the minimum allowed value. This must be a page item that is either on the current, or global page.<p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1709194671409716)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Maximum Date'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify if this item has a maximum date.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1709506741409716)
,p_plugin_attribute_id=>wwv_flow_imp.id(1709194671409716)
,p_display_sequence=>10
,p_display_value=>'None'
,p_return_value=>'NONE'
,p_help_text=>'No maximum date defined.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1710026671409716)
,p_plugin_attribute_id=>wwv_flow_imp.id(1709194671409716)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
,p_help_text=>'Maximum date is derived dynamically from another item''s value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1710596227409716)
,p_plugin_attribute_id=>wwv_flow_imp.id(1709194671409716)
,p_display_sequence=>30
,p_display_value=>'Static'
,p_return_value=>'STATIC'
,p_help_text=>'Maximum date is a static value, defined as either an absolute value, or relative value to today''s date.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1716031160409717)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Maximum Static'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709194671409716)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum date that can be input or selected.</p>',
'<p>The date value can be an absolute value in <code>''YYYY-MM-DDTHH24:MI:SS''</code> or <code>''YYYYMMDDHH24MI''</code> format or a relative value with respect to today''s date, such as <code>+7d</code>, or a dynamic value using substitution syntax, provi'
||'ding the substitution returns the correct date format or relative value.</p>',
'<p>Relative date values include:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - years from today''s date</dd>',
'  <dt>m</dt>',
'    <dd>+ / - months from today''s date</dd>',
'  <dt>w</dt>',
'    <dd>+ / - weeks from today''s date</dd>',
'  <dt>d</dt>',
'    <dd>+ / - days from today''s date</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1711057812409716)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Maximum Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709194671409716)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>'<p>The item that determines the maximum allowed value. This must be a page item that is either on the current, or global page.<p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1718330832409718)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Multiple Months'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1716493546409717)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_lov_type=>'STATIC'
,p_help_text=>'Whether the calendar should display multiple months and how many.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2427793654991245)
,p_plugin_attribute_id=>wwv_flow_imp.id(1718330832409718)
,p_display_sequence=>10
,p_display_value=>'No'
,p_return_value=>'N'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2428190913991518)
,p_plugin_attribute_id=>wwv_flow_imp.id(1718330832409718)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2428580586992202)
,p_plugin_attribute_id=>wwv_flow_imp.id(1718330832409718)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2429489597995618)
,p_plugin_attribute_id=>wwv_flow_imp.id(1718330832409718)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2429816838995931)
,p_plugin_attribute_id=>wwv_flow_imp.id(1718330832409718)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1713354664409716)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Use Defaults'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1716493546409717)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>'Whether to use the defaults defined for this component in Shared Components, Component Settings or custom settings.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1711481685409716)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Appearance & Behavior'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER:TODAY-BUTTON'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1713354664409716)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Control the appearance and behavior of the calendar used to select dates.</p>',
'<p>Note: This is only used when ''Display As'' is either ''Popup'' or ''Inline''.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1711838969409716)
,p_plugin_attribute_id=>wwv_flow_imp.id(1711481685409716)
,p_display_sequence=>10
,p_display_value=>'Show Week'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>'Whether the week of the year will be shown.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1712365635409716)
,p_plugin_attribute_id=>wwv_flow_imp.id(1711481685409716)
,p_display_sequence=>20
,p_display_value=>'Month Picker'
,p_return_value=>'MONTH-PICKER'
,p_help_text=>'Whether the month should be rendered as a button, to allow selection instead of text.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1712837913409716)
,p_plugin_attribute_id=>wwv_flow_imp.id(1711481685409716)
,p_display_sequence=>30
,p_display_value=>'Year Picker'
,p_return_value=>'YEAR-PICKER'
,p_help_text=>'Whether the year should be rendered as a button, to allow selection instead of text.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2621579516065433)
,p_plugin_attribute_id=>wwv_flow_imp.id(1711481685409716)
,p_display_sequence=>40
,p_display_value=>'Paginate by Multiple Months'
,p_return_value=>'NUMBER-OF-MONTH'
,p_help_text=>'Whether the pagination size when displaying several months is only one month or the number of months.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(280967332597274675)
,p_plugin_attribute_id=>wwv_flow_imp.id(1711481685409716)
,p_display_sequence=>50
,p_display_value=>'Show Today Button'
,p_return_value=>'TODAY-BUTTON'
,p_help_text=>'Whether the today button is shown to select the current date. The Today button is not displayed if the current day is outside min or max.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1713712488409717)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Days Outside Month'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1713354664409716)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Dictates the behavior of days outside the current viewing month.</p>',
'<p>Note: This is only used when ''Display As'' is either ''Popup'' or ''Inline''.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1714115985409717)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713712488409717)
,p_display_sequence=>10
,p_display_value=>'Hidden'
,p_return_value=>'HIDDEN'
,p_help_text=>'Days outside the current viewing month will be hidden.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1714643050409717)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713712488409717)
,p_display_sequence=>20
,p_display_value=>'Selectable'
,p_return_value=>'SELECTABLE'
,p_help_text=>'Days outside the current viewing month will be visible and selectable.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1715105582409717)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713712488409717)
,p_display_sequence=>30
,p_display_value=>'Visible'
,p_return_value=>'VISIBLE'
,p_help_text=>'Days outside the current viewing month will be visible.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1706456158409715)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Time Increment'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>'minutes'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1713354664409716)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Time increment in minutes used by the time selection control. Note: This just controls the control used for selecting the time, any time outside of these increments can still be manually entered and saved.</p>',
'<p>Note: This is only used when ''Display As'' is either ''Popup'' or ''Inline'', and in addition ''Show Time'' is on.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1719108861409718)
,p_plugin_id=>wwv_flow_imp.id(1700270759409701)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Show On'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1713354664409716)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>'Controls when the calendar popup is displayed. Note: This is only used when ''Display As'' is ''Popup''.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1719539503409718)
,p_plugin_attribute_id=>wwv_flow_imp.id(1719108861409718)
,p_display_sequence=>10
,p_display_value=>'Item Focus'
,p_return_value=>'FOCUS'
,p_help_text=>'When the item receives focus or when the calendar icon is clicked.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1720026750409718)
,p_plugin_attribute_id=>wwv_flow_imp.id(1719108861409718)
,p_display_sequence=>20
,p_display_value=>'Icon Click'
,p_return_value=>'IMAGE'
,p_help_text=>'Only when the calendar icon is clicked.'
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1700838675352758)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>'Geocoded Address'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelView#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_version_scn=>72472649
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This item type provides Geocoding (turning a postal address to a coordinate) functionality.<p>',
'<p>Geocoding is performed by <em>the browser</em> doing a REST request to the <strong>Oracle Elocation</strong> Geocoding Service (elocation.oracle.com). Thus the browser must be connected to the internet in order for geocoding to work.</p>',
'<p>Geocoding input data comes from other page items, which are mapped to address parts like Street, House Number, Postal Code or City. The Geocoder will show a popup window with a list of possible matches. After choosing a match, the item''s session s'
||'tate value will be the address coordinate in GeoJSON format. If <strong>Sanitize Address</strong> is enabled, address part page items will be overwritten with the sanitized values received from the Geocoding service.</p>',
'<p>For simpler use cases, the <strong>Unstructured Address</strong> mode allows to map only one text field or text area where end users enter address parts, separated by comma. In this case, the <strong>Sanitize Address</strong> mode is not available'
||'.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(6282184372711753)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_title=>'Geocoding Input'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(6282574537711753)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_title=>'Geocoding Result'
,p_display_sequence=>20
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1701330611413991)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Geocoder Match Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>The <strong>Match Mode</strong> determines how closely the attributes of an input address must match the data being used for geocoding.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702013128418533)
,p_plugin_attribute_id=>wwv_flow_imp.id(1701330611413991)
,p_display_sequence=>10
,p_display_value=>'Exact'
,p_return_value=>'EXACT'
,p_help_text=>'<p>All provided address parts must match. However, if the house number, street name or street type do not <em>all</em> match, the first match in the following is returned: postal code, city or town, and state. For example, if the street name is incor'
||'rect but a valid postal code is specified, a location in the postal code is returned.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702860244421796)
,p_plugin_attribute_id=>wwv_flow_imp.id(1701330611413991)
,p_display_sequence=>20
,p_display_value=>'Relax Street Type'
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>'<p>The provided <em>street type</em> can be different from the data used for geocoding. For example, <strong>Main Street</strong> or <strong>Main Blvd</strong> match <strong>Main St</strong>, if there is no other <strong>Main Blvd</strong> or <strong'
||'>Main Street</strong> in the relevant area.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1708669966452560)
,p_plugin_attribute_id=>wwv_flow_imp.id(1701330611413991)
,p_display_sequence=>30
,p_display_value=>'Relax House Number'
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>'<p>The house number and street type can be different from the data used for geocoding. For example, <strong>123 Main St</strong> matches <strong>123 Main Lane</strong> and <strong>124 Main St</strong>, as long as there are no ambiguities or other mat'
||'ches.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702428218420313)
,p_plugin_attribute_id=>wwv_flow_imp.id(1701330611413991)
,p_display_sequence=>40
,p_display_value=>'Relax Street Name'
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>'<p>The <em>base name</em> of the street, the house number, and the street type can be different from the data used for geocoding. For example, <strong>Pleasant Vale</strong> matches <strong>Pleasant Valley</strong> as long as there are no ambiguities'
||' or other matches in the data.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1703440180425368)
,p_plugin_attribute_id=>wwv_flow_imp.id(1701330611413991)
,p_display_sequence=>50
,p_display_value=>'Relax Postal Code'
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>'<p>The postal code (if provided), street name, street type and house number can be different from the data used for geocoding.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1703985342434956)
,p_plugin_attribute_id=>wwv_flow_imp.id(1701330611413991)
,p_display_sequence=>60
,p_display_value=>'Relax All'
,p_return_value=>'RELAX_ALL'
,p_help_text=>'<p>The address can be outside the city specified as long as it is within the same county. Also includes the characteristics of <strong>Relax Postal Code</strong>.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1709401396458135)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Show Coordinates in Popup'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3010200212280744)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>'<p>Determine whether to display address coordinates (longitude, latitude) in the geocoding results popup dialog.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2105827892587713)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Map Preview'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Whether to allow previewing the geocoded address on a map.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2601067718431827)
,p_plugin_attribute_id=>wwv_flow_imp.id(2105827892587713)
,p_display_sequence=>10
,p_display_value=>'Results Popup'
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Show the map in the Geocoding results popup, so that users can review the position before selecting a result.</p>',
'<p>This is only supported when "Display As - Grid View" is enabled.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2601404353432915)
,p_plugin_attribute_id=>wwv_flow_imp.id(2105827892587713)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
,p_help_text=>'Show a map visualizing the address location at the item position.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1744825789778265)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Background'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2105827892587713)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Pick the background map to show geocoding results on. You can use an out-of-the-box map background or select a custom Map Background for the application''s Shared Components</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1746613534792926)
,p_plugin_attribute_id=>wwv_flow_imp.id(1744825789778265)
,p_display_sequence=>5
,p_display_value=>'Default'
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the default map background.</p>',
'<p>It either uses "OpenStreetMap Bright" or "OpenStreetMap Dark" for dark themes.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1745320076781973)
,p_plugin_attribute_id=>wwv_flow_imp.id(1744825789778265)
,p_display_sequence=>10
,p_display_value=>'OpenStreetMap Bright'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>General purpose basemap based on OpenStreetMap data. This basemap style provides detailed location context for your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">View on GitHub</a></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1745780305787850)
,p_plugin_attribute_id=>wwv_flow_imp.id(1744825789778265)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap Dark'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Non-obtrusive dark basemap based on OpenStreetMap data. This basemap style accentuates visualizations of your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license. Cartography by Stamen Design is licensed under CC0.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">View on GitHub</a></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1746150917790500)
,p_plugin_attribute_id=>wwv_flow_imp.id(1744825789778265)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Non-obtrusive light basemap based on OpenStreetMap data. This basemap style accentuates visualizations of your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license. Cartography by Stamen Design is licensed under CC0.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">View on GitHub</a></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2601367265556756)
,p_plugin_attribute_id=>wwv_flow_imp.id(1744825789778265)
,p_display_sequence=>40
,p_display_value=>'Oracle World Map'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>General purpose basemap based on HERE Map data. This base map style provides location context for your data and accentuates visualization of your data.</p>',
'<p>Style schema and definitions by Oracle, USA.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2096569823509787)
,p_plugin_attribute_id=>wwv_flow_imp.id(1744825789778265)
,p_display_sequence=>50
,p_display_value=>'Shared Component'
,p_return_value=>'shared-component'
,p_help_text=>'Use one of the Map Backgrounds defined in Shared Components.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2206585812380955)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Height'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'pixels'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2105827892587713)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the height (in pixels) of the displayed map.</p>',
'<p>Map''s default height is calculated based on it''s width with an 3:2 aspect ratio.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3010200212280744)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Display As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Select how the geocoding results are displayed.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3011428457283918)
,p_plugin_attribute_id=>wwv_flow_imp.id(3010200212280744)
,p_display_sequence=>10
,p_display_value=>'List View'
,p_return_value=>'LIST'
,p_help_text=>'<p>The results will be shown in a list view.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3011010596282953)
,p_plugin_attribute_id=>wwv_flow_imp.id(3010200212280744)
,p_display_sequence=>20
,p_display_value=>'Grid View'
,p_return_value=>'GRID'
,p_help_text=>'<p>The results will be shown in a grid view.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2097058254515505)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>'Custom Background'
,p_attribute_type=>'MAP BACKGROUND ID'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1744825789778265)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'shared-component'
,p_help_text=>'Choose one of the Map Backgrounds defined in Shared Components.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1709967230470781)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>'Structured Address'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Whether address parts are provided to the geocoding service in a <em>structured</em> or <em>unstructured</em> manner.</p>',
'<p>Structured means that explicit page items are mapped to address parts like Street, Postal Code, City or Region. This leads to more accurate geocoding results, and also allows to feed the ',
'corrected addresses back to the page items.</p>',
'<p>Unstructured means that only one item is used for the whole address; parts are separated by comma. This mode does not allow to feed corrected addresses back to the page item.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1710428568474713)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Country Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_help_text=>'<p>Choose whether to use a static country for geocoding, or whether to derive the country from an item.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1710966154475523)
,p_plugin_attribute_id=>wwv_flow_imp.id(1710428568474713)
,p_display_sequence=>10
,p_display_value=>'Static'
,p_return_value=>'STATIC'
,p_help_text=>'<p>Use a static country from a select list.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1711762868476607)
,p_plugin_attribute_id=>wwv_flow_imp.id(1710428568474713)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
,p_help_text=>'<p>Get the country from an application or page item. The item must contain the 2-digit ISO code for a country. </p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1712263798480014)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Country'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1710428568474713)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><strong>US</strong>: United States</li>',
'<li><strong>UK</strong>: United Kingdom</li>',
'<li><strong>DE</strong>: Germany</li>',
'<li><strong>AT</strong>: Austria</li>',
'</ul>'))
,p_help_text=>'<p>Pick a page or application item to get the country for geocoding from. The item must contain the 2-digit ISO code for a country.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1712712695483947)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Country'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1710428568474713)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_help_text=>'<p>Pick the country to use for geocoding.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1713260223484493)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>10
,p_display_value=>'United States'
,p_return_value=>'US'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1713640362485278)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>20
,p_display_value=>'United Kingdom'
,p_return_value=>'UK'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1714942400488162)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>30
,p_display_value=>'Germany'
,p_return_value=>'DE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1715315187488602)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>40
,p_display_value=>'France'
,p_return_value=>'FR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1715776600489110)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>50
,p_display_value=>'Italy '
,p_return_value=>'IT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1732218107588818)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>60
,p_display_value=>'Canada'
,p_return_value=>'CA'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1732613691589456)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>70
,p_display_value=>'Netherlands'
,p_return_value=>'NL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1733039072590094)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>80
,p_display_value=>'Belgium'
,p_return_value=>'BE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1733467346590779)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>90
,p_display_value=>'Austria'
,p_return_value=>'AT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1733819745591632)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>100
,p_display_value=>'Switzerland'
,p_return_value=>'CH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1734205667592050)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>110
,p_display_value=>'Spain'
,p_return_value=>'ES'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1734685684592583)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>120
,p_display_value=>'Portugal'
,p_return_value=>'PT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1735060793593960)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>130
,p_display_value=>'Russian Federation'
,p_return_value=>'RU'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1735422526594737)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>140
,p_display_value=>'Estonia'
,p_return_value=>'EE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1735848786595289)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>150
,p_display_value=>'India'
,p_return_value=>'IN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1736299306596060)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>160
,p_display_value=>'Mexico'
,p_return_value=>'MX'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1736643807596659)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>170
,p_display_value=>'Australia'
,p_return_value=>'AU'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1737040872597462)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>180
,p_display_value=>'Brazil'
,p_return_value=>'BR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1737421643598208)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>190
,p_display_value=>'Chile'
,p_return_value=>'CL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1737878315598644)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>200
,p_display_value=>'Czech Republic'
,p_return_value=>'CZ'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1738298290599154)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>210
,p_display_value=>'Norway'
,p_return_value=>'NO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1738640811599640)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>220
,p_display_value=>'Finland'
,p_return_value=>'FI'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1739045295600254)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>230
,p_display_value=>'Denmark'
,p_return_value=>'DK'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1739492220600840)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>240
,p_display_value=>'Hong Kong'
,p_return_value=>'HK'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1739888238601924)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>250
,p_display_value=>'Ireland'
,p_return_value=>'IE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1740248023602467)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>260
,p_display_value=>'Latvia'
,p_return_value=>'LV'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1740660821603187)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>270
,p_display_value=>'Romania'
,p_return_value=>'RO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1741021923603709)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>280
,p_display_value=>'Colombia'
,p_return_value=>'CO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1741493695604368)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>290
,p_display_value=>'Poland'
,p_return_value=>'PL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1741819445604954)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>300
,p_display_value=>'United Arab Emirates'
,p_return_value=>'AE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1742273782605774)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>310
,p_display_value=>'Hungary'
,p_return_value=>'HU'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1742644763606445)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>320
,p_display_value=>'Saudi Arabia'
,p_return_value=>'SA'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1743094899606998)
,p_plugin_attribute_id=>wwv_flow_imp.id(1712712695483947)
,p_display_sequence=>330
,p_display_value=>'South Africa'
,p_return_value=>'ZA'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1716542235497108)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>'Address Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709967230470781)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_help_text=>'<p>Pick the item containing unstructured address parts, separated by comma.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1720233540512149)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>'Street Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709967230470781)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_help_text=>'<p>Pick the item containing the <em>Street</em> part of the address.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1720738899514712)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>'House Number Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709967230470781)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_help_text=>'<p>Pick the item containing the <em>House Number</em> part of the address.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1721280838517001)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>'City Sub Area Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709967230470781)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_help_text=>'<p>Pick the item containing the <em>Sub Area (within a City)</em> part of the address.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1721711111518708)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>'City Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709967230470781)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_help_text=>'<p>Pick the item containing the <em>City</em> part of the address.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1722254500520558)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Postal Code Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709967230470781)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_help_text=>'<p>Pick the item containing the <em>Postal Code</em> part of the address.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1722749669524835)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>'Region Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709967230470781)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6282184372711753)
,p_help_text=>'<p>Pick the item containing the <em>Region (State)</em> part of the address.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1723298553527158)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Sanitize Address'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1709967230470781)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'<p>Enable this switch to feed address data from the geocoding service back to the mapped items.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1727004690548379)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>'Match Vector Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(6282574537711753)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Pick a page item for the Geocoder to return the <em>Match Vector</em> into. The match vector is a 17-digit string with detailed information about how each address attribute has been matched against the data used for geocoding.</p>',
'<p><strong>Match Vector digits can have the following values:</strong></p>',
'<ul>',
'<li><p>0: The input attribute is not null and is matched with a non-null value.</p></li>',
'<li><p>1: The input attribute is null and is matched with a null value.</p></li>',
'<li><p>2: The input attribute is not null and is replaced by a different non-null value.</p></li>',
'<li><p>3: The input attribute is not null and is replaced by a null value.</p></li>',
'<li><p>4: The input attribute is null and is replaced by a non-null value.</p></li>',
'</ul>',
'<br>',
'<p><strong>Match Vector digits and the address attribute corresponding to each:</strong></p>',
'<ul>',
'<li><p>3: Address Point (exact address matched in data used for geocoding)</p></li>',
'<li><p>4: Point Of Interest Name</p></li>',
'<li><p>5: House Number</p></li>',
'<li><p>6: Street Prefix</p></li>',
'<li><p>7: Street Name</p></li>',
'<li><p>8: Street Suffix</p></li>',
'<li><p>9: Street Type</p></li>',
'<li><p>10: Secondary Unit</p></li>',
'<li><p>11: City</p></li>',
'<li><p>14: Region</p></li>',
'<li><p>15: Country</p></li>',
'<li><p>16: Postal Code</p></li>',
'<li><p>17: Postal Add-On Code</p></li>',
'<li><p><em>other digits are unused yet.</em></p></li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1727549870549765)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Trigger Geocoding'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Determine when to trigger geocoding. This includes the browser performing the REST request to the geocoding service and showing the popup window with possible matches.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1728048005551626)
,p_plugin_attribute_id=>wwv_flow_imp.id(1727549870549765)
,p_display_sequence=>10
,p_display_value=>'Automatic'
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Geocoding is triggered automatically before the page is submitted.</p>',
'<p>If a dependent item value has changed, like for example the value of <em>P1_STREET</em> and geocoding was not executed so far, or a valid address hasn''t been selected, we make sure that geocoding is triggered automatically. In this case we interru'
||'pt the submission flow of the current page submit and show a popup window with possible matches first. If the user picked a matching result, the page can be re-submitted without any further interruption.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1728439221554365)
,p_plugin_attribute_id=>wwv_flow_imp.id(1727549870549765)
,p_display_sequence=>20
,p_display_value=>'Dynamic Action'
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>'<p>Geocoding must be triggered by adding the Dynamic Action <em>Trigger Geocoding</em> to the page.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1728803167561342)
,p_plugin_attribute_id=>wwv_flow_imp.id(1727549870549765)
,p_display_sequence=>30
,p_display_value=>'jQuery Selector'
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>'<p>Geocoding is triggered based on an event on the DOM element targeted by the selector. If an input field is referenced, Geocoding is triggered on <em>change</em> of the element, if a button is referenced, Geocoding will be triggered <em>on click</e'
||'m>.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1747463542804307)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1727549870549765)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Execute process when items <em>P1_STREET</em> and <em>P1_ZIP_CODE</em> changes, jQuery selector:</p>',
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>'<p>Provide the jQuery selector referencing the element which triggers geocoding. Buttons will trigger geocoding <em>on click</em>, other elements will trigger <em>on change</em>.</p>'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(12982963519254231)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_name=>'apexgeocoderresponse'
,p_display_name=>'Geocoding Response'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(12982639254254214)
,p_plugin_id=>wwv_flow_imp.id(1700838675352758)
,p_name=>'apexgeocoderselection'
,p_display_name=>'Result Selection'
);
end;
/
prompt --application/shared_components/plugins/region_type/dynamic_content
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1702533213534863)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DYNAMIC_CONTENT'
,p_display_name=>'Dynamic Content'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DYNAMIC_CONTENT'),'')
,p_api_version=>1
,p_standard_attributes=>'AJAX_ITEMS_TO_SUBMIT:LAZY_LOADING'
,p_substitute_attributes=>false
,p_version_scn=>72472649
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays the HTML content returned by a function.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1800664597261423)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>'Smart Filters'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_api_version=>1
,p_standard_attributes=>'INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>false
,p_version_scn=>72472649
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'<p>A region based on the source of an associated Smart Filters, that provides end-users with numerous filters that are used to narrow search results at run-time. </p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1816085788971276)
,p_plugin_id=>wwv_flow_imp.id(1800664597261423)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'maximum_suggestion_chips'
,p_prompt=>'Maximum Suggestion Chips'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Specify the maximum number of Suggestion Chips to be displayed. If not specified a default of 5 will be used.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1816321935999387)
,p_plugin_id=>wwv_flow_imp.id(1800664597261423)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'more_filters_suggestion_chip'
,p_prompt=>'More Filters Suggestion Chip'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether Filters that are not displayed as Suggestion Chips can be selected via the More Filters drop-down menu button.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1808803156261456)
,p_plugin_id=>wwv_flow_imp.id(1800664597261423)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'compact_numbers_threshold'
,p_prompt=>'Compact Numbers Threshold'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'Provide a threshold value, above which counts are displayed using a compact number format. With the compact number format, a value of <strong>1,234</strong> will be displayed as <strong>1K</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1801137838146661)
,p_plugin_id=>wwv_flow_imp.id(1800664597261423)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'show_total_row_count'
,p_prompt=>'Show Total Row Count'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify where to display the total row count.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1801499572149580)
,p_plugin_attribute_id=>wwv_flow_imp.id(1801137838146661)
,p_display_sequence=>10
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'The total row count is not displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1801880772227865)
,p_plugin_attribute_id=>wwv_flow_imp.id(1801137838146661)
,p_display_sequence=>20
,p_display_value=>'Yes'
,p_return_value=>'Y'
,p_help_text=>'The total row count is displayed below the suggestion chips.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1802207279232480)
,p_plugin_attribute_id=>wwv_flow_imp.id(1801137838146661)
,p_display_sequence=>30
,p_display_value=>'Selector'
,p_return_value=>'E'
,p_help_text=>'The total row count (without any label) is displayed within the element specified by this selector. This allows you to place the total row count just about anywhere on the page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1802866258261858)
,p_plugin_id=>wwv_flow_imp.id(1800664597261423)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'total_row_count_label'
,p_prompt=>'Total Row Count Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1801137838146661)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Label to use for the total row count. If no label is provided here, APEX will use the APEX.FS.TOTAL_ROW_COUNT_LABEL text message.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1803111571268834)
,p_plugin_id=>wwv_flow_imp.id(1800664597261423)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'total_row_count_selector'
,p_prompt=>'Total Row Count Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1801137838146661)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>'This is the selector of an element on the page where the Smart Filters region will display the total row count.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(152342058082379972)
,p_plugin_id=>wwv_flow_imp.id(1800664597261423)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.collapsibleSearchBar = null;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter a JavaScript function that takes an options object, modifies the object, and returns it. This allows advanced customization of the region during initialization. See the <code>facetsRegion</code> interface JavaScript API documentation for the av'
||'ailable options.</p>'))
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(1812244001261470)
,p_plugin_id=>wwv_flow_imp.id(1800664597261423)
,p_name=>'facetschange'
,p_display_name=>'Filters Change'
);
end;
/
prompt --application/shared_components/plugins/process_type/manage_task
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1808459759949716)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'MANAGE_TASK'
,p_display_name=>'Human Task - Manage'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','MANAGE_TASK'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472653
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process to manage a human task. The different types of task management are Approve, Reject, Complete (without Outcome), Claim, Release, Delegate, Forward, Cancel, Comment and Invite Participant.'
,p_version_identifier=>'1.0'
,p_plugin_comment=>'LOCKED - [RICALLEN] 6840 - Page Task'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1808664743954775)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'APPROVE_TASK'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Select a type'
,p_help_text=>'The type of operation to be performed on the task. Options are Approve, Reject, Complete (without Outcome), Claim, Release, Delegate, Forward, Cancel, Comment and Invite Participant.  Approve and Reject can only be used with Approval Tasks.  Complete'
||' (without Outcome) is only used for Action Tasks.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1808936659959062)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>10
,p_display_value=>'Approve'
,p_return_value=>'APPROVE_TASK'
,p_help_text=>'This declarative component allows the end user to approve an existing approval task they are currently assigned.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1809394945961761)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>20
,p_display_value=>'Reject'
,p_return_value=>'REJECT_TASK'
,p_help_text=>'This declarative component allows the end user to reject an approval task they are currently assigned.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1605256087626050)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>25
,p_display_value=>'Complete (without Outcome)'
,p_return_value=>'COMPLETE_TASK'
,p_help_text=>'This declarative component allows the end user to complete a task they are currently assigned.  This should not be used for Approval Tasks, which need an outcome.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1809759155967036)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>30
,p_display_value=>'Comment'
,p_return_value=>'ADD_TASK_COMMENT'
,p_help_text=>'This declarative component allows the end user to add a comment to an existing task they are assigned.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1811075298077483)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>40
,p_display_value=>'Claim'
,p_return_value=>'CLAIM_TASK'
,p_help_text=>'The Claim action allows end user to claim a human task of which they are a potential owner.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1811499554081898)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>50
,p_display_value=>'Delegate'
,p_return_value=>'DELEGATE_TASK'
,p_help_text=>'The Delegate action allows the end user to delegate a task assigned to them to another potential owner of the human task.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3100202036311715)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>60
,p_display_value=>'Release'
,p_return_value=>'RELEASE_TASK'
,p_help_text=>'Release a task previously claimed so that it is available for claiming by another Potential Owner.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3200209891503536)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>70
,p_display_value=>'Cancel'
,p_return_value=>'CANCEL_TASK'
,p_help_text=>'Cancel a task. This action can be performed by the initiator of a task.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1504582208661196)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>80
,p_display_value=>'Invite Participant'
,p_return_value=>'ADD_TASK_POTENTIAL_OWNER'
,p_help_text=>'The Business Administrator can invite another user to be a potential owner to act on a task.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308143898265469743)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>90
,p_display_value=>'Set Priority'
,p_return_value=>'SET_TASK_PRIORITY'
,p_help_text=>'Sets the priority of the task to a value between 1 and 5. The available values are 1-Urgent, 2-High, 3-Medium, 4-Low, 5-Lowest'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1504231626593060)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>100
,p_display_value=>'Request Information'
,p_return_value=>'REQUEST_INFO'
,p_help_text=>'Request further information from the initiator of the task. Only the actual owner of a task can do this.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1504686616599920)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>110
,p_display_value=>'Submit Information'
,p_return_value=>'SUBMIT_INFO'
,p_help_text=>'Provide further information requested by the assignee of a task. Only the initiator of the task can do this.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4601582363778238)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>120
,p_display_value=>'Set Due Date'
,p_return_value=>'SET_DUE_DATE'
,p_help_text=>'Update the Due Date of the Task . This operation can only be performed by the Business Administrator of the task. This operation cannot be performed for Completed, Canceled or Errored tasks.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3000591335255039)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>130
,p_display_value=>'Renew'
,p_return_value=>'RENEW_TASK'
,p_help_text=>'Allows the Business Administrator of an expired task to renew the task.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2808328478555314)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>140
,p_display_value=>'Remove Participaint'
,p_return_value=>'REMOVE_POTENTIAL_OWNER'
,p_help_text=>'Removes the potential owner from the task instance. Only the Business Administrator of a task can perform this operation.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2808756961640563)
,p_plugin_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_display_sequence=>150
,p_display_value=>'Update Parameter'
,p_return_value=>'SET_TASK_PARAMS'
,p_help_text=>'Update the value of a task parameter. Only a Business Administrator or the Actual Owner of a task can perform this action.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1810743047984368)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Task ID Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'The Task Id identifies a task instance uniquely. This needs to be passed in as an attribute in order to Claim, Delegate, Cancel, Release, Forward, Approve, Reject, Complete, Invite Participants or Add Comments to a Task.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1811881522091052)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Comment Text'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ADD_TASK_COMMENT,REQUEST_INFO,SUBMIT_INFO'
,p_help_text=>'This contains the comment added to the task either by the assignee, the initiator or the business administrator of the task. Substitution strings can be used in the comment text in the format &SAMPLE_TEXT.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1812265430296938)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'To User Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DELEGATE_TASK,ADD_TASK_POTENTIAL_OWNER,REMOVE_POTENTIAL_OWNER'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'For the Delegate operation type, this indicates the user to which this task is being delegated by the current assignee of the task. ',
'For the Invite Participant operation type, this indicates the user being added as a potential owner by the business administrator of the task.',
'',
'This user should not be the same as the current user to whom the task is assigned.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308144299941500726)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Priority Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SET_TASK_PRIORITY'
,p_help_text=>'A page item containing the priority of the task. It can be a value between 1 and 5. 1-Urgent, 2-High, 3-Medium, 4-Low and 5-Lowest.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(4602344261814651)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Due Date Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SET_DUE_DATE'
,p_help_text=>'Page Item representing the due date to be set for a task. This will override any due date that was previously set for the task based on its task definition.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3000919670270560)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Renewed Due Date'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'RENEW_TASK'
,p_help_text=>'An (optional) page item, containing the <em>Due Date</em> for the renewed task. If not provided, the due date for the renewed task will be calculated based on the due on settings at the task definition level.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3001215272274083)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Renewed Priority'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'RENEW_TASK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An (optional) page item, containing the <em>Priority</em> of the renewed task.  If not provided, the priority of the renewed task will be based on the priority defined at the task definition level. Possible Values are:',
'<dl>',
'<dt>1</dt>',
'<dd>Urgent</dd>',
'<dt>2</dt>',
'<dd>High</dd>',
'<dt>3</dt>',
'<dd>Medium (default)</dd>',
'<dt>4</dt>',
'<dd>Low</dd>',
'<dt>5</dt>',
'<dd>Lowest</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3001930149366643)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Renewed Task ID Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'RENEW_TASK'
,p_help_text=>'Page Item to store the ID of the renewed task.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2809663844698429)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Parameter Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SET_TASK_PARAMS'
,p_help_text=>'Item containing the Static ID of the parameter to be updated. The <strong>Updatable</strong> switch must be enabled for the parameter, otherwise an error will be raised.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2809900892706440)
,p_plugin_id=>wwv_flow_imp.id(1808459759949716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'New Value Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1808664743954775)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SET_TASK_PARAMS'
,p_help_text=>'Item containing the new value for the task parameter.'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1900426248156512)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>55031389
,p_subscribe_plugin_settings=>true
,p_help_text=>'Use Oracle Cloud Infrastructure REST services as REST Data Sources.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/rest_enabled_sql_query
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1900493147070964)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'REST_ENABLED_SQL_QUERY'
,p_display_name=>'REST Enabled SQL Query'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','REST_ENABLED_SQL_QUERY'),'')
,p_api_version=>1
,p_standard_attributes=>'NO_TEST_ENDPOINT'
,p_substitute_attributes=>true
,p_version_scn=>55031563
,p_subscribe_plugin_settings=>true
,p_help_text=>'Define query for use against remote Oracle databases.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1902484959135004)
,p_plugin_id=>wwv_flow_imp.id(1900493147070964)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the SQL Query to execute on the REST Enabled SQL Reference.'
);
end;
/
prompt --application/shared_components/plugins/process_type/download
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2201000366121056)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DOWNLOAD'
,p_display_name=>'Download'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DOWNLOAD'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_version_scn=>72472653
,p_subscribe_plugin_settings=>true
,p_help_text=>'Downloads one or multiple files. This process type works in Before Header position at Page Rendering or in Page Processing when submitting a page. The processing stops after this process is executed.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(2202294376228497)
,p_plugin_id=>wwv_flow_imp.id(2201000366121056)
,p_title=>'Source'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2203675664234640)
,p_plugin_id=>wwv_flow_imp.id(2201000366121056)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Multiple Files'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose <strong>On</strong> to download all files returned by your SQL Query as a ZIP archive.</p>',
'<p>Choose <strong>Off</strong> to download a single file returned by your SQL Query.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2203913016238836)
,p_plugin_id=>wwv_flow_imp.id(2201000366121056)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Filename'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2203675664234640)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'my_files.zip'
,p_help_text=>'Enter a filename for the downloaded ZIP archive.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2204203316241786)
,p_plugin_id=>wwv_flow_imp.id(2201000366121056)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'View File As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ATTACHMENT'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2203675664234640)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>'Select the content-disposition for the downloaded file. Content-disposition is an extension to the MIME protocol that instructs the browser on how the document displays.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2204504610242970)
,p_plugin_attribute_id=>wwv_flow_imp.id(2204203316241786)
,p_display_sequence=>10
,p_display_value=>'Attachment'
,p_return_value=>'ATTACHMENT'
,p_help_text=>'Saves the file to disk.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2204977175243950)
,p_plugin_attribute_id=>wwv_flow_imp.id(2204203316241786)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'Displays the file instead of the current page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2205665793252019)
,p_plugin_id=>wwv_flow_imp.id(2201000366121056)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2203675664234640)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(2202294376228497)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select file_content,',
'       file_name',
'  from my_files',
' where type = :P1_TYPE',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL Query which retrieves the files for download. The resulting files will be compressed into a ZIP archive.</p>',
'<p>You can reference page or application items using bind syntax, providing you include them in <strong>Items to Submit.</strong></p>',
'<p>The column order of the provided SQL Query should be as follows:</p>',
'',
'<ol>',
'  <li>File Content - BLOB, CLOB or VARCHAR2 column</li>',
'  <li>Filename - VARCHAR2 column</li>',
'</ol>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2205975010255739)
,p_plugin_id=>wwv_flow_imp.id(2201000366121056)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>2
,p_sql_max_column_count=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2203675664234640)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_attribute_group_id=>wwv_flow_imp.id(2202294376228497)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select file_content,',
'       file_name,',
'       mime_type',
'  from my_files',
' where id = :P1_ID',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL Query which retrieves a single file for download. In case multiple files are returned, only the first file will be downloaded.</p>',
'<p>You can reference page or application items using bind syntax, providing you include them in <strong>Items to Submit.</strong></p>',
'<p>The column order of the provided SQL Query should be as follows:</p>',
'',
'<ol>',
'  <li>File Content - BLOB, CLOB or VARCHAR2 column</li>',
'  <li>Filename - VARCHAR2 column</li>',
'  <li>Mime Type - VARCHAR2 column (optional)</li>',
'</ol>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/download
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2201243630153345)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DOWNLOAD'
,p_display_name=>'Download'
,p_category=>'EXECUTE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DOWNLOAD'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_version_scn=>72472653
,p_subscribe_plugin_settings=>true
,p_help_text=>'Downloads one or multiple files.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(2206324509272186)
,p_plugin_id=>wwv_flow_imp.id(2201243630153345)
,p_title=>'Source'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2206840373275023)
,p_plugin_id=>wwv_flow_imp.id(2201243630153345)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Multiple Files'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose <strong>On</strong> to download all files returned by your SQL Query as a ZIP archive.</p>',
'<p>Choose <strong>Off</strong> to download a single file returned by your SQL Query.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2207173323276569)
,p_plugin_id=>wwv_flow_imp.id(2201243630153345)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Filename'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2206840373275023)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'my_files.zip'
,p_help_text=>'Enter a filename for the downloaded ZIP archive.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2207463951278600)
,p_plugin_id=>wwv_flow_imp.id(2201243630153345)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'View File As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ATTACHMENT'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2206840373275023)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>'Select the content-disposition for the downloaded file. Content-disposition is an extension to the MIME protocol that instructs the browser on how the document displays.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2207762984279393)
,p_plugin_attribute_id=>wwv_flow_imp.id(2207463951278600)
,p_display_sequence=>10
,p_display_value=>'Attachment'
,p_return_value=>'ATTACHMENT'
,p_help_text=>'Saves the file to disk.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2208129276280237)
,p_plugin_attribute_id=>wwv_flow_imp.id(2207463951278600)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'Displays the file instead of the current page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2208950763285178)
,p_plugin_id=>wwv_flow_imp.id(2201243630153345)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2206840373275023)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(2206324509272186)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select file_content,',
'       file_name',
'  from my_files',
' where type = :P1_TYPE',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL Query which retrieves the files for download. The resulting files will be compressed into a ZIP archive.</p>',
'<p>You can reference page or application items using bind syntax, providing you include them in <strong>Items to Submit.</strong></p>',
'<p>The column order of the provided SQL Query should be as follows:</p>',
'',
'<ol>',
'  <li>File Content - BLOB, CLOB or VARCHAR2 column</li>',
'  <li>Filename - VARCHAR2 column</li>',
'</ol>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2209241227287577)
,p_plugin_id=>wwv_flow_imp.id(2201243630153345)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>2
,p_sql_max_column_count=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2206840373275023)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_attribute_group_id=>wwv_flow_imp.id(2206324509272186)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select file_content,',
'       file_name,',
'       mime_type',
'  from my_files',
' where id = :P1_ID',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL Query which retrieves a single file for download. In case multiple files are returned, only the first file will be downloaded.</p>',
'<p>You can reference page or application items using bind syntax, providing you include them in <strong>Items to Submit.</strong></p>',
'<p>The column order of the provided SQL Query should be as follows:</p>',
'',
'<ol>',
'  <li>File Content - BLOB, CLOB or VARCHAR2 column</li>',
'  <li>Filename - VARCHAR2 column</li>',
'  <li>Mime Type - VARCHAR2 column (optional)</li>',
'</ol>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2209982962291007)
,p_plugin_id=>wwv_flow_imp.id(2201243630153345)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Items to Submit'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(2206324509272186)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the uppercase page items submitted to the server, and therefore, available for use within your <strong>SQL Query</strong>.</p>',
'<p>You can type in the item name or pick from the list of available items. If you pick from the list and there is already text entered then a comma is placed at the end of the existing text, followed by the item name returned from the list.</p>'))
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2302882720656544)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>55031185
,p_subscribe_plugin_settings=>true
,p_help_text=>'Use ORDS REST services as REST Data Sources.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2700889063556536)
,p_plugin_id=>wwv_flow_imp.id(2302882720656544)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Returns legacy ORDS JSON'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Enable this, if this ORDS REST service returns data in the <em>ORDS legacy JSON representation</em>.'
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2606845974894125)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>'Search'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_version_scn=>72472653
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a text field, enabling the end user to search the list entries of the facets in the Faceted Search region. A Faceted Search region supports one Search facet, which will always be at the top of the list of Facets, regardless of its sequence.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2607008165899744)
,p_plugin_id=>wwv_flow_imp.id(2606845974894125)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Search Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2607312816901820)
,p_plugin_attribute_id=>wwv_flow_imp.id(2607008165899744)
,p_display_sequence=>10
,p_display_value=>'Row Search'
,p_return_value=>'ROW'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2607759273903144)
,p_plugin_attribute_id=>wwv_flow_imp.id(2607008165899744)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2608156895911496)
,p_plugin_id=>wwv_flow_imp.id(2606845974894125)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Input Field'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2608417903912546)
,p_plugin_attribute_id=>wwv_flow_imp.id(2608156895911496)
,p_display_sequence=>10
,p_display_value=>'Top of Faceted Search Region'
,p_return_value=>'FACET'
,p_help_text=>'A search field will render at the top of the Faceted Search region, above the facets.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2608887428914009)
,p_plugin_attribute_id=>wwv_flow_imp.id(2608156895911496)
,p_display_sequence=>20
,p_display_value=>'External Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'A page item can be selected using the associated External Page Item attribute, to be used as the search field for the Faceted Search region.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2609288187919863)
,p_plugin_id=>wwv_flow_imp.id(2606845974894125)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'External Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2608156895911496)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2205297904876322)
,p_plugin_id=>wwv_flow_imp.id(2606845974894125)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Collapsed Search Field'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>'Specify whether the search field of Smart Filters is initially collapsed.'
);
end;
/
prompt --application/shared_components/plugins/process_type/send_push_notification
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2800241607129045)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_PUSH_NOTIFICATION'
,p_display_name=>'Send Push Notification'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS:APEX_APPL_TASKDEF_ACTIONS:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_PUSH_NOTIFICATION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_version_scn=>72472653
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>Process sends a push notification to a user. All devices to which the user subscribes receive the push notification.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2803089368129065)
,p_plugin_id=>wwv_flow_imp.id(2800241607129045)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'To'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Username of the application user who should receive the push notification. To receive the notification, the user must have subscribed to the application first. Username is case sensitive.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2804156107129066)
,p_plugin_id=>wwv_flow_imp.id(2800241607129045)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_max_length=>4000
,p_is_translatable=>true
,p_help_text=>'Title of the push notification.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2804523632129066)
,p_plugin_id=>wwv_flow_imp.id(2800241607129045)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Body'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_display_length=>60
,p_max_length=>4000
,p_is_translatable=>true
,p_help_text=>'Body of the push notification.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2811954109167387)
,p_plugin_id=>wwv_flow_imp.id(2800241607129045)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Link Target'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'URL of the page that will be opened when the user clicks on the push notification. This works better when deep linking is enabled or rejoin session is enabled on the application. Defaults to the home page of the application.'
);
end;
/
prompt --application/shared_components/plugins/process_type/workflow
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2800300838509779)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WORKFLOW'
,p_display_name=>'Workflow'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WORKFLOW'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>54773552
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Process to perform the following operations on a Workflow:',
'<ul>',
'<li>Start a new Workflow Instance based on the selected Workflow Definition</li>',
'<li>Terminate, Suspend, Resume or Retry an existing Workflow Instance</li>',
'</ul>'))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2800648937532558)
,p_plugin_id=>wwv_flow_imp.id(2800300838509779)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'START'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'The Type of the Workflow Operation being performed by this process.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2800917704534899)
,p_plugin_attribute_id=>wwv_flow_imp.id(2800648937532558)
,p_display_sequence=>10
,p_display_value=>'Start'
,p_return_value=>'START'
,p_help_text=>'Start a new workflow instance based on a workflow definition.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2801395183536932)
,p_plugin_attribute_id=>wwv_flow_imp.id(2800648937532558)
,p_display_sequence=>20
,p_display_value=>'Terminate'
,p_return_value=>'TERMINATE'
,p_help_text=>'Terminate a running workflow instance'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2801736160548743)
,p_plugin_attribute_id=>wwv_flow_imp.id(2800648937532558)
,p_display_sequence=>30
,p_display_value=>'Suspend'
,p_return_value=>'SUSPEND'
,p_help_text=>'Suspend a running workflow instance'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2802126319550153)
,p_plugin_attribute_id=>wwv_flow_imp.id(2800648937532558)
,p_display_sequence=>40
,p_display_value=>'Resume'
,p_return_value=>'RESUME'
,p_help_text=>'Resume a previously suspended workflow instance'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2802505981551924)
,p_plugin_attribute_id=>wwv_flow_imp.id(2800648937532558)
,p_display_sequence=>50
,p_display_value=>'Retry'
,p_return_value=>'RETRY'
,p_help_text=>'Retry a failed workflow instance'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3000250776341091)
,p_plugin_id=>wwv_flow_imp.id(2800300838509779)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Definition'
,p_attribute_type=>'WORKFLOW ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2800648937532558)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'START'
,p_help_text=>'The Workflow Definition.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3000568621346270)
,p_plugin_id=>wwv_flow_imp.id(2800300838509779)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Details Primary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2800648937532558)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'START'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Page Item specifying the primary key value of the row in the system of records which acts as the source for this workflow. The source is defined in the <strong>Workflow Version</strong> inside the <strong>Workflow Designer</strong>.',
'</p> ',
'<p>',
'When executing the workflow, the Detail Primary Key Item will be used only if the source in the workflow version is specified.',
'</p>',
'<p>',
'When the source of the workflow version is of type Table or SQL Query, then the value of this detail primary key is available in workflow queries or code using the APEX$WORKFLOW_DETAIL_PK bind variable or substitution string.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3000808276350190)
,p_plugin_id=>wwv_flow_imp.id(2800300838509779)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Workflow Id Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'The Workflow Id Item identifies a workflow instance uniquely. When the Type is Terminate, Resume, Suspend or Retry, this needs to be passed in as an attribute in order to perform those operations on the workflow instance . When the Type is Start, the'
||' Workflow Id Item is an optional Page Item where the id of the newly created workflow instance can be stored.'
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2801375174221512)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>'Map'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_version_scn=>1088654313
,p_subscribe_plugin_settings=>true
,p_help_text=>'Report based on a SQL Query that displays coordinate data as a map. Supports points, lines and polygon data.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1600327131948288)
,p_plugin_id=>wwv_flow_imp.id(2801375174221512)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'use_vector_tile_layers'
,p_prompt=>'Use Vector Tile Layers'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Whether to use <em>Vector Tile Layers</em> as the background map. If <strong>maps.oracle.com</strong> provides a Vector Tile Layer for the chosen background map, and this attribute is enabled, the map region will use it.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2801502987221529)
,p_plugin_id=>wwv_flow_imp.id(2801375174221512)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(2501189800179937)
,p_plugin_id=>wwv_flow_imp.id(2801375174221512)
,p_name=>'spatialmapchanged'
,p_display_name=>'Map Changed'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(2501913148179938)
,p_plugin_id=>wwv_flow_imp.id(2801375174221512)
,p_name=>'spatialmapclick'
,p_display_name=>'Map Clicked'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(2500840574179919)
,p_plugin_id=>wwv_flow_imp.id(2801375174221512)
,p_name=>'spatialmapinitialized'
,p_display_name=>'Map Initialized'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(2501516390179938)
,p_plugin_id=>wwv_flow_imp.id(2801375174221512)
,p_name=>'spatialmapobjectclick'
,p_display_name=>'Map Object Clicked'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/share
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2969861332562847)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHARE'
,p_display_name=>'Share'
,p_category=>'MISC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHARE'),'')
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#da.share#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_version_scn=>72472653
,p_subscribe_plugin_settings=>true
,p_help_text=>'Share the current page of this application, a different URL or files with other applications.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2970299354567615)
,p_plugin_id=>wwv_flow_imp.id(2969861332562847)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'The title to be shared.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2970637007568522)
,p_plugin_id=>wwv_flow_imp.id(2969861332562847)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Text'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_help_text=>'The text to be shared.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2970882204571148)
,p_plugin_id=>wwv_flow_imp.id(2969861332562847)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Share Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'current_page'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose to share the current page, a URL or files.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2971226676572422)
,p_plugin_attribute_id=>wwv_flow_imp.id(2970882204571148)
,p_display_sequence=>10
,p_display_value=>'Current Page'
,p_return_value=>'current_page'
,p_help_text=>'Share the current page that the user is viewing.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2971576773573670)
,p_plugin_attribute_id=>wwv_flow_imp.id(2970882204571148)
,p_display_sequence=>20
,p_display_value=>'URL'
,p_return_value=>'url'
,p_help_text=>'Share a page in this application, a page from another application, or a custom URL.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(7002700780023840)
,p_plugin_attribute_id=>wwv_flow_imp.id(2970882204571148)
,p_display_sequence=>30
,p_display_value=>'File(s)'
,p_return_value=>'files'
,p_help_text=>'Share one or multiple files, statically defined or from a SQL query.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2973484172585736)
,p_plugin_id=>wwv_flow_imp.id(2969861332562847)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'URL'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2970882204571148)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'url'
,p_help_text=>'The URL to be shared. This can be a page in this application, a page from another application or a custom URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2973809751588755)
,p_plugin_id=>wwv_flow_imp.id(2969861332562847)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'File(s) Source'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'file_url'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2970882204571148)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'files'
,p_lov_type=>'STATIC'
,p_help_text=>'Choose between providing URL(s) or an SQL query for the files to be shared.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2974118259591587)
,p_plugin_attribute_id=>wwv_flow_imp.id(2973809751588755)
,p_display_sequence=>10
,p_display_value=>'File URL(s)'
,p_return_value=>'file_url'
,p_help_text=>'Enter file URL(s) to be shared. Each URL must be written on a new line.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2974547024593064)
,p_plugin_attribute_id=>wwv_flow_imp.id(2973809751588755)
,p_display_sequence=>20
,p_display_value=>'SQL Query'
,p_return_value=>'sql_query'
,p_help_text=>'Enter a SQL query to fetch the files from the database.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2975355561606665)
,p_plugin_id=>wwv_flow_imp.id(2969861332562847)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'File URL(s)'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2973809751588755)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'file_url'
,p_help_text=>'The URL(s) to the file(s) you want to share. Start each URL on a new line for multiple files.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2975618008609487)
,p_plugin_id=>wwv_flow_imp.id(2969861332562847)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>2
,p_sql_max_column_count=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2973809751588755)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql_query'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use an SQL query to retrieve BLOB data to be shared. Below are the columns used for the query. If a mime type column is not provided then the mime type will be determined using the file name.</p>',
'',
'<pre>',
'Query Columns Expected:',
'1. BLOB Column (required)',
'2. File Name Column (required)',
'3. Mime Type Column (optional)',
'</pre>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2422779822841268)
,p_plugin_id=>wwv_flow_imp.id(2969861332562847)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Items to Submit'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2973809751588755)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql_query'
,p_help_text=>'<p>Enter column, page or application items to set into session state when evaluating the SQL Query for the Share dynamic action. For multiple items, separate each item name with a comma. You can type in the name or pick from the list of available ite'
||'ms. If you pick from the list and there is already text entered, then a comma is placed at the end of the existing text, followed by the item name returned from the list.</p>'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/get_current_position
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2976029985616084)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GET_CURRENT_POSITION'
,p_display_name=>'Get Current Position'
,p_category=>'MISC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GET_CURRENT_POSITION'),'')
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#da.geolocation#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_version_scn=>72472653
,p_subscribe_plugin_settings=>true
,p_help_text=>'Triggers the device to return its current position. The device will ask permission to first time users.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2976306864619246)
,p_plugin_id=>wwv_flow_imp.id(2976029985616084)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'geojson'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose between returning the GeoJSON to a page item, Latitude and Longitude to a page item, or full object to a JavaScript function.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2976596181620188)
,p_plugin_attribute_id=>wwv_flow_imp.id(2976306864619246)
,p_display_sequence=>10
,p_display_value=>'GeoJSON'
,p_return_value=>'geojson'
,p_help_text=>'Returns the GeoJSON as a string to a page item.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2976933016621244)
,p_plugin_attribute_id=>wwv_flow_imp.id(2976306864619246)
,p_display_sequence=>20
,p_display_value=>'Latitude and Longitude'
,p_return_value=>'lat_long'
,p_help_text=>'Returns the latitude and longitude to two different page items.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2977389083624053)
,p_plugin_attribute_id=>wwv_flow_imp.id(2976306864619246)
,p_display_sequence=>30
,p_display_value=>'JavaScript Function'
,p_return_value=>'javascript_code'
,p_help_text=>'Get the full Geolocation Position object to use in a JavaScript function.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2978323869631669)
,p_plugin_id=>wwv_flow_imp.id(2976029985616084)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2976306864619246)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'geojson'
,p_help_text=>'Enter the page item to return the GeoJSON string to.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2978690004635198)
,p_plugin_id=>wwv_flow_imp.id(2976029985616084)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Latitude Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2976306864619246)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'lat_long'
,p_help_text=>'Enter the page item to return the latitude to.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2978935187637955)
,p_plugin_id=>wwv_flow_imp.id(2976029985616084)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Longitude Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2976306864619246)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'lat_long'
,p_help_text=>'Enter the page item to return the longitude to.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2979298262640476)
,p_plugin_id=>wwv_flow_imp.id(2976029985616084)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'JavaScript Function'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2976306864619246)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'javascript_code'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( position, event ) {',
'    apex.debug.log( position, event );',
'}',
'</pre>'))
,p_help_text=>'Enter a JavaScript function that takes a GeolocationPosition object as the first parameter and the event as the second parameter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2979544911644044)
,p_plugin_id=>wwv_flow_imp.id(2976029985616084)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Enable High Accuracy'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Choose if high accuracy geolocation should be enabled. When enabled, the device will provide a more accurate position but this can result in a slower response time or increased power consumption. If disabled, the device can take the liberty to save r'
||'esources by responding more quickly and/or using less power. Default: disabled.'
);
end;
/
prompt --application/shared_components/plugins/item_type/image_upload
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3003081863951416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'IMAGE_UPLOAD'
,p_display_name=>'Image Upload'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','IMAGE_UPLOAD'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.cropperEditor#MIN#.js',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#item.FileUpload#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_version_scn=>72472657
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays an Image Upload item. This item allows users to upload one or multiple images from their local file system or device. Those images can be optionally cropped or resized.'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(3003634769959186)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_title=>'Display'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(3004020609959187)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_title=>'Storage'
,p_display_sequence=>20
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(3004408802959187)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_title=>'Cropping'
,p_display_sequence=>30
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(10400611178493474)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_title=>'Resize To'
,p_display_sequence=>40
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3010020882043238)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3004020609959187)
,p_help_text=>'Select the database table where the uploaded file is stored.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3010372468044442)
,p_plugin_attribute_id=>wwv_flow_imp.id(3010020882043238)
,p_display_sequence=>10
,p_display_value=>'BLOB column specified in Item Source attribute'
,p_return_value=>'DB_COLUMN'
,p_help_text=>'Stores the uploaded file in the table used by the <strong>Automatic Row Processing (DML)</strong> process and the column specified in the item source attribute. The column has to be of data type BLOB. If the file gets downloaded, the table name of th'
||'e <strong>Automatic Row Fetch</strong> process is used.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3010793644045885)
,p_plugin_attribute_id=>wwv_flow_imp.id(3010020882043238)
,p_display_sequence=>20
,p_display_value=>'Table APEX_APPLICATION_TEMP_FILES'
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Stores the uploaded file(s) in a temporary location that you can access with the view APEX_APPLICATION_TEMP_FILES. &PRODUCT_NAME. will automatically delete the file(s) at the end of the session or at the end of the upload request, depending on wha'
||'t you choose for <strong>Purge File At</strong>.</p>',
'<p>To access a file if <strong>Allow Multiple Files</strong> is set to <strong>No</strong>:</p>',
'<pre>',
'select *',
'  from apex_application_temp_files',
' where name = :<em>page item name</em>;',
'</pre>',
'<p>To access files if <strong>Allow Multiple Files</strong> is set to <strong>Yes</strong>:</p>',
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
'                        p_str => :<em>page item name</em>,',
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
'        -- add code here to store the uploaded file in your own table',
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3012307380063342)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'MIME Type Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3010020882043238)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_attribute_group_id=>wwv_flow_imp.id(3004020609959187)
,p_help_text=>'Enter the uppercase page or application item name used to store the mime type of the uploaded file. The mime type is used by the browser to identify which application is used to display the content of the BLOB when the file is downloaded.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3012646603065376)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Filename Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3010020882043238)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_attribute_group_id=>wwv_flow_imp.id(3004020609959187)
,p_help_text=>'Enter the page or application item used to store the filename of the uploaded file.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3013230026072217)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'BLOB Last Updated Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3010020882043238)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_attribute_group_id=>wwv_flow_imp.id(3004020609959187)
,p_help_text=>'Enter the uppercase page or application item name used to store the current timestamp when a file is uploaded. This date value is used for browser caching.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11801545198218631)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Display Download Link'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3010020882043238)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_attribute_group_id=>wwv_flow_imp.id(3003634769959186)
,p_help_text=>'Specify whether the download link displays when there is a non-empty BLOB associated with this item.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11801869651225300)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Download Link Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(11801545198218631)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(3003634769959186)
,p_help_text=>'Enter the text to displayed as part of the download link. If not specified, the text stored in the Text Message for <code>APEX.ITEM.IMAGE_UPLOAD.DOWNLOAD_LINK_TEXT</code>, within Shared Components, displays.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3013557247073844)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Purge Files at'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3010020882043238)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3004020609959187)
,p_help_text=>'Define when &PRODUCT_NAME. should remove the temporary file.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3013908823075201)
,p_plugin_attribute_id=>wwv_flow_imp.id(3013557247073844)
,p_display_sequence=>10
,p_display_value=>'End of Session'
,p_return_value=>'SESSION'
,p_help_text=>'Delete the file at the end of the current &PRODUCT_NAME. session.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3014325232077841)
,p_plugin_attribute_id=>wwv_flow_imp.id(3013557247073844)
,p_display_sequence=>20
,p_display_value=>'End of Request'
,p_return_value=>'REQUEST'
,p_help_text=>'Delete the file at the end of the current HTTP request.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3021220512136477)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Allow Multiple Files'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3010020882043238)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_group_id=>wwv_flow_imp.id(3004020609959187)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether multiple files can be uploaded at once.</p>',
'',
'<p>Note - Multiple file names will be stored as a colon delimited list in the page item.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3004956677963229)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>'Display As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DROPZONE_ICON'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3003634769959186)
,p_help_text=>'Select a display style for image upload item.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3005318621967461)
,p_plugin_attribute_id=>wwv_flow_imp.id(3004956677963229)
,p_display_sequence=>10
,p_display_value=>'Inline File Browse'
,p_return_value=>'INLINE'
,p_help_text=>'Display the image upload input field similar to other text fields and items on the page.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3005756686971233)
,p_plugin_attribute_id=>wwv_flow_imp.id(3004956677963229)
,p_display_sequence=>20
,p_display_value=>'Icon Dropzone'
,p_return_value=>'DROPZONE_ICON'
,p_help_text=>'Displays an icon only drop zone which is replaced with a preview of the image or multi-image icon when there is a value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3006118641973922)
,p_plugin_attribute_id=>wwv_flow_imp.id(3004956677963229)
,p_display_sequence=>30
,p_display_value=>'Inline Dropzone'
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>'Display the image upload input field as an inline drop zone and features a title and description. When the inline drop zone has a value the icon is replaced with a preview of the selected image or an icon for multiple images.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3006508397975340)
,p_plugin_attribute_id=>wwv_flow_imp.id(3004956677963229)
,p_display_sequence=>40
,p_display_value=>'Block Dropzone'
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>'Display the image upload input field as a wizard-style drop zone that features a title and description, and a button to select files. When the drop zone has a value the icon is replaced with a preview of the selected image or an icon for multiple ima'
||'ges.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3006909442976895)
,p_plugin_attribute_id=>wwv_flow_imp.id(3004956677963229)
,p_display_sequence=>50
,p_display_value=>'Native File Browse'
,p_return_value=>'NATIVE'
,p_help_text=>'Use the browser''s native formatting to display the file browse item.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3008540816002314)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>'Dropzone Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(3004956677963229)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_attribute_group_id=>wwv_flow_imp.id(3003634769959186)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the title for the Dropzone.',
'If this field is left blank, the Text Messages <code>APEX.ITEM.FILE.DROP_FILE</code> or <code>APEX.ITEM.FILE.DROP_FILES</code> will be used by default.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3008883548005350)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>'Dropzone Description'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3004956677963229)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_attribute_group_id=>wwv_flow_imp.id(3003634769959186)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the description text for the Dropzone.</p>',
'<p>If this field is left blank, the following Text Messages will be used by default, depending on the Display As property.</p>',
'<p><strong>Block Drop Zone</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
'<p><strong>Inline Drop Zone</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3020909769128575)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Maximum File Size'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'KB'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(10400611178493474)
,p_help_text=>'Maximum file size for images set in KB. If a value is entered the image will be scaled down to fit.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3019985418120815)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>'Maximum Width'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'PX'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(10400611178493474)
,p_help_text=>'Maximum width for images set in pixels. If a value is entered the image will be scaled down to fit.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3020269081123060)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>'Maximum Height'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'PX'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(10400611178493474)
,p_help_text=>'Maximum height for images set in pixels. If a value is entered the image will be scaled down to fit.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3022331112154077)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>'Allow Cropping'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3021220512136477)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(3004408802959187)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify if users can crop uploaded images.</p>',
'<p>When enabled you will also be able to set the aspect ration for the cropped image. By default the aspect ratio will match the file being uploaded unless another option is defined.</p>',
'<p>Cropping is not currently supported when "Multiple Files" is enabled.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3022666416155451)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>'Aspect Ratio'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTO'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3022331112154077)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3004408802959187)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the aspect ratio for the cropper to use.</p>',
'<p>Original will use the aspect ration of the uploaded image</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3024545969164278)
,p_plugin_attribute_id=>wwv_flow_imp.id(3022666416155451)
,p_display_sequence=>10
,p_display_value=>'Original'
,p_return_value=>'AUTO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3022996770158651)
,p_plugin_attribute_id=>wwv_flow_imp.id(3022666416155451)
,p_display_sequence=>20
,p_display_value=>'1:1 (square)'
,p_return_value=>'1:1'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3023358899159834)
,p_plugin_attribute_id=>wwv_flow_imp.id(3022666416155451)
,p_display_sequence=>30
,p_display_value=>'16:9 (widescreen)'
,p_return_value=>'16:9'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3023772872161120)
,p_plugin_attribute_id=>wwv_flow_imp.id(3022666416155451)
,p_display_sequence=>40
,p_display_value=>'4:3 (standard)'
,p_return_value=>'4:3'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3024196288162804)
,p_plugin_attribute_id=>wwv_flow_imp.id(3022666416155451)
,p_display_sequence=>50
,p_display_value=>'2:1 (univisium)'
,p_return_value=>'2:1'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3024989039164808)
,p_plugin_attribute_id=>wwv_flow_imp.id(3022666416155451)
,p_display_sequence=>60
,p_display_value=>'Custom'
,p_return_value=>'CUSTOM'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3025976640178182)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>'Custom Aspect Ratio'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3022666416155451)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_attribute_group_id=>wwv_flow_imp.id(3004408802959187)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Set a custom aspect ratio for the crop window to use</p>',
'<p>Aspect ratio must be set either as a fraction, decimal, or : representation</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3001152461115797)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>80
,p_prompt=>'Capture Using'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3003634769959186)
,p_null_text=>'None'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Setting the default camera lets you default the Image Upload item to opening the devices camera when the app is used from a mobile device.</p>',
'<p>It is important to note that if the default camera option is set, on a mobile device the user will not be able to select files but they will be able to take a photo, switch cameras, or use photos already existing on their device.</p>',
'<p>On a desktop the item will always function the same regardless of the value chosen.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3001881058121628)
,p_plugin_attribute_id=>wwv_flow_imp.id(3001152461115797)
,p_display_sequence=>10
,p_display_value=>'Selfie Camera'
,p_return_value=>'USER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3002261326124762)
,p_plugin_attribute_id=>wwv_flow_imp.id(3001152461115797)
,p_display_sequence=>20
,p_display_value=>'Main Camera'
,p_return_value=>'ENVIRONMENT'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(12200391620882667)
,p_plugin_id=>wwv_flow_imp.id(3003081863951416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>40
,p_prompt=>'Preview Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTO'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3004956677963229)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DROPZONE_ICON'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3003634769959186)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Set the size of the displayed preview.</p>',
'<p>Default is "Auto" which uses the image''s size. Additional sizes are defined in the theme using the class apex-item-image--{size}.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1810887748586335)
,p_plugin_attribute_id=>wwv_flow_imp.id(12200391620882667)
,p_display_sequence=>10
,p_display_value=>'Auto'
,p_return_value=>'AUTO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1808909061578715)
,p_plugin_attribute_id=>wwv_flow_imp.id(12200391620882667)
,p_display_sequence=>20
,p_display_value=>'Extra Small'
,p_return_value=>'XS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(12200647829884079)
,p_plugin_attribute_id=>wwv_flow_imp.id(12200391620882667)
,p_display_sequence=>30
,p_display_value=>'Small'
,p_return_value=>'SM'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(12201055881884752)
,p_plugin_attribute_id=>wwv_flow_imp.id(12200391620882667)
,p_display_sequence=>40
,p_display_value=>'Medium'
,p_return_value=>'MD'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(12201446980885859)
,p_plugin_attribute_id=>wwv_flow_imp.id(12200391620882667)
,p_display_sequence=>50
,p_display_value=>'Large'
,p_return_value=>'LG'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(12201895677886919)
,p_plugin_attribute_id=>wwv_flow_imp.id(12200391620882667)
,p_display_sequence=>60
,p_display_value=>'Extra Large'
,p_return_value=>'XL'
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3128550315022076)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>'Form'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_version_scn=>1088654313
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Form region which supports different data sources. This form region holds information on the data source (which can be local, remote or REST service) and has page items assigned to it. Each item is assigned to a form region and a display region.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(3128740851022088)
,p_plugin_id=>wwv_flow_imp.id(3128550315022076)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3129968725049081)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>'Form - Automatic Row Processing (DML)'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_version_scn=>72472659
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process to insert, update, or delete a form region row(s).'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3130191485054761)
,p_plugin_id=>wwv_flow_imp.id(3129968725049081)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Target Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select which row processing technique is performed to save data changes made to the Form Region.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3130418909057477)
,p_plugin_attribute_id=>wwv_flow_imp.id(3130191485054761)
,p_display_sequence=>10
,p_display_value=>'Region Source'
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Inserts, updates, and deletes utilize the region source SQL Query .</p>',
'<p>Note - Ensure columns that are not insertable or updatable have <strong>Query Only</strong>  set to <code>Yes</code>, to exclude them from processing.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3131111455059474)
,p_plugin_attribute_id=>wwv_flow_imp.id(3130191485054761)
,p_display_sequence=>20
,p_display_value=>'Table / View'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Inserts, updates, and deletes utilize a different table or view to the one defined in the region source SQL Query.',
'For example, the SQL Query retrieves data from a table-join or non-undateable view and the DML processing needs to be performed against a single base table or updatable view.</p>',
'<p>Note - Ensure columns that are not insertable or updatable have <strong>Query Only</strong> set to <code>Yes</code>, to exclude them from processing.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3131849869061275)
,p_plugin_attribute_id=>wwv_flow_imp.id(3130191485054761)
,p_display_sequence=>30
,p_display_value=>'PL/SQL Code'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Processing is based on custom PL/SQL code. This option allows you to execute any PL/SQL code to implement any data manipulation in the underlying database.</p>',
'<p>This option should be utilized when using database packages, such as table APIs or calls to RESTful Web Services, to implement business logic.</p>',
'<p>Note - The PL/SQL code will be called for each row that has been inserted, updated or deleted.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3132468628068159)
,p_plugin_id=>wwv_flow_imp.id(3129968725049081)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Table Owner'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3130191485054761)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Select the table owner (schema) name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3132746852071841)
,p_plugin_id=>wwv_flow_imp.id(3129968725049081)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Table Name'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(3132468628068159)
,p_depending_on_attribute_id=>wwv_flow_imp.id(3130191485054761)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Enter the case-sensitive table or view name. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3133042217093897)
,p_plugin_id=>wwv_flow_imp.id(3129968725049081)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'PL/SQL Code to Insert/Update/Delete'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3130191485054761)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :P1_EMPNO, :P1_ENAME, :P1_DEPTNO )',
'        returning rowid into :P1_ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :P1_ENAME,',
'               deptno = :P1_DEPTNO',
'         where rowid  = :P1_ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :P1_ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter PL/SQL code to process each row of data manipulated in the Form Region.</p>',
'<p>Use the page item name as a bind variable to access its value. The system variable <code>APEX$ROW_STATUS</code> returns the status of a row and can be used to check if the row has been created, updated or deleted (see example below for how to chec'
||'k this).</p>',
'<p><em>Note:</em> If primary key columns get populated by a trigger or in the PL/SQL code, it is a requirement that the new values are assigned to the bind variables of the primary key columns, because &PRODUCT_NAME. uses those values to fetch the ro'
||'w after an insert or update.</p>',
'<p>Oracle recommends calling procedures or functions within a PL/SQL package, to facilitate reuse and maintainability.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3133532996097347)
,p_plugin_id=>wwv_flow_imp.id(3129968725049081)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Prevent Lost Updates'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether processing should ensure that updates are not lost when multiple users update the same database record.</p> ',
'<p>Lost updates occur when two or more people try to update the same data, and the last update overwrites updates made by the first user to save changes. To prevent this from happening, updates can check the existing column value(s) in the database w'
||'ith the value(s) retrieved when the row was originally queried.</p>',
'<p>For example:',
'  <ol>',
'    <li>User A queries employee (EMP) records.</li>',
'    <li>User B queries the same employee records.</li>',
'    <li>User B updates employee details for EMPNO = 7839 and applies (commits) the changes to the database.</li>',
'    <li>User A Updates employee details for EMPNO = 7839 and is attempting to apply the changes to the database.</li>',
'  </ol>',
'If User A successfully updates the same row, changes made by User B will be lost.',
'When User A is attempting to save the employee row, then the data in the database is different from what User A queried originally. In step 1 above, the column value(s) originally queried by User A can be captured. Then in Step 4 above, the value(s) '
||'can be compared to the current values in the database. This comparison will raise an error for User A, as the database value(s) were updated by User B in Step 3. This prevents a user from overwriting changes made by another ',
'user to the same row.</p>',
'<p>Note</p>',
'<ul>',
'<li>How the lost updates are detected is specified in the Attributes for the Form region, based on the setting for <strong>Lost Update Type</strong>.</li>',
'<li>Lost Update Detection is <em>not available</em> for Form Regions using a <strong>REST Data Source</strong> and a <strong>Target Type</strong> of <strong>Table/View</strong> or <strong>PL/SQL Code</strong>.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3134090605099409)
,p_plugin_id=>wwv_flow_imp.id(3129968725049081)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Lock Row'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether each row to be updated or deleted is locked in the underlying table before processing the row.</p>',
'<p>Note: Lock Rows is <em>not available</em> for Form Regions using a <strong>REST Data Source</strong> and a <strong>Target Type</strong> of <strong>Table/View</strong> or <strong>PL/SQL Code</strong>.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3134396093101055)
,p_plugin_attribute_id=>wwv_flow_imp.id(3134090605099409)
,p_display_sequence=>10
,p_display_value=>'Yes'
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Rows to be updated or deleted will be locked using SELECT ... FOR UPDATE to prevent other transactions being performed on the row until the transaction is committed.</p>',
'<p>Note - If an error is raised, such as for updatable views that do not support locking, then you may be able to utilize PL/SQL code to lock the driving table.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3135017839102248)
,p_plugin_attribute_id=>wwv_flow_imp.id(3134090605099409)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'Rows will not be locked.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3135486454103394)
,p_plugin_attribute_id=>wwv_flow_imp.id(3134090605099409)
,p_display_sequence=>30
,p_display_value=>'PL/SQL Code'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>'Custom PL/SQL code will be used to lock the rows until the transaction is committed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3136083157108563)
,p_plugin_id=>wwv_flow_imp.id(3129968725049081)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'PL/SQL Code to Lock Row'
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3134090605099409)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :P1_EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>'Enter the PL/SQL code to lock the database table rows to be updated and deleted.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3136593347114047)
,p_plugin_id=>wwv_flow_imp.id(3129968725049081)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Return Primary Key(s) after Insert'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3130191485054761)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether the primary key column(s) should be returned to the corresponding region items once the row is inserted into the database.',
'Generally, this option should be used when the primary key columns are populated from a database trigger or an Oracle Database 12 <em>c</em> Identity column.</p>',
'<p>Note - If an error is raised specifying that the RETURNING INTO clause is not allowed, you must set this option to No and pre-populate the primary key column(s).</p>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3136784192133583)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>'Form - Initialization'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_version_scn=>72472660
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process to initialize form region items. Initialization can either be fetching data from the region source, using the primary key value(s) or simple initialization of the form region items.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1672950586323461)
,p_plugin_id=>wwv_flow_imp.id(3136784192133583)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Next Primary Key Item(s)'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1673291445325769)
,p_plugin_id=>wwv_flow_imp.id(3136784192133583)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Previous Primary Key Item(s)'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1673579797330204)
,p_plugin_id=>wwv_flow_imp.id(3136784192133583)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Current Row/Total Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/workflow_start
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3200217660406011)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WORKFLOW_START'
,p_display_name=>'Workflow Start'
,p_supported_component_types=>'APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WORKFLOW_START'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472660
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process begins the execution of the workflow in which this process has been added as an activity.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/invoke_api
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3204699598107993)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'INVOKE_API'
,p_display_name=>'Invoke API'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','INVOKE_API'),'')
,p_api_version=>2
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_version_scn=>72472660
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Process invokes a procedure or function stored in the local database or an operation defined in a REST Data Source.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3205316962114587)
,p_plugin_id=>wwv_flow_imp.id(3204699598107993)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLSQL_PACKAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select whether to call a procedure or function within a PL/SQL package or a standalone one, or an operation defined in a REST Data Source.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3205679693115886)
,p_plugin_attribute_id=>wwv_flow_imp.id(3205316962114587)
,p_display_sequence=>10
,p_display_value=>'PL/SQL Package'
,p_return_value=>'PLSQL_PACKAGE'
,p_is_quick_pick=>true
,p_help_text=>'Call a procedure or function of a PL/SQL package stored in the local database.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3206069670120924)
,p_plugin_attribute_id=>wwv_flow_imp.id(3205316962114587)
,p_display_sequence=>20
,p_display_value=>'PL/SQL Procedure or Function'
,p_return_value=>'PLSQL_PROCEDURE_FUNCTION'
,p_help_text=>'Call a standalone PL/SQL procedure or function stored in the local database.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1601477945162805)
,p_plugin_attribute_id=>wwv_flow_imp.id(3205316962114587)
,p_display_sequence=>30
,p_display_value=>'REST Source'
,p_return_value=>'WEB_SOURCE'
,p_help_text=>'Call a REST Operation, defined in Shared Components, REST Data Sources.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3206448001147336)
,p_plugin_id=>wwv_flow_imp.id(3204699598107993)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Owner'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3205316962114587)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_PACKAGE,PLSQL_PROCEDURE_FUNCTION'
,p_help_text=>'Select the PL/SQL Package, PL/SQL Stored Procedure, or Function owner (schema) name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3206787696162763)
,p_plugin_id=>wwv_flow_imp.id(3204699598107993)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Package'
,p_attribute_type=>'PLSQL PACKAGE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(3206448001147336)
,p_depending_on_attribute_id=>wwv_flow_imp.id(3205316962114587)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_PACKAGE'
,p_help_text=>'Enter the <em>case-sensitive</em> PL/SQL package name. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3207097131168699)
,p_plugin_id=>wwv_flow_imp.id(3204699598107993)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Procedure or Function'
,p_attribute_type=>'PLSQL METHOD'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(3206787696162763)
,p_depending_on_attribute_id=>wwv_flow_imp.id(3205316962114587)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_PACKAGE'
,p_help_text=>'Enter the <em>case-sensitive</em> procedure or function name defined in the selected PL/SQL package. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3207591290187072)
,p_plugin_id=>wwv_flow_imp.id(3204699598107993)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Procedure or Function'
,p_attribute_type=>'PLSQL METHOD'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(3206448001147336)
,p_depending_on_attribute_id=>wwv_flow_imp.id(3205316962114587)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_PROCEDURE_FUNCTION'
,p_help_text=>'Enter the <em>case-sensitive</em> procedure or function name of a standalone stored PL/SQL procedure or function defined in the database. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1604995097716069)
,p_plugin_id=>wwv_flow_imp.id(3204699598107993)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'REST Source'
,p_attribute_type=>'REST SOURCE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3205316962114587)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'WEB_SOURCE'
,p_help_text=>'Choose the REST Source which contains the Operation to be invoked.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1605669904723951)
,p_plugin_id=>wwv_flow_imp.id(3204699598107993)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Operation'
,p_attribute_type=>'REST OPERATION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(1604995097716069)
,p_depending_on_attribute_id=>wwv_flow_imp.id(3205316962114587)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'WEB_SOURCE'
,p_help_text=>'Choose the Operation to invoke. The select list shows the <strong>name</strong>, if configured for the REST Operation. Otherwise, its <strong>HTTP method</strong> and <strong>URL pattern</strong> will be shown.'
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3205849286768480)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>'Data Loading'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472660
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process to load data into the target table or collection based on the given data load definition.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3206362206778771)
,p_plugin_id=>wwv_flow_imp.id(3205849286768480)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Data Load Definition'
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Select the <strong>Data Load Definition</strong> from Shared Components. Among other attributes, the data load definition defines the target table or collection, the loading method and the <em>Data Profile</em>. All column name, column mapping and da'
||'ta type information is stored in the data profile.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3206568816782155)
,p_plugin_id=>wwv_flow_imp.id(3205849286768480)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Source Data Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify the source of the data to load.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3206878557783527)
,p_plugin_attribute_id=>wwv_flow_imp.id(3206568816782155)
,p_display_sequence=>10
,p_display_value=>'File Browse Item'
,p_return_value=>'FILE'
,p_help_text=>'Pick the name of a file browse item on the current page. APEX will load data from the chosen file.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3207319585784462)
,p_plugin_attribute_id=>wwv_flow_imp.id(3206568816782155)
,p_display_sequence=>20
,p_display_value=>'Textarea item name'
,p_return_value=>'TEXT'
,p_help_text=>'Pick the name of a text area item, which contains data to be loaded.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3207692626786156)
,p_plugin_attribute_id=>wwv_flow_imp.id(3206568816782155)
,p_display_sequence=>30
,p_display_value=>'SQL Query'
,p_return_value=>'SQL_QUERY'
,p_help_text=>'Provide a SQL Query returning a CLOB or a BLOB containing the data to load.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3208086445789769)
,p_plugin_id=>wwv_flow_imp.id(3205849286768480)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'File Browse item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3206568816782155)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>'Pick the file browse item to load data from. The item must use <strong>APEX_APPLICATION_TEMP_FILES</strong> as its <strong>Storage Type</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3208411305791534)
,p_plugin_id=>wwv_flow_imp.id(3205849286768480)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Textarea item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3206568816782155)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>'Pick the name of a textarea item, which contains data to be loaded.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3208742752793524)
,p_plugin_id=>wwv_flow_imp.id(3205849286768480)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3206568816782155)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>'Provide a SQL query returning one row and one column, which contains a BLOB or CLOB to load data from.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3209026300796805)
,p_plugin_id=>wwv_flow_imp.id(3205849286768480)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Page item containing XLSX Sheet Name'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A select list or popup LOV item to display available worksheets in the uploaded XLSX file would use the following <em>List Of Values SQL Query</em> (<strong>PX_FILE</strong> is the file browse item used to upload the XLSX file).</p><p>Note that th'
||'e <strong>SHEET_FILE_NAME</strong> attribute must be used as the LOV return column.</p>',
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>'<p>Provide a page item containing a worksheet name for loading of XLSX files. Data will be loaded from the specified worksheet. If not provided, APEX will load data from the first worksheet in the XLSX file.</p><p>Typically, <em>select list</em> item'
||'s are used for this: In the <em>List Of Values query</em>, use <strong>APEX_DATA_PARSER.GET_XLSX_WORKSHEETS</strong> in order to retrieve worksheet display and internal names.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1319771677848714)
,p_plugin_id=>wwv_flow_imp.id(3205849286768480)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Processed Row Count Item'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>'Pick a page item to store the amount of uploaded (and processed) rows into. The value is available after the Data Loading process completes and can be used for display in messages.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1320047176851343)
,p_plugin_id=>wwv_flow_imp.id(3205849286768480)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Error Row Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>'Pick a page item to store the amount of error rows into. The value is available after the Data Loading process completes and can be used for display in messages.'
);
end;
/
prompt --application/shared_components/plugins/process_type/workflow_end
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3400214027498015)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WORKFLOW_END'
,p_display_name=>'Workflow End'
,p_supported_component_types=>'APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WORKFLOW_END'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472660
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process completes the execution of the workflow in which this process has been added as an activity. When the <strong>End State</strong> attribute is specified as Completed, the workflow ends with a Completed state. When the end state is specified as'
||' Terminated, the workflow ends in a Terminated state.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3600220197502078)
,p_plugin_id=>wwv_flow_imp.id(3400214027498015)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'End State'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'COMPLETED'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3600574414505826)
,p_plugin_attribute_id=>wwv_flow_imp.id(3600220197502078)
,p_display_sequence=>10
,p_display_value=>'Completed'
,p_return_value=>'COMPLETED'
,p_help_text=>'This is the natural state of termination of a workflow when all its activities are completed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3600924800510006)
,p_plugin_attribute_id=>wwv_flow_imp.id(3600220197502078)
,p_display_sequence=>20
,p_display_value=>'Terminated'
,p_return_value=>'TERMINATED'
,p_help_text=>'This End state represents a forced termination of the workflow.'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(4021805768598102)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'Oracle Cloud Applications (SaaS) REST Service'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>55031263
,p_subscribe_plugin_settings=>true
,p_help_text=>'Use Oracle ADF REST services as REST Data Sources.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(6046040466532396)
,p_plugin_id=>wwv_flow_imp.id(4021805768598102)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Sandbox Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Provides the name of a metadata sandbox (if any) to use in App Builder and at runtime when using this Oracle SaaS REST service. Oracle SaaS REST endpoints automatically reflect application customizations made to the system. If you need to develop an '
||'APEX application against in-progress customizations being made in a named metadata sandbox, set the value of this component setting to the case-sensitive name of the sandbox that APEX should use. If the value is null, then APEX works with the version'
||' of the REST service that only reflects published customizations.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3223378656446808)
,p_plugin_id=>wwv_flow_imp.id(4021805768598102)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Advanced Settings'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Provides the case-sensitive names of advanced settings to be used with the guidance of Oracle Support, one setting name per line.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(4950030211157982)
,p_plugin_id=>wwv_flow_imp.id(4021805768598102)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Use Batch DML?'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Batch DML improves performance and transactional integrity by grouping multiple delete, update, and insert operations against this REST service into a single exchange with the remote server. Oracle recommends disabling this setting only if you encoun'
||'ter functional issues with a particular SaaS service endpoint while using batch DML.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(8816555877136473)
,p_plugin_id=>wwv_flow_imp.id(4021805768598102)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Root Resource Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(4950030211157982)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Provides the case-sensitive name of the root business object resource. All batch operations related to this REST service use its root resource''s batch endpoint. For an Oracle Cloud Applications (SaaS) REST Service, this is typically the name of the t'
||'op-level business object like "order", even when the service you are working with might be a nested resource like the order''s line items. For example, when working with a REST service endpoint URL like https://example.org/rest/r12/order or a nested r'
||'esource like https://example.org/rest/r12/order/12345/child/orderLinesCollection, in both cases the root resource name is "order". For a new REST data source, APEX will set this name automatically, but an existing REST data source can enable batch DM'
||'L operations by entering the appropriate root resource name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(4870728575905830)
,p_plugin_id=>wwv_flow_imp.id(4021805768598102)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use Total Results?'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'An Oracle Cloud Applications (SaaS) REST Service supports returning the total number of results, even if only a subset are returned (for example, the first pageful). In certain situations, this total row computation may add unwanted runtime overhead.'
||' You can disable APEX''s use of this feature for this data source by setting the value to No.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9319255455314055)
,p_plugin_id=>wwv_flow_imp.id(4021805768598102)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Use Pagination?'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'In general, Oracle Cloud Applications (SaaS) REST services support retrieving results a page at a time. However, if this data source''s endpoint does not support the "offset" parameter, then set this property to No to disable pagination.'
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(4386180889228297)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>'Range'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:FORMAT_MASK_DATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Displays an item with a built-in list of values selector. Each option represents a range of values, from a lower to an upper boundary.  The facet supports single or multiple selection, and manual entry. ',
'</p>',
'<p>',
'For single selection support, displays multiple values as radio group options, enabling the end user to select a single value. For multiple selection support, displays multiple values as check boxes, enabling the end user to select multiple values. ',
'For manual entry support, text fields will render below the facet, allowing the end user to manually enter the range of values they wish to use for filtering the Filtered region.</p> ',
'<p>',
'For filtering and count computation, the lower boundary of a specified range is always treated <em>inclusive</em>, and the upper boundary is <em>exclusive</em>. Example LOV Syntax:',
'</p>',
'<dl>',
'<dt>Less than 100</dt><dd><code>|100</code></dd>',
'<dt>Between 100 and 500 (exclusive)</dt><dd><code>100|500</code></dd>',
'<dt>500 and more</dt><dd><code>500|</code></dd>',
'</dl>',
'<p>',
'For DATE or TIMESTAMP values, use the <code>YYYYMMDDHH24MISS</code> canonical format. The Format Mask is only used for representation on the client.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2513920677752961)
,p_plugin_id=>wwv_flow_imp.id(4386180889228297)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Select Multiple'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether the facet supports the selection of multiple list entries.  When set to <strong>On</strong>, the facet will render as checkboxes to support multiple selection.  When set to <strong>Off</strong>, the facet will render as radio group op'
||'tions, to support single selection.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2513635447749258)
,p_plugin_id=>wwv_flow_imp.id(4386180889228297)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Manual Entry'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether the Range facet supports manual entry.  When set to <strong>On</strong>, text fields will render below the facet, allowing the end user to manually enter the range of values they wish to use for filtering the Filtered region.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(4386359236228299)
,p_plugin_id=>wwv_flow_imp.id(4386180889228297)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Range Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(2513635447749258)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Enter the text to be displayed between the Manual Entry text fields.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(728476028199560899)
,p_plugin_id=>wwv_flow_imp.id(4386180889228297)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Current Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(2513635447749258)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'%0 to %1'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(728478221838569501)
,p_plugin_id=>wwv_flow_imp.id(4386180889228297)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Current Label Open High'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(2513635447749258)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Above %0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(728476302635562853)
,p_plugin_id=>wwv_flow_imp.id(4386180889228297)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Current Label Open Low'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(2513635447749258)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Below %0'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(4390664988228304)
,p_plugin_id=>wwv_flow_imp.id(4386180889228297)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>List of values based on SQL query</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>List of values with same display and return value</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Note: When selecting the same column for both the display and return values use a column alias.</p>',
'</dd>',
'<dt>List of values with bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(8870444141116576)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>'Display Map'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a map based on coordinates in GeoJSON point format.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9070464796133078)
,p_plugin_id=>wwv_flow_imp.id(8870444141116576)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Background'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select the Background Map to use. You can use out-of-the-box Map Backgrounds or choose a custom Map Background from the application''s Shared Components.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9070760381135077)
,p_plugin_attribute_id=>wwv_flow_imp.id(9070464796133078)
,p_display_sequence=>10
,p_display_value=>'Default'
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the default map background.</p>',
'<p>It either uses "OpenStreetMap Bright" or "OpenStreetMap Dark" for dark themes.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9071162492136081)
,p_plugin_attribute_id=>wwv_flow_imp.id(9070464796133078)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap Bright'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>General purpose basemap based on OpenStreetMap data. This basemap style provides detailed location context for your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">View on GitHub</a></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9071529690137784)
,p_plugin_attribute_id=>wwv_flow_imp.id(9070464796133078)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap Dark'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Non-obtrusive dark basemap based on OpenStreetMap data. This basemap style accentuates visualizations of your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license. Cartography by Stamen Design is licensed under CC0.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">View on GitHub</a></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9071983425139542)
,p_plugin_attribute_id=>wwv_flow_imp.id(9070464796133078)
,p_display_sequence=>40
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Non-obtrusive light basemap based on OpenStreetMap data. This basemap style accentuates visualizations of your data.</p>',
'<p>Style schema and definitions by KlokanTech.com & OpenMapTiles contributors, derived from "Mapbox Open Styles". Licensed under BSD/CC-BY license. Cartography by Stamen Design is licensed under CC0.</p>',
'<p><a rel="noopener noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">View on GitHub</a></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9072395929141067)
,p_plugin_attribute_id=>wwv_flow_imp.id(9070464796133078)
,p_display_sequence=>50
,p_display_value=>'Oracle World Map'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>General purpose basemap based on HERE Map data. This base map style provides location context for your data and accentuates visualization of your data.</p>',
'<p>Style schema and definitions by Oracle, USA.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2093505136427948)
,p_plugin_attribute_id=>wwv_flow_imp.id(9070464796133078)
,p_display_sequence=>60
,p_display_value=>'Shared Component'
,p_return_value=>'shared-component'
,p_help_text=>'Use one of the Map Backgrounds defined in Shared Components.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9072916496197068)
,p_plugin_id=>wwv_flow_imp.id(8870444141116576)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Zoom Level'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the zoom level for this layer to become visible.</p>',
'<p>',
'Minimum value: 1<br>',
'Maximum value: 18',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9073279785199355)
,p_plugin_id=>wwv_flow_imp.id(8870444141116576)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Show Marker'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'<p>Specify whether a marker should be displayed.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9073555327202501)
,p_plugin_id=>wwv_flow_imp.id(8870444141116576)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Marker Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(9073279785199355)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the marker fill color.</p>',
'<p>The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names. Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, gr'
||'een and blue respectively. RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9075223673219708)
,p_plugin_id=>wwv_flow_imp.id(8870444141116576)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Tooltip'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(9073279785199355)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the tooltip text for a displayed marker.</p>',
'<p>The tooltip attribute supports HTML and APEX template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9073839532205482)
,p_plugin_id=>wwv_flow_imp.id(8870444141116576)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Show Map Controls'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether map controls should be displayed.</p>',
'<p>This adds zoom and rotation controls to the map.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9074137581210550)
,p_plugin_id=>wwv_flow_imp.id(8870444141116576)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Interactive Map'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether the map should be interactive.</p>',
'<p>If set to "No", it creates a static map with no interactivity.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11976499186792296)
,p_plugin_id=>wwv_flow_imp.id(8870444141116576)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Height'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'pixels'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the height (in pixels) of the displayed map.</p>',
'<p>Map''s default height is calculated based on it''s width with an 3:2 aspect ratio.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2095679710502819)
,p_plugin_id=>wwv_flow_imp.id(8870444141116576)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>15
,p_prompt=>'Custom Background'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(9070464796133078)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'shared-component'
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>8240
,p_help_text=>'Choose one of the Map Backgrounds defined in Shared Components.'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11251017839289082)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>'Exists SQL Query'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'A query that causes the authorization scheme to pass if it returns at least one row and causes the scheme to fail if it returns no rows.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11251530568311696)
,p_plugin_id=>wwv_flow_imp.id(11251017839289082)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>'A query that causes the authorization scheme to pass if it returns at least one row and causes the scheme to fail if it returns no rows.'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11252021695318665)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>'NOT Exists SQL Query'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'A query that causes the authorization scheme to pass if it returns no rows and causes the scheme to fail if it returns one or more rows.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11252200009321795)
,p_plugin_id=>wwv_flow_imp.id(11252021695318665)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>'A query that causes the authorization scheme to fail if it returns at least one row and causes the scheme to succeed if it returns no rows.'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11252712476325388)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>'Item is NULL'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Value of item is null.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11252900140331368)
,p_plugin_id=>wwv_flow_imp.id(11252712476325388)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>'The authorization succeeds if this item''s value is null and fails otherwise.'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11253409836334113)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>'Item is NOT NULL'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Value of item is not null.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11253615031335591)
,p_plugin_id=>wwv_flow_imp.id(11253409836334113)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'The authorization succeeds if this item''s value is not null and fails otherwise'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11254106158342546)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>'PL/SQL Function Returning Boolean'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'A PL/SQL function body that returns true or false. A false value causes the authorization scheme to fail. A true value causes it to pass.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11254314469344909)
,p_plugin_id=>wwv_flow_imp.id(11254106158342546)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'PL/SQL Function Body'
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A PL/SQL function body that returns true or false. A false value causes the authorization scheme to fail. A true value causes it to pass.',
'<p/>',
'Example:',
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11255012523353865)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>'Preference equals Value'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Value of preference equals value.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11255227067358013)
,p_plugin_id=>wwv_flow_imp.id(11255012523353865)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Preference Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'The authorization succeeds if this preference''s value is equal to the value in the field below and fails if they are different'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11255701918360235)
,p_plugin_id=>wwv_flow_imp.id(11255012523353865)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'see above'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11257015209373543)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>'Preference does NOT equal Value'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Value of preference does not equal value.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11257220750375150)
,p_plugin_id=>wwv_flow_imp.id(11257015209373543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Preference Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'The authorization succeeds if this preference''s value is different to the value in the field below and fails if they are equal'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11257725944376646)
,p_plugin_id=>wwv_flow_imp.id(11257015209373543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'see above'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11258208760381085)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>'Item equals Value'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Value of item equals value.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11258417764383723)
,p_plugin_id=>wwv_flow_imp.id(11258208760381085)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'The authorization succeeds if this item''s value equals the value in the field below and fails if they are different'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11258925383385933)
,p_plugin_id=>wwv_flow_imp.id(11258208760381085)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'see above'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11259414086392075)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>'Item does NOT equal Value'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Value of item does not equal value.</p>',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11259621358394213)
,p_plugin_id=>wwv_flow_imp.id(11259414086392075)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'The authorization succeeds if this item''s value is different to the value in the field below and fails if they are equal'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11260124128395028)
,p_plugin_id=>wwv_flow_imp.id(11259414086392075)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'see above'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(12476487024106188)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>'Trigger Geocoding'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>Manually trigger the geocoding search of an <em>Geocoded Address</em> item.</p>'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(15242808636946504)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>'Social Sign-In'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Supports authentication with Google, Facebook, generic OpenID Connect, and generic OAuth2 Identity Providers.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(15243730328988135)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Credential Store'
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Select the credential store which contains Client ID and Secret for the Authentication Provider.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(15249686303031715)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(18383539811983244)
,p_plugin_attribute_id=>wwv_flow_imp.id(15249686303031715)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>'Use an OpenID Connect based authentication provider. You have to enter the provider''s OpenID Discovery URL below.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(18384865200013886)
,p_plugin_attribute_id=>wwv_flow_imp.id(15249686303031715)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
,p_help_text=>'Use an OAuth2 authentication provider. You have to enter URLs for the authorization, token and userinfo endpoints below.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(18650405105549494)
,p_plugin_attribute_id=>wwv_flow_imp.id(15249686303031715)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>'Use pre-defined settings for Google Login.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(18650810905551172)
,p_plugin_attribute_id=>wwv_flow_imp.id(15249686303031715)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>'Use pre-defined settings for Facebook Login.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(15249997224035381)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(15249686303031715)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(18385430957035861)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(15249686303031715)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(18385701636038222)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(15249686303031715)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(18386081451040404)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(15249686303031715)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(18386627580109078)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>'email,profile'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter a comma separated list of permissions to request for the user who is logging in.',
'The acceptable values depend on your authentication provider.',
'For OpenID Connect and Google, Oracle APEX automatically adds the "openid" scope.',
'The authentication provider returns user attributes based on these permissions.',
'You can map the attributes to application items, or use a Post Authentication procedure to process them, using the APEX_JSON.GET_% functions.',
'</p><p>',
'OpenID Connect scopes and attributes (also called claims) are listed here: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(226010579134296999)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(18386934074146656)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the attribute which contains the username, or free text with one or more attribute substitutions that are enclosed by "#".',
'You can reference the authentication scheme''s name with #APEX_AUTH_NAME#.',
'For example, "#email# (#APEX_AUTH_NAME#)" will result in a username that consists of the email address, followed by " (", followed by the authentication scheme name, followed by ")", like "jane.doe@example.com (Google)".',
'</p><p>',
'Consult the authentication provider''s documentation for supported attributes.',
'Note that you need to set the required Scope, otherwise the authentication provider will not send all attributes.',
'OpenID Connect scopes and attributes (also called claims) are listed here: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(18652865850779852)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'link,picture,email'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter a comma separated list of additional user data attributes.',
'</p><p>',
'Consult the authentication provider''s documentation for supported attributes.',
'Note that you need to set the required Scope, otherwise the authentication provider will not send all attributes.',
'OpenID Connect scopes and attributes (also called claims) are listed here: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(118623542514218726)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>'Convert Username To Upper Case'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select "Yes" to automatically convert the username value to upper case. Select "No" to keep the original username value supplied by the authentication provider.</p>',
'<p>Oracle recommends setting this attribute to "Yes" if your application uses the native Application Access Control shared component.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(545768003551719989)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(15249686303031715)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(545768719525723870)
,p_plugin_attribute_id=>wwv_flow_imp.id(545768003551719989)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(545768336282722977)
,p_plugin_attribute_id=>wwv_flow_imp.id(545768003551719989)
,p_display_sequence=>22
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client id in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(545769143256728532)
,p_plugin_attribute_id=>wwv_flow_imp.id(545768003551719989)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(829911196403661792)
,p_plugin_attribute_id=>wwv_flow_imp.id(545768003551719989)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(328064759558360148)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>'Verify Attributes'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If enabled, &PRODUCT_NAME. looks for an attribute "#name#_verified" (for example, "email_verified" for Attribute "email").',
'OpenID defines that the identity provider sends <code>"#name#_verified":false</code> for unverified "email" and "phone_number" attributes.',
'&PRODUCT_NAME. ignores such unverified attributes.',
'This will result in a failed authentication if "#name#" is the Username attribute.',
'</p><p>',
'If the identity provider lets attackers enter unverified data that the application uses for authentication,',
'they could impersonate other users in the application.',
'The "Verify Attributes" check prevents this.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(388762589390412438)
,p_plugin_id=>wwv_flow_imp.id(15242808636946504)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>'Map Additional User Attributes To'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Provide a comma-separated list of application item names that the <em>Additional User Attributes</em> map to. For example, if you set',
'<ul>',
'<li>Additional User Attributes: email,profile,picture</li>',
'<li>Map Additional User Attributes To: G_EMAIL,G_PROFILE,G_PICTURE</li>',
'</ul>',
'then APEX automatically saves the attribute values in session state for the corresponding items.'))
);
end;
/
prompt --application/shared_components/plugins/ir_column/image
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(20600852094583135)
,p_plugin_type=>'IR COLUMN'
,p_name=>'IMAGE'
,p_display_name=>'Display Image'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('IR COLUMN','IMAGE'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays the column as an image.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/ir_column/download
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(20601072269585767)
,p_plugin_type=>'IR COLUMN'
,p_name=>'DOWNLOAD'
,p_display_name=>'Download BLOB'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('IR COLUMN','DOWNLOAD'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays the column as a link to download the file.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/ir_column/hidden_column
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(20601225239594915)
,p_plugin_type=>'IR COLUMN'
,p_name=>'HIDDEN_COLUMN'
,p_display_name=>'Hidden'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('IR COLUMN','HIDDEN_COLUMN'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Does not display the column, but it is referenceable.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/ir_column/link
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(20601584141598428)
,p_plugin_type=>'IR COLUMN'
,p_name=>'LINK'
,p_display_name=>'Link'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('IR COLUMN','LINK'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Displays the column as a link.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/ir_column/pct_graph
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(20601778279599857)
,p_plugin_type=>'IR COLUMN'
,p_name=>'PCT_GRAPH'
,p_display_name=>'Percent Graph'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('IR COLUMN','PCT_GRAPH'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays the column as a percentage graph. The value retrieved must be between 0 and 100.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/ir_column/plain
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(20601913155601093)
,p_plugin_type=>'IR COLUMN'
,p_name=>'PLAIN'
,p_display_name=>'Plain Text'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('IR COLUMN','PLAIN'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Displays the column value.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/ir_column/plain_lov
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(20602157610602837)
,p_plugin_type=>'IR COLUMN'
,p_name=>'PLAIN_LOV'
,p_display_name=>'Plain Text (based on List of Values)'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('IR COLUMN','PLAIN_LOV'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays the value returned from the list of values specified.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/ir_column/strip_html
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(20602390275604636)
,p_plugin_type=>'IR COLUMN'
,p_name=>'STRIP_HTML'
,p_display_name=>'Remove HTML'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('IR COLUMN','STRIP_HTML'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays the column value, after removing HTML tags and escaping special characters.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/ir_column/rich_text
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(20602511529606003)
,p_plugin_type=>'IR COLUMN'
,p_name=>'RICH_TEXT'
,p_display_name=>'Rich Text'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('IR COLUMN','RICH_TEXT'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Renders the column using HTML or Markdown.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/geocoding
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(23280737050223902)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'GEOCODING'
,p_display_name=>'Server Side Geocoding'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS:APEX_APPL_TASKDEF_ACTIONS:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','GEOCODING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_version_scn=>82123644
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This process type provides Geocoding (turning a postal address to a coordinate) functionality.</p>',
'<p>Geocoding is performed by calling <strong>SDO_GCDR.ELOC_GEOCODE</strong>, which does a REST request to the <strong>Oracle Elocation</strong> Geocoding Service (elocation.oracle.com). For further information on this function, see the <strong>Oracle'
||' Spatial Developer''s Guide</strong>.',
'',
'<p>Geocoding input data comes from page items, which are mapped to address parts like Street, House Number, Postal Code or City. The process populates a coordinate and match vector page item with the results of the first matched address. In addition,'
||' all matches can be loaded into a collection for further processing.  If <strong>Sanitize Address</strong> is enabled, address part page items will be overwritten with the sanitized values of the first matched address.</p>',
'',
'<p>Note - This process type is only supported on Oracle Autonomous Database.</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(6274597128526118)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_title=>'Geocoding Input'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(6274942011526119)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_title=>'Geocoding Result'
,p_display_sequence=>20
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23333750438533611)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Match Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>The <strong>Match Mode</strong> determines how closely the attributes of an input address must match the data being used for geocoding.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23334914507535386)
,p_plugin_attribute_id=>wwv_flow_imp.id(23333750438533611)
,p_display_sequence=>10
,p_display_value=>'Exact'
,p_return_value=>'EXACT'
,p_help_text=>'<p>All provided address parts must match. However, if the house number, street name or street type do not <em>all</em> match, the first match in the following is returned: postal code, city or town, and state. For example, if the street name is incor'
||'rect but a valid postal code is specified, a location in the postal code is returned.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23335265194536539)
,p_plugin_attribute_id=>wwv_flow_imp.id(23333750438533611)
,p_display_sequence=>20
,p_display_value=>'Relax Street Type'
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>'<p>The provided <em>street type</em> can be different from the data used for geocoding. For example, <strong>Main Street</strong> or <strong>Main Blvd</strong> match <strong>Main St</strong>, if there is no other <strong>Main Blvd</strong> or <strong'
||'>Main Street</strong> in the relevant area.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23335683752537605)
,p_plugin_attribute_id=>wwv_flow_imp.id(23333750438533611)
,p_display_sequence=>30
,p_display_value=>'Relax House Number'
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>'<p>The house number and street type can be different from the data used for geocoding. For example, <strong>123 Main St</strong> matches <strong>123 Main Lane</strong> and <strong>124 Main St</strong>, as long as there are no ambiguities or other mat'
||'ches.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23336068668538973)
,p_plugin_attribute_id=>wwv_flow_imp.id(23333750438533611)
,p_display_sequence=>40
,p_display_value=>'Relax Street Name'
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>'<p>The <em>base name</em> of the street, the house number, and the street type can be different from the data used for geocoding. For example, <strong>Pleasant Vale</strong> matches <strong>Pleasant Valley</strong> as long as there are no ambiguities'
||' or other matches in the data.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23336444088540057)
,p_plugin_attribute_id=>wwv_flow_imp.id(23333750438533611)
,p_display_sequence=>50
,p_display_value=>'Relax Postal Code'
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>'<p>The postal code (if provided), street name, street type and house number can be different from the data used for geocoding.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23336925705541129)
,p_plugin_attribute_id=>wwv_flow_imp.id(23333750438533611)
,p_display_sequence=>60
,p_display_value=>'Relax All'
,p_return_value=>'RELAX_ALL'
,p_help_text=>'<p>The address can be outside the city specified as long as it is within the same county. Also includes the characteristics of <strong>Relax Postal Code</strong>.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23281332145237032)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Country Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23296341939280297)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_help_text=>'Choose whether to use a static country for geocoding, or whether to derive the country from an item.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23281679414238784)
,p_plugin_attribute_id=>wwv_flow_imp.id(23281332145237032)
,p_display_sequence=>10
,p_display_value=>'Static'
,p_return_value=>'STATIC'
,p_help_text=>'Use a static country from a select list.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23282079556239939)
,p_plugin_attribute_id=>wwv_flow_imp.id(23281332145237032)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
,p_help_text=>'Get the country from an application or page item. The item must contain the 2-digit ISO code for a country.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23282698831244738)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Country'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23281332145237032)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_help_text=>'Pick the country to use for geocoding.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23282977422245648)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>10
,p_display_value=>'United States'
,p_return_value=>'US'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23283347021246304)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>20
,p_display_value=>'United Kingdom'
,p_return_value=>'UK'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23283760966246907)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>30
,p_display_value=>'Germany'
,p_return_value=>'DE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23284138885247592)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>40
,p_display_value=>'France'
,p_return_value=>'FR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23284594209248547)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>50
,p_display_value=>'Italy'
,p_return_value=>'IT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23284987502248932)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>60
,p_display_value=>'Canada'
,p_return_value=>'CA'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23285391712249499)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>70
,p_display_value=>'Netherlands'
,p_return_value=>'NL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23285773809250145)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>80
,p_display_value=>'Belgium'
,p_return_value=>'BE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23286191004251074)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>90
,p_display_value=>'Austria'
,p_return_value=>'AT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23286582135251934)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>100
,p_display_value=>'Switzerland'
,p_return_value=>'CH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23287010799252444)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>110
,p_display_value=>'Spain'
,p_return_value=>'ES'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23287363052253747)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>120
,p_display_value=>'Portugal'
,p_return_value=>'PT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23287792535254345)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>130
,p_display_value=>'Estonia'
,p_return_value=>'EE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23288131381254775)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>140
,p_display_value=>'India'
,p_return_value=>'IN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23288589450255437)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>150
,p_display_value=>'Mexico'
,p_return_value=>'MX'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23288956217256087)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>160
,p_display_value=>'Australia'
,p_return_value=>'AU'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23289361075256604)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>170
,p_display_value=>'Brazil'
,p_return_value=>'BR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23289801014257358)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>180
,p_display_value=>'Chile'
,p_return_value=>'CL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23290221559258372)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>190
,p_display_value=>'Czech Republic'
,p_return_value=>'CZ'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23290598948258809)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>200
,p_display_value=>'Norway'
,p_return_value=>'NO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23290983695259310)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>210
,p_display_value=>'Finland'
,p_return_value=>'FI'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23291359472259827)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>220
,p_display_value=>'Denmark'
,p_return_value=>'DK'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23291780933260336)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>230
,p_display_value=>'Hong Kong'
,p_return_value=>'HK'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23292146133260829)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>240
,p_display_value=>'Ireland'
,p_return_value=>'IE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23292591257261362)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>250
,p_display_value=>'Latvia'
,p_return_value=>'LV'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23292982832262227)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>260
,p_display_value=>'Romania'
,p_return_value=>'RO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23293331885262690)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>270
,p_display_value=>'Colombia'
,p_return_value=>'CO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23293740187263302)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>280
,p_display_value=>'Poland'
,p_return_value=>'PL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23294207860264635)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>290
,p_display_value=>'United Arab Emirates'
,p_return_value=>'AE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23294557231265294)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>300
,p_display_value=>'Hungary'
,p_return_value=>'HU'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23295019089266004)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>310
,p_display_value=>'Saudi Arabia'
,p_return_value=>'SA'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(23295412918266577)
,p_plugin_attribute_id=>wwv_flow_imp.id(23282698831244738)
,p_display_sequence=>320
,p_display_value=>'South Africa'
,p_return_value=>'ZA'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23295875685273149)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Country Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23281332145237032)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><strong>US</strong>: United States</li>',
'<li><strong>UK</strong>: United Kingdom</li>',
'<li><strong>DE</strong>: Germany</li>',
'<li><strong>AT</strong>: Austria</li>',
'</ul>'))
,p_help_text=>'Pick a page or application item to get the country for geocoding from. The item must contain the 2-digit ISO code for a country.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23296341939280297)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>'Structured Address'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Whether address parts are provided to the geocoding service in a <em>structured</em> or <em>unstructured</em> manner.</p>',
'<p>Structured means that explicit page items are mapped to address parts like Street, Postal Code, City or Region. This leads to more accurate geocoding results, and also allows to feed the ',
'corrected addresses back to the page items.</p>',
'<p>Unstructured means that only one item is used for the whole address; parts are separated by comma. This mode does not allow to feed corrected addresses back to the page item.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23296665187284038)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Sanitize Address'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23296341939280297)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'<p>Enable this switch to feed address data from the geocoding service back to the mapped items. If the geocoder returns multiple matching addresses, the <em>first match</em> will be fed back to the configured page items.</p><p>Configure a <strong>Col'
||'lection Name</strong> to fetch all matched addresses into a collection, for further processing.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23343630921579864)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Address Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23296341939280297)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_help_text=>'Pick the item containing unstructured address parts, separated by comma.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23297262711291196)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Street Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23296341939280297)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_help_text=>'Pick the item containing the Street part of the address.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23297581907293854)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'House Number Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23296341939280297)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_help_text=>'Pick the item containing the <em>House Number</em> part of the address.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23297906116296261)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Postal Code Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23296341939280297)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_help_text=>'Pick the item containing the <em>Postal Code</em> part of the address.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23298140636299471)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'City Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23296341939280297)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_help_text=>'Pick the item containing the <em>City</em> part of the address.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23298465359302239)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'City Sub Area Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23296341939280297)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_help_text=>'Pick the item containing the <em>Sub Area (within a City)</em> part of the address. This attribute is not passed to the geocoder, but can be received back for address enrichment.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23298746855304274)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Region Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(23296341939280297)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(6274597128526118)
,p_help_text=>'Pick the item containing the <em>Region (State)</em> part of the address.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23299216371310695)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Coordinate Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(6274942011526119)
,p_help_text=>'<p>Pick a page item to store the coordinate of <em>the first Geocoder match</em>, in GeoJSON format.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23299513762315037)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Match Vector Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(6274942011526119)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Pick a page item to store the <em>Match Vector</em> of <em>the first Geocoder match</em>. The match vector is a 17-digit string with detailed information about how each address attribute has been matched against the data used for geocoding.</p>',
'<p><strong>Match Vector digits can have the following values:</strong></p>',
'<ul>',
'<li><p>0: The input attribute is not null and is matched with a non-null value.</p></li>',
'<li><p>1: The input attribute is null and is matched with a null value.</p></li>',
'<li><p>2: The input attribute is not null and is replaced by a different non-null value.</p></li>',
'<li><p>3: The input attribute is not null and is replaced by a null value.</p></li>',
'<li><p>4: The input attribute is null and is replaced by a non-null value.</p></li>',
'</ul>',
'<br>',
'<p><strong>Match Vector digits and the address attribute corresponding to each:</strong></p>',
'<ul>',
'<li><p>3: Address Point (exact address matched in data used for geocoding)</p></li>',
'<li><p>4: Point Of Interest Name</p></li>',
'<li><p>5: House Number</p></li>',
'<li><p>6: Street Prefix</p></li>',
'<li><p>7: Street Name</p></li>',
'<li><p>8: Street Suffix</p></li>',
'<li><p>9: Street Type</p></li>',
'<li><p>10: Secondary Unit</p></li>',
'<li><p>11: City</p></li>',
'<li><p>14: Region</p></li>',
'<li><p>15: Country</p></li>',
'<li><p>16: Postal Code</p></li>',
'<li><p>17: Postal Add-On Code</p></li>',
'<li><p><em>other digits are unused yet.</em></p></li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(23312282210252045)
,p_plugin_id=>wwv_flow_imp.id(23280737050223902)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Collection Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>30
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(6274942011526119)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If the name of a collection is provided, then all geocoding results are fetched into this collection. The mapping of geocoding result attributes to collection member attributes is as follows:</p>',
'<ul>',
'<li><code>C001</code>: <strong>Street</strong></li>',
'<li><code>C002</code>: <strong>House Number</strong></li>',
'<li><code>C003</code>: <strong>Postal Code</strong></li>',
'<li><code>C004</code>: <strong>City</strong></li>',
'<li><code>C005</code>: <strong>City sub area</strong></li>',
'<li><code>C006</code>: <strong>Region (State)</strong></li>',
'<li><code>C007</code>: <strong>Country</strong></li>',
'<li><code>C011</code>: <strong>Match Vector</strong></li>',
'<li><code>N001</code>: <strong>Longitude</strong></li>',
'<li><code>N002</code>: <strong>Latitude</strong></li>',
'<li><code>D001</code>: <strong>Timestamp of Geocoding</strong></li>',
'</ul>',
'<p>Use the following query to fetch geocoding results from the collection:</p>',
'',
'<pre>',
'select c001 as street,',
'       c002 as house_number,',
'       c003 as postal_code,',
'       c004 as city,',
'       c005 as city_sub_area,',
'       c006 as region,',
'       c007 as country,',
'       c011 as match_vector,',
'       n001 as longitude,',
'       n002 as latitude,',
'       d001 as geocode_date',
'  from apex_collections',
' where collection_name = ''{collection name}''',
'</pre>',
'<p>If the collection does not exist, it will be created before the first member is added. Existing collections will <em>not</em> be cleared; this must be done using a separate page process which runs before this geocoding process.</p>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(37314610637444633)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>'List View'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ORDER_BY:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_version_scn=>72472662
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display data in an easy to navigate list. You can also incorporate numerous features to enhance the list view.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37319921504457296)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'list_view_features'
,p_prompt=>'Features'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select the features that are enabled for this list view.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(37507022952387983)
,p_plugin_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_display_sequence=>5
,p_display_value=>'Advanced Formatting'
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24342207873614875)
,p_plugin_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_display_sequence=>10
,p_display_value=>'Show Image'
,p_return_value=>'IMAGE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24341804410613872)
,p_plugin_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_display_sequence=>20
,p_display_value=>'Show List Divider'
,p_return_value=>'DIVIDER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24343018955618095)
,p_plugin_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_display_sequence=>50
,p_display_value=>'Has Split Button'
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24341429213611599)
,p_plugin_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_display_sequence=>55
,p_display_value=>'Enable Search'
,p_return_value=>'SEARCH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24342612721616279)
,p_plugin_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_display_sequence=>65
,p_display_value=>'Is Nested List View'
,p_return_value=>'NESTED'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(37507428146389462)
,p_plugin_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_display_sequence=>70
,p_display_value=>'Inset List'
,p_return_value=>'INSET'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37321616440465218)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'text_column'
,p_prompt=>'Text Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>'Select the database column that contains the main content for the list view entry.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(18004831401462408)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'list_attributes'
,p_prompt=>'List Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>The client creates dividers based on the list item text</dt>',
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
'<dt>Change the icon</dt>',
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
'<dt>Change the split button icon</dt>',
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>'Enter additional attributes to be set on the list element. See the examples for some attributes that affect the list view.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(18003624513413103)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'list_entry_attributes'
,p_prompt=>'List Entry Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Set list entry link icon to delete.</dt>',
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>'Enter additional attributes to set on list item element. See the examples for some attributes that affect the list view.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37322140682472248)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'text_formatting'
,p_prompt=>'Text Formatting'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display name and below the hire date of an employee</dt>',
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
'&lt;p&gt;Hire date: &amp;HIREDATE.&lt;/p&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the HTML markup to render the main content for a list view entry.</p>',
'<p>To reference column values of your list view SQL statement, use substitution syntax.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37323637481490256)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'supplemental_info_column'
,p_prompt=>'Supplemental Information Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>'Select the database column that contains supplemental information for the list view entry.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37512329447408820)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_static_id=>'supplemental_info_formatting'
,p_prompt=>'Supplemental Information Formatting'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display the salary in bold</dt>',
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the HTML markup to render supplemental information for a list view entry.</p>',
'<p>To reference column values of your list view SQL statement use substitution syntax.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37323130554488257)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'counter_column'
,p_prompt=>'Counter Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>'Select the database column that contains the value to display in the count bubble.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(42537525650337692)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_static_id=>'image_type'
,p_prompt=>'Image Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>'Select what kind of image displays and where it is read from. The displayed image can be an icon with a size of 16x16 or a thumbnail with a size of 80x80. The source for the image can be a database BLOB column or a URL to a static file.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(42538712275343327)
,p_plugin_attribute_id=>wwv_flow_imp.id(42537525650337692)
,p_display_sequence=>20
,p_display_value=>'Icon stored in BLOB'
,p_return_value=>'ICON_BLOB'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(42539233400349414)
,p_plugin_attribute_id=>wwv_flow_imp.id(42537525650337692)
,p_display_sequence=>30
,p_display_value=>'Icon read from URL'
,p_return_value=>'ICON_URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(42539638940351053)
,p_plugin_attribute_id=>wwv_flow_imp.id(42537525650337692)
,p_display_sequence=>40
,p_display_value=>'Image stored in BLOB'
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(42540042403352086)
,p_plugin_attribute_id=>wwv_flow_imp.id(42537525650337692)
,p_display_sequence=>50
,p_display_value=>'Image read from URL'
,p_return_value=>'IMAGE_URL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37324142675491770)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_static_id=>'image_blob_column'
,p_prompt=>'Image BLOB Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(42537525650337692)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>'Select the database column of data type BLOB that contains the image.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(42541812668371813)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_static_id=>'image_primary_key_column_1'
,p_prompt=>'Image Primary Key Column 1'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(42537525650337692)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>'Select the primary key column or a unique database column that is used to lookup the image.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(24272827642729595)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_static_id=>'image_primary_key_column_2'
,p_prompt=>'Image Primary Key Column 2'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(42541812668371813)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Select a second primary key column or a unique database column that is used to lookup the image.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(24218503552483082)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_static_id=>'image_url_column'
,p_prompt=>'Image URL Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(42537525650337692)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>'Select the database column that contains the URL to the icon/image.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37324722720495516)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_static_id=>'list_divider_column'
,p_prompt=>'List Divider Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>'Select the database column that contains the divider. Every time the divider value changes, a new divider displays between the list view entries.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(24027626694091285)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_static_id=>'list_divider_formatting'
,p_prompt=>'List Divider Formatting'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display department name and the number of employees as a badge</dt>',
'<dd><pre>',
'&amp;DNAME. &lt;span class="t-MediaList-badge"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the HTML markup to render the divider of a list view.</p>',
'<p>To reference column values of your list view SQL statement use substitution syntax.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37322614971483782)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_static_id=>'link_target'
,p_prompt=>'Link Target'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Enter a target page to be called when the user clicks a list entry.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37325839689500405)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_static_id=>'split_button_target'
,p_prompt=>'Split Button Target'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Enter a target page to be called when the user clicks a list entry.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(24021612683850679)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_static_id=>'search_type'
,p_prompt=>'Search Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how the search is performed.</p>',
'<p>A client-side search is performed immediately as soon as the user starts to type. For all server-based searches, the user has to press Enter to show the search results. Only server-based searches take into account Character Value Comparison global'
||'ization attributes defined for the application.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24022326881854766)
,p_plugin_attribute_id=>wwv_flow_imp.id(24021612683850679)
,p_display_sequence=>20
,p_display_value=>'Client Side'
,p_return_value=>'CLIENT'
,p_help_text=>'To perform a browser-based search, all list view entries have to be loaded into the browser (note that the "Number of Fetched Rows" attribute is ignored in this case). Only use this search option for a small number of list entries to avoid unnecessar'
||'ily long page loads.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24022823811882269)
,p_plugin_attribute_id=>wwv_flow_imp.id(24021612683850679)
,p_display_sequence=>30
,p_display_value=>'Server: Exact & Case Sensitive'
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>'Search uses LIKE [search value]% to query the result.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24023232469884808)
,p_plugin_attribute_id=>wwv_flow_imp.id(24021612683850679)
,p_display_sequence=>40
,p_display_value=>'Server: Exact & Ignore Case'
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>'Search uses LIKE UPPER( [search value] )% to query the result. Existing indexes on the column will not be used, unless it is a function-based index using an UPPER expression.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24023619787890578)
,p_plugin_attribute_id=>wwv_flow_imp.id(24021612683850679)
,p_display_sequence=>50
,p_display_value=>'Server: Like & Case Sensitive'
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>'Search uses LIKE %[search value]% to query the result. This will prevent the use of an existing index on that column.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24024029483893440)
,p_plugin_attribute_id=>wwv_flow_imp.id(24021612683850679)
,p_display_sequence=>60
,p_display_value=>'Server: Like & Ignore Case'
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>'Search uses LIKE %UPPER( [search value] )% to query the result. This will prevent the use of an existing index on that column.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(10775027534399383)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_static_id=>'search_column'
,p_prompt=>'Search Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>'Select an alternative database column used for the search. If nothing is specified, then the Text Column is used.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37327132202507698)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_static_id=>'search_box_placeholder'
,p_prompt=>'Search Box Placeholder'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>'Enter the text that is displayed in the search box. If no value is specified, the value of the system message <strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong> is used.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(37325332071498117)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_static_id=>'nested_list_column'
,p_prompt=>'Nested List Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(37319921504457296)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>'Select the database column containing the hierarchy level of a nested query. If you use a CONNECT BY query use the pseudo column <code>LEVEL</code>.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(644548607716477014)
,p_plugin_id=>wwv_flow_imp.id(37314610637444633)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(72276595215456808)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>'Close Region'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>'Closes a region, such as inline dialog, inline popup, or collapsible, that supports being opened and is opened.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(72276779733456826)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>'Open Region'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>'Opens a region, such as inline dialog, inline popup, or collapsible, that supports being opened.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(132376923088056966)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>'Is In Role or Group'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>55031706
,p_subscribe_plugin_settings=>true
,p_help_text=>'Checks the provided comma-separated roles/groups names included in the user''s roles/groups.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(132377321338088226)
,p_plugin_id=>wwv_flow_imp.id(132376923088056966)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Name(s)'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter one or more comma-separated group names.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(91772529032268265)
,p_plugin_id=>wwv_flow_imp.id(132376923088056966)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(91772831765269995)
,p_plugin_attribute_id=>wwv_flow_imp.id(91772529032268265)
,p_display_sequence=>10
,p_display_value=>'Application Role'
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(91773214348271589)
,p_plugin_attribute_id=>wwv_flow_imp.id(91772529032268265)
,p_display_sequence=>20
,p_display_value=>'Workspace Group'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(91773695579272344)
,p_plugin_attribute_id=>wwv_flow_imp.id(91772529032268265)
,p_display_sequence=>30
,p_display_value=>'Custom'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(132377111646077506)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>'Is Not In Role or Group'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>55031779
,p_subscribe_plugin_settings=>true
,p_help_text=>'Checks the provided comma-separated roles/groups names not included in the user''s roles/groups.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(135876608363708702)
,p_plugin_id=>wwv_flow_imp.id(132377111646077506)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Name(s)'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter one or more comma-separated group names.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(91774410321279131)
,p_plugin_id=>wwv_flow_imp.id(132377111646077506)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(91774719920280165)
,p_plugin_attribute_id=>wwv_flow_imp.id(91774410321279131)
,p_display_sequence=>10
,p_display_value=>'Application Role'
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(91775192472281109)
,p_plugin_attribute_id=>wwv_flow_imp.id(91774410321279131)
,p_display_sequence=>20
,p_display_value=>'Workspace Group'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(91775511878281830)
,p_plugin_attribute_id=>wwv_flow_imp.id(91774410321279131)
,p_display_sequence=>30
,p_display_value=>'Custom'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(146860542307282603)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>'Checkbox'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a single checkbox that the user can check or uncheck. The defined checked or unchecked value is stored in session state when submitted.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(146860884924292553)
,p_plugin_id=>wwv_flow_imp.id(146860542307282603)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Checked Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Enter the value stored in the page item if the end user checks the checkbox. The value can be up to 255 characters long.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(146861562091295771)
,p_plugin_id=>wwv_flow_imp.id(146860542307282603)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Unchecked Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Enter the value stored in the page item if the user unchecks the checkbox. This attribute can also be left blank if you want to store <code>NULL</code> when checked. The value can be up to 255 characters long.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(146862485248305221)
,p_plugin_id=>wwv_flow_imp.id(146860542307282603)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Use Defaults'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Whether to use the defaults defined for this component in Shared Components, Component Settings or custom settings.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(146864548825351464)
,p_plugin_id=>wwv_flow_imp.id(146860542307282603)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Checked Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(146862485248305221)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the value stored in the page item if the user checks the checkbox. The value can be up to 255 characters long.</p>',
'<p>',
'On a Faceted Search page, if the facet filters a query column <em>based on a List Of Values</em>, this value must match <em>both</em> LOV display and return value. If display and return values differ, then you cannot use this facet type for this colu'
||'mn - use the <strong>Checkbox Group</strong> facet instead.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(146865043227355165)
,p_plugin_id=>wwv_flow_imp.id(146860542307282603)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Unchecked Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(146862485248305221)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the value stored in the page item if the user unchecks the checkbox. This attribute can also be left blank if you want to store <code>NULL</code> when unchecked. The value can be up to 255 characters long.</p>',
'<p><em>Note: This value is used if the page item is populated with a value which does not match either the <strong>Checked Value</strong> or <strong>Unchecked Value</strong>.</em></p>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(230331270232947234)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>'Interactive Grid'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'<p>Feature-rich reporting component with <strong>data editing capabilities</strong>, enabling users to add, modify, or delete rows of data directly on the page.</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(465646569260662699)
,p_plugin_id=>wwv_flow_imp.id(230331270232947234)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(936016374443633302)
,p_plugin_id=>wwv_flow_imp.id(230331270232947234)
,p_name=>'apexbeginrecordedit'
,p_display_name=>'Row Initialization'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(233322074007251020)
,p_plugin_id=>wwv_flow_imp.id(230331270232947234)
,p_name=>'gridpagechange'
,p_display_name=>'Page Change'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(233321734838250996)
,p_plugin_id=>wwv_flow_imp.id(230331270232947234)
,p_name=>'interactivegridmodechange'
,p_display_name=>'Mode Change'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(233322895758251022)
,p_plugin_id=>wwv_flow_imp.id(230331270232947234)
,p_name=>'interactivegridreportchange'
,p_display_name=>'Report Change'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(230312956793621156)
,p_plugin_id=>wwv_flow_imp.id(230331270232947234)
,p_name=>'interactivegridsave'
,p_display_name=>'Save'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(936015222634633296)
,p_plugin_id=>wwv_flow_imp.id(230331270232947234)
,p_name=>'interactivegridselectionchange'
,p_display_name=>'Selection Change'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(233322485880251022)
,p_plugin_id=>wwv_flow_imp.id(230331270232947234)
,p_name=>'interactivegridviewchange'
,p_display_name=>'View Change'
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(253123678064187648)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>'Row Selector'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays a check box on each row of an Interactive Grid, allowing selection of specific row(s) for row manipulation.</p>',
'<p>By default the APEX$ROW_SELECTOR column is set to a type of Row Selector.  This column is automatically added when the Interactive Grid is made editable.</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(253123956742195925)
,p_plugin_id=>wwv_flow_imp.id(253123678064187648)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Enable Multi Select'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Allow multiple rows to be selected.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(253124243508199498)
,p_plugin_id=>wwv_flow_imp.id(253123678064187648)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Show Select All'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(253123956742195925)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Allow the user to select all rows using Ctrl+A or if <em>Hide Controls</em> is <em>No</em> using a checkbox in the column header.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(276642483200371586)
,p_plugin_id=>wwv_flow_imp.id(253123678064187648)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Hide Control'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Hide the checkbox or radio-control displayed on each row.'
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(253124868675308889)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>'Actions Menu'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays the actions icon (hamburger) on each row of an Interactive Grid. ',
'The actions menu includes options such as Single Row View, Add Row, Delete Row, and Refresh Row, and so forth, depending on the grid attributes and end user authorizations. These menu options allow end users to perform specific actions on the current'
||' row in the grid.</p>',
'<p>The actions menu can be used in both editable and non-editable Interactive Grids, but the menu options will differ depending on this. For non-editable Interactive Grids, the menu will have a subset of options, for example Single Row View and Refre'
||'sh Row, and not include editable specific actions like Add Row, Delete Row and so on.</p>',
'<p>When an Interactive Grid is made editable, the APEX$ROW_ACTION column will be automatically added, and set to a type of Actions Menu. For non-editable Interactive Grids, this column must be added manually.</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(258086019711957603)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>'Chart'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:ORDER_BY'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display data using various built-in chart types.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(608666764128858384)
,p_plugin_id=>wwv_flow_imp.id(258086019711957603)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(258533608465739815)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>'Hide'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Hides the affected elements.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(262136912621901373)
,p_plugin_id=>wwv_flow_imp.id(258533608465739815)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Hide all page items on the same line'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether all the page items and labels on the same line as the affected elements are hidden.</p>',
'<p>Note: This attribute does not work for items on pages that do not use a table grid to display form items. This includes any page using a mobile page template.</p>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(258537221774904509)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Enables the affected elements.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(258537428700906571)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Disables the affected elements. Disabling makes these elements non-editable so that they do not retain item values when the page is submitted.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(258538225714915177)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>'Set Value'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Sets the value of the affected elements.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(262584206591281622)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Set Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how to derive the value(s) to set.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(262584812132283213)
,p_plugin_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_display_sequence=>10
,p_display_value=>'Static Assignment'
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>'Set a single static value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(262585623560286495)
,p_plugin_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_display_sequence=>15
,p_display_value=>'JavaScript Expression'
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>'Set one or more values, derived or calculated from JavaScript.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(262585216634284505)
,p_plugin_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_display_sequence=>20
,p_display_value=>'SQL Statement'
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>'Set one or more values, based on the result of a SQL query.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(427666425507065443)
,p_plugin_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_display_sequence=>40
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>'Set a single value, based on the result of a PL/SQL expression.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(427667018365072832)
,p_plugin_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>'Set a single value, based on the result of a PL/SQL function body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1295383602600152012)
,p_plugin_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_display_sequence=>60
,p_display_value=>'Dialog Return Item'
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>'Set a single value, based on the return item of a dialog. Note: This type only works if the dynamic action fires for the <strong>Dialog Closed</strong> event.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(258539307968928889)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>'Enter a static value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(262586323439352724)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'SQL Statement'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
'<p>In this example, enter <code>P1_DEPTNO</code> in <strong>Page Items to Submit</strong>. You should also select two <em>Affected Elements</em>, for the <code>loc</code> and <code>dname</code> columns respectively, for example P1_LOC and P1_DNAME.</'
||'p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL statement that returns between 1 and 100 columns. The columns you select with the SQL statement needs to correspond, by position, to the Page Items you select in <strong>Affected Elements</strong>.</p>',
'<p>You can reference page or application items using bind syntax, providing you include them in <strong>Page Items to Submit</strong></p>',
'<p><em>Note: If the SQL statement returns only a single row, this is set as the values. If it returns multiple row, the value set is a comma separated string of all the rows, for each value.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(427662501518001786)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'PL/SQL Expression'
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
'<p>In this example, enter <code>P1_SAL</code> in <strong>Page Items to Submit</strong>.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL expression used to set the value.</p>',
'<p>You can reference page or application items, providing you include them in <strong>Page Items to Submit</strong>.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(293265419645253258)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'JavaScript Expression'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This code has access to the following dynamic action related attributes:</p>',
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
'    <dd>A reference to the DOM object of the element that triggered the dynamic action.</dd>',
'  <dt><code>this.affectedElements</code></dt>',
'    <dd>A jQuery object containing all the affected elements.</dd>',
'  <dt><code>this.action</code></dt>',
'    <dd>The action object containing details such as the action name and additional attribute values.</dd>',
'  <dt><code>this.browserEvent</code></dt>',
'     <dd>The event object of event that triggered the event. Note: On load this equals ''load''.</dd>',
'  <dt><code>this.data</code></dt>',
'    <dd>Optional additional data that can be passed from the event handler.</dd>',
'</dl>'))
,p_help_text=>'Enter a JavaScript expression used to set the value. This expression can either result in a single value, or an array of values (where the item being set supports multiple values, for example a Shuttle).'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(427662910653013912)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'PL/SQL Function Body'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
'<p>In this example, enter <code>P1_SAL</code> and <code>P1_JOB</code> in <strong>Page Items to Submit</strong>.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL function body used to set the value.</p>',
'<p>You can reference page or application items, providing you do include them in <strong>Page Items to Submit</strong>.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(262597322287494361)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Items to Submit'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>'Enter page or application items to submit when executing this action. For multiple items, separate each item name with a comma. You can type in the name or pick from the list of available items. If you pick from the list and there is already text ent'
||'ered then a comma is placed at the end of the existing text, followed by the item name returned from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(618758229653179194)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Escape Special Characters'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether HTML special characters are escaped. Oracle strongly recommends setting this attribute to <strong>On</strong>, to prevent Cross-Site Scripting (XSS) attacks.',
'Most items escape their value so when setting the value of an item you may need to set this to <strong>Off</strong> to avoid double escaping.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(399189606786047634)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Suppress Change Event'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether the change event is suppressed on the items specified in <strong>Page Items to Return</strong>. This prevents subsequent <em>Change</em> based Dynamic Actions from firing, for these items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1295495331704184122)
,p_plugin_id=>wwv_flow_imp.id(258538225714915177)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>'Return Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(262584206591281622)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>'Enter the name of a page item returned by the dialog used to set the value.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(258538732294917000)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>'Execute JavaScript Code'
,p_category=>'EXECUTE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Enables you to define or call custom, page specific JavaScript code to use within the dynamic action framework. If you are defining JavaScript code that is specific to just one page, you can use the page-level attribute <em>Function and Global Variab'
||'le Declaration</em> to define this. Functions and variables defined there can then be referenced from this action.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(258539816972931512)
,p_plugin_id=>wwv_flow_imp.id(258538732294917000)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Code'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This code has access to the following dynamic action related attributes:</p>',
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
'    <dd>A reference to the DOM object of the element that triggered the dynamic action.</dd>',
'  <dt><code>this.affectedElements</code></dt>',
'    <dd>A jQuery object containing all the affected elements.</dd>',
'  <dt><code>this.action</code></dt>',
'    <dd>The action object containing details such as the action name and additional attribute values.</dd>',
'  <dt><code>this.browserEvent</code></dt>',
'     <dd>The event object of event that triggered the event. Note: On load this equals ''load''.</dd>',
'  <dt><code>this.data</code></dt>',
'    <dd>Optional additional data that can be passed from the event handler.</dd>',
'</dl>'))
,p_help_text=>'Enter any custom JavaScript that is specific to the page or dynamic action.'
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(260818839554927396)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>'Interactive Grid - Automatic Row Processing (DML)'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process to insert, update, or delete Interactive Grid rows.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(260819106949935652)
,p_plugin_id=>wwv_flow_imp.id(260818839554927396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Target Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select which row processing technique is performed to save data changes made to the Interactive Grid.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(260819425689937336)
,p_plugin_attribute_id=>wwv_flow_imp.id(260819106949935652)
,p_display_sequence=>10
,p_display_value=>'Region Source'
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Inserts, updates, and deletes utilize the region source SQL Query .</p>',
'<p>Note - Ensure columns that are not insertable or updatable have <strong>Query Only</strong>  set to <code>Yes</code>, to exclude them from processing.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(260819835191938290)
,p_plugin_attribute_id=>wwv_flow_imp.id(260819106949935652)
,p_display_sequence=>20
,p_display_value=>'Table / View'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Inserts, updates, and deletes utilize a different table or view to the one defined in the region source SQL Query.',
'For example, the SQL Query retrieves data from a table-join or non-undateable view and the DML processing needs to be performed against a single base table or updatable view.</p>',
'<p>Note - Ensure columns that are not insertable or updatable have <strong>Query Only</strong> set to <code>Yes</code>, to exclude them from processing.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(260820229830940047)
,p_plugin_attribute_id=>wwv_flow_imp.id(260819106949935652)
,p_display_sequence=>30
,p_display_value=>'PL/SQL Code'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Processing is based on custom PL/SQL code. This option allows you to execute any PL/SQL code to implement any data manipulation in the underlying database.</p>',
'<p>This option should be utilized when using database packages, such as table APIs or calls to RESTful Web Services, to implement business logic.</p>',
'<p>Note - The PL/SQL code will be called for each row that has been inserted, updated or deleted.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(260820699209949601)
,p_plugin_id=>wwv_flow_imp.id(260818839554927396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Table Owner'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(260819106949935652)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Select the table owner (schema) name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(260821252819962990)
,p_plugin_id=>wwv_flow_imp.id(260818839554927396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Table Name'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(260820699209949601)
,p_depending_on_attribute_id=>wwv_flow_imp.id(260819106949935652)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Enter the case-sensitive table or view name. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(261083814084772472)
,p_plugin_id=>wwv_flow_imp.id(260818839554927396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'PL/SQL Code to Insert/Update/Delete'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(260819106949935652)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter PL/SQL code to process each row of data manipulated in the Interactive Grid.</p>',
'<p>Use the column name as a bind variable to access the value of a column. The system variable <code>APEX$ROW_STATUS</code> returns the status of a row and can be used to check if the row has been created, updated or deleted (see example below for ho'
||'w to check this).</p>',
'<p><em>Note:</em> If primary key columns get populated by a trigger or in the PL/SQL code, it is a requirement that the new values are assigned to the bind variables of the primary key columns, because &PRODUCT_NAME. uses those values to fetch the ro'
||'w after an insert or update.</p>',
'<p>Oracle recommends calling procedures or functions within a PL/SQL package, to facilitate reuse and maintainability.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(261084825593778341)
,p_plugin_id=>wwv_flow_imp.id(260818839554927396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Prevent Lost Updates'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether processing should ensure that updates are not lost when multiple users update the same database record.</p> ',
'<p>Lost updates occur when two or more people try to update the same data, and the last update overwrites updates made by the first user to save changes. To prevent this from happening, updates can check the existing column value(s) in the database w'
||'ith the value(s) retrieved when the row was originally queried.</p>',
'<p>For example:',
'  <ol>',
'    <li>User A queries employee (EMP) records.</li>',
'    <li>User B queries the same employee records.</li>',
'    <li>User B updates employee details for EMPNO = 7839 and applies (commits) the changes to the database.</li>',
'    <li>User A Updates employee details for EMPNO = 7839 and is attempting to apply the changes to the database.</li>',
'  </ol>',
'If User A successfully updates the same row, changes made by User B will be lost.',
'When User A is attempting to save the employee row, then the data in the database is different from what User A queried originally. In step 1 above, the column value(s) originally queried by User A can be captured. Then in Step 4 above, the value(s) '
||'can be compared to the current values in the database. This compaison will raise an error for User A, as the database value(s) were updated by User B in Step 3. This prevents a user from overwriting changes made by another user to the same row.</p>',
'<p>Note</p>',
'<ul>',
'<li>How the lost updates are detected is specified in the Attributes for the Interactive Grid region, based on the setting for <strong>Lost Update Type</strong>.</li>',
'<li>Lost Update Detection is <em>not available</em> for Interactive Grid Regions using a <strong>REST Data Source</strong> and a <strong>Target Type</strong> of <strong>Table/View</strong> or <strong>PL/SQL Code</strong>.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(261085131500782260)
,p_plugin_id=>wwv_flow_imp.id(260818839554927396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Lock Row'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether each row to be updated or deleted is locked in the underlying table before processing the row.</p>',
'<p>Note: Lock Rows is <em>not available</em> for Interactive Grid Regions using a <strong>REST Data Source</strong> and a <strong>Target Type</strong> of <strong>Table/View</strong> or <strong>PL/SQL Code</strong>.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(261085409986783810)
,p_plugin_attribute_id=>wwv_flow_imp.id(261085131500782260)
,p_display_sequence=>10
,p_display_value=>'Yes'
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Rows to be updated or deleted will be locked using SELECT ... FOR UPDATE to prevent other transactions being performed on the row until the transaction is committed.</p>',
'<p>Note - If an error is raised, such as for updatable views that do not support locking, then you may be able to utilize PL/SQL code to lock the driving table.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(261085868401784451)
,p_plugin_attribute_id=>wwv_flow_imp.id(261085131500782260)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'Rows will not be locked.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(261086261920786764)
,p_plugin_attribute_id=>wwv_flow_imp.id(261085131500782260)
,p_display_sequence=>30
,p_display_value=>'PL/SQL Code'
,p_return_value=>'PLSQL_CODE'
,p_help_text=>'Custom PL/SQL code will be used to lock the rows until the transaction is committed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(261087562475803605)
,p_plugin_id=>wwv_flow_imp.id(260818839554927396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'PL/SQL Code to Lock Row'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(261085131500782260)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>'Enter the PL/SQL code to lock the database table rows to be updated and deleted.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(352431952250846035)
,p_plugin_id=>wwv_flow_imp.id(260818839554927396)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Return Primary Key(s) after Insert'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(260819106949935652)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether the primary key column(s) should be returned to the corresponding Interactive Grid row once the row is inserted into the database.',
'Generally, this option should be used when the primary key columns are populated from a database trigger or an Oracle Database 12 <em>c</em> Identity column.</p>',
'<p>Note - If an error is raised specifying that the RETURNING INTO clause is not allowed, you must set this option to No and pre-populate the primary key column(s).</p>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(261340108358474705)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>'Add Class'
,p_category=>'STYLE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>'Adds one or more CSS classes to the affected elements.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(261340305288502177)
,p_plugin_id=>wwv_flow_imp.id(261340108358474705)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Class'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Add the CSS classes <code>articlenumber</code> and <code>highlight</code> to the HTML tag of the affected elements:',
'<pre>articlenumber highlight</pre>'))
,p_help_text=>'Specify one or more classes to be applied to the affected elements. If specifying more than one, separate class names with a space.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(261349722930705968)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>'Remove Class'
,p_category=>'STYLE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>'Removes one or more CSS classes from the affected elements.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(261350305185719779)
,p_plugin_id=>wwv_flow_imp.id(261349722930705968)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Class'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'<p>Specify one or more class names that to be removed from the affected elements. If specifying more than one, separate class names with a space. Leave blank to remove all class names from the affected elements.</p>'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(261356726281848792)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>'Set Style'
,p_category=>'STYLE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>'Sets a style (CSS) property to the affected elements.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(261356901132851044)
,p_plugin_id=>wwv_flow_imp.id(261356726281848792)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Style Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the name of the style (CSS) property you want to set for the affected elements.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(261357406326852547)
,p_plugin_id=>wwv_flow_imp.id(261356726281848792)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter the value to set the style property to for the affected elements. Leave blank to remove the style property from the affected elements.'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(352953211423309033)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>'Custom'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_help_text=>'An authentication scheme that allows you to define your own PL/SQL Functions for determining user authentication.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(353179625368369848)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Sentry Function Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify PL/SQL code returning a boolean value, within the ''PL/SQL Code'' -</p>',
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
'<p>Specify a PL/SQL Database function - </p>',
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of a function that is executed by the &PRODUCT_NAME. engine at the start of any request made to the engine, such as before each page is shown or processed, or an AJAX request is issued. ',
'It can be defined in the authentication''s PL/SQL Code, within a package or as a stored function.</p>',
'<p>If this function returns false (indicating perhaps that the user isn''t logged in),this marks the session as not valid and the <em>Invalid Session Procedure</em> will be invoked.',
'After that, &PRODUCT_NAME. redirects to the URL defined in ''Session Not Valid > Go To''.',
'If the value of this field is empty,',
'an internal default sentry is called that tries to establish a valid session by comparing the session ID in the URL and the session information in the authentication scheme cookie (with a fall-back to the &PRODUCT_NAME. Builder cookie, if that fails)'
||'.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(551983430308015470)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Invalid Session Procedure Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Basic Authentication required'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="protected realm"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of a PL/SQL procedure that gets called if an invalid session has been detected.</p>',
'',
'<p>It can reference a function of the anonymous PL/SQL code block, a package function or a stand alone function in the database. For example: <code>invalid_session_basic_auth</code></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example: <code>#OWNER#.invalid_session_basic_auth</code></'
||'p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(353293115026395181)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Authentication Function Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the following code in the ''PL/SQL Code'' textarea</p>',
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
'<p>and <code>my_authentication</code> as ''Authentication Function''.'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the name of the function that will verify the user''s username and password, after they were entered on a login page.',
'If you enter nothing, you allow any username/password to succeed.',
'The function itself can be defined in the authentication''s ''PL/SQL Code'' textarea, within a package or as a stored function.</p>',
'',
'<p>This function must return a boolean to the login procedure that calls it. It has 2 input parameters ''p_username'' and ''p_password'' that can be used to access the values an end user entered on the login page.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(353301225415398269)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Post Logout Procedure Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the following code in the ''PL/SQL Code'' textarea</p>',
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
'<p>and <code>my_post_logout</code> as ''Post Logout Procedure''.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The name of the procedure that gets called after the end user clicked on the logout URL. It can be used for logging.',
'The procedure itself can be defined in the authentication''s ''PL/SQL Code'' textarea, within a package or as a stored function.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(629094915193552126)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Enable Legacy Authentication Attributes'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Additional authentication attributes become visible if this select list is set to "Yes".',
'They are mainly relevant for custom authentications that have been ported from &PRODUCT_NAME. 4.0 and earlier.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(629174621211563368)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'SSO Partner Application Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(629094915193552126)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If you authenticate with Oracle Application Server Single Sign-On and your application is a registered partner application with SSO, then enter exactly the same name you used when registering the partner application with SSO.',
'',
'If you are relying on Oracle APEX to be the registered partner application, then leave this field blank.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(629550107668606770)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Host'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(629094915193552126)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(629554415286608926)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'LDAP Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(629094915193552126)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'The port number of your LDAP directory host.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(629644211608617346)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(629094915193552126)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the Oracle APEX instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(629669815417618470)
,p_plugin_attribute_id=>wwv_flow_imp.id(629644211608617346)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(629680822344620420)
,p_plugin_attribute_id=>wwv_flow_imp.id(629644211608617346)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(629685004813624810)
,p_plugin_attribute_id=>wwv_flow_imp.id(629644211608617346)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(629825611870636385)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'LDAP DN String'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(629094915193552126)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Exact DN</dt>',
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
'  <dt>Non-Exact DN (Search Base)</dt>',
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN.  Use <strong>%LDAP_USER%</strong> as a place-holder for the username.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(629787303213633849)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Use Exact Distinguised Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(629094915193552126)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(741851526139627010)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(629787303213633849)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>'Enter the search filter when not using an exact distinguished name (DN). Use <code>%LDAP_USER%</code> as a place-holder for the username.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(629863429878641530)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(629094915193552126)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(38291032596231774)
,p_plugin_id=>wwv_flow_imp.id(352953211423309033)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(629094915193552126)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <code><strong>%LDAP_USER%</strong></code> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(38291304329233033)
,p_plugin_attribute_id=>wwv_flow_imp.id(38291032596231774)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(38291708139234196)
,p_plugin_attribute_id=>wwv_flow_imp.id(38291032596231774)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(38292111602235122)
,p_plugin_attribute_id=>wwv_flow_imp.id(38291032596231774)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Do not escape any characters. This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with <code>apex_escape.ldap_dn</code> or <code>apex_escape.ldap_search_filter</code>).'))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(360896225809711408)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>'Execute Code'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS:APEX_APPL_TASKDEF_ACTIONS:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Process to execute PL/SQL code.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(361240401142661438)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>'Close Dialog'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_version_scn=>72472667
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Process to close the current modal or non-modal dialog page.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(369154203766535800)
,p_plugin_id=>wwv_flow_imp.id(361240401142661438)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Items to Return '
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of one or more page items to be returned by the dialog. For multiple items separate each item name with a comma.</p>',
'<p>You can access the returned item values by defining a Dynamic Action to fire on the <strong>Dialog Closed</strong> event on the element that opens the dialog, with an action of <strong>Set Value</strong> and a <em>Set Type</em> of <strong>Dialog R'
||'eturn Item</strong>.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(111651648353491718)
,p_plugin_id=>wwv_flow_imp.id(361240401142661438)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Show Success Messages'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specify whether success messages from processes should be displayed automatically.'
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(361248208719417603)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>'Clear Session State'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472669
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Process to clear session state stored within &PRODUCT_NAME.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361248525085440449)
,p_plugin_id=>wwv_flow_imp.id(361248208719417603)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select what type of session state to clear.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361259116722915252)
,p_plugin_attribute_id=>wwv_flow_imp.id(361248525085440449)
,p_display_sequence=>1
,p_display_value=>'Clear all Items on the Current Page'
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361250412576446197)
,p_plugin_attribute_id=>wwv_flow_imp.id(361248525085440449)
,p_display_sequence=>3
,p_display_value=>'Clear all Items on Page(s)'
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361250015380444942)
,p_plugin_attribute_id=>wwv_flow_imp.id(361248525085440449)
,p_display_sequence=>5
,p_display_value=>'Clear Items'
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361249617968443751)
,p_plugin_attribute_id=>wwv_flow_imp.id(361248525085440449)
,p_display_sequence=>7
,p_display_value=>'Clear Current Session'
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361249219909442830)
,p_plugin_attribute_id=>wwv_flow_imp.id(361248525085440449)
,p_display_sequence=>9
,p_display_value=>'Clear Current Application'
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361248822065441760)
,p_plugin_attribute_id=>wwv_flow_imp.id(361248525085440449)
,p_display_sequence=>10
,p_display_value=>'Clear Applications'
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361253232596482537)
,p_plugin_id=>wwv_flow_imp.id(361248208719417603)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Application(s)'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(361248525085440449)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>'Enter a comma separated list of application IDs, such as <code>100,101,105</code>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361254917715489399)
,p_plugin_id=>wwv_flow_imp.id(361248208719417603)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Item(s)'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(361248525085440449)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>'Select page items to clear from session state, such as <code>P1_EMPNO,P1_ENAME</code>. For multiple items, separate each item name with a comma. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361255209304493322)
,p_plugin_id=>wwv_flow_imp.id(361248208719417603)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Page(s)'
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(361248525085440449)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>'Enter a comma separated list of page numbers, such as <code>1,2,5</code>.'
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(361603521916198029)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>'Reset Pagination'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472669
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process to reset pagination of reports on the current page.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361603814800201390)
,p_plugin_id=>wwv_flow_imp.id(361603521916198029)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Target'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select whether the pagination on all pages, some pages or the current page should be reset.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361604111996202714)
,p_plugin_attribute_id=>wwv_flow_imp.id(361603814800201390)
,p_display_sequence=>10
,p_display_value=>'This Page'
,p_return_value=>'THIS_PAGE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361604905742205597)
,p_plugin_attribute_id=>wwv_flow_imp.id(361603814800201390)
,p_display_sequence=>20
,p_display_value=>'Page(s)'
,p_return_value=>'PAGES'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361604508330204363)
,p_plugin_attribute_id=>wwv_flow_imp.id(361603814800201390)
,p_display_sequence=>30
,p_display_value=>'All Pages'
,p_return_value=>'ALL_PAGES'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361606225139211720)
,p_plugin_id=>wwv_flow_imp.id(361603521916198029)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Page(s)'
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(361603814800201390)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>'Enter a comma separated list of page numbers.'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(361705302264974293)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>'Tabular Form - Add Rows'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472669
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Process to add a row into a Tabular Form region.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361705527915977613)
,p_plugin_id=>wwv_flow_imp.id(361705302264974293)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Number of Rows'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>'Enter the number of rows.'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(361709604296657121)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>'Tabular Form - Multi Row Update'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472669
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Process to update multiple rows from a Tabular Form region. This process will also insert records added in the region.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361709824771662765)
,p_plugin_id=>wwv_flow_imp.id(361709604296657121)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Table Owner'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Select the table owner (schema) name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361710119164665443)
,p_plugin_id=>wwv_flow_imp.id(361709604296657121)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Table Name'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(361709824771662765)
,p_help_text=>'Enter the case-sensitive table or view name. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361710408812670214)
,p_plugin_id=>wwv_flow_imp.id(361709604296657121)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Primary Key Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(361710119164665443)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the column containing the primary key value. For tables with more than two-part primary keys, select <strong>ROWID</strong>.</p>',
'<p>The primary key is used to identify rows to be updated and must not be editable in the tabular form. For new rows, the primary key value must be empty.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361710732738674350)
,p_plugin_id=>wwv_flow_imp.id(361709604296657121)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Secondary Key Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(361710119164665443)
,p_help_text=>'Select the column containing the second primary key value. This attribute should only be populated if your primary key is composed of two columns.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361711421080694858)
,p_plugin_id=>wwv_flow_imp.id(361709604296657121)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Runtime Where Clause'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limit the departments using:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>'Enter the SQL WHERE clause to append to all generated INSERT and UPDATE statements. Use this attribute to limit the records used within automatically generated SQL calls.'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(361799714569626543)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>'Automatic Row Fetch'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472669
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Process to retrieve records from a single database table or view. This process is used to populate form items with a source of Type <strong>Database Column</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361800032025633659)
,p_plugin_id=>wwv_flow_imp.id(361799714569626543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Table Owner'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Select the table owner (schema) name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361800327927635543)
,p_plugin_id=>wwv_flow_imp.id(361799714569626543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Table Name'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(361800032025633659)
,p_help_text=>'Enter the case-sensitive table or view name. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361800622105638213)
,p_plugin_id=>wwv_flow_imp.id(361799714569626543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Primary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item to hold the primary key column value. You can type in the name or pick from the list.'
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361800918654639837)
,p_plugin_id=>wwv_flow_imp.id(361799714569626543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>'Primary Key Column '
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(361800327927635543)
,p_help_text=>'Select the column containing the primary key value. For tables with more than two-part primary keys, select <strong>ROWID</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361801213910642088)
,p_plugin_id=>wwv_flow_imp.id(361799714569626543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Secondary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(361801505499645968)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Enter the page or application item to hold the second primary key column value. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361801505499645968)
,p_plugin_id=>wwv_flow_imp.id(361799714569626543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>'Secondary Key Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(361800327927635543)
,p_depending_on_attribute_id=>wwv_flow_imp.id(361800918654639837)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>'Select the column containing the second primary key value. This attribute should only be populated if your primary key is composed of two columns.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361805328759939092)
,p_plugin_id=>wwv_flow_imp.id(361799714569626543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Row Version Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(361800327927635543)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the column that identifies the version of the row, this column does not need to be present on the page. Leave this attribute blank to use the built-in checksum.</p>',
'<p>Opportunistic locking uses lost update detection to ensure data integrity in applications where data can be accessed concurrently. &PRODUCT_NAME. can use a built in checksum to perform lost update detection and determine the version of the row. Th'
||'e checksum is a hash function of all the column values for the specific table row. It is retrieved when the record is queried from the database, and then compared against the hash of the current record in the database as part of <em>Automatic Row Pro'
||'cessing</em>. If the two values are the same then the update proceeds, otherwise an error is raised by Automatic Row Processing.</p>',
'<p>This attribute enables you to specify a single column which holds the row version, as an alternative to using the built-in checksum processing. This column should be updated whenever a record in the database is updated. Oracle recommends implement'
||'ing a ''Before Update'' database trigger on the table to increment or otherwise update the row version column. NUMBER columns are presumed to contain a sequence number for the row. However, DATE and TIMESTAMP columns can also be used. The advantage of '
||'using a single column is that the &PRODUCT_NAME. engine does not need to perform the hash of the complete row, instead it can just compare a single column value.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361804814168854679)
,p_plugin_id=>wwv_flow_imp.id(361799714569626543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Runtime Where Clause'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limit the departments using:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>'Enter the SQL WHERE clause to append to the generated SELECT statement. Use this attribute to limit the records used within automatically generated SQL calls.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361802100261724338)
,p_plugin_id=>wwv_flow_imp.id(361799714569626543)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Fetch Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'This option exists for backwards compatibility only.',
'New applications should always leave this setting empty.',
'The option "Set Memory Cache on Display" is deprecated and is not utilized in processes generated with this release of &PRODUCT_NAME..',
'</p>',
'<p>',
'When an Automated Row Fetch process selects a row, the corresponding page items are set to the fetched column values. The DML Fetch Mode setting determines when that happens. The default mode updates the in-memory session state immediately when the r'
||'ow is fetched. The mode ''Set Memory Cache on Display'' updates this session state only when (and if) the item is rendered. If you need to reference the fetched value of the item using bind variable or <code>v(''ITEM_NAME'')</code> syntax between the tim'
||'e of the row fetch and the time of the item rendering, you must use the default fetch mode. When you create a new Automatic Row Fetch process, its fetch mode is set to this default mode. Unless your page''s logic depends on the ''On Display'' behavior, '
||'we suggest that you update this process to use default behavior, to give you maximum flexibility to reference fetched column values during page rendering.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(361803025912727611)
,p_plugin_attribute_id=>wwv_flow_imp.id(361802100261724338)
,p_display_sequence=>20
,p_display_value=>'Set Memory Cache on Display [Deprecated]'
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(361898027238424612)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>'Web Service'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_version_scn=>72472669
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Process to consume the specified Web service.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361898312142431520)
,p_plugin_id=>wwv_flow_imp.id(361898027238424612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Web Service Operation'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>'Select a Web Service Operation.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(703289302749886160)
,p_plugin_id=>wwv_flow_imp.id(361898027238424612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Store Result In'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(703289611172888366)
,p_plugin_attribute_id=>wwv_flow_imp.id(703289302749886160)
,p_display_sequence=>10
,p_display_value=>'Item(s)'
,p_return_value=>'ITEMS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(703290033944889185)
,p_plugin_attribute_id=>wwv_flow_imp.id(703289302749886160)
,p_display_sequence=>20
,p_display_value=>'Collection'
,p_return_value=>'COLLECTION'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(703290641370900883)
,p_plugin_id=>wwv_flow_imp.id(361898027238424612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Collection Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(703289302749886160)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(362034004386015380)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>'Form Pagination'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Process to retrieve the previous or next record from a database table or view. This process can be used to provide pagination on Form pages, so that end users can retrieve the previous or next record without navigating back to a report.</p>',
'<p><em>Note: If the form allows data to be updated then you should generally ensure that the appropriate form processing is performed prior to this pagination process executing. Otherwise, any updates made by the end user will be lost when they navig'
||'ate to another record.</em></p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362034324862021077)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Table Owner'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Select the table owner (schema) name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362034618176024149)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Table Name'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(362034324862021077)
,p_help_text=>'Enter the case-sensitive table or view name. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362035122261037451)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Primary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item that holds the primary key column value. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362035415360040649)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>'Primary Key Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(362034618176024149)
,p_help_text=>'Select the column containing the primary key value. For tables with more than two-part primary keys, select <strong>ROWID>/strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362035708675043722)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Secondary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(362036002636046567)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Enter the page or application item that holds the second primary key column value. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362036002636046567)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Secondary Key Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(362034618176024149)
,p_depending_on_attribute_id=>wwv_flow_imp.id(362035415360040649)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>'Select the column containing the second primary key value. This attribute should only be populated if your primary key is composed of two columns.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362067915033505841)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Navigation Order Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(362034618176024149)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the column containing the navigation order value.</p>',
'<p>This column is used to determine the previous and next rows. Therefore, a column such as <code>DISPLAY_SEQ</code> is an ideal column to use. If you want to order records in the sequence they were created you could use a column such as <code>CREATE'
||'D</code> or <code>ID</code>, when populated from a sequence or based on an Oracle Database 12<em>c</em> Identity column. However, you have the flexibility to order records on any two columns, for example <code>JOB</code> and <code>DEPTNO</code></p>',
'<p><em>Note: The navigation order columns should match the default columns used to order the report end users navigated from to get to this form. Alternatively, you should ensure end users understand how the previous and next rows are determined, for'
||' example by using button labels or help text.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362068209426508489)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Secondary Navigation Order Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(362034618176024149)
,p_help_text=>'Select the column containing the second navigation order value. This attribute should only be populated if your navigation key is composed of two columns.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362068730117514082)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Next Primary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item that holds the primary key column value for the <em>next</em> record. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362069024510516623)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Previous Primary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item that holds the primary key column value for the <em>previous</em> record. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362069318687519376)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Next Secondary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(362036002636046567)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Enter the page or application item that holds the second primary key column value for the <eme>next</em> record. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362069614158521442)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Previous Secondary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(362036002636046567)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Enter the page or application item that holds the second primary key column value for the <em>previous</em> record. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362070100572527702)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Current Row Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the page or application item to hold the total record count value. You can type in the name or pick from the list.</p>',
'<p>If your result set contains more than 10,000 rows, defining this item may slow down the performance.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362070418675534553)
,p_plugin_id=>wwv_flow_imp.id(362034004386015380)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Runtime Where Clause'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>'Enter a SQL statement to restrict the records returned by the query.'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(362310022409142749)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>'Legacy Web Service'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Process to consume the specified Web service. Oracle recommends updating this process to <strong>Web Service</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362310307960149400)
,p_plugin_id=>wwv_flow_imp.id(362310022409142749)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Web Service Reference'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the Web service reference number.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(704862682583352671)
,p_plugin_id=>wwv_flow_imp.id(362310022409142749)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Store Result In'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(704862979987353733)
,p_plugin_attribute_id=>wwv_flow_imp.id(704862682583352671)
,p_display_sequence=>10
,p_display_value=>'Item(s)'
,p_return_value=>'ITEMS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(704863378280354870)
,p_plugin_attribute_id=>wwv_flow_imp.id(704862682583352671)
,p_display_sequence=>20
,p_display_value=>'Collection'
,p_return_value=>'COLLECTION'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(704864081757360262)
,p_plugin_id=>wwv_flow_imp.id(362310022409142749)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Collection Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(704862682583352671)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(376364131288521442)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>'Textarea'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:SESSION_STATE_CLOB'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a multiple-row text area.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(376904739508510313)
,p_plugin_id=>wwv_flow_imp.id(376364131288521442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Resizable'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specify whether the text area resizing using the mouse is enabled.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(376905227172516182)
,p_plugin_id=>wwv_flow_imp.id(376364131288521442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Auto-Height'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether the height of the text area varies based on the amount of text displayed. Use this option to scale the text area to the amount of data.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(376905734098518181)
,p_plugin_id=>wwv_flow_imp.id(376364131288521442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Character Counter'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether a counter is displayed below the text area. The counter displays the number of characters entered in the field, such as <code>123</code>. If the Maximum Length attribute is specified, the counter also displays the number of the total '
||'characters permitted, e.g. <code>123 of 4000</code>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362202612251785897)
,p_plugin_id=>wwv_flow_imp.id(376364131288521442)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Trim Spaces'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how the item value is trimmed after submitting the page. This setting trims spaces, tabs, and new lines from the text entered.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362202910095786913)
,p_plugin_attribute_id=>wwv_flow_imp.id(362202612251785897)
,p_display_sequence=>10
,p_display_value=>'Leading'
,p_return_value=>'LEADING'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362203307938787882)
,p_plugin_attribute_id=>wwv_flow_imp.id(362202612251785897)
,p_display_sequence=>20
,p_display_value=>'Trailing'
,p_return_value=>'TRAILING'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362203705781788933)
,p_plugin_attribute_id=>wwv_flow_imp.id(362202612251785897)
,p_display_sequence=>30
,p_display_value=>'Leading and Trailing'
,p_return_value=>'BOTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362204104056789676)
,p_plugin_attribute_id=>wwv_flow_imp.id(362202612251785897)
,p_display_sequence=>40
,p_display_value=>'None'
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(380028817628072908)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>'Classic Report'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING:ORDER_BY'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Simplified report based on a SQL Query. Classic Reports are similar to Interactive Reports, but do not include the numerous end-user customization options available with Interactive Reports.'
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(234584057047894023)
,p_plugin_id=>wwv_flow_imp.id(380028817628072908)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(380029119558081299)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>'Tabular Form'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Display multiple rows of data in a grid layout, where end users can update values directly within a grid element.'
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845153406632834485)
,p_plugin_id=>wwv_flow_imp.id(380029119558081299)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(380454112071587884)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>'Interactive Report'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'<p>Feature-rich reporting component that enables end users to create and customize saved reports, with a variety of features such as aggregations, computed columns, highlighting, charting, grouping, subscriptions, and more.</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1831648887398980457)
,p_plugin_id=>wwv_flow_imp.id(380454112071587884)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'actions_menu_structure'
,p_prompt=>'Actions Menu Structure'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify whether the Actions menu structure will be consistent with the Interactive Grid component, or whether it will use the legacy structure.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1831649884271983182)
,p_plugin_attribute_id=>wwv_flow_imp.id(1831648887398980457)
,p_display_sequence=>10
,p_display_value=>'Legacy'
,p_return_value=>'LEGACY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1831650362309985149)
,p_plugin_attribute_id=>wwv_flow_imp.id(1831648887398980457)
,p_display_sequence=>20
,p_display_value=>'Interactive Grid'
,p_return_value=>'IG'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(234862891586787752)
,p_plugin_id=>wwv_flow_imp.id(380454112071587884)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(384582062506273077)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>'Static Content'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Display text content or a region container for page items. To output HTML markup and not have the content escaped, set <em>Output As</em> to <strong>HTML</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(384582415870309214)
,p_plugin_id=>wwv_flow_imp.id(384582062506273077)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_static_id=>'expand_shortcuts'
,p_prompt=>'Expand Shortcuts'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(481599132721933414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>'Specify whether &PRODUCT_NAME. expands Shortcuts in the HTML body.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(481599132721933414)
,p_plugin_id=>wwv_flow_imp.id(384582062506273077)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_static_id=>'output_as'
,p_prompt=>'Output As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how text content is output.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(481599442113934184)
,p_plugin_attribute_id=>wwv_flow_imp.id(481599132721933414)
,p_display_sequence=>10
,p_display_value=>'Text (escape special characters)'
,p_return_value=>'TEXT'
,p_help_text=>'&PRODUCT_NAME. escapes special HTML characters, such as <code>"<", ">", "&"</code>, when emitting the region source.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(481600445121939808)
,p_plugin_attribute_id=>wwv_flow_imp.id(481599132721933414)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>'&PRODUCT_NAME. includes HTML markup when emitting the region source. This may make the region vulnerable to cross-site scripting.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(481600813887948606)
,p_plugin_id=>wwv_flow_imp.id(384582062506273077)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_static_id=>'show_line_breaks'
,p_prompt=>'Show Line Breaks'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(481599132721933414)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>'Specify whether line breaks in the region source cause line breaks in the region output.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(105618485369724390)
,p_plugin_id=>wwv_flow_imp.id(384582062506273077)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(385049040242438541)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>'PL/SQL Dynamic Content'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Displays the HTML output from the PL/SQL code.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845153863368834496)
,p_plugin_id=>wwv_flow_imp.id(385049040242438541)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(385104627384108788)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>'SVG Chart'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Display data in a SVG Chart. This region type has been deprecated. Please use <em>Chart</em> region type for new chart regions. Oracle recommends that you use <em>Upgrade Application</em> to update these regions to the equivalent Chart region.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845153953839834498)
,p_plugin_id=>wwv_flow_imp.id(385104627384108788)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(385106170962146118)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>'Simple Chart'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Display data in a HTML chart. This region type has been deprecated. Please use <em>Chart</em> region type for new chart regions. Oracle recommends that you use <em>Upgrade Application</em> to update these regions to the equivalent Chart region.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(385504073407123938)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>'Tree'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display data in a hierarchical structure, based on parent-child relationships between records.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(388222674242760077)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_static_id=>'activate_node_link_with'
,p_prompt=>'Activate Node Link with'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Select the action required to activate node links on your tree. A tree may be used primarily for selection/display or navigation. If used for both selection and navigation it is recommended to set this to Double Click so that a single click will j'
||'ust select the node.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(388222945238760981)
,p_plugin_attribute_id=>wwv_flow_imp.id(388222674242760077)
,p_display_sequence=>10
,p_display_value=>'Single Click'
,p_return_value=>'S'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(388223328719761701)
,p_plugin_attribute_id=>wwv_flow_imp.id(388222674242760077)
,p_display_sequence=>20
,p_display_value=>'Double Click'
,p_return_value=>'D'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(388223746905766372)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_static_id=>'selected_node_page_item'
,p_prompt=>'Selected Node Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715830565095726781)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the page or application item that you wish to hold the selected node value. You can type in the name or pick from the list of available items.</p>',
'<p>This item is used to save tree state, by holding the value of the last selected node. The value of the selected node can be saved to the selected item via the node link attribute, or via a page process. When the page is reloaded, the tree is opene'
||'d to the selected node value.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(388224056018770786)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_static_id=>'tree_tooltip'
,p_prompt=>'Tooltip'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select whether tooltips are displayed, and the source for the tooltip. If a tooltip is defined, it is displayed when the end user focuses or hovers over a tree node label.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(388224310716771380)
,p_plugin_attribute_id=>wwv_flow_imp.id(388224056018770786)
,p_display_sequence=>10
,p_display_value=>'None'
,p_return_value=>'N'
,p_help_text=>'No tooltip will be displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(388224757018772639)
,p_plugin_attribute_id=>wwv_flow_imp.id(388224056018770786)
,p_display_sequence=>20
,p_display_value=>'Legacy Template'
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>'Use a static tooltip value with the following data source column substitutions: #VALUE#, #TITLE#, #LINK# and #TOOLTIP#'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(715829871157706251)
,p_plugin_attribute_id=>wwv_flow_imp.id(388224056018770786)
,p_display_sequence=>30
,p_display_value=>'HTML Expression'
,p_return_value=>'TEMPLATE'
,p_help_text=>'Provide an HTML Expression to use as tooltip. Substitutions are being performed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(388225194623774797)
,p_plugin_attribute_id=>wwv_flow_imp.id(388224056018770786)
,p_display_sequence=>40
,p_display_value=>'Database Column'
,p_return_value=>'DB'
,p_help_text=>'Use the value of the <strong>Tooltip Column</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(388225546559783958)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_static_id=>'tooltip_value'
,p_prompt=>'Tooltip Value'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(388224056018770786)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>'Enter the text displayed when an end user hovers over a tree element.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(388410177919650647)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_static_id=>'static_tree_id'
,p_prompt=>'Static Tree ID'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>An optional unique identifier for the tree.</p>',
'<p>It is better to give the region a Static ID and use the apex.region("<i>static-id</i>").widget() API to access the tree element.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1397688173262880316)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_static_id=>'icon_type_css_class'
,p_prompt=>'Icon Type CSS Class'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A CSS class used to specify the type of icons used for all nodes. This class is used in CSS rules to specify properties for all icons of that type. The icon type along with the value of the icon column of the region source determines the icon CSS '
||'classes used for each node.</p>',
'<p>Typical values are:</p>',
'<ul>',
'<li><strong><code>a-Icon</code></strong> This allows using a small number of built-in APEX icons such as <code>icon-circle</code> or <code>icon-tree-folder</code>.</li>',
'<li><strong><code>fa</code></strong> This allows using Font APEX or Font Awesome icons. The Universal Theme makes one of these icon libraries available.</li>',
'</ul>',
'<p>If no value is given there is no icon type. The icon type CSS class, if needed, can be included in the icon column. For example the icon column value could be "fa fa-user".',
'For a tree with no icons set the Icon Type, and Default Icon attributes to empty and in the SQL Query source the icon column should be null.',
'Custom or third party themes may have their own font or CSS sprite icon library and use a different icon type/prefix class that you can specify here.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(388198764505202174)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_static_id=>'default_icon_css_class'
,p_prompt=>'Default Icon CSS Class'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>'<p>If the Icon Type is <code>fa</code> for Font APEX you can use values such as: <code>fa-user-circle-o</code>, <code>fa-file-o</code>, or <code>fa-arrow-circle-right</code>. See the Universal Theme app for a list of all the icons.</p>'
,p_help_text=>'The default icon to use when the SQL Query icon column is null. The value is a CSS class name that specifies what icon will be seen. The possible values depend on the Icon Type.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715809220298508190)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_static_id=>'node_label_column'
,p_prompt=>'Node Label Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_is_translatable=>false
,p_help_text=>'Select the data source column containing the value for the node label. The value cannot contain markup.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715811910493561671)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_static_id=>'hierarchy_level_column'
,p_prompt=>'Hierarchy Level Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715810380689519088)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>'Select the data source column containing the value for the hierarchy level of the node. Required when the <strong>Hierarchy</strong> attribute is set to <strong>Not Computed</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715813002119570686)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_static_id=>'icon_css_class_column'
,p_prompt=>'Icon CSS Class Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'Select the data source column containing the value for the icon CSS class to be applied to the node.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715814135069583776)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_static_id=>'node_id_column'
,p_prompt=>'Node ID Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715810380689519088)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>'Select the data source column containing the ID for a node. This is required when the hierarchy is being computed by Oracle APEX. Typically, a primary key column is chosen here.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715815231948590626)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_static_id=>'parent_key_column'
,p_prompt=>'Parent Key Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715810380689519088)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>'Select the data source column containing the value for the parent key of a node. Required when Oracle APEX computes the hierarchy.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715816326045601781)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_static_id=>'node_status_column'
,p_prompt=>'Node Status Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715810380689519088)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>'Select the data source column containing the value for the node status. Required when the <strong>Hierarchy</strong> attribute is set to <strong>Not Computed</strong>. The column must contain <strong>0</strong> for leaf nodes and <strong>1</strong> f'
||'or nodes with children.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715817436034604662)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_static_id=>'start_tree_with'
,p_prompt=>'Start Tree With'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715810380689519088)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>'This attribute determines how the root of the tree is computed. Nodes, for which the <strong>Parent Key</strong> column contains the value defined here will be considered as root nodes. Multiple roots are possible.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(715818524967607963)
,p_plugin_attribute_id=>wwv_flow_imp.id(715817436034604662)
,p_display_sequence=>10
,p_display_value=>'Based on Existing Item'
,p_return_value=>'ITEM'
,p_help_text=>'Use an item value to start the tree.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(715818952174610864)
,p_plugin_attribute_id=>wwv_flow_imp.id(715817436034604662)
,p_display_sequence=>20
,p_display_value=>'Based on SQL Query'
,p_return_value=>'SQL'
,p_help_text=>'Use the value returned by a SQL query to start the tree.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(715819396180612829)
,p_plugin_attribute_id=>wwv_flow_imp.id(715817436034604662)
,p_display_sequence=>30
,p_display_value=>'Based on Static Value'
,p_return_value=>'STATIC'
,p_help_text=>'Use a static value to start the tree.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(715819794480614454)
,p_plugin_attribute_id=>wwv_flow_imp.id(715817436034604662)
,p_display_sequence=>40
,p_display_value=>'Value is NULL'
,p_return_value=>'NULL'
,p_help_text=>'Use SQL NULL to start the tree.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715821189465630260)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_static_id=>'start_tree_with_item'
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715817436034604662)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>'Choose the item containing the value to start the tree with.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715822207129637643)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_static_id=>'start_tree_with_sql_query'
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715817436034604662)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>'Specify the SQL Query to determine the value to start the tree with. The SQL Query is always being executed in the <em>local database</em> and must return exactly one column.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715823388473642206)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_static_id=>'start_tree_with_static_value'
,p_prompt=>'Static Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715817436034604662)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>'Static value to start the tree with.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715830565095726781)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_static_id=>'node_value_column'
,p_prompt=>'Node Value Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_is_translatable=>false
,p_help_text=>'Select the data source column containing the value for the node "value". This value is not displayed but added to the tree adapter node id property that can be accessed using JavaScript.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715824464978646322)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_static_id=>'tree_link'
,p_prompt=>'Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Specify the link to be executed when a node is clicked.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715825559244651508)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_static_id=>'tooltip_column'
,p_prompt=>'Tooltip Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(388224056018770786)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>'Select the data source column containing the value for the node tooltip.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715810380689519088)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_static_id=>'tree_hierarchy'
,p_prompt=>'Hierarchy'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Indicate whether Oracle APEX should compute the tree hierarchy from the data or whether the data already contains all hierarchy information.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(715810629237528987)
,p_plugin_attribute_id=>wwv_flow_imp.id(715810380689519088)
,p_display_sequence=>10
,p_display_value=>'Computed with SQL'
,p_return_value=>'SQL'
,p_help_text=>'The hierarchy is computed using the SQL START WITH CONNECT BY clause. Providing a <strong>Parent Key Column</strong> is required. Use this option only if your SQL query does <em>not</em> already contain a START WITH CONNECT BY clause.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(715811097049545246)
,p_plugin_attribute_id=>wwv_flow_imp.id(715810380689519088)
,p_display_sequence=>20
,p_display_value=>'Not Computed'
,p_return_value=>'LEVEL'
,p_help_text=>'All hierarchy information is already contained in the data. Mapping the <strong>Node Level</strong> and <strong>Node Status</strong> columns is required for this option. The <strong>Node Level</strong> must contain the hierarchy level as a numeric va'
||'lue; the <strong>Node Status</strong> must contain <strong>0</strong> for a leaf node and <strong>1</strong> for a non-leaf node.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715827441883672711)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_static_id=>'link_column'
,p_prompt=>'Link Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715824464978646322)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Select the data source column containing the value for the link to be executed when a node is clicked.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(715828729502680591)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_static_id=>'order_siblings_by'
,p_prompt=>'Order Siblings By'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(715810380689519088)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>'Select the data source column to use for ordering children within a parent node.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(381686476818136654)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a JavaScript function that takes an options object for the Tree, modifies the object, and returns it. This allows advanced customization of the Tree during initialization of the treeView widget. See the treeView widget JavaScript API documen'
||'tation for the available options.<p>',
'<p>Additional options defined by the tree region:</p>',
'<ul>',
'<li><strong>makeNodeAdapter</strong> Used to define a custom nodeAdapter. It is a function that takes the same arguments as makeDefaultNodeAdapter and must return a treeNodeAdapter interface.</li>',
'<li><strong>initialSelectedNodeId</strong> The value of a node to select. This is set according to the Selected Node Page Item attribute.</li>',
'<li><strong>nodeHasTooltip</strong> This is set according to the Tooltip attribute. It is true if the node has a tooltip and false otherwise.</li>',
'<li><strong>regionStaticId</strong> This is the element id used for this region.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(715829199415682079)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following SQL queries return columns specific to Tree region attributes:</p>',
'<dl>',
'<dt>When the Hierarchy attribute is set to Computed with SQL</dt>',
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
'<p>Specify EMPNO for Node ID Column, MGR as Parent Key Column attributes</p>',
'</dd>',
'<dt>When the Hierarchy attribute is set to Not Computed</dt>',
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
'<p>Specify STATUS for Node Status Column, LEVEL for Hierarchy Level Column attributes.</p>',
'</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(389020154426295680)
,p_plugin_id=>wwv_flow_imp.id(385504073407123938)
,p_name=>'treeviewselectionchange'
,p_display_name=>'Selection Change'
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(385516061640387971)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>'Calendar'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Display date based entries on a variety of calendar views.</p>',
'<p>You should use <em>Calendar</em> rather than this region type when creating new regions. Classic Calendar regions are generally those created in &PRODUCT_NAME. Release 4.2 or earlier.</p>'))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845154143004834501)
,p_plugin_id=>wwv_flow_imp.id(385516061640387971)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(385516341883422042)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>'Classic Tree'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Display data in a hierarchical structure, based on parent-child relationships between records.</p>',
'<p>You should use <em>Tree</em> rather than this region type when creating new regions. </p>'))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(385518660732877617)
,p_plugin_id=>wwv_flow_imp.id(385516341883422042)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'tree_component_id'
,p_prompt=>'Tree Component ID'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(388431570538859249)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>'Expand Tree'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_help_text=>'Expand the current node in a tree region.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(388635386274723384)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>'Collapse Tree'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_help_text=>'Collapse the current node in a tree region.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(435122514730662817)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>'Password'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays an HTML password form element. As the end user enters text a black dot is displayed for that character, instead of the actual character entered.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(435122925859694465)
,p_plugin_id=>wwv_flow_imp.id(435122514730662817)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Submit when Enter pressed'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specify whether pressing the <em>Enter</em> key while in this field automatically submits the page.'
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(442021108862425785)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>'Stop and Start Grid Layout'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_version_scn=>72472674
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Legacy item Used to stop the previous HTML table and start a new HTML table. Before <em>Grid Layout</em> was introduced in &PRODUCT_NAME. Release xx, this item type was used extensively to tailor the display of page items.</p>',
'<p>Oracle recommends deleting these legacy item types and updating the <em>Start New Grid</em> to <strong>Yes</strong> for the next page item displayed in that region. This is functionally equivalent to using a Stop and Start Grid Layout item.</p>'))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(457584914213394021)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>'Refresh'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472676
,p_subscribe_plugin_settings=>true
,p_help_text=>'Triggers a refresh of the affected elements. Not all elements support a refresh action. You can use this action to refresh content in Interactive Reports, Classic Reports, and all item types with cascading LOV support.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(517009436728139227)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>'Show'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_version_scn=>72472676
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Shows the affected elements.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(262167718423622079)
,p_plugin_id=>wwv_flow_imp.id(517009436728139227)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Show all on the same line'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether all the page items and labels on the same line as the affected elements are shown.</p>',
'<p>Note: This attribute does not work for items on pages that do not use a table grid to display form items. This includes any page using a mobile page template.</p>'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(552639319797428791)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>'HTTP Header Variable'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472676
,p_subscribe_plugin_settings=>true
,p_help_text=>'Authenticate externally, where the username is stored in a HTTP Header variable set by the web server.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(552647115426436957)
,p_plugin_id=>wwv_flow_imp.id(552639319797428791)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username. If not specified, REMOTE_USER will be used.</p>',
'',
'<p>The HTTP header variable is a variable set by the web server.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(552651403090442945)
,p_plugin_id=>wwv_flow_imp.id(552639319797428791)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(552655716596446845)
,p_plugin_attribute_id=>wwv_flow_imp.id(552651403090442945)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(552667630233460180)
,p_plugin_attribute_id=>wwv_flow_imp.id(552651403090442945)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(552687932441470278)
,p_plugin_attribute_id=>wwv_flow_imp.id(552651403090442945)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(552699720929485951)
,p_plugin_id=>wwv_flow_imp.id(552639319797428791)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(552651403090442945)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(552704028894488210)
,p_plugin_id=>wwv_flow_imp.id(552639319797428791)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(552651403090442945)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(879327919421164751)
,p_plugin_id=>wwv_flow_imp.id(552639319797428791)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(879343501197168872)
,p_plugin_attribute_id=>wwv_flow_imp.id(879327919421164751)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(879347807777170859)
,p_plugin_attribute_id=>wwv_flow_imp.id(879327919421164751)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(39504908766917753)
,p_plugin_id=>wwv_flow_imp.id(552639319797428791)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>For Oracle Access Manager based SSO, enter for example:</p>',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.</p>',
'',
'<p>The substitution parameter <code>%POST_LOGOUT_URL%</code> will be replaced by an encoded URL to the login page of your application.</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(562560582820583985)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>'HTML Expression'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_version_scn=>72472676
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a non-enterable item based on a HTML expression.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(562566479673647057)
,p_plugin_id=>wwv_flow_imp.id(562560582820583985)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTML Expression'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Change the background and text colors</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Use Heading 2</dt>',
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
'  <dt>Use a dynamic class from the SQL query</dt>',
'    <dd><pre>&lt;span class="&amp;COLUMN_CLASS!ATTR.">&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    The <code>&amp;COLUMN_CLASS!ATTR.</code> and <code>&amp;EMPLOYEE_STATUS.</code> substitutions in this example are columns selected in the SQL query.</dd>',
'  <dt>Show an image, and a tooltip on hover</dt>',
'    <dd><pre>&lt;img src="&amp;IMAGE_NAME!ATTR." title="&amp;EMPLOYEE_NAME!ATTR."&gt;</pre></dd>',
'</dl>'))
,p_help_text=>'Enter HTML expressions to be shown in this column. Use <code>&amp;COLUMN.</code> syntax to show column values in HTML.'
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(567106626791482337)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>'Link'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_version_scn=>72472676
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a non-enterable item as a link.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(626823504054693040)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>'Clear'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472676
,p_subscribe_plugin_settings=>true
,p_help_text=>'Clears the affected elements.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(626823719638697634)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>'Alert'
,p_category=>'NOTIFICATION'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_version_scn=>72472676
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays an alert message, with a single <em>Ok</em> button. Use to display information that must be responded to, by pressing the button, but continues executing the event.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(626823916999706267)
,p_plugin_id=>wwv_flow_imp.id(626823719638697634)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Message'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>'<p>Employee &amp;P1_ENAME. &lt;strong&gt;could not&lt;&#x2F;strong&gt; be deleted.</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the message to be displayed in the alert dialog.</p>',
'<p>Item substitutions will be performed client-side at the time the dialog is shown.</p>'))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3701076455936800)
,p_plugin_id=>wwv_flow_imp.id(626823719638697634)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'<p>Optionally provide a dialog title.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3701701323970349)
,p_plugin_id=>wwv_flow_imp.id(626823719638697634)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Specify the style of the dialog.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3703043398973992)
,p_plugin_attribute_id=>wwv_flow_imp.id(3701701323970349)
,p_display_sequence=>10
,p_display_value=>'Information'
,p_return_value=>'information'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3702623945972615)
,p_plugin_attribute_id=>wwv_flow_imp.id(3701701323970349)
,p_display_sequence=>20
,p_display_value=>'Danger'
,p_return_value=>'danger'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3702291441971350)
,p_plugin_attribute_id=>wwv_flow_imp.id(3701701323970349)
,p_display_sequence=>30
,p_display_value=>'Warning'
,p_return_value=>'warning'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3703410946975189)
,p_plugin_attribute_id=>wwv_flow_imp.id(3701701323970349)
,p_display_sequence=>40
,p_display_value=>'Success'
,p_return_value=>'success'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3705287585006856)
,p_plugin_id=>wwv_flow_imp.id(626823719638697634)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Icon'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Specify an optional dialog icon.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3704914260003167)
,p_plugin_id=>wwv_flow_imp.id(626823719638697634)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'CSS Classes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional CSS classes to be applied to the dialog container.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3705505358011056)
,p_plugin_id=>wwv_flow_imp.id(626823719638697634)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'OK Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'Enter the label of the OK button. If none is provided, the value of text message <code>APEX.DIALOG.OK</code> will be used.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(626824429466709866)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>'Confirm'
,p_category=>'NOTIFICATION'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_version_scn=>72472676
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a confirmation dialog, with Cancel and Confirm buttons. If the user chooses <em>Cancel</em> then the proceeding actions are not executed and the current event is canceled.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(626824618169716040)
,p_plugin_id=>wwv_flow_imp.id(626824429466709866)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Message'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>'<p>&lt;strong&gt;Are you sure&lt;&#x2F;strong&gt; you wish to delete employee &amp;P1_ENAME.?</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the message to be displayed in the confirmation dialog.</p>',
'<p>Item substitutions will be performed on the client-side at the time the dialog is shown.</p>'))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2101389282482255)
,p_plugin_id=>wwv_flow_imp.id(626824429466709866)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'<p>Optionally provide a dialog title.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2103085785653286)
,p_plugin_id=>wwv_flow_imp.id(626824429466709866)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Specify the style of the dialog.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2104149014656515)
,p_plugin_attribute_id=>wwv_flow_imp.id(2103085785653286)
,p_display_sequence=>10
,p_display_value=>'Information'
,p_return_value=>'information'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2103302674655458)
,p_plugin_attribute_id=>wwv_flow_imp.id(2103085785653286)
,p_display_sequence=>20
,p_display_value=>'Warning'
,p_return_value=>'warning'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2103765346655897)
,p_plugin_attribute_id=>wwv_flow_imp.id(2103085785653286)
,p_display_sequence=>30
,p_display_value=>'Danger'
,p_return_value=>'danger'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2104502204657360)
,p_plugin_attribute_id=>wwv_flow_imp.id(2103085785653286)
,p_display_sequence=>40
,p_display_value=>'Success'
,p_return_value=>'success'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2106373192721945)
,p_plugin_id=>wwv_flow_imp.id(626824429466709866)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Icon'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Specify an optional dialog icon.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2106035369711819)
,p_plugin_id=>wwv_flow_imp.id(626824429466709866)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'CSS Classes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional CSS classes to be applied to the dialog container.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2106917926775379)
,p_plugin_id=>wwv_flow_imp.id(626824429466709866)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Confirm Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'Enter the label of the confirmation button. If none is provided, the value of text message <code>APEX.DIALOG.OK</code> will be used.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2106670847763561)
,p_plugin_id=>wwv_flow_imp.id(626824429466709866)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Cancel Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'Enter the label of the Cancel button. If none is provided, the value of text message <code>APEX.DIALOG.CANCEL</code> will be used.'
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(668666822163400066)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>'Parse Uploaded Data'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Process to parse the prepared spreadsheet data in preparation for loading into an existing table. This process type is generated by the Create Page Wizard for <em>Data Loading</em>.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(668751414675407356)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Data Load Definition'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Select the Data Load Definition, from Shared Components, which defines the table to be loaded.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(668863505241423607)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Import From Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>Import From</em> option chosen by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(714598810997211212)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Separator Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>Seperator</em> text entered by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(714603217923213191)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Enclosed By Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>Optionally Enclosed By</em> text entered by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(668904302255432174)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'First Row Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>First Row has Column Names</em> checkbox value entered by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(668954022687438059)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Currency Symbol Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>Currency Symbol</em> text entered by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(668962228228439718)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Group Separator Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>Group Seperator</em> text entered by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(668977904810442452)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Decimal Character Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>Decimal Character</em> text entered by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(668982211736444415)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'File Name Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>File Name</em> value entered by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(669001326628448680)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Copy and Paste Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>Copy and Paste Delimited Date</em> text entered by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(24234014577732260)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Character Set Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'Enter the page item to hold the <em>File Character Set</em> selected by the end user. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48837321936282082)
,p_plugin_id=>wwv_flow_imp.id(668666822163400066)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Date Format Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Enter the page item to hold the <em>Date Format</em> text entered by the end user. You can type in the name or pick from the list of available items.'
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(669051019271465508)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>'Data Upload Column Mapping'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Map uploaded spreadsheet columns to table columns. This region type is generated by the Create Page Wizard for <em>Data Loading</em>.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(669071925851467433)
,p_plugin_id=>wwv_flow_imp.id(669051019271465508)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'data_load_def_id'
,p_prompt=>'Data Load Definition'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Select the Data Load Definition defined in the <em>Data Loading</em> process.'
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(669101621133475493)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>'Prepare Uploaded Data'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Process to prepare spreadsheet data for uploading into an existing table. This process type is generated by the Create Page Wizard for <em>Data Loading</em>.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(670229105709707629)
,p_plugin_id=>wwv_flow_imp.id(669101621133475493)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Data Load Definition'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Select the Data Load Definition, from Shared Components, which defines the table to be loaded.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(380468155644060156)
,p_plugin_id=>wwv_flow_imp.id(669101621133475493)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Insert Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item to hold the number of records to be inserted. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(380468974968063264)
,p_plugin_id=>wwv_flow_imp.id(669101621133475493)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Update Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item to hold the number of records to be updated. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(380469514614067903)
,p_plugin_id=>wwv_flow_imp.id(669101621133475493)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item to hold the number of records with errors. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(380470030664073278)
,p_plugin_id=>wwv_flow_imp.id(669101621133475493)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Review Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item to hold the number of records reviewed. You can type in the name or pick from the list of available items.'
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(669285217502512352)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>'Load Uploaded Data'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Process to load the parsed spreadsheet data into an existing table or view. This process type is generated by the Create Page Wizard for <em>Data Loading</em>.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(669308626852514974)
,p_plugin_id=>wwv_flow_imp.id(669285217502512352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Data Load Definition'
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Select the Data Load Definition, from Shared Components, which defines the table to be loaded.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(669317208629519157)
,p_plugin_id=>wwv_flow_imp.id(669285217502512352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Insert Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page or application item to hold the number of records inserted.',
'You can type in the name or pick from the list of available items.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(669321513477520652)
,p_plugin_id=>wwv_flow_imp.id(669285217502512352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Update Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page or application item to hold the number of records updated.',
'You can type in the name or pick from the list of available items.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(669325819364522297)
,p_plugin_id=>wwv_flow_imp.id(669285217502512352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page or application item to hold the number of records with errors.',
'You can type in the name or pick from the list of available items.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(208350031209048901)
,p_plugin_id=>wwv_flow_imp.id(669285217502512352)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Review Count Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page or application item to hold the number of records reviewed.',
'You can type in the name or pick from the list of available items.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(707619648734994478)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>'Oracle APEX Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>Enter your username and password for your &PRODUCT_NAME. account. Each workspace has its own user account repository. The application you are logging into belongs to workspace &amp;F4155_WORKSPACE_NAME.. Remember, passwords are case sensitive.</p>'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(707675753928996044)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>'Open Door Credentials'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_help_text=>'Enables anyone to access your application. Enter any identifier that will identify you as the user of the application during this session. This will set the value of the APP_USER variable.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(707686311942002797)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>'Database Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_help_text=>'This authentication scheme requires that a database user (schema) exists in the local database. When using this method, the user name and password of the database account is used to authenticate the user.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(707764939992010930)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>'LDAP Directory'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_help_text=>'Authentication of user/password with an authentication request to an LDAP server.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708018036276066565)
,p_plugin_id=>wwv_flow_imp.id(707764939992010930)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708026427403073465)
,p_plugin_id=>wwv_flow_imp.id(707764939992010930)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708041750260080084)
,p_plugin_id=>wwv_flow_imp.id(707764939992010930)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(708049024764082165)
,p_plugin_attribute_id=>wwv_flow_imp.id(708041750260080084)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(708053230651083932)
,p_plugin_attribute_id=>wwv_flow_imp.id(708041750260080084)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(708057433075084636)
,p_plugin_attribute_id=>wwv_flow_imp.id(708041750260080084)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708170045804107167)
,p_plugin_id=>wwv_flow_imp.id(707764939992010930)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708104537708095412)
,p_plugin_id=>wwv_flow_imp.id(707764939992010930)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708207443165115942)
,p_plugin_id=>wwv_flow_imp.id(707764939992010930)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(708104537708095412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(708300825765129776)
,p_plugin_id=>wwv_flow_imp.id(707764939992010930)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(38288205752186126)
,p_plugin_id=>wwv_flow_imp.id(707764939992010930)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(38288513717188434)
,p_plugin_attribute_id=>wwv_flow_imp.id(38288205752186126)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(38288919604190164)
,p_plugin_attribute_id=>wwv_flow_imp.id(38288205752186126)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(38289324453191614)
,p_plugin_attribute_id=>wwv_flow_imp.id(38288205752186126)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(707826526617016488)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'Oracle Application Server Single Sign-On'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>55530428
,p_subscribe_plugin_settings=>true
,p_help_text=>'Delegates authentication to the Oracle AS Single Sign-On (SSO) Server. To use this authentication scheme, your site must have been registered as a partner application with the SSO server.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(707874032982027788)
,p_plugin_id=>wwv_flow_imp.id(707826526617016488)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Partner Application Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If you authenticate with Oracle Application Server Single Sign-On and your application is a registered partner application with SSO, then enter exactly the same name you used when registering the partner application with SSO.',
'</p>',
'<p>',
'If you are relying on &PRODUCT_NAME. to be the registered partner application, then leave this field blank.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(477693327944088403)
,p_plugin_id=>wwv_flow_imp.id(707826526617016488)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the logout path of the Single Sign-On Server, for example',
'<em>https://login.example.com/sso/logout</em>.',
'On logout of your application, &PRODUCT_NAME. will use this value, concatenate ''?p_done_url='' and the application''s login url, and use the resulting URL to log out of Single Sign-On before redirecting back to your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(707880052029033247)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>'No Authentication'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_help_text=>'Adopts the current database user. This can be used in combination with a mod_plsql DAD configuration that uses basic authentication to set the database session user.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(38519294499392621)
,p_plugin_id=>wwv_flow_imp.id(707880052029033247)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Username'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>'Enter the username for the &PRODUCT_NAME. session. If empty, &PRODUCT_NAME. uses the database session user (typically APEX_PUBLIC_USER).'
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(716993259356536483)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>'Calendar'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:SUPPORTS_EXTERNAL_FILTERING:LAZY_LOADING'
,p_substitute_attributes=>false
,p_version_scn=>72472677
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display date based entries on a variety of calendar views. With the inclusion of an end date, the calendar can display duration based events. Calendars can also update records directly if "Drag and Drop" is enabled.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716993576597543647)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_static_id=>'start_date_column'
,p_prompt=>'Start Date Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_is_translatable=>false
,p_help_text=>'Select the column which holds the start date for events displayed on this calendar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716993872715545529)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_static_id=>'end_date_column'
,p_prompt=>'End Date Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_is_translatable=>false
,p_help_text=>'Select the column which holds the end date for events displayed on this calendar. If this attribute is specified, then the calendar displays duration based events.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716994160638551031)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_static_id=>'display_column'
,p_prompt=>'Display Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_help_text=>'Select the column which holds the text displayed for events on this calendar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716994453521554330)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_static_id=>'primary_key_column'
,p_prompt=>'Primary Key Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the column which holds the primary key value for calendar events. If the table has a multi-part primary key, then select <strong>ROWID</strong>.</p>',
'<p>The value of this column is returned in the <code>APEX$PK_VALUE</code> substitution variable. Utilize this variable in the <em>Drag and Drop Code</em> attribute to identify the record to be updated, following the drag and drop operation on the cal'
||'endar.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716994772918560561)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_static_id=>'view_edit_link'
,p_prompt=>'View / Edit Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Enter a target page to be called when the user clicks an existing entry.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716995064292564584)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'create_link'
,p_prompt=>'Create Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a target page to be called when the user clicks an empty cell, or outside of an existing calendar entry.</p>',
'<p>You need to use the special calendar substitution variables <pre>&APEX$NEW_START_DATE.</pre> and <pre>&APEX$NEW_END_DATE.</pre> to pass the selected dates from the calendar to the target page.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716995378729573099)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_static_id=>'drag_and_drop'
,p_prompt=>'Drag and Drop'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(716994453521554330)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether drag and drop operations are permitted on this calendar.</p>',
'<p><em>Note: If drag and drop is enabled, then any end users who have rights to view this calendar, also have rights to update calendar entries.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716995668377577896)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_static_id=>'drag_and_drop_plsql_code'
,p_prompt=>'Drag and Drop PL/SQL Code'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(716995378729573099)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Example with Start Date only (for non-duration based events)</dt>',
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'<dt>Example with Start and End dates. (for duration based events)</dt>',
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the PL/SQL code to update the underlying tables or updateable views when a calendar entry is updated using drag and drop.</p>',
'<p>If this calendar shows duration-based events (by selecting a column for End Date), then the PL/SQL code also needs to update this value. If the whole event is dragged, then the End Date maintains the current duration. If the end of the event is dr'
||'agged, the duration of the event is updated. In such cases the start date will be unchanged, but the end date is updated to reflect the revised duration.</p>',
'<p>The calendar substitution variables include:</p>',
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
'    <dd>Returns the revised start date. The date format is <code>''YYYYMMDDHH24MISS''</code> even if the <em>Show Time</em> for this calendar is <strong>No</strong>.</dd>',
'  <dt>APEX$NEW_END_DATE</dt>',
'    <dd>Returns the revised end date for duration based events. The date format is <code>''YYYYMMDDHH24MISS''</code> even if the <em>Show Time</em> for this calendar is <strong>No</strong>.</dd>',
'  <dt>APEX$PK_VALUE</dt>',
'    <dd>Returns the value of the column specified in the Primary Key Column.</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716995977422588893)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_static_id=>'additional_calendar_views'
,p_prompt=>'Additional Calendar Views'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(739025333221911743)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select which additional calendar views to display. The month view is always displayed.</p>',
'<p>Note: the Weekly and Daily views are not available if Show Time is specified as <strong>No</strong>.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(484632936569874213)
,p_plugin_attribute_id=>wwv_flow_imp.id(716995977422588893)
,p_display_sequence=>40
,p_display_value=>'List'
,p_return_value=>'list'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(484633358657877168)
,p_plugin_attribute_id=>wwv_flow_imp.id(716995977422588893)
,p_display_sequence=>50
,p_display_value=>'Navigation'
,p_return_value=>'navigation'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716997678919603353)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_static_id=>'calendar_export'
,p_prompt=>'Export'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose which export links are provided at the bottom of the calendar.</p>',
'<p><em>Note: This exports all of the calendar entries currently displayed, not a single calendar entry.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(716999168568608195)
,p_plugin_attribute_id=>wwv_flow_imp.id(716997678919603353)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(716997976116604645)
,p_plugin_attribute_id=>wwv_flow_imp.id(716997678919603353)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(716998373959605713)
,p_plugin_attribute_id=>wwv_flow_imp.id(716997678919603353)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(716999779985618067)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_static_id=>'calendar_views_and_navigation'
,p_prompt=>'Calendar Views and Navigation'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(739025333221911743)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Select which calendar views to display. At least one of <strong>Day</strong>, <strong>Week</strong> or <strong>Month</strong> must be selected. If not, the calendar will automatically display the <strong>month</strong> view.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(772524462334484489)
,p_plugin_attribute_id=>wwv_flow_imp.id(716999779985618067)
,p_display_sequence=>10
,p_display_value=>'Month'
,p_return_value=>'month'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(717000472653621483)
,p_plugin_attribute_id=>wwv_flow_imp.id(716999779985618067)
,p_display_sequence=>20
,p_display_value=>'Week'
,p_return_value=>'week'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(717000871143622145)
,p_plugin_attribute_id=>wwv_flow_imp.id(716999779985618067)
,p_display_sequence=>30
,p_display_value=>'Day'
,p_return_value=>'day'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(696140132483024062)
,p_plugin_attribute_id=>wwv_flow_imp.id(716999779985618067)
,p_display_sequence=>35
,p_display_value=>'List'
,p_return_value=>'list'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(717001267693623757)
,p_plugin_attribute_id=>wwv_flow_imp.id(716999779985618067)
,p_display_sequence=>40
,p_display_value=>'Navigation'
,p_return_value=>'navigation'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3800340614088058)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>13
,p_static_id=>'event_sorting'
,p_prompt=>'Event Sorting'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether the events are sorted automatically or by the provided region source.</p>',
'<p>This setting effects most likely only overlapping multi-day events in month / week view or events displayed in day or list view.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3800813881108509)
,p_plugin_attribute_id=>wwv_flow_imp.id(3800340614088058)
,p_display_sequence=>10
,p_display_value=>'Automatic'
,p_return_value=>'AUTOMATIC'
,p_help_text=>'Automatic sorting, either by event time or by event title. Dependent on the "Show Time" option.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3801222313120458)
,p_plugin_attribute_id=>wwv_flow_imp.id(3800340614088058)
,p_display_sequence=>20
,p_display_value=>'By Region Source'
,p_return_value=>'REGION_SOURCE'
,p_help_text=>'Manual sorting, dependent on the ordering of the provided region source.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(739025333221911743)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_static_id=>'show_time'
,p_prompt=>'Show Time'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether the time portion of the date should be displayed. </p>',
'<p>The Week and Day views will only be displayed when Show Time is set to <strong>Yes</strong>. If the start date or end date columns do not include time components they will be shown as 12:00 am.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(163693512506908039)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_static_id=>'css_class'
,p_prompt=>'CSS Class'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Styling the calendar based on project status</p>',
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the column which holds the CSS Class to style the events displayed on this calendar. <br>',
'There are a number of default classes available:',
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
'See documentation on adding additional CSS classes.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2604471144293543)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_static_id=>'supplemental_information'
,p_prompt=>'Supplemental Information'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter additional HTML which is displayed in the List View and Tooltip. Use &COLUMN. syntax to show column values in HTML. </p>',
'<p>Note: Show Tooltip must be set to <strong>Yes</strong> in order for this supplemental information to be displayed in the Month, Week and Day views.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(491266533374023782)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_static_id=>'show_weekend'
,p_prompt=>'Show Weekend'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Select whether Saturday and Sunday are displayed for this calendar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(518889601605918244)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_static_id=>'time_format'
,p_prompt=>'Time Format'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(739025333221911743)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Select the time format used to display the time portion of an event for this calendar.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(518893959287938933)
,p_plugin_attribute_id=>wwv_flow_imp.id(518889601605918244)
,p_display_sequence=>10
,p_display_value=>'Default'
,p_return_value=>'00'
,p_help_text=>'Utilizes the application timestamp format, entered under Globalization. If this attribute is not populated it will use the database NLS setting.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(518914467554939737)
,p_plugin_attribute_id=>wwv_flow_imp.id(518889601605918244)
,p_display_sequence=>20
,p_display_value=>'12 Hour'
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays time using the 12 hour clock including a.m. (from the Latin <em>ante meridiem</em>, meaning "before midday") and p.m. (<em>post meridiem</em>, "after midday"), such as 8:00 a.m. and 4:00 p.m.</p>',
'<p>The actual display format for a.m./p.m., such as capitalization and periods, is derived from the Timestamp Format.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(518914796377940460)
,p_plugin_attribute_id=>wwv_flow_imp.id(518889601605918244)
,p_display_sequence=>30
,p_display_value=>'24 Hour'
,p_return_value=>'24'
,p_help_text=>'Displays time using the 24 hour clock, such as 08:00 and 16:00.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(623002076135066927)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_static_id=>'show_tooltip'
,p_prompt=>'Show Tooltip'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select whether a tooltip is displayed when users hover over an event in this calendar.</p>',
'<p><em>The drop down dialog will display the event name, supplemental information, and date details.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(673441164964154995)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_static_id=>'first_hour'
,p_prompt=>'First Hour'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(739025333221911743)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Enter an integer between 0 and 23 to specify the first hour displayed on the Week and Day calendars.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1218336983535257968)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_static_id=>'maximum_events_day'
,p_prompt=>'Maximum Events / Day'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum number of events displayed for each day within the Month view. </p>',
'<p>If there are more than the specified number of events on a specific day, that day will include  <strong>More ...</strong>. Clicking on this item will display a pop-up window with all of the events for that specific day.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2080058124058207989)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_static_id=>'multiple_line_event'
,p_prompt=>'Multiple Line Events'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select <strong>Yes</strong> to have events display over multiple lines, based on the length of the Display Column text. </p>',
'<p>Select <strong>No</strong> if you only want each event being displayed on a single line, and truncating text that does not fit in the display. The full text will be displayed in the tooltip.</p>',
'<p>Note: The multiple line events setting is only used within Month view. For Weekly and Daily views the duration of the event determines the height of the event displayed.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(848019138346305412)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
'    pOptions.titleFormat      = "[Conference Schedule]";                                // custom title',
'    pOptions.slotMinTime      = "07:00:00";                                             // hide slots before minTime',
'    pOptions.slotMaxTime      = "18:00:00";                                             // hide slots after maxTime',
'    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // week view column headings',
'    pOptions.slotDuration     = "00:15:00";                                             // custom slot duration',
'    pOptions.weekNumbers      = true;                                                   // show week numbers',
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>'Enter a JavaScript function to override the standard FullCalendar initialization attributes. The function must return an Object containing the calendar initialization attributes as parameters.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(236983483525335070)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(493100634228105571)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_name=>'apexcalendardateselect'
,p_display_name=>'Date selected'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(493100238395105571)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_name=>'apexcalendareventselect'
,p_display_name=>'Event selected'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(493099818743105570)
,p_plugin_id=>wwv_flow_imp.id(716993259356536483)
,p_name=>'apexcalendarviewchange'
,p_display_name=>'View changed'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(723477031014918732)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>'Tabular Form - Multi Row Delete'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72472681
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Process to delete multiple rows from a Tabular Form region.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723477251489924376)
,p_plugin_id=>wwv_flow_imp.id(723477031014918732)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Table Owner'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Select the table owner (schema) name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723477545882927054)
,p_plugin_id=>wwv_flow_imp.id(723477031014918732)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Table Name'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(723477251489924376)
,p_help_text=>'Enter the case-sensitive table or updateable view name. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723477835530931825)
,p_plugin_id=>wwv_flow_imp.id(723477031014918732)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Primary Key Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(723477545882927054)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the column containing the primary key value. For tables with more than two-part primary keys, select <strong>ROWID</strong>.</p>',
'<p>The primary key is used to identify rows to be deleted and must not be editable in the tabular form. For new rows, the primary key value must be empty.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723478159456935961)
,p_plugin_id=>wwv_flow_imp.id(723477031014918732)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Secondary Key Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(723477545882927054)
,p_help_text=>'Select the column containing the second primary key value. This attribute should only be populated if your primary key is composed of two columns.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723478847798956469)
,p_plugin_id=>wwv_flow_imp.id(723477031014918732)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Runtime Where Clause'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limit the departments using:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>'Enter the SQL WHERE clause to append to the generated DELETE statement. Use this attribute to limit the records used within automatically generated SQL calls.'
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(723624323202892766)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>'User Preferences'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472681
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process to set User Preferences for the end user.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723624639568915612)
,p_plugin_id=>wwv_flow_imp.id(723624323202892766)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select a process type to reset or set user preferences.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(723626924903922340)
,p_plugin_attribute_id=>wwv_flow_imp.id(723624639568915612)
,p_display_sequence=>10
,p_display_value=>'Reset Preferences (remove all preferences for current user)'
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(723627321668923828)
,p_plugin_attribute_id=>wwv_flow_imp.id(723624639568915612)
,p_display_sequence=>20
,p_display_value=>'Set to Item Value'
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(723627719296924995)
,p_plugin_attribute_id=>wwv_flow_imp.id(723624639568915612)
,p_display_sequence=>30
,p_display_value=>'Set to Item Value if Not Null'
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723631645557973527)
,p_plugin_id=>wwv_flow_imp.id(723624323202892766)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Preference Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(723624639568915612)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>'Enter a preference name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723631934127978868)
,p_plugin_id=>wwv_flow_imp.id(723624323202892766)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(723624639568915612)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>'Select a page or application item which holds the preference value. You can type in the name or pick from the list of available items.'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(723640922660606468)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>'Automatic Row Processing (DML)'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472681
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Process to insert, update, or delete records into a single database table or updateable view. This process is used to process form items with a source of Type <strong>Database Column</strong>. Attributes entered for this process should correlate with'
||' the attributes entered in the <em>Automatic Row Fetch</em> process.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723641240116613584)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Table Owner'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Select the table owner (schema) name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723641536018615468)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Table Name'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(723641240116613584)
,p_help_text=>'Enter the case-sensitive table or view name. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723641830196618138)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Primary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item that holds the primary key column value. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723642126745619762)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>'Primary Key Column '
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(723641536018615468)
,p_help_text=>'Select the column containing the primary key value. For tables with more than two-part primary keys, select <strong>ROWID</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723642422001622013)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Secondary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(723642713590625893)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Enter the page or application item that holds the secondary key column value. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723642713590625893)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Secondary Key Column'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(723641536018615468)
,p_depending_on_attribute_id=>wwv_flow_imp.id(723642126745619762)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>'Select the column containing the second primary key value. This attribute should only be populated if your primary key is composed of two columns.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723646536850919017)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Row Version Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the column that identifies the version of the row, this column does not need to be present on the page. Leave this attribute blank to use the built-in checksum.</p>',
'<p>Opportunistic locking uses lost update detection to ensure data integrity in applications where data can be accessed concurrently. &PRODUCT_NAME. can use a built in checksum to perform lost update detection and determine the version of the row. Th'
||'e checksum is a hash function of all the column values for the specific table row. It is retrieved when the record is queried from the database in <em>Automatic Row Fetch</em>, and then compared against the hash of the current record in the database '
||'as part of this process. If the two values are the same then the update proceeds, otherwise an error is raised by this process.</p>',
'<p>This attribute enables you to specify a single column which holds the row version, as an alternative to using the built-in checksum processing. This column should be updated whenever a record in the database is updated. Oracle recommends implement'
||'ing a <em>Before Update</en> database trigger on the table to increment or otherwise update the row version column. NUMBER columns are presumed to contain a sequence number for the row. However, DATE and TIMESTAMP columns can also be used. The advant'
||'age of using a single column is that the &PRODUCT_NAME. engine does not need to perform the hash of the complete row, instead it can just compare a single column value.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(723646022259834604)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Runtime Where Clause'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limit the departments:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>'Enter the SQL WHERE clause to append to all generated INSERT, UPDATE, and DELETE statements. Use this attribute to limit the records used within automatically generated SQL calls.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361842218629998562)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Return Key Into Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the page or application item item to hold the primary key column value returned from a SQL INSERT statement. You can type in the name or pick from the list of available items.</p>',
'<p>Specify this column to get back the primary key fields populated by sequences or database triggers. This value is set into session state by the process. </p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361842512807001262)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Return Second Key Into Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(723642713590625893)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Enter the page or application item to hold the second primary key column value returned from a SQL INSERT statement. You can type in the name or pick from the list of available items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(361843216017030111)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Supported Operations'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Check which data manipulation language (DML) operations are supported. This data manipulation process will perform DML when the request value is one of the listed values. When using a button to submit this page, the request value is set by the button'
||'.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362471227178028863)
,p_plugin_attribute_id=>wwv_flow_imp.id(361843216017030111)
,p_display_sequence=>10
,p_display_value=>'Insert'
,p_return_value=>'I'
,p_help_text=>'Triggered by Request Values: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362471623727030373)
,p_plugin_attribute_id=>wwv_flow_imp.id(361843216017030111)
,p_display_sequence=>20
,p_display_value=>'Update'
,p_return_value=>'U'
,p_help_text=>'Triggered by Request Values: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362472022649030909)
,p_plugin_attribute_id=>wwv_flow_imp.id(361843216017030111)
,p_display_sequence=>30
,p_display_value=>'Delete'
,p_return_value=>'D'
,p_help_text=>'Triggered by Request Values: DELETE, REMOVE, DELETE ROW, DROP'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(216670983590615543)
,p_plugin_id=>wwv_flow_imp.id(723640922660606468)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>'Lock Row'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'<p>Select whether each row to be updated or deleted is locked in the underlying table before processing the row.</p>'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(854773928315984269)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>'Set Focus'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_version_scn=>72472683
,p_subscribe_plugin_settings=>true
,p_help_text=>'Sets the focus to the affected elements. This will default to the 1st of the affected elements if there are multiple. This can be especially useful when used in conjunction with the <em>Show</em> and <em>Enable</em> actions to take the user straight '
||'to the appropriate item.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(854776817374066356)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>'Submit Page'
,p_category=>'NAVIGATION'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472683
,p_subscribe_plugin_settings=>true
,p_help_text=>'Submits the page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(854777422315124533)
,p_plugin_id=>wwv_flow_imp.id(854776817374066356)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Request / Button Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Enter the request value used to submit the page. Set this to the button name, if a button triggers the Dynamic Action. This ensures the button''s <em>Execute Validations</em> attribute is respected during page processing.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(477648707512082509)
,p_plugin_id=>wwv_flow_imp.id(854776817374066356)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Show Processing'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specify whether the current page is grayed-out and a ''processing'' style animation is displayed during page submission. This can be useful to prevent end user action during long running operations, such as the end user attempting to re-click on the se'
||'arch button when the report is slow to refresh.'
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(858626633540183539)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>'Number Field'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_version_scn=>72472683
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Displays a number field. This item type automatically validates that the value is a number.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(858627014886206552)
,p_plugin_id=>wwv_flow_imp.id(858626633540183539)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Minimum Value'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'</ul>'))
,p_help_text=>'Enter the minimum value permitted.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(858627524583209309)
,p_plugin_id=>wwv_flow_imp.id(858626633540183539)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Maximum Value'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'</ul>'))
,p_help_text=>'Enter the maximum value permitted.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(858676504215733205)
,p_plugin_id=>wwv_flow_imp.id(858626633540183539)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Number Alignment'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'left'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how to align the number that displays. This setting does not apply when the item is rendered as <em>Read Only</em> or where <strong>HTML Form Element Attributes</strong> are specified.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(858678212526735663)
,p_plugin_attribute_id=>wwv_flow_imp.id(858676504215733205)
,p_display_sequence=>10
,p_display_value=>'Start'
,p_return_value=>'left'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(858678618067737263)
,p_plugin_attribute_id=>wwv_flow_imp.id(858676504215733205)
,p_display_sequence=>20
,p_display_value=>'Center'
,p_return_value=>'center'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(858679023954738917)
,p_plugin_attribute_id=>wwv_flow_imp.id(858676504215733205)
,p_display_sequence=>30
,p_display_value=>'End'
,p_return_value=>'right'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2300365362479724)
,p_plugin_id=>wwv_flow_imp.id(858626633540183539)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Virtual Keyboard'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'decimal'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select which virtual keyboard to display when using the number field on a touchscreen.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2301088504485864)
,p_plugin_attribute_id=>wwv_flow_imp.id(2300365362479724)
,p_display_sequence=>10
,p_display_value=>'Decimal'
,p_return_value=>'decimal'
,p_help_text=>'Numeric only keyboard, with an added decimal key.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2300686541485042)
,p_plugin_attribute_id=>wwv_flow_imp.id(2300365362479724)
,p_display_sequence=>20
,p_display_value=>'Numeric'
,p_return_value=>'numeric'
,p_help_text=>'Numeric only keyboard. This option is useful for monetary values, PIN, ZIP Codes, CC numbers, etc.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1408344259766255)
,p_plugin_attribute_id=>wwv_flow_imp.id(2300365362479724)
,p_display_sequence=>30
,p_display_value=>'Text'
,p_return_value=>'text'
,p_help_text=>'Regular alphanumeric keyboard.'
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(956011735689077213)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>'Send E-Mail'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS:APEX_APPL_TASKDEF_ACTIONS:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_version_scn=>72472687
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process sends an email and optionally one or more attachments from the application.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(956092037052376563)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'From'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>'Enter the email address to display as the sender of the email. This email address must be a valid address. Otherwise, the message will not be sent. Use substitution syntax if you want to use a dynamic value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(956050619869980888)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'To'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>'Enter the email recipients by specifying one or more email addresses. For multiple email addresses, use a comma-separated list. Use substitution syntax if you want to use a dynamic value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(956051928180983251)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Cc'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>'Enter the carbon copy email recipients by specifying one or more email addresses. For multiple email addresses, use a comma-separated list. Use substitution syntax if you want to use a dynamic value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(956052531990984386)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Bcc'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>'Enter the blind carbon copy email recipients by specifying one or more email addresses. For multiple email addresses, use a comma-separated list. Use substitution syntax if you want to use a dynamic value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(956082217032200544)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Reply To'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>'Enter the email address replies should be sent to. If not specified the e-mail address entered in <strong>From</strong> will be used. Use substitution syntax if you want to use a dynamic value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(956053241340987086)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Subject'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1801033763884282)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Enter the subject of the e-mail. Use substitution syntax, such as <code>&amp;P6_PRODUCT_NAME.</code>, if you want to include a dynamic value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(956053823463991423)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>'Body Plain Text'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1801033763884282)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text of the e-mail. The plain text version is used if the recipient&#39;s e-mail client does not support rich text display. Use substitution syntax, such as <code>&amp;P6_PRODUCT_NAME.</code>, if you want to include dynamic content in yo'
||'ur text.</p>',
'<p><em>Note: The SMTP/MIME specification dictates that no single line shall exceed 1000 characters. To comply with this restriction, you must add a carriage return or line feed characters to break your text into chunks of 1000 characters or less. Fai'
||'ling to do so will result in erroneous email messages, including partial messages or messages with extraneous exclamation points.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(956082724997202851)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>'Body HTML'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1801033763884282)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text that yields a multi-part HTML message, including both plain text and HTML content. The settings and capabilities of the recipient&#39;s email client will determine what displays. Although most modern email clients can read an HTML forma'
||'tted email, remember that some users disable this functionality to address security issues. Use substitution syntax, such as <code>&amp;P6_PRODUCT_NAME.</code>, if you want to include dynamic content in the text.</p>',
'<p>When referencing images using the &lt;img /&gt; tag, remember that the images must be accessible to the recipient&#39;s email client in order for them to see the image. For example, suppose you reference an image on your network called hello.gif a'
||'s follows:</p>',
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
'<p>In this example, the image is not attached to the email, but is referenced by the email. For the recipient to see it, they must be able to access the image using a Web browser. If the image is inside a firewall and the recipient is outside of the '
||'firewall, the image will not display. For this reason, avoid using images. If you must include images, be sure to include the ALT attribute to provide a textual description in the event the image is not accessible.</p>',
'<p><em>Note: The SMTP/MIME specification dictates that no single line shall exceed 1000 characters. To comply with this restriction, you must add a carriage return or line feed characters to break your text into chunks of 1000 characters or less. Fai'
||'ling to do so will result in erroneous email messages, including partial messages or messages with extraneous exclamation points.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(956084325437259694)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'Attachment SQL'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The SQL statement must be in the following format:</p>',
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
'<p>The columns mime_type and content_id are optional. If content_id is present then the file will be attached inline and the value of content_id will be used for the attachment''s CID.</p>',
'<p>If the content_id column contains the value ''my_inline_content'' then that image may be embedded within the email using the following HTML:</p>',
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL statement which returns one or more BLOBs that are attached as files to the e-mail.</p>',
'<p>If the content_id column contains a null value then the associated files will be regular attachments. Files such as documents or zip archives are generally attached in this way.</p>',
'<p>If the value of the content_id is non-null then the associated file will be marked as being attached inline. The value of the content_id column will be used as the CID (Content ID) of the attachment. This CID value can be used in the HTML code of '
||'the email in order to embed images directly within the email content. Note that some email clients may not automatically display inline attachments. Also note that email standards dictate various requirements for the format of content identifiers. Or'
||'acle APEX does not enforce compliance with these standards.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(965817719331444057)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>'Send Immediately'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether this email is sent immediately. This will also send all emails currently in the &PRODUCT_NAME. email queue table. By default, &PRODUCT_NAME. stores unsent email messages in a table and periodically delivers them for better system perf'
||'ormance.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1801033763884282)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>'Email Template'
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Choose an email template to use.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1802168961897202)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>'Placeholder Values'
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1801033763884282)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Template placeholder names along with the values, to be substituted.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1802477287905419)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>'Language Override'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1801033763884282)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If a language code is specified, the process will look up the template from an application translation for this language. If no translation exists, the process uses the primary language of the application. Substitution syntax is supported.</p>',
'<p>Language code hierarchy is supported. If a value of "fr-ca" (French - Canada) is specified, but only a translation for "fr" (french) exists, this translation is being used.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2987663396794397)
,p_plugin_id=>wwv_flow_imp.id(956011735689077213)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>95
,p_prompt=>'Escape Body Substitutions'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(956082724997202851)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_deprecated_values=>'RAW'
,p_help_text=>'Whether to escape substitution values in the HTML body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3900437988146868)
,p_plugin_attribute_id=>wwv_flow_imp.id(2987663396794397)
,p_display_sequence=>10
,p_display_value=>'Yes'
,p_return_value=>'HTML'
,p_help_text=>'Use HTML escaping. The !RAW modifier prevents escaping for a substitution.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3900810919147488)
,p_plugin_attribute_id=>wwv_flow_imp.id(2987663396794397)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'RAW'
,p_is_deprecated=>true
,p_help_text=>'Do not escape substitution values.'
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(964809907491253927)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>'File Upload'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#item.FileUpload#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_version_scn=>72472687
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a File Upload item. This item allows users to upload one or multiple files from their local file system or device.'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(3003546775134326)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_title=>'Display'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(3003121315134325)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_title=>'Storage'
,p_display_sequence=>20
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(964835401087640042)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3003121315134325)
,p_help_text=>'Select the database table where the uploaded file is stored.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(964836502257649822)
,p_plugin_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_display_sequence=>10
,p_display_value=>'BLOB column specified in Item Source attribute'
,p_return_value=>'DB_COLUMN'
,p_help_text=>'Stores the uploaded file in the table used by the <strong>Automatic Row Processing (DML)</strong> process and the column specified in the item source attribute. The column has to be of data type BLOB. If the file gets downloaded, the table name of th'
||'e <strong>Automatic Row Fetch</strong> process is used.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(731386319815053643)
,p_plugin_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_display_sequence=>20
,p_display_value=>'Table APEX_APPLICATION_TEMP_FILES'
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Stores the uploaded file(s) in a temporary location that you can access with the view APEX_APPLICATION_TEMP_FILES. &PRODUCT_NAME. will automatically delete the file(s) at the end of the session or at the end of the upload request, depending on wha'
||'t you choose for <strong>Purge File At</strong>.</p>',
'<p>To access a file if <strong>Allow Multiple Files</strong> is set to <strong>No</strong>:</p>',
'<pre>',
'select *',
'  from apex_application_temp_files',
' where name = :<em>page item name</em>;',
'</pre>',
'<p>To access files if <strong>Allow Multiple Files</strong> is set to <strong>Yes</strong>:</p>',
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
'                        p_str => :<em>page item name</em>,',
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
'        -- add code here to store the uploaded file in your own table',
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(964837210962680729)
,p_plugin_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_display_sequence=>30
,p_display_value=>'Table WWV_FLOW_FILES'
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Stores the uploaded file in the &PRODUCT_NAME. table <code>WWV_FLOW_FILES</code>.</p>',
'<p>To access the file use:</p>',
'<pre>',
'select *',
'  from wwv_flow_files',
' where name = :<em>page item name</em>;',
'</pre>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(964818202736309368)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>'MIME Type Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_attribute_group_id=>wwv_flow_imp.id(3003121315134325)
,p_help_text=>'Enter the uppercase page or application item name used to store the mime type of the uploaded file. The mime type is used by the browser to identify which application is used to display the content of the BLOB when the file is downloaded.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(964818707238310655)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>'Filename Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_attribute_group_id=>wwv_flow_imp.id(3003121315134325)
,p_help_text=>'Enter the page or application item used to store the filename of the uploaded file.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(964819215203312912)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>'Character Set Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_attribute_group_id=>wwv_flow_imp.id(3003121315134325)
,p_help_text=>'Enter the uppercase page or application item name used to store the character set of the uploaded file. The character set of the BLOB is not automatically set on upload. End users should set the character set for the document they are uploading.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(964819720744314575)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>'BLOB Last Updated Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_attribute_group_id=>wwv_flow_imp.id(3003121315134325)
,p_help_text=>'Enter the uppercase page or application item name used to store the current timestamp when a file is uploaded. This date value is used for browser caching.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(964842823007778822)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>'Display Download Link'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_attribute_group_id=>wwv_flow_imp.id(3003546775134326)
,p_help_text=>'Specify whether the download link displays when there is a non-empty BLOB associated with this item.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(964821798974336682)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>'Download Link Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(964842823007778822)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_attribute_group_id=>wwv_flow_imp.id(3003546775134326)
,p_help_text=>'Enter the text to displayed as part of the download link. If not specified, the text stored in the Text Message for <code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code>, within Shared Components, displays.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(964820216027322616)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>'Content Disposition'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(964842823007778822)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3003546775134326)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how the browser handles the content when downloading.</p>',
'<p><em>Note: Not all content can be displayed inline. Support for displaying content inline depends on whether the specific mime type is supported by the browser.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(964820818797323426)
,p_plugin_attribute_id=>wwv_flow_imp.id(964820216027322616)
,p_display_sequence=>10
,p_display_value=>'Inline'
,p_return_value=>'inline'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(964821223992324973)
,p_plugin_attribute_id=>wwv_flow_imp.id(964820216027322616)
,p_display_sequence=>20
,p_display_value=>'Attachment'
,p_return_value=>'attachment'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(731387030349079430)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'Purge File at'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3003121315134325)
,p_help_text=>'Define when &PRODUCT_NAME. should remove the temporary file.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(731387341950082182)
,p_plugin_attribute_id=>wwv_flow_imp.id(731387030349079430)
,p_display_sequence=>10
,p_display_value=>'End of Session'
,p_return_value=>'SESSION'
,p_help_text=>'Delete the file at the end of the current &PRODUCT_NAME. session.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(731387731499084204)
,p_plugin_attribute_id=>wwv_flow_imp.id(731387030349079430)
,p_display_sequence=>20
,p_display_value=>'End of Request'
,p_return_value=>'REQUEST'
,p_help_text=>'Delete the file at the end of the current HTTP request.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(454581457667776194)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>'Allow Multiple Files'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(964835401087640042)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_group_id=>wwv_flow_imp.id(3003121315134325)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether multiple files can be uploaded at once.</p>',
'',
'<p>Note - Multiple file names will be stored as a colon delimited list in the page item.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(454582257259837774)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>'File Types'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(3003121315134325)
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt>Indicate that only image files should be accepted</dt>',
'<dd><pre>image/*</pre></dd>',
'<dt>Indicate that only image and video files should be accepted</dt>',
'<dd><pre>image/*,video/*</pre></dd>',
'<dt>Indicate that only PNG image files should be accepted</dt>',
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>'Specify a comma delimited list of file types which might be used by the browser to restrict which files can be uploaded.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(16666690581217000)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>'Display As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3003546775134326)
,p_help_text=>'Select a display style for how the file browse item should be displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(16667070722219531)
,p_plugin_attribute_id=>wwv_flow_imp.id(16666690581217000)
,p_display_sequence=>10
,p_display_value=>'Inline File Browse'
,p_return_value=>'INLINE'
,p_help_text=>'Display the file browse input field similar to other text fields and items on the page.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(16667390751221130)
,p_plugin_attribute_id=>wwv_flow_imp.id(16666690581217000)
,p_display_sequence=>20
,p_display_value=>'Inline Dropzone'
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>'Display the file browse input field as an inline drop zone can features a title and description.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(16779225779481514)
,p_plugin_attribute_id=>wwv_flow_imp.id(16666690581217000)
,p_display_sequence=>30
,p_display_value=>'Block Dropzone'
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>'Display the file browse input field as a wizard-style drop zone can features a title and description, and a button to select files.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22008009319845506)
,p_plugin_attribute_id=>wwv_flow_imp.id(16666690581217000)
,p_display_sequence=>40
,p_display_value=>'Native File Browse'
,p_return_value=>'NATIVE'
,p_help_text=>'Use the browser''s native formatting to display the file browse item.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(16669341688528880)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>'Dropzone Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(16666690581217000)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_attribute_group_id=>wwv_flow_imp.id(3003546775134326)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the title for the Dropzone.',
'If this field is left blank, the Text Messages <code>APEX.ITEM.FILE.DROP_FILE</code> or <code>APEX.ITEM.FILE.DROP_FILES</code> will be used by default.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(16681385163784419)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>'Dropzone Description'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(16666690581217000)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_attribute_group_id=>wwv_flow_imp.id(3003546775134326)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the description text for the Dropzone.</p>',
'<p>If this field is left blank, the following Text Messages will be used by default, depending on the Display As property.</p>',
'<p><strong>Block Drop Zone</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
'<p><strong>Inline Drop Zone</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(16681866876796068)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Maximum File Size'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'KB'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(3003121315134325)
,p_help_text=>'Enter the maximum file size (in KB) that should be accepted for files uploaded via this item.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3007331754155392)
,p_plugin_id=>wwv_flow_imp.id(964809907491253927)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>240
,p_prompt=>'Capture Using'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(3003546775134326)
,p_null_text=>'None'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Setting the default camera lets you default the File Upload item to opening the devices camera when the app is used from a mobile device.</p>',
'<p>It is important to note that if the default camera option is set, on a mobile device the user will not be able to select files but they will be able to take a photo, switch cameras, or use photos already existing on their device.</p>',
'<p>On a desktop the item will always function the same regardless of the value chosen.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3008467610160456)
,p_plugin_attribute_id=>wwv_flow_imp.id(3007331754155392)
,p_display_sequence=>10
,p_display_value=>'Selfie Camera'
,p_return_value=>'USER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3008875298161725)
,p_plugin_attribute_id=>wwv_flow_imp.id(3007331754155392)
,p_display_sequence=>20
,p_display_value=>'Main Camera'
,p_return_value=>'ENVIRONMENT'
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(973073216779459799)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>'List Manager'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_default_escape_mode=>'HTML'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:MULTI_VALUE_ALWAYS'
,p_substitute_attributes=>true
,p_version_scn=>72472688
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays a text item with a popup list of values icon, <em>Add</em> and <em>Remove</em> buttons, and a list of selected values.</p>',
'<p>You can type in the value or pick from the list of available items. You can then utilize the buttons to manage the values selected. The selected values are stored in a single colon-delimited string.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(973075623967480816)
,p_plugin_id=>wwv_flow_imp.id(973073216779459799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Fetch'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how data is displayed when the Popup LOV is opened.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(973076228816482253)
,p_plugin_attribute_id=>wwv_flow_imp.id(973075623967480816)
,p_display_sequence=>10
,p_display_value=>'No Fetch'
,p_return_value=>'NO_FETCH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(973077034010483721)
,p_plugin_attribute_id=>wwv_flow_imp.id(973075623967480816)
,p_display_sequence=>20
,p_display_value=>'Fetch First Rowset'
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(973077408168485730)
,p_plugin_attribute_id=>wwv_flow_imp.id(973075623967480816)
,p_display_sequence=>30
,p_display_value=>'Fetch First Rowset and Filter Current Value'
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(973074833187474061)
,p_plugin_id=>wwv_flow_imp.id(973073216779459799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Preserve Case'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specify whether the value remains as entered, or is converted to uppercase.</p>'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845154323494834504)
,p_plugin_id=>wwv_flow_imp.id(973073216779459799)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>List of values based on SQL query</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>List of values with same display and return value</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Note: When selecting the same column for both the display and return values use a column alias.</p>',
'</dd>',
'<dt>List of values with bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1086048547681945775)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>'Legacy Automatic Row Processing'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472688
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Process to insert, update, or delete records into a single database table or updateable view. This process is used to process form items with a source of Type <strong>Database Column</strong>. Oracle recommends updating this process type to <strong>A'
||'utomatic Row Processing (DML)</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(724250841038369418)
,p_plugin_id=>wwv_flow_imp.id(1086048547681945775)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select which data manipulation language (DML) operations are supported.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362408026159343735)
,p_plugin_attribute_id=>wwv_flow_imp.id(724250841038369418)
,p_display_sequence=>10
,p_display_value=>'Insert'
,p_return_value=>'INSERT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362408425080344291)
,p_plugin_attribute_id=>wwv_flow_imp.id(724250841038369418)
,p_display_sequence=>20
,p_display_value=>'Update'
,p_return_value=>'UPDATE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362408824002344800)
,p_plugin_attribute_id=>wwv_flow_imp.id(724250841038369418)
,p_display_sequence=>30
,p_display_value=>'Delete'
,p_return_value=>'DELETE'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1086048865137952891)
,p_plugin_id=>wwv_flow_imp.id(1086048547681945775)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Table Owner'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Select the table owner (schema) name.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1086049161039954775)
,p_plugin_id=>wwv_flow_imp.id(1086048547681945775)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Table Name'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(1086048865137952891)
,p_help_text=>'Enter the case-sensitive table or view name. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1086049455217957445)
,p_plugin_id=>wwv_flow_imp.id(1086048547681945775)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Primary Key Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Enter the page or application item that holds the primary key column value. You can type in the name or pick from the list.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1086049751766959069)
,p_plugin_id=>wwv_flow_imp.id(1086048547681945775)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>'Primary Key Column '
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_imp.id(1086049161039954775)
,p_help_text=>'Select the column containing the primary key value. If the table has a multi-part primary key, then select <strong>ROWID</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1086053647281173911)
,p_plugin_id=>wwv_flow_imp.id(1086048547681945775)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Runtime Where Clause'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limit the department:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>'Enter the SQL WHERE clause to append to all generated SELECT, UPDATE, and DELETE statements. Use this attribute to limit the records used within automatically generated SQL calls.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1112790930653153311)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>'Cancel Event'
,p_category=>'MISC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>72472692
,p_subscribe_plugin_settings=>true
,p_help_text=>'Cancels the current event.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1166598346362318406)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>'Date Picker (jQuery)'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_version_scn=>72472692
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays a text field with a calendar icon. End users can either enter the date directly into the text item, or click on the calendar icon to select a date, and optionally a time, from the calendar popup.</p>',
'<p>Time is only displayed in the calendar popup if the <em>Format Mask</em> for this item includes time components.</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1166599468441343733)
,p_plugin_id=>wwv_flow_imp.id(1166598346362318406)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Highlighted Date'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a default date value to be highlighted when the calendar pop-up is invoked. If not specified, the calendar highlights the current date and time.</p>',
'<p>The value can be an absolute value in <code>''YYYYMMDDHH24MI''</code> format or a relative value with respect to today''s date, such as <code>+7d</code>, or a dynamic value using substitution syntax, providing the substitution returns the correct dat'
||'e format or relative value.</p>',
'<p>Relative date values include:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - years from today''s date</dd>',
'  <dt>m</dt>',
'    <dd>+ / - months from today''s date</dd>',
'  <dt>w</dt>',
'    <dd>+ / - weeks from today''s date</dd>',
'  <dt>d</dt>',
'    <dd>+ / - days from today''s date</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1166598552726329767)
,p_plugin_id=>wwv_flow_imp.id(1166598346362318406)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Minimum Date'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the minimum date that can be input or selected.</p>',
'<p>The date value can be an absolute value in <code>''YYYY-MM-DDTHH24:MI:SS''</code> or <code>''YYYYMMDDHH24MI''</code> format or a relative value with respect to today''s date, such as <code>+7d</code>, or a dynamic value using substitution syntax, provi'
||'ding the substitution returns the correct date format or relative value.</p>',
'<p>Relative date values include:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - years from today''s date</dd>',
'  <dt>m</dt>',
'    <dd>+ / - months from today''s date</dd>',
'  <dt>w</dt>',
'    <dd>+ / - weeks from today''s date</dd>',
'  <dt>d</dt>',
'    <dd>+ / - days from today''s date</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1166598957228331042)
,p_plugin_id=>wwv_flow_imp.id(1166598346362318406)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Maximum Date'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum date that can be input or selected.</p>',
'<p>The date value can be an absolute value in <code>''YYYY-MM-DDTHH24:MI:SS''</code> or <code>''YYYYMMDDHH24MI''</code> format or a relative value with respect to today''s date, such as <code>+7d</code>, or a dynamic value using substitution syntax, provi'
||'ding the substitution returns the correct date format or relative value.</p>',
'<p>Relative date values include:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - years from today''s date</dd>',
'  <dt>m</dt>',
'    <dd>+ / - months from today''s date</dd>',
'  <dt>w</dt>',
'    <dd>+ / - weeks from today''s date</dd>',
'  <dt>d</dt>',
'    <dd>+ / - days from today''s date</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1166599961992351304)
,p_plugin_id=>wwv_flow_imp.id(1166598346362318406)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Show'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select when the date picker pop-up calendar displays.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(975967945937309446)
,p_plugin_attribute_id=>wwv_flow_imp.id(1166599961992351304)
,p_display_sequence=>10
,p_display_value=>'On focus'
,p_return_value=>'focus'
,p_help_text=>'The calendar pop-up displays as soon as the item receives focus.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(975968322865312246)
,p_plugin_attribute_id=>wwv_flow_imp.id(1166599961992351304)
,p_display_sequence=>20
,p_display_value=>'On icon click'
,p_return_value=>'button'
,p_help_text=>'The calendar pop-up displays when the icon is clicked.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(975968729792314196)
,p_plugin_attribute_id=>wwv_flow_imp.id(1166599961992351304)
,p_display_sequence=>30
,p_display_value=>'Both'
,p_return_value=>'both'
,p_help_text=>'The calendar pop-up displays as soon as the item receives focus and subsequently when the icon is clicked.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(977131519506267935)
,p_plugin_attribute_id=>wwv_flow_imp.id(1166599961992351304)
,p_display_sequence=>40
,p_display_value=>'Inline'
,p_return_value=>'inline'
,p_help_text=>'The calendar always displays inline on the page. No text field is displayed and the current date selection is shown highlighted in the calendar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1166600445500356042)
,p_plugin_id=>wwv_flow_imp.id(1166598346362318406)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Show other Months'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Specify whether the leading dates from the previous month and the trailing dates for the next month are displayed. The leading and trailing dates fully populate the first and last lines of the calendar. For example, if the first day of the week is Su'
||'nday, and the first of the current month displayed falls on a Wednesday, then the Sunday, Monday, and Tuesday show the last three days of the previous month.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1166601947494375554)
,p_plugin_id=>wwv_flow_imp.id(1166598346362318406)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Number of Months'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1166600445500356042)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
'    <dd>Displays three months horizontally.</dd>',
'  <dt>[2,3]</dt>',
'    <dd>Displays six months, two rows by three columns.</dd>',
'  <dt>[4,3]</dt>',
'    <dd>Displays twelve months, four rows by three columns.</dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter how many months to show in the calendar pop-up.</p>',
'<p>You can enter an integer value or a two-dimensional array using <code>[<em>row,column</em>]</code>, to define the number of rows and columns to display</p>',
'<p><em>Note: Months after the <strong>Highlighted Date</strong> are displayed.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1166602447625385046)
,p_plugin_id=>wwv_flow_imp.id(1166598346362318406)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Navigation List for'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select whether select lists are provided within the calendar pop-up for Month and/or Year.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(785072709337552768)
,p_plugin_attribute_id=>wwv_flow_imp.id(1166602447625385046)
,p_display_sequence=>5
,p_display_value=>'None'
,p_return_value=>'NONE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(785071421673546859)
,p_plugin_attribute_id=>wwv_flow_imp.id(1166602447625385046)
,p_display_sequence=>10
,p_display_value=>'Month'
,p_return_value=>'MONTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(785071825829548006)
,p_plugin_attribute_id=>wwv_flow_imp.id(1166602447625385046)
,p_display_sequence=>20
,p_display_value=>'Year'
,p_return_value=>'YEAR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(785072306567551978)
,p_plugin_attribute_id=>wwv_flow_imp.id(1166602447625385046)
,p_display_sequence=>30
,p_display_value=>'Month and Year'
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1166600943554364880)
,p_plugin_id=>wwv_flow_imp.id(1166598346362318406)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Year Range'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1166602447625385046)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
'    <dd>Uses absolute years to restrict permitted years to be between 2000 and 2010, inclusive.</dd>',
'  <dt>-05:+05</dt>',
'    <dd>Uses relative dates to limit permitted years to +/- five years from the current year.</dd>',
'  <dt>+01:+03</dt>',
'    <dd>Uses relative dates to limit permitted years to next year for a further two years.</dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a range of permitted years shown in the <strong>Year</strong> select list within the calendar pop-up.</p>',
'<p>The year value can be an absolute value in <code>''YYYY:YYYY''</code> format or 	relative values, using <code>''-nn:+nn''</code> format, where <code>nn</code> are integer values.'))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1230861140507488144)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>'Text Field'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_version_scn=>72472692
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Displays a text field.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1230861330595494795)
,p_plugin_id=>wwv_flow_imp.id(1230861140507488144)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Submit when Enter pressed'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'Specify whether pressing the <em>Enter</em> key while in this field automatically submits the page.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1230861822761501984)
,p_plugin_id=>wwv_flow_imp.id(1230861140507488144)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Disabled'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether this item is disabled, which prevents end users from changing the value.</p>',
'<p>A disabled text item still displays with the same HTML formatting, unlike an item type of <em>Display Only</em>, which removes the HTML formatting. Disabled text items are part of page source, which enables their session state to be evaluated. Con'
||'versely, display only items are not stored in session state.</p>'))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1230862319775510558)
,p_plugin_id=>wwv_flow_imp.id(1230861140507488144)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Send On Page Submit'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1230861822761501984)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Specify whether the current item value should be sent when the page is submitted.'
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2642009195904118)
,p_plugin_id=>wwv_flow_imp.id(1230861140507488144)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>'Subtype'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the HTML5 text subtype. This enables devices with on-screen keyboards to show an optimized keyboard layout specific to the subtype, for easier data input. The subtype selection is also used to render an appropriate link with the value of the p'
||'age item, if it is rendered read only. This attribute does not change the text item, or data entry, when using a physical keyboard.  ',
'</p>',
'<p><strong><em>Note:</strong> This HTML5 feature only works in modern browsers. Older, non HTML5-compliant, browsers ignore this attribute and render the page item as a normal text field.</em></p>'))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4337919498933328)
,p_plugin_attribute_id=>wwv_flow_imp.id(2642009195904118)
,p_display_sequence=>5
,p_display_value=>'Text'
,p_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2643201361911326)
,p_plugin_attribute_id=>wwv_flow_imp.id(2642009195904118)
,p_display_sequence=>10
,p_display_value=>'E-Mail'
,p_return_value=>'EMAIL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2643606901912900)
,p_plugin_attribute_id=>wwv_flow_imp.id(2642009195904118)
,p_display_sequence=>20
,p_display_value=>'Phone Number'
,p_return_value=>'TEL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(228427524363055714)
,p_plugin_attribute_id=>wwv_flow_imp.id(2642009195904118)
,p_display_sequence=>25
,p_display_value=>'Search'
,p_return_value=>'SEARCH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2644810018913786)
,p_plugin_attribute_id=>wwv_flow_imp.id(2642009195904118)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(362145212820086745)
,p_plugin_id=>wwv_flow_imp.id(1230861140507488144)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>'Trim Spaces'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how the item value is trimmed after submitting the page. This setting trims spaces, tabs, and new lines from the text entered.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362145508722088644)
,p_plugin_attribute_id=>wwv_flow_imp.id(362145212820086745)
,p_display_sequence=>10
,p_display_value=>'Leading'
,p_return_value=>'LEADING'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362145906566089618)
,p_plugin_attribute_id=>wwv_flow_imp.id(362145212820086745)
,p_display_sequence=>20
,p_display_value=>'Trailing'
,p_return_value=>'TRAILING'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362146304625090506)
,p_plugin_attribute_id=>wwv_flow_imp.id(362145212820086745)
,p_display_sequence=>30
,p_display_value=>'Leading and Trailing'
,p_return_value=>'BOTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(362147027041095284)
,p_plugin_attribute_id=>wwv_flow_imp.id(362145212820086745)
,p_display_sequence=>40
,p_display_value=>'None'
,p_return_value=>'NONE'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(580485075516965313)
,p_plugin_id=>wwv_flow_imp.id(1230861140507488144)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>'Text Case'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'No Change'
,p_help_text=>'Select how the item value text case is transformed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(580485397894966793)
,p_plugin_attribute_id=>wwv_flow_imp.id(580485075516965313)
,p_display_sequence=>10
,p_display_value=>'Lower'
,p_return_value=>'LOWER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(580485762023967520)
,p_plugin_attribute_id=>wwv_flow_imp.id(580485075516965313)
,p_display_sequence=>20
,p_display_value=>'Upper'
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1230888011377927220)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT:SESSION_STATE_CLOB'
,p_substitute_attributes=>true
,p_version_scn=>72472692
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Items that are included within the page source but are not rendered. Hidden item values are saved in session state. They are generally used to store values required by page processing or other page items, but should not be displayed to the end user.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1230888530209942193)
,p_plugin_id=>wwv_flow_imp.id(1230888011377927220)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Value Protected'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specifying whether the item is protected, preventing the value from being manipulated when the page is posted.'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/odata
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1367839645514176958)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ODATA'
,p_display_name=>'OData REST Service'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ODATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_version_scn=>55031121
,p_subscribe_plugin_settings=>false
,p_help_text=>'Use OData REST services as REST Data Sources.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1367839859014176959)
,p_plugin_id=>wwv_flow_imp.id(1367839645514176958)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Resource Path'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Resource Paths with Parameters:</p>',
'<ul>',
'<li><code>Categories(:cat_id)/Products</code></li>',
'<li><code>Categories(:cat_id)</code></li>',
'<li><code>GetNearestAirport(lat=:lat,lon=:lon)</code></li>',
'</ul>',
'<p>Resource Path without any Parameter</p>',
'<ul>',
'<li><code>Categories</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'This attribute provides the path to access the resource of the service. It will be ',
'appended to the OData REST endpoint URL provided, which is the value of the <strong>URL Endpoint</strong>',
'attribute. The resource path can include parameters.',
'</p>',
'<dl>',
'<dt>Service Root URL (URL Endpoint)</dt>',
'<dd><code>http://example.com:port/path/Service.svc</code></dd>',
'<dt>Resource Path</dt>',
'<dd><code>Categories(1)/Products</code></dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1367840244401176960)
,p_plugin_id=>wwv_flow_imp.id(1367839645514176958)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Parameter Default Values'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<code>:lat{33}</code>',
'<code>:lon{118}</code>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This Attribute is used to pass the default values for parameters in the <strong>Resource Path</strong>.</p>',
'<p>This attribute is structured as follows:',
'<code>:param_name_1{param_value_1}:param_name_2{param_value_2}</code></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1374758616908534071)
,p_plugin_id=>wwv_flow_imp.id(1367839645514176958)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Supported OData Options'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selected options control how the URL or request bodies are built. The following example shows a URL when the <strong>Ordering</strong> and <strong>Request Specific Columns</strong> options are enabled.</p>',
'<p>',
'<code>http://example.com/service/Products?$orderby=ReleaseDate desc&$select=ID,Rating,ReleaseDate,ProductName,Color&$search=(red and hardware)</code><p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1374760819975536830)
,p_plugin_attribute_id=>wwv_flow_imp.id(1374758616908534071)
,p_display_sequence=>10
,p_display_value=>'Return Sorted Results'
,p_return_value=>'option_orderby'
,p_help_text=>'<p>The <strong>$orderby</strong> option allows clients to request resources in a particular order.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1374761159970538102)
,p_plugin_attribute_id=>wwv_flow_imp.id(1374758616908534071)
,p_display_sequence=>20
,p_display_value=>' Return only Specific Columns'
,p_return_value=>'option_select'
,p_help_text=>'<p>The <strong>$select</strong> option allows clients to request a specific set of columns.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1374762498688539391)
,p_plugin_attribute_id=>wwv_flow_imp.id(1374758616908534071)
,p_display_sequence=>30
,p_display_value=>'Row Search'
,p_return_value=>'option_search'
,p_help_text=>'<p>The <strong>$search</strong> option allows clients to pass a free-text search expression to the OData REST endpoint. The REST Endpoint must support <em>Search Expressions</em> for this feature.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1374765031436550669)
,p_plugin_attribute_id=>wwv_flow_imp.id(1374758616908534071)
,p_display_sequence=>40
,p_display_value=>'Results Pagination'
,p_return_value=>'option_client_driven_paging'
,p_help_text=>'<p>The OData REST API supports <em>Pagination</em> using the <strong>$skip</strong> and <strong>$top</strong> query parameters.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1367842609297176961)
,p_plugin_id=>wwv_flow_imp.id(1367839645514176958)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Case-Insensitive Filtering'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'none'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367843452701176961)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367842609297176961)
,p_display_sequence=>10
,p_display_value=>'Not Supported'
,p_return_value=>'none'
,p_help_text=>'<p>Filtering is case-sensitive.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367844015149176961)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367842609297176961)
,p_display_sequence=>20
,p_display_value=>'Based on Lower Case'
,p_return_value=>'filter_lower'
,p_help_text=>'<p>When enabled, filtering on the OData REST endpoint is executed based on values converted to lower case, using the <strong>tolower</strong> expression.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367843023460176961)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367842609297176961)
,p_display_sequence=>30
,p_display_value=>'Based on Upper Case'
,p_return_value=>'filter_upper'
,p_help_text=>'<p>When enabled, filtering on the OData REST endpoint is executed based on values converted to upper case, using the <strong>toupper</strong> expression.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1367844512308176961)
,p_plugin_id=>wwv_flow_imp.id(1367839645514176958)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Send Query Options'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Whether the OData query options are appended to the endpoint URL or passed as the request body of a HTTP POST request. Appended to the endpoint URL can lead to long URLs, potentially exceeding web server limits.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3380791941168582)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367844512308176961)
,p_display_sequence=>10
,p_display_value=>'Append to URL'
,p_return_value=>'N'
,p_help_text=>'The query to be passed to the OData REST endpoint is appended to the endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3381237401167360)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367844512308176961)
,p_display_sequence=>20
,p_display_value=>'Pass as Request Body'
,p_return_value=>'Y'
,p_help_text=>'The query to be passed to the OData REST endpoint is send as the <em>Request Body</em> of a HTTP <strong>POST</strong> request.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1367844917003176961)
,p_plugin_id=>wwv_flow_imp.id(1367839645514176958)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Return Total Result Count'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'count_none'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367846296826176962)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367844917003176961)
,p_display_sequence=>10
,p_display_value=>'Not Supported'
,p_return_value=>'count_none'
,p_help_text=>'<p>The OData REST endpoint does not support returning a total result count.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367846797853176962)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367844917003176961)
,p_display_sequence=>20
,p_display_value=>'Inline in Response'
,p_return_value=>'count_true_inline'
,p_help_text=>'<p>The <strong>$count=true</strong> query option requests the total count of results for a request being returned <em>inline</em> with the JSON response body containing the results.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367845735002176962)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367844917003176961)
,p_display_sequence=>30
,p_display_value=>'Separate HTTP Request'
,p_return_value=>'count_not_inline'
,p_help_text=>'<p>The total result count is obtained by executing a <em>separate HTTP request</em> with the <strong>/$count</strong> appended to the URL.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367845292667176961)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367844917003176961)
,p_display_sequence=>40
,p_display_value=>'Inline in Response ("allpages")'
,p_return_value=>'count_allpages_inline'
,p_help_text=>'<p>The <strong>$inlinecount=allpages</strong> query option <em>is required for legacy OData REST Endpoints</em>, and it requests the total count of results for a request being returned <em>inline</em> with the JSON response body containing the result'
||'s.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1367847290079176962)
,p_plugin_id=>wwv_flow_imp.id(1367839645514176958)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>40
,p_prompt=>'Supported OData Filters'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify whether these OData filter types are supported by this REST endpoint. If a filter type is not supported, &PRODUCT_NAME. will not attempt to pass that filter to the REST endpoint and rather execute the filter locally.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367847708135176962)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367847290079176962)
,p_display_sequence=>10
,p_display_value=>'Contains'
,p_return_value=>'filter_contains'
,p_help_text=>'<p>The <strong>contains</strong> function checks whether a text is a substring of another string. The filter is case-sensitive by default. For case-insensitive filtering support, see the <strong>Case-insensitive Filtering</strong> attribute.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367848198549176962)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367847290079176962)
,p_display_sequence=>20
,p_display_value=>'In'
,p_return_value=>'filter_in'
,p_help_text=>'<p>The <strong>in</strong> filter type determines whether a value is contained in a list.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367848659617176962)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367847290079176962)
,p_display_sequence=>30
,p_display_value=>'Starts With'
,p_return_value=>'filter_startswith'
,p_help_text=>'<p>The <strong>startswith</strong> filter type determines whether a string begins with the search term.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1367849213076176962)
,p_plugin_attribute_id=>wwv_flow_imp.id(1367847290079176962)
,p_display_sequence=>40
,p_display_value=>'Ends With'
,p_return_value=>'filter_endswith'
,p_help_text=>'<p>The <strong>endswith</strong> filter type determines whether a string ends with the search term.</p>'
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1411721528366264478)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>'Display Image'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_version_scn=>29787326
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays an image stored in a database BLOB columns, or based on an image URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1411722225512282537)
,p_plugin_id=>wwv_flow_imp.id(1411721528366264478)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Based On'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select where to retrieve the image from.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1411722839364286570)
,p_plugin_attribute_id=>wwv_flow_imp.id(1411722225512282537)
,p_display_sequence=>10
,p_display_value=>'Image URL stored in Page Item Value'
,p_return_value=>'URL'
,p_help_text=>'The image URL is read from the value stored in session state for the page item specified.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1411723213999298173)
,p_plugin_attribute_id=>wwv_flow_imp.id(1411722225512282537)
,p_display_sequence=>20
,p_display_value=>'BLOB Column specified in Item Source'
,p_return_value=>'DB_COLUMN'
,p_help_text=>'Reads the image from the BLOB column specified in the <strong>Item Source</strong> attribute.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(967663732298251689)
,p_plugin_attribute_id=>wwv_flow_imp.id(1411722225512282537)
,p_display_sequence=>30
,p_display_value=>'BLOB Column returned by SQL statement'
,p_return_value=>'SQL'
,p_help_text=>'Displays the image based on the BLOB column which is returned by the SQL statement specified.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1411726413054354627)
,p_plugin_id=>wwv_flow_imp.id(1411721528366264478)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Alternative Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1411722225512282537)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>'Enter text which is read by screen readers when an end user navigates to this image.'
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Alternative Text serves as a crucial element to enhance accessibility for users with visual impairments. It provides a textual description of images within the pages, offering insights into their significance in relation to the content.<p>',
'<strong>Best practices:</strong>',
'<ol>',
'<li><strong>Purposeful Description:</strong>',
'<ul>',
'<li>Alt Text should succinctly convey the significance of the image in relation to the surrounding content.</li>',
'<li>Focus on describing the "why" of the image rather than stating what the image is.</li>',
'<li>Keep Alt Text clear, concise, and descriptive.</li></li>',
'</ul>',
'<li><strong>Avoidance of Redundant Phrases:</strong>',
'<ul>',
'<li>Instruction to avoid redundant phrases such as "image of" in Alt Text.</li></li>',
'</ul>',
'</ol>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(483911502060080155)
,p_plugin_id=>wwv_flow_imp.id(1411721528366264478)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Alternative Text Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1411722225512282537)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Enter the uppercase page or application item name which holds the alternative text for this image. This text is read by screen readers when an end user navigates to this item.'
,p_important_for_accessibility=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1411725016255336668)
,p_plugin_id=>wwv_flow_imp.id(1411721528366264478)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Filename Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1411722225512282537)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Enter the uppercase page or application item name that holds the filename column value associated with the BLOB column.'
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1411725531492341063)
,p_plugin_id=>wwv_flow_imp.id(1411721528366264478)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'BLOB Last Updated Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1411722225512282537)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the uppercase page or application item name that holds the date column value when the associated BLOB was last updated.</p>',
'<p>This value is used for browser caching and to identify if the image has been changed since the last request from the browser. If the image is not updated then the image is retrieved from the browser cache, if available.</p>'))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(967666433253270876)
,p_plugin_id=>wwv_flow_imp.id(1411721528366264478)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'SQL Statement'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1411722225512282537)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>'Enter the SQL statement to return the BLOB column containing the image.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(91302656605713331)
,p_plugin_id=>wwv_flow_imp.id(1411721528366264478)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>'MIME Type Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1411722225512282537)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>'Enter the uppercase page or application item name used to store the mime type of the uploaded file. The mime type is used by the browser to identify which application is used to display the content of the BLOB when the file is downloaded.'
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1446346919506821055)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>'Text Field with autocomplete'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#item.Autocomplete#MIN#.js'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_version_scn=>266691236
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a text field that displays a list of possible values, based on the text already entered by the end user, inline with the text item. The list is further refined as the end user types in more text.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1410601903280325)
,p_plugin_id=>wwv_flow_imp.id(1446346919506821055)
,p_title=>'Search'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1446356110531045518)
,p_plugin_id=>wwv_flow_imp.id(1446346919506821055)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Match Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1410601903280325)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how the search against the entered value is performed. When using <em>Fetch On Type</em> this setting can have an impact on query performance.</p>',
'<p><em>Note: Selecting <strong>Contains & Case Sensitive</strong> or <strong>Contains & Ignore Case</strong> prevents the use of column indexes.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1097406465150066557)
,p_plugin_attribute_id=>wwv_flow_imp.id(1446356110531045518)
,p_display_sequence=>10
,p_display_value=>'Contains & Case Sensitive'
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1097406557760066557)
,p_plugin_attribute_id=>wwv_flow_imp.id(1446356110531045518)
,p_display_sequence=>20
,p_display_value=>'Exact & Case Sensitive'
,p_return_value=>'EXACT_CASE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1097406651197066557)
,p_plugin_attribute_id=>wwv_flow_imp.id(1446356110531045518)
,p_display_sequence=>30
,p_display_value=>'Contains & Ignore Case'
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1097406756688066558)
,p_plugin_attribute_id=>wwv_flow_imp.id(1446356110531045518)
,p_display_sequence=>40
,p_display_value=>'Exact & Ignore Case'
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1446360005383072413)
,p_plugin_id=>wwv_flow_imp.id(1446346919506821055)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Fetch On Type'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether matching values are retrieved from the database as the user types on the autocomplete item. Fetch On Type retrieves matching records from the database each time the user types a character. Otherwise, all of the list values are load'
||'ed on page load.</p>',
'<p>Oracle recommends using <em>Fetch On Type</em> when you have a large select list, as loading a large number of records may impact the time to initially load the page.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1446361019928076629)
,p_plugin_id=>wwv_flow_imp.id(1446346919506821055)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Maximum Values in List'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_default_value=>'7'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum number of items to display in the select box.</p> ',
'<p>This value can help avoid performance problems by returning too many rows, and also prevent a very large return set when only a few letters have been entered.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(224532777127157782)
,p_plugin_id=>wwv_flow_imp.id(1446346919506821055)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Minimum Characters'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'1'
,p_unit=>'characters'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(1410601903280325)
,p_help_text=>'<p>Specify the minimum number of characters that must be entered before a search is executed.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(388196560996701804)
,p_plugin_id=>wwv_flow_imp.id(1446346919506821055)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>'Use Cache'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1446360005383072413)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'<p>Specify whether search results are cached in the browser, when <strong>Fetch on Search</strong> is enabled.</p>'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845152901732834477)
,p_plugin_id=>wwv_flow_imp.id(1446346919506821055)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display and store same value in page item</dt>',
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
'<dt>Display employees of a specific department by using a bind variable</dt>',
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/combobox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1449147321873942472)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COMBOBOX'
,p_display_name=>'Combobox'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COMBOBOX'),'')
,p_api_version=>2
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:MULTI_VALUE_OPTIONAL:FILTER:LINK:SESSION_STATE_CLOB'
,p_substitute_attributes=>false
,p_version_scn=>266692086
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays a text item with a list of values icon. When the end user clicks the icon, a popup window appears with a suggestion dropdown of values. It supports filtering and freetext input. If multiple values can be selected they are displayed as chi'
||'ps.</p>',
'<p>Combobox is best suited for small lists where end users should be able to add own text. For selections without freetext input <strong>Select List</strong>, <strong>Select One</strong> and <strong>Select Many</strong> are better suited. For large r'
||'esult sets have a look at <strong>Popup LOV.</strong></p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1501127946486720)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_title=>'Search'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1449156512898166935)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>'Match Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1501127946486720)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how the search against the entered value is performed. When using <em>Fetch On Search</em> this setting can have an impact on query performance.</p>',
'<p><em>Note: Selecting <strong>Contains</strong> prevents the use of column indexes.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1100206867517187974)
,p_plugin_attribute_id=>wwv_flow_imp.id(1449156512898166935)
,p_display_sequence=>10
,p_display_value=>'Contains'
,p_return_value=>'CONTAINS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1100206960127187974)
,p_plugin_attribute_id=>wwv_flow_imp.id(1449156512898166935)
,p_display_sequence=>20
,p_display_value=>'Starts With'
,p_return_value=>'STARTS_WITH'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9512583831944113)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>'Case-Sensitive'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(1501127946486720)
,p_help_text=>'<p>Controls if the search is case-sensitive.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9512801718953236)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>110
,p_prompt=>'Value HTML Expression'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'  &lt;div class="cc-container"&gt;',
'    &lt;span class="cc-item"&gt;Name: &amp;NAME.&lt;/span&gt;',
'    {if ?CAPITAL/}&lt;span class="cc-item"&gt;Capital: &amp;CAPITAL.&lt;/span&gt;{endif/}',
'    {if ?NATIONALITY/}&lt;span class="cc-item"&gt;Nationality: &amp;NATIONALITY.&lt;/span&gt;{endif/}',
'    {if ?POPULATION/}&lt;span class="cc-item"&gt;Population: &amp;POPULATION.&lt;/span&gt;{endif/}',
'  &lt;/div&gt;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define how the options will be rendered in the select box.</p>',
'<p>The attribute supports template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1449160407750193830)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>80
,p_prompt=>'Fetch on Search'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether matching values are retrieved from the database as the user types on the combobox item. <strong>Fetch on Search</strong> retrieves matching records from the database each time the user types a character. Otherwise, all of the list '
||'values are loaded on page load.</p>',
'<p>Oracle recommends using Fetch on Search when you have a large select list, as loading a large number of records may impact the time to initially load the page.</p>',
'<p>If attribute Fetch on Search is set to <strong>false</strong>, consolidation logic will be applied to avoid duplicated values, this is affected by the attribute <strong>Case Sensitive</strong> too. If Fetch on Search is set to <strong>true</strong'
||'>, no consolidation logic will be applied and LOV source cannot have a display column configured.</p>',
'<p>Example of data consolidation when LOV has only one column and attribute <strong>Case Sensitive</strong> is set to false: If the user types "blue", and on the Combobox data-set the option "Blue" exists, the value will be set to "Blue" and not "blu'
||'e". If the value doesn''t exists on the data-set the value would be set to what the user typed.</p>',
'<p>Example of data consolidation when LOV has return and display column configured and attribute <strong>Case Sensitive</strong> is set to false: If the user types "blue", the value would be set to the return value of the option. Following the blue e'
||'xample: If the option on the LOV is <strong>Display: Blue, Return: 15</strong> and the user types "blue", the value would be 15 and the display value would be set to "Blue". If the value doesn''t exists on the data-set, then the <strong>Manual Entries'
||' Item</strong> value would be set to "blue".</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1449161422295198046)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Maximum Values in List'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum number of options to display in the select box. If not specified, up to 250 options are shown.</p>',
'<p>This value can help improve performance, by avoiding returning too many rows, and also prevent a very large return set when only a few letters have been entered.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9511951611920903)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>20
,p_prompt=>'Multi Selection'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Controls if the suggestion dropdown should remain opened after selection. If enabled it will add a checkbox next to each option to indicate the selected status. This option is only applicable for multi-value items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(227333179494279199)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>70
,p_prompt=>'Minimum Characters'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'0'
,p_max_length=>2
,p_unit=>'characters'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(1501127946486720)
,p_help_text=>'Specify the minimum number of characters that must be entered before a search is executed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(390996963363823221)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>90
,p_prompt=>'Use Cache'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1449160407750193830)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Specify whether search results are cached in the browser, when <strong>Fetch on Search</strong> is enabled.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11200843595919285)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>100
,p_prompt=>'Manual Entries Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1449160407750193830)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The specified item holds manual entered entries that are not found on the LOV data-set. Use this configuration if you are planning to further process the Combobox value, and you need to know if a value exists on the data-set or not.</p>',
'<p>It is required when the list of values has display and return columns configured. This would preferably be a hidden item, with the attribute <strong>Value Protected</strong> equal to false, therefore the value can be processed on the server. If <s'
||'trong>Multiple Values</strong> equal true, the Manual Entries Item would have its value separated in the same format as the item itself, using the attribute separator. The item value is updated unidirectionally from the Combobox item to Manual Entrie'
||'s Item, and not the other way around.</p>',
'<p>The use of this property will affect the session state content, where the Combobox item value will only contain the values that are part of the LOV data-set, to access the Manual Entries, developer has to check the session state content for the Ma'
||'nual Entries Item. This also applies to the JavaScript method apex.items.PX_ITEM_NAME.getValue, where it will return only the the values that are part of the LOV data-set too.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(847953304099955894)
,p_plugin_id=>wwv_flow_imp.id(1449147321873942472)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Display and store same value in page item</dt>',
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
'<dt>Display employees of a specific department by using a bind variable</dt>',
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_one
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1450550658162003627)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_ONE'
,p_display_name=>'Select One'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_ONE'),'')
,p_api_version=>2
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK:SESSION_STATE_CLOB'
,p_substitute_attributes=>false
,p_version_scn=>231358557
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>Displays a text item with a list of values icon. When the end user clicks the field, a popup window appears with a list of suggested values. It supports filtering, groups, and template directives</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1495899415428699)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_title=>'Search'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1405477552531977)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_title=>'Messages'
,p_display_sequence=>20
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1450559849186228090)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>'Match Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1495899415428699)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how the search against the entered value is performed. When using <em>Fetch On Search</em> this setting can have an impact on query performance.</p>',
'<p><em>Note: Selecting <strong>Contains</strong> prevents the use of column indexes.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1101610203805249129)
,p_plugin_attribute_id=>wwv_flow_imp.id(1450559849186228090)
,p_display_sequence=>10
,p_display_value=>'Contains'
,p_return_value=>'CONTAINS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1101610296415249129)
,p_plugin_attribute_id=>wwv_flow_imp.id(1450559849186228090)
,p_display_sequence=>20
,p_display_value=>'Starts With'
,p_return_value=>'STARTS_WITH'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(10915920120005268)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>'Case-Sensitive'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(1495899415428699)
,p_help_text=>'<p>Controls if the search is case-sensitive.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(10916138007014391)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>110
,p_prompt=>'Value HTML Expression'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'  &lt;div class="cc-container"&gt;',
'    &lt;span class="cc-item"&gt;Name: &amp;NAME.&lt;/span&gt;',
'    {if ?CAPITAL/}&lt;span class="cc-item"&gt;Capital: &amp;CAPITAL.&lt;/span&gt;{endif/}',
'    {if ?NATIONALITY/}&lt;span class="cc-item"&gt;Nationality: &amp;NATIONALITY.&lt;/span&gt;{endif/}',
'    {if ?POPULATION/}&lt;span class="cc-item"&gt;Population: &amp;POPULATION.&lt;/span&gt;{endif/}',
'  &lt;/div&gt;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define how the options will be rendered in the select box.</p>',
'<p>The attribute supports template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1450563744038254985)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>80
,p_prompt=>'Fetch on Search'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether matching values are retrieved from the database as the user types on the item. <strong>Fetch on Search</strong> retrieves matching records from the database each time the user types a character. Otherwise, all of the list values ar'
||'e loaded on page load.</p>',
'<p>Oracle recommends using Fetch on Search when you have a large select list, as loading a large number of records may impact the time to initially load the page.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1450564758583259201)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Maximum Values in List'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum number of options to display in the select box. If not specified, up to 250 options are shown.</p>',
'<p>This value can help improve performance, by avoiding returning too many rows, and also prevent a very large return set when only a few letters have been entered.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(228736515782340354)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>70
,p_prompt=>'Minimum Characters'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'0'
,p_max_length=>2
,p_unit=>'characters'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(1495899415428699)
,p_help_text=>'Specify the minimum number of characters that must be entered before a search is executed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(392400299651884376)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>90
,p_prompt=>'Use Cache'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1450563744038254985)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Specify whether search results are cached in the browser, when <strong>Fetch on Search</strong> is enabled.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(10914612527948927)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'No Data Found Message'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(1405477552531977)
,p_help_text=>'Enter a text message to display when no rows are found.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(849356640388017049)
,p_plugin_id=>wwv_flow_imp.id(1450550658162003627)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>List of values based on SQL query</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>List of values with same display and return value</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Note: When selecting the same column for both the display and return values use a column alias.</p>',
'</dd>',
'<dt>List of values with bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_many
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1450551142750988111)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_MANY'
,p_display_name=>'Select Many'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_MANY'),'')
,p_api_version=>2
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:MULTI_VALUE_ALWAYS:FILTER:LINK'
,p_substitute_attributes=>false
,p_version_scn=>231358686
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>Displays a LOV-based item that shows suggestions that allow multi-values. When the end user clicks the field, a popup window appears with a list of suggested values. It supports filtering, groups, and template directives</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(1498051233452751)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_title=>'Search'
,p_display_sequence=>10
);
wwv_flow_imp_shared.create_plugin_attr_group(
 p_id=>wwv_flow_imp.id(2140969079244118)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_title=>'Messages'
,p_display_sequence=>20
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(4016372352278092)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Display Values As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'separated'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify how to display values when the item is not focused.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4017109801279484)
,p_plugin_attribute_id=>wwv_flow_imp.id(4016372352278092)
,p_display_sequence=>10
,p_display_value=>'Chips'
,p_return_value=>'chips'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4017589280282271)
,p_plugin_attribute_id=>wwv_flow_imp.id(4016372352278092)
,p_display_sequence=>20
,p_display_value=>'Comma-separated list'
,p_return_value=>'separated'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1450560333775212574)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>'Match Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_attribute_group_id=>wwv_flow_imp.id(1498051233452751)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how the search against the entered value is performed. When using <em>Fetch On Search</em> this setting can have an impact on query performance.</p>',
'<p><em>Note: Selecting <strong>Contains</strong> prevents the use of column indexes.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1101610688394233613)
,p_plugin_attribute_id=>wwv_flow_imp.id(1450560333775212574)
,p_display_sequence=>10
,p_display_value=>'Contains'
,p_return_value=>'CONTAINS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1101610781004233613)
,p_plugin_attribute_id=>wwv_flow_imp.id(1450560333775212574)
,p_display_sequence=>20
,p_display_value=>'Starts With'
,p_return_value=>'STARTS_WITH'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(10916404708989752)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>'Case-Sensitive'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(1498051233452751)
,p_help_text=>'<p>Controls if the search is case-sensitive.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(10916622595998875)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>110
,p_prompt=>'Value HTML Expression'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'  &lt;div class="cc-container"&gt;',
'    &lt;span class="cc-item"&gt;Name: &amp;NAME.&lt;/span&gt;',
'    {if ?CAPITAL/}&lt;span class="cc-item"&gt;Capital: &amp;CAPITAL.&lt;/span&gt;{endif/}',
'    {if ?NATIONALITY/}&lt;span class="cc-item"&gt;Nationality: &amp;NATIONALITY.&lt;/span&gt;{endif/}',
'    {if ?POPULATION/}&lt;span class="cc-item"&gt;Population: &amp;POPULATION.&lt;/span&gt;{endif/}',
'  &lt;/div&gt;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define how the options will be rendered in the select box.</p>',
'<p>The attribute supports template directives.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1450564228627239469)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>80
,p_prompt=>'Fetch on Search'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether matching values are retrieved from the database as the user types on the item. <strong>Fetch on Search</strong> retrieves matching records from the database each time the user types a character. Otherwise, all of the list values ar'
||'e loaded on page load.</p>',
'<p>Oracle recommends using Fetch on Search when you have a large select list, as loading a large number of records may impact the time to initially load the page.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1450565243172243685)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Maximum Values in List'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the maximum number of options to display in the select box. If not specified, up to 250 options are shown.</p>',
'<p>This value can help improve performance, by avoiding returning too many rows, and also prevent a very large return set when only a few letters have been entered.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(228737000371324838)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>70
,p_prompt=>'Minimum Characters'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'0'
,p_max_length=>2
,p_unit=>'characters'
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(1498051233452751)
,p_help_text=>'Specify the minimum number of characters that must be entered before a search is executed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(392400784240868860)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>90
,p_prompt=>'Use Cache'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1450564228627239469)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Specify whether search results are cached in the browser, when <strong>Fetch on Search</strong> is enabled.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(10915097116933411)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'No Data Found Message'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>false
,p_attribute_group_id=>wwv_flow_imp.id(2140969079244118)
,p_help_text=>'Enter a text message to display when no rows are found.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3816750316087801)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>100
,p_prompt=>'Use Defaults'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Whether to use the defaults defined for this component in Shared Components, Component Settings or custom settings.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3817507011119078)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>105
,p_prompt=>'Display Values As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'chips'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(3816750316087801)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>'Specify how to display values when the item is not focused.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3817802844120919)
,p_plugin_attribute_id=>wwv_flow_imp.id(3817507011119078)
,p_display_sequence=>10
,p_display_value=>'Chips'
,p_return_value=>'chips'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3818286911129106)
,p_plugin_attribute_id=>wwv_flow_imp.id(3817507011119078)
,p_display_sequence=>20
,p_display_value=>'Comma-separated list'
,p_return_value=>'separated'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(849357124977001533)
,p_plugin_id=>wwv_flow_imp.id(1450551142750988111)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>List of values based on SQL query</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>List of values with same display and return value</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Note: When selecting the same column for both the display and return values use a column alias.</p>',
'</dd>',
'<dt>List of values with bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1630055805138100682)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>'Rich Text Editor'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_css_file_urls=>'#APEX_FILES#libraries/tinymce/#TINYMCE_VERSION#/skins/ui/oxide/skin#MIN#.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE:SESSION_STATE_CLOB'
,p_substitute_attributes=>true
,p_version_scn=>1171460683
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a rich text editor with comprehensive text formatting options. End users can enhance the content displayed in a similar fashion to using a word processor, such as Microsoft Word.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(635934396859331517)
,p_plugin_id=>wwv_flow_imp.id(1630055805138100682)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Format'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Specify the output format of the content entered in the rich text editor.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(635934864536336814)
,p_plugin_attribute_id=>wwv_flow_imp.id(635934396859331517)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>'Use HTML for the source and output of this rich text editor. HTML is more flexible and offers more formatting options than Markdown, but is less secure and must be trusted or sanitized when displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(635935286305339196)
,p_plugin_attribute_id=>wwv_flow_imp.id(635934396859331517)
,p_display_sequence=>20
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
,p_help_text=>'Use Markdown format for the source and output of this rich text editor. Markdown is more restrictive than HTML in terms of features, but is more secure as it must first pass through a parser before being displayed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1630056002845109474)
,p_plugin_id=>wwv_flow_imp.id(1630055805138100682)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Toolbar'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INTERMEDIATE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(635934396859331517)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>'Select the number of text formatting options available within the editor.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1630056586699114299)
,p_plugin_attribute_id=>wwv_flow_imp.id(1630056002845109474)
,p_display_sequence=>10
,p_display_value=>'Basic'
,p_return_value=>'BASIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1263397500002270668)
,p_plugin_attribute_id=>wwv_flow_imp.id(1630056002845109474)
,p_display_sequence=>20
,p_display_value=>'Intermediate'
,p_return_value=>'INTERMEDIATE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1630056989123115033)
,p_plugin_attribute_id=>wwv_flow_imp.id(1630056002845109474)
,p_display_sequence=>30
,p_display_value=>'Full'
,p_return_value=>'FULL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3002839506280891)
,p_plugin_id=>wwv_flow_imp.id(1630055805138100682)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Toolbar Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OVERFLOW'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1630056002845109474)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INTERMEDIATE,FULL'
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether the toolbar items should only take up one line and overflow into a popup menu if wider than the editor''s width, or whether to split them into multiple lines.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4300979367469673)
,p_plugin_attribute_id=>wwv_flow_imp.id(3002839506280891)
,p_display_sequence=>10
,p_display_value=>'Overflow Menu'
,p_return_value=>'OVERFLOW'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4301796883472484)
,p_plugin_attribute_id=>wwv_flow_imp.id(3002839506280891)
,p_display_sequence=>30
,p_display_value=>'Multiline'
,p_return_value=>'MULTILINE'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1262287152809234036)
,p_plugin_id=>wwv_flow_imp.id(1630055805138100682)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Minimum Height'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>'pixels'
,p_is_translatable=>false
,p_help_text=>'Set the minimum height in pixels of the editable area.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1262288044006238954)
,p_plugin_id=>wwv_flow_imp.id(1630055805138100682)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Maximum Height'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>'pixels'
,p_is_translatable=>false
,p_help_text=>'Set the maximum height in pixels of the editable area. Leaving this attribute empty will let the editor grow infinitely as you type.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(7200628197662075)
,p_plugin_id=>wwv_flow_imp.id(1630055805138100682)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Display Rich Text'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>'<p>Specify whether the value shown in the grid view is rich text, or plain text without any Markdown or HTML notation.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(3010482773505284)
,p_plugin_id=>wwv_flow_imp.id(1630055805138100682)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Allow Custom HTML'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2013272884781036)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CKEDITOR'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>For advanced usage only.</p>',
'<p>As a preferred alternative, embedding snippets of custom HTML can also be done via the "HTML Embed" functionality available in the "Full" Toolbar.</p>',
'<p>Unless necessary, this setting should be left disabled, as it is only meant to provide backwards compatibility with HTML generated by CKEditor4 or HTML hand-crafted by end users.</p>',
'<p>This setting controls whether the "General HTML Support" ("GHS") and "Source Editing" library plugins will be enabled or not. "Source Editing" offers the ability to manually change the underlying HTML, while General HTML Support allows for HTML fe'
||'atures that are not explicitly supported by any other dedicated library plugin. For example, HTML elements like <code>iframe</code> or <code>video</code>, or custom HTML atrributes like <code>id</code>, if added via the "Source Editing" functionality'
||', would normally be stripped away unless this attribute is enabled.</p>',
'<p>Under the hood, the General HTML Support plugins would be configured as follows:',
'<pre><code>htmlSupport: {',
'    allow: [ {',
'        name: /.*/,',
'        attributes: true,',
'        classes: true,',
'        styles: true',
'    } ]',
'}</code></pre></p>',
'<p>For more granular control, it is recommended to leave this setting off, and instead configure it via the Initialization JavaScript Function. For example:',
'<pre><code>function( options ) {',
'',
'    options.editorOptions.extraPlugins.push (',
'        CKEditor5.sourceEditing.SourceEditing,',
'        CKEditor5.htmlSupport.GeneralHtmlSupport,',
'        CKEditor5.htmlSupport.HtmlComment',
'    );',
'',
'    options.editorOptions.toolbar.items.push( "sourceEditing" );',
'',
'    options.editorOptions.htmlSupport = {',
'        allow: [ {',
'            name: /.*/,',
'            attributes: true,',
'            classes: true,',
'            styles: true',
'        } ]',
'    };',
'',
'    return options;',
'}</code></pre></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2013272884781036)
,p_plugin_id=>wwv_flow_imp.id(1630055805138100682)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>1
,p_prompt=>'Library'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TINYMCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Specify which JavaScript library the Rich Text Editor should be based on.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(3206762172378778)
,p_plugin_attribute_id=>wwv_flow_imp.id(2013272884781036)
,p_display_sequence=>10
,p_display_value=>'TinyMCE'
,p_return_value=>'TINYMCE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2013574151783411)
,p_plugin_attribute_id=>wwv_flow_imp.id(2013272884781036)
,p_display_sequence=>20
,p_display_value=>'Oracle Rich Text Library'
,p_return_value=>'CKEDITOR'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(3112575602612766963)
,p_plugin_id=>wwv_flow_imp.id(1630055805138100682)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Example for TinyMCE:</p>',
'<pre>',
'function(options){',
'    // disable the Text Patterns feature',
'    options.editorOptions.text_patterns = false;',
'    // apply a custom toolbar',
'    options.editorOptions.toolbar = "bold italic | bullist numlist | undo redo";',
'    return options;',
'}',
'</pre>',
'<p>Example for Oracle Rich Text Library:</p>',
'<pre>',
'function(options){',
'    // disable the Autoformat feature',
'    options.editorOptions.removePlugins.push( "Autoformat" );',
'    // apply a custom toolbar',
'    options.editorOptions.toolbar = [ "heading", "bulletedList", "numberedList", "fontSize", "undo", "redo" ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>'Enter a JavaScript function to override the standard editor configuration. Specific library options should be applied to <code>options.editorOptions</code>. See the specific library''s API docs for more information.'
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1779772489424311086)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>'Color Picker'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#item.Colorpicker#MIN#.js'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_version_scn=>28367502
,p_subscribe_plugin_settings=>true
,p_help_text=>'Allows users to choose or enter a color. Colors can be selected from a color spectrum.'
,p_version_identifier=>'2.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(550403250259918560)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(551367544301244965)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>'Select the amount of information shown in the color picker.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(550403921767922285)
,p_plugin_attribute_id=>wwv_flow_imp.id(550403250259918560)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'SIMPLE'
,p_help_text=>'Shows just the color spectrum controls and color presets if any are defined.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(550404269414923460)
,p_plugin_attribute_id=>wwv_flow_imp.id(550403250259918560)
,p_display_sequence=>20
,p_display_value=>'Full'
,p_return_value=>'FULL'
,p_help_text=>'Shows additional fields to view or enter colors as Hex, HSL, or RGB values with optional Alpha value depending on Return Value As. Also shows the Initial and Current colors.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(551367544301244965)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Display As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how the color picker is displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551368003116247557)
,p_plugin_attribute_id=>wwv_flow_imp.id(551367544301244965)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>'A color can be entered in the text field or chosen from the popup color picker.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551368367822248327)
,p_plugin_attribute_id=>wwv_flow_imp.id(551367544301244965)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'A color picker is shown inline.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551368820390249888)
,p_plugin_attribute_id=>wwv_flow_imp.id(551367544301244965)
,p_display_sequence=>30
,p_display_value=>'Color-only Popup'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>'A button opens a popup color picker.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551469948272853196)
,p_plugin_attribute_id=>wwv_flow_imp.id(551367544301244965)
,p_display_sequence=>40
,p_display_value=>'Native Color Picker'
,p_return_value=>'NATIVE'
,p_help_text=>'A native browser color input. The UI is dependent on the browser.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(630450561726642679)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Use Defaults'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Whether to use the defaults defined for this component in Shared Components, Component Settings or custom settings.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(550407832783006227)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(630450561726642679)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the amount of information shown in the color picker.</p>',
'<p>Note this does not apply when Display As is Native Color Picker.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(550408418705007375)
,p_plugin_attribute_id=>wwv_flow_imp.id(550407832783006227)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'SIMPLE'
,p_help_text=>'Shows just the color spectrum controls and color presets if any are defined.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(550408900996015864)
,p_plugin_attribute_id=>wwv_flow_imp.id(550407832783006227)
,p_display_sequence=>20
,p_display_value=>'Full'
,p_return_value=>'FULL'
,p_help_text=>'Shows additional fields to view or enter colors as Hex, HSL, or RGB values with optional Alpha value depending on Return Value As. Also shows the Initial and Current colors.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(550764493023397466)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Display As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(630450561726642679)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>'Select how the color picker is displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(550765244915400562)
,p_plugin_attribute_id=>wwv_flow_imp.id(550764493023397466)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>'A color can be entered in the text field or chosen from the popup color picker.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(550764781445398986)
,p_plugin_attribute_id=>wwv_flow_imp.id(550764493023397466)
,p_display_sequence=>20
,p_display_value=>'Inline'
,p_return_value=>'INLINE'
,p_help_text=>'A color picker is shown inline.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(550765575345402504)
,p_plugin_attribute_id=>wwv_flow_imp.id(550764493023397466)
,p_display_sequence=>30
,p_display_value=>'Color-only Popup'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>'A button opens a popup color picker.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551473676631880984)
,p_plugin_attribute_id=>wwv_flow_imp.id(550764493023397466)
,p_display_sequence=>40
,p_display_value=>'Native Color Picker'
,p_return_value=>'NATIVE'
,p_help_text=>'A native browser color input. The UI is dependent on the browser.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(551688608315986495)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Color Preset'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(550764493023397466)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>'Select whether the color picker should show a set of predefined colors and if so are they from the theme or custom.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551689124385987538)
,p_plugin_attribute_id=>wwv_flow_imp.id(551688608315986495)
,p_display_sequence=>10
,p_display_value=>'None'
,p_return_value=>'NONE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551689545726989556)
,p_plugin_attribute_id=>wwv_flow_imp.id(551688608315986495)
,p_display_sequence=>20
,p_display_value=>'Theme Style Colors'
,p_return_value=>'THEME_STYLE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551689930702991102)
,p_plugin_attribute_id=>wwv_flow_imp.id(551688608315986495)
,p_display_sequence=>30
,p_display_value=>'Custom Colors'
,p_return_value=>'CUSTOM'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(551690436138997704)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Colors'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(551688608315986495)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'List of preset colors to be displayed in the color picker''s dialog.',
'Separate colors using a semicolon.'))
,p_important_for_accessibility=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(551690938640005057)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Contrast With'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(550764493023397466)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Allows comparing the color of this item with a the color from another item or a static value and displaying the contrast ratio between them in the color picker UI.  ',
'This can help the user choose colors with enough contrast to be accessible to everyone.'))
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>In the color picker UI, you can compare the color of a selected item with that of another item or a static value. This feature displays the contrast ratio between the two colors, aiding users in choosing colors that ensure accessibility for all in'
||'dividuals.</p>',
'<p>Contrast ratio refers to the difference in luminance or color between two elements in a design, typically the foreground (e.g., text or icons) and the background. A higher contrast ratio enhances readability and visibility, particularly for users '
||'with visual impairments or color vision deficiencies. The World Wide Web Consortium (W3C) recommends a minimum contrast ratio of 4.5:1 for normal text and 3:1 for large text (18pt or 14pt bold). </p>',
'<strong>Best practices</strong>:',
'<ol>',
'<li><strong>Contrast Ratio:</strong> Choose colors with a sufficient contrast ratio to ensure readability and visibility for all users. A higher contrast ratio between text and background colors is especially important for users with low vision or co'
||'lor blindness.</li>',
'<li><strong>Contrast checker:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 4.5:1 for text and interactive elements to ensure readability for indivi'
||'duals with varying levels of vision impairment.</li>',
'</ol>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551691368715005731)
,p_plugin_attribute_id=>wwv_flow_imp.id(551690938640005057)
,p_display_sequence=>10
,p_display_value=>'None'
,p_return_value=>'NONE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551691786900007756)
,p_plugin_attribute_id=>wwv_flow_imp.id(551690938640005057)
,p_display_sequence=>20
,p_display_value=>'Page Item'
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(551692243251008710)
,p_plugin_attribute_id=>wwv_flow_imp.id(551690938640005057)
,p_display_sequence=>30
,p_display_value=>'Static Color'
,p_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(551692721781014969)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Contrast Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(551690938640005057)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>'Item to be used for contrast comparison.'
,p_important_for_accessibility=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(551693186879019659)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Contrast Color'
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(551690938640005057)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>'Color to be used for contrast comparison.'
,p_important_for_accessibility=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(549148889210907047)
,p_plugin_id=>wwv_flow_imp.id(1779772489424311086)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Return Value As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(550764493023397466)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>'Specify the format of the color value returned by this item. Even if the color is entered in a different valid format it will be presented, returned, and sent to the server in this format.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(549149330423908665)
,p_plugin_attribute_id=>wwv_flow_imp.id(549148889210907047)
,p_display_sequence=>10
,p_display_value=>'Hex'
,p_return_value=>'HEX'
,p_help_text=>'Hex color value. No alpha value is allowed. For example #2244ee'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(549149780463910228)
,p_plugin_attribute_id=>wwv_flow_imp.id(549148889210907047)
,p_display_sequence=>20
,p_display_value=>'rgb'
,p_return_value=>'RGB'
,p_help_text=>'Red, Green, Blue in rgb function notation. Example rgb(34,68,238)'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(549320695805038594)
,p_plugin_attribute_id=>wwv_flow_imp.id(549148889210907047)
,p_display_sequence=>30
,p_display_value=>'rgb/rgba'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Red, Green, Blue, with optional Alpha (transparency) in rgb/rgba function notation.',
'If the color has no alpha (alpha equals 1), an rgb format is used.',
'If the color has an alpha, an rgba format is used.',
'Example rgba(34,68,238,0.5)'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(549150182877911677)
,p_plugin_attribute_id=>wwv_flow_imp.id(549148889210907047)
,p_display_sequence=>40
,p_display_value=>'hsl'
,p_return_value=>'HSL'
,p_help_text=>'Hue, Saturation, Lightness in hsl function notation. Example hsl(230,86,53)'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(549321101724039553)
,p_plugin_attribute_id=>wwv_flow_imp.id(549148889210907047)
,p_display_sequence=>50
,p_display_value=>'hsl/hsla'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hue, Saturation, Lightness with optional alpha (transparency) in hsl/hsla function notation. ',
'If the color has no alpha (alpha equals 1), an hsl format is used.',
'If the color has an alpha, an hsla format is used.',
'Example hsla(230,86,53,0.5)'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(549321450357041193)
,p_plugin_attribute_id=>wwv_flow_imp.id(549148889210907047)
,p_display_sequence=>60
,p_display_value=>'Any CSS Value'
,p_return_value=>'CSS'
,p_help_text=>'Any valid CSS color format including color names or a CSS variable.'
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1800066898109169760)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>'Popup LOV'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE:MULTI_VALUE_OPTIONAL'
,p_substitute_attributes=>true
,p_version_scn=>72472700
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays a text item with a popup list of values icon. When the end user clicks the icon, a popup window appears with a search field, and a list of supported values.</p>',
'<p>Popup LOV is best suited for large lists since end users can enter search criteria to reduce the available values displayed. For relatively small lists <em>Select List</em> is often better suited.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1800068983311222289)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Display As'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how the popup list of values is displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1800069590238224258)
,p_plugin_attribute_id=>wwv_flow_imp.id(1800068983311222289)
,p_display_sequence=>10
,p_display_value=>'Modal Dialog'
,p_return_value=>'DIALOG'
,p_help_text=>'The list of values will be shown in a modal dialog.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1800069993701225262)
,p_plugin_attribute_id=>wwv_flow_imp.id(1800068983311222289)
,p_display_sequence=>20
,p_display_value=>'Inline Popup'
,p_return_value=>'POPUP'
,p_help_text=>'The list of values will be shown in an inline popup under the field.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1800067187898204706)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Initial Fetch'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select how data is initially fetched for the list of values. This applies only the first time the popup is opened after the page loads or the item is refreshed such as due to a cascade. See also attribute Minimum Characters.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1800067791014205587)
,p_plugin_attribute_id=>wwv_flow_imp.id(1800067187898204706)
,p_display_sequence=>10
,p_display_value=>'On User Request'
,p_return_value=>'NO_FETCH'
,p_help_text=>'Initially no list of values is fetched until the user searches with or without a search term.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1800068204174209405)
,p_plugin_attribute_id=>wwv_flow_imp.id(1800067187898204706)
,p_display_sequence=>20
,p_display_value=>'Automatic'
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>'Initially fetch list of values without a search term.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1800068585605213520)
,p_plugin_attribute_id=>wwv_flow_imp.id(1800067187898204706)
,p_display_sequence=>30
,p_display_value=>'Automatic with Current Value'
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>'Initially fetch list of values with current value as the search term.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9037093113159140)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Manual Entry'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Select if manual entry is allowed or not. If Yes the user can select existing values from the popup list of values or enter a value manually. This is like a Combobox. If No the user can only select values from the popup list of values. This is like a'
||' Select List. When manual entry is allowed, it is the return value of the corresponding List of Values that must be entered.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9037383318177266)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Search as You Type'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'When Yes the list of values is filtered as you type in the search field. When No the list of values is not filtered until the user presses Enter or the Search icon button.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9037699825192444)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Minimum Characters'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(9037383318177266)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>'Specify the minimum number of characters required in the search term before the list of values will be fetched. This can be useful to reduce the amount of searching done when the LOV query is expensive. All of the display values in the list should be'
||' longer than this minimum otherwise they cannot be found.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9037973825195793)
,p_plugin_attribute_id=>wwv_flow_imp.id(9037699825192444)
,p_display_sequence=>10
,p_display_value=>'No minimum (0)'
,p_return_value=>'0'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9038300277196807)
,p_plugin_attribute_id=>wwv_flow_imp.id(9037699825192444)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9038738010197706)
,p_plugin_attribute_id=>wwv_flow_imp.id(9037699825192444)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9039143176198691)
,p_plugin_attribute_id=>wwv_flow_imp.id(9037699825192444)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9039528380199625)
,p_plugin_attribute_id=>wwv_flow_imp.id(9037699825192444)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(9039968403200723)
,p_plugin_attribute_id=>wwv_flow_imp.id(9037699825192444)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9040583894241082)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>'The popup dialog title. If blank the default title will be used.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9040894549248059)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Popup Width'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>'The width of the popup. If blank a default is used.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9041180669256760)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Popup Height'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>'The height of the popup. If blank a default is used.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9041484550137059)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional Outputs'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Return additional List of Values (LOV) columns to other page items, and Interactive Grid columns. Define a mapping of LOV column name, to page item name or Interactive Grid column Static ID.</p>',
'<p>Note: This only applies when the LOV definition includes additional columns. This option is only applicable for single-value items.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(9034124600967605)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a JavaScript function that takes an options object for the Popup LOV item, modifies the object, and returns it. This allows advanced customization of the Popup LOV item dialog and its contents during initialization.</p>',
'',
'<p>These options are passed to the <code>popup</code> widget or jQuery UI <code>dialog</code> widget:<br>',
'draggable, resizable, width, height, minWidth, minHeight, maxWidth, and maxHeight<br>',
'See the JQuery UI dialog widget documentation for details.</p>',
'',
'<p>When the results are displayed in a simple list the <code>defaultIconListOptions</code> option is an object that is passed to the <code>tableModelView</code> widget. See the APEX tableModelView widget documentation for the available options.</p>',
'',
'<p>When the results are displayed in a grid the <code>defaultGridOptions</code> option is an object that is passed to the <code>grid</code> widget.',
'See the APEX grid widget documentation for the available options.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845153088232834479)
,p_plugin_id=>wwv_flow_imp.id(1800066898109169760)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>List of values based on SQL query</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>List of values with same display and return value</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Note: When selecting the same column for both the display and return values use a column alias.</p>',
'</dd>',
'<dt>List of values with bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1811565602388283608)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>'Execute Server-side Code'
,p_category=>'EXECUTE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_version_scn=>72472700
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Executes code on the server.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1811566513386305684)
,p_plugin_id=>wwv_flow_imp.id(1811565602388283608)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'PL/SQL Code'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2700405449462251)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Increases the salary by 3% for those employees which are qualified for a salary raise:</dt>',
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
'<p>In this example, you need to enter <code>P2_DEPTNO</code> in <strong>Items to Submit</strong>.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify an execution only PL/SQL anonymous block, that is executed on the server.</p>',
'<p>You can reference other page or application items from within your application using bind syntax (for example <code>:P1_MY_ITEM</code>). Any items referenced also need to be included in <strong>Page Items to Submit</strong>.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2700703882467720)
,p_plugin_id=>wwv_flow_imp.id(1811565602388283608)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>'JavaScript Code'
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2700405449462251)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Increases the salary by 3% for those employees which are qualified for a salary raise:</dt>',
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
'  // placeholder for some complicated logic to calculate if employee needs a raise',
'  return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
'<p>In this example, you need to enter <code>P2_DEPTNO</code> in <strong>Items to Submit</strong>.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify an execution only JavaScript block, that is executed on the server.</p>',
'<p>You can reference other page or application items from within your application using bind syntax (for example <code>apex.env.P1_MY_ITEM</code>). Any items referenced also need to be included in <strong>Page Items to Submit</strong>.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1811567115248315739)
,p_plugin_id=>wwv_flow_imp.id(1811565602388283608)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Items to Submit'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the uppercase page items submitted to the server, and therefore, available for use within your <strong>PL/SQL Code</strong>.</p>',
'<p>You can type in the item name or pick from the list of available items.',
'If you pick from the list and there is already text entered then a comma is placed at the end of the existing text, followed by the item name returned from the list.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(888122401495541038)
,p_plugin_id=>wwv_flow_imp.id(1811565602388283608)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Items to Return'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''New Value'');',
'</pre>',
'</p>',
'<p>In this example, enter <code>P1_MY_ITEM</code> in this attribute in order for ''New Value'' to be displayed in that item on your page.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the uppercase page items set when the call to the server returns, based on their current value in session state. If your <strong>PL/SQL Code</strong> sets one or more page item values in session state you need to define those items in this a'
||'ttribute.</p>',
'<p>You can type in the item name or pick from the list of available items.',
'If you pick from the list and there is already text entered then a comma is placed at the end of the existing text, followed by the item name returned from the list.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1002790918416823799)
,p_plugin_id=>wwv_flow_imp.id(1811565602388283608)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Suppress Change Event'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(888122401495541038)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>'Specify whether the change event is suppressed on the items specified in <strong>Page Items to Return</strong>. This prevents subsequent <em>Change</em> based Dynamic Actions from firing, for these items.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2700405449462251)
,p_plugin_id=>wwv_flow_imp.id(1811565602388283608)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>'Language'
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2248579157998483215)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>'Display Only'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK:SESSION_STATE_CLOB'
,p_substitute_attributes=>true
,p_version_scn=>72472700
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Displays a non-enterable text item.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2248592969903496143)
,p_plugin_id=>wwv_flow_imp.id(2248579157998483215)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>'Send On Page Submit'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'Specify whether the current item value should be sent when the page is submitted.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1803821466219365649)
,p_plugin_id=>wwv_flow_imp.id(2248579157998483215)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Based On'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(4800927632436292)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>'Select how to determine the value displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1803822070028366811)
,p_plugin_attribute_id=>wwv_flow_imp.id(1803821466219365649)
,p_display_sequence=>10
,p_display_value=>'Item Value'
,p_return_value=>'VALUE'
,p_help_text=>'The current value of the item displays.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1803822445572369209)
,p_plugin_attribute_id=>wwv_flow_imp.id(1803821466219365649)
,p_display_sequence=>20
,p_display_value=>'Display Value of List of Values'
,p_return_value=>'LOV'
,p_help_text=>'The current value of the page item gets mapped to a different display value using a List of Values.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1803822855268372026)
,p_plugin_attribute_id=>wwv_flow_imp.id(1803821466219365649)
,p_display_sequence=>30
,p_display_value=>'Output of PL/SQL Code'
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>'The specified PL/SQL code emits the output displayed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1803823354360381170)
,p_plugin_id=>wwv_flow_imp.id(2248579157998483215)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'PL/SQL Code'
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1803821466219365649)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the PL/SQL code using <code>sys.htp.p</code> or <code>sys.htp.prn</code> to emit HTML code.</p>',
'<p>Oracle recommends using <code>sys.htf.escape_sc</code> to escape data retrieved from the database to ensure that HTML tags are escaped.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1363556632373484636)
,p_plugin_id=>wwv_flow_imp.id(2248579157998483215)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Show Line Breaks'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1803821466219365649)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether line breaks are preserved in the output.</p>',
'<p>Because the display is rendered as HTML, when set to <strong>Yes</strong> line breaks in the display value are converted to HTML line breaks, so they display correctly.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(4800927632436292)
,p_plugin_id=>wwv_flow_imp.id(2248579157998483215)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>'Format'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4801218870437281)
,p_plugin_attribute_id=>wwv_flow_imp.id(4800927632436292)
,p_display_sequence=>10
,p_display_value=>'Plain Text'
,p_return_value=>'PLAIN'
,p_help_text=>'The value will be escaped.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4801656011439608)
,p_plugin_attribute_id=>wwv_flow_imp.id(4800927632436292)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>'The value will first be sanitized on the client, and then rendered as safe HTML.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(140872665655302890)
,p_plugin_attribute_id=>wwv_flow_imp.id(4800927632436292)
,p_display_sequence=>25
,p_display_value=>'HTML (Unsafe)'
,p_return_value=>'HTML_UNSAFE'
,p_is_deprecated=>true
,p_help_text=>'The value will be rendered as is. The developer must ensure the value is safe. If the value comes from an untrusted source, such as a user-populated Rich Text Editor, the regular HTML option is preferred.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(4802071527441522)
,p_plugin_attribute_id=>wwv_flow_imp.id(4800927632436292)
,p_display_sequence=>30
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
,p_help_text=>'The value will be converted from Markdown into safe HTML.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845153181852834480)
,p_plugin_id=>wwv_flow_imp.id(2248579157998483215)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Example 1: List of values based on SQL query.</strong>',
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'<p>',
'<strong>Example 2: Static list examples</strong>',
'<ul>',
'<li>STATIC:Yes;Y,No;N (show Yes / No, instead of Y and N)</li>',
'</ul>',
'</p>',
'',
'<p>',
'<strong>Example 3: List of values with additional restriction using bind variable</strong>',
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2547808060578229016)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>'Star Rating'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_version_scn=>29808778
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Modern Star Rating Item</strong></p>',
'<p>This item displays a numeric value as a number of stars or other icons. The end user can change the value by selecting the desired number of stars. The value can be adjusted by clicking the number of stars with the mouse or by using the keyboard.<'
||'/p>',
'<p>The icon to be displayed, the background and foreground colors can be adjusted either in the component settings or in the individual item settings. To use individual items and colors, set the attribute <strong>Use Component Defaults</strong> to <s'
||'trong>No</strong>.</p>',
'<p>As icons, you may use any icon from the Icon Font available in your application. For Universal Theme applications, use an icon from the <em>Font APEX</em> library.</p>'))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(475527326399196418)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Default Icon'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>'Choose the default icon to use.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2721912433448449647)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Active Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Choose the default color for active stars.'
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing star rating accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li>Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individuals with varying levels of vision impairment.'
||'</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2721912884614449648)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Inactive Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Choose the default color for inactive stars.'
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing star rating accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li>Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individuals with varying levels of vision impairment.'
||'</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(475538451111203492)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Tooltip'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>'Rating: #VALUE# stars.'
,p_help_text=>'Specify the template for the tooltip. The #VALUE# substitution is being replaced by the current rating value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(470180844645338807)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Number of Stars'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Total number of stars to be displayed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470251151324440675)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470263362673575666)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470263792668576010)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470264197754576285)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470264650749576748)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470264961143577132)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470265413888577465)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470265803806577966)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470266183252578379)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470266568693578886)
,p_plugin_attribute_id=>wwv_flow_imp.id(470180844645338807)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(470195603586349451)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Use Defaults'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Whether to use the defaults defined for this component in Shared Components, Component Settings or custom settings.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(470360305601388583)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Icon'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(470195603586349451)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>'Specify the icon to use.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2721914847860449650)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Active Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(470195603586349451)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Choose the default color for active stars.'
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing star rating accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li>Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individuals with varying levels of vision impairment.'
||'</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2721915319189449650)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Inactive Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(470195603586349451)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Choose the default color for inactive stars.'
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing star rating accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li>Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individuals with varying levels of vision impairment.'
||'</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2721915642741449650)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Tooltip'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(470195603586349451)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'Rating: #VALUE# stars.'
,p_help_text=>'Specify the template for the tooltip. The #VALUE# substitution is being replaced by the current rating value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(576030049193688277)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Show Clear Button'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(470195603586349451)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Choose whether to show clear button or not.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(470218232268377857)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Show Value'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(470195603586349451)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'choose whether to display value next to the stars.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(470221148895382244)
,p_plugin_id=>wwv_flow_imp.id(2547808060578229016)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Read Only Display'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(470195603586349451)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>'Choose what to display When the item is readonly.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470238266735410069)
,p_plugin_attribute_id=>wwv_flow_imp.id(470221148895382244)
,p_display_sequence=>20
,p_display_value=>'Stars'
,p_return_value=>'STARS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470238737727410979)
,p_plugin_attribute_id=>wwv_flow_imp.id(470221148895382244)
,p_display_sequence=>30
,p_display_value=>'Value'
,p_return_value=>'VALUE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470239127391413405)
,p_plugin_attribute_id=>wwv_flow_imp.id(470221148895382244)
,p_display_sequence=>40
,p_display_value=>'Stars and Value'
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(470239521066415362)
,p_plugin_attribute_id=>wwv_flow_imp.id(470221148895382244)
,p_display_sequence=>50
,p_display_value=>'Single Star and Value'
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2693981597889753854)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>'Checkbox Group'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL:MULTI_VALUE_ALWAYS'
,p_substitute_attributes=>true
,p_version_scn=>72472700
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Displays multiple values as check boxes, enabling the end user to select multiple values. A list of values is required for items displayed as check boxes. The values corresponding to the checked boxes are stored in a single colon-delimited string.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(911353315791136342)
,p_plugin_id=>wwv_flow_imp.id(2693981597889753854)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Number of Columns'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>'Enter the number of layout columns used to display the check boxes. For example, a value of 2 would display two columns of check boxes. By default, all values display in one column.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845156526173834547)
,p_plugin_id=>wwv_flow_imp.id(2693981597889753854)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>List of values based on SQL query</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>List of values with same display and return value</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Note: When selecting the same column for both the display and return values use a column alias.</p>',
'</dd>',
'<dt>List of values with bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2698572619073428716)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>'Select List'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL:MULTI_VALUE_OPTIONAL'
,p_substitute_attributes=>true
,p_version_scn=>203971317
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays an item with a built-in list of values selector. When the end user clicks the item, the list of supported values displays directly inline with the current item.</p>',
'<p>Select List is best suited for relatively small, discrete lists. End-Users can very quickly select a value from the list without needing to change focus to a popup dialog. For large lists <em>Popup LOV</em> is often better suited.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2698572905698434305)
,p_plugin_id=>wwv_flow_imp.id(2698572619073428716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Page Action on Selection'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select what action is taken when a list value is selected.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2264411080592689929)
,p_plugin_attribute_id=>wwv_flow_imp.id(2698572905698434305)
,p_display_sequence=>1
,p_display_value=>'None'
,p_return_value=>'NONE'
,p_help_text=>'No immediate action is taken when the value is changed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2698575413579455462)
,p_plugin_attribute_id=>wwv_flow_imp.id(2698572905698434305)
,p_display_sequence=>5
,p_display_value=>'Submit Page'
,p_return_value=>'SUBMIT'
,p_help_text=>'The page is submitted with the page REQUEST set to the page item name.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2698574606653453436)
,p_plugin_attribute_id=>wwv_flow_imp.id(2698572905698434305)
,p_display_sequence=>7
,p_display_value=>'Redirect and Set Value'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>'The browser is redirected to the current page and session state for the current item is set to the selected value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2698574220720448121)
,p_plugin_attribute_id=>wwv_flow_imp.id(2698572905698434305)
,p_display_sequence=>9
,p_display_value=>'Redirect to Page'
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>'The browser is redirected to the page contained in the selected value. The return values in the list must include valid page numbers or page aliases.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2698573815526446624)
,p_plugin_attribute_id=>wwv_flow_imp.id(2698572905698434305)
,p_display_sequence=>10
,p_display_value=>'Redirect to URL'
,p_return_value=>'REDIRECT_URL'
,p_help_text=>'The browser is redirected to the URL contained in the selected value. The return values in the list must include valid URLs.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(459061412834919653)
,p_plugin_id=>wwv_flow_imp.id(2698572619073428716)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Execute Validations'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2698572905698434305)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>'Specify whether validations are performed when the page is submitted, based on the page action setting of <strong>Submit Page</strong>.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845156662497834548)
,p_plugin_id=>wwv_flow_imp.id(2698572619073428716)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>List of values based on SQL query</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>List of values with same display and return value</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Note: When selecting the same column for both the display and return values use a column alias.</p>',
'</dd>',
'<dt>List of values with bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3482208123256545756)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>'Column Toggle Report'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ORDER_BY:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_version_scn=>29825526
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display a report where end users can select the columns to display at runtime. End users can then change the columns based on the width and orientation of the screen they are using to display the report.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1823587226519967208)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'type'
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select the basis for this report column.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1823587544288968547)
,p_plugin_attribute_id=>wwv_flow_imp.id(1823587226519967208)
,p_display_sequence=>10
,p_display_value=>'Plain Text'
,p_return_value=>'PLAIN'
,p_help_text=>'Displays the column value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1823587907770969285)
,p_plugin_attribute_id=>wwv_flow_imp.id(1823587226519967208)
,p_display_sequence=>20
,p_display_value=>'Link'
,p_return_value=>'LINK'
,p_help_text=>'Displays the column as a link.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1305234852618727263)
,p_plugin_attribute_id=>wwv_flow_imp.id(1823587226519967208)
,p_display_sequence=>30
,p_display_value=>'Percent Graph'
,p_return_value=>'PCT_GRAPH'
,p_help_text=>'Displays the column as a percentage graph. The value retrieved must be between 0 and 100.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1823588275617978359)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'target'
,p_prompt=>'Target'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1823587226519967208)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Enter a target page to be called when the user clicks an existing entry.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1238927721819003883)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'link_text'
,p_prompt=>'Link Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1823587226519967208)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Enter the HTML text to be shown as a link. Use an image tag to display images, or pick from the list of default images.'
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Accessible link text is essential for users of assistive technologies, such as screen readers, to navigate and understand content effectively.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Descriptive Text:</strong> Use descriptive and meaningful text that clearly indicates the purpose or destination of the link. Avoid generic terms like "click here" or "read more."</li>',
'<li><strong>Conciseness:</strong> Keep link text concise while ensuring it conveys the necessary information. Aim for a balance between brevity and descriptiveness.</li>',
'</ol>',
'<strong>Example Link Text:</strong>',
'<ul>',
'<li><strong>Generic:</strong> "Click here for more information"</li>',
'<li><strong>Descriptive:</strong> "Read the latest blog post"</li>',
'<li><strong>Contextual:</strong> "Learn about accessibility best practices"</li>',
'</ul>',
'<p>By following these best practices for link text, you can create a more inclusive and accessible browsing experience for all users, including those with disabilities.<p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1238931409403155860)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'link_attributes'
,p_prompt=>'Link Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1823587226519967208)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Specify additional column link attributes to be included in the <code>&lt;a href=...&gt;</code> tag, including link target, classes or styles.'
,p_important_for_accessibility=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1305278757261772485)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'background_color'
,p_prompt=>'Background Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1823587226519967208)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include - ',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the background of this graph.',
'The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names.</p>',
'<p>Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, green and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing graph accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individu'
||'als with varying levels of vision impairment.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1305279121857779186)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'foreground_color'
,p_prompt=>'Foreground Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1823587226519967208)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include - ',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the foreground of this graph.',
'The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names.</p>',
'<p>Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, green and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing graph accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individu'
||'als with varying levels of vision impairment.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1305282212210798696)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_static_id=>'bar_width'
,p_prompt=>'Bar Width'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'pixels'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1823587226519967208)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>'Enter the width in pixels for this bar chart.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(149106414354906696)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'value_identifies_row'
,p_prompt=>'Value Identifies Row'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'This is used for accessibility to identify the column that best represents the content of the row.'
,p_important_for_accessibility=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2695400128710862038)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_static_id=>'priority'
,p_prompt=>'Priority'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The report works by hiding and showing columns based on two inputs: available screen width or by the user checking and unchecking which columns to display in a column picker menu. Select a priority value for each columns you want to display respon'
||'sively. Any column given a priority will be available in the column picker menu.<p>',
'',
'<p>To make a column persistent, so it is never hidden, select <strong>Always Displayed</strong>, which also removes the column from the column picker menu.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(686758760912714500)
,p_plugin_attribute_id=>wwv_flow_imp.id(2695400128710862038)
,p_display_sequence=>5
,p_display_value=>'Always Displayed'
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1245557520909123628)
,p_plugin_attribute_id=>wwv_flow_imp.id(2695400128710862038)
,p_display_sequence=>10
,p_display_value=>'1 - Hide Last'
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1245557959195124246)
,p_plugin_attribute_id=>wwv_flow_imp.id(2695400128710862038)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1245558584414124867)
,p_plugin_attribute_id=>wwv_flow_imp.id(2695400128710862038)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1245558946802125444)
,p_plugin_attribute_id=>wwv_flow_imp.id(2695400128710862038)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1245559350856125993)
,p_plugin_attribute_id=>wwv_flow_imp.id(2695400128710862038)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1245559812372127827)
,p_plugin_attribute_id=>wwv_flow_imp.id(2695400128710862038)
,p_display_sequence=>60
,p_display_value=>'6 - Hide First'
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1823549938363826650)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'layout_options'
,p_prompt=>'Layout Options'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Check additional report layout options.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1238928674387055064)
,p_plugin_attribute_id=>wwv_flow_imp.id(1823549938363826650)
,p_display_sequence=>10
,p_display_value=>'Stripes'
,p_return_value=>'STRIPE'
,p_help_text=>'Add alternating row stripes on each row.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1238929097998055827)
,p_plugin_attribute_id=>wwv_flow_imp.id(1823549938363826650)
,p_display_sequence=>20
,p_display_value=>'Stroke'
,p_return_value=>'STROKE'
,p_help_text=>'Add horizontal lines between each row.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1238929416131062515)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'css_classes'
,p_prompt=>'CSS Classes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Enter additional space delimited CSS classes to be included in the component.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1238929773245063952)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'custom_attributes'
,p_prompt=>'Custom Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'<p>Enter additional attributes to be included in the table HTML tag. The class HTML attribute is generated and therefore should not be supplied, use the dedicated <em>CSS Classes</em> attribute instead.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(106020849730927710)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'button_text'
,p_prompt=>'Column Button Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>'This is the label to use for the button that opens the column selection popup. If no text is given a default label is used.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(107062574864851281)
,p_plugin_id=>wwv_flow_imp.id(3482208123256545756)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3601651046632666378)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>'Shuttle'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:MULTI_VALUE_ALWAYS'
,p_substitute_attributes=>true
,p_version_scn=>72472704
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays as a multiple select list that includes two boxes containing lists. The left list displays the source list of values that have not been selected and the right list shows the currently selected values. End users can select one or more valu'
||'es in a list then use the shuttle controls to move the selected values or all values.</p>',
'<p>The current values are stored in a single colon-delimited string.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1815740271128931626)
,p_plugin_id=>wwv_flow_imp.id(3601651046632666378)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Show Controls'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select what data movement controls displays in the middle of the shuttle.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1815740874245932549)
,p_plugin_attribute_id=>wwv_flow_imp.id(1815740271128931626)
,p_display_sequence=>10
,p_display_value=>'All'
,p_return_value=>'ALL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1815741286365936063)
,p_plugin_attribute_id=>wwv_flow_imp.id(1815740271128931626)
,p_display_sequence=>20
,p_display_value=>'Moving Only'
,p_return_value=>'MOVE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1815741691214937407)
,p_plugin_attribute_id=>wwv_flow_imp.id(1815740271128931626)
,p_display_sequence=>30
,p_display_value=>'Ordering Only'
,p_return_value=>'ORDER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1815746874076970329)
,p_plugin_attribute_id=>wwv_flow_imp.id(1815740271128931626)
,p_display_sequence=>40
,p_display_value=>'None'
,p_return_value=>'NONE'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845156821574834552)
,p_plugin_id=>wwv_flow_imp.id(3601651046632666378)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>List of values based on SQL query</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>List of values with same display and return value</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Note: When selecting the same column for both the display and return values use a column alias.</p>',
'</dd>',
'<dt>List of values with bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(1815705269182590478)
,p_plugin_id=>wwv_flow_imp.id(3601651046632666378)
,p_name=>'shuttlechangeorder'
,p_display_name=>'Change Order'
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3605341835055239817)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>'Radio Group'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_version_scn=>72472704
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays multiple values as radio group options, enabling the end user to select a single value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1822713552956622305)
,p_plugin_id=>wwv_flow_imp.id(3605341835055239817)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Number of Columns'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>'Enter the number of radio group columns to display. For example, a value of <code>2</code> would display two columns, so if there were five values then it would display over three rows.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1823061668632450689)
,p_plugin_id=>wwv_flow_imp.id(3605341835055239817)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Page Action on Selection'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select what action is taken when a radio group value is selected.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1823062574865452418)
,p_plugin_attribute_id=>wwv_flow_imp.id(1823061668632450689)
,p_display_sequence=>10
,p_display_value=>'None'
,p_return_value=>'NONE'
,p_help_text=>'No immediate action is taken when the value is changed.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1823062977982453399)
,p_plugin_attribute_id=>wwv_flow_imp.id(1823061668632450689)
,p_display_sequence=>20
,p_display_value=>'Submit Page'
,p_return_value=>'SUBMIT'
,p_help_text=>'The page is submitted with the page REQUEST set to the page item name.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1823063380406454049)
,p_plugin_attribute_id=>wwv_flow_imp.id(1823061668632450689)
,p_display_sequence=>30
,p_display_value=>'Redirect and Set Value'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>'The browser redirects to the current page and session state for the current item is set to the selected value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(459060107939889859)
,p_plugin_id=>wwv_flow_imp.id(3605341835055239817)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Execute Validations'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1823061668632450689)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>'Specify whether validations are performed when the page is submitted, due to page action setting <strong>Submit Page</strong>.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(728745079326901742)
,p_plugin_id=>wwv_flow_imp.id(3605341835055239817)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Hide Radio Buttons'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_help_text=>'Specify whether to display just the label and hide the radio control.'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845156982734834553)
,p_plugin_id=>wwv_flow_imp.id(3605341835055239817)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>List of values based on SQL query</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
'<dt>List of values with same display and return value</dt>',
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
'<p>Note: When selecting the same column for both the display and return values use a column alias.</p>',
'</dd>',
'<dt>List of values with bind variable</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
'<p>Note: Set <em>Cascading LOV Parent Item(s)</em> attribute to <code>P3_DEPTNO</code> if <code>P3_DEPTNO</code> is a modifiable page item on the same page.</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(4136056421507264989)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>'Reflow Report'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_default_escape_mode=>'HTML'
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ORDER_BY:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_version_scn=>29825799
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display a responsive report which transforms from columns to rows to display reports on smaller browser (screen) sizes.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2477435524770686441)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'type'
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select the basis for this report column.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2477435842539687780)
,p_plugin_attribute_id=>wwv_flow_imp.id(2477435524770686441)
,p_display_sequence=>10
,p_display_value=>'Plain Text'
,p_return_value=>'PLAIN'
,p_help_text=>'Displays the column value.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2477436206021688518)
,p_plugin_attribute_id=>wwv_flow_imp.id(2477435524770686441)
,p_display_sequence=>20
,p_display_value=>'Link'
,p_return_value=>'LINK'
,p_help_text=>'Displays the column as a link.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1959083150869446496)
,p_plugin_attribute_id=>wwv_flow_imp.id(2477435524770686441)
,p_display_sequence=>30
,p_display_value=>'Percent Graph'
,p_return_value=>'PCT_GRAPH'
,p_help_text=>'Displays the column as a percentage graph. The value retrieved must be between 0 and 100.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2477436573868697592)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'target'
,p_prompt=>'Target'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2477435524770686441)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'<p>Enter a target page to be called when the user clicks an existing entry.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1892776020069723116)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'link_text'
,p_prompt=>'Link Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(2477435524770686441)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Enter the HTML text to be shown as a link. Use an image tag to display images, or pick from the list of default images.'
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Accessible link text is essential for users of assistive technologies, such as screen readers, to navigate and understand content effectively.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Descriptive Text:</strong> Use descriptive and meaningful text that clearly indicates the purpose or destination of the link. Avoid generic terms like "click here" or "read more."</li>',
'<li><strong>Conciseness:</strong> Keep link text concise while ensuring it conveys the necessary information. Aim for a balance between brevity and descriptiveness.</li>',
'</ol>',
'<strong>Example Link Text:</strong>',
'<ul>',
'<li><strong>Generic:</strong> "Click here for more information"</li>',
'<li><strong>Descriptive:</strong> "Read the latest blog post"</li>',
'<li><strong>Contextual:</strong> "Learn about accessibility best practices"</li>',
'</ul>',
'<p>By following these best practices for link text, you can create a more inclusive and accessible browsing experience for all users, including those with disabilities.<p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1892779707653875093)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'link_attributes'
,p_prompt=>'Link Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2477435524770686441)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>'Specify additional column link attributes to be included in the <code>&lt;a href=...&gt;</code> tag, including link target, classes or styles.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1959127055512491718)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'background_color'
,p_prompt=>'Background Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2477435524770686441)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include - ',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the background of this graph.',
'The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names.</p>',
'<p>Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, green and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing graph accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individu'
||'als with varying levels of vision impairment.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1959127420108498419)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'foreground_color'
,p_prompt=>'Foreground Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2477435524770686441)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Examples of major HTML color codes include - ',
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the foreground of this graph.',
'The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names.</p>',
'<p>Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, green and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing graph accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individu'
||'als with varying levels of vision impairment.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1959130510461517929)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_static_id=>'bar_width'
,p_prompt=>'Bar Width'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'pixels'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2477435524770686441)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>'Enter the width in pixels for this bar chart.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(149105606951887044)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'value_identifies_row'
,p_prompt=>'Value Identifies Row'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'This is used for accessibility to identify the column that best represents the content of the row.'
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>It''s crucial to define row headers for tabular report data, such as in Classic or Interactive Reports, to enhance usability for users of assistive technologies like screen readers.</p>',
'<strong>Best Practices:</strong>',
'<ol>',
'<li><strong>Impact on Usability for Screen Reader Users:</strong>',
'<ul>',
'<li>When a screen reader user navigates through different rows of the report, the column or columns designated as identifying the row will be announced as the row header upon moving to the new row.</li>',
'<li>Failure to define a row header column makes it significantly more challenging for screen reader users to orient themselves while navigating the report.</li>',
'</ul>',
'</li>',
'<li><strong>Enhancing Orientation and Navigation:</strong>',
'<ul>',
'<li>Defining this attribute improves the navigation experience for screen reader users by providing clear orientation points within the tabular data.</li>',
'<li>This ensures smoother navigation and comprehension of the report''s content for users relying on assistive technologies.</li>',
'</ul>',
'</li>',
'<li><strong>Recommendations:</strong>',
'<ul>',
'<li>Define, one or more columns that identify the row, that will function as the row header for users of Assistive Technology.</li>',
'<li>This will be announced every time a user moves between rows, so the entire row header should not be too long to become overly verbose.</li>',
'</ul>',
'</li>',
'</ol>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2477398236614545883)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'layout_options'
,p_prompt=>'Layout Options'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Check additional report layout options.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1892776972637774297)
,p_plugin_attribute_id=>wwv_flow_imp.id(2477398236614545883)
,p_display_sequence=>10
,p_display_value=>'Stripes'
,p_return_value=>'STRIPE'
,p_help_text=>'Add alternating row stripes on each row.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1892777396248775060)
,p_plugin_attribute_id=>wwv_flow_imp.id(2477398236614545883)
,p_display_sequence=>20
,p_display_value=>'Stroke'
,p_return_value=>'STROKE'
,p_help_text=>'Add horizontal lines between each row.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1892777714381781748)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'css_classes'
,p_prompt=>'CSS Classes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Enter additional space delimited CSS classes to be included in the component.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1892778071495783185)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'custom_attributes'
,p_prompt=>'Custom Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'<p>Enter additional attributes to be included in the table HTML tag. The class HTML attribute is generated and therefore should not be supplied, use the dedicated <em>CSS Classes</em> attribute instead.</p>'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(107061404414844166)
,p_plugin_id=>wwv_flow_imp.id(4136056421507264989)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(6012795064666735813)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>'Percent Graph'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_version_scn=>29818384
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays the value as a percentage graph. The value retrieved must be between 0 and 100.'
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1760373882350100186)
,p_plugin_id=>wwv_flow_imp.id(6012795064666735813)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Show Value'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Specify whether the percent value is visible.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1765925486701799362)
,p_plugin_id=>wwv_flow_imp.id(6012795064666735813)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Background Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the background of this graph.',
'The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names.</p>',
'<p>Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, green and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing graph accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individu'
||'als with varying levels of vision impairment.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1765925773847803225)
,p_plugin_id=>wwv_flow_imp.id(6012795064666735813)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Foreground Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the foreground of this graph.',
'The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names.</p>',
'<p>Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, green and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enhancing graph accessibility through mindful color selection and compliance with WCAG standards is crucial for ensuring inclusivity in data visualization.</p>',
'<strong>Best Practices:</strong>',
'<ul>',
'<li><strong>Check Color Contrast Ratio:</strong> Utilize contrast checking tools to evaluate the color contrast ratio between foreground and background colors. Aim for a ratio of at least 3:1 against adjacent colors to ensure readability for individu'
||'als with varying levels of vision impairment.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1760374133781106494)
,p_plugin_id=>wwv_flow_imp.id(6012795064666735813)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Text Color'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1760373882350100186)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the color used for the text of this graph.',
'The color is specified using hexadecimal (hex) notation, RGB color codes, or HTML color names.</p>',
'<p>Hex notation is defined as #xxyyzz (a # followed by 3 double digit hex numbers), where xx, yy, and zz represent the two character hex values for red, green and blue respectively.',
'RGB codes are defined as RGB(xxx,xxx,xxx), where xxx is a number between 0 and 255 each representing the single 8-bit byte value for red, green, and blue respectively.</p>',
'<p>Search the internet for ''HTML Color Codes'' to find the equivalent hex code or RGB code for the color you wish to utilize.</p>'))
,p_important_for_accessibility=>true
,p_accessibility_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When it comes to accessibility, text colors should adhere to certain guidelines to ensure readability and inclusivity for all users, including those with visual impairments. Here are some best practices for choosing text colors:</p>',
'<strong>Best Practises:</strong>',
'<ol>',
'<li><strong>High Contrast:</strong> Text should have sufficient contrast against the background to ensure readability. The Web Content Accessibility Guidelines (WCAG) recommend a minimum contrast ratio of 4.5:1 for normal text and 3:1 for large text '
||'(defined as text that is at least 18pt or 14pt bold).</li>',
'<li><strong>Avoid Pure Black and Pure White:</strong> While black text on a white background may seem like the default choice, pure black (#000000) and pure white (#FFFFFF) can create harsh contrasts that may strain the eyes. Slightly off-black and o'
||'ff-white shades are often easier on the eyes.</li>',
'<li><strong>Use of Red and Green:</strong> Red and green are particularly problematic for individuals with certain types of color blindness. If these colors are used to convey information, ensure that there are alternative ways to differentiate them '
||'(e.g., using patterns or labels).</li>',
'<li><strong>Consistency:</strong> Maintain consistency in text colors throughout your website or application to provide a cohesive experience for users. Inconsistencies in color usage can be confusing and detract from accessibility.</li>',
'<li><strong>Testing:</strong> Use accessibility testing tools to evaluate the contrast ratio of text colors against their background. These tools can help identify areas where contrast needs to be adjusted to meet accessibility standards.</li>',
'</ol>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1765926334751816120)
,p_plugin_id=>wwv_flow_imp.id(6012795064666735813)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Bar Width'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>'pixels'
,p_is_translatable=>false
,p_help_text=>'Enter the width in pixels for this bar chart.'
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A0D0A202A2050657263656E742047726170682041504558204974656D20706C7567696E0D0A202A2F0D0A2F2A676C6F62616C2077696E646F772C617065782A2F0D0A282066756E6374696F6E28207574696C2C206C6F63616C652C206974656D2C20';
wwv_flow_imp.g_varchar2_table(2) := '242029207B0D0A202020202275736520737472696374223B0D0A0D0A202020202F2A2A0D0A20202020202A2040706172616D206974656D49640D0A20202020202A2040706172616D206F7074696F6E730D0A20202020202A2F0D0A2020202077696E646F';
wwv_flow_imp.g_varchar2_table(3) := '772E70637447726170684974656D496E6974203D2066756E6374696F6E28206974656D49642C206F7074696F6E732029207B0D0A2020202020202020766172206974656D24203D20242820222322202B206974656D496420293B0D0A0D0A202020202020';
wwv_flow_imp.g_varchar2_table(4) := '202066756E6374696F6E206E6F726D616C697A65282076616C75652029207B0D0A2020202020202020202020202F2F2076616C7565206973206120737472696E6720776869636820697320666F726D61746564207769746820746865204E4C5320646563';
wwv_flow_imp.g_varchar2_table(5) := '696D616C20736570617261746F72206F66207468652064617461626173652073657373696F6E2E0D0A2020202020202020202020202F2F207061727365466C6F617420616C776179732065787065637473206120646F742C207468617427732077687920';
wwv_flow_imp.g_varchar2_table(6) := '7765206861766520746F207265706C6163652069740D0A20202020202020202020202076616C7565203D204D6174682E726F756E6428207061727365466C6F6174282076616C75652E7265706C61636528206C6F63616C652E676574446563696D616C53';
wwv_flow_imp.g_varchar2_table(7) := '6570617261746F7228292C20222E22202929293B0D0A0D0A202020202020202020202020696620282069734E614E282076616C756520292029207B0D0A2020202020202020202020202020202076616C7565203D206E756C6C3B0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(8) := '202020207D20656C736520696620282076616C7565203C20302029207B0D0A2020202020202020202020202020202076616C7565203D20303B0D0A2020202020202020202020207D20656C736520696620282076616C7565203E203130302029207B0D0A';
wwv_flow_imp.g_varchar2_table(9) := '2020202020202020202020202020202076616C7565203D203130303B0D0A2020202020202020202020207D0D0A20202020202020202020202072657475726E2076616C75653B0D0A20202020202020207D0D0A0D0A202020202020202066756E6374696F';
wwv_flow_imp.g_varchar2_table(10) := '6E2072656E646572282076616C75652029207B0D0A202020202020202020202020766172206F7574203D207574696C2E68746D6C4275696C64657228293B0D0A0D0A20202020202020202020202076616C7565203D206E6F726D616C697A65282076616C';
wwv_flow_imp.g_varchar2_table(11) := '756520293B0D0A2020202020202020202020200D0A202020202020202020202020696620282076616C756520213D3D206E756C6C2029207B0D0A202020202020202020202020202020206F75742E6D61726B75702820223C64697620636C6173733D2761';
wwv_flow_imp.g_varchar2_table(12) := '2D5265706F72742D70657263656E744368617274272220293B0D0A2020202020202020202020202020202069662028206F7074696F6E732E6261636B67726F756E64436F6C6F72207C7C206F7074696F6E732E77696474682029207B0D0A202020202020';
wwv_flow_imp.g_varchar2_table(13) := '20202020202020202020202020206F75742E6F7074696F6E616C41747472280D0A202020202020202020202020202020202020202020202020227374796C65222C0D0A20202020202020202020202020202020202020202020202028206F7074696F6E73';
wwv_flow_imp.g_varchar2_table(14) := '2E6261636B67726F756E64436F6C6F72203F20226261636B67726F756E642D636F6C6F723A22202B206F7074696F6E732E6261636B67726F756E64436F6C6F72202B20223B22203A2022222029202B0D0A20202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(15) := '202020202028206F7074696F6E732E7769647468203F202277696474683A22202B206F7074696F6E732E7769647468202B2022707822203A20222220290D0A2020202020202020202020202020202020202020293B0D0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(16) := '2020207D0D0A202020202020202020202020202020206F75742E6D61726B75702820223E3C64697620636C6173733D27612D5265706F72742D70657263656E7443686172742D66696C6C272220290D0A2020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(17) := '2E6F7074696F6E616C41747472280D0A202020202020202020202020202020202020202020202020227374796C65222C0D0A2020202020202020202020202020202020202020202020202277696474683A22202B2076616C7565202B2022253B22202B0D';
wwv_flow_imp.g_varchar2_table(18) := '0A20202020202020202020202020202020202020202020202028206F7074696F6E732E666F726567726F756E64436F6C6F72203F20226261636B67726F756E642D636F6C6F723A22202B206F7074696F6E732E666F726567726F756E64436F6C6F72203A';
wwv_flow_imp.g_varchar2_table(19) := '20222220290D0A2020202020202020202020202020202020202020290D0A20202020202020202020202020202020202020202E6D61726B75702820223E3C2F6469763E2220290D0A20202020202020202020202020202020202020202E6D61726B757028';
wwv_flow_imp.g_varchar2_table(20) := '20223C7370616E20636C6173733D27752D56697375616C6C7948696464656E273E2220290D0A20202020202020202020202020202020202020202E636F6E74656E74282076616C7565202B2022252220290D0A2020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(21) := '2020202E6D61726B75702820223C2F7370616E3E3C2F6469763E2220293B0D0A2020202020202020202020207D0D0A20202020202020202020202072657475726E206F75742E746F537472696E6728293B0D0A20202020202020207D0D0A0D0A20202020';
wwv_flow_imp.g_varchar2_table(22) := '202020206F7074696F6E73203D20242E657874656E6428207B7D2C207B7D2C206F7074696F6E7320293B0D0A20202020202020200D0A20202020202020206974656D242E68746D6C282072656E64657228206974656D242E68746D6C28292029293B0D0A';
wwv_flow_imp.g_varchar2_table(23) := '20202020202020200D0A20202020202020206974656D2E63726561746528206974656D49642C207B0D0A202020202020202020202020646973706C617956616C7565466F723A2072656E6465720D0A20202020202020207D293B0D0A202020207D3B0D0A';
wwv_flow_imp.g_varchar2_table(24) := '0D0A7D292820617065782E7574696C2C20617065782E6C6F63616C652C20617065782E6974656D2C20617065782E6A517565727920293B';
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(1765927697818739994)
,p_plugin_id=>wwv_flow_imp.id(6012795064666735813)
,p_file_name=>'widget.pctGraph.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(8511644498934019458)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>'Markdown Editor'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE:SESSION_STATE_CLOB'
,p_substitute_attributes=>true
,p_version_scn=>72472750
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays a text area supporting markdown input, with text formatting options, support for including images, and a preview option to view the formatted text.  The Markdown Editor allows you to write using easy-to-read, easy-to-write plain text, then c'
||'onvert it to structurally valid HTML using the various options provided, and supported syntax.'
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(34405931740234149)
,p_plugin_id=>wwv_flow_imp.id(8511644498934019458)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Toolbar'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Provides several options to configure the toolbar for the markdown editor'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(34408106298242570)
,p_plugin_attribute_id=>wwv_flow_imp.id(34405931740234149)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'SIMPLE'
,p_help_text=>'Display basic formatting controls in the toolbar.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(34408560093252260)
,p_plugin_attribute_id=>wwv_flow_imp.id(34405931740234149)
,p_display_sequence=>20
,p_display_value=>'Full'
,p_return_value=>'FULL'
,p_help_text=>'Display full set of formatting controls in the toolbar.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(34408916632257999)
,p_plugin_attribute_id=>wwv_flow_imp.id(34405931740234149)
,p_display_sequence=>40
,p_display_value=>'None'
,p_return_value=>'NONE'
,p_help_text=>'Hide the toolbar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(590983936587988716)
,p_plugin_id=>wwv_flow_imp.id(8511644498934019458)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Syntax Highlighting'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Whether to apply syntax highlighting for specific Markdown elements such as bold, italics, code blocks, etc.</p>',
'<p>Highlighting will only take place for content under 4000 characters in length.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(55495142284465026)
,p_plugin_id=>wwv_flow_imp.id(8511644498934019458)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>'<p>Enter a JavaScript function that takes a configuration object for the Markdown Editor, modifies the object, and returns it. This allows advanced customization of the Markdown Editor appearance, features, and behavior including toolbar, menus, and '
||'actions.<p>'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(9126110225642555867)
,p_plugin_id=>wwv_flow_imp.id(8511644498934019458)
,p_name=>'markdownified'
,p_display_name=>'markdownified'
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(16382027049111291021)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>'Switch'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_version_scn=>72472750
,p_subscribe_plugin_settings=>true
,p_help_text=>'Displays as a flip toggle switch.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(14841509770799749)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'On Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'<p>Enter the value stored in the item if the user picks the <strong>On</strong> option. The value can be up to 255 characters long.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(14842132411815696)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'On Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text displayed for the <strong>On</strong> option. If no text is entered, the system default label is used.</p>',
'<p>Note: If the Component Setting ''Display Style'' is <strong>Switch</strong>, this attribute is only used as the display value for Interactive Grid columns. It will not be displayed for page items.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(14842724970851430)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Off Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the value stored in the item if the user picks the <strong>Off</strong> option. This attribute can also be left blank if you want to store <code>NULL</code> when the Off option is selected. The value can be up to 255 characters long.</p>',
'<p><em>Note: This value is used if the item is populated with a value which does not match either the <strong>On Value</strong> or <strong>Off Value</strong>.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(14843532719863116)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Off Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text displayed for the <strong>Off</strong> option. If no text is entered, the system default label is used.</p>',
'<p><em>Note: If the Component Setting ''Display Style'' is <strong>Switch</strong>, this attribute is only used as the display value for Interactive Grid columns. It will not be displayed for page items.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2089613064757884864)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>'Display Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(306600152922320417)
,p_plugin_attribute_id=>wwv_flow_imp.id(2089613064757884864)
,p_display_sequence=>5
,p_display_value=>'Switch'
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2089613549171886868)
,p_plugin_attribute_id=>wwv_flow_imp.id(2089613064757884864)
,p_display_sequence=>10
,p_display_value=>'Pill Button'
,p_return_value=>'SWITCH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2089613999173888214)
,p_plugin_attribute_id=>wwv_flow_imp.id(2089613064757884864)
,p_display_sequence=>20
,p_display_value=>'Select List'
,p_return_value=>'SELECT_LIST'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(10610711090664543)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Use Defaults'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Whether to use the defaults defined for this component in Shared Components, Component Settings or custom settings.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(16382071946350365830)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'On Value'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(10610711090664543)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'<p>Enter the value stored in the item if the user picks the <strong>On</strong> option. The value can be up to 255 characters long.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(16382622645104567710)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'On Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(10610711090664543)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text displayed for the <strong>On</strong> option. If no text is entered, the system default label is used.</p>',
'<p>Note: If the Component Setting ''Display Style'' is <strong>Switch</strong>, this attribute is only used as the display value for Interactive Grid columns. It will not be displayed for page items.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(16382623150298569207)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Off Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(10610711090664543)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the value stored in the item if the user picks the <strong>Off</strong> option. This attribute can also be left blank if you want to store <code>NULL</code> when the Off option is selected. The value can be up to 255 characters long.</p>',
'<p><em>Note: This value is used if the item is populated with a value which does not match either the <strong>On Value</strong> or <strong>Off Value</strong>.</em></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(21162632375092489)
,p_plugin_id=>wwv_flow_imp.id(16382027049111291021)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Off Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(10610711090664543)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text displayed for the <strong>Off</strong> option. If no text is entered, the system default label is used.</p>',
'<p><em>Note: If the Component Setting ''Display Style'' is <strong>Switch</strong>, this attribute is only used as the display value for Interactive Grid columns. It will not be displayed for page items.</em></p>'))
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_imp_page.create_page(
 p_id=>1
,p_name=>'Messages'
,p_alias=>'MESSAGES'
,p_step_title=>'Messages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(91626406749381989)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'13'
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_imp_shared.create_install(
 p_id=>wwv_flow_imp.id(6143914686249783)
);
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_imp.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false)
);
commit;
end;
/
set verify on feedback on define on
prompt  ...done
