prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- Oracle APEX export file
--
-- You should run this script using a SQL client connected to the database as
-- the owner (parsing schema) of the application or as a database user with the
-- APEX_ADMINISTRATOR_ROLE role.
--
-- This export file has been automatically generated. Modifying this file is not
-- supported by Oracle and can lead to unexpected application and/or instance
-- behavior now or in the future.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_imp.import_begin (
 p_version_yyyy_mm_dd=>'2024.05.31'
,p_release=>'24.1.0'
,p_default_workspace_id=>10
,p_default_application_id=>4500
,p_default_id_offset=>0
,p_default_owner=>'APEX_240100'
);
end;
/
 
prompt APPLICATION 4500 - Oracle APEX SQL Workshop
--
-- Application Export:
--   Application:     4500
--   Name:            Oracle APEX SQL Workshop
--   Exported By:     APEX_240100
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    167
--       Items:                  925
--       Computations:            95
--       Validations:            163
--       Processes:              309
--       Regions:                774
--       Buttons:                416
--       Dynamic Actions:        278
--     Shared Components:
--       Logic:
--         Items:                 20
--         Processes:             28
--         Computations:           3
--         Build Options:          9
--       Navigation:
--         Lists:                 40
--         Breadcrumbs:            2
--           Entries:            116
--         NavBar Entries:         3
--       Security:
--         Authentication:         1
--         Authorization:         23
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                16
--           Region:              39
--           Label:               13
--           List:                25
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           2
--           Button:               8
--           Report:              23
--         LOVs:                 182
--         Shortcuts:              7
--         Plug-ins:              19
--       PWA:
--       Globalization:
--         Messages:             546
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--   Version:         24.1.0
--   Instance ID:     1000197243005302
--

prompt --application/delete_application
begin
wwv_flow_imp.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_imp_workspace.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_240100')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX SQL Workshop')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'SQL-WORKSHOP')
,p_application_group=>wwv_flow_imp.id(91050719712959059)
,p_application_group_name=>'APEX Product'
,p_application_group_comment=>'Applications shipped with the APEX product distribution'
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20240716121407'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_accessible_read_only=>'N'
,p_session_state_commits=>'IMMEDIATE'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&G_USER_DEFAULT_DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_publish_yn=>'Y'
,p_documentation_banner=>'Oracle APEX database object development user interface.  SQL Workshop provides database object and data browsing, query building, SQL command processor, and SQL Scripts.'
,p_authentication_id=>wwv_flow_imp.id(539837904309662819)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 24.1.0'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'S'
,p_runtime_api_usage=>'O:W'
,p_pass_ecid=>'N'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_substitution_string_01=>'PRODUCT_NAME'
,p_substitution_value_01=>'Oracle APEX'
,p_substitution_string_02=>'LOGOUT'
,p_substitution_value_02=>'Logout'
,p_substitution_string_03=>'MSG_COMPANY'
,p_substitution_value_03=>'Workspace: &COMPANY.'
,p_substitution_string_04=>'MSG_LANGUAGE'
,p_substitution_value_04=>'Language'
,p_substitution_string_05=>'MSG_COPYRIGHT'
,p_substitution_value_05=>'Copyright &copy; 1999, 2024, Oracle and/or its affiliates.'
,p_substitution_string_06=>'MSG_USER'
,p_substitution_value_06=>'User'
,p_substitution_string_07=>'MSG_JSCRIPT'
,p_substitution_value_07=>'You must run this product with JavaScript enabled.'
,p_substitution_string_08=>'MSG_TBL_SUMMARY'
,p_substitution_value_08=>'Page Layout Table'
,p_substitution_string_09=>'EDIT'
,p_substitution_value_09=>'Edit'
,p_substitution_string_10=>'DONE'
,p_substitution_value_10=>'Done'
,p_substitution_string_11=>'TOP'
,p_substitution_value_11=>'Top'
,p_substitution_string_12=>'CLOSE'
,p_substitution_value_12=>'Close'
,p_substitution_string_13=>'DATE_FORMAT'
,p_substitution_value_13=>'mm/dd/yyyy'
,p_substitution_string_14=>'LONG_DATE_FORMAT'
,p_substitution_value_14=>'fmDay, Month dd, yyyy'
,p_substitution_string_15=>'TIME_FORMAT'
,p_substitution_value_15=>'hh:mi:ss AM'
,p_substitution_string_16=>'DATE_TIME_FORMAT'
,p_substitution_value_16=>'mm/dd/yyyy hh:mi:ss AM'
,p_substitution_string_17=>'RETURN_TO_APPLICATION'
,p_substitution_value_17=>'Return to Application'
,p_substitution_string_18=>'HELP'
,p_substitution_value_18=>'Help'
,p_substitution_string_19=>'MSG_WORKSPACE'
,p_substitution_value_19=>'Workspace'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_print_server_type=>'INSTANCE'
,p_file_storage=>'DB'
,p_is_pwa=>'N'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_imp_shared.create_user_interface(
 p_id=>wwv_flow_imp.id(4500)
,p_theme_id=>3
,p_home_url=>'f?p=4100:1:&SESSION.'
,p_login_url=>'f?p=4550:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>0
,p_nav_list_template_options=>'#DEFAULT#'
,p_css_file_urls=>'#IMAGE_PREFIX#css/apex_builder#MIN#.css'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
);
end;
/
prompt --application/shared_components/navigation/lists/sql_command_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(996508348031635)
,p_name=>'SQL Command Tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558087
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(996930166037917)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Results'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="result_tab" onclick="html_TabClick(this,''resultsHolder'');return false;"'
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(997202592039442)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Explain'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="explain_tab" onclick="sc_getPlan();html_TabClick(this,''explainHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22157207203570630)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Describe'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="describe_tab" onclick="sc_getDesc();html_TabClick(this,''describeHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'139'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(997509865041519)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Saved SQL'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="savedsql_tab" onclick="sc_getSavedSQL();html_TabClick(this,''SavedSQLHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23661510949786902)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="history_tab" onclick="sc_DisplayHist();html_TabClick(this,''historyHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/qb_sub_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1390719147195878)
,p_name=>'QB_SUB_TABS'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1391928151198404)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Conditions'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="cond_tab" onclick="html_TabClick(this,''conditionsHolder'');return false;"'
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1395101055209596)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="sql_tab" onclick="qb_postState();qb_genSql();html_TabClick(this,''queryText_table'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1395705903210915)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Results'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="result_tab" onclick="qb_genSql();html_TabClick(this,''queryResults_table'');qb_checkQuery();return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(159965504417193520)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Saved SQL'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="SavedSql_tab" onclick="qb_getSavedSQL();html_TabClick(this,''SavedSQLHolder'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/p2000_ob_tree_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1600109635671564)
,p_name=>'P2000_OB_TREE_MENU'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2209583665942618)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create %0'
,p_list_item_link_target=>'#action$create-current-object-type'
,p_list_text_01=>'create-current-object-type'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1602136956548295)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1600327266671611)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Refresh'
,p_list_item_link_target=>'#action$objects-refresh'
,p_list_item_current_for_pages=>'#action$objects-refresh'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1600708408671612)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Expand All'
,p_list_item_link_target=>'#action$objects-expand-all'
,p_list_item_current_for_pages=>'#action$objects-expand-all'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1601168944671613)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Collapse All'
,p_list_item_link_target=>'#action$objects-collapse-all'
,p_list_item_current_for_pages=>'#action$objects-collapse-all'
);
end;
/
prompt --application/shared_components/navigation/lists/query_builder_link_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1993413324492056)
,p_name=>'Query_Builder_Link_Menu'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1994208260500093)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Delete Join'
,p_list_item_link_target=>'javascript:qb_delLinkClick();'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1994516571502453)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Set Left Outer Join'
,p_list_item_link_target=>'javascript:qb_outer(''L'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1994823151504371)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Set Right Outer Join'
,p_list_item_link_target=>'javascript:qb_outer(''R'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1993900988497974)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Unset Outer Join'
,p_list_item_link_target=>'javascript:qb_outer(''E'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/extension_links_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2200356137180721)
,p_name=>'Extension Links Menu'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lev,',
'       label,',
'       target,',
'       null     as is_current,',
'       null     as image,',
'       null     as image_attrib,',
'       null     as image_alt_attribute,',
'       null     as attribute1,',
'       null     as attribute2,',
'       null     as attribute3,',
'       null     as attribute4,',
'       null     as attribute5,',
'       ''_blank'' as attribute6,',
'       null     as attribute7,',
'       null     as attribute8,',
'       null     as attribute9,',
'       null     as attribute10',
'  from (',
'          select 1                          as lev,',
'                 name                       as label,',
'                 wwv_extension.get_url(url) as target,',
'                 null                       as wsname,',
'                 display_sequence',
'            from wwv_extension_links',
'           where security_group_id = :workspace_id',
'          union all',
'          select 1                                           as lev,',
'                 nvl(eg.menu_label, initcap(c.display_name)) as label,',
'                 null                                        as target,',
'                 c.display_name                              as wsname,',
'                 0                                           as display_sequence',
'            from wwv_extension_grants eg, wwv_flow_companies c',
'           where eg.security_group_id           = :workspace_id',
'             and eg.extension_security_group_id = c.provisioning_company_id',
'             and exists (',
'                   select 1',
'                     from wwv_extension_links l',
'                    where l.security_group_id = eg.extension_security_group_id',
'                      and is_public           = ''Y'' )',
'          union all',
'          select 2                             as lev,',
'                 name                          as label,',
'                 wwv_extension.get_url(el.url) as target,',
'                 eg.wsname                     as wsname,',
'                 el.display_sequence',
'            from (',
'                    select eg.*,',
'                           c.display_name as wsname',
'                      from wwv_extension_grants eg, wwv_flow_companies c',
'                     where eg.security_group_id           = :workspace_id',
'                       and eg.extension_security_group_id = c.provisioning_company_id',
'                 )                         eg, wwv_extension_links el',
'           where el.security_group_id = eg.extension_security_group_id',
'             and el.is_public         = ''Y''',
'       )',
' order by wsname nulls first, lev, display_sequence, label'))
,p_list_status=>'PUBLIC'
,p_reference_id=>2000133062045966
,p_version_scn=>40349138
);
end;
/
prompt --application/shared_components/navigation/lists/dg_bp_datasources_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2500895807659729)
,p_name=>'DG_BP_DATASOURCES_TASKS'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2501049036659732)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Blueprint Details'
,p_list_item_link_target=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.::P4001_BLUEPRINT_ID:&P4015_BLUEPRINT_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p2000_ob_create_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2686914575823204)
,p_name=>'P2000_OB_CREATE_MENU'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2690717953823212)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Table'
,p_list_item_link_target=>'f?p=&APP_ID.:2020:&SESSION.::&DEBUG.:2020,2022,TBL_WIZ_COLUMNS,TBL_WIZ_FKS,TBL_WIZ_CONS:P2020_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_text_01=>'create-table'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2691106004823212)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'View'
,p_list_item_link_target=>'f?p=&APP_ID.:2015:&SESSION.::&DEBUG.:2015:P2015_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_text_01=>'create-view'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2691523551823212)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Index'
,p_list_item_link_target=>'f?p=&APP_ID.:2025:&SESSION.::&DEBUG.:2025,2026,2027:P2025_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_text_01=>'create-index'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2691925468823213)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Sequence'
,p_list_item_link_target=>'f?p=&APP_ID.:2030:&SESSION.::&DEBUG.:2030:P2030_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_text_01=>'create-sequence'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2692366703823213)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Type'
,p_list_item_link_target=>'f?p=&APP_ID.:2035:&SESSION.::&DEBUG.:2035:P2035_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_text_01=>'create-type'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2692721994823213)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Package'
,p_list_item_link_target=>'f?p=&APP_ID.:2040:&SESSION.::&DEBUG.:2040:P2040_PARSING_SCHEMA,P2040_OBJECT_TYPE:~PARSING_SCHEMA~,PACKAGE:'
,p_list_text_01=>'create-package'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2693192078823213)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Procedure'
,p_list_item_link_target=>'f?p=&APP_ID.:2040:&SESSION.::&DEBUG.:2040:P2040_PARSING_SCHEMA,P2040_OBJECT_TYPE:~PARSING_SCHEMA~,PROCEDURE:'
,p_list_text_01=>'create-procedure'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2693535147823214)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Function'
,p_list_item_link_target=>'f?p=&APP_ID.:2040:&SESSION.::&DEBUG.:2040:P2040_PARSING_SCHEMA,P2040_OBJECT_TYPE:~PARSING_SCHEMA~,FUNCTION:'
,p_list_text_01=>'create-function'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2693993448823214)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Trigger'
,p_list_item_link_target=>'f?p=&APP_ID.:2055:&SESSION.::&DEBUG.:2055:P2055_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_text_01=>'create-trigger'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2694329810823214)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Database Link'
,p_list_item_link_target=>'f?p=&APP_ID.:2070:&SESSION.::&DEBUG.:2070:P2070_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'create-database-link'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2694714530823214)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Materialized View'
,p_list_item_link_target=>'f?p=&APP_ID.:2060:&SESSION.::&DEBUG.:2060:P2060_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_text_01=>'create-materialized-view'
,p_required_patch=>wwv_flow_imp.id(1080926199001296276)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2695150394823215)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Synonym'
,p_list_item_link_target=>'f?p=&APP_ID.:2010:&SESSION.::&DEBUG.:2010:P2010_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_text_01=>'create-synonym'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2695514336823215)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'SODA Collection'
,p_list_item_link_target=>'f?p=&APP_ID.:3150:&SESSION.::&DEBUG.:3150,3151:P3150_PARSING_SCHEMA,P3150_OB_FLAG:~PARSING_SCHEMA~,Y:'
,p_list_text_01=>'create-soda-collection'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2695974354823215)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'MLE Environment'
,p_list_item_link_target=>'f?p=&APP_ID.:5005:&SESSION.::&DEBUG.:5005:P5005_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_db_version.c_has_mle_with_modules'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'create-mle-environment'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2696327021823215)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'MLE Module - JavaScript'
,p_list_item_link_target=>'f?p=&APP_ID.:5015:&SESSION.::&DEBUG.:5015:P5015_PARSING_SCHEMA:~PARSING_SCHEMA~:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_db_version.c_has_mle_with_modules'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'create-mle-module'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/dg_bp_table_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2800695231074419)
,p_name=>'DG_BP_TABLE_TASKS'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2801229597074438)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'View Data Sources'
,p_list_item_link_target=>'f?p=&APP_ID.:4015:&SESSION.::&DEBUG.::P4015_BLUEPRINT_ID,P4015_BLUEPRINT_NAME:&P4001_BLUEPRINT_ID.,&P4001_BLUEPRINT_NAME.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/dg_bp_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3001483965708067)
,p_name=>'DG_BP_TASKS'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3001622697708068)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'View Built Ins'
,p_list_item_link_target=>'f?p=&APP_ID.:4011:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/qb_query_quick_results_pg_111
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3531801850564253)
,p_name=>'QB Query Quick Results (pg 111)'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3532824014570648)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'#'
,p_list_text_01=>'id="sql_tab" onclick="html_TabClick(this,''QuerySQL'');return false;"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/dg_bp_create_wizard
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(7502006538093520)
,p_name=>'DG_BP_CREATE_WIZARD'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7503005490093539)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Use Existing Tables'
,p_list_item_link_target=>'f?p=&APP_ID.:4020:&SESSION.::&DEBUG.:4020:::'
,p_list_item_icon=>'gi-icon-create-app-websheet '
,p_list_text_01=>'Select existing tables from your schema to quickly build a blueprint that allow fast inserts of generated data into them.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7502239389093537)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'From Scratch'
,p_list_item_link_target=>'f?p=&APP_ID.:4007:&SESSION.::&DEBUG.:4007:::'
,p_list_item_icon=>'gi-icon-app-builder-create-app'
,p_list_text_01=>'Create a new blueprint from scratch, based on a sample table with provided columns that allows you to quickly generate sample data.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7502691410093539)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Import JSON File'
,p_list_item_link_target=>'f?p=&APP_ID.:4010:&SESSION.::&DEBUG.:4010:::'
,p_list_item_icon=>'gi-icon-app-builder-import-app'
,p_list_text_01=>'Upload a valid blueprint from a JSON file, or copy paste your JSON data with the required fields.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p4100_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(8537282234307541)
,p_name=>'P4100_MENU'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8537863224307545)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Export Blueprint'
,p_list_item_link_target=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.:4009:P4009_BLUEPRINT_NAME,P4009_BLUEPRINT_ID:&P4100_BLUEPRINT_NAME.,&P4100_BLUEPRINT_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8539572238319250)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8537421724307543)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Delete Blueprint'
,p_list_item_link_target=>'f?p=&APP_ID.:4015:&SESSION.::&DEBUG.:4015:P4015_BLUEPRINT_ID,P4015_BLUEPRINT_NAME:&P4100_BLUEPRINT_ID.,&P4100_BLUEPRINT_NAME.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/quicksql_actions
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(8612181654398721)
,p_name=>'QuickSQL Actions'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558089
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8612394212398723)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Load'
,p_list_item_link_target=>'f?p=&APP_ID.:1103:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8614643735404527)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8612792255398725)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Save Model'
,p_list_item_link_target=>'f?p=&APP_ID.:1105:&SESSION.::&DEBUG.:1105:::'
,p_list_text_01=>'saveModel'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2049250879798103)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Update Model'
,p_list_item_link_target=>'f?p=&APP_ID.:1105:&SESSION.::&DEBUG.:1105:::'
,p_list_text_01=>'updateModel'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8613138533398725)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Save Model As'
,p_list_item_link_target=>'f?p=&APP_ID.:1105:&SESSION.:SAVE_AS:&DEBUG.::::'
,p_list_text_01=>'saveModelAs'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8614988779404528)
,p_list_item_display_sequence=>32
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2216410897200565)
,p_list_item_display_sequence=>51
,p_list_item_link_text=>'Reset'
,p_list_item_link_target=>'javascript:apex.page.submit(''RESET'');'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2218861666262225)
,p_list_item_display_sequence=>51
,p_list_item_link_text=>'Reset'
,p_list_item_link_target=>'javascript:apex.event.trigger(document, ''clear'');'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8617042317437219)
,p_list_item_display_sequence=>59
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8613586112398725)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Properties'
,p_list_item_link_target=>'f?p=&APP_ID.:1108:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'properties'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/sql_script_actions
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(8839831299543497)
,p_name=>'SQL Script Actions'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558091
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8840805178543498)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Save SQL Script'
,p_list_item_link_target=>'f?p=&APP_ID.:1104:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'saveScript'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8841666360543498)
,p_list_item_display_sequence=>32
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8842008580543498)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Download'
,p_list_item_link_target=>'javascript:QuickSQL.download();'
,p_list_text_01=>'download'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/table_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11239830706238313)
,p_name=>'Table Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11129306899761893)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Table Columns'
,p_list_item_link_target=>'f?p=&APP_ID.:1047:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11252702534296443)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Table Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11253122273302192)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Table Constraints'
,p_list_item_link_target=>'f?p=&APP_ID.:706:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11286227355445574)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Table Statistics'
,p_list_item_link_target=>'f?p=&APP_ID.:1052:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11215531943727735)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Table Storage Sizes'
,p_list_item_link_target=>'f?p=&APP_ID.:1048:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/exception_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11254208206307506)
,p_name=>'Exception Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11247001795267858)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Tables without Primary Keys'
,p_list_item_link_target=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11257003273325012)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Tables without Indexes'
,p_list_item_link_target=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11247315993271938)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Unindexed Foreign Keys'
,p_list_item_link_target=>'f?p=&APP_ID.:704:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(69176903649450759)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Tables without Triggers'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/security_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11271128516379623)
,p_name=>'Security Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11122717588736506)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Object Grants'
,p_list_item_link_target=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_security.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8953808698289635)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Column Privileges'
,p_list_item_link_target=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_security.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(240016507458722563)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Role Privileges'
,p_list_item_link_target=>'f?p=&APP_ID.:1502:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_security.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(240018327890728456)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'System Privileges'
,p_list_item_link_target=>'f?p=&APP_ID.:1404:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_security.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/pl_sql_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11319530060616601)
,p_name=>'PL/SQL Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11134009370790923)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Program Unit Arguments'
,p_list_item_link_target=>'f?p=&APP_ID.:1046:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11323926167634444)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Unit Line Counts'
,p_list_item_link_target=>'f?p=&APP_ID.:1054:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(163506601642923359)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Search PL/SQL Source Code'
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/recycle_bin
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11401232423499912)
,p_name=>'Recycle Bin'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11401613160503840)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Dropped Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_page.png'
,p_list_item_icon_attributes=>'height="20" width="20"  alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11404101994519551)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Purge Recycle Bin'
,p_list_item_link_target=>'f?p=&APP_ID.:403:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_process.png'
,p_list_item_icon_attributes=>'height="20" width="20"  alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sql_developer_web_schemas
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11631195554192189)
,p_name=>'SQL Developer Web Schemas'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with schema_list as (',
' select *',
'   from wwv_flow_collections',
'  where collection_name = ''SDW_SCHEMAS''',
'  order by c002, c001)',
'select null, ',
'       c001 label, ',
'       c003 target, ',
'       ''NO'' is_current_list_entry, ',
'       ''a-Icon icon-rest-services'' || case when c002 = ''Y'' then '' u-success-text'' else '' u-opacity-50'' end image, ',
'       '''' image_attrib, ',
'       null image_alt,',
'       case when c002 = ''Y'' then ''<!-- &APP_TEXT$SDW_REST_ENABLED. -->''',
'            else ''<span>&APP_TEXT$SDW_NOT_REST_ENABLED.</span>''',
'       end a01,  -- description',
'       case when c002 = ''Y'' then ''<span id="link''||rownum||''_new_window" aria-hidden="true" class="u-vh">&APP_TEXT$SDW_OPEN_NEW_WINDOW.</span>&APP_TEXT$SDW_CONNECT.''',
'       end a02,',
'       case when c002 = ''Y'' then ''aria-describedby="link''||rownum||''_new_window"''',
'       end a03',
'  from schema_list'))
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
end;
/
prompt --application/shared_components/navigation/lists/ob_table_subtab
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11739111107829730)
,p_name=>'OB_TABLE_SUBTAB'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11744500680874063)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Data'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_DATA:&SESSION.:T:&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2101:42:46:47'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11747316180897446)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:TABLE_DDL:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(243327690322706018)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'REST'
,p_list_item_link_target=>'f?p=&APP_ID.:OBJECT_REST:&SESSION.::&DEBUG.:2111:::'
,p_security_scheme=>wwv_flow_imp.id(802775228359756685)
,p_required_patch=>wwv_flow_imp.id(256109433659228165)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(565810533598211906)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Sample Queries'
,p_list_item_link_target=>'f?p=&APP_ID.:OBJECT_SAMPLE_QUERIES:&SESSION.::&DEBUG.:2112:::'
,p_security_scheme=>wwv_flow_imp.id(802775228359756685)
,p_required_patch=>wwv_flow_imp.id(256109433659228165)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ob_object_types
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(23674222199102465)
,p_name=>'OB_OBJECT_TYPES'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23674801898106075)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tables'
,p_list_item_icon=>'table_s.gif'
,p_list_text_01=>'TABLE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1001'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23675208132107838)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Views'
,p_list_item_icon=>'view_s.gif'
,p_list_text_01=>'VIEW'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23676115750110093)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Indexes'
,p_list_item_icon=>'index_s.gif'
,p_list_text_01=>'INDEX'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23677731334114549)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Sequences'
,p_list_item_icon=>'sequence_s.gif'
,p_list_text_01=>'SEQUENCE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23678808609117400)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Types'
,p_list_item_icon=>'type_s.gif'
,p_list_text_01=>'TYPE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23676924062112497)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Packages'
,p_list_item_icon=>'package_s.gif'
,p_list_text_01=>'PACKAGE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23677327871113573)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Procedures'
,p_list_item_icon=>'procedure_s.gif'
,p_list_text_01=>'PROCEDURE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23675611595108895)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Functions'
,p_list_item_icon=>'function_s.gif'
,p_list_text_01=>'FUNCTION'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23678405146116460)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Triggers'
,p_list_item_icon=>'trigger_s.gif'
,p_list_text_01=>'TRIGGER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23679113457118846)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Database Links'
,p_list_item_icon=>'dblink_s.gif'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'DATABASE_LINK'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23676520945111591)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Materialized Views'
,p_list_item_icon=>'materialized_view_s.gif'
,p_list_text_01=>'MATERIALIZED_VIEW'
,p_required_patch=>wwv_flow_imp.id(240247031763163202)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23678002029115528)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Synonyms'
,p_list_item_icon=>'synonym_s.gif'
,p_list_text_01=>'SYNONYM'
,p_required_patch=>wwv_flow_imp.id(240237502901130926)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3310563180268546)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'SODA Collections'
,p_list_item_icon=>'table_s.gif'
,p_list_text_01=>'SODA_COLLECTION'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1001'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1689228451536108)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'MLE Environments'
,p_list_item_icon=>'table_s.gif'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_db_version.c_has_mle_with_modules'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'MLE_ENVIRONMENT'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1001'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1689580569541319)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'MLE Modules - JavaScript'
,p_list_item_icon=>'table_s.gif'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_db_version.c_has_mle_with_modules'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'MLE_MODULE_JAVASCRIPT'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1001'
);
end;
/
prompt --application/shared_components/navigation/lists/ui_default_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(40650212014681045)
,p_name=>'ui default tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40758212349422677)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Create Column Group'
,p_list_item_link_target=>'f?p=&APP_ID.:804:&SESSION.::&DEBUG.:804:P804_TABLE_ID:&P802_TABLE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40841914817552027)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Manage Column Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:805:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(429084627870179449)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Synchronize with Database'
,p_list_item_link_target=>'f?p=&APP_ID.:807:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(201476126054569515)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Migrate to Attribute Dictionary'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::P32_SCHEMA,P33_TABLE_ID:&P800_SCHEMA.,&P802_TABLE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40819416727890341)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Remove from Table Dictionary'
,p_list_item_link_target=>'f?p=&APP_ID.:830:&SESSION.::&DEBUG.::P830_TABLE_ID:&P802_TABLE_ID.:'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'P802_TABLE_ID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/table_dictionary_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(40848526002687735)
,p_name=>'table dictionary tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(201458325044096158)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Attribute Dictionary Migration'
,p_list_item_link_target=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.::P32_SCHEMA:&P800_SCHEMA.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40876113946214023)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40876316370214768)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sql_workshop_home_list_apex_4_0
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(46900227098494683)
,p_name=>'SQL Workshop Home List - APEX 4.0'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46900407490498504)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Object Browser'
,p_list_item_link_target=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'sql-workshop-object-browser'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46900613377500241)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL Commands'
,p_list_item_link_target=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'sql-workshop-commands'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46900819264501864)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'SQL Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-sql-script'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46901026191503941)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.:1002:::'
,p_list_item_icon=>'qb'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47583907412198107)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(325069319924256588)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'RESTful Services'
,p_list_item_link_target=>'f?p=4850:100:&SESSION.'
,p_list_item_icon=>'sql-workshop-rest'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_imp.id(802775228359756685)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ddl_wizard
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(87134126220568115)
,p_name=>'DDL Wizard'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(87135922338569906)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Schema'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'18'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(87136718887571537)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Object Type'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'43'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(87137516731572565)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Object Name'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'44'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(87138313496573982)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Script'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'29:45'
);
end;
/
prompt --application/shared_components/navigation/lists/4500_24_tablescolums
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(98332317887807047)
,p_name=>'4500_24_TablesColums'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(98332922735808489)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tables'
,p_list_item_link_target=>'javascript:void($d_TabClick(''tabletab'',''tablereport'',''tabcurrent'',p24Tabs))'||wwv_flow.LF||
''
,p_list_text_01=>'id="tabletab"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(98333326198809479)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Columns'
,p_list_item_link_target=>'javascript:void($d_TabClick(''columntab'',''columnreport'',''tabcurrent'',p24Tabs))'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'P24_TABLE_NAME'
,p_list_text_01=>'id="columntab"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/database_monitor
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(133792932105421631)
,p_name=>'database monitor'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(133794915960426480)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Sessions'
,p_list_item_link_target=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(173640005872718109)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'System Statistics'
,p_list_item_link_target=>'f?p=&APP_ID.:560:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(134580728113951404)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Top SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(137498619860396665)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Long Operations'
,p_list_item_link_target=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_package_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(149957726913651895)
,p_name=>'create package progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1080739923278204088)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:125:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P117_CREATE_PACKAGE'
,p_list_item_disp_condition2=>'TABLE'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/recyclebin
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(151000331198918456)
,p_name=>'recyclebin'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(151001418516924257)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Purge Recycle Bin'
,p_list_item_link_target=>'f?p=&FLOW_ID.:403:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/session_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(159562414490322899)
,p_name=>'session tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(159564908042330521)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Sessions'
,p_list_item_link_target=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'540'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(159565421201334330)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Locks'
,p_list_item_link_target=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'541'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(162017426458197138)
,p_list_item_display_sequence=>2.1
,p_list_item_link_text=>'Waits'
,p_list_item_link_target=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'548'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(159588009305397176)
,p_list_item_display_sequence=>2.2
,p_list_item_link_text=>'I/O'
,p_list_item_link_target=>'f?p=&APP_ID.:545:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'545'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(159566527088336046)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:542:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'542'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(159567803324338684)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Open Cursors'
,p_list_item_link_target=>'f?p=&APP_ID.:543:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'543,546'
);
end;
/
prompt --application/shared_components/navigation/lists/script_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(163470423703447178)
,p_name=>'Script Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558093
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(164091703714775079)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Manage Results'
,p_list_item_link_target=>'f?p=&APP_ID.:1220:&SESSION.::&DEBUG.:1220:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(150027319743782244)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Show Quotas'
,p_list_item_link_target=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(221300505462590355)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:SCRIPTS_TO_EXPORT:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(221300908233591110)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/utilities_line_1
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(169562905299954428)
,p_name=>'Utilities line 1'
,p_list_status=>'PUBLIC'
,p_version_scn=>122522321
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(169563123101954428)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Data Workshop'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_list_item_icon=>'icon-utilities-data-workshop'
,p_list_text_01=>'Load and unload data using CSV, XLSX, XML or JSON files.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1680531624716286)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Data Generator'
,p_list_item_link_target=>'f?p=&APP_ID.:4000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-generate-ddl'
,p_list_text_01=>'Create blueprints to populate tables with randomly generated data.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(1753335990774646)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(686840721222033340)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-query-builder'
,p_list_text_01=>'Build queries graphically by adding tables into a panel, and selecting columns to return.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(713107322646978455)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Quick SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:RP,1100:::'
,p_list_item_icon=>'a-Icon icon-utilities-query-builder'
,p_list_text_01=>'Generate SQL using shorthand syntax'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165295291982048923)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Sample Datasets'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_list_item_icon=>'icon-sc-files'
,p_list_text_01=>'Install, refresh, or remove sample datasets.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(621480553521527744)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Generate DDL'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-generate-ddl'
,p_list_text_01=>'Generate scripts for all or selected database objects within a schema.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(169564017816954429)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'UI Defaults'
,p_list_item_link_target=>'f?p=&APP_ID.:813:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-db-ui-defaults'
,p_list_text_01=>'UI Defaults allow AI interactions to understand the contents of your tables and populate initial labels for forms and reports.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(862293371954895810)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Schema Comparison'
,p_list_item_link_target=>'f?p=&APP_ID.:1350:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilites-schema-comparison'
,p_list_text_01=>'Show differences between database objects in two different schemas.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(169563411461954429)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Methods on Tables'
,p_list_item_link_target=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:120,124,125:::'
,p_list_item_icon=>'icon-utilities-methods-tables'
,p_list_text_01=>'Generate API scripts for DML operations on specified tables.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(862292771917895809)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Recycle Bin'
,p_list_item_link_target=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilites-recycle-bin'
,p_list_text_01=>'Restore database objects that have been dropped.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1379793096144889954)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Object Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:1042:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-object-reports'
,p_list_text_01=>'Access numerous reports on tables, exceptions, security, objects and PL/SQL code.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(862293694522895810)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'About Database'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-about-database'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'Review database details. Note: A Database account granted the DBA role is required.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1144637580332327672)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Database Monitor'
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-database-monitor'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'Run database activity reports. Note: A Database account granted the DBA role is required.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sql_workshop_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(170601318269466378)
,p_name=>'sql workshop navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558095
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(170601819280466388)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL Commands'
,p_list_item_link_target=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/sqlcmd.gif'
,p_list_text_01=>'commandLine'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(170602114146466388)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'SQL Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/sqlscrpt.gif'
,p_list_text_01=>'file'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(170602413280466389)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/qbuilder.gif'
,p_list_text_01=>'queryBuilder'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(170628208161633707)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/shared_comp_small.gif'
,p_list_text_01=>'utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(872825001018813755)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'RESTful Services'
,p_list_item_link_target=>'f?p=4850:1:&SESSION.'
,p_list_item_icon=>'htmldb/icons/dbservice.png'
,p_list_text_01=>'restfulServices'
,p_security_scheme=>wwv_flow_imp.id(802775228359756685)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ui_defaults_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(194504915759237345)
,p_name=>'UI Defaults Navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558096
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(421011030860726171)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:813:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'813'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194505202972237349)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Table Dictionary'
,p_list_item_link_target=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.::P800_SCHEMA:&P813_SCHEMA.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'800'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194505603010237353)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Attribute Dictionary'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'6:17'
);
end;
/
prompt --application/shared_components/navigation/lists/all_object_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(276235426866859669)
,p_name=>'All Object Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558096
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(276237431846870512)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'All Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:500:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(276237707735873072)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Invalid Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:1040:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(276238015700875357)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Object Creation Calendar'
,p_list_item_link_target=>'f?p=&APP_ID.:1055:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_session.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(276238320549876791)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Object Counts by Type'
,p_list_item_link_target=>'f?p=&APP_ID.:1059:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(65214035632967721)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Data Dictionary'
,p_list_item_link_target=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_global.g_cloud'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/attribute_dictionary_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(442022106915434689)
,p_name=>'attribute dictionary tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558096
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(442022828528434694)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(442023208094434695)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_administration_header
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(697546799309390664)
,p_name=>'APEX 5 - Administration (Header)'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558096
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697546976894390664)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Administration'
,p_list_item_link_target=>'f?p=4350:1:&APP_SESSION.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697547235161390665)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697547501968390665)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Service'
,p_security_scheme=>wwv_flow_imp.id(12520119493499631)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697547855490390665)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Manage Service'
,p_list_item_link_target=>'f?p=4350:21:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(697547501968390665)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697548157703390665)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(697547501968390665)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(322769288632400743)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Make a Service Request'
,p_list_item_link_target=>'f?p=4350:96:&SESSION.::NO:49::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(697547501968390665)
,p_security_scheme=>wwv_flow_imp.id(12520119493499631)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697548721548390666)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Set Workspace Preferences'
,p_list_item_link_target=>'f?p=4350:17:&SESSION.::NO:RP::'
,p_parent_list_item_id=>wwv_flow_imp.id(697547501968390665)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697549084529390666)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Define Workspace Message'
,p_list_item_link_target=>'f?p=4350:35:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(697547501968390665)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(180642720025555459)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Define Environment Banner'
,p_list_item_link_target=>'f?p=4350:105:&SESSION.:::105:P105_LAST_APP_ID,P105_LAST_PAGE_ID:&APP_ID.,&APP_PAGE_ID.'
,p_parent_list_item_id=>wwv_flow_imp.id(697547501968390665)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697549313943390666)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Workspace Utilization'
,p_list_item_link_target=>'f?p=4350:101:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(697547501968390665)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2400223137184492)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Manage Extension Links'
,p_list_item_link_target=>'f?p=4350:110:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(697547501968390665)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697549654493390666)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Users and Groups'
,p_list_item_link_target=>'f?p=4350:55:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(12520119493499631)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697549971815390666)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Monitor Activity'
,p_list_item_link_target=>'f?p=4350:22:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(10590808779171805)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697550297696390667)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dashboards'
,p_list_item_link_target=>'f?p=4350:33:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(10590808779171805)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1250750521916198591)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Change My Password'
,p_list_item_link_target=>'f?p=4350:3:&SESSION.::&DEBUG.:3#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(10590808779171805)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(697551745129395610)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
,p_version_scn=>75558097
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697551976020395610)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Documentation'
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_01=>'helpLinkDocLib'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2105955016147042297)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Discussion Forum'
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2185349560170378007)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Learn More about Oracle APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697552813369395610)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697553124884395611)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'About'
,p_list_item_link_target=>'f?p=4350:9:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_shared_navigation_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(718942723406995455)
,p_name=>'APEX Shared Navigation Menu'
,p_list_status=>'PUBLIC'
,p_reference_id=>2206460728364447
,p_version_scn=>117449631
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2281176336227509)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'App Builder'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'App Builder Drill Down'
,p_list_text_01=>'tab-app-builder'
,p_security_scheme=>wwv_flow_imp.id(178922732459641711)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID in ( 4000, 4020 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2281529366227509)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Create'
,p_list_item_link_target=>'f?p=4000:56:&SESSION.::&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID::'
,p_parent_list_item_id=>wwv_flow_imp.id(2281176336227509)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2281966107227510)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=4000:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_parent_list_item_id=>wwv_flow_imp.id(2281176336227509)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2282317893227510)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::&DEBUG.:4900:FB_FLOW_ID,FB_FLOW_PAGE_ID::'
,p_parent_list_item_id=>wwv_flow_imp.id(2281176336227509)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2282742991227510)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2281176336227509)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2283179858227510)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Workspace Utilities'
,p_parent_list_item_id=>wwv_flow_imp.id(2281176336227509)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2283552474227510)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'All Workspace Utilities'
,p_list_item_link_target=>'f?p=4000:182:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2283179858227510)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2283976448227510)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2283179858227510)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2284381095227510)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Workspace Themes'
,p_list_item_link_target=>'f?p=4000:763:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2283179858227510)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2284708593227510)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Application Groups'
,p_list_item_link_target=>'f?p=4000:722:&SESSION.::&DEBUG.:RP'
,p_parent_list_item_id=>wwv_flow_imp.id(2283179858227510)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2285188419227510)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'&PRODUCT_NAME. Views'
,p_list_item_link_target=>'f?p=4000:714:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2283179858227510)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2285510701227511)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Cross Application Reports'
,p_list_item_link_target=>'f?p=4000:9009:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2283179858227510)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2285973276227511)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL Workshop'
,p_list_item_link_target=>'f?p=4500:3002:&SESSION.'
,p_list_item_icon_alt_attribute=>'SQL Workshop Drill Down'
,p_list_text_01=>'tab-sql-workshop'
,p_security_scheme=>wwv_flow_imp.id(178925305824656679)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'( :APP_ID = 4500 and :APP_PAGE_ID not in ( ''1000'',''8000'',''35'', ''900'' ) ) or :APP_ID in ( 4850, 4300 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2286391488227511)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Object Browser'
,p_list_item_link_target=>'f?p=4500:2000:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2285973276227511)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2286757633227511)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'SQL Commands'
,p_list_item_link_target=>'f?p=4500:1003:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2285973276227511)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2287148099227511)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'SQL Scripts'
,p_list_item_link_target=>'f?p=4500:1004:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2285973276227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Utilities'
,p_parent_list_item_id=>wwv_flow_imp.id(2285973276227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2287911448227511)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'All Utilities'
,p_list_item_link_target=>'f?p=4500:1005:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2288356609227511)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2288757841227512)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Data Workshop'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2289158337227512)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Data Generator'
,p_list_item_link_target=>'f?p=4500:4000:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_security_scheme=>wwv_flow_imp.id(1753335990774646)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2289538381227512)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=4500:1002:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2289995332227512)
,p_list_item_display_sequence=>270
,p_list_item_link_text=>'Quick SQL'
,p_list_item_link_target=>'f?p=4500:1100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2290370922227512)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>'Sample Datasets'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2290775826227512)
,p_list_item_display_sequence=>290
,p_list_item_link_text=>'Generate DDL'
,p_list_item_link_target=>'f?p=4500:12:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2291100604227512)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'UI Defaults'
,p_list_item_link_target=>'f?p=4500:813:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2291590562227512)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Schema Comparison'
,p_list_item_link_target=>'f?p=4500:1350:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2291927493227512)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Methods on Tables'
,p_list_item_link_target=>'f?p=4500:120:&SESSION.:'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2292358796227513)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Recycle Bin'
,p_list_item_link_target=>'f?p=4500:1070:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2292743506227513)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Object Reports'
,p_list_item_link_target=>'f?p=4500:1042:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2293184926227513)
,p_list_item_display_sequence=>350
,p_list_item_link_text=>'About Database'
,p_list_item_link_target=>'f?p=4500:36:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2293504983227513)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Database Monitor'
,p_list_item_link_target=>'f?p=4500:11:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(2287543490227511)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2293911352227513)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'RESTful Services'
,p_list_item_link_target=>'f?p=4850:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2285973276227511)
,p_security_scheme=>wwv_flow_imp.id(802775228359756685)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2294323788227513)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'SQL Developer Web'
,p_list_item_link_target=>'f?p=4500:64:&SESSION.::&DEBUG.:64:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2285973276227511)
,p_security_scheme=>wwv_flow_imp.id(11403377390021811)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2294744941227513)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Team Development'
,p_list_item_link_target=>'f?p=4600:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon_alt_attribute=>'Team Development Drill Down'
,p_list_text_01=>'tab-team-dev'
,p_security_scheme=>wwv_flow_imp.id(173297929258927869)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID in ( 4600, 4650 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2295108913227513)
,p_list_item_display_sequence=>370
,p_list_item_link_text=>'Labels'
,p_list_item_link_target=>'f?p=4600:300:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2294744941227513)
,p_security_scheme=>wwv_flow_imp.id(12506407035221692)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2295561187227514)
,p_list_item_display_sequence=>380
,p_list_item_link_text=>'Milestones'
,p_list_item_link_target=>'f?p=4600:200:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2294744941227513)
,p_security_scheme=>wwv_flow_imp.id(12506407035221692)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2295918887227514)
,p_list_item_display_sequence=>390
,p_list_item_link_text=>'Templates'
,p_list_item_link_target=>'f?p=4600:1000:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2294744941227513)
,p_security_scheme=>wwv_flow_imp.id(12506407035221692)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2296375043227514)
,p_list_item_display_sequence=>400
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=4600:2000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2294744941227513)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2296743536227514)
,p_list_item_display_sequence=>410
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2294744941227513)
,p_security_scheme=>wwv_flow_imp.id(12506407035221692)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2297148070227514)
,p_list_item_display_sequence=>420
,p_list_item_link_text=>'Feedback'
,p_list_item_link_target=>'f?p=4650:8012:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2294744941227513)
,p_security_scheme=>wwv_flow_imp.id(12506407035221692)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2297500359227514)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Gallery'
,p_list_item_link_target=>'f?p=4750:50:&SESSION.'
,p_list_text_01=>'tab-apps'
,p_security_scheme=>wwv_flow_imp.id(12506407035221692)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID = 4750'
,p_list_item_current_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/navigation/listentry
begin
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(940455082467897)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1302660976451618)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SELECT_MANY'
,p_attribute_01=>'separated'
,p_version_scn=>229016598
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1308824809778855)
,p_plugin_type=>'DYNAMIC ACTION'
,p_plugin=>'NATIVE_OPEN_AI_ASSISTANT'
,p_version_scn=>16259796
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(3221592352137505)
,p_plugin_type=>'PROCESS TYPE'
,p_plugin=>'NATIVE_GEOCODING'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_version_scn=>117643320
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(14848715049940930)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(99821386660888928)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(118451017525833014)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_MAP_REGION'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'use_vector_tile_layers', 'Y')).to_clob
,p_version_scn=>1088662546
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(123182641277478451)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_APEX'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(124362361029989292)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_plugin=>'NATIVE_ADFBC'
,p_version_scn=>37165931336888
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(176118118407506807)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1272782587538879395)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'Y')).to_clob
,p_reference_id=>174677809582024970
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1765072762112712055)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'include_slider', 'N')).to_clob
,p_version_scn=>1088662546
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1831722742580993878)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'actions_menu_structure', 'IG')).to_clob
,p_version_scn=>1088662546
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1917693824782940193)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
,p_version_scn=>37165931336884
);
end;
/
prompt --application/shared_components/security/authorizations/flow_data_generator
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(1753335990774646)
,p_name=>'Flow: DATA_GENERATOR'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'DATA_GENERATOR'
,p_error_message=>'You are not authorized to use Data Generator in SQL Workshop'
,p_reference_id=>2200672316280271
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/extension_links_exist
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(4200240113971948)
,p_name=>'Extension Links Exist'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_extension_links',
' where security_group_id = :workspace_id',
'union all',
'select 1',
'  from wwv_extension_links el, wwv_extension_grants eg',
' where eg.security_group_id           = :workspace_id',
'   and eg.extension_security_group_id = el.security_group_id',
'   and el.is_public = ''Y'''))
,p_reference_id=>2801004939760399
,p_version_scn=>41671338
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/quicksql_ords_allowed
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(4806801565557841)
,p_name=>'QUICKSQL_ORDS_ALLOWED'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_qs_dev.is_minimum_version ',
'  and wwv_flow_authorization.is_authorized_developer(',
'    p_developer_authorization => ''EDIT'' );'))
,p_error_message=>'QuickSQL is not available. This is likely due to an insufficient version of ORDS. Minimum ORDS version required is 23.3.'
,p_version_scn=>75558103
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_sql_and_not_cloudy
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(7676404413799609)
,p_name=>'Flow: SQL and not cloudy'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_authorization.is_authorized_developer (',
'           p_developer_authorization => ''SQL'' ) ',
'       and not wwv_flow_global.g_cloud;',
''))
,p_error_message=>'This feature is not available.'
,p_reference_id=>786930698123107979
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/dashboard_access
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(10590808779171805)
,p_name=>'Dashboard access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'    wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''ADMIN''',
'    )',
'    or wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''EDIT''',
'    );'))
,p_error_message=>'You are not authorized to access Dashboards and Monitor Activity.'
,p_reference_id=>786936829326142579
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>'Used to control access to Dashboards and Monitor Activity under Administration. Developers will have access when Builder is enabled, while Admins will always have access. Prompted by Bug 13859631.'
);
end;
/
prompt --application/shared_components/security/authorizations/sso_authentication
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(11007909946539925)
,p_name=>'SSO authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication not in (''APEX'',''CLOUD_IDM'',''LDAP'',''DB'');'
,p_error_message=>'Builder SSO is not enabled'
,p_reference_id=>6738410669854771
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This authorization scheme checks whether the builder authentication can be used for single sign-on to workspaces. This includes SSO, header-based and LDAP authentication, but not',
'',
'  - APEX: login requires a workspace name',
'  - CLOUD_IDM: external login to IDM, but switching workspaces is not allowed, since the login is for a single tenant only'))
);
end;
/
prompt --application/shared_components/security/authorizations/sql_developer_web_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(11403377390021811)
,p_name=>'SQL Developer Web enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_listener.sql_developer_web_enabled;',
'end;'))
,p_error_message=>'SQL Developer Web link is not enabled for this instance.'
,p_reference_id=>11401467991562895
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sql_scripts_supported
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(11650706329157488)
,p_name=>'SQL_SCRIPTS Supported'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return true;'
,p_error_message=>'SQL Script functionality is not supported in this configuration.'
,p_reference_id=>786931734190107980
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sql_scripts_not_supported
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(11800412655616562)
,p_name=>'SQL_SCRIPTS NOT Supported'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return false;'
,p_error_message=>'DDL view in line is not supported.'
,p_reference_id=>786931461585107980
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(12506407035221692)
,p_name=>'Flow: EDIT'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'You are not authorized to edit applications'
,p_reference_id=>12480509677812756
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(12520119493499631)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>'You are not authorized to administer applications'
,p_reference_id=>12511219858301010
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_sql
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(12524102140541924)
,p_name=>'Flow: SQL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'You are not authorized to use SQL Workshop'
,p_reference_id=>12523823826538734
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/ui_def_exists_for_object
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(20416908986150096)
,p_name=>'UI_DEF_EXISTS_FOR_OBJECT'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_id',
'  from wwv_flow_hnt_table_info',
' where schema     = :OBJECT_OWNER',
'   and table_name = :OBJECT_NAME'))
,p_error_message=>'Error.'
,p_reference_id=>786932671432107981
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_data_loader
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(46496411771574510)
,p_name=>'Flow: DATA_LOADER'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'DATA_LOADER'
,p_error_message=>'You are not authorized for data loader'
,p_reference_id=>786941042784190072
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit_or_sql
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(46619710624049700)
,p_name=>'Flow: EDIT or SQL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT:SQL'
,p_error_message=>'You are not authorized to edit applications or use SQL Workshop'
,p_reference_id=>46618038002026587
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(173297929258927869)
,p_name=>'APEX 5.0 Team development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>'Team development not enabled for this workspace'
,p_reference_id=>786516861027697723
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(178922732459641711)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786516029127697713
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(178925305824656679)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'You are not authorized to use SQL Workshop'
,p_reference_id=>786516265251697717
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/registered_dba_login_and_db_monitor_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(206059717799303330)
,p_name=>'REGISTERED_DBA_LOGIN and DB Monitor Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR''), ''N'') = ''N'' then',
'    wwv_flow_debug.trace(''ALLOW_DB_MONITOR disabled'');',
'    return false;',
'elsif :APP_PAGE_ALIAS=''DBA_LOGIN'' then',
'    if not wwv_flow_authorization.is_authorized_developer(''SQL'') then',
'        wwv_flow_debug.trace(''must have SQL privs on DBA_LOGIN page'');',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end if;',
'    ',
'if wwv_flow_security.user_is_dba (p_username => :DBA_USERNAME ) then',
'    return true;',
'end if;',
'',
':F4500_DBA_LOGIN := ''N'';',
'',
'wwv_flow_utilities.redirect_url (',
'    p_url => wwv_flow_utilities.prepare_url ( ''f?p=''||:APP_ID||'':DBA_LOGIN:''||:SESSION||'':''||:APP_ID||'',''||:APP_PAGE_ID||'':''||:DEBUG ) );',
'',
'return true;'))
,p_error_message=>'DBA pages are disabled.'
,p_version_scn=>1949778306
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/db_10_2_or_higher
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(239225402734254498)
,p_name=>'db 10.2 or higher'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'   from sys.dba_objects',
' where object_name = ''SYS_PLSQL_SQL_INJECT_TAB''',
' and owner = ''SYS'''))
,p_error_message=>'SQL Injection analysis is not supported with your current database version or configuration. It is only available for Oracle release 10.2 or higher with SQL Injection packages installed.'
,p_reference_id=>786933222298107982
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
'( select to_number(substr(banner,instr(substr(banner,0,l.p),'' '',-1)+1,',
'                    l.p-instr(substr(banner,0,l.p),'' '',-1)+1)) version',
'from v$version,',
'  ( select instr(banner,''.'') p',
'         from v$version',
'         where banner like ''Oracle%''  ) l',
'  where banner like ''Oracle%''  )',
'where version >= 10.2'))
);
end;
/
prompt --application/shared_components/security/authorizations/db_10_1_or_higher
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(240648913515910366)
,p_name=>'db 10.1 or higher'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>'select 1 from sys.dual'
,p_error_message=>'Your database must be release 10.1 for this feature to be supported.'
,p_reference_id=>786932968525107981
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>'for release 2.0, used to protect Recycle Bin'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(802775228359756685)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786519856057734816
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/service_requests_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(916236223411830688)
,p_name=>'Service Requests Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'' then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>'No privilege for attempted operation.'
,p_reference_id=>786932326296107981
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(767165102345220885)
,p_icon_sequence=>10
,p_icon_subtext=>'Workspace &COMPANY.'
,p_icon_target=>'#'
,p_icon_image_alt=>'Workspace &COMPANY.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(331786907421617643)
,p_icon_sequence=>20
,p_icon_subtext=>'( <span style="text-decoration:underline;">Switch Workspace</span> )'
,p_icon_target=>'f?p=4550:20'
,p_icon_image_alt=>'Switch Workspace'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_security_scheme=>wwv_flow_imp.id(11007909946539925)
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(160707630779049420)
,p_icon_sequence=>30
,p_icon_image=>'Logout'
,p_icon_subtext=>'( <span style="text-decoration:underline;">Logout</span> )'
,p_icon_target=>'&LOGOUT_URL.'
,p_icon_image_alt=>'Logout'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
end;
/
prompt --application/shared_components/logic/application_processes/load_prism_js_file
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(8010001659675724)
,p_process_sequence=>1
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Prism JS file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_javascript.add_3rd_party_library_file( ',
'    p_library => wwv_flow_cdn.c_library_prismjs,',
'    p_attributes => ''data-manual'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'2000,2010,2016,2022,2025,2027,2030,2035,2040,2055,2061,2065,2070'
,p_process_when_type=>'CURRENT_PAGE_IN_CONDITION'
,p_process_comment=>'Loads Prism JS file for highlighting syntax. This is used in "Object Browser > Create Object Wizard" pages. Please refer server side condition for list of pages.'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_poststate
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(1504518033640244)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_postState'
,p_process_sql_clob=>':P1002_OWNER := :APP_USER;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 10-JAN-2005 17:03:31'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_rendertable
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(1916013849479713)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_renderTable'
,p_process_sql_clob=>'wwv_flow_query_builder.renderTableV2(:P1002_ID,:P1002_COUNT);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 11-JAN-2005 09:16:46'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/ajax_set_ui_mode
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(2609556949513377)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ajax_set_ui_mode'
,p_process_sql_clob=>'wwv_flow_4000_ui.ajax_set_ui_mode;'
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
,p_version_scn=>7800143
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_object_feed
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(3934212967688584)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_object_feed'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_object_feed.getmoreObjects(',
'p_type    =>'';TABLE;VIEW'',',
'p_owner   =>:P1002_SCHEMA,',
'p_display =>''DIV'',',
'p_session   =>:SESSION,',
'p_onclick =>:P1002_ONCLICK,',
'p_Start   =>1,',
'p_stop    =>50000,',
'p_class   =>''ob_Object'');',
'wwv_flow.debug(''End'');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 13-JAN-2005 19:11:46'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_posthistory
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(6231903825594156)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_posthistory'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_buffer varchar2(32767) := null;',
'  l_amount number;',
'  l_offset number;',
'begin',
'  for c1 in (select command',
'             from wwv_flow_sw_sql_cmds',
'             where id = :P1201_HISTORY_ID',
'             and security_group_id = :flow_security_group_id)',
'  loop',
'      if c1.command is not null and sys.dbms_lob.getlength( c1.command ) > 0 then',
'          l_amount := 8000;',
'          l_offset := 1;',
'          begin',
'              loop',
'                  sys.dbms_lob.read( c1.command, l_amount, l_offset, l_buffer );',
'                  sys.htp.prn( l_buffer );',
'                  l_offset := l_offset + l_amount;',
'                  l_amount := 8000;',
'              end loop;',
'          exception',
'              when others then',
'                  null;',
'          end;',
'      end if;    ',
'      exit;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get history.'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 18-JAN-2005 12:49:22'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_postsavedsql
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(7139200190149482)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_postSavedSQL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_buffer varchar2(32767) := null;',
'  l_amount number;',
'  l_offset number;',
'begin',
'  for c1 in (select qb_sql, id, title, description',
'               from wwv_flow_qb_saved_query',
'              where id = :P1003_QUERY_ID',
'                and security_group_id = :flow_security_group_id)',
'',
'  loop',
'      :P1003_QUERY_ID := c1.id;',
'      :P1003_SAVE_NAME := c1.title;',
'      :P1003_SAVE_DESC := c1.description;',
'      if c1.qb_sql is not null and sys.dbms_lob.getlength( c1.qb_sql ) > 0 then',
'          l_amount := 8000;',
'          l_offset := 1;',
'          begin',
'              loop',
'                  sys.dbms_lob.read( c1.qb_sql, l_amount, l_offset, l_buffer );',
'                  sys.htp.prn( l_buffer );',
'                  l_offset := l_offset + l_amount;',
'                  l_amount := 8000;',
'              end loop;',
'          exception',
'              when others then',
'                  null;',
'          end;',
'      end if;    ',
'      exit;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get saved SQL.'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 19-JAN-2005 12:35:15'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_get_saved_query
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(7276531262852173)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_get_saved_query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.owa_util.mime_header(''text/javascript'', FALSE );',
'sys.htp.p(''Cache-Control: no-cache'');',
'sys.htp.p(''Pragma: no-cache'');',
'sys.owa_util.http_header_close;',
'sys.htp.p(''var fUser ="''||:APP_USER||''";'');',
'wwv_flow_query_builder.loadQuery;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 19-JAN-2005 17:19:02'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/ob_get_object_feed
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(11551302098165190)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'OB_GET_OBJECT_FEED'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_object_feed.getmoreObjects(',
'p_type    =>:P2001_FEED_TYPE,',
'p_owner   =>:P2001_FEED_OWNER,',
'p_Start   =>:P2001_FEED_START,',
'p_stop    =>:P2001_FEED_STOP,',
'p_display =>:P2001_FEED_DISPLAY,',
'p_session   =>:SESSION,',
'p_include =>:P2001_FEED_INCLUDE,',
'p_onclick =>:P2001_FEED_ONCLICK,',
'p_class  =>:P2001_FEED_CLASS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'DO_NOT_TRANSLATE'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'This is for the Object Browser please do not change'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_getbind
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(21627908860597925)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_getBind'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_new_binds varchar2(32700);',
'l_old_binds varchar2(32700);',
'begin',
'  l_new_binds := wwv_flow_sw_api.get_binds(',
'                     p_stmt     => :P1003_SQL_COMMAND2,',
'                     p_language => :P1003_CMD_LANGUAGE );',
'  l_old_binds := v(''P1200_BINDS''); ',
'',
'  if (l_new_binds is null) then',
'    return;',
'  else',
'    sys.htp.p(''l_new_binds ''||l_new_binds);',
'  end if;',
'  if l_new_binds = l_old_binds then ',
'    return;',
'  else',
'    wwv_flow.update_cache_with_write (',
'      p_name   => ''P1200_BINDS'',',
'      p_value  => l_new_binds );',
'    wwv_flow.update_cache_with_write (',
'      p_name   => ''P1200_BIND_VALS'',',
'      p_value  => '''');',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get binds'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 14-FEB-2005 19:57:28'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_buildsql
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(22896611795429544)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_buildSql'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- used by sc_core.js/sc_getSQL',
'declare ',
'  i number := 0;',
'  l_owner  varchar2(128) := wwv_flow_sw_api.valid_workspace_schema(v(''P139_OWNER''));',
'  l_object varchar2(128) := v(''P139_OBJECT'');',
'begin',
'  sys.htp.p(l_owner||''.''||l_object||'' ('');',
'  for c in ( select argument_name',
'               from sys.dba_arguments',
'              where owner = l_owner',
'                and (package_name||''.''||object_name = l_object',
'                     or object_name = l_object)',
'                and argument_name is not null',
'                and data_level = 0',
'                and nvl(overload,1) = 1',
'              order by position )',
'  loop',
'    if (i < 1) then',
'      sys.htp.p(c.argument_name ||'' => '');',
'      i := i+1;',
'    else',
'      sys.htp.p('',''||c.argument_name ||'' => '');',
'    end if;',
'  end loop;',
'  sys.htp.p('')'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 15-FEB-2005 20:29:24'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_parsing
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(28056921387126354)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_parsing'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_status varchar2(255) := null;',
'begin',
'  wwv_flow_sw_parser.parse_file(p_file_id => :P1023_FILE_ID);',
'  if wwv_flow_sw_script.invalid_script(p_file_id => :P1023_FILE_ID) = 1 then',
'    l_status := ''FAILURE'';',
'  else',
'    l_status := ''SUCCESS'';',
'  end if;',
'  sys.htp.p(l_status);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to parse the script.'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 21-FEB-2005 15:36:28'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/returnnothing
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(77984007292719402)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ReturnNothing'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_save_script
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(106683007949808585)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_save_script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'           from htmldb_collections',
'           where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'    wwv_flow_sw_script.update_script_file (',
'     p_file_id     => c1.file_id,',
'     p_script_name => c1.name,',
'     p_script      => c1.script);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to update script.'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 23-FEB-2005 15:37:51'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_create_script
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(108492501270666096)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_create_script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'             from htmldb_collections',
'             where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'    wwv_flow_sw_script.create_script_from_clob (        ',
'     p_script_name => c1.name,',
'     p_script      => c1.script);   ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create script.'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 25-FEB-2005 10:54:13'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_dup_name
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(112585108113201529)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_dup_name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_cnt          number := 0;  ',
'  l_current_id   number := null;',
'  l_new_filename varchar2(4000) := null;',
'  l_old_filename varchar2(4000) := null;',
'  l_existing_id  number := null;',
'  l_created_by   varchar2(255) := null;',
'  ',
'  l_flag         varchar2(255) := null;',
'begin',
'  l_new_filename := lower(v(''P60_SCRIPT_NAME''));',
'  l_old_filename := lower(v(''P60_OLD_SCRIPT_NAME''));',
'  l_current_id := v(''P60_FILE_ID'');',
'	',
'  if l_new_filename = nvl(l_old_filename,'''') then',
'     l_flag := ''SUCCESS'';	   ',
'  else',
'     for c1 in (select id, created_by',
'                from wwv_flow_files',
'                where lower(filename) = l_new_filename)',
'     loop',
'       l_cnt := l_cnt + 1;    ',
'       l_existing_id := c1.id;',
'       l_created_by := c1.created_by;',
'       exit;    ',
'     end loop;',
'     if l_cnt > 0 then',
'       if l_existing_id = nvl(l_current_id,0) then',
'         l_flag := ''SAVE_NEW'';',
'       else       	 ',
'         l_flag := ''FAIL'';',
'       end if;',
'       if upper(l_created_by) != upper(v(''APP_USER'')) then    	 ',
'           l_flag := ''FAIL_RENAME'';         ',
'       end if;       ',
'     else',
'     	l_flag := ''SAVE_NEW'';',
'     end if;',
'  end if;',
'  sys.htp.p(l_flag);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get duplicate script name.'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 03-MAR-2005 22:12:36'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_create_job
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(136604317027747819)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_create_job'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1003_JOBID := wwv_flow_sc_transactions.sc_create_job(:P1003_LANGUAGE);',
':P1003_AUTOCOMMIT := ''Y'';'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create job '
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 15-MAR-2005 19:03:39'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_remove_job
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(136605514734756665)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_remove_job'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_tid number ;',
'begin',
'  l_tid := wwv_flow_sc_transactions.add_trans(:SESSION, :FLOW_USER, ',
'                :P1003_SCHEMA,''STOP'', 0, '''', ''exit'');',
'  :P1003_JOBID := '''';',
' :P1003_AUTOCOMMIT := '''';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to remove job'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 15-MAR-2005 19:05:07'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_read_out
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(137030824141880927)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_read_out'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_out   clob;',
'  l_tid   number;',
'  lob_length     integer;',
'  read_amount    integer;',
'  read_offset    integer := 1;',
'  buffer         varchar2(32700);',
'begin',
'   l_tid := v(''P1200_STMT'');',
'   select transaction_result into l_out ',
'    from wwv_flow_sc_trans ',
'    where session_id = (select nv(''SESSION'') x from sys.dual)',
'    and transaction_id = l_tid;',
'   if (length(l_out) > 0) then',
'     lob_length := length(l_out);',
'     while (lob_length > 0) loop',
'       if (lob_length > 32000) then',
'         read_amount := 32000;',
'       else ',
'         read_amount := lob_length;',
'       end if;',
'       sys.dbms_lob.read(l_out,read_amount,read_offset,buffer);',
'       sys.htp.p(wwv_flow_escape.noop(buffer));',
'       read_offset := read_offset+read_amount;',
'       lob_length := lob_length-read_amount;',
'     end loop;',
'   else',
'     sys.htp.p(''HTMLDB:NONE'');',
'   end if;',
'',
'exception when others then',
' sys.htp.p(''HTMLDB:NONE ERROR ''||wwv_flow_escape.html(SQLERRM));',
' sys.htp.p(''HTMLDB:NONE ERROR ''||wwv_flow_escape.html(SQLERRM));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to read output'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 16-MAR-2005 09:19:10'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/sr_replace_script
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(138449522524133557)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sr_replace_script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'             from htmldb_collections',
'             where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'      for c2 in (select id',
'                 from wwv_flow_files',
'                 where lower(filename) = lower(c1.name)',
'                 and file_type = ''SCRIPT'')',
'      loop',
'          l_file_id := c2.id;',
'          exit;',
'      end loop; ',
'      if l_file_id is not null then          	',
'        wwv_flow_sw_script.update_script_file (',
'         p_file_id     => l_file_id,',
'         p_script_name => c1.name,',
'         p_script      => c1.script);',
'      end if;',
'  end loop;',
'end;  '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to replace script.'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 17-MAR-2005 16:34:36'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_read_dbms
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(140873708217846868)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_read_dbms'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_out   clob;',
'  l_tid   number;',
'begin',
'   l_tid := v(''P1200_STMT'');',
'   select transaction_output into l_out from wwv_flow_sc_trans ',
'   where session_id = :SESSION and transaction_id = l_tid;',
'   if length(l_out) > 0 then',
'     sys.htp.p(wwv_flow_escape.noop(l_out));',
'   else',
'     sys.htp.p(''HTMLDB:NONE'');',
'   end if;',
'exception when others then',
' sys.htp.p(''HTMLDB:NONE'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to read output'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 21-MAR-2005 17:00:09'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_sql_trans
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(141051327945527301)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_sql_trans'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_tid number;',
'begin',
'l_tid := wwv_flow_sc_transactions.add_trans (',
'    p_session => :SESSION,',
'    p_user    => :FLOW_USER,',
'    p_schema  => wwv_flow_sw_api.valid_workspace_schema(:P1003_SCHEMA),',
'    p_type    => :P1200_TYPE,',
'    p_rows    => :P1003_ROWS,',
'    p_binds   => :P1200_BIND_VALS,',
'    p_sql     => wwv_flow_sw_api.to_sql_command(wwv_flow.g_f01) );',
'sys.htp.prn(l_tid);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to load SQL trans'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 21-MAR-2005 21:40:14'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/sc_savequery
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(158194723674245313)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sc_saveQuery'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.sc_savequery (',
'    p_name     => :P1003_SAVE_NAME,',
'    p_desc     => :P1003_SAVE_DESC,',
'    p_query_id => :P1003_QUERY_ID,',
'    p_schema   => :P1003_SCHEMA,',
'    p_sql_command => :P1003_SQL_COMMAND2 );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save Query'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 04-APR-2005 16:26:34'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/check_avail_jobs
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(192446004690296352)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check_avail_jobs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_jobs number;',
'begin',
'  select value-(select count(*) from sys.dba_jobs) into l_jobs  ',
'  from v$parameter ',
'  where name = ''job_queue_processes'';',
'  sys.htp.prn(l_jobs);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get job status'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 10-MAY-2005 16:28:24'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/spotlightindex
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(233722337928545821)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'spotlightIndex'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_spotlight_dev.emit_spotlight_search_index(',
'    p_app_id          => wwv_flow.g_x01,',
'    p_advanced_search => wwv_flow.g_x02);'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
,p_version_scn=>36494215
);
end;
/
prompt --application/shared_components/logic/application_processes/check_job_queue
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(251183224917806135)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check_job_queue'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_jobs number;',
'begin',
'  select value into l_jobs  ',
'  from v$parameter ',
'  where name = ''job_queue_processes'';',
'  sys.htp.prn(l_jobs);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to check jobs'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 23-MAY-2005 11:26:42'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/get_message
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(251509908846066406)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get_message'
,p_process_sql_clob=>'sys.htp.p(wwv_flow_lang.system_message(:SYSTEM_MESSAGE));'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to get message.'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
,p_process_comment=>'created 23-MAY-2005 12:10:05'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_processes/qb_check_unique
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(266120031373725934)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'qb_check_unique'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_counter number;',
'begin',
'',
'  select count(*) into l_counter ',
'  from wwv_flow_qb_saved_query ',
'  where title = v(''P1002_QUERY_NAME'') ',
'   and created_by = v(''FLOW_USER'')',
'   and security_group_id = wwv_flow_security.g_security_group_id;',
'',
'  if (l_counter > 0) then',
'   sys.htp.p(''<div class="htmldbNotification"><ul><li>'');',
'   sys.htp.p(wwv_flow_lang.system_message(''QB_DUPLICATE_QUERY''));',
'   sys.htp.p(''</li></ul></div>'');',
'  else',
'    sys.htp.prn(''0'');',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to validate save'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
,p_process_comment=>'created 20-JUN-2005 14:13:20'
,p_version_scn=>37165770887418
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(5086354147)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/current_object_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(63888631031213062)
,p_name=>'CURRENT_OBJECT_ID'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/datagen_schema
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2301647445959345)
,p_name=>'DATAGEN_SCHEMA'
,p_protection_level=>'I'
,p_item_comment=>'Stores the schema used by the data generator UI'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/dba_username
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(25966015567654518)
,p_name=>'DBA_USERNAME'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4500_dba_login
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(206052124417257915)
,p_name=>'F4500_DBA_LOGIN'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4500_last_view
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(48602367732370754)
,p_name=>'F4500_LAST_VIEW'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4500_p502_object_type
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(240551529397730482)
,p_name=>'F4500_P502_OBJECT_TYPE'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(22437001853024837)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by Custom2 authentication for deep linking support'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/g_ctrl_file_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(34319320571482284)
,p_name=>'G_CTRL_FILE_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/g_user_default_date_format
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(367331519540068469)
,p_name=>'G_USER_DEFAULT_DATE_FORMAT'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/last_selected_parse_as
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(101416805412462518)
,p_name=>'LAST_SELECTED_PARSE_AS'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This is used to support public synonyms.  Supporting public synonym is on hold until R2.'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/last_step
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(48607820040821755)
,p_name=>'LAST_STEP'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/object_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(12255104688621266)
,p_name=>'OBJECT_ID'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/object_locker
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(12255530314628639)
,p_name=>'OBJECT_LOCKER'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/object_name
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(12255902395630078)
,p_name=>'OBJECT_NAME'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/object_owner
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(12256308628631835)
,p_name=>'OBJECT_OWNER'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/object_type
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(12258200626676850)
,p_name=>'OBJECT_TYPE'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/ob_object_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(171514813299244598)
,p_name=>'OB_OBJECT_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/success_msg
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(106656207167489750)
,p_name=>'SUCCESS_MSG'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This application item is used to display success message for certain SQL Workshop regions. (Used from SQL Command Processor page 3 and page 1)'
,p_version_scn=>37165770887406
);
end;
/
prompt --application/shared_components/logic/application_items/system_message
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(251508117719059591)
,p_name=>'SYSTEM_MESSAGE'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Message displayed while running commands in SQL Commands. Message is retrieved using on-demand process "get_message".'
,p_version_scn=>37165770887406
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(5088358914)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Unable to compute workspace name.'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/datagen_schema
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(2304233968021720)
,p_computation_sequence=>10
,p_computation_item=>'DATAGEN_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'upper(wwv_flow_user_api.get_default_schema)'
,p_compute_when=>':DATAGEN_SCHEMA is null and :APP_PAGE_ID between 4000 and 4200'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/g_user_default_date_format
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(367332002718076269)
,p_computation_sequence=>10
,p_computation_item=>'G_USER_DEFAULT_DATE_FORMAT'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_date_format varchar2(255);',
'begin',
'    for c1 in (select default_date_format',
'                 from wwv_flow_fnd_user',
'                where user_name = :APP_USER',
'                  and security_group_id = :flow_security_group_id',
'                  and trim(default_date_format) is not null) loop',
'        return c1.default_date_format;',
'        exit;',
'    end loop;',
'    --',
'    return :DATE_FORMAT;',
'end;'))
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/accessibility_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(582053521006435152)
,p_lov_name=>'ACCESSIBILITY_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(582053521006435152)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558105
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(582053811202435157)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Screen Reader'
,p_lov_return_value=>'SCREEN_READER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/access_restrictions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(21837016666086569)
,p_lov_name=>'ACCESS_RESTRICTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(21837016666086569)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21837217288086572)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Available only from local server'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21837410790086575)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Available from local server and remote clients'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/active_inactive
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(133833120564560201)
,p_lov_name=>'ACTIVE INACTIVE'
,p_lov_query=>'.'||wwv_flow_imp.id(133833120564560201)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(133833301814560204)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Active'
,p_lov_return_value=>'ACTIVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(133833501889560209)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Inactive'
,p_lov_return_value=>'INACTIVE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/alignment_left_right
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(40606619495197864)
,p_lov_name=>'ALIGNMENT LEFT RIGHT'
,p_lov_query=>'.'||wwv_flow_imp.id(40606619495197864)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40606830354197883)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Left'
,p_lov_return_value=>'L'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40607009987197887)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Right'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/all_or_varchar2_column_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88068725864843110)
,p_lov_name=>'ALL.OR.VARCHAR2.COLUMN.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(88068725864843110)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88068924929843115)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Column Types'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88069124491843115)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'VARCHAR Column Types'
,p_lov_return_value=>'0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/all_selected_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88062000322816814)
,p_lov_name=>'ALL.SELECTED.COLS'
,p_lov_query=>'.'||wwv_flow_imp.id(88062000322816814)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88062216112816814)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Columns'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88062421264816815)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Selected Columns'
,p_lov_return_value=>'SELECTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_dictionary_query_conditions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(14480503854514923)
,p_lov_name=>'APEX DICTIONARY QUERY CONDITIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(14480503854514923)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14480728931514923)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'='
,p_lov_return_value=>'='
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14480909767514923)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'!='
,p_lov_return_value=>'!='
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14481110010514923)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'LIKE'
,p_lov_return_value=>'LIKE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14493818099547338)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'NOT LIKE'
,p_lov_return_value=>'NOT LIKE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14482210780516882)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'>'
,p_lov_return_value=>'>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14482613551517732)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'<'
,p_lov_return_value=>'<'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14608723770258677)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'BETWEEN'
,p_lov_return_value=>'BETWEEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14609025848259268)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'IS'
,p_lov_return_value=>'IS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_dictionary_view_modes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(14392800214125907)
,p_lov_name=>'APEX DICTIONARY VIEW MODES'
,p_lov_query=>'.'||wwv_flow_imp.id(14392800214125907)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14393015881125907)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Icons'
,p_lov_return_value=>'ICONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14393201164125907)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Tree'
,p_lov_return_value=>'TREE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14393419313125907)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'REPORT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_view_names
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(14454808001440421)
,p_lov_name=>'APEX VIEW NAMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct apex_view_name d,',
'       apex_view_name r',
' from apex_dictionary ',
'where column_id=0',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558107
);
end;
/
prompt --application/shared_components/user_interface/lovs/asc_desc_returns_asc_desc
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88023114905423598)
,p_lov_name=>'ASC.DESC.RETURNS.ASC.DESC'
,p_lov_query=>'.'||wwv_flow_imp.id(88023114905423598)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88023312120423599)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ascending'
,p_lov_return_value=>'ASC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88023515635423599)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Descending'
,p_lov_return_value=>'DESC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ascdesc
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23484408692637977)
,p_lov_name=>'ASCDESC'
,p_lov_query=>'.'||wwv_flow_imp.id(23484408692637977)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23484707046637977)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ascending'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23484911662637978)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Descending'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/before_or_after
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(10601629460223677)
,p_lov_name=>'BEFORE_OR_AFTER'
,p_lov_query=>'.'||wwv_flow_imp.id(10601629460223677)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10601955947223700)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Before'
,p_lov_return_value=>'before'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10602352125223701)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'After'
,p_lov_return_value=>'after'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cascade_checkbox
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6527926084636289)
,p_lov_name=>'CASCADE CHECKBOX'
,p_lov_query=>'.'||wwv_flow_imp.id(6527926084636289)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6528129949636292)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp'
,p_lov_return_value=>'CASCADE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cascade_constraints
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88063516252821367)
,p_lov_name=>'CASCADE.CONSTRAINTS'
,p_lov_query=>'.'||wwv_flow_imp.id(88063516252821367)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88063706191821368)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Cascade Constraints?'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/case_sensitive_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88013722767293437)
,p_lov_name=>'CASE.SENSITIVE.Y'
,p_lov_query=>'.'||wwv_flow_imp.id(88013722767293437)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88013930765293438)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Case Sensitive'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/constraint_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8657002398372817)
,p_lov_name=>'CONSTRAINT TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(8657002398372817)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8657206568372817)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Check'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8657415834372818)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Primary Key'
,p_lov_return_value=>'P'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8657606976372818)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Unique'
,p_lov_return_value=>'U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8657818917372818)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Referential'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/constraint_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(11518010813871302)
,p_lov_name=>'CONSTRAINT.STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(11518010813871302)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11518205871871344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'ENABLED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11518415817871364)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'DISABLED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11518621543871364)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'All'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/constraint_types_002
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88046920202557653)
,p_lov_name=>'CONSTRAINT.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(88046920202557653)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88047118047557654)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Check'
,p_lov_return_value=>'CHECK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88047308153557654)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Foreign Key'
,p_lov_return_value=>'FK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88047511353557655)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Primary Key'
,p_lov_return_value=>'PK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88047724693557655)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Unique'
,p_lov_return_value=>'UNIQUE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/contraint_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(270341627024745223)
,p_lov_name=>'CONTRAINT TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(270341627024745223)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(270341802062745225)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Check'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(270342021056745226)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unique'
,p_lov_return_value=>'U'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_index_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16028009107759017)
,p_lov_name=>'CREATE INDEX TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(16028009107759017)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16028212649759018)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16028407362759020)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1800436823219905)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Spatial'
,p_lov_return_value=>'S'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_db_version.c_has_locator'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_user_privileges
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(164684400772980444)
,p_lov_name=>'CREATE USER PRIVILEGES'
,p_lov_query=>'.'||wwv_flow_imp.id(164684400772980444)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164684601746980447)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'CONNECT'
,p_lov_return_value=>'CONNECT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164684816646980450)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'RESOURCE'
,p_lov_return_value=>'RESOURCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164685019181980451)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'DBA'
,p_lov_return_value=>'DBA'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_mle_module_javascript_how
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3091085801966871)
,p_lov_name=>'CREATE.MLE_MODULE_JAVASCRIPT.HOW'
,p_lov_query=>'.'||wwv_flow_imp.id(3091085801966871)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3091335489967017)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Upload File'
,p_lov_return_value=>'FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3091744026967018)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Source Code'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2629444467250033)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_package_how
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88084232331986937)
,p_lov_name=>'CREATE.PACKAGE.HOW'
,p_lov_query=>'.'||wwv_flow_imp.id(88084232331986937)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88084409721986937)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Build a package from scratch'
,p_lov_return_value=>'SCRATCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88084631917986937)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Build a package with methods on database table(s)'
,p_lov_return_value=>'TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_table_how
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88092414548047979)
,p_lov_name=>'CREATE.TABLE.HOW'
,p_lov_query=>'.'||wwv_flow_imp.id(88092414548047979)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88092609025047979)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'From scratch'
,p_lov_return_value=>'SCRATCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88092810507047980)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'As a copy and paste from a spreadsheet (this will take you into the Data Workshop)'
,p_lov_return_value=>'SPREADSHEET'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_table_now_script
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88093424937050988)
,p_lov_name=>'CREATE.TABLE.NOW.SCRIPT'
,p_lov_query=>'.'||wwv_flow_imp.id(88093424937050988)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88093602555050989)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Create table now'
,p_lov_return_value=>'RUN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88093808384050989)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Create a script to edit SQL'
,p_lov_return_value=>'EDIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_table_fk_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(111182618715174982)
,p_lov_name=>'CREATE_TABLE_FK_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(111182618715174982)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(245703827624645868)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Disallow Delete'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(111183005880174986)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Cascade Delete'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(111182804604174985)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Set Null on Delete'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_csv_col_delimiter
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3927422505659936)
,p_lov_name=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov_query=>'.'||wwv_flow_imp.id(3927422505659936)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558107
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3927758348659940)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>','
,p_lov_return_value=>','
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3928144847659940)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>';'
,p_lov_return_value=>';'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3928530804659940)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'|'
,p_lov_return_value=>'|'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4182031389753526)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'#'
,p_lov_return_value=>'#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3928907085659940)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'tab'
,p_lov_return_value=>'tab'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_csv_enclosed_by
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3931221323686172)
,p_lov_name=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov_query=>'.'||wwv_flow_imp.id(3931221323686172)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4083926401630096)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'None'
,p_lov_return_value=>'None'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3931589877686177)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'"'
,p_lov_return_value=>'"'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3931843915686177)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>''''
,p_lov_return_value=>''''
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_data_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84321549291630718)
,p_lov_name=>'DATA.LOAD.DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84321549291630718)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84321869333630699)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84322205066630696)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84322661858630696)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84323012454630696)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'TIMESTAMP'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84323403277630695)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84323862951630695)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'TIMESTAMP WITH TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84324206688630695)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_first_line
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3934090607812623)
,p_lov_name=>'DATA.LOAD.FIRST_LINE'
,p_lov_query=>'.'||wwv_flow_imp.id(3934090607812623)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3934379444812623)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'First line contains headers'
,p_lov_return_value=>'HEADERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_force_sysguid
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(325824092198610958)
,p_lov_name=>'DATA.LOAD.FORCE_SYSGUID'
,p_lov_query=>'.'||wwv_flow_imp.id(325824092198610958)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(325824367791610958)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SYS_GUID'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(325824735376610959)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Identity Column'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_max_row_range
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3867907456164412)
,p_lov_name=>'DATA.LOAD.MAX_ROW_RANGE'
,p_lov_query=>'.'||wwv_flow_imp.id(3867907456164412)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3868668632164428)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3870258934164431)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3870691602164431)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3925900413184232)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'All Rows'
,p_lov_return_value=>'0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_source_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(212732804335774230)
,p_lov_name=>'DATA.LOAD.SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(212732804335774230)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558109
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(212733137832774240)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Upload a File'
,p_lov_return_value=>'FILE'
,p_lov_template=>'<span class="a-Icon icon-file-upload" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(212733551391774249)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Copy and Paste'
,p_lov_return_value=>'COPY_PASTE'
,p_lov_template=>'<span class="a-Icon icon-clipboard" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3891423527523942)
,p_lov_name=>'DATA.LOAD.STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(3891423527523942)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558109
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3891740585523942)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Running'
,p_lov_return_value=>'RUNNING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3892162613523943)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Finished'
,p_lov_return_value=>'FINISHED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3924280979996980)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Failed'
,p_lov_return_value=>'FAILED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_upload_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1643936135665207)
,p_lov_name=>'DATA.UPLOAD.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1643936135665207)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558109
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1644247579665210)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Upload a File'
,p_lov_return_value=>'FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1644613825665214)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Copy and Paste'
,p_lov_return_value=>'COPY_PASTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(21015224563508746)
,p_lov_name=>'DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(21015224563508746)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558109
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21015508059508749)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21015722350508750)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21015902475508751)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21016106513508751)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'TIMESTAMP'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21016525754508751)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21016725005508751)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'BLOB'
,p_lov_return_value=>'BLOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24123119765584645)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'BFILE'
,p_lov_return_value=>'BFILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21016327140508751)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'CHAR'
,p_lov_return_value=>'CHAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24128605267608850)
,p_lov_disp_sequence=>85
,p_lov_disp_value=>'FLOAT'
,p_lov_return_value=>'FLOAT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24122330370578271)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'INTERVAL YEAR TO MONTH'
,p_lov_return_value=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24122503489579932)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'INTERVAL DAY TO SECOND'
,p_lov_return_value=>'INTERVAL DAY TO SECOND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24121914440573626)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'TIMESTAMP WITH TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24122121020575524)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21019413051524343)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'BINARY_FLOAT'
,p_lov_return_value=>'BINARY_FLOAT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21019722401527136)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'BINARY_DOUBLE'
,p_lov_return_value=>'BINARY_DOUBLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24122707991581257)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'RAW'
,p_lov_return_value=>'RAW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24128400765607550)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'NCHAR'
,p_lov_return_value=>'NCHAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21016914224508752)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'NVARCHAR2'
,p_lov_return_value=>'NVARCHAR2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24138600492263086)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'NCLOB'
,p_lov_return_value=>'NCLOB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_session_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1225013363619314377)
,p_lov_name=>'DB SESSION STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(1225013363619314377)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558109
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1225013668008314381)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Current Session'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1225013946804314386)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Long Transaction'
,p_lov_return_value=>'L'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1225014259544314386)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Active Session'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1225014590119314386)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Idle Session'
,p_lov_return_value=>'I'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1225014814217314386)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Blocking Session'
,p_lov_return_value=>'B'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1225015134770314386)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Blocked Session'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_parm_non_default
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(244335514951659559)
,p_lov_name=>'DB_PARM_NON_DEFAULT'
,p_lov_query=>'.'||wwv_flow_imp.id(244335514951659559)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558109
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244335715591659561)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244335932066659565)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Non-Default'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ddl_actions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88039608166535203)
,p_lov_name=>'DDL.ACTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(88039608166535203)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558109
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88039800819535204)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Add Column'
,p_lov_return_value=>'ADD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88040002165535204)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Add Constraint'
,p_lov_return_value=>'ADD_CONSTRAINT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88040231651535205)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Analyze'
,p_lov_return_value=>'ANALYZE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88040417249535205)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Copy'
,p_lov_return_value=>'COPY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88040624827535205)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Create Index'
,p_lov_return_value=>'INDEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88040822124535205)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Create Text Index'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88041012331535206)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Create Trigger'
,p_lov_return_value=>'CREATE_TRIGGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88041229308535206)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Disable Constraint'
,p_lov_return_value=>'DISABLE_CONSTRAINT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88041400926535206)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Disable Trigger'
,p_lov_return_value=>'DISABLE_TRIGGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88041603607535208)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Drop Column'
,p_lov_return_value=>'REMOVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88041815176535208)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Drop Constraint'
,p_lov_return_value=>'DROP_CONSTRAINT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88042009088535208)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Drop Index'
,p_lov_return_value=>'DROP_INDEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88042226760535209)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Drop Table'
,p_lov_return_value=>'DROP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88042406323535209)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Drop Trigger'
,p_lov_return_value=>'DROP_TRIGGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88042607701535209)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Enable Constraint'
,p_lov_return_value=>'ENABLE_CONSTRAINT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88042803313535209)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Enable Trigger'
,p_lov_return_value=>'ENABLE_TRIGGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88043019072535210)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Modify Column'
,p_lov_return_value=>'MODIFY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88043204776535210)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Rename Column'
,p_lov_return_value=>'RENAME_COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88043422512535210)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Rename Table'
,p_lov_return_value=>'RENAME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88043603529535211)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Truncate'
,p_lov_return_value=>'TRUNCATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/describe_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(22153924949556802)
,p_lov_name=>'DESCRIBE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(22153924949556802)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558110
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22154111837556805)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'TABLE'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22517827091787523)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'VIEW'
,p_lov_return_value=>'VIEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22518130554788590)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'PROCEDURE'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22518404019790369)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'FUNCTION'
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22518909907792079)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'PACKAGE'
,p_lov_return_value=>'PACKAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_builtins_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2447835114213405)
,p_lov_name=>'DG_BUILTINS_OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(p_name => ''ODG.BUILTINS.'' || upper(friendly_name) ) d,',
'       friendly_name r,',
'       native_datatype d_type,',
'       wwv_flow_lang.system_message(p_name => ''ODG.BUILTINS.'' || upper( builtin_category ) ) b_cat',
'  from apex_dg_builtins'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'R'
,p_group_column_name=>'B_CAT'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'D'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75558110
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(14730280756101914)
,p_query_column_name=>'B_CAT'
,p_heading=>'Category'
,p_display_sequence=>10
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(14730501129101915)
,p_query_column_name=>'D'
,p_heading=>'Built In'
,p_display_sequence=>20
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(14730986839101916)
,p_query_column_name=>'D_TYPE'
,p_heading=>'Type'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(14731324215101916)
,p_query_column_name=>'R'
,p_display_sequence=>40
,p_data_type=>'VARCHAR2'
,p_is_visible=>'N'
,p_is_searchable=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_create_bp_from_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1691026444286284)
,p_lov_name=>'DG_CREATE_BP_FROM_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(1691026444286284)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558110
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1691380660286293)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Select from list'
,p_lov_return_value=>'SELECT'
,p_lov_template=>'<span class="a-Icon icon-item-native-select-list" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1691779030286294)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Copy and Paste'
,p_lov_return_value=>'COPY_PASTE'
,p_lov_template=>'<span class="a-Icon icon-clipboard" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_custom_data_sources
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3401014796445463)
,p_lov_name=>'DG_CUSTOM_DATA_SOURCES'
,p_lov_query=>'.'||wwv_flow_imp.id(3401014796445463)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558110
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3401363667445485)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3401708566445486)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_data_source_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1720919255102185)
,p_lov_name=>'DG_DATA_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(1720919255102185)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558110
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1721265182102185)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Data Source'
,p_lov_return_value=>'DATA_SOURCE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_data_sources',
' where blueprint_id = :P4004_BLUEPRINT_ID',
'   and security_group_id = :flow_security_group_id;'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1721632335102186)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Built In'
,p_lov_return_value=>'BUILTIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1722059389102186)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Blueprint'
,p_lov_return_value=>'BLUEPRINT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_dg_blueprint_tables t,',
'       wwv_dg_blueprints b',
' where ( :APP_PAGE_ID != ''4004''',
'         or ( b.id = t.blueprint_id',
'              and b.name = :P4004_BLUEPRINT_NAME',
'              and t.seq < :P4004_BLUEPRINT_TABLE_SEQ ) )',
'    and ( :APP_PAGE_ID != ''4100''',
'         or ( b.id = t.blueprint_id',
'              and b.name = :P4100_BLUEPRINT_NAME',
'              and t.seq < :P4100_BLUEPRINT_TABLE_SEQ ) )',
'    and b.security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1722449832102186)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Inline'
,p_lov_return_value=>'INLINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1722832097102186)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Sequence'
,p_lov_return_value=>'SEQUENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1723262358102186)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Formula'
,p_lov_return_value=>'FORMULA'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_file_output_formats
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1710780100785805)
,p_lov_name=>'DG_FILE_OUTPUT_FORMATS'
,p_lov_query=>'.'||wwv_flow_imp.id(1710780100785805)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558110
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1711001076785837)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'JavaScript Object Notation (JSON)'
,p_lov_return_value=>'PRETTY JSON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1711435829785838)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Comma Separated Values (CSV)'
,p_lov_return_value=>'CSV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1711802215785838)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SQL Insert'
,p_lov_return_value=>'SQL INSERT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_generated_data_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1701812462624498)
,p_lov_name=>'DG_GENERATED_DATA_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(1701812462624498)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558110
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1702122524624504)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'File Export'
,p_lov_return_value=>'FILE_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1702518857624504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Insert Into Database'
,p_lov_return_value=>'INSERT_INTO_DATABASE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_insert_data_methods
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2000148335668303)
,p_lov_name=>'DG_INSERT_DATA_METHODS'
,p_lov_query=>'.'||wwv_flow_imp.id(2000148335668303)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558110
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2001657267668307)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Insert Into'
,p_lov_return_value=>'INSERT INTO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2002079039668308)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Fast Insert Into'
,p_lov_return_value=>'FAST INSERT INTO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_languages
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1787978077426546)
,p_lov_name=>'DG_LANGUAGES'
,p_lov_query=>'.'||wwv_flow_imp.id(1787978077426546)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558110
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1788244153426552)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'English'
,p_lov_return_value=>'en'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1788676820426553)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'German'
,p_lov_return_value=>'de'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1789016778426553)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Spanish'
,p_lov_return_value=>'es'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_scaling_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1716336235087650)
,p_lov_name=>'DG_SCALING_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(1716336235087650)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558111
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1716607858087677)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'.25x'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1717093746087677)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'.5x'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1717482340087677)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'.75x'
,p_lov_return_value=>'75'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1717866167087678)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'1x'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1718239401087678)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'2x'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1718655207087678)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'3x'
,p_lov_return_value=>'300'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1719092203087678)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'5x'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1719419850087678)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'10x'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1719862820087679)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'20x'
,p_lov_return_value=>'2000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1720276552087679)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'50x'
,p_lov_return_value=>'5000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1720618018087679)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'100x'
,p_lov_return_value=>'10000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dg_source_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13808340560561616)
,p_lov_name=>'DG_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(13808340560561616)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558112
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13808619603561635)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13809059161561637)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_inline
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88029914736461415)
,p_lov_name=>'DISPLAY.INLINE'
,p_lov_query=>'.'||wwv_flow_imp.id(88029914736461415)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558112
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88030128904461415)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Display Inline'
,p_lov_return_value=>'DISPLAY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_as_reports
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(285136607862263925)
,p_lov_name=>'DISPLAY_AS_REPORTS'
,p_reference_id=>285506029323635827
,p_lov_query=>'.'||wwv_flow_imp.id(285136607862263925)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108084526445030643)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Report Column (display-only, does not save state)'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108084705562030643)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Display as Text (based on LOV, does not save state)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108084932477030643)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Display as Text (saves state)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108085112395030643)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Display as Text (escape special characters, does not save state)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108085330405030643)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Hidden '
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_as_tabular_forms
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(173321532130152965)
,p_lov_name=>'DISPLAY_AS_TABULAR_FORMS'
,p_lov_query=>'.'||wwv_flow_imp.id(173321532130152965)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558112
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108070909691016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Report Column (display-only, does not save state)'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108071103633016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display as Text (based on LOV, does not save state)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108071320755016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display as Text (saves state)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108071517893016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display as Text (escape special characters, does not save state)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108071726823016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Field'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108071926389016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Area'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108072101156016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Select List'
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108072319348016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hidden '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108072523666016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Popup LOV'
,p_lov_return_value=>'POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108072726301016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker'
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108072902041016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (use application format mask)'
,p_lov_return_value=>'PICK_DATE_USING_APP_FORMAT_MASK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108073114807016343)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108073320317016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108073505124016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108073706032016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH24_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108073911349016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108074115783016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108074322493016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108074521430016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108074730419016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108074911008016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108075100812016344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108075332696016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108075516430016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108075700209016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108075913799016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108076125223016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108076313464016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108076515529016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108076725453016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108076913772016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108077111031016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108077331467016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108077528710016345)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108077720268016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108077923098016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108078110678016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108078309308016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108078528637016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108078730750016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH24_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108078928693016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108079128762016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108079326218016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108079524994016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108079705480016346)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (use Application Date Format)'
,p_lov_return_value=>'PICK_DATE_USING_APP_DATE_FORMAT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_or_save
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88028228457455927)
,p_lov_name=>'DISPLAY_OR_SAVE'
,p_lov_query=>'.'||wwv_flow_imp.id(88028228457455927)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558113
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88028407997455927)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Display Inline'
,p_lov_return_value=>'DISPLAY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88028614614455928)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Save As Script File'
,p_lov_return_value=>'SCRIPT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/distinct_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(102422424410025075)
,p_lov_name=>'DISTINCT_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct :column_name',
'',
'from   :table_name',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558113
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_object_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(167453708814513863)
,p_lov_name=>'DYNAMIC OBJECT TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       object_type d,',
'       object_type r',
' from sys.dba_objects where owner = :F4500_P500_SCHEMA',
'union  select ''DATABASE LINK'' d,''DATABASE LINK'' r from sys.dual',
'union  select ''TABLE'' d,''TABLE'' r from sys.dual',
'union  select ''TRIGGER'' d,''TRIGGER'' r from sys.dual',
'union  select ''JAVA CLASS'' d,''JAVA CLASS'' r from sys.dual',
'union  select ''JAVA SOURCE'' d,''JAVA SOURCE'' r from sys.dual',
'union  select ''INDEX'' d,''INDEX'' r from sys.dual',
'union  select ''SEQUENCE'' d,''SEQUENCE'' r from sys.dual',
'union  select ''FUNCTION'' d,''FUNCTION'' r from sys.dual',
'union  select ''PROCEDURE'' d,''PROCEDURE'' r from sys.dual',
'union  select ''PACKAGE'' d,''PACKAGE'' r from sys.dual',
'union  select ''PACKAGE BODY'' d,''PACKAGE BODY'' r from sys.dual',
'union  select ''XML SCHEMA'' d,''XML SCHEMA'' r from sys.dual',
'union  select ''TYPE'' d,''TYPE'' r from sys.dual',
'union  select ''VIEW'' d,''VIEW'' r from sys.dual',
'union  select ''MATERIALIZED VIEW'' d,''MATERIALIZED VIEW'' r from sys.dual',
'union  select ''SYNONYM'' d,''SYNONYM'' r from sys.dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558113
);
end;
/
prompt --application/shared_components/user_interface/lovs/expire_password
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7461015136055036)
,p_lov_name=>'EXPIRE PASSWORD'
,p_lov_query=>'.'||wwv_flow_imp.id(7461015136055036)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558113
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7461210075055051)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'EXPIRE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/for_each_row
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88058923955804681)
,p_lov_name=>'FOR.EACH.ROW'
,p_lov_query=>'.'||wwv_flow_imp.id(88058923955804681)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558113
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88059109438804682)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'For Each Row'
,p_lov_return_value=>'for each row'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_from_4000
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(197481124765787930)
,p_lov_name=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_reference_id=>44798420131812391
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_no_since_from_4000
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(460129911419159358)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE (FROM 4000)'
,p_reference_id=>170713321121898589
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_number_from_4000
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(460130116613160765)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_NUMBER (FROM 4000)'
,p_reference_id=>441970320516445261
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''N''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_validation_data_type_from_4000
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(197595525878393704)
,p_lov_name=>'FORM_VALIDATION_DATA_TYPE (FROM 4000)'
,p_reference_id=>197490902498999083
,p_lov_query=>'.'||wwv_flow_imp.id(197595525878393704)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197596203845396779)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197596425687396780)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'VARCHAR'
,p_lov_return_value=>'VARCHAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_charset
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(143356515285702408)
,p_lov_name=>'I18N_IANA_CHARSET'
,p_reference_id=>144796827445692396
,p_lov_query=>'.'||wwv_flow_imp.id(143356515285702408)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9229220048925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic ISO-8859-6'
,p_lov_return_value=>'iso-8859-6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9229405581925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic Windows 1256'
,p_lov_return_value=>'windows-1256'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9229628588925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese Big5'
,p_lov_return_value=>'big5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9229827838925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese GBK'
,p_lov_return_value=>'gbk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9230014665925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic ISO-8859-5'
,p_lov_return_value=>'iso-8859-5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9230231223925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-R'
,p_lov_return_value=>'koi8-r'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9230421211925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-U'
,p_lov_return_value=>'koi8-u'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9230611952925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic Windows 1251'
,p_lov_return_value=>'windows-1251'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9230825878925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European ISO-8859-2'
,p_lov_return_value=>'iso-8859-2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9231020628925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European Windows 1250'
,p_lov_return_value=>'windows-1250'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9231210284925457)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek ISO-8859-7'
,p_lov_return_value=>'iso-8859-7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9231417884925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek Windows 1253'
,p_lov_return_value=>'windows-1253'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9231628287925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew ISO-8859-8-i'
,p_lov_return_value=>'iso-8859-8-i'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9231830514925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew Windows 1255'
,p_lov_return_value=>'windows-1255'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9232010444925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese EUC'
,p_lov_return_value=>'euc-jp'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9232217412925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese Shift JIS'
,p_lov_return_value=>'shift_jis'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9232432569925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Korean EUC'
,p_lov_return_value=>'euc-kr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9232618695925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European ISO-8859-4'
,p_lov_return_value=>'iso-8859-4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9232801800925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European Windows 1257'
,p_lov_return_value=>'windows-1257'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9233008729925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Southern European ISO-8859-3'
,p_lov_return_value=>'iso-8859-3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9233226333925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Thai TIS-620'
,p_lov_return_value=>'tis-620'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9233412235925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish ISO-8859-9'
,p_lov_return_value=>'iso-8859-9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9233629658925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish Windows 1254'
,p_lov_return_value=>'windows-1254'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9233803634925458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-8'
,p_lov_return_value=>'utf-8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9234002057925459)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Big Endian'
,p_lov_return_value=>'utf-16be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9234209685925459)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Little Endian'
,p_lov_return_value=>'utf-16le'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9234405813925459)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'us-ascii'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9234624781925459)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vietnamese Windows 1258'
,p_lov_return_value=>'windows-1258'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9234826068925459)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European ISO-8859-1'
,p_lov_return_value=>'iso-8859-1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9235025977925459)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European Windows 1252'
,p_lov_return_value=>'windows-1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_db_charset
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(143362112016702427)
,p_lov_name=>'I18N_IANA_DB_CHARSET'
,p_reference_id=>144802427115692411
,p_lov_query=>'.'||wwv_flow_imp.id(143362112016702427)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9197525868826969)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic ISO-8859-6'
,p_lov_return_value=>'AR8ISO8859P6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9197719499826969)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Arabic Windows 1256'
,p_lov_return_value=>'AR8MSWIN1256'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9197926602826969)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Chinese Big5'
,p_lov_return_value=>'ZHT16MSWIN950'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9198108871826969)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Chinese GBK'
,p_lov_return_value=>'ZHS16GBK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9198314327826969)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Cyrilic ISO-8859-5'
,p_lov_return_value=>'CL8ISO8859P5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9198509701826969)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Cyrilic KOI8-R'
,p_lov_return_value=>'CL8KOI8R'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9198725529826969)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Cyrilic KOI8-U'
,p_lov_return_value=>'CL8KOI8U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9198913491826970)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Cyrilic Windows 1251'
,p_lov_return_value=>'CL8MSWIN1251'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9199128797826970)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Eastern European ISO-8859-2'
,p_lov_return_value=>'EE8ISO8859P2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9199323295826970)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Eastern European Windows 1250'
,p_lov_return_value=>'EE8MSWIN1250'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9199525603826970)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Greek ISO-8859-7'
,p_lov_return_value=>'EL8ISO8859P7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9199710618826970)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Greek Windows 1253'
,p_lov_return_value=>'EL8MSWIN1253'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9199917873826970)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Hebrew ISO-8859-8-i'
,p_lov_return_value=>'IW8ISO8859P8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9200124476826971)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Hebrew Windows 1255'
,p_lov_return_value=>'IW8MSWIN1255'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9200304639826971)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Japanese EUC'
,p_lov_return_value=>'JA16EUC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9200514410826971)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Japanese Shift JIS'
,p_lov_return_value=>'JA16SJIS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9200704239826971)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Korean EUC'
,p_lov_return_value=>'KO16MSWIN949'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9200903786826971)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Northern European ISO-8859-4'
,p_lov_return_value=>'NEE8ISO8859P4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9201130515826971)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Northern European Windows 1257'
,p_lov_return_value=>'BLT8MSWIN1257'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9201303279826971)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Southern European ISO-8859-3'
,p_lov_return_value=>'SE8ISO8859P3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9201518062826971)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'Thai TIS-620'
,p_lov_return_value=>'TH8TISASCII'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9201729626826971)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Turkish ISO-8859-9'
,p_lov_return_value=>'WE8ISO8859P9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9201928057826971)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Turkish Windows 1254'
,p_lov_return_value=>'TR8MSWIN1254'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9202110863826971)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'Unicode UTF-8'
,p_lov_return_value=>'AL32UTF8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9202305353826971)
,p_lov_disp_sequence=>242
,p_lov_disp_value=>'Unicode UTF-16 Big Endian'
,p_lov_return_value=>'AL16UTF16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9202522080826972)
,p_lov_disp_sequence=>244
,p_lov_disp_value=>'Unicode UTF-16 Little Endian'
,p_lov_return_value=>'AL16UTF16LE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9202732398826972)
,p_lov_disp_sequence=>248
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'US7ASCII'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9202914568826972)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'Vietnamese Windows 1258'
,p_lov_return_value=>'VN8MSWIN1258'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9203117480826972)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'Western European ISO-8859-1'
,p_lov_return_value=>'WE8ISO8859P1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9203309867826972)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>'Western European Windows 1252'
,p_lov_return_value=>'WE8MSWIN1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_detail_view_modes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(144167830179232748)
,p_lov_name=>'ICON DETAIL VIEW MODES'
,p_reference_id=>116048926655714272
,p_lov_query=>'.'||wwv_flow_imp.id(144167830179232748)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(240823626953628604)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Icons'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(240823804523628605)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Details'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/identity_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(254185527365105468)
,p_lov_name=>'IDENTITY_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(254185527365105468)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(254185828755105469)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(254186111548105469)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Default'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(254186405911105469)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Default on Null'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_args_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88064701145826564)
,p_lov_name=>'INCLUDE.ARGS.Y'
,p_lov_query=>'.'||wwv_flow_imp.id(88064701145826564)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88064927960826565)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Include Arguments'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/intra_component_navigator
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1457916849659682)
,p_lov_name=>'INTRA COMPONENT NAVIGATOR'
,p_lov_query=>'.'||wwv_flow_imp.id(1457916849659682)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1458119331659683)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Object Browser'
,p_lov_return_value=>'1001'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1458304212659683)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'SQL Commands'
,p_lov_return_value=>'1003'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1458524645659683)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'SQL Scripts'
,p_lov_return_value=>'1004'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1458701375659683)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Query Builder'
,p_lov_return_value=>'1002'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_types_without_plugins
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(29577622544843540)
,p_lov_name=>'ITEM_TYPES (WITHOUT PLUGINS)'
,p_reference_id=>29544521926748713
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_native_plugins varchar2(255);',
'begin',
'    l_native_plugins := '' union all select display_name as d, name_with_prefix as r from wwv_flow_native_plugins where plugin_type = ''''ITEM TYPE'''' order by 1'';',
'',
'    if lower(wwv_flow.g_flow_language) = ''en'' then',
'        return ''select display_name as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    else',
'        return ''select wwv_flow_lang.system_message(''''ITEM_TYPE.''''||name) as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    end if;',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/language_selector
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(111525828615050878)
,p_lov_name=>'LANGUAGE_SELECTOR'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''en'' d, ''en'' r',
'  from sys.dual',
'union ',
'select flow_language d, flow_language r',
'  from wwv_flows',
' where id in ',
' (select translation_flow_id',
'    from wwv_flow_language_map',
'   where primary_language_flow_id = v(''APP_ID''))',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558117
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_all_schemas
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(26396713461308449)
,p_lov_name=>'LIST_ALL_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d, username v',
'from sys.dba_users ',
'where wwv_flow_provisioning.restricted_schema_i(username,:APP_USER) = 0',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558117
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(64015215313088942)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'V'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75558117
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas_qb
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(14016705748242026)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS-QB'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1002_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1002_SCHEMA ) d,',
'       :P1002_SCHEMA v',
'  from sys.dual',
' where :P1002_POPUP = 1',
' order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'V'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75558117
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas_sc
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23001304041139468)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1003_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1003_SCHEMA ) d,',
'       :P1003_SCHEMA v',
'  from sys.dual',
' where :P1003_POPUP = 1',
' order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'V'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75558117
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_users
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(96930227515507687)
,p_lov_name=>'LIST_USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || wwv_flow_lang.system_message(''ALL_USERS'') || '' -'' d, ''0'' r',
'  from sys.dual',
' where exists (',
'    select null',
'      from  wwv_flow_developers ',
'     where security_group_id = :flow_security_group_id ',
'       and userid = :flow_user ',
'       and instr(developer_role||'':'',''ADMIN:'') > 0)',
'union all',
'select user_name d, user_name r',
'  from wwv_flow_fnd_user',
' where security_group_id = :flow_security_group_id',
'   and (user_name = :flow_user or exists',
'        (select null from wwv_flow_developers',
'          where security_group_id = :flow_security_group_id',
'            and userid = :flow_user',
'            and instr(developer_role||'':'',''ADMIN:'') > 0))',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558117
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_message
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(21459801069722432)
,p_lov_name=>'LOGIN_MESSAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(21459801069722432)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21460014390722445)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Message'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21460423875722448)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom Message'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_objectstore_references
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2126335033862968)
,p_lov_name=>'LOV_OBJECTSTORE_REFERENCES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, base_url, cloud_credential_name from wwv_remote_servers',
'where security_group_id = :WORKSPACE_ID',
'and server_type = ''CLOUD_OBJECT_STORE'''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(2127071488865633)
,p_query_column_name=>'ID'
,p_display_sequence=>10
,p_data_type=>'NUMBER'
,p_is_visible=>'N'
,p_is_searchable=>'N'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(2127437388865635)
,p_query_column_name=>'NAME'
,p_heading=>'Name'
,p_display_sequence=>20
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(2127806644865636)
,p_query_column_name=>'BASE_URL'
,p_heading=>'URL'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(2128268586865636)
,p_query_column_name=>'CLOUD_CREDENTIAL_NAME'
,p_heading=>'DBMS_CLOUD Credential'
,p_display_sequence=>40
,p_data_type=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/manage_table_constraints
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(165911414842182864)
,p_lov_name=>'MANAGE.TABLE.CONSTRAINTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.constraint_name) d,  c.constraint_name r',
'from sys.dba_constraints c, sys.dba_cons_columns l',
'where c.table_name = :OBJECT_NAME',
'and c.owner = :OBJECT_OWNER',
'and c.constraint_type in (''P'',''U'',''C'',''R'')',
'and c.constraint_name = l.constraint_name ',
'and l.owner = :OBJECT_OWNER',
'and l.table_name = :OBJECT_NAME',
'and (l.position = 1 or l.position is null)',
'and c.status = ''ENABLED''',
'order by c.constraint_name, c.constraint_type, l.position'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558117
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_a
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88005728392276151)
,p_lov_name=>'MAX_ROWS_A'
,p_lov_query=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88005902539276153)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88006132674276154)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88006303849276154)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88006502528276154)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88006721789276154)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88006905692276155)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88007113392276155)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88007318997276155)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88007513744276155)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(182328908607767113)
,p_lov_disp_sequence=>5000
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(260332524931295254)
,p_lov_disp_sequence=>10000
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(260332828394296254)
,p_lov_disp_sequence=>100000
,p_lov_disp_value=>'100000'
,p_lov_return_value=>'100000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_b
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88008910861280555)
,p_lov_name=>'MAX_ROWS_B'
,p_lov_query=>'.'||wwv_flow_imp.id(88008910861280555)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(183741320426917019)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88009125818280556)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88009318636280556)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88009527364280557)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88009708671280557)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88009918679280557)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88010107969280558)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88010312982280558)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88010525571280558)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88010713109280558)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88010919618280559)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88011124222280559)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88011310169280559)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'50000'
,p_lov_return_value=>'50000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/more_less_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(161595731562973452)
,p_lov_name=>'MORE_LESS_COLUMNS'
,p_lov_query=>'.'||wwv_flow_imp.id(161595731562973452)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161595917373973455)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'More Columns'
,p_lov_return_value=>'MORE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161596108445973460)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Fewer Columns'
,p_lov_return_value=>'LESS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/my_job
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88020412686337805)
,p_lov_name=>'MY.JOB'
,p_lov_query=>'.'||wwv_flow_imp.id(88020412686337805)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88020600548337806)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'My Jobs'
,p_lov_return_value=>'my_job'
);
end;
/
prompt --application/shared_components/user_interface/lovs/null_notnull
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88038204225524574)
,p_lov_name=>'NULL.NOTNULL'
,p_lov_query=>'.'||wwv_flow_imp.id(88038204225524574)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88038423679524575)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'NOT NULL (require a value)'
,p_lov_return_value=>'NOT NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88038631515524575)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NULL (do not require a value)'
,p_lov_return_value=>'NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88081132547977521)
,p_lov_name=>'OBJECT.TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''FUNCTION'')) d, ''98'' r from sys.dual union all',
'select initcap(wwv_flow_lang.system_message(''INDEX'')) d, ''INDEX'' r from sys.dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PACKAGE'')) d, ''117'' r from sys.dual union all     ',
'select initcap(wwv_flow_lang.system_message(''PROCEDURE'')) d, ''121'' r from sys.dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SEQUENCE'')) d, ''97'' r from sys.dual union all     ',
'select initcap(wwv_flow_lang.system_message(''SYNONYM'')) d, ''99'' r from sys.dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TABLE'')) d, ''600'' r from sys.dual union all     ',
'select initcap(wwv_flow_lang.system_message(''TRIGGER'')) d, ''TRIGGER'' r from sys.dual union all     ',
'select initcap(wwv_flow_lang.system_message(''VIEW'')) d, ''48'' r from sys.dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558117
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types_with_images2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(161349613017569311)
,p_lov_name=>'OBJECT.TYPES.WITH.IMAGES2'
,p_lov_query=>'.'||wwv_flow_imp.id(161349613017569311)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161349926473569318)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Function'
,p_lov_return_value=>'98'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:98:&SESSION.::NO:98,107,100:P81_CREATE_OBJECT_TYPE:98"><img src="#IMAGE_PREFIX#htmldb/builder/function.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161350104339569322)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Index'
,p_lov_return_value=>'INDEX'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:56:&SESSION.:index:NO:57:P70_ACTION,P81_CREATE_OBJECT_TYPE:INDEX,INDEX"><img src="#IMAGE_PREFIX#htmldb/builder/index.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_V'
||'ALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161350313495569322)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'117'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:117:&SESSION.::NO:117,118,120:P81_CREATE_OBJECT_TYPE:117"><img src="#IMAGE_PREFIX#htmldb/builder/package.gif" width="58" height="38" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a'
||'>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161350510273569323)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Procedure'
,p_lov_return_value=>'121'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:121:&SESSION.::NO:121,122,123:P81_CREATE_OBJECT_TYPE:121"><img src="#IMAGE_PREFIX#htmldb/builder/procedure.gif" width="58" height="38" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /><'
||'/a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161350704929569323)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Sequence'
,p_lov_return_value=>'97'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:97:&SESSION.::NO:97:P81_CREATE_OBJECT_TYPE:97"><img src="#IMAGE_PREFIX#htmldb/builder/sequence.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161350927921569323)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Synonym'
,p_lov_return_value=>'99'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:99:&SESSION.::NO:99:P81_CREATE_OBJECT_TYPE:99"><img src="#IMAGE_PREFIX#htmldb/builder/synonym.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161351109256569323)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE_CREATE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:TABLE_CREATE:&SESSION.::NO:602,604,612:P81_CREATE_OBJECT_TYPE:600"><img src="#IMAGE_PREFIX#htmldb/builder/table.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#'
||'" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161351331481569324)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:3:&SESSION.:triger:NO:3::"><img src="#IMAGE_PREFIX#htmldb/builder/trigger.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161351517964569324)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'View'
,p_lov_return_value=>'48'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:48:&SESSION.::NO:48:P81_CREATE_OBJECT_TYPE:48"><img src="#IMAGE_PREFIX#htmldb/builder/view.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161351731977569324)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Database Link'
,p_lov_return_value=>'91'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a style="padding-left:20px;" href="f?p=4500:91:&SESSION.::NO:91:P81_CREATE_OBJECT_TYPE:91"><img src="#IMAGE_PREFIX#htmldb/builder/dblink.gif" width="54" height="43" title="#DISPLAY_VALUE#" alt="#DISPLAY_VALUE#" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88087713200000281)
,p_lov_name=>'OBJECT.TYPES2'
,p_lov_query=>'.'||wwv_flow_imp.id(88087713200000281)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558118
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88087913591000281)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Columns'
,p_lov_return_value=>'Columns'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88088111508000282)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Packages'
,p_lov_return_value=>'Packages'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88088331361000282)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Procedures/Functions'
,p_lov_return_value=>'Procedures/Functions'
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types3
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(149192410304386529)
,p_lov_name=>'OBJECT.TYPES3'
,p_lov_query=>'.'||wwv_flow_imp.id(149192410304386529)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558118
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149192703287386532)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Function'
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149192916678386534)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Index'
,p_lov_return_value=>'INDEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149193104939386534)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'PACKAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149193312103386534)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Procedure'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149193514215386535)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Sequence'
,p_lov_return_value=>'SEQUENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149193711471386535)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Synonym'
,p_lov_return_value=>'SYNONYM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149193923583386535)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149194128979386535)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149194306560386535)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'View'
,p_lov_return_value=>'VIEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(106105223193950457)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Database Link'
,p_lov_return_value=>'DATABASE LINK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109308316213864971)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Type'
,p_lov_return_value=>'TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109321428942887516)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Materialized View'
,p_lov_return_value=>'MATERIALIZED VIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ob_create_table_handler
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(17956529721028277)
,p_lov_name=>'OB_CREATE_TABLE_HANDLER'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558119
);
end;
/
prompt --application/shared_components/user_interface/lovs/ob_cycle
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(276749314239737540)
,p_lov_name=>'OB_CYCLE'
,p_lov_query=>'.'||wwv_flow_imp.id(276749314239737540)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(276749519233737542)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cycle'
,p_lov_return_value=>'CYCLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ob_order
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(276750123935740352)
,p_lov_name=>'OB_ORDER'
,p_lov_query=>'.'||wwv_flow_imp.id(276750123935740352)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(276750313195740352)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Order'
,p_lov_return_value=>'ORDER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/on_delete_cascade_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88046110159554703)
,p_lov_name=>'ON.DELETE.CASCADE.Y'
,p_lov_query=>'.'||wwv_flow_imp.id(88046110159554703)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88046324301554704)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'On Delete Cascade'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/order_by
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88015211732318611)
,p_lov_name=>'ORDER.BY'
,p_lov_query=>'.'||wwv_flow_imp.id(88015211732318611)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88015409187318612)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Title'
,p_lov_return_value=>'title'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88015624432318612)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'File Name'))
,p_lov_return_value=>'filename'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88015826924318612)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Created Asc'))
,p_lov_return_value=>'created_on'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88016003779318613)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Created Desc'))
,p_lov_return_value=>'created_on desc'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88016226006318613)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Created By'))
,p_lov_return_value=>'created_by'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88016402368318613)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Size Asc'))
,p_lov_return_value=>'doc_size'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88016613155318613)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Size Desc'))
,p_lov_return_value=>'doc_size desc'
);
end;
/
prompt --application/shared_components/user_interface/lovs/output_format
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88012712031290348)
,p_lov_name=>'OUTPUT.FORMAT'
,p_lov_query=>'.'||wwv_flow_imp.id(88012712031290348)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88012904683290349)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTML'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88013100776290349)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Excel'
,p_lov_return_value=>'EXCEL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1000_show
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(184589019269022599)
,p_lov_name=>'P1000 SHOW'
,p_lov_query=>'.'||wwv_flow_imp.id(184589019269022599)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(184589207940022600)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(184589426163022602)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'My Assignments'
,p_lov_return_value=>'MINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(184593723631288771)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'My Open'
,p_lov_return_value=>'MY_OPEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(184593319129287486)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'All Open'
,p_lov_return_value=>'ALL_OPEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1004_show_results
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(179031515879675216)
,p_lov_name=>'P1004_SHOW_RESULTS'
,p_lov_query=>'.'||wwv_flow_imp.id(179031515879675216)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179031709094675217)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Show Results'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p101_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(150992731358804903)
,p_lov_name=>'P101_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.column_name)||'' - ''||lower(t.data_type) d, ',
'       t.column_name r',
'from   sys.dba_tab_columns t',
'where              ',
'      t.table_name = :P101_TABLE_NAME',
'  and t.owner = :P101_TABLE_OWNER and',
'      (nvl(:P101_SHOW,''1'') = ''1'' or t.data_type in (''VARCHAR'',''VARCHAR2'')) and column_id is not null',
'order by t.column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558119
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_audit_col_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(561151526618018480)
,p_lov_name=>'P1101_AUDIT_COL_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(561151526618018480)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561151855252018480)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Audit Columns'
,p_lov_return_value=>'AUDIT_COLS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561152288785018481)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Row Version Number'
,p_lov_return_value=>'ROW_VERSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561152614552018481)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Row Key'
,p_lov_return_value=>'ROW_KEY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_date_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(561155009716075756)
,p_lov_name=>'P1101_DATE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(561155009716075756)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561155337871075756)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561155720392075757)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'TIMESTAMP'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561156148788075757)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'TIMESTAMP WITH TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561156516823075757)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_db_version
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(561159215572120923)
,p_lov_name=>'P1101_DB_VERSION'
,p_lov_query=>'.'||wwv_flow_imp.id(561159215572120923)||'.'
,p_location=>'STATIC'
,p_version_scn=>21913766
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(616271032412133442)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'23ai'
,p_lov_return_value=>'23'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4401205819200657)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'21c'
,p_lov_return_value=>'21c'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561159550831120924)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'19c'
,p_lov_return_value=>'19c'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_length_semantics
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(561157497023099105)
,p_lov_name=>'P1101_LENGTH_SEMANTICS'
,p_lov_query=>'.'||wwv_flow_imp.id(561157497023099105)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558120
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561157786208099106)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Default'
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561158557818099106)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'CHAR'
,p_lov_return_value=>'CHAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561158130042099106)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'BYTE'
,p_lov_return_value=>'BYTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_on_delete
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(561149224457990543)
,p_lov_name=>'P1101_ON_DELETE'
,p_lov_query=>'.'||wwv_flow_imp.id(561149224457990543)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558120
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561149574178990543)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cascade'
,p_lov_return_value=>'CASCADE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561149925686990545)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Restrict'
,p_lov_return_value=>'RESTRICT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561150376364990545)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Set Null'
,p_lov_return_value=>'SET NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1101_trigger_method
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(561153525630044678)
,p_lov_name=>'P1101_TRIGGER_METHOD'
,p_lov_query=>'.'||wwv_flow_imp.id(561153525630044678)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558120
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561153872500044678)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'SYS_GUID'
,p_lov_return_value=>'GUID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561154212975044678)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Identity Column'
,p_lov_return_value=>'IDENTITY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244368349049855044)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Sequence'
,p_lov_return_value=>'SEQ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(122155829515030912)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1220_script_files
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(12563519145254272)
,p_lov_name=>'P1220_SCRIPT_FILES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.filename, f.id',
'from wwv_flow_files f, wwv_flow_sw_results r',
'where f.id = r.file_id ',
'and f.file_type = ''SCRIPT''',
'and (nvl(:P1220_SHOW,''0'') = ''0'' or run_by = :P1220_SHOW)',
'order by f.filename'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558120
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1301_session_opts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(26561807054435939)
,p_lov_name=>'P1301_SESSION_OPTS'
,p_lov_query=>'.'||wwv_flow_imp.id(26561807054435939)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558120
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26562005235435939)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'ALL'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26562200440435942)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Successful Sessions'
,p_lov_return_value=>'SUC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26562427473435942)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Failed Sessions'
,p_lov_return_value=>'FAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1302_sesopt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(26247521414208435)
,p_lov_name=>'P1302_SESOPT'
,p_lov_query=>'.'||wwv_flow_imp.id(26247521414208435)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558120
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26247711140208437)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'ALL'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26247917746208441)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Successful Login'
,p_lov_return_value=>'SUC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26248104479208441)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Failed Login'
,p_lov_return_value=>'FAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_comment_on
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2382418254873350)
,p_lov_name=>'P2000_COMMENT_ON'
,p_lov_query=>'.'||wwv_flow_imp.id(2382418254873350)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2382773415873350)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2383112884873350)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Column'
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_constraint_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6047691541572644)
,p_lov_name=>'P2000_CONSTRAINT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(6047691541572644)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6047948636572648)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Check'
,p_lov_return_value=>'CHECK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6048385917572650)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Foreign Key'
,p_lov_return_value=>'FOREIGN KEY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6048730362572650)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Primary Key'
,p_lov_return_value=>'PRIMARY KEY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6049141161572650)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Unique'
,p_lov_return_value=>'UNIQUE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_dummy
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(21051579869086845)
,p_lov_name=>'P2000_DUMMY'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_default_sort_column_name=>'D'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75558121
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_filter_operation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2377428328828737)
,p_lov_name=>'P2000_FILTER_OPERATION'
,p_lov_query=>'.'||wwv_flow_imp.id(2377428328828737)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2377792186828738)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'='
,p_lov_return_value=>'EQ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2378120552828738)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'!='
,p_lov_return_value=>'NEQ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2378570484828738)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'>'
,p_lov_return_value=>'GT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2378930835828738)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'>='
,p_lov_return_value=>'GTE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2379366639828739)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'<'
,p_lov_return_value=>'LT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2379787769828739)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'<='
,p_lov_return_value=>'LTE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2380150449828739)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'is null'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2380595430828739)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'is not null'
,p_lov_return_value=>'NN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2380918043828740)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'like'
,p_lov_return_value=>'LIKE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_fk_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6049648636596575)
,p_lov_name=>'P2000_FK_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(6049648636596575)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6049902786596575)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cascade Delete'
,p_lov_return_value=>'ON DELETE CASCADE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6050361020596576)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Set Null on Delete'
,p_lov_return_value=>'ON DELETE SET NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_redact_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2372526307115830)
,p_lov_name=>'P2000_REDACT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2372526307115830)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2372814128115831)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Full'
,p_lov_return_value=>'FULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2373282436115831)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Partial'
,p_lov_return_value=>'PARTIAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2373607004115831)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Regular Expression'
,p_lov_return_value=>'REGEXP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2374064827115831)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Random'
,p_lov_return_value=>'RANDOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2374436550115831)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_remove_redact
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2371765569098492)
,p_lov_name=>'P2000_REMOVE_REDACT'
,p_lov_query=>'.'||wwv_flow_imp.id(2371765569098492)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2372024858098492)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Remove redaction policy'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_rem_col_policy
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2374950879129168)
,p_lov_name=>'P2000_REM_COL_POLICY'
,p_lov_query=>'.'||wwv_flow_imp.id(2374950879129168)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2375276716129169)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Remove column from policy'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_semantics
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2383831987893567)
,p_lov_name=>'P2000_SEMANTICS'
,p_lov_query=>'.'||wwv_flow_imp.id(2383831987893567)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2384188923893567)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Char'
,p_lov_return_value=>'CHAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2384516913893567)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Byte'
,p_lov_return_value=>'BYTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2000_show_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2381539388856852)
,p_lov_name=>'P2000_SHOW_COLS'
,p_lov_query=>'.'||wwv_flow_imp.id(2381539388856852)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2381881328856852)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Show Columns'
,p_lov_return_value=>'X'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2010_syn_object
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4601505050190750)
,p_lov_name=>'P2010_SYN_OBJECT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name object_name,',
'       type object_type',
'  from sys.dba_tab_privs',
' where grantee = :P2010_PARSING_SCHEMA',
'   and grantor = :P2010_SYN_SCHEMA',
' union',
'select object_name object_name,',
'       object_type',
'  from sys.dba_objects',
' where owner             = :P2010_PARSING_SCHEMA',
'   and :P2010_SYN_SCHEMA = :P2010_PARSING_SCHEMA',
'   and object_name not like ''DR$%''',
'   and object_name not like ''BIN$%''',
'   and object_type != ''LOB''',
'   and ( object_type != ''INDEX'' or object_name not like ''SYS_%$$'' )',
' order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'OBJECT_NAME'
,p_display_column_name=>'OBJECT_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75558123
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(4602544630213035)
,p_query_column_name=>'OBJECT_NAME'
,p_heading=>'Object Name'
,p_display_sequence=>10
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(4602251379213035)
,p_query_column_name=>'OBJECT_TYPE'
,p_heading=>'Object Type'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2610_users
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(20110029824731114)
,p_lov_name=>'P2610_USERS'
,p_lov_query=>'.'||wwv_flow_imp.id(20110029824731114)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20110203670731120)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'All Schemas'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20110423350731122)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Internal Schemas'
,p_lov_return_value=>'INTERNAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20110606356731122)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Database Schemas'
,p_lov_return_value=>'USER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2613_locked_unlocked
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1493723866781789)
,p_lov_name=>'P2613_LOCKED_UNLOCKED'
,p_lov_query=>'.'||wwv_flow_imp.id(1493723866781789)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1493913666781840)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Locked'
,p_lov_return_value=>'LOCK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1494107328781852)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unlocked'
,p_lov_return_value=>'UNLOCK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3100_load_to
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(60089930390905970)
,p_lov_name=>'P3100_LOAD_TO'
,p_lov_query=>'.'||wwv_flow_imp.id(60089930390905970)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(60090216213905982)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'New Table'
,p_lov_return_value=>'NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(60090671533905996)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Existing Table'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3100_update_method
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(60103143434104047)
,p_lov_name=>'P3100_UPDATE_METHOD'
,p_lov_query=>'.'||wwv_flow_imp.id(60103143434104047)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(60103430659104047)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Append'
,p_lov_return_value=>'APPEND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(60103886752104048)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Replace'
,p_lov_return_value=>'REPLACE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3120_table_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(60123851090684199)
,p_lov_name=>'P3120_TABLE_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name||'' (''|| initcap(data_type) ||'')'' as d,',
'       column_name as r',
'from sys.dba_tab_columns',
'where owner = :P3100_TABLE_OWNER',
'and table_name = :P3100_EXISTING_TABLE',
'order by column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558124
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3142_table_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2839941212629864)
,p_lov_name=>'P3142_TABLE_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name||'' (''|| initcap(data_type) ||'')'' as d,',
'       column_name as r',
'from sys.dba_tab_columns',
'where owner = :P3140_SCHEMA',
'and table_name = :P3140_EXISTING_TABLE_NAME',
'order by column_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_version_scn=>75558124
);
end;
/
prompt --application/shared_components/user_interface/lovs/p35_timeframe
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(30574425871912860)
,p_lov_name=>'P35_TIMEFRAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, to_char(t) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10 t from sys.dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 60 t from sys.dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5*60 t from sys.dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15*60 t from sys.dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30*60 t from sys.dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 3600 t from sys.dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 2*3600  t from sys.dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3*3600  t from sys.dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4*3600  t from sys.dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6*3600 t from sys.dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8*3600 t from sys.dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12*3600 t from sys.dual union all',
'select ''18 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 18*3600 t from sys.dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1*24*60*60 t from sys.dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2*24*60*60 t from sys.dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3*24*60*60 t from sys.dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4*24*60*60 t from sys.dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5*24*60*60 t from sys.dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 6*24*60*60 t from sys.dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7*24*60*60 t  from sys.dual',
') q'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558124
);
end;
/
prompt --application/shared_components/user_interface/lovs/p36_display_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(998111353442494)
,p_lov_name=>'P36_DISPLAY_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(998111353442494)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(998325750442498)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Version'
,p_lov_return_value=>'VERSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(998523049442499)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Settings'
,p_lov_return_value=>'DATABASE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(998704170442500)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Options'
,p_lov_return_value=>'OPTIONS'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(999130596442500)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'National Language Support'
,p_lov_return_value=>'NLS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(999327277442500)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'CGI Environment'
,p_lov_return_value=>'CGI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5615222230694443)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Parameters'
,p_lov_return_value=>'PARAMETER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p42_order_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(148760022603009971)
,p_lov_name=>'P42.ORDER.COLUMNS'
,p_lov_query=>'select wwv_flow_escape.html(column_name) d, column_name v from sys.dba_tab_columns where owner = :F4500_P42_OBJECT_OWNER and table_name = :F4500_P42_OBJECT_NAME order by column_id'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558124
);
end;
/
prompt --application/shared_components/user_interface/lovs/p64_obj_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(27925820885518618)
,p_lov_name=>'P64_OBJ_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(27925820885518618)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27926020563518626)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application'
,p_lov_return_value=>'APPLICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27926230018518634)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'CSS Export'
,p_lov_return_value=>'CSS_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27926402670518634)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Application Export'
,p_lov_return_value=>'FLOW_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27926614786518636)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Script'
,p_lov_return_value=>'SCRIPT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27926803274518636)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Script File Export'
,p_lov_return_value=>'SCRIPT_FILE_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27927031603518636)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Theme'
,p_lov_return_value=>'THEME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27927219004518642)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Static File'
,p_lov_return_value=>'STATIC FILE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p71_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(174553601832855016)
,p_lov_name=>'P71_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER',
' and table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558124
);
end;
/
prompt --application/shared_components/user_interface/lovs/p76_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(174520707223695721)
,p_lov_name=>'P76_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,  column_name r',
'from sys.dba_tab_columns',
'where owner =  :OBJECT_OWNER and',
'table_name= :OBJECT_NAME and column_id is not null',
'order by column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558124
);
end;
/
prompt --application/shared_components/user_interface/lovs/p82_constraints
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(174431027591821617)
,p_lov_name=>'P82_CONSTRAINTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.constraint_name) d,  c.constraint_name r',
'from sys.dba_constraints c, sys.dba_cons_columns l',
'where c.table_name = :OBJECT_NAME',
'and c.owner = :OBJECT_OWNER',
'and c.constraint_type in (''P'',''U'',''C'',''R'')',
'and c.constraint_name = l.constraint_name ',
'and l.owner = :OBJECT_OWNER',
'and l.table_name = :OBJECT_NAME',
'and c.status = ''DISABLED''',
'order by c.constraint_name, c.constraint_type, l.position'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558124
);
end;
/
prompt --application/shared_components/user_interface/lovs/p86_triggers
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(174475310182109956)
,p_lov_name=>'P86_TRIGGERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.trigger_name)||'' (''||t.status||'')'' d, t.trigger_name r',
'from sys.dba_triggers t',
'where t.table_name = :OBJECT_NAME ',
'and t.table_owner = :OBJECT_OWNER',
'order by t.trigger_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558124
);
end;
/
prompt --application/shared_components/user_interface/lovs/parameter_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4013634066938059)
,p_lov_name=>'PARAMETER_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(4013634066938059)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4013908234938083)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'IN'
,p_lov_return_value=>'IN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4014345637938085)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'OUT'
,p_lov_return_value=>'OUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4014719077938085)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'IN OUT'
,p_lov_return_value=>'IN OUT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pl_sql_object_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(9486017492391468)
,p_lov_name=>'PL/SQL OBJECT TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(9486017492391468)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9486202458391470)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Procedure'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9486430806391474)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Function'
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9486609421391475)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'PACKAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9486818320391475)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Package Body'
,p_lov_return_value=>'PACKAGE BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9487009618391475)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/privileges_table_show
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8935311761146039)
,p_lov_name=>'PRIVILEGES.TABLE.SHOW'
,p_lov_query=>'.'||wwv_flow_imp.id(8935311761146039)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8935521709146041)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Grants to selected schema'
,p_lov_return_value=>'TO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8935711543146043)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Grants from selected schema'
,p_lov_return_value=>'FROM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8935913844146043)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'All'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_private
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88067712358839197)
,p_lov_name=>'PUBLIC.PRIVATE'
,p_lov_query=>'.'||wwv_flow_imp.id(88067712358839197)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88067900572839197)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Private'
,p_lov_return_value=>'PRIVATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88068127252839198)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Public'
,p_lov_return_value=>'PUBLIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/query_builder_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2308814912225605)
,p_lov_name=>'QUERY_BUILDER_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(2308814912225605)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2309026164225610)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Private'
,p_lov_return_value=>'P'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2309221064225612)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Public'
,p_lov_return_value=>'R'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2309411169225612)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Public Read/Write'
,p_lov_return_value=>'W'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/query_owners
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3358317445244033)
,p_lov_name=>'QUERY_OWNERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r from (',
'select wwv_flow_escape.html(created_by) d, created_by r ',
'  from wwv_flow_qb_saved_query',
'where security_group_id = :flow_security_group_id',
'and exists (     ',
'select 1 ',
'from  wwv_flow_developers ',
'where security_group_id = :flow_security_group_id and ',
'      userid = :flow_user and ',
'      instr(developer_role||'':'',''ADMIN:'') > 0 ',
'union ',
'select 1 ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id ',
'and user_name = :flow_user ',
'and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')) ',
'union all  ',
'select v(''APP_USER'') d, v(''APP_USER'') r',
'FROM sys.DUAL) ',
'group by d,r',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558124
);
end;
/
prompt --application/shared_components/user_interface/lovs/quicksql_data_lang
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(397206437082468486)
,p_lov_name=>'QUICKSQL_DATA_LANG'
,p_lov_query=>'.'||wwv_flow_imp.id(397206437082468486)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(397206751492468497)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'English'
,p_lov_return_value=>'EN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(397207144316468498)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'German'
,p_lov_return_value=>'DE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(397207548117468498)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Korean'
,p_lov_return_value=>'KO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(397207927574468498)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Japanese'
,p_lov_return_value=>'JA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(397208363097468498)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Spanish'
,p_lov_return_value=>'ES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/quota_size
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1589203900827893)
,p_lov_name=>'QUOTA SIZE'
,p_lov_query=>'.'||wwv_flow_imp.id(1589203900827893)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1589405753827932)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Zero'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1589832194827937)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Value (MB)'
,p_lov_return_value=>'VALUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1589631060827937)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Unlimited'
,p_lov_return_value=>'UNLIMITED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recycle_bin_object_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(165057106281786448)
,p_lov_name=>'RECYCLE BIN OBJECT TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(165057106281786448)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(165057400753786453)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Index'
,p_lov_return_value=>'INDEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(165057605335786456)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(165057800969786457)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redaction_enabled
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7500901536272987)
,p_lov_name=>'REDACTION_ENABLED'
,p_lov_query=>'.'||wwv_flow_imp.id(7500901536272987)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7501216647272994)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7501515266272994)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_expressions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7516909805609852)
,p_lov_name=>'REDACT_EXPRESSIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(7516909805609852)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7517226584609865)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'1=1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7517506593609865)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oracle APEX User is'
,p_lov_return_value=>'v(''APP_USER'') = '''' or v(''APP_USER'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7517804068609865)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Oracle APEX User is not'
,p_lov_return_value=>'v(''APP_USER'') != '''' or v(''APP_USER'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7518128701609866)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'User Environment Session User is'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''SESSION_USER'') = '''' or SYS_CONTEXT(''USERENV'',''SESSION_USER'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7518404287609866)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'User Environment Session User is not'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''SESSION_USER'') != '''' or SYS_CONTEXT(''USERENV'',''SESSION_USER'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7518717668609866)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'User Environment Session Role is'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''SESSION_ROLE'') = '''' or SYS_CONTEXT(''USERENV'',''SESSION_ROLE'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7519030231609866)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'User Environment Session Role is not'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''SESSION_ROLE'') != '''' or SYS_CONTEXT(''USERENV'',''SESSION_ROLE'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7519316622609867)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'User Environment Application Module is'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''APPLICATION_MODULE'') = '''' or SYS_CONTEXT(''USERENV'',''APPLICATION_MODULE'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7519610265609867)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'User Environment Application Module is not'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''APPLICATION_MODULE'') != '''' or SYS_CONTEXT(''USERENV'',''APPLICATION_MODULE'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7519923103609867)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'User Environment Client Identifier is'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_IDENTIFIER'') = '''' or SYS_CONTEXT(''USERENV'',''CLIENT_IDENTIFIER'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7520222645609867)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'User Environment Client Identifier is not'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_IDENTIFIER'') != '''' or SYS_CONTEXT(''USERENV'',''CLIENT_IDENTIFIER'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7520505568609926)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'User Environment Client Information is'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_INFORMATION'') = '''' or SYS_CONTEXT(''USERENV'',''CLIENT_INFORMATION'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7520806771609926)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'User Environment Client Information is not'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_INFORMATION'') != '''' or SYS_CONTEXT(''USERENV'',''CLIENT_INFORMATION'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7521121453609926)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'User Environment Client IP Address is'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_IP_ADDRESS'') = '''' or SYS_CONTEXT(''USERENV'',''CLIENT_IP_ADDRESS'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7521408264609926)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'User Environment Client IP Address is not'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_IP_ADDRESS'') != '''' or SYS_CONTEXT(''USERENV'',''CLIENT_IP_ADDRESS'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7521704157619850)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'User Environment Client Machine Name is'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_MACHINE_NAME'') = '''' or SYS_CONTEXT(''USERENV'',''CLIENT_MACHINE_NAME'') is null'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7522029162623362)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'User Environment Client Machine Name is not'
,p_lov_return_value=>'SYS_CONTEXT(''USERENV'',''CLIENT_MACHINE_NAME'') != '''' or SYS_CONTEXT(''USERENV'',''CLIENT_MACHINE_NAME'') is null'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_func_parms
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7469301964208818)
,p_lov_name=>'REDACT_FUNC_PARMS'
,p_lov_query=>'.'||wwv_flow_imp.id(7469301964208818)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558127
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7469607797208922)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Redact First Five US SSN'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,1,5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7469909319209004)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Redact Last Four US SSN'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,6,9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7470220279209004)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Redact Entire US SSN'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,1,9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7470527551209004)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Redact First Five Numeric US SSN'
,p_lov_return_value=>'9,1,5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7470809785209004)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Redact Last Four Numeric US SSN'
,p_lov_return_value=>'9,6,9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7471105134209004)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Redact Entire Numeric US SSN'
,p_lov_return_value=>'9,1,9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7471430655209004)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Redact Numeric US ZIP Code'
,p_lov_return_value=>'9,1,5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7471711236209005)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Redact First Twelve Credit Card Number'
,p_lov_return_value=>'VVVVFVVVVFVVVVFVVVV,VVVV-VVVV-VVVV-VVVV,*,1,12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7472009351209006)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Redact Date Millenium'
,p_lov_return_value=>'m1d1y2000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7472316128209006)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Redact Date Epoch'
,p_lov_return_value=>'m1d1y1970'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_regexp_pattern
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7472906353351996)
,p_lov_name=>'REDACT_REGEXP_PATTERN'
,p_lov_query=>'.'||wwv_flow_imp.id(7472906353351996)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558127
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7473231345352007)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US Social Security Number'
,p_lov_return_value=>'(\d\d\d)-(\d\d)-(\d\d\d\d)'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7473505981352008)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Middle of Credit Card with Leading 6 and Trailing 4 digits'
,p_lov_return_value=>'(\d\d\d\d\d\d)(\d\d\d*)(\d\d\d\d)'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7473832380352008)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Any Digit'
,p_lov_return_value=>'\d'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7474122208352008)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'US Phone Number'
,p_lov_return_value=>'(\(\d\d\d\)|\d\d\d)-(\d\d\d)-(\d\d\d\d)'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7474420613352009)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Email Address'
,p_lov_return_value=>'([A-Za-z0-9._%+-]+)@([A-Za-z0-9.-]+\.[A-Za-z]{2,4})'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7474702702352009)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'IP Address'
,p_lov_return_value=>'(\d{1,3}\.\d{1,3}\.\d{1,3})\.\d{1,3}'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_regexp_repl_str
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7474914908572203)
,p_lov_name=>'REDACT_REGEXP_REPL_STR'
,p_lov_query=>'.'||wwv_flow_imp.id(7474914908572203)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558127
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7475217540572261)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Redact Middle Credit Card Digits'
,p_lov_return_value=>'\1XXXXXX\3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7475532017572262)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Redact with Single X'
,p_lov_return_value=>'X'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7475808807572262)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Redact with Single 1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7476121686572262)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Redact US Phone'
,p_lov_return_value=>'\1-XXX-XXXX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7476430001572262)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Redact Email Name'
,p_lov_return_value=>'xxxx@\2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7476702761572263)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Redact Email Domain'
,p_lov_return_value=>'\1 (at) xxxxx.com'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7477004982572263)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Redact Entire Email'
,p_lov_return_value=>'xxxx (at) xxxxx.com'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7477316416572263)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Redact IP Address'
,p_lov_return_value=>'\1.999'
);
end;
/
prompt --application/shared_components/user_interface/lovs/regexp_match_param
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7477530753595662)
,p_lov_name=>'REGEXP_MATCH_PARAM'
,p_lov_query=>'.'||wwv_flow_imp.id(7477530753595662)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558127
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7477819505595662)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Case Sensitive'
,p_lov_return_value=>'c'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7478103965595662)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Case Insensitive'
,p_lov_return_value=>'i'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7478429992595663)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Multiple Lines'
,p_lov_return_value=>'m'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7478728314595663)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Newline Wildcard'
,p_lov_return_value=>'n'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7479001778595663)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Ignore Whitespace'
,p_lov_return_value=>'x'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_select
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88095631994062466)
,p_lov_name=>'ROW.SELECT'
,p_lov_query=>'.'||wwv_flow_imp.id(88095631994062466)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558127
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88095810522062467)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Rows'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88096011165062467)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Selected Rows'
,p_lov_return_value=>'SELECTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88096206304062468)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'No Rows'
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sample_data_spreadsheets
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(217855733246275209)
,p_lov_name=>'SAMPLE.DATA.SPREADSHEETS'
,p_lov_query=>'.'||wwv_flow_imp.id(217855733246275209)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558127
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217856069642275210)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Academic'
,p_lov_return_value=>'ACADEMIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217856445509275213)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Classic Departments and Employees'
,p_lov_return_value=>'DEPT_EMP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217856856420275213)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Formula 1'
,p_lov_return_value=>'F1'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217857246380275213)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'JSON and Structured Test Data'
,p_lov_return_value=>'JSON_TEST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217857693606275213)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'JSON only Test Data'
,p_lov_return_value=>'JSON'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217858097098275213)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Movies'
,p_lov_return_value=>'MOVIE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217858447167275214)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Project and Tasks'
,p_lov_return_value=>'PROJECTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217858839052275214)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Sales'
,p_lov_return_value=>'SALES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217859293900275214)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Tennis'
,p_lov_return_value=>'TENNIS'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217859626213275214)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Vehicle Speed'
,p_lov_return_value=>'SPEED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217860008215275214)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'World Cup'
,p_lov_return_value=>'WORLDCUP'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217860462659275215)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'World Population'
,p_lov_return_value=>'WORLD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/schema_compare_categories
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(14728126072025797)
,p_lov_name=>'SCHEMA COMPARE CATEGORIES'
,p_lov_query=>'.'||wwv_flow_imp.id(14728126072025797)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558127
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14728314552025797)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Columns Names'
,p_lov_return_value=>'COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14728532416025797)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tables'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14728710300025797)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Column Datatypes'
,p_lov_return_value=>'DATATYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14839906156999563)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indexes'
,p_lov_return_value=>'INDEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14877305584283250)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Function'
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14929828730535894)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sequences'
,p_lov_return_value=>'SEQUENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14932013409550455)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Triggers'
,p_lov_return_value=>'TRIGGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16908630581731543)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'PACKAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16908901622732667)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Package Body'
,p_lov_return_value=>'PACKAGE BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16909205432733687)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Procedure'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16909507509734338)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Type'
,p_lov_return_value=>'TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(77467331623506913)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'View'
,p_lov_return_value=>'VIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/script_output_view_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(11936228645031897)
,p_lov_name=>'SCRIPT_OUTPUT_VIEW_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(11936228645031897)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558128
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11936413744031900)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Statement'
,p_lov_return_value=>'STMT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(12078021672086769)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Results'
,p_lov_return_value=>'RESULTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11936610007031901)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Feedback'
,p_lov_return_value=>'MSG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/script_result_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16851103836270043)
,p_lov_name=>'SCRIPT_RESULT_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(16851103836270043)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558128
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16851311853270045)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Submitted'
,p_lov_return_value=>'SUBMITTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16851527617270045)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Executing'
,p_lov_return_value=>'EXECUTING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16851718446270046)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Complete'
,p_lov_return_value=>'COMPLETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16851904138270047)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Canceled'
,p_lov_return_value=>'CANCELED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/search_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(246393217654948737)
,p_lov_name=>'SEARCH_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(246393217654948737)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558129
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246393407696948737)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Match Case'
,p_lov_return_value=>'CASE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_monitoring_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159923116388036162)
,p_lov_name=>'SESSION MONITORING STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(159923116388036162)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558129
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(159923408566036193)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(159923619966036211)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Active'
,p_lov_return_value=>'ACTIVE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sga_target_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1417526170798303)
,p_lov_name=>'SGA_TARGET_LOV'
,p_lov_query=>'.'||wwv_flow_imp.id(1417526170798303)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558129
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1417704549798326)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'64'
,p_lov_return_value=>'64M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1417915382798336)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'128'
,p_lov_return_value=>'128M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1418109764798336)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'192'
,p_lov_return_value=>'192M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1418312463798336)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'256'
,p_lov_return_value=>'256M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1418503267798338)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'320'
,p_lov_return_value=>'320M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1418716837798338)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'384'
,p_lov_return_value=>'384M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1418915626798339)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'448'
,p_lov_return_value=>'448M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1419122341798339)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'512'
,p_lov_return_value=>'512M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_tables_with_and_without_comments
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8639918272273372)
,p_lov_name=>'SHOW TABLES WITH AND WITHOUT COMMENTS'
,p_lov_query=>'.'||wwv_flow_imp.id(8639918272273372)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558131
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8640124542273376)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tables with comments'
,p_lov_return_value=>'WITH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8640331660273378)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Tables without comments'
,p_lov_return_value=>'WITHOUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8640518874273378)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'All Tables'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_hide_y_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88026529019446655)
,p_lov_name=>'SHOW.HIDE.Y.N'
,p_lov_query=>'.'||wwv_flow_imp.id(88026529019446655)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558131
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88026728054446655)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Show'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88026921198446656)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Hide'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sid_service
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(270736905720819349)
,p_lov_name=>'SID_SERVICE'
,p_lov_query=>'.'||wwv_flow_imp.id(270736905720819349)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558131
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(270737132068819350)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Service Name'
,p_lov_return_value=>'SERVICE_NAME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(270737303121819350)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SID'
,p_lov_return_value=>'SID'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sql_script_result_view_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(164092723800780852)
,p_lov_name=>'SQL SCRIPT RESULT VIEW MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(164092723800780852)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558131
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164092906932780860)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Summary'
,p_lov_return_value=>'SUMMARY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(164093123083780865)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Detail'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sql_filetype
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88033203570477156)
,p_lov_name=>'SQL.FILETYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(88033203570477156)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558131
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88033427813477157)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Script File (*.sql)'
,p_lov_return_value=>'sql'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sql_txt_filetype
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88078901941959255)
,p_lov_name=>'SQL.TXT.FILETYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(88078901941959255)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558131
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88079103923959257)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Text File (*.txt)'
,p_lov_return_value=>'txt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88079307836959257)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Script File (*.sql)'
,p_lov_return_value=>'sql'
);
end;
/
prompt --application/shared_components/user_interface/lovs/synchronize_defaults_p809
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42723506268079541)
,p_lov_name=>'SYNCHRONIZE DEFAULTS P809'
,p_lov_query=>'.'||wwv_flow_imp.id(42723506268079541)||'.'
,p_location=>'STATIC'
,p_version_scn=>117451426
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42723726496079548)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Attributes to UI Defaults'
,p_lov_return_value=>'FROM_APP'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#DISPLAY_VALUE#<br />',
'<span style="margin-left:20px;"><img src="#IMAGE_PREFIX#menu/info_64.gif" class="htmldbGreenIcon" alt="#DISPLAY_VALUE#" /></span>'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42723917981079550)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'UI Defaults to Application Attributes'
,p_lov_return_value=>'FROM_DEF'
,p_lov_template=>'#DISPLAY_VALUE#<br /><span style="margin-left:20px;"><img src="#IMAGE_PREFIX#menu/client_64.gif" class="htmldbGreenIcon" alt="#DISPLAY_VALUE#" /></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42726531464105754)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Database to UI Defaults'
,p_lov_return_value=>'FROM_DB'
,p_lov_template=>'#DISPLAY_VALUE#<br /><span style="margin-left:20px;"><img src="#IMAGE_PREFIX#menu/db_64.gif" class="htmldbGreenIcon" alt="#DISPLAY_VALUE#" /></span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/syn_db_location
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2983860617051710)
,p_lov_name=>'SYN_DB_LOCATION'
,p_lov_query=>'.'||wwv_flow_imp.id(2983860617051710)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558134
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2984191751051712)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Local Object'
,p_lov_return_value=>'LOCAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2984588478051713)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Remote Object'
,p_lov_return_value=>'REMOTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/system_privileges
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(25560713417668203)
,p_lov_name=>'SYSTEM PRIVILEGES'
,p_lov_query=>'.'||wwv_flow_imp.id(25560713417668203)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558134
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25560932733668206)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE VIEW'
,p_lov_return_value=>'CREATE VIEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25561118325668208)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PROCEDURE'
,p_lov_return_value=>'CREATE PROCEDURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25561329462668208)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SYNONYM'
,p_lov_return_value=>'CREATE SYNONYM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25561509484668208)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TABLE'
,p_lov_return_value=>'CREATE TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25561703573668209)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE INDEXTYPE'
,p_lov_return_value=>'CREATE INDEXTYPE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25561918387668209)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SEQUENCE'
,p_lov_return_value=>'CREATE SEQUENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25562101316668209)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE DATABASE LINK'
,p_lov_return_value=>'CREATE DATABASE LINK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25562309219668209)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TYPE'
,p_lov_return_value=>'CREATE TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25562510373668210)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE MATERIALIZED VIEW'
,p_lov_return_value=>'CREATE MATERIALIZED VIEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25562725532668210)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE CLUSTER'
,p_lov_return_value=>'CREATE CLUSTER'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25562915030668210)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TRIGGER'
,p_lov_return_value=>'CREATE TRIGGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25563105054668210)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE OPERATOR'
,p_lov_return_value=>'CREATE OPERATOR'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25563322062668210)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE LIBRARY'
,p_lov_return_value=>'CREATE LIBRARY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25563526933668211)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE DIMENSION'
,p_lov_return_value=>'CREATE DIMENSION'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25563701512668211)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE JOB'
,p_lov_return_value=>'CREATE JOB'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25563918014668211)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PROFILE'
,p_lov_return_value=>'CREATE PROFILE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25564128815668211)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PUBLIC DATABASE LINK'
,p_lov_return_value=>'CREATE PUBLIC DATABASE LINK'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25564332270668211)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PUBLIC SYNONYM'
,p_lov_return_value=>'CREATE PUBLIC SYNONYM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25564509385668212)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE ROLE'
,p_lov_return_value=>'CREATE ROLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25564707743668213)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE ROLLBACK SEGMENT'
,p_lov_return_value=>'CREATE ROLLBACK SEGMENT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25564902366668213)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE RULE'
,p_lov_return_value=>'CREATE RULE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25565120530668213)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE RULE SET'
,p_lov_return_value=>'CREATE RULE SET'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25565300473668214)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SESSION'
,p_lov_return_value=>'CREATE SESSION'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25565512486668214)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TABLESPACE'
,p_lov_return_value=>'CREATE TABLESPACE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25565717929668214)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE USER'
,p_lov_return_value=>'CREATE USER'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/table_children
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3694131248687844)
,p_lov_name=>'TABLE_CHILDREN'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''4500_1002_QB_JOIN'')||',
'       '' ''||wwv_flow_escape.html(p.column_name)||',
'       '' ''||wwv_flow_lang.system_message(''4500_1002_QB_TO'')||',
'       '' ''||wwv_flow_escape.html(c.table_name)||''.''||wwv_flow_escape.html(c.column_name) d , t.cid||''|''||c.column_name||''|''||p.column_name r',
'  from sys.dba_cons_columns c,',
'       sys.dba_cons_columns p,',
'       sys.dba_objects o,',
'       ( select c.r_constraint_name pc, ',
'                c.table_name cn, ',
'                c.constraint_name cc,',
'                oo.object_id cid, ',
'                rownum',
'           from sys.dba_constraints c,',
'                sys.dba_objects oo',
'          where c.constraint_type = ''R''',
'            and c.owner = :P59_SCHEMA',
'            and oo.object_name = c.table_name',
'            and oo.owner = c.owner ) t',
' where t.cc             = c.constraint_name',
'   and c.owner          = :P59_SCHEMA',
'   and t.pc             = p.constraint_name',
'   and p.owner          = :P59_SCHEMA',
'   and p.table_name     = :P59_TNAME ',
'   and o.object_name    = p.table_name',
'   and o.owner          = c.owner'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558135
);
end;
/
prompt --application/shared_components/user_interface/lovs/table_parents
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3693427654677337)
,p_lov_name=>'TABLE_PARENTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select wwv_flow_lang.system_message(''4500_1002_QB_JOIN'')||',
' '' ''||wwv_flow_escape.html(c.column_name)||'' ''||wwv_flow_lang.system_message(''4500_1002_QB_TO'')||',
' '' ''||wwv_flow_escape.html(p.table_name)||''.''||wwv_flow_escape.html(p.column_name) d , o.object_id||''|''||p.column_name||''|''||c.column_name r ',
'from',
'       sys.dba_cons_columns c,',
'       sys.dba_cons_columns p,',
'        sys.dba_objects o,',
'      ( SELECT c.r_constraint_name pc, c.table_name cn , c.constraint_name cc, rownum',
'        FROM sys.dba_constraints c ',
'        WHERE  c.constraint_type = ''R''',
'        AND c.table_name = :P59_TNAME',
'        and c.owner = :P59_SCHEMA ) t',
'where  t.cc = c.constraint_name',
'and c.owner = :P59_SCHEMA',
'and t.pc = p.constraint_name',
'and p.owner = :P59_SCHEMA',
'and o.object_name = p.table_name',
'and o.owner = c.owner'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>75558135
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabular_form_display_types_from_4000
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(197598824193421582)
,p_lov_name=>'TABULAR_FORM_DISPLAY_TYPES (FROM 4000)'
,p_reference_id=>41868019518520883
,p_lov_query=>'.'||wwv_flow_imp.id(197598824193421582)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197599231811423843)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Report Column'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197599400226423843)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Display as Text (based on LOV, does not save state)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197599610663423843)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Display as Text (saves state)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197599819865423845)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Display as Text (escape special characters, does not save state)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197600018265423845)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Date Picker'
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197600224897423845)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Text Field'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197600423450423845)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Text Area'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197600606669423845)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Select List (static LOV)'
,p_lov_return_value=>'SELECT_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197600805803423845)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Select List (named LOV)'
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197601002403423845)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Select List (query based LOV)'
,p_lov_return_value=>'SELECT_LIST_FROM_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197601201540423846)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Radio Group (static LOV)'
,p_lov_return_value=>'RADIOGROUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197601419878423846)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Radio Group (named LOV)'
,p_lov_return_value=>'RADIOGROUP_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197601630729423846)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Radio Group (query based LOV)	'
,p_lov_return_value=>'RADIOGROUP_FROM_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197601813915423846)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Hidden '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197602006927423846)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Popup LOV (named LOV)'
,p_lov_return_value=>'POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197602231429423846)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Popup LOV (query based LOV)'
,p_lov_return_value=>'POPUP_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197602405258423846)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Popup Key LOV (named LOV)'
,p_lov_return_value=>'POPUPKEY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197602612872423846)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Popup Key LOV (query based LOV)	'
,p_lov_return_value=>'POPUPKEY_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/top_sql_by
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(236910808625037522)
,p_lov_name=>'TOP_SQL_BY'
,p_lov_query=>'.'||wwv_flow_imp.id(236910808625037522)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558135
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(236911029447037524)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'CPU Time'
,p_lov_return_value=>'CPU_TIME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(236911210865037524)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Disk Reads'
,p_lov_return_value=>'DISK_READS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(236911407417037525)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Executions'
,p_lov_return_value=>'EXECUTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(236911618778037525)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Buffer Gets'
,p_lov_return_value=>'BUFFER_GETS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(236911815989037525)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Buffer Gets / Rows Processed'
,p_lov_return_value=>'EFFICIENCY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(236912011147037525)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Buffer Gets / Executions'
,p_lov_return_value=>'EFFICIENCY2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/type_collection_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16529130513602905)
,p_lov_name=>'TYPE_COLLECTION_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(16529130513602905)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558136
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16529302646602905)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'VArray'
,p_lov_return_value=>'V'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16529528167602906)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nested Table'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/type_data_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16534820904659665)
,p_lov_name=>'TYPE_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(16534820904659665)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558136
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16535002611659667)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'BFILE'
,p_lov_return_value=>'BFILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16535213310659667)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'BLOB'
,p_lov_return_value=>'BLOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16535418281659667)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'CHAR'
,p_lov_return_value=>'CHAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16535626402659668)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16535817963659668)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16536022932659668)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'DECIMAL'
,p_lov_return_value=>'DECIMAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16536213254659668)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'DOUBLE PRECISION'
,p_lov_return_value=>'DOUBLE PRECISION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16536400283659668)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'FLOAT'
,p_lov_return_value=>'FLOAT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16536606880659669)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'INTEGER'
,p_lov_return_value=>'INTEGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16536824560659669)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16547232731688790)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'REAL'
,p_lov_return_value=>'REAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16547507582690914)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'SMALLINT'
,p_lov_return_value=>'SMALLINT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16547811738692161)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'RAW'
,p_lov_return_value=>'RAW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16548116240693431)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16548420395694645)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'REF'
,p_lov_return_value=>'REF'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16548730785697678)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'< Nested Object >'
,p_lov_return_value=>'NEST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/type_of_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16521502229452853)
,p_lov_name=>'TYPE_OF_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(16521502229452853)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558136
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16521731440452856)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Collection Type'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16521925201452858)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Object Type'
,p_lov_return_value=>'O'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_default_exp_imp_formats
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(40883415986261937)
,p_lov_name=>'UI DEFAULT EXP IMP FORMATS'
,p_lov_query=>'.'||wwv_flow_imp.id(40883415986261937)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558136
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40883610383262047)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Unix'
,p_lov_return_value=>'UNIX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40883829969262053)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40884027551262053)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Database'
,p_lov_return_value=>'DB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_alignment_left_center_right
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(251500722928507973)
,p_lov_name=>'UI_DEF_ALIGNMENT_LEFT_CENTER_RIGHT'
,p_lov_query=>'.'||wwv_flow_imp.id(251500722928507973)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558136
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251500919515507973)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Left'
,p_lov_return_value=>'LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251501105156507973)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Center'
,p_lov_return_value=>'CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251501300215507973)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Right'
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_alignment_l_c_r
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(260501806598530292)
,p_lov_name=>'UI_DEF_ALIGNMENT_L_C_R'
,p_lov_query=>'.'||wwv_flow_imp.id(260501806598530292)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558136
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(260502019605530294)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Left'
,p_lov_return_value=>'L'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(260502229771530295)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Center'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(260502407085530295)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Right'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_display_as_tabular_forms
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(251435312257287190)
,p_lov_name=>'UI_DEF_DISPLAY_AS_TABULAR_FORMS'
,p_lov_query=>'.'||wwv_flow_imp.id(251435312257287190)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558136
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17234522425911770)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Radio Group (named LOV)'
,p_lov_return_value=>'RADIOGROUP_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251435518816287190)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Report Column (display-only, does not save state)'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251435707171287190)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display as Text (based on LOV, does not save state)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251435904461287190)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display as Text (saves state)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251436131397287190)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display as Text (escape special characters, does not save state)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251436331018287190)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Field'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251436513801287190)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Area'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251436712096287191)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Select List'
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251436921215287191)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hidden '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251437110722287191)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Popup LOV'
,p_lov_return_value=>'POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251437316775287191)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (Classic)'
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251437506052287191)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (use application format mask)'
,p_lov_return_value=>'PICK_DATE_USING_APP_FORMAT_MASK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251437713738287195)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251437928196287195)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251438122869287195)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251438327137287195)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH24_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251438527222287195)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251438708379287195)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251438921019287195)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251439126695287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251439305041287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251439508577287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251439705601287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251439912743287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251440126520287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251440332088287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251440513083287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251440720307287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251440914527287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251441107529287196)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251441327665287197)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251441519610287197)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251441716061287197)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251441922940287197)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251442121133287197)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251442323229287197)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251442518523287197)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251442702648287197)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251442915305287199)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251443114390287199)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251443317438287199)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH24_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251443530076287199)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251443706296287199)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251443923019287199)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251444119218287199)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251444312958287199)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (use Application Date Format)'
,p_lov_return_value=>'PICK_DATE_USING_APP_DATE_FORMAT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(619426426716882935)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker'
,p_lov_return_value=>'DATE_PICKER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17235123595921491)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Popup Key LOV (named LOV)'
,p_lov_return_value=>'POPUPKEY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17235632599924147)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Simple Checkbox'
,p_lov_return_value=>'SIMPLE_CHECKBOX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_static_dynamic
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(251523907288749450)
,p_lov_name=>'UI_DEF_STATIC_DYNAMIC'
,p_lov_query=>'.'||wwv_flow_imp.id(251523907288749450)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558137
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251524122983749452)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Static'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(251524330798749453)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Dynamic'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/unix_dos
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88081812938981328)
,p_lov_name=>'UNIX.DOS'
,p_lov_query=>'.'||wwv_flow_imp.id(88081812938981328)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558137
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88082021798981329)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88082214036981329)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'UNIX'
,p_lov_return_value=>'UNIX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/user_interface_form_defaults_sync_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(40766106443619635)
,p_lov_name=>'USER INTERFACE FORM DEFAULTS SYNC OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(40766106443619635)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558137
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40766308005619649)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Label'
,p_lov_return_value=>'LABEL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40766500283619653)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Display As'
,p_lov_return_value=>'DISPLAY_AS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40766713910619654)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Form Display Sequence'
,p_lov_return_value=>'FORM_DISPLAY_SEQUENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40766902092619654)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Element Width'
,p_lov_return_value=>'ELEMENT_WIDTH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40767122890619654)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Element Maximum Width'
,p_lov_return_value=>'ELEMENT_MAX_WIDTH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40767319691619654)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Element Height'
,p_lov_return_value=>'ELEMENT_HEIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40767510229619654)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Alignment'
,p_lov_return_value=>'ITEM_ALIGNMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40767731122619654)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Help Text'
,p_lov_return_value=>'HELP_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40767913178619654)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Column Group'
,p_lov_return_value=>'COLUMN_GROUP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_detail_summary
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(183733207435875441)
,p_lov_name=>'VIEW_DETAIL_SUMMARY'
,p_lov_query=>'.'||wwv_flow_imp.id(183733207435875441)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558137
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(183733411221875446)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Detail'
,p_lov_return_value=>'DETAIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(183733609162875449)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Summary'
,p_lov_return_value=>'SUMMARY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_credentials_for_dbms_cloud
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3034883284660886)
,p_lov_name=>'WEB_CREDENTIALS_FOR_DBMS_CLOUD'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       authentication_type,',
'       client_id',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID',
'   and authentication_type in (''OCI'', ''BASIC'')'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>75558137
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(3035303136662958)
,p_query_column_name=>'ID'
,p_display_sequence=>10
,p_data_type=>'NUMBER'
,p_is_visible=>'N'
,p_is_searchable=>'N'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(3035790565662962)
,p_query_column_name=>'NAME'
,p_heading=>'Name'
,p_display_sequence=>20
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(3036173161662962)
,p_query_column_name=>'AUTHENTICATION_TYPE'
,p_heading=>'Authentication Type'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(3036569773662962)
,p_query_column_name=>'CLIENT_ID'
,p_heading=>'User ID'
,p_display_sequence=>40
,p_data_type=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/y_n_returns_y_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88037119678519608)
,p_lov_name=>'Y.N.RETURNS.Y.N'
,p_lov_query=>'.'||wwv_flow_imp.id(88037119678519608)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558137
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88037301694519609)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88037513209519609)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_true_false
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(550748599416480697)
,p_lov_name=>'YES NO TRUE FALSE'
,p_lov_query=>'.'||wwv_flow_imp.id(550748599416480697)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558137
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(550748896421480698)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'TRUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(550749224337480699)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'FALSE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23482928300634173)
,p_lov_name=>'YES.NO.RETURNS.Y.N'
,p_lov_query=>'.'||wwv_flow_imp.id(23482928300634173)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558137
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23483215241634177)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23483425275634179)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/y_noprompt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88018003898325845)
,p_lov_name=>'Y_NOPROMPT'
,p_lov_query=>'.'||wwv_flow_imp.id(88018003898325845)||'.'
,p_location=>'STATIC'
,p_version_scn=>75558137
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88018226427325846)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;',
'',
''))
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/pages/page_groups
begin
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215533113079716670)
,p_group_name=>'Browse Database Object Definitions'
,p_group_desc=>'Browse database objects.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215538527409730225)
,p_group_name=>'Create / Alter / Drop Database Objects'
,p_group_desc=>'Wizards to create database objects.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215532403383713875)
,p_group_name=>'DDL Generation'
,p_group_desc=>'Create data definition language SQL scripts.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215533519659718594)
,p_group_name=>'Data Dicitonary Browsing'
,p_group_desc=>'Query the data dictionary.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(275619009526176844)
,p_group_name=>'Data Dictionary Reporting'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(276009919979760075)
,p_group_name=>'Data Dictionary Security Reports'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(276037127560809519)
,p_group_name=>'Data Dictionary Table Reports'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(109807152552070130)
,p_group_name=>'Data Generator'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(206250111084432914)
,p_group_name=>'Database Monitoring'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(206341928994677765)
,p_group_name=>'Manage Database Users (Schemas)'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(11540120040990569)
,p_group_name=>'Object Browser Iframe Pages'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(276002212445738952)
,p_group_name=>'PL/SQL Object Reports'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215663614239000844)
,p_group_name=>'Query By Example'
,p_group_desc=>'Perform query and update of database table data. Includes insert update and delete functionality.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215661000733996927)
,p_group_name=>'Recycle Bin'
,p_group_desc=>'Facilitate use of 10g recycle bin'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213236325564854129)
,p_group_name=>'SQL Command Processing'
,p_group_desc=>'SQL Command Processing'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213236600761856491)
,p_group_name=>'Script Management'
,p_group_desc=>'All pages related to the definition and management of scripts.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215628425752985221)
,p_group_name=>'Table Normalization'
,p_group_desc=>'Create a look up table.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(201270629259751113)
,p_group_name=>'UI Defaults'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(11093307704620192)
,p_group_name=>'Version 2.0'
,p_group_desc=>'Keep this page in version 2.0'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(11539602725985552)
,p_group_name=>'Version 2.0 : Object Browser'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbs/sql_workshop_breadcrumb
begin
wwv_flow_imp_shared.create_menu(
 p_id=>wwv_flow_imp.id(6696510824685479)
,p_name=>'sql.workshop.breadcrumb'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(772329493998247)
,p_short_name=>'<span class="u-VisuallyHidden">SQL Workshop</span><span class="a-Icon icon-breadcrumb-previous" title="SQL Workshop"></span>'
,p_link=>'f?p=&APP_ID.:3002:&SESSION.::&DEBUG.:::'
,p_page_id=>3002
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1617280034078536)
,p_parent_id=>wwv_flow_imp.id(1739076704334540)
,p_short_name=>'Blueprint Designer'
,p_link=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.:::'
,p_page_id=>4100
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1739076704334540)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Data Generator'
,p_link=>'f?p=&APP_ID.:4000:&SESSION.::&DEBUG.:::'
,p_page_id=>4000
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1739233835336975)
,p_parent_id=>wwv_flow_imp.id(1739076704334540)
,p_short_name=>'Create Tables Blueprint'
,p_link=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:::'
,p_page_id=>4001
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1739498683340270)
,p_parent_id=>wwv_flow_imp.id(1739233835336975)
,p_short_name=>'Table: &P4002_BLUEPRINT_TABLE_NAME.'
,p_link=>'f?p=&APP_ID.:4002:&SESSION.::&DEBUG.:::'
,p_page_id=>4002
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1917207507033256)
,p_parent_id=>wwv_flow_imp.id(772329493998247)
,p_short_name=>'Object Browser'
,p_link=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
,p_page_id=>2000
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2107388801517405)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Load from Object Store'
,p_link=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:3130::'
,p_page_id=>3130
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2234766158770718)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Load from Object Store'
,p_link=>'f?p=&APP_ID.:3132:&SESSION.::&DEBUG.:::'
,p_page_id=>3132
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2632992076169026)
,p_parent_id=>wwv_flow_imp.id(2107388801517405)
,p_short_name=>'Review External Table'
,p_link=>'f?p=&APP_ID.:3140:&SESSION.::&DEBUG.:::'
,p_page_id=>3140
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2911233921630113)
,p_parent_id=>wwv_flow_imp.id(1739076704334540)
,p_short_name=>'Built Ins'
,p_link=>'f?p=&APP_ID.:4011:&SESSION.::&DEBUG.:::'
,p_page_id=>4011
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6705201527713238)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Data Dictionary'
,p_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_page_id=>13
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6706426100716981)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'All Objects'
,p_link=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:::'
,p_page_id=>500
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6811015570619086)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Generate DDL'
,p_link=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:::'
,p_page_id=>18
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6812109315622008)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Generate DDL'
,p_link=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::'
,p_page_id=>43
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6813302846625021)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Generate DDL'
,p_link=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:::'
,p_page_id=>44
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6814424184630342)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Generate DDL'
,p_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:::'
,p_page_id=>29
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8926117673071967)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Object Grants'
,p_link=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:::'
,p_page_id=>1401
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8952218341276601)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Column Privileges'
,p_link=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::'
,p_page_id=>1402
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8971325993409812)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Role Privileges'
,p_link=>'f?p=&APP_ID.:1502:&SESSION.::&DEBUG.:::'
,p_page_id=>1502
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10124106014708590)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Manage Script Results'
,p_link=>'f?p=&APP_ID.:1220:&SESSION.::&DEBUG.:1220::'
,p_page_id=>1220
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10592208399879519)
,p_parent_id=>wwv_flow_imp.id(772329493998247)
,p_short_name=>'SQL Commands'
,p_link=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.:::'
,p_page_id=>1003
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10593427149886024)
,p_parent_id=>wwv_flow_imp.id(772329493998247)
,p_short_name=>'SQL Scripts'
,p_link=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_page_id=>1004
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10594829078900305)
,p_parent_id=>wwv_flow_imp.id(772329493998247)
,p_short_name=>'Utilities'
,p_link=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.:::'
,p_page_id=>1005
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10596216354906213)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Query Builder'
,p_link=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.:::'
,p_page_id=>1002
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10992323079081645)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Upload Script'
,p_link=>'f?p=&FLOW_ID.:1017:&SESSION.'
,p_page_id=>1017
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11068702995513360)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Invalid Objects'
,p_link=>'f?p=&APP_ID.:1040:&SESSION.::&DEBUG.:::'
,p_page_id=>1040
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11085502299574373)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Object Reports'
,p_link=>'f?p=&APP_ID.:1042:&SESSION.::&DEBUG.:::'
,p_page_id=>1042
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11149705248454307)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'PL/SQL Program Unit Arguments'
,p_link=>'f?p=&APP_ID.:1046:&SESSION.::&DEBUG.:::'
,p_page_id=>1046
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11153616234464356)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Table Columns'
,p_link=>'f?p=&APP_ID.:1047:&SESSION.::&DEBUG.:::'
,p_page_id=>1047
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11217630077734286)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Table Storage Sizes'
,p_link=>'f?p=&APP_ID.:1048:&SESSION.::&DEBUG.:::'
,p_page_id=>1048
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11288509439457981)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Table Statistics'
,p_link=>'f?p=&APP_ID.:1052:&SESSION.::&DEBUG.:::'
,p_page_id=>1052
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11326702174643629)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'PL/SQL Unit Line Counts'
,p_link=>'f?p=&APP_ID.:1054:&SESSION.::&DEBUG.:::'
,p_page_id=>1054
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11338430795706423)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Object Creation Calendar'
,p_link=>'f?p=&APP_ID.:1055:&SESSION.::&DEBUG.:::'
,p_page_id=>1055
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11357823604800886)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Object Counts by Type'
,p_link=>'f?p=&APP_ID.:1059:&SESSION.::&DEBUG.:::'
,p_page_id=>1059
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11399029987478216)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Recycle Bin'
,p_link=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.:::'
,p_page_id=>1070
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11862912827302953)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Results'
,p_link=>'f?p=&APP_ID.:1225:&SESSION.::&DEBUG.:::'
,p_page_id=>1225
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(14636719155541383)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Schema Comparison'
,p_link=>'f?p=&FLOW_ID.:1350:&SESSION.'
,p_page_id=>1350
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(17981116039285577)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Table Comments'
,p_link=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.:::'
,p_page_id=>701
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(18641121311026961)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Tables without Primary Keys'
,p_link=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:::'
,p_page_id=>702
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(18645002872040514)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Unindexed Foreign Keys'
,p_link=>'f?p=&APP_ID.:704:&SESSION.::&DEBUG.:::'
,p_page_id=>704
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(20466103415554205)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Database Administrator Login'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>1
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(21105931218170005)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Table Constraints'
,p_link=>'f?p=&APP_ID.:706:&SESSION.::&DEBUG.:::'
,p_page_id=>706
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22279723159373331)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Run Script'
,p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_page_id=>10
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22285026166387102)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Script Editor'
,p_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_page_id=>60
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22511901715091409)
,p_parent_id=>wwv_flow_imp.id(6705201527713238)
,p_short_name=>'Data Dictionary Browser'
,p_link=>'f?p=&FLOW_ID.:14:&SESSION.'
,p_page_id=>14
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22513030170093436)
,p_parent_id=>wwv_flow_imp.id(6705201527713238)
,p_short_name=>'Data Dictionary Browser'
,p_link=>'f?p=&FLOW_ID.:15:&SESSION.'
,p_page_id=>15
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(27996403095868309)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Invalid Script'
,p_link=>'f?p=&APP_ID.:1022:&SESSION.::&DEBUG.:::'
,p_page_id=>1022
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(28034702528035781)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Parse Script'
,p_link=>'f?p=&FLOW_ID.:1023:&SESSION.'
,p_page_id=>1023
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(29042426642278445)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Tables without Indexes'
,p_link=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.:::'
,p_page_id=>707
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40285323892651842)
,p_parent_id=>wwv_flow_imp.id(421010727467722425)
,p_short_name=>'Table Dictionary'
,p_link=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
,p_page_id=>800
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40292805535877838)
,p_parent_id=>wwv_flow_imp.id(40285323892651842)
,p_short_name=>'Create Defaults'
,p_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_page_id=>801
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40299503213041788)
,p_parent_id=>wwv_flow_imp.id(40285323892651842)
,p_short_name=>'Table and Column Properties'
,p_link=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
,p_page_id=>802
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40567512492661701)
,p_parent_id=>wwv_flow_imp.id(40299503213041788)
,p_short_name=>'Column Defaults'
,p_link=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:::'
,p_page_id=>803
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40643306074424515)
,p_parent_id=>wwv_flow_imp.id(40299503213041788)
,p_short_name=>'Details'
,p_link=>'f?p=&APP_ID.:804:&SESSION.::&DEBUG.:::'
,p_page_id=>804
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40820227368905885)
,p_parent_id=>wwv_flow_imp.id(40299503213041788)
,p_short_name=>'Remove'
,p_link=>'f?p=&APP_ID.:830:&SESSION.::&DEBUG.:::'
,p_page_id=>830
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40837720793349176)
,p_parent_id=>wwv_flow_imp.id(40299503213041788)
,p_short_name=>'Column Groups'
,p_link=>'f?p=&FLOW_ID.:805:&SESSION.'
,p_page_id=>805
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40849914508722527)
,p_parent_id=>wwv_flow_imp.id(40285323892651842)
,p_short_name=>'Synchronize Defaults'
,p_link=>'f?p=&APP_ID.:840:&SESSION.::&DEBUG.:::'
,p_page_id=>840
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40878107658219856)
,p_parent_id=>wwv_flow_imp.id(40285323892651842)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.:::'
,p_page_id=>841
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40882008035232666)
,p_parent_id=>wwv_flow_imp.id(40285323892651842)
,p_short_name=>'Import'
,p_link=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_page_id=>842
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40886501144281716)
,p_parent_id=>wwv_flow_imp.id(40285323892651842)
,p_short_name=>'Import'
,p_link=>'f?p=&APP_ID.:843:&SESSION.::&DEBUG.:::'
,p_page_id=>843
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(69179911399462494)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Tables without Triggers'
,p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
,p_page_id=>2
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(72162217233653931)
,p_parent_id=>wwv_flow_imp.id(11399029987478216)
,p_short_name=>'Dropped Objects'
,p_link=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::'
,p_page_id=>400
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(75123728807801147)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Generate DDL'
,p_link=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:::'
,p_page_id=>45
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(111995318366763047)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Generate DDL'
,p_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_page_id=>12
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(133761526646244887)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Database Monitor'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(134582607728955084)
,p_parent_id=>wwv_flow_imp.id(133761526646244887)
,p_short_name=>'Top SQL'
,p_link=>'f?p=&FLOW_ID.:21:&SESSION.'
,p_page_id=>21
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(137474117958285727)
,p_parent_id=>wwv_flow_imp.id(133761526646244887)
,p_short_name=>'Long Operations'
,p_link=>'f?p=&FLOW_ID.:34:&SESSION.'
,p_page_id=>34
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(143179626108764932)
,p_parent_id=>wwv_flow_imp.id(72162217233653931)
,p_short_name=>'Object Details'
,p_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::'
,p_page_id=>401
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(143180608231769218)
,p_parent_id=>wwv_flow_imp.id(11399029987478216)
,p_short_name=>'Purge Recycle Bin'
,p_link=>'f?p=&APP_ID.:403:&SESSION.::&DEBUG.:::'
,p_page_id=>403
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(150053105689895122)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Script Quotas'
,p_link=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_page_id=>31
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(159591503203412870)
,p_parent_id=>wwv_flow_imp.id(133761526646244887)
,p_short_name=>'Sessions'
,p_link=>'f?p=&FLOW_ID.:540:&SESSION.'
,p_page_id=>540
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(159755809418519186)
,p_parent_id=>wwv_flow_imp.id(159591503203412870)
,p_short_name=>'Session Details'
,p_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.:::'
,p_page_id=>550
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(159933105269080223)
,p_parent_id=>wwv_flow_imp.id(159591503203412870)
,p_short_name=>'Kill Session'
,p_link=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.:::'
,p_page_id=>549
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(160130313889480180)
,p_parent_id=>wwv_flow_imp.id(159591503203412870)
,p_short_name=>'SQL'
,p_link=>'f?p=&APP_ID.:542:&SESSION.::&DEBUG.:::'
,p_page_id=>542
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(160176710875611770)
,p_parent_id=>wwv_flow_imp.id(159591503203412870)
,p_short_name=>'I/O'
,p_link=>'f?p=&APP_ID.:545:&SESSION.::&DEBUG.:::'
,p_page_id=>545
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(160179326112616109)
,p_parent_id=>wwv_flow_imp.id(159591503203412870)
,p_short_name=>'Locks'
,p_link=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.:::'
,p_page_id=>541
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(160301306026960460)
,p_parent_id=>wwv_flow_imp.id(159591503203412870)
,p_short_name=>'Open Cursors'
,p_link=>'f?p=&APP_ID.:543:&SESSION.::&DEBUG.:::'
,p_page_id=>543
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(160475100044505141)
,p_parent_id=>wwv_flow_imp.id(160130313889480180)
,p_short_name=>'SQL Plan'
,p_link=>'f?p=&FLOW_ID.:551:&SESSION.'
,p_page_id=>551
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(160542529171631000)
,p_parent_id=>wwv_flow_imp.id(160301306026960460)
,p_short_name=>'Cursor Detail'
,p_link=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.:::'
,p_page_id=>546
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(163508316960932084)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'Search PL/SQL Source Code'
,p_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_page_id=>27
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(164008763793256066)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Manage Sample Data'
,p_link=>'f?p=&APP_ID.:200:&SESSION.'
,p_page_id=>200
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(164035265026435705)
,p_parent_id=>wwv_flow_imp.id(164008763793256066)
,p_short_name=>'Manage Dataset'
,p_link=>'f?p=&APP_ID.:201:&SESSION.'
,p_page_id=>201
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(168883113098410783)
,p_parent_id=>wwv_flow_imp.id(159591503203412870)
,p_short_name=>'Waits'
,p_link=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.:::'
,p_page_id=>548
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(171482002943811468)
,p_parent_id=>wwv_flow_imp.id(772329493998247)
,p_short_name=>'Create Package'
,p_link=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:::'
,p_page_id=>120
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(171486607219855054)
,p_parent_id=>wwv_flow_imp.id(772329493998247)
,p_short_name=>'Create Package'
,p_link=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:::'
,p_page_id=>124
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(171488126185861375)
,p_parent_id=>wwv_flow_imp.id(772329493998247)
,p_short_name=>'Create Package'
,p_link=>'f?p=&APP_ID.:125:&SESSION.::&DEBUG.:::'
,p_page_id=>125
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(172518105625045296)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'About Database'
,p_link=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:::'
,p_page_id=>36
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(182583013828345804)
,p_parent_id=>wwv_flow_imp.id(133761526646244887)
,p_short_name=>'System Statistics'
,p_link=>'f?p=&APP_ID.:560:&SESSION.::&DEBUG.:::'
,p_page_id=>560
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(196241518637196386)
,p_parent_id=>wwv_flow_imp.id(421010727467722425)
,p_short_name=>'Attribute Dictionary'
,p_link=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::'
,p_page_id=>6
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(197565613605290234)
,p_parent_id=>wwv_flow_imp.id(196241518637196386)
,p_short_name=>'Column Details'
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(200281305325646013)
,p_parent_id=>wwv_flow_imp.id(197565613605290234)
,p_short_name=>'Synonym'
,p_link=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:::'
,p_page_id=>30
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201423513077254455)
,p_parent_id=>wwv_flow_imp.id(40299503213041788)
,p_short_name=>'Table Defaults'
,p_link=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:::'
,p_page_id=>19
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201465410091357808)
,p_parent_id=>wwv_flow_imp.id(40285323892651842)
,p_short_name=>'Migrate'
,p_link=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:::'
,p_page_id=>32
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201468702160374868)
,p_parent_id=>wwv_flow_imp.id(201465410091357808)
,p_short_name=>'Confirm'
,p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_page_id=>33
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(221315102551645720)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Export SQL Scripts'
,p_link=>'f?p=&FLOW_ID.:65:&SESSION.'
,p_page_id=>65
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(221325920426667820)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Import Scripts'
,p_link=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:::'
,p_page_id=>112
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(222573212803039290)
,p_parent_id=>wwv_flow_imp.id(10593427149886024)
,p_short_name=>'Import Scripts'
,p_link=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:::'
,p_page_id=>115
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(239008520667654108)
,p_parent_id=>wwv_flow_imp.id(11085502299574373)
,p_short_name=>'System Privileges'
,p_link=>'f?p=&APP_ID.:1404:&SESSION.::&DEBUG.:::'
,p_page_id=>1404
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(262136511357898947)
,p_parent_id=>wwv_flow_imp.id(196241518637196386)
,p_short_name=>'Grid Edit'
,p_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::'
,p_page_id=>28
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(293412507991016597)
,p_parent_id=>wwv_flow_imp.id(40567512492661701)
,p_short_name=>'Static List of Values'
,p_link=>'f?p=&FLOW_ID.:37:&SESSION.'
,p_page_id=>37
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(421010727467722425)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'UI Defaults'
,p_link=>'f?p=&APP_ID.:813:&SESSION.::&DEBUG.:::'
,p_page_id=>813
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(428883026446520866)
,p_parent_id=>wwv_flow_imp.id(40567512492661701)
,p_short_name=>'Create Static List of Values'
,p_link=>'f?p=&FLOW_ID.:40:&SESSION.'
,p_page_id=>40
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(429083825310173254)
,p_parent_id=>wwv_flow_imp.id(40299503213041788)
,p_short_name=>'Synchronize with Database'
,p_link=>'f?p=&APP_ID.:807:&SESSION.::&DEBUG.:::'
,p_page_id=>807
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(442018226743378979)
,p_parent_id=>wwv_flow_imp.id(196241518637196386)
,p_short_name=>'Export'
,p_link=>'f?p=&FLOW_ID.:39:&SESSION.'
,p_page_id=>39
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(442035418735604919)
,p_parent_id=>wwv_flow_imp.id(196241518637196386)
,p_short_name=>'Import'
,p_link=>'f?p=&FLOW_ID.:41:&SESSION.'
,p_page_id=>41
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(442061305390114586)
,p_parent_id=>wwv_flow_imp.id(196241518637196386)
,p_short_name=>'Import'
,p_link=>'f?p=&FLOW_ID.:56:&SESSION.'
,p_page_id=>56
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(460475029741643216)
,p_parent_id=>wwv_flow_imp.id(17981116039285577)
,p_short_name=>'Edit'
,p_link=>'f?p=&FLOW_ID.:70:&SESSION.'
,p_page_id=>70
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1104480510265001727)
,p_parent_id=>wwv_flow_imp.id(772329493998247)
,p_short_name=>'Create Package'
,p_link=>'f?p=&APP_ID.:126:&SESSION.::&DEBUG.:::'
,p_page_id=>126
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4213233088501710020)
,p_parent_id=>wwv_flow_imp.id(10594829078900305)
,p_short_name=>'Quick SQL'
,p_link=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
,p_page_id=>1100
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4067704225251042)
,p_parent_id=>wwv_flow_imp.id(1739076704334540)
,p_option_sequence=>20
,p_short_name=>'Blueprint: &P4015_BLUEPRINT_NAME.'
,p_link=>'f?p=&APP_ID.:4015:&SESSION.::&DEBUG.:::'
,p_page_id=>4015
);
end;
/
prompt --application/shared_components/navigation/breadcrumbs/alternative_sql_plan
begin
wwv_flow_imp_shared.create_menu(
 p_id=>wwv_flow_imp.id(238735327519050534)
,p_name=>'Alternative SQL Plan'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(238744703025100258)
,p_parent_id=>wwv_flow_imp.id(239011303829658740)
,p_short_name=>'Database Monitor'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(238747600732109040)
,p_parent_id=>wwv_flow_imp.id(238744703025100258)
,p_short_name=>'Top SQL'
,p_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_page_id=>21
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(238748709736111653)
,p_parent_id=>wwv_flow_imp.id(238747600732109040)
,p_short_name=>'SQL Plan'
,p_link=>'f?p=&APP_ID.:551:&SESSION.::&DEBUG.:::'
,p_page_id=>551
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(239011303829658740)
,p_parent_id=>wwv_flow_imp.id(467828023586139366)
,p_short_name=>'Utilities'
,p_link=>'f?p=&APP_ID.:1005:&SESSION.::&DEBUG.:::'
,p_page_id=>1005
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(467828023586139366)
,p_parent_id=>wwv_flow_imp.id(238741426181078594)
,p_short_name=>'SQL Workshop'
,p_link=>'f?p=&APP_ID.:3002:&SESSION.::&DEBUG.:::'
,p_page_id=>3002
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(851340608959428999)
,p_short_name=>'Import Scripts'
,p_link=>'f?p=&FLOW_ID.:115:&SESSION.'
,p_page_id=>115
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_rw_faceted_search
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(2060528835933702)
,p_theme_id=>3
,p_name=>'APEX RW - Faceted Search'
,p_internal_name=>'APEX_RW_-_FACETED_SEARCH'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES# a-Page--facetedSearch" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div id="main" class="a-Body">',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>383682332851249713
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293466290023956040)
,p_page_template_id=>wwv_flow_imp.id(2060528835933702)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293466745309956041)
,p_page_template_id=>wwv_flow_imp.id(2060528835933702)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293467243124956041)
,p_page_template_id=>wwv_flow_imp.id(2060528835933702)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293467733758956041)
,p_page_template_id=>wwv_flow_imp.id(2060528835933702)
,p_name=>'Facets'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293468229496956041)
,p_page_template_id=>wwv_flow_imp.id(2060528835933702)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293468791199956042)
,p_page_template_id=>wwv_flow_imp.id(2060528835933702)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293469219997956042)
,p_page_template_id=>wwv_flow_imp.id(2060528835933702)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_page_designer
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(8700783499134798)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Page Designer'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="#PAGE_CSS_CLASSES#">',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#a_PageDesigner" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_01#',
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" style="display: none;" id="pdNotification">',
' <div class="a-AlertMessages-item">',
'  <div id="pdNotificationState" class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span id="pdNotificationIcon" class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="pdNotificationMessage">#PD_MESSAGE#</h5>',
'      <button id="pdNotificationClose" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'',
'',
'<div id="a_PageDesigner" class="a-PageDesigner resize">',
'  #REGION_POSITION_02#',
'  #REGION_POSITION_03#',
'  #REGION_POSITION_04#',
'  #BODY#',
'  <div style="display:none;">',
'  #REGION_POSITION_06#',
'  </div>',
'</div>',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>-->',
'<div style="display: none;" id="successMessage" role="alert">#SUCCESS_MESSAGE#</div>',
''))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>'<div class="apex-container">#ROWS#</div>'
,p_grid_row_template=>'<div class="apex-row">#COLUMNS#</div>'
,p_grid_column_template=>'<div class="apex-col apex-col-#COLUMN_NUMBER# #CSS_CLASSES#">#CONTENT#</div>'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(8707702767134841)
,p_page_template_id=>wwv_flow_imp.id(8700783499134798)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(8708205425134841)
,p_page_template_id=>wwv_flow_imp.id(8700783499134798)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(8708748551134841)
,p_page_template_id=>wwv_flow_imp.id(8700783499134798)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(8709230306134842)
,p_page_template_id=>wwv_flow_imp.id(8700783499134798)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(8709793241134842)
,p_page_template_id=>wwv_flow_imp.id(8700783499134798)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(8710277851134842)
,p_page_template_id=>wwv_flow_imp.id(8700783499134798)
,p_name=>'Dialog Area'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>-1
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(8710720911134843)
,p_page_template_id=>wwv_flow_imp.id(8700783499134798)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/done_minimal_for_ppr_pulls
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(14599108081253832)
,p_theme_id=>3
,p_name=>'[x] Minimal For PPR Pulls'
,p_internal_name=>'DONE_MINIMAL_FOR_PPR_PULLS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com" xmlns:apex="http://apex.oracle.com">',
'',
'<head>',
'',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'<title>#TITLE#</title>',
'</head>',
'<body onload="parent.htmldb_PageLoaded(this)">',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<htmldb:SUCCESS_MESSAGE><div id="SUCCESS_MESSAGE">#SUCCESS_MESSAGE#</div></htmldb:SUCCESS_MESSAGE>',
'<htmldb:NOTIFICATION_MESSAGE><div id="NOTIFICATION_MESSAGE">#NOTIFICATION_MESSAGE#</div></htmldb:NOTIFICATION_MESSAGE>',
'<htmldb:GLOBAL_NOTIFICATION><div id="GLOBAL_NOTIFICATION">#GLOBAL_NOTIFICATION#</div></htmldb:GLOBAL_NOTIFICATION>',
'<htmldb:REGION_POSITION_01><div id="REGION_POSITION_01">#REGION_POSITION_01#</div></htmldb:REGION_POSITION_01>',
'<htmldb:REGION_POSITION_02><div id="REGION_POSITION_02">#REGION_POSITION_02#</div></htmldb:REGION_POSITION_02>',
'<htmldb:REGION_POSITION_03><div id="REGION_POSITION_03">#REGION_POSITION_03#</div></htmldb:REGION_POSITION_03>',
'<htmldb:REGION_POSITION_04><div id="REGION_POSITION_04">#REGION_POSITION_04#</div></htmldb:REGION_POSITION_04>',
'<htmldb:REGION_POSITION_05><div id="REGION_POSITION_05">#REGION_POSITION_05#</div></htmldb:REGION_POSITION_05>',
'<htmldb:REGION_POSITION_06><div id="REGION_POSITION_06">#REGION_POSITION_06#</div></htmldb:REGION_POSITION_06>',
'<htmldb:REGION_POSITION_08><div id="REGION_POSITION_08">#REGION_POSITION_08#</div></htmldb:REGION_POSITION_08>',
'<htmldb:BOX_BODY><div id="BOX_BODY">#BODY#</div></htmldb:BOX_BODY>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden" role="alert">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_theme_class_id=>8
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>14502301802938058
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72720613825033039)
,p_page_template_id=>wwv_flow_imp.id(14599108081253832)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72721161344033039)
,p_page_template_id=>wwv_flow_imp.id(14599108081253832)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72721644609033040)
,p_page_template_id=>wwv_flow_imp.id(14599108081253832)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72722131917033041)
,p_page_template_id=>wwv_flow_imp.id(14599108081253832)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72722693387033041)
,p_page_template_id=>wwv_flow_imp.id(14599108081253832)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72723140320033042)
,p_page_template_id=>wwv_flow_imp.id(14599108081253832)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72723686956033042)
,p_page_template_id=>wwv_flow_imp.id(14599108081253832)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72724150466033042)
,p_page_template_id=>wwv_flow_imp.id(14599108081253832)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/done_popup
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(102479827851590823)
,p_theme_id=>3
,p_name=>'[x] Popup'
,p_internal_name=>'DONE_POPUP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8">',
'    <title>#TITLE#</title>',
'    <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'    ',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="aPopupPage">',
'    <noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>#REGION_POSITION_02##REGION_POSITION_03##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##BODY#</div>',
'<div style="text-align:middle;">#REGION_POSITION_08#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden" role="alert">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>19940022257958945
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72747837208039244)
,p_page_template_id=>wwv_flow_imp.id(102479827851590823)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72748383231039244)
,p_page_template_id=>wwv_flow_imp.id(102479827851590823)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72748845206039245)
,p_page_template_id=>wwv_flow_imp.id(102479827851590823)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72749324646039245)
,p_page_template_id=>wwv_flow_imp.id(102479827851590823)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72749812168039246)
,p_page_template_id=>wwv_flow_imp.id(102479827851590823)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72750360374039246)
,p_page_template_id=>wwv_flow_imp.id(102479827851590823)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72750803591039247)
,p_page_template_id=>wwv_flow_imp.id(102479827851590823)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_2_popup
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(203703017586195109)
,p_theme_id=>3
,p_name=>'[x] APEX 4.2 - Popup'
,p_internal_name=>'APEX_4.2_POPUP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title><link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head><body #ONLOAD# style="min-width:380px;"><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>',
'  <div id="RP2">#REGION_POSITION_02#</div>',
'  <div id="RP3">#REGION_POSITION_03#</div>',
'  <div id="RP4">#REGION_POSITION_04#</div>',
'  <div id="RP5">#REGION_POSITION_05#</div>',
'  <div class="popupContent" id="ContentArea">#BODY#</div>',
'</div>',
'<div id="RP8" style="text-align:middle;">#REGION_POSITION_08#</div>',
'<br />',
'<br />',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden" role="alert">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>36144306570651063
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72523296440978248)
,p_page_template_id=>wwv_flow_imp.id(203703017586195109)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72523702339978248)
,p_page_template_id=>wwv_flow_imp.id(203703017586195109)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72524242413978249)
,p_page_template_id=>wwv_flow_imp.id(203703017586195109)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72524768893978249)
,p_page_template_id=>wwv_flow_imp.id(203703017586195109)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72525268743978250)
,p_page_template_id=>wwv_flow_imp.id(203703017586195109)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72525772106978250)
,p_page_template_id=>wwv_flow_imp.id(203703017586195109)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_data_generator
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(255350889127290340)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Data Generator'
,p_internal_name=>'APEX_5.0_DATA_GENERATOR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div id="main" class="a-Body a-DataGen-container" role="main">',
'    <div class="a-Side a-Side--left a-DataGen-tree">#TREE#</div>',
'    <div class="a-Main a-DataGen-pe">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </div>',
'    <aside class="a-Side a-DataGen-help">#HELP#</aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove" aria-hidden="tru'
||'e"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove" aria-hidden="tru'
||'e"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(255351268404290374)
,p_page_template_id=>wwv_flow_imp.id(255350889127290340)
,p_name=>'Property Editor'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(255351736860290390)
,p_page_template_id=>wwv_flow_imp.id(255350889127290340)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(255352260601290390)
,p_page_template_id=>wwv_flow_imp.id(255350889127290340)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(255352793458290391)
,p_page_template_id=>wwv_flow_imp.id(255350889127290340)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(255353290296290391)
,p_page_template_id=>wwv_flow_imp.id(255350889127290340)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(255353714187290391)
,p_page_template_id=>wwv_flow_imp.id(255350889127290340)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(255354268275290392)
,p_page_template_id=>wwv_flow_imp.id(255350889127290340)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(255355927746326622)
,p_page_template_id=>wwv_flow_imp.id(255350889127290340)
,p_name=>'Tree'
,p_placeholder=>'TREE'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(385762900697898960)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'</header>',
'  <div id="main" class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293197477190857439)
,p_page_template_id=>wwv_flow_imp.id(385762900697898960)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293197913546857439)
,p_page_template_id=>wwv_flow_imp.id(385762900697898960)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293198474112857440)
,p_page_template_id=>wwv_flow_imp.id(385762900697898960)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293198939496857440)
,p_page_template_id=>wwv_flow_imp.id(385762900697898960)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293199445451857440)
,p_page_template_id=>wwv_flow_imp.id(385762900697898960)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293199911520857441)
,p_page_template_id=>wwv_flow_imp.id(385762900697898960)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293200410154857441)
,p_page_template_id=>wwv_flow_imp.id(385762900697898960)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(690782249755803171)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Dialog'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,baseDialogClass:''a-Dialog--uiDialog'',dialogClass:#DIALOG_CSS_CLASSES#,jsDialogClass:true,#DIALOG'
||'_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293496531310977325)
,p_page_template_id=>wwv_flow_imp.id(690782249755803171)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293497030739977325)
,p_page_template_id=>wwv_flow_imp.id(690782249755803171)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293497504241977326)
,p_page_template_id=>wwv_flow_imp.id(690782249755803171)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog_grid_layout
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(690782638016803186)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog (Grid Layout)'
,p_internal_name=>'APEX_5.0_DIALOG_GRID_LAYOUT'
,p_is_popup=>true
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#',
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE#',
'#NOTIFICATION_MESSAGE#',
'#GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'#BODY#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#REGION_POSITION_06#',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden" role="alert">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'400'
,p_dialog_width=>'600'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>561572340071582364
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140071016629349459)
,p_page_template_id=>wwv_flow_imp.id(690782638016803186)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140071106516349459)
,p_page_template_id=>wwv_flow_imp.id(690782638016803186)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140071277608349459)
,p_page_template_id=>wwv_flow_imp.id(690782638016803186)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140071396624349459)
,p_page_template_id=>wwv_flow_imp.id(690782638016803186)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140071454429349459)
,p_page_template_id=>wwv_flow_imp.id(690782638016803186)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140071569367349459)
,p_page_template_id=>wwv_flow_imp.id(690782638016803186)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140071645904349459)
,p_page_template_id=>wwv_flow_imp.id(690782638016803186)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(690783120585803188)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Edit Screen'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'</header>',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main id="main" class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER.">',
'        <span class="u-vh">&MSG_USER.</span>',
'      </span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE.">',
'        <span class="u-vh">&MSG_WORKSPACE.</span>',
'      </span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE.">',
'        <span class="u-vh">&MSG_LANGUAGE.</span>',
'      </span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293349232714925401)
,p_page_template_id=>wwv_flow_imp.id(690783120585803188)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293349722862925401)
,p_page_template_id=>wwv_flow_imp.id(690783120585803188)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293350226544925401)
,p_page_template_id=>wwv_flow_imp.id(690783120585803188)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293350790252925402)
,p_page_template_id=>wwv_flow_imp.id(690783120585803188)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293351285132925402)
,p_page_template_id=>wwv_flow_imp.id(690783120585803188)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293351755525925402)
,p_page_template_id=>wwv_flow_imp.id(690783120585803188)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293352256265925403)
,p_page_template_id=>wwv_flow_imp.id(690783120585803188)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293352771572925403)
,p_page_template_id=>wwv_flow_imp.id(690783120585803188)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(690783685471803190)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'    #REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'</header>',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div id="main" class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.'' aria-label=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.''><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1535660419768830)
,p_page_template_id=>wwv_flow_imp.id(690783685471803190)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1536150392768830)
,p_page_template_id=>wwv_flow_imp.id(690783685471803190)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1536611772768830)
,p_page_template_id=>wwv_flow_imp.id(690783685471803190)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1537128560768830)
,p_page_template_id=>wwv_flow_imp.id(690783685471803190)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1537679546768830)
,p_page_template_id=>wwv_flow_imp.id(690783685471803190)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1538171159768831)
,p_page_template_id=>wwv_flow_imp.id(690783685471803190)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1538656126768831)
,p_page_template_id=>wwv_flow_imp.id(690783685471803190)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(690784265136803192)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Wizard Dialog'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,baseDialogClass:''a-Dialog--wizard'',dialogClass:#DIALOG_CSS_CLASSES#,jsDialogClass:true,#DIALOG_A'
||'TTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293546448026992214)
,p_page_template_id=>wwv_flow_imp.id(690784265136803192)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293546991987992214)
,p_page_template_id=>wwv_flow_imp.id(690784265136803192)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293547472075992214)
,p_page_template_id=>wwv_flow_imp.id(690784265136803192)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(703368619593851824)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'</header>',
'#REGION_POSITION_08#',
'<main class="a-Main" id="main">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="u-Layout u-Layout--centerVertically">',
'    <div class="a-Wizard a-Wizard--default">',
'      #REGION_POSITION_02#',
'      <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'      <div class="a-Wizard-body">#BODY#</div>',
'      <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'    </div>',
'  </div>',
'</main>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message" role="alert">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="errorMsg" role="region" aria-labelledby="page_warning_id">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''>',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h2 class="u-vh" id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      <div class="a-AlertMessages-messageTitle" id="errorMsg-Message" role="alert">#MESSAGE#</div>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'')'
||';return false;"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3660968978568280)
,p_page_template_id=>wwv_flow_imp.id(703368619593851824)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3661463434568280)
,p_page_template_id=>wwv_flow_imp.id(703368619593851824)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3661950537568281)
,p_page_template_id=>wwv_flow_imp.id(703368619593851824)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3662456891568281)
,p_page_template_id=>wwv_flow_imp.id(703368619593851824)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3662994658568281)
,p_page_template_id=>wwv_flow_imp.id(703368619593851824)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3663461609568281)
,p_page_template_id=>wwv_flow_imp.id(703368619593851824)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3663902119568281)
,p_page_template_id=>wwv_flow_imp.id(703368619593851824)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sql_workshop_iframe_page
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(740688669716062470)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - SQL Workshop iFrame Page'
,p_internal_name=>'APEX_5.0_SQL_WORKSHOP_IFRAME_PAGE'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="sql-workshop-iframe-page a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>751105067571616073
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293519859359987029)
,p_page_template_id=>wwv_flow_imp.id(740688669716062470)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293520348879987030)
,p_page_template_id=>wwv_flow_imp.id(740688669716062470)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293520839261987030)
,p_page_template_id=>wwv_flow_imp.id(740688669716062470)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_query_builder_to_be_deleted
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(755509294845301750)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Query Builder (to be deleted)'
,p_internal_name=>'APEX_5.0_QUERY_BUILDER_TO_BE_DELETED'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <script src="#IMAGE_PREFIX#sw/minified/htmldb_data.min.js" type="text/javascript" defer="defer"></script>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Body">',
'    <main class="a-Main">     ',
'    <table summary="" cellpadding="0" cellspacing="0" border="0" id="qbTable" width="98%" height="70%">',
'      <tr>',
'        <td id="qbSideBar" valign="top" width="200" style="width:200px;"><div id="qbLeftHeader">#REGION_POSITION_02#</div>',
'          <div id="dbaseObjectsSlider"><br />',
'          </div></td>',
'        <td id="v_slide" class="obSlideBar" valign="middle" width="5" style="width:5px;"><span id="qbSideBartoggle" onclick="qb_toggleSideBar();"><img id="qbSideBar_toggle" src="#IMAGE_PREFIX#qb/close.png" alt="" class="htmldbPseudoButton" /></span><'
||'/td>',
'        <td valign="top" class="qbFrameHolder" id="qbFrameHolder"><div id="qbRightHeader">#REGION_POSITION_03#</div>',
'          <div id="qbTableHolder" class="d1">',
'            <div align="right">',
'              <div id="qbLinkHolder"></div>',
'            </div>',
'          </div>',
'          <div id="h_slide" onmousedown="qb_hPosition(this);">&nbsp;</div>',
'          <div id="qbBottomHolder" class="d2">#REGION_POSITION_04#',
'            <div id="htmlTabHolder" class="qbTabHolder">#REGION_POSITION_05#</div>',
'          </div></td>',
'      </tr>',
'    </table>',
'        #REGION_POSITION_01##BODY#  ',
'    </main>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden" role="alert">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140060983384349476)
,p_page_template_id=>wwv_flow_imp.id(755509294845301750)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140061032146349476)
,p_page_template_id=>wwv_flow_imp.id(755509294845301750)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140061193063349476)
,p_page_template_id=>wwv_flow_imp.id(755509294845301750)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140061226080349476)
,p_page_template_id=>wwv_flow_imp.id(755509294845301750)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140061378064349476)
,p_page_template_id=>wwv_flow_imp.id(755509294845301750)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140061409051349476)
,p_page_template_id=>wwv_flow_imp.id(755509294845301750)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140061559959349475)
,p_page_template_id=>wwv_flow_imp.id(755509294845301750)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140061698962349475)
,p_page_template_id=>wwv_flow_imp.id(755509294845301750)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_query_builder_popup_legacy_to_be_deleted
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(787616727240016897)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Query Builder Popup (Legacy to be deleted)'
,p_internal_name=>'APEX_5.0_QUERY_BUILDER_POPUP_LEGACY_TO_BE_DELETED'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8">',
'<script src="#IMAGE_PREFIX#sw/minified/htmldb_data.min.js" type="text/javascript"></script>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body #ONLOAD# xmlns:htmldb="http://htmldb.oracle.com"><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbBreadcrumbTop"><br /></div>',
'<table class="htmldbLayout" cellpadding="0" cellspacing="0" border="0" summary="">',
'<tr>',
'<td class="htmldbBreadcrumbRegion"><br /></td>',
'<td rowspan="2" class="htmldbRunEditRegion">#REGION_POSITION_06#</td></tr>',
'<tr>',
'<td id="htmldbRunEditZag"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" width="1" height="6" /></td>',
'</tr>',
'</table>',
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<table summary="" cellpadding="0" cellspacing="0" border="0" id="qbTable" width="98%" height="70%">',
'<tr>',
'<td id="qbSideBar" valign="top" width="200" style="width:200px;"><div id="qbLeftHeader">#REGION_POSITION_02#</div><div id="dbaseObjectsSlider"><br /></div></td>',
'<td id="v_slide" class="obSlideBar" valign="middle" width="5" style="width:5px;"><span id="qbSideBartoggle" onclick="qb_toggleSideBar();"><img id="qbSideBar_toggle" src="#IMAGE_PREFIX#qb/close.png" alt="" class="htmldbPseudoButton" /></span></td>',
'<td valign="top" class="qbFrameHolder" id="qbFrameHolder"><div id="qbRightHeader">#REGION_POSITION_03#</div>',
'<div id="qbTableHolder" class="d1"><div align="right"><div id="qbLinkHolder"></div></div></div>',
'<div id="h_slide" onmousedown="qb_hPosition(this);">&nbsp;</div>',
'<div id="qbBottomHolder" class="d2">#REGION_POSITION_04#<div id="htmlTabHolder" class="qbTabHolder">#REGION_POSITION_05#</div><br /><br /></div></td>',
'</tr>',
'</table><div class="htmldbBodyMargin">#REGION_POSITION_01##BODY#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'<a name="END"><br /></a>',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden" role="alert">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_top_non_curr_tab_font_attr=>'class="parenttabtextoff"'
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>16
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'no longer used'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140093017683349434)
,p_page_template_id=>wwv_flow_imp.id(787616727240016897)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140093198174349433)
,p_page_template_id=>wwv_flow_imp.id(787616727240016897)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140093288224349433)
,p_page_template_id=>wwv_flow_imp.id(787616727240016897)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140093382714349433)
,p_page_template_id=>wwv_flow_imp.id(787616727240016897)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140093468334349433)
,p_page_template_id=>wwv_flow_imp.id(787616727240016897)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140093506426349433)
,p_page_template_id=>wwv_flow_imp.id(787616727240016897)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140093696461349433)
,p_page_template_id=>wwv_flow_imp.id(787616727240016897)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_button_legacy_apex_5_migration
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3791826543328)
,p_template_name=>'HTML button (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_BUTTON_LEGACY_APEX_5_MIGRATION'
,p_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_hot_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_1_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(300313006293429763)
,p_template_name=>'APEX 4.1 - Button'
,p_internal_name=>'APEX_4.1_BUTTON'
,p_template=>'<button class="aButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_hot_template=>'<button class="aButton hotButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_reference_id=>275775519061831382
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="button-gray" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> ',
'',
'',
'<a href="#LINK#" class="button-orange" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> '))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(385765234519963355)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(385765690470963369)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(385765860428963371)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(690706750701136097)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(717395744009796543)
,p_template_name=>'APEX 5.0 - Icon Badge Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><span class="a-But'
||'ton-badge"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><spa'
||'n class="a-Button-badge"></span></button>'
,p_reference_id=>631020282344854024
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_menu_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(717395999962796580)
,p_template_name=>'APEX 5.0 - Icon Badge Menu Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_reference_id=>631020159860848910
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/4500_results_region_template
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(4569137138)
,p_layout=>'TABLE'
,p_template=>'<table cellspacing="2" cellpadding="2" border="0" width="100%" bgcolor="#C5D5C5" summary="" id="#REGION_STATIC_ID#"><tr><td align=left bgcolor="#C5D5C5"><font class="regionheader" face=aria color=white>&nbsp;<h2>#TITLE#</h2></font></td><td width="1%"'
||' align="right"  bgcolor="#C5D5C5">#EXPAND#</td><td width="1%" align="right"  bgcolor="#C5D5C5">#CLOSE#</td></tr></table>#BODY#<p/>'
,p_page_plug_template_name=>'[x] (4500) results_region_template'
,p_internal_name=>'4500_RESULTS_REGION_TEMPLATE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>354972725853931304
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60375372175005690)
,p_plug_template_id=>wwv_flow_imp.id(4569137138)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60375895122005690)
,p_plug_template_id=>wwv_flow_imp.id(4569137138)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60376317531005691)
,p_plug_template_id=>wwv_flow_imp.id(4569137138)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60376842086005691)
,p_plug_template_id=>wwv_flow_imp.id(4569137138)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/popup_dialog
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2315729644343442)
,p_layout=>'TABLE'
,p_template=>'<table style="display:none;position:absolute;background-color:#EEEEEE;border:#000000 solid 1px;padding:0px;text-align:center;font-size:12px;color:#000000;" summary="" cellpadding="0" cellspacing="0" border="0" id="#REGION_STATIC_ID#"><tr><td class="h'
||'tmldbWizardHeader"><h2>#TITLE#</h2></td><td class="htmldbWizardHeader" align="right"><span onClick="dhtml_CloseDialog(this);"><img src="#IMAGE_PREFIX#qb/vertical_close.png" /></span></td></tr><tr><td colspan="2" class="htmldbWizardBody">#BODY#</td></'
||'tr><tr><td colspan="2" align="right">#CLOSE#&nbsp;&nbsp;&nbsp;#DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#</td></tr></table>'
,p_page_plug_template_name=>'Popup Dialog'
,p_internal_name=>'POPUP_DIALOG'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>140626130059891289
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140568594196344440)
,p_plug_template_id=>wwv_flow_imp.id(2315729644343442)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140568698711344440)
,p_plug_template_id=>wwv_flow_imp.id(2315729644343442)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140568704569344440)
,p_plug_template_id=>wwv_flow_imp.id(2315729644343442)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140568867043344440)
,p_plug_template_id=>wwv_flow_imp.id(2315729644343442)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140568907417344440)
,p_plug_template_id=>wwv_flow_imp.id(2315729644343442)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140569054311344440)
,p_plug_template_id=>wwv_flow_imp.id(2315729644343442)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140569150526344440)
,p_plug_template_id=>wwv_flow_imp.id(2315729644343442)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140569294370344440)
,p_plug_template_id=>wwv_flow_imp.id(2315729644343442)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140569392716344440)
,p_plug_template_id=>wwv_flow_imp.id(2315729644343442)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_and_region_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2976007666683831)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 4.0 - Div with ID and Region Attributes'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>2974803291668087
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60420651362125961)
,p_plug_template_id=>wwv_flow_imp.id(2976007666683831)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60421176955125961)
,p_plug_template_id=>wwv_flow_imp.id(2976007666683831)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/ppr_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(12270828624874231)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_ID#" style="clear:both;"><htmldb:PPR_#REGION_ID#>#BODY#</htmldb:PPR_#REGION_ID#></div>'
,p_page_plug_template_name=>'PPR Region'
,p_internal_name=>'PPR_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140569617539344439)
,p_plug_template_id=>wwv_flow_imp.id(12270828624874231)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140569774467344439)
,p_plug_template_id=>wwv_flow_imp.id(12270828624874231)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/top_bar_white_collapsed
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(22867306215341549)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="top-bar" #REGION_ATTRIBUTES#><div style="float: left">#BODY#</div><div style="float: left">#CLOSE##EDIT##DELETE##CREATE##CREATE2##PREVIOUS##NEXT#</div></div>',
''))
,p_page_plug_template_name=>'Top Bar (white) (collapsed)'
,p_internal_name=>'TOP_BAR_WHITE_COLLAPSED'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>21
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17586323272111445
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140570290826344439)
,p_plug_template_id=>wwv_flow_imp.id(22867306215341549)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140570388177344439)
,p_plug_template_id=>wwv_flow_imp.id(22867306215341549)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140570438244344438)
,p_plug_template_id=>wwv_flow_imp.id(22867306215341549)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140570535541344438)
,p_plug_template_id=>wwv_flow_imp.id(22867306215341549)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140570634988344438)
,p_plug_template_id=>wwv_flow_imp.id(22867306215341549)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140570756770344438)
,p_plug_template_id=>wwv_flow_imp.id(22867306215341549)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140570831895344438)
,p_plug_template_id=>wwv_flow_imp.id(22867306215341549)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140570969512344438)
,p_plug_template_id=>wwv_flow_imp.id(22867306215341549)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140571052856344438)
,p_plug_template_id=>wwv_flow_imp.id(22867306215341549)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_hide_and_show_region_2
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(35638231141594602)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="hide-show-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="hide-show-top">',
'    <div class="hide-show-title"><h3>',
'      <a href="#" onclick="htmldb_ToggleTableBody(''i#REGION_STATIC_ID#'',''body#REGION_STATIC_ID#''); return false;">',
'        <img src="#IMAGE_PREFIX#htmldb/builder/rollup_plus_dgray.gif" class="pseudoButtonActive" id="i#REGION_STATIC_ID#" alt="" />',
'        #TITLE#',
'      </a></h3>    ',
'    </div>',
'  </div>',
'  <div class="hide-show-body" style="display:none;" id="body#REGION_STATIC_ID#">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 -  Hide and Show Region 2'
,p_internal_name=>'APEX_4.0__HIDE_AND_SHOW_REGION_2'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>106535103160611208
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60383940446097909)
,p_plug_template_id=>wwv_flow_imp.id(35638231141594602)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60384463823097909)
,p_plug_template_id=>wwv_flow_imp.id(35638231141594602)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar_100
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(40570329559709427)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion buttonRegion" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    #BODY#',
'    <span class="aButtonContainer">',
'      #CLOSE##COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#',
'    </span>',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Top Bar (100%)'
,p_internal_name=>'APEX_4.0_TOP_BAR_100%'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17357218626599946
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92532656060295513)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92533191075295513)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92533679190295514)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92534148283295514)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92534641363295514)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92535194699295514)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92535567759295515)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92536056688295515)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92536558065295515)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92537029933295515)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92537573978295516)
,p_plug_template_id=>wwv_flow_imp.id(40570329559709427)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_float_left
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(42819301025617014)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# style="float:left;clear:both;">#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 4.0 - Div (Float Left)'
,p_internal_name=>'APEX_4.0_DIV_FLOAT_LEFT'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>35964702876463547
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60409856513110472)
,p_plug_template_id=>wwv_flow_imp.id(42819301025617014)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60410375256110472)
,p_plug_template_id=>wwv_flow_imp.id(42819301025617014)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_reports_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(61427413413570608)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-region" id="#REGION_STATIC_ID#" style="width:100%">',
'  <div class="rc-gray-top"><div class="rc-gray-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Reports Region'
,p_internal_name=>'APEX_4.0_REPORTS_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17354512447599941
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92168701967172843)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92169211860172843)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92169797584172843)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92170262034172843)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92170716005172844)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92171271350172844)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92171765054172844)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92172252381172845)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92172791355172845)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92173277101172845)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92173728856172845)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92174203551172846)
,p_plug_template_id=>wwv_flow_imp.id(61427413413570608)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(81906901123495005)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Sidebar (Gray Header)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92457792126283296)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92458290936283297)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92458752992283297)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92459233580283297)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92459731909283297)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92460244765283298)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92460701276283298)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92461211744283298)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92461729007283299)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92462201909283299)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92462711126283299)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92463240252283300)
,p_plug_template_id=>wwv_flow_imp.id(81906901123495005)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/blank_wizard_region_c_htmldbbwr
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(106819925599248236)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbBWR" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">',
'<thead>',
'<tr>',
'<th class="T"><br /></th>',
'<th class="BT" valign="bottom">#CLOSE#&nbsp;&nbsp;#EDIT##DELETE#<img src="#IMAGE_PREFIX#htmldb/builder/1px_trans.gif" alt="" height="1" width="5" />#PREVIOUS##NEXT##CREATE##CREATE2#</th>',
'</tr>',
'</thead>',
'<tbody>',
'<tr>',
'<td colspan="2" class="B">#BODY#</td>',
'</tr>',
'</tbody>',
'</table>'))
,p_page_plug_template_name=>'Blank Wizard Region (c:htmldbBWR)'
,p_internal_name=>'BLANK_WIZARD_REGION_C:HTMLDBBWR'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140615659540344392)
,p_plug_template_id=>wwv_flow_imp.id(106819925599248236)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140615799443344391)
,p_plug_template_id=>wwv_flow_imp.id(106819925599248236)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140615814240344391)
,p_plug_template_id=>wwv_flow_imp.id(106819925599248236)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140615965516344391)
,p_plug_template_id=>wwv_flow_imp.id(106819925599248236)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140616067438344391)
,p_plug_template_id=>wwv_flow_imp.id(106819925599248236)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140616153694344391)
,p_plug_template_id=>wwv_flow_imp.id(106819925599248236)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140616296448344391)
,p_plug_template_id=>wwv_flow_imp.id(106819925599248236)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140616345733344391)
,p_plug_template_id=>wwv_flow_imp.id(106819925599248236)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140616421636344391)
,p_plug_template_id=>wwv_flow_imp.id(106819925599248236)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(140310301493602560)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box'
,p_internal_name=>'APEX_4.2_ACTION_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93477798265372021)
,p_plug_template_id=>wwv_flow_imp.id(140310301493602560)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93478282586372021)
,p_plug_template_id=>wwv_flow_imp.id(140310301493602560)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93478715893372022)
,p_plug_template_id=>wwv_flow_imp.id(140310301493602560)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93479227472372022)
,p_plug_template_id=>wwv_flow_imp.id(140310301493602560)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93479770498372022)
,p_plug_template_id=>wwv_flow_imp.id(140310301493602560)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93480268066372023)
,p_plug_template_id=>wwv_flow_imp.id(140310301493602560)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93480750612372023)
,p_plug_template_id=>wwv_flow_imp.id(140310301493602560)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93481208801372023)
,p_plug_template_id=>wwv_flow_imp.id(140310301493602560)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93481728110372024)
,p_plug_template_id=>wwv_flow_imp.id(140310301493602560)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_confirm
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(162408401422136243)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (Confirm)'
,p_internal_name=>'APEX_4.2_ACTION_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93570154929376176)
,p_plug_template_id=>wwv_flow_imp.id(162408401422136243)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93570696390376176)
,p_plug_template_id=>wwv_flow_imp.id(162408401422136243)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93571107919376176)
,p_plug_template_id=>wwv_flow_imp.id(162408401422136243)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93571659814376177)
,p_plug_template_id=>wwv_flow_imp.id(162408401422136243)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93572146459376177)
,p_plug_template_id=>wwv_flow_imp.id(162408401422136243)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93572651201376177)
,p_plug_template_id=>wwv_flow_imp.id(162408401422136243)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93573104264376177)
,p_plug_template_id=>wwv_flow_imp.id(162408401422136243)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93573650168376178)
,p_plug_template_id=>wwv_flow_imp.id(162408401422136243)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93574152818376178)
,p_plug_template_id=>wwv_flow_imp.id(162408401422136243)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(197664431770780199)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Sidebar (Gray Header) (2)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92468830285283303)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92469348579283304)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92469876115283304)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92470338380283304)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92470860467283305)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92471344473283305)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92471882358283305)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92472363708283305)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92472814140283306)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92473313176283306)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92473880851283306)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92474342730283306)
,p_plug_template_id=>wwv_flow_imp.id(197664431770780199)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(201494524216316816)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (2)'
,p_internal_name=>'APEX_4.2_ACTION_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93486116800372039)
,p_plug_template_id=>wwv_flow_imp.id(201494524216316816)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93486646245372040)
,p_plug_template_id=>wwv_flow_imp.id(201494524216316816)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93487104985372040)
,p_plug_template_id=>wwv_flow_imp.id(201494524216316816)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93487651200372041)
,p_plug_template_id=>wwv_flow_imp.id(201494524216316816)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93488133153372041)
,p_plug_template_id=>wwv_flow_imp.id(201494524216316816)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93488631028372041)
,p_plug_template_id=>wwv_flow_imp.id(201494524216316816)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93489145417372042)
,p_plug_template_id=>wwv_flow_imp.id(201494524216316816)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93489662893372042)
,p_plug_template_id=>wwv_flow_imp.id(201494524216316816)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93490192435372042)
,p_plug_template_id=>wwv_flow_imp.id(201494524216316816)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(208285310117555084)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Wizard Body'
,p_internal_name=>'APEX_4.2_WIZARD_BODY'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209615589242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93622510957534560)
,p_plug_template_id=>wwv_flow_imp.id(208285310117555084)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93623002611534560)
,p_plug_template_id=>wwv_flow_imp.id(208285310117555084)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_divider
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(208285802016555084)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'<div class="wizardRegionHeading">',
'  <h1>#TITLE#</h1>',
'  <div class="buttonContainer">',
'#EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'  </div>',
'</div>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Wizard Body (Divider)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_DIVIDER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209811475242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93675005329541314)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93675576789541314)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93676087195541314)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93676451135541315)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93676966455541315)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93677448478541315)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93677941090541316)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93678476827541316)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93678909055541316)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93679415680541316)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93679996135541316)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93680418126541317)
,p_plug_template_id=>wwv_flow_imp.id(208285802016555084)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/body_and_button_positions
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(267352014896608032)
,p_layout=>'TABLE'
,p_template=>'<table  cellpadding="0" cellspacing="0" border="0" summary="" class="htmldbButtonPositionsOnly" id="#REGION_STATIC_ID#"><tbody><tr><td>#BODY#</td><td style="padding-right:25px;">#CLOSE#</td><td>#PREVIOUS#</td><td>#NEXT#</td><td>#DELETE#</td><td>#CHAN'
||'GE##EDIT#</td><td>#CREATE#</td><td>#CREATE2#</td><td>#HELP#</td></tr></tbody></table>'
,p_page_plug_template_name=>'Body and Button Positions'
,p_internal_name=>'BODY_AND_BUTTON_POSITIONS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>149939626832608434
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140622773062344384)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140622839124344384)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140622955035344384)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140623035834344384)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140623106716344384)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140623237658344384)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140623381858344384)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140623493674344384)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140623521160344383)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140623663131344383)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140623702882344383)
,p_plug_template_id=>wwv_flow_imp.id(267352014896608032)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(380771699411878611)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>174748721787471587
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32533248303578824)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32533787652578824)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32534245733578824)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32534732904578824)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32535217145578825)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32535724904578825)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32536231950578825)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32536746692578826)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32537228836578826)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32537737605578826)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32538223039578827)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32538703125578827)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32539210140578827)
,p_plug_template_id=>wwv_flow_imp.id(380771699411878611)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(385770331595976651)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32623447158747577)
,p_plug_template_id=>wwv_flow_imp.id(385770331595976651)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32623930637747577)
,p_plug_template_id=>wwv_flow_imp.id(385770331595976651)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32624452081747578)
,p_plug_template_id=>wwv_flow_imp.id(385770331595976651)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32624942853747578)
,p_plug_template_id=>wwv_flow_imp.id(385770331595976651)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_hidden_heading
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(385893260111566687)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region (Hidden Heading)'
,p_internal_name=>'APEX_5.0_REGION_HIDDEN_HEADING'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>717832816842067694
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88075751470788134)
,p_plug_template_id=>wwv_flow_imp.id(385893260111566687)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88076200588788134)
,p_plug_template_id=>wwv_flow_imp.id(385893260111566687)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_layout_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(386079172240342588)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="u-Table #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'#BODY#',
'#SUB_REGIONS#',
'</div>'))
,p_sub_plug_template=>'<div class="u-Table-fill">#SUB_REGION#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Layout Container'
,p_internal_name=>'APEX_5.0_LAYOUT_CONTAINER'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140625790284344381)
,p_plug_template_id=>wwv_flow_imp.id(386079172240342588)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140625807453344381)
,p_plug_template_id=>wwv_flow_imp.id(386079172240342588)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(690697788869123307)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>687153470345619376
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63776867797240707)
,p_plug_template_id=>wwv_flow_imp.id(690697788869123307)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63777303746240708)
,p_plug_template_id=>wwv_flow_imp.id(690697788869123307)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63777881567240708)
,p_plug_template_id=>wwv_flow_imp.id(690697788869123307)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63778313844240708)
,p_plug_template_id=>wwv_flow_imp.id(690697788869123307)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63778834388240709)
,p_plug_template_id=>wwv_flow_imp.id(690697788869123307)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63779306602240709)
,p_plug_template_id=>wwv_flow_imp.id(690697788869123307)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63779852086240709)
,p_plug_template_id=>wwv_flow_imp.id(690697788869123307)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63780312472240710)
,p_plug_template_id=>wwv_flow_imp.id(690697788869123307)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63780839984240710)
,p_plug_template_id=>wwv_flow_imp.id(690697788869123307)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(690714020036152159)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <h2 id="#REGION_STATIC_ID#_heading" class="u-vh a-Region-header">#TITLE#</h2>',
'  #PREVIOUS##BODY##NEXT#',
'</div>',
''))
,p_page_plug_template_name=>'[x] APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>678354360586321695
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1539235096426804)
,p_plug_template_id=>wwv_flow_imp.id(690714020036152159)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1539706112426804)
,p_plug_template_id=>wwv_flow_imp.id(690714020036152159)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1540264609426804)
,p_plug_template_id=>wwv_flow_imp.id(690714020036152159)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1540713745426805)
,p_plug_template_id=>wwv_flow_imp.id(690714020036152159)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(703386252988943977)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span aria-hidden="true" class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>698829239393878937
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131762601478047228)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131763173588047228)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131763614730047228)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131764157197047229)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131764614541047229)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131765108535047229)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131765642285047230)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131766129604047230)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131766647979047230)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131767181175047231)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131767671950047231)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131768183552047231)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131768645225047232)
,p_plug_template_id=>wwv_flow_imp.id(703386252988943977)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717403738062820750)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# #REGION_LANDMARK_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>689955986849128825
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1565987021065886)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1566465560065886)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1566939912065887)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1567472621065887)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1567967225065887)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1568449711065887)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1568917135065888)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1569455056065888)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1569927174065888)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1570455298065888)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1570924401065889)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1571490620065889)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1571918653065889)
,p_plug_template_id=>wwv_flow_imp.id(717403738062820750)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717413953976820775)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_form_table_attr=>' '
,p_reference_id=>17354206769599941
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135733768264120568)
,p_plug_template_id=>wwv_flow_imp.id(717413953976820775)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135734299553120569)
,p_plug_template_id=>wwv_flow_imp.id(717413953976820775)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717414629694820775)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-PageColumn-header">',
'    <h2 class="a-PageColumn-heading">#TITLE#</h2>',
'  </div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613223222362440
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140630234463344377)
,p_plug_template_id=>wwv_flow_imp.id(717414629694820775)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140630313846344376)
,p_plug_template_id=>wwv_flow_imp.id(717414629694820775)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column_body
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717415310646820776)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn-body #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column (Body)'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN_BODY'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174630015632506596
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140630424943344376)
,p_plug_template_id=>wwv_flow_imp.id(717415310646820776)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140630552482344376)
,p_plug_template_id=>wwv_flow_imp.id(717415310646820776)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717416953442820777)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="toolbar" aria-label="#TITLE!ATTR#" class="a-Toolbar #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Toolbar-items a-Toolbar-items--left">#PREVIOUS#</div>',
'  <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar'
,p_internal_name=>'APEX_5.0_TOOLBAR'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613705533399534
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68610428493251732)
,p_plug_template_id=>wwv_flow_imp.id(717416953442820777)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68610995903251732)
,p_plug_template_id=>wwv_flow_imp.id(717416953442820777)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68611464254251732)
,p_plug_template_id=>wwv_flow_imp.id(717416953442820777)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68611953614251733)
,p_plug_template_id=>wwv_flow_imp.id(717416953442820777)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_left
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717417607324820781)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--left #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Left)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_LEFT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174628415239478085
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140631265610344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140631366145344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140631416167344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140631504266344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140631670438344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140631796624344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140631851827344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140631904406344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632086527344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632184989344375)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632272366344374)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632352001344374)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632498942344374)
,p_plug_template_id=>wwv_flow_imp.id(717417607324820781)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_right
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717418310522820781)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--right #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Right)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_RIGHT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174629130392501406
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632574281344374)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632684557344374)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632728489344374)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632829190344374)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140632976120344374)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140633006992344374)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140633187155344373)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140633239349344373)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140633325873344373)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140633488530344373)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140633553386344373)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140633605355344373)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140633751591344373)
,p_plug_template_id=>wwv_flow_imp.id(717418310522820781)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717419046555820782)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88313743579825443)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88314285488825443)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88314755551825443)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88315249566825443)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88315758715825444)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88316248937825444)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88316730127825444)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88317297497825445)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88317767735825445)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88318231456825445)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88318773857825445)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88319243833825446)
,p_plug_template_id=>wwv_flow_imp.id(717419046555820782)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717419707883820782)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 id="#REGION_STATIC_ID#_TITLE" class="u-vh">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>702777601713950915
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214500426458485473)
,p_plug_template_id=>wwv_flow_imp.id(717419707883820782)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214500918011485473)
,p_plug_template_id=>wwv_flow_imp.id(717419707883820782)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(717420493098820783)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88143647164806722)
,p_plug_template_id=>wwv_flow_imp.id(717420493098820783)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88144151940806723)
,p_plug_template_id=>wwv_flow_imp.id(717420493098820783)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_iframe_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(737759501522573640)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--iframe #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'  <div class="a-Region-iframeButtons">',
'    <div class="a-ButtonRegion">',
'      <div class="a-ButtonRegion-wrap">',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'          <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'        </div>',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - iFrame Region'
,p_internal_name=>'APEX_5.0_IFRAME_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--paddedBody'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>737749193541531906
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88108300357799072)
,p_plug_template_id=>wwv_flow_imp.id(737759501522573640)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88108815584799073)
,p_plug_template_id=>wwv_flow_imp.id(737759501522573640)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88109314277799073)
,p_plug_template_id=>wwv_flow_imp.id(737759501522573640)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88109892250799073)
,p_plug_template_id=>wwv_flow_imp.id(737759501522573640)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88110326094799073)
,p_plug_template_id=>wwv_flow_imp.id(737759501522573640)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88110891925799074)
,p_plug_template_id=>wwv_flow_imp.id(737759501522573640)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88111399783799074)
,p_plug_template_id=>wwv_flow_imp.id(737759501522573640)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88111825843799074)
,p_plug_template_id=>wwv_flow_imp.id(737759501522573640)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88112390238799075)
,p_plug_template_id=>wwv_flow_imp.id(737759501522573640)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(746376253838324384)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div role="alert" class="a-Alert-body">#BODY#</div>',
'    </div>',
'    <div class="a-Alert-buttons">#PREVIOUS##CLOSE##CREATE##NEXT#</div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>746362351042209764
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4808613273959695)
,p_plug_template_id=>wwv_flow_imp.id(746376253838324384)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4809154739959695)
,p_plug_template_id=>wwv_flow_imp.id(746376253838324384)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4809651819959695)
,p_plug_template_id=>wwv_flow_imp.id(746376253838324384)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4810140923959695)
,p_plug_template_id=>wwv_flow_imp.id(746376253838324384)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4810614250959695)
,p_plug_template_id=>wwv_flow_imp.id(746376253838324384)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4811112028959696)
,p_plug_template_id=>wwv_flow_imp.id(746376253838324384)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_dialog
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(1131993087623131882)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#"  class="a-DialogRegion js-regionDialog #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# style="display:none" title="#TITLE#">',
'  <div class="a-DialogRegion-body">',
'#BODY#',
'  </div>',
'  <div class="a-DialogRegion-buttons">',
'     <div class="a-ButtonRegion a-ButtonRegion--dialogRegion">',
'       <div class="a-ButtonRegion-wrap">',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'       </div>',
'     </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region Dialog'
,p_internal_name=>'APEX_5.0_REGION_DIALOG'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'js-draggable:js-resizable:js-modal'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>428597701677720079
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88396950648832854)
,p_plug_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88397406280832854)
,p_plug_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88397947921832854)
,p_plug_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88398453429832855)
,p_plug_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88398987674832855)
,p_plug_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88399462614832855)
,p_plug_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88399989588832856)
,p_plug_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88400409851832856)
,p_plug_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_nested_splitter
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(1225836530715180993)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="resize #REGION_CSS_CLASSES#"> ',
'#BODY#',
'<div id="#REGION_STATIC_ID#_content" class="resize">',
'#SUB_REGIONS#',
'</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Nested Splitter'
,p_internal_name=>'APEX_5.0_NESTED_SPLITTER'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>177373906751600776
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140637795916344369)
,p_plug_template_id=>wwv_flow_imp.id(1225836530715180993)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140637817526344369)
,p_plug_template_id=>wwv_flow_imp.id(1225836530715180993)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist_from_4999
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(1216501287578773)
,p_list_template_current=>'<div class="dhtmlMenuItem"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#htmldb/builder/menu_pulldown.png" width="32" height="84" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBott'
||'om(this,''#LIST_ITEM_ID#'',false)" alt=""/><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_noncurrent=>'<div class="dhtmlMenuItem"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#htmldb/builder/menu_pulldown.png" width="32" height="84" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBott'
||'om(this,''#LIST_ITEM_ID#'',false)" alt="" /><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_name=>'DHTML List (Image) with Sublist from 4999'
,p_internal_name=>'DHTML_LIST_IMAGE_WITH_SUBLIST_FROM_4999'
,p_theme_id=>3
,p_theme_class_id=>10
,p_list_template_before_rows=>'<div class="dhtmlMenuLG">'
,p_list_template_after_rows=>'</div><br style="clear:both;"/><br style="clear:both;"/>'
,p_before_sub_list=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">',
'<li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>'))
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_reference_id=>6245728734686542
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_tabbed_navigation_list_ppr
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(11751121765920036)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="javascript:ob_PPR_TAB(''#LINK#'')" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="javascript:ob_PPR_TAB(''#LINK#'')" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_list_template_name=>'Simple Tabbed Navigation List (PPR)'
,p_internal_name=>'SIMPLE_TABBED_NAVIGATION_LIST_PPR'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbTabbedNavigationList" border="0" cellpadding="0" cellspacing="0" summary=""><tr>',
'',
''))
,p_list_template_after_rows=>'<td width="100%"><br /></td></tr></table>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_reference_id=>108849122001556988
);
end;
/
prompt --application/shared_components/user_interface/templates/list/dhtml_list_button_with_sublist
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(18702621564272688)
,p_list_template_current=>'<li>#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" class="dList" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_list_template_name=>'DHTML List Button with Sublist'
,p_internal_name=>'DHTML_LIST_BUTTON_WITH_SUBLIST'
,p_theme_id=>3
,p_theme_class_id=>10
,p_list_template_before_rows=>'<ul class="dList">'
,p_list_template_after_rows=>'</ul>'
,p_item_templ_curr_w_child=>'<li>#TEXT#</li>'
,p_item_templ_noncurr_w_child=>'<li><a href="#LINK#" class="dList" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_reference_id=>18183125227392377
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(20507805987268923)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List (2)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/flowwizard
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(23328315128356826)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-current"><span>#TEXT#</span></div>',
''))
,p_list_template_noncurrent=>'<div class="apex-wiz-non"><span>#TEXT#</span></div>'
,p_list_template_name=>'FlowWizard'
,p_internal_name=>'FLOWWIZARD'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-wiz-bar">'
,p_list_template_after_rows=>'</div>'
,p_between_items=>'<div class="apex-wiz-arrow"></div>'
,p_reference_id=>60218330803141060
);
end;
/
prompt --application/shared_components/user_interface/templates/list/columbus_object_browser_object_types
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(23673306353078906)
,p_list_template_current=>'<option htmldb:type="#A01#" id="#A01#" value="#A01#" selected="selected"">#TEXT#</option>'
,p_list_template_noncurrent=>'<option htmldb:type="#A01#" id="#A01#" value="#A01#">#TEXT#</option>'
,p_list_template_name=>'(Columbus) Object Browser Object Types'
,p_internal_name=>'COLUMBUS_OBJECT_BROWSER_OBJECT_TYPES'
,p_theme_id=>3
,p_theme_class_id=>16
,p_list_template_before_rows=>'<label for="obObjectSelect" class="hideMeButHearMe">Object Type</label><select onchange="gLastTab=false;gSideBar.onchange(true);"  id="obObjectSelect" class="a-Form-select">'
,p_list_template_after_rows=>'</select>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(32427114807996970)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>32421627622986728
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/unordered_list_omit_current
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(35432701931461853)
,p_list_template_current=>' '
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_list_template_name=>'Unordered List (omit current)'
,p_internal_name=>'UNORDERED_LIST_OMIT_CURRENT'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="noIndent">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>354043718465235283
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_tabbed_navigation_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(108863608130594810)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_list_template_name=>'Simple Tabbed Navigation List'
,p_internal_name=>'SIMPLE_TABBED_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbTabbedNavigationList" border="0" cellpadding="0" cellspacing="0"><tr>',
'',
''))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td width="100%"><br /></td></tr></table>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_reference_id=>108854228567566739
);
end;
/
prompt --application/shared_components/user_interface/templates/list/image_list_legend
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(175500817357553766)
,p_list_template_current=>'<li><img src="#IMAGE_PREFIX##IMAGE#" style="margin-right:10px;" alt="" />#TEXT#</li>'
,p_list_template_noncurrent=>'<li><img src="#IMAGE_PREFIX##IMAGE#" style="margin-right:10px;" alt="" />#TEXT#</li>'
,p_list_template_name=>'Image List (Legend)'
,p_internal_name=>'IMAGE_LIST_LEGEND'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="htmldbSessionLegend">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>237858014773116158
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(196867506292090262)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs (2)'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_pull_down_button_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(208299907447573159)
,p_list_template_current=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton" type="button"><span>#TEXT#</span></button> '
,p_list_template_noncurrent=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton" type="button"><span>#TEXT#</span></button> '
,p_list_template_name=>'APEX 4.2 - Pull Down Button List'
,p_internal_name=>'APEX_4.2_PULL_DOWN_BUTTON_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<div class="rButtonContainer dhtmlMenuLGButton">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton" type="button"><span>#TEXT#</span></button> '
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" class="dhtmlMenu" type="button"><span>#TEXT#<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></span></button> ',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>'
,p_reference_id=>253872418832604079
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_run_edit_bar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(212033724996722960)
,p_list_template_current=>'  <li><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#TEXT_ESC_SC#" class="iconSmall #A01#" /></a></li>'
,p_list_template_noncurrent=>'  <li><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#TEXT_ESC_SC#" class="iconSmall #A01#" /></a></li>'
,p_list_template_name=>'APEX 4.2 - Run / Edit Bar'
,p_internal_name=>'APEX_4.2_RUN_/_EDIT_BAR'
,p_theme_id=>3
,p_theme_class_id=>3
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="aRunEditBar">',
'  <li><span class="currentPage">&PAGE. &FB_FLOW_PAGE_ID.</span></li>'))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>210390516819756900
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_wizard_progress_sidebar_clickable
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(240152923292316768)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-current">',
'  <div class="apex-wiz-top"></div>',
'  <div class="apex-wiz-body">#TEXT#</div>',
'</div>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-non">',
'  <div class="apex-wiz-top"></div>',
'  <div class="apex-wiz-body"><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div>',
'</div>'))
,p_list_template_name=>'(Done) Wizard Progress Sidebar (Clickable)'
,p_internal_name=>'DONE_WIZARD_PROGRESS_SIDEBAR_CLICKABLE'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-wiz-bar">'
,p_list_template_after_rows=>'</div>'
,p_between_items=>'<div class="apex-wiz-arrow-small"></div>'
,p_reference_id=>240146817030288131
);
end;
/
prompt --application/shared_components/user_interface/templates/list/button_list_horizontal_c_htmldbbuttonlist
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(292458412644987596)
,p_list_template_current=>'<td><a href="#LINK#" class="htmldbButtonListCurrent">#TEXT#</a></td>'
,p_list_template_noncurrent=>'<td><a href="#LINK#" class="htmldbButtonList">#TEXT#</a></td>'
,p_list_template_name=>'Button List Horizontal (c:htmldbButtonList)'
,p_internal_name=>'BUTTON_LIST_HORIZONTAL_C:HTMLDBBUTTONLIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="htmldbButtonList" summary="" border="0" cellpadding="0" cellspacing="3"><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_item_templ_curr_w_child=>'<td><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" width="20" height="1" /></td>'
,p_item_templ_noncurr_w_child=>'<td><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" width="20" height="1" /></td>'
,p_reference_id=>21059717155998569
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(385776082908002390)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_a06_label=>'Link Target'
,p_reference_id=>573607518145151423
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(385776364537002403)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a06_label=>'Target'
,p_reference_id=>747588010155545129
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(385894774262579225)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_pull_down_button_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(436814111820869843)
,p_list_template_current=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton" type="button"><span>#TEXT#</span></button> '
,p_list_template_noncurrent=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton" type="button"><span>#TEXT#</span></button> '
,p_list_template_name=>'APEX 4.0 - Pull Down Button List'
,p_internal_name=>'APEX_4.0_PULL_DOWN_BUTTON_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<div class="rButtonContainer dhtmlMenuLGButton">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton" type="button"><span>#TEXT#</span></button> '
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" class="dhtmlMenu" type="button"><span>#TEXT#<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></span></button> ',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>'
,p_reference_id=>253872418832604079
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_ob_button_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(461032606198391037)
,p_list_template_current=>'<div class="list-button-c"><button onclick="#LINK#" class="dhtmlMenu" type="button"><span>#TEXT#</span></button></div>'
,p_list_template_noncurrent=>'<div class="list-button-nc"><button onclick="#LINK#" class="dhtmlMenu" type="button"><span>#TEXT#</span></button></div>'
,p_list_template_name=>'APEX 4.0 - OB Button List'
,p_internal_name=>'APEX_4.0_OB_BUTTON_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<div class="dhtmlMenuLGButton">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<div class="list-button-c-sub"><button onclick="#LINK#" class="dhtmlMenu" type="button"><span>#TEXT#</span></button></div>'
,p_item_templ_noncurr_w_child=>'<div class="list-button-nc-sub"><button onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" class="dhtmlMenu" type="button"><span>#TEXT#</span></button></div>'
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>'
,p_reference_id=>461050507240493294
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(692727073209839891)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" aria-current="page" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_name=>'[x] APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(703372217110859571)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_002
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(704358525679957526)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs_002
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(764029929273005392)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sql_workshop_buttons_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(1241653799958177324)
,p_list_template_current=>'<button type="button" onclick="apex.navigation.redirect(''#LINK#'')" class="a-Button">#TEXT#</button>'
,p_list_template_noncurrent=>'<button type="button" onclick="apex.navigation.redirect(''#LINK#'')" class="a-Button">#TEXT#</button>'
,p_list_template_name=>'APEX 5.0 - SQL Workshop Buttons List'
,p_internal_name=>'APEX_5.0_SQL_WORKSHOP_BUTTONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="a-Button-list">'
,p_list_template_after_rows=>'</div>'
,p_reference_id=>1241650007443166178
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_23_1_object_browser_cards
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1449172575682074)
,p_row_template_name=>'APEX 23.1 - Object Browser Cards'
,p_internal_name=>'APEX_23.1_OBJECT_BROWSER_CARDS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="b-OB-Card">',
'  <div class="b-OB-Card-wrap">',
'    <span class="b-OB-Card-icon a-Icon #CARD_ICON#" aria-hidden="true"></span>',
'    <h3 class="b-OB-Card-title" aria-describedby="description_#CARD_ICON#"><a href="#CARD_LINK#" aria-haspopup="dialog">#CARD_TITLE#</a></h3>',
'    <p class="b-OB-Card-description" id="description_#CARD_ICON#">#CARD_TEXT#</p>',
'  </div>',
'</li>',
''))
,p_row_template_before_rows=>' <ul class="b-OB-Cards #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_cards" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<!-- #PAGINATION# -->'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard_new_ajax
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(2251716882439710)
,p_row_template_name=>'Standard (New Ajax)'
,p_internal_name=>'STANDARD_NEW_AJAX'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# #ARIA_SORT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999_3
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(7082409118250737)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report From 4999 (3)'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999_3'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(11028007180514315)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report from 4999'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999_2
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(22095907193828478)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report From 4999 (2)'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999_2'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/database_browser_trigger_body
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(33210746522512634)
,p_row_template_name=>'Database Browser Trigger Body'
,p_internal_name=>'DATABASE_BROWSER_TRIGGER_BODY'
,p_row_template1=>'<pre>#TRIGGER_BODY#</pre>'
,p_row_template_before_rows=>'<table><tr><td>'
,p_row_template_after_rows=>'</td></tr></table>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>354957901800346152
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/quick_pick_list_items
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(38811532466194226)
,p_row_template_name=>'quick_pick_list_items'
,p_internal_name=>'QUICK_PICK_LIST_ITEMS'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_row_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(46912117501975223)
,p_row_template_name=>'APEX 4.0 - Portlet Row Template'
,p_internal_name=>'APEX_4.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/icon_report_from_4999
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(134307417931747174)
,p_row_template_name=>'Icon Report From 4999'
,p_internal_name=>'ICON_REPORT_FROM_4999'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100" style="float:left;margin:10px;">',
'<tr><td align="center"><a href="#3#"><img src="#IMAGE_PREFIX##1#" title="#2#" alt="#2#" style="display:block;"/></a></td></tr>',
'<tr><td align="center"><a href="#3#" class="htmldbIconName">#4#</a></td></tr>',
'</table>',
'<br style="clear:both;" />'))
,p_row_template_condition1=>'mod (#ROWNUM#, 5) = 0'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100" style="float:left;margin:10px;">',
'<tr><td align="center"><a href="#3#"><img src="#IMAGE_PREFIX##1#" title="#2#" alt="#2#" style="display:block;"/></a></td></tr>',
'<tr><td align="center"><a href="#3#" class="htmldbIconName">#4#</a></td></tr>',
'</table>'))
,p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table class="htmldbListIconHolder" border="0" cellpadding="0" cellpadding="0" summary="">#TOP_PAGINATION#<tr><td>'
,p_row_template_after_rows=>'</td></tr>#PAGINATION#</table></htmldb:#REGION_ID#></div>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>134516716361378454
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_no_background
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(161923301611160944)
,p_row_template_name=>'Vertical - No Background'
,p_internal_name=>'VERTICAL_NO_BACKGROUND'
,p_row_template1=>'<tr><th scope="row" align="right">#COLUMN_HEADER#</th><td>#COLUMN_VALUE#</td></tr>'
,p_row_template_before_rows=>'#CSV_LINK#<table class="htmldbVerticalRptPlain" summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>172647727246303349
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/no_background
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(165449703104678078)
,p_row_template_name=>'No Background'
,p_internal_name=>'NO_BACKGROUND'
,p_row_template1=>'<td#ALIGNMENT# id="td#ROWNUM#_#COLNUM#" headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" class="htmldbRptNoBackground" summary="#REGION_TITLE#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_before_first=>'<tr id="row#ROWNUM#">'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>237868603542157245
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_column_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(171907206171165798)
,p_row_template_name=>'APEX 4.0 - Portlet Column Template'
,p_internal_name=>'APEX_4.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/automatic_ppr_no_background
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(172773906323382535)
,p_row_template_name=>'Automatic PPR - No Background'
,p_internal_name=>'AUTOMATIC_PPR_NO_BACKGROUND'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="htmldbRptNoBackHoriz"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>172923115706660192
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(385896719135645040)
,p_row_template_name=>'APEX 5.0 - Badge List'
,p_internal_name=>'APEX_5.0_BADGE_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_date_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(386075171368129866)
,p_row_template_name=>'APEX 5.0 - Date List'
,p_internal_name=>'APEX_5.0_DATE_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="a-DateList-item">',
'    <div class="a-MediaBlock">',
'      <div class="a-MediaBlock-graphic">',
'        <span class="a-DateList-date">',
'          <span class="a-DateList-day">#DAY#</span>',
'          <span class="a-DateList-month">#MONTH#</span>',
'        </span>',
'      </div>',
'      <div class="a-MediaBlock-content">',
'        <span class="a-DateList-desc">#TEXT#</span>',
'        <span class="a-DateList-attribute">#CREATED_BY#</span>',
'        <span class="a-DateList-attribute">#CREATED_ON#</span>',
'      </div>',
'    </div>',
'  </li>'))
,p_row_template_before_rows=>'<ul class="a-DateList">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_standard_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(617728329737082310)
,p_row_template_name=>'APEX 4.0 - Standard Report'
,p_internal_name=>'APEX_4.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# #ARIA_SORT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(717423775712828084)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(717432943772828094)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(717433602632828095)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(717436155076828097)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# #ARIA_SORT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_vertical_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1127586271702515372)
,p_row_template_name=>'APEX 5.0 - Vertical Report'
,p_internal_name=>'APEX_5.0_VERTICAL_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'  <td class="a-Report-cell a-Report-cell--header" scope="row">#COLUMN_HEADER#</td>',
'  <td class="a-Report-cell">#COLUMN_VALUE#</td>',
'</tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report a-Report--vertical a-Report--staticRowColors #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" summary="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>' '
,p_row_template_after_last=>' '
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>1126924627125205941
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1340556612002171029)
,p_row_template_name=>'APEX 5.0 - Portlet Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1340557295961171098)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3301520602864636)
,p_template_name=>'FormField_Optional'
,p_internal_name=>'FORMFIELD_OPTIONAL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_required
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(3301625476864638)
,p_template_name=>'FormField_Required'
,p_internal_name=>'FORMFIELD_REQUIRED'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>2
,p_reference_id=>17388508175892042
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/label_tag_only
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(4904018598976684)
,p_template_name=>'LABEL Tag Only'
,p_internal_name=>'LABEL_TAG_ONLY'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(6693608793786901)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional_w_o_popup
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(12399821819620115)
,p_template_name=>'FormField_Optional w/o popup'
,p_internal_name=>'FORMFIELD_OPTIONAL_W/O_POPUP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><span class="htmldbLabelOptional">'
,p_template_body2=>'</span></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>238114715839717766
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/htmldb_greenarealabel_c_htmldbgalabel
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(187652405321922937)
,p_template_name=>'htmldb_GreenAreaLabel (c:htmldbGALabel)'
,p_internal_name=>'HTMLDB_GREENAREALABEL_C:HTMLDBGALABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_4_0_top_bar_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(197619827652543551)
,p_template_name=>'APEX 4.0 - Top Bar Label'
,p_internal_name=>'APEX_4.0_TOP_BAR_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(488671029226029669)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE##INLINE_HELP_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_inline_help_text=>'<div class="a-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(488671190365029680)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(492677255463052067)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(492677350674053149)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' </label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(717397080423801376)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="" aria-label="" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span>'
||'</button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(717397144393801382)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumbs
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(6698104029693013)
,p_name=>'breadcrumbs'
,p_internal_name=>'BREADCRUMBS'
,p_current_page_option=>'<span class="htmldbBreadcrumb">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#" class="htmldbBreadcrumb" title="#NAME#">#NAME#</a>'
,p_between_levels=>'<span class="htmldbBreadcrumbSep"><img alt="" src="#IMAGE_PREFIX#apex/apex_top_sep.gif"></span>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>60115300853820165
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(387975456606606350)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>8
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_imp_shared.create_popup_lov_template(
 p_id=>wwv_flow_imp.id(12797101143975616)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/basic_calendar
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(11334530416692434)
,p_cal_template_name=>'Basic Calendar'
,p_internal_name=>'BASIC_CALENDAR'
,p_day_of_week_format=>'<th scope="col">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation">',
' <tr>',
'   <td align="center" style="font-weight:bold;">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="1" cellpadding="1" cellspacing="1" summary="0">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div>#DD#</div><br />'
,p_day_open_format=>'<td valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" bgcolor="#d3d3d3">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div>#DD#</div>'
,p_weekend_open_format=>'<td valign="top">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div>#DD#</div>'
,p_nonday_open_format=>'<td valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_imp_shared.create_theme(
 p_id=>wwv_flow_imp.id(75126415316030828)
,p_theme_id=>3
,p_theme_name=>'APEX 5.0'
,p_theme_internal_name=>'APEX_5.0'
,p_navigation_type=>'T'
,p_nav_bar_type=>'NAVBAR'
,p_is_locked=>false
,p_default_page_template=>wwv_flow_imp.id(385762900697898960)
,p_default_dialog_template=>wwv_flow_imp.id(690784265136803192)
,p_error_template=>wwv_flow_imp.id(703368619593851824)
,p_printer_friendly_template=>wwv_flow_imp.id(385762900697898960)
,p_default_button_template=>wwv_flow_imp.id(385765234519963355)
,p_default_region_template=>wwv_flow_imp.id(380771699411878611)
,p_default_report_template=>wwv_flow_imp.id(717436155076828097)
,p_default_label_template=>wwv_flow_imp.id(488671029226029669)
,p_default_menu_template=>wwv_flow_imp.id(6698104029693013)
,p_default_calendar_template=>wwv_flow_imp.id(11334530416692434)
,p_default_list_template=>wwv_flow_imp.id(20507805987268923)
,p_default_nav_list_position=>'TOP'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(3),'')
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/oracle-fonts/oraclesans-apex#MIN#.css?v=#APEX_VERSION#'
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(72332249557526712)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(204023927913767476)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556399735490108657)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556400064664109422)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689635167517993971)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689636107671993973)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689636807321993973)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689638757932993974)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(692727409810839893)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(696624360683145458)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(697239665711708855)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(698688432545187815)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(698689189405187817)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(698689890777187817)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(698691450870187818)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(717406084452820762)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(717424165974828087)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(717426618396828089)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746376625117324389)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746420691677405750)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746421932096405751)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746422298476405751)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746422550773405751)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746423628537405752)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746423916240405752)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746424218274405754)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746424531468405755)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746424813431405755)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746425349736405755)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(746425674061405755)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(1141459524801402371)
,p_theme_id=>3
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Dialog Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Predefined dialog sizes'
,p_null_text=>'Default Size'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1541502566426805)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden to Assistive Tech'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690714020036152159)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(696624360683145458)
,p_template_types=>'REGION'
,p_help_text=>'By default, region title is hidden but accessible, use this option to remove the header from accessible interface'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755319348318018349)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(746376253838324384)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755319458208018350)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(746376253838324384)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755319634177018356)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(746376253838324384)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_imp.id(746376625117324389)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755319862500018356)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(746376253838324384)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_imp.id(746376625117324389)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755320072547018357)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(746376253838324384)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_imp.id(746376625117324389)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755320288486018357)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(746376253838324384)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_imp.id(717406084452820762)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755320416910018357)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(746376253838324384)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_imp.id(717406084452820762)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755320549428018357)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(746376253838324384)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755320725444018357)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(746376253838324384)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_imp.id(746376625117324389)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755321011331018360)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690697788869123307)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755321262415018361)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690697788869123307)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_imp.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755321430113018361)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690697788869123307)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_imp.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755321650581018361)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690697788869123307)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755321826695018361)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690697788869123307)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755321997452018361)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690697788869123307)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755322169222018361)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690697788869123307)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_imp.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755322393600018361)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690697788869123307)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_imp.id(696624360683145458)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755334063275018373)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(737759501522573640)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755334236254018373)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(737759501522573640)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755334469839018373)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(737759501522573640)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755334699540018373)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(737759501522573640)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755334871937018373)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(737759501522573640)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755335024214018375)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(737759501522573640)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755335244855018375)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(737759501522573640)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755343697621018390)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755343852274018390)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755344085264018390)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755344293879018390)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755344447099018391)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755344602370018391)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755344861153018391)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755345020387018391)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755345249021018391)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755345413694018391)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755345686664018391)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755345836994018391)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755346057787018391)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(385896719135645040)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755346536605018392)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755346771517018392)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755346908516018392)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755347127238018393)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755347387178018393)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755347523204018393)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755347707352018393)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755347942333018393)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(717426618396828089)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755348111386018393)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755348302485018394)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755348557394018394)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755348717973018394)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755348979659018394)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717423775712828084)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(717424165974828087)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755359739129018410)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_imp.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755359935524018410)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_imp.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755360139586018410)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_imp.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755360307757018410)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_imp.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755360503097018411)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_imp.id(692727409810839893)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755360682997018411)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755360717790018411)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755360835509018411)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755360943590018411)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755361040145018411)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755367926644019886)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_imp.id(746424531468405755)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755368131371019886)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_imp.id(746424813431405755)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755368316248019887)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(746425349736405755)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755368553370019887)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_imp.id(746424218274405754)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755368735312019887)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_imp.id(746424531468405755)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755368927938019887)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_imp.id(746424813431405755)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755369189057019887)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_imp.id(746422550773405751)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755369395951019887)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_imp.id(746422550773405751)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755369570087019887)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_imp.id(746422550773405751)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755369737564019889)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_imp.id(746425674061405755)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755369838791019889)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755370076039019889)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_imp.id(746424218274405754)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755370120514019889)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755370393151019889)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_imp.id(746422298476405751)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755370562593019889)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_imp.id(746422298476405751)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755370786398019889)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_imp.id(746423916240405752)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755370945815019890)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_imp.id(746421932096405751)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755371117542019890)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_imp.id(746423628537405752)
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755371211932019890)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755371447167019890)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_imp.id(746422298476405751)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755371663537019890)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_imp.id(746422298476405751)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755371848184019890)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_imp.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755372020903019890)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_imp.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755372233442019890)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_imp.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755372416975019890)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_imp.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755372687978019890)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_imp.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(755372807853019891)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_imp.id(746420691677405750)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787117311043949716)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2251716882439710)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(698688432545187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787117583690949716)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2251716882439710)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(698689189405187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787117782882949716)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2251716882439710)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787117993065949716)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2251716882439710)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787118109139949716)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2251716882439710)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787118210367949716)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2251716882439710)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787118446447949717)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(2251716882439710)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(698691450870187818)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787118999001949718)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(617728329737082310)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(698688432545187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787119198364949718)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(617728329737082310)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(698689189405187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787119375234949718)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(617728329737082310)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787119542567949718)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(617728329737082310)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787119713399949718)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(617728329737082310)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787119853489949718)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(617728329737082310)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787120018395949718)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(617728329737082310)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(698691450870187818)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787133502775949747)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717436155076828097)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(698688432545187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787133742911949747)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717436155076828097)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(698689189405187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787133937296949747)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717436155076828097)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787134188912949747)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717436155076828097)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787134324612949747)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717436155076828097)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787134433950949747)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717436155076828097)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787134647594949747)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717436155076828097)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(698691450870187818)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(926399273702707533)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(926399333093707533)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(940697553666341585)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(703372217110859571)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131768309924193980)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1127586271702515372)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(698689189405187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131768523123193980)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1127586271702515372)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131768627575193980)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1127586271702515372)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131768874640193981)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1127586271702515372)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131769045921193981)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1127586271702515372)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(698691450870187818)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131769275377193981)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1127586271702515372)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(698689890777187817)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1199561355394032423)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(746425349736405755)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1445975050737085430)
,p_theme_id=>3
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be resized.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1445975135241085430)
,p_theme_id=>3
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be moved.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1445975358746085430)
,p_theme_id=>3
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_imp.id(1141459524801402371)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1445975518111085431)
,p_theme_id=>3
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_imp.id(1141459524801402371)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1445975704313085431)
,p_theme_id=>3
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_imp.id(1141459524801402371)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1445975835000085431)
,p_theme_id=>3
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_imp.id(1131993087623131882)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
,p_help_text=>'Display as modal.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525655309965182076)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525655479052182076)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525655500963182076)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525655616409182076)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525655890890182076)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(697239665711708855)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525656046318182076)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(697239665711708855)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525667568855182133)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525667694538182133)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525667713426182133)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525667858315182133)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525668042336182133)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(697239665711708855)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525668231424182134)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(697239665711708855)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544815603312477990)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(38811532466194226)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544815753448477990)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(38811532466194226)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544815884959477990)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(38811532466194226)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544818837483478024)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717433602632828095)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544818973917478024)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717433602632828095)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544819035865478024)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(717433602632828095)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554812770773408377)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554812985067408377)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554813151047408377)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554813301944408378)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554813525412408378)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689636107671993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554813730587408378)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554813933522408378)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554814137047408378)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554814391152408378)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554814467842408378)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554814632627408378)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(380771699411878611)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_imp.id(689636807321993973)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554831633096526796)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(690714020036152159)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554831701564526797)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690714020036152159)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554831806774526797)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(690714020036152159)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554846967207542276)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554847055162542276)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554847272590542276)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554847450067542276)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554847672581542276)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689636107671993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554847887758542276)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554848073675542277)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554848294732542277)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554848424496542277)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_imp.id(717406084452820762)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554848666729542278)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(717403738062820750)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_imp.id(717406084452820762)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554862320208550802)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554862544640550802)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554862741972550802)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554862983266550802)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689636807321993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554863120634550802)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554863336092550802)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(696624360683145458)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554863545945550802)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554863760759550802)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689638757932993974)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554863920638550802)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689636107671993973)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554864134947550802)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(703386252988943977)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689635167517993971)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/globalization/language
begin
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246516903976156)
,p_translation_flow_id=>4501
,p_translation_flow_language_cd=>'es'
,p_translation_comments=>'SQL Workshop - Spanish'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246614295976156)
,p_translation_flow_id=>4502
,p_translation_flow_language_cd=>'fr'
,p_translation_comments=>'SQL Workshop - French'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246709197976156)
,p_translation_flow_id=>4503
,p_translation_flow_language_cd=>'de'
,p_translation_comments=>'SQL Workshop - German'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246810868976156)
,p_translation_flow_id=>4504
,p_translation_flow_language_cd=>'it'
,p_translation_comments=>'SQL Workshop - Italian'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72246910302976156)
,p_translation_flow_id=>4505
,p_translation_flow_language_cd=>'pt-br'
,p_translation_comments=>'SQL Workshop - Brazilian Portuguese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72247010323976156)
,p_translation_flow_id=>4506
,p_translation_flow_language_cd=>'zh-cn'
,p_translation_comments=>'SQL Workshop - Simplified Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72247105821976156)
,p_translation_flow_id=>4507
,p_translation_flow_language_cd=>'zh-tw'
,p_translation_comments=>'SQL Workshop - Traditional Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72247224176976156)
,p_translation_flow_id=>4508
,p_translation_flow_language_cd=>'ko'
,p_translation_comments=>'SQL Workshop - Korean'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72247317117976156)
,p_translation_flow_id=>4509
,p_translation_flow_language_cd=>'ja'
,p_translation_comments=>'SQL Workshop - Japanese'
,p_direction_right_to_left=>'N'
);
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(3083101046366798)
,p_build_option_name=>'Allow Alter of MLE Env Lang Options'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Whether to allow the updating of an MLE environment''s language options. See bug 33890408.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(140211619632429750)
,p_build_option_name=>'SQL Command Processor Transactions'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'within the SQL command processor; ability to run in a transactional mode. ',
'',
'Uses DBMS_JOBS to maintain session state over multiple pages views / statements within a transaction.'))
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(140265918963157648)
,p_build_option_name=>'Database Monitoring'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'monitor sessions',
'view SQL',
'view tablespace information',
'view data files',
'trace sessions',
''))
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(240237502901130926)
,p_build_option_name=>'Create Synonym Wizard'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Show or suppress the create synonym wizard'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(240247031763163202)
,p_build_option_name=>'Create MView Wizard'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Show or suppress create materialized view wizard'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(256109433659228165)
,p_build_option_name=>'Object REST Enablement'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_default_on_export=>'INCLUDE'
,p_build_option_comment=>'This is being used to hide REST Enablement features in the Object Browser.'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(693462110571635991)
,p_build_option_name=>'Enable APEX Internal Feedback'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_default_on_export=>'EXCLUDE'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(1080926199001296276)
,p_build_option_name=>'Commented Out'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(1694682434415493288)
,p_build_option_name=>'BUILDER_AUTH_SSO'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
);
end;
/
prompt --application/shared_components/globalization/messages
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(625174511518088116)
,p_name=>'DATA.LOAD.SODA_FILE_FORMATS'
,p_message_text=>'Supported formats json, txt, zip'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4801520630592684)
,p_name=>'EDITOR.UNSAVED_CHANGES'
,p_message_text=>'Changes have been made. Press OK to close editor without saving changes.'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(556059929884498062)
,p_name=>'GATHER_TABLE_STATS'
,p_message_text=>'Gather Table Statistics'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2212896908166355)
,p_name=>'OB.ACTION_ADD_COL'
,p_message_text=>'Add Column'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3474254740742093)
,p_name=>'OB.ACTION_ADD_IMPORT'
,p_message_text=>'Add Import'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5400859373416842)
,p_name=>'OB.ACTION_ALTER'
,p_message_text=>'Alter'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1941063512089528)
,p_name=>'OB.ACTION_CHANGE_VIEW'
,p_message_text=>'Change View'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1851290203844630)
,p_name=>'OB.ACTION_COLUMNS'
,p_message_text=>'Columns...'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1928159810461137)
,p_name=>'OB.ACTION_COMMENT'
,p_message_text=>'Comment'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1857545053039404)
,p_name=>'OB.ACTION_COMPILE'
,p_message_text=>'Compile'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1853647715946628)
,p_name=>'OB.ACTION_COPY'
,p_message_text=>'Copy'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2214419958183873)
,p_name=>'OB.ACTION_COPY_TABLE'
,p_message_text=>'Copy Table'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5910118428968822)
,p_name=>'OB.ACTION_COUNT_ROWS'
,p_message_text=>'Count Rows'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1857366404034413)
,p_name=>'OB.ACTION_CREATE'
,p_message_text=>'Create'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2214281087182640)
,p_name=>'OB.ACTION_CREATE_APP'
,p_message_text=>'Create App'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1817160120602218)
,p_name=>'OB.ACTION_CREATE_CURRENT'
,p_message_text=>'Create Current Object'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2214057665180110)
,p_name=>'OB.ACTION_CREATE_LT'
,p_message_text=>'Create Lookup Table'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2216643324353712)
,p_name=>'OB.ACTION_CREATE_RELATIONAL_VIEW'
,p_message_text=>'Create Relational View'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2214940707347017)
,p_name=>'OB.ACTION_CREATE_SEARCH_INDEX'
,p_message_text=>'Create Search Index'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3001062160099481)
,p_name=>'OB.ACTION_DEL_COL'
,p_message_text=>'Delete Column'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1856394934017757)
,p_name=>'OB.ACTION_DISABLE'
,p_message_text=>'Disable'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1851828289855516)
,p_name=>'OB.ACTION_DL_EXCEL'
,p_message_text=>'Download'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1852067231863763)
,p_name=>'OB.ACTION_DL_TEXT'
,p_message_text=>'Download'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1855956246009879)
,p_name=>'OB.ACTION_DROP'
,p_message_text=>'Drop'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2213406646173510)
,p_name=>'OB.ACTION_DROP_COL'
,p_message_text=>'Drop Column'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2216472771350095)
,p_name=>'OB.ACTION_DROP_SEARCH_INDEX'
,p_message_text=>'Drop Search Index'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2602338086467147)
,p_name=>'OB.ACTION_DROP_TABLE'
,p_message_text=>'Drop Table'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1856152981015681)
,p_name=>'OB.ACTION_ENABLE'
,p_message_text=>'Enable'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1851492005846931)
,p_name=>'OB.ACTION_FILTER'
,p_message_text=>'Filter...'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1857032973028978)
,p_name=>'OB.ACTION_GET_STATS'
,p_message_text=>'Gather Statistics'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1634059969389080)
,p_name=>'OB.ACTION_GOTO_ERROR'
,p_message_text=>'Go to Error'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1856599786020316)
,p_name=>'OB.ACTION_GRANT'
,p_message_text=>'Grant'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1855331449001308)
,p_name=>'OB.ACTION_INSERT'
,p_message_text=>'Insert Row'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1855788029008255)
,p_name=>'OB.ACTION_LOAD_DATA'
,p_message_text=>'Load Data'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2213094212168437)
,p_name=>'OB.ACTION_MODIFY_COL'
,p_message_text=>'Modify Column'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1816182757599836)
,p_name=>'OB.ACTION_OPEN_OBJECT'
,p_message_text=>'Open Object'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1857925335049208)
,p_name=>'OB.ACTION_REBUILD'
,p_message_text=>'Rebuild'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1849821324656912)
,p_name=>'OB.ACTION_REFRESH'
,p_message_text=>'Refresh'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2213696925175427)
,p_name=>'OB.ACTION_RENAME'
,p_message_text=>'Rename Table'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2213296170170746)
,p_name=>'OB.ACTION_RENAME_COL'
,p_message_text=>'Rename Column'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1856850273024957)
,p_name=>'OB.ACTION_REVOKE'
,p_message_text=>'Revoke'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1853477501943794)
,p_name=>'OB.ACTION_RUN'
,p_message_text=>'Run'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1857736410044524)
,p_name=>'OB.ACTION_SAVE_COMPILE'
,p_message_text=>'Save and Compile'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2602691256472293)
,p_name=>'OB.ACTION_TABLE_COMMENT'
,p_message_text=>'Table Comment'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1858376572067697)
,p_name=>'OB.ACTION_TEST'
,p_message_text=>'Test'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2213819483177158)
,p_name=>'OB.ACTION_TRUNCATE'
,p_message_text=>'Truncate Table'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2214644170185856)
,p_name=>'OB.ACTION_UI_DEFAULTS'
,p_message_text=>'UI Defaults'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234644174279126877)
,p_name=>'OB.ADD_IMPORT'
,p_message_text=>'Add Import'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1642064381100623)
,p_name=>'OB.CARD_DATABASE_LINK'
,p_message_text=>'Database Link'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1640077596066902)
,p_name=>'OB.CARD_FUNCTION'
,p_message_text=>'Function'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1640227217071597)
,p_name=>'OB.CARD_FUNCTION_DESC'
,p_message_text=>'A function is a subprogram that can take parameters and return a value.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1640444792073465)
,p_name=>'OB.CARD_INDEX'
,p_message_text=>'Index'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116528009209776151)
,p_name=>'OB.CARD_MLE_ENVIRONMENT'
,p_message_text=>'MLE Environment'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116528228610779062)
,p_name=>'OB.CARD_MLE_MODULE'
,p_message_text=>'MLE Module - JavaScript'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1639242873034636)
,p_name=>'OB.CARD_PACKAGE'
,p_message_text=>'Package'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1639485691043240)
,p_name=>'OB.CARD_PACKAGE_DESC'
,p_message_text=>'A package is a database object that groups logically related PL/SQL items, such as types, functions and procedures.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1639642282045093)
,p_name=>'OB.CARD_PROCEDURE'
,p_message_text=>'Procedure'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1639818215065063)
,p_name=>'OB.CARD_PROCEDURE_DESC'
,p_message_text=>'A procedure is a subprogram that performs a specific action.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1640804738079513)
,p_name=>'OB.CARD_SEQUENCE'
,p_message_text=>'Sequence'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1642859268113647)
,p_name=>'OB.CARD_SODA_COLLECTION'
,p_message_text=>'SODA Collection'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1642478599104806)
,p_name=>'OB.CARD_SYNONYM'
,p_message_text=>'Synonym'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1638246942966648)
,p_name=>'OB.CARD_TABLE'
,p_message_text=>'Table'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1638406203971240)
,p_name=>'OB.CARD_TABLE_DESC'
,p_message_text=>'A table is a unit of data storage in an Oracle database, containing rows and columns.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1641628594095055)
,p_name=>'OB.CARD_TRIGGER'
,p_message_text=>'Trigger'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1641241298090253)
,p_name=>'OB.CARD_TYPE'
,p_message_text=>'Type'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1638847869019285)
,p_name=>'OB.CARD_VIEW'
,p_message_text=>'View'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1639036225032276)
,p_name=>'OB.CARD_VIEW_DESC'
,p_message_text=>'A view is a logical representation of another table or combination of tables.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2354919561288748)
,p_name=>'OB.CLOSE_WARNING'
,p_message_text=>'There are unsaved changes. Do you want to continue?'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3274225303590796)
,p_name=>'OB.CMD_COMPILE.MLE_ENVIRONMENT'
,p_message_text=>'MLE Environment %0 compiled.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18804787158568124)
,p_name=>'OB.CMD_COMPILE.TRIGGER'
,p_message_text=>'Trigger %0 compiled.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(18804563832565763)
,p_name=>'OB.CMD_COMPILE.VIEW'
,p_message_text=>'View %0 compiled.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8610365781132053)
,p_name=>'OB.CMD_COUNT_ROWS.RESULT'
,p_message_text=>'%0 has %1 rows.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5001474760593682)
,p_name=>'OB.CMD_CREATE_SODA_INDEX'
,p_message_text=>'Index %0 created.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5001290027592497)
,p_name=>'OB.CMD_CREATE_SODA_VIEW'
,p_message_text=>'View %0 created.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19001090872628470)
,p_name=>'OB.CMD_DISABLE.INDEX'
,p_message_text=>'Index %0 has been disabled.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19000462675599472)
,p_name=>'OB.CMD_DISABLE.TRIGGER'
,p_message_text=>'Trigger %0 has been disabled.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5000893356590583)
,p_name=>'OB.CMD_DROP_SODA'
,p_message_text=>'Collection %0 dropped.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5001035746591645)
,p_name=>'OB.CMD_DROP_SODA_INDEX'
,p_message_text=>'JSON search index dropped.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19000841572626023)
,p_name=>'OB.CMD_ENABLE.INDEX'
,p_message_text=>'Index %0 has been enabled.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19000265824597329)
,p_name=>'OB.CMD_ENABLE.TRIGGER'
,p_message_text=>'Trigger %0 has been enabled.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7601265083866984)
,p_name=>'OB.CMD_GATHER_STATS.IN_PROGRESS'
,p_message_text=>'Gather statistics in progress...'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7600324805826673)
,p_name=>'OB.CMD_GATHER_STATS.RUNNING'
,p_message_text=>'Gather statistics is still running. Please wait until it finishes.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7600536014831069)
,p_name=>'OB.CMD_GATHER_STATS.STARTED'
,p_message_text=>'Job has started to gather statistics. This may take a while to finish. Please wait and refresh the view later.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19001398168694451)
,p_name=>'OB.CMD_REBUILD.INDEX'
,p_message_text=>'Index %0 has been rebuilt.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004333645632289)
,p_name=>'OB.CMD_TEST_DB_LINK'
,p_message_text=>'Database link "%0" has been successfully tested.'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2002950771825300)
,p_name=>'OB.COL_ACTION_TYPE'
,p_message_text=>'Action Type'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003070367825311)
,p_name=>'OB.COL_ACTIVE'
,p_message_text=>'Active'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003155175825311)
,p_name=>'OB.COL_APP_ID'
,p_message_text=>'App ID'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003298088825312)
,p_name=>'OB.COL_APP_NAME'
,p_message_text=>'App Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003333420825312)
,p_name=>'OB.COL_ATTRIBUTES'
,p_message_text=>'# of Attributes'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2013353334825313)
,p_name=>'OB.COL_AVG_COL_LEN'
,p_message_text=>'Average Column Length'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003485373825312)
,p_name=>'OB.COL_AVG_ROW_LEN'
,p_message_text=>'Average Row Length'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003599471825312)
,p_name=>'OB.COL_BASE_NAME'
,p_message_text=>'Base Object Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003659370825312)
,p_name=>'OB.COL_BASE_OWNER'
,p_message_text=>'Base Object Owner'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003713874825312)
,p_name=>'OB.COL_BASE_TYPE'
,p_message_text=>'Base Object Type'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003824597825312)
,p_name=>'OB.COL_BLOCKS'
,p_message_text=>'Blocks'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2003915747825312)
,p_name=>'OB.COL_BUCKETS'
,p_message_text=>'Buckets'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004058812825312)
,p_name=>'OB.COL_CACHE_SIZE'
,p_message_text=>'Cache Size'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004106914825312)
,p_name=>'OB.COL_COLUMNS'
,p_message_text=>'Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004272996825312)
,p_name=>'OB.COL_COLUMN_EXPRESSION'
,p_message_text=>'Column Expression'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004450351825312)
,p_name=>'OB.COL_COLUMN_NAME'
,p_message_text=>'Column Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004526185825312)
,p_name=>'OB.COL_COLUMN_POSITION'
,p_message_text=>'Column Position'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004669525825312)
,p_name=>'OB.COL_COMMENT'
,p_message_text=>'Comment'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004788319825312)
,p_name=>'OB.COL_COMPLETE'
,p_message_text=>'Complete'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004833367825312)
,p_name=>'OB.COL_COMPRESSION'
,p_message_text=>'Compression'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2004940221825312)
,p_name=>'OB.COL_CONSTRAINT'
,p_message_text=>'Constraint'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2005067017825312)
,p_name=>'OB.COL_CONTENT'
,p_message_text=>'Content'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2005195349825312)
,p_name=>'OB.COL_CREATED'
,p_message_text=>'Created'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2005348853825312)
,p_name=>'OB.COL_CYCLE_FLAG'
,p_message_text=>'Cycle Flag'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2005417647825312)
,p_name=>'OB.COL_DATA_LENGTH'
,p_message_text=>'Data Length'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2005518966825312)
,p_name=>'OB.COL_DATA_PRECISION'
,p_message_text=>'Data Precision'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2005695223825312)
,p_name=>'OB.COL_DATA_SCALE'
,p_message_text=>'Data Scale'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2005713800825312)
,p_name=>'OB.COL_DATA_TYPE'
,p_message_text=>'Data Type'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2005866917825312)
,p_name=>'OB.COL_DB_LINK'
,p_message_text=>'DB Link'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2005967544825312)
,p_name=>'OB.COL_DEFAULT'
,p_message_text=>'Default'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2006000877825312)
,p_name=>'OB.COL_DELETE_RULE'
,p_message_text=>'Delete Rule'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2006174041825312)
,p_name=>'OB.COL_DENSITY'
,p_message_text=>'Density'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2006203193825312)
,p_name=>'OB.COL_DESCRIPTION'
,p_message_text=>'Description'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2006373589825312)
,p_name=>'OB.COL_DISTINCT'
,p_message_text=>'Distinct'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2006462793825312)
,p_name=>'OB.COL_DOCUMENT_COUNT'
,p_message_text=>'Document Count'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2006563724825312)
,p_name=>'OB.COL_ENDPOINT'
,p_message_text=>'SODA REST Endpoint'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2006631768825312)
,p_name=>'OB.COL_ERROR'
,p_message_text=>'Error'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2006763163825312)
,p_name=>'OB.COL_FINAL'
,p_message_text=>'Final'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2006993788825312)
,p_name=>'OB.COL_FUNCTION_STATUS'
,p_message_text=>'Function Status'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007072267825312)
,p_name=>'OB.COL_GRANTABLE'
,p_message_text=>'Grantable'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007142555825312)
,p_name=>'OB.COL_GRANTEE'
,p_message_text=>'Grantee'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007230719825312)
,p_name=>'OB.COL_GRANTOR'
,p_message_text=>'Grantor'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007372985825312)
,p_name=>'OB.COL_HOST'
,p_message_text=>'Host'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1505585825054006)
,p_name=>'OB.COL_IDENTITY'
,p_message_text=>'Identity'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2792122121539948)
,p_name=>'OB.COL_IMPORT_NAME'
,p_message_text=>'Import Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007493515825312)
,p_name=>'OB.COL_INCREMENT_BY'
,p_message_text=>'Increment By'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007549995825312)
,p_name=>'OB.COL_INDEX'
,p_message_text=>'Index'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007688332825312)
,p_name=>'OB.COL_INDEX_NAME'
,p_message_text=>'Index Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007712030825312)
,p_name=>'OB.COL_INDEX_TYPE'
,p_message_text=>'Index Type'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007828457825312)
,p_name=>'OB.COL_INSTANTIABLE'
,p_message_text=>'Instantiable'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2007961851825312)
,p_name=>'OB.COL_INVALID'
,p_message_text=>'Invalid'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2008074430825312)
,p_name=>'OB.COL_JOB_INTERVAL'
,p_message_text=>'Job Interval'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2008224861825312)
,p_name=>'OB.COL_KEY'
,p_message_text=>'Key'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2008321281825312)
,p_name=>'OB.COL_LAST_ANALYZED'
,p_message_text=>'Last Analyzed'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2008406441825312)
,p_name=>'OB.COL_LAST_CHANGE'
,p_message_text=>'Last Change'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2008506515825312)
,p_name=>'OB.COL_LAST_MODIFIED'
,p_message_text=>'Last Modified'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2008645292825312)
,p_name=>'OB.COL_LAST_NUMBER'
,p_message_text=>'Last Number'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2008764337825312)
,p_name=>'OB.COL_LAST_REFRESH'
,p_message_text=>'Last Refresh'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2008823266825312)
,p_name=>'OB.COL_LAST_SYNC'
,p_message_text=>'Last Synchronization'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009090707825312)
,p_name=>'OB.COL_LINE'
,p_message_text=>'Line'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009176264825312)
,p_name=>'OB.COL_LOCAL_ATTRIBUTES'
,p_message_text=>'Local Attributes'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009226775825312)
,p_name=>'OB.COL_LOCAL_METHODS'
,p_message_text=>'Local Methods'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009359340825312)
,p_name=>'OB.COL_LOCATION'
,p_message_text=>'Location'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009474159825312)
,p_name=>'OB.COL_MASTER'
,p_message_text=>'Master'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009504018825312)
,p_name=>'OB.COL_MASTER_LINK'
,p_message_text=>'Master Link'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009623539825312)
,p_name=>'OB.COL_MASTER_OWNER'
,p_message_text=>'Master Owner'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009730348825312)
,p_name=>'OB.COL_MASTER_ROLLBACK'
,p_message_text=>'Master Rollback Seg.'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009886454825312)
,p_name=>'OB.COL_MASTER_VIEW'
,p_message_text=>'Master View'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2009973489825312)
,p_name=>'OB.COL_MAX_VALUE'
,p_message_text=>'Max Value'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2010039333825312)
,p_name=>'OB.COL_METHODS'
,p_message_text=>'# of Methods'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2010196235825312)
,p_name=>'OB.COL_MIN_VALUE'
,p_message_text=>'Min Value'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2791961817538251)
,p_name=>'OB.COL_MODULE_NAME'
,p_message_text=>'Module Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2791741029537221)
,p_name=>'OB.COL_MODULE_OWNER'
,p_message_text=>'Module Owner'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2010293218825312)
,p_name=>'OB.COL_NAME'
,p_message_text=>'Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(135002483531583703)
,p_name=>'OB.COL_NEXT_SYNC'
,p_message_text=>'Next Synchronization'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2010523603825313)
,p_name=>'OB.COL_NULLABLE'
,p_message_text=>'Nullable'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2010677796825313)
,p_name=>'OB.COL_NULLS'
,p_message_text=>'Nulls'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2010757040825313)
,p_name=>'OB.COL_NUM_ROWS'
,p_message_text=>'Number of Rows'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2010833830825313)
,p_name=>'OB.COL_OBJECT_NAME'
,p_message_text=>'Object Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2010932127825313)
,p_name=>'OB.COL_OBJECT_OWNER'
,p_message_text=>'Object Owner'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011060742825313)
,p_name=>'OB.COL_OBJECT_STATUS'
,p_message_text=>'Object Status'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011156547825313)
,p_name=>'OB.COL_OBJECT_TYPE'
,p_message_text=>'Object Type'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011278412825313)
,p_name=>'OB.COL_OBJ_COL'
,p_message_text=>'Object/Collection'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011362822825313)
,p_name=>'OB.COL_ORDER_FLAG'
,p_message_text=>'Order Flag'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011435929825313)
,p_name=>'OB.COL_OWNER'
,p_message_text=>'Owner'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011521987825313)
,p_name=>'OB.COL_PARTITIONED'
,p_message_text=>'Partitioned'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011631291825313)
,p_name=>'OB.COL_POSITION'
,p_message_text=>'Position'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011763402825313)
,p_name=>'OB.COL_PREBUILT'
,p_message_text=>'Prebuilt'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011913766825313)
,p_name=>'OB.COL_PREDEFINED'
,p_message_text=>'Predefined'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012047692825313)
,p_name=>'OB.COL_PREFIX_LENGTH'
,p_message_text=>'Prefix Length'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012160840825313)
,p_name=>'OB.COL_PRIMARY_KEY'
,p_message_text=>'Primary Key'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012231742825313)
,p_name=>'OB.COL_PRIVILEGE'
,p_message_text=>'Privilege'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012364338825313)
,p_name=>'OB.COL_QUERY'
,p_message_text=>'Query'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012469351825313)
,p_name=>'OB.COL_REFERENCING_NAMES'
,p_message_text=>'Referencing Names'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012500175825313)
,p_name=>'OB.COL_REFRESH_GROUP'
,p_message_text=>'Refresh Group'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012648182825313)
,p_name=>'OB.COL_REFRESH_METHOD'
,p_message_text=>'Refresh Method'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012760869825313)
,p_name=>'OB.COL_REFRESH_MODE'
,p_message_text=>'Refresh Mode'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012803053825313)
,p_name=>'OB.COL_RELATED_CONSTRAINT'
,p_message_text=>'Related Constraint'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2012974744825313)
,p_name=>'OB.COL_RELATIONAL_VIEWS'
,p_message_text=>'Relational Views'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2013086822825313)
,p_name=>'OB.COL_RELEVANCE'
,p_message_text=>'Relevance'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7800535782997265)
,p_name=>'OB.COL_REST_ENABLED'
,p_message_text=>'REST Enabled'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2013121737825313)
,p_name=>'OB.COL_REST_SOURCE'
,p_message_text=>'REST Source'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2013292121825313)
,p_name=>'OB.COL_ROWS'
,p_message_text=>'Rows'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2013542908825313)
,p_name=>'OB.COL_SEARCH_CONDITION'
,p_message_text=>'Search Condition'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2013673225825313)
,p_name=>'OB.COL_SEARCH_INDEX'
,p_message_text=>'Search Index Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2013784569825313)
,p_name=>'OB.COL_SIZE'
,p_message_text=>'Size'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2013804713825313)
,p_name=>'OB.COL_START_WITH'
,p_message_text=>'Start With'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2013959769825313)
,p_name=>'OB.COL_STATUS'
,p_message_text=>'Status'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014071187825313)
,p_name=>'OB.COL_SUPERTYPE_NAME'
,p_message_text=>'Supertype Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014185056825313)
,p_name=>'OB.COL_SUPERTYPE_OWNER'
,p_message_text=>'Supertype Owner'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014209235825313)
,p_name=>'OB.COL_SYNONYM_NAME'
,p_message_text=>'Synonym Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014314536825313)
,p_name=>'OB.COL_SYNONYM_OWNER'
,p_message_text=>'Synonym Owner'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014427236825313)
,p_name=>'OB.COL_TABLE'
,p_message_text=>'Table'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014541956825314)
,p_name=>'OB.COL_TABLESPACE_NAME'
,p_message_text=>'Tablespace Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014621664825314)
,p_name=>'OB.COL_TABLE_NAME'
,p_message_text=>'Table Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014776336825314)
,p_name=>'OB.COL_TABLE_OWNER'
,p_message_text=>'Table Owner'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014832882825314)
,p_name=>'OB.COL_TABLE_TYPE'
,p_message_text=>'Table Type'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2014957560825314)
,p_name=>'OB.COL_TEMPORARY'
,p_message_text=>'Temporary'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015084258825314)
,p_name=>'OB.COL_TEXT'
,p_message_text=>'Text'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015122594825314)
,p_name=>'OB.COL_TRIGGERING_EVENT'
,p_message_text=>'Triggering Event'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015298819825314)
,p_name=>'OB.COL_TRIGGER_NAME'
,p_message_text=>'Trigger Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015310961825314)
,p_name=>'OB.COL_TRIGGER_STATUS'
,p_message_text=>'Trigger Status'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015481885825314)
,p_name=>'OB.COL_TRIGGER_TYPE'
,p_message_text=>'Trigger Type'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015518897825314)
,p_name=>'OB.COL_TYPE'
,p_message_text=>'Type'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015662415825314)
,p_name=>'OB.COL_TYPE_NAME'
,p_message_text=>'Type Name'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015728810825314)
,p_name=>'OB.COL_TYPE_OID'
,p_message_text=>'Type OID'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015884196825314)
,p_name=>'OB.COL_UNIQUENESS'
,p_message_text=>'Uniqueness'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015906693825314)
,p_name=>'OB.COL_UPDATABLE'
,p_message_text=>'Updatable'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2016069474825314)
,p_name=>'OB.COL_UPDATE_LOG'
,p_message_text=>'Update Log'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2016148734825314)
,p_name=>'OB.COL_UPDATE_TRIGGER'
,p_message_text=>'Update Trigger'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2016201682825314)
,p_name=>'OB.COL_USAGE'
,p_message_text=>'Usage'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2016375677825314)
,p_name=>'OB.COL_USERNAME'
,p_message_text=>'Username'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2016421374825314)
,p_name=>'OB.COL_USE_LOG'
,p_message_text=>'Can Use Log'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2008117575825312)
,p_name=>'OB.COL_VISIBILITY'
,p_message_text=>'Visibility'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2016533635825314)
,p_name=>'OB.COL_WHEN_CLAUSE'
,p_message_text=>'When Clause'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110982115000031967)
,p_name=>'OB.CORRECT_ERRORS'
,p_message_text=>'Correct errors before saving.'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2402188315706775)
,p_name=>'OB.CREATE_DATA'
,p_message_text=>'Insert Row'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1401676602278908)
,p_name=>'OB.CREATE_FUNCTION'
,p_message_text=>'Create Function'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1401817405281044)
,p_name=>'OB.CREATE_PACKAGE'
,p_message_text=>'Create Package'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1401434269276492)
,p_name=>'OB.CREATE_PROCEDURE'
,p_message_text=>'Create Procedure'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6401560940496359)
,p_name=>'OB.DUP_ARG_FOUND'
,p_message_text=>'Duplicate argument(s) %0 found. Please enter unique argument names.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6401025426482272)
,p_name=>'OB.DUP_COL_FOUND'
,p_message_text=>'Duplicate column(s) %0 found. Please enter unique column names.'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3201124927799749)
,p_name=>'OB.EDIT_DATA'
,p_message_text=>'Edit Row'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234643963608125373)
,p_name=>'OB.EDIT_IMPORT'
,p_message_text=>'Edit Import'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801037656867270)
,p_name=>'OB.FILTER_ADDED'
,p_message_text=>'Filter added. Enter filter.'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000880229099437)
,p_name=>'OB.FILTER_GROUP'
,p_message_text=>'Filter %0'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25403171384294321)
,p_name=>'OB.FUNCTION'
,p_message_text=>'Function'
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234643764570124054)
,p_name=>'OB.IMPORT_CREATED'
,p_message_text=>'Import created'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234644549700131414)
,p_name=>'OB.IMPORT_DELETED'
,p_message_text=>'Import Deleted'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(234644334693129798)
,p_name=>'OB.IMPORT_DELETE_CONFIRM'
,p_message_text=>'Are you sure you want to delete this Import?'
,p_is_js_message=>true
,p_version_scn=>37165770887574
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12400246073519700)
,p_name=>'OB.INSUFFICIENT_PRIVILEGES'
,p_message_text=>'The %0 schema does not have the required privileges to create this object.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1801224131166749)
,p_name=>'OB.INVALID'
,p_message_text=>'Invalid'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2354515999281581)
,p_name=>'OB.INVALID_OBJECTS'
,p_message_text=>'Invalid Objects'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2643912110539056)
,p_name=>'OB.MLE.URL_COULD_NOT_FETCH'
,p_message_text=>'Could not fetch file.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2643679253533143)
,p_name=>'OB.MLE.URL_MUST_BE_PROVIDED'
,p_message_text=>'The URL must be provided.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19000778534332184)
,p_name=>'OB.MOVE_DOWN'
,p_message_text=>'Move Down'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(19000530372331181)
,p_name=>'OB.MOVE_UP'
,p_message_text=>'Move Up'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1852627111904749)
,p_name=>'OB.NO_DATA'
,p_message_text=>'No data found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1852895262931238)
,p_name=>'OB.NO_DATA_COLUMNS'
,p_message_text=>'No columns found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854600923969095)
,p_name=>'OB.NO_DATA_CONSTRAINTS'
,p_message_text=>'No constraints found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1853210661938419)
,p_name=>'OB.NO_DATA_ERRORS'
,p_message_text=>'No errors found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1853058101935344)
,p_name=>'OB.NO_DATA_GRANTS'
,p_message_text=>'No grants found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3473876179727379)
,p_name=>'OB.NO_DATA_IMPORTS'
,p_message_text=>'No imports found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854446253965450)
,p_name=>'OB.NO_DATA_INDEX'
,p_message_text=>'No indexes found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1853836394953988)
,p_name=>'OB.NO_DATA_REF'
,p_message_text=>'No references to other objects found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854053058957077)
,p_name=>'OB.NO_DATA_REF_BY'
,p_message_text=>'No references by other objects found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1855077409981432)
,p_name=>'OB.NO_DATA_REST'
,p_message_text=>'No REST synchronizations found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854268959960475)
,p_name=>'OB.NO_DATA_SYNONYMS'
,p_message_text=>'No synonyms found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854853628975269)
,p_name=>'OB.NO_DATA_TRIGGERS'
,p_message_text=>'No triggers found.'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1818167097605097)
,p_name=>'OB.NO_SCHEMA'
,p_message_text=>'Can''t open object in schema %0'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(16600587002064927)
,p_name=>'OB.NO_SQL'
,p_message_text=>'Enter all required fields.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3831258877277213)
,p_name=>'OB.OBJECTS'
,p_message_text=>'Objects'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5400842814711239)
,p_name=>'OB.OBJECT_NAME_RESERVED'
,p_message_text=>'Entered object name <strong>%0</strong> is an Oracle reserved word. Please enter another name.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5400600427707334)
,p_name=>'OB.OBJECT_NAME_TOO_LONG'
,p_message_text=>'Entered Object Name is too long. Maximum allowed length is %0 bytes.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7424972051959851)
,p_name=>'OB.PACKAGE'
,p_message_text=>'Package'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(25402912990293333)
,p_name=>'OB.PROCEDURE'
,p_message_text=>'Procedure'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2402670867730182)
,p_name=>'OB.ROW_DELETED'
,p_message_text=>'Row deleted'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2402458092719554)
,p_name=>'OB.ROW_DELETE_CONFIRM'
,p_message_text=>'Are you sure you want to delete this row?'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2402810018934361)
,p_name=>'OB.ROW_INSERTED'
,p_message_text=>'Row inserted'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2016688242825314)
,p_name=>'OB.SV_COLUMN_STATISTICS'
,p_message_text=>'Column Statistics'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1807797026123910)
,p_name=>'OB.SV_CONTENTS'
,p_message_text=>'Contents'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2016836469825314)
,p_name=>'OB.SV_DATA_GUIDE'
,p_message_text=>'JSON Data Guide'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2016903170825314)
,p_name=>'OB.SV_INDEX'
,p_message_text=>'Index'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017099365825314)
,p_name=>'OB.SV_INDEX_COLUMNS'
,p_message_text=>'Index Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017109663825314)
,p_name=>'OB.SV_META_DATA'
,p_message_text=>'Collection Meta Data'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017208639825314)
,p_name=>'OB.SV_REFERENCED_BY'
,p_message_text=>'Referenced by'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017357703825314)
,p_name=>'OB.SV_REFERENCES'
,p_message_text=>'References'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017446043825314)
,p_name=>'OB.SV_REST_SYNC'
,p_message_text=>'REST Synchronizations'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017532039825314)
,p_name=>'OB.SV_SUMMARY'
,p_message_text=>'Summary'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017682912825314)
,p_name=>'OB.SV_SYNONYMS'
,p_message_text=>'Synonyms'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017712919825314)
,p_name=>'OB.SV_TABLE_STATISTICS'
,p_message_text=>'Table Statistics'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017885172825314)
,p_name=>'OB.SV_TRIGGER'
,p_message_text=>'Trigger'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2017959280825314)
,p_name=>'OB.SV_TRIGGER_COLUMNS'
,p_message_text=>'Trigger Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2354269405269720)
,p_name=>'OB.TB_LABEL'
,p_message_text=>'%0 Actions'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1453528600760292)
,p_name=>'OB.TB_MORE'
,p_message_text=>'More'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018096988825314)
,p_name=>'OB.VIEW_BODY'
,p_message_text=>'Body'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018180799825314)
,p_name=>'OB.VIEW_CODE'
,p_message_text=>'Code'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018225377825315)
,p_name=>'OB.VIEW_COL_CONTENTS'
,p_message_text=>'Collection Contents'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018354847825315)
,p_name=>'OB.VIEW_CONSTRAINTS'
,p_message_text=>'Constraints'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018427938825315)
,p_name=>'OB.VIEW_DATA'
,p_message_text=>'Data'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019648648825315)
,p_name=>'OB.VIEW_DDL'
,p_message_text=>'DDL'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018549114825315)
,p_name=>'OB.VIEW_DEPS'
,p_message_text=>'Dependencies'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018659189825315)
,p_name=>'OB.VIEW_DETAILS'
,p_message_text=>'Details'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2792487507560154)
,p_name=>'OB.VIEW_ENV_IMPORTS'
,p_message_text=>'Imports'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018723222825315)
,p_name=>'OB.VIEW_ERRORS'
,p_message_text=>'Errors'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018856480825315)
,p_name=>'OB.VIEW_GRANTS'
,p_message_text=>'Grants'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2018989595825315)
,p_name=>'OB.VIEW_GUIDE'
,p_message_text=>'Data Guide'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019001126825315)
,p_name=>'OB.VIEW_INDEXES'
,p_message_text=>'Indexes'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019149236825315)
,p_name=>'OB.VIEW_MATERIALIZED_VIEW'
,p_message_text=>'Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019254681825315)
,p_name=>'OB.VIEW_META'
,p_message_text=>'Meta Data'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019343553825315)
,p_name=>'OB.VIEW_OBJECT_DETAILS'
,p_message_text=>'Object Details'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019499939825315)
,p_name=>'OB.VIEW_SAMPLES'
,p_message_text=>'Sample Queries'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019540759825315)
,p_name=>'OB.VIEW_SPECIFICATION'
,p_message_text=>'Specification'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019784223825315)
,p_name=>'OB.VIEW_STATS'
,p_message_text=>'Statistics'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019862870825315)
,p_name=>'OB.VIEW_SYNONYMS'
,p_message_text=>'Synonyms'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2019956734825315)
,p_name=>'OB.VIEW_TABLE'
,p_message_text=>'Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2020077680825315)
,p_name=>'OB.VIEW_TRIGGERS'
,p_message_text=>'Triggers'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2020173704825315)
,p_name=>'OB.VIEW_UI_DEFS'
,p_message_text=>'UI Defaults'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2020254147825315)
,p_name=>'OB.VIEW_VIEW'
,p_message_text=>'Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3902048964406116)
,p_name=>'OB_TREE.DATABASE_LINK_PLURAL'
,p_message_text=>'Database Links'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901643500403927)
,p_name=>'OB_TREE.FUNCTION_PLURAL'
,p_message_text=>'Functions'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900657315395883)
,p_name=>'OB_TREE.INDEX_PLURAL'
,p_message_text=>'Indexes'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3902211473407400)
,p_name=>'OB_TREE.MATERIALIZED_VIEW_PLURAL'
,p_message_text=>'Materialized Views'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600976273704134)
,p_name=>'OB_TREE.MLE_ENVIRONMENT_PLURAL'
,p_message_text=>'MLE Environments'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3601153986708784)
,p_name=>'OB_TREE.MLE_MODULE_PLURAL'
,p_message_text=>'MLE Modules - JavaScript'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901261278400365)
,p_name=>'OB_TREE.PACKAGE_PLURAL'
,p_message_text=>'Packages'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901494070402832)
,p_name=>'OB_TREE.PROCEDURE_PLURAL'
,p_message_text=>'Procedures'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900819609397962)
,p_name=>'OB_TREE.SEQUENCE_PLURAL'
,p_message_text=>'Sequences'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3902643700409933)
,p_name=>'OB_TREE.SODA_COLLECTION_PLURAL'
,p_message_text=>'SODA Collections'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3902476981408554)
,p_name=>'OB_TREE.SYNONYM_PLURAL'
,p_message_text=>'Synonyms'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900244234392486)
,p_name=>'OB_TREE.TABLE_PLURAL'
,p_message_text=>'Tables'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901849450404939)
,p_name=>'OB_TREE.TRIGGER_PLURAL'
,p_message_text=>'Triggers'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901022396399060)
,p_name=>'OB_TREE.TYPE_PLURAL'
,p_message_text=>'Types'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900485389393893)
,p_name=>'OB_TREE.VIEW_PLURAL'
,p_message_text=>'Views'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2215158266643539)
,p_name=>'ODG.BLUEPRINT_ERRORS'
,p_message_text=>'Could not save %0: %1. %2'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8052220435709409)
,p_name=>'ODG.BLUEPRINT_SAVED'
,p_message_text=>'Blueprint Saved'
,p_is_js_message=>true
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3015187357045317)
,p_name=>'ODG.PE.ADVANCED'
,p_message_text=>'Advanced'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3007671235963892)
,p_name=>'ODG.PE.BLUEPRINT'
,p_message_text=>'Blueprint'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804705192527799)
,p_name=>'ODG.PE.BLUEPRINT.DESCRIPTION.HELP'
,p_message_text=>'Enter a description for this blueprint.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(259741959839369660)
,p_name=>'ODG.PE.BLUEPRINT.DISPLAY_NAME.HELP'
,p_message_text=>'Enter a user-friendly blueprint name.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3704744807443876)
,p_name=>'ODG.PE.BLUEPRINT.NAME.HELP'
,p_message_text=>'Enter a unique name for this blueprint. The name will be automatically capitalized and special characters will be removed.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3804966557528835)
,p_name=>'ODG.PE.BLUEPRINT.SCHEMA.HELP'
,p_message_text=>'The blueprint schema. You can use existing tables visible in this schema to generate data into tables in this blueprint.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5205228542411197)
,p_name=>'ODG.PE.BLUEPRINT_COL'
,p_message_text=>'Blueprint Column'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3018187812120330)
,p_name=>'ODG.PE.BLUEPRINT_DESIGNER'
,p_message_text=>'Blueprint Designer'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73954850321753693)
,p_name=>'ODG.PE.BLUEPRINT_SOURCE'
,p_message_text=>'Blueprint Source'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5205055762409889)
,p_name=>'ODG.PE.BLUEPRINT_TBL'
,p_message_text=>'Blueprint Table'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1406913860547486)
,p_name=>'ODG.PE.BLUEPRINT_TREE_NAME'
,p_message_text=>'Blueprint'
,p_version_scn=>21942881
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3010923780014733)
,p_name=>'ODG.PE.BUILT_IN'
,p_message_text=>'Built-In'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(73955042455761517)
,p_name=>'ODG.PE.CLICK_TO_SELECT_BLUEPRINT_DS'
,p_message_text=>'Select a Table and Column from this Blueprint'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(48061688906241109)
,p_name=>'ODG.PE.CLICK_TO_SELECT_CUSTOM_DS'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a Custom Data Source',
''))
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3810951800555884)
,p_name=>'ODG.PE.COL.DISPLAY_NAME.HELP'
,p_message_text=>'Enter a user-friendly column name.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806335325535707)
,p_name=>'ODG.PE.COL.DS.BLUEPRINT.HELP'
,p_message_text=>'References an existing column in another table in this blueprint. This option is available when there are two or more tables.'
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807190669539389)
,p_name=>'ODG.PE.COL.DS.BUILTIN.FORMAT_MASK.HELP'
,p_message_text=>'Enter a format for the dates to be generated. Default format used: ''YYYY-MM-DD"T"HH24:MI:SS"Z"'''
,p_version_scn=>37165770887597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806545647536562)
,p_name=>'ODG.PE.COL.DS.BUILTIN.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>References an existing built-in data source. Depending on the built-in data type, other customizations are available.</p>',
'<p>For DATE data types, you can customize a <strong>Minimum Date</strong>, <strong>Maximum Date</strong> and <strong>Format Mask</strong>.</p>',
'<p>For NUMBER data types, you can customize a <strong>Minimum Value</strong>, <strong>Maximum Value</strong> and <strong>Value Precision</strong>.</p>',
'<p>When mixed with multi-value options, you can generate more than one built-in value per row.</p>',
''))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806910853538618)
,p_name=>'ODG.PE.COL.DS.BUILTIN.MAX_DATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a date you want the dates to be generated equal to or less than.</p>',
'<p>',
'The date string will be converted to a date object using the format mask specified. If none is provided, the default format mask is: YYYY-MM-DD"T"HH24:MI:SS"Z"</p>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807574829540906)
,p_name=>'ODG.PE.COL.DS.BUILTIN.MAX_VAL.HELP'
,p_message_text=>'Enter a value to generate numbers equal to or less than.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806724401537956)
,p_name=>'ODG.PE.COL.DS.BUILTIN.MIN_DATE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a date you want the dates to be generated equal to or greater than.</p>',
'<p>The date string will be converted to a date object using the format mask specified. If none is provided, the default format mask is: YYYY-MM-DD"T"HH24:MI:SS"Z"</p>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807327600540009)
,p_name=>'ODG.PE.COL.DS.BUILTIN.MIN_VAL.HELP'
,p_message_text=>'Enter a value to generate numbers equal to or greater than.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807732018541674)
,p_name=>'ODG.PE.COL.DS.BUILTIN.PRECISION.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter <strong>0</strong> if you want no decimal values.</p>',
'<p>Enter -1 to round generated numbers to ten.</p>',
'<p>Enter any positive integer as the number of decimal places desired.</p>',
''))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3807915379544606)
,p_name=>'ODG.PE.COL.DS.CUSTOM.HELP'
,p_message_text=>'References an existing custom data source in this blueprint. Custom Data Sources obtain data from existing tables in the current schema or from a SQL Query.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808165192545429)
,p_name=>'ODG.PE.COL.DS.CUSTOM_COLUMN.HELP'
,p_message_text=>'References a column from an existing custom data source in this blueprint. Custom Data Sources obtain data from existing tables in the current schema or from a SQL Query.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3806144869534773)
,p_name=>'ODG.PE.COL.DS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a Data Source Type:</p>',
'<ul>',
'    <li><strong>Blueprint:</strong> Creates a reference to a column in another table in this blueprint. This option is available when there are two or more tables.</li>',
'    <li><strong>Custom Data Source:</strong> References data in a table or in a SQL query. This option is available when there are data sources added to this blueprint.</li>',
'    <li><strong>Built In:</strong> Generates real-world sample data from a wide variety of categories already included in APEX.<br/> Built-in data can be related to each other. Example: if a column uses location.city and another uses location.state, '
||'the city will correlate with the state selected.</br>Can be used with multi-value options.</li>',
'    <li><strong>Inline:</strong> Allows you to add custom values each with its own frequency. The frequency indicates how often the related value appears in the generated data, when used with multi-value options.</li>',
'    <li><strong>Sequence:</strong> Creates a numeric sequence with customizable start value and interval between successive numbers (increment).</li>',
'    <li><strong>Formula:</strong> You can use PL/SQL expressions to reference other columns in this table and apply basic transformations.</li>',
'</ul>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808391401546122)
,p_name=>'ODG.PE.COL.DS.INLINE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Add custom values each with its own frequency.</p>',
'<p>The <strong>frequency</strong> indicates how often this value appears compared to other values in the list. The higher the frequency, the more often this value will occur in the generated data.</p>',
'<p>Example.: If you provide <code>ValueA,1</code> and <code>ValueB,3</code>, ValueA will occur 1/4 rows and ValueB will occur 3/4 rows.</p>',
'<p>When combined with <strong>Multi Value</strong> set to "YES", the frequency will also affect how often a value occurs on each row.</p>',
'<p>Example: an <strong>inline</strong> value of <code>JavaScript,4;PLSQL,2;CSS,3</code> could generate the following output data for this column:<br/><br/>',
'row1: Javascript,PLSQL<br/>',
'row2: Javascript,CSS<br/>',
'row3: Javascript,PLSQL,CSS<br/>',
'row4: Javascript,CSS<br/>',
'</p>',
'<p><strong>Note:</strong> the frequency value is an approximation, so it might not produce the exact distribution.</p>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808772209547508)
,p_name=>'ODG.PE.COL.DS.SEQUENCE.INCREMENT.HELP'
,p_message_text=>'Specify the interval between sequence numbers.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808569225546833)
,p_name=>'ODG.PE.COL.DS.SEQUENCE.START_WITH.HELP'
,p_message_text=>'<p>Set the number to be used as the first value in the sequence.</p>'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3809125297549403)
,p_name=>'ODG.PE.COL.FORMULA.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define a PL/SQL formula to transform the column output data. Use the <code>{column_name}</code> syntax to reference column values from the table.</p>',
'<p>Example that produces custom emails, referencing col1 and col2 from the same table:</p>',
'<p><code>lower({col1}||''.''||{col2}||''@company.com'' )</code></p>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3811399271557149)
,p_name=>'ODG.PE.COL.LANG.HELP'
,p_message_text=>'This indicates the language used for generating data for this column.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3811507343557792)
,p_name=>'ODG.PE.COL.MAX_LENGTH.HELP'
,p_message_text=>'Enter the maximum number of characters to generate for this column.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3809998958552483)
,p_name=>'ODG.PE.COL.MULTI_VALUE.DELIMITER.HELP'
,p_message_text=>'Define a delimiter to separate each value in this column.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3809721906551359)
,p_name=>'ODG.PE.COL.MULTI_VALUE.FORMAT.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an output format option:</p>',
'<ul>',
'    <li><strong>Delimited:</strong> You can use a custom delimiter to separate values for this column generated data.</li>',
'    <li><strong>JSON:</strong> This column generated data will be in JavaScript object notation (JSON). Example: <code>{"column_name":["output1","output2","output3"]}</code></li>',
'</ul>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3808922395548233)
,p_name=>'ODG.PE.COL.MULTI_VALUE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When enabled, values can be repeated in generated data.</p>',
'<p>When disabled, built in data types will always generate distinct column values. Inline data types will be distinct as long as all values appear only once.</p>',
''))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3810557480554477)
,p_name=>'ODG.PE.COL.MULTI_VALUE.MAX_ENTRIES.HELP'
,p_message_text=>'Determine the maximum amount of values for this column.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3810399480553742)
,p_name=>'ODG.PE.COL.MULTI_VALUE.MIN_ENTRIES.HELP'
,p_message_text=>'Determine the minimum amount of values for this column.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3810740767555141)
,p_name=>'ODG.PE.COL.MULTI_VALUE.PARTITION_BY.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can select another built-in from the same group of the built-in selected above.</p>',
'<p>For instance, by selecting built-in car.model for a column and partition by car.make ensures the car models correlate the car maker.</p>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3810168229553102)
,p_name=>'ODG.PE.COL.MULTI_VALUE.UNIQUE.HELP'
,p_message_text=>'When enabled, each value in this column will not repeat. Otherwise, duplicates are allowed.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805929267533751)
,p_name=>'ODG.PE.COL.NAME.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a name for this column. If its name matches an existing column in a table with the same name in the current schema, you can run insert statements directly to populate it with generated data.',
''))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3809559973550681)
,p_name=>'ODG.PE.COL.PERCENT_BLANK.HELP'
,p_message_text=>'Define a number between 0 and 100 to set the percentage of NULL values that will be generated for this column.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3809316940550074)
,p_name=>'ODG.PE.COL.REQUIRED.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Marks this column as required, therefore it will not generate NULL values.</p>',
'<p>When set to ''NO'', a number from 0 to 100 can be set in the <strong>Percent Blank</strong> property to indicate how many NULL values will be generated.</p>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3811134271556539)
,p_name=>'ODG.PE.COL.SEQ.HELP'
,p_message_text=>'This auto-generated value dictates the order in which columns get their data generated.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3010120837995002)
,p_name=>'ODG.PE.COLUMN'
,p_message_text=>'Column'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255763086717633849)
,p_name=>'ODG.PE.COMMENT'
,p_message_text=>'Comment'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3409812959168233)
,p_name=>'ODG.PE.CONFIRM_DELETE'
,p_message_text=>'Are you sure you want to delete %0 "%1"?'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4801902788205738)
,p_name=>'ODG.PE.CONTEXT.ADD_COLUMN'
,p_message_text=>'Add Column'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4802126092208655)
,p_name=>'ODG.PE.CONTEXT.ADD_DATA_SOURCE'
,p_message_text=>'Add Data Source'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4801729899173838)
,p_name=>'ODG.PE.CONTEXT.ADD_TABLE'
,p_message_text=>'Add Table'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4802564439213634)
,p_name=>'ODG.PE.CONTEXT.DELETE_COLUMN'
,p_message_text=>'Delete Column'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4802707119215031)
,p_name=>'ODG.PE.CONTEXT.DELETE_DATA_SOURCE'
,p_message_text=>'Delete Data Source'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4802342069211455)
,p_name=>'ODG.PE.CONTEXT.DELETE_TABLE'
,p_message_text=>'Delete Table'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4802902441219867)
,p_name=>'ODG.PE.CONTEXT.PREVIEW_DATA'
,p_message_text=>'Preview Data'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(54969233954390661)
,p_name=>'ODG.PE.CORRECT_BEFORE_SAVE'
,p_message_text=>'Before you can save, preview, or generate data, correct the following errors in the blueprint: %0'
,p_is_js_message=>true
,p_version_scn=>15350308
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3008762075983330)
,p_name=>'ODG.PE.CREATED_BY'
,p_message_text=>'Created By'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3008574225981837)
,p_name=>'ODG.PE.CREATED_ON'
,p_message_text=>'Created On'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3010780907011780)
,p_name=>'ODG.PE.CUSTOM_DATA_SOURCE'
,p_message_text=>'Custom Data Source'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3010523953008368)
,p_name=>'ODG.PE.DATA_SOURCE'
,p_message_text=>'Data Source'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3811768862558462)
,p_name=>'ODG.PE.DATA_SOURCE.NAME.HELP'
,p_message_text=>'Enter a name for this data source.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3812569166561276)
,p_name=>'ODG.PE.DATA_SOURCE.SQL_QUERY.HELP'
,p_message_text=>'<p>Add a valid SQL Query with named columns so they can be selected as a custom data source.</p>'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3812106237560038)
,p_name=>'ODG.PE.DATA_SOURCE.TABLE.HELP'
,p_message_text=>'Name of an existing table in the schema.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3811972005559266)
,p_name=>'ODG.PE.DATA_SOURCE.TYPE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a source type:</p>',
'<ul>',
'    <li><strong>Table</strong> requires an existing table in the schema. Optional Where clause can be added.</li>',
'    <li><strong>SQL Query</strong> requires a valid SQL query.</li>',
'</ul>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3812307876560607)
,p_name=>'ODG.PE.DATA_SOURCE.WHERE_CLAUSE.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Optionally add a where clause to filter the data from the source table. Do not include the where clause itself.</p>',
'<p>Example: <code>deptno <= 20</code> will result in</p>',
'<p><code>select * </br>from dept</br>where deptno <= 20</code></p>'))
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3015516427047421)
,p_name=>'ODG.PE.DATA_SOURCE_NAME'
,p_message_text=>'Data Source Name'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3017690542110364)
,p_name=>'ODG.PE.DELIMITED'
,p_message_text=>'Delimited'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3013539606035369)
,p_name=>'ODG.PE.DELIMITER'
,p_message_text=>'Delimiter'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3008337300977400)
,p_name=>'ODG.PE.DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3009569132990379)
,p_name=>'ODG.PE.DISPLAY_NAME'
,p_message_text=>'Display Name'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3509882244182126)
,p_name=>'ODG.PE.ERROR_DELETE'
,p_message_text=>'Could not delete blueprint object %0. Output: %1'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3017350963100139)
,p_name=>'ODG.PE.EXISTING_TABLE'
,p_message_text=>'Existing Table'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3013395967034377)
,p_name=>'ODG.PE.FORMAT'
,p_message_text=>'Format'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3011522908021160)
,p_name=>'ODG.PE.FORMAT_MASK'
,p_message_text=>'Format Mask'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3014536648041622)
,p_name=>'ODG.PE.FORMULA'
,p_message_text=>'Formula'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4100873143349896)
,p_name=>'ODG.PE.HELP'
,p_message_text=>'<h3>Blueprint Designer</h3><p>Use the tree view on the left to select a blueprint, table, column or custom data source object and modify its attributes.</p><p>You can create new tables, columns and custom data sources using the context menu too.</p><'
||'p>Using the Generate Data and Preview Data buttons, you can preview data for the tables and columns, and export the data to a JSON, CSV, or SQL file. If a table exists in the schema with the same name, data can be inserted into the corresponding colu'
||'mns.</p>'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3012730715030085)
,p_name=>'ODG.PE.INCREMENT'
,p_message_text=>'Increment'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3012360030026898)
,p_name=>'ODG.PE.INLINE'
,p_message_text=>'Inline'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3010341155996794)
,p_name=>'ODG.PE.LANGUAGE'
,p_message_text=>'Language'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3011338806019784)
,p_name=>'ODG.PE.MAX_DATE'
,p_message_text=>'Maximum Date'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3014164377039273)
,p_name=>'ODG.PE.MAX_ENTRIES'
,p_message_text=>'Maximum Entries'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3015343551046283)
,p_name=>'ODG.PE.MAX_LENGTH'
,p_message_text=>'Maximum Length'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3011902882024649)
,p_name=>'ODG.PE.MAX_VALUE'
,p_message_text=>'Maximum Value'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3011134524017445)
,p_name=>'ODG.PE.MIN_DATE'
,p_message_text=>'Minimum Date'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3013991405038057)
,p_name=>'ODG.PE.MIN_ENTRIES'
,p_message_text=>'Minimum Entries'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3011739096022733)
,p_name=>'ODG.PE.MIN_VALUE'
,p_message_text=>'Minimum Value'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3012965942031265)
,p_name=>'ODG.PE.MULTI_VALUE'
,p_message_text=>'Multi Value'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3013131342033377)
,p_name=>'ODG.PE.MULTI_VALUE_OPTIONS'
,p_message_text=>'Multi Value Options'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3007978157972442)
,p_name=>'ODG.PE.NAME'
,p_message_text=>'Name'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3017808319113916)
,p_name=>'ODG.PE.NO_PARTITION'
,p_message_text=>'No Partition'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3009782277991869)
,p_name=>'ODG.PE.NUM_ROWS'
,p_message_text=>'Number of Rows'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3014350987040561)
,p_name=>'ODG.PE.PARTITION_BY'
,p_message_text=>'Partition By'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3014984132043844)
,p_name=>'ODG.PE.PERCENT_BLANK'
,p_message_text=>'Percent Blank'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4201049819877724)
,p_name=>'ODG.PE.REDIRECT'
,p_message_text=>'Go to Blueprints'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3014796346042764)
,p_name=>'ODG.PE.REQUIRED'
,p_message_text=>'Required'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3016954438076797)
,p_name=>'ODG.PE.RETURN_TYPE'
,p_message_text=>'Return Type'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3008155540975880)
,p_name=>'ODG.PE.SCHEMA'
,p_message_text=>'Schema'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255763867714642519)
,p_name=>'ODG.PE.SEARCH'
,p_message_text=>'Search'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3009957558993237)
,p_name=>'ODG.PE.SEQUENCE'
,p_message_text=>'Sequence'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3016161362050745)
,p_name=>'ODG.PE.SQL_QUERY'
,p_message_text=>'SQL Query'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3012548323028349)
,p_name=>'ODG.PE.START_WITH'
,p_message_text=>'Start With'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3009370563987035)
,p_name=>'ODG.PE.TABLE'
,p_message_text=>'Table'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805340060531043)
,p_name=>'ODG.PE.TABLE.DISPLAY_NAME.HELP'
,p_message_text=>'Enter a user-friendly table name.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1403411887644831)
,p_name=>'ODG.PE.TABLE.NAME.ERROR'
,p_message_text=>'The table name should not contain spaces.'
,p_is_js_message=>true
,p_version_scn=>22249552
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805141919529799)
,p_name=>'ODG.PE.TABLE.NAME.HELP'
,p_message_text=>'Enter a name for this table. If its name matches an existing table in the current schema, you can run insert statements to directly populate its columns with generated data.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(54970540922554277)
,p_name=>'ODG.PE.TABLE.NUM_ROWS.ERROR'
,p_message_text=>'The maximum number of rows allowed is 500,000.'
,p_is_js_message=>true
,p_version_scn=>15141300
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805589614531940)
,p_name=>'ODG.PE.TABLE.NUM_ROWS.HELP'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the number of rows of data to generate for this table. This number can be scaled later to generate fewer or more rows of data.</p>',
'<p>The maximum number of rows allowed is 500,000</p>'))
,p_version_scn=>15141260
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3805712164532877)
,p_name=>'ODG.PE.TABLE.SEQ.HELP'
,p_message_text=>'This auto-generated value dictates the order in which tables get their data generated.'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255762216927565243)
,p_name=>'ODG.PE.TABLES'
,p_message_text=>'Tables'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3015951900049423)
,p_name=>'ODG.PE.TABLE_NAME'
,p_message_text=>'Table Name'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3015792300048322)
,p_name=>'ODG.PE.TYPE'
,p_message_text=>'Type'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(309972573244004937)
,p_name=>'ODG.PE.UNABLE_TO_DELETE.BODY'
,p_message_text=>'<p>The <code>%0</code> %1 is currently referenced by:</p><code>%2</code><br><br><p>Please remove all references to this %3 first and try again.</p>'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(309972364279001653)
,p_name=>'ODG.PE.UNABLE_TO_DELETE.TITLE'
,p_message_text=>'Unable to delete %0'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3013711233036981)
,p_name=>'ODG.PE.UNIQUE'
,p_message_text=>'Unique'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3009121003985784)
,p_name=>'ODG.PE.UPDATED_BY'
,p_message_text=>'Updated By'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3008926794984602)
,p_name=>'ODG.PE.UPDATED_ON'
,p_message_text=>'Updated On'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3012135600025816)
,p_name=>'ODG.PE.VALUE_PRECISION'
,p_message_text=>'Value Precision'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(255762631051630238)
,p_name=>'ODG.PE.VIEWS'
,p_message_text=>'Views'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3016309169052030)
,p_name=>'ODG.PE.WHERE_CLAUSE'
,p_message_text=>'Where Clause'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5907526340473557)
,p_name=>'PE.CODE_EDITOR'
,p_message_text=>'Code Editor: %0'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5906046830303871)
,p_name=>'PE.LIST_OF_VALUES'
,p_message_text=>'List of Values %0'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(240658061184279133)
,p_name=>'PE.NO_COMPONENTS_SELECTED'
,p_message_text=>'No components currently selected'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5905619355298052)
,p_name=>'PE.PICK'
,p_message_text=>'Pick %0'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2051332710059484)
,p_name=>'QUICKSQL.ABOUT'
,p_message_text=>'About Quick SQL'
,p_version_scn=>45129633
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(288106152097340154)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use Quick SQL to rapidly create a relational data model from a simple text specification. With minimal typing, you can instantly generate the SQL commands to create tables, views, triggers, index structures, and sample data. While not a replacemen'
||'t for formal data modeling, it''s a lightning-fast way to produce a SQL script you can later evolve as needed.</p>',
'',
'<p>Top Use Cases:',
'<ul>',
'  <li>Quickly create robust data models</li>',
'  <li>Save Quick SQL shorthand as a model to adapt or use later</li>',
'  <li>Easily generate sample data</li>',
'  <li>Learn SQL syntax using provided examples</li>',
'</ul>',
'</p>'))
,p_version_scn=>40145885
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184668194170428798)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Controls whether audit column triggers use the APEX-aware expression to set the <code>created_by</code> and <code>updated_by</code> column values:',
''))
,p_version_scn=>39913246
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2055378505438736)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_text=>'When not enabled the following function is used:'
,p_version_scn=>45137876
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184673724980577946)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_text=>'Generates PL/SQL package API for each table to query, insert, update, and delete its data.'
,p_version_scn=>39913334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184682076856629834)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_text=>'Audits changes for each table in <code>created</code>, <code>created_by</code>, <code>updated</code>, <code>updated_by</code> columns using a trigger.'
,p_version_scn=>39913430
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184687133295708234)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_text=>'Compresses each table''s data to optimize space.'
,p_version_scn=>39913663
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184688894599736074)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_text=>'Overrides default audit column name for user who created a row.'
,p_version_scn=>39930075
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184689027075742257)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_text=>'Overrides default audit column name for when row was created.'
,p_version_scn=>39914054
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184694962019798352)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_text=>'Overrides default datatype for dates. Valid values are:'
,p_version_scn=>39914076
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184707889930819644)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_text=>'Sets database version compatibility for generated SQL. Valid values:'
,p_version_scn=>39927395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2055176741436415)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_text=>'Default'
,p_version_scn=>45137820
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2053163403402822)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_text=>'Departments and Employees'
,p_version_scn=>45137037
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(713113287843203492)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_text=>'Includes DEPARTMENTS and EMPLOYEES tables with an additional EMP_V join view.  Generates random data (/INSERT).  Adds a NOT NULL constraint (/NN).  Defines tables, columns and child tables using indented lists. Illustrates how primary and foreign key'
||' columns get automatically added.'
,p_version_scn=>39380206
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2054982149434711)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_text=>'Description'
,p_version_scn=>45137760
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3401027774241468)
,p_name=>'QUICKSQL.DIAGRAM_TITLE'
,p_message_text=>'Diagram'
,p_is_js_message=>true
,p_version_scn=>47409286
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184718810726850774)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_text=>'Includes commands to initially drop each database object.'
,p_version_scn=>39919216
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7402670978443803)
,p_name=>'QUICKSQL.EDITIONABLE'
,p_message_text=>'Enables PL/SQL triggers and packages to be editionable.'
,p_version_scn=>39919366
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2056117639487976)
,p_name=>'QUICKSQL.EDITIONABLE_SETTING'
,p_message_text=>'When generating PL/SQL objects including triggers and packages make these editionable.'
,p_version_scn=>45140672
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2053368280408404)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_text=>'Employee Skills'
,p_version_scn=>45137111
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(713112726666196735)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_text=>'Includes DEPARTMENTS, EMPLOYEES, and SKILLS tables using indentation to identify parent and child tables.  Specifies a SQL datatype (VC255). Generates ten rows of random data (/INSERT) and provides example values (/VALUES). Defines legal values with '
||'a check constraint (/CHECK). Illustrates adding a column comment in square brackets.'
,p_version_scn=>39385565
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2052905490086499)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_text=>'Example'
,p_version_scn=>45130088
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184955470455149614)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_text=>'Generates an <code>ID</code> primary key column for each table.'
,p_version_scn=>39925124
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2051579609060907)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_text=>'Getting Started'
,p_version_scn=>45129652
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(288107368887373395)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>SQL is generated automatically in the SQL panel upon typing. Enter parent table names at the start of a line. Add column names, one per line, following the table they belong to using a uniform indentation of 2 or more spaces. Primary keys are gene'
||'rated automatically. Create parent/child relationships by simply indenting child tables under parent tables, or define any foreign key relationships needed using the <code>/fk</code> column directive. By default, relationships prevent deletion of ref'
||'erenced rows. However, to automatically delete child rows when a parent row is deleted, add the <code>/cascade</code> directive to the child table or child foreign key column.</p>',
'',
'<p>Unqualified columns default to a <code>varchar2</code> datatype. To specify a different type, add <code>num</code>, <code>int</code>, or <code>date</code> after the column name, separated by a space. If you don''t explicitly specify a type, one may'
||' be deduced from the English text in the column name. For example, if the column name contains the word "date" then it will be a <code>date</code> datatype, or if the column name contains the word "num" or "number" it will be a <code>number</code> da'
||'tatype. To specify a specific <code>varchar2</code> length enter <code>vc<em>NN</em></code> where <code><em>NN</em></code> is the length of the <code>varchar2</code>. Object names are formatted automatically, replacing spaces with underscores, so you'
||' can use spaces in column and table names.</p>',
'',
'<p>Click the Settings button to view many generation options. You can easily add "Audit Columns" to track who created and last updated a given row and when. Enable a row version column to simplify lost update detection since its value automatically i'
||'ncrements by one on each row update.  Generate a PL/SQL package API for each table with procedures to query, insert, update, and delete rows.</p>'))
,p_version_scn=>37166084578110
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725112430983910509)
,p_name=>'QUICKSQL.HELP.API'
,p_message_text=>'Generates PL/SQL package API to query, insert, update, and delete data.'
,p_is_js_message=>true
,p_version_scn=>45140910
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725112639931916262)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_text=>'Audits changes with Oracle auditing (e.g. <code>audit all on <em>table_name</em></code>)'
,p_is_js_message=>true
,p_version_scn=>45140947
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725112868872923441)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_text=>'Audits changes in <code>created</code>, <code>created_by</code>, <code>updated</code>, <code>updated_by</code> columns using a trigger.'
,p_is_js_message=>true
,p_version_scn=>45140976
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725110182018829848)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_text=>'Constrains value to an inclusive range (e.g. <code>/between 1 and 100</code>)'
,p_is_js_message=>true
,p_version_scn=>45140992
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2054186111421462)
,p_name=>'QUICKSQL.HELP.CASCADE'
,p_message_text=>'Auto-deletes rows when parent row is deleted.'
,p_is_js_message=>true
,p_version_scn=>45141008
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725107159626792263)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_text=>'Provides case-sensitive list of only allowed values (e.g. <code>/check Yes, No</code>)'
,p_is_js_message=>true
,p_version_scn=>45141033
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185257284050410232)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_text=>'Prefixes all column names in the table with this value.'
,p_is_js_message=>true
,p_version_scn=>45141058
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2051944895066695)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_text=>'Column Name'
,p_is_js_message=>true
,p_version_scn=>45141074
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725111739646857312)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_text=>'Annotates model with comments using square brackets or dash dash'
,p_is_js_message=>true
,p_version_scn=>45141091
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725113060400927845)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_text=>'Compresses the data to optimize space.'
,p_is_js_message=>true
,p_version_scn=>45141107
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725107457114804968)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_text=>'Uses a constant value while generating data (e.g. <code>/constant NYC</code>)'
,p_is_js_message=>true
,p_version_scn=>45141126
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(574808573766447382)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_text=>'Specifies value to insert if column is missing or null.'
,p_is_js_message=>true
,p_version_scn=>45141142
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2054557398428227)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_text=>'Adds a BLOB column and _FILENAME, _CHARSET, _MIMETYPE, _LASTUPD columns that enhance the ability for file download via a browser.'
,p_is_js_message=>true
,p_version_scn=>45141158
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725111363719847509)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_text=>'Defines foreign key relationship to another table (e.g. <code>/references <em>table_name</em></code>)'
,p_is_js_message=>true
,p_version_scn=>45141194
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725111096243842314)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_text=>'Hides value from appearing in results of <code>select * from <em>table_name</em></code>'
,p_is_js_message=>true
,p_version_scn=>45141210
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(460328015703763545)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_text=>'Creates an index to speed up searches.'
,p_is_js_message=>true
,p_version_scn=>45141229
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725113535941943386)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_text=>'Inserts <strong><em>NN</em></strong> (&le; 1000) rows of example data (e.g. <code>/insert 20</code>)'
,p_is_js_message=>true
,p_version_scn=>45141245
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2052306055078294)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_text=>'Forces column values to lower case'
,p_is_js_message=>true
,p_version_scn=>45141261
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2054314438426098)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_text=>'NNN identifies a number between 1 and 32767.'
,p_is_js_message=>true
,p_version_scn=>45141302
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725108276464822358)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_text=>'Requires a value using a <code>not null</code> constraint.'
,p_is_js_message=>true
,p_version_scn=>45141318
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725111553542853532)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_text=>'Identifies primary key when auto-created one does not suffice.'
,p_is_js_message=>true
,p_version_scn=>45141334
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725114008402976527)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_text=>'Enables Auto-REST data access using Oracle REST Data Services (ORDS)'
,p_is_js_message=>true
,p_version_scn=>45141350
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2061055700512397)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_text=>'Generate SQL SELECT statement after generating data for each table'
,p_is_js_message=>true
,p_version_scn=>45141843
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(116793818610424618)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_text=>'Generates table level unique constraint (e.g. <code>/unique state,city</code>)'
,p_is_js_message=>true
,p_version_scn=>45141366
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725106874366786022)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_text=>'Prevents duplicate values with a unique constraint.'
,p_is_js_message=>true
,p_version_scn=>45141401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2052119695070111)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_text=>'Forces column values to upper case'
,p_is_js_message=>true
,p_version_scn=>45141385
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(725107684099808580)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_text=>'Lists example values for generated data (e.g. <code>/values 1,2,3</code> or <code>/values Small,Large</code>)'
,p_is_js_message=>true
,p_version_scn=>45141417
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2051777098062773)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_text=>'Creating the Database Objects'
,p_version_scn=>45129674
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(296541223167665719)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Once you have finished entering the Quick SQL Shorthand and applied appropriate settings, you are ready to use the generated SQL. It can create the database objects, and optionally populate some or all tables with sample data. Follow these steps:<'
||'br>',
'<ol>',
'  <li>Choose <strong>Save Model</strong> from the left pane <em>Actions</em> menu to save the Quick SQL shorthand as a named model to reuse in the future.</li>',
'  <li>Enter a model name.</li>',
'  <li>Choose <strong>Save SQL Script</strong> from the right pane <em>SQL Script Actions</em> menu to save the generated output as a script.</li>',
'  <li>Enter a script name.</li>',
'  <li>Click <strong>Review and Run</strong> to navigate to the Script Editor.</li>',
'  <li>In the Script Editor, review the script contents if needed.</li>',
'  <li>Click <strong>Run</strong> to create the database objects.</li>',
'  <li>On the script confirmation page, click <strong>Run Now</strong>.</li>',
'  <li>On the results page review the statements processed, successful, and with errors. If any errors are reported, navigate through the result pages to see the specific Oracle error messages.</li>',
'  <li>Optionally, click <strong>Create App from Script</strong> to go to into the Create App Wizard and have pages automatically generated based on the tables and views specified in the script.</li>',
'</ol>',
'</p>',
'',
'<p><em><strong>Note:</strong></em> Oracle recommends downloading the SQL shorthand to your computer if you want to update it in the future. If you have specified any settings then navigate to the bottom of the Oracle SQL Output pane and copy the line'
||' starting with <code># settings =</code> to the top of the Quick SQL Shorthand pane.</p>',
'<p>Choose <strong>Download</strong> from the right pane <em>SQL Script Actions</em> menu to save the SQL file to your computer.</p>'))
,p_version_scn=>40148672
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11601045035511232)
,p_name=>'QUICKSQL.INSERT_SETTING'
,p_message_text=>'Disables all sample data generation when set to false.'
,p_version_scn=>39919795
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3400550410232779)
,p_name=>'QUICKSQL.JS_NOT_LOADED'
,p_message_text=>'QuickSQL file resources could not be loaded from ORDS. Please check your reverse proxy configuration if applicable.'
,p_version_scn=>47434247
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184749788214908870)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_text=>'Chooses language for sample data generation. Supported values:'
,p_version_scn=>39920086
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184909646341994382)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_text=>'Allows <code>varchar2</code> sizes over 4000 (&le; 32767) in databases configured to support longer varchars.'
,p_version_scn=>39921874
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184912464529030108)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_text=>'Ignores any settings beyond those set in Quick SQL shorthand.'
,p_version_scn=>39922237
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184953196701066650)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_text=>'Chooses primary key strategy of identity, sequence, SYS_GUID, or none.  Valid values:'
,p_version_scn=>39924923
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184955249054104018)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_text=>'Prefixes primary key column with table name (e.g. <code>EMPLOYEE_ID</code>)'
,p_version_scn=>39925023
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184954636069088053)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_text=>'Identifies common prefix for all objects, automatically separated by an underscore.'
,p_version_scn=>39924669
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2053584341409530)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_text=>'Product Sales'
,p_version_scn=>45137193
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(713113448842206461)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_text=>'Defines star schema with PRODUCTS, CUSTOMERS, CHANNELS, PROMOTIONS, and SALES tables.  The SALES table has foreign key references to others.  Identifies numeric columns (NUM). Defines legal values (/CHECK) for two columns. Generates random sample dat'
||'a (/INSERT) for all tables, and adds SALES_V join view including them all.'
,p_version_scn=>39386153
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2053719220411285)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_text=>'Project Management'
,p_version_scn=>45137238
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(713112950240199680)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_text=>'Defines project management schema with PROJECTS parent table and four child tables: MILESTONES, LINKS, ATTACHMENTS, and ACTION_ITEMS. Adds view PROJECT_MS joining projects and milestones and PROJECT_AI combining projects and action items. Specifies l'
||'egal values (/CHECK), example values (/VALUES), and generates sample rows (/INSERT). Adds audit columns in SQL syntax directives after #-sign (auditcols: true).'
,p_version_scn=>39388491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2055732878449407)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_text=>'Resets all application settings to default values.  When included all application settings currently active for your session will be ignored.'
,p_version_scn=>45138117
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184955873168174304)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_text=>'Adds trigger-assigned <code>ROW_KEY</code> column for alphanumeric id to each table.'
,p_version_scn=>39925451
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184963056213308121)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_text=>'Adds trigger-assigned <code>ROW_VERSION</code> column that increments on update to each table.'
,p_version_scn=>39927253
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185117790875655747)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_text=>'Qualifies generated SQL object names with an optional schema.'
,p_version_scn=>39927614
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185175670431154803)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_text=>'Sets <code>varchar2</code> column length semantics to <code>byte</code>, <code>char</code>, or default.'
,p_version_scn=>39929561
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2054763254432110)
,p_name=>'QUICKSQL.SETTING'
,p_message_text=>'Setting'
,p_version_scn=>45137686
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(184001664306113352)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can define SQL syntax generation options <em>interactively</em> in the <strong>Settings</strong> dialog or <em>explicitly</em> in your Quick SQL Shorthand. Including settings in your Quick SQL Shorthand ensures the same options are always used'
||'. For example, to prefix all table names with <code>test</code> and generate for schema <code>obe</code> enter the following:</p>',
'<p>',
'<code># settings = { prefix: "test", schema: "obe" }</code>',
'</p>',
'<p>Alternatively, enter each setting on a separate line for the same result:</p>',
'<p>',
'<code># prefix: "test"<br>',
'# schema: "obe"</code>',
'</p>',
'<p><em><strong>Note:</strong> Settings must start on a new line and begin with <code># settings = </code> to enter multiple settings, or <code># </code> to enter a single setting per line. All values are case insensitive. Add brackets, spaces, or com'
||'mas for additional clarity if desired. To include all settings in the generated script, use <code># verbose: true</code>.</em>',
'</p>',
'&nbsp;<br>'))
,p_version_scn=>39914255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3401243143242596)
,p_name=>'QUICKSQL.SQL_TITLE'
,p_message_text=>'SQL'
,p_version_scn=>47409339
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2052518505080634)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_text=>'Syntax'
,p_version_scn=>45130012
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2053991876412261)
,p_name=>'QUICKSQL.TODOS'
,p_message_text=>'ToDos'
,p_version_scn=>45137255
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(839277711771636211)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_text=>'Includes ASSIGNEES and TODOS tables. Defines NOT NULL constraints (/NN). Specifies legal values (/CHECK). Generates sample data (/INSERT). Adds audit columns (#auditcols: true). Enables creating a custom ToDo system in minutes.'
,p_version_scn=>39389039
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185118571468664184)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_text=>'Overrides default audit column name for user who last updated a row.'
,p_version_scn=>39934491
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185118778020682348)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_text=>'Overrides default audit column name for when a row was last updated.'
,p_version_scn=>39914144
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(185131355684693041)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_text=>'Includes all settings values in generated script.'
,p_version_scn=>39934779
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2052718358084737)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_text=>'Ensure the view name contains no spaces, ensure the table names contain no spaces.  Delimit table names by a space or comma.'
,p_version_scn=>45130065
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(24186897178604247)
,p_name=>'SCRIPT.MAX_SCRIPT_SIZE'
,p_message_text=>'This script is above the maximum size limit of %0 bytes. Please edit to make it smaller than the current size, %1 bytes.'
,p_is_js_message=>true
,p_version_scn=>78317249
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1344105008697170133)
,p_name=>'SCRIPTS.CHANGES_SAVED'
,p_message_text=>'Changes saved'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2607221627981139)
,p_name=>'SDW_CONNECT'
,p_message_text=>'Connect'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2607869683984381)
,p_name=>'SDW_ERROR_ACTION'
,p_message_text=>'Action'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2607682684983471)
,p_name=>'SDW_ERROR_CAUSE'
,p_message_text=>'Cause'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2607044126977992)
,p_name=>'SDW_NOT_REST_ENABLED'
,p_message_text=>'This schema is not REST-enabled'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000706429283846)
,p_name=>'SDW_OPEN_NEW_WINDOW'
,p_message_text=>'Opens in new window'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2606857775976558)
,p_name=>'SDW_REST_ENABLED'
,p_message_text=>'REST-enabled'
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3005039574867164)
,p_name=>'STATIC_LOV.GROUP.VALUES'
,p_message_text=>'Values'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3005877475872855)
,p_name=>'STATIC_LOV.MOVE_DOWN'
,p_message_text=>'Move Down'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3006652251892718)
,p_name=>'STATIC_LOV.MOVE_DOWN_VALUE_N'
,p_message_text=>'Move Down Value %0'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3005669183871714)
,p_name=>'STATIC_LOV.MOVE_UP'
,p_message_text=>'Move Up'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3007407225904194)
,p_name=>'STATIC_LOV.MOVE_UP_VALUE_N'
,p_message_text=>'Move Up Value %0'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3005440858870100)
,p_name=>'STATIC_LOV.PROP.VALUES'
,p_message_text=>'Values'
,p_is_js_message=>true
,p_version_scn=>37165770887598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3005236767868663)
,p_name=>'STATIC_LOV.REMOVE'
,p_message_text=>'Remove'
,p_is_js_message=>true
,p_version_scn=>37165770887564
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3007284747901031)
,p_name=>'STATIC_LOV.REMOVE_VALUE_N'
,p_message_text=>'Remove Value %0'
,p_is_js_message=>true
,p_version_scn=>37165770887564
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3006284830875758)
,p_name=>'STATIC_LOV.VALUE.DISPLAY'
,p_message_text=>'Display'
,p_is_js_message=>true
,p_version_scn=>37165770887564
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3006072131874349)
,p_name=>'STATIC_LOV.VALUE.FREQUENCY'
,p_message_text=>'Frequency'
,p_is_js_message=>true
,p_version_scn=>37165770887564
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3004810936857093)
,p_name=>'STATIC_LOV.VALUES'
,p_message_text=>'Values'
,p_is_js_message=>true
,p_version_scn=>37165770887564
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3006873524895654)
,p_name=>'STATIC_LOV.VALUE_N_DISPLAY'
,p_message_text=>'Value %0: Display'
,p_is_js_message=>true
,p_version_scn=>37165770887564
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3007005584899201)
,p_name=>'STATIC_LOV.VALUE_N_FREQUENCY'
,p_message_text=>'Value %0: Frequency'
,p_is_js_message=>true
,p_version_scn=>37165770887564
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1428391852969216)
,p_name=>'UI_DEFAULT.GET_DATA_DICTIONARY_ERROR'
,p_message_text=>'Error getting the data dictionary cache value for %0.'
,p_version_scn=>119797447
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2213848594146231)
,p_name=>'UI_DEFAULT.SYNC_INTO_DATA_DICTIONARY_ERROR'
,p_message_text=>'Error syncing %0 information into the data dictionary cache.'
,p_version_scn=>120702566
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/rename_script_name
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(32179615812392135)
,p_shortcut_name=>'RENAME_SCRIPT_NAME'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75558194
,p_shortcut=>'The script name exists already in your workspace and owned by another user.  Please enter different script name.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/null_script_name
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(110802131425678586)
,p_shortcut_name=>'NULL_SCRIPT_NAME'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75558194
,p_shortcut=>'Script Name must be specified.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/null_script
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(110803013894682985)
,p_shortcut_name=>'NULL_SCRIPT'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75558194
,p_shortcut=>'Script must be entered.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/dup_script_name
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(111043910462526159)
,p_shortcut_name=>'DUP_SCRIPT_NAME'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75558194
,p_shortcut=>'The script name exists already in your workspace.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/max_script_size
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(133393615560571789)
,p_shortcut_name=>'MAX_SCRIPT_SIZE'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75558194
,p_shortcut=>'The script exceeds the maximum size allowed.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(165162327257300666)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75558194
,p_shortcut=>'Would you like to perform this delete action?'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/ok_to_get_next_prev_pk_value
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(180175522684124268)
,p_shortcut_name=>'OK_TO_GET_NEXT_PREV_PK_VALUE'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>75558194
,p_shortcut=>'Are you sure you want to leave this page without saving?'
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(539837904309662819)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>540226219724705040
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_ai_hook
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1465565782563888)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.AI_HOOK'
,p_display_name=>'AI Hook'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.AI_HOOK'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'procedure render (',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_region in            apex_plugin.t_region,',
'    p_param  in            apex_plugin.t_region_render_param,',
'    p_result in out nocopy apex_plugin.t_region_render_result )',
'as',
'    l_enabled   boolean         := wwv_flow_ai.is_enabled;',
'    l_ajax_id   varchar2(1000)  := wwv_flow_plugin.get_ajax_identifier;',
'    l_ai_key    varchar2(1000)  := p_region.attributes.get_varchar2( ''ai_key'' );',
'begin',
'    wwv_flow_javascript.add_onload_code (',
'        p_code =>',
'            ''apex.aiHook = {'' || wwv_flow.LF ||',
'            ''    aiEnabled: '' || case when l_enabled then ''true'' else ''false'' end || '','' || wwv_flow.LF ||',
'            ''    ajaxId: {}''  || wwv_flow.LF ||',
'            ''};'',',
'        p_key  => ''ai-hook'' );',
'',
'    if l_enabled then',
'        wwv_flow_javascript.add_onload_code (',
'            p_code => ''apex.aiHook.ajaxId[ '' || wwv_flow_escape.js_literal( l_ai_key ) || '' ] = '' ||',
'                wwv_flow_escape.js_literal( l_ajax_id ) || '';'' );',
'    end if;',
'end render;'))
,p_api_version=>3
,p_render_function=>'render'
,p_standard_attributes=>'AI_ENABLED_ALWAYS:AI_SYSTEM_PROMPT'
,p_substitute_attributes=>true
,p_reference_id=>1423361590814899
,p_version_scn=>128904175
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2063514013567718)
,p_plugin_id=>wwv_flow_imp.id(1465565782563888)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'ai_key'
,p_prompt=>'Key'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Provide a key, or an id, that will be used to get a handle on the plug-in''s AJAX ID as such: <code>apex.aiHook.ajaxId[ "{key here}" ]</code>.'
);
end;
/
prompt --application/shared_components/plugins/region_type/object_browser
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2105478322088418)
,p_plugin_type=>'REGION TYPE'
,p_name=>'OBJECT_BROWSER'
,p_display_name=>'Object Browser'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','OBJECT_BROWSER'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'procedure render (',
'    p_region in            wwv_flow_plugin_api.t_region,',
'    p_plugin in            wwv_flow_plugin_api.t_plugin,',
'    p_param  in            wwv_flow_plugin_api.t_region_render_param,',
'    p_result in out nocopy wwv_flow_plugin_api.t_region_render_result )',
'is',
'    c_render_name       varchar2(255) := p_region.attributes.get_varchar2(''attribute_01'');',
'    c_ajax_name         varchar2(255) := p_region.attributes.get_varchar2(''attribute_02'');',
'    c_variable_name     varchar2(255) := p_region.attributes.get_varchar2(''attribute_03'');',
'begin',
'    if c_render_name is not null then',
'        execute immediate ''begin '' || c_render_name || ''; end;'';',
'    end if;',
'    ',
'    if c_ajax_name is not null then',
'        wwv_flow_javascript.add_inline_code ( c_variable_name || ''='' || wwv_flow_escape.js_literal( wwv_flow_plugin.get_ajax_identifier ) || '';'' );',
'    end if;',
'end render;',
'',
'procedure ajax (',
'    p_region in            wwv_flow_plugin_api.t_region,',
'    p_plugin in            wwv_flow_plugin_api.t_plugin,',
'    p_param  in            wwv_flow_plugin_api.t_region_ajax_param,',
'    p_result in out nocopy wwv_flow_plugin_api.t_region_ajax_result )',
'is',
'    c_ajax_name varchar2(255) := p_region.attributes.get_varchar2(''attribute_02'');',
'begin',
'    execute immediate ''begin '' || c_ajax_name || ''( p_json_path => :p_json_path ); end;'' using p_param.json_path;',
'end ajax;'))
,p_api_version=>3
,p_render_function=>'render'
,p_ajax_function=>'ajax'
,p_substitute_attributes=>true
,p_version_scn=>88931178
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2105636326091683)
,p_plugin_id=>wwv_flow_imp.id(2105478322088418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Render Procedure Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2105977537092681)
,p_plugin_id=>wwv_flow_imp.id(2105478322088418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'attribute_02'
,p_prompt=>'Ajax Procedure Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2106219119093540)
,p_plugin_id=>wwv_flow_imp.id(2105478322088418)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'attribute_03'
,p_prompt=>'Ajax Identifier Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_language
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2678472121698841)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_LANGUAGE'
,p_display_name=>'Code Language'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_LANGUAGE'),'')
,p_api_version=>2
,p_render_function=>'wwv_flow_f4000_plugins.render_code_language'
,p_validation_function=>'wwv_flow_f4000_plugins.validate_code_language'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_reference_id=>1801904462214602
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2678664416698833)
,p_plugin_id=>wwv_flow_imp.id(2678472121698841)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Default Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Automatically Picked'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2679023964698832)
,p_plugin_attribute_id=>wwv_flow_imp.id(2678664416698833)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2679542644698827)
,p_plugin_attribute_id=>wwv_flow_imp.id(2678664416698833)
,p_display_sequence=>20
,p_display_value=>'PL/SQL'
,p_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2680096274698826)
,p_plugin_id=>wwv_flow_imp.id(2678472121698841)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Type Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2680454110698826)
,p_plugin_id=>wwv_flow_imp.id(2678472121698841)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Hide SQL'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2680096274698826)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(12506617921221692)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>'Developer Authorization'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1713462395757980)
,p_plugin_id=>wwv_flow_imp.id(12506617921221692)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1714304067757981)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1714884646757981)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1715334069757981)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1715895874757982)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1716321480757982)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1716874753757982)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1717324527757983)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1717868080757983)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1718388334757984)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1718815104757984)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1719393374757984)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1719857229757985)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1713874581757981)
,p_plugin_attribute_id=>wwv_flow_imp.id(1713462395757980)
,p_display_sequence=>140
,p_display_value=>'DATA_GENERATOR: Ability to access Data Generator in SQL Workshop'
,p_return_value=>'DATA_GENERATOR'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_plugin_dynamic_attribute
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(12964533458812939)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_display_name=>'Plug-In Dynamic Attribute'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_plugin_attribute'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_plugin_attribute'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_reference_id=>6480508142096556
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(44507297529251872)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_reference_id=>77082398185639908
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(61354658999430857)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>'Search Box'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513166384709230023)
,p_plugin_id=>wwv_flow_imp.id(61354658999430857)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513166776921230023)
,p_plugin_id=>wwv_flow_imp.id(61354658999430857)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(113746032581665431)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>'INTERNAL Oracle APEX Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113737019268347425
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(118578616481923799)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>'INTERNAL Social Sign-In'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_reference_id=>117694777698093086
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416869786596942532)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416870176495942532)
,p_plugin_attribute_id=>wwv_flow_imp.id(416869786596942532)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416870657765942533)
,p_plugin_attribute_id=>wwv_flow_imp.id(416869786596942532)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416871156029942533)
,p_plugin_attribute_id=>wwv_flow_imp.id(416869786596942532)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416871607466942533)
,p_plugin_attribute_id=>wwv_flow_imp.id(416869786596942532)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416872177370942534)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416869786596942532)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416872581992942534)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416869786596942532)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416872962730942534)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416869786596942532)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416873391914942534)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416869786596942532)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416873750757942535)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Oracle APEX automatically adds the "openid" scope. The authentication '
||'provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416874127059942535)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416874505912942535)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416874915284942536)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416875349153942536)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416875761388942536)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416869786596942532)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416876181671942536)
,p_plugin_attribute_id=>wwv_flow_imp.id(416875761388942536)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416876663698942537)
,p_plugin_attribute_id=>wwv_flow_imp.id(416875761388942536)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416877170216942537)
,p_plugin_attribute_id=>wwv_flow_imp.id(416875761388942536)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416877675017942537)
,p_plugin_attribute_id=>wwv_flow_imp.id(416875761388942536)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416878171919942538)
,p_plugin_id=>wwv_flow_imp.id(118578616481923799)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (for example, "email_verified" for Username Attribute "email"). If the value of this attribute is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_wizard_selection
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(217679430964254738)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.WIZARD_SELECTION'
,p_display_name=>'Wizard Selection'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.WIZARD_SELECTION'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_wizard_selection'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_wizard_selection'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:SOURCE:ELEMENT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_reference_id=>3260301366184169092
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(217679670985254744)
,p_plugin_id=>wwv_flow_imp.id(217679430964254738)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(217680058170254749)
,p_plugin_attribute_id=>wwv_flow_imp.id(217679670985254744)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'S'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(217680572057254752)
,p_plugin_attribute_id=>wwv_flow_imp.id(217679670985254744)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'M'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(217681055305254752)
,p_plugin_attribute_id=>wwv_flow_imp.id(217679670985254744)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'L'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(217681523143254753)
,p_plugin_id=>wwv_flow_imp.id(217679430964254738)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Submit Page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Select whether or not to submit the page when making a selection'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(217681920100254757)
,p_plugin_id=>wwv_flow_imp.id(217679430964254738)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356673325634447685)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'INTERNAL Oracle Cloud Identity Management'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749806821809026
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356675826982447689)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>'INTERNAL Database Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749511183746276
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356690631776447712)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>'INTERNAL HTTP Header Variable'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>708795120396802284
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308201894539529873)
,p_plugin_id=>wwv_flow_imp.id(356690631776447712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308202231139529875)
,p_plugin_id=>wwv_flow_imp.id(356690631776447712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308202624435529875)
,p_plugin_attribute_id=>wwv_flow_imp.id(308202231139529875)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308203137186529876)
,p_plugin_attribute_id=>wwv_flow_imp.id(308202231139529875)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308203606408529876)
,p_plugin_attribute_id=>wwv_flow_imp.id(308202231139529875)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308204186943529876)
,p_plugin_id=>wwv_flow_imp.id(356690631776447712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(308202231139529875)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308204508127529877)
,p_plugin_id=>wwv_flow_imp.id(356690631776447712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(308202231139529875)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308204959488529877)
,p_plugin_id=>wwv_flow_imp.id(356690631776447712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308205342825529877)
,p_plugin_attribute_id=>wwv_flow_imp.id(308204959488529877)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308205800881529878)
,p_plugin_attribute_id=>wwv_flow_imp.id(308204959488529877)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308206323991529878)
,p_plugin_id=>wwv_flow_imp.id(356690631776447712)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356758608092447765)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'INTERNAL LDAP Directory'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>863910941135523528
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the username and password for authentication against the LDAP directory identified on the login page. Remember, passwords may be case sensitive.</p>',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356758914849447766)
,p_plugin_id=>wwv_flow_imp.id(356758608092447765)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356759306041447766)
,p_plugin_id=>wwv_flow_imp.id(356758608092447765)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356759710067447766)
,p_plugin_id=>wwv_flow_imp.id(356758608092447765)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356760114899447766)
,p_plugin_attribute_id=>wwv_flow_imp.id(356759710067447766)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356760629181447767)
,p_plugin_attribute_id=>wwv_flow_imp.id(356759710067447766)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356761131992447767)
,p_plugin_attribute_id=>wwv_flow_imp.id(356759710067447766)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356761615461447767)
,p_plugin_id=>wwv_flow_imp.id(356758608092447765)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356762006427447767)
,p_plugin_id=>wwv_flow_imp.id(356758608092447765)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356762419044447767)
,p_plugin_id=>wwv_flow_imp.id(356758608092447765)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(356762006427447767)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356762813227447768)
,p_plugin_id=>wwv_flow_imp.id(356758608092447765)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356763212988447768)
,p_plugin_id=>wwv_flow_imp.id(356758608092447765)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356763608991447768)
,p_plugin_attribute_id=>wwv_flow_imp.id(356763212988447768)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356764121289447769)
,p_plugin_attribute_id=>wwv_flow_imp.id(356763212988447768)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356764608128447769)
,p_plugin_attribute_id=>wwv_flow_imp.id(356763212988447768)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356819907237447808)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'INTERNAL Oracle Application Server Single Sign-On'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113750429890071859
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_clob_code_editor
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(690797475249954954)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_display_name=>'CLOB Code Editor'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.CLOB_CODE_EDITOR'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_code_editor'
,p_standard_attributes=>'SOURCE_SQL:NO_DATA_FOUND_MESSAGE:INIT_JAVASCRIPT_CODE:AI_ENABLED_ALWAYS'
,p_substitute_attributes=>true
,p_reference_id=>1127739634804688041
,p_version_scn=>120172118
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2186457409587363)
,p_plugin_id=>wwv_flow_imp.id(690797475249954954)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2186875830587363)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2187366454587363)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2187807006587363)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2188382331587363)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2188809371587364)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2189322552587364)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2189807153587364)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2190346849587364)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2190837051587364)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PL/SQL_FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2191365685587364)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2191827486587364)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript - Module'
,p_return_value=>'mle-javascript-module'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2192388193587365)
,p_plugin_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_display_sequence=>110
,p_display_value=>'MLE - JavaScript - Snippet'
,p_return_value=>'mle-javascript-snippet'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2192898631587365)
,p_plugin_id=>wwv_flow_imp.id(690797475249954954)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'attribute_02'
,p_prompt=>'Height'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2193284740587365)
,p_plugin_attribute_id=>wwv_flow_imp.id(2192898631587365)
,p_display_sequence=>1
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2193736140587365)
,p_plugin_attribute_id=>wwv_flow_imp.id(2192898631587365)
,p_display_sequence=>2
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2194265770587365)
,p_plugin_attribute_id=>wwv_flow_imp.id(2192898631587365)
,p_display_sequence=>3
,p_display_value=>'20'
,p_return_value=>'20'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2194714691587365)
,p_plugin_attribute_id=>wwv_flow_imp.id(2192898631587365)
,p_display_sequence=>10
,p_display_value=>'30'
,p_return_value=>'30'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2195296836587366)
,p_plugin_attribute_id=>wwv_flow_imp.id(2192898631587365)
,p_display_sequence=>20
,p_display_value=>'60'
,p_return_value=>'60'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2195731741587366)
,p_plugin_attribute_id=>wwv_flow_imp.id(2192898631587365)
,p_display_sequence=>25
,p_display_value=>'80'
,p_return_value=>'80'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2196279868587366)
,p_plugin_attribute_id=>wwv_flow_imp.id(2192898631587365)
,p_display_sequence=>30
,p_display_value=>'Automatic'
,p_return_value=>'AUTO'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2196705510587366)
,p_plugin_id=>wwv_flow_imp.id(690797475249954954)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'attribute_03'
,p_prompt=>'Read Only'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2197175763587366)
,p_plugin_id=>wwv_flow_imp.id(690797475249954954)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>15
,p_static_id=>'attribute_04'
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2197585167587366)
,p_plugin_attribute_id=>wwv_flow_imp.id(2197175763587366)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
,p_help_text=>'VARCHAR2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2198058126587366)
,p_plugin_attribute_id=>wwv_flow_imp.id(2197175763587366)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2198580173587367)
,p_plugin_id=>wwv_flow_imp.id(690797475249954954)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'attribute_05'
,p_prompt=>'Remote Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>'Specify the an item containing the ID of the remote database to use for code validation.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2198938029587367)
,p_plugin_id=>wwv_flow_imp.id(690797475249954954)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_static_id=>'attribute_06'
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2186457409587363)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'<p>An event listener will further be placed on this item, so that when its value changes, the editor will change accordingly.</p>',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2200232926587368)
,p_plugin_id=>wwv_flow_imp.id(690797475249954954)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2200641443587368)
,p_plugin_id=>wwv_flow_imp.id(690797475249954954)
,p_name=>'SOURCE_SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob_content',
'from demo_scripts'))
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_splitter
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1223659655805557097)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.SPLITTER'
,p_display_name=>'Splitter'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.SPLITTER'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_splitter'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_splitter'
,p_substitute_attributes=>true
,p_reference_id=>330671351658403453
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>A splitter dynamically divides the available space for two sub regions horizontally or vertically. The splitter region must have exactly two sub regions. Just about any region template can be used, as long as it has an id attribute, but some will '
||'look better than others. Avoid regions templates with margins or padding. If the region template has an element that wraps the sub regions then a CSS selector that selects the wrapping element must be entered in the Selector property.</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272772239348879385)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Splitter Keyboard Navigation'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If yes a global keyboard handler will be added to support using Ctrl-F6 to navigate to the next splitter and Shift-Ctrl-F6 to navigate to the previous splitter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272772670124879385)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>400
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An optional CSS selector that identifies the element that contains the two sub regions. The selector should start with the the static region id. If omitted the region id or static id will be used. ',
'<p>',
'Example:<br>',
'#regonStaticId > .container',
'<p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272773089811879385)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'attribute_02'
,p_prompt=>'Orientation'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'horizontal'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'A horizontal splitter has the two sub regions side by side. A vertical splitter has the two sub regions one on top of the other. The first sub region is always on the left or top.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1272773436103879385)
,p_plugin_attribute_id=>wwv_flow_imp.id(1272773089811879385)
,p_display_sequence=>10
,p_display_value=>'Horizontal'
,p_return_value=>'horizontal'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1272773955437879386)
,p_plugin_attribute_id=>wwv_flow_imp.id(1272773089811879385)
,p_display_sequence=>20
,p_display_value=>'Vertical'
,p_return_value=>'vertical'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272774486513879386)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'attribute_03'
,p_prompt=>'Positioned From'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'begin'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'This determines from which side the position of the splitter is measured and to which side the splitter will collapse. Choose Begin to collapse to the left (right if direction is RTL) or top. Choose End to collapse to the right (left if direction is '
||'RTL) or bottom.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1272774832182879388)
,p_plugin_attribute_id=>wwv_flow_imp.id(1272774486513879386)
,p_display_sequence=>10
,p_display_value=>'Begin (left/top)'
,p_return_value=>'begin'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1272775310859879389)
,p_plugin_attribute_id=>wwv_flow_imp.id(1272774486513879386)
,p_display_sequence=>20
,p_display_value=>'End (right/bottom)'
,p_return_value=>'end'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272775861831879390)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'attribute_04'
,p_prompt=>'Position'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'This is the initial position in pixels of the splitter bar. If the splitter is initially collapsed this is the position used when the splitter is first expanded. If Persist State is Yes then if there is a saved position it overrides this value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272776298415879390)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'attribute_05'
,p_prompt=>'Collapsed'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1272779866076879391)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'If Yes the splitter is initially collapsed. If Persist State is Yes then if there is a saved collapsed state it overrides this value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272776622800879390)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'attribute_06'
,p_prompt=>'Snap'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'Optional. The number of pixels the splitter moves in each increment when dragging or with the arrow keys. If not specified the splitter can be dragged with single pixel precision.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272777035399879390)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_static_id=>'attribute_07'
,p_prompt=>'Keyboard Increment'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1272776622800879390)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Optional. The number of pixels to move the splitter for each arrow key press. If not specified the default is 10.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272777443759879390)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'attribute_08'
,p_prompt=>'Minimum Size'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'The minimum position of the splitter before it automatically collapses. If not specified the default of 60 is used.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272777835460879390)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_static_id=>'attribute_09'
,p_prompt=>'Continuous Resize'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'If Yes the two sub regions are sized on each movement of the splitter while dragging or moving with the arrow keys. Otherwise the sub regions are sized only when the splitter stops moving. This should be set to No if the sub regions are computational'
||'ly expensive to resize.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272778274734879391)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_static_id=>'attribute_10'
,p_prompt=>'Restore Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter handle when the splitter is collapsed. If not specified a default is provided.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272778621295879391)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_static_id=>'attribute_11'
,p_prompt=>'Collapse Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter handle when the splitter is expanded. If not specified a default is provided.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272779063732879391)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_static_id=>'attribute_12'
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter bar. Providing a title for each splitter is helpful for accessibility especially when there are multiple splitters.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272779463251879391)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>12
,p_static_id=>'attribute_13'
,p_prompt=>'Persist State'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If Yes the state of the splitter is persisted as a user preference.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272779866076879391)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>45
,p_static_id=>'attribute_14'
,p_prompt=>'Can Collapse '
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'When set to Yes the splitter can collapse or expand by clicking on the handle or pressing Enter or Space. When set to No the splitter can only be moved to its minimum size.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272780235601879392)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_static_id=>'attribute_15'
,p_prompt=>'Sub Region Contains iframe'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Only set to Yes if either sub region of the splitter contains an iframe.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272780635681879392)
,p_plugin_id=>wwv_flow_imp.id(1223659655805557097)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_static_id=>'attribute_16'
,p_prompt=>'Drag To Collapse'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1272779866076879391)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'If Yes the splitter can be collapsed by dragging past the minimum size. If No the splitter can only be dragged to the minimum size.'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_editor
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1510820626581865225)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_EDITOR'
,p_display_name=>'Code Editor'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_EDITOR'),'')
,p_api_version=>2
,p_render_function=>'wwv_flow_f4000_plugins.render_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_code_editor'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:ENCRYPT:INIT_JAVASCRIPT_CODE:SESSION_STATE_CLOB:AI_ENABLED_ALWAYS'
,p_substitute_attributes=>true
,p_reference_id=>1114646612921244845
,p_version_scn=>120171691
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2126607663583335)
,p_plugin_id=>wwv_flow_imp.id(1510820626581865225)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2127074935583335)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2127552333583335)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2128096667583336)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2128566161583336)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2129041309583336)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2129563589583336)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>43
,p_display_value=>'YAML'
,p_return_value=>'yaml'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2130076706583336)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2130526806583336)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2131030798583336)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>60
,p_display_value=>'PL/SQL Functions/Procedures'
,p_return_value=>'PLSQL_FUNCTIONS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2131595363583337)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2132059162583337)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2132530990583337)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2133095154583337)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript - Module'
,p_return_value=>'mle-javascript-module'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2133538665583337)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>105
,p_display_value=>'MLE - JavaScript - Snippet'
,p_return_value=>'mle-javascript-snippet'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2134050334583337)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>110
,p_display_value=>'File URLs - JavaScript'
,p_return_value=>'file-urls-javascript'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2134568126583337)
,p_plugin_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_display_sequence=>120
,p_display_value=>'File URLs - CSS'
,p_return_value=>'file-urls-css'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2135068175583338)
,p_plugin_id=>wwv_flow_imp.id(1510820626581865225)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2135487088583338)
,p_plugin_attribute_id=>wwv_flow_imp.id(2135068175583338)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2135936742583338)
,p_plugin_attribute_id=>wwv_flow_imp.id(2135068175583338)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2136423004583338)
,p_plugin_id=>wwv_flow_imp.id(1510820626581865225)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Show Query Builder'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL,PAGE_ITEM'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2136831758583338)
,p_plugin_id=>wwv_flow_imp.id(1510820626581865225)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Adjustable Height'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'If Yes the user can adjust the height of the code editor.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2137282852583338)
,p_plugin_id=>wwv_flow_imp.id(1510820626581865225)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remote  Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Specify a page item containing the remote database ID to use for code validation.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2137631631583338)
,p_plugin_id=>wwv_flow_imp.id(1510820626581865225)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2126607663583335)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'',
'<p>An event listener will be placed on this item, so when its value changes, the editor will change accordingly.</p>',
'',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2138028288583338)
,p_plugin_id=>wwv_flow_imp.id(1510820626581865225)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Diff Editor'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When in diff mode, the value is expected to be a stringified JSON of type <code>{"original":"...","modified":"..."}</code></p>',
'<p>Set the session state data type to CLOB when dealing with large values.</p>',
'<p>The original value is not editable. The modified value is editable by default, but this can be changed via the item''s Read Only flag.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2140507218583343)
,p_plugin_id=>wwv_flow_imp.id(1510820626581865225)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(2448181332878348304)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Add Check All Checkbox'
,p_category=>'MISC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The "Add Check All Checkbox" dynamic action turns a column heading containing the #CHECK_ALL_CHECKBOX# string into an accessible check all style checkbox, that will check and uncheck all the checkboxes in its corresponding column.<p>',
'<p>',
'To use this plug-in, please ensure the following attributes are set:',
'<ol>',
'<li>In the report column, defined ''#CHECK_ALL_CHECKBOX#'' as the Heading value.</li>',
'<li>For the Dynamic Action When attribute, select the report region containing the column.</li>',
'<li>Define the Dynamic Action to fire ''After Refresh'', and the Action to ''Fire on Page Load''. (Both will default appropriately if the Dynamic Action is created by selecting the region in the ''Rendering'' section of Page Designer and creating the Dynam'
||'ic Action from there.</li>',
'<li>This will not handle the accessibility of the checkboxes rendered on each row, this must be done separately in the region source. (See 4000:656 ''Regions'' region for an example).</li>',
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_imp_page.create_page(
 p_id=>0
,p_name=>'zero'
,p_alias=>'ZERO'
,p_step_title=>'zero'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'14'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11140505307196687)
,p_plug_name=>'Global Items For Object Browser'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'23'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386906063356677524)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-sql-workshop'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386906446198682887)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_imp.id(386906063356677524)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32104702900781739)
,p_plug_name=>'Navigation Tabs Landmark'
,p_parent_plug_id=>wwv_flow_imp.id(386906446198682887)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'&PRODUCT_NAME.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(385795398770024112)
,p_plug_name=>'APEX 5 - Tabs'
,p_region_name=>'a_Header_menu'
,p_parent_plug_id=>wwv_flow_imp.id(32104702900781739)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(718942723406995455)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385776082908002390)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386906842726682887)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_imp.id(386906446198682887)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(',
'    ''<a href="'' ||',
'    wwv_flow_utilities.prepare_url( ''f?p=4100:1:'' || :APP_SESSION || ''::'' || :DEBUG ) ||',
'    ''" class="a-Header-logo"'' ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''title'',',
'        p_value => wwv_flow_lang.system_message( ''HOME_NAV'' ) ) ||',
'    case when :APP_PAGE_ID = 1000 then',
'        '' aria-current="page"''',
'    end ||',
'    ''><span role="img" aria-labelledby="logoLabel" class="a-Header-apexLogo"><span id="logoLabel" class="u-vh">'' ||',
'    wwv_flow_escape.html( wwv_flow_lang.system_message( ''HOME_NAV'' ) ) ||',
'    ''</span></span></a>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Logo'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386906639708682887)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_imp.id(386906063356677524)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(385807144565239746)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_imp.id(386906639708682887)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Navigation Bar'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2402226235991819)
,p_plug_name=>'Extension Menu'
,p_region_name=>'extensionsMenu'
,p_parent_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_location=>null
,p_list_id=>wwv_flow_imp.id(2200356137180721)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
,p_translate_title=>'N'
,p_plug_required_role=>wwv_flow_imp.id(4200240113971948)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(385814960550248814)
,p_plug_name=>'Administration Menu'
,p_region_name=>'adminMenu'
,p_parent_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(697546799309390664)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486772007528301730)
,p_plug_name=>'Help Menu'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(697551745129395610)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(385816859034290012)
,p_plug_name=>'Header Account'
,p_parent_plug_id=>wwv_flow_imp.id(386906639708682887)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.account_mega_menu (',
'    p_username          => :APP_USER,',
'    p_workspace_id      => :WORKSPACE_ID,',
'    p_session           => :APP_SESSION,',
'    p_logout_url        => :LOGOUT_URL',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Account'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388720726124473736)
,p_plug_name=>'APEX 5 - Search'
,p_parent_plug_id=>wwv_flow_imp.id(386906639708682887)
,p_region_css_classes=>'a-Header-search'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-SearchBox a-SearchBox--noGoButton a-SearchBox--autoExpand a-SearchBox--fill">'');',
'sys.htp.p(''  <div class="a-SearchBox-field">'');',
'sys.htp.p(''    <span class="a-SearchBox-icon"><span class="a-Icon icon-search"></span></span>'');',
'sys.htp.p(''    <label for="P0_SEARCH" class="visuallyhidden">''||wwv_flow_lang.system_message(''SEARCH'')||''</label>'');',
'sys.htp.p(''    <input type="text" class="a-SearchBox-input" id="P0_SEARCH" placeholder="''||wwv_flow_lang.system_message(''SEARCH'')||''">'');',
'sys.htp.p(''  </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_IN_CONDITION'
,p_plug_display_when_condition=>'1000'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_imp.id(1080926199001296276)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(387929033434561917)
,p_plug_name=>'APEX 5 - Control Bar'
,p_region_css_classes=>'a-ControlBar apex-sql-workshop'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'1000,3002'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(387929284740561918)
,p_plug_name=>'APEX 5 - Control Bar Left'
,p_parent_plug_id=>wwv_flow_imp.id(387929033434561917)
,p_region_css_classes=>'a-ControlBar-col a-ControlBar-col--noPadding'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_new_grid=>true
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(384688805135932803)
,p_plug_name=>'APEX 5 - Breadcrumb'
,p_parent_plug_id=>wwv_flow_imp.id(387929284740561918)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid=>true
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_imp.id(6696510824685479)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(387975456606606350)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(387929403973561918)
,p_plug_name=>'APEX 5 - Control Bar Right'
,p_parent_plug_id=>wwv_flow_imp.id(387929033434561917)
,p_region_css_classes=>'a-ControlBar-col'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(387994680244652086)
,p_plug_name=>'Schema'
,p_region_name=>'apex-control-icons'
,p_parent_plug_id=>wwv_flow_imp.id(387929403973561918)
,p_region_css_classes=>'a-Form a-Form--small a-Form--schemaSelect'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(735033617066168731)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_button_name=>'UPGRADE_AVAILABLE'
,p_button_static_id=>'header-upgradeAvailable'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Upgrade Available'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_AVAILABLE:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-utilities-build-interval'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(735033564580168730)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_button_name=>'UPGRADE_IN_PROGRESS'
,p_button_static_id=>'header-upgradeInProgress'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Upgrading'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_IN_PROGRESS:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''RUNNING'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-ig-refresh u-Animate-spin'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(161345724959782337)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_button_name=>'SPOTLIGHT'
,p_button_static_id=>'header-spotlightSearch'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Search'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-search'
,p_button_cattributes=>'data-action="spotlight-search" data-no-update="true"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2402359072991820)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_button_name=>'HEADER_EXTENSIONS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765690470963369)
,p_button_image_alt=>'Extensions'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-extension'
,p_button_cattributes=>'data-menu="extensionsMenu_menu"'
,p_security_scheme=>wwv_flow_imp.id(4200240113971948)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(385815804801264383)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_button_name=>'HEADER_ADMINISTRATION'
,p_button_static_id=>'header-adminMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765690470963369)
,p_button_image_alt=>'Administration'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-gears-alt'
,p_button_cattributes=>'data-menu="adminMenu_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(385816282863272115)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_button_name=>'HEADER_FEEDBACK'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Feedback'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4750:11001:&SESSION.::&DEBUG.:RP,11001:P11001_APPLICATION_ID,P11001_PAGE_ID:&APP_ID.,&APP_PAGE_ID.:'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-comments'
,p_required_patch=>wwv_flow_imp.id(693462110571635991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(385816622634278210)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(385807144565239746)
,p_button_name=>'HEADER_HELP'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765690470963369)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11141129549203626)
,p_name=>'OB_OBJECT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(11140505307196687)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11143605700225196)
,p_name=>'P0_PPRTIMESTAMP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(11140505307196687)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(387994857980652090)
,p_name=>'P0_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(387994680244652086)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-QB'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1002_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1002_SCHEMA ) d,',
'       :P1002_SCHEMA v',
'  from sys.dual',
' where :P1002_POPUP = 1',
' order by 1'))
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'a-Form-select'
,p_label_alignment=>'RIGHT'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_imp_page.create_page(
 p_id=>1
,p_name=>'Database Administrator Login'
,p_alias=>'DBA_LOGIN'
,p_step_title=>'Database Administrator Login'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'#P1_USERNAME ,#P1_PASSWORD{width:200px;}',
'</style>'))
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_montitor.htm'
,p_page_component_map=>'13'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1043922209309492)
,p_plug_name=>'Database Administrator Login'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>20
,p_plug_header=>'<p>You have requested access to a page which requires specific database privileges.  Enter the credentials for a database account that has been granted the DBA role.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1019666021060320819)
,p_plug_name=>'button region'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1020222865942116889)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1019666021060320819)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(359654713065770667)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1019666021060320819)
,p_button_name=>'P1_LOGIN'
,p_button_static_id=>'P1_LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Login'
,p_button_position=>'CREATE'
,p_request_source=>'LOGIN_BUTTON'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(155129504944225119)
,p_branch_action=>'return ''f?p=''||:P1_APP||'':''||:P1_PAGE||'':''||:SESSION;'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_FUNCTION_RETURNING_URL'
,p_branch_language=>'PLSQL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1046305318309560)
,p_name=>'P1_USERNAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1043922209309492)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>25
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a username and password for a database account in this database having DBA privileges.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1046904764309562)
,p_name=>'P1_PASSWORD'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1043922209309492)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>25
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the password.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(206105727449627884)
,p_name=>'P1_APP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1043922209309492)
,p_item_default=>'&APP_ID.'
,p_source=>'substr(:REQUEST,1,instr(:REQUEST,'','')-1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(206106408533631817)
,p_name=>'P1_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1043922209309492)
,p_item_default=>'1'
,p_source=>'substr(:REQUEST,instr(:REQUEST,'','')+1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(206083700119496957)
,p_validation_name=>'check dba password'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_auth boolean := false;',
'begin',
'    l_auth := sys.wwv_flow_val.verify_user (',
'                  username => :P1_USERNAME,',
'                  password => :P1_PASSWORD ) = sys.wwv_flow_val.valid_user;',
'',
'    if    l_auth',
'      and wwv_flow_security.user_is_dba (',
'              p_username => :P1_USERNAME )',
'    then',
'        :F4500_DBA_LOGIN := ''Y'';',
'        :DBA_USERNAME := upper(:P1_USERNAME);',
'        return true;',
'    end if;',
'',
'    :F4500_DBA_LOGIN := ''N'';',
'    return false;',
'exception when others then',
'    return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Incorrect password or user does not have required role.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(155252725985250123)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear sensitive items'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P1_USERNAME,P1_PASSWORD'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>155252725985250123
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_imp_page.create_page(
 p_id=>2
,p_name=>'Tables without Triggers'
,p_alias=>'TABLES-WITHOUT-TRIGGERS'
,p_step_title=>'Tables without Triggers'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276037127560809519)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_excp_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34148419202124380)
,p_plug_name=>'Tables without Triggers'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name',
'  from sys.user_tables a',
' where table_name not like ''BIN$%''',
'   and not exists ( select 1',
'                     from sys.user_triggers',
'                    where table_name = a.table_name )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P2_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(34148531542124380)
,p_name=>'Tables without Triggers'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34148708061124427)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(34149600179126708)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1317325530536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TABLE_NAME'
,p_sort_column_1=>'TABLE_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(69172413159446494)
,p_plug_name=>'Tables without Triggers'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This report displays tables that do not have triggers.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(69173409024446500)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722738457991798612)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34148419202124380)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP,RIR,2:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(69175712074446516)
,p_branch_action=>'2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(69174122456446507)
,p_name=>'P2_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(69173409024446500)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(69175301137446513)
,p_computation_sequence=>10
,p_computation_item=>'P2_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P2_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69192210847547410)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P2_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69192210847547410
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_imp_page.create_page(
 p_id=>6
,p_name=>'Attribute Dictionary'
,p_alias=>'ATTRIBUTE-DICTIONARY'
,p_step_title=>'Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196872320678099165)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_imp.id(194504915759237345)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197497415607067300)
,p_plug_name=>'column attributes'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>15
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    c.column_id,',
'    s.syn_name column_name,',
'    case when c.column_name != s.syn_name',
'         then c.column_name',
'         end base_record,',
'    --',
'    c.label,',
'    c.help_text,',
'    c.format_mask,',
'    c.default_value,',
'    --',
'    c.form_format_mask,',
'    c.form_display_width,',
'    c.form_display_height,',
'    c.form_data_type,',
'    --',
'    c.report_format_mask,',
'    decode(c.report_col_alignment,',
'           ''LEFT'',l.m,''CENTER'',ctr.m,''RIGHT'',r.m,null) report_col_alignment,',
'    --',
'    c.created_by,',
'    c.created_on,',
'    c.last_updated_by,',
'    c.last_updated_on',
'  from WWV_FLOW_HNT_COLUMN_DICT c,',
'       wwv_flow_hnt_col_dict_syn s,',
'       (select wwv_flow_lang.system_message(''LEFT'') m from sys.dual) l,',
'       (select wwv_flow_lang.system_message(''CENTER'') m from sys.dual) ctr,',
'       (select wwv_flow_lang.system_message(''RIGHT'') m from sys.dual) r',
' where c.security_group_id = :flow_security_group_id',
'   and c.column_id = s.column_id',
'   and s.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(197497511891067300)
,p_name=>'column attributes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197497702734067305)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Column ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197497823803067306)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Column Name'
,p_column_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:RP:P17_COLUMN_ID,F4500_LAST_VIEW:#COLUMN_ID#,6:'
,p_column_linktext=>'#COLUMN_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(198209126276365169)
,p_db_column_name=>'BASE_RECORD'
,p_display_order=>3
,p_column_identifier=>'AZ'
,p_column_label=>'Synonym of'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197497923751067307)
,p_db_column_name=>'LABEL'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197498014645067307)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Help Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197498129478067308)
,p_db_column_name=>'FORMAT_MASK'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Format Mask'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197498230034067309)
,p_db_column_name=>'DEFAULT_VALUE'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Default Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197498415272067310)
,p_db_column_name=>'FORM_FORMAT_MASK'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Form Format Mask'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197498505217067311)
,p_db_column_name=>'FORM_DISPLAY_WIDTH'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Form Display Width'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197498621334067312)
,p_db_column_name=>'FORM_DISPLAY_HEIGHT'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Form Display Height'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197498705818067313)
,p_db_column_name=>'FORM_DATA_TYPE'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Form Data Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197499906035067322)
,p_db_column_name=>'REPORT_FORMAT_MASK'
,p_display_order=>13
,p_column_identifier=>'W'
,p_column_label=>'Report Format Mask'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197500006990067324)
,p_db_column_name=>'REPORT_COL_ALIGNMENT'
,p_display_order=>14
,p_column_identifier=>'X'
,p_column_label=>'Report Column Alignment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197502421219067350)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>18
,p_column_identifier=>'AV'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197502514016067351)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>19
,p_column_identifier=>'AW'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197502620316067351)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>20
,p_column_identifier=>'AX'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(197502708086067352)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>21
,p_column_identifier=>'AY'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(197504409480105184)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1317400830536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COLUMN_NAME:BASE_RECORD:LABEL:HELP_TEXT:FORMAT_MASK:DEFAULT_VALUE'
,p_sort_column_1=>'COLUMN_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197652104930775557)
,p_plug_name=>'Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>25
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>UI Defaults allow AI interactions to understand the contents of your tables. They are also used to populate initial labels for forms and reports, providing consistency across multiple pages in an application or multiple applications.</p>',
'',
'<p>The Attribute Dictionary contains a set of attributes about a column that are used in creating forms and reports.  The definitions are matched by column name and a particular definition can be shared amongst several columns by using synonyms.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(442023927001440467)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(442022106915434689)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196941919040505465)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(197497415607067300)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(262152709439070830)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(197497415607067300)
,p_button_name=>'GRID_EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Grid Edit'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196240900601196384)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(197497415607067300)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:F4500_LAST_VIEW:6'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1019663455307233863)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(442023927001440467)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1019663721484233884)
,p_event_id=>wwv_flow_imp.id(1019663455307233863)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:6:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_imp_page.create_page(
 p_id=>10
,p_name=>'Script - Run'
,p_alias=>'SCRIPT-RUN'
,p_step_title=>'Run Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213236600761856491)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_inline_css=>'.u-Report {width: 100%; font-size: 12px;}'
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_rep_run_script.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10048401428195635)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42832115592689804)
,p_plug_name=>'Run Script'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_script.display_run_confirm(',
'    p_file_id => :F4500_P10_FILE_ID,',
'    p_date_time_format => ''&DATE_TIME_FORMAT.'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(372022143187)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(42832115592689804)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109787703963442985)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(42832115592689804)
,p_button_name=>'EDIT_SCRIPT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Edit Script'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:&F4500_P10_FILE_ID.'
,p_button_condition=>'wwv_flow_sw_script.script_w_warning(p_file_id => :F4500_P10_FILE_ID)'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(372007991036)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(42832115592689804)
,p_button_name=>'RUN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run Now'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(471472722487546596)
,p_branch_name=>'Go To Page 1225'
,p_branch_action=>'f?p=&APP_ID.:1225:&SESSION.::&DEBUG.:RP,1225:P1224_RESULT_ID:&P10_RESULT_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29063885017)
,p_name=>'P10_RUN_AS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(387994680244652086)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_tag_attributes=>'class="a-Form-select"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select a database schema (or username) to run this script as.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29128987183)
,p_name=>'F4500_P10_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(42832115592689804)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16826800561032587)
,p_name=>'P10_RESULT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(10048401428195635)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(145945111357011245)
,p_name=>'P10_SCRIPT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(42832115592689804)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'from wwv_flow_files',
'where id = :F4500_P10_FILE_ID',
'and file_type = ''SCRIPT'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18056327424)
,p_validation_name=>'Must Select Run As'
,p_validation_sequence=>10
,p_validation=>'P10_RUN_AS'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Oracle Schema (USER NAME) must be specified to run this script.  '
,p_validation_condition=>'RUN,RUN_IN_BACKGROUND'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(29063885017)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(128081917428230107)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv (',
'    p_schema => :P10_RUN_AS',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error checking privileges.'
,p_process_when_button_id=>wwv_flow_imp.id(372007991036)
,p_internal_uid=>128081917428230107
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19995201456899729)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set sort preference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_preferences.set_preference(',
'p_preference=>''FSP4500_P1220_R11177418830226625_SORT'',',
'p_value => ''fsp_sort_8'',',
'p_user => v(''USER''));'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>19995201456899729
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(210368638674469028)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'submit script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P10_RESULT_ID := wwv_flow_sw_script.submit_to_run (',
'                   p_file_id  => :F4500_P10_FILE_ID,',
'                   p_run_by   => :APP_USER,',
'                   p_run_as   => :P10_RUN_AS',
'                   );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to submit the script to run.'
,p_internal_uid=>210368638674469028
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9321931833012508)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'run script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_script.run_file',
'      (p_result_id => :P10_RESULT_ID,',
'       p_file_id => :F4500_P10_FILE_ID,       ',
'       p_schema    => :P10_RUN_AS,',
'       p_run_by  => :APP_USER);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to run script.'
,p_process_when_button_id=>wwv_flow_imp.id(372007991036)
,p_internal_uid=>9321931833012508
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_imp_page.create_page(
 p_id=>11
,p_name=>'Database Monitor'
,p_alias=>'DATABASE-MONITOR'
,p_step_title=>'Database Monitor'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_help_text=>'AEUTL/dbadm_montitor.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(133796225310429187)
,p_plug_name=>'Activity'
,p_icon_css_classes=>'icon-region-native-flash-chart5'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(703386252988943977)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(133792932105421631)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
);
end;
/
prompt --application/pages/page_00012
begin
wwv_flow_imp_page.create_page(
 p_id=>12
,p_name=>'Generate DDL'
,p_alias=>'GENERATE-DDL'
,p_step_title=>'Generate DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1486819378945387)
,p_plug_name=>'Schema Objects'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>11
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner schema_owner, ',
'       sum(decode(object_type,''TABLE'',1,0)) tables,',
'       sum(decode(object_type,''VIEW'',1,0)) views,',
'       sum(decode(object_type,''PACKAGE'',1,0)) packages,',
'       sum(decode(object_type,''PROCEDURE'',1,0)) procedures,',
'       sum(decode(object_type,''FUNCTION'',1,0)) functions,',
'       sum(decode(object_type,''TRIGGER'',1,0)) triggers,',
'       sum(decode(object_type,''SYNONYM'',1,0)) synonyms,',
'       sum(decode(object_type,''TYPE'',1,0)) types,',
'       sum(decode(object_type,''SEQUENCE'',1,0)) sequences,',
'       sum(decode(object_type,''INDEX'',1,0)) indexes,',
'       sum(decode(object_type,''DATABASE LINK'',1,0)) database_links,',
'       sum(decode(object_type,''MATERIALIZED VIEW'',1,0)) materialized_views',
'from (',
'select owner, object_type, object_name',
'from sys.dba_objects where owner in (',
'select c.schema',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
'where  c.security_group_id = :flow_security_group_id and',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :flow_user and',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'        instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0))',
') x',
'group by owner'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1486931056945387)
,p_name=>'Schema Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1487112568945421)
,p_db_column_name=>'SCHEMA_OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1487206500945426)
,p_db_column_name=>'TABLES'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Tables'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1487310320945426)
,p_db_column_name=>'VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1487409322945426)
,p_db_column_name=>'PACKAGES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Packages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1487510143945426)
,p_db_column_name=>'PROCEDURES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Procedures'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1487601504945427)
,p_db_column_name=>'FUNCTIONS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Functions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1487703932945427)
,p_db_column_name=>'TRIGGERS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Triggers'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1487827146945427)
,p_db_column_name=>'SYNONYMS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Synonyms'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1487904312945427)
,p_db_column_name=>'TYPES'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Types'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1488006466945427)
,p_db_column_name=>'SEQUENCES'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Sequences'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1488122175945427)
,p_db_column_name=>'INDEXES'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Indexes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1488212701945428)
,p_db_column_name=>'DATABASE_LINKS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Database Links'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1488332313945428)
,p_db_column_name=>'MATERIALIZED_VIEWS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Materialized Views'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1488801884947581)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1317500331536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SCHEMA_OWNER:TABLES:VIEWS:PACKAGES:PROCEDURES:FUNCTIONS:TRIGGERS:SYNONYMS:TYPES:SEQUENCES:INDEXES:DATABASE_LINKS:MATERIALIZED_VIEWS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112022311206824401)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1486819378945387)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Script'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(698586606001530549)
,p_name=>'On Close Modal'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(112022311206824401)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(698586727765530550)
,p_event_id=>wwv_flow_imp.id(698586606001530549)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1486819378945387)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'    lUrl        = ''f?p=4500:1004:&SESSION.::&DEBUG.:'';',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
' setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_imp_page.create_page(
 p_id=>13
,p_name=>'Data Dictionary'
,p_alias=>'DATA-DICTIONARY'
,p_step_title=>'Data Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11093307704620192)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11600917523650714)
,p_plug_name=>'schema owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441230013633249819)
,p_plug_name=>'All Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select DISTINCT o.object_name, c.comments',
'  from sys.all_objects o, sys.all_tab_comments c',
'  where o.owner = c.owner',
'    and o.object_name = c.table_name',
'    and o.object_type = ''VIEW'' ',
'    and (o.owner = ''SYS'' or ',
'         o.owner like ''FLOWS_%'' or',
'         o.owner like ''APEX_%'')',
'    and (o.object_name like ''USER%'' or',
'         o.object_name like ''ALL%'' or',
'         o.object_name like ''APEX_%'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P13_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441230131418249819)
,p_name=>'All Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441230306780249821)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Object Name'
,p_column_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.::F4500_P14_OBJECT_NAME,F4500_P15_PARSE_STMT_AS:#OBJECT_NAME#,&P13_SCHEMA.'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441230423945249822)
,p_db_column_name=>'COMMENTS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441230514869251034)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1317622422536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OBJECT_NAME:COMMENTS'
,p_sort_column_1=>'OBJECT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(72492410848555529)
,p_branch_action=>'13'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(465515900436190)
,p_name=>'P13_SCHEMA'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(11600917523650714)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Identifies the database schema you would like to view this page as.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(467211183444240)
,p_name=>'P13_SCHEMA_LABEL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(441230013633249819)
,p_source=>'wwv_flow_lang.system_message(''CONFIRM.PARSING_SCHEMA'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_source_post_computation=>'wwv_flow_escape.html(:P13_SCHEMA_LABEL)'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112261530045965316)
,p_computation_sequence=>10
,p_computation_item=>'P13_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P13_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(432751826383974955)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P13_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>432751826383974955
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_imp_page.create_page(
 p_id=>14
,p_name=>'Data Dictionary Browser'
,p_alias=>'DATA-DICTIONARY-BROWSER'
,p_step_title=>'Data Dictionary Browser'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11093307704620192)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'function ToggleAll(e){',
'  if (e.checked){CheckAll(); }',
'  else{ClearAll();}',
'  }',
'',
'function Check(e){e.checked = true; }',
'function Clear(e){e.checked = false;}',
'function CheckAll(){',
'  var ml = document.wwv_flow;',
'  var len = ml.elements.length;',
'  for (var i = 0; i < len; i++){',
'    var e = ml.elements[i];',
'    if (e.name == "f01") {Check(e);}',
'   }',
'  ml.f01.checked = true;',
' }',
'',
'function ClearAll(){',
'  var ml = document.wwv_flow;',
'  var len = ml.elements.length;',
'  for (var i = 0; i < len; i++){',
'    var e = ml.elements[i];',
'    if (e.name == "f01") {Clear(e);}',
'  }',
'  ml.f01.checked = false;',
'}',
'</script>'))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8433315974658433)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(72610012393226909)
,p_name=>'Dictionary Query By Example (QBE) Form'
,p_template=>wwv_flow_imp.id(385893260111566687)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767);',
'begin',
'  q := ',
'''select',
'  wwv_flow_item.checkbox(1,x.column_name) include,  ',
'  x.column_id,',
'  x.column_name column_name, ',
'  wwv_flow_item.text(2,null,90)||wwv_flow_item.hidden(3,x.data_type)||wwv_flow_item.hidden(4,x.column_name) condition,   ',
'  x.data_type data_type,',
'  x.comments',
'from (',
'select ',
'  t.column_id,',
'  t.column_name,',
'  t.data_type,',
'  c.comments',
'from sys.all_tab_columns t, sys.all_col_comments c',
'where t.owner = c.owner',
'and t.table_name = c.table_name',
'and t.column_name = c.column_name',
'and (t.owner in (''''SYS'''','''''' || wwv_flow.g_flow_schema_owner || ''''''))',
'and t.table_name = :F4500_P14_OBJECT_NAME',
') x'';',
'return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_plug_query_max_columns=>60
,p_query_num_rows=>1000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_LEFT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'F4500_P15_PARSE_STMT_AS'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48718216970771769)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Include'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48718313462771769)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Seq'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48718420839771769)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48718529301771769)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Column Condition'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48718632395771769)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48718718158771769)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48718831167771769)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48718909626771769)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48719009204771770)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48719105173771770)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48719221922771770)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48719316380771770)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48719417803771770)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48719518395771770)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48719617809771770)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191029519116227646)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191029610644227647)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191029716011227647)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191029817088227647)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191029916789227647)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030025132227647)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030120853227647)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030206484227647)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030332711227648)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030404015227648)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030511643227648)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030618215227648)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030726761227648)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030832475227648)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191030919647227648)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031004327227648)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031110691227648)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031218978227649)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031318337227649)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031402823227649)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031516513227649)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031603927227649)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031722871227649)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031805641227649)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191031923723227649)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032023968227650)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032102507227650)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032204363227650)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032300003227650)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032426520227650)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032530901227650)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032628309227650)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032729791227650)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032817859227651)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191032901529227651)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033006050227652)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033129993227652)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033221815227652)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033321315227652)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033418668227652)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033510260227653)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033632393227653)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033723264227653)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033822141227653)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191033916672227653)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(72676514275580298)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8433315974658433)
,p_button_name=>'Query'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Query'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(72673335411575794)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8433315974658433)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'EDIT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(72676946566580304)
,p_branch_action=>'15'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(72676514275580298)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(72673714957575801)
,p_branch_action=>'13'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(72673335411575794)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72694595799623334)
,p_name=>'F4500_P14_OBJECT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8433315974658433)
,p_prompt=>'View Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies data dictionary view name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72783020283894832)
,p_name=>'F4500_P14_QUERY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(72610012393226909)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72974620438464018)
,p_name=>'F4500_P15_PARSE_STMT_AS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8433315974658433)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select a database schema (or username) to parse this query by example query as.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101240401152279929)
,p_name=>'F4500_P14_CHECK_ALL'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(72610012393226909)
,p_prompt=>'Check All'
,p_post_element_text=>'<input type="checkbox" name="f10" onclick="ToggleAll(this)" />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_help_text=>'Checks all rows'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112334425618219519)
,p_computation_sequence=>10
,p_computation_item=>'F4500_P15_PARSE_STMT_AS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'F4500_P15_PARSE_STMT_AS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101182427964386235)
,p_validation_name=>'select at least one column'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'begin',
'',
'  if wwv_flow.g_f01.count = 0 then',
'',
'    return false;',
'',
'  else',
'',
'    return true;',
'',
'  end if;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'At least one column must be specified to view. '
,p_when_button_pressed=>wwv_flow_imp.id(72676514275580298)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(128448727865650733)
,p_validation_name=>'must select parse as'
,p_validation_sequence=>10
,p_validation=>'F4500_P15_PARSE_STMT_AS'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Oracle Schema (USER NAME) must be specified to parse this query.  '
,p_when_button_pressed=>wwv_flow_imp.id(72676514275580298)
,p_associated_item=>wwv_flow_imp.id(72974620438464018)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(72792311558912454)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sql   varchar2(32767) := null;',
'  l_count number := 1;',
'begin  ',
'  l_sql:=''select '';',
'',
'  for i in 1..wwv_flow.g_f01.count loop',
'    l_sql:=l_sql||wwv_flow.g_f01(i)||'', '';',
'  end loop;',
'  l_sql:=rtrim(l_sql,'', '');',
'',
'  l_sql:=l_sql||'' from ''||:F4500_P14_OBJECT_NAME;  ',
'  ',
'  for j in 1..wwv_flow.g_f04.count loop -- column_name',
'    if wwv_flow.g_f02(j) is not null then    -- condition',
'        ',
'      if l_count = 1 then      ',
'        l_sql:=l_sql||'' where ''||wwv_flow.g_f04(j)||'' like '';',
'        l_sql:=l_sql||wwv_flow_utilities.ite(wwv_flow.g_f03(j)=''VARCHAR2'',',
'                                             ''''''''||upper(wwv_flow.g_f02(j))||'''''''',',
'                                             wwv_flow.g_f02(j));',
'      elsif l_count > 1 then',
'        l_sql:=l_sql||'' and ''||wwv_flow.g_f04(j)||'' like '';',
'        l_sql:=l_sql||wwv_flow_utilities.ite(wwv_flow.g_f03(j)=''VARCHAR2'',',
'                                             ''''''''||upper(wwv_flow.g_f02(j))||'''''''',',
'                                             wwv_flow.g_f02(j));',
'      end if;',
'      l_count := l_count + 1;',
'    end if;    ',
'  end loop; ',
'  ',
'  :f4500_p14_query := l_sql;',
'  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error building a valid data dictionary query.'
,p_process_when_button_id=>wwv_flow_imp.id(72676514275580298)
,p_internal_uid=>72792311558912454
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69310525990845161)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:F4500_P15_PARSE_STMT_AS);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69310525990845161
);
end;
/
prompt --application/pages/page_00015
begin
wwv_flow_imp_page.create_page(
 p_id=>15
,p_name=>'Data Dictionary Browser'
,p_alias=>'DATA-DICTIONARY-BROWSER1'
,p_step_title=>'Data Dictionary Browser'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215533519659718594)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8428426757653465)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(72708419326651673)
,p_name=>'Query Results'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'--',
'-- flows has privs to set non public parsing schema',
'--',
'wwv_flow_sw_api.check_priv (',
'    p_schema => :F4500_P15_PARSE_STMT_AS);',
'',
'wwv_flow.debug(:f4500_p14_query);',
'return :f4500_p14_query;',
'',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_item=>'F4500_P15_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_LEFT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'F4500_P15_PARSE_STMT_AS'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48496908414770400)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'COL01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497024693770400)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'COL02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497115550770400)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'COL03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497214669770400)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'COL04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497315430770401)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'COL05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497418633770401)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497501678770401)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497624681770401)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497703128770401)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497823777770401)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48497912399770401)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48498024704770401)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48498100804770401)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48498211783770402)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48498322912770402)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(101387732499375710)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'COL16'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(101387824096375712)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'COL17'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(101387902538375712)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'COL18'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(101388010724375712)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'COL19'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(101388126372375712)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'COL20'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162268930148685559)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'COL21'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269023884685559)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'COL22'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269121692685565)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'COL23'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269213375685566)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'COL24'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269321244685566)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'COL25'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269410621685566)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'COL26'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269504428685566)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'COL27'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269604156685566)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'COL28'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269728992685566)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'COL29'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269820824685566)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'COL30'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162269903098685567)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'COL31'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270022230685567)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'COL32'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270123628685567)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'COL33'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270214729685567)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'COL34'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270306013685567)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'COL35'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270403739685567)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'COL36'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270512314685567)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'COL37'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270619695685567)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'COL38'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270725824685568)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'COL39'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270819092685568)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'COL40'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162270931199685568)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'COL41'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271022721685568)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'COL42'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271100480685568)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'COL43'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271206417685568)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'COL44'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271320546685568)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'COL45'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271422779685568)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'COL46'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271504769685569)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'COL47'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271608376685569)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'COL48'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271732479685569)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'COL49'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271816655685569)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'COL50'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162271917777685569)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'COL51'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162272006093685569)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'COL52'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162272124828685569)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'COL53'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162272203274685569)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'COL54'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162272315265685570)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'COL55'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162272400451685570)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'COL56'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162272518315685570)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'COL57'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162272609604685570)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'COL58'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162272725503685570)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'COL59'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162272824324685570)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'COL60'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(72709513331652891)
,p_plug_name=>'Query Result'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This page displays the results of your data dictionary query.  Click the navigation buttons at the top of your result list to enter a new query or to browse another data dictionary table.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(72923691296374499)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(83958920185763837)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8428426757653465)
,p_button_name=>'F4500_P15_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73092323108960513)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8428426757653465)
,p_button_name=>'BrowseAnotherView'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Browse Another View'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73051386810876661)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8428426757653465)
,p_button_name=>'New_Query'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'New Query'
,p_button_position=>'EDIT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(73051719881876667)
,p_branch_action=>'14'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(73051386810876661)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(73092721135960520)
,p_branch_action=>'13'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(73092323108960513)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(72886276500307504)
,p_branch_action=>'15'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72928317406381693)
,p_name=>'F4500_P15_ROWS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8428426757653465)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the maximum number of rows to display in the report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(72933410758391006)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset when max rows changes'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>72933410758391006
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(37917032522591199)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset pagination'
,p_process_sql_clob=>'wwv_flow_disp_page_plugs.reset_region_pagination(72708419326651673);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>37917032522591199
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_imp_page.create_page(
 p_id=>17
,p_name=>'Column Details'
,p_alias=>'COLUMN-DETAILS'
,p_step_title=>'Column Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(690783120585803188)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46291826911679077)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717413953976820775)
,p_plug_display_sequence=>7
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197559328785290205)
,p_plug_name=>'Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197566004135292852)
,p_plug_name=>'Form Specific Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197566208984294244)
,p_plug_name=>'Report Specific Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197567331624310205)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_04'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197822732653934972)
,p_plug_name=>'Column Details'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>These details are used by the App Builder when creating pages and regions.   The definitions are matched by column name and a particular definition can be shared amongst several columns by using synonyms.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(198173528700015897)
,p_name=>'Synonyms'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>15
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select syn_id, syn_name',
'  from wwv_flow_hnt_col_dict_syn',
' where column_id  = :P17_COLUMN_ID',
'   and syn_name  != :P17_COLUMN_NAME',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_condition=>'P17_COLUMN_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200287610973758311)
,p_query_column_id=>1
,p_column_alias=>'SYN_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:30:P30_SYN_ID:#SYN_ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" />'
,p_column_link_attr=>'width="16" height="16" border="0" '
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(198173830721015920)
,p_query_column_id=>2
,p_column_alias=>'SYN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Synonym Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200265324873440726)
,p_plug_name=>'Synonyms'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>12
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P17_COLUMN_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197559816861290206)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(197567331624310205)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200447708951211856)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(198173528700015897)
,p_button_name=>'ADD_SYN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Add Synonym'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:30:P30_COLUMN_ID:&P17_COLUMN_ID.'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197559726985290205)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(197567331624310205)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P17_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197559625357290205)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(197567331624310205)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P17_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197559529748290205)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(197567331624310205)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P17_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197615115236523203)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(197567331624310205)
,p_button_name=>'GET_PREVIOUS_COLUMN_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_COLUMN_ID'')'
,p_button_condition=>'P17_COLUMN_ID_PREV'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197615015591523203)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(197567331624310205)
,p_button_name=>'GET_NEXT_COLUMN_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_COLUMN_ID'')'
,p_button_condition=>'P17_COLUMN_ID_NEXT'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(197617918295523222)
,p_branch_action=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::P17_COLUMN_ID:&P17_COLUMN_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(197615015591523203)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(197618101873523223)
,p_branch_action=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::P17_COLUMN_ID:&P17_COLUMN_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(197615115236523203)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(197560601247290207)
,p_branch_action=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197560802788290208)
,p_name=>'P17_COLUMN_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(197559328785290205)
,p_use_cache_before_default=>'NO'
,p_source=>'COLUMN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197561021685290219)
,p_name=>'P17_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(197559328785290205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Name'
,p_source=>'COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The column name associated with the defaults.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197561232285290220)
,p_name=>'P17_LABEL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(197559328785290205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Label'
,p_source=>'LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Label to be used whenever a column with this name, or one of its synonyms, is referenced with any create wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197561404939290221)
,p_name=>'P17_HELP_TEXT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(197559328785290205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Used as help text in a form or interactive report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197561629856290221)
,p_name=>'P17_FORMAT_MASK'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(197559328785290205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Format Mask'
,p_source=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Format mask to be used as default.  If a specific report, form or tabular form format mask exists for this column, that will be used instead.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197561806342290223)
,p_name=>'P17_DEFAULT_VALUE'
,p_item_sequence=>46
,p_item_plug_id=>wwv_flow_imp.id(197559328785290205)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Value'
,p_source=>'DEFAULT_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When creating a form that references this column, this specifies the default value for the item resulting from this column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197562214371290224)
,p_name=>'P17_FORM_FORMAT_MASK'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(197566004135292852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Format Mask'
,p_source=>'FORM_FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When a form is created referencing this column, or one of its synonyms, this format mask will be used.  If provided, it will override the general format mask.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197562431629290224)
,p_name=>'P17_FORM_DISPLAY_WIDTH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(197566004135292852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Width'
,p_source=>'FORM_DISPLAY_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>12
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When a form is created referencing this column, or one of its synonyms, this determines the display width.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197562831365290226)
,p_name=>'P17_FORM_DISPLAY_HEIGHT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(197566004135292852)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1'
,p_prompt=>'Height'
,p_source=>'FORM_DISPLAY_HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>12
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When a form is created referencing this column, or one of its synonyms, this determines the height of the resulting item.  This is only applicable for items of type textarea.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197563204690290226)
,p_name=>'P17_FORM_DATA_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(197566004135292852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data Type'
,p_source=>'FORM_DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FORM_VALIDATION_DATA_TYPE (FROM 4000)'
,p_lov=>'.'||wwv_flow_imp.id(197595525878393704)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Specified -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When a form is created referencing this column, or one of its synonyms, this determines if the Data Type validation should be set to VARCHAR (the default) or NUMBER.  If set to number, a validation will be performed to ensure that the value of the it'
||'em is numeric.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197563625318290228)
,p_name=>'P17_REPORT_FORMAT_MASK'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(197566208984294244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Format Mask'
,p_source=>'REPORT_FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When a report is created referencing this column, or one of its synonyms, this format mask will be used.  If provided, it will override the general format mask.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197563811032290228)
,p_name=>'P17_REPORT_COL_ALIGNMENT'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(197566208984294244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Alignment'
,p_source=>'REPORT_COL_ALIGNMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI_DEF_ALIGNMENT_LEFT_CENTER_RIGHT'
,p_lov=>'.'||wwv_flow_imp.id(251500722928507973)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When a report is created referencing this column, or one of its synonyms, this determines the column alignment (left, center, or right).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197616916753523211)
,p_name=>'P17_COLUMN_ID_NEXT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(197567331624310205)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197617117858523212)
,p_name=>'P17_COLUMN_ID_PREV'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(197567331624310205)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197617302147523213)
,p_name=>'P17_COLUMN_ID_COUNT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(197567331624310205)
,p_prompt=>'Column:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_display_when=>'P17_COLUMN_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The number of columns currently defined.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200265725696450365)
,p_name=>'P17_SYN_NAME1'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(200265324873440726)
,p_prompt=>'Synonym 1'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'First synonym for the column.  If synonyms are added, the definition for the base column will be used whenever a column name matches the synonym.  Additional synonyms can be added after the base column is created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200265932622452354)
,p_name=>'P17_SYN_NAME2'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(200265324873440726)
,p_prompt=>'Synonym 2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Second synonym for the column.  Additional synonyms can be added after the base column is created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(198129821429313685)
,p_validation_name=>'COLUMN_NAME UNIQUE'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_need_check varchar2(1) := ''N'';',
'begin',
'   if :P17_COLUMN_ID is not null then',
'      for c1 in (',
'         select column_name old_col_name',
'           from wwv_flow_hnt_column_dict',
'          where column_id = :P17_COLUMN_ID',
'            and security_group_id = :flow_security_group_id )',
'      loop',
'         if c1.old_col_name != :P17_COLUMN_NAME then',
'            l_need_check := ''Y'';  -- name change',
'         end if;',
'      end loop;',
'   else l_need_check := ''Y'';  -- new record',
'   end if;',
'',
'   if l_need_check = ''Y'' then',
'      for c1 in (',
'         select count(*) cnt',
'           from wwv_flow_hnt_col_dict_syn',
'          where syn_name = upper(:P17_COLUMN_NAME) ',
'            and security_group_id = :flow_security_group_id )',
'      loop',
'         if c1.cnt > 0 then',
'            return false;',
'         else return true;',
'         end if;',
'      end loop;',
'   else return true;',
'   end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'This column name already exists as either a column or a synonym of a column.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_imp.id(197561021685290219)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200440001922077374)
,p_validation_name=>'syn1 != syn2'
,p_validation_sequence=>15
,p_validation=>':P17_SYN_NAME1 != :P17_SYN_NAME2'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Synonym 1 and 2 must not be the same.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P17_SYN_NAME1 is not null and',
':P17_SYN_NAME2 is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(197559529748290205)
,p_associated_item=>wwv_flow_imp.id(200265725696450365)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200442715213090738)
,p_validation_name=>'syn, syn2 != col'
,p_validation_sequence=>16
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(:P17_SYN_NAME1,''1'') != :P17_COLUMN_NAME and',
'nvl(:P17_SYN_NAME2,''2'') != :P17_COLUMN_NAME'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Synonyms must not be the same as the column name.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P17_SYN_NAME1 is not null or',
':P17_SYN_NAME2 is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(197559529748290205)
,p_associated_item=>wwv_flow_imp.id(200265725696450365)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200297601688935415)
,p_validation_name=>'SYN_NAME1 UNIQUE'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_col_dict_syn',
' where syn_name = upper(:P17_SYN_NAME1)',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This synonym already exists as either a column or a synonym of a column.'
,p_validation_condition=>'P17_SYN_NAME1'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(197559529748290205)
,p_associated_item=>wwv_flow_imp.id(200265725696450365)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200443508680117227)
,p_validation_name=>'SYN_NAME2 UNIQUE'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_col_dict_syn',
' where syn_name = upper(:P17_SYN_NAME2)',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This synonym already exists as either a column or a synonym of a column.'
,p_validation_condition=>'P17_SYN_NAME2'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(197559529748290205)
,p_associated_item=>wwv_flow_imp.id(200265932622452354)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1019620180310959568)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(198173528700015897)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1019620416321959569)
,p_event_id=>wwv_flow_imp.id(1019620180310959568)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:17:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(197564805519290231)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_03=>'P17_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>197564805519290231
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(197617702299523215)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_03=>'P17_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_07=>'COLUMN_NAME'
,p_attribute_09=>'P17_COLUMN_ID_NEXT'
,p_attribute_10=>'P17_COLUMN_ID_PREV'
,p_attribute_13=>'P17_COLUMN_ID_COUNT'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>197617702299523215
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(197565016928290232)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_03=>'P17_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_09=>'P17_COLUMN_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_HNT_COLUMN_DICT.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>197565016928290232
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(200266428036470028)
,p_process_sequence=>35
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Insert Synonyms'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P17_SYN_NAME1 is not null then',
'   insert into wwv_flow_hnt_col_dict_syn',
'      (column_id, syn_name)',
'   values',
'      (:P17_COLUMN_ID, :P17_SYN_NAME1);',
'end if;',
'if :P17_SYN_NAME2 is not null then',
'   insert into wwv_flow_hnt_col_dict_syn',
'      (column_id, syn_name)',
'   values',
'      (:P17_COLUMN_ID, :P17_SYN_NAME2);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Synonyms failed to be created.'
,p_process_when_button_id=>wwv_flow_imp.id(197559529748290205)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P17_SYN_NAME1 is not null or',
':P17_SYN_NAME2 is not null'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>200266428036470028
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(197565221306290233)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'17'
,p_process_when_button_id=>wwv_flow_imp.id(197559726985290205)
,p_internal_uid=>197565221306290233
);
end;
/
prompt --application/pages/page_00018
begin
wwv_flow_imp_page.create_page(
 p_id=>18
,p_name=>'Generate DDL - Schema'
,p_alias=>'GENERATE-DDL-SCHEMA'
,p_page_mode=>'MODAL'
,p_step_title=>'Generate DDL - Schema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11093307704620192)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74343509509191237)
,p_plug_name=>'Generate DDL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>'<p>Select the database schema which owns the database objects for which you would like to generate a data definition language (DDL) script.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(87140610261575493)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(87134126220568115)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(703372217110859571)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208302519813575959)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(946241682753406286)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208302519813575959)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(74371220283225403)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208302519813575959)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(74355506047207982)
,p_branch_action=>'43'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(74371220283225403)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74350120711201184)
,p_name=>'F4500_P18_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(74343509509191237)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select the database schema that owns the objects you for which you would like to generate DDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(148823616528244857)
,p_computation_sequence=>10
,p_computation_item=>'LAST_SELECTED_PARSE_AS'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4500_P18_SCHEMA'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(87184711302620651)
,p_validation_name=>'F4500_P18_SCHEMA Not Null'
,p_validation_sequence=>1
,p_validation=>'F4500_P18_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Schema must be specified.'
,p_associated_item=>wwv_flow_imp.id(74350120711201184)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 01-AUG-2002 11:49'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(946246338971408274)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(946241682753406286)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(946246684483408279)
,p_event_id=>wwv_flow_imp.id(946246338971408274)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_imp_page.create_page(
 p_id=>19
,p_name=>'Table Defaults'
,p_alias=>'TABLE-DEFAULTS'
,p_step_title=>'Table Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201420231138254416)
,p_plug_name=>'Table Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_HNT_TABLE_INFO'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(940656935720194111)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(940657010859194112)
,p_plug_name=>'Table Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201420615995254420)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(940656935720194111)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201420425314254419)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(940656935720194111)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P19_TABLE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201420527486254419)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(940656935720194111)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P19_TABLE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(201444027095519583)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:802::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(201420527486254419)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(201421332116254423)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1483106311681006)
,p_name=>'P19_TABLE_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_item_source_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_source=>'TABLE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1483259210681007)
,p_name=>'P19_SCHEMA'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_item_source_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_prompt=>'Schema'
,p_source=>'SCHEMA'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The Schema which owns the current Table or View.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1483387435681008)
,p_name=>'P19_TABLE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_item_source_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_prompt=>'Table Name'
,p_source=>'TABLE_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The table or view within the current schema associated with the UI Defaults.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1483486541681009)
,p_name=>'P19_FORM_REGION_TITLE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_item_source_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_prompt=>'Singular Label'
,p_source=>'FORM_REGION_TITLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'A singular, human-readable descriptor of the data within this table.  This allows AI interactions to understand the contents of this table and is used in generating APEX components referencing this table.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1483563963681010)
,p_name=>'P19_REPORT_REGION_TITLE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_item_source_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_prompt=>'Plural Label'
,p_source=>'REPORT_REGION_TITLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'A plural, human-readable descriptor of the data within this table.  This allows AI interactions to understand the contents of this table and is used in generating APEX components referencing this table.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1484156865681016)
,p_name=>'P19_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_item_source_plug_id=>wwv_flow_imp.id(201420231138254416)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The full description of the data within this table. This allows AI interactions to understand the contents of this table.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1484373460681018)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(201420231138254416)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Table Defaults'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_process_error_message=>'Unable to save UI Defaults.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>1484373460681018
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2002649877056102)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Dictionary Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.update_table_cache (',
'    p_schema         => :P19_SCHEMA,',
'    p_table_name     => :P19_TABLE_NAME,',
'    p_singular_label => :P19_FORM_REGION_TITLE,',
'    p_plural_label   => :P19_REPORT_REGION_TITLE,',
'    p_description    => :P19_DESCRIPTION );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(201420425314254419)
,p_internal_uid=>2002649877056102
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1484266672681017)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(201420231138254416)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Table Defaults'
,p_internal_uid=>1484266672681017
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_imp_page.create_page(
 p_id=>20
,p_name=>'Create App from Script'
,p_alias=>'CREATE-APP-FROM-SCRIPT'
,p_page_mode=>'MODAL'
,p_step_title=>'Create App from Script'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(82705316400738126)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179748680802869406)
,p_plug_name=>'No Tables Found'
,p_region_css_classes=>'a-Alert--dialog margin-top-md'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'This script does not contain any create table statements or the tables do not exist in the selected schema.'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value table_name',
'from table(',
'    wwv_flow_define_app_v3.get_valid_tables(',
'        p_schema    => :P20_SCHEMA,',
'        p_file_id   => :P20_SCRIPT_FILE_ID ))'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1152240684997363045)
,p_name=>'Tables'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--noBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value table_name',
'from table(',
'    wwv_flow_define_app_v3.get_valid_tables(',
'        p_schema    => :P20_SCHEMA,',
'        p_file_id   => :P20_SCRIPT_FILE_ID ))',
'order by 1;'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value table_name',
'from table(',
'    wwv_flow_define_app_v3.get_valid_tables(',
'        p_schema    => :P20_SCHEMA,',
'        p_file_id   => :P20_SCRIPT_FILE_ID ))'))
,p_display_condition_type=>'EXISTS'
,p_header=>'The following table(s) in this script will be used to default report and form page(s) in the Create Application wizard.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'The script does NOT contain any create table statements or those tables do NOT exist in the database schema.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(179748550028869405)
,p_query_column_id=>1
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1152240724442363046)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1152240897463363047)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1152240724442363046)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1152241140193363050)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1152240724442363046)
,p_button_name=>'CREATE_APP_WIZ'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value table_name',
'from table(',
'    wwv_flow_define_app_v3.get_valid_tables(',
'        p_schema    => :P20_SCHEMA,',
'        p_file_id   => :P20_SCRIPT_FILE_ID ))'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(179748914199869409)
,p_branch_name=>'create app wizard'
,p_branch_action=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:RP,1,5,130,150,170,250:P1_SCRIPT_FILE_ID,P1_SCHEMA:&P20_SCRIPT_FILE_ID.,&P20_SCHEMA.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1152241140193363050)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(82704992099738122)
,p_name=>'P20_SCHEMA'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(82705316400738126)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select a database schema.  Create table statements in this script can be checked against the database schema to see if they can be used in Create Application Wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(82706436951738137)
,p_name=>'P20_SCRIPT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(82705316400738126)
,p_prompt=>'Script Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'from wwv_flow_files',
'where id = :P20_SCRIPT_FILE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(179748251592869402)
,p_name=>'P20_SCRIPT_FILE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1152240684997363045)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1152240917321363048)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1152240897463363047)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1152241056917363049)
,p_event_id=>wwv_flow_imp.id(1152240917321363048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(82705089581738123)
,p_name=>'set schema in session'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P20_SCHEMA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82705167397738124)
,p_event_id=>wwv_flow_imp.id(82705089581738123)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(657512869312459935)
,p_name=>'Create App'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1152241140193363050)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(657512906754459936)
,p_event_id=>wwv_flow_imp.id(657512869312459935)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE_APP_WIZ'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00021
begin
wwv_flow_imp_page.create_page(
 p_id=>21
,p_name=>'Top SQL'
,p_alias=>'TOP-SQL'
,p_step_title=>'Top SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_topsql.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160632704976002525)
,p_plug_name=>'Query Parameter Container'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(168892618181554185)
,p_name=>'Top SQL'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>21
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    x   varchar2(32767);',
'    p   varchar2(32767):= null;',
'begin',
'',
'x:=''select * from ( '';',
'x:=x||''select wwv_flow_escape.html(replace(replace(substr(sql_text,1,500),'''','''','''', ''''),'''',''''||chr(32)||chr(32),'''',''''||chr(32))) sql_text, '';',
'x:=x||''  (cpu_time/1000000) cpu_time,disk_reads,buffer_gets, '';',
'x:=x||''  executions, '';',
'x:=x||''  case when rows_processed = 0 then null else (buffer_gets/nvl(replace(rows_processed,0,1),1)) end efficiency, '';',
'x:=x||''  (buffer_gets/nvl(replace(executions,0,1),1)) efficiency2, '';',
'x:=x||''  child_number,hash_value,address, '';',
'x:=x||'' case '';',
'x:=x||'' when (select count(*) from sys.gv_$sql_plan sp where  sp.address=s.address '';',
'x:=x||'' and sp.HASH_VALUE=s.hash_value and sp.CHILD_NUMBER=s.child_number) > 0'';',
'x:=x||'' then ''''<a href="f?p=4500:551:&SESSION.::NO:551:P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER,P551_INST_ID:''''||s.address||'''',''''||s.hash_value||'''',''''||s.child_number||'''',''''||s.inst_id||''''"><span class="a-Icon icon-search"></span><span class="u'
||'-VisuallyHidden">''||wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'')||''</span></a> '''' '';',
'x:=x||'' else null '';',
'x:=x||'' end x, '';',
'x:=x||'' null link, '';',
'x:=x||''  (elapsed_time/1000000) elapsed_time,  '';',
'x:=x||''  ''''''||wwv_flow_lang.system_message(''SESSION_MON_ELAPSED'')||'' ''''||to_char((elapsed_time/1000000),''''999G999G999G999D00'''') || '';',
'x:=x||''  ''''<br />''||wwv_flow_lang.system_message(''SESSION_MON_CPU'')||'' ''''||to_char((cpu_time/1000000),''''999G999G999G999D00'''') the_time,  '';',
'x:=x||''  ''''''||wwv_flow_lang.system_message(''SESSION_MON_DISK'')||'' ''''||to_char(disk_reads,''''999G999G999G999'''')||''''<br />''''|| '';',
'x:=x||''  ''''''||wwv_flow_lang.system_message(''SESSION_MON_BUFFER'')||'' ''''||to_char(buffer_gets,''''999G999G999G999'''') reads,module  '';',
'',
'',
'',
'x:=x||''from sys.gv_$sql s '';',
'-- Begin Predicates',
'if :P21_SEARCH is not null then',
'  p := p||''where instr(upper(sql_text),upper(:P21_SEARCH))>0 '';',
'end if;',
'',
'if :P21_MINIMUM_EXECUTIONS  is not null then',
'    if p is null then',
'        p := p||'' where '';',
'    else',
'        p := p||'' and '';',
'    end if;',
'    ',
'    p := p||''EXECUTIONS >=:P21_MINIMUM_EXECUTIONS '';',
'end if;',
'',
'if :P21_MODULE is not null then',
'    if p is null then',
'        p := p||'' where '';',
'    else',
'        p := p||'' and '';',
'    end if;',
'    p := p||'' instr(upper(module),upper(:P21_MODULE))>0 '';',
'end if;',
'',
'if p is not null then',
'    x:=x||p;',
'end if;',
'',
'-- End Predicates',
'x:=x||'' order by '';',
'',
'case :P21_TOP_BY',
'    when ''CPU_TIME'' then x:=x||'' CPU_TIME '';',
'    when ''DISK_READS'' then x:=x||'' DISK_READS '';',
'    when ''BUFFER_GETS'' then x:=x||'' BUFFER_GETS '';',
'    when ''EXECUTIONS'' then x:=x||'' EXECUTIONS '';',
'    when ''EFFICIENCY'' then x:=x||'' EFFICIENCY '';',
'    when ''EFFICIENCY2'' then x:=x||'' EFFICIENCY2 '';',
'    ',
'else x:=x||'' CPU_TIME '';',
'end case;',
'',
'',
'x:=x||''  desc nulls last) '';',
'',
'wwv_flow.debug(x);',
'',
'return x;',
'',
'end;'))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_item=>'P21_TOP_N'
,p_query_row_count_max=>10000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171388315032544852)
,p_query_column_id=>1
,p_column_alias=>'SQL_TEXT'
,p_column_display_sequence=>16
,p_column_heading=>'SQL Text'
,p_use_as_row_header=>'N'
,p_column_css_style=>'font-family:monospace;'
,p_column_hit_highlight=>'&P21_SEARCH.'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171388404157544852)
,p_query_column_id=>2
,p_column_alias=>'CPU_TIME'
,p_column_display_sequence=>5
,p_column_heading=>'CPU<br />Time in<br />Seconds'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D000'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171388519098544852)
,p_query_column_id=>3
,p_column_alias=>'DISK_READS'
,p_column_display_sequence=>7
,p_column_heading=>'Disk<br />Reads'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171388702211544853)
,p_query_column_id=>4
,p_column_alias=>'BUFFER_GETS'
,p_column_display_sequence=>8
,p_column_heading=>'Buffer<br />Gets'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171389222447544853)
,p_query_column_id=>5
,p_column_alias=>'EXECUTIONS'
,p_column_display_sequence=>9
,p_column_heading=>'Executions'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171460708330609160)
,p_query_column_id=>6
,p_column_alias=>'EFFICIENCY'
,p_column_display_sequence=>13
,p_column_heading=>'Buffer Gets<br />/ Rows<br />Processed'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189510522012751279)
,p_query_column_id=>7
,p_column_alias=>'EFFICIENCY2'
,p_column_display_sequence=>14
,p_column_heading=>'Buffer <br />Gets /<br />Executions'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171389514740544854)
,p_query_column_id=>8
,p_column_alias=>'CHILD_NUMBER'
,p_column_display_sequence=>10
,p_column_heading=>'Child Number'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171389602402544854)
,p_query_column_id=>9
,p_column_alias=>'HASH_VALUE'
,p_column_display_sequence=>11
,p_column_heading=>'Hash Value'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171389730882544854)
,p_query_column_id=>10
,p_column_alias=>'ADDRESS'
,p_column_display_sequence=>12
,p_column_heading=>'Address'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(287415608918139948)
,p_query_column_id=>11
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'<br />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(182588111320364025)
,p_query_column_id=>12
,p_column_alias=>'LINK'
,p_column_display_sequence=>2
,p_column_heading=>'<br />'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:551:&SESSION.::&DEBUG.:551:P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER:#ADDRESS#,#HASH_VALUE#,#CHILD_NUMBER#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#24find.gif" border="0" alt="" width="24" height="24" />'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189510628385751281)
,p_query_column_id=>13
,p_column_alias=>'ELAPSED_TIME'
,p_column_display_sequence=>4
,p_column_heading=>'Elapsed <br />Time in<br />Seconds'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193252116724137021)
,p_query_column_id=>14
,p_column_alias=>'THE_TIME'
,p_column_display_sequence=>3
,p_column_heading=>'Time in<br />Seconds'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193302526383187173)
,p_query_column_id=>15
,p_column_alias=>'READS'
,p_column_display_sequence=>6
,p_column_heading=>'Reads'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193326725259205755)
,p_query_column_id=>16
,p_column_alias=>'MODULE'
,p_column_display_sequence=>15
,p_column_heading=>'Module'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P21_MODULE.'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(160636525408008427)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(160632704976002525)
,p_button_name=>'P21_GO'
,p_button_static_id=>'P21_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(160636702055008428)
,p_branch_action=>'f?p=&FLOW_ID.:21:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160635519867006875)
,p_name=>'P21_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(160632704976002525)
,p_prompt=>'SQL Text'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter case insensitive query criteria on the SQL text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(161861005551431142)
,p_name=>'P21_TOP_N'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_imp.id(160632704976002525)
,p_item_default=>'10'
,p_prompt=>'Display Top'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap" style="padding-left:15px;"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the maximum number of SQL statements to display.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(171366328266454012)
,p_name=>'P21_TOP_BY'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_imp.id(160632704976002525)
,p_prompt=>'Top By'
,p_source=>'EFFICIENCY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TOP_SQL_BY'
,p_lov=>'.'||wwv_flow_imp.id(236910808625037522)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicate your report sort preference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180387913498802349)
,p_name=>'P21_MINIMUM_EXECUTIONS'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(160632704976002525)
,p_prompt=>'Minimum Executions'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap" style="padding-left:15px;"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Constrain query to SQL commands with at least this number of executions.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(192864705765667292)
,p_name=>'P21_MODULE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(160632704976002525)
,p_prompt=>'Module'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct module d, module r',
'  from sys.gv_$sql'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap" style="padding-left:15px;"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the module set by the client application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(238759409305130430)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'21'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(241565932566286195)
,p_validation_name=>'P21_MINIMUM_EXECUTIONS'
,p_validation_sequence=>10
,p_validation=>'P21_MINIMUM_EXECUTIONS'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Please enter a numeric value'
,p_associated_item=>wwv_flow_imp.id(180387913498802349)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(160637327486009049)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>160637327486009049
);
end;
/
prompt --application/pages/page_00023
begin
wwv_flow_imp_page.create_page(
 p_id=>23
,p_name=>'query builder results'
,p_alias=>'QUERY_BUILDER_RESULTS'
,p_step_title=>'query builder results'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(14599108081253832)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_proc.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4345425019330550)
,p_name=>'results'
,p_template=>wwv_flow_imp.id(12270828624874231)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_query_builder.check_priv (p_schema => :P1002_SCHEMA);',
'    return :P1002_QUERY;',
'end; '))
,p_footer=>'<span class="htmldbCSV"><a href="f?p=&APP_ID.:&APP_PAGE_ID.:&APP_SESSION.:FLOW_EXCEL_OUTPUT_R4345425019330550">Download</a></span>'
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11028007180514315)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1002_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348623393330557)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348732177330557)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348819176330557)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348911783330557)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349009268330557)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349101121330558)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349218228330558)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349303988330558)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349424164330558)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349532076330558)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349605066330558)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349732439330558)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349801732330558)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4349928913330558)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350005849330559)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350116939330559)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350207886330559)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350303267330559)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350418593330559)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350508128330559)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350601606330559)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350714454330559)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350817456330559)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4350906976330560)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4351027155330560)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4351104489330560)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4351200861330560)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4351310658330560)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4351417497330560)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4351530996330560)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4345606818330554)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4345709023330554)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4345812127330554)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4345917382330554)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346028532330554)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346124612330554)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346213755330554)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346314733330554)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346413799330555)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346503891330555)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346601482330555)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346727710330555)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346828687330555)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4346920935330555)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347001983330555)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347116666330555)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347208498330555)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347302539330555)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347422580330556)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347527682330556)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347629829330556)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347710057330556)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347807428330556)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4347902500330556)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348012066330556)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348102133330556)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348202924330557)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348327301330557)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348402381330557)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4348515291330557)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
end;
/
prompt --application/pages/page_00024
begin
wwv_flow_imp_page.create_page(
 p_id=>24
,p_name=>'Table Finder'
,p_alias=>'TABLE-FINDER'
,p_step_title=>'Table Finder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="p24_Init()"'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function p24_AppendBack(){',
'    var lValue = opener.$v(''P1003_SQL_COMMAND1'') + ''\n\n'' + $v(''qReturn'');',
'    opener.setCodeEditorValue(lValue);',
'    window.close();',
'}',
'',
'function p24_ReplaceBack(){',
'    opener.setCodeEditorValue($v(''qReturn''));',
'    window.close();',
'}',
'',
'var p24TabTest = false;',
'function p24_Init(){',
'    if(p24TabTest){',
'        $d_TabClick(''columntab'',''columnreport'',''tabcurrent'',p24Tabs)',
'    }else{',
'        $d_TabClick(''tabletab'',''tablereport'',''tabcurrent'',p24Tabs)',
'    }',
'}',
'',
'var p24Tabs = [''tabletab'',''columntab''];',
'</script>'))
,p_step_template=>wwv_flow_imp.id(203703017586195109)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/wrkshp_table_finder.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12117026009139651)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>7
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_2'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(12183729610626245)
,p_name=>'Tables'
,p_template=>wwv_flow_imp.id(42819301025617014)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_display_point=>'BODY_3'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.object_id,',
'       t.table_name,',
'       t.num_rows,',
'       t.last_analyzed,',
'       ''TABLE'' object_type',
'  from sys.user_tables t,',
'       sys.user_objects o',
' where o.object_name = t.table_name',
'   and o.object_type = ''TABLE''',
'   and (instr(upper(t.table_name), upper(:P24_FIND)) > 0 or :P24_FIND IS NULL)',
'union all',
'select o.object_id,',
'       v.view_name table_name,',
'       null num_rows,',
'       null last_analyzed,',
'       ''VIEW'' object_type',
'  from sys.user_views v,',
'       sys.user_objects o',
' where o.object_name = v.view_name',
'   and o.object_type = ''VIEW''',
'   and (instr(upper(v.view_name), upper(:P24_FIND)) > 0 or :P24_FIND IS NULL)',
'   and :P24_INCLUDE_VIEWS = ''YES'''))
,p_header=>'<div id="tablereport">'
,p_footer=>'</div>'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_item=>'P24_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>20000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12184028410626250)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12184115287626250)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:24:&SESSION.:&REQUEST.:&DEBUG.::P24_TABLE_NAME:#TABLE_NAME#'
,p_column_linktext=>'#TABLE_NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12184223295626250)
,p_query_column_id=>3
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>3
,p_column_heading=>'Rows'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40945525348156654)
,p_query_column_id=>4
,p_column_alias=>'LAST_ANALYZED'
,p_column_display_sequence=>4
,p_column_heading=>'Last Analyzed'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12184404832626251)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(12243208082566182)
,p_name=>'Columns'
,p_template=>wwv_flow_imp.id(42819301025617014)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_display_point=>'BODY_3'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name,',
'       data_type,',
'       data_length,',
'       data_precision,',
'       data_scale,',
'       nullable',
'  from sys.user_tab_columns',
' where table_name = :P24_TABLE_NAME',
' order by column_id'))
,p_display_when_condition=>'P24_TABLE_NAME'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>150000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>150000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12243500051566185)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Column'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12243616112566185)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12243703595566185)
,p_query_column_id=>3
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>3
,p_column_heading=>'Length'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12243817097566185)
,p_query_column_id=>4
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>4
,p_column_heading=>'Precision'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12243901714566185)
,p_query_column_id=>5
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>5
,p_column_heading=>'Scale'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40969229915337787)
,p_query_column_id=>6
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>6
,p_column_heading=>'Nullable'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(23482928300634173)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12257807960632350)
,p_plug_name=>'Select View'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;padding-top:10px; width:100%"'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'q2 varchar2(32767);',
'begin',
'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);',
'q2 := ''select ''||chr(10);',
'for c1 in (',
'select column_name',
'from sys.dba_TAB_COLUMNS c',
'where table_name = :P24_TABLE_NAME and',
'    c.owner = :P1003_SCHEMA',
'order by column_id) loop',
'q2 := q2 ||'' ''||wwv_flow_escape.html(c1.column_name)||'',''||chr(10);',
'end loop;',
'q2 := rtrim(rtrim(q2,chr(10)),'','')||chr(10)||'' from ''||wwv_flow_escape.html(:P24_TABLE_NAME)||chr(10);',
'sys.htp.p(''<textarea id="qReturn" style="width:100%;height:200px;">''||q2||''</textarea>'');',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P24_TABLE_NAME'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98328429053791328)
,p_plug_name=>'Open Div'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'<div>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_header=>'<div id="tables" style="clear:both;">'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98328622929791328)
,p_plug_name=>'Close Div'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>2000
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'</div>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98334600702811560)
,p_plug_name=>'Region_Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_list_id=>wwv_flow_imp.id(98332317887807047)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(108863608130594810)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98338412608824440)
,p_plug_name=>'js'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'var p24TabTest = true;',
'//-->',
'</script>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P24_TABLE_NAME'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98339511354833599)
,p_plug_name=>'Sub Div Open'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>29
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'<div id="columnreport" style="display:none;">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98339730224833600)
,p_plug_name=>'Sub Div Close'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'</div>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98520530596378377)
,p_plug_name=>'Save to Worksheet'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;padding-top:10px;"'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>45
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<button value="''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.APPEND'')||''" class="a-Button" type="button" onclick="p24_AppendBack()">''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.APPEND'')||''</button>'');',
'sys.htp.p(''<button value="''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.REPLACE'')||''" class="a-Button" type="button" onclick="p24_ReplaceBack()">''||wwv_flow_lang.system_message(''SQL_REPORT_WIZ.REPLACE'')||''</button>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P24_STATE'
,p_plug_display_when_cond2=>'SC'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div style=''padding-bottom:40px''>'
,p_plug_footer=>'</div>'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(142868013283899762)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div style="display:none;">'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12166516320262781)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(12117026009139651)
,p_button_name=>'P24_GO'
,p_button_static_id=>'P24_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12226604666243469)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(12117026009139651)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Close'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12166725687262782)
,p_branch_action=>'f?p=&APP_ID.:24:&SESSION.:&REQUEST.:&DEBUG.::p24_table_name:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12165709394260825)
,p_name=>'P24_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12117026009139651)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter query criteria and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12182711818611559)
,p_name=>'P24_INCLUDE_VIEWS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(12117026009139651)
,p_prompt=>'Views'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to include views.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12221908775216250)
,p_name=>'P24_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12117026009139651)
,p_item_default=>'15'
,p_prompt=>'Rows'
,p_source=>'15'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determines the maximum number of result rows to display for SQL queries.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12244614315567983)
,p_name=>'P24_TABLE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12243208082566182)
,p_prompt=>'Table:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies name of selected table'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14003528650686435)
,p_name=>'P24_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12117026009139651)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_post_element_text=>'&nbsp;'
,p_source=>'&P1003_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Identifies selected schema'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(142872704756906673)
,p_name=>'P24_STATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(142868013283899762)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12253126483599912)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(12166516320262781)
,p_internal_uid=>12253126483599912
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(77533228440026331)
,p_process_sequence=>1
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'POPUP FROM OB'
,p_process_sql_clob=>':P1003_SCHEMA := :P2001_FEED_OWNER;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OB'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>77533228440026331
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(432752016817981645)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>432752016817981645
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_imp_page.create_page(
 p_id=>27
,p_name=>'Search PL/SQL Source Code'
,p_alias=>'SEARCH-PL-SQL-SOURCE-CODE'
,p_step_title=>'Search PL/SQL Source Code'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276002212445738952)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_plsql.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42229710876797320)
,p_plug_name=>'Search PL/SQL Source'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>30
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       type,',
'       line,',
'       text',
'  from sys.user_source',
' where line >= nvl(:P27_FROM_LINE, 0)',
'   and line <= nvl(:P27_TO_LINE, 999999999)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P27_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(42229808451797320)
,p_name=>'Search PL/SQL Source'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(42230023926797336)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Object Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(42230117345797337)
,p_db_column_name=>'TYPE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(42230216998797338)
,p_db_column_name=>'LINE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Line'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(42230313084797338)
,p_db_column_name=>'TEXT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(42230500346797618)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1317719617536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:TYPE:LINE:TEXT'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'LINE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(163544124488204308)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(163937914275639630)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(163544124488204308)
,p_button_name=>'P27_GO'
,p_button_static_id=>'P27_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722739444901798622)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(42229710876797320)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(163938104362639631)
,p_branch_action=>'f?p=&FLOW_ID.:27:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10272119258228776)
,p_name=>'P27_FROM_LINE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(163544124488204308)
,p_prompt=>'From Line'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'To restrict the search to a range of PL/SQL object line numbers, enter the starting line number. You can then click <strong>Go</strong> or enter a final line number in the <strong>To Line</strong> field.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10272901381233082)
,p_name=>'P27_TO_LINE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(163544124488204308)
,p_prompt=>'To Line'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'To restrict the search to a range of PL/SQL object line numbers, enter the final line number to include in the search and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(163539403139131919)
,p_name=>'P27_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(163544124488204308)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(276406030441418929)
,p_computation_sequence=>10
,p_computation_item=>'P27_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema;'
,p_compute_when=>'P27_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69230410388689297)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P27_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Validate Schema'
,p_internal_uid=>69230410388689297
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_imp_page.create_page(
 p_id=>28
,p_name=>'Grid Edit of Attribute Dictionary'
,p_alias=>'GRID-EDIT-OF-ATTRIBUTE-DICTIONARY'
,p_step_title=>'Grid Edit of Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(262134402124898913)
,p_name=>'Grid Edit of Attribute Dictionary'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COLUMN_ID,',
'       COLUMN_NAME,',
'       LABEL,',
'       HELP_TEXT,',
'       FORMAT_MASK,',
'       DEFAULT_VALUE',
'  from WWV_FLOW_HNT_COLUMN_DICT',
' where security_group_id = :flow_security_group_id',
'   and (instr(column_name,upper(:P28_COLUMN_QUERY)) > 0 or',
'        :P28_COLUMN_QUERY is null)'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>20
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262134725222898919)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'COLUMN_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262134823360898920)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>30
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'COLUMN_NAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262134932029898920)
,p_query_column_id=>3
,p_column_alias=>'LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>15
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'LABEL'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262135001507898920)
,p_query_column_id=>4
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>30
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'HELP_TEXT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262135132608898920)
,p_query_column_id=>5
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>6
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'POPUP'
,p_named_lov=>wwv_flow_imp.id(197481124765787930)
,p_lov_show_nulls=>'NO'
,p_column_width=>15
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262135207815898920)
,p_query_column_id=>6
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>7
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>10
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_ref_column_name=>'DEFAULT_VALUE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(628568620310013555)
,p_query_column_id=>7
,p_column_alias=>'LINK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:P17_COLUMN_ID,F4500_LAST_VIEW:#COLUMN_ID#,28'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="">'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_derived_column=>'Y'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262141417301940636)
,p_column_sequence=>1
,p_query_column_name=>'COLUMN_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262141507017940641)
,p_column_sequence=>2
,p_query_column_name=>'COLUMN_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262141605371940641)
,p_column_sequence=>3
,p_query_column_name=>'LABEL'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262141729127940641)
,p_column_sequence=>4
,p_query_column_name=>'HELP_TEXT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262141805621940641)
,p_column_sequence=>5
,p_query_column_name=>'FORMAT_MASK'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262141907022940641)
,p_column_sequence=>6
,p_query_column_name=>'DEFAULT_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(262137418855903221)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(262138925219914472)
,p_plug_name=>'Grid Edit'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>25
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>You can only edit the general attributes about a column.  To update the form or report specific attributes, you must edit the column directly.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(262145005012974917)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(262137418855903221)
,p_button_name=>'P28_GO'
,p_button_static_id=>'P28_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(262135320808898922)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(262137418855903221)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(262148929515000904)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(262137418855903221)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RP,28::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(262135417041898922)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(262137418855903221)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(262136116677898928)
,p_branch_action=>'f?p=&APP_ID.:28:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(262143517217959511)
,p_name=>'P28_COLUMN_QUERY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(262137418855903221)
,p_prompt=>'Column Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter case insensitive search for Column Name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(262135932386898924)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(262134402124898913)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_DICT'
,p_attribute_03=>'COLUMN_ID'
,p_process_error_message=>'Unable to process update.'
,p_process_when_button_id=>wwv_flow_imp.id(262135417041898922)
,p_process_success_message=>'#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.'
,p_internal_uid=>262135932386898924
);
end;
/
prompt --application/pages/page_00029
begin
wwv_flow_imp_page.create_page(
 p_id=>29
,p_name=>'Generate DDL'
,p_alias=>'GENERATE-DDL1'
,p_page_mode=>'MODAL'
,p_step_title=>'Generate DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215532403383713875)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(82336717613137775)
,p_plug_name=>'Script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<pre class="code">'');',
'',
'if :F4500_P18_DDL_TYPE = ''OBJECT_TYPE'' then',
'    wwv_flow_generate_ddl.execute_get_ddl(',
'        p_schema             => :F4500_P18_SCHEMA,',
'        p_object_types       => :F4500_P18_OBJECT_TYPE,',
'        p_output_type        => wwv_flow_generate_ddl.c_output_to_htp,',
'        p_inc_dependent_ddls => true );',
'elsif :F4500_P18_DDL_TYPE = ''OBJECT_NAME'' then',
'    wwv_flow_generate_ddl.execute_get_ddl(',
'        p_schema             => :F4500_P18_SCHEMA,',
'        p_object_types       => :F4500_P18_OBJECT_TYPE,',
'        p_objects            => :F4500_P18_OBJECT_NAME,',
'        p_output_type        => wwv_flow_generate_ddl.c_output_to_htp,',
'        p_inc_dependent_ddls => true );',
'end if;',
'',
'sys.htp.p(''</pre>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(87151528579582262)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208285310117555084)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(87134126220568115)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(703372217110859571)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208322925662624972)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(946327948158664045)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208322925662624972)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(82681018106461976)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208322925662624972)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(87105209651530215)
,p_name=>'F4500_P18_DDL_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(82336717613137775)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(946328199192666145)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(946327948158664045)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(946328409674666146)
,p_event_id=>wwv_flow_imp.id(946328199192666145)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_imp_page.create_page(
 p_id=>30
,p_name=>'Column Attribute Synonym'
,p_alias=>'COLUMN-ATTRIBUTE-SYNONYM'
,p_page_mode=>'MODAL'
,p_step_title=>'Column Attribute Synonym'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200278631019645978)
,p_plug_name=>'Column Attribute Synonym'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1019615273077762321)
,p_plug_name=>'button region'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200279126469645983)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1019615273077762321)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200278818960645982)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1019615273077762321)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P30_SYN_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200279030745645982)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1019615273077762321)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P30_SYN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200278916710645982)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1019615273077762321)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_button_condition=>'P30_SYN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200279929766645986)
,p_branch_action=>'f?p=&APP_ID.:17:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200280111389645987)
,p_name=>'P30_SYN_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(200278631019645978)
,p_use_cache_before_default=>'NO'
,p_source=>'SYN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200280308834646002)
,p_name=>'P30_SYN_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(200278631019645978)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Synonym'
,p_source=>'SYN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Synonym of the base column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200445632275152368)
,p_name=>'P30_COLUMN_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(200278631019645978)
,p_prompt=>'Column Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The base column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200445910935155668)
,p_name=>'P30_COLUMN_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(200278631019645978)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P17_COLUMN_ID.'
,p_source=>'COLUMN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200447126912188700)
,p_validation_name=>'P30_SYN_NAME UNIQUE'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_col_dict_syn',
' where syn_name = upper(:P30_SYN_NAME)',
'   and syn_id  != nvl(:P30_SYN_ID,0)',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This name already exists as either a column or a synonym of a column.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_imp.id(200280308834646002)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1019616406385773800)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(200279126469645983)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1019616791204773802)
,p_event_id=>wwv_flow_imp.id(1019616406385773800)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(200280525520646005)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_HNT_COL_DICT_SYN'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COL_DICT_SYN'
,p_attribute_03=>'P30_SYN_ID'
,p_attribute_04=>'SYN_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>200280525520646005
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(200449613284251025)
,p_process_sequence=>50
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Column Name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select column_name',
'     from wwv_flow_hnt_column_dict',
'    where column_id = :P30_COLUMN_ID )',
'loop',
'   :P30_COLUMN_NAME := c1.column_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Failed to load column name.'
,p_process_when=>'P30_COLUMN_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>200449613284251025
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(200280709877646006)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_HNT_COL_DICT_SYN'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COL_DICT_SYN'
,p_attribute_03=>'P30_SYN_ID'
,p_attribute_04=>'SYN_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_HNT_COL_DICT_SYN.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>200280709877646006
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(200280928125646007)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'30'
,p_process_when_button_id=>wwv_flow_imp.id(200279030745645982)
,p_internal_uid=>200280928125646007
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1019616973406776824)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'close dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>1019616973406776824
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_imp_page.create_page(
 p_id=>31
,p_name=>'Script Quotas'
,p_alias=>'SCRIPT-QUOTAS'
,p_page_mode=>'MODAL'
,p_step_title=>'Script Quotas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'430'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_quotas.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150029301997796011)
,p_plug_name=>'Result Quota in Bytes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(164592024753268295)
,p_plug_name=>'Script Quota in Bytes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(755298110427836847)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(150929922265552010)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(755298110427836847)
,p_button_name=>'OK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Close'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150030705591806521)
,p_name=>'P31_SCRIPT_QUOTA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(150029301997796011)
,p_prompt=>'Maximum Script Result Size:'
,p_source=>'to_char(nvl(to_number(wwv_flow_platform.get_preference(''SQL_SCRIPT_MAX_OUTPUT_SIZE'')),2000000),''999G999G999G999G999'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the maximum allowable size for an individual script result. This size is established by an administrator and cannot be changed from within the workspace. When the maximum allowable size for a script result is reached, the running script wi'
||'ll be canceled.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150032513210808776)
,p_name=>'P31_TOTAL_QUOTA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(150029301997796011)
,p_prompt=>'Quota for All Script Results:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the amount of space allocated for script results.  This quota is established by an administrator and cannot be changed from within the workspace. When the Quota for All Scripts Results is reached, any script running will be canceled.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150033722214811335)
,p_name=>'P31_FREE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(150029301997796011)
,p_prompt=>'Free:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the available space in the workspace that can used for generating script results.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150034629833813503)
,p_name=>'P31_AVAILABLE_SPACE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(150029301997796011)
,p_prompt=>'Quota:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Identifies the percentage of script results quota currently used in the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150040021091829941)
,p_name=>'P31_USED'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(150029301997796011)
,p_prompt=>'Used'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the script results size currently used in the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164592806529272486)
,p_name=>'P31_SCRIPT_MAX_SIZE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(164592024753268295)
,p_prompt=>'Maximum Script Size:'
,p_source=>'to_char(nvl(to_number(wwv_flow_platform.get_preference(''MAX_SCRIPT_SIZE'')),2000000),''999G999G999G999G999'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the maximum allowable size for an individual script.  This quota is established by an administrator and cannot be changed from within the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(755298281503836848)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(150929922265552010)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(755298318870836849)
,p_event_id=>wwv_flow_imp.id(755298281503836848)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(150010615148724106)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Space Info at Bottom'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_max_output_size   number := 0;',
'    l_used              number := 0;',
'    l_free              number := 0;',
'begin',
'    l_max_output_size := nvl(wwv_flow_platform.get_preference(''WORKSPACE_MAX_OUTPUT_SIZE''),10000000);',
'    for c1 in (select sum(result_size) the_sum',
'                 from wwv_flow_sw_detail_results',
'                where security_group_id = :flow_security_group_id)',
'    loop',
'        l_used := nvl(c1.the_sum,0);',
'        exit;',
'    end loop;--c1',
'    ',
'    l_free := nvl(l_max_output_size - l_used,0);',
'    if sign(l_free) = -1 then',
'        l_free := 0;',
'    end if;',
'    ',
'    ',
'    ',
'    ',
'    :P31_FREE := to_char(l_free,''999G999G999G999G999'');',
'    :P31_USED := to_char(l_used,''999G999G999G999G999'');',
'    ',
'    :P31_TOTAL_QUOTA := to_char(l_max_output_size,''999G999G999G999G999'');',
'    ',
'    :P31_AVAILABLE_SPACE := wwv_flow_sw_script.draw_quotameter2(',
'                                   p_max_size       => l_max_output_size,',
'                                   p_current_size   => l_used);',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>150010615148724106
);
end;
/
prompt --application/pages/page_00032
begin
wwv_flow_imp_page.create_page(
 p_id=>32
,p_name=>'Migrate UI Defaults'
,p_alias=>'MIGRATE-UI-DEFAULTS'
,p_step_title=>'Migrate UI Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201465610401357811)
,p_plug_name=>'Migrate UI Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_id,',
'       table_name',
'  from wwv_flow_hnt_table_info',
' where schema = :P32_SCHEMA'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(201465725331357811)
,p_name=>'Migrate User Interface Defaults'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201465928362357816)
,p_db_column_name=>'TABLE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Table ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(201466128857357818)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Object Name'
,p_column_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:33:P33_TABLE_ID:#TABLE_ID#'
,p_column_linktext=>'#TABLE_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(201466523518360650)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1317820705536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TABLE_ID:SCHEMA:TABLE_NAME'
,p_sort_column_1=>'SCHEMA'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'TABLE_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201473024959465101)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206022131398886554)
,p_plug_name=>'Migration'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Migrating the table defaults for a selected table will create columns in the Attribute Dictionary for each column that does not already exist.  If conflicts are found, they will be displayed prior to migration so you can decide whether or not to p'
||'roceed.<p/>',
'',
'<p>During the migration process, the table defaults for the selected table will be removed.  This is necessary because when processes use UI Defaults, they first look for table specific defaults and use those before using the Attribute Dictionary.</p'
||'>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201473216439465161)
,p_name=>'P32_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(201473024959465101)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1003_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1003_SCHEMA ) d,',
'       :P1003_SCHEMA v',
'  from sys.dual',
' where :P1003_POPUP = 1',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(432752318680991651)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P32_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>432752318680991651
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_imp_page.create_page(
 p_id=>33
,p_name=>'Confirm Migration of UI Defaults'
,p_alias=>'CONFIRM-MIGRATION-OF-UI-DEFAULTS'
,p_step_title=>'Confirm Migration of UI Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24163417493414861)
,p_plug_name=>'No Columns to Migrate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>30
,p_plug_new_grid_column=>false
,p_plug_source=>'All the columns in this table already exist in the Attribute Dictionary.  There is nothing to migrate.'
,p_plug_query_row_template=>wwv_flow_imp.id(11028007180514315)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P33_CONFLICT_CNT'
,p_plug_display_when_cond2=>'&P33_COL_CNT.'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(201470011706404498)
,p_name=>'Conflicts'
,p_template=>wwv_flow_imp.id(717419707883820782)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name',
'  from wwv_flow_hnt_column_info',
' where table_id = :P33_TABLE_ID',
'   and column_name in (',
'       select syn_name',
'         from wwv_flow_hnt_col_dict_syn ',
'        where security_group_id = :flow_security_group_id)'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P33_CONFLICT_CNT != 0 and ',
':P33_CONFLICT_CNT != :P33_COL_CNT'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_header=>'The following columns already exist in the Attribute Dictionary as either columns or synonyms.  If you proceed, these columns will not be migrated.<p/>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201470316057404505)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201471826167427615)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>5
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201475120897520662)
,p_plug_name=>'No Conflicts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_source=>'No conflicts have been found.'
,p_plug_query_row_template=>wwv_flow_imp.id(11028007180514315)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_ZERO'
,p_plug_display_when_condition=>'P33_CONFLICT_CNT'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1019605934752642469)
,p_plug_name=>'Conflicts'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(206019507026870044)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(201471826167427615)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:33::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(206018822432836649)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(201471826167427615)
,p_button_name=>'MIGRATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Migrate'
,p_button_position=>'CREATE'
,p_button_condition=>'P33_CONFLICT_CNT'
,p_button_condition2=>'&P33_COL_CNT.'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(206019020743836651)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(206018822432836649)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24162923465397638)
,p_name=>'P33_COL_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(201471826167427615)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201471618202425322)
,p_name=>'P33_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(201470011706404498)
,p_prompt=>'Table:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_id r',
'  from wwv_flow_hnt_table_info'))
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201474527692513167)
,p_name=>'P33_CONFLICT_CNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(201471826167427615)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(24162612467375600)
,p_computation_sequence=>10
,p_computation_item=>'P33_CONFLICT_CNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_hnt_column_info',
' where table_id = :P33_TABLE_ID',
'   and column_name in (',
'       select syn_name',
'         from wwv_flow_hnt_col_dict_syn ',
'        where security_group_id = :flow_security_group_id)'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(24163027274398784)
,p_computation_sequence=>20
,p_computation_item=>'P33_COL_CNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_hnt_column_info',
' where table_id = :P33_TABLE_ID'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(206019323602846417)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'migrate'
,p_process_sql_clob=>'wwv_flow_hint.migrate(:P33_TABLE_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'UI Defaults failed to be migrated.'
,p_process_when_button_id=>wwv_flow_imp.id(206018822432836649)
,p_process_success_message=>'UI Defaults migrated to Attribute Dictionary.'
,p_internal_uid=>206019323602846417
);
end;
/
prompt --application/pages/page_00034
begin
wwv_flow_imp_page.create_page(
 p_id=>34
,p_name=>'Long Operations'
,p_alias=>'LONG-OPERATIONS'
,p_step_title=>'Long Operations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_long_opr.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467808909208767996)
,p_plug_name=>'Long Operations'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.SID, l.inst_id, l.SERIAL#,s.username,s.module,s.action,s.client_info,',
'       l.OPNAME, l.TARGET, l.TARGET_DESC, l.SOFAR, l.TOTALWORK, l.UNITS, ',
'       l.START_TIME, l.LAST_UPDATE_TIME, round((l.TIME_REMAINING/60),2) TIME_REMAINING, round((l.ELAPSED_SECONDS/60),2) ELAPSED_SECONDS, l.CONTEXT, ',
'       l.MESSAGE,       ',
'       ROUND(l.sofar/l.totalwork*100, 2) pct_complete',
'  from sys.gv_$session_longops l,sys.gv_$session s',
' where l.sid = s.sid',
'   and l.time_remaining > 0',
'   and l.inst_id = s.inst_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(467809024892767996)
,p_name=>'Long Operations'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467809228777768042)
,p_db_column_name=>'SID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'SID'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID:#SID#'
,p_column_linktext=>'#SID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467809332252768048)
,p_db_column_name=>'SERIAL#'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Serial#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467809516758768050)
,p_db_column_name=>'MODULE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Module'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467809604912768051)
,p_db_column_name=>'ACTION'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467809715440768051)
,p_db_column_name=>'CLIENT_INFO'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Client Info'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467809807576768052)
,p_db_column_name=>'OPNAME'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Operation'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467809920217768053)
,p_db_column_name=>'TARGET'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Target'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810032385768054)
,p_db_column_name=>'TARGET_DESC'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Target Desc'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810127974768055)
,p_db_column_name=>'SOFAR'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Current<br />Units'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810210590768056)
,p_db_column_name=>'TOTALWORK'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Total<br />Units'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810327085768057)
,p_db_column_name=>'UNITS'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>'Unit<br />Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810424613768058)
,p_db_column_name=>'START_TIME'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Start Time'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810517935768059)
,p_db_column_name=>'LAST_UPDATE_TIME'
,p_display_order=>13
,p_column_identifier=>'N'
,p_column_label=>'Last<br />Update<br />Time'
,p_column_type=>'DATE'
,p_format_mask=>'&TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810611827768060)
,p_db_column_name=>'TIME_REMAINING'
,p_display_order=>14
,p_column_identifier=>'O'
,p_column_label=>'Minutes<br />Remaining'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810717372768061)
,p_db_column_name=>'ELAPSED_SECONDS'
,p_display_order=>15
,p_column_identifier=>'P'
,p_column_label=>'Elapsed<br />Minutes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810805999768062)
,p_db_column_name=>'CONTEXT'
,p_display_order=>16
,p_column_identifier=>'Q'
,p_column_label=>'Context'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467811024642768064)
,p_db_column_name=>'PCT_COMPLETE'
,p_display_order=>17
,p_column_identifier=>'S'
,p_column_label=>'Percent<br /> Complete'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467810931079768063)
,p_db_column_name=>'MESSAGE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Message'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467809409633768049)
,p_db_column_name=>'USERNAME'
,p_display_order=>20
,p_column_identifier=>'C'
,p_column_label=>'Username'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19254413497333493)
,p_db_column_name=>'INST_ID'
,p_display_order=>21
,p_column_identifier=>'T'
,p_column_label=>'Instance ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(467811218476768994)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1317914265536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SID:INST_ID:MODULE:CLIENT_INFO:OPNAME:SOFAR:TOTALWORK:UNITS:START_TIME:LAST_UPDATE_TIME:TIME_REMAINING:ELAPSED_SECONDS:PCT_COMPLETE:'
);
end;
/
prompt --application/pages/page_00036
begin
wwv_flow_imp_page.create_page(
 p_id=>36
,p_name=>'About Database'
,p_alias=>'ABOUT-DATABASE'
,p_step_title=>'About Database'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_step_template=>wwv_flow_imp.id(690783120585803188)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_db_detail.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(996831560382082)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5632008088794443)
,p_name=>'Parameters'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,value param_val,ISDEFAULT,',
'       DESCRIPTION',
'  from v$parameter',
' where /* lower(name) like ''%''||lower(:P555_SEARCH)||''%''',
'   and (:P555_SHOW = ''ALL''',
'        or',
'          (:P555_SHOW = ''CUSTOM'' and isdefault = ''FALSE'')) ',
'   and */ substr(name,1,2) != ''__''',
'order by name'))
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':PARAMETER:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5632302474794468)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301369692088065005)
,p_query_column_id=>2
,p_column_alias=>'PARAM_VAL'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5632509538794469)
,p_query_column_id=>3
,p_column_alias=>'ISDEFAULT'
,p_column_display_sequence=>3
,p_column_heading=>'Is&nbsp;Default'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5632627784794469)
,p_query_column_id=>4
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>4
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(172512209864041595)
,p_name=>'Database'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME,',
'       CREATED,',
'       RESETLOGS_TIME,',
'       PRIOR_RESETLOGS_CHANGE#,',
'       PRIOR_RESETLOGS_TIME,',
'       LOG_MODE,',
'       CHECKPOINT_CHANGE#,',
'       ARCHIVE_CHANGE#,',
'       OPEN_RESETLOGS,',
'       VERSION_TIME,',
'       OPEN_MODE,',
'       PROTECTION_MODE,',
'       PROTECTION_LEVEL,',
'       REMOTE_ARCHIVE,',
'       DATABASE_ROLE,',
'       ARCHIVELOG_CHANGE#,',
'       SWITCHOVER_STATUS,',
'       DATAGUARD_BROKER,',
'       GUARD_STATUS,',
'       FORCE_LOGGING',
'  from v$database'))
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':DATABASE:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1127586271702515372)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172512609361041599)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'NAME'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172512705827041599)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>2
,p_column_heading=>'CREATED'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172512902493041599)
,p_query_column_id=>3
,p_column_alias=>'RESETLOGS_TIME'
,p_column_display_sequence=>3
,p_column_heading=>'RESETLOGS_TIME'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172513026750041599)
,p_query_column_id=>4
,p_column_alias=>'PRIOR_RESETLOGS_CHANGE#'
,p_column_display_sequence=>4
,p_column_heading=>'PRIOR_RESETLOGS_CHANGE#'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172513100737041600)
,p_query_column_id=>5
,p_column_alias=>'PRIOR_RESETLOGS_TIME'
,p_column_display_sequence=>5
,p_column_heading=>'PRIOR_RESETLOGS_TIME'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172513201718041600)
,p_query_column_id=>6
,p_column_alias=>'LOG_MODE'
,p_column_display_sequence=>6
,p_column_heading=>'LOG_MODE'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172513328511041600)
,p_query_column_id=>7
,p_column_alias=>'CHECKPOINT_CHANGE#'
,p_column_display_sequence=>7
,p_column_heading=>'CHECKPOINT_CHANGE#'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172513400321041600)
,p_query_column_id=>8
,p_column_alias=>'ARCHIVE_CHANGE#'
,p_column_display_sequence=>8
,p_column_heading=>'ARCHIVE_CHANGE#'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172514000103041600)
,p_query_column_id=>9
,p_column_alias=>'OPEN_RESETLOGS'
,p_column_display_sequence=>9
,p_column_heading=>'OPEN_RESETLOGS'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172514118014041601)
,p_query_column_id=>10
,p_column_alias=>'VERSION_TIME'
,p_column_display_sequence=>10
,p_column_heading=>'VERSION_TIME'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172514200823041601)
,p_query_column_id=>11
,p_column_alias=>'OPEN_MODE'
,p_column_display_sequence=>11
,p_column_heading=>'OPEN_MODE'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172514331382041601)
,p_query_column_id=>12
,p_column_alias=>'PROTECTION_MODE'
,p_column_display_sequence=>12
,p_column_heading=>'PROTECTION_MODE'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172514405190041601)
,p_query_column_id=>13
,p_column_alias=>'PROTECTION_LEVEL'
,p_column_display_sequence=>13
,p_column_heading=>'PROTECTION_LEVEL'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172514514003041601)
,p_query_column_id=>14
,p_column_alias=>'REMOTE_ARCHIVE'
,p_column_display_sequence=>14
,p_column_heading=>'REMOTE_ARCHIVE'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172514819520041601)
,p_query_column_id=>15
,p_column_alias=>'DATABASE_ROLE'
,p_column_display_sequence=>15
,p_column_heading=>'DATABASE_ROLE'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172514915226041602)
,p_query_column_id=>16
,p_column_alias=>'ARCHIVELOG_CHANGE#'
,p_column_display_sequence=>16
,p_column_heading=>'ARCHIVELOG_CHANGE#'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172515117807041602)
,p_query_column_id=>17
,p_column_alias=>'SWITCHOVER_STATUS'
,p_column_display_sequence=>17
,p_column_heading=>'SWITCHOVER_STATUS'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172515226718041602)
,p_query_column_id=>18
,p_column_alias=>'DATAGUARD_BROKER'
,p_column_display_sequence=>18
,p_column_heading=>'DATAGUARD_BROKER'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172515313032041602)
,p_query_column_id=>19
,p_column_alias=>'GUARD_STATUS'
,p_column_display_sequence=>19
,p_column_heading=>'GUARD_STATUS'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172515713476041603)
,p_query_column_id=>20
,p_column_alias=>'FORCE_LOGGING'
,p_column_display_sequence=>20
,p_column_heading=>'FORCE_LOGGING'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(172673725969331492)
,p_name=>'Version'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>7
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select banner from v$version'
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':VERSION:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_footer=>'<p />'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172673910997331494)
,p_query_column_id=>1
,p_column_alias=>'BANNER'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(172675002205334076)
,p_name=>'Options'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select * from v$option'
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':OPTIONS:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172675205390334077)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172675332169334078)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(172752728356379421)
,p_name=>'National Language Support'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select * from v$nls_parameters order by 1'
,p_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':NLS:'') > 0'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172752905784379422)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'National Language Parameter'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172753010951379422)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(172789621476405877)
,p_plug_name=>'CGI Environment'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.print_cgi_env',
' (p_html_table_attr=>''class="u-Report" role="presentation" cellpadding="0" cellspacing="0" border="0"'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'instr('':''||:P36_DISPLAY||'':'','':CGI:'') > 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1001305952526018)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(996831560382082)
,p_button_name=>'P36_GO'
,p_button_static_id=>'P36_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186757815719295477)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(996831560382082)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:RP,36::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1001509298526032)
,p_branch_action=>'f?p=&FLOW_ID.:36:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1000529716523424)
,p_name=>'P36_DISPLAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(996831560382082)
,p_item_default=>'VERSION'
,p_prompt=>'Display'
,p_source=>'VERSION'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P36_DISPLAY_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(998111353442494)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'7'
,p_attribute_02=>'HORIZONTAL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_imp_page.create_page(
 p_id=>37
,p_name=>'Static List of Values'
,p_alias=>'STATIC-LIST-OF-VALUES'
,p_step_title=>'Static List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(293409423986016572)
,p_name=>'Tabular Form'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       COLUMN_ID,',
'       LOV_DISP_SEQUENCE,',
'       LOV_DISP_VALUE,',
'       LOV_RETURN_VALUE',
'  from WWV_FLOW_HNT_LOV_DATA',
' where column_id = :P37_COLUMN_ID',
''))
,p_display_when_condition=>'P803_LOV_QUERY'
,p_display_condition_type=>'ITEM_IS_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(293411632557016588)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(293409717273016579)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(293417105871069157)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_column_default=>'P37_COLUMN_ID'
,p_column_default_type=>'ITEM'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'COLUMN_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(293409807959016579)
,p_query_column_id=>4
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>5
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'LOV_DISP_SEQUENCE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(293409901347016579)
,p_query_column_id=>5
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>4
,p_column_heading=>'Display Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>32
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'LOV_DISP_VALUE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(293410024985016580)
,p_query_column_id=>6
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Return Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>32
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_HNT_LOV_DATA'
,p_ref_column_name=>'LOV_RETURN_VALUE'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(293416627450069149)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(293416700260069150)
,p_column_sequence=>2
,p_query_column_name=>'COLUMN_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(293416830439069150)
,p_column_sequence=>3
,p_query_column_name=>'LOV_DISP_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(293416924320069154)
,p_column_sequence=>4
,p_query_column_name=>'LOV_DISP_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(293417027781069154)
,p_column_sequence=>5
,p_query_column_name=>'LOV_RETURN_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(293412819869019599)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(293414632121032622)
,p_plug_name=>'Static Lists of Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419046555820782)
,p_plug_display_sequence=>25
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>If you create a form, report, or tabular form that includes this column and if the appropriate Display As Type is set to use a list of values (Radio Group or Select List) then a Named List of Values will be created within the application and will '
||'be referenced by the resulting item or report column.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(424181607280659513)
,p_plug_name=>'Warning'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>12
,p_plug_source=>'You must remove the List of Values Query before defining a Static List of Values.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P803_LOV_QUERY'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1018745812043609207)
,p_plug_name=>'Edit Static List of Values'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>35
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(293410423423016582)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(293409423986016572)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Add Row'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'javascript:apex.widget.tabular.addRow();'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(293410101662016582)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(293412819869019599)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(293410205641016582)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(293412819869019599)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(293410327093016582)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(293412819869019599)
,p_button_name=>'MULTI_ROW_DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''MULTI_ROW_DELETE'');'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(293412104986016589)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(293415132383051672)
,p_name=>'P37_TABLE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(293409423986016572)
,p_prompt=>'Table:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_id r',
'  from WWV_FLOW_HNT_TABLE_INFO '))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(293415310697054883)
,p_name=>'P37_COLUMN_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(293409423986016572)
,p_prompt=>'Column Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_id r',
'  from WWV_FLOW_HNT_COLUMN_INFO'))
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'The currently selected column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(424086824998418734)
,p_validation_name=>'SequenceMand'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_null varchar2(1) := ''N'';',
'begin',
'for i in 1..wwv_flow.g_f05.count loop',
'    if wwv_flow.g_f03(i) is null',
'       then l_null := ''Y'';',
'            exit;',
'    end if;',
'end loop;',
'',
'if l_null = ''Y''',
'   then return false;',
'else ',
'   return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Sequence must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(293410205641016582)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(424102231578420636)
,p_validation_name=>'SequenceNumeric'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_check varchar2(200);',
'   l_ones  varchar2(200);',
'   l_found varchar2(1) := ''N'';',
'   ',
'begin',
'for i in 1..wwv_flow.g_f05.count',
'loop',
'   if wwv_flow.g_f03(i) is not null',
'      then l_check := wwv_flow.g_f03(i);',
'           l_check := replace(l_check,''0'',''1'');',
'           l_check := replace(l_check,''2'',''1'');',
'           l_check := replace(l_check,''3'',''1'');',
'           l_check := replace(l_check,''4'',''1'');',
'           l_check := replace(l_check,''5'',''1'');',
'           l_check := replace(l_check,''6'',''1'');',
'           l_check := replace(l_check,''7'',''1'');',
'           l_check := replace(l_check,''8'',''1'');',
'           l_check := replace(l_check,''9'',''1'');',
'           l_ones := ''1'';',
'           if l_check = lpad(l_ones,length(l_check),''1'')',
'              then null;',
'           else l_found := ''Y'';',
'                exit;',
'           end if;',
'   end if;',
'end loop;',
'',
'if l_found = ''Y''',
'   then return false;',
'else',
'   return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Sequence must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(293410205641016582)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(424102404697422319)
,p_validation_name=>'DisplayMand'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_null varchar2(1) := ''N'';',
'begin',
'for i in 1..wwv_flow.g_f05.count loop',
'    if wwv_flow.g_f04(i) is null',
'       then l_null := ''Y'';',
'            exit;',
'    end if;',
'end loop;',
'',
'if l_null = ''Y''',
'   then return false;',
'else ',
'   return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Display Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(293410205641016582)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(293411213001016585)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(293409423986016572)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_HNT_LOV_DATA'
,p_attribute_03=>'ID'
,p_process_error_message=>'Unable to process update.'
,p_process_when_button_id=>wwv_flow_imp.id(293410205641016582)
,p_process_success_message=>'#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.'
,p_internal_uid=>293411213001016585
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(293411416934016586)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(293409423986016572)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'ApplyMRD'
,p_attribute_02=>'WWV_FLOW_HNT_LOV_DATA'
,p_attribute_03=>'ID'
,p_process_error_message=>'Unable to process delete.'
,p_process_when=>'MULTI_ROW_DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'#MRD_COUNT# row(s) deleted.'
,p_internal_uid=>293411416934016586
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(293411729613016588)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(293409423986016572)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_HNT_LOV_DATA'
,p_attribute_03=>'ID'
,p_process_error_message=>'Unable to process update.'
,p_process_when_button_id=>wwv_flow_imp.id(293410423423016582)
,p_process_success_message=>'#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.'
,p_internal_uid=>293411729613016588
);
end;
/
prompt --application/pages/page_00038
begin
wwv_flow_imp_page.create_page(
 p_id=>38
,p_name=>'QB - Saved SQL'
,p_alias=>'QB_SQL_TAB'
,p_step_title=>'Saved Queries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11093307704620192)
,p_step_template=>wwv_flow_imp.id(14599108081253832)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/qry_blr_save.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159939829413099962)
,p_plug_name=>'Find Criteria'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(159940232617099966)
,p_name=>'Saved Queries'
,p_template=>wwv_flow_imp.id(12270828624874231)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   ID,',
'  initcap(substr(title,1,50)) title,',
'  last_updated_on Updated,',
'  created_by,',
'  last_UPDATED_BY,',
'  description,',
'  QUERY_OWNER schema',
'from wwv_flow_qb_saved_query',
'where security_group_id = :flow_security_group_id',
'and (:p38_find is null or instr( upper(title) ,upper(:p38_find) ) > 0 )',
'and (:p38_owner = ''0'' or created_by = :p38_owner)',
'and query_type = ''W''',
'and (created_by = :APP_USER or',
'exists (',
'select 1',
'from  wwv_flow_developers',
'where security_group_id = :flow_security_group_id and',
'userid = :APP_USER and',
'instr(developer_role||'':'',''ADMIN:'') > 0',
'union',
'select 1',
'from wwv_flow_fnd_user',
'where security_group_id = :FLOW_SECURITY_GROUP_ID',
'and user_name = :APP_USER',
'and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))'))
,p_display_when_condition=>'P38_VIEW'
,p_display_when_cond2=>'DETAIL'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(2251716882439710)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No saved SQL found'
,p_query_num_rows_item=>'P38_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159959511942138966)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Delete'
,p_use_as_row_header=>'N'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160113424849394443)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159940904414099968)
,p_query_column_id=>3
,p_column_alias=>'TITLE'
,p_column_display_sequence=>4
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1002:&SESSION.:LOAD:&DEBUG.::P1002_QUERY_ID,P1002_SCHEMA:#ID#,#SCHEMA#'
,p_column_linktext=>'#TITLE!HTML#'
,p_default_sort_column_sequence=>2
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159941115102099968)
,p_query_column_id=>4
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>7
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_default_sort_column_sequence=>1
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160107426993376207)
,p_query_column_id=>5
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>3
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159941312755099969)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>6
,p_column_heading=>'Updated by'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159941419384099969)
,p_query_column_id=>7
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>5
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160115520166404770)
,p_query_column_id=>8
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>8
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(160112712017394439)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159956320301128242)
,p_column_sequence=>2
,p_query_column_name=>'TITLE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159956508083128243)
,p_column_sequence=>3
,p_query_column_name=>'UPDATED'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(160107017342376203)
,p_column_sequence=>4
,p_query_column_name=>'CREATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159956717081128243)
,p_column_sequence=>5
,p_query_column_name=>'LAST_UPDATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159956800507128243)
,p_column_sequence=>6
,p_query_column_name=>'DESCRIPTION'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(160115421666404766)
,p_column_sequence=>7
,p_query_column_name=>'SCHEMA'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(159974622387246003)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(159939829413099962)
,p_button_name=>'GO'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT-BOTTOM'
,p_button_redirect_url=>'javascript:qb_getSavedSQL(false);'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(160019417324254067)
,p_button_sequence=>37
,p_button_plug_id=>wwv_flow_imp.id(159939829413099962)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:PPR_Tabluar_Submit(''R159940232617099966'',''4500'',''38'',''DELETE'',true,''R159940232617099966'');'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159945027925099984)
,p_branch_action=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159942102412099972)
,p_name=>'P38_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(159939829413099962)
,p_prompt=>'Owner'
,p_source=>'V(''APP_USER'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'QUERY_OWNERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r from (',
'select wwv_flow_escape.html(created_by) d, created_by r ',
'  from wwv_flow_qb_saved_query',
'where security_group_id = :flow_security_group_id',
'and exists (     ',
'select 1 ',
'from  wwv_flow_developers ',
'where security_group_id = :flow_security_group_id and ',
'      userid = :flow_user and ',
'      instr(developer_role||'':'',''ADMIN:'') > 0 ',
'union ',
'select 1 ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id ',
'and user_name = :flow_user ',
'and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')) ',
'union all  ',
'select v(''APP_USER'') d, v(''APP_USER'') r',
'FROM sys.DUAL) ',
'group by d,r',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Users -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select the owner of the query and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159942615380099976)
,p_name=>'P38_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(159939829413099962)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the string to be used in the search and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159944121760099979)
,p_name=>'P38_ROWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(159939829413099962)
,p_item_default=>'10'
,p_prompt=>'Rows'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_tag_attributes=>'style="min-width: 40px;"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of rows to display per page and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(159944614049099982)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(159940232617099966)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'Delete'
,p_attribute_02=>'WWV_FLOW_QB_SAVED_QUERY'
,p_attribute_03=>'ID'
,p_process_error_message=>'Unable to delete query'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Query Deleted'
,p_internal_uid=>159944614049099982
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(205961520224603885)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>205961520224603885
);
end;
/
prompt --application/pages/page_00039
begin
wwv_flow_imp_page.create_page(
 p_id=>39
,p_name=>'Export Attribute Dictionary'
,p_alias=>'EXPORT-ATTRIBUTE-DICTIONARY'
,p_page_mode=>'MODAL'
,p_step_title=>'Export Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(442015912779378946)
,p_name=>'Attribute Dictionary'
,p_template=>wwv_flow_imp.id(717419707883820782)
,p_display_sequence=>35
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) count_of_objects',
'  from wwv_flow_hnt_col_dict_syn',
' where security_group_id = :flow_security_group_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(617728329737082310)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(442016220478378962)
,p_query_column_id=>1
,p_column_alias=>'COUNT_OF_OBJECTS'
,p_column_display_sequence=>1
,p_column_heading=>'Count of Columns'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(717813023228832578)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(755303512721989893)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(717813023228832578)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(442016327500378963)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(717813023228832578)
,p_button_name=>'EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(442017308992378967)
,p_name=>'P39_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(442015912779378946)
,p_item_default=>'DOS'
,p_prompt=>'File Format'
,p_source=>'DOS'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI DEFAULT EXP IMP FORMATS'
,p_lov=>'.'||wwv_flow_imp.id(40883415986261937)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a file format. Options include:',
'<ul>',
'<li>Select <strong>DOS</strong> to have the lines in the resulting file terminated by carriage returns and line feeds.</li>',
'<li>Select <strong>UNIX</strong> to have the lines in the resulting file contain terminated by line feeds.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1009694976479591949)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(755303512721989893)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1009695297795591949)
,p_event_id=>wwv_flow_imp.id(1009694976479591949)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(442018605914378985)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow_gen_hint.g_mime_shown := true;',
'',
'wwv_flow_utilities.print_download_header(',
'    p_mime_type => ''application/x-sql'',',
'    p_is_attachment => true,',
'    p_file_name => lower(wwv_flow.get_company_name(p_escape=>false)) || ''_attr_dict.sql''',
');',
'',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_gen_hint.export_attr_dict(',
'    p_format => :P39_FORMAT);',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Failed to export Attribute Dictionary.'
,p_process_when_button_id=>wwv_flow_imp.id(442016327500378963)
,p_process_success_message=>'Attribute Dictionary Exported.'
,p_internal_uid=>442018605914378985
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1009695498066598038)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'close dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(442016327500378963)
,p_internal_uid=>1009695498066598038
);
end;
/
prompt --application/pages/page_00040
begin
wwv_flow_imp_page.create_page(
 p_id=>40
,p_name=>'Create Static List of Values'
,p_alias=>'CREATE-STATIC-LIST-OF-VALUES'
,p_step_title=>'Create Static List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(428880730649520691)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(428882302935520704)
,p_plug_name=>'Static Lists of Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717419046555820782)
,p_plug_display_sequence=>25
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>If you create a form, report, or tabular form that includes this column and if the appropriate Display As Type is set to use a list of values (Radio Group or Select List) then a Named List of Values will be created within the application and will '
||'be referenced by the resulting item or report column.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(428882520691520705)
,p_plug_name=>'Warning'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>12
,p_plug_source=>'You must remove the List of Values Query before defining a Static List of Values.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P803_LOV_QUERY'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(428886510649531096)
,p_name=>'Create Static List of Values'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i,',
'       ''<input type="text" size="32" maxlength="255" value="" name="f01">'' g01,',
'       ''<input type="text" size="32" maxlength="255" value="" name="f02">'' g02',
'from   wwv_flow_dual100',
'where  i < 16',
'order  by i'))
,p_display_when_condition=>'P803_LOV_QUERY'
,p_display_condition_type=>'ITEM_IS_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11028007180514315)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428886806000531122)
,p_query_column_id=>1
,p_column_alias=>'I'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428886907071531122)
,p_query_column_id=>2
,p_column_alias=>'G01'
,p_column_display_sequence=>2
,p_column_heading=>'Display Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428887001746531122)
,p_query_column_id=>3
,p_column_alias=>'G02'
,p_column_display_sequence=>3
,p_column_heading=>'Return Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1014897265161898157)
,p_plug_name=>'Create Static List of Values'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>35
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(428881105139520693)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(428880730649520691)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(428880907735520693)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(428880730649520691)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P803_LOV_QUERY'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(428884626535520896)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:37:P37_TABLE_ID,P37_COLUMN_ID:&P40_TABLE_ID.,&P40_COLUMN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(428881506826520694)
,p_name=>'P40_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(428886510649531096)
,p_prompt=>'Table:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_id r',
'  from WWV_FLOW_HNT_TABLE_INFO '))
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(428881706696520696)
,p_name=>'P40_COLUMN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(428886510649531096)
,p_prompt=>'Column Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_id r',
'  from WWV_FLOW_HNT_COLUMN_INFO'))
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'The currently selected column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(428890019138571419)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   r  varchar2(4000);',
'begin',
'for i in 1..wwv_flow.g_f01.count',
'   loop',
'      if wwv_flow.g_f01(i) is not null',
'         then',
'            r := nvl(wwv_flow.g_f02(i),wwv_flow.g_f01(i));',
'            wwv_flow_hint.create_lov_data (',
'               p_column_id          => :P40_COLUMN_ID,',
'               p_lov_disp_sequence  => i,',
'               p_lov_disp_value     => wwv_flow.g_f01(i),',
'               p_lov_return_value   => r',
'               );',
'      end if;',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating Static List of Values.'
,p_process_when_button_id=>wwv_flow_imp.id(428880907735520693)
,p_process_success_message=>'Static List of Values created.'
,p_internal_uid=>428890019138571419
);
end;
/
prompt --application/pages/page_00041
begin
wwv_flow_imp_page.create_page(
 p_id=>41
,p_name=>'Import Attribute Dictionary'
,p_alias=>'IMPORT-ATTRIBUTE-DICTIONARY'
,p_page_mode=>'MODAL'
,p_step_title=>'Import Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(442032917265604900)
,p_plug_name=>'Import Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(698586323532530546)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1019660859974192277)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(698586323532530546)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(442033115076604902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(698586323532530546)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(442036232137604924)
,p_branch_action=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(442033115076604902)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(442033523152604907)
,p_name=>'P41_FILE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(442032917265604900)
,p_prompt=>'Import File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>60
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the location of the file to be imported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(442034110950604909)
,p_name=>'P41_FILE_CHARSET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(442032917265604900)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'File Character Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(143356515285702408)||'.'
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicate the character set encoding of the file to be imported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1019661086642196097)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1019660859974192277)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1019661322310196098)
,p_event_id=>wwv_flow_imp.id(1019661086642196097)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(442035817268604922)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_title     varchar2(4000) := null;',
'  l_start     number := 0;',
'begin',
'  l_start := instr(:P41_FILE,''/'',1)+1;',
'  l_title := substr(:P41_FILE,l_start);',
'  --',
'  -- save file attributes',
'  --',
'  update wwv_flow_file_objects$ ',
'  set    title             = l_title, ',
'         description       = l_title||'' upload'',',
'         security_group_id = :flow_security_group_id,      ',
'         mime_type         = ''application/text'',',
'         created_by        = :flow_user,',
'         file_charset      = :P41_FILE_CHARSET,',
'         file_type         = ''ATTR_DICT''',
'  where name = :P41_FILE;        ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error uploading export file.'
,p_process_when_button_id=>wwv_flow_imp.id(442033115076604902)
,p_process_success_message=>'Export file uploaded.'
,p_internal_uid=>442035817268604922
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(442036004711604923)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P56_FILE_ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P41_FILE)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'  :P56_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(442033115076604902)
,p_internal_uid=>442036004711604923
);
end;
/
prompt --application/pages/page_00043
begin
wwv_flow_imp_page.create_page(
 p_id=>43
,p_name=>'Generate DDL - Object Type'
,p_alias=>'GENERATE-DDL-OBJECT-TYPE'
,p_page_mode=>'MODAL'
,p_step_title=>'Generate DDL - Object Type'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215532403383713875)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function P18_ToggleAll(e){',
'  if (e.checked){CheckAll(); }',
'  else{ClearAll();}',
'}',
'',
'function CheckAll() { ',
'  $f_CheckAll(''F4500_P18_OBJECT_TYPE_CONTAINER'',true);',
'}',
'',
'function ClearAll() {  ',
'  $f_CheckAll(''F4500_P18_OBJECT_TYPE_CONTAINER'',false);',
'}',
'</script>'))
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(85523417424861176)
,p_plug_name=>'Generate DDL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Select the object types for which you would like to generate DDL. Clicking <strong>Generate DDL</strong> generates DDL for the selected object types. To select object names for selected object types, click <strong>Next</strong>.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(87143407026576996)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(87134126220568115)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(703372217110859571)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208305201721589657)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(946273527333420312)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(208305201721589657)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(87097320371476462)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208305201721589657)
,p_button_name=>'GenerateDDL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Generate DDL'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(85539028451868614)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208305201721589657)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(85533522217866787)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(208305201721589657)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159388225398837595)
,p_branch_action=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::F4500_P18_DDL_TYPE:OBJECT_TYPE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(87097320371476462)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'(:F4500_P43_OUTPUT_TYPE = ''DISPLAY'') or (:F4500_P43_OUTPUT_TYPE2 = ''DISPLAY'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159389630770876973)
,p_branch_action=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::F4500_P45_DDL_TYPE:OBJECT_TYPE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(87097320371476462)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4500_P43_OUTPUT_TYPE'
,p_branch_condition_text=>'SCRIPT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(85539405441868615)
,p_branch_action=>'44'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(85539028451868614)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(85533911864866789)
,p_branch_action=>'18'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(85533522217866787)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11791613029493611)
,p_name=>'F4500_P43_OUTPUT_TYPE2'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_imp.id(85523417424861176)
,p_item_default=>'DISPLAY'
,p_prompt=>'Output:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DISPLAY.INLINE'
,p_lov=>'.'||wwv_flow_imp.id(88029914736461415)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_security_scheme=>wwv_flow_imp.id(11800412655616562)
,p_help_text=>'Select output format'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48184530853593205)
,p_name=>'P43_CHECK_ALL'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(85523417424861176)
,p_prompt=>'Check All'
,p_post_element_text=>'<input type="checkbox" onclick="P18_ToggleAll(this)" />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Checks all rows'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85558313530878212)
,p_name=>'F4500_P18_OBJECT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(85523417424861176)
,p_prompt=>'Object Type:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'OBJECT.TYPES3'
,p_lov=>'.'||wwv_flow_imp.id(149192410304386529)||'.'
,p_cattributes_element=>'id="objects"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the object types for which you would like to generate DDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(89861219489547759)
,p_name=>'F4500_P43_OUTPUT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(85523417424861176)
,p_item_default=>'DISPLAY'
,p_prompt=>'Output:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DISPLAY_OR_SAVE'
,p_lov=>'.'||wwv_flow_imp.id(88028228457455927)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_security_scheme=>wwv_flow_imp.id(11650706329157488)
,p_help_text=>'Select an output format.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162850203621813354)
,p_name=>'P43_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(85523417424861176)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(143356515285702408)||'.'
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'The DDL file will be encoded in the specified character set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(50956205122393401)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'43'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(85589806185896818)
,p_validation_name=>'object type not null'
,p_validation_sequence=>10
,p_validation=>'F4500_P18_OBJECT_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Object Type must be specified.'
,p_associated_item=>wwv_flow_imp.id(85558313530878212)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(238747200386108968)
,p_validation_name=>'no obj found on selected obj types'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  la_obj_types wwv_flow_global.vc_arr2;',
'  l_cnt        pls_integer := 0;',
'begin',
'	la_obj_types := wwv_flow_utilities.string_to_table2(:F4500_P18_OBJECT_TYPE);',
'	for i in 1..la_obj_types.count',
'	loop',
'    for c1 in (select count(*) cnt',
'               from sys.dba_objects',
'               where owner = :F4500_P18_SCHEMA',
'               and object_type = la_obj_types(i))',
'    loop',
'      l_cnt := l_cnt + c1.cnt;',
'    end loop;',
'  end loop; ',
'  ',
'  if l_cnt = 0 then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The selected object type(s) does not have any objects to generate DDL.'
,p_validation_condition=>'F4500_P18_OBJECT_TYPE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(85558313530878212)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(946273781692422819)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(946273527333420312)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(946274076362422820)
,p_event_id=>wwv_flow_imp.id(946273781692422819)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69944328376943484)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:F4500_P18_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69944328376943484
);
end;
/
prompt --application/pages/page_00044
begin
wwv_flow_imp_page.create_page(
 p_id=>44
,p_name=>'Generate DDL - Object Name'
,p_alias=>'GENERATE-DDL-OBJECT-NAME'
,p_page_mode=>'MODAL'
,p_step_title=>'Generate DDL - Object Name'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215532403383713875)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function ToggleAll(e){',
'  if (e.checked){CheckAll(); }',
'  else{ClearAll();}',
'}',
'',
'function CheckAll() { ',
'  html_CheckAll('''',true,document.getElementsByName(''f01''));',
'}',
'',
'function ClearAll() {  ',
'  html_CheckAll('''',false,document.getElementsByName(''f01''));',
'}',
'</script>'))
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(85613016500937615)
,p_plug_name=>'Generate DDL'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_security.current_company_can_build(p_in_schema=>:F4500_P18_SCHEMA)'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>'<p>Select the object(s) for which you would like to generate DDL.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1100180815559278538)
,p_name=>'Object List'
,p_parent_plug_id=>wwv_flow_imp.id(85613016500937615)
,p_template=>wwv_flow_imp.id(717419707883820782)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4500_P18_OBJECT_TYPE = ''DATABASE LINK'' then',
'return ''select ''''DATABASE LINK'''' object_type, wwv_flow_item.checkbox(1,db_link) ck, db_link object_name ',
'          from sys.all_db_links'';',
'else',
'return q''[with obj_type_str as (',
'    select '':''||:F4500_P18_OBJECT_TYPE||'':'' obj_type_str from sys.dual ),',
'obj_types as (',
'    select regexp_substr (',
'               obj_type_str,',
'               ''[^:]*'',',
'               instr(obj_type_str,'':'',1,level)+1 ) t',
'    from obj_type_str',
'    connect by level <= length(regexp_replace(obj_type_str,''[^:]+'',null))-1)',
'select object_type,',
'       wwv_flow_item.checkbox(1,object_name) ck,',
'       object_name',
'  from apex_sys_all_objects',
' where owner = :F4500_P18_SCHEMA',
'   and object_type in (select /*+cardinality(obj_types 1)*/ t from obj_types)',
'   and object_name not like ''BIN$%''',
'   and ( instr( object_name, upper(:P44_FILTER) ) > 0 or :P44_FILTER is null )',
' order by object_type, object_name',
']'';',
'end if;'))
,p_display_when_condition=>'wwv_flow_security.current_company_can_build(p_in_schema=>:F4500_P18_SCHEMA)'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P44_FILTER'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_plug_query_max_columns=>20
,p_query_num_rows=>6000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No objects are found.'
,p_query_row_count_max=>6000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'F4500_P18_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1100181673905278546)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(149192410304386529)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1100181728362278547)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'<input type="checkbox" onclick="ToggleAll(this)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1100181896038278548)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1100181921771278549)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'COL04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1100182078926278550)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'COL05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109715877256401701)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109715938218401702)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716080839401703)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716154046401704)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716204511401705)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716316499401706)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716482884401707)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716531693401708)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716661196401709)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716775366401710)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716807965401711)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109716935303401712)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109717038927401713)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109717177513401714)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109717273339401715)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(87149231167581025)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(87134126220568115)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(703372217110859571)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208318322976605211)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(946329872802686495)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208318322976605211)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(85623701579946048)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208318322976605211)
,p_button_name=>'Generate_DDL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Generate DDL'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(85619124651943239)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208318322976605211)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159390622374893487)
,p_branch_action=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::F4500_P18_DDL_TYPE:OBJECT_NAME'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(85623701579946048)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'(:F4500_P18_OUTPUT_TYPE = ''DISPLAY'') or (:F4500_P18_OUTPUT_TYPE2 = ''DISPLAY'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159392022636912420)
,p_branch_action=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::F4500_P45_DDL_TYPE:OBJECT_NAME'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(85623701579946048)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4500_P18_OUTPUT_TYPE'
,p_branch_condition_text=>'SCRIPT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(87117401659549150)
,p_branch_action=>'43'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(85619124651943239)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11806523652638638)
,p_name=>'F4500_P18_OUTPUT_TYPE2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(85613016500937615)
,p_prompt=>'Output:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DISPLAY_OR_SAVE'
,p_lov=>'.'||wwv_flow_imp.id(88028228457455927)||'.'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_security_scheme=>wwv_flow_imp.id(11800412655616562)
,p_help_text=>'Select output format'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(87024932721261201)
,p_name=>'F4500_P18_OBJECT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(85613016500937615)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(88539701604148954)
,p_name=>'F4500_P18_OUTPUT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(85613016500937615)
,p_use_cache_before_default=>'NO'
,p_item_default=>'DISPLAY'
,p_prompt=>'Output:'
,p_source=>'&F4500_P43_OUTPUT_TYPE.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DISPLAY_OR_SAVE'
,p_lov=>'.'||wwv_flow_imp.id(88028228457455927)||'.'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_security_scheme=>wwv_flow_imp.id(11650706329157488)
,p_help_text=>'Select an output format.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162857217735836311)
,p_name=>'P44_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(85613016500937615)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(143356515285702408)||'.'
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'The DDL file will be encoded in the specified character set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1100180268447278532)
,p_name=>'P44_FILTER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(85613016500937615)
,p_prompt=>'Filter'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a filter criteria for the object list and press enter.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(87028623232265585)
,p_computation_sequence=>10
,p_computation_item=>'F4500_P18_OBJECT_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01);'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(50954820575388422)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'44'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(87145702497579131)
,p_validation_name=>'F4500_P18_OBJECT_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'F4500_P18_OBJECT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Objects to generate DDL must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(85623701579946048)
,p_associated_item=>wwv_flow_imp.id(87024932721261201)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 01-AUG-2002 11:42'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(946330041280688776)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(946329872802686495)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(946330320441688777)
,p_event_id=>wwv_flow_imp.id(946330041280688776)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(458047418753364501)
,p_name=>'Refresh on Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P44_FILTER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(458047598803364502)
,p_event_id=>wwv_flow_imp.id(458047418753364501)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1100180815559278538)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(458047749380364504)
,p_name=>'Search on Enter'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P44_FILTER'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.keyCode === 13'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(458047813827364505)
,p_event_id=>wwv_flow_imp.id(458047749380364504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1100180815559278538)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(458047935822364506)
,p_event_id=>wwv_flow_imp.id(458047749380364504)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CANCEL_EVENT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(364066423071939822)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- check privs',
'if not wwv_flow_security.current_company_can_build(p_in_schema=>:F4500_P18_SCHEMA) then',
'    raise_application_error(-20000, ',
'    wwv_flow_lang.system_message(''WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'',',
'    :flow_user,',
'    :F4500_P18_SCHEMA)',
'    );        ',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>364066423071939822
);
end;
/
prompt --application/pages/page_00045
begin
wwv_flow_imp_page.create_page(
 p_id=>45
,p_name=>'Generate DDL'
,p_alias=>'GENERATE-DDL2'
,p_page_mode=>'MODAL'
,p_step_title=>'Generate DDL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215532403383713875)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(88228113855390371)
,p_plug_name=>'Generate DDL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208285310117555084)
,p_plug_display_sequence=>10
,p_plug_query_num_rows=>1000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fielddata">No objects are found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>'<p>Enter the name and description of the script you want created.  The SQL script will be created in the Script Repository.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(88230210704390428)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(87134126220568115)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(703372217110859571)
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208321823107614767)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(946274668663440596)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208321823107614767)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(88228611692390398)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208321823107614767)
,p_button_name=>'Save'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Script'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(88259309698403650)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208321823107614767)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(946297186978452577)
,p_branch_name=>'view SQL scripts'
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(88228611692390398)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(88259710083403653)
,p_branch_action=>'44'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(88259309698403650)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4500_P45_DDL_TYPE'
,p_branch_condition_text=>'OBJECT_NAME'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(89900713605626396)
,p_branch_action=>'43'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(88259309698403650)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4500_P45_DDL_TYPE'
,p_branch_condition_text=>'OBJECT_TYPE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(88229014845390407)
,p_name=>'F4500_P45_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(88228113855390371)
,p_prompt=>'Script Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the name of the script you are creating.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_reference_id=>140278015093574147
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(88229331393390421)
,p_name=>'F4500_P45_FILE_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(88228113855390371)
,p_source=>'sql'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(88229630927390421)
,p_name=>'F4500_P45_DESCRIPTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(88228113855390371)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<p>Enter the description of the script you are creating.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(89913509495643471)
,p_name=>'F4500_P45_DDL_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(88228113855390371)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(90136209716901753)
,p_validation_name=>'F4500_P45_FILE_TYPE Not Null'
,p_validation_sequence=>1
,p_validation=>'F4500_P45_FILE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'File Type must be specified.'
,p_associated_item=>wwv_flow_imp.id(88229331393390421)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 02-AUG-2002 15:14'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(88231113975390470)
,p_validation_name=>'script name not null'
,p_validation_sequence=>10
,p_validation=>'F4500_P45_SCRIPT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Script Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(88229014845390407)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(89505410945655253)
,p_validation_name=>'script name cannot be > 50'
,p_validation_sequence=>10
,p_validation=>'length(:F4500_P45_SCRIPT_NAME) < 50'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Script Name cannot be greater than 50 characters.'
,p_validation_condition=>'F4500_P45_SCRIPT_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(88228611692390398)
,p_associated_item=>wwv_flow_imp.id(88229014845390407)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(193110721525110034)
,p_validation_name=>'duplicate script name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_cnt pls_integer := 0;',
'begin',
'  for c1 in (select count(*) cnt',
'             from wwv_flow_files',
'             where lower(filename) = lower(:F4500_P45_SCRIPT_NAME)',
'             and file_type = ''SCRIPT'')',
'  loop',
'    l_cnt := c1.cnt;        ',
'    exit;    ',
'  end loop;',
'  ',
'  if l_cnt > 0 then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The script name exists already in your workspace.  Please enter another name.'
,p_validation_condition=>'F4500_P45_SCRIPT_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(88228611692390398)
,p_associated_item=>wwv_flow_imp.id(88229014845390407)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(946274804120442603)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(946274668663440596)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(946275146913442603)
,p_event_id=>wwv_flow_imp.id(946274804120442603)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(88338403552462715)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save ddl'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Check that the user has the appropriate privileges',
'--',
'wwv_flow_sw_api.check_priv ( p_schema => :F4500_P18_SCHEMA );',
'',
'--',
'-- if generate DDL is from page 43, pass only select object types',
'--',
'if :f4500_p45_ddl_type = ''OBJECT_TYPE'' then',
'    wwv_flow_generate_ddl.execute_get_ddl(',
'        p_schema             => :f4500_p18_schema,',
'        p_object_types       => :F4500_P18_OBJECT_TYPE,',
'        p_output_type        => wwv_flow_generate_ddl.c_output_to_script,',
'        p_filename           => :F4500_P45_SCRIPT_NAME,',
'        p_description        => :F4500_P45_DESCRIPTION,',
'        p_inc_dependent_ddls => true );',
'--',
'-- if generate DDL is from page 44, pass only select object names',
'--',
'elsif :f4500_p45_ddl_type = ''OBJECT_NAME'' then',
'    wwv_flow_generate_ddl.execute_get_ddl(',
'        p_schema       => :f4500_p18_schema,',
'        p_object_types => :F4500_P18_OBJECT_TYPE,',
'        p_objects      => :f4500_p18_object_name,',
'        p_output_type  => wwv_flow_generate_ddl.c_output_to_script,',
'        p_filename     => :F4500_P45_SCRIPT_NAME,',
'        p_description  => :F4500_P45_DESCRIPTION,',
'        p_inc_dependent_ddls => true );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error saving DDL.'
,p_process_when_button_id=>wwv_flow_imp.id(88228611692390398)
,p_process_success_message=>'DDL saved.'
,p_internal_uid=>88338403552462715
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(698586590782530548)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'DDL saved.'
,p_internal_uid=>698586590782530548
);
end;
/
prompt --application/pages/page_00056
begin
wwv_flow_imp_page.create_page(
 p_id=>56
,p_name=>'Import Attribute Dictionary'
,p_alias=>'IMPORT-ATTRIBUTE-DICTIONARY1'
,p_page_mode=>'MODAL'
,p_step_title=>'Import Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(442059416850114565)
,p_plug_name=>'Install Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_attr_dict_workspace(:P56_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The export file has been imported successfully.</p>',
'<p>If you wish to Install now, click <strong>Install</strong>.</p>',
'<p>You can also install this file at a later time by navigating to the App Builder Export Repository.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(442060817629114578)
,p_plug_name=>'Invalid File'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_source=>'File is not a valid &PRODUCT_NAME. Table Dictionary export file.'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_attr_dict_workspace(:P56_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(717815980221881011)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1019661617684203637)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(717815980221881011)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(442059610391114568)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(717815980221881011)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(442060010582114574)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(717815980221881011)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(442062111270114601)
,p_branch_action=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(442059610391114568)
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(442060230463114574)
,p_name=>'P56_FILE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(442059416850114565)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(442060601613114576)
,p_name=>'P56_EXP_WORKSPACE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(442059416850114565)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Exported from Workspace:'
,p_source=>'wwv_flow_imp_parser.get_attr_dict_workspace(:P56_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(442061730972114594)
,p_validation_name=>'check version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :P56_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'NOT COMPATIBLE (Your export may contain calls not supported by your application version.)'
,p_when_button_pressed=>wwv_flow_imp.id(442059610391114568)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1019661864828206677)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1019661617684203637)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1019662135563206678)
,p_event_id=>wwv_flow_imp.id(1019661864828206677)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(442061927469114595)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_imp_parser.parse (',
'     p_file_id => :P56_FILE_ID',
'     );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Failed to install Attribute Dictionary.'
,p_process_when_button_id=>wwv_flow_imp.id(442059610391114568)
,p_process_success_message=>'Attribute Dictionary Installed.'
,p_internal_uid=>442061927469114595
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(717815642935877734)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(442059610391114568)
,p_process_success_message=>'Attribute Dictionary Installed.'
,p_internal_uid=>717815642935877734
);
end;
/
prompt --application/pages/page_00059
begin
wwv_flow_imp_page.create_page(
 p_id=>59
,p_name=>'query builder popup'
,p_alias=>'QB_RESULTS'
,p_step_title=>'query builder results'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(14599108081253832)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3647026120165922)
,p_plug_name=>'table popup'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(12270828624874231)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_when_condition=>'TABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3689913662588164)
,p_name=>'P59_CHECK_ALL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3647026120165922)
,p_prompt=>'Check All'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'Y_NOPROMPT'
,p_lov=>'.'||wwv_flow_imp.id(88018003898325845)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="qb_CheckAllColumns(this)" onclick="this.blur()"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(3301520602864636)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the first 20 columns of this table.  You may select up to 60 columns.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3692425661657808)
,p_name=>'P59_TNAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3647026120165922)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3695017874693481)
,p_name=>'P59_PARENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3647026120165922)
,p_prompt=>'Add Parent'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TABLE_PARENTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select wwv_flow_lang.system_message(''4500_1002_QB_JOIN'')||',
' '' ''||wwv_flow_escape.html(c.column_name)||'' ''||wwv_flow_lang.system_message(''4500_1002_QB_TO'')||',
' '' ''||wwv_flow_escape.html(p.table_name)||''.''||wwv_flow_escape.html(p.column_name) d , o.object_id||''|''||p.column_name||''|''||c.column_name r ',
'from',
'       sys.dba_cons_columns c,',
'       sys.dba_cons_columns p,',
'        sys.dba_objects o,',
'      ( SELECT c.r_constraint_name pc, c.table_name cn , c.constraint_name cc, rownum',
'        FROM sys.dba_constraints c ',
'        WHERE  c.constraint_type = ''R''',
'        AND c.table_name = :P59_TNAME',
'        and c.owner = :P59_SCHEMA ) t',
'where  t.cc = c.constraint_name',
'and c.owner = :P59_SCHEMA',
'and t.pc = p.constraint_name',
'and p.owner = :P59_SCHEMA',
'and o.object_name = p.table_name',
'and o.owner = c.owner'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="qb_makeJoin(this);"'
,p_label_alignment=>'RIGHT'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from sys.dual where exists (',
' select null ',
' from sys.dba_cons_columns c, ',
' 	  sys.dba_cons_columns p,',
'	  ( SELECT p.table_name pn, p.constraint_name pc, c.table_name cn , c.constraint_name cc ,o.object_id ,o.object_name',
'	    FROM sys.dba_constraints p, sys.dba_constraints c , sys.dba_objects o ',
'	    WHERE (p.constraint_type = ''P'' OR p.constraint_type = ''U'') ',
'		AND c.constraint_type = ''R'' ',
'		AND p.constraint_name = c.r_constraint_name ',
'		AND c.table_name = UPPER(:P59_TNAME) ',
'		and p.owner = :P59_SCHEMA',
'		and o.object_name = p.table_name',
'		and o.owner = p.owner',
'                and p.owner = c.owner) t',
'where t.cc = c.constraint_name',
'and t.pc = p.constraint_name',
'and c.owner = :P59_SCHEMA',
'and p.owner = c.owner ',
')'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(3301520602864636)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a related parent table to be added to your query.  The parent tables displayed are tables that the current table references.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3695901382698165)
,p_name=>'P59_CHILDREN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3647026120165922)
,p_prompt=>'Add Child'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TABLE_CHILDREN'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''4500_1002_QB_JOIN'')||',
'       '' ''||wwv_flow_escape.html(p.column_name)||',
'       '' ''||wwv_flow_lang.system_message(''4500_1002_QB_TO'')||',
'       '' ''||wwv_flow_escape.html(c.table_name)||''.''||wwv_flow_escape.html(c.column_name) d , t.cid||''|''||c.column_name||''|''||p.column_name r',
'  from sys.dba_cons_columns c,',
'       sys.dba_cons_columns p,',
'       sys.dba_objects o,',
'       ( select c.r_constraint_name pc, ',
'                c.table_name cn, ',
'                c.constraint_name cc,',
'                oo.object_id cid, ',
'                rownum',
'           from sys.dba_constraints c,',
'                sys.dba_objects oo',
'          where c.constraint_type = ''R''',
'            and c.owner = :P59_SCHEMA',
'            and oo.object_name = c.table_name',
'            and oo.owner = c.owner ) t',
' where t.cc             = c.constraint_name',
'   and c.owner          = :P59_SCHEMA',
'   and t.pc             = p.constraint_name',
'   and p.owner          = :P59_SCHEMA',
'   and p.table_name     = :P59_TNAME ',
'   and o.object_name    = p.table_name',
'   and o.owner          = c.owner'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="qb_makeJoin(this);"'
,p_label_alignment=>'RIGHT'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from dual where exists (',
' select null',
' from sys.dba_cons_columns c,',
' 	  sys.dba_cons_columns p,',
'	  ( SELECT p.table_name pn, p.constraint_name pc, c.table_name cn , c.constraint_name cc ,o.object_id ,o.object_name',
'	    FROM sys.dba_constraints p, sys.dba_constraints c , sys.dba_objects o',
'	    WHERE (p.constraint_type = ''P'' OR p.constraint_type = ''U'')',
'		AND c.constraint_type = ''R''',
'		AND p.constraint_name = c.r_constraint_name',
'		AND p.table_name = UPPER(:P59_TNAME)',
'		and p.owner = :P59_SCHEMA',
'		and o.object_name = c.table_name',
'		and o.owner = p.owner',
'                and p.owner = c.owner) t',
'where t.cc = c.constraint_name',
'and t.pc = p.constraint_name',
'and c.owner = :P59_SCHEMA',
'and p.owner = c.owner',
')'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(3301520602864636)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a related child table to be added to your query.  The child tables displayed reference the primary key of this table.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3700222909808461)
,p_name=>'P59_SCHEMA'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3647026120165922)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4335521893253922)
,p_name=>'P59_BUTTON'
,p_item_sequence=>0
,p_item_plug_id=>wwv_flow_imp.id(3647026120165922)
,p_item_default=>'<img src="#IMAGE_PREFIX#qb/vertical_close.png" onclick="qb_tablePopup(this)" style="float:right;" />'
,p_source=>'<img class="htmldbPseudoButton" src="#IMAGE_PREFIX#qb/vertical_close.png" onclick="qb_close(this)" style="float:right;" />'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML_UNSAFE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3723413137900295)
,p_computation_sequence=>10
,p_computation_item=>'P59_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1002_SCHEMA'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00060
begin
wwv_flow_imp_page.create_page(
 p_id=>60
,p_name=>'Script Editor'
,p_alias=>'SCRIPT-EDITOR'
,p_step_title=>'Script Editor'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213236600761856491)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'htmldb_dup_script_name=''"DUP_SCRIPT_NAME"'';',
'htmldb_rename_script_name=''"RENAME_SCRIPT_NAME"'';',
'htmldb_null_script_name=''"NULL_SCRIPT_NAME"'';',
'htmldb_null_script=''"NULL_SCRIPT"'';',
'',
'let g_run = false;',
'',
'',
'function gStoreScript(req, run, cb) {',
'  let plsqlCode, scriptLength,',
'    saveNew = false,',
'    maxLength = $v("P60_MAX_LENGTH"),',
'    fileID = $v("P60_FILE_ID"),',
'    scriptName = $v("P60_SCRIPT_NAME");',
'',
'  const alertOption = {',
'    style: "warning"',
'  };',
'',
'  function dupNameCheck(cb) {',
'    let status = "";',
'    apex.server.process( "sr_dup_name", {',
'        pageItems: ["P60_SCRIPT_NAME", "P60_OLD_SCRIPT_NAME", "P60_FILE_ID"]',
'    }, {',
'      dataType: "text"',
'    }).done(function(data) {',
'      if ( data.substr(0,11) == ''FAIL_RENAME'' ) {',
'        status = "FAIL_RENAME";',
'      } else if ( data.substr(0,4) == ''FAIL'' ) {',
'        status = "FAIL";',
'      } else if ( data.substr(0,8) == ''SAVE_NEW'' ) {',
'        status = "SAVE_NEW";',
'      } else {',
'        status = "SUCCESS";',
'      }',
'    }).always(function() {',
'      cb(status);',
'    });',
'  }',
'',
'  function doSave() {',
'    apex.builder.plugin.codeEditor.saveProcess("#codeEditor_widget", "STORE_SCRIPT", "f01", {f02: fileID,f03: scriptName})',
'      .always(function() {',
'          cb(saveNew);',
'      });',
'  }',
'',
'  plsqlCode = $("#codeEditor_widget").codeEditor("getValue");',
'  scriptLength = plsqlCode.length;',
'',
'  if (!scriptName) {',
'    apex.message.alert( htmldb_null_script_name, () => {}, alertOption);',
'    return false;',
'  }',
'  if (!plsqlCode) {',
'    apex.message.alert( htmldb_null_script, () => {}, alertOption); ',
'    return false;',
'  }',
'  ',
'  if (req !== ''GET'' && req !== ''REPLACE'') {',
'    if (scriptLength > maxLength) {  ',
'',
'     let scriptLengthFormated = apex.locale.formatNumber( scriptLength, "999G999G999G999G990" );',
'     let maxLengthFormated = apex.locale.formatNumber( maxLength, "999G999G999G999G990" );',
'',
'     apex.message.alert(apex.lang.formatMessage( "SCRIPT.MAX_SCRIPT_SIZE",maxLengthFormated, scriptLengthFormated ),() => {}, alertOption);',
'     return false;',
'    }',
' ',
'    dupNameCheck(function(status) {',
'      if (status == ''FAIL'') {',
'        g_run = run;',
'        apex.theme.openRegion("saveDialog");',
'        return;',
'      } else if (status == ''FAIL_RENAME'') {',
'        apex.message.alert( htmldb_rename_script_name, () => {}, alertOption);',
'        return;',
'      } else if (status == ''SAVE_NEW'' && req != ''CREATE'') {',
'        saveNew = true;',
'      }',
'      doSave()',
'    });',
'  } else {',
'      doSave()',
'  }',
'',
'  return true;',
'}',
'',
'',
'$(document).on("apexreadyend", function() {',
'  apex.jQuery(".a-Body, .a-Main, #codeEditor, #codeEditor > .a-Region-body, .a-MonacoEditor").addClass("resize");',
'  apex.theme.pageResizeInit();',
'});'))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_rep.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8319409375555186)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(133086723654895090)
,p_plug_name=>'Edit Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_sw_api.g_raise_errors'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(138352509674476936)
,p_plug_name=>'Save Script'
,p_region_name=>'saveDialog'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>50
,p_plug_source=>'<p>A script with this name already exists. Do you wish to overwrite it?</p>'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(657007663334142125)
,p_plug_name=>'Script'
,p_region_name=>'codeEditor'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob001',
'  from wwv_flow_collections',
' where collection_name = ''APEX_4500_60'''))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'DDL',
  'attribute_02', '30',
  'attribute_03', 'N',
  'attribute_04', 'VARCHAR2')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138359330068530191)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(138352509674476936)
,p_button_name=>'CANCEL'
,p_button_static_id=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(138360700895540644)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(138352509674476936)
,p_button_name=>'YES'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Yes'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(108477306269478215)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(929194157205394205)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_button_name=>'SAVE_ONLY'
,p_button_static_id=>'saveButton'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Save'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(133097724606939967)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_button_name=>'SAVE'
,p_button_static_id=>'saveButton'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Save'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(133522817791564007)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(106549728476820975)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_button_name=>'DOWNLOAD_SCRIPT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--gapRight'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Download'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91124011966862772)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(70905955607824816)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_button_name=>'CREATE_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Create App'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:RP,20:P20_SCRIPT_FILE_ID:&P60_FILE_ID.'
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(106937316772503576)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_button_name=>'RUN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164269527228796320)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_button_name=>'CREATE_RUN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P60_FILE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(106937509658503599)
,p_branch_action=>'f?p=&APP_ID.:1022:&SESSION.::&DEBUG.::P1022_FILE_ID:&P60_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'((wwv_flow_sw_parser.parsed(:P60_FILE_ID) = 1) and (wwv_flow_sw_script.invalid_script(:P60_FILE_ID) = 1)) AND :REQUEST in (''RUN'',''REPLACE_RUN'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107280029269051559)
,p_branch_action=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::F4500_P10_FILE_ID:&P60_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'((wwv_flow_sw_parser.parsed(:P60_FILE_ID) = 1) and (wwv_flow_sw_script.invalid_script(:P60_FILE_ID) = 0)) AND :REQUEST in (''RUN'',''REPLACE_RUN'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107281716933057420)
,p_branch_action=>'f?p=&APP_ID.:1023:&SESSION.::&DEBUG.::P1023_FILE_ID:&P60_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'((wwv_flow_sw_parser.parsed(:P60_FILE_ID) = 0)) AND :REQUEST in (''RUN'',''REPLACE_RUN'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11486929047542446)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(108548416854020696)
,p_name=>'P60_STORE_TEMP_SCRIPT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(133086723654895090)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(133366221073346269)
,p_name=>'P60_MAX_LENGTH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(133086723654895090)
,p_source=>'nvl(wwv_flow_platform.get_preference(''MAX_SCRIPT_SIZE''),500000)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(133520024029557477)
,p_name=>'P60_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(133086723654895090)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138327500427906596)
,p_name=>'P60_OLD_SCRIPT_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'from wwv_flow_files',
'where id = :P60_FILE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(139587000222243903)
,p_name=>'P60_SCRIPT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8319409375555186)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Script Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'from wwv_flow_files',
'where id = :P60_FILE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>35
,p_cMaxlength=>70
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter Name of the script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929194302076394207)
,p_name=>'Save'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(133097724606939967)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929194434908394208)
,p_event_id=>wwv_flow_imp.id(929194302076394207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''SAVE'', false, function(saveNew) {',
'  apex.server.process(saveNew ? "sr_create_script" : "sr_save_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      apex.submit(''PARSE'');',
'    }',
'  });',
'});',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929194586508394209)
,p_name=>'Save Only'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(929194157205394205)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929194699358394210)
,p_event_id=>wwv_flow_imp.id(929194586508394209)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''SAVE'', false, function(saveNew) {',
'  apex.server.process(saveNew ? "sr_create_script" : "sr_save_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      $("#codeEditor_widget").codeEditor("showNotification", ',
'        "<ul><li class=''is-success''>" + apex.util.escapeHTML(apex.lang.getMessage("SCRIPTS.CHANGES_SAVED")) + "</li></ul>");',
'    }',
'  });',
'});',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929194857449394212)
,p_name=>'Download'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(106549728476820975)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929194943733394213)
,p_event_id=>wwv_flow_imp.id(929194857449394212)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''GET'', false, function() {',
'  apex.submit(''DOWNLOAD'');',
'});',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929195078635394214)
,p_name=>'Delete'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(91124011966862772)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929195113281394215)
,p_event_id=>wwv_flow_imp.id(929195078635394214)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.confirm(htmldb_delete_message,''DELETE'');'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929195268604394216)
,p_name=>'Create'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(108477306269478215)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929195320595394217)
,p_event_id=>wwv_flow_imp.id(929195268604394216)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''CREATE'', false, function() {',
'  apex.server.process("sr_create_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      apex.submit(''PARSE'');',
'    }',
'  });',
'});',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929195456922394218)
,p_name=>'Run'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(106937316772503576)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929195536549394219)
,p_event_id=>wwv_flow_imp.id(929195456922394218)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''SAVE'', true, function(saveNew) {',
'  apex.server.process(saveNew ? "sr_create_script" : "sr_save_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      apex.submit(''RUN'');',
'    }',
'  });',
'});',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929195655906394220)
,p_name=>'Create Run'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(164269527228796320)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929195719790394221)
,p_event_id=>wwv_flow_imp.id(929195655906394220)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'gStoreScript(''CREATE'', true, function() {',
'  apex.server.process("sr_create_script", {}, {',
'    dataType: "",',
'    success: function() {',
'      apex.submit(''RUN'');',
'    }',
'  });',
'});',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929196268004394226)
,p_name=>'Update save button'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P60_SCRIPT_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P60_FILE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929196339444394227)
,p_event_id=>wwv_flow_imp.id(929196268004394226)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#saveButton")[0].disabled = $v("P60_SCRIPT_NAME") !== $v("P60_OLD_SCRIPT_NAME");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929196462393394228)
,p_name=>'Cancel'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(138359330068530191)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929196557267394229)
,p_event_id=>wwv_flow_imp.id(929196462393394228)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(138352509674476936)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929196601940394230)
,p_name=>'Save and replace'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(138360700895540644)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929196718724394231)
,p_event_id=>wwv_flow_imp.id(929196601940394230)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.theme.closeRegion("saveDialog");',
'gStoreScript("REPLACE", g_run, function(saveNew) {',
'  apex.server.process("sr_replace_script", {}, {',
'    dataType: "",',
'    success: function() {',
'        apex.submit(g_run ? "REPLACE_RUN" : "PARSE");',
'    }',
'  });',
'});',
''))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(91125406557870640)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_files',
'where id = :P60_FILE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete the script.'
,p_process_when_button_id=>wwv_flow_imp.id(91124011966862772)
,p_process_success_message=>'Script deleted.'
,p_internal_uid=>91125406557870640
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107296117288133287)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clob        clob;',
'  l_script_name varchar2(4000) := null;',
'begin',
'  for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'             from htmldb_collections',
'             where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'    l_clob := c1.script;',
'    l_script_name := c1.name;           ',
'  end loop;',
'  if instr(l_script_name,''.sql'',1) = 0 then',
'  	l_script_name := l_script_name||''.sql'';',
'  end if;',
'  wwv_flow_init_htp_buffer;',
'  wwv_flow.g_page_text_generated := true;',
'  wwv_flow.g_unrecoverable_error := true;',
'  ',
'  wwv_flow_utilities.print_download_header(',
'    p_mime_type =>     ''text/plain'',',
'    p_file_name =>     l_script_name,',
'    p_is_attachment => true',
'  );',
'  ',
'  sys.owa_util.http_header_close;',
'  ',
'  wwv_flow_sw_script.print_clob(p_str => l_clob);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to download script.'
,p_process_when=>'DOWNLOAD'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>107296117288133287
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164287405457168586)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set file_id for create and run'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select clob001 script, c001 file_id',
'           from htmldb_collections',
'           where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'    :P60_FILE_ID := c1.file_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'RUN'
,p_process_when_type=>'NEVER'
,p_internal_uid=>164287405457168586
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(251810317427563975)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set file_id for replace and run'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select clob001 script, c001 file_id, c002 name                   ',
'             from htmldb_collections',
'             where collection_name = ''SR_SCRIPT_SOURCE'') loop',
'      for c2 in (select id',
'                 from wwv_flow_files',
'                 where lower(filename) = lower(c1.name)',
'                 and file_type = ''SCRIPT'')',
'      loop',
'          l_file_id := c2.id;',
'          exit;',
'      end loop; ',
'      :P60_FILE_ID := l_file_id;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'REPLACE_RUN,RUN'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>251810317427563975
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(657008053639142129)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert BLOB to CLOB'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob         clob;',
'    l_dest_offsset integer := 1;',
'    l_src_offsset  integer := 1;',
'    l_lang_context integer := sys.dbms_lob.default_lang_ctx;',
'    l_warning      integer;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX_4500_60'' );',
'    for c1 in ( select blob_content, file_charset',
'                from wwv_flow_files',
'                where id = :P60_FILE_ID ) loop',
'        sys.dbms_lob.createTemporary(lob_loc => l_clob,cache => false);',
'',
'        sys.dbms_lob.converttoclob(',
'            dest_lob     => l_clob,',
'            src_blob     => c1.blob_content,',
'            amount       => sys.dbms_lob.lobmaxsize,',
'            dest_offset  => l_dest_offsset,',
'            src_offset   => l_src_offsset,',
'            blob_csid    => nvl( nls_charset_id( wwv_flow_lang.map_db_charset( c1.file_charset ) ), sys.dbms_lob.default_csid ),',
'            lang_context => l_lang_context,',
'            warning      => l_warning',
'        );',
'        --if l_warning is null then',
'            wwv_flow_collection.add_member( p_collection_name => ''APEX_4500_60'',',
'                                        p_clob001         => l_clob );',
'        --end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'PREPOPULATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>657008053639142129
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(929194220744394206)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'STORE_SCRIPT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob := empty_clob;',
'    l_file_id     number := null;',
'    l_script_name varchar2(4000) := null;',
'begin    ',
'    sys.dbms_lob.createtemporary( l_code, false, sys.dbms_lob.SESSION );',
'',
'    htmldb_collection.create_or_truncate_collection(',
'        p_collection_name => ''SR_SCRIPT_SOURCE'');',
'',
'    for i in 1..wwv_flow.g_f01.count loop   	   ',
'        sys.dbms_lob.writeappend(l_code,length(wwv_flow.g_f01(i)),wwv_flow.g_f01(i));        ',
'    end loop;',
'',
'    l_file_id := wwv_flow_sw_script.array_element(wwv_flow.g_f02,1);',
'    if l_file_id is null then',
'      l_file_id := wwv_flow_id.next_val;',
'    end if;',
'    l_script_name := wwv_flow_sw_script.array_element(wwv_flow.g_f03,1);',
'',
'    htmldb_collection.add_member(',
'        p_collection_name => ''SR_SCRIPT_SOURCE'',',
'        p_c001            => l_file_id,',
'        p_c002            => l_script_name,',
'        p_clob001         => l_code);',
'',
'    sys.owa_util.status_line(204, ''No Content'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>929194220744394206
);
end;
/
prompt --application/pages/page_00064
begin
wwv_flow_imp_page.create_page(
 p_id=>64
,p_name=>'SQL Developer Web'
,p_alias=>'SQL-DEVELOPER-WEB'
,p_page_mode=>'MODAL'
,p_step_title=>'SQL Developer Web'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(690782249755803171)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'340'
,p_dialog_width=>'480'
,p_dialog_attributes=>'resizable:true'
,p_protection_level=>'C'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1508595643948502)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Alert--noTitle a-Alert--flushed'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--noIcon:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>30
,p_plug_source=>'You can access your REST-enabled schemas using SQL Developer Web. Select a REST-enabled schema below to get started.'
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'SDW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5601054909162408)
,p_plug_name=>'Workspace Schemas'
,p_region_name=>'sdw_schema_list'
,p_region_sub_css_classes=>'a-MediaList--alignMiddle'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(11631195554192189)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'SDW'
,p_landmark_type=>'exclude_landmark'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5604602132162444)
,p_plug_name=>'Hidden Items'
,p_plug_display_sequence=>80
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15904939241699740)
,p_plug_name=>'Connecting'
,p_region_css_classes=>'margin-none padding-bottom-none a-Alert--inlineDialog u-tC a-Alert--noTitle'
,p_icon_css_classes=>'icon-rest-services u-success-text'
,p_region_template_options=>'a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>70
,p_plug_source=>'<span id="autoconnect_message">Opening Schema <strong>&P64_DB_SCHEMA.</strong> in SQL Developer Web...</span>'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'SDW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5601546128162413)
,p_name=>'P64_DB_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5604602132162444)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5604703908162445)
,p_name=>'P64_EXCHANGE_URL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5604602132162444)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5604823467162446)
,p_name=>'P64_EXCHANGE_BODY'
,p_data_type=>'CLOB'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5604602132162444)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5400685025007006)
,p_name=>'Invoke SDW'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P64_EXCHANGE_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5400706838007007)
,p_event_id=>wwv_flow_imp.id(5400685025007006)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// get text from alert body and trim unnecessary \n and blanks  ',
'const lMessage = $("#autoconnect_message").text().replace(/^\s+|\s+$/g, ''''); ',
'',
'const lSpinner$ = apex.util.showSpinner($("body"),{alert:lMessage}),',
'    lRequest = new Request(apex.items.P64_EXCHANGE_URL.value, {',
'        method: ''POST'',',
'        headers: {',
'            ''Content-type'': ''application/x-www-form-urlencoded''',
'        },',
'        body: apex.items.P64_EXCHANGE_BODY.value',
'    }),',
'    lResponse = fetch(lRequest);',
'',
'lResponse.then(async (res) => {',
'    if (res.ok) {',
'        apex.navigation.openInNewWindow(res.url);',
'        apex.navigation.dialog.close(true);',
'        return Promise.resolve();',
'    } else {',
'        return Promise.reject(await new Response(res.body).json());',
'    }',
'}).catch((err) => {',
'    apex.message.showErrors([',
'        {',
'            type: "error",',
'            location: "page",',
'            message: err.message,',
'            techInfo: [{',
'                name: apex.lang.formatMessage( "SDW_ERROR_CAUSE" ),',
'                value: err.cause',
'            },',
'            {',
'                name: apex.lang.formatMessage( "SDW_ERROR_ACTION" ),',
'                value: err.action',
'            }],',
'            unsafe: true',
'        }',
'    ]);',
'}).finally((data) => {',
'    lSpinner$.remove();',
'});'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5400836657007008)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Session State'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_process_when=>'SDW'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>5400836657007008
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5400268228007002)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'init schema list collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'   :P64_DB_SCHEMA := wwv_flow_listener.init_sdw_schema_list;',
'   if :P64_DB_SCHEMA is not null then',
'      wwv_flow.g_request    := ''SDW'';',
'   end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'SDW'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>5400268228007002
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5603985333162437)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'init ORDS params'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ords_metadata.ords_apex_sso.generate_exchange_token(',
'    p_schema        => :P64_DB_SCHEMA,',
'    p_subject       => ''APEX/'' || :WORKSPACE_ID || ''/'' || :APP_USER,',
'    p_exchange_url  => :P64_EXCHANGE_URL,',
'    p_exchange_body => :P64_EXCHANGE_BODY );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invoking SQL Developer Web call failed.'
,p_process_when=>'SDW'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>5603985333162437
);
end;
/
prompt --application/pages/page_00065
begin
wwv_flow_imp_page.create_page(
 p_id=>65
,p_name=>'Export SQL Scripts'
,p_alias=>'EXPORT-SQL-SCRIPTS'
,p_step_title=>'Export SQL Scripts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_transfer.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(221594212518002207)
,p_name=>'Scripts'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'  f.id,',
'  substr(f.filename,1,50) t,',
'  f.created_by,',
'  nvl(f.updated_on,f.created_on) updated,',
'  f.doc_size doc_size',
'from wwv_flow_files f, wwv_flow_fnd_user u',
'where u.security_group_id = :flow_security_group_id',
'and u.user_name = :APP_USER',
'and f.file_type = ''SCRIPT''',
'and (f.created_by = :P65_OWNER or nvl(:P65_OWNER,''0'') = ''0'')',
'and (instr(upper(f.filename||''\\''||f.created_by||''\\''||f.updated_by),',
'     upper(:P65_SCRIPT))>0',
'     or :P65_SCRIPT is null)',
'and f.id not in (select n001 script_id',
'                 from htmldb_collections',
'                 where collection_name = ''SCRIPTS_TO_EXPORT'' )'))
,p_header=>'<p>Use this page to export one or more scripts for importing into another workspace.</p>'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No scripts found'
,p_query_num_rows_item=>'P65_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(221594526240002215)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(240505720206614239)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(221594728717002215)
,p_query_column_id=>2
,p_column_alias=>'T'
,p_column_display_sequence=>4
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(221594910026002215)
,p_query_column_id=>3
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>3
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(221595021213002216)
,p_query_column_id=>4
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>5
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(221595214182002216)
,p_query_column_id=>5
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>6
,p_column_heading=>'Bytes'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(240504819167613940)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(240505025462613941)
,p_column_sequence=>2
,p_query_column_name=>'T'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(240505123175613941)
,p_column_sequence=>3
,p_query_column_name=>'CREATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(240505213863613941)
,p_column_sequence=>4
,p_query_column_name=>'UPDATED'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(240505331731613941)
,p_column_sequence=>5
,p_query_column_name=>'DOC_SIZE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(223023600623732430)
,p_name=>'Scripts to Export'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox(4,n001) script_id, c003 script_name, c002 script_owner',
'from wwv_flow_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No scripts have been selected for export.  Check the scripts you wish to export and then click <strong>Add To Export</strong>.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(240515522022631840)
,p_query_column_id=>1
,p_column_alias=>'SCRIPT_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Remove'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(223024030248732761)
,p_query_column_id=>2
,p_column_alias=>'SCRIPT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236919731229100888)
,p_query_column_id=>3
,p_column_alias=>'SCRIPT_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(240515215620631836)
,p_column_sequence=>1
,p_query_column_name=>'SCRIPT_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(240511510731622913)
,p_column_sequence=>2
,p_query_column_name=>'SCRIPT_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(240511619091622913)
,p_column_sequence=>3
,p_query_column_name=>'SCRIPT_OWNER'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(851296250267898501)
,p_plug_name=>'Export SQL Scripts'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>1
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1141996850168158802)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(221626407641123826)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1141996850168158802)
,p_button_name=>'P65_GO'
,p_button_static_id=>'P65_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(237021909392643306)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(223023600623732430)
,p_button_name=>'REMOVE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Remove Checked'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 e',
'from htmldb_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(236922711190123460)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(223023600623732430)
,p_button_name=>'EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export All'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 e',
'from htmldb_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(238488908509330323)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(851296250267898501)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(221610015943050593)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(851296250267898501)
,p_button_name=>'ADD_TO_EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add To Export'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(221610220380050594)
,p_branch_action=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(238489106074330326)
,p_branch_action=>'f?p=&FLOW_ID.:1004:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(238488908509330323)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(221614211488077690)
,p_name=>'P65_SCRIPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1141996850168158802)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Find scripts by script name, owner or updated by.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(221617207810086022)
,p_name=>'P65_OWNER'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(1141996850168158802)
,p_prompt=>'Owner'
,p_source=>'APP_USER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_USERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || wwv_flow_lang.system_message(''ALL_USERS'') || '' -'' d, ''0'' r',
'  from sys.dual',
' where exists (',
'    select null',
'      from  wwv_flow_developers ',
'     where security_group_id = :flow_security_group_id ',
'       and userid = :flow_user ',
'       and instr(developer_role||'':'',''ADMIN:'') > 0)',
'union all',
'select user_name d, user_name r',
'  from wwv_flow_fnd_user',
' where security_group_id = :flow_security_group_id',
'   and (user_name = :flow_user or exists',
'        (select null from wwv_flow_developers',
'          where security_group_id = :flow_security_group_id',
'            and userid = :flow_user',
'            and instr(developer_role||'':'',''ADMIN:'') > 0))',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the owner of the scripts you want to view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(221619030666092658)
,p_name=>'P65_ROWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1141996850168158802)
,p_item_default=>'10'
,p_prompt=>'Rows'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the number of rows to display per page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(239423928369687764)
,p_name=>'P65_FILE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(223023600623732430)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lower(wwv_flow.get_company_name(p_escape=>false))||''_script.sql''',
''))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'File Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from htmldb_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Save the generated script export as this file name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(238654020553478736)
,p_validation_name=>'must select at least one script'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f04.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one script to export'
,p_when_button_pressed=>wwv_flow_imp.id(237021909392643306)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(221625026903119899)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>221625026903119899
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(223021505855686598)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add selected members to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_f01  number := null;',
'  ',
'  function array_element( ',
'      p_vcarr in wwv_flow_global.vc_arr2,',
'      p_index in number )',
'      return varchar2',
'  is',
'      l_return_value varchar2(4000) := NULL;',
'  begin',
'      if p_vcarr is not null then',
'          l_return_value := substr(p_vcarr( p_index ), 1, 4000);',
'      end if;  ',
'      ',
'      return l_return_value;  ',
'  exception',
'      when others then',
'          return NULL;',
'  end;',
'begin',
'  for i in 1..wwv_flow.g_f02.count loop',
'  	l_f01 := array_element(wwv_flow.g_f01,i);',
'  	if l_f01 is not null then',
'      HTMLDB_COLLECTION.ADD_MEMBER(',
'       p_collection_name => ''SCRIPTS_TO_EXPORT'',',
'       p_n001          => wwv_flow.g_f02(l_f01),',
'       p_c002          => wwv_flow.g_f03(l_f01),',
'       p_c003          => wwv_flow.g_f04(l_f01));',
'    end if;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to add selected scripts to collection.'
,p_process_when_button_id=>wwv_flow_imp.id(221610015943050593)
,p_internal_uid=>223021505855686598
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(236921832183120045)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_user     varchar2(  255) := null;',
'    l_filename varchar2(32767) := null;',
'begin',
'    l_filename := nvl (',
'        :P65_FILE_NAME,',
'        wwv_flow.get_company_name(p_escape=>false)||''_script.sql'' );',
'',
'    sys.htp.init;',
'    wwv_flow.g_page_text_generated := true;',
'',
'    wwv_flow_utilities.print_download_header (',
'        p_mime_type     => ''application/text'',',
'        p_is_attachment => true,',
'        p_file_name     => l_filename );',
'',
'    sys.owa_util.http_header_close;',
'',
'    wwv_flow_gen_api2.export_script (',
'        p_commit => ''NO'' );',
'',
'    wwv_flow.g_page_text_generated := true;',
'    wwv_flow.g_unrecoverable_error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to export selected scripts.'
,p_process_when_button_id=>wwv_flow_imp.id(236922711190123460)
,p_internal_uid=>236921832183120045
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(237315715588692488)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove select script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select seq_id, n001 script_id, c002 script_name, c003 script_owner',
'from htmldb_collections ',
'where collection_name =''SCRIPTS_TO_EXPORT'') loop',
'',
'for i in 1..wwv_flow.g_f04.count loop',
'   if wwv_flow.g_f04(i) = c1.script_id then',
'      HTMLDB_COLLECTION.DELETE_MEMBER(',
'       p_collection_name => ''SCRIPTS_TO_EXPORT'',',
'       p_seq => c1.seq_ID);',
'   end if;',
'end loop;',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to remove selected scripts.'
,p_process_when_button_id=>wwv_flow_imp.id(237021909392643306)
,p_process_success_message=>'Selected scripts removed.'
,p_internal_uid=>237315715588692488
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(223020132259675341)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create collection if needed'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not HTMLDB_COLLECTION.COLLECTION_EXISTS  (',
'  p_collection_name => ''SCRIPTS_TO_EXPORT'' ) then',
'  ',
'  HTMLDB_COLLECTION.CREATE_COLLECTION(',
'    p_collection_name => ''SCRIPTS_TO_EXPORT'' );',
'  ',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create collection.'
,p_internal_uid=>223020132259675341
);
end;
/
prompt --application/pages/page_00070
begin
wwv_flow_imp_page.create_page(
 p_id=>70
,p_name=>'Edit Table Comment'
,p_alias=>'EDIT-TABLE-COMMENT'
,p_step_title=>'Edit Table Comment'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276037127560809519)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(460471505997643177)
,p_plug_name=>'Edit Table Comment'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(956276052917084382)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(956277056436094930)
,p_plug_name=>'Edit Table Comment'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(460471703411643179)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(956276052917084382)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(460471930670643180)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(956276052917084382)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(460476410549643238)
,p_branch_action=>'701'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460470502008643165)
,p_name=>'P70_EDIT_IND'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(460471505997643177)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460470724212643170)
,p_name=>'P70_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(460471505997643177)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460472113969643181)
,p_name=>'P70_TABLE_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(460471505997643177)
,p_prompt=>'Table Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Name of the table'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460472711726643182)
,p_name=>'P70_TABLE_COMMENT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(460471505997643177)
,p_prompt=>'Table Comment:'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>12
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>'Comments for the table'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(460475202101643222)
,p_computation_sequence=>1
,p_computation_item=>'P70_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P701_OWNER'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(460475408127643226)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'UpdateComment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_sw_page_calls.update_comment(:p70_owner,:p70_table_name,:p70_table_comment);',
'    :P70_EDIT_IND := ''N'';',
'    :P70_TABLE_NAME := null;',
'    :P70_TABLE_COMMENT := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error updating comment.'
,p_process_when_button_id=>wwv_flow_imp.id(460471930670643180)
,p_process_success_message=>'Comment updated.'
,p_internal_uid=>460475408127643226
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(460476012661643231)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'LoadTableComment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_names  wwv_flow_dynamic_exec.vc_arr2;',
'    l_values wwv_flow_dynamic_exec.vc_arr2;',
'begin',
'    l_names(1)  := ''OWNER'';',
'    l_values(1) := nvl(:P70_OWNER, wwv_flow_user_api.get_default_schema);',
'    l_names(2)  := ''TABLE_NAME'';',
'    l_values(2) := :P70_TABLE_NAME;',
'    ',
'    wwv_flow_sw_api.check_priv(l_values(1));',
'',
'    wwv_flow_code_exec.execute (',
'        p_code => q''{',
'begin',
'    for c1 in (',
'    select comments',
'      from sys.all_tab_comments',
'     where table_name = :TABLE_NAME',
'       and owner      = :OWNER )',
'    loop',
'       :P70_TABLE_COMMENT := c1.comments;',
'    end loop;',
'end;}'',',
'    p_language        => wwv_flow_code_exec.c_plsql,',
'    p_names           => l_names,',
'    p_values          => l_values,',
'    p_parse_as_schema => :P70_OWNER );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error loading comment.'
,p_internal_uid=>460476012661643231
);
end;
/
prompt --application/pages/page_00112
begin
wwv_flow_imp_page.create_page(
 p_id=>112
,p_name=>'Import Scripts'
,p_alias=>'IMPORT-SCRIPTS'
,p_step_title=>'Import Scripts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_transfer.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45313425484446302)
,p_plug_name=>'Import Scripts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Select the export file you want to import.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(846720149938214911)
,p_plug_name=>'Import Scripts'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(846720290809214912)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45314316560446306)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(846720290809214912)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45314626525446306)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(846720290809214912)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(45316031293446311)
,p_branch_action=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(45314626525446306)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(317708930532127772)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(45314316560446306)
,p_branch_sequence=>2
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45314128381446303)
,p_name=>'P112_FILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(45313425484446302)
,p_prompt=>'Import file'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>65
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the export file you want to import.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
,p_item_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(144813309454701505)
,p_name=>'P112_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(45313425484446302)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'File Character Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(143356515285702408)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicate the character set encoding of the file to be imported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47823429294935916)
,p_validation_name=>'file not null'
,p_validation_sequence=>10
,p_validation=>'P112_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'File must be selected to upload.'
,p_when_button_pressed=>wwv_flow_imp.id(45314626525446306)
,p_associated_item=>wwv_flow_imp.id(45314128381446303)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(46711932360845989)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload export file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_title varchar2(4000) := substr(:P112_FILE,instr(:P112_FILE,''/'',1)+1);',
'begin',
'  update wwv_flow_file_objects$ ',
'  set    title = l_title,',
'         description = l_title||'' upload'',',
'         security_group_id = :flow_security_group_id,      ',
'         mime_type = ''application/text'',',
'         created_by = :flow_user,',
'         file_charset = :P112_FILE_CHARSET,',
'         file_type = ''SCRIPT_FILE_EXPORT''',
'  where name = :P112_FILE;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error uploading export file.'
,p_process_success_message=>'Export file uploaded.'
,p_internal_uid=>46711932360845989
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(53577809201103154)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set p115_file_id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P112_FILE)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'  :P115_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(45314626525446306)
,p_internal_uid=>53577809201103154
);
end;
/
prompt --application/pages/page_00115
begin
wwv_flow_imp_page.create_page(
 p_id=>115
,p_name=>'Import Scripts'
,p_alias=>'IMPORT-SCRIPTS1'
,p_step_title=>'Import Scripts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_transfer.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48434504766677479)
,p_plug_name=>'Import Scripts'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(241334518256723791)
,p_plug_name=>'Not compatible'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'N'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Your export file is not supported.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(846720480377214914)
,p_plug_name=>'Not Compatible'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'N'
,p_plug_header=>'Your export file is not supported.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(846720580825214915)
,p_plug_name=>'Not Compatible Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(846720647219214916)
,p_plug_name=>'Import Scripts'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(846720747915214917)
,p_plug_name=>'Import Scripts Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P115_COMPATIBLE'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48439106283687354)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(846720747915214917)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Import Script(s)'
,p_button_position=>'NEXT'
,p_button_condition=>'P115_INSTALL'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(241361201128832328)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(846720580825214915)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(240445017133024625)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(846720747915214917)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(241366231734850616)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(846720580825214915)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48435614809680294)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(846720747915214917)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(241286527335631773)
,p_branch_action=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>5
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(241367712472854513)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>7
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CANCEL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48439400077687355)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48439106283687354)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(163315910465186289)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49326827810797604)
,p_name=>'P115_IMP_COMPANY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(48434504766677479)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow.get_company_name(',
'    p_escape => false );'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Scripts Exported From Workspace:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p115_file_id) = :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'The workspace that the scripts in this file were exported from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49328616859803981)
,p_name=>'P115_IMP_COMPANY_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(48434504766677479)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_lang.system_message(''SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'',wwv_flow_imp_parser.get_security_group_id (p_file_id => :p115_file_id),v(''PRODUCT_NAME''));'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p115_file_id) <> :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'The workspace ID that the scripts in this file were exported from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53858004081074800)
,p_name=>'P115_FILE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(48434504766677479)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(237819228092998884)
,p_name=>'P115_SCRIPTS_TO_IMPORT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(48434504766677479)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(240408118359788422)
,p_name=>'P115_INSTALL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(48434504766677479)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(240417824041875264)
,p_name=>'P115_CONFIRM'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(48434504766677479)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P115_INSTALL'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'PLSQL'
,p_attribute_03=>'sys.htp.p(wwv_flow_lang.system_message(''F4500_P115.CONFIRM''));'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(240431724742951138)
,p_name=>'P115_ERROR'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(48434504766677479)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P115_INSTALL'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'PLSQL'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table cellspacing="0" cellpadding="0" border="0" role="presentation"><tr>'');',
'sys.htp.p(''<td>'');',
'sys.htp.p(''<img src="''||wwv_flow.g_image_prefix||''error.gif" width="32" height="32" alt="''||wwv_flow_lang.system_message(''ERROR'')||''" />'');',
'sys.htp.p(''</td>'');',
'sys.htp.p(''<td>'');',
'sys.htp.p(wwv_flow_lang.system_message(''F4500_P115.ERROR'',v(''PRODUCT_NAME'')));',
'sys.htp.p(''</td>'');',
'sys.htp.p(''</tr>'');',
'sys.htp.p(''</table>'');'))
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(241338415317760784)
,p_name=>'P115_COMPATIBLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(241334518256723791)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(237816617572986308)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'list contents only'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c_browser_language  constant varchar2(255)   := wwv_flow.g_browser_language;',
'  c_nls_numeric_chars constant varchar2(8)     := wwv_flow.g_nls_decimal_separator || wwv_flow.g_nls_group_separator;',
'  l_list                       varchar2(32767);',
'  l_size                       varchar2(255);',
'',
'  l_file_names                 wwv_flow_global.vc_arr2;',
'  l_file_status                wwv_flow_global.vc_arr2;',
'  l_file_has_error             boolean := false;',
'',
'begin',
'  wwv_imp_util.set_list_contents_only( true );',
'  wwv_flow_imp_parser.parse ( p_file_id => :P115_FILE_ID );',
'  -- Restore NLS settings since parsing of an export file has likely changed it',
'  wwv_flow.g_browser_language := c_browser_language;',
'',
'  sys.dbms_session.set_nls (',
'      param => ''NLS_NUMERIC_CHARACTERS'',',
'      value => '''''''' || replace(c_nls_numeric_chars, '''''''', '''''''''''') || '''''''' );',
'',
'  wwv_flow.reset_g_nls_decimal_separator ();',
'',
'  wwv_imp_workspace.get_imported_files_and_status(',
'      p_file_names => l_file_names,',
'      p_file_status => l_file_status );',
'',
'  for i in 1..l_file_names.count loop',
'       if l_file_status(i) like ''%SCRIPT_EXCEEDS_MAX'' then',
'           l_size := substr(l_file_status(i),',
'                     1,',
'                     instr(l_file_status(i), ''_'', 1) - 1',
'                     );',
'           l_file_has_error := true;',
'       end if;',
'       ',
'       if i = 1 then',
'           l_list := ''<table class="a-Report  a-Report--stretch" cellspacing="0" cellpadding="0" border="0" aria-label="''||wwv_flow_lang.system_message(''F4500_P115.SCRIPTS_TO_INSTALL'')||''">'';',
'           l_list := l_list||''<tr><th scope="col" class="a-Report-colHead">''||wwv_flow_lang.system_message(''F4500_P115.SCRIPTS_TO_INSTALL'');',
'           l_list := l_list||''</td><th scope="col" class="a-Report-colHead">''||wwv_flow_lang.system_message(''F4000_P801_ACTION'')||''</td></tr>'';',
'       end if;',
'',
'       l_list := l_list||''<tr>'';',
'       l_list := l_list||''<td class="a-Report-cell" scope="row">''||wwv_flow_escape.html(l_file_names(i))||''</td>'';',
'       l_list := l_list||''<td class="a-Report-cell" scope="row">''||',
'                 ( case when l_file_status(i) like ''%SCRIPT_EXCEEDS_MAX'' then',
'                     wwv_flow_lang.system_message(''WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'', l_size)',
'                 when l_file_status(i) = ''REPLACE'' then',
'                     wwv_flow_lang.system_message(''WWV_FLOW_API.REPLACE_SCRIPT_FILE'')',
'                 when l_file_status(i) = ''NEW'' then',
'                     wwv_flow_lang.system_message(''WWV_FLOW_API.NEW_SCRIPT_FILE'')',
'                 end )',
'                 ||''</td>'';',
'       l_list := l_list||''</tr>'';',
'       if i = l_file_names.count then',
'           l_list := l_list||''</table>'';',
'       end if;',
'  end loop;',
'',
'  if l_file_has_error then',
'      :P115_INSTALL := ''N'';',
'  else',
'      :P115_INSTALL := ''Y'';',
'  end if;',
'  :P115_SCRIPTS_TO_IMPORT := l_list;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to list script names.'
,p_process_when=>'P115_COMPATIBLE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_internal_uid=>237816617572986308
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49330606732819896)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Import Script Files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_imp_util.set_list_contents_only( false );',
'',
'wwv_flow_imp_parser.parse (',
'    p_file_id => :P115_FILE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to import Script. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_imp.id(48439106283687354)
,p_process_success_message=>'Script files imported.'
,p_internal_uid=>49330606732819896
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(241191829423357951)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete uploaded export file when done'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- delete uploaded export file when install is done or previous button clicked',
'delete from wwv_flow_files',
'where id = :P115_FILE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete uploaded export file.'
,p_internal_uid=>241191829423357951
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(241344730948793602)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set p115_compatible'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_version varchar2(4000) := null;',
'begin',
'    l_version := wwv_flow_imp_parser.get_version(p_file_id=>:P115_FILE_ID);',
'    if l_version is not null then',
'        :P115_COMPATIBLE := ''Y'';',
'    else',
'        :P115_COMPATIBLE := ''N'';',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to check compatibility.'
,p_internal_uid=>241344730948793602
);
end;
/
prompt --application/pages/page_00120
begin
wwv_flow_imp_page.create_page(
 p_id=>120
,p_name=>'Create Package on a Table'
,p_alias=>'CREATE-PACKAGE-ON-A-TABLE'
,p_step_title=>'Create Package on Tables'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215538527409730225)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40523827920433441)
,p_plug_name=>'Create Package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 22-FEB-2003 02:54:34'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150015111816732608)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(149957726913651895)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(703372217110859571)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208330211557677621)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752119785231695892)
,p_plug_name=>'Create Package on Tables'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40524801546433444)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(208330211557677621)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(731913040202132963)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(208330211557677621)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40526426326433447)
,p_branch_name=>'Go To Page 124'
,p_branch_action=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40524801546433444)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1779173365216746)
,p_name=>'P120_PARSING_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(40523827920433441)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40960921017244740)
,p_name=>'P120_PACKAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40523827920433441)
,p_prompt=>'Package Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter a package name.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72672508254979049)
,p_name=>'P120_PRESERVE_CASE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(40523827920433441)
,p_prompt=>'Preserve Case'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select this checkbox to preserve case if you want to preserve mixed case characters in your object identifiers like package and table names, otherwise everything will be changed to upper case'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(72676525223983908)
,p_computation_sequence=>10
,p_computation_item=>'P120_PACKAGE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P120_PACKAGE_NAME)'
,p_compute_when=>'P120_PRESERVE_CASE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1779277618216747)
,p_computation_sequence=>10
,p_computation_item=>'P120_PARSING_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P120_PARSING_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(41047425817618127)
,p_validation_name=>'P120_PACKAGE_NAME valid & available'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P120_PACKAGE_NAME,',
'    p_owner           => :P120_PARSING_SCHEMA,',
'    p_object_type     => ''PACKAGE'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_associated_item=>wwv_flow_imp.id(40960921017244740)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(294758725272408291)
,p_validation_name=>'reserved name'
,p_validation_sequence=>20
,p_validation=>'return not wwv_flow_f4500_ob_wiz_dev.is_database_reserved_word( p_word => :P120_PACKAGE_NAME );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The identified package name is an Oracle reserved word.  Please choose another name.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00124
begin
wwv_flow_imp_page.create_page(
 p_id=>124
,p_name=>'Create Package on Tables'
,p_alias=>'CREATE-PACKAGE-ON-TABLES'
,p_step_title=>'Create Package on Tables'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215538527409730225)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/obj_pack.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40935203709143747)
,p_plug_name=>'Create Package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_footer=>'<p>Specify the tables for which you wish to generate a PL/SQL package-based application program interface (API).</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 22-FEB-2003 02:54:34'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150016722551735736)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(149957726913651895)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(703372217110859571)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(239954516961057568)
,p_plug_name=>'WIzard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752120117475695893)
,p_plug_name=>'Create Package on Tables'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40936707199143767)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(239954516961057568)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40936428728143763)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(239954516961057568)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(731914413414174282)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(239954516961057568)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40938025082143770)
,p_branch_action=>'125'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(40936707199143767)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40937732167143770)
,p_branch_action=>'120'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(40936428728143763)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40937022841143768)
,p_name=>'P124_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>':P120_PARSING_SCHEMA'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 22-FEB-2003 02:54:34'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40950615252176842)
,p_name=>'P124_TABLE1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 1'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40955125126217527)
,p_name=>'P124_TABLE2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 2'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40955428936218616)
,p_name=>'P124_TABLE3'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 3'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40955732745219728)
,p_name=>'P124_TABLE4'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 4'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40956004479221029)
,p_name=>'P124_TABLE5'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 5'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40956308981222307)
,p_name=>'P124_TABLE6'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 6'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40956613483223608)
,p_name=>'P124_TABLE7'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 7'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40956916600224542)
,p_name=>'P124_TABLE8'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 8'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40957220409225596)
,p_name=>'P124_TABLE9'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 9'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40957523872226576)
,p_name=>'P124_TABLE10'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Table 10'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'OB_CREATE_TABLE_HANDLER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'from sys.dba_objects',
'where owner = :P120_PARSING_SCHEMA ',
'and object_type in (''TABLE'')',
'and object_name not like ''BIN$%'' ',
'and object_name not like ''DR$%'' ',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the name of the table to generate an API for'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40962010413251074)
,p_name=>'P124_PACKAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40935203709143747)
,p_prompt=>'Package Name:'
,p_source=>'P120_PACKAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of the package to contain the API to be created'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(41051007032631596)
,p_validation_name=>'P124_TABLE1 Not Null'
,p_validation_sequence=>10
,p_validation=>'P124_TABLE1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table must be specified.'
,p_associated_item=>wwv_flow_imp.id(40950615252176842)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-FEB-2003 18:20'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3371318219597712)
,p_validation_name=>'tables exist'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P124_TABLE1 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE1,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE1),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;',
'if :P124_TABLE2 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE2,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE2),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;',
'if :P124_TABLE3 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE3,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE3),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;',
'if :P124_TABLE4 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE4,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE4),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;',
'if :P124_TABLE5 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE5,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE5),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;',
'if :P124_TABLE6 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE6,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE6),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;',
'if :P124_TABLE7 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE7,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE7),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;',
'if :P124_TABLE8 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE8,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE8),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;',
'if :P124_TABLE9 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE9,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE9),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;',
'if :P124_TABLE10 is not null and not wwv_flow_sw_util.table_exists(:P124_TABLE10,:P120_PARSING_SCHEMA) then',
'  return wwv_flow_lang.system_message(''F4500.TABLE_NOT_FOUND_IN_SCHEMA'',wwv_flow_escape.html(:P124_TABLE10),wwv_flow_escape.html(:P120_PARSING_SCHEMA));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(40936707199143767)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(108074006656521986)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'make table names upper case'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P124_TABLE1  := upper(:P124_TABLE1);',
':P124_TABLE2  := upper(:P124_TABLE2);',
':P124_TABLE3  := upper(:P124_TABLE3);',
':P124_TABLE4  := upper(:P124_TABLE4);',
':P124_TABLE5  := upper(:P124_TABLE5);',
':P124_TABLE6  := upper(:P124_TABLE6);',
':P124_TABLE7  := upper(:P124_TABLE7);',
':P124_TABLE8  := upper(:P124_TABLE8);',
':P124_TABLE9  := upper(:P124_TABLE9);',
':P124_TABLE10 := upper(:P124_TABLE10);'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P120_PRESERVE_CASE'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>108074006656521986
);
end;
/
prompt --application/pages/page_00125
begin
wwv_flow_imp_page.create_page(
 p_id=>125
,p_name=>'Table API Creation'
,p_alias=>'TABLE-API-CREATION'
,p_step_title=>'Create Package on Tables'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215538527409730225)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function showDDLSpec(){',
'    theDDL = document.getElementById(''pkgSpec'');',
'    showDiv = document.getElementById(''ddlSpecShow'');',
'    hideDiv = document.getElementById(''ddlSpecHide'');',
'    hideDiv.style.display = ''block'';',
'    theDDL.style.display = ''block'';',
'    showDiv.style.display = ''none'';',
'    }',
'',
'function hideDDLSpec(){',
'    theDDL = document.getElementById(''pkgSpec'');',
'    showDiv = document.getElementById(''ddlSpecShow'');',
'    hideDiv = document.getElementById(''ddlSpecHide'');',
'    hideDiv.style.display = ''none'';',
'    theDDL.style.display = ''none'';',
'    showDiv.style.display = ''block'';',
'    }',
'',
'function showDDLBody(){',
'    theDDL = document.getElementById(''pkgBody'');',
'    showDiv = document.getElementById(''ddlBodyShow'');',
'    hideDiv = document.getElementById(''ddlBodyHide'');',
'    hideDiv.style.display = ''block'';',
'    theDDL.style.display = ''block'';',
'    showDiv.style.display = ''none'';',
'    }',
'',
'function hideDDLBody(){',
'    theDDL = document.getElementById(''pkgBody'');',
'    showDiv = document.getElementById(''ddlBodyShow'');',
'    hideDiv = document.getElementById(''ddlBodyHide'');',
'    hideDiv.style.display = ''none'';',
'    theDDL.style.display = ''none'';',
'    showDiv.style.display = ''block'';',
'    }',
''))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ddlClass {',
'    width:400px;',
'    height:300px;',
'    border:1px #3F8640 solid;',
'    font-family:monospace;',
'    text-overflow:auto;',
'    background:#C5D5C5;',
'    display:none;',
'    white-space: pre;}',
''))
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1962729556076041)
,p_plug_name=>'PL/SQL Package'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_generate_table_api.create_api(',
'  p_owner => :P120_PARSING_SCHEMA,',
'  p_app_name => :P120_PACKAGE_NAME,',
'  p_table_name_01 => :P124_TABLE1,',
'  p_table_name_02 => :P124_TABLE2,',
'  p_table_name_03 => :P124_TABLE3,',
'  p_table_name_04 => :P124_TABLE4,',
'  p_table_name_05 => :P124_TABLE5,',
'  p_table_name_06 => :P124_TABLE6,',
'  p_table_name_07 => :P124_TABLE7,',
'  p_table_name_08 => :P124_TABLE8,',
'  p_table_name_09 => :P124_TABLE9,',
'  p_table_name_10 => :P124_TABLE10',
');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Please confirm your request.',
'<br /><br />'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(239962318955077077)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(273115725560451995)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(149957726913651895)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(703372217110859571)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(752120212176695894)
,p_plug_name=>'Create Package on Tables'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2320006090100655)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(239962318955077077)
,p_button_name=>'FINISH'
,p_button_static_id=>'finish_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Package'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2278707972911932)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(239962318955077077)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(731960813407217756)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(239962318955077077)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4500_LAST_VIEW.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(722738102808798609)
,p_branch_name=>'Go To Page 126'
,p_branch_action=>'f?p=&APP_ID.:126:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2320006090100655)
,p_branch_sequence=>5
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2327302458137435)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'compile package'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_generate_table_api.create_api(',
'  p_owner => :P124_OWNER,',
'  p_app_name => :P120_PACKAGE_NAME,',
'  p_table_name_01 => :P124_TABLE1,',
'  p_table_name_02 => :P124_TABLE2,',
'  p_table_name_03 => :P124_TABLE3,',
'  p_table_name_04 => :P124_TABLE4,',
'  p_table_name_05 => :P124_TABLE5,',
'  p_table_name_06 => :P124_TABLE6,',
'  p_table_name_07 => :P124_TABLE7,',
'  p_table_name_08 => :P124_TABLE8,',
'  p_table_name_09 => :P124_TABLE9,',
'  p_table_name_10 => :P124_TABLE10,',
'  p_action => ''EXECUTE''',
');',
':P126_DDL_STATUS := ''SUCCESS'';',
'',
'      :OBJECT_NAME  := :P120_PACKAGE_NAME;',
'      :OBJECT_OWNER := :P120_OWNER;',
'      :OBJECT_TYPE  := ''PACKAGE'';',
'',
'FOR C IN (SELECT OBJECT_ID FROM sys.DBA_OBJECTS ',
'          WHERE OBJECT_NAME = :P120_PACKAGE_NAME ',
'          AND OWNER = :P120_PARSING_SCHEMA',
'          AND OBJECT_TYPE = ''PACKAGE'') LOOP',
':OBJECT_ID := C.OBJECT_ID;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(2320006090100655)
,p_internal_uid=>2327302458137435
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2259621075811652)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download spec'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_generate_table_api.create_api(',
'  p_owner => :P124_OWNER,',
'  p_app_name => :P120_PACKAGE_NAME,',
'  p_table_name_01 => :P124_TABLE1,',
'  p_table_name_02 => :P124_TABLE2,',
'  p_table_name_03 => :P124_TABLE3,',
'  p_table_name_04 => :P124_TABLE4,',
'  p_table_name_05 => :P124_TABLE5,',
'  p_table_name_06 => :P124_TABLE6,',
'  p_table_name_07 => :P124_TABLE7,',
'  p_table_name_08 => :P124_TABLE8,',
'  p_table_name_09 => :P124_TABLE9,',
'  p_table_name_10 => :P124_TABLE10,',
'  p_action => ''DOWNLOAD_SPEC''',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'DOWNLOAD_SPEC'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>2259621075811652
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2260505061825908)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download body'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_generate_table_api.create_api(',
'  p_owner => :P124_OWNER,',
'  p_app_name => :P120_PACKAGE_NAME,',
'  p_table_name_01 => :P124_TABLE1,',
'  p_table_name_02 => :P124_TABLE2,',
'  p_table_name_03 => :P124_TABLE3,',
'  p_table_name_04 => :P124_TABLE4,',
'  p_table_name_05 => :P124_TABLE5,',
'  p_table_name_06 => :P124_TABLE6,',
'  p_table_name_07 => :P124_TABLE7,',
'  p_table_name_08 => :P124_TABLE8,',
'  p_table_name_09 => :P124_TABLE9,',
'  p_table_name_10 => :P124_TABLE10,',
'  p_action => ''DOWNLOAD_BODY''',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'DOWNLOAD_BODY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>2260505061825908
);
end;
/
prompt --application/pages/page_00126
begin
wwv_flow_imp_page.create_page(
 p_id=>126
,p_name=>'Unable to Create Package'
,p_alias=>'UNABLE-TO-CREATE-PACKAGE'
,p_step_title=>'Unable to Create Package'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11540120040990569)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2308725586092552)
,p_plug_name=>'Unable to Create Package'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(722738203744798610)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(16898919354444866)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(722738203744798610)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:125:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(110684468724037402)
,p_branch_name=>'route page'
,p_branch_action=>'declare'||wwv_flow.LF||
'    l_object_id number;'||wwv_flow.LF||
'begin'||wwv_flow.LF||
'    for r in ( select object_id'||wwv_flow.LF||
'                 from sys.dba_objects'||wwv_flow.LF||
'                where owner       = :P120_PARSING_SCHEMA'||wwv_flow.LF||
'                  and object_name = :P120_PACKAGE_NAME'||wwv_flow.LF||
'                  and object_type = ''PACKAGE'' )'||wwv_flow.LF||
'    loop'||wwv_flow.LF||
'        l_object_id := r.object_id;'||wwv_flow.LF||
'    end loop;'||wwv_flow.LF||
''||wwv_flow.LF||
'    return wwv_flow_page_api.get_url('||wwv_flow.LF||
'               p_page        => 2000,'||wwv_flow.LF||
'               p_clear_cache => ''RP,2000'','||wwv_flow.LF||
'               p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'','||wwv_flow.LF||
'               p_values      => :P120_PARSING_SCHEMA||'',''||l_object_id );'||wwv_flow.LF||
'end;'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'BRANCH_TO_FUNCTION_RETURNING_URL'
,p_branch_language=>'PLSQL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P126_DDL_STATUS'
,p_branch_condition_text=>'SUCCESS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2309022777092554)
,p_name=>'P126_DDL_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2308725586092552)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00138
begin
wwv_flow_imp_page.create_page(
 p_id=>138
,p_name=>'Enter Bind Variables'
,p_alias=>'SC_GETBINDS'
,p_step_title=>'Enter Bind Variables'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_footer_text=>'<input type="text" style="display:none;" />'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11093307704620192)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script src="#IMAGE_PREFIX#sc/sc_core.js" type="text/javascript"></script>',
''))
,p_step_template=>wwv_flow_imp.id(102479827851590823)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21663321664876078)
,p_plug_name=>'Bind Variables'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    tBind     varchar2(2000);',
'    l_binds   wwv_flow_global.vc_arr2;',
'    l_bindVar wwv_flow_global.vc_arr2;',
'begin',
'    l_binds := wwv_flow_utilities.string_to_table (str => v(''p1200_binds''),sep => '','');',
'    l_bindVar := wwv_flow_utilities.string_to_table (str => v(''p1200_bind_vals''),sep => '','');',
'    ',
'    if l_binds.count > 0 then',
'        sys.htp.p(''<div class="a-Report a-Report--stretch"><div class="a-Report-wrap"><div class="a-Report-tableWrap">'');',
'        sys.htp.p(''<table class="a-Report-report" ''||wwv_flow_utilities.get_layout_table_attributes||''>'');',
'        sys.htp.p(''<thead><tr>'');',
'        sys.htp.p(''<th class="a-Report-colHead" align="left" id="BIND_VAR">''||wwv_flow_lang.system_message(''BIND_VARIABLE'')||''</th>'');',
'        sys.htp.p(''<th class="a-Report-colHead" align="left" id="TO_VALUE">''||wwv_flow_lang.system_message(''F4500_P10_VALUE'')||''</th>'');',
'        sys.htp.p(''</tr></thead>'');',
'        sys.htp.p(''<tbody>'');',
'    end if;',
'',
'    for i in 1..l_binds.count loop',
'        begin',
'            select decode(l_bindVar(i),''HTMLDB:NULL'','''',l_bindVar(i)) ',
'              into tBind from sys.dual;',
'        exception when no_data_found then',
'            tBind := ''HTMLDB:NULL'';',
'        end;',
'',
'        sys.htp.prn(''<tr><td class="a-Report-cell" headers="BIND_VAR" align="right">'');',
'        sys.htp.prn(HTMLDB_ITEM.HIDDEN(1,wwv_flow_escape.html(l_binds(i))));',
'        sys.htp.prn(wwv_flow_escape.html(l_binds(i))||''</td><td class="a-Report-cell" headers="TO_VALUE">'');',
'',
'       if (l_bindVar.count >= i) then',
'           sys.htp.prn(HTMLDB_ITEM.TEXT(2,wwv_flow_escape.html(tBind),null,null,''title="''||wwv_flow_lang.system_message(''NEW_BIND_VARIABLE'',wwv_flow_escape.html(l_binds(i)))||''"''));  ',
'       else ',
'           sys.htp.prn(HTMLDB_ITEM.TEXT(2,null,null,null,''title="''||wwv_flow_lang.system_message(''NEW_BIND_VARIABLE'',wwv_flow_escape.html(l_binds(i)))||''"''));  ',
'       end if;',
'',
'       sys.htp.p(''</td></tr>'');',
'    end loop;',
'',
'    if l_binds.count > 0 then',
'        sys.htp.p(''</tbody>'');',
'        sys.htp.p(''</table>'');',
'        sys.htp.p(''</div></div></div>'');',
'    end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1272646864697365249)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21684021092159769)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1272646864697365249)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Submit'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(21710203515485840)
,p_branch_action=>'f?p=&APP_ID.:138:&SESSION.:LEAVE:&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(21684021092159769)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1119153986522390602)
,p_name=>'Post Binds'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'REQUEST_EQUALS_CONDITION'
,p_display_when_cond=>'LEAVE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1119154041010390603)
,p_event_id=>wwv_flow_imp.id(1119153986522390602)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sc_postBind("&P1200_BIND_VALS.");'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(21707831172465411)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'post_binds'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.debug(''binds ''||HTMLDB_APPLICATION.G_F01.COUNT);',
'wwv_flow.debug(''vals ''||HTMLDB_APPLICATION.G_F02.COUNT);',
'FOR I in 1..HTMLDB_APPLICATION.G_F01.COUNT LOOP',
'  if (HTMLDB_APPLICATION.G_F02.count >= i) then',
'    if (i = 1) then',
'      :p1200_bind_vals := nvl(HTMLDB_APPLICATION.G_F02(i),''HTMLDB:NULL'');',
'    else',
'      :p1200_bind_vals := :p1200_bind_vals||'',''||HTMLDB_APPLICATION.G_F02(i);',
'    end if;',
'  end if;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(21684021092159769)
,p_internal_uid=>21707831172465411
);
end;
/
prompt --application/pages/page_00139
begin
wwv_flow_imp_page.create_page(
 p_id=>139
,p_name=>'SQL Command Describe'
,p_alias=>'SQL_CMD_DESC'
,p_step_title=>'SQL Command Describe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213236325564854129)
,p_step_template=>wwv_flow_imp.id(14599108081253832)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_proc.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22151631482530337)
,p_plug_name=>'Describe'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22734206162670902)
,p_name=>'Functions and Procedures'
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P139_OWNER as owner,',
'       object_name,',
'       nvl (',
'           argument_name,',
'           decode(in_out, ''OUT'', ''<return value>'', ''<none>'')',
'           ) as argument,',
'       nvl(in_out, ''IN'') as in_out,',
'       case',
'         when type_subname is null then',
'           case',
'             when data_type = ''VARCHAR2'' and data_length is not null then data_type||'' (''||data_length||'')''',
'             else data_type',
'           end',
'         else data_type||'' (''||type_subname||'')''',
'       end as datatype',
'  from sys.user_arguments',
' where object_name = trim(:P139_OBJECT)',
' order by object_name, overload, position'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P139_TYPE in (''PROCEDURE'',''FUNCTION'') and',
'(:P139_OBJECT is not null) and ',
':P139_STATUS = ''VALID'''))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'There are no arguments for this object.'
,p_query_row_count_max=>10000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(133525430001143648)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22787418942954200)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:sc_getSQL(''&P139_OWNER..#OBJECT_NAME#'');'
,p_column_linktext=>'#OBJECT_NAME#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22787805472954201)
,p_query_column_id=>3
,p_column_alias=>'ARGUMENT'
,p_column_display_sequence=>2
,p_column_heading=>'Argument'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23989902807114363)
,p_query_column_id=>4
,p_column_alias=>'IN_OUT'
,p_column_display_sequence=>3
,p_column_heading=>'In Out'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23650632085677148)
,p_query_column_id=>5
,p_column_alias=>'DATATYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Datatype'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22918222587536700)
,p_name=>'Package'
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P139_OWNER as owner,',
'       package_name,',
'       decode(overload, null, object_name, object_name||''(''||to_char(overload)||'')'') as procedure,',
'       argument_name as argument,',
'       decode(argument_name, null, decode(data_type, null, '''', ''OUT''), in_out) as in_out,',
'       case',
'         when type_subname is null then',
'           case',
'             when data_type = ''VARCHAR2'' and data_length is not null then data_type||'' (''||data_length||'')''',
'             else data_type',
'           end',
'         else data_type||'' (''||type_subname||'')''',
'       end as datatype,',
'       object_name',
'  from sys.user_arguments',
' where package_name = trim(:P139_OBJECT)',
'   and data_level < 1',
' order by object_name, overload, position'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P139_TYPE in (''PACKAGE'') and',
'(:P139_OBJECT is not null or',
':P139_OBJECT != ''0'')'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>10000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(133493118423979428)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>7
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23998524072205627)
,p_query_column_id=>2
,p_column_alias=>'PACKAGE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Package Name'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:ret_Column(''&P139_OWNER..#PACKAGE_NAME#'');'
,p_column_linktext=>'#PACKAGE_NAME#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23652810951686944)
,p_query_column_id=>3
,p_column_alias=>'PROCEDURE'
,p_column_display_sequence=>2
,p_column_heading=>'Procedure'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:sc_getSQL(''&P139_OWNER..#PACKAGE_NAME#.#OBJECT_NAME#'');'
,p_column_linktext=>'#PROCEDURE#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22918909183536703)
,p_query_column_id=>4
,p_column_alias=>'ARGUMENT'
,p_column_display_sequence=>3
,p_column_heading=>'Argument'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23652914818686944)
,p_query_column_id=>5
,p_column_alias=>'IN_OUT'
,p_column_display_sequence=>4
,p_column_heading=>'In Out'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23653012360686944)
,p_query_column_id=>6
,p_column_alias=>'DATATYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Datatype'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23998008488201171)
,p_query_column_id=>7
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26118215107900863)
,p_plug_name=>'INVALID Function/Procedure'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table><tr><td valign="top"><img src="''||wwv_flow.g_image_prefix||''error.gif" width="32" height="32"></td>'');',
'sys.htp.p(''<td valign="top" style="color:red;font-size:smaller">'');',
'sys.htp.p(wwv_flow_lang.system_message(''INVALID_OBJECT'',:P139_OBJECT));',
'sys.htp.p(''</td></tr></table>'');',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P139_TYPE in (''PROCEDURE'',''FUNCTION'') and',
'(:P139_OBJECT is not null or :P139_OBJECT != ''0'')',
'and :P139_STATUS != ''VALID'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(181940330173429738)
,p_plug_name=>'Describe Help Message'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>15
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''SC_DESCRIBE''));'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P139_TYPE = ''---'' and :P139_OBJECT = ''---'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(198570132213852702)
,p_plug_name=>'Describe object not found'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>17
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(wwv_flow_lang.system_message(''SC_NOT_VALID_OBJECT''));',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P139_TYPE = ''---'' and :P139_OBJECT != ''---'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(367602808298431816)
,p_name=>'Tables and Views'
,p_display_sequence=>22
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.owner,',
'       t.table_name,',
'       t.column_name,',
'       t.data_type,',
'       decode (',
'           t.data_precision,',
'           null,',
'           decode (',
'               t.data_type,',
'               ''CHAR'',      t.char_length,',
'               ''NCHAR'',     t.char_length,',
'               ''VARCHAR'',   t.char_length,',
'               ''VARCHAR2'',  t.char_length,',
'               ''NVARCHAR2'', t.char_length,',
'               t.data_length ),',
'               decode (',
'                   t.data_type,',
'                   ''NUMBER'',',
'                   null,',
'                   t.data_precision ) ) as data_length,',
'       t.data_precision,',
'       t.data_scale,',
'       cons.position pk,',
'       decode(t.nullable,''Y'',''<img src="#IMAGE_PREFIX#check_small_black.gif" border="0" height="15" width="15" alt="''||wwv_flow_lang.system_message(''F4500.NULLABLE'')||''" />'',null) nullable,',
'       t.data_default,',
'       t.column_id,',
'       c.comments comments',
'  from sys.all_tab_columns t,',
'       sys.all_col_comments c,',
'       ( select cl.column_name, cl.position',
'             from sys.all_cons_columns cl,',
'                  sys.all_constraints cn',
'            where cn.owner           = replace(trim(:P139_OWNER),''"'')',
'              and cn.table_name      = replace(trim(:P139_OBJECT),''"'')',
'              and cn.constraint_type = ''P''',
'              and cl.owner           = cn.owner',
'              and cl.table_name      = cn.table_name',
'              and cl.constraint_name = cn.constraint_name',
'        ) cons',
' where t.column_name = c.column_name',
'   and c.table_name  = t.table_name',
'   and c.owner       = t.owner',
'   and t.table_name  = replace(trim(:P139_OBJECT),''"'')',
'   and t.owner       = replace(trim(:P139_OWNER),''"'')',
'   and t.column_name = cons.column_name (+)',
' order by t.column_id'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P139_TYPE in (''TABLE'',''VIEW'') and',
'(:P139_OBJECT is not null)'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>10000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P1003_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603003019431819)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>12
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603114805431819)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Table'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:ret_Column(''&P139_OWNER..#TABLE_NAME#'');'
,p_column_linktext=>'#TABLE_NAME#'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603215003431819)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Column'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:ret_Column(''#COLUMN_NAME#'');'
,p_column_linktext=>'#COLUMN_NAME#'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603325404431819)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603432375431819)
,p_query_column_id=>5
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Length'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603513875431819)
,p_query_column_id=>6
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precision'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603626301431819)
,p_query_column_id=>7
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scale'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603732700431819)
,p_query_column_id=>8
,p_column_alias=>'PK'
,p_column_display_sequence=>7
,p_column_heading=>'Primary Key'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603804807431820)
,p_query_column_id=>9
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>8
,p_column_heading=>'Nullable'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367603919443431820)
,p_query_column_id=>10
,p_column_alias=>'DATA_DEFAULT'
,p_column_display_sequence=>9
,p_column_heading=>'Default'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367604017413431820)
,p_query_column_id=>11
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>10
,p_column_heading=>'Column'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(367604102858431820)
,p_query_column_id=>12
,p_column_alias=>'COMMENTS'
,p_column_display_sequence=>11
,p_column_heading=>'Comment'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22156222310565561)
,p_name=>'P139_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(22151631482530337)
,p_prompt=>'Object Type'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P139_TYPE'
,p_display_when2=>'---'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select the data type of the database object you wish to describe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22174606305655533)
,p_name=>'P139_OBJECT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22151631482530337)
,p_prompt=>'Object'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P139_TYPE'
,p_display_when2=>'---'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select the name of the database object you wish to describe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26109431636848823)
,p_name=>'P139_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(22151631482530337)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(163607902932567187)
,p_name=>'P139_OWNER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(22151631482530337)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(163900618281479961)
,p_name=>'P139_ACTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(22151631482530337)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(260345913184518928)
,p_name=>'P139_PREV_SQL'
,p_data_type=>'CLOB'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(22151631482530337)
,p_display_as=>'NATIVE_HIDDEN'
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22516125575777686)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.get_describe_object_info (',
'    p_action           => :P139_ACTION,',
'    p_schema           => :P1003_SCHEMA,',
'    p_desc_object_name => rtrim(ltrim( :P139_OBJECT )),',
'    -- output computed item values',
'    p_object_owner     => :P139_OWNER,',
'    p_object_name      => :P139_OBJECT,',
'    p_object_type      => :P139_TYPE,',
'    p_object_status    => :P139_STATUS );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>22516125575777686
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22816121146082168)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>22816121146082168
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(260344915824510246)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save history'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P1003_SQL_COMMAND2,',
'    p_schema            => :P1003_SCHEMA',
'    );',
'',
':P139_PREV_SQL := :P1003_SQL_COMMAND2;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P1003_SQL_COMMAND2 != nvl(:P139_PREV_SQL,'' '')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>260344915824510246
);
end;
/
prompt --application/pages/page_00200
begin
wwv_flow_imp_page.create_page(
 p_id=>200
,p_name=>'Manage Sample Data'
,p_alias=>'MANAGE-SAMPLE-DATA'
,p_step_title=>'Manage Sample Data'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(164012970789368906)
,p_plug_name=>'Sample Datasets'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>Sample datasets provide the ability to create, refresh, or remov sets of database objects that are useful for demonstration purposes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(165488781375201416)
,p_plug_name=>'Sample Datasets'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>11
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
', name',
', description',
', last_refresh_date',
', table_prefix',
'from wwv_sample_datasets d'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(165488893053201416)
,p_name=>'Schema Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>165488893053201416
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164012436342368901)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164012577251368902)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'Dataset'
,p_column_link=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:RP,201:P201_DATASET_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164012694267368903)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>30
,p_column_identifier=>'P'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164012857803368905)
,p_db_column_name=>'TABLE_PREFIX'
,p_display_order=>50
,p_column_identifier=>'R'
,p_column_label=>'Table Prefix'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164012778081368904)
,p_db_column_name=>'LAST_REFRESH_DATE'
,p_display_order=>60
,p_column_identifier=>'Q'
,p_column_label=>'Dataset Last Update'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'DD-MON-YYYY'
,p_tz_dependent=>'Y'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(165490763881203610)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1640078'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:DESCRIPTION:TABLE_PREFIX:LAST_REFRESH_DATE:'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
end;
/
prompt --application/pages/page_00201
begin
wwv_flow_imp_page.create_page(
 p_id=>201
,p_name=>'Manage Dataset'
,p_alias=>'MANAGE-DATASET'
,p_step_title=>'Manage Dataset'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_ddl.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(164013012634368907)
,p_plug_name=>'Dataset Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(328044736026804566)
,p_plug_name=>'Sample Datasets'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>Sample datasets provide the ability to create, refresh, or remov sets of database objects that are useful for demonstration purposes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(329520546612637076)
,p_plug_name=>'Manage Dataset'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
', name',
', description',
', last_refresh_date',
', table_prefix',
'from wwv_sample_datasets d'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(329520658290637076)
,p_name=>'Schema Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>329520658290637076
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164032467678435683)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164032889377435686)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'Dataset'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164033268322435686)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>30
,p_column_identifier=>'P'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164034024956435687)
,p_db_column_name=>'TABLE_PREFIX'
,p_display_order=>50
,p_column_identifier=>'R'
,p_column_label=>'Table prefix'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(164033673818435686)
,p_db_column_name=>'LAST_REFRESH_DATE'
,p_display_order=>60
,p_column_identifier=>'Q'
,p_column_label=>'Last refresh date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'DD-MON-YYYY'
,p_tz_dependent=>'Y'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(329522529118639270)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1640344'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:DESCRIPTION:TABLE_PREFIX:LAST_REFRESH_DATE:'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164014183687368918)
,p_name=>'P201_DATASET_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(164013012634368907)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164014249133368919)
,p_name=>'P201_WS_REFRESH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(164013012634368907)
,p_prompt=>'Workspace Last Refreshed'
,p_format_mask=>'DD-MON-YYYY HH24:MI'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164014367738368920)
,p_name=>'P201_SCHEMA'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(164013012634368907)
,p_prompt=>'Installed into Schema'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164014559321368922)
,p_name=>'P201_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(164013012634368907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dataset'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164014660950368923)
,p_name=>'P201_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(164013012634368907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164014779365368924)
,p_name=>'P201_TABLE_PREFIX'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(164013012634368907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Prefix'
,p_source=>'TABLE_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164014862083368925)
,p_name=>'P201_LAST_REFRESH_DATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(164013012634368907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dataset Last Updated'
,p_format_mask=>'DD-MON-YYYY'
,p_source=>'LAST_REFRESH_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164014488800368921)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch WWV_SAMPLE_DATASETS'
,p_attribute_02=>'WWV_SAMPLE_DATASETS'
,p_attribute_03=>'P201_DATASET_ID'
,p_attribute_04=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>164014488800368921
);
end;
/
prompt --application/pages/page_00400
begin
wwv_flow_imp_page.create_page(
 p_id=>400
,p_name=>'Dropped Objects'
,p_alias=>'DROPPED-OBJECTS'
,p_step_title=>'Dropped Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215661000733996927)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_rcycl_.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4240028411514106)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(151000331198918456)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11603702678674839)
,p_plug_name=>'schema owner'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(72170018852796333)
,p_plug_name=>'Recycle Bin'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'When a table is dropped, Oracle Database does not immediately remove the space associated with the table. The database renames the table and places it and any associated objects into the Recycle Bin. You can recover objects in the Recycle Bin at a la'
||'ter time. Note that this behavior can be disabled by a database administrator.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(478189003940910628)
,p_plug_name=>'Recycle Bin'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.object_name identifier,',
'  o.original_name,',
'  o.object_name,',
'  replace(o.type,'' '',''_'') type,',
'  o.operation,',
'  o.createtime,',
'  to_date(o.droptime,''YYYY-MM-DD:HH24:MI:SS'') droptime,',
'  to_date(o.droptime,''YYYY-MM-DD:HH24:MI:SS'') droptimesince,',
'  o.can_undrop,',
'  o.can_purge,',
'  /*o.base_object object_id*/',
'  o.purge_object object_id',
'from sys.user_recyclebin o',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P400_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(478189118717910628)
,p_name=>'Recycle Bin'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478189318636910642)
,p_db_column_name=>'IDENTIFIER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_link=>'f?p=&FLOW_ID.:401:&SESSION.::&DEBUG.::P401_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#24find.gif" border="0" height="24" width="24">'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478189431476910645)
,p_db_column_name=>'ORIGINAL_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Original Name'
,p_column_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::P401_OBJECT_ID:#OBJECT_ID#'
,p_column_linktext=>'#ORIGINAL_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478189628200910648)
,p_db_column_name=>'TYPE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478189517434910646)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Object Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478189723375910649)
,p_db_column_name=>'OPERATION'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Operation'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478189803915910650)
,p_db_column_name=>'CREATETIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Created'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15340290608841402)
,p_db_column_name=>'DROPTIME'
,p_display_order=>7
,p_column_identifier=>'L'
,p_column_label=>'Drop Date'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478190112436910654)
,p_db_column_name=>'CAN_UNDROP'
,p_display_order=>26
,p_column_identifier=>'I'
,p_column_label=>'&nbsp;'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478190215884910656)
,p_db_column_name=>'CAN_PURGE'
,p_display_order=>36
,p_column_identifier=>'J'
,p_column_label=>'&nbsp;'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478190318059910657)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>46
,p_column_identifier=>'K'
,p_column_label=>'Object ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478190025531910653)
,p_db_column_name=>'DROPTIMESINCE'
,p_display_order=>56
,p_column_identifier=>'H'
,p_column_label=>'Dropped'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(478190502698911026)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318025096536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ORIGINAL_NAME:TYPE:DROPTIME:OBJECT_ID:DROPTIMESINCE:'
,p_sort_column_1=>'DROPTIME'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'ORIGINAL_NAME'
,p_sort_direction_2=>'ASC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(465926830788091)
,p_branch_action=>'f?p=&FLOW_ID.:400:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(525320683135333)
,p_name=>'P400_SCHEMA'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(11603702678674839)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(187652405321922937)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select a schema (username) you want to view. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(175580808373672184)
,p_name=>'P400_DEFAULT_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(478189003940910628)
,p_source=>'return wwv_flow_user_api.get_default_schema;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(69327630670884389)
,p_computation_sequence=>10
,p_computation_item=>'P400_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P400_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1020677943389018448)
,p_name=>'RENDERING: Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(4240028411514106)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1020678234799018449)
,p_event_id=>wwv_flow_imp.id(1020677943389018448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:400:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69316307206858608)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P400_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_process_when=>'P400_SCHEMA'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_internal_uid=>69316307206858608
);
end;
/
prompt --application/pages/page_00401
begin
wwv_flow_imp_page.create_page(
 p_id=>401
,p_name=>'Object Details'
,p_alias=>'OBJECT-DETAILS'
,p_step_title=>'Object Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11093307704620192)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_rcycl_.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(473825148833877)
,p_plug_name=>'Object Details'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page provides additional information about the recycled object and allows purging objects (drop permanently) or restoring them from the recycling bin.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(476219177851040)
,p_name=>'Dropped Object Details'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.object_name identifier,',
'  b.original_name base_object_name,',
'  o.original_name,',
'  o.object_name,',
'  o.type,',
'  o.operation,',
'  o.createtime,',
'  o.droptime,',
'  substr(o.can_undrop, 1, 1) as can_undrop,',
'  substr(o.can_purge, 1, 1) as can_purge',
'from sys.dba_recyclebin o, sys.dba_recyclebin b',
'where o.owner = :P401_OBJECT_OWNER',
'and b.purge_object = o.base_object',
'and o.object_name = :P401_OBJECT_NAME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(476622036851053)
,p_query_column_id=>1
,p_column_alias=>'IDENTIFIER'
,p_column_display_sequence=>1
,p_column_heading=>'Identifier'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(476708297851053)
,p_query_column_id=>2
,p_column_alias=>'BASE_OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Base Object Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(476810063851053)
,p_query_column_id=>3
,p_column_alias=>'ORIGINAL_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Original Object Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(476925144851053)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(477024808851053)
,p_query_column_id=>5
,p_column_alias=>'TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(477105517851054)
,p_query_column_id=>6
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>6
,p_column_heading=>'Operation'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(477217067851054)
,p_query_column_id=>7
,p_column_alias=>'CREATETIME'
,p_column_display_sequence=>7
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(477320606851054)
,p_query_column_id=>8
,p_column_alias=>'DROPTIME'
,p_column_display_sequence=>8
,p_column_heading=>'Dropped On'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(477409806851054)
,p_query_column_id=>9
,p_column_alias=>'CAN_UNDROP'
,p_column_display_sequence=>9
,p_column_heading=>'Can be restored?'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(23482928300634173)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(477520310851054)
,p_query_column_id=>10
,p_column_alias=>'CAN_PURGE'
,p_column_display_sequence=>10
,p_column_heading=>'Can be purged?'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(23482928300634173)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(499410144971419)
,p_name=>'Table Columns'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.column_name,',
'         initcap(t.data_type) data_type,',
'         decode(t.data_type,''NUMBER'',null,t.data_length) data_length,',
'         t.data_precision,',
'         t.data_scale,',
'         wwv_flow_sw_util.get_pk_position (t.owner,t.table_name,t.column_name) pk,',
'decode(t.nullable,''Y'',''<span class="a-Icon icon-check"></span>'',null) nullable,',
'         t.data_default,',
'         t.column_id,',
'         substr(c.comments,1,3000) comments',
'from sys.dba_tab_columns t, sys.dba_col_comments c',
'where t.column_name = c.column_name               ',
'  and t.table_name = :P401_OBJECT_NAME',
'  and c.table_name = :P401_OBJECT_NAME',
'  and t.owner = :P401_OBJECT_OWNER',
'order by t.column_id'))
,p_display_when_condition=>'P401_OBJECT_TYPE'
,p_display_when_cond2=>'TABLE'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'<span class="instructiontext">No columns found.</span>'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(499624525971424)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(499732289971424)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(499827940971424)
,p_query_column_id=>3
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>4
,p_column_heading=>'Length'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(499932389971424)
,p_query_column_id=>4
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>5
,p_column_heading=>'Precision'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(500032050971424)
,p_query_column_id=>5
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>6
,p_column_heading=>'Scale'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(500105274971424)
,p_query_column_id=>6
,p_column_alias=>'PK'
,p_column_display_sequence=>1
,p_column_heading=>'Primary Key'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(500223719971425)
,p_query_column_id=>7
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>7
,p_column_heading=>'Nullable'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(500303898971425)
,p_query_column_id=>8
,p_column_alias=>'DATA_DEFAULT'
,p_column_display_sequence=>8
,p_column_heading=>'Default'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(500425198971425)
,p_query_column_id=>9
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>9
,p_column_heading=>'Column Id'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(500526057971425)
,p_query_column_id=>10
,p_column_alias=>'COMMENTS'
,p_column_display_sequence=>10
,p_column_heading=>'Comments'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(506831316005926)
,p_name=>'Index Summary'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select OWNER,',
'       INDEX_NAME,',
'       INDEX_TYPE,',
'       TABLE_OWNER,',
'       TABLE_NAME,',
'       TABLE_TYPE,',
'       UNIQUENESS,',
'       COMPRESSION,',
'       PREFIX_LENGTH,',
'       TABLESPACE_NAME,',
'       STATUS,',
'       LAST_ANALYZED',
' from sys.dba_indexes i',
'where i.index_name = :P401_OBJECT_NAME',
'and i.owner = :P401_OBJECT_OWNER'))
,p_display_when_condition=>'P401_OBJECT_TYPE'
,p_display_when_cond2=>'NORMAL_INDEX:INDEX'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(277999816507196427)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(277999924067196428)
,p_query_column_id=>2
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Index Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000013408196428)
,p_query_column_id=>3
,p_column_alias=>'INDEX_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Index Type'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000110551196428)
,p_query_column_id=>4
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>4
,p_column_heading=>'Table Owner'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000217638196428)
,p_query_column_id=>5
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000301536196429)
,p_query_column_id=>6
,p_column_alias=>'TABLE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Table Type'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000412358196429)
,p_query_column_id=>7
,p_column_alias=>'UNIQUENESS'
,p_column_display_sequence=>7
,p_column_heading=>'Uniqueness'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000509329196429)
,p_query_column_id=>8
,p_column_alias=>'COMPRESSION'
,p_column_display_sequence=>8
,p_column_heading=>'Compression'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000624209196429)
,p_query_column_id=>9
,p_column_alias=>'PREFIX_LENGTH'
,p_column_display_sequence=>9
,p_column_heading=>'Prefix Length'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000717643196429)
,p_query_column_id=>10
,p_column_alias=>'TABLESPACE_NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Tablespace Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000831033196430)
,p_query_column_id=>11
,p_column_alias=>'STATUS'
,p_column_display_sequence=>11
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(278000910266196430)
,p_query_column_id=>12
,p_column_alias=>'LAST_ANALYZED'
,p_column_display_sequence=>12
,p_column_heading=>'Last Analyzed'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(565731416606686)
,p_name=>'Trigger Summary Information'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,',
'trigger_name,',
'trigger_type,',
'triggering_event,',
'table_owner,',
'base_object_type,',
'table_name,',
'column_name,',
'referencing_names,',
'when_clause,',
'status,',
'description,',
'action_type',
'from sys.dba_triggers',
'where trigger_name = :P401_OBJECT_NAME and owner = :P401_OBJECT_OWNER'))
,p_display_when_condition=>'P401_OBJECT_TYPE'
,p_display_when_cond2=>'TRIGGER'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(565924109606694)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566021271606694)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Trigger Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566126880606694)
,p_query_column_id=>3
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Trigger Type'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566211863606694)
,p_query_column_id=>4
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>4
,p_column_heading=>'Triggering Event'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566324866606694)
,p_query_column_id=>5
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Table Owner'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566410720606694)
,p_query_column_id=>6
,p_column_alias=>'BASE_OBJECT_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Base Object Type'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566522449606694)
,p_query_column_id=>7
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>7
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566609492606695)
,p_query_column_id=>8
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>8
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566704941606695)
,p_query_column_id=>9
,p_column_alias=>'REFERENCING_NAMES'
,p_column_display_sequence=>9
,p_column_heading=>'Referencing Names'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566829022606695)
,p_query_column_id=>10
,p_column_alias=>'WHEN_CLAUSE'
,p_column_display_sequence=>10
,p_column_heading=>'When Clause'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(566902023606695)
,p_query_column_id=>11
,p_column_alias=>'STATUS'
,p_column_display_sequence=>11
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(567013947606695)
,p_query_column_id=>12
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>12
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(567113619606695)
,p_query_column_id=>13
,p_column_alias=>'ACTION_TYPE'
,p_column_display_sequence=>13
,p_column_heading=>'Action Type'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(570014017620550)
,p_name=>'Trigger Body'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trigger_body',
'from sys.dba_triggers',
'where trigger_name = :P401_OBJECT_NAME and owner = :P401_OBJECT_OWNER'))
,p_display_when_condition=>'P401_OBJECT_TYPE'
,p_display_when_cond2=>'TRIGGER'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(570226900620552)
,p_query_column_id=>1
,p_column_alias=>'TRIGGER_BODY'
,p_column_display_sequence=>1
,p_column_heading=>'Trigger Body'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(278739423349285182)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(572503684721678)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(278739423349285182)
,p_button_name=>'PURGE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Object'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P401_CAN_PURGE = ''YES''',
'and :P401_OBJECT_TYPE in (''TABLE'', ''NORMAL_INDEX'', ''INDEX'')'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(563731632597236)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(278739423349285182)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(612020877142921)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(278739423349285182)
,p_button_name=>'RESTORE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Restore Object'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P401_CAN_UNDROP = ''YES''',
'and :P401_OBJECT_TYPE = ''TABLE'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(572805476721679)
,p_branch_name=>'Go To Page 1070'
,p_branch_action=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(572503684721678)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(616919313454755)
,p_branch_name=>'Go To Page 1070'
,p_branch_action=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(612020877142921)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(479427965863057)
,p_name=>'P401_OBJECT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(476219177851040)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(497007936961304)
,p_name=>'P401_OBJECT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(476219177851040)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(518214740029578)
,p_name=>'P401_OBJECT_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(476219177851040)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14575304481510701)
,p_name=>'P401_CAN_UNDROP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(476219177851040)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14576222189544219)
,p_name=>'P401_CAN_PURGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(476219177851040)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46243200227025823)
,p_name=>'P401_OBJECT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(476219177851040)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1500323633186760220)
,p_name=>'P401_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(278739423349285182)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(574207624732252)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_base_object number;',
'    l_msg         varchar2(32767);',
'begin',
'select base_object into l_base_object ',
'  from sys.dba_recyclebin',
' where purge_object = :P401_OBJECT_ID;',
'',
'',
'for c1 in (',
'     select owner, object_name, type',
'     from sys.dba_recyclebin',
'     where purge_object = l_base_object ',
') loop',
'    l_msg := wwv_flow_sw_page_calls.purge_object(c1.object_name,c1.owner,c1.type);',
'end loop;',
'',
'if l_msg <> ''SUCCESS'' then',
'        raise_application_error( -20999, l_msg );',
'end if;',
'',
'--:P402_MSG := wwv_flow_sw_page_calls.purge_object(l_owner,:P401_OBJECT_OWNER,:P401_OBJECT_TYPE);',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(572503684721678)
,p_process_when=>'P401_CAN_PURGE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'YES'
,p_process_success_message=>'Object purged successfully.'
,p_internal_uid=>574207624732252
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(615905115450652)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'restore object'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_base_object number;',
'    l_msg         varchar2(32767);',
'begin',
'  select base_object into l_base_object ',
'    from sys.dba_recyclebin',
'   where purge_object = :P401_OBJECT_ID',
'     and can_undrop = ''YES'';',
'',
'',
'  for c1 in (',
'     select owner, object_name, type',
'     from sys.dba_recyclebin',
'     where purge_object = l_base_object ',
'  )loop',
'    l_msg := wwv_flow_sw_page_calls.restore_object(c1.object_name,c1.owner,c1.type);',
'  end loop;',
'',
'  if l_msg <> ''SUCCESS'' then',
'      raise_application_error( -20999, l_msg );',
'  end if;',
'',
'--:P402_MSG := wwv_flow_sw_page_calls.restore_object(:P401_OBJECT_NAME,:P401_OBJECT_OWNER,:P401_OBJECT_TYPE);',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(612020877142921)
,p_process_when=>'P401_CAN_UNDROP'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'YES'
,p_process_success_message=>'Object restored successfully.'
,p_internal_uid=>615905115450652
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(46245924599042376)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values based on object id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'     select owner, object_name, type, can_undrop, can_purge',
'     from sys.dba_recyclebin',
'     where purge_object = :P401_OBJECT_ID',
') loop',
'     :P401_OBJECT_OWNER := c1.owner;',
'     :P401_OBJECT_NAME  := c1.object_name;',
'     :P401_OBJECT_TYPE  := c1.type;',
'     :P401_CAN_UNDROP   := c1.can_undrop;',
'     :P401_CAN_PURGE    := c1.can_purge;',
'end loop; ',
'',
'wwv_flow_sw_api.check_priv ( p_schema => :P401_OBJECT_OWNER );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>46245924599042376
);
end;
/
prompt --application/pages/page_00403
begin
wwv_flow_imp_page.create_page(
 p_id=>403
,p_name=>'Purge Recycle Bin'
,p_alias=>'PURGE-RECYCLE-BIN'
,p_page_mode=>'MODAL'
,p_step_title=>'Purge Recycle Bin'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215661000733996927)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEUTL/sql_utl_rcycl_empty.htm'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12915923927664202)
,p_plug_name=>'Purge Recycle Bin'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Please confirm your request to purge the Recycle Bin.</p>',
'',
'<p>If you decide that you are never going to restore objects from the Recycle Bin, you can purge them.  Purging the Recycle Bin removes <strong>all</strong> objects and releases their storage space.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select 1 from sys.dba_recyclebin where owner = nvl(:P400_SCHEMA,wwv_flow_user_api.get_default_schema)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(157938819580413996)
,p_plug_name=>'Recycle Bin Empty'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>40
,p_plug_source=>'<p>Recycle Bin is empty and cannot be purged.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>'select 1 from sys.dba_recyclebin where owner = nvl(:P400_SCHEMA,wwv_flow_user_api.get_default_schema)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(722737454749798602)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12926028785741314)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(722737454749798602)
,p_button_name=>'PURGE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge Recycle Bin'
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from sys.dba_recyclebin where owner = nvl(:P400_SCHEMA,wwv_flow_user_api.get_default_schema)'
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722737538240798603)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(722737454749798602)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1119154104615390604)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(722737538240798603)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1119154226953390605)
,p_event_id=>wwv_flow_imp.id(1119154104615390604)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12930701043780683)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge recyclebin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_msg varchar2(32767);',
'begin',
'    l_msg := wwv_flow_sw_page_calls.purge_recyclebin(:P400_SCHEMA);',
'    if l_msg <> ''SUCCESS'' then',
'        raise_application_error( -20999, l_msg );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(12926028785741314)
,p_internal_uid=>12930701043780683
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(722737639681798604)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(12926028785741314)
,p_process_success_message=>'Recyclebin purged.'
,p_internal_uid=>722737639681798604
);
end;
/
prompt --application/pages/page_00500
begin
wwv_flow_imp_page.create_page(
 p_id=>500
,p_name=>'All Objects'
,p_alias=>'ALL-OBJECTS'
,p_step_title=>'All Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215533113079716670)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8298414867976068)
,p_plug_name=>'Schema in Jog'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441220613960112851)
,p_plug_name=>'Database Object Results'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :F4500_P500_SCHEMA object_owner,',
'       object_name, ',
'       status, ',
'       object_type object_type,',
'       created date_created,',
'       nvl(LAST_DDL_TIME,created) lastddltime,',
'       case',
'       when object_type in (''TYPE BODY'', ''PACKAGE BODY'')',
'       then ( select to_char(o2.object_id)',
'                from sys.user_objects o2',
'               where o2.object_name = o.object_name',
'                 and o2.object_type = replace(o.object_type, '' BODY'', null) )',
'       when object_type = ''LOB''',
'       then ( select to_char(o2.object_id)',
'                from sys.user_objects o2,',
'                     sys.user_lobs l',
'               where o2.object_name = l.table_name',
'                 and l.segment_name = o.object_name )',
'       when object_type = ''DATABASE LINK''',
'       -- keep this logic in sync with wwv_flow_f4500_ob_wiz_dev.get_object_id ( private ) function',
'       then to_char(ora_hash( object_name, 1000000000, power( 2, 30 ) ))',
'       else to_char(object_id)',
'       end object_id',
'  from sys.user_objects o',
' where object_name not like ''BIN$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'F4500_P500_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441220719108112851)
,p_name=>'Database Object Results'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441220915412112864)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441221010045112865)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Object Name'
,p_column_link=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:RP,2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:#OBJECT_OWNER#,#OBJECT_ID#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441221132283112866)
,p_db_column_name=>'STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441221201214112867)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441221329379112868)
,p_db_column_name=>'DATE_CREATED'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441221422134112869)
,p_db_column_name=>'LASTDDLTIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Last DDL'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441221518897112870)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'ID'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441222102992115206)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318124956536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OBJECT_OWNER:OBJECT_NAME:STATUS:OBJECT_TYPE:DATE_CREATED:LASTDDLTIME:OBJECT_ID'
,p_sort_column_1=>'OBJECT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722739336427798621)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(441220613960112851)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.::'
,p_icon_css_classes=>'fa-undo'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33071078540256522)
,p_branch_action=>'500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33071617059256525)
,p_name=>'F4500_P500_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8298414867976068)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select a schema (username) you want to view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(101429917448484868)
,p_computation_sequence=>10
,p_computation_item=>'LAST_SELECTED_PARSE_AS'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4500_P500_SCHEMA'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(276391831864372049)
,p_computation_sequence=>20
,p_computation_item=>'F4500_P500_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'F4500_P500_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48602961334414461)
,p_computation_sequence=>30
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'500'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(128711215402133951)
,p_validation_name=>'must select schema'
,p_validation_sequence=>10
,p_validation=>'F4500_P500_SCHEMA'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Oracle Schema (USER NAME) must be specified.'
,p_associated_item=>wwv_flow_imp.id(33071617059256525)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69259125073778677)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:F4500_P500_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69259125073778677
);
end;
/
prompt --application/pages/page_00540
begin
wwv_flow_imp_page.create_page(
 p_id=>540
,p_name=>'Sessions'
,p_alias=>'SESSIONS'
,p_step_title=>'Sessions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(159560000024320866)
,p_name=>'Sessions Query'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid, inst_id from sys.gv_$mystat where rownum = 1), ',
'vs as (select inst_id, rownum rnum,sid,status,username,last_call_et,',
'              command,machine,osuser,module,action,resource_consumer_group,',
'              client_info,client_identifier,type,terminal',
'         from sys.gv_$session) ',
' select case when (select sid from my_s where rownum = 1) = vs.sid then  ',
'                  ''C'' ',
'             when vs.status = ''ACTIVE'' then ',
'                  case when last_call_et > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  vs.status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status, vs.sid,',
'        vs.username,',
'        case when vs.status = ''ACTIVE'' ',
'                  then last_call_et ',
'             else null end seconds_in_wait,',
'        decode(vs.command,  ',
'         0,null, ',
'         1,''CRE TAB'', ',
'         2,''INSERT'', ',
'         3,''SELECT'', ',
'         4,''CRE CLUSTER'', ',
'         5,''ALT CLUSTER'', ',
'         6,''UPDATE'', ',
'         7,''DELETE'', ',
'         8,''DRP CLUSTER'', ',
'         9,''CRE INDEX'', ',
'         10,''DROP INDEX'', ',
'         11,''ALT INDEX'', ',
'         12,''DROP TABLE'', ',
'         13,''CRE SEQ'', ',
'         14,''ALT SEQ'', ',
'         15,''ALT TABLE'', ',
'         16,''DROP SEQ'', ',
'         17,''GRANT'', ',
'         18,''REVOKE'', ',
'         19,''CRE SYN'', ',
'         20,''DROP SYN'', ',
'         21,''CRE VIEW'', ',
'         22,''DROP VIEW'', ',
'         23,''VAL INDEX'', ',
'         24,''CRE PROC'', ',
'         25,''ALT PROC'', ',
'         26,''LOCK TABLE'', ',
'         28,''RENAME'', ',
'         29,''COMMENT'', ',
'         30,''AUDIT'', ',
'         31,''NOAUDIT'', ',
'         32,''CRE DBLINK'', ',
'         33,''DROP DBLINK'', ',
'         34,''CRE DB'', ',
'         35,''ALTER DB'', ',
'         36,''CRE RBS'', ',
'         37,''ALT RBS'', ',
'         38,''DROP RBS'', ',
'         39,''CRE TBLSPC'', ',
'         40,''ALT TBLSPC'', ',
'         41,''DROP TBLSPC'', ',
'         42,''ALT SESSION'', ',
'         43,''ALT USER'', ',
'         44,''COMMIT'', ',
'         45,''ROLLBACK'', ',
'         46,''SAVEPOINT'', ',
'         47,''PL/SQL EXEC'', ',
'         48,''SET XACTN'', ',
'         49,''SWITCH LOG'', ',
'         50,''EXPLAIN'', ',
'         51,''CRE USER'', ',
'         52,''CRE ROLE'', ',
'         53,''DROP USER'', ',
'         54,''DROP ROLE'', ',
'         55,''SET ROLE'', ',
'         56,''CRE SCHEMA'', ',
'         57,''CRE CTLFILE'', ',
'         58,''ALTER TRACING'', ',
'         59,''CRE TRIGGER'', ',
'         60,''ALT TRIGGER'', ',
'         61,''DRP TRIGGER'', ',
'         62,''ANALYZE TAB'', ',
'         63,''ANALYZE IX'', ',
'         64,''ANALYZE CLUS'', ',
'         65,''CRE PROFILE'', ',
'         66,''DRP PROFILE'', ',
'         67,''ALT PROFILE'', ',
'         68,''DRP PROC'', ',
'         69,''DRP PROC'', ',
'         70,''ALT RESOURCE'', ',
'         71,''CRE SNPLOG'', ',
'         72,''ALT SNPLOG'', ',
'         73,''DROP SNPLOG'', ',
'         74,''CREATE SNAP'', ',
'         75,''ALT SNAP'', ',
'         76,''DROP SNAP'', ',
'         79,''ALTER ROLE'', ',
'         79,''ALTER ROLE'', ',
'         85,''TRUNC TAB'', ',
'         86,''TRUNC CLUST'', ',
'         88,''ALT VIEW'', ',
'         91,''CRE FUNC'', ',
'         92,''ALT FUNC'', ',
'         93,''DROP FUNC'', ',
'         94,''CRE PKG'', ',
'         95,''ALT PKG'', ',
'         96,''DROP PKG'', ',
'         97,''CRE PKG BODY'', ',
'         98,''ALT PKG BODY'', ',
'         99,''DRP PKG BODY'', ',
'         to_char(vs.command)) command,',
'        case when length(vs.machine) > 15 then substr(vs.machine,1,15)||''...''  ',
'             else lower(vs.machine) end machine,',
'        vs.machine machine2,',
'        vs.osuser, ',
'        initcap(vs.status) status,',
'        case when length(vs.module) > 15 then substr(vs.module,1,15)||''...''',
'             else vs.module end module,',
'        vs.module module2,',
'        case when length(vs.action) > 15 then substr(vs.action,1,15)||''...'' ',
'             else vs.action end action,',
'        vs.action action2,',
'        vs.resource_consumer_group,vs.client_info,vs.client_identifier,',
'         -- 10g only blocking_session,',
'        vs.inst_id',
'   from vs ',
'  where vs.USERNAME is not null',
'    and nvl(vs.osuser,''x'') <> ''SYSTEM''',
'    and vs.type <> ''BACKGROUND''',
'    and (:P540_STATUS = ''ALL'' or (:P540_STATUS = ''ACTIVE'' and vs.status = ''ACTIVE''))',
'    and (:P540_SEARCH is null',
'        or',
'        (:P540_SEARCH is not null',
'         and',
'            (vs.username like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.osuser) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.machine) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.module) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.client_info) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or ',
'             upper(vs.client_identifier) like ''%''||upper(:P540_SEARCH)||''%'' ',
'             or',
'             to_char(vs.sid) = :P540_SEARCH',
'            )',
'         )',
'    )',
'   '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No sessions found'
,p_query_num_rows_item=>'P540_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030035934459536811)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Session Status'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159560724478320875)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159560320922320875)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Database<br />User'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159561608504320876)
,p_query_column_id=>4
,p_column_alias=>'SECONDS_IN_WAIT'
,p_column_display_sequence=>6
,p_column_heading=>'Seconds<br />in<br />Database'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159561806964320876)
,p_query_column_id=>5
,p_column_alias=>'COMMAND'
,p_column_display_sequence=>5
,p_column_heading=>'Command'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>3
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036034320536812)
,p_query_column_id=>6
,p_column_alias=>'MACHINE'
,p_column_display_sequence=>7
,p_column_heading=>'Machine'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036153860536813)
,p_query_column_id=>7
,p_column_alias=>'MACHINE2'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036203488536814)
,p_query_column_id=>8
,p_column_alias=>'OSUSER'
,p_column_display_sequence=>9
,p_column_heading=>'OS User'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036357969536815)
,p_query_column_id=>9
,p_column_alias=>'STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036433316536816)
,p_query_column_id=>10
,p_column_alias=>'MODULE'
,p_column_display_sequence=>11
,p_column_heading=>'Module'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036592847536817)
,p_query_column_id=>11
,p_column_alias=>'MODULE2'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036642525536818)
,p_query_column_id=>12
,p_column_alias=>'ACTION'
,p_column_display_sequence=>13
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036712262536819)
,p_query_column_id=>13
,p_column_alias=>'ACTION2'
,p_column_display_sequence=>14
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036826358536820)
,p_query_column_id=>14
,p_column_alias=>'RESOURCE_CONSUMER_GROUP'
,p_column_display_sequence=>15
,p_column_heading=>'Resource Consumer Group'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030036926884536821)
,p_query_column_id=>15
,p_column_alias=>'CLIENT_INFO'
,p_column_display_sequence=>16
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1030037057648536822)
,p_query_column_id=>16
,p_column_alias=>'CLIENT_IDENTIFIER'
,p_column_display_sequence=>17
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18811011728799476)
,p_query_column_id=>17
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Instance ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159573010728350258)
,p_plug_name=>'Session Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_imp.id(159562414490322899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159576332199356488)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(159580715492370509)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(159576332199356488)
,p_button_name=>'P540_GO'
,p_button_static_id=>'P540_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159580928891370510)
,p_branch_action=>'f?p=&FLOW_ID.:540:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159579603887366941)
,p_name=>'P540_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(159576332199356488)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter search criteria to search the following fields and click <strong>Go</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Database User</li>',
'<li>Machine</li>',
'<li>OS User</li>',
'<li>Client Information</li>',
'<li>Client Identifier</li>',
'<li>Module</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159602622343467194)
,p_name=>'P540_ROWS'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_imp.id(159576332199356488)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of sessions to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159860516070913064)
,p_name=>'P540_COLUMNS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(159576332199356488)
,p_item_default=>'MORE'
,p_prompt=>'Show'
,p_source=>'MORE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MORE_LESS_COLUMNS'
,p_lov=>'.'||wwv_flow_imp.id(161595731562973452)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Make a selection to restrict or expand the number of displayed columns and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159922305306032954)
,p_name=>'P540_STATUS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(159576332199356488)
,p_item_default=>'ACTIVE'
,p_prompt=>'Status'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION MONITORING STATUS'
,p_lov=>'.'||wwv_flow_imp.id(159923116388036162)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Narrow the display by selecting a status and clicking <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(159928527517067731)
,p_computation_sequence=>10
,p_computation_item=>'P540_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'ACTIVE'
,p_compute_when=>'P540_STATUS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(166559913619454189)
,p_computation_sequence=>10
,p_computation_item=>'P540_COLUMNS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'MORE'
,p_compute_when=>'P540_COLUMNS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(159606011177482895)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(159580715492370509)
,p_internal_uid=>159606011177482895
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(166556909332443474)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set More / Less on other pages'
,p_process_sql_clob=>':P548_COLUMNS := nvl(:P540_COLUMNS,''MORE'');'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>166556909332443474
);
end;
/
prompt --application/pages/page_00541
begin
wwv_flow_imp_page.create_page(
 p_id=>541
,p_name=>'Session Locks'
,p_alias=>'SESSION-LOCKS'
,p_step_title=>'Locks'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_help_text=>'AEUTL/dbadm_sessions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160154029453569089)
,p_plug_name=>'Session Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_imp.id(159562414490322899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160154225031569089)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(201909305328005313)
,p_name=>'Session Locks'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with locks as(',
'    select session_id,lock_type,',
'           mode_held,mode_requested,lock_id1,lock_id2,blocking_others',
'      from sys.dba_lock),',
'waiters as (',
'    select w.session_id waiting_session,',
'            h.session_id holding_session,',
'            w.lock_type lock_type,',
'            h.mode_held mode_held,',
'            w.mode_requested mode_requested,',
'            w.lock_id1,',
'            w.lock_id2',
'      from locks w, locks h',
'     where h.blocking_others =  ''Blocking''',
'      and  h.mode_held      !=  ''None''',
'      and  h.mode_held      !=  ''Null''',
'      and  w.mode_requested !=  ''None''',
'      and  w.lock_type       =  h.lock_type',
'      and  w.lock_id1        =  h.lock_id1',
'      and  w.lock_id2        =  h.lock_id2),',
'blockers as(',
'    select holding_session waiting_session, to_number(null) holding_session,',
'           ''None'' lock_type, null mode_held, null mode_requested,',
'           null lock_id1, null lock_id2',
'      from waiters',
'     minus',
'    select waiting_session waiting_session, to_number(null) holding_session,',
'           ''None'' lock_type, null mode_held, null mode_requested,',
'           null lock_id1, null lock_id2',
'      from waiters),',
'waiters_blockers as(',
'    select waiting_session,holding_session,lock_type,mode_held,mode_requested,lock_id1,lock_id2',
'      from waiters',
'     union all',
'    select waiting_session,holding_session,lock_type,mode_held,mode_requested,lock_id1,lock_id2',
'      from blockers),',
'lock_objects as(',
'    select session_id,cnt lock_obj_count,',
'           case when cnt = 1 then object_name',
'                else null end object_name,',
'           object_id,owner,object_type',
'      from(',
'        select session_id,count(distinct object_name) cnt,max(object_name) object_name,',
'               max(lo.object_id) object_id, max(ao.owner) owner,max(object_type) object_type',
'          from sys.gv_$locked_object lo,sys.dba_objects ao',
'         where lo.object_id = ao.object_id',
'         group by session_id)),',
'wait_block_ses as(',
'select waiting_session,holding_session,lock_type,mode_held,mode_requested,',
'       s.username,s.osuser,s.CLIENT_INFO,s.CLIENT_IDENTIFIER,o.object_name,o.owner,o.object_id,module,o.object_type,o.lock_obj_count,s.inst_id,',
'        decode(s.command,',
'         0,null,',
'         1,''CRE TAB'',',
'         2,''INSERT'',',
'         3,''SELECT'',',
'         4,''CRE CLUSTER'',',
'         5,''ALT CLUSTER'',',
'         6,''UPDATE'',',
'         7,''DELETE'',',
'         8,''DRP CLUSTER'',',
'         9,''CRE INDEX'',',
'         10,''DROP INDEX'',',
'         11,''ALT INDEX'',',
'         12,''DROP TABLE'',',
'         13,''CRE SEQ'',',
'         14,''ALT SEQ'',',
'         15,''ALT TABLE'',',
'         16,''DROP SEQ'',',
'         17,''GRANT'',',
'         18,''REVOKE'',',
'         19,''CRE SYN'',',
'         20,''DROP SYN'',',
'         21,''CRE VIEW'',',
'         22,''DROP VIEW'',',
'         23,''VAL INDEX'',',
'         24,''CRE PROC'',',
'         25,''ALT PROC'',',
'         26,''LOCK TABLE'',',
'         28,''RENAME'',',
'         29,''COMMENT'',',
'         30,''AUDIT'',',
'         31,''NOAUDIT'',',
'         32,''CRE DBLINK'',',
'         33,''DROP DBLINK'',',
'         34,''CRE DB'',',
'         35,''ALTER DB'',',
'         36,''CRE RBS'',',
'         37,''ALT RBS'',',
'         38,''DROP RBS'',',
'         39,''CRE TBLSPC'',',
'         40,''ALT TBLSPC'',',
'         41,''DROP TBLSPC'',',
'         42,''ALT SESSION'',',
'         43,''ALT USER'',',
'         44,''COMMIT'',',
'         45,''ROLLBACK'',',
'         46,''SAVEPOINT'',',
'         47,''PL/SQL EXEC'',',
'         48,''SET XACTN'',',
'         49,''SWITCH LOG'',',
'         50,''EXPLAIN'',',
'         51,''CRE USER'',',
'         52,''CRE ROLE'',',
'         53,''DROP USER'',',
'         54,''DROP ROLE'',',
'         55,''SET ROLE'',',
'         56,''CRE SCHEMA'',',
'         57,''CRE CTLFILE'',',
'         58,''ALTER TRACING'',',
'         59,''CRE TRIGGER'',',
'         60,''ALT TRIGGER'',',
'         61,''DRP TRIGGER'',',
'         62,''ANALYZE TAB'',',
'         63,''ANALYZE IX'',',
'         64,''ANALYZE CLUS'',',
'         65,''CRE PROFILE'',',
'         66,''DRP PROFILE'',',
'         67,''ALT PROFILE'',',
'         68,''DRP PROC'',',
'         69,''DRP PROC'',',
'         70,''ALT RESOURCE'',',
'         71,''CRE SNPLOG'',',
'         72,''ALT SNPLOG'',',
'         73,''DROP SNPLOG'',',
'         74,''CREATE SNAP'',',
'         75,''ALT SNAP'',',
'         76,''DROP SNAP'',',
'         79,''ALTER ROLE'',',
'         79,''ALTER ROLE'',',
'         85,''TRUNC TAB'',',
'         86,''TRUNC CLUST'',',
'         88,''ALT VIEW'',',
'         91,''CRE FUNC'',',
'         92,''ALT FUNC'',',
'         93,''DROP FUNC'',',
'         94,''CRE PKG'',',
'         95,''ALT PKG'',',
'         96,''DROP PKG'',',
'         97,''CRE PKG BODY'',',
'         98,''ALT PKG BODY'',',
'         99,''DRP PKG BODY'',',
'         to_char(s.command)) command',
'  from waiters_blockers wb, sys.gv_$session s,',
'       lock_objects o',
' where s.sid = wb.waiting_session',
'   and o.session_id(+) = wb.waiting_session',
'  ),',
'ws_schemas as(',
'    select schema',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id)',
'select  case when holding_session is null then ''B''',
'             else ''D''',
'       end session_status,',
'       decode(level,1,1,power(level*3,2)) padding,',
'       level lvl,',
'       waiting_session,',
'       holding_session,',
'       username,',
'       osuser,',
'       client_info,',
'       client_identifier,',
'       inst_id,',
'       case when lock_obj_count = 1 then',
'            case when owner in (select schema from ws_schemas) then',
'                ''<a href="''||wwv_flow_page_api.get_url(',
'                                 p_page        => 2000,',
'                                 p_clear_cache => ''RP,2000'',',
'                                 p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'',',
'                                 p_values      => owner||'',''||object_id )||''">''||object_name||''</a>''',
'            else object_name end',
'        else ''<br />'' end object_name,',
'       object_id,owner,module,object_type',
'  from wait_block_ses',
' start with holding_session is null',
' connect by prior waiting_session = holding_session'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No locks exist'
,p_query_num_rows_item=>'P541_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1104686689608514408)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Session status'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201909801727005344)
,p_query_column_id=>2
,p_column_alias=>'PADDING'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201909915384005344)
,p_query_column_id=>3
,p_column_alias=>'LVL'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910003086005345)
,p_query_column_id=>4
,p_column_alias=>'WAITING_SESSION'
,p_column_display_sequence=>4
,p_column_heading=>'SID'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#WAITING_SESSION#,#INST_ID#'
,p_column_linktext=>'#WAITING_SESSION#'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910100459005345)
,p_query_column_id=>5
,p_column_alias=>'HOLDING_SESSION'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910215980005346)
,p_query_column_id=>6
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>7
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910317370005346)
,p_query_column_id=>7
,p_column_alias=>'OSUSER'
,p_column_display_sequence=>8
,p_column_heading=>'Osuser'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910415010005346)
,p_query_column_id=>8
,p_column_alias=>'CLIENT_INFO'
,p_column_display_sequence=>9
,p_column_heading=>'Client Info'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910509766005346)
,p_query_column_id=>9
,p_column_alias=>'CLIENT_IDENTIFIER'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(19584330054508562)
,p_query_column_id=>10
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Instance ID'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910617106005346)
,p_query_column_id=>11
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>13
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910728257005346)
,p_query_column_id=>12
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>14
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910831228005346)
,p_query_column_id=>13
,p_column_alias=>'OWNER'
,p_column_display_sequence=>12
,p_column_heading=>'Object Owner'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(201910926632005346)
,p_query_column_id=>14
,p_column_alias=>'MODULE'
,p_column_display_sequence=>11
,p_column_heading=>'Module'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203542111299338200)
,p_query_column_id=>15
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>15
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(160155109735569098)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(160154225031569089)
,p_button_name=>'P541_GO'
,p_button_static_id=>'P541_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(160156623684569105)
,p_branch_action=>'f?p=&FLOW_ID.:541:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160155305071569098)
,p_name=>'P541_ROWS'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_imp.id(160154225031569089)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of sessions to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(160156419438569104)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>160156419438569104
);
end;
/
prompt --application/pages/page_00542
begin
wwv_flow_imp_page.create_page(
 p_id=>542
,p_name=>'Session SQL'
,p_alias=>'SESSION-SQL'
,p_step_title=>'SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(159946628564101172)
,p_name=>'Sessions SQL'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid from sys.gv_$mystat where rownum = 1),',
'system_msg_prv as (',
'    select rownum, wwv_flow_lang.system_message(''SESSION_MON_PREVIOUS'') the_message from sys.dual),',
'system_msg_cur as (',
'    select rownum,wwv_flow_lang.system_message(''SESSION_MON_CURRENT'') the_message from sys.dual)',
' select case when (select sid from my_s where rownum = 1) = sid then  ',
'                  ''C'' ',
'             when status = ''ACTIVE'' then ',
'                  case when last_call_et > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status, sid,',
'        username,current_previous,inst_id,',
'        case when vs.status = ''ACTIVE'' ',
'                 then last_call_et ',
'             else null end seconds_in_wait,',
'        case when length(sql_text) > decode(:P542_COLUMNS,''LESS'',125,75)',
'             then substr(replace(sql_text,'','','', ''),1,decode(:P542_COLUMNS,''LESS'',125,75))||''...''',
'             else replace(sql_text,'','','', '') end sql_text,',
'             sql_text full_sql,address,hash_value,child_number,',
'             case when exists (select 1 cnt from sys.gv_$sql_plan p ',
'                         where p.address = vs.address ',
'                           and vs.hash_value = p.hash_value',
'                           and vs.child_number = p.child_number',
'                           and vs.inst_id = p.inst_id) ',
'                  then ''<a href="f?p=''||:APP_ID||'':551:''||:APP_SESSION||''::NO::P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER,P551_INST_ID:''||',
'                       vs.address||'',''||vs.hash_value||'',''||vs.child_number||'',''||vs.inst_id ||''">''||',
'                            wwv_flow_escape.html(',
'                            case when length(sql_text) > decode(:P542_COLUMNS,''LESS'',125,75)',
'                             then substr(replace(sql_text,'','','', ''),1,decode(:P542_COLUMNS,''LESS'',125,75))||''...''',
'                             else replace(sql_text,'','','', '')',
'                            end) ||',
'                       ''</a>''',
'                else wwv_flow_escape.html(',
'                     case when length(sql_text) > decode(:P542_COLUMNS,''LESS'',125,75)',
'                     then substr(replace(sql_text,'','','', ''),1,decode(:P542_COLUMNS,''LESS'',125,75))||''...''',
'                     else replace(sql_text,'','','', '')',
'                     end )',
'                end link1',
'   from   ',
'   (select s.sid,s.inst_id,s.status,s.last_call_et SECONDS_IN_WAIT,s.username,',
'                (select the_message from system_msg_cur where rownum = 1) current_previous,',
'                sql_text,fetches,executions,parse_calls,disk_reads,cpu_time,elapsed_time,',
'                q.address,q.hash_value,q.child_number,last_call_et',
'           from sys.gv_$session s, sys.gv_$sql q',
'          where s.sql_id is not null',
'            and s.inst_id = q.inst_id',
'            and s.sql_address = q.address',
'            and s.sql_hash_value = q.hash_value',
'            and s.USERNAME is not null',
'            and nvl(s.osuser,''x'') <> ''SYSTEM''',
'            and s.type <> ''BACKGROUND''',
'          union',
'         select s.sid,s.inst_id,s.status,s.last_call_et SECONDS_IN_WAIT,s.username,',
'                (select the_message from system_msg_prv where rownum = 1) current_previous,',
'                sql_text,fetches,executions,parse_calls,disk_reads,cpu_time,elapsed_time,',
'                q.address,q.hash_value,q.child_number,last_call_et',
'           from sys.gv_$session s, sys.gv_$sql q',
'          where s.sql_id is null',
'            and s.inst_id = q.inst_id',
'            and s.prev_sql_addr = q.address',
'            and s.prev_hash_value = q.hash_value',
'            and s.USERNAME is not null',
'            and nvl(s.osuser,''x'') <> ''SYSTEM''',
'            and s.type <> ''BACKGROUND'') vs',
'  where 1=1',
'    and (:P542_STATUS = ''ALL'' or (:P542_STATUS = ''ACTIVE'' and vs.status = ''ACTIVE''))',
'    and (:P542_SEARCH is null',
'        or',
'        (:P542_SEARCH is not null',
'         and',
'            (vs.username like ''%''||upper(:P542_SEARCH)||''%'' ',
'             or ',
'             upper(vs.sql_text) like ''%''||upper(:P542_SEARCH)||''%''',
'             or',
'             to_char(vs.sid) = :P542_SEARCH ',
'            )',
'         )',
'        )'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No sessions found'
,p_query_num_rows_item=>'P542_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1104686955361514411)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Session status'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159947413171101175)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159947128376101174)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Database<br />User'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160121010032450640)
,p_query_column_id=>4
,p_column_alias=>'CURRENT_PREVIOUS'
,p_column_display_sequence=>5
,p_column_heading=>'Current<br />Previous'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18825904174327086)
,p_query_column_id=>5
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Instance ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160123809471459968)
,p_query_column_id=>6
,p_column_alias=>'SECONDS_IN_WAIT'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159960931962162045)
,p_query_column_id=>7
,p_column_alias=>'SQL_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'SQL'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#LINK1#'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162148513532035585)
,p_query_column_id=>8
,p_column_alias=>'FULL_SQL'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160447305278223756)
,p_query_column_id=>9
,p_column_alias=>'ADDRESS'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160447417088223757)
,p_query_column_id=>10
,p_column_alias=>'HASH_VALUE'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160455710276386082)
,p_query_column_id=>11
,p_column_alias=>'CHILD_NUMBER'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166648819224335782)
,p_query_column_id=>12
,p_column_alias=>'LINK1'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159948329119101177)
,p_plug_name=>'Session Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_imp.id(159562414490322899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159948526162101178)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(159949431390101180)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(159948526162101178)
,p_button_name=>'P542_GO'
,p_button_static_id=>'P542_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159950911378101184)
,p_branch_action=>'f?p=&FLOW_ID.:542:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159948921511101179)
,p_name=>'P542_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(159948526162101178)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter search criteria to search the following fields and click <strong>Go</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Database User</li>',
'<li>SQL</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159949601014101181)
,p_name=>'P542_ROWS'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_imp.id(159948526162101178)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of sessions to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159950109461101182)
,p_name=>'P542_COLUMNS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(159948526162101178)
,p_item_default=>'MORE'
,p_prompt=>'Show'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MORE_LESS_COLUMNS'
,p_lov=>'.'||wwv_flow_imp.id(161595731562973452)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Make a selection to restrict or expand the number of displayed columns and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159950311811101182)
,p_name=>'P542_STATUS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(159948526162101178)
,p_item_default=>'ALL'
,p_prompt=>'Status'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION MONITORING STATUS'
,p_lov=>'.'||wwv_flow_imp.id(159923116388036162)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Narrow the display by selecting a status and clicking <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(159950521007101183)
,p_computation_sequence=>10
,p_computation_item=>'P542_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'ALL'
,p_compute_when=>'P542_STATUS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(159950714928101184)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>159950714928101184
);
end;
/
prompt --application/pages/page_00543
begin
wwv_flow_imp_page.create_page(
 p_id=>543
,p_name=>'Open Cursors'
,p_alias=>'OPEN-CURSORS'
,p_step_title=>'Open Cursors'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(160210418551732438)
,p_name=>'Open Cursors'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid from sys.gv_$mystat where rownum = 1), ',
'vs as (select * from sys.gv_$session),',
'oc as (select sid, inst_id, count(*) open_cursors from sys.gv_$open_cursor group by sid, inst_id)',
' select case when (select sid from my_s where rownum = 1) = vs.sid then  ',
'                  ''C'' ',
'             when vs.status = ''ACTIVE'' then ',
'                  case when last_call_et > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  vs.status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status, ',
'        vs.sid, oc.open_cursors, vs.username, vs.inst_id',
'   from vs, oc',
'  where vs.sid = oc.sid',
'    and vs.inst_id = oc.inst_id',
'    and vs.USERNAME > ''!''',
'    and nvl(vs.osuser,''x'') <> ''SYSTEM''',
'    and vs.type <> ''BACKGROUND''',
'    and (:P543_STATUS = ''ALL'' or (:P543_STATUS = ''ACTIVE'' and vs.status = ''ACTIVE''))',
'    and (:P543_SEARCH is null',
'        or',
'        (:P543_SEARCH is not null',
'         and',
'            (vs.username like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.osuser) like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.terminal) like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.module) like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.client_info) like ''%''||upper(:P543_SEARCH)||''%'' ',
'             or ',
'             upper(vs.sid) like ''%''||upper(:P543_SEARCH)||''%'' ',
'            )',
'         )',
'        )'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No sessions found'
,p_query_num_rows_item=>'P543_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1104687056530514412)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Session status'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160211228557732440)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160218014225754630)
,p_query_column_id=>3
,p_column_alias=>'OPEN_CURSORS'
,p_column_display_sequence=>5
,p_column_heading=>'Open Cursor Count'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.::P546_SID,P546_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#OPEN_CURSORS#'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160222612278763591)
,p_query_column_id=>4
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Database<br />User'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18826220020350671)
,p_query_column_id=>5
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Instance ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160212118897732441)
,p_plug_name=>'Session Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_imp.id(159562414490322899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160212320118732442)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(160213205206732444)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(160212320118732442)
,p_button_name=>'P543_GO'
,p_button_static_id=>'P543_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(160214724459732449)
,p_branch_action=>'f?p=&FLOW_ID.:543:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160212712536732443)
,p_name=>'P543_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(160212320118732442)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter search criteria to search the following fields and click <strong>Go</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Database User</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160213409142732444)
,p_name=>'P543_ROWS'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_imp.id(160212320118732442)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of sessions to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160214104600732447)
,p_name=>'P543_STATUS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(160212320118732442)
,p_item_default=>'ALL'
,p_prompt=>'Status'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION MONITORING STATUS'
,p_lov=>'.'||wwv_flow_imp.id(159923116388036162)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Restrict the results by selecting a status and clicking <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(160214330133732448)
,p_computation_sequence=>10
,p_computation_item=>'P543_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'ALL'
,p_compute_when=>'P543_STATUS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(160214523933732449)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>160214523933732449
);
end;
/
prompt --application/pages/page_00545
begin
wwv_flow_imp_page.create_page(
 p_id=>545
,p_name=>'Session IO'
,p_alias=>'SESSION-IO'
,p_step_title=>'I/O'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(159844815240842239)
,p_name=>'Session IO Query'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid from sys.gv_$mystat where rownum = 1), ',
'vs as (select *  ',
'          from sys.gv_$session),',
'io_s as (select sid, block_gets, consistent_gets, physical_reads, block_changes, consistent_changes, inst_id ',
'   from sys.gv_$sess_io) ',
' select case when (select sid from my_s where rownum = 1) = vs.sid then  ',
'                  ''C'' ',
'             when vs.status = ''ACTIVE'' then ',
'                  case when last_call_et > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  vs.status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status, vs.sid,',
'        vs.username,',
'        vs.inst_id,',
'        case when vs.status = ''ACTIVE'' ',
'                  then last_call_et ',
'             else null end seconds_in_wait,',
'        decode(vs.command,  ',
'         0,null, ',
'         1,''CRE TAB'', ',
'         2,''INSERT'', ',
'         3,''SELECT'', ',
'         4,''CRE CLUSTER'', ',
'         5,''ALT CLUSTER'', ',
'         6,''UPDATE'', ',
'         7,''DELETE'', ',
'         8,''DRP CLUSTER'', ',
'         9,''CRE INDEX'', ',
'         10,''DROP INDEX'', ',
'         11,''ALT INDEX'', ',
'         12,''DROP TABLE'', ',
'         13,''CRE SEQ'', ',
'         14,''ALT SEQ'', ',
'         15,''ALT TABLE'', ',
'         16,''DROP SEQ'', ',
'         17,''GRANT'', ',
'         18,''REVOKE'', ',
'         19,''CRE SYN'', ',
'         20,''DROP SYN'', ',
'         21,''CRE VIEW'', ',
'         22,''DROP VIEW'', ',
'         23,''VAL INDEX'', ',
'         24,''CRE PROC'', ',
'         25,''ALT PROC'', ',
'         26,''LOCK TABLE'', ',
'         28,''RENAME'', ',
'         29,''COMMENT'', ',
'         30,''AUDIT'', ',
'         31,''NOAUDIT'', ',
'         32,''CRE DBLINK'', ',
'         33,''DROP DBLINK'', ',
'         34,''CRE DB'', ',
'         35,''ALTER DB'', ',
'         36,''CRE RBS'', ',
'         37,''ALT RBS'', ',
'         38,''DROP RBS'', ',
'         39,''CRE TBLSPC'', ',
'         40,''ALT TBLSPC'', ',
'         41,''DROP TBLSPC'', ',
'         42,''ALT SESSION'', ',
'         43,''ALT USER'', ',
'         44,''COMMIT'', ',
'         45,''ROLLBACK'', ',
'         46,''SAVEPOINT'', ',
'         47,''PL/SQL EXEC'', ',
'         48,''SET XACTN'', ',
'         49,''SWITCH LOG'', ',
'         50,''EXPLAIN'', ',
'         51,''CRE USER'', ',
'         52,''CRE ROLE'', ',
'         53,''DROP USER'', ',
'         54,''DROP ROLE'', ',
'         55,''SET ROLE'', ',
'         56,''CRE SCHEMA'', ',
'         57,''CRE CTLFILE'', ',
'         58,''ALTER TRACING'', ',
'         59,''CRE TRIGGER'', ',
'         60,''ALT TRIGGER'', ',
'         61,''DRP TRIGGER'', ',
'         62,''ANALYZE TAB'', ',
'         63,''ANALYZE IX'', ',
'         64,''ANALYZE CLUS'', ',
'         65,''CRE PROFILE'', ',
'         66,''DRP PROFILE'', ',
'         67,''ALT PROFILE'', ',
'         68,''DRP PROC'', ',
'         69,''DRP PROC'', ',
'         70,''ALT RESOURCE'', ',
'         71,''CRE SNPLOG'', ',
'         72,''ALT SNPLOG'', ',
'         73,''DROP SNPLOG'', ',
'         74,''CREATE SNAP'', ',
'         75,''ALT SNAP'', ',
'         76,''DROP SNAP'', ',
'         79,''ALTER ROLE'', ',
'         79,''ALTER ROLE'', ',
'         85,''TRUNC TAB'', ',
'         86,''TRUNC CLUST'', ',
'         88,''ALT VIEW'', ',
'         91,''CRE FUNC'', ',
'         92,''ALT FUNC'', ',
'         93,''DROP FUNC'', ',
'         94,''CRE PKG'', ',
'         95,''ALT PKG'', ',
'         96,''DROP PKG'', ',
'         97,''CRE PKG BODY'', ',
'         98,''ALT PKG BODY'', ',
'         99,''DRP PKG BODY'', ',
'         to_char(vs.command)) command,',
'        block_gets, consistent_gets, physical_reads, block_changes, consistent_changes',
'   from vs,io_s',
'  where io_s.sid = vs.sid',
'    and io_s.inst_id = vs.inst_id',
'    and vs.USERNAME > ''!''',
'    and nvl(vs.osuser,''x'') <> ''SYSTEM''',
'    and vs.type <> ''BACKGROUND''',
'    and (:P545_SEARCH is null',
'        or',
'        (:P545_SEARCH is not null',
'         and',
'            (vs.username like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.osuser) like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.terminal) like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.module) like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.client_info) like ''%''||upper(:P545_SEARCH)||''%'' ',
'             or ',
'             upper(vs.sid) like ''%''||upper(:P545_SEARCH)||''%'' ',
'            )',
'         )',
'        )'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No sessions found'
,p_query_num_rows_item=>'P545_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1104686827477514410)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Session status'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159845300132842243)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159845031154842242)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Database<br />User'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18825706336308831)
,p_query_column_id=>4
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Instance ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159846007799842244)
,p_query_column_id=>5
,p_column_alias=>'SECONDS_IN_WAIT'
,p_column_display_sequence=>6
,p_column_heading=>'Time'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159846114062842244)
,p_query_column_id=>6
,p_column_alias=>'COMMAND'
,p_column_display_sequence=>5
,p_column_heading=>'Command'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159852724634858715)
,p_query_column_id=>7
,p_column_alias=>'BLOCK_GETS'
,p_column_display_sequence=>7
,p_column_heading=>'Block<br />Gets'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159852830699858716)
,p_query_column_id=>8
,p_column_alias=>'CONSISTENT_GETS'
,p_column_display_sequence=>8
,p_column_heading=>'Consistent<br />Gets'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159852903559858716)
,p_query_column_id=>9
,p_column_alias=>'PHYSICAL_READS'
,p_column_display_sequence=>9
,p_column_heading=>'Physical<br />Reads'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159853004646858716)
,p_query_column_id=>10
,p_column_alias=>'BLOCK_CHANGES'
,p_column_display_sequence=>10
,p_column_heading=>'Block<br />Changes'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159853108630858716)
,p_query_column_id=>11
,p_column_alias=>'CONSISTENT_CHANGES'
,p_column_display_sequence=>11
,p_column_heading=>'Consistent<br />Changes'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159846228937842244)
,p_plug_name=>'Session Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(159562414490322899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159846414980842244)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(159847321329842249)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(159846414980842244)
,p_button_name=>'P545_GO'
,p_button_static_id=>'P545_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159848225788842251)
,p_branch_action=>'f?p=&FLOW_ID.:545:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159846809948842246)
,p_name=>'P545_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(159846414980842244)
,p_prompt=>'Search'
,p_post_element_text=>'&nbsp;&nbsp;'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter search criteria to search the following fields and click <strong>Go</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Database User</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159847504928842249)
,p_name=>'P545_ROWS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(159846414980842244)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of sessions to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(159848001527842250)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>159848001527842250
);
end;
/
prompt --application/pages/page_00546
begin
wwv_flow_imp_page.create_page(
 p_id=>546
,p_name=>'Cursor Detail'
,p_alias=>'CURSOR-DETAIL'
,p_step_title=>'Cursor Detail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(160520708337520904)
,p_name=>'Open Cursors'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(SQL_TEXT,chr(0)) sql_text, sid,',
'       replace(case when exists (select 1 cnt from sys.gv_$sql_plan p ',
'                         where p.address = oc.address ',
'                           and oc.hash_value = p.hash_value',
'                            and oc.inst_id = p.inst_id) ',
'                  then ''<a href="f?p=''||:APP_ID||'':551:''||:APP_SESSION||''::NO::P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER,P551_INST_ID:''||',
'                       oc.address||'',''||oc.hash_value||'',''||0||'',''||oc.inst_id ||''">''||',
'                            sql_text || ''</a>'' ',
'                else ',
'                     sql_text',
'                end,chr(0)) link1',
'  from sys.gv_$open_cursor oc',
' where sid = :P546_SID',
'   and inst_id = :P546_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Open Cursors'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No open cursors'
,p_query_num_rows_item=>'P546_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160520904823520911)
,p_query_column_id=>1
,p_column_alias=>'SQL_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'SQL Text'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#LINK1#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160557302599680183)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>1
,p_column_heading=>'SID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(167341501879504078)
,p_query_column_id=>3
,p_column_alias=>'LINK1'
,p_column_display_sequence=>3
,p_column_heading=>'Link1'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160541914280626775)
,p_plug_name=>'Session Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_imp.id(159562414490322899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160559422338685883)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>2
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(160546329779650138)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(160559422338685883)
,p_button_name=>'P546_GO'
,p_button_static_id=>'P546_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(160546521102650140)
,p_branch_action=>'f?p=&FLOW_ID.:546:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19590430887594024)
,p_name=>'P546_INST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(160559422338685883)
,p_prompt=>'Instance ID'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>38
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160521713878522509)
,p_name=>'P546_SID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(160559422338685883)
,p_prompt=>'SID'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sid d, sid r',
'from sys.gv_$session',
'order by sid'))
,p_cSize=>10
,p_cMaxlength=>38
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160522719072524094)
,p_name=>'P546_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(160559422338685883)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the maximum number of rows to display in reports that return more then one row and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00548
begin
wwv_flow_imp_page.create_page(
 p_id=>548
,p_name=>'Wait Events'
,p_alias=>'WAIT-EVENTS'
,p_step_title=>'Waits'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'table.waitsColumn{border:0px;}',
'table.waitsColumn th{background:#efefef;border:0px;padding:0px 5px 0px 0px;text-align:right;}',
'table.waitsColumn td{border:0px;padding:1px;white-space:nowrap;font-weight:bold;}',
'table.waitsColumn td.l{text-align:right;font-weight:normal;padding-right:5px;}'))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(164313818540444573)
,p_name=>'Wait Events'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with my_s as (select sid from sys.gv_$mystat where rownum = 1),',
'wait_obj as (select s1.sid,d1.owner||''.''||d1.object_name obj_name,s1.row_wait_obj#,d1.object_id,d1.data_object_id,d1.object_name,d1.owner object_owner,',
'                    d1.object_type',
'               from sys.gv_$session s1,sys.dba_objects d1',
'              where s1.row_wait_obj# = d1.object_id',
'                and s1.wait_time = 0',
'                and s1.wait_class != ''Idle''),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id)',
'select case when (select sid from my_s where rownum = 1) = s.sid then  ',
'                  ''C'' ',
'             when s.status = ''ACTIVE'' then ',
'                  case when sw.seconds_in_wait > 30  ',
'                       then ''L'' ',
'                       else ''A'' ',
'                  end ',
'             when  s.status = ''INACTIVE'' ',
'                       then ''I'' ',
'            else null ',
'        end session_status,',
'       s.sid,s.username,sw.event, decode(sw.wait_time,0,''W'',''C'') waiting,',
'       sw.wait_time, sw.state,sw.seconds_in_wait,s.status,s.module,s.client_info,',
'       case when o.object_type in (''TABLE'',''VIEW'',''INDEX'',''MATERIALIZED VIEW'') then',
'            case when o.object_owner in  (select schema from ws_schemas)',
'                 then ''<a href="''||wwv_flow_page_api.get_url(',
'                                 p_page        => 2000,',
'                                 p_clear_cache => ''RP,2000'',',
'                                 p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'',',
'                                 p_values      => o.object_owner||'',''||o.object_id )||''">''||wwv_flow_escape.html(o.object_name)||''</a>'' ',
'                 else wwv_flow_escape.html(o.object_name) end',
'            else wwv_flow_escape.html(object_name) end object_name,',
'       sw.p1text,sw.p1,sw.p2text,sw.p2,sw.p3text,sw.p3,sw.wait_class,',
'       s.inst_id,',
'       null dummy',
'  from sys.gv_$session s, sys.gv_$session_wait sw, wait_obj o',
' where s.sid = sw.sid',
'   and s.inst_id = sw.inst_id',
'   and s.sid = o.sid(+)',
'   and s.username is not null',
'   and nvl(s.osuser,''x'') <> ''SYSTEM''',
'   and s.type <> ''BACKGROUND''',
'   and (:P548_ACTIVE = ''ALL'' or s.status = ''ACTIVE'')',
'   and (:P548_SEARCH is null',
'        or',
'        (:P548_SEARCH is not null',
'         and',
'            (s.username like ''%''||upper(:P548_SEARCH)||''%'' ',
'             or ',
'             upper(s.module) like ''%''||upper(:P548_SEARCH)||''%'' ',
'             or ',
'             upper(s.client_info) like ''%''||upper(:P548_SEARCH)||''%''              ',
'             or',
'             to_char(s.sid) = :P548_SEARCH',
'            )',
'         )',
'    )'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No sessions found'
,p_query_num_rows_item=>'P548_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1104686783117514409)
,p_query_column_id=>1
,p_column_alias=>'SESSION_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Session status'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1225013363619314377)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164384110089229671)
,p_query_column_id=>2
,p_column_alias=>'SID'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:550:&SESSION.::&DEBUG.::P550_SID,P550_INST_ID:#SID#,#INST_ID#'
,p_column_linktext=>'#SID#'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164460107102588343)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Database<br />User'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164370221208185538)
,p_query_column_id=>4
,p_column_alias=>'EVENT'
,p_column_display_sequence=>7
,p_column_heading=>'Event'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164422311455428749)
,p_query_column_id=>5
,p_column_alias=>'WAITING'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164370332690185539)
,p_query_column_id=>6
,p_column_alias=>'WAIT_TIME'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164422432492428749)
,p_query_column_id=>7
,p_column_alias=>'STATE'
,p_column_display_sequence=>11
,p_column_heading=>'State'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164422531764428749)
,p_query_column_id=>8
,p_column_alias=>'SECONDS_IN_WAIT'
,p_column_display_sequence=>12
,p_column_heading=>'Seconds<br />In Wait'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164454816752562796)
,p_query_column_id=>9
,p_column_alias=>'STATUS'
,p_column_display_sequence=>13
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164463730005623312)
,p_query_column_id=>10
,p_column_alias=>'MODULE'
,p_column_display_sequence=>5
,p_column_heading=>'Module'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164463806034623313)
,p_query_column_id=>11
,p_column_alias=>'CLIENT_INFO'
,p_column_display_sequence=>6
,p_column_heading=>'Client<br />Information'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(165416519153630756)
,p_query_column_id=>12
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>9
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166531312861274156)
,p_query_column_id=>13
,p_column_alias=>'P1TEXT'
,p_column_display_sequence=>15
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166531414063274158)
,p_query_column_id=>14
,p_column_alias=>'P1'
,p_column_display_sequence=>16
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166531511344274158)
,p_query_column_id=>15
,p_column_alias=>'P2TEXT'
,p_column_display_sequence=>17
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166531612947274158)
,p_query_column_id=>16
,p_column_alias=>'P2'
,p_column_display_sequence=>18
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166531721019274158)
,p_query_column_id=>17
,p_column_alias=>'P3TEXT'
,p_column_display_sequence=>19
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166531814344274158)
,p_query_column_id=>18
,p_column_alias=>'P3'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166531908149274158)
,p_query_column_id=>19
,p_column_alias=>'WAIT_CLASS'
,p_column_display_sequence=>14
,p_column_heading=>'Wait Class'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18825404689289422)
,p_query_column_id=>20
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Instance ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(167166504668306104)
,p_query_column_id=>21
,p_column_alias=>'DUMMY'
,p_column_display_sequence=>21
,p_column_heading=>'P1...P3'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" class="waitsColumn">',
'<tr><th>#P1TEXT#</th><td>#P1#</td></tr>',
'<tr><th>#P2TEXT#</th><td>#P2#</td></tr>',
'<tr><th>#P3TEXT#</th><td>#P3#</td></tr>',
'</table>'))
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P548_COLUMNS'
,p_display_when_condition2=>'MORE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(164315004796444581)
,p_plug_name=>'Session Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(159562414490322899)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(164315227809444581)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164316110214444589)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(164315227809444581)
,p_button_name=>'P548_GO'
,p_button_static_id=>'P548_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(164317018261444596)
,p_branch_action=>'f?p=&FLOW_ID.:548:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164315604152444584)
,p_name=>'P548_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(164315227809444581)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter search criteria to search the following fields and click <strong>Go</strong>:',
'<ul>',
'<li>SID</li>',
'<li>Database User</li>',
'<li>Module</li>',
'<li>Client Information</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164316311493444590)
,p_name=>'P548_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(164315227809444581)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of sessions to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164457018961572885)
,p_name=>'P548_ACTIVE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(164315227809444581)
,p_item_default=>'ACTIVE'
,p_prompt=>'Status'
,p_source=>'ACTIVE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION MONITORING STATUS'
,p_lov=>'.'||wwv_flow_imp.id(159923116388036162)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Narrow the display by selecting a status and clicking <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(166537804727309695)
,p_name=>'P548_COLUMNS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(164315227809444581)
,p_use_cache_before_default=>'NO'
,p_item_default=>'MORE'
,p_prompt=>'Show'
,p_source=>'P540_COLUMNS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MORE_LESS_COLUMNS'
,p_lov=>'.'||wwv_flow_imp.id(161595731562973452)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Make a selection to restrict or expand the number of displayed columns and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(166540127237316127)
,p_computation_sequence=>10
,p_computation_item=>'P540_COLUMNS'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P548_COLUMNS'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164316814785444594)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>164316814785444594
);
end;
/
prompt --application/pages/page_00549
begin
wwv_flow_imp_page.create_page(
 p_id=>549
,p_name=>'Kill Session'
,p_alias=>'KILL-SESSION'
,p_step_title=>'Kill Session'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_help_text=>'AEUTL/dbadm_sessions.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159831314115768578)
,p_plug_name=>'Kill Session'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>'Press the <strong>Kill Session</strong> button to kill the session.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(969056127360554648)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(159831513762768579)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(969056127360554648)
,p_button_name=>'KILL_SESSION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Kill Session'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(159831703365768580)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(969056127360554648)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159832109455768585)
,p_branch_action=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160141018353528779)
,p_name=>'P549_SID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(159831314115768578)
,p_use_cache_before_default=>'NO'
,p_prompt=>'SID:'
,p_source=>'P550_SID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(159831911140768584)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Kill Session'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_serial  number;',
'begin',
'    for c1 in (select serial#',
'                 from sys.gv_$session',
'                where sid = :P550_SID',
'                  and inst_id = :P550_INST_ID) loop',
'       l_serial := c1.serial#;',
'       exit;',
'    end loop;',
'',
'    wwv_flow_dynamic_exec.kill_session( p_sid => :P550_SID, p_inst_id => :P550_INST_ID, p_serial# => l_serial );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(159831513762768579)
,p_process_success_message=>'Session Killed'
,p_internal_uid=>159831911140768584
);
end;
/
prompt --application/pages/page_00550
begin
wwv_flow_imp_page.create_page(
 p_id=>550
,p_name=>'Session Details'
,p_alias=>'SESSION-DETAILS'
,p_step_title=>'Session Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'',
'table.htmldbRR{width:97%;margin:0px 5px 0px 5px 0px;vertical-align:top;}',
'',
'table.htmldbSessionLayout td table td{vertical-align:top; }',
'',
'table.htmldbRptRowNoBack td{font-size:8pt;padding:1px 3px;}',
'   table.htmldbRptRowNoBack td.p{text-align:right;color:#3F8640;font-weight:bold;border-right: 1px #efefef solid;width:220px;}',
'   ',
'<!-- delete the following classes once in CSS -->',
'   table.htmldbRptNoBackground th,table.htmldbRptNoBackground td{font-size:8pt;padding:1px 3px;}',
'   table.htmldbRptNoBackground th{text-align:center;color:#3F8640;font-weight:bold;padding:1px 3px;}',
'',
'</style>',
''))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_sessions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(159696707442087376)
,p_name=>'Server (Database Session)'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.SID,s.inst_id,s.status,s.username,s.process,s.LOGON_TIME,',
'       s.logon_time since,s.server,s.type,p.spid,p.TRACEID,',
'       s.serial#',
'  from sys.gv_$session s, sys.gv_$process p',
' where sid = :P550_SID',
'   and s.paddr = p.addr',
'   and s.inst_id = p.inst_id',
'   and s.inst_id = :P550_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Server'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340556612002171029)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Session not found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159703726236149506)
,p_query_column_id=>1
,p_column_alias=>'SID'
,p_column_display_sequence=>1
,p_column_heading=>'SID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18815227059860661)
,p_query_column_id=>2
,p_column_alias=>'INST_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Instance ID'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159703820066149507)
,p_query_column_id=>3
,p_column_alias=>'STATUS'
,p_column_display_sequence=>4
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159703914106149507)
,p_query_column_id=>4
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>5
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159704000699149508)
,p_query_column_id=>5
,p_column_alias=>'PROCESS'
,p_column_display_sequence=>6
,p_column_heading=>'Process'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159704116355149508)
,p_query_column_id=>6
,p_column_alias=>'LOGON_TIME'
,p_column_display_sequence=>7
,p_column_heading=>'Logon Time'
,p_use_as_row_header=>'N'
,p_column_format=>'&LONG_DATE_FORMAT. HH24:MI:SS'
,p_heading_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159704217897149508)
,p_query_column_id=>7
,p_column_alias=>'SINCE'
,p_column_display_sequence=>8
,p_column_heading=>'Logon Time'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159704300579149508)
,p_query_column_id=>8
,p_column_alias=>'SERVER'
,p_column_display_sequence=>9
,p_column_heading=>'Server'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159704409056149508)
,p_query_column_id=>9
,p_column_alias=>'TYPE'
,p_column_display_sequence=>10
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161291615728275134)
,p_query_column_id=>10
,p_column_alias=>'SPID'
,p_column_display_sequence=>11
,p_column_heading=>'OS Process ID'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161291709916275134)
,p_query_column_id=>11
,p_column_alias=>'TRACEID'
,p_column_display_sequence=>12
,p_column_heading=>'Traceid'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189491201917669777)
,p_query_column_id=>12
,p_column_alias=>'SERIAL#'
,p_column_display_sequence=>2
,p_column_heading=>'Serial #'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(159727213057344478)
,p_name=>'Client'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select osuser,machine,terminal,CLIENT_INFO,CLIENT_IDENTIFIER',
'  from sys.gv_$session',
' where sid = :P550_SID',
'   and inst_id = :P550_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Client'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340556612002171029)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Session not found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(159727213057344478)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159727525728344482)
,p_query_column_id=>1
,p_column_alias=>'OSUSER'
,p_column_display_sequence=>1
,p_column_heading=>'OS User'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159727629047344482)
,p_query_column_id=>2
,p_column_alias=>'MACHINE'
,p_column_display_sequence=>2
,p_column_heading=>'Machine'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159727722017344482)
,p_query_column_id=>3
,p_column_alias=>'TERMINAL'
,p_column_display_sequence=>3
,p_column_heading=>'Terminal'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159727830806344483)
,p_query_column_id=>4
,p_column_alias=>'CLIENT_INFO'
,p_column_display_sequence=>4
,p_column_heading=>'Client Information'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159727918652344483)
,p_query_column_id=>5
,p_column_alias=>'CLIENT_IDENTIFIER'
,p_column_display_sequence=>5
,p_column_heading=>'Client Identifier'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(159732903885379685)
,p_name=>'Application'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(command,  ',
'         0,null, ',
'         1,''CRE TAB'', ',
'         2,''INSERT'', ',
'         3,''SELECT'', ',
'         4,''CRE CLUSTER'', ',
'         5,''ALT CLUSTER'', ',
'         6,''UPDATE'', ',
'         7,''DELETE'', ',
'         8,''DRP CLUSTER'', ',
'         9,''CRE INDEX'', ',
'         10,''DROP INDEX'', ',
'         11,''ALT INDEX'', ',
'         12,''DROP TABLE'', ',
'         13,''CRE SEQ'', ',
'         14,''ALT SEQ'', ',
'         15,''ALT TABLE'', ',
'         16,''DROP SEQ'', ',
'         17,''GRANT'', ',
'         18,''REVOKE'', ',
'         19,''CRE SYN'', ',
'         20,''DROP SYN'', ',
'         21,''CRE VIEW'', ',
'         22,''DROP VIEW'', ',
'         23,''VAL INDEX'', ',
'         24,''CRE PROC'', ',
'         25,''ALT PROC'', ',
'         26,''LOCK TABLE'', ',
'         28,''RENAME'', ',
'         29,''COMMENT'', ',
'         30,''AUDIT'', ',
'         31,''NOAUDIT'', ',
'         32,''CRE DBLINK'', ',
'         33,''DROP DBLINK'', ',
'         34,''CRE DB'', ',
'         35,''ALTER DB'', ',
'         36,''CRE RBS'', ',
'         37,''ALT RBS'', ',
'         38,''DROP RBS'', ',
'         39,''CRE TBLSPC'', ',
'         40,''ALT TBLSPC'', ',
'         41,''DROP TBLSPC'', ',
'         42,''ALT SESSION'', ',
'         43,''ALT USER'', ',
'         44,''COMMIT'', ',
'         45,''ROLLBACK'', ',
'         46,''SAVEPOINT'', ',
'         47,''PL/SQL EXEC'', ',
'         48,''SET XACTN'', ',
'         49,''SWITCH LOG'', ',
'         50,''EXPLAIN'', ',
'         51,''CRE USER'', ',
'         52,''CRE ROLE'', ',
'         53,''DROP USER'', ',
'         54,''DROP ROLE'', ',
'         55,''SET ROLE'', ',
'         56,''CRE SCHEMA'', ',
'         57,''CRE CTLFILE'', ',
'         58,''ALTER TRACING'', ',
'         59,''CRE TRIGGER'', ',
'         60,''ALT TRIGGER'', ',
'         61,''DRP TRIGGER'', ',
'         62,''ANALYZE TAB'', ',
'         63,''ANALYZE IX'', ',
'         64,''ANALYZE CLUS'', ',
'         65,''CRE PROFILE'', ',
'         66,''DRP PROFILE'', ',
'         67,''ALT PROFILE'', ',
'         68,''DRP PROC'', ',
'         69,''DRP PROC'', ',
'         70,''ALT RESOURCE'', ',
'         71,''CRE SNPLOG'', ',
'         72,''ALT SNPLOG'', ',
'         73,''DROP SNPLOG'', ',
'         74,''CREATE SNAP'', ',
'         75,''ALT SNAP'', ',
'         76,''DROP SNAP'', ',
'         79,''ALTER ROLE'', ',
'         79,''ALTER ROLE'', ',
'         85,''TRUNC TAB'', ',
'         86,''TRUNC CLUST'', ',
'         88,''ALT VIEW'', ',
'         91,''CRE FUNC'', ',
'         92,''ALT FUNC'', ',
'         93,''DROP FUNC'', ',
'         94,''CRE PKG'', ',
'         95,''ALT PKG'', ',
'         96,''DROP PKG'', ',
'         97,''CRE PKG BODY'', ',
'         98,''ALT PKG BODY'', ',
'         99,''DRP PKG BODY'', ',
'         to_char(command)) command,LAST_CALL_ET,program,module,action',
'-- need open_cursors, current_sql, previous_sql, trace, program service?',
'  from sys.gv_$session',
' where sid = :P550_SID',
'   and inst_id = :P550_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Application'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340556612002171029)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Session not found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(159732903885379685)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159733215352379691)
,p_query_column_id=>1
,p_column_alias=>'COMMAND'
,p_column_display_sequence=>1
,p_column_heading=>'Command'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159733315050379692)
,p_query_column_id=>2
,p_column_alias=>'LAST_CALL_ET'
,p_column_display_sequence=>2
,p_column_heading=>'Last Call Elapsed Time'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159733413526379692)
,p_query_column_id=>3
,p_column_alias=>'PROGRAM'
,p_column_display_sequence=>3
,p_column_heading=>'Program'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159733514417379692)
,p_query_column_id=>4
,p_column_alias=>'MODULE'
,p_column_display_sequence=>4
,p_column_heading=>'Module'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159733626539379692)
,p_query_column_id=>5
,p_column_alias=>'ACTION'
,p_column_display_sequence=>5
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159760820526535896)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160531823621553788)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c pls_integer := 0;',
'  ',
'begin',
'for c1 in (select rawtohex(SQL_ADDRESS) sql_address,SQL_HASH_VALUE,SQL_CHILD_NUMBER,inst_id',
'            from sys.gv_$session s           ',
'           where s.sid = :P550_SID',
'             and s.inst_id = :P550_INST_ID',
'             and exists (select 1 ',
'                           from sys.gv_$sql_plan p',
'                          where s.SQL_ADDRESS = p.address',
'                            and s.SQL_HASH_VALUE = p.hash_value',
'                            and s.SQL_CHILD_NUMBER = p.child_number',
'                            and s.inst_id = p.inst_id)',
'          )',
'loop',
'    sys.htp.p(''<a href="f?p=&APP_ID.:551:''||',
'      :APP_SESSION||',
'      ''::::P551_ADDRESS,P551_HASH_VALUE,P551_CHILD_NUMBER,P551_INST_ID:''||',
'      c1.SQL_ADDRESS||'',''||c1.SQL_HASH_VALUE||'',''||',
'      c1.SQL_CHILD_NUMBER||'',''||c1.inst_id||''">''||',
'      wwv_flow_lang.system_message(''Explain Plan'')||''</a>'');',
'    exit;',
'end loop;',
'',
'',
'for c1 in(select replace(q.sql_fulltext,chr(0)) sql_text',
'            from sys.gv_$session s, sys.gv_$sql q',
'           where s.sql_address = q.address',
'             and s.sql_hash_value = q.hash_value',
'             and s.SQL_CHILD_NUMBER = q.child_number',
'             and s.inst_id = q.inst_id',
'             and s.inst_id = :P550_INST_ID',
'             and s.sid = :P550_SID)',
'loop',
'    c := c+ 1;',
'    sys.htp.prn(''<div class="u-fixedFont" style="white-space: pre-wrap">'');',
'    sys.htp.prn(replace(wwv_flow_escape.html(c1.sql_text),chr(10),''<br />''));',
'    sys.htp.prn(''</div>'');',
'',
'end loop;',
'',
'',
'if c = 0 then',
'    sys.htp.prn(''<span class="fieldData">''||wwv_flow_lang.system_message(''SQL not available'')||''</span>'');',
'end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_comment=>'10g+ Version'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(161382425489157968)
,p_name=>'Contention (Locks)'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with locks as(',
'    select session_id,lock_type,',
'           mode_held,mode_requested,lock_id1,lock_id2,blocking_others',
'      from sys.dba_lock),',
'waiters as (',
'    select w.session_id waiting_session,',
'            h.session_id holding_session,',
'            w.lock_type lock_type,',
'            h.mode_held mode_held,',
'            w.mode_requested mode_requested,',
'            w.lock_id1,',
'            w.lock_id2',
'      from locks w, locks h',
'     where h.blocking_others =  ''Blocking''',
'      and  h.mode_held      !=  ''None''',
'      and  h.mode_held      !=  ''Null''',
'      and  w.mode_requested !=  ''None''',
'      and  w.lock_type       =  h.lock_type',
'      and  w.lock_id1        =  h.lock_id1',
'      and  w.lock_id2        =  h.lock_id2',
'      and  (w.session_id = :P550_SID',
'            or',
'            h.session_id = :P550_SID)),',
'blockers as(',
'    select holding_session waiting_session, to_number(null) holding_session, ',
'           ''None'' lock_type, null mode_held, null mode_requested, ',
'           null lock_id1, null lock_id2',
'      from waiters',
'     minus',
'    select waiting_session waiting_session, to_number(null) holding_session, ',
'           ''None'' lock_type, null mode_held, null mode_requested, ',
'           null lock_id1, null lock_id2',
'      from waiters),',
'waiters_blockers as(',
'    select waiting_session,holding_session,lock_type,mode_held,mode_requested,lock_id1,lock_id2',
'      from waiters',
'     union all',
'    select waiting_session,holding_session,lock_type,mode_held,mode_requested,lock_id1,lock_id2',
'      from blockers),',
'lock_objects as(',
'    select session_id,cnt lock_obj_count, inst_id,',
'           case when cnt = 1 then object_name',
'                else null end object_name,',
'           object_id,owner,object_type',
'      from(',
'        select session_id,inst_id,count(distinct object_name) cnt,max(object_name) object_name,',
'               max(lo.object_id) object_id, max(ao.owner) owner,max(object_type) object_type',
'          from sys.gv_$locked_object lo,sys.dba_objects ao,waiters_blockers wb',
'         where lo.object_id = ao.object_id',
'           and (wb.waiting_session = lo.session_id',
'                or',
'                wb.holding_session = lo.session_id)',
'         group by session_id, inst_id)),',
'wait_block_ses as(',
'select waiting_session,holding_session,lock_type,mode_held,mode_requested,',
'       s.username,s.osuser,s.CLIENT_INFO,s.CLIENT_IDENTIFIER,o.object_name,o.owner,o.object_id,module,o.object_type,o.lock_obj_count,',
'        decode(s.command,  ',
'         0,null, ',
'         1,''CRE TAB'', ',
'         2,''INSERT'', ',
'         3,''SELECT'', ',
'         4,''CRE CLUSTER'', ',
'         5,''ALT CLUSTER'', ',
'         6,''UPDATE'', ',
'         7,''DELETE'', ',
'         8,''DRP CLUSTER'', ',
'         9,''CRE INDEX'', ',
'         10,''DROP INDEX'', ',
'         11,''ALT INDEX'', ',
'         12,''DROP TABLE'', ',
'         13,''CRE SEQ'', ',
'         14,''ALT SEQ'', ',
'         15,''ALT TABLE'', ',
'         16,''DROP SEQ'', ',
'         17,''GRANT'', ',
'         18,''REVOKE'', ',
'         19,''CRE SYN'', ',
'         20,''DROP SYN'', ',
'         21,''CRE VIEW'', ',
'         22,''DROP VIEW'', ',
'         23,''VAL INDEX'', ',
'         24,''CRE PROC'', ',
'         25,''ALT PROC'', ',
'         26,''LOCK TABLE'', ',
'         28,''RENAME'', ',
'         29,''COMMENT'', ',
'         30,''AUDIT'', ',
'         31,''NOAUDIT'', ',
'         32,''CRE DBLINK'', ',
'         33,''DROP DBLINK'', ',
'         34,''CRE DB'', ',
'         35,''ALTER DB'', ',
'         36,''CRE RBS'', ',
'         37,''ALT RBS'', ',
'         38,''DROP RBS'', ',
'         39,''CRE TBLSPC'', ',
'         40,''ALT TBLSPC'', ',
'         41,''DROP TBLSPC'', ',
'         42,''ALT SESSION'', ',
'         43,''ALT USER'', ',
'         44,''COMMIT'', ',
'         45,''ROLLBACK'', ',
'         46,''SAVEPOINT'', ',
'         47,''PL/SQL EXEC'', ',
'         48,''SET XACTN'', ',
'         49,''SWITCH LOG'', ',
'         50,''EXPLAIN'', ',
'         51,''CRE USER'', ',
'         52,''CRE ROLE'', ',
'         53,''DROP USER'', ',
'         54,''DROP ROLE'', ',
'         55,''SET ROLE'', ',
'         56,''CRE SCHEMA'', ',
'         57,''CRE CTLFILE'', ',
'         58,''ALTER TRACING'', ',
'         59,''CRE TRIGGER'', ',
'         60,''ALT TRIGGER'', ',
'         61,''DRP TRIGGER'', ',
'         62,''ANALYZE TAB'', ',
'         63,''ANALYZE IX'', ',
'         64,''ANALYZE CLUS'', ',
'         65,''CRE PROFILE'', ',
'         66,''DRP PROFILE'', ',
'         67,''ALT PROFILE'', ',
'         68,''DRP PROC'', ',
'         69,''DRP PROC'', ',
'         70,''ALT RESOURCE'', ',
'         71,''CRE SNPLOG'', ',
'         72,''ALT SNPLOG'', ',
'         73,''DROP SNPLOG'', ',
'         74,''CREATE SNAP'', ',
'         75,''ALT SNAP'', ',
'         76,''DROP SNAP'', ',
'         79,''ALTER ROLE'', ',
'         79,''ALTER ROLE'', ',
'         85,''TRUNC TAB'', ',
'         86,''TRUNC CLUST'', ',
'         88,''ALT VIEW'', ',
'         91,''CRE FUNC'', ',
'         92,''ALT FUNC'', ',
'         93,''DROP FUNC'', ',
'         94,''CRE PKG'', ',
'         95,''ALT PKG'', ',
'         96,''DROP PKG'', ',
'         97,''CRE PKG BODY'', ',
'         98,''ALT PKG BODY'', ',
'         99,''DRP PKG BODY'', ',
'         to_char(s.command)) command',
'  from waiters_blockers wb, sys.gv_$session s,',
'       lock_objects o',
' where s.sid = wb.waiting_session',
'   and s.inst_id = :P550_INST_ID',
'   and o.session_id(+) = wb.waiting_session',
'   and o.inst_id = s.inst_id',
'  ),',
'ws_schemas as(',
'select schema ',
'  from wwv_flow_company_schemas',
' where security_group_id = :flow_security_group_id)',
'select case when holding_session is null then ''<img src="#IMAGE_PREFIX#htmldb/sessions/locks.gif" />'' ',
'            else ''<span style="padding-left:''||power(2*level,2)||''px;"''||',
'                 ''><img src="#IMAGE_PREFIX#htmldb/sessions/lock_wait.gif" /></span>''',
'       end status_icon,',
'       waiting_session,',
'       username,',
'       case when lock_obj_count = 1 then',
'            case when owner in (select schema from ws_schemas) then',
'                ''<a href="''||wwv_flow_page_api.get_url(',
'                                 p_page        => 2000,',
'                                 p_clear_cache => ''RP,2000'',',
'                                 p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'',',
'                                 p_values      => owner||'',''||object_id )||''">''||wwv_flow_escape.html(object_name)||''</a>''',
'            else wwv_flow_escape.html(object_name) end',
'        else ''<br />'' end object_name,      ',
'       object_id,',
'       owner,',
'       object_type',
'  from wait_block_ses ',
' start with holding_session is null',
' connect by prior waiting_session =  holding_session'))
,p_customized=>'1'
,p_customized_name=>'Contention'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No locks found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(161382425489157968)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161383523003157982)
,p_query_column_id=>1
,p_column_alias=>'STATUS_ICON'
,p_column_display_sequence=>1
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203555320793420208)
,p_query_column_id=>2
,p_column_alias=>'WAITING_SESSION'
,p_column_display_sequence=>2
,p_column_heading=>'SID'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161383009895157982)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>3
,p_column_heading=>'Username'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161383120215157982)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Object'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203555805807420209)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203555930087420209)
,p_query_column_id=>6
,p_column_alias=>'OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203556123615420209)
,p_query_column_id=>7
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>7
,p_column_heading=>'Object Type'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(161388000911226566)
,p_name=>'Waits'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select event,p1,p2,',
'       case when p3 = 0 then null else p3 end p3',
'  from sys.gv_$session_wait',
' where sid = :P550_SID',
'   and inst_id = :P550_INST_ID'))
,p_customized=>'1'
,p_customized_name=>'Waits'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340556612002171029)
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    x   varchar2(32767);',
'begin',
'    for c1 in (select p1text,p2text,p3text,p3',
'                 from sys.gv_$session_wait',
'                where sid = :P550_SID',
'                  and inst_id = :P550_INST_ID',
'                  and rownum = 1)',
'    loop',
'        x := wwv_flow_lang.system_message(''4500_SESS_EVENT'')||'':''||c1.p1text||'':''||c1.p2text;',
'        ',
'        if c1.p3 > 0 then',
'            x:=x||'':''||c1.p3text;',
'        end if;',
'        ',
'    end loop;',
'    ',
'    return x;',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(161388000911226566)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161388322508226572)
,p_query_column_id=>1
,p_column_alias=>'EVENT'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161388510769226572)
,p_query_column_id=>2
,p_column_alias=>'P1'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161388719388226572)
,p_query_column_id=>3
,p_column_alias=>'P2'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(180105911818180025)
,p_query_column_id=>4
,p_column_alias=>'P3'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(174749827669973447)
,p_name=>'Time Statistics (Seconds)'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,(C003/100) C003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''TIME''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174750102002973464)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174750209294973464)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D0'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(174760416334026933)
,p_name=>'SQL Cursor Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>120
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,to_number(C003) c003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''SQL_CURSOR''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(174760416334026933)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174760715110026936)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174760617695026935)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(174763401012041476)
,p_name=>'Logical I/O Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,',
'       case when c002 = ''redo size'' ',
'            then case when to_Number(C003) > 104857 ',
'                 then to_char(to_Number(C003)/1024/1024,''999G999G999999G999G999G990D0'')||'' ''',
'                   || wwv_flow_lang.system_message(''4500_SESS_MEGABYTES'')',
'            else to_char(to_Number(C003)/1024,''999G999G999999G999G999G990D0'') ||'' ''',
'              ||wwv_flow_lang.system_message(''4500_SESS_KILOBYTES'') end',
'       else to_char(to_number(C003),''999G999G999999G999G999G990'') end c003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''LOGICAL_IO''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(174763401012041476)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174763715768041478)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174763619193041477)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(174764715211045565)
,p_name=>'Physical I/O Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,',
'       to_number(C003) c003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''PHYSICAL_IO''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(181122418053358449)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'C002'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(181122525668358449)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'C003'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(174766225039057809)
,p_name=>'Transaction Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,C003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''TRANSACTION''',
'order by seq_id'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174766526003057812)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174766416592057812)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(174767004045061216)
,p_name=>'Memory Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,',
'       case when C002 in (''session uga memory'',''session pga memory'')',
'            then ',
'            case when to_Number(C003) > 104857 ',
'                 then to_char(to_Number(C003)/1024/1024,''999G999G999999G999G999G999D0'')||'' ''',
'                   || wwv_flow_lang.system_message(''4500_SESS_MEGABYTES'')',
'            else to_char(to_Number(C003)/1024,''999G999G999999G999G999G999D0'') ||'' ''',
'              ||wwv_flow_lang.system_message(''4500_SESS_KILOBYTES'') end',
'       else to_char(to_number(C003),''999G999G999999G999G999G999'') end c003',
'  from wwv_flow_collections',
' where collection_name = ''SESSION_STATS''',
'   and C001 = ''MEMORY''',
'order by seq_id',
''))
,p_customized=>'1'
,p_customized_name=>'Memory Statistics'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46912117501975223)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(174767004045061216)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174767301751061218)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(174767209260061218)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(159762828968547746)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(159760820526535896)
,p_button_name=>'P550_GO'
,p_button_static_id=>'P550_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1020668628334854542)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(159760820526535896)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(161609804176088573)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(159760820526535896)
,p_button_name=>'TRACE_SESSION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Trace Session'
,p_button_position=>'NEXT'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(461031001565380178)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(159760820526535896)
,p_button_name=>'KILL_SESSION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Kill Session'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159835004193777176)
,p_branch_action=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(461031001565380178)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(159763013275547748)
,p_branch_action=>'f?p=&FLOW_ID.:550:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18822226450191580)
,p_name=>'P550_INST_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(159760820526535896)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(159698314021089255)
,p_name=>'P550_SID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(159760820526535896)
,p_prompt=>'SID'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sid||'' - ''||username d, sid r',
'from sys.gv_$session',
'where type <> ''BACKGROUND''',
'order by sid'))
,p_cSize=>10
,p_cMaxlength=>38
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a SID (Session ID) and press <strong>Go</strong>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(238762228699136055)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'550'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(241918623881406650)
,p_validation_name=>'SID Exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_dummy number;',
'begin',
'',
'    begin',
'      l_dummy := :P550_SID;',
'    exception when others then return false;',
'    end;',
'',
'for c1 in (select 1',
'             from sys.gv_$session',
'            where sid = :P550_SID',
'              and inst_id = :P550_INST_ID)',
'loop',
'   return true;',
'end loop;--c1',
'',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Please choose or enter a valid, numeric Session Identifier'
,p_when_button_pressed=>wwv_flow_imp.id(159762828968547746)
,p_associated_item=>wwv_flow_imp.id(159698314021089255)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(160296627104938155)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(159762828968547746)
,p_internal_uid=>160296627104938155
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(174748328099954603)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Collection'
,p_process_sql_clob=>'wwv_flow_session_mon.populate_stats_array( p_sid => :P550_SID, p_inst_id => :P550_INST_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'select 1 from sys.gv_$session where sid = :P550_SID and inst_id = :P550_INST_ID'
,p_process_when_type=>'EXISTS'
,p_internal_uid=>174748328099954603
);
end;
/
prompt --application/pages/page_00551
begin
wwv_flow_imp_page.create_page(
 p_id=>551
,p_name=>'Session SQL Plan'
,p_alias=>'SESSION-SQL-PLAN'
,p_step_title=>'SQL Plan'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(206250111084432914)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'  a.indexUsed, a.indexUsed:link,a.indexUsed:visited{font-weight:bold;color:#333333}',
'span.highLight{color:#2F9F58;font-weight:bold;}',
'.fielddatabold{padding-left:7px;}',
'span.noIndex{font-weight:bold;color:#ff0000;}',
'</style>'))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_topsql.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(160439524013199750)
,p_name=>'Query Plan'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select id,position,',
'           address,hash_value,child_number,operation,options,',
'           object_type,OBJECT#,object_name,object_owner,',
'           cost,cardinality,bytes,',
'           access_predicates,filter_predicates,time,parent_id,',
'           SEARCH_COLUMNS',
'      from sys.gv_$sql_plan',
'    where address =  :P551_ADDRESS',
'      and hash_value = :P551_HASH_VALUE',
'      and child_number = :P551_CHILD_NUMBER',
'      and inst_id = :P551_INST_ID),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id) ',
'select operation,options,',
'       case when object_type in (''TABLE'',''VIEW'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'') then',
'            case when object_owner in (select schema from ws_schemas) then',
'                 ''<a href="''||wwv_flow_page_api.get_url(',
'                                  p_page        => 2000,',
'                                  p_clear_cache => ''RP,2000'',',
'                                  p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'',',
'                                  p_values      => object_owner||'',''||OBJECT# )||''">''||wwv_flow_escape.html(object_name)||''</a>''',
'            else wwv_flow_escape.html(object_name) end ',
'       else wwv_flow_escape.html(object_name) end object_name,',
'       cost,cardinality,bytes,',
'       decode(level,1,1,power(level,2)+15) padding,access_predicates,filter_predicates,TIME,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,filter_predicates) ',
'       else wwv_flow_escape.html(replace(filter_predicates,''='','' = '')) end filter_predicates2,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,access_predicates) ',
'       else wwv_flow_escape.html(replace(access_predicates,''='','' = '')) end access_predicates2',
'       ,SEARCH_COLUMNS,',
'       OBJECT# object_id,object_type',
'        from sqlplan s1',
'  start with (address =  :P551_ADDRESS',
'              and hash_value = :P551_HASH_VALUE',
'              and child_number = :P551_CHILD_NUMBER',
'              and id=0 )',
'connect by prior id = parent_id',
'        and prior address = address',
'        and prior hash_value = hash_value',
'        and prior child_number = child_number',
'order by id, position'))
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'* Unindexed columns are shown in red',
'<p><br /></p>'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No plan is available for this statement.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160440325113199764)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>'Operation'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<div style="padding-left:#PADDING#;white-space:nowrap;font-family:monospace;">#OPERATION#</div>'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160440401689199764)
,p_query_column_id=>2
,p_column_alias=>'OPTIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Options'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;font-family:monospace;'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160466103836469312)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Object'
,p_use_as_row_header=>'N'
,p_column_css_style=>'font-family:monospace;'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160441724143199767)
,p_query_column_id=>4
,p_column_alias=>'COST'
,p_column_display_sequence=>5
,p_column_heading=>'Cost'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160441824001199767)
,p_query_column_id=>5
,p_column_alias=>'CARDINALITY'
,p_column_display_sequence=>4
,p_column_heading=>'Rows'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160464600242458839)
,p_query_column_id=>6
,p_column_alias=>'BYTES'
,p_column_display_sequence=>7
,p_column_heading=>'Bytes'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160466211715469312)
,p_query_column_id=>7
,p_column_alias=>'PADDING'
,p_column_display_sequence=>9
,p_column_heading=>'Padding'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(177482610888475900)
,p_query_column_id=>8
,p_column_alias=>'ACCESS_PREDICATES'
,p_column_display_sequence=>8
,p_column_heading=>'Access<br />Predicates'
,p_use_as_row_header=>'N'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(177493424656498802)
,p_query_column_id=>9
,p_column_alias=>'FILTER_PREDICATES'
,p_column_display_sequence=>10
,p_column_heading=>'Filter<br />Predicates'
,p_use_as_row_header=>'N'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(177499728381518816)
,p_query_column_id=>10
,p_column_alias=>'TIME'
,p_column_display_sequence=>6
,p_column_heading=>'Time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188855513759384744)
,p_query_column_id=>11
,p_column_alias=>'FILTER_PREDICATES2'
,p_column_display_sequence=>11
,p_column_heading=>'Filter<br />Predicates *'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188856714582394409)
,p_query_column_id=>12
,p_column_alias=>'ACCESS_PREDICATES2'
,p_column_display_sequence=>12
,p_column_heading=>'Access<br />Predicates'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191261706669295834)
,p_query_column_id=>13
,p_column_alias=>'SEARCH_COLUMNS'
,p_column_display_sequence=>13
,p_column_heading=>'Search Columns'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(192458011625374082)
,p_query_column_id=>14
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>14
,p_column_heading=>'Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(192458111378374082)
,p_query_column_id=>15
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>15
,p_column_heading=>'Object Type'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160444301899203800)
,p_plug_name=>'SQL Statement'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p><br /></p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(191852001361786364)
,p_name=>'Indexes'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select object_type,OBJECT#,object_name,object_owner',
'      from sys.gv_$sql_plan',
'    where address =  :P551_ADDRESS',
'      and hash_value = :P551_HASH_VALUE',
'      and child_number = :P551_CHILD_NUMBER',
'      and inst_id = :P551_INST_ID',
'      and object_type in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id),',
't as(',
'        select object_owner table_owner,object_name table_name,',
'               OBJECT# OBJECT_ID',
'          from sqlplan',
'         where object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name,',
'               d.OBJECT_ID',
'          from sys.dba_indexes d1, sqlplan s1,',
'               sys.dba_objects d',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           and s1.object_type in(''INDEX'',''INDEX (UNIQUE)'')',
'           and d.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'           and d.owner = d1.table_owner',
'           and d.object_name = d1.table_name',
'           ),',
'cols as(',
'    select table_owner,index_name,',
'           rtrim(',
'           max(decode(position,1 ,column_name))||'',''||',
'           max(decode(position,2 ,column_name))||'',''||',
'           max(decode(position,3 ,column_name))||'',''||',
'           max(decode(position,4 ,column_name))||'',''||',
'           max(decode(position,5 ,column_name))||'',''||',
'           max(decode(position,6 ,column_name))||'',''||',
'           max(decode(position,7 ,column_name))||'',''||',
'           max(decode(position,8,column_name))',
'           ,'','') columns',
'     from(',
'        select c.table_owner,c.index_name,c.column_name,c.column_position position',
'          from sys.dba_ind_columns c, t',
'         where t.table_owner = c.table_owner',
'           and t.table_name = c.table_name)',
'    group by table_owner,index_name',
')',
'select di.owner, ',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="''||wwv_flow_page_api.get_url(',
'                             p_page        => 2000,',
'                             p_clear_cache => ''RP,2000'',',
'                             p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'',',
'                             p_values      => di.owner||'',''||t.object_id )||''">''||wwv_flow_escape.html(di.table_name)||''</a>''',
'       else wwv_flow_escape.html(di.table_name) end table_name,',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="''||wwv_flow_page_api.get_url(',
'                             p_page        => 2000,',
'                             p_clear_cache => ''RP,2000'',',
'                             p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'',',
'                             p_values      => di.owner||'',''||do2.object_id )||''">''||wwv_flow_escape.html(di.index_name)||''</a>''',
'       else wwv_flow_escape.html(di.index_name) end index_name,',
'       case when (select count(*) cnt ',
'                    from sqlplan sp1',
'                   where sp1.object_type like ''INDEX%''',
'                     and sp1.object_name = di.index_name) > 0 ',
'            then ''<span class="a-Icon icon-check"></span>''',
'       end check_mark,',
'      c.columns, uniqueness, di.status,',
'      index_type, partitioned, ',
'      funcidx_status, join_index,t.object_id, do2.object_id index_object_id',
'from   sys.dba_indexes di,sys.dba_objects do2,',
'       t,cols c',
'where di.table_owner = t.table_owner',
'  and di.table_name = t.table_name',
'  and index_type != ''LOB''',
'  and do2.object_type = ''INDEX''',
'  and do2.owner = di.owner',
'  and do2.object_name = di.index_name',
'  and c.table_owner = di.table_owner',
'  and c.index_name  = di.index_name'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'No indexes found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10g Version'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191903916308894727)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191914004281948081)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_inline_lov=>'f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA'
,p_lov_language=>'PLSQL'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191904029943894727)
,p_query_column_id=>3
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Index Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193103521263091034)
,p_query_column_id=>4
,p_column_alias=>'CHECK_MARK'
,p_column_display_sequence=>4
,p_column_heading=>'Used in<br />Plan'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191904131795894727)
,p_query_column_id=>5
,p_column_alias=>'COLUMNS'
,p_column_display_sequence=>5
,p_column_heading=>'Columns'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191904218976894727)
,p_query_column_id=>6
,p_column_alias=>'UNIQUENESS'
,p_column_display_sequence=>6
,p_column_heading=>'Uniqueness'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191904322350894727)
,p_query_column_id=>7
,p_column_alias=>'STATUS'
,p_column_display_sequence=>8
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191904408586894727)
,p_query_column_id=>8
,p_column_alias=>'INDEX_TYPE'
,p_column_display_sequence=>7
,p_column_heading=>'Index<br />Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191904629439894728)
,p_query_column_id=>9
,p_column_alias=>'PARTITIONED'
,p_column_display_sequence=>9
,p_column_heading=>'Partitioned'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191904726268894728)
,p_query_column_id=>10
,p_column_alias=>'FUNCIDX_STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Funcidx Status'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191904825185894728)
,p_query_column_id=>11
,p_column_alias=>'JOIN_INDEX'
,p_column_display_sequence=>11
,p_column_heading=>'Join Index'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191904910408894728)
,p_query_column_id=>12
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>12
,p_column_heading=>'Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(192352008977606896)
,p_query_column_id=>13
,p_column_alias=>'INDEX_OBJECT_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Index Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192365729203697830)
,p_plug_name=>'SQL Text'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>21
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(241221106969455523)
,p_name=>'Table Columns'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>120
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select object_type,OBJECT# object_id,object_name,object_owner',
'      from sys.gv_$sql_plan',
'    where address =  :P551_ADDRESS',
'      and hash_value = :P551_HASH_VALUE',
'      and child_number = :P551_CHILD_NUMBER',
'      and inst_id = :P551_INST_ID',
'      and object_type in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')),',
't1 as(',
'        select s.object_owner table_owner,s.object_name table_name',
'          from sqlplan s',
'         where s.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name',
'          from sys.dba_indexes d1, sqlplan s1',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           and replace(s1.object_type,'' (UNIQUE)'') = ''INDEX''',
'           )',
'select t.table_owner,t.table_name,c.column_name,c.data_type',
'  from t1 t,sys.dba_tab_columns c',
' where t.table_name = c.table_name',
'   and t.table_owner = c.owner',
' order by t.table_owner,t.table_name,c.column_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>2000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'No columns found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10+ Version'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241221323469455535)
,p_query_column_id=>1
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Table Owner'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241221421528455535)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241221513889455535)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241221617348455535)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18819425393039925)
,p_name=>'P551_INST_ID'
,p_item_sequence=>67
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160445115405207764)
,p_name=>'P551_ADDRESS'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160446226487210993)
,p_name=>'P551_HASH_VALUE'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160458200017392570)
,p_name=>'P551_CHILD_NUMBER'
,p_item_sequence=>39.5
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(187875109566080761)
,p_name=>'P551_EXECUTIONS'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_prompt=>'Executions:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Number of times this SQL was executed'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(187948130129096183)
,p_name=>'P551_CPU_TIME'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_prompt=>'CPU Time (Seconds):'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'CPU Time in seconds that this SQL required the last time it executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(187998417100101852)
,p_name=>'P551_ROWS_PROCESSED'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_prompt=>'Rows Processed:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Number of rows this SQL returned the last time it executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(188075326928114152)
,p_name=>'P551_DISK_READS'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_prompt=>'Disk Reads:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'The number of blocks read from disk the last time this SQL executed'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(188121511129119012)
,p_name=>'P551_BUFFER_GETS'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_prompt=>'Buffer Gets:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Number of blocks in memory this SQL accessed the last time it executed'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(188138429483124368)
,p_name=>'P551_GETS_PROCESSED'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_prompt=>'Buffer Gets / Rows Processed:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'The number of blocks read divided by the number of rows returned.  This is a measure of efficiency.  It will be null if rows processed is zero.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(191923404983023978)
,p_name=>'P551_EFFICIENCY2'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_prompt=>'Buffer Gets / Executions:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Number of blocks read divided by the number of times a query was executed.  Higher numbers indicate a high number of block reads per execution.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(192366606825700813)
,p_name=>'P551_SQL_TEXT'
,p_item_sequence=>47
,p_item_plug_id=>wwv_flow_imp.id(192365729203697830)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'style="font-family:monospace;"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(192371420855742707)
,p_name=>'P551_MODULE'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_prompt=>'Module: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'style="white-space:nowrap;"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The module as set by the client tool.  In the case of this product, module is set as:<br />',
'HTMLDB APPLICATION: ####',
'where "####" is the number of the application that last executed this SQL'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(192372800207746239)
,p_name=>'P551_ACTION'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(160444301899203800)
,p_prompt=>'Action:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This is the action as set by the client tool.  In the case of this product, action is set to:',
'PAGE ####',
'where "####" is the page number of the application that last executed this SQL'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(188648032216172463)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Top Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    type local_arr is table of varchar2(50);',
'    keyWords local_arr;',
'    ',
'    function highlight_keywords(p_sql in varchar2)',
'    return varchar2',
'    is',
'        l_sql   varchar2(32767) := replace(p_sql,chr(0));',
'    begin',
'        keyWords := local_arr(''SELECT'',''FROM'',''WHERE'',''AND'',''OR'',''ORDER BY'',''WITH'',''BETWEEN'',',
'                              ''GROUP BY'',''HAVING'',''CONNECT BY'',''START WITH'',''PRIOR'',''EXISTS'',',
'                              ''NOT'',''IN'',',
'                              ''LIKE'',''CONTAINS'',''REGEXP_INSTR'',''REGEXP_LIKE'',''IS'',''NULL'');',
'        for i in keyWords.first..keyWords.last loop',
'            l_sql := replace(upper(l_sql),keyWords(i)||'' '',''<span class="highLight">''||keyWords(i)||''</span> '');',
'        end loop;--i',
'        return l_sql;',
'    end highlight_keywords;',
'begin',
'    ',
'    ',
'    for c1 in (select EXECUTIONS,',
'                      DISK_READS,',
'                      (CPU_TIME / 1000000) CPU_TIME,',
'                      BUFFER_GETS,',
'                      ROWS_PROCESSED,',
'                      case when ROWS_PROCESSED = 0 then null ',
'                           else (BUFFER_GETS / replace(ROWS_PROCESSED,0,1)) end GETS_PROCESSED,',
'                      case when EXECUTIONS = 0 then null ',
'                           else (BUFFER_GETS / replace(EXECUTIONS,0,1)) end GETS_EXECUTIONS,',
'                      sql_fulltext,',
'                      MODULE,ACTION',
'                 from sys.gv_$sql',
'                where address       = :P551_ADDRESS',
'                  and HASH_VALUE    = :P551_HASH_VALUE',
'                  and inst_id       = :P551_INST_ID',
'                  and CHILD_NUMBER  = :P551_CHILD_NUMBER)',
'    loop',
'        :P551_EXECUTIONS        := to_char(c1.EXECUTIONS,''999G999G999G999G999G999G999G990'');',
'        :P551_DISK_READS        := to_char(c1.DISK_READS,''999G999G999G999G999G999G999G990'');',
'        :P551_CPU_TIME          := to_char(c1.CPU_TIME,''999G999G999G999G999G999G999G990D0'');',
'        :P551_BUFFER_GETS       := to_char(c1.BUFFER_GETS,''999G999G999G999G999G999G999G990'');',
'        :P551_ROWS_PROCESSED    := to_char(c1.ROWS_PROCESSED,''999G999G999G999G999G999G999G990'');',
'        :P551_GETS_PROCESSED    := to_char(c1.GETS_PROCESSED,''999G999G999G999G999G999G999G990'');',
'        :P551_EFFICIENCY2       := to_char(c1.GETS_EXECUTIONS,''999G999G999G999G999G999G999G990'');',
'        :P551_SQL_TEXT          := substr(highlight_keywords(replace(wwv_flow_escape.html(sys.dbms_lob.substr(c1.sql_fulltext,3200,1)),chr(10),''<br />'')),1,32000);',
'        :P551_MODULE            := c1.module;',
'        :P551_ACTION            := c1.action;',
'',
'    end loop;--c1',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>188648032216172463
);
end;
/
prompt --application/pages/page_00560
begin
wwv_flow_imp_page.create_page(
 p_id=>560
,p_name=>'System Statistics'
,p_alias=>'SYSTEM-STATISTICS'
,p_step_title=>'System Statistics'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'table.statsBlock{margin:5px 10px 15px 10px;width:250px;float:left;vertical-align:top;}',
'table.statsBlock th{font-size:8pt;color:#777777;text-align:center;border-bottom:1px #cccccc solid;}',
'table.statsBlock td{font-size:8pt;padding-left:5px;border-left: 1px #efefef solid;}',
'table.statsBlock td.n{color:#3F8640;text-align:right;font-weight:bold;padding-right:5px;padding-left:0px; border-left:0px;width:200px;}',
'',
'table.statsLayoutTbl td{vertical-align:top;}',
'',
'table.htmldbRptNoBackground th,table.htmldbRptNoBackground td{font-size:9pt;}',
'table.htmldbRptNoBackground th{text-align:right;color:#3F8640;font-weight:bold;}',
'',
'table.htmldbRptRowNoBack td{font-size:8pt;padding:1px 3px;}',
'table.htmldbRptRowNoBack td.p{text-align:right;color:#3F8640;font-weight:bold;border-right: 1px #efefef solid;width:220px;}',
'',
'table.htmldbRR2{width:97%;margin:0px 5px 0px 5px 0px;vertical-align:top;}',
'table.htmldbRR2 th.T,table.htmldbRR2 th.BT {padding:0px 5px 0px 5px;font-size:10pt;color:#777777;border-bottom:1px #cccccc solid;}',
'table.htmldbRR2 th.T{text-align:left;}',
'table.htmldbRR2 td{vertical-align:top;}',
'',
'table.htmldbSessionLayout td table td{vertical-align:top; }',
'.rounded-corner-region .rc-body .rc-content-bin {height:150px;}',
'</style>',
''))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(206059717799303330)
,p_required_patch=>wwv_flow_imp.id(140265918963157648)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/dbadm_stats.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(182527924521262618)
,p_name=>'Time Statistics (Seconds)'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>85
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 Parameter,(C003/100) value, seq_id, 1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS'' and ',
'       nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'   and C001 = ''TIME''',
'union all',
'select c002 Parameter,(select max(c003/100 - a.C003/100) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002 and C001 = ''TIME'') value, a.seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''TIME'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Saved'' Parameter,(C003/100) value, seq_id, 2 o',
'  from htmldb_collections',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''TIME'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'union all'))
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(182527924521262618)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(182983722307360701)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(182983826081360702)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(182984330965363237)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183145429560561544)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'O'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(182528319308262620)
,p_name=>'SQL Cursor Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>95
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,to_number(C003) value, seq_id, 1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''SQL_CURSOR'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,(select max(c003 - a.C003) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002) ',
'       value,',
'       seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''SQL_CURSOR'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(182528319308262620)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183164027192664907)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183164125402664908)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183164218510664908)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183164301537664908)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'Order'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(182528707687262620)
,p_name=>'Logical I/O Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,',
'       to_number(C003) value,',
'       seq_id,',
'       1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''LOGICAL_IO'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,',
'      (select max(c003 - a.C003) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002 and c001 = ''LOGICAL_IO'') ',
'       value,',
'       seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''LOGICAL_IO'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,',
'       case when c002 = ''redo size'' ',
'            then case when to_Number(C003) > 104857 ',
'                 then to_char(to_Number(C003)/1024/1024,''999G999G999999G999G999G990D0'')||'' ''',
'                   || wwv_flow_lang.system_message(''4500_SESS_MEGABYTES'')',
'            else to_char(to_Number(C003)/1024,''999G999G999999G999G999G990D0'') ||'' ''',
'              ||wwv_flow_lang.system_message(''4500_SESS_KILOBYTES'') end',
'       else to_char(to_number(C003),''999G999G999999G999G999G990'') end value,',
'       seq_id,',
'       1 o',
'  from htmldb_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''LOGICAL_IO''',
'order by seq_id, o'))
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(182528707687262620)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183207827595769121)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183207930060769121)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183208021202769122)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183208116247769122)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'Order'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(182529109073262622)
,p_name=>'Physical I/O Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,',
'       to_number(C003) value,',
'       seq_id, 1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''PHYSICAL_IO'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,(select max(c003 - a.C003) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002) ',
'       value,',
'       seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''PHYSICAL_IO'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183009205778412759)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183009312242412760)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183009411366412760)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183153209868584209)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'Order'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(182529520304262623)
,p_name=>'Transaction Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>125
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 Parameter,',
'       to_number(C003) value,',
'       seq_id, ',
'       1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''TRANSACTION'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,',
'       (select max(c003 - a.C003) from htmldb_collections ',
'        where collection_name = ''SYSTEM_STATS'' and c002 = a.c002) ',
'       value,',
'       seq_id, ',
'       3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and a.C001 = ''TRANSACTION'' ',
'   and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(182529520304262623)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183198502614733509)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183198608531733509)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183198724559733509)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Seq Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183198831536733510)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'O'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(182529925349262624)
,p_name=>'Memory Statistics'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002 parameter,',
'      to_Number(C003) value,',
'      seq_id,',
'      1 o',
'  from wwv_flow_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''MEMORY'' and nvl(:P560_SHOW_SAVED_STATISTICS,''N'') != ''Y''',
'union all',
'select c002 Parameter,',
'      (select max(c003 - a.C003) from htmldb_collections where collection_name = ''SYSTEM_STATS'' and c002 = a.c002 and c001 = ''MEMORY'') ',
'       value,',
'       seq_id, 3 o',
'  from wwv_flow_collections a',
' where collection_name = ''SYSTEM_STATS_SAVE''',
'   and C001 = ''MEMORY'' and :P560_SHOW_SAVED_STATISTICS = ''Y''',
'order by seq_id, o'))
,p_customized=>'1'
,p_customized_name=>'Memory Statistics'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select C002,',
'       case when C002 in (''session uga memory'',''session pga memory'')',
'            then ',
'            case when to_Number(C003) > 104857 ',
'                 then to_char(to_Number(C003)/1024/1024,''999G999G999999G999G999G999D0'')||'' ''',
'                   || wwv_flow_lang.system_message(''4500_SESS_MEGABYTES'')',
'            else to_char(to_Number(C003)/1024,''999G999G999999G999G999G999D0'') ||'' ''',
'              ||wwv_flow_lang.system_message(''4500_SESS_KILOBYTES'') end',
'       else to_char(to_number(C003),''999G999G999999G999G999G999'') end c003',
'  from htmldb_collections',
' where collection_name = ''SYSTEM_STATS''',
'   and C001 = ''MEMORY''',
'order by seq_id'))
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(182529925349262624)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183229108080829769)
,p_query_column_id=>1
,p_column_alias=>'PARAMETER'
,p_column_display_sequence=>1
,p_column_heading=>'Parameter'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183229230442829769)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183229925395834757)
,p_query_column_id=>3
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(183230019659834757)
,p_query_column_id=>4
,p_column_alias=>'O'
,p_column_display_sequence=>4
,p_column_heading=>'Order'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(182640107698476570)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(467824415050070719)
,p_button_sequence=>7
,p_button_plug_id=>wwv_flow_imp.id(182640107698476570)
,p_button_name=>'REMOVE_SAVED_STATISTICS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Remove Saved Statistics'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:560:&SESSION.:TRUNCATE:&DEBUG.::P560_SHOW_SAVED_STATISTICS:N'
,p_button_condition=>'return wwv_flow_collection.collection_exists(''SYSTEM_STATS_SAVE'');'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(206248007144422393)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(182640107698476570)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Statistics'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:560:&SESSION.:SAVE:&DEBUG.::P560_SHOW_SAVED_STATISTICS:Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(182765111104723592)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(182640107698476570)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Refresh Report'
,p_button_position=>'EDIT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(182531531518262643)
,p_branch_action=>'f?p=&FLOW_ID.:560:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183015231058420053)
,p_name=>'P560_SHOW_SAVED_STATISTICS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(182640107698476570)
,p_prompt=>'Show delta between current and saved values'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'Y_NOPROMPT'
,p_lov=>'.'||wwv_flow_imp.id(88018003898325845)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Display actual statistic values, or display deltas between an saved value and the current value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183089811974461829)
,p_name=>'P560_STATISTICS_SAVED'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(182640107698476570)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183101009812480164)
,p_name=>'P560_ELAPSED_SECONDS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(182640107698476570)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time since last save in seconds:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  return (sys.dbms_utility.get_time - :P560_STATISTICS_SAVED) / 100;',
'exception',
'when others then return null;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when=>'P560_SHOW_SAVED_STATISTICS'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicates the amount of time that has passed since the statistics were last saved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(182531113511262640)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>182531113511262640
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(182531303248262640)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Collection'
,p_process_sql_clob=>'wwv_flow_session_mon.populate_sys_stats_array (p_mode=>''REPORT'');'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to populate statistics'
,p_process_when=>'SAVE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>182531303248262640
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(182964815765311595)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Baseline Statistics'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_session_mon.populate_sys_stats_array (p_mode=>''SAVE'');',
':P560_STATISTICS_SAVED := sys.dbms_utility.get_time;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'SAVE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Statistics Saved'
,p_internal_uid=>182964815765311595
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(183083215175443839)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate saved collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.truncate_collection(''SYSTEM_STATS_SAVE'');',
'wwv_flow_collection.delete_collection(''SYSTEM_STATS_SAVE'');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to remove saved statistics'
,p_process_when=>'TRUNCATE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Saved Statistics Removed'
,p_internal_uid=>183083215175443839
);
end;
/
prompt --application/pages/page_00701
begin
wwv_flow_imp_page.create_page(
 p_id=>701
,p_name=>'Table Comments'
,p_alias=>'TABLE-COMMENTS'
,p_step_title=>'Table Comments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276037127560809519)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1514318650310360)
,p_plug_name=>'Table Comments'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P701a */ table_name,',
'       table_type,',
'       comments',
'  from sys.user_tab_comments',
' where table_name not like ''BIN$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P701_OWNER'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P701_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1514423881310360)
,p_name=>'Table Comments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_detail_link=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:70:P70_TABLE_NAME:#TABLE_NAME#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1514703753310477)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1514823402310477)
,p_db_column_name=>'TABLE_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Table Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1514913537310477)
,p_db_column_name=>'COMMENTS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1515115174310902)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318219456536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'EDIT_LINK:TABLE_NAME:TABLE_TYPE:COMMENTS'
,p_sort_column_1=>'TABLE_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_worksheet_condition(
 p_id=>wwv_flow_imp.id(441096332093098971)
,p_report_id=>wwv_flow_imp.id(1515115174310902)
,p_condition_type=>'FILTER'
,p_allow_delete=>'Y'
,p_column_name=>'COMMENTS'
,p_operator=>'is not null'
,p_condition_sql=>'"COMMENTS" is not null'
,p_condition_display=>'#APXWS_COL_NAME# #APXWS_OP_NAME#'
,p_enabled=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11566007059392200)
,p_plug_name=>'schema holder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722740347063798631)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1514318650310360)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(24788509909060041)
,p_branch_action=>'f?p=&FLOW_ID.:&P701_BACK.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P701_BACK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18552102336256921)
,p_branch_action=>'701'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1516219246331048)
,p_name=>'P701_EDIT_IND'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(11566007059392200)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18551728761256919)
,p_name=>'P701_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11566007059392200)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema - '
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112117709249457804)
,p_computation_sequence=>10
,p_computation_item=>'P701_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P701_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69207929426619009)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P701_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_process_when=>'P701_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>69207929426619009
);
end;
/
prompt --application/pages/page_00702
begin
wwv_flow_imp_page.create_page(
 p_id=>702
,p_name=>'Tables without Primary Keys'
,p_alias=>'TABLES-WITHOUT-PRIMARY-KEYS'
,p_step_title=>'Tables without Primary Keys'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276037127560809519)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_excp_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11591004915561994)
,p_plug_name=>'object owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34150120028169627)
,p_plug_name=>'Tables without Primary Keys'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name',
'  from sys.user_tables',
' where temporary = ''N''',
'   and table_name not like ''BIN$%''',
'   and table_name not in (select table_name',
'                            from sys.user_constraints',
'                           where constraint_type = ''P'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P702_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(34150221388169627)
,p_name=>'Tables without Primary Keys'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34150426203169816)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Table Without Primary Key'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(34151325983171991)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318318284536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TABLE_NAME'
,p_sort_column_1=>'TABLE_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722738776029798615)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34150120028169627)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18560914534285915)
,p_branch_action=>'702'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18560506556285914)
,p_name=>'P702_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11591004915561994)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select the name of the database schema owner.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112186401059739325)
,p_computation_sequence=>10
,p_computation_item=>'P702_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P702_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24507405816261503)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>24507405816261503
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69216118044644162)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P702_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69216118044644162
);
end;
/
prompt --application/pages/page_00704
begin
wwv_flow_imp_page.create_page(
 p_id=>704
,p_name=>'Unindexed Foreign Keys'
,p_alias=>'UNINDEXED-FOREIGN-KEYS'
,p_step_title=>'Unindexed Foreign Keys'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276037127560809519)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_excp_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8710806460667309)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24484410870177872)
,p_plug_name=>'Unindexed Foreign Keys'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This report displays tables that do not have indexed foreign keys. Failure to index foreign keys can result in poor join performance and lock escalation. It is typically good programming practice to index foreign keys.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441195900047724309)
,p_plug_name=>'Unindexed Foreign Keys'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with',
'/*gather all referential constraints of interest, including their column lists*/',
'cons_cols as (',
'    select',
'        cons.owner,',
'        cons.table_name,',
'        cons.constraint_name,',
'        listagg(''"''||cols.column_name||''"'', '','') within group (order by cols.position) as columns',
'    from sys.user_constraints cons',
'    join sys.user_cons_columns cols',
'        on cols.owner = cons.owner',
'        and cols.constraint_name = cons.constraint_name',
'    where cons.constraint_type = ''R''',
'    and cons.table_name not like ''BIN$%''',
'    and cons.table_name not like ''DR$%''',
'    and cons.table_name not like ''APEX$%''',
'    group by',
'        cons.owner,',
'        cons.table_name,',
'        cons.constraint_name',
'),',
'/*generate a suggested name for the index*/',
'cons as (',
'    select',
'        cons_cols.owner,',
'        cons_cols.table_name,',
'        cons_cols.constraint_name,',
'        cons_cols.columns,',
'        replace(''%_IDX'', ''%'',',
'            rtrim(substr(',
'                case when cons_cols.constraint_name like ''SYS/_%'' escape ''/''',
'                then replace(cons_cols.constraint_name,''_FK'','''')',
'                else cons_cols.table_name || ''_'' || translate(cons_cols.columns,''A,"'',''A'')',
'                end',
'                ,1,to_number(:P704_MAX_IDENTIFIER_LENGTH)-length(''%_IDX'')+1)',
'                ,''_'')',
'           ) as suggested_index_name        ',
'    from cons_cols',
')',
'/*report any referential integrity constraints that don''t have a matching index (i.e. leading columns are indexed)*/',
'select',
'    cons.owner,',
'    cons.table_name,',
'    cons.constraint_name,',
'    cons.columns as foreign_key_columns,',
'    suggested_index_name,',
'    ''CREATE INDEX "'' || cons.owner || ''"."'' || cons.suggested_index_name',
'        || ''" ON "'' || cons.owner || ''"."'' || cons.table_name',
'        || ''" ('' || cons.columns || '');'' as suggested_ddl',
'from cons',
'left join (',
'    /*note that this will not detect an index of interest that happens to be owned by a different schema;',
'      we could use all_ind_columns and join on table_owner but performance on large multitenant instances',
'      like our hosted instances suffers*/',
'    select',
'        table_name,',
'        index_name,',
'        listagg(''"''||column_name||''"'', '','') within group (order by column_position) as columns',
'    from sys.user_ind_columns',
'    group by',
'        table_name,',
'        index_name',
'    ) ind',
'    on ind.table_name = cons.table_name',
'    and ind.columns like cons.columns || ''%'' /*if the index includes additional columns, it''s still suitable*/',
'where ind.table_name is null /*only show the ones where a matching index was not found*/',
'order by',
'    cons.owner,',
'    cons.table_name,',
'    cons.constraint_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P704_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441196021144724309)
,p_name=>'Unindexed Foreign Keys'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2700325745215603)
,p_db_column_name=>'OWNER'
,p_display_order=>10
,p_column_identifier=>'E'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441196217916724534)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>20
,p_column_identifier=>'A'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441196309630724537)
,p_db_column_name=>'CONSTRAINT_NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Constraint Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2700458601215604)
,p_db_column_name=>'FOREIGN_KEY_COLUMNS'
,p_display_order=>40
,p_column_identifier=>'F'
,p_column_label=>'Foreign Key Columns'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2700559254215605)
,p_db_column_name=>'SUGGESTED_INDEX_NAME'
,p_display_order=>50
,p_column_identifier=>'G'
,p_column_label=>'Suggested Index Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2700616717215606)
,p_db_column_name=>'SUGGESTED_DDL'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>'Suggested DDL'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441197507663728688)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318426679536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TABLE_NAME:CONSTRAINT_NAME:FOREIGN_KEY_COLUMNS:SUGGESTED_INDEX_NAME:SUGGESTED_DDL:'
,p_sort_column_1=>'TABLE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722738533377798613)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(441195900047724309)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2700768472215607)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(441195900047724309)
,p_button_name=>'CREATE_SCRIPT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Script'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2700919157215609)
,p_branch_name=>'show script'
,p_branch_action=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:60:P60_FILE_ID:&P704_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2700768472215607)
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P704_FILE_ID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18587514102515500)
,p_branch_name=>'Go To Page 704'
,p_branch_action=>'704'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2700105229215601)
,p_name=>'P704_MAX_IDENTIFIER_LENGTH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8710806460667309)
,p_source=>'return wwv_flow_db_version.c_actual_dbms_id_length;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2700291216215602)
,p_name=>'P704_FILE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8710806460667309)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2701043322215610)
,p_name=>'P704_SCRIPT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8710806460667309)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18587109795515499)
,p_name=>'P704_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8710806460667309)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112203211972780360)
,p_computation_sequence=>10
,p_computation_item=>'P704_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P704_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2700863414215608)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_max_identifier_length number := wwv_flow_db_version.c_actual_dbms_id_length;',
'    l_script_name           varchar2(255);',
'    l_clob                  clob;',
'    l_file_id               number;',
'begin',
'',
'    l_script_name := ''FK indexes for '' || :P704_OWNER;',
'',
'    l_clob := '''';',
'',
'    -- this must use the dba dictionary views',
'    for r in (',
'        with',
'        /*gather all referential constraints of interest, including their column lists*/',
'        cons_cols as (',
'            select',
'                cons.owner,',
'                cons.table_name,',
'                cons.constraint_name,',
'                listagg(''"''||cols.column_name||''"'', '','') within group (order by cols.position) as columns',
'            from sys.dba_constraints cons',
'            join sys.dba_cons_columns cols',
'                on cols.owner = cons.owner',
'                and cols.constraint_name = cons.constraint_name',
'            where cons.constraint_type = ''R''',
'            and cons.table_name not like ''BIN$%''',
'            and cons.table_name not like ''DR$%''',
'            and cons.table_name not like ''APEX$%''',
'            and cons.owner = :P704_OWNER',
'            group by',
'                cons.owner,',
'                cons.table_name,',
'                cons.constraint_name',
'        ),',
'        /*generate a suggested name for the index*/',
'        cons as (',
'            select',
'                cons_cols.owner,',
'                cons_cols.table_name,',
'                cons_cols.constraint_name,',
'                cons_cols.columns,',
'                replace(''%_IDX'', ''%'',',
'                    rtrim(substr(',
'                        case when cons_cols.constraint_name like ''SYS/_%'' escape ''/''',
'                        then replace(cons_cols.constraint_name,''_FK'','''')',
'                        else cons_cols.table_name || ''_'' || translate(cons_cols.columns,''A,"'',''A'')',
'                        end',
'                        ,1,l_max_identifier_length-length(''%_IDX'')+1)',
'                        ,''_'')',
'                   ) as suggested_index_name        ',
'            from cons_cols',
'        )',
'        /*report any referential integrity constraints that don''t have a matching index (i.e. leading columns are indexed)*/',
'        select',
'            cons.owner,',
'            cons.table_name,',
'            cons.constraint_name,',
'            cons.columns as foreign_key_columns,',
'            suggested_index_name,',
'            ''CREATE INDEX "'' || cons.owner || ''"."'' || cons.suggested_index_name',
'                || ''" ON "'' || cons.owner || ''"."'' || cons.table_name',
'                || ''" ('' || cons.columns || '');'' as suggested_ddl',
'        from cons',
'        left join (',
'            select',
'                table_owner,',
'                table_name,',
'                index_name,',
'                listagg(''"''||column_name||''"'', '','') within group (order by column_position) as columns',
'            from sys.dba_ind_columns',
'            where table_owner = :P704_OWNER',
'            group by',
'                table_owner,',
'                table_name,',
'                index_name',
'            ) ind',
'            on ind.table_owner = cons.owner',
'            and ind.table_name = cons.table_name',
'            and ind.columns like cons.columns || ''%'' /*if the index includes additional columns, it''s still suitable*/',
'        where ind.table_name is null /*only show the ones where a matching index was not found*/',
'        order by',
'            cons.owner,',
'            cons.table_name,',
'            cons.constraint_name',
'    ) loop',
'        l_clob := case when l_clob is not null then',
'                      l_clob',
'                      || wwv_flow.lf',
'                  end',
'            || ''prompt Create index '' || r.suggested_index_name || '' on '' || r.owner || ''.'' || r.table_name',
'            || wwv_flow.lf',
'            || r.suggested_ddl',
'            || wwv_flow.lf;',
'    end loop;',
'',
'    if l_clob is null then',
'        raise_application_error(-20000, ''No indexes were suggested.'');',
'    end if;',
'    ',
'    l_file_id := wwv_flow_id.next_val;',
'',
'    wwv_flow_sw_script.create_script_from_clob (        ',
'        p_script_name => l_script_name,',
'        p_script      => l_clob,',
'        p_file_id     => l_file_id',
'    );',
'    ',
'    :P704_FILE_ID     := l_file_id;',
'    :P704_SCRIPT_NAME := l_script_name;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2700768472215607)
,p_process_success_message=>'Script created: &P704_SCRIPT_NAME.'
,p_internal_uid=>2700863414215608
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69219124755655532)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P704_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69219124755655532
);
end;
/
prompt --application/pages/page_00706
begin
wwv_flow_imp_page.create_page(
 p_id=>706
,p_name=>'Table Constraints'
,p_alias=>'TABLE-CONSTRAINTS'
,p_step_title=>'Table Constraints'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276037127560809519)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11572824898435245)
,p_plug_name=>'object owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441097114297107344)
,p_plug_name=>'Table Constraints'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P706a */ table_name,',
'       constraint_name,',
'      decode(c.constraint_type,',
'''P'',wwv_flow_lang.system_message(''F4500_PRIMARY''),',
'''U'',wwv_flow_lang.system_message(''F4500_UNIQUE''),',
'''R'',wwv_flow_lang.system_message(''F4500_REFERENTIAL''),',
'''C'',wwv_flow_lang.system_message(''F4500_CHECK'')) cons_type,',
'      status, :P706_OWNER as owner',
'  from sys.user_constraints c',
' where table_name not like ''BIN$%'' and table_name not like ''DR$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P706_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441097230058107344)
,p_name=>'Table Constraints'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441097414035107425)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441097524547107435)
,p_db_column_name=>'CONSTRAINT_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Constraint Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441097614240107437)
,p_db_column_name=>'CONS_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Constraint Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441097708697107438)
,p_db_column_name=>'STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441097818220107439)
,p_db_column_name=>'OWNER'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441098031878108403)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318509504536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TABLE_NAME:CONSTRAINT_NAME:CONS_TYPE:STATUS:OWNER'
,p_sort_column_1=>'TABLE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'CONSTRAINT_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722740289719798630)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(441097114297107344)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(21102712190146129)
,p_branch_action=>'706'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21102311093146127)
,p_name=>'P706_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11572824898435245)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112167713853591637)
,p_computation_sequence=>10
,p_computation_item=>'P706_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P706_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69209918475625379)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P706_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69209918475625379
);
end;
/
prompt --application/pages/page_00707
begin
wwv_flow_imp_page.create_page(
 p_id=>707
,p_name=>'Tables without Indexes'
,p_alias=>'TABLES-WITHOUT-INDEXES'
,p_step_title=>'Tables without Indexes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276037127560809519)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_excp_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8706200096656047)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34151919153185207)
,p_plug_name=>'Tables without Indexes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.table_name, :P707_OWNER as object_owner, o.object_id',
'from sys.user_objects o,',
'(select table_name',
'   from sys.user_tables ut',
'  where ut.temporary = ''N''',
'    and ut.table_name not like ''BIN$%''',
'    and ut.table_name not in ( select table_name',
'                              from sys.user_indexes)',
'    and not exists (select 1 from sys.user_objects where ut.table_name = object_name and object_type = ''MATERIALIZED VIEW'')',
') t',
'where o.object_type = ''TABLE''',
'  and t.table_name = o.object_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P707_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(34152010345185207)
,p_name=>'Tables without Indexes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34152223184185456)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Table Name'
,p_column_link=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:RP,2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:#OBJECT_OWNER#,#OBJECT_ID#'
,p_column_linktext=>'#TABLE_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34152419864185457)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Object'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34152308640185457)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(34152607891185745)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318607488536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TABLE_NAME:OBJECT_ID:OBJECT_OWNER'
,p_sort_column_1=>'TABLE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722738668314798614)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34151919153185207)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29035419971246286)
,p_branch_action=>'707'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29034726120246281)
,p_name=>'P707_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8706200096656047)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema - '
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112197521060764030)
,p_computation_sequence=>10
,p_computation_item=>'P707_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P707_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69217908479650829)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P707_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69217908479650829
);
end;
/
prompt --application/pages/page_00800
begin
wwv_flow_imp_page.create_page(
 p_id=>800
,p_name=>'Table Dictionary'
,p_alias=>'TABLE-DICTIONARY'
,p_step_title=>'Table Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40286007077665046)
,p_plug_name=>'UI Defaults'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       wwv_flow_lang.system_message(''NO'') defaults_exist,',
'       ''#IMAGE_PREFIX#htmldb/icons/icon_uid_without_defaults.gif'' icon_name,',
'       decode(wo.object_type,',
'              ''TABLE'',wwv_flow_lang.system_message(''TABLE''),',
'              ''VIEW'',wwv_flow_lang.system_message(''VIEW''),',
'              wo.object_type) icon_alt_tag,',
'       ''f?p=4500:801:''||:app_session||',
'       ''::NO:RP,801,802:P800_SCHEMA,P801_TABLE_ID,P802_TABLE_ID:''||',
'       :P800_SCHEMA||'',''||wo.object_id||'','' edit_link,',
'       replace(replace(wo.object_name,''_'','' ''),''$'',''$ '') object_display_name,',
'       replace(wo.object_name,''$'',''$ '') object_name,',
'       wo.object_id,',
'       wo.object_type',
'  from ',
'(',
'-- objects without hints',
'select (select object_id',
'          from sys.dba_objects a',
'         where h.table_name = a.object_name',
'           and a.owner = :P800_SCHEMA',
'           and a.object_type in (''TABLE'',''VIEW'')) object_id,',
'       h.table_name object_name,',
'       (select d.object_type',
'          from sys.dba_objects d',
'         where h.table_name = d.object_name',
'           and d.owner = :P800_SCHEMA',
'           and d.object_type in (''TABLE'',''VIEW'')) object_type',
'  from (select object_name table_name',
'          from sys.dba_objects',
'         where object_type in (''TABLE'',''VIEW'')',
'           and owner = :P800_SCHEMA',
'           and object_name not like ''BIN$%''',
'           and object_name not like ''APEX$%''',
'           and object_name not like ''DR$%''',
'           and object_name not like ''SYS_IOT_%''',
'        MINUS',
'        select table_name',
'          from WWV_FLOW_HNT_TABLE_INFO',
'         where SCHEMA = :P800_SCHEMA) h ',
') wo',
'UNION',
'-- objects with hints',
'select wwv_flow_lang.system_message(''YES'') defaults_exist,',
'        decode(w.object_type,',
'               ''N'',''#IMAGE_PREFIX#htmldb/icons/icon_uid_without_table.gif'',',
'                   ''#IMAGE_PREFIX#htmldb/icons/icon_uid_with_defaults.gif'') icon_name,',
'       decode(w.object_type,',
'              ''N'',wwv_flow_lang.system_message(''NOT_IN_DATA_DICT''),',
'                  w.object_type) icon_alt_tag,',
'       ''f?p=4500:802:''||:app_session||',
'       ''::NO:RP,802:P800_SCHEMA,P802_TABLE_ID:''||',
'       :P800_SCHEMA||'',''||w.table_id edit_link,',
'       replace(w.object_name,''_'','' '') object_display_name,',
'       w.object_name,',
'       w.table_id object_id,',
'       upper(w.object_type) object_type',
'  from (',
'select h.table_id,',
'       h.table_name object_name,',
'       nvl((select decode(d.object_type,',
'                          ''TABLE'',wwv_flow_lang.system_message(''TABLE''),',
'                          ''VIEW'',wwv_flow_lang.system_message(''VIEW''),',
'                          d.object_type)',
'              from sys.dba_objects d',
'             where h.table_name = d.object_name',
'               and h.schema = d.owner',
'               and d.object_type in (''TABLE'',''VIEW'')),',
'            wwv_flow_lang.system_message(''NOT_IN_DATA_DICT'')) object_type,',
'       last_updated_on,',
'       last_updated_by',
'  from WWV_FLOW_HNT_TABLE_INFO h',
' where h.schema  = :P800_SCHEMA',
') w'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(40286123901665046)
,p_name=>'User Interface Defaults'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'EDIT_LINK'
,p_icon_view_img_src_column=>'ICON_NAME'
,p_icon_view_label_column=>'OBJECT_DISPLAY_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40286431240665098)
,p_db_column_name=>'ICON_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Icon'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#ICON_NAME#'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40286524116665098)
,p_db_column_name=>'ICON_ALT_TAG'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Tag'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40286627278665098)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40286730575665098)
,p_db_column_name=>'OBJECT_DISPLAY_NAME'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Object Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40286829978665098)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Object ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40286918582665099)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40286319008665090)
,p_db_column_name=>'DEFAULTS_EXIST'
,p_display_order=>7
,p_column_identifier=>'A'
,p_column_label=>'Defaults Exist'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(471529820585334127)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Object Name'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(40287209100674551)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318706658536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'OBJECT_NAME:OBJECT_TYPE:DEFAULTS_EXIST'
,p_sort_column_1=>'OBJECT_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'OBJECT_DISPLAY_NAME'
,p_sort_direction_2=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40290006946818687)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40848912973693399)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(40848526002687735)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194506030480237353)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(194504915759237345)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201908823096522017)
,p_plug_name=>'Table Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>35
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>UI Defaults allow AI interactions to understand the contents of your tables. They are also used to populate initial labels for forms and reports, providing consistency across multiple pages in an application or multiple applications.</p>',
'',
'<p>The Table Dictionary is specific to tables and columns within a selected schema.  These defaults will be used over any defined within the Attribute Dictionary.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(262104519763193943)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(40286007077665046)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(46779314754007949)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(40286007077665046)
,p_button_name=>'SYNCHRONIZE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Synchronize'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:840:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40668908699241110)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40287126977670257)
,p_name=>'P800_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40290006946818687)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1003_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1003_SCHEMA ) d,',
'       :P1003_SCHEMA v',
'  from sys.dual',
' where :P1003_POPUP = 1',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(3301520602864636)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1019610214909694499)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(40848912973693399)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1019610511242694500)
,p_event_id=>wwv_flow_imp.id(1019610214909694499)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:800:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40288828108777466)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set schema'
,p_process_sql_clob=>':P800_SCHEMA := nvl(:P3002_SCHEMA, wwv_flow_user_api.get_default_schema);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P800_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>40288828108777466
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2555920107878997793)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2555920107878997793
);
end;
/
prompt --application/pages/page_00801
begin
wwv_flow_imp_page.create_page(
 p_id=>801
,p_name=>'Create Table Dictionary Defaults'
,p_alias=>'CREATE-TABLE-DICTIONARY-DEFAULTS'
,p_step_title=>'Create Table Dictionary Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40294116352925502)
,p_plug_name=>'Create Table Dictionary Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>30
,p_plug_header=>'<p>The selected table/view is not currently in the Table Dictionary.  Defaults will be created from the table and column definition in the database.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(755295791925836823)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(755295807893836824)
,p_plug_name=>'Create Table Dictionary Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40294524926946897)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(755295791925836823)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Defaults'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40301521828097320)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(755295791925836823)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40301830704097320)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40294009426923443)
,p_name=>'P801_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40294116352925502)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40300901265081958)
,p_name=>'P801_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40294116352925502)
,p_prompt=>'Table Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40304405092234425)
,p_name=>'P801_DEFAULT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(40294116352925502)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40304718252238203)
,p_name=>'P801_DEFAULT_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(40294116352925502)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(427726303876522786)
,p_name=>'P801_SCHEMA'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(40294116352925502)
,p_prompt=>'Schema:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40293109595885680)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create meta data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_hint.synch_hints(',
'  p_schema     => :P800_SCHEMA,',
'  p_table_name => :P801_TABLE_NAME);',
'',
'-- Get new table id',
'for c1 in (select table_id',
'             from wwv_flow_hnt_table_info',
'            where schema     = :P800_SCHEMA',
'              and table_name = :P801_TABLE_NAME)',
'loop',
'   :P801_DEFAULT_ID := c1.table_id;',
'end loop;',
'',
':P801_DEFAULT_STATUS := wwv_flow_hint.check_table(',
'    p_schema=>:P800_SCHEMA,',
'    p_table_name=>:P801_TABLE_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Action NOT completed'
,p_process_success_message=>'Action Completed'
,p_internal_uid=>40293109595885680
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2555923208205196619)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2555923208205196619
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40305830813298591)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select object_name ',
'from sys.dba_objects ',
'where object_id = :P801_TABLE_ID) loop',
'   :P801_table_name := c1.object_name;',
'end loop;',
'',
':P801_SCHEMA := :P800_SCHEMA;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>40305830813298591
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13804023015557924)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check and Redirect'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_table_id wwv_flow_hnt_table_info.table_id%type;',
'begin',
'    select table_id ',
'      into l_table_id',
'      from wwv_flow_hnt_table_info',
'     where schema     = :P800_SCHEMA',
'       and table_name = :P801_TABLE_NAME;',
'',
'    -- redirect to Page 802',
'    wwv_flow_utilities.redirect_url(',
'        p_url => wwv_flow_page_api.get_url(',
'            p_page        => 802,',
'            p_clear_cache => ''RP,802'',',
'            p_items       => ''P800_SCHEMA,P802_TABLE_ID'',',
'            p_values      =>  :P800_SCHEMA||'',''||l_table_id ) );',
'exception',
'    when no_data_found then',
'        -- do nothing, render page 801',
'        null;       ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P801_TABLE_NAME'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>13804023015557924
);
end;
/
prompt --application/pages/page_00802
begin
wwv_flow_imp_page.create_page(
 p_id=>802
,p_name=>'Table and Column Properties'
,p_alias=>'TABLE-AND-COLUMN-PROPERTIES'
,p_step_title=>'Table and Column Properties'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_javascript_code=>'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1482801974681003)
,p_plug_name=>'Table Defaults'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>22
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40299713207047545)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40437215497993577)
,p_plug_name=>'Column Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT TABLE_ID,',
'       COLUMN_ID,',
'       COLUMN_NAME, ',
'       LABEL,',
'      (select max(GROUP_NAME)',
'       from   WWV_FLOW_HNT_GROUPS g',
'       where  g.table_id = c.table_id and',
'              g.group_id = c.group_id) column_group,',
'      (select max(DISPLAY_SEQUENCE) ',
'       from   WWV_FLOW_HNT_GROUPS g',
'       where  g.table_id = c.table_id and',
'              g.group_id = c.group_id) column_group_DISPLAY_SEQUENCE,',
'       decode(display_in_report,''Y'',''<span class="a-Icon icon-check"></span>'',null) display_in_report, ',
'       DISPLAY_SEQ_REPORT, ',
'       MASK_REPORT,',
'       decode(c.alignment,',
'              ''L'',l.m,''C'',ctr.m,''R'',r.m,null) alignment,',
'       DISPLAY_AS_TAB_FORM,  -- need lov',
'       decode(display_in_form,''Y'',''<span class="a-Icon icon-check"></span>'',null) display_in_form, ',
'       DISPLAY_SEQ_FORM, ',
'       DISPLAY_AS_FORM,      -- need lov',
'       MASK_FORM,',
'       DEFAULT_VALUE, ',
'       DISPLAY_WIDTH, ',
'       MAX_WIDTH, ',
'       HEIGHT, ',
'       decode(required,''Y'',''<span class="a-Icon icon-check"></span>'',null) required, ',
'       (case when length(help_text) > 255 ',
'             then substr(help_text,1,255)||'' ...''',
'             else help_text',
'             end) ',
'             help_text, ',
'       length(help_text) help_length,',
'       (case when length(lov_query) > 255 ',
'             then substr(LOV_QUERY,1,255)||'' ...''',
'             else lov_query',
'             end) ',
'             lov_query,',
'       (case when length(WWV_FLOW_HINT.GET_STATIC_LOV_STRING(COLUMN_ID)) > 255',
'             then substr(WWV_FLOW_HINT.GET_STATIC_LOV_STRING(COLUMN_ID),1,255)||'' ...''',
'             else WWV_FLOW_HINT.GET_STATIC_LOV_STRING(COLUMN_ID)',
'             end) STATIC_LOV',
'  FROM WWV_FLOW_HNT_COLUMN_INFO c,',
'       (select wwv_flow_lang.system_message(''LEFT'') m from sys.dual) l,',
'       (select wwv_flow_lang.system_message(''CENTER'') m from sys.dual) ctr,',
'       (select wwv_flow_lang.system_message(''RIGHT'') m from sys.dual) r',
' where table_id = :P802_TABLE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(40437331524993577)
,p_name=>'User Interface Defaults'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40437508053993609)
,p_db_column_name=>'TABLE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Table ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40437615428993612)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Column ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40437724037993613)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Column Name'
,p_column_link=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:Y,803:P803_TABLE_ID,P803_COLUMN_ID:#TABLE_ID#,#COLUMN_ID#'
,p_column_linktext=>'#COLUMN_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40437821566993613)
,p_db_column_name=>'LABEL'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40437913601993613)
,p_db_column_name=>'DISPLAY_IN_REPORT'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Display In Report'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40438002528993613)
,p_db_column_name=>'DISPLAY_SEQ_REPORT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40438232560993613)
,p_db_column_name=>'MASK_REPORT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Report Display Mask'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40438309835993614)
,p_db_column_name=>'ALIGNMENT'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Alignment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40438723721993614)
,p_db_column_name=>'DISPLAY_AS_TAB_FORM'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Display As Tab Form'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40438825175993614)
,p_db_column_name=>'DISPLAY_IN_FORM'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Display In Form'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40438914466993615)
,p_db_column_name=>'DISPLAY_SEQ_FORM'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Form Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439021205993615)
,p_db_column_name=>'DISPLAY_AS_FORM'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Display As Form'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(29577622544843540)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439117728993615)
,p_db_column_name=>'MASK_FORM'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Form Display Mask'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439220175993615)
,p_db_column_name=>'DEFAULT_VALUE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Default Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439329305993615)
,p_db_column_name=>'DISPLAY_WIDTH'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Display Width'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439407905993615)
,p_db_column_name=>'MAX_WIDTH'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Max Width'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439517919993616)
,p_db_column_name=>'HEIGHT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Height'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439605629993616)
,p_db_column_name=>'REQUIRED'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Required'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439731737993617)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Help Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439807311993617)
,p_db_column_name=>'LOV_QUERY'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'LOV Query'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40439919134993617)
,p_db_column_name=>'STATIC_LOV'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Static LOV'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40609316069499661)
,p_db_column_name=>'COLUMN_GROUP'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Column Group'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40609515161508828)
,p_db_column_name=>'COLUMN_GROUP_DISPLAY_SEQUENCE'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Column Group Display Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40837013881334138)
,p_db_column_name=>'HELP_LENGTH'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Help Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(40443822118220643)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318807846536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COLUMN_NAME:DISPLAY_SEQ_REPORT:LABEL:COLUMN_GROUP:ALIGNMENT:DISPLAY_IN_REPORT:DISPLAY_IN_FORM:REQUIRED:HELP_LENGTH'
,p_sort_column_1=>'DISPLAY_SEQ_REPORT'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40666404319823610)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(40650212014681045)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(429073412399033036)
,p_plug_name=>'Warning - Columns Require List of Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385893260111566687)
,p_plug_display_sequence=>25
,p_plug_query_row_template=>wwv_flow_imp.id(11028007180514315)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_hint.check_lov_issues(:P802_TABLE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<img src="#IMAGE_PREFIX#htmldb/icons/alert_warning.gif" alt=""/> The following column(s) have display types that require list of values but there are no list of values defined.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1714834770826811)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(40299713207047545)
,p_button_name=>'VIEW_TABLE_IN_OB'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'View in Object Browser'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:&P802_SCHEMA.,&P802_OBJECT_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201423923688272695)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(40299713207047545)
,p_button_name=>'EDIT_TABLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Edit Table Defaults'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:19:P19_TABLE_ID:&P802_TABLE_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451854508938899874)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(40299713207047545)
,p_button_name=>'GET_PREVIOUS_TABLE_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_TABLE_ID'')'
,p_button_condition=>'P802_TABLE_ID_PREV'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451854426160899873)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(40299713207047545)
,p_button_name=>'GET_NEXT_TABLE_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_TABLE_ID'')'
,p_button_condition=>'P802_TABLE_ID_NEXT'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(451855830940899886)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.::P802_TABLE_ID:&P802_TABLE_ID_NEXT.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(451854426160899873)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(451856005423899888)
,p_branch_action=>'f?p=&FLOW_ID.:802:&SESSION.::&DEBUG.::P802_TABLE_ID:&P802_TABLE_ID_PREV.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(451854508938899874)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1482666673681001)
,p_name=>'P802_OBJECT_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1484407691681019)
,p_name=>'P802_DESCRIPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The full description of the data within this table. This allows AI interactions to understand the contents of this table.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40300021172049834)
,p_name=>'P802_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40302223475116797)
,p_name=>'P802_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_prompt=>'Object Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the corresponding database table or view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40353026503720715)
,p_name=>'P802_TABLE_EXISTS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_prompt=>'Object Exists'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_imp.id(23482928300634173)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Indicates if the table exists in the selected schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40649202486640460)
,p_name=>'P802_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'P800_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Identifies the selected database schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201435615695393318)
,p_name=>'P802_FORM_REGION_TITLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_prompt=>'Singular Label'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'A singular, human-readable descriptor of the data within this table.  This allows AI interactions to understand the contents of this table and is used in generating APEX components referencing this table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201436224006395726)
,p_name=>'P802_REPORT_REGION_TITLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_prompt=>'Plural Label'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'A plural, human-readable descriptor of the data within this table.  This allows AI interactions to understand the contents of this table and is used in generating APEX components referencing this table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(429075312923071029)
,p_name=>'P802_LOV_ISSUES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(429073412399033036)
,p_source=>'wwv_flow_hint.check_lov_issues(:P802_TABLE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="htmldbWarning"'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451854810728899876)
,p_name=>'P802_TABLE_ID_NEXT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451855005289899881)
,p_name=>'P802_TABLE_ID_PREV'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1482801974681003)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451855229265899883)
,p_name=>'P802_TABLE_ID_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40299713207047545)
,p_prompt=>'Object:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(451855629871899885)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_HNT_TABLE_INFO'
,p_attribute_03=>'P802_TABLE_ID'
,p_attribute_04=>'TABLE_ID'
,p_attribute_07=>'TABLE_NAME'
,p_attribute_09=>'P802_TABLE_ID_NEXT'
,p_attribute_10=>'P802_TABLE_ID_PREV'
,p_attribute_13=>'P802_TABLE_ID_COUNT'
,p_attribute_14=>'schema = :P800_SCHEMA'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>451855629871899885
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2555916914580933506)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2555916914580933506
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40306618261313899)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'load table properties'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_tab_default in (',
'    select t.schema,',
'           t.table_name,',
'           t.form_region_title,',
'           t.report_region_title,',
'           t.description,',
'           ( select o.object_id',
'               from sys.dba_objects o',
'              where o.object_type in ( ''TABLE'', ''VIEW'' )',
'                and o.owner       = t.schema',
'                and o.object_name = t.table_name ) object_id',
'      from wwv_flow_hnt_table_info t',
'     where table_id = :P802_TABLE_ID',
'       and schema   = :P800_SCHEMA ) ',
'loop',
'    ',
'    :P802_TABLE_NAME          := l_tab_default.table_name;',
'    :P802_FORM_REGION_TITLE   := l_tab_default.form_region_title;',
'    :P802_REPORT_REGION_TITLE := l_tab_default.report_region_title;',
'    :P802_DESCRIPTION         := l_tab_default.description;',
'    :P802_TABLE_EXISTS        := case when l_tab_default.object_id is not null then',
'                                     ''Y''',
'                                 else',
'                                     ''N''',
'                                 end;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>40306618261313899
);
end;
/
prompt --application/pages/page_00803
begin
wwv_flow_imp_page.create_page(
 p_id=>803
,p_name=>'Column Defaults'
,p_alias=>'COLUMN-DEFAULTS'
,p_step_title=>'Column Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_javascript_code=>'var htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';'
,p_step_template=>wwv_flow_imp.id(690783120585803188)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40567718307686659)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40593701599050795)
,p_plug_name=>'Column'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40593919911050798)
,p_plug_name=>'General Defaults'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40594104898050799)
,p_plug_name=>'Report and Tabular Form Defaults'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40594513838050802)
,p_plug_name=>'Form Defaults'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40650909721689914)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(40650212014681045)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46292112983679077)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717413953976820775)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(293403116472848342)
,p_plug_name=>'List of Values'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(423915426347766246)
,p_plug_name=>'Column Defaults'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>If you have selected a Display As type that requires a List of Values (e.g. Radio Group or Select List), provide either a List of Values query or create a static List of Values.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(429076825998093741)
,p_plug_name=>'Warning - Need List of Values'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_plug_source=>'<img src="#IMAGE_PREFIX#htmldb/icons/alert_warning.gif" alt=""/> This column has a display type (for Forms or Reports) that require list of values but there is no list of values defined.'
,p_plug_query_row_template=>wwv_flow_imp.id(11028007180514315)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'instr('',''||wwv_flow_hint.check_lov_issues(:P803_TABLE_ID)||'','','',''||:P803_COLUMN_NAME||'','') > 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(460118521920020424)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>90
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P803_DISPLAY_AS_FORM and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_item_type,',
'        p_type_page_item_name => ''P803_DISPLAY_AS_FORM'',',
'        p_page_item_prefix    => ''P803_FORM_'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40559215564661672)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(436576801146358511)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(293403116472848342)
,p_button_name=>'QB'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Query Builder'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:popupURL(''f?p=4500:1002:&SESSION.:::1002:P1002_RETURN_INTO,P1002_POPUP,P1002_SCHEMA:P803_LOV_QUERY,1,'' + encodeURIComponent(''&P800_SCHEMA.''));'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(424043318671360140)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(293403116472848342)
,p_button_name=>'EDIT_STATIC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Edit Static List of Values'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_lov_data',
' where column_id = :P803_COLUMN_ID'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(429089022685253660)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40559018900661671)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P803_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(424026324989342982)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(293403116472848342)
,p_button_name=>'CREATE_STATIC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Create Static List of Values'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_hnt_lov_data',
' where column_id = :P803_COLUMN_ID'))
,p_button_condition_type=>'NOT_EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451876812708034876)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_button_name=>'GET_PREVIOUS_COLUMN_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_COLUMN_ID'')'
,p_button_condition=>'P803_COLUMN_ID_PREV'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451876702153034876)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_button_name=>'GET_NEXT_COLUMN_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_COLUMN_ID'')'
,p_button_condition=>'P803_COLUMN_ID_NEXT'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(451880720379034887)
,p_branch_action=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:803:P803_COLUMN_ID:&P803_COLUMN_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(451876702153034876)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(451880918162034887)
,p_branch_action=>'f?p=&APP_ID.:803:&SESSION.::&DEBUG.:803:P803_COLUMN_ID:&P803_COLUMN_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(451876812708034876)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(251498918988497391)
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:RP,40:P40_TABLE_ID,P40_COLUMN_ID:&P803_TABLE_ID.,&P803_COLUMN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_STATIC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(428894725765601748)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:RP,37:P37_TABLE_ID,P37_COLUMN_ID:&P803_TABLE_ID.,&P803_COLUMN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_STATIC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40559413672661673)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:803::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2889586796100801)
,p_name=>'P803_FORM_ATTRIBUTE_16'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_16'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 16, :P803_FORM_ATTRIBUTE_16 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2889674337100802)
,p_name=>'P803_FORM_ATTRIBUTE_17'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_17'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 17, :P803_FORM_ATTRIBUTE_17 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2889734476100803)
,p_name=>'P803_FORM_ATTRIBUTE_18'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_18'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 18, :P803_FORM_ATTRIBUTE_18 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2889841413100804)
,p_name=>'P803_FORM_ATTRIBUTE_19'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_19'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 19, :P803_FORM_ATTRIBUTE_19 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2889950275100805)
,p_name=>'P803_FORM_ATTRIBUTE_20'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_20'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 20, :P803_FORM_ATTRIBUTE_20 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2890027784100806)
,p_name=>'P803_FORM_ATTRIBUTE_21'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_21'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 21, :P803_FORM_ATTRIBUTE_21 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2890107964100807)
,p_name=>'P803_FORM_ATTRIBUTE_22'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_22'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 22, :P803_FORM_ATTRIBUTE_22 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2890289903100808)
,p_name=>'P803_FORM_ATTRIBUTE_23'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_23'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 23, :P803_FORM_ATTRIBUTE_23 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2890314102100809)
,p_name=>'P803_FORM_ATTRIBUTE_24'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_24'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 24, :P803_FORM_ATTRIBUTE_24 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2890420758100810)
,p_name=>'P803_FORM_ATTRIBUTE_25'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_25'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 25, :P803_FORM_ATTRIBUTE_25 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5941804461132033)
,p_name=>'P803_FORM_ATTRIBUTE_11'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P803_FORM_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5942020465132037)
,p_name=>'P803_FORM_ATTRIBUTE_12'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P803_FORM_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5942219964132037)
,p_name=>'P803_FORM_ATTRIBUTE_13'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P803_FORM_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5942408013132037)
,p_name=>'P803_FORM_ATTRIBUTE_14'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P803_FORM_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5942605629132038)
,p_name=>'P803_FORM_ATTRIBUTE_15'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P803_FORM_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40559617798661674)
,p_name=>'P803_COLUMN_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_use_cache_before_default=>'NO'
,p_source=>'COLUMN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40559812141661688)
,p_name=>'P803_TABLE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table:'
,p_source=>'TABLE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_id r',
'  from WWV_FLOW_HNT_TABLE_INFO '))
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40560224805661691)
,p_name=>'P803_COLUMN_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(40593701599050795)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Name'
,p_source=>'COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The currently selected column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40560601899661692)
,p_name=>'P803_LABEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(40593919911050798)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Label'
,p_source=>'LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Used as the label or column heading when a form or report is created against this table or view. This also allows AI interactions to understand the contents of this column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40560825886661692)
,p_name=>'P803_HELP_TEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(40593919911050798)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Used as help text in a form or interactive report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40561005216661692)
,p_name=>'P803_FORM_FORMAT_MASK'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Format Mask'
,p_source=>'MASK_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When creating a form against this table or view, this specifies the mask that will be applied to the item, such as 999-99-9999. This is not used for character based items.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40561221322661692)
,p_name=>'P803_DISPLAY_SEQ_FORM'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display Sequence'
,p_source=>'DISPLAY_SEQ_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When creating a form against this table or view, this determines the sequence in which the columns will be displayed in the resulting form page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40561426448661692)
,p_name=>'P803_DISPLAY_IN_FORM'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display'
,p_source=>'DISPLAY_IN_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_imp.id(23482928300634173)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When creating a form against this table or view, this determines whether this column will be displayed in the resulting form page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40561609640661693)
,p_name=>'P803_DISPLAY_AS_FORM'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TEXT'
,p_prompt=>'Display As'
,p_source=>'DISPLAY_AS_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM_TYPES (WITHOUT PLUGINS)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_native_plugins varchar2(255);',
'begin',
'    l_native_plugins := '' union all select display_name as d, name_with_prefix as r from wwv_flow_native_plugins where plugin_type = ''''ITEM TYPE'''' order by 1'';',
'',
'    if lower(wwv_flow.g_flow_language) = ''en'' then',
'        return ''select display_name as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    else',
'        return ''select wwv_flow_lang.system_message(''''ITEM_TYPE.''''||name) as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    end if;',
'end;'))
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'When creating a form against this table or view, this determines the way the column will be displayed, such as text area or text field.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40561801206661693)
,p_name=>'P803_DISPLAY_AS_TAB_FORM'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(40594104898050799)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TEXT'
,p_prompt=>'Display As'
,p_source=>'DISPLAY_AS_TAB_FORM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI_DEF_DISPLAY_AS_TABULAR_FORMS'
,p_lov=>'.'||wwv_flow_imp.id(251435312257287190)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When creating a tabular form against this table or view, this determines the way the column will be displayed, such as select list or popup LOV.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40562003085661693)
,p_name=>'P803_DISPLAY_SEQ_REPORT'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(40594104898050799)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display Sequence'
,p_source=>'DISPLAY_SEQ_REPORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When creating a report against this table or view, this determines the sequence in which the columns will be displayed in the resulting report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40562218785661693)
,p_name=>'P803_DISPLAY_IN_REPORT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(40594104898050799)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display'
,p_source=>'DISPLAY_IN_REPORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_imp.id(23482928300634173)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When creating a report against this table or view, this determines whether this column will be displayed in the resulting report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40562600042661694)
,p_name=>'P803_MASK_REPORT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(40594104898050799)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Format Mask'
,p_source=>'MASK_REPORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When creating a report against this table or view, this specifies the mask that will be applied against the data, such as 999-99-9999. This is not used for character based items.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40563015040661694)
,p_name=>'P803_LOV_QUERY'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(293403116472848342)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List of Values Query'
,p_source=>'LOV_QUERY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40563228954661694)
,p_name=>'P803_DEFAULT_VALUE'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Value'
,p_source=>'DEFAULT_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When creating a form against this table or view, this specifies the default value for the item resulting from this column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40563412199661695)
,p_name=>'P803_REQUIRED'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Required'
,p_source=>'REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_imp.id(23482928300634173)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When creating a form against this table or view, this specifies to generate a validation in which the resulting item must be NOT NULL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40563628013661695)
,p_name=>'P803_ALIGNMENT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(40594104898050799)
,p_use_cache_before_default=>'NO'
,p_item_default=>'L'
,p_prompt=>'Alignment'
,p_source=>'ALIGNMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI_DEF_ALIGNMENT_L_C_R'
,p_lov=>'.'||wwv_flow_imp.id(260501806598530292)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'When creating a report against this table or view, this determines the alignment for the resulting report column (left, center, or right).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40563830413661695)
,p_name=>'P803_FORM_CSIZE'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Width'
,p_source=>'DISPLAY_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>12
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the length (in characters) of the form element that will be displayed for this item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40564000801661695)
,p_name=>'P803_FORM_CMAXLENGTH'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Width'
,p_source=>'MAX_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the maximum number of character users are allowed to type into this form element.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40564206968661696)
,p_name=>'P803_FORM_CHEIGHT'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Height'
,p_source=>'HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the height (in lines) for text areas, shuttles and multi select lists.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40566402628661698)
,p_name=>'P803_GROUP_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(40593919911050798)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Group'
,p_source=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name, group_id',
'from WWV_FLOW_HNT_GROUPS',
'where table_id = :P803_TABLE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_HNT_GROUPS',
' where table_id = :P803_TABLE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a group for this column to belong to.  Groups are used to default regions in forms and column groups in interactive reports.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451879713461034884)
,p_name=>'P803_COLUMN_ID_NEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451879920761034884)
,p_name=>'P803_COLUMN_ID_PREV'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451880106254034885)
,p_name=>'P803_COLUMN_ID_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(40567718307686659)
,p_prompt=>'Column:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(456283231949087342)
,p_name=>'P803_DISPLAY_AS_FORM_JS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_prompt=>'&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_itemlink varchar2(32767) := null;',
'begin',
'  l_itemlink:=l_itemlink||''<div style="font-size:small">'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_TEXT_FIELD'''');">[''||wwv_flow_lang.system_message(''PAGE_REGION.LIST_ITEM_TEXT'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_NUMBER_FIELD'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_NUMBER_FIELD'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_DATE_PICKER_APEX'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_DATE_PICKER_APEX'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_TEXTAREA'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_TEXTAREA'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_SELECT_LIST'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_SELECT_LIST'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_RADIOGROUP'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_RADIOGROUP'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_POPUP_LOV'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_POPUP_LOV'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_CHECKBOX'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_CHECKBOX'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_DISPLAY_ONLY'''');">[''||wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_DISPLAY_ONLY'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:setValue(''''P803_DISPLAY_AS_FORM'''',''''NATIVE_HIDDEN'''');">[''||wwv_flow_lang.system_message(''WWV_FLOW_CUSTOMIZE.T_HIDDEN'')||'']</a>'';',
'  l_itemlink:=l_itemlink||''</div>'';',
'  ',
'  return l_itemlink;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML_UNSAFE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460092709566874978)
,p_name=>'P803_FORM_ATTRIBUTE_01'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P803_FORM_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460094321687878422)
,p_name=>'P803_FORM_ATTRIBUTE_02'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P803_FORM_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460095328266880315)
,p_name=>'P803_FORM_ATTRIBUTE_03'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P803_FORM_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460096301386882055)
,p_name=>'P803_FORM_ATTRIBUTE_04'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P803_FORM_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460096607273883789)
,p_name=>'P803_FORM_ATTRIBUTE_05'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P803_FORM_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460098614891885971)
,p_name=>'P803_FORM_ATTRIBUTE_06'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P803_FORM_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460099721471887849)
,p_name=>'P803_FORM_ATTRIBUTE_07'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P803_FORM_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460100827705889689)
,p_name=>'P803_FORM_ATTRIBUTE_08'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P803_FORM_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460101901517891591)
,p_name=>'P803_FORM_ATTRIBUTE_09'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P803_FORM_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460103607750893373)
,p_name=>'P803_FORM_ATTRIBUTE_10'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_use_cache_before_default=>'NO'
,p_source=>'FORM_ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P803_FORM_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(717397080423801376)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460105704549911343)
,p_name=>'P803_FORM_FORMAT_MASK_DATE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_prompt=>'Format Mask'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify the date format mask used by the item type. You can use substitution syntax to reference a dynamic format mask from an application or page item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(460109927752918087)
,p_name=>'P803_FORM_FORMAT_MASK_NUMBER'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(40594513838050802)
,p_prompt=>'Format Mask'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_NUMBER (FROM 4000)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''N''',
''))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify the date format mask used by the item type. You can use substitution syntax to reference a dynamic format mask from an application or page item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(460113718794943834)
,p_computation_sequence=>10
,p_computation_item=>'P803_FORM_FORMAT_MASK_NUMBER'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P803_FORM_FORMAT_MASK'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_native_plugins',
' where plugin_type = ''ITEM TYPE''',
'   and name        = substr(:P803_DISPLAY_AS_FORM, 8)',
'   and instr(standard_attributes, ''FORMAT_MASK_NUMBER'') > 0'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(460113030999928412)
,p_computation_sequence=>20
,p_computation_item=>'P803_FORM_FORMAT_MASK_DATE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P803_FORM_FORMAT_MASK'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_native_plugins',
' where plugin_type = ''ITEM TYPE''',
'   and name        = substr(:P803_DISPLAY_AS_FORM, 8)',
'   and instr(standard_attributes, ''FORMAT_MASK_DATE'') > 0'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(460135423025200528)
,p_validation_name=>'Validate Plugin Form Attributes'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id   => 4411,',
'        p_page_id          => null,',
'        p_plugin_type      => wwv_flow_plugin.c_plugin_type_item_type,',
'        p_plugin_name      => :P803_DISPLAY_AS_FORM,',
'        p_attribute_scope  => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix => ''P803_FORM_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(424143832711477640)
,p_validation_name=>'LOV_QUERY valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.is_valid_lov_query (',
'           p_parse_as_schema => :P800_SCHEMA,',
'           p_query           => :P803_LOV_QUERY );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'List of Values Query is not valid.'
,p_validation_condition=>'P803_LOV_QUERY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(40563015040661694)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(424156205877507799)
,p_validation_name=>'can''t have lov query and static lov'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_nbr_static_entries  number;',
'begin',
'',
'select count(*)',
'  into l_nbr_static_entries',
'  from wwv_flow_hnt_lov_data',
' where column_id = :P803_COLUMN_ID;',
'',
'if l_nbr_static_entries > 0 and',
'   :P803_LOV_QUERY is not null',
'then return false;',
'else return true;',
'end if;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Cannot have both List of Values Query and Static List of Values.'
,p_validation_condition=>'P803_LOV_QUERY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(40563015040661694)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(698585127520530534)
,p_name=>'Handle Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(40650909721689914)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(698585269385530535)
,p_event_id=>wwv_flow_imp.id(698585127520530534)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'location.reload();'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40566704848661698)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_03=>'P803_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>40566704848661698
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2203930681939288838)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.init_number_fields_for_display (',
'        p_application_id   => 4411,',
'        p_page_id          => null,',
'        p_plugin_type      => wwv_flow_plugin.c_plugin_type_item_type,',
'        p_plugin_name      => :P803_DISPLAY_AS_FORM,',
'        p_attribute_scope  => wwv_flow_plugin.c_attribute_scope_component );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2203930681939288838
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(451880529772034886)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_03=>'P803_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_07=>'DISPLAY_SEQ_REPORT'
,p_attribute_09=>'P803_COLUMN_ID_NEXT'
,p_attribute_10=>'P803_COLUMN_ID_PREV'
,p_attribute_13=>'P803_COLUMN_ID_COUNT'
,p_attribute_14=>'table_id = :P803_TABLE_ID'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>451880529772034886
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(460141623380276345)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set form format mask'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_plugin in (',
'        select standard_attributes',
'         from wwv_flow_native_plugins',
'        where plugin_type = ''ITEM TYPE''',
'          and name        = substr(:P803_DISPLAY_AS_FORM, 8)',
'          and instr(standard_attributes, ''FORMAT_MASK'') > 0 )',
'    loop',
'        if l_plugin.standard_attributes like ''%FORMAT_MASK_DATE%'' then',
'            :P803_FORM_FORMAT_MASK := :P803_FORM_FORMAT_MASK_DATE;',
'        elsif l_plugin.standard_attributes like ''%FORMAT_MASK_NUMBER%'' then',
'            :P803_FORM_FORMAT_MASK := :P803_FORM_FORMAT_MASK_NUMBER;',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>460141623380276345
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(429089223162263191)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Column'
,p_process_sql_clob=>'wwv_flow_hint.remove_column_hint(:P803_COLUMN_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting column defaults.'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Column defaults deleted.'
,p_internal_uid=>429089223162263191
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(828554424683615725)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id   => 4411,',
'        p_page_id          => null,',
'        p_plugin_type      => wwv_flow_plugin.c_plugin_type_item_type,',
'        p_plugin_name      => :P803_DISPLAY_AS_FORM,',
'        p_attribute_scope  => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix => ''P803_FORM_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>828554424683615725
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40566927819661700)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_attribute_03=>'P803_COLUMN_ID'
,p_attribute_04=>'COLUMN_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_HNT_COLUMN_INFO.'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>40566927819661700
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2002775257056103)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update dictionary cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_table_default in (',
'    select schema, table_name',
'      from wwv_flow_hnt_table_info ',
'     where table_id = :P803_TABLE_ID )',
'loop',
'    wwv_dictionary_cache_dev.update_column_cache (',
'        p_schema       => l_table_default.schema,',
'        p_table_name   => l_table_default.table_name,',
'        p_column_name  => :P803_COLUMN_NAME,',
'        p_column_label => :P803_LABEL );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>2002775257056103
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2555915326214851788)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2555915326214851788
);
end;
/
prompt --application/pages/page_00804
begin
wwv_flow_imp_page.create_page(
 p_id=>804
,p_name=>'Column Group'
,p_alias=>'COLUMN-GROUP'
,p_page_mode=>'MODAL'
,p_step_title=>'Column Group'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40637106508421525)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40637310468421529)
,p_plug_name=>'Column Group'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(40843211185588780)
,p_name=>'Column Groups'
,p_template=>wwv_flow_imp.id(717419046555820782)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    GROUP_NAME,',
'    DESCRIPTION,',
'    DISPLAY_SEQUENCE',
'from WWV_FLOW_HNT_GROUPS',
'where table_id = :P802_TABLE_ID',
'order by display_sequence'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Column Groups exist.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40843520416588799)
,p_query_column_id=>1
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Group Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40843615031588803)
,p_query_column_id=>2
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40843919497591263)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1019193188451734746)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(40637106508421525)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40638508351421532)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(40637106508421525)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P804_GROUP_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40638100770421531)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(40637106508421525)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P804_GROUP_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40638318244421532)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(40637106508421525)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_button_condition=>'P804_GROUP_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40642912894421543)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40638701715421533)
,p_name=>'P804_GROUP_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(40637310468421529)
,p_use_cache_before_default=>'NO'
,p_source=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40638915692421535)
,p_name=>'P804_TABLE_ID'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(40637310468421529)
,p_use_cache_before_default=>'NO'
,p_source=>'TABLE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40639100311421535)
,p_name=>'P804_GROUP_NAME'
,p_is_required=>true
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(40637310468421529)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Group'
,p_source=>'GROUP_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies a group of related items or columns.  This will become the region name in any resulting form and will be displayed in the header of the detailed view of any resulting interactive reports.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40639600534421535)
,p_name=>'P804_DESCRIPTION'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_imp.id(40637310468421529)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'A description for the group.  This becomes the description of the column group in any resulting interactive reports but is never seen by end users.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40640121046421536)
,p_name=>'P804_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>2.5
,p_item_plug_id=>wwv_flow_imp.id(40637310468421529)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequence'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>7
,p_cMaxlength=>30
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The sequence is used to order the column groups in any resulting form or detail view on an interactive report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40647713727530234)
,p_name=>'P804_TABLE_NAME'
,p_item_sequence=>2.2
,p_item_plug_id=>wwv_flow_imp.id(40637310468421529)
,p_prompt=>'Table Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1019193365148737225)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1019193188451734746)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1019193634042737229)
,p_event_id=>wwv_flow_imp.id(1019193365148737225)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40642209530421541)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_HNT_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_GROUPS'
,p_attribute_03=>'P804_GROUP_ID'
,p_attribute_04=>'GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>40642209530421541
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40642419089421542)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_HNT_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_HNT_GROUPS'
,p_attribute_03=>'P804_GROUP_ID'
,p_attribute_04=>'GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_HNT_GROUPS.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>40642419089421542
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40642611037421542)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'33'
,p_process_when_button_id=>wwv_flow_imp.id(40638100770421531)
,p_internal_uid=>40642611037421542
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(698585011297530533)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>698585011297530533
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40647826541533918)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select table_name ',
'from #OWNER#.WWV_FLOW_HNT_TABLE_INFO ',
'where table_id = :P804_TABLE_ID) loop',
'   :P804_table_name := c1.table_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>40647826541533918
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2555921832746175381)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2555921832746175381
);
end;
/
prompt --application/pages/page_00805
begin
wwv_flow_imp_page.create_page(
 p_id=>805
,p_name=>'Column Groups'
,p_alias=>'COLUMN-GROUPS'
,p_step_title=>'Column Groups'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40837822255349176)
,p_plug_name=>'User Interface Default Column Groups'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    GROUP_ID,',
'    TABLE_ID,',
'    GROUP_NAME,',
'    DESCRIPTION,',
'    DISPLAY_SEQUENCE,',
'    CREATED_BY,',
'    CREATED_ON,',
'    LAST_UPDATED_BY,',
'    LAST_UPDATED_ON',
'from WWV_FLOW_HNT_GROUPS',
'where table_id = :P802_TABLE_ID'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(40837918562349176)
,p_name=>'User Interface Default Column Groups'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40838127245349181)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Group ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40838211364349183)
,p_db_column_name=>'TABLE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Table ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40838327088349183)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Group Name'
,p_column_link=>'f?p=&APP_ID.:804:&SESSION.::&DEBUG.::P804_GROUP_ID:#GROUP_ID#'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40838409289349183)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40838530925349183)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40838627304349183)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40838719590349183)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40838829417349184)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40838926410349184)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(40839000984349375)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1318912827536649'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DISPLAY_SEQUENCE:GROUP_NAME:DESCRIPTION'
,p_sort_column_1=>'DISPLAY_SEQUENCE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'GROUP_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40839523456403132)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>5
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40842906552578067)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(40839523456403132)
,p_button_name=>'CREATE_COLUMN_GROUP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Column Group'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:804:&SESSION.::&DEBUG.:804:P804_TABLE_ID:&P802_TABLE_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40840320428403143)
,p_name=>'P805_SCHEMA'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(40839523456403132)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40840526158403143)
,p_name=>'P805_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40839523456403132)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40840725076403143)
,p_name=>'P805_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40839523456403132)
,p_prompt=>'Table Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the corresponding database table or view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(698585300165530536)
,p_name=>'Dialog Closed (Report)'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(40837822255349176)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(698585465831530537)
,p_event_id=>wwv_flow_imp.id(698585300165530536)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(40837822255349176)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(698585551385530538)
,p_name=>'Dialog Closed (Button)'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(40842906552578067)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(698585684215530539)
,p_event_id=>wwv_flow_imp.id(698585551385530538)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(40837822255349176)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(42233223988861200)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>42233223988861200
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40841306403417161)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select table_name ',
'from #OWNER#.WWV_FLOW_HNT_TABLE_INFO ',
'where table_id = :P802_TABLE_ID) loop',
'   :P805_table_name := c1.table_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>40841306403417161
);
end;
/
prompt --application/pages/page_00807
begin
wwv_flow_imp_page.create_page(
 p_id=>807
,p_name=>'Synchronize with Database'
,p_alias=>'SYNCHRONIZE-WITH-DATABASE'
,p_step_title=>'Synchronize with Database'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(429082326437172991)
,p_plug_name=>'Synchronize from Database'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(429088021384234343)
,p_plug_name=>'Synchronize with Database'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419046555820782)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>When you synchronize a table with the database, any columns that no longer exist in the database table or view will be removed and new columns will be added to the column definition.  None of the column definition properties for the existing colum'
||'ns will be modified.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1019602928435527658)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1019604657553619497)
,p_plug_name=>'Synchronize with Database'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(429082519978172992)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1019602928435527658)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(429082712096172994)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1019602928435527658)
,p_button_name=>'SYNC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Synchronize'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(429084402988173260)
,p_branch_action=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(429083105420172995)
,p_name=>'P807_TABLE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(429082326437172991)
,p_prompt=>'Table Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(429083306480172997)
,p_name=>'P807_SCHEMA'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(429082326437172991)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(429084022205173256)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select table_name ',
'     from WWV_FLOW_HNT_TABLE_INFO ',
'    where table_id = :P802_TABLE_ID) ',
'loop',
'   :P807_table_name := c1.table_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P802_TABLE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>429084022205173256
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(429084212787173257)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'synch defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv(:P800_SCHEMA);',
'wwv_flow_hint.synch_hints(:P800_SCHEMA,:P807_TABLE_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(429082712096172994)
,p_process_success_message=>'Table Dictionary entry synchronized with database data dictionary.'
,p_internal_uid=>429084212787173257
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2555922331492184433)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2555922331492184433
);
end;
/
prompt --application/pages/page_00813
begin
wwv_flow_imp_page.create_page(
 p_id=>813
,p_name=>'UI Defaults'
,p_alias=>'UI-DEFAULTS'
,p_step_title=>'UI Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(421012108481729215)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(194504915759237345)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(196867506292090262)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(421012312637730439)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(421013623981752601)
,p_name=>'Attribute Dictionary'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>50
,p_region_css_classes=>'h320'
,p_region_sub_css_classes=>'a-BadgeList--cols a-BadgeList--responsive a-BadgeList--large'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) c,',
'       max(nvl(c.last_updated_on,c.created_on)) last_updated_on',
'  from WWV_FLOW_HNT_COLUMN_DICT c,',
'       wwv_flow_hnt_col_dict_syn s',
' where c.security_group_id = :flow_security_group_id',
'   and c.column_id = s.column_id',
'   and s.security_group_id = :flow_security_group_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(421013623981752601)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(421013926949752640)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'Count of attributes'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(421016406113832584)
,p_query_column_id=>2
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>2
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'Since'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(421014330691764059)
,p_name=>'Table Dictionary'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_region_css_classes=>'h320'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) count_of_tables,',
'       max(nvl(last_updated_on,created_on)) last_updated_on,',
'       :P813_SCHEMA default_schema',
'  from WWV_FLOW_HNT_TABLE_INFO h',
' where h.schema  = nvl(:P813_SCHEMA,:P813_DEFAULT_SCHEMA)'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(421014330691764059)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(421015819011817386)
,p_query_column_id=>1
,p_column_alias=>'COUNT_OF_TABLES'
,p_column_display_sequence=>1
,p_column_heading=>'Count of tables with defaults'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(421015918273817386)
,p_query_column_id=>2
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>2
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(421017006375851615)
,p_query_column_id=>3
,p_column_alias=>'DEFAULT_SCHEMA'
,p_column_display_sequence=>3
,p_column_heading=>'Default schema'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(421523419900723720)
,p_plug_name=>'UI Defaults'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>UI Defaults allow AI interactions to understand the contents of your tables. They are also used to populate initial labels for forms and reports, providing consistency across multiple pages in an application or multiple applications.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(628556724325856603)
,p_name=>'P813_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(421012312637730439)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1003_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1003_SCHEMA ) d,',
'       :P1003_SCHEMA v',
'  from sys.dual',
' where :P1003_POPUP = 1',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(628559716529889439)
,p_name=>'P813_DEFAULT_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(421012312637730439)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select min(d)',
'from',
'(',
'select c.schema d',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
'where  c.security_group_id = :flow_security_group_id and',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :flow_user and',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'        instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0)',
'  and  nvl(:P1003_POPUP,0) <> 1',
'union all',
'select :P1003_SCHEMA d',
'from   sys.dual',
'where  :P1003_POPUP = 1',
')'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(628819707504485750)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set schema'
,p_process_sql_clob=>':P813_SCHEMA := nvl(:P3002_SCHEMA, wwv_flow_user_api.get_default_schema);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P813_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>628819707504485750
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2555920717453066833)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P813_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2555920717453066833
);
end;
/
prompt --application/pages/page_00830
begin
wwv_flow_imp_page.create_page(
 p_id=>830
,p_name=>'Remove from Table Dictionary'
,p_alias=>'REMOVE-FROM-TABLE-DICTIONARY'
,p_step_title=>'Remove from Table Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40821612047201204)
,p_plug_name=>'Remove from Table Dictionary'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(698585887524530541)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(755295941579836825)
,p_plug_name=>'Remove from Table Dictionary'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1019609081712660734)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(698585887524530541)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40824010145229012)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(698585887524530541)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Remove Defaults'
,p_button_position=>'EDIT'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40824424214233093)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40821920358203611)
,p_name=>'P830_TABLE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40821612047201204)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40822908846219133)
,p_name=>'P830_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40821612047201204)
,p_prompt=>'Table Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the corresponding database table or view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40869710633023841)
,p_name=>'P830_SCHEMA'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(40821612047201204)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40875212036175609)
,p_name=>'P830_COLUMNS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(40821612047201204)
,p_prompt=>'Columns:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40821401312198123)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove table hint'
,p_process_sql_clob=>'wwv_flow_hint.remove_table_hint(p_table_id=>:P830_TABLE_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(40824010145229012)
,p_process_success_message=>'User interface default removed.'
,p_internal_uid=>40821401312198123
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2555922515001189163)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2555922515001189163
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40823318543221957)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set table name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select table_name ',
'from #OWNER#.WWV_FLOW_HNT_TABLE_INFO ',
'where table_id = :P830_TABLE_ID) loop',
'   :P830_table_name := c1.table_name;',
'end loop;',
'for c1 in (',
'select count(*) c from WWV_FLOW_HNT_COLUMN_INFO where table_id = :P830_TABLE_ID) loop',
'   :P830_COLUMNS := c1.c;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>40823318543221957
);
end;
/
prompt --application/pages/page_00840
begin
wwv_flow_imp_page.create_page(
 p_id=>840
,p_name=>'Synchronize Defaults'
,p_alias=>'SYNCHRONIZE-DEFAULTS'
,p_step_title=>'Synchronize Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(40862329277925160)
,p_name=>'UI Defaults'
,p_template=>wwv_flow_imp.id(717419707883820782)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       wwv_flow_lang.system_message(''F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'') defaults_exist, count(*) count_of_objects',
'  from ',
'(',
'-- objects without hints',
'select (select object_id',
'          from sys.dba_objects a',
'         where h.table_name = a.object_name',
'           and a.owner = :P800_SCHEMA',
'           and a.object_type in (''TABLE'',''VIEW'')) object_id,',
'       h.table_name object_name,',
'       (select d.object_type',
'          from sys.dba_objects d',
'         where h.table_name = d.object_name',
'           and d.owner = :P800_SCHEMA',
'           and d.object_type in (''TABLE'',''VIEW'')) object_type',
'  from (select object_name table_name',
'          from sys.dba_objects',
'         where object_type in (''TABLE'',''VIEW'')',
'           and owner = :P800_SCHEMA',
'           and object_name not like ''BIN$%''',
'           and object_name not like ''APEX$%''',
'           and object_name not like ''DR$%''',
'           and object_name not like ''SYS_IOT_%''',
'        MINUS',
'        select table_name',
'          from WWV_FLOW_HNT_TABLE_INFO',
'         where SCHEMA = :P800_SCHEMA) h ',
') wo',
'UNION',
'-- objects with hints',
'select wwv_flow_lang.system_message(''F4500_DICTIONARY_OBJECTS_W_DEFAULTS'') defaults_exist, count(*) count_of_objects',
'  from (',
'select h.table_id,',
'       h.table_name object_name,',
'       nvl((select decode(d.object_type,',
'                          ''TABLE'',wwv_flow_lang.system_message(''TABLE''),',
'                          ''VIEW'',wwv_flow_lang.system_message(''VIEW''),',
'                          d.object_type)',
'              from sys.dba_objects d',
'             where h.table_name = d.object_name',
'               and h.schema = d.owner',
'               and d.object_type in (''TABLE'',''VIEW'')),',
'            ''N'') object_type,',
'       last_updated_on,',
'       last_updated_by',
'  from WWV_FLOW_HNT_TABLE_INFO h',
' where h.schema  = :P800_SCHEMA',
') w'))
,p_header=>'<p>Synchronize defaults with the database data dictionary.  This will add new columns added to tables since the last synchronization and remove columns that no longer exist.</p> '
,p_footer=>'<p />'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40862615831925164)
,p_query_column_id=>1
,p_column_alias=>'DEFAULTS_EXIST'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40862717180925164)
,p_query_column_id=>2
,p_column_alias=>'COUNT_OF_OBJECTS'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(763471694281364474)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(763472607085385886)
,p_plug_name=>'UI Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>5
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40868410371004862)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(763471694281364474)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40868607789004863)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(763471694281364474)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Synchronize Defaults'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40868917297006878)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40868024438999502)
,p_name=>'P840_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40862329277925160)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_colspan=>4
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40869029417010357)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create missing ui defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv(:P800_SCHEMA);',
'for c1 in (',
'select object_name table_name',
'          from sys.dba_objects',
'         where object_type in (''TABLE'',''VIEW'')',
'           and owner = :P800_SCHEMA',
'           and object_name not like ''BIN$%''',
'           and object_name not like ''APEX$%''',
'           and object_name not like ''DR$%''',
'           and object_name not like ''SYS_IOT_%''',
'           ) loop',
'    wwv_flow_hint.synch_hints(:P800_SCHEMA,c1.table_name);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'UI Defaults synchronized with database data dictionary.'
,p_internal_uid=>40869029417010357
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(42231501778826373)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>42231501778826373
);
end;
/
prompt --application/pages/page_00841
begin
wwv_flow_imp_page.create_page(
 p_id=>841
,p_name=>'Export Table Dictionary'
,p_alias=>'EXPORT-TABLE-DICTIONARY'
,p_page_mode=>'MODAL'
,p_step_title=>'Export Table Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(40877330444219839)
,p_name=>'Table Dictionary'
,p_template=>wwv_flow_imp.id(717419707883820782)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''OBJECTS_WITH_DEFAULTS'') defaults_exist,',
'       count(*) count_of_objects',
'  from (',
'select h.table_id,',
'       h.table_name object_name,',
'       nvl((select decode(d.object_type,',
'                          ''TABLE'',wwv_flow_lang.system_message(''TABLE''),',
'                          ''VIEW'',wwv_flow_lang.system_message(''VIEW''),',
'                          d.object_type)',
'              from sys.dba_objects d',
'             where h.table_name = d.object_name',
'               and h.schema = d.owner',
'               and d.object_type in (''TABLE'',''VIEW'')),',
'            ''N'') object_type,',
'       last_updated_on,',
'       last_updated_by',
'  from WWV_FLOW_HNT_TABLE_INFO h',
' where h.schema  = :P800_SCHEMA',
') w',
'UNION',
'select wwv_flow_lang.system_message(''OBJECTS_WITHOUT_DEFAULTS'') defaults_exist,',
'       count(*) count_of_objects',
'  from (',
'select (select object_id',
'          from sys.dba_objects a',
'         where h.table_name = a.object_name',
'           and a.owner = :P800_SCHEMA',
'           and a.object_type in (''TABLE'',''VIEW'')) object_id,',
'       h.table_name object_name,',
'       (select d.object_type',
'          from sys.dba_objects d',
'         where h.table_name = d.object_name',
'           and d.owner = :P800_SCHEMA',
'           and d.object_type in (''TABLE'',''VIEW'')) object_type',
'  from (select object_name table_name',
'          from sys.dba_objects',
'         where object_type in (''TABLE'',''VIEW'')',
'           and owner = :P800_SCHEMA',
'           and object_name not like ''BIN$%''    ',
'        MINUS',
'        select table_name',
'          from WWV_FLOW_HNT_TABLE_INFO',
'         where SCHEMA = :P800_SCHEMA) h ',
') wo'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40877516743219840)
,p_query_column_id=>1
,p_column_alias=>'DEFAULTS_EXIST'
,p_column_display_sequence=>1
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40877610738219840)
,p_query_column_id=>2
,p_column_alias=>'COUNT_OF_OBJECTS'
,p_column_display_sequence=>2
,p_column_heading=>'Count of Objects'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(692817211130250934)
,p_plug_name=>'Export Table Dictionary'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>5
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(717761919422725416)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(755302360322951128)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(717761919422725416)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40878414686219858)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(717761919422725416)
,p_button_name=>'EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40878604670219859)
,p_name=>'P841_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40877330444219839)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Schema whose Table Dictionary is being exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40883121396254052)
,p_name=>'P841_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40877330444219839)
,p_item_default=>'DOS'
,p_prompt=>'File Format'
,p_source=>'DOS'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI DEFAULT EXP IMP FORMATS'
,p_lov=>'.'||wwv_flow_imp.id(40883415986261937)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a file format. Options include:',
'<ul>',
'<li>Select <strong>DOS</strong> to have the lines in the resulting file terminated by carriage returns and line feeds.</li>',
'<li>Select <strong>UNIX</strong> to have the lines in the resulting file contain terminated by line feeds.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1019611456383706785)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(755302360322951128)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1019611720157706789)
,p_event_id=>wwv_flow_imp.id(1019611456383706785)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40882702349248568)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv(:P800_SCHEMA);',
'sys.htp.init;',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow_gen_hint.g_mime_shown := true;',
'',
'wwv_flow_utilities.print_download_header(',
'  p_mime_type => ''application/x-sql'',',
'  p_is_attachment => true,',
'  p_file_name => lower(:P800_SCHEMA)||''_table_dict.sql''',
');',
'',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_gen_hint.export(',
'    p_schema => :P800_SCHEMA,',
'    p_format => :P841_FORMAT);',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Failed to export Table Dictionary.'
,p_process_success_message=>'Table Dictionary Exported.'
,p_internal_uid=>40882702349248568
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1019611226268704613)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'close dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1019611226268704613
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(42231814591830072)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>42231814591830072
);
end;
/
prompt --application/pages/page_00842
begin
wwv_flow_imp_page.create_page(
 p_id=>842
,p_name=>'Import Table Dictionary'
,p_alias=>'IMPORT-TABLE-DICTIONARY'
,p_page_mode=>'MODAL'
,p_step_title=>'Import Table Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40888907506297365)
,p_plug_name=>'Import Table Dictionary'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(717763899567749057)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1009688824679531697)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(717763899567749057)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40880720135227490)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(717763899567749057)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40881413589227491)
,p_branch_action=>'f?p=&APP_ID.:843:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40880720135227490)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40881128858227491)
,p_name=>'P842_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40888907506297365)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'&P800_SCHEMA.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(424240005941037614)
,p_name=>'P842_FILE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40888907506297365)
,p_prompt=>'Import File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the location of the file to be imported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(424269810284152400)
,p_name=>'P842_FILE_CHARSET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(40888907506297365)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'File Character Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(143356515285702408)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicate the character set encoding of the file to be imported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1009689045695533892)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1009688824679531697)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1009689362614533893)
,p_event_id=>wwv_flow_imp.id(1009689045695533892)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(424262519372136112)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_title     varchar2(4000) := null;',
'  l_start     number := 0;',
'begin',
'  l_start := instr(:P842_FILE,''/'',1)+1;',
'  l_title := substr(:P842_FILE,l_start);',
'  --',
'  -- save file attributes',
'  --',
'  update wwv_flow_file_objects$ ',
'  set    title             = l_title, ',
'         description       = l_title||'' upload'',',
'         security_group_id = :flow_security_group_id,      ',
'         mime_type         = ''application/text'',',
'         created_by        = :flow_user,',
'         file_charset      = :P842_FILE_CHARSET,',
'         file_type         = ''UI_DEFAULTS''',
'  where name = :P842_FILE;        ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error uploading export file.'
,p_process_when_button_id=>wwv_flow_imp.id(40880720135227490)
,p_process_success_message=>'Export file uploaded.'
,p_internal_uid=>424262519372136112
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(424272720027183574)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P843_FILE_ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P842_FILE)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'  :P843_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(40880720135227490)
,p_internal_uid=>424272720027183574
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(42232126712833550)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P800_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>42232126712833550
);
end;
/
prompt --application/pages/page_00843
begin
wwv_flow_imp_page.create_page(
 p_id=>843
,p_name=>'Import Table Dictionary'
,p_alias=>'IMPORT-TABLE-DICTIONARY1'
,p_page_mode=>'MODAL'
,p_step_title=>'Import Table Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(201270629259751113)
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40888428846294007)
,p_plug_name=>'Install Table Dictionary'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The export file has been imported successfully.</p>',
'<p>If you wish to Install now, click <strong>Install</strong>.</p>',
'<p>You can also install this file at a later time by navigating to the App Builder Export Repository.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(424274923668222439)
,p_plug_name=>'Invalid File'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_source=>'File is not a valid &PRODUCT_NAME. Table Dictionary export file.'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(698586091443530543)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1009690863443563034)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(698586091443530543)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40886628072281718)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(698586091443530543)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40887430447285055)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(698586091443530543)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40887325788281719)
,p_branch_action=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40887008305281719)
,p_name=>'P843_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40888428846294007)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Schema:'
,p_source=>'P800_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(424275516181229788)
,p_name=>'P843_FILE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40888428846294007)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(424276305015245463)
,p_name=>'P843_SCHEMA_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(40888428846294007)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Exported from Schema:'
,p_source=>'wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The schema associated with the UI Defaults Table Dictionary.  This schema must be associated with the current workspace in order for the import to proceed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(424278603676273502)
,p_validation_name=>'check version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :P843_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'NOT COMPATIBLE (Your export may contain calls not supported by your application version.)'
,p_when_button_pressed=>wwv_flow_imp.id(40886628072281718)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(424278924801279554)
,p_validation_name=>'valid export file'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'File is not a valid &PRODUCT_NAME. Table Dictionary export file.'
,p_when_button_pressed=>wwv_flow_imp.id(40886628072281718)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(628825426139661358)
,p_validation_name=>'file schema associated with workspace'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_exp_schema varchar(255) := wwv_flow_imp_parser.get_ui_schema(:P843_FILE_ID);',
'begin',
'   for c1 in (',
'      select c.schema',
'        from wwv_flow_company_schemas c,',
'             wwv_flow_fnd_user u',
'       where c.security_group_id = :flow_security_group_id and',
'             u.security_group_id = :flow_security_group_id and',
'             u.user_name = :flow_user and',
'             (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'              instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0) )',
'   loop',
'      if c1.schema = l_exp_schema then',
'         return true;',
'      end if;',
'   end loop;',
'',
'   return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Exported from schema not associated with the current workspace.'
,p_when_button_pressed=>wwv_flow_imp.id(40886628072281718)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1009691998544566539)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1009690863443563034)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1009692286742566540)
,p_event_id=>wwv_flow_imp.id(1009691998544566539)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(424279312811285618)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_imp_parser.parse (',
'     p_file_id => :P843_FILE_ID',
'     );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error installing Table Dictionary.'
,p_process_when_button_id=>wwv_flow_imp.id(40886628072281718)
,p_process_success_message=>'Table Dictionary installed.'
,p_internal_uid=>424279312811285618
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(698586175593530544)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(40886628072281718)
,p_process_success_message=>'Table Dictionary installed.'
,p_internal_uid=>698586175593530544
);
end;
/
prompt --application/pages/page_00900
begin
wwv_flow_imp_page.create_page(
 p_id=>900
,p_name=>'Builder SSO Auth - Set Password'
,p_alias=>'BUILDER-SSO-AUTH-SET-PASSWORD'
,p_step_title=>'Please Set your APEX Account Password - Oracle APEX'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-ControlBar {display: none;}',
'.a-Alert--wizard .a-Alert-icon .large-icon {width: 96px; height: 96px;}'))
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>'MUST_NOT_BE_PUBLIC_USER'
,p_required_patch=>wwv_flow_imp.id(1694682434415493288)
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1694248221876928011)
,p_plug_name=>'Welcome to &PRODUCT_NAME.!'
,p_icon_css_classes=>'large-icon gi-icon-apex-logo-icon'
,p_region_template_options=>'a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Before you get started, please take a moment to set your &PRODUCT_NAME. (APEX) account password.</p>',
'<p>Your access to this service is controlled by Single Sign-On (SSO). When your workspace was created, an APEX account was also created with your SSO username and a randomly generated password. Resetting this password is required to run apps you crea'
||'te.</p>',
'<p><small>Note: This will not reset your SSO password.</small></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1694248456138928013)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1694248221876928011)
,p_button_name=>'SET_PWD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set APEX Account Password'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=4350:3:&APP_SESSION.::::#pwd'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1694248723011928016)
,p_branch_name=>'Redirect to APEX Homepage'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1694248582045928014)
,p_name=>'Redirect to Homepage after Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1694248456138928013)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1694248624745928015)
,p_event_id=>wwv_flow_imp.id(1694248582045928014)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_01002
begin
wwv_flow_imp_page.create_page(
 p_id=>1002
,p_name=>'Query Builder'
,p_alias=>'QUERYBUILDER'
,p_step_title=>'Query Builder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11093307704620192)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
''))
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#qb/qb_core.js',
'f?p=4500:0:&SESSION.:APPLICATION_PROCESS=qb_get_saved_query'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var gLastRowHighlight = false;',
'',
'apex.jQuery(document).ready(function() {',
'  apex.jQuery(".a-Body, .a-Main, #QUERYTEXT_fieldset").addClass("resize");  ',
'  apex.theme.pageResizeInit();    ',
'});',
'',
'function pageInit() {',
'  qb_initPage();',
'  qb_getTableList();',
'  var ret = $v(''P1002_RETURN_INTO'');',
'  if (ret != '''' && opener) {',
'    var cSql;',
'    try {',
'        cSql = opener.$( "#" + ret ).codeEditor( "getValue" );',
'    } catch( e ) {',
'        cSql = opener.$v(ret);',
'    }',
'    if (cSql != '''' && $v(''P1002_POPUP'') == 1) {',
'      apex.theme.openRegion("warnDialog");',
'    }',
'  }',
'}',
''))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("body").trigger("resize");',
'pageInit();'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'body .ui-dialog.ui-front {z-index: 20001;}',
'body .ui-dialog.ui-dialog--helpDialog {z-index: 20002;}',
'.d1fix {position:relative;left:0;top:0;overflow:hidden;}',
'.d2fix {position:relative;left:0;top:0;overflow:hidden;}',
''))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/qry_bldr.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1973330602194207)
,p_plug_name=>'(DHTML) Clone Table Rows'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table style="display:none;" role="presentation">',
'<tr id="clone">',
'<td style="text-align: center;" class="qbTableData"><img class="htmldbPseudoButton" style="margin: 2px;" src="#IMAGE_PREFIX#green_arrow_up.gif" onclick="qb_RowUp(this)" /><img class="htmldbPseudoButton" style="margin: 2px;" src="#IMAGE_PREFIX#green_a'
||'rrow_down.gif" onclick="qb_RowDown(this)" /></td>',
'<td class="qbTableData"><br /></td>',
'<td style="text-align: center;" class="qbTableData"><input id="_alias" onchange="qb_genSql()" onblur="qb_genSql()" /></td>',
'<td class="qbTableData"><br /></td>',
'<td style="text-align: center;" class="qbTableData"><input id="_con" onchange="qb_genSql()" onblur="qb_genSql()" /></td>',
'<td style="text-align: center;" class="qbTableData"><select id="_st" onchange="qb_genSql()"><option value="ASC">Asc</option><option value="DESC">Desc</option></select></td>',
'<td style="text-align: center;" class="qbTableData"><input style="width:30px;" id=" _so" onchange="qbValSo(this)" onblur="qbValSo(this)" /></td>',
'<td style="text-align: center;" class="qbTableData"><input id="_out" type="checkbox" checked="checked" onclick="qb_toggleOut(this)" onfocus="qbSetFocus();" /></td>',
'<td style="text-align: center;" class="qbTableData"><select onchange="qb_setFun(this)" class="qbfun" id="_fun"></select></td>',
'<td style="text-align: center;" class="qbTableData"><input id="_grp" type="checkbox" onclick="qb_toggleGrp(this)" /></td>',
'<td style="text-align: center;" class="htmldbPseudoButton"><img id="_del"  src="#IMAGE_PREFIX#delete.gif" onclick="qb_rmConditionImg(this.value)" /></td>',
'</tr>',
'</table>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1996130208515869)
,p_plug_name=>'Query Builder List Menu'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_list_id=>wwv_flow_imp.id(1993413324492056)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(18702621564272688)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="defaultLinkMenu" style="display:none;">'
,p_plug_footer=>'</div>'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2310326687229087)
,p_plug_name=>'Save SQL'
,p_region_name=>'saveDialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>50
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2422415865645260)
,p_plug_name=>'Dynamic js '
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>90
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<script type="text/javascript"> '');',
'sys.htp.p(''var l_maxCols="''||',
'            wwv_flow_lang.system_message(p_name=>''4500_1002_QB_MAX_COLS'')||''";'');',
'sys.htp.p(''var l_noSave="''||',
'            wwv_flow_lang.system_message(p_name=>''QB_NOTHING_TO_SAVE'')||''";'');',
'sys.htp.p(''var l_noName="''||',
'            wwv_flow_lang.system_message(p_name=>''SC_NAME_NN'')||''";'');',
'sys.htp.p(''var l_invSo="''||',
'            wwv_flow_lang.system_message(p_name=>''INVALID_SORT_ORDER'')||''";'');',
'sys.htp.p(''</script>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11768119830012071)
,p_plug_name=>'Schema'
,p_region_name=>'apex-control-icons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>190
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28526129350879148)
,p_plug_name=>'Warning'
,p_region_name=>'warnDialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>60
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''QB_WARN_MESSAGE''));'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(170603309758466390)
,p_plug_name=>'sql workshop navigation'
,p_region_name=>'apex-sqlws-icons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>180
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(170601318269466378)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(212033724996722960)
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(249359403920818462)
,p_plug_name=>'hidden items'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157684743709338208)
,p_plug_name=>'Main'
,p_region_name=>'qbTable'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="height:600px;width:800px;"'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_02', 'horizontal',
  'attribute_03', 'begin',
  'attribute_04', '220',
  'attribute_05', 'N',
  'attribute_09', 'N',
  'attribute_12', 'Left Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'Y',
  'attribute_15', 'N',
  'attribute_16', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157684801680338209)
,p_plug_name=>'Left'
,p_region_name=>'qbSideBar'
,p_parent_plug_id=>wwv_flow_imp.id(1157684743709338208)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1038321573565388)
,p_plug_name=>'Left Header'
,p_region_name=>'qbLeftHeader'
,p_parent_plug_id=>wwv_flow_imp.id(1157684801680338209)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157685310203338214)
,p_plug_name=>'Objects List'
,p_region_name=>'dbaseObjectsSlider'
,p_parent_plug_id=>wwv_flow_imp.id(1157684801680338209)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157684935965338210)
,p_plug_name=>'Right Splitter'
,p_region_name=>'qbFrameHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1157684743709338208)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1225836530715180993)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', '#qbFrameHolder_content',
  'attribute_02', 'vertical',
  'attribute_03', 'end',
  'attribute_04', '280',
  'attribute_05', 'N',
  'attribute_09', 'N',
  'attribute_12', 'Bottom Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'Y',
  'attribute_15', 'N',
  'attribute_16', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157685084512338211)
,p_plug_name=>'Top'
,p_parent_plug_id=>wwv_flow_imp.id(1157684935965338210)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1039008891571168)
,p_plug_name=>'Right Column Top'
,p_parent_plug_id=>wwv_flow_imp.id(1157685084512338211)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157685417712338215)
,p_plug_name=>'Diagram Area'
,p_region_name=>'qbTableHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1157685084512338211)
,p_region_css_classes=>'d1 resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div>',
'  <div id="qbLinkHolder" class="resize"></div>',
'</div>'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157685103835338212)
,p_plug_name=>'Bottom'
,p_region_name=>'qbBottomHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1157684935965338210)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1393317200204756)
,p_plug_name=>'Query Builder Sub Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(1157685103835338212)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1390719147195878)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(108863608130594810)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157685538149338216)
,p_plug_name=>'Tab Holder'
,p_region_name=>'htmlTabHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1157685103835338212)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="overflow:auto;"'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1333007308012693)
,p_plug_name=>'SubTab Conditions'
,p_parent_plug_id=>wwv_flow_imp.id(1157685538149338216)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.prn(''<div id="conditionsHolder">'');',
'wwv_flow_query_builder.renderCloneRow;',
'sys.htp.prn(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table id="conditionsHolder" cellpadding="0" cellspacing="0" border="0" summary="" class="mshtmldbRowWithBorders">',
'            <tr>',
'              <td align="right" class="mshtmldbRowWithBorders2">',
'                <table id="conditions" class="htmldbStandard3" summary="" cellpadding="0" cellspacing="0" border="0" width="95%">',
'                  <tbody>',
'                    <tr>',
'                      <th><br /></th>',
'                      <th>Column</th>',
'                      <th>Alias</th>',
'                      <th>Object</th>',
'                      <th>Condition</th>',
'                      <th>Sort Type</th>',
'                      <th>Sort Order</th>',
'                      <th>Output?</th>',
'                      <th>Function</th>',
'                      <th>Group By</th>',
'                    </tr>',
'                  </tbody>',
'                </table>',
'              </td>',
'            </tr>',
'          </table>',
''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1436110377335282)
,p_plug_name=>'SubTab SQL'
,p_parent_plug_id=>wwv_flow_imp.id(1157685538149338216)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="queryText_table" class="resize" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1437123537339088)
,p_plug_name=>'SubTab Results'
,p_parent_plug_id=>wwv_flow_imp.id(1157685538149338216)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<div id="queryResults"><br/></div>'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="queryResults_table" style="display:none">'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(159962509565166619)
,p_plug_name=>'SubTab SavedSQL'
,p_parent_plug_id=>wwv_flow_imp.id(1157685538149338216)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="SavedSQLHolder" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157686118374338222)
,p_plug_name=>'Popup Style'
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'.a-Header, #R387929284740561918, .a-Footer {display: none;}',
'</style>'))
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1002_POPUP'
,p_plug_display_when_cond2=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2413904428566265)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2310326687229087)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2415211139577627)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2310326687229087)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28645317900165287)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(28526129350879148)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Return'
,p_button_position=>'NEXT'
,p_button_condition=>'P1002_POPUP'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28651301755170068)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(28526129350879148)
,p_button_name=>'OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13297030016911316)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(1039008891571168)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
,p_button_condition=>'P1002_POPUP'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2314619470331004)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(1039008891571168)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_button_condition=>'p1002_popup'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1978217274228265)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_imp.id(1039008891571168)
,p_button_name=>'RUN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Run'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:qb_genSql();html_TabClick(html_GetElement(''result_tab''),''queryResults_table'');qb_getQueryResults();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13144627705418685)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_imp.id(1039008891571168)
,p_button_name=>'RETURN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Return'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:qb_returnSQL();'
,p_button_condition=>'p1002_popup'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3579503096092654)
,p_branch_action=>'f?p=&APP_ID.:1002:&SESSION.::&DEBUG.::P1002_QUERY_ID:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1476718454545792)
,p_name=>'P1002_FIND'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1038321573565388)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>25
,p_cMaxlength=>2000
,p_tag_css_classes=>'a-Form-searchField'
,p_tag_attributes=>'onkeyup="qb_searchTables()" onchange="qb_sendState()"'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1509710676657010)
,p_name=>'P1002_QUERY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(249359403920818462)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1634500089515010)
,p_name=>'P1002_ID'
,p_item_sequence=>0
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2081632332595130)
,p_name=>'P1002_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(249359403920818462)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2306118535113108)
,p_name=>'P1002_QUERY_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(249359403920818462)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2306306638113110)
,p_name=>'P1002_QUERY_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2310326687229087)
,p_prompt=>'Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'QUERY_BUILDER_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(2308814912225605)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(3301520602864636)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'No help text available'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2306502403113110)
,p_name=>'P1002_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(249359403920818462)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2306731044113111)
,p_name=>'P1002_QUERY_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2310326687229087)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_tag_attributes=>'style="cursor:text;padding:0; z-index:8000;position:relative;"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Your query will be saved using this name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2312432143249546)
,p_name=>'P1002_QUERY_DESC'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2310326687229087)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter an optional query description.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3571131333951282)
,p_name=>'QUERYTEXT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1436110377335282)
,p_prompt=>'SQL Query'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>100
,p_cMaxlength=>32767
,p_cHeight=>12
,p_tag_css_classes=>'u-fixedFont resize'
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(6693608793786901)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3964727904071332)
,p_name=>'P1002_ONCLICK'
,p_item_sequence=>310
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11769701953016299)
,p_name=>'P1002_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(387994680244652086)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-QB'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1002_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1002_SCHEMA ) d,',
'       :P1002_SCHEMA v',
'  from sys.dual',
' where :P1002_POPUP = 1',
' order by 1'))
,p_cHeight=>1
,p_tag_attributes=>'a-Form-select'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13132612421385865)
,p_name=>'P1002_POPUP'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2422415865645260)
,p_item_default=>'0'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13137304371402423)
,p_name=>'P1002_RETURN_INTO'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2422415865645260)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110230120799906584)
,p_name=>'P1002_RESULTS_ERROR_MSG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2422415865645260)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_lang.system_message(''QB_CREATE_QUERY'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114668822188903097)
,p_name=>'P1002_IMAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(249359403920818462)
,p_source=>'<div id="dragimg" style="position:absolute;left:0;top:0;display:none;"><img src="#IMAGE_PREFIX#qb/drag.png" alt="" /></div>'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'style="display:none;"'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2158316801387544526)
,p_computation_sequence=>10
,p_computation_item=>'P1002_POPUP'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2324421042444998)
,p_computation_sequence=>10
,p_computation_item=>'P1002_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1002_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL_OR_ZERO'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929196863636394232)
,p_name=>'Save'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2314619470331004)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929196916531394233)
,p_event_id=>wwv_flow_imp.id(929196863636394232)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2310326687229087)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929197068811394234)
,p_name=>'Save SQL Cancel'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2413904428566265)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929197142931394235)
,p_event_id=>wwv_flow_imp.id(929197068811394234)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2310326687229087)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929197233776394236)
,p_name=>'Save SQL Save'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2415211139577627)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929197343166394237)
,p_event_id=>wwv_flow_imp.id(929197233776394236)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'qb_saveQuery(''SAVE'');'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929197456427394238)
,p_name=>'Warning Cancel'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(28645317900165287)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929197547407394239)
,p_event_id=>wwv_flow_imp.id(929197456427394238)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'window.close();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929197621895394240)
,p_name=>'Warning OK'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(28651301755170068)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929197781041394241)
,p_event_id=>wwv_flow_imp.id(929197621895394240)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(28526129350879148)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(260977613488485260)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1002_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1002_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>260977613488485260
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2305502473099041)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Page Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p1002_query_id is null then',
'  :p1002_query_type := ''P'';',
'  :p1002_owner := :FLOW_USER;',
'  :p1002_query_name := '''';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to populate initial values.'
,p_internal_uid=>2305502473099041
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7886012904365381)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save_Query_PPR'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i number;',
'  l_ret varchar2(32767);',
'  qid number := -99;',
'  l_o_name varchar2(2000);',
'begin',
'  wwv_flow_sw_api.check_priv(:P1002_SCHEMA);',
'',
'  begin',
'    if wwv_flow.g_f22(1) is not null then',
'      qid := wwv_flow.g_f22(1);',
'    end if;',
'  exception when others then',
'    null;',
'  end;',
'',
'  begin',
'    select title into l_o_name from wwv_flow_qb_saved_query where id = qid;',
'  exception when others then',
'    l_o_name := ''''; ',
'  end;',
'',
'  if (wwv_flow.g_f19(1) = l_o_name) then',
'    delete from wwv_flow_qb_saved_query where id = qid;',
'    commit;',
'  else',
'      qid := wwv_flow_id.next_val;',
'  end if;',
'  ',
'  insert into wwv_flow_qb_saved_query ',
'   (id, title, query_type, description, qb_sql, query_owner, created_by ) ',
'  values ',
'   (qid, wwv_flow.g_f19(1) , ''W'', wwv_flow.g_f21(1), wwv_flow.g_f23(1), :P1002_SCHEMA, :FLOW_USER );',
'',
'  for i in 1..wwv_flow.g_f01.count loop',
'    insert into wwv_flow_qb_saved_tabs ',
'     (id, oid, cnt, top, left, tname ) ',
'    values ',
'     (qid,wwv_flow.g_f01(i),wwv_flow.g_f02(i),wwv_flow.g_f03(i),wwv_flow.g_f04(i),wwv_flow.g_f05(i));',
'  end loop;',
'',
'  for i in 1..wwv_flow.g_f06.count loop',
'    insert into wwv_flow_qb_saved_cond ',
'     (id, col, alias, fv, fp, out, st, so, grp, con, ord) ',
'    values ',
'     (qid, wwv_flow.g_f06(i), wwv_flow.g_f07(i), wwv_flow.g_f08(i), wwv_flow.g_f09(i),',
'      wwv_flow.g_f10(i), wwv_flow.g_f11(i), wwv_flow.g_f12(i), wwv_flow.g_f13(i), wwv_flow.g_f14(i),',
'      i);',
'  end loop;',
'   ',
'  for i in 1..wwv_flow.g_f15.count loop',
'    insert into wwv_flow_qb_saved_join ',
'     (id, field1, field2, cond) ',
'    values ',
'     (qid,wwv_flow.g_f15(i),wwv_flow.g_f16(i),wwv_flow.g_f17(i));',
'  end loop;',
'',
'  sys.htp.prn(qid);',
'  wwv_flow.g_unrecoverable_error := true;',
'EXCEPTION WHEN OTHERS THEN ',
' sys.htp.prn(''---''||wwv_flow_escape.html(SQLERRM));',
' wwv_flow.g_unrecoverable_error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'SAVE_QUERY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Success'
,p_internal_uid=>7886012904365381
);
end;
/
prompt --application/pages/page_01003
begin
wwv_flow_imp_page.create_page(
 p_id=>1003
,p_name=>'SQL Command Processor'
,p_alias=>'SQLCOMMANDPROCESSOR'
,p_step_title=>'SQL Commands'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213236325564854129)
,p_javascript_file_urls=>'#IMAGE_PREFIX#sc/sc_core.js'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(document).ready(function() {',
'  apex.jQuery(".a-Body, .a-Main").addClass("resize");  ',
'  apex.theme.pageResizeInit();',
'});',
''))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sc_PageInit();',
'',
'$("body").trigger("resize");',
'',
'var resizeTimeout = 0;',
'',
'var editorWidget = $("#P1003_SQL_COMMAND1_widget");',
'',
'editorWidget.css("height", "100%");',
'editorWidget.resize();',
'',
'// resize event is triggered twice',
'// adding a timeout for resizing the code editor only once',
'$(''#scCommandHolder'').on(''resize'', function(){',
'    clearTimeout(resizeTimeout);',
'    resizeTimeout = setTimeout(function(){',
'        editorWidget.resize();',
'    }, 100);',
'});',
'',
'var runButton = $(''#scRightHeader .a-Button--hot'');',
'',
'if ( runButton.length ) {',
'    runButton.click( function() {',
'        apex.item("P1003_SQL_COMMAND1").setFocus();',
'    });',
'}',
''))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#htmlTabHolder ',
'{',
'    overflow: auto; ',
'}',
'',
'#P1003_SQL_COMMAND1_CONTAINER',
'{',
'    overflow: hidden ',
'}',
'',
'.a-Form-inputContainer',
'{',
'    height: 100%;',
'}',
''))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_proc.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6464923591877238)
,p_plug_name=>'Save SQL'
,p_region_name=>'saveDialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22950425871849907)
,p_plug_name=>'javascript'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'var ret = $v("P1003_RETURN_INTO"), value = opener.$v(ret);',
'$s("P1003_SQL_COMMAND2", value);',
'$s("P1003_SQL_COMMAND1", value);',
'</script>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':p1003_popup = 1 ',
'and :p1003_RETURN_INTO is not null'))
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_read_only_when2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160850031678663106)
,p_plug_name=>'Dynamic Js'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<script type="text/javascript"> '');',
'sys.htp.p(''g_Running="''|| ',
'            wwv_flow_lang.system_message(p_name=>''SC_SQL_RUNNING'')||''";'');',
'sys.htp.p(''</script>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157686386582338224)
,p_plug_name=>'Main'
,p_region_name=>'SqlAndResults'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="height:600px;width:100%;" 400px;"'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_02', 'vertical',
  'attribute_03', 'end',
  'attribute_04', '200',
  'attribute_08', '100',
  'attribute_09', 'N',
  'attribute_12', 'Bottom Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'N',
  'attribute_15', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157686476230338225)
,p_plug_name=>'Top'
,p_parent_plug_id=>wwv_flow_imp.id(1157686386582338224)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1008808320154634)
,p_plug_name=>'SQL Command Entry'
,p_region_name=>'scCommandHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1157686476230338225)
,p_region_css_classes=>'a-Form--slimPadding resize d1'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(149883011479458110)
,p_plug_name=>'Top Header'
,p_region_name=>'scRightHeader'
,p_parent_plug_id=>wwv_flow_imp.id(1157686476230338225)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157686581263338226)
,p_plug_name=>'Bottom'
,p_region_name=>'scBottomHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1157686386582338224)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'aria-live="polite"'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(998332374048023)
,p_plug_name=>'SQL Command Sub Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(1157686581263338226)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(996508348031635)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(11751121765920036)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157686726641338228)
,p_plug_name=>'Tab Holder'
,p_region_name=>'htmlTabHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1157686581263338226)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7074001099790125)
,p_plug_name=>'SubTab Results'
,p_region_name=>'resultsHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1157686726641338228)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="fielddata"'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="fielddata">',
'Enter SQL statement or PL/SQL command and click Run to see the results.',
'</span>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7077724001825157)
,p_plug_name=>'SubTab Explain'
,p_parent_plug_id=>wwv_flow_imp.id(1157686726641338228)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="explainHolder" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7079506471829522)
,p_plug_name=>'SubTab SavedSQL'
,p_parent_plug_id=>wwv_flow_imp.id(1157686726641338228)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="SavedSQLHolder" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11759823723994214)
,p_plug_name=>'schema'
,p_region_name=>'sql-schema-select'
,p_parent_plug_id=>wwv_flow_imp.id(1157686726641338228)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22163002271588185)
,p_plug_name=>'SubTab Describe'
,p_parent_plug_id=>wwv_flow_imp.id(1157686726641338228)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="describeHolder" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23969318672589066)
,p_plug_name=>'SubTab History'
,p_parent_plug_id=>wwv_flow_imp.id(1157686726641338228)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div id="historyHolder" style="display:none;">'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157686679267338227)
,p_plug_name=>'Hidden Items'
,p_plug_display_sequence=>30
,p_plug_display_point=>'AFTER_HEADER'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1272958007418897127)
,p_plug_name=>'Popup Style'
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'.a-Header, #R387929284740561918, .a-Footer {display: none;}',
'</style>'))
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1003_POPUP'
,p_plug_display_when_cond2=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22939220621744313)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_button_name=>'RETURN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Return'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:sc_returnSQL();'
,p_button_condition=>'P1003_POPUP'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10646217569354338)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Save'
,p_button_position=>'CREATE'
,p_button_condition=>'P1003_POPUP'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10644629905348428)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_button_name=>'RUN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6472826193915838)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6464923591877238)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6474106585919640)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6464923591877238)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13280425243815372)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'VIEW_SCRIPTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4421816717753960)
,p_branch_action=>'f?p=&APP_ID.:1003:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1009422172158645)
,p_name=>'P1003_SQL_COMMAND2'
,p_data_type=>'CLOB'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1157686679267338227)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1010404642163039)
,p_name=>'P1003_SQL_COMMAND1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1008808320154634)
,p_prompt=>'SQL Command'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>5
,p_tag_css_classes=>'a-Form-textarea--code'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_css_classes=>'resize'
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P1003_CMD_EDITOR_LANGUAGE'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1928693836020541)
,p_name=>'P1003_CMD_LANGUAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Determines the language which should be used to execute the entered statement.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3016364673375330)
,p_name=>'P1003_MLE_ENV'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_prompt=>'Environment'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d,',
'       object_name r',
'  from (',
'         select case when o.owner != :P1003_SCHEMA then o.owner || ''.'' end || object_name as object_name',
'          from ( select o.owner, o.owner as grantee, o.object_type, o.object_name',
'                   from sys.dba_objects o',
'                  union',
'                 select p.owner, p.grantee, p.type, p.table_name',
'                   from sys.dba_tab_privs p ) o',
'         where o.object_type = ''MLE ENVIRONMENT''',
'           and o.grantee in ( :P1003_SCHEMA, ''PUBLIC'' )',
'       )',
'order by object_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Default'
,p_lov_cascade_parent_items=>'P1003_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_attributes=>'class="a-Form-select" onchange="sc_SetMleEnvOnly()"'
,p_begin_on_new_line=>'N'
,p_display_when=>'wwv_flow_db_version.c_has_mle_with_modules'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Determines the MLE Environment which should be used to execute the entered statement.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3016727094375334)
,p_name=>'P1003_CMD_EDITOR_LANGUAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Determines the language which should be used to execute the entered statement.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6470812902902555)
,p_name=>'P1003_SAVE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6464923591877238)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Your query will be saved using this name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6471725716906222)
,p_name=>'P1003_SAVE_DESC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6464923591877238)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter an optional query description.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6499004703108337)
,p_name=>'P1003_QUERY_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1157686679267338227)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11765804246007547)
,p_name=>'P1003_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(387994680244652086)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1003_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1003_SCHEMA ) d,',
'       :P1003_SCHEMA v',
'  from sys.dual',
' where :P1003_POPUP = 1',
' order by 1'))
,p_cHeight=>1
,p_tag_attributes=>'class="a-Form-select" onchange="sc_SetSchemaOnly()"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12103711913917886)
,p_name=>'P1003_ERASE_ICON'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_source=>'''<a href="javascript:setValue(''''P1003_SQL_COMMAND1'''','''''''');$x(''''P1003_SQL_COMMAND1'''').focus();" class="a-Button a-Button--small">''||wwv_flow_lang.system_message(''CLEAR_COMMAND'')||''</a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML_UNSAFE'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''<a href="javascript:setValue(''''P1003_SQL_COMMAND1'''','''''''');$x(''''P1003_SQL_COMMAND1'''').focus();" class="a-Button a-Button--small">',
'<img alt="''||wwv_flow_lang.system_message(''CLEAR_COMMAND'')||''" title="''||wwv_flow_lang.system_message(''CLEAR_COMMAND'')||''" src="#IMAGE_PREFIX#htmldb/icons/erase_16.gif" />',
'</a>'''))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12106403864934485)
,p_name=>'P1003_FIND_ICON'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''<a href="javascript:popupURL(''''f?p=4500:24:&SESSION.:SC::24:P24_STATE:SC:'''');"',
'    class="a-Button a-Button--small a-Button--padLeft">'' ||',
'    wwv_flow_lang.system_message(''FIND_TABLES'') ||',
'    ''</a>'''))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML_UNSAFE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22427709467385060)
,p_name=>'P1003_DESC_OBJ'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1157686679267338227)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22928616063638920)
,p_name=>'P1003_POPUP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1157686679267338227)
,p_item_default=>'0'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22929809614646511)
,p_name=>'P1003_RETURN_INTO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1157686679267338227)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(136320022504169238)
,p_name=>'P1003_AUTOCOMMIT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_item_default=>'Y'
,p_prompt=>'Autocommit'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onclick="this.blur();" onchange="sc_toggleJob(this);"'
,p_display_when=>'nvl(wwv_flow_platform.get_preference(''ENABLE_TRANSACTIONAL_SQL''),''N'') = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_required_patch=>wwv_flow_imp.id(140211619632429750)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(136534514172415835)
,p_name=>'P1003_JOBID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1157686679267338227)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138940226594571588)
,p_name=>'P1003_ROWS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_item_default=>'10'
,p_prompt=>'Rows'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Determines the maximum number of result rows to display for SQL queries.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183853180032893742)
,p_name=>'P1003_DICTIONARY_QUERY_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1008808320154634)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(355992729508853224)
,p_name=>'P1003_LANGUAGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(149883011479458110)
,p_use_cache_before_default=>'NO'
,p_source=>'return wwv_flow.g_browser_language;'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1157686252918338223)
,p_computation_sequence=>10
,p_computation_item=>'P1003_POPUP'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1440283825697991815)
,p_name=>'REMOVE_JOB_ON_UNLOAD'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'unload'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1440284123781991817)
,p_event_id=>wwv_flow_imp.id(1440283825697991815)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'EVENT_SOURCE'
,p_attribute_01=>'sc_removeJob();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929197857307394242)
,p_name=>'Save Cancel'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(6472826193915838)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929197977146394243)
,p_event_id=>wwv_flow_imp.id(929197857307394242)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sc_CancelSave();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929198077910394244)
,p_name=>'Save Save'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(6474106585919640)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929198114155394245)
,p_event_id=>wwv_flow_imp.id(929198077910394244)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sc_saveSql();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929198245230394246)
,p_name=>'Open Save Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(10646217569354338)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929198332391394247)
,p_event_id=>wwv_flow_imp.id(929198245230394246)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6464923591877238)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929198492500394248)
,p_name=>'Run'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(10644629905348428)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929198544616394249)
,p_event_id=>wwv_flow_imp.id(929198492500394248)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'html_TabClick(html_GetElement(''result_tab''),''resultsHolder'');',
'setTimeout(function() {',
'    sc_getResults(''&SESSION.'', true);',
'},100);',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(183853259628893743)
,p_name=>'Set Chart Query'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'REQUEST_EQUALS_CONDITION'
,p_display_when_cond=>'CHART_QUERY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(183853351376893744)
,p_event_id=>wwv_flow_imp.id(183853259628893743)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1003_SQL_COMMAND1'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       decode(FK_CHART_QUERY,',
'              null,',
'              ''select "''||COLUMN_NAME||''", count(*) c ''||chr(10)||',
'              ''from "''||TABLE_NAME||''" ''||chr(10)||',
'              ''group by "''||COLUMN_NAME||''" ''||chr(10)||',
'              ''order by 2 desc'',FK_CHART_QUERY) chart_query',
'from WWV_DICTIONARY_CACHE_COL',
'where OWNER_NAME = :P1003_SCHEMA',
'  and TABLE_NAME = :OBJECT_NAME',
'  and security_group_id = :WORKSPACE_ID',
'  and id = :P1003_DICTIONARY_QUERY_ID',
''))
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(183853431151893745)
,p_event_id=>wwv_flow_imp.id(183853259628893743)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'html_TabClick(html_GetElement(''result_tab''),''resultsHolder'');',
'setTimeout(function() {',
'    sc_getResults(''&SESSION.'', true);',
'},100);',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(173569190786980902)
,p_name=>'Set Table Query'
,p_event_sequence=>70
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'REQUEST_EQUALS_CONDITION'
,p_display_when_cond=>'TABLE_QUERY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173569217880980903)
,p_event_id=>wwv_flow_imp.id(173569190786980902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1003_SQL_COMMAND1'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sys.dbms_lob.substr(DEFAULT_QUERY,32767,1) DEFAULT_QUERY',
'  from WWV_DICTIONARY_CACHE_OBJ co',
' where co.object_owner = :P1003_SCHEMA',
'   and co.object_name = :OBJECT_NAME',
'   and co.security_group_id = :WORKSPACE_ID',
''))
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173569334225980904)
,p_event_id=>wwv_flow_imp.id(173569190786980902)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'html_TabClick(html_GetElement(''result_tab''),''resultsHolder'');',
'setTimeout(function() {',
'    sc_getResults(''&SESSION.'', true);',
'},100);',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(616816958352762844)
,p_name=>'Initialize Ctrl+Enter command'
,p_event_sequence=>80
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(616817066061762845)
,p_event_id=>wwv_flow_imp.id(616816958352762844)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function execute(){',
'    html_TabClick($x(''result_tab''), ''resultsHolder'');',
'    // keeps the UI usable while waiting for results.',
'    setTimeout(function () {',
'      sc_getResults($v("pInstance"));',
'    }, 1);',
'}',
'',
'var isMacLike = /(Mac|iPhone|iPod|iPad)/i.test(navigator.platform);',
'',
'var editor = $(''#P1003_SQL_COMMAND1_widget'').codeEditor(''getEditor'');',
'',
'if( isMacLike ){',
'    // special control key on Mac',
'    // this won''t override Insert Line Below as they are mapped to different keys',
'    editor.addCommand(monaco.KeyMod.WinCtrl | monaco.KeyCode.Enter, execute);',
'} else {',
'    // regular control key for all other OSes',
'    // this will override Insert Line Below, which is ok',
'    editor.addCommand(monaco.KeyMod.CtrlCmd | monaco.KeyCode.Enter, execute);',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3016445213375331)
,p_name=>'Show/Hide MLE Env'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1003_CMD_LANGUAGE'
,p_condition_element=>'P1003_CMD_LANGUAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'JAVASCRIPT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'wwv_flow_db_version.c_has_mle_with_modules'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3016587226375332)
,p_event_id=>wwv_flow_imp.id(3016445213375331)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1003_MLE_ENV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3016664810375333)
,p_event_id=>wwv_flow_imp.id(3016445213375331)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1003_MLE_ENV'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3016857430375335)
,p_name=>'Adjust Editor Language'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1003_CMD_LANGUAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3016929208375336)
,p_event_id=>wwv_flow_imp.id(3016857430375335)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let editorLang = $v( "P1003_CMD_LANGUAGE" );',
'if( editorLang === "JAVASCRIPT" ) {',
'    editorLang = $.apex.codeEditor.LANG_JAVASCRIPT_MLE_SNIPPET;',
'}',
'$s( "P1003_CMD_EDITOR_LANGUAGE", editorLang );',
''))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(14017618785721380)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'default schema'
,p_process_sql_clob=>':P1003_SCHEMA := wwv_flow_user_api.get_default_schema;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>14017618785721380
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(260980702453510428)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>260980702453510428
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(161193710216800474)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1003_SQL_COMMAND2 := '''';',
':P1003_QUERY_ID := '''';',
':P1003_SQL_COMMAND1 := '''';',
':P1003_SAVE_NAME  := '''';',
':P1003_SAVE_DESC := '''';'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>161193710216800474
);
end;
/
prompt --application/pages/page_01004
begin
wwv_flow_imp_page.create_page(
 p_id=>1004
,p_name=>'SQL Scripts'
,p_alias=>'SQL-SCRIPTS'
,p_step_title=>'SQL Scripts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11093307704620192)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>',
'<script src="#IMAGE_PREFIX#sc/sc_core.js" type="text/javascript"></script>'))
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_rep.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(163472020717455733)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(163470423703447178)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(20507805987268923)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467833706021240350)
,p_plug_name=>'Scripts'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P1004a */',
'f.id,',
'decode(doc_size,0,',
'       ''&nbsp'',',
'       ''<a href="''||wwv_flow_utilities.prepare_url(''f?p=4500:60:''||:flow_session||''::::P60_FILE_ID:'' ||f.id)||''" class="a-Button a-Button--small">''||',
'       ''<span class="a-Icon icon-edit" title="&EDIT."></span></a>''',
'       ) edit,',
'wwv_flow_item.checkbox(1,f.id,''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(f.filename))||''"'') cb,',
'substr(f.filename,1,50) t,',
'f.CREATED_ON created,',
'f.created_by,',
'nvl(f.updated_on,f.created_on) updated,',
'f.updated_by,',
'f.doc_size doc_size,',
'(select decode(count(*),0,',
'        ''0'',',
'        sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:1220:''||:flow_session||''::::IR_FILE_ID:''||f.id),',
'        to_char(count(*),''999G999G999G999G990''))) c ',
'        from WWV_FLOW_SW_RESULTS',
'        where file_id = f.id) ouput_count,       ',
'decode(doc_size,1,sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:1022:''||:flow_session||''::::P1022_FILE_ID:''|| f.id),',
'       ''<img src="#IMAGE_PREFIX#htmldb/icons/error_small.gif" alt="''||wwv_flow_lang.system_message(''ERROR'')||''" />''),',
'decode(wwv_flow_sw_parser.parsed(f.id),1,',
'decode(wwv_flow_sw_script.invalid_script(f.id), 1,',
'       sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:1022:''||:flow_session||''::::P1022_FILE_ID:''|| f.id),',
'       ''<span class="a-Icon icon-error" title="''||wwv_flow_lang.system_message(''ERROR'')||''"></span>''),',
'       sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:10:''||:flow_session||''::::F4500_P10_FILE_ID:''|| f.id),',
'       ''<span class="a-Icon icon-run-script" title="''||wwv_flow_lang.system_message(''DEMO_APPLICATION.RUN'')||''"></span>'')),',
'       sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4500:1023:''||:flow_session||''::::P1023_FILE_ID:''|| f.id),',
'       ''<span class="a-Icon icon-run-script" title="''||wwv_flow_lang.system_message(''DEMO_APPLICATION.RUN'')||''"></span>''))) r,',
'       nvl(updated_on,created_on) updated_on_sort,',
'       ''icon-util-script'' icon_img, ',
'   ''&EDIT.'' icon_alt,',
'    decode(doc_size,0,',
'       ''#'',',
'     wwv_flow_utilities.prepare_url(',
'       ''f?p=4500:60:''||:flow_session||''::::P60_FILE_ID:'' ||f.id)',
'       ) icon_edit,',
'       substr(f.filename,1,50) icon_script_name',
'from wwv_flow_files f, wwv_flow_fnd_user u',
'where u.security_group_id = :flow_security_group_id',
'and u.user_name = :APP_USER',
'and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'       or exists ( select 1',
'                     from  wwv_flow_developers',
'                    where security_group_id = :flow_security_group_id',
'                      and userid = :APP_USER',
'                      and instr(developer_role||'':'',''ADMIN:'') > 0',
'                    union',
'                   select 1',
'                     from wwv_flow_fnd_user',
'                    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                      and user_name = :APP_USER',
'                      and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(467833818073240350)
,p_name=>'Scripts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#ICON_EDIT#" class="a-IRR-icon"><span class="a-Icon #ICON_IMG#"></span><span class="a-IRR-iconName">#ICON_SCRIPT_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834017393240364)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834225670240368)
,p_db_column_name=>'CB'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834117249240367)
,p_db_column_name=>'EDIT'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Edit'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834516929240371)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834312564240369)
,p_db_column_name=>'T'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834400346240370)
,p_db_column_name=>'CREATED'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834613111240372)
,p_db_column_name=>'UPDATED'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Updated On'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834724673240373)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467835106111240377)
,p_db_column_name=>'UPDATED_ON_SORT'
,p_display_order=>9
,p_column_identifier=>'L'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834829151240374)
,p_db_column_name=>'DOC_SIZE'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Bytes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467834916936240375)
,p_db_column_name=>'OUPUT_COUNT'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Results'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467835016550240376)
,p_db_column_name=>'R'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Run'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467835717156298381)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Icon Image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467835812010298382)
,p_db_column_name=>'ICON_ALT'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Icon Alternative Text'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467835920704298388)
,p_db_column_name=>'ICON_EDIT'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Edit Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467836014574298389)
,p_db_column_name=>'ICON_SCRIPT_NAME'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Script Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(467836414517307027)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1319202581536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'ID:CB:EDIT:CREATED_BY:T:CREATED:UPDATED_BY:UPDATED_ON_SORT:DOC_SIZE:OUPUT_COUNT:R:ICON_IMG:ICON_ALT:ICON_EDIT:ICON_SCRIPT_NAME'
,p_sort_column_1=>'UPDATED_ON_SORT'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10684914348921132)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(467833706021240350)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10807025483846713)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(467833706021240350)
,p_button_name=>'UPLOAD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Upload'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1017:&SESSION.::&DEBUG.:RP,1017:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4213240874740764243)
,p_button_sequence=>25
,p_button_plug_id=>wwv_flow_imp.id(467833706021240350)
,p_button_name=>'CREATE_QS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Quick SQL'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10811003413897151)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(467833706021240350)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:60,SR_SCRIPT_SOURCE::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(10682401792909898)
,p_branch_action=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112519217202485006)
,p_validation_name=>'must select script(s) to delete'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Scripts to delete must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(10684914348921132)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(657007896931142127)
,p_name=>'Refresh Report'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(10807025483846713)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(657007940226142128)
,p_event_id=>wwv_flow_imp.id(657007896931142127)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(467833706021240350)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199175924058878435)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(467833706021240350)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199176000849878436)
,p_event_id=>wwv_flow_imp.id(1199175924058878435)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10688117596931583)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    wwv_flow_sw_script.delete_file (wwv_flow.g_f01(i));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete script(s).'
,p_process_when_button_id=>wwv_flow_imp.id(10684914348921132)
,p_process_success_message=>'Script(s) deleted.'
,p_internal_uid=>10688117596931583
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(109964518598304737)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_type=>'NEVER'
,p_internal_uid=>109964518598304737
);
end;
/
prompt --application/pages/page_01005
begin
wwv_flow_imp_page.create_page(
 p_id=>1005
,p_name=>'Utilities'
,p_alias=>'UTILITIES'
,p_step_title=>'Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11093307704620192)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169564631965962067)
,p_plug_name=>'Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--noBadge:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(169562905299954428)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(466733423380364017)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use these utilities to load and unload data from an Oracle database, generate DDL, view object reports, and restore dropped database objects.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(171468103360681580)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1005'
);
end;
/
prompt --application/pages/page_01017
begin
wwv_flow_imp_page.create_page(
 p_id=>1017
,p_name=>'Upload Script'
,p_alias=>'UPLOAD-SCRIPT'
,p_page_mode=>'MODAL'
,p_step_title=>'Upload Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep_script_upload.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10998013210200854)
,p_plug_name=>'Upload Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>11
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208324524754634133)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>21
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10999819574212100)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208324524754634133)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upload'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(969052831447554615)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208324524754634133)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8484026248651124)
,p_name=>'P1017_SCRIPT_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(10998013210200854)
,p_prompt=>'Script Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>70
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter a script name if you wish to use different script name other than the uploaded script name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11002725686280101)
,p_name=>'P1017_FILE'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(10998013210200854)
,p_prompt=>'File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>50
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Click <strong>Browse</strong> to locate the script to be uploaded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11003907378303220)
,p_name=>'P1017_FILE_CHARSET'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(10998013210200854)
,p_prompt=>'File Character Set'
,p_source=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(143356515285702408)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Choose the character set in which the script is encoded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16681422922177974)
,p_name=>'P1017_FILENAME'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(10998013210200854)
,p_prompt=>'File Name'
,p_source=>'substr(:P1017_FILE,instr(:P1017_FILE,''/'')+1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Name of the script to upload.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(16561628697971464)
,p_computation_sequence=>10
,p_computation_item=>'P1017_SCRIPT_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(:P1017_FILE,instr(:P1017_FILE,''/'')+1)'
,p_compute_when=>'P1017_SCRIPT_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11011107687350655)
,p_validation_name=>'P1017_FILE'
,p_validation_sequence=>20
,p_validation=>'P1017_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Script must be loaded.'
,p_when_button_pressed=>wwv_flow_imp.id(10999819574212100)
,p_associated_item=>wwv_flow_imp.id(11002725686280101)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8495330235690148)
,p_validation_name=>'script name must be unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_cnt number := 0;',
'begin',
'  for c1 in (select count(*) cnt',
'             from wwv_flow_files',
'             where lower(filename) = lower(:P1017_SCRIPT_NAME)',
'             and file_type = ''SCRIPT'')',
'  loop',
'    l_cnt := c1.cnt;',
'  end loop;',
'  if l_cnt > 0 then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'A script with this name already exists.  Please upload script with different name.'
,p_validation_condition=>'P1017_SCRIPT_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(10999819574212100)
,p_associated_item=>wwv_flow_imp.id(8484026248651124)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(133436003289757453)
,p_validation_name=>'script not 0 bytes'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_doc_size number := 0;',
'begin',
'  for c1 in (select doc_size                     ',
'             from wwv_flow_files',
'             where name = :P1017_FILE)',
'  loop',
'    l_doc_size := c1.doc_size;',
'  end loop;',
'  if l_doc_size = 0 then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The uploaded script is empty.  Please upload the script with content.'
,p_validation_condition=>'P1017_FILE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(10999819574212100)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(133442803382814264)
,p_validation_name=>'exceeds max size'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_doc_size number := 0;',
'  l_max_size number := 0;',
'begin',
'  l_max_size := nvl(wwv_flow_platform.get_preference(''MAX_SCRIPT_SIZE''),500000);',
'  ',
'  for c1 in (select doc_size                     ',
'             from wwv_flow_files',
'             where name = :P1017_FILE)',
'  loop',
'    l_doc_size := c1.doc_size;',
'  end loop;',
'  if l_doc_size > l_max_size then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The script exceeds the maximum size allowed.'
,p_validation_condition=>'P1017_FILE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(10999819574212100)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(969053132020554618)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(969052831447554615)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(969053206061554619)
,p_event_id=>wwv_flow_imp.id(969053132020554618)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11012208080379125)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save File Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_script.save_file_attrib(',
'    p_flow_id           => :flow_id,',
'    p_security_group_id => :flow_security_group_id,',
'    p_name              => :P1017_FILE,',
'    p_created_by        => :flow_user,',
'    p_filename          => :P1017_SCRIPT_NAME,    ',
'    p_file_type         => ''SCRIPT'',',
'    p_file_charset      => :P1017_FILE_CHARSET',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to upload script.'
,p_process_when_button_id=>wwv_flow_imp.id(10999819574212100)
,p_process_success_message=>'Script uploaded.  You may click on the script to edit or run it.'
,p_internal_uid=>11012208080379125
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11013500377395876)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Parse Uploaded File'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_id number := 0;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_files',
'             where name = :P1017_FILE)',
'  loop',
'    l_id := c1.id;',
'  end loop;',
'  if l_id != 0 then',
'    wwv_flow_sw_parser.parse_file( p_file_id => l_id );',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to parse the script.'
,p_process_when_button_id=>wwv_flow_imp.id(10999819574212100)
,p_internal_uid=>11013500377395876
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(657007761187142126)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>657007761187142126
);
end;
/
prompt --application/pages/page_01022
begin
wwv_flow_imp_page.create_page(
 p_id=>1022
,p_name=>'Invalid Script'
,p_alias=>'INVALID-SCRIPT'
,p_step_title=>'Invalid Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_rep.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27980719731681180)
,p_plug_name=>'Invalid Script'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_script.display_invalid_stmt(',
'    p_file_id => :P1022_FILE_ID,',
'    p_date_time_format => :DATE_TIME_FORMAT );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1301955172115853704)
,p_name=>'&nbsp;'
,p_parent_plug_id=>wwv_flow_imp.id(27980719731681180)
,p_template=>wwv_flow_imp.id(746376253838324384)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.filename "Script Name",',
'               f.created_by "Created By",',
'               f.created_on "Created On",',
'               f.updated_on "Updated",',
'               f.doc_size "Script Size in Bytes",',
'               (select count(distinct stmt_number) "Number of Statements"',
'               from wwv_flow_sw_stmts',
'               where file_id = f.id',
'               and isrunnable = ''Y''',
'               and security_group_id = :FLOW_SECURITY_GROUP_ID) cnt',
'               from wwv_flow_files f',
'               where f.id = :P1022_FILE_ID'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1127586271702515372)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301955215074853705)
,p_query_column_id=>1
,p_column_alias=>'Script Name'
,p_column_display_sequence=>1
,p_column_heading=>'Script Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301955354792853706)
,p_query_column_id=>2
,p_column_alias=>'Created By'
,p_column_display_sequence=>2
,p_column_heading=>'Created By'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301955457770853707)
,p_query_column_id=>3
,p_column_alias=>'Created On'
,p_column_display_sequence=>3
,p_column_heading=>'Created On'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301955562422853708)
,p_query_column_id=>4
,p_column_alias=>'Updated'
,p_column_display_sequence=>4
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301955678832853709)
,p_query_column_id=>5
,p_column_alias=>'Script Size in Bytes'
,p_column_display_sequence=>5
,p_column_heading=>'Script Size in Bytes'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301955726828853710)
,p_query_column_id=>6
,p_column_alias=>'CNT'
,p_column_display_sequence=>6
,p_column_heading=>'Number of Statements'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28014901498959784)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(27980719731681180)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Edit Script'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:&P1022_FILE_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28020314789973088)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(27980719731681180)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1004:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27995229493863723)
,p_name=>'P1022_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(27980719731681180)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01023
begin
wwv_flow_imp_page.create_page(
 p_id=>1023
,p_name=>'Parse Script'
,p_alias=>'PARSE-SCRIPT'
,p_step_title=>'Parse Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="sc_parsing()"'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function sc_parsing(){      ',
'  var get = new htmldb_Get(null,4500,''APPLICATION_PROCESS=sr_parsing'',0);',
'  var results = get.get();',
'  var status = results.substring(0,7);',
'  if (status == ''FAILURE''){',
'    doSubmit(''FAILURE'');',
'  }',
'  else{',
'    doSubmit(''SUCCESS'');',
'  } ',
'}'))
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/sql_rep.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28035817091039968)
,p_plug_name=>'Parsing Script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(969056247209554649)
,p_plug_name=>'Parsing Script, please wait...'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(969056395065554650)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28113528248298642)
,p_branch_action=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::F4500_P10_FILE_ID:&P1023_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SUCCESS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28114808293302384)
,p_branch_action=>'f?p=&APP_ID.:1022:&SESSION.::&DEBUG.::P1022_FILE_ID:&P1023_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'FAILURE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28037905448046026)
,p_name=>'P1023_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(28035817091039968)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28058730045128869)
,p_name=>'P1023_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(28035817091039968)
,p_source=>'PARSING'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01040
begin
wwv_flow_imp_page.create_page(
 p_id=>1040
,p_name=>'Invalid Objects'
,p_alias=>'INVALID-OBJECTS'
,p_step_title=>'Invalid Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(275619009526176844)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11724207541696289)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34145430213104114)
,p_plug_name=>'Invalid Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1040_OWNER as object_owner,',
'       object_name,',
'       object_type,',
'       status,',
'       case',
'       when object_type in (''TYPE BODY'', ''PACKAGE BODY'')',
'       then ( select to_char(o2.object_id)',
'                from sys.user_objects o2',
'               where o2.object_name = o.object_name',
'                 and o2.object_type = replace(o.object_type, '' BODY'', null) )',
'       when object_type = ''LOB''',
'       then ( select to_char(o2.object_id)',
'                from sys.user_objects o2,',
'                     sys.user_lobs l',
'               where o2.object_name = l.table_name',
'                 and l.segment_name = o.object_name )',
'       when object_type = ''DATABASE LINK''',
'       -- keep this logic in sync with wwv_flow_f4500_ob_wiz_dev.get_object_id ( private ) function',
'       then to_char(ora_hash( object_name, 1000000000, power( 2, 30 ) ))',
'       else to_char(object_id)',
'       end object_id,',
'       created date_created,',
'       nvl(last_ddl_time, created) lastddltime',
'  from sys.user_objects o',
' where status = ''INVALID''',
'   and object_name not like ''BIN$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1040_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(34145524067104114)
,p_name=>'Invalid Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34145824988104161)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Object Name'
,p_column_link=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:RP,2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:#OBJECT_OWNER#,#OBJECT_ID#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34146001711104161)
,p_db_column_name=>'STATUS'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34145931016104161)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34145717239104156)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34146117372104161)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34146222448104161)
,p_db_column_name=>'DATE_CREATED'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34146323886104162)
,p_db_column_name=>'LASTDDLTIME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Last DDL'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(34146803034108603)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1319319648536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OBJECT_NAME:STATUS:OBJECT_TYPE:OBJECT_OWNER:OBJECT_ID:DATE_CREATED:LASTDDLTIME'
,p_sort_column_1=>'OBJECT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722739206044798620)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34145430213104114)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11062627377486815)
,p_branch_action=>'f?p=&FLOW_ID.:1040:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11061518898481403)
,p_name=>'P1040_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11724207541696289)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112248625019926062)
,p_computation_sequence=>10
,p_computation_item=>'P1040_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1040_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69260509967783707)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1040_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69260509967783707
);
end;
/
prompt --application/pages/page_01042
begin
wwv_flow_imp_page.create_page(
 p_id=>1042
,p_name=>'Object Reports'
,p_alias=>'OBJECT-REPORTS'
,p_step_title=>'Object Reports'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(275619009526176844)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_obj_rpt.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32415731233960470)
,p_plug_name=>'Table Reports'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_imp.id(703386252988943977)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(11239830706238313)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(32427114807996970)
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32440018476060806)
,p_plug_name=>'PL/SQL Reports'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_imp.id(703386252988943977)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_imp.id(11319530060616601)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(32427114807996970)
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32443902808075234)
,p_plug_name=>'Exception Reports'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_imp.id(703386252988943977)
,p_plug_display_sequence=>110
,p_list_id=>wwv_flow_imp.id(11254208206307506)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(32427114807996970)
,p_plug_column_width=>'apex-col--bottomBorder'
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32452801432150529)
,p_plug_name=>'Security Reports'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_imp.id(703386252988943977)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(11271128516379623)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(32427114807996970)
,p_plug_column_width=>'apex-col--leftBorder'
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32460223642185327)
,p_plug_name=>'All Object Reports'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h240'
,p_plug_template=>wwv_flow_imp.id(703386252988943977)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(276235426866859669)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(32427114807996970)
,p_plug_column_width=>'apex-col--leftBorder'
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>31536000
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(171473126132707058)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1042'
);
end;
/
prompt --application/pages/page_01046
begin
wwv_flow_imp_page.create_page(
 p_id=>1046
,p_name=>'PL/SQL Program Unit Arguments'
,p_alias=>'PL-SQL-PROGRAM-UNIT-ARGUMENTS'
,p_step_title=>'PL/SQL Program Unit Arguments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276002212445738952)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_plsql.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11704507223573166)
,p_plug_name=>'Owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441250116947415301)
,p_plug_name=>'All Arguments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1046_OWNER as owner,',
'       package_name,',
'       object_name,',
'       object_id,',
'       argument_name,',
'       position,',
'       in_out',
'  from sys.user_arguments',
' where argument_name is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1046_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441250212488415301)
,p_name=>'All Arguments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441250410030415304)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441250522806415305)
,p_db_column_name=>'PACKAGE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Package'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441250631454415306)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Program Unit'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441250931756415325)
,p_db_column_name=>'POSITION'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Position'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441250825763415325)
,p_db_column_name=>'ARGUMENT_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Argument'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441251016200415326)
,p_db_column_name=>'IN_OUT'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'In Out'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441250710319415307)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>7
,p_column_identifier=>'D'
,p_column_label=>'Object'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441251228871415923)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1319402155536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OWNER:PACKAGE_NAME:OBJECT_NAME:POSITION:ARGUMENT_NAME:IN_OUT:OBJECT_ID'
,p_sort_column_1=>'PACKAGE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'OBJECT_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'POSITION'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722739608986798624)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(441250116947415301)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11193001302595653)
,p_branch_action=>'f?p=&FLOW_ID.:1046:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11191616949590962)
,p_name=>'P1046_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11704507223573166)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(69226109218679418)
,p_computation_sequence=>10
,p_computation_item=>'P1046_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1046_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69222531120666822)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1046_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69222531120666822
);
end;
/
prompt --application/pages/page_01047
begin
wwv_flow_imp_page.create_page(
 p_id=>1047
,p_name=>'Table Columns'
,p_alias=>'TABLE-COLUMNS'
,p_step_title=>'Table Columns'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(275619009526176844)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5096130889958700)
,p_plug_name=>'Table Columns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P1047a */',
'   :P1047_OWNER owner,',
'   table_name,',
'   column_name,',
'   initcap(data_type) ||',
'      decode(data_type,',
'          ''CHAR'',      ''(''|| char_length ||'')'',',
'          ''VARCHAR'',   ''(''|| char_length ||'')'',',
'          ''VARCHAR2'',  ''(''|| char_length ||'')'',',
'          ''NCHAR'',     ''(''|| char_length ||'')'',',
'          ''NVARCHAR'',  ''(''|| char_length ||'')'',',
'          ''NVARCHAR2'', ''(''|| char_length ||'')'',',
'          ''NUMBER'',    ''(''||',
'                       nvl(data_precision,data_length)||',
'                       decode(data_scale,null,null,',
'                                        '',''||data_scale)||'')'',',
'          null) data_type,',
'decode(nullable,''Y'',''<span class="a-Icon icon-check"></span>'',null) nullable,',
'         column_id',
'from sys.user_tab_columns',
'where table_name not like ''BIN$%''',
'  and column_id is not null',
'order by table_name, column_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1047_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5096215461958700)
,p_name=>'Table Columns'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5096418083958758)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5096525354958758)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Table'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5096909376958759)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5096613345958758)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Column'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5096719279958758)
,p_db_column_name=>'DATA_TYPE'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5096800255958758)
,p_db_column_name=>'NULLABLE'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Nullable'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5097104772958929)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1319506784536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OWNER:TABLE_NAME:COLUMN_ID:COLUMN_NAME:DATA_TYPE:NULLABLE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11560827900610888)
,p_plug_name=>'Owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722740442598798632)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5096130889958700)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11170511130439125)
,p_branch_action=>'f?p=&FLOW_ID.:1047:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11163701113293085)
,p_name=>'P1047_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11560827900610888)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Owner'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(8024706122365449)
,p_computation_sequence=>10
,p_computation_item=>'P1047_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1047_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69201622930598210)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1047_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69201622930598210
);
end;
/
prompt --application/pages/page_01048
begin
wwv_flow_imp_page.create_page(
 p_id=>1048
,p_name=>'Table Storage Sizes'
,p_alias=>'TABLE-STORAGE-SIZES'
,p_step_title=>'Table Storage Sizes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276037127560809519)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11527527033122057)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441113717051166865)
,p_plug_name=>'Table Sizes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>11
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1048_OWNER owner,',
'       segment_name, ',
'       tablespace_name, ',
'       round(bytes/1024/1024,2) megabytes',
'from sys.user_segments',
'where segment_type = ''TABLE'' and',
'(nvl(:P1048_INCLUDE_RECYCLE_BIN,''N'')=''Y'' or segment_name not like ''BIN$%'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1048_OWNER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441113831627166865)
,p_name=>'Table Sizes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441114119746166872)
,p_db_column_name=>'SEGMENT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441114200482166873)
,p_db_column_name=>'TABLESPACE_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Tablespace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(973959280123400202)
,p_db_column_name=>'MEGABYTES'
,p_display_order=>12
,p_column_identifier=>'F'
,p_column_label=>'Megabytes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441114026679166871)
,p_db_column_name=>'OWNER'
,p_display_order=>22
,p_column_identifier=>'A'
,p_column_label=>'OWNER'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441115028986173752)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1319625627536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SEGMENT_NAME:TABLESPACE_NAME:MEGABYTES:'
,p_sort_column_1=>'SEGMENT_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(468202327871617260)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(441113717051166865)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1048:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11225609681895677)
,p_branch_action=>'f?p=&FLOW_ID.:1048:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11224616639893667)
,p_name=>'P1048_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11527527033122057)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Owner'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Identify the database schema owner.  Each workspace may have privileges on one or more schemas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85310118139997572)
,p_name=>'P1048_INCLUDE_RECYCLE_BIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(11527527033122057)
,p_item_default=>'N'
,p_prompt=>'Include Recycle Bin'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.Y.N'
,p_lov=>'.'||wwv_flow_imp.id(23482928300634173)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select <strong>Yes</strong> to include objects in the recycle bin and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112175516671620820)
,p_computation_sequence=>10
,p_computation_item=>'P1048_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1048_OWNER'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69214501075639261)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1048_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69214501075639261
);
end;
/
prompt --application/pages/page_01052
begin
wwv_flow_imp_page.create_page(
 p_id=>1052
,p_name=>'Table Statistics'
,p_alias=>'TABLE-STATISTICS'
,p_step_title=>'Table Statistics'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276037127560809519)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_tbl.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11575703689448002)
,p_plug_name=>'object owner'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441100513841137953)
,p_plug_name=>'Table Statistics'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P1052a */',
'  :p1052_schema owner,',
'  table_name,',
'  decode(IOT_TYPE,''YES'',''IOT'',''HEAP'')||',
'    decode(temporary,''N'',null,''-Temporary'')||',
'    decode(trim(cache),''N'',null,''-Cached'')||',
'    decode(partitioned,''NO'',null,''-Partitioned'')||',
'    decode(compression,''DISABLED'',null,''-Compressed'')',
'    table_type,',
'  last_analyzed,',
'  NUM_ROWS,',
'  AVG_ROW_LEN',
'from sys.user_tables',
'where table_name not like ''BIN$%'' and',
'      table_name not like ''DR$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1052_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441100608395137953)
,p_name=>'Table Statistics'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441100801813137973)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441100913652137974)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441101103682137976)
,p_db_column_name=>'LAST_ANALYZED'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Last Analyzed'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441101204942137976)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441101319944137977)
,p_db_column_name=>'AVG_ROW_LEN'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Average Row Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441101001547137975)
,p_db_column_name=>'TABLE_TYPE'
,p_display_order=>6
,p_column_identifier=>'C'
,p_column_label=>'Table Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441112607946148736)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1319716240536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OWNER:TABLE_NAME:LAST_ANALYZED:NUM_ROWS:AVG_ROW_LEN:TABLE_TYPE'
,p_sort_column_1=>'TABLE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722740182933798629)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(441100513841137953)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11577832217465775)
,p_name=>'P1052_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11575703689448002)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112170304981598569)
,p_computation_sequence=>10
,p_computation_item=>'P1052_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1052_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69211808563631993)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1052_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69211808563631993
);
end;
/
prompt --application/pages/page_01054
begin
wwv_flow_imp_page.create_page(
 p_id=>1054
,p_name=>'PL/SQL Unit Line Counts'
,p_alias=>'PL-SQL-UNIT-LINE-COUNTS'
,p_step_title=>'PL/SQL Unit Line Counts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276002212445738952)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_plsql.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5100303284971553)
,p_plug_name=>'PL/SQL Program Unit Line Counts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1054_SCHEMA owner,',
'  type,',
'  name,',
'  count(*) lines',
'from sys.user_source',
'group by 1, type, name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1054_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5100428245971553)
,p_name=>'PL/SQL Program Unit Line Counts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5100629890971562)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5100701521971562)
,p_db_column_name=>'TYPE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5100822171971562)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'PL/SQL Object Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5100916967971562)
,p_db_column_name=>'LINES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Lines'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5101117716972170)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1319809225536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OWNER:TYPE:NAME:LINES'
,p_sort_column_1=>'LINES'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11706409610621133)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722739545318798623)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5100303284971553)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11715609787659055)
,p_branch_action=>'f?p=&APP_ID.:1054:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11708029003626749)
,p_name=>'P1054_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11706409610621133)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112238622333906358)
,p_computation_sequence=>10
,p_computation_item=>'P1054_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1054_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(276581106200129678)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>276581106200129678
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69228525494684171)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1054_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69228525494684171
);
end;
/
prompt --application/pages/page_01055
begin
wwv_flow_imp_page.create_page(
 p_id=>1055
,p_name=>'Object Creation Calendar'
,p_alias=>'OBJECT-CREATION-CALENDAR'
,p_step_title=>'Object Creation Calendar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(275619009526176844)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
,p_page_component_map=>'08'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8288117937948579)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(722738912283798617)
,p_plug_name=>'Object Creation Calendar'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id, owner, object_type||'': ''||object_name object_name, created, last_DDL_time, object_type',
'from sys.dba_objects',
'where owner = :p1055_schema and object_name not like ''BIN$%''',
'order by created'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1055_SCHEMA'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'additional_calendar_views', 'month:list:navigation',
  'display_column', 'OBJECT_NAME',
  'maximum_events_day', '10',
  'multiple_line_event', 'Y',
  'show_time', 'N',
  'show_tooltip', 'N',
  'show_weekend', 'Y',
  'start_date_column', 'LAST_DDL_TIME')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11337325344701687)
,p_branch_action=>'f?p=&FLOW_ID.:1055:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8288822786949976)
,p_name=>'P1055_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8288117937948579)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112254729090946101)
,p_computation_sequence=>10
,p_computation_item=>'P1055_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1055_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69262125550788241)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1055_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_process_when=>'P1055_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>69262125550788241
);
end;
/
prompt --application/pages/page_01059
begin
wwv_flow_imp_page.create_page(
 p_id=>1059
,p_name=>'Object Counts by Type'
,p_alias=>'OBJECT-COUNTS-BY-TYPE'
,p_step_title=>'Object Counts by Type'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(275619009526176844)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_objs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8517111890760577)
,p_plug_name=>'Schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441228300730210134)
,p_plug_name=>'Database Objects by Type'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :P1059_SCHEMA owner, object_type, count(*) object_count',
'from sys.user_objects',
'where upper(object_name) not like ''BIN$%''',
'group by 1, object_type'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1059_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441228426684210134)
,p_name=>'Database Objects by Type'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441228624524210143)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441228701422210144)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441228806701210144)
,p_db_column_name=>'OBJECT_COUNT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Object Count'
,p_column_link=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:500,RIR:IR_OBJECT_TYPE,F4500_P500_SCHEMA:#OBJECT_TYPE#,&P1059_SCHEMA.'
,p_column_linktext=>'#OBJECT_COUNT#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441229110882212034)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1319900288536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OWNER:OBJECT_TYPE:OBJECT_COUNT'
,p_sort_column_1=>'OWNER'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'OBJECT_TYPE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
,p_sum_columns_on_break=>'OBJECT_COUNT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722738837231798616)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(441228300730210134)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(276213904693777514)
,p_branch_action=>'f?p=&APP_ID.:1059:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8519204749767917)
,p_name=>'P1059_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8517111890760577)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select a database schema (username) you want to view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112258025412954595)
,p_computation_sequence=>10
,p_computation_item=>'P1059_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1059_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69263710444793307)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1059_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_internal_uid=>69263710444793307
);
end;
/
prompt --application/pages/page_01070
begin
wwv_flow_imp_page.create_page(
 p_id=>1070
,p_name=>'Recycle Bin'
,p_alias=>'RECYCLE-BIN'
,p_step_title=>'Recycle Bin'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_restor.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11402600478509665)
,p_plug_name=>'Recycle Bin'
,p_icon_css_classes=>'icon-utilites-recycle-bin'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_imp.id(703386252988943977)
,p_plug_display_sequence=>11
,p_list_id=>wwv_flow_imp.id(11401232423499912)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
,p_plug_required_role=>wwv_flow_imp.id(240648913515910366)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(240662923622936918)
,p_plug_name=>'Recycle Bin Not Supported'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>21
,p_plug_source=>'The Recycle Bin is not supported with your current database version.  It is only available for Oracle release 10.1 or higher.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>'!'||wwv_flow_imp.id(240648913515910366)
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1020678633228036507)
,p_name=>'RENDERING: Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(11402600478509665)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1020678912790036509)
,p_event_id=>wwv_flow_imp.id(1020678633228036507)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:1070:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
end;
/
prompt --application/pages/page_01100
begin
wwv_flow_imp_page.create_page(
 p_id=>1100
,p_name=>'Quick SQL'
,p_alias=>'QUICK-SQL'
,p_step_title=>'Quick SQL'
,p_autocomplete_on_off=>'ON'
,p_javascript_file_urls=>'[require requirejs]#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#widget.codeEditor#MIN#.js'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(async () => {',
'    // need to combine page init code with the await import, otherwise the code below it fails',
'    await import( "#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#quickSQL#MIN#.js?v=#APEX_VERSION#" );',
'',
'    const runbtn$ = apex.item( "run_btn" ); ',
'    window.QuickSQL = new apex.quickSql( {',
'        onInputEditorInitialized: function(editor){',
'',
'            if ( $v( "P1100_RAW_SQL" ).length ) {',
'                QuickSQL.generate();',
'            }',
'',
'            editor.onDidChangeModelContent(function(){',
'                if( editor.getValue().trim() === "" ){',
'                    runbtn$.disable();',
'                } else {',
'                    runbtn$.enable();',
'                }',
'            } )',
'',
'            $( "html" ).removeClass( "no-js" );',
'        },',
'        autoGen: true,',
'        autoGenDebounce: 600',
'    } );',
'',
'    // fix diagram on window resize',
'    $( window ).on( "apexwindowresized", function() {',
'        if ( $( "#outputTabsContainer .a-Tabs" ).aTabs( "getActive" ).el$[0].id == "diagram" ){',
'            QuickSQL.diagram.updateDiagram();',
'        }',
'    });',
'',
'    // fix diagram on tab change',
'    apex.widget.util.onVisibilityChange( $( "#diagram" ), function ( pShow ) {',
'        if ( pShow ) {',
'            QuickSQL.diagram.updateDiagram();',
'        }',
'    } );',
'',
'    // set defaults',
'    QuickSQL.setParserOptions( apex.items.P1100_JSON_OPTIONS.value )',
'} )();'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.qs-main {',
'  max-width: 100vw;',
'  transition: opacity .2s ease, visibility .2s ease;',
'}',
'',
'.no-js .qs-main {',
'  opacity: 0;',
'  visibility: hidden;',
'}',
'',
'.qs-main,',
'.qs-main > .apex-grid-container,',
'.qs-main .apex-row,',
'.qs-main-col,',
'.qs-col-body {',
'  flex-grow: 1;',
'  display: flex;',
'}',
'',
'.qs-main .apex-col {',
'  display: flex;',
'}',
'',
'.qs-main,',
'.qs-main-col,',
'.qs-main .apex-col,',
'.qs-col-body {',
'  flex-direction: column;',
'}',
'',
'.sql-container {',
'  display: flex;',
'  flex-grow: 1;',
'  flex-direction: column;',
'}',
'',
'.sql-container {',
'  justify-content: center;',
'}',
'',
'h2.no-sql-yet {',
'  margin: 24px;',
'  text-align: center;',
'  color: rgba(0, 0, 0, .55);',
'  font-size: 20px;',
'  line-height: 1.5;',
'  font-weight: 400;',
'}',
'',
'.a-ButtonRegion--showTitle .a-ButtonRegion-title {',
'  font-size: 14px;',
'  font-weight: 500;',
'}',
'',
'.a-Button--iconTextButton .fa {',
'  margin-left: 4px;',
'}',
'',
'.a-Button--iconLeft .fa {',
'  margin-left: 0;',
'}',
'',
'.a-Button--iconLeft {',
'  padding-left: 28px;',
'}',
'',
'span.quicksql-table {',
'  color: #1E84BF;',
'  font-weight: bold;',
'}',
'',
'/* RDS Tab Tweaks */',
'.apex-rds-container {',
'  box-shadow: none;',
'  margin-block-end: -10px;',
'}',
'',
'.apex-rds-container .a-RDS-link {',
'  padding-bottom: 10px;',
'}',
'',
'.a-RDS-list .a-RDS-link:focus {',
'  outline-offset: -2px;',
'}',
'',
'',
'/* ERD */',
'#diagram {',
'  --ab-diagram-background: transparent;',
'  --qs-diagram-font-family: var(--a-base-font-family, sans-serif);',
'',
'  position: relative;',
'  overflow: auto;',
'  outline: none;',
'}',
'',
'#diagram:focus-visible {',
'    outline-width: 1px;',
'    outline-style: solid;',
'    outline-offset: -2px;',
'    outline-color: var(--a-palette-primary);',
'}',
'',
'.joint-paper {',
'  position: relative;',
'}',
'',
'.joint-paper > svg,',
'.joint-paper-background,',
'.joint-paper-grid,',
'.joint-paper-scroller {',
'  inset: 0;',
'  position: absolute;',
'}',
'',
'.joint-element {',
'  filter: drop-shadow(var(--ab-diagram-element-shadow));',
'}',
'',
'.joint-paper-grid {',
'  display: none;',
'}',
'',
'.joint-viewport {',
'  -webkit-user-select: none;',
'  -moz-user-select: none;',
'  user-select: none;',
'}',
'',
'.joint-element * {',
'  -webkit-user-drag: none;',
'}',
'',
'.marker-source,',
'.marker-target,',
'.joint-element .scalable * {',
'  vector-effect: non-scaling-stroke;',
'}',
'',
'.joint-link .connection-wrap,',
'.joint-link .connection {',
'  fill: none;',
'}',
'',
'.selection-wrapper,',
'.link-tools,',
'.marker-vertices,',
'.marker-arrowheads,',
'.marker-vertex-group {',
'  display: none',
'}'))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(4806801565557841)
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8605264067371202)
,p_plug_name=>'QuickSQL Actions Menu'
,p_region_name=>'qsql_actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>50
,p_list_id=>wwv_flow_imp.id(8612181654398721)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8605425632371204)
,p_plug_name=>'SQL Script Actions Menu'
,p_region_name=>'sql_actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_imp.id(8839831299543497)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213236648802764201)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213236759445764202)
,p_plug_name=>'Quick SQL Container'
,p_region_name=>'qs_container'
,p_region_css_classes=>'qs-main a-Region--touchTop'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213236842105764203)
,p_plug_name=>'Shorthand Container'
,p_parent_plug_id=>wwv_flow_imp.id(4213236759445764202)
,p_region_css_classes=>'qs-main-col'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_grid_column_span=>5
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213237147658764206)
,p_plug_name=>'Quick SQL'
,p_parent_plug_id=>wwv_flow_imp.id(4213236842105764203)
,p_region_css_classes=>'apex-col--bottomBorder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213237222183764207)
,p_plug_name=>'Input'
,p_parent_plug_id=>wwv_flow_imp.id(4213236842105764203)
,p_region_css_classes=>'qs-col-body'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div class="sql-container" id="quicksql_input"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213236929029764204)
,p_plug_name=>'Output Container'
,p_parent_plug_id=>wwv_flow_imp.id(4213236759445764202)
,p_region_css_classes=>'qs-main-col'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_column_width=>'apex-col--leftBorder'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2000465812438702)
,p_plug_name=>'Tabs Container'
,p_region_name=>'tabsContainer'
,p_parent_plug_id=>wwv_flow_imp.id(4213236929029764204)
,p_region_css_classes=>'qs-col-body'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2000545974438703)
,p_plug_name=>'&"APP_TEXT$QUICKSQL.DIAGRAM_TITLE".'
,p_region_name=>'diagram'
,p_parent_plug_id=>wwv_flow_imp.id(2000465812438702)
,p_region_css_classes=>'qs-col-body canvas'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'tabindex="0"'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213237403490764209)
,p_plug_name=>'&"APP_TEXT$QUICKSQL.SQL_TITLE".'
,p_region_name=>'output-sql-region'
,p_parent_plug_id=>wwv_flow_imp.id(2000465812438702)
,p_region_css_classes=>'qs-col-body'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="sql-container" id="quicksql_output">',
'<h2 class="no-sql-yet">Type some Quick SQL shorthand<br>to produce generated SQL here</h2>',
'</div>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213237340125764208)
,p_plug_name=>'SQL'
,p_parent_plug_id=>wwv_flow_imp.id(4213236929029764204)
,p_region_css_classes=>'apex-col--bottomBorder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2000395581438701)
,p_plug_name=>'Tabs'
,p_region_name=>'outputTabsContainer'
,p_parent_plug_id=>wwv_flow_imp.id(4213237340125764208)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>10
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'USER')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4213512950070243944)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(4213237340125764208)
,p_button_name=>'RUN'
,p_button_static_id=>'run_btn'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Review and Run'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-run-script'
,p_button_cattributes=>'disabled'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8605381296371203)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(4213237340125764208)
,p_button_name=>'SQL_ACTIONS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'SQL Actions'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'icon-actions'
,p_button_cattributes=>'data-menu="sql_actions_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6210808431373647)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(4213237147658764206)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1102:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4213237954091764214)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(4213237147658764206)
,p_button_name=>'SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Settings'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1101:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-util'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8605197054371201)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(4213237147658764206)
,p_button_name=>'QSQL_ACTIONS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Quick SQL Actions'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'icon-actions'
,p_button_cattributes=>'data-menu="qsql_actions_menu"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6209931810373638)
,p_branch_name=>'Branch to Review and Run'
,p_branch_action=>'f?p=&APP_ID.:60:&SESSION.:PREPOPULATE:&DEBUG.:RP,60:P60_SCRIPT_NAME:&P1100_SCRIPT_NAME.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4213512950070243944)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3405255873193108)
,p_name=>'P1100_JSON_OPTIONS'
,p_data_type=>'CLOB'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4213236648802764201)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6206726496373606)
,p_name=>'P1100_OUTPUT_SQL'
,p_data_type=>'CLOB'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4213236648802764201)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6211031969373649)
,p_name=>'P1100_ORDS_PATH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4213236759445764202)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6211192921373650)
,p_name=>'P1100_ORDS_VERSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4213236759445764202)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4032943314209342949)
,p_name=>'P1100_SCRIPT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4213236648802764201)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213238093096764215)
,p_name=>'P1100_RAW_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4213237222183764207)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213240908381764244)
,p_name=>'P1100_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4213236648802764201)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'US_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213511259383243927)
,p_name=>'P1100_MODEL_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4213236648802764201)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2001029260438708)
,p_computation_sequence=>10
,p_computation_item=>'P1100_ORDS_PATH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'htmldb_util.host_url(''APEX_PATH'')'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2001165568438709)
,p_computation_sequence=>10
,p_computation_item=>'P1100_ORDS_VERSION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_cgi.get_apex_listener_version'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6208891564373627)
,p_name=>'quicksql Menu Items hide/show/enable/disable'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6208994857373628)
,p_event_id=>wwv_flow_imp.id(6208891564373627)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "#qsql_actions_menu" ).on( "menubeforeopen", function ( event, ui ) { ',
'    var menuItems = ui.menu.items; ',
'    menuItems = menuItems.map( function ( item ) { ',
'        if ( item.id == "properties" || item.id == "saveModelAs" ){',
'            if ( apex.item( "P1100_MODEL_ID" ).getValue() == "" ){',
'                item.disabled = true;  ',
'            } else {',
'                item.disabled = false;',
'            }',
'        }',
'        if ( item.id == "updateModel" ){',
'            if ( apex.item( "P1100_MODEL_ID" ).getValue() == "" ){',
'                item.hide = true;  ',
'            } else {',
'                item.hide = false;',
'            }',
'        }',
'        if (item.id == "saveModel"){',
'            if ( apex.item( "P1100_MODEL_ID" ).getValue() == "" ){',
'                item.hide = false;  ',
'            } else {',
'                item.hide = true;',
'            }',
'',
'            if (apex.item( "P1100_RAW_SQL" ).getValue() == ""){',
'                item.disabled = true;',
'            } else {',
'                item.disabled = false;',
'            }',
'        }',
'        return item; ',
'    }); ',
'});'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6209011863373629)
,p_name=>'sql Menu Items hide/show/enable/disable'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6209109898373630)
,p_event_id=>wwv_flow_imp.id(6209011863373629)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "#sql_actions_menu" ).on( "menubeforeopen", function ( event, ui ) { ',
'    var menuItems = ui.menu.items; ',
'    menuItems = menuItems.map( function ( item ) { ',
'        if ( item.id == "download" || item.id == "saveScript" ){',
'            if ( QuickSQL.hasContent() ){',
'                item.disabled = false;  ',
'            } else {',
'                item.disabled = true;',
'            }',
'        }',
'        return item; ',
'    }); ',
'});'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4213510882703243923)
,p_name=>'Settings Updated'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4213237954091764214)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3405100624193107)
,p_event_id=>wwv_flow_imp.id(4213510882703243923)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Generate JSON Options'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_audit_cols   varchar2(1) := ''N'';',
'    l_row_version  varchar2(1) := ''N'';',
'    l_row_key      varchar2(1) := ''N'';',
'begin',
'    if instr (:P1101_ADTL_COLS,''AUDIT_COLS'') > 0 then l_audit_cols := ''Y''; end if;',
'    if instr (:P1101_ADTL_COLS,''ROW_VERSION'') > 0 then l_row_version := ''Y''; end if;',
'    if instr (:P1101_ADTL_COLS,''ROW_KEY'') > 0 then l_row_key := ''Y''; end if;',
'',
'    :P1100_JSON_OPTIONS := wwv_qs_dev.get_options_json (',
'        p_apex_yn                 => :P1101_APEX,',
'        p_api_yn                  => :P1101_API,',
'        p_audit_yn                => l_audit_cols,',
'        p_compressed_yn           => :P1101_COMPRESSED,',
'        p_date_datatype           => :P1101_DATE_DATATYPE,',
'        p_db_version              => :P1101_DB_VERSION,',
'        p_include_drops_yn        => :P1101_INCLUDE_DROPS,',
'        p_inserts_yn              => :P1101_GENERATE_INSERTS,',
'        p_editionable_yn          => :P1101_EDITIONABLE,',
'        p_auto_gen_pk_yn          => :P1101_AUTO_GEN_PK,',
'        p_table_prefix            => :P1101_TABLE_PREFIX,',
'        p_trigger_method          => :P1101_TRIGGER_METHOD,',
'        p_prefix_pk_with_tname_yn => :P1101_PREFIX_PK_WITH_TNAME,',
'        p_row_key_yn              => l_row_key,',
'        p_row_version_yn          => l_row_version,',
'        p_schema                  => :P1101_SCHEMA,',
'        p_semantics               => :P1101_SEMANTICS,',
'        p_created_col             => :P1101_CREATED_COLUMN_NAME,',
'        p_created_by_col          => :P1101_CREATED_BY_COLUMN_NAME,',
'        p_updated_col             => :P1101_UPDATED_COLUMN_NAME,',
'        p_updated_by_col          => :P1101_UPDATED_BY_COLUMN_NAME',
'    );',
'end;'))
,p_attribute_03=>'P1100_JSON_OPTIONS'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
,p_da_action_comment=>'Run on this page 1100 instead of 1101 to centralize this call and initialize our `defaults`'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3405320616193109)
,p_event_id=>wwv_flow_imp.id(4213510882703243923)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Set QuickSQL JSON Options'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'QuickSQL.setParserOptions( apex.items.P1100_JSON_OPTIONS.value )'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213510988860243924)
,p_event_id=>wwv_flow_imp.id(4213510882703243923)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Show Success and Regenerate'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.showPageSuccess( this.data.successMessage.text );',
'QuickSQL.clearOutput().generate( true );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4213511046988243925)
,p_name=>'Load Model'
,p_event_sequence=>60
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.data && this.data.dialogPageId == 1103'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213511179879243926)
,p_event_id=>wwv_flow_imp.id(4213511046988243925)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_MODEL_ID'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P1103_MODEL_ID'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213512378722243938)
,p_event_id=>wwv_flow_imp.id(4213511046988243925)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_RAW_SQL'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_model clob;',
'begin',
'    for l_quick_sql in (',
'        select quick_sql model',
'        into l_model',
'        from wwv_qs_models ',
'        where id = :P1100_MODEL_ID )',
'    loop',
'        l_model := l_quick_sql.model;',
'    end loop;',
'    ',
'    if l_model is null then',
'        for l_quick_sql in (',
'            select model',
'            from wwv_qs_saved_models ',
'            where id = :P1100_MODEL_ID  ',
'            and security_group_id = :flow_security_group_id )',
'        loop',
'            l_model := l_quick_sql.model;',
'        end loop;',
'    end if;',
'    ',
'    return l_model;',
'end;'))
,p_attribute_07=>'P1100_MODEL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2400681812658502)
,p_event_id=>wwv_flow_imp.id(4213511046988243925)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Submit P1100_MODEL_ID item to session state '
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_MODEL_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select id',
'    from wwv_qs_saved_models ',
'   where id = :P1100_MODEL_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_attribute_07=>'P1100_MODEL_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213512436337243939)
,p_event_id=>wwv_flow_imp.id(4213511046988243925)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( QuickSQL.inputEditor$ ).codeEditor( ''setValue'', $v(''P1100_RAW_SQL'' ) );',
'QuickSQL.generate();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(234029578097714211)
,p_name=>'Load Model from Help'
,p_event_sequence=>70
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.data && this.data.dialogPageId == 1102'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234029627917714212)
,p_event_id=>wwv_flow_imp.id(234029578097714211)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_MODEL_ID'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P1102_ID'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234029751802714213)
,p_event_id=>wwv_flow_imp.id(234029578097714211)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_RAW_SQL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>'select QUICK_SQL from wwv_qs_models where id = :P1100_MODEL_ID'
,p_attribute_07=>'P1100_MODEL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2400719915658503)
,p_event_id=>wwv_flow_imp.id(234029578097714211)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Set P1100_MODEL_ID to NULL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_MODEL_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234029866406714214)
,p_event_id=>wwv_flow_imp.id(234029578097714211)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( QuickSQL.inputEditor$ ).codeEditor( ''setValue'', $v( ''P1100_RAW_SQL'' ) );',
'QuickSQL.generate();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4213512583487243940)
,p_name=>'Script Saved'
,p_event_sequence=>80
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.data && this.data.dialogPageId == 1104'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213512788365243942)
,p_event_id=>wwv_flow_imp.id(4213512583487243940)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_SCRIPT_NAME'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P1104_SCRIPT_NAME'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213512603284243941)
,p_event_id=>wwv_flow_imp.id(4213512583487243940)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess(this.data.successMessage.text);'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4229299179126069801)
,p_event_id=>wwv_flow_imp.id(4213512583487243940)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(4213512950070243944)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6210129502373640)
,p_name=>'Enable Run'
,p_event_sequence=>100
,p_condition_element=>'P1100_OUTPUT_SQL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6210239383373641)
,p_event_id=>wwv_flow_imp.id(6210129502373640)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(4213512950070243944)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(160975260602355734)
,p_name=>'Model Saved'
,p_event_sequence=>120
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.data && this.data.dialogPageId == 1105'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2402504262658521)
,p_event_id=>wwv_flow_imp.id(160975260602355734)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_MODEL_ID'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P1105_ID'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2402697076658522)
,p_event_id=>wwv_flow_imp.id(160975260602355734)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Submit P1100_MODEL_ID item to session state '
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P1100_MODEL_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(160975343161355735)
,p_event_id=>wwv_flow_imp.id(160975260602355734)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess(this.data.successMessage.text);'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6210368112373642)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Session State'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'RESET'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>6210368112373642
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6210007315373639)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Review and Run'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX_4500_60'' );',
'    wwv_flow_collection.add_member( p_collection_name => ''APEX_4500_60'',',
'                                p_clob001         => :P1100_OUTPUT_SQL );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4213512950070243944)
,p_internal_uid=>6210007315373639
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2000763421438705)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'load ords libraries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_ords_js_path varchar2(4000) := :P1100_ORDS_PATH || ''_/lib/js/'';',
'begin',
'    -- has both min and not min versions',
'    wwv_flow_javascript.add_library (',
'        p_name                    => ''lodash'',',
'        p_directory               => c_ords_js_path || ''lodash/'',',
'        p_check_to_add_minified   => true );',
'',
'    -- backbone has min and not min, via -min suffix',
'    wwv_flow_javascript.add_library (',
'        p_name                    => ''backbone-min'',',
'        p_directory               => c_ords_js_path || ''backbone/'' );',
'',
'    -- rappid does not have minified version in ORDS',
'    wwv_flow_javascript.add_library (',
'        p_name                    => ''rappid'',',
'        p_directory               => c_ords_js_path || ''rappid/'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2000763421438705
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4213396239246364009)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1101_TABLE_PREFIX           := null;',
':P1101_SCHEMA                 := null;',
':P1101_COMPRESSED             := wwv_qs_dev.c_default_compressed_yn;',
':P1101_GENERATE_INSERTS       := wwv_qs_dev.c_default_inserts_yn;',
':P1101_TRIGGER_METHOD         := wwv_qs_dev.c_default_trigger_method;',
':P1101_DATE_DATATYPE          := wwv_qs_dev.c_default_date_datatype;',
':P1101_SEMANTICS              := wwv_qs_dev.c_default_semantics;',
':P1101_ADTL_COLS              := null;',
':P1101_API                    := wwv_qs_dev.c_default_api_yn;',
':P1101_INCLUDE_DROPS          := wwv_qs_dev.c_default_include_drops_yn;',
':P1101_AUTO_GEN_PK            := wwv_qs_dev.c_default_auto_gen_pk_yn;',
':P1101_EDITIONABLE            := wwv_qs_dev.c_default_editionable_yn;',
':P1101_APEX                   := wwv_qs_dev.c_default_apex_yn;',
':P1101_DB_VERSION             := wwv_qs_dev.get_default_db_version;',
':P1101_PREFIX_PK_WITH_TNAME   := wwv_qs_dev.c_default_prefix_pk_yn;',
':P1101_CREATED_COLUMN_NAME    := wwv_qs_dev.c_default_created_col_name;',
':P1101_CREATED_BY_COLUMN_NAME := wwv_qs_dev.c_default_created_by_col_name;',
':P1101_UPDATED_COLUMN_NAME    := wwv_qs_dev.c_default_updated_col_name;',
':P1101_UPDATED_BY_COLUMN_NAME := wwv_qs_dev.c_default_updated_by_col_name;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4213396239246364009
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6207519697373614)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set_session_state'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>6207519697373614
);
end;
/
prompt --application/pages/page_01101
begin
wwv_flow_imp_page.create_page(
 p_id=>1101
,p_name=>'Settings'
,p_alias=>'SETTINGS'
,p_page_mode=>'MODAL'
,p_step_title=>'Settings'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(4806801565557841)
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(418692771217061012)
,p_plug_name=>'Primary Key'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213238967558764224)
,p_plug_name=>'Table'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213239074761764225)
,p_plug_name=>'Column'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213239169987764226)
,p_plug_name=>'Additional Columns'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213239246459764227)
,p_plug_name=>'Options'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213239316838764228)
,p_plug_name=>'Audit Columns'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213240264228764237)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4213240448767764239)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4213240264228764237)
,p_button_name=>'RESET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4213240387572764238)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4213240264228764237)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4213240521142764240)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4213240264228764237)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4211581002465736742)
,p_name=>'P1101_ADTL_COLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4213239169987764226)
,p_item_default=>'return NVL(:P1101_ADTL_COLS,'''');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Include'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P1101_AUDIT_COL_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(561151526618018480)||'.'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4211581252875736744)
,p_name=>'P1101_API'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4213239246459764227)
,p_item_default=>'return NVL(:P1101_API,wwv_qs_dev.c_default_api_yn);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'PL/SQL API'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'&"APP_TEXT$QUICKSQL.API_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4211581316983736745)
,p_name=>'P1101_INCLUDE_DROPS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4213239246459764227)
,p_item_default=>'return NVL(:P1101_INCLUDE_DROPS,wwv_qs_dev.c_default_include_drops_yn);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Include Drops'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'&"APP_TEXT$QUICKSQL.DROP_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4211581592238736747)
,p_name=>'P1101_AUTO_GEN_PK'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(418692771217061012)
,p_item_default=>'return NVL(:P1101_AUTO_GEN_PK,wwv_qs_dev.c_default_primary_key_yn);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Add Primary Key'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'&"APP_TEXT$QUICKSQL.GENPK_SETTING"!RAW.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4211581680215736748)
,p_name=>'P1101_DB_VERSION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(4213239246459764227)
,p_item_default=>'wwv_qs_dev.get_default_db_version'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Compatibility'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1101_DB_VERSION'
,p_lov=>'.'||wwv_flow_imp.id(561159215572120923)||'.'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&"APP_TEXT$QUICKSQL.DB_SETTING".',
'<ul>',
'<li>23ai</li>',
'<li>21c</li>',
'<li>19c</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4211581865073736750)
,p_name=>'P1101_EDITIONABLE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4213239246459764227)
,p_item_default=>'return NVL(:P1101_EDITIONABLE,wwv_qs_dev.c_default_editionable_yn);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Editionable'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'&"APP_TEXT$QUICKSQL.EDITIONABLE_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213239484201764229)
,p_name=>'P1101_TABLE_PREFIX'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4213238967558764224)
,p_item_default=>'return NVL(:P1101_TABLE_PREFIX, null);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Object Prefix'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'&"APP_TEXT$QUICKSQL.PREFIX_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213239526879764230)
,p_name=>'P1101_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4213238967558764224)
,p_item_default=>'return NVL(:P1101_SCHEMA, null);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'&"APP_TEXT$QUICKSQL.SCHEMA_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213239709227764232)
,p_name=>'P1101_COMPRESSED'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4213238967558764224)
,p_item_default=>'return NVL(:P1101_COMPRESSED,wwv_qs_dev.c_default_compressed_yn);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Compression'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'&"APP_TEXT$QUICKSQL.COMPRESS_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213239809630764233)
,p_name=>'P1101_TRIGGER_METHOD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(418692771217061012)
,p_prompt=>'Population Method'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1101_TRIGGER_METHOD'
,p_lov=>'.'||wwv_flow_imp.id(561153525630044678)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    &"APP_TEXT$QUICKSQL.PK_SETTING".',
'</p>',
'<ul>',
'    <li><strong>SYS_GUID:</strong>  This method will populate the primary key with a globally unique identifier.  It generates a numeric random number that is non sequential and non uniform in length.  This method is useful in that it can be more sec'
||'ure, it can also allow data to be merged from different databases with out fear of primary key conflict.</li>',
'    <li><strong>Identity Column:</strong> Sets the primary key by default to an ever increasing number.</li>',
'    <li><strong>Sequence:</strong>  This method will increment the primary key using number sequence.  This primary key population is implemented via a database trigger.</li>',
'    <li><strong>None:</strong> This method will not populate the primary key with any value.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213239938816764234)
,p_name=>'P1101_DATE_DATATYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4213239074761764225)
,p_item_default=>'return NVL(:P1101_DATE_DATATYPE,wwv_qs_dev.c_default_date_datatype);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Date Data Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1101_DATE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(561155009716075756)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&"APP_TEXT$QUICKSQL.DATE_SETTING".',
'<ul>',
'<li>Date</li>',
'<li>Timestamp</li>',
'<li>Timestamp with time zone</li>',
'<li>Timestamp with local time zone</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213240026535764235)
,p_name=>'P1101_SEMANTICS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4213239074761764225)
,p_item_default=>'return NVL(:P1101_SEMANTICS,wwv_qs_dev.c_default_semantics);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Semantics'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1101_LENGTH_SEMANTICS'
,p_lov=>'.'||wwv_flow_imp.id(561157497023099105)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'&"APP_TEXT$QUICKSQL.SEMANTICS_SETTING"!RAW.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213395487977364001)
,p_name=>'P1101_APEX'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4213239246459764227)
,p_item_default=>'return NVL(:P1101_APEX,wwv_qs_dev.c_default_apex_yn);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'APEX Enabled'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&"APP_TEXT$QUICKSQL.APEX_SETTING_PART1".',
'<pre>''coalesce(sys_context(''''APEX$SESSION'''',''''APP_USER''''),user)''</pre>',
'&"APP_TEXT$QUICKSQL.APEX_SETTING_PART2".',
'<pre>''user''</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213395649583364003)
,p_name=>'P1101_PREFIX_PK_WITH_TNAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(418692771217061012)
,p_item_default=>'return NVL(:P1101_PREFIX_PK_WITH_TNAME,wwv_qs_dev.c_default_prefix_pk_with_tname_yn);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Prefix primary keys with table name'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'&"APP_TEXT$QUICKSQL.PREFIXPKWITHTNAME_SETTING"!RAW.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213395708955364004)
,p_name=>'P1101_CREATED_COLUMN_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4213239316838764228)
,p_prompt=>'Created Column Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'&"APP_TEXT$QUICKSQL.CREATED_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213395805560364005)
,p_name=>'P1101_CREATED_BY_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4213239316838764228)
,p_prompt=>'Created By Column Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'&"APP_TEXT$QUICKSQL.CREATEDBYCOL_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213395919520364006)
,p_name=>'P1101_UPDATED_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4213239316838764228)
,p_prompt=>'Updated Column Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'&"APP_TEXT$QUICKSQL.UPDATEDCOL_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213396097010364007)
,p_name=>'P1101_UPDATED_BY_COLUMN_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4213239316838764228)
,p_prompt=>'Updated By Column Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_help_text=>'&"APP_TEXT$QUICKSQL.UPDATEDBYCOL_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213396158971364008)
,p_name=>'P1101_GENERATE_INSERTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4213238967558764224)
,p_item_default=>'return NVL(:P1101_GENERATE_INSERTS,''Y'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Generate Inserts'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'&"APP_TEXT$QUICKSQL.INSERT_SETTING".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4213240640984764241)
,p_name=>'Cancel Button'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4213240521142764240)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213240776604764242)
,p_event_id=>wwv_flow_imp.id(4213240640984764241)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(418692828927061013)
,p_name=>'Show Trigger Method'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1101_AUTO_GEN_PK'
,p_condition_element=>'P1101_AUTO_GEN_PK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(418692992602061014)
,p_event_id=>wwv_flow_imp.id(418692828927061013)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1101_TRIGGER_METHOD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(418693055526061015)
,p_event_id=>wwv_flow_imp.id(418692828927061013)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1101_TRIGGER_METHOD'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4213466897943559802)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Settings saved'
,p_internal_uid=>4213466897943559802
);
end;
/
prompt --application/pages/page_01102
begin
wwv_flow_imp_page.create_page(
 p_id=>1102
,p_name=>'QuickSQL Help'
,p_alias=>'QUICKSQL-HELP'
,p_page_mode=>'MODAL'
,p_step_title=>'Help'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Dialog--wizard .a-Dialog-body { padding: 12px; }',
'.a-Region-header { padding: 0; }',
'.a-Region .a-Region-title { font-weight: 500; font-size: 16px; }',
'.about-region h3 { font-size: 14px; line-height: 20px; margin-bottom: 8px; color: #707070; font-weight: bold; }',
'.about-region p, .about-region ul { font-size: 14px; line-height: 20px; color: #404040; }',
'.about-region ul { margin: 0 12px 0 32px; }',
'.about-region p { margin-bottom: 16px; }'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(4806801565557841)
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(176251420272916914)
,p_plug_name=>'Data Types'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return wwv_qs_dev.get_column_datatypes;'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213508697531243901)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213508778625243902)
,p_plug_name=>'About'
,p_region_css_classes=>'about-region'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return wwv_qs_dev.get_about;'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213508882269243903)
,p_plug_name=>'Table Directives'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return wwv_qs_dev.get_table_directives;'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213508913789243904)
,p_plug_name=>'Column Directives'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return wwv_qs_dev.get_column_directives;'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213509032311243905)
,p_plug_name=>'Views'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return wwv_qs_dev.get_view_syntax;'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213509121351243906)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_function_body_language=>'PLSQL'
,p_plug_source=>'return wwv_qs_dev.get_pound_options;'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4502341925178775194)
,p_name=>'Samples'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       wwv_flow_lang.message(name) name,',
'       wwv_flow_lang.message(description) description,',
'       created,',
'       lower(created_by) created_by,',
'       updated,',
'       lower(updated_by) updated_by,',
'       null run_model',
'from WWV_QS_MODELS',
'where published_yn = ''Y''',
'order by name'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Sample Models'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(288832971898531288)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(288833320886531290)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>#NAME#</strong><br>',
'#DESCRIPTION#'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(288833712302531290)
,p_query_column_id=>3
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(288834182073531291)
,p_query_column_id=>4
,p_column_alias=>'CREATED'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(288834522632531291)
,p_query_column_id=>5
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(288834905665531291)
,p_query_column_id=>6
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(288835389467531292)
,p_query_column_id=>7
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(288835747558531292)
,p_query_column_id=>8
,p_column_alias=>'RUN_MODEL'
,p_column_display_sequence=>8
,p_column_heading=>'Run Model'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'Load Model'
,p_column_link_attr=>'class="a-Button a-Button--small js-loadModel" data-id="#ID#"'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(288836128723531292)
,p_name=>'P1102_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4502341925178775194)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(288836741204534631)
,p_name=>'Load Model'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.js-loadModel'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(288837167967534632)
,p_event_id=>wwv_flow_imp.id(288836741204534631)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1102_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(288837628495534632)
,p_event_id=>wwv_flow_imp.id(288836741204534631)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'LOAD_MODEL'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(288838543080543084)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P1102_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>288838543080543084
);
end;
/
prompt --application/pages/page_01103
begin
wwv_flow_imp_page.create_page(
 p_id=>1103
,p_name=>'Load'
,p_alias=>'LOAD'
,p_page_mode=>'MODAL'
,p_step_title=>'Load'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(4806801565557841)
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109720083786401743)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(164965429122482309)
,p_plug_name=>'Search'
,p_parent_plug_id=>wwv_flow_imp.id(109720083786401743)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(164965644813482311)
,p_plug_name=>'Saved'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(109720158381401744)
,p_name=>'My Models'
,p_parent_plug_id=>wwv_flow_imp.id(164965644813482311)
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       coalesce( description, sys.dbms_lob.substr(model,300,1)) description,',
'       wwv_flow_page_api.get_url(',
'           p_application => :APP_ID,',
'           p_page        => 1107,',
'           p_session     => :APP_SESSION,',
'           p_clear_cache => 1107,',
'           p_items       => ''P1107_ID'',',
'           p_values      => id ) target_url,',
'       htmldb_util.get_since(created) created,',
'       lower(created_by) created_by,',
'       htmldb_util.get_since(updated) updated,',
'       lower(updated_by) updated_by,',
'       null run_model',
'from wwv_qs_saved_models',
'where created_by = :APP_USER',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and ( :P1103_SEARCH is null or',
'      instr( upper(name), upper(:P1103_SEARCH) ) > 0 or',
'      instr( upper(created_by), upper(:P1103_SEARCH) ) > 0 )',
'order by name'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No saved models'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109720363423401746)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109720421448401747)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong><a href="#TARGET_URL#">#NAME#</a></strong> ( #CREATED_BY#, #CREATED# )<br />',
'#DESCRIPTION#'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109720587335401748)
,p_query_column_id=>3
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185275001696967002)
,p_query_column_id=>4
,p_column_alias=>'TARGET_URL'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109720636207401749)
,p_query_column_id=>5
,p_column_alias=>'CREATED'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109720735913401750)
,p_query_column_id=>6
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160971966849355701)
,p_query_column_id=>7
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160972065543355702)
,p_query_column_id=>8
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(160972158666355703)
,p_query_column_id=>9
,p_column_alias=>'RUN_MODEL'
,p_column_display_sequence=>9
,p_column_heading=>'Load Model'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'Load Model'
,p_column_link_attr=>'class="a-Button a-Button--small js-loadModel" data-id="#ID#"'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(160976864824355750)
,p_name=>'Workspace Models'
,p_parent_plug_id=>wwv_flow_imp.id(164965644813482311)
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       coalesce( description, sys.dbms_lob.substr(model,300,1)) description,',
'       wwv_flow_page_api.get_url(',
'           p_application => :APP_ID,',
'           p_page        => 1107,',
'           p_session     => :APP_SESSION,',
'           p_clear_cache => 1107,',
'           p_items       => ''P1107_ID'',',
'           p_values      => id ) target_url,',
'       htmldb_util.get_since(created) created,',
'       lower(created_by) created_by,',
'       htmldb_util.get_since(updated) updated,',
'       lower(updated_by) updated_by,',
'       null run_model',
'from wwv_qs_saved_models',
'where security_group_id = :FLOW_SECURITY_GROUP_ID',
'and ( :P1103_SEARCH is null or',
'      instr( upper(name), upper(:P1103_SEARCH) ) > 0 or',
'      instr( upper(created_by), upper(:P1103_SEARCH) ) > 0 )',
'order by name'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No workspace saved models'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164964650386482301)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164964721158482302)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong><a href="#TARGET_URL#">#NAME#</a></strong> ( #CREATED_BY#, #CREATED# )<br />',
'#DESCRIPTION#'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164964882281482303)
,p_query_column_id=>3
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164967644212482331)
,p_query_column_id=>4
,p_column_alias=>'TARGET_URL'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164964953103482304)
,p_query_column_id=>5
,p_column_alias=>'CREATED'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164965098845482305)
,p_query_column_id=>6
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164965192342482306)
,p_query_column_id=>7
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164965298423482307)
,p_query_column_id=>8
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164965322324482308)
,p_query_column_id=>9
,p_column_alias=>'RUN_MODEL'
,p_column_display_sequence=>9
,p_column_heading=>'Run Model'
,p_use_as_row_header=>'N'
,p_column_link=>'#'
,p_column_linktext=>'Load Model'
,p_column_link_attr=>'class="a-Button a-Button--small js-loadModel" data-id="#ID#"'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4213509296976243907)
,p_name=>'Samples'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       wwv_flow_lang.message(name) name,',
'       wwv_flow_lang.message(description) description,',
'       created,',
'       lower(created_by) created_by,',
'       updated,',
'       lower(updated_by) updated_by,',
'       null run_model',
'from WWV_QS_MODELS',
'where published_yn = ''Y''',
'and ( :P1103_SEARCH is null or',
'      instr( upper(name), upper(:P1103_SEARCH) ) > 0 )',
'order by name'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Sample Models'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213509398794243908)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213509422627243909)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>#NAME#</strong><br>',
'#DESCRIPTION#'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213509549091243910)
,p_query_column_id=>3
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213509732781243912)
,p_query_column_id=>4
,p_column_alias=>'CREATED'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213509825902243913)
,p_query_column_id=>5
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213509924058243914)
,p_query_column_id=>6
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213510004791243915)
,p_query_column_id=>7
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213510248949243917)
,p_query_column_id=>8
,p_column_alias=>'RUN_MODEL'
,p_column_display_sequence=>8
,p_column_heading=>'Run Model'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:void(0);'
,p_column_linktext=>'Load Model'
,p_column_link_attr=>'class="a-Button a-Button--small js-loadModel" data-id="#ID#"'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164965762657482312)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(164965429122482309)
,p_button_name=>'FIND'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Find'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164965582758482310)
,p_name=>'P1103_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(164965429122482309)
,p_prompt=>'Search'
,p_placeholder=>'Search by name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213510333631243918)
,p_name=>'P1103_MODEL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(109720083786401743)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4213510436840243919)
,p_name=>'Load Model'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.js-loadModel'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213510594520243920)
,p_event_id=>wwv_flow_imp.id(4213510436840243919)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1103_MODEL_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213510619859243921)
,p_event_id=>wwv_flow_imp.id(4213510436840243919)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'LOAD_MODEL'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4213510729325243922)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P1103_MODEL_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'LOAD_MODEL'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>4213510729325243922
);
end;
/
prompt --application/pages/page_01104
begin
wwv_flow_imp_page.create_page(
 p_id=>1104
,p_name=>'Save Script'
,p_alias=>'SAVE-SCRIPT'
,p_page_mode=>'MODAL'
,p_step_title=>'Save Script'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(4806801565557841)
,p_dialog_height=>'320'
,p_dialog_width=>'480'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213511558797243930)
,p_plug_name=>'Form'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4213511738452243932)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4213511874005243933)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4213511738452243932)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Script'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4213511973236243934)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4213511738452243932)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4213511627570243931)
,p_name=>'P1104_SCRIPT_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4213511558797243930)
,p_prompt=>'Script Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6207117118373610)
,p_validation_name=>'sql is not empty'
,p_validation_sequence=>10
,p_validation=>':P1100_OUTPUT_SQL is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'There is no SQL to save. Please generate SQL first to proceed.'
,p_when_button_pressed=>wwv_flow_imp.id(4213511874005243933)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4032942963591342945)
,p_validation_name=>'script exists replace'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_script in (',
'    select id',
'    from wwv_flow_files f, wwv_flow_fnd_user u',
'    where u.security_group_id = :flow_security_group_id',
'    and u.user_name = :APP_USER',
'    and f.filename = :P1104_SCRIPT_NAME',
'    and f.created_by != :APP_USER',
'    and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'           or exists ( select 1',
'                         from  wwv_flow_developers',
'                        where security_group_id = :flow_security_group_id',
'                          and userid = :APP_USER',
'                          and instr(developer_role||'':'',''ADMIN:'') > 0',
'                        union',
'                       select 1',
'                         from wwv_flow_fnd_user',
'                        where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                          and user_name = :APP_USER',
'                          and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER''))) )',
'loop',
'    return false;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The script name exists already in your workspace and is owned by another user.  Please enter a different script name.'
,p_when_button_pressed=>wwv_flow_imp.id(4213511874005243933)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4213512088867243935)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4213511973236243934)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213512109682243936)
,p_event_id=>wwv_flow_imp.id(4213512088867243935)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6206833571373607)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SaveScript'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_script_id     number;',
'    l_script_name   varchar2(4000);',
'    l_sql           clob := :P1100_OUTPUT_SQL;',
'begin',
'',
'    -- save SQL ',
'    l_script_name := :P1104_SCRIPT_NAME;',
'    ',
'    for l_script in (',
'        select id',
'        from wwv_flow_files f, wwv_flow_fnd_user u',
'        where u.security_group_id = :flow_security_group_id',
'        and u.user_name = :APP_USER',
'        and f.filename = l_script_name',
'        and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'               or exists ( select 1',
'                             from  wwv_flow_developers',
'                            where security_group_id = :flow_security_group_id',
'                              and userid = :APP_USER',
'                              and instr(developer_role||'':'',''ADMIN:'') > 0',
'                            union',
'                           select 1',
'                             from wwv_flow_fnd_user',
'                            where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                              and user_name = :APP_USER',
'                              and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER''))) )',
'    loop',
'        l_script_id := l_script.id;',
'    end loop;',
'    ',
'    if l_script_id is null then',
'        wwv_flow_sw_script.create_script_from_clob (        ',
'             p_script_name => l_script_name,',
'             p_script      => l_sql );',
'    else',
'        wwv_flow_sw_script.update_script_file (',
'             p_file_id     => l_script_id,',
'             p_script_name => l_script_name,',
'             p_script      => l_sql );',
'             ',
'        :P1100_SCRIPT_NAME := l_script_name;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4213511874005243933)
,p_internal_uid=>6206833571373607
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4032943149813342947)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'closeDialog'
,p_attribute_01=>'P1104_SCRIPT_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Script "&P1104_SCRIPT_NAME." saved'
,p_internal_uid=>4032943149813342947
);
end;
/
prompt --application/pages/page_01105
begin
wwv_flow_imp_page.create_page(
 p_id=>1105
,p_name=>'Save Model'
,p_alias=>'SAVE-MODEL'
,p_page_mode=>'MODAL'
,p_step_title=>'Save Model'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(4806801565557841)
,p_dialog_height=>'320'
,p_dialog_width=>'480'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(322850391897931279)
,p_plug_name=>'Model Detail'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>50
,p_query_type=>'TABLE'
,p_query_table=>'WWV_QS_SAVED_MODELS'
,p_query_where=>'security_group_id = :flow_security_group_id'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4374476372760452414)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2400953957658505)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4374476372760452414)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_confirm_message=>'<strong>Are you sure</strong> you wish to delete this model?'
,p_confirm_style=>'danger'
,p_button_condition=>'P1105_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(161432681248974219)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4374476372760452414)
,p_button_name=>'CREATE'
,p_button_static_id=>'save_model'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Model'
,p_button_position=>'NEXT'
,p_button_condition=>'P1105_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2400805552658504)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4374476372760452414)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Update Model'
,p_button_position=>'NEXT'
,p_button_condition=>'P1105_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(160966326559208507)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4374476372760452414)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2402490956658520)
,p_branch_name=>'Redirect to Page 1100'
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:CR,1100::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2400953957658505)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(161433093416974222)
,p_name=>'P1105_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(322850391897931279)
,p_item_source_plug_id=>wwv_flow_imp.id(322850391897931279)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(161434220697974223)
,p_name=>'P1105_MODEL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(322850391897931279)
,p_item_source_plug_id=>wwv_flow_imp.id(322850391897931279)
,p_prompt=>'Model Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(161434657465974223)
,p_name=>'P1105_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(322850391897931279)
,p_item_source_plug_id=>wwv_flow_imp.id(322850391897931279)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(161435015389974224)
,p_name=>'P1105_MODEL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(322850391897931279)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P1100_RAW_SQL'
,p_item_default_type=>'ITEM'
,p_source=>'P1100_RAW_SQL'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4203016367374408)
,p_computation_sequence=>10
,p_computation_item=>'P1105_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_qs_saved_models ',
' where id = :P1100_MODEL_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_compute_when=>':P1100_MODEL_ID is not null and nvl(:REQUEST, ''SAVE'') != ''SAVE_AS'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(160972358555355705)
,p_validation_name=>'model not null'
,p_validation_sequence=>10
,p_validation=>'P1105_MODEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Quick SQL shorthand syntax must be specified to save.'
,p_validation_condition=>'CREATE,SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(160966829022208518)
,p_validation_name=>'model name exists, use different name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_model in (',
'    select id',
'    from wwv_qs_saved_models',
'    where security_group_id = :flow_security_group_id',
'    and name = :P1105_MODEL_NAME',
'    and ( id != :P1105_ID or :P1105_ID is null ) )',
'loop',
'    return false;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The model name exists already in your workspace.  Please enter a different name.'
,p_validation_condition=>'CREATE,SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(161434220697974223)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(160967999436208524)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(160966326559208507)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(160968483954208525)
,p_event_id=>wwv_flow_imp.id(160967999436208524)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(160967102552208521)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SaveModel'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1105_ID is null  then',
'    insert into wwv_qs_saved_models ',
'        ( name, description, model )  ',
'    values ',
'        ( :P1105_MODEL_NAME, :P1105_DESCRIPTION, :P1105_MODEL)',
'    returning id into :P1105_ID;        ',
'else ',
'    update wwv_qs_saved_models ',
'        set name        = :P1105_MODEL_NAME,',
'            description = :P1105_DESCRIPTION,',
'            model       = :P1105_MODEL',
'            where id    = :P1105_ID',
'              and security_group_id = :flow_security_group_id;',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save model'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>160967102552208521
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2402390171658519)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(322850391897931279)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Delete Model'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'N'
,p_attribute_06=>'Y'
,p_attribute_08=>'N'
,p_process_error_message=>'Unable to delete model.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2400953957658505)
,p_process_success_message=>'The model has been deleted.'
,p_internal_uid=>2402390171658519
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(160967514690208524)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'closeDialog'
,p_attribute_01=>'P1105_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Model saved'
,p_internal_uid=>160967514690208524
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(160974971020355731)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(322850391897931279)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Model Detail'
,p_internal_uid=>160974971020355731
);
end;
/
prompt --application/pages/page_01107
begin
wwv_flow_imp_page.create_page(
 p_id=>1107
,p_name=>'Edit Model'
,p_alias=>'EDIT-MODEL'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Model'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(4806801565557841)
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(485634170968606312)
,p_plug_name=>'Model Detail'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>50
,p_query_type=>'TABLE'
,p_query_table=>'WWV_QS_SAVED_MODELS'
,p_query_where=>'security_group_id = :flow_security_group_id'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4537260151831127447)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(162785179424675041)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4537260151831127447)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1107_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(162784336183675039)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(4537260151831127447)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_button_condition=>'P1107_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(162784731683675041)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4537260151831127447)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1103:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185274917186967001)
,p_branch_name=>'back to load'
,p_branch_action=>'f?p=&APP_ID.:1103:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162786242905675047)
,p_name=>'P1107_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(485634170968606312)
,p_item_source_plug_id=>wwv_flow_imp.id(485634170968606312)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162786614227675052)
,p_name=>'P1107_MODEL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(485634170968606312)
,p_item_source_plug_id=>wwv_flow_imp.id(485634170968606312)
,p_prompt=>'Model Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162787043588675052)
,p_name=>'P1107_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(485634170968606312)
,p_item_source_plug_id=>wwv_flow_imp.id(485634170968606312)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(162789961188675059)
,p_validation_name=>'model name exists, use different name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_model in (',
'    select id',
'    from wwv_qs_saved_models',
'    where security_group_id = :flow_security_group_id',
'    and name = :P1107_MODEL_NAME',
'    and ( id != :P1107_ID or :P1107_ID is null ) )',
'loop',
'    return false;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The model name exists already in your workspace.  Please enter a different name.'
,p_when_button_pressed=>wwv_flow_imp.id(162784336183675039)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(162789035349675054)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(485634170968606312)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'SaveModel'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_process_error_message=>'Unable to save model.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>162789035349675054
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(162789454864675054)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(485634170968606312)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Model Detail'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>162789454864675054
);
end;
/
prompt --application/pages/page_01108
begin
wwv_flow_imp_page.create_page(
 p_id=>1108
,p_name=>'Properties'
,p_alias=>'PROPERTIES'
,p_page_mode=>'MODAL'
,p_step_title=>'Properties'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(4806801565557841)
,p_dialog_height=>'360'
,p_dialog_width=>'480'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(324864851687260634)
,p_plug_name=>'Model Detail'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>50
,p_query_type=>'TABLE'
,p_query_table=>'WWV_QS_SAVED_MODELS'
,p_query_where=>'security_group_id = :flow_security_group_id'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6208265444373621)
,p_name=>'P1108_ROW_VERSION'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_item_source_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_prompt=>'Version'
,p_source=>'ROW_VERSION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6208407956373623)
,p_name=>'P1108_CREATED'
,p_source_data_type=>'DATE'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_item_source_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_prompt=>'Created'
,p_source=>'CREATED'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6208568842373624)
,p_name=>'P1108_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_item_source_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_prompt=>'Created By'
,p_source=>'CREATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6208681095373625)
,p_name=>'P1108_UPDATED'
,p_source_data_type=>'DATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_item_source_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_prompt=>'Updated'
,p_source=>'UPDATED'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6208750755373626)
,p_name=>'P1108_UPDATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_item_source_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_prompt=>'Updated By'
,p_source=>'UPDATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(163448111912303609)
,p_name=>'P1108_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_item_source_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(163449239193303610)
,p_name=>'P1108_MODEL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_item_source_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_prompt=>'Model Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(163449675961303610)
,p_name=>'P1108_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_item_source_plug_id=>wwv_flow_imp.id(324864851687260634)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2020206077329416)
,p_computation_sequence=>10
,p_computation_item=>'P1108_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_qs_saved_models ',
' where id = :P1100_MODEL_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_compute_when=>':P1100_MODEL_ID is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2021021249329417)
,p_validation_name=>'model not null'
,p_validation_sequence=>10
,p_validation=>'P1108_MODEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Quick SQL shorthand syntax must be specified to save.'
,p_validation_condition=>'CREATE,SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2017663932329400)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(324864851687260634)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Model Detail'
,p_internal_uid=>2017663932329400
);
end;
/
prompt --application/pages/page_01200
begin
wwv_flow_imp_page.create_page(
 p_id=>1200
,p_name=>'SQL Query'
,p_alias=>'SQL-QUERY'
,p_step_title=>'SQL Query'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213236325564854129)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'	table.htmldbShowHideMin{border-collapse:collapse;border:none;width:600px;}',
'	th.htmldbShowHideMin{font-weight:bold;font-size:12px;text-align:left;}',
'	td.htmldbShowHideMin{border:1px #cccccc solid;padding:4px;font-size:12px;}',
'</style>'))
,p_step_template=>wwv_flow_imp.id(14599108081253832)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5837904136173370)
,p_plug_name=>'SQL Script results (autocommit)'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_2'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_page_calls.sql_results (',
'    p_sql_command2  => :p1003_sql_command2,',
'    p_bind_vals     => :p1200_bind_vals,',
'    p_schema        => :p1003_schema,',
'    p_language      => :p1003_cmd_language,',
'    p_mle_env       => :p1003_mle_env );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(( upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) != ''SELECT'' and',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,4)) != ''WITH'' and',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) != ''COMMIT'' and',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,8)) != ''ROLLBACK''',
') or',
':P1003_CMD_LANGUAGE in ( wwv_flow_code_exec.c_javascript, wwv_flow_code_exec.c_java, wwv_flow_code_exec.c_python ) ) and',
':P1003_AUTOCOMMIT = ''Y'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21503410687604939)
,p_plug_name=>'SQL Command Results (autocommit)'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_sql       clob;',
'    report      wwv_flow_global.vc_arr2;',
'    binds       wwv_flow_global.vc_arr2;',
'    l_start     number;',
'begin',
'',
'-- get the statement to run',
'  l_sql := :P1003_SQL_COMMAND2;',
'',
'-- get the binds values used last time if they exist',
'  binds := wwv_flow_utilities.string_to_table (',
'                            str => v(''P1200_BIND_VALS''),',
'                            sep => '','');',
'',
'  for i in 1..binds.count loop',
'   if binds(i) = ''HTMLDB:NULL'' then',
'    binds(i) := null;',
'   end if;',
'  end loop;',
'',
'-- get start time',
'l_start := sys.dbms_utility.get_time;',
'',
'if upper(substr(ltrim(:P1003_SQL_COMMAND2),1,6)) = ''COMMIT'' then',
'  sys.htp.p(wwv_flow_lang.system_message(''AUTOCOMMIT'')); ',
'elsif upper(substr(ltrim(:P1003_SQL_COMMAND2),1,8)) = ''ROLLBACK'' then',
'  sys.htp.p(wwv_flow_lang.system_message(''ROLLBACK'')); ',
'else',
'  -- get the results ',
'    wwv_flow_sw_api.check_priv(:P1003_SCHEMA);	',
'    wwv_flow_security.g_parse_as_schema := :P1003_SCHEMA;',
'    report := wwv_flow_render_query.get_report (',
'        p_owner  => :P1003_SCHEMA,',
'        p_query  => l_sql,',
'        p_values => binds,',
'        p_format => ''HTMLR'',',
'        p_limit_type => ''R'',',
'        p_max_rows => :P1003_ROWS',
'    );',
'  wwv_flow_security.g_parse_as_schema := wwv_flow.g_flow_schema_owner;',
'  -- get count minus 1 because of header row returned',
'  -- get count minus 2 because of to many rows message',
'  if (report.count > to_number(v(''P1003_ROWS''))+1) then',
'       :p1200_rows := report.count-2;',
'  else',
'       :p1200_rows := report.count-1;',
'  end if;',
'',
'  sys.htp.p(''<div id=ResultsSQL>'');',
'  -- print the results',
'  for i in 1..report.count loop',
'    sys.htp.p(report(i));',
'  end loop;',
'  sys.htp.p(''</div>'');',
'  if (report.count > 1) then',
'    -- print row count and timing information',
'    sys.htp.prn(''<table><tr><td>'');   ',
'    sys.htp.prn(''<span style="font-size:13px">''||wwv_flow_lang.system_message(''ROWS_IN_SECONDS'',:p1200_rows,to_char(round((sys.dbms_utility.get_time-l_start)/100,2),''999G999G999G990D00''))||''</span>'');',
'sys.htp.prn(''</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><span style="font-size:11px"><a href="f?p=4500:1204:''||:SESSION||''::::P1204_BROWSER_LANG:''||wwv_flow.g_browser_language||''">''||',
'         wwv_flow_lang.system_message(''F4000.P420.CSV_EXPORT'')||',
'         ''</a></span></td></tr></table>'');',
'  end if;',
'end if;',
'exception when others then',
'  wwv_flow_security.g_parse_as_schema := wwv_flow.g_flow_schema_owner;',
'  wwv_flow_debug.log_exception;',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'((upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) = ''SELECT'' or',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,4)) = ''WITH'' or',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) = ''COMMIT'' or',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,8)) = ''ROLLBACK'') and',
':P1003_CMD_LANGUAGE not in ( wwv_flow_code_exec.c_javascript, wwv_flow_code_exec.c_java, wwv_flow_code_exec.c_python ) and',
':P1003_AUTOCOMMIT = ''Y'')'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27937306591128514)
,p_plug_name=>'DBMS Output'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(35638231141594602)
,p_plug_display_sequence=>32
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_count number := v(''P1200_ROWS'');',
'begin',
'  sys.htp.p(''<pre>'');',
'  for i in 1..wwv_flow_render_query.g_dbms_output.count loop',
'    sys.htp.p(wwv_flow_render_query.g_dbms_output(i));',
'  end loop;',
'  sys.htp.p(''</pre>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'((upper(substr(ltrim(:P1003_SQL_COMMAND2),1,6)) = ''SELECT'' or',
'upper(substr(ltrim(:P1003_SQL_COMMAND2),1,4)) = ''WITH'')) and',
'wwv_flow_render_query.g_dbms_output.count > 1'))
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_read_only_when2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27945305393241780)
,p_plug_name=>'Item Holder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>1
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_1'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(136436823187793970)
,p_plug_name=>'SQL Script results (no autocommit)'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>42
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_2'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<!-- HTMLDB:RUNNING'' || :P1003_CMD_LANGUAGE || '' --><DIV id="dSQLResult">'');',
'sys.htp.p(wwv_flow_lang.system_message(p_name=>''SC_SQL_RUNNING''));',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(( upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) != ''SELECT'' and',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,4)) != ''WITH'' ) or',
':P1003_CMD_LANGUAGE in ( wwv_flow_code_exec.c_javascript, wwv_flow_code_exec.c_java, wwv_flow_code_exec.c_python ) ) and',
':P1003_AUTOCOMMIT != ''Y'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(137068820874069237)
,p_plug_name=>'SQL Command Results (no autocommit)'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>31
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<!-- HTMLDB:RUNNINGSQL --><DIV id="dSQLResult">'');',
'sys.htp.p(wwv_flow_lang.system_message(p_name=>''SC_SQL_RUNNING''));',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,6)) = ''SELECT'' or',
'upper(substr(ltrim(replace(replace(:P1003_SQL_COMMAND2,chr(10),''''),chr(13),'''')),1,4)) = ''WITH'') and',
':P1003_CMD_LANGUAGE not in ( wwv_flow_code_exec.c_javascript, wwv_flow_code_exec.c_java, wwv_flow_code_exec.c_python ) and',
':P1003_AUTOCOMMIT != ''Y'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(137341724550811368)
,p_plug_name=>'DBMS Output'
,p_region_name=>'dbms_output_show_hide'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(35638231141594602)
,p_plug_display_sequence=>52
,p_plug_display_column=>1
,p_plug_display_point=>'BODY_3'
,p_plug_source=>'<div id="DBMS_OUTPUT_DIV"></div>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4417028828681705)
,p_name=>'P1200_ROWS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(27945305393241780)
,p_item_default=>'10'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4418303464693368)
,p_name=>'P1200_PREV_SQL'
,p_data_type=>'CLOB'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(27945305393241780)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21572909937200807)
,p_name=>'P1200_ACTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(27945305393241780)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21606912080381235)
,p_name=>'P1200_BINDS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(27945305393241780)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21736625668766618)
,p_name=>'P1200_BIND_VALS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(27945305393241780)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141063525539678026)
,p_name=>'P1200_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(27945305393241780)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141446907512589228)
,p_name=>'P1200_STMT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(27945305393241780)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(302525021229299586)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>302525021229299586
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(27211261219513908)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Strip start comments from P1003_SQL_COMMAND2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- convert CRLF to LF',
'-- remove -- comments at the beginning',
'--',
':P1003_SQL_COMMAND2 := regexp_replace (',
'                           regexp_replace (',
'                               :P1003_SQL_COMMAND2,',
'                               chr(13)||''?''||chr(10),',
'                               chr(10) ),',
'                           ''^(\s*--[^''||chr(10)||'']*''||chr(10)||'')+'',',
'                           null );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P1003_SQL_COMMAND2 != nvl(:P1200_PREV_SQL,'' '')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>27211261219513908
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6214509600387615)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save history'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.save_history (',
'    p_security_group_id => :flow_security_group_id,',
'    p_user              => :flow_user,',
'    p_sql_cmd           => :P1003_SQL_COMMAND2,',
'    p_schema            => :P1003_SCHEMA',
'    );',
'',
':P1200_PREV_SQL := :P1003_SQL_COMMAND2 ;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save command history.'
,p_process_when=>':P1003_SQL_COMMAND2 != nvl(:P1200_PREV_SQL,'' '')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>6214509600387615
);
end;
/
prompt --application/pages/page_01201
begin
wwv_flow_imp_page.create_page(
 p_id=>1201
,p_name=>'History'
,p_alias=>'HISTORY'
,p_step_title=>'History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213236325564854129)
,p_javascript_file_urls=>'#IMAGE_PREFIX#sc/sc_core.js'
,p_step_template=>wwv_flow_imp.id(14599108081253832)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5983109938894128)
,p_name=>'SQL Command History'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       CREATED_ON created, ',
'       created_by, ',
'       sys.dbms_lob.substr(command,100,1) sql_cmd,',
'       PARSED_SCHEMA,',
'       ''javascript:sc_postHistory(''||',
'       wwv_flow_escape.js_literal(ID)||',
'       '',''||wwv_flow_escape.js_literal(PARSED_SCHEMA)||',
'       '');'' link',
'from wwv_flow_sw_sql_cmds  ',
'where security_group_id = :flow_security_group_id  ',
'and created_by = :flow_user ',
'and (:P1201_FIND is null or instr(upper(command),upper(:P1201_FIND)) > 0)',
'order by CREATED_ON desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No command history found.'
,p_query_row_count_max=>100
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23982602424811438)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5983413805894138)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>1
,p_column_heading=>'Time'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5983518709894138)
,p_query_column_id=>3
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>3
,p_column_heading=>'By'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5983625499894139)
,p_query_column_id=>4
,p_column_alias=>'SQL_CMD'
,p_column_display_sequence=>2
,p_column_heading=>'SQL'
,p_use_as_row_header=>'N'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#SQL_CMD#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161196926932862064)
,p_query_column_id=>5
,p_column_alias=>'PARSED_SCHEMA'
,p_column_display_sequence=>5
,p_column_heading=>'Schema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(423052112825639938)
,p_query_column_id=>6
,p_column_alias=>'LINK'
,p_column_display_sequence=>6
,p_column_heading=>'Link'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26154723718225041)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23976007778699484)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(26154723718225041)
,p_button_name=>'GO'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT-CENTER'
,p_button_redirect_url=>'javascript:sc_DisplayHist(true);'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5985722851905156)
,p_branch_action=>'javascript:sc_DisplayHist();'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5986320805906753)
,p_name=>'P1201_PASSBACK1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5983109938894128)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5986924960907925)
,p_name=>'P1201_PASSBACK2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5983109938894128)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6341431950207894)
,p_name=>'P1201_HISTORY_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5983109938894128)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13468207898983653)
,p_name=>'P1201_FIND'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(26154723718225041)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter query condition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
prompt --application/pages/page_01202
begin
wwv_flow_imp_page.create_page(
 p_id=>1202
,p_name=>'Explain Query Plan'
,p_alias=>'EXPLAIN-QUERY-PLAN'
,p_step_title=>'Plan'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213236325564854129)
,p_step_template=>wwv_flow_imp.id(14599108081253832)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2219893965597640)
,p_plug_name=>'Statement not supported'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>'This statement is not supported for explain plan.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1202_QUERY_TYPE'
,p_plug_display_when_cond2=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'10g Version'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(135681931596634447)
,p_plug_name=>'plan'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(239514318560826866)
,p_name=>'Index Columns'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select c006 object_owner, c007 object_type,c008 object_name',
'      from htmldb_collections',
'     where COLLECTION_NAME=''HTMLDB_QUERY_PLAN''',
'       and c007 in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')),',
'ws_schemas as(',
'    select schema',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id),',
't as(',
'        select s.object_owner table_owner,s.object_name table_name,',
'               d.OBJECT_ID',
'          from sqlplan s,sys.dba_objects d',
'         where s.object_owner = d.owner',
'           and s.object_name = d.object_name',
'           and s.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name,',
'               d.OBJECT_ID',
'          from sys.dba_indexes d1, sqlplan s1,',
'               sys.dba_objects d',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           and replace(s1.object_type,'' (UNIQUE)'') = ''INDEX''',
'           and d.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'           and d.owner = d1.table_owner',
'           and d.object_name = d1.table_name',
'           ),',
'cols as(',
'    select table_owner,index_name,',
'           rtrim(',
'           max(decode(position,1 ,column_name))||'',''||',
'           max(decode(position,2 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,3 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,4 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,5 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,6 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,7 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,8 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,9 ,substr(column_name,1,128)))||'',''||',
'           max(decode(position,10,substr(column_name,1,128)))',
'           ,'','') columns',
'     from(',
'        select c.table_owner,c.index_name,c.column_name,c.column_position position',
'          from sys.dba_ind_columns c, t',
'         where t.table_owner = c.table_owner',
'           and t.table_name = c.table_name)',
'    group by table_owner,index_name',
')',
'select di.owner,',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="''||wwv_flow_page_api.get_url(',
'                             p_page        => 2000,',
'                             p_clear_cache => ''RP,2000'',',
'                             p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'',',
'                             p_values      => di.owner||'',''||t.object_id )||''">''||wwv_flow_escape.html(di.table_name)||''</a>''',
'       else wwv_flow_escape.html(di.table_name) end table_name,',
'       case when di.owner in (select schema from ws_schemas) then',
'            ''<a href="''||wwv_flow_page_api.get_url(',
'                             p_page        => 2000,',
'                             p_clear_cache => ''RP,2000'',',
'                             p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'',',
'                             p_values      => di.owner||'',''||do2.object_id )||''">''||wwv_flow_escape.html(di.index_name)||''</a>''',
'       else wwv_flow_escape.html(di.index_name) end index_name,',
'       case when (select count(*) cnt',
'                    from sqlplan sp1',
'                   where sp1.object_type like ''INDEX%''',
'                     and sp1.object_name = di.index_name) > 0',
'            then ''<img src="#IMAGE_PREFIX#check_small_black.gif" alt=""/>''',
'            else ''<br />''',
'       end check_mark,',
'      c.columns, uniqueness, di.status,',
'      index_type, partitioned,',
'      funcidx_status, join_index,t.object_id, do2.object_id index_object_id',
'from   sys.dba_indexes di,sys.dba_objects do2,',
'       t,cols c',
'where di.table_owner = t.table_owner',
'  and di.table_name = t.table_name',
'  and index_type != ''LOB''',
'  and do2.object_type = ''INDEX''',
'  and do2.owner = di.owner',
'  and do2.object_name = di.index_name',
'  and c.table_owner = di.table_owner',
'  and c.index_name  = di.index_name'))
,p_display_when_condition=>'P1202_QUERY_TYPE'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'No indexes found'
,p_query_row_count_max=>1000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10g Version'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241097528833140170)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239515507477826873)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_inline_lov=>'f?p=4500:1001:''||:APP_SESSION||'':FOCUS:::OB_OBJECT_ID,OB_CURRENT_TYPE,OB_SCHEMA'
,p_lov_language=>'PLSQL'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241097615533140170)
,p_query_column_id=>3
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Index Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241097704512140171)
,p_query_column_id=>4
,p_column_alias=>'CHECK_MARK'
,p_column_display_sequence=>4
,p_column_heading=>'Used in<br />Plan'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241097817354140171)
,p_query_column_id=>5
,p_column_alias=>'COLUMNS'
,p_column_display_sequence=>5
,p_column_heading=>'Columns'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241097917854140171)
,p_query_column_id=>6
,p_column_alias=>'UNIQUENESS'
,p_column_display_sequence=>6
,p_column_heading=>'Uniqueness'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241098028330140171)
,p_query_column_id=>7
,p_column_alias=>'STATUS'
,p_column_display_sequence=>7
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241098131175140171)
,p_query_column_id=>8
,p_column_alias=>'INDEX_TYPE'
,p_column_display_sequence=>8
,p_column_heading=>'Index Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241098226446140171)
,p_query_column_id=>9
,p_column_alias=>'PARTITIONED'
,p_column_display_sequence=>9
,p_column_heading=>'Partitioned'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241098301230140171)
,p_query_column_id=>10
,p_column_alias=>'FUNCIDX_STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Funcidx Status'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241098430048140172)
,p_query_column_id=>11
,p_column_alias=>'JOIN_INDEX'
,p_column_display_sequence=>11
,p_column_heading=>'Join Index'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241098518617140172)
,p_query_column_id=>12
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>12
,p_column_heading=>'Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(241098624718140172)
,p_query_column_id=>13
,p_column_alias=>'INDEX_OBJECT_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Index Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(239555324756875948)
,p_name=>'Query Plan'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select to_number(c001) id, to_number(c002) parent_id,to_number(c003) position,',
'           c004 operation, c005 options,',
'           c006 object_owner, c007 object_type,c008 object_name,',
'           c009 access_predicates, c010 filter_predicates,',
'           to_number(c011) cardinality, to_number(c012)cost,',
'           to_number(c013) bytes, to_number(c014)time',
'      from htmldb_collections',
'     where COLLECTION_NAME=''HTMLDB_QUERY_PLAN''),',
'objects as (',
'   select o.object_id,s.id',
'     from sys.dba_objects o,sqlplan s',
'    where o.owner = s.object_owner',
'      and o.object_name = s.object_name',
'      and replace(s.object_type,'' (UNIQUE)'') = o.object_type',
'      and s.object_type in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')',
'     ),',
'ws_schemas as(',
'    select schema ',
'      from wwv_flow_company_schemas',
'     where security_group_id = :flow_security_group_id), ',
'plan_objects as(',
'    select s.id,parent_id,position,',
'           operation,options,',
'           object_owner,object_type,object_name,',
'           access_predicates,filter_predicates,',
'           cardinality,cost,bytes,time,',
'           o.object_id',
'      from sqlplan s,objects o',
'     where s.id = o.id(+))',
'select operation,options,',
'       case when object_type in (''TABLE'',''VIEW'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'') then',
'            case when object_owner in (select schema from ws_schemas) then',
'                 ''<a href="''||wwv_flow_page_api.get_url(',
'                                  p_page        => 2000,',
'                                  p_clear_cache => ''RP,2000'',',
'                                  p_items       => ''P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID'',',
'                                  p_values      => object_owner||'',''||object_id )||''">''||wwv_flow_escape.html(object_name)||''</a>''',
'            else wwv_flow_escape.html(object_name) end ',
'       else wwv_flow_escape.html(object_name) end object_name,',
'       cost,cardinality,bytes,',
'       decode(level,1,1,power(level,2)+15) padding,access_predicates,filter_predicates,TIME,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,filter_predicates)',
'       else wwv_flow_escape.html(replace(filter_predicates,''='','' = '')) end filter_predicates2,',
'       case when object_type = ''TABLE'' then',
'            wwv_flow_session_mon.highlight_plan_ind_cols(object_owner,object_name,access_predicates) ',
'       else wwv_flow_escape.html(replace(access_predicates,''='','' = '')) end access_predicates2,',
'       object_id,object_type',
'   from plan_objects s1',
'  start with id = 0',
'connect by prior id = parent_id',
'  order by id, position'))
,p_display_when_condition=>'P1202_QUERY_TYPE'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'* Unindexed columns are shown in red',
'<br />'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No plan is available for this statement.'
,p_query_row_count_max=>10000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10g Version'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239555800201875951)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>'Operation'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<div style="padding-left:#PADDING#px;white-space:nowrap;font-family:monospace;">#OPERATION#</div>'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239555912431875952)
,p_query_column_id=>2
,p_column_alias=>'OPTIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Options'
,p_use_as_row_header=>'N'
,p_column_css_style=>'white-space:nowrap;font-family:monospace;'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239555711134875950)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Object'
,p_use_as_row_header=>'N'
,p_column_css_style=>'font-family:monospace;'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239556015951875952)
,p_query_column_id=>4
,p_column_alias=>'COST'
,p_column_display_sequence=>6
,p_column_heading=>'Cost'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239556131228875952)
,p_query_column_id=>5
,p_column_alias=>'CARDINALITY'
,p_column_display_sequence=>4
,p_column_heading=>'Rows'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239555612991875950)
,p_query_column_id=>6
,p_column_alias=>'BYTES'
,p_column_display_sequence=>7
,p_column_heading=>'Bytes'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239555528964875950)
,p_query_column_id=>7
,p_column_alias=>'PADDING'
,p_column_display_sequence=>10
,p_column_heading=>'Padding'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239556514881875952)
,p_query_column_id=>8
,p_column_alias=>'ACCESS_PREDICATES'
,p_column_display_sequence=>8
,p_column_heading=>'Access<br />Predicates'
,p_use_as_row_header=>'N'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239556626602875952)
,p_query_column_id=>9
,p_column_alias=>'FILTER_PREDICATES'
,p_column_display_sequence=>9
,p_column_heading=>'Filter<br />Predicates'
,p_use_as_row_header=>'N'
,p_column_css_style=>'font-family:monospace;'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239556719045875953)
,p_query_column_id=>10
,p_column_alias=>'TIME'
,p_column_display_sequence=>5
,p_column_heading=>'Time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G999G999G999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239557011368875953)
,p_query_column_id=>11
,p_column_alias=>'FILTER_PREDICATES2'
,p_column_display_sequence=>11
,p_column_heading=>'Filter<br />Predicates *'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239557112931875953)
,p_query_column_id=>12
,p_column_alias=>'ACCESS_PREDICATES2'
,p_column_display_sequence=>12
,p_column_heading=>'Access<br />Predicates'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239556820353875953)
,p_query_column_id=>13
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Object Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239556911845875953)
,p_query_column_id=>14
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>14
,p_column_heading=>'Object Type'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(239675610426212457)
,p_name=>'Table Columns'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sqlplan as (',
'    select c006 object_owner, c007 object_type,c008 object_name',
'      from htmldb_collections',
'     where COLLECTION_NAME=''HTMLDB_QUERY_PLAN''',
'       and c007 in (''TABLE'',''INDEX'',''MATERIALIZED VIEW'',''INDEX (UNIQUE)'')),',
't1 as(',
'        select s.object_owner table_owner,s.object_name table_name',
'          from sqlplan s',
'         where s.object_type in (''TABLE'',''MATERIALIZED VIEW'')',
'         union',
'        select d1.table_owner table_owner,d1.table_name table_name',
'          from sys.dba_indexes d1, sqlplan s1',
'         where d1.index_name = s1.object_name',
'           and d1.owner = s1.object_owner',
'           and replace(s1.object_type,'' (UNIQUE)'') = ''INDEX''',
'           ),',
't as (select t1.table_owner, t1.table_name,',
'             o.object_id',
'        from t1, sys.dba_objects o',
'       where t1.table_owner = o.owner',
'         and t1.table_name = o.object_name',
'         and o.object_type in (''TABLE'',''MATERIALIZED VIEW'') ',
'      )',
'select t.table_owner,t.table_name,c.column_name,c.data_type',
'  from t,sys.dba_tab_columns c',
' where t.table_name = c.table_name',
'   and t.table_owner = c.owner',
' order by t.table_owner,t.table_name,c.column_id'))
,p_display_when_condition=>'P1202_QUERY_TYPE'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>2000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>10000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_comment=>'10g Version'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239675924163212494)
,p_query_column_id=>1
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Table Owner'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239676025992212494)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239676117659212494)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(239676200856212494)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2219739725597639)
,p_name=>'P1202_QUERY_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(135681931596634447)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6369926344376593)
,p_name=>'P1202_PLAN_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(135681931596634447)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2219658385597638)
,p_computation_sequence=>10
,p_computation_item=>'P1202_QUERY_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sy wwv_flow_plsql_lexer.t_symbol;',
'begin',
'    wwv_flow_plsql_lexer.init( wwv_flow.g_f01(1) );',
'',
'    l_sy := wwv_flow_plsql_lexer.get;',
'',
'    if l_sy in ( wwv_flow_plsql_lexer.c_sy_select,',
'                 wwv_flow_plsql_lexer.c_sy_insert,',
'                 wwv_flow_plsql_lexer.c_sy_update,',
'                 wwv_flow_plsql_lexer.c_sy_DELETE,',
'                 wwv_flow_plsql_lexer.c_sy_MERGE,',
'                 wwv_flow_plsql_lexer.c_sy_with )',
'    then',
'        return ''Y'';',
'    else',
'        return ''N'';',
'    end if;',
'end;'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(302531415221364040)
,p_process_sequence=>5
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>302531415221364040
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6370900633388058)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create plan table if needed.'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.create_plan_table (',
'    p_schema => :P1003_SCHEMA',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error explaining plan for statement: <pre>exit</pre>'
,p_internal_uid=>6370900633388058
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6373330761396752)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Explain Plan'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_plan_id number := wwv_flow_id.next_val;',
'begin',
'  :P1202_PLAN_ID := l_plan_id;',
'  wwv_flow_sw_api.explain_plan (',
'    p_plan_id => l_plan_id,',
'    p_sql     => wwv_flow_sw_api.to_sql_command(wwv_flow.g_f01),',
'    p_schema  => :P1003_SCHEMA',
'    );',
'',
'-- when we don''t have a valid sql command, we set the :P1202_QUERY_TYPE flag to N ',
'-- which will display the region Statement not supported',
'exception',
'      when others then ',
'        :P1202_QUERY_TYPE := ''N'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error computing plan for statement.'
,p_process_when=>'P1202_QUERY_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_internal_uid=>6373330761396752
);
end;
/
prompt --application/pages/page_01203
begin
wwv_flow_imp_page.create_page(
 p_id=>1203
,p_name=>'SQL Command Processor - Saved SQL'
,p_alias=>'SQL-COMMAND-PROCESSOR-SAVED-SQL'
,p_step_title=>'Saved SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213236325564854129)
,p_step_template=>wwv_flow_imp.id(14599108081253832)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(6415019707620645)
,p_name=>'Saved SQL'
,p_template=>wwv_flow_imp.id(12270828624874231)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid=>true
,p_display_column=>1
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       QUERY_OWNER,',
'       case query_type',
'         when ''W'' then wwv_flow_lang.system_message(''SC_VQ'')',
'         when ''R'' then wwv_flow_lang.system_message(''SC_SC'')',
'       end qType,',
'       title,',
'       sys.dbms_lob.substr(QB_SQL,120) as QB_SQL,',
'       DESCRIPTION,',
'       CREATED_BY,',
'       CREATED_ON,',
'       LAST_UPDATED_BY,',
'       LAST_UPDATED_ON,',
'       SECURITY_GROUP_ID,',
'       ''javascript:sc_postSavedSQL(''||',
'            wwv_flow_escape.js_literal(id)||',
'       '',''||wwv_flow_escape.js_literal(title)||',
'       '',''||wwv_flow_escape.js_literal(description)||',
'       '',''||wwv_flow_escape.js_literal(',
'                case query_type',
'                  when ''W'' then ''VQB''',
'                  when ''R'' then ''SC''',
'                end)||',
'       '',''||wwv_flow_escape.js_literal(query_owner)||',
'       '');'' link_url',
' from WWV_FLOW_QB_SAVED_QUERY',
'where security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and (:P1203_FIND is null',
'       or instr(upper(title),upper(:P1203_FIND)) > 0 ',
'       or instr(upper(QB_SQL),upper(:P1203_FIND)) > 0 )',
'  and (created_by = case when :P1203_SHOW = ''0'' then created_by else :P1203_SHOW end) ',
'  and (created_by = :APP_USER',
'      or exists ( select 1',
'                    from wwv_flow_developers',
'                   where security_group_id = :flow_security_group_id',
'                     and userid = :APP_USER',
'                     and instr(developer_role||'':'',''ADMIN:'') > 0',
'                   union',
'                  select 1',
'                    from wwv_flow_fnd_user',
'                   where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                     and user_name = :APP_USER',
'                     and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))',
'order by LAST_UPDATED_ON desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(2251716882439710)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Saved SQL Found'
,p_query_num_rows_item=>'P1203_ROWS'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6415504466620655)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(158049613622816668)
,p_query_column_id=>2
,p_column_alias=>'QUERY_OWNER'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159619215751589324)
,p_query_column_id=>3
,p_column_alias=>'QTYPE'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(158049717816816670)
,p_query_column_id=>4
,p_column_alias=>'TITLE'
,p_column_display_sequence=>6
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'#LINK_URL#'
,p_column_linktext=>'#TITLE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(158049805684816670)
,p_query_column_id=>5
,p_column_alias=>'QB_SQL'
,p_column_display_sequence=>8
,p_column_heading=>'SQL'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(158049907140816670)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>7
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6415807384620655)
,p_query_column_id=>7
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>4
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(158050107364816670)
,p_query_column_id=>8
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(158050228739816670)
,p_query_column_id=>9
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>10
,p_column_heading=>'Updated By'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(158050326944816671)
,p_query_column_id=>10
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>11
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(158050425755816671)
,p_query_column_id=>11
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(423020317449535345)
,p_query_column_id=>12
,p_column_alias=>'LINK_URL'
,p_column_display_sequence=>13
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(159446531179807318)
,p_query_column_id=>13
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Delete'
,p_use_as_row_header=>'N'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159444003821799425)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159444115343799426)
,p_column_sequence=>2
,p_query_column_name=>'QUERY_OWNER'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159618306552589318)
,p_column_sequence=>3
,p_query_column_name=>'QTYPE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159444208693799426)
,p_column_sequence=>4
,p_query_column_name=>'TITLE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159444319711799426)
,p_column_sequence=>5
,p_query_column_name=>'QB_SQL'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159444406523799426)
,p_column_sequence=>6
,p_query_column_name=>'DESCRIPTION'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159444630169799427)
,p_column_sequence=>7
,p_query_column_name=>'CREATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159444723920799427)
,p_column_sequence=>8
,p_query_column_name=>'CREATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159444806816799427)
,p_column_sequence=>9
,p_query_column_name=>'LAST_UPDATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159444909486799427)
,p_column_sequence=>10
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(159445029183799427)
,p_column_sequence=>11
,p_query_column_name=>'SECURITY_GROUP_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(423020228600535343)
,p_column_sequence=>12
,p_query_column_name=>'LINK_URL'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(158079710730882097)
,p_plug_name=>'Page Item'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(158072826052867579)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(158079710730882097)
,p_button_name=>'GO'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT-BOTTOM'
,p_button_redirect_url=>'javascript:sc_getSavedSQL();'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(159470001406874413)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(158079710730882097)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:PPR_Tabluar_Submit(''R6415019707620645'',''4500'',''1203'',''DELETE'',true,''R6415019707620645'');'
,p_button_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SavedSQLHolder',
'',
'javascript:PPR_Tabluar_Submit(''R6415019707620645'',''4500'',''1203'',''DELETE'',true);',
'javascript:PPR_Tabluar_Submit(''SavedSQLHolder'',''4500'',''1203'',''DELETE'',true);'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6428713494666085)
,p_branch_action=>'f?p=&FLOW_ID.:1203:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6424513652656720)
,p_name=>'P1203_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(158079710730882097)
,p_item_default=>'&APP_USER.'
,p_prompt=>'Owner'
,p_source=>':APP_USER'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'QUERY_OWNERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r from (',
'select wwv_flow_escape.html(created_by) d, created_by r ',
'  from wwv_flow_qb_saved_query',
'where security_group_id = :flow_security_group_id',
'and exists (     ',
'select 1 ',
'from  wwv_flow_developers ',
'where security_group_id = :flow_security_group_id and ',
'      userid = :flow_user and ',
'      instr(developer_role||'':'',''ADMIN:'') > 0 ',
'union ',
'select 1 ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id ',
'and user_name = :flow_user ',
'and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')) ',
'union all  ',
'select v(''APP_USER'') d, v(''APP_USER'') r',
'FROM sys.DUAL) ',
'group by d,r',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Users -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the username to show.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6426331313661863)
,p_name=>'P1203_FIND'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(158079710730882097)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter query condition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7140916813154218)
,p_name=>'P1203_SAVE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(158079710730882097)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(161238102522892832)
,p_name=>'P1203_ROWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(158079710730882097)
,p_item_default=>'10'
,p_prompt=>'Rows'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cHeight=>1
,p_tag_attributes=>'style="min-width: 40px;"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(159468320668870516)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(6415019707620645)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'Delete'
,p_attribute_02=>'WWV_FLOW_QB_SAVED_QUERY'
,p_attribute_03=>'ID'
,p_process_error_message=>'Unable to remove Query row(s)'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Query row(s) removes'
,p_internal_uid=>159468320668870516
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(205718418307439419)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>205718418307439419
);
end;
/
prompt --application/pages/page_01204
begin
wwv_flow_imp_page.create_page(
 p_id=>1204
,p_name=>'SQL Command Download Report'
,p_alias=>'SC_DL_REPORT'
,p_step_title=>'SQL Command Download Report'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11539602725985552)
,p_step_template=>wwv_flow_imp.id(740688669716062470)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/obj_brows.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1287321922908833672)
,p_plug_name=>'Browser Language'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1287345129834835717)
,p_name=>'P1204_BROWSER_LANG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1287321922908833672)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(302540120808394071)
,p_process_sequence=>5
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1003_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1003_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>302540120808394071
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(204028208695700079)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'print report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sql               varchar2(32767);',
'    l_bind_names        sys.dbms_sql.varchar2_table;',
'    l_bind_values       wwv_flow_global.vc_arr2;',
'    l_parameters        wwv_flow_exec_api.t_parameters;',
'',
'    l_csv_charset       varchar2(255) := NULL;',
'    l_context           wwv_flow_exec.t_context;',
'    l_run               wwv_flow_data_export.t_run;',
'    l_csv               clob;',
'    l_blob              blob;',
'        ',
'begin',
'',
'    wwv_flow.g_browser_language := :P1204_BROWSER_LANG;',
'    wwv_flow_lang.alter_session(wwv_flow_lang.map_language(wwv_flow.g_browser_language));',
'    ',
'    wwv_flow_init_htp_buffer;',
'    wwv_flow.g_page_text_generated := true;',
'    wwv_flow.g_unrecoverable_error := true;',
'    ',
'    wwv_flow_utilities.print_download_header(',
'        p_mime_type     => ''text/plain'',',
'        p_file_name     => ''report.csv'',',
'        p_is_attachment => true );',
'  ',
'    sys.owa_util.http_header_close;',
'',
'    if wwv_flow_preferences.get_preference( p_preference => ''F4500_CSV_DOWNLOAD_UNICODE'' ) = ''Y'' then',
'      l_csv_charset := ''AL32UTF8'';',
'    else',
'      for c1 in (',
'          select csv_encoding, flow_language_derived_from',
'          from wwv_flows',
'          where id = wwv_flow.g_flow_id',
'      ) loop',
'          if c1.flow_language_derived_from <> ''0'' and nvl(c1.csv_encoding,''N'') = ''Y'' then',
'              l_csv_charset := wwv_flow_lang.get_nls_windows_charset;',
'          end if;',
'          exit;',
'      end loop;',
'    end if;',
'    ',
'    -- get the statement to run',
'    l_sql := :P1003_SQL_COMMAND2;',
'',
'    l_bind_names := wwv_flow_utilities.get_binds( l_sql );',
'',
'    -- get the binds values used last time if they exist',
'    l_bind_values := wwv_flow_utilities.string_to_table (',
'        str => :P1200_BIND_VALS,',
'        sep => '','');',
'',
'    for i in 1..l_bind_names.count loop',
'        if l_bind_values(i) != ''HTMLDB:NULL'' then',
'            wwv_flow_exec_api.add_parameter(',
'                p_parameters    => l_parameters,',
'                p_name          => l_bind_names(i),',
'                p_value         => l_bind_values(i) );',
'        end if;',
'    end loop;',
'',
'    wwv_flow_exec.open_query_context(',
'        p_context                   => l_context,',
'        p_location                  => wwv_flow_exec_api.c_location_local_db,',
'        p_query_type                => wwv_flow_exec_api.c_query_type_sql_query,',
'        p_sql_query                 => :P1003_SQL_COMMAND2,',
'        p_sql_parameters            => l_parameters,',
'        p_parse_as_schema_override  => :P1003_SCHEMA );',
'        ',
'    l_run := wwv_flow_data_export.run(',
'        p_context   => l_context,',
'        p_format    => wwv_flow_data_export_api.c_format_csv );',
'        ',
'    l_csv := wwv_flow_data_export.get_clob_output( p_run => l_run );',
'',
'    wwv_flow_exec.close_context( l_context );',
'',
'    if (l_csv_charset is not null) then',
'        ',
'        l_blob := wwv_flow_utilities.clob_to_blob( p_clob => l_csv, p_charset => l_csv_charset );',
'        ',
'        -- download the binary contents of the BLOB',
'        sys.wpg_docload.download_file( l_blob ); ',
'    ',
'        -- cleanup the temporary BLOB ',
'        sys.dbms_lob.freetemporary( l_blob );   ',
'        ',
'    else',
'        -- print the results',
'        htmldb_util.prn( l_csv );',
'',
'    end if;',
'',
'    -- cleanup the temporary CLOB     ',
'    sys.dbms_lob.freetemporary( l_csv );',
'    ',
'    wwv_flow.g_unrecoverable_error := true;',
'',
'exception',
'    when others then',
'        wwv_flow_exec.close_context( l_context );',
'        wwv_flow.g_unrecoverable_error := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error'
,p_process_success_message=>'ok'
,p_internal_uid=>204028208695700079
);
end;
/
prompt --application/pages/page_01220
begin
wwv_flow_imp_page.create_page(
 p_id=>1220
,p_name=>'Script Results'
,p_alias=>'SCRIPT-RESULTS'
,p_step_title=>'Manage Script Results'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467846201977971481)
,p_plug_name=>'Results'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with dr as',
'(select result_id,',
'        sum(result_size) the_sum',
'  from wwv_flow_sw_detail_results ',
' where security_group_id = :flow_security_group_id',
' group by result_id),',
'wv_lang as',
'    (select r.result_id,s.file_id,',
'            wwv_flow_lang.system_message(''FORM_OF'',r.cnt,s.cnt) the_msg,',
'            wwv_flow_lang.system_message(''FORM_OF'',r.cnt,r.cnt) the_msg2',
'      from',
'        (select file_id,count(distinct stmt_number) cnt',
'           from wwv_flow_sw_stmts',
'          where isrunnable = ''Y''',
'            and security_group_id = :flow_security_group_id',
'          group by file_id) s,',
'        (select result_id,file_id,count(*) cnt',
'           from wwv_flow_sw_detail_results',
'          where security_group_id = :flow_security_group_id',
'          group by result_id,file_id) r',
'     where s.file_id = r.file_id(+))',
'SELECT ',
'   r.id edit_script,',
'   r.id "ID", ',
'   r.file_id,',
'   r.file_id details,',
'   f.filename FILE_Name, ',
'   f.filename script_name,',
'   r.job_id "JOB_ID", ',
'   r.run_by "RUN_BY", ',
'   r.run_as run_as,',
'   the_sum output_size,  ',
'   r.started "STARTED", ',
'   r.ended "ENDED",    ',
'   (decode(sign(r.end_time-r.start_time),-1,24*60*60*(nvl(r.ended,sysdate) - r.started),r.end_time-r.start_time)/100) elapsed,',
'   decode(r.status,''EXECUTING'',',
'          sys.htf.anchor(''f?p=4500:1225:''||:app_session||''::::P1224_RESULT_ID:''||r.id,wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.EXECUTING'')),',
'   wwv_flow_escape.html(case when r.status = ''SUBMITTED'' then wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.SUBMITTED'') when r.status = ''EXECUTING'' then wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.EXECUTING'') when r.status = ''COMPLETE'' then w'
||'wv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.COMPLETED'') when r.status = ''CANCELED'' then wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.CANCELED'')  when r.status = ''CANCELING'' then wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.CANCELING'') end'
||')) status,',
'   r.run_comments "RUN_COMMENTS", ',
'   r.security_group_id "SECURITY_GROUP_ID",',
'   decode(r.status,''COMPLETE'',htmldb_item.checkbox(1,r.id,null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''DELETE_LABEL'', wwv_flow_escape.html(f.filename))),',
'          ''CANCELED'',htmldb_item.checkbox(1,r.id,null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''DELETE_LABEL'', wwv_flow_escape.html(f.filename))),',
'          null) purge,',
'    -- wv_lang.the_msg  statements,',
'    (select decode(r.status,''COMPLETE'',the_msg2,the_msg) from wv_lang where wv_lang.file_id = r.file_id and wv_lang.result_id = r.id) statements,',
'decode(r.status,''EXECUTING'',''Y'',''SUBMITTED'',''Y'',''N'') highlight_row',
'FROM ',
'   wwv_flow_sw_results r, wwv_flow_files f,dr',
'where r.file_id = f.id',
'  and dr.result_id(+) = r.id',
'  and r.security_group_id = :flow_security_group_id',
'  and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'       or exists ( select 1',
'                     from  wwv_flow_developers',
'                    where security_group_id = :flow_security_group_id',
'                      and userid = :APP_USER',
'                      and instr(developer_role||'':'',''ADMIN:'') > 0',
'                    union',
'                   select 1',
'                     from wwv_flow_fnd_user',
'                    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                      and user_name = :APP_USER',
'                      and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(467846302875971481)
,p_name=>'Results'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467848112067971525)
,p_db_column_name=>'PURGE'
,p_display_order=>1
,p_column_identifier=>'Q'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
,p_column_comment=>'<input type="checkbox" name="x01" value="1" onClick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467846507842971503)
,p_db_column_name=>'EDIT_SCRIPT'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Edit'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847028132971513)
,p_db_column_name=>'SCRIPT_NAME'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Script '
,p_column_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:#FILE_ID#'
,p_column_linktext=>'#SCRIPT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467846730134971505)
,p_db_column_name=>'FILE_ID'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Selected File'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847105887971514)
,p_db_column_name=>'JOB_ID'
,p_display_order=>5
,p_column_identifier=>'G'
,p_column_label=>'Job ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847212983971515)
,p_db_column_name=>'RUN_BY'
,p_display_order=>6
,p_column_identifier=>'H'
,p_column_label=>'Run By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847309666971516)
,p_db_column_name=>'RUN_AS'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Run As'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847502077971518)
,p_db_column_name=>'STARTED'
,p_display_order=>8
,p_column_identifier=>'K'
,p_column_label=>'Started'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847605493971519)
,p_db_column_name=>'ENDED'
,p_display_order=>9
,p_column_identifier=>'L'
,p_column_label=>'Finished'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847720961971520)
,p_db_column_name=>'ELAPSED'
,p_display_order=>10
,p_column_identifier=>'M'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847829876971521)
,p_db_column_name=>'STATUS'
,p_display_order=>11
,p_column_identifier=>'N'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847927845971522)
,p_db_column_name=>'RUN_COMMENTS'
,p_display_order=>12
,p_column_identifier=>'O'
,p_column_label=>'Run Comments'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467848014449971523)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>13
,p_column_identifier=>'P'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467846607473971504)
,p_db_column_name=>'ID'
,p_display_order=>14
,p_column_identifier=>'B'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467848206284971526)
,p_db_column_name=>'STATEMENTS'
,p_display_order=>15
,p_column_identifier=>'R'
,p_column_label=>'Statements'
,p_column_type=>'STRING'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467847424073971517)
,p_db_column_name=>'OUTPUT_SIZE'
,p_display_order=>16
,p_column_identifier=>'J'
,p_column_label=>'Bytes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467846906672971512)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>17
,p_column_identifier=>'E'
,p_column_label=>'Summary'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#htmldb/icons/copy_small.gif" border="0" alt="xxx">'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467846815659971511)
,p_db_column_name=>'DETAILS'
,p_display_order=>18
,p_column_identifier=>'D'
,p_column_label=>'View Results'
,p_column_link=>'f?p=&APP_ID.:1225:&SESSION.::&DEBUG.::P1224_RESULT_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-search"></span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467848316753971527)
,p_db_column_name=>'HIGHLIGHT_ROW'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'&nbsp;'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(467848523688971977)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1320009472536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PURGE:SCRIPT_NAME:RUN_BY:STARTED:ENDED:ELAPSED:STATUS:SECURITY_GROUP_ID:STATEMENTS:OUTPUT_SIZE:DETAILS:'
,p_sort_column_1=>'STARTED'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11250108787573812)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(467846201977971481)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_sw_results',
'where security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(10120023136690967)
,p_branch_action=>'1220'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(277455912402422805)
,p_name=>'P1220_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(467846201977971481)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1896404407400627)
,p_computation_sequence=>10
,p_computation_item=>'P1220_FILE_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1220_FIND'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11613201326226114)
,p_validation_name=>'must select output(s) to delete'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'No script output was selected'
,p_when_button_pressed=>wwv_flow_imp.id(11250108787573812)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199176160684878437)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(467846201977971481)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199176295390878438)
,p_event_id=>wwv_flow_imp.id(1199176160684878437)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10119807492690965)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'Refresh,GO'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>10119807492690965
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11611202449207579)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete output'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  delete from wwv_flow_sw_results',
'  where id = wwv_flow.g_f01(i)',
'  and security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete checked output.'
,p_process_when_button_id=>wwv_flow_imp.id(11250108787573812)
,p_process_success_message=>'Selected output deleted.'
,p_internal_uid=>11611202449207579
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(182280216628523464)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clean out orphan long ops'
,p_process_sql_clob=>'wwv_flow_sw_script.clean_out_orphan_long_op;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to cancel script that is not running.'
,p_process_when_type=>'NEVER'
,p_internal_uid=>182280216628523464
);
end;
/
prompt --application/pages/page_01225
begin
wwv_flow_imp_page.create_page(
 p_id=>1225
,p_name=>'Results'
,p_alias=>'RESULTS'
,p_step_title=>'Results'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>'<script src="#IMAGE_PREFIX#sc/sc_core.js" type="text/javascript"></script>'
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_rep.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11922008681959891)
,p_plug_name=>'Output'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_elapsed number := 0;',
'begin',
'  sys.htp.prn(''<span class="fielddata">'');',
'  sys.htp.prn(''<hr />'');',
'  for c1 in (select id, result_id, stmt_num, stmt_text, msg, result, ',
'                    started, start_time, ended, end_time, Result_Rows',
'             from wwv_flow_sw_detail_results',
'             where result_id = :p1224_result_id',
'             and security_group_id = :flow_security_group_id',
'             order by seq_id)',
'  loop',
'    -- statement',
'    if instr('':''||:P1225_VIEW_MODE||'':'','':STMT:'') > 0 then',
'      sys.htp.prn(''<pre>'');',
'      wwv_flow_sw_script.print_stmt(p_id => c1.id);',
'      sys.htp.prn(''</pre>'');',
'    end if;',
'  ',
'    -- results',
'    if instr('':''||:P1225_VIEW_MODE||'':'','':RESULTS:'') > 0 then',
'          sys.htp.prn(''<div class="htmldbScriptResult">'');',
'    	wwv_flow_sw_script.print_result(p_id => c1.id);',
'          sys.htp.prn(''</div>'');',
'    end if;',
'  ',
'    -- feedback',
'    if instr('':''||:P1225_VIEW_MODE||'':'','':MSG:'') > 0 then',
'      sys.htp.prn(''<br />'');',
'      sys.htp.prn(wwv_flow_escape.html(c1.msg));',
'    end if;',
'  ',
'    -- rows',
'    /*if instr('':''||:P1225_VIEW_MODE||'':'','':MSG:'') > 0 then',
'      if c1.result_rows is not null then',
'        if c1.result_rows = 1 then ',
'        	 sys.htp.prn(wwv_flow_lang.system_message(',
'        	          ''WWV_FLOW_SW_SCRIPT.RESULT_ROW'',',
'        	          to_char(c1.Result_Rows,''999G999G999G999G999G999G990'')',
'        	          ));                ',
'        else         ',
'           sys.htp.prn(wwv_flow_lang.system_message(',
'        	          ''WWV_FLOW_SW_SCRIPT.RESULT_ROWS'',',
'        	          to_char(c1.Result_Rows,''999G999G999G999G999G999G990'')',
'        	          ));',
'        end if;',
'      end if;',
'    end if;*/',
'  ',
'    -- elap time',
'    if instr('':''||:P1225_VIEW_MODE||'':'','':MSG:'') > 0 then ',
'      if sign(c1.end_time-c1.start_time) = -1 then',
'        l_elapsed := 24*60*60*(nvl(c1.ended,sysdate) - c1.started);',
'      else',
'        l_elapsed := c1.end_time-c1.start_time;',
'      end if;',
'      l_elapsed := l_elapsed/100;',
'      ',
'      -- don''t show elapsed time for result with errors',
'      if sys.dbms_lob.instr(c1.msg,''ORA-'',1,1) > 0 then',
'        l_elapsed := null;',
'      end if;',
'      ',
'      if l_elapsed is not null then',
'        sys.htp.prn('' ''||wwv_flow_lang.system_message(',
'                  ''WWV_FLOW_SW_SCRIPT.ELAPSED'',',
'                  to_char(l_elapsed,''999G999G999G999G990D00'')',
'                  ));',
'      end if;',
'    end if;',
'  ',
'    -- end of statement',
'    sys.htp.prn(''<hr />'');',
'  end loop;',
'  sys.htp.prn(''</span>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1225_VIEW'
,p_plug_display_when_cond2=>'DETAIL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11941610899045610)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(12089027223164064)
,p_name=>'Script Summary (Detail View)'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left; clear:both;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT ',
'   id edit_script,',
'   "ID" "ID", ',
'   file_id,',
'   file_id details,',
'   (select fileName from wwv_flow_files where id = r.file_id) FILE_Name, ',
'   (select fileName from wwv_flow_files where id = r.file_id) script_name,',
'   "JOB_ID" "JOB_ID", ',
'   "RUN_BY" "RUN_BY", ',
'   run_as run_as,',
'   "STARTED" "STARTED",',
'   started started2, ',
'   "ENDED" "ENDED", ',
'   decode(end_time,null,null,',
'   wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.ELAPSED'',to_char((decode(sign(end_time-start_time),-1,24*60*60*(nvl(ended,sysdate) - started),end_time-start_time)/100),''999G999G999G999G990D00''))) elapsed,',
'   status,',
'   "RUN_COMMENTS" "RUN_COMMENTS", ',
'   "SECURITY_GROUP_ID" "SECURITY_GROUP_ID",',
'   (select count(*) from wwv_flow_sw_detail_results where result_id = r.id) statements,',
'   wwv_flow_sw_script.get_success_cnt(:P1224_RESULT_ID) succesful,',
'   wwv_flow_sw_script.get_failure_cnt(:P1224_RESULT_ID) with_errors ',
'FROM ',
'   "WWV_FLOW_SW_RESULTS" r',
'where security_group_id = :flow_security_group_id',
'  and id = :P1224_RESULT_ID'))
,p_display_when_condition=>'P1225_VIEW'
,p_display_when_cond2=>'DETAIL'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1127586271702515372)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_exp_filename=>'scripts.csv'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12089224469164067)
,p_query_column_id=>1
,p_column_alias=>'EDIT_SCRIPT'
,p_column_display_sequence=>1
,p_column_heading=>'Edit Script'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12089301193164068)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12089405069164068)
,p_query_column_id=>3
,p_column_alias=>'FILE_ID'
,p_column_display_sequence=>3
,p_column_heading=>'File Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12089503956164068)
,p_query_column_id=>4
,p_column_alias=>'DETAILS'
,p_column_display_sequence=>4
,p_column_heading=>'Details'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12089625641164068)
,p_query_column_id=>5
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'File Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12089729410164068)
,p_query_column_id=>6
,p_column_alias=>'SCRIPT_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Script Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:#FILE_ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#ed-item.gif" border="0" alt="&EDIT.">#SCRIPT_NAME#'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12089814037164068)
,p_query_column_id=>7
,p_column_alias=>'JOB_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Job'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12089907680164068)
,p_query_column_id=>8
,p_column_alias=>'RUN_BY'
,p_column_display_sequence=>8
,p_column_heading=>'Run By'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12090009316164068)
,p_query_column_id=>9
,p_column_alias=>'RUN_AS'
,p_column_display_sequence=>9
,p_column_heading=>'Parsing Schema'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12090132705164069)
,p_query_column_id=>10
,p_column_alias=>'STARTED'
,p_column_display_sequence=>10
,p_column_heading=>'Script Started'
,p_use_as_row_header=>'N'
,p_column_format=>'&LONG_DATE_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(112578215367052286)
,p_query_column_id=>11
,p_column_alias=>'STARTED2'
,p_column_display_sequence=>11
,p_column_heading=>'<br />'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12090217850164069)
,p_query_column_id=>12
,p_column_alias=>'ENDED'
,p_column_display_sequence=>12
,p_column_heading=>'Script Ended'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12090310919164069)
,p_query_column_id=>13
,p_column_alias=>'ELAPSED'
,p_column_display_sequence=>13
,p_column_heading=>'Elapsed time'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16883519523407070)
,p_query_column_id=>14
,p_column_alias=>'STATUS'
,p_column_display_sequence=>14
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(16851103836270043)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12090506322164069)
,p_query_column_id=>15
,p_column_alias=>'RUN_COMMENTS'
,p_column_display_sequence=>16
,p_column_heading=>'Comments'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12090622401164069)
,p_query_column_id=>16
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>17
,p_column_heading=>'Security Group'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12094102120194661)
,p_query_column_id=>17
,p_column_alias=>'STATEMENTS'
,p_column_display_sequence=>15
,p_column_heading=>'Statements Processed'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(182182231491300604)
,p_query_column_id=>18
,p_column_alias=>'SUCCESFUL'
,p_column_display_sequence=>18
,p_column_heading=>'Successful'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(182182312450300604)
,p_query_column_id=>19
,p_column_alias=>'WITH_ERRORS'
,p_column_display_sequence=>19
,p_column_heading=>'With Errors'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(164053306541529880)
,p_name=>'Result Summary'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="float:left; clear:both;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'(decode(sign(end_time-start_time),-1,24*60*60*(nvl(ended,sysdate) - started),end_time-start_time)/100) elapsed,',
'sys.dbms_lob.substr(stmt_text,60,1) stmt,',
'sys.dbms_lob.substr(result,60,1) log,',
'nvl(msg,wwv_flow_lang.system_message(''WWV_FLOW_SW_SCRIPT.EXECUTING'')) msg,',
'result_rows rowcnt,',
'decode(nvl(sys.dbms_lob.getlength(result),0),0,null,',
'  sys.htf.anchor(''javascript:sc_callResultPopup(''''&SESSION.'''',''''''||id||'''''');'',',
'  wwv_flow_lang.system_message(''F4500_P1224_VIEW_OUTPUT''))) output',
'from wwv_flow_sw_detail_results',
'where result_id = :P1224_RESULT_ID',
'and security_group_id = :flow_security_group_id'))
,p_display_when_condition=>'P1225_VIEW'
,p_display_when_cond2=>'SUMMARY'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_footer=>'<p />'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_num_rows_item=>'P1225_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_exp_filename=>'results.csv'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164053523951529886)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Number'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164053615089529886)
,p_query_column_id=>2
,p_column_alias=>'ELAPSED'
,p_column_display_sequence=>2
,p_column_heading=>'Elapsed'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164054031009529886)
,p_query_column_id=>3
,p_column_alias=>'STMT'
,p_column_display_sequence=>3
,p_column_heading=>'Statement'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164053702812529886)
,p_query_column_id=>4
,p_column_alias=>'LOG'
,p_column_display_sequence=>4
,p_column_heading=>'Log'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164053916316529886)
,p_query_column_id=>5
,p_column_alias=>'MSG'
,p_column_display_sequence=>5
,p_column_heading=>'Feedback'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164053808466529886)
,p_query_column_id=>6
,p_column_alias=>'ROWCNT'
,p_column_display_sequence=>6
,p_column_heading=>'Rows'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164054105991529886)
,p_query_column_id=>7
,p_column_alias=>'OUTPUT'
,p_column_display_sequence=>7
,p_column_heading=>'Output'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(182075813896125294)
,p_name=>'Script Summary (Summary View)'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_region_attributes=>'style="float:left; clear:both;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) statements_processed, ',
'wwv_flow_sw_script.get_success_cnt(:P1224_RESULT_ID) succesful,',
'wwv_flow_sw_script.get_failure_cnt(:P1224_RESULT_ID) with_errors ',
'from wwv_flow_sw_detail_results where result_id = :P1224_RESULT_ID'))
,p_display_when_condition=>'P1225_VIEW'
,p_display_when_cond2=>'SUMMARY'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717423775712828084)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(182089208448180458)
,p_query_column_id=>1
,p_column_alias=>'STATEMENTS_PROCESSED'
,p_column_display_sequence=>1
,p_column_heading=>'Statements Processed'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(182178606211293375)
,p_query_column_id=>2
,p_column_alias=>'SUCCESFUL'
,p_column_display_sequence=>2
,p_column_heading=>'Successful'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(182090016067182690)
,p_query_column_id=>3
,p_column_alias=>'WITH_ERRORS'
,p_column_display_sequence=>3
,p_column_heading=>'With Errors'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11944332370051884)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_button_name=>'P1225_GO'
,p_button_static_id=>'P1225_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4212068580375544812)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_button_name=>'CREATE_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Create App'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:RP,20:P20_SCRIPT_FILE_ID,P20_SCHEMA:&P1225_FILE_ID.,&P1225_RUN_AS.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(467856212269044380)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_button_name=>'EDIT_SCRIPT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Edit Script'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:&P1225_FILE_ID.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11938414231037148)
,p_name=>'P1225_VIEW_MODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_prompt=>'Show:'
,p_source=>':STMT:MSG:ELAPSED:ROWS:RESULTS:'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SCRIPT_OUTPUT_VIEW_MODE'
,p_lov=>'.'||wwv_flow_imp.id(11936228645031897)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when=>'P1225_VIEW'
,p_display_when2=>'DETAIL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the type of output to be displayed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(82706511505738138)
,p_name=>'P1225_RUN_AS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select run_as',
'from wwv_flow_sw_results',
'where security_group_id = :flow_security_group_id',
'and id = :P1224_RESULT_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164056220178543294)
,p_name=>'P1225_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_prompt=>'Script:'
,p_post_element_text=>'&nbsp;&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  (select fileName from wwv_flow_files where id = r.file_id) script_name',
'FROM ',
'   "WWV_FLOW_SW_RESULTS" r',
'where security_group_id = :flow_security_group_id',
'  and id = :P1224_RESULT_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Name of the SQL script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164057801955547440)
,p_name=>'P1225_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_prompt=>'Status:'
,p_post_element_text=>'&nbsp;&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   status',
'FROM ',
'   "WWV_FLOW_SW_RESULTS" r',
'where security_group_id = :flow_security_group_id',
'  and id = :P1224_RESULT_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SCRIPT_RESULT_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(16851103836270043)||'.'
,p_cSize=>2
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'The status of the SQL script.  Use this status to determine if your script is running, or if it has completed execution.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164110808750890063)
,p_name=>'P1224_RESULT_ID'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164194224977256815)
,p_name=>'P1225_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_item_default=>'15'
,p_prompt=>'Rows'
,p_source=>'15'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_A'
,p_lov=>'.'||wwv_flow_imp.id(88005728392276151)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when=>'nvl(:P1225_VIEW,''SUMMARY'')=''SUMMARY'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the number of rows to display per page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164617423386419293)
,p_name=>'P1225_VIEW'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_item_default=>'SUMMARY'
,p_prompt=>'View:'
,p_source=>'SUMMARY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'VIEW_DETAIL_SUMMARY'
,p_lov=>'.'||wwv_flow_imp.id(183733207435875441)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Display a summary or a detailed view of your script results.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(245278829308900214)
,p_name=>'P1225_FILE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(11941610899045610)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_id',
'from wwv_flow_sw_results',
'where id = :P1224_RESULT_ID',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(856093801147711151)
,p_computation_sequence=>10
,p_computation_item=>'P1225_FILE_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_id',
'from wwv_flow_sw_results',
'where id = :P1224_RESULT_ID',
'and security_group_id = :flow_security_group_id'))
);
end;
/
prompt --application/pages/page_01350
begin
wwv_flow_imp_page.create_page(
 p_id=>1350
,p_name=>'Schema Comparison'
,p_alias=>'SCHEMA-COMPARISON'
,p_step_title=>'Schema Comparison'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_comp_schema.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14640703422583946)
,p_plug_name=>'Compare'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(14654103993650366)
,p_name=>'Results'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_type, object_name, table_name, ',
'       decode(schema1,0,null,''<span class="a-Icon icon-check"></span>'') schema1, ',
'       decode(schema2,0,null,''<span class="a-Icon icon-check"></span>'') schema2',
'from (',
'select',
'  ''TABLE.TRIGGER'' object_type,',
'  table_name object_name,',
'  TABLE_NAME||''.''||TRIGGER_NAME||''.''||TRIGGER_TYPE||''.''||',
'    TRIGGERING_EVENT||''.''||WHEN_CLAUSE||''.''||ACTION_TYPE table_name,',
'  sum(decode(OWNER,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(OWNER,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_triggers',
'where (OWNER = :P1350_SCHEMA_1 or OWNER = :P1350_SCHEMA_2) and',
'      TABLE_NAME not like ''BIN$%'' and',
'      TABLE_NAME not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(TABLE_NAME)||''.''||upper(trigger_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''TRIGGER'')',
'group by table_name, TABLE_NAME||''.''||TRIGGER_NAME||''.''||TRIGGER_TYPE||''.''||',
'    TRIGGERING_EVENT||''.''||WHEN_CLAUSE||''.''||ACTION_TYPE ',
'union all',
'select',
'  ''SEQUENCE'' object_type,',
'  sequence_name object_name,',
'  SEQUENCE_NAME||''.''||INCREMENT_BY||''.''||',
'    CYCLE_FLAG||''.''||ORDER_FLAG||''.''||CACHE_SIZE table_name,',
'  sum(decode(sequence_owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(sequence_owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_sequences',
'where (sequence_owner = :P1350_SCHEMA_1 or sequence_owner = :P1350_SCHEMA_2) and',
'      SEQUENCE_NAME not like ''BIN$%'' and',
'      SEQUENCE_NAME not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(SEQUENCE_NAME),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''SEQUENCE'')',
'group by sequence_name, SEQUENCE_NAME||''.''||INCREMENT_BY||''.''||CYCLE_FLAG||''.''||ORDER_FLAG||''.''||CACHE_SIZE',
'union all',
'select type object_type, ',
'       object_name,',
'       table_name, ',
'       sum(decode(owner,:P1350_SCHEMA_1,1,0)) schema1,',
'       sum(decode(owner,:P1350_SCHEMA_2,1,0)) schema2',
'from (',
'select type, name object_name, name||''.''||type||'' ''||t.l_lines||''=''||max(line)||'' ''||t.l_size||''=''||sum(length(text)) table_name, owner',
'from sys.dba_source s,',
'     (select wwv_flow_lang.system_message(''LINES'') l_lines,',
'             wwv_flow_lang.system_message(''SIZE'') l_size',
'      from sys.dual) t',
'where owner in (:P1350_SCHEMA_1,:P1350_SCHEMA_2) and',
'      name not like ''BIN$%'' and',
'      name not like ''DR$%'' and',
'      (:P1350_SEARCH is null or instr(upper(name),upper(:P1350_SEARCH))>0) and',
'      (:P1350_COMPARE = ''0'' or :P1350_COMPARE = type)',
'group by owner, name,type, t.l_lines, t.l_size ) plsql',
'group by type, object_name, table_name',
'union all',
'select',
'  ''TABLE'' object_type,',
'  t.table_name object_name,',
'  t.table_name,',
'  sum(decode(t.owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(t.owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_tables t',
'where (owner = :P1350_SCHEMA_1 or owner = :P1350_SCHEMA_2) and',
'      table_name not like ''BIN$%'' and',
'      table_name not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(table_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''TABLE'')',
'group by t.table_name',
'union all',
'select',
'  ''VIEW'' object_type,',
'  t.view_name object_name,',
'  t.view_name table_name,',
'  sum(decode(t.owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(t.owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_views t',
'where (owner = :P1350_SCHEMA_1 or owner = :P1350_SCHEMA_2) and',
'      view_name not like ''BIN$%'' and',
'      view_name not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(view_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''VIEW'')',
'group by t.view_name',
'union all',
'select',
'  ''TABLE.COLUMN'' object_type,',
'  t.table_name||''.''||t.column_name object_name,',
'  t.table_name||''.''||t.column_name table_name,',
'  sum(decode(t.owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(t.owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_tab_columns t',
'where (owner = :P1350_SCHEMA_1 or owner = :P1350_SCHEMA_2) and',
'      table_name not like ''BIN$%'' and',
'      table_name not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(table_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''COLUMN'')',
'group by t.table_name||''.''||t.column_name',
'union all',
'select',
'  ''TABLE.COLUMN.DATATYPE'' object_type,',
'  t.table_name||''.''||t.column_name||''.''||data_type object_name,',
'  t.table_name||''.''||t.column_name||''.''||data_type||''.''||',
'   data_length||''.''||data_scale||''.''||DATA_PRECISION||''.''||nullable table_name,',
'  sum(decode(t.owner,:P1350_SCHEMA_1,1,0)) schema1,',
'  sum(decode(t.owner,:P1350_SCHEMA_2,1,0)) schema2',
'from sys.dba_tab_columns t',
'where (owner = :P1350_SCHEMA_1 or owner = :P1350_SCHEMA_2) and',
'      table_name not like ''BIN$%'' and',
'      table_name not like ''DR$%'' and',
'(:P1350_SEARCH is null or instr(upper(table_name),upper(:P1350_SEARCH))>0) and',
'(:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''DATATYPE'')',
'group by t.table_name||''.''||t.column_name||''.''||data_type,',
'         t.table_name||''.''||t.column_name||''.''||data_type||''.''||',
'          data_length||''.''||data_scale||''.''||DATA_PRECISION||''.''||nullable',
'union all',
'select ''TABLE.INDEX'' object_type,',
'       object_name,',
'       table_name,',
'       sum(decode(table_owner,:P1350_SCHEMA_1,1,0)) schema1,',
'       sum(decode(table_owner,:P1350_SCHEMA_2,1,0)) schema2',
'from (',
'    select table_owner,',
'           table_name||'' ''||uniqueness||'' (''||',
'           max(decode(position,1 ,column_name))||',
'           max(decode(position,2 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,3 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,4 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,5 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,6 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,7 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,8 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,9 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,10,'',''||substr(column_name,1,128)))||'')''',
'           object_name,',
'           table_name||''.''||',
'           decode(substr(index_name,1,4),''SYS_'',''SYS'',index_name',
'           )||''.''||uniqueness||'':''||',
'           max(decode(position,1 ,column_name))||',
'           max(decode(position,2 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,3 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,4 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,5 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,6 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,7 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,8 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,9 ,'',''||substr(column_name,1,128)))||',
'           max(decode(position,10,'',''||substr(column_name,1,128)))',
'           table_name',
'     from(',
'        select dc.table_name, dc.table_owner,dc.index_name,di.uniqueness, di.status,',
'               di.index_type, di.temporary, di.partitioned,di.funcidx_status, di.join_index,',
'               dc.column_name,dc.column_position position',
'          from sys.dba_ind_columns dc,sys.dba_indexes di',
'         where dc.table_owner in (:P1350_SCHEMA_1,:P1350_SCHEMA_2)',
'           and dc.table_name not like ''BIN$%''',
'           and dc.table_name not like ''DR$%''',
'           and dc.index_name = di.index_name',
'           and dc.index_owner = di.owner ',
'           and (:P1350_SEARCH is null or instr(upper(dc.table_name),upper(:P1350_SEARCH))>0)',
'           and (:P1350_COMPARE = ''0'' or :P1350_COMPARE = ''INDEX'')',
'           )',
'    group by table_name,table_owner,index_name,uniqueness, status,',
'             index_type, temporary, partitioned,funcidx_status, join_index',
') idx',
'group by object_name, table_name)',
'full_query',
'where (',
'      nvl(:P1350_SHOW_DELTA,''N'')=''N'' or ',
'      (nvl(:P1350_SHOW_DELTA,''N'')=''Y'' and schema1 != schema2)',
'      )',
'order by 1, 2'))
,p_display_when_condition=>'nvl(:P1350_SCHEMA_1,''0'') != ''0'' and nvl(:P1350_SCHEMA_2,''0'') != ''0'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_item=>'P1350_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'Y'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Print'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width_units=>'PERCENTAGE'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'&PRODUCT_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
,p_sort_null=>'F'
,p_plug_query_exp_filename=>'schemacompare.csv'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14722611958002774)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Object Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20432031610471969)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P1350_SEARCH.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14654425108650367)
,p_query_column_id=>3
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Details'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P1350_SEARCH.'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P1350_SHOW_DETAILS'
,p_display_when_condition2=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14710629254856310)
,p_query_column_id=>4
,p_column_alias=>'SCHEMA1'
,p_column_display_sequence=>4
,p_column_heading=>'Schema 1'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14710719432856310)
,p_query_column_id=>5
,p_column_alias=>'SCHEMA2'
,p_column_display_sequence=>5
,p_column_heading=>'Schema 2'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_include_in_export=>'Y'
,p_print_col_width=>'19'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14649315374625282)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(14640703422583946)
,p_button_name=>'P1350_GO'
,p_button_static_id=>'P1350_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Compare'
,p_button_position=>'NEXT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14649526303625283)
,p_branch_action=>'f?p=&FLOW_ID.:1350:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14644528141600532)
,p_name=>'P1350_SCHEMA_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(14640703422583946)
,p_prompt=>'Schema 1'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select a schema to compare from a list based on the schemas available to your workspace.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14646929311610356)
,p_name=>'P1350_SCHEMA_2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(14640703422583946)
,p_prompt=>'Schema 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select a schema to compare from a list based on the schemas available to your workspace.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14648208102623119)
,p_name=>'P1350_COMPARE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(14640703422583946)
,p_prompt=>'Compare'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SCHEMA COMPARE CATEGORIES'
,p_lov=>'.'||wwv_flow_imp.id(14728126072025797)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the database object type to compare and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14651704770631707)
,p_name=>'P1350_SEARCH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(14640703422583946)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>15
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'To search for an object, enter a case insensitive name and click <strong>Go</strong>. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14843209188019369)
,p_name=>'P1350_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(14640703422583946)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_B'
,p_lov=>'.'||wwv_flow_imp.id(88008910861280555)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>'P1300_VIEW'
,p_display_when2=>'TREE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the number of rows to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14846617284031121)
,p_name=>'P1350_SHOW_DELTA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(14640703422583946)
,p_prompt=>'Show Differences Only'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20434508323484132)
,p_name=>'P1350_SHOW_DETAILS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(14640703422583946)
,p_prompt=>'Show Details'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(14741310928078139)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>14741310928078139
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(14973521034728897)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P1350_SCHEMA_1,''0'') != ''0'' then',
'wwv_flow_sw_api.check_priv(:P1350_SCHEMA_1);',
'end if;',
'if nvl(:P1350_SCHEMA_2,''0'') != ''0'' then',
'wwv_flow_sw_api.check_priv(:P1350_SCHEMA_2);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>14973521034728897
);
end;
/
prompt --application/pages/page_01401
begin
wwv_flow_imp_page.create_page(
 p_id=>1401
,p_name=>'Object Grants'
,p_alias=>'OBJECT-GRANTS'
,p_step_title=>'Object Grants'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276009919979760075)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_sec.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8930331192104360)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19407804003066810)
,p_plug_name=>'All Tab Privs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'GRANTOR,',
'GRANTEE,',
'TABLE_NAME,',
'PRIVILEGE,',
'GRANTABLE',
'from sys.user_tab_privs',
'where',
'(grantor = :P1401_SCHEMA or grantee = :P1401_SCHEMA) '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1401_SCHEMA'
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'P1401_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(19407932308066810)
,p_name=>'All Tab Privs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19408129440066938)
,p_db_column_name=>'GRANTOR'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Grantor'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19408221393066943)
,p_db_column_name=>'GRANTEE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Grantee'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19408332550066943)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19408400366066943)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Privilege'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(19408502099066944)
,p_db_column_name=>'GRANTABLE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Grantable'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(19408702026067106)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1320127947536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'GRANTOR:GRANTEE:TABLE_NAME:PRIVILEGE:GRANTABLE'
,p_sort_column_1=>'GRANTOR'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'GRANTEE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'TABLE_NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722740039977798628)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(19407804003066810)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8938919971162017)
,p_branch_action=>'f?p=&FLOW_ID.:1401:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8931603403115248)
,p_name=>'P1401_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8930331192104360)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select the database schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112221103801863163)
,p_computation_sequence=>10
,p_computation_item=>'P1401_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1401_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69232127357694165)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1401_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_process_when=>'P1401_SCHEMA'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_internal_uid=>69232127357694165
);
end;
/
prompt --application/pages/page_01402
begin
wwv_flow_imp_page.create_page(
 p_id=>1402
,p_name=>'Column Privileges'
,p_alias=>'COLUMN-PRIVILEGES'
,p_step_title=>'Column Privileges'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_sec.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28377513056022881)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441212808045963738)
,p_plug_name=>'All Col Privs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select grantor,',
'       grantee,',
'       table_name,',
'       column_name,',
'       privilege,',
'       grantable',
'  from sys.user_col_privs',
' where grantor = :P1402_SCHEMA',
'    or grantee = :P1402_SCHEMA'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1402_SCHEMA'
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'P1402_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441212915505963738)
,p_name=>'All Col Privs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441213128313963754)
,p_db_column_name=>'GRANTOR'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Grantor'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441213207272963755)
,p_db_column_name=>'GRANTEE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Grantee'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441213321567963755)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441213431235963756)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Column Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441213531369963757)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Privilege'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441213628578963758)
,p_db_column_name=>'GRANTABLE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Grantable'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441213907129965009)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1320223528536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'GRANTOR:GRANTEE:TABLE_NAME:COLUMN_NAME:PRIVILEGE:GRANTABLE'
,p_sort_column_1=>'GRANTOR'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'GRANTEE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'TABLE_NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722739928414798627)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(441212808045963738)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28429512607240356)
,p_branch_action=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28300321967968632)
,p_name=>'P1402_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(28377513056022881)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select the database schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112226723325878216)
,p_computation_sequence=>10
,p_computation_item=>'P1402_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1402_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28427427020235094)
,p_process_sequence=>99
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>28427427020235094
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69234508441698183)
,p_process_sequence=>109
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1402_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_process_when=>'P1402_SCHEMA'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_internal_uid=>69234508441698183
);
end;
/
prompt --application/pages/page_01404
begin
wwv_flow_imp_page.create_page(
 p_id=>1404
,p_name=>'System Privileges'
,p_alias=>'SYSTEM-PRIVILEGES'
,p_step_title=>'System Privileges'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276009919979760075)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_sec.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30630307037341820)
,p_plug_name=>'User Sys Privs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username grantee, privilege, admin_option ',
'  from sys.user_sys_privs ',
' where username = :P1404_SCHEMA'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1404_SCHEMA'
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'P1404_SCHEMA'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(30630407492341820)
,p_name=>'User Sys Privs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30630625932341868)
,p_db_column_name=>'GRANTEE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Grantee'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30630716656341874)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Privilege'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30630808201341874)
,p_db_column_name=>'ADMIN_OPTION'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Admin Option'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(30631131556342806)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1320331786536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'GRANTEE:PRIVILEGE:ADMIN_OPTION'
,p_sort_column_1=>'GRANTEE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PRIVILEGE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150985103138335771)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722739709913798625)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(30630307037341820)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(150987612640335791)
,p_branch_action=>'f?p=&APP_ID.:1404:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150985502980335774)
,p_name=>'P1404_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(150985103138335771)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select the database schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(150987232512335786)
,p_computation_sequence=>10
,p_computation_item=>'P1404_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1404_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69255828405770104)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1404_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Validate Schema'
,p_process_when=>'P1404_SCHEMA'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_internal_uid=>69255828405770104
);
end;
/
prompt --application/pages/page_01502
begin
wwv_flow_imp_page.create_page(
 p_id=>1502
,p_name=>'Role Privileges'
,p_alias=>'ROLE-PRIVILEGES'
,p_step_title=>'Role Privileges'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(276009919979760075)
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEUTL/sql_utl_sec.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8974807332440625)
,p_plug_name=>'schema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(441216315087051564)
,p_plug_name=>'Role Privileges'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'username GRANTEE,',
'GRANTED_ROLE,',
'ADMIN_OPTION,',
'DEFAULT_ROLE',
'from sys.USER_ROLE_PRIVS',
'where username = :P1502_schema'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P1502_SCHEMA'
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'P1502_schema'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(441216418813051564)
,p_name=>'Role Privileges'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441216721271051571)
,p_db_column_name=>'GRANTED_ROLE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Granted Role'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441216829439051572)
,p_db_column_name=>'ADMIN_OPTION'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Administration Option'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441216900766051573)
,p_db_column_name=>'DEFAULT_ROLE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Default Role'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(441216616979051570)
,p_db_column_name=>'GRANTEE'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>'Grantee'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(441217525277055383)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1320411997536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'GRANTED_ROLE:ADMIN_OPTION:DEFAULT_ROLE:GRANTEE'
,p_sort_column_1=>'GRANTED_ROLE'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(722739854916798626)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(441216315087051564)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RP,RIR,&APP_PAGE_ID.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(138867815025815665)
,p_branch_action=>'f?p=&APP_ID.:1502:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8976932612447907)
,p_name=>'P1502_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8974807332440625)
,p_item_default=>'wwv_flow_user_api.get_default_schema'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Schema -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select the database schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(69251110828746190)
,p_computation_sequence=>10
,p_computation_item=>'P1502_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_user_api.get_default_schema'
,p_compute_when=>'P1502_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(69249227319741483)
,p_process_sequence=>109
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P1502_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema'
,p_process_when=>'P1502_schema'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_internal_uid=>69249227319741483
);
end;
/
prompt --application/pages/page_02000
begin
wwv_flow_imp_page.create_page(
 p_id=>2000
,p_name=>'Object Browser'
,p_alias=>'OB'
,p_step_title=>'Object Browser'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.recordView#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.treeView#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.toolbar#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.splitter#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4500_p2000#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserDialogs#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserConfig#MIN#.js',
'[require requirejs]#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#widget.codeEditor#MIN#.js'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var gAjaxIdentifiers = {},',
'    gObjectsCache = {};',
'',
'/* this should be done as soon as possible after f4500_p2000.js is loaded',
' * after ready needed because actions are created */',
'$(() => {',
'  apex.jQuery(".a-Body, .a-Main").addClass("resize");',
'  apex.theme.pageResizeInit();',
'  objectBrowser.initialize({',
'    // saved session state if kept on server',
'    treeRegionId: "objectsTree",',
'    treeAjaxIdentifier: gAjaxIdentifiers.objectTree,',
'    gridRegionId: "objectsData",',
'    gridAjaxIdentifier: gAjaxIdentifiers.objectData,',
'    codeRegionId: "objectsCode",',
'    codeAjaxIdentifier: gAjaxIdentifiers.objectCode,',
'    cachedIds: gObjectsCache,',
'    links: gActionLinks,',
'    preferences: gPreferences',
'  });',
'});'))
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1456031401486703)
,p_plug_name=>'AI Hook'
,p_plug_display_sequence=>190
,p_location=>null
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.AI_HOOK'
,p_ai_system_prompt=>'APEX$CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ai_key', 'codeEditor')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'*** Do not remove *** ',
'This region is necessary for the AI Chat feature in the code editors.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1901781580041201)
,p_plug_name=>'Object Browser'
,p_region_name=>'obMainSplitter'
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', '#obMainSplitter',
  'attribute_02', 'horizontal',
  'attribute_03', 'begin',
  'attribute_04', '280',
  'attribute_05', 'N',
  'attribute_08', '200',
  'attribute_09', 'Y',
  'attribute_12', 'Left Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'Y',
  'attribute_15', 'N',
  'attribute_16', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1901835854041202)
,p_plug_name=>'Main'
,p_region_name=>'obMain'
,p_parent_plug_id=>wwv_flow_imp.id(1901781580041201)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1801915102652129)
,p_plug_name=>'obObjectDoc'
,p_region_name=>'obObjectDoc'
,p_parent_plug_id=>wwv_flow_imp.id(1901835854041202)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;" aria-labelledby="obObjectDocLabel obObjectDocStatus" role="region"'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1802052772652130)
,p_plug_name=>'obObjectDocTitle'
,p_region_name=>'obObjectDocTitle'
,p_parent_plug_id=>wwv_flow_imp.id(1801915102652129)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header class="b-OB-docHeader">',
'  <span class="b-OB-docHeader-icon"></span>',
'  <div class="b-OB-docHeader-title">',
'    <div id="obObjectDocLabel" class="b-OB-docHeader-label"></div>',
'    <div class="b-OB-docHeader-status" aria-hidden="true">',
'      <span class="a-Icon icon-warning"></span>',
'      <span id="obObjectDocStatus">&"APP_TEXT$OB.INVALID"!HTML.</span>',
'    </div>',
'  </div>',
'</header>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1802129041652131)
,p_plug_name=>'obObjectDocBody'
,p_region_name=>'obObjectDocBody'
,p_parent_plug_id=>wwv_flow_imp.id(1801915102652129)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1802233306652132)
,p_plug_name=>'obObjectDocToolbar'
,p_region_name=>'obObjectDocToolbar'
,p_parent_plug_id=>wwv_flow_imp.id(1801915102652129)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1832055515569920)
,p_plug_name=>'obObjectDocTabs'
,p_region_name=>'obObjectDocTabs'
,p_parent_plug_id=>wwv_flow_imp.id(1801915102652129)
,p_region_css_classes=>'a-Tabs-toolbar a-Toolbar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1802381615652133)
,p_plug_name=>'Create Database Objects'
,p_region_name=>'obObjectDocCreate'
,p_parent_plug_id=>wwv_flow_imp.id(1901835854041202)
,p_region_css_classes=>'b-OB-CreateObjects'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<h2>Create Database Objects</h2>'
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1604753994038302)
,p_name=>'Create Other Database Objects'
,p_parent_plug_id=>wwv_flow_imp.id(1802381615652133)
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>20
,p_region_sub_css_classes=>'b-OB-Cards--mini'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_dev.get_create_obj_cards_query (',
'    p_type => ''OTHER'' );'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1449172575682074)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1604871565038303)
,p_query_column_id=>1
,p_column_alias=>'CARD_TITLE'
,p_column_display_sequence=>10
,p_column_heading=>'Card Title'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1605086810038305)
,p_query_column_id=>2
,p_column_alias=>'CARD_TEXT'
,p_column_display_sequence=>30
,p_column_heading=>'Card Text'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1604952511038304)
,p_query_column_id=>3
,p_column_alias=>'CARD_ICON'
,p_column_display_sequence=>20
,p_column_heading=>'Card Icon'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1605105915038306)
,p_query_column_id=>4
,p_column_alias=>'CARD_LINK'
,p_column_display_sequence=>40
,p_column_heading=>'Card Link'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1831421373569914)
,p_name=>'Create Database Objects'
,p_parent_plug_id=>wwv_flow_imp.id(1802381615652133)
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_dev.get_create_obj_cards_query (',
'    p_type => ''MAIN'' );'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1449172575682074)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1831541954569915)
,p_query_column_id=>1
,p_column_alias=>'CARD_TITLE'
,p_column_display_sequence=>10
,p_column_heading=>'Card Title'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1831799419569917)
,p_query_column_id=>2
,p_column_alias=>'CARD_TEXT'
,p_column_display_sequence=>30
,p_column_heading=>'Card Text'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1831654444569916)
,p_query_column_id=>3
,p_column_alias=>'CARD_ICON'
,p_column_display_sequence=>20
,p_column_heading=>'Card Icon'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1831869855569918)
,p_query_column_id=>4
,p_column_alias=>'CARD_LINK'
,p_column_display_sequence=>40
,p_column_heading=>'Card Link'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2100410857955801)
,p_plug_name=>'Sidebar'
,p_parent_plug_id=>wwv_flow_imp.id(1901781580041201)
,p_region_css_classes=>'b-OB-Sidebar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Objects'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1903409317683002)
,p_plug_name=>'Objects Tree Container'
,p_region_name=>'objectsTreeContainer'
,p_parent_plug_id=>wwv_flow_imp.id(2100410857955801)
,p_region_css_classes=>'a-ObjectBrowser-treeWrap resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1903502675683003)
,p_plug_name=>'Objects Tree'
,p_region_name=>'objectsTree'
,p_parent_plug_id=>wwv_flow_imp.id(1903409317683002)
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'aria-label="&"APP_TEXT$OB.OBJECTS"!ATTR."'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1940376569723402)
,p_plug_name=>'Sidebar Header'
,p_region_name=>'obLeftHeader'
,p_parent_plug_id=>wwv_flow_imp.id(2100410857955801)
,p_region_css_classes=>'b-OB-Sidebar-header'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1940286357723401)
,p_plug_name=>'Context Menu'
,p_parent_plug_id=>wwv_flow_imp.id(1940376569723402)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2100515267955802)
,p_plug_name=>'Object Search'
,p_parent_plug_id=>wwv_flow_imp.id(1940376569723402)
,p_region_css_classes=>'b-OB-Search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2101478706955811)
,p_plug_name=>'Tree Menu'
,p_region_name=>'objectsTreeMenu'
,p_parent_plug_id=>wwv_flow_imp.id(2100410857955801)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'js-addActions'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(1600109635671564)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2713351357867402)
,p_plug_name=>'Create Menu'
,p_region_name=>'objectsCreateMenu'
,p_parent_plug_id=>wwv_flow_imp.id(2100410857955801)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'js-addActions'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(2686914575823204)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1903304059683001)
,p_plug_name=>'Object Browser Plug-ins Container'
,p_plug_display_sequence=>50
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1902145140041205)
,p_plug_name=>'Fetch ObjectsTree'
,p_parent_plug_id=>wwv_flow_imp.id(1903304059683001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_OBJECT_BROWSER'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_02', 'wwv_flow_f4500_ob_dev.ajax',
  'attribute_03', 'gAjaxIdentifiers.objectTree')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1902316528041207)
,p_plug_name=>'Fetch Object Code'
,p_parent_plug_id=>wwv_flow_imp.id(1903304059683001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_OBJECT_BROWSER'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_02', 'wwv_flow_f4500_ob_dev.ajax',
  'attribute_03', 'gAjaxIdentifiers.objectCode')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1902722257041211)
,p_plug_name=>'Emit Globals'
,p_parent_plug_id=>wwv_flow_imp.id(1903304059683001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_OBJECT_BROWSER'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'wwv_flow_f4500_ob_dev.emit_globals')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2101022726955807)
,p_plug_name=>'Fetch Object Data'
,p_parent_plug_id=>wwv_flow_imp.id(1903304059683001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_OBJECT_BROWSER'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_02', 'wwv_flow_f4500_ob_dev.ajax',
  'attribute_03', 'gAjaxIdentifiers.objectData')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4144493613273661)
,p_plug_name=>'Template: SQL Preview'
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<template id="sqlPreviewRegion">',
'  <div class="a-Region a-Region--noBottomBorder">',
'    <div class="a-Region-header">',
'      <div class="a-Region-headerItems a-Region-headerItems--title">',
'        <h2 class="a-Region-title">SQL</h2>',
'      </div>',
'      <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'        <button class="a-Button a-Button--iconTextButton a-Button--iconLeft a-Button--noUI js-copy" aria-label="&"APP_TEXT$OB.ACTION_COPY"." type="button" title="&"APP_TEXT$OB.ACTION_COPY"."><span class="a-Icon icon-copy" aria-hidden="true"></span>&"'
||'APP_TEXT$OB.ACTION_COPY".</button>',
'      </div>',
'    </div>',
'    <div class="a-Region-body">',
'      <div class="preview">',
'        <pre><code class="previewSQL lang-sql"></code></pre>',
'      </div>',
'      <div class="previewMessage">&"APP_TEXT$OB.NO_SQL".</div>',
'    </div>',
'  </div>',
'</template>'))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8602521523781405)
,p_plug_name=>'Inline Dialogs'
,p_plug_display_sequence=>180
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2121980975504704)
,p_plug_name=>'Add/Modify Column'
,p_region_name=>'dialogAddModCol'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_region_attributes=>'data-bind-cursor="cursorAddModCol"'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>80
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1799148713652101)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(2121980975504704)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>220
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17611363158567018)
,p_plug_name=>'Column Details'
,p_parent_plug_id=>wwv_flow_imp.id(2121980975504704)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8393648552553316)
,p_plug_name=>'Data Redaction'
,p_parent_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717419046555820782)
,p_plug_display_sequence=>180
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from sys.dba_tab_privs ',
' where privilege = ''EXECUTE'' ',
'   and table_name = ''DBMS_REDACT'' ',
'   and grantee = :P2000_ADDMODCOL_DLG_OWNER'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2122580640504710)
,p_plug_name=>'Drop/Rename Column'
,p_region_name=>'dialogDropRenameCol'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_region_attributes=>'data-bind-cursor="cursorDropRenameCol"'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>90
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1799305142652103)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(2122580640504710)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>90
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17611138850567016)
,p_plug_name=>'Column Details'
,p_parent_plug_id=>wwv_flow_imp.id(2122580640504710)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2123071594504715)
,p_plug_name=>'Rename Table'
,p_region_name=>'dialogRenameTable'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>100
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1799413420652104)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(2123071594504715)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>90
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17611485960567019)
,p_plug_name=>'Table Details'
,p_parent_plug_id=>wwv_flow_imp.id(2123071594504715)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2123401549504719)
,p_plug_name=>'Comment'
,p_region_name=>'dialogComment'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_region_attributes=>'data-bind-cursor="cursorComment"'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>110
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1799595804652105)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(2123401549504719)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>110
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17611528077567020)
,p_plug_name=>'Comment Details'
,p_parent_plug_id=>wwv_flow_imp.id(2123401549504719)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2123868803504723)
,p_plug_name=>'Copy Table'
,p_region_name=>'dialogCopyTable'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>120
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1799626678652106)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(2123868803504723)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>160
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17611693044567021)
,p_plug_name=>'Table Details'
,p_parent_plug_id=>wwv_flow_imp.id(2123868803504723)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2124914061504734)
,p_plug_name=>'Truncate Table'
,p_region_name=>'dialogTruncateTable'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>130
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1799782365652107)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(2124914061504734)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>100
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17611750887567022)
,p_plug_name=>'Table Details'
,p_parent_plug_id=>wwv_flow_imp.id(2124914061504734)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2125241088504737)
,p_plug_name=>'Drop Constraint'
,p_region_name=>'dialogDropConstraint'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>150
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1799922363652109)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(2125241088504737)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>130
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17611937239567024)
,p_plug_name=>'Constraint Details'
,p_parent_plug_id=>wwv_flow_imp.id(2125241088504737)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2125673932504741)
,p_plug_name=>'%0 Constraint'
,p_region_name=>'dialogEnDisConstraint'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>230
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800728366652117)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(2125673932504741)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>140
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612730192567032)
,p_plug_name=>'Constraint Details'
,p_parent_plug_id=>wwv_flow_imp.id(2125673932504741)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2126430048504749)
,p_plug_name=>'Columns'
,p_region_name=>'dialogColumns'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>140
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1799877730652108)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(2126430048504749)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>120
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17611860981567023)
,p_plug_name=>'Column Details'
,p_parent_plug_id=>wwv_flow_imp.id(2126430048504749)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4143722710277153)
,p_plug_name=>'Drop'
,p_region_name=>'dialogDropObject'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>70
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1799281303652102)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(4143722710277153)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>60
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17611288055567017)
,p_plug_name=>'Object Details'
,p_parent_plug_id=>wwv_flow_imp.id(4143722710277153)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5803927624163309)
,p_plug_name=>'Edit Data'
,p_region_name=>'dialogRowEdit'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>290
,p_plug_source=>'<div id="editDataForm"></div>'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7015821948648502)
,p_plug_name=>'Drop Trigger'
,p_region_name=>'dialogDropTrigger'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>220
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800647215652116)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(7015821948648502)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>150
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612617281567031)
,p_plug_name=>'Trigger Details'
,p_parent_plug_id=>wwv_flow_imp.id(7015821948648502)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7016819747648512)
,p_plug_name=>'%0 Trigger'
,p_region_name=>'dialogEnDisTrigger'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>240
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800831676652118)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(7016819747648512)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>150
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612812375567033)
,p_plug_name=>'Trigger Details'
,p_parent_plug_id=>wwv_flow_imp.id(7016819747648512)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7017534107648519)
,p_plug_name=>'Create Constraint'
,p_region_name=>'dialogAddConstraint'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>260
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1801094462652120)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(7017534107648519)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>410
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17613001441567035)
,p_plug_name=>'Constraint Details'
,p_parent_plug_id=>wwv_flow_imp.id(7017534107648519)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7018078706648524)
,p_plug_name=>'Filters'
,p_region_name=>'dialogFilter'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog js-dialog-class-b-OB-Dialog--filters'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_region_attributes=>'data-bind-model="FilterModel"'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>280
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1802646754652136)
,p_plug_name=>'Filter Rows'
,p_parent_plug_id=>wwv_flow_imp.id(7018078706648524)
,p_region_css_classes=>'b-OB-addFilters'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1802429312652134)
,p_plug_name=>'Filter Row'
,p_parent_plug_id=>wwv_flow_imp.id(1802646754652136)
,p_region_css_classes=>'b-OB-addFilter'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7018622609648530)
,p_plug_name=>'Actions'
,p_parent_plug_id=>wwv_flow_imp.id(7018078706648524)
,p_region_css_classes=>'b-OB-addFilters-add '
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7019158593648535)
,p_plug_name=>'Drop SODA Collection'
,p_region_name=>'dialogDropSODA'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>170
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800158964652111)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(7019158593648535)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>130
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612186242567026)
,p_plug_name=>'SODA Collection Details'
,p_parent_plug_id=>wwv_flow_imp.id(7019158593648535)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7019662830648540)
,p_plug_name=>'Create Search Index'
,p_region_name=>'dialogSODAIndex'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>180
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800297074652112)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(7019662830648540)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>150
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612214728567027)
,p_plug_name=>'Search Index Details'
,p_parent_plug_id=>wwv_flow_imp.id(7019662830648540)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7020286968648546)
,p_plug_name=>'Create Relational View'
,p_region_name=>'dialogSODAView'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>210
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800534188652115)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(7020286968648546)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>180
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612579071567030)
,p_plug_name=>'Relational View Details'
,p_parent_plug_id=>wwv_flow_imp.id(7020286968648546)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8604970644781429)
,p_plug_name=>'Drop Index'
,p_region_name=>'dialogDropIndex'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>160
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800094924652110)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(8604970644781429)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>130
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612077394567025)
,p_plug_name=>'Index Details'
,p_parent_plug_id=>wwv_flow_imp.id(8604970644781429)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8605735779781437)
,p_plug_name=>'Grant'
,p_region_name=>'dialogGrant'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>250
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800932098652119)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(8605735779781437)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>210
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612913578567034)
,p_plug_name=>'Grant Details'
,p_parent_plug_id=>wwv_flow_imp.id(8605735779781437)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8606348177781443)
,p_plug_name=>'Revoke Grant'
,p_region_name=>'dialogRevoke'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>270
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1801168869652121)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(8606348177781443)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>190
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17613122989567036)
,p_plug_name=>'Grant Details'
,p_parent_plug_id=>wwv_flow_imp.id(8606348177781443)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17609839226567003)
,p_plug_name=>'Test Database Link'
,p_region_name=>'dialogDBLinkTest'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>200
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800496202652114)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(17609839226567003)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>140
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612428572567029)
,p_plug_name=>'Database Link Details'
,p_parent_plug_id=>wwv_flow_imp.id(17609839226567003)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17610371114567008)
,p_plug_name=>'Alter Sequence'
,p_region_name=>'dialogAlterSequence'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_region_attributes=>'data-bind-cursor="cursorAlterSequence"'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>190
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800353049652113)
,p_plug_name=>'SQL Preview'
,p_parent_plug_id=>wwv_flow_imp.id(17610371114567008)
,p_region_css_classes=>'b-OB-sqlPreview js-sqlPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>475
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17612331933567028)
,p_plug_name=>'Sequence Details'
,p_parent_plug_id=>wwv_flow_imp.id(17610371114567008)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>5
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(190781682631520604)
,p_plug_name=>'Edit Import'
,p_region_name=>'dialogImportEdit'
,p_parent_plug_id=>wwv_flow_imp.id(8602521523781405)
,p_region_css_classes=>'js-dialog-class-b-OB-Dialog'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_plug_template=>wwv_flow_imp.id(1131993087623131882)
,p_plug_display_sequence=>300
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_db_version.c_has_mle_with_modules'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2713259356867401)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1940286357723401)
,p_button_name=>'OBJECTS_CREATE_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(385765690470963369)
,p_button_image_alt=>'Create Database Objects'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-plus'
,p_button_cattributes=>'data-menu="objectsCreateMenu_menu"'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7018532214648529)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(7018622609648530)
,p_button_name=>'FILTER_DLG_ADD'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Add'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-add mnw120'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7018434388648528)
,p_button_sequence=>190
,p_button_plug_id=>wwv_flow_imp.id(1802429312652134)
,p_button_name=>'FILTER_DLG_REMOVE'
,p_button_static_id=>'filterRemove_XX'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Remove'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-remove a-Button--small'
,p_icon_css_classes=>'icon-ban'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1632188254041653)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4143722710277153)
,p_button_name=>'DROP_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Drop'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(190782640935520614)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_button_name=>'IMPORT_EDIT_DLG_SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-save'
,p_button_cattributes=>'ab-visible="{case P2000_IMPORT_EDIT_DLG_MODE/}{when E/}V{otherwise/}H{endcase/}"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5804051430163310)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5803927624163309)
,p_button_name=>'ROW_EDIT_DLG_SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-save'
,p_button_cattributes=>'ab-visible="{case P2000_ROW_EDIT_DLG_MODE/}{when E/}V{otherwise/}H{endcase/}"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8602408072781404)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2126430048504749)
,p_button_name=>'COLS_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(190782733812520615)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_button_name=>'IMPORT_EDIT_DLG_CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-create'
,p_button_cattributes=>'ab-visible="{case P2000_IMPORT_EDIT_DLG_MODE/}{when C/}V{otherwise/}H{endcase/}"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8602713256781407)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2121980975504704)
,p_button_name=>'ADDMODCOL_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8604081204781420)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2125241088504737)
,p_button_name=>'DROPCON_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Drop'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5804324191163313)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(5803927624163309)
,p_button_name=>'ROW_EDIT_DLG_CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-create'
,p_button_cattributes=>'ab-visible="{case P2000_ROW_EDIT_DLG_MODE/}{when C/}V{otherwise/}H{endcase/}"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603076999781410)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2122580640504710)
,p_button_name=>'DROPRENCOL_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8604275012781422)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2125673932504741)
,p_button_name=>'ENDIS_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8605421418781434)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8604970644781429)
,p_button_name=>'DROPIDX_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Drop'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7016383770648507)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(7015821948648502)
,p_button_name=>'DROPTRIG_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Drop'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7017344293648517)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(7016819747648512)
,p_button_name=>'ENDISTRG_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7019533775648539)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(7019158593648535)
,p_button_name=>'DROPSODA_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Drop'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603203687781412)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(2123071594504715)
,p_button_name=>'RENTAB_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7020164358648545)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(7019662830648540)
,p_button_name=>'SODAIDX_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603406799781414)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(2123401549504719)
,p_button_name=>'COMTAB_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8606946839781449)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(8605735779781437)
,p_button_name=>'GRANT_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Grant'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7015744457648501)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(8606348177781443)
,p_button_name=>'REVOKE_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Revoke'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7019086262648534)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(7017534107648519)
,p_button_name=>'ADDCON_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603689435781416)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(2123868803504723)
,p_button_name=>'COPTAB_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17609785061567002)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(7020286968648546)
,p_button_name=>'SODAVIEW_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17610223177567007)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(17609839226567003)
,p_button_name=>'DBLTEST_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Test'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17610923435567014)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(17610371114567008)
,p_button_name=>'ALTSEQ_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Alter'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7018849133648532)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(7018078706648524)
,p_button_name=>'FILTER_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603857564781418)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(2124914061504734)
,p_button_name=>'TRUNCTAB_DLG_OK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Truncate'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-ok'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1632524327041655)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4143722710277153)
,p_button_name=>'DROP_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5804239465163312)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5803927624163309)
,p_button_name=>'ROW_EDIT_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(190782337217520611)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_button_name=>'IMPORT_EDIT_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8602397721781403)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2126430048504749)
,p_button_name=>'COLS_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(190782458658520612)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_button_name=>'IMPORT_EDIT_DLG_DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-delete'
,p_button_cattributes=>'ab-visible="{case P2000_IMPORT_EDIT_DLG_MODE/}{when E/}V{otherwise/}H{endcase/}"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5804186473163311)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5803927624163309)
,p_button_name=>'ROW_EDIT_DLG_DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-delete'
,p_button_cattributes=>'ab-visible="{case P2000_ROW_EDIT_DLG_MODE/}{when E/}V{otherwise/}H{endcase/}"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8602665098781406)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2121980975504704)
,p_button_name=>'ADDMODCOL_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603966001781419)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2125241088504737)
,p_button_name=>'DROPCON_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8602959829781409)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2122580640504710)
,p_button_name=>'DROPRENCOL_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8604121674781421)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2125673932504741)
,p_button_name=>'ENDISCON_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8605381152781433)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8604970644781429)
,p_button_name=>'DROPIDX_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7016267692648506)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(7015821948648502)
,p_button_name=>'DROPTRIG_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7017250706648516)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(7016819747648512)
,p_button_name=>'ENDISTRG_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7019440956648538)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(7019158593648535)
,p_button_name=>'DROPSODA_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603194858781411)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(2123071594504715)
,p_button_name=>'RENTAB_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7020032497648544)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(7019662830648540)
,p_button_name=>'SODAIDX_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603358129781413)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(2123401549504719)
,p_button_name=>'COMTAB_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8606846362781448)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(8605735779781437)
,p_button_name=>'GRANT_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7018943685648533)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(7017534107648519)
,p_button_name=>'ADDCON_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603562623781415)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(2123868803504723)
,p_button_name=>'COPTAB_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8607008244781450)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(8606348177781443)
,p_button_name=>'REVOKE_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17609653594567001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(7020286968648546)
,p_button_name=>'SODAVIEW_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17610162085567006)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(17609839226567003)
,p_button_name=>'DBLTEST_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17610828128567013)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(17610371114567008)
,p_button_name=>'ALTSEQ_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7018743274648531)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(7018078706648524)
,p_button_name=>'FILTER_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8603736831781417)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(2124914061504734)
,p_button_name=>'TRUNCTAB_DLG_CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-cancel'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1632968752041661)
,p_name=>'P2000_DROP_DLG_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17611288055567017)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_help_text=>'Name of the database schema owner.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1633862723041669)
,p_name=>'P2000_DROP_DLG_OBJ_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17611288055567017)
,p_prompt=>'Object Type'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_help_text=>'Type of object to be dropped.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1634748696041671)
,p_name=>'P2000_DROP_DLG_OBJ_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17611288055567017)
,p_prompt=>'Object Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_help_text=>'Name of object to be dropped.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1635696856041672)
,p_name=>'P2000_DROP_DLG_CASCADE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17611288055567017)
,p_prompt=>'Cascade Constraints'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_help_text=>'Set to <strong>On</strong> to include "cascade constraints" option.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1654324365162343)
,p_name=>'P2000_COPYTABLE_DLG_CHOOSE_COL'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17611693044567021)
,p_item_default=>'ALL'
,p_prompt=>'Columns'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ALL.SELECTED.COLS'
,p_lov=>'.'||wwv_flow_imp.id(88062000322816814)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select either to copy all columns, or only selected columns.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1655124548168591)
,p_name=>'P2000_COPYTABLE_DLG_COLUMNS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(17611693044567021)
,p_prompt=>'Select Columns'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the columns to include in the copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1655920424194792)
,p_name=>'P2000_COPYTABLE_DLG_ROWS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17611693044567021)
,p_item_default=>'ALL'
,p_prompt=>'Copy'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW.SELECT'
,p_lov=>'.'||wwv_flow_imp.id(88095631994062466)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether to copy rows of data to the new table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1656722383201024)
,p_name=>'P2000_COPYTABLE_DLG_WHERE'
,p_is_required=>true
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(17611693044567021)
,p_prompt=>'Where'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter a where clause to limit the rows to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1814418414592869)
,p_name=>'P2000_ADDMODCOL_DLG_LENGTH'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Length'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>10
,p_tag_attributes=>'ab-item-value="=LENGTH"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Specify the length for column to be added or modified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1815333995598323)
,p_name=>'P2000_ADDMODCOL_DLG_PRECISION'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Precision'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>10
,p_tag_attributes=>'ab-item-value="=PRECISION"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the precision of the column to be added or modified.</p>',
'<p>Precision is the maximum number of significant decimal digits, where the most significant digit is the left-most nonzero digit, and the least significant digit is the right-most known digit.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1816381230601003)
,p_name=>'P2000_ADDMODCOL_DLG_SCALE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Scale'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>10
,p_tag_attributes=>'ab-item-value="=SCALE"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the scale of the column to be added or modified.</p>',
'<p>Scale is the number of digits from the decimal point to the least significant digit.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1817354854604667)
,p_name=>'P2000_ADDMODCOL_DLG_NULL'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_item_default=>'NULL'
,p_prompt=>'Nullable'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'ab-item-value="=NULLABLE"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Specify if the column should allow null values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1818345033608456)
,p_name=>'P2000_ADDMODCOL_DLG_IDENTITY'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Identity'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify if the column is an identity column.</p>',
'<p>An identity column will be assigned an increasing or decreasing integer value from a sequence generator for each subsequent INSERT statement.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1827232638749396)
,p_name=>'P2000_ADDMODCOL_DLG_COL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Column'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_tag_attributes=>'ab-item-value="=COLUMN_NAME"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Name of the column to be added or modified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1875054295598508)
,p_name=>'P2000_REDACT_NAME_ORIG'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1875394925598510)
,p_name=>'P2000_REDACT_EXP_ORIG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1875767527598511)
,p_name=>'P2000_REDACT_TYPE_ORIG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1876130304598511)
,p_name=>'P2000_REDACT_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_prompt=>'Policy Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_read_only_when=>'P2000_REDACT_NAME_ORIG'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter a unique name for the redaction policy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1877068816598513)
,p_name=>'P2000_REMOVE_REDACT_POLICY'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P2000_REMOVE_REDACT'
,p_lov=>'.'||wwv_flow_imp.id(2371765569098492)||'.'
,p_begin_on_new_line=>'N'
,p_display_when=>'P2000_REDACT_NAME_ORIG'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_help_text=>'Check to remove existing redaction policy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1877469758598513)
,p_name=>'P2000_REDACT_EXP'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_prompt=>'Expression'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_EXPRESSIONS'
,p_lov=>'.'||wwv_flow_imp.id(7516909805609852)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a Boolean SQL expression or choose one from the pop-up list. Redaction takes place only if this policy expression evaluates to TRUE. Be careful when making comparisons with NULL. Remember that in SQL the value NULL is undefined, so comparisons '
||'with NULL tend to give FALSE. This expression must be based on SYS_CONTEXT values from a specified namespace. The default namespace for SYS_CONTEXT is USERENV, which includes values such as SESSION_USER and CLIENT_IDENTIFIER. (See Oracle Database SQL'
||' Language Reference for detailed information about this function.) In addition to SYS_CONTEXT, you can use the V and NV functions (for Oracle APEX) and the DOMINATES function (for Oracle Label Security). You cannot use user-created functions in the e'
||'xpression parameter.',
'',
'<p />In the policy expression, in addition to the SYS_CONTEXT function, you only can use the following operators: =, !=, >, <, >=, <='))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1878300513598515)
,p_name=>'P2000_REDACT_ENABLED'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_item_default=>'Y'
,p_prompt=>'Policy Enabled'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REDACTION_ENABLED'
,p_lov=>'.'||wwv_flow_imp.id(7500901536272987)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select either Enable or Disable to enable or disable the redaction policy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1879282209598516)
,p_name=>'P2000_REDACT_TYPE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_prompt=>'Function Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_REDACT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2372526307115830)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Redact Type --'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a function that sets the type of redaction.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1880141422598517)
,p_name=>'P2000_REMOVE_COL_FROM_POLICY'
,p_item_sequence=>175
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P2000_REM_COL_POLICY'
,p_lov=>'.'||wwv_flow_imp.id(2374950879129168)||'.'
,p_begin_on_new_line=>'N'
,p_display_when=>'P2000_REDACT_COLS_ORIG'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_help_text=>'Check to remove the column from the redaction policy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1880555712598518)
,p_name=>'P2000_FUNCTION_PARMS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_prompt=>'Function Parameters'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_FUNC_PARMS'
,p_lov=>'.'||wwv_flow_imp.id(7469301964208818)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter or choose from the pop-up list how the column redaction should appear. See Syntax for Performing Partial Data Redaction in Oracle Database Advanced Security Guide 12c Release 1 (12.1) for more information.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1881454402598520)
,p_name=>'P2000_REGEXP_PATTERN'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_prompt=>'Regular Expression Pattern'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_REGEXP_PATTERN'
,p_lov=>'.'||wwv_flow_imp.id(7472906353351996)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter or choose from the pop-up list a regular expression to match the data that is to be redacted. If a match is made then it will be redacted using the regular expression specified in the Regular Expression Replace String field.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1882335165598521)
,p_name=>'P2000_REGEXP_REPLACE_STR'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_prompt=>'Regular Expression Replace String'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_REGEXP_REPL_STR'
,p_lov=>'.'||wwv_flow_imp.id(7474914908572203)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter or choose from the pop-up list how you want to replace the data to be redacted. It can be of any of the data types CHAR, VARCHAR2, NCHAR, or NVARCHAR2. The regexp_replace_string can contain up to 500 back references to subexpressions in the for'
||'m \n, where n is a number from 1 to 9. If you want to include a backslash (\) in the regexp_replace_string setting, then you must precede it with the escape character, which is also a backslash. For example, to literally replace the matched pattern w'
||'ith \2 (rather than replace it with the second matched subexpression of the matched pattern) you would enter \\2 in the regexp_replace_string setting. For more information, see Oracle Database SQL Language Reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1883276864598522)
,p_name=>'P2000_REGEXP_POSITION'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_item_default=>'1'
,p_prompt=>'Regular Expression Position'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter the starting position for the string search. This is a positive integer indicating the character of the column_name data where Oracle Database should begin the search. The default is 1 , meaning that Oracle Database begins the search at the fir'
||'st character of the column_name data.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1884111648598523)
,p_name=>'P2000_REGEXP_OCCURANCE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_item_default=>'0'
,p_prompt=>'Regular Expression Occurance'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter a non-negative integer to specify the occurrence to perform the search and replace operation. If you enter 0, all occurrences will be replaced.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1885027270598524)
,p_name=>'P2000_REGEXP_MATCH_PARM'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_prompt=>'Regular Expression Match Parameter'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGEXP_MATCH_PARAM'
,p_lov=>'.'||wwv_flow_imp.id(7477530753595662)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Match Parameter --'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the default matching behavior of the function. The behavior of this parameter is the same for this function as for the REGEXP_REPLACE SQL function.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1885911334598524)
,p_name=>'P2000_REDACT_COLS_ORIG'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1886381351598525)
,p_name=>'P2000_REDACT_ENABLED_ORIG'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(8393648552553316)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1902818840041212)
,p_name=>'P2000_OB_INIT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2100515267955802)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'Y'
,p_item_comment=>'Item to initialize object tree entry to view a specific object.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1905427919041238)
,p_name=>'P2000_OB_INIT_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(387994680244652086)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2100666512955803)
,p_name=>'P2000_OB_OBJECTS_FILTER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2100515267955802)
,p_prompt=>'Search'
,p_placeholder=>'Type to filter...'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cMaxlength=>2000
,p_tag_attributes=>'aria-controls="objectsTree"'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_css_classes=>'b-OB-Search'
,p_item_icon_css_classes=>'a-Icon icon-search'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'SEARCH'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2100719213955804)
,p_name=>'P2000_OB_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(387994680244652086)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select c.schema d, c.id v',
'    from wwv_flow_company_schemas c,',
'         wwv_flow_fnd_user u',
'   where c.security_group_id = u.security_group_id',
'     and c.security_group_id = :flow_security_group_id',
'     and u.user_name = :flow_user',
'     and (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'          instr( '':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'', '':''||c.schema||'':'' ) > 0 )',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA_ID'
,p_help_text=>'Identifies the name of the database schema owner.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2122099356504705)
,p_name=>'P2000_ADDMODCOL_DLG_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2122357917504708)
,p_name=>'P2000_ADDMODCOL_DLG_OBJ_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2122461519504709)
,p_name=>'P2000_ADDMODCOL_DLG_DATA_TYPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Data Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(21015224563508746)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the data type of the column to be modified.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2122687298504711)
,p_name=>'P2000_RENDROPCOL_DLG_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17611138850567016)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2122710606504712)
,p_name=>'P2000_RENDROPCOL_DLG_OBJ_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17611138850567016)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2122811362504713)
,p_name=>'P2000_RENDROPCOL_DLG_COLS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(17611138850567016)
,p_prompt=>'Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Name of the column to be dropped or renamed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2122963799504714)
,p_name=>'P2000_RENDROPCOL_DLG_COL_REN'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17611138850567016)
,p_prompt=>'New Column Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_tag_attributes=>'ab-item-value="=COLUMN_NAME"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'New name of the column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2123103425504716)
,p_name=>'P2000_RENTABLE_DLG_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17611485960567019)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2123209011504717)
,p_name=>'P2000_RENTABLE_DLG_OBJ_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(17611485960567019)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2123362504504718)
,p_name=>'P2000_RENTABLE_DLG_TAB_REN'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17611485960567019)
,p_prompt=>'New Table Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'New name of the table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2123558998504720)
,p_name=>'P2000_COMMENT_DLG_OWNER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17611528077567020)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2123633572504721)
,p_name=>'P2000_COMMENT_DLG_OBJ_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(17611528077567020)
,p_prompt=>'<span ab-text="=P2000_COMMENT_DLG_TYPE"></span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2123743074504722)
,p_name=>'P2000_COMMENT_DLG_COMMENT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(17611528077567020)
,p_prompt=>'Comment'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>2
,p_tag_attributes=>'ab-item-value="=COMMENTS"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter the comment.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2123970195504724)
,p_name=>'P2000_COPYTABLE_DLG_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(17611693044567021)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2124018752504725)
,p_name=>'P2000_COPYTABLE_DLG_OBJ_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17611693044567021)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2124176267504726)
,p_name=>'P2000_COPYTABLE_DLG_TAB_NEW'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17611693044567021)
,p_prompt=>'New Table Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter name of the table to copy to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2125044809504735)
,p_name=>'P2000_TRUNCTABLE_DLG_OWNER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(17611750887567022)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2125178545504736)
,p_name=>'P2000_TRUNCTABLE_DLG_OBJ_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(17611750887567022)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2125372245504738)
,p_name=>'P2000_DROPCON_DLG_OWNER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17611937239567024)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2125404354504739)
,p_name=>'P2000_DROPCON_DLG_OBJ_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17611937239567024)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2125565000504740)
,p_name=>'P2000_DROPCON_DLG_CONSTRAINT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17611937239567024)
,p_prompt=>'Constraint'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select constraint_name d, constraint_name v ',
'  from sys.dba_constraints ',
' where owner = :P2000_DROPCON_DLG_OWNER ',
'   and table_name = :P2000_DROPCON_DLG_OBJ_NAME'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose constraint from the list.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2125747071504742)
,p_name=>'P2000_ENDISCON_DLG_OWNER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(17612730192567032)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2125872732504743)
,p_name=>'P2000_ENDISCON_DLG_OBJ_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(17612730192567032)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2125985471504744)
,p_name=>'P2000_ENDISCON_DLG_CONSTRAINT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(17612730192567032)
,p_prompt=>'Constraint'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the constraint from the list.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5804469753163314)
,p_name=>'P2000_ROW_EDIT_DLG_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5803927624163309)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6025024374323942)
,p_name=>'P2000_ADDCON_DLG_TYPE'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_item_default=>'CHECK'
,p_prompt=>'Constraint Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_CONSTRAINT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(6047691541572644)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify type of constraint.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6025818877328572)
,p_name=>'P2000_ADDCON_DLG_CASCADE'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_item_default=>'D'
,p_prompt=>'Delete Behavior'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P2000_FK_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(6049648636596575)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Disallow Delete'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose a cascade option.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6026175923333687)
,p_name=>'P2000_ADDCON_DLG_CON_COL'
,p_is_required=>true
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Constraint on Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_tag_attributes=>'ab-visible="{case P2000_ADDCON_DLG_TYPE/}{when CHECK/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify column to place constraint on'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6026974669337439)
,p_name=>'P2000_ADDCON_DLG_CHECK_CON'
,p_is_required=>true
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Constraint Expression'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>5
,p_tag_attributes=>'ab-visible="{case P2000_ADDCON_DLG_TYPE/}{when CHECK/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter SQL check constraint condition. The expression is appended to the selected ',
'Constraint on Column value. '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6029377500357141)
,p_name=>'P2000_ADDCON_DLG_UK_COL1'
,p_is_required=>true
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Unique column 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_tag_attributes=>'ab-visible="{case P2000_ADDCON_DLG_TYPE/}{when UNIQUE/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify first column for unique constraint'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6030172284360757)
,p_name=>'P2000_ADDCON_DLG_UK_COL2'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Unique column 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_tag_attributes=>'ab-visible="{case P2000_ADDCON_DLG_TYPE/}{when UNIQUE/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify second column for unique constraint'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6030950035366275)
,p_name=>'P2000_ADDCON_DLG_UK_COL3'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Unique column 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_tag_attributes=>'ab-visible="{case P2000_ADDCON_DLG_TYPE/}{when UNIQUE/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify third column for unique constraint'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6031798647370426)
,p_name=>'P2000_ADDCON_DLG_PK_COL1'
,p_is_required=>true
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Primary Key Column 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_tag_attributes=>'ab-visible="{case P2000_ADDCON_DLG_TYPE/}{when PRIMARY KEY/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify first column for primary constraint'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6032572553373685)
,p_name=>'P2000_ADDCON_DLG_PK_COL2'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Primary Key Column 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_tag_attributes=>'ab-visible="{case P2000_ADDCON_DLG_TYPE/}{when PRIMARY KEY/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify second column for primary constraint'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6033359385377169)
,p_name=>'P2000_ADDCON_DLG_PK_COL3'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Primary Key Column 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_tag_attributes=>'ab-visible="{case P2000_ADDCON_DLG_TYPE/}{when PRIMARY KEY/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify third column for primary constraint'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6034147718383347)
,p_name=>'P2000_ADDCON_DLG_FK_COL'
,p_is_required=>true
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Foreign Key Column(s)'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify which column has a foreign key'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6034970271386528)
,p_name=>'P2000_ADDCON_DLG_FK_TAB'
,p_is_required=>true
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Reference Table Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d, table_name r',
'  from sys.dba_tables',
' where owner = :P2000_ADDCON_DLG_OWNER',
'   and table_name not like ''DR$%''',
'   and table_name not like ''BIN$%''',
' order by 1'))
,p_lov_cascade_parent_items=>'P2000_ADDCON_DLG_POP_FK'
,p_ajax_items_to_submit=>'P2000_ADDCON_DLG_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_attributes=>'ab-visible="{case P2000_ADDCON_DLG_TYPE/}{when FOREIGN KEY/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify name of table for foreign key'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6035764078392449)
,p_name=>'P2000_ADDCON_DLG_FK_COLS2'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Reference Table Column(s)'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from sys.dba_tab_cols',
' where owner = :P2000_ADDCON_DLG_OWNER',
'   and table_name = :P2000_ADDCON_DLG_FK_TAB',
' order by column_id'))
,p_lov_cascade_parent_items=>'P2000_ADDCON_DLG_FK_TAB'
,p_ajax_items_to_submit=>'P2000_ADDCON_DLG_OWNER,P2000_ADDCON_DLG_FK_TAB'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify column from table for foreign key'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7015917162648503)
,p_name=>'P2000_DROPTRIG_DLG_OWNER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17612617281567031)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7016053513648504)
,p_name=>'P2000_DROPTRIG_DLG_OBJ_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17612617281567031)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7016197506648505)
,p_name=>'P2000_DROPTRIG_DLG_TRIGGER'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17612617281567031)
,p_prompt=>'Trigger'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the trigger to drop.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7016447982648508)
,p_name=>'P2000_COMMENT_DLG_TYPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17611528077567020)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7016502645648509)
,p_name=>'P2000_GRANT_DLG_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(17612913578567034)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7016641744648510)
,p_name=>'P2000_REVOKE_DLG_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17613122989567036)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7016703668648511)
,p_name=>'P2000_ADDMODCOL_DLG_FMT_DT'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7016948942648513)
,p_name=>'P2000_ENDIS_DLG_OWNER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17612812375567033)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7017010826648514)
,p_name=>'P2000_ENDIS_DLG_OBJ_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17612812375567033)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7017188105648515)
,p_name=>'P2000_ENDIS_DLG_TRIGGER'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17612812375567033)
,p_prompt=>'Trigger'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the trigger from the list.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7017600417648520)
,p_name=>'P2000_ADDCON_DLG_OWNER'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7017749535648521)
,p_name=>'P2000_ADDCON_DLG_OBJ_NAME'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7017853491648522)
,p_name=>'P2000_ADDCON_DLG_CONSTRAINT'
,p_is_required=>true
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter the name of the constraint.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7018123156648525)
,p_name=>'P2000_FILTER_COLUMN_XX'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(1802429312652134)
,p_prompt=>'Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'filterColumns'
,p_tag_attributes=>'ab-item-value="=column"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(492677350674053149)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the column for the filter.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7018246069648526)
,p_name=>'P2000_FILTER_OP_XX'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(1802429312652134)
,p_prompt=>'Operation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_FILTER_OPERATION'
,p_lov=>'.'||wwv_flow_imp.id(2377428328828737)||'.'
,p_cHeight=>1
,p_tag_css_classes=>'js-filter-op'
,p_tag_attributes=>'ab-item-value="=op"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(492677350674053149)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the operation for the filter.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7018315732648527)
,p_name=>'P2000_FILTER_VALUE_XX'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(1802429312652134)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_tag_attributes=>'ab-item-value="=value"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter a value for the filter expression.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7019273327648536)
,p_name=>'P2000_DROPSODA_DLG_OWNER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17612186242567026)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7019393634648537)
,p_name=>'P2000_DROPSODA_DLG_COL_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17612186242567026)
,p_prompt=>'Collection Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7019727433648541)
,p_name=>'P2000_SODAIDX_DLG_OWNER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(17612214728567027)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7019886184648542)
,p_name=>'P2000_SODAIDX_DLG_COL_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(17612214728567027)
,p_prompt=>'Collection Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7019906816648543)
,p_name=>'P2000_SODAIDX_DLG_IDX_NAME'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17612214728567027)
,p_prompt=>'Index Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter a name for the SODA index.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7020366852648547)
,p_name=>'P2000_SODAVIEW_DLG_OWNER'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17612579071567030)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7020498577648548)
,p_name=>'P2000_SODAVIEW_DLG_COL_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17612579071567030)
,p_prompt=>'Collection Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7020542195648549)
,p_name=>'P2000_SODAVIEW_DLG_VIEW_NAME'
,p_is_required=>true
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(17612579071567030)
,p_prompt=>'View Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter a name for the SODA view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7020643781648550)
,p_name=>'P2000_SODAVIEW_DLG_JSON_SEL'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(17612579071567030)
,p_prompt=>'JSON Selector'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Enter a JSON selector expression for the SODA view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8602215037781402)
,p_name=>'P2000_SHOW_COLUMNS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(17611860981567023)
,p_prompt=>'Select the columns to display'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P2000_SHOW_COLS'
,p_lov=>'.'||wwv_flow_imp.id(2381539388856852)||'.'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8602847226781408)
,p_name=>'P2000_ADDMODCOL_DLG_COLS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to modify.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8604581497781425)
,p_name=>'P2000_ADDMODCOL_DLG_YD_PREC'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Year / Day Precision'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the precision of the column to be added or modified.</p>',
'<p>Year precision is the number of digits in the YEAR datetime field. The default is 2.</p>',
'<p>Day precision is the number of digits in the DAY datetime field. Accepted values are 0 to 9. The default is 2.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8604671545781426)
,p_name=>'P2000_ADDMODCOL_DLG_DEFAULT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Default'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>30
,p_tag_attributes=>'ab-item-value="=DATA_DEFAULT" '
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Optionally specify a default value for this column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8604704622781427)
,p_name=>'P2000_COMMENT_DLG_OBJ_COL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17611528077567020)
,p_item_default=>'T'
,p_prompt=>'Comment On'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P2000_COMMENT_ON'
,p_lov=>'.'||wwv_flow_imp.id(2382418254873350)||'.'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether commenting on the table or a column.'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8604840066781428)
,p_name=>'P2000_COMMENT_DLG_COLS'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_imp.id(17611528077567020)
,p_prompt=>'Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_tag_attributes=>'ab-visible="{case P2000_COMMENT_DLG_OBJ_COL/}{when C/}V{otherwise/}H{endcase/}"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a column from the list.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8605022081781430)
,p_name=>'P2000_DROPIDX_DLG_OWNER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(17612077394567025)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8605157051781431)
,p_name=>'P2000_DROPIDX_DLG_OBJ_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(17612077394567025)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8605235160781432)
,p_name=>'P2000_DROPIDX_DLG_INDEX'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17612077394567025)
,p_prompt=>'Index'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the index from the list.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8605568692781435)
,p_name=>'P2000_ADDMODCOL_DLG_HAS_IDTY'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8605672179781436)
,p_name=>'P2000_ADDMODCOL_DLG_CHAR_USED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(17611363158567018)
,p_prompt=>'Semantics'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_SEMANTICS'
,p_lov=>'.'||wwv_flow_imp.id(2383831987893567)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Default'
,p_cHeight=>1
,p_tag_attributes=>'ab-item-value="=USE_CHAR" '
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify byte or char for column semantics.</p>',
'<p>In the byte length semantics, size is the maximum number of bytes that can be stored in the column.</p> ',
'<p>In the character length semantics, size is the maximum number of code points in the database character set that can be stored in the column.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8605833844781438)
,p_name=>'P2000_GRANT_DLG_OWNER'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(17612913578567034)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8605957174781439)
,p_name=>'P2000_GRANT_DLG_OBJ_NAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(17612913578567034)
,p_prompt=>'<span ab-text="=P2000_GRANT_DLG_TYPE"></span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8606066484781440)
,p_name=>'P2000_GRANT_DLG_GRANTEE'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(17612913578567034)
,p_prompt=>'Grantee'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Specify the user to grant privileges to.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8606135062781441)
,p_name=>'P2000_GRANT_DLG_GRANT'
,p_is_required=>true
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(17612913578567034)
,p_prompt=>'Privilege'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC:-D-;-R-'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the grant.'
,p_attribute_01=>'2'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8606207556781442)
,p_name=>'P2000_GRANT_DLG_OPTION'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(17612913578567034)
,p_prompt=>'With Grant Option'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Specify if the grantee should be able to grant this to others.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8606479868781444)
,p_name=>'P2000_REVOKE_DLG_OWNER'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17613122989567036)
,p_prompt=>'<span ab-text="=P2000_REVOKE_DLG_TYPE"></span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8606539190781445)
,p_name=>'P2000_REVOKE_DLG_OBJ_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17613122989567036)
,p_prompt=>'<span ab-text="=P2000_REVOKE_DLG_TYPE"></span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8606664802781446)
,p_name=>'P2000_REVOKE_DLG_GRANTEE'
,p_is_required=>true
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(17613122989567036)
,p_prompt=>'Revoke From'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2000_DUMMY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null d, null r',
'  from sys.dual',
' where 1=2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the grantee to revoke from.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8606710873781447)
,p_name=>'P2000_REVOKE_DLG_GRANT'
,p_is_required=>true
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(17613122989567036)
,p_prompt=>'Privilege'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC:-D-;-R-'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the grant to revoke.'
,p_attribute_01=>'2'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17609952797567004)
,p_name=>'P2000_DBLTEST_DLG_OWNER'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17612428572567029)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17610019902567005)
,p_name=>'P2000_DBLTEST_DLG_DB_LINK_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(17612428572567029)
,p_prompt=>'Database Link'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17610476603567009)
,p_name=>'P2000_ALTSEQ_DLG_OWNER'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17612331933567028)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17610586272567010)
,p_name=>'P2000_ALTSEQ_DLG_SEQ_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(17612331933567028)
,p_prompt=>'Sequence Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17610618836567011)
,p_name=>'P2000_ALTSEQ_DLG_CURRENT_VAL'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17612331933567028)
,p_prompt=>'Current Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'readonly ab-item-value="=LAST_NUMBER"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_is_persistent=>'N'
,p_help_text=>'The current value of the sequence.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17611077936567015)
,p_name=>'P2000_ADDCON_DLG_POP_FK'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(17613001441567035)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19000244635183578)
,p_name=>'P2000_ALTSEQ_DLG_MIN_VAL'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(17612331933567028)
,p_prompt=>'Minimum Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>10
,p_tag_attributes=>'ab-item-value="=MIN_VALUE"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Specify the minimum value of the sequence. Minimum value must be less than or equal to current value and must be less than max value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19001092263202558)
,p_name=>'P2000_ALTSEQ_DLG_MAX_VAL'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(17612331933567028)
,p_prompt=>'Maximum Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>10
,p_tag_attributes=>'ab-item-value="=MAX_VALUE"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Specify the maximum value the sequence can generate. Maximum value must be equal to or greater than current value and must be greater than minimum value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19001825909211995)
,p_name=>'P2000_ALTSEQ_DLG_INCREMENT_BY'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(17612331933567028)
,p_prompt=>'Increment By'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>10
,p_tag_attributes=>'ab-item-value="=INCREMENT_BY"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Specify the interval between sequence numbers. This integer value can be any positive or negative integer, but it cannot be 0. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19002743943215804)
,p_name=>'P2000_ALTSEQ_DLG_CYCLE'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_imp.id(17612331933567028)
,p_prompt=>'Cycle'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'ab-item-value="=CYCLE_FLAG"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_escape_on_http_input=>'N'
,p_help_text=>'Set Cycle to <strong>On</strong> to indicate that the sequence continues to generate values after reaching either its maximum or minimum value. After an ascending sequence reaches its maximum value, it generates its minimum value. After a descending '
||'sequence reaches its minimum, it generates its maximum value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19003553256219221)
,p_name=>'P2000_ALTSEQ_DLG_CACHE'
,p_item_sequence=>465
,p_item_plug_id=>wwv_flow_imp.id(17612331933567028)
,p_prompt=>'Number to Cache'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>10
,p_tag_attributes=>'ab-item-value="=CACHE_SIZE"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_help_text=>'Specify how many values of the sequence the database preallocates and keeps in memory for faster access.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19004397762222052)
,p_name=>'P2000_ALTSEQ_DLG_ORDER'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(17612331933567028)
,p_prompt=>'Order'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'ab-item-value="=ORDER_FLAG"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_escape_on_http_input=>'N'
,p_help_text=>'Set Order to <strong>On</strong> to guarantee that sequence numbers are generated in order of request. This ORDER clause is useful if you are using the sequence numbers as timestamps. Guaranteeing order is usually not important for sequences used to '
||'generate primary keys. ORDER is necessary only to guarantee ordered generation if you are using Oracle Database with Real Application Clusters. If you are using exclusive mode, sequence numbers are always generated in order.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190781722603520605)
,p_name=>'P2000_IMPORT_EDIT_DLG_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190781893318520606)
,p_name=>'P2000_ORIGINAL_IMPORT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190781928114520607)
,p_name=>'P2000_SCHEMA_HELPER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_use_cache_before_default=>'NO'
,p_source=>'select schema from wwv_flow_company_schemas where id = :P2000_OB_SCHEMA'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190782079755520608)
,p_name=>'P2000_MODULE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_prompt=>'&"APP_TEXT$OB.COL_MODULE_OWNER".'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select schema d,',
'       schema r',
'  from (',
'    select c.schema',
'      from wwv_flow_company_schemas c,',
'           wwv_flow_fnd_user u',
'     where c.security_group_id = u.security_group_id',
'       and c.security_group_id = :flow_security_group_id',
'       and u.user_name = :flow_user',
'       and (u.allow_access_to_schemas is null or',
'            instr( '':''||u.allow_access_to_schemas||'':'', '':''||c.schema||'':'' ) > 0 )',
'',
'     union',
'',
'     select distinct owner as schema',
'      from ( select o.owner, o.owner as grantee, o.object_type, o.object_name',
'               from sys.dba_objects o',
'              union',
'             select p.owner, p.grantee, p.type, p.table_name',
'               from sys.dba_tab_privs p ) o',
'     where o.object_type = ''MLE MODULE''',
'       and o.grantee in ( :P2000_SCHEMA_HELPER, ''PUBLIC'' )',
'  )'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P2000_SCHEMA_HELPER'
,p_ajax_items_to_submit=>'P2000_SCHEMA_HELPER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190782162613520609)
,p_name=>'P2000_MODULE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_prompt=>'&"APP_TEXT$OB.COL_MODULE_NAME".'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d,',
'       object_name r',
'  from ( select o.owner, o.owner as grantee, o.object_type, o.object_name',
'           from sys.dba_objects o',
'          union',
'         select p.owner, p.grantee, p.type, p.table_name',
'           from sys.dba_tab_privs p ) o',
' where o.object_type = ''MLE MODULE''',
'   and o.grantee in ( :P2000_SCHEMA_HELPER, ''PUBLIC'' )',
'   and :P2000_MODULE_OWNER is not null',
'   and owner = :P2000_MODULE_OWNER',
' order by object_name'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P2000_MODULE_OWNER'
,p_ajax_items_to_submit=>'P2000_MODULE_OWNER,P2000_SCHEMA_HELPER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190782266505520610)
,p_name=>'P2000_IMPORT_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(190781682631520604)
,p_prompt=>'&"APP_TEXT$OB.COL_IMPORT_NAME".'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2101191668955808)
,p_computation_sequence=>10
,p_computation_item=>'P2000_OB_SCHEMA'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_company_schemas c,',
'       (select wwv_flow_user_api.get_default_schema default_schema',
'          from sys.dual ) d',
' where c.schema = d.default_schema',
'   and c.security_group_id = :WORKSPACE_ID'))
,p_compute_when=>'P2000_OB_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2057080399923201)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'setPreference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.set_preference (',
'        p_preference_name   => wwv_flow.g_x01,',
'        p_preference_value  => wwv_flow.g_x02 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2057080399923201
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(126077631877829103)
,p_process_sequence=>20
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getHints'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_plugins.emit_code_complete_list (',
'    p_application_id   => null,',
'    p_parsing_schema   => wwv_flow.g_x01,',
'    p_type             => null, -- no page item hints in ob',
'    p_search_prefix    => wwv_flow.g_x02,',
'    p_parent           => wwv_flow.g_x03,',
'    p_grand_parent     => wwv_flow.g_x04 );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>126077631877829103
);
end;
/
prompt --application/pages/page_02001
begin
wwv_flow_imp_page.create_page(
 p_id=>2001
,p_name=>'OB_DATA_FEED_OBJECTS'
,p_alias=>'OB_DATA_FEED_OBJECTS'
,p_step_title=>'OB_DATA_FEED_OBJECTS'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11539602725985552)
,p_step_template=>wwv_flow_imp.id(740688669716062470)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/obj_brows.htm'
,p_page_comment=>'Page Items of this page are used by an application process used by Object Browser. Don''t delete! -Patrick'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11545303511042525)
,p_plug_name=>'Object Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11545932601050949)
,p_name=>'P2001_FEED_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11545303511042525)
,p_prompt=>'Type'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(6693608793786901)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify attribute'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11546117846050959)
,p_name=>'P2001_FEED_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(11545303511042525)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(6693608793786901)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify attribute'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11546332706050962)
,p_name=>'P2001_FEED_START'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(11545303511042525)
,p_prompt=>'Start'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(6693608793786901)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify attribute'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11546525225050977)
,p_name=>'P2001_FEED_STOP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(11545303511042525)
,p_prompt=>'Stop'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(6693608793786901)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify attribute'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11546718928050978)
,p_name=>'P2001_FEED_DISPLAY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(11545303511042525)
,p_prompt=>'Display'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(6693608793786901)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify attribute'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11546905323050998)
,p_name=>'P2001_FEED_INCLUDE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(11545303511042525)
,p_prompt=>'Include'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(6693608793786901)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify attribute'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11547117493050998)
,p_name=>'P2001_FEED_ONCLICK'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(11545303511042525)
,p_prompt=>'Onclick'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(6693608793786901)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify attribute'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11547331758050999)
,p_name=>'P2001_FEED_CLASS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(11545303511042525)
,p_prompt=>'Class'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(6693608793786901)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify attribute'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
prompt --application/pages/page_02010
begin
wwv_flow_imp_page.create_page(
 p_id=>2010
,p_name=>'Create Synonym'
,p_alias=>'CREATE-SYNONYM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Synonym'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserWizard#MIN#.js'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_required_patch=>wwv_flow_imp.id(240237502901130926)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEUTL/obj_syn.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1702337722973413)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40499307023612564)
,p_plug_name=>'Synonym Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(242006689922791220)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1807924925696440)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(242006689922791220)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Synonym'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8005288177485328)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_imp.id(1702337722973413)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1808313244696441)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(242006689922791220)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1774620949216701)
,p_name=>'P2010_PARSING_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40499307023612564)
,p_prompt=>'Synonym Owner'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1776507670216720)
,p_name=>'P2010_REMOTE_SYN_OBJECT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(40499307023612564)
,p_prompt=>'Remote Object'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the remote object upon which you wish to create a synonym.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1802044913696436)
,p_name=>'P2010_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40499307023612564)
,p_prompt=>'Synonym Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the name of the synonym to be created. Synonym  names must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1802348474908711)
,p_name=>'P2010_DDL'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(1702337722973413)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1804210975696437)
,p_name=>'P2010_DB_LOCATION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(40499307023612564)
,p_item_default=>'LOCAL'
,p_prompt=>'Create Synonym On'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SYN_DB_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(2983860617051710)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select <strong>Local Object</strong>, if you wish to create a synonym on an object from the local database.</p>',
'<p>Select <strong>Remote Object</strong>, if you wish to create a synonym on an object from a remote database.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1804603942696438)
,p_name=>'P2010_SYN_SCHEMA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(40499307023612564)
,p_item_default=>'P2010_PARSING_SCHEMA'
,p_item_default_type=>'ITEM'
,p_prompt=>'Object Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select schema d, schema r',
'from (',
'    select :P2010_PARSING_SCHEMA schema',
'      from sys.dual',
'     union',
'    select p.owner schema',
'      from sys.dba_tab_privs p',
'     where p.grantee           = :P2010_PARSING_SCHEMA',
'       -- P2010_PARSING_SCHEMA is always limited to workspace schemas',
'       -- so no additional checks required ',
'       and p.owner      not in (''SYS'', ''SYSTEM'')',
'       and p.privilege  in (''SELECT'', ''READ''))',
'order by 1 '))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify the database schema (or username) which owns the object upon which you wish to create your synonym.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1805566250696438)
,p_name=>'P2010_SYN_OBJECT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(40499307023612564)
,p_prompt=>'Object'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P2010_SYN_OBJECT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name object_name,',
'       type object_type',
'  from sys.dba_tab_privs',
' where grantee = :P2010_PARSING_SCHEMA',
'   and grantor = :P2010_SYN_SCHEMA',
' union',
'select object_name object_name,',
'       object_type',
'  from sys.dba_objects',
' where owner             = :P2010_PARSING_SCHEMA',
'   and :P2010_SYN_SCHEMA = :P2010_PARSING_SCHEMA',
'   and object_name not like ''DR$%''',
'   and object_name not like ''BIN$%''',
'   and object_type != ''LOB''',
'   and ( object_type != ''INDEX'' or object_name not like ''SYS_%$$'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P2010_SYN_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select an object upon which you wish to create a synonym.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806431585696438)
,p_name=>'P2010_DB_LINK'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(40499307023612564)
,p_prompt=>'Database Link'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select db_link d, db_link r',
'  from sys.dba_db_links ',
' where owner = :P2010_PARSING_SCHEMA',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Database Link -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select a database link, to be used to access the Remote Object.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2000640047897502)
,p_name=>'P2010_OBJECT_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(40499307023612564)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2000719537897503)
,p_name=>'P2010_OBJECT_TYPE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(40499307023612564)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1810311640696457)
,p_validation_name=>'P2010_NAME valid & available'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2010_NAME,',
'    p_owner           => :P2010_PARSING_SCHEMA,',
'    p_object_type     => ''SYNONYM'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2010_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1807924925696440)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1777592167216730)
,p_validation_name=>'P2010_SYN_SCHEMA not null'
,p_validation_sequence=>50
,p_validation=>'P2010_SYN_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2010_DB_LOCATION'
,p_validation_condition2=>'LOCAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(1804603942696438)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1777897058216733)
,p_validation_name=>'P2010_SYN_OBJECT not null'
,p_validation_sequence=>60
,p_validation=>'P2010_SYN_OBJECT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2010_DB_LOCATION'
,p_validation_condition2=>'LOCAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(1805566250696438)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1777912297216734)
,p_validation_name=>'P2010_REMOTE_SYN_OBJECT not null'
,p_validation_sequence=>70
,p_validation=>'P2010_REMOTE_SYN_OBJECT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2010_DB_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(1776507670216720)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1778008308216735)
,p_validation_name=>'P2010_DB_LINK not null'
,p_validation_sequence=>80
,p_validation=>'P2010_DB_LINK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2010_DB_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(1806431585696438)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2121648011504701)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1808313244696441)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2121705145504702)
,p_event_id=>wwv_flow_imp.id(2121648011504701)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1702440544973414)
,p_name=>'Preview SQL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2010_SYN_OBJECT,P2010_SYN_SCHEMA,P2010_DB_LINK,P2010_REMOTE_SYN_OBJECT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P2010_SYN_OBJECT") !== '''' || ( $v("P2010_REMOTE_SYN_OBJECT") !== '''' && $v("P2010_DB_LINK") !== '''' )'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1702511514973415)
,p_event_id=>wwv_flow_imp.id(1702440544973414)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getSynonymDDL ( $v( "P2010_NAME" ), $v( "P2010_DB_LOCATION" ), $v( "P2010_SYN_SCHEMA" ), $v( "P2010_SYN_OBJECT" ), $v( "P2010_REMOTE_SYN_OBJECT" ), $v( "P2010_DB_LINK" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v("P2010_SYN_OBJECT") !== '''' || ( $v("P2010_REMOTE_SYN_OBJECT") !== '''' && $v("P2010_DB_LINK") !== '''' )'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8005842209485334)
,p_event_id=>wwv_flow_imp.id(1702440544973414)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_DDL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3000985696953545)
,p_name=>'P2010_NAME Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2010_NAME'
,p_condition_element=>'P2010_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3001369835953552)
,p_event_id=>wwv_flow_imp.id(3000985696953545)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Replace Spaces and Double Quotes'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2010_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3001873902953552)
,p_event_id=>wwv_flow_imp.id(3000985696953545)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_DDL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3002339371953552)
,p_event_id=>wwv_flow_imp.id(3000985696953545)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Preview SQL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getSynonymDDL ( $v( "P2010_NAME" ), $v( "P2010_DB_LOCATION" ), $v( "P2010_SYN_SCHEMA" ), $v( "P2010_SYN_OBJECT" ), $v( "P2010_REMOTE_SYN_OBJECT" ), $v( "P2010_DB_LINK" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v("P2010_SYN_OBJECT") !== '''' || ( $v("P2010_REMOTE_SYN_OBJECT") !== '''' && $v("P2010_DB_LINK") !== '''' )'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8005321742485329)
,p_name=>'Show/Hide Preview SQL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2010_DDL'
,p_condition_element=>'P2010_DDL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8005468226485330)
,p_event_id=>wwv_flow_imp.id(8005321742485329)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1702337722973413)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8005569392485331)
,p_event_id=>wwv_flow_imp.id(8005321742485329)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1702337722973413)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8005600389485332)
,p_event_id=>wwv_flow_imp.id(8005321742485329)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#preview_sql").text($v("P2010_DDL"));',
'Prism.highlightAll();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8005790917485333)
,p_event_id=>wwv_flow_imp.id(8005321742485329)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery("#preview_sql").text("");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8005937175485335)
,p_name=>'Submit CREATE'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1807924925696440)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8006020515485336)
,p_event_id=>wwv_flow_imp.id(8005937175485335)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1776617234216721)
,p_name=>'Show/Hide DB Link Items'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2010_DB_LOCATION'
,p_condition_element=>'P2010_DB_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1776786503216722)
,p_event_id=>wwv_flow_imp.id(1776617234216721)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_SYN_SCHEMA,P2010_SYN_OBJECT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1777079728216725)
,p_event_id=>wwv_flow_imp.id(1776617234216721)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_DB_LINK,P2010_REMOTE_SYN_OBJECT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1776895749216723)
,p_event_id=>wwv_flow_imp.id(1776617234216721)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_SYN_SCHEMA,P2010_SYN_OBJECT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1776986073216724)
,p_event_id=>wwv_flow_imp.id(1776617234216721)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_DB_LINK,P2010_REMOTE_SYN_OBJECT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1777321251216728)
,p_event_id=>wwv_flow_imp.id(1776617234216721)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_DB_LINK,P2010_REMOTE_SYN_OBJECT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1777472847216729)
,p_event_id=>wwv_flow_imp.id(1776617234216721)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_SYN_SCHEMA,P2010_SYN_OBJECT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1777111135216726)
,p_name=>'Hide P2010_DB_LOCATION'
,p_event_sequence=>70
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'NOT_EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_db_links ',
' where owner = :P2010_PARSING_SCHEMA'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1777234395216727)
,p_event_id=>wwv_flow_imp.id(1777111135216726)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2010_DB_LOCATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2000261023894307)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2010_OBJECT_TYPE := ''SYNONYM'';',
'',
':P2010_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_object(',
'    p_object_name     => :P2010_NAME,',
'    p_object_type     => :P2010_OBJECT_TYPE,',
'    p_parsing_schema  => :P2010_PARSING_SCHEMA,',
'    p_ddl             => :P2010_DDL );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(1807924925696440)
,p_internal_uid=>2000261023894307
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2000525334897501)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2010_OBJECT_ID,P2010_OBJECT_TYPE,P2010_NAME'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1807924925696440)
,p_process_when=>'P2010_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Synonym created successfully.'
,p_internal_uid=>2000525334897501
);
end;
/
prompt --application/pages/page_02015
begin
wwv_flow_imp_page.create_page(
 p_id=>2015
,p_name=>'Create View'
,p_alias=>'CREATE-VIEW'
,p_page_mode=>'MODAL'
,p_step_title=>'Create View'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215538527409730225)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'600'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEUTL/obj_views.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34964681692654985)
,p_plug_name=>'View Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(243017487674671656)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3205808446057440)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(243017487674671656)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8006704746485343)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(243017487674671656)
,p_button_name=>'PREVIEW'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>' Preview SQL'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3206239183057441)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(243017487674671656)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create View'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8006699398485342)
,p_branch_name=>'Preview SQL - P2016'
,p_branch_action=>'f?p=&APP_ID.:2016:&SESSION.::&DEBUG.:2016::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8006704746485343)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1702069430973410)
,p_name=>'P2015_OBJECT_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(34964681692654985)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1702618867973416)
,p_name=>'P2015_OBJECT_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(34964681692654985)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1774788167216702)
,p_name=>'P2015_PARSING_SCHEMA'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(34964681692654985)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003345351737471)
,p_name=>'P2015_DDL'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(34964681692654985)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3203085233057437)
,p_name=>'P2015_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(34964681692654985)
,p_prompt=>'View Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the view. The name must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3204362072057437)
,p_name=>'P2015_QUERY'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(34964681692654985)
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>18
,p_field_template=>wwv_flow_imp.id(492677350674053149)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'<p>Enter a valid SQL query for the view.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3207887328057458)
,p_computation_sequence=>20
,p_computation_item=>'P2015_QUERY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sql varchar2(32767);',
'begin',
'    l_sql := wwv_flow_utilities.remove_trailing_whitespace(:P2015_QUERY);',
'    l_sql := rtrim(l_sql,chr(10));',
'    l_sql := rtrim(l_sql,chr(13));',
'    l_sql := wwv_flow.trim_sql(',
'                 p_sql               => l_sql,',
'                 p_ends_in_semicolon => false,',
'                 p_do_substitutions  => false );',
'    return l_sql;',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(8006506924485341)
,p_computation_sequence=>30
,p_computation_item=>'P2015_DDL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''create view ''||wwv_flow_assert.enquote_name(:P2015_NAME)||chr(10)|| ',
'''as''||chr(10)||',
':P2015_QUERY||'';'''))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3208256517057458)
,p_validation_name=>'P2015_NAME valid & available'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2015_NAME,',
'    p_owner           => :P2015_PARSING_SCHEMA,',
'    p_object_type     => ''VIEW'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2015_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(3203085233057437)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(16001091844077323)
,p_validation_name=>'P2015_QUERY valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_parse_as_schema      => :P2015_PARSING_SCHEMA,',
'                            p_sql_query            => :P2015_QUERY );',
'',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2015_QUERY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(3204362072057437)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2102951744957372)
,p_name=>'Replace Spaces and Double Quotes'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2015_NAME'
,p_condition_element=>'P2015_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2103312601957380)
,p_event_id=>wwv_flow_imp.id(2102951744957372)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2015_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2015_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8006333522485339)
,p_name=>'Submit CREATE'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3206239183057441)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8006478629485340)
,p_event_id=>wwv_flow_imp.id(8006333522485339)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8006833282485344)
,p_name=>'Cancel Dialog'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3205808446057440)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8006913445485345)
,p_event_id=>wwv_flow_imp.id(8006833282485344)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3300558414085036)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2015_OBJECT_TYPE := ''VIEW'';',
'',
':P2015_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_object(',
'    p_object_name     => :P2015_NAME,',
'    p_object_type     => :P2015_OBJECT_TYPE,',
'    p_parsing_schema  => :P2015_PARSING_SCHEMA,',
'    p_ddl             => :P2015_DDL );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3206239183057441)
,p_internal_uid=>3300558414085036
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3400139474090776)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2015_OBJECT_ID,P2015_OBJECT_TYPE,P2015_NAME'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3206239183057441)
,p_process_when=>'P2015_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'View created successfully.'
,p_internal_uid=>3400139474090776
);
end;
/
prompt --application/pages/page_02016
begin
wwv_flow_imp_page.create_page(
 p_id=>2016
,p_name=>'Create View - Preview SQL'
,p_alias=>'CREATE-VIEW-PREVIEW-SQL'
,p_page_mode=>'MODAL'
,p_step_title=>'Create View - Preview SQL'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code_onload=>'Prism.highlightAll();'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8007032416485346)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql">&P2015_DDL.</code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30130444957605605)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8007140123485347)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8007032416485346)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11601068671719483)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(30130444957605605)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create View'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2015:&SESSION.:BRANCH_TO_PAGE_ACCEPT|CREATE:&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11601435850719484)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(30130444957605605)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2015:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11601835693719484)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(30130444957605605)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11602558062719517)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(11601835693719484)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11603095180719520)
,p_event_id=>wwv_flow_imp.id(11602558062719517)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_02020
begin
wwv_flow_imp_page.create_page(
 p_id=>2020
,p_name=>'Create Table'
,p_alias=>'CREATE-TABLE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Table'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserWizard#MIN#.js'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'800'
,p_dialog_width=>'1100'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2500606111718504)
,p_plug_name=>'Columns'
,p_region_name=>'wizardIG'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       c001 column_name,',
'       c002 data_type,',
'       c003 data_precision,',
'       c004 data_scale,',
'       c005 not_null,',
'       c006 default_value,',
'       c007 primary_key,',
'       c008 column_comments,',
'       n001 sort_order',
'  from wwv_flow_collections',
' where collection_name = ''TBL_WIZ_COLUMNS'' '))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Columns'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
,p_plug_footer=>'<br/><p>Double-click on any cell or click on the Edit button to enable editing.</p>'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2500866406718506)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2500920575718507)
,p_name=>'COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Column Name'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>32
,p_is_required=>true
,p_max_length=>128
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Enter the name of the column. Column name must be a valid Oracle identifier.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2501055341718508)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Data Type'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(21015224563508746)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Select Datatype -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Select the data type of the column. Precision and Scale columns will be enabled or disabled depending on the selected data type.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2501146258718509)
,p_name=>'DATA_PRECISION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_PRECISION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Precision'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>60
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Enter precision. Precision must be a valid positive integer. This field will be enabled only if the selected data type supports specifying precision.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2501285771718510)
,p_name=>'DATA_SCALE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_SCALE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Scale / Length'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>70
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Enter Scale or Length. Scale or Length must be a valid integer. This field will be enabled only if the selected data type supports specifying Scale or Length. '
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2501379384718511)
,p_name=>'NOT_NULL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NOT_NULL'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Not Null'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>80
,p_value_alignment=>'CENTER'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'If selected, column will be created with <code>not null</code> clause.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2501592264718513)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6804127649188039)
,p_name=>'COLUMN_COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_COMMENTS'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Comments'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Enter comments for the column.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(7500525297395303)
,p_name=>'PRIMARY_KEY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PRIMARY_KEY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Primary Key'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>90
,p_value_alignment=>'CENTER'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>false
,p_include_in_export=>true
,p_help_text=>'Select this check box, if the column is a primary key column. '
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9405569858786337)
,p_name=>'DEFAULT_VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DEFAULT_VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Default Expression'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter default value expression. It should be a valid SQL expression, but custom functions are not allowed.</p>',
'',
'<p>Example default value expressions</p>',
'<ul>',
'<li>Text: <code>''Oracle APEX''</code></li>',
'<li>Number: <code>42</code></li>',
'<li>Built-in Function: <code>sysdate</code></li>',
'</ul>'))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13801809376557902)
,p_name=>'SORT_ORDER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SORT_ORDER'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sort Order'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13801916537557903)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_required_patch=>wwv_flow_imp.id(1080926199001296276)
,p_column_comment=>'This column is useful if we want to provide bulk delete of columns or bulk re-ordering. But I think it''s not required for this given use case'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(2500773142718505)
,p_internal_uid=>2500773142718505
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_toolbar_buttons=>null
,p_add_button_label=>'Add Column'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>300
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>'objectBrowserWizard.initIG'
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(5306711573062761)
,p_interactive_grid_id=>wwv_flow_imp.id(2500773142718505)
,p_static_id=>'53068'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(5306917066062763)
,p_report_id=>wwv_flow_imp.id(5306711573062761)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2201167637663387)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(7500525297395303)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2901041609174693)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(9405569858786337)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>125
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5307498287062772)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(2500866406718506)
,p_is_visible=>false
,p_is_frozen=>false
,p_width=>40
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5308355397062780)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(2500920575718507)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>200
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5309245599062785)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(2501055341718508)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>150
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5310114124062789)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(2501146258718509)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>70
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5311046556062793)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(2501285771718510)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5311967983062797)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(2501379384718511)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>70
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5401893195291862)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(2501592264718513)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>40
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7601140747463102)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(6804127649188039)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(19401241970442108)
,p_view_id=>wwv_flow_imp.id(5306917066062763)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(13801809376557902)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2501882821718516)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4405175496732349)
,p_plug_name=>'Table Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5615976302134050)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2501882821718516)
,p_button_name=>'PREVIEW'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Preview SQL'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2502240944718520)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2501882821718516)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Table'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2501931893718517)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2501882821718516)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7500445767395302)
,p_branch_name=>'Preview SQL'
,p_branch_action=>'f?p=&APP_ID.:2022:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(5615976302134050)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1774830044216703)
,p_name=>'P2020_PARSING_SCHEMA'
,p_item_sequence=>70
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2500412532718502)
,p_name=>'P2020_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4405175496732349)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the table. The name must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5615578262134046)
,p_name=>'P2020_OBJECT_TYPE'
,p_item_sequence=>80
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5615652531134047)
,p_name=>'P2020_OBJECT_ID'
,p_item_sequence=>90
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6001986635547815)
,p_name=>'P2020_SEMANTICS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4405175496732349)
,p_item_default=>'C'
,p_prompt=>'Semantics'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:BYTE;B,CHAR;C'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Default'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the semantics option for the text columns. When CHAR is selected, then the number of characters is used to determine the storage and when BYTE is selected, then the number of bytes is used to determine the storage for the text columns. Choosin'
||'g "Default" will default to the database setting. If you are not sure about this setting, then choose "Default".'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9403235454786314)
,p_name=>'P2020_COMMENTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4405175496732349)
,p_prompt=>'Comments'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter comments for the table. These comments will be added to the table object.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2504626591718544)
,p_validation_name=>'P2020_NAME valid & available'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2020_NAME,',
'    p_owner           => :P2020_PARSING_SCHEMA,',
'    p_object_type     => ''TABLE'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2020_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2500412532718502)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5804916342163319)
,p_validation_name=>'P2020_COMMENTS length <= 4000'
,p_validation_sequence=>30
,p_validation=>'length( :P2020_COMMENTS ) <= 4000'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Comments length should be less than or equals to 4000 characters. '
,p_associated_item=>wwv_flow_imp.id(9403235454786314)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2504728167718545)
,p_validation_name=>'No Duplicate Columns'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_text    varchar2(4000)  := null;',
'begin',
'    select listagg(c001,  '', '' on overflow truncate) within group (order by c001)',
'      into l_error_text',
'      from (',
'          select distinct c001',
'            from wwv_flow_collections',
'           where collection_name = ''TBL_WIZ_COLUMNS''',
'           group by c001',
'          having count(*) > 1 );',
'',
'    if l_error_text is not null then',
'        return wwv_flow_lang.message(''OB.DUP_COL_FOUND'',wwv_flow_escape.html(l_error_text));',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2504846516718546)
,p_tabular_form_region_id=>wwv_flow_imp.id(2500606111718504)
,p_validation_name=>'COLUMN_NAME Valid'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_builder.is_valid_identifier(:COLUMN_NAME) ',
'and :COLUMN_NAME not in (''DATE'',''NUMBER'',''VARCHAR2'',''CLOB'',''BLOB'')'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Invalid Column Name "&COLUMN_NAME."'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2505184353718549)
,p_tabular_form_region_id=>wwv_flow_imp.id(2500606111718504)
,p_validation_name=>'COLUMN_NAME reserved word'
,p_validation_sequence=>60
,p_validation=>'return not wwv_flow_f4500_ob_wiz_dev.is_database_reserved_word( p_word => upper(:COLUMN_NAME) );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The identified column name is an Oracle reserved word.  Please choose another name.'
,p_associated_column=>'COLUMN_NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2504996094718547)
,p_tabular_form_region_id=>wwv_flow_imp.id(2500606111718504)
,p_validation_name=>'SCALE not null'
,p_validation_sequence=>70
,p_validation=>'DATA_SCALE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must have some value.'
,p_validation_condition=>':DATA_TYPE in (''VARCHAR2'', ''NVARCHAR2'', ''RAW'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'DATA_SCALE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7500342986395301)
,p_validation_name=>'At least one column'
,p_validation_sequence=>80
,p_validation=>'wwv_flow_collection.collection_member_count( p_collection_name => ''TBL_WIZ_COLUMNS'') > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Table must have at least one column.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1778125252216736)
,p_tabular_form_region_id=>wwv_flow_imp.id(2500606111718504)
,p_validation_name=>'DEFAULT_VALUE valid SQL expression'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_code_exec_dev.check_code(',
'    p_type     => wwv_flow_code_exec_dev.c_check_expression,',
'    p_code     => :DEFAULT_VALUE,',
'    p_language => wwv_flow_code_exec.c_sql ) is null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Invalid default expression <code>&DEFAULT_VALUE.</code>. Please enter a valid SQL expression.'
,p_validation_condition=>'DEFAULT_VALUE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'DEFAULT_VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5614350605134034)
,p_tabular_form_region_id=>wwv_flow_imp.id(2500606111718504)
,p_validation_name=>'DATA_PRECISION valid postive integer'
,p_validation_sequence=>100
,p_validation=>':DATA_PRECISION = floor( :DATA_PRECISION ) and to_number( :DATA_PRECISION ) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#COLUMN_HEADER# must be a valid positive integer'
,p_validation_condition=>'DATA_PRECISION'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'DATA_PRECISION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5614471207134035)
,p_tabular_form_region_id=>wwv_flow_imp.id(2500606111718504)
,p_validation_name=>'DATA_SCALE valid integer'
,p_validation_sequence=>110
,p_validation=>':DATA_SCALE = floor( :DATA_SCALE )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#COLUMN_HEADER# must be a valid integer'
,p_validation_condition=>'DATA_SCALE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'DATA_SCALE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5805027396163320)
,p_tabular_form_region_id=>wwv_flow_imp.id(2500606111718504)
,p_validation_name=>'COLUMN_COMMENTS length <= 4000'
,p_validation_sequence=>120
,p_validation=>'length( :COLUMN_COMMENTS ) <= 4000'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Comments length should be less than or equals to 4000 characters. '
,p_associated_column=>'COLUMN_COMMENTS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2502027652718518)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2501931893718517)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502194861718519)
,p_event_id=>wwv_flow_imp.id(2502027652718518)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2502380962718521)
,p_name=>'Submit CREATE'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2502240944718520)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502490299718522)
,p_event_id=>wwv_flow_imp.id(2502380962718521)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2503934099718537)
,p_name=>'Disable & Clear'
,p_event_sequence=>25
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2500606111718504)
,p_triggering_element=>'DATA_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2504040866718538)
,p_event_id=>wwv_flow_imp.id(2503934099718537)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_SCALE,DATA_PRECISION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2504137682718539)
,p_event_id=>wwv_flow_imp.id(2503934099718537)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_SCALE,DATA_PRECISION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2502505552718523)
,p_name=>'Disable/Enable - NUMBER'
,p_event_sequence=>30
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2500606111718504)
,p_triggering_element=>'DATA_TYPE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NUMBER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502673089718524)
,p_event_id=>wwv_flow_imp.id(2502505552718523)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_SCALE,DATA_PRECISION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2503067102718528)
,p_name=>'Disable/Enable - FLOAT'
,p_event_sequence=>50
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2500606111718504)
,p_triggering_element=>'DATA_TYPE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FLOAT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2503195526718529)
,p_event_id=>wwv_flow_imp.id(2503067102718528)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_PRECISION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2503265637718530)
,p_event_id=>wwv_flow_imp.id(2503067102718528)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_SCALE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2502754504718525)
,p_name=>'Disable/Enable - VARCHAR & Others'
,p_event_sequence=>60
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2500606111718504)
,p_triggering_element=>'DATA_TYPE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'VARCHAR2,NVARCHAR2,RAW,CHAR,NCHAR,TIMESTAMP,TIMESTAMP WITH TIME ZONE,TIMESTAMP WITH LOCAL TIME ZONE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502879032718526)
,p_event_id=>wwv_flow_imp.id(2502754504718525)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_SCALE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502971793718527)
,p_event_id=>wwv_flow_imp.id(2502754504718525)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_PRECISION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2503384376718531)
,p_name=>'Disable/Enable - INTERVAL YEAR TO MONTH'
,p_event_sequence=>70
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2500606111718504)
,p_triggering_element=>'DATA_TYPE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'INTERVAL YEAR TO MONTH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2503449356718532)
,p_event_id=>wwv_flow_imp.id(2503384376718531)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_PRECISION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2503592318718533)
,p_event_id=>wwv_flow_imp.id(2503384376718531)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_SCALE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2503693986718534)
,p_name=>'Disable/Enable - INTERVAL DAY TO SECOND'
,p_event_sequence=>80
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2500606111718504)
,p_triggering_element=>'DATA_TYPE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'INTERVAL DAY TO SECOND'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2503789529718535)
,p_event_id=>wwv_flow_imp.id(2503693986718534)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DATA_SCALE,DATA_PRECISION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10108334663592031)
,p_name=>'Replace Spaces and Double Quotes - P2020_NAME'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2020_NAME'
,p_condition_element=>'P2020_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10108429550592032)
,p_event_id=>wwv_flow_imp.id(10108334663592031)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2020_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2020_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10108576632592033)
,p_name=>'Replace Spaces and Double Quotes - COLUMN_NAME'
,p_event_sequence=>120
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2500606111718504)
,p_triggering_element=>'COLUMN_NAME'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'COLUMN_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10108684025592034)
,p_event_id=>wwv_flow_imp.id(10108576632592033)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'COLUMN_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''COLUMN_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13802093547557904)
,p_name=>'Add Actions to IG Menu'
,p_event_sequence=>140
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13802192410557905)
,p_event_id=>wwv_flow_imp.id(13802093547557904)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#wizardIG_ig_row_actions_menu").menu("option").items.push({type:"action", labelKey:"OB.MOVE_UP", action:"selection-move-up"});',
'',
'$("#wizardIG_ig_row_actions_menu").menu("option").items.push({type:"action", labelKey:"OB.MOVE_DOWN", action:"selection-move-down"});'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18602012195796705)
,p_name=>'Enable/Disable DEFAULT_VALUE'
,p_event_sequence=>150
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2500606111718504)
,p_triggering_element=>'DEFAULT_VALUE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'PRIMARY_KEY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'focusin'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18602160979796706)
,p_event_id=>wwv_flow_imp.id(18602012195796705)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DEFAULT_VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18602203816796707)
,p_event_id=>wwv_flow_imp.id(18602012195796705)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DEFAULT_VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18602316447796708)
,p_event_id=>wwv_flow_imp.id(18602012195796705)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'DEFAULT_VALUE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5803152500163301)
,p_name=>'Submit PREVIEW'
,p_event_sequence=>160
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5615976302134050)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5803239152163302)
,p_event_id=>wwv_flow_imp.id(5803152500163301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5804781291163317)
,p_name=>'Resize Columns IG'
,p_event_sequence=>170
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'apexwindowresized'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5804828656163318)
,p_event_id=>wwv_flow_imp.id(5804781291163317)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.region("wizardIG").widget().height( window.innerHeight - 320 );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5615735577134048)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2020_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_table(',
'                        p_name               => :P2020_NAME,',
'                        p_parsing_schema     => :P2020_PARSING_SCHEMA,',
'                        p_semantics          => :P2020_SEMANTICS,',
'                        p_comments           => :P2020_COMMENTS,',
'                        p_columns_collection => ''TBL_WIZ_COLUMNS'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2502240944718520)
,p_internal_uid=>5615735577134048
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5615835579134049)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2020_NAME,P2020_OBJECT_ID,P2020_OBJECT_TYPE'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2502240944718520)
,p_process_success_message=>'Table created successfully.'
,p_internal_uid=>5615835579134049
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2504403716718542)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(2500606111718504)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Collection TBL_WIZ_COLUMNS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_collection_name varchar2(20) := ''TBL_WIZ_COLUMNS'';',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        wwv_flow_collection.add_member(',
'            p_collection_name => l_collection_name,',
'            p_c001            => :COLUMN_NAME,',
'            p_c002            => :DATA_TYPE,',
'            p_c003            => :DATA_PRECISION,',
'            p_c004            => :DATA_SCALE,',
'            p_c005            => :NOT_NULL,',
'            p_c006            => case when :PRIMARY_KEY = ''N'' then :DEFAULT_VALUE end,',
'            p_c007            => :PRIMARY_KEY,',
'            p_c008            => :COLUMN_COMMENTS,',
'            p_n001            => :SORT_ORDER );',
'    when ''U'' then',
'        wwv_flow_collection.update_member(',
'            p_collection_name => l_collection_name,',
'            p_seq             => :SEQ_ID,',
'            p_c001            => :COLUMN_NAME,',
'            p_c002            => :DATA_TYPE,',
'            p_c003            => :DATA_PRECISION,',
'            p_c004            => :DATA_SCALE,',
'            p_c005            => :NOT_NULL,',
'            p_c006            => case when :PRIMARY_KEY = ''N'' then :DEFAULT_VALUE end,',
'            p_c007            => :PRIMARY_KEY,',
'            p_c008            => :COLUMN_COMMENTS,',
'            p_n001            => :SORT_ORDER );',
'    when ''D'' then',
'        wwv_flow_collection.delete_member(',
'            p_collection_name => l_collection_name,',
'            p_seq             => :SEQ_ID );',
'    end case;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2504403716718542
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6801180864730230)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate PK_SOURCE in TBL_WIZ_COLUMNS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_seq_id number;',
'    l_collection_name varchar2(20) := ''TBL_WIZ_COLUMNS'';',
'begin',
'    -- this process is executed only when 1 column is selected as PK column',
'    -- so this query must execute with out any exception',
'    select seq_id',
'      into l_seq_id',
'      from wwv_flow_collections',
'     where collection_name = l_collection_name',
'       and c007            = ''Y''; ',
'',
'    -- for PK column, set c009 value as IDENTITY',
'    -- we need this info to add default value for PK column',
'    wwv_flow_collection.update_member_attribute (',
'        p_collection_name => l_collection_name,',
'        p_seq             => l_seq_id,',
'        p_attr_number     => 9,',
'        p_attr_value      => ''IDENTITY'' );     ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from sys.dual',
' where (',
'-- only one column selected as PK',
'select count(*)',
'  from wwv_flow_collections',
' where collection_name = ''TBL_WIZ_COLUMNS''',
'   and c007            = ''Y'' ) = 1',
'and (',
'-- and data type is NUMBER or FLOAT for PK column',
'select count(*)',
'  from wwv_flow_collections',
' where collection_name = ''TBL_WIZ_COLUMNS''',
'   and c007            = ''Y''',
'   and c002            in (''NUMBER'',''FLOAT'') ) = 1'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>6801180864730230
);
end;
/
prompt --application/pages/page_02022
begin
wwv_flow_imp_page.create_page(
 p_id=>2022
,p_name=>'Create Table - Preview SQL'
,p_alias=>'CREATE-TABLE-PREVIEW-SQL'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Table - Preview SQL'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code_onload=>'Prism.highlightAll();'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9406644390786348)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql">&P2022_DDL.</code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13405116462312627)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5902597092917328)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(13405116462312627)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Table'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:2020:&SESSION.:BRANCH_TO_PAGE_ACCEPT|CREATE:&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9406420096786346)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(9406644390786348)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5902845615917331)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(13405116462312627)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2020:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5903223438917332)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(13405116462312627)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5614140773134032)
,p_name=>'P2022_DDL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(9406644390786348)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5614241277134033)
,p_computation_sequence=>10
,p_computation_item=>'P2022_DDL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_wiz_dev.get_table_ddl(',
'    p_name               => :P2020_NAME,',
'    p_parsing_schema     => :P2020_PARSING_SCHEMA,',
'    p_semantics          => :P2020_SEMANTICS,',
'    p_comments           => :P2020_COMMENTS,',
'    p_columns_collection => ''TBL_WIZ_COLUMNS'' )'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5907288793963301)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5903223438917332)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5907385547963302)
,p_event_id=>wwv_flow_imp.id(5907288793963301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_02025
begin
wwv_flow_imp_page.create_page(
 p_id=>2025
,p_name=>'Create Index'
,p_alias=>'CREATE-INDEX'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Index'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserWizard#MIN#.js'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'850'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5217825444548396)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5908732178963316)
,p_plug_name=>'Index Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5910447701963333)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>35
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(7103131374724921)
,p_name=>'Table Indexes'
,p_template=>wwv_flow_imp.id(717419046555820782)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.index_name,',
'       c.column_name, ',
'       c.column_position, ',
'       c.column_length, ',
'       c.descend ',
'  from sys.dba_ind_columns c',
' where c.table_name  = :P2025_TABLE ',
'   and c.table_owner = :P2025_PARSING_SCHEMA',
' order by c.index_name,',
'          c.column_position'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P2025_TABLE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No indexes found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7103299327724922)
,p_query_column_id=>1
,p_column_alias=>'INDEX_NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Index Name'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7103337674724923)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Column'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7103472599724924)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>30
,p_column_heading=>'Position'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7103513988724925)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_LENGTH'
,p_column_display_sequence=>40
,p_column_heading=>'Length'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7103655267724926)
,p_query_column_id=>5
,p_column_alias=>'DESCEND'
,p_column_display_sequence=>50
,p_column_heading=>'Order'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(8881062859899513)
,p_name=>'Spatial Registry'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name,',
'       c.srid,',
'       w.cs_name ',
'  from mdsys.user_sdo_geom_metadata c,',
'       mdsys.cs_srs w',
' where c.srid = w.srid',
'   and c.table_name  = :P2025_TABLE',
'   and c.column_name = :P2025_COL1'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P2025_TABLE,P2025_COL1'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Column &P2025_COL1!HTML. not found in Spatial Registry.'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P2025_PARSING_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2701288120866875)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Column'
,p_use_as_row_header=>'Y'
,p_column_link=>'javascript:objectBrowserWizard.branchToRegisterColumn(''P2025_EDIT'',''YES'')'
,p_column_linktext=>'#COLUMN_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2701636741866878)
,p_query_column_id=>2
,p_column_alias=>'SRID'
,p_column_display_sequence=>30
,p_column_heading=>'Coordinate System ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2702014594866879)
,p_query_column_id=>3
,p_column_alias=>'CS_NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Coordinate System Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2687915014362819)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5217825444548396)
,p_button_name=>'REGISTER_COLUMN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Register Column'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2716283289829896)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5217825444548396)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Index'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9406710786786349)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(5910447701963333)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2716635291829898)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5217825444548396)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2689433381362834)
,p_branch_name=>'Spatial Metadata'
,p_branch_action=>'f?p=&APP_ID.:2026:&SESSION.::&DEBUG.:2026:P2026_EDIT,P2026_TABLE,P2026_COLUMN_NAME:&P2025_EDIT.,&P2025_TABLE.,&P2025_COL1.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2687915014362819)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775056832216705)
,p_name=>'P2025_PARSING_SCHEMA'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2686103120362801)
,p_name=>'P2025_POINTS_ONLY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_item_default=>'N'
,p_prompt=>'Table Contains Only Point Objects'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enable this switch if the table contains <em>only</em> Point geometry objects, in order to get a more efficient index structure.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2686948555362809)
,p_name=>'P2025_COLUMN_HAS_METADATA'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2690968291362849)
,p_name=>'P2025_EDIT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5908803536963317)
,p_name=>'P2025_TABLE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d,',
'       table_name r',
'  from sys.dba_tables',
' where owner      = :P2025_PARSING_SCHEMA',
'   and table_name not like ''DR$%''',
'   and table_name not like ''BIN$%''',
' order by 1'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a table you wish to create the index for.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5908942014963318)
,p_name=>'P2025_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_prompt=>'Index Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the index. The name must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore. This field contains an automatically generated name by default, based on the selected table name and type'
||' of index.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5909135397963320)
,p_name=>'P2025_INDEX_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_item_default=>'N'
,p_prompt=>'Type of Index'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE INDEX TYPES'
,p_lov=>'.'||wwv_flow_imp.id(16028009107759017)||'.'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the type of index.',
'<ul>',
'<li>Normal indexes are generally used for indexing <code>NUMBER</code> and <code>VARCHAR</code> data.</li>',
'<li>Text indexes are generally used for indexing <code>CLOB</code> columns.</li>',
'<li>Spatial indexes are generally used for indexing <code>SDO_GEOMETRY</code> columns.</li>',
'</ul>'))
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5909285236963321)
,p_name=>'P2025_UNIQUE_INDEX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_item_default=>'N'
,p_prompt=>'Unique Index'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indexes can be unique or non-unique. Unique indexes guarantee that no two rows of a table have duplicate values in the key column (or columns). Non-unique indexes do not impose this restriction on the column values.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5909394248963322)
,p_name=>'P2025_COL1'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_prompt=>'Index Column 1'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name ||'' (''||data_type||'')'' d,',
'       column_name r',
'  from sys.dba_tab_columns',
' where owner      = :P2025_PARSING_SCHEMA',
'   and table_name = :P2025_TABLE',
'   and column_id is not null',
'   and ( :P2025_INDEX_TYPE != ''S'' or data_type  = ''SDO_GEOMETRY'')',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2025_TABLE,P2025_INDEX_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the column for the first position in index.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5909413489963323)
,p_name=>'P2025_COL2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_prompt=>'Index Column 2'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name ||'' (''||data_type||'')'' d,',
'       column_name r',
'  from sys.dba_tab_columns',
' where owner       = :P2025_PARSING_SCHEMA',
'   and table_name  = :P2025_TABLE',
'   and column_id   is not null',
'   and column_name != :P2025_COL1',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2025_TABLE,P2025_COL1'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the column for the second position in index.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5909522227963324)
,p_name=>'P2025_COL3'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_prompt=>'Index Column 3'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name ||'' (''||data_type||'')'' d,',
'       column_name r',
'  from sys.dba_tab_columns',
' where owner       = :P2025_PARSING_SCHEMA',
'   and table_name  = :P2025_TABLE',
'   and column_id   is not null',
'   and column_name not in ( :P2025_COL1, :P2025_COL2 )',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2025_TABLE,P2025_COL1,P2025_COL2'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the column for the third position in index.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5909629186963325)
,p_name=>'P2025_COL4'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_prompt=>'Index Column 4'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name ||'' (''||data_type||'')'' d,',
'       column_name r',
'  from sys.dba_tab_columns',
' where owner       = :P2025_PARSING_SCHEMA',
'   and table_name  = :P2025_TABLE',
'   and column_id   is not null',
'   and column_name not in ( :P2025_COL1, :P2025_COL2, :P2025_COL3 )',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2025_TABLE,P2025_COL1,P2025_COL2,P2025_COL3'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the column for the fourth position in index.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5910175195963330)
,p_name=>'P2025_DDL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(5910447701963333)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5910281923963331)
,p_name=>'P2025_OBJECT_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5910399736963332)
,p_name=>'P2025_OBJECT_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5912105932963350)
,p_name=>'P2025_USE_V2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(5908732178963316)
,p_item_default=>'Y'
,p_prompt=>'System Managed Index'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify whether to use a <em>system managed</em> spatial index, which is recommended. If enabled, &PRODUCT_NAME. creates a spatial index of the <strong>MDSYS.SPATIAL_INDEX_V2</strong> type, if disabled, <strong>MDSYS.SPATIAL_INDEX</strong> will be us'
||'ed.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5911612483963345)
,p_validation_name=>'P2025_TABLE exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_objects',
' where object_name = :P2025_TABLE',
'   and owner       = :P2025_PARSING_SCHEMA',
'   and object_type = ''TABLE'''))
,p_validation_type=>'EXISTS'
,p_error_message=>'Table &P2025_TABLE!HTML. does not exist. Note that the table name is case-sensitive.'
,p_validation_condition=>'P2025_TABLE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(5908803536963317)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5911940649963348)
,p_validation_name=>'P2020_NAME valid & available'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2025_NAME,',
'    p_owner           => :P2025_PARSING_SCHEMA,',
'    p_object_type     => ''INDEX'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2025_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(5908942014963318)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5912031979963349)
,p_validation_name=>'Spatial Index - Valid Column'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_tab_columns',
' where owner       = :P2025_PARSING_SCHEMA',
'   and table_name  = :P2025_TABLE',
'   and column_name = :P2025_COL1',
'   and data_type   = ''SDO_GEOMETRY'''))
,p_validation_type=>'EXISTS'
,p_error_message=>'Selected column datatype can not be used for spatial index.'
,p_validation_condition=>':P2025_INDEX_TYPE = ''S'' and :P2025_COL1 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5909394248963322)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2688960646362829)
,p_validation_name=>'Spatial Index - Has Spacial Metadata'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_wiz_dev.get_geom_metadata(',
'    p_owner        => :P2025_PARSING_SCHEMA,',
'    p_table_name   => :P2025_TABLE,',
'    p_column_name  => :P2025_COL1 ) is not null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Column &P2025_COL1!HTML. not present in spatial registry.'
,p_validation_condition=>'P2025_INDEX_TYPE'
,p_validation_condition2=>'S'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2716283289829896)
,p_associated_item=>wwv_flow_imp.id(5909394248963322)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2689064521362830)
,p_validation_name=>'Spatial Index - Table Contains Only Points'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_wiz_dev.validate_gtype(',
'    p_table_name     => :P2025_TABLE,',
'    p_owner          => :P2025_PARSING_SCHEMA,',
'    p_column_name    => :P2025_COL1,',
'    p_gtype          => 2001 )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Table contains geometry objects which are not points. Review the SDO_GEOMETRY.SDO_GTYPE attribute.'
,p_validation_condition=>':P2025_INDEX_TYPE = ''S'' and :P2025_POINTS_ONLY = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2716283289829896)
,p_associated_item=>wwv_flow_imp.id(5909394248963322)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5909799701963326)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2716635291829898)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5909879624963327)
,p_event_id=>wwv_flow_imp.id(5909799701963326)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5909996237963328)
,p_name=>'Submit CREATE'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2716283289829896)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5910018436963329)
,p_event_id=>wwv_flow_imp.id(5909996237963328)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5910564301963334)
,p_name=>'Set P2025_NAME'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_TABLE,P2025_INDEX_TYPE'
,p_condition_element=>'P2025_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5910658524963335)
,p_event_id=>wwv_flow_imp.id(5910564301963334)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_wiz_dev.generate_name (',
'    p_owner  => :P2025_PARSING_SCHEMA,',
'    p_name   => :P2025_TABLE,',
'    p_suffix => case :P2025_INDEX_TYPE',
'                    when ''N'' then ''_IDX''',
'                    when ''T'' then ''_CTX''',
'                    when ''S'' then ''_SX''',
'                end )'))
,p_attribute_07=>'P2025_TABLE,P2025_PARSING_SCHEMA,P2025_INDEX_TYPE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5910724581963336)
,p_name=>'P2025_COL1 Hide/Show Columns '
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_COL1'
,p_condition_element=>'P2025_COL1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2687315233362813)
,p_event_id=>wwv_flow_imp.id(5910724581963336)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8881062859899513)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2025_INDEX_TYPE'
,p_client_condition_expression=>'S'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5910892116963337)
,p_event_id=>wwv_flow_imp.id(5910724581963336)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_COL2'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2025_INDEX_TYPE'
,p_client_condition_expression=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2687061706362810)
,p_event_id=>wwv_flow_imp.id(5910724581963336)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_COLUMN_HAS_METADATA'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_wiz_dev.get_geom_metadata(',
'    p_owner        => :P2025_PARSING_SCHEMA,',
'    p_table_name   => :P2025_TABLE,',
'    p_column_name  => :P2025_COL1 )'))
,p_attribute_07=>'P2025_TABLE,P2025_COL1'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2025_INDEX_TYPE'
,p_client_condition_expression=>'S'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5910915820963338)
,p_event_id=>wwv_flow_imp.id(5910724581963336)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_COL2,P2025_COL3,P2025_COL4'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2687162632362811)
,p_event_id=>wwv_flow_imp.id(5910724581963336)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8881062859899513)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2025_INDEX_TYPE'
,p_client_condition_expression=>'S'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2688289898362822)
,p_event_id=>wwv_flow_imp.id(5910724581963336)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_COLUMN_HAS_METADATA'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2687249844362812)
,p_event_id=>wwv_flow_imp.id(5910724581963336)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8881062859899513)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2025_INDEX_TYPE'
,p_client_condition_expression=>'S'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5911006359963339)
,p_name=>'P2025_COL2 Hide/Show Columns '
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_COL2'
,p_condition_element=>'P2025_COL2'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5911160807963340)
,p_event_id=>wwv_flow_imp.id(5911006359963339)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_COL3'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5911242414963341)
,p_event_id=>wwv_flow_imp.id(5911006359963339)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_COL3,P2025_COL4'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5911357875963342)
,p_name=>'P2025_COL3 Hide/Show Column '
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_COL3'
,p_condition_element=>'P2025_COL3'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5911490564963343)
,p_event_id=>wwv_flow_imp.id(5911357875963342)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_COL4'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5911508779963344)
,p_event_id=>wwv_flow_imp.id(5911357875963342)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_COL4'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2686325291362803)
,p_name=>'Show/Hide Spatial Columns'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_INDEX_TYPE'
,p_condition_element=>'P2025_INDEX_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'S'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2686445464362804)
,p_event_id=>wwv_flow_imp.id(2686325291362803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_USE_V2,P2025_POINTS_ONLY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2686578822362805)
,p_event_id=>wwv_flow_imp.id(2686325291362803)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_USE_V2,P2025_POINTS_ONLY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2687438386362814)
,p_event_id=>wwv_flow_imp.id(2686325291362803)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8881062859899513)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2688812320362828)
,p_event_id=>wwv_flow_imp.id(2686325291362803)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2716283289829896)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9405292682786334)
,p_event_id=>wwv_flow_imp.id(2686325291362803)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2687915014362819)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2686663979362806)
,p_name=>'Show/Hide P2025_UNIQUE_INDEX'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_INDEX_TYPE'
,p_condition_element=>'P2025_INDEX_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2686723315362807)
,p_event_id=>wwv_flow_imp.id(2686663979362806)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_UNIQUE_INDEX'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2686859934362808)
,p_event_id=>wwv_flow_imp.id(2686663979362806)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_UNIQUE_INDEX'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2688336356362823)
,p_name=>'Show/Hide Buttons'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_COLUMN_HAS_METADATA'
,p_condition_element=>'P2025_COLUMN_HAS_METADATA'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2688477689362824)
,p_event_id=>wwv_flow_imp.id(2688336356362823)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2687915014362819)
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.item("P2025_INDEX_TYPE").getValue() === ''S'' && apex.item("P2025_COL1").getValue() !== '''''
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2688703182362827)
,p_event_id=>wwv_flow_imp.id(2688336356362823)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2716283289829896)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2688580463362825)
,p_event_id=>wwv_flow_imp.id(2688336356362823)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2687915014362819)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2688659014362826)
,p_event_id=>wwv_flow_imp.id(2688336356362823)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2716283289829896)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2025_INDEX_TYPE'
,p_client_condition_expression=>'S'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2689183410362831)
,p_name=>'Preview SQL'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_TABLE,P2025_INDEX_TYPE,P2025_UNIQUE_INDEX,P2025_COL1,P2025_COL2,P2025_COL3,P2025_COL4,P2025_USE_V2,P2025_POINTS_ONLY'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P2025_TABLE").getValue() !== "" && apex.item("P2025_NAME").getValue() !== "" && apex.item("P2025_COL1").getValue() !== "" '
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2689247946362832)
,p_event_id=>wwv_flow_imp.id(2689183410362831)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getIndexDDL( $v( "P2025_TABLE" ), $v( "P2025_NAME" ), $v( "P2025_UNIQUE_INDEX" ), $v( "P2025_COL1" ), $v( "P2025_COL2" ), $v( "P2025_COL3" ), $v( "P2025_COL4" ), $v( "P2025_INDEX_TYPE" ), $v( "P2025_USE_V2" ), $v( "P2025_POINTS_ON'
||'LY" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2689389002362833)
,p_event_id=>wwv_flow_imp.id(2689183410362831)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_DDL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2691027222362850)
,p_name=>'Submit REGISTER_COLUMN'
,p_event_sequence=>110
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2687915014362819)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7101176573724901)
,p_event_id=>wwv_flow_imp.id(2691027222362850)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'objectBrowserWizard.branchToRegisterColumn(''P2025_EDIT'',''NO'');'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7101376427724903)
,p_name=>'Hide P2025_COL2, P2025_COL3, P2025_COL4'
,p_event_sequence=>120
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7101429977724904)
,p_event_id=>wwv_flow_imp.id(7101376427724903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_COL2,P2025_COL3,P2025_COL4'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7101571759724905)
,p_name=>'Hide REGISTER_COLUMN'
,p_event_sequence=>130
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7101654446724906)
,p_event_id=>wwv_flow_imp.id(7101571759724905)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2687915014362819)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7102565191724915)
,p_name=>'Show/Hide Table Indexes'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_TABLE'
,p_condition_element=>'P2025_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7103750603724927)
,p_event_id=>wwv_flow_imp.id(7102565191724915)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(7103131374724921)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7103838649724928)
,p_event_id=>wwv_flow_imp.id(7102565191724915)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(7103131374724921)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7103921257724929)
,p_event_id=>wwv_flow_imp.id(7102565191724915)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(7103131374724921)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10105640227592004)
,p_name=>'P2025_NAME Change'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_NAME'
,p_condition_element=>'P2025_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10105712637592005)
,p_event_id=>wwv_flow_imp.id(10105640227592004)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Replace Spaces and Double Quotes'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2025_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10105861446592006)
,p_event_id=>wwv_flow_imp.id(10105640227592004)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Preview SQL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getIndexDDL( $v( "P2025_TABLE" ), $v( "P2025_NAME" ), $v( "P2025_UNIQUE_INDEX" ), $v( "P2025_COL1" ), $v( "P2025_COL2" ), $v( "P2025_COL3" ), $v( "P2025_COL4" ), $v( "P2025_INDEX_TYPE" ), $v( "P2025_USE_V2" ), $v( "P2025_POINTS_ON'
||'LY" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.item("P2025_TABLE").getValue() !== "" && apex.item("P2025_COL1").getValue() !== "" '
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10105960298592007)
,p_event_id=>wwv_flow_imp.id(10105640227592004)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2025_DDL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8002894210485304)
,p_name=>'Show/Hide Preview SQL'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2025_DDL'
,p_condition_element=>'P2025_DDL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8002979857485305)
,p_event_id=>wwv_flow_imp.id(8002894210485304)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5910447701963333)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8003016229485306)
,p_event_id=>wwv_flow_imp.id(8002894210485304)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5910447701963333)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8003169380485307)
,p_event_id=>wwv_flow_imp.id(8002894210485304)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#preview_sql").text($v("P2025_DDL"));',
'Prism.highlightAll();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8003256306485308)
,p_event_id=>wwv_flow_imp.id(8002894210485304)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery("#preview_sql").text("");'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7003385778418811)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2025_OBJECT_TYPE := ''INDEX'';',
'',
':P2025_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_object(',
'    p_object_name     => :P2025_NAME,',
'    p_object_type     => :P2025_OBJECT_TYPE,',
'    p_parsing_schema  => :P2025_PARSING_SCHEMA,',
'    p_ddl             => :P2025_DDL );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2716283289829896)
,p_process_success_message=>'Index created successfully.'
,p_internal_uid=>7003385778418811
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2690897546362848)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2025_NAME,P2025_OBJECT_ID,P2025_OBJECT_TYPE,P2025_PARSING_SCHEMA'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2716283289829896)
,p_process_when=>'P2025_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Index created successfully.'
,p_internal_uid=>2690897546362848
);
end;
/
prompt --application/pages/page_02026
begin
wwv_flow_imp_page.create_page(
 p_id=>2026
,p_name=>'Spatial Metadata'
,p_alias=>'SPATIAL-METADATA'
,p_page_mode=>'MODAL'
,p_step_title=>'Spatial Metadata'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9755233951523461)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(428509749043337465)
,p_plug_name=>'Spatial Meta Data'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15745841218260344)
,p_plug_name=>'Register Column'
,p_parent_plug_id=>wwv_flow_imp.id(428509749043337465)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12411098558043142)
,p_plug_name=>'Dimensions'
,p_parent_plug_id=>wwv_flow_imp.id(15745841218260344)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2690063539362840)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(9755233951523461)
,p_button_name=>'PREVIEW'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Preview SQL'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5613048329027449)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(9755233951523461)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Spatial Meta Data'
,p_button_position=>'NEXT'
,p_button_condition=>'P2026_EDIT'
,p_button_condition2=>'NO'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5613418082027452)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(9755233951523461)
,p_button_name=>'REPLACE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Replace Spatial Meta Data'
,p_button_position=>'NEXT'
,p_button_condition=>'P2026_EDIT'
,p_button_condition2=>'YES'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5613816285027452)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(9755233951523461)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2025:&SESSION.::&DEBUG.:2026::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5614216105027453)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(9755233951523461)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2690689855362846)
,p_branch_name=>'Preview SQL'
,p_branch_action=>'f?p=&APP_ID.:2027:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2690063539362840)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2690703842362847)
,p_branch_name=>'Continue to Index Creation'
,p_branch_action=>'f?p=&APP_ID.:2025:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5601427413022245)
,p_name=>'P2026_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15745841218260344)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema:'
,p_source=>'P2025_PARSING_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Identifies the name of the database schema of the spatial table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5602343297022251)
,p_name=>'P2026_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15745841218260344)
,p_prompt=>'Table:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of the table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5603258947022251)
,p_name=>'P2026_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(15745841218260344)
,p_prompt=>'Column:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(COLUMN_NAME)||'' (''||data_type||'')'' d,',
'       column_name r',
'  from sys.dba_tab_columns',
' where owner      = :P2025_PARSING_SCHEMA ',
'   and table_name = :P2026_TABLE',
'   and data_type  = ''SDO_GEOMETRY''',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Name of the geometry column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5604149719022252)
,p_name=>'P2026_SRID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(15745841218260344)
,p_prompt=>'Coordinate System'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select srid ||'': '' || cs_name as d,',
'       srid as r',
'  from mdsys.cs_srs ',
' where wktext is not null',
' order by srid'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Coordinate system of the geometry objects in the spatial table (<em>Spatial Reference system ID</em>.',
'</p>',
'<p>If your data is longitude and latitude, use <strong>4326 (WGS 84)</strong></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_07=>'Coordinate System (SRID)'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5605011080022254)
,p_name=>'P2026_CS_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(15745841218260344)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5605428764022254)
,p_name=>'P2026_EDIT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(15745841218260344)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5606114655022255)
,p_name=>'P2026_DIMX_HDR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12411098558043142)
,p_prompt=>'Dimension'
,p_source=>'X'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>1
,p_grid_column=>3
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5606547957022255)
,p_name=>'P2026_DIMX_MIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12411098558043142)
,p_prompt=>'Minimum'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'X Axis minimum value boundary of the spatial objects in the table. For latitude/longitude coordinate systems, this is typically -180.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5607480304022256)
,p_name=>'P2026_DIMX_MAX'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12411098558043142)
,p_prompt=>'Maximum:'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'X Axis maximum value boundary of the spatial objects in the table. For latitude/longitude coordinate systems, this is typically 180.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5608380627022256)
,p_name=>'P2026_DIMX_TOL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12411098558043142)
,p_prompt=>'Spatial Tolerance'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Spatial <em>tolerance</em> to use for the X axis. If two points are closer to each other than the tolerance specified, Oracle Spatial considers them as the same point.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5609298292022258)
,p_name=>'P2026_DIMY_HDR'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(12411098558043142)
,p_prompt=>'Dimension'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>1
,p_grid_column=>3
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5609691460022258)
,p_name=>'P2026_DIMY_MIN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(12411098558043142)
,p_prompt=>'Minimum'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Y Axis minimum value boundary of the spatial objects in the table. For latitude/longitude coordinate systems, this is typically -90.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5610533686022258)
,p_name=>'P2026_DIMY_MAX'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(12411098558043142)
,p_prompt=>'Maximum'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Y Axis maximum value boundary of the spatial objects in the table. For latitude/longitude coordinate systems, this is typically 90.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5611434469022259)
,p_name=>'P2026_DIMY_TOL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(12411098558043142)
,p_prompt=>'Spatial Tolerance'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Spatial <em>tolerance</em> to use for the Y axis. If two points are closer to each other than the tolerance specified, Oracle Spatial considers them as the same point.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6600661883893965)
,p_name=>'P2026_DDL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(428509749043337465)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6901264936191874)
,p_computation_sequence=>20
,p_computation_item=>'P2026_DDL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_wiz_dev.get_add_geom_metadata_dml(',
'    p_table_name    => :P2026_TABLE,',
'    p_column_name   => :P2026_COLUMN_NAME,',
'    p_action        => case when :P2026_EDIT = ''YES'' then ''recreate'' else ''create'' end,',
'    p_srid          => :P2026_SRID,',
'    p_dim_x_min     => :P2026_DIMX_MIN,',
'    p_dim_x_max     => :P2026_DIMX_MAX,',
'    p_dim_y_min     => :P2026_DIMY_MIN,',
'    p_dim_y_max     => :P2026_DIMY_MAX,',
'    p_dim_x_tol     => :P2026_DIMX_TOL,',
'    p_dim_y_tol     => :P2026_DIMY_TOL )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6300393619551920)
,p_validation_name=>'SRID matches Table Geometries'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_wiz_dev.validate_srid(',
'    p_table_name     => :P2026_TABLE,',
'    p_owner          => :P2025_PARSING_SCHEMA,',
'    p_column_name    => :P2026_COLUMN_NAME,',
'    p_srid           => :P2026_SRID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Table contains geometry objects with different coordinate system ID. Review the SDO_GEOMETRY.SDO_SRID attribute.'
,p_associated_item=>wwv_flow_imp.id(5604149719022252)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2690139929362841)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5614216105027453)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2690249803362842)
,p_event_id=>wwv_flow_imp.id(2690139929362841)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6800336981166505)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_dev.execute_ddl (',
'    p_ddl             => :P2026_DDL,',
'    p_parse_as_schema => :P2025_PARSING_SCHEMA );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'ADD:REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Spatial Registry has been updated.'
,p_internal_uid=>6800336981166505
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5612393413023848)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Metadata'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_metadata wwv_flow_t_varchar2 := wwv_flow_t_varchar2();',
'begin',
'    case when :P2026_EDIT = ''YES'' then ',
'        l_metadata := wwv_flow_string.split(',
'                        wwv_flow_f4500_ob_wiz_dev.get_geom_metadata(',
'                            p_owner         => :P2025_PARSING_SCHEMA,',
'                            p_table_name    => :P2026_TABLE,',
'                            p_column_name   => :P2026_COLUMN_NAME ), '':'' );',
'',
'        if l_metadata.count = 7 then',
'            :P2026_SRID     := l_metadata( 1 );',
'            :P2026_DIMX_MIN := l_metadata( 2 );',
'            :P2026_DIMX_MAX := l_metadata( 3 );',
'            :P2026_DIMX_TOL := l_metadata( 4 );',
'            :P2026_DIMY_MIN := l_metadata( 5 );',
'            :P2026_DIMY_MAX := l_metadata( 6 );',
'            :P2026_DIMY_TOL := l_metadata( 7 );',
'        end if;',
'    else',
'        :P2026_SRID     := ''4326'';',
'        :P2026_DIMX_MIN := ''-180'';',
'        :P2026_DIMX_MAX := ''180'';',
'        :P2026_DIMX_TOL := 0.05;',
'        :P2026_DIMY_MIN := ''-90'';',
'        :P2026_DIMY_MAX := ''90'';',
'        :P2026_DIMY_TOL := 0.05;',
'    end case;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>5612393413023848
);
end;
/
prompt --application/pages/page_02027
begin
wwv_flow_imp_page.create_page(
 p_id=>2027
,p_name=>'Spatial Metadata Preview SQL'
,p_alias=>'SPATIAL-METADATA-PREVIEW-SQL'
,p_page_mode=>'MODAL'
,p_step_title=>'Spatial Metadata - Preview SQL'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code_onload=>'Prism.highlightAll();'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6004702022547943)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql">&P2026_DDL.</code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16463031834587608)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6004826182547944)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6004702022547943)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6708084610064150)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(16463031834587608)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Spatial Meta Data'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2026:&SESSION.:BRANCH_TO_PAGE_ACCEPT|ADD:&DEBUG.:::'
,p_button_condition=>'P2026_EDIT'
,p_button_condition2=>'NO'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6708496992064152)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(16463031834587608)
,p_button_name=>'REPLACE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Replace Spatial Meta Data'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2026:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::'
,p_button_condition=>'P2026_EDIT'
,p_button_condition2=>'YES'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6708880112064152)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(16463031834587608)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2026:&SESSION.::&DEBUG.:2027::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6709286258064153)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(16463031834587608)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2690449258362844)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(6709286258064153)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2690514998362845)
,p_event_id=>wwv_flow_imp.id(2690449258362844)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_02030
begin
wwv_flow_imp_page.create_page(
 p_id=>2030
,p_name=>'Create Sequence'
,p_alias=>'CREATE-SEQUENCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Sequence'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserWizard#MIN#.js'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10519538043036268)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11217851934478246)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47281037611245946)
,p_plug_name=>'Sequence Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2701580941353498)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(10519538043036268)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Sequence'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8003372933485309)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(11217851934478246)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2701939056353500)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10519538043036268)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775122236216706)
,p_name=>'P2030_PARSING_SCHEMA'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2702629809353508)
,p_name=>'P2030_DDL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(11217851934478246)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2703788641353513)
,p_name=>'P2030_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2704160017353513)
,p_name=>'P2030_OBJECT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8606997445376172)
,p_name=>'P2030_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_prompt=>'Sequence Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the name of the sequence. The name must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8608211074376173)
,p_name=>'P2030_START_WITH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_prompt=>'Start With'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify the first sequence number to be generated. Use this field to start an ascending sequence at a value greater than its minimum or to start a descending sequence at a value less than its maximum. For ascending sequences, the default value is the'
||' minimum value of the sequence. For descending sequences, the default value is the maximum value of the sequence. This value must be a valid integer.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8609117614376174)
,p_name=>'P2030_MIN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_prompt=>'Minimum Value'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify the minimum value of the sequence. This value must be less than or equal to <strong>Start With</strong> and must be less than <strong>Maximum Value</strong>. This value must be a valid integer. If no minimum value is specified, Oracle uses mi'
||'nimum value of 1 for an ascending sequence or -(10<sup>27</sup> -1) for a descending sequence.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8610023717376174)
,p_name=>'P2030_MAX'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_prompt=>'Maximum Value'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify the maximum value the sequence can generate. This value must be equal to or greater than <strong>Start With</strong> and must be greater than <strong>Minimum Value</strong>. This value must be a valid integer. If no maximum value is specified'
||', Oracle uses maximum value of 10<sup>27</sup> -1 for an ascending sequence or -1 for a descending sequence.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8610903457376175)
,p_name=>'P2030_INCREMENT_BY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_item_default=>'1'
,p_prompt=>'Increment By'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify the interval between sequence numbers. This integer value can be any positive or negative integer, but it cannot be 0. The absolute of this value must be less than the difference of <strong>Maximum Value</strong> and <strong>Minimum Value</st'
||'rong>. If this value is negative, then the sequence descends. If the value is positive, then the sequence ascends.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8611898361376175)
,p_name=>'P2030_CYCLE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_item_default=>'N'
,p_prompt=>'Cycle'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select this checkbox to indicate that the sequence continues to generate values after reaching either its maximum or minimum value. After an ascending sequence reaches its maximum value, it generates its minimum value. After a descending sequence '
||'reaches its minimum, it generates its maximum value.</p>',
'<p>Unselect this checkbox to indicate that the sequence cannot generate more values after reaching its maximum or minimum value. This is the default.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8612257817376176)
,p_name=>'P2030_CACHE'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_imp.id(47281037611245946)
,p_item_default=>'20'
,p_prompt=>'Number to Cache'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a cache size.  The value is used to preallocate a set of sequence numbers and keep them in memory so that sequence numbers can be accessed faster. When the last of the sequence numbers in the cache has been used, the database reads another set '
||'of numbers into the cache. This value must be a valid positive integer greater than 1.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10105349012592001)
,p_validation_name=>'P2030_NAME valid & available'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2030_NAME,',
'    p_owner           => :P2030_PARSING_SCHEMA,',
'    p_object_type     => ''SEQUENCE'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2030_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(8606997445376172)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10105478209592002)
,p_validation_name=>'P2030_START_WITH >= P2030_MIN'
,p_validation_sequence=>30
,p_validation=>'to_number( :P2030_START_WITH ) >= to_number( :P2030_MIN )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Start with value must be greater than or equal to Minimum value.'
,p_validation_condition=>':P2030_START_WITH is not null and :P2030_MIN is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8608211074376173)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5615005741134041)
,p_validation_name=>'P2030_START_WITH <= P2030_MAX'
,p_validation_sequence=>40
,p_validation=>'to_number( :P2030_START_WITH ) <= to_number( :P2030_MAX )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Start with value must be less than or equal to Maximum value.'
,p_validation_condition=>':P2030_START_WITH is not null and :P2030_MAX is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8608211074376173)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10105577902592003)
,p_validation_name=>'P2030_MAX > P2030_MIN'
,p_validation_sequence=>50
,p_validation=>'to_number( :P2030_MAX ) > to_number( :P2030_MIN )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Maximum Value must be greater than Minimum value.'
,p_validation_condition=>':P2030_MAX is not null and :P2030_MIN is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8610023717376174)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5614571195134036)
,p_validation_name=>'P2030_START_WITH valid integer'
,p_validation_sequence=>60
,p_validation=>':P2030_START_WITH = floor( :P2030_START_WITH )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a valid integer'
,p_validation_condition=>'P2030_START_WITH'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(8608211074376173)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5614628864134037)
,p_validation_name=>'P2030_INCREMENT_BY valid integer but not Zero'
,p_validation_sequence=>70
,p_validation=>':P2030_INCREMENT_BY = floor( :P2030_INCREMENT_BY ) and to_number( :P2030_INCREMENT_BY ) != 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a valid non-zero integer'
,p_validation_condition=>'P2030_INCREMENT_BY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(8610903457376175)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5614796748134038)
,p_validation_name=>'P2030_CACHE valid postive integer'
,p_validation_sequence=>80
,p_validation=>':P2030_CACHE = floor( :P2030_CACHE ) and to_number( :P2030_CACHE ) > 1'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a valid positive integer greater than 1'
,p_validation_condition=>'P2030_CACHE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(8612257817376176)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5614863926134039)
,p_validation_name=>'P2030_MIN valid integer'
,p_validation_sequence=>90
,p_validation=>':P2030_MIN = floor( :P2030_MIN )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a valid integer'
,p_validation_condition=>'P2030_MIN'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(8609117614376174)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5614965267134040)
,p_validation_name=>'P2030_MAX valid integer'
,p_validation_sequence=>100
,p_validation=>':P2030_MAX = floor( :P2030_MAX )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a valid integer'
,p_validation_condition=>'P2030_MAX'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(8610023717376174)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2705827762353537)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2701939056353500)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2706352776353537)
,p_event_id=>wwv_flow_imp.id(2705827762353537)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2704904414353533)
,p_name=>'Submit CREATE'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2701580941353498)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705461577353537)
,p_event_id=>wwv_flow_imp.id(2704904414353533)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3009733313395443)
,p_name=>'Preview SQL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2030_START_WITH,P2030_MIN,P2030_MAX,P2030_INCREMENT_BY,P2030_CYCLE,P2030_CACHE'
,p_condition_element=>'P2030_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3009845599395444)
,p_event_id=>wwv_flow_imp.id(3009733313395443)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2030_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getSequenceDDL ( $v( "P2030_NAME" ), $v( "P2030_START_WITH" ), $v( "P2030_INCREMENT_BY" ),  $v( "P2030_MIN" ), $v( "P2030_MAX" ), $v( "P2030_CYCLE" ), $v( "P2030_CACHE" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3009946980395445)
,p_event_id=>wwv_flow_imp.id(3009733313395443)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2030_DDL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3010088188395446)
,p_name=>'P2030_NAME Change'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2030_NAME'
,p_condition_element=>'P2030_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3010183802395447)
,p_event_id=>wwv_flow_imp.id(3010088188395446)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Replace Spaces and Double Quotes'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2030_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2030_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3010222986395448)
,p_event_id=>wwv_flow_imp.id(3010088188395446)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2030_DDL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3010314191395449)
,p_event_id=>wwv_flow_imp.id(3010088188395446)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Preview SQL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2030_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getSequenceDDL ( $v( "P2030_NAME" ), $v( "P2030_START_WITH" ), $v( "P2030_INCREMENT_BY" ),  $v( "P2030_MIN" ), $v( "P2030_MAX" ), $v( "P2030_CYCLE" ), $v( "P2030_CACHE" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8003479883485310)
,p_name=>'Show/Hide Preview SQL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2030_DDL'
,p_condition_element=>'P2030_DDL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8003587958485311)
,p_event_id=>wwv_flow_imp.id(8003479883485310)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(11217851934478246)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8003610950485312)
,p_event_id=>wwv_flow_imp.id(8003479883485310)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(11217851934478246)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8003796991485313)
,p_event_id=>wwv_flow_imp.id(8003479883485310)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#preview_sql").text($v("P2030_DDL"));',
'Prism.highlightAll();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8003801782485314)
,p_event_id=>wwv_flow_imp.id(8003479883485310)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery("#preview_sql").text("");'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10305323147638557)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2030_OBJECT_TYPE := ''SEQUENCE'';',
'',
':P2030_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_object(',
'                        p_object_name     => :P2030_NAME,',
'                        p_object_type     => :P2030_OBJECT_TYPE,',
'                        p_parsing_schema  => :P2030_PARSING_SCHEMA,',
'                        p_ddl             => :P2030_DDL );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2701580941353498)
,p_process_success_message=>'Sequence created successfully.'
,p_internal_uid=>10305323147638557
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10305967349640795)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2030_OBJECT_ID,P2030_OBJECT_TYPE,P2030_NAME'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2701580941353498)
,p_process_when=>'P2030_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Sequence created successfully.'
,p_internal_uid=>10305967349640795
);
end;
/
prompt --application/pages/page_02035
begin
wwv_flow_imp_page.create_page(
 p_id=>2035
,p_name=>'Create Type'
,p_alias=>'CREATE-TYPE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Type'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserWizard#MIN#.js'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12512482622436000)
,p_plug_name=>'Type Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13226588087393858)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13924901978835836)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2708072700357599)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(13226588087393858)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Type'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8004015744485316)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(13924901978835836)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2707626984357598)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(13226588087393858)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775254293216707)
,p_name=>'P2035_PARSING_SCHEMA'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2708749862357603)
,p_name=>'P2035_DDL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(13924901978835836)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2709449757357607)
,p_name=>'P2035_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_prompt=>'Type Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the type. The name must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2709871715357608)
,p_name=>'P2035_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2710222542357608)
,p_name=>'P2035_OBJECT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7802549291441913)
,p_name=>'P2035_COLL_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_item_default=>'V'
,p_prompt=>'Collection Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TYPE_COLLECTION_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(16529130513602905)||'.'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a collection type to create.</p>',
'<p>A <strong>VArray (variable-size array)</strong> is an ordered set of elements, each of which has the same data type.</p>',
'<p>A <strong>Nested Table</strong> creates a named nested table of selected data type.'))
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7802640128441914)
,p_name=>'P2035_DATA_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_item_default=>'VARCHAR2'
,p_prompt=>'Data Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TYPE_DATA_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(16534820904659665)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the data type of the collection elements.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7802780811441915)
,p_name=>'P2035_OBJECT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_prompt=>'Object'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( object_name ) d,',
'       object_name r',
'  from sys.dba_objects',
' where owner       = :P2035_PARSING_SCHEMA',
'   and object_type = ''TYPE''',
'   and status      = ''VALID'''))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a <code>TYPE</code> to create nested <code>TYPE</code>.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7802856635441916)
,p_name=>'P2035_LENGTH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_prompt=>'Length'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the length of the selected data type. This value must be a valid positive integer.'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7802963248441917)
,p_name=>'P2035_PRECISION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_prompt=>'Precision'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter precision for the selected data type. This value must be a valid positive integer.'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7803091108441918)
,p_name=>'P2035_SCALE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_prompt=>'Scale'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter scale for the selected data type. This value must be a valid integer.'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7803165687441919)
,p_name=>'P2035_LIMIT'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(12512482622436000)
,p_prompt=>'Limit'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the number of elements in the VARRAY. This value must be a valid positive integer.'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10906093036818651)
,p_validation_name=>'P2035_NAME valid & available'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2035_NAME,',
'    p_owner           => :P2035_PARSING_SCHEMA,',
'    p_object_type     => ''TYPE'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2035_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2709449757357607)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7806004992441948)
,p_validation_name=>'P2035_OBJECT not null'
,p_validation_sequence=>20
,p_validation=>'P2035_OBJECT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2035_DATA_TYPE'
,p_validation_condition2=>'NEST'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(7802780811441915)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7806164663441949)
,p_validation_name=>'P2035_LENGTH not null'
,p_validation_sequence=>30
,p_validation=>'P2035_LENGTH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2035_DATA_TYPE'
,p_validation_condition2=>'CHAR:RAW:VARCHAR2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(7802856635441916)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7806201931441950)
,p_validation_name=>'P2035_SCALE not null'
,p_validation_sequence=>40
,p_validation=>'P2035_SCALE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2035_DATA_TYPE'
,p_validation_condition2=>'DECIMAL:NUMBER'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(7803091108441918)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9402170965786303)
,p_validation_name=>'P2035_PRECISION not null'
,p_validation_sequence=>50
,p_validation=>'P2035_PRECISION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2035_DATA_TYPE'
,p_validation_condition2=>'DECIMAL:NUMBER:FLOAT'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(7802963248441917)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9402275199786304)
,p_validation_name=>'P2035_LIMIT not null'
,p_validation_sequence=>60
,p_validation=>'P2035_LIMIT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2035_COLL_TYPE'
,p_validation_condition2=>'V'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(7803165687441919)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5615166246134042)
,p_validation_name=>'P2035_LIMIT valid positive integer'
,p_validation_sequence=>70
,p_validation=>':P2035_LIMIT = floor( :P2035_LIMIT ) and to_number( :P2035_LIMIT ) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a valid positive integer.'
,p_validation_condition=>'P2035_LIMIT'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(7803165687441919)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5615202491134043)
,p_validation_name=>'P2035_LENGTH valid positive integer'
,p_validation_sequence=>80
,p_validation=>':P2035_LENGTH = floor( :P2035_LENGTH ) and to_number( :P2035_LENGTH ) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a valid positive integer.'
,p_validation_condition=>'P2035_LENGTH'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(7802856635441916)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5615341202134044)
,p_validation_name=>'P2035_PRECISION valid positive integer'
,p_validation_sequence=>90
,p_validation=>':P2035_PRECISION = floor( :P2035_PRECISION ) and to_number( :P2035_PRECISION ) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a valid positive integer.'
,p_validation_condition=>'P2035_PRECISION'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(7802963248441917)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5615472350134045)
,p_validation_name=>'P2035_SCALE valid integer'
,p_validation_sequence=>100
,p_validation=>':P2035_SCALE = floor( :P2035_SCALE )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a valid integer.'
,p_validation_condition=>'P2035_SCALE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(7803091108441918)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2711988834357631)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2707626984357598)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2712482303357632)
,p_event_id=>wwv_flow_imp.id(2711988834357631)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2711022615357629)
,p_name=>'Submit CREATE'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2708072700357599)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2711564158357631)
,p_event_id=>wwv_flow_imp.id(2711022615357629)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7803219868441920)
,p_name=>'P2035_NAME Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2035_NAME'
,p_condition_element=>'P2035_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7803394525441921)
,p_event_id=>wwv_flow_imp.id(7803219868441920)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Replace Spaces and Double Quotes'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2035_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7805582005441943)
,p_event_id=>wwv_flow_imp.id(7803219868441920)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_DDL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7805499937441942)
,p_event_id=>wwv_flow_imp.id(7803219868441920)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Preview SQL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getTypeDDL ( $v( "P2035_NAME" ), $v( "P2035_COLL_TYPE" ), $v( "P2035_LIMIT" ), $v( "P2035_DATA_TYPE" ), $v( "P2035_OBJECT" ), $v( "P2035_LENGTH" ), $v( "P2035_PRECISION" ), $v( "P2035_SCALE" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7803434856441922)
,p_name=>'Collection Type Change'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2035_COLL_TYPE'
,p_condition_element=>'P2035_COLL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'V'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7803537549441923)
,p_event_id=>wwv_flow_imp.id(7803434856441922)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_LIMIT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7803612366441924)
,p_event_id=>wwv_flow_imp.id(7803434856441922)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_LIMIT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7804929144441937)
,p_event_id=>wwv_flow_imp.id(7803434856441922)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_LIMIT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7803788018441925)
,p_name=>'Show/Hide P2035_OBJECT'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2035_DATA_TYPE'
,p_condition_element=>'P2035_DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEST'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7803842111441926)
,p_event_id=>wwv_flow_imp.id(7803788018441925)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_OBJECT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7803939104441927)
,p_event_id=>wwv_flow_imp.id(7803788018441925)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_OBJECT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7805095027441938)
,p_event_id=>wwv_flow_imp.id(7803788018441925)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_OBJECT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7804032444441928)
,p_name=>'Show/Hide P2035_LENGTH'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2035_DATA_TYPE'
,p_condition_element=>'P2035_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'CHAR,RAW,VARCHAR2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7804132893441929)
,p_event_id=>wwv_flow_imp.id(7804032444441928)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_LENGTH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7804227414441930)
,p_event_id=>wwv_flow_imp.id(7804032444441928)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_LENGTH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7805102865441939)
,p_event_id=>wwv_flow_imp.id(7804032444441928)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_LENGTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7804312128441931)
,p_name=>'Show/Hide P2035_SCALE'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2035_DATA_TYPE'
,p_condition_element=>'P2035_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'DECIMAL,NUMBER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7804427706441932)
,p_event_id=>wwv_flow_imp.id(7804312128441931)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_SCALE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7804566539441933)
,p_event_id=>wwv_flow_imp.id(7804312128441931)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_SCALE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7805292752441940)
,p_event_id=>wwv_flow_imp.id(7804312128441931)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_SCALE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7804610275441934)
,p_name=>'Show/Hide P2035_PRECISION'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2035_DATA_TYPE'
,p_condition_element=>'P2035_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'DECIMAL,NUMBER,FLOAT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7804703463441935)
,p_event_id=>wwv_flow_imp.id(7804610275441934)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_PRECISION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7804802081441936)
,p_event_id=>wwv_flow_imp.id(7804610275441934)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_PRECISION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7805379371441941)
,p_event_id=>wwv_flow_imp.id(7804610275441934)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_PRECISION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7805680218441944)
,p_name=>'Preview SQL'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2035_COLL_TYPE,P2035_LIMIT,P2035_DATA_TYPE,P2035_OBJECT,P2035_LENGTH,P2035_PRECISION,P2035_SCALE'
,p_condition_element=>'P2035_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7805793496441945)
,p_event_id=>wwv_flow_imp.id(7805680218441944)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getTypeDDL ( $v( "P2035_NAME" ), $v( "P2035_COLL_TYPE" ), $v( "P2035_LIMIT" ), $v( "P2035_DATA_TYPE" ).toLowerCase(), $v( "P2035_OBJECT" ), $v( "P2035_LENGTH" ), $v( "P2035_PRECISION" ), $v( "P2035_SCALE" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7805862927441946)
,p_event_id=>wwv_flow_imp.id(7805680218441944)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2035_DDL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8004120400485317)
,p_name=>'Show/Hide Preview SQL'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2035_DDL'
,p_condition_element=>'P2035_DDL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8004278985485318)
,p_event_id=>wwv_flow_imp.id(8004120400485317)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(13924901978835836)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8004346319485319)
,p_event_id=>wwv_flow_imp.id(8004120400485317)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(13924901978835836)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8004403895485320)
,p_event_id=>wwv_flow_imp.id(8004120400485317)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#preview_sql").text($v("P2035_DDL"));',
'Prism.highlightAll();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8004567983485321)
,p_event_id=>wwv_flow_imp.id(8004120400485317)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery("#preview_sql").text("");'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2900455988058622)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2035_OBJECT_TYPE := ''TYPE'';',
'',
':P2035_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_object(',
'                        p_object_name     => :P2035_NAME,',
'                        p_object_type     => :P2035_OBJECT_TYPE,',
'                        p_parsing_schema  => :P2035_PARSING_SCHEMA,',
'                        p_ddl             => :P2035_DDL );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2708072700357599)
,p_process_success_message=>'Type created successfully.'
,p_internal_uid=>2900455988058622
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3100134889062214)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2035_OBJECT_ID,P2035_OBJECT_TYPE,P2035_NAME'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2708072700357599)
,p_process_when=>'P2035_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Type created successfully.'
,p_internal_uid=>3100134889062214
);
end;
/
prompt --application/pages/page_02040
begin
wwv_flow_imp_page.create_page(
 p_id=>2040
,p_name=>'Create Package/Function/Procedure'
,p_alias=>'CREATE-PACKAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserWizard#MIN#.js'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Change title based on object type',
'apex.util.getTopApex().jQuery(".ui-dialog-content").dialog("option", "title", $v("P2040_CREATE_OBJECT_MSG"));'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6005487004547950)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7104426503724934)
,p_plug_name=>'&P2040_OBJECT_TYPE_DISPLAY. Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7818531968682792)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5611703939134008)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6005487004547950)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2601476893134415)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(7818531968682792)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'&P2040_CREATE_OBJECT_MSG.'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2601856303134416)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7818531968682792)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775335093216708)
,p_name=>'P2040_PARSING_SCHEMA'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(7104426503724934)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1805494242551105)
,p_name=>'P2040_CREATE_OBJECT_MSG'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(7104426503724934)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2606658523161492)
,p_name=>'P2040_DDL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(7104426503724934)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5611817478134009)
,p_name=>'P2040_OBJECT_TYPE_DISPLAY'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(7104426503724934)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6004934032547945)
,p_name=>'P2040_BODY_DDL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(7104426503724934)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7104528593724935)
,p_name=>'P2040_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7104426503724934)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the &P2040_OBJECT_TYPE_DISPLAY. to be created. The name must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7104639306724936)
,p_name=>'P2040_OBJECT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(7104426503724934)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7104763063724937)
,p_name=>'P2040_OBJECT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(7104426503724934)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7104848436724938)
,p_name=>'P2040_SAMPLE_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(7104426503724934)
,p_item_default=>'N'
,p_prompt=>'Include Sample Code'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify whether to include sample code while creating the &P2040_OBJECT_TYPE_DISPLAY..</p>',
'',
''))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5611964541134010)
,p_computation_sequence=>10
,p_computation_item=>'P2040_OBJECT_TYPE_DISPLAY'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.message(''OB.''||:P2040_OBJECT_TYPE)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1805520188551106)
,p_computation_sequence=>20
,p_computation_item=>'P2040_CREATE_OBJECT_MSG'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.message(''OB.CREATE_''||:P2040_OBJECT_TYPE)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7105120494724941)
,p_validation_name=>'P2040_NAME not null'
,p_validation_sequence=>10
,p_validation=>':P2040_NAME is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P2040_SAMPLE_CODE'
,p_validation_condition2=>'SPEC'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2601476893134415)
,p_associated_item=>wwv_flow_imp.id(7104528593724935)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7105991383724949)
,p_validation_name=>'P2040_NAME valid & available'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2040_NAME,',
'    p_owner           => :P2040_PARSING_SCHEMA,',
'    p_object_type     => :P2040_OBJECT_TYPE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2040_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(2601476893134415)
,p_associated_item=>wwv_flow_imp.id(7104528593724935)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7104065610724930)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2601856303134416)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7104129441724931)
,p_event_id=>wwv_flow_imp.id(7104065610724930)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7104246369724932)
,p_name=>'Submit CREATE'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2601476893134415)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7104369547724933)
,p_event_id=>wwv_flow_imp.id(7104246369724932)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6005045291547946)
,p_name=>'Replace Spaces and Double Quotes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2040_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6005149561547947)
,p_event_id=>wwv_flow_imp.id(6005045291547946)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2040_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2040_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6005223101547948)
,p_name=>'Preview SQL'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2040_NAME,P2040_SAMPLE_CODE'
,p_condition_element=>'P2040_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5611694795134007)
,p_event_id=>wwv_flow_imp.id(6005223101547948)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'getPackageBody'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2040_BODY_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.generateCode( $v( "P2040_NAME" ), ''PACKAGE BODY'', $v( "P2040_SAMPLE_CODE" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_server_condition_expr1=>'P2040_OBJECT_TYPE'
,p_server_condition_expr2=>'PACKAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6005359569547949)
,p_event_id=>wwv_flow_imp.id(6005223101547948)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'getDDL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2040_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.generateCode( $v( "P2040_NAME" ), $v("P2040_OBJECT_TYPE"), $v( "P2040_SAMPLE_CODE" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5611051019134001)
,p_name=>'Show/Hide Preview SQL'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2040_DDL'
,p_condition_element=>'P2040_DDL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5611130154134002)
,p_event_id=>wwv_flow_imp.id(5611051019134001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6005487004547950)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5611212557134003)
,p_event_id=>wwv_flow_imp.id(5611051019134001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6005487004547950)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5611309112134004)
,p_event_id=>wwv_flow_imp.id(5611051019134001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery("#preview_sql").text("");'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5611461409134005)
,p_event_id=>wwv_flow_imp.id(5611051019134001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let lDDL = ( $v("P2040_OBJECT_TYPE") === ''PACKAGE'' ) ? $v("P2040_DDL") + ''\n\n'' + $v("P2040_BODY_DDL") : $v("P2040_DDL");',
'apex.jQuery("#preview_sql").text(lDDL);',
'Prism.highlightAll();'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3003106615287941)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Package'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_wiz_dev.create_package(',
'    p_name            => :P2040_NAME,',
'    p_parsing_schema  => :P2040_PARSING_SCHEMA,',
'    p_spec_ddl        => :P2040_DDL,',
'    p_body_ddl        => :P2040_BODY_DDL,',
'    p_object_id       => :P2040_OBJECT_ID );    '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2601476893134415)
,p_process_when=>'P2040_OBJECT_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PACKAGE'
,p_internal_uid=>3003106615287941
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5612511477134016)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Function/Procedure'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2040_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_object(',
'    p_object_name    => :P2040_NAME,',
'    p_object_type    => :P2040_OBJECT_TYPE,',
'    p_parsing_schema => :P2040_PARSING_SCHEMA,',
'    p_ddl            => :P2040_DDL );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2601476893134415)
,p_process_when=>':P2040_OBJECT_TYPE in (''FUNCTION'',''PROCEDURE'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>5612511477134016
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3003795554290207)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2040_NAME,P2040_OBJECT_ID,P2040_OBJECT_TYPE'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2601476893134415)
,p_process_when=>'P2040_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'&P2040_OBJECT_TYPE_DISPLAY. created successfully.'
,p_internal_uid=>3003795554290207
);
end;
/
prompt --application/pages/page_02055
begin
wwv_flow_imp_page.create_page(
 p_id=>2055
,p_name=>'Create Trigger'
,p_alias=>'CREATE-TRIGGER'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Trigger'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserWizard#MIN#.js'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13740242265088271)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18658882391120307)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41162114901535096)
,p_plug_name=>'Trigger Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 07-FEB-2003 18:17:26'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(41891418800570972)
,p_name=>'Existing Triggers'
,p_template=>wwv_flow_imp.id(717419046555820782)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner,',
'       trigger_name, ',
'       table_owner,',
'       table_name,',
'       base_object_type,',
'       trigger_type,',
'       triggering_event,',
'       when_clause,',
'       action_type,',
'       status',
'  from sys.dba_triggers t',
' where t.table_name  = :P2055_TABLE',
'   and t.table_owner = :P2055_PARSING_SCHEMA',
' order by t.trigger_name'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P2055_TABLE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Table does not have any triggers.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7204609260463795)
,p_query_column_id=>1
,p_column_alias=>'OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Trigger Schema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7205079228463796)
,p_query_column_id=>2
,p_column_alias=>'TRIGGER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7205402082463796)
,p_query_column_id=>3
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>3
,p_column_heading=>'Table Schema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7205859085463796)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7206287740463797)
,p_query_column_id=>5
,p_column_alias=>'BASE_OBJECT_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Base Object'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7206674841463797)
,p_query_column_id=>6
,p_column_alias=>'TRIGGER_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7207036181463797)
,p_query_column_id=>7
,p_column_alias=>'TRIGGERING_EVENT'
,p_column_display_sequence=>7
,p_column_heading=>'Event'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7207457374463797)
,p_query_column_id=>8
,p_column_alias=>'WHEN_CLAUSE'
,p_column_display_sequence=>8
,p_column_heading=>'When'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7207870942463798)
,p_query_column_id=>9
,p_column_alias=>'ACTION_TYPE'
,p_column_display_sequence=>9
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7208221765463798)
,p_query_column_id=>10
,p_column_alias=>'STATUS'
,p_column_display_sequence=>10
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2720188195366187)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(18658882391120307)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Trigger'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7830013318124959)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(13740242265088271)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2719726775366186)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(18658882391120307)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775595659216710)
,p_name=>'P2055_PARSING_SCHEMA'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(41162114901535096)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2721408051366198)
,p_name=>'P2055_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(41162114901535096)
,p_prompt=>'Trigger Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid name for the trigger. The name must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2721859857366198)
,p_name=>'P2055_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(41162114901535096)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2722242731366198)
,p_name=>'P2055_OBJECT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(41162114901535096)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6801907519421457)
,p_name=>'P2055_TABLE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(41162114901535096)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d,',
'       table_name r',
'  from sys.dba_tables',
' where owner      = :P2055_PARSING_SCHEMA',
'   and table_name not like ''DR$%''',
'   and table_name not like ''BIN$%''',
' order by 1'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the table you wish to create a trigger on.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6804123909421458)
,p_name=>'P2055_BEFORE_OR_AFTER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(41162114901535096)
,p_item_default=>'before'
,p_prompt=>'Firing Point'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BEFORE_OR_AFTER'
,p_lov=>'.'||wwv_flow_imp.id(10601629460223677)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify when the trigger should execute.</p>',
'<ul>',
'<li><strong>Before</strong>: Causes the database to fire the trigger before running the triggering event.</li>',
'<li><strong>After</strong>: Causes the database to fire the trigger after running the triggering event.</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7830471888124966)
,p_name=>'P2055_DDL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(13740242265088271)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7801562846441903)
,p_validation_name=>'P2055_NAME valid & available'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2055_NAME,',
'    p_owner           => :P2055_PARSING_SCHEMA,',
'    p_object_type     => ''TRIGGER'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2055_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2721408051366198)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2723982059366234)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2719726775366186)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2724459433366234)
,p_event_id=>wwv_flow_imp.id(2723982059366234)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2723037163366232)
,p_name=>'Submit CREATE'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2720188195366187)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2723538913366233)
,p_event_id=>wwv_flow_imp.id(2723037163366232)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10109726758592045)
,p_name=>'Table Selected'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2055_TABLE'
,p_condition_element=>'P2055_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7801395931441901)
,p_event_id=>wwv_flow_imp.id(10109726758592045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(41891418800570972)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7801485116441902)
,p_event_id=>wwv_flow_imp.id(10109726758592045)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(41891418800570972)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10109822406592046)
,p_event_id=>wwv_flow_imp.id(10109726758592045)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(41891418800570972)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10109908100592047)
,p_event_id=>wwv_flow_imp.id(10109726758592045)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2055_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4500_ob_wiz_dev.generate_name (',
'    p_owner  => :P2055_PARSING_SCHEMA,',
'    p_name   => :P2055_TABLE,',
'    p_suffix => ''_T'' )'))
,p_attribute_07=>'P2055_PARSING_SCHEMA,P2055_TABLE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7801937304441907)
,p_name=>'Replace Spaces and Double Quotes'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2055_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7802088115441908)
,p_event_id=>wwv_flow_imp.id(7801937304441907)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2055_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2055_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5612670801134017)
,p_name=>'Preview SQL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2055_TABLE,P2055_NAME,P2055_BEFORE_OR_AFTER'
,p_condition_element=>'P2055_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5612797404134018)
,p_event_id=>wwv_flow_imp.id(5612670801134017)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2055_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getTriggerSQL ( $v( "P2055_TABLE" ), $v( "P2055_NAME" ), $v( "P2055_BEFORE_OR_AFTER" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5612877897134019)
,p_event_id=>wwv_flow_imp.id(5612670801134017)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2055_DDL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5612937409134020)
,p_name=>'Show/Hide Preview SQL'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2055_DDL'
,p_condition_element=>'P2055_DDL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5613021352134021)
,p_event_id=>wwv_flow_imp.id(5612937409134020)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(13740242265088271)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5613194156134022)
,p_event_id=>wwv_flow_imp.id(5612937409134020)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(13740242265088271)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5613208611134023)
,p_event_id=>wwv_flow_imp.id(5612937409134020)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#preview_sql").text($v("P2055_DDL"));',
'Prism.highlightAll();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5613321624134024)
,p_event_id=>wwv_flow_imp.id(5612937409134020)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery("#preview_sql").text("");'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8200861783700042)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2055_OBJECT_TYPE := ''TRIGGER'';',
'',
':P2055_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_object(',
'    p_object_name     => :P2055_NAME,',
'    p_object_type     => :P2055_OBJECT_TYPE,',
'    p_parsing_schema  => :P2055_PARSING_SCHEMA,',
'    p_ddl             => :P2055_DDL );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2720188195366187)
,p_process_success_message=>'Trigger created successfully.'
,p_internal_uid=>8200861783700042
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8201451140702304)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2055_OBJECT_ID,P2055_OBJECT_TYPE,P2055_NAME,P2055_PARSING_SCHEMA'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2720188195366187)
,p_process_when=>'P2055_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Trigger created successfully.'
,p_internal_uid=>8201451140702304
);
end;
/
prompt --application/pages/page_02060
begin
wwv_flow_imp_page.create_page(
 p_id=>2060
,p_name=>'Create Materialized View'
,p_alias=>'CREATE-MATERIALIZED-VIEW'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Materialized View'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20669919691531770)
,p_plug_name=>'Materialized View Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21384025156489628)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9403073798786312)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(21384025156489628)
,p_button_name=>'PREVIEW'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Preview SQL'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2726136019369328)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(21384025156489628)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Materialized View'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2725755628369327)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(21384025156489628)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9403131925786313)
,p_branch_name=>'Preview SQL - P2061'
,p_branch_action=>'f?p=&APP_ID.:2061:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775607620216711)
,p_name=>'P2060_PARSING_SCHEMA'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(20669919691531770)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2727555176369335)
,p_name=>'P2060_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20669919691531770)
,p_prompt=>'Materialized View Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the name of the materialized view. View names must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2727922326369336)
,p_name=>'P2060_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20669919691531770)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2728360660369336)
,p_name=>'P2060_OBJECT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20669919691531770)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9402374714786305)
,p_name=>'P2060_SQL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(20669919691531770)
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>18
,p_field_template=>wwv_flow_imp.id(492677350674053149)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a SQL query. You can use Query builder to build SQL queries. You can also use SQL Commands window to test and run SQL queries. Use appropriate buttons to invoke these utilities.'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9402824772786310)
,p_name=>'P2060_DDL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(20669919691531770)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6804227454188040)
,p_computation_sequence=>10
,p_computation_item=>'P2060_SQL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sql varchar2(32767);',
'begin',
'    l_sql := wwv_flow_utilities.remove_trailing_whitespace(:P2060_SQL);',
'    l_sql := rtrim(l_sql,chr(10));',
'    l_sql := rtrim(l_sql,chr(13));',
'    l_sql := wwv_flow.trim_sql(',
'                 p_sql               => l_sql,',
'                 p_ends_in_semicolon => false,',
'                 p_do_substitutions  => false );',
'    return l_sql;',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(9402982607786311)
,p_computation_sequence=>20
,p_computation_item=>'P2060_DDL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''create materialized view ''||wwv_flow_assert.enquote_name(:P2060_NAME)||chr(10)|| ',
'''as''||chr(10)||',
':P2060_SQL||'';'''))
,p_compute_when=>':P2060_NAME is not null and :P2060_SQL is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3702018325250101)
,p_validation_name=>'P2060_NAME valid & available'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2060_NAME,',
'    p_owner           => :P2060_PARSING_SCHEMA,',
'    p_object_type     => ''MATERIALIZED_VIEW'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2060_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13803598519557919)
,p_validation_name=>'P2060_SQL valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location         => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type       => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_parse_as_schema  => :P2060_PARSING_SCHEMA,',
'                            p_sql_query        => :P2060_SQL );',
'',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_associated_item=>wwv_flow_imp.id(9402374714786305)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2730079097369354)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2725755628369327)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2730575366369354)
,p_event_id=>wwv_flow_imp.id(2730079097369354)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2729129212369352)
,p_name=>'Submit CREATE'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2726136019369328)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2729631636369353)
,p_event_id=>wwv_flow_imp.id(2729129212369352)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9402605826786308)
,p_name=>'Replace Spaces and Double Quotes'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2060_NAME'
,p_condition_element=>'P2060_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9402721083786309)
,p_event_id=>wwv_flow_imp.id(9402605826786308)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2060_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2060_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3702957005373669)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2060_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_object(',
'    p_object_name     => :P2060_NAME,',
'    p_object_type     => ''MATERIALIZED VIEW'',',
'    p_parsing_schema  => :P2060_PARSING_SCHEMA,',
'    p_ddl             => :P2060_DDL );',
'',
':P2060_OBJECT_TYPE := ''MATERIALIZED_VIEW'';'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2726136019369328)
,p_process_success_message=>'Sequence created successfully.'
,p_internal_uid=>3702957005373669
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3703572055376041)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2060_OBJECT_ID,P2060_OBJECT_TYPE,P2060_NAME'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2726136019369328)
,p_process_when=>'P2060_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Materialized View created successfully.'
,p_internal_uid=>3703572055376041
);
end;
/
prompt --application/pages/page_02061
begin
wwv_flow_imp_page.create_page(
 p_id=>2061
,p_name=>'Create Materialized View - Preview SQL'
,p_alias=>'CREATE-MATERIALIZED-VIEW-PREVIEW-SQL'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Materialized View - Preview SQL'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code_onload=>'Prism.highlightAll();'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18529956103886170)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20807578928489690)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql">&P2060_DDL.</code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12800899227004356)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(20807578928489690)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3801246869660170)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(18529956103886170)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Materialized View'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2060:&SESSION.:BRANCH_TO_PAGE_ACCEPT|CREATE:&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3801615736660171)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(18529956103886170)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2060:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3802042903660172)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(18529956103886170)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3802842944660206)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3802042903660172)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803343435660208)
,p_event_id=>wwv_flow_imp.id(3802842944660206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_02065
begin
wwv_flow_imp_page.create_page(
 p_id=>2065
,p_name=>'Create Lookup Table'
,p_alias=>'CREATE-LOOKUP-TABLE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Lookup Table'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9406558606786347)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9404487876786326)
,p_plug_name=>'Preview SQL'
,p_region_name=>'preview_sql'
,p_parent_plug_id=>wwv_flow_imp.id(9406558606786347)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P2065_COLUMN is not null then',
'    return ''<pre id="copy_sql"><code id="preview_sql" class="lang-sql">'' ||',
'           wwv_flow_f4500_ob_wiz_dev.get_lookup_table_ddl(',
'               p_table          => :P2065_TABLE,',
'               p_parsing_schema => :P2065_PARSING_SCHEMA,',
'               p_column_name    => :P2065_COLUMN,',
'               p_lookup_table   => :P2065_NAME ) ||',
'           ''</code></pre>'';',
'else',
'    return null;',
'end if;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_ajax_items_to_submit=>'P2065_TABLE,P2065_COLUMN,P2065_NAME'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23401203628904202)
,p_plug_name=>'Lookup Table Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24115309093862060)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9405461548786336)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(9406558606786347)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2732221742372440)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(24115309093862060)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Lookup Table'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2731870430372440)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(24115309093862060)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775742365216712)
,p_name=>'P2065_PARSING_SCHEMA'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(23401203628904202)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2733602108372448)
,p_name=>'P2065_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(23401203628904202)
,p_prompt=>'Lookup Table Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of newly created lookup table'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2734013557372448)
,p_name=>'P2065_OBJECT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(23401203628904202)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2734412987372449)
,p_name=>'P2065_OBJECT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(23401203628904202)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9403657784786318)
,p_name=>'P2065_TABLE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(23401203628904202)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name d,',
'       table_name r',
'  from sys.dba_tables',
' where owner      = :P2065_PARSING_SCHEMA',
'   and table_name not like ''DR$%''',
'   and table_name not like ''BIN$%''',
' order by 1'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_read_only_when=>'P2065_TABLE'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Name of table to create a lookup table from'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9403715816786319)
,p_name=>'P2065_COLUMN'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(23401203628904202)
,p_prompt=>'Text Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d,',
'       column_name r',
'  from sys.dba_tab_columns',
' where owner      = :P2065_PARSING_SCHEMA',
'   and table_name = :P2065_TABLE',
'   and data_type  = ''VARCHAR2''',
'   and column_id is not null',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P2065_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify which column is to be used to generate the lookup table. Only VARCHAR2 columns are displayed here.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9403944953786321)
,p_validation_name=>'P2065_NAME valid & available'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P2065_NAME,',
'    p_owner           => :P2065_PARSING_SCHEMA,',
'    p_object_type     => ''TABLE'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2065_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2733602108372448)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2736175195372463)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2731870430372440)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2736630032372464)
,p_event_id=>wwv_flow_imp.id(2736175195372463)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2735221177372462)
,p_name=>'Submit CREATE'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2732221742372440)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2735713608372463)
,p_event_id=>wwv_flow_imp.id(2735221177372462)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9404086235786322)
,p_name=>'Replace Spaces and Double Quotes'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2065_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9404193869786323)
,p_event_id=>wwv_flow_imp.id(9404086235786322)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2065_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2065_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9404292099786324)
,p_name=>'Set P2065_NAME'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2065_COLUMN'
,p_condition_element=>'P2065_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9404373027786325)
,p_event_id=>wwv_flow_imp.id(9404292099786324)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2065_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P2065_COLUMN").getValue() + ''_'' + ''LOOKUP'''
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9404510729786327)
,p_name=>'Refresh Preview SQL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2065_TABLE,P2065_COLUMN,P2065_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P2065_TABLE").getValue() !== "" && apex.item("P2065_COLUMN").getValue() !== "" && apex.item("P2065_NAME").getValue() !== ""'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9404623503786328)
,p_event_id=>wwv_flow_imp.id(9404510729786327)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(9404487876786326)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9404779063786329)
,p_event_id=>wwv_flow_imp.id(9404510729786327)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(9406558606786347)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9404853765786330)
,p_event_id=>wwv_flow_imp.id(9404510729786327)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(9406558606786347)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9405066792786332)
,p_name=>'Syntax Highlight'
,p_event_sequence=>60
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(9404487876786326)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9405157395786333)
,p_event_id=>wwv_flow_imp.id(9405066792786332)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'Prism.highlightAll();'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5500458044958471)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2065_OBJECT_TYPE := ''TABLE'';',
'',
'wwv_flow_f4500_ob_wiz_dev.create_lookup_table(',
'    p_table           => :P2065_TABLE,',
'    p_parsing_schema  => :P2065_PARSING_SCHEMA,',
'    p_column_name     => :P2065_COLUMN,',
'    p_lookup_table    => :P2065_NAME,',
'    p_object_id       => :P2065_OBJECT_ID);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2732221742372440)
,p_process_success_message=>'Table created successfully.'
,p_internal_uid=>5500458044958471
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5500710331959498)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2065_OBJECT_ID,P2065_OBJECT_TYPE,P2065_NAME,P2065_PARSING_SCHEMA'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2732221742372440)
,p_process_when=>'P2065_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Table created successfully.'
,p_internal_uid=>5500710331959498
);
end;
/
prompt --application/pages/page_02070
begin
wwv_flow_imp_page.create_page(
 p_id=>2070
,p_name=>'Create Database Link'
,p_alias=>'CREATE-DATABASE-LINK'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Database Link'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#objectBrowserWizard#MIN#.js'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26852648428237245)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27550962319679223)
,p_plug_name=>'SQL Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_plug_source=>'<pre id="copy_sql"><code id="preview_sql" class="lang-sql"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(165649885071535409)
,p_plug_name=>'Database Link'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2738356251375186)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(26852648428237245)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Database Link'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8004610133485322)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(27550962319679223)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'a-Icon icon-copy'
,p_button_cattributes=>'data-clipboard-source="#copy_sql"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2737914013375186)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(26852648428237245)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775847731216713)
,p_name=>'P2070_PARSING_SCHEMA'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2739083316375187)
,p_name=>'P2070_DDL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(27550962319679223)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2740141656375188)
,p_name=>'P2070_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2740591032375188)
,p_name=>'P2070_OBJECT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11006494870024538)
,p_name=>'P2070_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_prompt=>'Database Link Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the name of the database link. Database link names must conform to Oracle naming conventions and cannot contain spaces, or start with a number or underscore.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11007300164024539)
,p_name=>'P2070_CONNECT_TO_SCHEMA'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_prompt=>'Connect To Schema'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the database schema on the remote system to access.  Note that the schema name is case-sensitive.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11008250953024539)
,p_name=>'P2070_PASSWORD'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password for the remote database schema.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11009140626024540)
,p_name=>'P2070_REMOTE_HOST'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_prompt=>'Remote Hostname or IP'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the hostname or IP address of the database server you wish to access.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11010032506024540)
,p_name=>'P2070_REMOTE_HOST_PORT'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_prompt=>'Remote Host Port'
,p_source=>'1521'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the network port number on which the Oracle Net Listener is accepting requests. This is typically 1521.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11010904472024541)
,p_name=>'P2070_SID_OR_SERVICE'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_prompt=>'Identified by'
,p_source=>'SID'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SID_SERVICE'
,p_lov=>'.'||wwv_flow_imp.id(270736905720819349)||'.'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Choose how you want to identify the remote database, using "Oracle System Identifier" ( SID ) or "Service Name".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11011841132024541)
,p_name=>'P2070_SID_OR_SERVICE_NAME'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(165649885071535409)
,p_prompt=>'SID or Service Name'
,p_source=>'ORCL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter "Oracle System Identifier" ( SID ) or "Service Name" of the remote database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10106291605592010)
,p_validation_name=>'P2070_NAME valid & available'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name             => :P2070_NAME,',
'    p_owner            => :P2070_PARSING_SCHEMA,',
'    p_object_type      => ''DATABASE_LINK'',',
'    p_length_check     => false,',
'    p_valid_identifier => false );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2070_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(11006494870024538)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10106305335592011)
,p_validation_name=>'P2070_NAME valid DB link name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_builder.is_valid_dblink_name(upper(:P2070_NAME)) then',
'    return wwv_flow_lang.system_message(''F4500.NOT_VALID_OBJECT_NAME'',wwv_flow_escape.html(:P2070_NAME));',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P2070_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(11006494870024538)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2742203381375189)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2737914013375186)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2742791365375189)
,p_event_id=>wwv_flow_imp.id(2742203381375189)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2741367509375189)
,p_name=>'Submit CREATE'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2738356251375186)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2741843377375189)
,p_event_id=>wwv_flow_imp.id(2741367509375189)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10107007392592018)
,p_name=>'P2070_NAME Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2070_NAME'
,p_condition_element=>'P2070_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10107128880592019)
,p_event_id=>wwv_flow_imp.id(10107007392592018)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Replace Spaces and Double Quotes'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2070_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P2070_NAME'').getValue().replaceAll('' '',''_'').replaceAll(''"'','''')'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10107338644592021)
,p_event_id=>wwv_flow_imp.id(10107007392592018)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2070_DDL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10107274863592020)
,p_event_id=>wwv_flow_imp.id(10107007392592018)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Preview SQL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2070_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getDBLinkDDL( $v( "P2070_NAME" ), $v( "P2070_CONNECT_TO_SCHEMA" ), $v( "P2070_PASSWORD" ), $v( "P2070_REMOTE_HOST" ), $v( "P2070_REMOTE_HOST_PORT" ), $v( "P2070_SID_OR_SERVICE" ), $v( "P2070_SID_OR_SERVICE_NAME" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.item("P2070_NAME").getValue() !== "" && apex.item("P2070_CONNECT_TO_SCHEMA").getValue() !== "" && apex.item("P2070_PASSWORD").getValue() !== "" && apex.item("P2070_REMOTE_HOST").getValue() !== ""'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10107402925592022)
,p_name=>'Preview SQL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2070_CONNECT_TO_SCHEMA,P2070_PASSWORD,P2070_REMOTE_HOST,P2070_REMOTE_HOST_PORT,P2070_SID_OR_SERVICE,P2070_SID_OR_SERVICE_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P2070_NAME").getValue() !== "" && apex.item("P2070_CONNECT_TO_SCHEMA").getValue() !== "" && apex.item("P2070_PASSWORD").getValue() !== "" && apex.item("P2070_REMOTE_HOST").getValue() !== ""'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10107537420592023)
,p_event_id=>wwv_flow_imp.id(10107402925592022)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2070_DDL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'objectBrowserWizard.getDBLinkDDL( $v( "P2070_NAME" ), $v( "P2070_CONNECT_TO_SCHEMA" ), $v( "P2070_PASSWORD" ), $v( "P2070_REMOTE_HOST" ), $v( "P2070_REMOTE_HOST_PORT" ), $v( "P2070_SID_OR_SERVICE" ), $v( "P2070_SID_OR_SERVICE_NAME" ) );'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10107610710592024)
,p_event_id=>wwv_flow_imp.id(10107402925592022)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2070_DDL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8004785409485323)
,p_name=>'Show/Hide Preview SQL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2070_DDL'
,p_condition_element=>'P2070_DDL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8004834033485324)
,p_event_id=>wwv_flow_imp.id(8004785409485323)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(27550962319679223)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8004968580485325)
,p_event_id=>wwv_flow_imp.id(8004785409485323)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(27550962319679223)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8005005630485326)
,p_event_id=>wwv_flow_imp.id(8004785409485323)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery("#preview_sql").text($v("P2070_DDL"));',
'Prism.highlightAll();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8005133022485327)
,p_event_id=>wwv_flow_imp.id(8004785409485323)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery("#preview_sql").text("");'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4400702843942462)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run DDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_db_link_name varchar2(128);',
'begin',
'    :P2070_OBJECT_TYPE := ''DATABASE_LINK'';',
'    ',
'    -- depending on DB settings, we may need to append domain name to db link name',
'    -- in UI it''s not possible to append domain name, because it will throw invalid object name error',
'    -- if we just pass db-link name with-out domain name, Oracle will automatically append it for us',
'    -- we need this full name before, so we can compute object id and also we can use it to set P2070_NAME item value',
'    l_db_link_name := wwv_flow_f4500_ob_wiz_dev.get_full_db_link_name(:P2070_NAME);',
'    ',
'    :P2070_OBJECT_ID := wwv_flow_f4500_ob_wiz_dev.create_object(',
'                            p_object_name     => l_db_link_name,',
'                            p_object_type     => :P2070_OBJECT_TYPE,',
'                            p_parsing_schema  => :P2070_PARSING_SCHEMA,',
'                            p_ddl             => :P2070_DDL );',
'',
'    if :P2070_OBJECT_ID is not null then',
'        :P2070_NAME := l_db_link_name;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2738356251375186)
,p_process_success_message=>'Database link created successfully.'
,p_internal_uid=>4400702843942462
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4401358672944463)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P2070_OBJECT_ID,P2070_OBJECT_TYPE,P2070_NAME'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2738356251375186)
,p_process_when=>'P2070_OBJECT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Database link created successfully.'
,p_internal_uid=>4401358672944463
);
end;
/
prompt --application/pages/page_02300
begin
wwv_flow_imp_page.create_page(
 p_id=>2300
,p_name=>'Package Detail'
,p_alias=>'PACKAGE_DETAIL'
,p_step_title=>'Package Detail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_help_text=>'AEUTL/obj_pack.htm'
,p_page_comment=>'This page is used by the Object Browser as landing page for the currently selected object type. Don''t delete it! - Patrick'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(467006627439825669)
,p_branch_name=>'Go To Page 2250'
,p_branch_action=>'f?p=&APP_ID.:2250:&SESSION.:GETOBJECT_TREE:&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_03002
begin
wwv_flow_imp_page.create_page(
 p_id=>3002
,p_name=>'SQL Workshop'
,p_alias=>'SQL-WORKSHOP'
,p_step_title=>'SQL Workshop'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_deep_linking=>'Y'
,p_help_text=>'AEUTL/sql_about.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(769212543972447)
,p_plug_name=>'&P3002_SCHEMA.'
,p_region_sub_css_classes=>'sql-workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_imp.id(46900227098494683)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385894774262579225)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(24083118039996911)
,p_name=>'Recent SQL Scripts'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P3002c */',
'substr(f.filename,1,50) name,',
'nvl(f.updated_on,f.created_on) updated,',
'f.id',
'from wwv_flow_files f, wwv_flow_fnd_user u',
'where u.security_group_id = :flow_security_group_id',
'and u.user_name = :APP_USER',
'and f.file_type = ''SCRIPT'' and (f.created_by = :APP_USER',
'       or exists ( select 1',
'                     from  wwv_flow_developers',
'                    where security_group_id = :flow_security_group_id',
'                      and userid = :APP_USER',
'                      and instr(developer_role||'':'',''ADMIN:'') > 0',
'                    union',
'                   select 1',
'                     from wwv_flow_fnd_user',
'                    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                      and user_name = :APP_USER',
'                      and attribute_01 in (''ORACLE_ADMIN'',''SCHOOL_ADMIN'',''TEACHER'')))',
'order by updated desc'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1340557295961171098)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(24083118039996911)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(24084858275996928)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.::P60_FILE_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(24083855649996918)
,p_query_column_id=>2
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>2
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(24083270378996912)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33438082761898212)
,p_plug_name=>'Learn More Region'
,p_region_css_classes=>'a-ButtonRegion--banner apex-sql-workshop'
,p_region_template_options=>'a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>70
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-MediaBlock">'');',
'sys.htp.p(''    <div class="a-MediaBlock-graphic">'');',
'sys.htp.p(''        <span class="icon-get-started" aria-hidden="true"></span>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''    <div class="a-MediaBlock-content">'');',
'sys.htp.p(''        <h2>''||wwv_flow_lang.system_message(''LEARN_MORE_SQL_WORKSHOP'')||''</h2>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_platform.get_preference(''GETTING_STARTED_ENABLED'') = ''Y'';'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46904309839593843)
,p_name=>'Recently Created Tables'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P3002a */ object_name,',
'       created,',
'       object_id,',
'       :P3002_SCHEMA object_owner',
'from sys.user_objects',
'where',
'      object_name not like ''BIN$%'' and',
'      object_type = ''TABLE''',
'order by created desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46912117501975223)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No tables found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P3002_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46904602375593856)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:2000:&SESSION.:::2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:#OBJECT_OWNER#,#OBJECT_ID#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46904718036593858)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46904828986593858)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(710588573054275238)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_OWNER'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(46915904438027404)
,p_name=>'Recent SQL Commands'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4500P3002b */',
'    replace(replace(',
'       sys.dbms_lob.substr(command,35,1),chr(10),'' ''),chr(13),'' '')||',
'       decode(greatest(sys.dbms_lob.getlength(command),35),35,null,''...'') sql_cmd,',
'    CREATED_ON created, ',
'    created_by, ',
'    id,',
'    PARSED_SCHEMA',
'from ',
'    wwv_flow_sw_sql_cmds  ',
'where ',
'    security_group_id = :flow_security_group_id  ',
'    and created_by = :flow_user ',
'    and PARSED_SCHEMA = :P3002_SCHEMA',
'order by ',
'    created_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(46912117501975223)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No SQL commands found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(46915904438027404)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46917202491036341)
,p_query_column_id=>1
,p_column_alias=>'SQL_CMD'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46916227762027412)
,p_query_column_id=>2
,p_column_alias=>'CREATED'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46917330903036341)
,p_query_column_id=>3
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46917410539036341)
,p_query_column_id=>4
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46917526117036341)
,p_query_column_id=>5
,p_column_alias=>'PARSED_SCHEMA'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48531311825296092)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The SQL Workshop is a collection of tools to manage database objects.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201516612078031858)
,p_plug_name=>'Schema'
,p_region_css_classes=>'a-Form--floatColsLeft'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Form--leftLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>65
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'Select the default database schema for your SQL Workshop session.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33441178232898243)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33438082761898212)
,p_button_name=>'GET_STARTED'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Get Started'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/go/get_started_sql_workshop'');'
,p_button_css_classes=>'a-Button--dark'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27786530080161924)
,p_branch_action=>'f?p=&APP_ID.:3002:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46910410185943935)
,p_name=>'P3002_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(201516612078031858)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1003_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1003_SCHEMA ) d,',
'       :P1003_SCHEMA v',
'  from sys.dual',
' where :P1003_POPUP = 1',
' order by 1'))
,p_tag_css_classes=>'a-Form-field stretch'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(171443012411362459)
,p_computation_sequence=>10
,p_computation_item=>'F4500_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3002'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6004225712547938)
,p_name=>'Submit Page'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3002_SCHEMA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6004373005547939)
,p_event_id=>wwv_flow_imp.id(6004225712547938)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(201517700566047477)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv(:P3002_SCHEMA);',
'',
':P800_SCHEMA     := :P3002_SCHEMA;',
':P10_RUN_AS      := :P3002_SCHEMA;',
':P2000_OB_SCHEMA := wwv_flow_f4500_ob_wiz_dev.get_workspace_schema_id( p_schema => :P3002_SCHEMA );',
':P1003_SCHEMA    := :P3002_SCHEMA;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>201517700566047477
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(46913903783979944)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set schema'
,p_process_sql_clob=>':P3002_SCHEMA := wwv_flow_user_api.get_default_schema;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P3002_SCHEMA'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>46913903783979944
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(46968921284148678)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P3002_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>46968921284148678
);
end;
/
prompt --application/pages/page_03100
begin
wwv_flow_imp_page.create_page(
 p_id=>3100
,p_name=>'Load Data'
,p_alias=>'LOAD-DATA'
,p_page_mode=>'MODAL'
,p_step_title=>'Load Data'
,p_reload_on_submit=>'A'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'div#configureColumns {',
'    margin-left: calc(30% + 8px);',
'    box-shadow: none;',
'    margin-right: 16px;',
'    margin-top: 4px;',
'    margin-bottom: 4px;',
'}',
'',
'#configureColumns .a-Alert-body {',
'  margin: 0;',
'}',
'',
'div#configureColumns .a-Alert-icon, ',
'div#configureColumns .a-Alert-content, ',
'div#configureColumns .a-Alert-buttons {',
'  padding: 8px 0;',
'}',
'',
'div#configureColumns .a-Alert-buttons {',
'    padding: 8px;',
'}',
'',
'div#configureColumns .a-Report-cell {',
'  padding: 0 8px;',
'  background-color: transparent;',
'}'))
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_dialog_height=>'720'
,p_dialog_width=>'1024'
,p_dialog_attributes=>'resizable:true'
,p_dialog_css_classes=>'a-Page--DataLoad &P3100_BODY_CLASS.'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1620249167834602)
,p_plug_name=>'File'
,p_region_name=>'drag_drop_file'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>60
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1623796617834637)
,p_plug_name=>'File Loaded'
,p_region_name=>'load_completed'
,p_parent_plug_id=>wwv_flow_imp.id(1620249167834602)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="b-FileDataPreview">',
'  <span class="a-Icon a-Icon--large icon-ig-dl-xls" aria-hidden="true"></span>',
'  <span class="b-FileDataPreview-label">&P3100_FILE_NAME.</span>',
'</div>'))
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3100_FILE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1620435155834604)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1697074737214101)
,p_plug_name=>'Preview'
,p_region_css_classes=>'a-DataLoad-preview'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>95
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1621706117834617)
,p_name=>'Parsed Data'
,p_region_name=>'preview_table'
,p_parent_plug_id=>wwv_flow_imp.id(1697074737214101)
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select line_number, ',
'       substr( col001, 1, 500 ) col001, ',
'       substr( col002, 1, 500 ) col002, ',
'       substr( col003, 1, 500 ) col003, ',
'       substr( col004, 1, 500 ) col004, ',
'       substr( col005, 1, 500 ) col005, ',
'       substr( col006, 1, 500 ) col006, ',
'       substr( col007, 1, 500 ) col007, ',
'       substr( col008, 1, 500 ) col008, ',
'       substr( col009, 1, 500 ) col009, ',
'       substr( col010, 1, 500 ) col010 ',
'from wwv_flow_temp_files f, ',
'     table( wwv_flow_data_parser.parse(',
'                p_content               => f.blob_content,',
'                p_file_name             => f.filename,',
'                --   ',
'                p_add_headers_row       => ''Y'',',
'                -- please *always* set p_max_rows as a safeguard against fully parsing large files',
'                p_max_rows              => nullif(:P3100_MAX_ROW_COUNT, ''0''),',
'                -- for parser to return p_return_rows, region max rows must be > p_return_rows',
'                p_return_rows           => 5,',
'                p_xlsx_sheet_name       => ( case when :P3100_FILE_TYPE = 1 and :P3100_XLSX_SHEET is not null then :P3100_XLSX_SHEET end ),',
'                p_csv_col_delimiter     => replace(:P3100_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                p_file_charset          => coalesce( :P3100_FILE_CHARSET, ''AL32UTF8'' ),',
'                p_csv_enclosed          => nullif( :P3100_CSV_ENCLOSED, ''None'' ),',
'                p_force_trim_whitespace => :P3120_TRIM_WHITESPACE,',
'                p_nullif                => :P3120_NULLIF )',
'                )',
'where f.name = :P3100_FILE',
'and :P3100_SOURCE_TYPE = ''FILE''',
'union all',
'select line_number, ',
'       substr( col001, 1, 500 ) col001, ',
'       substr( col002, 1, 500 ) col002, ',
'       substr( col003, 1, 500 ) col003, ',
'       substr( col004, 1, 500 ) col004, ',
'       substr( col005, 1, 500 ) col005, ',
'       substr( col006, 1, 500 ) col006, ',
'       substr( col007, 1, 500 ) col007, ',
'       substr( col008, 1, 500 ) col008, ',
'       substr( col009, 1, 500 ) col009, ',
'       substr( col010, 1, 500 ) col010 ',
'from wwv_flow_collections c, ',
'     table( wwv_flow_data_parser.parse(',
'                p_content               => c.blob001,',
'                p_file_type             => 2,',
'                --   ',
'                p_add_headers_row       => ''Y'',',
'                p_max_rows              => nullif(:P3100_MAX_ROW_COUNT, ''0''),',
'                -- for parser to return p_return_rows, region max rows must be > p_return_rows',
'                p_return_rows           => 5,',
'                p_csv_col_delimiter     => replace(:P3100_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                p_file_charset          => coalesce( :P3100_FILE_CHARSET, ''AL32UTF8'' ),',
'                p_force_trim_whitespace => :P3120_TRIM_WHITESPACE,',
'                p_csv_enclosed          => nullif( :P3100_CSV_ENCLOSED, ''None'' ),',
'                p_nullif                => :P3120_NULLIF )',
'                )',
'where c.collection_name=''CLOB_CONTENT''',
'and :P3100_SOURCE_TYPE = ''COPY_PASTE'';',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_row_count_max=>150
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1621834152834618)
,p_query_column_id=>1
,p_column_alias=>'LINE_NUMBER'
,p_column_display_sequence=>1
,p_column_heading=>'Line'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1621903762834619)
,p_query_column_id=>2
,p_column_alias=>'COL001'
,p_column_display_sequence=>2
,p_column_heading=>'COL001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622051084834620)
,p_query_column_id=>3
,p_column_alias=>'COL002'
,p_column_display_sequence=>3
,p_column_heading=>'COL002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622187965834621)
,p_query_column_id=>4
,p_column_alias=>'COL003'
,p_column_display_sequence=>4
,p_column_heading=>'COL003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622266185834622)
,p_query_column_id=>5
,p_column_alias=>'COL004'
,p_column_display_sequence=>5
,p_column_heading=>'COL004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622338030834623)
,p_query_column_id=>6
,p_column_alias=>'COL005'
,p_column_display_sequence=>6
,p_column_heading=>'COL005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622446791834624)
,p_query_column_id=>7
,p_column_alias=>'COL006'
,p_column_display_sequence=>7
,p_column_heading=>'COL006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622556563834625)
,p_query_column_id=>8
,p_column_alias=>'COL007'
,p_column_display_sequence=>8
,p_column_heading=>'COL007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622647721834626)
,p_query_column_id=>9
,p_column_alias=>'COL008'
,p_column_display_sequence=>9
,p_column_heading=>'COL008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622722391834627)
,p_query_column_id=>10
,p_column_alias=>'COL009'
,p_column_display_sequence=>10
,p_column_heading=>'COL009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622845352834628)
,p_query_column_id=>11
,p_column_alias=>'COL010'
,p_column_display_sequence=>11
,p_column_heading=>'COL010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1753932155870113)
,p_plug_name=>'get file profile and save'
,p_region_name=>'getFileProfile'
,p_parent_plug_id=>wwv_flow_imp.id(1697074737214101)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile             clob;',
'    l_file_content        blob;',
'    l_profile_record      wwv_flow_data_parser.t_file_profile;',
'begin',
'    l_profile        := wwv_flow_data_parser.get_file_profile;',
'    l_profile_record := wwv_flow_data_parser.json_to_profile( l_profile );',
'  ',
'    if :P3100_FIRST_LINE is null or :P3100_FIRST_LINE != ''HEADERS'' then',
'        for i in 1 .. l_profile_record.file_columns.count loop',
'            l_profile_record.file_columns( i ).name := ''COL'' || lpad( i,3,''0'');',
'        end loop;',
'        l_profile := wwv_flow_data_parser.profile_to_json(l_profile_record);',
'    end if;',
'    ',
'    -- save file profile in collection for later use',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'    wwv_flow_collection.add_member( ''APEX$DATALOAD'', p_clob001 => l_profile );',
'    ',
'    :P3100_FILE_TYPE           := l_profile_record.file_type;',
'    :P3100_CSV_COL_DELIMITER   := l_profile_record.csv_delimiter;',
'    :P3100_NEW_COL_DELIMITER   := ( case when l_profile_record.csv_delimiter = chr(9) then ''tab'' else l_profile_record.csv_delimiter end );',
'    :P3100_PARSED_ROW_COUNT    := l_profile_record.parsed_rows;',
'    ',
'    if l_profile_record.file_columns.count <= 10 then',
'        :P3100_PARSED_COLUMN_COUNT := l_profile_record.file_columns.count;',
'    else',
'        :P3100_PARSED_COLUMN_COUNT := 10;',
'    end if;',
'',
'    :P3100_FILE_COLUMN_COUNT   := l_profile_record.file_columns.count;',
'    :P3100_FILE_INVALID        := case when l_profile_record.file_columns.count > 0 ',
'                                      then ''N'' ',
'                                      else ''Y'' ',
'                                  end;',
'exception',
'    when others then',
'        :P3100_FILE_INVALID := ''Y'';',
'        wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3453574897395910)
,p_plug_name=>'Unsupported File'
,p_parent_plug_id=>wwv_flow_imp.id(1697074737214101)
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard:a-Form--labelsAbove'
,p_region_attributes=>'style="display:none"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'&PRODUCT_NAME. could not find columns in the uploaded file, as the file format or structure is unsupported. Please upload another file.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16455974874013422)
,p_plug_name=>'Preview Information'
,p_parent_plug_id=>wwv_flow_imp.id(1697074737214101)
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_icon_css_classes=>'icon-report'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="desc">Parsed first <span id="placeholder_P3100_PARSED_ROW_COUNT">&P3100_PARSED_ROW_COUNT.</span> rows to sample the column types. The preview below only displays the first <span id="placeholder_P3100_PARSED_COLUMN_COUNT">&P3100_PARSED_COLUM'
||'N_COUNT.</span> columns and 5 rows. Only up to 500 characters of column content are shown. To view the full preview and configure data load settings, please click <strong>Preview</strong> button.</p>',
''))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1700073592214131)
,p_plug_name=>'Settings'
,p_region_name=>'settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>85
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16455885026013421)
,p_plug_name=>'Settings Item Container'
,p_parent_plug_id=>wwv_flow_imp.id(1700073592214131)
,p_region_template_options=>'a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3993380922355405)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6218048841571854)
,p_plug_name=>'Load Information'
,p_region_name=>'load-to-table'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>105
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2829146353927247)
,p_name=>'Jobs Still Running to Load Data'
,p_parent_plug_id=>wwv_flow_imp.id(6218048841571854)
,p_template=>wwv_flow_imp.id(717419046555820782)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    j.job_name, ',
'    j.state,',
'    j.start_date,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,2,''i'',2 ) as workspace_user,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,3,''i'',2 ) as table_owner,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,4,''i'',2 ) as table_name',
' from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'  and c.display_name = :COMPANY',
'  and j.state = ''RUNNING''',
'  and job_name like ''ORACLE_APEX_DTLD$%'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
' from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'  and c.display_name = :COMPANY ',
'  and j.state = ''RUNNING''',
'  and job_name like ''ORACLE_APEX_DTLD$%'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(218530990339706541)
,p_query_column_id=>1
,p_column_alias=>'JOB_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'DBMS_SCHEDULER Job Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(218529334602706525)
,p_query_column_id=>2
,p_column_alias=>'STATE'
,p_column_display_sequence=>2
,p_column_heading=>'Job State'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(218529455390706526)
,p_query_column_id=>3
,p_column_alias=>'START_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Started'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(218529523739706527)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_USER'
,p_column_display_sequence=>4
,p_column_heading=>'Workspace User'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(218529625567706528)
,p_query_column_id=>5
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Table Owner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(218529730064706529)
,p_query_column_id=>6
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52175039421071205)
,p_plug_name=>'Where do you want to load this data?'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>65
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52038037134715336)
,p_plug_name=>'Basic Table Info'
,p_parent_plug_id=>wwv_flow_imp.id(52175039421071205)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52038248707715338)
,p_plug_name=>'Table Definition'
,p_parent_plug_id=>wwv_flow_imp.id(52175039421071205)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52038303945715339)
,p_plug_name=>'Additional Fields'
,p_parent_plug_id=>wwv_flow_imp.id(52175039421071205)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(82702857605738101)
,p_name=>'Configure Information'
,p_region_name=>'configureColumns'
,p_parent_plug_id=>wwv_flow_imp.id(52175039421071205)
,p_template=>wwv_flow_imp.id(746376253838324384)
,p_display_sequence=>30
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_icon_css_classes=>'icon-report'
,p_region_template_options=>'a-Alert--colorBG:a-Alert--noIcon:a-Alert--info:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--noBorders'
,p_region_attributes=>'style="display: none;"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_info           varchar2(32767);',
'    l_mapped_col_cnt number;',
'    l_file_col_cnt   number;',
'begin',
'    l_mapped_col_cnt := to_number(:P3100_MAPPED_COLUMN_COUNT);',
'    l_file_col_cnt := to_number(:P3100_FILE_COLUMN_COUNT);',
'    ',
'    if :P3100_LOAD_TO = ''EXISTING'' then',
'        if l_mapped_col_cnt = 0 then',
'            l_info := wwv_flow_lang.system_message( ''DATA.LOAD.DEFINE_COL_MAPPING'', wwv_flow_escape.html(:P3100_EXISTING_TABLE ));',
'        else',
'            if l_mapped_col_cnt = l_file_col_cnt then',
'                l_info := wwv_flow_lang.system_message( ''DATA.LOAD.ALL_COL_MAPPED'', :P3100_FILE_COLUMN_COUNT, wwv_flow_escape.html(:P3100_EXISTING_TABLE ) );',
'            elsif l_mapped_col_cnt < l_file_col_cnt then',
'                l_info := wwv_flow_lang.system_message( ''DATA.LOAD.MAP_REMAINING_COLS'', :P3100_MAPPED_COLUMN_COUNT, :P3100_FILE_COLUMN_COUNT, wwv_flow_escape.html(:P3100_EXISTING_TABLE ) );',
'            end if;',
'        end if;',
'    else',
'        l_info := wwv_flow_lang.system_message(''DATA.LOAD.SELECT_COLS'');',
'    end if;',
'',
'    return ''select ''||wwv_flow_assert.enquote_literal(l_info)||'' info from sys.dual'';',
'end;'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(82703320182738106)
,p_query_column_id=>1
,p_column_alias=>'INFO'
,p_column_display_sequence=>1
,p_column_heading=>'Info'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(118039895666597546)
,p_plug_name=>'Choose Source'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type is null then',
'    return true;',
'else',
'    if :p3100_source_type = ''FILE'' then',
'      if :P3100_FILE is null then',
'          return true;',
'      end if;',
'    elsif :p3100_source_type = ''COPY_PASTE'' then',
'      if :P3100_DATA is null then',
'          return true;',
'      end if;',
'    end if;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(118040030879597548)
,p_plug_name=>'Copy and Paste Container'
,p_region_name=>'copy_paste_file'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(217930797515203801)
,p_plug_name=>'Samples'
,p_parent_plug_id=>wwv_flow_imp.id(118040030879597548)
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'You can copy and paste CSV data, or select a sample data set.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P3100_DATA'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(217930831433203802)
,p_plug_name=>'Copy Paste Textarea'
,p_parent_plug_id=>wwv_flow_imp.id(118040030879597548)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(2976007666683831)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P3100_DATA'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(212734359026785604)
,p_plug_name=>'Pasted Data'
,p_region_css_classes=>'b-FileDataPreview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>50
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<span class="a-Icon a-Icon--large icon-page-dynamic" aria-hidden="true"></span>'');',
'sys.htp.p(''<span>''||wwv_flow_lang.system_message(''DATA.LOAD.PASTED_DATA'')||''</span>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3100_DATA'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-Icon a-Icon--large icon-clipboard" aria-hidden="true"></span>',
'The data pasted and parsed.'))
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1620594128834605)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1620435155834604)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4142265341584031)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(16455974874013422)
,p_button_name=>'FULL_PREVIEW'
,p_button_static_id=>'bt-full-preview'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Preview'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:RP,3120:P3120_FIRST_LINE,P3120_MAX_ROW_COUNT,P3120_PREV_MAX_ROW_COUNT,P3120_XLSX_SHEET,P3120_CSV_COL_DELIMITER,P3120_CSV_ENCLOSED,P3120_FILE_CHARSET,P3120_FILE_SIZE,P3120_NULLIF,P3120_ACTION:&P3100_FIRST_LINE.,&P3100_MAX_ROW_COUNT.,&P3100_PREV_MAX_ROW_COUNT.,&P3100_XLSX_SHEET.,\&P3100_CSV_COL_DELIMITER.\,\&P3100_CSV_ENCLOSED.\,&P3100_FILE_CHARSET.,&P3100_FILE_SIZE.,&P3120_NULLIF.,tab_preview'
,p_icon_css_classes=>'icon-open-in-dialog margin-left-sm'
,p_button_comment=>'Set Columns and Settings'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(212734620593785607)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1620435155834604)
,p_button_name=>'NEXT'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.widget.textareaClob.uploadNonEmpty(''P3100_DATA'', ''NEXT'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_DATA is null and :P3100_FILE is null then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1620874202834608)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1620435155834604)
,p_button_name=>'LOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Load Data'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null and coalesce( :P3100_FILE_INVALID, ''N'' ) = ''N'' then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null and coalesce( :P3100_FILE_INVALID, ''N'' ) = ''N'' then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(69708360594469904)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(82702857605738101)
,p_button_name=>'CONFIGURE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Configure'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:RP,3120:P3120_FIRST_LINE,P3120_MAX_ROW_COUNT,P3120_PREV_MAX_ROW_COUNT,P3120_XLSX_SHEET,P3120_CSV_COL_DELIMITER,P3120_CSV_ENCLOSED,P3120_FILE_CHARSET,P3120_FILE_SIZE,P3120_NULLIF,P3120_ACTION:&P3100_FIRST_LINE.,&P3100_MAX_ROW_COUNT.,&P3100_PREV_MAX_ROW_COUNT.,&P3100_XLSX_SHEET.,\&P3100_CSV_COL_DELIMITER.\,\&P3100_CSV_ENCLOSED.\,&P3100_FILE_CHARSET.,&P3100_FILE_SIZE.,&P3120_NULLIF.,tab_columns'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null and coalesce( :P3100_FILE_INVALID, ''N'' ) = ''N'' then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null and coalesce( :P3100_FILE_INVALID, ''N'' ) = ''N'' then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-open-in-dialog margin-left-sm'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1698876190214119)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1620435155834604)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p3100_source_type = ''FILE'' then',
'  if :P3100_FILE is not null then',
'      return true;',
'  end if;',
'elsif :p3100_source_type = ''COPY_PASTE'' then',
'  if :P3100_DATA is not null then',
'      return true;',
'  end if;',
'end if;',
'return false;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1698422687214115)
,p_branch_name=>'View Load Detail'
,p_branch_action=>'f?p=&APP_ID.:3110:&SESSION.::&DEBUG.:RP,3110:P3110_LOAD_TO:&P3100_LOAD_TO.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1620874202834608)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4095429302018728)
,p_branch_name=>'Upload File'
,p_branch_action=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'UPLOAD_FILE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1620366629834603)
,p_name=>'P3100_FILE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1620249167834602)
,p_prompt=>'Upload FIle'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3100_SOURCE_TYPE = ''FILE'' and',
':P3100_FILE is null'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_css_classes=>'data-load-input'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_12=>'DROPZONE_BLOCK'
,p_attribute_14=>'Supported formats csv, xlsx, txt, xml, json'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1623446560834634)
,p_name=>'P3100_CSV_COL_DELIMITER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(16455885026013421)
,p_prompt=>'Column Delimiter'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov=>'.'||wwv_flow_imp.id(3927422505659936)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a column delimiter character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1623832490834638)
,p_name=>'P3100_FILE_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(6218048841571854)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1623974907834639)
,p_name=>'P3100_FILE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1623796617834637)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1624290645834642)
,p_name=>'P3100_FIRST_LINE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(16455885026013421)
,p_prompt=>'Column Headers'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DATA.LOAD.FIRST_LINE'
,p_lov=>'.'||wwv_flow_imp.id(3934090607812623)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) not in (wwv_flow_data_parser.c_file_type_xml, wwv_flow_data_parser.c_file_type_json) then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select this option if your data contains column names in the first row.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1701709661214148)
,p_name=>'P3100_XLSX_SHEET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(16455885026013421)
,p_prompt=>'Select Sheet'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_file_name',
'from wwv_flow_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_''',
'  and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' )',
'  and rownum = 1',
'order by sheet_sequence'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_display_name, sheet_file_name',
'from wwv_flow_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_''',
'  and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' )',
'order by sheet_sequence;'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sheet_cnt number := 0;',
'begin',
'    -- shortcut: return immediately when we don''t have an XLSX file, since invoking wwv_flow_data_parser.get_xlsx_worksheets',
'    -- is an expensive operation leading to nothing',
'    if lower( :P3100_FILE ) not like ''%.xls_'' then',
'        return false;',
'    end if;',
'',
'    select count(*)',
'    into l_sheet_cnt',
'    from wwv_flow_temp_files f, ',
'         table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                    p_content => f.blob_content ) )',
'    where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_''',
'      and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' );',
'    ',
'    -- if there is multiple sheets, display',
'    if ( l_sheet_cnt > 1 ) then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'exception',
'    when others then ',
'        return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Your file contains multiple sheets.  Select the worksheet you want to load.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1755986144870133)
,p_name=>'P3100_CSV_ENCLOSED'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(16455885026013421)
,p_prompt=>'Enclosed By'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov=>'.'||wwv_flow_imp.id(3931221323686172)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a column enclosed by character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1821527306529505)
,p_name=>'P3100_PARSED_COLUMN_COUNT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(6218048841571854)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1821614646529506)
,p_name=>'P3100_MAX_ROW_COUNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(16455885026013421)
,p_item_default=>'200'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Select the maximum number of rows to be used to sample column types.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1835450193875914)
,p_name=>'P3100_PARSED_ROW_COUNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(6218048841571854)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2877400520221585)
,p_name=>'P3100_TABLE_OWNER'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(52038037134715336)
,p_prompt=>'Table Owner'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select the database schema you would like to create and load data into.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2878249657221664)
,p_name=>'P3100_TABLE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(52038248707715338)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the table name you would like to create. By default, all table names are converted to upper case.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2879125861221669)
,p_name=>'P3100_ERROR_TABLE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(52038303945715339)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identify the error table name you would like to save errors during data load. By default, all table names are converted to upper case.  If data load succeeds without any error, this error table is dropped automatically.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2880013230221675)
,p_name=>'P3100_USE_DATA_TYPES'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(52038303945715339)
,p_item_default=>'Y'
,p_prompt=>'Use Column Data Types'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select to use the column types parsed from the file. If un-checked, the table columns will be created as VARCHAR2(4000).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3714657994479804)
,p_name=>'P3100_LOAD_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(6218048841571854)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3993413092355406)
,p_name=>'P3100_SHOW_CONFIG_SAVED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3993380922355405)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3994208357355414)
,p_name=>'P3100_BODY_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3993380922355405)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4093251523018706)
,p_name=>'P3100_NEW_COL_DELIMITER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(6218048841571854)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4093425258018708)
,p_name=>'P3100_FILE_SIZE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(6218048841571854)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4094333119018717)
,p_name=>'P3100_PREV_MAX_ROW_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(16455885026013421)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4142757793584036)
,p_name=>'P3100_FILE_INVALID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3993380922355405)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4143126851584040)
,p_name=>'P3100_FILE_CHARSET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(16455885026013421)
,p_item_default=>'AL32UTF8'
,p_prompt=>'File Encoding'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_DB_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(143362112016702427)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the characterset in which the file is encoded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52175474041071209)
,p_name=>'P3100_LOAD_TO'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(52038037134715336)
,p_item_default=>'NEW'
,p_prompt=>'Load To'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P3100_LOAD_TO'
,p_lov=>'.'||wwv_flow_imp.id(60089930390905970)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52175634888071211)
,p_name=>'P3100_EXISTING_TABLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(52038248707715338)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name a, table_name b',
'from sys.dba_tables',
'where owner=:P3100_TABLE_OWNER',
'and table_name not like ''BIN$%''',
'order by table_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P3100_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the database table you would like to load data into.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52176221364071217)
,p_name=>'P3100_UPDATE_METHOD'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(52038303945715339)
,p_item_default=>'APPEND'
,p_prompt=>'Update Method'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P3100_UPDATE_METHOD'
,p_lov=>'.'||wwv_flow_imp.id(60103143434104047)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>Append</strong> If data already exists in the table, the wizard appends the new rows into the table. If data does not exist, the new rows are simply loaded.</li>',
'    <li><strong>Replace</strong> The entire table is replaced by deleting the table first and then loading the new rows into the table.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(82692293286962401)
,p_name=>'P3100_MAPPED_COLUMN_COUNT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(6218048841571854)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(118039922747597547)
,p_name=>'P3100_SOURCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(118039895666597546)
,p_item_default=>'FILE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(212732804335774230)||'.'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_css_classes=>'apex-button-group a-DataLoad-sourceType'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(207424569646369642)
,p_name=>'P3100_FORCE_SYSGUID_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(52038303945715339)
,p_item_default=>'N'
,p_prompt=>'Primary Keys'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.FORCE_SYSGUID'
,p_lov=>'.'||wwv_flow_imp.id(325824092198610958)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how to set the primary key. Primary keys can be set using SYS_GUID, or identity column.</p>',
'<p>',
'SYS_GUID generates and returns a globally unique identifier. On most platforms, this generated identifier is based on a host identifier, a process or thread identifier of the process or thread invoking the function, and a nonrepeating value (sequence'
||' of bytes). ',
'</p>',
'<p>',
'<strong>SYS_GUID</strong> consumes more space, but is unpredictable.  <strong>Identity Column</strong> is compact, but can be predictable.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(212734444925785605)
,p_name=>'P3100_DATA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(217930831433203802)
,p_prompt=>'Copy and Paste Data'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>10
,p_tag_attributes=>'spellcheck="false"'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(212736048149785621)
,p_name=>'P3100_LOAD_SAMPLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(217930797515203801)
,p_prompt=>'Sample'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SAMPLE.DATA.SPREADSHEETS'
,p_lov=>'.'||wwv_flow_imp.id(217855733246275209)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Sample -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_css_classes=>'hide-visibility'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(275647023544510048)
,p_name=>'P3100_FILE_COLUMN_COUNT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(6218048841571854)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4264573968082529)
,p_computation_sequence=>10
,p_computation_item=>'P3100_FIRST_LINE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P3100_FIRST_LINE'
,p_compute_when_text=>'CHANGE_TO_NULL'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(90116888862448617)
,p_computation_sequence=>20
,p_computation_item=>'P3100_FILE_CHARSET'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_bom       raw(4);',
'    l_file_blob blob;',
'    l_charset   varchar2(20) := ''WE8ISO8859P1'';',
'begin ',
'    select f.blob_content',
'      into l_file_blob',
'      from wwv_flow_temp_files f ',
'     where f.name = :P3100_FILE',
'       and :P3100_SOURCE_TYPE = ''FILE'';',
'',
'    if sys.dbms_lob.getlength( l_file_blob ) > 2 then',
'        l_bom := sys.dbms_lob.substr( lob_loc => l_file_blob, amount => 3, offset => 1 );',
'        if l_bom = hextoraw(''EFBBBF'') then',
'            -- UTF-8 BOM',
'            l_charset := ''AL32UTF8'';',
'        else',
'            -- UTF-16 BOM',
'            if sys.utl_raw.substr(l_bom, 1, 2) = hextoraw(''FEFF'') then ',
'                l_charset := ''AL16UTF16''; ',
'            elsif sys.utl_raw.substr(l_bom, 1, 2) = hextoraw(''FFFE'') then ',
'                l_charset := ''AL16UTF16LE''; ',
'            end if; ',
'        end if;',
'    end if;',
'    return l_charset;',
'exception',
'    when NO_DATA_FOUND then',
'        return null;',
'end;'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE   = ''FILE''    and ',
'   :P3100_FILE          is not null and ',
'   :P3100_FILE_CHARSET  is null and',
'   substr( lower ( :P3100_FILE ), -4 ) in ( ''.txt'', ''.csv'', ''.tsv'' ) ',
'then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2825983102927215)
,p_computation_sequence=>10
,p_computation_item=>'P3100_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P3100_TABLE_NAME)'
,p_compute_when=>'P3100_LOAD_TO'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2826085522927216)
,p_computation_sequence=>20
,p_computation_item=>'P3100_ERROR_TABLE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_loader_dev.get_error_table_name(',
'    p_table_owner => :P3100_TABLE_OWNER,',
'    p_table_name  => (',
'                     case when :P3100_LOAD_TO = ''NEW'' then',
'                         :P3100_TABLE_NAME',
'                     when :P3100_LOAD_TO = ''EXISTING'' then',
'                         :P3100_EXISTING_TABLE',
'                     end) );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4264646118082530)
,p_computation_sequence=>30
,p_computation_item=>'P3100_FIRST_LINE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'HEADERS'
,p_compute_when=>'UPLOAD_FILE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(55560538278883047)
,p_computation_sequence=>40
,p_computation_item=>'P3100_CSV_ENCLOSED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'"'
,p_compute_when=>'UPLOAD_FILE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2826480966927220)
,p_validation_name=>'table name not null'
,p_validation_sequence=>10
,p_validation=>'P3100_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1620874202834608)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2883179759304436)
,p_validation_name=>'table name not > 30 (11g) or > 128 (12.2)'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if length(:P3100_TABLE_NAME) > wwv_flow_global.c_dbms_id_length then',
'  return wwv_flow_lang.system_message(''F4300.TABLE_NAMES_NOT_LONGER_THAN_30'',wwv_flow_global.c_dbms_id_length);',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1620874202834608)
,p_associated_item=>wwv_flow_imp.id(2878249657221664)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2883434847305509)
,p_validation_name=>'cannot have same table name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from sys.dba_tables',
'where table_name = :P3100_TABLE_NAME',
'and owner = :P3100_TABLE_OWNER;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# already exists.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1620874202834608)
,p_associated_item=>wwv_flow_imp.id(2878249657221664)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2883783996306921)
,p_validation_name=>'table name is reserved word'
,p_validation_sequence=>50
,p_validation=>'return not wwv_flow_f4500_ob_wiz_dev.is_database_reserved_word( p_word => :P3100_TABLE_NAME );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The identified #LABEL# is an Oracle reserved word.  Please choose another name.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1620874202834608)
,p_associated_item=>wwv_flow_imp.id(2878249657221664)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2829413078927250)
,p_validation_name=>'cannot load until other jobs finish'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_running_job_cnt number;',
'begin',
'',
'    select count(*) into l_running_job_cnt',
'     from user_scheduler_jobs j, wwv_flow_companies c',
'    where job_name like ''ORACLE_APEX_DTLD$%''',
'      --',
'      and c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'      and c.display_name = :COMPANY  ',
'      -- ',
'      and state   = ''RUNNING''',
'      and rownum <= ( wwv_flow_data_loader.c_max_jobs_per_apex_session + 1 ) ;',
'    ',
'    if l_running_job_cnt >= wwv_flow_data_loader.c_max_jobs_per_apex_session then',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'There are other jobs still running to load data.  Please wait until those jobs finish.'
,p_when_button_pressed=>wwv_flow_imp.id(1620874202834608)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(74472471070949601)
,p_validation_name=>'uploaded file is too large'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_size         number;',
'    l_overall_file_size number := wwv_flow_platform.get_preference(''DATA_LOADING_MAX_FILE_SIZE'');',
'begin',
'    begin',
'        select sys.dbms_lob.getlength( blob_content )',
'          into l_file_size',
'          from wwv_flow_temp_files',
'         where name = :P3100_FILE;',
'    exception ',
'        when NO_DATA_FOUND then',
'            return null;',
'        when TOO_MANY_ROWS then',
'            return null;',
'    end;',
'    ',
'    -- overall file size limit, configured in instance settings',
'    if l_overall_file_size is not null and l_file_size > l_overall_file_size then',
'        :P3100_FILE := null;',
'        return wwv_flow_lang.system_message( p_name => ''WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'',',
'                                             p0     => '''',',
'                                             p1     => round( l_overall_file_size / 1048576 ) );    ',
'    end if;',
'    ',
'    -- specific file size limits',
'    if :P3100_FILE like ''%xml'' then',
'        if l_file_size > 104857600 then',
'            :P3100_FILE := null;',
'            return wwv_flow_lang.system_message( p_name => ''WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'',',
'                                                 p0     => ''XML'',',
'                                                 p1     => ''100'');',
'        end if;',
'    elsif :P3100_FILE like ''%xlsx'' then',
'        if l_file_size > 52428800 then',
'            :P3100_FILE := null;',
'            return wwv_flow_lang.system_message( p_name => ''WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'',',
'                                                 p0     => ''XLSX'',',
'                                                 p1     => ''50'' );',
'        end if;',
'    end if;',
'    ',
'    return null;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'UPLOAD_FILE'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'this safeguards against uploading too large XML and XLSX files. Both are processed by database XML functions which consume too much PGA memory for large files.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(218529884504706530)
,p_validation_name=>'Table names must not contain invalid chars'
,p_validation_sequence=>120
,p_validation=>'P3100_TABLE_NAME'
,p_validation2=>'#&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'#LABEL# must not contain #,  &, <, >, ", /, ;, *, |, =, % or , character.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1620874202834608)
,p_associated_item=>wwv_flow_imp.id(2878249657221664)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(52178774929071242)
,p_validation_name=>'existing table not null'
,p_validation_sequence=>140
,p_validation=>'P3100_EXISTING_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1620874202834608)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(82703473624738107)
,p_validation_name=>'column mapping missing'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_MAPPED_COLUMN_COUNT = 0 then',
'    return false;',
'else',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Column mapping is missing. Please map the columns to existing table before loading the data.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1620874202834608)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(82704685257738119)
,p_validation_name=>'CLOB column must be mapped to CLOB'
,p_validation_sequence=>160
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_profile     wwv_flow_data_parser.t_file_profile;',
'    l_profile          clob;',
'begin',
'    select clob001 into l_profile ',
'    from wwv_flow_collections ',
'    where collection_name =''APEX$DATALOAD''',
'    and rownum = 1;',
'',
'    l_file_profile := wwv_flow_data_parser.json_to_profile( p_json => l_profile );',
'    ',
'    for i in 1 .. l_file_profile.file_columns.count',
'    loop',
'        -- if data contains CLOB column',
'        if l_file_profile.file_columns( i ).data_type = wwv_flow_exec_api.c_data_type_clob then',
'            -- get user configured mapping',
'            for l_configure in (',
'                select',
'                    c002   mapped_column',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                and c001 = l_file_profile.file_columns( i ).name )',
'            loop',
'                -- get mapped column data type',
'                -- if CLOB column not mapped to CLOB column, raise error',
'                for l_mapped_column in (',
'                    select data_type',
'                    from sys.dba_tab_columns',
'                    where owner = :P3100_TABLE_OWNER',
'                    and table_name = :P3100_EXISTING_TABLE',
'                    and column_name = l_configure.mapped_column )',
'                loop',
'                    if l_mapped_column.data_type != ''CLOB'' then',
'                       return false;',
'                    end if;',
'                end loop;',
'            end loop;',
'        end if;',
'    end loop;',
'',
'    -- if there are no user configured mapping and not clob column, pass the validation',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'CLOB column is mapped to incorrect column data type.  Please map the column to another CLOB column.'
,p_validation_condition=>'P3100_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1620874202834608)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1620651033834606)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1620594128834605)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1620722727834607)
,p_event_id=>wwv_flow_imp.id(1620651033834606)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1620980613834609)
,p_name=>'Upload File'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_FILE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(306772540166647203)
,p_event_id=>wwv_flow_imp.id(1620980613834609)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_DATA'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1621012524834610)
,p_event_id=>wwv_flow_imp.id(1620980613834609)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(".a-FileDrop").addClass("is-loading");'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1621303372834613)
,p_event_id=>wwv_flow_imp.id(1620980613834609)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_FILE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1624365974834643)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_FIRST_LINE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4212445483056009)
,p_event_id=>wwv_flow_imp.id(1624365974834643)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16453972019013402)
,p_name=>'Shade Headers on Load'
,p_event_sequence=>60
,p_condition_element=>'P3100_FIRST_LINE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEADERS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16454254932013405)
,p_event_id=>wwv_flow_imp.id(16453972019013402)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16454305473013406)
,p_event_id=>wwv_flow_imp.id(16453972019013402)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").removeClass("first-row-headers");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4093020088018704)
,p_name=>'Adjust display of UI items after page load'
,p_event_sequence=>90
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if :P3100_FILE is not null then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    if :P3100_DATA is not null then',
'        return true;',
'    end if;',
'end if;',
'return false;'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4093314800018707)
,p_event_id=>wwv_flow_imp.id(4093020088018704)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// replace column count placeholders in header text of parsed data preview region',
'$( "#placeholder_P3100_PARSED_COLUMN_COUNT" ).text( $v( "P3100_PARSED_COLUMN_COUNT" ) );',
'$( "#placeholder_P3100_PARSED_ROW_COUNT"    ).text( $v( "P3100_PARSED_ROW_COUNT"    ) );',
'',
'// set the column delimiter radio group to the actual value, which ',
'// is being determined *after* the item has been rendered, so the browser does not have the correct state.',
'$s( "P3100_CSV_COL_DELIMITER", $v("P3100_NEW_COL_DELIMITER") );',
'',
'// if the file has less than 10 columns: Adjust the header text and hide the "expand preview" button',
'// if ( parseInt( $v( "P3100_PARSED_COLUMN_COUNT" ) ) <= 10 ) {',
'//     $( "span#placeholder_gt10_columns" ).css( "display", "none" );',
'//     $( "#bt-full-preview"              ).css( "display", "none" );',
'// }',
'',
'// if the Invalid File Item is set (wrong extension, parser errors), hide the "Load into Table Region"',
'if ( $v( "P3100_FILE_INVALID" ) === "Y" ) {',
'    $( "#load-to-table"        ).css( "display", "none" );',
'    $( "#preview_table p.desc" ).css( "display", "none" );',
'   // $( "#settings"             ).css( "display", "none" );',
'    $( "#bt-full-preview"      ).css( "display", "none" );',
'}',
'',
'// shared functions',
'var getColId = function( id ){',
'    var int = parseInt( id ), i;',
'    if ( int <= 9 ) {',
'            i = ''COL00'' + int;',
'        } else if ( int > 9 && int <= 99 ) {',
'            i = ''COL0'' + int;',
'        } else {',
'            i = ''COL'' + int;',
'        }',
'    return i;',
'};',
'',
'var toggleCol = function ( columnId, isShowing ) {',
'    if ( columnId ) {',
'        var header$  = $( ''#'' + columnId ),',
'            body$    = $( ''td[headers='' + columnId + '']'' );',
'',
'        if ( isShowing ) {',
'            header$.show();',
'            body$.show();',
'        } else {',
'            header$.hide();',
'            body$.hide();',
'        }',
'    }',
'};',
'',
'// hide empty columns',
'( function () {',
'    var hideGreaterThan = parseInt( $v(''P3100_PARSED_COLUMN_COUNT'') ) + 1,',
'        emptyColId;',
'',
'        for ( i = hideGreaterThan; i <= 100; i++ ) {',
'            emptyColId = getColId( i );',
'            toggleCol( emptyColId, false );',
'        }',
'',
'})();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4093642896018710)
,p_name=>'Confirm "All Rows" for large files'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_MAX_ROW_COUNT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P3100_FILE_SIZE") >= 2097152 && $v("P3100_MAX_ROW_COUNT") === "0"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4094236591018716)
,p_event_id=>wwv_flow_imp.id(4093642896018710)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_PREV_MAX_ROW_COUNT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3100_MAX_ROW_COUNT")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4095047078018724)
,p_event_id=>wwv_flow_imp.id(4093642896018710)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_MAX_ROW_COUNT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3100_PREV_MAX_ROW_COUNT")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213315682056018)
,p_event_id=>wwv_flow_imp.id(4093642896018710)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4094907728018723)
,p_event_id=>wwv_flow_imp.id(4093642896018710)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Sampling all rows can take a while for larger files. Do you really want to sample the whole file?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4095223549018726)
,p_event_id=>wwv_flow_imp.id(4093642896018710)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_MAX_ROW_COUNT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4212566683056010)
,p_event_id=>wwv_flow_imp.id(4093642896018710)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4211875853056003)
,p_name=>'Shade Headers for XML, JSON and ICS'
,p_event_sequence=>110
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not ( lower(:P3100_FILE) like ''%.csv'' or',
'lower(:P3100_FILE) like ''%.txt'' or',
'lower(:P3100_FILE) like ''%.xls_'' )'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4211929751056004)
,p_event_id=>wwv_flow_imp.id(4211875853056003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4212677251056011)
,p_name=>'Refresh Preview'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_XLSX_SHEET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4212758492056012)
,p_event_id=>wwv_flow_imp.id(4212677251056011)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4212923062056014)
,p_name=>'Col Delimiter Changed'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_CSV_COL_DELIMITER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213071428056015)
,p_event_id=>wwv_flow_imp.id(4212923062056014)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4213181627056016)
,p_name=>'Enclosed Char Changed'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_CSV_ENCLOSED'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213217254056017)
,p_event_id=>wwv_flow_imp.id(4213181627056016)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4143243113584041)
,p_name=>'Charset changed: Refresh Preview'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_FILE_CHARSET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4143358730584042)
,p_event_id=>wwv_flow_imp.id(4143243113584041)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16455464300013417)
,p_name=>'Refresh after Preview Closes'
,p_event_sequence=>160
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4142265341584031)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3993097173355402)
,p_event_id=>wwv_flow_imp.id(16455464300013417)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.page.cancelWarnOnUnsavedChanges();',
'apex.widget.waitPopup();',
'window.location.reload();',
'//apex.navigation.redirect ( "f?p=&APP_ID.:&APP_PAGE_ID.:&APP_SESSION." );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3993618071355408)
,p_name=>'Show Configuration Saved Message'
,p_event_sequence=>170
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P3100_SHOW_CONFIG_SAVED'
,p_display_when_cond2=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3994194095355413)
,p_event_id=>wwv_flow_imp.id(3993618071355408)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_SHOW_CONFIG_SAVED'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3993702069355409)
,p_event_id=>wwv_flow_imp.id(3993618071355408)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess( apex.lang.getMessage(''DATA.LOAD.CONFIGURATION_SAVED'') );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(118040198043597549)
,p_name=>'Toggle Upload file or Copy and paste'
,p_event_sequence=>180
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_SOURCE_TYPE'
,p_condition_element=>'P3100_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(118040233834597550)
,p_event_id=>wwv_flow_imp.id(118040198043597549)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1620249167834602)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(212734214591785603)
,p_event_id=>wwv_flow_imp.id(118040198043597549)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1620249167834602)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(212734019025785601)
,p_event_id=>wwv_flow_imp.id(118040198043597549)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(118040030879597548)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(212734123228785602)
,p_event_id=>wwv_flow_imp.id(118040198043597549)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(118040030879597548)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(185533117272749149)
,p_event_id=>wwv_flow_imp.id(118040198043597549)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1620435155834604)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(185533211262749150)
,p_event_id=>wwv_flow_imp.id(118040198043597549)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1620435155834604)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(217950443854386701)
,p_event_id=>wwv_flow_imp.id(118040198043597549)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Trigger Window Resize',
'$(window).trigger("apexwindowresized");'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(207423119915369628)
,p_name=>'Show File or Copy Paste'
,p_event_sequence=>190
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P3100_SOURCE_TYPE'
,p_display_when_cond2=>'FILE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(207423255527369629)
,p_event_id=>wwv_flow_imp.id(207423119915369628)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1620249167834602)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(207423435392369631)
,p_event_id=>wwv_flow_imp.id(207423119915369628)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(118040030879597548)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(212736112486785622)
,p_name=>'Get Sample'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_LOAD_SAMPLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(212736253657785623)
,p_event_id=>wwv_flow_imp.id(212736112486785622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.server.process(',
'    "get_sample_csv", {',
'        pageItems: [''P3100_LOAD_SAMPLE'']',
'    }, {',
'        dataType: "text",',
'        loadingIndicator: ''P3100_DATA'',',
'        loadingIndicatorPosition: "centered",',
'        success: function(pData) {',
'            $(''#P3100_DATA'').val(pData);',
'        }',
'    }',
');'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(52174810176071203)
,p_name=>'On Preview click save PK setting'
,p_event_sequence=>210
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4142265341584031)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52174945017071204)
,p_event_id=>wwv_flow_imp.id(52174810176071203)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3100_FORCE_SYSGUID_ID,P3100_TABLE_OWNER'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(465287104958492826)
,p_name=>'set load to in session state'
,p_event_sequence=>215
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_LOAD_TO'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(465287223385492827)
,p_event_id=>wwv_flow_imp.id(465287104958492826)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- reset column configuration collection ',
'-- as the collection saves:',
'--     select columns info, if new table',
'--     column mapping, if existing table',
'wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
''))
,p_attribute_02=>'P3100_LOAD_TO'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82703849943738111)
,p_event_id=>wwv_flow_imp.id(465287104958492826)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1621706117834617)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82704384858738116)
,p_event_id=>wwv_flow_imp.id(465287104958492826)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(82702857605738101)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(52175777779071212)
,p_name=>'show hide new and existing'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_LOAD_TO'
,p_condition_element=>'P3100_LOAD_TO'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52178935302071244)
,p_event_id=>wwv_flow_imp.id(52175777779071212)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_TABLE_NAME,P3100_FORCE_SYSGUID_ID,P3100_USE_DATA_TYPES'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52177623415071231)
,p_event_id=>wwv_flow_imp.id(52175777779071212)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_TABLE_NAME,P3100_FORCE_SYSGUID_ID,P3100_USE_DATA_TYPES'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52179130531071246)
,p_event_id=>wwv_flow_imp.id(52175777779071212)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_EXISTING_TABLE,P3100_UPDATE_METHOD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52177847149071233)
,p_event_id=>wwv_flow_imp.id(52175777779071212)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_EXISTING_TABLE,P3100_UPDATE_METHOD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(69708079265469901)
,p_event_id=>wwv_flow_imp.id(52175777779071212)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_EXISTING_TABLE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52178602083071241)
,p_event_id=>wwv_flow_imp.id(52175777779071212)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_TABLE_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(69710307005469924)
,p_name=>'display configure region'
,p_event_sequence=>230
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_TABLE_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P3100_LOAD_TO").getValue() === "NEW" && apex.item("P3100_TABLE_NAME").getValue() != ""'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(363474706432315405)
,p_event_id=>wwv_flow_imp.id(69710307005469924)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3100_TABLE_NAME'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52038419075715340)
,p_event_id=>wwv_flow_imp.id(69710307005469924)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(82702857605738101)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82704174426738114)
,p_event_id=>wwv_flow_imp.id(69710307005469924)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(82702857605738101)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(69710691103469927)
,p_name=>'auto-map cols and display configure'
,p_event_sequence=>240
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_EXISTING_TABLE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P3100_LOAD_TO").getValue() === "EXISTING" && apex.item("P3100_EXISTING_TABLE").getValue() != ""'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(554413800972229304)
,p_event_id=>wwv_flow_imp.id(69710691103469927)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- clear column mapping configuration as existing table changed',
'wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );'))
,p_attribute_05=>'PLSQL'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(465286152048492816)
,p_event_id=>wwv_flow_imp.id(69710691103469927)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile             clob;',
'    l_file_profile        wwv_flow_data_parser.t_file_profile;',
'    l_column_name_changed boolean := false;',
'    l_column_map          wwv_flow_global.vc_map := wwv_flow_global.c_empty_vc_map;',
'begin',
'    select clob001 into l_profile ',
'    from wwv_flow_collections ',
'    where collection_name =''APEX$DATALOAD''',
'    and rownum = 1;',
'',
'    l_file_profile := wwv_flow_data_parser.json_to_profile( p_json => l_profile );',
'    if :P3100_FIRST_LINE is null or :P3100_FIRST_LINE != ''HEADERS'' then',
'        for i in 1 .. l_file_profile.file_columns.count loop',
'            l_file_profile.file_columns( i ).name := ''COL'' || lpad( i,3,''0'');',
'        end loop;',
'        l_profile := wwv_flow_data_parser.profile_to_json( l_file_profile );',
'        ',
'        l_column_name_changed := true;',
'        ',
'        -- see if configure columns are same, if not column names changed',
'        for i in 1 .. l_file_profile.file_columns.count',
'        loop',
'            for l_configure in (',
'                select',
'                    c001   column_name,',
'                    c002   mapped_column',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                and c001 = l_file_profile.file_columns( i ).name )',
'            loop    ',
'                l_column_name_changed := false;',
'                exit;',
'            end loop;',
'        end loop;',
'    end if;',
'    ',
'    -- save changed file profile for later use',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'    wwv_flow_collection.add_member( ''APEX$DATALOAD'', p_clob001 => l_profile );',
'    ',
'    if l_column_name_changed then',
'        -- clear column mapping configuration as column names changed',
'        wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    end if;',
'    ',
'    -- auto discover column mapping or get mapping user configured',
'    if :P3100_LOAD_TO = ''EXISTING'' then',
'        -- get column mapping user configured',
'        for l_configure in (',
'            select',
'                c001   column_name,',
'                c002   mapped_column',
'            from wwv_flow_collections',
'            where collection_name = ''APEX$DATALOAD_COLUMNS''',
'            and c002 is not null )',
'        loop',
'            l_column_map( l_configure.column_name ) := l_configure.mapped_column;',
'        end loop;',
'        ',
'        if l_column_map.count = 0 then',
'            -- get column mapping with existing table',
'            for i in 1 .. l_file_profile.file_columns.count',
'            loop',
'                for l_existing_table in (',
'                    select column_name',
'                    from sys.dba_tab_columns',
'                    where owner = :P3100_TABLE_OWNER',
'                    and table_name = :P3100_EXISTING_TABLE',
'                    and column_name = l_file_profile.file_columns( i ).name )',
'                loop',
'                    l_column_map( l_file_profile.file_columns( i ).name ) := l_existing_table.column_name;',
'                    -- add APEX$DATALOAD_COLUMNS collection as it is not populated yet',
'                    wwv_flow_collection.add_member(',
'                        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'                        p_c001 => l_existing_table.column_name,                 -- column name',
'                        p_c002 => l_existing_table.column_name,                 -- mapped column',
'                        p_c003 => l_file_profile.file_columns( i ).format_mask, -- format mask',
'                        p_c004 => l_file_profile.file_columns( i ).group_char,  -- group char',
'                        p_c005 => l_file_profile.file_columns( i ).decimal_char -- decimal char    ',
'                        );',
'                end loop;',
'            end loop;',
'        end if;',
'    end if;',
'    -- need to compute here for configure region display',
'    :P3100_FILE_COLUMN_COUNT   := l_file_profile.file_columns.count;',
'    :P3100_MAPPED_COLUMN_COUNT := l_column_map.count;',
'end;'))
,p_attribute_02=>'P3100_FIRST_LINE,P3100_TABLE_OWNER,P3100_EXISTING_TABLE'
,p_attribute_03=>'P3100_MAPPED_COLUMN_COUNT,P3100_FILE_COLUMN_COUNT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82703082744738103)
,p_event_id=>wwv_flow_imp.id(69710691103469927)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(82702857605738101)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82703247866738105)
,p_event_id=>wwv_flow_imp.id(69710691103469927)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(82702857605738101)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82692780879962406)
,p_event_id=>wwv_flow_imp.id(69710691103469927)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1621706117834617)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(82692565955962404)
,p_name=>'Refresh after Map Col Closes'
,p_event_sequence=>260
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(69708360594469904)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82692671323962405)
,p_event_id=>wwv_flow_imp.id(82692565955962404)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.page.cancelWarnOnUnsavedChanges();',
'apex.widget.waitPopup();',
'window.location.reload();',
'//apex.navigation.redirect ( "f?p=&APP_ID.:&APP_PAGE_ID.:&APP_SESSION." );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(82703933486738112)
,p_name=>'warn replace'
,p_event_sequence=>270
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_UPDATE_METHOD'
,p_condition_element=>'P3100_UPDATE_METHOD'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPLACE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(82704040481738113)
,p_event_id=>wwv_flow_imp.id(82703933486738112)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Entire existing data in the table will be deleted first before loading.  If load fails, you can recover deleted data by flashing back the table.  Do you really want to replace the data in this table?'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(363475286580315410)
,p_name=>'set update mothod'
,p_event_sequence=>280
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_UPDATE_METHOD'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(363475339955315411)
,p_event_id=>wwv_flow_imp.id(363475286580315410)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3100_UPDATE_METHOD'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(363475493214315412)
,p_name=>'set force SYSGUID'
,p_event_sequence=>290
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3100_FORCE_SYSGUID_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(363475549299315413)
,p_event_id=>wwv_flow_imp.id(363475493214315412)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3100_FORCE_SYSGUID_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3452940940395904)
,p_name=>'Stop Processing for unsupported files'
,p_event_sequence=>300
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P3100_FILE_INVALID") === "Y" || $v("P3100_FILE_COLUMN_COUNT") === "" || $v("P3100_FILE_COLUMN_COUNT") === "0"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P3100_SOURCE_TYPE = ''FILE'' and :P3100_FILE_NAME is not null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3453002460395905)
,p_event_id=>wwv_flow_imp.id(3452940940395904)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3100_LOAD_TO,P3100_TABLE_NAME,P3100_EXISTING_TABLE,P3100_XLSX_SHEET,P3100_FORCE_SYSGUID_ID,P3100_USE_DATA_TYPES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3453354013395908)
,p_event_id=>wwv_flow_imp.id(3452940940395904)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1621706117834617)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3453722334395912)
,p_event_id=>wwv_flow_imp.id(3452940940395904)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(16455974874013422)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3453627172395911)
,p_event_id=>wwv_flow_imp.id(3452940940395904)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3453574897395910)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2827481640927230)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Click Previous to Clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'3100,3110,3120'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1698876190214119)
,p_internal_uid=>2827481640927230
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(212735502054785616)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy and paste load change clob to blob'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_seq_id number;',
'    l_clob   clob;',
'begin',
'    select seq_id, ',
'           clob001',
'      into l_seq_id, ',
'           l_clob',
'      from wwv_flow_collections',
'     where collection_name = ''CLOB_CONTENT'';',
'    ',
'    wwv_flow_collection.update_member(',
'        p_collection_name => ''CLOB_CONTENT'',',
'        p_seq             => l_seq_id,',
'        p_clob001         => l_clob,',
'        p_blob001         => wwv_flow_utilities.clob_to_blob( p_clob => l_clob ) );',
'end;         ',
'            ',
'    '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'NEXT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>212735502054785616
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3511555467397550)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load to New Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy_message varchar2(32767);',
'begin',
'    wwv_flow_data_loader_dev.load_to_new_table(',
'        p_source_type       => :P3100_SOURCE_TYPE,',
'        p_file_name         => :P3100_FILE,',
'        --',
'        p_target_schema     => :P3100_TABLE_OWNER,',
'        p_target_name       => :P3100_TABLE_NAME,',
'        p_error_table_name  => :P3100_ERROR_TABLE,',
'        --',
'        p_add_id_column     => true,',
'        p_force_sysguid_id  => :P3100_FORCE_SYSGUID_ID = ''Y'',',
'        p_skip_rows         => ( case when :P3100_FIRST_LINE     = ''HEADERS'' and :P3100_FILE_TYPE in ( ''1'', ''2'' ) then 1    else 0     end ),',
'        p_use_column_names  => ( case when :P3100_FIRST_LINE     = ''HEADERS''                                      then true else false end ),',
'        p_use_data_types    => ( case when :P3100_USE_DATA_TYPES = ''Y''                                            then true else false end ),',
'        -- ',
'        p_load_id           => :P3100_LOAD_ID,',
'        p_message           => l_dummy_message );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1620874202834608)
,p_process_when=>'P3100_LOAD_TO'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NEW'
,p_internal_uid=>3511555467397550
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(71166758312651836)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load to Existing Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy_message varchar2(32767);',
'begin',
'    wwv_flow_data_loader_dev.load_to_existing_table(',
'        p_source_type         => :P3100_SOURCE_TYPE,',
'        --',
'        p_file_name           => :P3100_FILE,',
'        --',
'        p_target_schema       => :P3100_TABLE_OWNER,',
'        p_target_name         => :P3100_EXISTING_TABLE,',
'        p_error_table_name    => :P3100_ERROR_TABLE,',
'        --',
'        p_skip_rows           => ( case when :P3100_FIRST_LINE = ''HEADERS'' and :P3100_FILE_TYPE in ( ''1'', ''2'' ) then 1 else 0 end ),',
'        p_truncate_rows       => ( :P3100_UPDATE_METHOD = ''REPLACE'' ),',
'        --',
'        p_load_id             => :P3100_LOAD_ID,',
'        p_message             => l_dummy_message );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1620874202834608)
,p_process_when=>'P3100_LOAD_TO'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'EXISTING'
,p_internal_uid=>71166758312651836
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1624133201834641)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get File Info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile_record wwv_flow_data_parser.t_file_profile;',
'begin',
'    if not :P3100_FILE like ''[Downloaded_File]%'' then',
'        -- get the file name',
'        select filename, sys.dbms_lob.getlength( blob_content) as file_size',
'        into :P3100_FILE_NAME, :P3100_FILE_SIZE',
'        from wwv_flow_temp_files ',
'        where name = :P3100_FILE;',
'    else',
'        :P3100_FILE_NAME := :P3100_FILE;',
'    end if;',
'    ',
'    if :P3100_SOURCE_TYPE is null then',
'        wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD_COLUMNS'' );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1624133201834641
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3994483430355416)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Body Class'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_FILE is null and :P3100_DATA is null then',
'  :P3100_BODY_CLASS := ''is-first-step'';',
'else',
'  :P3100_BODY_CLASS := '''';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3994483430355416
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(212736324940785624)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get_sample_csv'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  sys.owa_util.mime_header(''text/plain'', true );',
'  if :P3100_LOAD_SAMPLE = ''DEPT_EMP'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_emp_data);',
'  elsif :P3100_LOAD_SAMPLE = ''PROJECTS'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_project_data);',
'  elsif :P3100_LOAD_SAMPLE = ''SPEED'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_vehical_speed_data);',
'  elsif :P3100_LOAD_SAMPLE = ''SALES'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_sales_data);',
'  elsif :P3100_LOAD_SAMPLE = ''WORLD'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_country_population_data);',
'  elsif :P3100_LOAD_SAMPLE = ''ACADEMIC'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_ACADEMIC_data);',
'  elsif :P3100_LOAD_SAMPLE = ''JSON_TEST'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_json_test_data);',
'  elsif :P3100_LOAD_SAMPLE = ''JSON'' then',
'      sys.htp.prn(wwv_flow_define_app_v3.get_json_only_data);',
'  --elsif :P3100_LOAD_SAMPLE = ''TENNIS'' then',
'  --    sys.htp.prn(wwv_flow_define_app_v3.get_tennis_data);',
'  --elsif :P3100_LOAD_SAMPLE = ''WORLDCUP'' then',
'  --    sys.htp.prn(wwv_flow_define_app_v3.get_worldcup_data);',
'  --    wwv_htp.print_clob(wwv_flow_define_app_v3.get_worldcup_data);',
'  --elsif :P3100_LOAD_SAMPLE = ''F1'' then',
'  --    sys.htp.prn(wwv_flow_define_app_v3.get_f1_data);',
'  --elsif :P3100_LOAD_SAMPLE = ''MOVIE'' then',
'  --    sys.htp.prn(wwv_flow_define_app_v3.get_movie_data);',
'  end if;',
'  :P3100_FIRST_LINE := ''HEADERS'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>212736324940785624
);
end;
/
prompt --application/pages/page_03110
begin
wwv_flow_imp_page.create_page(
 p_id=>3110
,p_name=>'Load Data'
,p_alias=>'LOAD-DATA4'
,p_page_mode=>'MODAL'
,p_step_title=>'Load Data'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Region-headerItems--buttons { white-space: nowrap; }',
'.a-Region-bodyHeader { padding: 12px; margin: 0; border-bottom: 1px solid rgba(0, 0, 0,0.1); background-color: #FFF8E1; color: #202020; }',
''))
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_dialog_height=>'800'
,p_dialog_width=>'960'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1595347007342836)
,p_name=>'Load in Progress'
,p_region_name=>'loadInProgress'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 as status,',
'       n001 as rows_processed ',
'from wwv_flow_collections ',
'where collection_name=''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(385896719135645040)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1595498912342837)
,p_query_column_id=>1
,p_column_alias=>'STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(3891423527523942)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1595552243342838)
,p_query_column_id=>2
,p_column_alias=>'ROWS_PROCESSED'
,p_column_display_sequence=>2
,p_column_heading=>'Rows Processed'
,p_use_as_row_header=>'N'
,p_column_format=>'9G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4212017881056005)
,p_plug_name=>'Load Failed'
,p_region_name=>'loadIncomplete'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>50
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Data loading failed intermittently and is incomplete.',
'<pre id="imcompl_load_error"></pre>',
'Please check the error and try again. <br/>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(465285456657492809)
,p_plug_name=>'New Table'
,p_parent_plug_id=>wwv_flow_imp.id(4212017881056005)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Table <code>&P3100_TABLE_NAME!HTML.</code> created! <b id="incompl_success_row_count"></b> rows loaded successfully. <b class="u-danger-text" id="incompl_fail_row_count"></b> rows rejected.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(465285530738492810)
,p_plug_name=>'Existing Table'
,p_parent_plug_id=>wwv_flow_imp.id(4212017881056005)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_INCOMPLETE'', wwv_flow_escape.html(:P3100_EXISTING_TABLE) ) );',
'elsif :P3100_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_INCOMPLETE'',  wwv_flow_escape.html(:P3100_EXISTING_TABLE) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5339195701073204)
,p_plug_name=>'Success with Warning'
,p_region_name=>'loadError'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(465285017247492805)
,p_plug_name=>'New Table'
,p_parent_plug_id=>wwv_flow_imp.id(5339195701073204)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Table <code>&P3100_TABLE_NAME!HTML.</code> created! <b id="err_success_row_count"></b> rows loaded successfully. <b class="u-danger-text" id="err_fail_row_count"></b> rows rejected.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(465285131035492806)
,p_plug_name=>'Existing Table'
,p_parent_plug_id=>wwv_flow_imp.id(5339195701073204)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_WARNING'', wwv_flow_escape.html(:P3100_EXISTING_TABLE) ) );',
'elsif :P3100_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_WARNING'', wwv_flow_escape.html( :P3100_EXISTING_TABLE) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5339468330073206)
,p_plug_name=>'Load Failed'
,p_region_name=>'loadFail'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>40
,p_plug_source=>'The data could not be loaded.  Please check the error and try again.  <b id="fail_row_count"></b> rows failed.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5339553222073207)
,p_plug_name=>'Data Load Success'
,p_region_name=>'loadSuccess'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(465285279958492807)
,p_plug_name=>'New Table'
,p_parent_plug_id=>wwv_flow_imp.id(5339553222073207)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Table <code>&P3100_TABLE_NAME!HTML.</code> created with <b id="success_row_count"></b> rows!'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(465285312911492808)
,p_plug_name=>'Existing Table'
,p_parent_plug_id=>wwv_flow_imp.id(5339553222073207)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_SUCCESS'', wwv_flow_escape.html(:P3100_EXISTING_TABLE) ) );',
'elsif :P3100_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_SUCCESS'', wwv_flow_escape.html( :P3100_EXISTING_TABLE) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5339609838073208)
,p_name=>'Rejected Rows in &P3100_ERROR_TABLE!HTML. Table'
,p_region_name=>'failed_rows'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch:a-Report--rowHighlight'
,p_region_attributes=>'style="display: none;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q              varchar2(32767);',
'    l_column_name  varchar2(255);',
'    l_columns      varchar2(32767);',
'    l_profile_json clob;',
'    l_file_profile wwv_flow_data_parser.t_file_profile;',
'begin',
'    ',
'    select clob001 ',
'    into l_profile_json',
'    from wwv_flow_collections',
'    where collection_name = ''APEX$DATALOAD''',
'    and rownum = 1;',
'',
'    -- query upto 10 columns not including CLOB',
'    for l_file in ( ',
'        select column_position, column_name, data_type ',
'        from table( wwv_flow_data_parser.get_columns(l_profile_json ) )',
'        where rownum <= 10',
'        and data_type != ''CLOB'' )',
'    loop',
'        l_column_name := null;',
'',
'        if :P3100_LOAD_TO = ''EXISTING'' then',
'            for l_existing_table in (',
'                select column_name',
'                from sys.dba_tab_columns',
'                where owner = :P3100_TABLE_OWNER',
'                and table_name = :P3100_EXISTING_TABLE',
'                and column_name = l_file.column_name )',
'            loop',
'                l_column_name := l_existing_table.column_name;',
'            end loop;',
'            -- if column header not used, columns such as c001 mapped to existing column',
'            if l_column_name is null then',
'                for l_configure in (',
'                    select',
'                        c002 mapped_column',
'                    from wwv_flow_collections',
'                    where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                    and c002 is not null',
'                    and c001 = l_file.column_name )',
'                loop',
'                    l_column_name := l_configure.mapped_column;',
'                end loop;',
'            end if;',
'        else',
'            -- validate file columns against newly created table',
'            -- get only the ones created',
'            for l_table in (',
'                select column_name',
'                from sys.dba_tab_columns',
'                where owner = :P3100_TABLE_OWNER',
'                and table_name = :P3100_TABLE_NAME',
'                and column_name = l_file.column_name )',
'            loop',
'                l_column_name := l_table.column_name;',
'            end loop;',
'        end if;',
'',
'        if l_column_name is not null then',
'            l_columns := l_columns ||case when l_columns is not null then '','' end || l_column_name;',
'        end if;',
'    end loop;',
'   ',
'    q := ''select ORA_ERR_MESG$ as error_message''|| ',
'         (case when l_columns is not null then '',''|| l_columns end ) ||',
'         '' from ''||wwv_flow_assert.enquote_name( :P3100_ERROR_TABLE );',
'',
'    return q;',
'end;'))
,p_header=>'All rejected rows are stored in the &P3100_ERROR_TABLE!HTML. table. The report below shows the first 10 rows.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_plug_query_max_columns=>11
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>10
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
,p_plug_query_parse_override=>'P3100_TABLE_OWNER'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3520374672543756)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3520702531543767)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3521151693543767)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3521588214543767)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3521949833543767)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3522354084543767)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3522740524543768)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3523119062543768)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3523578712543768)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3523909078543768)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3524395492543769)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5341141690073223)
,p_plug_name=>'Load Finished'
,p_region_name=>'load_finished'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8889803744889085)
,p_plug_name=>'Table Information'
,p_region_name=>'table_info'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="timer-container"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8890101023889088)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3527300320543833)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8890101023889088)
,p_button_name=>'CANCEL'
,p_button_static_id=>'btn_cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3528572823543840)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8890101023889088)
,p_button_name=>'VIEW_TABLE'
,p_button_static_id=>'viewTableBtn'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'View Table'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:RP,2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:&P3100_TABLE_OWNER.,&P3110_TAB_OBJ_ID.'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3527705431543838)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(8890101023889088)
,p_button_name=>'CREATE_APP'
,p_button_static_id=>'createAppBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_imp.id(12506407035221692)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(207424077958369637)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5339609838073208)
,p_button_name=>'DROP_TABLE'
,p_button_static_id=>'dropTableBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Drop Table and Reload'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'style="display: none;"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(306772383679647201)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5339609838073208)
,p_button_name=>'VIEW_ERROR_TABLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Open in Object Browser'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:RP,2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:&P3100_TABLE_OWNER.,&P3110_TAB_OBJ_ID.'
,p_icon_css_classes=>'icon-open-in-dialog'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3528172063543840)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8890101023889088)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'btn_previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193042467413621230)
,p_branch_name=>'Go To Create App Wizard'
,p_branch_action=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:1,5,130,150,170,250:P1_SCHEMA,P1_NEW_TABLE_NAME:&P3100_TABLE_OWNER.,&P3100_TABLE_NAME.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GOTO_CREATE_APP'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(207424900170369646)
,p_branch_name=>'Go To Page 3100'
,p_branch_action=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:RP,3100,3110,3120::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(207424077958369637)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3517225315543731)
,p_name=>'P3110_LOAD_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1595347007342836)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3517623849543739)
,p_name=>'P3110_PROCESSED_ROW_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1595347007342836)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3518350628543743)
,p_name=>'P3110_GOOD_ROW_CNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5341141690073223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3518712757543743)
,p_name=>'P3110_BAD_ROW_CNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(5341141690073223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3525288239543813)
,p_name=>'P3110_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8889803744889085)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Owner'
,p_source=>'P3100_TABLE_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3526169869543831)
,p_name=>'P3110_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8889803744889085)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3942228815766702)
,p_name=>'P3110_TABLE_CREATED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5341141690073223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3942711680766707)
,p_name=>'P3110_TAB_OBJ_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5341141690073223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4212146369056006)
,p_name=>'P3110_LOAD_ERROR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1595347007342836)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(69708154742469902)
,p_name=>'P3110_LOAD_TO'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5341141690073223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(207424749954369644)
,p_name=>'P3110_ERR_TAB_OBJ_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5341141690073223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(579566414994721532)
,p_name=>'P3110_GOOD_ROW_CNT_DISP'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(5341141690073223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(579566572187721533)
,p_name=>'P3110_BAD_ROW_CNT_DISP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(5341141690073223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(579566655822721534)
,p_name=>'P3110_PROCESSED_ROW_CNT_DISP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1595347007342836)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(465284904596492804)
,p_computation_sequence=>10
,p_computation_item=>'P3110_TABLE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_LOAD_TO = ''NEW'' then',
'    return :P3100_TABLE_NAME;',
'elsif :P3100_LOAD_TO = ''EXISTING'' then',
'    return :P3100_EXISTING_TABLE;',
'end if;'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3531982674543848)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3527300320543833)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3532493223543849)
,p_event_id=>wwv_flow_imp.id(3531982674543848)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3530158368543845)
,p_name=>'Timer for Refresh Progress'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3530667815543847)
,p_event_id=>wwv_flow_imp.id(3530158368543845)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSpinner$ = apex.util.showSpinner( $( "#loadInProgress" ) );',
'',
'var showFinished = function(){',
'    // Hide Table Information',
'    apex.region("table_info").element.hide();',
'',
'    var lLoadTo = apex.item("P3110_LOAD_TO").getValue();',
'    var lTableCreated = apex.item( "P3110_TABLE_CREATED" ).getValue();',
'    var lBadRowCnt = apex.item( "P3110_BAD_ROW_CNT" ).getValue();',
'    var lSuccessRowCnt = apex.item("P3110_GOOD_ROW_CNT").getValue();',
'    var lProcessedRowCnt = apex.item( "P3110_PROCESSED_ROW_CNT" ).getValue();',
'    ',
'    var lBadRowCntDisp = apex.item( "P3110_BAD_ROW_CNT_DISP" ).getValue();',
'    var lSuccessRowCntDisp = apex.item("P3110_GOOD_ROW_CNT_DISP").getValue();',
'    var lProcessedRowCntDisp = apex.item( "P3110_PROCESSED_ROW_CNT_DISP" ).getValue();',
'    ',
'    if (lLoadTo === "NEW") {',
'        if (lTableCreated === "Y") {',
'            apex.jQuery("#viewTableBtn").show();',
'            apex.jQuery("#btn_cancel").hide();',
'        }',
'    } else if (lLoadTo === "EXISTING") {',
'        apex.jQuery("#viewTableBtn").show();',
'    }',
'    ',
'    if ( apex.item("P3110_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'        // show failure region',
'',
'        apex.jQuery("#incompl_success_row_count").text( lSuccessRowCntDisp );',
'        apex.jQuery("#incompl_fail_row_count").text( lBadRowCntDisp );',
'        apex.jQuery("#imcompl_load_error").text( apex.item( "P3110_LOAD_ERROR" ).getValue() );        ',
'        apex.region("loadIncomplete").element.show();',
'        if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'        if (lBadRowCnt > "0") {',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'        }',
'    } else {',
'        ',
'        if ( lBadRowCnt === "0" ) {',
'            // show success region',
'            apex.jQuery("#success_row_count").text( lSuccessRowCntDisp );',
'            apex.region("loadSuccess").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            apex.jQuery("#btn_previous").hide();',
'        } else if ( lSuccessRowCnt > "0" && lBadRowCnt > "0" ) {',
'            // show error region',
'            apex.jQuery("#err_success_row_count").text( lSuccessRowCntDisp );',
'            apex.jQuery("#err_fail_row_count").text( lBadRowCntDisp );',
'            apex.region("loadError").element.show();',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'',
'        } else if ( lBadRowCnt === lProcessedRowCnt ) {',
'            // show failure region',
'            apex.jQuery("#fail_row_count").text( lBadRowCntDisp );',
'            apex.region("loadFail").element.show();',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'            if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'        }',
'    }',
' };',
'',
'var triggerRefresh = function(){ ',
'    apex.event.trigger( apex.jQuery("#timer-container"), "job_timer" );',
'',
'    if ( apex.item("P3110_LOAD_STATUS").getValue() === ''FINISHED''  || ',
'         apex.item("P3110_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'      clearInterval( refreshInterval );',
'      apex.region("loadInProgress").element.hide();',
'      lSpinner$.remove();',
'      showFinished();',
'    }',
'};',
'',
'var refreshInterval = setInterval( triggerRefresh, 1000);'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3531075388543848)
,p_name=>'Refresh Progress Report on Timer'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#timer-container'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'job_timer'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1595200264342835)
,p_event_id=>wwv_flow_imp.id(3531075388543848)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1595347007342836)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1825642177529546)
,p_event_id=>wwv_flow_imp.id(3531075388543848)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_job_is_running boolean := false;',
'begin',
'    --',
'    -- Step 1: Determine whether the scheduler job is running',
'    --',
'    for j in (',
'        select 1',
'          from sys.user_scheduler_jobs',
'         where job_name like ''ORACLE_APEX_DTLD$%''',
'           and regexp_substr( comments, ''(\:)(.*?)(\:)'',1,5,''i'',2 ) = ''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID',
'           and state    = ''RUNNING'' ',
'           and rownum   = 1 )',
'    loop',
'        l_job_is_running := true;',
'    end loop;',
'',
'    --',
'    -- Step 2: Determine the current status from the status collection',
'    --',
'    for l_load in (',
'        select c001 as status,',
'               c002 as error_message,',
'               n001 as rows_processed ',
'        from wwv_flow_collections ',
'        where collection_name=''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID)',
'    loop',
'        :P3110_LOAD_STATUS       := l_load.status;',
'        :P3110_LOAD_ERROR        := l_load.error_message;',
'        :P3110_PROCESSED_ROW_CNT := l_load.rows_processed;',
'    end loop;',
'',
'    if :P3110_LOAD_STATUS = ''RUNNING'' and not l_job_is_running then',
'        :P3110_LOAD_STATUS       := ''FAILED'';',
'        :P3110_LOAD_ERROR        := wwv_flow_lang.system_message(''DATA.LOAD.JOB_INTERMITTENTLY_FAILED'');',
'    end if;',
'    ',
'    :P3110_PROCESSED_ROW_CNT_DISP := to_char( :P3110_PROCESSED_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'end;'))
,p_attribute_03=>'P3110_LOAD_STATUS,P3110_PROCESSED_ROW_CNT,P3110_LOAD_ERROR,P3110_PROCESSED_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1825966086529549)
,p_event_id=>wwv_flow_imp.id(3531075388543848)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_table_exists boolean := false;',
'    l_context wwv_flow_exec.t_context;',
'    q varchar2(32767);',
'begin',
'    if :P3110_LOAD_STATUS in (''FAILED'', ''FINISHED'' ) then',
'        if :P3100_LOAD_TO = ''NEW'' then',
'            for l_table in (',
'                select table_name',
'                from sys.dba_tables',
'                where table_name = :P3100_TABLE_NAME',
'                and owner = :P3100_TABLE_OWNER )',
'            loop',
'                :P3110_TABLE_CREATED := ''Y'';',
'            end loop;',
'        end if;',
'        ',
'        for l_table in (',
'            select table_name',
'            from sys.dba_tables',
'            where table_name = :P3100_ERROR_TABLE',
'            and owner = :P3100_TABLE_OWNER )',
'        loop',
'            l_error_table_exists := true;',
'        end loop;',
'        ',
'        q := ''with'';',
'        q := q||'' success_data as (select count(*) as cnt from ''||',
'             wwv_flow_assert.enquote_name(',
'                 case when :P3100_LOAD_TO = ''NEW'' then',
'                     :P3100_TABLE_NAME',
'                 when :P3100_LOAD_TO = ''EXISTING'' then',
'                     :P3100_EXISTING_TABLE',
'                 end )',
'                 || '')'';',
'        if l_error_table_exists then',
'            q := q||'', failed_data as (select count(*) as cnt from ''||wwv_flow_assert.enquote_name( :P3100_ERROR_TABLE ) || '')'';',
'        end if;',
'        q := q||'' select s.cnt as success_count'';',
'        if l_error_table_exists then',
'            q := q||'', e.cnt as error_count'';',
'        end if;',
'        q:=q||'' from'';',
'        q:=q||'' success_data s'';',
'        if l_error_table_exists then',
'            q:=q||'', failed_data e'';',
'        end if;',
'     ',
'        wwv_flow_exec.open_query_context(',
'            p_context     => l_context,',
'            p_location    => wwv_flow_exec_api.c_location_local_db,',
'            p_query_type  => wwv_flow_exec_api.c_query_type_sql_query,',
'            p_sql_query   => q,',
'            p_parse_as_schema_override => :P3100_TABLE_OWNER );',
'            ',
'        if wwv_flow_exec.next_row( p_context => l_context ) then',
'            :P3110_GOOD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 1 );',
'            if l_error_table_exists then',
'                :P3110_BAD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 2 );',
'            else',
'                :P3110_BAD_ROW_CNT := 0;',
'            end if;',
'        end if;',
'        ',
'        if :P3100_LOAD_TO = ''EXISTING'' then',
'            :P3110_GOOD_ROW_CNT := :P3110_PROCESSED_ROW_CNT - :P3110_BAD_ROW_CNT;',
'        end if;',
'        ',
'        :P3110_GOOD_ROW_CNT_DISP := to_char( :P3110_GOOD_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'        :P3110_BAD_ROW_CNT_DISP  := to_char( :P3110_BAD_ROW_CNT,  ''999G999G999G999G999G999G990'' );',
'        ',
'        wwv_flow_exec.close_context( p_context => l_context );',
'    end if;',
'exception ',
'    when others then',
'        wwv_flow_exec.close_context( p_context => l_context );',
'        raise;',
'end;'))
,p_attribute_03=>'P3110_GOOD_ROW_CNT,P3110_BAD_ROW_CNT,P3110_TABLE_CREATED,P3110_TAB_OBJ_ID,P3110_GOOD_ROW_CNT_DISP,P3110_BAD_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(212737138757785632)
,p_name=>'confirm drop tables'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(207424077958369637)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(212737294452785633)
,p_event_id=>wwv_flow_imp.id(212737138757785632)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to drop &P3100_TABLE_NAME. and &P3100_ERROR_TABLE. tables created from the data load?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(207424826705369645)
,p_event_id=>wwv_flow_imp.id(212737138757785632)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DROP_TABLE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(193042576836621231)
,p_name=>'Go to create app wizard'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3527705431543838)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(193042612869621232)
,p_event_id=>wwv_flow_imp.id(193042576836621231)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'GOTO_CREATE_APP'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(207425026686369647)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'drop table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_drop1 sys.dbms_sql.varchar2a;',
'    l_drop2 sys.dbms_sql.varchar2a;',
'begin',
'    l_drop1(1) := ''drop table ''||wwv_flow_assert.enquote_name(:P3100_TABLE_NAME);',
'    l_drop2(1) := ''drop table ''||wwv_flow_assert.enquote_name(:P3100_ERROR_TABLE);',
'    ',
'    wwv_flow_dynamic_exec.run_ddl (',
'        p_sql  => l_drop1,',
'        p_user => :P3100_TABLE_OWNER );',
'   ',
'   wwv_flow_dynamic_exec.run_ddl (',
'        p_sql  => l_drop2,',
'        p_user => :P3100_TABLE_OWNER );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(207424077958369637)
,p_internal_uid=>207425026686369647
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(207424671147369643)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get object ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_object in (',
'    select object_id, object_name',
'    from sys.dba_objects',
'    where object_name in (:P3100_TABLE_NAME, :P3100_EXISTING_TABLE, :P3100_ERROR_TABLE)',
'    and owner = :P3100_TABLE_OWNER )',
'loop',
'    if l_object.object_name = :P3100_TABLE_NAME and :P3100_LOAD_TO = ''NEW'' then',
'        :P3110_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3100_EXISTING_TABLE and :P3100_LOAD_TO = ''EXISTING'' then',
'        :P3110_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3100_ERROR_TABLE then',
'        :P3110_ERR_TAB_OBJ_ID := l_object.object_id;',
'    end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P3110_TAB_OBJ_ID'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>207424671147369643
);
end;
/
prompt --application/pages/page_03120
begin
wwv_flow_imp_page.create_page(
 p_id=>3120
,p_name=>'Load Data'
,p_alias=>'LOAD-DATA5'
,p_page_mode=>'MODAL'
,p_step_title=>'Configure'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690782249755803171)
,p_page_css_classes=>'a-Page--DataLoadPreview'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_dialog_height=>'768'
,p_dialog_width=>'1024'
,p_dialog_chained=>'N'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3942307544766703)
,p_plug_name=>'RDS'
,p_region_name=>'preview_selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4142580643584034)
,p_plug_name=>'Buttons'
,p_region_css_classes=>'u-tC'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="desc">Column types are based on a sample of the first <span id="placeholder_P3120_PARSED_ROW_COUNT">&P3120_PARSED_ROW_COUNT.</span> rows.<br />',
'Showing <span id="placeholder_P3120_PARSED_COLUMN_COUNT">&P3120_PARSED_COLUMN_COUNT.</span> columns, up to 500 characters per column, and a maximum of 100 rows.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20163613189354601)
,p_name=>'Columns to Load'
,p_region_name=>'tab_columns'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'a-DataLoad-previewColumns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with ',
'    l_columns as (',
'        select ',
'            fc.column_position,    ',
'            case when :P3120_FIRST_LINE = ''HEADERS'' then fc.column_name else ''COL'' || lpad( rownum,3,''0'') end as column_name, ',
'            regexp_replace( fc.data_type, ''\(\d+\)'','''') data_type,',
'            case when substr( fc.data_type, 1, 8 ) = ''VARCHAR2''',
'               then replace( substr( fc.data_type, 10 ), '')'' )',
'               else null',
'           end as max_length,',
'            fc.format_mask,',
'            fc.detected_group_char group_char,',
'            fc.detected_decimal_char decimal_char',
'        from wwv_flow_collections c,',
'             table( wwv_flow_data_parser.get_columns( c.clob001 ) ) fc',
'        where c.collection_name =''APEX$DATALOAD'' ),',
'    l_config_columns as (',
'        select',
'            to_number(s.c001) column_position,',
'            s.c002 column_name,',
'            s.c003 format_mask,',
'            s.c004 group_char,',
'            s.c005 decimal_char,',
'            s.c006 data_type,',
'            s.c007 max_length',
'        from wwv_flow_collections s',
'        where collection_name = ''APEX$DATALOAD_COLUMNS'' )',
'select',
'    c.column_position,',
'    htmldb_item.hidden(',
'        p_idx            => 6,',
'        p_value          => c.column_position )||',
'    htmldb_item.hidden(',
'        p_idx            => 2,',
'        p_value          => c.column_name )||',
'    htmldb_item.checkbox2(',
'        p_idx            => 1,',
'        p_value          => c.column_position, ',
'        p_attributes     => ''aria-label="Select Row: ''||wwv_flow_escape.html_attribute(c.column_name)||''"'',',
'        p_checked_values => cf.column_position ) as select_column,   ',
'    c.column_name,',
'    case when cf.data_type = ''CLOB'' then',
'        htmldb_item.display_and_save(',
'            p_idx            => 7,',
'            p_value          => cf.data_type,',
'            p_item_label     => wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name)) )',
'    else',
'        htmldb_item.select_list_from_lov(',
'            p_idx            => 7,',
'            p_value          => cf.data_type,',
'            p_lov            => ''DATA.LOAD.DATA_TYPES'',',
'            p_show_null      => ''NO'',',
'            p_show_extra     => ''NO'',',
'            p_attributes     => case when cf.data_type = ''CLOB'' then ''disabled '' end ||',
'                                ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as column_type,',
'    htmldb_item.text(',
'        p_idx            => 8,',
'        p_value          => cf.max_length,',
'        p_size           => 5,',
'        p_maxLength      => 5,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as max_length,',
'    htmldb_item.text(',
'        p_idx            => 3,',
'        p_value          => cf.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    htmldb_item.text(',
'        p_idx            => 4,',
'        p_value          => cf.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    htmldb_item.text(',
'        p_idx            => 5,',
'        p_value          => cf.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c, l_config_columns cf',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'and  c.column_position = cf.column_position (+)',
'union',
'select',
'    c.column_position,',
'    htmldb_item.hidden(',
'        p_idx            => 6,',
'        p_value          => c.column_position )||',
'    htmldb_item.hidden(',
'        p_idx            => 2,',
'        p_value          => c.column_name )||',
'    htmldb_item.checkbox2(',
'        p_idx            => 1,',
'        p_value          => c.column_position, ',
'        p_attributes     => ''aria-label="Select Row: ''||wwv_flow_escape.html_attribute(c.column_name)||''"'',',
'        p_checked_values => c.column_position) as select_column,    ',
'    c.column_name,',
'    case when c.data_type = ''CLOB'' then',
'        htmldb_item.display_and_save(',
'            p_idx            => 7,',
'            p_value          => c.data_type,',
'            p_item_label     => wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name)) )',
'    else',
'        htmldb_item.select_list_from_lov(',
'            p_idx            => 7,',
'            p_value          => c.data_type,',
'            p_lov            => ''DATA.LOAD.DATA_TYPES'',',
'            p_show_null      => ''NO'',',
'            p_show_extra     => ''NO'',',
'            p_attributes     => ( case when c.data_type = ''CLOB'' then ''disabled '' end )||',
'                                ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as column_type,',
'    htmldb_item.text(',
'        p_idx            => 8,',
'        p_value          => c.max_length,',
'        p_size           => 5,',
'        p_maxLength      => 5,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as max_length,',
'    htmldb_item.text(',
'        p_idx            => 3,',
'        p_value          => c.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    htmldb_item.text(',
'        p_idx            => 4,',
'        p_value          => c.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    htmldb_item.text(',
'        p_idx            => 5,',
'        p_value          => c.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0',
'order by 1'))
,p_display_when_condition=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''NEW'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No columns found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17016028737895907)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>62
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16447964178874803)
,p_query_column_id=>2
,p_column_alias=>'SELECT_COLUMN'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" id="toggle-select-all-columns" aria-label="&APP_TEXT$SELECT_ALL.">'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16446390485874789)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(84357785070572101)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_TYPE'
,p_column_display_sequence=>12
,p_column_heading=>'Column Type'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(94755771110727901)
,p_query_column_id=>5
,p_column_alias=>'MAX_LENGTH'
,p_column_display_sequence=>22
,p_column_heading=>'Max Length'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16447112807874803)
,p_query_column_id=>6
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>32
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(82704532073738118)
,p_query_column_id=>7
,p_column_alias=>'GROUP_CHAR'
,p_column_display_sequence=>42
,p_column_heading=>'Group Separator'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(16447595872874803)
,p_query_column_id=>8
,p_column_alias=>'DECIMAL_CHAR'
,p_column_display_sequence=>52
,p_column_heading=>'Decimal Character'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33184350659846644)
,p_plug_name=>'Settings Item Container'
,p_region_css_classes=>'a-ButtonRegion--DataLoadPreview'
,p_region_template_options=>'a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33362689698963696)
,p_plug_name=>'Preview'
,p_region_name=>'tab_preview'
,p_region_css_classes=>'a-DataLoad-preview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4095522542018729)
,p_name=>'Parsed Data'
,p_region_name=>'preview_table'
,p_parent_plug_id=>wwv_flow_imp.id(33362689698963696)
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select line_number, ',
'       substr(col001, 1, 500) col001,substr(col002, 1, 500) col002,substr(col003, 1, 500) col003,substr(col004, 1, 500) col004,substr(col005, 1, 500) col005,substr(col006, 1, 500) col006,substr(col007, 1, 500) col007,substr(col008, 1, 500) col008,sub'
||'str(col009, 1, 500) col009,substr(col010, 1, 500) col010,',
'       substr(col011, 1, 500) col011,substr(col012, 1, 500) col012,substr(col013, 1, 500) col013,substr(col014, 1, 500) col014,substr(col015, 1, 500) col015,substr(col016, 1, 500) col016,substr(col017, 1, 500) col017,substr(col018, 1, 500) col018,sub'
||'str(col019, 1, 500) col019,substr(col020, 1, 500) col020,',
'       substr(col021, 1, 500) col021,substr(col022, 1, 500) col022,substr(col023, 1, 500) col023,substr(col024, 1, 500) col024,substr(col025, 1, 500) col025,substr(col026, 1, 500) col026,substr(col027, 1, 500) col027,substr(col028, 1, 500) col028,sub'
||'str(col029, 1, 500) col029,substr(col030, 1, 500) col030,',
'       substr(col031, 1, 500) col031,substr(col032, 1, 500) col032,substr(col033, 1, 500) col033,substr(col034, 1, 500) col034,substr(col035, 1, 500) col035,substr(col036, 1, 500) col036,substr(col037, 1, 500) col037,substr(col038, 1, 500) col038,sub'
||'str(col039, 1, 500) col039,substr(col040, 1, 500) col040,',
'       substr(col041, 1, 500) col041,substr(col042, 1, 500) col042,substr(col043, 1, 500) col043,substr(col044, 1, 500) col044,substr(col045, 1, 500) col045,substr(col046, 1, 500) col046,substr(col047, 1, 500) col047,substr(col048, 1, 500) col048,sub'
||'str(col049, 1, 500) col049,substr(col050, 1, 500) col050,',
'       substr(col051, 1, 500) col051,substr(col052, 1, 500) col052,substr(col053, 1, 500) col053,substr(col054, 1, 500) col054,substr(col055, 1, 500) col055,substr(col056, 1, 500) col056,substr(col057, 1, 500) col057,substr(col058, 1, 500) col058,sub'
||'str(col059, 1, 500) col059,substr(col060, 1, 500) col060,',
'       substr(col061, 1, 500) col061,substr(col062, 1, 500) col062,substr(col063, 1, 500) col063,substr(col064, 1, 500) col064,substr(col065, 1, 500) col065,substr(col066, 1, 500) col066,substr(col067, 1, 500) col067,substr(col068, 1, 500) col068,sub'
||'str(col069, 1, 500) col069,substr(col070, 1, 500) col070,',
'       substr(col071, 1, 500) col071,substr(col072, 1, 500) col072,substr(col073, 1, 500) col073,substr(col074, 1, 500) col074,substr(col075, 1, 500) col075,substr(col076, 1, 500) col076,substr(col077, 1, 500) col077,substr(col078, 1, 500) col078,sub'
||'str(col079, 1, 500) col079,substr(col080, 1, 500) col080,',
'       substr(col081, 1, 500) col081,substr(col082, 1, 500) col082,substr(col083, 1, 500) col083,substr(col084, 1, 500) col084,substr(col085, 1, 500) col085,substr(col086, 1, 500) col086,substr(col087, 1, 500) col087,substr(col088, 1, 500) col088,sub'
||'str(col089, 1, 500) col089,substr(col090, 1, 500) col090,',
'       substr(col091, 1, 500) col091,substr(col092, 1, 500) col092,substr(col093, 1, 500) col093,substr(col094, 1, 500) col094,substr(col095, 1, 500) col095,substr(col096, 1, 500) col096,substr(col097, 1, 500) col097,substr(col098, 1, 500) col098,sub'
||'str(col099, 1, 500) col099,substr(col100, 1, 500) col100',
'from wwv_flow_temp_files f, ',
'     table( wwv_flow_data_parser.parse(',
'                p_content               => f.blob_content,',
'                p_file_name             => f.filename,',
'                p_add_headers_row       => ''Y'',',
'                -- we cannot use coalesce( :P3120_FIRST_LINE, :P3100_FIRST_LINE ) since :P3120_FIRST_LINE contains NULL when not selected!',
'                --p_skip_rows          => case when :P3120_FIRST_LINE = ''HEADERS'' and :P3100_FILE_TYPE in ( 1, 2 ) then 1 else 0 end,',
'                -- please *always* set p_max_rows as a safeguard against fully parsing large files',
'                p_max_rows              => nullif(:P3120_MAX_ROW_COUNT, ''0''),',
'                -- for parser to return p_return_rows, region max rows must be > p_return_rows',
'                p_return_rows           => 100,',
'                p_xlsx_sheet_name       => ( case when :P3100_FILE_TYPE = 1 and :P3120_XLSX_SHEET is not null then :P3120_XLSX_SHEET end ),',
'                p_csv_col_delimiter     => replace(:P3120_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                p_file_charset          => coalesce( :P3120_FILE_CHARSET, ''AL32UTF8'' ),',
'                p_csv_enclosed          => nullif( :P3120_CSV_ENCLOSED, ''None'' ),',
'                p_force_trim_whitespace => :P3120_TRIM_WHITESPACE,',
'                p_nullif                => :P3120_NULLIF )',
'                )',
'where f.name = :P3100_FILE',
'and :P3100_SOURCE_TYPE = ''FILE''',
'union all',
'select line_number, ',
'       substr(col001, 1, 500) col001,substr(col002, 1, 500) col002,substr(col003, 1, 500) col003,substr(col004, 1, 500) col004,substr(col005, 1, 500) col005,substr(col006, 1, 500) col006,substr(col007, 1, 500) col007,substr(col008, 1, 500) col008,sub'
||'str(col009, 1, 500) col009,substr(col010, 1, 500) col010,',
'       substr(col011, 1, 500) col011,substr(col012, 1, 500) col012,substr(col013, 1, 500) col013,substr(col014, 1, 500) col014,substr(col015, 1, 500) col015,substr(col016, 1, 500) col016,substr(col017, 1, 500) col017,substr(col018, 1, 500) col018,sub'
||'str(col019, 1, 500) col019,substr(col020, 1, 500) col020,',
'       substr(col021, 1, 500) col021,substr(col022, 1, 500) col022,substr(col023, 1, 500) col023,substr(col024, 1, 500) col024,substr(col025, 1, 500) col025,substr(col026, 1, 500) col026,substr(col027, 1, 500) col027,substr(col028, 1, 500) col028,sub'
||'str(col029, 1, 500) col029,substr(col030, 1, 500) col030,',
'       substr(col031, 1, 500) col031,substr(col032, 1, 500) col032,substr(col033, 1, 500) col033,substr(col034, 1, 500) col034,substr(col035, 1, 500) col035,substr(col036, 1, 500) col036,substr(col037, 1, 500) col037,substr(col038, 1, 500) col038,sub'
||'str(col039, 1, 500) col039,substr(col040, 1, 500) col040,',
'       substr(col041, 1, 500) col041,substr(col042, 1, 500) col042,substr(col043, 1, 500) col043,substr(col044, 1, 500) col044,substr(col045, 1, 500) col045,substr(col046, 1, 500) col046,substr(col047, 1, 500) col047,substr(col048, 1, 500) col048,sub'
||'str(col049, 1, 500) col049,substr(col050, 1, 500) col050,',
'       substr(col051, 1, 500) col051,substr(col052, 1, 500) col052,substr(col053, 1, 500) col053,substr(col054, 1, 500) col054,substr(col055, 1, 500) col055,substr(col056, 1, 500) col056,substr(col057, 1, 500) col057,substr(col058, 1, 500) col058,sub'
||'str(col059, 1, 500) col059,substr(col060, 1, 500) col060,',
'       substr(col061, 1, 500) col061,substr(col062, 1, 500) col062,substr(col063, 1, 500) col063,substr(col064, 1, 500) col064,substr(col065, 1, 500) col065,substr(col066, 1, 500) col066,substr(col067, 1, 500) col067,substr(col068, 1, 500) col068,sub'
||'str(col069, 1, 500) col069,substr(col070, 1, 500) col070,',
'       substr(col071, 1, 500) col071,substr(col072, 1, 500) col072,substr(col073, 1, 500) col073,substr(col074, 1, 500) col074,substr(col075, 1, 500) col075,substr(col076, 1, 500) col076,substr(col077, 1, 500) col077,substr(col078, 1, 500) col078,sub'
||'str(col079, 1, 500) col079,substr(col080, 1, 500) col080,',
'       substr(col081, 1, 500) col081,substr(col082, 1, 500) col082,substr(col083, 1, 500) col083,substr(col084, 1, 500) col084,substr(col085, 1, 500) col085,substr(col086, 1, 500) col086,substr(col087, 1, 500) col087,substr(col088, 1, 500) col088,sub'
||'str(col089, 1, 500) col089,substr(col090, 1, 500) col090,',
'       substr(col091, 1, 500) col091,substr(col092, 1, 500) col092,substr(col093, 1, 500) col093,substr(col094, 1, 500) col094,substr(col095, 1, 500) col095,substr(col096, 1, 500) col096,substr(col097, 1, 500) col097,substr(col098, 1, 500) col098,sub'
||'str(col099, 1, 500) col099,substr(col100, 1, 500) col100',
'from wwv_flow_collections c, ',
'     table( wwv_flow_data_parser.parse(',
'                p_content               => c.blob001,',
'                p_file_type             => 2,',
'                --   ',
'                p_add_headers_row       => ''Y'',',
'                p_max_rows              => nullif(:P3120_MAX_ROW_COUNT, ''0''),',
'                -- for parser to return p_return_rows, region max rows must be > p_return_rows',
'                p_return_rows           => 100,',
'                p_csv_col_delimiter     => replace(:P3120_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                p_file_charset          => coalesce( :P3120_FILE_CHARSET, ''AL32UTF8'' ),',
'                p_csv_enclosed          => nullif( :P3120_CSV_ENCLOSED, ''None'' ),',
'                p_force_trim_whitespace => :P3120_TRIM_WHITESPACE,',
'                p_nullif                => :P3120_NULLIF )',
'                )',
'where c.collection_name=''CLOB_CONTENT''',
'and :P3100_SOURCE_TYPE = ''COPY_PASTE'';'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>110
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_row_count_max=>110
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4095627438018730)
,p_query_column_id=>1
,p_column_alias=>'LINE_NUMBER'
,p_column_display_sequence=>1
,p_column_heading=>'Line'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4095701906018731)
,p_query_column_id=>2
,p_column_alias=>'COL001'
,p_column_display_sequence=>2
,p_column_heading=>'COL001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4095816508018732)
,p_query_column_id=>3
,p_column_alias=>'COL002'
,p_column_display_sequence=>3
,p_column_heading=>'COL002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4095916993018733)
,p_query_column_id=>4
,p_column_alias=>'COL003'
,p_column_display_sequence=>4
,p_column_heading=>'COL003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096078432018734)
,p_query_column_id=>5
,p_column_alias=>'COL004'
,p_column_display_sequence=>5
,p_column_heading=>'COL004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096140312018735)
,p_query_column_id=>6
,p_column_alias=>'COL005'
,p_column_display_sequence=>6
,p_column_heading=>'COL005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096207006018736)
,p_query_column_id=>7
,p_column_alias=>'COL006'
,p_column_display_sequence=>7
,p_column_heading=>'COL006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096399568018737)
,p_query_column_id=>8
,p_column_alias=>'COL007'
,p_column_display_sequence=>8
,p_column_heading=>'COL007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096479039018738)
,p_query_column_id=>9
,p_column_alias=>'COL008'
,p_column_display_sequence=>9
,p_column_heading=>'COL008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096541442018739)
,p_query_column_id=>10
,p_column_alias=>'COL009'
,p_column_display_sequence=>10
,p_column_heading=>'COL009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096698615018740)
,p_query_column_id=>11
,p_column_alias=>'COL010'
,p_column_display_sequence=>11
,p_column_heading=>'COL010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096794029018741)
,p_query_column_id=>12
,p_column_alias=>'COL011'
,p_column_display_sequence=>12
,p_column_heading=>'COL011'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096882678018742)
,p_query_column_id=>13
,p_column_alias=>'COL012'
,p_column_display_sequence=>13
,p_column_heading=>'COL012'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4096977361018743)
,p_query_column_id=>14
,p_column_alias=>'COL013'
,p_column_display_sequence=>14
,p_column_heading=>'COL013'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4097069663018744)
,p_query_column_id=>15
,p_column_alias=>'COL014'
,p_column_display_sequence=>15
,p_column_heading=>'COL014'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4097109638018745)
,p_query_column_id=>16
,p_column_alias=>'COL015'
,p_column_display_sequence=>16
,p_column_heading=>'COL015'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4097296832018746)
,p_query_column_id=>17
,p_column_alias=>'COL016'
,p_column_display_sequence=>17
,p_column_heading=>'COL016'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4097335005018747)
,p_query_column_id=>18
,p_column_alias=>'COL017'
,p_column_display_sequence=>18
,p_column_heading=>'COL017'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4097407519018748)
,p_query_column_id=>19
,p_column_alias=>'COL018'
,p_column_display_sequence=>19
,p_column_heading=>'COL018'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4097570225018749)
,p_query_column_id=>20
,p_column_alias=>'COL019'
,p_column_display_sequence=>20
,p_column_heading=>'COL019'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4097694903018750)
,p_query_column_id=>21
,p_column_alias=>'COL020'
,p_column_display_sequence=>21
,p_column_heading=>'COL020'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4139230045584001)
,p_query_column_id=>22
,p_column_alias=>'COL021'
,p_column_display_sequence=>22
,p_column_heading=>'COL021'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4139353025584002)
,p_query_column_id=>23
,p_column_alias=>'COL022'
,p_column_display_sequence=>23
,p_column_heading=>'COL022'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4139438866584003)
,p_query_column_id=>24
,p_column_alias=>'COL023'
,p_column_display_sequence=>24
,p_column_heading=>'COL023'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4139528587584004)
,p_query_column_id=>25
,p_column_alias=>'COL024'
,p_column_display_sequence=>25
,p_column_heading=>'COL024'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4139626793584005)
,p_query_column_id=>26
,p_column_alias=>'COL025'
,p_column_display_sequence=>26
,p_column_heading=>'COL025'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4139773523584006)
,p_query_column_id=>27
,p_column_alias=>'COL026'
,p_column_display_sequence=>27
,p_column_heading=>'COL026'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4139853620584007)
,p_query_column_id=>28
,p_column_alias=>'COL027'
,p_column_display_sequence=>28
,p_column_heading=>'COL027'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4139943037584008)
,p_query_column_id=>29
,p_column_alias=>'COL028'
,p_column_display_sequence=>29
,p_column_heading=>'COL028'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140020006584009)
,p_query_column_id=>30
,p_column_alias=>'COL029'
,p_column_display_sequence=>30
,p_column_heading=>'COL029'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140128629584010)
,p_query_column_id=>31
,p_column_alias=>'COL030'
,p_column_display_sequence=>31
,p_column_heading=>'COL030'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140221496584011)
,p_query_column_id=>32
,p_column_alias=>'COL031'
,p_column_display_sequence=>32
,p_column_heading=>'COL031'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140305790584012)
,p_query_column_id=>33
,p_column_alias=>'COL032'
,p_column_display_sequence=>33
,p_column_heading=>'COL032'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140455288584013)
,p_query_column_id=>34
,p_column_alias=>'COL033'
,p_column_display_sequence=>34
,p_column_heading=>'COL033'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140588027584014)
,p_query_column_id=>35
,p_column_alias=>'COL034'
,p_column_display_sequence=>35
,p_column_heading=>'COL034'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140662450584015)
,p_query_column_id=>36
,p_column_alias=>'COL035'
,p_column_display_sequence=>36
,p_column_heading=>'COL035'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140741697584016)
,p_query_column_id=>37
,p_column_alias=>'COL036'
,p_column_display_sequence=>37
,p_column_heading=>'COL036'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140892210584017)
,p_query_column_id=>38
,p_column_alias=>'COL037'
,p_column_display_sequence=>38
,p_column_heading=>'COL037'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4140971698584018)
,p_query_column_id=>39
,p_column_alias=>'COL038'
,p_column_display_sequence=>39
,p_column_heading=>'COL038'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141054010584019)
,p_query_column_id=>40
,p_column_alias=>'COL039'
,p_column_display_sequence=>40
,p_column_heading=>'COL039'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141102541584020)
,p_query_column_id=>41
,p_column_alias=>'COL040'
,p_column_display_sequence=>41
,p_column_heading=>'COL040'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141295677584021)
,p_query_column_id=>42
,p_column_alias=>'COL041'
,p_column_display_sequence=>42
,p_column_heading=>'COL041'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141327065584022)
,p_query_column_id=>43
,p_column_alias=>'COL042'
,p_column_display_sequence=>43
,p_column_heading=>'COL042'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141496900584023)
,p_query_column_id=>44
,p_column_alias=>'COL043'
,p_column_display_sequence=>44
,p_column_heading=>'COL043'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141539072584024)
,p_query_column_id=>45
,p_column_alias=>'COL044'
,p_column_display_sequence=>45
,p_column_heading=>'COL044'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141606742584025)
,p_query_column_id=>46
,p_column_alias=>'COL045'
,p_column_display_sequence=>46
,p_column_heading=>'COL045'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141769077584026)
,p_query_column_id=>47
,p_column_alias=>'COL046'
,p_column_display_sequence=>47
,p_column_heading=>'COL046'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141881409584027)
,p_query_column_id=>48
,p_column_alias=>'COL047'
,p_column_display_sequence=>48
,p_column_heading=>'COL047'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4141944378584028)
,p_query_column_id=>49
,p_column_alias=>'COL048'
,p_column_display_sequence=>49
,p_column_heading=>'COL048'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4142057597584029)
,p_query_column_id=>50
,p_column_alias=>'COL049'
,p_column_display_sequence=>50
,p_column_heading=>'COL049'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4142112774584030)
,p_query_column_id=>51
,p_column_alias=>'COL050'
,p_column_display_sequence=>51
,p_column_heading=>'COL050'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213830519056023)
,p_query_column_id=>52
,p_column_alias=>'COL051'
,p_column_display_sequence=>52
,p_column_heading=>'COL051'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4213985667056024)
,p_query_column_id=>53
,p_column_alias=>'COL052'
,p_column_display_sequence=>53
,p_column_heading=>'COL052'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214058128056025)
,p_query_column_id=>54
,p_column_alias=>'COL053'
,p_column_display_sequence=>54
,p_column_heading=>'COL053'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214108143056026)
,p_query_column_id=>55
,p_column_alias=>'COL054'
,p_column_display_sequence=>55
,p_column_heading=>'COL054'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214201077056027)
,p_query_column_id=>56
,p_column_alias=>'COL055'
,p_column_display_sequence=>56
,p_column_heading=>'COL055'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214356043056028)
,p_query_column_id=>57
,p_column_alias=>'COL056'
,p_column_display_sequence=>57
,p_column_heading=>'COL056'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214416146056029)
,p_query_column_id=>58
,p_column_alias=>'COL057'
,p_column_display_sequence=>58
,p_column_heading=>'COL057'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214534078056030)
,p_query_column_id=>59
,p_column_alias=>'COL058'
,p_column_display_sequence=>59
,p_column_heading=>'COL058'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214647053056031)
,p_query_column_id=>60
,p_column_alias=>'COL059'
,p_column_display_sequence=>60
,p_column_heading=>'COL059'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214783952056032)
,p_query_column_id=>61
,p_column_alias=>'COL060'
,p_column_display_sequence=>61
,p_column_heading=>'COL060'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214830626056033)
,p_query_column_id=>62
,p_column_alias=>'COL061'
,p_column_display_sequence=>62
,p_column_heading=>'COL061'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4214990581056034)
,p_query_column_id=>63
,p_column_alias=>'COL062'
,p_column_display_sequence=>63
,p_column_heading=>'COL062'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215038658056035)
,p_query_column_id=>64
,p_column_alias=>'COL063'
,p_column_display_sequence=>64
,p_column_heading=>'COL063'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215189206056036)
,p_query_column_id=>65
,p_column_alias=>'COL064'
,p_column_display_sequence=>65
,p_column_heading=>'COL064'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215288166056037)
,p_query_column_id=>66
,p_column_alias=>'COL065'
,p_column_display_sequence=>66
,p_column_heading=>'COL065'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215323561056038)
,p_query_column_id=>67
,p_column_alias=>'COL066'
,p_column_display_sequence=>67
,p_column_heading=>'COL066'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215485218056039)
,p_query_column_id=>68
,p_column_alias=>'COL067'
,p_column_display_sequence=>68
,p_column_heading=>'COL067'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215536239056040)
,p_query_column_id=>69
,p_column_alias=>'COL068'
,p_column_display_sequence=>69
,p_column_heading=>'COL068'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215679718056041)
,p_query_column_id=>70
,p_column_alias=>'COL069'
,p_column_display_sequence=>70
,p_column_heading=>'COL069'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215752947056042)
,p_query_column_id=>71
,p_column_alias=>'COL070'
,p_column_display_sequence=>71
,p_column_heading=>'COL070'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215873869056043)
,p_query_column_id=>72
,p_column_alias=>'COL071'
,p_column_display_sequence=>72
,p_column_heading=>'COL071'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4215976896056044)
,p_query_column_id=>73
,p_column_alias=>'COL072'
,p_column_display_sequence=>73
,p_column_heading=>'COL072'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4216096921056045)
,p_query_column_id=>74
,p_column_alias=>'COL073'
,p_column_display_sequence=>74
,p_column_heading=>'COL073'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4216186784056046)
,p_query_column_id=>75
,p_column_alias=>'COL074'
,p_column_display_sequence=>75
,p_column_heading=>'COL074'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4216277094056047)
,p_query_column_id=>76
,p_column_alias=>'COL075'
,p_column_display_sequence=>76
,p_column_heading=>'COL075'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4216365696056048)
,p_query_column_id=>77
,p_column_alias=>'COL076'
,p_column_display_sequence=>77
,p_column_heading=>'COL076'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4216421564056049)
,p_query_column_id=>78
,p_column_alias=>'COL077'
,p_column_display_sequence=>78
,p_column_heading=>'COL077'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4216571845056050)
,p_query_column_id=>79
,p_column_alias=>'COL078'
,p_column_display_sequence=>79
,p_column_heading=>'COL078'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4261747128082501)
,p_query_column_id=>80
,p_column_alias=>'COL079'
,p_column_display_sequence=>80
,p_column_heading=>'COL079'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4261825910082502)
,p_query_column_id=>81
,p_column_alias=>'COL080'
,p_column_display_sequence=>81
,p_column_heading=>'COL080'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4261942413082503)
,p_query_column_id=>82
,p_column_alias=>'COL081'
,p_column_display_sequence=>82
,p_column_heading=>'COL081'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262046820082504)
,p_query_column_id=>83
,p_column_alias=>'COL082'
,p_column_display_sequence=>83
,p_column_heading=>'COL082'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262197071082505)
,p_query_column_id=>84
,p_column_alias=>'COL083'
,p_column_display_sequence=>84
,p_column_heading=>'COL083'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262203979082506)
,p_query_column_id=>85
,p_column_alias=>'COL084'
,p_column_display_sequence=>85
,p_column_heading=>'COL084'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262355414082507)
,p_query_column_id=>86
,p_column_alias=>'COL085'
,p_column_display_sequence=>86
,p_column_heading=>'COL085'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262430686082508)
,p_query_column_id=>87
,p_column_alias=>'COL086'
,p_column_display_sequence=>87
,p_column_heading=>'COL086'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262575343082509)
,p_query_column_id=>88
,p_column_alias=>'COL087'
,p_column_display_sequence=>88
,p_column_heading=>'COL087'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262609592082510)
,p_query_column_id=>89
,p_column_alias=>'COL088'
,p_column_display_sequence=>89
,p_column_heading=>'COL088'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262779568082511)
,p_query_column_id=>90
,p_column_alias=>'COL089'
,p_column_display_sequence=>90
,p_column_heading=>'COL089'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262873318082512)
,p_query_column_id=>91
,p_column_alias=>'COL090'
,p_column_display_sequence=>91
,p_column_heading=>'COL090'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4262986979082513)
,p_query_column_id=>92
,p_column_alias=>'COL091'
,p_column_display_sequence=>92
,p_column_heading=>'COL091'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4263080531082514)
,p_query_column_id=>93
,p_column_alias=>'COL092'
,p_column_display_sequence=>93
,p_column_heading=>'COL092'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4263124215082515)
,p_query_column_id=>94
,p_column_alias=>'COL093'
,p_column_display_sequence=>94
,p_column_heading=>'COL093'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4263239397082516)
,p_query_column_id=>95
,p_column_alias=>'COL094'
,p_column_display_sequence=>95
,p_column_heading=>'COL094'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4263315322082517)
,p_query_column_id=>96
,p_column_alias=>'COL095'
,p_column_display_sequence=>96
,p_column_heading=>'COL095'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4263447002082518)
,p_query_column_id=>97
,p_column_alias=>'COL096'
,p_column_display_sequence=>97
,p_column_heading=>'COL096'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4263507300082519)
,p_query_column_id=>98
,p_column_alias=>'COL097'
,p_column_display_sequence=>98
,p_column_heading=>'COL097'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4263690377082520)
,p_query_column_id=>99
,p_column_alias=>'COL098'
,p_column_display_sequence=>99
,p_column_heading=>'COL098'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4263792446082521)
,p_query_column_id=>100
,p_column_alias=>'COL099'
,p_column_display_sequence=>100
,p_column_heading=>'COL099'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4263882248082522)
,p_query_column_id=>101
,p_column_alias=>'COL100'
,p_column_display_sequence=>101
,p_column_heading=>'COL100'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18663279696871922)
,p_plug_name=>'get file profile and save'
,p_region_name=>'getFileProfile'
,p_parent_plug_id=>wwv_flow_imp.id(33362689698963696)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile             clob;',
'    l_file_content        blob;',
'    l_profile_record      wwv_flow_data_parser.t_file_profile;',
'    ',
'    l_column_name_changed boolean := false;',
'begin',
'    l_profile        := wwv_flow_data_parser.get_file_profile;',
'    l_profile_record := wwv_flow_data_parser.json_to_profile( l_profile );',
'',
'    if :P3120_FIRST_LINE is null or :P3120_FIRST_LINE != ''HEADERS'' then',
'        for i in 1 .. l_profile_record.file_columns.count loop',
'            l_profile_record.file_columns( i ).name := ''COL'' || lpad( i,3,''0'');',
'        end loop;',
'        l_profile := wwv_flow_data_parser.profile_to_json(l_profile_record);',
'        ',
'        l_column_name_changed := true;',
'        ',
'        -- see if configure columns are same, if not column names changed',
'        for i in 1 .. l_profile_record.file_columns.count',
'        loop',
'            for l_configure in (',
'                select',
'                    c001   column_name,',
'                    c002   mapped_column',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                and c001 = l_profile_record.file_columns( i ).name )',
'            loop    ',
'                l_column_name_changed := false;',
'                exit;',
'            end loop;',
'        end loop;',
'    end if;',
'    ',
'    -- save file profile in collection for later use',
'   wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'   wwv_flow_collection.add_member( ''APEX$DATALOAD'', p_clob001 => l_profile );',
'   ',
'    if l_column_name_changed then',
'        wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    end if;',
'   ',
'    :P3120_PARSED_ROW_COUNT := l_profile_record.parsed_rows;',
'    ',
'    if l_profile_record.file_columns.count <= 100 then',
'        :P3120_PARSED_COLUMN_COUNT := l_profile_record.file_columns.count;',
'    else',
'        :P3120_PARSED_COLUMN_COUNT := 100;',
'    end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(193340845691147579)
,p_name=>'Column Mapping'
,p_region_name=>'tab_columns'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'a-DataLoad-previewColumns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with',
'l_msg as (',
'    select wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.UNMAPPED'') unmapped',
'    from sys.dual)',
', l_columns as (',
'    select ',
'        fc.column_position,    ',
'        case when :P3120_FIRST_LINE = ''HEADERS'' then',
'            fc.column_name',
'        else ',
'            ''COL'' || lpad( rownum,3,''0'')',
'        end as column_name,',
'        case when :P3120_FIRST_LINE = ''HEADERS'' then',
'            ( select tc.column_name ',
'              from sys.dba_tab_columns tc',
'              where tc.owner = :P3100_TABLE_OWNER',
'              and tc.table_name = :P3100_EXISTING_TABLE',
'              and tc.column_name = fc.column_name )',
'        else',
'             null',
'        end as map_column_name, ',
'        fc.data_type, ',
'        fc.format_mask,',
'        fc.detected_group_char group_char,',
'        fc.detected_decimal_char decimal_char',
'    from wwv_flow_collections c,',
'         table( wwv_flow_data_parser.get_columns( c.clob001 ) ) fc',
'    where c.collection_name =''APEX$DATALOAD'' )',
', l_sum_existing_tab_col as (',
'    select sum( length( ''<option value="''|| column_name ||''">''|| column_name ||'' (''|| data_type ||'')</option>'' ) ) total_length',
'    from sys.dba_tab_columns tc',
'    where tc.owner = :P3100_TABLE_OWNER',
'    and tc.table_name = :P3100_EXISTING_TABLE )',
'select',
'    c.column_position,',
'    c.column_name,',
'    c.data_type,',
'    htmldb_item.hidden(',
'        p_idx            => 1,',
'        p_value          => c.column_name)||',
'    case when tc.total_length <= 3900 then',
'        htmldb_item.select_list_from_lov(',
'            p_idx            => 2,',
'            p_value          => m.c002,',
'            p_lov            => ''P3120_TABLE_COLUMNS'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,         ',
'            p_show_extra     => ''NO'',',
'            p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'', wwv_flow_escape.html_attribute(c.column_name))||''"'') ',
'    else',
'        -- bug 30464422 fix, show popup if total existing table column option  > 3900 to avoid error',
'        wwv_flow_item.popup_from_lov(',
'            p_idx            => 2,',
'            p_value          => m.c002,',
'            p_lov_name       => ''P3120_TABLE_COLUMNS'',',
'            p_width          => 40,',
'            p_show_null      => ''YES'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as column_map,',
'    htmldb_item.text(',
'        p_idx            => 3,',
'        p_value          => m.c003,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    htmldb_item.text(',
'        p_idx            => 4,',
'        p_value          => m.c004,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    htmldb_item.text(',
'        p_idx            => 5,',
'        p_value          => m.c005,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c, l_sum_existing_tab_col tc, l_msg msg, wwv_flow_collections m',
'where c.column_name = m.c001 (+)',
'and wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'union',
'select',
'    c.column_position,',
'    c.column_name,',
'    c.data_type, ',
'    htmldb_item.hidden(',
'        p_idx            => 1,',
'        p_value          => c.column_name)||',
'    case when tc.total_length <= 3900 then',
'        htmldb_item.select_list_from_lov(',
'            p_idx            => 2,',
'            p_value          => c.map_column_name,',
'            p_lov            => ''P3120_TABLE_COLUMNS'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_show_extra     => ''NO'',',
'            p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'', c.column_name )||''"'')',
'    else',
'        -- bug 30464422 fix, show popup if total existing table column option  > 3900 to avoid error ',
'        wwv_flow_item.popup_from_lov(',
'            p_idx            => 2,',
'            p_value          => c.map_column_name,',
'            p_lov_name       => ''P3120_TABLE_COLUMNS'',',
'            p_width          => 40,',
'            p_show_null      => ''YES'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'', c.column_name )||''"'')',
'    end as column_map,',
'    htmldb_item.text(',
'        p_idx            => 3,',
'        p_value          => c.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    htmldb_item.text(',
'        p_idx            => 4,',
'        p_value          => c.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    htmldb_item.text(',
'        p_idx            => 5,',
'        p_value          => c.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char        ',
'from l_columns c, l_msg msg, l_sum_existing_tab_col tc',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0',
'order by 1'))
,p_display_when_condition=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No columns found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(71165069604648136)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(71164390875648131)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Source Column'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(71164643957648135)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(71165427710648136)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_MAP'
,p_column_display_sequence=>4
,p_column_heading=>'Map To'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(71166248421648137)
,p_query_column_id=>5
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>5
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(82704401450738117)
,p_query_column_id=>6
,p_column_alias=>'GROUP_CHAR'
,p_column_display_sequence=>6
,p_column_heading=>'Group Separator'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(71165863827648137)
,p_query_column_id=>7
,p_column_alias=>'DECIMAL_CHAR'
,p_column_display_sequence=>7
,p_column_heading=>'Decimal Character'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3942483089766704)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4142580643584034)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4142690830584035)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4142580643584034)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Close Dialog'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4264413621082528)
,p_name=>'P3120_FILE_SIZE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16728721207833241)
,p_name=>'P3120_FIRST_LINE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_prompt=>'Column Headers'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DATA.LOAD.FIRST_LINE'
,p_lov=>'.'||wwv_flow_imp.id(3934090607812623)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) not in (wwv_flow_data_parser.c_file_type_xml, wwv_flow_data_parser.c_file_type_json) then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select this option if your data contains column names in the first row.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16729160519833244)
,p_name=>'P3120_MAX_ROW_COUNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_item_default=>'200'
,p_prompt=>'Rows to Sample'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.MAX_ROW_RANGE'
,p_lov=>'.'||wwv_flow_imp.id(3867907456164412)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_css_classes=>'tab-columns'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the maximum number of rows to be used to sample column types.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'6'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16730081104833245)
,p_name=>'P3120_PREV_MAX_ROW_COUNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16730418310833246)
,p_name=>'P3120_XLSX_SHEET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_prompt=>'Select Sheet'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_display_name, sheet_file_name',
'from wwv_flow_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_'';'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sheet_cnt number := 0;',
'begin',
'    -- shortcut: return immediately when we don''t have an XLSX file, since invoking wwv_flow_data_parser.get_xlsx_worksheets',
'    -- is an expensive operation leading to nothing',
'    if lower( :P3100_FILE ) not like ''%.xls_'' then',
'        return false;',
'    end if;',
'',
'    select count(*)',
'    into l_sheet_cnt',
'    from wwv_flow_temp_files f, ',
'         table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                    p_content => f.blob_content ) )',
'    where f.name = :P3100_FILE and lower( :P3100_FILE ) like ''%.xls_'';',
'    ',
'    -- if there is multiple sheets, display',
'    if ( l_sheet_cnt > 1 ) then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Your file contains multiple sheets.  Select the worksheet you want to load.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16731233824833247)
,p_name=>'P3120_CSV_COL_DELIMITER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_prompt=>'Column Delimiter'
,p_source=>'P3100_CSV_COL_DELIMITER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov=>'.'||wwv_flow_imp.id(3927422505659936)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a column delimiter character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16732148218833247)
,p_name=>'P3120_CSV_ENCLOSED'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_prompt=>'Enclosed By'
,p_source=>'P3100_CSV_ENCLOSED'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov=>'.'||wwv_flow_imp.id(3931221323686172)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P3100_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P3100_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a column enclosed by character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16733088247833248)
,p_name=>'P3120_FILE_CHARSET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_item_default=>'AL32UTF8'
,p_prompt=>'File Encoding'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_DB_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(143362112016702427)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_css_classes=>'tab-preview'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the characterset in which the file is encoded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16753269820154313)
,p_name=>'P3120_PARSED_ROW_COUNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20163613189354601)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16910933728036337)
,p_name=>'P3120_PARSED_COLUMN_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20163613189354601)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20812906888966802)
,p_name=>'P3120_TRIM_WHITESPACE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_item_default=>'Y'
,p_prompt=>'Force Trim Whitespace'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_css_classes=>'tab-columns'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    This controls how APEX trims leading and trailing whitespace from loaded data values:',
'</p>',
'<ul>',
'    <li><strong>Disabled</strong>: Only <em>unquoted Whitespace</em> in CSV files will be trimmed. Quoted whitespace or whitespace in XML, XLSX or JSON files will be preserved.</li>',
'    <li><strong>Enabled</strong>: All leading and trailing whitespace will be trimmed from loaded data values.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72668194960230601)
,p_name=>'P3120_ACTION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Used for default tab selection on page load'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(207424466246369641)
,p_name=>'P3120_NULLIF'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(33184350659846644)
,p_prompt=>'Treat as Null'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>20
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_css_classes=>'tab-columns'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The entered case insensitive value will be treated as NULL.  For example, "tbd", "n/a", "unknown", "-".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(16480193144310407)
,p_validation_name=>'must at least select one column'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'At least one column must be selected to load.'
,p_when_button_pressed=>wwv_flow_imp.id(3942483089766704)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(81742731063478601)
,p_validation_name=>'check group and decimal char'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_load_to      varchar2(10);',
'    ',
'    l_group_char   varchar2(4);',
'    l_decimal_char varchar2(4);',
'    l_column_name  varchar2(128);',
'    l_error_msg    varchar2(4000);',
'',
'    function validate_group_decimal_char',
'    return varchar2',
'    is',
'        l_msg varchar2(4000);',
'    begin',
'        -- if group separator defined, decimal character must be defined',
'        if l_group_char is not null then',
'            if l_decimal_char is null then',
'                l_msg := wwv_flow_lang.system_message( ',
'                            ''DATA_LOAD.DECIMAL_CHAR_REQUIRED'',',
'                            l_column_name );',
'            end if;',
'        end if;',
'',
'        -- group and decimal chars cannot be same',
'        if l_group_char = l_decimal_char then',
'            l_msg := wwv_flow_lang.system_message(',
'                         ''DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'',',
'                         l_column_name );',
'        end if;',
'        ',
'        return l_msg;',
'    end validate_group_decimal_char;',
'begin',
'    l_load_to := coalesce( :P3100_LOAD_TO, ''NEW'');',
'',
'    if l_load_to = ''NEW'' then',
'        -- loop through all column postions',
'        for i in 1 .. wwv_flow.g_f06.count',
'        loop',
'            for j in 1 .. wwv_flow.g_f01.count',
'            loop',
'                -- if column checked to load, validate',
'                if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'                    l_column_name  := wwv_flow.g_f02( i );',
'                    l_group_char   := wwv_flow.g_f04( i );',
'                    l_decimal_char := wwv_flow.g_f05( i );',
'',
'                    l_error_msg := validate_group_decimal_char;',
'                    if l_error_msg is not null then',
'                        return l_error_msg;',
'                    end if;',
'',
'                    exit;',
'                end if;',
'            end loop;',
'        end loop;',
'    elsif l_load_to= ''EXISTING'' then',
'        for i in 1 .. wwv_flow.g_f02.count',
'        loop',
'            -- if column mapped, check group and decimal char',
'            if wwv_flow.g_f02(i) is not null then',
'                l_column_name  := wwv_flow.g_f02( i );',
'                l_group_char   := wwv_flow.g_f04( i );',
'                l_decimal_char := wwv_flow.g_f05( i );',
'',
'                l_error_msg := validate_group_decimal_char;',
'                if l_error_msg is not null then',
'                    return l_error_msg;',
'                end if;',
'            end if;',
'        end loop;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(3942483089766704)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(285737382733666601)
,p_validation_name=>'table columns not mapped multiple times'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_names  wwv_flow_global.vc_map;',
'    l_col_name_idx  pls_integer;',
'begin',
'    l_col_name_idx := wwv_flow.g_f02.first;',
'    while l_col_name_idx is not null loop',
'        if wwv_flow.g_f02( l_col_name_idx ) is not null then',
'            if l_column_names.exists( wwv_flow.g_f02( l_col_name_idx ) ) then',
'                return wwv_flow_lang.system_message ( ''DATA_LOAD.DUPLICATE_MAPPING'', wwv_flow.g_f02( l_col_name_idx ) );',
'            else',
'                l_column_names( wwv_flow.g_f02( l_col_name_idx ) ) := null;',
'            end if;',
'        end if;',
'',
'        l_col_name_idx := wwv_flow.g_f02.next( l_col_name_idx );',
'    end loop;',
'    return null;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3942483089766704)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(94756065775727904)
,p_validation_name=>'check max length'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_type    wwv_flow_global.t_dbms_id;',
'    l_max_length   number;',
'begin',
'    ',
'    -- loop through all column postions',
'    for i in 1 .. wwv_flow.g_f06.count',
'    loop',
'',
'        for j in 1 .. wwv_flow.g_f01.count',
'        loop',
'            -- if column checked to load, validate',
'            if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'',
'                l_data_type  := wwv_flow.g_f07( i );',
'',
'                begin',
'                    l_max_length := to_number( wwv_flow.g_f08( i ) );',
'                exception when others then',
'                    if l_data_type = ''VARCHAR2'' then',
'                        -- if not number, validation fails',
'                        return false;',
'                    end if;',
'                end;',
'',
'                if l_data_type = ''VARCHAR2'' then',
'                    -- if null, validation fails',
'                    if l_max_length is null then',
'                        return false;',
'                    else',
'                        -- varchar2 data type max length must be between 1 and allowed max varchar2 size',
'                        if l_max_length < 1 or ',
'                           l_max_length > case when wwv_flow_db_version.c_has_extended_string_size then 32767 else 4000 end',
'                        then',
'                            return false;',
'                        end if;',
'                    end if;',
'                end if;',
'',
'                exit;',
'            end if;',
'        end loop;',
'    end loop;',
'',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The maximum length is required for VARCHAR2 columns and must be a number between 1 and allowed maximum size of VARCHAR2.'
,p_validation_condition=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3942483089766704)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4213685135056021)
,p_name=>'Hide empty columns'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(4095522542018729)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4213721059056022)
,p_event_id=>wwv_flow_imp.id(4213685135056021)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#dataload-full-preview th").each( function ( i,o ) {',
'    var lHdr        = $(o).attr("id");',
'    var lColIsEmpty = false;',
'        ',
'    // check whether the column header is empty ...',
'    if ( lHdr && lHdr !== "" && $(o).text() === "" ) {',
'        lColIsEmpty = true;',
'        ',
'        // now check whether the column is also empty',
'        $( "#dataload-full-preview td[headers=" + lHdr + "]" ).each( function( i, o ) {',
'            if ( $( o ).text() !== "" && $( o ).text() !== ''\xa0'' ) {',
'                lColIsEmpty = false;',
'                return;',
'            }',
'        });',
'        if ( lColIsEmpty ) {',
'            $( "#dataload-full-preview th#" + lHdr ).css( "display", "none");',
'            $( "#dataload-full-preview td[headers=" + lHdr + "]" ).css( "display", "none");',
'        }',
'    }',
'});'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16454539826013408)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4142690830584035)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16454641639013409)
,p_event_id=>wwv_flow_imp.id(16454539826013408)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16455260786013415)
,p_name=>'Init UI on load'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16455305658013416)
,p_event_id=>wwv_flow_imp.id(16455260786013415)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Dialog size',
'apex.theme.stretchDialog( apex.util.getTopApex().jQuery( ''#'' + window.frameElement.parentNode.id ), 90 );',
'// RDS icons',
'var icon$ = $(''<span class="a-Icon icon-tree-attributes" aria-hidden="true"></span>'');',
'var rdsTab$ = $(''.apex-rds-item:last-child a:first-child span'');',
'var rdsId = $( ''#preview_selector > .apex-rds-container'' ).find( ''ul'' ).attr( ''id'' ).slice(0, -4);',
'icon$.prependTo(rdsTab$);',
'// shared functions',
'var getColId = function( id ){',
'    var int = parseInt( id ), i;',
'    if ( int <= 9 ) {',
'            i = ''COL00'' + int;',
'        } else if ( int > 9 && int <= 99 ) {',
'            i = ''COL0'' + int;',
'        } else {',
'            i = ''COL'' + int;',
'        }',
'    return i;',
'};',
'',
'var toggleCol = function ( columnId, isShowing ) {',
'    if ( columnId ) {',
'        var header$  = $( ''#'' + columnId ),',
'            body$    = $( ''td[headers='' + columnId + '']'' );',
'',
'        if ( isShowing ) {',
'            header$.show();',
'            body$.show();',
'        } else {',
'            header$.hide();',
'            body$.hide();',
'        }',
'    }',
'};',
'',
'var getRds = function(){',
'    return apex.widget.regionDisplaySelector( rdsId );',
'};',
'',
'// hide empty columns',
'( function () {',
'    var hideGreaterThan = parseInt( $v(''P3120_PARSED_COLUMN_COUNT'') ) + 1,',
'        emptyColId;',
'',
'        for ( i = hideGreaterThan; i <= 100; i++ ) {',
'            emptyColId = getColId( i );',
'            toggleCol( emptyColId, false );',
'        }',
'',
'})();',
'',
'// replace column count placeholders in header text of parsed data preview region',
'$( "#placeholder_P3120_PARSED_COLUMN_COUNT" ).text( $v( "P3120_PARSED_COLUMN_COUNT" ) );',
'$( "#placeholder_P3120_PARSED_ROW_COUNT" ).text( $v( "P3120_PARSED_ROW_COUNT" ) );',
'',
'// Setting items hide/show based on RDS',
'var s_col$ = $(''.tab-columns''),',
'    s_prev$ = $(''.tab-preview'');',
'',
'$( ''body'' ).on( ''atabsactivate'', function(){',
'    var id = getRds().getActiveTab().href;',
'    ',
'    if ( id.indexOf( ''columns'' ) > 0 ) {',
'        s_col$.show();',
'        s_prev$.hide();',
'    } else {',
'        s_col$.hide();',
'        s_prev$.show();',
'    }',
'});',
'',
'// checkboxes',
'( function () {',
'',
'    var checkboxes$ = $( ''input[name=f01]'' ),',
'        checkAll$   = $( ''#toggle-select-all-columns'' );',
'',
'    var checkAllState = function(){',
'        checkAll$.prop( ''checked'', checkboxes$.length === $( ''input[name=f01]:checked'' ).length );',
'    };',
'',
'    checkAll$.on( ''click'', function () {',
'        var isAllChecked = checkAll$.is( '':checked'' );',
'        checkboxes$.prop( ''checked'', isAllChecked )',
'    });',
'',
'    // init check state on load',
'    checkAllState();',
'})();',
'',
'$( apex.gPageContext$ ).on( ''apexreadyend'', function() {',
'    setTimeout(function(){',
'       var rds$ = getRds(),',
'        selection = ''#'' + apex.item(''P3120_ACTION'').getValue();',
'        tab$ = rds$.tabs[ selection ];',
'        if ( tab$ ) {',
'            tab$.makeActive();',
'        } ',
'    }, 250);',
'});'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16752054697154301)
,p_name=>'Save Settings'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3942483089766704)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16752168781154302)
,p_event_id=>wwv_flow_imp.id(16752054697154301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P3120_FIRST_LINE,P3120_MAX_ROW_COUNT,P3120_XLSX_SHEET,P3120_CSV_COL_DELIMITER,P3120_CSV_ENCLOSED,P3120_FILE_CHARSET'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16752707403154308)
,p_event_id=>wwv_flow_imp.id(16752054697154301)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16768954447310903)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_FIRST_LINE'
,p_condition_element=>'P3120_FIRST_LINE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEADERS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16769015705310904)
,p_event_id=>wwv_flow_imp.id(16768954447310903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16769134660310905)
,p_event_id=>wwv_flow_imp.id(16768954447310903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4264029006082524)
,p_name=>'Refresh on Col Delimiter Changed'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_CSV_COL_DELIMITER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4264194567082525)
,p_event_id=>wwv_flow_imp.id(4264029006082524)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4264258126082526)
,p_name=>'Refresh on CSV Enclosed Changed'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_CSV_ENCLOSED'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4264376498082527)
,p_event_id=>wwv_flow_imp.id(4264258126082526)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16811073562400490)
,p_name=>'Confirm "All Rows" for large files'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_MAX_ROW_COUNT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P3120_FILE_SIZE") >= 2097152 && $v("P3120_MAX_ROW_COUNT") === "0"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16811926756400496)
,p_event_id=>wwv_flow_imp.id(16811073562400490)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_MAX_ROW_COUNT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3120_PREV_MAX_ROW_COUNT")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16812473388400496)
,p_event_id=>wwv_flow_imp.id(16811073562400490)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_PREV_MAX_ROW_COUNT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3120_MAX_ROW_COUNT")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16813924321400497)
,p_event_id=>wwv_flow_imp.id(16811073562400490)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_COLUMN'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16811426661400495)
,p_event_id=>wwv_flow_imp.id(16811073562400490)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Sampling all rows can take a while for larger files. Do you really want to sample the whole file?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16812990982400496)
,p_event_id=>wwv_flow_imp.id(16811073562400490)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_MAX_ROW_COUNT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16813472577400496)
,p_event_id=>wwv_flow_imp.id(16811073562400490)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_COLUMN'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(117569538954427443)
,p_name=>'Shade Headers on Load'
,p_event_sequence=>100
,p_condition_element=>'P3120_FIRST_LINE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEADERS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(117569990360427477)
,p_event_id=>wwv_flow_imp.id(117569538954427443)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(117570493134427479)
,p_event_id=>wwv_flow_imp.id(117569538954427443)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").removeClass("first-row-headers");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(117570855192429166)
,p_name=>'Shade Headers for XML, JSON and ICS'
,p_event_sequence=>110
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not ( lower(:P3100_FILE) like ''%.csv'' or',
'lower(:P3100_FILE) like ''%.txt'' or',
'lower(:P3100_FILE) like ''%.xls_'' )'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(117571250469429167)
,p_event_id=>wwv_flow_imp.id(117570855192429166)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(137427955810428905)
,p_name=>'Refresh on charset change'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_FILE_CHARSET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(137428031631428906)
,p_event_id=>wwv_flow_imp.id(137427955810428905)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20813061159966803)
,p_name=>'Refresh on Trim Whitespace change'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_TRIM_WHITESPACE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20813154193966804)
,p_event_id=>wwv_flow_imp.id(20813061159966803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_PREVIEW'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(137427833294428904)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Action Type (Preview or Column Mapping)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :REQUEST = ''REFRESH_PREVIEW'' then',
'  :P3120_ACTION := ''tab_preview'';',
'elsif :REQUEST = ''REFRESH_COLUMN'' then',
'  :P3120_ACTION := ''tab_columns'';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>137427833294428904
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(856315813437359250)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Collection when Rows to Sample Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REFRESH_COLUMN'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Column Mapping information cleared and resampled.'
,p_internal_uid=>856315813437359250
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3942624774766706)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New Table - Save Column Load Checkbox'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile           clob;',
'    l_col_selected      boolean := false;',
'    l_mapped_col_cnt    pls_integer := 0;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    -- loop through all column postions',
'    for i in 1 .. wwv_flow.g_f06.count',
'    loop',
'        ',
'        for j in 1 .. wwv_flow.g_f01.count',
'        loop',
'            -- if column checked to load, save the column configuration',
'            if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'',
'                wwv_flow_collection.add_member(',
'                    p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'                    p_c001            => wwv_flow.g_f06( i ), -- column position',
'                    p_c002            => wwv_flow.g_f02( i ), -- column name',
'                    p_c003            => wwv_flow.g_f03( i ), -- format mask',
'                    p_c004            => wwv_flow.g_f04( i ), -- group char',
'                    p_c005            => wwv_flow.g_f05( i ), -- decimal char',
'                    p_c006            => wwv_flow.g_f07( i ), -- column type',
'                    p_c007            => case when wwv_flow.g_f07( i ) = ''VARCHAR2'' then wwv_flow.g_f08( i ) end  -- max length',
'                    );',
'',
'                exit;',
'            end if;',
'        end loop;',
'    end loop;',
'        ',
'    select clob001',
'    into l_profile ',
'    from wwv_flow_collections ',
'    where collection_name = ''APEX$DATALOAD'' ',
'    and rownum = 1;',
'    ',
'    for i in (',
'        select column_position, column_name',
'        from table( wwv_flow_data_parser.get_columns( l_profile ) ) c ) ',
'    loop',
'        if wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0 then',
'            l_col_selected := true;',
'        else',
'            l_col_selected := false;',
'            for l_select_col in (',
'                select c001 idx ',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS'' )',
'            loop',
'                begin',
'                    if to_number( l_select_col.idx ) = i.column_position then',
'                        l_col_selected := true;',
'                        exit;',
'                    end if;',
'                exception when invalid_number then null; ',
'                end;',
'            end loop;',
'        end if;',
'        ',
'        if l_col_selected then',
'            l_mapped_col_cnt := l_mapped_col_cnt + 1;',
'        end if;',
'    end loop;',
'    ',
'    :P3100_MAPPED_COLUMN_COUNT := l_mapped_col_cnt;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3942483089766704)
,p_process_when=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>3942624774766706
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(82703578316738108)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Existing Table - Save Column Mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_map    wwv_flow_global.vc_map := wwv_flow_global.c_empty_vc_map;',
'begin    ',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    wwv_flow_collection.add_members(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'        p_c001            => wwv_flow.g_f01,  -- column_name',
'        p_c002            => wwv_flow.g_f02,  -- mapped column',
'        p_c003            => wwv_flow.g_f03,  -- format mask',
'        p_c004            => wwv_flow.g_f04,  -- group char',
'        p_c005            => wwv_flow.g_f05   -- decimal char           ',
'        );',
'    ',
'    -- get column mapping user configured',
'    for l_configure in (',
'        select',
'            c001   column_name,',
'            c002   mapped_column',
'        from wwv_flow_collections',
'        where collection_name = ''APEX$DATALOAD_COLUMNS''',
'        and c002 is not null )',
'    loop',
'        l_column_map( l_configure.column_name ) := l_configure.mapped_column;',
'    end loop;',
'',
'    --',
'    -- if no column has been mapped, clear the collection, so that APEX can automatically',
'    -- map columns again when "save" changes is clicked. This prevents columns from being',
'    -- doubled in the collection (bug #32405712)',
'    --',
'    if l_column_map.count = 0 then',
'        wwv_flow_collection.truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    end if;         ',
'    ',
'    :P3100_MAPPED_COLUMN_COUNT := l_column_map.count;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3942483089766704)
,p_process_when=>'coalesce( :P3100_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>82703578316738108
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3719233401479850)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3100_FIRST_LINE        := ( case when :P3120_FIRST_LINE is null then ''CHANGE_TO_NULL'' else :P3120_FIRST_LINE end );',
':P3100_MAX_ROW_COUNT     := :P3120_MAX_ROW_COUNT;',
':P3100_XLSX_SHEET        := :P3120_XLSX_SHEET;',
':P3100_CSV_COL_DELIMITER := :P3120_CSV_COL_DELIMITER;',
':P3100_CSV_ENCLOSED      := :P3120_CSV_ENCLOSED;',
':P3100_FILE_CHARSET      := :P3120_FILE_CHARSET;',
':P3100_SHOW_CONFIG_SAVED := ''Y'';'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3942483089766704)
,p_internal_uid=>3719233401479850
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(16454432416013407)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3942483089766704)
,p_internal_uid=>16454432416013407
);
end;
/
prompt --application/pages/page_03130
begin
wwv_flow_imp_page.create_page(
 p_id=>3130
,p_name=>'Object Store'
,p_alias=>'OBJECT-STORE'
,p_step_title=>'Object Store'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function setFileName( pFileName ) {',
'    var lTypeAvro    = "1",',
'        lTypeParquet = "2",',
'        lTypeOther   = "3",',
'        lFileType;',
'    ',
'    function setExternalTableName() {',
'        var lTableName;',
'',
'        if ( lFileType === lTypeAvro ) {',
'            lTableName = pFileName.substr( 0, pFileName.indexOf(".avro"));',
'        } else if ( lFileType === lTypeParquet ) {',
'            lTableName = pFileName.substr( 0, pFileName.indexOf(".parquet"));',
'        } ',
'',
'        if ( lTableName ) {',
'            if ( lTableName.indexOf( "/" ) !== -1 ) {',
'                lTableName = lTableName.substr( lTableName.lastIndexOf( "/" ) + 1 );',
'            }',
'            $s("P3130_EXTERNAL_TABLE_NAME", lTableName.toUpperCase().replace(/[\s-\"\''.,#*+%&\/:;<>=)(]/g, "_") + "_EXT");',
'        }',
'    }',
'',
'    if ( pFileName.substr( -5 ).toLowerCase() === ".avro" ) {',
'        lFileType = lTypeAvro;',
'    } else if ( pFileName.substr( -8 ).toLowerCase() === ".parquet") {',
'        lFileType = lTypeParquet;',
'    } else {',
'        lFileType = lTypeOther;',
'    }',
'    ',
'    if ( $v("P3130_FILE_NAME") === "" ) {',
'        $s( "P3130_FILE_NAME", pFileName );',
'        $s( "P3130_FILE_TYPE", lFileType );',
'        setExternalTableName();',
'    } else {',
'        if ( $v("P3130_FILE_TYPE") === lTypeOther ) {',
'            $s( "P3130_FILE_NAME", pFileName );  ',
'            $s( "P3130_FILE_TYPE", lFileType );',
'            if ( lFileType !== lTypeOther ) {',
'                setExternalTableName();',
'            }',
'        } else {',
'            if ( ( "," + $v("P3130_FILE_NAME") + ",").indexOf( "," + pFileName + "," ) === -1 ) {',
'                $s("P3130_FILE_NAME", $v("P3130_FILE_NAME") + "," + pFileName );',
'            }',
'        }',
'    }',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1900876712643901)
,p_plug_name=>'Object Store References'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Form--labelsAbove:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Choose an existing reference to an <em>Object Store</em> in order to load data. An object store reference consists of an URL and credential information.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2101503916493910)
,p_plug_name=>'Object Store Files '
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1202011154678505)
,p_plug_name=>'Store cannot be accessed.'
,p_parent_plug_id=>wwv_flow_imp.id(2101503916493910)
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'APEX cannot access the object store. Please check the endpoint URL and your authentication credentials.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1903884742643931)
,p_plug_name=>'File Listing'
,p_parent_plug_id=>wwv_flow_imp.id(2101503916493910)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--simple:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name, ',
'       wwv_flow_escape.js_literal( object_name, null ) as file_name_js, ',
'       bytes, ',
'       checksum, ',
'       coalesce( last_modified, created ) as last_modified ',
'  from table( wwv_dbms_cloud.list_files( ',
'                  p_remote_server_id => :P3130_REMOTE_SERVER_ID,',
'                  p_schema           => :P3130_SCHEMA ) )',
' where :P3130_REMOTE_SERVER_ID is not null and :P3130_CAN_ACCESS_STORE = 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P3130_REMOTE_SERVER_ID,P3130_SCHEMA,P3130_CAN_ACCESS_STORE'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2102155945493916)
,p_no_data_found_message=>'No files found.'
,p_allow_report_saving=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_finder_drop_down=>'N'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_help=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>2102155945493916
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2102200753493917)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Object Name'
,p_column_link=>'javascript:setFileName(''#FILE_NAME_JS#'');'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2102336445493918)
,p_db_column_name=>'FILE_NAME_JS'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'File Name Js'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2102483050493919)
,p_db_column_name=>'BYTES'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Size'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2102544543493920)
,p_db_column_name=>'CHECKSUM'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Checksum'
,p_allow_sorting=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2102690461493921)
,p_db_column_name=>'LAST_MODIFIED'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Last Modified'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2220577563013311)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'22206'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OBJECT_NAME:BYTES:LAST_MODIFIED:CHECKSUM:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1904405065643937)
,p_plug_name=>'Load File from Object Store'
,p_parent_plug_id=>wwv_flow_imp.id(2101503916493910)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2877329203080424)
,p_plug_name=>'Other items'
,p_parent_plug_id=>wwv_flow_imp.id(1904405065643937)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2192246260655622)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page allows to load Avro or Parquet files from external data sources (Object Store) into your database schema.</p>',
'<p>&PRODUCT_NAME. uses the <strong>DBMS_CLOUD</strong> package to provide <em>External Tables</em> on top of external files. Data can be copied from the external table to a normal table, but external tables can also be queried directly.</p>',
'<p><a href="&SYSTEM_HELP_URL." target="_blank">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2102866548493923)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(2877329203080424)
,p_button_name=>'CREATE_EXTTAB'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create External Table'
,p_button_position=>'BELOW_BOX'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2877017327080421)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(2877329203080424)
,p_button_name=>'LOAD_USING_APEX'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Import File'
,p_button_position=>'BELOW_BOX'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1905039762643943)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1900876712643901)
,p_button_name=>'CREATE_REFERENCE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Create New'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3131:&SESSION.::&DEBUG.:RP,3131::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2193236526655632)
,p_branch_name=>'Go To Page 3140'
,p_branch_action=>'f?p=&APP_ID.:3140:&SESSION.::&DEBUG.:RP,3140:P3140_EXTERNAL_TABLE_NAME,P3140_SCHEMA:&P3130_EXTERNAL_TABLE_NAME.,&P3130_SCHEMA.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2102866548493923)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2877534565080426)
,p_branch_name=>'Go To Page 3100'
,p_branch_action=>'f?p=&APP_ID.:3100:&SESSION.:UPLOAD_FILE:&DEBUG.:RP:P3100_FILE,P3100_SOURCE_TYPE,P3100_FIRST_LINE:&P3130_DOWNLOADED_FILE.,FILE,HEADERS&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2877017327080421)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1203691355678521)
,p_branch_action=>'f?p=&APP_ID.:3131:&SESSION.::&DEBUG.:RP,3131:P3131_REMOTE_SERVER_ID:&P3130_REMOTE_SERVER_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_REMOTE_SERVER'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2192328040655623)
,p_branch_name=>'Go To Page 3132'
,p_branch_action=>'f?p=&APP_ID.:3132:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_dbms_cloud.check_prerequisites(coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)) != ''SUCCESS'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1201722483678502)
,p_name=>'P3130_CAN_ACCESS_STORE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1900876712643901)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1903629324643929)
,p_name=>'P3130_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1900876712643901)
,p_prompt=>'Object Store Reference'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon a-Button--pillEnd" onclick="void(0);" aria-label="Edit" type="button" id="P3130_EDIT_REMOTE_SERVER_ID" aria-controls="search-container" title="Clear"><span class="a-Icon ico'
||'n-edit" aria-hidden="true"></span></button>',
''))
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LOV_OBJECTSTORE_REFERENCES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, base_url, cloud_credential_name from wwv_remote_servers',
'where security_group_id = :WORKSPACE_ID',
'and server_type = ''CLOUD_OBJECT_STORE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>100
,p_tag_attributes=>'style="width: 100%"'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_08=>'1024'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1904584935643938)
,p_name=>'P3130_FILE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1904405065643937)
,p_prompt=>'File Name Pattern'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon a-Button--pillEnd" onclick="void(0);" aria-label="Clear" type="button" id="P3130_EXTERNAL_TABLE_CLEAR" aria-controls="search-container" title="Clear"><span class="a-Icon ico'
||'n-remove" aria-hidden="true"></span></button>',
''))
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Comma-delimited list of source file URIs. You can use wildcards in the file names in your URIs. The character "*" can be used as the wildcard for multiple characters, the character "?" can be used as the wildcard for a single character.',
'</p>',
'<p>',
'The format of the URIs depend on the Cloud Object Storage service you are using, for details see <strong>DBMS_CLOUD</strong> Package File URI Formats. It''s recommended to avoid special characters like "%", spaces or "/" in file names.',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1904664145643939)
,p_name=>'P3130_EXTERNAL_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2877329203080424)
,p_prompt=>'External Table Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a name for the external table to create. The name must not be taken for another table in the &P3130_SCHEMA!HTML. schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1904744737643940)
,p_name=>'P3130_FILE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2877329203080424)
,p_prompt=>'File Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Avro;1,Parquet;2,Other;3'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Pick the file type of the chosen object store files. For <strong>Parquet</strong> and <strong>Avro</strong> files, APEX creates an external table first, then data is copied from the external table to the target table. Other files are downloaded t'
||'o APEX and then processed by the APEX engine as they were uploaded in SQL Workshop, Load Data.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2100734287493902)
,p_name=>'P3130_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(387994680244652086)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Name of the database schema owner'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2105290202493947)
,p_name=>'P3130_SERVER_URL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1900876712643901)
,p_prompt=>'URL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2877821137080429)
,p_name=>'P3130_DOWNLOADED_FILE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2877329203080424)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2905595021173305)
,p_name=>'P3130_SCHEMA_FROM_FILE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2877329203080424)
,p_item_default=>'FIRST'
,p_prompt=>'Derive Data Definition'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:First File;FIRST,All Files;ALL'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'     The external table columns and data types are automatically derived from the Parquet or Avro file. The column names will match those found in Parquet or Avro. The data types are converted from Parquet or Avro data types to Oracle data types. All'
||' columns are added to the table.',
'',
'</p>',
'<p>',
'   <strong>First</strong> specifies to use the metadata from the first Parquet or Avro file, <strong>All</strong> to use metadata from all Parquet or Avro files to generate the columns and their data types. Use <strong>First</strong> if all of the fi'
||'les have the same schema. Use <strong>All</strong> (slower) if the files may have different schemas.    ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1905703553643950)
,p_computation_sequence=>10
,p_computation_item=>'P3130_EXTERNAL_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P3130_EXTERNAL_TABLE_NAME)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2100994821493904)
,p_computation_sequence=>10
,p_computation_item=>'P3130_SCHEMA'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1201872722678503)
,p_computation_sequence=>20
,p_computation_item=>'P3130_CAN_ACCESS_STORE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when wwv_dbms_cloud.can_access_objectstore( ',
'    p_schema           => :P3130_SCHEMA,',
'    p_remote_server_id => :P3130_REMOTE_SERVER_ID ) then 1 else 0 end'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2877616550080427)
,p_validation_name=>'External Table Name NOT NULL'
,p_validation_sequence=>10
,p_validation=>'P3130_EXTERNAL_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(2102866548493923)
,p_associated_item=>wwv_flow_imp.id(1904664145643939)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2912855128299828)
,p_validation_name=>'ext table name not > 30 (11g) or > 128 (12.2)'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if length(:P3130_EXTERNAL_TABLE_NAME) > wwv_flow_global.c_dbms_id_length then',
'  return wwv_flow_lang.system_message(''F4300.TABLE_NAMES_NOT_LONGER_THAN_30'',wwv_flow_global.c_dbms_id_length);',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P3140_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2102866548493923)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(90119211027448641)
,p_validation_name=>'External Table names must not contain invalid chars'
,p_validation_sequence=>20
,p_validation=>'P3130_EXTERNAL_TABLE_NAME'
,p_validation2=>'#&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# must not contain #,  &, <, >, ", /, ;, *, |, =, % or , character.',
''))
,p_when_button_pressed=>wwv_flow_imp.id(2102866548493923)
,p_associated_item=>wwv_flow_imp.id(1904664145643939)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1201690132678501)
,p_validation_name=>'File Name Pattern NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P3130_FILE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(2102866548493923)
,p_associated_item=>wwv_flow_imp.id(1904584935643938)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2905492312173304)
,p_validation_name=>'External table does not exist'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_tables',
' where table_name = :P3130_EXTERNAL_TABLE_NAME',
'   and owner      = :P3130_SCHEMA'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# is already in use. Please choose another.'
,p_when_button_pressed=>wwv_flow_imp.id(2102866548493923)
,p_associated_item=>wwv_flow_imp.id(1904664145643939)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(705985525998195105)
,p_validation_name=>'Valid File for Import to APEX'
,p_validation_sequence=>50
,p_validation=>'substr( lower( :P3130_FILE_NAME ), instr( :P3130_FILE_NAME, ''.'', -1 ) ) in (''.js'', ''.json'', ''.geojson'', ''.csv'', ''.tsv'', ''.txt'', ''.xml'', ''.xlsx'', ''.xlsm'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Only CSV, XLSX, XML or JSON files can be imported to APEX.'
,p_when_button_pressed=>wwv_flow_imp.id(2877017327080421)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2101093844493905)
,p_name=>'Clear External Table Name'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P3130_EXTERNAL_TABLE_CLEAR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2101167113493906)
,p_event_id=>wwv_flow_imp.id(2101093844493905)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_FILE_NAME,P3130_EXTERNAL_TABLE_NAME,P3130_FILE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2101332584493908)
,p_name=>'Clear File Name List on ESC'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_FILE_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.keyCode===27'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keydown'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2101430570493909)
,p_event_id=>wwv_flow_imp.id(2101332584493908)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_FILE_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2101765437493912)
,p_name=>'Refresh File Listing'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_REMOTE_SERVER_ID'
,p_condition_element=>'P3130_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1203282970678517)
,p_event_id=>wwv_flow_imp.id(2101765437493912)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P3130_EDIT_REMOTE_SERVER_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1203157882678516)
,p_event_id=>wwv_flow_imp.id(2101765437493912)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P3130_EDIT_REMOTE_SERVER_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2105371194493948)
,p_event_id=>wwv_flow_imp.id(2101765437493912)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2105484613493949)
,p_event_id=>wwv_flow_imp.id(2101765437493912)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2101930804493914)
,p_event_id=>wwv_flow_imp.id(2101765437493912)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2101503916493910)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2102009481493915)
,p_event_id=>wwv_flow_imp.id(2101765437493912)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2101503916493910)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1201954281678504)
,p_event_id=>wwv_flow_imp.id(2101765437493912)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_CAN_ACCESS_STORE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when wwv_dbms_cloud.can_access_objectstore( ',
'    p_schema           => :P3130_SCHEMA,',
'    p_remote_server_id => :P3130_REMOTE_SERVER_ID ) then 1 else 0 end    '))
,p_attribute_07=>'P3130_REMOTE_SERVER_ID,P3130_SCHEMA'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2101803975493913)
,p_event_id=>wwv_flow_imp.id(2101765437493912)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1903884742643931)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2105536067493950)
,p_event_id=>wwv_flow_imp.id(2101765437493912)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SERVER_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url from wwv_remote_servers where id=:P3130_REMOTE_SERVER_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_attribute_07=>'P3130_REMOTE_SERVER_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2905765540173307)
,p_name=>'File Name changed'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_FILE_NAME'
,p_condition_element=>'P3130_FILE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2905851822173308)
,p_event_id=>wwv_flow_imp.id(2905765540173307)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2877329203080424)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2905955362173309)
,p_event_id=>wwv_flow_imp.id(2905765540173307)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2877329203080424)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2876588630080416)
,p_name=>'File Type Chosen'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_FILE_TYPE'
,p_condition_element=>'P3130_FILE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'3'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2876613373080417)
,p_event_id=>wwv_flow_imp.id(2876588630080416)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SCHEMA_FROM_FILE,P3130_EXTERNAL_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2877208402080423)
,p_event_id=>wwv_flow_imp.id(2876588630080416)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2877017327080421)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2876722057080418)
,p_event_id=>wwv_flow_imp.id(2876588630080416)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2102866548493923)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2876938615080420)
,p_event_id=>wwv_flow_imp.id(2876588630080416)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2102866548493923)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2876870003080419)
,p_event_id=>wwv_flow_imp.id(2876588630080416)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3130_SCHEMA_FROM_FILE,P3130_EXTERNAL_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2877111754080422)
,p_event_id=>wwv_flow_imp.id(2876588630080416)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2877017327080421)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1202169364678506)
,p_name=>'Show / Hide alert'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3130_CAN_ACCESS_STORE'
,p_condition_element=>'P3130_CAN_ACCESS_STORE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1202296339678507)
,p_event_id=>wwv_flow_imp.id(1202169364678506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1202011154678505)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1202899518678513)
,p_event_id=>wwv_flow_imp.id(1202169364678506)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1904405065643937)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1202564739678510)
,p_event_id=>wwv_flow_imp.id(1202169364678506)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1903884742643931)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1202746406678512)
,p_event_id=>wwv_flow_imp.id(1202169364678506)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1903884742643931)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1202471705678509)
,p_event_id=>wwv_flow_imp.id(1202169364678506)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1202011154678505)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1202622226678511)
,p_event_id=>wwv_flow_imp.id(1202169364678506)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1904405065643937)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1203455162678519)
,p_name=>'Edit Remote Server'
,p_event_sequence=>100
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P3130_EDIT_REMOTE_SERVER_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1203582696678520)
,p_event_id=>wwv_flow_imp.id(1203455162678519)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EDIT_REMOTE_SERVER'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(705985356104195103)
,p_name=>'Click CREATE_EXTTAB'
,p_event_sequence=>110
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2102866548493923)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(705985413980195104)
,p_event_id=>wwv_flow_imp.id(705985356104195103)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE_EXTTAB'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1904972753643942)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create External Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_dbms_cloud.create_external_table(',
'        p_schema               => :P3130_SCHEMA,',
'        p_remote_server_id     => :P3130_REMOTE_SERVER_ID,',
'        --',
'        p_filename_pattern     => :P3130_FILE_NAME,',
'        p_file_type            => :P3130_FILE_TYPE,',
'        p_schema_from_file     => :P3130_SCHEMA_FROM_FILE,',
'        p_external_table_name  => :P3130_EXTERNAL_TABLE_NAME);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2102866548493923)
,p_process_success_message=>'External table &P3130_EXTERNAL_TABLE_NAME. created.'
,p_internal_uid=>1904972753643942
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2877496402080425)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Using APEX'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_name varchar2(32767);',
'begin',
'    l_name := wwv_dbms_cloud.download_file_to_apex(',
'                  p_schema            => :P3130_SCHEMA,',
'                  p_remote_server_id  => :P3130_REMOTE_SERVER_ID,',
'                  p_filename          => :P3130_FILE_NAME );',
'                  ',
'    :P3130_DOWNLOADED_FILE := l_name;',
'    ',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD_COLUMNS'' );',
'    wwv_flow_session_state.clear_state_for_page( p_page_id => 3100 );',
'    wwv_flow_session_state.clear_state_for_page( p_page_id => 3110 );',
'    wwv_flow_session_state.clear_state_for_page( p_page_id => 3120 );',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2877017327080421)
,p_process_success_message=>'File downloaded.'
,p_internal_uid=>2877496402080425
);
end;
/
prompt --application/pages/page_03131
begin
wwv_flow_imp_page.create_page(
 p_id=>3131
,p_name=>'Create / Edit Object Store Reference'
,p_alias=>'CREATE-EDIT-OBJECT-STORE-REFERENCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Object Store Reference'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2103195561493926)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4066085671696583)
,p_plug_name=>'Object Store Reference'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_imp.id(717419707883820782)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1204002492678525)
,p_plug_name=>'Credentials'
,p_parent_plug_id=>wwv_flow_imp.id(4066085671696583)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1205300436678538)
,p_plug_name=>'USER_CREDENTIAL'
,p_parent_plug_id=>wwv_flow_imp.id(1204002492678525)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2103400135493929)
,p_plug_name=>'Username / Password'
,p_parent_plug_id=>wwv_flow_imp.id(1204002492678525)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2878479318080435)
,p_plug_name=>'Web Credential'
,p_parent_plug_id=>wwv_flow_imp.id(1204002492678525)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4266277708546587)
,p_plug_name=>'OCI Native Credentials'
,p_parent_plug_id=>wwv_flow_imp.id(1204002492678525)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2103321713493928)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2103195561493926)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1204301951678528)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2103195561493926)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_button_condition=>'P3131_REMOTE_SERVER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2103281067493927)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2103195561493926)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1204218416678527)
,p_branch_name=>'Go To Page 3130'
,p_branch_action=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:RP:P3130_REMOTE_SERVER_ID:&P3131_REMOTE_SERVER_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2103281067493927)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1204691689678531)
,p_branch_name=>'Go To Page 3130'
,p_branch_action=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:RP:P3130_REMOTE_SERVER_ID:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1204301951678528)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1203764282678522)
,p_name=>'P3131_KEEP_CREDENTIALS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4066085671696583)
,p_item_default=>'Y'
,p_prompt=>'Keep Credentials'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P3131_REMOTE_SERVER_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When the object store reference is changed, decide whether to keep the existing credentials or whether to enter new credentials. When deleting the object store reference, this indicates whether the credentials should be kept or not.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1204931142678534)
,p_name=>'P3131_CREATE_WEB_CREDENTIAL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1204002492678525)
,p_prompt=>'Create As Web Credential'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Whether to store the credentials in the APEX credential store as well. ',
'</p>',
'<p>Note that the DBMS_CLOUD credential store is independent from APEX Web Credentials and there is no automatic synchronization between these.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1205479260678539)
,p_name=>'P3131_USER_CREDENTIAL_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1205300436678538)
,p_prompt=>'DBMS_CLOUD Credential'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>'select column_value d, column_value r from table(wwv_dbms_cloud.list_credentials( p_schema => :P3130_SCHEMA ))'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select - '
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick an existing DBMS_CLOUD credential (USER_CREDENTIALS view). The <a rel="noopener noreferrer" href="https://www.oracle.com/pls/topic/lookup?ctx=en/cloud/paas/autonomous-data-warehouse-cloud&id=CSWHU-GUID-742FC365-AA09-48A8-922C-1987795CF36A" targe'
||'t="_blank">DBMS_CLOUD documentation</a> contains more information.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2103535823493930)
,p_name=>'P3131_USERNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2103400135493929)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the user name to authenticate with.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2103642320493931)
,p_name=>'P3131_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2103400135493929)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Provide the password to authenticate with.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104752109493942)
,p_name=>'P3131_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4066085671696583)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2163694961052673)
,p_name=>'P3131_SERVER_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4066085671696583)
,p_prompt=>'Reference Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a name under which the server URL and the credential information is stored.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2164010878052681)
,p_name=>'P3131_SERVER_URL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4066085671696583)
,p_prompt=>'URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the URL to the object store bucket. Refer to the <a rel="noopener noreferrer" href="https://www.oracle.com/pls/topic/lookup?ctx=en/cloud/paas/autonomous-data-warehouse-cloud&id=CSWHU-GUID-5D3E1614-ADF2-4DB5-B2B2-D5613F10E4FA" target="_bla'
||'nk">DBMS_CLOUD package documentation</a> for more information about Object Store URL formats.',
'</p>',
'<p>',
'    If your source files reside on the <strong>Oracle Cloud Infrastructure Object Storage</strong>, you can use Oracle Cloud Infrastructure native URIs with the format as follows (do not append the file name to the URL):',
'</p>',
'<p>',
'    <code>https://objectstorage.<em>region</em>.oraclecloud.com/n/<em>namespace-string</em>/b/<em>bucket</em>/o/</code>',
'</p>',
'<p>',
'    If the object store supports folders and the folder is part of this URL, then only files from within that folder will be visible for data loading.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2164426432052681)
,p_name=>'P3131_CREDENTIAL_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1204002492678525)
,p_item_default=>'USERPASS'
,p_prompt=>'Credential Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Username/Password;USERPASS,OCI Native;OCI,Web Credential;APEX,DBMS_CLOUD Credential;USER_CREDENTIALS'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_css_classes=>'data-load-input apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Choose the authentication type.',
'</p>',
'<ul>',
'    <li><strong>Username/Password</strong>: Authenticate to the object store using simple Username and Password.</li>',
'    <li><strong>OCI Native Authentication</strong>: Authenticate using OCI User ID, OCI Tenancy ID, private key and public key fingerprint.</li>',
'    <li><strong>Existing Web Credential</strong>: This allows to reuse an existing credential created in Workspace Utilities, Web Credentials. Note that only existing Web Credentials of the <strong>Basic</strong> (for Username/Password) or <strong>OC'
||'I Native</strong> authentication types can be used here. A new DBMS_CLOUD credential will be created using information stored as the APEX Web Credentials.</li>',
'    <li><strong>DBMS_CLOUD Credential</strong>: Use an already existing DBMS_CREDENTIAL (entries from USER_CREDENTIALS view).</li>',
'</ul>',
'<p>',
'    ',
'</p>',
'<p>Note that the DBMS_CLOUD credential store is independent from APEX Web Credentials and there is no automatic synchronization between these.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2165184719052683)
,p_name=>'P3131_USER_OCID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4266277708546587)
,p_prompt=>'User OCID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the Oracle Cloud Infrastructure <em>User OCID</em>. &PRODUCT_NAME. does not store this information encrypted.</p> <p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm'
||'">Oracle Cloud Infrastructure Documentation</a></p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2165534380052684)
,p_name=>'P3131_TENANCY_OCID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4266277708546587)
,p_prompt=>'Tenancy OCID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Cloud Infrastructure <em>Tenancy''s OCID</em>.</p>',
'<p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a></p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2165901304052684)
,p_name=>'P3131_PRIVATE_KEY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4266277708546587)
,p_prompt=>'Private Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Enter the private key in PEM format for OCI authentication. &PRODUCT_NAME. stores this information encrypted and secure, so it cannot be retrieved back in clear text.</p><p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.orac'
||'le.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a></p>'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2166372571052684)
,p_name=>'P3131_FINGERPRINT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4266277708546587)
,p_prompt=>'Fingerprint'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the <em>public RSA key fingerprint</em> for OCI authentication. </p><p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a'
||'></p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2879472190080445)
,p_name=>'P3131_WEB_CREDENTIAL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2878479318080435)
,p_prompt=>'Web Credential'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'WEB_CREDENTIALS_FOR_DBMS_CLOUD'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       authentication_type,',
'       client_id',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID',
'   and authentication_type in (''OCI'', ''BASIC'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Pick an already existing <strong>Web Credential</strong>, which has been configured in Application Builder, Workspace Utilities, Web Credentials. This credential information will be used to create a new <strong>DBMS_CLOUD</strong> object store cr'
||'edential. DBMS_CLOUD object store credentials and APEX Web Credentials are not kept in sync, so the object store credentials must be updated once the APEX Web Credential changes.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2191139061655611)
,p_validation_name=>'USER_OCID required'
,p_validation_sequence=>10
,p_validation=>'P3131_USER_OCID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''OCI'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2103281067493927)
,p_associated_item=>wwv_flow_imp.id(2165184719052683)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2191257913655612)
,p_validation_name=>'TENANCY_OCID required'
,p_validation_sequence=>20
,p_validation=>'P3131_TENANCY_OCID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''OCI'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2103281067493927)
,p_associated_item=>wwv_flow_imp.id(2165534380052684)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2191415915655614)
,p_validation_name=>'PRIVATE_KEY required'
,p_validation_sequence=>30
,p_validation=>'P3131_PRIVATE_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''OCI'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2103281067493927)
,p_associated_item=>wwv_flow_imp.id(2165901304052684)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2191502498655615)
,p_validation_name=>'FINGERPRINT required'
,p_validation_sequence=>40
,p_validation=>'P3131_FINGERPRINT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''OCI'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2103281067493927)
,p_associated_item=>wwv_flow_imp.id(2166372571052684)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2191602326655616)
,p_validation_name=>'USERNAME required'
,p_validation_sequence=>50
,p_validation=>'P3131_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''USERPASS'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2103281067493927)
,p_associated_item=>wwv_flow_imp.id(2103535823493930)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2191883032655618)
,p_validation_name=>'PASSWORD required'
,p_validation_sequence=>60
,p_validation=>'P3131_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''USERPASS'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2103281067493927)
,p_associated_item=>wwv_flow_imp.id(2103642320493931)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2879523972080446)
,p_validation_name=>'Web Credential required'
,p_validation_sequence=>70
,p_validation=>'P3131_WEB_CREDENTIAL_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P3131_CREDENTIAL_TYPE = ''APEX'' and ( :P3131_KEEP_CREDENTIALS = ''N'' or :P3131_REMOTE_SERVER_ID is null )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2103281067493927)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2191994420655619)
,p_validation_name=>'SERVER_NAME not already taken'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'  from wwv_remote_servers',
' where name              = :P3130_SERVER_NAME',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Name for the Object Store reference is already taken.'
,p_when_button_pressed=>wwv_flow_imp.id(2103281067493927)
,p_associated_item=>wwv_flow_imp.id(2163694961052673)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2192128889655621)
,p_validation_name=>'URL starts with HTTPS'
,p_validation_sequence=>90
,p_validation=>'lower(substr(:P3131_SERVER_URL, 1, 8 ) ) = ''https://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Server URL must begin with https://'
,p_when_button_pressed=>wwv_flow_imp.id(2103281067493927)
,p_associated_item=>wwv_flow_imp.id(2164010878052681)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2103769877493932)
,p_name=>'Username/Password'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_CREDENTIAL_TYPE'
,p_condition_element=>'P3131_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'USERPASS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2103826160493933)
,p_event_id=>wwv_flow_imp.id(2103769877493932)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2103400135493929)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1205086266678535)
,p_event_id=>wwv_flow_imp.id(2103769877493932)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3131_CREATE_WEB_CREDENTIAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2103964024493934)
,p_event_id=>wwv_flow_imp.id(2103769877493932)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4266277708546587)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2878525171080436)
,p_event_id=>wwv_flow_imp.id(2103769877493932)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2878479318080435)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1205519896678540)
,p_event_id=>wwv_flow_imp.id(2103769877493932)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1205300436678538)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2877911363080430)
,p_name=>'OCI Native'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_CREDENTIAL_TYPE'
,p_condition_element=>'P3131_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2878269961080433)
,p_event_id=>wwv_flow_imp.id(2877911363080430)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2103400135493929)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1205151616678536)
,p_event_id=>wwv_flow_imp.id(2877911363080430)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3131_CREATE_WEB_CREDENTIAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2878692193080437)
,p_event_id=>wwv_flow_imp.id(2877911363080430)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2878479318080435)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1205671717678541)
,p_event_id=>wwv_flow_imp.id(2877911363080430)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1205300436678538)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2878335156080434)
,p_event_id=>wwv_flow_imp.id(2877911363080430)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4266277708546587)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2878908061080440)
,p_name=>'Web Credential'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_CREDENTIAL_TYPE'
,p_condition_element=>'P3131_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'APEX'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2879099008080441)
,p_event_id=>wwv_flow_imp.id(2878908061080440)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2103400135493929)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1205213844678537)
,p_event_id=>wwv_flow_imp.id(2878908061080440)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3131_CREATE_WEB_CREDENTIAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2879159033080442)
,p_event_id=>wwv_flow_imp.id(2878908061080440)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4266277708546587)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1205709819678542)
,p_event_id=>wwv_flow_imp.id(2878908061080440)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1205300436678538)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2879260129080443)
,p_event_id=>wwv_flow_imp.id(2878908061080440)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2878479318080435)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1205840013678543)
,p_name=>'USER_CREDENTIAL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_CREDENTIAL_TYPE'
,p_condition_element=>'P3131_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'USER_CREDENTIALS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1205969341678544)
,p_event_id=>wwv_flow_imp.id(1205840013678543)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2103400135493929)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1206060693678545)
,p_event_id=>wwv_flow_imp.id(1205840013678543)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3131_CREATE_WEB_CREDENTIAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1206169682678546)
,p_event_id=>wwv_flow_imp.id(1205840013678543)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4266277708546587)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1206223719678547)
,p_event_id=>wwv_flow_imp.id(1205840013678543)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2878479318080435)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1206300617678548)
,p_event_id=>wwv_flow_imp.id(1205840013678543)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1205300436678538)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2104288091493937)
,p_name=>'Compute Remote Server Name'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_SERVER_URL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2104349707493938)
,p_event_id=>wwv_flow_imp.id(2104288091493937)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'try {',
'    $s("P3131_SERVER_NAME", $v("P3131_SERVER_URL").replace(/^https?:\/\//, "").replace(/(.*)(\/.*)/, "$1").replace(/[.#_$\/]/g,"-") );',
'} catch ( e ) {}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1203814159678523)
,p_name=>'Show / Hide Credentials'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3131_KEEP_CREDENTIALS'
,p_condition_element=>'P3131_KEEP_CREDENTIALS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1203936594678524)
,p_event_id=>wwv_flow_imp.id(1203814159678523)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1204002492678525)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1204116077678526)
,p_event_id=>wwv_flow_imp.id(1203814159678523)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1204002492678525)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1204763374678532)
,p_name=>'Cancel Dialog'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2103321713493928)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1204841585678533)
,p_event_id=>wwv_flow_imp.id(1204763374678532)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2104599819493940)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Object Store Reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_remote_server_id number;',
'begin',
'    if :P3131_REMOTE_SERVER_ID is not null and :P3131_KEEP_CREDENTIALS = ''N'' then',
'        wwv_dbms_cloud.drop_objectstore_reference(',
'            p_schema           => :P3130_SCHEMA,',
'            p_remote_server_id => :P3131_REMOTE_SERVER_ID );',
'    end if;',
'',
'    if :P3131_REMOTE_SERVER_ID is not null and :P3131_KEEP_CREDENTIALS = ''Y'' then',
'        update wwv_remote_servers ',
'           set name     = :P3131_SERVER_NAME,',
'               base_url = :P3131_SERVER_URL',
'         where security_group_id = :WORKSPACE_ID',
'           and id                = :P3131_REMOTE_SERVER_ID;',
'    end if;',
'    ',
'    if :P3131_REMOTE_SERVER_ID is null or :P3131_KEEP_CREDENTIALS = ''N'' then',
'',
'        if :P3131_CREDENTIAL_TYPE = ''USERPASS'' then',
'            l_remote_server_id := wwv_dbms_cloud.create_objectstore_reference(',
'                p_schema                => :P3130_SCHEMA,',
'                p_server_name           => :P3131_SERVER_NAME,',
'                p_server_url            => :P3131_SERVER_URL,',
'                --',
'                p_create_web_credential => ( :P3131_CREATE_WEB_CREDENTIAL = ''Y'' ),',
'                --',
'                p_username              => :P3131_USERNAME,',
'                p_password              => :P3131_PASSWORD ); ',
'        elsif :P3131_CREDENTIAL_TYPE = ''OCI'' then',
'            l_remote_server_id := wwv_dbms_cloud.create_objectstore_reference(',
'                p_schema                => :P3130_SCHEMA,',
'                p_server_name           => :P3131_SERVER_NAME,',
'                p_server_url            => :P3131_SERVER_URL,',
'                --',
'                p_create_web_credential => ( :P3131_CREATE_WEB_CREDENTIAL = ''Y'' ),',
'                --',
'                p_user_ocid             => :P3131_USER_OCID,',
'                p_tenancy_ocid          => :P3131_TENANCY_OCID,',
'                p_private_key           => :P3131_PRIVATE_KEY,',
'                p_fingerprint           => :P3131_FINGERPRINT );         ',
'        elsif :P3131_CREDENTIAL_TYPE = ''USER_CREDENTIALS'' then',
'            l_remote_server_id := wwv_dbms_cloud.create_objectstore_reference(',
'                p_schema                => :P3130_SCHEMA,',
'                p_server_name           => :P3131_SERVER_NAME,',
'                p_server_url            => :P3131_SERVER_URL,',
'                --',
'                p_credential_name       => :P3131_USER_CREDENTIAL_NAME );                ',
'        else',
'            l_remote_server_id := wwv_dbms_cloud.create_objectstore_reference(',
'                p_schema        => :P3130_SCHEMA,',
'                p_server_name   => :P3131_SERVER_NAME,',
'                p_server_url    => :P3131_SERVER_URL,',
'                --',
'                p_credential_id => :P3131_WEB_CREDENTIAL_ID );        ',
'        end if;',
'        :P3131_REMOTE_SERVER_ID := l_remote_server_id;',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2103281067493927)
,p_process_success_message=>'Object Store Reference saved.'
,p_internal_uid=>2104599819493940
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1204583928678530)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Object Store Reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_dbms_cloud.drop_objectstore_reference(',
'        p_schema           => :P3130_SCHEMA,',
'        p_remote_server_id => :P3131_REMOTE_SERVER_ID,',
'        p_drop_credential  => nvl( :P3131_KEEP_CREDENTIALS, ''N'' ) = ''N'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1204301951678528)
,p_process_success_message=>'Object Store Reference deleted.'
,p_internal_uid=>1204583928678530
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1203374519678518)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Remote Server'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select name,',
'           base_url',
'      into :P3131_SERVER_NAME,',
'           :P3131_SERVER_URL',
'      from wwv_remote_servers',
'     where security_group_id = :WORKSPACE_ID',
'       and id                = :P3131_REMOTE_SERVER_ID;',
'exception',
'    when NO_DATA_FOUND then',
'        :P3131_REMOTE_SERVER_ID := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P3131_REMOTE_SERVER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>1203374519678518
);
end;
/
prompt --application/pages/page_03132
begin
wwv_flow_imp_page.create_page(
 p_id=>3132
,p_name=>'Object Store Loading not available'
,p_alias=>'OBJECT-STORE-LOADING-NOT-AVAILABLE'
,p_step_title=>'Object Store Loading not available'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2192588139655625)
,p_plug_name=>'Data Loading from Object Store not available'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'htp.p(wwv_flow_lang.system_message(v(''P3132_DBMS_CLOUD_STATUS''), :P3132_SCHEMA));',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2193034261655630)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page allows to load Avro or Parquet files from external data sources (Object Store) into your database schema.</p>',
'<p>&PRODUCT_NAME. uses the <strong>DBMS_CLOUD</strong> package to provide <em>External Tables</em> on top of external files. Data can be copied from the external table to a normal table, but external tables can also be queried directly.</p>',
'<p><a href="&SYSTEM_HELP_URL." target="_blank">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2193131108655631)
,p_branch_action=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_dbms_cloud.check_prerequisites(coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)) = ''SUCCESS'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2192646721655626)
,p_name=>'P3132_DBMS_CLOUD_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2192588139655625)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2192825895655628)
,p_name=>'P3132_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(387994680244652086)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2192792665655627)
,p_computation_sequence=>10
,p_computation_item=>'P3132_DBMS_CLOUD_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_dbms_cloud.check_prerequisites(coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema))'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2192906107655629)
,p_computation_sequence=>20
,p_computation_item=>'P3132_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)'
);
end;
/
prompt --application/pages/page_03140
begin
wwv_flow_imp_page.create_page(
 p_id=>3140
,p_name=>'Load from External Table'
,p_alias=>'LOAD-FROM-EXTERNAL-TABLE'
,p_step_title=>'Load from External Table'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'div#configureColumns {',
'    margin-left: calc(30% + 8px);',
'    box-shadow: none;',
'    margin-right: 16px;',
'    margin-top: 4px;',
'    margin-bottom: 4px;',
'}',
'',
'#configureColumns .a-Alert-body {',
'  margin: 0;',
'}',
'',
'div#configureColumns .a-Alert-icon, ',
'div#configureColumns .a-Alert-content, ',
'div#configureColumns .a-Alert-buttons {',
'  padding: 8px 0;',
'}',
'',
'div#configureColumns .a-Alert-buttons {',
'    padding: 8px;',
'}',
'',
'div#configureColumns .a-Report-cell {',
'  padding: 0 8px;',
'  background-color: transparent;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2193332767655633)
,p_name=>'External table &P3140_EXTERNAL_TABLE_NAME!HTML.'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_loader_dev.get_preview_query(',
'           p_table_owner    => :P3140_SCHEMA,',
'           p_table_name     => :P3140_EXTERNAL_TABLE_NAME );',
'           '))
,p_optimizer_hint=>'APEX$USE_NO_PAGINATION'
,p_header=>'This preview shows up to 15 columns and 10 rows. Click the <strong>View in Object Browser</strong> button to review the table in Object Browser.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_plug_query_max_columns=>15
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_string.join(',
'           wwv_flow_data_loader_dev.get_column_names(',
'               p_table_owner    => :P3140_SCHEMA,',
'               p_table_name     => :P3140_EXTERNAL_TABLE_NAME ), '':'' );',
'           '))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>10
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'External Table is empty.'
,p_query_row_count_max=>10
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
,p_plug_query_parse_override=>'P3140_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2193489325655634)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2193510128655635)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2193649711655636)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2193768725655637)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2193841769655638)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2193961119655639)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2194001358655740)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2194115840655741)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2194272133655742)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2194378931655743)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2194432990655744)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2194593359655745)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2194610202655746)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2194701190655747)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2194820707655748)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2618318283013901)
,p_plug_name=>'Load Data'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2621380151013931)
,p_plug_name=>'Additional Fields'
,p_parent_plug_id=>wwv_flow_imp.id(2618318283013901)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(85416193196169617)
,p_name=>'Configure Information'
,p_region_name=>'configureColumns'
,p_parent_plug_id=>wwv_flow_imp.id(2618318283013901)
,p_template=>wwv_flow_imp.id(746376253838324384)
,p_display_sequence=>10
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_icon_css_classes=>'icon-report'
,p_region_template_options=>'a-Alert--colorBG:a-Alert--noIcon:a-Alert--info:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--noBorders'
,p_region_attributes=>'style="display: none;"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_info           varchar2(32767);',
'    l_mapped_col_cnt number;',
'    l_file_col_cnt   number;',
'begin',
'    l_mapped_col_cnt := to_number(:P3140_MAPPED_COLUMN_COUNT);',
'    l_file_col_cnt := to_number(:P3140_FILE_COLUMN_COUNT);',
'    ',
'    if :P3140_LOAD_TO = ''EXISTING'' then',
'        if l_mapped_col_cnt = 0 then',
'            l_info := wwv_flow_lang.system_message( ''DATA.LOAD.DEFINE_COL_MAPPING'', wwv_flow_escape.html( :P3140_EXISTING_TABLE_NAME ) );',
'        else',
'            if l_mapped_col_cnt = l_file_col_cnt then',
'                l_info := wwv_flow_lang.system_message( ''DATA.LOAD.ALL_COL_MAPPED'', :P3140_FILE_COLUMN_COUNT, wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME ) );',
'            elsif l_mapped_col_cnt < l_file_col_cnt then',
'                l_info := wwv_flow_lang.system_message( ''DATA.LOAD.MAP_REMAINING_COLS'', :P3140_MAPPED_COLUMN_COUNT, :P3140_FILE_COLUMN_COUNT, wwv_flow_escape.html( :P3140_EXISTING_TABLE_NAME ) );',
'            end if;',
'        end if;',
'    else',
'        l_info := wwv_flow_lang.system_message(''DATA.LOAD.SELECT_COLS'');',
'    end if;',
'',
'    return ''select ''||wwv_flow_assert.enquote_literal(l_info)||'' info from sys.dual'';',
'end;'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P3140_LOAD_TO,P3140_EXISTING_TABLE_NAME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2713617939431532)
,p_query_column_id=>1
,p_column_alias=>'INFO'
,p_column_display_sequence=>1
,p_column_heading=>'Info'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2619609080013914)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page shows contents of the external table, based on object store files and allows to copy rows from the external table to a normal table in the APEX workspace schema. As an alternative, applications can also use the external table directly. H'
||'owever, external table access is typically slower than normal table access. Also, external tables cannot be indexed. ',
'</p>',
'<p>For frequent access to the data it''s thus recommended to load data into a normal table in the Orace Database. Instead of using this wizard, that process can also be done by using SQL Statements in <strong>SQL Commands</strong>.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2906149752173311)
,p_name=>'Active Data Loading Jobs'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    substr( j.job_name, 18 ) as dataload_job_id,',
'    j.state,',
'    j.start_date,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,2,''i'',2 ) as workspace_user,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,3,''i'',2 ) as table_owner,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,4,''i'',2 ) as table_name',
' from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'  and c.display_name = :COMPANY  ',
'  and j.state = ''RUNNING''',
'  and job_name like ''ORACLE_APEX_DTLD$%''',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select 1',
' from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'  and c.display_name = :COMPANY  ',
'  and j.state = ''RUNNING''',
'  and job_name like ''ORACLE_APEX_DTLD$%'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2906231349173312)
,p_query_column_id=>1
,p_column_alias=>'DATALOAD_JOB_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Job ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2906344075173313)
,p_query_column_id=>2
,p_column_alias=>'STATE'
,p_column_display_sequence=>2
,p_column_heading=>'Job State'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2906421180173314)
,p_query_column_id=>3
,p_column_alias=>'START_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Started'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2906591469173315)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_USER'
,p_column_display_sequence=>4
,p_column_heading=>'Workspace User'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2906610800173316)
,p_query_column_id=>5
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>5
,p_column_heading=>'Table Owner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2906753539173317)
,p_query_column_id=>6
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2619446273013912)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2618318283013901)
,p_button_name=>'VIEW_TABLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Exit to Object Browser'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:RP,2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:&P3140_SCHEMA.,&P3140_OBJECT_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2619165209013909)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2618318283013901)
,p_button_name=>'LOAD_DATA'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Load Data to Local Table'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2714014474431537)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(85416193196169617)
,p_button_name=>'CONFIGURE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Configure'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3142:&SESSION.::&DEBUG.:RP,3142:P3120_ACTION:tab_columns'
,p_icon_css_classes=>'icon-open-in-dialog margin-left-sm'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2619854071013916)
,p_branch_name=>'Go To Page 3141'
,p_branch_action=>'f?p=&APP_ID.:3141:&SESSION.::&DEBUG.:RP:P3141_LOAD_TO,P3141_TABLE_OWNER:&P3140_LOAD_TO.,&P3140_SCHEMA.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2619165209013909)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P3140_MONITOR_PROGRESS'
,p_branch_condition_text=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(150091984209895807)
,p_branch_action=>'f?p=&APP_ID.:3140:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2619165209013909)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P3140_MONITOR_PROGRESS'
,p_branch_condition_text=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2875468341080405)
,p_branch_name=>'Go To Page 3130'
,p_branch_action=>'f?p=&APP_ID.:3130:&SESSION.::&DEBUG.:RP,3130,3140,3131::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2875695788080407)
,p_branch_action=>'f?p=&APP_ID.:3132:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_dbms_cloud.check_prerequisites(coalesce( :P3130_SCHEMA, wwv_flow_user_api.get_default_schema)) != ''SUCCESS'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2194955174655749)
,p_name=>'P3140_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(387994680244652086)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2195098390655750)
,p_name=>'P3140_EXTERNAL_TABLE_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2621380151013931)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2618591561013903)
,p_name=>'P3140_LOAD_TO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2618318283013901)
,p_item_default=>'NEW'
,p_prompt=>'Load into'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P3100_LOAD_TO'
,p_lov=>'.'||wwv_flow_imp.id(60089930390905970)||'.'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether to load into a new or existing table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2618641343013904)
,p_name=>'P3140_NEW_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2618318283013901)
,p_prompt=>'New Table Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the table name you would like to create. By default, all table names are converted to upper case.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2619280072013910)
,p_name=>'P3140_OBJECT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2621380151013931)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620124113013919)
,p_name=>'P3140_MAPPED_COLUMN_COUNT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2621380151013931)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2620256188013920)
,p_name=>'P3140_FILE_COLUMN_COUNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2621380151013931)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2621861215013936)
,p_name=>'P3140_UPDATE_METHOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2621380151013931)
,p_item_default=>'APPEND'
,p_prompt=>'Update Method'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Append;APPEND,Replace;REPLACE'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>Append</strong> If data already exists in the table, the wizard appends the new rows into the table. If data does not exist, the new rows are simply loaded.</li>',
'    <li><strong>Replace</strong> The entire table is replaced by deleting the table first and then loading the new rows into the table.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2621964383013937)
,p_name=>'P3140_ERROR_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2618318283013901)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the error table name you would like to save errors during data load. By default, all table names are converted to upper case.  If data load succeeds without any error, this error table is dropped automatically.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2622374790013941)
,p_name=>'P3140_MONITOR_PROGRESS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2621380151013931)
,p_item_default=>'Y'
,p_prompt=>'Monitor Progress'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If enabled, data loading will allow to monitor data loading progress by committing after a batch of rows. If disabled, all data will be inserted in one transaction, which is normally faster, but which does not allow to monitor loading progress.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2622444770013942)
,p_name=>'P3140_SUCCESS_MSG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(2621380151013931)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2711467497285822)
,p_name=>'P3140_EXISTING_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2618318283013901)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name a, table_name b',
'  from sys.dba_tables',
' where owner=:P3140_SCHEMA',
'   and table_name not like ''BIN$%'' ',
'   and external = ''NO''',
' order by table_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P3100_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the database table you would like to load data into.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2906981461173319)
,p_name=>'P3140_COMMIT_INTERVAL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2621380151013931)
,p_item_default=>'5000'
,p_prompt=>'Commit Interval'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:2K;2000,5K;5000,10K;10000,50K;50000,100K;100000'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify after how many loaded rows APEX should execute a COMMIT.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150091820683895806)
,p_name=>'P3140_DROP_EXTERNAL_TABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2621380151013931)
,p_item_default=>'Y'
,p_prompt=>'Drop External Table after Load'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If enabled, the external table will be dropped after data loading.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1905419549643947)
,p_computation_sequence=>10
,p_computation_item=>'P3140_NEW_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P3140_NEW_TABLE_NAME)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1905527064643948)
,p_computation_sequence=>20
,p_computation_item=>'P3140_ERROR_TABLE_NAME'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_loader_dev.get_error_table_name(',
'    p_table_owner => :P3140_TABLE_OWNER,',
'    p_table_name  => (',
'                     case when :P3140_LOAD_TO = ''NEW'' then',
'                         :P3140_NEW_TABLE_NAME',
'                     when :P3140_LOAD_TO = ''EXISTING'' then',
'                         :P3140_EXISTING_TABLE_NAME',
'                     end) );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2619398941013911)
,p_computation_sequence=>10
,p_computation_item=>'P3140_OBJECT_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id',
'  from dba_objects',
' where owner = :P3140_SCHEMA',
'   and object_type = ''TABLE''',
'   and object_name = :P3140_EXTERNAL_TABLE_NAME'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1905676080643949)
,p_validation_name=>'External Table still exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from sys.dba_tables',
' where owner = :P3140_SCHEMA',
'   and table_name = :P3140_EXTERNAL_TABLE_NAME'))
,p_validation_type=>'EXISTS'
,p_error_message=>'External table &P3140_EXTERNAL_TABLE_NAME!HTML. does not exist any more.'
,p_when_button_pressed=>wwv_flow_imp.id(2619165209013909)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2910481948183552)
,p_validation_name=>'new table name not > 30 (11g) or > 128 (12.2)'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if length(:P3140_NEW_TABLE_NAME) > wwv_flow_global.c_dbms_id_length then',
'  return wwv_flow_lang.system_message(''F4300.TABLE_NAMES_NOT_LONGER_THAN_30'',wwv_flow_global.c_dbms_id_length);',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P3140_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2619165209013909)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2905360278173303)
,p_validation_name=>'New Table name is required'
,p_validation_sequence=>40
,p_validation=>'P3140_NEW_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P3140_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2619165209013909)
,p_associated_item=>wwv_flow_imp.id(2618641343013904)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(90119319564448642)
,p_validation_name=>'Table names must not contain invalid chars'
,p_validation_sequence=>50
,p_validation=>'P3140_NEW_TABLE_NAME'
,p_validation2=>'#&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'#LABEL# must not contain #,  &, <, >, ", /, ;, *, |, =, % or , character.'
,p_validation_condition=>'P3140_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2619165209013909)
,p_associated_item=>wwv_flow_imp.id(2618641343013904)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2907092600173320)
,p_validation_name=>'Commit Interval is not null'
,p_validation_sequence=>60
,p_validation=>'P3140_COMMIT_INTERVAL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P3140_MONITOR_PROGRESS'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2619165209013909)
,p_associated_item=>wwv_flow_imp.id(2906981461173319)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2619913988013917)
,p_name=>'Existing Table chosen'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3140_EXISTING_TABLE_NAME'
,p_condition_element=>'P3140_EXISTING_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620023735013918)
,p_event_id=>wwv_flow_imp.id(2619913988013917)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_profile clob;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );        ',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD'' );',
'',
'    l_file_profile := wwv_flow_data_parser.profile_to_json( wwv_flow_data_loader_dev.get_profile_from_table( :P3140_SCHEMA, :P3140_EXTERNAL_TABLE_NAME ));',
'    wwv_flow_data_loader_dev.build_column_mapping_coll(',
'        p_file_profile_json => l_file_profile,',
'        p_load_to_owner     => :P3140_SCHEMA,',
'        p_load_to_table     => :P3140_EXISTING_TABLE_NAME );',
'    wwv_flow_collection.add_member( p_collection_name => ''APEX$DATALOAD'', p_clob001 => l_file_profile );',
'        ',
'    select count(c001) file_columns, ',
'           count(c002) mapped_columns',
'      into :P3140_FILE_COLUMN_COUNT,',
'           :P3140_MAPPED_COLUMN_COUNT',
'      from wwv_flow_collections',
'     where collection_name = ''APEX$DATALOAD_COLUMNS'';',
'end;'))
,p_attribute_02=>'P3140_SCHEMA,P3140_EXISTING_TABLE_NAME,P3140_EXTERNAL_TABLE_NAME'
,p_attribute_03=>'P3140_MAPPED_COLUMN_COUNT,P3140_FILE_COLUMN_COUNT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620534062013923)
,p_event_id=>wwv_flow_imp.id(2619913988013917)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(85416193196169617)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620446465013922)
,p_event_id=>wwv_flow_imp.id(2619913988013917)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(85416193196169617)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620324571013921)
,p_event_id=>wwv_flow_imp.id(2619913988013917)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(85416193196169617)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2620629076013924)
,p_name=>'New or existing'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3140_LOAD_TO'
,p_condition_element=>'P3140_LOAD_TO'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620753443013925)
,p_event_id=>wwv_flow_imp.id(2620629076013924)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_NEW_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2623174441013949)
,p_event_id=>wwv_flow_imp.id(2620629076013924)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_UPDATE_METHOD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620801064013926)
,p_event_id=>wwv_flow_imp.id(2620629076013924)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_EXISTING_TABLE_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2621297025013930)
,p_event_id=>wwv_flow_imp.id(2620629076013924)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_EXISTING_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620986005013927)
,p_event_id=>wwv_flow_imp.id(2620629076013924)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_EXISTING_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2621147057013929)
,p_event_id=>wwv_flow_imp.id(2620629076013924)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_EXISTING_TABLE_NAME,P3140_NEW_TABLE_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2621035050013928)
,p_event_id=>wwv_flow_imp.id(2620629076013924)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_NEW_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2623052974013948)
,p_event_id=>wwv_flow_imp.id(2620629076013924)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_UPDATE_METHOD'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2621527909013933)
,p_name=>'Dialog closed'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2714014474431537)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2621663378013934)
,p_event_id=>wwv_flow_imp.id(2621527909013933)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(85416193196169617)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2622639891013944)
,p_name=>'New Table'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3140_NEW_TABLE_NAME'
,p_condition_element=>'P3140_NEW_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2622866778013946)
,p_event_id=>wwv_flow_imp.id(2622639891013944)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_profile clob;',
'begin',
'    l_file_profile := wwv_flow_data_parser.profile_to_json( wwv_flow_data_loader_dev.get_profile_from_table( :P3140_SCHEMA, :P3140_EXTERNAL_TABLE_NAME ));',
'',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD'' );',
'    wwv_flow_collection.add_member( p_collection_name => ''APEX$DATALOAD'', p_clob001 => l_file_profile );',
'        ',
'end;'))
,p_attribute_02=>'P3140_SCHEMA,P3140_NEW_TABLE_NAME,P3140_EXTERNAL_TABLE_NAME'
,p_attribute_03=>'P3140_MAPPED_COLUMN_COUNT,P3140_FILE_COLUMN_COUNT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2622712922013945)
,p_event_id=>wwv_flow_imp.id(2622639891013944)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(85416193196169617)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2622950162013947)
,p_event_id=>wwv_flow_imp.id(2622639891013944)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(85416193196169617)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2907170259173321)
,p_name=>'Show Hide Commit Interval'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3140_MONITOR_PROGRESS'
,p_condition_element=>'P3140_MONITOR_PROGRESS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2907259377173322)
,p_event_id=>wwv_flow_imp.id(2907170259173321)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_COMMIT_INTERVAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2907366118173323)
,p_event_id=>wwv_flow_imp.id(2907170259173321)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3140_COMMIT_INTERVAL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2906897705173318)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Status Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD_STATUS'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2619165209013909)
,p_internal_uid=>2906897705173318
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2619725797013915)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load into new Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.load_to_new_table(',
'    p_source_type       => ''TABLE'',',
'    p_source_schema     => :P3140_SCHEMA,',
'    p_source_name       => :P3140_EXTERNAL_TABLE_NAME,',
'    p_drop_source_table => :P3140_DROP_EXTERNAL_TABLE = ''Y'',',
'    --',
'    p_target_schema     => :P3140_SCHEMA,',
'    p_target_name       => :P3140_NEW_TABLE_NAME,',
'    p_error_table_name  => :P3140_ERROR_TABLE_NAME,',
'    --',
'    p_add_id_column     => false,',
'    --',
'    p_monitor_progress  => :P3140_MONITOR_PROGRESS = ''Y'',',
'    p_commit_interval   => :P3140_COMMIT_INTERVAL,',
'    --',
'    p_load_id           => :P3100_LOAD_ID,',
'    p_message           => :P3140_SUCCESS_MSG );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2619165209013909)
,p_process_when=>'P3140_LOAD_TO'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NEW'
,p_process_success_message=>'&P3140_SUCCESS_MSG.'
,p_internal_uid=>2619725797013915
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2621794321013935)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load into existing table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.load_to_existing_table(',
'    p_source_type      => ''TABLE'',',
'    p_source_schema    => :P3140_SCHEMA,',
'    p_source_name      => :P3140_EXTERNAL_TABLE_NAME,',
'    p_drop_source_table => :P3140_DROP_EXTERNAL_TABLE = ''Y'',    ',
'    --',
'    p_target_schema    => :P3140_SCHEMA,',
'    p_target_name      => :P3140_EXISTING_TABLE_NAME,',
'    p_error_table_name => :P3140_ERROR_TABLE_NAME,',
'',
'    p_skip_rows        => 0,',
'    p_truncate_rows    => ( :P3140_UPDATE_METHOD = ''REPLACE'' ),',
'    --',
'    p_monitor_progress => :P3140_MONITOR_PROGRESS = ''Y'',',
'    p_commit_interval  => :P3140_COMMIT_INTERVAL,',
'    --',
'    p_load_id          => :P3100_LOAD_ID,',
'    p_message          => :P3140_SUCCESS_MSG );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2619165209013909)
,p_process_when=>'P3140_LOAD_TO'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'EXISTING'
,p_process_success_message=>'&P3140_SUCCESS_MSG.'
,p_internal_uid=>2621794321013935
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2875306072080404)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Drop external table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_dbms_cloud.drop_table(',
'        p_schema     => :P3140_SCHEMA,',
'        p_table_name => :P3140_EXTERNAL_TABLE_NAME );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_process_success_message=>'External table &P3140_EXTERNAL_TABLE_NAME!HTML. dropped.'
,p_internal_uid=>2875306072080404
);
end;
/
prompt --application/pages/page_03141
begin
wwv_flow_imp_page.create_page(
 p_id=>3141
,p_name=>'Load Data'
,p_alias=>'LOAD-DATA1'
,p_page_mode=>'MODAL'
,p_step_title=>'Load Data'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Region-headerItems--buttons { white-space: nowrap; }',
'.a-Region-bodyHeader { padding: 12px; margin: 0; border-bottom: 1px solid rgba(0, 0, 0,0.1); background-color: #FFF8E1; color: #202020; }',
''))
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_dialog_height=>'800'
,p_dialog_width=>'960'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4231473388833227)
,p_name=>'Load in Progress'
,p_region_name=>'loadInProgress'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 as status,',
'       n001 as rows_processed ',
'from wwv_flow_collections ',
'where collection_name=''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(385896719135645040)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2636744459490406)
,p_query_column_id=>1
,p_column_alias=>'STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(3891423527523942)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2637147571490407)
,p_query_column_id=>2
,p_column_alias=>'ROWS_PROCESSED'
,p_column_display_sequence=>2
,p_column_heading=>'Rows Processed'
,p_use_as_row_header=>'N'
,p_column_format=>'9G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6848144262546396)
,p_plug_name=>'Load Failed'
,p_region_name=>'loadIncomplete'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>50
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Data loading failed intermittently and is incomplete.',
'<pre id="imcompl_load_error"></pre>',
'Please check the error and try again. <br/>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467921583038983200)
,p_plug_name=>'New Table'
,p_parent_plug_id=>wwv_flow_imp.id(6848144262546396)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Table <code>&P3100_TABLE_NAME!HTML.</code> created! <b id="incompl_success_row_count"></b> rows loaded successfully. <b class="u-danger-text" id="incompl_fail_row_count"></b> rows rejected.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467921657119983201)
,p_plug_name=>'Existing Table'
,p_parent_plug_id=>wwv_flow_imp.id(6848144262546396)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3100_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_INCOMPLETE'', wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME) ) );',
'elsif :P3100_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_INCOMPLETE'',wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7975322082563595)
,p_plug_name=>'Success with Warning'
,p_region_name=>'loadError'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467921143628983196)
,p_plug_name=>'New Table'
,p_parent_plug_id=>wwv_flow_imp.id(7975322082563595)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Table <code>&P3141_TABLE_NAME!HTML.</code> created! <b id="err_success_row_count"></b> rows loaded successfully. <b class="u-danger-text" id="err_fail_row_count"></b> rows rejected.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467921257416983197)
,p_plug_name=>'Existing Table'
,p_parent_plug_id=>wwv_flow_imp.id(7975322082563595)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3140_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_WARNING'', wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME ) ) );',
'elsif :P3140_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_WARNING'', wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME ) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7975594711563597)
,p_plug_name=>'Load Failed'
,p_region_name=>'loadFail'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>40
,p_plug_source=>'The data could not be loaded.  Please check the error and try again.  <b id="fail_row_count"></b> rows failed.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7975679603563598)
,p_plug_name=>'Data Load Success'
,p_region_name=>'loadSuccess'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467921406339983198)
,p_plug_name=>'New Table'
,p_parent_plug_id=>wwv_flow_imp.id(7975679603563598)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Table <code>&P3141_TABLE_NAME!HTML.</code> created with <b id="success_row_count"></b> rows!'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467921439292983199)
,p_plug_name=>'Existing Table'
,p_parent_plug_id=>wwv_flow_imp.id(7975679603563598)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3140_UPDATE_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.APPEND_SUCCESS'', wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME) ) );',
'elsif :P3140_UPDATE_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''DATA.LOAD.REPLACE_SUCCESS'',wwv_flow_escape.html(:P3140_EXISTING_TABLE_NAME) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3141_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(7975736219563599)
,p_name=>'Rejected Rows in &P3140_ERROR_TABLE_NAME!HTML. Table'
,p_region_name=>'failed_rows'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch:a-Report--rowHighlight'
,p_region_attributes=>'style="display: none;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q              varchar2(32767);',
'    l_column_name  varchar2(255);',
'    l_columns      varchar2(32767);',
'    l_profile_json clob;',
'    l_file_profile wwv_flow_data_parser.t_file_profile;',
'begin',
'    ',
'    select clob001 ',
'    into l_profile_json',
'    from wwv_flow_collections',
'    where collection_name = ''APEX$DATALOAD''',
'    and rownum = 1;',
'',
'    -- query upto 10 columns not including CLOB',
'    for l_file in ( ',
'        select column_position, column_name, data_type ',
'        from table( wwv_flow_data_parser.get_columns(l_profile_json ) )',
'        where rownum <= 10',
'        and data_type != ''CLOB'' )',
'    loop',
'        l_column_name := null;',
'',
'        if :P3141_LOAD_TO = ''EXISTING'' then',
'            for l_existing_table in (',
'                select column_name',
'                from sys.dba_tab_columns',
'                where owner = :P3140_SCHEMA',
'                and table_name = :P3140_EXISTING_TABLE_NAME',
'                and column_name = l_file.column_name )',
'            loop',
'                l_column_name := l_existing_table.column_name;',
'            end loop;',
'            -- if column header not used, columns such as c001 mapped to existing column',
'            if l_column_name is null then',
'                for l_configure in (',
'                    select',
'                        c002 mapped_column',
'                    from wwv_flow_collections',
'                    where collection_name = ''APEX$DATALOAD_COLUMNS''',
'                    and c002 is not null',
'                    and c001 = l_file.column_name )',
'                loop',
'                    l_column_name := l_configure.mapped_column;',
'                end loop;',
'            end if;',
'        else',
'            -- validate file columns against newly created table',
'            -- get only the ones created',
'            for l_table in (',
'                select column_name',
'                from sys.dba_tab_columns',
'                where owner = :P3140_SCHEMA',
'                and table_name = :P3140_NEW_TABLE_NAME',
'                and column_name = l_file.column_name )',
'            loop',
'                l_column_name := l_table.column_name;',
'            end loop;',
'        end if;',
'',
'        if l_column_name is not null then',
'            l_columns := l_columns ||case when l_columns is not null then '','' end || l_column_name;',
'        end if;',
'    end loop;',
'   ',
'    q := ''select ORA_ERR_MESG$ as error_message''|| ',
'         (case when l_columns is not null then '',''|| l_columns end ) ||',
'         '' from ''||wwv_flow_assert.enquote_name( :P3140_ERROR_TABLE_NAME );',
'',
'    return q;',
'end;'))
,p_header=>'All rejected rows are stored in the &P3140_ERROR_TABLE_NAME!HTML. table. The report below shows the first 10 rows.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_plug_query_max_columns=>11
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>10
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
,p_plug_query_parse_override=>'P3140_SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2642474943490437)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2642783184490439)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2643103412490440)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2643597772490441)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2643971737490441)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2644389985490442)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2644722864490443)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2645103567490443)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2645549311490445)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2645910817490445)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2646351133490447)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7977268071563614)
,p_plug_name=>'Load Finished'
,p_region_name=>'load_finished'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11525930126379476)
,p_plug_name=>'Table Information'
,p_region_name=>'table_info'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="timer-container"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11526227405379479)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2652436563490456)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(11526227405379479)
,p_button_name=>'CANCEL'
,p_button_static_id=>'btn_cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2652804813490457)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(11526227405379479)
,p_button_name=>'VIEW_TABLE'
,p_button_static_id=>'viewTableBtn'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'View Table'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:RP,2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:&P3100_TABLE_OWNER.,&P3141_TAB_OBJ_ID.'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2653211373490457)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(11526227405379479)
,p_button_name=>'CREATE_APP'
,p_button_static_id=>'createAppBtn'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:1,5,130,150,170,250:P1_SCHEMA,P1_NEW_TABLE_NAME:&P3141_TABLE_OWNER.,&P3141_TABLE_NAME.'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_imp.id(12506407035221692)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2907407723173324)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(7975736219563599)
,p_button_name=>'DROP_TABLE'
,p_button_static_id=>'dropTableBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Drop Table and Reload'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'style="display: none;"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2647149557490448)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(7975736219563599)
,p_button_name=>'VIEW_ERROR_TABLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_image_alt=>'Open in Object Browser'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:RP,2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:&P3140_SCHEMA.,&P3141_ERR_TAB_OBJ_ID.'
,p_icon_css_classes=>'icon-open-in-dialog'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2653673246490457)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(11526227405379479)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'btn_previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2907854454173328)
,p_branch_action=>'f?p=&APP_ID.:3140:&SESSION.::&DEBUG.:RP,3141,3142::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2907407723173324)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2637521218490412)
,p_name=>'P3141_LOAD_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4231473388833227)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2637926336490415)
,p_name=>'P3141_LOAD_ERROR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4231473388833227)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2638379139490416)
,p_name=>'P3141_PROCESSED_ROW_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4231473388833227)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2638776512490418)
,p_name=>'P3141_PROCESSED_ROW_CNT_DISP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4231473388833227)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2647839701490450)
,p_name=>'P3141_LOAD_TO'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7977268071563614)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2648222651490451)
,p_name=>'P3141_TABLE_CREATED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(7977268071563614)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2648623641490451)
,p_name=>'P3141_TAB_OBJ_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(7977268071563614)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2649077941490452)
,p_name=>'P3141_ERR_TAB_OBJ_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(7977268071563614)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2649419661490452)
,p_name=>'P3141_GOOD_ROW_CNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(7977268071563614)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2649835221490452)
,p_name=>'P3141_GOOD_ROW_CNT_DISP'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(7977268071563614)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2650272085490452)
,p_name=>'P3141_BAD_ROW_CNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(7977268071563614)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2650601946490453)
,p_name=>'P3141_BAD_ROW_CNT_DISP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(7977268071563614)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2651388735490454)
,p_name=>'P3141_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11525930126379476)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Owner'
,p_source=>'P3140_TABLE_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2651744536490455)
,p_name=>'P3141_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(11525930126379476)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2654175922490475)
,p_computation_sequence=>10
,p_computation_item=>'P3141_TABLE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3141_LOAD_TO = ''NEW'' then',
'    return :P3140_NEW_TABLE_NAME;',
'elsif :P3141_LOAD_TO = ''EXISTING'' then',
'    return :P3140_EXISTING_TABLE_NAME;',
'end if;'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2655247087490477)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2652436563490456)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2655725505490479)
,p_event_id=>wwv_flow_imp.id(2655247087490477)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2656101624490479)
,p_name=>'Timer for Refresh Progress'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2656677307490480)
,p_event_id=>wwv_flow_imp.id(2656101624490479)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSpinner$ = false;',
'',
'var showFinished = function(){    ',
'    // Hide Table Information',
'    apex.region("table_info").element.hide();',
'',
'    var lLoadTo = apex.item("P3141_LOAD_TO").getValue();',
'    var lTableCreated = apex.item( "P3141_TABLE_CREATED" ).getValue();',
'    var lBadRowCnt = apex.item( "P3141_BAD_ROW_CNT" ).getValue();',
'    var lSuccessRowCnt = apex.item("P3141_GOOD_ROW_CNT").getValue();',
'    var lProcessedRowCnt = apex.item( "P3141_PROCESSED_ROW_CNT" ).getValue();',
'    ',
'    var lBadRowCntDisp = apex.item( "P3141_BAD_ROW_CNT_DISP" ).getValue();',
'    var lSuccessRowCntDisp = apex.item("P3141_GOOD_ROW_CNT_DISP").getValue();',
'    var lProcessedRowCntDisp = apex.item( "P3141_PROCESSED_ROW_CNT_DISP" ).getValue();',
'    ',
'    if (lLoadTo === "NEW") {',
'        if (lTableCreated === "Y") {',
'            apex.jQuery("#viewTableBtn").show();',
'            apex.jQuery("#btn_cancel").hide();',
'        }',
'    } else if (lLoadTo === "EXISTING") {',
'        apex.jQuery("#viewTableBtn").show();',
'    }',
'    ',
'    if ( apex.item("P3141_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'        // show failure region',
'',
'        apex.jQuery("#incompl_success_row_count").text( lSuccessRowCntDisp );',
'        apex.jQuery("#incompl_fail_row_count").text( lBadRowCntDisp );',
'        apex.jQuery("#imcompl_load_error").text( apex.item( "P3141_LOAD_ERROR" ).getValue() );        ',
'        apex.region("loadIncomplete").element.show();',
'        if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'        if (lBadRowCnt > "0") {',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'        }',
'    } else {',
'        ',
'        if ( lBadRowCnt === "0" ) {',
'            // show success region',
'            apex.jQuery("#success_row_count").text( lSuccessRowCntDisp );',
'            apex.region("loadSuccess").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            apex.jQuery("#btn_previous").hide();',
'        } else if ( lSuccessRowCnt > "0" && lBadRowCnt > "0" ) {',
'            // show error region',
'            apex.jQuery("#err_success_row_count").text( lSuccessRowCntDisp );',
'            apex.jQuery("#err_fail_row_count").text( lBadRowCntDisp );',
'            apex.region("loadError").element.show();',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'',
'        } else if ( lBadRowCnt === lProcessedRowCnt ) {',
'            // show failure region',
'            apex.jQuery("#fail_row_count").text( lBadRowCntDisp );',
'            apex.region("loadFail").element.show();',
'            apex.region("failed_rows").refresh()',
'            apex.region("failed_rows").element.show();',
'            if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'        }',
'    }',
' };',
'',
'var triggerRefresh = function(){ ',
'    if ( !lSpinner$ ) {',
'        lSpinner$ = apex.util.showSpinner( $( "#loadInProgress" ) );',
'    }',
'        ',
'    apex.event.trigger( apex.jQuery("#timer-container"), "job_timer" );',
'',
'    if ( apex.item("P3141_LOAD_STATUS").getValue() === ''FINISHED''  || ',
'         apex.item("P3141_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'      clearInterval( refreshInterval );',
'      apex.region("loadInProgress").element.hide();',
'      lSpinner$.remove();',
'      showFinished();',
'    }',
'};',
'',
'var refreshInterval = setInterval( triggerRefresh, 1000);'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2657037056490480)
,p_name=>'Refresh Progress Report on Timer'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#timer-container'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'job_timer'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2657549421490481)
,p_event_id=>wwv_flow_imp.id(2657037056490480)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4231473388833227)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2658068440490482)
,p_event_id=>wwv_flow_imp.id(2657037056490480)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_job_is_running number;',
'begin',
'    for l_load in (',
'        select c001 as status,',
'               c002 as error_message,',
'               n001 as rows_processed ',
'        from wwv_flow_collections ',
'        where collection_name=''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID)',
'    loop',
'        :P3141_LOAD_STATUS       := l_load.status;',
'        :P3141_LOAD_ERROR        := l_load.error_message;',
'        :P3141_PROCESSED_ROW_CNT := l_load.rows_processed;',
'    end loop;',
'',
'    -- if the status is "RUNNING", check whether we really have an active scheduler job',
'    if :P3141_LOAD_STATUS = ''RUNNING'' then',
'        begin',
'            select 1',
'              into l_job_is_running',
'              from user_scheduler_jobs',
'             where job_name like ''ORACLE_APEX_DTLD$%''',
'               and regexp_substr( comments, ''(\:)(.*?)(\:)'',1,5,''i'',2 ) = ''APEX$DATALOAD_STATUS''||:P3100_LOAD_ID',
'               and state = ''RUNNING'';',
'        exception ',
'            when no_data_found then',
'                :P3141_LOAD_STATUS       := ''FAILED'';',
'                :P3141_LOAD_ERROR        := wwv_flow_lang.system_message(''DATA.LOAD.JOB_INTERMITTENTLY_FAILED'');',
'        end;',
'    end if;',
'    ',
'    :P3141_PROCESSED_ROW_CNT_DISP := to_char( :P3141_PROCESSED_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'end;'))
,p_attribute_03=>'P3141_LOAD_STATUS,P3141_PROCESSED_ROW_CNT,P3141_LOAD_ERROR,P3141_PROCESSED_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2658534748490483)
,p_event_id=>wwv_flow_imp.id(2657037056490480)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_table_exists boolean := false;',
'    l_context wwv_flow_exec.t_context;',
'    q varchar2(32767);',
'begin',
'    if :P3141_LOAD_STATUS in (''FAILED'', ''FINISHED'' ) then',
'        if :P3141_LOAD_TO = ''NEW'' then',
'            for l_table in (',
'                select table_name',
'                from sys.dba_tables',
'                where table_name = :P3140_NEW_TABLE_NAME',
'                and owner = :P3140_SCHEMA )',
'            loop',
'                :P3141_TABLE_CREATED := ''Y'';',
'            end loop;',
'        end if;',
'        ',
'        for l_table in (',
'            select table_name',
'            from sys.dba_tables',
'            where table_name = :P3140_ERROR_TABLE_NAME',
'            and owner = :P3140_SCHEMA )',
'        loop',
'            l_error_table_exists := true;',
'        end loop;',
'        ',
'        q := ''with'';',
'        q := q||'' success_data as (select count(*) as cnt from ''||',
'             wwv_flow_assert.enquote_name(',
'                 case when :P3141_LOAD_TO = ''NEW'' then',
'                     :P3140_NEW_TABLE_NAME',
'                 when :P3141_LOAD_TO = ''EXISTING'' then',
'                     :P3140_EXISTING_TABLE_NAME',
'                 end )',
'                 || '')'';',
'        if l_error_table_exists then',
'            q := q||'', failed_data as (select count(*) as cnt from ''||wwv_flow_assert.enquote_name( :P3140_ERROR_TABLE_NAME ) || '')'';',
'        end if;',
'        q := q||'' select s.cnt as success_count'';',
'        if l_error_table_exists then',
'            q := q||'', e.cnt as error_count'';',
'        end if;',
'        q:=q||'' from'';',
'        q:=q||'' success_data s'';',
'        if l_error_table_exists then',
'            q:=q||'', failed_data e'';',
'        end if;',
'     ',
'        wwv_flow_exec.open_query_context(',
'            p_context     => l_context,',
'            p_location    => wwv_flow_exec_api.c_location_local_db,',
'            p_query_type  => wwv_flow_exec_api.c_query_type_sql_query,',
'            p_sql_query   => q,',
'            p_parse_as_schema_override => :P3140_SCHEMA );',
'            ',
'        if wwv_flow_exec.next_row( p_context => l_context ) then',
'            :P3141_GOOD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 1 );',
'            if l_error_table_exists then',
'                :P3141_BAD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 2 );',
'            else',
'                :P3141_BAD_ROW_CNT := 0;',
'            end if;',
'        end if;',
'        ',
'        if :P3141_LOAD_TO = ''EXISTING'' then',
'            :P3141_GOOD_ROW_CNT := :P3141_PROCESSED_ROW_CNT - :P3141_BAD_ROW_CNT;',
'        end if;',
'        ',
'        :P3141_GOOD_ROW_CNT_DISP := to_char( :P3141_GOOD_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'        :P3141_BAD_ROW_CNT_DISP  := to_char( :P3141_BAD_ROW_CNT,  ''999G999G999G999G999G999G990'' );',
'        ',
'        wwv_flow_exec.close_context( p_context => l_context );',
'    end if;',
'exception ',
'    when others then',
'        wwv_flow_exec.close_context( p_context => l_context );',
'        raise;',
'end;'))
,p_attribute_03=>'P3141_GOOD_ROW_CNT,P3141_BAD_ROW_CNT,P3141_TABLE_CREATED,P3141_TAB_OBJ_ID,P3141_GOOD_ROW_CNT_DISP,P3141_BAD_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2907517723173325)
,p_name=>'confirm drop tables'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2907407723173324)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2907674238173326)
,p_event_id=>wwv_flow_imp.id(2907517723173325)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to drop &P3141_TABLE_NAME. and &P3140_ERROR_TABLE_NAME. tables created from the data load?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2907796467173327)
,p_event_id=>wwv_flow_imp.id(2907517723173325)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DROP_TABLE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2654816541490476)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'drop table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_drop1 sys.dbms_sql.varchar2a;',
'    l_drop2 sys.dbms_sql.varchar2a;',
'begin',
'    l_drop1(1) := ''drop table ''||wwv_flow_assert.enquote_name(:P3141_TABLE_NAME);',
'    l_drop2(1) := ''drop table ''||wwv_flow_assert.enquote_name(:P3140_ERROR_TABLE_NAME);',
'    ',
'    wwv_flow_dynamic_exec.run_ddl (',
'        p_sql  => l_drop1,',
'        p_user => :P3140_SCHEMA );',
'   ',
'   wwv_flow_dynamic_exec.run_ddl (',
'        p_sql  => l_drop2,',
'        p_user => :P3140_SCHEMA );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2907407723173324)
,p_internal_uid=>2654816541490476
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2875531313080406)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Object ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_object in (',
'    select object_id, object_name',
'    from sys.dba_objects',
'    where object_name in (:P3140_NEW_TABLE_NAME, :P3140_EXISTING_TABLE_NAME, :P3140_ERROR_TABLE_NAME)',
'    and owner = :P3140_SCHEMA )',
'loop',
'    if l_object.object_name = :P3140_NEW_TABLE_NAME and :P3141_LOAD_TO = ''NEW'' then',
'        :P3141_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3140_EXISTING_TABLE_NAME and :P3141_LOAD_TO = ''EXISTING'' then',
'        :P3141_TAB_OBJ_ID := l_object.object_id;',
'    elsif l_object.object_name = :P3140_ERROR_TABLE_NAME then',
'        :P3141_ERR_TAB_OBJ_ID := l_object.object_id;',
'    end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2875531313080406
);
end;
/
prompt --application/pages/page_03142
begin
wwv_flow_imp_page.create_page(
 p_id=>3142
,p_name=>'Map Columns'
,p_alias=>'MAP-COLUMNS'
,p_page_mode=>'MODAL'
,p_step_title=>'Map Columns'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( function () {',
'',
'    var checkboxes$ = $( ''input[name=f01]'' ),',
'        checkAll$   = $( ''#toggle-select-all-columns'' );',
'',
'    var checkAllState = function(){',
'        checkAll$.prop( ''checked'', checkboxes$.length === $( ''input[name=f01]:checked'' ).length );',
'    };',
'',
'    checkboxes$.on( ''click'', function () {',
'        var that$ = $( this ),',
'            colId = getColId( that$.val() ),',
'            isChecked = that$.prop( ''checked'' );',
'',
'        toggleCol( colId, isChecked );',
'',
'        checkAllState();',
'    });',
'',
'    checkAll$.on( ''click'', function () {',
'        var isAllChecked = checkAll$.is( '':checked'' );',
'',
'        checkboxes$',
'            .prop( ''checked'', isAllChecked )',
'            .each(function(){',
'                var cb$ = $( this );',
'                toggleCol( getColId( cb$.val() ), cb$.prop( ''checked'' ) );  ',
'            });',
'    });',
'',
'    // init check state on load',
'    checkAllState();',
'})();'))
,p_step_template=>wwv_flow_imp.id(690782249755803171)
,p_page_css_classes=>'a-Page--DataLoadPreview'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_dialog_height=>'768'
,p_dialog_width=>'1024'
,p_dialog_chained=>'N'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6668055717333270)
,p_plug_name=>'RDS'
,p_region_name=>'preview_selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6868328816150601)
,p_plug_name=>'Buttons'
,p_region_css_classes=>'u-tC'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22889361361921168)
,p_name=>'Columns to Load'
,p_region_name=>'tab_columns'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'a-DataLoad-previewColumns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with ',
'    l_columns as (',
'        select ',
'            fc.column_position,    ',
'            fc.column_name , ',
'            regexp_replace( fc.data_type, ''\(\d+\)'','''') data_type,',
'            case when substr( fc.data_type, 1, 8 ) = ''VARCHAR2''',
'               then replace( substr( fc.data_type, 10 ), '')'' )',
'               else null',
'            end as max_length,',
'            fc.format_mask,',
'            fc.detected_group_char group_char,',
'            fc.detected_decimal_char decimal_char',
'        from wwv_flow_collections c,',
'             table( wwv_flow_data_parser.get_columns( c.clob001 ) ) fc',
'        where c.collection_name =''APEX$DATALOAD'' ),',
'    l_config_columns as (',
'        select',
'            to_number(s.c001) column_position,',
'            s.c002 column_name,',
'            s.c003 format_mask,',
'            s.c004 group_char,',
'            s.c005 decimal_char,',
'            s.c006 data_type,',
'            s.c007 max_length',
'        from wwv_flow_collections s',
'        where collection_name = ''APEX$DATALOAD_COLUMNS'' )',
'select',
'    c.column_position,',
'    htmldb_item.hidden(',
'        p_idx            => 6,',
'        p_value          => c.column_position )||',
'    htmldb_item.hidden(',
'        p_idx            => 2,',
'        p_value          => c.column_name )||',
'    htmldb_item.checkbox2(',
'        p_idx            => 1,',
'        p_value          => c.column_position,',
'        p_attributes     => ''aria-label="Select Row: ''||wwv_flow_escape.html_attribute(c.column_name)||''"'',',
'        p_checked_values => cf.column_position ) as select_column,   ',
'    c.column_name,',
'    case when cf.data_type = ''CLOB'' then',
'        htmldb_item.display_and_save(',
'            p_idx            => 7,',
'            p_value          => cf.data_type,',
'            p_item_label     => wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name)) )',
'    else',
'        htmldb_item.select_list_from_lov(',
'            p_idx            => 7,',
'            p_value          => cf.data_type,',
'            p_lov            => ''DATA.LOAD.DATA_TYPES'',',
'            p_show_null      => ''NO'',',
'            p_show_extra     => ''NO'',',
'            p_attributes     => case when cf.data_type = ''CLOB'' then ''disabled '' end ||',
'                                ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as data_type,',
'    htmldb_item.text(',
'        p_idx            => 8,',
'        p_value          => cf.max_length,',
'        p_size           => 5,',
'        p_maxLength      => 5,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as max_length,',
'    htmldb_item.text(',
'        p_idx            => 3,',
'        p_value          => cf.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    htmldb_item.text(',
'        p_idx            => 4,',
'        p_value          => cf.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    htmldb_item.text(',
'        p_idx            => 5,',
'        p_value          => cf.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c, l_config_columns cf',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'and  c.column_position = cf.column_position (+)',
'union',
'select',
'    c.column_position,',
'    htmldb_item.hidden(',
'        p_idx            => 6,',
'        p_value          => c.column_position )||',
'    htmldb_item.hidden(',
'        p_idx            => 2,',
'        p_value          => c.column_name )||',
'    htmldb_item.checkbox2(',
'        p_idx            => 1,',
'        p_value          => c.column_position,',
'        p_attributes     => ''aria-label="Select Row: ''||wwv_flow_escape.html_attribute(c.column_name)||''"'',',
'        p_checked_values => c.column_position ) as select_column,    ',
'    c.column_name, ',
'    case when c.data_type = ''CLOB'' then',
'        htmldb_item.display_and_save(',
'            p_idx            => 7,',
'            p_value          => c.data_type,',
'            p_item_label     => wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name)) )',
'    else',
'        htmldb_item.select_list_from_lov(',
'            p_idx            => 7,',
'            p_value          => c.data_type,',
'            p_lov            => ''DATA.LOAD.DATA_TYPES'',',
'            p_show_null      => ''NO'',',
'            p_show_extra     => ''NO'',',
'            p_attributes     => ( case when c.data_type = ''CLOB'' then ''disabled '' end )||',
'                                ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'', wwv_flow_escape.html_attribute(c.column_name))||''"'')',
'    end as data_type,',
'    htmldb_item.text(',
'        p_idx            => 8,',
'        p_value          => c.max_length,',
'        p_size           => 5,',
'        p_maxLength      => 5,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as max_length,',
'    htmldb_item.text(',
'        p_idx            => 3,',
'        p_value          => c.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as format_mask,',
'    htmldb_item.text(',
'        p_idx            => 4,',
'        p_value          => c.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as group_char,',
'    htmldb_item.text(',
'        p_idx            => 5,',
'        p_value          => c.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2,',
'        p_attributes     => ''aria-label="''||wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'', wwv_flow_escape.html_attribute(c.column_name))||''"'') as decimal_char',
'from l_columns c',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0',
'order by 1'))
,p_display_when_condition=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''NEW'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No columns found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2727769881566586)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>53
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2728100161566587)
,p_query_column_id=>2
,p_column_alias=>'SELECT_COLUMN'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" id="toggle-select-all-columns">'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2728556072566588)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2728971934566589)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(94755936775727903)
,p_query_column_id=>5
,p_column_alias=>'MAX_LENGTH'
,p_column_display_sequence=>13
,p_column_heading=>'Max Length'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2729373220566589)
,p_query_column_id=>6
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>23
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2729724797566590)
,p_query_column_id=>7
,p_column_alias=>'GROUP_CHAR'
,p_column_display_sequence=>33
,p_column_heading=>'Group Separator'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2730157525566590)
,p_query_column_id=>8
,p_column_alias=>'DECIMAL_CHAR'
,p_column_display_sequence=>43
,p_column_heading=>'Decimal Character'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(35910098832413211)
,p_plug_name=>'Settings Item Container'
,p_region_css_classes=>'a-ButtonRegion--DataLoadPreview'
,p_region_template_options=>'a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(196066593863714146)
,p_name=>'Column Mapping'
,p_region_name=>'tab_columns'
,p_template=>wwv_flow_imp.id(385770331595976651)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'a-DataLoad-previewColumns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with',
'l_msg as (',
'    select wwv_flow_lang.system_message(''DATA_WORKSHOP.CONFIGURE.UNMAPPED'') unmapped',
'      from sys.dual)',
', l_columns as (',
'    select ',
'        fc.column_position,    ',
'        fc.column_name,',
'            ( select tc.column_name ',
'              from sys.dba_tab_columns tc',
'              where tc.owner = :P3140_SCHEMA',
'              and tc.table_name = :P3140_EXISTING_TABLE_NAME',
'              and tc.column_name = fc.column_name )',
'        map_column_name,',
'        fc.data_type, ',
'        fc.format_mask,',
'        fc.detected_group_char group_char,',
'        fc.detected_decimal_char decimal_char',
'    from wwv_flow_collections c,',
'         table( wwv_flow_data_parser.get_columns( c.clob001 ) ) fc',
'    where c.collection_name =''APEX$DATALOAD'' )',
', l_sum_existing_tab_col as (',
'    select sum( length( ''<option value="''|| column_name ||''">''|| column_name ||'' (''|| data_type ||'')</option>'' ) ) total_length',
'    from sys.dba_tab_columns tc',
'    where tc.owner = :P3140_SCHEMA',
'    and tc.table_name = :P3140_EXISTING_TABLE_NAME )',
'select',
'    c.column_position,',
'    c.column_name,',
'    c.data_type,',
'    htmldb_item.hidden(',
'        p_idx            => 1,',
'        p_value          => c.column_name)||',
'    case when tc.total_length <= 3900 then',
'        htmldb_item.select_list_from_lov(',
'            p_idx            => 2,',
'            p_value          => m.c002,',
'            p_lov            => ''P3142_TABLE_COLUMNS'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_show_extra     => ''NO'')',
'    else',
'        -- bug 30464422 fix, show popup if total existing table column option  > 3900 to avoid error',
'        wwv_flow_item.popup_from_lov(',
'            p_idx            => 2,',
'            p_value          => m.c002,',
'            p_lov_name       => ''P3142_TABLE_COLUMNS'',',
'            p_width          => 40,',
'            p_show_null      => ''YES'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped )',
'    end as column_map,',
'    htmldb_item.text(',
'        p_idx            => 3,',
'        p_value          => m.c003,',
'        p_size           => 20,',
'        p_maxLength      => 1000 ) as format_mask,',
'    htmldb_item.text(',
'        p_idx            => 4,',
'        p_value          => m.c004,',
'        p_size           => 2,',
'        p_maxLength      => 2 ) as group_char,',
'    htmldb_item.text(',
'        p_idx            => 5,',
'        p_value          => m.c005,',
'        p_size           => 2,',
'        p_maxLength      => 2 ) as decimal_char',
'from l_columns c, l_sum_existing_tab_col tc, l_msg msg, wwv_flow_collections m',
'where c.column_name = m.c001 (+)',
'and wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'union',
'select',
'    c.column_position,',
'    c.column_name,',
'    c.data_type, ',
'    htmldb_item.hidden(',
'        p_idx            => 1,',
'        p_value          => c.column_name)||',
'    case when tc.total_length <= 3900 then',
'        htmldb_item.select_list_from_lov(',
'            p_idx            => 2,',
'            p_value          => c.map_column_name,',
'            p_lov            => ''P3142_TABLE_COLUMNS'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped,',
'            p_show_extra     => ''NO'')',
'    else',
'        -- bug 30464422 fix, show popup if total existing table column option  > 3900 to avoid error ',
'        wwv_flow_item.popup_from_lov(',
'            p_idx            => 2,',
'            p_value          => c.map_column_name,',
'            p_lov_name       => ''P3142_TABLE_COLUMNS'',',
'            p_width          => 40,',
'            p_show_null      => ''YES'',',
'            p_null_value     => null,',
'            p_null_text      => msg.unmapped )',
'    end as column_map,',
'    htmldb_item.text(',
'        p_idx            => 3,',
'        p_value          => c.format_mask,',
'        p_size           => 20,',
'        p_maxLength      => 1000 ) as format_mask,',
'    htmldb_item.text(',
'        p_idx            => 4,',
'        p_value          => c.group_char,',
'        p_size           => 2,',
'        p_maxLength      => 2 ) as group_char,',
'    htmldb_item.text(',
'        p_idx            => 5,',
'        p_value          => c.decimal_char,',
'        p_size           => 2,',
'        p_maxLength      => 2 ) as decimal_char        ',
'from l_columns c, l_msg msg, l_sum_existing_tab_col tc',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0',
'order by 1',
''))
,p_display_when_condition=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No columns found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2781051602566683)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_POSITION'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2781426044566686)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Source Column'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2781826747566687)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2782213212566687)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_MAP'
,p_column_display_sequence=>4
,p_column_heading=>'Map To'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2782645018566688)
,p_query_column_id=>5
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>5
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2783080218566689)
,p_query_column_id=>6
,p_column_alias=>'GROUP_CHAR'
,p_column_display_sequence=>6
,p_column_heading=>'Group Separator'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2783473349566689)
,p_query_column_id=>7
,p_column_alias=>'DECIMAL_CHAR'
,p_column_display_sequence=>7
,p_column_heading=>'Decimal Character'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2726636014566580)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6868328816150601)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2727070542566581)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6868328816150601)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Close Dialog'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2739158268566606)
,p_name=>'P3142_ACTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(35910098832413211)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Used for default tab selection on page load'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2784349989566715)
,p_validation_name=>'must at least select one column'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'At least one column must be selected to load.'
,p_when_button_pressed=>wwv_flow_imp.id(2726636014566580)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(81742847338478602)
,p_validation_name=>'check group and decimal char'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_load_to      varchar2(10);',
'    ',
'    l_group_char   varchar2(4);',
'    l_decimal_char varchar2(4);',
'    l_column_name  varchar2(128);',
'    l_error_msg    varchar2(4000);',
'',
'    function validate_group_decimal_char',
'    return varchar2',
'    is',
'        l_msg varchar2(4000);',
'    begin',
'        -- if group separator defined, decimal character must be defined',
'        if l_group_char is not null then',
'            if l_decimal_char is null then',
'                l_msg := wwv_flow_lang.system_message( ',
'                            ''DATA_LOAD.DECIMAL_CHAR_REQUIRED'',',
'                            l_column_name );',
'            end if;',
'        end if;',
'',
'        -- group and decimal chars cannot be same',
'        if l_group_char = l_decimal_char then',
'            l_msg := wwv_flow_lang.system_message(',
'                         ''DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'',',
'                         l_column_name );',
'        end if;',
'        ',
'        return l_msg;',
'    end validate_group_decimal_char;',
'begin',
'    l_load_to := coalesce( :P3140_LOAD_TO, ''NEW'');',
'',
'    if l_load_to = ''NEW'' then',
'        -- loop through all column postions',
'        for i in 1 .. wwv_flow.g_f06.count',
'        loop',
'            for j in 1 .. wwv_flow.g_f01.count',
'            loop',
'                -- if column checked to load, validate',
'                if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'                    l_column_name  := wwv_flow.g_f02( i );',
'                    l_group_char   := wwv_flow.g_f04( i );',
'                    l_decimal_char := wwv_flow.g_f05( i );',
'',
'                    l_error_msg := validate_group_decimal_char;',
'                    if l_error_msg is not null then',
'                        return l_error_msg;',
'                    end if;',
'',
'                    exit;',
'                end if;',
'            end loop;',
'        end loop;',
'    elsif l_load_to= ''EXISTING'' then',
'        for i in 1 .. wwv_flow.g_f02.count',
'        loop',
'            -- if column mapped, check group and decimal char',
'            if wwv_flow.g_f02(i) is not null then',
'                l_column_name  := wwv_flow.g_f02( i );',
'                l_group_char   := wwv_flow.g_f04( i );',
'                l_decimal_char := wwv_flow.g_f05( i );',
'',
'                l_error_msg := validate_group_decimal_char;',
'                if l_error_msg is not null then',
'                    return l_error_msg;',
'                end if;',
'            end if;',
'        end loop;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(285737408143666602)
,p_validation_name=>'table columns not mapped multiple times'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_names  wwv_flow_global.vc_map;',
'    l_col_name_idx  pls_integer;',
'begin',
'    l_col_name_idx := wwv_flow.g_f02.first;',
'    while l_col_name_idx is not null loop',
'        if wwv_flow.g_f02( l_col_name_idx ) is not null then',
'            if l_column_names.exists( wwv_flow.g_f02( l_col_name_idx ) ) then',
'                return wwv_flow_lang.system_message ( ''DATA_LOAD.DUPLICATE_MAPPING'', wwv_flow.g_f02( l_col_name_idx ) );',
'            else',
'                l_column_names( wwv_flow.g_f02( l_col_name_idx ) ) := null;',
'            end if;',
'        end if;',
'',
'        l_col_name_idx := wwv_flow.g_f02.next( l_col_name_idx );',
'    end loop;',
'    return null;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2726636014566580)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(742452908834169229)
,p_validation_name=>'check max length'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_type    wwv_flow_global.t_dbms_id;',
'    l_max_length   number;',
'begin',
'    ',
'    -- loop through all column postions',
'    for i in 1 .. wwv_flow.g_f06.count',
'    loop',
'',
'        for j in 1 .. wwv_flow.g_f01.count',
'        loop',
'            -- if column checked to load, validate',
'            if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'',
'                l_data_type  := wwv_flow.g_f07( i );',
'',
'                begin',
'                    l_max_length := to_number( wwv_flow.g_f08( i ) );',
'                exception when others then',
'                    if l_data_type = ''VARCHAR2'' then',
'                        -- if not number, validation fails',
'                        return false;',
'                    end if;',
'                end;',
'',
'                if l_data_type = ''VARCHAR2'' then',
'                    -- if null, validation fails',
'                    if l_max_length is null then',
'                        return false;',
'                    else',
'                        -- varchar2 data type max length must be between 1 and allowed max varchar2 size',
'                        if l_max_length < 1 or ',
'                           l_max_length > case when wwv_flow_db_version.c_has_extended_string_size then 32767 else 4000 end',
'                        then',
'                            return false;',
'                        end if;',
'                    end if;',
'                end if;',
'',
'                exit;',
'            end if;',
'        end loop;',
'    end loop;',
'',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The maximum length is required for VARCHAR2 columns and must be a number between 1 and allowed maximum size of VARCHAR2.'
,p_validation_condition=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2726636014566580)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2787543165566721)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2727070542566581)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2788053295566721)
,p_event_id=>wwv_flow_imp.id(2787543165566721)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2789336626566722)
,p_name=>'Save Settings'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2726636014566580)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2790329219566723)
,p_event_id=>wwv_flow_imp.id(2789336626566722)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2785097988566716)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New Table - Save Column Load Checkbox'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile        clob;',
'    l_col_selected      boolean := false;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'     -- loop through all column postions',
'    for i in 1 .. wwv_flow.g_f06.count',
'    loop',
'        ',
'        for j in 1 .. wwv_flow.g_f01.count',
'        loop',
'            -- if column checked to load, save the column configuration',
'            if wwv_flow.g_f01( j ) = wwv_flow.g_f06( i ) then',
'',
'                wwv_flow_collection.add_member(',
'                    p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'                    p_c001            => wwv_flow.g_f06( i ), -- column position',
'                    p_c002            => wwv_flow.g_f02( i ), -- column name',
'                    p_c003            => wwv_flow.g_f03( i ), -- format mask',
'                    p_c004            => wwv_flow.g_f04( i ), -- group char',
'                    p_c005            => wwv_flow.g_f05( i ), -- decimal char',
'                    p_c006            => wwv_flow.g_f07( i ), -- column type',
'                    p_c007            => case when wwv_flow.g_f07( i ) = ''VARCHAR2'' then wwv_flow.g_f08( i ) end  -- max length',
'                    );',
'',
'                exit;',
'            end if;',
'        end loop;',
'    end loop;',
'        ',
'    select clob001',
'    into l_profile ',
'    from wwv_flow_collections ',
'    where collection_name = ''APEX$DATALOAD'' ',
'    and rownum = 1;',
'    ',
'    for i in (',
'        select column_position, column_name',
'        from table( wwv_flow_data_parser.get_columns( l_profile ) ) c ) ',
'    loop',
'        if wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0 then',
'            l_col_selected := true;',
'        else',
'            l_col_selected := false;',
'            for l_select_col in (',
'                select c001 idx ',
'                from wwv_flow_collections',
'                where collection_name = ''APEX$DATALOAD_COLUMNS'' )',
'            loop',
'                begin',
'                    if to_number( l_select_col.idx ) = i.column_position then',
'                        l_col_selected := true;',
'                        exit;',
'                    end if;',
'                exception when invalid_number then null; ',
'                end;',
'            end loop;',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2726636014566580)
,p_process_when=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2785097988566716
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2785856127566718)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Existing Table - Save Column Mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_map    wwv_flow_global.vc_map := wwv_flow_global.c_empty_vc_map;',
'begin    ',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );',
'    wwv_flow_collection.add_members(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'        p_c001            => wwv_flow.g_f01,  -- column_name',
'        p_c002            => wwv_flow.g_f02,  -- mapped column',
'        p_c003            => wwv_flow.g_f03,  -- format mask',
'        p_c004            => wwv_flow.g_f04,  -- group char',
'        p_c005            => wwv_flow.g_f05   -- decimal char           ',
'        );',
'    ',
'    -- get column mapping user configured',
'    for l_configure in (',
'        select',
'            c001   column_name,',
'            c002   mapped_column',
'        from wwv_flow_collections',
'        where collection_name = ''APEX$DATALOAD_COLUMNS''',
'        and c002 is not null )',
'    loop',
'        l_column_map( l_configure.column_name ) := l_configure.mapped_column;',
'    end loop;',
'    ',
'    :P3140_MAPPED_COLUMN_COUNT := l_column_map.count;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2726636014566580)
,p_process_when=>'coalesce( :P3140_LOAD_TO, ''NEW'') = ''EXISTING'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2785856127566718
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2785467859566717)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2726636014566580)
,p_internal_uid=>2785467859566717
);
end;
/
prompt --application/pages/page_03150
begin
wwv_flow_imp_page.create_page(
 p_id=>3150
,p_name=>'Load Data into SODA Collection'
,p_alias=>'LOAD-DATA-INTO-SODA-COLLECTION'
,p_page_mode=>'MODAL'
,p_step_title=>'Load Data into SODA Collection'
,p_autocomplete_on_off=>'OFF'
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_dialog_height=>'720'
,p_dialog_width=>'1024'
,p_dialog_attributes=>'resisable:true'
,p_dialog_css_classes=>'a-Page--DataLoad &P3150_BODY_CLASS.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3201665929656810)
,p_plug_name=>'Load to SODA Collection'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P3150_FILE_NAME is not null and :P3150_VALID_FILE = 1'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3203099837656824)
,p_plug_name=>'JSON Properties'
,p_parent_plug_id=>wwv_flow_imp.id(3201665929656810)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3203189517656825)
,p_plug_name=>'Common Properties'
,p_parent_plug_id=>wwv_flow_imp.id(3201665929656810)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3203367147656827)
,p_plug_name=>'ZIP Properties'
,p_parent_plug_id=>wwv_flow_imp.id(3201665929656810)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P3150_FILE_NAME like ''%.zip'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3201917616656813)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3150_FILE_NAME'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3366342740004636)
,p_plug_name=>'Invalid file uploaded.'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>15
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'The uploaded file is invalid. Only ZIP or JSON files can be uploaded to a SODA collection.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P3150_FILE_NAME is not null and :P3150_VALID_FILE = 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3620884258294383)
,p_plug_name=>'File'
,p_region_name=>'drag_drop_file'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_soda_dev.has_soda_role( :P3150_PARSING_SCHEMA )'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3624431708294418)
,p_plug_name=>'File Loaded'
,p_region_name=>'load_completed'
,p_parent_plug_id=>wwv_flow_imp.id(3620884258294383)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="b-FileDataPreview">',
'  <span class="a-Icon a-Icon--large icon-ig-dl-xls" aria-hidden="true"></span>',
'  <span class="b-FileDataPreview-label">&P3150_FILE_NAME. - &P3150_FILE_SIZE.</span>',
'</div>'))
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P3150_FILE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74476252882949639)
,p_plug_name=>'SODA_APP database role required'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>5
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The &P3150_PARSING_SCHEMA!HTML. schema does not have the <strong>SODA_APP</strong> role granted. Please have the role granted by the database administrator using the following SQL command:',
'<pre>',
'grant SODA_APP to &P3150_PARSING_SCHEMA!HTML.;',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_soda_dev.has_soda_role( :P3150_PARSING_SCHEMA )'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3201857722656812)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3201917616656813)
,p_button_name=>'LOAD_DATA'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Load Data'
,p_button_position=>'NEXT'
,p_button_condition=>'P3150_VALID_FILE'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3203898791656832)
,p_branch_action=>'f?p=&APP_ID.:3151:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3201857722656812)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3201555224656809)
,p_branch_name=>'Go To Page 3150'
,p_branch_action=>'f?p=&APP_ID.:3150:&SESSION.:UPLOAD_FILE:&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806812091856101)
,p_name=>'P3150_OB_FLAG'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_item_default=>'Y'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'Determines how the page is opened. If this flag is Y, then page is opened from OB page 4500:2000, otherwise it''s opened from other apps/pages.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2000935408459793)
,p_name=>'P3150_FILE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3620884258294383)
,p_prompt=>'Upload FIle'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_display_when=>'P3150_FILE'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_css_classes=>'data-load-input'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_12=>'DROPZONE_BLOCK'
,p_attribute_14=>'Supported formats json, txt, zip'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001672117459798)
,p_name=>'P3150_FILE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3624431708294418)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3201781556656811)
,p_name=>'P3150_NEW_COLL_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_prompt=>'SODA Collection Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a name for the new SODA collection. Only upper case names are supported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3202062879656814)
,p_name=>'P3150_PARSING_SCHEMA'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3202231086656816)
,p_name=>'P3150_LOAD_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_item_default=>'NEW'
,p_prompt=>'Load To'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:New Collection;NEW,Existing Collection;EXISTING'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Decide whether to load into a new or existing SODA collection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3202383555656817)
,p_name=>'P3150_EXISTING_COLL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_prompt=>'Existing SODA Collection'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_soda_dev.get_soda_collections( p_schema => :P3150_PARSING_SCHEMA ) ) c, sys.dba_tables t',
' where c.column_value = t.table_name',
'   and t.owner = :P3150_PARSING_SCHEMA'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose an existing SODA collection to load data into.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3202996934656823)
,p_name=>'P3150_RELATIONAL_VIEW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_prompt=>' Relational View Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_tag_attributes=>'style="text-transform:uppercase"'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the name of a relational view has been provided, APEX will use the <em>Data Guide</em> feature in order to generate a relational view on top of the SODA collection. The relational view can then be used to create an application.',
'Only upper case names are supported.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3203272647656826)
,p_name=>'P3150_ROW_SELECTOR'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3203099837656824)
,p_prompt=>'JSON Selector'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3150_FILE_NAME like ''%.js'' or ',
':P3150_FILE_NAME like ''%.json'' or',
':P3150_FILE_NAME like ''%.geojson'''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a <em>JSON Selector</em>, which points to an array in the uploaded JSON file. Each JSON object within the array will be loaded as a JSON document to the SODA collection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3203588428656829)
,p_name=>'P3150_LOAD_NON_JSON'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3203367147656827)
,p_item_default=>'N'
,p_prompt=>'Load Non-JSON Files'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'not wwv_flow_soda_dev.is_ajd_service'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If enabled, non JSON files will also be loaded to the collection. Note that Data Guide is not available for collections with non JSON documents.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3203988702656833)
,p_name=>'P3150_LOAD_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3204339623656837)
,p_name=>'P3150_CALLED_FROM'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3366429158004637)
,p_name=>'P3150_VALID_FILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3366342740004636)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3366672810004639)
,p_name=>'P3150_CONVERT_XML_FILES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3203367147656827)
,p_item_default=>'Y'
,p_prompt=>'Convert XML files to JSON'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If enabled, XML files within the ZIP archive will be converted to JSON before loading to the collection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12343242850853111)
,p_name=>'P3150_BODY_CLASS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12343878072853117)
,p_name=>'P3150_APPEND_METHOD'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_item_default=>'APPEND'
,p_prompt=>'Update Method'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Append;APPEND,Replace;REPLACE'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>Append</strong> If data already exists in the collection, the wizard appends the new documents to the collection. If data does not exist, the new documents are simply loaded.</li>',
'    <li><strong>Replace</strong> The entire collection is replaced by deleting data first and then loading the new documents.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12343949010853118)
,p_name=>'P3150_AUTO_DETECT_SELECTOR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3203099837656824)
,p_item_default=>'Y'
,p_prompt=>'JSON Selector Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Auto-Detect;Y,Custom;N,Linefeed (JSON List);CR'
,p_tag_css_classes=>'apex-button-group'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3150_FILE_NAME like ''%.js'' or ',
':P3150_FILE_NAME like ''%.json'' or',
':P3150_FILE_NAME like ''%.txt'' or',
':P3150_FILE_NAME like ''%.geojson'''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_read_only_when=>':P3150_FILE_NAME like ''%.txt'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify how to extract JSON documents from the uploaded file.</p>',
'<ul>',
'    <li><strong>Auto-Detect</strong> requires that the uploaded file is a <em>valid JSON document</em>. APEX will look for the first JSON array within the uploaded file and will upload each JSON object within the array as a document to the SODA colle'
||'ction.</li>',
'    <li><strong>Custom</strong> requires that the uploaded file is a <em>valid JSON document</em>. APEX will use the user-provided <strong>JSON selector</strong> to reference a JSON array within the uploaded file, and will upload each JSON object wit'
||'hin the array as a document to the SODA collection.</li>',
'    <li><strong>Linefeed (JSON List)</strong> requires a file containing multiple JSON documents, each document in one line, and separated by line feeds. This type of JSON upload supports individual JSON documents (line length) up to 32,767 bytes.</l'
||'i>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74473851856949615)
,p_name=>'P3150_CREATE_RELATONAL_VIEW'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_item_default=>'case when :P3150_LOAD_TO = ''NEW'' then ''Y'' else ''N'' end'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Create Relational View'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If enabled, and a name for the relational view is provided, APEX will use the <em>Data Guide</em> feature in order to generate a relational view on top of the SODA collection. The relational view can then be used to create an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74474500551949622)
,p_name=>'P3150_FILE_SIZE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3624431708294418)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74477333881949650)
,p_name=>'P3150_SKIP_NON_JSON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3203189517656825)
,p_item_default=>'N'
,p_prompt=>'Skip invalid rows'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>':P3150_FILE_NAME not like ''%.zip'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If enabled, rows containing invalid JSON documents will be skipped. If disabled, an error will be raised.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(190994948754372717)
,p_computation_sequence=>10
,p_computation_item=>'P3150_NEW_COLL_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P3150_NEW_COLL_NAME)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(190995069615372718)
,p_computation_sequence=>20
,p_computation_item=>'P3150_RELATIONAL_VIEW'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P3150_CREATE_RELATONAL_VIEW = ''Y'' then upper(:P3150_RELATIONAL_VIEW) end'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(12343145548853110)
,p_computation_sequence=>20
,p_computation_item=>'P3150_FILE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename',
'  from wwv_flow_temp_files',
' where name = :P3150_FILE',
' '))
,p_compute_when=>'P3150_FILE'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(74474799740949624)
,p_computation_sequence=>30
,p_computation_item=>'P3150_FILE_SIZE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_util.filesize_mask( sys.dbms_lob.getlength( blob_content ))',
'  from wwv_flow_temp_files',
' where name = :P3150_FILE',
' '))
,p_compute_when=>'P3150_FILE'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3366588398004638)
,p_computation_sequence=>40
,p_computation_item=>'P3150_VALID_FILE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when substr(lower(:P3150_FILE), instr( :P3150_FILE, ''.'', -1)) in (''.js'',''.json'',''.geojson'',''.zip'', ''.xml'', ''.txt'') then 1 else 0 end'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(74473780110949614)
,p_validation_name=>'Check Schema Access'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_sw_api.check_priv(:P3150_PARSING_SCHEMA);',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Schema access violation.'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(74474479047949621)
,p_validation_name=>'Relational View Name NOT NULL'
,p_validation_sequence=>10
,p_validation=>'P3150_RELATIONAL_VIEW'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P3150_CREATE_RELATONAL_VIEW'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(3202996934656823)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12343454298853113)
,p_validation_name=>'Relational View Name does not yet exist'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_views',
' where owner     = :P3150_PARSING_SCHEMA',
'   and view_name = :P3150_RELATIONAL_VIEW'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This view name is already taken. Please choose another.'
,p_validation_condition=>'P3150_CREATE_RELATONAL_VIEW'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(3202996934656823)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12343589142853114)
,p_validation_name=>'New Collection Name NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P3150_NEW_COLL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(3201781556656811)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(90119599628448644)
,p_validation_name=>'New Relational View must not contain invalid chars'
,p_validation_sequence=>30
,p_validation=>'P3150_RELATIONAL_VIEW'
,p_validation2=>'#''&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# must not contain #,  &, <, >, ", '', /, ;, *, |, =, % or , character.',
''))
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(3202996934656823)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(90119437498448643)
,p_validation_name=>'New Collection Name must not contain invalid chars'
,p_validation_sequence=>40
,p_validation=>'P3150_NEW_COLL_NAME'
,p_validation2=>'#''&<>"/;*|=%, '
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# must not contain #,  &, <, >, ", '', /, ;, *, |, =, % or , character.',
''))
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(3201781556656811)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(190993339913372701)
,p_validation_name=>'New Collection Name does not exist'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from sys.dba_tables',
' where owner      = :P3150_PARSING_SCHEMA',
'   and table_name = :P3150_NEW_COLL_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The collection name is already used. Please choose another.'
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(3201781556656811)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12343382475853112)
,p_validation_name=>'New Collection Name does not exists -2-'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from table( wwv_flow_soda_dev.get_soda_collections( :P3150_PARSING_SCHEMA ) )',
' where column_value = :P3150_NEW_COLL_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A SODA collection "&P3150_NEW_COLL_NAME." exists, but without a storage table.',
'Drop the collection using DBMS_SODA.DROP_COLLECTION before proceeding.'))
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(3201781556656811)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12343783713853116)
,p_validation_name=>'Existing Collection Name NOT NULL'
,p_validation_sequence=>100
,p_validation=>'P3150_EXISTING_COLL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(3202383555656817)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(74474843438949625)
,p_validation_name=>'Existing Collection Name exists'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_tables',
' where owner      = :P3150_PARSING_SCHEMA',
'   and table_name = :P3150_EXISTING_COLL_NAME'))
,p_validation_type=>'EXISTS'
,p_error_message=>'SODA Collection &P3150_EXISTING_COLL_NAME!HTML. does not exist.'
,p_validation_condition=>'P3150_LOAD_TO'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(3202383555656817)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(74476155699949638)
,p_validation_name=>'Is Valid JSON Document'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_json number;',
'begin',
'    select 1 ',
'      into l_is_json',
'      from wwv_flow_temp_files',
'     where name = :P3150_FILE',
'       and blob_content is json;',
'   ',
'    return true;',
'exception',
'    when no_data_found then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'"Auto-Detect" and "Custom" JSON selector types are only allowed for valid JSON files.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:P3150_FILE_NAME like ''%.js'' or ',
' :P3150_FILE_NAME like ''%.json'' or',
' :P3150_FILE_NAME like ''%.geojson'' ) and :P3150_AUTO_DETECT_SELECTOR in (''Y'', ''N'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3201857722656812)
,p_associated_item=>wwv_flow_imp.id(12343949010853118)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2004492679513599)
,p_name=>'Upload File'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_FILE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2005322890513600)
,p_event_id=>wwv_flow_imp.id(2004492679513599)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(".a-FileUpload").addClass("is-loading");'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2005885262513600)
,p_event_id=>wwv_flow_imp.id(2004492679513599)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_FILE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3202430226656818)
,p_name=>'New Collection'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_LOAD_TO'
,p_condition_element=>'P3150_LOAD_TO'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3202522469656819)
,p_event_id=>wwv_flow_imp.id(3202430226656818)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_NEW_COLL_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3202829743656822)
,p_event_id=>wwv_flow_imp.id(3202430226656818)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_EXISTING_COLL_NAME,P3150_APPEND_METHOD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3202673691656820)
,p_event_id=>wwv_flow_imp.id(3202430226656818)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_EXISTING_COLL_NAME,P3150_APPEND_METHOD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3202762055656821)
,p_event_id=>wwv_flow_imp.id(3202430226656818)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_NEW_COLL_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12344087306853119)
,p_name=>'Auto Detect Row Selector'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_AUTO_DETECT_SELECTOR'
,p_condition_element=>'P3150_AUTO_DETECT_SELECTOR'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12344149259853120)
,p_event_id=>wwv_flow_imp.id(12344087306853119)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_ROW_SELECTOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12344239970853121)
,p_event_id=>wwv_flow_imp.id(12344087306853119)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_ROW_SELECTOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12344392388853122)
,p_event_id=>wwv_flow_imp.id(12344087306853119)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_ROW_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12344408055853123)
,p_name=>'New Collection Name changed'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_NEW_COLL_NAME'
,p_condition_element=>'P3150_NEW_COLL_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18603396504796718)
,p_event_id=>wwv_flow_imp.id(12344408055853123)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_NEW_COLL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P3150_NEW_COLL_NAME").getValue().replaceAll(" ","_")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12344520496853124)
,p_event_id=>wwv_flow_imp.id(12344408055853123)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P3150_NEW_COLL_NAME").toUpperCase() + "_VIEW"'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3205155657656845)
,p_name=>'Load Non JSON'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_LOAD_NON_JSON'
,p_condition_element=>'P3150_LOAD_NON_JSON'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3205276503656846)
,p_event_id=>wwv_flow_imp.id(3205155657656845)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW,P3150_CREATE_RELATONAL_VIEW'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3205367112656847)
,p_event_id=>wwv_flow_imp.id(3205155657656845)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_CREATE_RELATONAL_VIEW'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3205452493656848)
,p_event_id=>wwv_flow_imp.id(3205155657656845)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(74474977367949626)
,p_event_id=>wwv_flow_imp.id(3205155657656845)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_CREATE_RELATONAL_VIEW'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(74474030821949617)
,p_name=>'Create Relational View'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_CREATE_RELATONAL_VIEW'
,p_condition_element=>'P3150_CREATE_RELATONAL_VIEW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(74474157885949618)
,p_event_id=>wwv_flow_imp.id(74474030821949617)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(74474298420949619)
,p_event_id=>wwv_flow_imp.id(74474030821949617)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(74474356705949620)
,p_event_id=>wwv_flow_imp.id(74474030821949617)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(90115276635448601)
,p_name=>'Linefeed JSON'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_AUTO_DETECT_SELECTOR'
,p_condition_element=>'P3150_AUTO_DETECT_SELECTOR'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(90115372975448602)
,p_event_id=>wwv_flow_imp.id(90115276635448601)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_SKIP_NON_JSON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(90115409186448603)
,p_event_id=>wwv_flow_imp.id(90115276635448601)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_SKIP_NON_JSON'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18603129790796716)
,p_name=>'Replaces Spaces - P3150_RELATIONAL_VIEW'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3150_RELATIONAL_VIEW'
,p_condition_element=>'P3150_RELATIONAL_VIEW'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18603255350796717)
,p_event_id=>wwv_flow_imp.id(18603129790796716)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3150_RELATIONAL_VIEW'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P3150_RELATIONAL_VIEW").getValue().replaceAll(" ","_")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3203712454656831)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load data to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_content blob;',
'    l_file_type    pls_integer;',
'    ',
'    l_row_selector varchar2(255);',
'begin',
'    select blob_content',
'      into l_file_content',
'      from wwv_flow_temp_files',
'     where name = :P3150_FILE;',
'     ',
'    if :P3150_FILE_NAME like ''%.zip'' then',
'        l_file_type := wwv_flow_soda_dev.c_file_type_zip;',
'    elsif  :P3150_FILE_NAME like ''%.js'' or :P3150_FILE_NAME like ''%json'' or :P3150_FILE_NAME like ''%txt'' then',
'        l_file_type := wwv_flow_soda_dev.c_file_type_json_collection;',
'    end if;',
'    ',
'    if l_file_type = wwv_flow_soda_dev.c_file_type_json_collection then',
'        l_row_selector := case when :P3150_AUTO_DETECT_SELECTOR = ''N''  then :P3150_ROW_SELECTOR',
'                               when :P3150_AUTO_DETECT_SELECTOR = ''CR'' then chr( wwv_flow_soda_dev.c_row_selector_chr_jsonlist )',
'                               when :P3150_AUTO_DETECT_SELECTOR = ''Y''  then null',
'                          end;',
'    end if;',
'    ',
'    :P3150_LOAD_ID := wwv_flow_id.next_val;',
'    ',
'    if l_file_type = wwv_flow_soda_dev.c_file_type_zip and :P3150_LOAD_NON_JSON = ''Y'' then',
'        :P3150_RELATIONAL_VIEW := null;',
'    end if;',
'',
'    if :P3150_LOAD_TO = ''NEW'' then',
'        wwv_flow_soda_dev.load_into_new_collection(',
'            p_content              => l_file_content,',
'            p_content_type         => l_file_type,',
'            --',
'            p_collection_name      => :P3150_NEW_COLL_NAME,',
'            p_relational_view_name => :P3150_RELATIONAL_VIEW,',
'            p_handle_nonjson_files => case when :P3150_AUTO_DETECT_SELECTOR = ''CR'' ',
'                                          then',
'                                              case when :P3150_SKIP_NON_JSON = ''N'' then wwv_flow_soda_dev.c_allow_nonjson_files else wwv_flow_soda_dev.c_skip_nonjson_files end',
'                                          else ',
'                                              case when :P3150_LOAD_NON_JSON = ''Y'' then wwv_flow_soda_dev.c_allow_nonjson_files else wwv_flow_soda_dev.c_skip_nonjson_files end',
'                                      end,',
'            p_convert_xml_to_json  => :P3150_CONVERT_XML_FILES = ''Y'',',
'            -- ',
'            p_row_selector         => l_row_selector,',
'            -- ',
'            p_commit_interval      => 200,',
'            p_status_collection    => ''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID,',
'            -- ',
'            p_run_in_background    => true,',
'            -- ',
'            p_execute_as_schema    => :P3150_PARSING_SCHEMA );',
'    else',
'        wwv_flow_soda_dev.load_into_existing_collection(',
'            p_content              => l_file_content,',
'            p_content_type         => l_file_type,',
'            --',
'            p_handle_nonjson_files => case when :P3150_AUTO_DETECT_SELECTOR = ''CR'' ',
'                                          then',
'                                              case when :P3150_SKIP_NON_JSON = ''N'' then wwv_flow_soda_dev.c_allow_nonjson_files else wwv_flow_soda_dev.c_skip_nonjson_files end',
'                                          else ',
'                                              case when :P3150_LOAD_NON_JSON = ''Y'' then wwv_flow_soda_dev.c_allow_nonjson_files else wwv_flow_soda_dev.c_skip_nonjson_files end',
'                                      end,',
'            p_convert_xml_to_json  => :P3150_CONVERT_XML_FILES = ''Y'',',
'            p_collection_name      => :P3150_EXISTING_COLL_NAME,',
'            p_relational_view_name => null,',
'            -- ',
'            p_row_selector         => l_row_selector,',
'            p_truncate             => ( :P3150_APPEND_METHOD = ''REPLACE'' ),',
'            -- ',
'            p_commit_interval      => 200,',
'            p_status_collection    => ''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID,',
'            -- ',
'            p_run_in_background    => true,',
'            -- ',
'            p_execute_as_schema    => :P3150_PARSING_SCHEMA );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3201857722656812)
,p_internal_uid=>3203712454656831
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(169589682639178940)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate schema access'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:P3150_PARSING_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'OBJECT_OWNER'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>169589682639178940
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2604098187653710)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Body Class'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3150_FILE is null then',
'  :P3150_BODY_CLASS := ''is-first-step'';',
'else',
'  :P3150_BODY_CLASS := '''';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2604098187653710
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4391137511679772648)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Selector'
,p_process_sql_clob=>':P3150_AUTO_DETECT_SELECTOR := ''CR'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P3150_FILE_NAME like ''%.txt'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>4391137511679772648
);
end;
/
prompt --application/pages/page_03151
begin
wwv_flow_imp_page.create_page(
 p_id=>3151
,p_name=>'Load Data'
,p_alias=>'LOAD-DATA2'
,p_page_mode=>'MODAL'
,p_step_title=>'Load Data'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Region-headerItems--buttons { white-space: nowrap; }',
'.a-Region-bodyHeader { padding: 12px; margin: 0; border-bottom: 1px solid rgba(0, 0, 0,0.1); background-color: #FFF8E1; color: #202020; }',
''))
,p_step_template=>wwv_flow_imp.id(690784265136803192)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(46619710624049700)
,p_dialog_height=>'800'
,p_dialog_width=>'960'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(6252145073553331)
,p_name=>'Load in Progress'
,p_region_name=>'loadInProgress'
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 as status,',
'       n001 as rows_processed ',
'from wwv_flow_collections ',
'where collection_name=''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(385896719135645040)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2021287082720117)
,p_query_column_id=>1
,p_column_alias=>'STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(3891423527523942)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2021635635720119)
,p_query_column_id=>2
,p_column_alias=>'ROWS_PROCESSED'
,p_column_display_sequence=>2
,p_column_heading=>'Documents Loaded'
,p_use_as_row_header=>'N'
,p_column_format=>'9G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6834087449944525)
,p_plug_name=>'Load Failed'
,p_region_name=>'loadIncomplete'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>50
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Data loading failed intermittently and is incomplete.',
'<pre id="imcompl_load_error"></pre>',
'Please check the error and try again. <br/>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467907526226381329)
,p_plug_name=>'New Table'
,p_parent_plug_id=>wwv_flow_imp.id(6834087449944525)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Collection <code>&P3151_TABLE_NAME!HTML.</code> created! <b id="incompl_success_row_count"></b> documents loaded successfully. <b class="u-danger-text" id="incompl_fail_row_count"></b> documents rejected.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467907600307381330)
,p_plug_name=>'Existing Table'
,p_parent_plug_id=>wwv_flow_imp.id(6834087449944525)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3150_APPEND_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'', wwv_flow_escape.html(:P3150_EXISTING_COLL_NAME) ) );',
'elsif :P3150_APPEND_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'',  wwv_flow_escape.html(:P3150_EXISTING_COLL_NAME) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3100_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7960818590952875)
,p_plug_name=>'Load Failed'
,p_region_name=>'loadFail'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>40
,p_plug_source=>'The data could not be loaded.  Please check the error and try again.  <b id="fail_row_count"></b> documents failed.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9996351288283702)
,p_plug_name=>'Data Load Success'
,p_region_name=>'loadSuccess'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(469942078024703302)
,p_plug_name=>'New Table'
,p_parent_plug_id=>wwv_flow_imp.id(9996351288283702)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Collection <code>&P3151_TABLE_NAME!HTML.</code> created with <b id="success_row_count"></b> documents!'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3150_LOAD_TO'
,p_plug_display_when_cond2=>'NEW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(469942110977703303)
,p_plug_name=>'Existing Table'
,p_parent_plug_id=>wwv_flow_imp.id(9996351288283702)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3150_APPEND_METHOD = ''APPEND'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''WWV_FLOW_SODA_DEV.APPEND_SUCCESS'', wwv_flow_escape.html(:P3150_EXISTING_COLL_NAME) ) );',
'elsif :P3150_APPEND_METHOD = ''REPLACE'' then',
'    sys.htp.p( wwv_flow_lang.system_message(''WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'',wwv_flow_escape.html(:P3150_EXISTING_COLL_NAME) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3150_LOAD_TO'
,p_plug_display_when_cond2=>'EXISTING'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9997939756283718)
,p_plug_name=>'Load Finished'
,p_region_name=>'load_finished'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13546601811099580)
,p_plug_name=>'Table Information'
,p_region_name=>'table_info'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="timer-container"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13546899090099583)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2037068631720149)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(13546899090099583)
,p_button_name=>'CANCEL'
,p_button_static_id=>'btn_cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2037465062720149)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(13546899090099583)
,p_button_name=>'VIEW_TABLE'
,p_button_static_id=>'viewTableBtn'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'View Collection'
,p_button_position=>'CREATE'
,p_button_condition=>'nvl(:P3150_CALLED_FROM, ''X'') != ''OBJECT_BROWSER'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_imp.id(12524102140541924)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2037893392720150)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(13546899090099583)
,p_button_name=>'CREATE_APP'
,p_button_static_id=>'createAppBtn'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:1,5,130,150,170,250:P1_SCHEMA,P1_NEW_TABLE_NAME:&P3151_TABLE_OWNER.,&P3150_RELATIONAL_VIEW.'
,p_button_condition=>'nvl(:P3150_CALLED_FROM,''X'') != ''OBJECT_BROWSER'' and :P3150_RELATIONAL_VIEW is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'style="display: none;"'
,p_security_scheme=>wwv_flow_imp.id(12506407035221692)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6004480099547940)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(13546899090099583)
,p_button_name=>'DONE'
,p_button_static_id=>'btn_done'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Done'
,p_button_position=>'CREATE'
,p_button_condition=>'P3150_CALLED_FROM'
,p_button_condition2=>'OBJECT_BROWSER'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_cattributes=>'style="display: none;"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2038274836720150)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(13546899090099583)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'btn_previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765860428963371)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3150:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1806948265856102)
,p_branch_name=>'Branch to OB Page'
,p_branch_action=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:&P3150_PARSING_SCHEMA.,&P3151_OBJECT_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2037465062720149)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P3150_OB_FLAG'
,p_branch_condition_text=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1778885901216743)
,p_name=>'P3151_INVALIDATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(9997939756283718)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022034417720122)
,p_name=>'P3151_LOAD_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6252145073553331)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022465876720124)
,p_name=>'P3151_LOAD_ERROR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6252145073553331)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022879838720124)
,p_name=>'P3151_PROCESSED_ROW_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6252145073553331)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2023251178720124)
,p_name=>'P3151_PROCESSED_ROW_CNT_DISP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6252145073553331)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2032810852720145)
,p_name=>'P3151_TABLE_CREATED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(9997939756283718)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2033235046720146)
,p_name=>'P3151_OBJECT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(9997939756283718)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2034024225720146)
,p_name=>'P3151_GOOD_ROW_CNT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(9997939756283718)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2034460368720146)
,p_name=>'P3151_GOOD_ROW_CNT_DISP'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(9997939756283718)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2035926806720148)
,p_name=>'P3151_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13546601811099580)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'P3150_PARSING_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v ',
'  from wwv_flow_company_schemas c, ',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID  ',
'   and u.user_name         = :FLOW_USER   ',
'   and ( u.allow_access_to_schemas is null or ',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
' order by 1'))
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2036340568720149)
,p_name=>'P3151_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(13546601811099580)
,p_prompt=>'Collection Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3204039796656834)
,p_name=>'P3151_LOAD_TO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(9997939756283718)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3204293548656836)
,p_name=>'P3151_VIEW_OBJ_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(9997939756283718)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9403321411786315)
,p_name=>'P3151_OBJECT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(9997939756283718)
,p_item_default=>'SODA_COLLECTION'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9403421404786316)
,p_name=>'P3151_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(9997939756283718)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1778980144216744)
,p_computation_sequence=>10
,p_computation_item=>'P3151_INVALIDATE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'{"refreshView":"true"}'
,p_compute_when=>'DONE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6004636059547942)
,p_computation_sequence=>20
,p_computation_item=>'P3151_INVALIDATE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'{"refreshTree":"true"}'
,p_compute_when=>'VIEW_TABLE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2038714876720174)
,p_computation_sequence=>10
,p_computation_item=>'P3151_TABLE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3150_LOAD_TO = ''NEW'' then',
'    return :P3150_NEW_COLL_NAME;',
'elsif :P3150_LOAD_TO = ''EXISTING'' then',
'    return :P3150_EXISTING_COLL_NAME;',
'end if;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3204187211656835)
,p_computation_sequence=>20
,p_computation_item=>'P3151_LOAD_TO'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3150_LOAD_TO'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2039719192720175)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2037068631720149)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2040223850720176)
,p_event_id=>wwv_flow_imp.id(2039719192720175)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2040629796720176)
,p_name=>'Timer for Refresh Progress'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2041138390720177)
,p_event_id=>wwv_flow_imp.id(2040629796720176)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSpinner$ = apex.util.showSpinner( $( "#loadInProgress" ) );',
'',
'var showFinished = function(){    ',
'    // Hide Table Information',
'    apex.region("table_info").element.hide();',
'',
'    var lLoadTo = apex.item("P3151_LOAD_TO").getValue();',
'    ',
'    var lTableCreated = apex.item( "P3151_TABLE_CREATED" ).getValue();',
'    var lBadRowCnt = 0;',
'    var lSuccessRowCnt = apex.item("P3151_GOOD_ROW_CNT").getValue();',
'    var lProcessedRowCnt = apex.item( "P3151_PROCESSED_ROW_CNT" ).getValue();',
'    ',
'    var lBadRowCntDisp = 0;',
'    var lSuccessRowCntDisp = apex.item("P3151_GOOD_ROW_CNT_DISP").getValue();',
'    var lProcessedRowCntDisp = apex.item( "P3151_PROCESSED_ROW_CNT_DISP" ).getValue();',
'    ',
'    if (lLoadTo === "NEW") {',
'        if (lTableCreated === "Y") {',
'            apex.jQuery("#viewTableBtn").show();',
'            apex.jQuery("#btn_cancel").hide();',
'        }',
'    } else if (lLoadTo === "EXISTING") {',
'        apex.jQuery("#viewTableBtn").show();',
'    }',
'    ',
'    if ( apex.item("P3151_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'        // show failure region',
'',
'        apex.jQuery("#incompl_success_row_count").text( lSuccessRowCntDisp );',
'        apex.jQuery("#incompl_fail_row_count").text( lBadRowCntDisp );',
'        apex.jQuery("#imcompl_load_error").text( apex.item( "P3151_LOAD_ERROR" ).getValue() );        ',
'        apex.region("loadIncomplete").element.show();',
'        apex.jQuery("#btn_done").hide();',
'        if (lTableCreated === "Y") {',
'                apex.jQuery("#dropTableBtn").show();',
'            };',
'    } else {',
'        ',
'            // show success region',
'            apex.jQuery("#success_row_count").text( lSuccessRowCntDisp );',
'            apex.region("loadSuccess").element.show();',
'            apex.jQuery("#createAppBtn").show();',
'            apex.jQuery("#btn_previous").hide();',
'            apex.jQuery("#btn_done").show();',
'    }',
' };',
'',
'var triggerRefresh = function(){ ',
'    apex.event.trigger( apex.jQuery("#timer-container"), "job_timer" );',
'',
'    if ( apex.item("P3151_LOAD_STATUS").getValue() === ''FINISHED''  || ',
'         apex.item("P3151_LOAD_STATUS").getValue() === ''FAILED'' ) {',
'      clearInterval( refreshInterval );',
'      apex.region("loadInProgress").element.hide();',
'      lSpinner$.remove();',
'      showFinished();',
'    }',
'};',
'',
'var refreshInterval = setInterval( triggerRefresh, 1000);'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2041584904720177)
,p_name=>'Refresh Progress Report on Timer'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#timer-container'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'job_timer'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2042034037720177)
,p_event_id=>wwv_flow_imp.id(2041584904720177)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6252145073553331)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2042531363720178)
,p_event_id=>wwv_flow_imp.id(2041584904720177)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_job_is_running boolean := false;',
'begin',
'    --',
'    -- Step 1: Determine whether the scheduler job is running',
'    --',
'    for j in (',
'        select 1',
'          from sys.user_scheduler_jobs',
'         where job_name like ''ORACLE_APEX_DTLD$%''',
'           and regexp_substr( comments, ''(\:)(.*?)(\:)'',1,5,''i'',2 ) = ''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID',
'           and state    = ''RUNNING'' ',
'           and rownum   = 1 )',
'    loop',
'        l_job_is_running := true;',
'    end loop;',
'',
'    --',
'    -- Step 2: Determine the current status from the status collection',
'    --',
'    for l_load in (',
'        select c001 as status,',
'               c002 as error_message,',
'               n001 as rows_processed ',
'        from wwv_flow_collections ',
'        where collection_name=''APEX$DATALOAD_STATUS''||:P3150_LOAD_ID)',
'    loop',
'        :P3151_LOAD_STATUS       := l_load.status;',
'        :P3151_LOAD_ERROR        := l_load.error_message;',
'        :P3151_PROCESSED_ROW_CNT := l_load.rows_processed;',
'    end loop;',
'',
'    if :P3151_LOAD_STATUS = ''RUNNING'' and not l_job_is_running then',
'        :P3151_LOAD_STATUS       := ''FAILED'';',
'        :P3151_LOAD_ERROR        := wwv_flow_lang.system_message(''DATA.LOAD.JOB_INTERMITTENTLY_FAILED'');',
'    end if;',
'    ',
'    :P3151_PROCESSED_ROW_CNT_DISP := to_char( :P3151_PROCESSED_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'end;'))
,p_attribute_03=>'P3151_LOAD_STATUS,P3151_PROCESSED_ROW_CNT,P3151_LOAD_ERROR,P3151_PROCESSED_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2043090830720179)
,p_event_id=>wwv_flow_imp.id(2041584904720177)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_table_exists boolean := false;',
'    l_context wwv_flow_exec.t_context;',
'    q varchar2(32767);',
'begin',
'    if :P3151_LOAD_STATUS in (''FAILED'', ''FINISHED'' ) then',
'        if :P3150_LOAD_TO = ''NEW'' then',
'            for l_table in (',
'                select table_name',
'                from sys.dba_tables',
'                where table_name = :P3150_NEW_COLL_NAME',
'                and owner = :P3150_PARSING_SCHEMA )',
'            loop',
'                :P3151_TABLE_CREATED := ''Y'';',
'            end loop;',
'        end if;',
'        ',
'        q := ''with'';',
'        q := q||'' success_data as (select count(*) as cnt from ''||',
'             wwv_flow_assert.enquote_name( :P3151_TABLE_NAME )|| '')'';',
'        q := q||'' select s.cnt as success_count'';',
'        q:=q||'' from'';',
'        q:=q||'' success_data s'';',
'     ',
'        wwv_flow_exec.open_query_context(',
'            p_context     => l_context,',
'            p_location    => wwv_flow_exec_api.c_location_local_db,',
'            p_query_type  => wwv_flow_exec_api.c_query_type_sql_query,',
'            p_sql_query   => q,',
'            p_parse_as_schema_override => :P3150_PARSING_SCHEMA );',
'            ',
'        if wwv_flow_exec.next_row( p_context => l_context ) then',
'            :P3151_GOOD_ROW_CNT := wwv_flow_exec.get_number( p_context => l_context, p_column_idx => 1 );',
'        end if;',
'        ',
'        if :P3150_LOAD_TO = ''EXISTING'' then',
'            :P3151_GOOD_ROW_CNT := :P3151_PROCESSED_ROW_CNT;',
'        end if;',
'        ',
'        :P3151_GOOD_ROW_CNT_DISP := to_char( :P3151_GOOD_ROW_CNT, ''999G999G999G999G999G999G990'' );',
'        ',
'        wwv_flow_exec.close_context( p_context => l_context );',
'    end if;',
'exception ',
'    when others then',
'        wwv_flow_exec.close_context( p_context => l_context );',
'        raise;',
'end;'))
,p_attribute_03=>'P3151_GOOD_ROW_CNT,P3151_TABLE_CREATED,P3151_OBJECT_ID,P3151_GOOD_ROW_CNT_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9403535368786317)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog - View Table'
,p_attribute_01=>'P3151_NAME,P3151_OBJECT_ID,P3151_OBJECT_TYPE,P3151_INVALIDATE'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2037465062720149)
,p_process_when=>'P3150_OB_FLAG'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_internal_uid=>9403535368786317
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6004557618547941)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog  - Done'
,p_attribute_01=>'P3151_INVALIDATE'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(6004480099547940)
,p_internal_uid=>6004557618547941
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2039371551720175)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Object ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_object in (',
'    select object_id,',
'           object_name',
'      from sys.dba_objects',
'     where object_name in (:P3150_NEW_COLL_NAME, :P3150_EXISTING_COLL_NAME, :P3150_RELATIONAL_VIEW)',
'       and owner       = :P3150_PARSING_SCHEMA )',
'loop',
'    if l_object.object_name = :P3150_NEW_COLL_NAME and :P3150_LOAD_TO = ''NEW'' then',
'        :P3151_OBJECT_ID := l_object.object_id;',
'        :P3151_NAME      := l_object.object_name;',
'    elsif l_object.object_name = :P3150_EXISTING_COLL_NAME and :P3150_LOAD_TO = ''EXISTING'' then',
'        :P3151_OBJECT_ID := l_object.object_id;',
'        :P3151_NAME      := l_object.object_name;',
'    elsif l_object.object_name = :P3150_RELATIONAL_VIEW then',
'        :P3151_VIEW_OBJ_ID := l_object.object_id;',
'    end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2039371551720175
);
end;
/
prompt --application/pages/page_04000
begin
wwv_flow_imp_page.create_page(
 p_id=>4000
,p_name=>'Blueprints'
,p_alias=>'BLUEPRINTS'
,p_step_title=>'Blueprints'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_step_template=>wwv_flow_imp.id(385762900697898960)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1625680749558014)
,p_plug_name=>'About Data Generator'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Data Generator uses blueprints to generate sample data. Blueprints are JSON files that define the tables and columns that will store the generated data.</p>',
'<p>You can create one from scratch using our Blueprint Designer, import valid blueprints or use existing tables in your schema.</p>',
'<p>Use the links below to explore our built in data types.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1626003657558018)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(3001483965708067)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(704358525679957526)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_required_patch=>wwv_flow_imp.id(1080926199001296276)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2273641094819402)
,p_plug_name=>'Blueprints'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id,',
'       a.name,',
'       case when length(a.description) > 100 then',
'                substr( a.description, 1, 97 ) || ''...''',
'            else',
'                a.description',
'       end description,',
'       a.lang,',
'       a.default_schema,',
'       count(b.id) tables,',
'       (select count(*) from wwv_dg_blueprint_tab_columns where blueprint_table_id in ( select id from wwv_dg_blueprint_tables where blueprint_id = a.id ) ) columns,',
'       (select count(*) from wwv_dg_blueprint_data_sources where blueprint_id = a.id ) data_sources,',
'       a.created_on,',
'       a.created_by,',
'       a.last_updated_on,',
'       a.last_updated_by,',
'       null export,',
'       null generate',
'  from wwv_dg_blueprints a,',
'       wwv_dg_blueprint_tables b',
' where a.id = b.blueprint_id (+)',
'   and a.default_schema = :P4000_SCHEMA',
'   and a.security_group_id = :flow_security_group_id',
' group by a.id, a.name, a.description, a.lang, a.created_on, ',
'          a.created_by, a.last_updated_on, a.last_updated_by,',
'          a.default_schema'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Blueprints'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2273820316819404)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SHAKEEB'
,p_internal_uid=>2273820316819404
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2273981712819405)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2274014012819406)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.:4100:P4100_BLUEPRINT_ID,P4100_SCHEMA:#ID#,#DEFAULT_SCHEMA#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2274108418819407)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2274212953819408)
,p_db_column_name=>'LANG'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2274303717819409)
,p_db_column_name=>'DEFAULT_SCHEMA'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Default Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2274503674819411)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2274616041819412)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2274715331819413)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2274815492819414)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2275608142819422)
,p_db_column_name=>'EXPORT'
,p_display_order=>170
,p_column_identifier=>'Q'
,p_column_label=>'Export'
,p_column_link=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.:4009:P4009_BLUEPRINT_ID:#ID#'
,p_column_linktext=>'Export'
,p_column_link_attr=>'class="a-Button a-Button--small"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2275762852819423)
,p_db_column_name=>'GENERATE'
,p_display_order=>180
,p_column_identifier=>'R'
,p_column_label=>'Generate'
,p_column_link=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.:4005:P4005_BLUEPRINT_ID:#ID#'
,p_column_linktext=>'Generate Data'
,p_column_link_attr=>'class="a-Button a-Button--small"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2275948301819425)
,p_db_column_name=>'TABLES'
,p_display_order=>190
,p_column_identifier=>'T'
,p_column_label=>'Tables'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2276027112819426)
,p_db_column_name=>'COLUMNS'
,p_display_order=>200
,p_column_identifier=>'U'
,p_column_label=>'Columns'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2276241544819428)
,p_db_column_name=>'DATA_SOURCES'
,p_display_order=>210
,p_column_identifier=>'W'
,p_column_label=>'Data Sources'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2288425746427871)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'22885'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:TABLES:COLUMNS:DATA_SOURCES:LAST_UPDATED_ON:LAST_UPDATED_BY:GENERATE:EXPORT:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203817016774964148)
,p_plug_name=>'Data Generation Schema'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Form--leftLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Select the database schema to be used for data generation.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2275460666819420)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2273641094819402)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4000:&SESSION.::&DEBUG.:RR,4000::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11032258787930727)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2273641094819402)
,p_button_name=>'CREATE_BLUEPRINT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Blueprint'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2301071382932536)
,p_name=>'P4000_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(203817016774964148)
,p_prompt=>'Schema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1003_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1003_SCHEMA ) d,',
'       :P1003_SCHEMA v',
'  from sys.dual',
' where :P1003_POPUP = 1',
' order by 1'))
,p_cHeight=>1
,p_tag_css_classes=>'a-Form-field'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2001227187704604)
,p_name=>'Reset Schema'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4000_SCHEMA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2001337248704605)
,p_event_id=>wwv_flow_imp.id(2001227187704604)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Set application item to be used in the generation pages */',
':DATAGEN_SCHEMA := :P4000_SCHEMA;',
'-- The line below sets the schema user globally in the data generator APIs',
'wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'',
'/* Set object browser schema item to be consistent */',
':P2000_OB_SCHEMA := wwv_flow_f4500_ob_wiz_dev.get_workspace_schema_id( p_schema => :DATAGEN_SCHEMA );'))
,p_attribute_02=>'P4000_SCHEMA'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3776740685840043)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4000_SCHEMA is not null then',
'    wwv_flow_sw_api.check_priv(:P4000_SCHEMA);',
'else ',
'    :P4000_SCHEMA := wwv_flow_user_api.get_default_schema;',
'end if;',
'',
'/* Set application item to be used in the generation pages */',
':DATAGEN_SCHEMA := :P4000_SCHEMA;',
'-- The line below sets the schema user globally in the data generator APIs',
'wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'',
'/* Set object browser schema item to be consistent */',
':P2000_OB_SCHEMA := wwv_flow_f4500_ob_wiz_dev.get_workspace_schema_id( p_schema => :DATAGEN_SCHEMA );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3776740685840043
);
end;
/
prompt --application/pages/page_04001
begin
wwv_flow_imp_page.create_page(
 p_id=>4001
,p_name=>'Create Blueprint Wizard'
,p_alias=>'BLUEPRINT-WIZARD'
,p_step_title=>'Create Blueprint'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_step_template=>wwv_flow_imp.id(703368619593851824)
,p_page_css_classes=>'a-Page--createApp'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1625570526558013)
,p_plug_name=>'About Tables Blueprint'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>Use this wizard to quickly create blueprints from scratch, use a valid JSON file or from existing tables in your schema.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4028408027843429)
,p_plug_name=>'Create Tables Blueprint'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4028557786843430)
,p_plug_name=>'Blueprint Options'
,p_region_css_classes=>'mxw780 margin-auto margin-top-lg '
,p_region_sub_css_classes=>'a-MediaList--featuredBlocks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(7502006538093520)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(692727073209839891)
);
end;
/
prompt --application/pages/page_04005
begin
wwv_flow_imp_page.create_page(
 p_id=>4005
,p_name=>'Generate Blueprint Data'
,p_alias=>'GENERATE-DATA-FROM-BLUEPRINT'
,p_page_mode=>'MODAL'
,p_step_title=>'Generate Blueprint Data'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_javascript_code_onload=>'$( ''#table-invalid h2.a-Alert-title'' ).remove();'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.fa {',
'    font-family: inherit !important;',
'    position: relative;',
'}',
'',
'.fa, .fa.fa-sm, .force-fa-lg .fa.fa-sm {',
'    font-size: 16px;',
'}',
'.fa {',
'    speak: none;',
'    font-style: normal;',
'    font-weight: 400;',
'    font-variant: normal;',
'    text-transform: none;',
'    text-rendering: auto;',
'    line-height: 1;',
'    -webkit-font-smoothing: antialiased;',
'    -moz-osx-font-smoothing: grayscale;',
'}',
'.fa, .fa:before {',
'    display: inline-block;',
'    vertical-align: top;',
'}',
'.fa-check-circle {content: "\f058";}'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2709006809590143)
,p_plug_name=>'Generate Data'
,p_region_name=>'generate-data-container'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2709623537590149)
,p_plug_name=>'Valid Blueprint Tables'
,p_region_name=>'table-invalid'
,p_parent_plug_id=>wwv_flow_imp.id(2709006809590143)
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--noIcon:a-Alert--danger:a-Alert--horizontal:a-Form--labelsAbove:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>10
,p_plug_source=>'<p>All Blueprint Tables must be valid in order to generate data.</p>'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id and security_group_id = :flow_security_group_id  )',
'   and a.blueprint_id = :P4005_BLUEPRINT_ID',
'   and a.security_group_id = :flow_security_group_id ',
'union',
'select null',
'  from wwv_dg_blueprints b',
' where not exists ( select * from wwv_dg_blueprint_tables where blueprint_id = b.id and security_group_id = :flow_security_group_id  )',
'   and b.id = :P4005_BLUEPRINT_ID',
'   and b.security_group_id = :flow_security_group_id'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2709740978590150)
,p_name=>'Blueprint Tables'
,p_parent_plug_id=>wwv_flow_imp.id(2709006809590143)
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(a.display_name, a.name) name,',
'       count(b.id) columns,',
'       a.num_rows,',
'       round( :P4005_ROW_SCALING / 100 * a.num_rows ) total,',
'       wwv_flow_lang.system_message(''ODG.TABLE.VALID'') valid_table,',
'       ''u-success-text'' css,',
'       wwv_flow_lang.system_message(''ODG.TABLE.VALID.TOOLTIP'')  tooltip',
'  from wwv_dg_blueprint_tables a,',
'       wwv_dg_blueprint_tab_columns b',
' where a.blueprint_id = :P4005_BLUEPRINT_ID',
'   and a.id = b.blueprint_table_id',
'   and a.security_group_id = :flow_security_group_id ',
' group by a.display_name, a.name, a.num_rows',
' union',
'select nvl(a.display_name, a.name) name,',
'       0 columns,',
'       a.num_rows,',
'       round( :P4005_ROW_SCALING / 100 * a.num_rows ) total,',
'       wwv_flow_lang.system_message(''ODG.TABLE.INVALID'') valid_table,',
'       ''u-danger-text'' css,',
'       wwv_flow_lang.system_message(''ODG.TABLE.INVALID.TOOLTIP'') tooltip',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4005_BLUEPRINT_ID',
'   and a.security_group_id = :flow_security_group_id ',
' group by a.display_name, a.name, a.num_rows;'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4005_BLUEPRINT_ID,P4005_ROW_SCALING'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No tables were found for this blueprint.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2820669445655501)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2820757374655502)
,p_query_column_id=>2
,p_column_alias=>'COLUMNS'
,p_column_display_sequence=>20
,p_column_heading=>'Columns'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2820837900655503)
,p_query_column_id=>3
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>30
,p_column_heading=>'Rows'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2820985782655504)
,p_query_column_id=>4
,p_column_alias=>'TOTAL'
,p_column_display_sequence=>40
,p_column_heading=>'Total'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2821028560655505)
,p_query_column_id=>5
,p_column_alias=>'VALID_TABLE'
,p_column_display_sequence=>50
,p_column_heading=>'Validity'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong class="#CSS#" title="#TOOLTIP#">#VALID_TABLE#</strong>'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2822132112655516)
,p_query_column_id=>6
,p_column_alias=>'CSS'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2821268491655507)
,p_query_column_id=>7
,p_column_alias=>'TOOLTIP'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2821300753655508)
,p_plug_name=>'Buttons Container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2821442443655509)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2821300753655508)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2100937327042609)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2821300753655508)
,p_button_name=>'INSERT_DATA'
,p_button_static_id=>'btn-insert-data'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Insert Data'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2821762946655512)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2821300753655508)
,p_button_name=>'GENERATE_DATA'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Generate Data'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2821910090655514)
,p_branch_name=>'DL_DOC'
,p_branch_action=>'f?p=&APP_ID.:4005:&SESSION.:APPLICATION_PROCESS=DL_DOC:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2821762946655512)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2311777472834427)
,p_name=>'P4005_DG_ACTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2709006809590143)
,p_item_default=>'FILE_EXPORT'
,p_prompt=>'Action'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DG_GENERATED_DATA_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(1701812462624498)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_count     number;',
'begin',
'    for q in',
'    (',
'        select name ',
'          from wwv_dg_blueprint_tables ',
'         where blueprint_id = :P4005_BLUEPRINT_ID',
'    )',
'    loop',
'        select count(*) into l_count ',
'          from sys.dba_objects',
'         where object_type in (''TABLE'')',
'           and object_name = upper(q.name)',
'           and owner = :DATAGEN_SCHEMA;',
'        if l_count > 0 then',
'            return true;',
'        else',
'            return false;',
'        end if;',
'    end loop;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the action you want to take with the generated data:</p>',
'<ul>',
'    <li><strong>File Output:</strong> All generated data will be exported as a JSON, CSV, ZIP or SQL file.</li>',
'    <li><strong>Insert into Database:</strong> All generated data will be inserted into matching tables in the schema.</li>',
'</ul>'))
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2312053866834430)
,p_name=>'P4005_INSERT_METHODS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2709006809590143)
,p_item_default=>'JSON'
,p_prompt=>'Insert Method'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DG_INSERT_DATA_METHODS'
,p_lov=>'.'||wwv_flow_imp.id(2000148335668303)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the insert method for the generated data.</p>',
'<ul>',
'    <li><strong>Insert Into:</strong> Will insert one row at a time. If there are errors on this action, the row will be discarded and the next insert will attempt to run.</li>',
'    <li><strong>Fast Insert Into:</strong> Will insert all rows at once. If the insert fails on a table, no records will be added.</li>',
'</ul>',
'<p>Before inserting be mindful of table constrains and triggers that might prevent successful insert operations.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2709166841590144)
,p_name=>'P4005_BLUEPRINT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2709006809590143)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2709284944590145)
,p_name=>'P4005_BLUEPRINT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2709006809590143)
,p_prompt=>'Blueprint Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'The name of the blueprint.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2709449950590147)
,p_name=>'P4005_FILE_FORMAT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2709006809590143)
,p_item_default=>'JSON'
,p_prompt=>'Output Format'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DG_FILE_OUTPUT_FORMATS'
,p_lov=>'.'||wwv_flow_imp.id(1710780100785805)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the output format of the generated data.</p>',
'<ul>',
'    <li><strong>JavaScript Object Notation (JSON):</strong> outputs a JSON file.</li>',
'    <li><strong>Comma Separated Values (CSV):</strong> If this blueprint has more than one table, it will output a zip file containing a CSV file for each table. Otherwise, it will output a single CSV file.</li>',
'    <li><strong>SQL Insert:</strong> outputs a SQL script with inserts.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2709529766590148)
,p_name=>'P4005_ROW_SCALING'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2709006809590143)
,p_item_default=>'100'
,p_prompt=>'Row Scaling'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DG_SCALING_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(1716336235087650)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Change this value to change the amount of generated data.</p>',
'<p>A value of .25x will generate a quarter of the provided rows. A value of 100x will generate one hundred times the number of provided rows.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2821824377655513)
,p_computation_sequence=>10
,p_computation_item=>'P4005_BLUEPRINT_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'  from wwv_dg_blueprints ',
' where id = :P4005_BLUEPRINT_ID ',
'   and security_group_id = :flow_security_group_id;'))
,p_compute_when=>'P4005_BLUEPRINT_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2822278676655517)
,p_name=>'Toggle Active State of Generate Data Button'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4005_BLUEPRINT_ID',
'   and a.security_group_id = :flow_security_group_id',
'union',
'select null',
'  from wwv_dg_blueprints b',
' where not exists ( select * from wwv_dg_blueprint_tables where blueprint_id = b.id )',
'   and b.id = :P4005_BLUEPRINT_ID',
'   and b.security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2822309618655518)
,p_event_id=>wwv_flow_imp.id(2822278676655517)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2821762946655512)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2822418039655519)
,p_name=>'Update Blueprint Tables Report'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4005_ROW_SCALING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2822563540655520)
,p_event_id=>wwv_flow_imp.id(2822418039655519)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2709740978590150)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2100745350042607)
,p_name=>'Show/Hide Generate Data Button'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4005_DG_ACTION'
,p_condition_element=>'P4005_DG_ACTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'INSERT_INTO_DATABASE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2100802669042608)
,p_event_id=>wwv_flow_imp.id(2100745350042607)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2100937327042609)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2101399084042613)
,p_event_id=>wwv_flow_imp.id(2100745350042607)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2821762946655512)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2101067908042610)
,p_event_id=>wwv_flow_imp.id(2100745350042607)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2821762946655512)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2101280300042612)
,p_event_id=>wwv_flow_imp.id(2100745350042607)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2100937327042609)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2101487031042614)
,p_name=>'Insert Into Tables'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2100937327042609)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2101530756042615)
,p_event_id=>wwv_flow_imp.id(2101487031042614)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSpinner$ = apex.util.showSpinner( $( "#generate-data-container" ) ),',
'    btnInsert$ = $( ''#btn-insert-data'' );',
'',
'btnInsert$.prop( ''disabled'', true );',
'',
'apex.server.process( ',
'    ''INSERT_INTO_TABLES'',',
'    {',
'        x01: apex.item(''P4005_BLUEPRINT_NAME'').getValue(),',
'        x02: apex.item(''P4005_INSERT_METHODS'').getValue(),',
'        x03: apex.item(''P4005_ROW_SCALING'').getValue(),',
'    },',
'    {',
'        success: function( pData ) {',
'            console.log( pData );',
'            lSpinner$.remove();',
'            btnInsert$.prop( ''disabled'', false );',
'            if ( pData.success === true ) {',
'                apex.message.showPageSuccess( pData.message );',
'            } else {',
'                apex.message.showErrors([ { type: "error", location: [ "page" ], message: pData.message, unsafe: true } ]);',
'            }',
'        },',
'        error: function( pError ) {',
'            lSpinner$.remove();',
'            btnInsert$.prop( ''disabled'', false );',
'            apex.message.showErrors([ { type: "error", location: [ "page" ], message: pError.message, unsafe: true } ]);',
'        },',
'        dataType: "json"',
'    }',
');',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2312104951834431)
,p_name=>'Hide insert methods on load'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2312206202834432)
,p_event_id=>wwv_flow_imp.id(2312104951834431)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4005_INSERT_METHODS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2314029109834450)
,p_event_id=>wwv_flow_imp.id(2312104951834431)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2100937327042609)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2312329847834433)
,p_name=>'Toggle Generate Insert formats'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4005_DG_ACTION'
,p_condition_element=>'P4005_DG_ACTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'INSERT_INTO_DATABASE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2312430403834434)
,p_event_id=>wwv_flow_imp.id(2312329847834433)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4005_INSERT_METHODS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2312716082834437)
,p_event_id=>wwv_flow_imp.id(2312329847834433)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4005_INSERT_METHODS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2312886250834438)
,p_name=>'Toggle Generate Output File'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4005_DG_ACTION'
,p_condition_element=>'P4005_DG_ACTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE_EXPORT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2312930298834439)
,p_event_id=>wwv_flow_imp.id(2312886250834438)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4005_FILE_FORMAT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2313180021834441)
,p_event_id=>wwv_flow_imp.id(2312886250834438)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4005_FILE_FORMAT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2059365322585584)
,p_name=>'Close'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2821442443655509)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2059758222585587)
,p_event_id=>wwv_flow_imp.id(2059365322585584)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9840770374941624)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add to Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_errors    clob;',
'begin',
'',
'    wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'    ',
'    wwv_dg_blueprint_util_int.generate_data_into_collection (',
'        p_blueprint       => :P4005_BLUEPRINT_NAME,',
'        p_format          => :P4005_FILE_FORMAT,',
'        p_row_scaling     => :P4005_ROW_SCALING,',
'        p_errors          => l_errors );',
'',
'    if sys.dbms_lob.getlength( l_errors ) > 0 then ',
'        wwv_flow_json.parse( p_source => l_errors );',
'        raise_application_error( -20001, wwv_flow_json.get_varchar2(',
'            p_path => ''odgOutputErrors[0].errors[0].errorText''',
'        ) );',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2821762946655512)
,p_internal_uid=>9840770374941624
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2822013141655515)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'DL_DOC'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_mimetype    varchar2(200);',
'    l_name        varchar2(200) := wwv_flow_escape.html( p_string => :P4005_BLUEPRINT_NAME );',
'    l_filename    varchar2(200);',
'    l_error_check varchar2(100);',
'    l_data_output blob;',
'    l_error_json  clob;',
'begin',
'',
'    for c1 in (select ',
'                      -- Generated data:',
'                      blob001 generated_data,',
'                      c006    file_extension,',
'                      c007    mime_type,',
'                      -- Error handling:',
'                      c001    error_check,',
'                      clob001 error_json',
'                 from wwv_flow_collections',
'                where collection_name = ''APEX$DG$'' || :P4005_BLUEPRINT_NAME',
'                  and seq_id = 1 )',
'    loop',
'        l_mimetype    := c1.mime_type;',
'        l_filename    := lower( replace(l_name, '' '', ''_'') ) || ''.'' || c1.file_extension;',
'        l_data_output := c1.generated_data;',
'        l_error_json  := c1.error_json;',
'        l_error_check := c1.error_check;',
'    end loop;',
'',
'    if nvl( l_error_check, '''' ) = ''ERROR'' then',
'        wwv_flow_json.parse( p_source => l_error_json );',
'        raise_application_error( -20001, wwv_flow_json.get_varchar2(',
'            p_path => ''odgOutputErrors[1].errors[1].errorText''',
'        ) );',
'    else',
'        sys.htp.init;',
'        sys.owa_util.mime_header( l_mimetype, FALSE );',
'        sys.htp.p(''Content-length: '' || sys.dbms_lob.getlength( l_data_output ));',
'        sys.htp.p(''Content-Disposition: attachment; filename="'' || lower( l_filename ) || ''"'' );',
'        sys.owa_util.http_header_close;',
'        sys.wpg_docload.download_file( l_data_output );',
'',
'        wwv_flow.stop_apex_engine;',
'',
'    end if;',
'',
'exception when wwv_flow.e_stop_apex_engine then',
'    NULL;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while generating data.',
'',
'#SQLERRM#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Data successfully generated.'
,p_internal_uid=>2822013141655515
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2101605684042616)
,p_process_sequence=>30
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'INSERT_INTO_TABLES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_output      blob;',
'    l_file_ext    varchar2(100);',
'    l_mime_type   varchar2(200);',
'    l_errors      clob;',
'begin',
'',
'    wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'',
'    wwv_dg_blueprint_util_int.generate_data (',
'            p_blueprint   => replace( WWV_FLOW.g_x01, ''+'', '' ''),',
'            p_format      => replace( WWV_FLOW.g_x02, ''+'', '' ''),',
'            p_row_scaling => WWV_FLOW.g_x03,',
'            p_output      => l_output,',
'            p_file_ext    => l_file_ext,',
'            p_mime_type   => l_mime_type,',
'            p_errors      => l_errors);',
'',
'    if sys.dbms_lob.getlength( l_errors ) > 0 then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( ''success'', false );',
'        wwv_flow_json.write( ''message'', wwv_flow_lang.system_message( ''ODG.BLUEPRINT.INSERT_INTO_ERROR'' ) );',
'        wwv_flow_json.close_object;',
'    else',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( ''success'', true );',
'        wwv_flow_json.write( ''message'', wwv_flow_lang.system_message( ''ODG.BLUEPRINT.SUCCESS_INSERTING_DATA'' ) );',
'        wwv_flow_json.close_object;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'x'
,p_process_success_message=>'x'
,p_internal_uid=>2101605684042616
);
end;
/
prompt --application/pages/page_04007
begin
wwv_flow_imp_page.create_page(
 p_id=>4007
,p_name=>'Create Blueprint from Scratch'
,p_alias=>'BLUEPRINT-FROM-SCRATCH'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Blueprint'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2608830202757614)
,p_plug_name=>'Buttons Container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2608976611757615)
,p_plug_name=>'Define Blueprint'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2609596406757621)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2608830202757614)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2609815188757624)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2608830202757614)
,p_button_name=>'ADD_BLUEPRINT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Blueprint'
,p_button_position=>'CREATE'
,p_button_condition=>'P4007_BLUEPRINT_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1627840228558036)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2608830202757614)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P4007_BLUEPRINT_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1627928540558037)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2608830202757614)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_button_condition=>'P4007_BLUEPRINT_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2875675536149712)
,p_branch_name=>'Go to Blueprint Designer'
,p_branch_action=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.:4100:P4100_BLUEPRINT_ID,P4100_BLUEPRINT_NAME,P4100_SCHEMA:&P4007_BLUEPRINT_ID.,&P4007_NAME.,&DATAGEN_SCHEMA.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'ADD_BLUEPRINT,SAVE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1628010425558038)
,p_branch_name=>'Go To Blueprints on Delete'
,p_branch_action=>'f?p=&APP_ID.:4000:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1627840228558036)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1628225639558040)
,p_name=>'P4007_OLD_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2608976611757615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1649929645792584)
,p_name=>'P4007_SCHEMA'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2608976611757615)
,p_item_default=>':DATAGEN_SCHEMA'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Schema Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS-SC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( c.schema ) d,',
'       c.schema v',
'  from wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
' where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and u.user_name         = :FLOW_USER',
'   and ( u.allow_access_to_schemas is null or',
'         instr( '':'' || u.allow_access_to_schemas || '':'' , '':'' || c.schema || '':'' ) > 0 )',
'   and nvl( :P1003_POPUP , 0 ) <> 1',
' union all ',
'select wwv_flow_escape.html( :P1003_SCHEMA ) d,',
'       :P1003_SCHEMA v',
'  from sys.dual',
' where :P1003_POPUP = 1',
' order by 1'))
,p_cHeight=>1
,p_tag_css_classes=>'a-Form-field'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_retval      boolean := false; -- defaulted to false',
'    l_num_schemas pls_integer;',
'begin',
'    -- Populate the l_num_schemas variable with the number of schemas available in this workspace',
'    select count(*)',
'      into l_num_schemas',
'      from wwv_flow_company_schemas c,',
'           wwv_flow_fnd_user u',
'     where c.security_group_id = :flow_security_group_id and',
'           u.security_group_id = :flow_security_group_id and',
'           u.user_name = :flow_user and',
'           (',
'                u.ALLOW_ACCESS_TO_SCHEMAS is null',
'                or',
'                instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'') > 0',
'           );',
'',
'    -- If there are multiple schemas available in this workspace,',
'    -- then set return value to true, otherwise return l_retval''s defaulted value of false',
'    if l_num_schemas > 1 then',
'        l_retval := true;',
'    end if;',
'    return l_retval;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WRKSP_USER_SCHEMA'
,p_help_text=>'Select the schema you would like this blueprint associated to. Changing this value here, sets the schema user value for your entire session.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003676408704628)
,p_name=>'P4007_DESCRIPTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2608976611757615)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter text that describes this blueprint.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2609083551757616)
,p_name=>'P4007_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2608976611757615)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>200
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for your blueprint.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2609218700757618)
,p_name=>'P4007_LANGUAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2608976611757615)
,p_item_default=>'en'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Currently only the English language is supported. In future releases, this will become a select list of other supported languages.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2609403470757620)
,p_name=>'P4007_BLUEPRINT_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2608976611757615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11032354698930728)
,p_name=>'P4007_SETUP_STARTER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2608976611757615)
,p_item_default=>'Y'
,p_prompt=>'Add Starter Table'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4007_BLUEPRINT_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If selected, a sample blueprint table will be created to demonstrate various functionalities of the Data Generator. No table or data will be added to your schema by selecting this option.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(230002519881015508)
,p_validation_name=>'Blueprint name should be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'  from wwv_dg_blueprints',
' where name = :P4007_NAME',
'   and security_group_id = :flow_security_group_id;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'A blueprint with this name already exists. Please provide a different name.'
,p_when_button_pressed=>wwv_flow_imp.id(2609815188757624)
,p_associated_item=>wwv_flow_imp.id(2609083551757616)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2609664462757622)
,p_name=>'CNX'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2609596406757621)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2609702688757623)
,p_event_id=>wwv_flow_imp.id(2609664462757622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1628374198558041)
,p_name=>'Confirm Blueprint Delete'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1627840228558036)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1628441296558042)
,p_event_id=>wwv_flow_imp.id(1628374198558041)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to delete the  &P4007_NAME. blueprint?'
,p_attribute_02=>'Confirm Blueprint Deletion'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1628589488558043)
,p_event_id=>wwv_flow_imp.id(1628374198558041)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1628682256558044)
,p_name=>'Change Modal Title for Edit'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4007_BLUEPRINT_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1628716066558045)
,p_event_id=>wwv_flow_imp.id(1628682256558044)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$(''#ui-id-1'').html(''Edit Blueprint'');'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2001517690704607)
,p_name=>'Reset Schema'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4007_SCHEMA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2001626133704608)
,p_event_id=>wwv_flow_imp.id(2001517690704607)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Set application item to be used in the generation pages */',
':DATAGEN_SCHEMA := :P4007_SCHEMA;',
'',
'-- The line below sets the schema user globally in the data generator APIs',
'wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'',
'/* Set object browser schema item to be consistent */',
':P2000_OB_SCHEMA := wwv_flow_f4500_ob_wiz_dev.get_workspace_schema_id( p_schema => :DATAGEN_SCHEMA );'))
,p_attribute_02=>'P4007_SCHEMA'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2609968377757625)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Blueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    default_tbl_name   varchar2(100) := ''EMPLOYEES_TBL'';',
'    default_ds_name    varchar2(100) := ''SHIRT_SIZES'';',
'    default_col_1_name varchar2(100) := ''ID'';',
'    default_col_2_name varchar2(100) := ''FIRST_NAME'';',
'    default_col_3_name varchar2(100) := ''LAST_NAME'';',
'    default_col_4_name varchar2(100) := ''EMAIL'';',
'    default_col_5_name varchar2(100) := ''BIRTHDAY'';',
'    default_col_6_name varchar2(100) := ''SKILLSET'';',
'    default_col_7_name varchar2(100) := ''SALARY'';',
'    default_col_8_name varchar2(100) := ''SHIRT_SIZE'';',
'    default_tbl_id     number;',
'    default_ds_id      number;',
'    default_col_1_id   number;',
'    default_col_2_id   number;',
'    default_col_3_id   number;',
'    default_col_4_id   number;',
'    default_col_5_id   number;',
'    default_col_6_id   number;',
'    default_col_7_id   number;',
'    default_col_8_id   number;',
'begin',
'    begin',
'        wwv_dg_data_gen_api.remove_blueprint(',
'            p_name => :P4007_NAME',
'            );',
'    exception when no_data_found then null;',
'    end;',
' ',
'    wwv_dg_data_gen_api.add_blueprint(',
'        p_name           => :P4007_NAME,',
'        p_display_name   => :P4007_NAME,',
'        p_description    => :P4007_DESCRIPTION,',
'        p_default_schema => nvl( :P4007_SCHEMA, :DATAGEN_SCHEMA ),',
'        p_lang           => nvl(:P4007_LANGUAGE, ''en'' ),',
'        p_blueprint_id   => :P4007_BLUEPRINT_ID',
'    );',
'',
'    if :P4007_SETUP_STARTER = ''Y'' then',
'',
'        -- Create a default data source (Query-based as we might not have any tables in the current schema).',
'        wwv_dg_data_gen_api.add_data_source(',
'            p_blueprint        => :P4007_NAME,',
'            p_name             => default_ds_name,',
'            p_data_source_type => ''SQL_QUERY'',',
'            p_sql_query        => q''[select ''S'' shirt_size,''18'' width,''28'' length from sys.dual union all select ''M'' shirt_size,''20'' width,''29'' length from sys.dual union all select ''L'' shirt_size,''22'' width,''30'' length from sys.dual]'',',
'            p_data_source_id   => default_ds_id',
'        );',
'',
'        -- Create a default table from scratch with sample columns.',
'        wwv_dg_data_gen_api.add_table(',
'            p_blueprint    => :P4007_NAME,',
'            p_sequence     => 10,',
'            p_table_name   => default_tbl_name,',
'            p_display_name => initcap( lower( default_tbl_name ) ),',
'            p_rows         => 50,',
'            p_table_id     => default_tbl_id',
'        );',
'',
'        -- Create a default sample columns.',
'        wwv_dg_data_gen_api.add_column(',
'            p_blueprint           => :P4007_NAME,',
'            p_sequence            => 10,',
'            p_table_name          => default_tbl_name,',
'            p_column_name         => default_col_1_name,',
'            p_display_name        => initcap( lower( default_col_1_name ) ),',
'            p_data_source_type    => ''SEQUENCE'',',
'            p_sequence_start_with => 0,',
'            p_sequence_increment  => 1,',
'            p_column_id           => default_col_1_id',
'        );',
'        ',
'        wwv_dg_data_gen_api.add_column(',
'            p_blueprint           => :P4007_NAME,',
'            p_sequence            => 20,',
'            p_table_name          => default_tbl_name,',
'            p_column_name         => default_col_2_name,',
'            p_display_name        => initcap( lower( default_col_2_name ) ),',
'            p_data_source_type    => ''BUILTIN'',',
'            p_data_source         => ''person.first_name'',',
'            p_column_id           => default_col_2_id',
'        );',
'',
'        wwv_dg_data_gen_api.add_column(',
'            p_blueprint           => :P4007_NAME,',
'            p_sequence            => 30,',
'            p_table_name          => default_tbl_name,',
'            p_column_name         => default_col_3_name,',
'            p_display_name        => initcap( lower( default_col_3_name ) ),',
'            p_data_source_type    => ''BUILTIN'',',
'            p_data_source         => ''person.last_name'',',
'            p_column_id           => default_col_3_id',
'        );',
'',
'        wwv_dg_data_gen_api.add_column(',
'            p_blueprint           => :P4007_NAME,',
'            p_sequence            => 40,',
'            p_table_name          => default_tbl_name,',
'            p_column_name         => default_col_4_name,',
'            p_display_name        => initcap( lower( default_col_4_name ) ),',
'            p_data_source_type    => ''FORMULA'',',
'            p_formula             => q''[lower( {FIRST_NAME} || ''.'' || {LAST_NAME} ) || ''@company.com'']'',',
'            p_column_id           => default_col_4_id',
'        );',
'',
'        wwv_dg_data_gen_api.add_column(',
'            p_blueprint           => :P4007_NAME,',
'            p_sequence            => 50,',
'            p_table_name          => default_tbl_name,',
'            p_column_name         => default_col_5_name,',
'            p_display_name        => initcap( lower( default_col_5_name ) ),',
'            p_data_source_type    => ''BUILTIN'',',
'            p_data_source         => ''date.random_past'',',
'            p_percent_blank       => 15,',
'            p_column_id           => default_col_5_id',
'        );',
'',
'        wwv_dg_data_gen_api.add_column(',
'            p_blueprint           => :P4007_NAME,',
'            p_sequence            => 60,',
'            p_table_name          => default_tbl_name,',
'            p_column_name         => default_col_6_name,',
'            p_display_name        => initcap( lower( default_col_6_name ) ),',
'            p_data_source_type    => ''INLINE'',',
'            p_data_source         => ''JavaScript,4;PLSQL,4;Java,2;HTML,6;CSS,3;JQuery,4;Angular,2;NodeJS,2'',',
'            p_multi_value         => ''Y'',',
'            p_mv_format           => ''DELIMITED'',',
'            p_mv_unique           => ''Y'',',
'            p_mv_delimiter        => '':'',',
'            p_mv_min_entries      => 1,',
'            p_mv_max_entries      => 6,',
'            p_percent_blank       => 40,',
'            p_column_id           => default_col_6_id',
'        );',
'',
'        wwv_dg_data_gen_api.add_column(',
'            p_blueprint           => :P4007_NAME,',
'            p_sequence            => 70,',
'            p_table_name          => default_tbl_name,',
'            p_column_name         => default_col_7_name,',
'            p_display_name        => initcap( lower( default_col_7_name ) ),',
'            p_data_source_type    => ''BUILTIN'',',
'            p_data_source         => ''number.random'',',
'            p_min_numeric_value   => 1000,',
'            p_max_numeric_value   => 8000,',
'            p_numeric_precision   => 2,',
'            p_percent_blank       => 75,',
'            p_column_id           => default_col_7_id',
'        );',
'        ',
'        wwv_dg_data_gen_api.add_column(',
'            p_blueprint           => :P4007_NAME,',
'            p_sequence            => 80,',
'            p_table_name          => default_tbl_name,',
'            p_column_name         => default_col_8_name,',
'            p_display_name        => initcap( lower( default_col_8_name ) ),',
'            p_data_source_type    => ''DATA_SOURCE'',',
'            p_data_source         => default_ds_name || ''.shirt_size'',',
'            p_percent_blank       => 50,',
'            p_column_id           => default_col_8_id',
'        );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while creating/saving the blueprint.',
'',
'#SQLERRM#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2609815188757624)
,p_process_success_message=>'Blueprint successfully created.'
,p_internal_uid=>2609968377757625
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1628110410558039)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Blueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_dg_data_gen_api.update_blueprint(',
'        p_name           => :P4007_OLD_NAME,',
'        p_new_name       => :P4007_NAME,',
'        p_description    => :P4007_DESCRIPTION,',
'        p_default_schema => nvl( :P4007_SCHEMA, :DATAGEN_SCHEMA ),',
'        p_lang           => nvl(:P4007_LANGUAGE, ''en'' )',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while updating the blueprint.',
'',
'#SQLERRM#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1627928540558037)
,p_process_when=>'P4007_BLUEPRINT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Blueprint successfully updated.'
,p_internal_uid=>1628110410558039
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1602772922167936)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Blueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dg_data_gen_api.remove_blueprint( ',
'    p_name => :P4007_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while deleting the blueprint.',
'',
'#SQLERRM#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1627840228558036)
,p_process_success_message=>'Blueprint successfully deleted.'
,p_internal_uid=>1602772922167936
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1627777905558035)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Page Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    name,',
'    name as old_name,',
'    description,',
'    lang',
'into',
'    :P4007_NAME,',
'    :P4007_OLD_NAME,',
'    :P4007_DESCRIPTION,',
'    :P4007_LANGUAGE',
'from',
'    WWV_DG_BLUEPRINTS',
'where',
'    id = :P4007_BLUEPRINT_ID',
'and security_group_id = :flow_security_group_id ;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P4007_BLUEPRINT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>1627777905558035
);
end;
/
prompt --application/pages/page_04009
begin
wwv_flow_imp_page.create_page(
 p_id=>4009
,p_name=>'Export Blueprint'
,p_alias=>'EXPORT-BLUEPRINT'
,p_page_mode=>'MODAL'
,p_step_title=>'Export Blueprint'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2706890884590121)
,p_plug_name=>'Blueprint JSON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2707295520590125)
,p_plug_name=>'Buttons Container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2707361331590126)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2707295520590125)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2707670938590129)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2707295520590125)
,p_button_name=>'EXPORT_BLUEPRINT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export Blueprint'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2708822257590141)
,p_branch_name=>'DL_DOC'
,p_branch_action=>'f?p=&APP_ID.:4009:&SESSION.:APPLICATION_PROCESS=DL_DOC:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2707670938590129)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2706922772590122)
,p_name=>'P4009_BLUEPRINT_JSON'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2706890884590121)
,p_prompt=>'Blueprint JSON'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>18
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Click on ''Export Blueprint'' to download it in JavaScript Object Notation (JSON) format.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707004778590123)
,p_name=>'P4009_BLUEPRINT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2706890884590121)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2707154457590124)
,p_name=>'P4009_BLUEPRINT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2706890884590121)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2707488820590127)
,p_name=>'CNX'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2707361331590126)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2707590763590128)
,p_event_id=>wwv_flow_imp.id(2707488820590127)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2707757903590130)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate page items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob clob;',
'begin',
'    for c1 in (',
'        select name',
'        from wwv_dg_blueprints',
'        where id = :P4009_BLUEPRINT_ID',
'    )',
'    loop',
'        :P4009_BLUEPRINT_NAME := c1.name;',
'    end loop;',
'',
'    l_clob := wwv_dg_data_gen_api.export_blueprint( p_name => :P4009_BLUEPRINT_NAME );',
'',
'    if length(l_clob) < 32767 then',
'      :P4009_BLUEPRINT_JSON := l_clob;',
'    else',
'      :P4009_BLUEPRINT_JSON := wwv_flow_lang.system_message( ''ODG.BLUEPRINT.EXPORT_FILE_LIMIT'', :P4009_BLUEPRINT_NAME );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4009_BLUEPRINT_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2707757903590130
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2708914974590142)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'DL_DOC'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_json      clob;',
'    l_file_ext  varchar2(4)   := ''json'';',
'    l_mime_type varchar2(30)  := ''application/json'';',
'    l_name      varchar2(200) := wwv_flow_escape.html( p_string => :P4009_BLUEPRINT_NAME );',
'    l_offset    number        := 1;',
'    l_buffer    pls_integer   := 20000;',
'    l_filename  varchar2(255) := lower( replace( l_name, '' '', ''_'' ) ) || ''.'' || l_file_ext;',
'begin',
'',
'    l_json := wwv_dg_data_gen_api.export_blueprint( p_name => l_name );',
'',
'    sys.htp.init;',
'    ',
'    sys.owa_util.mime_header( l_mime_type, false );',
'    sys.htp.p( ''content-length: '' || sys.dbms_lob.getlength( l_json ) );',
'    sys.htp.p( ''content-disposition: attachment; filename="'' || l_filename || ''"'');',
'    sys.owa_util.http_header_close;',
'',
'    -- looping prints > 32k',
'    loop',
'        exit when l_offset > sys.dbms_lob.getlength( l_json );',
'        sys.htp.prn( sys.dbms_lob.substr( l_json, l_buffer, l_offset ) );',
'        l_offset := l_offset + l_buffer;',
'    end loop;',
'    ',
'    wwv_flow.stop_apex_engine;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while downloading Blueprint JSON.',
'',
'#SQLERRM#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2707670938590129)
,p_process_success_message=>'Blueprint JSON successfully downloaded.'
,p_internal_uid=>2708914974590142
);
end;
/
prompt --application/pages/page_04010
begin
wwv_flow_imp_page.create_page(
 p_id=>4010
,p_name=>'Import Blueprint'
,p_alias=>'IMPORT-BLUEPRINT'
,p_page_mode=>'MODAL'
,p_step_title=>'Import Blueprint'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_inline_css=>'.apex-item-filedrop{ min-block-size: 200px; }'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1626293620558020)
,p_plug_name=>'Choose Source'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1626449957558022)
,p_plug_name=>'Copy Paste'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1626587029558023)
,p_plug_name=>'File'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5252646784892141)
,p_plug_name=>'Buttons Container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5252793193892142)
,p_plug_name=>'Define Blueprint'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>50
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2644474919134532)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5252646784892141)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2644840985134533)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5252646784892141)
,p_button_name=>'IMPORT_BLUEPRINT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Import Blueprint'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2610520133757631)
,p_branch_name=>'Go to Blueprint Designer'
,p_branch_action=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.:4100:P4100_BLUEPRINT_ID,P4100_SCHEMA:&P4010_BLUEPRINT_ID.,&DATAGEN_SCHEMA.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1622019979095046)
,p_name=>'P4010_BP_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1626293620558020)
,p_item_default=>'FILE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(212732804335774230)||'.'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_css_classes=>'apex-button-group a-DataLoad-sourceType'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1622149345095047)
,p_name=>'P4010_BLUEPRINT_FILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1626587029558023)
,p_prompt=>'Upload Blueprint JSON File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_css_classes=>'a-FileDrop data-load-input'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_11=>'application/json'
,p_attribute_12=>'DROPZONE_BLOCK'
,p_attribute_14=>'Upload a valid JSON blueprint file.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2500581458945501)
,p_name=>'P4010_BLUEPRINT_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(5252793193892142)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2645556738134538)
,p_name=>'P4010_OVERRIDE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5252793193892142)
,p_prompt=>'Override Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>200
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Optional: enter a blueprint name to override the value set in the JSON.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2646426579134539)
,p_name=>'P4010_BLUEPRINT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1626449957558022)
,p_prompt=>'Paste Blueprint JSON Text'
,p_placeholder=>'Provide valid Blueprint JSON text here.'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>10
,p_tag_css_classes=>'h200'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2647350633134540)
,p_name=>'P4010_REPLACE_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5252793193892142)
,p_item_default=>'en'
,p_prompt=>'Replace'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(492677255463052067)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'If the blueprint name or the override name already exists and this switch is enabled, this import process will overwrite the existing blueprint, otherwise this import process will fail (so as not to overwrite the existing blueprint).'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1624646356558004)
,p_validation_name=>'Blueprint JSON Text not null'
,p_validation_sequence=>10
,p_validation=>'P4010_BLUEPRINT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4010_BP_TYPE'
,p_validation_condition2=>'COPY_PASTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2644840985134533)
,p_associated_item=>wwv_flow_imp.id(2646426579134539)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1624726801558005)
,p_validation_name=>'Blueprint JSON File not null'
,p_validation_sequence=>20
,p_validation=>'P4010_BLUEPRINT_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4010_BP_TYPE'
,p_validation_condition2=>'FILE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2644840985134533)
,p_associated_item=>wwv_flow_imp.id(1622149345095047)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(63808680822869209)
,p_validation_name=>'is JSON valid'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_blob_content blob;',
'    l_clob_content clob;',
'begin',
'    if :P4010_BP_TYPE = ''COPY_PASTE'' then',
'',
'        return :P4010_BLUEPRINT is json ( strict );',
'    elsif :P4010_BP_TYPE = ''FILE'' and :P4010_BLUEPRINT_FILE is not null then',
'',
'        select blob_content',
'          into l_blob_content',
'          from wwv_flow_temp_files',
'         where name = :P4010_BLUEPRINT_FILE;',
'    ',
'        if sys.dbms_lob.getlength( l_blob_content ) > 0 then',
'            l_clob_content := wwv_flow_utilities.blob_to_clob(l_blob_content);',
'    ',
'            return l_clob_content is json ( strict );',
'        end if;',
'    end if;',
'',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The blueprint must be a valid JSON.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2649085680134545)
,p_name=>'CNX'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2644474919134532)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2649502175134546)
,p_event_id=>wwv_flow_imp.id(2649085680134545)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1622292927095048)
,p_name=>'Toggle Blueprint File or Blueprint Text'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4010_BP_TYPE'
,p_condition_element=>'P4010_BP_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COPY_PASTE'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1622356649095049)
,p_event_id=>wwv_flow_imp.id(1622292927095048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4010_BLUEPRINT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1624463799558002)
,p_event_id=>wwv_flow_imp.id(1622292927095048)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4010_BLUEPRINT_FILE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1622457925095050)
,p_event_id=>wwv_flow_imp.id(1622292927095048)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4010_BLUEPRINT_FILE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1624339559558001)
,p_event_id=>wwv_flow_imp.id(1622292927095048)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4010_BLUEPRINT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2648637438134544)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Import Blueprint Text'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'',
'wwv_dg_data_gen_api.import_blueprint (',
'     p_clob          => :P4010_BLUEPRINT,',
'     p_override_name => :P4010_OVERRIDE_NAME,',
'     p_replace       => case when :P4010_REPLACE_YN = ''Y'' then true',
'                             when :P4010_REPLACE_YN = ''N'' then false end,',
'     p_blueprint_id  => :P4010_BLUEPRINT_ID',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while trying to import the blueprint.',
'',
'#SQLERRM_TEXT#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2644840985134533)
,p_process_when=>'P4010_BP_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'COPY_PASTE'
,p_process_success_message=>'Blueprint successfully imported.'
,p_internal_uid=>2648637438134544
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1624591707558003)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Import Blueprint File'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_blob_content blob;',
'    l_clob_content clob;',
'begin',
'    begin',
'        select blob_content',
'        into l_blob_content',
'        from wwv_flow_temp_files',
'        where name = :P4010_BLUEPRINT_FILE;',
'    exception',
'        when no_data_found then',
'            raise;',
'    end;',
'',
'    -- The code below is temporary and will work with the existing wwv_dg_data_gen_api.import_blueprint()',
'    -- procedure (that only accepts a clob). An overloaded procedure will soon be provided by Insum that',
'    -- accepts a blob. Once that overloaded version of the import_blueprint() procedure is available,',
'    -- the uncommented code below should be removed and the commented out call to',
'    -- wwv_dg_data_gen_api.import_blueprint() (that uses a p_blob parameter) should be uncommented.',
'    -- Allan 9-JUL-2021',
'    if sys.dbms_lob.getlength(l_blob_content) > 0 then',
'        l_clob_content := wwv_flow_utilities.blob_to_clob(l_blob_content);',
'        wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'        wwv_dg_data_gen_api.import_blueprint (',
'            p_clob          => l_clob_content,',
'            p_override_name => :P4010_OVERRIDE_NAME,',
'            p_replace       => case when :P4010_REPLACE_YN = ''Y'' then true',
'                                    when :P4010_REPLACE_YN = ''N'' then false end,',
'            p_blueprint_id  => :P4010_BLUEPRINT_ID',
'        );',
'    end if;',
'',
'',
'    /*',
'    wwv_dg_data_gen_api.import_blueprint (',
'        p_blob          => l_blob_content,',
'        p_override_name => :P4010_OVERRIDE_NAME,',
'        p_replace       => case when :P4010_REPLACE_YN = ''Y'' then true',
'                                when :P4010_REPLACE_YN = ''N'' then false end,',
'        p_blueprint_id  => :P4010_BLUEPRINT_ID',
'    );',
'    */',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while trying to import the blueprint.',
'',
'#SQLERRM_TEXT#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2644840985134533)
,p_process_when=>'P4010_BP_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'FILE'
,p_process_success_message=>'Blueprint successfully imported.'
,p_internal_uid=>1624591707558003
);
end;
/
prompt --application/pages/page_04011
begin
wwv_flow_imp_page.create_page(
 p_id=>4011
,p_name=>'Built Ins'
,p_alias=>'BUILT-INS'
,p_step_title=>'Built Ins'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.example-output{',
'    overflow: hidden;',
'    overflow-wrap: break-word;',
'}',
'.example-json{',
'    display: none;',
'}'))
,p_step_template=>wwv_flow_imp.id(2060528835933702)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_protection_level=>'C'
,p_help_text=>'<p>You can use built ins when creating a new column in your table to populate it with information based on real-world data, accurate to the data type required.</p>'
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2202053589958824)
,p_plug_name=>'Search Results'
,p_region_name=>'builtins-results'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message( p_name => ''ODG.BUILTINS.'' || upper( substr(a.FRIENDLY_NAME, 0, instr(a.FRIENDLY_NAME,''.'') -1 ) ) ) as builtin_category,',
'      wwv_flow_lang.system_message(p_name => ''ODG.BUILTINS.'' || upper(a.friendly_name) ) short_name,',
'      a.friendly_name,',
'      a.native_datatype,',
'      a.example_output',
' from WWV_DG_META_TAB_COLS a'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_no_data_found=>'No Built Ins found'
,p_show_total_row_count=>false
);
wwv_flow_imp_page.create_card(
 p_id=>wwv_flow_imp.id(2205603831832149)
,p_region_id=>wwv_flow_imp.id(2202053589958824)
,p_layout_type=>'GRID'
,p_component_css_classes=>'a-FA-cards'
,p_title_adv_formatting=>true
,p_title_html_expr=>'<h3>&BUILTIN_CATEGORY.: &SHORT_NAME.</h3>'
,p_sub_title_adv_formatting=>false
,p_sub_title_column_name=>'NATIVE_DATATYPE'
,p_body_adv_formatting=>true
,p_body_html_expr=>'<span class="example-json">&EXAMPLE_OUTPUT!RAW.</span>'
,p_second_body_adv_formatting=>false
,p_second_body_column_name=>'FRIENDLY_NAME'
,p_media_adv_formatting=>false
,p_pk1_column_name=>'FRIENDLY_NAME'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2202176807958824)
,p_plug_name=>'Filters'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(2202053589958824)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'compact_numbers_threshold', '10000',
  'current_facets_selector', '#active_facets',
  'display_chart_for_top_n_values', '10',
  'show_charts', 'Y',
  'show_current_facets', 'E',
  'show_total_row_count', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2202675784958832)
,p_name=>'P4011_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2202176807958824)
,p_prompt=>'Search'
,p_source=>'BUILTIN_CATEGORY,SHORT_NAME,FRIENDLY_NAME,NATIVE_DATATYPE,USAGE_NOTES,COMMENTS,BODY,EXAMPLE_OUTPUT'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_filter_values=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2205426681832147)
,p_name=>'P4011_CATEGORY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2202176807958824)
,p_prompt=>'Category'
,p_source=>'BUILTIN_CATEGORY'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>50
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2205794990832150)
,p_name=>'P4011_RETURN_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2202176807958824)
,p_prompt=>'Return Type'
,p_source=>'NATIVE_DATATYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
end;
/
prompt --application/pages/page_04012
begin
wwv_flow_imp_page.create_page(
 p_id=>4012
,p_name=>'Preview Blueprint Data'
,p_alias=>'PREVIEW-DATA-FROM-BLUEPRINT'
,p_page_mode=>'MODAL'
,p_step_title=>'Preview Blueprint Data'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_javascript_code_onload=>'$( ".slim-info h2.a-Alert-title" ).remove();'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.fa {',
'    font-family: inherit !important;',
'    position: relative;',
'}',
'',
'.fa, .fa.fa-sm, .force-fa-lg .fa.fa-sm {',
'    font-size: 16px;',
'}',
'.fa {',
'    speak: none;',
'    font-style: normal;',
'    font-weight: 400;',
'    font-variant: normal;',
'    text-transform: none;',
'    text-rendering: auto;',
'    line-height: 1;',
'    -webkit-font-smoothing: antialiased;',
'    -moz-osx-font-smoothing: grayscale;',
'}',
'.fa, .fa:before {',
'    display: inline-block;',
'    vertical-align: top;',
'}',
'.fa-check-circle {content: "\f058";}'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6209553206794390)
,p_plug_name=>'Generate Data'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4242248611412745)
,p_plug_name=>'Invalid Tables Exist'
,p_region_name=>'table-invalid'
,p_parent_plug_id=>wwv_flow_imp.id(6209553206794390)
,p_region_css_classes=>'slim-info'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--noIcon:a-Alert--danger:a-Alert--horizontal:a-Form--labelsAbove:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>50
,p_plug_source=>'<p>All Blueprint Tables must be valid in order to generate data.</p>'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4012_BLUEPRINT_ID',
'   and a.security_group_id = :flow_security_group_id',
'union',
'select null',
'  from wwv_dg_blueprints b',
' where not exists ( select * from wwv_dg_blueprint_tables where blueprint_id = b.id )',
'   and b.id = :P4012_BLUEPRINT_ID',
'   and b.security_group_id = :flow_security_group_id;'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5010831789703028)
,p_name=>'Preview Data'
,p_parent_plug_id=>wwv_flow_imp.id(6209553206794390)
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002,',
'       c003,',
'       c004,',
'       c005,',
'       c006,',
'       c007,',
'       c008,',
'       c009,',
'       c010,',
'       c011,',
'       c012,',
'       c013,',
'       c014,',
'       c015,',
'       c016,',
'       c017,',
'       c018,',
'       c019,',
'       c020,',
'       c021,',
'       c022,',
'       c023,',
'       c024,',
'       c025,',
'       c026,',
'       c027,',
'       c028,',
'       c029,',
'       c030,',
'       c031,',
'       c032,',
'       c033,',
'       c034,',
'       c035,',
'       c036,',
'       c037,',
'       c038,',
'       c039,',
'       c040,',
'       c041,',
'       c042,',
'       c043,',
'       c044,',
'       c045,',
'       c046,',
'       c047,',
'       c048,',
'       c049,',
'       c050',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c001 = :P4012_TABLE_LIST;'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4012_BLUEPRINT_ID',
'   and a.security_group_id = :flow_security_group_id',
'union',
'select null',
'  from wwv_dg_blueprints b',
' where not exists ( select * from wwv_dg_blueprint_tables where blueprint_id = b.id )',
'   and b.id = :P4012_BLUEPRINT_ID',
'   and b.security_group_id = :flow_security_group_id;'))
,p_display_condition_type=>'NOT_EXISTS'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4012_TABLE_LIST'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_headers varchar2(1000);',
'begin',
'    select            c002||'':''||c003||'':''||c004||'':''||c005||'':''||c006||'':''||c007||'':''||c008||'':''||c009||'':''||c010||'':''||',
'           c011||'':''||c012||'':''||c013||'':''||c014||'':''||c015||'':''||c016||'':''||c017||'':''||c018||'':''||c019||'':''||c020||'':''||',
'           c021||'':''||c022||'':''||c023||'':''||c024||'':''||c025||'':''||c026||'':''||c027||'':''||c028||'':''||c029||'':''||c030||'':''||',
'           c031||'':''||c032||'':''||c033||'':''||c034||'':''||c035||'':''||c036||'':''||c037||'':''||c038||'':''||c039||'':''||c040||'':''||',
'           c041||'':''||c042||'':''||c043||'':''||c044||'':''||c045||'':''||c046||'':''||c047||'':''||c048||'':''||c049||'':''||c050',
'      into l_headers',
'      from wwv_flow_collections',
'     where collection_name = ''PREVIEW_DATA_HEADERS''',
'       and c001 = :P4012_TABLE_LIST;',
'    ',
'    return l_headers;',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Select a table to preview data.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5010966973703029)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>10
,p_column_heading=>'C002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c002 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011095718703030)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>20
,p_column_heading=>'C003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c003 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011172254703031)
,p_query_column_id=>3
,p_column_alias=>'C004'
,p_column_display_sequence=>30
,p_column_heading=>'C004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c004 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011296084703032)
,p_query_column_id=>4
,p_column_alias=>'C005'
,p_column_display_sequence=>40
,p_column_heading=>'C005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c005 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011396725703033)
,p_query_column_id=>5
,p_column_alias=>'C006'
,p_column_display_sequence=>50
,p_column_heading=>'C006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c006 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011454895703034)
,p_query_column_id=>6
,p_column_alias=>'C007'
,p_column_display_sequence=>60
,p_column_heading=>'C007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c007 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011565526703035)
,p_query_column_id=>7
,p_column_alias=>'C008'
,p_column_display_sequence=>70
,p_column_heading=>'C008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c008 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011682647703036)
,p_query_column_id=>8
,p_column_alias=>'C009'
,p_column_display_sequence=>80
,p_column_heading=>'C009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c009 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011794779703037)
,p_query_column_id=>9
,p_column_alias=>'C010'
,p_column_display_sequence=>90
,p_column_heading=>'C010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c010 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011883340703038)
,p_query_column_id=>10
,p_column_alias=>'C011'
,p_column_display_sequence=>100
,p_column_heading=>'C011'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c011 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5011994673703039)
,p_query_column_id=>11
,p_column_alias=>'C012'
,p_column_display_sequence=>110
,p_column_heading=>'C012'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c012 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012059709703040)
,p_query_column_id=>12
,p_column_alias=>'C013'
,p_column_display_sequence=>120
,p_column_heading=>'C013'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c013 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012122891703041)
,p_query_column_id=>13
,p_column_alias=>'C014'
,p_column_display_sequence=>130
,p_column_heading=>'C014'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c014 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012213922703042)
,p_query_column_id=>14
,p_column_alias=>'C015'
,p_column_display_sequence=>140
,p_column_heading=>'C015'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c015 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012310476703043)
,p_query_column_id=>15
,p_column_alias=>'C016'
,p_column_display_sequence=>150
,p_column_heading=>'C016'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c016 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012434717703044)
,p_query_column_id=>16
,p_column_alias=>'C017'
,p_column_display_sequence=>160
,p_column_heading=>'C017'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c017 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012518861703045)
,p_query_column_id=>17
,p_column_alias=>'C018'
,p_column_display_sequence=>170
,p_column_heading=>'C018'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c018 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012661403703046)
,p_query_column_id=>18
,p_column_alias=>'C019'
,p_column_display_sequence=>180
,p_column_heading=>'C019'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c019 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012751920703047)
,p_query_column_id=>19
,p_column_alias=>'C020'
,p_column_display_sequence=>190
,p_column_heading=>'C020'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c020 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012830476703048)
,p_query_column_id=>20
,p_column_alias=>'C021'
,p_column_display_sequence=>200
,p_column_heading=>'C021'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c021 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5012948725703049)
,p_query_column_id=>21
,p_column_alias=>'C022'
,p_column_display_sequence=>210
,p_column_heading=>'C022'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c022 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5013049835703050)
,p_query_column_id=>22
,p_column_alias=>'C023'
,p_column_display_sequence=>220
,p_column_heading=>'C023'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c023 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2200808212832101)
,p_query_column_id=>23
,p_column_alias=>'C024'
,p_column_display_sequence=>230
,p_column_heading=>'C024'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c024 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2200944901832102)
,p_query_column_id=>24
,p_column_alias=>'C025'
,p_column_display_sequence=>240
,p_column_heading=>'C025'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c025 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201015200832103)
,p_query_column_id=>25
,p_column_alias=>'C026'
,p_column_display_sequence=>250
,p_column_heading=>'C026'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c026 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201198813832104)
,p_query_column_id=>26
,p_column_alias=>'C027'
,p_column_display_sequence=>260
,p_column_heading=>'C027'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c027 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201266101832105)
,p_query_column_id=>27
,p_column_alias=>'C028'
,p_column_display_sequence=>270
,p_column_heading=>'C028'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c028 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201342951832106)
,p_query_column_id=>28
,p_column_alias=>'C029'
,p_column_display_sequence=>280
,p_column_heading=>'C029'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c029 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201455698832107)
,p_query_column_id=>29
,p_column_alias=>'C030'
,p_column_display_sequence=>290
,p_column_heading=>'C030'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c030 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201582873832108)
,p_query_column_id=>30
,p_column_alias=>'C031'
,p_column_display_sequence=>300
,p_column_heading=>'C031'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c031 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201647917832109)
,p_query_column_id=>31
,p_column_alias=>'C032'
,p_column_display_sequence=>310
,p_column_heading=>'C032'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c032 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201730866832110)
,p_query_column_id=>32
,p_column_alias=>'C033'
,p_column_display_sequence=>320
,p_column_heading=>'C033'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c033 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201828032832111)
,p_query_column_id=>33
,p_column_alias=>'C034'
,p_column_display_sequence=>330
,p_column_heading=>'C034'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c034 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2201998988832112)
,p_query_column_id=>34
,p_column_alias=>'C035'
,p_column_display_sequence=>340
,p_column_heading=>'C035'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c035 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202014499832113)
,p_query_column_id=>35
,p_column_alias=>'C036'
,p_column_display_sequence=>350
,p_column_heading=>'C036'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c036 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202118638832114)
,p_query_column_id=>36
,p_column_alias=>'C037'
,p_column_display_sequence=>360
,p_column_heading=>'C037'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c037 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202230492832115)
,p_query_column_id=>37
,p_column_alias=>'C038'
,p_column_display_sequence=>370
,p_column_heading=>'C038'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c038 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202390788832116)
,p_query_column_id=>38
,p_column_alias=>'C039'
,p_column_display_sequence=>380
,p_column_heading=>'C039'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c039 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202428004832117)
,p_query_column_id=>39
,p_column_alias=>'C040'
,p_column_display_sequence=>390
,p_column_heading=>'C040'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c040 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202562685832118)
,p_query_column_id=>40
,p_column_alias=>'C041'
,p_column_display_sequence=>400
,p_column_heading=>'C041'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c041 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202632518832119)
,p_query_column_id=>41
,p_column_alias=>'C042'
,p_column_display_sequence=>410
,p_column_heading=>'C042'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c042 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202713960832120)
,p_query_column_id=>42
,p_column_alias=>'C043'
,p_column_display_sequence=>420
,p_column_heading=>'C043'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c043 is not null',
'   and c001 = :P4012_TABLE_LIST'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202887478832121)
,p_query_column_id=>43
,p_column_alias=>'C044'
,p_column_display_sequence=>430
,p_column_heading=>'C044'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c044 is not null',
'   and c001 = :P4012_TABLE_LIST;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202929068832122)
,p_query_column_id=>44
,p_column_alias=>'C045'
,p_column_display_sequence=>440
,p_column_heading=>'C045'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c045 is not null',
'   and c001 = :P4012_TABLE_LIST;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2203064480832123)
,p_query_column_id=>45
,p_column_alias=>'C046'
,p_column_display_sequence=>450
,p_column_heading=>'C046'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c046 is not null',
'   and c001 = :P4012_TABLE_LIST;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2203121230832124)
,p_query_column_id=>46
,p_column_alias=>'C047'
,p_column_display_sequence=>460
,p_column_heading=>'C047'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c047 is not null',
'   and c001 = :P4012_TABLE_LIST;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2203281919832125)
,p_query_column_id=>47
,p_column_alias=>'C048'
,p_column_display_sequence=>470
,p_column_heading=>'C048'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c048 is not null',
'   and c001 = :P4012_TABLE_LIST;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2203368886832126)
,p_query_column_id=>48
,p_column_alias=>'C049'
,p_column_display_sequence=>480
,p_column_heading=>'C049'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c049 is not null',
'   and c001 = :P4012_TABLE_LIST;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2203461858832127)
,p_query_column_id=>49
,p_column_alias=>'C050'
,p_column_display_sequence=>490
,p_column_heading=>'C050'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c050 is not null',
'   and c001 = :P4012_TABLE_LIST;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(6613115808010561)
,p_name=>'Blueprint Tables'
,p_region_name=>'table-invalid'
,p_parent_plug_id=>wwv_flow_imp.id(6209553206794390)
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.name,',
'       count(b.id) columns,',
'       a.num_rows,',
'       wwv_flow_lang.system_message(''ODG.TABLE.VALID'')  valid_table,',
'       ''u-success-text'' css,',
'       wwv_flow_lang.system_message(''ODG.TABLE.VALID.TOOLTIP'')  tooltip',
'  from wwv_dg_blueprint_tables a,',
'       wwv_dg_blueprint_tab_columns b',
' where a.blueprint_id = :P4012_BLUEPRINT_ID',
'   and a.id = b.blueprint_table_id',
'   and a.security_group_id = :flow_security_group_id',
'   and b.security_group_id = a.security_group_id',
' group by a.display_name, a.name, a.num_rows',
' union',
'select nvl(a.display_name, a.name) name,',
'       0 columns,',
'       a.num_rows,',
'       wwv_flow_lang.system_message(''ODG.TABLE.INVALID'')  valid_table,',
'       ''u-danger-text'' css,',
'       wwv_flow_lang.system_message(''ODG.TABLE.INVALID.TOOLTIP'')  tooltip',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4012_BLUEPRINT_ID',
'   and a.security_group_id = :flow_security_group_id',
' group by a.display_name, a.name, a.num_rows;'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4012_BLUEPRINT_ID',
'   and a.security_group_id = :flow_security_group_id',
'union',
'select null',
'  from wwv_dg_blueprints b',
' where not exists ( select * from wwv_dg_blueprint_tables where blueprint_id = b.id )',
'   and b.id = :P4012_BLUEPRINT_ID',
'   and b.security_group_id = :flow_security_group_id;'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4012_BLUEPRINT_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No tables were found for this blueprint.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3903675268420420)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3904094318420420)
,p_query_column_id=>2
,p_column_alias=>'COLUMNS'
,p_column_display_sequence=>20
,p_column_heading=>'Columns'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3904460662420421)
,p_query_column_id=>3
,p_column_alias=>'NUM_ROWS'
,p_column_display_sequence=>30
,p_column_heading=>'Rows'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3905226963420422)
,p_query_column_id=>4
,p_column_alias=>'VALID_TABLE'
,p_column_display_sequence=>50
,p_column_heading=>'Validity'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong class="#CSS#" title="#TOOLTIP#">#VALID_TABLE#</strong>'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3905668426420423)
,p_query_column_id=>5
,p_column_alias=>'CSS'
,p_column_display_sequence=>80
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3906053020420423)
,p_query_column_id=>6
,p_column_alias=>'TOOLTIP'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6321847150859755)
,p_plug_name=>'Buttons Container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3507816806204305)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(6321847150859755)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3508242293204306)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6321847150859755)
,p_button_name=>'GENERATE_DATA'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(690706750701136097)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Generate Data'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.:4005:P4005_BLUEPRINT_ID:&P4012_BLUEPRINT_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3501160051204291)
,p_name=>'P4012_BLUEPRINT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6209553206794390)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3501552847204294)
,p_name=>'P4012_BLUEPRINT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6209553206794390)
,p_prompt=>'Blueprint Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'The name of the blueprint.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5010796061703027)
,p_name=>'P4012_TABLE_LIST'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(6209553206794390)
,p_prompt=>'Table List'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d,',
'       name r',
'  from wwv_dg_blueprint_tables',
' where blueprint_id = :P4012_BLUEPRINT_ID',
'   and security_group_id = :flow_security_group_id'))
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4012_BLUEPRINT_ID',
'   and a.security_group_id = :flow_security_group_id',
'union',
'select null',
'  from wwv_dg_blueprints b',
' where not exists ( select * from wwv_dg_blueprint_tables where blueprint_id = b.id )',
'   and b.id = :P4012_BLUEPRINT_ID',
'   and b.security_group_id = :flow_security_group_id;'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a table from the blueprint to preview its data.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(223041722504792206)
,p_name=>'P4012_PREVIEW_SIZE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(6209553206794390)
,p_item_default=>'5'
,p_prompt=>'Preview Size'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:5;5,10;10,15;15'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Change the number of rows shown in the preview.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3508768151204318)
,p_computation_sequence=>10
,p_computation_item=>'P4012_BLUEPRINT_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>'select name from wwv_dg_blueprints where id = :P4012_BLUEPRINT_ID;'
,p_compute_when=>'P4012_BLUEPRINT_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3510742936204322)
,p_name=>'Toggle Active State of Generate Data Button'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4012_BLUEPRINT_ID',
'   and a.security_group_id = :flow_security_group_id',
'union',
'select null',
'  from wwv_dg_blueprints b',
' where not exists ( select * from wwv_dg_blueprint_tables where blueprint_id = b.id )',
'   and b.id = :P4012_BLUEPRINT_ID',
'   and b.security_group_id = :flow_security_group_id;'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3511250778204323)
,p_event_id=>wwv_flow_imp.id(3510742936204322)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3508242293204306)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2203712222832130)
,p_name=>'Generate Preview'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4012_TABLE_LIST'
,p_condition_element=>'P4012_TABLE_LIST'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2020456243310117)
,p_event_id=>wwv_flow_imp.id(2203712222832130)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5010831789703028)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2020289972310115)
,p_event_id=>wwv_flow_imp.id(2203712222832130)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5010831789703028)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2020330752310116)
,p_event_id=>wwv_flow_imp.id(2203712222832130)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5010831789703028)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(223041867964792207)
,p_name=>'Reload on Change'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4012_PREVIEW_SIZE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(223041980138792208)
,p_event_id=>wwv_flow_imp.id(223041867964792207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2602544158711724)
,p_name=>'Close'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3507816806204305)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2602660949711725)
,p_event_id=>wwv_flow_imp.id(2602544158711724)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2204502016832138)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists( p_collection_name => ''PREVIEW_DATA'' ) then ',
'    wwv_flow_collection.delete_collection(',
'        p_collection_name => ''PREVIEW_DATA'' );',
'end if;',
'',
'if wwv_flow_collection.collection_exists( p_collection_name => ''PREVIEW_DATA_HEADERS'' ) then',
'    wwv_flow_collection.delete_collection (',
'        p_collection_name => ''PREVIEW_DATA_HEADERS'' );',
'end if;',
'',
'wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'wwv_dg_blueprint_util_int.preview_blueprint(',
'    p_blueprint         => :P4012_BLUEPRINT_NAME,',
'    p_number_of_rows    => nvl(:P4012_PREVIEW_SIZE, 5),',
'    p_data_collection   => ''PREVIEW_DATA'',',
'    p_header_collection => ''PREVIEW_DATA_HEADERS''',
');'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2204502016832138
);
end;
/
prompt --application/pages/page_04014
begin
wwv_flow_imp_page.create_page(
 p_id=>4014
,p_name=>'Preview Table Data'
,p_alias=>'PREVIEW-DATA-FROM-TABLE'
,p_page_mode=>'MODAL'
,p_step_title=>'Preview Table Data'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_javascript_code_onload=>'$( ''.slim-info h2.a-Alert-title'' ).remove();'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6655701226959434)
,p_plug_name=>'Generate Data'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5943469502822034)
,p_plug_name=>'Invalid Tables Exist'
,p_region_name=>'table-invalid'
,p_parent_plug_id=>wwv_flow_imp.id(6655701226959434)
,p_region_css_classes=>'slim-info'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--noIcon:a-Alert--danger:a-Alert--horizontal:a-Form--labelsAbove:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_imp.id(746376253838324384)
,p_plug_display_sequence=>10
,p_plug_source=>'<p>Previewing the &P4014_TABLE_NAME. table cannot be done as the table contains no columns or is invalid.</p>'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4014_BP_ID',
'   and a.security_group_id = :flow_security_group_id'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(7746543825602622)
,p_name=>'Sample Data Preview'
,p_parent_plug_id=>wwv_flow_imp.id(6655701226959434)
,p_template=>wwv_flow_imp.id(380771699411878611)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002,',
'       c003,',
'       c004,',
'       c005,',
'       c006,',
'       c007,',
'       c008,',
'       c009,',
'       c010,',
'       c011,',
'       c012,',
'       c013,',
'       c014,',
'       c015,',
'       c016,',
'       c017,',
'       c018,',
'       c019,',
'       c020,',
'       c021,',
'       c022,',
'       c023,',
'       c024,',
'       c025,',
'       c026,',
'       c027,',
'       c028,',
'       c029,',
'       c030,',
'       c031,',
'       c032,',
'       c033,',
'       c034,',
'       c035,',
'       c036,',
'       c037,',
'       c038,',
'       c039,',
'       c040,',
'       c041,',
'       c042,',
'       c043,',
'       c044,',
'       c045,',
'       c046,',
'       c047,',
'       c048,',
'       c049,',
'       c050',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA'';'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4014_BP_ID',
'   and a.security_group_id = :flow_security_group_id'))
,p_display_condition_type=>'NOT_EXISTS'
,p_header=>'<p>Previewed below are the first 10 rows (or less) of data that will be generated in the &P4014_TABLE_NAME. table.</p>'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(717436155076828097)
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_headers clob;',
'begin',
'    select            c002||'':''||c003||'':''||c004||'':''||c005||'':''||c006||'':''||c007||'':''||c008||'':''||c009||'':''||c010||'':''||',
'           c011||'':''||c012||'':''||c013||'':''||c014||'':''||c015||'':''||c016||'':''||c017||'':''||c018||'':''||c019||'':''||c020||'':''||',
'           c021||'':''||c022||'':''||c023||'':''||c024||'':''||c025||'':''||c026||'':''||c027||'':''||c028||'':''||c029||'':''||c030||'':''||',
'           c031||'':''||c032||'':''||c033||'':''||c034||'':''||c035||'':''||c036||'':''||c037||'':''||c038||'':''||c039||'':''||c040||'':''||',
'           c041||'':''||c042||'':''||c043||'':''||c044||'':''||c045||'':''||c046||'':''||c047||'':''||c048||'':''||c049||'':''||c050',
'      into l_headers',
'      from wwv_flow_collections',
'     where collection_name = ''PREVIEW_DATA_HEADERS'';',
'    ',
'    return l_headers;',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3839174433303942)
,p_query_column_id=>1
,p_column_alias=>'C002'
,p_column_display_sequence=>40
,p_column_heading=>'C002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3839507019303945)
,p_query_column_id=>2
,p_column_alias=>'C003'
,p_column_display_sequence=>50
,p_column_heading=>'C003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c003 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3839910507303945)
,p_query_column_id=>3
,p_column_alias=>'C004'
,p_column_display_sequence=>60
,p_column_heading=>'C004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c004 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3840380798303945)
,p_query_column_id=>4
,p_column_alias=>'C005'
,p_column_display_sequence=>70
,p_column_heading=>'C005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c005 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3840754075303946)
,p_query_column_id=>5
,p_column_alias=>'C006'
,p_column_display_sequence=>80
,p_column_heading=>'C006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c006 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3841168218303947)
,p_query_column_id=>6
,p_column_alias=>'C007'
,p_column_display_sequence=>90
,p_column_heading=>'C007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c007 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3841575351303947)
,p_query_column_id=>7
,p_column_alias=>'C008'
,p_column_display_sequence=>130
,p_column_heading=>'C008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c008 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3841906116303947)
,p_query_column_id=>8
,p_column_alias=>'C009'
,p_column_display_sequence=>140
,p_column_heading=>'C009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c009 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3842364647303948)
,p_query_column_id=>9
,p_column_alias=>'C010'
,p_column_display_sequence=>150
,p_column_heading=>'C010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c010 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3772628072840002)
,p_query_column_id=>10
,p_column_alias=>'C011'
,p_column_display_sequence=>160
,p_column_heading=>'C011'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c011 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3772735111840003)
,p_query_column_id=>11
,p_column_alias=>'C012'
,p_column_display_sequence=>170
,p_column_heading=>'C012'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c012 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3772828842840004)
,p_query_column_id=>12
,p_column_alias=>'C013'
,p_column_display_sequence=>180
,p_column_heading=>'C013'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c013 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3772973399840005)
,p_query_column_id=>13
,p_column_alias=>'C014'
,p_column_display_sequence=>190
,p_column_heading=>'C014'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c014 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773004291840006)
,p_query_column_id=>14
,p_column_alias=>'C015'
,p_column_display_sequence=>200
,p_column_heading=>'C015'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c015 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773160260840007)
,p_query_column_id=>15
,p_column_alias=>'C016'
,p_column_display_sequence=>210
,p_column_heading=>'C016'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c016 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773294429840008)
,p_query_column_id=>16
,p_column_alias=>'C017'
,p_column_display_sequence=>220
,p_column_heading=>'C017'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c017 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773336914840009)
,p_query_column_id=>17
,p_column_alias=>'C018'
,p_column_display_sequence=>230
,p_column_heading=>'C018'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c018 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773453680840010)
,p_query_column_id=>18
,p_column_alias=>'C019'
,p_column_display_sequence=>240
,p_column_heading=>'C019'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c019 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773558107840011)
,p_query_column_id=>19
,p_column_alias=>'C020'
,p_column_display_sequence=>250
,p_column_heading=>'C020'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c020 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773623290840012)
,p_query_column_id=>20
,p_column_alias=>'C021'
,p_column_display_sequence=>260
,p_column_heading=>'C021'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c021 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773739157840013)
,p_query_column_id=>21
,p_column_alias=>'C022'
,p_column_display_sequence=>270
,p_column_heading=>'C022'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c022 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773812317840014)
,p_query_column_id=>22
,p_column_alias=>'C023'
,p_column_display_sequence=>280
,p_column_heading=>'C023'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c023 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3773989896840015)
,p_query_column_id=>23
,p_column_alias=>'C024'
,p_column_display_sequence=>290
,p_column_heading=>'C024'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c024 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774083743840016)
,p_query_column_id=>24
,p_column_alias=>'C025'
,p_column_display_sequence=>300
,p_column_heading=>'C025'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c025 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774165102840017)
,p_query_column_id=>25
,p_column_alias=>'C026'
,p_column_display_sequence=>310
,p_column_heading=>'C026'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c026 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774276261840018)
,p_query_column_id=>26
,p_column_alias=>'C027'
,p_column_display_sequence=>320
,p_column_heading=>'C027'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c027 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774352386840019)
,p_query_column_id=>27
,p_column_alias=>'C028'
,p_column_display_sequence=>330
,p_column_heading=>'C028'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c028 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774473342840020)
,p_query_column_id=>28
,p_column_alias=>'C029'
,p_column_display_sequence=>340
,p_column_heading=>'C029'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c029 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774598530840021)
,p_query_column_id=>29
,p_column_alias=>'C030'
,p_column_display_sequence=>350
,p_column_heading=>'C030'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c030 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774683511840022)
,p_query_column_id=>30
,p_column_alias=>'C031'
,p_column_display_sequence=>360
,p_column_heading=>'C031'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c031 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774756613840023)
,p_query_column_id=>31
,p_column_alias=>'C032'
,p_column_display_sequence=>370
,p_column_heading=>'C032'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c032 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774883579840024)
,p_query_column_id=>32
,p_column_alias=>'C033'
,p_column_display_sequence=>380
,p_column_heading=>'C033'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c033 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3774987496840025)
,p_query_column_id=>33
,p_column_alias=>'C034'
,p_column_display_sequence=>390
,p_column_heading=>'C034'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c034 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775064234840026)
,p_query_column_id=>34
,p_column_alias=>'C035'
,p_column_display_sequence=>400
,p_column_heading=>'C035'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c035 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775142575840027)
,p_query_column_id=>35
,p_column_alias=>'C036'
,p_column_display_sequence=>410
,p_column_heading=>'C036'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c036 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775237958840028)
,p_query_column_id=>36
,p_column_alias=>'C037'
,p_column_display_sequence=>420
,p_column_heading=>'C037'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c037 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775362657840029)
,p_query_column_id=>37
,p_column_alias=>'C038'
,p_column_display_sequence=>430
,p_column_heading=>'C038'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c038 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775452042840030)
,p_query_column_id=>38
,p_column_alias=>'C039'
,p_column_display_sequence=>440
,p_column_heading=>'C039'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c039 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775576389840031)
,p_query_column_id=>39
,p_column_alias=>'C040'
,p_column_display_sequence=>450
,p_column_heading=>'C040'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c040 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775699733840032)
,p_query_column_id=>40
,p_column_alias=>'C041'
,p_column_display_sequence=>460
,p_column_heading=>'C041'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c041 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775788364840033)
,p_query_column_id=>41
,p_column_alias=>'C042'
,p_column_display_sequence=>470
,p_column_heading=>'C042'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c042 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775896593840034)
,p_query_column_id=>42
,p_column_alias=>'C043'
,p_column_display_sequence=>480
,p_column_heading=>'C043'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c043 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3775987395840035)
,p_query_column_id=>43
,p_column_alias=>'C044'
,p_column_display_sequence=>490
,p_column_heading=>'C044'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c044 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3776044774840036)
,p_query_column_id=>44
,p_column_alias=>'C045'
,p_column_display_sequence=>500
,p_column_heading=>'C045'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c045 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3776158451840037)
,p_query_column_id=>45
,p_column_alias=>'C046'
,p_column_display_sequence=>510
,p_column_heading=>'C046'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c046 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3776227749840038)
,p_query_column_id=>46
,p_column_alias=>'C047'
,p_column_display_sequence=>520
,p_column_heading=>'C047'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c047 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3776372502840039)
,p_query_column_id=>47
,p_column_alias=>'C048'
,p_column_display_sequence=>530
,p_column_heading=>'C048'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c048 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3776492026840040)
,p_query_column_id=>48
,p_column_alias=>'C049'
,p_column_display_sequence=>540
,p_column_heading=>'C049'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c049 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3776544286840041)
,p_query_column_id=>49
,p_column_alias=>'C050'
,p_column_display_sequence=>550
,p_column_heading=>'C050'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXISTS'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''PREVIEW_DATA''',
'   and c050 is not null;'))
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6656568726959442)
,p_plug_name=>'Buttons Container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3843034040303949)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(6656568726959442)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3843896155303951)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6656568726959442)
,p_button_name=>'GENERATE_DATA'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Generate Data'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4006:&SESSION.::&DEBUG.:Y,4006:P4006_BP_ID,P4006_BP_NAME,P4006_TABLE_ID,P4006_TABLE_NAME:&P4014_BP_ID.,&P4014_BP_NAME.,&P4014_TABLE_ID.,&P4014_TABLE_NAME.'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3833609509303931)
,p_name=>'P4014_BP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6655701226959434)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3834034232303934)
,p_name=>'P4014_TABLE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6655701226959434)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3834427101303934)
,p_name=>'P4014_BP_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6655701226959434)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3834871697303934)
,p_name=>'P4014_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6655701226959434)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3846233368303968)
,p_name=>'CNX'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3843034040303949)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2601687380711715)
,p_event_id=>wwv_flow_imp.id(3846233368303968)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'BRANCH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3847130722303970)
,p_name=>'Update Total Rows'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4014_ROW_SCALING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3847694368303970)
,p_event_id=>wwv_flow_imp.id(3847130722303970)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4014_TOTAL_ROWS'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'Math.round( apex.item( ''P4014_ROW_SCALING'' ).getValue() / 100 * $v( ''P4014_ROWS_TO_GENERATE'' ) )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3848078849303970)
,p_name=>'Disable on Format Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4014_FORMAT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3848513200303971)
,p_event_id=>wwv_flow_imp.id(3848078849303970)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3843896155303951)
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.item( ''P4014_FORMAT'' ).getValue() === ''FAST INSERT INTO'' || apex.item( ''P4014_FORMAT'' ).getValue() === ''INSERT INTO'''
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3849441364303971)
,p_name=>'Enable on Format Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4014_FORMAT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3849983647303972)
,p_event_id=>wwv_flow_imp.id(3849441364303971)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3843896155303951)
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.item( ''P4014_FORMAT'' ).getValue() !== ''FAST INSERT INTO'' && apex.item( ''P4014_FORMAT'' ).getValue() !== ''INSERT INTO'''
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1702923561418289)
,p_name=>'Toggle Active State of Generate Data Button'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4014_BP_ID',
'   and a.security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1703334926418292)
,p_event_id=>wwv_flow_imp.id(1702923561418289)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3843896155303951)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3845874609303967)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Generate Sample Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    if wwv_flow_collection.collection_exists( p_collection_name => ''PREVIEW_DATA'' ) then ',
'        wwv_flow_collection.delete_collection(',
'            p_collection_name => ''PREVIEW_DATA'' );',
'    end if;',
'',
'    if wwv_flow_collection.collection_exists( p_collection_name => ''PREVIEW_DATA_HEADERS'' ) then',
'        wwv_flow_collection.delete_collection (',
'            p_collection_name => ''PREVIEW_DATA_HEADERS'' );',
'    end if;',
'',
'    -- This variable must be set (Again) before running the preview.',
'    wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'',
'    wwv_dg_blueprint_util_int.preview_blueprint(',
'        p_blueprint         => :P4014_BP_NAME,',
'        p_table_name        => :P4014_TABLE_NAME,',
'        p_number_of_rows    => 10,',
'        p_data_collection   => ''PREVIEW_DATA'',',
'        p_header_collection => ''PREVIEW_DATA_HEADERS''',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_dg_blueprint_tables a',
' where not exists ( select * from wwv_dg_blueprint_tab_columns where blueprint_table_id = a.id )',
'   and a.blueprint_id = :P4014_BP_ID',
'   and a.security_group_id = :flow_security_group_id'))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>3845874609303967
);
end;
/
prompt --application/pages/page_04015
begin
wwv_flow_imp_page.create_page(
 p_id=>4015
,p_name=>'Delete Blueprint'
,p_alias=>'DELETE-BLUEPRINT'
,p_page_mode=>'MODAL'
,p_step_title=>'Delete Blueprint'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_step_template=>wwv_flow_imp.id(690782249755803171)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3202055388104820)
,p_plug_name=>'Confirm Blueprint Delete'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717420493098820783)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3202716965104827)
,p_plug_name=>'Message'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208285310117555084)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>'Are you sure you want to delete &P4015_BLUEPRINT_NAME.? All tables, columns and custom data sources associated with this blueprint will be deleted.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3202853775104828)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3202431600104824)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3202853775104828)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3202302369104823)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3202853775104828)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8615410388466617)
,p_branch_name=>'Go to Blueprints Home'
,p_branch_action=>'f?p=&APP_ID.:4000:&SESSION.::&DEBUG.:4000::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3202302369104823)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3202919213104829)
,p_name=>'P4015_BLUEPRINT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3202716965104827)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3203042209104830)
,p_name=>'P4015_BLUEPRINT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3202716965104827)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3202563425104825)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3202431600104824)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3202698771104826)
,p_event_id=>wwv_flow_imp.id(3202563425104825)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8615171335465804)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Blueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dg_data_gen_api.remove_blueprint( ',
'    p_name => :P4100_BLUEPRINT_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while deleting the blueprint.',
'',
'#SQLERRM#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3202302369104823)
,p_process_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Blueprint successfully deleted.',
''))
,p_internal_uid=>8615171335465804
);
end;
/
prompt --application/pages/page_04020
begin
wwv_flow_imp_page.create_page(
 p_id=>4020
,p_name=>'Create Blueprint from Tables'
,p_alias=>'CREATE-BLUEPRINT-FROM-TABLES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Blueprint from Tables'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1718683120293536)
,p_plug_name=>'Excluded Columns'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3287185567253680)
,p_plug_name=>'Choose Source'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3287341904253682)
,p_plug_name=>'Copy Paste'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3287478976253683)
,p_plug_name=>'Select'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1906067983860548)
,p_plug_name=>'User tables'
,p_region_name=>'validTables'
,p_parent_plug_id=>wwv_flow_imp.id(3287478976253683)
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name table_name,',
'       50 num_rows',
'  from sys.dba_objects',
' where object_type in (''TABLE'')',
'   and object_name not like ''BIN$%''',
'   and owner = :DATAGEN_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)'))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'User tables'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1718031675293530)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1718921562293539)
,p_name=>'NUM_ROWS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NUM_ROWS'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Rows'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_01=>'1'
,p_attribute_03=>'left'
,p_attribute_04=>'text'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1906243582860550)
,p_name=>'TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TABLE_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Table Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(1906114531860549)
,p_internal_uid=>1906114531860549
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>true
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>280
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(options) {',
'    options.defaultGridViewOptions = {',
'        activateColumnHeader: null,',
'        reorderColumns: false,',
'        resizeColumns: false,',
'        persistSelection: true,',
'        pagination: {',
'            virtual: true',
'        }',
'    };',
'    options.defaultModelOptions = {',
'        pageSize: 500',
'    };',
'    return options;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(1720725137294547)
,p_interactive_grid_id=>wwv_flow_imp.id(1906114531860549)
,p_static_id=>'17208'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(1720908517294548)
,p_report_id=>wwv_flow_imp.id(1720725137294547)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1721418731294554)
,p_view_id=>wwv_flow_imp.id(1720908517294548)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(1906243582860550)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1951257463972534)
,p_view_id=>wwv_flow_imp.id(1720908517294548)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(1718921562293539)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6913538731587801)
,p_plug_name=>'Buttons Container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6959108925107372)
,p_plug_name=>'Define Blueprint'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1663588044695666)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6913538731587801)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1663960387695666)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6913538731587801)
,p_button_name=>'CREATE_BLUEPRINT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Blueprint'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1671855077695671)
,p_branch_name=>'Go to Blueprint Designer'
,p_branch_action=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.:4100:P4100_BLUEPRINT_ID,P4100_BLUEPRINT_NAME,P4100_SCHEMA:&P4020_BLUEPRINT_ID.,&P4020_BLUEPRINT_NAME.,&DATAGEN_SCHEMA.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1661406090695664)
,p_name=>'P4020_FROM_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3287185567253680)
,p_item_default=>'SELECT'
,p_prompt=>'From'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DG_CREATE_BP_FROM_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(1691026444286284)||'.'
,p_field_template=>wwv_flow_imp.id(717397144393801382)
,p_item_css_classes=>'apex-button-group a-DataLoad-sourceType'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1662104694695665)
,p_name=>'P4020_TABLES_LIST_INPUT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3287341904253682)
,p_prompt=>'Tables'
,p_placeholder=>'Provide a list of comma separated table names with desired number of rows in the ''TABLE NAME:NUMBER OF ROWS'' format, one table per line'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Please input a comma separated list of tables and the number of records that will be generated by default. The format for each table is <code>TABLE_NAME:ROWS_TO_GENERATE</code>.',
'Example: <code>PRODUCTS:10,CUSTOMERS:50,SALES:1000</code>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1706689332215239)
,p_name=>'P4020_BLUEPRINT_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6959108925107372)
,p_prompt=>'Blueprint Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>200
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_css_classes=>'margin-bottom-md'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for your blueprint.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1708483316215245)
,p_name=>'P4020_BLUEPRINT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(6959108925107372)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1718469968293534)
,p_name=>'P4020_SELECTED_ROWS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1906067983860548)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1718762518293537)
,p_name=>'P4020_EXCLUDED_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1718683120293536)
,p_item_default=>'CREATED,CREATED_BY,CREATED_ON,UPDATED,UPDATED_BY,UPDATED_ON'
,p_prompt=>'Excluded Columns'
,p_placeholder=>'Provide a list of comma separated excluded columns, applies to all tables selected'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Please input a list of column names to exclude from the auto column generation.</p>',
'<p>The excluded columns parameter will be applied to all tables in the tables selected/input.</p>',
'<p>The format is <code>column1,column2,column3</code></p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1666905769695668)
,p_validation_name=>'Tables list input not null'
,p_validation_sequence=>10
,p_validation=>'P4020_TABLES_LIST_INPUT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4020_FROM_TYPE'
,p_validation_condition2=>'COPY_PASTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1663960387695666)
,p_associated_item=>wwv_flow_imp.id(1662104694695665)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1719268576293542)
,p_validation_name=>'Excluded Columns in correct format'
,p_validation_sequence=>30
,p_validation=>'P4020_EXCLUDED_COLUMNS'
,p_validation2=>'^(([a-zA-Z0-9#$_]+){1}|(([a-zA-Z0-9#$_]+,)+[a-zA-Z0-9#$_]+))$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Please enter the excluded columns in the correct format column1,column2,column3,...'
,p_validation_condition=>'P4020_FROM_TYPE'
,p_validation_condition2=>'COPY_PASTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1663960387695666)
,p_associated_item=>wwv_flow_imp.id(1718762518293537)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1719570061293545)
,p_validation_name=>'Tables list in correct format'
,p_validation_sequence=>40
,p_validation=>'P4020_TABLES_LIST_INPUT'
,p_validation2=>'^(([a-zA-Z0-9#$_]+:[0-9]+){1}|(([a-zA-Z0-9#$_]+:[0-9]+,)+[a-zA-Z0-9#$_]+:[0-9]+))$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Please input tables in the correct format: table1:rows,table2:rows,...'
,p_validation_condition=>'P4020_FROM_TYPE'
,p_validation_condition2=>'COPY_PASTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1663960387695666)
,p_associated_item=>wwv_flow_imp.id(1662104694695665)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2313308215834443)
,p_tabular_form_region_id=>wwv_flow_imp.id(1906067983860548)
,p_validation_name=>'Validate limit tables is not reached'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_rows_arr wwv_flow_t_varchar2;',
'begin',
'    l_rows_arr := wwv_flow_string.split( :P4020_SELECTED_ROWS, '','' );',
'',
'    if l_rows_arr.count > 20 then',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You can only choose 20 tables to generate a blueprint (additional tables can be added afterwards).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(223041585772792204)
,p_validation_name=>'Blueprint name should be unique'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'  from wwv_dg_blueprints',
' where name = :P4020_BLUEPRINT_NAME',
'   and security_group_id = :flow_security_group_id;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'A blueprint with this name already exists. Please provide a different name.'
,p_associated_item=>wwv_flow_imp.id(1706689332215239)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1668485273695669)
,p_name=>'CNX'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1663588044695666)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1668912846695670)
,p_event_id=>wwv_flow_imp.id(1668485273695669)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1669363058695670)
,p_name=>'Toggle Select or Copy and Paste'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4020_FROM_TYPE'
,p_condition_element=>'P4020_FROM_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SELECT'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1669846990695670)
,p_event_id=>wwv_flow_imp.id(1669363058695670)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3287478976253683)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1905964142860547)
,p_event_id=>wwv_flow_imp.id(1669363058695670)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4020_TABLES_LIST_INPUT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1670828027695670)
,p_event_id=>wwv_flow_imp.id(1669363058695670)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4020_TABLES_LIST_INPUT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1905897719860546)
,p_event_id=>wwv_flow_imp.id(1669363058695670)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3287478976253683)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1718240832293532)
,p_name=>'Save Selected Rows'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1663960387695666)
,p_condition_element=>'P4020_FROM_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SELECT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1718338441293533)
,p_event_id=>wwv_flow_imp.id(1718240832293532)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Clear previous selections, if any',
'$s("P4020_SELECTED_ROWS", "");',
'',
'let gridView = apex.region("validTables").call("getViews").grid,',
'    records = gridView.getSelectedRecords(),',
'    invalidTables = [],',
'    tableName,',
'    selRecords;',
'',
'if (records.length > 0) {',
'    selRecords  = records.map( function(r) {',
'        var num_rows = gridView.model.getValue( r, "NUM_ROWS" ),',
'            table_name = gridView.model.getValue( r, "TABLE_NAME");',
'        if ( num_rows && num_rows > 0 ) {',
'            return table_name + '':'' + num_rows;',
'        } else {',
'            invalidTables.push(table_name);',
'        }',
'    });',
'    ',
'    if ( invalidTables.length === 0 ) {',
'        apex.page.submit({',
'            request: "CREATE_BLUEPRINT",',
'            set: {',
'                "P4020_SELECTED_ROWS": selRecords',
'            },',
'            showWait: true',
'        });',
'    } else {',
'        apex.message.alert( apex.lang.getMessage("ODG.MESSAGE.INVALID_ROWS", invalidTables.join('', '') ) );',
'    }',
'} else {',
'    apex.message.alert( apex.lang.getMessage("ODG.MESSAGE.SELECT_ONE_TABLE") );',
'}'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1719059427293540)
,p_event_id=>wwv_flow_imp.id(1718240832293532)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE_BLUEPRINT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2313464241834444)
,p_name=>'Alert on number of tables selected'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1906067983860548)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'NATIVE_IG|REGION TYPE|interactivegridselectionchange'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2313568787834445)
,p_event_id=>wwv_flow_imp.id(2313464241834444)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var recordsLength = this.data.selectedRecords.length,',
'    maxAllowed = 20;',
'',
'if ( recordsLength >= maxAllowed ) {',
'    apex.message.showErrors([{',
'        type: "error",',
'        location: [ "page" ],',
'        message: apex.lang.formatMessage( "ODG.MESSAGE.MAX_RECORDS_TABLES", maxAllowed )',
'    }]);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1668075606695669)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Blueprint Copy Paste'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_tables_arr           wwv_flow_t_varchar2;',
'    l_excluded_columns_arr wwv_flow_t_varchar2;',
'begin',
'    if :P4020_TABLES_LIST_INPUT is not null then',
'        l_tables_arr := wwv_flow_string.split( :P4020_TABLES_LIST_INPUT, '','' );',
'        ',
'        if :P4020_EXCLUDED_COLUMNS is not null then',
'            l_excluded_columns_arr := wwv_flow_string.split( :P4020_EXCLUDED_COLUMNS, '','' );',
'        end if;',
'',
'        wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'',
'        wwv_dg_blueprint_util_int.add_blueprint_from_tables(',
'            p_name            => :P4020_BLUEPRINT_NAME,',
'            p_description     => ''Generated using existing tables.'',',
'            p_tables          => l_tables_arr,',
'            p_preserve_case   => ''N'',',
'            p_exclude_columns => l_excluded_columns_arr,',
'            p_blueprint_id    => :P4020_BLUEPRINT_ID,',
'            p_default_schema  => :DATAGEN_SCHEMA',
'        );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while trying to import the blueprint.',
'',
'#SQLERRM_TEXT#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1663960387695666)
,p_process_when=>'P4020_FROM_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'COPY_PASTE'
,p_process_success_message=>'Blueprint successfully created.'
,p_internal_uid=>1668075606695669
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1667644891695669)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Blueprint Select'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_tables_arr           wwv_flow_t_varchar2;',
'    l_excluded_columns_arr wwv_flow_t_varchar2;',
'begin',
'    if :P4020_SELECTED_ROWS is not null then',
'        l_tables_arr := wwv_flow_string.split( :P4020_SELECTED_ROWS, '','' );',
'        ',
'        if :P4020_EXCLUDED_COLUMNS is not null then',
'            l_excluded_columns_arr := wwv_flow_string.split( :P4020_EXCLUDED_COLUMNS, '','' );',
'        end if;',
'',
'        wwv_dg_blueprint_util_int.g_current_schema := :DATAGEN_SCHEMA;',
'',
'        wwv_dg_blueprint_util_int.add_blueprint_from_tables(',
'            p_name            => :P4020_BLUEPRINT_NAME,',
'            p_description     => ''Generated using existing tables.'',',
'            p_tables          => l_tables_arr,',
'            p_preserve_case   => ''N'',',
'            p_exclude_columns => l_excluded_columns_arr,',
'            p_blueprint_id    => :P4020_BLUEPRINT_ID,',
'            p_default_schema  => :DATAGEN_SCHEMA',
'        );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while trying to import the blueprint.',
'',
'#SQLERRM_TEXT#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1663960387695666)
,p_process_when=>'P4020_FROM_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SELECT'
,p_process_success_message=>'Blueprint successfully created.'
,p_internal_uid=>1667644891695669
);
end;
/
prompt --application/pages/page_04100
begin
wwv_flow_imp_page.create_page(
 p_id=>4100
,p_name=>'Blueprint Designer'
,p_alias=>'BLUEPRINT-DESIGNER'
,p_step_title=>'Blueprint Designer'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(109807152552070130)
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.treeView#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.lovDialog#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.propertyEditor#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.tdPropertyEditor#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4500_p4100#MIN#.js',
'[require requirejs]#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.toolbar#MIN#.js',
'[require requirejs]#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.codeEditor#MIN#.js'))
,p_step_template=>wwv_flow_imp.id(255350889127290340)
,p_page_css_classes=>'page-data-generator'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(1753335990774646)
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1620892626095034)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2611882588483427)
,p_plug_name=>'ConfirmSaveDialog'
,p_region_name=>'ConfirmBlueprintSave'
,p_parent_plug_id=>wwv_flow_imp.id(1620892626095034)
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1925923942866615)
,p_plug_name=>'AI Hook'
,p_plug_display_sequence=>30
,p_plug_display_point=>'HELP'
,p_location=>null
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.AI_HOOK'
,p_ai_system_prompt=>'APEX$CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ai_key', 'codeEditor')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'*** Do not remove *** ',
'This region is necessary for the AI Chat feature in the code editors.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2610112062483410)
,p_plug_name=>'Help Panel'
,p_region_name=>'help_container'
,p_region_css_classes=>'a-HelpRegion'
,p_icon_css_classes=>'icon-help'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_plug_display_point=>'HELP'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4039444063817912)
,p_plug_name=>'Rendering Tree'
,p_region_css_classes=>'a-DataGen-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'TREE'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div aria-label=''&"APP_TEXT$ODG.PE.BLUEPRINT_TREE_NAME".'' id="treeNav"></div>',
'',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4039574293817913)
,p_plug_name=>'Property Editor'
,p_region_name=>'peMain'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(223041283015792201)
,p_plug_name=>'Rendering Toolbar'
,p_region_name=>'TDContextMenu'
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(717416953442820777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'TREE'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(220665331587624510)
,p_plug_name=>'Menu'
,p_region_name=>'optionsMenu'
,p_parent_plug_id=>wwv_flow_imp.id(387929403973561918)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions'
,p_plug_template=>wwv_flow_imp.id(385770331595976651)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(8537282234307541)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(385776364537002403)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(223041382081792202)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(223041283015792201)
,p_button_name=>'RENDERING_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765690470963369)
,p_button_image_alt=>'Rendering Menu'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="TDrenderingTreeMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3202208891104822)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(387929403973561918)
,p_button_name=>'OPTIONS'
,p_button_static_id=>'menu-options'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765690470963369)
,p_button_image_alt=>'Options'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--gapRight a-Button--simple'
,p_icon_css_classes=>'icon-tools'
,p_button_cattributes=>'data-menu="optionsMenu_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(223041612948792205)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(387929403973561918)
,p_button_name=>'GENERATE_DATA'
,p_button_static_id=>'SaveAndGenerateBlueprintChanges'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Generate Data'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4028222105843427)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(387929403973561918)
,p_button_name=>'PREVIEW_DATA'
,p_button_static_id=>'SaveAndPreviewBlueprintChanges'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Preview Data'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4027820308843423)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(387929403973561918)
,p_button_name=>'Save'
,p_button_static_id=>'SaveBlueprintChanges'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2526518218222509)
,p_branch_name=>'Go to Blueprints Home'
,p_branch_action=>'f?p=&APP_ID.:4000:&SESSION.::&DEBUG.:4000::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1593576357466344)
,p_name=>'P4100_BLUEPRINT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1620892626095034)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1987050255227140)
,p_name=>'P4100_BLUEPRINT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1620892626095034)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2603105497711730)
,p_name=>'P4100_REQUIRED_SAVE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1620892626095034)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(223041422221792203)
,p_name=>'P4100_SCHEMA'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1620892626095034)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4028731589843432)
,p_computation_sequence=>10
,p_computation_item=>'P4100_BLUEPRINT_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
' from wwv_dg_blueprints',
'where id = :P4100_BLUEPRINT_ID;'))
,p_compute_when=>'P4100_BLUEPRINT_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2602399726711722)
,p_name=>'Detect Dialog Canceled'
,p_event_sequence=>10
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2602442810711723)
,p_event_id=>wwv_flow_imp.id(2602399726711722)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'location.reload();'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P4100_REQUIRED_SAVE'
,p_client_condition_expression=>'true'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2526415716222508)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Blueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dg_data_gen_api.remove_blueprint( ',
'    p_name => :P4100_BLUEPRINT_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error was encountered while deleting the blueprint.',
'',
'#SQLERRM#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Blueprint successfully deleted.',
''))
,p_internal_uid=>2526415716222508
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4026853731843413)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GetColumnNames'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    v_dsType              varchar2(100);',
'    v_dsName              varchar2(1000);',
'    v_dsTable             varchar2(1000);',
'    v_sql                 varchar2(32767);',
'begin',
'    v_dsType := wwv_flow.g_x01;',
'    v_dsName := wwv_flow.g_x02;',
' ',
'    if v_dsType = ''SQL_QUERY'' then',
'        v_sql := wwv_flow.g_x03;',
'',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.open_array(''columns'');',
'        for column_record in ( select column_name',
'                                 from table( wwv_flow_exec_dev.get_query_columns(',
'                                        p_location        => ''LOCAL'',',
'                                        p_query_type      => ''SQL'',',
'                                        p_sql_query       => v_sql,',
'                                        p_parse_as_schema => :P4100_SCHEMA',
'                                    )',
'                                )',
'        )',
'        loop',
'            wwv_flow_json.write( column_record.column_name );',
'        end loop;',
'        wwv_flow_json.close_array;',
'        wwv_flow_json.close_object;',
'    else',
'',
'        select table_name',
'          into v_dsTable ',
'          from apex_dg_bp_data_sources',
'         where name = v_dsName;',
'        ',
'        if v_dsTable is not null then',
'            wwv_flow_json.open_object;',
'            wwv_flow_json.open_array(''columns'');',
'            for dsColumn in ( select a.column_name col_name',
'                                from sys.dba_tab_columns a',
'                               where a.table_name = v_dsTable )',
'            loop',
'                wwv_flow_json.write( dsColumn.col_name );',
'            end loop;',
'            wwv_flow_json.close_array;',
'            wwv_flow_json.close_object;',
'        else',
'            wwv_flow_json.open_object;',
'            wwv_flow_json.write(''success'', false);',
'            wwv_flow_json.write(''message'', ''No table found on this schema for this custom data source: '' || v_dsName );',
'            wwv_flow_json.close_object;',
'        end if;',
'    end if;',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write(''success'', false);',
'        wwv_flow_json.write(''message'', sqlerrm);',
'        wwv_flow_json.close_object;',
'        raise;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4026853731843413
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4027112299843416)
,p_process_sequence=>30
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GetBPTablesAndColumns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    sourceType         varchar2(3000);',
'    dataSourceCategory varchar2(3000);',
'    blueprintName      varchar2(1000);',
'begin',
'    wwv_flow_json.open_object; -- Open top level JSON object.',
'    ',
'    for bp in ( select name,',
'                       display_name,',
'                       description,',
'                       default_schema,',
'                       created_on,',
'                       created_by,',
'                       last_updated_on,',
'                       last_updated_by',
'                  from wwv_dg_blueprints',
'                 where id = :P4100_BLUEPRINT_ID )',
'    loop',
'        blueprintName := bp.name;',
'        wwv_flow_json.write( ''label'', bp.name );',
'        wwv_flow_json.write( ''display'', bp.display_name );',
'        wwv_flow_json.write( ''oldLabel'', bp.name );',
'        wwv_flow_json.write( ''type'', ''blueprint'' );',
'        wwv_flow_json.write( ''description'', bp.description );',
'        wwv_flow_json.write( ''schema'', bp.default_schema );',
'        wwv_flow_json.write( ''created'', bp.created_on );',
'        wwv_flow_json.write( ''createdBy'', bp.created_by );',
'        wwv_flow_json.write( ''updated'', bp.last_updated_on );',
'        wwv_flow_json.write( ''updatedBy'', bp.last_updated_by );',
'        wwv_flow_json.write( ''nodeAction'', ''none'' );',
'    end loop;',
'',
'    wwv_flow_json.open_array( ''children'' ); -- Open tables & data sources array.',
'    wwv_flow_json.open_object; -- Open table object.',
'    wwv_flow_json.write( ''label'', ''Tables'' );',
'    wwv_flow_json.write( ''type'', ''TablesParent'' );',
'    wwv_flow_json.open_array( ''children'' ); -- Open tables array',
'    ',
'    for bp_tbl in ( select id,',
'                           name,',
'                           seq,',
'                           display_name,',
'                           num_rows',
'                      from wwv_dg_blueprint_tables ',
'                     where blueprint_id = :P4100_BLUEPRINT_ID',
'                     order by seq )',
'    loop',
'        wwv_flow_json.open_object; -- Open table object',
'        wwv_flow_json.write( ''id'', bp_tbl.id );',
'        wwv_flow_json.write( ''type'', ''table'' );',
'        wwv_flow_json.write( ''label'', bp_tbl.name );',
'        wwv_flow_json.write( ''blueprintName'', blueprintName );',
'        wwv_flow_json.write( ''oldLabel'', bp_tbl.name );',
'        wwv_flow_json.write( ''display'', bp_tbl.display_name );',
'        wwv_flow_json.write( ''seq'', bp_tbl.seq );',
'        wwv_flow_json.write( ''rows'', bp_tbl.num_rows );',
'        wwv_flow_json.write( ''nodeAction'', ''none'' );',
'        -- Append columns:',
'        wwv_flow_json.open_array( ''children'' ); -- Open columns array',
'        for bp_tbl_col in ( select id,',
'                                   name,',
'                                   display_name,',
'                                   seq,',
'                                   lang,',
'                                   data_source_type,',
'                                   data_source,',
'                                   min_numeric_value,',
'                                   max_numeric_value,',
'                                   numeric_precision,',
'                                   min_date_value,',
'                                   max_date_value,',
'                                   data_format_mask,',
'                                   sequence_start_with,',
'                                   sequence_increment,',
'                                   data_source_table,',
'                                   data_source_column,',
'                                   depends_on,',
'                                   formula,',
'                                   percent_blank,',
'                                   native_datatype,',
'                                   multi_value_yn,',
'                                   mv_delimiter,',
'                                   mv_min_entries,',
'                                   mv_max_entries,',
'                                   mv_partition_by,',
'                                   mv_format,',
'                                   mv_unique,',
'                                   max_length',
'                     from wwv_dg_blueprint_tab_columns',
'                    where blueprint_table_id = bp_tbl.id',
'                    order by seq )',
'        loop',
'            -- Source types are transformed in the DG view:',
'            -- Need to transform it on each case, otherwise we pass the value as-is',
'            -- This is modeled in the treeview as it is in the original DG tables,',
'            -- but the use of the views is recommended by Insum.',
'            sourceType := upper( replace( bp_tbl_col.data_source_type, '' '', ''_'' ) );',
'',
'            wwv_flow_json.open_object; -- Open column object',
'',
'            wwv_flow_json.write( ''id'', bp_tbl_col.id );',
'            wwv_flow_json.write( ''type'', ''column'' || ''-'' || lower( sourceType ) );',
'            wwv_flow_json.write( ''label'', bp_tbl_col.name );',
'            wwv_flow_json.write( ''oldLabel'', bp_tbl_col.name );',
'            wwv_flow_json.write( ''parentTable'', bp_tbl.name );',
'            wwv_flow_json.write( ''blueprintName'', blueprintName );',
'            wwv_flow_json.write( ''display'', bp_tbl_col.display_name );',
'            wwv_flow_json.write( ''seq'', bp_tbl_col.seq );',
'            wwv_flow_json.write( ''lang'', bp_tbl_col.lang );',
'            wwv_flow_json.write( ''source'', sourceType );',
'            wwv_flow_json.write( ''ds'', bp_tbl_col.data_source );',
'            -- Add other key-values depending on data source type.',
'            if sourceType = ''BUILTIN'' then',
'                wwv_flow_json.write( ''builtin'', bp_tbl_col.data_source || '':'' || bp_tbl_col.native_datatype );',
'                wwv_flow_json.write( ''dsType'', '''' );',
'                wwv_flow_json.write( ''dsCustomDataSource'', '''' );',
'                wwv_flow_json.write( ''dsName'', '''' );',
'                wwv_flow_json.write( ''dsColumn'', '''' );',
'                wwv_flow_json.write( ''dsQuery'', '''' );               ',
'                wwv_flow_json.write( ''inline'', '''' );',
'            elsif sourceType = ''DATA_SOURCE'' then',
'                wwv_flow_json.write( ''dsCustomDataSource'', bp_tbl_col.data_source );',
'                -- Verify if the data source is a table or query.',
'                for ds_type in ( select name,',
'                                        data_source_type,',
'                                        sql_query',
'                                   from wwv_dg_blueprint_data_sources',
'                                  where name = substr( bp_tbl_col.data_source, 0, instr( bp_tbl_col.data_source, ''.'' ) - 1 ) )',
'                loop',
'                    wwv_flow_json.write( ''builtin'', '''' );',
'                    wwv_flow_json.write( ''inline'', '''' );',
'                    wwv_flow_json.write( ''dsName'', ds_type.name );',
'                    wwv_flow_json.write( ''dsColumn'', substr( bp_tbl_col.data_source, instr( bp_tbl_col.data_source, ''.'' ) + 1, length( bp_tbl_col.data_source ) ) );',
'                    wwv_flow_json.write( ''dsType'', ds_type.data_source_type );',
'                    if ds_type.data_source_type = ''TABLE'' then',
'                        wwv_flow_json.write( ''dsQuery'', '''' );',
'                    elsif ds_type.data_source_type = ''SQL_QUERY'' then',
'                        -- Required for fetching the DS columns later.',
'                        wwv_flow_json.write( ''dsQuery'', ds_type.sql_query );',
'                    end if;',
'                end loop;',
'            elsif sourceType = ''INLINE'' then',
'                wwv_flow_json.write( ''builtin'', '''' );',
'                wwv_flow_json.write( ''inline'', bp_tbl_col.data_source );',
'                wwv_flow_json.write( ''dsType'', '''' );',
'                wwv_flow_json.write( ''dsCustomDataSource'', '''' );',
'                wwv_flow_json.write( ''dsName'', '''' );',
'                wwv_flow_json.write( ''dsColumn'', '''' );',
'                wwv_flow_json.write( ''dsQuery'', '''' ); ',
'            end if;',
'',
'            wwv_flow_json.write( ''min'', bp_tbl_col.min_numeric_value );',
'            wwv_flow_json.write( ''max'', bp_tbl_col.max_numeric_value );',
'            wwv_flow_json.write( ''precision'', bp_tbl_col.numeric_precision );',
'            wwv_flow_json.write( ''minDate'', to_char( bp_tbl_col.min_date_value, bp_tbl_col.data_format_mask ) );',
'            wwv_flow_json.write( ''maxDate'', to_char( bp_tbl_col.max_date_value, bp_tbl_col.data_format_mask ) );',
'            wwv_flow_json.write( ''formatMask'', bp_tbl_col.data_format_mask );',
'            wwv_flow_json.write( ''seqStart'', bp_tbl_col.sequence_start_with );',
'            wwv_flow_json.write( ''seqIncrement'', bp_tbl_col.sequence_increment );',
'            wwv_flow_json.write( ''data_source_table'', bp_tbl_col.data_source_table ); -- These appear to be always null.',
'            wwv_flow_json.write( ''data_source_column'', bp_tbl_col.data_source_column ); -- These appear to be always null.',
'            wwv_flow_json.write( ''dependsOn'', bp_tbl_col.depends_on );',
'            wwv_flow_json.write( ''formula'', bp_tbl_col.formula );',
'            if bp_tbl_col.percent_blank = ''0'' then',
'                wwv_flow_json.write( ''required'', ''Y'' );',
'            else',
'                wwv_flow_json.write( ''required'', ''N'' );',
'            end if;',
'            wwv_flow_json.write( ''blank'', bp_tbl_col.percent_blank );',
'            wwv_flow_json.write( ''mv'', bp_tbl_col.multi_value_yn );',
'            wwv_flow_json.write( ''mvDelimiter'', bp_tbl_col.mv_delimiter );',
'            wwv_flow_json.write( ''mvMin'', bp_tbl_col.mv_min_entries );',
'            wwv_flow_json.write( ''mvMax'', bp_tbl_col.mv_max_entries );',
'            wwv_flow_json.write( ''mvPartition'', bp_tbl_col.mv_partition_by );',
'            wwv_flow_json.write( ''mvFormat'', bp_tbl_col.mv_format );',
'            wwv_flow_json.write( ''mvUnique'', bp_tbl_col.mv_unique );',
'            wwv_flow_json.write( ''maxLength'', bp_tbl_col.max_length );',
'            wwv_flow_json.write( ''nodeAction'', ''none'' );',
'            wwv_flow_json.close_object; -- Close column object',
'        end loop;',
'        wwv_flow_json.close_array; -- Close columns array',
'',
'        wwv_flow_json.close_object; -- Close table object',
'    end loop;',
'',
'    wwv_flow_json.close_array; -- Close tables array.',
'    wwv_flow_json.close_object; -- Close table object.',
'    wwv_flow_json.open_object; -- Open data sources object.',
'    wwv_flow_json.write( ''label'', ''Custom Data Sources'' );',
'    wwv_flow_json.write( ''type'', ''DataSourcesParent'' );',
'    wwv_flow_json.open_array( ''children'' ); -- Open data sources array',
'    for bp_ds in ( select id,',
'                          name,',
'                          data_source_type,',
'                          table_name,',
'                          sql_query,',
'                          where_clause ',
'                     from wwv_dg_blueprint_data_sources',
'                    where blueprint_id = :P4100_BLUEPRINT_ID )',
'    loop',
'        wwv_flow_json.open_object; -- Open data source object',
'        wwv_flow_json.write( ''id'',  bp_ds.id );',
'        wwv_flow_json.write( ''type'', ''datasource'' );',
'        wwv_flow_json.write( ''blueprintName'', blueprintName );',
'        wwv_flow_json.write( ''label'', bp_ds.name );',
'        wwv_flow_json.write( ''oldLabel'', bp_ds.name );',
'        wwv_flow_json.write( ''dsType'', bp_ds.data_source_type );',
'        wwv_flow_json.write( ''table'', bp_ds.table_name );',
'        wwv_flow_json.write( ''sqlQuery'', bp_ds.sql_query );',
'        wwv_flow_json.write( ''whereClause'', bp_ds.where_clause );',
'        wwv_flow_json.write( ''nodeAction'', ''none'' );',
'        wwv_flow_json.close_object; -- Close data source object',
'    end loop;',
'    wwv_flow_json.close_array; -- Close data sources array',
'    wwv_flow_json.close_object; -- Close data source object.',
'    wwv_flow_json.close_array; -- Close tables and data sources array.',
'    wwv_flow_json.close_object; -- Close top level JSON object.',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4027112299843416
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5402394591066021)
,p_process_sequence=>40
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SaveBlueprintObject'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_node_clob           clob;',
'    l_node_action         varchar2(1000);',
'    l_node_name           varchar2(1000);',
'    l_old_node_name       varchar2(1000);',
'    l_description         varchar2(32767);',
'    l_schema              varchar2(1000);',
'    l_parent_name         varchar2(1000);',
'    l_sequence            varchar2(1000);',
'    l_display_name        varchar2(1000);',
'    l_rows                varchar2(1000);',
'    l_max_length          varchar2(1000);',
'    l_mv                  varchar2(1000);',
'    l_mv_format           varchar2(1000);',
'    l_mv_unique           varchar2(1000);',
'    l_mv_delimiter        varchar2(1000);',
'    l_mv_min_entries      varchar2(1000);',
'    l_mv_max_entries      varchar2(1000);',
'    l_mv_partition_by     varchar2(1000);',
'    l_lang                varchar2(1000);',
'    l_data_source_type    varchar2(1000);',
'    l_data_source         varchar2(1000);',
'    l_return_type         varchar2(1000);',
'    l_min_numeric_value   varchar2(1000);',
'    l_max_numeric_value   varchar2(1000);',
'    l_numeric_precision   varchar2(1000);',
'    l_min_date_value      varchar2(1000);',
'    l_max_date_value      varchar2(1000);',
'    l_format_mask         varchar2(1000);',
'    l_sequence_start_with varchar2(1000);',
'    l_sequence_increment  varchar2(1000);',
'    l_formula             varchar2(32767);',
'    l_percent_blank       varchar2(1000);',
'    l_ds_type             varchar2(1000);',
'    l_table               varchar2(1000);',
'    l_sql_query           varchar2(32767);',
'    l_where_clause        varchar2(1000);',
'    l_returning_id        number;',
'    l_blueprint_name      varchar2(1000);',
'begin',
'    for i in 1..wwv_flow.g_f01.count loop',
'        l_node_clob := l_node_clob || wwv_flow.g_f01(i);',
'    end loop;',
'',
'    wwv_flow_json.parse(',
'        p_source => l_node_clob );',
'',
'    l_node_action := wwv_flow_json.get_varchar2( p_path=>''nodeAction'' );',
'    l_node_name := wwv_flow_json.get_varchar2( p_path=>''label'' );',
'    l_old_node_name := wwv_flow_json.get_varchar2( p_path=>''oldLabel'' );',
'    l_blueprint_name := wwv_flow_json.get_varchar2( p_path=>''blueprintName'' );',
'',
'    if l_node_action = ''addTable'' then',
'',
'        l_display_name := wwv_flow_json.get_varchar2( p_path=>''display'' );',
'        l_rows := wwv_flow_json.get_varchar2( p_path=>''rows'' );',
'        l_sequence := wwv_flow_json.get_varchar2( p_path=>''seq'' );',
'',
'        wwv_dg_data_gen_api.add_table(',
'            p_blueprint      => l_blueprint_name,',
'            p_table_name     => l_node_name,',
'            p_sequence       => l_sequence,',
'            p_display_name   => l_display_name,',
'            p_rows           => l_rows,',
'            p_table_id       => l_returning_id',
'        );',
'',
'    elsif l_node_action = ''addColumn'' then',
'',
'        l_parent_name := wwv_flow_json.get_varchar2( p_path=>''parentTable'' );',
'        l_display_name := wwv_flow_json.get_varchar2( p_path=>''display'' );',
'        l_sequence := wwv_flow_json.get_varchar2( p_path=>''seq'' );',
'        l_max_length := wwv_flow_json.get_varchar2( p_path=>''maxLength'' );',
'        l_mv := wwv_flow_json.get_varchar2( p_path=>''mv'' );',
'',
'        if l_mv = ''Y'' then',
'            l_mv_format := wwv_flow_json.get_varchar2( p_path=>''mvFormat'' );',
'            l_mv_unique := wwv_flow_json.get_varchar2( p_path=>''mvUnique'' );',
'            l_mv_delimiter := wwv_flow_json.get_varchar2( p_path=>''mvDelimiter'' );',
'            l_mv_min_entries := wwv_flow_json.get_varchar2( p_path=>''mvMin'' );',
'            l_mv_max_entries := wwv_flow_json.get_varchar2( p_path=>''mvMax'' );',
'            l_mv_partition_by := wwv_flow_json.get_varchar2( p_path=>''mvPartition'' );',
'        end if;',
'',
'        l_lang := wwv_flow_json.get_varchar2( p_path=>''lang'' );',
'        l_data_source_type := wwv_flow_json.get_varchar2( p_path=>''source'' );',
'',
'        if l_data_source_type = ''DATA_SOURCE'' or l_data_source_type = ''BUILTIN'' or',
'            l_data_source_type = ''BLUEPRINT'' or l_data_source_type = ''INLINE'' then',
'            l_data_source := wwv_flow_json.get_varchar2( p_path=>''ds'' );',
'        end if;',
'',
'        if l_data_source_type = ''BUILTIN'' then',
'            l_return_type := substr( wwv_flow_json.get_varchar2( p_path=>''builtin'' ), instr( wwv_flow_json.get_varchar2( p_path=>''builtin'' ), '':'' ) + 1 );',
'',
'            if l_return_type = ''NUMBER'' then',
'                l_min_numeric_value := wwv_flow_json.get_varchar2( p_path=>''min'' );',
'                l_max_numeric_value := wwv_flow_json.get_varchar2( p_path=>''max'' );',
'                l_numeric_precision := wwv_flow_json.get_varchar2( p_path=>''precision'' );',
'            elsif l_return_type = ''DATE'' then',
'                l_format_mask := wwv_flow_json.get_varchar2( p_path=>''formatMask'' );',
'',
'                l_min_date_value := wwv_flow_json.get_varchar2( p_path=>''minDate'' );',
'                l_max_date_value := wwv_flow_json.get_varchar2( p_path=>''maxDate'' );',
'                -- Update date value according to mask format.',
'                if length( l_format_mask ) > 0 then',
'                    l_min_date_value := to_date( l_min_date_value, l_format_mask );',
'                    l_max_date_value := to_date( l_max_date_value, l_format_mask );',
'                end if;',
'            end if;',
'        end if;',
'',
'        if l_data_source_type = ''SEQUENCE'' then',
'            l_sequence_start_with := wwv_flow_json.get_varchar2( p_path=>''seqStart'' );',
'            l_sequence_increment := wwv_flow_json.get_varchar2( p_path=>''seqIncrement'' );',
'        end if;',
'',
'        l_formula := wwv_flow_json.get_varchar2( p_path=>''formula'' );',
'        l_percent_blank := wwv_flow_json.get_varchar2( p_path=>''blank'' );',
'',
'        wwv_flow_debug_api.message( ''PARENT_TABLE is '' || l_parent_name );',
'',
'        wwv_dg_data_gen_api.add_column(',
'            p_blueprint           => l_blueprint_name,',
'            p_table_name          => l_parent_name,',
'            p_column_name         => l_node_name,',
'            p_sequence            => l_sequence,',
'            p_display_name        => l_display_name,',
'            p_max_length          => l_max_length,',
'            p_multi_value         => l_mv,',
'            p_mv_format           => l_mv_format,',
'            p_mv_unique           => l_mv_unique,',
'            p_mv_delimiter        => l_mv_delimiter,     ',
'            p_mv_min_entries      => l_mv_min_entries,       ',
'            p_mv_max_entries      => l_mv_max_entries,       ',
'            p_mv_partition_by     => l_mv_partition_by,        ',
'            p_lang                => l_lang, ',
'            p_data_source_type    => l_data_source_type,         ',
'            p_data_source         => l_data_source,      ',
'            p_min_numeric_value   => l_min_numeric_value,          ',
'            p_max_numeric_value   => l_max_numeric_value,        ',
'            p_numeric_precision   => l_numeric_precision,        ',
'            p_min_date_value      => l_min_date_value,     ',
'            p_max_date_value      => l_max_date_value,     ',
'            p_format_mask         => l_format_mask,',
'            p_sequence_start_with => l_sequence_start_with,            ',
'            p_sequence_increment  => l_sequence_increment,',
'            p_formula             => l_formula,        ',
'            p_percent_blank       => l_percent_blank,',
'            p_column_id           => l_returning_id',
'        );',
'',
'    elsif l_node_action = ''addDataSource'' then',
'',
'        l_ds_type := wwv_flow_json.get_varchar2( p_path=>''dsType'' );',
'',
'        if l_ds_type = ''TABLE'' then',
'            l_table := wwv_flow_json.get_varchar2( p_path=>''table'' );',
'            l_where_clause := wwv_flow_json.get_varchar2( p_path=>''whereClause'' );',
'        elsif l_ds_type = ''SQL_QUERY'' then',
'            l_sql_query := wwv_flow_json.get_varchar2( p_path=>''sqlQuery'' );',
'        end if;',
'',
'        wwv_dg_data_gen_api.add_data_source(',
'            p_blueprint        => l_blueprint_name,',
'            p_name             => l_node_name,',
'            p_data_source_type => l_ds_type,',
'            p_table            => l_table,',
'            p_sql_query        => l_sql_query,',
'            p_where_clause     => l_where_clause,',
'            p_data_source_id   => l_returning_id',
'        );',
'',
'    elsif l_node_action = ''updateTable'' then',
'',
'        l_display_name := wwv_flow_json.get_varchar2( p_path=>''display'' );',
'        l_rows := wwv_flow_json.get_varchar2( p_path=>''rows'' );',
'        l_sequence := wwv_flow_json.get_varchar2( p_path=>''seq'' );',
'',
'        wwv_dg_data_gen_api.update_table(',
'            p_blueprint      => l_blueprint_name,',
'            p_table_name     => l_old_node_name,',
'            p_new_table_name => l_node_name,',
'            p_sequence       => l_sequence,',
'            p_display_name   => l_display_name,',
'            p_rows           => l_rows',
'        );',
'    elsif l_node_action = ''updateColumn'' then',
'',
'        l_parent_name := wwv_flow_json.get_varchar2( p_path=>''parentTable'' );',
'        l_display_name := wwv_flow_json.get_varchar2( p_path=>''display'' );',
'        l_sequence := wwv_flow_json.get_varchar2( p_path=>''seq'' );',
'        l_max_length := wwv_flow_json.get_varchar2( p_path=>''maxLength'' );',
'        l_mv := wwv_flow_json.get_varchar2( p_path=>''mv'' );',
'',
'        if l_mv = ''Y'' then',
'            l_mv_format := wwv_flow_json.get_varchar2( p_path=>''mvFormat'' );',
'            l_mv_unique := wwv_flow_json.get_varchar2( p_path=>''mvUnique'' );',
'            l_mv_delimiter := wwv_flow_json.get_varchar2( p_path=>''mvDelimiter'' );',
'            l_mv_min_entries := wwv_flow_json.get_varchar2( p_path=>''mvMin'' );',
'            l_mv_max_entries := wwv_flow_json.get_varchar2( p_path=>''mvMax'' );',
'            l_mv_partition_by := wwv_flow_json.get_varchar2( p_path=>''mvPartition'' );',
'        end if;',
'',
'        l_lang := wwv_flow_json.get_varchar2( p_path=>''lang'' );',
'        l_data_source_type := wwv_flow_json.get_varchar2( p_path=>''source'' );',
'',
'        if l_data_source_type = ''DATA_SOURCE'' or l_data_source_type = ''BUILTIN'' or',
'            l_data_source_type = ''BLUEPRINT'' or l_data_source_type = ''INLINE'' then',
'            l_data_source := wwv_flow_json.get_varchar2( p_path=>''ds'' );',
'        end if;',
'',
'        if l_data_source_type = ''BUILTIN'' then',
'            l_return_type := substr( wwv_flow_json.get_varchar2( p_path=>''builtin'' ), instr( wwv_flow_json.get_varchar2( p_path=>''builtin'' ), '':'' ) + 1 );',
'',
'            if l_return_type = ''NUMBER'' then',
'                l_min_numeric_value := wwv_flow_json.get_varchar2( p_path=>''min'' );',
'                l_max_numeric_value := wwv_flow_json.get_varchar2( p_path=>''max'' );',
'                l_numeric_precision := wwv_flow_json.get_varchar2( p_path=>''precision'' );',
'            elsif l_return_type = ''DATE'' then',
'                l_format_mask := wwv_flow_json.get_varchar2( p_path=>''formatMask'' );',
'',
'                l_min_date_value := wwv_flow_json.get_varchar2( p_path=>''minDate'' );',
'                l_max_date_value := wwv_flow_json.get_varchar2( p_path=>''maxDate'' );',
'                -- Update date value according to mask format.',
'                if length( l_format_mask ) > 0 then',
'                    l_min_date_value := to_date( l_min_date_value, l_format_mask );',
'                    l_max_date_value := to_date( l_max_date_value, l_format_mask );',
'                end if;',
'            end if;',
'        end if;',
'',
'        if l_data_source_type = ''SEQUENCE'' then',
'            l_sequence_start_with := wwv_flow_json.get_varchar2( p_path=>''seqStart'' );',
'            l_sequence_increment := wwv_flow_json.get_varchar2( p_path=>''seqIncrement'' );',
'        end if;',
'',
'        l_formula := wwv_flow_json.get_varchar2( p_path=>''formula'' );',
'        l_percent_blank := wwv_flow_json.get_varchar2( p_path=>''blank'' );',
'',
'        wwv_dg_data_gen_api.update_column(',
'            p_blueprint           => l_blueprint_name,',
'            p_table_name          => l_parent_name,',
'            p_column_name         => l_old_node_name,',
'            p_new_column_name     => l_node_name,',
'            p_sequence            => l_sequence,',
'            p_display_name        => l_display_name,',
'            p_max_length          => l_max_length,',
'            p_multi_value         => l_mv,',
'            p_mv_format           => l_mv_format,',
'            p_mv_unique           => l_mv_unique,',
'            p_mv_delimiter        => l_mv_delimiter,     ',
'            p_mv_min_entries      => l_mv_min_entries,       ',
'            p_mv_max_entries      => l_mv_max_entries,       ',
'            p_mv_partition_by     => l_mv_partition_by,        ',
'            p_lang                => l_lang, ',
'            p_data_source_type    => l_data_source_type,         ',
'            p_data_source         => l_data_source,      ',
'            p_min_numeric_value   => l_min_numeric_value,          ',
'            p_max_numeric_value   => l_max_numeric_value,        ',
'            p_numeric_precision   => l_numeric_precision,        ',
'            p_min_date_value      => l_min_date_value,     ',
'            p_max_date_value      => l_max_date_value,     ',
'            p_format_mask         => l_format_mask,',
'            p_sequence_start_with => l_sequence_start_with,            ',
'            p_sequence_increment  => l_sequence_increment,',
'            p_formula             => l_formula,        ',
'            p_percent_blank       => l_percent_blank    ',
'        );',
'    elsif l_node_action = ''updateDataSource'' then',
'        ',
'        l_ds_type := wwv_flow_json.get_varchar2( p_path=>''dsType'' );',
'',
'        if l_ds_type = ''TABLE'' then',
'            l_table := wwv_flow_json.get_varchar2( p_path=>''table'' );',
'            l_where_clause := wwv_flow_json.get_varchar2( p_path=>''whereClause'' );',
'        elsif l_ds_type = ''SQL_QUERY'' then',
'            l_sql_query := wwv_flow_json.get_varchar2( p_path=>''sqlQuery'' );',
'        end if;',
'',
'        wwv_dg_data_gen_api.update_data_source(',
'            p_blueprint        => l_blueprint_name,',
'            p_name             => l_old_node_name,',
'            p_new_name         => l_node_name,',
'            p_data_source_type => l_ds_type,',
'            p_table            => l_table,',
'            p_sql_query        => l_sql_query,',
'            p_where_clause     => l_where_clause',
'        );',
'',
'    elsif l_node_action = ''updateBlueprint'' then',
'',
'        l_description := wwv_flow_json.get_varchar2( p_path=>''description'' );',
'        l_schema := wwv_flow_json.get_varchar2( p_path=>''schema'' );',
'        l_display_name := wwv_flow_json.get_varchar2( p_path=>''display'' );',
'',
'        wwv_dg_data_gen_api.update_blueprint(',
'            p_name             => l_old_node_name,',
'            p_new_name         => l_node_name,',
'            p_display_name     => l_display_name,',
'            p_description      => l_description,',
'            p_default_schema   => l_schema',
'            -- TODO: check lang.',
'        );',
'    end if;',
'',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write(''success'', true);',
'    wwv_flow_json.close_object;',
'',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write(''success'', false);',
'        wwv_flow_json.write(''message'', sqlerrm);',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>5402394591066021
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5402450128066022)
,p_process_sequence=>50
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GetBuiltins'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.open_array( ''builtins'' );',
'    for builtin in ( select wwv_flow_lang.system_message(p_name => ''ODG.BUILTINS.'' || upper(friendly_name) ) d,',
'                            friendly_name r,',
'                            native_datatype d_type,',
'                            wwv_flow_lang.system_message(p_name => ''ODG.BUILTINS.'' || upper( builtin_category ) ) b_cat',
'                       from apex_dg_builtins )',
'    loop',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( ''r'', builtin.r || '':'' || builtin.d_type );',
'        wwv_flow_json.write( ''d'', builtin.d );',
'        wwv_flow_json.close_object;',
'    end loop;',
'    wwv_flow_json.close_array;',
'    wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5402450128066022
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2610421112483413)
,p_process_sequence=>60
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GetRelatedBuiltIns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_related_builtin varchar2(4000);',
'    l_parent_builtin  varchar2(4000);',
'begin',
'',
'    l_related_builtin := wwv_flow.g_x01;',
'    l_parent_builtin  := wwv_flow.g_x02;',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.open_array( ''builtins'' );',
'    for builtin in ( select wwv_flow_lang.system_message(p_name => ''ODG.BUILTINS.'' || upper(friendly_name) ) d,',
'                            friendly_name r',
'                       from apex_dg_builtins ',
'                      where builtin_category = l_related_builtin',
'                        and friendly_name != l_parent_builtin )',
'    loop',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( ''r'', builtin.r );',
'        wwv_flow_json.write( ''d'', builtin.d );',
'        wwv_flow_json.close_object;',
'    end loop;',
'    wwv_flow_json.close_array;',
'    wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2610421112483413
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5402704075066025)
,p_process_sequence=>70
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'PrepareURL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   result varchar2(32767);',
'begin',
'   result:=htmldb_util.prepare_url(wwv_flow.g_x01);',
'   wwv_flow_json.open_object;',
'   wwv_flow_json.write(''success'', true);',
'   wwv_flow_json.write(''url'', result);',
'   wwv_flow_json.close_object;',
'exception',
' when others then',
'   wwv_flow_json.open_object;',
'   wwv_flow_json.write(''success'', false);',
'   wwv_flow_json.write(''message'', sqlerrm);',
'   wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5402704075066025
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2610228796483411)
,p_process_sequence=>80
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GetDbObjects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_names           wwv_flow_dynamic_exec.vc_arr2;',
'    l_values          wwv_flow_dynamic_exec.vc_arr2;',
'    l_sql_statement   varchar2( 32767 );',
'    l_include_public  boolean;',
'    l_cursor          number := sys.dbms_sql.open_cursor;',
'    l_object_name     varchar2( 32767 );',
'    l_comment         varchar2( 32676 );',
'    l_ignore          number;',
'begin',
'',
'    l_include_public := ( wwv_flow.g_x03 = ''Y'' );',
'    l_names(1)  := ''p_schema_name'';',
'    l_values(1) := :DATAGEN_SCHEMA;',
'    l_names(2)  := ''p_type'';',
'    l_values(2) := wwv_flow.g_x01;',
'',
'    l_sql_statement := q''{',
'            select o.name,',
'                   c.comments',
'              from ( select object_name as name,',
'                            owner       as table_owner,',
'                            object_name as table_name',
'                       from sys.all_objects',
'                      where owner       = :p_schema_name',
'                        and object_type = :p_type',
'                      union',
'                     /* get all objects which are referenced by a private or public synonym */',
'                     select s.synonym_name as name,',
'                            s.table_owner,',
'                            s.table_name',
'                       from sys.all_synonyms s,',
'                            sys.all_objects o',
'                      where }'' ||',
'                        case',
'                          when l_include_public then q''{ s.owner in ( :p_schema_name, ''PUBLIC'' ) }''',
'                          else ''s.owner = :p_schema_name''',
'                        end || q''{',
'                        and o.owner       = s.table_owner',
'                        and o.owner      <> ''SYS''',
'                        and o.object_name = s.table_name',
'                        and o.object_type = :p_type',
'                        /* don''t include a public synonym if it points to a local object with the same name */',
'                        and not (   o.owner       = :p_schema_name',
'                                and o.object_name = s.synonym_name',
'                                )',
'                   ) o,',
'                   sys.all_tab_comments c',
'             where c.owner      = o.table_owner',
'               and c.table_name = o.table_name',
'               and c.table_type = :p_type',
'             order by 1',
'           }'';',
'',
'    wwv_flow_dynamic_exec.parse_sql_statement (',
'            p_cursor          => l_cursor,',
'            p_sql_statement   => l_sql_statement,',
'            p_auto_bind_items => false,',
'            p_names           => l_names,',
'            p_values          => l_values,',
'            p_parse_as_schema => :DATAGEN_SCHEMA );',
'',
'',
'    sys.dbms_sql.define_column( l_cursor, 1, l_object_name, 32767 );',
'    sys.dbms_sql.define_column( l_cursor, 2, l_comment, 32767 );',
'    l_ignore := sys.dbms_sql.execute( l_cursor );',
'    ',
'    -- Fetch as long as there is a row returned',
'    wwv_flow_json.open_array;',
'    while sys.dbms_sql.fetch_rows( l_cursor ) > 0',
'    loop',
'        sys.dbms_sql.column_value( l_cursor, 1, l_object_name );',
'        sys.dbms_sql.column_value( l_cursor, 2, l_comment );',
'',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.  write( ''name'',    l_object_name );',
'        wwv_flow_json.  write( ''comment'', l_comment );',
'        wwv_flow_json.close_object;',
'    end loop;',
'    wwv_flow_json.close_array;',
'',
'    sys.dbms_sql.close_cursor(l_cursor);',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2610228796483411
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3201780515104817)
,p_process_sequence=>90
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'DeleteFromBlueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_object_name        varchar2(1000);',
'   l_object_parent_name varchar2(1000);',
'   l_object_type        varchar2(100);',
'begin',
'   l_object_name := wwv_flow.g_x01;',
'   l_object_type := wwv_flow.g_x02;',
'   l_object_parent_name := wwv_flow.g_x03;',
'',
'   if l_object_type = ''table'' then',
'',
'        wwv_dg_data_gen_api.remove_table(',
'            p_blueprint  => :P4100_BLUEPRINT_NAME,',
'            p_table_name => l_object_name );',
'',
'   elsif l_object_type = ''column'' then',
'',
'        wwv_dg_data_gen_api.remove_column(',
'            p_blueprint   => :P4100_BLUEPRINT_NAME,',
'            p_table_name  => l_object_parent_name,',
'            p_column_name => l_object_name );',
'',
'   elsif l_object_type = ''datasource'' then',
'',
'        wwv_dg_data_gen_api.remove_data_source(',
'            p_blueprint => :P4100_BLUEPRINT_NAME,',
'            p_name      => l_object_name );',
'',
'   end if;',
'',
'   wwv_flow_json.open_object;',
'   wwv_flow_json.write(''success'', true);',
'   wwv_flow_json.close_object;',
'exception',
' when others then',
'   wwv_flow_json.open_object;',
'   wwv_flow_json.write(''success'', false);',
'   wwv_flow_json.write(''message'', sqlerrm);',
'   wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3201780515104817
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2611649472483425)
,p_process_sequence=>100
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ValidateProperty'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                    p_location        => wwv_flow.g_x03,',
'                    p_query_type      => wwv_flow.g_x04,',
'                    p_sql_query       => wwv_flow.g_x02,',
'                    p_parse_as_schema => :P4100_SCHEMA );',
'',
'',
'    wwv_flow_json.open_object;',
'    if ( length( l_describe_result.error_message ) > 0 ) then',
'        wwv_flow_json.write(''success'', false);',
'        wwv_flow_json.write(''message'',l_describe_result.error_message);',
'    else',
'        wwv_flow_json.write(''success'', true);',
'    end if;',
'    wwv_flow_json.close_object;',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write(''success'', false);',
'        wwv_flow_json.write(''message'', sqlerrm);',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2611649472483425
);
end;
/
prompt --application/pages/page_05005
begin
wwv_flow_imp_page.create_page(
 p_id=>5005
,p_name=>'Create MLE Environment'
,p_alias=>'CREATE-MLE-ENVIRONMENT'
,p_page_mode=>'MODAL'
,p_step_title=>'Create MLE Environment'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4706787661678552)
,p_plug_name=>'MLE Environment Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4707134271678556)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3018126071205834)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4707134271678556)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create MLE Environment'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3018522517205835)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4707134271678556)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775947064216714)
,p_name=>'P5005_PARSING_SCHEMA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4706787661678552)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3013506388205824)
,p_name=>'P5005_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4706787661678552)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Environment Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The name of the environment. It should be a valid SQL object identifier, for example <code>MY_ENV</code>.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3015329370205829)
,p_name=>'P5005_LANGUAGE_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4706787661678552)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Language Options'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Language options can, for example, enable or disable builtins not covered by a language standard. They can also be used to select a specific version of a language standard. MLE language options can map directly to GraalVM language options.</p>',
'<p>',
'    The currently supported language options are:',
'    <ul>',
'        <li>js.strict</li>',
'        <li>js.console</li>',
'        <li>js.polyglot-builtin</li>',
'    </ul>',
'</p>',
'<p>Example: <code>js.strict=true,js.console=false</code></p>',
'<p>If a language option specified in an environment is not supported by MLE, or if the language',
'option string has an invalid format, an ORA-04152 error is thrown when a context is created',
'using the environment.</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3673881097097501)
,p_name=>'P5005_OBJECT_STATUS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4706787661678552)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18602640094796711)
,p_name=>'P5005_OBJECT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4706787661678552)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18602760328796712)
,p_name=>'P5005_OBJECT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4706787661678552)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3020671452205844)
,p_validation_name=>'P5005_NAME valid & available'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P5005_NAME,',
'    p_owner           => :P5005_PARSING_SCHEMA,',
'    p_object_type     => ''MLE_ENVIRONMENT'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P5005_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(3018126071205834)
,p_associated_item=>wwv_flow_imp.id(3013506388205824)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18602429112796709)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3018522517205835)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18602598777796710)
,p_event_id=>wwv_flow_imp.id(18602429112796709)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18602980715796714)
,p_name=>'Replaces Spaces '
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P5005_NAME'
,p_condition_element=>'P5005_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18603058366796715)
,p_event_id=>wwv_flow_imp.id(18602980715796714)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5005_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P5005_NAME").getValue().replaceAll(" ","_")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3021318709205845)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'On Create'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv( :P5005_PARSING_SCHEMA );',
'',
'wwv_flow_code_exec_mle_dev.create_env (',
'    p_schema            => :P5005_PARSING_SCHEMA,',
'    p_env_name          => :P5005_NAME,',
'    p_language_options  => :P5005_LANGUAGE_OPTIONS );',
'',
'-- set return item values to OB page 2000',
':P5005_OBJECT_TYPE := ''MLE_ENVIRONMENT'';',
'',
'select object_id,',
'       status',
'  into :P5005_OBJECT_ID,',
'       :P5005_OBJECT_STATUS',
'  from sys.dba_objects',
' where object_name = :P5005_NAME',
'   and object_type = ''MLE ENVIRONMENT''',
'   and owner       = :P5005_PARSING_SCHEMA;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3018126071205834)
,p_process_success_message=>'Environment created'
,p_internal_uid=>3021318709205845
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18602819791796713)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P5005_NAME,P5005_OBJECT_ID,P5005_OBJECT_TYPE'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3018126071205834)
,p_process_success_message=>'MLE Environment created successfully.'
,p_internal_uid=>18602819791796713
);
end;
/
prompt --application/pages/page_05015
begin
wwv_flow_imp_page.create_page(
 p_id=>5015
,p_name=>'Create MLE Module - JavaScript'
,p_alias=>'CREATE-MLE-MODULE-JAVASCRIPT'
,p_page_mode=>'MODAL'
,p_step_title=>'Create MLE Module - JavaScript'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.hidden {',
'    display: none;',
'}',
'',
'#P5015_SOURCE_TEXT_widget {',
'    height: 300px !important;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1693866970472732)
,p_plug_name=>'MLE Module Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(380771699411878611)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1694213580472736)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690697788869123307)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1694304467472737)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1694213580472736)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create MLE Module'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1694413763472738)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1694213580472736)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(385765234519963355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1693993114472733)
,p_name=>'P5015_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The name of the module. It should be a valid SQL object identifier, for example <code>MY_MODULE</code>.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1694067625472734)
,p_name=>'P5015_MODULE_VERSION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Version'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671029226029669)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'An optional version string. The version is purely informational and does not influence the behavior of MLE. For example <code>1.0.0</code>.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1694115097472735)
,p_name=>'P5015_SOURCE_OPTIONS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Source Type'
,p_source=>'TEXT'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE.MLE_MODULE_JAVASCRIPT.HOW'
,p_lov=>'.'||wwv_flow_imp.id(3091085801966871)||'.'
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose "Upload File" if in order to upload a file from your computer, "Source Code" in order to type or paste the module code, or "URL" to simply paste the URL of a file on the internet.'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1694652981472740)
,p_name=>'P5015_SOURCE_FILE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_css_classes=>'hidden'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The file to upload.'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'REQUEST'
,p_attribute_10=>'N'
,p_attribute_12=>'DROPZONE_INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1694771147472741)
,p_name=>'P5015_SOURCE_TEXT'
,p_data_type=>'CLOB'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Source Code'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(492677350674053149)
,p_item_css_classes=>'hidden'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The module source code.'
,p_attribute_01=>'mle-javascript-module'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1776049813216715)
,p_name=>'P5015_PARSING_SCHEMA'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2630211696305701)
,p_name=>'P5015_SOURCE_URL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(488671190365029680)
,p_item_css_classes=>'hidden'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The URL of the file to be fetched.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8400183196472801)
,p_name=>'P5015_OBJECT_STATUS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18603972813796724)
,p_name=>'P5015_OBJECT_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18604073264796725)
,p_name=>'P5015_OBJECT_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1693866970472732)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18603658922796721)
,p_validation_name=>'P5015_NAME valid & available'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4500_ob_wiz_dev.validate_object_name(',
'    p_name            => :P5015_NAME,',
'    p_owner           => :P5015_PARSING_SCHEMA,',
'    p_object_type     => ''MLE_MODULE'' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P5015_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1694304467472737)
,p_associated_item=>wwv_flow_imp.id(1693993114472733)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1695250100472746)
,p_validation_name=>'Source option must be selected'
,p_validation_sequence=>20
,p_validation=>'P5015_SOURCE_OPTIONS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A source type must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(1694304467472737)
,p_associated_item=>wwv_flow_imp.id(1694115097472735)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1695449604472748)
,p_validation_name=>'Source FILE'
,p_validation_sequence=>30
,p_validation=>'P5015_SOURCE_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A file must be provided.'
,p_validation_condition=>'P5015_SOURCE_OPTIONS'
,p_validation_condition2=>'FILE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1694304467472737)
,p_associated_item=>wwv_flow_imp.id(1694652981472740)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1695585135472749)
,p_validation_name=>'Source TEXT'
,p_validation_sequence=>40
,p_validation=>'P5015_SOURCE_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Some source code must be provided.'
,p_validation_condition=>'P5015_SOURCE_OPTIONS'
,p_validation_condition2=>'TEXT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1694304467472737)
,p_associated_item=>wwv_flow_imp.id(1694771147472741)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1694876160472742)
,p_name=>'On P5015_SOURCE_OPTIONS Change'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P5015_SOURCE_OPTIONS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1694909581472743)
,p_event_id=>wwv_flow_imp.id(1694876160472742)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'const choice = apex.items.P5015_SOURCE_OPTIONS.value;',
'',
'const file = apex.items.P5015_SOURCE_FILE;',
'const plain = apex.items.P5015_SOURCE_TEXT;',
'const url = apex.items.P5015_SOURCE_URL;',
'',
'if ( choice === "FILE" ) {',
'    file.show();',
'} else {',
'    file.hide();',
'}',
'',
'if ( choice === "TEXT" ) {',
'    plain.show();',
'} else {',
'    plain.hide();',
'}',
'',
'if ( choice === "URL" ) {',
'    url.show();',
'} else {',
'    url.hide();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18603421546796719)
,p_name=>'Replaces Spaces'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P5015_NAME'
,p_condition_element=>'P5015_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18603564853796720)
,p_event_id=>wwv_flow_imp.id(18603421546796719)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5015_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P5015_NAME").getValue().replaceAll(" ","_")'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18603740944796722)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1694413763472738)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18603898767796723)
,p_event_id=>wwv_flow_imp.id(18603740944796722)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2630391999305702)
,p_name=>'On Submit Click'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1694304467472737)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2630427431305703)
,p_event_id=>wwv_flow_imp.id(2630391999305702)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.clearErrors();',
'',
'const showUrlError = errm => {',
'    apex.message.showErrors( {',
'        type: "error",',
'        location: "page",',
'        message: errm',
'    } );',
'};',
'',
'const submit = () => {',
'    apex.page.submit( {',
'        request: "CREATE"',
'    } );',
'};',
'',
'if( apex.items.P5015_SOURCE_OPTIONS.value === "URL" ) {',
'    const url = apex.items.P5015_SOURCE_URL.value;',
'    if( !url) {',
'        apex.message.showErrors( {',
'            type: "error",',
'            location: "inline",',
'            pageItem: "P5015_SOURCE_URL",',
'            message: apex.lang.getMessage( "OB.MLE.URL_MUST_BE_PROVIDED" )',
'        } );',
'    } else {',
'        fetch( url )',
'            .then( res => {',
'                if( !res.ok ) {',
'                    throw new Error( apex.lang.getMessage( "OB.MLE.URL_COULD_NOT_FETCH" ) );',
'                }',
'                return res.text();',
'            })',
'            .then( text => {',
'                apex.items.P5015_SOURCE_TEXT.value = text;',
'                submit();',
'            } )',
'            .catch( e => {',
'                apex.message.showErrors( {',
'                    type: "error",',
'                    location: "page",',
'                    message: e.message',
'                } );',
'            } );',
'    }',
'} else {',
'    submit();',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2984396387654501)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'On Create Click - Create Module'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob clob;',
'begin',
'    wwv_flow_sw_api.check_priv( :P5015_PARSING_SCHEMA );',
'',
'    if :P5015_SOURCE_OPTIONS = ''FILE'' then',
'        select wwv_flow_utilities.blob_to_clob( blob_content )',
'          into l_clob',
'          from wwv_flow_temp_files',
'         where name = :P5015_SOURCE_FILE;',
'    elsif :P5015_SOURCE_OPTIONS in ( ''TEXT'', ''URL'' ) then',
'        l_clob := :P5015_SOURCE_TEXT;',
'    end if;',
'',
'    wwv_flow_code_exec_mle_dev.create_module (',
'        p_schema        => :P5015_PARSING_SCHEMA,',
'        p_module_name   => :P5015_NAME,',
'        p_language      => wwv_flow_code_exec.c_javascript,',
'        p_version       => :P5015_MODULE_VERSION,',
'        p_source        => l_clob );',
'',
'    -- set return item values to OB page 2000',
'    :P5015_OBJECT_TYPE := ''MLE_MODULE'';',
'',
'    select object_id,',
'           status',
'      into :P5015_OBJECT_ID,',
'           :P5015_OBJECT_STATUS',
'      from sys.dba_objects',
'     where object_name = :P5015_NAME',
'       and object_type = ''MLE MODULE''',
'       and owner       = :P5015_PARSING_SCHEMA;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1694304467472737)
,p_process_success_message=>'Module created'
,p_internal_uid=>2984396387654501
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18604136616796726)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P5015_NAME,P5015_OBJECT_ID,P5015_OBJECT_TYPE'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1694304467472737)
,p_process_success_message=>'Module created successfully.'
,p_internal_uid=>18604136616796726
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_imp_page.create_page(
 p_id=>8000
,p_name=>'Workspace Search Results'
,p_alias=>'WORKSPACE-SEARCH-RESULTS'
,p_step_title=>'Workspace Search Results'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(690783685471803190)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12524102140541924)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29097909672335205)
,p_plug_name=>'Search Results'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(690714020036152159)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    ''Application'' type,',
'    id, ',
'    name||'' (''||id||'')'' name,',
'    last_updated_on updated,',
'    lower(last_updated_by)  updated_by,',
'    created_on  created,',
'    lower(created_by) created_by,',
'    f.owner,',
'    decode(f.publish_yn,''Y'',t_yes,''N'',t_no,t_no) published,',
'    ''<button type="button" data-link="''||wwv_flow_dev.get_run_url(id)||',
'        ''" title="''||wwv_flow_escape.html(sm.run)||',
'        ''" aria-label="''||wwv_flow_escape.html(sm.run)||',
'        ''" class="a-Button a-Button--noLabel a-Button--withIcon launch-aut"><span class="a-Icon icon-run-page" aria-hidden="true"></span></button>''',
'        run_link,',
'    ''<a href="''||',
'        decode(build_status,''RUN_ONLY'',',
'        ''f?p=4000:733:''||:app_session||''::::FB_FLOW_ID:''||id,',
'        ''f?p=4000:1:''||:app_session||',
'        '':::RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:''||',
'        f.id||'',''||f.id||'',''||f.id||'','') ||',
'        ''"><img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-pencil.png" class="apex-edit-pencil"''||',
'        '' border="0" alt="''||wwv_flow_escape.html(sm.m_edit)||''" title="''||wwv_flow_escape.html(sm.m_edit)||''"/></a>''',
'        edit_link',
'from   wwv_flow_visible_flows f,',
'      (select wwv_flow_lang.system_message(''EDIT'') m_edit,',
'              wwv_flow_lang.system_message(''RUN'') run,',
'              wwv_flow_lang.system_message(''RUN_ONLY'') run_only,',
'              wwv_flow_lang.system_message(''RUN_AND_BUILD'') run_and_build,',
'              wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'              wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'              wwv_flow_lang.system_message(''Unassigned'') t_unassigned',
'       from sys.dual) sm'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(29098015502335205)
,p_name=>'Search Results'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29098218651335225)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29098630127335227)
,p_db_column_name=>'NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29098806283335227)
,p_db_column_name=>'OWNER'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29099308842335228)
,p_db_column_name=>'UPDATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29099620468335229)
,p_db_column_name=>'CREATED'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29099716652335229)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29108918291498233)
,p_db_column_name=>'TYPE'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29109018593498237)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29109109335498237)
,p_db_column_name=>'PUBLISHED'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Published'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29109216943498237)
,p_db_column_name=>'RUN_LINK'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Run'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29109308233498237)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Edit'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(29101911908335569)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1320518008536650'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'EDIT_LINK:TYPE:NAME:OWNER:UPDATED:UPDATED_BY:PUBLISHED:RUN_LINK'
,p_sort_column_1=>'UPDATED'
,p_sort_direction_1=>'DESC'
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_imp_shared.create_install(
 p_id=>wwv_flow_imp.id(273921102557795427)
);
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_imp.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false)
);
commit;
end;
/
set verify on feedback on define on
prompt  ...done
