/*!
 Date Picker - APEX component for picking dates. Supports rendering as date/datetimepicker or native date form controls
 Copyright (c) 2022, 2024, Oracle and/or its affiliates.
 */
!function(e,t,a,n,r,l,s,o,i){"use strict";const d=a.getTopApex().jQuery,c="dayFormatter",u="apex_disabled",p="apex-item-datepicker",m="a-DatePicker",f="a-Icon",_="u-vh",D="ui-dialog-datepicker",g="is-selected",v="is-disabled",h="icon-calendar-time",y="icon-calendar",b=m+"-actions",C="ALL",T="DAY",w="HOUR",E="MINUTE",M="YYYY-MM-DD",A='YYYY-MM-DD"T"HH24:MI',S='YYYY-MM-DD"T"HH24:MI:SS',I="YYYYMMDDHH24MI",N="change",x="click",k="id",V="size",$="placeholder",O="valid-example",Y="required",U="maxlength",B="minlength",L="disabled",H="aria-label",R="tabindex",P="aria-labelledby",F="aria-controls",K="aria-hidden",q="role",W="value",j="name",z="type",Q="title",X="readonly",J="autofocus",G="autocomplete",Z="aria-describedby",ee="aria-expanded",te="aria-disabled",ae="aria-selected",ne="region",re="none",le="link",se="inline",oe="selectable",ie="popup",de="native",ce="focus",ue="click",pe="number",me="number-of-month",fe="one-month",_e="visible",De="hidden",ge=n.getMessage,ve="APEX.DATEPICKER.",he=ve+"SELECT_DATE_AND_TIME",ye=ve+"SELECT_DATE",be=ve+"SELECT_DAY",Ce=ve+"ISO_WEEK",Te=ve+"ISO_WEEK_ABBR",we=ve+"SELECT_TIME",Ee=ve+"HOUR",Me=ve+"MINUTES",Ae=ve+"AM_PM",Se=ve+"ACTIONS",Ie=ve+"MONTH",Ne=ve+"YEAR",xe=ve+"PREVIOUS_MONTH",ke=ve+"NEXT_MONTH",Ve=ve+"DONE",$e=ve+"TODAY",Oe=ve+"CLEAR",Ye=ve+"SELECT_MONTH_AND_YEAR",Ue=ve+"VISUALLY_HIDDEN_EDIT",Be=ve+"POPUP",Le=ve+"VALUE_MUST_BE_BETWEEN",He=ve+"VALUE_MUST_BE_ON_OR_AFTER",Re=ve+"VALUE_MUST_BE_ON_OR_BEFORE",Pe=ve+"VALUE_INVALID",Fe="ArrowRight",Ke="ArrowLeft",qe={getNumberOfDays:function(e,t){let a=e+t;for(;a%7!=0;)a+=1;return a},setMonth:function(e,t){let a=e.getDate();return e.setMonth(t),e.getDate()!==a&&e.setDate(0),e},getMinuteOptions:function(e){let t=e;(e<1||e>60)&&(t=1);const a=Math.ceil(60/t),n=[];for(let e=0;e<a;e++){const a=e*t;n.push(a)}return n},getYearDifference:function(e,t){let a=(e.getTime()-t.getTime())/1e3;return a/=86400,Math.ceil(Math.abs(a/365.25))},findClosestMinute:function(e,t){let a=qe.getMinuteOptions(e);return a.push(60),a.reduce(((e,a)=>{const n=Math.abs(e-t),r=Math.abs(a-t);return n===r?e>a?e:a:r<n?a:e}))},checkMinMax:function(e,t,a=r.UNIT.SECOND){return e.minDate&&e.maxDate?r.isSameOrAfter(t,e.minDate,a)&&r.isSameOrBefore(t,e.maxDate,a):e.minDate?r.isSameOrAfter(t,e.minDate,a):!e.maxDate||r.isSameOrBefore(t,e.maxDate,a)},parseMinMax:function(e,t){try{return r.parse(e,t)}catch(e){}try{return r.parse(e,S)}catch(e){}try{return r.parse(e,A)}catch(e){}try{return r.parse(e,M)}catch(e){}try{return r.parse(e,I)}catch(e){}return null},updateMinMax:function(e){e.min?(e.minDate=qe.parseMinMax(e.min,e.format),null===e.minDate&&l.error(`Min must (${e.min}) match the following formats:`,[e.format,S,I])):e.minDate=null,e.max?(e.maxDate=qe.parseMinMax(e.max,e.format),null===e.maxDate&&l.error(`Max must (${e.max}) match the following formats:`,[e.format,S,I])):e.maxDate=null},moveCalendarView:function(e,t,n,l){let s=n;if(qe.render(e,t),!s){const n=r.format(qe.calcCurrentCalendarDate(e,t,l)||e._currentCalendarDate,M);s="td[data-date='"+a.escapeCSS(n)+"']"}queueMicrotask((function(){d(e._calendar).find(s).trigger("focus")}))},calcCurrentCalendarDate:function(e,t,a){let n=null;if(!a)return n;e._currentCalendarDate&&(n=r.clone(e._currentCalendarDate)),qe.checkMinMax(t,a,r.UNIT.DAY)?n=r.clone(a):t.minDate&&r.isBefore(a,t.minDate,r.UNIT.DAY)?n=r.clone(t.minDate):t.maxDate&&r.isAfter(a,t.maxDate,r.UNIT.DAY)&&(n=r.clone(t.maxDate));const l=qe.findClosestMinute(t.timeIncrementMinute,n.getMinutes());if(60===l){const e=l-n.getMinutes();n=r.add(n,e,r.UNIT.MINUTE)}else n.setMinutes(l);return n},commitValue:function(e,t){let a;e._pendingValue&&(e._pendingValue.setSeconds(0),a=r.format(e._pendingValue,t.format)),e.setValue(a)},setDateToValue:function(e,t,a,n,r){let l=e._pendingValue||e._currentCalendarDate||new Date;a?([T,C].includes(n)&&(l=new Date(a.getFullYear(),a.getMonth(),a.getDate(),l.getHours(),l.getMinutes(),l.getSeconds(),0)),[w,C].includes(n)&&l.setHours(a.getHours()),[E,C].includes(n)&&l.setMinutes(a.getMinutes())):l=null,e._pendingValue=l,r||e.showTime&&t.displayAs!==se||qe.commitValue(e,t)},elements:{getActive:function(e){return d(e._calendar).find(".is-selected")},getSelectable:function(e){return d(e._calendar).find("td[data-date]")},getFocusElement:function(e){const t=qe.elements.getActive(e);return t.length?t:qe.elements.getSelectable(e).first()}},addKeyBoardNavigation:function(e,n){qe.elements.getSelectable(e).off("keydown.document"+e._elementIDSafe),n.disabled||qe.elements.getSelectable(e).on("keydown.document"+e._elementIDSafe,(function(l){const s=r.parse(t(l.currentTarget).attr("data-date"),M);let o,i,c,u="td[data-date='#DATADATE#']",p=n.previousNextDistanceSteps,m=r.UNIT.MONTH;switch(l.code){case"Home":l.preventDefault(),c=d(l.currentTarget).closest("tr").find("td[data-date]").first(),c.trigger("focus");break;case"End":l.preventDefault(),c=d(l.currentTarget).closest("tr").find("td[data-date]").last(),c.trigger("focus");break;case"PageDown":l.preventDefault(),!0===l.shiftKey&&(m=r.UNIT.YEAR,p=1),o=r.add(r.clone(s),1,m),i=r.format(o,M),c=d(e._calendar).find(u.replace("#DATADATE#",a.escapeCSS(i))).first(),c.length?c.trigger("focus"):(e._currentCalendarDate=qe.calcCurrentCalendarDate(e,n,r.add(r.clone(e._currentCalendarDate),p,m)),qe.moveCalendarView(e,n,null,o));break;case"PageUp":l.preventDefault(),!0===l.shiftKey&&(m=r.UNIT.YEAR,p=1),o=r.subtract(r.clone(s),1,m),i=r.format(o,M),c=d(e._calendar).find(u.replace("#DATADATE#",a.escapeCSS(i))).first(),c.length?c.trigger("focus"):(e._currentCalendarDate=qe.calcCurrentCalendarDate(e,n,r.subtract(r.clone(e._currentCalendarDate),p,m)),qe.moveCalendarView(e,n,null,o));break;case e._backwardkey:l.preventDefault(),o=r.subtract(r.clone(s),1,r.UNIT.DAY),i=r.format(o,M),c=d(e._calendar).find(u.replace("#DATADATE#",a.escapeCSS(i))).last(),c.length?c.trigger("focus"):(e._currentCalendarDate=qe.calcCurrentCalendarDate(e,n,r.lastOfMonth(r.subtract(r.clone(e._currentCalendarDate),p,r.UNIT.MONTH))),qe.moveCalendarView(e,n,null,o));break;case e._forwardKey:l.preventDefault(),o=r.add(r.clone(s),1,r.UNIT.DAY),i=r.format(o,M),c=d(e._calendar).find(u.replace("#DATADATE#",a.escapeCSS(i))).first(),c.length?c.trigger("focus"):(e._currentCalendarDate=qe.calcCurrentCalendarDate(e,n,r.firstOfMonth(r.add(r.clone(e._currentCalendarDate),p,r.UNIT.MONTH))),qe.moveCalendarView(e,n,null,o));break;case"ArrowDown":l.preventDefault(),o=r.add(r.clone(s),7,r.UNIT.DAY),i=r.format(o,M),c=d(e._calendar).find(u.replace("#DATADATE#",a.escapeCSS(i))).first(),c.length?c.trigger("focus"):(e._currentCalendarDate=qe.calcCurrentCalendarDate(e,n,r.add(r.clone(e._currentCalendarDate),p,r.UNIT.MONTH)),qe.moveCalendarView(e,n,null,o));break;case"ArrowUp":l.preventDefault(),o=r.subtract(r.clone(s),7,r.UNIT.DAY),i=r.format(o,M),c=d(e._calendar).find(u.replace("#DATADATE#",a.escapeCSS(i))).first(),c.length?c.trigger("focus"):(e._currentCalendarDate=qe.calcCurrentCalendarDate(e,n,r.subtract(r.clone(e._currentCalendarDate),p,r.UNIT.MONTH)),qe.moveCalendarView(e,n,null,o));break;case"Enter":case"Space":l.preventDefault(),l.stopPropagation(),d(this).click();break;case"Escape":n.displayAs===ie&&(l.preventDefault(),l.stopPropagation(),qe.dialog.close(e))}}))},dialog:{show:function(e){if(!e._dialogOpen){const t={id:e._elementIDSafe+"_dialog",title:n.formatMessageNoEscape(Be,e._elementLabelSafe),isPopup:!0,parentElement:e,returnFocusTo:e._wrappedElement$,noOverlay:!0,draggable:!0,resizable:!1,width:"auto",height:"auto",okButton:!1,dialogClass:D,notification:!1,callback:function(){e._skipFocus=!0,e._popupButton$.removeClass(u),e._popupButton$.attr(ee,"false"),e._wrappedElement$.attr(ee,"false"),e._dialogOpen=!1,queueMicrotask((function(){e._skipFocus=!1}))},init:function(t){t.empty(),t.append('<input type="hidden" autofocus="autofocus" />'),t.append(e._calendar)},open:function(t){e._dialog$=d(t.target);e._dialog$.closest("."+D).find(".ui-dialog-titlebar").addClass(_),e._popupButton$.addClass(u),e._popupButton$.attr(ee,"true"),e._wrappedElement$.attr(ee,"true"),e._dialogOpen=!0}};e._dialog$=o.showDialog("",t)}},close:function(e){e._dialog$&&e._dialog$.popup("close")},destroy:function(e){e._dialog$&&(e._dialog$.popup("close"),e._dialog$.closest("."+D).remove(),e._dialog$=null)}},setCalendarHours:function(e,t,a,n){let r=parseInt(a.val(),10);e._ampm&&n&&("PM"===n.val()&&12!==r&&(r+=12),"AM"===n.val()&&12===r&&(r=0));const l=(new Date).setHours(r);qe.setDateToValue(e,t,new Date(l),w)},addOrRemoveAttributes:function(e,t,a){"boolean"==typeof a?e.prop(t,a):a?e.attr(t,a):e.removeAttr(t)},createOrUpdateInput:function(e,a){e._wrappedElement$||(e._wrappedElement$=e.element.find("input")),0===e._wrappedElement$.length&&(e._wrappedElement$=t("<input>"),e.element.append(e._wrappedElement$),e._wrappedElement$.val(e.element.val())),e._wrappedElement$.off("change."+e._elementID),e._wrappedElement$.on("change."+e._elementID,(function(){e._skipRender=!1,e.setAttribute(W,e._wrappedElement$.val()),a.displayAs===ie&&e._dialogOpen&&queueMicrotask((function(){qe.elements.getFocusElement(e).trigger("focus")}))})),e._wrappedElement$.attr(k,e._inputIDSafe),e._wrappedElement$.addClass("apex-item-text"),e._wrappedElement$.addClass("apex-item-datepicker"),e._wrappedElement$.addClass(p),a.displayAs===de?(e.element.addClass(p+"-"+de),e.element.removeClass(p+"-"+ie),e.element.removeClass(p+"-"+se),a.minDate&&qe.addOrRemoveAttributes(e._wrappedElement$,"min",a.min),a.maxDate&&qe.addOrRemoveAttributes(e._wrappedElement$,"max",a.max),a.showTime?(e._wrappedElement$.attr(z,"datetime-local"),a.format=A):(e._wrappedElement$.attr(z,"date"),a.format=M)):e._wrappedElement$.attr(z,"text"),a.displayAs===se?(e._wrappedElement$.prop(X,!0),e._wrappedElement$.attr(R,"-1"),e._wrappedElement$.attr("aria-roledescription",ge(Ue)),e._wrappedElement$.addClass(_)):(e._wrappedElement$.prop(X,a.readonly),a.tabindex||""+a.tabindex=="0"?e._wrappedElement$.attr(R,a.tabindex):e._wrappedElement$.removeAttr(R,a.tabindex),e._wrappedElement$.removeAttr("aria-roledescription"),e._wrappedElement$.removeClass(_)),a.displayAs===ie?e._wrappedElement$.attr("aria-haspopup","dialog"):e._wrappedElement$.removeAttr("aria-haspopup","dialog"),e._wrappedElement$.prop(L,a.disabled),e._wrappedElement$.prop(Y,a.required),e._inputRegistered||([ce,ue].includes(a.showOn)&&e._wrappedElement$.on(a.showOn,(function(){a.displayAs!==ie||e._dialogOpen||e._skipFocus||queueMicrotask((()=>{e.isConnected&&e._wrappedElement$.is(":focus")&&qe.dialog.show(e)})),e._skipFocus=!1})),e._wrappedElement$.on("keydown",(function(t){a.displayAs===ie&&(["ArrowDown","ArrowUp"].includes(t.key)?(qe.dialog.show(e),qe.elements.getFocusElement(e).trigger("focus")):["Tab","Escape"].includes(t.key)&&(qe.dialog.close(e),"Escape"===t.key&&(t.preventDefault(),t.stopPropagation())))})),e._inputRegistered=!0)},createUpdateOrDeletePopupButton:function(e,a){if(e._popupButton$||(e._popupButton$=e.element.find("button.a-Button--calendar")),a.displayAs===ie){if(0===e._popupButton$.length&&(e._popupButton$=We.defaultElements.button(e,a,null,"a-Button--calendar ui-datepicker-trigger"),e.element.append(e._popupButton$)),e._popupButtonRegistered||(e._popupButton$.on(x,(function(t){a.displayAs===ie&&(qe.dialog.show(e),qe.elements.getFocusElement(e).trigger("focus")),t.preventDefault()})),e._popupButtonRegistered=!0),0===e._popupButton$.find("span").length){const a=t("<span>");a.addClass("a-Icon"),e.showTime?a.addClass("icon-calendar-time"):a.addClass("icon-calendar"),e._popupButton$.append(a)}e._elementLabelIDSafe&&e._popupButton$.attr(Z,e._elementLabelIDSafe),a.disabled?e._popupButton$.addClass(u):e._dialogOpen||e._popupButton$.removeClass(u),e._popupButton$.attr("aria-controls",e._inputIDSafe),e._popupButton$.attr("aria-haspopup","dialog"),a.showOn===ce?e._popupButton$.attr(R,"-1"):e._popupButton$.removeAttr(R),a.showTime?(e._popupButton$.attr(Q,ge(he)),e._popupButton$.attr(H,ge(he)),e._popupButton$.find("span").addClass(h),e._popupButton$.find("span").removeClass(y)):(e._popupButton$.attr(Q,ge(ye)),e._popupButton$.attr(H,ge(ye)),e._popupButton$.find("span").removeClass(h),e._popupButton$.find("span").addClass(y))}else e._popupButton$&&e._popupButton$.remove(),e._popupButton$=null,e._popupButtonRegistered=null},render:function(e,t){if(e._calendar&&e._calendar.empty(),t.displayAs!==de){t.displayAs===ie&&(e.element.addClass(p+"--"+ie),e.element.removeClass(p+"--"+se),e.element.removeClass(p+"--"+de)),t.displayAs===se&&(e.element.addClass(p+"--"+se),e.element.removeClass(p+"--"+ie),e.element.removeClass(p+"--"+de)),e._calendar||(e._calendar=We.calendar(e,t));const a=We.container(e,t);e._calendar.append(a),t.displayAs===se&&(e.element.append(e._calendar),t.disabled?e.element.addClass(u):e.element.removeClass(u)),qe.addKeyBoardNavigation(e,t)}}},We={defaultElements:{button:function(e,a,n,r,l,s,o){const i=t("<button>");if(i.addClass("a-Button"),i.attr(z,"button"),l){i.attr(Q,n);const e=t("<span>");e.addClass(f),e.addClass(l),e.attr(K,"true"),i.append(e),i.attr(H,n)}else i.text(n);return i.addClass(r),s&&i.attr(R,s),o&&i.attr(F,o),a.displayAs!==ie&&e._elementLabelIDSafe&&i.attr(Z,e._elementLabelIDSafe),i},label:function(e,a){const n=t("<label>");return n.addClass(_),n.attr("for",a),n.text(e),n}},calendar:function(e,a){const n=t("<div>");n.addClass(m),n.attr(q,ne);const r=a.showTime?ge(he):ge(ye);return e._elementLabelSafe?n.attr(H,e._elementLabelSafe+" - "+r):n.attr(H,r),a.displayAs===se?n.addClass(m+"-"+se):n.removeClass(m+"-"+se),n},container:function(e,a){const n=e._calendar,l=We.header();n.append(l);const s=We.monthYearSelection.container();l.append(s),s.append(We.monthYearSelection.monthSelection(e,a)),s.append(We.monthYearSelection.yearSelection(e,a)),l.append(We.buttons.prevMonth(e,a)),l.append(We.buttons.nextMonth(e,a));const o=t("<div>");o.attr(k,e._calendarTableIDSafe),o.addClass(m+"-calendars"),o.attr(q,ne),o.attr(H,ge(be)),n.append(o);for(let n=0;n<a.numberOfMonths;n++){let l=r.clone(e._currentCalendarDate);if(a.numberOfMonths>1){const t=a.numberOfMonths-Math.trunc(a.numberOfMonths/2)-1;l=r.add(l,-t+n,r.UNIT.MONTH),e._calendar.addClass(m+"--multiple")}else e._calendar.removeClass(m+"--multiple");const s=e._elementIDSafe+"_"+r.format(l,"month_YYYY")+"_header",i=t("<div>");i.addClass(m+"-calendarContainer"),i.attr(q,ne),i.attr(P,s),o.append(i);const d=t("<div>");d.addClass(m+"-calendarTitle"),d.text(r.format(l,"Month YYYY")),d.attr(k,s),d.attr("aria-live","polite"),i.append(d);const c=We.table.container(l,s);i.append(c),c.append(We.table.head(a)),c.append(We.table.body(e,a,l))}if(a.showTime||a.todayButton||!a.required&&a.displayAs===se){const t=We.footer.container();if(a.showTime){const n=We.footer.timePicker(e,a);t.append(n)}const r=We.footer.actions(e,a);""!==r.html()&&t.append(r),""!==t.html()&&n.append(t)}return n},header:function(){const e=t("<div>");return e.addClass(m+"-header"),e.attr(H,ge(Ye)),e.attr(q,"navigation"),e},table:{container:function(e,a){const n=t("<table>");return n.addClass(m+"-calendar"),n.attr(P,a),n.attr(q,"grid"),n},head:function(e){const a=t("<thead>");a.attr(q,"rowgroup");const n=t("<tr>");if(n.attr(q,"row"),a.append(n),e.displayWeeks===pe){const e=t("<th>");n.append(e),e.attr(q,"columnheader"),e.addClass(m+"-weekColumn");const a=t("<span>");a.attr(K,"true"),a.text(ge(Te)),e.append(a);const r=t("<span>");r.addClass(_),r.text(ge(Ce)),e.append(r)}for(let e=0;e<=6;e++){const a=t("<th>");n.append(a),a.attr(q,"columnheader");const r=t("<span>");r.attr(K,"true"),r.text(s.getAbbrevDayNames()[e]),a.append(r);const l=t("<span>");l.addClass(_),l.text(s.getDayNames()[e]),a.append(l)}return a},body:function(e,a,n){const s=r.firstOfMonth(n),o=r.localeDayOfWeek(s),i=r.daysInMonth(s),u=qe.getNumberOfDays(o,i),p=e._pendingValue,f=new Date,_=t("<tbody>");let D=!0,h=!0,y=t("<tr>");_.attr(q,"rowgroup");for(let b=0;b<u;b++){const u=r.add(r.clone(s),b-o,r.UNIT.DAY),C=parseInt(r.format(u,"DD"),10),w=r.format(u,M);let E=!0,A={disabled:!1,class:null,tooltip:null};if((b%7==0||0===b)&&(y=t("<tr>"),y.attr(q,"row"),_.append(y),a.displayWeeks===pe)){const e=r.add(r.clone(u),1,r.UNIT.DAY),a=r.ISOWeek(e),n=t("<th>");y.append(n),n.attr(R,"-1"),n.attr(q,"rowheader"),n.addClass(m+"-weekColumn"),n.text(a),n.attr("abbr",ge(Ce)+" "+a),n.attr(H,ge(Ce)+" "+a)}const S=t("<td>");y.append(S);const I=t("<span>");if(I.text(C),I.attr(q,le),S.append(I),(a.showDaysOutsideMonth!==De||b>=o&&b<o+i)&&e[c]){let a=0;try{if("function"==typeof e[c]){const n=e[c](w);n&&"object"==typeof n?(t.extend(A,n),A.class&&S.addClass(A.class),A.tooltip&&S.attr(Q,A.tooltip)):a=1}else a=2;a>0&&D&&(1===a?l.trace("dayFormatter function must return as valid JSON object in format { disabled: false, class: null, tooltip: null }."):l.error("dFormatter must be a function (apex.items.P1_DATE_PICKER.dayFormatter = function () {...};) that returns as valid JSON object."),D=!1)}catch(e){h&&l.error("dayFormatter function returned with an error",e),h=!1}}p&&n&&r.isSame(qe.calcCurrentCalendarDate(e,a,p),p,r.UNIT.DAY)&&r.isSame(p,u,r.UNIT.DAY)&&r.isSame(n,u,r.UNIT.MONTH)&&!a.disabled&&!A.disabled&&(e.getValue()||e._pendingValue)?(S.attr(ae,"true"),S.attr(R,"0"),S.addClass(g)):S.attr(R,"-1"),r.isSame(f,u,r.UNIT.DAY)&&(a.showDaysOutsideMonth===oe||r.isSame(n,u,r.UNIT.MONTH))&&(S.attr("aria-current","date"),S.addClass("is-current")),qe.checkMinMax(a,u,r.UNIT.DAY)?(b<o||b>=o+i)&&a.showDaysOutsideMonth!==oe?(a.showDaysOutsideMonth===_e?(E=!1,S.addClass(v),I.removeAttr(q,le)):a.showDaysOutsideMonth===De&&(E=!1,S.addClass(v),S.text("")),S.attr(te,"true")):(S.attr("data-date",w),S.attr(q,"gridcell"),S.on("keydown",(function(t){"Tab"===t.key&&t.shiftKey&&(t.preventDefault(),d(e._calendar).find("."+m+"-nav--next").trigger("focus"))})),a.disabled||A.disabled||!E||S.on(x,(function(){const t=_.closest("."+m+"-calendars").find("td");t.attr(ae,"false"),t.removeClass(g),t.attr(R,"-1"),S.attr(ae,"true"),S.attr(R,"0"),S.addClass(g),a.displayAs===se&&(e._skipRender=!0),a.showTime||a.displayAs!==ie||qe.dialog.close(e),qe.setDateToValue(e,a,u,T)}))):(E=!1,S.addClass(v),S.attr(te,"true"),I.removeAttr(q,le)),A.disabled&&(S.addClass(v),S.attr(te,"true"),I.removeAttr(q,le))}return _}},footer:{container:function(){const e=t("<div>");return e.addClass(m+"-footer"),e},timePicker:function(e,a){const n=t("<div>");n.attr(H,ge(we)),n.addClass(m+"-timePicker"),n.attr(q,ne);const l=t("<span>");l.addClass(f+" icon-time"),l.attr(K,"true"),n.append(l),!a.disabled&&e._initialValueDate&&l.on(x,(function(t){t.stopPropagation(),e._currentCalendarDate=qe.calcCurrentCalendarDate(e,a,e._initialValueDate),qe.setDateToValue(e,a,r.clone(e._currentCalendarDate),C),qe.moveCalendarView(e,a,null,r.clone(e._currentCalendarDate))}));const o=e._elementIDSafe+"_hours",i=t("<div>");i.addClass(m+"-timeHours"),n.append(i),i.append(We.defaultElements.label(ge(Ee),o));const c=t("<select>");c.attr(k,o),e._elementLabelIDSafe&&c.attr(Z,e._elementLabelIDSafe),c.attr(F,e._calendarTableIDSafe),c.prop(L,a.disabled),i.append(c),a.disabled||c.on("keydown",(function(t){"Tab"===t.key&&t.shiftKey&&(t.preventDefault(),qe.elements.getFocusElement(e).trigger("focus"))}));const u=e._pendingValue||e._currentCalendarDate,p=u.getHours();if(e._ampm){let e=p%12;e=e||12;for(let a=1;a<=12;a++){const n=t("<option>");n.text(a),n.attr(W,a),e===a&&n.prop("selected",!0),c.append(n)}}else for(let e=0;e<24;e++){const a=t("<option>");a.text(("0"+e).slice(-2)),a.attr(W,e),p===e&&a.prop("selected",!0),c.append(a)}const _=e._elementIDSafe+"_minutes",D=t("<div>");D.addClass(m+"-timeMinutes"),n.append(D),D.append(We.defaultElements.label(ge(Me),_));const g=t("<select>");g.attr(k,_),e._elementLabelIDSafe&&g.attr(Z,e._elementLabelIDSafe),g.attr(F,e._calendarTableIDSafe),D.append(g);if(qe.getMinuteOptions(a.timeIncrementMinute).forEach((function(e){const a=t("<option>");a.text(("0"+e).slice(-2)),a.attr(W,e),e===u.getMinutes()&&a.prop("selected",!0),g.append(a)})),g.on(N,(function(){const t=parseInt(g.val(),10),n=(new Date).setMinutes(t);qe.setDateToValue(e,a,new Date(n),E),a.displayAs===se&&queueMicrotask((function(){d("#"+_).trigger("focus")}))})),g.prop(L,a.disabled),e._ampm){const r=e._elementIDSafe+"_ampm",l=t("<div>");l.addClass(m+"-timeAmPm"),n.append(l),l.append(We.defaultElements.label(ge(Ae),r));const i=t("<select>");i.attr(k,r),e._elementLabelIDSafe&&i.attr(Z,e._elementLabelIDSafe),i.attr(F,e._calendarTableIDSafe),i.prop(L,a.disabled),l.append(i);const u=t("<option>");u.text(s.getSettings().calendar.amFormat),u.attr(W,"AM"),i.append(u);const f=t("<option>");f.text(s.getSettings().calendar.pmFormat),f.attr(W,"PM"),i.append(f),p>=12?f.prop("selected",!0):u.prop("selected",!0),i.on(N,(function(){qe.setCalendarHours(e,a,c,i),a.displayAs===se&&queueMicrotask((function(){d("#"+r).trigger("focus")}))})),c.on(N,(function(){qe.setCalendarHours(e,a,c,i),a.displayAs===se&&queueMicrotask((function(){d("#"+o).trigger("focus")}))}))}else c.on(N,(function(){qe.setCalendarHours(e,a,c),a.displayAs===se&&queueMicrotask((function(){d("#"+o).trigger("focus")}))}));return n},actions:function(e,a){const n=t("<div>");n.addClass(b),n.attr(q,ne),n.attr(H,ge(Se));let l=r.UNIT.DAY;return a.showTime&&(l=r.UNIT.MINUTE),qe.checkMinMax(a,new Date,l)&&a.todayButton&&n.append(We.buttons.today(e,a)),a.required||a.displayAs!==se||n.append(We.buttons.clear(e,a)),a.showTime&&a.displayAs===ie&&n.append(We.buttons.close(e,a)),n}},monthYearSelection:{container:function(){const e=t("<div>");return e.attr("aria-live","polite"),e.addClass(m+"-monthPicker"),e},monthSelection:function(e,a){const n=e._elementIDSafe+"_month",l=t("<div>");l.addClass(m+"-month"),l.append(We.defaultElements.label(ge(Ie),n));const o=t("<select>");o.attr(k,n),e._elementLabelIDSafe&&o.attr(Z,e._elementLabelIDSafe),o.attr(F,e._calendarTableIDSafe),l.append(o),!a.disabled&&a.changeMonth||(o.prop(L,!0),o.addClass(v));const i=r.clone(e._currentCalendarDate);return s.getMonthNames().forEach((function(n,l){if(qe.setMonth(i,l),qe.checkMinMax(a,i,r.UNIT.MONTH)){const a=t("<option>");a.text(n),a.attr(W,l),e._currentCalendarDate&&l===e._currentCalendarDate.getMonth()&&a.prop("selected",!0),o.append(a)}})),a.disabled||(o.on(N,(function(){const t=parseInt(o.val(),10);e._currentCalendarDate=qe.calcCurrentCalendarDate(e,a,new Date(qe.setMonth(e._currentCalendarDate,t))),qe.moveCalendarView(e,a,"#"+n)})),a.changeYear||o.on("keydown",(function(t){"Tab"!==t.key||t.shiftKey||(d(e._calendar).find("."+m+"-nav--prev").trigger("focus"),t.preventDefault())}))),l},yearSelection:function(e,a){const n=e._elementIDSafe+"_year",l=t("<div>");l.addClass(m+"-year"),l.append(We.defaultElements.label(ge(Ne),n));const s=t("<select>");s.attr(k,n),e._elementLabelIDSafe&&s.attr(Z,e._elementLabelIDSafe),s.attr(F,e._calendarTableIDSafe),l.append(s),!a.disabled&&a.changeYear||(s.prop(L,!0),s.addClass(v));let o=e._currentCalendarDate.getFullYear(),i=r.clone(e._currentCalendarDate),c=3*a.yearSelectionRange,u=a.yearSelectionRange;a.minDate&&r.isBefore(a.minDate,i,r.UNIT.YEAR)&&(c=qe.getYearDifference(a.minDate,i)),a.maxDate&&r.isAfter(a.maxDate,i,r.UNIT.YEAR)&&(u=qe.getYearDifference(a.maxDate,i));for(let e=-c;e<=u;e++){const n=o+e;if(i.setFullYear(n),qe.checkMinMax(a,i,r.UNIT.YEAR)){const e=t("<option>");e.text(n),o===n&&e.prop("selected",!0),s.prepend(e)}}return a.disabled||(s.on(N,(function(){const t=parseInt(s.val(),10);e._currentCalendarDate=qe.calcCurrentCalendarDate(e,a,new Date(e._currentCalendarDate.setFullYear(t))),qe.moveCalendarView(e,a,"#"+n)})),s.on("keydown",(function(t){"Tab"!==t.key||t.shiftKey||(t.preventDefault(),d(e._calendar).find("."+m+"-nav--prev").trigger("focus"))}))),l}},buttons:{prevMonth:function(e,t){let a="-1";t.displayAs!==se||t.changeMonth||t.changeYear||(a=null);const n=We.defaultElements.button(e,t,ge(xe),m+"-nav "+m+"-nav--prev","icon-prev",a,e._calendarTableIDSafe);return t.disabled||(n.on("keydown",(function(a){a.key===e._backwardkey?(e._currentCalendarDate=qe.calcCurrentCalendarDate(e,t,r.subtract(r.clone(e._currentCalendarDate),t.previousNextDistanceSteps,r.UNIT.MONTH)),qe.moveCalendarView(e,t,"."+m+"-nav--prev")):"Tab"!==a.key||a.shiftKey?"Tab"!==a.key||!a.shiftKey||t.changeMonth||t.changeYear||t.displayAs!==ie||(d(e._calendar).find("."+b).children().last().trigger("focus"),a.preventDefault()):(a.preventDefault(),d(e._calendar).find("."+m+"-nav--next").trigger("focus"))})),n.on(x,(function(a){a.preventDefault(),a.stopPropagation(),e._currentCalendarDate=qe.calcCurrentCalendarDate(e,t,r.subtract(r.clone(e._currentCalendarDate),t.previousNextDistanceSteps,r.UNIT.MONTH)),qe.moveCalendarView(e,t,"."+m+"-nav--prev")}))),n},nextMonth:function(e,t){const a=We.defaultElements.button(e,t,ge(ke),m+"-nav "+m+"-nav--next","icon-next","-1",e._calendarTableIDSafe);return t.disabled||(a.on("keydown",(function(a){"Tab"!==a.key||a.shiftKey?"Tab"===a.key&&a.shiftKey?(a.preventDefault(),d(e._calendar).find("."+m+"-nav--prev").trigger("focus")):a.key===e._forwardKey&&(e._currentCalendarDate=qe.calcCurrentCalendarDate(e,t,r.add(r.clone(e._currentCalendarDate),t.previousNextDistanceSteps,r.UNIT.MONTH)),qe.moveCalendarView(e,t,"."+m+"-nav--next")):(a.preventDefault(),qe.elements.getFocusElement(e).trigger("focus"))})),a.on(x,(function(a){a.preventDefault(),a.stopPropagation(),e._currentCalendarDate=qe.calcCurrentCalendarDate(e,t,r.add(r.clone(e._currentCalendarDate),t.previousNextDistanceSteps,r.UNIT.MONTH)),qe.moveCalendarView(e,t,"."+m+"-nav--next")}))),a},close:function(e,t){const a=We.defaultElements.button(e,t,ge(Ve),m+"--close",null,null,e._inputIDSafe);return t.disabled||(a.on(x,(function(a){a.preventDefault(),a.stopPropagation(),qe.dialog.close(e),qe.commitValue(e,t)})),t.changeMonth||t.changeYear||a.on("keydown",(function(a){"Tab"!==a.key||a.shiftKey||(a.preventDefault(),d(e._calendar).find("."+m+"-nav--prev").trigger("focus")),"Tab"!==a.key||!a.shiftKey||t.showTime||t.todayButton||(a.preventDefault(),qe.elements.getFocusElement(e).trigger("focus"))}))),a},today:function(e,t){const a="--today",n=We.defaultElements.button(e,t,ge($e),m+a,null,t.disabled?"-1":null,e._inputIDSafe);return t.disabled||(n.on(x,(function(n){n.preventDefault(),n.stopPropagation(),e._currentCalendarDate=qe.calcCurrentCalendarDate(e,t,new Date),e._pendingValue=e._currentCalendarDate,qe.setDateToValue(e,t,r.clone(e._currentCalendarDate),C),t.showTime?qe.moveCalendarView(e,t,"."+m+a,r.clone(e._currentCalendarDate)):qe.dialog.close(e)})),n.on("keydown",(function(a){"Tab"!==a.key||a.shiftKey||t.changeMonth||t.changeYear||t.showTime&&t.displayAs!==se||(a.preventDefault(),d(e._calendar).find("."+m+"-nav--prev").trigger("focus")),"Tab"===a.key&&a.shiftKey&&!t.showTime&&(a.preventDefault(),qe.elements.getFocusElement(e).trigger("focus"))}))),n},clear:function(e,t){const a="--clear",n=We.defaultElements.button(e,t,ge(Oe),m+a,null,t.disabled?"-1":null,e._inputIDSafe);return t.disabled||(n.on(x,(function(n){n.preventDefault(),n.stopPropagation(),qe.setDateToValue(e,t,null,C),queueMicrotask((function(){d(e._calendar).find("."+m+a).trigger("focus")}))})),n.on("keydown",(function(a){"Tab"!==a.key||a.shiftKey||t.changeMonth||t.changeYear||t.todayButton||t.showTime||(a.preventDefault(),d(e._calendar).find("."+m+"-nav--prev").trigger("focus")),"Tab"!==a.key||!a.shiftKey||t.showTime||t.todayButton||(a.preventDefault(),qe.elements.getFocusElement(e).trigger("focus"))}))),n}}},je={name:{type:i.dataTypes.string,reactive:!0},type:{type:i.dataTypes.string,reactive:!0},value:{type:i.dataTypes.string,reactive:!0},tabindex:{type:i.dataTypes.number,reactive:!0},showTime:{type:i.dataTypes.boolean,defaultValue:!1,reactive:!0},todayButton:{type:i.dataTypes.boolean,defaultValue:!0,reactive:!0},changeMonth:{type:i.dataTypes.boolean,defaultValue:!0,reactive:!0},changeYear:{type:i.dataTypes.boolean,defaultValue:!0,reactive:!0},displayWeeks:{type:i.dataTypes.enum,defaultValue:re,enumValues:[pe,re],reactive:!0},format:{type:i.dataTypes.string,defaultValue:s.getDateFormat(),reactive:!0},displayAs:{type:i.dataTypes.enum,defaultValue:ie,enumValues:[se,ie,de],reactive:!0},showOn:{type:i.dataTypes.enum,defaultValue:ce,enumValues:[ce,ue,"image"]},showDaysOutsideMonth:{type:i.dataTypes.enum,enumValues:[_e,De,"selectable"],defaultValue:_e,reactive:!0},numberOfMonths:{type:i.dataTypes.number,defaultValue:1,range:{min:0,max:5},reactive:!0},timeIncrementMinute:{type:i.dataTypes.number,defaultValue:1,range:{min:1,max:60},reactive:!0},yearSelectionRange:{type:i.dataTypes.number,defaultValue:5,range:{min:1},reactive:!0},disabled:{type:i.dataTypes.boolean,defaultValue:!1,reactive:!0},required:{type:i.dataTypes.boolean,defaultValue:!1},previousNextDistance:{type:i.dataTypes.enum,defaultValue:fe,enumValues:[me,fe],reactive:!0},min:{type:i.dataTypes.string,reactive:!0},max:{type:i.dataTypes.string,reactive:!0},placeholder:{type:i.dataTypes.string,reactive:!0},autofocus:{type:i.dataTypes.boolean,reactive:!0},readonly:{type:i.dataTypes.boolean,reactive:!0,defaultValue:!1},autocomplete:{type:i.dataTypes.string,reactive:!0},size:{type:i.dataTypes.number,range:{min:1},reactive:!0},maxlength:{type:i.dataTypes.number,range:{min:1},reactive:!0},minlength:{type:i.dataTypes.number,range:{min:1},reactive:!0},ariaDescribedby:{type:i.dataTypes.string,reactive:!0},ariaLabelledby:{type:i.dataTypes.string,reactive:!0}};i._addHyphenCaseAttrNames(je);const ze=i._configObservedAttributes(je);class Qe extends e.ItemComponent{#e={};constructor(){super(),this._configPrivateState(this.#e)}_render(e){const n=this;if(n._skipRender)n._skipRender=!1;else{if(n._rendered||(n._elementID=n.getAttribute(k),n._elementIDSafe=a.escapeCSS(n._elementID),n._inputIDSafe=n._elementIDSafe+"_input",n._calendarTableIDSafe=n._elementIDSafe+"_calendar"),qe.updateMinMax(n.#e),n._elementLabelIDSafe=a.escapeCSS(n.element.attr(P)),n._elementLabelIDSafe&&(n._elementLabelSafe=t("#"+n._elementLabelIDSafe).text()),n.getAttribute("previous-next-distance")===me?n.#e.previousNextDistanceSteps=n.#e.numberOfMonths:n.#e.previousNextDistanceSteps=1,n._ampm=!1,n._ampm||(n.#e.format.toLowerCase().includes("pm")||n.#e.format.toLowerCase().includes("am"))&&(n._ampm=!0),n._rendered||(qe.createOrUpdateInput(n,n.#e),n._initialValueDate=n.getNativeValue()),qe.createUpdateOrDeletePopupButton(n,n.#e),n._currentCalendarDate||(n._currentCalendarDate=qe.calcCurrentCalendarDate(n,n.#e,n.getNativeValue()||new Date),n._pendingValue=qe.calcCurrentCalendarDate(n,n.#e,n.getNativeValue())),n._rendered||[j,P,z,$,G,V,U,B,Z,J,R,H].forEach((e=>{n._moveAttribute(e,n._wrappedElement$)})),e)for(const t of e)switch(t.attributeName){case W:n._wrappedElement$&&n._wrappedElement$.val(t.newValue),n._currentCalendarDate=qe.calcCurrentCalendarDate(n,n.#e,n.getNativeValue()||new Date),n._pendingValue=qe.calcCurrentCalendarDate(n,n.#e,n.getNativeValue());break;case j:case Z:case z:case P:case $:case G:case V:case U:case B:case J:case R:case H:n._moveAttribute(t.attributeName,n._wrappedElement$);break;case Y:case L:case X:n._wrappedElement$.prop(t.attributeName,n.#e[t.attributeName]);break;case"min":case"max":n._currentCalendarDate=qe.calcCurrentCalendarDate(n,n.#e,n.getNativeValue()||new Date),n._pendingValue=qe.calcCurrentCalendarDate(n,n.#e,n.getNativeValue());break;case"display-as":qe.createOrUpdateInput(n,n.#e),n._calendar&&(n._calendar.remove(),n._calendar=void 0),qe.dialog.destroy(n)}"rtl"===n.element.css("direction")?(n._backwardkey=Fe,n._forwardKey=Ke):(n._backwardkey=Ke,n._forwardKey=Fe),n._rendered&&!e||qe.render(n,n.#e),n._rendered=!0}}disconnectedCallback(){queueMicrotask((()=>{this.isConnected||qe.dialog.destroy(this)}))}getNativeValue(){const e=this.getValue();if(!e)return null;try{return r.parse(e,this.#e.format)}catch(e){return l.info("The date must match the format "+this.#e.format,e),null}}hasDisplayValue(){if([se,de].includes(this.#e.displayAs))return!0;if(this._wrappedElement$.val().length)return!0;{const e=this._wrappedElement$.attr($);return!(!e||!e.length)}}getValidity(){let e,t={valid:!0,valueMissing:!1,rangeOverflow:!1,rangeUnderflow:!1};if(this.#e.required&&this.isEmpty())return t.valid=!1,t.valueMissing=!0,t;if(this.isEmpty())return t;try{e=r.parse(this.getValue(),this.#e.format)}catch(e){return l.trace(e),t.valid=!1,t}return this.#e.minDate&&r.isBefore(e,this.#e.minDate,r.UNIT.SECOND)?(t.rangeUnderflow=!0,t.valid=!1,t):this.#e.maxDate&&r.isAfter(e,this.#e.maxDate,r.UNIT.SECOND)?(t.rangeOverflow=!0,t.valid=!1,t):t}_getValidationMessage(){let e="",t=this.getValidity();if(!t.valid)if(t.valueMissing)e=ge("APEX.PAGE_ITEM_IS_REQUIRED");else if(this.#e.minDate&&this.#e.maxDate&&(t.rangeOverflow||t.rangeUnderflow))e=n.formatMessageNoEscape(Le,r.format(this.#e.minDate,this.#e.format),r.format(this.#e.maxDate,this.#e.format));else if(t.rangeUnderflow)e=n.formatMessageNoEscape(He,r.format(this.#e.minDate,this.#e.format));else if(t.rangeOverflow)e=n.formatMessageNoEscape(Re,r.format(this.#e.maxDate,this.#e.format));else{const t=this.element.attr(O)?this.element.attr(O):r.format(new Date,this.#e.format);e=n.formatMessageNoEscape(Pe,t)}return e}displayValueFor(e){return r.isValid(e)?r.format(e,this.#e.format):e}getPopupSelector(){return this.#e.displayAs===se?null:"."+D}setFocusTo(){return this.#e.displayAs===se?qe.elements.getFocusElement(this):this._wrappedElement$}refresh(){qe.render(this,this.#e),qe.elements.getFocusElement(this).focus()}setValue(e,t,a){this._wrappedElement$&&this._wrappedElement$.val(e),a||this.element.trigger(N)}static get observedAttributes(){return i._configObservedAttributes(je,ze)}static get componentMetaData(){return je}}customElements.define("a-date-picker",Qe)}(apex.item,apex.jQuery,apex.util,apex.lang,apex.date,apex.debug,apex.locale,apex.message,apex.WebComponent);