/*!
 * Copyright (c) 2023, 2024, Oracle and/or its affiliates.
 */
(()=>{"use strict";const{jQuery:t,debug:e,region:i,util:a,widget:o,WebComponent:r,actions:s,lang:n}=apex,d=o.util,l={readOnly:!0,renderStencil:!1,showNavigator:!1,selectionMode:"none",linkDesignations:[{typeId:"ERROR",glyph:""},{typeId:"TIMEOUT",glyph:""}],style:{paperCls:"paper",toastForegroundContainerCls:"a-WorkflowToast"},routeHighlights:[{typeId:"TERMINATED",color:"var(--a-diagram-route-terminated)",allowHighlightedOutboundLinks:!1},{typeId:"FAULTED",color:"var(--a-diagram-route-faulted)",allowHighlightedOutboundLinks:!1},{typeId:"ACTIVE",color:" var(--a-diagram-route-active)",allowHighlightedOutboundLinks:!1},{typeId:"COMPLETED",color:"var(--a-diagram-route-completed)"},{typeId:"WAITING",color:"var(--a-diagram-route-waiting)",allowHighlightedOutboundLinks:!1},{typeId:"SUSPENDED",color:"var(--a-diagram-route-suspended)",allowHighlightedOutboundLinks:!1}]},g="zoom-in",h="zoom-out",c="zoom-reset",u="show-navigator";class p extends r{diagramElement;toolbarElement;targetElement;#t;#e;#i;#a;#o;#r;#s;#n;#d;#l;#g=!1;#h=!1;#c=!1;constructor(){super();const o=this.getAttribute("buttons");this.#l=this.getAttribute("ajax-identifier"),this.#s=this.getAttribute("region-id"),this.#n=t(`#${a.escapeCSS(this.#s)}`),this.#d=this.getAttribute("workflow-id-item"),this.#i=this.getAttribute("init-zoom"),this.#r=!this.hasAttribute("auto-load")||"false"!==this.getAttribute("auto-load").toLowerCase(),this.#a=JSON.parse(this.getAttribute("workflow-config")||"[]"),this.#n.length||e.error("Workfow Diagram region must use a template with ID attribute"),this.#e=o?o.split(":"):[],i.create(this.#s,{type:"WorkflowDiagram",refresh:this.refresh.bind(this)})}_render(){if(this.rendered)return;const e=document.createElement("div");this.targetElement=e,e.classList.add("a-WorkflowApp"),e.setAttribute("role","img"),e.setAttribute("aria-label",n.getMessage("APEX.WF_DIAGRAM.ARIA_LABEL")),e.setAttribute("aria-description",n.getMessage("APEX.WF_DIAGRAM.ARIA_DESC")),this.append(e);const i=DiagramBuilder.KeyboardAction;this.#t=new DiagramBuilder({...l,locale:{[DiagramBuilder.Locale.STR_ZOOM_LEVEL]:n.getMessage("APEX.WF.ZOOM_LEVEL")},keyboardNavigationMap:{up:i.PAPER_PAN_UP,down:i.PAPER_PAN_DOWN,left:i.PAPER_PAN_LEFT,right:i.PAPER_PAN_RIGHT,"ctrl+0":i.ZOOM_RESET,"ctrl+minus":i.ZOOM_OUT,"ctrl+plus":i.ZOOM_IN},el:e,initialZoom:parseFloat(this.#i)}),this.#u(),this.#p(),d.onVisibilityChange(t(this),(t=>{t&&this.#h&&(this.#h=!1,this.refresh())})),this.#r&&this.refresh()}_fetchData(){return new Promise(((t,e)=>{this.#c=!0,apex.server.plugin({regions:[{id:this.#s,ajaxIdentifier:this.#l}],pageItems:this.#d?[this.#d]:[]},{refreshObject:this,loadingIndicator:this,loadingIndicatorPosition:"centered",success:e=>{this.#c=!1,t(e.regions[0].result)},error:(t,i,a)=>{this.#c=!1,e(t,i,a)}})}))}refresh(){this.#t&&!this.#c&&(d.isVisible(t(this))?this._fetchData().then((t=>{const e=[],i=[],a=[],o={};t.forEach((t=>{if(e.findIndex((e=>e.id===t.activityId))<0&&e.push({id:t.activityId,text:t.activityName,typeId:t.activityType,diagram:t.activityDiagram}),"INCOMPLETE"!==t.state){const e=a.find((e=>e.cellId===t.activityId&&e.previousId===t.previousId)),{linkId:i}=t;e&&e.linkId!==i||a.push({cellId:t.activityId,previousId:t.previousId,highlightTypeId:t.state,linkId:i}),"COMPLETED"!==t.state&&(o[t.activityId]=t.state)}t.linkId&&i.findIndex((e=>e.id===t.linkId))<0&&i.push({id:t.linkId,name:t.linkName,source:t.activityId,target:t.linkTargetId,diagram:t.linkDiagram,type:t.linkType})})),Object.entries(o).forEach((([t,e])=>{a.filter((e=>e.cellId===t)).forEach((t=>t.highlightTypeId=e))})),this.#t.setElementsConfig(this.#m(e)),this.#t.load({cells:[...this.#I(e),...this.#f(i)],route:a})})):this.#h=!0)}get diagramBuilder(){return this.#t}#p(){const t=this.#t,e=this;this.#o=s.createContext("workflowDiagram",this),this.#o.add([{name:g,action:function(){t.zoom(.1)}},{name:h,action:function(){t.zoom(-.1)}},{name:c,action:function(){t.zoom(1,!0)}},{name:u,get:function(){return e.#g},set:function(i){i?t.showNavigator():t.hideNavigator(),e.#g=i}}])}#u(){let e={actionsContext:this.#o,simple:!0,data:[]},i=[];if(this.#e.includes("ZOOM_IN")&&i.push({type:"BUTTON",title:n.getMessage("APEX.WF.ZOOM_IN"),label:n.getMessage("APEX.WF.ZOOM_IN"),iconOnly:!0,icon:"icon-zoom-region",action:g}),this.#e.includes("ZOOM_OUT")&&i.push({type:"BUTTON",title:n.getMessage("APEX.WF.ZOOM_OUT"),label:n.getMessage("APEX.WF.ZOOM_OUT"),iconOnly:!0,icon:"icon-zoom-page",action:h}),this.#e.includes("ZOOM_RESET")&&i.push({type:"BUTTON",title:n.getMessage("APEX.WF.ZOOM_RESET"),label:n.getMessage("APEX.WF.ZOOM_RESET"),iconOnly:!0,icon:"icon-search",action:c}),i.length&&e.data.push({id:"zoomControls",align:"end",groupTogether:!0,controls:i}),this.#e.includes("NAVIGATOR")&&e.data.push({id:"navigatorControls",align:"end",controls:[{type:"BUTTON",title:n.getMessage("APEX.WF.NAVIGATOR"),label:n.getMessage("APEX.WF.NAVIGATOR"),iconOnly:!0,icon:"icon-navigator",action:u}]}),e.data.length){const i=document.createElement("div");this.toolbarElement=i,i.classList.add("a-Toolbar","a-Toolbar-pageColumn","a-Toolbar-pageColumn--gridLayout","a-Toolbar--simple"),this.prepend(i),t(i).toolbar(e)}}#f(t){return t.map((t=>{let e,i,a=JSON.parse(t.diagram),o=[];return a.source.args&&(e={args:a.source.args,name:a.source.name}),a.target.args&&(i={args:a.target.args,name:a.target.name}),"NORMAL"!==t.type&&o.push({text:t.name,position:a.label}),{id:t.id,source:{id:t.source,anchor:e},target:{id:t.target,anchor:i},vertices:a.vertices,z:a.z,designation:t.type,labels:o,...a.router&&{router:a.router}}}))}#I(t){return t.map((t=>(delete(t={...t,...JSON.parse(t.diagram),hasMenu:!1}).diagram,t)))}#m(t){let e=this.#a.filter((t=>"$PLUGIN$"===t.typeId))[0],i=this.#a.reduce(((t,e)=>(t.push(e.typeId),t)),[]);return[...t.filter((t=>!i.includes(t.typeId))).map((t=>({...e,typeId:t.typeId}))),...this.#a]}}t((function(){customElements.define("a-workflow-diagram",p)}))})();