/*!
 Splitter - a jQuery UI based widget for dynamically dividing the available space for two sub regions horizontally or vertically.
 Copyright (c) 2010, 2024, Oracle and/or its affiliates. All rights reserved.
 */
!function(t,e,i,s){"use strict";const o="a-Splitter",r="."+o,n="a-Splitter-barH",a="a-Splitter-barV",l="."+n+",."+a,h="a-Splitter-thumb",d="."+h,p="u-RTL",f="is-focused",c="is-active",b="is-collapsed",u="is-disabled",m="button",g="aria-label",z="aria-expanded",S="aria-controls",_="aria-disabled",v="aria-orientation",E="aria-valuenow",$="aria-valuemin",C="aria-valuemax",A="role",w="separator",x="button",P="ariaSplitterStatus",T="#"+P;var L="title";function O(t){return s.getMessage("APEX.SPLITTER."+t)}function y(t,...e){return s.formatMessage("APEX.SPLITTER."+t,...e)}t.widget("apex.splitter",{widgetEventPrefix:"splitter",options:{orientation:"horizontal",positionedFrom:"begin",minSize:60,position:100,noCollapse:!1,dragCollapse:!0,collapsed:!1,snap:!1,inc:10,realTime:!1,iframeFix:!1,restoreText:null,collapseText:null,title:null,change:null},lastPos:null,bar$:null,before$:null,after$:null,horiz:!0,fromEnd:!1,barSize:1,_emitSrAlert:function(e){const i="ariaSplitterAlert",s="#"+i,o=t(T),r=t(s);o.length>0&&o.remove(),r.length>0&&r.remove(),t("body").append("<div class='u-vh' id='"+i+"' role='alert'></div>"),t(s).html(e)},_emitSrMsg:function(e){const i=t(T);i.length>0?i.empty():t("body").append("<div class='u-vh' id='"+P+"' role='status'></div>"),window.setTimeout((function(){t(T).append(e)}),0)},_create:function(){var s,n,a,l,h,b,u=this,g=this.options,z=this.element,S=e.htmlBuilder(),_=t.ui.keyCode,v=!!g.snap&&[1*g.snap,1*g.snap],E=g.noCollapse?0:1,$=null;if(2!==z.children().length)throw new Error("Splitter must have exactly two children.");if("horizontal"!==g.orientation&&"vertical"!==g.orientation)throw new Error("Orientation bad value");if("begin"!==g.positionedFrom&&"end"!==g.positionedFrom)throw new Error("PositionedFrom bad value");if(g.minSize<E&&(g.minSize=E,i.warn("Option minSize adjusted")),this.horiz="horizontal"===g.orientation,this.fromEnd="end"===g.positionedFrom,b=this.horiz?"left":"top",this.before$=z.children().eq(0),this.after$=z.children().eq(1),z.addClass(o+" resize"),"rtl"===z.css("direction")&&(z.addClass(p),this.horiz&&(this.before$=z.children().eq(1),this.after$=z.children().eq(0),this.fromEnd=!this.fromEnd)),z.parent(r).length>0||this.before$.is(r)||this.after$.is(r))throw new Error("Child of splitter cannot be a splitter");this.before$[0].id||(this.before$[0].id=(z[0].id||"splitter")+"_first"),this.after$[0].id||(this.after$[0].id=(z[0].id||"splitter")+"_second"),g.position<g.minSize&&(g.position=g.minSize),this.lastPos=g.position,g.snap&&(g.inc=g.snap),this._renderBar(S),this.bar$=t(S.toString()).insertAfter(z.children().eq(0)),this.horiz?this.barSize=this.bar$.width():this.barSize=this.bar$.height(),z.css({position:"relative"}).children().css({position:"absolute"}),this.horiz?(s=this.bar$.position()[b],n=0,a="e-resize",this.fromEnd?(l=_.LEFT,h=_.RIGHT):(l=_.RIGHT,h=_.LEFT)):(s=0,n=this.bar$.position()[b],a="s-resize",this.fromEnd?(l=_.UP,h=_.DOWN):(l=_.DOWN,h=_.UP)),this.bar$.css({left:s,top:n}).draggable({axis:u.horiz?"x":"y",containment:"parent",cancel:m,cursor:a,iframeFix:g.iframeFix,grid:v,scroll:!1,drag:function(t,e){var i;g.realTime&&(i=e.position[b],u.fromEnd&&(i=(u.horiz?z.width():z.height())-i-u.barSize),u._setPos(i,!1))},start:function(){u.bar$.addClass(c)},stop:function(t,e){var i=e.position[b];u.bar$.removeClass(c),u.fromEnd&&(i=(u.horiz?z.width():z.height())-i-u.barSize),u._setPos(i,!1)}}).on("click",(function(){t(this).find(d).trigger("focus")})),this.bar$.find(m).on("click",(function(t){let e=!1,i=!1;u.lastEnterDownAt&&Date.now()-u.lastEnterDownAt<200&&(i=!0),t.pointerType&&"mouse"===t.pointerType&&!u.thumbMouseEntered&&(e=!0),g.collapsed||i||!e?u._setPos(u._getPos(),!u._isCollapsed()):(t.preventDefault(),t.stopPropagation())})),apex.widget.util.TouchProxy.addTouchListeners(this.bar$[0]),this.bar$.find(d).on("focus",(function(){t(this).parent().addClass(f+" "+c)})).mouseenter((function(){u.thumbMouseEntered=!0})).mouseleave((function(){u.thumbMouseEntered=!1})).blur((function(){t(this).parent().removeClass(f+" "+c)})).keydown((function(t){var e,i,s=t.keyCode,o=null,r=!1;if("Enter"===t.key&&(u.lastEnterDownAt=Date.now()),u.horiz||s!==_.LEFT&&s!==_.RIGHT?!u.horiz||s!==_.UP&&s!==_.DOWN||u._emitSrAlert(O("VERTICAL_CANNOT_UP_DOWN")):u._emitSrAlert(O("HORIZ_CANNOT_LEFT_RIGHT")),s!==h||g.collapsed?s===l&&((o=u._getPos())<0?(g.noCollapse||(r=!0),o=0):o+=g.inc,e=u._getMaxPos(),o>e&&(o=e,u._emitSrAlert(y("MAX_SIZE_REACHED",Math.round(o))))):(o=u._getPos(),(o-=g.inc)<g.minSize&&g.noCollapse&&(o=g.minSize,u._emitSrAlert(y("MIN_SIZE_REACHED",o))),o<0&&(o=0)),null!==o)return i=o,u.fromEnd&&(i=(u.horiz?z.width():z.height())-i-u.barSize),u.bar$.css(b,i),$&&(clearTimeout($),$=null),$=setTimeout((function(){$=null,u._setPos(o,r)}),100),!1})),this._on(!0,this._eventHandlers),g.disabled&&this._setOption("disabled",g.disabled),this.refresh()},_eventHandlers:{resize:function(i){var s,o,r,n,a=this.options,l=this.element;if(i.target===l[0]){if(s=l.height(),o=l.width(),0===s||0===o)throw new Error("Splitter needs to be in a component with size");n=l.offset(),this.horiz?(l.children().each((function(){e.setOuterHeight(t(this),s)})),this.fromEnd?(r=[n.left+a.minSize,n.top,n.left+o-this.barSize,n.top+s],a.dragCollapse&&!a.noCollapse||(r[2]-=a.minSize)):(r=[n.left,n.top,n.left+o-this.barSize-a.minSize,n.top+s],a.dragCollapse&&!a.noCollapse||(r[0]+=a.minSize+1))):(l.children().each((function(){e.setOuterWidth(t(this),o)})),this.fromEnd?(r=[n.left,n.top+a.minSize,n.left+o,n.top+s-this.barSize],a.dragCollapse&&!a.noCollapse||(r[3]-=a.minSize)):(r=[n.left,n.top,n.left+o,n.top+s-this.barSize-a.minSize],a.dragCollapse&&!a.noCollapse||(r[1]+=a.minSize+1))),this._setPos(a.position,a.collapsed),this.bar$.draggable("option","containment",r),l.children(".resize").filter(":visible").trigger("resize"),i.stopPropagation()}}},_destroy:function(){this.element.removeClass(o+" "+u+" "+p+" resize").children(l).remove(),this.element.children().css("position","")},refresh:function(){this.element.is(":visible")&&this.element.trigger("resize")},_setOption:function(e,s){const o=this.options;var r,n,a;if(!o.noCollapse||"collapsed"!==e&&"restoreText"!==e&&"collapseText"!==e){if("orientation"===e||"positionedFrom"===e||"noCollapse"===e)throw new Error("Readonly option: "+e);if("position"===e?this._setPos(1*s,this._isCollapsed()):"collapsed"===e?this._setPos(this._getPos(),!!s):"snap"===e?(s=!!s&&1*s,o.snap=s,r=!!s&&[s,s],this.bar$.draggable("option","grid",r),s&&(o.inc=s)):"inc"===e?(s*=1,o.snap&&(s=o.snap),o.inc=s):"disabled"===e?(o.disabled=s,a=this.bar$.find(d),o.noCollapse?s?a.removeAttr("tabindex"):a.attr("tabindex","0"):a[0].disabled=s,this.bar$.draggable("option","disabled",s),s?(this.element.addClass(u),this.bar$.addClass(u),a.attr(_,!0)):(a.removeAttr(_),this.bar$.removeClass(u),this.element.removeClass(u))):"minSize"===e?(s<(n=o.noCollapse?0:1)&&(s=n,i.warn("Option minSize adjusted")),o.minSize=s):t.Widget.prototype._setOption.apply(this,arguments),"title"===e){let t=this.bar$.find(d);this.bar$.attr(L,s),t.attr(g,this._thumbAriaLabel(o.collapsed))}else if("restoreText"===e&&o.collapsed&&!o.disabled){this.bar$.find(m).attr(g,this._thumbAriaLabel(o.collapsed))}else if("collapseText"!==e||o.collapsed||o.disabled)"iframeFix"===e?this.bar$.draggable("option","iframeFix",s):"dragCollapse"===e&&this.refresh();else{this.bar$.find(m).attr(g,this._thumbAriaLabel(o.collapsed))}}else i.warn("Setting "+e+" option on noCollapse splitter has no effect.")},_getAriaLabel:function(e){let i=e.attr(g);if(i)return i;let s=e.attr("aria-labelledby");return s?(i=t("#"+s).attr(g),i||""):""},_thumbAriaLabel:function(e){const i=this.options,s=this.fromEnd?this.after$[0].id:this.before$[0].id,o=t("#"+s);let r="";return r||(r=this._getAriaLabel(o)),r||(r=this._getAriaLabel(o.find(".resize[role='region']").first())),r||(r=i.title,r||(r=e?i.restoreText:i.collapseText),r)},_barAriaLabel:function(e,i){const s=this.options,o=this.fromEnd?this.after$[0].id:this.before$[0].id,r=t("#"+o);let n;return e===w?"":(i||(n=s.title),n||i&&(n=this._getAriaLabel(r)),n||i&&(n=this._getAriaLabel(r.find(".resize[role='region']").first())),n||(n=i?s.restoreText:s.collapseText),n)},_renderBar:function(t){const e=this.options;let i=this.horiz?n:a;this.fromEnd&&(i+=" a-Splitter--end"),e.noCollapse&&(e.collapsed=!1),e.collapsed&&(i+=" "+b),t.markup("<div").attr("class",i).optionalAttr(L,e.title).markup("><div></div>");const s=e.noCollapse?"span":"button",o="button"===s?" type='button'":" tabindex='0'",r=e.noCollapse?w:e.collapsed?x:w,l=r===x?"false":"",d=r===w?this.horiz?"vertical":"horizontal":"";t.markup("<"+s+o).attr("class",h).attr(A,r).optionalAttr(g,this._thumbAriaLabel(e.collapsed)).optionalAttr(S,e.collapsed?null:"begin"===e.positionedFrom?this.before$[0].id:this.after$[0].id).optionalAttr(z,l).optionalAttr(v,d).markup("></"+s+">"),t.markup("</div>")},_getPos:function(){var t=this.element,e=this.horiz?"left":"top",i=this.bar$.position()[e];return this.fromEnd&&(i=(this.horiz?t.width():t.height())-i-this.barSize),i},_isCollapsed:function(){return this.bar$.hasClass(b)},_getMaxPos:function(){var t=this.options,e=this.element;return this.horiz?e.width()-this.barSize-t.minSize:e.height()-this.barSize-t.minSize},_setPos:function(t,i){const s=this,o=this.options,r=this.element,n=this.bar$,a=n.find(d),l=this.horiz?"left":"top",h=this._isCollapsed(),p=this.lastPos,f=this.horiz?r.width():r.height(),c=this._getMaxPos();let u,m,_;function P(t,e,i){const r=i?"false":"true";let l;if(l=f-s.barSize-2*o.minSize<0?"button":t,a.attr(A,l).attr(g,s._thumbAriaLabel(i)),l===w)a.attr(E,Math.round(e)).attr($,o.minSize).attr(C,Math.round(c)).attr(S,"begin"===o.positionedFrom?s.before$[0].id:s.after$[0].id).attr(v,s.horiz?"vertical":"horizontal").removeAttr(z),n.removeAttr(A).removeAttr(g),s.lastValueNow!==e&&(s._emitSrMsg(y("RESIZED_TO",Math.round(e))),s.lastValueNow=e);else{a.removeAttr(E).removeAttr($).removeAttr(C).removeAttr(v).attr(z,r);let t=s._barAriaLabel(x,i);t?n.attr(A,"region").attr(g,t):n.removeAttr(A).removeAttr(g)}i?a.removeAttr(S):a.attr(S,"begin"===o.positionedFrom?s.before$[0].id:s.after$[0].id)}if(o.noCollapse&&(i=!1),h&&!i&&(t=this.lastPos)<o.minSize&&(t=o.minSize),t<o.minSize?o.noCollapse?t=o.minSize:i=!0:t>c&&(t=c),o.noCollapse&&t<=0&&(t=0),t>0&&(this.lastPos=t),i&&(t=0,o.position=0),_=t,this.fromEnd&&(_=f-t-this.barSize),this.bar$.css(l,_),this.fromEnd?(u=this.after$,m=f-_-this.barSize):(u=this.before$,m=_),i?(this.bar$.addClass(b),u.hide(),P(x,m,!0)):(o.noCollapse?u.toggle(0!==t):(this.bar$.removeClass(b),u.show()),this.horiz?e.setOuterWidth(u,m):e.setOuterHeight(u,m),P(w,m,!1)),this.fromEnd?(u=this.before$,m=_):(u=this.after$,m=f-_-this.barSize),this.horiz?e.setOuterWidth(u,m):e.setOuterHeight(u,m),o.noCollapse&&u.toggle(0!==m),this.after$.css(l,_+this.barSize+"px"),this.before$.css(l,0),(!i&&t!==p||h!==i)&&(o.collapsed=i,o.position=t,r.children(".resize").filter(":visible").trigger("resize"),this._trigger("change",{},{position:o.position,collapsed:o.collapsed,lastPosition:this.lastPos})),i&&h!==i){let t=this._thumbAriaLabel(i);this._emitSrAlert(t?y("COLLAPSED_REGION",t):O("REGION_IS_COLLAPSED"))}if(!i&&h!==i){let t=this._thumbAriaLabel(i);this._emitSrAlert(t?y("RESTORED_REGION",t):O("REGION_IS_RESTORED"))}}});var R=0,F=0;t.apex.splitter.nextSplitter=function(e){var i,s,o,h=e?-1:1,p=t(document.activeElement);if(!(R>0||F>0))return(o=(s=t(r+" >."+n+","+r+" >."+a).filter(":visible").not(".ui-state-disabled").add(p)).index(p))>=0&&(o+=h,e&&p.parent().is(l)&&(o+=h),o>=0&&o<s.length&&(i=s.eq(o))),(i&&0===i.length&&!p.parent().is(l)||p.is("html,body"))&&(i=t(r+" >."+n+","+r+" >."+a).filter(":visible").not(".ui-state-disabled")[e?"last":"first"]()),i&&i.length>0?(i.children(d).trigger("focus"),!0):void 0},t((function(){t(document.body).on("menubeforeopen",(function(){F+=1})).on("menuafterclose",(function(){F-=1})).on("dialogopen",(function(){R+=1})).on("dialogclose",(function(){R-=1}))})),apex.message&&apex.message.addVisibilityCheck((function(e){var i=t("#"+e);i.parents(".a-Splitter").each((function(){i.is(":visible")||t(this).splitter("option","collapsed",!1)}))}))}(apex.jQuery,apex.util,apex.debug,apex.lang);