/*!
 * Copyright (c) 2023, 2024, Oracle and/or its affiliates.
 *
 * Forked from jQuery UI version 1.13.2 tabs.js on Nov. 20th 2023.
 *
 * jQuery UI Tabs 1.13.2
 * http://jqueryui.com
 *
 * Copyright jQuery Foundation and other contributors
 * Released under the MIT license.
 * http://jquery.org/license
 */
(()=>{"use strict";const t="aria-selected",e="aria-expanded",i="tabindex";var a;$.widget("ui.tabs",{version:"1.13.2",delay:300,options:{active:null,classes:{"ui-tabs":"ui-corner-all","ui-tabs-nav":"ui-corner-all","ui-tabs-panel":"ui-corner-bottom","ui-tabs-tab":"ui-corner-top"},collapsible:!1,event:"click",heightStyle:"content",hide:null,show:null,activate:null,beforeActivate:null,beforeLoad:null,load:null},_isLocal:(a=/#.*$/,function(t){var e,i;e=t.href.replace(a,""),i=location.href.replace(a,"");try{e=decodeURIComponent(e)}catch(t){}try{i=decodeURIComponent(i)}catch(t){}return t.hash.length>1&&e===i}),_create:function(){var t=this,i=this.options;this.running=!1,this._addClass("ui-tabs","ui-widget ui-widget-content"),this._toggleClass("ui-tabs-collapsible",null,i.collapsible),this._processTabs(),i.active=this._initialActive(),i.collapsible||this.tabs.removeAttr(e),Array.isArray(i.disabled)&&(i.disabled=$.uniqueSort(i.disabled.concat($.map(this.tabs.filter(".ui-state-disabled"),(function(e){return t.tabs.index(e)})))).sort()),!1!==this.options.active&&this.anchors.length?this.active=this._findActive(i.active):this.active=$(),this._refresh(),this.active.length&&this.load(i.active)},_initialActive:function(){var t=this.options.active,e=this.options.collapsible,i=location.hash.substring(1);return null===t&&(i&&this.tabs.each((function(e,a){if($(a).attr("aria-controls")===i)return t=e,!1})),null===t&&(t=this.tabs.index(this.tabs.filter(".ui-tabs-active"))),null!==t&&-1!==t||(t=!!this.tabs.length&&0)),!1!==t&&-1===(t=this.tabs.index(this.tabs.eq(t)))&&(t=!e&&0),!e&&!1===t&&this.anchors.length&&(t=0),t},_getCreateEventData:function(){return{tab:this.active,panel:this.active.length?this._getPanelForTab(this.active):$()}},_tabKeydown:function(e){const i=this,a=$($.ui.safeActiveElement(this.document[0])).closest("li");let s=this.tabs.index(a),n=!0;if(!this._handlePageNav(e)){switch(e.keyCode){case $.ui.keyCode.RIGHT:case $.ui.keyCode.DOWN:s+=1;break;case $.ui.keyCode.UP:case $.ui.keyCode.LEFT:n=!1,s-=1;break;case $.ui.keyCode.END:s=this.anchors.length-1;break;case $.ui.keyCode.HOME:s=0;break;case $.ui.keyCode.SPACE:return e.preventDefault(),clearTimeout(this.activating),void this._activate(s);case $.ui.keyCode.ENTER:return e.preventDefault(),clearTimeout(this.activating),void this._activate(s!==this.options.active&&s);default:return}e.preventDefault(),clearTimeout(this.activating),s=this._focusNextTab(s,n),e.ctrlKey||e.metaKey||(a.attr(t,"false"),this.setSelectedTimeout&&clearTimeout(this.setSelectedTimeout),this.setSelectedTimeout=setTimeout((function(){this.setSelectedTimeout=!1,i.tabs.eq(s).attr(t,"true")}),100),this.activating=this._delay((function(){this.option("active",s)}),this.delay))}},_panelKeydown:function(t){this._handlePageNav(t)||t.ctrlKey&&t.keyCode===$.ui.keyCode.UP&&(t.preventDefault(),this.active.trigger("focus"))},_handlePageNav:function(t){return t.altKey&&t.keyCode===$.ui.keyCode.PAGE_UP?(this._activate(this._focusNextTab(this.options.active-1,!1)),!0):t.altKey&&t.keyCode===$.ui.keyCode.PAGE_DOWN?(this._activate(this._focusNextTab(this.options.active+1,!0)),!0):void 0},_findNextTab:function(t,e){var i=this.tabs.length-1;for(;-1!==$.inArray((t>i&&(t=0),t<0&&(t=i),t),this.options.disabled);)t=e?t+1:t-1;return t},_focusNextTab:function(t,e){return t=this._findNextTab(t,e),this.tabs.eq(t).trigger("focus"),t},_setOption:function(t,i){"active"!==t?(this._super(t,i),"collapsible"===t&&(i||this.tabs.removeAttr(e),this._toggleClass("ui-tabs-collapsible",null,i),i||!1!==this.options.active||this._activate(0)),"event"===t&&this._setupEvents(i),"heightStyle"===t&&this._setupHeightStyle(i)):this._activate(i)},_sanitizeSelector:function(t){return t?t.replace(/[!"$%&'()*+,./:;<=>?@[\]^`{|}~]/g,"\\$&"):""},refresh:function(){var t=this.options,e=this.tablist.children(":has(a[href])");t.disabled=$.map(e.filter(".ui-state-disabled"),(function(t){return e.index(t)})),this._processTabs(),!1!==t.active&&this.anchors.length?this.active.length&&!$.contains(this.tablist[0],this.active[0])?this.tabs.length===t.disabled.length?(t.active=!1,this.active=$()):this._activate(this._findNextTab(Math.max(0,t.active-1),!1)):t.active=this.tabs.index(this.active):(t.active=!1,this.active=$()),this._refresh()},_refresh:function(){const a=this.options,s=a.collapsible;this._setOptionDisabled(a.disabled),this._setupEvents(a.event),this._setupHeightStyle(a.heightStyle),s?this.tabs.not(this.active).attr(t,"false").attr(e,"false").attr(i,-1):this.tabs.not(this.active).attr(t,"false").removeAttr(e).attr(i,-1),this.panels.not(this._getPanelForTab(this.active)).hide().attr({"aria-hidden":"true"}),this.active.length?(s?this.active.attr(t,"true").attr(e,"true").attr(i,0):this.active.attr(t,"true").removeAttr(e).attr(i,0),this._addClass(this.active,"ui-tabs-active","ui-state-active"),this._getPanelForTab(this.active).show().attr({"aria-hidden":"false"})):this.tabs.eq(0).attr(i,0)},_processTabs:function(){var t=this,e=this.tabs,i=this.anchors,a=this.panels;this.tablist=this._getList().attr("role","tablist"),this._addClass(this.tablist,"ui-tabs-nav","ui-helper-reset ui-helper-clearfix ui-widget-header"),this.tablist.on("mousedown"+this.eventNamespace,"> li",(function(t){$(this).is(".ui-state-disabled")&&t.preventDefault()})).on("focus"+this.eventNamespace,".ui-tabs-anchor",(function(){$(this).closest("li").is(".ui-state-disabled")&&this.blur()})),this.tabs=this.tablist.find("> li:has(a[href])").attr({role:"tab",tabIndex:-1}),this._addClass(this.tabs,"ui-tabs-tab","ui-state-default"),this.anchors=this.tabs.map((function(){return $("a",this)[0]})).attr({tabIndex:-1}),this._addClass(this.anchors,"ui-tabs-anchor"),this.panels=$(),this.anchors.each((function(e,i){var a,s,n,h=$(i).uniqueId().attr("id"),r=$(i).closest("li"),o=r.attr("aria-controls");t._isLocal(i)?(n=(a=i.hash).substring(1),s=t.element.find(t._sanitizeSelector(a))):(a="#"+(n=r.attr("aria-controls")||$({}).uniqueId()[0].id),(s=t.element.find(a)).length||(s=t._createPanel(n)).insertAfter(t.panels[e-1]||t.tablist),s.attr("aria-live","polite")),s.length&&(t.panels=t.panels.add(s)),o&&r.data("ui-tabs-aria-controls",o),r.attr({"aria-controls":n,"aria-labelledby":h}),s.attr("aria-labelledby",h)})),this.panels.attr("role","tabpanel"),this._addClass(this.panels,"ui-tabs-panel","ui-widget-content"),e&&(this._off(e.not(this.tabs)),this._off(i.not(this.anchors)),this._off(a.not(this.panels)))},_getList:function(){return this.tablist||this.element.find("ol, ul").eq(0)},_createPanel:function(t){return $("<div>").attr("id",t).data("ui-tabs-destroy",!0)},_setOptionDisabled:function(t){var e,i,a;for(Array.isArray(t)&&(t.length?t.length===this.anchors.length&&(t=!0):t=!1),a=0;i=this.tabs[a];a++)e=$(i),!0===t||-1!==$.inArray(a,t)?(e.attr("aria-disabled","true"),this._addClass(e,null,"ui-state-disabled")):(e.removeAttr("aria-disabled"),this._removeClass(e,null,"ui-state-disabled"));this.options.disabled=t,this._toggleClass(this.widget(),this.widgetFullName+"-disabled",null,!0===t)},_setupEvents:function(t){var e={};t&&$.each(t.split(" "),(function(t,i){e[i]="_eventHandler"})),this._off(this.anchors.add(this.tabs).add(this.panels)),this._on(!0,this.anchors,{click:function(t){t.preventDefault()}}),this._on(this.anchors,e),this._on(this.tabs,{keydown:"_tabKeydown"}),this._on(this.panels,{keydown:"_panelKeydown"}),this._focusable(this.tabs),this._hoverable(this.tabs)},_setupHeightStyle:function(t){var e,i=this.element.parent();"fill"===t?(e=i.height(),e-=this.element.outerHeight()-this.element.height(),this.element.siblings(":visible").each((function(){var t=$(this),i=t.css("position");"absolute"!==i&&"fixed"!==i&&(e-=t.outerHeight(!0))})),this.element.children().not(this.panels).each((function(){e-=$(this).outerHeight(!0)})),this.panels.each((function(){$(this).height(Math.max(0,e-$(this).innerHeight()+$(this).height()))})).css("overflow","auto")):"auto"===t&&(e=0,this.panels.each((function(){e=Math.max(e,$(this).height("").height())})).height(e))},_eventHandler:function(t){var e=this.options,i=this.active,a=$(t.currentTarget).closest("li"),s=a[0]===i[0],n=s&&e.collapsible,h=n?$():this._getPanelForTab(a),r=i.length?this._getPanelForTab(i):$(),o={oldTab:i,oldPanel:r,newTab:n?$():a,newPanel:h};t.preventDefault(),a.hasClass("ui-state-disabled")||a.hasClass("ui-tabs-loading")||this.running||s&&!e.collapsible||!1===this._trigger("beforeActivate",t,o)||(e.active=!n&&this.tabs.index(a),this.active=s?$():a,this.xhr&&this.xhr.abort(),r.length||h.length||$.error("jQuery UI Tabs: Mismatching fragment identifier."),h.length&&this.load(this.tabs.index(a),t),this._toggle(t,o))},_toggle:function(a,s){const n=this,h=this.options,r=h.collapsible,o=s.newPanel,l=s.oldPanel;function c(){n.running=!1,n._trigger("activate",a,s)}function u(){n._addClass(s.newTab.closest("li"),"ui-tabs-active","ui-state-active"),o.length&&n.options.show?n._show(o,n.options.show,c):(o.show(),c())}this.running=!0,l.length&&h.hide?this._hide(l,h.hide,(function(){n._removeClass(s.oldTab.closest("li"),"ui-tabs-active","ui-state-active"),u()})):(this._removeClass(s.oldTab.closest("li"),"ui-tabs-active","ui-state-active"),l.hide(),u()),l.attr("aria-hidden","true"),r?s.oldTab.attr(t,"false").attr(e,"false"):s.oldTab.attr(t,"false"),o.length&&l.length?s.oldTab.attr(i,-1):o.length&&this.tabs.filter((function(){return 0===$(this).attr(i)})).attr(i,-1),o.attr("aria-hidden","false"),r?s.newTab.attr(t,"true").attr(e,"true").attr(i,0):s.newTab.attr(t,"true").attr(i,0)},_activate:function(t){var e,i=this._findActive(t);i[0]!==this.active[0]&&(i.length||(i=this.active),e=i.find(".ui-tabs-anchor")[0],this._eventHandler({target:e,currentTarget:e,preventDefault:$.noop}))},_findActive:function(t){return!1===t?$():this.tabs.eq(t)},_getIndex:function(t){return"string"==typeof t&&(t=this.anchors.index(this.anchors.filter("[href$='"+$.escapeSelector(t)+"']"))),t},_destroy:function(){this.xhr&&this.xhr.abort(),this.tablist.removeAttr("role").off(this.eventNamespace),this.anchors.removeAttr("role tabIndex").removeUniqueId(),this.tabs.add(this.panels).each((function(){$.data(this,"ui-tabs-destroy")?$(this).remove():$(this).removeAttr("role "+i+" aria-live aria-busy "+t+" aria-labelledby aria-hidden "+e)})),this.tabs.each((function(){var t=$(this),e=t.data("ui-tabs-aria-controls");e?t.attr("aria-controls",e).removeData("ui-tabs-aria-controls"):t.removeAttr("aria-controls")})),this.panels.show(),"content"!==this.options.heightStyle&&this.panels.css("height","")},enable:function(t){var e=this.options.disabled;!1!==e&&(void 0===t?e=!1:(t=this._getIndex(t),e=Array.isArray(e)?$.map(e,(function(e){return e!==t?e:null})):$.map(this.tabs,(function(e,i){return i!==t?i:null}))),this._setOptionDisabled(e))},disable:function(t){var e=this.options.disabled;if(!0!==e){if(void 0===t)e=!0;else{if(t=this._getIndex(t),-1!==$.inArray(t,e))return;e=Array.isArray(e)?$.merge([t],e).sort():[t]}this._setOptionDisabled(e)}},load:function(t,e){t=this._getIndex(t);var i=this,a=this.tabs.eq(t),s=a.find(".ui-tabs-anchor"),n=this._getPanelForTab(a),h={tab:a,panel:n},r=function(t,e){"abort"===e&&i.panels.stop(!1,!0),i._removeClass(a,"ui-tabs-loading"),n.removeAttr("aria-busy"),t===i.xhr&&delete i.xhr};this._isLocal(s[0])||(this.xhr=$.ajax(this._ajaxSettings(s,e,h)),this.xhr&&"canceled"!==this.xhr.statusText&&(this._addClass(a,"ui-tabs-loading"),n.attr("aria-busy","true"),this.xhr.done((function(t,a,s){setTimeout((function(){n.html(t),i._trigger("load",e,h),r(s,a)}),1)})).fail((function(t,e){setTimeout((function(){r(t,e)}),1)}))))},_ajaxSettings:function(t,e,i){var a=this;return{url:t.attr("href").replace(/#.*$/,""),beforeSend:function(t,s){return a._trigger("beforeLoad",e,$.extend({jqXHR:t,ajaxSettings:s},i))}}},_getPanelForTab:function(t){var e=$(t).attr("aria-controls");return this.element.find(this._sanitizeSelector("#"+e))}}),!1!==$.uiBackCompat&&$.widget("ui.tabs",$.ui.tabs,{_processTabs:function(){this._superApply(arguments),this._addClass(this.tabs,"ui-tab")}})})();