/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojlocaledata","ojs/ojconverterutils-i18n","ojs/ojconfig","ojs/ojconverter-nativedatetime"],function(a,i,e,r,o){"use strict";const n=e.OraI18nUtils,t="UTC";let s={hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"long"};const c=["Africa/Abidjan","Africa/Addis_Ababa","Africa/Algiers","Africa/Bangui","Africa/Blantyre","Africa/Cairo","Africa/Casablanca","Africa/Ceuta","Africa/Johannesburg","Africa/Khartoum","Africa/Tripoli","Africa/Tunis","America/Adak","America/Anchorage","America/Anguilla","America/Argentina/Buenos_Aires","America/Atikokan","America/Belem","America/Belize","America/Boa_Vista","America/Bogota","America/Caracas","America/Chicago","America/Chihuahua","America/Creston","America/Detroit","America/Ensenada","America/Fort_Wayne","America/Glace_Bay","America/Godthab","America/Guatemala","America/Guyana","America/Havana","America/Los_Angeles","America/Managua","America/Merida","America/Miquelon","America/Montevideo","America/Noronha","America/Santiago","America/Sao_Paulo","America/Scoresbysund","America/St_Johns","America/Winnipeg","Antarctica/DumontDUrville","Antarctica/McMurdo","Antarctica/Syowa","Antarctica/Vostok","Asia/Almaty","Asia/Amman","Asia/Anadyr","Asia/Aqtau","Asia/Aqtobe","Asia/Ashgabat","Asia/Baghdad","Asia/Baku","Asia/Bangkok","Asia/Beirut","Asia/Brunei","Asia/Calcutta","Asia/Chongqing","Asia/Colombo","Asia/Dacca","Asia/Damascus","Asia/Dubai","Asia/Gaza","Asia/Hong_Kong","Asia/Irkutsk","Asia/Istanbul","Asia/Jakarta","Asia/Jerusalem","Asia/Kabul","Asia/Karachi","Asia/Kathmandu","Asia/Krasnoyarsk","Asia/Magadan","Asia/Manila","Asia/Nicosia","Asia/Novosibirsk","Asia/Omsk","Asia/Rangoon","Asia/Seoul","Asia/Tehran","Asia/Tokyo","Asia/Vladivostok","Asia/Yakutsk","Asia/Yekaterinburg","Atlantic/Canary","Atlantic/Cape_Verde","Atlantic/South_Georgia","Atlantic/Stanley","Australia/ACT","Australia/Adelaide","Australia/Brisbane","Australia/Currie","Australia/Darwin","Australia/LHI","Australia/Perth","Chile/EasterIsland","Eire","Europe/Belfast","Europe/Kaliningrad","Europe/Moscow","Europe/Riga","Europe/Samara","Europe/Tallinn","Europe/Vilnius","HST","Pacific/Fiji","Pacific/Guam","Pacific/Marquesas","Pacific/Midway","Pacific/Norfolk","Pacific/Tongatapu","Africa/Djibouti","Africa/Harare","Africa/Lagos","Africa/Maputo","Africa/Mogadishu","Africa/Nairobi","Africa/Nouakchott","America/Buenos_Aires","America/Costa_Rica","America/Denver","America/Edmonton","America/El_Salvador","America/Guayaquil","America/Halifax","America/Indiana/Indianapolis","America/Indianapolis","America/Lima","America/Manaus","America/Mazatlan","America/Mexico_City","America/Montreal","America/New_York","America/Panama","America/Phoenix","America/Puerto_Rico","America/Regina","America/Tijuana","America/Toronto","America/Vancouver","Asia/Aden","Asia/Bahrain","Asia/Dhaka","Asia/Kamchatka","Asia/Katmandu","Asia/Kolkata","Asia/Kuala_Lumpur","Asia/Kuwait","Asia/Muscat","Asia/Qatar","Asia/Riyadh","Asia/Saigon","Asia/Shanghai","Asia/Singapore","Asia/Taipei","Asia/Tashkent","Atlantic/Azores","Atlantic/Bermuda","Atlantic/Reykjavik","Australia/Hobart","Australia/Lord_Howe","Australia/Sydney","Europe/Amsterdam","Europe/Athens","Europe/Belgrade","Europe/Belgrade","Europe/Berlin","Europe/Brussels","Europe/Bucharest","Europe/Budapest","Europe/Copenhagen","Europe/Dublin","Europe/Helsinki","Europe/Istanbul","Europe/Kiev","Europe/Lisbon","Europe/London","Europe/Luxembourg","Europe/Madrid","Europe/Oslo","Europe/Paris","Europe/Prague","Europe/Rome","Europe/Sofia","Europe/Stockholm","Europe/Tirane","Europe/Vienna","Europe/Warsaw","Europe/Zurich","Indian/Chagos","Indian/Cocos","Pacific/Auckland","Pacific/Easter","Pacific/Gambier","Pacific/Honolulu","Pacific/Kwajalein","Pacific/Noumea","Pacific/Pago_Pago","Pacific/Pitcairn","US/Aleutian","US/Hawaii","UTC"];function A(a,i,e,r){const o=i.split("/"),c=o[0],A=o[1];let l,u;const m=a.split("-")[0];const d=new Date,p={offsetLocName:null,locName:null},g=r[c];if("en"===m?void 0!==o[1]&&(l=" "+o[1],l=l.replace(/_/g," "),l=l.replace("Saigon","Ho Chi Minh City")):void 0!==g&&(l=g[A],void 0!==l&&(l=l.exemplarCity,void 0!==l&&(l=" "+l))),void 0===l)return null;s.timeZone=i,u=new Intl.DateTimeFormat(a,s).formatToParts(d).find(a=>"timeZoneName"===a.type).value;let f=`(${t})`;return 0!==e&&(f=n.getTimeStringFromOffset(t,e,!0,!0),f=`(${f})`),u=" - "+u,p.offsetLocName=f+l+u,p.locName=l+u,p}function l(a,e){const t=i.__getBundle(),s=(n.getLocaleElementsMainNode(t),n.getLocaleElementsMainNodeKey(t)),l=function(a){function i(i){let e=null;const r=a.main[i];return r&&(e=r.dates),e}let e=r.getLocale(),o=i(e);if(o)return o;let n=e.split("-");for(n.pop();n.length>0;){if(e=n.join("-"),o=i(e),o)return o;n.pop()}return a.main["en-US"].dates}(t),u=l.timeZoneNames.zone,m=new Date,d={year:m.getFullYear(),month:m.getMonth()+1,date:m.getDate(),hours:m.getHours(),minutes:m.getMinutes()};for(let i=0;i<c.length;i++){let r=c[i];const n=-o.getISODateOffset(d,r),t=A(s,r,n,u);null!==t&&("Asia/Saigon"===r&&(r="Asia/Ho_Chi_Minh"),a.push({id:r,displayName:t})),e[r]=n}}class u{static getAvailableTimeZonesImpl(){const a=i.__getBundle(),e=n.getLocaleElementsMainNodeKey(a),r=u?._timeZoneDataCache[e]?.availableTimeZones;return r||u._availableTimeZonesImpl(a)}static _availableTimeZonesImpl(a){const i={sensitivity:"variant"},e=[];let r={};const o=n.getLocaleElementsMainNodeKey(a),t=n.getLocaleElementsMainNodeKey(a);l(e,r),e.sort(function(a,e){return r[e.id]-r[a.id]+a.displayName.locName.localeCompare(e.displayName.locName,t,i)});const s=e.length;for(let a=0;a<s;a++)e[a].displayName=e[a].displayName.offsetLocName;return u._timeZoneDataCache[o]={availableTimeZones:e},e}}u._timeZoneDataCache={},a.AvailableTimeZones=u,Object.defineProperty(a,"__esModule",{value:!0})});
//# sourceMappingURL=ojavailabletimezones.js.map