/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojoption","ojs/ojcore-base","jquery","ojs/ojdomutils","ojs/ojthemeutils","ojs/ojcomponentcore","ojs/ojchildmutationobserver","ojs/ojlabelledbyutils","ojs/ojcustomelement-utils","ojs/ojbutton2"],function(e,t,n,o,s,i,l,a,r,u){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l,a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a;var c={properties:{chroming:{type:"string",enumValues:["borderless","full","half","outlined","solid"]},disabled:{type:"boolean",value:!1},display:{type:"string",enumValues:["all","icons","label"],value:"all"},label:{type:"string"},translations:{type:"object",value:{}}},methods:{getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},events:{ojAction:{}},extension:{}};c.extension._WIDGET_NAME="ojButton",c.extension._TRACK_CHILDREN="nearestCustomElement",c.extension._GLOBAL_TRANSFER_ATTRS=["href","aria-label","aria-labelledby","aria-describedby"],t.CustomElementBridge.register("oj-menu-button",{metadata:c,innerDomFunction:function(e){return e.getAttribute("href")?"a":"button"}});var h={properties:{chroming:{type:"string",enumValues:["borderless","full","half","outlined","solid"]},describedBy:{type:"string"},disabled:{type:"boolean",value:!1},display:{type:"string",enumValues:["all","icons","label"],value:"all"},focusManagement:{type:"string",enumValues:["none","oneTabstop"],value:"oneTabstop"},labelledBy:{type:"string"},translations:{type:"object",value:{}},value:{type:"any",writeback:!0}},methods:{getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}};h.extension._WIDGET_NAME="ojButtonset",h.extension._ALIASED_PROPS={value:"checked"},t.CustomElementBridge.register("oj-buttonset-one",{metadata:h});var d={properties:{chroming:{type:"string",enumValues:["borderless","full","half","outlined","solid"]},describedBy:{type:"string"},disabled:{type:"boolean",value:!1},display:{type:"string",enumValues:["all","icons","label"],value:"all"},focusManagement:{type:"string",enumValues:["none","oneTabstop"],value:"oneTabstop"},labelledBy:{type:"string"},translations:{type:"object",value:{}},value:{type:"Array<any>",writeback:!0}},methods:{getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}};if(d.extension._WIDGET_NAME="ojButtonset",d.extension._ALIASED_PROPS={value:"checked"},t.CustomElementBridge.register("oj-buttonset-many",{metadata:d}),t.ButtonLegacy){var m={properties:{chroming:{type:"string",enumValues:["borderless","callToAction","danger","full","half","outlined","solid"]},disabled:{type:"boolean",value:!1},display:{type:"string",enumValues:["all","icons","label"],value:"all"},translations:{type:"object",value:{}}},methods:{refresh:{},setProperty:{},getProperty:{},setProperties:{},getNodeBySubId:{},getSubIdByNode:{}},events:{ojAction:{}},extension:{}};m.extension._WIDGET_NAME="ojButton",m.extension._TRACK_CHILDREN="nearestCustomElement",m.extension._GLOBAL_TRANSFER_ATTRS=["href","aria-label","aria-labelledby","aria-describedby"],t.CustomElementBridge.register("oj-button",{metadata:m,innerDomFunction:function(e){return e.getAttribute("href")?"a":"button"}})}!function(){var e,u,c="oj-button oj-component oj-enabled oj-default",h="oj-button-icons-only oj-button-icon-only oj-button-text-icons oj-button-text-icon-start oj-button-text-icon-end oj-button-text-only",d="oj-button-full-chrome oj-button-half-chrome oj-button-outlined-chrome oj-button-cta-chrome oj-button-danger-chrome",m={solid:"oj-button-full-chrome",outlined:"oj-button-outlined-chrome",borderless:"oj-button-half-chrome",full:"oj-button-full-chrome",half:"oj-button-half-chrome",callToAction:"oj-button-cta-chrome",danger:"oj-button-danger-chrome oj-button-full-chrome"},b={button:["ojButtonset","ojToolbar"],buttonset:["ojToolbar"]};function p(e,t){y(e,d),e.classList.add(m[t])}function f(e,t){var o,s=e.name,i=e.form;if(s){var l=":radio[name='"+(s=s.replace(/'/g,"\\'"))+"']:oj-button";o=t?t.filter(l):i?n(i).find(l):n(l,e.ownerDocument).filter(function(){return!this.form})}else o=(t?t.filter(e):n(e)).filter(":oj-button");return o}function _(e,t,n){var o=function(e,t,n){for(var o=0;o<n.length;++o){var s=n[o];if(t.indexOf(s)>=0)for(;;e=e.parentNode){var l=i.__GetWidgetConstructor(e,s);if(l)return l}}return null}(t,n,b[e]);return o?o("option","chroming"):s.getCachedCSSVarValues(["--oj-private-"+e+"-global-chroming-default"])[0]}function v(e,t){var n=e.className;if(n){for(var o=n.split(" "),s=t.split(" "),i=s.length;i>=0;i--)o.indexOf(s[i])>=0&&s.splice(i,1);s.length>0&&(e.className=n+" "+s.join(" "))}else e.className=t}function y(e,t){var n=e.className;if(n){for(var o=n.split(" "),s=t.split(" "),i=!1,l=0;l<s.length;l++){var a=o.indexOf(s[l]);a>=0&&(o.splice(a,1),i=!0)}i&&(e.className=o.join(" "))}}t.__registerWidget("oj.ojButton",n.oj.baseComponent,{defaultElement:"<button>",widgetEventPrefix:"oj",options:{chroming:"solid",disabled:!1,display:"all",label:null,icons:{start:null,end:null},menu:null,action:null},_InitOptions:function(e,t){this._super(e,t),this._IsCustomElement()&&this._processSlots(),this._initButtonTypes(),this._IsCustomElement()||"disabled"in t||this.option("disabled",!!this.element[0].disabled,{_context:{internalSet:!0}}),"label"in t||(this.keepDomLabel=!0,this.option("label","inputPush"===this.type?this.buttonElement.val():this.buttonElement[0].innerHTML,{_context:{internalSet:!0}})),this._IsCustomElement()||!this.options.menu||t.icons&&void 0!==t.icons.end||this.option("icons.end","oj-component-icon oj-button-menu-dropdown-icon",{_context:{writeback:!0,internalSet:!0}})},_ComponentCreate:function(){this._super(),this.menuEventNamespace=this.eventNamespace+"menu",this._initButtonTypes2(),this.hasTitle=!!this.rootElement.getAttribute("title");var t=this,s=this._isToggle;v(this.rootElement,c),p(this.rootElement,this.options.chroming);var i=function(){t.rootElement.classList.remove("oj-active"),t.rootElement.classList.remove("oj-hover"),t._toggleDefaultClasses()};if(this._touchStartHandler=function(){t._IsEffectivelyDisabled()||(t.rootElement.classList.add("oj-active"),t._toggleDefaultClasses(),t.document.one("touchend",i))},o.isTouchSupported()&&(this.buttonElement[0].addEventListener("touchstart",this._touchStartHandler,{passive:!0}),this.buttonElement.bind("touchend"+this.eventNamespace+" touchcancel"+this.eventNamespace,i)),this.buttonElement.bind("mouseenter"+this.eventNamespace,function(){t._IsEffectivelyDisabled()||t._isSelectedInButtonsetOne()||(t.rootElement.classList.add("oj-hover"),o.recentTouchEnd()||this===e&&t.rootElement.classList.add("oj-active"),t.rootElement.classList.remove("oj-default"),t.rootElement.classList.remove("oj-focus-only"))}).bind("mouseleave"+this.eventNamespace,function(){t.rootElement.classList.remove("oj-hover"),t._IsEffectivelyDisabled()||(t.rootElement.classList.remove("oj-active"),t._toggleDefaultClasses())}),this._disabledClickHandler=function(e){t._IsEffectivelyDisabled()&&(e.preventDefault(),e.stopImmediatePropagation())},this._ojActionClickHandler=function(e){t._trigger("action",e,{})},this._IsCustomElement()?(this.rootElement.addEventListener("click",this._disabledClickHandler,!0),this.rootElement.addEventListener("click",this._ojActionClickHandler,!1)):this.buttonElement[0].addEventListener("click",this._disabledClickHandler,!0),this._focusable({element:n(this.rootElement),applyHighlight:!0,afterToggle:function(){t._toggleDefaultClasses()}}),s&&(this.element.bind("change"+this.eventNamespace,function(e){t._applyCheckedStateFromDom(!0);var n=t._getEnclosingContainerComponent("buttonset"),o=n&&n._getCheckedFromDom(n.$buttons);n&&void 0!==o&&n.option("checked",o,{_context:{writeback:!0,originalEvent:e,internalSet:!0}})}),this.buttonElement.bind("mousedown"+this.eventNamespace,function(){t._IsEffectivelyDisabled()||(u=this,t._isSelectedInButtonsetOne()||t.rootElement.classList.add("oj-active"),t.document.one("mouseup",function(){u=null,t.rootElement.classList.remove("oj-active")}))}).bind("mouseup"+this.eventNamespace,function(){t._IsEffectivelyDisabled()||(t.rootElement.classList.remove("oj-active"),this===u&&t.element.focus())})),"checkbox"===this.type)this.buttonElement.bind("click"+this.eventNamespace,function(){if(t._IsEffectivelyDisabled())return!1}),this.element.bind("keyup"+this.eventNamespace,function(e){e.keyCode===n.ui.keyCode.ENTER&&(t._IsEffectivelyDisabled()||t.element.click())});else if("radio"===this.type)this.buttonElement.bind("click"+this.eventNamespace,function(){if(t._IsEffectivelyDisabled())return!1}),this.element.bind("keyup"+this.eventNamespace,function(e){e.keyCode===n.ui.keyCode.ENTER&&(t.element[0].checked||t._IsEffectivelyDisabled()||(t.element[0].checked=!0,t.element.change(),t.element.click()))});else if(this.buttonElement.bind("mousedown"+this.eventNamespace,function(n){if(t._IsEffectivelyDisabled())return!1;1!==n.which||o.recentTouchEnd()||(t._isSelectedInButtonsetOne()||t.rootElement.classList.add("oj-active"),t.rootElement.classList.remove("oj-default"),t.rootElement.classList.remove("oj-focus-only"),e=this,t.document.one("mouseup",function(){e=null}))}).bind("mouseup"+this.eventNamespace,function(){if(t._IsEffectivelyDisabled())return!1;t.rootElement.classList.remove("oj-active"),t._toggleDefaultClasses()}).bind("keydown"+this.eventNamespace,function(e){if(t._IsEffectivelyDisabled())return e.keyCode===n.ui.keyCode.TAB||e.keyCode===n.ui.keyCode.LEFT||e.keyCode===n.ui.keyCode.RIGHT;var o=e.keyCode===n.ui.keyCode.SPACE,s="anchor"===t.type;s&&o&&e.preventDefault(),(o&&!s||e.keyCode===n.ui.keyCode.ENTER)&&(t._isSelectedInButtonsetOne()||t.rootElement.classList.add("oj-active"),t.rootElement.classList.remove("oj-default"),t.rootElement.classList.remove("oj-focus-only"))}).bind("keyup"+this.eventNamespace+" blur"+this.eventNamespace,function(){t.rootElement.classList.remove("oj-active"),t._toggleDefaultClasses()}),"anchor"===this.type){var l=this.buttonElement[0].getAttribute("tabindex");(null===l||isNaN(l))&&this.buttonElement[0].setAttribute("tabindex","0")}this.options.disabled&&this._manageAnchorTabIndex(!1,!0),this._updateEffectivelyDisabled();var a=t._getEnclosingContainerComponent("buttonset");this._IsCustomElement()||a&&a._IsCustomElement()?this._setDisplayOptionOnDom():this._handleLabelAndIconsAtCreateTime(),this._setupMenuButton(null),this._toggleDefaultClasses(),this._childMutationObserver&&this._childMutationObserver.observe()},_NotifyContextMenuGesture:function(e,t,o){this._OpenContextMenu(t,o,{position:{of:"keyboard"===o?n(this.rootElement):t}})},_addMutationObserver:function(){if(!this._childMutationObserver&&this._IsCustomElement()){var e=this;this._childMutationObserver=new l(this.rootElement,function(t){t.forEach(function(t){var n;if("childList"===t.type){var o=t.addedNodes&&t.addedNodes[0],s=t.target;if(o&&3===o.nodeType&&s&&1===s.nodeType&&s.classList.contains("oj-button-label")){e._childMutationObserver.disconnect(),n=!0;var i=e.buttonElement[0].querySelector(".oj-button-text");i&&(i.textContent=o.textContent),o.parentNode.removeChild(o)}}else"characterData"===t.type&&(e._childMutationObserver.disconnect(),n=!0);n&&(e._setDisplayOptionOnDom(),e._childMutationObserver.observe())})})}},_removeMutationObserver:function(){this._childMutationObserver&&(this._childMutationObserver.disconnect(),this._childMutationObserver=null)},_processSlots:function(){var e,t=this,o=this.element[0],s=o.parentNode,i="OJ-MENU-BUTTON"===s.tagName,l=r.CustomElementUtils.getSlotMap(s);e=i?["startIcon","","endIcon","menu"]:["startIcon","","endIcon"],n.each(e,function(e,t){l[t]&&""!==t&&n.each(l[t],function(e,t){o.appendChild(t)})});for(var a=s.children,u=a.length-1;u>=0;u--){var c=a[u];c!==o&&"contextMenu"!==c.getAttribute("slot")&&s.removeChild(c)}var h=r.CustomElementUtils.getSlotMap(o);n.each(e,function(e,s){h[s]&&n.each(h[s],function(e,i){if(o.appendChild(i),""===s){var l=i,a=l;3===l.nodeType&&(a=document.createElement("span"),l.parentNode.insertBefore(a,l),a.appendChild(l)),a.classList.add("oj-button-text"),t._setTextSpanIdAndLabelledBy(a)}else if("startIcon"===s)i.classList.add("oj-button-icon"),i.classList.add("oj-start");else if("endIcon"===s)i.classList.add("oj-button-icon"),i.classList.add("oj-end");else if("menu"===s&&(n(i).uniqueId(),t.menuSlot="#"+i.id,void 0===h.endIcon)){var r=document.createElement("span"),u="oj-button-menu-dropdown-icon";void 0===h.startIcon&&"icons"===t.options.display&&(u="oj-button-menu-icon-only-dropdown-icon"),r.className="oj-button-icon oj-end oj-component-icon "+u,r.setAttribute("slot","endIcon"),o.insertBefore(r,i)}})});var d=document.createElement("div");for(d.className="oj-button-label";o.hasChildNodes();)d.appendChild(o.firstChild);o.appendChild(d)},_getMenuNode:function(){return this._IsCustomElement()?this.menuSlot:this.options.menu},_initButtonTypes:function(){var e=this.element[0];if("INPUT"===e.tagName&&"checkbox"===e.type)this.type="checkbox",this._isToggle=!0;else if("INPUT"===e.tagName&&"radio"===e.type)this.type="radio",this._isToggle=!0;else if("INPUT"!==e.tagName||"button"!==e.type&&"submit"!==e.type&&"reset"!==e.type)if("BUTTON"===e.tagName)this.type="button";else{if("A"!==e.tagName)throw new Error("JET Button not supported on this element type");this.type="anchor"}else this.type="inputPush";if(this._isToggle){var t="label[for='"+this.element[0].getAttribute("id")+"']";this.buttonElement=this.element.siblings().filter(t)}else this.buttonElement=this.element},_initButtonTypes2:function(){var e=this.element[0];if(this._isToggle){this.buttonElement[0].classList.add("oj-button-label"),e.classList.add("oj-button-input"),e.classList.add("oj-helper-hidden-accessible"),e.setAttribute("data-oj-internal","");var t=document.createElement("span");this.element[0].parentNode.insertBefore(t,this.buttonElement[0]),t.appendChild(this.buttonElement[0]),t.appendChild(this.element[0]),this.rootElement=this.element[0].parentNode,this.rootElement.classList.add("oj-button-toggle"),e.checked&&(this.rootElement.classList.add("oj-selected"),this.rootElement.classList.remove("oj-default"),this.rootElement.classList.remove("oj-focus-only"))}else this._IsCustomElement()?(this.rootElement=this.element[0].parentNode,e.classList.add("oj-button-button")):(this.rootElement=this.element[0],this._IsCustomElement()||e.classList.add("oj-button-toggle"))},widget:function(){return n(this.rootElement)},_destroy:function(){this._removeMenuBehavior(this._getMenuNode()),this.buttonElement[0].removeEventListener("click",this._disabledClickHandler,!0),this.buttonElement[0].removeEventListener("click",this._ojActionClickHandler,!1),this.buttonElement[0].removeEventListener("touchstart",this._touchStartHandler,{passive:!0}),delete this._touchStartHandler;var e=this.element[0];e.classList.remove("oj-helper-hidden-accessible"),e.removeAttribute("aria-labelledby"),e.removeAttribute("aria-describedby"),this.element.removeUniqueId(),this.options.disabled&&this._manageAnchorTabIndex(!0,!1);var t=this._isToggle;t||y(this.rootElement,c+" oj-button-toggle oj-hover oj-active oj-selected "+h+" "+d);var n=this.buttonElement[0].querySelector(".oj-button-text");n&&(this.buttonElement[0].innerHTML=n.innerHTML),t?(this.buttonElement[0].classList.remove("oj-button-label"),o.unwrap(this.element)):this.hasTitle||this.rootElement.removeAttribute("title"),u===this.buttonElement[0]&&(u=null),this.buttonElement.off("blur"),this._removeMutationObserver()},_NotifyDetached:function(){this._super(),this._toggleDefaultClasses()},__setAncestorComponentDisabled:function(e){this._super(e),this._updateEffectivelyDisabled()},_updateEffectivelyDisabled:function(){var t=this.element[0],n=this._IsEffectivelyDisabled();if(n?(this.rootElement.classList.add("oj-disabled"),this.rootElement.classList.remove("oj-enabled")):(this.rootElement.classList.remove("oj-disabled"),this.rootElement.classList.add("oj-enabled")),"anchor"!==this.type?(t.disabled=n,this.rootElement.removeAttribute("aria-disabled")):(t.setAttribute("aria-disabled",n),this._IsCustomElement()&&this.rootElement.removeAttribute("aria-disabled")),n){var o=this.widget()[0].classList;o.remove("oj-active"),o.remove("oj-default"),o.remove("oj-focus-only"),o.remove("oj-hover"),o.remove("oj-focus"),o.remove("oj-focus-highlight"),e=null,this._dismissMenu(this._getMenuNode())}else this._toggleDefaultClasses()},_setOption:function(e,t,n){var o=this.options[e];switch(this._super(e,t,n),e){case"chroming":p(this.rootElement,t);break;case"disabled":if(this._manageAnchorTabIndex(o,t),this._updateEffectivelyDisabled(),!this._IsCustomElement()){var s=this._getEnclosingContainerElement("toolbar");s.length&&s.ojToolbar("refresh")}break;case"label":this._setLabelOption();break;case"display":"inputPush"!==this.type&&this._setDisplayOptionOnDom();break;case"icons":this._setIconsOption(!0);break;case"menu":this._setupMenuButton(o)}},refresh:function(){this._super(),this._ancestorDisabled&&!this._getEnclosingContainerElement("buttonset").length&&this.__setAncestorComponentDisabled(!1),p(this.rootElement,this.options.chroming)},_applyCheckedStateFromDom:function(e){"radio"===this.type?(e?f(this.element[0]):this.element).each(function(){var e=n(this).data("oj-ojButton");this.checked?(e.rootElement.classList.add("oj-selected"),e.rootElement.classList.remove("oj-default"),e.rootElement.classList.remove("oj-focus-only")):(e.rootElement.classList.remove("oj-selected"),e._toggleDefaultClasses())}):"checkbox"===this.type&&(this.element[0].checked?(this.rootElement.classList.add("oj-selected"),this.rootElement.classList.remove("oj-default"),this.rootElement.classList.remove("oj-focus-only")):(this.rootElement.classList.remove("oj-selected"),this._toggleDefaultClasses()))},_handleLabelAndIconsAtCreateTime:function(){if("inputPush"===this.type)this._setLabelOnDomOfSpanlessButton();else{var e=this._setLabelOnDomAtCreateTime(),t=this._setIconOnDom(!0),n=this._setIconOnDom(!1);this._setDisplayOptionOnDom(e,t,n)}},_setLabelOnDomAtCreateTime:function(){var e=this.buttonElement[0],t=document.createElement("span");if(t.className="oj-button-text",this.keepDomLabel)for(;e.hasChildNodes();)t.appendChild(e.firstChild);else e.innerHTML="",t.textContent=this.options.label;if("button"===this.type){var o=document.createElement("div");o.className="oj-button-label",o.appendChild(t),this.element[0].appendChild(o)}else e.appendChild(t);return"button"!==this.type&&"anchor"!==this.type||this.element[0].hasAttribute("aria-label")||this.element[0].hasAttribute("aria-labelledby")||this._setTextSpanIdAndLabelledBy(t),n(t)},_setTextSpanIdAndLabelledBy:function(e){n(e).uniqueId(),this.element[0].hasAttribute("aria-label")||this.element[0].hasAttribute("aria-labelledby")||this.element[0].setAttribute("aria-labelledby",e.getAttribute("id"))},_setLabelOption:function(){if("inputPush"===this.type)this._setLabelOnDomOfSpanlessButton();else{var e=this.buttonElement[0].querySelector(".oj-button-text");e.textContent=this.options.label,this._setDisplayOptionOnDom(n(e))}},_setLabelOnDomOfSpanlessButton:function(){this.options.label&&this.element.val(this.options.label)},_setIconsOption:function(){if("inputPush"!==this.type){var e=this._setIconOnDom(!0),t=this._setIconOnDom(!1);this._setDisplayOptionOnDom(void 0,e,t)}},_setIconOnDom:function(e){var t,n,o,s,i=this.buttonElement[0];"button"===this.type&&(i=this.element.children("div.oj-button-label")[0]),e?(t=".oj-button-icon.oj-start",n="oj-button-icon oj-start",o=this.options.icons.start,s="_lastStartIcon"):(t=".oj-button-icon.oj-end",n="oj-button-icon oj-end",o=this.options.icons.end,s="_lastEndIcon");var l,a,r=i.querySelectorAll(t);if(o)if(r.length){var u=this[s];for(l=0;l<r.length;l++)y(a=r[l],u),v(a,o)}else{var c=document.createElement("span");c.className=n+" "+o,e?i.insertBefore(c,i.firstChild):i.appendChild(c)}else for(l=0;l<r.length;l++)(a=r[l]).parentNode.removeChild(a);return this[s]=o,!!o},_setDisplayOptionOnDom:function(e,t,o){var s=this.buttonElement.children(".oj-button-label");if(!s.length){var i=this._getEnclosingContainerComponent("buttonset");s=this._IsCustomElement()||i&&i._IsCustomElement()?this.buttonElement.children("oj-option"):this.buttonElement}void 0===e&&(e=s.children(".oj-button-text")),void 0===t&&(t=!!this.options.icons.start||s.children("[slot='startIcon']").length),void 0===o&&(o=!!this.options.icons.end||s.children("[slot='endIcon']").length);var l,a=t&&o,r=t||o,u="icons"===this.options.display,c="label"===this.options.display;if(c)s.children("[slot='startIcon']")&&s.children("[slot='startIcon']")[0].classList.add("oj-helper-hidden"),s.children("[slot='endIcon']")&&s.children("[slot='endIcon']")[0].classList.add("oj-helper-hidden");else if(r&&u){if(e[0]&&e[0].classList.add("oj-helper-hidden-accessible"),!this.hasTitle){var d=e[0]?e[0].textContent:"";this.rootElement.setAttribute("title",n.trim(d))}this._addMutationObserver()}else e[0]&&e[0].classList.remove("oj-helper-hidden-accessible"),this.hasTitle||this.rootElement.removeAttribute("title"),this._removeMutationObserver();c&&(l="oj-button-text-only"),l=r?u?a?"oj-button-icons-only":"oj-button-icon-only":a?"oj-button-text-icons":t?"oj-button-text-icon-start":"oj-button-text-icon-end":"oj-button-text-only",y(this.rootElement,h),this.rootElement.classList.add(l)},_manageAnchorTabIndex:function(e,t){if(!e!=!t&&"anchor"===this.type&&!this._getEnclosingContainerElement("buttonset").length&&!this._getEnclosingContainerElement("toolbar").length){var n=this.element[0];if(t){var o=n.getAttribute("tabindex");this._oldAnchorTabIndex=this._isInteger(Number(o))?o:null,n.setAttribute("tabindex",-1)}else null==this._oldAnchorTabIndex?n.removeAttribute("tabindex"):n.setAttribute("tabindex",this._oldAnchorTabIndex)}},_isInteger:function(e){return"number"==typeof e&&isFinite(e)&&Math.floor(e)===e},_selectorMap:{buttonset:".oj-buttonset",toolbar:".oj-toolbar",buttonsetone:"oj-buttonset-one"},_constructorMap:{buttonset:"ojButtonset",toolbar:"ojToolbar"},_isSelectedInButtonsetOne:function(){return 1===this._getEnclosingContainerElement("buttonsetone").length&&this.rootElement.classList.contains("oj-selected")},_getEnclosingContainerElement:function(e){return n(this.rootElement).closest(this._selectorMap[e])},_getEnclosingContainerComponent:function(e){var t=this._getEnclosingContainerElement(e)[0],n=i.__GetWidgetConstructor(t,this._constructorMap[e]);return n&&n("instance")},_setupMenuButton:function(e){if(this._getMenuNode()&&"INPUT"===this.element[0].tagName)throw new Error("Menu Button functionality is not supported on input elements.");if(this._removeMenuBehavior(e),this._getMenuNode()){var t=this;this.element.attr("aria-haspopup",!0).attr("role","button").on("keydown"+this.menuEventNamespace,function(e){if(e.which===n.ui.keyCode.DOWN||e.which===n.ui.keyCode.ENTER||e.which===n.ui.keyCode.SPACE)return t._toggleMenu(e,"firstItem"),e.preventDefault(),!0;if(e.which===n.ui.keyCode.ESCAPE){var o=!t.rootElement.classList.contains("oj-selected");return t._dismissMenu(t._getMenuNode(),e),o}return!0}).on("click"+this.menuEventNamespace,function(e){var n=t._getMenu();return n.__spaceEnterDownInMenu||t._toggleMenu(e,"menu"),n.__spaceEnterDownInMenu=!1,e.preventDefault(),!0})}},_removeMenuBehavior:function(e){this.element.removeAttr("aria-haspopup").removeAttr("role").off(this.menuEventNamespace),this._dismissMenu(e),n(e).off(this.menuEventNamespace),this._menuListenerSet=!1},_getMenu:function(){var e=this._getMenuOnly(this._getMenuNode());if(!e)throw new Error('JET Button: "menu" option specified, but does not reference a valid JET Menu.');if(!this._menuListenerSet){var t,n=this;t=e._IsCustomElement()?"ojClose":"ojclose",e.widget().on(t+this.menuEventNamespace,function(e){n._menuDismissHandler(e)}),this._menuListenerSet=!0}return e},_getMenuOnly:function(e){var t=i.__GetWidgetConstructor(n(e)[0],"ojMenu");return t&&t("instance")},_toggleMenu:function(e,t){if(!this._IsEffectivelyDisabled()){var n=this._getMenu(),o=n.widget();this._menuVisible?this._dismissMenu(this._getMenuNode(),e):(n.open(e,{launcher:this.element,initialFocus:t}),o.is(":visible")&&(this._menuVisible=!0,o[0].getAttribute("aria-label")||o[0].getAttribute("aria-labelledby")||(this.element.uniqueId(),this._setAriaLabelledBy=!0,o[0].setAttribute("aria-labelledby",this.element[0].getAttribute("id"))),this.rootElement.classList.add("oj-selected"),this.rootElement.classList.remove("oj-default"),this.rootElement.classList.remove("oj-focus-only")))}},_dismissMenu:function(e,t){if(this._menuVisible){var n=this._getMenuOnly(e);n&&(n.__collapseAll(t,!0),n.__dismiss(t))}},_menuDismissHandler:function(){this._setAriaLabelledBy&&(n(this._getMenuNode()).removeAttr("aria-labelledby"),this._setAriaLabelledBy=!1),this.rootElement.classList.remove("oj-selected"),this._toggleDefaultClasses(),this._menuVisible=!1},_toggleDefaultClasses:function(){var e,t;if(n(this.rootElement).is(".oj-hover, .oj-active, .oj-selected, .oj-disabled"))e=!1,t=!1;else{var o=n(this.rootElement).is(".oj-focus");e=!o,t=o}e?this.rootElement.classList.add("oj-default"):this.rootElement.classList.remove("oj-default"),t?this.rootElement.classList.add("oj-focus-only"):this.rootElement.classList.remove("oj-focus-only")}}),t.__registerWidget("oj.ojButtonset",n.oj.baseComponent,{_items:"button, input[type=button], input[type=submit], input[type=reset], input[type=checkbox], input[type=radio], a",widgetEventPrefix:"oj",options:{checked:null,chroming:"solid",display:"all",focusManagement:"oneTabstop",labelledBy:null,describedBy:null},_setCheckedOnDom:function(e,t){var o,s=n.type(e),i=this.element[0];if((o="OJ-BUTTONSET-MANY"===i.tagName||t.length>0&&t.filter("input[type=checkbox]").length===t.length)&&"array"!==s)throw new Error("Invalid 'checked' value set on JET Buttonset: "+e);if(!(this._setCheckedOnButtons(e,t,s,o)||null==e||this._IsCustomElement()&&t.length!==i.children.length))throw new Error("Invalid 'checked' value set on JET Buttonset: "+e)},_setCheckedOnButtons:function(e,t,n,o){var s=this._shallowCompare(e,t,o);return this._shouldDeepCompare(e,o,s)&&(s=this._deepCompare(e,t,o,s)),o?s===e.length:1===s},_shallowCompare:function(e,t,n){var o=this,s=0;return t.each(function(){var t=o._getInputValue(this);(n?e.indexOf(t)>-1:t===e)?(this.checked=!0,s+=1):this.checked=!1}),s},_shouldDeepCompare:function(e,t,n){return t?n!==e.length:!n},_deepCompare:function(e,t,n,o){var s=o,i=this;return t.each(function(){var t=i._getInputValue(this);if(n)for(var o=0;o<e.length;o++)i._deepCompareValues(t,e[o])&&(this.checked=!0,s+=1);else i._deepCompareValues(t,e)&&(this.checked=!0,s+=1)}),s},_deepCompareValues:function(e,o){return"object"===n.type(e)&&e.ojCompareValues?0===e.ojCompareValues(e,o):t.Object.compareValues(e,o)},_getInputValue:function(e){return this._IsCustomElement()?this._getOjOptionFromInput(e).value:e.value},_getOjOptionFromInput:function(e){return e.previousElementSibling.children[0]},_getCheckedFromDom:function(e){var t,n=null,o=null,s=this;return e.each(function(){if("input"!==this.tagName.toLowerCase())return t=void 0,!1;var e,i,l=this.type.toLowerCase();if("radio"===l)e=!0,i=this.name.toLowerCase();else{if("checkbox"!==l)return t=void 0,!1;e=!1,i=null}if(void 0!==t&&(e!==n||i!==o||n&&!o))return t=void 0,!1;var a=s._getInputValue(this);void 0===t?(t=e?this.checked?a:null:this.checked?[a]:[],n=e,o=i):this.checked&&(n?t=a:t.push(a))}),t},_CompareOptionValues:function(e,t,o){return"checked"===e?t===o||"array"===n.type(t)&&"array"===n.type(o)&&this._compareArraysAsSets(t,o):this._superApply(arguments)},_compareArraysAsSets:function(e,t){return!e.some(function(e){return t.indexOf(e)<0})&&!t.some(function(t){return e.indexOf(t)<0})},_removeNonOjOptions:function(){this.element.children(":not(oj-option)").remove()},_processOjOptions:function(){var e=this,t=this.element[0].querySelectorAll("oj-option");n.each(t,function(t,n){n.customOptionRenderer=e._customOptionRenderer.bind(e)})},_customOptionRenderer:function(e){this._removeOptionDecoration(e),this._addOptionDecoration(e)},_addOptionDecoration:function(e){this._addOptionClasses(e);var t="OJ-BUTTONSET-ONE"===this.element[0].tagName,o=t?"radio":"checkbox",s=e.value,i=e.disabled,l=document.createElement("input"),a=document.createElement("label");n(l).uniqueId(),l.value=s,l.type=o,l.disabled=i;var r=l.id;a.htmlFor=r,t&&(this._name||(this._name="_n_"+r),l.name=this._name),e.parentNode.insertBefore(a,e),a.appendChild(e),a.parentNode.insertBefore(l,a.nextElementSibling),this._setup(!1),this._setCheckedOnDom(this.options.checked,this.$buttons),this.$buttons.each(function(){n(this).data("oj-ojButton")._applyCheckedStateFromDom(!1)})},_removeOptionDecoration:function(e){var t=e.parentNode;if("LABEL"===t.tagName){this._removeOptionClasses(e);var o=n(t).siblings(".oj-button-input");o.ojButton("destroy"),o.removeUniqueId(),o.remove(),t.parentNode.insertBefore(e,t),t.parentNode.removeChild(t)}},_addOptionClasses:function(e){var t=r.CustomElementUtils.getSlotMap(e),n=t[""]?t[""]:null,o=t.startIcon?t.startIcon[0]:null,s=t.endIcon?t.endIcon[0]:null;if(o&&(o.classList.add("oj-button-icon"),o.classList.add("oj-start")),n)for(var i=0;i<n.length;i++){var l=n[i],a=l;3===l.nodeType&&(a=document.createElement("span"),l.parentNode.insertBefore(a,l),a.appendChild(l)),a.classList.add("oj-button-text")}s&&(s.classList.add("oj-button-icon"),s.classList.add("oj-end"))},_removeOptionClasses:function(e){var t=r.CustomElementUtils.getSlotMap(e),n=t[""]?t[""]:null,o=t.startIcon?t.startIcon[0]:null,s=t.endIcon?t.endIcon[0]:null;if(o&&(o.classList.remove("oj-button-icon"),o.classList.remove("oj-start")),n)for(var i=0;i<n.length;i++)n[i].classList.remove("oj-button-text");s&&(s.classList.remove("oj-button-icon"),s.classList.remove("oj-end"))},_InitOptions:function(e,t){if(this._super(e,t),this.$buttons=this.element.find(this._items),!("checked"in t)){this.initCheckedFromDom=!0;var o=this._getCheckedFromDom(this.$buttons);"array"!==n.type(o)&&"OJ-BUTTONSET-MANY"!==this.element[0].tagName||(this.options.checked=[]),void 0!==o&&this.option("checked",o,{_context:{internalSet:!0}})}},_ComponentCreate:function(){this._super();var e=this.element[0];e.setAttribute(i._OJ_CONTAINER_ATTR,this.widgetName),e.classList.add("oj-buttonset"),e.classList.add("oj-component"),this._setRole(this.options.focusManagement),this._IsCustomElement()&&(this._removeNonOjOptions(),this._processOjOptions()),this._setup(!0)},_NotifyContextMenuGesture:function(e,t,n){var o=this.element.find(":oj-button[tabindex=0]");this._OpenContextMenu(t,n,{launcher:o,position:{of:"keyboard"===n?o.ojButton("widget"):t}})},_propagateDisabled:function(e){var t=!!e;this.$buttons.each(function(){n(this).data("oj-ojButton").__setAncestorComponentDisabled(t)})},_setRole:function(e){var t=this.element[0];"oneTabstop"===e?t.setAttribute("role","toolbar"):t.removeAttribute("role")},_setOption:function(e,t,o){var s=this.options[e];if(this._superApply(arguments),"disabled"===e){if(this._propagateDisabled(t),this._refreshTabStop(),!this._IsCustomElement()){var i=n(this.element).closest(".oj-toolbar");i.length&&i.ojToolbar("refresh")}}else if("checked"===e)this._setCheckedOnDom(t,this.$buttons),this.$buttons.each(function(){n(this).data("oj-ojButton")._applyCheckedStateFromDom(!1)});else if("focusManagement"===e)this._setRole(t);else if("chroming"===e)p(this.element[0],t),this.$buttons.ojButton("refresh");else if("display"===e)this.$buttons.ojButton("option",e,t);else if("labelledBy"===e){var l=this.element;this._labelledByUpdatedForSet(l[0].id,s,t,l)}else"describedBy"===e&&this._describedByUpdated(s,t)},refresh:function(){this._super(),this._IsCustomElement()&&this._processOjOptions(),this._setup(!1)},_setup:function(e){var t=this,o=this.element[0];this.isRtl="rtl"===this._GetReadingDirection(),p(o,this.options.chroming),!e||this.initCheckedFromDom||this._IsCustomElement()||this._setCheckedOnDom(this.options.checked,this.$buttons),e||(this.$buttons=this.element.find(this._items)),this.$buttons.length>1?o.classList.add("oj-buttonset-multi"):o.classList.remove("oj-buttonset-multi"),this.$buttons.filter(":oj-button").ojButton("refresh").each(function(){n(this).data("oj-ojButton")._applyCheckedStateFromDom(!1)}).end().not(":oj-button").ojButton({display:this.options.display}).end();for(var s=0,i=this.$buttons.length;s<i;s++){var l=this.$buttons.eq(s).ojButton("widget")[0];l.classList.remove("oj-buttonset-first"),l.classList.remove("oj-buttonset-last"),0===s?l.classList.add("oj-buttonset-first"):s===i-1&&l.classList.add("oj-buttonset-last")}this._propagateDisabled(this.options.disabled),"oneTabstop"===this.options.focusManagement&&(this.$buttons.unbind("keydown"+this.eventNamespace).bind("keydown"+this.eventNamespace,function(e){t._handleKeyDown(e,n(this))}).unbind("click"+this.eventNamespace).bind("click"+this.eventNamespace,function(){n(this).data("oj-ojButton")._IsEffectivelyDisabled()||t._setTabStop(n(this))}).unbind("focus"+this.eventNamespace).bind("focus"+this.eventNamespace,function(){t._setTabStop(n(this))}),this.$enabledButtons=this.$buttons.filter(function(){return!n(this).data("oj-ojButton")._IsEffectivelyDisabled()}),this._initTabindexes(e)),this.element.uniqueId(),this._labelledByUpdatedForSet(o.id,null,this.options.labelledBy,this.element);var a=this.options.describedBy;a&&this._describedByUpdated(a)},_labelledByUpdatedForSet:a._labelledByUpdatedForSet,_describedByUpdated:a._describedByUpdated,_GetContentElement:function(){return null!=this.$buttons||(this.$buttons=this.element.find(this._items)),this.$buttons},_refreshTabStop:function(){"oneTabstop"===this.options.focusManagement&&(this.$enabledButtons=this.$buttons.filter(function(){return!n(this).data("oj-ojButton")._IsEffectivelyDisabled()}),this._initTabindexes(!1))},_initTabindexes:function(e){var t,o=n(this._lastTabStop);this._lastTabStop=void 0,this.$buttons.attr("tabindex","0"),t=e||!o.is(this.$enabledButtons)?this.$enabledButtons.first():o,this._setTabStop(t)},_mapToTabbable:function(e){var t=this.$enabledButtons;return e.map(function(e,n){if("radio"!==n.type||n.checked||""===n.name)return n;var o=f(n,t).filter(":checked");return o.length?o[0]:n})},_setTabStop:function(e){var t=(e=this._mapToTabbable(e))[0];t!==this._lastTabStop&&(e[0]&&e[0].setAttribute("tabindex","0"),this._lastTabStop=t)},_handleKeyDown:function(e,t){switch(e.which){case n.ui.keyCode.UP:case n.ui.keyCode.DOWN:if("radio"!==t[0].getAttribute("type"))break;case n.ui.keyCode.LEFT:case n.ui.keyCode.RIGHT:e.preventDefault();var o=this.$enabledButtons,s=o.length;if(s<2)break;var i=(o.index(t)+(e.which===n.ui.keyCode.DOWN||e.which===n.ui.keyCode.RIGHT!==this.isRtl?1:-1)+s)%s;o.eq(i).focus()}},_destroy:function(){var e=this.element[0];y(e,"oj-buttonset oj-component "+d),e.removeAttribute(i._OJ_CONTAINER_ATTR),e.removeAttribute("role"),"oneTabstop"===this.options.focusManagement&&this.$buttons.attr("tabindex","0"),this.$buttons.map(function(){return n(this).ojButton("widget")[0]}).removeClass("oj-buttonset-first oj-buttonset-last").end().ojButton("destroy")}}),i.setDefaultOptions({ojButton:{chroming:i.createDynamicPropertyGetter(function(e){return _("button",e.element,e.containers)})},ojButtonset:{chroming:i.createDynamicPropertyGetter(function(e){return _("buttonset",e.element,e.containers)})}})}()});
//# sourceMappingURL=ojbutton.js.map