/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","jqueryui-amd/widget","jqueryui-amd/unique-id","jqueryui-amd/keycode","jqueryui-amd/focusable","jqueryui-amd/tabbable","ojs/ojcore","jquery","ojs/ojmessaging","ojs/ojmetadatautils","ojs/ojcore-base","ojs/ojdomutils","ojs/ojcustomelement","ojs/ojcustomelement-utils","ojs/ojcustomelement-registry","ojs/ojlogger","ojs/ojdefaultsutils","ojs/ojtranslation","ojs/ojfocusutils","ojs/ojgestureutils"],function(t,e,n,i,o,s,r,a,l,u,c,_,h,p,d,E,f,g,m,v){"use strict";r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r,a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l,c=c&&Object.prototype.hasOwnProperty.call(c,"default")?c.default:c;
/**
   * @preserve Copyright 2013 jQuery Foundation and other contributors
   * Released under the MIT license.
   * http://jquery.org/license
   */
const y=function(t){this.Init(t)};r.Object.createSubclass(y,r.Object,"oj.ComponentMessaging"),r._registerLegacyNamespaceProp("ComponentMessaging",y),y._STRATEGY_TYPE={NONE:"none",NOTEWINDOW:"notewindow",PLACEHOLDER:"placeholder",INLINE:"inline",LABEL_EDGE_INSIDE:"inside",LABEL_EDGE_INSIDE_FORM_CNTRL:"insideformcontrol",USER_ASSISTANCE_INLINE:"userassistanceinline"},y._STRATEGY_TYPE_TO_CALLBACK={};const T="aria-describedby";y.registerMessagingStrategy=function(t,e){t&&"function"==typeof e&&(y._STRATEGY_TYPE_TO_CALLBACK[t]=e)},y.prototype.Init=function(t){y.superclass.Init.call(this),this._component=t,this._activated=!1,this._initializeMessagingStrategies()},y.prototype.activate=function(t,e,n){var i=this;r.Assert.assertObject(n),this._launcher=t,this._contentElement=e,this._messagingContent=r.CollectionUtils.copyInto(this._messagingContent||{},n),this._isActive()?this._reactivate():(a.each(this._strategies,function(t,e){e.activate(i)}),this._activated=!0)},y.prototype.update=function(t){r.Assert.assertObject(t),r.Assert.assertBoolean(this._activated),this._messagingContent=r.CollectionUtils.copyInto(this._messagingContent||{},t),this._activated&&a.each(this._strategies,function(e,n){n.shouldUpdate(t)&&n.update()})},y.prototype.deactivate=function(){a.each(this._strategies,function(t,e){e.deactivate()}),this._activated=!1,this._component=null,this._launcher=null,this._contentElement=null,this._strategies={}},y.prototype.close=function(){this._activated&&a.each(this._strategies,function(t,e){e.close()})},y.prototype.releaseResources=function(){this._activated&&a.each(this._strategies,function(t,e){e.releaseResources()})},y.prototype.setupResources=function(){this._activated&&a.each(this._strategies,function(t,e){e.setupResources()})},y.prototype._createMessagingStrategy=function(t,e){return new(y._STRATEGY_TYPE_TO_CALLBACK[t]||y._STRATEGY_TYPE_TO_CALLBACK[y._STRATEGY_TYPE.NONE])(e)},y.prototype._getComponent=function(){return this._component||null},y.prototype._getLauncher=function(){return this._launcher||null},y.prototype._getContentElement=function(){return this._contentElement||null},y.prototype._getMessagingContent=function(){return this._messagingContent||{}},y.prototype._setMessagingContent=function(t){r.Assert.assertObject(t),this._messagingContent=r.CollectionUtils.copyInto(this._messagingContent||{},t)},y.prototype._isActive=function(){return this._activated},y.prototype._getResolvedMessagingDisplayOptions=function(t){for(var e={},n=!1,i=this._component.options,o={},s=this,r=Object.keys(t),l=0;l<r.length;l++){var u=r[l],c=t[u];n=!1;var _=u+"";if(Array.isArray(c))for(var h=0;h<c.length;h++){var p=c[h];n||(n=s._resolveStrategyTypeForArtifact(_,p,i,o))}else"string"==typeof c&&(n||(n=s._resolveStrategyTypeForArtifact(_,c,i,o)));n||(o[_]=y._STRATEGY_TYPE.NONE)}return s._addLabelStrategy(o),a.each(y._STRATEGY_TYPE,function(t,n){e[n]=[]}),a.each(o,function(t,n){e[n].push(t)}),e},y.prototype._getUserAssistanceStrategyToArtifactsObj=function(){var t={},e=this._component.options.displayOptions||{},n={},i=Object.keys(e);for(let t=0;t<i.length;t++){let o=i[t],s=e[o],r=o+"";n[r]="string"==typeof s&&"none"===s?y._STRATEGY_TYPE.NONE:y._STRATEGY_TYPE.USER_ASSISTANCE_INLINE}return this._addLabelStrategy(n),Object.keys(y._STRATEGY_TYPE).forEach(function(e){let n=y._STRATEGY_TYPE[e];t[n]=[]}),Object.keys(n).forEach(function(e){let i=n[e];t[i].push(e)}),t},y.prototype._addLabelStrategy=function(t){var e="labelEdge",n=this._component._ResolveLabelEdgeStrategyType();this._resolveStrategyTypeForArtifact(e,n,this._component.options,t)||(t[e]=y._STRATEGY_TYPE.NONE)},y.prototype._resolveStrategyTypeForArtifact=function(t,e,n,i){var o=!1,s=n.placeholder;switch(e){case y._STRATEGY_TYPE.PLACEHOLDER:"converterHint"===t&&(o||s||(i[t]=e,o=!0));break;case y._STRATEGY_TYPE.INLINE:"messages"===t&&(o||(i[t]=e,o=!0));break;case y._STRATEGY_TYPE.LABEL_EDGE_INSIDE:case y._STRATEGY_TYPE.LABEL_EDGE_INSIDE_FORM_CNTRL:"labelEdge"!==t||o||r.StringUtils.isEmptyOrUndefined(n.labelHint)||(i[t]=e,o=!0);break;default:o||"labelEdge"===t||(i[t]=e,o=!0)}return o},y.prototype._initializeMessagingStrategies=function(){var t=this._strategyToArtifacts(),e=t[y._STRATEGY_TYPE.NOTEWINDOW],n=t[y._STRATEGY_TYPE.NONE],i=t[y._STRATEGY_TYPE.PLACEHOLDER],o=t[y._STRATEGY_TYPE.INLINE],s=t[y._STRATEGY_TYPE.LABEL_EDGE_INSIDE],r=t[y._STRATEGY_TYPE.LABEL_EDGE_INSIDE_FORM_CNTRL],a=t[y._STRATEGY_TYPE.USER_ASSISTANCE_INLINE],l={};e.length>0&&(l[y._STRATEGY_TYPE.NOTEWINDOW]=this._createMessagingStrategy(y._STRATEGY_TYPE.NOTEWINDOW,e)),i.length>0&&0===s.length&&(l[y._STRATEGY_TYPE.PLACEHOLDER]=this._createMessagingStrategy(y._STRATEGY_TYPE.PLACEHOLDER,i)),o.length>0&&(l[y._STRATEGY_TYPE.INLINE]=this._createMessagingStrategy(y._STRATEGY_TYPE.INLINE,o)),a.length>0&&(l[y._STRATEGY_TYPE.USER_ASSISTANCE_INLINE]=this._createMessagingStrategy(y._STRATEGY_TYPE.USER_ASSISTANCE_INLINE,a)),s.length>0?l[y._STRATEGY_TYPE.LABEL_EDGE_INSIDE]=this._createMessagingStrategy(y._STRATEGY_TYPE.LABEL_EDGE_INSIDE,s):r.length>0&&(l[y._STRATEGY_TYPE.LABEL_EDGE_INSIDE_FORM_CNTRL]=this._createMessagingStrategy(y._STRATEGY_TYPE.LABEL_EDGE_INSIDE_FORM_CNTRL,r)),l[y._STRATEGY_TYPE.NONE]=this._createMessagingStrategy(y._STRATEGY_TYPE.NONE,n),this._strategies=l},y.prototype._reactivate=function(){var t,e=this._strategyToArtifacts(),n=this;a.each(e,function(e,i){e+="",t=n._strategies[e],i&&i.length>0?t?t&&t.reactivate(i):(t=n._createMessagingStrategy(e,i),n._strategies[e]=t,t.activate(n)):t&&y._STRATEGY_TYPE.NONE!==e&&(t.deactivate(),delete n._strategies[e])})},y.prototype._strategyToArtifacts=function(){let t,e=this._component._getResolvedUserAssistance();if("compact"!==e&&"displayOptions"!==e)t=this._getUserAssistanceStrategyToArtifactsObj();else{let n=this._component.options.displayOptions||{};"compact"===e?(n.messages="notewindow",n.validatorHint="notewindow",n.converterHint="notewindow",t=this._getResolvedMessagingDisplayOptions(n)):t=this._getResolvedMessagingDisplayOptions(n)}return t};const C=function(t){this.Init(t)};r.Object.createSubclass(C,r.Object,"oj.MessagingStrategy"),r._registerLegacyNamespaceProp("MessagingStrategy",C),C.prototype.Init=function(t){r.Assert.assertArray(t),C.superclass.Init.call(this),this._displayOptions=t},C.prototype.activate=function(t){this._componentMessaging=t},C.prototype.deactivate=function(){},C.prototype.close=function(){},C.prototype.setupResources=function(){},C.prototype.releaseResources=function(){},C.prototype.reactivate=function(t){this.Init(t)},C.prototype.shouldUpdate=function(t){return!0},C.prototype.update=function(){},C.prototype.GetLauncher=function(){return this._componentMessaging._getLauncher()},C.prototype.GetContentElement=function(){return this._componentMessaging._getContentElement()},C.prototype.GetComponent=function(){return this._componentMessaging._getComponent()},C.prototype.setHasValidatorHints=function(t){this._hasValidatorHints=t},C.prototype.getHasValidatorHints=function(){return!0===this._hasValidatorHints},C.prototype.GenerateIdIfNeeded=function(t){isNaN(C._uidCounter)&&(C._uidCounter=0);var e=t;e.id||(e.id="ojms_"+C._uidCounter,C._uidCounter+=1)},C.prototype.GetMessages=function(){return this.GetValidityState().getMessages()},C.prototype.GetMaxSeverity=function(){return this.GetValidityState().getMaxSeverity()},C.prototype.GetConverterHint=function(){var t=[],e=this._getMessagingContent(),n=e&&e.converterHint;return n&&t.push(n),t},C.prototype.GetValidatorHints=function(){if(!this.getHasValidatorHints()){this.setHasValidatorHints(!0);let t=this.GetComponent();this._setMessagingContent(t._getValidatorHintsMC()),t._initAsyncValidatorMessagingHint()}var t=this._getMessagingContent();return t&&t.validatorHint||[]},C.prototype.GetTitle=function(){var t=this._getMessagingContent();return t&&t.title||""},C.prototype.GetValidityState=function(){var t=this._getMessagingContent();return t&&t.validityState||null},C.prototype.HasMessages=function(){var t=this.GetMessages();return!!(t&&t.length>0)},C.prototype.ShowMessages=function(){return-1!==this._displayOptions.indexOf("messages")},C.prototype.ShowConverterHint=function(){return-1!==this._displayOptions.indexOf("converterHint")},C.prototype.ShowValidatorHint=function(){return-1!==this._displayOptions.indexOf("validatorHint")},C.prototype.ShowTitle=function(){return-1!==this._displayOptions.indexOf("title")||-1!==this._displayOptions.indexOf("helpInstruction")},C.prototype.IsInvalid=function(){return this.GetValidityState().isInvalid()},C.prototype.AddAriaDescribedByForInlineMessaging=function(t){let e=this.GetContentElement();r.Assert.assertPrototype(e,a);let n=a(t).uniqueId()[0].getAttribute("id");e.each(function(){let t=this.getAttribute(T),e=t?t.split(/\s+/):[];-1===e.indexOf(n)&&e.push(n);let i=e.join(" ").trim();this.setAttribute(T,i)})},C.prototype.AddDescribedByToElement=function(t,e){const n="described-by",i=t.getAttribute(n);let o,s=i?i.split(/\s+/):[];-1===s.indexOf(e)&&s.push(e),o=s.join(" ").trim(),t.setAttribute(n,o)},C.prototype.RemoveDescribedByFromElement=function(t,e){const n="described-by",i=t.getAttribute(n);let o=(i?i.split(/\s+/):[]).filter(t=>t!==e).join(" ").trim();o?t.setAttribute(n,o):t.removeAttribute(n)},C.prototype.RemoveAriaDescribedByForInlineMessaging=function(t){let e=this.GetContentElement();r.Assert.assertPrototype(e,a);let n=t.getAttribute("id");e.each(function(){let t=this.getAttribute(T),e=t?t.split(/\s+/):[],i=e.indexOf(n);-1!==i&&e.splice(i,1);let o=e.join(" ").trim();o?this.setAttribute(T,o):this.removeAttribute(T)})},C.prototype._getMessagingContent=function(){return this._componentMessaging?this._componentMessaging._getMessagingContent():{}},C.prototype._setMessagingContent=function(t){return this._componentMessaging?this._componentMessaging._setMessagingContent(t):{}};const S=function(t){this.Init(t)};y.registerMessagingStrategy(y._STRATEGY_TYPE.NONE,S),S._SELECTOR_STATE_INVALID="oj-invalid",S._SELECTOR_STATE_WARNING="oj-warning",r.Object.createSubclass(S,C,"oj.DefaultMessagingStrategy"),r._registerLegacyNamespaceProp("DefaultMessagingStrategy",S),S.prototype.update=function(){S.superclass.update.call(this);var t=this.GetLauncher(),e=this.GetMaxSeverity(),n=[],i=[],o=!1,s=this.GetComponent().widget();t&&(this.IsInvalid()?(n.push(S._SELECTOR_STATE_WARNING),i.push(S._SELECTOR_STATE_INVALID),o=!0):this.HasMessages()&&e===l.SEVERITY_LEVEL.WARNING?(n.push(S._SELECTOR_STATE_INVALID),i.push(S._SELECTOR_STATE_WARNING)):(n.push(S._SELECTOR_STATE_INVALID),n.push(S._SELECTOR_STATE_WARNING)),s.removeClass(n.join(" ")).addClass(i.join(" ")),this.GetContentElement().attr({"aria-invalid":o}))},S.prototype.deactivate=function(){this.GetComponent().widget().removeClass(S._SELECTOR_STATE_INVALID).removeClass(S._SELECTOR_STATE_WARNING),this.GetContentElement().removeAttr("aria-invalid"),S.superclass.deactivate.call(this)};const A=function(t){this.Init(t)};y.registerMessagingStrategy(y._STRATEGY_TYPE.PLACEHOLDER,A),r.Object.createSubclass(A,C,"oj.PlaceholderMessagingStrategy"),r._registerLegacyNamespaceProp("PlaceholderMessagingStrategy",A),A.prototype.Init=function(t){A.superclass.Init.call(this,t)},A.prototype.activate=function(t){A.superclass.activate.call(this,t),this._refreshPlaceholder()},A.prototype.reactivate=function(t){A.superclass.reactivate.call(this,t),this._refreshPlaceholder()},A.prototype.shouldUpdate=function(t){return!(!t||void 0===t.converterHint)},A.prototype.update=function(){A.superclass.update.call(this),this._refreshPlaceholder()},A.prototype._refreshPlaceholder=function(){var t=this.GetLauncher();if(this.ShowPlaceholderContent()&&t){var e=this.GetConverterHint(),n=e.length?e[0]:"";if(r.StringUtils.isEmptyOrUndefined(n))return;this.GetComponent().option({placeholder:n},{_context:{internalMessagingSet:!0}})}},A.prototype.ShowPlaceholderContent=function(){return this.ShowConverterHint()};const N=function(t,e){this.Init(t,e)};N.isInvalid=function(t){return l.getMaxSeverity(t)>=l.SEVERITY_LEVEL.ERROR},r.Object.createSubclass(N,r.Object,"oj.ComponentValidity"),r._registerLegacyNamespaceProp("ComponentValidity",N),N.prototype.Init=function(t,e){N.superclass.Init.call(this),this._initialize(t,e)},N.prototype.isInvalid=function(){return this._invalid},N.prototype.getMessages=function(){return this._messages},N.prototype.getMaxSeverity=function(){return this._maxSeverity},N.prototype.update=function(t,e){this._initialize(t,e)},N.prototype._initialize=function(t,e){this._compValid=t,this._compMessages=e,this._messages=this._getImmediateMessages(),this._maxSeverity=l.getMaxSeverity(this._messages),this._invalid=N.isInvalid(this._messages)},N.prototype._getImmediateMessages=function(){for(var t=this._compMessages||[],e=[],n=0;n<t.length;n++){var i=t[n];i instanceof l.ComponentMessage&&!i.canDisplay()||e.push(i)}return e};const O={};c._registerLegacyNamespaceProp("Components",O),O._OJ_CONTAINER_ATTR="data-oj-container";const b="oj-component-names",P="oj-component-initnode";var I="oj-subtree-hidden",R="oj-pending-subtree-hidden";const D="node is not a component element";function M(t,e){if(null==t)return null;var n=1===t.nodeType,i=c.Composite&&!e?c.Composite.getContainingComposite(t):null;if(i)return i;if(n&&t.hasAttribute("data-oj-internal"))return t.parentNode instanceof Element&&t.parentNode.hasAttribute("data-oj-surrogate-id")?M(t=document.querySelector("[data-oj-popup-"+t.id+"-parent]"),e):M(t.parentNode,e);if(U(t))return t;if(n&&t.classList.contains("oj-component")){if(x(t=t.querySelector(".oj-component-initnode:not([data-oj-internal])")||t))return t}else if(n&&t.hasAttribute("data-oj-containerid"))return M(t=document.getElementById(t.getAttribute("data-oj-containerid")),e);return M(t.parentNode,e)}function G(t,e){var n=function(){var t=a(this),n=t.data(b);if(null!=n)for(var i=0;i<n.length;i++){var o=t.data("oj-"+n[i]);null!=o&&e(o)}},i=a(t);i.hasClass(P)&&n.call(t),i.find("."+P).each(n)}function L(t,e,n){const i="oj-defer";function o(t){if(e&&t.classList.contains(P)){var o=a(t),s=o.data(b);if(null!=s)for(var r=0;r<s.length;r++){var l=o.data("oj-"+s[r]);null!=l&&e(l)}}if(n&&t.tagName.toLowerCase()===i){if(!t._activate)throw new Error("subtreeShown called before module ojs/ojdefer was loaded");t._activate()}}if(!function(t){for(var e=t;e;){if(e.nodeType===Node.DOCUMENT_NODE)return!1;if(e.nodeType===Node.ELEMENT_NODE&&e.classList.contains(I))return!0;e=e.parentNode}return!0}(t)){o(t);var s=[`.${P}`];n&&s.push(i);var r=[];s.forEach(function(t){r.push(`.${I} ${t}`),r.push(`.${R} ${t}`)}),n&&r.push(`${i}.${I}`);for(var l=s.join(","),u=r.join(","),c=function(t,e){for(var n=[],i=0,o=0;o<e.length;o++){for(var s=e[o];i<t.length&&t[i]!==s;)n.push(t[i]),i+=1;i+=1}for(;i<t.length;)n.push(t[i]),i+=1;return n}(t.querySelectorAll(l),t.querySelectorAll(u)),_=0;_<c.length;_++)o(c[_])}}function j(t){this.getCallback=function(){return t}}function w(t,e,n){return Object.keys(e).forEach(function(i){var o=t[i]||[],s=e[i];n?o=o.concat(s):o.push(s),t[i]=o}),t}function B(t){return d.isElementRegistered(t.tagName)}function x(t){return!!O.__GetWidgetConstructor(t)}function U(t){return B(t)||x(t)}O.setDefaultOptions=function(t){var e=O._defaultProperties||{};Object.keys(t).forEach(function(n){var i=t[n];if(!c.CollectionUtils.isPlainObject(i))throw new Error("Invalid default options");e[n]=w(e[n]||{},i,!1)}),O._defaultProperties=e},O.getDefaultOptions=function(){return O._defaultProperties||{}},O.createDynamicPropertyGetter=function(t){return new j(t)},O.getWidgetConstructor=function(t,e){return t&&!d.isElementRegistered(t.tagName)?O.__GetWidgetConstructor(t,e):null},O.__GetWidgetConstructor=function(t,e){var n=a(t),i=n.data(b);if(i&&(null==e?e=i[0]:i.indexOf(e)<0&&(e=void 0),null!=e)){var o=n[e];if("function"==typeof o)return o.bind(n)}return null},O.subtreeAttached=function(t){_.fixResizeListeners(t),G(t,function(t){t.__handleSubtreeAttached()})},O.subtreeDetached=function(t){G(t,function(t){t.__handleSubtreeDetached()})},O.subtreeShown=function(t,e){var n=a(t)[0];if(n.nodeType===Node.ELEMENT_NODE){var i=(e||{}).initialRender;i||_.fixResizeListeners(n),n.classList.remove(I),L(n,function(t){p.CustomElementUtils.allowSlotRelocation(!0);try{i?t._NotifyInitShown():t._NotifyShown()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}},!0)}},O.subtreeHidden=function(t){var e=a(t)[0];e.nodeType===Node.ELEMENT_NODE&&(L(e,function(t){p.CustomElementUtils.allowSlotRelocation(!0);try{t._NotifyHidden()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}},!1),e.classList.add(I))},O.markPendingSubtreeHidden=function(t){t.classList.add(R)},O.unmarkPendingSubtreeHidden=function(t){t.classList.remove(R)},O.isComponentInitialized=function(t,e){var n=t.data(b);return!!(a.isArray(n)&&n.indexOf(e)>-1&&t.is("."+P))},O.__getDefaultOptions=function(t){for(var e={},n=O.getDefaultOptions(),i=t.length-1;i>=0;i--){var o=n[t[i]];void 0!==o&&(e=w(e,o,!0))}return e},O.getComponentElementByNode=function(t){return M(t,!!(arguments.length>1&&arguments[1]))},O.getSubIdByNode=function(t,e){return O.callComponentMethod(t,"getSubIdByNode",e)},O.getNodeBySubId=function(t,e){return O.callComponentMethod(t,"getNodeBySubId",e)},O.getComponentOption=function(t,e){if(!U(t))throw new Error(D);return B(t)?t.getProperty?t.getProperty.call(t,e):void 0:O.__GetWidgetConstructor(t)("option",e)},O.setComponentOption=function(t,e,n){if(!U(t))throw new Error(D);B(t)?t.setProperty&&t.setProperty.call(t,e,n):O.__GetWidgetConstructor(t)("option",e,n)},O.callComponentMethod=function(t,e,n){if(!U(t))throw new Error(D);return B(t)?t[e]?t[e].apply(t,[].slice.call(arguments,2)):void 0:O.__GetWidgetConstructor(t).apply(a(t),[].slice.call(arguments,1))};const Y={};Y.proto=Object.create(r.BaseCustomElementBridge.proto),r.CollectionUtils.copyInto(Y.proto,{beforePropertyChangedEvent:function(t,e,n){var i=e,o=n.value;n.subproperty&&(i=n.subproperty.path,o=n.subproperty.value),this._partialRender(t,i,o)},AddComponentMethods:function(t){t.refresh=function(){p.CustomElementUtils.getElementBridge(this)._fullRender(this)},t.setProperty=function(t,e){var n=p.CustomElementUtils.getElementBridge(this);n.SaveEarlyPropertySet(this,t,e)||n.SetProperty(this,t,e,this,!0)},t.getProperty=function(t){return p.CustomElementUtils.getElementBridge(this).GetProperty(this,t,this)},t._propsProto.setProperty=function(t,e){this._BRIDGE.SetProperty(this._ELEMENT,t,e,this,!1)},t._propsProto.getProperty=function(t){return this._BRIDGE.GetProperty(this,t,this)}},CreateComponent:function(t){if(O.unmarkPendingSubtreeHidden(t),!this._INSTANCE&&this._EXTENSION._CONSTRUCTOR){var e=p.ElementUtils.getUniqueId();if(this._CONTEXT={element:t,props:this._PROPS_PROXY,unique:e},this._CONTEXT.uniqueId=t.id?t.id:e,this._INSTANCE=new this._EXTENSION._CONSTRUCTOR(this._CONTEXT),this._INSTANCE.createDOM&&this._INSTANCE.createDOM(),this._INSTANCE.updateDOM){p.CustomElementUtils.allowSlotRelocation(!0);try{this._INSTANCE.updateDOM()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}}},DefineMethodCallback:function(t,e,n){t[e]=function(){var t=p.CustomElementUtils.getElementBridge(this);if(t._INSTANCE){var i=n.internalName||e;return t._INSTANCE[i].apply(t._INSTANCE,arguments)}}},DefinePropertyCallback:function(t,e,n){function i(t,i){if(!this._BRIDGE.SaveEarlyPropertySet(this._ELEMENT,e,t)){i&&(t=p.transformPreactValue(this._ELEMENT,n,t));var o=this._BRIDGE._PROPS[e];p.ElementUtils.comparePropertyValues(n.writeback,t,o)?E.info(p.CustomElementUtils.getElementInfo(this._ELEMENT)+": Ignoring property set for property '"+e+"' with same value."):(i&&(t=this._BRIDGE.ValidatePropertySet(this._ELEMENT,e,t)),n._eventListener?(this._BRIDGE.SetEventListenerProperty(this._ELEMENT,e,t),this._BRIDGE._PROPS[e]=t):(this._BRIDGE._PROPS[e]=t,r.BaseCustomElementBridge.__FirePropertyChangeEvent(this._ELEMENT,e,t,o,i?"external":"internal"),this._BRIDGE.State.dirtyProps.add(e)))}}function o(){var t=this._BRIDGE._PROPS[e];return void 0===t&&(t=this._BRIDGE._getDefaultValue(e,n),this._BRIDGE._PROPS[e]=t),t}n._derived||r.BaseCustomElementBridge.__DefineDynamicObjectProperty(t._propsProto,e,function(){return o.bind(this)()},function(t){i.bind(this)(t,!1)}),r.BaseCustomElementBridge.__DefineDynamicObjectProperty(t,e,function(){var t=p.CustomElementUtils.getElementBridge(this);return o.bind(t._PROPS_PROXY)()},function(t){var e=p.CustomElementUtils.getElementBridge(this);i.bind(e._PROPS_PROXY)(t,!0)})},InitializeElement:function(t){r.BaseCustomElementBridge.proto.InitializeElement.call(this,t),this._EXTENSION._CONTROLS_SUBTREE_HIDDEN&&O.markPendingSubtreeHidden(t),r.BaseCustomElementBridge.__InitProperties(t,t)},InitializePrototype:function(t){r.BaseCustomElementBridge.proto.InitializePrototype.call(this,t),Object.defineProperty(t,"_propsProto",{value:{}})},initializeBridge:function(t,e){r.BaseCustomElementBridge.proto.initializeBridge.call(this,t,e),this._EXTENSION=this.METADATA.extension||{},this._PROPS={},t._propsProto&&(this._PROPS_PROXY=Object.create(t._propsProto),this._PROPS_PROXY._BRIDGE=this,this._PROPS_PROXY._ELEMENT=t)},ShouldRemoveDisabled:function(){return!0===this._EXTENSION._SHOULD_REMOVE_DISABLED},_fullRender:function(t){if(this._INSTANCE&&this._INSTANCE.updateDOM){p.CustomElementUtils.allowSlotRelocation(!0);try{this._INSTANCE.updateDOM()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}},_partialRender:function(t,e,n){if(this._INSTANCE){var i=this._INSTANCE.handlePropertyChanged;if((!i||!i(e,n))&&this._INSTANCE.updateDOM){p.CustomElementUtils.allowSlotRelocation(!0);try{this._INSTANCE.updateDOM()}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}}},_getDefaultValue:function(t,e){return this._EXTENSION._CONSTRUCTOR?f.DefaultsUtils.getDefaults(this._EXTENSION._CONSTRUCTOR,this.METADATA,!1)[t]:u.getDefaultValue(e)}}),r._registerLegacyNamespaceProp("DefinitionElementBridge",Y);class W extends p.ElementState{IsTransferAttribute(t){const e=p.CustomElementUtils.getElementBridge(this.Element),n=e._EXTENSION._GLOBAL_TRANSFER_ATTRS;return e._WIDGET_ELEM&&n&&n.includes(t)}GetDescriptiveTransferAttributeValue(t){return p.CustomElementUtils.getElementBridge(this.Element)._WIDGET_ELEM.getAttribute(t)}}const H={};H.proto=Object.create(r.BaseCustomElementBridge.proto),r._registerLegacyNamespaceProp("CustomElementBridge",H);const k=function(t,e){return function(n){t.dispatchEvent(new FocusEvent(e,{relatedTarget:n.relatedTarget}))}};r.CollectionUtils.copyInto(H.proto,{getThrottlePromise:function(){var t=this.State.getBindingProviderPromise();return t=t.then(function(t){return t?t.__GetThrottlePromise():null})},AddComponentMethods:function(t){t.setProperty=function(t,e){var n=p.CustomElementUtils.getElementBridge(this);if(!n.SaveEarlyPropertySet(this,t,e)&&!n._setEventProperty(this,t,e)&&!n._validateAndSetCopyProperty(this,t,e,null)){var i=u.getPropertyMetadata(t,d.getElementProperties(this));i?(n._setOption(t,e,i,this),n.State.dirtyProps.add(t.split(".")[0])):this[t]=e}},t.getProperty=function(t){var e=p.CustomElementUtils.getElementBridge(this),n=u.getPropertyMetadata(t,d.getElementProperties(this));if(e._deliverPropertyUpdates(this),p.AttributeUtils.isEventListenerProperty(t)||!n)return this[t];var i=n?n.extension:null;return i&&i._COPY_TO_INNER_ELEM?e._getCopyProperty(this,t,n):H._getPropertyAccessor(this,t)()},t.focus=function(){var t=p.CustomElementUtils.getElementBridge(this);if(t._WIDGET_INSTANCE){var e=t._WIDGET_INSTANCE.__getFocusElement();e&&(e!==this?e.focus():HTMLElement.prototype.focus.call(this))}else HTMLElement.prototype.focus.call(this)},t.blur=function(){var t=p.CustomElementUtils.getElementBridge(this);if(t._WIDGET_INSTANCE){var e=t._WIDGET_INSTANCE.__getFocusElement();e&&(e!==this?e.blur():HTMLElement.prototype.blur.call(this))}else HTMLElement.prototype.blur.call(this)}},BatchedPropertySet:function(t,e){var n,i=Object.keys(e),o={};for(n=0;n<i.length;n++){var s=i[n],r=e[s];this._setEventProperty(t,s,r)||this._validateAndSetCopyProperty(t,s,r,null)||(r=this.ValidatePropertySet(t,s,r),o[s=this.GetAliasForProperty(s)]=r)}var a=O.__GetWidgetConstructor(this._WIDGET_ELEM);if(a)a("option",o);else for(n=0;n<i.length;n++){var l=i[n];t.setProperty(l,e[l])}},CreateComponent:function(t){var e=this._INNER_DOM_FUNCTION;if(this._WIDGET_ELEM=H._getWidgetElement(t,e?e(t):this._EXTENSION._INNER_ELEM),this._WIDGET_ELEM!==t){for(var n=this._EXTENSION._GLOBAL_TRANSFER_ATTRS||[],i=0;i<n.length;i++){var o=n[i];t.hasAttribute(o)&&(this._WIDGET_ELEM.setAttribute(o,t.getAttribute(o)),this._removingTransfer=!0,t.removeAttribute(o))}this._copyProperties()}O.unmarkPendingSubtreeHidden(t);var s=a(this._WIDGET_ELEM),r=a(this._WIDGET_ELEM)[this._EXTENSION._WIDGET_NAME].bind(s);r(this._PROPS),this._WIDGET=r,this._WIDGET_INSTANCE=r("instance"),this._WRITEBACK_PROPS&&this._WIDGET_INSTANCE.__saveWritebackOptions(this._WRITEBACK_PROPS),this._setupFocusPropagation(t)},DefineMethodCallback:function(t,e,n){t[e]=function(){var t=p.CustomElementUtils.getElementBridge(this),i=n.internalName||e;t._deliverPropertyUpdates(this),p.CustomElementUtils.allowSlotRelocation(!0);try{return t._WIDGET.apply(null,[i].concat([].slice.call(arguments)))}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}},DefinePropertyCallback:function(t,e,n){var i=n.extension;Object.defineProperty(t,e,{enumerable:!0,get:function(){var t=p.CustomElementUtils.getElementBridge(this);return t._deliverPropertyUpdates(this),n._eventListener?t.GetEventListenerProperty(e):i&&i._COPY_TO_INNER_ELEM?t._getCopyProperty(this,e,n):H._getPropertyAccessor(this,e)()},set:function(t){const i=p.CustomElementUtils.getElementBridge(this);if(!i.SaveEarlyPropertySet(this,e,t)){t=p.transformPreactValue(this,n,t);"preact"===p.CustomElementUtils.getElementState(this).getBindingProviderType()?this._isUpdateQueued?this._propertyUpdates[e]=t:(this._isUpdateQueued=!0,this._propertyUpdates={},this._propertyUpdates[e]=t,window.queueMicrotask(()=>{i._deliverPropertyUpdates(this)})):n._eventListener?i.SetEventListenerProperty(this,e,t):i._validateAndSetCopyProperty(this,e,t,n)||(i._setOption(e,t,n,this),i.State.dirtyProps.add(e))}}})},GetAttributes:function(t){var e=u.getFlattenedAttributes(t.properties);return t.extension._GLOBAL_TRANSFER_ATTRS&&(e=e.concat(t.extension._GLOBAL_TRANSFER_ATTRS)),t.extension._WATCHED_ATTRS&&(e=e.concat(t.extension._WATCHED_ATTRS)),e},GetAliasForProperty:function(t){var e=this._EXTENSION._ALIASED_PROPS;return e&&e[t]?e[t]:t},InitializeElement:function(t){r.BaseCustomElementBridge.proto.InitializeElement.call(this,t),this._EXTENSION._CONTROLS_SUBTREE_HIDDEN&&O.markPendingSubtreeHidden(t),r.BaseCustomElementBridge.__InitProperties(t,this._PROPS)},HandleAttributeChanged:function(t,e,n,i){var o=this._EXTENSION._GLOBAL_TRANSFER_ATTRS,s=o&&-1!==o.indexOf(e),r=this._EXTENSION._WATCHED_ATTRS,a=r&&-1!==r.indexOf(e);s&&this._WIDGET_ELEM?this._removingTransfer?this._removingTransfer&&(this._removingTransfer=!1):(this._WIDGET_ELEM.setAttribute(e,i),this._removingTransfer=!0,t.removeAttribute(e)):a&&n!==i&&this._WIDGET_INSTANCE&&this._WIDGET_INSTANCE.__handleWatchedAttribute(e,n,i)},HandleDetached:function(t){r.BaseCustomElementBridge.proto.HandleDetached.call(this,t),O.__GetWidgetConstructor(this._WIDGET_ELEM)&&this._WIDGET_INSTANCE&&this._WIDGET_INSTANCE.__handleDisconnected(),this._teardownFocusPropagation(t)},HandleReattached:function(t){r.BaseCustomElementBridge.proto.HandleReattached.call(this,t),this._setupFocusPropagation(t),this._WIDGET_INSTANCE&&this._WIDGET_INSTANCE.__handleConnected()},initializeBridge:function(t,e){r.BaseCustomElementBridge.proto.initializeBridge.call(this,t,e),this._INNER_DOM_FUNCTION=e.innerDomFunction,this._EXTENSION=this.METADATA.extension||{},this._PROPS=this._EXTENSION._INNER_ELEM||this._INNER_DOM_FUNCTION?{_wrapper:t}:{},this._setupPropertyAccumulator(t,this._PROPS),this._processProperties(t)},_setOption:function(t,e,n,i){let o={};if(void 0===e&&-1===t.indexOf(".")&&(o={_context:{skipEvent:!0}},e=u.getDefaultValue(n),this.State.isComplete())){const e=i[t];r.BaseCustomElementBridge.__FirePropertyChangeEvent(i,t,void 0,e,"external")}H._getPropertyAccessor(i,t,o)(e)},_copyProperties:function(){if(this._COPY_ATTRS)for(var t=0;t<this._COPY_ATTRS.length;t++){var e=this._COPY_ATTRS[t],n=p.AttributeUtils.attributeToPropertyName(e);if(Object.prototype.hasOwnProperty.call(this._PROPS,n)){var i=this._PROPS[n];this._setCopyProperty(e,i),delete this._PROPS[n]}}},_deliverPropertyUpdates:function(t){if(t._isUpdateQueued){t._isUpdateQueued=!1;try{this.SetProperties(t,t._propertyUpdates,!0)}finally{t._propertyUpdates=void 0}}},_getCopyProperty:function(t,e,n){var i=p.AttributeUtils.propertyNameToAttribute(e);if(n.extension._ATTRIBUTE_ONLY){if(this._WIDGET_ELEM.hasAttribute(i)){var o=this._WIDGET_ELEM.getAttribute(i);return p.AttributeUtils.attributeToPropertyValue(t,i,o,n)}return null}return this._WIDGET_ELEM[e]},_processProperties:function(t){var e=d.getElementProperties(t);if(e)for(var n=Object.keys(e),i=0;i<n.length;i++){var o=n[i],s=e[o];s.writeback&&(this._WRITEBACK_PROPS||(this._WRITEBACK_PROPS={}),this._WRITEBACK_PROPS[o]=!0);var r=s.extension;r&&r._COPY_TO_INNER_ELEM&&(this._COPY_ATTRS||(this._COPY_ATTRS=[]),this._COPY_ATTRS.push(o))}},_setCopyProperty:function(t,e){null==e||!1===e?this._WIDGET_ELEM.removeAttribute(t):!0===e?this._WIDGET_ELEM.setAttribute(t,""):this._WIDGET_ELEM.setAttribute(t,e)},_setupPropertyAccumulator:function(t,e){this._WIDGET=function(n,i,o){if("option"===n)return r.BaseCustomElementBridge.__SetProperty(this.GetAliasForProperty.bind(this),e,i,o),e[i];throw new p.JetElementError(t,"Cannot access methods before element is upgraded.")}},_validateAndSetCopyProperty:function(t,e,n,i){var o=p.AttributeUtils.propertyNameToAttribute(e),s=this._COPY_ATTRS&&-1!==this._COPY_ATTRS.indexOf(o);if(s)if(n=this.ValidatePropertySet(t,e,n),this._WIDGET_ELEM){i||(i=u.getPropertyMetadata(e,d.getElementProperties(t)));var a=this._getCopyProperty(t,e,i);this._setCopyProperty(o,n),r.BaseCustomElementBridge.__FirePropertyChangeEvent(t,e,this._getCopyProperty(t,e,i),a,"external")}else this._PROPS[o]=n;return s},_setEventProperty:function(t,e,n){var i=p.AttributeUtils.isEventListenerProperty(e);return i&&(t[e]=n),i},_setupFocusPropagation:function(t){const e=this._WIDGET_INSTANCE.__getFocusElement();if(e&&e!==t){const n=k(t,"focus"),i=k(t,"blur");e.addEventListener("focus",n),e.addEventListener("blur",i),this._teardownFocus=function(t,e,n){return function(){t.removeEventListener("focus",e),t.removeEventListener("blur",n)}}(e,n,i)}},_teardownFocusPropagation:function(){this._teardownFocus&&(this._teardownFocus(),this._teardownFocus=null)}}),H.getMetadata=function(t){return H._METADATA_MAP[t.toLowerCase()]},H.isKnownEvent=function(t,e){var n=p.CustomElementUtils.getElementBridge(t);return null!=(n.METADATA.events&&n.METADATA.events[e])},H.isKnownProperty=function(t,e){var n=p.CustomElementUtils.getElementBridge(t);return null!=(n.METADATA.properties&&n.METADATA.properties[e])},H.getPropertyForAlias=function(t,e){var n=p.CustomElementUtils.getElementBridge(t)._EXTENSION._COMPONENT_TO_ELEMENT_ALIASES;return n&&n[e]?n[e]:e},H.register=function(t,e){var n=e[r.BaseCustomElementBridge.DESC_KEY_META];n=r.BaseCustomElementBridge.__ProcessEventListeners(n),e[r.BaseCustomElementBridge.DESC_KEY_META]=n,H._METADATA_MAP[t.toLowerCase()]=n;var i=n.extension,o=i&&i._WIDGET_NAME?H.proto:Y.proto;const s=i&&i._WIDGET_NAME?W:p.ElementState;var a=i._ALIASED_PROPS;a&&(i._COMPONENT_TO_ELEMENT_ALIASES={},Object.keys(a).forEach(function(t){i._COMPONENT_TO_ELEMENT_ALIASES[a[t]]=t}));const l={descriptor:e,bridgeProto:o,stateClass:s};d.registerElement(t,l,o.getClass(e))},H._getPropertyAccessor=function(t,e,n){return function(i){var o=p.CustomElementUtils.getElementBridge(t);return 1===arguments.length?(i=o.ValidatePropertySet(t,e,i),e=o.GetAliasForProperty(e),void o._WIDGET("option",e,i,n)):(e=o.GetAliasForProperty(e),o._WIDGET("option",e))}.bind(t)},H._getWidgetElement=function(t,e){var n=t;if(e){var i=t.firstElementChild;if(i&&i.tagName.toLowerCase()===e)n=i;else{n=document.createElement(e);for(var o=[],s=t.childNodes,r=0;r<s.length;r++)o.push(s[r]);for(t.appendChild(n);o.length;){var a=o.shift();p.CustomElementUtils.getSlotAssignment(a)||n.appendChild(a)}}n.setAttribute("data-oj-internal","")}return n},H._METADATA_MAP={};class F{static isDataProvider(t){return!(!t||!t.fetchFirst)}static isTreeDataProvider(t){return!(!t||!t.getChildDataProvider)}}c._registerLegacyNamespaceProp("DataProviderFeatureChecker",F);var V="translations",X=V+".";const K="oj-disabled",z="start bottom";var q,J,$,Q={isDefaultPrevented:function(){return!1},preventDefault:function(){this.isDefaultPrevented=it},stopPropagation:function(){this.isPropagationStopped=it},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=it}};function Z(t,e,n,i,o,s,r){var a=n,l=!1,u={};delete i[o],Object.defineProperty(i,o,{get:function(){if(l)return a;if(null!=t._settingNestedKey)return a;var n=s(r?r():o);return et([e,n,a],u)},set:function(e){a=e,null!=t._settingNestedKey?u[t._settingNestedKey]=!0:l=!0},enumerable:!0})}function tt(t){if(1===t.length){var e=t[0];return e instanceof j?e.getCallback():null}for(var n=!1,i=0;i<t.length&&!n;i++){var o=t[i];null!=o&&o instanceof j&&(n=!0)}return n?function(e){var n=[];return t.forEach(function(t){null!=t&&t instanceof j?n.push(t.getCallback()(e)):n.push(t)}),et(n)}:null}function et(t,e){for(var n,i=0;i<t.length;i++){var o=t[i];if(void 0!==o)if(a.isPlainObject(o))n=nt({},a.isPlainObject(n)?[n,o]:[o],i===t.length-1?null:e,null);else n=o}return n}function nt(t,e,n,i){for(var o=e.length,s=0;s<o;s++)for(var r=e[s],l=Object.keys(r),u=0;u<l.length;u++){var c,_=l[u];if(c=null==n?null:null==i?_:i+"."+_,null==n||!n[c]){var h=r[_];if(void 0!==h)if(a.isPlainObject(h)){var p=a.isPlainObject(t[_])?[t[_],h]:[h];t[_]=nt({},p,n,c)}else t[_]=h}}return t}function it(){return!0}function ot(t){return t.getAttribute&&t.getAttribute("class")||""}J="baseComponent",a.widget("oj."+J,{options:{contextMenu:null,rootAttributes:null,optionChange:void 0,destroy:void 0},refresh:function(){this._propertyContext=null,this._SetupContextMenu()},_createWidget:function(t,e){t&&(this.OuterWrapper=t._wrapper),this._originalDefaults=this.options||{},this._constructorOptions=t||{},this._super(t,e),this._AfterCreateEvent()},_SetRootAttributes:function(){var t=this.options.rootAttributes;if(t){var e=this.widget();if(null==e)return;var n=t.class;n&&e.addClass(n),t.style&&E.error("The rootAttributes.style option violates the recommended\n          Content Security Policy which disallows inline styles and is therefore ignored.\n          Use the rootAttributes.class option instead."),delete(t=a.extend({},t)).class,delete t.style,e.attr(t),delete t.id;var i=Object.keys(t);if(i.length)throw new Error("Unsupported values passed to rootAttributes option: "+i.toString())}},_create:function(){this._SaveAttributes(this.element),this._InitOptions(this._originalDefaults,this._constructorOptions),delete this._originalDefaults,delete this._constructorOptions,this._ComponentCreate(),this._AfterCreate(),this._SetupResources(),this.element.addClass(P)},_InitOptions:function(t,e){this._setupDefaultOptions(t,e),this._initContextMenuOption(e)},_ComponentCreate:function(){var t,e,n;t=this.element,e=this.widgetName,(n=t.data(b))||(n=[],t.data(b,n)),n.indexOf(e)<0&&n.push(e),this.activeableEventNamespace=this.eventNamespace+"activeable",this.hoverableEventNamespace=this.eventNamespace+"hoverable"},_AfterCreate:function(){this._SetRootAttributes(),this.contextMenuEventNamespace=this.eventNamespace+"contextMenu",this.activeableEventNamespace=this.eventNamespace+"activeable",this.hoverableEventNamespace=this.eventNamespace+"hoverable"},_AfterCreateEvent:a.noop,_setOptionClasses:function(){},_setOptionDisabled:function(){},_classes:function(){return""},_removeClass:function(){return this},_addClass:function(){return this},_toggleClass:function(){return this},_SaveAttributes:function(t){},_SaveAllAttributes:function(t){var e=this;this._savedAttributes=[],a.each(t,function(t,n){var i={},o={element:n,attributes:i},s=n.attributes;e._savedAttributes.push(o),a.each(s,function(t,e){var n=e.name;i[n]={attr:e.value}})})},_GetSavedAttributes:function(t){var e=this._savedAttributes;if(void 0===e)return null;for(var n=t[0],i=0,o=e.length;i<o;i++){var s=e[i];if(s.element===n)return s.attributes}return{}},_RestoreAttributes:function(){},_RestoreAllAttributes:function(){a.each(this._savedAttributes,function(t,e){var n=a(e.element),i=e.attributes;if(1===n.length){var o,s,r=e.element.attributes,l=[];for(o=0,s=r.length;o<s;o++)r[o].name in i||l.push(r[o].name);for(o=0,s=l.length;o<s;o++)"style"===l[o]?n[0].style=null:n.removeAttr(l[o]);var u=Object.keys(i);for(o=0;o<u.length;o++){var c=u[o];"style"===c&&""===i[c].attr?n[0].style=null:n.attr(c,i[c].attr)}}})},_GetTranslationsSectionName:function(){return this.widgetFullName},_CompareOptionValues:function(t,e,n){return this._IsCustomElement()&&this._getWritebackOption(t)?r.Object.compareValues(e,n):e===n},getTranslatedString:function(t,e){var n={};arguments.length>2?n=Array.prototype.slice.call(arguments,1):2===arguments.length&&("object"==typeof(n=arguments[1])||n instanceof Array||(n=[n]));var i=this.option(X+t);return null==i?t:g.applyParameters(i.toString(),n)},getNodeBySubId:function(t){return null!=t&&null!=t.subId||!this.element?null:this.element[0]},getSubIdByNode:function(t){return null},destroy:function(){if(this._IsCustomElement())throw new Error("destroy cannot be called on a custom element");this._trigger("destroy"),_.dispatchEvent(this.element[0],new CustomEvent("_ojDestroy")),this._ReleaseResources(),this._super(),this.element.removeClass(P),this.widget().removeClass(K),this._removeStateClasses(this.element),function(t,e){var n=t.data(b);if(n){var i=n.indexOf(e);i>=0&&(n.splice(i,1),0===n.length&&t.removeData(b))}}(this.element,this.widgetName),this._RestoreAttributes(),this._initialCmDomAttr?this.element.attr("contextmenu",this._initialCmDomAttr):this.element.removeAttr("contextmenu"),this._propertyContext=null},option:function(t,e){if(0===arguments.length)return a.widget.extend({},this.options);var n,i=arguments[0],o=i,s=null,r={};if("string"==typeof i){o={};var l=i.split(".");if(i=l.shift(),l.length){var u;s=l.join(".");try{arguments.length>1&&(this._settingNestedKey=s),u=a.widget.extend({},this.options[i]),o[i]=u}finally{this._settingNestedKey=null}for(n=0;n<l.length-1;n++)u[l[n]]=u[l[n]]||{},u=u[l[n]];if(i=l.pop(),1===arguments.length)return void 0===u[i]?null:u[i];u[i]=e}else{if(1===arguments.length)return void 0===this.options[i]?null:this.options[i];o[i]=e}r=arguments[2]||r}else r=arguments[1]||r;if(null!=s){var c={path:t,value:e};r=a.widget.extend({},r,{subkey:s,subproperty:c})}var _=r?r._context:null,h=!!_&&_.internalSet,d={},f=Object.keys(o);for(n=0;n<f.length;n++){var g=f[n],m=o[g],v=this.options[g];r&&r.changed||!this._CompareOptionValues(g,v,m)?d[g]=m:this._IsCustomElement()&&E.info(p.CustomElementUtils.getElementInfo(this.element[0])+": Ignoring property set for property '"+g+"' with same value.")}if(Object.keys(d).length>0){p.CustomElementUtils.allowSlotRelocation(!0);try{h?this._internalSetOptions(d,r):this._setOptions(d,r)}finally{p.CustomElementUtils.allowSlotRelocation(!1)}}return this},_internalSetOptions:function(t,e){for(var n=Object.keys(t),i=0;i<n.length;i++){var o=n[i],s=t[o],r=this.options[o];this.options[o]=s,this._optionChanged(o,s,r,e)}},_setOptions:function(t,e){p.CustomElementUtils.allowSlotRelocation(!0);try{for(var n=Object.keys(t),i=0;i<n.length;i++){var o=n[i],s=t[o];this._setOption(o,s,e)}}finally{p.CustomElementUtils.allowSlotRelocation(!1)}return this},_setOption:function(t,e,n){var i=this.options[t];if("disabled"===t)this.options[t]=e,this.widget().toggleClass(K,!!e).attr("aria-disabled",e),e&&this._removeStateClasses(this.widget());else{try{var o=null==n?null:n.subkey;null!=o&&(this._settingNestedKey=o),this._super(t,e)}finally{this._settingNestedKey=null}"contextMenu"===t&&this._SetupContextMenu()}return this._optionChanged(t,e,i,n),this},_optionChanged:function(t,e,n,i){var o,s=null,r=!1,l=!1,u=null,c="external",_=null;if(i&&(s=i._context)){if(s.skipEvent)return;u=s.originalEvent,r=void 0===s.writeback?null!=u:s.writeback,l=s.readOnly,_=s.optionMetadata,o=s.extraData,s.internalSet&&(c="internal")}(_=_||{}).writeback=r?"shouldWrite":"shouldNotWrite",l&&(_.readOnly=!0);var h={option:t,previousValue:n,value:e,optionMetadata:_,updatedFrom:c},p=null==i?null:i.subkey;if(p){var d=p.split("."),E=n;d.forEach(function(t){E&&(E=E[t])});var f=i.subproperty;f.previousValue=E,h.subproperty=f}null!=o&&(h=a.extend({},o,h)),this._trigger("optionChange",u,h)},_SetupResources:function(){this._SetupContextMenu()},_ReleaseResources:function(){this._ReleaseContextMenu()},_trigger:function(t,e,n){return this._trigger2(t,e,n).proceed},_trigger2:function(t,e,n){var i=n||{};if(this._IsCustomElement())return this._triggerCustomEvent(t,e,i);var o=this.options[t],s=a.Event(e,Q);return s.type=(this.widgetEventPrefix+t).toLowerCase(),s.target=this.element[0],this.element.trigger(s,i),{proceed:!(a.isFunction(o)&&!1===o.apply(this.element[0],[s].concat(i))||s.isDefaultPrevented()),event:s}},_triggerCustomEvent:function(t,e,n){var i,o,s,r={},l=this._getRootElement();if("optionChange"===t){var u=H.getPropertyForAlias(l,n.option);if(!H.isKnownProperty(l,u))return{proceed:!0,event:null};i=p.AttributeUtils.propertyNameToChangeEventType(u);for(var c=Object.keys(n),_=0;_<c.length;_++){var h=c[_];if("option"!==h)if("optionMetadata"===h)for(var d=Object.keys(n[h]),E=0;E<d.length;E++){var f=d[E];"writeback"!==f&&"component"!==f&&(r[f]=n[h][f])}else r[h]=n[h]}}else{if(i=p.AttributeUtils.eventTriggerToEventType(t),!H.isKnownEvent(l,i))return{proceed:!0,event:null};o=!0,s=!0,r=this._resolveJQueryObjects(n)}e&&(r.originalEvent=e instanceof a.Event?e.originalEvent:e);var g={detail:r};o&&(g.bubbles=!0),s&&(g.cancelable=!0);var m=new CustomEvent(i,g);return l.dispatchEvent(m),{proceed:!m.defaultPrevented,event:m}},_resolveJQueryObjects:function(t){for(var e=r.CollectionUtils.copyInto({},t),n=Object.keys(e),i=0;i<n.length;i++){var o=n[i],s=e[o];s&&s instanceof a&&(0===s.length?e[o]=null:1===s.length?e[o]=s[0]:e=s.toArray())}return e},_initContextMenuOption:function(t){var e=this.element.attr("contextmenu");this._initialCmDomAttr=e,e&&!("contextMenu"in t)&&this.option("contextMenu",document.getElementById(e),{_context:{internalSet:!0}})},_handleContextMenuGesture:function(t,e,n){if(!this._IsEffectivelyDisabled()){var i;if("OJ-MENU"===t.tagName)i=t;else{var o=O.__GetWidgetConstructor(t,"ojMenu");if(!(i=o&&o("instance")))throw new Error("Invalid JET Menu.")}this._NotifyContextMenuGesture(i,e,n),a(t).is(":visible")&&e.preventDefault()}},_SetupContextMenu:function(){var t=this._GetContextMenu();if(t||(t=this._GetDefaultContextMenu()),t&&void 0===this._contextMenuGestureInit){this._contextMenuGestureInit=t;var e=this;v.startDetectContextMenuGesture(this.widget()[0],function(n,i){e._handleContextMenuGesture(t,n,i)})}},_ReleaseContextMenu:function(){this._contextMenuGestureInit=void 0,v.stopDetectContextMenuGesture(this.widget()[0])},_GetContextMenu:function(){if(this._IsCustomElement()){var t=p.CustomElementUtils.getSlotMap(this._getRootElement()).contextMenu;if(t&&t.length>0)return t[0]}else if(this.options.contextMenu)return a(this.options.contextMenu).first()[0];return null},_NotifyContextMenuGesture:function(t,e,n){this._OpenContextMenu(e,n)},_OpenContextMenu:function(t,e,n,i,o){var s=this._GetContextMenu();if(s||(s=this._contextMenuGestureInit&&a(this._contextMenuGestureInit).is(":visible")?this._contextMenuGestureInit:this._GetDefaultContextMenu()),s){var r={mouse:{my:"start top",at:z,of:t,collision:"flipfit"},touch:{my:"start>40 center",at:z,of:t,collision:"flipfit"},keyboard:{my:"start top",at:z,of:"launcher",collision:"flipfit"}},l={launcher:this.element,position:r[e]},u={initialFocus:"menu"},c=o?a.extend(l,n,u):a.extend(!0,l,n,u);if(s.__openingContextMenu=!0,"OJ-MENU"===s.tagName)s.open(t,c,i);else{var _=O.__GetWidgetConstructor(s,"ojMenu");(_&&_("instance")).open(t,c,i);var h=function(t){t.preventDefault()};s.addEventListener("contextmenu",h),window.setTimeout(function(){s.removeEventListener("contextmenu",h)},50)}s.__openingContextMenu=!1}},_GetDefaultContextMenu:function(){return null},_removeStateClasses:function(t){t.removeClass("oj-hover oj-focus oj-focus-highlight oj-active"),t.find(".oj-hover").removeClass("oj-hover"),t.find(".oj-focus").removeClass("oj-focus"),t.find(".oj-focus-highlight").removeClass("oj-focus-highlight"),t.find(".oj-active").removeClass("oj-active")},_isRealMouseEvent:function(){return!_.recentTouchEnd()},_AddHoverable:function(t){var e;a.isPlainObject(t)?e=t.element:(e=t,t={});var n=t.afterToggle||a.noop;e.on("mouseenter"+this.hoverableEventNamespace,this._hoverStartHandler.bind(this,n)).on("mouseleave"+this.hoverableEventNamespace,this._hoverAndActiveEndHandler.bind(this,"oj-hover",n))},_RemoveHoverable:function(t){t&&t.off(this.hoverableEventNamespace)},_AddActiveable:function(t){var e;a.isPlainObject(t)?e=t.element:(e=t,t={});var n=t.afterToggle||a.noop,i="oj-active";_.isTouchSupported()&&(e[0]&&(this._touchstartListener=this._activeStartHandler.bind(this,n),e[0].addEventListener("touchstart",this._touchstartListener,{passive:!0})),e.on("touchend"+this.activeableEventNamespace+" touchcancel"+this.activeableEventNamespace,this._hoverAndActiveEndHandler.bind(this,i,n))),e.on("mousedown"+this.activeableEventNamespace,this._activeStartHandler.bind(this,n)).on("mouseup"+this.activeableEventNamespace,this._hoverAndActiveEndHandler.bind(this,i,n)).on("mouseenter"+this.activeableEventNamespace,this._activeStartHandler.bind(this,n)).on("mouseleave"+this.activeableEventNamespace,this._hoverAndActiveEndHandler.bind(this,i,n))},_RemoveActiveable:function(t){t&&(t[0]&&(t[0].removeEventListener("touchstart",this._touchstartListener,{passive:!0}),delete this._touchstartListener),t.off(this.activeableEventNamespace),q=null)},_activeStartHandler:function(t,e){var n=a(e.currentTarget);("mouseenter"!==e.type||this._isTargetInActiveElement(e.currentTarget))&&(n.hasClass(K)||"touchstart"!==e.type&&!this._isRealMouseEvent(e)||(n.addClass("oj-active"),t(e.type),"mousedown"===e.type&&(q=e.currentTarget,this.document.one("mouseup",function(){q=null}))))},_hoverStartHandler:function(t,e){var n=a(e.currentTarget);!n.hasClass(K)&&this._isRealMouseEvent(e)&&(n.addClass("oj-hover"),t(e.type))},_hoverAndActiveEndHandler:function(t,e,n){("oj-active"!==t||"mouseleave"!==n.type||this._isTargetInActiveElement(n.currentTarget))&&(a(n.currentTarget).removeClass(t),e(n.type))},_isTargetInActiveElement:function(t){return q===t||null!=q&&a.contains(q,t)},_hoverable:function(){},_focusable:function(t){a.isPlainObject(t)||(t={element:t}),t.component=this,_.makeFocusable(t)},_UnregisterChildNode:function(t){if(t){a(t).off(this.eventNamespace);var e=this.bindings;e&&(this.bindings=a(e.not(t)))}},_GetReadingDirection:function(){return _.getReadingDirection()},_NotifyAttached:function(){this._propertyContext=null},_NotifyDetached:function(){this._propertyContext=null,this._removeStateClasses(this.widget())},_NotifyInitShown:function(){},_NotifyShown:function(){},_NotifyHidden:function(){},_IsEffectivelyDisabled:function(){return!(!this.options.disabled&&!this._ancestorDisabled)},__setAncestorComponentDisabled:function(t){this._ancestorDisabled=t},_getTranslationSectionLoader:function(){var t=[],e=this,n=0;this._traverseWidgetHierarchy(function(i){var o=0===n?e._GetTranslationsSectionName():i.widgetFullName;n+=1;var s=g.getComponentTranslations(o);null==s||a.isEmptyObject(s)||t.push(o)});var i=t.length;return i>0?function(){if(1===i)return g.getComponentTranslations(t[0]);for(var e={},n=i-1;n>=0;n--)a.widget.extend(e,g.getComponentTranslations(t[n]));return e}:null},_getDynamicPropertyContext:function(){if(!this._propertyContext){var t={};this._propertyContext=t;var e=this.element[0];t.containers=function(t){for(var e=t,n=[];e;){var i=e.getAttribute,o=i?i.call(e,O._OJ_CONTAINER_ATTR):null;null!=o&&n.push(o),e=e.parentNode}return n}(e),t.element=e,t.isCustomElement=this._IsCustomElement(),t.isCustomElement&&(t.customElement=this._getRootElement())}return this._propertyContext},_setupDefaultOptions:function(t,e){var n=this.options,i=this._getTranslationSectionLoader(),o=e[V];null==i||void 0!==o&&!a.isPlainObject(o)||Z(this,void 0,e[V],n,V,i),this._loadGlobalDefaultOptions(t,e)},_loadGlobalDefaultOptions:function(t,e){var n=this.options,i=[];this._traverseWidgetHierarchy(function(t){i.push(t.widgetName)}),i.push("default");var o=O.__getDefaultOptions(i);if(!a.isEmptyObject(o))for(var s=this,r=function(){return s._getDynamicPropertyContext()},l=Object.keys(o),u=0;u<l.length;u++){var c=l[u],_=e[c];if(void 0===_||a.isPlainObject(_)){var h=o[c];if(h){var p=tt(h);if(p)Z(this,t[c],_,n,c,p,r);else{var d=[t[c]].concat(h);d.push(_),n[c]=et(d)}}}}},_traverseWidgetHierarchy:function(t){for(var e=this.constructor.prototype;null!=e&&"oj"===e.namespace;)t(e),e=Object.getPrototypeOf(e)},_getRootElement:function(){return this.OuterWrapper||this.element[0]},_IsCustomElement:function(){return d.isElementRegistered(this._getRootElement().tagName)},_GetThrottlePromise:function(){if(this._IsCustomElement()){var t=this._getRootElement();return p.CustomElementUtils.getElementBridge(t).getThrottlePromise()}return Promise.resolve(null)},_FixRendererContext:function(t){if(this._IsCustomElement()){var e=r.CollectionUtils.copyInto({},t);return delete e.component,e.componentElement=this._getRootElement(),e}return t},_GetCustomElement:function(){return this._getRootElement()},_WrapCustomElementRenderer:function(t){return this._IsCustomElement()&&"function"==typeof t?function(e){var n=t(e);return n&&n.insert?n.insert:null}:t},__saveWritebackOptions:function(t){this._writebackOptions=t},_getWritebackOption:function(t){return!(!this._writebackOptions||!this._writebackOptions[t])},__handleSubtreeAttached:function(){this._IsCustomElement()||this._NotifyAttached()},__handleSubtreeDetached:function(){this._IsCustomElement()||this._NotifyDetached()},_VerifyConnectedForSetup:function(){return!1},__handleConnected:function(){this._NotifyAttached(),this.__delayConnectDisconnect(0)||this._SetupResources()},__handleDisconnected:function(){this.__delayConnectDisconnect(1)||this._ReleaseResources(),this._NotifyDetached()},__delayConnectDisconnect:function(t){return!!this._VerifyConnectedForSetup()&&(void 0===this.connectedState&&window.queueMicrotask(function(){this.connectedState===t&&(0===t?this._SetupResources():this._ReleaseResources()),this.connectedState=void 0}.bind(this)),this.connectedState=t,!0)},__handleWatchedAttribute:function(t,e,n){this._WatchedAttributeChanged(t,e,n)},_WatchedAttributeChanged:function(t,e,n){},__getFocusElement:function(){return this.GetFocusElement()},GetFocusElement:function(){return this.element[0]}}),delete a.fn[J],r.__registerWidget=function(t,e,n,i){if(a.widget(t,e,n),i){var o=t.split(".")[1];delete a.fn[o]}if("oj.oj"===t.substring(0,5)||"oj._oj"===t.substring(0,6)){var s,r=t.split("."),l=r[0],u=r[1],c=l+"-"+u;s="_"===u.substring(0,1)?"_"+l+"-"+u.substring(3):l+"-"+u.substring(2),a.expr.pseudos[s.toLowerCase()]=function(t){return!!a.data(t,c)}}},a.cleanData=($=a.cleanData,function(t){const e=[],n=[];for(var i=0;i<t.length;i++){var o=t[i];if(null==o)break;var s=!1,r=O.__GetWidgetConstructor(o);if(r&&!(s=r("instance")._IsCustomElement())){var a=O.getComponentElementByNode(o);s=a&&d.isElementRegistered(a.tagName)}s?o.$$cleanElement&&n.push(o):e.push(o)}e.length>0&&$(e),n.forEach(t=>t.$$cleanElement())}),a.fn.addClass=function(t){if("function"==typeof t)return this.each(function(e){a(this).addClass(t.call(this,e,ot(this)))});const e=Array.isArray(t)?t:p.CustomElementUtils.getClassSet(t);return this.each(function(){1===this.nodeType&&this.classList.add(...e)}),this},a.fn.removeClass=function(t){if("function"==typeof t)return this.each(function(e){a(this).removeClass(t.call(this,e,ot(this)))});if(!arguments.length)return this.attr("class","");const e=Array.isArray(t)?t:p.CustomElementUtils.getClassSet(t);return this.each(function(){1===this.nodeType&&this.classList.remove(...e)}),this};const st={};r._registerLegacyNamespaceProp("Test",st),st.ready=!1,st.domNodeForLocator=function(t){var e=t;if(r.StringUtils.isString(t)){var n=t;try{e=JSON.parse(n)}catch(t){return null}}if(e&&e.element){var i=a(e.element);if(i&&i.length>0){delete e.element;var o=e;return O.getNodeBySubId(i[0],o)}}return null},st.getOpenPopupCount=function(){return r.ZOrderUtils.getOpenPopupCount()},st.findOpenPopups=function(){return r.ZOrderUtils.findOpenPopups()},st.compareStackingContexts=function(t,e){return r.ZOrderUtils.compareStackingContexts(t,e)};const rt=O.subtreeAttached,at=O.subtreeDetached,lt=O.subtreeHidden,ut=O.subtreeShown,ct=O.createDynamicPropertyGetter,_t=O.setDefaultOptions,ht=O.getDefaultOptions,pt=O.__GetWidgetConstructor,dt=O.setComponentOption,Et=O.getComponentOption,ft=O.getWidgetConstructor,gt=O.isComponentInitialized,mt=O.markPendingSubtreeHidden,vt=O.unmarkPendingSubtreeHidden,yt=O.__getDefaultOptions,Tt=O.getComponentElementByNode,Ct=O.getSubIdByNode,St=O.getNodeBySubId,At=O.callComponentMethod,Nt=O._OJ_CONTAINER_ATTR;t.DataProviderFeatureChecker=F,t._OJ_CONTAINER_ATTR=Nt,t.__GetWidgetConstructor=pt,t.__getDefaultOptions=yt,t.callComponentMethod=At,t.createDynamicPropertyGetter=ct,t.getComponentElementByNode=Tt,t.getComponentOption=Et,t.getDefaultOptions=ht,t.getNodeBySubId=St,t.getSubIdByNode=Ct,t.getWidgetConstructor=ft,t.isComponentInitialized=gt,t.markPendingSubtreeHidden=mt,t.setComponentOption=dt,t.setDefaultOptions=_t,t.subtreeAttached=rt,t.subtreeDetached=at,t.subtreeHidden=lt,t.subtreeShown=ut,t.unmarkPendingSubtreeHidden=vt,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojcomponentcore.js.map