/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojobservable","ojs/ojurlpathadapter","ojs/ojlogger"],function(t,e,r){"use strict";let o,i;e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e;let s=[],n=[];var a=function(){let t=o;const e=[];for(;t;){let r=t._activeState;if(!r){r=t._getPendingState({path:""}),r&&e.push(r);break}e.push({path:r.path||"",params:r.params,pathParams:r.pathParams}),t=t.childRouter}return e};const h=/^{(\w+)}$/;function c(t){const e=t.match(h);if(e)return e[1];throw Error(`no path parameter found for segment ${t}`)}function u(r,s,n){if(s=s||{},this._name="/",this._urlOffset=0,this.beforeStateChange=new t.BehaviorSubject({accept:function(){}}),this.currentState=new t.BehaviorSubject({complete:function(){}}),this._noHistory="skip"===s.history,this._noHistoryOffset=0,this._parentRouter=n,n)this._name=n._name+n._activeState.path+"/",this._urlOffset=n._urlOffset+n._activeState.pathParams.length+1,n._noHistory&&(this._noHistoryOffset=n._noHistoryOffset+n._activeState.pathParams.length+1);else{if(o)throw Error("Only one root CoreRouter instance may exist at a time");o=this,i=s.urlAdapter||new e,this._setupNavigationListener()}this.childRouter=void 0,this._configure(r)}return u.prototype.reconfigure=function(t,e){const r=this._routes;let o=e||this._getActiveRoutes();return o&&!Array.isArray(o)&&(o=[o]),this._configure(t),this.go(...o).catch(t=>{throw this._configure(r),t})},u.prototype._configure=function(t=[]){this._routes=t.map(function(t){let e=t.path,r=[];if("string"==typeof e){const t=e.split("/");e=t.shift(),r=t.map(c)}const o={path:e,detail:t.detail||{},pathParams:r,redirect:t.redirect};let i=e;if("string"==typeof e)i=new RegExp("^"+e+"$");else if(!(e instanceof RegExp))throw Error("Router path must be a string or RegExp");return o._match=i,Object.freeze(o),o},this)},u.prototype.sync=function(){let t;if(n.length){const e=n.shift(),r=this._getParentRoutes().concat(this._getPendingState(e)),o=i.getUrlForRoutes(r);this._noHistory||window.history.replaceState(null,"path",o),t=e}else t=this._getRouteSegment();return this._execute(t||{path:"",params:{}}).then(t=>{var e=t,r=this.childRouter;return r&&(e=r.sync()),e}).catch(t=>{throw n=[],t})},u.prototype._getRouteSegment=function(){let t;if(this._noHistory)t=s[this._noHistoryOffset];else{let e=i.getRoutesForUrl();t=e[this._urlOffset];const r=this._getRoutePathParams(t&&t.path);e=i.getRoutesForUrl({offset:this._urlOffset,pathParams:r}),t=e[this._urlOffset]}return t},u.prototype.go=function(...t){let e;if(t.forEach(function(t){var r=t.params;r&&Object.keys(r).forEach(function(t){"object"==typeof r[t]&&(e=Promise.reject('"params" object may only contain scalar values'))})}),!e){const o=t.map(t=>t.path).join("/");r.info(`Navigating router(${this._name}) to ${o}`);const h=t[0],c=i.getUrlForRoutes(a()),u=s;if(this._noHistory)r.info(`Navigating non-history tracking router(${this._name}) to ${o}`),s=s.slice(0,this._noHistoryOffset).concat(t);else{s=[];const t=this._getParentRoutes().concat(this._getPendingState(h,!0)),e=i.getUrlForRoutes(t);c!==e&&window.history.pushState(null,"path",e)}e=this.sync().catch(t=>{throw n=[],this._noHistory?s=u:window.history.replaceState(null,"path",c),t}),n=t.slice(1)}return e},u.prototype._execute=function(t){const e=this._getPendingState(t);let r;return e?(r=this._prepublish(e),this._isCurrentState(e)||(r=r.then(()=>this._publish(e)))):r=Promise.reject(`Router(${this._name}) has no state matching "${t.path}"`),r},u.prototype._prepublish=function(t){let e=[];this.beforeStateChange.next({state:t,accept:function(t){e.push(t)}});let r=Promise.all(e).then(()=>t);return this.childRouter&&(r=r.then(()=>this.childRouter._prepublish(t))),r=r.then(t=>r!==this._activeSync?Promise.reject("sync overridden"):t),this._activeSync=r,r},u.prototype._publish=function(t){var e=[];return this.childRouter=null,this._activeState=t,this.currentState.next({state:t,complete:function(t){e.push(t)}}),Promise.all(e).then(()=>t)},u.prototype._setupNavigationListener=function(){this===o&&(this._popstateHandler=()=>{n=[],this.sync()},window.addEventListener("popstate",this._popstateHandler,!1))},u.prototype._isCurrentState=function(t){var e,r,o=this._activeState;return!!o&&(e=o,r=t,i.getUrlForRoutes([e])===i.getUrlForRoutes([r]))},u.prototype._getPendingState=function(t,e){var r,o=t.path,i=t.params||{};let s=this._routes.find(t=>t._match.test(o));return s&&s.redirect&&(o=s.redirect,s=this._getPendingState({path:o,params:i})),s?(r={path:o,params:i,detail:s.detail,pathParams:s.pathParams,redirect:s.redirect,_match:s._match},Object.freeze(r)):e&&(r={path:o,params:{},detail:{},pathParams:[]}),r},u.prototype._getRoutePathParams=function(t=""){const e=this._getPendingState({path:t});return e?e.pathParams:[]},u.prototype._getParentRoutes=function(){return a().slice(0,this._urlOffset)},u.prototype._getActiveRoutes=function(){return a().slice(this._urlOffset)},u.prototype.createChildRouter=function(t,e={}){this._noHistory&&(e.history="skip");const r=this._activeState;if(!r)throw Error(`Router(${this._name}) has no current state. Call sync() on the router first.`);if(this.childRouter&&"skip"!==e.history)throw Error(`Router(${this._name}) state(${r.path}) already has a child router`);const o=new u(t,e,this);return this.childRouter=o,o},u.prototype.destroy=function(){this===o&&(window.removeEventListener("popstate",this._popstateHandler,!1),o=null)},u});
//# sourceMappingURL=ojcorerouter.js.map