/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","ojs/ojcustomelement-registry","ojs/ojcontext","ojs/ojlogger","ojs/ojthemeutils"],function(e,t,i,r,n,s){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r;const o={};class a{static isValidCustomElementName(e){const t=a._RESERVED_TAGS.has(e),i=a._ELEMENT_NAME_REGEXP.test(e);return!t&&i&&!e.startsWith("oj-bind-",0)}static getSupportedTypes(e){if(!e)return{};let t=o[e];if(!t){t={};const i=e.toLowerCase(),r=i.match(/(?=[^|])(?:[^|]*<[^>]+>)*[^|]*/g);let n=0;r.forEach(e=>{const i=e.trim();"any"===i||"boolean"===i||"number"===i||"string"===i||"array"===i||"object"===i||"null"===i?t[i]=1:0===i.indexOf("array<")?t.array=1:0===i.indexOf("object<")?t.object=1:t.other=1,n++}),t.typeCount=n,o[i]=t}return t}static getUniqueId(e){if(e)return e;const t=a._UNIQUE+a._UNIQUE_INCR;return a._UNIQUE_INCR+=1,t}static comparePropertyValues(e,i,r){return e?t.Object.compareValues(i,r):i===r}}a._UNIQUE_INCR=0,a._UNIQUE="_oj",a._RESERVED_TAGS=new Set(["annotation-xml","color-profile","font-face","font-face-src","font-face-uri","font-face-format","font-face-name","missing-glyph"]),a._ELEMENT_NAME_REGEXP=/^[a-z][.0-9_a-z]*-[-.0-9_a-z]*$/;const l={accessKey:"accesskey",autocapitalize:"autocapitalize",autofocus:"autofocus",class:"class",contentEditable:"contenteditable",dir:"dir",draggable:"draggable",enterKeyHint:"enterkeyhint",hidden:"hidden",id:"id",inputMode:"inputmode",lang:"lang",role:"role",slot:"slot",spellcheck:"spellcheck",style:"style",tabIndex:"tabindex",translate:"translate",title:"title"};class c extends Error{constructor(e,t){super(`${e.localName} with id '${e.id||""}': ${t}`),Error.captureStackTrace&&Error.captureStackTrace(this,c),this.name="JetElementError"}}const d=/^\s*\[[^]*\]\s*$/,p=/^\s*\{[^]*\}\s*$/,u=/^(?:\{\{)([^]+)(?:\}\})$/,h=/^(?:\[\[)([^]+)(?:\]\])$/,g={};Object.keys(l).forEach(function(e){const t=l[e];e!==t&&(g[t]=e)});class m{static getExpressionInfo(e){let t,i=!1;if(e){const r=e.trim();let n=u.exec(r);t=n?.[1],t||(i=!0,n=h.exec(r),t=n?.[1])}return{downstreamOnly:i,expr:t}}static attributeToPropertyValue(e,t,i,r){if(null!=i)try{return m.coerceValue(e,t,i,r.type)}catch(i){throw new c(e,`Error while parsing parsing attribute ${t}. ${i.stack||i}`)}}static parseAttributeValue(e,t,i,r,n=null){if(!r)throw new Error(`Unable to parse ${t}='${i}' for ${e} with id '${n}'.         This attribute only supports data bound values. Check the API doc for supported types`);const s=a.getSupportedTypes(r),o=d.test(i),l=p.test(i);if(s.array&&o||s.object&&l||s.any&&(o||l))try{return JSON.parse(i)}catch(r){throw new Error(`Unable to parse ${t}='${i}' for ${e} with id '${n}'           to a JSON Object. Check the value for correct JSON syntax, e.g. double quoted strings. ${r}`)}else{if(s.string||s.any)return i;if(s.boolean)return m.parseBooleanValue(e,t,i,r,n);if(s.number&&!isNaN(i))return Number(i)}throw new Error(`Unable to parse ${t}='${i}' for ${e} with id '${n}'       to a ${r}.`)}static parseBooleanValue(e,t,i,r,n){if(null==i||"true"===i||""===i||i.toLowerCase()===t)return!0;if("false"===i)return!1;throw new Error(`Unable to parse ${t}='${i}' for ${e} with id '${n}' to a ${r}.`)}static coerceValue(e,t,i,r){const n=e.tagName.toLowerCase();return m.parseAttributeValue(n,t,i,r,e.id)}static coerceBooleanValue(e,t,i,r){return m.parseBooleanValue(e.tagName.toLowerCase(),t,i,r,e.id)}static isGlobalOrData(e){return Object.prototype.hasOwnProperty.call(l,e)||e.startsWith("data-")||e.startsWith("aria-")}static getGlobalAttrForProp(e){return l[e]||e}static getGlobalPropForAttr(e){return g[e]||e}static getGlobalValuePropForAttr(e){return"contenteditable"===e.toLowerCase()?"isContentEditable":m.getGlobalPropForAttr(e)}}function _(e,t){let i=e.cache;return i||(i=new Map,e.cache=i),i.has(t)||i.set(t,e(t)),i.get(t)}m.attributeToPropertyName=_.bind(null,e=>e.toLowerCase().replace(/-(.)/g,(e,t)=>t.toUpperCase())),m.propertyNameToAttribute=_.bind(null,e=>e.replace(/([A-Z])/g,e=>`-${e.toLowerCase()}`)),m.eventTypeToEventListenerProperty=_.bind(null,e=>"on"+e.substr(0,1).toUpperCase()+e.substr(1)),m.isEventListenerProperty=_.bind(null,e=>/^on[A-Z]/.test(e)),m.isEventListenerAttr=_.bind(null,e=>/^on-[a-z]/.test(e)),m.eventListenerPropertyToEventType=_.bind(null,e=>e.substr(2,1).toLowerCase()+e.substr(3)),m.propertyNameToChangeEventType=_.bind(null,e=>`${e}Changed`),m.propertyNameToChangedCallback=_.bind(null,e=>`on${e[0].toUpperCase()}${e.substr(1)}Changed`),m.eventTriggerToEventType=_.bind(null,e=>`oj${e.substr(0,1).toUpperCase()}${e.substr(1)}`),m.eventAttrToPreactPropertyName=_.bind(null,e=>e.toLowerCase().split("-").reduce((e,t,i)=>{return i>1?e+((r=t).charAt(0).toUpperCase()+r.substr(1)):e+t;var r},""));const C=Symbol("childBindingProvider"),b=Symbol("cachedBindingProvider"),E=new Set;class P{static getElementInfo(e){return e?`${e.tagName.toLowerCase()} with id '${e.id}'`:""}static getElementState(e){let t=e[P._ELEMENT_STATE_KEY];if(!t&&i.isElementRegistered(e.tagName)){t=new(0,i.getElementRegistration(e.tagName).stateClass)(e),Object.defineProperty(e,P._ELEMENT_STATE_KEY,{value:t})}return t??null}static getElementBridge(e){let t=e[P._ELEMENT_BRIDGE_KEY];if(void 0===t&&i.isElementRegistered(e.tagName)){t=null;const r=i.getElementRegistration(e.tagName).bridgeProto;if(void 0!==r){t=Object.create(r);const n=i.getElementDescriptor(e.tagName);t.initializeBridge(e,n)}Object.defineProperty(e,P._ELEMENT_BRIDGE_KEY,{value:t})}return t??null}static getSlotMap(e){const t={},r=e.childNodes,n=r.length>0?i.getMetadata(e.localName):null;for(let i=0;i<r.length;i++){const s=r[i];if(P.isSlotable(s)){const i=P.getSlotAssignment(s);t[i]||(t[i]=[]),P._possiblyApplyImplicitContext(s,i,n),t[i].push(s),s[b]=P._getBindingProviderTypeForSlot(e,s)}}return t}static getSlotAssignment(e){const t=null!=e.__oj_slots?e.__oj_slots:e.getAttribute&&e.getAttribute("slot");return t||""}static isSlotable(e){return 1===e.nodeType||3===e.nodeType&&!!e.nodeValue.trim()}static getElementProperty(e,t){if(i.isElementRegistered(e.tagName)){let i=e[P.VCOMP_INSTANCE];return i?P.getPropertyValue(i.props,t):e.getProperty(t)}return e[t]}static getPropertyValue(e,t){let i=e;const r=t.split(".");try{r.forEach(e=>i=i[e])}catch{return}return i}static allowSlotRelocation(e){P._ALLOW_RELOCATION_COUNT+=e?1:-1}static canRelocateNode(e,t){const i=P.getElementState(e);if(!i.getSlotMap()||P._ALLOW_RELOCATION_COUNT>0)return!0;const r=i.getSlotSet();if(i.isPostCreateCallbackOrComplete()&&r.has(t)){if(e.hasAttribute("data-oj-preact"))throw new c(e,`${t.localName} cannot be relocated as a child of this element.`);if("preact"===i.getBindingProviderType())return!1}return!0}static getClassSet(e){if(e){const t=e.split(/\s+/).filter(e=>e.length>0);if(t.length>0)return new Set(t)}return E}static _possiblyApplyImplicitContext(e,t,i){e?.nodeType===Node.ELEMENT_NODE&&i.slots?.[t]?.implicitBusyContext&&e.setAttribute("data-oj-context","")}static _getBindingProviderTypeForSlot(e,t){return t[b]||1===t.nodeType&&t.getAttribute("data-oj-binding-provider")||P.getElementState(e)?.getBindingProviderType()}}P._ELEMENT_STATE_KEY="_ojElementState",P._ELEMENT_BRIDGE_KEY="_ojBridge",P._ALLOW_RELOCATION_COUNT=0,P.VCOMP_INSTANCE=Symbol("vcompInstance");class y{constructor(e){this.dirtyProps=new Set,this._componentState=v.WaitingToCreate,this._outerClasses=new Set,this.Element=e}startCreationCycle(){this._isInErrorState()||(null!=this._preCreatedPromise&&this._componentState!==v.WaitingToCreate||this._updateComponentState(v.Creating),this._registerBusyState())}pauseCreationCycle(){this._resolveBusyState()}resetCreationCycle(){this._updateComponentState(v.WaitingToCreate),this._bindingProviderPromise=null,this._preCreatedPromise=null,this._createdPromise=null}isComplete(){return this._componentState===v.Complete}isCreating(){return this._componentState===v.Creating}isPostCreateCallbackOrComplete(){return this._componentState===v.PostCreateCallback||this.isComplete()}canHandleAttributes(){return!this._isInErrorState()&&this._componentState!==v.WaitingToCreate}beginApplyingBindings(){this.isComplete()||(this._bindingProviderType="knockout",this._updateComponentState(v.ApplyingBindings))}allowPropertySets(){return this._componentState===v.Creating||this._componentState===v.ApplyingBindings||this._componentState===v.BindingsApplied||this._componentState===v.PostCreateCallback||this._componentState===v.Complete}allowPropertyChangedEvents(){return this._componentState===v.BindingsApplied||this._componentState===v.PostCreateCallback||this._componentState===v.Complete}getTrackChildrenOption(){const e=i.getElementDescriptor(this.Element.tagName).metadata;return e?.extension?._TRACK_CHILDREN??"none"}setCreateCallback(e){this._isInErrorState()||(this._updateComponentState(v.WaitingForBindings),this._preCreatedPromise||(this._preCreatedPromise=this.GetPreCreatedPromise()),this._createdPromise=this._preCreatedPromise.then(()=>{if(!this._isInErrorState()){const t=e();return this._updateComponentState(v.PostCreateCallback),t}return Promise.reject()}),this._createdPromise.then(()=>{this._updateComponentState(v.Complete)},e=>{if(this._updateComponentState(v.Incomplete),e)throw e}))}setBindingsDisposedCallback(e){this._disposedCallback=e}resolveBindingProvider(e){this._bpClean=e.__CleanNode,this._resolveBindingProviderCallback&&(this._bindingsApplied(),this._resolveBindingProviderCallback(e),this._resolveBindingProviderCallback=null,this._rejectBindingProviderCallback=null),this._bindingProvider=e}rejectBindingProvider(e){this._rejectBindingProviderCallback&&(this._rejectBindingProviderCallback(e),this._resolveBindingProviderCallback=null,this._rejectBindingProviderCallback=null)}disposeBindingProvider(){this.isComplete()?this._disposedCallback?.():(this.rejectBindingProvider(),this._updateComponentState(v.BindingsDisposed))}setBindingProviderCallback(e){this._bindingProviderCallback=e}getBindingProviderPromise(){const e=this.getBindingProviderType();if(!this._bindingProviderPromise)if(s.verifyThemeVersion(),"none"===e||"preact"===e)this._bindingsApplied(),this._bindingProviderPromise=Promise.resolve(null);else{if("knockout"!==e)throw new c(this.Element,`Unknown binding provider '${e}'.`);this._bindingProvider?(this._bindingsApplied(),this._bindingProviderPromise=Promise.resolve(this._bindingProvider)):this._bindingProviderPromise=new Promise((e,t)=>{this._resolveBindingProviderCallback=e,this._rejectBindingProviderCallback=t})}return this._bindingProviderPromise}getBindingProvider(){return this._bindingProvider}getBindingProviderType(){return this._bindingProviderType||(this._bindingProviderType=y._walkBindingProviders(this.Element)),this._bindingProviderType}getUseKoFlag(){return void 0===this._useKoFlag&&(this._useKoFlag=y._findKoUseFlag(this.Element)),this._useKoFlag}getBindingProviderCleanNode(){return this._bpClean||y._NOOP}getDescriptiveText(){let e=this.GetDescriptiveValue("aria-label")||this.GetDescriptiveValue("title")||this.GetDescriptiveLabelByValue("labelled-by")||this.GetDescriptiveValue("label-hint")||this.GetDescriptiveLabelByValue("aria-labelledby");return e=e?e.trim().replace(/\s+/g," "):"",e}getSlotMap(e){return!this._slotMap&&e&&(this._slotMap=P.getSlotMap(this.Element)),this._slotMap}getSlotSet(){if(!this._slotSet){const e=Object.keys(this._slotMap);let t=[];e.forEach(e=>t=t.concat(this._slotMap[e])),this._slotSet=new Set(t)}return this._slotSet}setOuterClasses(e){this.PatchClasses(this._outerClasses,e),this._outerClasses=e}PatchClasses(e,t){e.forEach(e=>{t.has(e)||this.Element.classList.remove(e)}),t.forEach(t=>{e.has(t)||this.Element.classList.add(t)})}GetCreatedPromise(){return this._createdPromise}GetPreCreatedPromise(){let e=this.getBindingProviderPromise();return"none"!==this.getTrackChildrenOption()&&(e=e.then(e=>this._getTrackedChildrenPromises(e))),e}IsTransferAttribute(e){return!1}GetDescriptiveValue(e){const t=m.attributeToPropertyName(e),r=i.getElementProperties(this.Element);let n;return n=r&&r[t]?this.Element[t]:this.IsTransferAttribute(e)?this.GetDescriptiveTransferAttributeValue(e):this.Element.getAttribute(e),n}GetDescriptiveTransferAttributeValue(e){return""}GetDescriptiveLabelByValue(e){const t=this.GetDescriptiveValue(e);if(t){const e=document.getElementById(t);if(e)return e.textContent}return null}_updateComponentState(e){if(this._componentState!==v.BindingsDisposed){switch(e){case v.WaitingToCreate:this.Element.classList.remove("oj-complete"),this._createdPromise=null;break;case v.Complete:this.Element.classList.add("oj-complete"),this._resolveBusyState();break;case v.BindingsDisposed:case v.Incomplete:this.Element.classList.add("oj-incomplete"),this._resolveBusyState()}this._componentState=e}}_bindingsApplied(){this._updateComponentState(v.BindingsApplied),this._bindingProviderCallback?.()}_registerBusyState(){const e=r.getContext(this.Element).getBusyContext();if(this._resolveCreatedBusyState)throw new c(this.Element,"Registering busy state before previous state is resolved.");this._resolveCreatedBusyState=e.addBusyState({description:P.getElementInfo(this.Element)+" is being upgraded."})}_resolveBusyState(){this._resolveCreatedBusyState&&(this._resolveCreatedBusyState(),this._resolveCreatedBusyState=null)}static _findKoUseFlag(e){return!!e.querySelector(":scope > template[data-oj-use-ko]")}static _walkBindingProviders(e,t=e){let i=e[b];if(i)return i;if(i=e.getAttribute("data-oj-binding-provider"),!i){const r=e.parentElement;if(null==r){if(e!==document.documentElement)throw new c(t,"Cannot determine binding provider for a disconnected subtree.");i="knockout"}else i=r[C]??y._walkBindingProviders(r,t)}return e[b]=i,i}_getTrackedChildrenPromises(e){const t=this.getTrackChildrenOption(),s=r.getContext(this.Element).getBusyContext(),o=this._getChildrenToTrack(this.Element,t,[]).map(t=>{if(!e){const e=s.addBusyState({description:`Waiting for element ${t.localName} to be defined.`}),r=setInterval(()=>{n.warn(`Waiting for element ${t.localName} to be defined.`)},2e4);return customElements.whenDefined(t.localName).then(()=>(e(),clearInterval(r),i.isElementRegistered(t.tagName)?P.getElementState(t).GetCreatedPromise():null)).catch(i=>{throw e(),clearInterval(r),new Error(`Error defining element ${t.localName} : ${i}`)})}return i.isElementRegistered(t.tagName)?P.getElementState(t).GetCreatedPromise():null});return Promise.all(o)}_getChildrenToTrack(e,t,i){const r=e.childNodes;for(let e=0;e<r.length;e++){const n=r[e];a.isValidCustomElementName(n.localName)?i.push(n):"nearestCustomElement"===t&&this._getChildrenToTrack(n,t,i)}return i}_isInErrorState(){return this._componentState===v.Incomplete||this._componentState===v.BindingsDisposed}}var v;y._NOOP=()=>{},function(e){e[e.WaitingToCreate=0]="WaitingToCreate",e[e.Creating=1]="Creating",e[e.WaitingForBindings=2]="WaitingForBindings",e[e.ApplyingBindings=3]="ApplyingBindings",e[e.BindingsApplied=4]="BindingsApplied",e[e.PostCreateCallback=5]="PostCreateCallback",e[e.Complete=6]="Complete",e[e.Incomplete=7]="Incomplete",e[e.BindingsDisposed=8]="BindingsDisposed"}(v||(v={}));const f=Symbol("custom element null"),S=Symbol("custom element empty string"),T=Symbol("ojBindConvertedNode");e.AttributeUtils=m,e.CACHED_BINDING_PROVIDER=b,e.CHILD_BINDING_PROVIDER=C,e.CustomElementUtils=P,e.ElementState=y,e.ElementUtils=a,e.JetElementError=c,e.LifecycleElementState=class extends y{constructor(){super(...arguments),this._connectCallbacks=[],this._disconnectCallbacks=[]}addLifecycleCallbacks(e,t){e&&this._connectCallbacks.push(e),t&&this._disconnectCallbacks.push(t)}removeLifecycleCallbacks(e,t){e&&(this._connectCallbacks=this._connectCallbacks.filter(t=>t!=e)),t&&(this._disconnectCallbacks=this._disconnectCallbacks.filter(e=>e!=t))}executeLifecycleCallbacks(e){(e?this._connectCallbacks:this._disconnectCallbacks).forEach(e=>e())}},e.OJ_BIND_CONVERTED_NODE=T,e.toSymbolizedValue=e=>null===e?f:""===e?S:e,e.transformPreactValue=(e,t,i)=>{let r=(e=>e===f?null:e===S?"":e)(i);return""===r&&i!==S&&(r=((e,t,i)=>{if((!e||"preact"===P.getElementState(e).getBindingProviderType())&&(!a.getSupportedTypes(t.type).string||t.enumValues))return;return i})(e,t,r)),r},Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojcustomelement-utils.js.map