/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","ojs/ojdomutils","ojs/ojlogger","ojs/ojkeyboardfocus-utils"],function(e,t,n,i,r){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;const l=function(){};l._DATA_OJ_TABMOD="data-oj-tabmod",l._FOCUSABLE_ELEMENTS_TAG=["input","select","button","a","textarea","object"],l.WARN_DUPLICATE_KEYS_DETAIL="Duplicate keys detected. Though this can occur due to race conditions, it is likely an indication that the underlying data set contains non-unique keys.",l.CHECKVIEWPORT_THRESHOLD=3,l.applyRendererContent=function(e,t,n,i){if(null!=t){if(null===t.parentNode||t.parentNode instanceof DocumentFragment)return e.appendChild(t),i&&i(t),!0;if(null!=t.parentNode)return!1;if(t.toString){if(n){var r=document.createElement("span");r.appendChild(document.createTextNode(t.toString())),e.appendChild(r)}else e.appendChild(document.createTextNode(t.toString()));return!0}}return!1},l.getFocusableElementsInNode=function(e,t){return r.getFocusableElementsInNode(e,t)},l.checkVisibility=function(e){return r.checkVisibility(e)},l.disableElement=function(e){r.disableElement(e)},l.disableAllFocusableElements=function(e,t,n){return r.disableAllFocusableElements(e,t,n)},l.enableAllFocusableElements=function(e){return r.enableAllFocusableElements(e)},l.isFromDefaultSelector=function(e){return e.target.classList.contains("oj-selectorbox")},l.getActionableElementsInNode=function(e){return r.getActionableElementsInNode(e)},l.isElementOrAncestorFocusable=function(e,t){return!(null==e||t&&t(e))&&(!!e.hasAttribute(l._DATA_OJ_TABMOD)||(e.tabIndex>=0||(l._FOCUSABLE_ELEMENTS_TAG.indexOf(e.tagName.toLowerCase())>-1||l.isElementOrAncestorFocusable(e.parentElement,t))))},l.handleActionableTab=function(e,t){var n=l.getFocusableElementsInNode(t);return 1===n.length||n.length>0&&e.target===n[n.length-1]&&(n[0].focus(),!0)},l.handleActionablePrevTab=function(e,t){var n=l.getFocusableElementsInNode(t);return 1===n.length||n.length>0&&e.target===n[0]&&(n[n.length-1].focus(),!0)},l.isEventClickthroughDisabled=function(e,t){for(var n=e.target;null!=n&&n!==t;){if(l.isClickthroughDisabled(n))return!0;n=n.parentNode}return!1},l.isClickthroughDisabled=function(e){return"disabled"===e.dataset.ojClickthrough},l.getDefaultScrollBarWidth=function(e){var t;if(e&&e.style){var n=e.style.visibility,i=e.style.position,r=e.style.overflowY,l=e.style.height,o=e.style.width;e.style.visibility="hidden",e.style.position="absolute",e.style.overflowY="hidden",e.style.height="50px",e.style.width="50px";var s=e.offsetWidth-e.clientWidth;e.style.overflowY="scroll",t=e.offsetWidth-e.clientWidth-s,e.style.width=o,e.style.height=l,e.style.overflowY=r,e.style.position=i,e.style.visibility=n}return t},l.disableDefaultBrowserStyling=function(e){e.setAttribute("x-ms-format-detection","none")},l.applyMergedInlineStyles=function(e,t,n){var i=l.convertStringToStyleObj(n),r=l.convertStringToStyleObj(t),o=Object.assign({},i,r);l.applyStyleObj(e,o)},l.convertStringToStyleObj=function(e){var t={};if(e.split)for(var n=e.split(";"),i=0;i<n.length;i++){var r=n[i];if(""!==r){var l=r.split(":");2===l.length&&(t[l[0].trim()]=l[1].trim())}}return t},l.applyStyleObj=function(e,t){for(var n=Object.keys(t),i=Object.values(t),r=0;r<n.length;r++)e.style[n[r]]=i[r]},l.isMobileTouchDevice=function(){var e=t.AgentUtils.getAgentInfo();return e.os===t.AgentUtils.OS.IOS||e.os===t.AgentUtils.OS.ANDROID||e.os===t.AgentUtils.OS.WINDOWSPHONE},l.getNoJQFocusHandlers=function(e,t){return n.getNoJQFocusHandlers(e,t)},l.areKeySetsEqual=function(e,n){if(e===n)return!0;var i,r,l=e.isAddAll();if(l!==n.isAddAll())return!1;if(l?(i=e.deletedValues(),r=n.deletedValues()):(i=e.values(),r=n.values()),i.size!==r.size)return!1;for(var o=i.values(),s=r.values(),E=o.next(),a=s.next();!E.done;){if(!t.KeyUtils.equals(E.value,a.value))return!1;E=o.next(),a=s.next()}return!0},l.KEYBOARD_KEYS={_SPACEBAR:" ",_SPACEBAR_IE:"SpaceBar",_SPACEBAR_CODE:32,_ENTER:"Enter",_ENTER_CODE:13,_UP:"ArrowUp",_UP_IE:"Up",_UP_CODE:38,_DOWN:"ArrowDown",_DOWN_IE:"Down",_DOWN_CODE:40,_LEFT:"ArrowLeft",_LEFT_IE:"Left",_LEFT_CODE:37,_RIGHT:"ArrowRight",_RIGHT_IE:"Right",_RIGHT_CODE:39,_HOME:"Home",_HOME_CODE:36,_END:"End",_END_CODE:35,_TAB:"Tab",_TAB_CODE:9,_ESCAPE:"Escape",_ESCAPE_IE:"Esc",_ESCAPE_CODE:27,_F2:"F2",_F2_CODE:113,_NUM5_KEY:"5",_NUM5_KEY_CODE:53,_LETTER_A:"a",_LETTER_A_UPPERCASE:"A",_LETTER_A_CODE:65,_META:"Meta",_META_CODE:91},l.isEnterKeyEvent=function(e){return e===l.KEYBOARD_KEYS._ENTER||e===l.KEYBOARD_KEYS._ENTER_CODE},l.isSpaceBarKeyEvent=function(e){return e===l.KEYBOARD_KEYS._SPACEBAR||e===l.KEYBOARD_KEYS._SPACEBAR_IE||e===l.KEYBOARD_KEYS._SPACEBAR_CODE},l.isEscapeKeyEvent=function(e){return e===l.KEYBOARD_KEYS._ESCAPE||e===l.KEYBOARD_KEYS._ESCAPE_IE||e===l.KEYBOARD_KEYS._ESCAPE_CODE},l.isTabKeyEvent=function(e){return e===l.KEYBOARD_KEYS._TAB||e===l.KEYBOARD_KEYS._TAB_CODE},l.isF2KeyEvent=function(e){return e===l.KEYBOARD_KEYS._F2||e===l.KEYBOARD_KEYS._F2_CODE},l.isHomeKeyEvent=function(e){return e===l.KEYBOARD_KEYS._HOME||e===l.KEYBOARD_KEYS._HOME_CODE},l.isEndKeyEvent=function(e){return e===l.KEYBOARD_KEYS._END||e===l.KEYBOARD_KEYS._END_CODE},l.isArrowUpKeyEvent=function(e){return e===l.KEYBOARD_KEYS._UP||e===l.KEYBOARD_KEYS._UP_IE||e===l.KEYBOARD_KEYS._UP_CODE},l.isArrowDownKeyEvent=function(e){return e===l.KEYBOARD_KEYS._DOWN||e===l.KEYBOARD_KEYS._DOWN_IE||e===l.KEYBOARD_KEYS._DOWN_CODE},l.isArrowLeftKeyEvent=function(e){return e===l.KEYBOARD_KEYS._LEFT||e===l.KEYBOARD_KEYS._LEFT_IE||e===l.KEYBOARD_KEYS._LEFT_CODE},l.isArrowRightKeyEvent=function(e){return e===l.KEYBOARD_KEYS._RIGHT||e===l.KEYBOARD_KEYS._RIGHT_IE||e===l.KEYBOARD_KEYS._RIGHT_CODE},l.isNumberFiveKeyEvent=function(e){return e===l.KEYBOARD_KEYS._NUM5_KEY||e===l.KEYBOARD_KEYS._NUM5_KEY_CODE},l.isLetterAKeyEvent=function(e){return e===l.KEYBOARD_KEYS._LETTER_A||e===l.KEYBOARD_KEYS._LETTER_A_UPPERCASE||e===l.KEYBOARD_KEYS._LETTER_A_CODE},l.isMetaKeyEvent=function(e){return e===l.KEYBOARD_KEYS._META||e===l.KEYBOARD_KEYS._META_CODE},l.getAddEventKeysResult=function(e,t,n){var r,o,s,E,a;function u(e,t){return{key:e,index:t}}var c=e.slice(),d=[];t.keys.forEach(function(e){d.push(e)});var A=[],f=t.addBeforeKeys?t.addBeforeKeys:t.afterKeys;null!=f&&f.forEach(function(e){A.push(e)});var _=!1,g=t.indexes;if(A.length===d.length)for(var K=0,y=!0;y;){for(;d.length!==K;)for(K=d.length,r=d.length-1;r>=0;r--)s=d[r],l.containsKey(c,s)?(A.splice(r,1),d.splice(r,1),_=!0):null!=(o=A[r])?-1!==(a=l._indexOfKey(c,o))&&(c.splice(a,0,s),A.splice(r,1),d.splice(r,1)):n&&(c.push(s),A.splice(r,1),d.splice(r,1));n&&0!==d.length?(i.error('Invalid "beforeKey" value detected in "add" event.'),c.push(d[0]),A.splice(0,1),d.splice(0,1),y=0!==d.length):y=!1}else if(null!=g&&g.length===d.length){var O=[];for(r=0;r<d.length;r++)if(s=d[r],l.containsKey(c,s))_=!0;else if(null!=(E=g[r])){for(var b=!1,h=0;h<O.length;h++)if(O[h].index>E){O.splice(h,0,u(s,E)),b=!0;break}b||O.push(u(s,E))}else n&&c.push(s);for(r=0;r<O.length;r++){var D=O[r];D.index<c.length?c.splice(D.index,0,D.key):n&&(D.index!==c.length&&i.error('Invalid "index" value detected in "add" event.'),c.push(D.key))}}else n&&d.forEach(function(e){c.push(e)});return _&&i.warn(l.WARN_DUPLICATE_KEYS_DETAIL),c},l.containsKey=function(e,n){for(var i=0;i<e.length;i++)if(t.KeyUtils.equals(e[i],n))return!0;return!1},l._indexOfKey=function(e,n){for(var i=0;i<e.length;i++)if(t.KeyUtils.equals(e[i],n))return i;return-1},l.calculateOffsetTop=function(e,t){for(var n=0,i=t;i&&i!==e&&e.contains(i);)n+=i.offsetTop,i=i.offsetParent;return n},l.getLogicalChildPopup=function(e){return r.getLogicalChildPopup(e)},l.isElementIntersectingScrollerBounds=function(e,t){var n,i,r,l;if(t===document.documentElement)n=0,i=document.documentElement.clientHeight,r=0,l=document.documentElement.clientWidth;else{var o=t.getBoundingClientRect();n=o.top,i=o.bottom,r=o.left,l=o.right}var s=e.getBoundingClientRect();return s.top<=i&&s.bottom>=n&&s.left<=l&&s.right>=r},l.getScrollEventElement=function(e){return e===document.body||e===document.documentElement?window:e},l.getEventDetail=function(e,t){return new Promise(n=>{if(t.data&&t.metadata)n(t);else{const r=e.getCapability("fetchByKeys");r&&"lookup"===r.implementation?e.fetchByKeys({keys:new Set(t.keys),scope:"global"}).then(e=>{t.data=[],t.metadata=[],t.keys.forEach(n=>{const i=e.results.get(n);t.data.push(i.data),t.metadata.push(i.metadata)}),n(t)},e=>{i.error("Error fetching event detail due to fetchByKeys: "+e),n(null)}):(i.error("Error fetching event detail due to fetchByKeys: capability"),n(null))}})},l.isIterateAfterDoneNotAllowed=function(e){if(e&&e.getCapability){var t=e.getCapability("fetchFirst");if(t&&"notAllowed"===t.iterateAfterDone)return!0}return!1},l.isRequestIdleCallbackSupported=function(){return null!=window.requestIdleCallback&&null!=window.cancelIdleCallback&&null!=window.IdleDeadline},l.isFetchAborted=function(e){if(null==e?.value)return!1;var t=e.value.fetchParameters?.signal;return null==t?(i.warn("Signal is missing from fetch parameters, which is set by collection component and should be present"),!1):t.aborted},l.isChrome=function(){return t.AgentUtils.getAgentInfo().browser===t.AgentUtils.BROWSER.CHROME},l.isFirefox=function(){return t.AgentUtils.getAgentInfo().browser===t.AgentUtils.BROWSER.FIREFOX},l.isIE=function(){return t.AgentUtils.getAgentInfo().browser===t.AgentUtils.BROWSER.IE},l.isEdge=function(){return t.AgentUtils.getAgentInfo().browser===t.AgentUtils.BROWSER.EDGE},l.isSafari=function(){return t.AgentUtils.getAgentInfo().browser===t.AgentUtils.BROWSER.SAFARI},l.isMac=function(){return t.AgentUtils.getAgentInfo().os===t.AgentUtils.OS.MAC},l.isWindows=function(){return t.AgentUtils.getAgentInfo().os===t.AgentUtils.OS.WINDOWS},l.isIos=function(){return t.AgentUtils.getAgentInfo().os===t.AgentUtils.OS.IOS},l.isAndroid=function(){return t.AgentUtils.getAgentInfo().os===t.AgentUtils.OS.ANDROID},l.isBlink=function(){return t.AgentUtils.getAgentInfo().engine===t.AgentUtils.ENGINE.BLINK};const o=l.applyMergedInlineStyles,s=l.applyRendererContent,E=l.applyStyleObj,a=l.areKeySetsEqual,u=l.containsKey,c=l.convertStringToStyleObj,d=l.disableElement,A=l.disableAllFocusableElements,f=l.disableDefaultBrowserStyling,_=l.enableAllFocusableElements,g=l.getActionableElementsInNode,K=l.getAddEventKeysResult,y=l.getDefaultScrollBarWidth,O=l.isElementOrAncestorFocusable,b=l.isIterateAfterDoneNotAllowed,h=l.getFocusableElementsInNode,D=l.getLogicalChildPopup,S=l.getNoJQFocusHandlers,v=l.handleActionablePrevTab,p=l.handleActionableTab,R=l.isArrowDownKeyEvent,I=l.isArrowLeftKeyEvent,C=l.isArrowRightKeyEvent,Y=l.isArrowUpKeyEvent,m=l.isClickthroughDisabled,B=l.isEndKeyEvent,T=l.isEnterKeyEvent,w=l.isEscapeKeyEvent,N=l.isEventClickthroughDisabled,F=l.isFetchAborted,U=l.isFromDefaultSelector,P=l.isF2KeyEvent,L=l.isHomeKeyEvent,W=l.isMobileTouchDevice,k=l.isSpaceBarKeyEvent,x=l.isTabKeyEvent,M=l.isNumberFiveKeyEvent,H=l.isLetterAKeyEvent,j=l.isMetaKeyEvent,q=l.KEYBOARD_KEYS,G=l.CHECKVIEWPORT_THRESHOLD,V=l.WARN_DUPLICATE_KEYS_DETAIL,J=l.calculateOffsetTop,Q=l.isElementIntersectingScrollerBounds,z=l.getScrollEventElement,X=l.getEventDetail,$=l.isRequestIdleCallbackSupported,Z=l.isChrome,ee=l.isFirefox,te=l.isSafari,ne=l.isEdge,ie=l.isIE,re=l.isMac,le=l.isWindows,oe=l.isIos,se=l.isAndroid,Ee=l.isWebkit=function(){return t.AgentUtils.getAgentInfo().engine===t.AgentUtils.ENGINE.WEBKIT},ae=l.isBlink,ue=l.getBrowserVersion=function(){return parseInt(t.AgentUtils.getAgentInfo().browserVersion,10)},ce=l.doesAttributeExistInFilterCriterion=function(e,t){if(t.text)return!0;if(t.attribute&&t.op&&"$exists"===t.op){if(this.doesAttributeExistInFilterCriterion(e,t.criterion))return!0}else if(t.attribute){if("*"===t.attribute)return!0;if(t.attribute===e)return!0}else{if(t.value&&t.value.hasOwnProperty(e))return!0;if(t.criteria&&t.criteria.length>0)for(let n=0;n<t.criteria.length;n++)if(this.doesAttributeExistInFilterCriterion(e,t.criteria[n]))return!0}return!1};e.CHECKVIEWPORT_THRESHOLD=G,e.KEYBOARD_KEYS=q,e.WARN_DUPLICATE_KEYS_DETAIL=V,e.applyMergedInlineStyles=o,e.applyRendererContent=s,e.applyStyleObj=E,e.areKeySetsEqual=a,e.calculateOffsetTop=J,e.containsKey=u,e.convertStringToStyleObj=c,e.disableAllFocusableElements=A,e.disableDefaultBrowserStyling=f,e.disableElement=d,e.doesAttributeExistInFilterCriterion=ce,e.enableAllFocusableElements=_,e.getActionableElementsInNode=g,e.getAddEventKeysResult=K,e.getBrowserVersion=ue,e.getDefaultScrollBarWidth=y,e.getEventDetail=X,e.getFocusableElementsInNode=h,e.getLogicalChildPopup=D,e.getNoJQFocusHandlers=S,e.getScrollEventElement=z,e.handleActionablePrevTab=v,e.handleActionableTab=p,e.isAndroid=se,e.isArrowDownKeyEvent=R,e.isArrowLeftKeyEvent=I,e.isArrowRightKeyEvent=C,e.isArrowUpKeyEvent=Y,e.isBlink=ae,e.isChrome=Z,e.isClickthroughDisabled=m,e.isEdge=ne,e.isElementIntersectingScrollerBounds=Q,e.isElementOrAncestorFocusable=O,e.isEndKeyEvent=B,e.isEnterKeyEvent=T,e.isEscapeKeyEvent=w,e.isEventClickthroughDisabled=N,e.isF2KeyEvent=P,e.isFetchAborted=F,e.isFirefox=ee,e.isFromDefaultSelector=U,e.isHomeKeyEvent=L,e.isIE=ie,e.isIos=oe,e.isIterateAfterDoneNotAllowed=b,e.isLetterAKeyEvent=H,e.isMac=re,e.isMetaKeyEvent=j,e.isMobileTouchDevice=W,e.isNumberFiveKeyEvent=M,e.isRequestIdleCallbackSupported=$,e.isSafari=te,e.isSpaceBarKeyEvent=k,e.isTabKeyEvent=x,e.isWebkit=Ee,e.isWindows=le,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojdatacollection-common.js.map