/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","preact/jsx-runtime","preact"],function(t,e,a){"use strict";class s{static async getUpdatedItemsFromMutationDetail(t,e,a){const{add:d,remove:n,update:r}=t??{},i=new Map;for(const[t,a]of e.entries())i.set(a.key,t);let o=[...e];return n&&(o=s._removeItemsFromDetail(n,o,i)),d&&(o=await s._addItemsFromDetail(d,o,i,a)),r&&(o=await s._updateItemsFromDetail(r,o,i,a)),o}static _addItemsAtEnd(t,e,a){const s=[...a];return t.forEach((t,a)=>{const d={data:t,key:e[a]?.key,metadata:e[a]};s.push(d)}),s}static _addItemsAtIndices(t,e,a,s){const d=[...s];return t.forEach((t,s)=>{const n={data:e[s],key:a[s]?.key,metadata:a[s]};t>=0?d.splice(t,0,n):d.push(n)}),d}static _addItemsBeforeKeys(t,e,a,d){const n=[],r=[];return t.forEach(t=>{n.push(s._getIndexByKey(d,t)),r.push({key:t})}),s._addItemsAtIndices(n,e,r,a)}static async _addItemsFromDetail(t,e,a,d){const{addBeforeKeys:n,afterKeys:r,data:i,indexes:o,keys:c,metadata:h}=t;let m=[...e],_=i||[],l=h||[];if(0===_.length&&c?.size){const t=await s._fetchDataByKeys(d,c)??[];_=t.map(t=>t.data),l=t.map(t=>t.metadata)}return 0===l.length&&c?.size&&(l=[...c].map(t=>({key:t}))),_.length&&(m=o?.length?s._addItemsAtIndices(o,_,l,m):n?.length?s._addItemsBeforeKeys(n,_,m,a):r?.size?s._addItemsBeforeKeys([...r],_,m,a):s._addItemsAtEnd(_,l,m)),m}static async _fetchDataByKeys(t,e){const a=[],s=(await t.fetchByKeys({keys:e})).results;for(const t of e)if(s.has(t)){const e=s.get(t);a.push({...e,key:t})}return a}static _getIndexByKey(t,e){return t.has(e)?t.get(e):-1}static _removeItemsAtIndices(t,e){const a=[...e];return t.sort((t,e)=>e-t),t.forEach(t=>{t<a.length&&a.splice(t,1)}),a}static _removeItemsAtKeys(t,e,a){const d=[];return t.forEach(t=>{const e=s._getIndexByKey(a,t);-1!==e&&d.push(e)}),s._removeItemsAtIndices(d,e)}static _removeItemsFromDetail(t,e,a){const{indexes:d,keys:n}=t;let r=[...e];return d?.length?r=s._removeItemsAtIndices(d,r):n?.size&&(r=s._removeItemsAtKeys(n,r,a)),r}static _updateItemsAtIndices(t,e,a,s){const d=[...s];return t.forEach((t,s)=>{if(d[t]){const n={data:e[s],key:a[s]?.key,metadata:a[s]};d.splice(t,1,n)}}),d}static _updateItemsAtKeys(t,e,a,s,d){const n=[...s];return t.forEach(t=>{const s=this._getIndexByKey(d,t),r={data:e[s],key:a[s]?.key,metadata:a[s]};s>=0&&n.splice(s,1,r)}),n}static async _updateItemsFromDetail(t,e,a,d){const{data:n,indexes:r,keys:i,metadata:o}=t;let c=[...e],h=n||[],m=o||[];if(0===h.length&&i?.size){const t=await s._fetchDataByKeys(d,i)??[];h=t.map(t=>t.data),m=t.map(t=>t.metadata)}return 0===m.length&&i?.size&&(m=[...i].map(t=>({key:t}))),h.length&&(r?.length?c=s._updateItemsAtIndices(r,h,m,c):i?.size&&(c=s._updateItemsAtKeys(i,h,m,c,a))),c}}class d{constructor(t,e,a){this._handleMutateEvent=async t=>{const{detail:e}=t,a=this._addBusyState("updating data from mutation event"),d=await s.getUpdatedItemsFromMutationDetail(e,this._currentData,this._dataProvider);a?.(),this._currentData=d,this._callback?.onDataUpdated?.(d)},this._handleRefreshEvent=t=>{this._fetchDataAndNotify()},this._addBusyState=e,this._callback=a,this._dataProvider=t,this._currentData=[],t.addEventListener("refresh",this._handleRefreshEvent),t.addEventListener("mutate",this._handleMutateEvent),this._fetchDataAndNotify()}destroy(){this._callback=void 0,this._currentData=[],this._dataProvider.removeEventListener("refresh",this._handleRefreshEvent),this._dataProvider.removeEventListener("mutate",this._handleMutateEvent)}async _fetchData(){const t=[],e=this._dataProvider.fetchFirst({size:-1});for await(const a of e){const e=a.data.map((t,e)=>({data:t,key:a.metadata[e].key,metadata:a.metadata[e]}));t.push(...e)}return this._currentData=t.slice(),t}async _fetchDataAndNotify(){const t=this._addBusyState("fetching data"),e=await this._fetchData();this._callback?.onDataUpdated?.(e),t()}}t.withDataProvider=function(t,s){var n;return(n=class extends a.Component{constructor(t){super(t),this._handleDataUpdate=t=>{this.setState({fetchedData:t})},this.state={fetchedData:[]}}componentDidMount(){this._initDataProviderHandler()}componentDidUpdate(t){this.props.data!==t.data&&this._resetDataProviderHandler()}componentWillUnmount(){this._releaseDataProviderHandler()}render(a,d){const{data:n,addBusyState:r,...i}=a,{fetchedData:o}=d,c={[s]:o,...i};return e.jsx(t,{...c})}_initDataProviderHandler(){const{data:t,addBusyState:e}=this.props;null!=t&&(this._dataProviderHandler=new d(t,e,{onDataUpdated:this._handleDataUpdate}))}_releaseDataProviderHandler(){this._dataProviderHandler?.destroy(),this._dataProviderHandler=void 0}_resetDataProviderHandler(){this._releaseDataProviderHandler(),this._initDataProviderHandler()}}).displayName=`WithDataProvider(${function(t){return t.displayName??t.name??"Component"}(t)})`,n},Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojdataproviderhandler.js.map