/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojthemeutils","ojs/ojcore-base","jquery"],function(e,t,n,i){"use strict";n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n,i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i;const o={_HTML_START_TAG:"<html>",_HTML_END_TAG:"</html>",_LEGAL_ELEMENTS:{SPAN:1,B:1,I:1,EM:1,BR:1,HR:1,LI:1,OL:1,UL:1,P:1,TT:1,BIG:1,SMALL:1,PRE:1},_LEGAL_ATTRIBUTES:{class:1,style:1}};var r,a,s,l,c,u,f,d;o.isHTMLContent=function(e){return 0===e.indexOf(o._HTML_START_TAG)&&e.lastIndexOf(o._HTML_END_TAG)===e.length-7},o.cleanHtml=function(e){var t=i(document.createElement("span")).get(0);return t.innerHTML=e,e&&e.indexOf("<")>=0&&o._cleanElementHtml(t),t},o._cleanElementHtml=function(e){for(var t=e.childNodes,n=t.length-1;n>=0;n--){var r=t.item(n);if(r&&1===r.nodeType)if(o._LEGAL_ELEMENTS[r.nodeName]){for(var a=r.attributes,s=a.length-1;s>=0;s--){var l=a[s];void 0!==i(r).attr(l.name)&&(o._LEGAL_ATTRIBUTES[l.name]||r.removeAttribute(l.nodeName))}o._cleanElementHtml(r)}else r&&e.removeChild(r)}},o.isAncestor=function(e,t){for(var n=t.parentNode;n;){if(n===e)return!0;n=n.parentNode}return!1},o.isAncestorOrSelf=function(e,t){return t===e||o.isAncestor(e,t)},o.addResizeListener=function(e,t,n,i){let r=o._RSZ_TRKR;i&&(r=o._RSZ_TRKR_OBS,o._OBS_BASED.set(t,!0));let a=r.get(e);null==a&&(a=new o._ResizeTracker(e,i),r.set(e,a),a.start()),a.addListener(t,n)},o.removeResizeListener=function(e,t){const n=o._OBS_BASED.get(t)?o._RSZ_TRKR_OBS:o._RSZ_TRKR,i=n.get(e);null!=i&&(i.removeListener(t),i.isEmpty()&&(i.stop(),n.delete(e)))},o.fixResizeListeners=function(e){i(e).find(".oj-helper-detect-expansion").parent().each(function(e,t){var n=o._RSZ_TRKR.get(t);null!=n&&n.init(!0)})},o.isMetaKeyPressed=function(e){var t=n.AgentUtils.getAgentInfo();return n.AgentUtils.OS.MAC===t.os?e.metaKey:e.ctrlKey},o.dispatchEvent=function(e,t){var n="disabled",i=e[n];try{e[n]=!1,e.dispatchEvent(t)}finally{e[n]=i}},o._invokeAfterPaint=(window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||function(e){return window.setTimeout(e,0)}).bind(window),o._cancelInvokeAfterPaint=(window.cancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||function(e){return window.clearTimeout(e)}).bind(window),o._ResizeTracker=function(e,t){e instanceof i&&(e=e[0]);var n=e.hasAttribute("data-oj-resize-notify"),r=i.Callbacks(),a=[],s=[],l=2,c=0,u=null,f=null,d=null,g=null,h=null,v=null,m=null;function L(e){var t=!1;if(null!=g.offsetParent){var n=g.offsetWidth,i=g.offsetHeight;f===n&&d===i||(c=l,A(n,i),t=!0,e&&E(!0))}return t}function p(t){const n=t[0].borderBoxSize;E(!1,[n?(n[0]||n).inlineSize:e.offsetWidth,n?(n[0]||n).blockSize:e.offsetHeight])}function E(t,i){var s=i?i[0]:e.offsetWidth,l=i?i[1]:e.offsetHeight,c=(t,i)=>{r.fire(t,i),n&&e.dispatchEvent(new Event("oj-resize"))};r.has()&&(t?(null!==u&&o._cancelInvokeAfterPaint(u),u=o._invokeAfterPaint(function(){u=null,c(s,l)})):c(s,l));for(var f=0;f<a.length;f++)a[f].getCallback()(s,l)}function S(e){e.stopPropagation(),L(!0)||c>0&&null!=g.offsetParent&&(0===g.scrollLeft||0===g.scrollTop)&&(c-=1,A(f,d))}function A(e,t){f=e,d=t;var n=g.firstChild.style,i=1;do{n.width=e+i+"px",n.height=t+i+"px",g.scrollLeft=i,g.scrollTop=i,i+=1}while((0===g.scrollTop||0===g.scrollLeft)&&i<=5);h.scrollLeft=e,h.scrollTop=t}this.addListener=function(t,i){if(void 0===i||isNaN(i)||0===i)r.add(t);else{a.push(new o._collapsingListenerManager(n?()=>{t.apply(null,arguments),e.dispatchEvent(new Event("oj-resize"))}:t,i)),s.push(t)}},this.removeListener=function(e){var t=s.indexOf(e);t>=0?(s.splice(t,1),a.splice(t,1)[0].stop()):r.remove(e)},this.isEmpty=function(){return!r.has()&&0===s.length},this.start=function(){if(t&&window.ResizeObserver instanceof Function)(m=new ResizeObserver(p)).observe(e,{box:"border-box"});else{v=S;var n=e.childNodes[0];(g=document.createElement("div")).className="oj-helper-detect-expansion";var i=document.createElement("div");g.appendChild(i),null!=n?e.insertBefore(g,n):e.appendChild(g),g.addEventListener("scroll",v,!1),(h=document.createElement("div")).className="oj-helper-detect-contraction";var o=document.createElement("div");o.style.width="200%",o.style.height="200%",h.appendChild(o),e.insertBefore(h,g),h.addEventListener("scroll",v,!1),this.init(!1)}},this.stop=function(){null!=u&&(o._cancelInvokeAfterPaint(u),u=null),null!=m?(m.disconnect(),m=null):null!=g&&(g.removeEventListener("scroll",v),h.removeEventListener("scroll",v),g.parentNode&&e.removeChild(g),h.parentNode&&e.removeChild(h))},this.init=function(e){if(g){var t=L(e);e&&!t&&null!=g.offsetParent&&A(f,d)}}},o._RSZ_TRKR=new WeakMap,o._RSZ_TRKR_OBS=new WeakMap,o._OBS_BASED=new WeakMap,o.isValidIdentifier=function(e){return/^[A-Za-z][0-9A-Z_a-z-]*$/.test(e)},o._collapsingListenerManager=function(e,t){var n=null,i=null,o=function(){e.apply(null,n),i=null},r=function(){n=Array.prototype.slice.call(arguments),null==i&&(i=window.setTimeout(o,t))};this.getCallback=function(){return r},this.stop=function(){null!=i&&(window.clearTimeout(i),i=null)}},o.isTouchSupported=function(){return"ontouchstart"in window||navigator.msMaxTouchPoints>0||navigator.maxTouchPoints>0},o.setInKoCleanExternal=function(e){o._koCleanNode=e},o.unwrap=function(e,t){var n=o._koCleanNode;n&&e.get(0)===n||(t?t.replaceWith(e):e.unwrap())},o.isChromeEvent=function(e){if(!("clientX"in e)||!("clientY"in e))return!1;var t=n.AgentUtils.getAgentInfo();if(n.AgentUtils.OS.ANDROID===t.os||n.AgentUtils.OS.IOS===t.os)return!1;if(t.engine!==n.AgentUtils.ENGINE.GECKO&&t.engine!==n.AgentUtils.ENGINE.WEBKIT&&t.engine!==n.AgentUtils.ENGINE.BLINK&&t.browser!==n.AgentUtils.BROWSER.IE)return!1;var r="ltr"===o.getReadingDirection(),a=!r&&t.browser===n.AgentUtils.BROWSER.SAFARI,s=e.target,l=i(s),c=s.getBoundingClientRect(),u=o.getScrollBarWidth();return!(!r||"HTML"!==s.nodeName&&"visible"===l.css("overflow-x")||!(e.clientX>c.right-u))||(!r&&!a&&"HTML"===s.nodeName&&e.clientX>c.right-u||(!r&&"visible"!==l.css("overflow-x")&&e.clientX<c.left+u||("HTML"===s.nodeName||"visible"!==l.css("overflow-y"))&&e.clientY>c.bottom-u))},o.getScrollBarWidth=function(){return i.position.scrollbarWidth()},o.getReadingDirection=function(){var e=document.documentElement.getAttribute("dir");return e&&(e=e.toLowerCase()),"rtl"===e?"rtl":"ltr"},o.setScrollLeft=function(e,t){e.scrollLeft=o.calculateScrollLeft(t)},o.calculateScrollLeft=function(e){var t=e;if("rtl"===o.getReadingDirection()){var i=n.AgentUtils.getAgentInfo().browser;i!==n.AgentUtils.BROWSER.IE&&i!==n.AgentUtils.BROWSER.EDGE&&(t=-e)}return t},o.getCSSLengthAsInt=function(e){if(!isNaN(e))return parseInt(e,10);if(e&&e.length>0&&"auto"!==e){var t=parseInt(e,10);return isNaN(t)&&(t=0),t}return 0},o.getCSSLengthAsFloat=function(e){if(!isNaN(e))return parseFloat(e);if(e&&e.length>0){var t=parseFloat(e);return isNaN(t)&&(t=0),t}return 0},o.getCSSTimeUnitAsMillis=function(e){if(!isNaN(e))return parseInt(e,10);if(e&&e.length>0){var t=parseFloat(e);if(isNaN(t))t=0;else{var n,i=e+"";i.length>2&&i.endsWith("ms")?n=i.slice(-3,-2):i.length>1&&i.endsWith("s")&&(n=i.slice(-2,-1)),isNaN(n)?t=0:!i.endsWith("ms")&&i.endsWith("s")&&(t*=1e3)}return t}return 0},o._LOGICAL_PARENT_DATA="oj-logical-parent",o.getLogicalParent=function(e){if(e)return e.data(o._LOGICAL_PARENT_DATA)},o.setLogicalParent=function(e,t){e&&(null===t?e.removeData(o._LOGICAL_PARENT_DATA):e.data(o._LOGICAL_PARENT_DATA,t))},o.isLogicalAncestorOrSelf=function(e,t){n.Assert.assertDomElement(e),n.Assert.assertDomElement(t);for(var r=t;r;){if(r===e)return!0;var a=o.getLogicalParent(i(r));r=a?a[0]:r.parentNode}return!1},o.validateURL=function(e,t){var n=t||["http:","https:"],i=document.createElement("a");i.href=e;var o=i.protocol;if(null!=o&&(o=o.toLowerCase()),n.indexOf(o)<0&&""!==o)throw new Error(o+" is not a valid URL protocol")},o._suppressNativeContextMenu=function(){i(document.body).hasClass("oj-hybrid")&&!i(document.body).hasClass("oj-hybrid-show-context-menu")&&document.body.addEventListener("contextmenu",function(e){"INPUT"!==e.target.nodeName&&"TEXTAREA"!==e.target.nodeName&&e.preventDefault()},!0)},o._suppressNativeContextMenu(),o.PRESS_HOLD_THRESHOLD=750,o.recentTouchEnd=function(){var e=0;function t(){e=Date.now()}return document.addEventListener("touchend",t,!0),document.addEventListener("touchcancel",t,!0),function(){return Date.now()-e<500}}(),o.recentTouchStart=(r=0,a=o.PRESS_HOLD_THRESHOLD+50,document.addEventListener("touchstart",function(){r=Date.now()},{passive:!0,capture:!0}),function(){return Date.now()-r<a}),o.recentPointer=(l=0,c=o.PRESS_HOLD_THRESHOLD+600,document.addEventListener("mousedown",function(){var e=Date.now();(!s||e>l+o.PRESS_HOLD_THRESHOLD)&&(l=e,s=!1)},!0),document.addEventListener("touchstart",function(){l=Date.now(),s=!0},{passive:!0,capture:!0}),document.addEventListener("mouseup",function(){l=Date.now(),s=!1},!0),document.addEventListener("touchend",function(){l=Date.now(),s=!1},!0),function(){return Date.now()-l<(s?c:600)}),o.makeFocusable=(u=0,f=(t.parseJSONFromFontFamily("oj-focus-config")||{}).focusHighlightPolicy,d=function(e,t){switch(e?e():f){case"all":return!0;case"none":return!1;default:return!(o.recentPointer()||t&&t())}},function(e){var t=e.element,n="ojFocusable",o="."+n,r=" "+o;if(e.remove){t.removeClass("oj-focus oj-focus-highlight");var a=t.data(n);if(null==a)return;var s=o+(""+a).split(",").join(r);t.off(s).removeData(n)}else{var l=e.afterToggle||i.noop,c=e.applyHighlight?function(t){t.addClass("oj-focus"),d(e.getFocusHighlightPolicy,e.recentPointer)&&t.addClass("oj-focus-highlight"),l("focusin")}:function(e){e.addClass("oj-focus"),l("focusin")},f=!1;(e.setupHandlers||function(r,a){var s=e.component,l=function(e){r(i(e.currentTarget)),f=!0},c=function(e){f&&(a(i(e.currentTarget)),f=!1)};if(s)s._on(t,{focusin:l,focusout:c});else{var d=u;u+=1;var g=t.data(n);t.data(n,null==g?d:g+","+d);var h={},v=o+d;h["focusin"+v]=l,h["focusout"+v]=c,t.on(h)}})(c,function(e){e.removeClass("oj-focus oj-focus-highlight"),l("focusout")})}}),o.getNoJQFocusHandlers=function(e,t){return{focusIn:function(t){return e(i(t))},focusOut:function(e){return t(i(e))}}};const g=o.isHTMLContent,h=o.cleanHtml,v=o.isAncestor,m=o.isAncestorOrSelf,L=o.addResizeListener,p=o.removeResizeListener,E=o.fixResizeListeners,S=o.isMetaKeyPressed,A=o.dispatchEvent,_=o.isValidIdentifier,T=o.isTouchSupported,R=o.setInKoCleanExternal,w=o.unwrap,N=o.isChromeEvent,O=o.getScrollBarWidth,C=o.getReadingDirection,H=o.setScrollLeft,P=o.calculateScrollLeft,D=o.getCSSLengthAsInt,b=o.getCSSLengthAsFloat,I=o.getCSSTimeUnitAsMillis,y=o.getLogicalParent,M=o.setLogicalParent,B=o.isLogicalAncestorOrSelf,j=o.validateURL,x=o.PRESS_HOLD_THRESHOLD,F=o.recentTouchEnd,U=o.recentTouchStart,z=o.recentPointer,k=o.getNoJQFocusHandlers,W=o.makeFocusable;e.PRESS_HOLD_THRESHOLD=x,e.addResizeListener=L,e.calculateScrollLeft=P,e.cleanHtml=h,e.dispatchEvent=A,e.fixResizeListeners=E,e.getCSSLengthAsFloat=b,e.getCSSLengthAsInt=D,e.getCSSTimeUnitAsMillis=I,e.getLogicalParent=y,e.getNoJQFocusHandlers=k,e.getReadingDirection=C,e.getScrollBarWidth=O,e.isAncestor=v,e.isAncestorOrSelf=m,e.isChromeEvent=N,e.isHTMLContent=g,e.isLogicalAncestorOrSelf=B,e.isMetaKeyPressed=S,e.isTouchSupported=T,e.isValidIdentifier=_,e.makeFocusable=W,e.recentPointer=z,e.recentTouchEnd=F,e.recentTouchStart=U,e.removeResizeListener=p,e.setInKoCleanExternal=R,e.setLogicalParent=M,e.setScrollLeft=H,e.unwrap=w,e.validateURL=j,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojdomutils.js.map