/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore","ojs/ojcomponentcore","ojs/ojlabel","ojs/ojcore-base","ojs/ojdomutils","ojs/ojcontext","ojs/ojlogger","ojs/ojthemeutils","@oracle/oraclejet-preact/hooks/UNSAFE_useFormVariantContext"],function(e,t,n,i,o,a,l,r,s){"use strict";i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i,a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a;var d={properties:{colspanWrap:{type:"string",enumValues:["nowrap","wrap"]},columns:{type:"number",value:0},direction:{type:"string",enumValues:["column","row"]},labelEdge:{type:"string",enumValues:["inside","start","top"]},labelWidth:{type:"string",value:"33%"},labelWrapping:{type:"string",enumValues:["truncate","wrap"],value:"wrap"},maxColumns:{type:"number",value:1},readonly:{type:"boolean",value:!1},userAssistanceDensity:{type:"string",enumValues:["compact","efficient","reflow"],value:"efficient"}},methods:{getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}};Object.freeze(d);var c=0;const u="oj-form-layout-option-defaults";function f(e){var t=this,n=e.element,s="-labelled-by",d="data-oj-formlayout-bonus-dom",f="["+d+"]";const m="data-oj-internal",p="data-oj-context",y="oj-enabled",h="oj-formlayout-labels-nowrap",b="OJ-FORM-LAYOUT";var v,g,j,C,x,w=!0,L=!1;ne(e),t._rootElementMutationObserver=new MutationObserver(function(e){document.body.contains(n)?(!function(e){for(var t=e.length,i=0;i<t;i++){var o=e[i];if("childList"===o.type)for(var a=o.addedNodes.length,l=0;l<a;l++){var r=o.addedNodes[l];r.parentNode===n&&j.appendChild(r)}}}(e),function(e){for(var t=!0,n=e.length,i=["colspan","label-hint"],o=0;o<n;o++){var a=e[o];if("childList"===a.type&&$(a.target)&&Q(a.target)){t=!1;break}if("attributes"===a.type&&i.includes(a.attributeName)){t=!1;break}}return t}(e)||(!function(e){for(var t=e.length,n=0;n<t;n++){var i=e[n];if("childList"===i.type)for(var o=i.removedNodes.length,a=0;a<o;a++){var l=i.removedNodes[a];1===l.nodeType&&(l.removeEventListener("labelHintChanged",F),l.removeEventListener("helpHintsChanged",D),l.removeEventListener("requiredChanged",H),l.removeEventListener("userAssistanceDensityChanged",M))}}}(e),n.refresh())):this.disconnect()}),t._resizeHandler=function(e,t){U()!==x&&n.refresh()},this.createDOM=function(){n.classList.add("oj-form-layout"),(j=document.createElement("div")).classList.add("oj-form"),j.setAttribute(p,""),j.setAttribute(m,""),j.setAttribute(d,""),n.readonly?j.classList.remove(y):j.classList.add(y);const e="oj-efficient";for("efficient"===n.userAssistanceDensity?j.classList.add(e):j.classList.remove(e);n.firstChild;)j.appendChild(n.firstChild);n.appendChild(j)};const E="data-oj-formlayout-workaround-dom",A=`:scope > [${E}]`;function O(e){n.columns<1&&"row"===n.direction&&o.addResizeListener(e,t._resizeHandler,25)}function N(){g&&(g(),g=null)}function S(){v&&(v(),v=null)}function B(e){return"inside"===n.labelEdge||"provided"!==e.labelEdge}function W(e){var t=null;return B(e)||e instanceof Element&&"labelHint"in e&&""!==e.labelHint&&(Z(e),t=function(e){let t=e.labelledBy;if(t){document.getElementById(t)&&l.error("The oj-form-layout descendent component with id "+e.id+' has both label-hint and labelled-by. Remove labelled-by="'+t+'" since no matching element was found in the document, and a label will be created using the label-hint.')}var n=document.createElement("oj-label");n.setAttribute(d,""),n.setAttribute(m,""),n.setAttribute("data-oj-binding-provider","none"),n.setAttribute(p,"");var i=document.createElement("span");i.id=e.id+"|hint",i.textContent=e.labelHint,te(e)&&_(e,n);return n.appendChild(i),function(e,t){var n=e,i=t;n.id=i.id+s,n.setAttribute("for",i.id)}(n,e),n}(e),e.parentElement.insertBefore(t,e),function(e){e.addEventListener("labelHintChanged",F),e.addEventListener("helpHintsChanged",D),e.addEventListener("requiredChanged",H),e.addEventListener("userAssistanceDensityChanged",M)}(e)),t}function F(e){var t=e.target,n=document.getElementById(t.id+"|hint");n&&(n.textContent=e.detail.value)}function D(e){var t=e.target,n=k(t);let i=e.detail.value;if(n){R(t)&&(n.help=i)}}function H(e){var t=e.target,n=k(t);if(n){let i;i=!!e.detail.value&&R(t),n.showRequired=i}}function M(e){let t=e.target,n=e.detail.value,i=e.detail.previousValue;if("compact"!==n&&"compact"!==i)return;let o=k(t);if(te(t))_(t,o);else{t.required&&(o.showRequired=!1);const e=t.helpHints;e&&(e.definition||e.source)&&(o.help={definition:null,source:null})}}function R(e){let t="use"===r.parseJSONFromFontFamily("oj-form-control-option-defaults").useUserAssistanceOptionDefault?e.userAssistanceDensity:"displayOptions";return"compact"===t||"displayOptions"===t}function k(e){return"labelledBy"in e?document.getElementById(e.labelledBy):n.querySelector('oj-label[for="'+e.id+'"]')}function _(e,t){var n=t,i=e.helpHints;let o;i&&(i.definition||i.source)&&(n.help=i),o=!!e.required&&R(e),n.showRequired=o}function I(){return"column"===n.direction||1===x}function T(e,t){if(!I()){for(var n,i=t.previousSibling;i&&1!==i.nodeType;)n=i,i=i.previousSibling;for(;n&&n!==t;)i=n.nextSibling,e.appendChild(n),n=i}}function V(e){if(!I())for(;e.nextSibling;){var t=e.nextSibling;if(1===t.nodeType)break;if(8===t.nodeType&&0===t.textContent.trim().indexOf("oj-bind-"))break;e.appendChild(t)}}function q(e,t){e&&V(e);var n=Y("oj-flex");return t.parentElement.insertBefore(n,t),T(n,n),n}function U(){let e=n.maxColumns;const t=n.columns;if(t>0)e=t,n.classList.add("oj-form-layout-no-min-column-width");else if(n.classList.remove("oj-form-layout-no-min-column-width"),"row"===n.direction&&!ee()){let t=parseFloat(window.getComputedStyle(j).columnWidth);if(!isNaN(t)){let i=parseFloat(window.getComputedStyle(n.parentElement).width),o=Math.max(Math.floor(i/t),1);o<e&&(e=o)}}return e}function G(e,t){var i=1;if("column"===n.direction)return"100%";e&&"colspan"in e&&e.colspan&&(i=Math.min(Math.floor(e.colspan),t));let o=r.parseJSONFromFontFamily(u).columnGap,a="calc(((100% / "+x+") - (("+o+" * ("+(x-1)+") / "+x+"))"+(ee()?" - 0.1px":"")+")";return i>1&&(a+=" * "+i+" + ("+o+" * "+(i-1)+")"),a+=")",a}function J(e,t){var n=Y("oj-flex-item");return n.style.flexGrow="0",n.style.flexShrink="1",n.style.flexBasis=t,n.style.width=t,n.style.maxWidth=t,e.appendChild(n),n}function z(e,t){var i=t%x,o=G();if("column"!==n.direction&&e&&i>0)for(var a=i;a<x;a++)a!==i&&P(e),J(e,o)}function P(e){var t=Y("oj-formlayout-column-gutter");e.appendChild(t)}function K(e,t,i,o){var a=G(e,o);T(i,e);var l=Y("oj-flex-item");if(i.appendChild(l),l.appendChild(e),t)if(l.style.flexGrow="1",l.style.flexShrink="1",l.style.flexBasis=a,l.style.width=a,l.style.maxWidth=a,t.tagName===b&&l.classList.add("oj-formlayout-nested-formlayout"),"start"===n.labelEdge){l.style.display="flex";let i=Y("oj-formlayout-inline-label"),o=Y("oj-formlayout-inline-value");i.style.flexGrow="0",i.style.flexShrink="0",i.style.flexBasis=n.labelWidth,i.style.width=n.labelWidth,i.style.maxWidth=n.labelWidth,i.appendChild(e),l.appendChild(i),o.style.flexGrow="1",o.style.flexShrink="1",o.style.flexBasis="calc(100% - "+n.labelWidth+")",o.style.width=o.style.flexBasis,o.style.maxWidth=o.style.flexBasis,o.appendChild(t),l.appendChild(o)}else l.appendChild(t);else if("labelHint"in e&&B(e))l.style.flexGrow="1",l.style.flexShrink="1",l.style.flexBasis=a,l.style.width=a,l.style.maxWidth=a,l.appendChild(e);else if(l.appendChild(e),l.style.flexGrow="1",l.style.flexShrink="1",l.style.flexBasis=a,l.style.width=a,l.style.maxWidth=a,l.classList.add("oj-formlayout-no-label-flex-item"),"OJ-LABEL-VALUE"===e.tagName){let t=r.parseJSONFromFontFamily(u).columnGap;l.classList.add("oj-formlayout-nested-labelvalue"),e.setAttribute("data-oj-colspan",o),e.setAttribute("data-oj-column-gap",t),e.refresh()}else e.tagName===b&&l.classList.add("oj-formlayout-nested-formlayout");V(i)}function Y(e){var t=document.createElement("div");return t.setAttribute(d,""),t.setAttribute(m,""),t.classList.add(e),t}function $(e){return e===n||e&&"DIV"===e.tagName&&e.hasAttribute(d)}function Q(e){for(var t=e,i=!0;t!==n;){if(t.tagName===b){i=!1;break}if(null==(t=t.parentElement)){i=!1;break}}return i}function X(e){for(;e.firstChild;){var t=e.firstChild;e.parentNode.insertBefore(t,e)}e.parentNode.removeChild(e)}function Z(e){var t=e;t.id||(t.id="oflId_"+c,c+=1)}function ee(){var e=i.AgentUtils.getAgentInfo();return"ie"===e.browser&&11===e.browserVersion}function te(e){let t=r.parseJSONFromFontFamily("oj-form-control-option-defaults"),n="displayOptions";if(t){n="use"===t.useUserAssistanceOptionDefault?e.userAssistanceDensity:"displayOptions"}return"compact"===n||"displayOptions"===n}function ne(e){var t=r.parseJSONFromFontFamily(u)||{};e?(e.props.labelEdge||(n.labelEdge=t.labelEdge),e.props.colspanWrap||(n.colspanWrap=t.colspanWrap),e.props.direction||(n.direction=t.direction)):(n.labelEdge||(n.labelEdge=t.labelEdge),n.colspanWrap||(n.colspanWrap=t.colspanWrap),n.direction||(n.direction=t.direction))}t.handlePropertyChanged=function(e,t){switch(e){case"readonly":return n.readonly?j.classList.remove(y):j.classList.add(y),!0;case"userAssistanceDensity":{const e="oj-efficient";return"efficient"===n.userAssistanceDensity?j.classList.add(e):j.classList.remove(e),!0}case"labelWrapping":return"truncate"===n.labelWrapping?j.classList.add(h):j.classList.remove(h),!0;default:return!1}},this.updateDOM=function(){function e(){!function(){if(!g){var e=a.getContext(n).getBusyContext(),t={description:"The oj-form-layout component with id = '"+n.id+"' is being rendered."};g=e.addBusyState(t)}}(),ne(),C=[],a.getContext(j).getBusyContext().whenReady().then(function(){var e,r=document.activeElement,s=!1;!function(){if(!v){var e=a.getContext(j).getBusyContext(),t={description:"The oj-form div for oj-form-layout component with id = '"+n.id+"' is being rendered."};v=e.addBusyState(t)}}(),t._rootElementMutationObserver.disconnect(),(e=j)&&t._resizeHandler&&o.removeResizeListener(e,t._resizeHandler),function(){const e=j.querySelector(A);e&&j.removeChild(e)}(),function(){var e;if("start"===n.labelEdge){var t=parseInt(n.labelWidth,10);(isNaN(t)||t>0)&&j.classList.add("oj-form-cols-labels-inline"),n.classList.add("oj-formlayout-labels-inline"),j.classList.remove("oj-form-cols")}else j.classList.add("oj-form-cols"),j.classList.remove("oj-form-cols-labels-inline"),n.classList.remove("oj-formlayout-labels-inline");"truncate"===n.labelWrapping?j.classList.add(h):j.classList.remove(h);let i=x;if((x=U())!==i){var o="oj-formlayout-max-cols-"+x,a=n.className;-1!==a.indexOf("oj-formlayout-max-cols-")?n.className=a.replace(/oj-formlayout-max-cols-[\d+]/,o):n.classList.add(o)}"row"===n.direction?(e=1,j.classList.add("oj-formlayout-form-across")):(e=x,j.classList.remove("oj-formlayout-form-across"));j.style.columnCount=e,j.style.webkitColumnCount=e,j.style.MozColumnCount=e}(),w||function(){for(var e=j.querySelectorAll(f),t=e.length,n=0;n<t;++n){var i=e[n];Q(i)&&("OJ-LABEL"===i.tagName?(i.for="",i.parentElement.removeChild(i)):X(i))}}(),function(){var e=j.firstElementChild,t=0,i="column"===n.direction;for(;e;){var o=e.tagName.toLowerCase();if(-1!==o.indexOf("-"))if("oj-label"===o){var a=e;if(!(e=e.nextElementSibling))throw Z(n),Z(a),S(),N(),new Error("oj-form-layout component with id='"+n.id+"' has an oj-label child element with id='"+a.id+"' but has no next sibling element that it is associated with.")}else"oj-label-value"===o?w||e.refresh():e.classList.contains("oj-complete")?W(e):((i||t%x==0)&&e.setAttribute("data-oj-needs-oj-flex-div",""),C.push(e));t+=1,e=e.nextElementSibling}}(),function(){var e,t=[],i=j.children.length,o="column"===n.direction,a=0,r=0;!function(e,t){for(var n=t,i=e.length-1;i>=0;i--)n[i]=e[i]}(j.children,t);var s,d=0,c=!1,u=!1;for(;a<i;){var f=t[a];if(s=1,(o||r%x==0)&&(e=q(e,f)),-1===C.indexOf(f))if("oj-label"===f.tagName.toLowerCase())K(f,t[a+=1],e);else if("labelHint"in f&&B(f))K(f,null,e);else{if("colspan"in f&&f.colspan>1)if(o)c||(l.error('Colspan attribute is ignored unless direction is set to "row"'),c=!0);else{var m=x-d;s=Math.floor(f.colspan),"wrap"===n.colspanWrap&&m<s&&d>0?(z(e,r),r+=m,s=Math.min(s,x),e=q(e,f)):s=Math.min(s,m),!u&&x>1&&(u=!0)}K(f,null,e,s)}r+=s,o||r%x==0||P(e),d=r%x,a+=1}u&&!o?j.classList.add("oj-form-control-full-width"):j.classList.remove("oj-form-control-full-width");z(e,r)}(),i.Components&&i.Components.subtreeAttached(j),r&&(s=o.isAncestorOrSelf(n,r)),s&&setTimeout(function(){r.focus()},0),O(j),function(){const e=document.createElement("div");e.style.display="table",e.style.visibility="hidden",e.setAttribute(E,""),j.appendChild(e)}(),t._rootElementMutationObserver.observe(n,{childList:!0,subtree:!0,attributes:!0}),w&&(w=!1),S(),N()})}var r;L||(!(w||!n.hasAttribute(p))&&!(r=a.getContext(n).getBusyContext()).isReady()?(L=!0,r.whenReady().then(function(){L=!1,e()})):e())}}f.getDynamicDefaults=function(){var e=r.parseJSONFromFontFamily(u)||{};return{labelEdge:e.labelEdge,direction:e.direction}},d.extension._CONSTRUCTOR=f,d.extension._TRACK_CHILDREN="nearestCustomElement",d.extension._BINDING={provide:new Map([[s.FormVariantContext,"default"]])},i.CustomElementBridge.register("oj-form-layout",{metadata:i.CollectionUtils.mergeDeep(d,{properties:{readonly:{binding:{provide:[{name:"containerReadonly",default:!1},{name:"readonly"}],consume:{name:"containerReadonly"}}},userAssistanceDensity:{binding:{provide:[{name:"containerUserAssistanceDensity",default:"efficient"},{name:"userAssistanceDensity",default:"efficient"}],consume:{name:"containerUserAssistanceDensity"}}},labelEdge:{binding:{provide:[{name:"containerLabelEdge"},{name:"labelEdge",transform:{top:"provided",start:"provided"}}],consume:{name:"containerLabelEdge"}}},labelWidth:{binding:{provide:[{name:"labelWidth"}]}},labelWrapping:{binding:{provide:[{name:"labelWrapping"}]}}}})})});
//# sourceMappingURL=ojformlayout.js.map