/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojdvt-toolkit","ojs/ojdvt-timecomponent","ojs/ojtimeaxis-toolkit"],function(e,t,a,i){"use strict";var s={_DEFAULT_TIMEAXES_LABEL_STYLE:t.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color: #333333;",_DEFAULT_ZOOM_CONTROL_DIAMETER:31,_DEFAULT_ZOOM_CONTROL_PADDING:10.5,_DEFAULT_ZOOM_CONTROL_SPACING:9,_DEFAULT_COMPONENT_PADDING:0,_DEFAULT_STANDALONE_TASK_HEIGHT:22,_DEFAULT_BASELINE_MARGIN_TOP:0,_DEFAULT_BASELINE_TASK_HEIGHT:6,_DEFAULT_TASK_DOWNTIME_HEIGHT:4,_DEFAULT_TASK_ATTRIBUTE_HEIGHT:5,_DEFAULT_SUMMARY_THICKNESS:3,_DEFAULT_TASK_LABEL_PADDING:5,_DEFAULT_TASK_PADDING:5,_DEFAULT_TASK_EFFECT_MARGIN:2,_DEFAULT_TASK_TINT_FILTER_ID:"ojGanttTaskTintFilter",_DEFAULT_TASK_SHADE_FILTER_ID:"ojGanttTaskShadeFilter",_DEFAULT_TASK_TINT_ALPHA:.3,_DEFAULT_TASK_SHADE_ALPHA:.35,_DEFAULT_AXIS_HEIGHT:23,_ROW_LABELS_AXIS_GAP:0,_ROW_LABEL_EXPAND_COLLAPSE_BUTTON_SIZE:24,_ROW_LABEL_INDENT_SIZE:24,_ROW_LABEL_BUTTON_CONTENT_GAP_SIZE:8,_ROW_LABEL_CONTAINER_PADDING:8,_DEFAULT_DEPENDENCY_LINE_INNER_COLOR:"#ffffff",_DEFAULT_DEPENDENCY_LINE_INNER_WIDTH:2,_DEFAULT_ANIMATION_DURATION:.5,_DEPENDENCY_LINE_ARC_RADIUS:6,_DEPENDENCY_LINE_TASK_FLANK_LENGTH:20,_DEPENDENCY_TRIANGLE_MARKER_HEIGHT:8,_DEPENDENCY_TRIANGLE_MARKER_WIDTH:6,_DEPENDENCY_ANGLE_MARKER_HEIGHT:12,_DEPENDENCY_ANGLE_MARKER_WIDTH:8,_DEPENDENCY_CIRCLE_MARKER_RADIUS:3,_DEPENDENCY_TRIANGLE_MARKER_ID:"ojGanttDependencyMarkerEndTriangle",_DEPENDENCY_ANGLE_MARKER_ID:"ojGanttDependencyMarkerEndAngle",_DEPENDENCY_OPEN_CIRCLE_MARKER_ID:"ojGanttDependencyMarkerOpenCircle",_DEPENDENCY_CLOSED_CIRCLE_MARKER_ID:"ojGanttDependencyMarkerClosedCircle",_AUTOPAN_EDGE_THRESHOLD:20,_DEFAULT_TASK_RESIZE_HANDLE_WIDTH:5,_DEFAULT_TASK_RESIZE_HANDLE_WIDTH_TOUCH:20,getHorizontalScrollbarStyle:()=>new t.CSSStyle(s._DEFAULT_HORIZONTAL_SCROLLBAR_STYLE),getVerticalScrollbarStyle:()=>new t.CSSStyle(s._DEFAULT_VERTICAL_SCROLLBAR_STYLE),getStandaloneTaskHeight:e=>{var t=e?e._resources:null;return t&&t.taskDefaults&&null!=t.taskDefaults.height?s.getSizeInPixels(t.taskDefaults.height):s._DEFAULT_STANDALONE_TASK_HEIGHT},getActualTaskHeight:(e,t)=>"alta"===t.getThemeBehavior()?s.getStandaloneTaskHeight(e)-s.getBaselineMarginTop(e)-s.getBaselineTaskHeight(e):s.getStandaloneTaskHeight(e),getBaselineMarginTop:e=>{var t=e?e._resources:null;return t&&t.baselineMarginTop?s.getSizeInPixels(t.baselineMarginTop):s._DEFAULT_BASELINE_MARGIN_TOP},getBaselineTaskHeight:e=>{var t=e?e._resources:null;return t&&t.taskDefaults&&t.taskDefaults.baseline&&null!=t.taskDefaults.baseline.height?s.getSizeInPixels(t.taskDefaults.baseline.height):s._DEFAULT_BASELINE_TASK_HEIGHT},getTaskDowntimeHeight:e=>{var t=e?e._resources:null;return t&&t.taskDowntimeHeight?s.getSizeInPixels(t.taskDowntimeHeight):s._DEFAULT_TASK_DOWNTIME_HEIGHT},getTaskAttributeHeight:e=>{var t=e?e._resources:null;return t&&t.taskAttributeHeight?s.getSizeInPixels(t.taskAttributeHeight):s._DEFAULT_TASK_ATTRIBUTE_HEIGHT},getMilestoneBaselineYOffset:e=>s.getBaselineTaskHeight(e),getSummaryThickness:()=>s._DEFAULT_SUMMARY_THICKNESS,getRowPaddingTop:e=>{var t=e?e._resources:null;return t&&null!=t.rowPaddingTop?s.getSizeInPixels(t.rowPaddingTop):s._DEFAULT_TASK_PADDING},getRowPaddingBottom:e=>{var t=e?e._resources:null;return t&&null!=t.rowPaddingBottom?s.getSizeInPixels(t.rowPaddingBottom):s._DEFAULT_TASK_PADDING},getTaskPadding:e=>{var t=e?e._resources:null;return t&&null!=t.taskPaddingLeft?s.getSizeInPixels(t.taskPaddingLeft):s._DEFAULT_TASK_LABEL_PADDING},getTaskMargin:e=>{var t=e?e._resources:null;return t&&null!=t.taskMarginLeft?s.getSizeInPixels(t.taskMarginLeft):s._DEFAULT_TASK_LABEL_PADDING},getTaskLabelMargin:e=>{var t=e?e._resources:null;return t&&null!=t.taskLabelMarginLeft?s.getSizeInPixels(t.taskLabelMarginLeft):s._DEFAULT_TASK_LABEL_PADDING},getTaskEffectMargin:()=>s._DEFAULT_TASK_EFFECT_MARGIN,getTaskTintFilterId:()=>s._DEFAULT_TASK_TINT_FILTER_ID,getTaskShadeFilterId:()=>s._DEFAULT_TASK_SHADE_FILTER_ID,getTaskTintAlpha:()=>s._DEFAULT_TASK_TINT_ALPHA,getTaskShadeAlpha:()=>s._DEFAULT_TASK_SHADE_ALPHA,getTimeAxisHeight:(e,t)=>{var a=e[t];if(a&&a.height)return a.height;var i=e._resources;return i&&i[t]&&null!=i[t].height?s.getSizeInPixels(i[t].height):s._DEFAULT_AXIS_HEIGHT},getMajorAxisLabelStyle:e=>{var a=e._resources,i=s._DEFAULT_TIMEAXES_LABEL_STYLE;return a&&(i=a.majorAxisLabelFontProp),new t.CSSStyle(i)},getMinorAxisLabelStyle:e=>{var a=e._resources,i=s._DEFAULT_TIMEAXES_LABEL_STYLE;return a&&(i=a.minorAxisLabelFontProp),new t.CSSStyle(i)},getRowAxisGap:()=>s._ROW_LABELS_AXIS_GAP,getDependencyLineTaskFlankLength:()=>s._DEPENDENCY_LINE_TASK_FLANK_LENGTH,getDependencyLineArcRadius:e=>"alta"===e.getThemeBehavior()?0:s._DEPENDENCY_LINE_ARC_RADIUS,getDependencyLineTriangleMarkerWidth:()=>s._DEPENDENCY_TRIANGLE_MARKER_WIDTH,getDependencyLineTriangleMarkerHeight:()=>s._DEPENDENCY_TRIANGLE_MARKER_HEIGHT,getDependencyLineAngleMarkerWidth:()=>s._DEPENDENCY_ANGLE_MARKER_WIDTH,getDependencyLineAngleMarkerHeight:()=>s._DEPENDENCY_ANGLE_MARKER_HEIGHT,getDependencyLineCircleMarkerRadius:()=>s._DEPENDENCY_CIRCLE_MARKER_RADIUS,getDependencyLineTriangleMarkerId:()=>s._DEPENDENCY_TRIANGLE_MARKER_ID,getDependencyLineAngleMarkerId:()=>s._DEPENDENCY_ANGLE_MARKER_ID,getDependencyLineOpenCircleMarkerId:()=>s._DEPENDENCY_OPEN_CIRCLE_MARKER_ID,getDependencyLineClosedCircleMarkerId:()=>s._DEPENDENCY_CLOSED_CIRCLE_MARKER_ID,getDependencyLineTaskGap:e=>s.getRowPaddingTop(e)-1,getAutoPanEdgeThreshold:()=>s._AUTOPAN_EDGE_THRESHOLD,getTaskLabelStyle:e=>{var a=e._resources,i="";return a&&(i=a.taskLabelFontProp),new t.CSSStyle(i)},getRowLabelStyle:e=>{var a=e._resources,i="";return a&&(i=a.rowLabelFontProp),new t.CSSStyle(i)},getRowLabelPaddingStart:e=>{var t=e?e._resources:null;return t&&null!=t.rowLabelPaddingStart?s.getSizeInPixels(t.rowLabelPaddingStart):s._ROW_LABEL_CONTAINER_PADDING},getRowLabelPaddingEnd:e=>{var t=e?e._resources:null;return t&&null!=t.rowLabelPaddingEnd?s.getSizeInPixels(t.rowLabelPaddingEnd):s._ROW_LABEL_CONTAINER_PADDING},getRowLabelButtonSize:()=>s._ROW_LABEL_EXPAND_COLLAPSE_BUTTON_SIZE,getRowLabelIndentSize:()=>s._ROW_LABEL_INDENT_SIZE,getRowLabelButtonContentGapSize:()=>s._ROW_LABEL_BUTTON_CONTENT_GAP_SIZE,getChartStrokeWidth:e=>{var a=e._resources;if(a){var i=a.chartArea;if(i){var s=i.strokeWidth;if(s)return t.CSSStyle.toNumber(s)}}return 1},getComponentPaddingStart:e=>{var t=e?e._resources:null;return t&&null!=t.componentPaddingStart?s.getSizeInPixels(t.componentPaddingStart):s._DEFAULT_COMPONENT_PADDING},getHorizontalGridlineWidth:e=>e._resources?t.CSSStyle.toNumber(e._resources.horizontalGridlineWidth):1,getAnimationDuration:e=>{var a,i=s._DEFAULT_ANIMATION_DURATION;return e._resources&&(a=e._resources.animationDuration)&&(i=t.CSSStyle.getTimeMilliseconds(a)/1e3),i},getFocusedDependencyLineInnerColor:()=>s._DEFAULT_DEPENDENCY_LINE_INNER_COLOR,getFocusedDependencyLineInnerWidth:()=>s._DEFAULT_DEPENDENCY_LINE_INNER_WIDTH,getTaskResizeHandleWidth:()=>t.Agent.isTouchDevice()?s._DEFAULT_TASK_RESIZE_HANDLE_WIDTH_TOUCH:s._DEFAULT_TASK_RESIZE_HANDLE_WIDTH,getSizeInPixels:(e,t)=>{if("string"==typeof e){if("%"===e.slice(-1))return t*Number(e.slice(0,-1))/100;if("px"===e.slice(-2))return Number(e.slice(0,-2));e=Number(e)}return"number"==typeof e?e<=1&&null!=t?t*e:e:0},hasClass:(e,t)=>e.getElem().classList.contains(t)};class n extends t.Container{constructor(e){super(e.getCtx(),null),this._gantt=e,this._gantt.getEventManager().associate(this,this),this.nodeType="dependency"}getGantt(){return this._gantt}getId(){return this._dependencyObj.id}setLayoutObject(e){this._dependencyObj=e}getLayoutObject(){return this._dependencyObj}getValue(e){var t;switch(e){case"type":t=this._dependencyObj.type;break;case"predecessorTaskId":t=this._dependencyObj.predecessorTaskObj.id;break;case"successorTaskId":t=this._dependencyObj.successorTaskObj.id;break;default:t=this._dependencyObj.data[e]}return t}getPredecessorNode(){return this._dependencyObj.predecessorTaskObj.node}getSuccessorNode(){return this._dependencyObj.successorTaskObj.node}static _getTaskStart(e,a){var i=t.Agent.isRightToLeft(e.getGantt().getCtx()),n=e.getGantt().getOptions(),r=e.getTask().getShape("main"),o=e.getTaskLabel(),h=o.getLabelOutputText(),l=o.getEffectiveLabelPosition(),d=s.getTaskLabelMargin(n),g=a?0:s.getTaskMargin(n);return i?a||null==h||null==h.getParent()||"end"!==l?e.getFinalX()+r.getFinalX()-r.getFinalWidth()-r.getPhysicalEndOffset()-g:e.getFinalX()+r.getFinalX()-r.getFinalWidth()-r.getPhysicalEndOffset()-h.getDimensions().w-2*d:a||null==h||null==h.getParent()||"start"!==l?e.getFinalX()+r.getFinalX()-r.getPhysicalStartOffset()-g:e.getFinalX()+r.getFinalX()-r.getPhysicalStartOffset()-h.getDimensions().w-2*d}static _getTaskMiddle(e){var t=e.getTask(),a=t.getShape("main"),i=e.getGantt().getCtx().getThemeBehavior(),s=t.isSummary("main")&&"alta"===i?e.getLayoutObject().height:a.getFinalHeight();return n._getTaskTop(e)+a.getFinalY()+Math.round(s/2)}static _getTaskEnd(e,a){var i=t.Agent.isRightToLeft(e.getGantt().getCtx()),n=e.getGantt().getOptions(),r=e.getTask().getShape("main"),o=e.getTaskLabel(),h=o.getLabelOutputText(),l=o.getEffectiveLabelPosition(),d=s.getTaskLabelMargin(n),g=a?0:s.getTaskMargin(n);return i?a||null==h||null==h.getParent()||"start"!==l?e.getFinalX()+r.getFinalX()+r.getPhysicalStartOffset()+g:e.getFinalX()+r.getFinalX()+r.getPhysicalStartOffset()+h.getDimensions().w+2*d:a||null==h||null==h.getParent()||"end"!==l?e.getFinalX()+r.getFinalX()+r.getFinalWidth()+r.getPhysicalEndOffset()+g:e.getFinalX()+r.getFinalX()+r.getFinalWidth()+r.getPhysicalEndOffset()+h.getDimensions().w+2*d}static _getTaskTop(e){return e.getFinalY()}static _getTaskBottom(e,t){var a=t?e.getLayoutObject().height:e.getFinalHeight();return n._getTaskTop(e)+a}static _isValidType(e){return e===n.START_START||e===n.START_FINISH||e===n.FINISH_START||e===n.FINISH_FINISH}isCustomContent(){var e=this._gantt.getOptions();return e.dependencyContent&&e.dependencyContent.renderer}getRendererContext(e){var t=this._gantt.getOptions(),a=this._gantt.getCtx(),i=this.getValue("type"),s=this.getPredecessorNode(),r=this.getSuccessorNode(),o=n._getRenderingTypeState(a,i),h=n._getEndPoints(s,r,o.isTypeBeginFinish,o.isTypeEndFinish,!0,!0),l={data:this.getLayoutObject().data,itemData:t.dependencyData?this.getLayoutObject()._itemData:null,content:{predecessorX:h.predecessorX,predecessorY:h.predecessorY,successorX:h.successorX,successorY:h.successorY},state:e};return a.fixRendererContext(l)}_renderCustomContent(e){var a=this.getGantt(),i=a.getOptions();this._content&&this.removeChild(this._content),this._content=new t.Container(a.getCtx()),this._content.setClassName(a.GetStyleClass("dependencyLineCustom")),this.addChild(this._content);var s=this._content.getContainerElem(),n=(0,i.dependencyContent.renderer)(this.getRendererContext(e));n&&(Array.isArray(n)?n.forEach(e=>{t.ToolkitUtils.appendChildElem(s,e)}):t.ToolkitUtils.appendChildElem(s,n))}render(e,a){a=!1!==a;this.getParent()!=e&&e.addChild(this),this.setAriaRole("img");var i=this.getGantt(),r=i.getCtx(),o=this.getValue("type"),h=this.getPredecessorNode(),l=this.getSuccessorNode();if(t.Agent.deferAriaCreation()||this.setAriaProperty("label",this.getAriaLabel()),this.isCustomContent())this._content&&!a||this._renderCustomContent({focused:!1});else{if("ie"!==t.Agent.browser&&"edge"!==t.Agent.browser||this._cleanup(),null!=this._line){this._line.setCmds(n._calcDepLine(r,h,l,o));var d=this._line.getElem()}else{var g=new t.Path(r,n._calcDepLine(r,h,l,o));0===s.getDependencyLineArcRadius(r)&&g.setPixelHinting(!0),d=g.getElem(),this.addChild(g);var _=new t.Stroke(s.getFocusedDependencyLineInnerColor(),1,s.getFocusedDependencyLineInnerWidth()),c=new t.Stroke("#000",1,1);g.setHoverStroke(_,c),this._line=g}var u=this.getValue("svgStyle");u&&this._line.setStyle(u);var p=i.GetStyleClass("dependencyLine");"straight"===i.getOptions().dependencyLineShape?(p+=" "+i.GetStyleClass("dependencyStraightLine"),h.isSelected()?p+=" "+i.GetStyleClass("dependencyStartOpenStraightLine"):p+=" "+i.GetStyleClass("dependencyStartClosedStraightLine"),l.isSelected()?p+=" "+i.GetStyleClass("dependencyEndOpenStraightLine"):p+=" "+i.GetStyleClass("dependencyEndClosedStraightLine")):p+=" "+i.GetStyleClass("dependencyRectilinearLine");var m=this.getValue("svgClassName");m?t.ToolkitUtils.setAttrNullNS(d,"class",p+" "+m):t.ToolkitUtils.setAttrNullNS(d,"class",p)}}hide(){this.setAlpha(0)}show(){this.setAlpha(1)}_cleanup(){null!=this._line&&(this.removeChild(this._line),this._line=null)}_calcConflict(){var e=!1,t=!1,a=this.getValue("type"),i=this.getGantt().getNavigableDependencyLinesForTask(this.getPredecessorNode(),"predecessor");if(null!=i)for(var s=0;s<i.length;s++){var r=i[s].getValue("type");(a!==n.START_START&&a!==n.START_FINISH||r!==n.START_START&&r!==n.FINISH_START)&&(a!==n.FINISH_FINISH&&a!==n.FINISH_START||r!==n.FINISH_FINISH&&r!==n.START_FINISH)||(e=!0)}if(null!=(i=this.getGantt().getNavigableDependencyLinesForTask(this.getSuccessorNode(),"successor")))for(s=0;s<i.length;s++)r=i[s].getValue("type"),(a!==n.START_START&&a!==n.FINISH_START||r!==n.START_START&&r!==n.START_FINISH)&&(a!==n.FINISH_FINISH&&a!==n.START_FINISH||r!==n.FINISH_FINISH&&r!==n.FINISH_START)||(t=!0);return e&&t?n.CONFLICT_BOTH:e?n.CONFLICT_PREDECESSOR:t?n.CONFLICT_SUCCESSOR:n.CONFLICT_NONE}static _getEndPoints(e,t,a,i,s,r){return{predecessorX:a?n._getTaskEnd(e,s):n._getTaskStart(e,s),predecessorY:r||e.getTask().isMilestone("main")?n._getTaskMiddle(e):n._getTaskBottom(e,!0),successorX:i?n._getTaskEnd(t,s):n._getTaskStart(t,s),successorY:r||t.getTask().isMilestone("main")?n._getTaskMiddle(t):n._getTaskTop(t)}}static _getRenderingTypeState(e,a){var i=t.Agent.isRightToLeft(e);switch(a){case n.START_START:return i?{isTypeBeginFinish:!0,isTypeEndFinish:!0}:{isTypeBeginFinish:!1,isTypeEndFinish:!1};case n.START_FINISH:return i?{isTypeBeginFinish:!0,isTypeEndFinish:!1}:{isTypeBeginFinish:!1,isTypeEndFinish:!0};case n.FINISH_START:return i?{isTypeBeginFinish:!1,isTypeEndFinish:!0}:{isTypeBeginFinish:!0,isTypeEndFinish:!1};case n.FINISH_FINISH:return i?{isTypeBeginFinish:!1,isTypeEndFinish:!1}:{isTypeBeginFinish:!0,isTypeEndFinish:!0}}return null}static _calcDepLine(e,t,a,i){var s=this._getRenderingTypeState(e,i);return"straight"===t.getGantt().getOptions().dependencyLineShape?n._calcStraightLine(t,a,s.isTypeBeginFinish,s.isTypeEndFinish):n._calcRectilinearLine(t,a,s.isTypeBeginFinish,s.isTypeEndFinish)}static _calcStraightLine(e,a,i,s){var r=n._getEndPoints(e,a,i,s,!0,!1),o=r.predecessorX,h=r.successorX,l=r.predecessorY,d=r.successorY;return t.PathUtils.moveTo(o,l)+t.PathUtils.lineTo(h,d)}static _calcRectilinearLine(e,a,i,r){var o=e.getGantt(),h=s.getDependencyLineArcRadius(o.getCtx()),l=s.getDependencyLineTaskFlankLength(),d=n._getEndPoints(e,a,i,r,!1,!0),g=d.predecessorX,_=d.successorX,c=d.predecessorY,u=d.successorY,p=o.getOptions(),m=s.getDependencyLineTaskGap(p),b=u>=c?n._getTaskBottom(e)+m:n._getTaskTop(e)-m;g=Math.round(g)+.5,_=Math.round(_)+.5,c=Math.round(c)+.5,u=Math.round(u)+.5,b=Math.round(b)+.5;var D=g+(i?1:-1)*l,v=r?_+l:_-l,S=t.PathUtils.moveTo(g,c);return i&&v<D||!i&&v>D?(S+=t.PathUtils.horizontalLineTo(D+(i?-1:1)*h),u>c?(S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,D,c+h),i&&r||!i&&!r?(S+=t.PathUtils.verticalLineTo(u-h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,D+(i?-1:1)*h,u)):(S+=t.PathUtils.verticalLineTo(b-h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,D+(i?-1:1)*h,b),S+=t.PathUtils.horizontalLineTo(v+(i?1:-1)*h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?0:1,v,b+h),S+=t.PathUtils.verticalLineTo(u-h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?0:1,v+(i?1:-1)*h,u))):u<c?(S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?0:1,D,c-h),i&&r||!i&&!r?(S+=t.PathUtils.verticalLineTo(u+h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?0:1,D+(i?-1:1)*h,u)):(S+=t.PathUtils.verticalLineTo(b+h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?0:1,D+(i?-1:1)*h,b),S+=t.PathUtils.horizontalLineTo(v+(i?1:-1)*h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,v,b-h),S+=t.PathUtils.verticalLineTo(u+h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,v+(i?1:-1)*h,u))):(S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,D,c+h),S+=t.PathUtils.verticalLineTo(b-h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,D+(i?-1:1)*h,b),S+=t.PathUtils.horizontalLineTo(v+(i?1:-1)*h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,v,b-h),S+=t.PathUtils.verticalLineTo(u+h),S+=r?t.PathUtils.arcTo(h,h,Math.PI/2,0,v-h,u):t.PathUtils.arcTo(h,h,Math.PI/2,1,v+h,u))):u>c?(S+=t.PathUtils.horizontalLineTo(v+(i?-1:1)*h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,v,c+h),S+=t.PathUtils.verticalLineTo(u-h),S+=r?t.PathUtils.arcTo(h,h,Math.PI/2,1,v-h,u):t.PathUtils.arcTo(h,h,Math.PI/2,0,v+h,u)):u<c?(S+=t.PathUtils.horizontalLineTo(v+(i?-1:1)*h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?0:1,v,c-h),S+=t.PathUtils.verticalLineTo(u+h),S+=r?t.PathUtils.arcTo(h,h,Math.PI/2,0,v-h,u):t.PathUtils.arcTo(h,h,Math.PI/2,1,v+h,u)):(i&&r||!i&&!r)&&(S+=t.PathUtils.horizontalLineTo(D+(i?-1:1)*h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?1:0,D,c+h),S+=t.PathUtils.verticalLineTo(b-h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?0:1,D+(i?1:-1)*h,b),S+=t.PathUtils.horizontalLineTo(v-h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?0:1,v,b-h),S+=t.PathUtils.verticalLineTo(u+h),S+=t.PathUtils.arcTo(h,h,Math.PI/2,i?0:1,v+(i?-1:1)*h,u)),S+=t.PathUtils.lineTo(_,u)}getNextNavigable(e){if(e.keyCode===t.KeyboardEvent.UP_ARROW||e.keyCode===t.KeyboardEvent.DOWN_ARROW){var a=this.getKeyboardFocusTask();a||(a=this.getPredecessorNode());var i=this,s=this.getGantt().getEventManager().getKeyboardHandler();if(s&&s.getNextNavigableDependencyLine){var n=a===this.getPredecessorNode()?"successor":"predecessor",r=this.getGantt().getNavigableDependencyLinesForTask(a,n);i=s.getNextNavigableDependencyLine(a,this,e,r)}return i.setKeyboardFocusTask(a),i}return e.keyCode===t.KeyboardEvent.RIGHT_ARROW||e.keyCode===t.KeyboardEvent.LEFT_ARROW?t.Agent.isRightToLeft(this.getGantt().getCtx())?e.keyCode===t.KeyboardEvent.LEFT_ARROW?this.getSuccessorNode():this.getPredecessorNode():e.keyCode===t.KeyboardEvent.RIGHT_ARROW?this.getSuccessorNode():this.getPredecessorNode():e.type===t.MouseEvent.CLICK?this:null}setKeyboardFocusTask(e){this._keyboardNavNode=e}getKeyboardFocusTask(){return this._keyboardNavNode}getKeyboardBoundingBox(e){return this.getDimensions(e)}getTargetElem(){return this._content?this._content.getContainerElem():this._line.getElem()}showKeyboardFocusEffect(){this.isCustomContent()?(this._renderCustomContent({focused:!0}),this._isShowingKeyboardFocusEffect=!0):this._line&&(t.ToolkitUtils.addClassName(this._line.getElem(),this._gantt.GetStyleClass("focus")),this._line.showHoverEffect(),this._isShowingKeyboardFocusEffect=!0)}hideKeyboardFocusEffect(){this.isShowingKeyboardFocusEffect()&&(this.isCustomContent()?this._renderCustomContent({focused:!1}):(this._line.hideHoverEffect(),t.ToolkitUtils.removeClassName(this._line.getElem(),this._gantt.GetStyleClass("focus"))),this._isShowingKeyboardFocusEffect=!1)}isShowingKeyboardFocusEffect(){return this._isShowingKeyboardFocusEffect}getDatatip(e,t,a){return this.getAriaLabel()}getAriaLabel(){return this._dependencyObj.ariaLabel}}n.START_START="startStart",n.START_FINISH="startFinish",n.FINISH_START="finishStart",n.FINISH_FINISH="finishFinish",n.CONFLICT_NONE=0,n.CONFLICT_PREDECESSOR=1,n.CONFLICT_SUCCESSOR=2,n.CONFLICT_BOTH=3;class r{constructor(e,t){this._rowAxis=e,this._gantt=e._gantt,this._contentType=t,this.nodeType="rowLabel"}render(e){var a=e.data;this._labelString=null!=a.label?a.label:"";var i=null!=a.shortDesc?a.shortDesc:"";this._shortDesc="function"==typeof i?i({data:e.data,itemData:e.data._itemData}):i;var s=t.Agent.isRightToLeft(this._gantt.getCtx()),n=this._rowAxis.getAvailableWidth();this._contentBackground||(this._contentBackground=new t.Rect(this._gantt.getCtx(),0,e.y,0,e.height),this._contentBackground.setPixelHinting(!0),this._contentBackground.setClassName(this._gantt.GetStyleClass("row")),this._gantt.getEventManager().associate(this._contentBackground,this,!0)),this._contentBackground.getParent()||this._rowAxis.addLabelBackground(this._contentBackground),this._content||(this._content="custom"===this._contentType?this._getCustomContent(e,n):this._getTextContent(e),this._content.setAriaRole("rowheader",!0)),this._contentDisplayable||(this._contentDisplayable=this._gantt.isRowsHierarchical()?this._addExpandCollapseButton(this._content,e):this._content,this._gantt.getEventManager().associate(this._contentDisplayable,this,!0)),this._contentDisplayable.getParent()||this._rowAxis.addLabelContent(this._contentDisplayable);var r=this._contentDisplayable.getDimensions();"g"===this.getDisplayableType()?(this._width=s?-Math.min(0,r.x):r.x+r.w,this._width=Math.max(0,this._width),this._yTopOFfset=r.y):(this._width=Math.min(r.w,n.calculatedWidth),this._yTopOFfset=0),this._height=r.h,this._contentDisplayable.setAriaProperty("label",this.getAriaLabel()),this._contentDisplayable.setAriaRole("row",!0),this._contentDisplayable.setAriaProperty("hidden",null)}_getCustomContent(e,a){var i=e.data,n=new t.Container(this._gantt.getCtx()),r=i.labelStyle;null!=r&&n.setStyle(r);var o=this._gantt.getOptions(),h=o.rowAxis.label.renderer,l=s.getRowLabelPaddingStart(o)+s.getRowLabelPaddingEnd(o),d=this._gantt.getRowAxisMaxWidth();if(-1===a.width&&null!=d&&"none"===d)var g=-1;else g=this._gantt.isRowsHierarchical()?Math.max(0,a.calculatedWidth-this._rowAxis.getLabelContentIndentSize(e))-l:Math.max(0,a.calculatedWidth-l);var _=e.height,c=n.getContainerElem(),u=h(this.getRendererContext(e,g,_,c));return u&&(Array.isArray(u)?u.forEach(e=>{t.ToolkitUtils.appendChildElem(c,e)}):t.ToolkitUtils.appendChildElem(c,u)),n}_getTextContent(e){var a=e.data,i=new t.OutputText(this._gantt.getCtx(),this._labelString,0,0),s=a.labelStyle;return null!=s&&""!==s&&0!==Object.keys(s).length&&i.setStyle(s),i.setCSSStyle(this._rowAxis._getCSSStyle(s)),i}_addExpandCollapseButton(e,a){var i=t.Agent.isRightToLeft(this._gantt.getCtx()),n=new t.Container(this._gantt.getCtx()),r=this._rowAxis.getLabelContentIndentSize(a),o=i?-r:r;if(i&&"text"===this._contentType&&(o-=e.getDimensions().w),e.setTranslateX(o),n.addChild(e),this._rowAxis.addLabelContent(n),null!=a.expanded){var h=s.getRowLabelButtonSize(),l=r-(h+s.getRowLabelButtonContentGapSize());l=i?-(l+h):l;var d=(e.getDimensions().h-h)/2,g=this._gantt.getEventManager(),_=this._createExpandCollapseButton(this._gantt.getCtx(),this._gantt.getOptions()._resources,a.expanded?"open":"closed",l,d,h,g.onExpandCollapseButtonClick,g);this._button=_,n.addChild(_)}else this._button=null;return n}_createExpandCollapseButton(e,a,i,s,n,r,o,h){var l=t.ToolkitUtils.getIconStyle(e,a[i]),d=new t.IconButton(e,"borderless",{style:l,size:r},null,null,o,h);return d.setTranslate(s,n),d.setAriaRole("button"),d.setAriaProperty("label",this.getAriaLabel()),this._gantt.getEventManager().associate(d,this),d}getRendererContext(e,t,i,s){var n=this._gantt.getOptions(),r=this._gantt.getDataLayoutManager(),o=e.data,h=o.tasks,l=[],d=n.rowData||n.taskData;if(d)for(var g=0;g<h.length;g++)l.push(h[g]._itemData);var _=r.getParentRowObj(e),c={component:n._widgetConstructor,parentElement:s,rowData:a.TimeComponent.sanitizeData(o,"row"),itemData:d?l:null,maxWidth:t,maxHeight:i,data:n.rowData?o._itemData:null,depth:e.depth,leaf:null==e.expanded,parentKey:_?_.id:null};return this._gantt.getCtx().fixRendererContext(c)}getRow(){return this._rowNode}setRow(e){this._rowNode=e}getRowIndex(){return this._rowIndex}setRowIndex(e){this._rowIndex=e}getRowLayoutObject(){return this._gantt.getRowLayoutObjs()[this.getRowIndex()]}getDisplayable(){return this._contentDisplayable}getBackground(){return this._contentBackground}getExpandCollapseButton(){return this._button}getLabelString(){return this._labelString}getDisplayableType(){return this._gantt.isRowsHierarchical()||"custom"===this._contentType?"g":"text"}getContentType(){return this._contentType}getX(){return"text"===this.getDisplayableType()?this._contentDisplayable.getX():this._contentDisplayable.getTranslateX()}setX(e){"text"===this.getDisplayableType()?this._contentDisplayable.setX(e):this._contentDisplayable.setTranslateX(e)}getY(){return"text"===this.getDisplayableType()?this._contentDisplayable.getY():this._contentDisplayable.getTranslateY()}setY(e){"text"===this.getDisplayableType()?this._contentDisplayable.setY(e):this._contentDisplayable.setTranslateY(e)}getWidth(){return this._width}getHeight(){return this._height}getYTopOffset(){return this._yTopOFfset}getAriaLabel(){var e=this._gantt.getOptions().translations,a=[],i=this.getRowLayoutObject();null!=i.expanded&&a.push(e[i.expanded?"stateExpanded":"stateCollapsed"]);var s=this._shortDesc||this.getLabelString();return this._gantt.isRowsHierarchical()&&(s=e.labelLevel+" "+i.depth+", "+s),t.Displayable.generateAriaLabel(s,a)}ensureInDOM(){null===this._contentDisplayable.getParent()&&(this._rowAxis.addLabelBackground(this._contentBackground),this._rowAxis.addLabelContent(this._contentDisplayable))}remove(){this._rowAxis.removeLabelBackground(this._contentBackground),this._rowAxis.removeLabelContent(this._contentDisplayable)}getNextNavigable(e){var a=t.Agent.isRightToLeft(this._gantt.getCtx()),i=this._gantt.getEventManager(),s=this._gantt.getDataLayoutManager(),n=this._gantt.getRowLayoutObjs(),r=this.getRowLayoutObject();if(e.altKey&&(!a&&e.keyCode===t.KeyboardEvent.RIGHT_ARROW||a&&e.keyCode===t.KeyboardEvent.LEFT_ARROW)){if(0===r.taskObjs.length)return this;var o=i.getLastFocusedTask();if(o&&t.Obj.compareValues(this._gantt.getCtx(),o.getLayoutObject().rowObj.id,r.id))return s.ensureInDOM(o.getLayoutObject(),"task"),o;var h=r.taskObjs[0];s.ensureInDOM(h,"task");var l=h.node;return i.setLastFocusedTask(l),l}if(e.keyCode===t.KeyboardEvent.UP_ARROW){var d=n[Math.max(0,r.index-1)];return s.ensureInDOM(d,"row"),d.node.getRowLabelContent()}if(e.keyCode===t.KeyboardEvent.DOWN_ARROW){var g=n[Math.min(n.length-1,r.index+1)];return s.ensureInDOM(g,"row"),g.node.getRowLabelContent()}return this}getTargetElem(){return this._contentDisplayable.getElem()}getKeyboardBoundingBox(e){return this._contentDisplayable.getDimensions(e)}showKeyboardFocusEffect(){this._isShowingKeyboardFocusEffect=!0,this.getRowLayoutObject().node.scrollIntoView();var e=this._contentBackground.getElem();t.ToolkitUtils.addClassName(e,this._gantt.GetStyleClass("focusHighlight"))}hideKeyboardFocusEffect(){var e=this._contentBackground.getElem();t.ToolkitUtils.removeClassName(e,this._gantt.GetStyleClass("focusHighlight")),this._isShowingKeyboardFocusEffect=!1}isShowingKeyboardFocusEffect(){return this._isShowingKeyboardFocusEffect}getDatatip(){return this._shortDesc}}class o extends t.Path{constructor(e,t,a,i,s,n,r,o,h){var l;switch(super(e,null,h),this._context=e,this._x=t,this._y=a,this._w=i,this._h=s,this._r=null!=n?n:"0",this._task=r,this._type=o,this._isHighlighted=!1,this._renderState="add",this._typeCmdGeneratorMap={main:this._generateRepShapeCmd,mainBackground:this._generateRepShapeCmd,mainSelect:this._generateRepShapeCmd,mainHover:this._generateRepShapeCmd,mainFocus:this._generateRepShapeCmd,mainDragFeedback:this._generateRepShapeCmd,mainResizeHandleStart:this._generateRectCmd,mainResizeHandleEnd:this._generateRectCmd,mainResizeHandleDragFeedback:this._generateRectCmd,progress:this._generateRectCmd,progressZero:this._generateRectCmd,progressFull:this._generateRectCmd,baseline:this._generateRepShapeCmd,baselineSelect:this._generateRepShapeCmd,baselineHover:this._generateRepShapeCmd,overtime:this._generateRectCmd,downtime:this._generateRectCmd,attribute:this._generateRectCmd},l=this.generateCmd(this._x,this._y,this._w,this._h,this._r),this.setCmds(l),this.applyStyleClasses(),this._type){case"mainDragFeedback":case"mainResizeHandleDragFeedback":this.setMouseEnabled(!1);case"mainResizeHandleStart":case"mainResizeHandleEnd":r.getGantt().getEventManager().associate(this,r.getContainer());case"main":case"progress":case"progressZero":case"progressFull":case"baseline":case"overtime":case"downtime":case"attribute":this.setPixelHinting("alta"===e.getThemeBehavior())}}_generateRepShapeCmd(e,a,i,n,r){var h,l=t.Agent.isRightToLeft(this._context),d=(o.MAIN_EFFECT_TYPES.indexOf(this._type)>-1||o.BASELINE_EFFECT_TYPES.indexOf(this._type)>-1)*s.getTaskEffectMargin();return"alta"!==this._context.getThemeBehavior()&&"mainHover"===this._type&&(d=0),this._task.isMilestone(this._type)&&0===i?(h=d*Math.sqrt(2),this._generateDiamondCmd(e,a-h,n+2*h,r)):this._task.isSummary(this._type)&&"main"===this._type?this._generateSummaryCmd(e,a,i,n,r):this._generateRectCmd(l?e+d:e-d,a-d,i+2*d,n+2*d,r)}_generateRectCmd(e,a,i,s,n){var r=t.Agent.isRightToLeft(this._context);return"0"===n||"0px"===n?t.PathUtils.moveTo(e,a)+t.PathUtils.horizontalLineTo(r?e-i:e+i)+t.PathUtils.verticalLineTo(a+s)+t.PathUtils.horizontalLineTo(e)+t.PathUtils.closePath():t.PathUtils.rectangleWithBorderRadius(e-r*i,a,i,s,n,Math.min(i,s),"0")}_generateSummaryCmd(e,a,i,n,r){if("alta"===this._context.getThemeBehavior()){var o=t.Agent.isRightToLeft(this._context),h=s.getSummaryThickness();if("0"===r||"0px"===r)return i>2*h?t.PathUtils.moveTo(e,a+n)+t.PathUtils.verticalLineTo(a)+t.PathUtils.horizontalLineTo(o?e-i:e+i)+t.PathUtils.verticalLineTo(a+n)+t.PathUtils.horizontalLineTo(o?e-i+h:e+i-h)+t.PathUtils.verticalLineTo(a+h)+t.PathUtils.horizontalLineTo(o?e-h:e+h)+t.PathUtils.verticalLineTo(a+n)+t.PathUtils.closePath():this._generateRectCmd(e,a,i,n,r);var l=Math.min(new t.CSSStyle({"border-radius":r}).getBorderRadius(),Math.min(i,n)),d=Math.max(l-h,0);return i>2*h?t.PathUtils.moveTo(e,a+n)+t.PathUtils.verticalLineTo(a+l)+t.PathUtils.arcTo(l,l,Math.PI/2,o?0:1,o?e-l:e+l,a)+t.PathUtils.horizontalLineTo(o?e-i+l:e+i-l)+t.PathUtils.arcTo(l,l,Math.PI/2,o?0:1,o?e-i:e+i,a+l)+t.PathUtils.verticalLineTo(a+n)+t.PathUtils.horizontalLineTo(o?e-i+h:e+i-h)+t.PathUtils.verticalLineTo(a+h+d)+t.PathUtils.arcTo(d,d,Math.PI/2,o?1:0,o?e-i+h+d:e+i-h-d,a+h)+t.PathUtils.horizontalLineTo(o?e-h-d:e+h+d)+t.PathUtils.arcTo(d,d,Math.PI/2,o?1:0,o?e-h:e+h,a+h+d)+t.PathUtils.verticalLineTo(a+n)+t.PathUtils.closePath():t.PathUtils.rectangleWithBorderRadius(e-o*i,a,i,n,l+"px "+l+"px 0px 0px",Math.min(i,n),"0")}return this._generateRectCmd(e,a,i,n,r)}_generateDiamondCmd(e,a,i,s){var n=i/2;if("0"===s||"0px"===s)return t.PathUtils.moveTo(e,a)+t.PathUtils.lineTo(e+n,a+n)+t.PathUtils.lineTo(e,a+i)+t.PathUtils.lineTo(e-n,a+n)+t.PathUtils.closePath();var r=Math.min(new t.CSSStyle({"border-radius":s}).getBorderRadius(),i/(2*Math.sqrt(2))),o=r/Math.sqrt(2),h=r,l=r;return t.PathUtils.moveTo(e-o,a+o)+t.PathUtils.arcTo(h,l,0,1,e+o,a+o)+t.PathUtils.lineTo(e+n-o,a+n-o)+t.PathUtils.arcTo(h,l,0,1,e+n-o,a+n+o)+t.PathUtils.lineTo(e+o,a+i-o)+t.PathUtils.arcTo(h,l,0,1,e-o,a+i-o)+t.PathUtils.lineTo(e-n+o,a+n+o)+t.PathUtils.arcTo(h,l,0,1,e-n+o,a+n-o)+t.PathUtils.closePath()}generateCmd(e,t,a,i,s){var n=this._task.getGantt(),r=n.getRenderingPrecision();return null===r?this._typeCmdGeneratorMap[this._type].call(this,e,t,a,i,s):this._typeCmdGeneratorMap[this._type].call(this,n.round(e,r),n.round(t,r),n.round(a,r),n.round(i,r),s)}getDefaultStyleClasses(){let e,t,a,i;const s=this._task.getGantt(),n=s.getEventManager().IsDragSupported("tasks");switch(this._type){case"main":case"mainSelect":case"mainHover":case"mainFocus":e=s.GetStyleClass("task"),t=s.GetStyleClass("taskMilestone"),a=s.GetStyleClass("taskBar"),i=s.GetStyleClass("taskSummary"),this._task.isMilestone(this._type)&&0===this._w?e+=" "+t:(e+=" "+(this._task.isSummary(this._type)?i:a),"main"===this._type&&null!=this._task.getProgressValue()&&(e+=" "+s.GetStyleClass("taskUnprogress"))),"main"===this._type&&n?e+=" "+s.GetStyleClass("draggable"):"mainSelect"===this._type?e+=" "+s.GetStyleClass("selected"):"mainHover"===this._type?e+=" "+s.GetStyleClass("hover"):"mainFocus"===this._type&&(e+=" "+s.GetStyleClass("focus"));break;case"mainBackground":e=s.GetStyleClass("taskBackdrop");break;case"progress":case"progressZero":case"progressFull":e=s.GetStyleClass("taskProgress"),this._task.isSummary("main")&&(e+=" "+s.GetStyleClass("taskSummaryProgress")),n&&(e+=" "+s.GetStyleClass("draggable"));break;case"overtime":case"downtime":case"attribute":e=s.GetStyleClass(`task${this._type[0].toUpperCase()}${this._type.slice(1)}`),n&&(e+=" "+s.GetStyleClass("draggable"));break;case"mainDragFeedback":case"mainResizeHandleDragFeedback":e=s.GetStyleClass("taskDragImage");break;case"mainResizeHandleStart":case"mainResizeHandleEnd":e=s.GetStyleClass("taskResizeHandle")+" "+s.GetStyleClass("draggable");break;case"baseline":case"baselineSelect":case"baselineHover":e=s.GetStyleClass("baseline"),t=s.GetStyleClass("baselineMilestone"),a=s.GetStyleClass("baselineBar"),this._task.isMilestone(this._type)&&0===this._w?e+=" "+t:e+=" "+a;break;default:e=""}return e}applyStyleClasses(e){if(("mainHover"===this._type||"mainFocus"===this._type)&&"alta"===this._context.getThemeBehavior()){const e={fill:"none"},a=this._task.getFillColor();null!=a&&(this.setStroke(t.SelectionEffectUtils.createSelectingStroke(a.fill)),e.stroke=a.fill,"none"===a.filter&&(e.filter="none")),this.setStyle(e)}this._svgClassName=e;const a=this.getDefaultStyleClasses();this.setClassName(e?`${a} ${e}`:a)}setClassName(e){this.getClassName()!==e&&(super.setClassName(e),this._fillColor=void 0,this._isHighlighted&&this.highlight())}setStyle(e){this.getStyle()!==e&&(super.setStyle(e),this._fillColor=void 0)}highlight(){this._isHighlighted||t.ToolkitUtils.addClassName(this._elem,this._task.getGantt().GetStyleClass("taskHighlight")),this._isHighlighted=!0}unhighlight(){this._isHighlighted&&t.ToolkitUtils.removeClassName(this._elem,this._task.getGantt().GetStyleClass("taskHighlight")),this._isHighlighted=!1}isHighlighted(){return this._isHighlighted}getFillColor(){if(this._fillColor)return this._fillColor.fromShapeCache=!0,this._fillColor;const e=this._task.getGantt().getCache(),a=`FILL_(${JSON.stringify(this.getClassName())||""})_${JSON.stringify(this.getStyle())||""}`,i=e.getFromCache(a);if(i)return this._fillColor=i,i;var n,r,o,h,l,d,g,_;n=(n=null!=(n=this.getElem()).firstChild?n.firstChild:n).cloneNode(!1),(r=this._task.getGantt().getCtx().getSvgDocument()).appendChild(n);try{if(h=(o=window.getComputedStyle(n)).fill,_=Number(o.fillOpacity),d=o.filter,!(String.prototype.startsWith?h.startsWith("url("):0===h.indexOf("url("))){switch(d){case"url("+JSON.stringify("#"+s.getTaskTintFilterId())+")":case"url(#"+s.getTaskTintFilterId()+")":l=t.ColorUtils.getBrighter(h,s.getTaskTintAlpha());break;case"url("+JSON.stringify("#"+s.getTaskShadeFilterId())+")":case"url(#"+s.getTaskShadeFilterId()+")":l=t.ColorUtils.getDarker(h,s.getTaskShadeAlpha());break;default:l=h}1===_||Number.isNaN(_)||(l=t.ColorUtils.getBrighter(l,1-_)),g={fill:h,computedFill:l,filter:d,stroke:o.stroke,fromShapeCache:!1}}}finally{r.removeChild(n)}return this._fillColor=g,e.putToCache(a,g),g}getType(){return this._type}setType(e){this._type=e}getTask(){return this._task}getPhysicalStartOffset(){return(o.MAIN_TYPES.indexOf(this._type)>-1||o.BASELINE_TYPES.indexOf(this._type)>-1)&&this._task.isMilestone(this._type)?this._finalHeight/2:0}getPhysicalEndOffset(){return(o.MAIN_TYPES.indexOf(this._type)>-1||o.BASELINE_TYPES.indexOf(this._type)>-1)&&this._task.isMilestone(this._type)?this._finalHeight/2:0}getType(){return this._type}getRenderState(){return this._renderState}setRenderState(e){this._renderState=e}getWidth(){return this._w}getFinalWidth(){return this._finalWidth}setWidth(e){var t;!(o.MAIN_TYPES.indexOf(this._type)>-1||o.BASELINE_TYPES.indexOf(this._type)>-1)||0!==this._w&&0!==e||(this._w=e,this.applyStyleClasses(this._svgClassName)),this._w=e,t=this.generateCmd(this._x,this._y,this._w,this._h,this._r),this.setCmds(t)}setFinalWidth(e){this._finalWidth=e}getHeight(){return this._h}getFinalHeight(){return this._finalHeight}setHeight(e){var t;this._h=e,t=this.generateCmd(this._x,this._y,this._w,this._h,this._r),this.setCmds(t)}setFinalHeight(e){this._finalHeight=e}getX(){return this._x}getFinalX(){return this._finalX}setX(e){var t;this._x=e,t=this.generateCmd(this._x,this._y,this._w,this._h,this._r),this.setCmds(t)}setFinalX(e){this._finalX=e}getY(){return this._y}getFinalY(){return this._finalY}setY(e){var t;this._y=e,t=this.generateCmd(this._x,this._y,this._w,this._h,this._r),this.setCmds(t)}setFinalY(e){this._finalY=e}getBorderRadius(){return this._r}setBorderRadius(e){var t;this._r=null!=e?e:"0",t=this.generateCmd(this._x,this._y,this._w,this._h,this._r),this.setCmds(t)}setDimensions(e,t,a,i,s){var n;!(o.MAIN_TYPES.indexOf(this._type)>-1||o.BASELINE_TYPES.indexOf(this._type)>-1)||0!==this._w&&0!==a||(this._w=a,this.applyStyleClasses(this._svgClassName)),this._x=e,this._y=t,this._w=a,this._h=i,this._r=null!=s?s:"0",n=this.generateCmd(this._x,this._y,this._w,this._h,this._r),this.setCmds(n)}}o.MAIN_TYPES=["main","mainBackground","mainSelect","mainHover","mainFocus"],o.MAIN_EFFECT_TYPES=["mainSelect","mainHover","mainFocus"],o.BASELINE_TYPES=["baseline","baselineSelect","baselineHover"],o.BASELINE_EFFECT_TYPES=["baselineSelect","baselineHover"],o.PROGRESS_TYPES=["progress","progressZero","progressFull"];var h={getDatatipColor:e=>{var t=e.getCtx(),a=e.getTask().getFillColor();return a?"alta"===t.getThemeBehavior()?a.fill:a.stroke:null},getDatatip:(e,a,i)=>{var s=e.getGantt();if(s.getEventManager().isKeyboardDnDScaleChanged()){var n=s.getEventManager().getKeyboardDnDNavigationScale(),r="move"===s.getEventManager().getKeyboardDnDMode()?"MoveBy":"ResizeBy",o=h._addDatatipRow("",s,"",r,n.charAt(0).toUpperCase()+n.slice(1),a);return h._processDatatip(o,s,a)}var l=s.getOptions().tooltip,d=l?l.renderer:null;if(a&&d){var g=s.getCtx().getTooltipManager(),_=s.getEventManager().isDnDDragging()?e.getSandboxDataContext():e.getDataContext();return g.getCustomTooltip(d,_)}var c=e.getValue("shortDesc");if(null!=c)return c;if(i&&!s.getCtx().isCustomElement()){var u=s.getOptions().valueFormats;if(!u||0===u.length){var p=e.getTask(),m=e.getValue("start"),b=e.getValue("end"),D=e.getValue("baseline","start"),v=e.getValue("baseline","end"),S=p.getProgressValue(),T=s.getOptions(),y=T.translations,C=p.isMilestone("main"),E=p.isMilestone("baseline"),f=!(null==m&&null==b),O=!(null==D&&null==v);if(f)if(C)var k=s.getTimeAxis().formatDate(new Date(null!=m?m:b),null,"general"),w=t.ResourceUtils.format(y.accessibleMilestoneInfo,[k]);else{var A=s.getTimeAxis().formatDate(new Date(m),null,"general"),R=s.getTimeAxis().formatDate(new Date(b),null,"general"),x=e.getDuration(m,b);w=t.ResourceUtils.format(y.accessibleTaskInfo,[A,R,x])}if(O)if(E)var L=s.getTimeAxis().formatDate(new Date(null!=D?D:v),null,"general"),P=y.labelBaselineDate+": "+L;else{var M=s.getTimeAxis().formatDate(new Date(D),null,"general"),j=s.getTimeAxis().formatDate(new Date(v),null,"general");P=(P=y.labelBaselineStart+": "+M)+"; "+y.labelBaselineEnd+": "+j}if(f){var I=e.getValue("label");if(null!=I)var H=y.labelLabel+": "+I;if(null!=S){var N=T._resources;if(N){var F=N.percentConverter;if(F){var B=F.format(S);if(null!=B)var U=y.labelProgress+": "+B}}}}var Y=e.getRowNode(),V=Y.getLabel();null==V&&(V=Y.getIndex()+1);var G=t.ResourceUtils.format(y.accessibleRowInfo,[V]);return w&&(G=G+"; "+w),P&&(G=G+"; "+P),H&&(G=G+"; "+H),U&&(G=G+"; "+U),G}}var z="";return z=h._addRowDatatip(z,e,a),z=h._addTaskDatatip(z,e,a),h._processDatatip(z,s,a)},_processDatatip:(e,t,a)=>""===e?null:a?'<table class="'+t.GetStyleClass("tooltipTable")+'">'+e+"</table>":e,_addRowDatatip:(e,t,a)=>{var i=t.getGantt();if(i.getEventManager().isDnDDragging())var s=t.getSandboxValue("_rowNode");else s=t.getRowNode();var n=s.getLabel();return null==n&&(n=s.getIndex()+1),h._addDatatipRow(e,i,"row","Row",n,a)},_addTaskDatatip:(e,t,a)=>{var i=t.getGantt(),s=i.getEventManager().isDnDDragging()?t.getSandboxValue:t.getValue,n=t.getTask(),r=s.call(t,"start"),o=s.call(t,"end"),l=s.call(t,"overtime","start"),d=s.call(t,"overtime","end"),g=s.call(t,"downtime","start"),_=s.call(t,"downtime","end"),c="on"===s.call(t,"attribute","rendered")?s.call(t,"attribute","shortDesc"):null,u=s.call(t,"baseline","start"),p=s.call(t,"baseline","end"),m=s.call(t,"label"),b=n.getProgressValue(),D=!(null==r&&null==o),v=!(null==u&&null==p),S=!(null==l&&null==d),T=!(null==g&&null==_),y=null!=c,C=n.isMilestone("main"),E=n.isMilestone("baseline");return D?(C?(e=h._addDatatipRow(e,i,"date","Date",null!=r?r:o,a),E?e=h._addDatatipRow(e,i,"baselineDate","BaselineDate",null!=u?u:p,a):v&&(e=h._addDatatipRow(e,i,"baselineStart","BaselineStart",u,a),e=h._addDatatipRow(e,i,"baselineEnd","BaselineEnd",p,a))):E?(e=h._addDatatipRow(e,i,"start","Start",r,a),e=h._addDatatipRow(e,i,"end","End",o,a),e=h._addDatatipRow(e,i,"baselineDate","BaselineDate",null!=u?u:p,a)):v?(e=h._addDatatipRow(e,i,"start","Start",r,a),e=h._addDatatipRow(e,i,"baselineStart","BaselineStart",u,a),e=h._addDatatipRow(e,i,"end","End",o,a),e=h._addDatatipRow(e,i,"baselineEnd","BaselineEnd",p,a)):(e=h._addDatatipRow(e,i,"start","Start",r,a),e=h._addDatatipRow(e,i,"end","End",o,a)),S&&(e=h._addDatatipRow(e,i,"overtimeStart","OvertimeStart",l,a),e=h._addDatatipRow(e,i,"overtimeEnd","OvertimeEnd",d,a)),T&&(e=h._addDatatipRow(e,i,"downtimeStart","DowntimeStart",g,a),e=h._addDatatipRow(e,i,"downtimeEnd","DowntimeEnd",_,a)),y&&(e=h._addDatatipRow(e,i,"attribute","Attribute",c,a)),e=h._addDatatipRow(e,i,"label","Label",m,a),null!=b&&(e=h._addDatatipRow(e,i,"progress","Progress",b,a))):v&&(e=h._addDatatipRow(e,i,"baselineStart","BaselineStart",u,a),e=h._addDatatipRow(e,i,"baselineEnd","BaselineEnd",p,a)),e},_addDatatipRow:(e,a,i,s,n,r,o)=>{if(null==n||""===n)return e;var l,d=h.getValueFormat(a,i);return"off"===d.tooltipDisplay?e:("string"==typeof d.tooltipLabel&&(l=d.tooltipLabel),null==l&&(l=null==s?"":a.getOptions().translations["label"+s]),n=h.formatValue(a,i,d,n),r?e+'<tr><td class="'+a.GetStyleClass("tooltipLabel")+'">'+l+'</td><td class="'+a.GetStyleClass("tooltipValue")+'">'+n+"</td></tr>":(e.length>0&&(e+="<br>"),e+t.ResourceUtils.format(a.getOptions().translations.labelAndValue,[l,n])))},getValueFormat:(e,t)=>{var a=e.getOptions().valueFormats;if(!a)return{};if(a instanceof Array){for(var i={},s=0;s<a.length;s++){var n=a[s];i[n.type]=n}e.getOptions().valueFormats=i,a=i}return a[t]?a[t]:{}},formatValue:(e,t,a,i)=>{var s=a.converter;if("start"===t||"end"===t||"date"===t||"baselineStart"===t||"baselineEnd"===t||"baselineDate"===t||"overtimeStart"===t||"overtimeEnd"===t||"downtimeStart"===t||"downtimeEnd"===t)return e.getTimeAxis().formatDate(new Date(i),s,"general");if(s&&s.format)return s.format(i);if("progress"===t){var n=e.getOptions()._resources;if(n){var r=n.percentConverter;if(r)return r.format(i)}}return i}};class l extends a.TimeComponentEventManager{constructor(e){super(e),this._HIGH_LEVEL_DND_NAVIGATION_SCALES=["milliseconds","seconds","minutes","hours","days","weeks","months","quarters","years"],this._HIGH_LEVEL_DND_DRAGSTART_DELTA_THRESHOLD=2}getFocus(){var e=super.getFocus(this),a=e&&"task"===e.nodeType;if(a&&null==e.getParent())return null;if(a&&null==e.getRowNode().getParent()){for(var i=e.getLayoutObject(),s=i.rowObj,n=this._comp.getDataLayoutManager();(null==i||!n.isRoot(s)&&n.isHiddenCollapsed(s))&&(s=n.getParentRowObj(s),null!=i||null!=s);){var r=s.taskObjs;i=r.length>0?r[0]:null}if(i){if("delete"!==i.renderState)return i.node;const e=n.getRowObjs();for(let a=0;a<e.length;a++)if(t.Obj.compareValues(this._comp.getCtx(),e[a].id,s.id)){const s=e[a].taskObjs;for(let e=0;e<s.length;e++)if(t.Obj.compareValues(this._comp.getCtx(),s[e].id,i.id))return s[e].node;return null}}return null}return e}setFocus(e){super.setFocus(e);var t=this.getFocus();t&&"task"===t.nodeType&&(this._lastFocusedTask=t)}getLastFocusedTask(){return this._lastFocusedTask}setLastFocusedTask(e){this._lastFocusedTask=e}hideTooltip(){this._preventHideTooltip||super.hideTooltip(),this._preventHideTooltip=!1}ProcessMarqueeEvent(e){if(this._comp.isMarqueeSelectEnabled()){var a=this.getSelectionHandler();if("start"===e.subtype)this._initSelection=e.ctrlKey?a.getSelectedIds():[],this._initSelectionTargets=e.ctrlKey?a.getSelection():[];else if("move"===e.subtype){this._isMarqueeDragging=!0;var i=this._comp.getMarqueeArtifactsContainer().stageToLocal(e._relPos);this._comp.autoPanOnEdgeDrag(i,s.getAutoPanEdgeThreshold(),!1,!1);var n=this._comp.getDataLayoutManager().getLayoutObjectsInBBox(new t.Rectangle(e.x,e.y,e.w,e.h)).taskObjs.map(e=>e.node);a.processInitialSelections(this._initSelection,this._initSelectionTargets),a.processGroupSelection(n,!0),this._isMarqueeDragging=!1}else"end"===e.subtype&&this.fireSelectionEvent()}}isMarqueeDragging(){return this._isMarqueeDragging}isDndSupported(){return!0}isDnDDragging(){return this._isDndDragging}_dragStartSetup(){this._dragInitialX=this._comp.getTimeZoomCanvas().getTranslateX(),this._dragInitialY=this._comp.getDatabody().getTranslateY(),this._dragInitialViewportStart=this._comp.getViewportStartTime(),this._dragInitialViewportEnd=this._comp.getViewportEndTime(),this._comp.getReferenceLinesContainer().setMouseEnabled(!1),this._comp.getReferenceAreasContainer().setMouseEnabled(!1),this._comp.getRowReferenceObjectsContainer().setMouseEnabled(!1),this._comp.getDependenciesContainer()&&this._comp.getDependenciesContainer().setMouseEnabled(!1),"highlightDependencies"===this._comp.getOptions().selectionBehavior&&this._comp.undimDatabody()}_dragCancelCleanup(){if(this._dragInitialX){var e=this._comp.getTimeZoomCanvas().getTranslateX()-this._dragInitialX,t=this._comp.getDatabody().getTranslateY()-this._dragInitialY;0===e&&0===t||(this._comp.panBy(e,t,!0),this._comp.setViewportStartTime(this._dragInitialViewportStart),this._comp.setViewportEndTime(this._dragInitialViewportEnd))}this._dragInitialX=null,this._dragInitialY=null,this._dragInitialViewportStart=null,this._dragInitialViewportEnd=null,this._comp.getReferenceLinesContainer().setMouseEnabled(!0),this._comp.getReferenceAreasContainer().setMouseEnabled(!0),this._comp.getRowReferenceObjectsContainer().setMouseEnabled(!0),this._comp.getDependenciesContainer()&&this._comp.getDependenciesContainer().setMouseEnabled(!0);var a=this.DragSource.getDragObject();a&&"task"===a.nodeType&&a.dragCancelCleanup()}_dropCleanup(){null==this._dragInitialViewportStart||this._dragInitialViewportStart===this._comp.getViewportStartTime()&&this._dragInitialViewportEnd===this._comp.getViewportEndTime()||this._comp.dispatchEvent(this._comp.createViewportChangeEvent()),this._dragInitialX=null,this._dragInitialY=null,this._dragInitialViewportStart=null,this._dragInitialViewportEnd=null,this._comp.getReferenceLinesContainer().setMouseEnabled(!0),this._comp.getReferenceAreasContainer().setMouseEnabled(!0),this._comp.getRowReferenceObjectsContainer().setMouseEnabled(!0),this._comp.getDependenciesContainer()&&this._comp.getDependenciesContainer().setMouseEnabled(!0),this._isDndDragging=!1}getKeyboardDnDMode(){return this._keyboardDnDMode}_handleKeyboardDnDInitiation(e,a,i,s,n){var r=t.Agent.isRightToLeft(this._comp.getCtx())?-1:1;this._isDndDragging=!0,this._dragStartSetup();var o=a.getTask().getShape("main");this._comp.registerAndConstructGlassPane();var h=this._comp.installGlassPane();this._keyboardDnDScaleRampIndex=this._HIGH_LEVEL_DND_NAVIGATION_SCALES.indexOf(this._comp.getTimeAxis().getScale()),a.setDraggedObject(i),a.dragStartSetup();var l=a.localToStage({x:o.getFinalX()+("end"===s)*r*o.getFinalWidth(),y:o.getFinalY()});this._keyboardDnDFeedbackLocalPos=this._comp.getDnDArtifactsContainer().stageToLocal(l),a.showDragFeedback(e,this._keyboardDnDFeedbackLocalPos,a.getRowNode(),{x:0,y:0},!0),h&&(this._preventHideTooltip=!0),this._keyboardDnDSourceObj=a,this._keyboardDnDTargetObj=a.getRowNode();var d=a.getValue("start"),g=a.getValue("end"),_=a.getValue("baseline","start")||null,c=a.getValue("baseline","end")||null;this._keyboardDnDFeedbackTime={start:d,end:g,baselineStart:_,baselineEnd:c};var u=this._comp.getOptions().translations,p=u[n.initiated];if(this._comp.isSelectionSupported()&&this._keyboardDnDSourceObj.isSelected()){var m=this._comp.getSelectionHandler().getSelectedCount();m>1&&(p+=". "+t.ResourceUtils.format(u[n.selectionInfo],[m-1]))}p+=". "+u[n.instruction]+".",this._comp.updateLiveRegionText(p)}handleKeyboardMoveInitiation(e,t){this._keyboardDnDMode=l.KEYBOARD_MOVE;var a=t.getTask().getShape("main");this._handleKeyboardDnDInitiation(e,t,a,"start",{initiated:"taskMoveInitiated",selectionInfo:"taskMoveSelectionInfo",instruction:"taskMoveInitiatedInstruction"})}handleKeyboardResizeStartInitiation(e,t){this._keyboardDnDMode=l.KEYBOARD_RESIZE_START;var a=t.getTask().getShape("mainResizeHandleStart");this._handleKeyboardDnDInitiation(e,t,a,"start",{initiated:"taskResizeStartInitiated",selectionInfo:"taskResizeSelectionInfo",instruction:"taskResizeInitiatedInstruction"})}handleKeyboardResizeEndInitiation(e,t){this._keyboardDnDMode=l.KEYBOARD_RESIZE_END;var a=t.getTask().getShape("mainResizeHandleEnd");this._handleKeyboardDnDInitiation(e,t,a,"end",{initiated:"taskResizeEndInitiated",selectionInfo:"taskResizeSelectionInfo",instruction:"taskResizeInitiatedInstruction"})}_handleKeyboardDnDChronologically(e,a){var s,n,r=t.Agent.isRightToLeft(this._comp.getCtx()),o=this.getKeyboardDnDNavigationScale(),d=this._comp.getStartTime(),g=this._comp.getEndTime(),_=this._comp.getContentLength(),c=this._comp.getTimeAxis(),u="forward"===a?"next":"previous",p=c.getAdjacentDate(this._keyboardDnDFeedbackTime.start,o,u).getTime(),m=c.getAdjacentDate(this._keyboardDnDFeedbackTime.end,o,u).getTime(),b="auto";switch(this._keyboardDnDMode){case l.KEYBOARD_MOVE:("forward"===a&&p<=g||"backward"===a&&m>=d)&&(n=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.start,_),this._keyboardDnDFeedbackTime.start=p,this._keyboardDnDFeedbackTime.end=m,this._keyboardDnDFeedbackTime.baselineStart&&(this._keyboardDnDFeedbackTime.baselineStart=c.getAdjacentDate(this._keyboardDnDFeedbackTime.baselineStart,o,u).getTime(),this._keyboardDnDFeedbackTime.baselineEnd=c.getAdjacentDate(this._keyboardDnDFeedbackTime.baselineEnd,o,u).getTime()),s=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.start,_));break;case l.KEYBOARD_RESIZE_START:var D=this._keyboardDnDSourceObj.getValue("end");("forward"===a&&p<=D||"backward"===a&&p>=d)&&(n=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.start,_),this._keyboardDnDFeedbackTime.start=p,s=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.start,_)),b="start";break;case l.KEYBOARD_RESIZE_END:var v=this._keyboardDnDSourceObj.getValue("start");("forward"===a&&m<=g||"backward"===a&&m>=v)&&(n=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.end,_),this._keyboardDnDFeedbackTime.end=m,s=i.TimeAxisUtils.getDatePosition(d,g,this._keyboardDnDFeedbackTime.end,_)),b="end"}null!=s&&(s=r?_-s:s,n=r?_-n:n,this._keyboardDnDFeedbackLocalPos.x+=s-n),this._keyboardDnDSourceObj.showDragFeedback(e,this._keyboardDnDFeedbackLocalPos,this._keyboardDnDTargetObj,{x:0,y:0},!0),this._keyboardDnDSourceObj.scrollIntoView(b,"auto"),this._comp.updateLiveRegionText(t.AriaUtils.processAriaLabel(h.getDatatip(this._keyboardDnDSourceObj,!1)))}handleKeyboardDnDForward(e){this._handleKeyboardDnDChronologically(e,"forward")}handleKeyboardDnDBackward(e){this._handleKeyboardDnDChronologically(e,"backward")}_handleKeyboardDnDScaleChange(e,a){this._isKeyboardDnDScaleChanged=!0,this._keyboardDnDScaleRampIndex=Math.max(0,Math.min(this._keyboardDnDScaleRampIndex+a,this._HIGH_LEVEL_DND_NAVIGATION_SCALES.length-1)),this._keyboardDnDSourceObj.showDragFeedback(e,this._keyboardDnDFeedbackLocalPos,this._keyboardDnDTargetObj,{x:0,y:0},!0),this._comp.updateLiveRegionText(t.AriaUtils.processAriaLabel(h.getDatatip(this._keyboardDnDSourceObj,!1))),this._isKeyboardDnDScaleChanged=!1}isKeyboardDnDScaleChanged(){return this._isKeyboardDnDScaleChanged}getKeyboardDnDNavigationScale(){return this._HIGH_LEVEL_DND_NAVIGATION_SCALES[this._keyboardDnDScaleRampIndex]}handleKeyboardDnDScaleUp(e){this._handleKeyboardDnDScaleChange(e,1)}handleKeyboardDnDScaleDown(e){this._handleKeyboardDnDScaleChange(e,-1)}_handleKeyboardMoveRowDirection(e,a){var i=this._comp.getRowLayoutObjs(),n=this._keyboardDnDTargetObj.getIndex();if("above"===a&&n>0)var r=i[n-1];else"below"===a&&n<i.length-1&&(r=i[n+1]);if(r){this._comp.getDataLayoutManager().ensureInDOM(r,"row"),this._keyboardDnDTargetObj=r.node;var o=this._comp.getOptions(),l=this._keyboardDnDTargetObj.localToStage({x:0,y:this._keyboardDnDTargetObj.getFinalY()+s.getRowPaddingTop(o)});this._keyboardDnDFeedbackLocalPos.y=this._comp.getDnDArtifactsContainer().stageToLocal(l).y}this._keyboardDnDSourceObj.showDragFeedback(e,this._keyboardDnDFeedbackLocalPos,this._keyboardDnDTargetObj,{x:0,y:0},!0),this._keyboardDnDSourceObj.scrollIntoView("auto","below"===a?"bottom":"top"),this._comp.updateLiveRegionText(t.AriaUtils.processAriaLabel(h.getDatatip(this._keyboardDnDSourceObj,!1)))}handleKeyboardMoveRowAbove(e){this._handleKeyboardMoveRowDirection(e,"above")}handleKeyboardMoveRowBelow(e){this._handleKeyboardMoveRowDirection(e,"below")}handleKeyboardDnDFinalize(e){var a,i,s,n,r,o;this._dropCleanup();var h=this._comp.getOptions().translations;if(this._keyboardDnDMode===l.KEYBOARD_MOVE){a=this._getDragDataContexts(this._keyboardDnDSourceObj),i=new Date(this._keyboardDnDFeedbackTime.start).toISOString(),s=new Date(this._keyboardDnDFeedbackTime.end).toISOString();var d=null==this._keyboardDnDFeedbackTime.baselineStart?null:new Date(this._keyboardDnDFeedbackTime.baselineStart).toISOString(),g=null==this._keyboardDnDFeedbackTime.baselineEnd?null:new Date(this._keyboardDnDFeedbackTime.baselineEnd).toISOString();n=i;var _=this._keyboardDnDTargetObj.getDataContext();r=t.EventFactory.newGanttMoveEvent(a,n,i,s,d,g,_),o=h.taskMoveFinalized}else if(this._keyboardDnDMode===l.KEYBOARD_RESIZE_END||this._keyboardDnDMode===l.KEYBOARD_RESIZE_START){var c;a=this._getDragDataContexts(this._keyboardDnDSourceObj).map(e=>e.dataContext),i=new Date(this._keyboardDnDFeedbackTime.start).toISOString(),s=new Date(this._keyboardDnDFeedbackTime.end).toISOString(),this._keyboardDnDMode===l.KEYBOARD_RESIZE_END?(n=s,c="end"):this._keyboardDnDMode===l.KEYBOARD_RESIZE_START&&(n=i,c="start"),r=t.EventFactory.newGanttResizeEvent(a,n,i,s,c),o=h.taskResizeFinalized}r&&(this._comp.dispatchEvent(r),this._comp.updateLiveRegionText(o)),this._keyboardDnDCleanup()}handleKeyboardDnDCancel(){var e=this._comp.getOptions().translations;this._keyboardDnDMode===l.KEYBOARD_MOVE?this._comp.updateLiveRegionText(e.taskMoveCancelled):this._keyboardDnDMode!==l.KEYBOARD_RESIZE_END&&this._keyboardDnDMode!==l.KEYBOARD_RESIZE_START||this._comp.updateLiveRegionText(e.taskResizeCancelled),this._dragCancelCleanup(),this._keyboardDnDCleanup()}handleHighLevelMouseDnDCancel(e){this._onDnDDragEnd(e),this._highLevelDnDEndExecuted=!0}_keyboardDnDCleanup(){null!=this._keyboardDnDMode&&(this._keyboardDnDSourceObj.dragEndCleanup(),this._keyboardDnDMode=null,this._isDndDragging=!1,this._keyboardDnDSourceObj=null,this._keyboardDnDTargetObj=null,this._keyboardDnDFeedbackTime=null,this._keyboardDnDScaleRampIndex=null,this._comp.unregisterAndDestroyGlassPane())}getDnDTaskSubType(e){if(e instanceof o){var t=e.getType();if("main"===t||"progress"===t)return"tasks";if("mainResizeHandleStart"===t||"mainResizeHandleEnd"===t)return"taskResizeHandles";if("baseline"===t)return null}return"tasks"}GetDragSourceType(e){switch(this._keyboardDnDMode){case l.KEYBOARD_MOVE:return this.IsDragSupported("tasks")?"tasks":null;case l.KEYBOARD_RESIZE_END:case l.KEYBOARD_RESIZE_START:return this.IsDragSupported("taskResizeHandles")?"taskResizeHandles":null}var a=this.DragSource.getDragObject();if(a&&"task"===a.nodeType){if(e&&"dragstart"===e.getNativeEvent().type){var i=e.getNativeEvent(),s=i.clientX,n=i.clientY,r=i.offsetX,o=i.offsetY;if(null==s&&null==n||("ie"===t.Agent.browser||"edge"===t.Agent.browser)&&isNaN(r)&&isNaN(o)){var h=e.target?e.target:a.getTask().getShape("main");a.setDraggedObject(h)}}var d=this.getDnDTaskSubType(a.getDraggedObject());return this.IsDragSupported(d)?d:null}return null}_getDragDataContexts(e,a){if(e&&"task"===e.nodeType){var i=e.getDraggedObject(),s=i.getType?i.getType():null;if(null!=this.getDnDTaskSubType(i)){var n=e=>{var i=e.getDataContext();switch(a&&t.ToolkitUtils.cleanDragDataContext(i),s){case"mainResizeHandleStart":return{dataContext:i,type:"start"};case"mainResizeHandleEnd":return{dataContext:i,type:"end"}}return i},r=[n(e)];if(this._comp.isSelectionSupported()&&e.isSelected()&&this._comp.getSelectionHandler().getSelectedCount()>1)for(var o=this._comp.getSelectionHandler().getSelection(),h=0;h<o.length;h++){var l=o[h];l&&"task"===l.nodeType&&l!==e&&r.push(n(l))}return r}}return null}GetDragDataContexts(e){var t=this.DragSource.getDragObject();return this._getDragDataContexts(t,e)}GetDropOffset(e){var a=this.DragSource.getDragObject();if(a&&"task"===a.nodeType&&"tasks"===this.getDnDTaskSubType(a.getDraggedObject())){var i=a.getValue("start"),s=a.getValue("end"),n=a.getTask().getTimeSpanDimensions(i,s),r=this._context.pageToStageCoords(e.pageX,e.pageY),o=this._comp.getDnDArtifactsContainer().stageToLocal(r);return new t.Point(n.startPos-o.x,a.getFinalY()-o.y)}return new t.Point(0,0)}_getDropObject(e){if(e){var t=this.GetLogicalObject(e.target),a=this._comp.getOptions().dnd,i=this._comp.isHighLevelDnDEnabled(),s=a&a.drop&&a.drop.tasks&&(a.drop.tasks.dataTypes||a.drop.tasks.drop);t&&"task"===t.nodeType&&i&&!s?this._dropObj=t.getRowNode():this._dropObj=t}return this._dropObj}GetDropTargetType(e){var t=this._getDropObject(e);return null==t?null:"row"===t.nodeType?"rows":"task"===t.nodeType?"tasks":null}GetDropEventPayload(e){var a=e.getNativeEvent().dataTransfer,s=a?Number(a.getData(t.EventManager.DROP_OFFSET_X_DATA_TYPE))||0:this._dropOffset.x,n=t.Agent.isRightToLeft(this._comp.getCtx()),r=this._getDropObject(e);if(null==r)return null;if("row"===r.nodeType||"task"===r.nodeType){var o=this._context.pageToStageCoords(e.pageX,e.pageY),h=this._comp.getTimeZoomCanvas().stageToLocal(o),l=this._comp.getStartTime(),d=this._comp.getEndTime(),g=this._comp.getContentLength(),_={value:new Date(i.TimeAxisUtils.getPositionDate(l,d,n?g-h.x:h.x,g)).toISOString(),start:null,end:null,baselineStart:null,baselineEnd:null,dataContext:r.getDataContext()},c=this.DragSource.getDragObject();if(c&&"task"===c.nodeType){var u=c.getValue("start"),p=c.getValue("end"),m=c.getValue("baseline","start")||null,b=c.getValue("baseline","end")||null,D=c.getDraggedObject(),v=this.getDnDTaskSubType(D);if("tasks"===v)_.start=i.TimeAxisUtils.getPositionDate(l,d,n?g-(h.x+s):h.x+s,g),_.end=_.start+(p-u),null==m&&null==b||(_.baselineStart=new Date(m-u+_.start).toISOString(),_.baselineEnd=new Date(b-p+_.end).toISOString()),_.start=new Date(_.start).toISOString(),_.end=new Date(_.end).toISOString();else if("taskResizeHandles"===v){"mainResizeHandleEnd"===(D.getType?D.getType():null)?(_.start=new Date(u).toISOString(),_.end=new Date(_.value).getTime()-u<0?u:_.value):(_.start=p-new Date(_.value).getTime()<0?p:_.value,_.end=new Date(p).toISOString())}}return _}return null}ShowDropEffect(e){const a=this._activeDropObj,i=this._getDropObject(e);this._activeDropObj=i;const n=this._currDragSourceType,r=this._currDropEffectCursorTarget;this._currDropEffectCursorTarget=e.target,!t.Agent.isTouchDevice()&&this._comp.isHighLevelDnDEnabled()&&e.target!==r&&(r&&s.hasClass(r,this._currDropEffectCursorStyleClass)&&r.removeClassName(this._currDropEffectCursorStyleClass),s.hasClass(e.target,this._currDropEffectCursorStyleClass)||e.target.addClassName(this._currDropEffectCursorStyleClass));this._comp.isTaskResizeEnabled()&&"taskResizeHandles"===n||i&&"row"===i.nodeType&&i!==a&&(a&&"row"===a.nodeType&&(a.removeEffect("invalidDrop"),a.removeEffect("activeDrop")),i.showEffect("activeDrop"))}ShowRejectedDropEffect(e){var t=this._activeDropObj,a=this._getDropObject(e);this._activeDropObj=a,this._currDropEffectCursorTarget=e.target,this._comp.isTaskResizeEnabled()&&"taskResizeHandles"===this._currDragSourceType||a&&"row"===a.nodeType&&a!==t&&a.showEffect("invalidDrop")}ClearDropEffect(){!t.Agent.isTouchDevice()&&this._comp.isHighLevelDnDEnabled()&&this._currDropEffectCursorTarget&&s.hasClass(this._currDropEffectCursorTarget,this._currDropEffectCursorStyleClass)&&this._currDropEffectCursorTarget.removeClassName(this._currDropEffectCursorStyleClass),this._currDropEffectCursorTarget=null;const e=this._getDropObject();e&&"row"===e.nodeType&&(e.removeEffect("invalidDrop"),e.removeEffect("activeDrop")),this._activeDropObj=null}_onDndDragStart(e){this._isDndDragging&&e.preventDefault();var a=e.getNativeEvent();if(a.defaultPrevented)this._comp.SetPanningEnabled(!0),this._comp.SetMarqueeEnabled(!0);else{this._isDndDragging=!0,this._dragStartSetup();var i=this.DragSource.getDragObject();if(i&&"task"===i.nodeType){i.dragStartSetup(e);var s=a.dataTransfer;this._dropOffset=s?new t.Point(Number(s.getData(t.EventManager.DROP_OFFSET_X_DATA_TYPE))||0,Number(s.getData(t.EventManager.DROP_OFFSET_Y_DATA_TYPE))||0):this.GetDropOffset(this._highLevelDnDDragStartPagePoint?{pageX:this._highLevelDnDDragStartPagePoint.x,pageY:this._highLevelDnDDragStartPagePoint.y}:e)}else this._dropOffset=new t.Point(0,0)}}_onDnDDragOver(e){var a=this;this._lastKnownDragOverEvent=e,a._isDndDragging=!0,this._isDragOverTicking||this._lastProcessedDragOverEvent&&this._lastKnownDragOverEvent.pageX===this._lastProcessedDragOverEvent.pageX&&this._lastKnownDragOverEvent.pageY===this._lastProcessedDragOverEvent.pageY||(requestAnimationFrame(()=>{a._isDragOverTicking=!1;var e=a.DragSource.getDragObject();if(e&&"task"===e.nodeType&&a._isDndDragging)if("dragover"!==a._lastKnownDragOverEvent.type||a._lastKnownDragOverEvent.getNativeEvent().defaultPrevented){var i=a._comp.getCtx().pageToStageCoords(a._lastKnownDragOverEvent.pageX,a._lastKnownDragOverEvent.pageY),s=a._comp.getDnDArtifactsContainer().stageToLocal(i);if(e.showDragFeedback(a._lastKnownDragOverEvent,s,a._getDropObject(),a._dropOffset),t.Agent.isTouchDevice()){var n=t.AriaUtils.processAriaLabel(h.getDatatip(e,!1));if(a._comp.isSelectionSupported()&&e.isSelected()){var r=a._comp.getSelectionHandler().getSelectedCount();r>1&&(n+=". "+t.ResourceUtils.format(a._comp.getOptions().translations.taskMoveSelectionInfo,[r-1]))}a._prevScreenReaderDragText&&a._prevScreenReaderDragText===n||a._comp.updateLiveRegionText(n),a._prevScreenReaderDragText=n}}else e.removeDragFeedbacks();a._lastProcessedDragOverEvent=a._lastKnownDragOverEvent}),this._isDragOverTicking=!0)}_onDnDDragEnd(e){const a=this.DragSource.getDragObject();a&&"task"===a.nodeType&&a.dragEndCleanup(),this._isDndDragging=!1,this._highLevelDnDDragStartPagePoint=null,this._activeDropObj=null,this._currDragSourceType=null,this._currDropEffectCursorStyleClass=null,this._dropOffset=new t.Point(0,0),(null!=e.keyCode||"dragend"===e.type&&"none"===e.getNativeEvent().dataTransfer.dropEffect)&&(this.ClearDropEffect(),this.handleKeyboardDnDCancel()),this._comp.SetPanningEnabled(!0),this._comp.SetMarqueeEnabled(!0),"highlightDependencies"===this._comp.getOptions().selectionBehavior&&this._comp.dimDatabody()}_onDnDDrop(e){this._dropCleanup();var a=e.getNativeEvent();if("drop"!==e.type||a.defaultPrevented){var i=this.DragSource.getDragObject(),s=i.getDraggedObject?this.getDnDTaskSubType(i.getDraggedObject()):"tasks";if(this._comp.isTaskMoveEnabled()&&"tasks"===s){t.Agent.isTouchDevice()&&this._comp.updateLiveRegionText(this._comp.getOptions().translations.taskMoveFinalized);var n=this.GetDropEventPayload(e),r="drop"!==e.type?this.GetDragDataContexts():JSON.parse(a.dataTransfer.getData(l.MOVE_TASKS_DATA_TYPE)),o=n.value,h=n.start,d=n.end,g=n.baselineStart,_=n.baselineEnd,c=n.dataContext,u=t.EventFactory.newGanttMoveEvent(r,o,h,d,g,_,c);this._comp.dispatchEvent(u)}else if(this._comp.isTaskResizeEnabled()&&"taskResizeHandles"===s){t.Agent.isTouchDevice()&&this._comp.updateLiveRegionText(this._comp.getOptions().translations.taskResizeFinalized);n=this.GetDropEventPayload(e);var p="drop"!==e.type?this.GetDragDataContexts():JSON.parse(a.dataTransfer.getData(l.RESIZE_TASKS_DATA_TYPE)),m=p[0].type;r=p.map(e=>e.dataContext),o=n.value,h=n.start,d=n.end,u=t.EventFactory.newGanttResizeEvent(r,o,h,d,m);this._comp.dispatchEvent(u)}}}OnDndDragStart(e){super.OnDndDragStart(e),this._onDndDragStart(e)}OnDndDragOver(e){super.OnDndDragOver(e),this._onDnDDragOver(e)}OnDndDragEnd(e){super.OnDndDragEnd(e),this._onDnDDragEnd(e)}OnDndDrop(e){super.OnDndDrop(e),this._onDnDDrop(e)}IsDragSupported(e){if("tasks"===e&&this._comp.isTaskMoveEnabled())return!0;if("taskResizeHandles"===e&&this._comp.isTaskResizeEnabled())return!0;if(this.isDndSupported()){var t=this._comp.getOptions(),a=t.dnd&&t.dnd.drag?t.dnd.drag:null;return a&&a[e]&&a[e].dataTypes&&a[e].dataTypes.length>0}return!1}IsDropSupported(e){if("rows"===e&&this._comp.isHighLevelDnDEnabled())return!0;if(this.isDndSupported()){var t=this._comp.getOptions(),a=t.dnd&&t.dnd.drop?t.dnd.drop:null;return a&&a[e]&&a[e].dataTypes}return!1}_onDnDPrePointerDown(e){var t=this.GetLogicalObjectAndDisplayable(e.target);if(t.logicalObject&&"task"===t.logicalObject.nodeType){var a=this.getDnDTaskSubType(t.displayable);if(this.IsDragSupported(a)){this._comp.SetPanningEnabled(!1),this._comp.SetMarqueeEnabled(!1);const e=this._comp.isTaskMoveEnabled(),i=this._comp.isTaskResizeEnabled();this._currDragSourceType=a,e&&"tasks"===a?this._currDropEffectCursorStyleClass=this._comp.GetStyleClass("highLevelDnDMoveDroppable"):i&&"taskResizeHandles"===a&&(this._currDropEffectCursorStyleClass=this._comp.GetStyleClass("highLevelDnDResizeDroppable")),t.logicalObject.setDraggedObject(t.displayable)}}}_onHighLevelDnDPointerDown(e){const a=this._context.pageToStageCoords(e.pageX,e.pageY),i=this.DragSource.getDragTransferable(a.x,a.y),s=this.GetDragSourceType(e);null!=i&&null!=s&&(this._highLevelDnDDragStartPagePoint=new t.Point(e.pageX,e.pageY),this._isDndDragging=!1)}_onHighLevelDnDPrePointerOver(e){null==this.GetDropTargetType(e)?this.ShowRejectedDropEffect(e):this.ShowDropEffect(e)}_onHighLevelDnDPrePointerOut(e){this.ClearDropEffect()}_onHighLevelDnDPointerMove(e){if(!this._isDndDragging&&this._highLevelDnDDragStartPagePoint&&(Math.abs(e.pageX-this._highLevelDnDDragStartPagePoint.x)>this._HIGH_LEVEL_DND_DRAGSTART_DELTA_THRESHOLD||Math.abs(e.pageY-this._highLevelDnDDragStartPagePoint.y)>this._HIGH_LEVEL_DND_DRAGSTART_DELTA_THRESHOLD)){this._context.getTooltipManager().hideTooltip();const t=this.DragSource.getDragObject();this.ProcessSelectionEventHelper(t,e.ctrlKey),t.hideHoverEffect&&t.hideHoverEffect(),this._onDndDragStart(e)}if(this._isDndDragging){if(null==this.GetDropTargetType(e))return void this.ShowRejectedDropEffect(e);this.ShowDropEffect(e),this._onDnDDragOver(e)}}_onHighLevelDnDPointerUp(e){if(this._highLevelDnDDragStartPagePoint=null,this._isDndDragging){this._highLevelDnDEndExecuted=!0;const t=this.GetDropTargetType(e);this.ClearDropEffect();return null==t||this._onDnDDrop(e),this.DragSource.setDragCandidate(null),void this._onDnDDragEnd(e)}this._comp.SetPanningEnabled(!0),this._comp.SetMarqueeEnabled(!0)}PreOnMouseDown(e){this._onDnDPrePointerDown(e),super.PreOnMouseDown(e)}OnMouseDown(e){super.OnMouseDown(e),this._highLevelDnDEndExecuted=!1,0!==e.button||e.ctrlKey||e.shiftKey||!this._comp.isHighLevelDnDEnabled()||this._onHighLevelDnDPointerDown(e)}PreOnMouseOver(e){this._isDndDragging&&this._comp.isHighLevelDnDEnabled()?this._onHighLevelDnDPrePointerOver(e):super.PreOnMouseOver(e)}PreOnMouseOut(e){this._isDndDragging&&this._comp.isHighLevelDnDEnabled()?this._onHighLevelDnDPrePointerOut(e):super.PreOnMouseOut(e)}OnMouseOut(e){super.OnMouseOut(e);var t=this._comp.getTimeCursor();t&&t.hide()}OnMouseMove(e){if((!this._comp.isHighLevelDnDEnabled()||(this._onHighLevelDnDPointerMove(e),!this._isDndDragging))&&(super.OnMouseMove(e),this._comp.IsTimeCursorEnabled())){var a=this._comp.getTimeCursor();if(a){var s=t.Agent.isRightToLeft(this._comp.getCtx()),n=this._comp.getTimeCursorContainer(),r=this._comp.getStartTime(),o=this._comp.getEndTime(),h=this._comp.getContentLength(),l=this._comp.getCtx().pageToStageCoords(e.pageX,e.pageY),d=n.stageToLocal(l),g=i.TimeAxisUtils.getPositionDate(r,o,s?h-d.x:d.x,h);a.updateRefObjs([{type:"line",value:new Date(g).toISOString()}]),a.show()}}}OnMouseUp(e){this._comp.isHighLevelDnDEnabled()&&(this._onHighLevelDnDPointerUp(e),this._highLevelDnDEndExecuted)||(this._highLevelDnDEndExecuted=!1,super.OnMouseUp(e))}OnClick(e){this._highLevelDnDEndExecuted?this._highLevelDnDEndExecuted=!1:super.OnClick(e)}onExpandCollapseButtonClick(e,t){var a=this.GetLogicalObject(t).getRowLayoutObject();this.toggleRowExpandCollapse(e,a)}toggleRowExpandCollapse(e,a){if(null!=a.expanded){var i,s,n,r,o=this._comp.getOptions(),h=o.expanded,l=a.id,d=a.data;if(o.rowData)i=d.id,s=d._itemData;else{var g=a.taskObjs[0].data;i=g.id,s=g._itemData}h.has(l)?(r=h.delete([l]),n="collapse"):(r=h.add([l]),n="expand"),this._comp.setRenderState({state:n,payload:a}),this._comp.isSelectionSupported()&&this._comp.getSelectionHandler().clearSelection();var _=t.EventFactory.newGanttExpandCollapseEvent(n,i,d,s,r);this._comp.dispatchEvent(_)}}HandleImmediateTouchStartInternal(e){1===e.targetTouches.length&&this._onDnDPrePointerDown(e)}OnTouchMoveBubble(e){this._isDndDragging&&(this._preventHideTooltip=!0),super.OnTouchMoveBubble(e)}}l.MOVE_TASKS_DATA_TYPE="text/_dvtdndmovetasks",l.RESIZE_TASKS_DATA_TYPE="text/_dvtdndresizetasks",l.KEYBOARD_MOVE="move",l.KEYBOARD_RESIZE_START="resizeStart",l.KEYBOARD_RESIZE_END="resizeEnd";class d extends a.TimeComponentKeyboardHandler{constructor(e,t){super(t),this._gantt=e}static _findPreviousTask(e,t,a,i,s){var n=a.taskObjs;if(0===n.length)return 0===i?s:d._findPreviousTask(e,t,t[i-1],i-1,s);var r=n[n.length-1];return e.getDataLayoutManager().ensureInDOM(r,"task"),r.node}static _findNextTask(e,t,a,i,s){var n=a.taskObjs;if(0===n.length)return i===t.length-1?s:d._findNextTask(e,t,t[i+1],i+1,s);var r=n[0];return e.getDataLayoutManager().ensureInDOM(r,"task"),r.node}static getNextNavigable(e,a,i,s){if(null==a||"task"!==a.nodeType)return null;var n=a.getRowNode(),r=e.getRowLayoutObjs(),o=n.getTaskObjs(),h=t.Agent.isRightToLeft(e.getCtx()),l=n.getIndex();switch(i.keyCode){case h?t.KeyboardEvent.RIGHT_ARROW:t.KeyboardEvent.LEFT_ARROW:var g=o.map(e=>e.node).indexOf(a);if(0!==g){var _=o[g-1];return e.getDataLayoutManager().ensureInDOM(_,"task"),_.node}if(l>0)return d._findPreviousTask(e,r,r[l-1],l-1,a);break;case h?t.KeyboardEvent.LEFT_ARROW:t.KeyboardEvent.RIGHT_ARROW:if((g=o.map(e=>e.node).indexOf(a))!==o.length-1){_=o[g+1];return e.getDataLayoutManager().ensureInDOM(_,"task"),_.node}if(l<r.length-1)return d._findNextTask(e,r,r[l+1],l+1,a);break;case t.KeyboardEvent.UP_ARROW:if(l>0&&null!=(a=d._findPreviousTask(e,r,r[l-1],l-1,a))){_=a.getRowNode().getTaskObjs()[0];return e.getDataLayoutManager().ensureInDOM(_,"task"),_.node}break;case t.KeyboardEvent.DOWN_ARROW:if(l<r.length-1&&null!=(a=d._findNextTask(e,r,r[l+1],l+1,a))){_=a.getRowNode().getTaskObjs()[0];return e.getDataLayoutManager().ensureInDOM(_,"task"),_.node}}return a}isNavigationEvent(e){var a=!1;switch(e.keyCode){case t.KeyboardEvent.OPEN_ANGLED_BRACKET:case t.KeyboardEvent.CLOSE_ANGLED_BRACKET:a=!!e.altKey;break;default:a=super.isNavigationEvent(e)}return a}_getDistance(e){var t=e.getValue("type"),a=e.getPredecessorNode(),i=e.getSuccessorNode(),s=t===n.START_START||t===n.START_FINISH?a.getValue("start"):a.getValue("end");if(t===n.START_START||t===n.FINISH_START)var r=i.getValue("start");else r=i.getValue("end");return Math.abs(r-s)}_getDependencyComparator(){var e=this;return(t,a)=>{var i=e._getDistance(t),s=e._getDistance(a);return i<s?-1:i>s?1:0}}getFirstNavigableDependencyLine(e,a,i){var s=this._gantt.getCtx(),n=a.keyCode;if(!i||i.length<1||!e)return null;for(var r=t.Agent.isRightToLeft(this._gantt.getCtx()),o=null,h=0,l=0;l<i.length;l++){var d=i[l];if(n===t.KeyboardEvent.CLOSE_ANGLED_BRACKET)var g=r?d.getValue("predecessorTaskId"):d.getValue("successorTaskId");else g=r?d.getValue("successorTaskId"):d.getValue("predecessorTaskId");if(!t.Obj.compareValues(s,e.getId(),g)){var _=this._getDistance(d);(null==o||_<h)&&(h=_,o=d)}}return o}getNextNavigableDependencyLine(e,a,i,s){if(!s)return null;if(!a)return s[0];if(!e)return a;s.sort(this._getDependencyComparator());for(var n=i.keyCode===t.KeyboardEvent.DOWN_ARROW,r=0,o=0;o<s.length;o++){if(s[o]===a){r=n?o===s.length-1?0:o+1:0===o?s.length-1:o-1;break}}return s[r]}isMoveInitiationEvent(e){return e.keyCode===t.KeyboardEvent.M&&e.ctrlKey}isResizeStartInitiationEvent(e){return 83===e.keyCode&&e.altKey}isResizeEndInitiationEvent(e){return 69===e.keyCode&&e.altKey}isDnDScaleUpEvent(e){return this._eventManager.getKeyboardDnDMode()&&e.keyCode===t.KeyboardEvent.PAGE_UP}isDnDScaleDownEvent(e){return this._eventManager.getKeyboardDnDMode()&&e.keyCode===t.KeyboardEvent.PAGE_DOWN}isDnDForwardEvent(e){var a=t.Agent.isRightToLeft(this._gantt.getCtx());return this._eventManager.getKeyboardDnDMode()&&e.keyCode===(a?t.KeyboardEvent.LEFT_ARROW:t.KeyboardEvent.RIGHT_ARROW)}isDnDBackwardEvent(e){var a=t.Agent.isRightToLeft(this._gantt.getCtx());return this._eventManager.getKeyboardDnDMode()&&e.keyCode===(a?t.KeyboardEvent.RIGHT_ARROW:t.KeyboardEvent.LEFT_ARROW)}isMoveRowAboveEvent(e){return this._eventManager.getKeyboardDnDMode()===l.KEYBOARD_MOVE&&e.keyCode===t.KeyboardEvent.UP_ARROW}isMoveRowBelowEvent(e){return this._eventManager.getKeyboardDnDMode()===l.KEYBOARD_MOVE&&e.keyCode===t.KeyboardEvent.DOWN_ARROW}isDnDFinalizeEvent(e){return this._eventManager.getKeyboardDnDMode()&&e.keyCode===t.KeyboardEvent.ENTER}isDnDCancelEvent(e){return this._eventManager.getKeyboardDnDMode()&&e.keyCode===t.KeyboardEvent.ESCAPE}isHighLevelMouseDnDCancelEvent(e){return this._eventManager.isDnDDragging()&&null==this._eventManager.getKeyboardDnDMode()&&e.keyCode===t.KeyboardEvent.ESCAPE}processKeyDown(e){var a=t.Agent.isRightToLeft(this._gantt.getCtx()),i=e.keyCode;if(i===t.KeyboardEvent.TAB){if(h=this._eventManager.getFocus())return t.EventManager.consumeEvent(e),h;for(var s=this._gantt.getRowLayoutObjs(),n=0;n<s.length;n++){var r=(l=s[n]).taskObjs;if(r.length>0){t.EventManager.consumeEvent(e);var o=r[0];return this._gantt.getDataLayoutManager().ensureInDOM(o,"task"),o.node}}}if(this.isMoveInitiationEvent(e)&&((h=this._eventManager.getFocus())&&"task"===h.nodeType&&h.isSelected()&&this._gantt.isTaskMoveEnabled()&&!this._eventManager.isDnDDragging()))return this._eventManager.handleKeyboardMoveInitiation(e,h),t.EventManager.consumeEvent(e),null;if(this.isResizeStartInitiationEvent(e)&&((h=this._eventManager.getFocus())&&"task"===h.nodeType&&h.isSelected()&&this._gantt.isTaskResizeEnabled()&&!this._eventManager.isDnDDragging()))return this._eventManager.handleKeyboardResizeStartInitiation(e,h),t.EventManager.consumeEvent(e),null;if(this.isResizeEndInitiationEvent(e)&&((h=this._eventManager.getFocus())&&"task"===h.nodeType&&h.isSelected()&&this._gantt.isTaskResizeEnabled()&&!this._eventManager.isDnDDragging()))return this._eventManager.handleKeyboardResizeEndInitiation(e,h),t.EventManager.consumeEvent(e),null;if(this.isDnDCancelEvent(e))return this._eventManager.handleKeyboardDnDCancel(),t.EventManager.consumeEvent(e),null;if(this.isDnDScaleUpEvent(e))return this._eventManager.handleKeyboardDnDScaleUp(e),t.EventManager.consumeEvent(e),null;if(this.isDnDScaleDownEvent(e))return this._eventManager.handleKeyboardDnDScaleDown(e),t.EventManager.consumeEvent(e),null;if(this.isDnDForwardEvent(e))return this._eventManager.handleKeyboardDnDForward(e),t.EventManager.consumeEvent(e),null;if(this.isDnDBackwardEvent(e))return this._eventManager.handleKeyboardDnDBackward(e),t.EventManager.consumeEvent(e),null;if(this.isMoveRowAboveEvent(e))return this._eventManager.handleKeyboardMoveRowAbove(e),t.EventManager.consumeEvent(e),null;if(this.isMoveRowBelowEvent(e))return this._eventManager.handleKeyboardMoveRowBelow(e),t.EventManager.consumeEvent(e),null;if(this.isDnDFinalizeEvent(e))return this._eventManager.handleKeyboardDnDFinalize(e),t.EventManager.consumeEvent(e),null;if(this.isHighLevelMouseDnDCancelEvent(e))return this._eventManager.handleHighLevelMouseDnDCancel(e),t.EventManager.consumeEvent(e),null;if(i===t.KeyboardEvent.SPACE&&e.ctrlKey&&e.shiftKey&&((h=this._eventManager.getFocus())&&"task"===h.nodeType))return t.EventManager.consumeEvent(e),this._eventManager.toggleRowExpandCollapse(e,h.getLayoutObject().rowObj),null;if(i===(a?t.KeyboardEvent.LEFT_ARROW:t.KeyboardEvent.RIGHT_ARROW)&&e.ctrlKey){var h=this._eventManager.getFocus();this._gantt.getDataLayoutManager();if(h&&"rowLabel"===h.nodeType){var l=h.getRowLayoutObject();if(this._gantt.getDataLayoutManager().isRowExpandable(l))return t.EventManager.consumeEvent(e),this._eventManager.toggleRowExpandCollapse(e,h.getRowLayoutObject()),null}}if(i===(a?t.KeyboardEvent.RIGHT_ARROW:t.KeyboardEvent.LEFT_ARROW)&&e.ctrlKey&&((h=this._eventManager.getFocus())&&"rowLabel"===h.nodeType)){l=h.getRowLayoutObject();if(this._gantt.getDataLayoutManager().isRowCollapsible(l))return t.EventManager.consumeEvent(e),this._eventManager.toggleRowExpandCollapse(e,l),null}return i===t.KeyboardEvent.ESCAPE?(this._eventManager.cancelMarquee(e),null):super.processKeyDown(e)}}class g extends t.Container{constructor(e,t){super(e.getCtx(),null),this._gantt=e,this._task=t,this._isHighlighted=!1}render(e){const a=this._gantt.getOptions();this._content&&this.removeChild(this._content),this._content=new t.Container(this._gantt.getCtx()),this._content.setClassName(this._gantt.GetStyleClass("taskCustom"));var i=t.Agent.isRightToLeft(this._gantt.getCtx());if("css"===this._getClipPathCoordSystem()){var s=this._task.getShape("main"),n=s.getWidth()+s.getPhysicalStartOffset()+s.getPhysicalEndOffset(),r=s.getHeight(),o=new t.Rect(this._gantt.getCtx(),i?-n:0,0,n,r);o.setVisible(!1),this._content.addChild(o)}this.addChild(this._content);const h=this._content.getContainerElem(),l=(0,a.taskContent.renderer)(this.getRendererContext(e));l&&(Array.isArray(l)?l.forEach(e=>{t.ToolkitUtils.appendChildElem(h,e)}):t.ToolkitUtils.appendChildElem(h,l));const d=this._getClipPathDim();this._applyClipPath(d),this._isHighlighted?this.highlight():this.unhighlight()}destroy(){this.setClipPath(null),this.removeFromParent()}getRendererContext(e){const t=this._gantt.getCtx(),a=this._task.getShape("main"),i=this._task.getContainer(),s=i.getRowNode(),n=s.getLayoutObject(),r=i.getData()._itemData,o={data:i.getData(!0),rowData:s.getData(!0),itemData:r||null,content:{height:a.getHeight(),width:a.getWidth()+a.getPhysicalStartOffset()+a.getPhysicalEndOffset()},state:{expanded:!!n.expanded,focused:!!i.isShowingKeyboardFocusEffect(),hovered:e,selected:!!i.isSelected()}};return t.fixRendererContext(o)}highlight(){this._isHighlighted=!0,this._content&&t.ToolkitUtils.addClassName(this._content.getElem(),this._gantt.GetStyleClass("taskHighlight"))}unhighlight(){this._isHighlighted=!1,this._content&&t.ToolkitUtils.removeClassName(this._content.getElem(),this._gantt.GetStyleClass("taskHighlight"))}_getClipPathCoordSystem(){return t.Agent.isRightToLeft(this._gantt.getCtx())?"svg":"css"}_getClipPathDim(e){const a=e||{},i=this._task.getShape("main"),s=t.Agent.isRightToLeft(this._gantt.getCtx()),n=this._getClipPathCoordSystem(),r=null!=a.w?a.w:i.getWidth(),o={y:0,translateY:0,w:r+i.getPhysicalStartOffset()+i.getPhysicalEndOffset(),h:null!=a.h?a.h:i.getHeight(),r:null!=a.r?a.r:i.getBorderRadius(),_coordSystem:n};return"svg"===n?(o.x=s?0-r-i.getPhysicalEndOffset():0-i.getPhysicalStartOffset(),o.translateX=s?0+i.getPhysicalStartOffset():0-i.getPhysicalStartOffset()):(o.x=0,o.translateX=0-i.getPhysicalStartOffset()),o}_applyClipPath(e){const{x:a,y:i,w:s,h:n,r:r}=e,o=t.PathUtils.rectangleWithBorderRadius(a,i,s,n,r,Math.min(s,n),"0");if("css"===e._coordSystem)this.getElem().style.clipPath=`path('${o}')`;else{const e=new t.ClipPath;e.addPath(o),this.setClipPath(e)}}setWidth(e){const t=this._getClipPathDim({w:e});this._applyClipPath(t)}setHeight(e){const t=this._getClipPathDim({h:e});this._applyClipPath(t)}setX(e){const t=this._getClipPathDim({x:e});this.setTranslateX(t.translateX),this._applyClipPath(t)}setY(e){const t=this._getClipPathDim({y:e});this.setTranslateY(t.translateY),this._applyClipPath(t)}setBorderRadius(e){const t=this._getClipPathDim({r:e});this._applyClipPath(t)}setDimensions(e,t,a,i,s){const n=this._getClipPathDim({x:e,y:t,w:a,h:i,r:s});this.setTranslate(n.translateX,n.translateY),this._applyClipPath(n)}}class _{constructor(e,t){this._gantt=e,this._container=t}getGantt(){return this._gantt}getContainer(){return this._container}getShape(e){return"main"===e?this._mainShape:"progress"===e?this._progressShape:"baseline"===e?this._baselineShape:"overtime"===e?this._overtimeShape:"downtime"===e?this._downtimeShape:"attribute"===e?this._attributeShape:"mainResizeHandleStart"===e?this._mainHandleStart:"mainResizeHandleEnd"===e?this._mainHandleEnd:void 0}getSvgStyle(e){return null==e?this._container.getValue("svgStyle"):this._container.getValue(e,"svgStyle")}getSvgClassName(e){return null==e?this._container.getValue("svgClassName")||this._container.getValue("className"):this._container.getValue(e,"svgClassName")||this._container.getValue(e,"className")}_applyStyles(e,t){const a=this.getSvgClassName(t),i=this.getSvgStyle(t);e.applyStyleClasses(a),i&&e.setStyle(i)}_applyMainContainerClippath(){if(t.Agent.isRightToLeft(this._gantt.getCtx())&&"firefox"!==t.Agent.browser){var e=this._mainShape.getWidth();this._mainContainer.setStyle({clipPath:`path('${this._mainShape.generateCmd(this._mainShape.getX()+e,this._mainShape.getY(),e,this._mainShape.getHeight(),this._mainShape.getBorderRadius())}')`})}else this._mainContainer.setStyle({clipPath:`path('${this._mainShape.getCmds()}')`})}isMilestone(e){var t,a,i=this._container.getValue("type");return"milestone"===i||"auto"===i&&("mainDragFeedback"===e||o.MAIN_TYPES.indexOf(e)>-1?(t=this._container.getValue("start"),a=this._container.getValue("end")):o.BASELINE_TYPES.indexOf(e)>-1&&(t=this._container.getValue("baseline","start"),a=this._container.getValue("baseline","end")),null!=t&&t==a)}isSummary(e){return"main"===e&&"summary"===this._container.getValue("type")}getTimeSpanDimensions(e,a){var s,n,r=this._gantt.getStartTime(),o=this._gantt.getEndTime(),h=this._gantt.getContentLength(),l=t.Agent.isRightToLeft(this._gantt.getCtx());return null!=e||null!=a?(s=i.TimeAxisUtils.getDatePosition(r,o,e,h),n=i.TimeAxisUtils.getDatePosition(r,o,a,h),l&&(s=h-s,n=h-n),{startPos:s,endPos:n,distance:n-s}):null}getFillColor(){if(null==this._fillColor){if(null==this._mainShape)return null;this._fillColor=this._mainShape.getFillColor()}return this._fillColor}getFinalHeight(e){var t=this._container.getLayoutObject();return e?t.overallHeightNoProgress:t.overallHeight}showEffect(e){(this.showMainEffect(e),"selected"===e)&&this._container.getRowNode().showEffect("selected")}removeEffect(e,t){(this.removeMainEffect(e,t),"selected"===e)&&this._container.getRowNode().removeEffect("selected")}render(e){var t=this._container.getValue("progress","height");this.renderBaseline(t),this.renderMain(t,e),this.renderProgress(t),this.renderOvertime(),this.renderDowntime(),this.renderAttribute(),"summary"===this._container.getValue("type")&&this._mainShape&&"alta"===this._gantt.getCtx().getThemeBehavior()&&this._container.addChild(this._mainShape),this._mainCustomContent&&this._container.addChild(this._mainCustomContent)}isMainCustomContent(){var e=this._gantt.getOptions();return e.taskContent&&e.taskContent.renderer}getRenderState(e){return"main"===e?this._mainShape.getRenderState():"progress"===e?this._progressShape.getRenderState():"baseline"===e?this._baselineShape.getRenderState():"overtime"===e?this._overtimeShape.getRenderState():"downtime"===e?this._downtimeShape.getRenderState():"attribute"===e?this._attributeShape.getRenderState():void 0}renderBaseline(e){var t,a,i,n,r,h,l,d,g,_,c,u,p,m=this._gantt.getOptions(),b=this._container.getValue("baseline"),D=this;b?(a=this._container.getValue("baseline","start"),i=this._container.getValue("baseline","end"),(d=this.getTimeSpanDimensions(a,"milestone"===this._container.getValue("type")&&a!=i?a:i))?(h=this.getTimeSpanDimensions(this._container.getValue("start"),a),t=this.isMilestone("baseline"),g=h?h.distance:0,c=Math.abs(d.distance),u=this._container.getValue("baseline","height"),n=t?Math.max(this._container.getValue("height"),u)+s.getMilestoneBaselineYOffset(m)-u:this._container.getValue("height")+s.getBaselineMarginTop(m),_=Math.max(0,(e-this._container.getValue("height"))/2)+n,p=t?m._resources.milestoneBaselineBorderRadius:b.borderRadius,null==this._baselineShape?(this._baselineShape=new o(this._gantt.getCtx(),g,_,c,u,p,this,"baseline"),t?this._container.addChildAt(this._baselineShape,0):this._container.addChild(this._baselineShape),this._baselineShape.setRenderState("add")):(this._baselineShape.setRenderState("exist"),t&&this._container.addChildAt(this._baselineShape,0)),this._baselineShape.setFinalWidth(c),this._baselineShape.setFinalHeight(u),this._baselineShape.setFinalX(g),this._baselineShape.setFinalY(_),l=()=>{D._applyStyles(D._baselineShape,"baseline")},r={x:g,y:_,w:c,h:u,r:p},this._gantt.getAnimationManager().preAnimateTaskBaseline(this,this._baselineShape,r,l)):this.removeBaseline()):this.removeBaseline()}removeBaseline(){var e,t=this;this._baselineShape&&(e=()=>{t._container.removeChild(t._baselineShape),t._baselineShape=null},this._gantt.getAnimationManager().preAnimateTaskBaselineRemove(this._baselineShape,e))}renderMain(e,a){var i,s,n,r,h,l,d,_,c,u,p=this._container.getData(),m=this._container.getValue("height"),b=this._container.getValue("start"),D=this._container.getValue("end"),v=this._gantt.getCtx(),S=t.Agent.isRightToLeft(v),T=v.getThemeBehavior(),y=this,C=this._gantt.getOptions();if(p)if(n=this.getTimeSpanDimensions(b,"milestone"===this._container.getValue("type")&&b!=D?b:D)){if(0,r=Math.max(0,(e-m)/2),h=Math.abs(n.distance),l=this.isSummary("main")&&"alta"===T?this._container.getFinalHeight(!0):m,_=this.isMilestone("main"),u=this._gantt.getViewportDensity()>1,"0"===(c=_?C._resources.milestoneBorderRadius:this._container.getValue("borderRadius"))||"0px"===c||u)d="0";else switch(this._container.getLayoutObject().aggregation){case"stackStart":d=S?`0px ${c} ${c} 0px`:`${c} 0px 0px ${c}`;break;case"stackMiddle":d="0";break;case"stackEnd":d=S?`${c} 0px 0px ${c}`:`0px ${c} ${c} 0px`;break;default:d=c}null==this._mainShape?("alta"===T||u||(this._mainBackgroundShape=new o(v,0,r,h,l,d,this,"mainBackground"),this._container.addChild(this._mainBackgroundShape)),this._mainShape=new o(v,0,r,h,l,d,this,"main"),this._container.addChild(this._mainShape),this._mainShape.setRenderState("add")):(this._mainShape.setRenderState("exist"),"alta"!==T&&(u?this._mainBackgroundShape&&(this._container.removeChild(this._mainBackgroundShape),this._mainBackgroundShape=null):this._mainBackgroundShape||(this._mainBackgroundShape=new o(v,0,r,h,l,d,this,"mainBackground"),this._container.addChildAt(this._mainBackgroundShape,this._container.getChildIndex(this._mainShape))))),this._mainShape.setFinalWidth(h),this._mainShape.setFinalHeight(l),this._mainShape.setFinalX(0),this._mainShape.setFinalY(r),this.isMainCustomContent()&&"add"===this._mainShape.getRenderState()&&(this._mainCustomContent&&this._mainCustomContent.destroy(),this._mainCustomContent=new g(this._gantt,this),this._mainCustomContent.render(!1));var E="on"===this._container.getValue("attribute","rendered"),f=null!=this.getProgressValue(),O=null!=this._container.getValue("downtime","start")||null!=this._container.getValue("downtime","end"),k=null!=this._container.getValue("overtime","start")||null!=this._container.getValue("overtime","end");"alta"!==T&&!_&&"0"!==d&&(E||f||O||k)?null==this._mainContainer&&(this._mainContainer=new t.Container(v),this._mainContainerSupport=new t.Rect(this._gantt.getCtx(),S?-h:0,0,h,l),this._mainContainerSupport.setVisible(!1),this._mainContainer.addChild(this._mainContainerSupport),this._applyMainContainerClippath(),this._container.addChild(this._mainContainer)):null!=this._mainContainer&&(this._container.removeChild(this._mainContainer),this._mainContainer=null,this._mainContainerSupport=null),s=()=>{y._fillColor=null,y._applyStyles(y._mainShape),a&&y._mainCustomContent&&"exist"===y._mainShape.getRenderState()&&y._mainCustomContent.render(!1)},i={x:0,y:r,w:h,h:l,r:d},this._gantt.getAnimationManager().preAnimateTaskMain(this,i,s)}else this.removeMain();else this.removeMain()}showMainEffect(e){var t=this._mainShape.getX(),a=this._mainShape.getY(),i=this._mainShape.getWidth(),s=this._mainShape.getHeight(),n=this._mainShape.getBorderRadius(),r=e=>{var t=e.getParent();if(null!=t){var a=e.getRowNode().getLayoutObject(),i=e.getLayoutObject(),s=a.earliestOverlayTaskObj;if(s&&"overlay"!==i._overlayBehavior){var n=s.node;if(n&&n.getParent()){var r=t.getChildIndex(n);t.addChildAt(e,r-1)}else t.addChild(e)}else t.addChild(e)}};if("selected"===e)null==this._mainSelectShape&&(this._mainSelectShape=new o(this._gantt.getCtx(),t,a,i,s,n,this,"mainSelect"),this._container.addChildAt(this._mainSelectShape,0),this._mainCustomContent&&this._mainCustomContent.render(!1),r(this._container));else if(("hover"===e||"focus"===e)&&null==this._mainHoverShape){var h="hover"===e?"mainHover":"mainFocus";this._mainHoverShape=new o(this._gantt.getCtx(),t,a,i,s,n,this,h),this._container.addChildAt(this._mainHoverShape,this._container.getChildIndex(this._mainShape)),this._mainCustomContent&&this._mainCustomContent.render("hover"===e),"on"!==this._gantt.getOptions().taskAggregation&&r(this._container)}this._mainShape.isHighlighted()&&(this._mainSelectShape&&this._mainSelectShape.highlight(),this._mainHoverShape&&this._mainHoverShape.highlight())}removeMainEffect(e,t){var a="on"===this._gantt.getOptions().taskAggregation;if(t=(void 0===t||t)&&!a,"selected"===e?(null!=this._mainSelectShape&&this._container.removeChild(this._mainSelectShape),this._mainSelectShape=null):"hover"!==e&&"focus"!==e||(null!=this._mainHoverShape&&this._container.removeChild(this._mainHoverShape),this._mainHoverShape=null),this._mainCustomContent&&this._mainCustomContent.render(!1),t){var i=this._container.getRowNode().getRenderOrderTaskObjs();if(i.length<2)return;var s=this._container.getParent();if(!s)return;for(var n=this._container.getLayoutObject(),r=this._container,o=i.indexOf(n)-1;o>=0;o--){var h=i[o].node;if(h&&!h.isSelected()&&h.getParent()){var l=s.getChildIndex(h);return void s.addChildAt(r,l)}}s.addChildAt(r,0)}}getMainWidth(){return this._mainShape.getWidth()}_setMainContainerSupportWidth(e){t.Agent.isRightToLeft(this._gantt.getCtx())&&this._mainContainerSupport.setX(-e),this._mainContainerSupport.setWidth(e)}setMainWidth(e){this._mainShape.setWidth(e),this._mainBackgroundShape&&this._mainBackgroundShape.setWidth(e),this._mainSelectShape&&this._mainSelectShape.setWidth(e),this._mainHoverShape&&this._mainHoverShape.setWidth(e),this._mainCustomContent&&this._mainCustomContent.setWidth(e),this._mainContainer&&this._applyMainContainerClippath(),this._mainContainerSupport&&this._setMainContainerSupportWidth(e)}getMainHeight(){return this._mainShape.getHeight()}setMainHeight(e){this._mainShape.setHeight(e),this._mainBackgroundShape&&this._mainBackgroundShape.setHeight(e),this._mainSelectShape&&this._mainSelectShape.setHeight(e),this._mainHoverShape&&this._mainHoverShape.setHeight(e),this._mainCustomContent&&this._mainCustomContent.setHeight(e),this._mainContainer&&this._applyMainContainerClippath(),this._mainContainerSupport&&this._mainContainerSupport.setHeight(e)}getMainX(){return this._mainShape.getX()}setMainX(e){this._mainShape.setX(e),this._mainBackgroundShape&&this._mainBackgroundShape.setX(e),this._mainSelectShape&&this._mainSelectShape.setX(e),this._mainHoverShape&&this._mainHoverShape.setX(e),this._mainCustomContent&&this._mainCustomContent.setX(e),this._mainContainer&&this._applyMainContainerClippath()}getMainY(){return this._mainShape.getY()}setMainY(e){this._mainShape.setY(e),this._mainBackgroundShape&&this._mainBackgroundShape.setY(e),this._mainSelectShape&&this._mainSelectShape.setY(e),this._mainHoverShape&&this._mainHoverShape.setY(e),this._mainCustomContent&&this._mainCustomContent.setY(e),this._mainContainer&&this._applyMainContainerClippath()}getMainBorderRadius(){return this._mainShape.getBorderRadius()}setMainBorderRadius(e){this._mainShape.setBorderRadius(e),this._mainBackgroundShape&&this._mainBackgroundShape.setBorderRadius(e),this._mainSelectShape&&this._mainSelectShape.setBorderRadius(e),this._mainHoverShape&&this._mainHoverShape.setBorderRadius(e),this._mainCustomContent&&this._mainCustomContent.setBorderRadius(e),this._mainContainer&&this._applyMainContainerClippath()}setMainDimensions(e,t,a,i,s){this._mainShape.setDimensions(e,t,a,i,s),this._mainBackgroundShape&&this._mainBackgroundShape.setDimensions(e,t,a,i,s),this._mainSelectShape&&this._mainSelectShape.setDimensions(e,t,a,i,s),this._mainHoverShape&&this._mainHoverShape.setDimensions(e,t,a,i,s),this._mainCustomContent&&this._mainCustomContent.setDimensions(e,t,a,i,s),this._mainContainer&&this._applyMainContainerClippath(),this._mainContainerSupport&&(this._setMainContainerSupportWidth(a),this._mainContainerSupport.setHeight(i))}removeMain(){var e,t=this;this._mainShape&&(e=()=>{t._mainCustomContent&&(t._mainCustomContent.destroy(),t._mainCustomContent=null),t.removeMainEffect("selected",!1),t._mainBackgroundShape&&(t._container.removeChild(t._mainBackgroundShape),t._mainBackgroundShape=null),t._container.removeChild(t._mainShape),t._mainShape=null,t._mainContainer&&(t._container.removeChild(t._mainContainer),t._mainContainer=null)},this._gantt.getAnimationManager().preAnimateTaskMainRemove(this._mainShape,this._mainBackgroundShape,this._mainSelectShape,this._mainHoverShape,this._mainCustomContent,this._mainContainer,e))}getProgressValue(){var e=this._container.getValue("progress","value");return this.isMilestone("main")||"number"!=typeof e?null:e}renderProgress(e){var t,a,i,s,n,r,h=this._container.getValue("height"),l=this.getProgressValue(),d=this;null!==l&&this._mainShape&&!this.isMilestone("main")?(i=Math.max(0,(h-e)/2),s=l*this._mainShape.getFinalWidth(),n=this._container.getValue("progress","borderRadius"),r="progress",0===l?r="progressZero":1===l&&(r="progressFull"),null==this._progressShape?(this._progressShape=new o(this._gantt.getCtx(),0,i,s,e,n,this,r),this._progressShape.setRenderState("add")):(this._progressShape.setType(r),this._progressShape.setRenderState("exist")),(this._mainContainer||this._container).addChild(this._progressShape),this._progressShape.setFinalWidth(s),this._progressShape.setFinalHeight(e),this._progressShape.setFinalX(0),this._progressShape.setFinalY(i),t=()=>{d._applyStyles(d._progressShape,"progress")},a={x:0,y:i,w:s,h:e,r:n},this._gantt.getAnimationManager().preAnimateTaskProgress(this,this._progressShape,a,t)):this.removeProgress()}removeProgress(){var e,t=this;this._progressShape&&(e=()=>{t._progressShape&&(t._progressShape.removeFromParent(),t._progressShape=null)},this._gantt.getAnimationManager().preAnimateTaskProgressRemove(this._progressShape,e))}renderOvertime(){var e=this;if(this._mainShape&&!this.isMilestone("main")){var t=this._container.getValue("overtime","start"),a=this._container.getValue("overtime","end"),i=this.getTimeSpanDimensions(t,a);if(i){var s=this._container.getValue("start"),n=this._container.getLayoutObject(),r=this.getTimeSpanDimensions(s,t).distance,h=n.overtimeHeight,l=Math.abs(i.distance);null==this._overtimeShape?(this._overtimeShape=new o(this._gantt.getCtx(),r,0,l,h,"0",this,"overtime"),this._overtimeShape.setRenderState("add")):this._overtimeShape.setRenderState("exist"),(this._mainContainer||this._container).addChild(this._overtimeShape),this._overtimeShape.setFinalWidth(l),this._overtimeShape.setFinalHeight(h),this._overtimeShape.setFinalX(r),this._overtimeShape.setFinalY(0);var d={x:r,y:0,w:l,h:h,r:"0"};this._gantt.getAnimationManager().preAnimateTaskOvertime(this,this._overtimeShape,d,()=>{e._applyStyles(e._overtimeShape,"overtime")})}else this.removeOvertime()}else this.removeOvertime()}removeOvertime(){var e,t=this;this._overtimeShape&&(e=()=>{t._overtimeShape&&(t._overtimeShape.removeFromParent(),t._overtimeShape=null)},this._gantt.getAnimationManager().preAnimateTaskOvertimeRemove(this._overtimeShape,e))}renderDowntime(){var e=this;if(this._mainShape&&!this.isMilestone("main")){var t=this._container.getValue("downtime","start"),a=this._container.getValue("downtime","end"),i=this.getTimeSpanDimensions(t,a);if(i){var s=this._gantt.getOptions(),n=this._container.getValue("start"),r=this._container.getLayoutObject(),h=this.getTimeSpanDimensions(n,t).distance,l=r.downtimeHeight,d=this._mainShape.getFinalHeight()-l,g=Math.abs(i.distance),_=s._resources.taskDowntimeBorderRadius,c=`${_} ${_} 0px 0px`;null==this._downtimeShape?(this._downtimeShape=new o(this._gantt.getCtx(),h,d,g,l,c,this,"downtime"),this._downtimeShape.setRenderState("add")):this._downtimeShape.setRenderState("exist"),(this._mainContainer||this._container).addChild(this._downtimeShape),this._downtimeShape.setFinalWidth(g),this._downtimeShape.setFinalHeight(l),this._downtimeShape.setFinalX(h),this._downtimeShape.setFinalY(d);var u={x:h,y:d,w:g,h:l,r:c};this._gantt.getAnimationManager().preAnimateTaskDowntime(this,this._downtimeShape,u,()=>{e._applyStyles(e._downtimeShape,"downtime")})}else this.removeDowntime()}else this.removeDowntime()}removeDowntime(){var e,t=this;this._downtimeShape&&(e=()=>{t._downtimeShape&&(t._downtimeShape.removeFromParent(),t._downtimeShape=null)},this._gantt.getAnimationManager().preAnimateTaskDowntimeRemove(this._downtimeShape,e))}renderAttribute(){var e=this;if("on"===this._container.getValue("attribute","rendered")&&this._mainShape&&!this.isMilestone("main")){var t=this._container.getLayoutObject().attributeHeight,a=this._mainShape.getFinalWidth();null==this._attributeShape?(this._attributeShape=new o(this._gantt.getCtx(),0,0,a,t,"0",this,"attribute"),this._attributeShape.setRenderState("add")):this._attributeShape.setRenderState("exist"),(this._mainContainer||this._container).addChild(this._attributeShape),this._attributeShape.setFinalWidth(a),this._attributeShape.setFinalHeight(t),this._attributeShape.setFinalX(0),this._attributeShape.setFinalY(0);var i={x:0,y:0,w:a,h:t,r:"0"};this._gantt.getAnimationManager().preAnimateTaskAttribute(this,this._attributeShape,i,()=>{e._applyStyles(e._attributeShape,"attribute")})}else this.removeAttribute()}removeAttribute(){var e,t=this;this._attributeShape&&(e=()=>{t._attributeShape&&(t._attributeShape.removeFromParent(),t._attributeShape=null)},this._gantt.getAnimationManager().preAnimateTaskAttributeRemove(this._attributeShape,e))}renderMainResizeHandles(e){var a,i,n,r,h,l=t.Agent.isRightToLeft(this._gantt.getCtx())?-1:1;if(this._mainShape){a=s.getTaskResizeHandleWidth(),i=this._mainShape.getX()-l*this._mainShape.getPhysicalStartOffset(),n=this._mainShape.getY(),r=this._mainShape.getWidth()+this._mainShape.getPhysicalStartOffset()+this._mainShape.getPhysicalEndOffset(),h=this._mainShape.getHeight();var d=this,g=(e,a)=>{if(t.Agent.isTouchDevice()||t.Agent.isEnvironmentTest()){var i=d._gantt.getOptions().translations,s="start"===a?i.taskResizeStartHandle:i.taskResizeEndHandle;e.setAriaRole("img"),e.setAriaProperty("label",s)}};this._mainHandleStart?this._mainHandleStart.setDimensions(i,n,a,h,"0"):(this._mainHandleStart=new o(this._gantt.getCtx(),i,n,a,h,"0",this,"mainResizeHandleStart"),g(this._mainHandleStart,"start")),e.addChild(this._mainHandleStart),this._mainHandleEnd?this._mainHandleEnd.setDimensions(i+l*(r-a),n,a,h,"0"):(this._mainHandleEnd=new o(this._gantt.getCtx(),i+l*(r-a),n,a,h,"0",this,"mainResizeHandleEnd"),g(this._mainHandleEnd,"end")),e.addChild(this._mainHandleEnd)}}removeHandles(e){this._mainHandleStart&&e!==this._mainHandleStart&&(this._mainHandleStart.getParent().removeChild(this._mainHandleStart),this._mainHandleStart=null),this._mainHandleEnd&&e!==this._mainHandleEnd&&(this._mainHandleEnd.getParent().removeChild(this._mainHandleEnd),this._mainHandleEnd=null)}highlight(){this._mainShape&&this._mainShape.highlight(),this._mainSelectShape&&this._mainSelectShape.highlight(),this._mainHoverShape&&this._mainHoverShape.highlight(),this._mainCustomContent&&this._mainCustomContent.highlight(),this._baselineShape&&this._baselineShape.highlight(),this._progressShape&&this._progressShape.highlight(),this._attributeShape&&this._attributeShape.highlight(),this._overtimeShape&&this._overtimeShape.highlight(),this._downtimeShape&&this._downtimeShape.highlight()}unhighlight(){this._mainShape&&this._mainShape.unhighlight(),this._mainSelectShape&&this._mainSelectShape.unhighlight(),this._mainHoverShape&&this._mainHoverShape.unhighlight(),this._mainCustomContent&&this._mainCustomContent.unhighlight(),this._baselineShape&&this._baselineShape.unhighlight(),this._progressShape&&this._progressShape.unhighlight(),this._attributeShape&&this._attributeShape.unhighlight(),this._overtimeShape&&this._overtimeShape.unhighlight(),this._downtimeShape&&this._downtimeShape.unhighlight()}}class c{constructor(e,t,a){this._gantt=e,this._container=t,this._associatedShape=a,this._renderState="add"}getGantt(){return this._gantt}getAssociatedShape(){return this._associatedShape}setAssociatedShape(e){this._associatedShape=e}getLabelOutputText(){return this._labelOutputText}getEffectiveLabelPosition(){return this._effectiveLabelPosition}getRenderState(){return this._renderState}_getLabelCSSStyle(e){let t;return null!=e&&Object.keys(e).length>0?(t=s.getTaskLabelStyle(this._gantt.getOptions()),t.parseInlineStyle(e)):t=this._gantt.getCache().getFromCache("baseTaskLabelCSSStyle"),t}_applyStyles(e,t){null!=e&&Object.keys(e).length>0&&this._labelOutputText.getStyle()!==e&&this._labelOutputText.setStyle(e),this._labelOutputText.getCSSStyle()!==t&&this._labelOutputText.setCSSStyle(t)}_placeLabel(e){var a,i,n,r,o,h,l=this._labelOutputText.getDimensions(),d=t.Agent.isRightToLeft(this._gantt.getCtx()),g=this._gantt.getOptions(),_=s.getTaskPadding(g),c=s.getTaskLabelMargin(g),u=_+c;switch("progress"!==e&&"progressStart"!==e||this.setAssociatedShape(this._container.getTask().getShape("progress")),h="main"===this._associatedShape.getType()&&this._container.getTask().isSummary("main")&&"alta"===this._gantt.getCtx().getThemeBehavior()?this._container.getLayoutObject().height:this._associatedShape.getFinalHeight(),o=this._associatedShape.getFinalY()+(h-l.h)/2,this.setFinalY(o),n=this._associatedShape.getFinalWidth(),a=d?this._associatedShape.getPhysicalEndOffset():this._associatedShape.getPhysicalStartOffset(),i=d?this._associatedShape.getPhysicalStartOffset():this._associatedShape.getPhysicalEndOffset(),e){case"end":d?this._labelOutputText.alignRight():this._labelOutputText.alignLeft(),r=n+i+c;break;case"progress":d?this._labelOutputText.alignLeft():this._labelOutputText.alignRight(),r=n-u;break;case"oProgress":d?this._labelOutputText.alignRight():this._labelOutputText.alignLeft(),r=this._container.getTask().getShape("progress").getFinalWidth()+u;break;case"innerStart":case"progressStart":d?this._labelOutputText.alignRight():this._labelOutputText.alignLeft(),r=-a+u;break;case"innerEnd":d?this._labelOutputText.alignLeft():this._labelOutputText.alignRight(),r=n+i-u;break;case"innerCenter":this._labelOutputText.alignCenter(),r=n/2;break;case"start":d?this._labelOutputText.alignLeft():this._labelOutputText.alignRight(),r=-(a+c)}d&&(r=-r),this.setFinalX(r),this._effectiveLabelPosition=e}_getAvailableWidth(e){var a,i,n,r,o,h,l,d,g,_,c,u,p,m,b,D,v,S,T,y,C,E,f=this._container.getLayoutObject(),O=this._container.getTask(),k=s.getTaskPadding(this._gantt.getOptions()),w=s.getTaskLabelMargin(this._gantt.getOptions()),A=k+w,R=t.Agent.isRightToLeft(this._gantt.getCtx()),x=this._gantt.getContentLength(),L=!1;switch(E=x-(C=R?x:0),e){case"end":case"end_ABSOLUTE":if(S="end",i=E,r=f.nextAdjacentTaskObj,o=f.nextAdjMilestoneBaselineTaskObj,r&&r.startTime<f.endTime&&r.endTime>f.endTime){v=0;break}for(;r&&r.startTime<f.endTime&&r.endTime<f.endTime;)r=r.nextAdjacentTaskObj;if(r)if((d=r.node)&&d.getParent())i=d.getTaskShapePhysicalBounds("main").startPos;else if(null!=r.startTime||null!=r.endTime){i=O.getTimeSpanDimensions(r.startTime,r.endTime).startPos}if(o)if((g=o.node)&&g.getParent())i=R?Math.max(i,g.getTaskShapePhysicalBounds("baseline").startPos):Math.min(i,g.getTaskShapePhysicalBounds("baseline").startPos);else if(null!=o.startTime||null!=o.endTime){var P=O.getTimeSpanDimensions(o.baselineStartTime,o.baselineEndTime).startPos;i=R?Math.max(i,P):Math.min(i,P)}v=Math.abs(this._container.getTaskShapePhysicalBounds("main").endPos-i)-2*w;break;case"innerCenter":case"innerStart":case"innerEnd":(r=f.nextAdjacentTaskObj)&&("innerCenter"===e?L=r.startTime<f.startTime+(f.endTime-f.startTime)/2:"innerEnd"===e&&(L=r.startTime<f.endTime));case"innerCenter_ABSOLUTE":case"innerStart_ABSOLUTE":case"innerEnd_ABSOLUTE":if("_ABSOLUTE"===e.slice(-9)&&(e=e.slice(0,-9)),y=this._labelOutputText&&"number"==typeof this._container.getValue("progress","value"),!O.isMilestone("main")){if(L){v=0,S=e;break}if(c=this._container.getTaskShapePhysicalBounds("main"),b=Math.abs(c.endPos-c.startPos),y){if(T=this._labelOutputText.getDimensions(),(u=O.getShape("progress"))?(p=u.getFinalWidth(),m=u.getFinalHeight()):(p=0,m=0),D=b-p,"innerStart"===e){if(v=p-2*A,T.w<=v&&T.h<=m){S="progressStart";break}}else if("innerEnd"===e&&(v=D-2*A,T.w<v)){S="innerEnd";break}T.h<=m&&p>D?(v=p-2*A,S="progress"):(v=D-2*A,S="oProgress");break}v=b-2*A,S=e;break}v=0,S=e;break;case"start":case"start_ABSOLUTE":if(S="start",a=C,n=f.previousAdjacentTaskObj,h=f.previousAdjacentMilestoneBaselineTaskObj,n&&n.endTime>f.startTime&&n.startTime<f.startTime){v=0;break}if(n)if((l=n.node)&&l.getParent())a=l.getTaskShapePhysicalBounds("main",!0).endPos;else if(null!=n.startTime||null!=n.endTime){a=O.getTimeSpanDimensions(n.startTime,n.endTime).endPos}if(h)if((_=h.node)&&_.getParent())a=R?Math.min(a,_.getTaskShapePhysicalBounds("baseline").endPos):Math.max(a,_.getTaskShapePhysicalBounds("baseline").endPos);else if(null!=h.startTime||null!=h.endTime){var M=O.getTimeSpanDimensions(h.baselineStartTime,h.baselineEndTime).endPos;a=R?Math.max(a,M):Math.min(a,M)}v=Math.abs(a-this._container.getTaskShapePhysicalBounds("main").startPos)-2*w;break;default:return null}return[S,v]}_preprocessLabelPosition(e){var t=this._container.getTask().isMilestone("main");if("string"==typeof e){if(t)switch(e){case"innerCenter":case"innerEnd":e="end";break;case"innerStart":e="start"}return[e+"_ABSOLUTE"]}return Array.isArray(e)?t?e.map(e=>{switch(e){case"innerCenter":case"innerEnd":return"end";case"innerStart":return"start";default:return e}}):e:[]}_evaluatePosition(e){for(var a,i,s,n={},r=this._labelOutputText.getDimensions().w,o=0,h=0;h<e.length;h++){var l=e[h];if("max"!==l){if(n[l]?d=n[l]:(d=this._getAvailableWidth(l),n[l]=d),d){if(a=d[0],r<=(i=d[1]))break;i>o&&(o=i,s=l)}}else if(null!=s){var d=n[s];a=d[0],i=d[1];break}}if(null==a)return!1;if(i<=1)return!1;let g=!0;return r>i&&(g=t.TextUtils.fitText(this._labelOutputText,i,1/0,this._container,1)),!!g&&(this._placeLabel(a),!0)}render(){var e,a,i=this._gantt.getCtx(),s=this._container.getValue("label"),n=this._container.getValue("labelPosition"),r=this._container.getValue("labelStyle"),o=this,h=this._gantt.GetStyleClass("taskLabel");if(this._renderState="exist",null!=s&&s.length>0&&"none"!==n&&this._associatedShape){const l=this._getLabelCSSStyle(r),d=this._preprocessLabelPosition(n);if(1===d.length&&"_ABSOLUTE"===d[0].slice(-9)){const e=this._getAvailableWidth(d[0])[1];if(e<=0)return void this.remove();const a=t.TextUtils.getTextStringWidth(i,"|",l);if(a*s.length>e){if(1===s.length)return void this.remove();if(a+t.TextUtils.getTextStringWidth(i,t.TextUtils.ELLIPSIS,l)>e)return void this.remove()}}null==this._labelOutputText&&(this._labelOutputText=new t.OutputText(this._gantt.getCtx(),s,0,0),this._gantt.getEventManager().IsDragSupported("tasks")&&(h+=" "+this._gantt.GetStyleClass("draggable")),this._labelOutputText.setClassName(h),this._renderState="add"),null==this._labelOutputText.getParent()&&this._container.addChild(this._labelOutputText),this._labelOutputText.setTextString(s),this._applyStyles(r,l),this._evaluatePosition(d)?(a=()=>{switch(o._effectiveLabelPosition){case"innerCenter":case"innerEnd":case"innerStart":case"progressStart":case"progress":case"oProgress":const e=o._associatedShape.getFillColor();if(e&&!e.fromShapeCache&&(!r||!r.color)){const a=t.ColorUtils.getContrastingTextColor(e.computedFill);o._labelOutputText.setFill(new t.SolidFill(a))}}},e={x:this.getFinalX(),y:this.getFinalY()},this._gantt.getAnimationManager().preAnimateTaskLabel(this._container,e,a)):this.remove()}else this.remove()}remove(){var e,t=this;this._labelOutputText&&(e=()=>{t._container.removeChild(t._labelOutputText),t._labelOutputText=null,t._effectiveLabelPosition=null},this._gantt.getAnimationManager().preAnimateTaskLabelRemove(this._labelOutputText,e))}highlight(){this._labelOutputText&&!this._isHighlighted&&t.ToolkitUtils.addClassName(this._labelOutputText.getElem(),this._gantt.GetStyleClass("taskHighlight")),this._isHighlighted=!0}unhighlight(){this._labelOutputText&&this._isHighlighted&&t.ToolkitUtils.removeClassName(this._labelOutputText.getElem(),this._gantt.GetStyleClass("taskHighlight")),this._isHighlighted=!1}getFinalX(){return this._finalX}setFinalX(e){this._finalX=e}getFinalY(){return this._finalY}setFinalY(e){this._finalY=e}}class u extends t.Container{constructor(e){super(e.getCtx(),null),this._gantt=e,this._task=new _(e,this),this._taskLabel=new c(e,this),this._gantt.getEventManager().associate(this,this),this.nodeType="task"}getId(){return this._taskObj.id}setLayoutObject(e){this._taskObj=e}getLayoutObject(){return this._taskObj}getData(e){return e?a.TimeComponent.sanitizeData(this._taskObj.data,"task"):this._taskObj.data}getValue(e,t){var a,i=this._gantt.getOptions().taskDefaults;switch(e){case"start":a=this._taskObj.startTime;break;case"end":a=this._taskObj.endTime;break;case"height":a=this._taskObj.height;break;case"baseline":if("height"===t){a=this._taskObj.baselineHeight;break}if((a=this._taskObj.data.baseline)&&null!=t)switch(t){case"start":a=this._taskObj.baselineStartTime;break;case"end":a=this._taskObj.baselineEndTime;break;default:a=null!=a[t]?a[t]:i.baseline[t]}break;case"overtime":if((a=this._taskObj.data.overtime)&&null!=t)switch(t){case"start":a=this._taskObj.overtimeStartTime;break;case"end":a=this._taskObj.overtimeEndTime;break;default:a=null!=a[t]?a[t]:i.overtime[t]}break;case"downtime":if((a=this._taskObj.data.downtime)&&null!=t)switch(t){case"start":a=this._taskObj.downtimeStartTime;break;case"end":a=this._taskObj.downtimeEndTime;break;default:a=null!=a[t]?a[t]:i.downtime[t]}break;case"attribute":if((a=this._taskObj.data.attribute)&&null!=t&&(a=null!=a[t]?a[t]:i.attribute[t],"shortDesc"===t&&"function"==typeof a))return a(u.getShortDescContext(this));break;case"progress":if("height"===t){a=this._taskObj.progressHeight;break}(a=this._taskObj.data.progress)&&null!=t&&(a=null!=a[t]?a[t]:i.progress[t]);break;default:a=null!=this._taskObj.data[e]?this._taskObj.data[e]:i[e]}return"shortDesc"===e&&"function"==typeof a?a(u.getShortDescContext(this)):a}getSandboxValue(e,t){var a=this.getSandboxData(),i=this._gantt.getOptions().taskDefaults,s=a[e],n=i[e];return s&&null!=t&&(s=s[t]),n&&null!=t&&(n=n[t]),null!=s?s:n}getSandboxData(){if(!this._sandboxData){this._sandboxData=t.JsonUtils.clone(a.TimeComponent.sanitizeData(this._taskObj.data,"task")),this._sandboxData._rowNode=this.getRowNode(),this._sandboxData.start=this._taskObj.startTime,this._sandboxData.end=this._taskObj.endTime,this._sandboxData.height=this._taskObj.height;var e=this._sandboxData.baseline;e&&(e.start=this._taskObj.baselineStartTime,e.end=this._taskObj.baselineEndTime,e.height=this._taskObj.baselineHeight);var i=this._sandboxData.overtime;i&&(i.start=this._taskObj.overtimeStartTime,i.end=this._taskObj.overtimeEndTime);var s=this._sandboxData.downtime;s&&(s.start=this._taskObj.downtimeStartTime,s.end=this._taskObj.downtimeEndTime);var n=this._sandboxData.progress;n&&(n.height=this._taskObj.progressHeight)}return this._sandboxData}getRowNode(){return this._taskObj.rowObj.node}getGantt(){return this._gantt}getRenderState(){return this._taskObj.renderState}getPreviousAdjacentTaskObj(){return this._taskObj.previousAdjacentTaskObj}getNextAdjacentTaskObj(){return this._taskObj.nextAdjacentTaskObj}getPrevAdjMilestoneBaselineTaskObj(){return this._taskObj.prevAdjMilestoneBaselineTaskObj}getNextAdjMilestoneBaselineTaskObj(){return this._taskObj.nextAdjMilestoneBaselineTaskObj}getTaskShapePhysicalBounds(e,a){var i=t.Agent.isRightToLeft(this._gantt.getCtx()),n=this._gantt.getOptions(),r=i?-1:1,o=this._task.getShape(e),h=o.getFinalX()+this.getFinalX(),l=o.getFinalWidth()+o.getPhysicalEndOffset(),d=h-r*o.getPhysicalStartOffset(),g=h+r*l;if(a){var _=this._taskLabel.getLabelOutputText();if(_&&null!=_.getParent()){var c=this._taskLabel.getEffectiveLabelPosition();"end"===c?g+=r*(s.getTaskLabelMargin(n)+_.getDimensions().w):"start"===c&&(d-=r*(s.getTaskLabelMargin(n)+_.getDimensions().w))}}return{startPos:d,endPos:g}}scrollIntoView(e,a){var i,n,r,o,h=t.Agent.isRightToLeft(this._gantt.getCtx()),d=this._gantt.getDatabody(),g=this._gantt.getOptions();this._gantt.getDataLayoutManager().ensureInDOM(this.getLayoutObject(),"task");var _,c,u=this._gantt.getEventManager().getKeyboardDnDMode();u===l.KEYBOARD_MOVE&&this._mainDragFeedbacks&&this._mainDragFeedbacks.length>0?(_=this._mainDragFeedbacks[0].getTask().getShape("main"),c=this._mainDragFeedbacks[0]):(u===l.KEYBOARD_RESIZE_START||u===l.KEYBOARD_RESIZE_END)&&this._mainResizeHandleDragFeedbacks&&this._mainResizeHandleDragFeedbacks.length>0?(_=this._mainResizeHandleDragFeedbacks[0].getTask().getShape("main"),c=this._mainResizeHandleDragFeedbacks[0]):(_=(_=this.getTask().getShape("main"))||this.getTask().getShape("baseline"),c=this),r=_.getWidth()+_.getPhysicalStartOffset()+_.getPhysicalEndOffset(),o=_.getHeight(),i=h?_.getX()-r+_.getPhysicalStartOffset():_.getX()-_.getPhysicalStartOffset(),n=_.getY();var p=d.stageToLocal(c.localToStage({x:i,y:n})),m=new t.Rectangle(p.x,p.y,r,o);this._gantt.scrollIntoView(m,e,a,s.getRowPaddingTop(g))}setTranslateX(e){var t=this._gantt.getRenderingPrecision(),a=null===t?e:this._gantt.round(e,t);return super.setTranslateX(a)}setTranslateY(e){var t=this._gantt.getRenderingPrecision(this._gantt),a=null===t?e:this._gantt.round(e,t);return super.setTranslateY(a)}setTranslate(e,t){var a=this._gantt.getRenderingPrecision(this._gantt),i=null===a?e:this._gantt.round(e,a),s=null===a?t:this._gantt.round(t,a);return super.setTranslate(i,s)}highlight(){this._task.highlight(),this._taskLabel.highlight()}unhighlight(){this._task.unhighlight(),this._taskLabel.unhighlight()}getDraggedObject(){return this._draggedObj}setDraggedObject(e){this._draggedObj=e}dragStartSetup(){this.hideDnDArtifacts(this._draggedObj)}dragEndCleanup(){if(this.hideDnDArtifacts(),this._sandboxData=null,this._gantt.isSelectionSupported()&&this.isSelected())for(var e=this._gantt.getSelectionHandler().getSelection(),t=0;t<e.length;t++){var a=e[t];a&&"task"===a.nodeType&&(a.show(),a.getPredecessorDependencies().forEach(e=>e.show()),a.getSuccessorDependencies().forEach(e=>e.show()))}}dragCancelCleanup(){if(this._gantt.isSelectionSupported()&&this.isSelected())for(var e=this._gantt.getSelectionHandler().getSelection(),t=0;t<e.length;t++){var a=e[t];if(a&&"task"===a.nodeType){var i=a.getRowNode();i&&i.showEffect("selected")}}}_renderClone(e){var t=new u(this._gantt),a=Object.assign({},this._taskObj);a.node=t,a._overtimeOffset=null!=a.overtimeStartTime?a.overtimeStartTime-a.startTime:0,a._downtimeOffset=null!=a.downtimeStartTime?a.downtimeStartTime-a.startTime:0,t.setLayoutObject(a);var i=this._gantt.getAnimationManager(),s=i.getAnimationMode();i.setAnimationMode("none"),t.render(e);var n=t.getTask(),r=t.getTaskLabel();return r.setAssociatedShape(n.getShape("main")),r.render(),t._selected=!0,n.showMainEffect("selected"),t.setMouseEnabled(!1),i.setAnimationMode(s),t}_renderOutlineClone(e){var t=this.getTask(),a=t.getShape("main"),i=new o(this._gantt.getCtx(),this.getTranslateX()+a.getFinalX(),this.getTranslateY()+a.getFinalY(),a.getFinalWidth(),a.getFinalHeight(),a.getBorderRadius(),t,"mainDragFeedback");return e.addChildAt(i,0),i}_setWidth(e){var a=t.Agent.isRightToLeft(this._gantt.getCtx()),s=a?1:-1,n=this._gantt.getStartTime(),r=this._gantt.getEndTime(),o=this._gantt.getContentLength(),h=a?o-this.getTranslateX():this.getTranslateX(),l=i.TimeAxisUtils.getPositionDate(n,r,h,o),d=this.getTranslateX()-s*e;d=a?o-d:d;var g=i.TimeAxisUtils.getPositionDate(n,r,d,o);if(this._taskObj.startTime=l,this._taskObj.endTime=g,this._taskObj.overtimeStartTime){var _=this._taskObj.overtimeEndTime-this._taskObj.overtimeStartTime;this._taskObj.overtimeStartTime=l+this._taskObj._overtimeOffset,this._taskObj.overtimeEndTime=this._taskObj.overtimeStartTime+_}if(this._taskObj.downtimeStartTime){var c=this._taskObj.downtimeEndTime-this._taskObj.downtimeStartTime;this._taskObj.downtimeStartTime=l+this._taskObj._downtimeOffset,this._taskObj.downtimeEndTime=this._taskObj.downtimeStartTime+c}this._taskObj.x=this.getTranslateX(),this._taskObj.y=this.getTranslateY();var u=this._gantt.getAnimationManager(),p=u.getAnimationMode();u.setAnimationMode("none"),this.render(this.getParent(),!0),this.getTaskLabel().render(),this.getTask().showMainEffect("selected"),u.setAnimationMode(p)}_getWidth(){return this.getTask().getShape("main").getWidth()}hide(e){this.setAlpha(0);var t=this.getRowNode();e&&t&&t.removeEffect("selected")}show(){this.setAlpha(1)}showDragFeedback(e,a,n,r,o){var h=this._gantt.getEventManager();if(this._draggedObj&&h){var l,d,g,_,c,u,p,m,b=h.getDnDTaskSubType(this._draggedObj),D=t.Agent.isRightToLeft(this._gantt.getCtx()),v=D?1:-1,S=this._gantt.getDnDArtifactsContainer(),T=this._gantt.getStartTime(),y=this._gantt.getEndTime(),C=this._gantt.getContentLength();switch(b){case"tasks":if(l=o?{deltaX:0,deltaY:0}:this._gantt.autoPanOnEdgeDrag(a,s.getAutoPanEdgeThreshold(),!1,!1),d=r.x+a.x+l.deltaX,g=r.y+a.y+l.deltaY,!n)return;if(n&&"row"===n.nodeType)m=n;else{if(!n||"task"!==n.nodeType)return;m=n.getRowNode()}this._renderTaskMoveDragFeedback(d,g,S,m),this._renderDependencyLinesDragFeedback(this._mainDragFeedbacks,S);var E=this.getTask().getShape("main");_=D?C-d:d,u=D?C-(d-E.getFinalWidth()):d+E.getFinalWidth(),c=i.TimeAxisUtils.getPositionDate(T,y,_,C),p=i.TimeAxisUtils.getPositionDate(T,y,u,C),this._showDragFeedbackTooltip(e,c,p,this._mainDragFeedbacks[0],"center",m);break;case"taskResizeHandles":l=o?{deltaX:0,deltaY:0}:this._gantt.autoPanOnEdgeDrag(a,s.getAutoPanEdgeThreshold(),!1,!0),d=a.x+l.deltaX,this._renderTaskResizeDragFeedback(d,S),this._renderDependencyLinesDragFeedback(this._mainResizeHandleDragFeedbacks,S);var f="mainResizeHandleEnd"===this._draggedObj.getType();f?(c=this.getValue("start"),u=this._mainResizeHandleDragFeedbacks[0].getTranslateX()-v*this._mainResizeHandleDragFeedbacks[0]._getWidth(),u=D?C-u:u,p=i.TimeAxisUtils.getPositionDate(T,y,u,C)):(_=this._mainResizeHandleDragFeedbacks[0].getTranslateX(),_=D?C-_:_,c=i.TimeAxisUtils.getPositionDate(T,y,_,C),p=this.getValue("end")),this._showDragFeedbackTooltip(e,c,p,this._mainResizeHandleDragFeedbacks[0],f?"end":"start")}}}_showDragFeedbackTooltip(e,a,i,s,n,r){var o=t.Agent.isRightToLeft(this._gantt.getCtx()),h=this.getSandboxData();r&&(h._rowNode=r);var l=h.start;if(h.start=a,h.end=i,h.overtime&&h.overtime.start){var d=h.overtime.start-l,g=h.overtime.end-h.overtime.start;h.overtime.start=h.start+d,h.overtime.end=h.overtime.start+g}if(h.downtime&&h.downtime.start){var _=h.downtime.start-l,c=h.downtime.end-h.downtime.start;h.downtime.start=h.start+_,h.downtime.end=h.downtime.start+c}var u,p=s.getDimensions(this.getCtx().getStage());switch(n){case"start":u=new t.Point(p.x+o*p.w,p.y);break;case"end":u=new t.Point(p.x+!o*p.w,p.y);break;default:u=p.getCenter()}var m=this.getCtx().stageToPageCoords(u.x,u.y);this._gantt.getEventManager().ProcessObjectTooltip(e,m.x,m.y,this,s.getElem())}_renderTaskMoveDragFeedback(e,a,n,r){var o=this._gantt.getOptions(),h=t.Agent.isRightToLeft(this._gantt.getCtx()),l=this._gantt.getStartTime(),d=this._gantt.getEndTime(),g=this._gantt.getContentLength(),_=this.getTask().getShape("main"),c=null!=o.rowDefaults.height?(o.rowDefaults.height-_.getFinalHeight())/2:s.getRowPaddingTop(o),u=r.localToStage({x:0,y:r.getFinalY()+c}),p=this._gantt.getDnDArtifactsContainer().stageToLocal(u).y,m=(e,t,a)=>{e.setTranslate(t,a),e._taskObj.x=t,e._taskObj.y=a};if(this._mainDragFeedbacks)for(var b=0;b<this._mainDragFeedbacks.length;b++){var D=this._mainDragFeedbacks[b],v=this._mainDragFeedbackOffsets[b],S=e+v.x;if(m(D,S,a+v.y),0===b){var T=this._mainDropOutlineFeedbacks[b];T.setX(S),T.setY(p)}this._mainDragFeedbackStartTimes[b]=i.TimeAxisUtils.getPositionDate(l,d,h?g-S:S,g)}else{this.hide(!0);var y=this._renderOutlineClone(n),C=this._renderOutlineClone(n);C.setX(e),C.setY(a);var E=this._renderClone(n);if(m(E,e,a),this._mainDragFeedbacks=[E],this._mainDragOutlineFeedbacks=[y],this._mainDropOutlineFeedbacks=[C],this._mainDragFeedbackOffsets=[new t.Point(0,0)],this._mainDragFeedbackStartTimes=[this.getValue("start")],this._gantt.isSelectionSupported()&&this.isSelected()&&this._gantt.getSelectionHandler().getSelectedCount()>1){var f=this._gantt.getSelectionHandler().getSelection();for(b=0;b<f.length;b++){var O=f[b];if(O&&"task"===O.nodeType&&O!==this){var k=O.getTask().getShape("main"),w=k.getX()+O.getTranslateX()-(_.getX()+this.getTranslateX()),A=k.getY()+O.getTranslateY()-(_.getY()+this.getTranslateY()),R=e+w,x=a+A;O.hide(!0);var L=O._renderOutlineClone(n);m(D=O._renderClone(n),R,x),this._mainDragFeedbacks.push(D),this._mainDragOutlineFeedbacks.push(L),this._mainDragFeedbackOffsets.push(new t.Point(w,A)),this._mainDragFeedbackStartTimes.push(O.getValue("start"))}}}}}_renderTaskResizeDragFeedback(e,a){var i,s,n=t.Agent.isRightToLeft(this._gantt.getCtx()),r=n?1:-1,o=this.getTask().getShape("main"),h="mainResizeHandleEnd"===this._draggedObj.getType();h?(i=o.getFinalX()+this.getTranslateX(),s=n?Math.min(e,i):Math.max(e,i)):(i=o.getFinalX()-r*o.getFinalWidth()+this.getTranslateX(),s=n?Math.max(e,i):Math.min(e,i));var l=Math.abs(s-i)-o.getFinalWidth(),d=(e,t,a)=>{e.setTranslate(t,a),e._taskObj.x=t,e._taskObj.y=a};if(this._mainResizeHandleDragFeedbacks)for(var g=0;g<this._mainResizeHandleDragFeedbacks.length;g++){var _=this._mainResizeHandleDragFeedbacks[g],c=this._mainResizeHandleDragFeedbackSources[g],u=c.getTask().getShape("main"),p=Math.max(0,u.getFinalWidth()+l);if(!h){var m=u.getFinalX()-r*u.getFinalWidth()+c.getTranslateX();_.setTranslateX(m+r*p),_._taskObj.x=_.getTranslateX()}_._setWidth(p)}else{this.hide();var b=this._renderClone(a);if(d(b,h?i:s,o.getFinalY()+this.getTranslateY()),this._mainResizeHandleDragFeedbacks=[b],this._mainResizeHandleDragFeedbackSources=[this],this._gantt.isSelectionSupported()&&this.isSelected()&&this._gantt.getSelectionHandler().getSelectedCount()>1){var D=this._gantt.getSelectionHandler().getSelection();for(g=0;g<D.length;g++){var v=D[g];if(v&&"task"===v.nodeType&&v!==this){var S,T=v.getTask().getShape("main"),y=T.getFinalWidth()+l;S=h?T.getFinalX()+v.getTranslateX():T.getFinalX()-r*T.getFinalWidth()+v.getTranslateX()+r*y,v.hide(),d(_=v._renderClone(a),S,T.getFinalY()+v.getTranslateY()),this._mainResizeHandleDragFeedbacks.push(_),this._mainResizeHandleDragFeedbackSources.push(v)}}}}}_renderDependencyLinesDragFeedback(e,t){if(this._mainDependencyLineDragFeedbacks)this._mainDependencyLineDragFeedbacks.forEach(e=>e.render(t,!0));else{this._mainDependencyLineDragFeedbacks=[];const a=new Map;if(this._gantt.isSelectionSupported()&&this.isSelected()){this._gantt.getSelectionHandler().getSelection().forEach(e=>{const t=e.getPredecessorDependencies(),i=e.getSuccessorDependencies();t.forEach(e=>{e.hide(),a.set(e.getLayoutObject(),Object.assign({},e.getLayoutObject()))}),i.forEach(e=>{e.hide(),a.set(e.getLayoutObject(),Object.assign({},e.getLayoutObject()))})})}e.forEach(e=>{const t=e.getLayoutObject();t.predecessorDepObjs=t.predecessorDepObjs.map(e=>{const i=a.get(e);return i.successorTaskObj=t,i}),t.successorDepObjs=t.successorDepObjs.map(e=>{const i=a.get(e);return i.predecessorTaskObj=t,i})}),a.forEach((e,a)=>{const i=new n(this._gantt);i.setLayoutObject(e),e.node=i,i.render(t),i.setMouseEnabled(!1),this._mainDependencyLineDragFeedbacks.push(i)})}}_updateDragFeedbacks(){var e,a,s,n,r=t.Agent.isRightToLeft(this._gantt.getCtx()),o=this._gantt.getStartTime(),h=this._gantt.getEndTime(),l=this._gantt.getContentLength();if(this._mainDragFeedbacks){var d=i.TimeAxisUtils.getDatePosition(o,h,this._mainDragFeedbackStartTimes[0],l);d=r?l-d:d;for(var g=0;g<this._mainDragFeedbacks.length;g++){e=this._mainDragFeedbacks[g],s=this._mainDragOutlineFeedbacks[g],a=i.TimeAxisUtils.getDatePosition(o,h,this._mainDragFeedbackStartTimes[g],l),a=r?l-a:a,this._mainDragFeedbackOffsets[g].x=a-d;var _=this.getTask().getShape("main"),c=_.getFinalWidth();e.setTranslateX(a),e._taskObj.x=e.getTranslateX(),e._setWidth(c),s.setX(_.getFinalX()+this.getFinalX()),s.setWidth(c),0===g&&((n=this._mainDropOutlineFeedbacks[g]).setX(a),n.setWidth(c)),0===g&&this._gantt.getEventManager()._keyboardDnDFeedbackLocalPos&&(this._gantt.getEventManager()._keyboardDnDFeedbackLocalPos.x=a)}}if(this._mainResizeHandleDragFeedbacks)for(g=0;g<this._mainResizeHandleDragFeedbacks;g++){e=this._mainResizeHandleDragFeedbacks[g];var u=i.TimeAxisUtils.getDatePosition(o,h,this._mainResizeHandleDragFeedbackSources[g].getValue("start"),l),p=i.TimeAxisUtils.getDatePosition(o,h,this._mainResizeHandleDragFeedbackSources[g].getValue("end"),l);a=r?l-u:u,e.setTranslateX(a),e._taskObj.x=e.getTranslateX(),e._setWidth(Math.abs(p-u)),0===g&&this._gantt.getEventManager()._keyboardDnDFeedbackLocalPos&&(this._gantt.getEventManager()._keyboardDnDFeedbackLocalPos.x=a)}this._mainDependencyLineDragFeedbacks&&this._mainDependencyLineDragFeedbacks.forEach(e=>e.render(e.getParent(),!0))}removeDragFeedbacks(){if(this._mainDragFeedbacks){for(var e=0;e<this._mainDragFeedbacks.length;e++)this._mainDragFeedbacks[e].getParent().removeChild(this._mainDragFeedbacks[e]),this._mainDragOutlineFeedbacks[e].getParent().removeChild(this._mainDragOutlineFeedbacks[e]);this._mainDropOutlineFeedbacks[0].getParent().removeChild(this._mainDropOutlineFeedbacks[0]),this._mainDragFeedbacks=null,this._mainDragOutlineFeedbacks=null,this._mainDropOutlineFeedbacks=null,this._mainDragFeedbackOffsets=null,this._mainDragFeedbackStartTimes=null}if(this._mainDependencyLineDragFeedbacks){for(e=0;e<this._mainDependencyLineDragFeedbacks.length;e++)this._mainDependencyLineDragFeedbacks[e].getParent().removeChild(this._mainDependencyLineDragFeedbacks[e]);this._mainDependencyLineDragFeedbacks=null}if(this._mainResizeHandleDragFeedbacks){for(e=0;e<this._mainResizeHandleDragFeedbacks.length;e++)this._mainResizeHandleDragFeedbacks[e].getParent().removeChild(this._mainResizeHandleDragFeedbacks[e]);this._mainResizeHandleDragFeedbacks=null,this._mainResizeHandleDragFeedbackSources=null}this._gantt.getEventManager().hideTooltip()}hideDnDArtifacts(){this.removeDragFeedbacks()}getTask(){return this._task}getTaskLabel(){return this._taskLabel}render(e,a){var i;a=!1!==a;this._gantt.getEventManager().isDnDDragging()||this.show();var s=t.SelectionEffectUtils.getSelectingCursor();this.isSelectable()&&this.getCursor()!==s&&this.setCursor(s),this.getParent()!=e&&e.addChild(this),this._task.render(a),this._getAriaTarget().setAriaRole("img"),this.refreshAriaLabel(),this._updateDragFeedbacks(),i={x:this.getFinalX(),y:this.getFinalY()},this._gantt.getAnimationManager().preAnimateTaskNode(this,i)}remove(){var e,t=this;e=()=>{t.getRowNode().removeChild(t)},this._gantt.getAnimationManager().preAnimateTaskNodeRemove(this,e)}getPredecessorDependencies(){var e=this._gantt.getDataLayoutManager();return this._taskObj.predecessorDepObjs.map(t=>(t.node||e.ensureInDOM(t,"dependency"),t.node))}getSuccessorDependencies(){var e=this._gantt.getDataLayoutManager();return this._taskObj.successorDepObjs.map(t=>(t.node||e.ensureInDOM(t,"dependency"),t.node))}getFinalX(){return this._taskObj.x}getFinalY(){return this._taskObj.y}getFinalHeight(e){return this._task.getFinalHeight(e)}getDuration(e,a){var i=this._gantt.getOptions().translations,s=36e5,n=a-e,r=this._gantt.getMinorAxis().getScale();return"hours"===r||"minutes"===r||"seconds"===r?(n=Math.round(n/s*100)/100,t.ResourceUtils.format(i.accessibleDurationHours,[n])):(n=Math.round(n/864e5*100)/100,t.ResourceUtils.format(i.accessibleDurationDays,[n]))}getDisplayable(){return this}getAriaLabel(){var e=[],a=this._gantt.getOptions().translations,s=this.getLayoutObject().rowObj,n="";if(this._gantt.isRowsHierarchical()&&(n=a.labelLevel+" "+s.depth+", "),null!=this._gantt.getRenderState()){var r=s.data.label;return null==r&&(r=a.labelRow+" "+s.index+1),r=n+r,null!=s.expanded&&e.push(a[s.expanded?"stateExpanded":"stateCollapsed"]),t.Displayable.generateAriaLabel(r,e)}this.isSelectable()&&e.push(a[this.isSelected()?"stateSelected":"stateUnselected"]),null!=(s=this.getLayoutObject().rowObj).expanded&&e.push(a.labelRow+" "+a[s.expanded?"stateExpanded":"stateCollapsed"]);var o=h.getDatatip(this,!1,!0);this._task.isMilestone("main")?o=a.accessibleTaskTypeMilestone+", "+o:this._task.isSummary("main")&&(o=a.accessibleTaskTypeSummary+", "+o),o=n+o;var l=this._taskObj.predecessorDepObjs,d=this._taskObj.successorDepObjs;if(l.length>0||d.length>0){var g="";if(l.length>0&&(g=t.ResourceUtils.format(a.accessiblePredecessorInfo,[l.length]),i.TimeAxisUtils.supportsTouch()||t.Agent.isEnvironmentTest()))for(var _=0;_<l.length;_++)g=g+", "+l[_].ariaLabel;if(d.length>0&&(g.length>0&&(g+=", "),g+=t.ResourceUtils.format(a.accessibleSuccessorInfo,[d.length]),i.TimeAxisUtils.supportsTouch()||t.Agent.isEnvironmentTest()))for(_=0;_<d.length;_++)g=g+", "+d[_].ariaLabel;g.length>0&&(o=o+", "+g)}var c=t.Displayable.generateAriaLabel(o,e),u=this.getAriaProperty("label");return null!=u&&u.indexOf(c)>-1?null:c}_getAriaTarget(){var e=this.getTask().getShape("main");return t.Agent.isTouchDevice()&&this._gantt.isTaskResizeEnabled()&&e?e:this}refreshAriaLabel(){this._updateAriaLabel()}_updateAriaLabel(){t.Agent.deferAriaCreation()||this._getAriaTarget().setAriaProperty("label",this.getAriaLabel())}getDataContext(){var e=this.getData()._itemData,t=this.getTask().getFillColor();return{data:this.getData(!0),rowData:this.getRowNode().getData(!0),itemData:e||null,color:t?t.fill:null,component:this._gantt.getOptions()._widgetConstructor}}static getShortDescContext(e){var t=e.getData()._itemData;return{data:e.getData(!0),rowData:e.getRowNode().getData(!0),itemData:t||null}}getSandboxDataContext(){var e=this.getSandboxData();if(e.start=new Date(e.start).toISOString(),e.end=new Date(e.end).toISOString(),e.baseline){var t=e.baseline.start,a=e.baseline.end;e.baseline.start=null!=t?new Date(t).toISOString():null,e.baseline.end=null!=a?new Date(a).toISOString():null}var i=this._taskObj.data._itemData;return{data:e,rowData:e._rowNode.getData(!0),itemData:i||null,color:h.getDatatipColor(this),component:this._gantt.getOptions()._widgetConstructor}}_setSelected(e,t,a){this._selected=e,this._selected?this._task.showEffect("selected"):this._task.removeEffect("selected",t),this.refreshAriaLabel(),this._gantt.setCurrentRow(this.getRowNode().getId());const i=this._gantt.getOptions(),s=this._gantt.getEventManager().isMarqueeDragging();if("straight"===i.dependencyLineShape&&("highlightDependencies"!==i.selectionBehavior||s)){var n=this._gantt.getDependenciesContainer();this.getPredecessorDependencies().forEach(e=>{e.render(n,!1)}),this.getSuccessorDependencies().forEach(e=>{e.render(n,!1)})}if((!a||s)&&"highlightDependencies"===i.selectionBehavior){var r=this._gantt.getViewPort();this._gantt.getDataLayoutManager().renderViewportDependencyLines(r,"vpc_translate",{taskObj:this.getLayoutObject(),isSelected:e})}}clearSelectionState(){this._setSelected(!1,!1)}getDatatip(){return h.getDatatip(this,!0)}getDatatipColor(){return h.getDatatipColor(this)}isSelectable(){return"none"!=this._gantt.getOptions().selectionMode}isSelected(){return this._selected}setSelected(e,t){this._setSelected(e,!0,t)}showHoverEffect(){this._task.showEffect("hover")}hideHoverEffect(){this._task.removeEffect("hover")}getNextNavigable(e){var a=t.Agent.isRightToLeft(this._gantt.getCtx()),i=this._gantt.getEventManager().getKeyboardHandler();if(e.type===t.MouseEvent.CLICK||i.isMultiSelectEvent(e))return this;if(e.altKey&&(e.keyCode===t.KeyboardEvent.OPEN_ANGLED_BRACKET||e.keyCode===t.KeyboardEvent.CLOSE_ANGLED_BRACKET)&&i&&i.getFirstNavigableDependencyLine){var s;s=t.Agent.isRightToLeft(this.getGantt().getCtx())?e.keyCode===t.KeyboardEvent.CLOSE_ANGLED_BRACKET?"predecessor":"successor":e.keyCode===t.KeyboardEvent.OPEN_ANGLED_BRACKET?"predecessor":"successor";var n=this._gantt.getNavigableDependencyLinesForTask(this,s),r=i.getFirstNavigableDependencyLine(this,e,n);return r&&r.setKeyboardFocusTask(this),r}return this._gantt.isRowAxisEnabled()&&e.altKey&&(!a&&e.keyCode===t.KeyboardEvent.LEFT_ARROW||a&&e.keyCode===t.KeyboardEvent.RIGHT_ARROW)?this.getRowNode().getRowLabelContent():i.isNavigationEvent(e)&&null==this._gantt.getEventManager().getKeyboardDnDMode()?d.getNextNavigable(this._gantt,this,e):null}getTargetElem(){return this._task.getShape("main").getElem()}getKeyboardBoundingBox(e){return this.getDimensions(e)}showKeyboardFocusEffect(){this._isShowingKeyboardFocusEffect=!0,this._task.showEffect("focus");var e=this._gantt.getViewportStartTime(),t=this._gantt.getViewportEndTime();this.scrollIntoView(),this._gantt.getViewportStartTime()===e&&this._gantt.getViewportEndTime()===t||this._gantt.dispatchEvent(this._gantt.createViewportChangeEvent())}hideKeyboardFocusEffect(){this.isShowingKeyboardFocusEffect()&&(this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect())}isShowingKeyboardFocusEffect(){return this._isShowingKeyboardFocusEffect}isDragAvailable(e){return!0}getDragTransferable(e,t){return[this.getId()]}getDragFeedback(e,t){return null}}class p extends t.Container{constructor(e){super(e.getCtx(),null),this._gantt=e,this._referenceObjects=[],this._gantt.getEventManager().associate(this,this),this.nodeType="row"}getId(){return this._rowObj.id}getGantt(){return this._gantt}setLayoutObject(e){this._rowObj=e}getLayoutObject(){return this._rowObj}getData(e){return e?a.TimeComponent.sanitizeData(this._rowObj.data,"row"):this._rowObj.data}getIndex(){return this._rowObj.index}getFinalY(){return this._rowObj.y}getLabel(){return this._rowObj.data.label}setRowLabelContent(e){var t=this._gantt.getEventManager(),a=t.getFocus();this._rowLabelContent!==a&&a instanceof r&&a.getRow()===this&&(t.setFocus(e),e.showKeyboardFocusEffect()),this._rowLabelContent=e}getRowLabelContent(){return this._rowLabelContent}getRowAxisHorizontalLine(){return this._rowAxisHorizontalLine}getRenderState(){return this._rowObj.renderState}getTaskObjs(){return this._rowObj.taskObjs}getRenderOrderTaskObjs(e){var t=e?e.sort((e,t)=>e.startTime-t.startTime):this._rowObj.taskObjs;if(this._rowObj.earliestOverlayTaskObj){var a=[],i=[];return t.forEach(e=>{"overlay"===e.overlapBehavior?a.push(e):i.push(e)}),i.concat(a)}return t}_renderTasks(e){e&&e.tasksDelete.forEach(e=>{e.node.remove()});var t,a=this.getRenderOrderTaskObjs(e?[...e.tasksAdd,...e.tasksUpdate]:null),i=e?e.tasksAdd:new Set,s=!e||e.updateRender;for(let e=0;e<a.length;e++){var n=(d=a[e]).node;n||((n=new u(this._gantt)).setLayoutObject(d),d.node=n);var r=i.has(d);if(s||r){var o=n.getTask(),h=o.getTimeSpanDimensions(n.getValue("start"),n.getValue("end"));h||(h=o.getTimeSpanDimensions(n.getValue("baseline","start"),n.getValue("baseline","end"))),d.x=h.startPos,n.render(this,!0)}!r&&t&&i.has(t)&&this.addChild(n),t=d}var l=e=>{var t=e.node,a=t.getTaskLabel(),i=t.getTask();a.setAssociatedShape(i.getShape("main")),a.render(),this._gantt.isTaskResizeEnabled()?i.renderMainResizeHandles(t):i.removeHandles()};for(let e=0;e<a.length;e++){var d=a[e];r=i.has(d);if(s||r)r&&!s&&d.previousAdjacentTaskObj&&!i.has(d.previousAdjacentTaskObj)&&d.previousAdjacentTaskObj.node&&d.previousAdjacentTaskObj.node.getParent()&&l(d.previousAdjacentTaskObj),l(d);else if(i.has(d.previousAdjacentTaskObj))for(var g=d;g&&!i.has(g);){var _=g.node.getTaskLabel(),c=_.getEffectiveLabelPosition();l(g),g=c===_.getEffectiveLabelPosition()?null:g.nextAdjacentTaskObj}}}render(e,t){this._renderTasks(t),this._renderBackground(this._gantt,this._gantt.getDatabodyBackground()),this._renderReferenceObjects(this._gantt,this._gantt.getRowReferenceObjectsContainer()),this._renderHorizontalGridline(this._gantt,this),e&&(this._gantt.isRowAxisEnabled()&&this._gantt.getRowAxis()&&this._finalizeRowLabelRender(this._gantt),e.addChild(this)),this.getTaskObjs().some(e=>e.node&&e.node.isSelected())||this.removeEffect("selected")}_finalizeRowLabelRender(e){var a=t.Agent.isRightToLeft(e.getCtx()),i=this.getRowLabelContent(),n=this.getFinalY(),r=this._rowObj.height,o=e.getOptions(),h=s.getRowLabelPaddingStart(o),l=h+s.getRowLabelPaddingEnd(o),d=e.getRowAxis();if("g"===i.getDisplayableType())var g=a?d.getWidth()-h:h;else{var _=i.getDisplayable();_.isTruncated()&&_.setTextString(_.getUntruncatedTextString()),t.TextUtils.fitText(_,d.getWidth()-l,r,_.getParent(),1),a?(_.alignRight(),g=d.getWidth()-h):g=h}var c=n-i.getYTopOffset()+(r-i.getHeight())/2;i.setRow(this);var u={x:g,y:c,backgroundX:.5,backgroundY:this._rowObj.y+.5,backgroundWidth:d.getWidth()-.5,backgroundHeight:this._rowObj.height-.5},p=this.getLabelState();p&&(i.setY(p.y),i.setX(p.x),i.getBackground().setRect(p.backgroundX,p.backgroundY,d.getWidth(),p.backgroundHeight));this.recordLabelState(u),this._gantt.getAnimationManager().preAnimateRowLabel(this,i,u)}_renderBackground(e,a){var i,s=this._rowObj.y,n=e.getContentLength(),r=this._rowObj.height,o="exist";this._background||(this._background=new t.Rect(e.getCtx(),0,s,n,r),this._background.setPixelHinting(!0),this._background.setClassName(e.GetStyleClass("row")),o="add",this._gantt.getEventManager().associate(this._background,this)),a.addChild(this._background),i={y:s,w:n,h:r},this._gantt.getAnimationManager().preAnimateRowBackground(this._background,i,o)}_renderReferenceObjects(e,t){var a=this._rowObj.data.referenceObjects||[],i=e.getEventManager(),s=e.getAnimationManager(),n=this._rowObj.y,r=n+this._rowObj.height,o=n,h=r;this._referenceObjects.length>0&&(o=this._referenceObjects[0].getY1(),h=this._referenceObjects[0].getY2()),this._referenceObjects.forEach(e=>t.removeChild(e)),this._referenceObjects=e.generateReferenceObjects(a,"area"),this._referenceObjects.forEach(e=>{i.associate(e,this),e.render(t,o,h),s.preAnimateRowReferenceObject(e,{y1:n,y2:r})})}getBackground(){return this._background}_renderHorizontalGridline(e,a){var i,n,r,o,h="exist",l=e.GetStyleClass("hgridline"),d=s.getHorizontalGridlineWidth(e.getOptions())%2*.5,g=this._gantt.getRowAxis(),_=this._gantt.isRowAxisEnabled()&&g;if(e.isHorizontalGridlinesVisible()){if(r=n=this._rowObj.y+this._rowObj.height+d,0,i=e.getContentLength(),this._horizontalLine||(this._horizontalLine=new t.Line(e.getCtx(),0,n,i,r),this._horizontalLine.setPixelHinting(!0),this._horizontalLine.setMouseEnabled(!1),this._horizontalLine.setClassName(l,!0),a.addChild(this._horizontalLine),h="add"),o={x1:0,x2:i,y1:n,y2:r},this._gantt.getAnimationManager().preAnimateHorizontalGridline(this._horizontalLine,o,h),_){var c={x1:0,x2:g.getWidth(),y1:n,y2:r};this._rowAxisHorizontalLine||(this._rowAxisHorizontalLine=new t.Line(this._gantt.getCtx(),this._horizontalLine.getX1(),this._horizontalLine.getY1(),c.x2,this._horizontalLine.getY2()),this._rowAxisHorizontalLine.setPixelHinting(!0),this._rowAxisHorizontalLine.setClassName(l,!0)),g.addHorizontalLine(this._rowAxisHorizontalLine),this._gantt.getAnimationManager().preAnimateHorizontalGridline(this._rowAxisHorizontalLine,c,h)}}else this._horizontalLine&&a.removeChild(this._horizontalLine),this._horizontalLine=null,this._rowAxisHorizontalLine&&g.removeHorizontalLine(this._rowAxisHorizontalLine),this._rowAxisHorizontalLine=null}showEffect(e){const t=this._gantt.GetStyleClass(e);if(this._background){if(s.hasClass(this._background,t))return;this._background.addClassName(t)}const a=this.getRowLabelContent();if(a){const e=a.getBackground();e&&e.addClassName(t)}}removeEffect(e){const t=this._gantt.GetStyleClass(e);if(this._background){if(!s.hasClass(this._background,t))return;this._background.removeClassName(t)}const a=this.getRowLabelContent();if(a){const e=a.getBackground();e&&e.removeClassName(t)}}recordLabelState(e){this._rowLabelState=e}getLabelState(){return this._rowLabelState}remove(){var e,t=this;e=()=>{if(t._background){var e=t._background.getParent();e&&e.removeChild(t._background)}var a=t.getParent();a&&a.removeChild(t)},this._gantt.getAnimationManager().preAnimateRowNodeRemove(this,e),this._removeRowLabel()}_removeRowLabel(){var e,t,a=this.getRowLabelContent(),i=this._gantt.getRowAxis(),s=this;a&&i&&(e=a.getDisplayable())&&(null==e.getParent()&&(a.ensureInDOM(),this._gantt.isHorizontalGridlinesVisible()&&i.addHorizontalLine(this._rowAxisHorizontalLine)),t=()=>{a.remove(),i.removeHorizontalLine(s._rowAxisHorizontalLine)},this._gantt.getAnimationManager().preAnimateRowLabelRemove(a,this._rowAxisHorizontalLine,t))}getDataContext(){return{rowData:this.getData(!0),component:this._gantt.getOptions()._widgetConstructor}}scrollIntoView(){var e=this._gantt.getViewportDimensions(),t=Math.min(this._rowObj.y-e.y,0),a=Math.max(0,this._rowObj.y+this._rowObj.height-(e.y+e.h)),i=t<0?t:a;this._gantt.panBy(0,i)}}class m{constructor(e){this._gantt=e,this._ctx=e.getCtx(),this._rowObjs=[],this._dependencyObjs=[],this._contentHeight=0,this._prevHighlightedTaskObjs=new Set,this._prevDependencyObjs=new Set}clear(){this._rowObjs=[],this._dependencyObjs=[],this._contentHeight=0,this._prevViewport=null}getRowObjs(){return this._rowObjs}getDependencyObjs(){return this._dependencyObjs}getContentHeight(){return this._contentHeight}getNumViewportTasks(){return this._numViewportTasks}_getTime(e){if(null==e||""===e)return null;var t=new Date(e).getTime();return isNaN(t)?null:t}_isIntervalOverlap(e,t,a,i,s){return(s=!1!==s)?e<=i&&a<=t:e<i&&a<t}_isOverlap(e,t){return this._isIntervalOverlap(e.overallStartTime,e.overallEndTime,t.overallStartTime,t.overallEndTime,!1)}_calcTaskHeight(e){var t=this._gantt.getOptions(),a=this._gantt.getCtx(),i=t.taskDefaults,n=e.data,r=n.progress,o=n.baseline,h=!1,l=n.type?n.type:i.type,d=null!=n.height?n.height:i.height,g=0,_=s.getBaselineMarginTop(t);!o||null==e.baselineStartTime&&null==e.baselineEndTime||(g=null!=o.height?o.height:i.baseline.height,h="milestone"===l||"auto"===l&&e.baselineStartTime===e.baselineEndTime,null==o.height&&i.baseline.height===s.getBaselineTaskHeight(t)&&(g=h?s.getActualTaskHeight(t,a):i.baseline.height),null==n.height&&i.height===s.getStandaloneTaskHeight(t)&&(d=s.getActualTaskHeight(t,a))),e.height=d,e.baselineHeight=g,e.overtimeHeight=d,e.downtimeHeight=s.getTaskDowntimeHeight(t),e.attributeHeight=s.getTaskAttributeHeight(t);var c=g>0?_:0,u=h?s.getMilestoneBaselineYOffset(t)+Math.max(g,d):d+c+g;if(e.overallHeightNoProgress=u,e.overallHeight=u,e.progressHeight=0,!("milestone"===l||"auto"===l&&e.startTime===e.endTime&&null!=e.startTime)&&r&&"number"==typeof r.value){var p=null!=r.height?r.height:i.progress.height;p="100%"===p?d:s.getSizeInPixels(p,d),e.progressHeight=p,d<p&&(e.overallHeight=Math.max(p,(p-d)/2+u))}}_clearAdjacency(e){e.previousAdjacentTaskObj=null,e.nextAdjacentTaskObj=null,e.prevAdjMilestoneBaselineTaskObj=null,e.nextAdjMilestoneBaselineTaskObj=null}_trackRowLevelBaselineMilestones(e,t){for(var a=e.taskObjs,i=[],s=0;s<t;s++)i.push([]);for(var n=0;n<a.length;n++){var r=a[n],o=this._gantt.getOptions().taskDefaults,h=r.data,l=h.type?h.type:o.type;("milestone"===l||"auto"===l&&r.baselineStartTime===r.baselineEndTime)&&i[r._rowLevel].push(r)}for(s=0;s<t;s++)i[s].sort((e,t)=>t.baselineStartTime-e.baselineStartTime);for(n=0;n<a.length;n++){var d=i[(r=a[n])._rowLevel],g=d.length;if(g>0){var _=d[g-1],c=_.baselineStartTime,u=r.startTime,p=r.endTime;c<u?(r.prevAdjMilestoneBaselineTaskObj=_,d.pop()):c>p&&null==r.nextAdjMilestoneBaselineTaskObj?r.nextAdjMilestoneBaselineTaskObj=_:c!==u&&c!==p||d.pop()}}}_calcRowTaskYHeight(e,t){for(var a,i=e.taskObjs,n=this._gantt.getOptions(),r=n.rowDefaults.height,o=n.taskDefaults.overlap.behavior,h=n.taskDefaults.overlap.offset,l=[],d=[],g=0;g<i.length;g++){var _=i[g];this._calcTaskHeight(_),this._clearAdjacency(_);var c=_.data,u=c.overlap?c.overlap.behavior:null,p=null!=u?u:o;p="auto"===p?null==r?"stack":"stagger":p,_.overlapBehavior=p;var m=h;if("overlay"===p&&null==a&&(a=_),0!==g){var b=i[g-1],D=this._isOverlap(_,b);D?E.push(_):(E=[_],l.push(E));var v=m||0,S=0;switch(p){case"stack":for(var T=!0,y=0;y<d.length;y++){var C=null;if(!this._isOverlap(_,d[y])){C=d[y],d[y]=_,T=!1;break}S+=1}T&&d.push(_),_.y=null!=m?S*m:0,C&&(_.previousAdjacentTaskObj=C,C.nextAdjacentTaskObj=_);break;case"stagger":D?(_._rowLevel=b._rowLevel,d[b._rowLevel]=_,_._staggerDirection=null!=b._staggerDirection?-b._staggerDirection:-1,_.y=b.y-_._staggerDirection*v):(d[S]=_,_._staggerDirection=1,_.y=0),_.previousAdjacentTaskObj=b,b.nextAdjacentTaskObj=_;break;case"overlay":d[S]=_,_.y=0}_._rowLevel=S}else{d.push(_),_._rowLevel=0;var E=[_];l.push(E),"stagger"===p&&(_._staggerDirection=1),_.y=0}}e.earliestOverlayTaskObj=a;var f=s.getRowPaddingTop(n),O=s.getRowPaddingBottom(n),k="alta"===this._gantt.getCtx().getThemeBehavior()?"overallHeight":"height";if(null==r)if(null==m){var w=d.map(()=>0);i.forEach(e=>{e[k]>w[e._rowLevel]&&(w[e._rowLevel]=e[k])});var A=w.map(e=>e+f+O).reduce((e,t,a)=>(e.push((e[a-1]||0)+t),e),[]);i.forEach(e=>{e.y+=(A[e._rowLevel-1]||0)+f}),this._trackRowLevelBaselineMilestones(e,d.length)}else i.forEach(e=>{e.y+=f});var R=l.map(e=>{var t=0;return e.forEach(e=>{var a=e.y+e[k];a>t&&(t=a)}),t});if(null==r){if(0===i.length)return void(e.height=s.getStandaloneTaskHeight(n)+f+O);e.height=R.reduce((e,t)=>Math.max(e,t))+f,null==m?l.forEach((t,a)=>{t.forEach(t=>{var a=w[t._rowLevel];t.y+=(a-t.overallHeight)/2+e.y})}):l.forEach((t,a)=>{t.forEach(t=>{t.y+=e.y})})}else e.height=r-t,l.forEach((t,a)=>{var i=R[a],s=Number.MAX_VALUE;t.forEach(t=>{t.y+=Math.floor((e.height-t[k])/2),t.y<s&&(s=t.y)});var n=Math.floor((e.height-i)/2)-s;t.forEach(t=>{"overlay"===t.overlapBehavior?t.y+=e.y:t.y+=e.y+n})})}_calcTaskAggregation(e){var t=(e,t)=>e.endTime===t.startTime&&e.startTime!==e.endTime&&t.startTime!==t.endTime&&e.height==t.height&&e.data.borderRadius==t.data.borderRadius,a=e.taskObjs;if(0!==a.length)if(1!==a.length)if(2!==a.length){a[0].aggregation=t(a[0],a[1])?"stackStart":"stackSolo",a[a.length-1].aggregation=t(a[a.length-2],a[a.length-1])?"stackEnd":"stackSolo";for(var i=1;i<a.length-1;i++){var s=a[i-1],n=a[i],r=a[i+1];t(s,n)&&t(n,r)?n.aggregation="stackMiddle":t(s,n)?n.aggregation="stackEnd":t(n,r)?n.aggregation="stackStart":n.aggregation="stackSolo"}}else t(a[0],a[1])?(a[0].aggregation="stackStart",a[1].aggregation="stackEnd"):(a[0].aggregation="stackSolo",a[1].aggregation="stackSolo");else a[0].aggregation="stackSolo"}_generateRowObjs(e){var t=this._gantt.getOptions(),a=0;this._gantt.isHorizontalGridlinesVisible()&&(a=s.getHorizontalGridlineWidth(t));for(var i=[],n=0,r=0;r<e.length;r++){var o=e[r],h=o.tasks;if(null!=h){var l={id:null!=o.id?o.id:h.length>0?h[0].id:null,data:o,index:r,y:n,renderState:"add"};null!=o._depth&&(l.depth=o._depth,l.expanded=o._expanded,l.parent=null==o._parentFlatIndex?null:i[o._parentFlatIndex],o._depth=void 0,o._expanded=void 0,o._parentFlatIndex=void 0,o._flatIndex=void 0);for(var d=[],g=0;g<h.length;g++){var _=h[g],c={id:_.id,data:_,startTime:_.start&&""!==_.start?this._getTime(_.start):this._getTime(_.end),endTime:_.end&&""!==_.end?this._getTime(_.end):this._getTime(_.start),rowObj:l,predecessorDepObjs:[],successorDepObjs:[],renderState:"add"},u=c.startTime,p=c.endTime,m=_.baseline;if(m){var b=m.start&&""!==m.start?this._getTime(m.start):this._getTime(m.end),D=m.end&&""!==m.end?this._getTime(m.end):this._getTime(m.start);null==b&&null==D||(c.baselineStartTime=b,c.baselineEndTime=D,(b<u||null==u)&&(u=b),(D>p||null==p)&&(p=D))}var v=_.overtime;if(v){var S=v.start&&c.startTime?Math.max(this._getTime(v.start),c.startTime):null,T=v.end&&c.endTime?Math.min(this._getTime(v.end),c.endTime):null;c.overtimeStartTime=S,c.overtimeEndTime=T}var y=_.downtime;if(y){var C=y.start&&c.startTime?Math.max(this._getTime(y.start),c.startTime):null,E=y.end&&c.endTime?Math.min(this._getTime(y.end),c.endTime):null;c.downtimeStartTime=C,c.downtimeEndTime=E}null!=u&&null!=p&&(c.overallStartTime=u,c.overallEndTime=p,d.push(c))}d.sort((e,t)=>e.startTime-t.startTime),l.taskObjs=d,i.push(l),this._calcRowTaskYHeight(l,a),n+=l.height+a,"on"===t.taskAggregation&&this._calcTaskAggregation(l)}}return i}_generateDependencyObjs(e,a){(a=a||this._createIdObjMap(this._rowObjs,"taskObjs")).forEach((e,t)=>{e.successorDepObjs=[],e.predecessorDepObjs=[]});for(var i=[],s=0;s<e.length;s++){var r=e[s],o=r.predecessorTaskId,h=r.successorTaskId,l=null==r.type?n.FINISH_START:r.type,d=null!=o&&a.has(o),g=null!=h&&a.has(h);if(n._isValidType(l)&&d&&g&&!t.Obj.compareValues(this._ctx,o,h)){var _,c,u=a.get(o),p=a.get(h),m=u.rowObj,b=p.rowObj;m.index<=b.index?(_=m,c=b):(_=b,c=m);var D=r.shortDesc;if(null==D){var v=this._gantt.getOptions().translations,S=v[l+"DependencyAriaDesc"];D=t.ResourceUtils.format(v.accessibleDependencyInfo,[S,o,h])}var T={id:r.id,data:r,index:s,type:l,predecessorTaskObj:u,successorTaskObj:p,rowObjTop:_,rowObjBottom:c,ariaLabel:D};u.successorDepObjs.push(T),p.predecessorDepObjs.push(T),i.push(T)}}i.sort((e,t)=>e.rowObjTop.index-t.rowObjTop.index);for(var y=0;y<i.length-1;y++)i[y].nextTopDependencyObj=i[y+1],i[y+1].prevTopDependencyObj=i[y];return i.sort((e,t)=>e.rowObjBottom.index-t.rowObjBottom.index),i}_createIdObjMap(e,t){for(var a=new this._ctx.ojMap,i=0;i<e.length;i++){var s=e[i];if(t)for(var n=s[t],r=0;r<n.length;r++){var o=n[r];a.set(o.id,o)}else a.set(s.id,s)}return a}_setDifferenceRenderState(e,t,a,i){for(var s=0;s<e.length;s++){var n=e[s];if(i)for(var r=n[i],o=0;o<r.length;o++){var h=r[o];if(!t.has(h.id)&&(h.renderState=a,"delete"===a)){var l=h.node;if(l&&l.getParent())"delete"!==n.renderState&&l.remove()}}else if(!t.has(n.id)&&(n.renderState=a,"delete"===a)){var d=n.node;d&&d.getParent()&&d.remove()}}}_setIntersectionRenderState(e,a,i){for(var s=0;s<a.length;s++){var n=a[s];if(i)for(var r=n[i],o=0;o<r.length;o++){var h=r[o],l=e.get(h.id);if(l){if(t.Obj.compareValues(this._ctx,l.rowObj.id,n.id))h.renderState="exist";else{h.renderState="migrate";var d=l.node;d&&d.getParent()&&"none"===this._gantt.getAnimationManager().getAnimationMode()&&d.getRowNode().removeChild(d)}h._oldObj=l}}else{var g=e.get(n.id);g&&(n.renderState="exist",n._oldObj=g)}}}_addAnimationFinalStateRowObjs(e,t){this._animationFinalStateRowObjs=this._animationFinalStateRowObjs||new Map,this._animationFinalStateRowObjs.has(e)||this._animationFinalStateRowObjs.set(e,new Set),t&&this._animationFinalStateRowObjs.get(e).add(t)}_prepareAnimationDOM(e,a,i,s,n){var r=this._gantt.getAnimationManager(),o=r.getAnimationMode();r.setAnimationMode("none"),this._animationInitialStateRowObjsDelete=[];var h=this._contentHeight,l=e[e.length-1];this._contentHeight=l.y+l.height;var d=this._gantt.scrollPositionToTranslateY(this._gantt.getOptions().scrollPosition),g=this._gantt.getViewportYBounds(d),_=g.yMin,c=g.yMax;this._contentHeight=h;for(var u=this.findRowIndRange(this._rowObjs,_,c),p=u.minRowInd,m=u.maxRowInd,b=p;b<=m;b++){var D=this._rowObjs[b];if(D){this.ensureInDOM(D,"row"),"delete"===D.renderState&&D.node.getRowLabelContent()&&this._animationInitialStateRowObjsDelete.push(D);var v=i.get(D.id);v&&this._addAnimationFinalStateRowObjs(v);for(var S=D.taskObjs,T=0;T<S.length;T++){var y=S[T],C=n.get(y.id);if(C){var E=C.rowObj;if(!t.Obj.compareValues(this._ctx,E.id,D.id)){var f=a.get(E.id);f&&this.ensureInDOM(f,"row"),this._addAnimationFinalStateRowObjs(E,C)}}}}}var O=this.findRowIndRange(e,_,c),k=O.minRowInd,w=O.maxRowInd;for(b=k;b<=w;b++){var A=e[b];if(A){this._addAnimationFinalStateRowObjs(A);var R=a.get(A.id);R&&this.ensureInDOM(R,"row");var x=A.taskObjs;for(T=0;T<x.length;T++){var L=x[T],P=s.get(L.id);if(P){var M=P.rowObj;if(!t.Obj.compareValues(this._ctx,M.id,A.id)){this.ensureInDOM(P,"task");var j=i.get(M.id);j&&this._addAnimationFinalStateRowObjs(j,L)}}}}}r.setAnimationMode(o)}_associateOldNodesAndNewLayoutObjs(e){for(var t=0;t<e.length;t++){var a=e[t],i=a._oldObj;if(i){var s=i.node;s&&(a.node=s,s.setLayoutObject(a)),a._oldObj=null}for(var n=a.taskObjs,r=0;r<n.length;r++){var o=n[r],h=o._oldObj;if(h){var l=h.node;l&&(o.node=l,l.setLayoutObject(o),l.isSelected()&&l.clearSelectionState()),o._oldObj=null}}}}calcLayout(){var e=this._gantt.getOptions(),t=this._gantt.getRenderState();if(null==t)var a=this._calcRowsLayout(e);else this._expandCollapseRowObject(e,t.state,t.payload);if(this._rowObjs.length>0){var i=this._rowObjs[this._rowObjs.length-1];this._contentHeight=i.y+i.height;var s=e.dependencies;null!=s&&s.length>0&&(this._dependencyObjs=this._generateDependencyObjs(s,a))}}_calcRowsLayout(e){var t=e.rows;if(null!=t&&0!==t.length){var a=t;this._gantt.isRowsHierarchical()&&(a=this._flattenRows(t,e.expanded));var i=this._generateRowObjs(a);if(this._rowObjs&&!this._gantt.isInitialRender()&&this._gantt.isLastRenderValid()){var s=this._createIdObjMap(this._rowObjs),n=this._createIdObjMap(i),r=this._createIdObjMap(this._rowObjs,"taskObjs"),o=this._createIdObjMap(i,"taskObjs");this._setDifferenceRenderState(this._rowObjs,n,"delete"),this._setDifferenceRenderState(i,s,"add"),this._setIntersectionRenderState(s,i),this._setDifferenceRenderState(this._rowObjs,o,"delete","taskObjs"),this._setDifferenceRenderState(i,r,"add","taskObjs"),this._setIntersectionRenderState(r,i,"taskObjs"),"none"!==this._gantt.getAnimationManager().getAnimationMode()&&this._prepareAnimationDOM(i,s,n,r,o),this._associateOldNodesAndNewLayoutObjs(i)}return this._rowObjs=i,o}this._rowObjs=[]}isRowExpandable(e){if(null==e.expanded)return!1;var t=this._gantt.getOptions().expanded,a=e.id;return!t.has(a)}isRowCollapsible(e){if(null==e.expanded)return!1;var t=this._gantt.getOptions().expanded,a=e.id;return t.has(a)}_expandCollapseRowObject(e,t,a){var i=this,n=a.index,r=a.data,o=r.rows,h=e.expanded,l=this._gantt.getAnimationManager(),d=l.getAnimationMode(),g="none"!==d;if(g)var _=this._gantt.getViewportYBounds(A),c=_.yMin,u=_.yMax-c,p=(e,t,a)=>{l.setAnimationMode("none");for(var s=0,n=t;n<e.length;n++){var r=e[n];if(i.ensureInDOM(r,"row"),i._addAnimationFinalStateRowObjs(r),(s+=r.height)>a)break}l.setAnimationMode(d)};var m=(e,t,a,i)=>{for(var s=a;s<i;s++){var n=e[s];if(n.renderState=t,"delete"===t){var r=n.node;r&&r.getParent()&&r.remove()}for(var o=n.taskObjs,h=0;h<o.length;h++){o[h].renderState=t}}};if(a.expanded="expand"===t,r._expanded=a.expanded,m(this._rowObjs,"exist",0,this._rowObjs.length),"expand"===t){var b=this._flattenRows(o,h,0,a.depth+1),D=this._generateRowObjs(b);D.forEach(e=>e.parent=e.parent||a),m(D,"add",0,D.length),g&&p(this._rowObjs,n,u),this._rowObjs=this._rowObjs.slice(0,n+1).concat(D,this._rowObjs.slice(n+1,this._rowObjs.length))}else{var v=this._calcFlattenedRowsLength(o,h);m(this._rowObjs,"delete",n+1,n+1+v),g&&p(this._rowObjs,n+1+v,u);var S=this._rowObjs.splice(n+1,v);g&&(this._animationInitialStateRowObjsDelete=S)}var T=0;this._gantt.isHorizontalGridlinesVisible()&&(T=s.getHorizontalGridlineWidth(e));for(var y=a.y+a.height+T,C=n+1;C<this._rowObjs.length;C++){var E=this._rowObjs[C];E.index=C;for(var f=E.taskObjs,O=0;O<f.length;O++){var k=f[O];k.y=k.y-E.y+y}E.y=y,y+=E.height+T}if(g){var w=this._rowObjs[this._rowObjs.length-1];this._contentHeight=w.y+w.height;for(var A=this._gantt.scrollPositionToTranslateY(this._gantt.getOptions().scrollPosition),R=this._gantt.getViewportYBounds(A),x=R.yMin,L=R.yMax,P=this.findRowIndRange(this._rowObjs,x,L),M=P.minRowInd,j=P.maxRowInd,I=M;I<=j;I++)this._addAnimationFinalStateRowObjs(this._rowObjs[I])}}_flattenRows(e,t,a,i){a=a||0,i=i||0;var s=this._gantt.getOptions(),n=s.rowData||s.taskData,r=(e,t,i,s)=>e.reduce((e,o)=>{o._depth=s,o._parentFlatIndex=i?i._flatIndex:null,o._flatIndex=a,a+=1;var h=o.rows;if(h){if(t.has(o.id))return o._expanded=!0,e.concat(o,r(h,t,o,s+1));o._expanded=!1}else if(n){var l=n.getChildDataProvider(o.id),d=!l||"yes"===l.isEmpty();o._expanded=!!d&&null}else o._expanded=null;return e.concat(o)},[]);return r(e,t,null,i)}_calcFlattenedRowsLength(e,t){var a=e=>e.reduce((e,i)=>{var s=i.rows;return s&&t.has(i.id)?e+1+a(s):e+1},0);return a(e)}isRoot(e){return null==e.parent}isHiddenCollapsed(e){for(var a=0;a<this._rowObjs.length;a++)if(t.Obj.compareValues(this._ctx,this._rowObjs[a].id,e.id))return!1;return!0}getParentRowObj(e){return e.parent}_renderRowObj(e,t,a){var i=this._gantt.getDatabody(),s=e.node;if("update"===a)s.render(null,t);else{if(s||((s=new p(this._gantt)).setLayoutObject(e),e.node=s),this._gantt.isRowAxisEnabled()){var n=this._gantt.getRowAxis();if(n){var o=n.getRowLabelContents(),h=e.index,l=o[h];l||((l=new r(n,n.getLabelContentType())).setRowIndex(h),o[h]=l),l.render(e),s.setRowLabelContent(l)}}s.render(i,t)}}_renderTaskObj(e,t){var a=e.rowObj,i=a.node,s=e.node;t&&s&&i&&s.getParent()===i||this._renderRowObj(a,{rowObj:a,tasksAdd:new Set([e]),tasksUpdate:new Set,tasksDelete:new Set,updateRender:!t},i&&i.getParent()?"update":"add")}_renderDependencyObj(e,t){var a=this._gantt.getDependenciesContainer(),i=e.node;if(i&&i.getParent())return!1;var s=this._gantt.getAnimationManager(),r=s.getAnimationMode();s.setAnimationMode("none");var o=e.predecessorTaskObj,h=e.successorTaskObj;if(this._animationFinalStateRowObjs){var l=o.rowObj,d=h.rowObj;this._animationFinalStateRowObjs.has(l)&&this._animationFinalStateRowObjs.get(l).has(o)||this.ensureInDOM(o,"task",t),this._animationFinalStateRowObjs.has(d)&&this._animationFinalStateRowObjs.get(d).has(h)||this.ensureInDOM(h,"task",t)}else this.ensureInDOM(o,"task",t),this.ensureInDOM(h,"task",t);return s.setAnimationMode(r),i||((i=new n(this._gantt)).setLayoutObject(e),e.node=i),i.render(a),!0}ensureInDOM(e,t,a){switch(t){case"row":return void this._renderRowObj(e);case"task":return void this._renderTaskObj(e,a);case"dependency":return void this._renderDependencyObj(e,!0);case"rowLabel":return void this._renderRowObj(e,{rowObj:e,tasksAdd:new Set,tasksUpdate:new Set,tasksDelete:new Set,updateRender:!1},"add")}}_binarySearchLeftMost(e,t,a,i,s){if(0===e.length)return 0;for(var n=0,r=e.length;n<r;){var o=Math.floor((n+r)/2),h=i?s?e[o][i][s]:e[o][i]:e[o];h<t?n=o+1:r=o}return n<e.length&&((h=i?s?e[n][i][s]:e[n][i]:e[n])===t||"successor"===a)?n:n>0?n-1:0}findRowIndRange(e,t,a){for(var i=this._binarySearchLeftMost(e,t,"predecessor","y"),s=i,n=i;n<e.length;n++){if(!(e[n].y<=a))break;s=n}return{minRowInd:i,maxRowInd:s}}findTaskObjsRange(e,t,a,i,s){for(var n=[],r=e.taskObjs,o=0;o<r.length;o++){var h=r[o];this._isIntervalOverlap(h.overallStartTime,h.overallEndTime,t,i)&&(a&&s?n.push(h):a||s?s?h.overallStartTime>t&&n.push(h):h.overallEndTime<i&&n.push(h):h.overallStartTime>t&&h.overallEndTime<i&&n.push(h))}return n}findBufferTaskObjsRange(e,t,a){for(var i=[],s=e.taskObjs,n=0;n<s.length;n++){var r=s[n],o=r.previousAdjacentTaskObj,h=r.nextAdjacentTaskObj,l=!o&&!h&&!this._isIntervalOverlap(r.overallStartTime,r.overallEndTime,t,a),d=r.overallEndTime<t&&(!h||h&&h.overallEndTime>=t),g=r.overallStartTime>a&&(!o||o&&o.overallStartTime<=a);(l||d||g)&&i.push(r)}return i}getLayoutObjectsInBBox(e){for(var a=this.findRowIndRange(this._rowObjs,e.y,e.y+e.h),s=a.minRowInd,n=a.maxRowInd,r=t.Agent.isRightToLeft(this._gantt.getCtx()),o=this._gantt.getStartTime(),h=this._gantt.getEndTime(),l=this._gantt.getContentLength(),d=i.TimeAxisUtils.getPositionDate(o,h,r?l-(e.x+e.w):e.x,l),g=i.TimeAxisUtils.getPositionDate(o,h,r?l-e.x:e.x+e.w,l),_=[],c=[],u=s;u<=n;u++){var p=this._rowObjs[u];_.push(p);for(var m=p.taskObjs,b=0;b<m.length;b++){var D=m[b];this._isIntervalOverlap(D.overallStartTime,D.overallEndTime,d,g)&&this._isIntervalOverlap(D.y,D.y+D.height,e.y,e.y+e.h)&&c.push(m[b])}}return{rowObjs:_,taskObjs:c}}_getSelectionDependencies(e,t){var a,i=this._createIdObjMap(this._rowObjs,"taskObjs");e===m.VPC_REFRESH?a=this._gantt.getOptions().selection.map(e=>i.get(e)).filter(e=>void 0!==e):a=this._gantt.getSelectionHandler().getSelection().map(e=>e.getLayoutObject());t&&(t.isSelected?a.push(t.taskObj):a=a.filter(e=>e!==t.taskObj));var s=(e,t,a,n)=>{var r;null!=e&&!a.has(e)&&i.has(e.id)&&(a.add(e),"up"===t?(r=e.predecessorDepObjs.map(e=>e.predecessorTaskObj),e.predecessorDepObjs.forEach(e=>n.add(e))):(r=e.successorDepObjs.map(e=>e.successorTaskObj),e.successorDepObjs.forEach(e=>n.add(e))),r.forEach(e=>s(e,t,a,n)))},n=new Set,r=new Set;a.forEach(e=>s(e,"up",n,r));var o=new Set;return a.forEach(e=>s(e,"down",o,r)),o.forEach(e=>n.add(e)),{taskObjs:n,dependencyObjs:r}}highlightTasks(e){this._gantt.getEventManager().isDnDDragging()||this._gantt.getDatabody()&&(0===e.size?this._gantt.undimDatabody():this._gantt.dimDatabody(),this._prevHighlightedTaskObjs.forEach(t=>{t.node&&!e.has(t)&&t.node.unhighlight()}),e.forEach(e=>{e.node&&!this._prevHighlightedTaskObjs.has(e)&&e.node.highlight()}),this._prevHighlightedTaskObjs=e)}renderViewportDependencyLines(e,t,a){var i,s=this._gantt.getOptions().selectionBehavior;if("highlightDependencies"===s){var r=this._getSelectionDependencies(t,a);this.highlightTasks(r.taskObjs),i=r.dependencyObjs}else i=new Set(this._dependencyObjs),this.highlightTasks(new Set);var o=this._gantt.getDependenciesContainer();o&&(this._gantt.getEventManager().isMarqueeDragging()&&"highlightDependencies"===s?this._prevDependencyObjs.forEach(e=>{!i.has(e)&&e.node&&o.removeChild(e.node)}):o.removeChildren());if(this._prevDependencyObjs=i,i.size>0){for(var h=(e,t)=>{var a,i,s=e.predecessorTaskObj,r=e.successorTaskObj;switch(e.type){case n.START_FINISH:a=s.startTime,i=r.endTime;break;case n.START_START:a=s.startTime,i=r.startTime;break;case n.FINISH_FINISH:a=s.endTime,i=r.endTime;break;case n.FINISH_START:default:a=s.endTime,i=r.startTime}return this._isIntervalOverlap(Math.min(a,i),Math.max(a,i),t.viewStartTime,t.viewEndTime)},l=this._binarySearchLeftMost(this._dependencyObjs,e.minRowInd,"successor","rowObjBottom","index"),d=this._dependencyObjs[l],g=d.prevTopDependencyObj,_=t===m.VPC_TRANSLATE||t===m.VPC_REFRESH;d&&d.rowObjTop.index<=e.maxRowInd;)i.has(d)&&h(d,e)&&this._renderDependencyObj(d,_),d=d.nextTopDependencyObj;for(;g;){g.rowObjBottom.index>=e.minRowInd&&i.has(g)&&h(g,e)&&this._renderDependencyObj(g,_),g=g.prevTopDependencyObj}}}_detachRowObjNode(e){var t=e.node;t&&(e.taskObjs.forEach(e=>{var t=e.node;t&&t.remove()}),t.remove())}_prepareViewport(e,t){var a=this._gantt.getDatabody();t===m.VPC_REFRESH&&(this._rowObjs.forEach(this._detachRowObjNode,this),a.removeChildren(),this._gantt.getDatabodyBackground().removeChildren(),this._gantt.getRowReferenceObjectsContainer().removeChildren());var i=this._gantt.getRowAxis();this._gantt.isRowAxisEnabled()&&i&&t!==m.VPC_TRANSLATE&&t!==m.VPC_SCALE&&i.clear()}_computeViewportRenderOperations(e,t){var a=[],s=[],n=[];if(t===m.VPC_REFRESH)for(var r=e.minRowInd;r<=e.maxRowInd;r++){var o=this._rowObjs[r],h=this.findTaskObjsRange(o,e.viewStartTime,!0,e.viewEndTime,!0);this.findBufferTaskObjsRange(o,e.viewStartTime,e.viewEndTime).forEach(e=>{h.push(e)}),s.push({rowObj:o,tasksAdd:new Set(h),tasksUpdate:new Set,tasksDelete:new Set,updateRender:!0})}else if(t===m.VPC_ANIMATE){this._animationFinalStateRowObjs.forEach((t,a)=>{var i=new Set,n=this.findTaskObjsRange(a,e.viewStartTime,!0,e.viewEndTime,!0),r=this.findBufferTaskObjsRange(a,e.viewStartTime,e.viewEndTime);n.forEach(e=>{t.has(e)||i.add(e)}),r.forEach(e=>{t.has(e)||i.add(e)}),t.forEach(e=>{i.add(e)}),this._animationFinalStateRowObjs.set(a,i),s.push({rowObj:a,tasksAdd:i,tasksUpdate:new Set,tasksDelete:new Set,updateRender:!0})},this);var l=this._gantt.getRowAxis();for(r=0;r<this._animationInitialStateRowObjsDelete.length;r++){var d=this._animationInitialStateRowObjsDelete[r].node;if(d&&l)d.getRowLabelContent().ensureInDOM(),this._gantt.isHorizontalGridlinesVisible()&&l.addHorizontalLine(d.getRowAxisHorizontalLine())}}else{var g=this._gantt.getEventManager(),_=i.TimeAxisUtils.supportsTouch()&&g&&g.isDnDDragging();for(r=this._prevViewport.minRowInd;r<Math.min(e.minRowInd,this._prevViewport.maxRowInd);r++)a.push(this._rowObjs[r]);for(r=Math.max(e.maxRowInd+1,this._prevViewport.minRowInd);r<=this._prevViewport.maxRowInd;r++)a.push(this._rowObjs[r]);for(r=e.minRowInd;r<Math.min(this._prevViewport.minRowInd,e.maxRowInd);r++){o=this._rowObjs[r],h=this.findTaskObjsRange(o,e.viewStartTime,!0,e.viewEndTime,!0);this.findBufferTaskObjsRange(o,e.viewStartTime,e.viewEndTime).forEach(e=>{h.push(e)}),s.push({rowObj:o,tasksAdd:new Set(h),tasksUpdate:new Set,tasksDelete:new Set,updateRender:!0})}for(r=Math.max(this._prevViewport.maxRowInd+1,e.minRowInd);r<=e.maxRowInd;r++){o=this._rowObjs[r],h=this.findTaskObjsRange(o,e.viewStartTime,!0,e.viewEndTime,!0);this.findBufferTaskObjsRange(o,e.viewStartTime,e.viewEndTime).forEach(e=>{h.push(e)}),s.push({rowObj:o,tasksAdd:new Set(h),tasksUpdate:new Set,tasksDelete:new Set,updateRender:!0})}var c=t===m.VPC_SCALE;if(this._prevViewport.maxRowInd>=e.minRowInd&&this._prevViewport.minRowInd<=e.maxRowInd){var u=this._prevViewport.viewStartTime,p=this._prevViewport.viewEndTime,b=e.viewStartTime,D=e.viewEndTime;for(r=Math.max(e.minRowInd,this._prevViewport.minRowInd);r<=Math.min(e.maxRowInd,this._prevViewport.maxRowInd);r++){o=this._rowObjs[r];var v=new Set,S=new Set,T=new Set;u<b&&this.findTaskObjsRange(o,u,!0,Math.min(b,p),p<b).forEach(e=>{v.add(e)}),p>D&&this.findTaskObjsRange(o,Math.max(D,u),u>D,p,!0).forEach(e=>{v.add(e)}),b<u&&this.findTaskObjsRange(o,b,!0,Math.min(D,u),D<u).forEach(e=>{S.add(e)}),D>p&&this.findTaskObjsRange(o,Math.max(p,b),b>p,D,!0).forEach(e=>{S.add(e)}),p>=b&&u<=D&&(T=new Set(this.findTaskObjsRange(o,Math.max(b,u),!0,Math.min(D,p),!0))),this.findBufferTaskObjsRange(o,this._prevViewport.viewStartTime,this._prevViewport.viewEndTime).forEach(e=>{v.add(e)}),this.findBufferTaskObjsRange(o,e.viewStartTime,e.viewEndTime).forEach(e=>{S.add(e)});var y=[];v.forEach(e=>{S.has(e)&&y.push(e)}),y.forEach(e=>{T.add(e),v.delete(e),S.delete(e)}),_&&(v=new Set),n.push({rowObj:o,tasksAdd:S,tasksUpdate:T,tasksDelete:v,updateRender:c})}}}return _&&(a=[]),{rowsDelete:a,rowsAdd:s,rowsUpdate:n}}_executeViewportRenderOperations(e){e.rowsDelete.forEach(this._detachRowObjNode,this),e.rowsAdd.forEach(e=>{this._renderRowObj(e.rowObj,e,"add")},this),e.rowsUpdate.forEach(e=>{this._renderRowObj(e.rowObj,e,"update")},this)}renderViewport(e,a){this._prepareViewport(e,a);var i=this._computeViewportRenderOperations(e,a),s=(e,t)=>e+t.tasksAdd.size+t.tasksUpdate.size;this._numViewportTasks=i.rowsAdd.reduce(s,0)+i.rowsUpdate.reduce(s,0);var n=this._gantt.getDatabody().getElem(),r=t.ToolkitUtils.getAttrNullNS(n,"shape-rendering");this._gantt.getViewportDensity()>1?"optimizeSpeed"!==r&&(t.ToolkitUtils.setAttrNullNS(n,"shape-rendering","optimizeSpeed"),t.ToolkitUtils.setAttrNullNS(n,"text-rendering","optimizeSpeed")):"optimizeSpeed"===r&&(t.ToolkitUtils.removeAttrNullNS(n,"shape-rendering"),t.ToolkitUtils.removeAttrNullNS(n,"text-rendering")),this._executeViewportRenderOperations(i),this.renderViewportDependencyLines(e,a),this._prevViewport=e,this._animationFinalStateRowObjs=null,this._animationInitialStateRowObjsDelete=[]}}m.VPC_TRANSLATE="vpc_translate",m.VPC_SCALE="vpc_scale",m.VPC_ANIMATE="vpc_animate",m.VPC_REFRESH="vpc_refresh";class b{constructor(e){this._gantt=e}prepareForAnimations(){var e=this._gantt.getCtx();this._gantt.StopAnimation(),this._animationMode="none",this._animationDuration=s.getAnimationDuration(this._gantt.getOptions()),this._gantt.isInitialRender()?this._gantt.isIRAnimationEnabled&&(this._animationMode="onDisplay"):this._gantt.isDCAnimationEnabled&&(this._animationMode="dataChange"),"onDisplay"===this._animationMode?(this.fadeInElemsIR=[],this.fadeInPlayableIR=new t.AnimFadeIn(e,this.fadeInElemsIR,this._animationDuration,0),this.dimensionsPlayableIR=this._createCustomPlayable(t.Easing.linear),this.translationsPlayableIR=this._createCustomPlayable(t.Easing.cubicInOut)):"dataChange"===this._animationMode&&(this.fadeInElemsDC=[],this.fadeInPlayableDC=new t.AnimFadeIn(e,this.fadeInElemsDC,this._animationDuration,0),this.fadeOutElemsDC=[],this.fadeOutPlayableDC=new t.AnimFadeOut(e,this.fadeOutElemsDC,this._animationDuration,0),this.dimensionsPlayableDC=this._createCustomPlayable(t.Easing.linear),this.translationsPlayableDC=this._createCustomPlayable(t.Easing.cubicInOut)),this._onEnds=[]}getAnimationMode(){return this._animationMode}setAnimationMode(e){this._animationMode=e}_createCustomPlayable(e){var a;return(a=new t.CustomAnimation(this._gantt.getCtx(),this._gantt,this._animationDuration)).setEasing(e),a}triggerAnimations(){var e,a;if(this._gantt.StopAnimation(),a=this._gantt.getCtx(),"onDisplay"===this._animationMode?(e=[this.fadeInPlayableIR,this.translationsPlayableIR,this.dimensionsPlayableIR],this._gantt.Animation=new t.ParallelPlayable(a,e,this._animationDuration,0)):"dataChange"===this._animationMode&&(e=[this.fadeInPlayableDC,this.translationsPlayableDC,this.dimensionsPlayableDC,this.fadeOutPlayableDC],this._gantt.Animation=new t.ParallelPlayable(a,e,this._animationDuration,0)),this._gantt.Animation){this._hideDepLines(),t.Playable.appendOnEnd(this._gantt.Animation,this._showDepLines,this),this._gantt.isDndEnabled()||(this._gantt.EventManager.removeListeners(this._gantt),this._bListenersRemoved=!0);for(var i=0;i<this._onEnds.length;i++)t.Playable.appendOnEnd(this._gantt.Animation,this._onEnds[i],this);t.Playable.appendOnEnd(this._gantt.Animation,this._onAnimationEnd,this),this._gantt.Animation.play()}}_hideDepLines(){var e=this._gantt.getDependenciesContainer();null!=e&&t.ToolkitUtils.setAttrNullNS(e.getElem(),"display","none")}_showDepLines(){var e=this._gantt.getDependenciesContainer();null!=e&&t.ToolkitUtils.removeAttrNullNS(e.getElem(),"display")}_onAnimationEnd(){this._gantt.AnimationStopped||this._gantt.RenderComplete(),this._bListenersRemoved&&this._gantt.EventManager.addListeners(this._gantt),this._gantt.Animation=null,this._gantt.AnimationStopped=!1,this._animationMode="none",this._gantt.renderViewport(m.VPC_REFRESH,!1)}preAnimateGanttIR(e){"onDisplay"===this._animationMode&&this.fadeInElemsIR.push(e._canvas)}preAnimateTaskNode(e,a){var i,s=e.getRenderState();"dataChange"===this._animationMode?"add"===s?(e.setTranslate(a.x,a.y),this.fadeInElemsDC.push(e)):"exist"!==s&&"migrate"!==s||((i=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getTranslateX,e.setTranslateX,a.x),i.addProp(t.Animator.TYPE_NUMBER,e,e.getTranslateY,e.setTranslateY,a.y)):e.setTranslate(a.x,a.y)}preAnimateTaskNodeRemove(e,t){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(e),this._onEnds.push(t)):t()}preAnimateTaskBaseline(e,a,i,s){var n,r,o=e.getRenderState("baseline");"onDisplay"===this._animationMode?(a.setDimensions(i.x,i.y,0,i.h,i.r),s(),(n=this.dimensionsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"dataChange"===this._animationMode?"add"===o?(a.setDimensions(i.x,i.y,0,i.h,i.r),s(),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"exist"===o&&((r=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getX,a.setX,i.x),r.addProp(t.Animator.TYPE_NUMBER,a,a.getY,a.setY,i.y),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w),n.addProp(t.Animator.TYPE_NUMBER,a,a.getHeight,a.setHeight,i.h),a.setBorderRadius(i.r),this._onEnds.push(s)):(a.setDimensions(i.x,i.y,i.w,i.h,i.r),s())}preAnimateTaskBaselineRemove(e,t){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(e),this._onEnds.push(t)):t()}preAnimateTaskMain(e,a,i){var s,n,r=e.getRenderState("main");"onDisplay"===this._animationMode?(e.setMainDimensions(a.x,a.y,0,a.h,a.r),i(),(s=this.dimensionsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getMainWidth,e.setMainWidth,a.w)):"dataChange"===this._animationMode?"add"===r?(e.setMainDimensions(a.x,a.y,0,a.h,a.r),i(),(s=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getMainWidth,e.setMainWidth,a.w)):"exist"===r&&((n=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getMainX,e.setMainX,a.x),n.addProp(t.Animator.TYPE_NUMBER,e,e.getMainY,e.setMainY,a.y),(s=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getMainWidth,e.setMainWidth,a.w),s.addProp(t.Animator.TYPE_NUMBER,e,e.getMainHeight,e.setMainHeight,a.h),e.setMainBorderRadius(a.r),this._onEnds.push(i)):(e.setMainDimensions(a.x,a.y,a.w,a.h,a.r),i())}preAnimateTaskMainRemove(e,t,a,i,s,n,r){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(e),t&&this.fadeOutElemsDC.push(t),a&&this.fadeOutElemsDC.push(a),i&&this.fadeOutElemsDC.push(i),s&&this.fadeOutElemsDC.push(s),n&&this.fadeOutElemsDC.push(n),this._onEnds.push(r)):r()}preAnimateTaskProgress(e,a,i,s){var n,r,o=e.getRenderState("progress");"onDisplay"===this._animationMode?(a.setDimensions(i.x,i.y,0,i.h,i.r),s(),(n=this.dimensionsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"dataChange"===this._animationMode?"add"===o?(a.setDimensions(i.x,i.y,0,i.h,i.r),s(),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"exist"===o&&((r=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getX,a.setX,i.x),r.addProp(t.Animator.TYPE_NUMBER,a,a.getY,a.setY,i.y),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w),n.addProp(t.Animator.TYPE_NUMBER,a,a.getHeight,a.setHeight,i.h),a.setBorderRadius(i.r),this._onEnds.push(s)):(a.setDimensions(i.x,i.y,i.w,i.h,i.r),s())}preAnimateTaskProgressRemove(e,t){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(e),this._onEnds.push(t)):t()}preAnimateTaskOvertime(e,a,i,s){var n,r,o=e.getRenderState("overtime");"onDisplay"===this._animationMode?(a.setDimensions(i.x,i.y,0,i.h,i.r),s(),(n=this.dimensionsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"dataChange"===this._animationMode?"add"===o?(a.setDimensions(i.x,i.y,0,i.h,i.r),s(),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"exist"===o&&((r=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getX,a.setX,i.x),r.addProp(t.Animator.TYPE_NUMBER,a,a.getY,a.setY,i.y),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w),n.addProp(t.Animator.TYPE_NUMBER,a,a.getHeight,a.setHeight,i.h),a.setBorderRadius(i.r),this._onEnds.push(s)):(a.setDimensions(i.x,i.y,i.w,i.h,i.r),s())}preAnimateTaskOvertimeRemove(e,t){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(progressShape),this._onEnds.push(t)):t()}preAnimateTaskDowntime(e,a,i,s){var n,r,o=e.getRenderState("downtime");"onDisplay"===this._animationMode?(a.setDimensions(i.x,i.y,0,i.h,i.r),s(),(n=this.dimensionsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"dataChange"===this._animationMode?"add"===o?(a.setDimensions(i.x,i.y,0,i.h,i.r),s(),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w)):"exist"===o&&((r=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getX,a.setX,i.x),r.addProp(t.Animator.TYPE_NUMBER,a,a.getY,a.setY,i.y),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w),n.addProp(t.Animator.TYPE_NUMBER,a,a.getHeight,a.setHeight,i.h),a.setBorderRadius(i.r),this._onEnds.push(s)):(a.setDimensions(i.x,i.y,i.w,i.h,i.r),s())}preAnimateTaskDowntimeRemove(e,t){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(e),this._onEnds.push(t)):t()}preAnimateTaskAttribute(e,a,i,s){var n,r,o=e.getRenderState("attribute");"onDisplay"===this._animationMode?(a.setDimensions(i.x,i.y,i.w,0,i.r),s(),(n=this.dimensionsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getHeight,a.setHeight,i.h)):"dataChange"===this._animationMode?"add"===o?(a.setDimensions(i.x,i.y,i.w,0,i.r),s(),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getHeight,a.setHeight,i.h)):"exist"===o&&((r=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getX,a.setX,i.x),r.addProp(t.Animator.TYPE_NUMBER,a,a.getY,a.setY,i.y),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getWidth,a.setWidth,i.w),n.addProp(t.Animator.TYPE_NUMBER,a,a.getHeight,a.setHeight,i.h),a.setBorderRadius(i.r),this._onEnds.push(s)):(a.setDimensions(i.x,i.y,i.w,i.h,i.r),s())}preAnimateTaskAttributeRemove(e,t){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(e),this._onEnds.push(t)):t()}preAnimateTaskLabel(e,a,i){var s,n=e.getTask(),r=e.getTaskLabel(),o=r.getLabelOutputText(),h=r.getRenderState(),l=n.getRenderState("main");"onDisplay"===this._animationMode?(i(),o.setY(a.y),o.setX(n.getShape("main").getX()),(s=this.translationsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,o,o.getX,o.setX,a.x),s.addProp(t.Animator.TYPE_NUMBER,o,o.getY,o.setY,a.y)):"dataChange"===this._animationMode?"add"===h?(o.setX(a.x),o.setY(a.y),i(),"add"===l?(o.setX(n.getShape("main").getX()),(s=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,o,o.getX,o.setX,a.x),s.addProp(t.Animator.TYPE_NUMBER,o,o.getY,o.setY,a.y)):"exist"===l&&this.fadeInElemsDC.push(o)):"exist"===h&&((s=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,o,o.getX,o.setX,a.x),s.addProp(t.Animator.TYPE_NUMBER,o,o.getY,o.setY,a.y),this._onEnds.push(i)):(o.setX(a.x),o.setY(a.y),i())}preAnimateTaskLabelRemove(e,t){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(e),this._onEnds.push(t)):t()}preAnimateHorizontalGridline(e,a,i){var s;"dataChange"===this._animationMode?"add"===i?(e.setY1(a.y1),e.setY2(a.y2),e.setX1(a.x1),e.setX2(a.x2),this.fadeInElemsDC.push(e)):"exist"===i&&((s=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getX1,e.setX1,a.x1),s.addProp(t.Animator.TYPE_NUMBER,e,e.getX2,e.setX2,a.x2),s.addProp(t.Animator.TYPE_NUMBER,e,e.getY1,e.setY1,a.y1),s.addProp(t.Animator.TYPE_NUMBER,e,e.getY2,e.setY2,a.y2)):(e.setY1(a.y1),e.setY2(a.y2),e.setX1(a.x1),e.setX2(a.x2))}preAnimateRowBackground(e,a,i){var s;"dataChange"===this._animationMode?("add"===i&&this.fadeInElemsDC.push(e),(s=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getHeight,e.setHeight,a.h),s.addProp(t.Animator.TYPE_NUMBER,e,e.getWidth,e.setWidth,a.w),this.translationsPlayableDC.getAnimator().addProp(t.Animator.TYPE_NUMBER,e,e.getY,e.setY,a.y)):(e.setY(a.y),e.setHeight(a.h),e.setWidth(a.w))}preAnimateRowReferenceObject(e,a){"dataChange"===this._animationMode?this.dimensionsPlayableDC.getAnimator().addProp(t.Animator.TYPE_NUMBER,e,e.getY2,e.setY2,a.y2):e.updateRefObjs(e._refObjs,a.y1,a.y2)}preAnimateRowNodeRemove(e,t){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(e),this.fadeOutElemsDC.push(e.getBackground()),this._onEnds.push(t)):t()}preAnimateRowLabel(e,a,i){var s,n,r=e.getRenderState(),o=a.getBackground();"dataChange"===this._animationMode?"add"===r?(a.setY(i.y),a.setX(i.x),this.fadeInElemsDC.push(a.getDisplayable()),o.setRect(i.backgroundX,i.backgroundY,i.backgroundWidth,i.backgroundHeight),this.fadeInElemsDC.push(o)):"exist"===r&&((s=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,a,a.getX,a.setX,i.x),s.addProp(t.Animator.TYPE_NUMBER,a,a.getY,a.setY,i.y),s.addProp(t.Animator.TYPE_NUMBER,o,o.getX,o.setX,i.backgroundX),s.addProp(t.Animator.TYPE_NUMBER,o,o.getY,o.setY,i.backgroundY),(n=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,o,o.getWidth,o.setWidth,i.backgroundWidth),n.addProp(t.Animator.TYPE_NUMBER,o,o.getHeight,o.setHeight,i.backgroundHeight)):(a.setY(i.y),a.setX(i.x),o.setRect(i.backgroundX,i.backgroundY,i.backgroundWidth,i.backgroundHeight))}preAnimateRowLabelRemove(e,t,a){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(e.getBackground()),this.fadeOutElemsDC.push(e.getDisplayable()),this.fadeOutElemsDC.push(t),this._onEnds.push(a)):a()}}class D extends t.Automation{GetSubIdForDomElement(e){var t=this._comp.getEventManager().GetLogicalObject(e);if(t&&t instanceof u){var a=t.getLayoutObject().rowObj;return"taskbar["+a.index+"]["+a.taskObjs.map(e=>e.node).indexOf(t)+"]"}return t&&t instanceof r?"rowLabel["+t.getRowIndex()+"]":t&&t instanceof n?t.getLayoutObject().index:null}getDomElementForSubId(e){if(e===t.Automation.TOOLTIP_SUBID)return this.GetTooltipElement(this._comp);var a=e.indexOf("["),i=e.indexOf("]"),s=e.substring(0,a);if(a>-1&&i>-1)if("taskbar"===s){var n=e.indexOf("[",a+1),r=e.indexOf("]",n+1);if(n>-1&&r>-1){var o=parseInt(e.substring(a+1,i)),h=parseInt(e.substring(n+1,r));if(isNaN(o)||isNaN(h))return null;if((_=this._comp.getRowLayoutObjs()).length>o){var l=_[o].taskObjs;if(l.length>h){var d=l[h];this._comp.getDataLayoutManager().ensureInDOM(d,"task",!0);var g=d.node.getTask().getShape("main");if(null!=g)return g.getElem()}}}}else if("rowLabel"===s){var _;if(o=parseInt(e.substring(a+1,i)),(_=this._comp.getRowLayoutObjs()).length>o){var c=_[o];this._comp.getDataLayoutManager().ensureInDOM(c,"rowLabel");var u=c.node.getRowLabelContent();if(null!=u)return u.getDisplayable().getElem()}}else if("dependency"===s){var p=parseInt(e.substring(a+1,i)),m=this._comp.getDependencyLayoutObjs();if(m.length>p)for(var b=0;b<m.length;b++){var D=m[b];if(D.index===p){this._comp.getDataLayoutManager().ensureInDOM(D,"dependency");var v=D.node;if(null!=v)return v.getElem()}}}return null}}class v extends t.BaseComponentDefaults{constructor(e){super({alta:{axisPosition:"top",animationOnDataChange:"none",animationOnDisplay:"none",scrollbar:{horizontal:"off",vertical:"off"},gridlines:{horizontal:"hidden",vertical:"visible"},selectionMode:"none",scrollPosition:{y:0},rowDefaults:{height:null},taskDefaults:{labelPosition:["end","innerCenter","start","max"],borderRadius:"0",overlap:{behavior:"auto",offset:null},progress:{height:"100%",borderRadius:"0"},baseline:{borderRadius:"0"},type:"auto"},rowAxis:{rendered:"off",width:"max-content",maxWidth:"none"}}},e)}getNoCloneObject(){return{start:!0,end:!0,viewportStart:!0,viewportEnd:!0,rows:!0,dependencies:!0,referenceObjects:{value:!0},majorAxis:{converter:!0,scale:!0,zoomOrder:!0},minorAxis:{converter:!0,scale:!0,zoomOrder:!0},valueFormats:{baselineDate:{converter:!0},baselineEnd:{converter:!0},baselineStart:{converter:!0},date:{converter:!0},downtimeEnd:{converter:!0},downtimeStart:{converter:!0},end:{converter:!0},overtimeEnd:{converter:!0},overtimeStart:{converter:!0},progress:{converter:!0},start:{converter:!0}},_resources:{converter:!0,defaultDateConverter:!0,defaultDateTimeConverter:!0,percentConverter:!0}}}getAnimationDuration(e){return e._resources?e._resources.animationDuration:null}}const S=e=>{var t={},a=t=>{var a=typeof e[t];if("number"===a||"string"===a){var i=new Date(e[t]).getTime();if(!isNaN(i))return i}return null};return t.start=a("start"),t.end=a("end"),e.viewportStart&&(t.viewStart=a("viewportStart")),e.viewportEnd&&(t.viewEnd=a("viewportEnd")),t.rows=e.rows,t.dependencies=e.dependencies,t.axisPosition="top",null!=e.axisPosition&&(t.axisPosition=e.axisPosition),t.selectionMode="none",null!=e.selectionMode&&(t.selectionMode=e.selectionMode),t.horizontalGridline="hidden",t.verticalGridline="hidden",null!=e.gridlines&&(null!=e.gridlines.horizontal&&(t.horizontalGridline=e.gridlines.horizontal),null!=e.gridlines.vertical&&(t.verticalGridline=e.gridlines.vertical)),t.xScrollbar="off",t.yScrollbar="off",e.scrollbars&&(e.scrollbars.horizontal&&(t.xScrollbar=e.scrollbars.horizontal),e.scrollbars.vertical&&(t.yScrollbar=e.scrollbars.vertical)),t.isIRAnimationEnabled="auto"===e.animationOnDisplay,t.isDCAnimationEnabled="auto"===e.animationOnDataChange,null!=e.rowAxis&&(t.rowAxisRendered=e.rowAxis.rendered,t.rowAxisWidth=e.rowAxis.width,t.rowAxisMaxWidth=e.rowAxis.maxWidth),t.referenceObjects=e.referenceObjects,t.styleClass=e.className,t.inlineStyle=e.style,t};class T extends t.Container{constructor(e){super(e.getCtx()),this._gantt=e;var a=e.getEventManager();this.addEvtListener(t.MouseEvent.MOUSEMOVE,a.OnMouseMove.bind(a),!1,this),this.addEvtListener(t.MouseEvent.MOUSEOVER,a.PreOnMouseOver.bind(a),!1,this),this.addEvtListener(t.MouseEvent.MOUSEOUT,a.PreOnMouseOut.bind(a),!1,this),this._labelBackgroundContainer=new t.Container(e.getCtx()),this.addChild(this._labelBackgroundContainer),this._labelContentContainer=new t.Container(e.getCtx()),this.addChild(this._labelContentContainer)}getDefaultRowLabelStyle(e){var t=this._gantt.getOptions();return e?(this._defaultLabelCSSStyle||(this._defaultLabelCSSStyle=s.getRowLabelStyle(t)),this._defaultLabelCSSStyle):s.getRowLabelStyle(t)}_getCSSStyle(e){if(null!=e&&""!==e&&0!==Object.keys(e).length){var t=this.getDefaultRowLabelStyle(!1);return t.parseInlineStyle(e),t}return this.getDefaultRowLabelStyle(!0)}getLabelContentType(){var e=this._gantt.getOptions().rowAxis;return e.label&&e.label.renderer?"custom":"text"}_getAvailableWidth(e){var t,a,i=this._gantt.getRowAxisMaxWidth(),n=this._gantt.getRowAxisWidth();return null!=i&&"none"!==i&&(t=Math.min(s.getSizeInPixels(i,e),e)),t=null==t||isNaN(t)?e:t,null!=n&&"max-content"!==n&&(a=s.getSizeInPixels(this._gantt.getRowAxisWidth(),e)),{maxWidth:t,width:a=null==a||isNaN(a)?-1:a,calculatedWidth:-1!==a?Math.min(a,t):t}}getAvailableWidth(){return this._availableWidth}getWidth(){return this._width}getLabelContentIndentSize(e){return e.depth*s.getRowLabelIndentSize()+s.getRowLabelButtonSize()+s.getRowLabelButtonContentGapSize()}_getMaxTextContentWidth(e,a,i){if(!this._gantt.isRowsHierarchical())return t.TextUtils.getMaxTextStringWidth(e,a,i);for(var s=this._gantt.getRowLayoutObjs(),n=0,r=0;r<a.length;r++){var o=a[r]?a[r]:"",h=i[r],l=t.TextUtils.getTextStringWidth(e,o,h),d=(null==s[r].expanded&&0===o.length?0:this.getLabelContentIndentSize(s[r]))+l;d>n&&(n=d)}return n}render(e,t){if(t||this.setAriaRole("grid",!0),this._availableWidth=this._getAvailableWidth(e),t)-1!==this._availableWidth.width&&(this._width=this._availableWidth.calculatedWidth);else{this._rowLabelContents=[];var a=this.getLabelContentType(),i=this._gantt.getRowLayoutObjs();if(-1===this._availableWidth.width){if("text"===a){for(var n=[],o=[],h=0;h<i.length;h++){var l=i[h].data,d=null!=l.label?l.label:"",g=this._getCSSStyle(l.labelStyle);n.push(d),o.push(g),this._rowLabelContents.push(null)}this._width=this._getMaxTextContentWidth(this._gantt.getCtx(),n,o)}else if("custom"===a){this._width=0;for(h=0;h<i.length;h++){var _=i[h],c=new r(this,a);c.setRowIndex(h),c.render(_),this._width=Math.max(this._width,c.getWidth()),this._rowLabelContents.push(c)}}var u=this._gantt.getOptions(),p=s.getRowLabelPaddingStart(u),m=s.getRowLabelPaddingEnd(u);this._width+=p+m}else{this._width=this._availableWidth.calculatedWidth;for(h=0;h<i.length;h++)this._rowLabelContents.push(null)}this._width=Math.ceil(Math.min(this._width,this._availableWidth.maxWidth))}}addLabelContent(e){this._labelContentContainer.addChild(e)}removeLabelContent(e){this._labelContentContainer.removeChild(e)}addLabelBackground(e){this._labelBackgroundContainer.addChild(e)}removeLabelBackground(e){this._labelBackgroundContainer.removeChild(e)}addHorizontalLine(e){this._labelContentContainer.addChild(e)}removeHorizontalLine(e){this._labelContentContainer.removeChild(e)}getRowLabelContents(){return this._rowLabelContents}setBackgroundContainer(e){this._backgroundContainer=e}getBackgroundContainer(){return this._backgroundContainer}setBackgroundDivider(e){this._backgroundDivider=e}getBackgroundDivider(){return this._backgroundDivider}adjustPosition(){var e=t.Agent.isRightToLeft(this._gantt.getCtx()),a=this._width,i=this._gantt.getCanvasSize()-this._gantt.getAxesHeight(),n=s.getComponentPaddingStart(this._gantt.getOptions()),r=e?this._gantt.getStartXOffset()+this._gantt.getCanvasLength()+this._gantt.getBorderWidth()+s.getRowAxisGap():n;this.setTranslateX(r);var o=new t.ClipPath;o.addRect(e?r:r-n,this._gantt.getDatabodyStart()+this._gantt.getStartYOffset(),a+n,i),this.setClipPath(o),this._backgroundContainer.setTranslateX(e?r-1:r);var h=new t.ClipPath;if(h.addRect(this.getTranslateX(),0,a,this._gantt._backgroundHeight),this._backgroundContainer.setClipPath(h),this._backgroundDivider){var l=this._gantt.getDatabodyStart()+this._gantt.getStartYOffset()+("top"!==this._gantt.getAxisPosition())*(this._gantt.getDatabodyHeight()+1);this._backgroundDivider.setY1(l),this._backgroundDivider.setY2(l)}}clear(){this._labelContentContainer.removeChildren(),this._labelBackgroundContainer.removeChildren()}}class y extends t.Container{constructor(e,t,a){super(e.getCtx(),null),this._gantt=e,this._type=t,this._refObjs=a,this._gantt.getEventManager().associate(this,this)}_applyStyles(){var e,t=this._refObjs[0].svgStyle,a=this._refObjs[0].svgClassName;switch(null!=t&&this._ref.setStyle(t),this._type){case"line":default:e=this._gantt.GetStyleClass("referenceObjectLine");break;case"timeCursor":e=this._gantt.GetStyleClass("timeCursorLine");break;case"area":e=this._gantt.GetStyleClass("referenceObjectArea")}var i=null!=a?e+" "+a:e;this._ref.setClassName(i,!0)}_calcCmds(e,a,s){var n=t.Agent.isRightToLeft(this._gantt.getCtx()),r=this._gantt.getStartTime(),o=this._gantt.getEndTime(),h=this._gantt.getContentLength(),l="";return"line"===this._type||"timeCursor"===this._type?this._refObjs.forEach(d=>{var g=new Date(d.value).getTime(),_=i.TimeAxisUtils.getDatePosition(r,o,g,h)+(s||0);n&&(_=h-_),l+=t.PathUtils.moveTo(_,e)+t.PathUtils.verticalLineTo(a)},this):this._refObjs.forEach(s=>{var d=new Date(s.start).getTime(),g=new Date(s.end).getTime(),_=i.TimeAxisUtils.getDatePosition(r,o,d,h),c=i.TimeAxisUtils.getDatePosition(r,o,g,h),u=n?h-c:_,p=n?h-_:c;l+=t.PathUtils.moveTo(u,e)+t.PathUtils.horizontalLineTo(p)+t.PathUtils.verticalLineTo(a)+t.PathUtils.horizontalLineTo(u)+t.PathUtils.verticalLineTo(e)},this),l}render(e,a,i){if(0!==this._refObjs.length){if(this._y1=null==a?this._gantt.getDatabodyStart():a,this._y2=null==i?this._gantt.getDatabodyStart()+this._gantt._canvasSize-this._gantt.getAxesHeight():i,this._ref=new t.Path(this._gantt.getCtx(),this._calcCmds(this._y1,this._y2,0)),"line"===this._type||"timeCursor"===this._type){this._partnerRef=new t.Path(this._gantt.getCtx(),this._calcCmds(this._y1,this._y2,1));var s=this._gantt.GetStyleClass("timeCursor"===this._type?"timeCursorInnerLine":"referenceObjectInnerLine");this._partnerRef.setClassName(s,!0),this.addChild(this._partnerRef)}this._applyStyles(),this.addChild(this._ref),e.addChild(this)}}updateRefObjs(e,t,a){this._refObjs=e,this._y1=null==t?this._y1:t,this._y2=null==a?this._y2:a,this._ref.setCmds(this._calcCmds(this._y1,this._y2,0)),this._partnerRef&&this._partnerRef.setCmds(this._calcCmds(this._y1,this._y2,1))}getY1(){return this._y1}getY2(){return this._y2}setY2(e){this.updateRefObjs(this._refObjs,this._y1,e)}hide(){this.setAlpha(0)}show(){this.setAlpha(1)}getDatatip(){return this._refObjs[0].shortDesc}}const C={renderGantt:e=>{if(C._renderBackground(e),C._renderScrollableCanvas(e),e.getAnimationManager().preAnimateGanttIR(e),e.removeEmptyText(),e.hasValidOptions()){C._prepareTaskFillFilters(e),e.renderTimeZoomCanvas(e._canvas);var t=e.getTimeZoomCanvas();if(C._renderAxes(e,t),C._renderDatabodyBackground(e,t),C._renderRowReferenceObjectsContainer(e,t),C._renderReferenceObjects(e,t,"area"),C._renderVerticalGridline(e,t),e.isRowAxisEnabled()&&e.getRowAxis().adjustPosition(),C._renderData(e,t,m.VPC_REFRESH),C._renderReferenceObjects(e,t,"line"),C._renderTimeCursor(e,t),C._renderZoomControls(e),e.isMarqueeSelectEnabled())C._renderMarqueeArtifactsContainer(e,t);else{var a=e.getMarqueeArtifactsContainer();a&&(a.getParent().removeChild(a),e.setMarqueeArtifactsContainer(null))}if(e.isDndEnabled()&&C._renderDnDArtifactsContainer(e,t),null!=e.getRenderState()){var i=e.getEventManager().getFocus();i&&i instanceof u&&i.refreshAriaLabel()}e._processInitialSelections(),(e.isTimeDirScrollbarOn()||e.isContentDirScrollbarOn())&&C._renderScrollbars(e,e),e.setIsLastRenderValid(!0)}else C._renderEmptyText(e),e.setIsLastRenderValid(!1);C.renderRowAxisVerticalDivider(e,e._canvas)},_prepareTaskFillFilters:e=>{if(!document.getElementById(s.getTaskTintFilterId())){var a=s.getTaskTintAlpha(),i=t.SvgShapeUtils.createElement("filter",s.getTaskTintFilterId()),n=t.SvgShapeUtils.createElement("feColorMatrix");n.setAttribute("color-interpolation-filters","sRGB"),n.setAttribute("type","matrix"),n.setAttribute("values",1-a+" 0 0 0 "+a+" 0 "+(1-a)+" 0 0 "+a+" 0 0 "+(1-a)+" 0 "+a+" 0 0 0 1 0"),i.appendChild(n);var r=s.getTaskShadeAlpha(),o=t.SvgShapeUtils.createElement("filter",s.getTaskShadeFilterId()),h=t.SvgShapeUtils.createElement("feColorMatrix");h.setAttribute("color-interpolation-filters","sRGB"),h.setAttribute("type","matrix"),h.setAttribute("values",1-r+" 0 0 0 0 0 "+(1-r)+" 0 0 0 0 0 "+(1-r)+" 0 0 0 0 0 1 0"),o.appendChild(h),e.appendSharedDefs(i),e.appendSharedDefs(o)}},_prerenderTimeDirScrollbar:(e,a,i)=>{var s=i.w,n=t.CSSStyle.toNumber(e.timeDirScrollbarStyles.getHeight());return e.setTimeDirScrollbar(new t.SimpleScrollbar(e.getCtx(),e.HandleEvent,e)),a.addChild(e.timeDirScrollbar),t.LayoutUtils.position(i,"bottom",e.timeDirScrollbar,s,n,0),new t.Dimension(s,n)},_prerenderContentDirScrollbar:(e,a,i)=>{var s=t.CSSStyle.toNumber(e.contentDirScrollbarStyles.getWidth()),n=i.h;return e.setContentDirScrollbar(new t.SimpleScrollbar(e.getCtx(),e.HandleEvent,e)),a.addChild(e.contentDirScrollbar),t.LayoutUtils.position(i,t.Agent.isRightToLeft(e.getCtx())?"left":"right",e.contentDirScrollbar,s,n,0),new t.Dimension(s,n)},_renderScrollbars:(e,a)=>{var i=e.getDatabody();if(null!=i){var s=e.getDatabodyStart(),n=e.getCtx(),r=e.getScrollbarPadding();if(null==e._scrollbarsCanvas?(e._scrollbarsCanvas=new t.Container(n,"g","sbCanvas"),a.addChild(e._scrollbarsCanvas)):e._scrollbarsCanvas.removeChildren(),e.isTimeDirScrollbarOn())var o=e.getCanvasLength(),h=e.Height-r,l=C._prerenderTimeDirScrollbar(e,e._scrollbarsCanvas,new t.Rectangle(0,0,o,h));if(e.isContentDirScrollbarOn()){o=e.Width-r,h=e.getCanvasSize()-e.getAxesHeight();var d=t.Agent.isRightToLeft(e.getCtx())?e.getScrollbarPadding():0,g=C._prerenderContentDirScrollbar(e,e._scrollbarsCanvas,new t.Rectangle(d,0,o-d,h))}if(e.timeDirScrollbar&&l){var _={};_.color=e.timeDirScrollbarStyles.getStyle(t.CSSStyle.COLOR),_.backgroundColor=e.timeDirScrollbarStyles.getStyle(t.CSSStyle.BACKGROUND_COLOR),_.min=e._start,_.max=e._end,_.isHorizontal=!0,_.isReversed=t.Agent.isRightToLeft(e.getCtx()),e.timeDirScrollbar.setTranslateX(e.getStartXOffset()),e.timeDirScrollbar.render(_,l.w,l.h),e.timeDirScrollbar.setViewportRange(e._viewStartTime,e._viewEndTime)}if(e.contentDirScrollbar&&g){(_={}).color=e.contentDirScrollbarStyles.getStyle(t.CSSStyle.COLOR),_.backgroundColor=e.contentDirScrollbarStyles.getStyle(t.CSSStyle.BACKGROUND_COLOR),_.min=-(Math.max(e.getContentHeight(),g.h)-s),_.max=s,_.isHorizontal=!1,_.isReversed=!0,e.contentDirScrollbar.setTranslateY(s+e.getStartYOffset()),e.contentDirScrollbar.render(_,g.w,g.h);var c=0;"bottom"===e.getAxisPosition()&&(c=e.getAxesHeight()),e.contentDirScrollbar.setViewportRange(i.getTranslateY()-(e.getCanvasSize()-s-c),i.getTranslateY())}}else null!=e._scrollbarsCanvas&&e._scrollbarsCanvas.removeChildren()},renderRowAxisVerticalDivider:(e,a)=>{var i=e.getCtx();if("alta"!==i.getThemeBehavior()&&e.isRowAxisEnabled()){var s=t.Agent.isRightToLeft(i)?e.getStartXOffset()+e.getCanvasLength():Math.round(e.getStartXOffset())+.5;e._rowAxisVerticalDivider?e._rowAxisVerticalDivider.setX1(s).setX2(s):(e._rowAxisVerticalDivider=new t.Line(i,s,e.getStartYOffset(),s,e._canvasSize+2*e.getBorderWidth()),e._rowAxisVerticalDivider.setPixelHinting(!0),e._rowAxisVerticalDivider.setClassName(e.GetStyleClass("majorvgridline"),!0),a.addChild(e._rowAxisVerticalDivider))}},renderRowAxis:(e,a)=>{var i=t.Agent.isRightToLeft(e.getCtx()),n=e.getRowAxis();if(e.isRowAxisEnabled()){n||((n=new T(e)).setPixelHinting(!0),e.setRowAxis(n),n.setBackgroundContainer(new t.Container(e.getCtx()))),a&&(a.addChild(n),e.getParent().addChildAt(n.getBackgroundContainer(),0)),n.render(e.Width-s.getRowAxisGap(),null==a);var r=n.getWidth(),o=r>0?r+s.getRowAxisGap():0;e._backgroundWidth-=o,i||(e._widthOffset+=o,e.setStartXOffset(e.getStartXOffset()+o)),e._canvasLength-=o;var h=n.getBackgroundContainer();h.removeChildren(),n.setBackgroundDivider();var l=new t.Rect(e.getCtx(),0,0,r+1,e._backgroundHeight);if(l.setClassName(e.GetStyleClass("databody")),l.setPixelHinting(!0),h.addChild(l),"alta"===e.getCtx().getThemeBehavior()||e.isHorizontalGridlinesVisible()){var d=new t.Line(e.getCtx(),0,0,r,0);d.setPixelHinting(!0),d.setClassName(e.GetStyleClass("hgridline"),!0),h.addChild(d),n.setBackgroundDivider(d)}}else a&&n&&(e.getParent().removeChild(n.getBackgroundContainer()),a.removeChild(n)),e.setRowAxis(null)},_renderBackground:e=>{var a=e._backgroundWidth,i=e._backgroundHeight;e._background?(e._background.setClipPath(null),e._background.setWidth(a),e._background.setHeight(i),e._background.setX(e._widthOffset)):e._background=new t.Rect(e.getCtx(),e._widthOffset,0,a,i,"bg"),e._background.setClassName(e.GetStyleClass("databody")),e._background.setPixelHinting(!0);var s=new t.ClipPath;s.addRect(e._widthOffset,0,a,i),e._background.setClipPath(s),e._background.getParent()!=e&&e.addChild(e._background)},_renderDatabodyBackground:(e,a)=>{var i=e.getDatabodyBackground();null==i&&(i=new t.Container(e.getCtx()),a.addChild(i),e.setDatabodyBackground(i)),null==e.getDatabody()&&i.setTranslateY(e.scrollPositionToTranslateY(e.getOptions().scrollPosition));var s=new t.ClipPath;s.addRect(0,e.getDatabodyStart(),e.getContentLength(),e.getDatabodyHeight()),i.setClipPath(s)},_renderRowReferenceObjectsContainer:(e,a)=>{var i=e.getRowReferenceObjectsContainer();null==i&&(i=new t.Container(e.getCtx()),a.addChild(i),e.setRowReferenceObjectsContainer(i)),null==e.getDatabody()&&i.setTranslateY(e.getDatabodyBackground().getTranslateY());var s=new t.ClipPath;s.addRect(0,e.getDatabodyStart(),e.getContentLength(),e.getDatabodyHeight()),i.setClipPath(s)},_renderDnDArtifactsContainer:(e,a)=>{var i=e.getDatabody();if(i){var s=e.getDnDArtifactsContainer();null==s&&(s=new t.Container(e.getCtx()),e.setDnDArtifactsContainer(s),s.setTranslateY(i.getTranslateY())),a.addChild(s);var n=new t.ClipPath;n.addRect(0,e.getDatabodyStart(),e.getContentLength(),e.getDatabodyHeight()),s.setClipPath(n)}},_renderMarqueeArtifactsContainer:(e,a)=>{var i=e.getDatabody();if(i){var s=e.getMarqueeArtifactsContainer();null==s&&(s=new t.Container(e.getCtx()),e.setMarqueeArtifactsContainer(s),s.setTranslateY(i.getTranslateY())),a.addChild(s);var n=new t.ClipPath;n.addRect(0,e.getDatabodyStart(),e.getContentLength(),e.getDatabodyHeight()),s.setClipPath(n);var r=e.getEventManager();if("multiple"===e.getOptions().selectionMode){var o=new t.Rectangle(1,1,e.getContentLength()-1,e.getContentHeight()-1),h=new t.SolidFill(""),l=new t.Stroke(""),d=new t.MarqueeHandler(s,o,o,h,l,!0,!0);r.setMarqueeSelectHandler(d)}}},_renderScrollableCanvas:e=>{e._canvas||(e._canvas=new t.Container(e.getCtx(),"g","canvas"),e.addChild(e._canvas))},_renderAxes:(e,t,a)=>{var i=e.getMajorAxis(),s=e.getMinorAxis(),n=e.getAxisPosition(),r=e.getOptions(),o=e.getReferenceObjects();if("top"===n){var h=0;i&&(C._renderAxis(e,t,i,h,e.getAxisHeight(r,"majorAxis"),[],a),h+=i.getSize()),s&&(C._renderAxis(e,t,s,h,e.getAxisHeight(r,"minorAxis"),o,a),h+=s.getSize()),e.setDatabodyStart(h)}else h=e._canvasSize,i&&(C._renderAxis(e,t,i,null,e.getAxisHeight(r,"majorAxis"),[],a),h-=i.getSize(),C._positionAxis(i,h)),s&&(C._renderAxis(e,t,s,h,e.getAxisHeight(r,"minorAxis"),o,a),h-=s.getSize(),C._positionAxis(s,h)),e.setDatabodyStart(0)},_renderAxis:(e,t,a,i,s,n,r)=>{a.getParent()!==t&&t.addChild(a),a.render({_viewStartTime:e._viewStartTime,_viewEndTime:e._viewEndTime,_referenceObjects:{referenceObjects:n,defaultStyleClass:e.GetStyleClass("referenceObjectLine"),defaultStroke:null},_throttle:r,_eventManager:e.getEventManager()},e.getContentLength(),s),null!=i&&C._positionAxis(a,i)},_positionAxis:(e,a)=>{var i=new t.Matrix(1,0,0,1,0,a);e.setMatrix(i)},_renderZoomControls:e=>{var a=e.getCtx(),i=e._resources,n=t.Agent.isRightToLeft(a),r={zoomInProps:{imageSize:16,class:i.zoomIn},zoomOutProps:{imageSize:16,class:i.zoomOut}};if(n)var o=e.getStartXOffset()+s._DEFAULT_ZOOM_CONTROL_PADDING;else o=e.getCanvasLength()+e.getStartXOffset()-(s._DEFAULT_ZOOM_CONTROL_PADDING+s._DEFAULT_ZOOM_CONTROL_DIAMETER);r.zoomInProps.posX=o,r.zoomOutProps.posX=o;var h=e._startY+s._DEFAULT_ZOOM_CONTROL_PADDING;if("top"===e.getAxisPosition())var l=h;else l=e._backgroundHeight-h;if("top"===e.getAxisPosition())var d=l,g=l+s._DEFAULT_ZOOM_CONTROL_DIAMETER+s._DEFAULT_ZOOM_CONTROL_SPACING;else d=l-2*s._DEFAULT_ZOOM_CONTROL_DIAMETER-s._DEFAULT_ZOOM_CONTROL_SPACING,g=l-s._DEFAULT_ZOOM_CONTROL_DIAMETER;r.zoomInProps.posY=d,r.zoomOutProps.posY=g,e.renderZoomControls(r)},_renderEmptyText:(e,a)=>{if(a){var i=e.getDatabody(),s=e.getDependenciesContainer();i&&i.getParent()&&(i.getParent().removeChild(i),e.setDatabody(null)),s&&s.getParent()&&(s.getParent().removeChild(s),e.setDependenciesContainer(null)),e.getDataLayoutManager().clear();var n=e.getOptions().translations.labelNoData;e.removeEmptyText()}else n=e.getOptions().translations.labelInvalidData,e.clearComponent();var r=e.getAxesHeight(),o=e.renderEmptyText(e._canvas,n,new t.Rectangle(e.getStartXOffset(),e.getStartYOffset()+r*("top"===e.getAxisPosition()),e.getCanvasLength(),e.getCanvasSize()-r),e.EventManager,null);o.setClassName(e.GetStyleClass("nodata")),e.setEmptyText(o)},_renderDatabody:(e,a)=>{var i=e.getDatabody();null==i&&(i=new t.Container(e.getCtx(),"g","db"),a.addChild(i),e.setDatabody(i),i.setTranslateY(e.getDatabodyBackground().getTranslateY()));var s=new t.ClipPath;s.addRect(0,e.getDatabodyStart(),e.getContentLength(),e.getDatabodyHeight()),i.setClipPath(s)},_renderVerticalGridline:(e,a)=>{var s=e.getVerticalGridlines();if(null!=s&&s.removeChildren(),e.isVerticalGridlinesVisible()){null==s&&(s=new t.Container(e.getCtx()),a.addChild(s),e.setVerticalGridlines(s));const n=e.getStartTime(),r=e.getEndTime(),o=e.getContentLength(),h=(a,s,h)=>{var l=e.getCtx(),d=t.Agent.isRightToLeft(l);s.forEach((g,_)=>{let c=i.TimeAxisUtils.getDatePosition(n,r,g.getTime(),o);d&&(c=o-c),(!d&&0===_||d&&_===s.length-1)&&(c=Math.round(c)+.5);const u=new t.Line(l,c,e.getDatabodyStart(),c,e.getDatabodyStart()+e._canvasSize-e.getAxesHeight());u.setPixelHinting(!0),u.setMouseEnabled(!1),u.setClassName(h,!0),a.addChild(u)})},l=((t,a)=>{const i=a?a.getViewportDates(a.getScale(),n,r):[],s=t.getViewportDates(t.getScale(),n,r);if("alta"===e.getCtx().getThemeBehavior())return{major:i,minor:a?[]:s};const o=new Set(i.map(e=>e.getTime())),h=new Set(s.map(e=>e.getTime())),l=0===i.filter(e=>e.getTime()>n&&e.getTime()<r&&!h.has(e.getTime())).length;return{major:l?i:[],minor:l?s.filter(e=>!o.has(e.getTime())):s}})(e.getMinorAxis(),e.getMajorAxis());h(s,l.minor,e.GetStyleClass("minorvgridline")),h(s,l.major,e.GetStyleClass("majorvgridline"))}},_renderReferenceObjects:(e,a,i)=>{var s="line"===i?e.getReferenceLinesContainer():e.getReferenceAreasContainer();null==s&&(s=new t.Container(e.getCtx()),a.addChild(s),"line"===i?e.setReferenceLinesContainer(s):e.setReferenceAreasContainer(s)),s.removeChildren();var n=e=>null!=e&&!isNaN(new Date(e).getTime()),r=e.getReferenceObjects().filter(e=>"line"===i?("line"===e.type||null==e.type)&&n(e.value):"area"===e.type&&n(e.start)&&n(e.end));e.generateReferenceObjects(r,i).forEach(e=>e.render(s))},_renderTimeCursor:(e,a)=>{var i=e.getTimeCursorContainer();null==i&&(i=new t.Container(e.getCtx()),a.addChild(i),e.setTimeCursorContainer(i)),i.removeChildren();var s=new y(e,"timeCursor",[{type:"line",value:new Date(e.getStartTime()).toISOString()}]);s.render(i),s.setMouseEnabled(!1),s.hide(),e.setTimeCursor(s)},_renderData:(e,t,a)=>{var i=e.getOptions(),n=e.getRowLayoutObjs(),r=e.getDependencyLayoutObjs();if(0!==n.length){C._renderDatabody(e,t),r.length>0&&C._renderDependenciesContainer(e,t),e.getCache().getFromCache("baseTaskLabelCSSStyle")||e.getCache().putToCache("baseTaskLabelCSSStyle",s.getTaskLabelStyle(i)),e.setDataRegionTranslateY(e.getBoundedContentTranslateY(e.getDatabody().getTranslateY()));var o=!e.isInitialRender()&&e.isLastRenderValid()&&"none"!==e.getAnimationManager().getAnimationMode();e.renderViewport(o?m.VPC_ANIMATE:a,!0)}else C._renderEmptyText(e,!0)},_renderDependenciesContainer:(e,a)=>{var i=e.getDependenciesContainer();null==i&&((i=new t.Container(e.getCtx())).setTranslateY(e.getDatabody().getTranslateY()),a.addChild(i),e.setDependenciesContainer(i),C._prepareDependencyMarkers(e));var s=new t.ClipPath;s.addRect(0,e.getDatabodyStart(),e.getContentLength(),e.getDatabodyHeight()),i.setClipPath(s)},_prepareDependencyMarkers:e=>{if(!document.getElementById(s.getDependencyLineAngleMarkerId())){var t=C._createTriangleMarker(e),a=C._createAngleMarker(e),i=C._createOpenCircleMarker(e),n=C._createClosedCircleMarker(e);e.appendSharedDefs(t),e.appendSharedDefs(a),e.appendSharedDefs(i),e.appendSharedDefs(n)}},_createTriangleMarker:e=>{var t=s.getDependencyLineTriangleMarkerId(),a=s.getDependencyLineTriangleMarkerWidth(),i=s.getDependencyLineTriangleMarkerHeight(),n=e.GetStyleClass("dependencyLineConnector"),r="M0,0L"+a+","+i/2+",0,"+i+"V0Z";return C._createMarker(e,t,a,i,r,n)},_createAngleMarker:e=>{var t=s.getDependencyLineAngleMarkerId(),a=s.getDependencyLineAngleMarkerWidth(),i=s.getDependencyLineAngleMarkerHeight(),n=e.GetStyleClass("dependencyRectilinearLineArrowConnector"),r="M0,0L"+a+","+i/2+",0,"+i;return C._createMarker(e,t,a,i,r,n)},_createMarker:(e,a,i,s,n,r)=>{var o=e.GetStyleClass("dependencyLineConnector")+" "+r,h=t.SvgShapeUtils.createElement("marker",a);t.ToolkitUtils.setAttrNullNS(h,"class",o),t.ToolkitUtils.setAttrNullNS(h,"markerUnits","userSpaceOnUse");var l=t.SvgShapeUtils.createElement("path");return t.ToolkitUtils.setAttrNullNS(h,"viewBox","0 0 "+i+" "+s),t.ToolkitUtils.setAttrNullNS(h,"refX",i),t.ToolkitUtils.setAttrNullNS(h,"refY",s/2),t.ToolkitUtils.setAttrNullNS(h,"markerWidth",i),t.ToolkitUtils.setAttrNullNS(h,"markerHeight",s),t.ToolkitUtils.setAttrNullNS(h,"orient","auto"),t.ToolkitUtils.setAttrNullNS(l,"d",n),h.appendChild(l),h},_createOpenCircleMarker:e=>{var t=s.getDependencyLineOpenCircleMarkerId(),a=s.getDependencyLineCircleMarkerRadius(),i=e.GetStyleClass("dependencyStraightLineOpenCircleConnector");return C._createCircleMarker(e,t,a,i)},_createClosedCircleMarker:e=>{var t=s.getDependencyLineClosedCircleMarkerId(),a=s.getDependencyLineCircleMarkerRadius(),i=e.GetStyleClass("dependencyStraightLineClosedCircleConnector");return C._createCircleMarker(e,t,a,i)},_createCircleMarker:(e,a,i,s)=>{var n=e.GetStyleClass("dependencyLineConnector")+" "+s,r=t.SvgShapeUtils.createElement("marker",a);t.ToolkitUtils.setAttrNullNS(r,"class",n),t.ToolkitUtils.setAttrNullNS(r,"markerUnits","userSpaceOnUse");var o=t.SvgShapeUtils.createElement("circle"),h=2*i+2,l=2*i+2;return t.ToolkitUtils.setAttrNullNS(r,"viewBox","0 0 "+h+" "+l),t.ToolkitUtils.setAttrNullNS(r,"refX",h/2),t.ToolkitUtils.setAttrNullNS(r,"refY",l/2),t.ToolkitUtils.setAttrNullNS(r,"markerWidth",h),t.ToolkitUtils.setAttrNullNS(r,"markerHeight",l),t.ToolkitUtils.setAttrNullNS(r,"orient","auto"),t.ToolkitUtils.setAttrNullNS(o,"cx",h/2),t.ToolkitUtils.setAttrNullNS(o,"cy",l/2),t.ToolkitUtils.setAttrNullNS(o,"r",i),r.appendChild(o),r}};class E extends a.TimeComponent{constructor(e,a,i){super(e,a,i),this._isInitialRender=!0,this.Defaults=new v(e),this.EventManager=new l(this,e,a,i),this.EventManager.addListeners(this),t.Agent.isTouchDevice()?this._keyboardHandler=null:(this._keyboardHandler=new d(this,this.EventManager),this.EventManager.setKeyboardHandler(this._keyboardHandler))}SetOptions(e){null==e.taskDefaults&&(e.taskDefaults={baseline:{}}),null==e.taskDefaults.baseline&&(e.taskDefaults.baseline={}),null==e.taskDefaults.height&&(e.taskDefaults.height=s.getStandaloneTaskHeight(e)),null==e.taskDefaults.baseline.height&&(e.taskDefaults.baseline.height=s.getBaselineTaskHeight(e)),super.SetOptions(e),this.setSelectionMode(this.Options.selectionMode);var a=this.isTaskMoveEnabled(),i=this.isTaskResizeEnabled();if((a||i)&&t.Agent.isTouchDevice()){this.Options.dnd=t.JsonUtils.merge(this.Options.dnd,{drag:{tasks:{dataTypes:[]},taskResizeHandles:{dataTypes:[]}},drop:{rows:{dataTypes:[]}}});var n=this,r=(e,t)=>{var a=n.Options.dnd.drag[t].dataTypes;Array.isArray(a)||(n.Options.dnd.drag[t].dataTypes=[a],a=n.Options.dnd.drag[t].dataTypes),a.push(e);var i=n.Options.dnd.drop.rows.dataTypes;Array.isArray(i)||(n.Options.dnd.drop.rows.dataTypes=[i],i=n.Options.dnd.drop.rows.dataTypes),i.push(e)};i&&r(l.RESIZE_TASKS_DATA_TYPE,"taskResizeHandles"),a&&r(l.MOVE_TASKS_DATA_TYPE,"tasks")}}getAutomation(){return this.Automation||(this.Automation=new D(this)),this.Automation}GetStyleClass(e){var t=this.getCtx().styleClasses;return null!=t?t[e]:e}Parse(e){return S(e)}_applyParsedProperties(e){this._axisPosition=e.axisPosition,this._selectionMode=e.selectionMode,this._horizontalGridline=e.horizontalGridline,this._verticalGridline=e.verticalGridline,this._viewStartTime=e.viewStart,this._viewEndTime=e.viewEnd,this._rowsData=e.rows,this.isIRAnimationEnabled=e.isIRAnimationEnabled,this.isDCAnimationEnabled=e.isDCAnimationEnabled,this._rowAxisRendered=e.rowAxisRendered,this._rowAxisWidth=e.rowAxisWidth,this._rowAxisMaxWidth=e.rowAxisMaxWidth,this._referenceObjects=e.referenceObjects,super._applyParsedProperties(e)}_bundleTimeAxisOptions(e,t){var a=this._resources;a.axisClass=this.GetStyleClass(t),a.axisSeparatorClass=this.GetStyleClass(t+"Ticks");var i,n={start:e.start,end:e.end,_resources:a,shortDesc:e.shortDesc,orientation:"horizontal"};if(e[t]){var r=e[t];r.scale&&(n.scale=r.scale),r.converter&&(n.converter=r.converter),n.zoomOrder=r.zoomOrder||[r.scale];"alta"===this.getCtx().getThemeBehavior()?(n._scaleLabelPosition={seconds:"center",minutes:"center",hours:"center",days:"center",weeks:"center",months:"center",quarters:"center",years:"center"},n._labelAlignment={horizontal:"middle",vertical:"middle"}):(n._scaleLabelPosition={seconds:"start",minutes:"start",hours:"start",days:"minorAxis"===t?"center":"start",weeks:"start",months:"start",quarters:"start",years:"start"},n._labelAlignment={horizontal:"top",vertical:"middle"}),n.zoomOrder.forEach(e=>{if(e&&e.name){const t=e.labelPosition||"auto",a="auto"===t?"start":t;n._scaleLabelPosition[e.name]=a}})}return"majorAxis"===t?i=s.getMajorAxisLabelStyle(e):"minorAxis"===t&&(i=s.getMinorAxisLabelStyle(e)),n.labelStyle=i,n}_getPreferredSize(e,a){return new t.Dimension(e,a)}render(e,t,a){if(this.getCache().clearCache(),e){if(super.render(e,t,a),this.isDndEnabled()){var s=this.getCtx();this.renderAriaLiveRegion("_dvtGanttAriaLiveRegion"+s.getStage().getId())}else this.removeAriaLiveRegion();this._animationManager=new b(this),this._animationManager.prepareForAnimations(),this._dataLayoutManager||(this._dataLayoutManager=new m(this)),this._dataLayoutManager.calcLayout(),C.renderRowAxis(this,this.getParent());var n,r,o=this.getAxisPosition(),h=e.majorAxis;if(h)if(h.scale){if(n=this._bundleTimeAxisOptions(this.Options,"majorAxis"),null==this._majorAxis){this._majorAxis=new i.TimeAxis(this.getCtx(),null,null);var l="alta"===this.getCtx().getThemeBehavior();"top"===o?this._majorAxis.setBorderVisibility(!1,!1,l,!1):this._majorAxis.setBorderVisibility(l,!1,!1,!1),this._slaveAxis=this._majorAxis}this._majorAxis.setCanvasSize(null);var d=this._majorAxis.getPreferredLength(n,this._canvasLength);r&&d>r&&(this._masterAxis=this._majorAxis,this._slaveAxis=this._minorAxis,r=d)}else this._majorAxis=null;if(e.minorAxis){if((n=this._bundleTimeAxisOptions(this.Options,"minorAxis"))._secondaryAxis=this._majorAxis,null==this._minorAxis){var g="alta"===this.getCtx().getThemeBehavior();this._minorAxis=new i.TimeAxis(this.getCtx(),null,null),"top"===o?this._minorAxis.setBorderVisibility(!1,!1,g,!1):this._minorAxis.setBorderVisibility(g,!1,!1,!1),this._masterAxis=this._minorAxis}this._minorAxis.setCanvasSize(null),r=this._minorAxis.getPreferredLength(n,this._canvasLength)}r&&this.setContentLength(r),this._minorAxis&&this._minorAxis.hasValidOptions()&&this.prepareViewportLength(),C.renderGantt(this),this._animationManager.triggerAnimations(),this.UpdateAriaAttributes(),this.Animation||this.RenderComplete(),this._renderState=null,this._isInitialRender=!1}else this._handleResize(t,a)}getAnimationManager(){return this._animationManager}getDataLayoutManager(){return this._dataLayoutManager}isRowsHierarchical(){var e=this.getOptions(),a=e.rowData||e.taskData;return a&&a.getChildDataProvider||t.Agent.isEnvironmentTest()&&this.getOptions().expanded instanceof Set}getViewportYBounds(e){var t=this._backgroundHeight-this.getAxesHeight(),a=0;return null!=e?a=this._translateYToScrollPositionY(e):this._databody&&(a=this._translateYToScrollPositionY(this._databody.getTranslateY())),{yMin:a,yMax:a+t}}getViewPort(){var e=this.getViewportYBounds(),t=this._dataLayoutManager.findRowIndRange(this.getRowLayoutObjs(),e.yMin,e.yMax);return{minRowInd:t.minRowInd,maxRowInd:t.maxRowInd,viewStartTime:this._viewStartTime,viewEndTime:this._viewEndTime}}getViewportDensity(){if(void 0!==this._viewportDensity)return this._viewportDensity;var e=this._dataLayoutManager.getNumViewportTasks();return this._viewportDensity=e<2e3?0:e<5e3?1:2,this._viewportDensity}getRenderingPrecision(){if(void 0!==this._renderingPrecision)return this._renderingPrecision;var e=this.getViewportDensity();return this._renderingPrecision=0===e?null:1===e?1:0,this._renderingPrecision}round(e,t){return Math.round(e*10**t)/10**t}renderViewport(e,a){if(null!=this._databody){this._viewportDensity=void 0,this._renderingPrecision=void 0;var i=this.getViewPort();if(this._dataLayoutManager.renderViewport(i,e),a){var s=this._translateYToScrollPositionY(this._databody.getTranslateY()),n=s-this.getRowLayoutObjs()[i.minRowInd].y,r=t.EventFactory.newGanttScrollPositionChangeEvent(s,i.minRowInd,n);this.dispatchEvent(r)}}}isInitialRender(){return this._isInitialRender}isLastRenderValid(){return this._isLastRenderValid}setIsLastRenderValid(e){this._isLastRenderValid=e}getRenderState(){return this._renderState}setRenderState(e){this._renderState=e}isDndEnabled(){const e=this.isHighLevelDnDEnabled();return this.getEventManager().isDndSupported()&&e}isHighLevelDnDEnabled(){const e=this.isTaskMoveEnabled(),t=this.isTaskResizeEnabled();return e||t}isTaskMoveEnabled(){var e=this.Options.dnd;return e&&e.move&&"enabled"===e.move.tasks}isTaskResizeEnabled(){var e=this.Options.taskDefaults;return e&&"enabled"===e.resizable}scroll(e){if(this.getDatabody()){var t=this.scrollPositionToTranslateY(e);this.isContentDirScrollbarOn()&&this.contentDirScrollbar&&this.contentDirScrollbar.setViewportRange(t-this.getDatabodyHeight(),t),this.setDataRegionTranslateY(t),this.renderViewport(m.VPC_TRANSLATE,!0)}}scrollPositionToTranslateY(e){var t=e.rowIndex,a=this.getRowLayoutObjs(),i=0;if(null!=t){var s=a[t=Math.min(Math.max(0,t),a.length-1)];if(null!=s){var n=null!=e.offsetY?e.offsetY:0;i=s.y+n}}else null!=e.y&&(i=e.y);return this._scrollPositionYToTranslateY(i)}_scrollPositionYToTranslateY(e){return this.getBoundedContentTranslateY(this.getDatabodyStart()-e)}_translateYToScrollPositionY(e){return this._databody?-(e-this.getDatabodyStart()):0}setDataRegionTranslateY(e){this._databody&&this._databody.setTranslateY(e),this._databodyBackground&&this._databodyBackground.setTranslateY(e),this._rowReferenceObjectsContainer&&this._rowReferenceObjectsContainer.setTranslateY(e),this.isMarqueeSelectEnabled()&&this._marqueeArtifactsContainer&&this._marqueeArtifactsContainer.setTranslateY(e),this.isDndEnabled()&&this._dndArtifactsContainer&&this._dndArtifactsContainer.setTranslateY(e),this.isRowAxisEnabled()&&this.getRowAxis().setTranslateY(e+this.getStartYOffset()),this._dependenciesContainer&&this._dependenciesContainer.setTranslateY(e)}processScrollbarEvent(e,t){if(super.processScrollbarEvent(e,t),t===this.timeDirScrollbar&&C._renderAxes(this,this.getTimeZoomCanvas(),!0),t===this.contentDirScrollbar){var a=e.newMax;this.setDataRegionTranslateY(a,!0)}this.renderViewport(m.VPC_TRANSLATE,t===this.contentDirScrollbar)}createViewportChangeEvent(){var e=this._majorAxis?this._majorAxis.getScale():null,a=this._minorAxis?this._minorAxis.getScale():null;return t.EventFactory.newGanttViewportChangeEvent(this._viewStartTime,this._viewEndTime,e,a)}_handleResize(e,t){this.Width=e,this.Height=t,this.applyStyleValues();var a=this.hasValidOptions();if(a&&C.renderRowAxis(this),this.prepareViewportLength(),C._renderBackground(this),a){this.renderTimeZoomCanvas(this._canvas),this.isRowAxisEnabled()&&this.getRowAxis().adjustPosition();var i=this.getTimeZoomCanvas();C._renderAxes(this,i),C._renderDatabodyBackground(this),C._renderRowReferenceObjectsContainer(this),C._renderReferenceObjects(this,i,"area"),C._renderVerticalGridline(this,i),C._renderData(this,null,m.VPC_SCALE),C._renderReferenceObjects(this,i,"line"),C._renderTimeCursor(this,i),C._renderZoomControls(this),this.isMarqueeSelectEnabled()&&C._renderMarqueeArtifactsContainer(this,i),this.isDndEnabled()&&C._renderDnDArtifactsContainer(this,i),(this.isTimeDirScrollbarOn()||this.isContentDirScrollbarOn())&&C._renderScrollbars(this,this)}else C._renderEmptyText(this);C.renderRowAxisVerticalDivider(this,this._canvas),this.Animation||this.RenderComplete()}applyStyleValues(){var e=t.Agent.isRightToLeft(this.getCtx()),a=this.getScrollbarPadding();this._borderWidth=s.getChartStrokeWidth(this.Options);var i=2*this._borderWidth;if(this._widthOffset=0,this.timeDirScrollbarStyles=this.getTimeDirScrollbarStyle(),this.contentDirScrollbarStyles=this.getContentDirScrollbarStyle(),this._backgroundWidth=this.Width,this._backgroundHeight=this.Height,this.isTimeDirScrollbarOn()&&(this._backgroundHeight=this._backgroundHeight-t.CSSStyle.toNumber(this.timeDirScrollbarStyles.getHeight())-3*a),this.isContentDirScrollbarOn()){var n=3*a+t.CSSStyle.toNumber(this.contentDirScrollbarStyles.getWidth());this._backgroundWidth-=n,e&&(this._widthOffset=n)}this.setStartXOffset(this._widthOffset+this._borderWidth),this.setStartYOffset(this._borderWidth);var r=s.getComponentPaddingStart(this.Options);this._backgroundWidth-=r,e||(this._widthOffset+=r,this.setStartXOffset(this.getStartXOffset()+r)),this._canvasLength=this._backgroundWidth-i,this._canvasSize=this._backgroundHeight-i}getBorderWidth(){return this._borderWidth}HandleMouseWheel(e){if(super.HandleMouseWheel(e),this.hasValidOptions())if(!e||e.ctrlKey||t.Agent.isTouchDevice()){if(e.zoomWheelDelta){var i=this.getCtx().pageToStageCoords(e.pageX,e.pageY);if(this.getGraphicalAreaBounds().containsPoint(i.x,i.y)){var s=this.getContentLength()*e.zoomWheelDelta,n=e.zoomTime,r=e.zoomCompLoc;this.handleZoomWheel(s,n,r,!0)}}}else{var o=e.wheelDelta?e.wheelDelta*a.TimeComponent.SCROLL_LINE_HEIGHT:0,h=e.wheelDeltaX?e.wheelDeltaX*a.TimeComponent.SCROLL_LINE_HEIGHT:0;if(this.panBy(-h,-o),e.wheelDeltaX){var l=this.createViewportChangeEvent();this.dispatchEvent(l)}}}handleZoomWheel(e,t,a,i){if(this.isZoomingEnabled()){e>this._masterAxis.getMaxContentLength()?(e=this._masterAxis.getMaxContentLength(),this.disableZoomButton(!0)):this.enableZoomButton(!0),this._canvasLength>e?(e=this._canvasLength,this.disableZoomButton(!1)):this.enableZoomButton(!1);var s=this.getContentLength()<=e;super.handleZoomWheel(e,t,a,i);var n=this._masterAxis.getZoomLevelLengths();if(s)for(;this._masterAxis.getZoomLevelOrder()>0&&(!this._slaveAxis||this._slaveAxis.getZoomLevelOrder()>0);){var r=n[this._masterAxis.getZoomLevelOrder()-1];if(!(this.getContentLength()>=r))break;this._masterAxis.setZoomLevelOrder(this._masterAxis.getZoomLevelOrder()-1),this._masterAxis.decreaseScale(),this._slaveAxis&&(this._slaveAxis.setZoomLevelOrder(this._slaveAxis.getZoomLevelOrder()-1),this._slaveAxis.decreaseScale())}else for(;this._masterAxis.getZoomLevelOrder()<n.length-1&&(!this._slaveAxis||this._slaveAxis.getZoomLevelOrder()<this._slaveAxis.getZoomLevelLengths().length-1)&&(r=n[this._masterAxis.getZoomLevelOrder()],this.getContentLength()<r);)this._masterAxis.setZoomLevelOrder(this._masterAxis.getZoomLevelOrder()+1),this._masterAxis.increaseScale(),this._slaveAxis&&(this._slaveAxis.setZoomLevelOrder(this._slaveAxis.getZoomLevelOrder()+1),this._slaveAxis.increaseScale());this.isTimeDirScrollbarOn()&&this.timeDirScrollbar&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime);var o=this.getTimeZoomCanvas();if(C._renderAxes(this,o,!0),C._renderDatabodyBackground(this),C._renderRowReferenceObjectsContainer(this),C._renderReferenceObjects(this,o,"area"),C._renderVerticalGridline(this,o),C._renderData(this,null,m.VPC_SCALE),C._renderReferenceObjects(this,o,"line"),C._renderTimeCursor(this,o),this.isMarqueeSelectEnabled()&&C._renderMarqueeArtifactsContainer(this,o),this.isDndEnabled()&&C._renderDnDArtifactsContainer(this,o),i){var h=this.createViewportChangeEvent();this.dispatchEvent(h)}}}getMajorAxis(){return this._majorAxis}getMinorAxis(){return this._minorAxis}getTimeAxis(){return this._minorAxis?this._minorAxis:this._majorAxis}getDatabody(){return this._databody}setDatabody(e){this._databody=e}dimDatabody(){this._databody&&!this._isDatabodyDimmed&&t.ToolkitUtils.addClassName(this._databody.getElem(),this.GetStyleClass("databodyDim")),this._isDatabodyDimmed=!0}undimDatabody(){this._databody&&this._isDatabodyDimmed&&t.ToolkitUtils.removeClassName(this._databody.getElem(),this.GetStyleClass("databodyDim")),this._isDatabodyDimmed=!1}getDatabodyBackground(){return this._databodyBackground}setDatabodyBackground(e){this._databodyBackground=e}getDatabodyStart(){return this._databodyStart}setDatabodyStart(e){this._databodyStart=e}getDatabodyHeight(){return this.getCanvasSize()-this.getAxesHeight()}getVerticalGridlines(){return this._gridlines}setVerticalGridlines(e){this._gridlines=e}getReferenceObjects(){return this._referenceObjects||[]}generateReferenceObjects(e,t){const a=[];let i=0,s=0;for(;s<e.length;){var n=e[s];(n.svgStyle||n.svgClassName||n.shortDesc)&&(s>i&&a.push(new y(this,t,e.slice(i,s))),a.push(new y(this,t,[e[s]])),i=s+1),s+=1}return s>i&&a.push(new y(this,t,e.slice(i,s))),a}getReferenceLinesContainer(){return this._refLinesContainer}setReferenceLinesContainer(e){this._refLinesContainer=e}getReferenceAreasContainer(){return this._refAreasContainer}setReferenceAreasContainer(e){this._refAreasContainer=e}getTimeCursorContainer(){return this._timeCursorContainer}setTimeCursorContainer(e){this._timeCursorContainer=e}getTimeCursor(){return this._timeCursor}setTimeCursor(e){this._timeCursor=e}getMarqueeArtifactsContainer(){return this._marqueeArtifactsContainer}setMarqueeArtifactsContainer(e){this._marqueeArtifactsContainer=e}getDnDArtifactsContainer(){return this._dndArtifactsContainer}setDnDArtifactsContainer(e){this._dndArtifactsContainer=e}getRowReferenceObjectsContainer(){return this._rowReferenceObjectsContainer}setRowReferenceObjectsContainer(e){this._rowReferenceObjectsContainer=e}setEmptyText(e){this._emptyText=e}removeEmptyText(){if(this._emptyText&&this._emptyText.getParent()){this._emptyText.getParent().removeChild(this._emptyText),delete this._emptyText,this._emptyText=null;let e=this.getEventManager(),t=e.getFocus();t&&t.getId&&"noDataPeer"===t.getId()&&e.setFocus(null)}}getRowsData(){return this._rowsData}getRowLayoutObjs(){return this._dataLayoutManager.getRowObjs()}getDependencyLayoutObjs(){return this._dataLayoutManager.getDependencyObjs()}setRows(e){this._rows=e}getCurrentRow(){return this._currentRow}setCurrentRow(e){this._currentRow=e}getAxisPosition(){return this._axisPosition}getAxisHeight(e,t){return s.getTimeAxisHeight(e,t)}getStartTime(){return this._start}getEndTime(){return this._end}getHoverBehavior(){return"none"}isHorizontalGridlinesVisible(){return"visible"===this._horizontalGridline}isVerticalGridlinesVisible(){return"visible"===this._verticalGridline}getContentHeight(){return this._dataLayoutManager.getContentHeight()}getAxesHeight(){var e=0;return this._majorAxis&&(e+=this._majorAxis.getSize()),this._minorAxis&&(e+=this._minorAxis.getSize()),e}isRowAxisEnabled(){var e="on"===this._rowAxisRendered,t=this.getRowLayoutObjs().length>0;return e&&t}getRowAxisWidth(){return this._rowAxisWidth}getRowAxisMaxWidth(){return this._rowAxisMaxWidth}getRowAxis(){return this._rowAxis}setRowAxis(e){this._rowAxis=e}getViewportDimensions(){return new t.Rectangle(this.getStartXOffset()-this.getTimeZoomCanvas().getTranslateX(),this._databodyStart-this._databody.getTranslateY(),this._canvasLength,this._canvasSize-this.getAxesHeight())}scrollIntoView(e,a,i,s){var n=t.Agent.isRightToLeft(this.getCtx()),r=this.getViewportDimensions(),o=0,h=0;a=a||"auto",i=i||"auto",s=s||0;var l=Math.min(e.x-r.x-s,0),d=Math.max(0,e.x+e.w-(r.x+r.w)+s),g=n?d:l,_=n?l:d;switch(a){case"start":o=g;break;case"end":o=_;break;default:o=(n?_<0:_>0)?_:g}var c=Math.min(e.y-r.y-s,0),u=Math.max(0,e.y+e.h-(r.y+r.h)+s);switch(i){case"top":h=c;break;case"bottom":h=u;break;default:h=c<0?c:u}this.panBy(o,h,!0)}autoPanOnEdgeDrag(e,t,a,i){var s=this.getViewportDimensions(),n=0,r=0;if(!a){var o=Math.max(e.x-s.x,0),h=Math.max(s.x+s.w-e.x,0);o<t?(n=o-t,n=Math.max(n,-s.x)):h<t&&(n=t-h,n=Math.min(n,this.getContentLength()-(s.x+s.w)))}if(!i){var l=Math.max(e.y-s.y,0),d=Math.max(s.y+s.h-e.y,0);l<t?(r=l-t,r=Math.max(r,-s.y)):d<t&&(r=t-d,r=this.getContentHeight()+this._databodyStart>=this._canvasSize?"bottom"===this.getAxisPosition()?Math.min(r,this._databody.getTranslateY()+this.getContentHeight()-s.h):Math.min(r,this._databody.getTranslateY()+this.getContentHeight()-this._canvasSize):Math.min(r,-s.y))}return this.panBy(n,r,!0),{deltaX:n,deltaY:r}}panBy(e,t,a){if(0!==e||0!==t){a=void 0!==a?a:"alta"!==this.getCtx().getThemeBehavior();var i=0!==e&&(a||Math.abs(e)>Math.abs(t)),s=this._databody&&0!==t&&(a||Math.abs(t)>Math.abs(e));if(i&&super.panBy(e,0),s){var n=this.getBoundedContentTranslateY(this._databody.getTranslateY()-t);this.isContentDirScrollbarOn()&&this.contentDirScrollbar.setViewportRange(n-this.getDatabodyHeight(),n),this.setDataRegionTranslateY(n,!0)}this.isTimeDirScrollbarOn()&&this.timeDirScrollbar&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime),this.renderViewport(m.VPC_TRANSLATE,s),i&&C._renderAxes(this,this.getTimeZoomCanvas(),!0)}}getBoundedContentTranslateY(e){var t=this.getContentHeight();if(null==t)return e;var a=this.getDatabodyHeight(),i=this.getDatabodyStart(),s=i+Math.min(0,a-t);return Math.min(i,Math.max(e,s))}beginDragPan(e,t){super.beginDragPan(e,t),this._currentViewStartTime=this._viewStartTime,this._currentViewEndTime=this._viewEndTime}endDragPan(e,t){this._currentViewStartTime===this._viewStartTime&&this._currentViewEndTime===this._viewEndTime&&(this._triggerViewportChange=!1),super.endDragPan(e,t)}setTaskBrightness(e,t){null!=(e=this.findTaskNodeById(e.getId()))&&(t?e.darken():e.brighten())}findTaskNodeById(e){var a=this.getCtx(),i=this.getRows();if(i)for(var s=0;s<i.length;s++)for(var n=i[s].getTasks(),r=0;r<n.length;r++)if(t.Obj.compareValues(a,e,n[r].getId()))return n[r];return null}hasValidOptions(){var e=!this._majorAxis||this._majorAxis.hasValidOptions(),t=this._minorAxis&&this._minorAxis.hasValidOptions(),a=this._start&&this._end&&this._end>this._start,i=!this._viewStartTime||!this._viewEndTime||this._viewEndTime>this._viewStartTime,s=!this._viewStartTime||this._viewStartTime>=this._start&&this._viewStartTime<this._end,n=!this._viewEndTime||this._viewEndTime>this._start&&this._viewEndTime<=this._end;return e&&t&&a&&i&&s&&n}getSelectionHandler(){return this._selectionHandler}isSelectionSupported(){return!!this._selectionHandler}setSelectionMode(e){this._selectionHandler="single"===e?new t.SelectionHandler(this.getCtx(),t.SelectionHandler.TYPE_SINGLE):"multiple"===e?new t.SelectionHandler(this.getCtx(),t.SelectionHandler.TYPE_MULTIPLE):null,this.getEventManager().setSelectionHandler(this._selectionHandler)}select(e){this.isLastRenderValid()&&(this.Options.selection=t.JsonUtils.clone(e),this._processInitialSelections())}_processInitialSelections(){var e=this.Options.selection;if(null!=e&&0!==e.length&&this.isSelectionSupported()){for(var t=new this._context.KeySetImpl(e),a=this.getRowLayoutObjs(),i=[],s=0;s<a.length;s++)for(var n=a[s].taskObjs,r=0;r<n.length;r++){var o=n[r];if(t.has(o.id)){this._dataLayoutManager.ensureInDOM(o,"task");var h=o.node;i.push(h)}}this.getSelectionHandler().processInitialSelections(e,i)}}getDependenciesContainer(){return this._dependenciesContainer}setDependenciesContainer(e){this._dependenciesContainer=e}setDefaultMarkerId(e){this._markerId=e}getDefaultMarkerId(){return this._markerId}getNavigableDependencyLinesForTask(e,t){return"successor"===t?e.getSuccessorDependencies():e.getPredecessorDependencies()}HandleTouchStart(e){}}e.Gantt=E,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojgantt-toolkit.js.map