/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore-base","knockout","ojs/ojconfig","ojs/ojlogger","ojs/ojhtmlutils"],function(e,t,n,r,i){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e;const o=function(){this.Init()};function a(e,r){return function(i,o,a,s){var u=n.getExpressionEvaluator();if(!u)return e(i,o,a,s);var c=function(e,n,r,i){var o=i[e];if(!o){var a=t.expressionRewriting.preProcessBindings(e,n);o=r.createEvaluator("{"+a+"}").evaluate,i[e]=o}return o}(i,s,u,r);return c([o.$data||{},o,{$element:a}])}}e.Object.createSubclass(o,e.Object,"ComponentBinding.GlobalChangeQueue"),o.prototype.Init=function(){o.superclass.Init.call(this),this._trackers=[],this._queue=[]},o.prototype.registerComponentChanges=function(t){-1===this._trackers.indexOf(t)&&(this._trackers.push(t),this._delayTimer||(this._delayTimer=setTimeout(e.Object.createCallback(this,this._deliverChangesImpl),1),this._delayPromise=new Promise(function(e){this._delayPromiseResolver=e}.bind(this))))},o.prototype.deliverChanges=function(){this._delayTimer&&clearTimeout(this._delayTimer),this._deliverChangesImpl()},o.prototype.getThrottlePromise=function(){return this._delayPromise||Promise.resolve()},o.prototype._deliverChangesImpl=function(){this._delayTimer=null,this._resolveDelayPromise();var e=this._trackers;this._trackers=[];for(var t=0;t<e.length;t++){var n=e[t];this._queue.push({tracker:n,changes:n.flushChanges()})}for(;this._queue.length>0;){var r=this._queue.shift();r.tracker.applyChanges(r.changes)}},o.prototype._resolveDelayPromise=function(){this._delayPromise&&(this._delayPromiseResolver(),this._delayPromiseResolver=null,this._delayPromise=null)};const s=(new function(){var e=new WeakMap,s={},u={},c={},l="_ojExtended",p="_ojCacheScope",d=new o;function h(e){var t,r=n.getExpressionEvaluator();if(r){var i=r.createEvaluator(e).evaluate;return function(e,t){return i([e,e.$data||{},{$element:t}])}}try{t=new Function("$context","$element","with($context.$data||{}){with($context){return "+e+"}}")}catch(t){throw new Error(t.message+' in expression "'+e+'"')}return t}function f(t,n,r){if(!r)return t(n,r);var i,o=e,a=r[p]||r;(i=o.get(a))||(i={},o.set(a,i));var s=i[n];return s||(s=t(n,r),i[n]=s),s}function v(e,t,n){var r=t.getBindingsString;if(r)return r.call(t,e,n);switch(e.nodeType){case 1:return e.getAttribute("data-bind");case 8:var i=e.nodeValue.match(/^\s*ko(?:\s+([\s\S]+))?\s*$/);return i?i[1]:null;default:return null}}this.install=function(){var e=t.bindingProvider,n="instance",o=e[n],p="getBindingAccessors";if(!o[p])return r.error("JET's Knockout bindings are not compatible with the current binding provider since it does not implement getBindingAccessors()"),this;var d={getWrapped:function(){return o}};e[n]=d;var g,m,y,E=[];return E.push(p,"nodeHasBindings","getBindings"),E.forEach(function(e){d[e]=function(e,n,r){var i="nodeHasBindings"===n;return function(o){if(i){var a=o.nodeType;if(1!==a&&8!==a)return!1}var u=r(n,e[n]),c=u?u.apply(e,arguments):null,l=s[n];if(null!=l){var p=arguments;l.forEach(function(n){var r=Array.prototype.slice.call(p);r.push(c,e),c=t.ignoreDependencies(n,null,r)})}return c}}(o,e,function(e,n){return e!==p?n:function(e,n){return function(r,i){if(i[l]){var o=v(r,n,i),a=o?function(e,n){return f(function(e){return h("{"+t.expressionRewriting.preProcessBindings(e,{valueAccessors:!0})+"}")},e,n)}(o,i)(i,r):null;if(1===r.nodeType&&t.components.isRegistered(r.tagName.toLowerCase())){var s=e.call(n,r,i).component;s&&((a=a||{}).component=s)}return a}return e.call(n,r,i)}}(n,o)})}),d.preprocessNode=function(e){var n=e.preprocessNode;return function(r){var i,o,a=null;return 1===r.nodeType&&(i=u[r.nodeName.toLowerCase()]),i||(i=n,a=e),i&&(o=t.ignoreDependencies(i,a,[r])),Array.isArray(o)&&(o=function(e,n){var r=t.bindingProvider.instance,i=n.slice(0),o=n[0],a=0,s=0;for(;a>=0;){var u=t.virtualElements.nextSibling(o);if(o!==e){var c=r.preprocessNode(o);Array.isArray(c)&&(i.splice.apply(i,[s,1].concat(c)),s+=c.length-1)}s+=1;var l=a+1;s+=(a=(o=u)?n.indexOf(o,l):-1)-l}return i}(r,o)),o}}(o),g=t.nativeTemplateEngine.prototype,y=g[m="renderTemplateSource"],g[m]=function(e,t,n,r){return y.call(this,e,t,n,r||document)},function(){const e=t.templateSources.domElement.prototype,n="nodes",r=e[n];e[n]=function(){const e=r.apply(this,arguments);return e&&11===e.nodeType?document.importNode(e,!0):e}}(),t.components.loaders.unshift({loadTemplate:function(e,n,r){var o;if("string"==typeof n)o=t.utils.parseHtmlFragment(n,document);else if(n.element){var a=n.element;if(a instanceof HTMLElement)o=i.getTemplateContent(a);else{if("string"!=typeof a)throw new Error(`Unknown element type: ${a}`);var s=document.getElementById(a);if(!s)throw new Error(`Cannot find element with ID ${a}`);o=i.getTemplateContent(s)}}o?t.components.defaultLoader.loadTemplate(e,o,r):r(null)}}),function(e){var n,i=t.bindingProvider.instance,o="parseBindingsString";for(;i&&!n;){var s=i[o];s?(n=!0,i[o]=a(s.bind(i),e)):i=i.getWrapped?i.getWrapped():null}n||r.error("Unable to patch KO expression evaluation implementation. If you have a custom binding provider, make sure it implements the getWrapped() method that returns the default binding provider instance.")}(c),this},this.addPostprocessor=function(e){Object.keys(e).forEach(function(t){s[t]=s[t]||[],s[t].push(e[t])})},this.registerPreprocessor=function(e,t){u[e]=t},this.getBindingsString=function(e,t,n){return v(e,t,n)},this.extendBindingContext=function(e,t,n,r,i){var o={$current:t,$root:void 0,$parent:void 0,$parents:void 0};return n&&(o[n]=t),r&&(o[r]=t),e?o=e.extend(o):o.$data={},Object.defineProperty(o,p,{value:i}),Object.defineProperty(o,l,{value:!0}),o},this.createBindingExpressionEvaluator=function(e,t){if(t[l])return h(e);var r,i=n.getExpressionEvaluator();if(i){var o=i.createEvaluator(e).evaluate;return function(e){return o([e.$data||{},e])}}try{r=new Function("$context","with($context){with($data||{}){return "+e+";}}")}catch(t){throw new Error(t.message+' in expression "'+e+'"')}return r},this.createEvaluator=function(e,t){return f(this.createBindingExpressionEvaluator,e,t)},this.getGlobalChangeQueue=function(){return d}}).install();return s});
//# sourceMappingURL=ojkoshared.js.map