/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","jquery","ojs/ojcomponentcore","ojs/ojlogger","ojs/ojdomutils","ojs/ojpreact-patch","jqueryui-amd/position","ojs/ojcontext","preact/jsx-runtime","preact","ojs/ojcustomelement-utils"],function(t,e,o,i,n,r,s,a,l,c,p,u){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l;const _=function(t){this._tapCallback=t,this.Init()};e._registerLegacyNamespaceProp("SimpleTapRecognizer",_),e.Object.createSubclass(_,e.Object,"oj.SimpleTapRecognizer"),_.prototype.Init=function(){_.superclass.Init.call(this);var t=this._eventHandler.bind(this);this._eventHandlerCallback=t;for(var e,o=document.documentElement,i=0;i<_._TOUCHEVENTS.length;i++)"touchstart"===(e=_._TOUCHEVENTS[i])||"touchmove"===e?o.addEventListener(e,t,{passive:!1,capture:!0}):o.addEventListener(e,t,!0)},_.prototype._eventHandler=function(t){var e=this._tapCallback,o=t.type;if("touchstart"===o)this._touchStartEvent=t,this._touchStartEvent._tapStart=(new Date).getTime();else if("touchmove"===o||"touchcancel"===o)this._touchStartEvent=null;else if("touchend"===o){if(this._touchStartEvent){var i=this._touchStartEvent._tapStart;if(isNaN(i))e(this._touchStartEvent);else(new Date).getTime()-i<_._PRESSHOLDTHRESSHOLD&&e(this._touchStartEvent)}this._touchStartEvent=null}},_.prototype.destroy=function(){this._tapCallback=null;var t=this._eventHandlerCallback;this._eventHandlerCallback=null;for(var e,o=document.documentElement,i=0;i<_._TOUCHEVENTS.length;i++)"touchstart"===(e=_._TOUCHEVENTS[i])||"touchmove"===e?o.removeEventListener(e,t,{passive:!1,capture:!0}):o.removeEventListener(e,t,!0)},_._TOUCHEVENTS=["touchstart","touchmove","touchcancel","touchend"],_._PRESSHOLDTHRESSHOLD=700;const d=function(){this.Init()};e._registerLegacyNamespaceProp("PopupService",d),e.Object.createSubclass(d,e.Object,"oj.PopupService");const f=function(){this.Init()},h={};d.prototype.Init=function(){d.superclass.Init.call(this)},d.getInstance=function(t){return d._popupService||(d._popupService=new f),d._popupService},d.prototype.open=function(t){e.Assert.failedInAbstractFunction()},d.prototype.close=function(t){e.Assert.failedInAbstractFunction()},d.prototype.changeOptions=function(t){e.Assert.failedInAbstractFunction()},d.prototype.triggerOnDescendents=function(t,o,i){e.Assert.failedInAbstractFunction()},d.prototype.destroy=function(){d._popupService=null},d.MODALITY={NONE:"none",MODAL:"modal",MODELESS:"modeless"},d.EVENT={POPUP_REMOVE:"ojPopupRemove",POPUP_CLOSE:"ojPopupClose",POPUP_REFRESH:"ojPopupRefresh",POPUP_AUTODISMISS:"ojPopupAutoDismiss",POPUP_BEFORE_OPEN:"ojPopupBeforeOpen",POPUP_AFTER_OPEN:"ojPopupAfterOpen",POPUP_BEFORE_CLOSE:"ojPopupBeforeClose",POPUP_AFTER_CLOSE:"ojPopupAfterClose"},d.LAYER_LEVEL={TOP_LEVEL:"topLevel",NEAREST_ANCESTOR:"nearestAncestor"},d.OPTION={POPUP:"popup",EVENTS:"events",MODALITY:"modality",LAUNCHER:"launcher",POSITION:"position",LAYER_SELECTORS:"layerSelectors",LAYER_LEVEL:"layerLevel",CONTEXT:"context",CUSTOM_ELEMENT:"customElement"},e.__registerWidget("oj.ojSurrogate",o.oj.baseComponent,{version:"1.0.0",widgetEventPrefix:"oj",options:{beforeDestroy:null},_ComponentCreate:function(){this._super(),this.element.uniqueId()},_invokeBeforeDestroy:function(){var t=this.options.beforeDestroy;this.options.beforeDestroy=null,t&&t()},_destroy:function(){this._invokeBeforeDestroy(),this.element.removeUniqueId(),this._super()},_NotifyDetached:function(){this._invokeBeforeDestroy(),this._super()},$$cleanElement:function(){this._invokeBeforeDestroy()}});e.CustomElementBridge.register("oj-surrogate",{metadata:{properties:{beforeDestroy:{type:"function"}},methods:{$$cleanElement:{}},extension:{_WIDGET_NAME:"ojSurrogate"}}}),e._registerLegacyNamespaceProp("PopupServiceImpl",f),e.Object.createSubclass(f,d,"oj.PopupServiceImpl"),f.prototype.open=function(t){e.Assert.assertObject(t);var s=o(t[d.OPTION.POPUP]);e.Assert.assertPrototype(s,o);var a=h.getStatus(s);if(a===h.STATUS.UNKNOWN||a===h.STATUS.BEFORE_OPEN||a===h.STATUS.CLOSE){var l=o(t[d.OPTION.LAUNCHER]);e.Assert.assertPrototype(l,o);var c=t[d.OPTION.POSITION];e.Assert.assertObjectOrNull(c);var p=t[d.OPTION.EVENTS];e.Assert.assertObject(p);var u=t[d.OPTION.MODALITY];(!u||d.MODALITY.MODELESS!==u&&d.MODALITY.MODAL!==u)&&(u=d.MODALITY.NONE);var _=t[d.OPTION.LAYER_SELECTORS];e.Assert.assertString(_);var E=t[d.OPTION.CUSTOM_ELEMENT],g=t[d.OPTION.LAYER_LEVEL];(!g||d.LAYER_LEVEL.TOP_LEVEL!==g&&d.LAYER_LEVEL.NEAREST_ANCESTOR!==g)&&(g=d.LAYER_LEVEL.NEAREST_ANCESTOR);var v=p[d.EVENT.POPUP_BEFORE_OPEN];v&&o.isFunction(v)||(v=f._defaultBeforeOpenCallback);var O=p[d.EVENT.POPUP_AFTER_OPEN];h.setStatus(s,h.STATUS.OPENING),r.setLogicalParent(s,l),h.addToAncestorLayer(s,l,u,_,g,E);var T,S=function(){try{s.removeAttr("aria-hidden"),this._assertEventSink()}catch(t){n.error("Error opening popup:\n%o",t)}finally{h.setStatus(s,h.STATUS.OPEN),O&&O(t);var i=h.getFirstAncestorLayer(s);if(e.Assert.assertPrototype(i,o),h.applyEvents(i,p),!h._getSurrogate(i)&&o.isFunction(p[d.EVENT.POPUP_REMOVE]))(0,p[d.EVENT.POPUP_REMOVE])()}};S=S.bind(this);try{T=v(t),i.subtreeShown(s[0])}catch(t){n.error("Error before open popup:\n%o",t)}finally{T&&T instanceof Promise?T.then(S):S()}}else this._assertEventSink()},f._defaultBeforeOpenCallback=function(t){var i=o(t[d.OPTION.POPUP]);e.Assert.assertPrototype(i,o);var n=t[d.OPTION.POSITION];i.show(),n&&i.position(n)},f.prototype.close=function(t){e.Assert.assertObject(t);var s=o(t[d.OPTION.POPUP]);e.Assert.assertPrototype(s,o);var a=h.getOpenPopupLayer(s);e.Assert.assertPrototype(a,o);var l=t[d.OPTION.EVENTS];l?l=o.extend(h.getEvents(a),l):(l=h.getEvents(a),t[d.OPTION.EVENTS]=l);var c=h.getStatus(s);if(c!==h.STATUS.OPEN&&c!==h.STATUS.BEFORE_CLOSE||!l)this._assertEventSink();else{var p=l[d.EVENT.POPUP_BEFORE_CLOSE];p&&o.isFunction(p)||(p=f._defaultBeforeCloseCallback);var u=l[d.EVENT.POPUP_AFTER_CLOSE];h.setStatus(s,h.STATUS.CLOSING),h.applyEvents(a,{}),s.attr("aria-hidden","true");var _,E=function(){try{s.hide(),null!==t[d.OPTION.POSITION]&&s.css({top:"auto",bottom:"auto",left:"auto",right:"auto"}),h.removeFromAncestorLayer(s),r.setLogicalParent(s,null),this._assertEventSink(),i.subtreeHidden(s[0])}catch(t){n.error("Error closing popup:\n%o",t)}finally{h.setStatus(s,h.STATUS.CLOSE),u&&o.isFunction(u)&&u(t)}};E=E.bind(this);try{_=p(t)}catch(t){n.error("Error before close popup:\n%o",t)}finally{_&&_ instanceof Promise?_.then(E):E()}}},f._defaultBeforeCloseCallback=function(t){var i=o(t[d.OPTION.POPUP]);e.Assert.assertPrototype(i,o),i.hide()},f.prototype.changeOptions=function(t){e.Assert.assertObject(t);var i=o(t[d.OPTION.POPUP]);if(e.Assert.assertPrototype(i,o),h.getStatus(i)===h.STATUS.OPEN){var n=h.getOpenPopupLayer(i);e.Assert.assertPrototype(n,o);var r=t[d.OPTION.EVENTS];r&&h.applyEvents(n,r);var s=t[d.OPTION.MODALITY];s&&h.applyModality(n,i,s);var a=t[d.OPTION.LAYER_SELECTORS];e.StringUtils.isEmptyOrUndefined(a)||n.attr("class",a)}},f.prototype.triggerOnDescendents=function(t,e,o){if(h.isPopupOpen(t)){var i={};i.event=e,i.argsArray=o;var n=h.getFirstAncestorLayer(t);h.postOrderVisit(n,this._triggerOnDescendentsVisitCallback,i)}},f.prototype._triggerOnDescendentsVisitCallback=function(t,e){var i=e.event,n=e.argsArray,r=h.getEvents(t);return r&&o.isFunction(r[i])&&r[i].apply(this,n),h.VISIT_RESULT.ACCEPT},f.prototype._assertEventSink=function(){var t,e,o,i=h.hasPopupsOpen(),n=this._callbackEventFilter;if(!i&&n){for(window.removeEventListener("resize",f._refreshCallback,!0),window.removeEventListener("scroll",f._refreshCallback,!0),(e=document.documentElement).removeEventListener("mousewheel",f._refreshCallback,{passive:!0,capture:!0}),e.removeEventListener("DOMMouseScroll",f._refreshCallback,!0),this._callbackEventFilter=null,t=0;t<f._REDISTRIBUTE_EVENTS.length;t++)o=f._REDISTRIBUTE_EVENTS[t],e.removeEventListener(o,n,!0);var s=this._simpleTapRecognizer;s&&(s.destroy(),this._simpleTapRecognizer=null)}else if(i&&!n){for(window.addEventListener("resize",f._refreshCallback,!0),window.addEventListener("scroll",f._refreshCallback,!0),(e=document.documentElement).addEventListener("mousewheel",f._refreshCallback,{passive:!0,capture:!0}),e.addEventListener("DOMMouseScroll",f._refreshCallback,!0),n=this._eventFilterCallback.bind(this),this._callbackEventFilter=n,t=0;t<f._REDISTRIBUTE_EVENTS.length;t++)o=f._REDISTRIBUTE_EVENTS[t],e.addEventListener(o,n,!0);r.isTouchSupported()&&(this._simpleTapRecognizer=new _(n))}},f.prototype._eventFilterCallback=function(t){var e=o(t.target);if(h.hasPopupsOpen()){if(!r.isChromeEvent(t)&&("focus"!==t.type||e.is(":focusable"))){var i=h.getDefaultLayer();if("keydown"!==t.type||!h.hasModalDialogOpen()||r.isAncestor(i[0],e[0])){var n=h.getFirstAncestorLayer(e),s=i.find("."+f._FOCUS_WITHIN_SELECTOR).first(),a=t.target.classList.contains(h._OVERLAY_SELECTOR);if(i[0]!==n[0]?n.hasClass(f._FOCUS_WITHIN_SELECTOR)||(s.length&&s.removeClass(f._FOCUS_WITHIN_SELECTOR),n.addClass(f._FOCUS_WITHIN_SELECTOR)):s.length&&!a&&s.removeClass(f._FOCUS_WITHIN_SELECTOR),"focus"!==t.type||"-1"!==e.attr("tabindex")){var l={};l.targetIsOverlay=a;for(var c=f._COPY_SAFE_EVENT_PROPERTIES,p={},u=0;u<c.length;u++){var _=c[u],d=t[_];void 0===d||o.isFunction(d)||(p[_]=d)}l.event=o.Event(t,p),h.postOrderVisit(i,f._redistributeVisitCallback,l)}}else h.eatEvent(t)}}else this._assertEventSink()},f._redistributeVisitCallback=function(t,e){var i=h.getEvents(t),n=e.event;return i&&o.isFunction(i[d.EVENT.POPUP_AUTODISMISS])?i[d.EVENT.POPUP_AUTODISMISS](n):"mousedown"===n.type&&e.targetIsOverlay&&n.preventDefault(),h.VISIT_RESULT.ACCEPT},f._refreshCallback=function(t){isNaN(f._refreshTimerId)&&(f._refreshTimerId=window.setTimeout(function(){f._refreshTimerId=Number.NaN;var t=h.getDefaultLayer();o.isFunction(window.requestAnimationFrame)?f._afRequestId=window.requestAnimationFrame(function(){f._afRequestId=null,h.postOrderVisit(t,f._refreshVisitCallback)}):h.postOrderVisit(t,f._refreshVisitCallback)},f._REFRESH_DELAY))},f._refreshVisitCallback=function(t,e){if(e.level>0)return h.VISIT_RESULT.REJECT;var i=h.getEvents(t);return i&&o.isFunction(i[d.EVENT.POPUP_REFRESH])&&i[d.EVENT.POPUP_REFRESH](),h.VISIT_RESULT.ACCEPT},f.prototype.destroy=function(){f.superclass.destroy.call(this)},f._FOCUS_WITHIN_SELECTOR="oj-focus-within",f._REDISTRIBUTE_EVENTS=["focus","mousedown","keydown"],f._COPY_SAFE_EVENT_PROPERTIES=["altKey","bubbles","cancelable","ctrlKey","currentTarget","eventPhase","metaKey","relatedTarget","shiftKey","target","timeStamp","view","which","button","buttons","clientX","clientY","offsetX","offsetY","pageX","pageY","screenX","screenY","toElement","char","charCode","key","keyCode"],f._REFRESH_DELAY=10,e._registerLegacyNamespaceProp("ZOrderUtils",h),h.STATUS={UNKNOWN:0,BEFORE_OPEN:.5,OPENING:1,OPEN:2,BEFORE_CLOSE:2.5,CLOSING:3,CLOSE:4},h._STATUS_DATA="oj-popup-status",h.getStatus=function(t){t instanceof Element&&(t=o(t));var e=t.data(h._STATUS_DATA);return isNaN(e)?h.STATUS.UNKNOWN:e},h.setStatus=function(t,e){t instanceof Element&&(t=o(t)),e>=h.STATUS.UNKNOWN&&e<=h.STATUS.CLOSE&&t.data(h._STATUS_DATA,e)},h.getFirstAncestorLayer=function(t){if(!t)return h.getDefaultLayer();for(var e=t;e&&e.length>0&&e.attr(h._SURROGATE_ATTR)!==h._DEFAULT_LAYER_ID;){if(h._hasSurrogate(e[0]))return e;e=e.parent()}return h.getDefaultLayer()},h.getDefaultLayer=function(){var t=o(document.getElementById(h._DEFAULT_LAYER_ID));return t.length>0||((t=o("<div>")).attr("role","presentation"),t.attr("id",h._DEFAULT_LAYER_ID),t.prependTo(o(document.body))),t},h.addToAncestorLayer=function(t,n,r,s,a,l){var c=t[0];if(h._hasSurrogate(c.parentNode))throw new Error("JET Popup is already open - id: "+c.getAttribute("id"));var p=h.getFirstAncestorLayer(a===d.LAYER_LEVEL.TOP_LEVEL?null:n),u=o("<div>"),_=t.attr("id");e.StringUtils.isEmptyOrUndefined(_)?u.uniqueId():u.attr("id",[_,"layer"].join("_")),u.attr("role","presentation"),u.addClass(s),t.after(u);const f=h._createSurrogate(u,l);i.subtreeDetached(c),t.appendTo(u),t.data(h._LAYER_ID_DATA,u.attr("id")),u.appendTo(p),i.subtreeAttached(c),h._applyVDomPatch(f[0],c),h.applyModality(u,t,r)},h._applyVDomPatch=function(t,e){t[s.OJ_POPUP]=e,s.patchPopupParent(t.parentElement)},h._getSurrogate=function(t){var e=t.attr(h._SURROGATE_ATTR);if(e)return document.getElementById(e)},h.applyEvents=function(t,e,n){n||(n=o(h._getSurrogate(t))),t.data(h._EVENTS_DATA,e),n.length>0&&e&&o.isFunction(e[d.EVENT.POPUP_REMOVE])&&i.setComponentOption(n[0],"beforeDestroy",e[d.EVENT.POPUP_REMOVE])},h.getEvents=function(t){return t.data(h._EVENTS_DATA)},h._createSurrogate=function(t,i){var n="script";i&&(n="oj-surrogate");var r=o(document.createElement(n)),s=t.attr("id");e.StringUtils.isEmptyOrUndefined(s)||r.attr("id",[s,"surrogate"].join("_")),i&&r.attr("data-oj-binding-provider","none"),r.insertBefore(t),i||r.ojSurrogate();var a=r.attr("id");return t.attr(h._SURROGATE_ATTR,a),r},h._removeSurrogate=function(t){var e=t.attr(h._SURROGATE_ATTR);t.removeAttr(h._SURROGATE_ATTR);var n=o(document.getElementById(e)),r=n.length>0;return r&&(t.insertAfter(n),i.setComponentOption(n[0],"beforeDestroy",null),n.remove()),r},h.getOpenPopupLayer=function(t){var e=t.parent();if(!e||0===e.length){var i=t.data(h._LAYER_ID_DATA);e=o(document.getElementById(i))}return e},h.removeFromAncestorLayer=function(t){var e=h.getOpenPopupLayer(t);h.preOrderVisit(e,h._closeDescendantPopupsCallback),h._removeOverlayFromAncestorLayer(e),h._resetAriaHiddenOnBackround(e),h._restoreBodyOverflow(),e.removeData(h._EVENTS_DATA),e.removeData(h._MODALITY_DATA),t.removeData(h._LAYER_ID_DATA);var o=t[0];i.subtreeDetached(o),h._removeSurrogate(e)&&o&&o.parentElement?(r.unwrap(t,e),i.subtreeAttached(o)):e.remove()},h._closeDescendantPopupsCallback=function(t,e){if(e.level>0)return h.VISIT_RESULT.REJECT;var i=t.data(h._EVENTS_DATA);return i&&o.isFunction(i[d.EVENT.POPUP_CLOSE])&&i[d.EVENT.POPUP_CLOSE](),h.VISIT_RESULT.ACCEPT},h._disableBodyOverflow=function(t){const i=document.body,n=t.children()[0];if(Math.floor(o(n).width())<=window.innerWidth&&Math.floor(o(n).height())<=window.innerHeight)if(e.AgentUtils.getAgentInfo().os===e.AgentUtils.OS.IOS){if(this._iosScrollLockBackup)return;const t=window.visualViewport.offsetLeft,e=window.visualViewport.offsetTop,o=window.pageXOffset,n=window.pageYOffset;this._iosScrollLockBackup={windowScrollX:o,windowScrollY:n,bodyPosition:i.style.position,bodyOverflow:i.style.overflow,bodyTop:i.style.top,bodyLeft:i.style.left,bodyRight:i.style.right},i.style.position="fixed",i.style.overflow="hidden",i.style.top=-(n-Math.floor(e))+"px",i.style.left=-(o-Math.floor(t))+"px",i.style.right="0"}else i.classList.add("oj-component-modal-open")},h._restoreBodyOverflow=function(){if(!h.hasModalDialogOpen()){const t=document.body;if(e.AgentUtils.getAgentInfo().os===e.AgentUtils.OS.IOS){if(!this._iosScrollLockBackup)return;const e=this._iosScrollLockBackup;t.style.position=e.bodyPosition,t.style.overflow=e.bodyOverflow,t.style.top=e.bodyTop,t.style.left=e.bodyLeft,t.style.right=e.bodyRight,window.scrollTo(e.windowScrollX,e.windowScrollY),delete this._iosScrollLockBackup}else t.classList.remove("oj-component-modal-open")}},h._removeFocusWithinFromOverlayedContent=function(){var t=h.getDefaultLayer().find("."+f._FOCUS_WITHIN_SELECTOR).first();t.length&&t.removeClass(f._FOCUS_WITHIN_SELECTOR)},h.applyModality=function(t,o,i){var n=t.data(h._MODALITY_DATA);t.data(h._MODALITY_DATA,i),e.StringUtils.isEmptyOrUndefined(n)?d.MODALITY.MODAL===i?(h._addOverlayToAncestorLayer(t),h._disableBodyOverflow(t),h._removeFocusWithinFromOverlayedContent(),h._setAriaHiddenOnBackround(t)):h._removeOverlayFromAncestorLayer(t):n!==i&&(i===d.MODALITY.MODAL?(h._addOverlayToAncestorLayer(t),h._disableBodyOverflow(t),h._removeFocusWithinFromOverlayedContent(),h._setAriaHiddenOnBackround(t)):(h._removeOverlayFromAncestorLayer(t),h._restoreBodyOverflow(),h._resetAriaHiddenOnBackround(t))),i===d.MODALITY.MODAL?o.attr("aria-modal","true"):o.removeAttr("aria-modal")},h._setAriaHiddenOnBackround=function(t){var e=t,i=o();do{i=i.add(e.siblings(':not(script):not([aria-hidden="true"])')),e=e.parent()}while("body"!==e[0].tagName.toLowerCase());i.attr("aria-hidden",!0),t.data(h._ARIA_HIDDEN_ELEMS,i)},h._resetAriaHiddenOnBackround=function(t){var e=t.data(h._ARIA_HIDDEN_ELEMS);e&&(e.removeAttr("aria-hidden"),t.removeData(h._ARIA_HIDDEN_ELEMS))},h.hasModalDialogOpen=function(){for(var t=h.getDefaultLayer().children(),e=t.length-1;e>-1;e--){if(o(t[e]).hasClass(h._OVERLAY_SELECTOR))return!0}return!1},h._addOverlayToAncestorLayer=function(t){var i=o("<div>");i.addClass(h._OVERLAY_SELECTOR),i.addClass(t[0].className),i.attr("role","presentation");var n=t.attr("id");e.StringUtils.isEmptyOrUndefined(n)?i.uniqueId():i.attr("id",[n,"overlay"].join("_")),t.before(i);var r=i.attr("id");t.attr(h._OVERLAY_ATTR,r)},h._removeOverlayFromAncestorLayer=function(t){var i=t.attr(h._OVERLAY_ATTR);e.StringUtils.isEmptyOrUndefined(i)||(t.removeAttr(h._OVERLAY_ATTR),o(document.getElementById(i)).remove())},h.VISIT_RESULT={ACCEPT:0,REJECT:1,COMPLETE:2},h._VISIT_TRAVERSAL={PRE_ORDER:0,POST_ORDER:1},h.postOrderVisit=function(t,e,o){var i=o;o||(i={}),i.level=0,i.type=h._VISIT_TRAVERSAL.POST_ORDER,h._visitTree(t,e,i)},h.preOrderVisit=function(t,e,o){var i=o;o||(i={}),i.level=0,i.type=h._VISIT_TRAVERSAL.PRE_ORDER,h._visitTree(t,e,i)},h._visitTree=function(t,e,i){for(var n=i.level,r=t.children(),s=r.length-1;s>-1;s--){var a=o(r[s]);if(h._hasSurrogate(a[0])){var l;if(i.type===h._VISIT_TRAVERSAL.PRE_ORDER){if((l=e(a,i))===h.VISIT_RESULT.COMPLETE)return l;if(l===h.VISIT_RESULT.REJECT)break}if(i.level=n+1,l=h._visitTree(a,e,i),i.level=n,l===h.VISIT_RESULT.COMPLETE)return l;if(i.type===h._VISIT_TRAVERSAL.POST_ORDER){if((l=e(a,i))===h.VISIT_RESULT.COMPLETE)return l;if(l===h.VISIT_RESULT.REJECT)break}}}return h.VISIT_RESULT.ACCEPT},h._hasSurrogate=function(t){return!(!t||1!==t.nodeType||!t.hasAttribute(h._SURROGATE_ATTR))},h.hasPopupsOpen=function(){return h.getDefaultLayer().children().length>0},h.getOpenPopupCount=function(){var t={popupCount:0},e=h.getDefaultLayer();return h.preOrderVisit(e,h._openPopupCountCallback,t),t.popupCount},h._openPopupCountCallback=function(t,e){return e.popupCount+=1,h.VISIT_RESULT.ACCEPT},h.findOpenPopups=function(){var t={},e=[];t.popups=e;var i=h.getDefaultLayer();return h.preOrderVisit(i,h._openPopupsCallback,t),e=t.popups,o(e)},h._openPopupsCallback=function(t,e){return e.popups.push(t[0]),h.VISIT_RESULT.ACCEPT},h.isAboveTopModalLayer=function(t){if(!t||!h.hasPopupsOpen())return!0;var e=function(){var t={topLayer:null},e=h.getDefaultLayer();if(h.preOrderVisit(e,function(t,e){if(e.level>0)return h.VISIT_RESULT.REJECT;var i=e.topLayer;return i?h.compareStackingContexts(o(t),o(i))>0&&(e.topLayer=t):e.topLayer=t,h.VISIT_RESULT.ACCEPT},t),t.topLayer)return t.topLayer[0]}();if(!e)return!0;var i=function(t){var e={topModalPopup:null};if(t.hasAttribute(h._OVERLAY_ATTR)&&(e.topModalPopup=o(t)),h.postOrderVisit(o(t),function(t,e){return t[0].hasAttribute(h._OVERLAY_ATTR)?(e.topModalPopup=t,h.VISIT_RESULT.COMPLETE):h.VISIT_RESULT.ACCEPT},e),e.topModalPopup)return e.topModalPopup[0]}(e);return!i||(r.isAncestorOrSelf(i,t)||h.compareStackingContexts(o(i),o(t))<0)},h.compareStackingContexts=function(t,i){function n(t,e){var i,n=["absolute","relative","fixed"],s=t.parents(),a=[];for(i=s.length-1;i>-1;i--)a.push(o(s[i]));(s=a).push(t);var l=[],c=0;for(i=0;i<s.length;i++){var p=s[i],u=p.css("position"),_=r.getCSSLengthAsFloat(p.css("opacity")),d=r.getCSSLengthAsInt(p.css("z-index")),f=o.inArray(p[0],p.parent().children());o.inArray(u,n)>-1&&d>0?(l.push({weight:[c,d,f],order:[f]}),c+=1):_<1?(l.push({weight:[c,1,f],order:[f]}),c+=1):e&&l.push({weight:[0,0,f],order:[f]})}return l}function s(t,e){for(var o=Math.max(t.length,e.length),i=0;i<o;i++){var n=i<t.length?t[i]:0,r=i<e.length?e[i]:0;if(n!==r)return n<r?-1:1}return 0}e.Assert.assertPrototype(t,o),e.Assert.assertPrototype(i,o);var a,l,c=n(t,!1),p=n(i,!1),u=Math.max(c.length,p.length);for(a=0;a<u;a++)if(0!==(l=s(a<c.length?c[a].weight:[-1],a<p.length?p[a].weight:[-1])))return l;for(c=n(t,!0),p=n(i,!0),u=Math.max(c.length,p.length),a=0;a<u;a++)if(0!==(l=s(a<c.length?c[a].order:[-1],a<p.length?p[a].order:[-1])))return l;return 0},h.eatEvent=function(t){t.stopPropagation(),t.preventDefault()},h.isPopupOpen=function(t){var e=t.parent();return!(!e||1!==e.length||!h._hasSurrogate(e[0]))},h._EVENTS_DATA="oj-popup-events",h._MODALITY_DATA="oj-popup-modality",h._ARIA_HIDDEN_ELEMS="oj-aria-hidden-elems",h._DEFAULT_LAYER_ID="__oj_zorder_container",h._SURROGATE_ATTR="data-oj-surrogate-id",h._LAYER_ID_DATA="oj-popup-layer-id",h._OVERLAY_ATTR="data-oj-overlayid",h._OVERLAY_SELECTOR="oj-component-overlay";const E={};e._registerLegacyNamespaceProp("PositionUtils",E),E.normalizeHorizontalAlignment=function(t,i){for(var n=o.extend({},t),r=0;r<E._ALIGN_RULE_PROPERTIES.length;r++){var s=E._ALIGN_RULE_PROPERTIES[r],a=n[s];if(a)if(e.StringUtils.isString(a))n[s]=a.replace("start",i?"right":"left").replace("end",i?"left":"right").replace("<",i?"+":"-").replace(">",i?"-":"+");else for(var l=0;l<E._SUB_ALIGN_RULE_PROPERTIES.length;l++){var c=E._SUB_ALIGN_RULE_PROPERTIES[l],p=a[c];e.StringUtils.isString(p)&&(a[c]=p.replace("start",i?"right":"left").replace("end",i?"left":"right").replace("<",i?"+":"-").replace(">",i?"-":"+"))}}return n},E.normalizePositionOf=function(t,e,o){return"event"===t?o:null==t||"launcher"===t?e:t},E._normalizeEventForPosition=function(t){o.each(["pageX","pageY"],function(e,o){if(t&&void 0===t[o]&&t.originalEvent){var i,n=t.originalEvent,r=n.type;if(i="touchstart"===r||"touchmove"===r?"touches":"touchend"===r?"changedTouches":null){var s=n[i][0];s&&(t[o]=s[o])}}})},E._ALIGN_RULE_PROPERTIES=["my","at"],E._SUB_ALIGN_RULE_PROPERTIES=["vertical","horizontal"],E.isAligningPositionClipped=function(t){if(t.target&&t.target.height>0&&t.target.width>0){var e=t.target.element;return!E.isWithinViewport(e)}return!1},E.isWithinViewport=function(t){function e(t,e){var o;if(["hidden","scroll","auto"].indexOf(e.overflowY)>-1){if(t.bottom-e.top<-1)return!1;if(o="auto"===e.overflowX&&e.scrollWidth>e.innerWidth||"scroll"===e.overflowX?r.getScrollBarWidth():0,e.bottom-o-t.top<1)return!1}return!(["hidden","scroll","auto"].indexOf(e.overflowX)>-1&&(o="auto"===e.overflowY&&e.scrollHeight>e.innerHeight||"scroll"===e.overflowY?r.getScrollBarWidth():0,t.right-(e.left+("rtl"===r.getReadingDirection()?o:0))<-1||t.left-(e.right-("ltr"===r.getReadingDirection()?o:0))>-1))}function i(t){var e=t[0];if(1===e.nodeType){var i=o.extend({},e.getBoundingClientRect());return i.overflowX=t.css("overflow-x"),i.overflowY=t.css("overflow-y"),i.innerHeight=t.innerHeight(),i.innerWidth=t.innerWidth(),i.scrollHeight=e.scrollHeight,i.scrollWidth=e.scrollWidth,i}return{height:0,width:0}}function n(t){return["fixed","absolute","relative","sticky"].indexOf(t.css("position"))>-1&&(!isNaN(parseInt(t.css("top"),10))||!isNaN(parseInt(t.css("bottom"),10))||!isNaN(parseInt(t.css("left"),10))||!isNaN(parseInt(t.css("right"),10)))}if(!t)return!1;if(o.isWindow(t[0])||n(t))return!0;for(var s,a=i(t),l=!0,c=t.parent();l&&c&&c.length>0&&"BODY"!==c[0].nodeName&&1===c[0].nodeType&&!n(c);){if("visible"!==(s=c).css("overflow-x")||"visible"!==s.css("overflow-y")){var p=i(c);p.height>0&&p.width>0&&(l=e(a,p))}c=c.parent()}return l},E._ANIMATION_TRANSFORM_ORIGIN_RULES={"right-top":"right top","right-middle":"right center","right-bottom":"right bottom","left-top":"left top","left-middle":"left center","left-bottom":"left bottom","center-top":"center top","center-middle":"center center","center-bottom":"center bottom"},E._ALIGN_MNEMONIC_DATA="oj-popup-align-mnemonic",E.captureTransformOriginAnimationEffectsOption=function(t,e){var o=[e.horizontal,e.vertical].join("-");t.data(E._ALIGN_MNEMONIC_DATA,o)},E.addTransformOriginAnimationEffectsOption=function(t,o){var i,n;e.StringUtils.isString(o)?(n=!0,i=o):(n=!1,i=JSON.stringify(o));var r=/#myPosition/g;if(i.match(r)){var s=t.data(E._ALIGN_MNEMONIC_DATA);e.StringUtils.isEmptyOrUndefined(s)&&(s="center-middle");var a=E._ANIMATION_TRANSFORM_ORIGIN_RULES[s];i=i.replace(r,a),o=n?i:JSON.parse(i)}return o},E._JQUI_MNEMONIC_GRP_REGX=/^(\w+)(\+|-)?(\d+)?/,E._VERTICAL_ENUM_TST_REGX=/^top$|^center$|^bottom$/,E._HORIZONTAL_ENUM_TST_REGX=/^start$|^left$|^center$|^end$|^right$/,E._COLLISION_ENUM_TST_REGX=/^none$|^flip$|^flipfit$|^fit$|^flipcenter$/,E._parsePositionNmnemonic=function(t,e){var o=[null,Number.NaN],i=E._JQUI_MNEMONIC_GRP_REGX.exec(t);if(i[1]&&e.test(i[1])&&(o[0]=i[1],i[2])){var n=parseInt(i[3],10);isNaN(n)||(n*="-"===i[2]?-1:1,o[1]=n)}return o},E._parseJSON=function(t){if(e.StringUtils.isString(t)&&/^{/.test(t)&&/}$/.test(t))try{return JSON.parse(t)}catch(t){}return null},E._coerceMyAtToJet=function(t,i,n,s){var a=E._parseJSON(i);a&&(i=a),(a=E._parseJSON(n))&&(n=a),s||(s={});var l,c=o.extend({},s),p={x:0,y:0};if(n&&"x"in n&&"y"in n&&(p.x=r.getCSSLengthAsInt(n.x),p.y=r.getCSSLengthAsInt(n.y)),e.StringUtils.isString(i)){var u=i.split(/\s/);u.length>0&&!e.StringUtils.isEmpty(u[0])&&(l=E._parsePositionNmnemonic(u[0],E._HORIZONTAL_ENUM_TST_REGX))[0]&&(c.horizontal=l[0],isNaN(l[1])||(p.x=l[1])),u.length>1&&!e.StringUtils.isEmpty(u[1])&&(l=E._parsePositionNmnemonic(u[1],E._VERTICAL_ENUM_TST_REGX))[0]&&(c.vertical=l[0],isNaN(l[1])||(p.y=l[1]))}else i&&("horizontal"in i&&(l=E._parsePositionNmnemonic(i.horizontal,E._HORIZONTAL_ENUM_TST_REGX))[0]&&(c.horizontal=l[0],isNaN(l[1])||(p.x=l[1])),"vertical"in i&&(l=E._parsePositionNmnemonic(i.vertical,E._VERTICAL_ENUM_TST_REGX))[0]&&(c.vertical=l[0],isNaN(l[1])||(p.y=l[1])));var _={};return _[t]=c,_.offset=p,_},E._coerceCollisionToJet=function(t,e){var o=e;return E._COLLISION_ENUM_TST_REGX.test(t)&&(o=t),{collision:o}},E._coerceOfToJet=function(t,i){var n=E._parseJSON(t);n&&(t=n);var s=i;if(e.StringUtils.isString(t))s=t;else if(o.isWindow(t))s="window";else if(t instanceof Element||t instanceof o){(t=o(t)).uniqueId(),s="#"+function(t){for(var e=[],o=/\w|_|-/,i=0;i<t.length;i++){var n=t.substring(i,i+1);o.test(n)?e.push(n):e.push("\\"+n)}return e.join("")}(t.attr("id"))}else t instanceof Event||t instanceof o.Event?("pageX"in t||"pageY"in t)&&((s={}).x=r.getCSSLengthAsFloat(t.pageX),s.y=r.getCSSLengthAsFloat(t.pageY)):t&&("x"in t||"y"in t)&&((s={}).x=r.getCSSLengthAsFloat(t.x),s.y=r.getCSSLengthAsFloat(t.y));return{of:s}},E.coerceToJet=function(t,e){t||(t={});var i=E._parseJSON(t);i&&(t=i),e||(e={});var n=e.my,r=e.at,s=e.collision,a=e.of,l=E._coerceMyAtToJet("my",t.my,t.offset,n),c=E._coerceMyAtToJet("at",t.at,null,r),p={offset:{x:l.offset.x+c.offset.x,y:l.offset.y+c.offset.y}};delete l.offset,delete c.offset;var u=o.extend({},l,c,p,E._coerceCollisionToJet(t.collision,s),E._coerceOfToJet(t.of,a),function(t,e){return{using:o.isFunction(t)?t:e}}(t.using,undefined));return u},E.coerceToJqUi=function(t){function i(e,o){var i=[];if(t[e][o]?i.push(t[e][o]):i.push("center"),"my"===e&&t.offset){var n="horizontal"===o?"x":"y",r=t.offset[n];isNaN(r)||0===r||(i.push(r>0?"+":""),i.push(Math.floor(r).toString()))}return i.join("")}var n={};["my","at"].forEach(function(e){if(t[e]){var o=[];o.push(i(e,"horizontal")),o.push(" "),o.push(i(e,"vertical")),n[e]=o.join("")}});var r=t.of;if(e.StringUtils.isString(r))n.of="window"===r?window:r;else if(r&&!e.StringUtils.isString(r)&&"x"in r&&"y"in r){var s=r.x,a=r.y,l=document.createEvent("MouseEvents");l.initMouseEvent("click",!0,!0,window,1,s,a,s,a,!1,!1,!1,!1,0,null),n.of=o.Event(l,{pageX:s,pageY:a})}else n.of=r;return t.collision&&(n.collision=t.collision),t.using&&(n.using=t.using),n},E.calcAvailablePopupSize=function(t,e,i){var n,s,a,l,c=o.position.getWithinInfo(i||window),p=o.position.getScrollInfo(c),u="rtl"===r.getReadingDirection(),_=u?p.width:0,d=u?0:p.width,f=e.element,h=e.target,E=c.isWindow?c.scrollLeft:0,g=c.isWindow?c.scrollTop:0,v=f.left,O=f.left+f.width,T=f.top,S=f.top+f.height,m=h.left,P=h.left+h.width,y=h.top,A=h.top+h.height,L=c.offset.left+E+_,I=c.offset.left+c.width+E-d,R=c.offset.top+g,N=c.offset.top+c.height+g-p.height;return v<m?(n=L,s=O<=m?m:O<=P?Math.min(P,I):I):v===m?m-L>I-P?(n=L,s=P):(n=m,s=I):v<P?(n=m,s=O<=P?P:I):(n=P,s=I),T<y?(a=R,l=S<=y?y:S<=A?Math.min(A,N):N):T===y?(a=y,l=N):T<A?(a=y,l=S<=A?A:N):(a=A,l=N),{width:s-n,height:l-a}},function(){var t,i=Math.max,n=Math.abs;const s=/left|center|right/,a=/top|center|bottom/,l=/[+-]\d+(\.[\d]+)?%?/,c=/^\w+/,p=/%$/;var u=o.fn.position,_=o.position.getWithinInfo;function d(t,e,o){return[parseFloat(t[0])*(p.test(t[0])?e/100:1),parseFloat(t[1])*(p.test(t[1])?o/100:1)]}function f(t,e){return parseInt(o.css(t,e),10)||0}o.position={getWithinInfo:_.bind(this),scrollbarWidth:function(){if(void 0!==t)return t;var e,i,n=document.createElement("div");n.style.display="block",n.style.position="absolute",n.style.width="50px",n.style.height="50px",n.style.overflow="hidden";var r=document.createElement("div");return r.style.height="100px",r.style.width="auto",n.appendChild(r),o("body").append(o(n)),e=r.offsetWidth,n.style.overflow="scroll",e===(i=r.offsetWidth)&&(i=n.clientWidth),o(n).remove(),t=e-i},getScrollInfo:function(t){var e=t.isWindow||t.isDocument?"":t.element.css("overflow-x"),i=t.isWindow||t.isDocument?"":t.element.css("overflow-y"),n="scroll"===e||"auto"===e&&t.width<t.element[0].scrollWidth;return{width:"scroll"===i||"auto"===i&&t.height<t.element[0].scrollHeight?o.position.scrollbarWidth():0,height:n?o.position.scrollbarWidth():0}}},o.fn.position=function(t){if(!t||!t.of)return u.apply(this,arguments);var r,p,_,h,E,g,v="string"==typeof(t=o.extend({},t)).of?o(document).find(t.of):o(t.of),O=o.position.getWithinInfo(t.within),T=o.position.getScrollInfo(O),S=(t.collision||"flip").split(" "),m={};return g=function(t){var o,i=t[0];if(9===i.nodeType)return{width:t.width(),height:t.height(),offset:{top:0,left:0}};if(null!=(o=i)&&o===o.window){var n=e.AgentUtils.getAgentInfo(),r=e.AgentUtils.OS.ANDROID===n.os||e.AgentUtils.OS.IOS===n.os;return{width:t.width(),height:r?i.innerHeight:t.height(),offset:{top:t.scrollTop(),left:t.scrollLeft()}}}return i.preventDefault?{width:0,height:0,offset:{top:i.pageY,left:i.pageX}}:{width:t.outerWidth(),height:t.outerHeight(),offset:t.offset()}}(v),v[0].preventDefault&&(t.at="left top"),p=g.width,_=g.height,h=g.offset,E=o.extend({},h),o.each(["my","at"],function(){var e,o,i=(t[this]||"").split(" ");1===i.length&&(i=s.test(i[0])?i.concat(["center"]):a.test(i[0])?["center"].concat(i):["center","center"]),i[0]=s.test(i[0])?i[0]:"center",i[1]=a.test(i[1])?i[1]:"center",e=l.exec(i[0]),o=l.exec(i[1]),m[this]=[e?e[0]:0,o?o[0]:0],t[this]=[c.exec(i[0])[0],c.exec(i[1])[0]]}),1===S.length&&(S[1]=S[0]),"right"===t.at[0]?E.left+=p:"center"===t.at[0]&&(E.left+=p/2),"bottom"===t.at[1]?E.top+=_:"center"===t.at[1]&&(E.top+=_/2),r=d(m.at,p,_),E.left+=r[0],E.top+=r[1],this.each(function(){var e,s,a=o(this),l=a.outerWidth(),c=a.outerHeight(),u=f(this,"marginLeft"),g=f(this,"marginTop"),P=l+u+f(this,"marginRight")+T.width,y=c+g+f(this,"marginBottom")+T.height,A=o.extend({},E),L=d(m.my,a.outerWidth(),a.outerHeight());"right"===t.my[0]?A.left-=l:"center"===t.my[0]&&(A.left-=l/2),"bottom"===t.my[1]?A.top-=c:"center"===t.my[1]&&(A.top-=c/2),A.left+=L[0],A.top+=L[1],e={marginLeft:u,marginTop:g},o.each(["left","top"],function(i,n){o.ui.position[S[i]]&&o.ui.position[S[i]][n](A,{targetWidth:p,targetHeight:_,elemWidth:l,elemHeight:c,collisionPosition:e,collisionWidth:P,collisionHeight:y,offset:[r[0]+L[0],r[1]+L[1]],my:t.my,at:t.at,within:O,elem:a})}),A.left=Math.round(A.left),A.top=Math.round(A.top),t.using&&(s=function(e){var o=h.left-A.left,r=o+p-l,s=h.top-A.top,u=s+_-c,d={target:{element:v,left:h.left,top:h.top,width:p,height:_},element:{element:a,left:A.left,top:A.top,width:l,height:c},horizontal:r<0?"left":o>0?"right":"center",vertical:u<0?"top":s>0?"bottom":"middle"};p<l&&Math.abs(o+r)<p&&(d.horizontal="center"),_<c&&Math.abs(s+u)<_&&(d.vertical="middle"),i(n(o),n(r))>i(n(s),n(u))?d.important="horizontal":d.important="vertical",t.using.call(this,e,d)}),a.offset(o.extend(A,{using:s}))})};var h=o.ui.position.flip.left;o.ui.position.flip={left:h.bind(this),top:function(t,e){var o,i,n=e.within,r=n.offset.top+n.scrollTop,s=n.height,a=n.isWindow?n.scrollTop:n.offset.top,l=t.top-e.collisionPosition.marginTop,c=l-a,p=l+e.collisionHeight-s-a;o="top"===e.my[1]?-e.elemHeight:"bottom"===e.my[1]?e.elemHeight:0,i="top"===e.at[1]?e.targetHeight:"bottom"===e.at[1]?-e.targetHeight:0;var u,_,d=-2*e.offset[1];c<0?((u=t.top+o+i+d+e.collisionHeight-s-r)<0||u<Math.abs(c))&&p<0&&c>p&&(t.top+=o+i+d):p>0&&((_=t.top-e.collisionPosition.marginTop+o+i+d-a)>0||Math.abs(_)<p)&&(t.top+=o+i+d)}},o.ui.position.fit={left:function(t,e){var o,i=e.within,n=i.isWindow?i.scrollLeft:i.offset.left,r=i.width,s=t.left-e.collisionPosition.marginLeft,a=n-s,l=s+e.collisionWidth-r-n;e.collisionWidth>r?a>0&&l<=0?(o=t.left+a+e.collisionWidth-r-n,t.left+=a-o):t.left=l>0&&a<=0?n:a>l?n+r-e.collisionWidth:n:a>0?t.left+=a:l>0?t.left-=l:t.left=Math.max(t.left-s,t.left),t.left<0&&(t.left=0)},top:function(t,e){var o,i=e.within,n=i.isWindow?i.scrollTop:i.offset.top,r=e.within.height,s=t.top-e.collisionPosition.marginTop,a=n-s,l=s+e.collisionHeight-r-n;e.collisionHeight>r?a>0&&l<=0?(o=t.top+a+e.collisionHeight-r-n,t.top+=a-o):t.top=l>0&&a<=0?n:a>l?n+r-e.collisionHeight:n:a>0?t.top+=a:l>0?t.top-=l:t.top=Math.max(t.top-s,t.top),t.top<0&&(t.top=0)}},o.ui.position.flipcenter={left:function(t,e){var i=t.left;o.ui.position.flip.left.call(this,t,e);var n=e.within,s=n.isWindow?n.scrollLeft:n.offset.left,a=n.width,l=t.left-e.collisionPosition.marginLeft,c=s-l,p=l+e.collisionWidth-a-s;(c>0||p>0)&&("right"===e.at[0]?i-=e.targetWidth/2:"left"===e.at[0]&&(i+=e.targetWidth/2),((i-=("rtl"===r.getReadingDirection()?-1:1)*(e.elemWidth/2))<s||i+e.elemWidth>a-s)&&(o.ui.position.fit.left.call(this,t,e),i=t.left),t.left=Math.max(0,i))},top:function(t,e){var i=t.top;o.ui.position.flip.top.call(this,t,e);var n=e.within,r=n.isWindow?n.scrollTop:n.offset.top,s=e.within.height,a=t.top-e.collisionPosition.marginTop,l=r-a,c=a+e.collisionHeight-s-r;(l>0||c>0)&&("top"===e.at[1]?i+=e.targetHeight/2:"bottom"===e.at[1]&&(i-=e.targetHeight/2),i+=e.elemHeight/2,t.top=Math.max(0,i))}}}();const g=function(){this.Init()};e._registerLegacyNamespaceProp("PopupLiveRegion",g),e.Object.createSubclass(g,e.Object,"oj.PopupLiveRegion"),g.prototype.Init=function(){g.superclass.Init.call(this),isNaN(g._refCounter)?g._refCounter=1:g._refCounter+=1},g.prototype.destroy=function(){if(!isNaN(g._refCounter)&&(g._refCounter-=1)<1){var t=o(document.getElementById(g._POPUP_LIVE_REGION_ID));t.length>0&&t.remove()}},g.prototype.announce=function(t){if(!e.StringUtils.isEmpty(t)){var i=g._getLiveRegion();i.children().remove(),setTimeout(function(){o("<div>").text(t).appendTo(i)},250)}},g._getLiveRegion=function(){var t=o(document.getElementById(g._POPUP_LIVE_REGION_ID));return 0===t.length&&((t=o("<div>")).attr({id:g._POPUP_LIVE_REGION_ID,role:"log","aria-live":"polite","aria-relevant":"additions"}),t.addClass("oj-helper-hidden-accessible"),t.appendTo(document.body)),t},g._POPUP_LIVE_REGION_ID="__oj_popup_arialiveregion";const v=function(t,i,n,r,s){e.Assert.assertPrototype(t,o),e.Assert.assertString(i),e.Assert.assertFunction(n),e.Assert.assertStringOrNull(r),this._options={insertBefore:!1,preventKeyEvents:!0},s&&(this._options=Object.assign({},this._options,s)),this._sibling=t,this._message=i,this._callback=n,this._id=r,this.Init()};e._registerLegacyNamespaceProp("PopupSkipLink",v),e.Object.createSubclass(v,e.Object,"oj.PopupSkipLink"),v.prototype.Init=function(){v.superclass.Init.call(this);var t=this._sibling,e=this._callback,i=this._message,n=this._options.insertBefore,r=this._options.preventKeyEvents;this._message=null;var s=this._id;this._id=null;var a=o(document.getElementById(s));a.length<1&&(a=o("<a>").attr({tabindex:"-1",href:"#",role:"link"})),a.attr("id",s),a.addClass("oj-helper-hidden-accessible"),a.text(i),n?a.insertBefore(t):a.insertAfter(t),a.on("click",v._activateHandler.bind(this,e)),r&&a.on("keydown keyup keypress",v._keyHandler),t.data(v._SKIPLINK_ATTR,a)},v._activateHandler=function(t,e){h.eatEvent(e),window.setImmediate(t)},v._keyHandler=function(t){t.keyCode===o.ui.keyCode.ENTER&&h.eatEvent(t)},v.prototype.destroy=function(){var t=this._sibling;if(delete this._sibling,delete this._callback,t){var e=t.data(v._SKIPLINK_ATTR);t.removeData(v._SKIPLINK_ATTR),e&&(e.off("click keydown keyup keypress"),e.remove())}},v.prototype.getLink=function(){var t,e=this._sibling;return e&&(t=e.data(v._SKIPLINK_ATTR)),t},v._SKIPLINK_ATTR="oj-skiplink";const O=function(t,e,o,i){this._element=t,this._operation=e,this._widgetName=o,this._isCustomElement=!!i,this.Init()};e._registerLegacyNamespaceProp("PopupWhenReadyMediator",O),e.Object.createSubclass(O,e.Object,"oj.PopupWhenReadyMediator"),O.prototype.Init=function(){O.superclass.Init.call(this),this._resolvedQueue=[],this._callback=this._eventHandler.bind(this);var t=this._operation,e=["oj"];this._isCustomElement?(e.push(t.charAt(0).toUpperCase()),e.push(t.slice(1))):e.push(t);var o=e.join("");this._eventType=o,this._element.on(o,this._callback);var i=l.getContext(this._element[0]).getBusyContext(),n={description:this._getBusyStateDescription.bind(this,this._element,this._operation,this._widgetName)},r=i.addBusyState(n);this.AddPromiseExecutor(r),this._whenReadyPromise=new Promise(this.AddPromiseExecutor.bind(this))},O.prototype._getBusyStateDescription=function(t,e,o){return o+" identified by '"+t.attr("id")+"' is busy animating on the '"+e+"' operation."},O.prototype._deliverResolved=function(t){var e=this._resolvedQueue;this._resolvedQueue=null;var o=t||this._operation;this._operation=null;for(var i=0;i<e.length;i++)try{e[i](o)}catch(t){n.error("Error resolving whenReady promises:\n%o",t)}this._whenReadyPromise=Promise.resolve("none")},O.prototype.destroy=function(){if(this._resolvedQueue&&this._deliverResolved("none"),this._callback){var t=this._eventType;this._element.off(t,this._callback)}this._callback=null,this._element=null,this._operation=null,this._whenReadyPromise=null,this._widgetName=null,this._eventType=null},O.prototype.getWhenReadyPromise=function(){return this._whenReadyPromise},O.prototype._eventHandler=function(t){t.target===this._element[0]&&(this._element.off(t.type,this._callback),this._deliverResolved(),this._callback=null)},O.prototype._getPendingOperation=function(){return this._operation?this._operation:"none"},O.prototype.AddPromiseExecutor=function(t,e){this._resolvedQueue&&this._resolvedQueue.push(t)},O.prototype.isOperationPending=function(t,e,o,i){var r=!1,s=this._widgetName,a=this._getPendingOperation();if(e===a)n.info("An %s instance invoked a '%s' operation while pending animation of the same type of operation.  The second request will be ignored.",s,e),r=!0;else if("none"!==a){n.info("An %s instance invoked a '%s' operation while pending animation of a '%s' operation. The second request will be invoked after the pending operation completes.",s,e,a),new Promise(this.AddPromiseExecutor.bind(this)).then(function(){this[o].apply(this,i)}.bind(t)),r=!0}return r};class T extends p.Component{constructor(){super(...arguments),this._setRootRef=t=>{this._rootRef=t}}render(t){return c.jsx("div",{style:{display:"none"},ref:this._setRootRef,children:t.children})}componentDidMount(){this._popup=o(this._rootRef.firstChild);const t={[d.OPTION.POPUP]:this._popup,[d.OPTION.EVENTS]:{[d.EVENT.POPUP_AUTODISMISS]:this.props.autoDismiss,[d.EVENT.POPUP_REFRESH]:function(){this._popup.position(this._getPosition())}.bind(this)},[d.OPTION.LAYER_SELECTORS]:this.props.layerSelectors,[d.OPTION.CUSTOM_ELEMENT]:!0,[d.OPTION.LAUNCHER]:o(this._rootRef),[d.OPTION.POSITION]:this._getPosition()};d.getInstance().open(t)}componentWillUnmount(){d.getInstance().close({[d.OPTION.POPUP]:this._popup})}componentDidUpdate(){this._popup.position(this._getPosition())}_getPosition(){return E.normalizeHorizontalAlignment(this.props.position,"rtl"===r.getReadingDirection())}}var S;T.defaultProps={autoDismiss:null,layerSelectors:"",position:{}};const m="__oj_zorder_container",P="__root_layer_host",y="__top_layer_host",A=u.ElementUtils.getUniqueId.bind(null,null),L=Symbol();class I{static findOpenVPopups(){const t=document.getElementById(P),e=document.getElementById(y),o=[];return t&&o.concat([].slice.call(t.children)),e&&o.concat([].slice.call(e.children)),o}}S=I,I._getPopupServiceOptions=(t,o)=>{const i={},n=e.PopupService.OPTION;i[n.POPUP]=t,i[n.LAUNCHER]=o,i[n.LAYER_SELECTORS]="oj-v-layer-host-layer";const r=e.PopupService.EVENT;return i[n.EVENTS]={[r.POPUP_BEFORE_OPEN]:()=>{},[r.POPUP_AFTER_OPEN]:()=>{},[r.POPUP_BEFORE_CLOSE]:()=>{},[r.POPUP_AFTER_CLOSE]:()=>{},[r.POPUP_AUTODISMISS]:()=>{},[r.POPUP_REFRESH]:()=>{},[r.POPUP_CLOSE]:()=>{S._closeLayerHost(t,o)},[r.POPUP_REMOVE]:()=>{}},i},I.getLayerHost=(t,e)=>{const o=t.anchorRef;let i;if(t[L]?i=document.getElementById(t[L]):t[L]=`__v_layer_host_${A()}`,i)return i;let n,r=!1;n=null!=o?o.current:t;let s=t.closest(`#${m}`);return s?r=!0:o&&o.current&&!o.current.x&&(s=o.current.closest(`#${m}`),s&&(r=!0)),r?S._openLayerHost(t[L],n):S._getNewLayerHost(t,e)},I._getNewLayerHost=(t,e)=>{const o=t.closest(`#${y}`);if(o)return o;let i=document.getElementById(P);if("top"===e){let t=document.getElementById(y);if(!t)if(t=document.createElement("div"),t.setAttribute("id",y),t.setAttribute("data-oj-binding-provider","preact"),t.classList.add("oj-top-layer-host"),i)i.after(t);else{let e=document.getElementById(m);e?e.after(t):document.body.prepend(t)}return t}if(!i){i=document.createElement("div"),i.setAttribute("id",P),i.setAttribute("data-oj-binding-provider","preact"),i.classList.add("oj-root-layer-host");let t=document.getElementById(m);t?t.after(i):document.body.prepend(i)}return i},I._openLayerHost=(t,o)=>{if(!t)return;let i=document.getElementById(t);i||(i=document.createElement("div"),i.setAttribute("id",t),i.setAttribute("data-oj-binding-provider","preact"),document.body.appendChild(i));const n=e.PopupService.getInstance(),r=S._getPopupServiceOptions(i,o);return n.open(r),i},I._closeLayerHost=(t,o)=>{if(!t)return;const i=e.PopupService.getInstance(),n=S._getPopupServiceOptions(t,o);i.close(n),t.remove()},e._registerLegacyNamespaceProp("VLayerUtils",I),t.PopupLiveRegion=g,t.PopupService=d,t.PopupSkipLink=v,t.PopupWhenReadyMediator=O,t.PositionUtils=E,t.VLayerUtils=I,t.VPopup=T,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojpopupcore.js.map