/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore","knockout","signals","ojs/ojlogger"],function(t,e,r,n){"use strict";!function(){var i,o,a,u,s,l="/",c="root",f="oj_Router",h=" | ",d=1024,p="popstate",v="hasChanged",_={hasChanged:!1},g=!1,m=[],b=window.location,R="parameters";function S(t){return t?t.split("/"):[]}function w(t){return K(S(t)[0])}function y(e,r){var n=document.createElement("a");return n.href=b.href,void 0!==e.search&&(n.search=e.search),void 0!==e.pathname&&(n.pathname=e.pathname),n.search=function(e,r){var n,i,o="",a=e.indexOf(f);if(-1!==a){var u=e.indexOf("&",a);-1===u&&(u=e.length),n=e.substring(0,a),i=e.substr(u)}else n=e+(-1===e.indexOf("?")?"?":"&"),i="";r&&Object.getOwnPropertyNames(r).length>0?o=function(e){var r=JSON.stringify(e),n=encodeURIComponent(r),i=t.LZString.compressToEncodedURIComponent(r),o=!1,a=f+"=";i.length<=n.length&&(o=!0);a+=o?"1"+i:"0"+n;if(a.length>d)throw new Error("Size of bookmarkable data is too big.");return a}(r):n=n.substring(0,n.length-1);return n+o+i}(n.search,r),n.href.replace(/\?$/,"")}function I(t){return t._parentRouter?I(t._parentRouter)+"."+t._name:t._name}function E(t){var e;if(t){if(e=E(t._parentRouter)){var r=t._stateId();r?e+=r+"/":e=void 0}}else e="/";return e}function C(t,e){var r;return t._childRouters.every(function(t){if(t._parentState){if(t._parentState===e)return r=t,!1}else r=t;return!0}),r}function x(t){var e=t.filter(function(t){return t.value!==t.router._stateId()});return n.option("level")===n.LEVEL_INFO&&(n.info("Potential changes are: "),e.forEach(function(t){n.info("   { router: %s, value: %s }",t.router&&I(t.router),t.value)})),e}function P(t){var e=this[t.router._name];void 0!==e&&(t.router._extra=e)}function O(){return m[0]&&m[0].cancel}function j(e){var r,i=e.charAt(0),o=e.slice(1);if("0"===i)o=decodeURIComponent(o);else{if("1"!==i)throw new Error("Error retrieving bookmarkable data. Format is invalid");o=t.LZString.decompressFromEncodedURIComponent(o)}if(r=JSON.parse(o),n.option("level")===n.LEVEL_INFO){n.info("Bookmarkable data: ");for(var a=Object.keys(r),u=0;u<a.length;u++){var s=a[u];n.info("   { router: %s, value: %s }",s,r[s])}}return r}function k(t,e,r){var n;return t._childRouters.every(function(t){return!((!t._parentState||t._parentState===r)&&t._getStateFromId(e))||(n=t,!1)}),n}function A(t){var e=[];return t._currentState()&&(e.push(new L(t)),t._childRouters.forEach(function(t){e=e.concat(A(t))})),e}function U(t){if(!t)return{title:"",segment:""};var e=U(C(t,t._stateId()));if(""===e.title){var r=t._currentState();if(r){var n=r._title;void 0!==n?("function"==typeof n&&(n=n()),e.title=String(n)):void 0!==(n=r._label)&&(n=String(n),""!==e.segment&&(n+=h+e.segment),e.segment=n)}}return e}function F(e){t.Router._transitionedToState.dispatch(e)}function L(t,e){this.router=t,this.value=e}function M(t){var e,r,n=t[t.length-1];for(n?(e=n.router,r=w(n.value)):(e=s,(r=s._defaultStateId)&&t.push(new L(e,r))),e=C(e,r);e;)(r=e._defaultStateId)&&t.push(new L(e,r)),e=C(e,r);var i=A(s),o=[];return i.forEach(function(e,r){var n=t[r];n&&e.router===n.router||o.unshift(e)}),o.concat(t)}function T(t,e,r){var i=t();return i||n.info("%s is false for state: %s",e,r),i}function H(t,e,r,n){return"function"==typeof t&&(e=e?e.then(function(e){return e&&(e=T(t,r,n)),e}):new Promise(function(e){e(T(t,r,n))})),e}function N(t,e){var r=t._currentState();if(r){for(var n=0;n<t._childRouters.length;n++)e=N(t._childRouters[n],e);e=H(r.viewModel&&r.viewModel.canExit?r.viewModel.canExit:r._canExit,e,"canExit",r._id)}return e}function D(t){var e;return O()?Promise.resolve(!1):(n.info("Start _canExit."),e=t?null===(e=N(t,null))?Promise.resolve(!0):e.then(function(t){return t&&!O()}):Promise.resolve(!0))}function V(t,e){if(O())return Promise.resolve();n.info("Start _canEnter.");var r=null;return t.forEach(function(t){var e=t.getState();e&&(r=H(e._canEnter,r,"canEnter",e._id))}),r=null===r?Promise.resolve({allChanges:t,origin:e}):r.then(function(r){var n;return r&&!O()&&(n={allChanges:t,origin:e}),n})}function Z(e){if(!e)return Promise.resolve(_);var r,i=Promise.resolve().then(function(){n.info("Entering _updateAll."),t.Router._updating=!0}),o=e.allChanges;return o.forEach(function(t){r=t.router.currentState.peek(),i=i.then(function(){if(!O())return function(t,e){var r=t.router._getStateFromId(w(t.router._stateId())),i=t.getState();return Promise.resolve().then(function(){n.option("level")===n.LEVEL_INFO&&n.info("Updating state of %s to %s.",I(t.router),t.value)}).then(r?r._exit:void 0).then(function(){var r=t.router,n=!1;if("popState"===e){var o,a=r._navHistory.length;for(o=a-1;o>=0;o--)if(r._navHistory[o]===t.value){n=!0,r._navHistory.splice(o,a-o);break}a-o==1&&(r._navigationType="back")}if(n||(delete r._navigationType,r._navHistory.push(w(r._stateId()))),t.value&&i){var u=S(t.value);i._paramOrder.forEach(function(t,e){var r=K(u[e+1]);r!==i[R][t]&&(i[R][t]=r)})}r._stateId(t.value)}).then(i?i._enter:void 0)}(t,e.origin)})}),i.then(function(){var e,i,a=!1;if(o.length){a=!O();var u=o[o.length-1];e=u.router,i=u.state}return t.Router._updating=!1,n.info("_updateAll returns %s.",String(a)),{hasChanged:a,router:e,oldState:r,newState:i}},function(e){return t.Router._updating=!1,Promise.reject(e)})}function $(t){var e;try{e=x(e=o.parse())}catch(t){return Promise.reject(t)}return V(e,t).then(Z)}function z(t,e){if(n.option("level")===n.LEVEL_INFO){var r=e.path?"path="+e.path:"",i=e.deferredHandling?"deferredHandling=true":"",o=e.router?I(e.router):"null";n.info(">> %s: origin=%s router=%s %s %s",t,e.origin,o,r,i)}}function B(){var t,e=m[0];return z("Resolving",e),e.cancel?(z("Cancelled",e),t=Promise.resolve(_)):t=function(t){if(z("Executing",t),!t.deferredHandling){if("sync"===t.origin)return $();if("popState"===t.origin)return D(t.router).then(function(e){return e?$(t.origin):Promise.resolve(_)})}return t.router._go(t)}(e),t.then(function(t){if(z("Done with",m.shift()),!0===t[v]){var e,r=U(s);""!==r.title?e=r.title:i&&i.length>0?(e=i,""!==r.segment&&(e+=h+r.segment)):e=r.segment,e!==window.document.title&&(window.document.title=e)}return F(t),t},function(t){return m=[],n.error("Error when executing transition: %o",t),F(_),Promise.reject(t)})}function J(t){z("Queuing  ",t);var e=m.push(t);if(1===e)u=B();else{var r=m[e-2];r.deferredHandling||(z("Cancelling",r),r.cancel=!0),u=u.then(B)}return u}function Q(){var t=w(s._stateId()),e=null;if(n.info("Handling popState event with URL: %s",b.href),t)for(var r=0;r<s._childRouters.length;r++){var i=s._childRouters[r];if(t===i.parent.stateId()){e=i;break}}J({router:e,origin:"popState"})}function q(){g||(o||(o=new t.Router.urlPathAdapter),o.init(l),i=window.document.title,window.addEventListener(p,Q,!1),n.info("Initializing rootInstance."),n.info("Base URL is %s",l),n.info("Current URL is %s",b.href),g=!0)}function G(t){var e=t;return e&&e.replace&&(e=(e=e.replace(/~/g,"~0")).replace(/\//g,"~1")),e}function K(t){var e=t;return e&&e.replace&&(e=(e=e.replace(/~1/g,"/")).replace(/~0/g,"~")),e}L.prototype.getState=function(){return this.state||this.value&&(this.state=this.router._getStateFromId(w(this.value))),this.state},L.prototype.addParameter=function(t){t&&(this.value+="/"+t)},t.Router=function(t,r,n){var i=this;function o(t,e){var r={name:u(t),params:{ojRouter:{parentRouter:e,get direction(){return e._navigationType}}}};return r.params.ojRouter[R]={},t&&(a(t,r),r.lifecycleListener={attached:e.moduleConfig.lifecycleListener.attached}),r}function a(t,r){var n=r.params.ojRouter[R],i=t[R];Object.keys(i).forEach(function(t){var r=i[t],o=n[t];o||(o=e.observable(),n[t]=o),o(r)})}function u(t){var e;return t&&((e=t.value)&&"string"==typeof e||(e=t._id)),e}this._name=t,this._parentState=n||(r?w(r._stateId()):void 0),this._parentRouter=r,this._childRouters=[],this._extra=void 0,this._stateId=e.observable(),this._stateIdComp=e.pureComputed({read:function(){return w(this._stateId())},write:function(t){this.go(t).then(null,function(t){throw t})},owner:i}),this._states=null,this._defaultStateId=void 0,this._currentState=e.pureComputed(function(){var t=w(i._stateId());return e.ignoreDependencies(i._getStateFromId,i,[t])}),this._currentValue=e.pureComputed(function(){var t,r=w(i._stateId()),n=e.ignoreDependencies(i._getStateFromId,i,[r]);return n&&(t=n.value),t}),this._navigationType=void 0,this._navHistory=[],this._moduleConfig=Object.create(null,{name:{value:e.pureComputed(function(){var t,e=w(this._stateId())||this._defaultStateId||this._states[0].name,r=this._getStateFromId(e);return r&&((t=r.value)&&"string"==typeof t||(t=r._id)),t},i),enumerable:!0},params:{value:Object.create(null,{ojRouter:{value:new function(){Object.defineProperties(this,{parentRouter:{value:i,enumerable:!0},direction:{get:function(){return i._navigationType},enumerable:!0}})},enumerable:!0}}),enumerable:!0},lifecycleListener:{value:{attached:function(t){var e=i.currentState();e&&(e.viewModel=t.viewModel)},enumerable:!0},enumerabl:!0}}),this._getObservableModuleConfig=function(){if(!this._observableModuleConfig){var t=i.currentState,r=t.peek(),n=e.observable(o(r,i));t.subscribe(function(t){var e=n.peek();e.name!==u(t)?n(o(t,i)):a(t,e)}),this._observableModuleConfig=n}return this._observableModuleConfig},Object.defineProperties(this,{parent:{value:this._parentRouter,enumerable:!0}})},Object.defineProperties(t.Router.prototype,{name:{get:function(){return this._name},enumerable:!0},states:{get:function(){return this._states},enumerable:!0},stateId:{get:function(){return this._stateIdComp},enumerable:!0},currentState:{get:function(){return this._currentState},enumerable:!0},currentValue:{get:function(){return this._currentValue},enumerable:!0},direction:{get:function(){return this._navigationType},enumerable:!0},defaultStateId:{get:function(){return this._defaultStateId},set:function(t){this._defaultStateId=t},enumerable:!0},moduleConfig:{get:function(){return this._moduleConfig},enumerable:!0},observableModuleConfig:{get:function(){return this._getObservableModuleConfig()},enumerable:!0}}),s=new t.Router(c,void 0,void 0),t.Router.prototype.getChildRouter=function(t){var e;if(t&&"string"==typeof t){var r=t.trim();r.length>0&&this._childRouters.every(function(t){return t._name!==r||(e=t,!1)})}return e},t.Router.prototype.getCurrentChildRouter=function(){return C(this,w(this._stateId()||this._defaultStateId))},t.Router.prototype.createChildRouter=function(e,r){var n;t.Assert.assertString(e);for(var i=r||w(this._stateId()),o=encodeURIComponent(e.trim()),a=0;a<this._childRouters.length;a++){var u=this._childRouters[a];if(u._name===o)throw new Error('Invalid router name "'+o+'", it already exists.');if(u._parentState===i)throw new Error('Cannot create more than one child router for parent state id "'+u._parentState+'".')}return n=new t.Router(o,this,i),this._childRouters.push(n),n},t.Router.prototype._getStateFromId=function(e){var r;return this._stateFromIdCallback?!(r=this._stateFromIdCallback(e))||r instanceof t.RouterState||(r=new t.RouterState(e,r,this)):r=function(e,r){var n;return r&&e._states&&(t.Assert.assertString(r),e._states.every(function(t){return t._id!==r||(n=t,!1)})),n}(this,e),r},t.Router.prototype.configure=function(e){return this._stateId(void 0),delete this._defaultStateId,this._navigationType=void 0,this._navHistory=[],"function"==typeof e?(this._states=null,this._stateFromIdCallback=e):(this._states=[],this._stateFromIdCallback=void 0,Object.keys(e).forEach(function(r){var n=e[r];this._states.push(new t.RouterState(r,n,this)),"boolean"==typeof n.isDefault&&n.isDefault&&(this._defaultStateId=w(r))},this)),this},t.Router.prototype.getState=function(t){return this._getStateFromId(t)},t.Router.prototype.go=function(t,e){q();var r=e||{};return Array.isArray(t)&&(t=t.map(G).join("/")),J({router:this,path:t,origin:"go",historyUpdate:r.historyUpdate})},t.Router.prototype._go=function(t){var e,r,i=!0,u=t.path,s=!1,l=!1;switch(t.historyUpdate){case"skip":l=!0;break;case"replace":s=!0}if(u){if("string"!=typeof u)return Promise.reject(new Error("Invalid object type for state id."));i=!1}if(i&&!(u=this._defaultStateId))return n.info(function(){return"Undefined state id with no default id on router "+I(this)}),Promise.resolve(_);if("/"===u.charAt(0))r=u;else{if(!(r=E(this._parentRouter)))return Promise.reject(new Error('Invalid path "'+u+'". The parent router does not have a current state.'));r+=u}n.info("Destination path: %s",r);try{e=function(t,e){var r,n,i,o,u=[],s=[],l=t,c=S(e),f=0;for(c.splice(0,1);l;)s.unshift(l),l=l._parentRouter;for(var h=c.shift();h;h=c.shift())if(i&&(i._paramOrder[f]?(o.addParameter(h),f+=1):f=0),!i||0===f){if(!(l=s.shift())&&!(l=k(r,h,n)))return a=e,u;if(!(i=(o=new L(l,h)).getState()))throw new Error('Invalid path "'+e+'". State id "'+h+'" does not exist on router "'+l._name+'".');u.push(o),r=l,n=h}return u}(this,r),e=M(e)}catch(t){return Promise.reject(t)}var c=x(e);return s||c.length>0?(n.info("Deferred mode or new state is different."),D(this).then(function(t){return t?V(c).then(Z).then(function(t){if(t[v])if(l)n.info("Skip history update.");else{var r=o.buildUrlFromStates(e);n.info("%s URL to %s",s?"Replacing":"Pushing",r),window.history[s?"replaceState":"pushState"](null,"",r)}return t}):Promise.resolve(_)})):Promise.resolve(_)},t.Router.prototype.store=function(t){this._extra=t;for(var e,r={},n=this;n;)void 0!==n._extra&&(r[n._name]=n._extra),n=n._parentRouter;for(n=this;n;){for(var i=0;i<n._childRouters.length;i++){var o=n._childRouters[i],a=w(n._stateId());if(a&&a===o._parentState){void 0!==o._extra&&(r[o._name]=o._extra),e=o;break}}n=e,e=void 0}window.history.replaceState(null,"",y({},r))},t.Router.prototype.retrieve=function(){return this._extra},t.Router.prototype.dispose=function(){for(;this._childRouters.length>0;)this._childRouters[0].dispose();if(this._parentRouter){for(var e=this._parentRouter._childRouters,r=0;r<e.length;r++)if(e[r]._name===this._name){e.splice(r,1);break}delete this._parentState}else l="/",o=null,this._name=c,window.document.title=i,window.removeEventListener(p,Q),t.Router._transitionedToState.removeAll(),g=!1;delete this._navigationType,this._navHistory=[],this._states=null,delete this._defaultStateId,delete this._extra},t.Router._transitionedToState=new r.Signal,t.Router._updating=!1,Object.defineProperties(t.Router,{rootInstance:{value:s,enumerable:!0},transitionedToState:{value:t.Router._transitionedToState,enumerable:!0}}),t.Router.defaults={},Object.defineProperties(t.Router.defaults,{urlAdapter:{get:function(){return o||(o=new t.Router.urlPathAdapter),o},set:function(t){if(g)throw new Error("Incorrect operation. Cannot change URL adapter after calling sync() or go().");o=t},enumerable:!0,readonly:!1},baseUrl:{get:function(){return l},set:function(t){if(g)throw new Error("Incorrect operation. Cannot change base URL after calling sync() or go().");l=t?t.match(/[^?#]+/)[0]:"/"},enumerable:!0,readonly:!1},rootInstanceName:{get:function(){return s._name},set:function(e){if(g)throw new Error("Incorrect operation. Cannot change the name of the root instance after calling sync() or go().");t.Assert.assertString(e),s._name=encodeURIComponent(e.trim())},enumerable:!0,readonly:!1}}),t.Router.sync=function(){var e={router:s,origin:"sync"};return q(),n.info("Entering sync with URL: %s",b.href),a?(e.path=a,e.deferredHandling=!0,e.historyUpdate="replace",a=void 0,J(e)):t.Router._updating?(n.info("Sync called while updating, waiting for updates to end."),new Promise(function(e){t.Router._transitionedToState.addOnce(function(t){n.info("Sync updates done."),e(t)})})):J(e)},t.Router.urlPathAdapter=function(){var t="";this.init=function(e){var r=document.createElement("a");r.href=e;var n=r.pathname;"/"!==(n=n.replace(/^([^/])/,"/$1")).slice(-1)&&(n+="/"),t=n},this.parse=function(){var e=s,r=b.pathname.replace(t,""),i=S(decodeURIComponent(r)).map(K),o=[];for(n.info("Parsing: %s",r);e;){var a=i.shift();if(!a)break;var u=new L(e,a),l=u.getState();l&&l._paramOrder.forEach(function(){u.addParameter(i.shift())}),o.push(u),e=C(e,a)}o=M(o);var c=b.search.split(f+"=")[1];return c&&(c=c.split("&")[0])&&o.forEach(P,j(c)),o},this.buildUrlFromStates=function(e){for(var r=!1,n="",i={},o=e.pop();o;o=e.pop())o.value&&(r||o.value!==o.router._defaultStateId)&&(n=n?o.value+"/"+n:o.value,r=!0),void 0!==o.router._extra&&(i[o.router._name]=o.router._extra);return y({pathname:t+n},i)}},t.Router.urlParamAdapter=function(){this.init=function(){},this.parse=function(){var t=b.search,e=function(t){var e={},r=t.split("?")[1];return r&&r.split("&").forEach(function(t){var r=t.split(/=(.+)?/),n=r[0];if(n.length){var i=r[1]&&decodeURIComponent(r[1]);e[n]=i}}),e}(t),r=s,i=[];for(n.info("Parsing: %s",t);r;){var o=e[r._name]||r._defaultStateId,a=S(o),u=new L(r,o=a.shift());if(o){var l=u.getState();l&&l._paramOrder.forEach(function(){u.addParameter(a.shift())}),i.push(u)}r=C(r,o)}i=M(i);var c=e[f];return c&&i.forEach(P,j(c)),i},this.buildUrlFromStates=function(t){for(var e=!1,r="",n={},i=t.pop();i;i=t.pop()){if(i.value&&(e||i.value!==i.router._defaultStateId)){var o="&"+i.router._name+"=",a=i.value;r=o+encodeURIComponent(a)+r,e=!0}void 0!==i.router._extra&&(n[i.router._name]=i.router._extra)}return r&&(r="?"+r.substr(1)),y({search:r},n)}}}();var i,o,a,u,s=t.Router;return o=String.fromCharCode,a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-$",t.LZString={compressToEncodedURIComponent:function(t){return null===t?"":function(t,e,r){if(null===t)return"";for(var n,i,o={},a={},u="",s=2,l=3,c=2,f="",h=0,d=0,p=t.length,v=0;v<p;v++){var _=t[v];Object.prototype.hasOwnProperty.call(o,_)||(o[_]=l,l+=1,a[_]=!0);var g=u+_;if(Object.prototype.hasOwnProperty.call(o,g))u=g;else{if(Object.prototype.hasOwnProperty.call(a,u)){if(u.charCodeAt(0)<256){for(n=c;n--;)h<<=1,d===e-1?(d=0,f+=r(h),h=0):d+=1;for(i=u.charCodeAt(0),n=8;n--;)h=h<<1|1&i,d===e-1?(d=0,f+=r(h),h=0):d+=1,i>>=1}else{for(i=1,n=c;n--;)h=h<<1|i,d===e-1?(d=0,f+=r(h),h=0):d+=1,i=0;for(i=u.charCodeAt(0),n=16;n--;)h=h<<1|1&i,d===e-1?(d=0,f+=r(h),h=0):d+=1,i>>=1}0==(s-=1)&&(s=Math.pow(2,c),c+=1),delete a[u]}else for(i=o[u],n=c;n--;)h=h<<1|1&i,d===e-1?(d=0,f+=r(h),h=0):d+=1,i>>=1;0==(s-=1)&&(s=Math.pow(2,c),c+=1),o[g]=l,l+=1,u=String(_)}}if(""!==u){if(Object.prototype.hasOwnProperty.call(a,u)){if(u.charCodeAt(0)<256){for(n=c;n--;)h<<=1,d===e-1?(d=0,f+=r(h),h=0):d+=1;for(i=u.charCodeAt(0),n=8;n--;)h=h<<1|1&i,d===e-1?(d=0,f+=r(h),h=0):d+=1,i>>=1}else{for(i=1,n=c;n--;)h=h<<1|i,d===e-1?(d=0,f+=r(h),h=0):d+=1,i=0;for(i=u.charCodeAt(0),n=16;n--;)h=h<<1|1&i,d===e-1?(d=0,f+=r(h),h=0):d+=1,i>>=1}0==(s-=1)&&(s=Math.pow(2,c),c+=1),delete a[u]}else for(i=o[u],n=c;n--;)h=h<<1|1&i,d===e-1?(d=0,f+=r(h),h=0):d+=1,i>>=1;0==(s-=1)&&(c+=1)}for(i=2,n=c;n--;)h=h<<1|1&i,d===e-1?(d=0,f+=r(h),h=0):d+=1,i>>=1;for(;;){if(h<<=1,d===e-1){f+=r(h);break}d+=1}return f}(t,6,function(t){return a.charAt(t)})},decompressFromEncodedURIComponent:function(t){return null===t?"":""===t?null:function(t,e,r){for(var n,i,a=[],u=4,s=4,l=3,c="",f="",h={val:r(0),position:e,index:1},d=0;d<3;d+=1)a[d]=d;for(var p=0,v=Math.pow(2,2),_=1;_!==v;)n=h.val&h.position,h.position>>=1,0===h.position&&(h.position=e,h.val=r(h.index),h.index+=1),p|=(n>0?1:0)*_,_<<=1;switch(p){case 0:for(p=0,v=Math.pow(2,8),_=1;_!==v;)n=h.val&h.position,h.position>>=1,0===h.position&&(h.position=e,h.val=r(h.index),h.index+=1),p|=(n>0?1:0)*_,_<<=1;i=o(p);break;case 1:for(p=0,v=Math.pow(2,16),_=1;_!==v;)n=h.val&h.position,h.position>>=1,0===h.position&&(h.position=e,h.val=r(h.index),h.index+=1),p|=(n>0?1:0)*_,_<<=1;i=o(p);break;case 2:return""}a[3]=i;var g=i;for(f=i;;){if(h.index>t)return"";for(p=0,v=Math.pow(2,l),_=1;_!==v;)n=h.val&h.position,h.position>>=1,0===h.position&&(h.position=e,h.val=r(h.index),h.index+=1),p|=(n>0?1:0)*_,_<<=1;switch(i=p){case 0:for(p=0,v=Math.pow(2,8),_=1;_!==v;)n=h.val&h.position,h.position>>=1,0===h.position&&(h.position=e,h.val=r(h.index),h.index+=1),p|=(n>0?1:0)*_,_<<=1;a[s]=o(p),i=(s+=1)-1,u-=1;break;case 1:for(p=0,v=Math.pow(2,16),_=1;_!==v;)n=h.val&h.position,h.position>>=1,0===h.position&&(h.position=e,h.val=r(h.index),h.index+=1),p|=(n>0?1:0)*_,_<<=1;a[s]=o(p),i=(s+=1)-1,u-=1;break;case 2:return f}if(0===u&&(u=Math.pow(2,l),l+=1),a[i])c=a[i];else{if(i!==s)return null;c=g+(g.length?g[0]:"")}f+=c,a[s]=g+c[0],s+=1,g=c,0==(u-=1)&&(u=Math.pow(2,l),l+=1)}}(t.length,32,function(e){return function(t,e){var r;if(i||(i={}),!i[t])for(i[t]={},r=0;r<t.length;r++)i[t][t[r]]=r;return i[t][e]}(a,t.charAt(e))})}},u=/^{(\w+)}$/,t.RouterState=function(e,r,n){r=r||{},t.Assert.assertString(e);var i=(e=e.trim()).split("/");this._id=i.shift(),this._parameters={},this._paramOrder=[],i.forEach(function(t,e){var r=t.match(u);if(r){var n=r[1];this._parameters[n]=null,this._paramOrder[e]=n}},this),this._canEnter=r.canEnter,this._canEnter&&t.Assert.assertFunctionOrNull(this._canEnter),this._enter=r.enter,this._enter&&t.Assert.assertFunctionOrNull(this._enter),this._canExit=r.canExit,this._canExit&&t.Assert.assertFunctionOrNull(this._canExit),this._exit=r.exit,this._exit&&t.Assert.assertFunctionOrNull(this._exit),this._value=r.value,this._label=r.label,this._title=r.title,this._router=n,this.viewModel=void 0,this.go=()=>this._router?this._router.go(this._id):(t.Router._transitionedToState.dispatch({hasChanged:!1}),Promise.reject(new Error("Router is not defined for this RouterState object."))),this.isCurrent=()=>{if(!this._router)throw new Error("Router is not defined for this RouterState object.");return this._router._stateId()===this._id},Object.defineProperties(this,{id:{value:this._id,enumerable:!0},value:{get:function(){return this._value},set:function(t){this._value=t},enumerable:!0},label:{get:function(){return this._label},set:function(t){this._label=t},enumerable:!0},title:{get:function(){return this._title},set:function(t){this._title=t},enumerable:!0},canEnter:{get:function(){return this._canEnter},set:function(t){this._canEnter=t},enumerable:!0},enter:{get:function(){return this._enter},set:function(t){this._enter=t},enumerable:!0},canExit:{get:function(){return this._canExit},set:function(t){this._canExit=t},enumerable:!0},exit:{get:function(){return this._exit},set:function(t){this._exit=t},enumerable:!0},parameters:{get:function(){return this._parameters},enumerable:!0}})},s});
//# sourceMappingURL=ojrouter.js.map