/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","preact/jsx-runtime","preact","ojs/ojcore-base","ojs/ojcustomelement-utils","ojs/ojcustomelement-registry","ojs/ojmetadatautils","ojs/ojlogger"],function(e,t,o,r,s,n,a,i){"use strict";r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r;const l=Symbol("row");class c{static renderNodes(e,r,n,a){const i=n.parentStub;let d=()=>Array.from(i.childNodes);n.nodes&&(d=c._getRetrieveNodesFunction(n.nodes));const u=console.error;console.error=(e,t)=>{-1===e.indexOf("Improper nesting of table.")&&u.apply(console,arguments)};try{const e=a?Array.from(a).reduce((e,[o,r])=>t.jsx(o.Provider,{value:r,children:e}),r):r;o.render(e,i)}finally{console.error=u}let p=!0;const _=d();_.forEach(e=>{e.setAttribute?(e.setAttribute("data-oj-vdom-template-root",""),p=!1):e._oj_vdom_template_root=!0,e[l]=n,e[s.CACHED_BINDING_PROVIDER]="preact"}),n.vnode=r,n.nodes=_,p&&e.setAttribute("data-oj-vdom-template-text-roots","")}static clean(e){const t=e[l];if(!t.cleaned){t.cleaned=!0;const e=c._getInsertNodesFunction(t.nodes);o.render(null,t.parentStub),e(t.nodes),t.computedVNode?.dispose();const r=t.template,s=r._cachedRows.indexOf(t);r._cachedRows.splice(s,1)}}static findTemplateRoots(e,t){let o=e&&e.querySelectorAll?Array.from(e.querySelectorAll('[data-oj-vdom-template-root=""]')):[];e&&e.hasAttribute&&e.hasAttribute("data-oj-vdom-template-root")&&o.push(e);let r=t?.hasAttribute("data-oj-vdom-template-text-roots");if(!r){r=(e&&e.querySelectorAll?e.querySelectorAll('[data-oj-vdom-template-text-roots=""]'):[]).length>0}if(r){const t=document.createTreeWalker(e,NodeFilter.SHOW_TEXT);let r=t.currentNode;for(;r;)r._oj_vdom_template_root&&o.push(r),r=t.nextNode()}return o}static _getInsertNodesFunction(e){const t=e[e.length-1],o=t.parentNode,r=t.nextSibling;return e=>{e.forEach(e=>o.insertBefore(e,r))}}static _getRetrieveNodesFunction(e){const t=e[0],o=e[e.length-1],r=t.parentNode,s=t.previousSibling,n=o.nextSibling;return()=>{const e=[];for(let t=s?s.nextSibling:r.firstChild;t!==n;t=t.nextSibling)e.push(t);return e}}static resolveVDomTemplateProps(e,t,o,r,s,a,i){const l=n.getPropertiesForElementTag(o),[u,p]=c.extendTemplate(e,c._COMPUTED_PROPS_CACHE_FACTORY,e=>{for(const t of u)t.recalculateValue(e)}),_=new d(e=>c._computeProps(e,o,l,r,s,i),t,a,p);return u.add(_),_}static _computeProps(e,t,o,r,n,i){const l=e(n),c=(Array.isArray(l)?l:[l]).find(e=>e.type===t);if(!c)throw new Error("Item template must contain an element named {elementTagName}");const d={},u=c.props;return Object.keys(u).forEach(e=>{r.has(e)&&(d[e]=s.transformPreactValue(null,a.getPropertyMetadata(e,o),c.props[e]))}),d}static extendTemplate(e,t,o){if(!e._cachedRows){let r=e.render;Object.defineProperties(e,{_cachedRows:{writable:!0,value:t()},render:{enumerable:!0,get:()=>r,set(e){r=e,e&&o(e)}}})}return e._cachedRows}}c._COMPUTED_PROPS_CACHE_FACTORY=()=>{const e=new Set;return[e,e.delete.bind(e)]},c._ROW_CACHE_FACTORY=()=>[];class d{constructor(e,t,o,r){this._calculate=e,this._defaultProps=o,this._disposeCallback=r,this._value=e(t),this._merged=this._getMergedValue(this._value)}peek(){return this._merged}subscribe(e){if(this._sub)throw new Error("Resolved property observable does not support multiple subscribers");this._sub=e}dispose(){this._disposeCallback(this)}recalculateValue(e){const t=this._calculate(e),o=this._value;this._value=t,this._sub&&!r.Object.compareValues(t,o)&&(this._merged=this._getMergedValue(t),this._sub(this._merged))}_getMergedValue(e){return Object.assign({},this._defaultProps,e)}}class u{static getContext(e,t,o,r,s,n,a){if(e){let l=o.__ojBindingContext?o.__ojBindingContext:e.__ContextFor(o);l||(i.info("Binding context not found when processing template for element with id: "+t.id+". Using binding context for element instead."),l=e.__ContextFor(t));const c=e.__ExtendBindingContext(l,r,s,n,t);if(c.$provided&&a){const e=new Map([...c.$provided,...a]);c.$provided=e}else a&&(c.$provided=a);return c}const l={$current:r};return n&&(l[n]=r),l}static getResolvedDefaultProps(e,t,o){let r=e.get(t);if(!r){const s=document.createElement(t);r=u.getStaticPropertyMap(s,o,document.body),e.set(t,r)}return r}static getStaticPropertyMap(e,t,o){const r={};if(e){const s=e.style;s.display="none",s.position="absolute",e.setAttribute("data-oj-binding-provider","none"),o.appendChild(e),t.forEach(function(t){void 0!==e[t]&&(r[t]=e[t])}),o.removeChild(e)}return r}static createPropertyBackedByObservable(e,t,o,r,s){const n=e.__Observable(r);Object.defineProperty(t,o,{get:()=>n(),set:e=>{n(e),s&&s(e)},enumerable:!0})}}e.PreactTemplate=c,e.TemplateEngineUtils=u,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojtemplateengine-utils.js.map