/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore-base","jquery","ojs/ojthemeutils","ojs/ojcomponentcore","ojs/ojlogger"],function(t,e,s,i,o){"use strict";var n;t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,function(){const s="oj-toolbar",n="OJ-MENU-BUTTON",a="OJ-BUTTON",r="OJ-C-BUTTON",u="OJ-C-MENU-BUTTON",l="OJ-C-SPLIT-MENU-BUTTON",h="oj-button, oj-menu-button, oj-buttonset-one, oj-buttonset-many, oj-c-button, oj-c-menu-button, oj-c-split-menu-button",d="oj-button, oj-menu-button, oj-buttonset-one .oj-button, oj-buttonset-many .oj-button, oj-c-button, oj-buttonset-one .oj-c-button, oj-buttonset-many .oj-c-button, oj-c-menu-button, oj-c-split-menu-button";t.__registerWidget("oj.ojToolbar",e.oj.baseComponent,{widgetEventPrefix:"oj",options:{chroming:"borderless"},_InitOptions:function(t,e){this._super(t,e),"disabled"in e&&o.warn("Caller attempted to set the 'disabled' option on Toolbar, but Toolbar does not support the 'disabled' option.  See API doc.")},_ComponentCreate:function(){this._super();var t=this.element[0];t.setAttribute(i._OJ_CONTAINER_ATTR,this.widgetName),t.classList.add(s),t.classList.add("oj-component"),t.setAttribute("role","toolbar"),this._hasInitialFocusHandler=!1,this._setup()},_NotifyContextMenuGesture:function(t,e,s){var i=this.element.find(":oj-button[tabindex=0]");this._OpenContextMenu(e,s,{launcher:i,position:{of:"keyboard"===s?i.ojButton("widget"):e}})},_setOption:function(t,e){"disabled"!==t?(this._superApply(arguments),"chroming"===t&&this._refreshChildren()):o.warn("Caller attempted to set the 'disabled' option on Toolbar, but Toolbar does not support the 'disabled' option.  See API doc.  Ignoring the call.")},refresh:function(){this._super(),this._setup(),this._refreshTabindex()},_setup:function(){var t=this,s=this.element[0];if(this.isRtl="rtl"===this._GetReadingDirection(),this.$enabledButtons=e(),this._IsCustomElement())this._hasInitialFocusHandler||(this._focusinListener=function(e){t._handleInitialFocus(e.target)},s.addEventListener("focusin",this._focusinListener,!0),this._hasInitialFocusHandler=!0),this.topLevelChildren=s.querySelectorAll(h),this._refreshChildren();else{const s=":oj-button";this.$buttons=this.element.find(s).off("keydown"+this.eventNamespace).on("keydown"+this.eventNamespace,function(s){t._handleKeyDown(s,e(this))}).off("click"+this.eventNamespace).on("click"+this.eventNamespace,function(s){e(this).ojButton("option","disabled")||t._setTabStop(e(this))}).off("focus"+this.eventNamespace).on("focus"+this.eventNamespace,function(s){t._handleFocus(e(this))}),this.$buttonsets=this.element.find(":oj-buttonset").ojButtonset("refresh"),this.$topLevelButtons=this.$buttons.not(this.$buttonsets.find(s)).ojButton("refresh")}},_handleFocus:function(t){this._IsCustomElement()||0!==this.$enabledButtons.length?this._setTabStop(t):(this.$enabledButtons=this.$buttons.filter(function(){return!e(this).ojButton("option","disabled")&&e(this).is(":visible")}),this._initTabindexes(null==this._lastTabStop),this.$enabledButtons[0].focus())},_isButtonDisabled:function(t){var e;if(t.tagName===a||t.tagName===r||t.tagName===n||t.tagName===u||t.tagName===l)e=t.disabled;else if(!(e=t.parentNode.disabled)){var s=t.querySelector("oj-option");e=s&&s.disabled}return e},_handleInitialFocus:function(t){var s=this,i=this.element[0],o="disabledChanged";if(i.removeEventListener("focusin",this._focusinListener,!0),this._hasInitialFocusHandler=!1,this.topLevelChildren=i.querySelectorAll(h),!this._mutationObserver){var b=[a,r,n,u,l,"OJ-BUTTONSET-ONE","OJ-BUTTONSET-MANY","OJ-OPTION"];this._disabledChangedListener=this.refresh.bind(this),this._mutationObserver=new MutationObserver(function(t){t.forEach(function(t){if("childList"===t.type){var e;if(t.addedNodes)for(e=0;e<t.addedNodes.length;e++)b.indexOf(t.addedNodes[e].nodeName)>=0&&t.addedNodes[e].addEventListener(o,s._disabledChangedListener);if(t.removedNodes)for(e=0;e<t.removedNodes.length;e++)b.indexOf(t.removedNodes[e].nodeName)>=0&&t.removedNodes[e].removeEventListener(o,s._disabledChangedListener)}})}),this._mutationObserver.observe(i,{childList:!0,subtree:!0})}i.querySelectorAll(h).forEach(function(t){t.removeEventListener(o,s._disabledChangedListener),t.addEventListener(o,s._disabledChangedListener)});var c=i.querySelectorAll(d);if(this.$buttons=e(c).off("keydown"+this.eventNamespace).on("keydown"+this.eventNamespace,function(t){var i=e(this);s._handleKeyDown(t,i)}).off("click"+this.eventNamespace).on("click"+this.eventNamespace,function(t){var i=e(this);i.hasClass("oj-disabled")||s._setTabStop(i)}).off("focusin"+this.eventNamespace).on("focusin"+this.eventNamespace,function(t){var i=e(this);s._handleFocus(i)}),this._IsCustomElement()?this.$enabledButtons=this.$buttons.filter(function(){return!s._isButtonDisabled(this)&&e(this).is(":visible")}):this.$enabledButtons=this.$buttons.filter(function(){return!e(this).ojButton("option","disabled")&&e(this).is(":visible")}),this._initTabindexes(null==this._lastTabStop),this.$enabledButtons&&this.$enabledButtons.length>0)if(t)("INPUT"===t.nodeName?t.parentElement:t).focus();else{let t=this._getButtonFocusElem(this.$enabledButtons[0]);t&&t.focus()}},_refreshTabindex:function(){var t=this;this._IsCustomElement()?this.$buttons=e(this.element[0].querySelectorAll(d)):this.$buttons=this.element.find(":oj-button"),void 0!==this.$buttons&&(this._IsCustomElement()?this.$enabledButtons=this.$buttons.filter(function(){return!t._isButtonDisabled(this)&&e(this).is(":visible")}):this.$enabledButtons=this.$buttons.filter(function(){return!e(this).ojButton("option","disabled")&&e(this).is(":visible")}),this._initTabindexes(null==this._lastTabStop))},_getButtonFocusElem:function(t){var e=t;if(void 0!==t&&this._IsCustomElement()){var s="button";t.classList.contains("oj-button-toggle")&&(s="input");for(var i=t.children,o=0;o<i.length;o++){var n=i[o];if(n.tagName.toLowerCase()===s){e=n;break}}}return e},_initTabindexes:function(t){var s,i=e(this._lastTabStop);if(this._lastTabStop=void 0,this._IsCustomElement())for(var o=0;o<this.$buttons.length;o++)this.$buttons[o].tagName.trim()===l.trim()&&this.$buttons[o].children[0].children[0].setAttribute("tabindex","-1"),this._getButtonFocusElem(this.$buttons[o]).setAttribute("tabindex","-1");else this.$buttons.attr("tabindex","-1");s=t||!i.is(this.$enabledButtons)?this.$enabledButtons.first():i,this._setTabStop(s)},_mapToTabbable:function(t){for(var s=[],i=0;i<this.$enabledButtons.length;i++)s.push(this._getButtonFocusElem(this.$enabledButtons[i]));var o=e(s);return t.map(function(t,e){if("radio"!==e.type||e.checked||""===e.name)return e;var s=function(t,e){var s,i=t.name;if(i){var o=":radio[name='"+(i=i.replace(/'/g,"\\'"))+"']:oj-button";s=e.filter(o)}else s=e.filter(t).filter(":oj-button");return s}(e,o).filter(":checked");return s.length?s[0]:e})},_setTabStop:function(t){var s=t,i=(s=this._IsCustomElement()?this._mapToTabbable(e(this._getButtonFocusElem(s[0]))):this._mapToTabbable(s))[0],o=this._lastTabStop;i!==o&&(o&&o.tagName.trim()===l.trim()?o.children[0].children[0].setAttribute("tabindex","-1"):e(o).attr("tabindex","-1"),s[0].tagName.trim()===l.trim()?s[0].children[0].children[0].setAttribute("tabindex","0"):s.attr("tabindex","0"),this._lastTabStop=i)},_handleKeyDown:function(t,s){var i=this;switch(t.which){case e.ui.keyCode.UP:case e.ui.keyCode.DOWN:if("radio"!==s.attr("type"))break;case e.ui.keyCode.LEFT:case e.ui.keyCode.RIGHT:t.preventDefault(),this._IsCustomElement()?this.$enabledButtons=this.$buttons.filter(function(){return!i._isButtonDisabled(this)&&e(this).is(":visible")}):this.$enabledButtons=this.$buttons.filter(function(){return!e(this).ojButton("option","disabled")&&e(this).is(":visible")});var o=this.$enabledButtons.length;if(o<2)break;var n=(this.$enabledButtons.index(s)+(t.which===e.ui.keyCode.DOWN||t.which===e.ui.keyCode.RIGHT^this.isRtl?1:-1)+o)%o;this._getButtonFocusElem(this.$enabledButtons.eq(n)[0]).focus()}},_destroy:function(){var t=this.element[0];t.classList.remove(s),t.classList.remove("oj-component"),t.removeAttribute(i._OJ_CONTAINER_ATTR),t.removeAttribute("role"),this.$buttons.attr("tabindex","0"),this._refreshChildren()},_refreshChildren:function(){if(this._IsCustomElement())for(var t=0;t<this.topLevelChildren.length;t++){var e=this.topLevelChildren[t];e.tagName===a||e.tagName===r||e.tagName===n||e.tagName===u||e.tagName===l?i.__GetWidgetConstructor(this._getButtonFocusElem(e),"ojButton")&&e.refresh():"OJ-BUTTONSET-ONE"!==e.tagName&&"OJ-BUTTONSET-MANY"!==e.tagName||i.__GetWidgetConstructor(e,"ojButtonset")&&e.refresh()}else this.$buttonsets.ojButtonset("refresh"),this.$topLevelButtons.ojButton("refresh")}})}(),i.setDefaultOptions({ojToolbar:{chroming:i.createDynamicPropertyGetter(function(){return s.getCachedCSSVarValues(["--oj-private-toolbar-global-chroming-default"])[0]})}}),(n={properties:{chroming:{type:"string",enumValues:["borderless","full","half","outlined","solid"]},translations:{type:"object",value:{}}},methods:{getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}}).extension._WIDGET_NAME="ojToolbar",t.CustomElementBridge.register("oj-toolbar",{metadata:t.CollectionUtils.mergeDeep(n,{properties:{chroming:{binding:{provide:[{name:"containerChroming",default:t.ThemeUtils.getCachedCSSVarValues(["--oj-private-toolbar-global-chroming-default"])[0]}]}}}})})});
//# sourceMappingURL=ojtoolbar.js.map