/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore-base","ojs/ojcustomelement-utils","ojs/ojcontext","ojs/ojlogger","ojs/ojcomponentcore"],function(e,n,t,o,i){"use strict";function r(e){var r,a="@firstInvalidShown",d=this,s=e.element,l=[];function u(){l=[],p(s),e.props.valid=h();for(var n=l.length,t=0;t<n;t++)v(l[t])}function v(e){e.addEventListener("validChanged",c.bind(this)),e.addEventListener("disabledChanged",g.bind(this)),e.addEventListener("readonlyChanged",g.bind(this))}function f(e){e.removeEventListener("validChanged",c),e.removeEventListener("disabledChanged",g),e.removeEventListener("readonlyChanged",g)}function c(){e.props.valid=h()}function g(n){var t=n.target,o=t.valid,i=!(t.readonly||t.disabled);"valid"===o||(e.props.valid=i&&"invalidShown"===o?"invalidShown":h())}function h(){for(var e="valid",n=l.length,t=0;t<n&&"invalidShown"!==e;t++){var o=l[t];if(C(o)){var i=o.valid,r=o.disabled,a=o.readonly;r||a||("invalidShown"===i?e="invalidShown":"invalidHidden"===i?e="invalidHidden":"pending"===i&&"valid"===e&&(e="pending"))}}return e}function p(e){var n,t=[],o=e.childNodes,i=o.length;for(n=0;n<i;n++){var r=o[n];O(r)?l.push(r):t.push(r)}for(i=t.length,n=0;n<i;n++)p(t[n])}function O(e){if(1===e.nodeType&&-1!==e.tagName.indexOf("-")&&"valid"in e&&(C(e)&&void 0!==e.valid))return!0;return!1}function m(e,n){var t=n.length;if(O(e))return!0;for(var o=0;o<t;o++)if(O(n[o]))return!0;return!1}function y(e){var n=l.length;if(1!==e.nodeType)return!1;for(var t=0;t<n;t++){if(l[t].contains(e))return!0}return!1}function b(e){for(var n=l.length,t=0;t<e.length;t++){var o=e[t];if(1===o.nodeType){if(-1!==l.indexOf(o))return!0;for(var i=0;i<n;i++)if(o.contains(l[i]))return!0}}return!1}function C(e){var t,o=n.CustomElementUtils.getElementBridge(e);if(!o)return!0;var r=o._WIDGET_ELEM;return void 0!==r&&(t=i.__GetWidgetConstructor(r)),!(void 0!==r&&!t)}d._rootElementMutationObserver=new MutationObserver(function(e){if(document.body.contains(s)){for(var n=e.length,t=!1,o=0;o<n&&!t;o++){var i=e[o],r=i.target,a=i.removedNodes,d=i.addedNodes;if(!(t=b(a))&&d.length>0)!y(r)&&m(r,d)&&(t=!0)}t&&(!function(e){for(var n=e.length,t=0;t<n;t++)for(var o=e[t],i=o.removedNodes.length,r=0;r<i;r++){var a=o.removedNodes[r];1===a.nodeType&&f(a)}}(e),u())}else this.disconnect()}),d.createDOM=function(){for(s.classList.add("oj-validation-group"),(r=document.createElement("div")).setAttribute("data-oj-context","");s.firstChild;)r.appendChild(s.firstChild);s.appendChild(r)},d.updateDOM=function(){var e=t.getContext(r).getBusyContext();let n=t.getContext(s).getBusyContext().addBusyState({description:`oj-validation-group#${s.id} initial valid state`});e.whenReady().then(function(){for(var e=l.length,n=0;n<e;n++)f(l[n]);u(),d._rootElementMutationObserver.observe(s,{childList:!0,subtree:!0})}).finally(n)},d.handlePropertyChanged=function(e,n){return!0},d.showMessages=function(){for(var e=0;e<l.length;e++){var n=l[e];n.disabled||n.readonly||"showMessages"in n&&n.showMessages()}},d.focusOn=function(e){var n=null,t=null;e===a?queueMicrotask(()=>{(t=function(){var e=[];if("invalidShown"!==s.valid)return null;for(var n=l.length,t=0;t<n;t++){var o=l[t];o.disabled||o.readonly||"invalidShown"===o.valid&&e.push(o)}if(0===e.length)return null;return e.sort(function(e,n){return e.compareDocumentPosition(n)&Node.DOCUMENT_POSITION_FOLLOWING?-1:1}),e[0]}())&&("focusOn"in t?t.focusOn(a):(t.focus(),oj.AgentUtils.getAgentInfo().os===oj.AgentUtils.OS.IOS&&t.scrollIntoView()))}):void 0===e?(n=function(){for(var e=null,n=l.length,t=0;t<n;t++)if(!(e=l[t]).readonly&&!e.disabled)return e;return null}())&&("focusOn"in n?n.focusOn():(n.focus(),oj.AgentUtils.getAgentInfo().os===oj.AgentUtils.OS.IOS&&n.scrollIntoView())):o.info("focusOn's parameter value is not '@firstInvalidShown' or empty, so it's a no-op.")}}var a;e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,(a={properties:{valid:{type:"string",writeback:!0,enumValues:["invalidHidden","invalidShown","pending","valid"],readOnly:!0}},methods:{focusOn:{},getProperty:{},setProperties:{},setProperty:{},showMessages:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}}).extension._CONSTRUCTOR=r,a.extension._TRACK_CHILDREN="nearestCustomElement",Object.freeze(a),e.CustomElementBridge.register("oj-validation-group",{metadata:a})});
//# sourceMappingURL=ojvalidationgroup.js.map