/**
 * @license
 * Copyright (c) 2014, 2024, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojlogger","ojs/ojhtmlutils","ojs/ojcustomelement-utils","ojs/ojcustomelement-registry","preact","preact/jsx-runtime","ojs/ojcontext","ojs/ojdataproviderhandler","ojs/ojpreact-managetabstops","ojs/ojbindpropagation","ojs/ojconfig","ojs/ojmetadatautils","ojs/ojcspexpressionevaluator-internal","ojs/ojmonitoring"],function(e,t,r,s,a,o,n,i,l,c,p,u,d,h,_){"use strict";i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i;class m extends o.Component{constructor(e){super(e),this._resolveConfig=e=>{e.then(t=>{e===this.props.config&&this.setState({view:this._getFragment(t.view),data:t.data})})},this._getFragment=e=>{const t=new DocumentFragment;return e.forEach(e=>{t.appendChild(e.cloneNode(this))}),t},this.state={view:null,data:null}}componentDidMount(){this._resolveConfig(this.props.config)}componentDidUpdate(e,t){this.props.config!==e.config&&this._resolveConfig(this.props.config)}render(){return n.jsx(o.Fragment,{children:this.state.view&&this.props.executeFragment?this.props.executeFragment(null,this.state.view,this.state.data,this.forceUpdate.bind(this),this.props.bindingProvider):null})}}class g extends o.Component{constructor(e){super(e),this._addBusyState=e=>i.getContext(this.props.componentElement).getBusyContext().addBusyState({description:e}),this.BindForEachWithDP=l.withDataProvider(y,"data")}render(e){return Array.isArray(e.data)?n.jsx(v,{data:e.data,itemRenderer:e.itemRenderer}):n.jsx(this.BindForEachWithDP,{addBusyState:this._addBusyState,data:e.data,itemRenderer:e.itemRenderer})}}class y extends o.Component{render(e){const t=e.data.map(e=>e.data);return n.jsx(v,{data:t,itemRenderer:e.itemRenderer})}}class v extends o.Component{render(){const e=this.props.data;return n.jsx(o.Fragment,{children:e?e.map((e,t)=>this.props.itemRenderer({data:e,index:t,observableIndex:()=>t})):[]})}}const b=Symbol(),f=Symbol(),x=Symbol(),C=Symbol(),E=function(e){return e},N="$provided",A=[{type:1,name:"$context"}];class P{constructor(){this._templateAstCache=new WeakMap,this._cspEvaluator=u.getExpressionEvaluator()??new h.CspExpressionEvaluatorInternal}static cleanupTemplateCache(e){e&&e._cachedRows&&(e._cachedRows.forEach(e=>e.dispose()),e._cachedRows=[])}executeFragment(e,t,r,a,o){let n=o;return n||(n=e?s.CustomElementUtils.getElementState(e)?.getBindingProvider():null),!r?.$provided||r.$provided instanceof Map||(r.$provided=new Map(Object.entries(r.$provided))),this._execute({[b]:n,[f]:e,[C]:r},t,r,a)}execute(e,t,r,s,a){const o=t.getAttribute("data-oj-as"),n=this._getContext(s,e,t,r,null,o);return this._execute({[b]:s,[f]:e,[C]:n},t,n,a)}_execute(e,t,r,s){const a=this._getAstViaCache(e,t),n=e[b];if(n){t._cachedRows||Object.defineProperties(t,{_cachedRows:{writable:!0,value:[]}});const e=n.__KoComputed(()=>{if(n.__KoIsInitial())return this._cspEvaluator.evaluate(a,{$context:r,$h:o.h,BindDom:m});P.cleanupTemplateCache(t),s()});return t._cachedRows.push(e),e()}return this._cspEvaluator.evaluate(a,{$context:r,$h:o.h,BindDom:m})}_getContext(e,r,s,a,o,n){if(e){let i=e.__ContextFor(s);return i||(t.info(`Binding context not found when processing template for element with id: ${r.id}. Using binding context for element instead.`),i=e.__ContextFor(r)),e.__ExtendBindingContext(i,a,o,n,r)}const i={$current:a};return n&&(i[n]=a),i}_getAstViaCache(e,t){let s=this._templateAstCache.get(t);if(!s){if(11===t.nodeType)s=this._createAst(e,Array.from(t.childNodes));else{const a=r.getTemplateContent(t)[0];s=this._createAst(e,Array.from(a.childNodes))}this._templateAstCache.set(t,s)}return s}_createAst(e,t){const r={type:9,elements:[]};return r.elements=Array.prototype.reduce.call(t,(t,r)=>{const s=this._processSpecialNodes(e,r);return s?t.push(s):3===r.nodeType?t.push({type:3,value:r.nodeValue}):1===r.nodeType&&t.push(this._createElementNode(e,r)),t},[]),r}_processSpecialNodes(e,t){if(1===t.nodeType)switch(t.tagName.toLowerCase()){case"oj-bind-text":return this._createExpressionNode(e,t.getAttribute("value"));case"oj-bind-if":return this._createIfExpressionNode(e,t);case"oj-bind-for-each":return this._createBindForEachExpressionNode(e,t);case"oj-bind-dom":return this._createBindDomExpressionNode(e,t);case"oj-bind-template-slot":return this._createBindTemplateNode(e,t);case"oj-defer":return this._createDeferNode(e,t);case"template":return this._createTemplateWithRenderCallback(e,t)}return null}_createBindTemplateNode(e,t){const r={type:10,properties:[]},s=t.getAttribute("name")||"";r.properties.push(this._getAttribute(e,"name",s));const a=t.getAttribute("data");a&&r.properties.push(this._getAttribute(e,"data",a));const n=t.getAttribute("as");return this._createCallNodeWithContext((r,s)=>{const a=s.data,i=s.name,l=e[C].__oj_slots[i];let c=l&&l[l.length-1],p=!1;if(!c)for(let e in t.childNodes)if("TEMPLATE"===t.childNodes[e].nodeName){c=t.childNodes[e],p=!0;break}if(c&&c.render)return c.render(a);if(c){const t=this._getAstViaCache(e,c),r=c.getAttribute("data-oj-as"),s=this._getContext(e[b],p?e[f]:e[C].__oj_composite,c,a,p?n:null,r);return this._cspEvaluator.evaluate(t,{$context:s,$h:o.h,BindDom:m})}},[r])}_createTemplateWithRenderCallback(e,t){const r=t.getAttribute("data-oj-as"),s=this._getAstViaCache.bind(this),a=this._cspEvaluator,n={key:"render",value:{type:3,value:(n,i)=>{const l=Object.assign({},e[C],{$current:n});if(r&&(l[r]=n),l.$provided&&i){const e=new Map([...l.$provided,...i]);l.$provided=e}else i&&(l.$provided=i);const c={[C]:l,[b]:e[b],[f]:e[f],[x]:e[x]},p=s(c,t);return a.evaluate(p,{$context:l,$h:o.h})}}};let i=this._getElementProps(e,t);return i.push(n),e[b]&&i.push({key:"data-oj-use-ko",value:{type:3,value:""}}),this._createHFunctionCallNode("template",[{type:10,properties:i}])}_createDeferContent(e,t,r){const s={view:t,data:r},a={config:Promise.resolve(s),bindingProvider:e[b],executeFragment:this.executeFragment.bind(this)};return o.h(m,a)}_createDeferNode(e,t){let r,s=this._createDeferContent(e,[],{});const a=[{key:"ref",value:{type:3,value:e=>{e?(r=e,o.render(s,r)):o.render(null,r)}}},{key:"_activateSubtree",value:this._createCallNodeWithContext(r=>a=>{s=this._createDeferContent(e,Array.from(t.childNodes),r),o.render(s,a)})}];let n=this._getElementProps(e,t);return n=n.concat(a),this._createHFunctionCallNode("oj-defer",[{type:10,properties:n}])}_createIfExpressionNode(e,t){if(!t.hasAttribute("test"))throw new Error("Missing the retuired 'test' attribute on <oj-bind-if>");return{type:5,operator:"...",argument:{type:8,test:this._createExpressionNode(e,t.getAttribute("test")),consequent:this._createAst(e,Array.from(t.childNodes)),alternate:{type:3,value:[]}}}}_createBindForEachExpressionNode(e,t){const r=t.getElementsByTagName("template")[0];if(!r)throw new Error("Template not found: oj-bind-for-each requires a single template element as its direct child");return this._createComponentNode(e,t,g,[{key:"itemRenderer",value:this._createNestedTemplateRendererNode(e,r)},{key:"componentElement",value:{type:3,value:e[f]}}])}_createNestedTemplateRendererNode(e,t){const r=t.getAttribute("data-oj-as"),s={[b]:e[b],[C]:e[C],[f]:e[f],[x]:(e,t)=>"function"!=typeof t||"$current.observableIndex"!==e&&e!==`${r}.observableIndex`?t:t()},a=this._getAstViaCache(s,t);return this._createCallNodeWithContext(e=>t=>{const s={$current:t};null!=r&&(s[r]=t);const n=Object.assign({},e,s);return this._cspEvaluator.evaluate(a,{$context:n,$h:o.h})})}_createElementNode(e,t){const r=this._getElementProps(e,t),s=t.tagName,o=s.toLowerCase(),n=a.getMetadata(s),i=this._createHFunctionCallNode(o,[this._createPossiblyProvidedAndConsumedProperties(o,e,n,r),this._createAst(e,Array.from(t.childNodes))]);return t.hasAttribute("data-oj-manage-tabs")?this._createComponentNode(e,null,c.ManageTabStops,[{key:"children",value:i}]):i}_createPossiblyProvidedAndConsumedProperties(e,t,r,a){const o={type:10,properties:a},n=p.getPropagationMetadataViaCache(e,r);if(!n)return o;const i=new Set;a.reduce((e,t)=>e.add(t.key),i);const l=[],c=this._getUnwrapObservable(t);for(const[e,t]of n){const r=t[1];r&&(e===p.CONSUMED_CONTEXT?l.push({key:"__oj_private_contexts",value:this._createCallNodeWithContext(e=>{const t=new Map,s=c(e)?.[N];return r.forEach(e=>{s?.has(e)&&t.set(e,c(s.get(e)))}),t})}):i.has(e)||i.has(s.AttributeUtils.propertyNameToAttribute(e).toUpperCase())||l.push({key:e,value:this._createCallNodeWithContext(e=>{const t=c(e)?.[N];if(t)return c(t.get(r.name))})}))}const u=0===l.length?o:{type:10,properties:o.properties.concat(l)},d=r.properties;return this._createCallNodeWithContext((t,r)=>{let a,o=new Map;for(const[t,[i]]of n)i&&i.forEach(n=>{let i,l=!0;if(t===p.STATIC_PROPAGATION)l=!1;else if(r.hasOwnProperty(t))i=r[t];else{const a=s.AttributeUtils.propertyNameToAttribute(t),o=a.toUpperCase();if(r.hasOwnProperty(o)){i=r[o];const n=d?.[t]?.type;n&&null!=i&&(i=s.AttributeUtils.parseAttributeValue(e,a,i,n))}else l=!1}const c="default";if(l){const e=n.transform;i=e&&e.hasOwnProperty(i)?e[i]:i}else n.hasOwnProperty(c)&&(i=n[c],l=!0);l&&(a=!0,o.set(n.name,i))});if(a){const e=t[N];void 0!==e&&(o=new Map([...e,...o])),t[N]=o}return r},[u])}_createBindDomExpressionNode(e,t){if(!t.hasAttribute("config"))throw new Error("Missing the required 'config' attribute on <oj-bind-dom>");const r=t.attributes.config.value;return this._createComponentNode(e,t,m,[this._createPropertyNode(e,"config",r,e=>Promise.resolve(e)),{key:"bindingProvider",value:{type:3,value:e[b]}},{key:"executeFragment",value:{type:3,value:this.executeFragment.bind(this)}}])}_createComponentNode(e,t,r,s){let a=t?this._getElementProps(e,t):[];return a=s?a.concat(s):a,this._createHFunctionCallNode(r,[{type:10,properties:a}])}_createPropertyNode(e,t,r,s){return{key:t,value:this._createExpressionNode(e,r,s)}}_postprocessClassNameValue(e){let t;return t=Array.isArray(e)?e.join(" "):"string"!=typeof e?Object.keys(e).reduce((t,r)=>(e[r]&&t.push(r),t),[]).join(" "):e,t}_getElementProps(e,t){let r;const o=[],n=[],i=new Map,l=new Map,c=Array.prototype.reduce.call(t.attributes,(c,p)=>{let u=p.name;const h=p.value;if(u.startsWith(":")){u=u.substring(1);const t=u.split(".");2===t.length&&"style"===t[0]?o.push({k:t[1],v:h}):"style"===u?r=h:"class"===u?c.push(this._createPropertyNode(e,"className",h,this._postprocessClassNameValue)):(u=s.AttributeUtils.isGlobalOrData(u)?s.AttributeUtils.getGlobalPropForAttr(u):s.AttributeUtils.attributeToPropertyName(u),c.push(this._createPropertyNode(e,u,h)))}else{const r=s.AttributeUtils.getExpressionInfo(h);if(s.AttributeUtils.isEventListenerAttr(u))u=s.AttributeUtils.eventAttrToPreactPropertyName(u),l.set(u,h);else if(s.AttributeUtils.isGlobalOrData(u))c.push(this._createPropertyNode(e,s.AttributeUtils.getGlobalPropForAttr(u),h));else if(r.expr){const o=s.AttributeUtils.attributeToPropertyName(u),l=o.split("."),p=d.getPropertyMetadata(l[0],a.getPropertiesForElementTag(t.tagName));if(p?.readOnly||(l.length>1?n.push({subProps:o,expr:r.expr}):c.push({key:o,value:this._createExpressionEvaluator(e,r.expr)})),!r.downstreamOnly&&p?.writeback){let e=l;const t=e.shift();let s=i.get(t);if(s){s=[...s,{expr:r.expr,subProps:e}]}else s=[{expr:r.expr,subProps:e}];i.set(t,s)}}else c.push({key:u.toUpperCase(),value:{type:3,value:h}})}return c},[]);if(null!=r){if(o.length>0)throw new Error("Binding the entire style attribute as well as the individual style properties on the same element is not supported");c.push(this._createPropertyNode(e,"style",r))}else o.length>0&&c.push({key:"style",value:{type:10,properties:o.map(t=>this._createPropertyNode(e,s.AttributeUtils.attributeToPropertyName(t.k),t.v))}});return n.length>0&&c.push(this._createRefPropertyNodeForNestedProps(e,n)),i.forEach((t,r)=>{const a=`on${r}Changed`,o=l.get(a);o&&l.delete(a),c.push(this._createWritebackPropertyNode(e,r,a,t,s.AttributeUtils.getExpressionInfo(o)?.expr))}),l.forEach((e,t)=>{const r=s.AttributeUtils.getExpressionInfo(e);r.expr&&c.push(this._createEventListenerPropertyNode(t,r.expr))}),c}_createRefPropertyNodeForNestedProps(e,t){const r={type:9,elements:t.map(({subProps:t,expr:r})=>({type:10,properties:[{key:t,value:this._createExpressionEvaluator(e,r)}]}))},s=P._nestedPropsRefCallback;return{key:"ref",value:this._createCallNodeWithContext(Function.prototype.bind.bind(s,e[b]),[r])}}static _nestedPropsRefCallback(e,t,r){if(r&&r.setProperties){const e=Object.assign({},...t);r.setProperties(e)}}_createWritebackPropertyNode(e,t,r,s,a){const o=[];let n;return{key:r,value:this._createCallNodeWithContext(r=>i=>{s.forEach((s,a)=>{let n=i.detail.value;var l=s.subProps,c=s.expr;l.length>0&&"object"==typeof n&&(n=l.reduce((e,t)=>e[t],n));let p=o[a];p||(p=this._cspEvaluator.createEvaluator(c).evaluate,o.push(p));const u=p([r,r.$data]);let d;if(e[b]&&e[b].__IsObservable(u))d=u;else{const e=this._getPropertyWriterExpression(c);if(null!==e){const t=this._cspEvaluator.createEvaluator(e).evaluate;d=this._getWriter(t([r.$data||{},r]))}}_.performMonitoredWriteback(t,d,i,n)}),a&&!n&&(n=this._cspEvaluator.createEvaluator(a).evaluate);const l=n?n([r,r.$data]):null;l&&l(i,r.$current||r.$data,r)})}}_createEventListenerPropertyNode(e,t){let r;return{key:e,value:this._createCallNodeWithContext(e=>s=>{r||(r=this._cspEvaluator.createEvaluator(t).evaluate);const a=r([e,e.$data]);a&&a(s,e.$current||e.$data,e)})}}_createExpressionNode(e,t,r){const a=s.AttributeUtils.getExpressionInfo(t);return a.expr?this._createExpressionEvaluator(e,a.expr,r):{type:3,value:t}}_createExpressionEvaluator(e,t,r){const s=this._cspEvaluator.createEvaluator(t).evaluate;return this._createCallNodeWithContext(a=>{const o=this._getUnwrapObservable(e),n=o(a);let i=o(s([n,n.$data]));return e[x]&&(i=e[x](t,i)),r?r(i):i})}_getUnwrapObservable(e){const t=e[b];return t?t.__UnwrapObservable:E}_createCallNodeWithContext(e,t){return{type:4,callee:{type:3,value:e},arguments:t?A.concat(t):A}}_createHFunctionCallNode(e,t){return{type:4,callee:{type:1,name:"$h"},arguments:[{type:3,value:e},...t]}}_getAttribute(e,t,r){const a=s.AttributeUtils.getExpressionInfo(r).expr;return{key:t,value:a?this._createExpressionEvaluator(e,a):{type:3,value:r}}}_getWriter(e){return e._ko_property_writers}_getPropertyWriterExpression(e){if(null==e||["true","false","null","undefined"].indexOf(e)>=0)return null;const t=(e=e.trim()).match(/^(?:[$_a-z][$\w]*|(.+)(\.\s*[$_a-z][$\w]*|\[.+\]))$/i);if(null===t)return null;return`{_ko_property_writers: function(v){${t[1]?`Object(${t[1]})${t[2]}`:e}=v;}}`}}const j=new P,w=j.executeFragment.bind(j),$=j.execute.bind(j),k=P.cleanupTemplateCache;e.cleanupTemplateCache=k,e.execute=$,e.executeFragment=w,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojvcomponent-template.js.map